CMAQv5.2 Aerosol Processing Module (Aero6)
==========================================

Aerosol calculations the CMAQ aero6 module account for several relevant microphysical processes: emission, condensation, evaporation, coagulation, new particle formation, and chemistry. The size distribution of particles is conceptualized in this module as the sum of three log-normal modes: Aitken, Accumulation and Coarse. The magnitude and shape of these modes are predicted in time by tracking the magnitude of three moments: 0th (equivalent to number), 2nd (proportional to surface area) and 3rd (proportional to volume or mass).

Brief Summary on Inorganic chemistry

Brief Summary on Organic Chemistry

Brief Summary on Sea Salt Emissions

Brief Summary on Dust Emissions

Brief Summary on coagulation

Brief Summary on New particle Formation

-----
# CMAQv5.2 Aerosol Module Release Notes

The aerosol processing module in CMAQv5.2 includes several important revisions over CMAQv5.1, most noticeably to the representation of dust and organic aerosol (OA). 

  * [Aerosol Transmission Factors](../../docs/Release_Notes/Aerosol_Transmission_Factors.md)
  * [Update of Gas-Phase Deposition Rates](../../docs/Release_Notes/Gas-Phase_Dep_H2O2_HACET_OrgNtr_s07tic_Species.md)

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module stm_vars

C  Contains:
C
C  Revision History:
C SR 07/2/2019 Initial version

C----------------------------------------------------------------------

      Implicit None

      Integer, Parameter :: N_STM_AE_SPC  = 14   ! number of stm ae species
      Integer, Parameter :: N_STM_OAE_SPC =  9   ! number of stm oae species
      Integer, Parameter :: N_STM_NR_SPC  =  1   ! number of stm nr species

      Logical, Save :: organosulf = .False.

C Define value as Y and N for the spc tables
      CHARACTER( 16 ), Parameter, Private :: Y = 'Yes'
      CHARACTER( 16 ), Parameter, Private :: N = 'No'

      ! Equivalent to the Namelist Registry Format for Gases and Nonreactives
      TYPE STM_SPC_DATA_1
          CHARACTER( 16 ) :: SPECIES_NAME  ! CMAQ Species Name
          REAL            :: MOLWT         ! g mol-1
          CHARACTER( 16 ) :: IC_SURR       ! IC Surrogate
          REAL            :: IC_FAC        ! IC Scale Factor
          CHARACTER( 16 ) :: BC_SURR       ! BC Surrogate
          REAL            :: BC_FAC        ! BC Scale Factor
          CHARACTER( 16 ) :: DEPV_SURR     ! Dry Deposition Surrogate
          REAL            :: DEPV_FAC      ! Dry Deposition Scale Factor
          CHARACTER( 16 ) :: SCAV_SURR     ! Wet Scavenging Surrogate
          REAL            :: SCAV_FAC      ! Wet Scavenging Scale Factor
          CHARACTER( 16 ) :: AERO_SURR     ! Aerosol Module Surrogate
          CHARACTER( 16 ) :: CLOUD_SURR    ! Cloud Chemistry Surrogate
          CHARACTER( 16 ) :: TRNS_FLAG     ! Do Transport (ADV + DIFF)?
          CHARACTER( 16 ) :: DDEP_FLAG     ! Output Dry Deposition Velocities
          CHARACTER( 16 ) :: WDEP_FLAG     ! Output Wet Scavenging Fluxes
          CHARACTER( 16 ) :: CONC_FLAG     ! Output Concentration
      END TYPE STM_SPC_DATA_1

      ! Equivalent to the Namelist Registry Format for Aerosols
      TYPE STM_SPC_DATA_2
          CHARACTER( 16 ) :: SPECIES_NAME  ! CMAQ Species Name
          REAL            :: MOLWT         ! g mol-1
          CHARACTER( 16 ) :: IC_SURR       ! IC Surrogate
          REAL            :: IC_FAC        ! IC Scale Factor
          CHARACTER( 16 ) :: BC_SURR       ! BC Surrogate
          REAL            :: BC_FAC        ! BC Scale Factor
          CHARACTER( 16 ) :: DEPV_SURR     ! Dry Deposition Surrogate
          REAL            :: DEPV_FAC      ! Dry Deposition Scale Factor
          CHARACTER( 16 ) :: SCAV_SURR     ! Wet Scavenging Surrogate
          REAL            :: SCAV_FAC      ! Wet Scavenging Scale Factor
          CHARACTER( 16 ) :: CLOUD_SURR    ! Cloud Chemistry Surrogate
          CHARACTER( 16 ) :: TRNS_FLAG     ! Do Transport?
          CHARACTER( 16 ) :: DDEP_FLAG     ! Output Dry Deposition Velocities
          CHARACTER( 16 ) :: WDEP_FLAG     ! Output Wet Scavenging Fluxes
          CHARACTER( 16 ) :: CONC_FLAG     ! Output Concentration
      END TYPE STM_SPC_DATA_2

      TYPE (STM_SPC_DATA_2), Parameter :: STM_AE_SPECIES_DATA(N_STM_AE_SPC) = (/
C                                                                 DRYDEP SURR                                            DDEP
C                                               ICFAC       BCFAC    |                                            TRNS | WDEP
C                      SPECIES      MW   IC       |  BC       |      |    FAC  WET-SCAV SURR  FAC AE2AQ SURR         | | | CONC  
C                      ------------ ---- ------- -+- ------- -+- ----+--- --- --------------- --- ------------------ + + + =
     & STM_SPC_DATA_2('ASO4AQH2O2J',96.0,''     ,0.0,''     ,0.0,'VMASSJ',1.0,'TRACER_ACCUM' ,1.0,'SO4_AQH2O2_ACCUM',Y,Y,Y,Y), 
     & STM_SPC_DATA_2('ASO4AQO3J'  ,96.0,''     ,0.0,''     ,0.0,'VMASSJ',1.0,'TRACER_ACCUM' ,1.0,'SO4_AQO3_ACCUM'  ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4AQFEMNJ',96.0,''     ,0.0,''     ,0.0,'VMASSJ',1.0,'TRACER_ACCUM' ,1.0,'SO4_AQFEMN_ACCUM',Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4AQMHPJ' ,96.0,''     ,0.0,''     ,0.0,'VMASSJ',1.0,'TRACER_ACCUM' ,1.0,'SO4_AQMHP_ACCUM' ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4AQPAAJ' ,96.0,''     ,0.0,''     ,0.0,'VMASSJ',1.0,'TRACER_ACCUM' ,1.0,'SO4_AQPAA_ACCUM' ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4GASJ'   ,96.0,''     ,0.0,''     ,0.0,'VMASSJ',1.0,'TRACER_ACCUM' ,1.0,'TRACER_ACCUM'    ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4EMISJ'  ,96.0,''     ,0.0,''     ,0.0,'VMASSJ',1.0,'TRACER_ACCUM' ,1.0,'TRACER_ACCUM'    ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4ICBCJ'  ,96.0,'ASO4J',1.0,'ASO4J',1.0,'VMASSJ',1.0,'TRACER_ACCUM' ,1.0,'TRACER_ACCUM'    ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4GASI'   ,96.0,''     ,0.0,''     ,0.0,'VMASSI',1.0,'TRACER_AITKEN',1.0,'TRACER_AITKEN'   ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4EMISI'  ,96.0,''     ,0.0,''     ,0.0,'VMASSI',1.0,'TRACER_AITKEN',1.0,'TRACER_AITKEN'   ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4ICBCI'  ,96.0,'ASO4I',1.0,'ASO4I',1.0,'VMASSI',1.0,'TRACER_AITKEN',1.0,'TRACER_AITKEN'   ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4GASK'   ,96.0,''     ,0.0,''     ,0.0,'VMASSC',1.0,'TRACER_COARSE',1.0,'TRACER_COARSE'   ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4EMISK'  ,96.0,''     ,0.0,''     ,0.0,'VMASSC',1.0,'TRACER_COARSE',1.0,'TRACER_COARSE'   ,Y,Y,Y,Y),
     & STM_SPC_DATA_2('ASO4ICBCK'  ,96.0,'ASO4K',1.0,'ASO4K',1.0,'VMASSC',1.0,'TRACER_COARSE',1.0,'TRACER_COARSE'   ,Y,Y,Y,Y)
     & /)

      TYPE (STM_SPC_DATA_2), Parameter :: STM_OAE_SPECIES_DATA(N_STM_OAE_SPC) = ( /
C                                                       DRYDEP SURR                                       DDEP
C                                          ICFAC  BCFAC    |                                         TRNS | WDEP
C                      SPECIES      MW   IC  |  BC  |      |    FAC WET-SCAV SURR  FAC AE2AQ SURR     | | | CONC  
C                      ------------ ---- -- -+- -- -+- ----+--- --- -------------- --- -------------- + + + +
     & STM_SPC_DATA_2('OSO4J'      ,96.0,'',0.0,'',0.0,'VMASSJ',1.0,'TRACER_ACCUM',1.0,'TRACER_ACCUM',Y,Y,Y,Y),
     & STM_SPC_DATA_2('OSO4AQH2O2J',96.0,'',0.0,'',0.0,'VMASSJ',1.0,'TRACER_ACCUM',1.0,'TRACER_ACCUM',Y,Y,Y,Y),
     & STM_SPC_DATA_2('OSO4AQO3J'  ,96.0,'',0.0,'',0.0,'VMASSJ',1.0,'TRACER_ACCUM',1.0,'TRACER_ACCUM',Y,Y,Y,Y),
     & STM_SPC_DATA_2('OSO4AQFEMNJ',96.0,'',0.0,'',0.0,'VMASSJ',1.0,'TRACER_ACCUM',1.0,'TRACER_ACCUM',Y,Y,Y,Y),
     & STM_SPC_DATA_2('OSO4AQMHPJ' ,96.0,'',0.0,'',0.0,'VMASSJ',1.0,'TRACER_ACCUM',1.0,'TRACER_ACCUM',Y,Y,Y,Y),
     & STM_SPC_DATA_2('OSO4AQPAAJ' ,96.0,'',0.0,'',0.0,'VMASSJ',1.0,'TRACER_ACCUM',1.0,'TRACER_ACCUM',Y,Y,Y,Y),
     & STM_SPC_DATA_2('OSO4GASJ'   ,96.0,'',0.0,'',0.0,'VMASSJ',1.0,'TRACER_ACCUM',1.0,'TRACER_ACCUM',Y,Y,Y,Y),
     & STM_SPC_DATA_2('OSO4EMISJ'  ,96.0,'',0.0,'',0.0,'VMASSJ',1.0,'TRACER_ACCUM',1.0,'TRACER_ACCUM',Y,Y,Y,Y),
     & STM_SPC_DATA_2('OSO4ICBCJ'  ,96.0,'',0.0,'',0.0,'VMASSJ',1.0,'TRACER_ACCUM',1.0,'TRACER_ACCUM',Y,Y,Y,Y)
     & /)

      TYPE (STM_SPC_DATA_1), Parameter :: STM_NR_SPECIES_DATA(N_STM_NR_SPC) = (/
C                                                             DRYDEP                                             DDEP
C                                            ICFAC      BCFAC  SURR        WET-SCAV                          TRNS | WDEP
C                      SPECIES    MW   IC      |  BC      |      |     FAC   SURR  FAC AE2AQ SURR  NR2AE SURR   | | | CONC  
C                      ---------- ---- ------ -+- ------ -+- ----+---- --- ------- --- ----------- ------------ + + + +
     & STM_SPC_DATA_1('SULF_ICBC',98.0,'SULF',1.0,'SULF',1.0,'VD_SULF',1.0,'H2SO4',1.0,'SULF_ICBC','H2SO4_ICBC',Y,Y,Y,Y)
     & /)

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      End Module stm_vars

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_internal_util_module.f,v 1.2 2006/02/15 14:47:24 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
 
C   -- use F90 module feature to group utility routines so that they can be
C      accessed within se library
 
C Revision history:
 
C   Orginal version: 11/05/99 by David Wong
C   Documentation and code text changes for se_generate_map: 12/24/05 by Jeff Young
C --------------------------------------------------------------------------

        module se_internal_util_module

        implicit none

        contains

C -----------------------------------------------------------------------------
C Purpose:
 
C To determine mapping of a grid onto a processor configuration with data 
C redistribution by calculating starting and ending row and column. The mapping
C is kept in each PE. This routine provides flexibility (see routine parameter 
C list) of domain decomposition in the level dimension as well for future use. 
C Currently, only row and column dimensions are decomposed.
C
C There are two ways, determined by the existence of an optional variable
C "flag", to generate a map:
C    1. The incoming parameters are indices of a partitioned sub-grid.
C       (No redistribution)
C    2. The incoming parameters are indices of the original sub-grid without
C       partition.
 
C To deal with the first case, no special calculation is done except to assign 
C the incoming indices to the map. Calculation is required for the second case. 
C For example, given 8 processors with 2 x 4 processor configuration (row by
C column), a 20x25 data grid, a 10 x 5 sub grid starts at (7,5), the following 
C are the starting and ending row and column, respectively.
 
C      PE #          row               column
C      -----------------------------------------
C       0           7, 11               5,  6
C       1           7, 11               7,  7
C       2           7, 11               8,  8
C       3           7, 11               9,  9
C       4          12, 16               5,  6
C       5          12, 16               7,  7
C       6          12, 16               8,  8
C       7          12, 16               9,  9
 
C Subroutine parameter description:
 
C   In:  begrow -- beginning row index
C        endrow -- ending row index
C        begcol -- beginning column index
C        endcol -- ending column index
C        nprow  -- number of processors along the row dimension
C        npcol  -- number of processors along the column dimension
C        flag   -- an optional variable to indicate which one of the two ways
C                  to generate a index map
 
C   Out: index  -- the index map
 
C Local variable description:
 
C   error    -- mpi function call error code
C   block    -- cell base block size (minus 1)
C   nb       -- no. cells with base block size (minus 1)
C   prow     -- local loop index
C   pcol     -- local loop index
C   my_pe    -- local processor number
 
C Include files:
C
C   mpif.h
C   se_pe_info_ext
C   se_domain_info_ext
C   se_ori_ext
 
C Revision history:
C
C   Orginal version: 2/15/99 by David Wong
 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                      -- provide a centralize spot to modify the global map
C                         according to the data orientation
 
C                    10/05/00 by David Wong
C                      -- combined two mapping routine into one and using a new
C                         optional variable flag to distinguish them
 
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C -----------------------------------------------------------------------------

      subroutine se_generate_map( begrow, endrow, begcol, endcol, 
     &                            nprow, npcol, index, flag )

      use se_pe_info_ext

      implicit none

      include "mpif.h"

      integer, intent( in )  :: begrow, endrow, begcol, endcol
      integer, intent( in )  :: nprow, npcol
      integer, optional, intent( in ) :: flag
      integer, intent( out ) :: index( :,:,: ) ! actual argument is a pointer

      integer :: my_pe, nb, block, prow, pcol, error

      if ( se_myworker_pe .ge. 0 ) then
         if ( present( flag ) ) then

C -- set the low and high column and row index of the
C    Process Analysis (PA) grid, respectively

            index( 1,1,se_myworker_pe+1 ) = begcol
            index( 2,1,se_myworker_pe+1 ) = endcol

            index( 1,2,se_myworker_pe+1 ) = begrow
            index( 2,2,se_myworker_pe+1 ) = endrow

C -- each PE sends PA grid index info to PE 0, gather process

            call mpi_gather( index( 1,1,se_myworker_pe+1 ), ! strt addr of send buf
     &                       4,                             ! no. elements in send buf
     &                       mpi_integer,                   ! data type in send buf
     &                       index( 1,1,se_myworker_pe+1 ), ! addr of recv buf (signifcant only at recv process)
     &                       4,                             ! no. elements in recv buf (signifcant only at recv process)
     &                       mpi_integer,                   ! data type in recv buf (signifcant only at recv process)
     &                       0,                             ! rank of recv process
     &                       se_worker_comm,                ! communicator
     &                       error )

C In mpi_gather, each process sends the contents of its send buffer to the recv
C process, which receives the messages and stores them in rank order.

C -- PE 0 broadcasts entire PA grid index info

            call mpi_bcast( index( 1,1,1 ),   ! strt addr of send/recv buf
     &                      4*se_numworkers,  ! no. elements in buf
     &                      mpi_integer,      ! data type in buf
     &                      0,                ! rank of broadcast process
     &                      se_worker_comm,   ! communicator
     &                      error )

         else

C -- figure out the low and high column and row index of the 
C    Process Analysis (PA) grid, respectively

            nb = mod( ( endcol - begcol + 1 ), npcol )
            block = ( endcol - begcol + 1 ) / npcol
            do pcol = 0, npcol-1

               do prow = 0, nprow-1
                  my_pe = prow * npcol + pcol
                  if ( pcol .lt. nb ) then
                     index( 1,1,my_pe+1 ) = begcol + pcol * ( block + 1 )
                     index( 2,1,my_pe+1 ) = index( 1,1,my_pe+1 ) + block
                  else
                     index( 1,1,my_pe+1 ) = begcol + nb * ( block + 1 )
     &                                    + ( pcol - nb ) * block
                     index( 2,1,my_pe+1 ) = index( 1,1,my_pe+1 ) + block - 1
                  end if
               end do
            end do

            nb = mod( ( endrow - begrow + 1 ), nprow )
            block = ( endrow - begrow + 1 ) / nprow
            do prow = 0, nprow-1

               do pcol = 0, npcol-1
                  my_pe = prow * npcol + pcol
                  if ( prow .lt. nb ) then
                     index( 1,2,my_pe+1 ) = begrow + prow * ( block + 1 )
                     index( 2,2,my_pe+1 ) = index( 1,2,my_pe+1 ) + block
                  else
                     index( 1,2,my_pe+1 ) = begrow + nb * ( block + 1 )
     &                                    + ( prow - nb ) * block
                     index( 2,2,my_pe+1 ) = index( 1,2,my_pe+1 ) + block - 1
                  end if
               end do
            end do

         end if

      end if

      return
      end subroutine se_generate_map

C --------------------------------------------------------------------------
C Purpose:
C
C   -- to interchange two integer values
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C --------------------------------------------------------------------------
        subroutine swap (data1, data2)

        implicit none

        integer, intent(inout) :: data1, data2

        integer :: temp

        temp = data1
        data1 = data2
        data2 = temp

        return
        end subroutine swap

C --------------------------------------------------------------------------
C Purpose:
C
C   -- to extract a character string of integer into individual integers
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C                    05/04/01 by David Wong
C                     -- remove all leading double blank spaces
C                    09/19/18 by David Wong
C                     -- remove unused variables
C --------------------------------------------------------------------------

        subroutine se_string_to_integer (str, data, n)

        character (len = *), intent(inout) :: str
        integer, intent(inout) :: data(*)
        integer, intent(out) :: n

        integer i, j, stat
        logical stop

C -- remove all leading double blank spaces
        stop = .false.
        do while (.not. stop)
          i = index(trim(str), "  ")
          if (i == 0) then
             stop = .true.
          else
             do j = i+1, 80
                str(j-1:j-1) = str(j:j)
             end do
          end if
        end do

C -- if the first character is a blank space, remove it
        if (str(1:1) .eq. ' ') then
           str(1:79) = str(2:80)
        end if

C -- extract each individual integer
        stop = .false.
        i = 1
        j = 1
        do while (.not. stop)
           read (str(i:80), *, iostat=stat) data(j)
           if (stat .ne. 0) then
              j = j - 1
              stop = .true.
           else
              j = j + 1
              i = index(str(i:80), ' ') + i
           end if
        end do

        n = j

        end subroutine se_string_to_integer

C --------------------------------------------------------------------------
C Purpose:
C
C   -- to modify existing global map when a dot file is encountered (primarily
C      for DFIO application)
C
C Revision history:
C
C   Orginal version: 05/24/01 by David Wong
C --------------------------------------------------------------------------

        subroutine se_dotfile_map (map1, nprow1, npcol1, map2, nprow2, npcol2)

        implicit none

        integer, intent(inout) :: map1(:,:,:), map2(:,:,:)
        integer, intent(in)    :: nprow1, npcol1, nprow2, npcol2

        integer :: i

        do i = npcol1, nprow1*npcol1, npcol1
           map1(2,1,i) = map1(2,1,i) + 1
        end do
        do i = nprow1*npcol1, nprow1*npcol1-npcol1+1, -1
           map1(2,2,i) = map1(2,2,i) + 1
        end do

        do i = 1, nprow2*npcol2
           map2(2,1,i) = map2(2,1,i) + 1
           map2(2,2,i) = map2(2,2,i) + 1
        end do

        end subroutine se_dotfile_map

C --------------------------------------------------------------------------
C Purpose:
C
C   -- to adjust the stencil size for boundary processors when there is/are a
C      NE, SE, SW, or/and NW communication. Consider a 3 x 2 processor 
C      configuration as shown below and suppose there is a NE communication:
C
C         3   4   5
C         0   1   2
C
C      processor 0's NE portion will receive from processor 4. However there is
C      no processor which is NE of processor 4. This routine will make NE 
C      portion of processor 4 available and the data is coming from processor 
C      5.
C
C Subroutine parameter description:
C
C   In: ndis  -- north displacement
C       edis  -- east displacement
C       sdis  -- south displacement
C       wdis  -- west displacement
C       flag  -- indicator: sending (1) or receiving (2)
C
C  Out: n_adj -- north adjustment
C       e_adj -- east adjustment
C       s_adj -- south adjustment
C       w_adj -- west adjustment
C
C Revision history:
C
C   Orginal version: 1/17/01 by David Wong
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C --------------------------------------------------------------------------
        subroutine se_corner_adjust (ndis, edis, sdis, wdis, flag,
     &                               n_adj, e_adj, s_adj, w_adj)

        use se_pe_info_ext

        implicit none

        integer, intent(in)  :: ndis, edis, sdis, wdis, flag
        integer, intent(out) :: n_adj, e_adj, s_adj, w_adj

        include 'mpif.h'

c       integer :: my_pe, error

c       call mpi_comm_rank (se_worker_comm, my_pe, error)

        n_adj = 0
        e_adj = 0
        s_adj = 0
        w_adj = 0

C -- adjust sending parameters
        if (flag .eq. 1) then

C -- adjustment north and east bound, respectively
           if ((ndis .gt. 0) .and. (edis .gt. 0)) then
              if ((se_myworker_pe .gt. 0) .and. (se_myworker_pe .le. se_npcol-1)) then
                 n_adj = ndis
              end if
              if (      (se_myworker_pe .lt. se_npcol*se_nprow-1)
     &            .and. (mod(se_myworker_pe, se_npcol) .eq. se_npcol-1)) then
                 e_adj = edis
              end if
           end if

C -- adjustment south and east bound, respectively
           if ((sdis .gt. 0) .and. (edis .gt. 0)) then
              if (se_myworker_pe .gt. se_npcol*(se_nprow-1)) then
                 s_adj = sdis
                 end if
              if (      (se_myworker_pe .gt. se_npcol-1)
     &            .and. (mod(se_myworker_pe, se_npcol) .eq. se_npcol-1)) then
                 e_adj = edis
              end if
           end if

C -- adjustment south and west bound, respectively
           if ((sdis .gt. 0) .and. (wdis .gt. 0)) then
              if (      (se_myworker_pe .ge. se_npcol*(se_nprow-1))
     &            .and. (se_myworker_pe .lt. se_npcol*se_nprow-1)) then
                 s_adj = sdis
              end if
              if ((mod(se_myworker_pe, se_npcol) .eq. 0) .and. (se_myworker_pe .gt. 0)) then
                 w_adj = wdis
              end if
           end if

C -- adjustment north and west bound, respectively
           if ((ndis .gt. 0) .and. (wdis .gt. 0)) then
              if (se_myworker_pe .lt. se_npcol-1) then
                 n_adj = ndis
              end if
              if (      (mod(se_myworker_pe, se_npcol) .eq. 0)
     &            .and. (se_myworker_pe .lt. se_npcol*(se_nprow-1))) then
                 w_adj = wdis
              end if
           end if

        else     ! -- adjust receiving parameters

C -- adjustment north and east bound, respectively
           if ((ndis .gt. 0) .and. (edis .gt. 0)) then
              if (se_myworker_pe .lt. se_npcol-1) then
                 n_adj = ndis
              end if
              if (      (se_myworker_pe .gt. se_npcol-1)
     &            .and. (mod(se_myworker_pe, se_npcol) .eq. se_npcol-1)) then
                 e_adj = edis
              end if
           end if

C -- adjustment south and east bound, respectively
           if ((sdis .gt. 0) .and. (edis .gt. 0)) then
              if (      (se_myworker_pe .lt. se_nprow*se_npcol-1)
     &            .and. (se_myworker_pe .ge. se_npcol*(se_nprow-1))) then
                 s_adj = sdis
                 end if
              if (      (se_myworker_pe .lt. se_nprow*se_npcol-1)
     &            .and. (mod(se_myworker_pe, se_npcol) .eq. se_npcol-1)) then
                 e_adj = edis
              end if
           end if

C -- adjustment south and west bound, respectively
           if ((sdis .gt. 0) .and. (wdis .gt. 0)) then
              if (se_myworker_pe .gt. se_npcol*(se_nprow-1)) then
                 s_adj = sdis
              end if
              if (      (mod(se_myworker_pe, se_npcol) .eq. 0)
     &            .and. (se_myworker_pe .lt. se_npcol*(se_nprow-1))) then
                 w_adj = wdis
              end if
           end if

C -- adjustment north and west bound, respectively
           if ((ndis .gt. 0) .and. (wdis .gt. 0)) then
              if ((se_myworker_pe .lt. se_npcol) .and. (se_myworker_pe .ge. 0)) then
                 n_adj = ndis
              end if
              if ((mod(se_myworker_pe, se_npcol) .eq. 0) .and. (se_myworker_pe .gt. 0)) then
                 w_adj = wdis
              end if
           end if
        end if

        end subroutine se_corner_adjust
 
        end module se_internal_util_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


! Used to calculate biogenic emissions. First available in CMAQ 5.4

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE MEGAN_DEFN

C-----------------------------------------------------------------------
C Function: biogenics emissions interface to the chemistry-transport model
      
      USE RUNTIME_VARS
      USE MEGAN_FX
      IMPLICIT NONE

      REAL,    ALLOCATABLE, SAVE :: VDEMIS_ME( :,:,: ) ! megan emis

      CONTAINS

C=======================================================================
         FUNCTION MEGAN_INIT( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )

         USE HGRD_DEFN
         USE CGRID_SPCS          ! CGRID mechanism species
         USE BEIS_DEFN           ! from beis
         USE centralized_io_module, only : soilinp_setup
         USE MEGAN_GSPRO
#ifdef mpas
         USE utilio_defn
#endif

         IMPLICIT NONE

         INTEGER JDATE, JTIME, TSTEP
         LOGICAL SUCCESS

         CHARACTER( 16 )       :: PNAME = 'MEGAN_INIT'
         CHARACTER( 80 )       :: VARDESC   ! env variable description
         CHARACTER( 120 )      :: XMSG = ' '            
         INTEGER V, K, STATUS

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

C In-line biogenic emissions?
         CALL LOG_SUBHEADING( LOGDEV, 'Initialize Online Biogenic VOC Emissions Module ' )

C biogenics to gas-phase species map
         IF ( BIOGEMIS_MEGAN ) THEN

            CALL MEGAN_MAP

            XMSG = 'Using in-line biogenic emissions option (MEGAN)'

            DESID_EMVAR( IMIOGSRM )%LEN = NMGNSPC
            ALLOCATE( DESID_EMVAR( IMIOGSRM )%ARRY ( NMGNSPC ) )
            ALLOCATE( DESID_EMVAR( IMIOGSRM )%UNITS( NMGNSPC ) )
            ALLOCATE( DESID_EMVAR( IMIOGSRM )%MW   ( NMGNSPC ) )
            ALLOCATE( DESID_EMVAR( IMIOGSRM )%USED ( NMGNSPC ) )
            ALLOCATE( DESID_EMVAR( IMIOGSRM )%CONV ( NMGNSPC ) )
            ALLOCATE( DESID_EMVAR( IMIOGSRM )%BASIS( NMGNSPC ) )
            ALLOCATE( DESID_EMVAR( IMIOGSRM )%LAREA( NMGNSPC ) )
            ALLOCATE( DESID_EMVAR( IMIOGSRM )%LAREAADJ( NMGNSPC ) )
            
            DESID_EMVAR( IMIOGSRM )%ARRY  = MEGAN_NAMES
            DESID_EMVAR( IMIOGSRM )%UNITS = 'MOLES/S'
            DESID_EMVAR( IMIOGSRM )%MW    = 1.0
            DESID_EMVAR( IMIOGSRM )%USED  = .FALSE.
            DESID_EMVAR( IMIOGSRM )%CONV  = 1.0
            DESID_EMVAR( IMIOGSRM )%BASIS = 'UNIT' 
            DESID_EMVAR( IMIOGSRM )%LAREA = .FALSE.
            DESID_EMVAR( IMIOGSRM )%LAREAADJ = .FALSE.

            ALLOCATE( VDEMIS_ME( NMGNSPC,NCOLS,NROWS ), STAT = STATUS )
            IF ( STATUS .NE. 0 ) THEN
              XMSG = 'VDEMIS_ME memory allocation failed'
              SUCCESS = .FALSE.; RETURN
            END IF

#ifdef mpas
            call mio_setfile ('GR_EMIS_001')

             call mio_fcreate ('MEGAN_OUTPUT',512 ) ! 512 means clobber+netcdf64
          if (BDSNP_MEGAN) then
             call mio_fcreate ('BDSNPOUT',512 ) ! 512 means clobber+netcdf64
             call mio_fcreate ('BDSNP_DIAG',512 ) ! 512 means clobber+netcdf64
          end if
#endif
         END IF

         SUCCESS = .TRUE.; RETURN

         END FUNCTION MEGAN_INIT
C=======================================================================

         SUBROUTINE GET_MEGAN ( JDATE, JTIME, TSTEP, L_DESID_DIAG )
       
         USE centralized_io_module, only : ldf,ctf,t24y,sw24y,lai_m,lai_y
         USE centralized_io_util_module
         USE ASX_DATA_MOD 
         USE hgrd_defn, only : ncols, nrows
         USE RUNTIME_VARS, only : NEW_START,IGNORE_SOILINP,logdev
         USE UTILIO_DEFN
         USE MEGAN_HRNO_MOD
         USE DESID_VARS, ONLY : DESID_N_ISTR, IMIOGSRM,
     &                         MAP_ISTRtoEMVAR, MAP_ISTRtoDIFF
         USE GRID_CONF, ONLY: GDTYP_GD, XCELL_GD, YCELL_GD, YORIG_GD, GL_NROWS
         USE MEGAN_GSPRO

         IMPLICIT NONE

         LOGICAL, INTENT( IN ) :: L_DESID_DIAG

         CHARACTER (20) :: TIME_STAMP
         INTEGER JDATE, JTIME, TSTEP( 3 ), ISTR, io_mode, LAYERS
         INTEGER I, J,MXLAI, LAIp_I,LAIc_i
         REAL JDAY, JYEAR, ZTIME
         REAL            :: CURRHR                          ! current GMT hour

         REAL shadeleafTK(ncols,nrows,5)
         REAL sunleafTK(ncols,nrows,5) 
         REAL sunfrac(ncols,nrows,5)
         REAL sunppfd(ncols,nrows,5)
         REAL shadeppfd(ncols,nrows,5)

         REAL er(ncols,nrows)  
         REAL non_dimgarma(19,ncols,nrows)
         REAL out_to_cmaq(NMGNSPC,ncols,nrows) ! 
         REAL CFNO(ncols,nrows)         ! emission activity for crop
         REAL CFNOG(ncols,nrows)        ! "     " for grass
         REAL GAMSM(ncols,nrows)        ! soil moisture activity for isop
         REAL GAMNO(ncols,nrows)        ! final NO emission activity
         REAL BDSNP_NO_out(ncols,nrows) ! final NO emission activity from BDSNP

         REAL PRECADJ(ncols,nrows)
         REAL LAIP ( NCOLS, NROWS )    ! previous LAI 
         REAL LAIC ( NCOLS, NROWS )    ! current LAI 

         CHARACTER( 16 ) :: PNAME = 'MEGAN_DEFN'
         CHARACTER( 120 )      :: XMSG = ' '

         INTEGER, SAVE :: MGN_IHR       ! current simulation hour
         INTEGER          MGN_NDX       ! RAINFALL array timestep index
!        Calculate cell area. 
!        Could be removed in favor of DESID changes
         REAL  DX1, DX2                            ! grid-cell width and length
         REAL, ALLOCATABLE :: LOC_CELL_AREA(:,:)   ! grid-cell area [m2]
         REAL  :: LOC_MSFX2(NCOLS,NROWS)
         INTEGER :: STAT

         if (.not. allocated(loc_cell_area)) then
            allocate (loc_cell_area(ncols, nrows), stat=stat)
         end if

#ifdef mpas 
         loc_msfx2 = 1.0
         loc_cell_area = cell_area
         !output_step   = time2sec(tstep(1))
         !half_syn_step = time2sec(tstep(2)) / 2
         JDAY   = FLOAT( MOD( JDATE, 1000 ) )
         JYEAR  = FLOAT( JDATE / 1000  )       
         CURRHR = REAL ( TIME2SEC( JTIME ) ) / 3600.0
#else
         JDAY   = FLOAT( MOD( JDATE, 1000 ) )
         JYEAR  = FLOAT( JDATE / 1000  )       
         CURRHR = REAL ( TIME2SEC( JTIME ) ) / 3600.0

         ! *** Get length and width of each grid cell
         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD ! in m
            DX2 = DG2M * YCELL_GD
     &          * COS( PI180*( YORIG_GD + YCELL_GD
     &          * FLOAT( GL_NROWS/2 ) ) ) ! in m
         ELSE
            DX1 = XCELL_GD        ! in m
            DX2 = YCELL_GD        ! in m
         END IF

         LOC_CELL_AREA = DX1 * DX2
         loc_msfx2 = msfx2
#endif
         non_dimgarma = 0.
         LAYERS = 5  ! canopy layers


         ! This option is only included for users who wish to confirm
         ! that their results match with offline MEGAN 3.2
         IF (USE_MEGAN_LAI) THEN ! Read from the preprocessed file
           MXLAI = 46 ! 8-daily
                      ! hard coded to avoid excessive environmental
                      ! variables. MEGAN3.2 offers monthly and 10-day options.
           CALL FINDLAI( JDATE, MXLAI, MXLAI, LAIp_I, LAIc_I)
           laip(:,:) = lai_m(:,:,laip_i)
           laic(:,:) = lai_m(:,:,laic_i)
         ELSE ! Take daily values from WRF/MCI
           laip = LAI_Y
           laic = Met_data%LAI 
         END IF

! Canopy light calculation
         CALL MEGCANOPY( JYEAR, LAYERS, JDAY,CURRHR,    
     &            grid_data%lat, grid_data%lon, laic,          
     &            met_data%TEMP2, met_data%rgrnd, met_data%wspd10,
     &            met_data%prsfc, met_data%Q2, ctf(1:6,:,:),
     &            ShadeleafTK, SunleafTK, SunFrac, SunPPFD, ShadePPFD)

! MEGAN_HRNO is here so we have rainfall/pulse/PRECADJ, temp and radiation 
! for prev 24 hrs. Also used to get save daily LAI.
          precadj=0. 
          CALL MEGAN_HRNO( JDATE, JTIME, TSTEP, L_DESID_DIAG,PRECADJ)

! SOIL NITROGEN CALCULATION
! We call MEGVSA for GAMSM if using BDSNP or 
! turning on drought stress. Used for
! GAMNO if using MEGAN YL95 for soil NO
          CFNO = 0 
          CFNOG = 0 
          GAMNO = 0
          bdsnp_no_out = 0. 

          CALL MEGVSA (JDATE,JTIME,TSTEP,JYEAR,JDAY,
     &    L_DESID_DIAG,Grid_Data%SLTYP, 
     &    ctf(1:6,:,:),laic, grid_data%lat, 
     &    met_data%TEMP2,Met_Data%SOIM1, Met_Data%SOIM2,
     &    Met_Data%SOIT1,PRECADJ,
     &    CFNO, CFNOG, GAMSM, GAMNO,BDSNP_NO_out)

         IF ( NEW_START .or. IGNORE_SOILINP) THEN
          t24y  = met_data%temp2 ! use instantaneous values if no 24h avg
          sw24y = met_data%rgrnd
          laip  = laic  ! no veg growth for first day of simulation
         END IF

! Emission activity calculation
         CALL MEGVEA( LAYERS, JDATE, CURRHR, 
     &   laip,laic,ldf,
     &   GAMSM, met_data%TEMP2,met_data%TEMP2,
     &   met_data%wspd10, 
     &   t24y, sw24y, sunleaftk, shadeleaftk, 
     &   sunfrac, sunppfd, shadeppfd,ER, NON_DIMGARMA )

! Speciate for mechanism
        if(bdsnp_megan) then
          CALL convert2mech(bdsnp_no_out,non_dimgarma,out_to_cmaq)
        else
          CALL convert2mech(gamno,non_dimgarma,out_to_cmaq)
        end if
! Units for use by EMIS_DEFN.F via vdemis_me: [moles/s/m2]
         do i=1,NMGNSPC
           vdemis_me(i,:,:) = out_to_cmaq(i,:,:)*loc_cell_area/loc_msfx2
         end do

#ifdef mpas
             call mio_time_format_conversion (jdate, jtime, time_stamp)
           IF (L_DESID_DIAG) THEN
                do i=1,NMGNSPC
                   call mio_fwrite('MEGAN_OUTPUT',trim(MEGAN_NAMES(i)), pname,
     &                             out_to_cmaq(i,:,1),time_stamp)
                end do
             END IF
#endif

         RETURN
         END SUBROUTINE GET_MEGAN

      END MODULE MEGAN_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE MGEMIS
C-----------------------------------------------------------------------
C Description:

C Revision History:
C   03 Nov 15: B. Gantt and G. Sarwar: created the initial version for marine 
C      gas emissions
C   26 Sep 16: D. Wong: removed repeated SEAICE interpx statement
C   20 Feb 18: G. Sarwar: removed Br2, added DMS, and revised estimates of 
C              halocarbon and HOI/I2 emissions
C   04 Dec 18: G. Srawar: updated local time calculation
C   01 Feb 19: D. Wong: Implemented centralized I/O approach
C   15 May 19: D. Wong: Replaced MGEM with USE_MARINE_GAS_EMISSION which is set in RUNTIME_VARS.F
C   16 May 19: D. Wong: * Removed initialization of OCEAN, SZONE, CHLR, and DMSL. 
C                       * Used LON directly to save space.
C   04 Sep 20: G. Sarwar* Fixed bug for Kw
C   03 Mar 22: D. Wong and G. Sarwar* updated for DMS emissions with cb6r5

      USE RUNTIME_VARS
      USE HGRD_DEFN
      USE DESID_VARS
#ifdef mpas
      use util_module
#endif

      IMPLICIT NONE

      INTEGER, PARAMETER :: NMGSPC = 12

C Marine gas Emissions Rates
      REAL, ALLOCATABLE, SAVE :: VDEMIS_MG( :,:,: )   ! marine gas emission rates [moles/s]

      PUBLIC NMGSPC, VDEMIS_MG, MGEMIS_INIT, GET_MGEMIS, MG_SPC, MGSPC_MAP
      PRIVATE

      INTEGER, SAVE              :: LGC_O3            ! pointer to O3 in CGRID

C Variables for the marine gas diagnostic file
      INTEGER :: NMGDIAG                              ! number of species in marine gas
                                                      ! diagnostic emission file
      REAL,    ALLOCATABLE       :: MGOUTD( : )       ! emission rates
      REAL,    ALLOCATABLE, SAVE :: MGBF( :,:,: )     ! marine gas emiss accumulator
      REAL,    ALLOCATABLE, SAVE :: WRMG( :,: )       ! marine gas emiss write buffer
      INTEGER, SAVE              :: MGSPC_MAP( NMGSPC )

! Species names in the speciated marine gas-emissions
      CHARACTER( 16 ), ALLOCATABLE :: WRMG_SPC( : )   ! species names

      CHARACTER( 16 ) :: MG_SPC( NMGSPC)           ! emitted species

      INTEGER :: MG_SPC_IND ( NMGSPC)              ! emitted species index

      DATA  MG_SPC  /  'MB3             ',
     &                 'MB2             ',
     &                 'MBC             ',
     &                 'MB2C            ',
     &                 'MBC2            ',
     &                 'CH3I            ',
     &                 'MIC             ',
     &                 'MIB             ',
     &                 'MI2             ',
     &                 'I2              ',
     &                 'HOI             ',
     &                 'DMS             ' /

       REAL :: MG_MW( NMGSPC )                    ! emitted species molecular weight (g/mol)

       DATA MG_MW   / 252.7,
     &                173.8,
     &                129.4,
     &                208.3,
     &                243.8,
     &                141.9,
     &                176.4,
     &                219.9,
     &                267.8,
     &                253.8,
     &                143.9,
     &                62.0     /

C Variables interpolated from the meteorological input files
      REAL,    ALLOCATABLE, SAVE :: U10( :,: )      ! wind speed at 10m [m/s]
      REAL,    ALLOCATABLE, SAVE :: TSEASFC( :,: )  ! sea surface temp K
      REAL,    ALLOCATABLE, SAVE :: SEAICE( :,: )   ! seaice fraction

      INTEGER I

C Domain decomposition info from emission and meteorology files
      INTEGER, SAVE :: GXOFF, GYOFF                 ! origin offset
      INTEGER, SAVE :: STRTCOL_O1, ENDCOL_O1, STRTROW_O1, ENDROW_O1
      INTEGER, SAVE :: STRTCOLMC3, ENDCOLMC3, STRTROWMC3, ENDROWMC3
      INTEGER, SAVE :: STRTCOLGC2, ENDCOLGC2, STRTROWGC2, ENDROWGC2

      CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      FUNCTION MGEMIS_INIT( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )

C Revision History:
C   03 Nov 15: B. Gantt and G. Sarwar: created the initial version for marine gas emissions

            USE UTILIO_DEFN
            USE HGRD_DEFN
            USE CGRID_SPCS
            USE RXNS_DATA
            USE RUNTIME_VARS, ONLY : USE_MARINE_GAS_EMISSION
            USE CENTRALIZED_IO_MODULE, only : chlr, dmsl

            IMPLICIT NONE
            INCLUDE SUBST_FILES_ID                                  ! file name parameters

C Arguments:
            INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP
            LOGICAL :: SUCCESS

            CHARACTER( 80 )       :: VARDESC                        ! env variable description

C Local Variables:

            CHARACTER( 16 ), SAVE :: PNAME = 'MGEMIS_INIT'
            CHARACTER( 96 ) :: XMSG = ' '
            CHARACTER(  16 ) :: VARNM
            INTEGER STATUS
            INTEGER S, N, L, K, V
            INTEGER :: START_INDEX, END_INDEX

C-----------------------------------------------------------------------

            SUCCESS = .TRUE.

C flag for marine gas emissions; this flag is set in the subroutine EM_FILE_INIT 
            IF ( .NOT. USE_MARINE_GAS_EMISSION ) RETURN

C Allocate MG arrays using NMGSPC value
            DESID_EMVAR( IMGSRM )%LEN = NMGSPC
            ALLOCATE( DESID_EMVAR( IMGSRM )%ARRY ( NMGSPC ) )
            ALLOCATE( DESID_EMVAR( IMGSRM )%UNITS( NMGSPC ) )
            ALLOCATE( DESID_EMVAR( IMGSRM )%MW   ( NMGSPC ) )
            ALLOCATE( DESID_EMVAR( IMGSRM )%USED ( NMGSPC ) )
            ALLOCATE( DESID_EMVAR( IMGSRM )%CONV ( NMGSPC ) )
            ALLOCATE( DESID_EMVAR( IMGSRM )%BASIS( NMGSPC ) )
            ALLOCATE( DESID_EMVAR( IMGSRM )%LAREA( NMGSPC ) )
            ALLOCATE( DESID_EMVAR( IMGSRM )%LAREAADJ( NMGSPC ) )
            
            DESID_EMVAR( IMGSRM )%ARRY  = MG_SPC
            DESID_EMVAR( IMGSRM )%UNITS = 'MOLES/S'
            DESID_EMVAR( IMGSRM )%MW    = MG_MW
            DESID_EMVAR( IMGSRM )%USED  = .FALSE.
            DESID_EMVAR( IMGSRM )%CONV  = 1.0
            DESID_EMVAR( IMGSRM )%BASIS = 'MOLE'
            DESID_EMVAR( IMGSRM )%LAREA = .FALSE.
            DESID_EMVAR( IMGSRM )%LAREAADJ = .FALSE.

            ALLOCATE ( VDEMIS_MG( NMGSPC,NCOLS,NROWS), STAT = STATUS )
            IF ( STATUS .NE. 0 ) THEN
               XMSG = '*** VDEMIS_MG, memory allocation failed'
               CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            ALLOCATE ( TSEASFC( NCOLS,NROWS ),
     &                 U10( NCOLS,NROWS ),
     &                 SEAICE( NCOLS,NROWS ), STAT = STATUS )
            IF ( STATUS .NE. 0 ) THEN
              XMSG = '*** DMSL, TSEASFC, U10, or SEAICE memory'
              CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
              SUCCESS = .FALSE.; RETURN
            END IF   
            U10     = 0.0
            TSEASFC = 293.15
            SEAICE  = 0.0

C Get index for surface ozone concentration 
            VARNM = 'O3'
            LGC_O3 = INDEX1( VARNM, N_GC_SPC, GC_SPC )
            IF ( LGC_O3 .LE. 0 ) THEN
               XMSG = 'Could not find ' // VARNM // 'in species table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF

            IF (USE_MARINE_GAS_EMISSION .AND. MGEMDIAG ) THEN           ! Open the marine gas emission diagnostic file
C Determine number of marine gas species for diagnostic file
                NMGDIAG = NMGSPC

C Allocate diagnostic arrays
                ALLOCATE ( MGOUTD( NMGDIAG ),
     &                     WRMG_SPC( NMGDIAG ), STAT = STATUS )
                IF ( STATUS .NE. 0 ) THEN
                    XMSG = '*** MGOUTD or WRMG_SPC memory alloc failed'
                    CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                    SUCCESS = .FALSE.; RETURN
                END IF

C Build diagnostic file write buffer (WRMG_SPC) array
                IF (INDEX( MECHNAME, 'CB6R5M_AE7_AQ' ) .GT. 0) THEN
                   START_INDEX = 1
                   END_INDEX = 12
                ELSE
                   START_INDEX = 12
                   END_INDEX = 12
                END IF

                NMGDIAG = 0
                DO S = START_INDEX, END_INDEX
                   NMGDIAG = NMGDIAG + 1
                   WRMG_SPC( NMGDIAG ) = MG_SPC( S )
                   MG_SPC_IND( NMGDIAG ) = S
                END DO

C Open the marine gas emission dignostic file
                IF ( IO_PE_INCLUSIVE ) CALL OPMGEMIS ( STDATE, STTIME, TSTEP, NMGDIAG, WRMG_SPC )

                ALLOCATE ( MGBF( NMGDIAG,NCOLS,NROWS ),
     &                     WRMG( NCOLS,NROWS ), STAT = STATUS )
                IF ( STATUS .NE. 0 ) THEN
                   XMSG = '*** MGBF or WRMG memory allocation failed'
                   CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                   SUCCESS = .FALSE.; RETURN
                END IF
                MGBF = 0.0

            END IF

         END FUNCTION MGEMIS_INIT

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE OPMGEMIS ( JDATE, JTIME, TSTEP, NMGDIAG, WRMG_SPC )

C 8 Aug 14 B.Gantt adapted from sea salt diagnostic

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN
         USE MIO_ASCII

         IMPLICIT NONE

         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:
         INTEGER, INTENT( IN )         :: JDATE      ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN )         :: JTIME      ! current model time, coded HHMMSS
         INTEGER, INTENT( IN )         :: TSTEP      ! output time step
         INTEGER, INTENT( IN )         :: NMGDIAG
         CHARACTER( 16 ), INTENT( IN ) :: WRMG_SPC( NMGDIAG )

C Local variables:
         CHARACTER( 16 ) :: PNAME = 'OPMGEMIS'
         CHARACTER( 96 ) :: XMSG = ' '

         INTEGER      V, L       ! loop induction variables
         
#ifdef mpas
         integer :: io_mode
#endif

C-----------------------------------------------------------------------

#ifdef mpas
         if (ncd_64bit_offset) then
            io_mode = ior (nf90_noclobber, nf90_64bit_offset)
         else
            io_mode = nf90_noclobber
         end if

         call mio_fcreate (CTM_MGEM_1, io_mode)

#else

C Try to open existing file for update
         IF ( .NOT. OPEN3( CTM_MGEM_1, FSRDWR3, PNAME ) ) THEN
            XMSG = 'Could not open CTM_MGEM_1 for update - '
     &           // 'try to open new'
            CALL M3MESG( XMSG )

C Set output file characteristics based on COORD.EXT and open diagnostic file
            FTYPE3D = GRDDED3
            SDATE3D = JDATE
            STIME3D = JTIME
            TSTEP3D = TSTEP
            CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

            NVARS3D = NMGDIAG
            NCOLS3D = GL_NCOLS
            NROWS3D = GL_NROWS
            NLAYS3D = 1
            NTHIK3D = 1
            GDTYP3D = GDTYP_GD
            P_ALP3D = P_ALP_GD
            P_BET3D = P_BET_GD
            P_GAM3D = P_GAM_GD
            XORIG3D = XORIG_GD
            YORIG3D = YORIG_GD
            XCENT3D = XCENT_GD
            YCENT3D = YCENT_GD
            XCELL3D = XCELL_GD
            YCELL3D = YCELL_GD
            VGTYP3D = VGTYP_GD
            VGTOP3D = VGTOP_GD
!           VGTPUN3D = VGTPUN_GD ! currently, not defined
            DO L = 1, NLAYS3D + 1
               VGLVS3D( L ) = VGLVS_GD( L )
            END DO
!           GDNAM3D = GDNAME_GD
            GDNAM3D = GRID_NAME  ! from HGRD_DEFN

            DO V = 1, NMGDIAG
               VTYPE3D( V ) = M3REAL
               VNAME3D( V ) = WRMG_SPC( V )
               UNITS3D( V ) = 'mol s-1'
               VDESC3D( V ) = 'hourly ' // TRIM( VNAME3D( V ) )               
     &                     // ' marine gas emission rate'
            END DO

            FDESC3D( 1 ) = 'hourly layer-1 marine gas emission rates'
            DO L = 2, MXDESC3
               FDESC3D( L ) = ' '
            END DO

            ! Store MIO Metadata
            NDIMS3D( 1:NVARS3D ) = 3
            L_TSTEP( 1:NVARS3D ) = .True.
            L_LAY  ( 1:NVARS3D ) = .False.
            L_COL  ( 1:NVARS3D ) = .True.
            L_ROW  ( 1:NVARS3D ) = .True.
            L_VEXT ( 1:NVARS3D ) = .False.

            CALL LOAD_MIO_FILE ( 'CTM_MGEM_1', 0, 0, 0,
     &           VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &           VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &           L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &           L_VEXT(1:NVARS3D) )
            

C Open marine gas emissions diagnostic file
            IF ( .NOT. OPEN3( CTM_MGEM_1, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not create the CTM_MGEM_1 file'
               CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
            END IF

         END IF
#endif

         RETURN

         END SUBROUTINE OPMGEMIS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE GET_MGEMIS ( JDATE, JTIME, TSTEP, CGRID, L_DESID_DIAG )

C GET_MGEMIS calculates the marine gas emission rates in a grid cell
C given the fractional grid-cell area covered by open ocean and surf zone

C Key Subroutines/Functions Called:  NONE

C Revision History:
C   03 Nov 15: B. Gantt and G. Sarwar: created the initial version from sea salt diagnostic file
C   20 Feb 18: G. Sarwar: removed Br2, added DMS, and revised estimates of halocarbon and HOI/I2 emissions
C   04 Dec 18: G. Srawar: updated local time calculation
C
CReferences:
C MacDonald, S. M., Gómez Martín, J. C., Chance, R., Warriner, S., Saiz-Lopez, A., Carpenter, L. J.,
C and Plane, J. M. C.: A laboratory characterisation of inorganic iodine emissions from the sea
C surface: dependence on oceanic variables and parameterisation for global modelling, Atmos. Chem.
C Phys., 14, 5841-5852, doi:10.5194/acp-14-5841-2014, 2014.
C
C     Sherwen, T., Evans, M. J., Carpenter, L. J., Andrews, S. J., Lidster, R. T., Dix, B., Koenig, T. K., 
C Sinreich, R., Ortega, I., Volkamer, R., Saiz-Lopez, A., Prados-Roman, C., Mahajan, A. S., and Ordóñez, C.: 
C Iodine's impact on tropospheric oxidants: a global model study in GEOS-Chem. Atmos. Chem. Phys., 2016, 16, 1161-1186.

C-----------------------------------------------------------------------
            USE UTILIO_DEFN
            USE CONST, ONLY: PI180, DG2M, DKBOLTZ, GRAV
            USE ASX_DATA_MOD, ONLY: MET_DATA                 ! added by Sarwar
            USE CGRID_SPCS     ! CGRID mechanism species
            USE PCGRID_DEFN    ! get cgrid
            USE GRID_CONF
            USE CENTRALIZED_IO_MODULE

            IMPLICIT NONE

C Arguments
            INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP( 3 )
            REAL, POINTER         :: CGRID( :,:,:,: )         !  concentrations
            LOGICAL, INTENT( IN ) :: L_DESID_DIAG ! flag determining whether or not DESID
                                                  !   is in diagnostic mode              
C Includes:
            INCLUDE SUBST_FILES_ID  ! file name parameters

C Parameters:
C.. Define Marine Gas indices

            INTEGER, PARAMETER :: IMB3  = 1
            INTEGER, PARAMETER :: IMB2  = 2
            INTEGER, PARAMETER :: IMBC  = 3
            INTEGER, PARAMETER :: IMB2C = 4
            INTEGER, PARAMETER :: IMBC2 = 5
            INTEGER, PARAMETER :: ICH3I = 6
            INTEGER, PARAMETER :: IMIC  = 7
            INTEGER, PARAMETER :: IMIB  = 8
            INTEGER, PARAMETER :: IMI2  = 9
            INTEGER, PARAMETER :: II2   = 10
            INTEGER, PARAMETER :: IHOI  = 11
            INTEGER, PARAMETER :: IDMS  = 12

            REAL, PARAMETER :: SECS2HR = 1.0 / 3600.0          ! hour per seconds
            REAL, PARAMETER :: C_FACT  = 1.0E-9 /(24.0*3600.0) ! factor to convert nmole/m2/day to mole/m2/sec
            REAL, PARAMETER :: LON2TZ  = 1.0 / 15.0            ! longitude to time zone, 1/degrees
            REAL, PARAMETER :: FHRLY(0:23) =
     &                         ( / 0.032, 0.032, 0.032, 0.033, 0.034, 0.036,
     &                             0.039, 0.044, 0.051, 0.057, 0.062, 0.064,
     &                             0.062, 0.057, 0.051, 0.044, 0.039, 0.036,
     &                             0.034, 0.033, 0.032, 0.032, 0.032, 0.032 / )

C Local Variables:
!            REAL    :: OFRAC              ! fractional seawater cover
!            REAL    :: SFRAC              ! fractional surf-zone cover
            REAL    :: CHLA
            REAL    :: SSTC
            REAL    :: SST            
            REAL    :: DMS_L              ! DMS in ocean water - nM  
            REAL    :: DMS                ! DMS in atmosphere                        
            REAL    :: SICE               ! SEAICE in a grid cell

            REAL    :: SCN
            REAL    :: K600
            REAL    :: KW
            REAL    :: KA
            REAL    :: KT
            REAL    :: GAMMA
            REAL    :: ALPHA
            REAL    :: H_DMS

            CHARACTER( 16 ), SAVE :: PNAME = 'GET_MGEMIS'
            CHARACTER( 96 )       :: XMSG = ' '
            CHARACTER( 80 ) :: MSG                      ! Message

            INTEGER         :: C, R, L, N, V, S         ! loop indices

            INTEGER         :: LOGUNIT
            INTEGER         :: NVARS, NSTEPS
            INTEGER         :: LOCHR
            INTEGER         :: OFF_SET
            INTEGER, SAVE   :: WSTEP  = 0                      ! local write counter
            INTEGER         :: MDATE, MTIME                    ! MGEM write date&time
 
            REAL            :: IWSTEP                          ! reciprocal of local write counter
            REAL            :: DX1, DX2                        ! CX x1- and x2-cell widths
            REAL            :: O3, I_AQ                        ! SST in K, SSTC in C, O3 in ppb, SWPD10 in m/s
            REAL            :: DUMMY                           ! dummy variable for calculating marine gas emission
!            REAL            :: WDSCALO                         ! WDSCALO: 10 meter wind-speed-dependent scaling factors for emissions flux functions
!            REAL            :: SSTSCALO                        ! SSTSCALO: SST-dependent scaling factor for emissions from Jaegle et al. (2011) (SST in Celsius)
            REAL            :: LOC_LON                         ! grid-cell longitude
            REAL            :: WSPD10                          ! wind speed
            REAL            :: WSPD10_M5                       ! wind speed with a minimum speed of 5 m/s (used for HOI and I2 emission calculation)
            REAL            :: MARINE_AREA                     ! marine fraction of surface and later marine surface area
            REAL            :: CURRHR                          ! current GMT hour
            REAL, SAVE      :: A                               ! horizontal area of cells, m**2
            REAL, PARAMETER :: TWOTHIRDS = 2.0 / 3.0           ! 2.0 / 3.0
            REAL, PARAMETER :: ONESIXHUNDREDS = 1.0 / 600.0    ! 1.0 / 600.0

            LOGICAL, SAVE   :: FIRST_TIME = .TRUE.
#ifdef mpas
            CHARACTER( 20 ) :: time_stamp
#endif

C----------------------------- Begin calc ------------------------------

           IF( FIRST_TIME ) THEN
C calculate grid-cell area
#ifndef mpas
             IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
                DX1 = DG2M * XCELL_GD ! in m.
                DX2 = DG2M * YCELL_GD
     &              * COS( PI180*( YORIG_GD + YCELL_GD*FLOAT( GL_NROWS/2 )))! in m.
             ELSE
                DX1 = XCELL_GD        ! in m.
                DX2 = YCELL_GD        ! in m.
             END IF
             A = DX1 * DX2                                      ! m2
#endif

             FIRST_TIME = .FALSE.
           END IF

           CURRHR = REAL ( TIME2SEC( JTIME ) ) / 3600.0

C Assume MET_CRO_2D file is already opened

           IF (WSPD10_AVAIL) THEN
              call interpolate_var ('WSPD10', jdate, jtime, U10)
           ELSE
              call interpolate_var ('WIND10', jdate, jtime, U10)
           END IF

           IF (TSEASFC_AVAIL) THEN
              call interpolate_var ('TSEASFC', jdate, jtime, TSEASFC)
           ELSE
              call interpolate_var ('TEMPG', jdate, jtime, TSEASFC)
           END IF

           call interpolate_var ('SEAICE', jdate, jtime, SEAICE)

           ! Only write out marine gas diagnostics if not in diagnostic
           ! mode
           IF ( MGEMDIAG .AND. WSTEP .EQ. 0 .AND. .NOT. L_DESID_DIAG ) MGBF = 0.0

C Initialize marine gas output buffer
          DO R = 1, NROWS
             DO C = 1, NCOLS
                MARINE_AREA = ( OCEAN( C,R ) + SZONE( C,R ) )
                IF ( MARINE_AREA .GT. 0.0 .AND. SEAICE( C, R ) .LE. 0.0) THEN
!            convert area fraction to an actual area
#ifdef mpas
                     MARINE_AREA = MARINE_AREA * cell_area(c,1)
#else
                     MARINE_AREA = MARINE_AREA * A
#endif

                     CHLA      = MIN ( 1.0, CHLR ( C,R ) )
                     WSPD10    = U10( C,R )
                     WSPD10_M5 = MAX (5.0, WSPD10)
                     SST       = TSEASFC (C,R)
!                    SSTC    = SST - 273.15
                     SSTC      = MIN( (SST - 273.15), 30.0)                          
                     LOC_LON   = LON (C,R)
                     O3       = 1000.0 * CGRID(C, R, 1, LGC_O3)
                     DMS_L     = DMSL( C, R )   

C.. calculate iodide in water
                     I_AQ = 1.46E6 * EXP( -9134.0 / SST)

!..    calculate parameters needed for DMS emissions 

!..    Calculate Schmidt number of DMS (Saltzman et al, JGR, 1993)
       SCN = 2674.0 - 147.12 * SSTC + 3.726 * SSTC * SSTC - 0.038 * SSTC * SSTC * SSTC

!..    Calculate water-side DMS gas-transfer velocity following Liss and Merlivat,  1986 (unit - cm/hr)
       IF ( WSPD10 .LE. 3.6 ) THEN
          KW = 0.17 * WSPD10 / ( (SCN * ONESIXHUNDREDS)**TWOTHIRDS)
        ELSE IF ( WSPD10 .GT. 3.6 .AND. WSPD10 .LE. 13.0 ) THEN
          KW = ( 2.85 * WSPD10 - 9.65 ) / SQRT(SCN * ONESIXHUNDREDS)
        ELSE IF ( WSPD10 .GT. 13.0) THEN
          KW = ( 5.9 * WSPD10 - 49.3 ) / SQRT(SCN * ONESIXHUNDREDS)
       ENDIF
    
!..    Calculate air-side DMS gas-transfer velocity (McGills et al, JGR, 2000) (unit - cm/hr)
       KA = 659.0 * WSPD10 / SQRT(62.0/18.0)
            
!..    Calculate Henry's Law Coefficient of DMS expressed as C_air/C_water following Dacey et al, GRL, 1984  (unit - atm . L /mole)
       H_DMS = EXP ( 12.64 - 3547.0/SST )                             
       
!..    Calculate Solubility Coeffcient of DMS expressed as C_water/C_air following McGills et al, JGR, 2000 - (unit dimensionless ) 
!..    Dacey et al. calculates Henry's Law Coefficient as C_air/C_water, thus, an inverse is taken for unit consistency 
!..    and then it is converted into dimensionless unit
       ALPHA = 0.082058 * SST / H_DMS                                

!..    Calculate Atmospheric Gradient Fraction following Lan et al,  Global Biogeochemical Cycles, 2011
       GAMMA = 1.0 /( 1.0 + KA / (ALPHA * KW))  

!..    Calculate total gas transfer velocity for DMS following Lan et al,  Global Biogeochemical Cycles, 2011 
       KT = KW * (1.0 - GAMMA)

C.. calculate local hour
                     OFF_SET = NINT(LOC_LON * LON2TZ )
                     LOCHR =  INT(CURRHR + OFF_SET )

                     IF (LOCHR .LT.  0) LOCHR = LOCHR + 24
                     IF (LOCHR .GT. 23) LOCHR = LOCHR - 24

                     IF (INDEX( MECHNAME, 'CB6R5M_AE7_AQ' ) .GT. 0) THEN
                        DUMMY = 4.31E-8 * MARINE_AREA * FHRLY(LOCHR) * CHLA * SECS2HR

C.. Calculate MB3 emission rate in mole/s
                        VDEMIS_MG( IMB3, C, R ) = DUMMY * 2.00

C.. Calculate MB2 emission rate in mole/s
                        VDEMIS_MG( IMB2, C, R ) = DUMMY * 0.50

C.. Calculate MBC emission rate in mole/s
                        VDEMIS_MG( IMBC, C, R ) = DUMMY * 0.08

C.. Calculate MB2C emission rate in mole/s
                        VDEMIS_MG( IMB2C, C, R ) = DUMMY * 0.12

C.. Calculate MBC2 emission rate in mole/s
                        VDEMIS_MG( IMBC2, C, R ) = DUMMY * 0.10

C.. Calculate CH3I emission rate in mole/s
                        VDEMIS_MG( ICH3I, C, R ) = DUMMY * 1.60

C.. Calculate MIC emission rate in mole/s
                        VDEMIS_MG( IMIC, C, R ) = DUMMY * 1.41

C.. Calculate MIB emission rate in mole/s
                        VDEMIS_MG( IMIB, C, R ) = DUMMY * 0.42

C.. Calculate MI2 emission rate in mole/s
                        VDEMIS_MG( IMI2, C, R ) = DUMMY * 0.46

C.. Calculate I2 emission rate in mole/s (Macdonald et al., ACP, 14, 5841-5852, 2014)
                        DUMMY = O3 * (I_AQ**1.3) * (1.74E9 - 6.54E8*LOG(WSPD10_M5)) ! NMOL/M2/D
                        DUMMY = MARINE_AREA * DUMMY * C_FACT
                        VDEMIS_MG( II2, C, R ) = MAX( 0.0, DUMMY )

C.. Calculate HOI emission rate in mole/s (Macdonald et al., ACP, 14, 5841-5852, 2014)
                        DUMMY = SQRT(I_AQ)
                        DUMMY = O3
     &                        * ((4.15E5*DUMMY - 20.6)/WSPD10_M5 - 23600.0*DUMMY)  ! NMOL/M2/D
                        DUMMY = MARINE_AREA * DUMMY * C_FACT
                        VDEMIS_MG( IHOI, C, R ) = MAX( 0.0, DUMMY )
                     END IF

C .. Calculate DMS emission rate in mole/s
                     DUMMY = MARINE_AREA *  DMS_L * KT * 2.78E-12
                     VDEMIS_MG( IDMS, C, R ) = MAX ( 0.0, DUMMY)

                ELSE
                     DO N = 1, NMGSPC
                        VDEMIS_MG( N, C, R ) = 0.0
                     END DO
                     CYCLE
                END IF

C Update the MGBF array, for writing the diagnostic marine gas emission file
                IF ( MGEMDIAG .AND. .NOT. L_DESID_DIAG ) THEN
                   V = 0
                   DO S = 1, NMGSPC
                      V = V + 1
                      MGOUTD( V ) = VDEMIS_MG( S,C,R )
                   END DO

                   DO S = 1, NMGDIAG
                      MGBF( S,C,R ) = MGBF( S,C,R ) + MGOUTD( MG_SPC_IND (S) )
     &                              * REAL( TIME2SEC ( TSTEP( 2 ) ) )
                  END DO
                END IF  ! MGEMDIAG

             END DO   ! C
         END DO   ! R


C If last call this hour, write out the total MG emissions [moles/s].
C Then reset the MG emissions array and local write counter.
         IF ( MGEMDIAG .AND. .NOT. L_DESID_DIAG ) THEN

             WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )

             IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
                IWSTEP = 1.0 / REAL( WSTEP )
#ifdef mpas
                call mio_time_format_conversion (jdate, jtime, time_stamp)
#else

                IF ( .NOT. CURRSTEP( JDATE, JTIME, STDATE, STTIME, TSTEP( 1 ),
     &                                MDATE, MTIME ) ) THEN
                     XMSG = 'Cannot get step date and time'
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
                END IF
                CALL NEXTIME( MDATE, MTIME, TSTEP( 1 ) )
#ifdef parallel_io
                IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                  IF ( .NOT. OPEN3( CTM_MGEM_1, FSREAD3, PNAME ) ) THEN
                       XMSG = 'Could not open ' // TRIM(CTM_MGEM_1)
                       CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
                  END IF
                END IF
#endif
#endif
                DO V = 1, NMGDIAG
                   DO R = 1, NROWS
                      DO C = 1, NCOLS
                         WRMG( C,R ) = MGBF( V,C,R ) * IWSTEP
                      END DO
                   END DO
#ifdef mpas
                   call mio_fwrite (CTM_MGEM_1, WRMG_SPC(V), pname, WRMG(:,1), time_stamp)
#else
                   IF ( .NOT. WRITE3( CTM_MGEM_1, WRMG_SPC( V ),
     &                        MDATE, MTIME, WRMG ) ) THEN
                     XMSG = 'Couldnt write ' // CTM_MGEM_1 // 'file'
                     CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
                   END IF
#endif
               END DO
#ifdef mpas
               WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), a19)')
     &                      'Timestep written to', CTM_MGEM_1,
     &                      'for time stamp', time_stamp
#else
               WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )')
     &                      'Timestep written to', CTM_MGEM_1,
     &                      'for date and time', MDATE, MTIME
#endif
               WSTEP = 0
               MGBF = 0.0
             END IF

          END IF  ! MGDIAG

         RETURN

       END SUBROUTINE GET_MGEMIS

      END MODULE MGEMIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       SUBROUTINE HRG3( DTC )

C**********************************************************************
C
C  FUNCTION:  To solve for the concentration of C2O3 and PAN
C
C  PRECONDITIONS: For the CB6R5PFAS_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, Jun 26, 2025
C
C   18 Jul 14 B.Hutzell: revised to use real(8) variables
C**********************************************************************
      USE HRDATA

      IMPLICIT NONE

C..INCLUDES:  NONE

C..ARGUMENTS:
      REAL( 8 ), INTENT( IN ) :: DTC              ! Time step


C..PARAMETERS: NONE


C..EXTERNAL FUNCTIONS: NONE


C..SAVED LOCAL VARIABLES:
!     CHARACTER( 16 ), SAVE  :: PNAME = 'HRG3'      ! Program name


C..SCRATCH LOCAL VARIABLES:
      REAL( 8 ) ::   A, B, C, Q   ! Quadratic equation terms
      REAL( 8 ) ::   CMN          ! Temp scalar
      REAL( 8 ) ::   L8           ! Loss of CCO_O2
      REAL( 8 ) ::   L9           ! Loss of PAN
      REAL( 8 ) ::   P8           ! Production of CCO_O2

      REAL( 8 ) ::   K8_8         ! Kc2o3+c2o3 * delta t
      REAL( 8 ) ::   R8_9         ! Kpan-->c2o3 * delta t
      REAL( 8 ) ::   R9_8         ! Kc2o3+no2-->pan * [NO2] * delta t

C**********************************************************************


c..Production of C2O3 (except from PAN )
      P8 =                 RXRAT(    95 )      ! PACD+OH=C2O3
     &   +                 RXRAT(   105 )      ! ALD2+O=C2O3+OH
     &   +                 RXRAT(   106 )      ! ALD2+OH=C2O3
     &   +                 RXRAT(   107 )      ! ALD2+NO3=C2O3+HNO3
     &   +    8.0000D-01 * RXRAT(   113 )      ! GLYD+OH=0.8000D+00*C2O3+...
     &   +                 RXRAT(   115 )      ! GLYD+NO3=C2O3+HNO3
     &   +                 RXRAT(   119 )      ! MGLY=C2O3+HO2+CO
     &   +                 RXRAT(   120 )      ! MGLY+NO3=C2O3+HNO3+XO2+RO2
     &   +                 RXRAT(   121 )      ! MGLY+OH=C2O3+CO
     &   +    5.0000D-01 * RXRAT(   128 )      ! KET=0.5000D+00*C2O3+...
     &   +    6.2000D-01 * RXRAT(   129 )      ! ACET=0.6200D+00*C2O3+...
     &   +                 RXRAT(   130 )      ! ACET+OH=C2O3+FORM+XO2+RO2
     &   +    2.6900D-01 * RXRAT(   158 )      ! ISPD+OH=0.2690D+00*C2O3+...
     &   +    1.4300D-01 * RXRAT(   159 )      ! ISPD+O3=0.1430D+00*C2O3+...
     &   +    2.0800D-01 * RXRAT(   161 )      ! ISPD=0.2080D+00*C2O3+...
     &   +    3.0000D-01 * RXRAT(   202 )      ! XOPN=0.3000D+00*C2O3+XO2H+...
     &   +    6.0000D-01 * RXRAT(   204 )      ! XOPN+O3=0.6000D+00*C2O3+...
     &   +    1.2000D-01 * RXRAT(   208 )      ! OPEN+O3=0.1200D+00*C2O3+...
     &   +                 RXRAT(   244 )      ! CL+ALD2=C2O3+HCL

c..Loss frequency of C2O3 ( not including C2O3 + C2O3 )
      L8 =                 RKI(    53 ) * YC ( NO           )   ! C2O3+NO=NO2+MEO2+RO2
     &   +                 RKI(    54 ) * YC ( NO2          )   ! C2O3+NO2=PAN
     &   +                 RKI(    57 ) * YC ( HO2          )   ! C2O3+HO2=0.3700D+...
     &   +                 RKI(    58 ) * YC ( RO2          )   ! C2O3+RO2=MEO2
     &   +                 RKI(    60 ) * YC ( CXO3         )   ! C2O3+CXO3=MEO2+...
     &   +                 RKI(    73 ) * YC ( MEO2         )   ! C2O3+MEO2=FORM+...
     &   +                 RKI(    77 ) * YC ( XO2H         )   ! C2O3+XO2H=...
     &   +                 RKI(    81 ) * YC ( XO2          )   ! C2O3+XO2=0.8000D+...
     &   +                 RKI(    85 ) * YC ( XO2N         )   ! C2O3+XO2N=...
     &   +                 RKI(   153 ) * YC ( ISO2         )   ! C2O3+ISO2=...
     &   +                 RKI(   168 ) * YC ( EPX2         )   ! C2O3+EPX2=...
     &   +                 RKI(   181 ) * YC ( BZO2         )   ! C2O3+BZO2=GLY+...
     &   +                 RKI(   186 ) * YC ( TO2          )   ! C2O3+TO2=0.4800D+...
     &   +                 RKI(   193 ) * YC ( XLO2         )   ! C2O3+XLO2=...
     &   +                 RKI(   216 ) * YC ( OPO3         )   ! C2O3+OPO3=MEO2+...

c..Loss frequency of PAN
      L9 =                 RKI(    55 )                         ! PAN=NO2+C2O3
     &   +                 RKI(    56 )                         ! PAN=0.6000D+...

c..K8_8, R8_9, and R9_8 terms
      K8_8  = RKI(    59 ) * DTC

      R8_9  = ( RKI(    55 )
     &      +   RKI(    56 ) ) * DTC 

      R9_8  = ( RKI(    54 ) * YC( NO2 ) ) * DTC 

c..Solution of quadratic equation to get C2O3 & PAN
      CMN = 1.0 + L9 * DTC
      A = 2.0D0 * K8_8 * CMN
      B = CMN * ( 1.0D0 + L8 * DTC ) - R8_9 * R9_8
      C = CMN * ( YC0( C2O3 ) + P8 * DTC ) +  R8_9 * YC0( PAN )

      Q = -0.5D0 * ( B + SIGN( 1.0D0, B ) * SQRT( B * B + 4.0D0 * A * C ) )

      YCP( C2O3 ) = MAX( Q / A , -C / Q  )

      YCP( PAN ) = ( YC0( PAN ) +  R9_8 * YCP( C2O3 ) ) / CMN

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE STAGE_OUTPUT

C-----------------------------------------------------------------------
C Function: Collection of output routines for STAGE deposition velocities
C           and dry deposition
C-----------------------------------------------------------------------
      USE RUNTIME_VARS, Only: MOSAIC
    
      Contains 
         Pure Function Write_time( WSTEP, TSTEP ) Result( Write_now ) 

         Implicit None

         Integer, Intent( IN ) :: WSTEP
         Integer, Intent( IN ) :: TSTEP
         Logical               :: Write_now     
        
         If( WSTEP .Ge. TSTEP ) Then
            Write_now = .TRUE.
         Else 
            Write_now = .FALSE.
         End If

         End Function Write_time

         Subroutine Open_depv( DATE, TIME, TSTEP )

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE CGRID_SPCS          ! CGRID mechanism species
         USE STAGE_DATA
         USE UTILIO_DEFN
         USE MOSAIC_MOD, Only: Tile_Data
         USE MIO_ASCII 

         IMPLICIT NONE
 
         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

         INTEGER, INTENT( IN ) :: DATE    ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN ) :: TIME    ! current model time, coded HHMMSS
         INTEGER, INTENT( IN ) :: TSTEP   ! output time step

C Local variables:

         CHARACTER( 16 ) :: PNAME = 'OPSTAGE_DEPV'
         CHARACTER( 16 ) :: VNAME            ! scratch string
         CHARACTER( 96 ) :: XMSG = ' '

         INTEGER      N_Vars
         INTEGER      V, N, L     ! loop induction variables

         SDATE3D = DATE
         STIME3D = TIME
         TSTEP3D = TSTEP
         CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

         FTYPE3D = GRDDED3
         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD 
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         FDESC3D = ' '   ! array

         L = LEN_TRIM( DEPV_METHOD )
         FDESC3D( 1 ) = 'Instanteous values of land use specific'
     &               // ' resistances and conductances:'
     &               // ' these parameters are' 
         FDESC3D( 2 ) = 'estimated by the '
     &               //  DEPV_METHOD( 1:L ) // ' algorithm.'

         IF ( .NOT. OPEN3( CTM_DEPV_DIAG, FSRDWR3, PNAME ) ) THEN

            XMSG = 'Could not open ' // CTM_DEPV_DIAG // ' file for update - '
     &           // 'try to open new'
            CALL M3MESG( XMSG )

C Set output file characteristics based on GRIDDESC and open the dep velocity dignostic file
            NVARS3D = Tile_Data%n_Vd
            NLAYS3D = 1
            DO L = 1, NLAYS3D + 1
               VGLVS3D( L ) = VGLVS_GD( L )
            END DO

            N = 0
            DO V = 1, N_SPC_DEPV
               If( Tile_Data%Vd_Out( V ) ) Then

                  N = N + 1 
                  VNAME = trim( Tile_Data%Vd_Name( V ) )
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = VNAME
                  UNITS3D( N ) = 'cm s-1'
                  VDESC3D( N ) = 'Dry deposition velocity'

               End If
            END DO

            ! Store MIO Metadata
            NDIMS3D( 1:NVARS3D ) = 3
            L_TSTEP( 1:NVARS3D ) = .True.
            L_LAY  ( 1:NVARS3D ) = .False.
            L_COL  ( 1:NVARS3D ) = .True.
            L_ROW  ( 1:NVARS3D ) = .True.
            L_VEXT ( 1:NVARS3D ) = .False.

            CALL LOAD_MIO_FILE ( 'CTM_DEPV_DIAG', 0, 0, 0,
     &           VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &           VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &           L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &           L_VEXT(1:NVARS3D) )


C Open diagnostic file, then close it for subsequent open by all processors

            IF ( .NOT. OPEN3( CTM_DEPV_DIAG, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not create '// TRIM( CTM_DEPV_DIAG ) // ' file'
               CALL M3EXIT( PNAME, DATE, TIME, XMSG, XSTAT1 )
            END IF

         END IF

         IF ( MOSAIC .AND. .NOT. OPEN3( CTM_DEPV_MOS, FSRDWR3, PNAME ) ) THEN

            XMSG = 'Could not open ' // CTM_DEPV_MOS // ' file for update - '
     &           // 'try to open new'
            CALL M3MESG( XMSG )

C Set output file characteristics based on GRIDDESC and open the dep velocity dignostic file
            NVARS3D = Tile_Data%n_Vd + 7
            NLAYS3D = Tile_Data%N_LUFRAC   ! preempting normal use of vertical layers

            N = 0
            N = N + 1 ! 1
            VTYPE3D( N ) = M3REAL
            VNAME3D( N ) = 'RA'
            UNITS3D( N ) = 's m-1'
            VDESC3D( N ) = 'aerodynamic resistance for land use category'

            N = N + 1 ! 2
            VTYPE3D( N ) = M3REAL
            VNAME3D( N ) = 'LUFRAC'
            UNITS3D( N ) = 'dimensionless'
            VDESC3D( N ) = 'Fractional land use'

            N = N + 1 ! 3
            VTYPE3D( N ) = M3REAL
            VNAME3D( N ) = 'LAI'
            UNITS3D( N ) = 'dimensionless'
            VDESC3D( N ) = 'leaf area index for land use category'

            N = N + 1 ! 4
            VTYPE3D( N ) = M3REAL
            VNAME3D( N ) = 'USTAR'
            UNITS3D( N ) = 'm s-1'
            VDESC3D( N ) = 'friction velocity for land use category'

            N = N + 1 ! 5
            VTYPE3D( N ) = M3REAL
            VNAME3D( N ) = 'Z0'
            UNITS3D( N ) = 'm'
            VDESC3D( N ) = 'surface roughness for land use category'

            N = N + 1 ! 6
            VTYPE3D( N ) = M3REAL
            VNAME3D( N ) = 'RST'
            UNITS3D( N ) = 's m-1'
            VDESC3D( N ) = 'Stomatal resistance to water vapor'

            N = N + 1 ! 7
            VTYPE3D( N ) = M3REAL
            VNAME3D( N ) = 'VEG'
            UNITS3D( N ) = 'ratio'
            VDESC3D( N ) = 'Vegetation coverage'

            DO V = 1, N_SPC_DEPV
               If( Tile_Data%Vd_Out( V ) ) Then

                  N = N + 1 
                  VNAME = trim( Tile_Data%Vd_Name( V ) )
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = VNAME
                  UNITS3D( N ) = 'cm s-1'
                  VDESC3D( N ) = 'Dry deposition velocity'

               End If
            END DO
 
            ! Store MIO Metadata
            NDIMS3D( 1:NVARS3D ) = 3
            L_TSTEP( 1:NVARS3D ) = .True.
            L_LAY  ( 1:NVARS3D ) = .False.
            L_COL  ( 1:NVARS3D ) = .True.
            L_ROW  ( 1:NVARS3D ) = .True.
            L_VEXT ( 1:NVARS3D ) = .False.

            CALL LOAD_MIO_FILE ( 'CTM_DEPV_MOS', 0, 0, 0,
     &           VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &           VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &           L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &           L_VEXT(1:NVARS3D) )

C Open diagnostic file

            IF ( .NOT. OPEN3( CTM_DEPV_MOS, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not create '// TRIM( CTM_DEPV_MOS) // ' file'
               CALL M3EXIT( PNAME, DATE, TIME, XMSG, XSTAT1 )
            END IF

         END IF
         Return
         End Subroutine Open_depv

         Subroutine Write_depv( DATE, TIME )

         USE CGRID_SPCS, ONLY : N_SPC_DEPV
         USE HGRD_DEFN
         USE UTILIO_DEFN
         USE MOSAIC_MOD,   Only: Tile_Data
         USE ASX_DATA_MOD, Only: MOSAIC_DATA

         Implicit None    

         Integer, Intent( IN ) :: DATE
         Integer, Intent( IN ) :: TIME
!         Real,    Intent( IN ) :: DEPV(:,:,:)

         Integer               :: N

         CHARACTER( 16 )  :: PNAME = 'WRITE_DEPV'
         CHARACTER( 120 ) :: XMSG = ' '
         
         INCLUDE SUBST_FILES_ID  ! file name parameters

         DO N = 1, N_SPC_DEPV
            If( Tile_Data%Vd_Out( N ) ) Then
               IF ( .NOT. WRITE3( CTM_DEPV_DIAG, trim( Tile_Data%Vd_Name( N ) ),
     &                            DATE, TIME, Tile_Data%Grd_Vd(:,:,N)*100.0 ) ) THEN
                  XMSG = 'Could not write ' // CTM_DEPV_DIAG // ' file'
                  CALL M3EXIT ( PNAME, DATE, TIME, XMSG, XSTAT1 )
               END IF
            End If
         END DO

         IF ( MOSAIC ) THEN


!-----------------------------------------------------------------------------------------!
!                               STAGE Diagnostic Output                                   !
!-----------------------------------------------------------------------------------------!

               IF ( .NOT. WRITE3( CTM_DEPV_MOS, 'LUFRAC',
     &                            DATE, TIME, Tile_Data%LUFRAC ) ) THEN
                   XMSG = 'Could not write ' // CTM_DEPV_MOS // ' file'
                  CALL M3EXIT ( PNAME, DATE, TIME, XMSG, XSTAT1 )
               END IF


               IF ( .NOT. WRITE3( CTM_DEPV_MOS, 'RA',
     &                            DATE, TIME, MOSAIC_DATA%RA ) ) THEN
                   XMSG = 'Could not write ' // CTM_DEPV_MOS // ' file'
                  CALL M3EXIT ( PNAME, DATE, TIME, XMSG, XSTAT1 )
               END IF

               IF ( .NOT. WRITE3( CTM_DEPV_MOS, 'RST',
     &                            DATE, TIME, Mosaic_Data%RSTW ) ) THEN
                   XMSG = 'Could not write ' // CTM_DEPV_MOS // ' file'
                  CALL M3EXIT ( PNAME, DATE, TIME, XMSG, XSTAT1 )
               END IF

               IF ( .NOT. WRITE3( CTM_DEPV_MOS, 'LAI',
     &                            DATE, TIME, MOSAIC_DATA%LAI ) ) THEN
                   XMSG = 'Could not write ' // CTM_DEPV_MOS // ' file'
                  CALL M3EXIT ( PNAME, DATE, TIME, XMSG, XSTAT1 )
               END IF

               IF ( .NOT. WRITE3( CTM_DEPV_MOS, 'USTAR',
     &                            DATE, TIME, MOSAIC_DATA%USTAR ) ) THEN
                   XMSG = 'Could not write ' // CTM_DEPV_MOS // ' file'
                  CALL M3EXIT ( PNAME, DATE, TIME, XMSG, XSTAT1 )
               END IF

               IF ( .NOT. WRITE3( CTM_DEPV_MOS, 'Z0',
     &                            DATE, TIME, MOSAIC_DATA%Z0 ) ) THEN
                   XMSG = 'Could not write ' // CTM_DEPV_MOS // ' file'
                  CALL M3EXIT ( PNAME, DATE, TIME, XMSG, XSTAT1 )
               END IF

               IF ( .NOT. WRITE3( CTM_DEPV_MOS, 'VEG',
     &                            DATE, TIME, MOSAIC_DATA%VEG ) ) THEN
                   XMSG = 'Could not write ' // CTM_DEPV_MOS // ' file'
                  CALL M3EXIT ( PNAME, DATE, TIME, XMSG, XSTAT1 )
               END IF

               DO N = 1, N_SPC_DEPV
                  If( Tile_Data%Vd_Out( N ) ) Then
                     IF ( .NOT. WRITE3( CTM_DEPV_MOS, 
     &                                  trim( Tile_Data%Vd_Name( N ) ),
     &                                  DATE, TIME,  Tile_Data%Lu_Vd(:,:,N,:)*100.0 ) ) THEN
                         XMSG = 'Could not write ' // CTM_DEPV_MOS // ' file'
                        CALL M3EXIT ( PNAME, DATE, TIME, XMSG, XSTAT1 )
                     End If
                  End If
               END DO
         End If

         End Subroutine Write_depv

      End Module STAGE_OUTPUT
      

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_pe_info_ext.f,v 1.2 2006/02/17 12:55:04 yoj Exp $ 

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Note: all these variables with prefix se_ are for stencil exchange library 
C       only
C
C to define processor info variables:
C
C   se_numprocs       -- number of processors allocated
C   se_npcol          -- number of processors allocated along column dimension
C   se_nprow          -- number of processors allocated along row dimension
C   se_my_pe          -- my logical global processor number
C   se_numworkers     -- number of processors in worker partition
C   se_numiopes       -- number of processors in I/O partition
C   se_myworker_pe    -- my logical worker processor number
C   se_myio_pe        -- my logical I/O processor number
C   se_partition_mode -- processor parition mode: 1 -- no parition
C                                                 2 -- worker + I/O parition
C   se_world_comm     -- MPI global communicator
C   se_worker_comm    -- MPI worker communicator
C   se_io_comm        -- MPI I/O communicator
C --------------------------------------------------------------------------

        module se_pe_info_ext

          integer :: se_numprocs
          integer :: se_npcol
          integer :: se_nprow
          integer :: se_my_pe

          integer :: se_numworkers
          integer :: se_numiopes
          integer :: se_myworker_pe
          integer :: se_myio_pe

          integer :: se_partition_mode

          integer :: se_world_comm
          integer :: se_worker_comm
          integer :: se_io_comm

          integer, allocatable :: ranks(:)

        end module se_pe_info_ext

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_domain_info_ext.f,v 1.1 2004/03/26 16:16:47 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Note: all these variables with prefix se_ are for stencil exchange library
C       only
C
C to define domain decomposition info variables:
C
C -- global values
C
C   se_gl_ncols  -- number of columns in the physical domain
C   se_gl_nrows  -- number of rows in the physical domain
C   se_gl_nlays  -- number of layers in the physical domain
C   se_gl_nspcs  -- number of species in the physical domain
C   se_gl_ind    -- global fine domain to processor map: the first two entries
C                   are the beginning and ending row number, the second two 
C                   entries are the beginning and ending column number, second 
C                   dimension corresponding to the processor number
C
C -- local dimension values
C
C   se_ncols -- max. number of columns in a processor for data declaration
C   se_nrows -- max. number of rows in a processor for data declaration
C   se_nlays -- max. number of layers in a processor for data declaration
C   se_nspcs -- max. number of species in a processor for data declaration
C
C -- local processor data dimension values
C
C   se_my_ncols -- number of columns a processor is responsible for
C   se_my_nrows -- number of rows a processor is responsible for
C   se_my_nlays -- number of layers a processor is responsible for
C   se_my_nspcs -- number of species a processor is responsible for
C
C -- local processor data dimension values plus one
C
C   se_my_ncolsp1 -- number of columns a processor is responsible for plus one
C   se_my_nrowsp1 -- number of rows a processor is responsible for plus one
C   se_my_nlaysp1 -- number of layers a processor is responsible for plus one
C   se_my_nspcsp1 -- number of species a processor is responsible for plus one
C
C eg. given eight processors, four processors are assigned to column
C     dimension and 2 are assigned to row dimension (note: vertical axis
C     denotes the column dimension and horizontal axis denotes row dimension),
C     and a 2-D domain of size 17 by 11
C
C     ie. numprocs = 8               PE map:    0   1
C         npcol    = 4                          2   3
C         nprow    = 2                          4   5
C         gl_ncols = 17                         6   7
C         gl_nrows = 11
C
C     in each PE, ncols by nrows = 5 x 6
C     se_my_ncols by se_my_nrows = 5 x 6 for PE 0
C     se_my_ncols by se_my_nrows = 5 x 5 for PE 1
C     se_my_ncols by se_my_nrows = 4 x 6 for PE 2, 4, and 6
C     se_my_ncols by se_my_nrows = 4 x 5 for PE 3, 5, and 7
C --------------------------------------------------------------------------

        module se_domain_info_ext

          integer :: se_gl_ncols
          integer :: se_gl_nrows
          integer :: se_gl_nlays
          integer :: se_gl_nspcs

          integer, allocatable, save, target :: se_gl_ind(:, :, :)
          integer, pointer :: se_gl_ind_ptr (:, :, :)

          integer :: se_ncols
          integer :: se_nrows
          integer :: se_nlays
          integer :: se_nspcs

          integer :: se_my_ncols
          integer :: se_my_nrows
          integer :: se_my_nlays
          integer :: se_my_nspcs
          integer :: se_my_ncolsp1
          integer :: se_my_nrowsp1
          integer :: se_my_nlaysp1
          integer :: se_my_nspcsp1
 
        end module se_domain_info_ext

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C....................................................................
C  CONTAINS:  This module provides the interface to the Models3 IOAPI
C     using the M3UTILIO module.  For parallel implementation of CMAQ, 
C     several IOAPI routines are replaced with PARIO versions.  For
C     example, the IOAPI function WRITE3 is renamed to an unused 
C     function name "EXCLUDE_WRITE3", and the PARIO function PWRITE3
C     is aliased to WRITE3.  So when WRITE3 is used in CMAQ, then the
C     PARIO function PWRITE3 is accessed.  This approach allows
C     flexibility in naming within CMAQ and eliminated the usage of
C     "cpp" flags to achieve the function overloading.
C              
C  REVISION HISTORY:
C       Original version 03/2011 by Shawn Roselle
C                        08/2011 by David Wong
C                          -- extended to handle buffer file
C                        08/2015 by David Wong
C                          -- defined WRITE3 under parallel I/O
C                             implementation
C                        02/2019 by David Wong
C                          -- removed INTERPB declaration which is
C                             not needed with centralized I/O
C                             implementation
C....................................................................

      MODULE UTILIO_DEFN

#ifdef mpas
       use util_module
       use mio_module
       
       use prog_interrupt_module, M3WARN => prog_interrupt_warning,
     &                             M3EXIT => prog_interrupt_exit,
     &                             M3MESG => prog_interrupt_msg,
     &                             M3MSG2 => prog_interrupt_msg,
     &                             m3parag => prog_interrupt_nmsgs


       INTEGER, PARAMETER :: XSTAT1 = 1
       INTEGER, PARAMETER :: XSTAT2 = 1
       INTEGER, PARAMETER :: XSTAT3 = 1

#else

#ifdef parallel

         USE M3UTILIO, EXCLUDE_INTERPB => INTERP3,
     &                 EXCLUDE_M3EXIT  => M3EXIT,
     &                 EXCLUDE_M3WARN  => M3WARN,
     &                 EXCLUDE_SHUT3   => SHUT3,
     &                 EXCLUDE_WRITE3  => WRITE3,
     &                 BUF_WRITE3      => WRITE3

         USE PARUTILIO, 
     &                  M3ERR   => PM3ERR,
     &                  M3EXIT  => PM3EXIT,
     &                  M3WARN  => PM3WARN,
#ifdef parallel_io
     &                  SHUT3   => PSHUT3

         LOGICAL, EXTERNAL :: WRITE3
#else
     &                  SHUT3   => PSHUT3,
     &                  WRITE3  => PWRITE3
#endif
#else
         USE M3UTILIO, INTERPB => INTERP3
#endif

#endif

      END MODULE UTILIO_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


       SUBROUTINE HRG1( DTC )

C**********************************************************************
C
C  FUNCTION: To solve for the concentration of NO2, NO, O3, and O3P
C            algebraically.
C
C  PRECONDITIONS: For the CB6R5PFAS_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, Jun 26, 2025
C
C   18 Jul 14 B.Hutzell: revised to use real(8) variables
C   01 Jun 18 B.Hutzell: replaced steady solution for O1D with backward Euler
C                        approximation. To match conditions where the initial
C                        concentration cannot be neglected.
C**********************************************************************
      USE HRDATA

      IMPLICIT NONE


C..INCLUDES: None


C..ARGUMENTS:
      REAL( 8 ), INTENT( IN ) :: DTC                      ! Time step


C..PARAMETERS: None


C..EXTERNAL FUNCTIONS: NONE


C..SAVED LOCAL VARIABLES:
!     CHARACTER( 16 ), SAVE  :: PNAME = 'HRG1'   ! Prgram Name


C..SCRATCH LOCAL VARIABLES:
      REAL( 8 ) :: O1D_S               ! sum of O1D loss frequencies
      REAL( 8 ) :: O3P_S               ! stoich coeff for O3P from O1D



      REAL( 8 ) :: R1_2                ! production term for NO from NO2
      REAL( 8 ) :: R2_1                ! production term for NO2 from NO
      REAL( 8 ) :: P1, P2, P3, P12     ! production terms for NO, NO2, O3, & O3P
      REAL( 8 ) :: L1, L2, L3, L12     ! loss terms for NO, NO2, O3, O3P
      REAL( 8 ) :: L1_INV, L2_INV,
     &             L3_INV, L12_INV     ! inverse of loss terms

      REAL( 8 ) :: T1, T2, T3, T4, T5  ! intermerdiate terms
      REAL( 8 ) :: F1, F2, F3          ! intermerdiate terms
      REAL( 8 ) :: A, B, C             ! coefficients for quadratic equation
      REAL( 8 ) :: Q, XX, S1, S2       ! intermerdiate terms

      REAL( 8 ) :: RK1, RK2, RK3       ! rate constants

      REAL( 8 ) :: PO3                 ! temp variable for O3

C**********************************************************************


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  O1D Section
c    1) sum of the rate constants for all O1D loss reactions
c    2) get fractional yield of O3P from O1D loss
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      O1D_S =                 RKI(    10 )                         ! O1D=O
     &      +                 RKI(    11 )                         ! O1D=0.2000D+01*OH

      O3P_S =                 RKI(    10 )                         ! O1D=O

      O3P_S  = O3P_S / O1D_S


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  NO Section
c    R1_2 = production of NO from NO2 ( rates of form k[NO2][x] )
c           except NO2+NO3=NO+NO2 (it is treated as if it were NO3=NO )
c    P1 =   remaining NO production terms
c    L1 =   loss of NO (except rxns producing NO2 - they are in R2_1)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      R1_2 =                 RKI(     1 )                         ! NO2=NO+O
     &     +                 RKI(     5 ) * YC ( O            )   ! NO2+O=NO
      R1_2  = R1_2 * DTC


      P1 =                 RXRAT(    28 )      ! NO3=NO
     &   +                 RXRAT(    30 )      ! NO2+NO3=NO+NO2
     &   +                 RXRAT(    42 )      ! HONO+HONO=NO+NO2
     &   +                 RXRAT(    43 )      ! HONO=NO+OH
      P1    = YC0( NO ) + P1 * DTC


      L1 =                 RKI(    40 ) * YC ( OH           )   ! NO+OH=HONO
     &   +                 RKI(    41 ) * YC ( NO2          )   ! NO+NO2=0.2000D+...
     &   +                 RKI(    83 ) * YC ( XO2N         )   ! NO+XO2N=0.5000D+...
     &   +    1.0000D-01 * RKI(   151 ) * YC ( ISO2         )   ! NO+ISO2=0.1000D+...
     &   +    8.2000D-02 * RKI(   180 ) * YC ( BZO2         )   ! NO+BZO2=0.9180D+...
     &   +    1.4000D-01 * RKI(   185 ) * YC ( TO2          )   ! NO+TO2=0.8600D+...
     &   +    1.4000D-01 * RKI(   191 ) * YC ( XLO2         )   ! NO+XLO2=0.8600D+...
      L1    = 1.0D0 + L1 * DTC


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  NO2 Section
c    R2_1 = production of NO2 from NO ( rates of form k[NO][x] )
c            a)  NO+O3=NO2 not included
c            b)  NO+NO3=2NO2 ( 1/2 of NO2 formation rate included )
c            c)  NO3+NO2=NO+NO2 is not included for NO2
c    P2 =  remaining NO2 production terms 
c            a)  NO+O3=NO2 not included
c            b)  NO+NO3=2NO2 (1/2 of NO2 formation rate included )
c    L2 = loss of NO2 (except rxns producing NO2 - they are in R1_2)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      R2_1 =                 RKI(     4 ) * YC ( O            )   ! NO+O=NO2
     &     +    2.0000D+00 * RKI(    24 ) * YC ( NO           )   ! NO+NO=0.2000D+01*NO2
     &     +                 RKI(    25 ) * YC ( HO2          )   ! NO+HO2=NO2+OH
     &     +                 RKI(    29 ) * YC ( NO3          )   ! NO+NO3=0.2000D+...
     &     +                 RKI(    53 ) * YC ( C2O3         )   ! NO+C2O3=NO2+MEO2+RO2
     &     +                 RKI(    61 ) * YC ( CXO3         )   ! NO+CXO3=NO2+ALD2+...
     &     +                 RKI(    71 ) * YC ( MEO2         )   ! NO+MEO2=NO2+HO2+FORM
     &     +                 RKI(    75 ) * YC ( XO2H         )   ! NO+XO2H=NO2+HO2
     &     +                 RKI(    79 ) * YC ( XO2          )   ! NO+XO2=NO2
     &     +                 RKI(   103 ) * YC ( HCO3         )   ! NO+HCO3=NO2+FACD+HO2
     &     +    9.0000D-01 * RKI(   151 ) * YC ( ISO2         )   ! NO+ISO2=0.9000D+...
     &     +                 RKI(   167 ) * YC ( EPX2         )   ! NO+EPX2=NO2+...
     &     +    9.1800D-01 * RKI(   180 ) * YC ( BZO2         )   ! NO+BZO2=0.9180D+...
     &     +    8.6000D-01 * RKI(   185 ) * YC ( TO2          )   ! NO+TO2=0.8600D+...
     &     +    8.6000D-01 * RKI(   191 ) * YC ( XLO2         )   ! NO+XLO2=0.8600D+...
     &     +                 RKI(   212 ) * YC ( OPO3         )   ! NO+OPO3=NO2+...
     &     +                 RKI(   230 ) * YC ( CLO          )   ! NO+CLO=NO2+CL
      R2_1  = R2_1 * DTC


      P2 =                 RXRAT(    27 )      ! NO3=NO2+O
     &   +                 RXRAT(    29 )      ! NO+NO3=0.2000D+01*NO2
     &   +                 RXRAT(    31 )      ! NO3+O=NO2
     &   +                 RXRAT(    32 )      ! NO3+OH=NO2+HO2
     &   +                 RXRAT(    33 )      ! NO3+HO2=NO2+OH
     &   +                 RXRAT(    34 )      ! NO3+O3=NO2
     &   +    2.0000D+00 * RXRAT(    35 )      ! NO3+NO3=0.2000D+01*NO2
     &   +                 RXRAT(    37 )      ! N2O5=NO2+NO3
     &   +                 RXRAT(    38 )      ! N2O5=NO2+NO3
     &   +                 RXRAT(    42 )      ! HONO+HONO=NO2+NO
     &   +                 RXRAT(    44 )      ! HONO+OH=NO2
     &   +                 RXRAT(    47 )      ! HNO3=NO2+OH
     &   +                 RXRAT(    49 )      ! PNA=NO2+HO2
     &   +    5.9000D-01 * RXRAT(    50 )      ! PNA=0.5900D+00*NO2+...
     &   +                 RXRAT(    51 )      ! PNA+OH=NO2
     &   +                 RXRAT(    55 )      ! PAN=NO2+C2O3
     &   +    6.0000D-01 * RXRAT(    56 )      ! PAN=0.6000D+00*NO2+...
     &   +                 RXRAT(    63 )      ! PANX=NO2+CXO3
     &   +    6.0000D-01 * RXRAT(    64 )      ! PANX=0.6000D+00*NO2+...
     &   +                 RXRAT(    92 )      ! NTR1=NO2
     &   +    5.0000D-01 * RXRAT(   140 )      ! ETH+NO3=0.5000D+...
     &   +    5.0000D-01 * RXRAT(   144 )      ! OLE+NO3=0.5000D+...
     &   +    5.0000D-01 * RXRAT(   148 )      ! IOLE+NO3=0.5000D+...
     &   +    3.5000D-01 * RXRAT(   157 )      ! ISOP+NO3=0.3500D+...
     &   +    1.4200D-01 * RXRAT(   160 )      ! ISPD+NO3=0.1420D+...
     &   +    4.4400D-01 * RXRAT(   170 )      ! INTR+OH=0.4440D+...
     &   +    4.7000D-01 * RXRAT(   174 )      ! TERP+NO3=0.4700D+...
     &   +    4.7000D-01 * RXRAT(   178 )      ! APIN+NO3=0.4700D+...
     &   +    5.0000D-01 * RXRAT(   205 )      ! XOPN+NO3=0.5000D+...
     &   +                 RXRAT(   214 )      ! OPAN=NO2+OPO3
     &   +    5.0000D-01 * RXRAT(   218 )      ! OPAN+OH=0.5000D+...
     &   +                 RXRAT(   219 )      ! PANX+OH=NO2+ALD2
     &   +                 RXRAT(   252 )      ! CLNO2=NO2+CL
     &   +                 RXRAT(   254 )      ! CLNO3=NO2+CLO
      P2 = YC0( NO2 ) + P2 * DTC


      L2 =                 RKI(     6 ) * YC ( O            )   ! NO2+O=NO3
     &   +                 RKI(    26 ) * YC ( O3           )   ! NO2+O3=NO3
     &   +                 RKI(    36 ) * YC ( NO3          )   ! NO2+NO3=N2O5
     &   +                 RKI(    41 ) * YC ( NO           )   ! NO2+NO=0.2000D+...
     &   +                 RKI(    45 ) * YC ( OH           )   ! NO2+OH=HNO3
     &   +                 RKI(    48 ) * YC ( HO2          )   ! NO2+HO2=PNA
     &   +                 RKI(    54 ) * YC ( C2O3         )   ! NO2+C2O3=PAN
     &   +                 RKI(    62 ) * YC ( CXO3         )   ! NO2+CXO3=PANX
     &   +                 RKI(   135 ) * YC ( ROR          )   ! NO2+ROR=NTR1
     &   +                 RKI(   197 ) * YC ( CRO          )   ! NO2+CRO=CRON
     &   +                 RKI(   213 ) * YC ( OPO3         )   ! NO2+OPO3=OPAN
     &   +                 RKI(   225 ) * YC ( OH           )   ! NO2+OH=HNO3
     &   +                 RKI(   253 ) * YC ( CLO          )   ! NO2+CLO=CLNO3
     &   +                 RKI(   278 )                         ! NO2=0.5000D+...
      L2     = 1.0D0 + L2 * DTC


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  O3 Section
c    P3 = production of O3 except O+O2=O3
c    L3 =   loss terms for O3 except NO+O3=NO2
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      P3 =    1.3000D-01 * RXRAT(    57 )      ! C2O3+HO2=0.1300D+...
     &   +    1.3000D-01 * RXRAT(    65 )      ! CXO3+HO2=0.1300D+...
     &   +    1.3000D-01 * RXRAT(   215 )      ! OPO3+HO2=0.1300D+...
      P3 = YC0( O3 ) + P3 * DTC


      L3 =                 RKI(     7 ) * YC ( O            )   ! O3+O=
     &   +                 RKI(     8 )                         ! O3=O
     &   +                 RKI(     9 )                         ! O3=O1D
     &   +                 RKI(    12 ) * YC ( OH           )   ! O3+OH=HO2
     &   +                 RKI(    13 ) * YC ( HO2          )   ! O3+HO2=OH
     &   +                 RKI(    26 ) * YC ( NO2          )   ! O3+NO2=NO3
     &   +                 RKI(    34 ) * YC ( NO3          )   ! O3+NO3=NO2
     &   +                 RKI(   139 ) * YC ( ETH          )   ! O3+ETH=FORM+...
     &   +                 RKI(   143 ) * YC ( OLE          )   ! O3+OLE=0.2950D+...
     &   +                 RKI(   147 ) * YC ( IOLE         )   ! O3+IOLE=0.7320D+...
     &   +                 RKI(   156 ) * YC ( ISOP         )   ! O3+ISOP=0.6000D+...
     &   +                 RKI(   159 ) * YC ( ISPD         )   ! O3+ISPD=0.4000D-...
     &   +                 RKI(   173 ) * YC ( TERP         )   ! O3+TERP=0.5700D+...
     &   +                 RKI(   177 ) * YC ( APIN         )   ! O3+APIN=0.5700D+...
     &   +                 RKI(   204 ) * YC ( XOPN         )   ! O3+XOPN=0.1200D+...
     &   +                 RKI(   208 ) * YC ( OPEN         )   ! O3+OPEN=0.1400D+...
     &   +                 RKI(   228 ) * YC ( CL           )   ! O3+CL=CLO
     &   +                 RKI(   279 )                         ! O3=
      L3    = 1.0D0 + L3 * DTC


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  O3P Section 
c    P12 = production of O3P except NO2+hv=O3P (J1)
c    L12 = loss terms
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      P12 =                 RXRAT(     8 )      ! O3=O
     &    +   O3P_S *       RXRAT(     9 )      ! O3=O1D
     &    +                 RXRAT(    16 )      ! OH+OH=O
     &    +                 RXRAT(    27 )      ! NO3=O+NO2
      P12 = YC0( O ) + P12 * DTC


      L12 =                 RKI(     2 )                         ! O=O3
     &    +                 RKI(     4 ) * YC ( NO           )   ! O+NO=NO2
     &    +                 RKI(     5 ) * YC ( NO2          )   ! O+NO2=NO
     &    +                 RKI(     6 ) * YC ( NO2          )   ! O+NO2=NO3
     &    +                 RKI(     7 ) * YC ( O3           )   ! O+O3=
     &    +                 RKI(    14 ) * YC ( OH           )   ! O+OH=HO2
     &    +                 RKI(    15 ) * YC ( HO2          )   ! O+HO2=OH
     &    +                 RKI(    23 ) * YC ( H2O2         )   ! O+H2O2=OH+HO2
     &    +                 RKI(    31 ) * YC ( NO3          )   ! O+NO3=NO2
     &    +                 RKI(    99 ) * YC ( FORM         )   ! O+FORM=OH+HO2+CO
     &    +                 RKI(   105 ) * YC ( ALD2         )   ! O+ALD2=C2O3+OH
     &    +                 RKI(   109 ) * YC ( ALDX         )   ! O+ALDX=CXO3+OH
     &    +                 RKI(   137 ) * YC ( ETH          )   ! O+ETH=FORM+HO2+CO+...
     &    +                 RKI(   141 ) * YC ( OLE          )   ! O+OLE=0.2000D+00*ALD2+...
     &    +                 RKI(   145 ) * YC ( IOLE         )   ! O+IOLE=0.1240D+...
     &    +                 RKI(   150 ) * YC ( ISOP         )   ! O+ISOP=0.7500D+...
     &    +                 RKI(   171 ) * YC ( TERP         )   ! O+TERP=0.1500D+...
     &    +                 RKI(   175 ) * YC ( APIN         )   ! O+APIN=0.1500D+...
      L12   = 1.0D0 + L12 * DTC

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Solution section
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c..compute reciprocal of loss terms
      L1_INV  = 1.0D0 / L1
      L2_INV  = 1.0D0 / L2
      L3_INV  = 1.0D0 / L3
      L12_INV = 1.0D0 / L12

c..compute specific k*delta t terms
      RK1 = RKI(   1 ) * DTC            ! J1    (NO2+hv=NO+O3P)
      RK2 = RKI(   2 ) * DTC            ! J2    (O3P+O2=O3)
      RK3 = RKI(   3 ) * DTC            ! k1_3  (NO+O3=NO2)

c..compute terms that are used to calulate a,b & c
      T1 = RK1  * L2_INV                ! J1   / ( 1.0 + Lno2 * dt )
      T2 = R1_2 * L2_INV                ! r1,2 / ( 1.0 + Lno2 * dt)
      T3 = R2_1 * L1_INV                ! r2,1 / ( 1.0 + Lno  * dt)
      T4 = RK2  * L12_INV               ! J2   / ( 1.0 + Lo3p * dt )
      T5 = T3   * P1 - T2 * P2          ! T3 * Pno - T2 * Pno2

      F1 = 1.0D0 + T2 + T3                ! factor in calculating a & b
      F2 = T1 * T4                      ! factor in calculating a & b
      F3 = L3 * L1 + RK3 * P1           ! (1 + Lo3 * dt) (1 + lno * dt )
                                        ! + k1,3 * dt * Pno

      PO3 = P3 + P12 * T4

      A = RK3 * ( F1  - F2 )

      B = F1 * F3 +  RK3 * ( F2 * ( P2 - P1 ) + PO3 +  T5 )

      C = RK3 * P1 * ( PO3 + P2 * F2 ) + F3 * T5

      Q = -0.5D0 * ( B + SIGN( 1.0D0, B ) * SQRT( B * B - 4.0D0 * A * C ) )

      XX = MAX( Q / A , C / Q  )


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Species solutions
c       [NO]   = ( P1 + x ) / ( 1 + L1 )
c       [NO2]  = ( P2 - x ) / ( 1 + L2 )
c       [O3 ]  = ( P3 + Ko3p->O3 ) / (1 + K1,3 * [NO] + L3 )
c       [O3P]  = ( P12 + J1 * [NO2] ) / ( 1 + L12 )
c       [O1D] = ( yc0(o1d) + Ko3->o1d * [O3] *dtc) / ( 1 + O1D_S*dtc )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      YCP( NO ) = MAX( 0.0D0, ( P1 + XX ) * L1_INV )

      YCP( NO2 ) = MAX( 0.0D0, ( P2 - XX ) * L2_INV )

      S1 = P12 + RK1 * YCP( NO2 )

      S2 = T4 * S1

      YCP( O3 ) = ( P3 + S2 ) / ( L3 + RK3 * YCP( NO ) )

      YCP( O ) = S1 * L12_INV

      YCP( O1D ) = ( YC0( O1D ) + RKI( 9 ) * YCP( O3 ) * DTC ) 
     &           / ( 1.0D0 + O1D_S * DTC )

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C routines for aerosol formation and transformation processes

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AEROPROC( DT, COL, ROW, LAYER )

C-----------------------------------------------------------------------
C  SUBROUTINE AEROPROC advances the number, second moment, and mass
C   concentrations for each mode over the time interval DT.

C  KEY SUBROUTINES CALLED:
C     GETPAR, ORGAER5, GETCOAGS, INTERCOAG_GH, INTRACOAG_GH,
C     VOLINORG

C  KEY FUNCTIONS CALLED:  GETAF

C  REVISION HISTORY:
C     Coded in December 1999 by Dr. Francis S. Binkowski
C      Modified from older versions used in CMAQ.

C FSB 05/17/00  new version of RPMARES included

C FSB 05/30/00  Fixed minor bug in awater.f

C FSB Correction to extinction coefficient in getbext.

C FSB 07/21/00 corrected units on ORGRATES and ORGBRATE_IN from
C      ppm/min to ppm/sec in AEROPROC and AEROSTEP.

C FSB 11/30/00 following changes from 07/28/00
C     Fixed problem for new emissions file version
C     Combined emissions for M3
C     Used a fixed value of Dpmin for plotting
C     Added variables OMEGA_AT & OMEGA_AC for partitioning
C     Eliminated the restriction on relative humidity for nucleation.
C     Added a branch in EQL for very low relative humidity (<1%).

C FSB Following changes to RPMARES:
C     Number of iterations reduced from 150 to 50.
C     Iterations are used only if 0.5 < = RATIO.
C     In calculating the molality of the bisulfate ion, a
C     MAX(1.0e-10, MSO4 ) is used.

C FSB 08/08/01 Changes to NEWPART to correct mass rate and to AEROSTEP
C     to correct sulfate, include emissions, and trap problem in
C     accumulation mode number calculation.

C FSB 09/19/01 Version AE3, major changes
C     Organics are done with Dr. Benedikt Schell's approach. (ORGAER3)
C     Particle production uses Kulmala approach (NEWPART3)
C     Condensational factors for sulfate and organics are calculated
C      separately.
C     Emissions are assumed to be input in vertical diffusion.
C     Include files replaced by Fortran 90 Modules.
C     The modules also contain subroutines.

C FSB 10/24/01 Added the treatment of gaseous N2O5 -> aerosol HNO3

C FSB 10/25/01 Changed the mass transfer calculation for Aitken to
C     accumulation mode by coagulation as recommended by Dr. Benedikt
C     Schell.

C SJR 04/24/02 Replaced thermodynamic code RPMARES with ISORROPIA
C     --Shawn J. Roselle

C GLG 04/04/03 Modifications to allow for evaporation of semi-volatile
C     organics from aerosol phase.  --Gerald L. Gipson

C FSB 11/18/03 Corrections to sulfate condensation.  Previously,
C     SCONDRATE was undefined when SO4RATE=0 and SCONDRATE was
C     negative when SO4RATE < DMDT_so4.

C PVB 01/08/04 Several changes in preparation for simulation of 2001
C      calendar year --Dr. Prakash V. Bhave
C    -Added interface to new subroutine, GETCOAGS, for calculating
C      coagulation rates.  GETCOAGS is used instead of Gauss-Hermite
C      quadrature for computational efficiency, by setting
C      FASTCOAG_FLAG = .TRUE.  --PVB
C    -Removed SOA from the definition of "DRY" aerosol.  Aerosol surface
C      area is now transported without SOA.  See notes in GETPAR, AERO,
C      and AERO_DEPV subroutines.  --SJR
C    -Moved EQL3 call from AEROPROC to AEROSTEP, immediately following
C      the ORGAER3 call.  This is a side effect of transporting aerosol
C      surface area without SOA.  --SJR
C    -New subroutine, HCOND3, to calculate condensation rates for
C      2nd and 3rd moments.  Results are unchanged.  --FSB
C    -Revised method of calculating SOA.  Partition SOA to the modes
C      in proportion to the amounts of total organic mass (SOA plus
C      primary) in each mode.  Modal geometric standard deviations are
C      now preserved during SOA condensation and evaporation. --FSB
C    -Combined the former subroutines AEROPROC and AEROSTEP into this
C      subroutine; retained the name AEROPROC.  --PVB

C PVB 09/21/04 added in-line documentation with input from FSB.
C     Changed MWH2SO4 from 98.07354 to 98.0 g/mol for consistency with
C     the mechanism files.

C PVB 09/27/04 removed the IF(XM3.GT.0.0) mode-merging precondition
C     because it caused significant erroneous mode crossover.  Fix
C     suggested by Dr. Chris Nolte.

C PVB 01/19/05 Added SO4RATE to the EQL3 call vector.  This is necessary
C     to ensure that the gas and inorganic fine PM (i+j) concentrations
C     are in thermodynamic equilibrium at the end of each time step.

C PVB 05/02/05 Modified ERF statement function for negative arguments such
C     that erf(-x) = -erf(x).  Previous version had erf(-x) = erf(x).

C PVB 04/06/06 Added GAMMA_N2O5 to the AEROPROC and EQL3 call vectors,
C     so it can be written to the aerosol diagnostic file.

C SLN 09/07/07 Several changes in preparation for new SOA module
C    -Removed Aitken-mode SOA species (CBLK(VORGAI),CBLK(VORGBI)) and
C     all of the related variables (OMASS_I, OMASS_J, FRACI, FRACJ,
C     OLD_M2_I, OLD_M3_I, NEW_M2_I, NEW_M3_I)
C    -Replaced the other SOA species (CBLK(VORGAJ),CBLK(VORGBJ)) with
C     precursor-specific SOA species (e.g., CBLK(VTOL1J)).
C    -Replaced SOA_A and SOA_B with an array, SOA_ALL.  Replaced
C     OLDSOA_A and OLDSOA_B with an array, OLDSOA.  Updated ORGAER3
C     call vector accordingly.
C    -Removed dependence of mode-merging criteria on SOA condensation
C     because that logic was flawed.  Deleted all variables needed
C     for that calculation (CHEMRATE_ORG, ORGRATE, ORGBRATE).

C PVB 11/02/07 Moved heterogenous N2O5 chemistry from EQL3 to a new
C     subroutine, HETCHEM.

C PVB 11/29/07 Implementation of new SOA formation mechanisms
C    -Replaced call to ORGAER3 with a call to ORGAER5
C    -Moved CBLK updates of SV species, SOA species, M2, and M3 into
C     ORGAER5 instead of updating those values in AEROPROC

C JOY 04/08/08 White space, alignment, readability

C JTK 04/17/08 Implemented coarse chemistry updates
C     -replaced condensation calculations with call to VOLINORG
C     -added code for coarse surface area and variable coarse std. dev.
C     -modified modal dynamics equations because new particle formation
C      and growth are now calculated in VOLINORG

C JOY 12/07/08 Removed unused EQL3 code, add column and row arguments to
C     VOLINORG for diagnostic logging

C SH  12/17/09 Major restructuring of all aerosol codes
C     -use new Fortran modules (e.g., AERO_DATA, SOA_DEFN); shortened call
C      vector; replaced CBLK with aerospc structure; eliminated AERO_INFO

C SH  03/10/11 Renamed met_data to aeromet_data

C HS  03/10/11 Added call to POAAGE between ORGAER and HETCHEM

C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN

C BH  09/30/13 Removed Call to HETCHEM and GAMMA_N2O5 argument
C              because of merging of gas and heterogeneous 
C              chemistry

C JB  02/07/14 Added Jai Xing's mass balance fix when there is excessive
C              condensation or evaporation under cold conditions

C BH  07/21/14 Removed call to POAAGE because reaction represented in
C              chemical mechanism

C GS/KF 09/23/14 Updated nucleation scheme with Vehkamaki et al. (2002)

C HP/BM  4/16 Removed m3_wet_flag since wet/dry status is now
C             tracked by AERO_DATA variable. Moments are always wet in AEROPROC
C             Updated treatment of aerosol moments

C SLN 12/30/19 Update for ddm-3d implementation in version 5.3.1

C  REFERENCES:
C   1. Binkowski, F.S. and U. Shankar, The regional particulate matter
C      model 1. Model description and preliminary results, J. Geophys.
C      Res., Vol 100, No D12, 26101-26209, 1995.

C   2. Binkowski, F.S. and S.J. Roselle, Models-3 Community
C      Multiscale Air Quality (CMAQ) model aerosol component 1:
C      Model Description.  J. Geophys. Res., Vol 108, No D6, 4183
C      doi:10.1029/2001JD001409, 2003.

C   3. Bhave, P.V., S.J. Roselle, F.S. Binkowski, C.G. Nolte, S. Yu,
C      G.L. Gipson, and K.L. Schere, CMAQ aerosol module development:
C      recent enhancements and future plans, Paper No. 6.8, CMAS Annual
C      Conference, Chapel Hill, NC, 2004.
C-----------------------------------------------------------------------
      
      USE AERO_DATA
      USE PRECURSOR_DATA      ! gas phase aero precursor data
      USE SOA_DEFN
      USE AEROMET_DATA
      USE CONST
      USE UTILIO_DEFN
      USE AERO_BUDGET

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX
      USE AERO_DDM3D, ONLY : s_aerospc_conc, s_precursor_conc,
     &                       s_so4rate
#endif


      IMPLICIT NONE

C *** arguments:
      REAL,    INTENT( IN ) :: DT          ! synchronization time step, sec
      INTEGER, INTENT( IN ) :: COL         ! Column of cell
      INTEGER, INTENT( IN ) :: ROW         ! Row of cell
      INTEGER, INTENT( IN ) :: LAYER       ! Layer of cell

C *** Parameters
      REAL, PARAMETER :: DIFFSULF = 9.36E-06  ! molecular diffusiviity for sulfuric acid
      REAL, PARAMETER :: SQRT2 = 1.4142135623731
      REAL, PARAMETER :: T0 = 288.15   ! [ K ]
      REAL, PARAMETER :: TWOTHIRDS   =  2.0 / 3.0
      REAL, PARAMETER :: ONE_OVER_TICE =  1.0 / 273.16

C *** local variables
      REAL         DIFFCORR   ! Correction to DIFFSULF & DIFFORG for pressure
      REAL         DV_SO4     ! molecular diffusivity of H2SO4 vapor after correction for ambient conditions
      REAL         SQRT_TEMP  ! square root of ambient temperature
      REAL         XLM        ! atmospheric mean free path [m]
      REAL         AMU        ! atmospheric dynamic viscosity [kg/m s]

      REAL( 8 ) :: CGR( N_MODE-1 ) ! Aitken & Accum. modes

      REAL( 8 ) :: LAMDA      ! mean free path [ m ]
      REAL( 8 ) :: KNC        ! KNC = TWO3 * DKBOLTZ *  AIRTEMP / AMU

C *** Free Molecular regime (depends upon modal density)
      REAL( 8 ) :: KFMAT      ! = SQRT( 3.0*DKBOLTZ * AIRTEMP / PDENSAT )
      REAL( 8 ) :: KFMAC      ! = SQRT( 3.0*DKBOLTZ * AIRTEMP / PDENSAC )
      REAL( 8 ) :: KFMATAC    ! = SQRT( 6.0*DKBOLTZ * AIRTEMP / ( PDENSAT + PDENSAC ) )

C *** Intermodal coagulation rates [ m**3/s ] ( 0th & 2nd moments )
      REAL( 8 ) :: BATAC( 2 ) ! Aitken to accumulation
      REAL( 8 ) :: BACAT( 2 ) ! accumulation from Aitken

C *** Intramodal coagulation rates [ m**3/s ] ( 0th & 2nd moments )
      REAL( 8 ) :: BATAT( 2 ) ! Aitken mode
      REAL( 8 ) :: BACAC( 2 ) ! accumulation mode

C *** Intermodal coagulation rate [ m**3/s ] ( 3rd moment )
      REAL( 8 ) :: C3IJ       ! Aitken to accumulation
      REAL( 8 ) :: C30ATAC    ! Aitken to accumulation
      REAL( 8 ) :: DG_D ( N_MODE )
      REAL( 8 ) :: SG_D ( N_MODE )
      REAL( 8 ) :: XXL_D( N_MODE )

! *** Variables for computing the budget
      REAL( 8 ) :: CBUDGET0_NUM ( N_MODE )
      REAL( 8 ) :: CBUDGET0_SRF ( N_MODE )
      REAL( 8 ) :: CBUDGET0_MASS( N_AEROSPC,N_MODE )

C *** variables for advancing concentrations one time step
      REAL( 8 ) :: A, B
      REAL( 8 ) :: Y0, Y
      REAL( 8 ) :: EXPDT
      REAL( 8 ) :: LOSS, PROD, POL
      REAL         TMASS
      REAL         FACTRANS ! special factor to compute mass transfer
      REAL         M30(3), M20(3), M00(3)      ! for initial conditions in time stepping

C *** Variables for mode merging
      REAL         GETAF
      REAL         AAA, XNUM, XM2, XM3,XXM2, XXM3
      REAL         FNUM, FM2, FM3, PHNUM, PHM2, PHM3

C *** local variables
      INTEGER      SPC        ! loop counter
      INTEGER      N          ! loop counter

      logical, save :: firstime = .true.
C-----------------------------------------------------------------------

      if ( firstime ) then
         firstime = .false.
#ifdef nomm
         write( logdev,* ) 'aero_subs: nomm'
#endif
      end if

C *** square root of the ambient temperature for later use
      SQRT_TEMP = SQRT( AIRTEMP )
 
C *** Calculate mean free path [ m ]:
C     6.6328E-8 is the sea level value given in Table I.2.8
C     on page 10 of U.S. Standard Atmosphere 1962

      XLM = 6.6328E-8 * STDATMPA * AIRTEMP  / ( T0 * AIRPRES )

C *** Calculate dynamic viscosity [ kg m**-1 s**-1 ]:
C     U.S. Standard Atmosphere 1962 page 14 expression
C     for dynamic viscosity is:
C     dynamic viscosity =  beta * T * sqrt(T) / ( T + S)
C     where beta = 1.458e-6 [ kg sec^-1 K**-0.5 ], s = 110.4 [ K ].
      AMU = 1.458E-6 * AIRTEMP * SQRT_TEMP / ( AIRTEMP + 110.4 )

C *** Set minimums for coarse mode
      MOMENT0_CONC( N_MODE ) = MAX( AEROMODE_MINNUM( N_MODE ),
     &                              MOMENT0_CONC( N_MODE ) )

C *** Secondary Organics
C     Update the secondary organic aerosol (SOA) mass concentrations
C     and the SVOC mass concentrations by equilibrium absorptive
C     partitioning between the particle and vapor phases.  Assume all
C     SOA resides in the accumulation mode.
C
C     Aerosol is wet when it enters orgaer
      CALL ORGAER( DT, LAYER )

C *** Secondary Inorganics
C     The VOLINORG subroutine includes the treatment of new particle
C     production and a fully dynamic treatment of inorganic gas-to-
C     particle mass transfer.

C *** Compute H2SO4 diffusivity, correct for temperature and pressure
      DIFFCORR = ( STDATMPA / AIRPRES ) * ( ONE_OVER_TICE * AIRTEMP ) ** 1.75
      DV_SO4 = DIFFSULF * DIFFCORR

C *** Update size parameters (distribution is wet from ORGAER)
      CALL GETPAR( FIXED_sg )

! *** Mass transfer of inorganic constituents      
! *** Process Budget is calculated inside this routine because NPF and
! *** condensation are calculated simultaneously
      CALL VOLINORG( DT, COL, ROW, LAYER, DV_SO4, CGR )

! *** Coagulation
!     Calculate coagulation coefficients using a method dictated by
!     the value of FASTCOAG_FLAG.  If TRUE, the computationally-
!     efficient GETCOAGS routine is used.  If FALSE, the more intensive
!     Gauss-Hermite numerical quadrature method is used.  See Section
!     2.1 of Bhave et al. (2004) for further discussion.
! *** Initialize Budget Variables
      CBUDGET0_NUM  = MOMENT0_CONC
      CBUDGET0_SRF  = MOMENT2_CONC * PI
      CBUDGET0_MASS = AEROSPC_CONC
 
! *** set atmospheric mean free path in double precision
      LAMDA    = XLM

! *** calculate term used in Equation A6 of Binkowski & Shankar (1995)
      KNC      = TWOTHIRDS * DKBOLTZ *  AIRTEMP / AMU

! *** calculate terms used in Equation A5 of Binkowski & Shankar (1995)
      KFMAT    = SQRT( 3.0 * DKBOLTZ * AIRTEMP / AEROMODE_DENS( 1 ) )
      KFMAC    = SQRT( 3.0 * DKBOLTZ * AIRTEMP / AEROMODE_DENS( 2 ) )
      KFMATAC  = SQRT( 6.0 * DKBOLTZ * AIRTEMP
     &         / ( AEROMODE_DENS( 1 ) + AEROMODE_DENS( 2 ) ) )

! *** transfer of number to accumulation mode from Aitken mode is zero
      BACAT( 1 ) = 0.0

      IF ( FASTCOAG_FLAG ) THEN ! Solve coagulation analytically

C *** set geometric mean diameters, geometric standard deviations, and
C     ln(GSD) in double precision
         DO N = 1, N_MODE
            DG_D( N ) = AEROMODE_DIAM( N )
            SG_D( N ) = EXP( AEROMODE_LNSG( N ) )
            XXL_D( N ) = AEROMODE_LNSG( N )
         END DO

C *** calculate intermodal and intramodal coagulation coefficients
C     for zeroth and second moments, and intermodal coagulation
C     coefficient for third moment
         CALL GETCOAGS( LAMDA, KFMATAC, KFMAT, KFMAC, KNC,
     &                  DG_D(1), DG_D(2), SG_D(1), SG_D(2),
     &                  XXL_D(1),XXL_D(2),
     &                  BATAT( 2 ), BATAT( 1 ), BACAC( 2 ), BACAC( 1 ),
     &                  BATAC( 2 ), BACAT( 2 ), BATAC( 1 ), C3IJ )

      ELSE                 ! Use Gauss-Hermite numerical quadrature

C *** calculate Aitken-mode intramodal coagulation coefficients
C     for zeroth and second moments
         CALL INTRACOAG_GH( LAMDA, KFMAT, KNC, AEROMODE_DIAM( 1 ),
     &                      AEROMODE_LNSG( 1 ), BATAT( 2 ), BATAT( 1 ) )

C *** calculate accumulation-mode intramodal coagulation coefficients
C     for zeroth and second moments
         CALL INTRACOAG_GH( LAMDA, KFMAC, KNC, AEROMODE_DIAM( 2 ),
     &                      AEROMODE_LNSG( 2 ), BACAC( 2 ), BACAC( 1 ) )

C *** calculate intermodal coagulation coefficients for zeroth, second,
C     and third moments
         CALL INTERCOAG_GH( LAMDA, KFMATAC, KNC,
     &                      AEROMODE_DIAM( 1 ), AEROMODE_DIAM( 2 ),
     &                      AEROMODE_LNSG( 1 ), AEROMODE_LNSG( 2 ),
     &                      BATAC( 2 ), BACAT( 2 ), BATAC( 1 ), C3IJ )

      END IF   ! FASTCOAG_FLAG

C *** calculate 3rd moment intermodal transfer rate by coagulation
      C30ATAC = C3IJ * MOMENT0_CONC( 1 ) * MOMENT0_CONC( 2 )

C *** TAKE ONE FORWARD TIME STEP - Solve Modal Dynamics Equations
C     This code implements Section 1.4 of Binkowski and Roselle (2003)
C     with two notable exceptions.  1) emissions are treated in
C     CMAQ`s vertical diffusion routine, so they do not appear in the
C     following equations. 2) new particle formation and condensational
C     growth are now treated in the VOLINORG subroutine, so they do not
C     appear in the following equations.
 
      ! Initial Moment Values
      M00 = MOMENT0_CONC
      M20 = MOMENT2_CONC
      M30 = MOMENT3_CONC

! *** Update Zeroth Moment (i.e. number concentration)
! *** Aitken mode: initial value of M0
      Y0 = MOMENT0_CONC( 1 )

      ! The rate of change for M0_Aitken is described in Equation 8a of
      ! Binkowski & Roselle (2003), with the c_i term equal to 0.
      A = BATAT( 1 )                      ! intramodal coagulation
      B = BATAC( 1 ) * moment0_conc( 2 )  ! intermodal coagulation

      EXPDT = EXP( - B * DT )
      IF ( EXPDT .LT. 1.0D0 ) THEN
         Y = B * Y0 * EXPDT / ( B + A * Y0 * ( 1.0D0 - EXPDT ) )
      ELSE
         Y = Y0                 ! solution in the limit that B approaches zero
      END IF

      ! Transfer new value of M0_Aitken to the moment array
      MOMENT0_CONC( 1 ) = MAX( AEROMODE_MINNUM( 1 ), REAL( Y ) )

      ! Accumulation mode: initial value of M0
      Y0 = MOMENT0_CONC( 2 )

      ! The rate of change for M0_accum is described in Equation 8b of
      ! Binkowski & Roselle (2003), except the coefficient C is zero
      ! because emissions are treated outside the CMAQ aerosol module.
      ! The equation reduces to the form: dY/dt = -A * Y**2 , where
      A = BACAC( 1 )                 ! intramodal coagulation

      ! Solve for M0_accum using Smoluchowski`s solution
      Y = Y0 / ( 1.0D0 + A * Y0 * DT )

      ! Transfer new value of M0_accum to the moment array
      MOMENT0_CONC( 2 ) = MAX( AEROMODE_MINNUM( 2 ), REAL( Y ) )

      ! ** Update Budget Variable for Zeroth Moment
      COAG_BUDGET( AERONUM_MAP( 1 ),1 ) = MOMENT0_CONC( 1 ) - CBUDGET0_NUM( 1 )
      COAG_BUDGET( AERONUM_MAP( 2 ),2 ) = MOMENT0_CONC( 2 ) - CBUDGET0_NUM( 2 )

! *** end of update for zeroth moment - note that the coarse mode number does
! *** not change because coarse-mode coagulation is neglected in the model
 

C *** UPDATE MASS CONCENTRATIONS (for each species)
C     The following procedure is described in Paragraphs 21-23
C     of Binkowski & Roselle (2003), except the Ei,n and Ej,n terms
C     are excluded here because emissions are treated outside the
C     CMAQ aerosol module.

C     Aitken mode mass concentration rates of change are of the form:
C        dc/dt = P - L*c    ! Equation 9a of Binkowski & Roselle (2003)
C     with solution
C        c(t0 + dt) = P/L + ( c(t0) - P/L ) * exp(-L*dt)

C     For all species, loss of Aitken mode mass is due to intermodal
C     coagulation.
C        LOSSn = PI/6 * RHOn * C30ATAC / MASSn
C        RHOn  = MASSn / (M3 * PI/6)
C     When above equations are combined, the PI/6 terms cancel yielding
C        LOSSn = C30ATAC / M3
C     where LOSSn is the loss rate of species n, RHOn is the mass of
C     species n per unit of particle volume, C30ATAC is the 3rd moment
C     loss rate due to intermodal coagulation, MASSn is the mass
C     concentration of species n, and M3 is the 3rd moment
C     concentration.

      LOSS = C30ATAC / MOMENT3_CONC( 1 )

      ! Set up extra variables to solve for Aitken mode mass concentrations
      FACTRANS = REAL( LOSS,4 ) * DT
      EXPDT = EXP( -FACTRANS )

      ! Transfer mass from Aitken to accumulation mode, resulting from 
      ! intermodal coagulation.

      DO SPC = 1, N_AEROSPC
         IF ( AERO_MISSING(SPC,1) ) CYCLE
 
         TMASS = AEROSPC_CONC( SPC,1 ) + AEROSPC_CONC( SPC,2 )
         IF( SPC .EQ. APHGJ_IDX  )THEN 
             ! assumes all production adsorb onto accumulation mode
             TMASS = TMASS + PHG_RATE * DT
         END IF

         AEROSPC_CONC( SPC,1 ) = MAX( AEROSPC( SPC )%MIN_CONC( 1 ),
     &                                REAL( AEROSPC_CONC( SPC,1 ) * EXPDT ) )
         AEROSPC_CONC( SPC,2 ) = MAX( AEROSPC( SPC )%MIN_CONC( 2 ),
     &                                TMASS - AEROSPC_CONC( SPC,1 ) )


         ! Update Budget Variable for Speciated Mass
         IF ( AEROSPC_MAP( SPC,1 ) .NE. 0 ) 
     &      COAG_BUDGET( AEROSPC_MAP( SPC,1 ),1 ) = 
     &           AEROSPC_CONC( SPC,1 ) - CBUDGET0_MASS( SPC,1 )
         IF ( AEROSPC_MAP( SPC,2 ) .NE. 0 ) 
     &      COAG_BUDGET( AEROSPC_MAP( SPC,2 ),1 ) = 
     &           AEROSPC_CONC( SPC,2 ) - CBUDGET0_MASS( SPC,2 )

      END DO

C *** end of update for species mass concentrations
 
! *** UPDATE SECOND MOMENT
      IF ( COAG_MOMENTS .EQ. 3 ) THEN
        ! For each lognormal mode, solve equations of form:
        !    dM2/dt = P2 - L2*M2   ! if L2 > 0
        ! with solution
        !    M2(t) = P2/L2 + ( M2(t0) - P2/L2 ) * exp( -L2*dt )
        ! or
        !    dM2/dt = P2           ! if L2 = 0
        ! with solution
        !    M2(t) = M2(t0) + P2*dt

        ! Loss of 2nd moment from Aitken mode is due to intermodal
        ! coagulation with accumulation mode and intramodal coagulation.
        ! Production term is removed, because new particle formation
        ! and condensational growth are accounted for in VOLINORG.
        LOSS = (
     &          ( BATAT( 2 ) * M00( 1 )
     &          + BATAC( 2 ) * M00( 2 ) ) * M00( 1 )
     &         ) / M20( 1 )

        ! Solve for M2_Aitken based on LOSS during this time step
        ! Note: LOSS is assumed to be non-negative.
        IF ( LOSS .GT. 0.0 ) THEN
           Y = M20( 1 ) * EXP( -LOSS * DT )
        ELSE
           Y = M20( 1 )
        END IF ! test on loss

        ! Transfer new value of M2_Aitken to the array
        MOMENT2_CONC( 1 ) = MAX( REAL( AEROMODE_MINM2( 1 ) ), REAL( Y ) )

        ! Production of 2nd moment in accumulation mode is due to
        ! intermodal coagulation Aitken mode
        PROD = BACAT( 2 ) * M00( 1 ) * M00( 2 )

        ! Loss of 2nd moment from accumulation mode is due only to
        ! intramodal coagulation
        LOSS = ( BACAC( 2 ) * M00( 2 ) * M00( 2 ) ) / M20( 2 )

        ! Solve for M2_accum based on PROD and LOSS during this time step
        ! Note: LOSS is assumed to be non-negative.
        IF ( LOSS .GT. 0.0 ) THEN
           POL = PROD / LOSS
           Y = POL + ( M20(2) - POL ) * EXP( -LOSS * DT )
        ELSE
           Y = M20(2) + PROD * DT
        END IF ! test on loss
     
        ! Transfer new value of M2_accum to moment array
        MOMENT2_CONC( 2 ) = MAX( REAL( AEROMODE_MINM2( 2 ) ), REAL( Y ) )

        ! Coarse mode: no change because coagulation of coarse particles
        ! is neglected in current model version.

      ELSE IF ( COAG_MOMENTS .EQ. 2 ) THEN
        ! Assume constant modal standard deviation and solve for new
        ! second moment as a function of the change in the third moment.
        MOMENT2_CONC( 1 ) = M20( 1 )*( MOMENT3_CONC( 1 ) / M30( 1 ) ) ** ( 2.0 / 3.0 )
        MOMENT2_CONC( 2 ) = M20( 2 )*( MOMENT3_CONC( 2 ) / M30( 2 ) ) ** ( 2.0 / 3.0 )

      END IF

      ! Update Budget Variable for Second Moment
      COAG_BUDGET( AEROSRF_MAP( 1 ),1 ) = MOMENT2_CONC( 1 ) * PI - CBUDGET0_SRF( 1 )
      COAG_BUDGET( AEROSRF_MAP( 2 ),2 ) = MOMENT2_CONC( 2 ) * PI - CBUDGET0_SRF( 2 )

C *** end of update for second moment
 

C *** Mode Merging
C     This code implements Section 1.5 of Binkowski and Roselle (2003).
C     If the Aitken mode mass is growing faster than accumulation mode
C     mass and the Aitken mode number concentration exceeds the
C     accumulation mode number concentration, then modes are merged by
C     renaming.

! *** Initialize Budget Variables
      CBUDGET0_NUM  = MOMENT0_CONC
      CBUDGET0_SRF  = MOMENT2_CONC * PI
      CBUDGET0_MASS = AEROSPC_CONC

#ifdef nomm
      if ( .false. ) then
#else
      IF ( CGR( 1 ) .GT. CGR( 2 ) .AND.
     &     MOMENT0_CONC( 1 ) .GT. MOMENT0_CONC( 2 ) ) THEN
#endif

C *** Before mode merging, update the third moments, geometric mean
C     diameters, geometric standard deviations, modal mass totals, and
C     particle densities, based on the new concentrations of M2, M0, and
C     speciated masses calculated above. This is still the wet
C     distribution.
         CALL GETPAR( FIXED_sg )

C *** Calculate AAA = ln( Dij / DGATK ) / ( SQRT2 * XXLSGAT ), where Dij
C     is the diameter at which the Aitken-mode and accumulation-mode
C     number distributions intersect (i.e., overlap).  AAA is equivalent
C     to the "Xnum" term described below Equation 10a by Binkowski and
C     Roselle (2003).
         AAA = GETAF( MOMENT0_CONC( 1 ), MOMENT0_CONC( 2 ),
     &                AEROMODE_DIAM( 1 ), AEROMODE_DIAM( 2 ), 
     &                AEROMODE_LNSG( 1 ), AEROMODE_LNSG( 2 ),
     &                SQRT2 ) 

C *** Ensure that Xnum is large enough so that no more than half of
C     the Aitken mode mass is merged into the accumulation mode during
C     any given time step.  This criterion is described in Paragraph 26
C     of Binkowski and Roselle (2003).
         XXM3 = 3.0 * AEROMODE_LNSG( 1 ) / SQRT2
         XNUM = MAX( AAA, XXM3 )

C *** Factors used in error function calls for M2 and M3 mode merging
         XXM2 = TWOTHIRDS * XXM3
         XM2  = XNUM - XXM2 ! set up for 2nd moment transfer
         XM3  = XNUM - XXM3 ! set up for 3rd moment and mass transfers

C *** Calculate the fractions of the number, 2nd, and 3rd moment
C     distributions with diameter greater than the intersection diameter
         FNUM  = 0.5 * ERFC( XNUM )            ! Eq 10a of B&R 2003
         FM2   = 0.5 * ERFC( XM2 )             ! Eq 10b of B&R 2003
         FM3   = 0.5 * ERFC( XM3 )             ! Eq 10b of B&R 2003

C *** Calculate the fractions of the number, 2nd, and 3rd moment
C     distributions with diameters less than the intersection diameter.
         PHNUM = 0.5 * ( 1.0 + ERF( XNUM ) )  ! Eq 10c of B&R 2003
         PHM2  = 0.5 * ( 1.0 + ERF( XM2 ) )   ! Eq 10d of B&R 2003
         PHM3  = 0.5 * ( 1.0 + ERF( XM3 ) )   ! Eq 10d of B&R 2003

C *** Update accumulation-mode moment concentrations using
C     Equations 11a - 11c of Binkowski and Roselle (2003).
         MOMENT0_CONC( 2 ) = MOMENT0_CONC( 2 ) + MOMENT0_CONC( 1 ) * FNUM
         MOMENT2_CONC( 2 ) = MOMENT2_CONC( 2 ) + MOMENT2_CONC( 1 ) * FM2
         MOMENT3_CONC( 2 ) = MOMENT3_CONC( 2 ) + MOMENT3_CONC( 1 ) * FM3

C *** Update Aitken-mode moment concentrations using
C     Equations 11d - 11f of Binkowski and Roselle (2003).
         MOMENT0_CONC( 1 ) = MOMENT0_CONC( 1 ) * PHNUM
         MOMENT2_CONC( 1 ) = MOMENT2_CONC( 1 ) * PHM2
         MOMENT3_CONC( 1 ) = MOMENT3_CONC( 1 ) * PHM3
 
C *** Rename masses of each species from Aitken mode to acumulation mode
C     using Equation 11b of Binkowski and Roselle (2003). Do this for
C     all species, even the aerosol water.
         DO SPC = 1, N_AEROSPC
            IF ( AERO_MISSING(SPC,1) ) CYCLE

            AEROSPC_CONC( SPC,2 ) = AEROSPC_CONC( SPC,2 ) + AEROSPC_CONC( SPC,1 ) * FM3
            AEROSPC_CONC( SPC,1 ) = AEROSPC_CONC( SPC,1 ) * PHM3
         END DO

      END IF ! end check on necessity for merging

C *** end of update for mode merging

C *** Update the third moments, geometric mean diameters, geometric
C     standard deviations, modal mass totals, and particle densities,
C     based on the final concentrations of M2, M0, and speciated masses
C     after mode merging is complete. This should be done for the wet
C     distribution.
      CALL GETPAR( FIXED_sg )

C *** Set minimum value for all concentrations in the CBLK array

      DO N = 1, N_MODE
         DO SPC = 1, N_AEROSPC
            AEROSPC_CONC( SPC,N ) = MAX( AEROSPC_CONC( SPC,N ),
     &                                   AEROSPC( SPC )%MIN_CONC( N ) )
#ifdef sens
            IF (AEROSPC_CONC( SPC,N ) .EQ. AEROSPC( SPC )%MIN_CONC( N ) )  THEN
               S_AEROSPC_CONC( SPC,N,: ) = 0.0
            ENDIF
#endif
         END DO
      END DO


! *** Propagate Mode Merging and Minimum value impacts to budget variables
      GROWTH_BUDGET( AERONUM_MAP(:) ) = MOMENT0_CONC(:) - CBUDGET0_NUM(:)
      GROWTH_BUDGET( AEROSRF_MAP(:) ) = MOMENT2_CONC(:) * PI - CBUDGET0_SRF(:)
      DO SPC = 1,N_AEROSPC
         WHERE( AEROSPC_MAP( SPC,: ) .NE. 0 )
     &          GROWTH_BUDGET( AEROSPC_MAP(SPC,:) )=
     &              AEROSPC_CONC(SPC,:) - CBUDGET0_MASS(SPC,:)
      END DO

      RETURN
      END SUBROUTINE AEROPROC


C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE VOLINORG( DT, COL, ROW, LAYER, DV_SO4, CGR )

C *** Calculates the partitioning of inorganic components (CL,NO3,NH4,SO4)
C     between the aerosol and gas phase over the operator synchronization
C     timestep (DT). Partitioning is calculated using the Hybrid approach,
C     where dynamic mass transfer of species to/from the coarse mode is
C     calculated using multiple sub-operator time steps (TSTEP) and the
C     fine modes are equilibrated with the gas phase. The mass transfer
C     calculations are made using the H+ flux-limiting approach of Pilinis
C     et al. (2000). If 'OPTIONFLAG' is not set to 'Hybrid', the mass
C     transfer calculations for the coarse mode are skipped, and the fine
C     modes are equilibrated with the gas phase.

C     Returns updated volatile inorganic species concentrations in the gas
C     and particulate phase, and the aerosol modal parameters

C *** Revision history: 4/07 - Moved HCOND3 and NEWPART3 calls from 
C                              AEROPROC to this subroutine for 
C                              mass transfer calculation  
C     15 Jul 08 J.Young, P.Bhave: increased cutoff to hybrid from .01 to .05 ug/m**3
C               J.Young: change 'OPTIONFLAG' to just a logical variable, 'Hybrid'

C     10 Mar 11 S.Howard Renamed met_data to aeromet_data
C     25 Mar 11 S.Roselle Replaced I/O API include files with UTILIO_DEFN
C     26 Apr 11 G.Sarwar Replaced existing ISORROPIA with ISORROPIA 2.1
C               Updated coarse-mode aerosol speciation and H+ calculation  
C     12 Apr 16 H. Pye and B. Murphy: Update with consistent treatment for wet particles.
C     15 Apr 16 J.Young: Use aerosol factors from AERO_DATA module named constants

C *** References
C 1. Pilinis C, Capaldo KP, Nenes A, Pandis SN (2000) MADM - A new
C    multicomponent aerosol dynamics model. AEROSOL SCIENCE AND TECHNOLOGY.
C    32(5):482-502
C
C 2. Capaldo KP, Pilinis C, Pandis SN (2000) A computationally efficient hybrid
C    approach for dynamic gas/aerosol transfer in air quality models. ATMOSPHERIC
C    ENVIRONMENT. 34(21):3617-3627
C
C 3. Fountoukis C, Nenes, A (2007) ISORROPIA II: a comnputationally efficient 
C    thermodynamic equilibrium model for K+-Ca2+-Mg2+-NH4+-SO42--NO3--Cl-H2O 
C    aerosols. ATMOSPHERIC CHEMISTRY AND PHYSICS. 7, 4639-4659

      USE AERO_DATA
      USE PRECURSOR_DATA
      USE SOA_DEFN
      USE AEROMET_DATA
      USE CONST
      USE UTILIO_DEFN
      USE CGRID_SPCS
      USE HLCONST_MOD

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX
      USE AERO_DDM3D, ONLY : S_SO4RATE, S_PRECURSOR_CONC
#endif

      IMPLICIT NONE

C *** Arguments:
      REAL    DT              ! time step [sec]
      INTEGER COL             ! grid column index
      INTEGER ROW             ! grid row index
      INTEGER LAYER           ! model layer index
      REAL    DV_SO4          ! molecular diffusivity of H2SO4 vapor 
                              ! after correction for ambient conditions
      REAL( 8 ) :: CGR( N_MODE-1 ) ! 3rd moment SO4 growth rate [m^3/m^3-s]

C *** Parameters: 
      INTEGER, PARAMETER :: NINORG = 9      ! number of inorganic species
      INTEGER, PARAMETER :: NVOLINORG = 3   ! number of volatile inorganic species

      ! indices for inorganic species
      INTEGER, PARAMETER :: KNH4 = 1, KNO3 = 2, KCL = 3, KSO4 = 4, KNA = 5, KMG = 6, KK = 7, KCA = 8, KHP = 9

      REAL( 8 ), PARAMETER :: D_TWOTHIRDS = 2.0D0 / 3.0D0

      REAL, PARAMETER :: CUTOFF = 0.05  ! [ug/m**3]
      REAL, PARAMETER :: ALPHSULF = 0.1 ! Accommodation coefficient for sulfuric acid
                                        ! see Capaldo et al. (2000)

C *** Local Variables:

C *** Inputs to subroutine HCOND3

      REAL, SAVE :: COFCBAR_SO4  ! Temperature-independent coefficients
                                 ! for caculating molecular vel [m/s]
                                 ! = sqrt((8*Rgas)/(pi*MW)) 
      REAL         CBAR_SO4      ! molecular velocity of H2SO4                      

      REAL( 8 ) :: AM0( N_MODE ) ! zeroth moments
      REAL( 8 ) :: AM1( N_MODE ) ! first moments
      REAL( 8 ) :: AM2( N_MODE ) ! second moments

      REAL( 8 ) :: M2DRY_INIT( N_MODE )  ! Dry Second Moment Initial Array
      REAL( 8 ) :: M3DRY_INIT( N_MODE )  ! Dry Third Moment Initial Array
      REAL( 8 ) :: M2WET_INIT( N_MODE )  ! Wet Second Moment Initial Array
      REAL( 8 ) :: M3WET_INIT( N_MODE )  ! Wet Third Moment Initial Array
      REAL( 8 ) :: M2WET_FINAL( N_MODE ) ! Wet Second Moment Final Array
      REAL( 8 ) :: M3WET_FINAL( N_MODE ) ! Wet Third Moment Final Array

C *** Outputs from HCOND3: size-dependent term in the condensational-growth 
C     expressions defined in Equations A13-A14 of [Binkowski & Shankar,1995]
      REAL( 8 ) :: FCONC_SO4( N_MODE,2 )  ! All sizes 2nd and 3rd moments
      REAL( 8 ) :: FCONC_OUT( 2 )         ! Output for HCOND3, 2nd and 3rd moments
      REAL( 8 ) :: FCONCM1_SO4       ! reciprocals of total SO4 cond rates

C *** Modal partition factors [ dimensionless ]
C     defined in Equations A17-A18 of [Binkowski & Shankar,1995]
      REAL( 8 ) :: OMEGA_AT_SO4  ! Aitken mode 2nd and 3rd moments
      REAL( 8 ) :: OMEGA_AC_SO4  ! Accumulation mode 2nd and 3rd moments
      REAL( 8 ) :: OMEGA( 2 )    ! partitioning coefficient for equilibrium PM mass
      REAL( 8 ) :: PHI( NINORG,2 ) ! Mass Fraction of each component in each aerosol mode
      REAL( 8 ) :: TOTAER( NINORG )! Total aerosol component across multiple modes 

C *** Variables for new particle formation:
      REAL XH2SO4            ! steady state H2SO4 concentration
      REAL( 8 ) :: DMDT_SO4  ! particle mass production rate [ ug/m**3 s ]
      REAL( 8 ) :: DNDT      ! particle number production rate [ # / m**3 s ]
      REAL( 8 ) :: DM2DT     ! second moment production rate [ m**2 / m**3 s]
      REAL( 8 ) :: SCONDRATE ! SO4 condensation rate [ ug/m**3 s ]

C *** Mode-specific sulfate production rate [ ug/m**3 s ]
      REAL( 8 ) :: CONDSO4( N_MODE )    ! sulfate condensation rate [ ug/m**3 s ]
      REAL( 8 ) :: RATE                 ! CONDSO4 or cond+nucl rate

C *** Size-dependent portion of mass-transfer rate equation
      REAL( 8 ) :: GRFAC1( N_MODE )     ! 2nd moment [ m**2/m**3-s ] 
      REAL( 8 ) :: GRFAC2( N_MODE )     ! 3rd moment [ m**3/m**3-s ] 
      
C *** ISORROPIA input variables
      REAL( 8 ) :: WI( NINORG - 1 )     ! species array [ mol/m**3 ]
      REAL( 8 ) :: RHI                  ! relative humidity [ fraction ]
      REAL( 8 ) :: TEMPI                ! temperature   [ deg K]
      REAL( 8 ) :: CNTRL( 2 )           ! ISOROPIA control parameters 

C *** ISORROPIA output variables
      REAL( 8 ) :: WT( NINORG - 1 )     ! species output array (unused)
      REAL( 8 ) :: GAS( 3 )             ! gas-phase   "     " 
      REAL( 8 ) :: AERLIQ( 15 )         ! liq aerosol "     " 
      REAL( 8 ) :: AERSLD( 19 )         ! solid "     "     "  (unused)
      REAL( 8 ) :: OTHER( 9 )           ! supplmentary output array (unused)
      CHARACTER( 15 ) :: SCASI          ! subcase number output (unused)

C *** Variables to account for mass conservation violations in ISRP3F
!     LOGICAL TRUSTNH4                  ! false if ISOROPIA's partitioning
                                        !  of NH4/NH3 is to be ignored
      LOGICAL TRUSTCL                   ! false if ISOROPIA's partitioning       
                                        !  of Cl/HCl is to be ignored

C *** Initial (double-precision) concentrations [ug/m3]
      REAL( 8 ) :: GNH3R8               ! gas-phase ammonia
      REAL( 8 ) :: GNO3R8               ! gas-phase nitric acid
      REAL( 8 ) :: GCLR8                ! gas-phase hydrochloric acid

C *** Variables for volatile species mass transfer between gas and aerosol and
C     mass partitioning between the modes 
      LOGICAL HYBRID ! mass transfer option flag (mass transfer if .TRUE.)
      REAL( 8 ) :: DELT                 ! time step DT [s]
      REAL( 8 ) :: HPLUS( N_MODE )      ! scratch var for H+ [umol/m**3]

      REAL( 8 ), SAVE :: H2SO4RATM1     ! Mol. wt. ratio of SO4/H2SO4

      REAL( 8 ) :: DVOLINORG( NVOLINORG ) ! vol inorg spcs mass to be xferred [mol/m3]
      REAL( 8 ) :: DVOLMAX                ! max value for DVOLINORG 
      REAL( 8 ) :: CINORG( NINORG,N_MODE ) ! scratch array for inorg spcs [ug/m**3]
      REAL( 8 ) :: SEACAT                 ! coarse sea-salt cations [ug/m**3]
      REAL( 8 ) :: SOILwVOLS              ! windblown dust before removal of
                                          ! SO4,NO3,CL,H2O [ug/m**3]
      REAL( 8 ) :: PMCwVOLS               ! anthrop coarse material before removal
                                          ! of SO4,NO3,CL,H2O [ug/m**3]
      REAL( 8 ) :: INT_TIME               ! internal mass transfer time (s)
      REAL( 8 ) :: TSTEP                  ! mass transfer time step [s]
      REAL( 8 ) :: DRYM20, Y              ! scratch vars for 2nd moment [m**2/m**3]
      REAL( 8 ) :: M3OTHR                 ! vars for 3rd moment calculation [m**3/m**3]
      REAL( 8 ), SAVE :: DF( NVOLINORG )  ! scratch array for mole -> ug conversion
      REAL( 8 ), SAVE :: DFH2OR8          ! mole -> ug conversion for H2O
      REAL( 8 ) :: J( NVOLINORG )         ! condensation/evaporation flux [mol/m**3-s]
      REAL( 8 ) :: CFINAL( NVOLINORG,N_MODE ) ! conc after mass xfer step [ug/m**3]
      REAL( 8 ) :: H2O                    ! Scratch LWC variable for output
      REAL( 8 ) :: COA                    ! Total Organic Aerosol Moles for Partitioning
      REAL( 8 ) :: H2O_NEW                ! Update of LWC after condensation 
      REAL( 8 ) :: SO4                    ! modal SO4 after condensation or cond + nucl
      REAL( 8 ) :: DDRYM3DT               ! rate of 3rd moment transfer - dry inorg spcs
      REAL( 8 ) :: DDRYM2DT               ! rate of 2nd moment transfer -  "     "    "
      REAL( 8 ) :: DRYM3, WETM3           ! scratch vars for 3rd moment calc [m**3/m**3]
      REAL( 8 ) :: DRYM2, WETM2           ! scratch vars for 2nd moment calc [m**2/m**3]
      REAL( 8 ) :: LOSS                   ! rate of loss of second moment [1/s] 
      REAL( 8 ) :: EQLBHIJ                ! H+ concentration from isoropia for I plus J-modes [ug/m**3]

      REAL( 8 ) :: DELNUM( N_MODE ) ! Change in Number due to some process
      REAL( 8 ) :: DELSRF( N_MODE ) ! Change in Surface Area due to some process
      REAL( 8 ) :: DELSO4( N_MODE ) ! Change in Sulfate due to some process
      REAL( 8 ) :: DELNO3( N_MODE ) ! Change in Nitrate due to some process
      REAL( 8 ) :: DELNH4( N_MODE ) ! Change in Ammonium due to some process
      REAL( 8 ) :: DELCL( N_MODE )  ! Change in Chloride due to some process
      REAL( 8 ) :: DELH2O( N_MODE ) ! Change in Water due to some process
      REAL( 8 ) :: DELH3OP( N_MODE )! Change in Proton due to some process
      REAL( 8 ) :: CBUDGET0_NUM( N_MODE ) ! Initial Number before some process
      REAL( 8 ) :: CBUDGET0_SRF( N_MODE ) ! Initial Surface Area before some process
      REAL( 8 ) :: CBUDGET0_SO4( N_MODE ) ! Initial Sulfate before some process
      REAL( 8 ) :: CBUDGET0_NO3( N_MODE ) ! Initial Nitrate before some process
      REAL( 8 ) :: CBUDGET0_NH4( N_MODE ) ! Initial Ammonium before some process
      REAL( 8 ) :: CBUDGET0_CL( N_MODE )  ! Initial Chloride before some process
      REAL( 8 ) :: CBUDGET0_H2O( N_MODE ) ! Initial Particle Water before some process
      REAL( 8 ) :: CBUDGET0_H3OP( N_MODE )! Initial Proton before some process

      REAL( 8 ) :: TMP
      INTEGER I, N, K, C                  ! loop and array indices
      INTEGER IMODE                       ! mode loop index  
      INTEGER ISTEP                       ! loop index, mass transfer time step loop
      INTEGER ISP                         ! loop index, species loop
      LOGICAL TrustIso                    ! For negative vap. press., TrustIso = F
      INTEGER IPFAS                       ! Loop Counter for PFAS partitioning

C *** Local Saved Variables 
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL, SAVE :: FIRSTWRITE = .TRUE.
      REAL( 8 ), SAVE :: SO4FAC         !  F6DPIM9 / RHOSO4
      REAL( 8 ), SAVE :: SOILFAC        !  F6DPIM9 / RHOSOIL
      REAL( 8 ), SAVE :: ANTHFAC        !  F6DPIM9 / RHOANTH
      REAL( 8 ), SAVE :: H2SO4RAT       ! Mol. wt ratios H2SO4/SO4
      REAL( 8 ), SAVE :: NH3RAT         ! Mol. wt ratios NH3/NH4
      REAL( 8 ), SAVE :: HNO3RAT        ! Mol. wt ratios HNO3/NO3
      REAL( 8 ), SAVE :: HCLRAT         ! Mol. wt ratios HCL/CL 
      REAL( 8 ), SAVE :: MWH2SO4        ! molecular weight for H2SO4
      REAL( 8 ), SAVE :: FAERH2SO4      ! 1e-6 / mw(h2so4)

      REAL( 8 ), SAVE :: CFAC_ANA
      REAL( 8 ), SAVE :: CFAC_ASO4
      REAL( 8 ), SAVE :: CFAC_ANH4
      REAL( 8 ), SAVE :: CFAC_ANO3
      REAL( 8 ), SAVE :: CFAC_ACL
      REAL( 8 ), SAVE :: CFAC_ACA
      REAL( 8 ), SAVE :: CFAC_AK
      REAL( 8 ), SAVE :: CFAC_AMG
      REAL( 8 ), SAVE :: CFAC_ASEACAT
      REAL( 8 ), SAVE :: CFAC_GNH3
      REAL( 8 ), SAVE :: CFAC_GHNO3
      REAL( 8 ), SAVE :: CFAC_GHCL

      REAL( 8 ), SAVE :: M3FAC_ANA
      REAL( 8 ), SAVE :: M3FAC_ASO4
      REAL( 8 ), SAVE :: M3FAC_ANH4
      REAL( 8 ), SAVE :: M3FAC_ANO3
      REAL( 8 ), SAVE :: M3FAC_ACL
      REAL( 8 ), SAVE :: M3FAC_H2O
      REAL( 8 ), SAVE :: M3FAC_PFAS
      
      REAL( 8 ), SAVE :: DPFAS0

      REAL( 4 )       :: HLAW, ACIDITY, HEFF, PFASGAS, PFASTOT, 
     &                   FPFAS, PFASNEW, DPFAS, fPFAS_AqsPhase,
     &                   fPFAS_OrgPhase, TT1, TT2, CSTAR, GASCONV

      logical, save :: write1 = .true.

#ifdef sens
      INTERFACE
         SUBROUTINE AERO_SENS( SCASI, W )
           CHARACTER( 15 ), INTENT( IN ) :: SCASI    ! (INPUT) subcase number output
           REAL(KIND=8),    INTENT( IN ) :: W( : )   ! (INPUT) WI concentrations 
         END SUBROUTINE AERO_SENS
      END INTERFACE 
#endif

C *** External functions
   !   Interface
   !      Real Function hlconst ( isub, temp, effective, hplus )
   !        Use utilio_defn
   !        Implicit None
   !        Integer,  Intent ( In ) :: isub
   !        Real,     Intent ( In ) :: temp
   !        Logical,  Intent ( In ) :: effective
   !        Real,     Intent ( In ) :: hplus
   !     End Function hlconst
   !   End Interface

C-----------------------------------------------------------------------
 
      IF ( FIRSTIME ) THEN
      
         FIRSTIME = .FALSE.
#ifdef noiso
         write( logdev,* ) 'aero_subs, volinorg: noiso'
#endif

         CFAC_ANA  = 1.0D-6 / REAL( AEROSPC_MW( ANA_IDX ), 8 )
         CFAC_ASO4 = 1.0D-6 / REAL( AEROSPC_MW( ASO4_IDX ), 8 )
         CFAC_ANH4 = 1.0D-6 / REAL( AEROSPC_MW( ANH4_IDX ), 8 )
         CFAC_ANO3 = 1.0D-6 / REAL( AEROSPC_MW( ANO3_IDX ), 8 )
         CFAC_ACL  = 1.0D-6 / REAL( AEROSPC_MW( ACL_IDX ), 8 )
         CFAC_ACA  = 1.0D-6 / REAL( AEROSPC_MW( ACA_IDX ), 8 )
         CFAC_AK   = 1.0D-6 / REAL( AEROSPC_MW( AK_IDX ), 8 )
         CFAC_AMG  = 1.0D-6 / REAL( AEROSPC_MW( AMG_IDX ), 8 )
         CFAC_ASEACAT = 1.0D-6 / REAL( AEROSPC_MW( ASEACAT_IDX ), 8 )
         CFAC_GNH3 = 1.0D-6 / PRECURSOR_MW( NH3_IDX )
         CFAC_GHNO3= 1.0D-6 / PRECURSOR_MW( HNO3_IDX )
         CFAC_GHCL = 1.0D-6 / PRECURSOR_MW( HCL_IDX )

         M3FAC_ANA  = 1.0D-9 * F6DPI / REAL( AEROSPC( ANA_IDX )%DENSITY, 8 )
         M3FAC_ASO4 = 1.0D-9 * F6DPI / REAL( AEROSPC( ASO4_IDX )%DENSITY, 8 )
         M3FAC_ANH4 = 1.0D-9 * F6DPI / REAL( AEROSPC( ANH4_IDX )%DENSITY, 8 )
         M3FAC_ANO3 = 1.0D-9 * F6DPI / REAL( AEROSPC( ANO3_IDX )%DENSITY, 8 )
         M3FAC_ACL  = 1.0D-9 * F6DPI / REAL( AEROSPC( ACL_IDX )%DENSITY, 8 )
         M3FAC_H2O  = 1.0D-9 * F6DPI / REAL( AEROSPC( AH2O_IDX )%DENSITY, 8 )
         M3FAC_PFAS = 1.0D-9 * F6DPI / REAL( 1500.0, 8 )

         MWH2SO4 = PRECURSOR_MW( SULF_IDX ) ! molecular weight for H2SO4
         FAERH2SO4 = 1.0E-6 / MWH2SO4

         COFCBAR_SO4 = SQRT( 8.0 * RGASUNIV / ( PI * REAL( MWH2SO4,4 ) * 1.0E-3 ) )
         H2SO4RATM1 = AEROSPC_MW( ASO4_IDX ) / MWH2SO4
         SO4FAC  = 1.0D-9 * F6DPI / REAL( AEROSPC( ASO4_IDX )%DENSITY, 8 )
         SOILFAC = 1.0D-9 * F6DPI / REAL( AEROSPC( ASOIL_IDX )%DENSITY, 8 )
         ANTHFAC = 1.0D-9 * F6DPI / REAL( AEROSPC( ACORS_IDX )%DENSITY, 8 )

         DF( KNH4 ) = 1.0D0 / CFAC_ANH4
         DF( KNO3 ) = 1.0D0 / CFAC_ANO3
         DF( KCL )  = 1.0D0 / CFAC_ACL
         DFH2OR8    = 1.0D6 * MWWAT      ! aerospc_mw(AH2O_IDX) (18.0 != 18.0153)

         ! Mol. wt ratios H2SO4/SO4, NH3/NH4, HNO3/NO3, HCL/CL
         H2SO4RAT= PRECURSOR_MW( SULF_IDX ) / REAL( AEROSPC_MW( ASO4_IDX ), 8 )
         NH3RAT  = PRECURSOR_MW( NH3_IDX )  / REAL( AEROSPC_MW( ANH4_IDX ), 8 )
         HNO3RAT = PRECURSOR_MW( HNO3_IDX ) / REAL( AEROSPC_MW( ANO3_IDX ), 8 )
         HCLRAT  = PRECURSOR_MW( HCL_IDX )  / REAL( AEROSPC_MW( ACL_IDX ), 8 )
      END IF

C *** Determine if Hybrid
      TMP = 0.0
#ifdef noiso
      hybrid = .false.
#else
      DO I = 1, N_AEROSPC
         IF(  AEROSPC( I )%tracer )CYCLE
         IF ( AEROSPC( I )%CHARGE .NE. 0 ) TMP = TMP + AEROSPC_CONC( I,N_MODE )
      END DO
      HYBRID = ( TMP .GE. CUTOFF ) .AND. ( AIRRH .GE. 0.18 )
#endif

      DELT  = REAL( DT, 8 )
      TEMPI = AIRTEMP             ! assume const within synch timestep
      RHI   = MIN( 0.95, AIRRH )  ! "        "     "      "     "

C *** Calculate molecular velocities (temperature dependent) and
C     H+ concentration

      CBAR_SO4 = COFCBAR_SO4 * SQRT( AIRTEMP )

      HPLUS = 0.0
      DO I = 1, N_MODE
         DO N = 1, N_AEROSPC
            IF(  AEROSPC( N )%tracer )CYCLE
            HPLUS( I ) = HPLUS( I )
     &                 - AEROSPC( N )%CHARGE * AEROSPC_CONC( N,I ) / AEROSPC_MW( N )
         END DO
      END DO

C *** Condensational Growth (Size-dependent terms)
C     Calculate intermediate variables needed to determine the 2nd and
C     3rd moment condensational-growth rates.  3rd moment terms are 
C     needed for the calculation of new particle production.  See 
C     Section 3.3 of Jiang & Roth (2003) for a detailed discussion.
C    
C *** Set moments using Equation 4 of Binkowski & Shankar
C     (1995) or Equation 3 of Binkowski and Roselle (2003).
C     N.B: these are for a "wet" size distribution

      DO I = 1, N_MODE
         AM0( I ) = MOMENT0_CONC( I ) 
         AM1( I ) = MOMENT0_CONC( I ) * AEROMODE_DIAM( I )
     &            * EXP( 0.5 * AEROMODE_LNSG( I ) * AEROMODE_LNSG( I ) )
         AM2( I ) = MOMENT2_CONC( I )
      END DO
      
C *** Calculate the size-dependent terms in the condensational-
C     growth factor expressions for sulfate using 
C     Equations A13-A14 of Binkowski & Shankar (1995). 
       
      DO I = 1, N_MODE
         CALL HCOND3( AM0( I ), AM1( I ), AM2( I ),
     &                DV_SO4, ALPHSULF, CBAR_SO4, FCONC_OUT )
         FCONC_SO4( I, : ) = FCONC_OUT( : )
      END DO 

      IF ( .NOT. HYBRID ) THEN
         FCONC_SO4( N_MODE,1 ) = 0.0D0
         FCONC_SO4( N_MODE,2 ) = 0.0D0
      END IF

      DO I = 1, N_MODE
         GRFAC1( I ) = FCONC_SO4( I,1 )
         GRFAC2( I ) = FCONC_SO4( I,2 )
      END DO

C *** New Particle Production
C     Calculate the new particle production rate due to binary
C     nucleation of H2O and H2SO4.  These calculations are performed 
C     only when the gas-phase production rate of H2SO4 (i.e., SO4RATE) 
C     is non-zero.  The condensation rate of H2SO4 is calculated as the
C     gas-phase production rate minus the new particle production rate.

C *** Initialize Variables
      DMDT_SO4  = 0.0D0
      DNDT      = 0.0D0
      DM2DT     = 0.0D0
      SCONDRATE = 0.0D0


C *** Produce new particles only during time steps when the gas-phase 
C     production rate of H2SO4 is non-zero

      IF ( SO4RATE .NE. 0.0D0 ) THEN

C *** Adjust sulfuric acid vapor concentration to a value in
C     equilibrium with the production of new particles and the
C     condensation of sulfuric acid vapor on existing particles, based 
C     on Equations A21 and A23 of Binkowski & Shankar (1995).
         TMP = 0.0
         DO I = 1, N_MODE
            TMP = TMP + FCONC_SO4( I,2 )
         END DO

         XH2SO4 = SO4RATE / REAL( TMP,4 )
         XH2SO4 = MAX( XH2SO4, CONMIN )
         !PRECURSOR_CONC( SULF_IDX ) = REAL( XH2SO4, 8 )

#ifdef sens
         DO NP = 1, NPMAX
            IF ( XH2SO4 .EQ. CONMIN ) THEN
               S_PRECURSOR_CONC( SULF_IDX, NP ) = 0.D0
            ELSE
               S_PRECURSOR_CONC( SULF_IDX, NP ) = S_SO4RATE( NP ) / REAL(TMP,8)
            ENDIF
         END DO
#endif

C *** Calculate new particle production rate for 0th, 2nd, & 3rd moments
         CALL NEWPART3 ( AIRRH, AIRTEMP, XH2SO4, SO4RATE,
     &                   DNDT, DMDT_SO4, DM2DT )
         
C *** Calculate sulfate condensation rate as the gas-phase production 
C     rate minus the new particle production rate, following Equation
C     3.23 of Jiang & Roth (2003).
         SCONDRATE = MAX( SO4RATE - DMDT_SO4, 0.0D0 )

! *** Propagate NPF Change to budget variables
         NPF_BUDGET( PRECURSOR_MAP( SULF_IDX ) ) = -DMDT_SO4 
     &             * H2SO4RAT  * DELT ! ug m-3 of Sulfuric Acid
                                      ! (converted to ppmv in update_precursor)
         NPF_BUDGET( AEROSPC_MAP( ASO4_IDX,1 ) ) =  DMDT_SO4 * DELT ! ug m-3
         NPF_BUDGET( AERONUM_MAP( 1 ) ) =  DNDT * DELT  ! N m-3
         NPF_BUDGET( AEROSRF_MAP( 1 ) ) =  DM2DT * DELT ! m2 m-3

      END IF   ! SO4RATE .NE. 0

C *** Sulfate Condensation (Size-resolved)
C     Calculate rate at which condensing sulfate should be added to each
C     mode.  The "omega" factors are defined in Equations 7a and 7b of
C     Binkowski & Shankar (1995). The i-mode and j-mode factors are 
C     calculated using Equation A17 of Binkowski & Shankar (1995). The 
C     condensation rate for accumulation mode (fine-equilibrium scheme) or 
C     coarse mode (hybrid and dynamic schemes) is computed by difference, 
C     to avoid mass conservation violations arising from numerical error.
      TMP = 0.0
      DO I = 1, N_MODE
         TMP = TMP + FCONC_SO4( I,2 )
      END DO

      FCONCM1_SO4  = 1.0D0 / TMP
      OMEGA_AT_SO4 = FCONCM1_SO4 * FCONC_SO4( 1,2 )
      OMEGA_AC_SO4 = FCONCM1_SO4 * FCONC_SO4( 2,2 )

C *** Growth values for mode merge condition
      CGR( 1 ) = SO4FAC * SCONDRATE * OMEGA_AT_SO4
      CGR( 2 ) = SO4FAC * SCONDRATE * OMEGA_AC_SO4

! *** Initialize Budget Counter Variables         
      CBUDGET0_NUM( : ) = REAL( MOMENT0_CONC( : ), 8)
      CBUDGET0_NUM( 1 ) = CBUDGET0_NUM( 1 ) + DNDT * DELT
      CBUDGET0_SRF( : ) = MOMENT2_CONC( : ) * PI
      CBUDGET0_SRF( 1 ) = CBUDGET0_SRF( 1 ) + DM2DT * DELT * PI
      CBUDGET0_SO4( : ) = AEROSPC_CONC( ASO4_IDX, : )
      CBUDGET0_SO4( 1 ) = CBUDGET0_SO4( 1 ) + DMDT_SO4 * DELT
      CBUDGET0_NO3( : ) = REAL( AEROSPC_CONC( ANO3_IDX, : ), 8)
      CBUDGET0_NH4( : ) = REAL( AEROSPC_CONC( ANH4_IDX, : ), 8)
      CBUDGET0_CL ( : ) = REAL( AEROSPC_CONC( ACL_IDX , : ), 8)
      CBUDGET0_H2O( : ) = REAL( AEROSPC_CONC( AH2O_IDX, : ), 8)
      CBUDGET0_H3OP( : )= REAL( AEROSPC_CONC( AH3OP_IDX, : ), 8)

! *** Diagnose Condensaiton Sink to Each Mode
      CONDSO4( 1 ) = OMEGA_AT_SO4 * SCONDRATE      
      
      IF ( HYBRID ) THEN 
         CONDSO4( 2 ) = OMEGA_AC_SO4 * SCONDRATE      
         CONDSO4( 3 ) = SCONDRATE - ( CONDSO4( 1 ) + CONDSO4( 2 ) ) 
      ELSE                                  ! fine equilibrium
         CONDSO4( 2 ) = SCONDRATE - CONDSO4( 1 )
         CONDSO4( 3 ) = 0.0D0               ! no coarse mode chemistry
      END IF

C *** For Hybrid approach, calculate dynamic mass trasfer for
C     semi-volatile components of coarse mode (NO3, CL, NH4)  

      IF ( HYBRID ) THEN 

         CNTRL( 1 ) = 1.0D0 ! reverse problem
         CNTRL( 2 ) = 1.0D0 ! aerosol in metastable state

         INT_TIME = 0.0D0
         TSTEP    = 90.0D0
         ISTEP    = 1
         IMODE    = 3
         TrustIso = .TRUE.
 
         DO WHILE ( INT_TIME .LT. DELT ) 

            IF ( INT_TIME + TSTEP .GT. DELT ) TSTEP = DELT - INT_TIME 
            INT_TIME = INT_TIME + TSTEP 
            ISTEP = ISTEP + 1   

C *** Calculate first moments using Equation 4 of Binkowski & Shankar
C     (1995) or Equation 3 of Binkowski and Roselle (2003).
C     N.B: these are for a "wet" size distribution
            AM0( IMODE ) = MOMENT0_CONC( IMODE )
            AM1( IMODE ) = MOMENT0_CONC( IMODE ) * AEROMODE_DIAM( IMODE )
     &                  * EXP( 0.5 * AEROMODE_LNSG( IMODE ) * AEROMODE_LNSG( IMODE ) )
            AM2( IMODE ) = MOMENT2_CONC( IMODE )

C *** Calculate the size-dependent terms in the condensational-
C     growth factor expressions for sulfate using 
C     Equations A13-A14 of Binkowski & Shankar (1995). 
            CALL HCOND3( AM0( IMODE ), AM1( IMODE ), AM2( IMODE ), DV_SO4, ALPHSULF, 
     &                      CBAR_SO4, FCONC_OUT )  ! adapted from Eq A14
            FCONC_SO4( IMODE, : ) = FCONC_OUT( : )

            GRFAC1( IMODE ) = FCONC_SO4( IMODE,1 ) 
            GRFAC2( IMODE ) = FCONC_SO4( IMODE,2 ) 

C *** Set conc array to aerosol concentrations prior to mass transfer
C     (The _RENORM and cation_FAC constants are set in the AERO_DATA module)

            SEACAT    = REAL( AEROSPC_CONC( ASEACAT_IDX,IMODE ), 8 )              
            SOILwVOLS = REAL( AEROSPC_CONC( ASOIL_IDX,IMODE ), 8 ) / ASOIL_RENORM 
            PMCwVOLS  = REAL( AEROSPC_CONC( ACORS_IDX,IMODE ), 8 ) / ACORSEM_RENORM 

            CINORG( KNH4,IMODE ) = REAL( AEROSPC_CONC( ANH4_IDX,IMODE ), 8 )  ! KNH4 = 1, ANH4_IDX = 4
            CINORG( KNO3,IMODE ) = REAL( AEROSPC_CONC( ANO3_IDX,IMODE ), 8 )  ! KNO3 = 2, ANO3_IDX = 2
            CINORG( KCL, IMODE ) = REAL( AEROSPC_CONC( ACL_IDX,IMODE ), 8 )   ! KCL = 3, ACL_IDX = 3
            CINORG( KSO4,IMODE ) = REAL( AEROSPC_CONC( ASO4_IDX,IMODE ), 8 )  ! KSO4 = 4, ASO4_IDX = 1
            CINORG( KNA, IMODE ) = ASCAT_NA_FAC * SEACAT                      ! KNA = 5
     &                           + ASOIL_NA_FAC * SOILwVOLS
     &                           + ACORS_NA_FAC * PMCwVOLS
            CINORG( KMG, IMODE ) = ASCAT_MG_FAC * SEACAT                      ! KMG = 6
     &                           + ASOIL_MG_FAC * SOILwVOLS
     &                           + ACORS_MG_FAC * PMCwVOLS
            CINORG( KK,  IMODE ) = ASCAT_K_FAC  * SEACAT                      ! KK = 7
     &                           + ASOIL_K_FAC  * SOILwVOLS
     &                           + ACORS_K_FAC  * PMCwVOLS
            CINORG( KCA, IMODE ) = ASCAT_CA_FAC * SEACAT                      ! KCA = 8
     &                           + ASOIL_CA_FAC * SOILwVOLS
     &                           + ACORS_CA_FAC * PMCwVOLS
            CINORG( KHP, IMODE ) = REAL( HPLUS( IMODE ), 8 )                  ! KHP = 9

            M3OTHR = SOILFAC * AEROSPC_CONC( ASOIL_IDX,IMODE )
     &             + ANTHFAC * AEROSPC_CONC( ACORS_IDX,IMODE )
            WETM3  = MOMENT3_CONC( IMODE )
            WETM2  = MOMENT2_CONC( IMODE )
            DRYM3  = WETM3 - REAL( H2OFAC * AEROSPC_CONC( AH2O_IDX, IMODE ), 8 )  ! Assume no SOA in coarse mode
            DRYM20 = WETM2 * ( DRYM3 / WETM3 ) ** D_TWOTHIRDS

C *** Initial vapor-phase concentrations [ug/m3]
            GNO3R8 = PRECURSOR_CONC( HNO3_IDX )
            GNH3R8 = PRECURSOR_CONC( NH3_IDX )
            GCLR8  = PRECURSOR_CONC( HCL_IDX )

C *** Compute sulfate production rate [ug/m3 s] for coarse mode

            RATE = CONDSO4( IMODE )
            SO4  = CINORG( KSO4,IMODE ) + RATE * TSTEP * H2SO4RATM1

            IF ( TrustIso ) THEN

C *** Double Precision vars for ISORROPIA [mole/m3]
C              Compute equilibrium vapor pressures [mol/m3] of NH3, HNO3, and HCL
C              at the gas/particle interface of coarse mode aerosol.
C                 GAS(1) = NH3, GAS(2) = HNO3, GAS(3) = HCl
               WI( 1 ) = CINORG( KNA, IMODE ) * CFAC_ANA
               WI( 2 ) =                  SO4 * CFAC_ASO4
               WI( 3 ) = CINORG( KNH4,IMODE ) * CFAC_ANH4
               WI( 4 ) = CINORG( KNO3,IMODE ) * CFAC_ANO3
               WI( 5 ) = CINORG( KCL, IMODE ) * CFAC_ACL
               WI( 6 ) = CINORG( KCA, IMODE ) * CFAC_ACA
               WI( 7 ) = CINORG( KK,  IMODE ) * CFAC_AK
               WI( 8 ) = CINORG( KMG, IMODE ) * CFAC_AMG
C              Also obtain the aqueous H+ concentration, AERLIQ(1) [mol/m3]

#ifdef verbose_aero
         if ( write1 ) then
         write( logdev,'(a, 8e13.3)' ) "VOLINORG,WI's C:",
     &                                  wi( 1 ), wi( 2 ), wi( 3 ), wi( 4 ),
     &                                  wi( 5 ), wi( 6 ), wi( 7 ), wi( 8 )
         write( logdev,* ) "VOLINORG,RH,T:", rhi, tempi
         end if
#endif

               CALL ISOROPIA( WI, RHI, TEMPI, CNTRL, WT, GAS, AERLIQ,  
     &                        AERSLD, SCASI, OTHER )

               IF ( GAS( 1 ) .LT. 0.0D0 .OR. GAS( 2 ) .LT. 0.0D0 .OR.
     &              GAS( 3 ) .LT. 0.0D0 ) THEN
                  IF ( FIRSTWRITE ) THEN
                     FIRSTWRITE = .FALSE.
                     WRITE( LOGDEV,2023 )
                  END IF
                  WRITE( LOGDEV,2029 ) COL, ROW, LAYER, GAS( 1 ), GAS( 2 ), GAS( 3 )
                  TrustIso = .FALSE.
               END IF

            END IF   ! TrustIso

C *** Change in volatile inorganic PM concentration to achieve
C     equilibrium, calculated as initial-gas-phase concentration minus 
C     equilibrium gas-phase concentration.  DVOLINORG is positive for
C     condensation and negative for evaporation.

#ifdef verbose_aero
         if ( write1 ) then
         write( logdev,'(a, 3e13.3)' ) "GASes:", gas( 1 ), gas( 2 ), gas( 3 )

         dvolinorg( knh4 ) = gnh3r8 * CFAC_GNH3  - gas( 1 )  ! [mol/m**3]
         dvolinorg( kno3 ) = gno3r8 * CFAC_GHNO3 - gas( 2 )  ! [mol/m**3]
         dvolinorg( kcl )  = gclr8  * CFAC_GHCL  - gas( 3 )  ! [mol/m**3]
           
         write( logdev,'(a, 3e13.3)' ) "DVOLINORG_coarse:",
     &      dvolinorg( knh4 ) / ( gnh3r8 * CFAC_GNH3 ),
     &      dvolinorg( kno3 ) / ( gno3r8 * CFAC_GHNO3),
     &      dvolinorg( kcl )  / ( gclr8  * CFAC_GHCL )
         end if
#endif

C *** Calculate condensation/evaporation flux for this time step and update 
C     volatile species concentrations.  Final aerosol conc set to be no less
C     than the minimum aerosol conc.
            IF ( TrustIso ) THEN
               CALL COMPUTE_FLUX( NVOLINORG, GNH3R8, GNO3R8, GCLR8, KNH4,
     &                            KNO3, KCL, GAS( 1:3 ), GRFAC2( IMODE ),
     &                            AERLIQ( 1 ), RATE, J )
            ELSE
               J( : ) = 0.0D0
            END IF 

            IF ( J( KNH4 ) * TSTEP * DF( KNH4 ) * NH3RAT .GT. GNH3R8 ) THEN
               WRITE( LOGDEV,* ) 'Condensed amt. exceeds NH3 conc: aero_subs.f'
               J( KNH4 ) = GNH3R8 / ( TSTEP * DF( KNH4 ) * NH3RAT )
            END IF
            IF ( J( KNO3 ) * TSTEP * DF( KNO3 ) * HNO3RAT .GT. GNO3R8 ) THEN
               WRITE( LOGDEV,* ) 'Condensed amt. exceeds HNO3 conc: aero_subs.f'
               J( KNO3 ) = GNO3R8 / ( TSTEP * DF( KNO3 ) * HNO3RAT )
            END IF
            IF ( J( KCL ) * TSTEP * DF(KCL) * HCLRAT .GT. GCLR8 ) THEN
               WRITE( LOGDEV,* ) 'Condensed amt. exceeds HCl conc: aero_subs.f'
               J( KCL ) = GCLR8 / ( TSTEP * DF( KCL ) * HCLRAT )
            END IF

C *** Integrate mass transfer equation, convert flux from molar to mass

            DO ISP = 1, NVOLINORG
               CFINAL( ISP,IMODE ) = MAX( 0.0D0,
     &                                    CINORG( ISP,IMODE )
     &                                    + J( ISP ) * TSTEP * DF( ISP ) )
            END DO               

C *** Calculate updated H+ concentration 

            HPLUS( IMODE ) = 0.0
     &                     - AEROSPC( ASO4_IDX )%CHARGE * SO4                  / AEROSPC_MW( ASO4_IDX )
     &                     - AEROSPC( ANO3_IDX )%CHARGE * CFINAL( KNO3,IMODE ) / AEROSPC_MW( ANO3_IDX )
     &                     - AEROSPC( ACL_IDX )%CHARGE  * CFINAL( KCL, IMODE ) / AEROSPC_MW( ACL_IDX )
     &                     - AEROSPC( ANH4_IDX )%CHARGE * CFINAL( KNH4,IMODE ) / AEROSPC_MW( ANH4_IDX )
!    &                     - AEROSPC( ANA_IDX )%CHARGE  * CINORG( KNA, IMODE ) / AEROSPC_MW( ANA_IDX )
     &                     - AEROSPC( ASEACAT_IDX )%CHARGE  * CINORG( KNA, IMODE ) / AEROSPC_MW( ASEACAT_IDX )
     &                     - AEROSPC( AMG_IDX )%CHARGE  * CINORG( KMG, IMODE ) / AEROSPC_MW( AMG_IDX )
     &                     - AEROSPC( AK_IDX )%CHARGE   * CINORG( KK,  IMODE ) / AEROSPC_MW( AK_IDX )
     &                     - AEROSPC( ACA_IDX )%CHARGE  * CINORG( KCA, IMODE ) / AEROSPC_MW( ACA_IDX )

C *** Equilibrate aerosol LWC with CFINAL by calling CALC_H2O
            WI( 1 ) = CINORG( KNA, IMODE ) * CFAC_ASEACAT
            WI( 2 ) =                  SO4 * CFAC_ASO4
            WI( 3 ) = CFINAL( KNH4,IMODE ) * CFAC_ANH4
            WI( 4 ) = CFINAL( KNO3,IMODE ) * CFAC_ANO3
            WI( 5 ) = CFINAL( KCL, IMODE ) * CFAC_ACL
            WI( 6 ) = CINORG( KCA, IMODE ) * CFAC_ACA
            WI( 7 ) = CINORG( KK,  IMODE ) * CFAC_AK
            WI( 8 ) = CINORG( KMG, IMODE ) * CFAC_AMG

            CALL CALC_H2O( WI, RHI, TEMPI, H2O_NEW ) 

            H2O = H2O_NEW * DFH2OR8 


C *** Update all Local Aerosol Mass and Vapor Concentrations 
            !Aerosol
            AEROSPC_CONC( ANH4_IDX,IMODE ) = REAL( CFINAL( KNH4,IMODE ),4 )
            AEROSPC_CONC( ANO3_IDX,IMODE ) = REAL( CFINAL( KNO3,IMODE ),4 )
            AEROSPC_CONC( ACL_IDX,IMODE )  = REAL( CFINAL( KCL, IMODE ),4 )
            AEROSPC_CONC( ASO4_IDX,IMODE ) = REAL( SO4,4 )
            AEROSPC_CONC( AH2O_IDX,IMODE ) = REAL( H2O,4 )
            AEROSPC_CONC( AH3OP_IDX,IMODE )   = REAL( HPLUS( 3 ),4 ) * AEROSPC_MW( ah3op_idx ) ! Coarse mode H+ concentration in ug/m3

            !Gas
            PRECURSOR_CONC( NH3_IDX ) = GNH3R8 + ( CINORG( KNH4,IMODE )
     &                                 -CFINAL( KNH4,IMODE ) ) * NH3RAT 
            PRECURSOR_CONC( HNO3_IDX )= GNO3R8 + ( CINORG( KNO3,IMODE )
     &                                 -CFINAL( KNO3,IMODE) ) * HNO3RAT  
            PRECURSOR_CONC( HCL_IDX ) = GCLR8 + ( CINORG( KCL,IMODE )
     &                                 -CFINAL( KCL,IMODE) ) * HCLRAT 
 
C *** Compute net change in 3rd moment due to dry inorganic mass transfer

            DDRYM3DT = ( ( CFINAL( KNH4,IMODE ) - CINORG( KNH4,IMODE ) ) * M3FAC_ANH4
     &                 + ( CFINAL( KNO3,IMODE ) - CINORG( KNO3,IMODE ) ) * M3FAC_ANO3
     &                 + ( CFINAL( KCL, IMODE ) - CINORG( KCL,IMODE ) )  * M3FAC_ACL
     &                 + ( SO4                  - CINORG( KSO4,IMODE ) ) * M3FAC_ASO4 ) / TSTEP

C *** Compute net change in 2nd moment due to dry inorganic mass transfer
C     (including nucleation) using equation A7 of Binkowski & Shankar (1995)
            DDRYM2DT = D_TWOTHIRDS * GRFAC1( IMODE ) / GRFAC2( IMODE ) * DDRYM3DT   

C *** Update dry 2nd moment for condensation/evaporation based on whether
C     net change in dry 2nd moment is production or loss
            IF ( DDRYM2DT .LT. 0.0D0 ) THEN
               LOSS = DDRYM2DT / DRYM20
               Y = DRYM20 * EXP( LOSS * TSTEP )
            ELSE
               Y = DRYM20 + DDRYM2DT * TSTEP
            END IF

C *** Add water (no SOA) 2nd moment while preserving standard deviation

            !Calculate 3rd Moment
            DRYM3 = ( M3FAC_ASO4 ) * SO4
     &            + M3FAC_ANH4 * CFINAL( KNH4,IMODE )
     &            + M3FAC_ANO3 * CFINAL( KNO3,IMODE )
     &            + M3FAC_ACL  * CFINAL( KCL,IMODE )
     &            + M3FAC_ANA  * SEACAT
     &            + M3OTHR                   
            WETM3 = DRYM3 + H2O * M3FAC_H2O

            !Calculate 2nd moment
            DRYM2 = MAX( REAL( AEROMODE_MINM2( IMODE ), 8 ), Y )
            WETM2 = DRYM2 * ( WETM3 / DRYM3 ) ** D_TWOTHIRDS

            MOMENT2_CONC( IMODE ) = REAL( WETM2,4 )

C *** Update the third moments, geometric mean diameters, geometric 
C     standard deviations, modal mass totals, and modal particle 
C     densities. It is a waste of time updating the aitken and
C     accumulation modes but the coarse mode does need to be updated
C     each sub-time step. This should be for the wet distribution
               
            CALL GETPAR( .TRUE. )

         END DO   ! end mass transfer time step loop
         
      END IF   ! for 'Hybrid' method

      write1 = .false.
C *** End of Coarse Mode dynamic mass transfer calculations

C *** Fine Aerosol Modes: Call ISORROPIA in forward mode to calculate gas-particle equilibrium
      !Get Precursors Vapor concentrations [ug m-3]
      GNH3R8 = PRECURSOR_CONC( NH3_IDX )   
      GNO3R8 = PRECURSOR_CONC( HNO3_IDX )  
      GCLR8  = PRECURSOR_CONC( HCL_IDX )

C *** Diagnose all total gas+particle concentrations to passed to
C     ISORROPIA. Convert everything to [mol m-3].
      WI( 1 ) = SUM( AEROSPC_CONC( ANA_IDX,1:2 ))   * CFAC_ANA
      !Compute sulfate from total sulfate production rate [ug/m3-s] for fine 
      !modes; add in H2SO4 nucleated in model timestep
      WI( 2 ) = ( SUM( AEROSPC_CONC( ASO4_IDX,1:2 ) ) 
     &           +( DMDT_SO4 + SUM( CONDSO4( 1:2 ) ) ) * DELT * H2SO4RATM1 ) * CFAC_ASO4
      WI( 3 ) = PRECURSOR_CONC( NH3_IDX )  * CFAC_GNH3
     &         +SUM( AEROSPC_CONC( ANH4_IDX,1:2 ) ) * CFAC_ANH4 
      WI( 4 ) = PRECURSOR_CONC( HNO3_IDX ) * CFAC_GHNO3
     &         +SUM( AEROSPC_CONC( ANO3_IDX,1:2 ) ) * CFAC_ANO3 
      WI( 5 ) = PRECURSOR_CONC( HCL_IDX )  * CFAC_GHCL 
     &         +SUM( AEROSPC_CONC( ACL_IDX,1:2 ) )  * CFAC_ACL 
      WI( 6 ) = SUM( AEROSPC_CONC( ACA_IDX,1:2 ) )  * CFAC_ACA 
      WI( 7 ) = SUM( AEROSPC_CONC( AK_IDX,1:2 ) )   * CFAC_AK 
      WI( 8 ) = SUM( AEROSPC_CONC( AMG_IDX,1:2 ) )  * CFAC_AMG 

      CNTRL( 1 ) = 0.0D0   ! Forward Problem
      CNTRL( 2 ) = 1.0D0   ! Aerosol in Metastable State

C *** Set flags to account for mass conservation violations in ISRP3F
      TRUSTCL  = .TRUE.
      IF ( (WI( 1 ) + WI( 5 )) .LT. 1.0D-20 .or. WI( 5 ) .LT. 1.0D-10 ) THEN
         TRUSTCL = .FALSE.
      END IF
         
#ifndef noiso
      CALL ISOROPIA( WI, RHI, TEMPI, CNTRL, WT, GAS, AERLIQ,
     &               AERSLD, SCASI, OTHER )

#ifdef sens
      CALL AERO_SENS( SCASI, WI )
#endif

C *** Save H+ concentration information in microgram/m3 for consistency
      EQLBHIJ = AERLIQ(1) * 1.0D6 * AEROSPC_MW( ah3op_idx)

#else
      gas( 1 ) = real( precursor_conc( nh3_idx ),  8 ) * CFAC_GNH3
      gas( 2 ) = real( precursor_conc( hno3_idx ), 8 ) * CFAC_GHNO3
      gas( 3 ) = real( precursor_conc( hcl_idx ),  8 ) * CFAC_GHCL

      EQLBHIJ =  HPLUS( 1 ) + HPLUS( 2 )  ! use charge balance if lacking isoropia info 

#endif

C *** Change in volatile inorganic PM concentration to achieve
C     equilibrium, calculated as initial-gas-phase concentration minus 
C     equilibrium gas-phase concentration.  DVOLINORG is positive for
C     condensation and negative for evaporation.
      DVOLINORG( KNH4 ) = GNH3R8 * CFAC_GNH3  - GAS( 1 )   ! mol m-3
      DVOLINORG( KNO3 ) = GNO3R8 * CFAC_GHNO3 - GAS( 2 )   ! mol m-3
      DVOLINORG( KCL )  = GCLR8  * CFAC_GHCL  - GAS( 3 )   ! mol m-3

      IF ( DVOLINORG( KNH4 ) .LT. 0.0D0 ) THEN
         DVOLMAX = -SUM(REAL( AEROSPC_CONC( ANH4_IDX,1:2 ), 8 ) ) * CFAC_ANH4 + EVAPMIND
         DVOLINORG( KNH4 ) = MAX( DVOLINORG( KNH4 ), DVOLMAX )
      END IF

      IF ( DVOLINORG( KNO3 ) .LT. 0.0D0 ) THEN
         DVOLMAX = -SUM(REAL( AEROSPC_CONC( ANO3_IDX,1:2 ), 8 ) ) * CFAC_ANO3 + EVAPMIND
         DVOLINORG( KNO3 ) = MAX( DVOLINORG( KNO3 ), DVOLMAX)
      END IF

      IF ( .not.TRUSTCL ) THEN  
         DVOLINORG( KCL ) = 0.0D0
      ELSEIF ( DVOLINORG( KCL ) .LT. 0.0D0 ) THEN
         DVOLMAX = -SUM(REAL( AEROSPC_CONC( ACL_IDX,1:2 ), 8 ) ) * CFAC_ACL + EVAPMIND
         DVOLINORG( KCL ) = MAX( DVOLINORG( KCL ), DVOLMAX )
      END IF

C *** Apply modal partitioning of equilibrium aerosol mass
      ! Calculate Distribution of Mass Transfer Among Modes
      OMEGA( 1 ) = GRFAC2( 1 ) / ( GRFAC2( 1 ) + GRFAC2( 2 ) )
      OMEGA( 2 ) = 1.0D0 - OMEGA( 1 )

      ! Save Initial Concentrations
      DO IMODE = 1, 2  
         CINORG( KSO4,IMODE ) = AEROSPC_CONC( ASO4_IDX, IMODE )
         CINORG( KNH4,IMODE ) = AEROSPC_CONC( ANH4_IDX, IMODE )
         CINORG( KNO3,IMODE ) = AEROSPC_CONC( ANO3_IDX, IMODE )
         CINORG( KNA, IMODE ) = AEROSPC_CONC( ANA_IDX,  IMODE )
         CINORG( KCL, IMODE ) = AEROSPC_CONC( ACL_IDX,  IMODE )
         CINORG( KCA, IMODE ) = AEROSPC_CONC( ACA_IDX,  IMODE )
         CINORG( KK,  IMODE ) = AEROSPC_CONC( AK_IDX,   IMODE )
         CINORG( KMG, IMODE ) = AEROSPC_CONC( AMG_IDX,  IMODE )
      END DO

      ! Calculate Initial Distribution of Mass Composition Among Modes
      DO ISP = 1, NVOLINORG
         TOTAER( ISP ) = MAX( SUM( CINORG( ISP,1:2 ) ), CONMIND )
         DO IMODE = 1, 2
            PHI( ISP, IMODE ) = CINORG( ISP,IMODE ) / TOTAER( ISP )
         ENDDO
      ENDDO
      
      ! Initialize Final Concentrations
      CFINAL = 0.0

      ! Calculate Final Concentrations
      DO ISP = 1, NVOLINORG
         IF ( DVOLINORG( ISP ) .LT. 0.0 ) THEN
            ! Evaporate Mass Using Condensed-Phase Fraction in each Mode
            CFINAL( ISP,1:2 ) = CFINAL( ISP,1:2 ) + CINORG( ISP,1:2 )
     &                        + PHI( ISP,1:2 ) * DVOLINORG( ISP ) * DF( ISP )
         ELSE
            ! Condense Mass Using Condensation Sink Factors
            CFINAL( ISP,1:2 ) = CFINAL( ISP,1:2 ) + CINORG( ISP,1:2 )
     &                        + OMEGA( 1:2 ) * DVOLINORG( ISP ) * DF( ISP )
         END IF
      END DO
       
      
C *** Apply Final Concentrations to Moment Variables in Aerosol Scheme
      ! Store Initial Wet Moments
      M3WET_INIT( : ) = MOMENT3_CONC( : )
      M2WET_INIT( : ) = MOMENT2_CONC( : )

      ! Calculate and Store Initial Dry Moments and set wet_moments_flag to false/dry
      ! There has not yet been an update to AEROSPC_CONC so this will
      ! calculate the old 3rd moment.
      call calcmoments( .false. )
      M3DRY_INIT( : ) = MOMENT3_CONC( : )
      M2DRY_INIT( : ) = MOMENT2_CONC( : )

      DO IMODE = 1, 2  ! modal partitioning of equilibrium aerosol mass

         IF ( IMODE .EQ. 1 ) THEN
            ! Update Number Concentration with NPF
            MOMENT0_CONC( IMODE ) = REAL( AM0(IMODE) + DNDT * DELT, 4 )
            ! Add NPF to total condensation rate
            RATE = DMDT_SO4 + CONDSO4( IMODE )
            SO4 = CINORG( KSO4,IMODE ) + RATE * DELT * H2SO4RATM1 
         ELSE
            ! Ignore NPF. The small particles are not in these modes
            SO4 = CINORG( KSO4,IMODE ) + CONDSO4( IMODE ) * DELT * H2SO4RATM1
         END IF

         ! Double precision vars for CALC_H2O
         WI( 1 ) = CINORG( KNA, IMODE ) * CFAC_ANA
         WI( 2 ) =                  SO4 * CFAC_ASO4
         WI( 3 ) = CFINAL( KNH4,IMODE ) * CFAC_ANH4
         WI( 4 ) = CFINAL( KNO3,IMODE ) * CFAC_ANO3
         WI( 5 ) = CFINAL( KCL, IMODE ) * CFAC_ACL
         WI( 6 ) = CINORG( KCA, IMODE ) * CFAC_ACA
         WI( 7 ) = CINORG( KK,  IMODE ) * CFAC_AK
         WI( 8 ) = CINORG( KMG, IMODE ) * CFAC_AMG

         CALL CALC_H2O( WI, RHI, TEMPI, H2O_NEW ) 
         
         ! Update All Aerosol Concentrations
         AEROSPC_CONC( AH2O_IDX, IMODE ) = REAL( H2O_NEW * DFH2OR8, 4 )
         AEROSPC_CONC( ANH4_IDX, IMODE ) = REAL( CFINAL( KNH4,IMODE ),4 )
         AEROSPC_CONC( ANO3_IDX, IMODE ) = REAL( CFINAL( KNO3,IMODE ),4 )
         AEROSPC_CONC( ACL_IDX, IMODE )  = REAL( CFINAL( KCL ,IMODE ),4 )
         AEROSPC_CONC( ASO4_IDX, IMODE ) = REAL( SO4,4 )
          
         ! Calculate Uptake of PFAS Compounds
         DPFAS = 0.0
         GASCONV = AIRDENS * INV_MWAIR
         IF ( IMODE .EQ. 2 ) THEN
            ! Assign H+ Concentration to each Mode
            !HPLUS( 1:2 ) = 0.0
            !DO I = 1, N_AEROSPC
            !   IF(  AEROSPC( I )%tracer )CYCLE
            !   HPLUS( 1:2 ) = HPLUS( 1:2 )
     &      !                  - AEROSPC( I )%CHARGE * AEROSPC_CONC( I,1:2 ) / AEROSPC_MW( I )
            !END DO
            H2O = AEROSPC_CONC( AH2O_IDX, 1 ) + AEROSPC_CONC( AH2O_IDX, 2 )
            IF(  H2O .GT. CONMIN )THEN
                H2O = 1.0 / H2O
                AEROSPC_CONC( AH3OP_IDX, 1:2 ) = REAL( EQLBHIJ * H2O, 4 ) * AEROSPC_CONC( AH2O_IDX, 1:2 ) 
            ELSE
                AEROSPC_CONC( AH3OP_IDX, 1:2 ) = CONMIN
            END IF
 
            ! Calculate Environmental Conditions
            H2O = AEROSPC_CONC( AH2O_IDX, IMODE )

            ACIDITY = AEROSPC_CONC( AH3OP_IDX,IMODE ) * 1.0e3 / aerospc_mw( AH3OP_IDX ) / H2O

            ACIDITY = MAX ( ACIDITY, CONMIN ) 


            ! Calculate Total Organic Moles (this is non-PFAS
            ! compounds). PFAS compounds will partition into this
            ! medium and the aqueous phase
            COA = SUM( SUM( AEROSPC_CONC( :,1:2 ),2 )
     &                    * AEROSPC_MWINV(:), MASK = AEROSPC( : )%OM )
            IF ( AORGH2O_IDX .GT. 0 ) COA = COA + AEROSPC_CONC( AORGH2O_IDX,IMODE )
     &                                           *AEROSPC_MWINV( AORGH2O_IDX ) 
            TT1 = 298.0 / REAL( TEMPI, 4 )
            TT2 = 1.0 / 298.0 - 1.0 / REAL( TEMPI, 4 )

            ! Loop over PFAS compounds
            DO IPFAS = 1,NPFAS
               C = MAP_PFAStoAERO( IPFAS )
               K = MAP_PFAStoGAS( IPFAS )

               IF ( C .NE. 0 .AND. K .NE. 0 .AND. LPFAS_PARTITIONING ) THEN
                 ! Calculate Effective Henry's Law
                 HEFF = HLCONST( PFAS(IPFAS)%HLC, REAL(TEMPI,4), .TRUE., ACIDITY )

                 ! Calculate Temperature-Dependent Cstar
                 CSTAR = PFAS( IPFAS )%Cstar * TT1 * Exp( PFAS(IPFAS)%DHVAP * TT2 / RGASUNIV )

                 ! Calculate the Fraction of each PFAS in the aerosol
                 ! phase.
                 fPFAS_OrgPhase = ( 1.0 + CSTAR * AEROSPC_MWINV(C) / COA ) ** (-1)
                 fPFAS_AqsPhase =   2.45e-11 * H2O * HEFF / ( 1.0 + 2.45e-11 * H2O * HEFF )
                 fPFAS_OrgPhase = MIN( fPFAS_OrgPhase, 0.999 ) !force fraction to be less than 1
                 fPFAS_AqsPhase = MIN( fPFAS_AqsPhase, 0.999 ) !force fraction to be less than 1
                 fPFAS = 1.0 - min( ( 1.0 + fPFAS_OrgPhase / ( 1.0 - fPFAS_OrgPhase ) 
     &                                    + fPFAS_AqsPhase / ( 1.0 - fPFAS_AqsPhase )
     &                                )**(-1), 1.0 )    

                 ! Apply Gas-Particle Partitioning Estimation to
                 ! distribute mass between phases (ug m-3)
                 PFASTOT = AEROSPC_CONC( C,IMODE ) + PFASGAS_CONC( IPFAS )
                 PFASNEW = MAX( fPFAS * PFASTOT, CONMIN )  
                 DPFAS0 = PFASNEW - AEROSPC_CONC( C,IMODE )
                 IF ( .NOT. AEROSPC( C )%TRACER ) 
     &           DPFAS   = DPFAS + DPFAS0
!     &                DPFAS   = DPFAS + PFASNEW - AEROSPC_CONC( C,IMODE )
                                                  
                 AEROSPC_CONC( C,IMODE ) = PFASNEW
                 PFASGAS_CONC( IPFAS )   = MAX( PFASTOT - AEROSPC_CONC( C,IMODE ), CONMIN )

                 ! Add PFAS partitioning to process budget
                 COND_BUDGET( AEROSPC_MAP( MAP_PFAStoAERO( IPFAS ), IMODE ) ) = REAL( DPFAS0, 4 )
                 COND_BUDGET( MAP_PFAStoGAS( IPFAS ) ) = COND_BUDGET(MAP_PFAStoGAS( IPFAS )) 
     &                                                   + REAL(-DPFAS0, 4)
     &                                                   /GASCONV/AEROSPC_MW(C)

               END IF
            END DO
         END IF
 
C *** Compute net change in 3rd moment due to dry inorganic mass transfer
C     (includes nucleated sulfate mass). This is for projecting the
C     change to the second moment due to dry inorganic condensation
         
         DDRYM3DT = ( DPFAS * M3FAC_PFAS
     &              + ( CFINAL( KNH4,IMODE ) - CINORG( KNH4,IMODE ) ) * M3FAC_ANH4
     &              + ( CFINAL( KNO3,IMODE ) - CINORG( KNO3,IMODE ) ) * M3FAC_ANO3
     &              + ( CFINAL( KCL, IMODE ) - CINORG( KCL,IMODE ) )  * M3FAC_ACL
     &              + ( SO4                  - CINORG( KSO4,IMODE ) ) * M3FAC_ASO4 ) 
     &              / DELT 

C *** Compute net change in 2nd moment due to dry inorganic mass transfer
C     (including nucleation) using equation A7 of Binkowski & Shankar (1995)
         DDRYM2DT = D_TWOTHIRDS * GRFAC1( IMODE ) / GRFAC2( IMODE ) * DDRYM3DT

C *** Update dry 2nd moment for condensation/evaporation based on whether
C     net change in dry 2nd moment is production or loss
         IF ( DDRYM2DT .LT. 0.0D0 ) THEN
            LOSS = DDRYM2DT / M2DRY_INIT( IMODE )
            Y = M2DRY_INIT( IMODE ) * EXP( LOSS * DELT )
         ELSE
            Y = M2DRY_INIT( IMODE ) + DDRYM2DT * DELT
         END IF
         moment2_conc( IMODE ) = REAL( MAX( REAL( AEROMODE_MINM2( IMODE ), 8 ), Y ),4 )

      END DO

C *** Add water and SOA to 2nd moment while preserving standard deviation
      call calcmoments( .true. )
      M3WET_FINAL = moment3_conc
      M2WET_FINAL = moment2_conc


C *** Update the third moments, geometric mean diameters, geometric 
C     standard deviations, modal mass totals, and modal particle 
C     densities. Note that moment2_conc needs to be up to date when this
C     routine is called. Moment3_conc does not need to be up to date
C     because it will be recalculated inside GETPAR as the sum of 
C     aerospc_conc variables. This should be for the wet distribution.
      CALL GETPAR( .TRUE. )
       
! *** Propagate Concentration Changes from Coarse-Mode Mass
! *** Transfer to Budget Vectors
      DELNUM( : )  = MOMENT0_CONC( : ) - CBUDGET0_NUM( : )
      DELSRF( : )  = MOMENT2_CONC( : ) * PI - CBUDGET0_SRF( : )
      DELSO4( : )  = AEROSPC_CONC( ASO4_IDX, : ) - CBUDGET0_SO4( : )
      DELNH4( : )  = AEROSPC_CONC( ANH4_IDX, : ) - CBUDGET0_NH4( : )
      DELNO3( : )  = AEROSPC_CONC( ANO3_IDX, : ) - CBUDGET0_NO3( : )
      DELCL( : )   = AEROSPC_CONC( ACL_IDX , : ) - CBUDGET0_CL( : )
      DELH2O( : )  = AEROSPC_CONC( AH2O_IDX, : ) - CBUDGET0_H2O( : )
      DELH3OP( : ) = AEROSPC_CONC( AH3OP_IDX,: ) - CBUDGET0_H3OP( : )

      COND_BUDGET( AERONUM_MAP( : ) ) = REAL( DELNUM( : ), 4 )
      COND_BUDGET( AEROSRF_MAP( : ) ) = REAL( DELSRF( : ), 4 )
      COND_BUDGET( AEROSPC_MAP( ASO4_IDX,: ) ) = REAL( DELSO4( : ), 4 )
      COND_BUDGET( AEROSPC_MAP( ANH4_IDX,: ) ) = REAL( DELNH4( : ), 4 )
      COND_BUDGET( AEROSPC_MAP( ANO3_IDX,: ) ) = REAL( DELNO3( : ), 4 )
      COND_BUDGET( AEROSPC_MAP( ACL_IDX ,: ) ) = REAL( DELCL( : ) , 4 )
      COND_BUDGET( AEROSPC_MAP( AH2O_IDX,: ) ) = REAL( DELH2O( : ), 4 )
      COND_BUDGET( AEROSPC_MAP( AH3OP_IDX,:) ) = REAL( DELH3OP( : ),4 )

      COND_BUDGET( PRECURSOR_MAP( SULF_IDX ) ) = SUM( REAL( -DELSO4(:) * H2SO4RAT, 4 ))
      COND_BUDGET( PRECURSOR_MAP( NH3_IDX  ) ) = SUM( REAL( -DELNH4(:) * NH3RAT  , 4 ))
      COND_BUDGET( PRECURSOR_MAP( HNO3_IDX ) ) = SUM( REAL( -DELNO3(:) * HNO3RAT , 4 ))
      COND_BUDGET( PRECURSOR_MAP( HCL_IDX  ) ) = SUM( REAL( -DELCL(:)  * HCLRAT  , 4 ))

 
C *** Update gas-phase concentrations from Aitken and Accumulation Mode Partitioning
      PRECURSOR_CONC( SULF_IDX ) = PRECURSOR_CONC( SULF_IDX )
     &                            +SUM( -DELSO4(:) * H2SO4RAT )
      PRECURSOR_CONC( NH3_IDX )  = GNH3R8 + sum( CINORG( KNH4,1:2 )
     &                            -CFINAL( KNH4,1:2 ) ) * NH3RAT 
      PRECURSOR_CONC( HNO3_IDX ) = GNO3R8 + sum( CINORG( KNO3,1:2 )
     &                            -CFINAL( KNO3,1:2) ) * HNO3RAT  
      PRECURSOR_CONC( HCL_IDX )  = GCLR8 + sum( CINORG( KCL,1:2 )
     &                            -CFINAL( KCL,1:2) ) * HCLRAT 

2023  FORMAT( 1X, 'VOLINORG returning negative gas concentrations from ISOROPIA:'
     &       /10X, 'GAS(1) = NH3, GAS(2) = HNO3, GAS(3) = HCl' )
2029  FORMAT( 1X, '[see VOLINORG msg]'
     &        1X, 'at (C,R,L): ', 3I4, 1X, 'GAS Conc:', 3( 1PE11.3 ) )

      RETURN
      END SUBROUTINE VOLINORG

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HCOND3( AM0, AM1, AM2, DV, ALPHA, CBAR, F )

C  calculates the size-dependent term in the condensational-growth rate
C  expression for the 2nd and 3rd moments of a lognormal aerosol mode
C  using the harmonic mean method.  This code follows Section A2 of
C  Binkowski & Shankar (1995).
 
C  Key Subroutines/Functions called:  none
 
C  Revision History:
C     coded November 7, 2003 by Dr. Francis S. Binkowski
C     Revised November 20, 2003 by F. Binkowski to have am1 and
C     am2 as inputs
 
C  Reference:
C   1. Binkowski, F.S. and U. Shankar, The regional particulate matter
C      model 1. Model description and preliminary results, J. Geophys.
C      Res., Vol 100, No D12, 26101-26209, 1995.

      USE CONST
      IMPLICIT NONE

C *** Arguments:

      REAL( 8 ), INTENT( IN ) :: AM0   ! zeroth moment of mode  [ #/m**3 ]
      REAL( 8 ), INTENT( IN ) :: AM1   ! first moment of mode   [ m/m**3 ]
      REAL( 8 ), INTENT( IN ) :: AM2   ! second moment of mode  [ m**2/m**3 ]
      REAL,      INTENT( IN ) :: Dv    ! molecular diffusivity of the
                                       ! condensing vapor  [ m**2/s ]
      REAL,      INTENT( IN ) :: ALPHA ! accommodation coefficient
      REAL,      INTENT( IN ) :: CBAR  ! kinetic velocity of condensing vapor [ m/s ]

      REAL( 8 ), INTENT( OUT ) :: F( 2 ) ! size-dependent term in condensational-growth
                                         ! rate: F(1) = 2nd moment [ m**2/m**3 s ]
                                         !       F(2) = 3rd moment [ m**3/m**3 s ]

C *** Local Variables:

      REAL( 8 ) :: GNC2 ! integrals used to calculate F(1) [m^2 / m^3 s]
      REAL( 8 ) :: GFM2 !

      REAL( 8 ) :: GNC3 ! integrals used to calculate F(2) [m^3 / m^3 s]
      REAL( 8 ) :: GFM3 !

      REAL( 8 ), PARAMETER :: TWOPI = 2.0D0 * PI
      REAL( 8 ), PARAMETER :: PI4 = 0.25D0 * PI

C-----------------------------------------------------------------------

C *** Implement equation A15 of Binkowski & Shankar (1995) for the
C     2nd and 3rd moments of a lognormal mode of arbitrary size.

      GNC2 = TWOPI * DV * AM0          ! 2nd moment, near-continuum
      GNC3 = TWOPI * DV * AM1          ! 3rd moment, near-continuum
      GFM2 = PI4 * ALPHA * CBAR * AM1  ! 2nd moment, free-molecular
      GFM3 = PI4 * ALPHA * CBAR * AM2  ! 3rd moment, free-molecular

C *** Implement equation A13 of Binkowski & Shankar (1995) for a
C     lognormal mode of arbitrary size.  These are the size-dependent
C     terms in the condensational-growth rate expression, given in
C     equation 7a of B&S (1995).

      F( 1 ) = GNC2 * GFM2 / ( GNC2 + GFM2 )  ! 2nd moment
      F( 2 ) = GNC3 * GFM3 / ( GNC3 + GFM3 )  ! 3rd moment

      RETURN
      END SUBROUTINE HCOND3

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE NEWPART3 ( RH, T, XH2SO4, SO4RATE, DNDT, DMDT_so4, DM2DT )

      USE AERO_DATA
      USE CONST
      USE PRECURSOR_DATA, ONLY: PRECURSOR_MW, SULF_IDX
      USE UTILIO_DEFN
      
      IMPLICIT NONE

C   REVISION HISTORY:
C     Replacement of Kulmala et al., 1998 nucleation scheme with scheme 
C     of Vehkamaki et al. (2002) by G. Sarwar and K. Fahey - 03/2014

C.. References:
C     Vehkamaki, H., Kulmala, M, Napari, I., Lehtinen, K.E.J., Timmreck, C.,
C     Noppel, M., and A. Laaksonen. (2002) An improved parameterization for 
C     sulfuric acid-water nucleation rates for tropospheric and stratospheric
C     conditions.  JGR, v107(D22).    
   
C..Inputs: 
      REAL, INTENT(IN ) :: RH              ! fractional relative humidity      
      REAL, INTENT(IN)  :: T               ! Ambient temperature [ K ]
      REAL, INTENT(IN)  :: XH2SO4          ! sulfuric acid concentration [ ug/m**3 ]
      REAL, INTENT(IN)  :: SO4RATE         ! gas-phase H2SO4 production rate [ ug/m**3 s ]

C.. Outputs:
      REAL( 8 ), INTENT( OUT ) :: DNDT     ! particle number production rate [ m^-3/s ]
      REAL( 8 ), INTENT( OUT ) :: DMDT_so4 ! SO4 mass production rate [ ug/m**3 s ]
      REAL( 8 ), INTENT( OUT ) :: DM2DT    ! second moment production rate [ m**2/m**3 s ]

C.. Parameters
      CHARACTER( 16 ), PARAMETER :: PNAME = 'NEWPART'                 

C.. Particle size parameters:
      REAL, PARAMETER :: d20 = 2.0E-07                ! diameter of a new particle [cm]
      REAL, PARAMETER :: d20sq = d20 * d20            ! new-particle diameter squared [cm**2]
      REAL, PARAMETER :: m2_20 = 1.0E-4 * d20sq       ! new-particle diameter squared [m**2]
      REAL, PARAMETER :: v20 = PI * d20 * d20sq /6.0  ! volume of a new particle [cm**3]
      
      REAL( 8 )       :: sulfmass                     ! mass of a new particle [ug]
      REAL( 8 )       :: sulfmass1                    ! inverse of sulfmass [ug**-1]

C.. Set constants and local variables for Vehkamaki et al. (2002) scheme
      REAL, PARAMETER :: C1 = 0.740997
      REAL, PARAMETER :: C2 = -0.00266379
      REAL, PARAMETER :: C3 = -0.00349998
      REAL, PARAMETER :: C4 = 0.0000504022
      REAL, PARAMETER :: C5 = 0.00201048
      REAL, PARAMETER :: C6 = -0.000183289
      REAL, PARAMETER :: C7 = 0.00157407
      REAL, PARAMETER :: C8 = -0.0000179059
      REAL, PARAMETER :: C9 = 0.000184403
      REAL, PARAMETER :: C10 = -1.50345E-6

      REAL :: XSTAR           ! mole fraction of sulfuric acid in the critical cluster
      REAL :: NA              ! total gas phase concentration of H2SO4  [ #/cm**3 ]
      REAL :: TEMP            ! ambient temperature
      REAL :: LNRH, LNNA      ! LN(RH), LN(Na)
      REAL :: LNRH2, LNNA2    ! LN(RH)**2, LN(Na)**2
      REAL :: LNRH3, LNNA3    ! LN(RH)**3, LN(Na)**3  
      REAL :: TEMP2, TEMP3    ! TEMP**2, TEMP**3
      REAL( 8 ) :: XFAC       ! exponential term for the nucleation rate  
      REAL( 8 ) :: Jnuc       ! nucleation rate [ #/cm**3 s ]
      
      REAL :: A, B, C, D, E, F, G, H, I, J

      REAL :: MW_H2SO4        ! MW of H2SO4 in [ g / mole ]        
      REAL :: DENSITY_H2SO4   ! DENSITY of H2SO4 in [ kg / m**3 ]

      REAL, PARAMETER :: SCALEFAC = 1.0E-06           ! for [ 1 / m**3 ] ->  [ 1 / cm**3 ]
      REAL, PARAMETER :: MUG2G = 1.0E-6               ! [ ug  ] -> [ g ]                 

C.. Initialize variables
      DNDT     = 0.0D0
      DMDT_so4 = 0.0D0
      DM2DT    = 0.0D0

C.. Calculate molecular weight of H2SO4 [ g / mole ] 
      MW_H2SO4 = REAL( PRECURSOR_MW( SULF_IDX ),4 )
         
C.. Calculate density of sulfuric acid [ kg / m**3 ] 
      DENSITY_H2SO4 = AEROSPC( ASO4_IDX )%DENSITY           

C.. Calculate mass of a new particle [ug]
      sulfmass = 1.0D+3 * DENSITY_H2SO4 * v20

C.. Calculate inverse of sulfmass [ug**-1]      
      sulfmass1 = 1.0D0 / sulfmass   
     
C.. Calculate sulfuric acid concentration in molecules/cm3 
      NA = XH2SO4 * MUG2G * AVO * SCALEFAC / MW_H2SO4     

C.. The parameterization is valid at sulfuric acid concentrations of 1.0E4 - 1.0E11 molecules cm-3
      NA  = MAX (NA, 1.0E4)
      NA  = MIN (1.0E11, NA)

C.. The parameterization is valid at temperatures of 190.00-305.15 K
      TEMP = MAX (T, 190.00)
      TEMP = MIN (305.15, TEMP)

C.. The parameterization is valid at RH of 0.0001-1.0
C   aero_driver.f limits RH to 0.005-0.99; thus no additional constraint is needed

C.. Define convenient constants
      TEMP2 = TEMP * TEMP
      TEMP3 = TEMP * TEMP2
      
      LNRH = LOG( RH )  
      LNNA = LOG( NA )
      LNRH2 = LNRH * LNRH
      LNRH3 = LNRH * LNRH2
      LNNA2 = LNNA * LNNA
      LNNA3 = LNNA * LNNA2

C.. Calculate mole fraction of sulfuric acid in the critical cluster
      XSTAR = C1 + C2 * TEMP + C3 * LNNA + C4 * TEMP * LNNA + 
     &      C5 * LNRH + C6 * TEMP * LNRH +
     &      C7 * LNRH2 + C8 * TEMP * LNRH2 + C9 * LNRH3 + 
     &      C10 * TEMP * LNRH3

C.. Calculate coefficients needed for the nucleation rate [Eq-12 - Vehkamaki et al., 2002]           
      A = 0.14309 + 2.21956 * TEMP - 0.0273911 * TEMP2 + 
     &      0.0000722811 * TEMP3 + 5.91822 / XSTAR
     
      B = 0.117489 + 0.462532 * TEMP - 0.0118059 * TEMP2 + 
     &      0.0000404196 * TEMP3 + 15.7963 / XSTAR
     
      C = -0.215554 - 0.0810269 * TEMP + 0.00143581 * TEMP2 - 
     &      4.7758E-6 * TEMP3 - 2.91297 / XSTAR
     
      D = -3.58856 + 0.049508 * TEMP - 0.00021382 * TEMP2 + 
     &      3.10801E-7 * TEMP3 - 0.0293333 / XSTAR
     
      E = 1.14598 - 0.600796 * TEMP + 0.00864245 * TEMP2 - 
     &      0.0000228947 * TEMP3 - 8.44985 / XSTAR
     
      F = 2.15855 + 0.0808121 * TEMP - 0.000407382 * TEMP2 - 
     &      4.01957E-7 * TEMP3 + 0.721326 / XSTAR

      G = 1.6241 - 0.0160106 * TEMP + 0.0000377124 * TEMP2 + 
     &      3.21794E-8 * TEMP3 - 0.0113255 / XSTAR
      
      H = 9.71682 - 0.115048 * TEMP + 0.000157098 * TEMP2 + 
     &      4.00914E-7 * TEMP3 + 0.71186 / XSTAR
     
      I = -1.05611 + 0.00903378 * TEMP - 0.0000198417 * TEMP2 +
     &      2.46048E-8 * TEMP3 - 0.0579087 / XSTAR

      J = -0.148712 + 0.00283508 * TEMP - 9.24619E-6 * TEMP2 + 
     &      5.00427E-9 * TEMP3 - 0.0127081 / XSTAR

C.. Calculate the exponential term for the nucleation rate [Eq-12 - Vehkamaki et al., 2002] 
      XFAC = A + B * LNRH + C * LNRH2 + D * LNRH3 + 
     &      E * LNNA + F * LNRH * LNNA + G * LNRH2 * LNNA +     
     &      H * LNNA2 + I * LNRH * LNNA2 + J * LNNA3

C.. Calculate particle nucleation rate: unit [ 1 / cm**3 s] [Eq-12 - Vehkamaki et al., 2002] 
      Jnuc = EXP(XFAC)  
      
C.. The parameterization is valid for nucleation rates of 1.0E-7-1.0E10 [ 1 / cm**3 s]
      Jnuc = MAX (Jnuc, 1.0D-7)
      Jnuc = MIN (1.0D10, Jnuc)

C.. Convert the unit of particle nucleation rate into [ 1 / m**3 s] by multiplying it by 1.0E6  
       DNDT = Jnuc * 1.0E06  ! (1/(m**3 s))

C.. Calculate mass production rate [ ug / (m**3 s) ] analogous to
C   Equation 6a of Binkowski & Roselle (2003). Set the upper limit
C   of the mass production rate as the gas-phase production rate of
C   H2SO4, and adjust the number production rate accordingly.
      DMDT_so4 = sulfmass * DNDT 

      IF ( DMDT_so4 .GT. SO4RATE ) THEN
         DMDT_so4 = SO4RATE
         DNDT = DMDT_SO4 * sulfmass1
      END IF

C.. Calculate the production rate of 2nd moment [ m**2 / (m**3 s) ]
C   This is similar to Equation 6c of Binkowski & Roselle (2003),
C   except the factor of PI is removed and the assumed particle
C   diameter is different.
      DM2DT = DNDT * m2_20

      RETURN    
      END SUBROUTINE NEWPART3 

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE Compute_Flux ( nvolinorg, GNH3R8, GNO3R8, GCLR8, KNH4,
     &                          KNO3, KCL, Ceq, CondRate, Hplus, rate, J )
 
C Description
C   Determines the evaporative/condensational flux of volatile
C   inorganic species to aerosol modes. In cases where the resulting H+
C   flux is greater than a specified limit, the Pilinis et al. (2000)
C   AS&T approach is used to modify species vapor pressures such that
C   cond./evap. produces an H+ flux equal to the limit (which is
C   proportional to the current mode concentration of H+).
C   Routine called by VOLINORG.
 
C Arguments
C   Inputs
C     nvolinorg: Number of Volatile inorganic species
C     GNH3R8   : NH3(g) concentration (ug/m3)
C     GNO3R8   : HNO3(g) concentration (ug/m3)
C     GCLR8    : HCl(g) concentration (ug/m3)
C     KNH4     : Index to NH4 species
C     KNO3     : Index to NO3 species
C     KCL      : Index to NO3 species 
C     Ceq      : vapor concentration (mol/m3)
C     CondRate : effective condensation rate (I) of 3rd moment to mode
C              : [treat units as (1/s)]
C     Hplus    : aerosol hydrogen ion concentration (mol/m3) for mode
C     rate     : H2SO4(g) condensation rate (ug/m3/s) for mode
 
C   Output
C     Ceq      : modified vapor concentration (mol/m3)
C     J        : molar cond./evap. flux of volatile inorganics (mol/m3-s)
 
C-----------------------------------------------------------------------

      USE AERO_DATA
      USE PRECURSOR_DATA
!     USE AEROMET_DATA

      IMPLICIT NONE

C     Arguments:
      INTEGER      nvolinorg
      REAL( 8 ) :: GNH3R8, GNO3R8, GCLR8 ! gas concentrations [ug/m3]
      INTEGER      KNH4, KNO3, KCL       ! Indices to species
      REAL( 8 ) :: Ceq( nvolinorg )      ! vapor concentrations [mol/m3]
      REAL( 8 ) :: CondRate              ! effective condensation rate (I) for 3rd moment
      REAL( 8 ) :: Hplus                 ! hydrogen ion concentration for mode [mol/m3]
      REAL( 8 ) :: rate
      REAL( 8 ) :: J( nvolinorg )        ! molar cond./evap. flux [mol/m3-s]

C     Local Variables:
      REAL( 8 ),  PARAMETER :: Afact = 1.0D-01  ! factor for H+ limiter
      REAL( 8 ),  PARAMETER :: small = 1.0D-25
      REAL( 8 ) :: Cinf( nvolinorg ) ! gas concentration in mol/m3
      REAL( 8 ) :: Qk              ! factor for modifying vapor press. based on H+ limit
      REAL( 8 ) :: Hflux           ! flux of H+ to mode from cond/evap
      REAL( 8 ) :: Hlim            ! maximum allowable H+ flux to mode
      REAL( 8 ) :: aa, bb, cc      ! terms in quadratic equation
      REAL( 8 ) :: JH2SO4          ! molar flux of H2SO4(g) [mol/m3/s]
      REAL( 8 ) :: CH2SO4          ! effective H2SO4(g) concentration [mol/m3]
      INTEGER      isp             ! inorganic species index

C-----------------------------------------------------------------------

C     Convert gas concentration from ug/m3 to mol/m3
      Cinf( KNH4 ) = GNH3R8 * 1.0D-6 / PRECURSOR_MW( NH3_IDX )
      Cinf( KNO3 ) = GNO3R8 * 1.0D-6 / PRECURSOR_MW( HNO3_IDX )
      Cinf( KCL )  = GCLR8  * 1.0D-6 / PRECURSOR_MW( HCL_IDX )

C     Calculate cond/evap fluxes (no H+ limiting)
      DO isp = 1, nvolinorg
         J( isp ) = CondRate * ( Cinf( isp ) - Ceq( isp ) )
      END DO

C     Convert rate to mol/m3/s and get effective Cinf for H2SO4(g)
      JH2SO4  = rate * 1.0D-6 / PRECURSOR_MW( SULPRD_IDX )
      CH2SO4  = JH2SO4 / CondRate

C     Limit H+ flux (Pilinis et al., 2000, AS&T). Note: J is flux
C     to entire mode, not one particle
      Hlim  = Afact * Hplus
      Hflux = 2.0D0 * JH2SO4 + J( KNO3 ) + J( KCL ) - J( KNH4 )

C     If Hflux is too large, limit the flux by modifying species
C     vapor pressures with Qk factor (Pilinis et al., 2000, AS&T).
      IF ( ABS( Hflux ) .GT. Hlim ) THEN
         Hlim = SIGN( Hlim, Hflux )

C        Solve quadratic for Qk: aa*Qk^2 + bb*Qk + cc = 0
         aa = Ceq( KCL ) + Ceq( KNO3 )

         bb = Hlim / CondRate
     &      + Cinf( KNH4) - Cinf( KNO3 ) - Cinf( KCL ) - 2.0D0 * CH2SO4
         cc = -Ceq( KNH4 )

         Qk = 0.0D0 ! initialize Qk

         IF ( aa .LT. small .AND. 0.0D0 .LT. bb ) THEN ! bb*Qk + cc = 0
            Qk = -cc / bb
         ELSE IF (aa .LT. small .AND. bb .LE. 0.0D0 ) THEN
            Qk = 0.0D0
         ELSE IF (-cc .LT. small .AND. bb .LT. 0.0D0 ) THEN  ! aa*Qk^2 + bb*Qk = 0
            Qk = -bb / aa
         ELSE IF (-cc .LT. small .AND. 0.0D0 .LE. bb ) THEN
            Qk = 0.0D0
         ELSE
            Qk = ( -bb + SQRT ( bb**2 - 4.0D0 * aa * cc ) ) / ( 2.0D0 * aa )
            IF ( bb ** 2 - 4.0D0 * aa * cc .LT. 0.0D0 ) THEN
               PRINT *, 'Compute_Flux, sqrt<0'
               Qk = 0.0D0
            END IF
         END IF

C     Modify vapor pressures and get new fluxes
         IF ( Qk .GT. small ) THEN
            Ceq( KNH4 ) = Ceq( KNH4 ) / Qk
            Ceq( KNO3 ) = Ceq( KNO3 ) * Qk
            Ceq( KCl )  = Ceq( KCl )  * Qk
            DO isp = 1, nvolinorg
               J( isp ) = CondRate * ( Cinf( isp ) - Ceq( isp ) )
            END DO
         END IF

      END IF   ! |Hflux| > Hlim

      END SUBROUTINE Compute_Flux

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CALC_H2O ( WI, RH, T, H2O_NEW )

C Description
C   Calculate the water content of aerosol at the new time step.  Water
C   calculations use the ZSR mixing rule with salts determined by the
C   ISORROPIA approach.
C   Routine called by VOLINORG.
 
C Arguments
C   Input
C     WI      : Concentration of components [mol/m^3] at new step
C     RH      : Relative humidity [0-1]
C     T       : Temperature [K]
 
C   Output
C     H2O_NEW : Water [mol/m^3] content at new time step
 
C-----------------------------------------------------------------------

      IMPLICIT NONE

C Parameters:
      INTEGER, PARAMETER :: NCMP = 8, NPAIR = 23
      REAL( 8 ),  PARAMETER :: SMALL = 1.0D-20
      REAL( 8 ),  PARAMETER :: Mw = 0.018D0   ! molar mass H2O (kg/mol)

C Arguments:
      REAL( 8 ), INTENT( IN )  :: WI( NCMP )
      REAL( 8 ), INTENT( IN )  :: RH, T
      REAL( 8 ), INTENT( OUT ) :: H2O_NEW

C Local Variables:
      CHARACTER( 3 ) :: SC ! subcase for composition
      REAL( 8 ) :: FSO4, FNH4, FNA, FNO3, FCL ! "free" ion amounts
      REAL( 8 ) :: FCA, FK, FMG            
      REAL( 8 ) :: CASO4         ! amount of calcium sulfate, does not participate in ZSR calc
      REAL( 8 ) :: WATER         ! kg of water for new time step 
      REAL( 8 ) :: X, Y
      REAL( 8 ) :: CONC( NCMP )    ! concentration (mol/m^3)
      REAL( 8 ) :: CONCR( NPAIR )  ! concentration (mol/m^3) ion "pairs" 
      REAL( 8 ) :: M0I( NPAIR )    ! single-solute molalities
      INTEGER :: J

C-----------------------------------------------------------------------

C     Return if small concentration
      IF ( WI( 1 ) + WI( 2 ) + WI( 3 ) + WI( 4 )
     &   + WI( 5 ) + WI( 6 ) + WI( 7 ) + WI( 8 ) .LE. SMALL) THEN
         H2O_NEW = SMALL
         RETURN
      END IF

C     Set component array (mol/m^3) for determining salts
      CONC = WI   ! array assignment

C     Get the sub-case to use in determining salts
      CALL GETSC ( CONC, RH, T, SC )

#ifdef verbose_aero
!     write( logdev,* ) 'CALC_H2O -SC: ', sc
#endif

C     Initialize ion "pairs" (i.e., salts) used in ZSR
      CONCR( : ) = 0.0D0

C     Depending on case, determine moles of salts in solution (i.e., CONCR)
C     for ZSR calculation below

      IF ( SC .EQ. 'S2' ) THEN    ! sulfate poor (NH4-SO4 system), old K2
         CONCR( 4 )= MIN ( CONC( 2 ), 0.5D0 * CONC( 3 ) )  ! (NH4)2SO4

      ELSE IF ( SC .EQ. 'B4' ) THEN  ! sulfate rich (no acid), old L4, O4
         X = 2.0D0 * CONC( 2 ) - CONC( 3 )     ! 2SO4 - NH4
         Y = CONC( 3 ) - CONC( 2 )            ! NH4 - SO4
         IF ( X .LE. Y ) THEN
            CONCR( 13 ) = X      ! (NH4)3H(SO4)2 is MIN (X,Y)
            CONCR(  4 ) = Y - X  ! (NH4)2SO4
         ELSE
            CONCR( 13 ) = Y      ! (NH4)3H(SO4)2 is MIN (X,Y)
            CONCR(  9 ) = X - Y  ! NH4HSO4
         END IF

      ELSE IF ( SC .EQ. 'C2' ) THEN  ! sulfate rich (free acid), old M2, P2
         CONCR( 9 ) = CONC( 3 )                      ! NH4HSO4
         CONCR( 7 ) = MAX( CONC( 2 ) - CONC( 3 ), 0.0D0 )   ! H2SO4

      ELSE IF ( SC .EQ. 'N3' ) THEN    ! sulfate poor (NH4-SO4-NO3 system)
         CONCR( 4 ) = MIN ( CONC( 2 ), 0.5D0 * CONC( 3 ) )           ! (NH4)2SO4
         FNH4       = MAX ( CONC( 3 ) - 2.0D0 * CONCR( 4 ), 0.0D0 )  ! available NH4
         CONCR( 5 ) = MAX ( MIN ( FNH4, CONC( 4 ) ), 0.0D0 )         ! NH4NO3=MIN(NH4,NO3)

      ELSE IF ( SC .EQ. 'Q5' ) THEN    ! sulfate poor, sodium poor (NH4-SO4-NO3-Cl-Na)
         CONCR( 2 ) = 0.5D0 * CONC( 1 )                              ! Na2SO4
         FSO4       = MAX ( CONC( 2 ) - CONCR( 2 ), 0.0D0 )          ! available SO4
         CONCR( 4 ) = MAX ( MIN ( FSO4, 0.5D0 * CONC( 3 ) ), SMALL ) ! NH42S4=MIN(NH4,S4)
         FNH4       = MAX ( CONC( 3 ) - 2.0D0 * CONCR( 4 ), 0.0D0 )  ! available NH4
         CONCR( 5 ) = MIN ( FNH4, CONC( 4 ) )                        ! NH4NO3=MIN(NH4,NO3)
         FNH4       = MAX ( FNH4 - CONCR( 5 ), 0.0D0 )               ! avaialable NH4
         CONCR( 6 ) = MIN ( FNH4, CONC( 5 ) )                        ! NH4Cl=MIN(NH4,Cl)

      ELSE IF ( SC .EQ. 'R6' ) THEN   ! sulfate poor, sodium rich (NH4-SO4-NO3-Cl-Na)
         CONCR( 2 ) = CONC( 2 )                            ! Na2SO4
         FNA        = MAX ( CONC( 1 ) - 2.0D0 * CONCR( 2 ), 0.0D0 )

         CONCR( 3 ) = MIN ( FNA, CONC( 4 ) )               ! NaNO3
         FNO3       = MAX ( CONC( 4 ) - CONCR( 3 ), 0.0D0 )
         FNA        = MAX ( FNA - CONCR( 3 ), 0.0D0 )

         CONCR( 1 ) = MIN ( FNA, CONC( 5 ) )               ! NaCl
         FCL        = MAX ( CONC( 5 ) - CONCR( 1 ), 0.0D0 )
         FNA        = MAX ( FNA - CONCR( 1 ), 0.0D0 )

         CONCR( 5 ) = MIN ( FNO3, CONC( 3 ) )              ! NH4NO3
         FNO3       = MAX ( FNO3 - CONCR( 5 ), 0.0D0 )
         FNH4       = MAX ( CONC( 3 ) - CONCR( 5 ), 0.0D0 )

         CONCR( 6 ) = MIN (FCL, FNH4 )                     ! NH4Cl

      ELSE IF ( SC .EQ. 'I6' ) THEN   ! sulfate rich (no acid) (NH4-SO4-NO3-Cl-Na)
         CONCR(  2 ) = 0.5D0 * CONC( 1 )                          ! Na2SO4
         FSO4        = MAX ( CONC( 2 ) - CONCR( 2 ), 0.0D0 )
         CONCR( 13 ) = MIN ( CONC( 3 ) / 3.0D0, FSO4 / 2.0D0 )    ! (NH4)3H(SO4)2
         FSO4        = MAX ( FSO4 - 2.0D0 * CONCR( 13 ), 0.0D0 )
         FNH4        = MAX ( CONC( 3 ) - 3.0D0 * CONCR( 13 ), 0.0D0 )

         IF ( FSO4 .LE. SMALL ) THEN    ! reduce (NH4)3H(SO4)2, add (NH4)2SO4
            CONCR( 13 ) = MAX ( CONCR( 13 ) - FNH4, 0.0D0 )   ! (NH4)3H(SO4)2
            CONCR(  4 ) = 2.0D0 * FNH4                  ! (NH4)2SO4
         ELSE IF ( FNH4 .LE. SMALL ) THEN ! reduce (NH4)3H(SO4)2, add NH4HSO4
            CONCR(  9 ) = 3.0D0 * MIN ( FSO4, CONCR( 13 ) ) ! NH4HSO4
            CONCR( 13 ) = MAX ( CONCR( 13 ) - FSO4, 0.0D0 )
            IF ( CONCR( 2 ) .GT. SMALL ) THEN ! reduce Na2SO4, add NaHSO4
               FSO4        = MAX ( FSO4 - CONCR( 9 ) / 3.0D0, 0.0D0 )
               CONCR( 12 ) = 2.0D0 * FSO4                ! NaHSO4
               CONCR(  2 ) = MAX ( CONCR( 2 ) - FSO4, 0.0D0 )  ! Na2SO4
             END IF
         END IF

      ELSE IF ( SC .EQ. 'J3' ) THEN   ! sulfate rich (free acid) (NH4-SO4-NO3-Cl-Na)
         CONCR(  9 ) = CONC( 3 )                             ! NH4HSO4
         CONCR( 12 ) = CONC( 1 )                             ! NAHSO4
         CONCR(  7 ) = MAX ( CONC( 2 ) - CONC( 3 ) - CONC( 1 ), 0.0D0 ) ! H2SO4

      ! Crustal cases
      ELSE IF ( SC .EQ. 'V7' ) THEN  ! sulfate poor, sodium+crustal poor
         CASO4     = MIN ( CONC( 6 ), CONC( 2 ) )            ! CCASO4
         FSO4      = MAX ( CONC( 2 ) - CASO4, 0.0D0 )
         FCA       = MAX ( CONC( 6 ) - CASO4, 0.0D0 )

         CONCR( 17 ) = MIN ( 0.5D0 * CONC( 7 ), FSO4 )       ! CK2SO4
         FK          = MAX ( CONC( 7 ) - 2.D0 * CONCR( 17 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 17 ), 0.0D0 )

         CONCR( 2 )  = MIN ( 0.5D0 * CONC( 1 ), FSO4 )       ! CNA2SO4
         FNA         = MAX ( CONC( 1 ) - 2.0D0 * CONCR( 2 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 2 ), 0.0D0 )

         CONCR( 21 ) = MIN ( CONC( 8 ), FSO4 )               ! CMGSO4
         FMG         = MAX ( CONC( 8 ) - CONCR( 21 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 21 ), 0.0D0 )

         CONCR( 4 )  = MAX ( MIN ( FSO4 , 0.5D0 * CONC( 3 ) ) , SMALL ) ! CNH42S4
         FNH4        = MAX ( CONC( 3 ) - 2.0D0 * CONCR( 4 ), 0.0D0 )

         CONCR( 5 )  = MIN ( FNH4, CONC( 4 ) )               ! CNH4NO3
         FNH4        = MAX ( FNH4 - CONCR( 5 ), 0.0D0 )

         CONCR( 6 )  = MIN ( FNH4, CONC( 5 ) )               ! CNH4CL

      ELSE IF ( SC .EQ. 'U8' ) THEN  ! sulfate poor, crustal+sodium rich, crustal poor
         CASO4       = MIN ( CONC( 6 ), CONC( 2 ) )          ! CCASO4
         FSO4        = MAX ( CONC( 2 ) - CASO4, 0.0D0 )
         FCA         = MAX ( CONC( 6 ) - CASO4, 0.0D0 )

         CONCR( 17 ) = MIN ( 0.5D0 * CONC( 7 ), FSO4 )       ! CK2SO4
         FK          = MAX ( CONC( 7 ) - 2.0D0 * CONCR( 17 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 17 ), 0.0D0 )

         CONCR( 21 ) = MIN ( CONC( 8 ), FSO4 )               ! CMGSO4
         FMG         = MAX ( CONC( 8 ) - CONCR( 21 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 21 ), 0.0D0 )

         CONCR( 2 )  = MAX ( FSO4, 0.0D0 )                   ! CNA2SO4
         FNA         = MAX ( CONC( 1 ) - 2.0D0 * CONCR( 2 ), 0.0D0 )

         CONCR( 3 )  = MIN ( FNA, CONC( 4 ) )                ! NaNO3
         FNO3        = MAX ( CONC( 4 ) - CONCR( 3 ), 0.0D0 )
         FNA         = MAX ( FNA - CONCR( 3 ), 0.0D0 )

         CONCR( 1 )  = MIN ( FNA, CONC( 5 ) )                ! NaCl
         FCL         = MAX ( CONC( 5 ) - CONCR( 1 ), 0.0D0 )
         FNA         = MAX ( FNA - CONCR( 1 ), 0.0D0 )

         CONCR( 5 )  = MIN ( FNO3, CONC( 3 ) )               ! NH4NO3
         FNO3        = MAX ( FNO3 - CONCR( 5 ), 0.0D0 )
         FNH4        = MAX ( CONC( 3 ) - CONCR( 5 ), 0.0D0 )

         CONCR( 6 )  = MIN ( FCL, FNH4 )                     ! NH4Cl
         FCL         = MAX ( FCL - CONCR( 6 ), 0.0D0 )
         FNH4        = MAX ( FNH4 - CONCR( 6 ), 0.0D0 )

      ELSE IF ( SC .EQ. 'W13' ) THEN  ! sulfate poor, crustal+sodium rich
         CASO4       = MIN ( CONC( 2 ), CONC( 6 ) )          ! CASO4
         FCA         = MAX ( CONC( 6 ) - CASO4, 0.0D0 )
         FSO4        = MAX ( CONC( 2 ) - CASO4, 0.0D0 )

         CONCR( 17 ) = MIN ( FSO4, 0.5D0 * CONC( 7 ) )       ! K2SO4
         FK          = MAX ( CONC( 7 ) - 2.0D0 * CONCR( 17 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 17 ), 0.0D0 )

         CONCR( 21 ) = FSO4                                  ! MGSO4
         FMG         = MAX ( CONC( 8 ) - CONCR( 21 ), 0.0D0 )

         CONCR( 1 )  = MIN ( CONC( 1 ), CONC( 5 ) )          ! NACL
         FNA         = MAX ( CONC( 1 ) - CONCR( 1 ), 0.0D0 )
         FCL         = MAX ( CONC( 5 ) - CONCR( 1 ), 0.0D0 )

         CONCR( 16 ) = MIN ( FCA, 0.5D0 * FCL )              ! CACL2
         FCA         = MAX ( FCA - CONCR( 16 ), 0.0D0 )
         FCL         = MAX ( CONC( 5 ) - 2.0D0 * CONCR( 16 ), 0.0D0 )

         CONCR( 15 ) = MIN ( FCA, 0.5D0 * CONC( 4 ) )        ! CA(NO3)2
         FCA         = MAX ( FCA - CONCR( 15 ), 0.0D0 )
         FNO3        = MAX ( CONC( 4 ) - 2.0D0 * CONCR( 15 ), 0.0D0 )

         CONCR( 23 ) = MIN ( FMG, 0.5D0 * FCL )              ! MGCL2
         FMG         = MAX ( FMG - CONCR( 23 ), 0.0D0 )
         FCL         = MAX ( FCL - 2.0D0 * CONCR( 23 ), 0.0D0 )

         CONCR( 22 ) = MIN ( FMG, 0.5D0 * FNO3 )             ! MG(NO3)2
         FMG         = MAX ( FMG - CONCR( 22 ), 0.0D0 )
         FNO3        = MAX ( FNO3 - 2.0D0 * CONCR( 22 ), 0.0D0 )

         CONCR( 3 )  = MIN ( FNA, FNO3 )                     ! NANO3
         FNA         = MAX ( FNA - CONCR( 3 ), 0.0D0 )
         FNO3        = MAX ( FNO3 - CONCR( 3 ), 0.0D0 )

         CONCR( 20 ) = MIN ( FK, FCL )                       ! KCL
         FK          = MAX ( FK - CONCR( 20 ), 0.0D0 )
         FCL         = MAX ( FCL - CONCR( 20 ), 0.0D0 )

         CONCR( 19 ) = MIN ( FK, FNO3 )                      ! KNO3
         FK          = MAX ( FK - CONCR( 19 ), 0.0D0 )
         FNO3        = MAX ( FNO3 - CONCR( 19 ), 0.0D0 )

      ELSE IF ( SC .EQ. 'L9' ) THEN  ! sulfate rich, no free acid
         CASO4       = MIN ( CONC( 6 ), CONC( 2 ) )          ! CCASO4
         FSO4        = MAX ( CONC( 2 ) - CASO4, 0.0D0 )
         FCA         = MAX ( CONC( 6 ) - CASO4, 0.0D0 )

         CONCR( 17 ) = MIN ( 0.5D0 * CONC( 7 ), FSO4 )       ! CK2SO4
         FK          = MAX ( CONC( 7 ) - 2.0D0 * CONCR( 17 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 17 ), 0.0D0 )

         CONCR( 2 )  = MIN ( 0.5D0 * CONC( 1 ), FSO4 )       ! CNA2SO4
         FNA         = MAX ( CONC( 1 ) - 2.0D0 * CONCR( 2 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 2 ), 0.0D0 )

         CONCR( 21 ) = MIN ( CONC( 8 ), FSO4 )               ! CMGSO4
         FMG         = MAX ( CONC( 8 ) - CONCR( 21 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 21 ), 0.0D0 )

         CONCR( 13 ) = MIN ( CONC( 3 ) / 3.0D0, FSO4 / 2.0D0 ) ! CLC
         FSO4        = MAX ( FSO4 - 2.0D0 * CONCR( 13 ), 0.0D0 )
         FNH4        = MAX ( CONC( 3 )- 3.0D0 * CONCR( 13 ),  0.0D0 )

         IF ( FSO4 .LE. SMALL ) THEN                           ! convert (NH4)3H(SO4)2 to (NH4)2SO4
            CONCR( 13 ) = MAX( CONCR( 13 ) - FNH4, 0.0D0 )
            CONCR(  4 ) = 2.0D0 * FNH4                         ! CNH42S4 

         ELSE IF ( FNH4 .LE. SMALL ) THEN                      ! convert (NH4)3H(SO4)2 to NH4HSO4
            CONCR(  9 ) = 3.0D0 * MIN( FSO4, CONCR( 13 ) )     ! CNH4HS4
            CONCR( 13 ) = MAX( CONCR( 13 ) - FSO4, 0.0D0 )     ! CLC, (NH4)3H(SO4)2
            IF ( CONCR( 2 ) .GT. SMALL ) THEN                  ! convert Na2SO4 to NaHSO4
               FSO4        = MAX( FSO4 - CONCR( 9 ) / 3.0D0, 0.0D0 )
               CONCR( 12 ) = 2.0D0 * FSO4                      ! CNAHSO4
               CONCR(  2 ) = MAX( CONCR( 2 ) - FSO4, 0.0D0 )   ! CNA2SO4
            END IF
            IF ( CONCR( 17 ) .GT. SMALL ) THEN                 ! convert K2SO4 to KHSO4
               FSO4        = MAX( FSO4 - CONCR( 9 ) / 3.0D0, 0.0D0 )
               CONCR( 18 ) = 2.0D0 * FSO4                      ! CKHSO4
               CONCR( 17 ) = MAX( CONCR( 17 ) - FSO4, 0.0D0 )  ! CK2SO4
            END IF
         END IF
         
      ELSE IF ( SC .EQ. 'K4' ) THEN ! sulfate super rich, free acid
         CONCR(  9 ) = CONC( 3 )                               ! NH4HSO4 = NH3
         CONCR( 12 ) = CONC( 1 )                               ! NaHSO4  = Na
         CONCR( 18 ) = CONC( 7 )                               ! KHSO4   = K
         CONCR( 21 ) = CONC( 8 )                               ! MgSO4   = Mg
         CONCR(  7 ) = MAX( CONC( 2 ) - CONC( 3 ) - CONC( 1 )
     &                    - CONC( 6 ) - CONC( 7 ) - CONC( 8 ), 0.0D0 ) ! H2SO4 = SO4 - NH4 - Na - Ca - K - Mg

      ELSE
         PRINT*, 'aero_subs.f: case not supported ',
     &          '(metastable reverse only)'
      END IF

C     Get single-solute molalities for ZSR calculation
      CALL GETM0I ( RH, M0I )

C     Calculate H2O with ZSR and determine delta water
      WATER = 0.0D0
      DO J = 1, NPAIR
         WATER = WATER + CONCR( J ) / M0I( J )
      END DO

      WATER = MAX ( WATER, SMALL )
      H2O_NEW = WATER / Mw

      END SUBROUTINE CALC_H2O  

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GETM0I ( RHIN, M0I )

!!!!!!!!!!!!!!! We want to get rid of this dependency !!!!!!!!!!!!!!!!

C Description
C   Determines single-solute molalities for the 13 possible salts at
C   the ambient RH.  These molalities are used in the ZSR calculation
C   in CALC_H2O. Note that the molalities were determined at the beginning
C   of the time step, and so they are available in the IONS common block
C   of isrpia.inc.
C   Routine called by CALC_H2O.

C Revision History
C   ??? ???? Prakash Bhave(?), Jim Kelly(?): initial revision
C   Apr 2011 Havala Pye: Removed use of IONS common block since it requires
C                        ISORROPIA to be called to setup the initial array values.
C                        Now uses single-solute molalities from ZSR common block
C                        in isrpia.inc that is defined in BLKISO in isocom.f
C                        BE VERY CAREFUL ABOUT IMPLICIT VARIABLES HERE!
 
C Arguments
C   Output
C     M0I : Single-solute molalities (mol/kg-H2O) for 13 salts
 
C-----------------------------------------------------------------------

!     implicit none

      INCLUDE 'isrpia.inc'

C Arguments
      REAL( 8 ), INTENT( IN )  :: RHIN
      REAL( 8 ), INTENT( OUT ) :: M0I( NPAIR )

      INTEGER IZ

C Location in pure molality array (function of RH)
      IZ = MIN( INT( RHIN * REAL( NZSR, 8 ) + 0.5D0 ), NZSR )
      IZ = MAX( IZ, 1 )

C Default value
      M0I = 1.0D+5   ! array assignment

C Actual values (10,11 not provided)
      M0I( 01 ) = AWSC( IZ )   ! NACl
      M0I( 02 ) = AWSS( IZ )   ! (NA)2SO4
      M0I( 03 ) = AWSN( IZ )   ! NANO3
      M0I( 04 ) = AWAS( IZ )   ! (NH4)2SO4
      M0I( 05 ) = AWAN( IZ )   ! NH4NO3
      M0I( 06 ) = AWAC( IZ )   ! NH4CL
      M0I( 07 ) = AWSA( IZ )   ! 2H-SO4
      M0I( 08 ) = AWSA( IZ )   ! H-HSO4
      M0I( 09 ) = AWAB( IZ )   ! NH4HSO4


      M0I( 12 ) = AWSB( IZ )   ! NAHSO4
      M0I( 13 ) = AWLC( IZ )   ! (NH4)3H(SO4)2

      M0I( 15 ) = AWCN( IZ )   ! CA(NO3)2
      M0I( 16 ) = AWCC( IZ )   ! CACl2
      M0I( 17 ) = AWPS( IZ )   ! K2SO4
      M0I( 18 ) = AWPB( IZ )   ! KHSO4
      M0I( 19 ) = AWPN( IZ )   ! KNO3
      M0I( 20 ) = AWPC( IZ )   ! KCl
      M0I( 21 ) = AWMS( IZ )   ! MGSO4
      M0I( 22 ) = AWMN( IZ )   ! MG(NO3)2
      M0I( 23 ) = AWMC( IZ )   ! MGCL2
    
      END SUBROUTINE GETM0I               

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GETSC ( CONC, RH, T, SC )
 
C Description
C   Determines the sub-case to use for water uptake calculations.
C   Follows the procedure of ISORROPIA.
C   Routine called by CALC_H2O.
 
C ArgumentS
C   Inputs
C     CONC : Concentration [mol/m^3] of aerosol components. This routine
C            sets minimum CONC to 1.0D-20
C     RH   : Relative humidity
C     T    : Temperature (K)
     
C   Output
C     SC   : Sub-case for aerosol composition
 
C-----------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER, PARAMETER :: NCMP = 8    ! was NCMP  = 5    ! number of aerosol components
      REAL( 8 ), PARAMETER :: SMALL = 1.0D-20

C Arguments:
!     REAL( 8 ), INTENT( IN )    :: CONC(  NCMP )
      REAL( 8 ), INTENT( INOUT ) :: CONC(  NCMP )
      REAL( 8 ), INTENT( IN )    :: RH, T
      CHARACTER( 3 ), INTENT( OUT ) :: SC
            
C Local Variables:
      REAL( 8 ) :: T0, TCF                     ! DRH(T) factor
      REAL( 8 ) :: S4RAT, S4RATW, NaRAT, SRI   ! sulfate & sodium ratios
      REAL( 8 ) :: CRAT                        ! crustals ratio
      REAL( 8 ) :: FSO4                        ! "free" sulfate
      REAL( 8 ) :: DNACL, DNH4CL, DNANO3, DNH4NO3, DNH42S4 ! DRH values

      REAL( 8 ) :: GETASR    ! ISORROPIA function for sulfate ratio

      LOGICAL :: SCP1R, SCP2R, SCP3R, SCP4R ! concentration regime

C-----------------------------------------------------------------------

      SCP1R = .FALSE.
      SCP2R = .FALSE.
      SCP3R = .FALSE.
      SCP4R = .FALSE.

C     See if any components are negligible (see isocom.for)
      IF ( CONC( 1 ) + CONC( 4 ) + CONC( 5 ) + 
     &     CONC( 6 ) + CONC( 7 ) + CONC( 8 ) .LE. SMALL ) THEN       ! Ca,K,Mg,Na,Cl,NO3=0
         SCP1R = .TRUE.                                    
      ELSE IF ( CONC( 1 ) +        CONC( 5 ) +
     &          CONC( 6 ) + CONC( 7 ) + CONC( 8 ) .LE. SMALL ) THEN  ! Ca,K,Mg,Na,Cl=0
         SCP2R = .TRUE.                                     
      ELSE IF ( CONC( 6 ) + CONC( 7 ) + CONC( 8 ) .LE. SMALL ) THEN  ! Ca,K,Mg=0
         SCP3R = .TRUE.                                     
      ELSE                                                           ! all species
         SCP4R = .TRUE.
      END IF

      CONC( : ) = MAX ( CONC( : ), SMALL )

C     Deliquescence RH calculations
      DNH42S4 = 0.7997D0
      DNH4NO3 = 0.6183D0
      IF ( INT( T ) .NE. 298 ) THEN
         T0      = 298.15D0
         TCF     = 1.0D0 / T - 1.0D0 / T0
         DNH4NO3 = DNH4NO3 * EXP( 852.0D0 * TCF )
         DNH42S4 = DNH42S4 * EXP(  80.0D0 * TCF )
         DNH4NO3 = MIN ( DNH4NO3, DNH42S4 ) ! adjust for curves crossing T<271K
      END IF

C     Find sub-case "SC"
      IF ( SCP1R ) THEN ! NH4-S04 system

         IF ( RH .GE. DNH42S4 ) THEN
            S4RATW = GETASR( CONC( 2 ), RH ) ! aerosol sulfate ratio
         ELSE
            S4RATW = 2.0D0                ! dry aerosol sulfate ratio
         END IF
         S4RAT  = CONC( 3 ) / CONC( 2 )     ! sulfate ratio (NH4/SO4)

         IF ( S4RATW .LE. S4RAT ) THEN      ! sulfate poor
            SC = 'S2'
         ELSE IF ( 1.0D0 .LE. S4RAT .AND. S4RAT .LT. S4RATW ) THEN ! sulfate rich (no acid)
            SC = 'B4'
         ELSE IF ( S4RAT .LT. 1.0D0 ) THEN   ! sulfate rich (free acid)
            SC = 'C2'
         END IF

      ELSE IF ( SCP2R ) THEN ! NH4-SO4-NO3 system

         IF ( RH .GE. DNH4NO3 ) THEN
            S4RATW = GETASR( CONC( 2 ), RH )
         ELSE
            S4RATW = 2.0D0               ! dry aerosol ratio
         END IF
         S4RAT = CONC( 3 ) / CONC( 2 )

         IF ( S4RATW .LE. S4RAT ) THEN     ! sulfate poor
            SC = 'N3'
         ELSE IF ( 1.0D0 .LE. S4RAT .AND. S4RAT .LT. S4RATW ) THEN  ! sulfate rich (no acid)
            SC = 'B4'
         ELSE IF ( S4RAT .LT. 1.0D0 ) THEN    ! sulfate rich (free acid)
            SC = 'C2'
         END IF

      ELSE IF ( SCP3R )  THEN ! NH4-SO4-NO3-Na-Cl system

C        Adjust DRH of NH4NO3 for low temperature
         DNACL  = 0.7528D0
         DNANO3 = 0.7379D0
         DNH4CL = 0.7710D0
         IF ( INT( T ) .NE. 298 ) THEN
            DNACL   = DNACL  * EXP(  25.0D0 * TCF )
            DNANO3  = DNANO3 * EXP( 304.0D0 * TCF )
            DNH4CL  = DNH4Cl * EXP( 239.0D0 * TCF )
            DNH4NO3 = MIN ( DNH4NO3, DNH4CL, DNANO3, DNACL )
         END IF

         IF ( RH .GE. DNH4NO3 ) THEN
            FSO4   = CONC( 2 ) - CONC( 1 ) / 2.0D0   ! sulfate unbound by Na+
            FSO4   = MAX ( FSO4, SMALL )
            SRI    = GETASR ( FSO4, RH )
            S4RATW = ( CONC( 1 ) + FSO4 * SRI ) / CONC( 2 )
            S4RATW = MIN ( S4RATW, 2.0D0 )
         ELSE
            S4RATW = 2.0D0                       ! ratio for dry aerosol
         END IF
         S4RAT = ( CONC( 1 ) + CONC( 3 ) ) / CONC( 2 )
         NaRAT = CONC( 1 ) / CONC( 2 )

         IF ( S4RATW .LE. S4RAT .AND. NaRAT .LT. 2.0D0 ) THEN ! sulfate poor, sodium poor
            SC = 'Q5'
         ELSE IF ( S4RAT .GE. S4RATW .AND. NaRAT .GE. 2.0D0 ) THEN ! SO4 poor, Na rich
            SC = 'R6'
         ELSE IF ( 1.0D0 .LE. S4RAT .AND. S4RAT .LT. S4RATW ) THEN ! SO4 rich, no acid
            SC = 'I6'
         ELSE IF ( S4RAT .LT. 1.0D0 ) THEN ! sulfate rich, free acid
            SC = 'J3'
         END IF

      ELSE IF ( SCP4R ) THEN ! NH4-SO4-Na-Cl-Ca-K-Mg system

         ! Do I need an RH if check here????
         FSO4   = CONC( 2 ) - CONC( 1 ) / 2.0D0
     &          - CONC( 6 ) - CONC( 7 ) / 2.0D0 - CONC( 8 )  ! sulfate unbound by sodium,calcium,pottasium,magnesium
         FSO4   = MAX ( FSO4, SMALL )
         SRI    = GETASR( FSO4, RH )                         ! sulfate ratio for NH4+
         S4RATW = ( CONC( 1 ) + FSO4 * SRI + CONC( 6 )
     &            + CONC( 7 ) + CONC( 8 ) ) / CONC( 2 )      ! limiting sulfate ratio
         S4RATW = MIN ( S4RATW, 2.0D0 )
         S4RAT = ( CONC( 1 ) + CONC( 3 ) + CONC( 6 ) + CONC( 7 ) + CONC( 8 ) ) / CONC( 2 ) ! sulfate ratio
         NaRAT = ( CONC( 1 ) + CONC( 6 ) + CONC( 7 ) + CONC( 8 ) ) / CONC( 2 ) ! crustals+sodium ratio
         CRAT  = ( CONC( 6 ) + CONC( 7 ) + CONC( 8 ) ) / CONC( 2 )             ! crustals ratio

         IF ( S4RATW .LE. S4RAT .AND. NaRAT .LT. 2.0D0 ) THEN ! sulfate, sodium, crustal poor
            SC = 'V7'
         ELSE IF ( S4RAT .GE. S4RATW .AND. NaRAT .GE. 2.0D0 ) THEN
            IF ( CRAT .LE. 2.0D0 ) THEN       ! sulfate poor, dust+sodium rich, dust poor
               SC = 'U8'
            ELSE                              ! sulfate poor, dust+sodium rich, dust rich
               SC = 'W13'
            END IF
         ELSE IF ( 1.0D0 .LE. S4RAT .AND. S4RAT .LT. S4RATW ) THEN ! sulfate rich, no acid
            SC = 'L9'
         ELSE IF ( S4RAT .LT. 1.0D0 ) THEN     ! sulfate rich, free acid
            SC = 'K4'
         END IF
      END IF

      !print*,'SUBCASE identified in calc_h2o', SC

      END SUBROUTINE GETSC

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      REAL FUNCTION GETAF( NI, NJ, DGNI, DGNJ, XLSGI, XLSGJ, SQRT2 )

C  Returns the value of "Xnum" in Equations 10a and 10c
C  of Binkowski and Roselle (2003), given the number concentrations,
C  median diameters, and natural logs of the geometric standard
C  deviations, in two lognormal modes.  The value returned by GETAF
C  is used subsequently in the mode merging calculations:
C       GETAF = ln( Dij / Dgi ) / ( SQRT2 * ln(Sgi) )
C  where Dij is the diameter of intersection,
C        Dgi is the median diameter of the smaller size mode, and
C        Sgi is the geometric standard deviation of smaller mode.
C  A quadratic equation is solved to obtain GETAF, following the
C  method of Press et al.
C 
C  References:
C   1. Binkowski, F.S. and S.J. Roselle, Models-3 Community
C      Multiscale Air Quality (CMAQ) model aerosol component 1:
C      Model Description.  J. Geophys. Res., Vol 108, No D6, 4183
C      doi:10.1029/2001JD001409, 2003.
C   2. Press, W.H., S.A. Teukolsky, W.T. Vetterling, and B.P.
C      Flannery, Numerical Recipes in Fortran 77 - 2nd Edition.
C      Cambridge University Press, 1992.

      IMPLICIT NONE

      REAL NI, NJ, DGNI, DGNJ, XLSGI, XLSGJ, SQRT2
      REAL AA, BB, CC, DISC, QQ, ALFA, L, YJI

C-----------------------------------------------------------------------

C *** Store intermediate values used for the quadratic solution
C     to reduce computational burden
      ALFA = XLSGI / XLSGJ
      YJI = LOG( DGNJ / DGNI ) / ( SQRT2 * XLSGI )
      L = LOG( ALFA * NJ / NI)

C *** Calculate quadratic equation coefficients & discriminant
      AA = 1.0 - ALFA * ALFA
      BB = 2.0 * YJI * ALFA * ALFA
      CC = L - YJI * YJI * ALFA * ALFA
      DISC = BB * BB - 4.0 * AA * CC

C *** If roots are imaginary, return a negative GETAF value so that no
C     mode merging takes place.
      IF ( DISC .LT. 0.0 ) THEN
         GETAF = - 5.0       ! error in intersection
         RETURN
      END IF

C *** Equation 5.6.4 of Press et al.
      QQ = -0.5 * ( BB + SIGN( 1.0, BB ) * SQRT( DISC ) )

C *** Return solution of the quadratic equation that corresponds to a
C     diameter of intersection lying between the median diameters of
C     the 2 modes.
      GETAF = CC / QQ       ! See Equation 5.6.5 of Press et al.

      RETURN
      END FUNCTION GETAF
 
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AERO_INLET ( DGN, XXLSG, RHOP, D_AD1, D_AD2, fPM )

C  Calculates the volume fraction of a given aerosol mode that would enter
C  a sharp-cut inlet, using equations from Jiang et al (2006). The
C  parameters D_AD1 and D_AD2 provide the lower and upper cutoff diameters
C  for the inlet size cut and the routine returns the fraction of the
C  size distribution that is transmitted through the hypothetical inlet
C  with the variable fPM. But first, those cutoffs are converted from 
C  Aerodynamic Diameter to Stokes Diameter (used internally within CMAQ).
 
C  CMAQ aerosols are represented with Stokes Diameter. There are many
C  alternate forms of diameter including the following:
C       Volume Equivalent Diameter (D_ve) - the diameter of a sphere with the
C          same volume as the particle.
C       Stokes Diameter (D_st) - the diameter of a sphere with the same
C          terminal velocity as the real particle. If the shape factor
C          is 1, then the Stokes and Volume Equivalent Diameters are
C          equal.
C       Aerodynamic Diameter (D_ad) - the diameter of a sphere with unit
C          density and the same terminal velocity as the real particle.
C          If the density is 1, then the Aerodynamic Diameter and Stokes
C          Diameter are equal.
C       Vacuum Aerodynamic Diameter (D_va) - the diameter of a sphere with very
C          high Knudsen number and thus a simplified relationship with
C          Stokes diameter that is only dependent on density and shape
C          factor, not Slip Correction. The very high Knudsen number
C          could be because the particle is very small or because the
C          system pressure is very low.
C       Electrical Mobility Diameter (D_em) - the diameter of a sphere with the
C          same migration velocity as the real particle. Requires a
C          slip-correction and a shape factor correction when converting
C          from volume equivalent diameter.
 
C  Conversions:
C       Parameters
C         rho  - Density
C         rho0 - Unit Density (1 g cm-3)
C         Cc( ) - Cunningham Slip Correction of a particular diameter
C         X   - Shape factor = (NonSpherical Drag Force)/(Spherical Drag Force)
C       Aerodynamic -> Stokes
C         D_st = D_ad * sqrt(rho0/rho) * sqrt( Cc(D_ad) / Cc(D_st) )
C       Volume Equivalent -> Stokes
C         D_st = D_ve * sqrt(1/X) * sqrt( Cc(D_ve) / Cc(D_st) )
C       Electrical Mobility -> Volume Equivalent
C         D_ve = D_em * [Cc(D_ve) / Cc(D_em)] * 1/X
C             (If X = 1 (i.e. spherical), then D_st = D_ve = D_em )
C       Vacuum Aerodynamic -> Volume Equivalent (DeCarlo et al., 2004)
C         D_ve = D_va * rho0/rho * X
C             (If X = 1 (i.e. spherical), then D_st = D_ve = D_va * rho0/rho )
 
C  Key Subroutines called: none
 
C  Revision History:
C    Coded Jul 2005 by Prakash Bhave
C          Apr 2008 J.Kelly: corrected equation for Dst25 calculation
C          Feb 2016 B.Murphy: modified to output PM1 and PM10 mode
C                             fractions in addition to PM2.5
 
C  References:
C   1. Jiang, W., Smyth, S., Giroux, E., Roth, H., Yin, D., Differences
C   between CMAQ fine mode particle and PM2.5 concentrations and their
C   impact on model performance evaluation in the Lower Fraser Valley,
C   Atmos. Environ., 40:4973-4985, 2006.
C   2. Meng, Z., Seinfeld, J.H., On the source of the submicrometer
C   droplet mode of urban and regional aerosols, Aerosol Sci. and
C   Technology, 20:253-265, 1994.
 
C-----------------------------------------------------------------------

      USE CONST
      IMPLICIT NONE

C    Input variables
      REAL, INTENT( IN ) :: DGN     ! geometric mean Stokes diameter by number [ m ]
      REAL, INTENT( IN ) :: XXLSG   ! natural log of geometric standard deviation
      REAL, INTENT( IN ) :: RHOP    ! average particle density [ kg/m**3 ]
      REAL, INTENT( IN ) :: D_AD1   ! Lower aerodynamic diameter cut point [ um ]
      REAL, INTENT( IN ) :: D_AD2   ! Upper aerodynamic diameter cut point [ um ]

C    Output variable
      REAL, INTENT( OUT ) :: fPM   ! fraction of particulate volume transmitted through 
                                   ! hypothetical inlet.

C    Internal variables
      REAL, PARAMETER :: SQRT2 = 1.4142136  !  SQRT( 2 )
      REAL, PARAMETER :: B = 0.21470 ! Cunningham slip-correction approx. param [ um ]
                                     ! This factor works well applied to the entire particle size-range
                                     ! The approximation is: Cc(Dp) = 1 + B/Dp
      REAL D_ST1, D_ST2              ! Stokes diameter equivalent of DCA..
      REAL DG                        ! DGN converted to [ um ]
      REAL ERF1, ERF2, ERFARG        ! argument of ERF, from Step#6 of Jiang et al. (2006)

C ----------------------- Begin solution -------------------------------

C *** Calculate Transmission Fractions for Inlets with Aerodynamic
C     Cutoffs
      DG = DGN  ! [um] The units need to be equivalent with the B parameter

      ! from Meng & Seinfeld (1994) and modified form of Fk(X) equation
      ! in Step#6 of Jiang et al. (2006).
      IF ( D_AD1 .EQ. 0.0 ) THEN
          ERF1 = -1.0
      ELSE
          ! Convert size cut to equivalent Stokes diameter using
          ! equation 2 of Jiang et al. (2006). Note: the equation in Step 5
          ! of this paper has a typo (i.e., eq. 2 is correct).
          D_ST1  = 0.5 * ( SQRT( B ** 2 + 4.0 * D_AD1 *
     &                        ( D_AD1 + B ) * 1.0E+03 / RHOP ) - B )
          ! Calculate mass fraction with Dca < SizeCut
          ERFARG = ( LOG( D_ST1 ) - LOG( DG ) ) / ( SQRT2 * XXLSG ) - 3.0 * XXLSG / SQRT2
          ERF1 = ERF( ERFARG )
      END IF

      ! Convert size cut to equivalent Stokes diameter using
      ! equation 2 of Jiang et al. (2006). Note: the equation in Step 5
      ! of this paper has a typo (i.e., eq. 2 is correct).
      D_ST2  = 0.5 * ( SQRT( B ** 2 + 4.0 * D_AD2 *
     &                     ( D_AD2 + B ) * 1.0E+03 / RHOP ) - B )

      ! Calculate mass fraction with Dca < SizeCut
      ERFARG = ( LOG( D_ST2 ) - LOG( DG ) ) / ( SQRT2 * XXLSG ) - 3.0 * XXLSG / SQRT2
      ERF2 = ERF( ERFARG )

      ! Calculate fraction between Lower and Upper Cut Points
      fPM = 0.5 * ( ERF2 - ERF1 )

      END SUBROUTINE AERO_INLET

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AERO_AMS ( M3_WET, M2_WET, M0, M_H2O, RHOP, RHO_H2O, fAMS )

C  The subroutine calculates transmission factors applicable for
C  comparison with AMS measurements using the curve suggested by Jimenez
C  and coworkers  (http://cires1.colorado.edu/jimenez-group/wiki/index.php/
C  FAQ_for_AMS_Data_Users#What_is_the_size_cut_of_AMS_measurements.3F).
C  The AMS measures Vacuum Aerodynamic Diameter (D_va) because the pressure is
C  so low in the instrument. This curve (also described in Ensberg et
C  al., 2013)  includes the following (Note: before applying the curve,
C  the bounds must be converted to Stokes Diameter):
C     D_va < 0.04 um: 0% transmission (T)
C     0.04 < D_va < 0.1 um:  T% = 1666.6 * (D_va - 0.04)   (1)
C     0.1  < D_va < 0.55 um: T% = 100%                     (2)
C     0.55 < D_va < 2.0 um:  T% = 100-68.965*(D_va-0.55)   (3)
C     2.0 um < D_va: T = 0%
 
C  CMAQ aerosols are represented with Stokes Diameter. There are many
C  alternate froms of diameter including the following:
C       Volume Equivalent Diameter (D_ve) - the diameter of a sphere with the
C          same volume as the particle.
C       Stokes Diameter (D_st) - the diameter of a sphere with the same
C          terminal velocity as the real particle. If the shape factor
C          is 1, then the Stokes and Volume Equivalent Diameters are
C          equal.
C       Vacuum Aerodynamic Diameter (D_va) - the diameter of a sphere with very
C          high Knudsen number and thus a simplified relationship with
C          Stokes diameter that is only dependent on density and shape
C          factor, not Slip Correction. The very high Knudsen number
C          could be because the particle is very small or because the
C          system pressure is very low.
 
C  Conversions:
C       Parameters
C         ro  - Density
C         ro0 - Unit Density (1 g cm-3)
C         Cc( ) - Cunningham Slip Correction of a particular diameter
C         X   - Shape factor = (NonSpherical Drag Force)/(Spherical Drag Force)
C       Vacuum Aerodynamic -> Volume Equivalent (DeCarlo et al., 2004)
C         D_ve = D_va * ro0/ro * X
C             (If X = 1 (i.e. spherical), then D_st = D_ve = D_va * ro0/ro )
 
C  Revision History:
C    Coded Feb 2016 B.Murphy: Created

C  References:
C   1. DeCarlo et al., Particle Morphology and Density Characterization
C   by Combined Mobility and Aerodynamic Diameter Measurements. Part 1:
C   Theory, Aerosol Sci. and Technology, 38:1185-1205, 2004
C   2. Ensberg et al., Inorganic and black carbon aerosols in the Los
C   Angeles Basin during CalNex, Journ. Geophys. Res., 2013.

C-----------------------------------------------------------------------

      USE AERO_DATA, ONLY    : MIN_SIGMA_G, MAX_SIGMA_G
      USE CONST
!     USE AEROMET_DATA, ONLY : F6PI, PI6

      IMPLICIT NONE

C    Input variables
      REAL, INTENT( IN ) :: M3_WET  ! Third Moment of Wet Distribution (m3/m3)
      REAL, INTENT( IN ) :: M2_WET  ! Second Moment of Wet Distribution (m2/m3)
      REAL, INTENT( IN ) :: M0      ! Number of Particles in Distribution (N/m3)
      REAL, INTENT( IN ) :: M_H2O   ! Mass Conc. of Water in Particles (ug/m3)
      REAL, INTENT( IN ) :: RHOP    ! average particle density [ kg/m**3 ]
      REAL, INTENT( IN ) :: RHO_H2O ! Water Density [ kg/m3 ]

C    Output variable
      REAL, INTENT(OUT) :: fAMS   ! fraction of particulate volume transmitted through AMS Inlet

C    Internal variables
      REAL, PARAMETER :: SQRT2 = 1.4142136    !  SQRT( 2 )
      REAL, PARAMETER :: DGMIN = 1.0E-9       !  min(Dp) in [m]
      REAL, PARAMETER :: ONETHIRD = 1.0 / 3.0
      REAL, PARAMETER :: TWOTHIRDS = 2.0 * ONETHIRD

      REAL DG                        ! DGN converted to [ um ]
      REAL DGv                       ! Volume Median Diameter
      REAL XXLSG                     ! ln(StndDev) for current mode
      REAL M3_DRY, M2_DRY, M3SUBT, M_WET, M_DRY, DRY_DENS, DENSFAC
      REAL XFSUM, LXFM2, L2SG, ES36
      REAL DBlo_st, DBhi_st, LOG_HILO, LOG_LOHI, LOG_HI, LOG_LO
      REAL SQRT2LSG, TERM1, TERM2, TERM3, TERM4, TERM5

C ----------------------- Begin solution -------------------------------

C *** First Calculate Parameters of Dry Distribution since this is more
C     applicable in general to AMS measurements.
      M3SUBT = ( 1.0E-9 * F6PI / RHO_H2O ) * M_H2O        ! m3 m-3
      M3_DRY = Max(M3_WET - M3SUBT, 0.0) + TINY(0.0)   ! m3 m-3 
      M2_DRY = M2_WET * ( M3_DRY / M3_WET ) ** TWOTHIRDS  ! m2 m-3

      M_WET = M3_WET * 1.0E+9 * PI6 * RHOP ! ug m-3
      M_DRY = Max(M_WET - M_H2O, 0.0) + TINY(0.0) ! m3 m-3 

      DRY_DENS = M_DRY / M3_DRY * F6PI * 1.0E-9   ! kg m-3

      XFSUM = ONETHIRD * Log( M0 ) + TWOTHIRDS * Log( M3_DRY )
      LXFM2 = Log( M2_DRY )
      L2SG = XFSUM - LXFM2   ! ( ln(sigma) )^2

      L2SG = Min( Max( L2SG, LOG( MIN_SIGMA_G ) ** 2 ), LOG( MAX_SIGMA_G ) ** 2 )
      LXFM2 = XFSUM - L2SG
      ES36 = Exp( 4.5 * L2SG )

      DG = Max( DGMIN, ( M3_DRY / ( M0 * ES36 ) ) ** ONETHIRD ) * 1.0E+06 ![um] Units should correspond to D
      XXLSG = Sqrt( L2SG )  ! ln(sigma)

      DGv = EXP( LOG( DG ) + 3.0 * L2SG )

C *** Calculate Transmission Fractions for AMS with Vacuum Aerodynamic
C     Cutoffs. This approximation is split into a piecewise function (see
C     Appendix B in Ensberg et al., 2013).
      fAMS = 0.0
      DENSFAC = 1.0E+03 / DRY_DENS  ! Density Correction Factor
                                    !   = rho0 / rho
                                    !   = 1000.0 / rho
      SQRT2LSG = SQRT2 * XXLSG

      ! First Piece of Function [T(%) = 1666.6 * (Dva - 0.04) ]
      DBlo_st = 0.040 * DENSFAC  ! Stokes Lower Bound of Piece [um]
      DBhi_st = 0.100 * DENSFAC  ! Stokes Upper Bound of Piece [um]

      LOG_HILO = LOG( 100.0/40.0 )
      LOG_HI   = LOG( DBhi_st/DGv )
      LOG_LO   = LOG( DBlo_st/DGv )

      TERM1 = LOG( DGv/DBlo_st ) / LOG_HILO
      TERM2 =  ERF( LOG_HI / SQRT2LSG )
     &        -ERF( LOG_LO / SQRT2LSG )
      TERM3 = XXLSG / ( LOG_HILO * (pi/2.0) ** 0.5 )
      TERM4 = EXP( -1.0 * ( LOG_LO / SQRT2LSG ) ** 2 )
      TERM5 = EXP( -1.0 * ( LOG_HI / SQRT2LSG ) ** 2 )

      fAMS = ( TERM1*TERM2  +  TERM3*(TERM4-TERM5) )

      ! Second Piece of Function [T(%) = 100]
      DBlo_st = DBhi_st         ! Stokes Lower Bound [um]
      DBhi_st = 0.55 * DENSFAC  ! Stokes Upper Bound [um]

      TERM1 = ERF( LOG( DBhi_st/DGv ) / SQRT2LSG )
      TERM2 = ERF( LOG( DBlo_st/DGv ) / SQRT2LSG )
      fAMS = fAMS +  (TERM1 - TERM2)

      ! Third Piece of Function [T(%) = 1.0 - 0.6805 * (Dva - 0.55) ]
      DBlo_st = DBhi_st        ! Stokes Lower Bound [um]
      DBhi_st = 2.0 * DENSFAC  ! Stokes Upper Bound [um]

      LOG_LOHI = LOG( 550.0/2000.0 )
      LOG_HI   = LOG( DBhi_st/DGv )
      LOG_LO   = LOG( DBlo_st/DGv )

      TERM1 = LOG( DGv/DBhi_st ) / LOG_LOHI
      TERM2 =  ERF( LOG_HI / SQRT2LSG )
     &        -ERF( LOG_LO / SQRT2LSG )
      TERM3 = XXLSG / ( LOG_LOHI * (pi/2.0) ** 0.5 )
      TERM4 = EXP( -1.0 * ( LOG_LO / SQRT2LSG ) ** 2 )
      TERM5 = EXP( -1.0 * ( LOG_HI / SQRT2LSG ) ** 2 )

      fAMS = fAMS + TERM1 * TERM2  +  TERM3 * (TERM4-TERM5)

      ! Apply the Factor of 0.5 Consistent with Appendix B in Ensberg et
      ! al., 2013. Omit the total mass quantity since these are fractions
      ! we want.
      fAMS = 0.5 * fAMS

      END SUBROUTINE AERO_AMS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      SUBROUTINE HETCHEM_EXTRACT_AERO ( CONCVEC, C, R, L, WET_M2, WET_M3, 
     &                                  DE_WET )

c  Calculates the change in aerosol surface area due to heterogeneous
C  reactions and updates the CGRID array with this information.
  
C  History
C  May 2016: BM Created

C  Key Subroutines Called: none
C
C  Called by: Gas-Phase Chemistry Driver
      USE AERO_DATA, ONLY: EXTRACT_AERO, CALCMOMENTS, N_MODE, MOMENT2_CONC,
     &                     MOMENT3_CONC, AEROMODE_DIAM, AEROMODE_LNSG,
     &                     CHEM_M2DRY_INIT, CHEM_M3DRY_INIT, FIXED_SG
      USE CONST, ONLY: pi
      USE GRID_CONF, ONLY: NLAYS, NCOLS, NROWS
      USE PRECURSOR_DATA, ONLY: EXTRACT_PRECURSOR

#ifdef sens
      USE DDM3D_DEFN, ONLY: SENGRID

#endif
      IMPLICIT NONE
      
      REAL, INTENT( IN ) :: CONCVEC ( : )  ! pointer to model concentrations
      REAL, PARAMETER    :: TWOTHIRDS = 2.0 / 3.0
      REAL               :: M2DRY_FINAL( N_MODE ) ! Dry 2nd Aerosol Moment
      REAL               :: M3DRY_FINAL( N_MODE ) ! Dry 3rd Aerosol Moment
      INTEGER            :: C, R, L, N
      REAL( 8 ), INTENT(OUT) :: WET_M2( : ), WET_M3( : ), DE_WET( : )
      LOGICAL, SAVE      :: FIRSTIME = .TRUE.

      IF ( FIRSTIME ) THEN
          FIRSTIME = .FALSE.
          ALLOCATE( CHEM_M2DRY_INIT( NCOLS,NROWS,NLAYS,N_MODE ),
     &              CHEM_M3DRY_INIT( NCOLS,NROWS,NLAYS,N_MODE ) )

      END IF

C *** extract grid cell concentrations of aero species from CGRID
C     into aerospc_conc in aero_data module
C     also converts dry surface area to wet second moment
#ifdef sens
               CALL EXTRACT_AERO ( CONCVEC(:), .TRUE., SENGRID(NCOLS,NROWS,NLAYS,:,:), .FALSE. )
#else
               CALL EXTRACT_AERO ( CONCVEC(:), .TRUE. )
#endif

C *** extract in inorganic aerosol processors

#ifdef sens
               CALL EXTRACT_PRECURSOR( CONCVEC(:), SENGRID( NCOLS,NROWS,NLAYS,:,: ) )
#else
               CALL EXTRACT_PRECURSOR( CONCVEC(:) ) 
#endif

C *** Update geometric mean diameters, geometric
C     standard deviations, modal mass totals, and modal particle
C     densities, based on the concentrations of M2, M0, and speciated
C     masses.
               CALL getpar( FIXED_sg )
     
C *** set up variables needed for calculating KN2O5 and YIELD_CLNO2

               DO N = 1, N_MODE
C *** estimate the "wet third moments" from moment3_conc
C     Note: this is the H2O concentration from previous time step
                  WET_M3( N ) = REAL( MOMENT3_CONC( N ), 8 )
C *** calculate "wet second moment" assuming that H2O does not
C     affect the geometric standard deviation
                  WET_M2( N ) = REAL( MOMENT2_CONC( N ), 8 ) 
C *** The "wet" geometric mean (same as median) diameter was updated in
C     getpar. It is stored in aeromode_diam
C *** calculate effective diameter (this is actually the mean) using Eq 3 of Pleim et al (1995)
                  DE_WET( N ) = REAL( AEROMODE_DIAM( N ) * EXP( 1.5 * AEROMODE_LNSG( N ) ** 2 ), 8)
               END DO

C *** Retrieve and Save the Dry 3rd and 2nd Moments
               CALL calcmoments( .False. )
               CHEM_M2DRY_INIT( C,R,L,: ) = REAL( MOMENT2_CONC( : ), 8 )
               CHEM_M3DRY_INIT( C,R,L,: ) = REAL( MOMENT3_CONC( : ), 8 )

      END SUBROUTINE HETCHEM_EXTRACT_AERO

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      SUBROUTINE HETCHEM_UPDATE_AERO ( CGRID )

c  Calculates the change in aerosol surface area due to heterogeneous
C  reactions and updates the CGRID array with this information.
C  
C  History
C  May 2016: BM Created

C  Key Subroutines Called: none
C
C  Called by: Gas-Phase Chemistry Driver
      USE AERO_DATA
      USE CONST, ONLY: pi
      USE GRID_CONF, ONLY: NLAYS, NROWS, NCOLS

      IMPLICIT NONE
      
      REAL, POINTER   :: CGRID ( :,:,:,: )  ! pointer to model concentrations
      REAL, PARAMETER :: TWOTHIRDS = 2.0 / 3.0
      REAL            :: M2DRY_FINAL( N_MODE ) ! Dry 2nd Aerosol Moment
      REAL            :: M3DRY_FINAL( N_MODE ) ! Dry 3rd Aerosol Moment
      INTEGER L, R, C, M 

      LOOP_LAY: DO L = 1, NLAYS
         LOOP_ROW: DO R = 1, NROWS
            LOOP_COL: DO C = 1, NCOLS   
      
               ! Extract grid cell concentrations of aero species from CGRID
               ! into aerospc_conc in aero_data module
               ! also converts dry surface area to wet second moment
#ifdef sens
               CALL EXTRACT_AERO ( CGRID( C,R,L,: ), .TRUE., CGRID(C,R,:,: ), .FALSE. )
#else
               CALL extract_aero ( CGRID( C,R,L,: ), .True. )
#endif

               ! Recalculate Dry 3rd Moment After Chemistry Processes
               ! 2nd moment hasnt been update yet.
               CALL calcmoments( .False. )
               M2DRY_FINAL( : ) = MOMENT2_CONC( : )
               M3DRY_FINAL( : ) = MOMENT3_CONC( : )

               ! Calculate new Second Moment Manually
               ! Assume standard deviation is fixed.
               M2DRY_FINAL( : ) = REAL( CHEM_M2DRY_INIT( C,R,L,: ) ) 
     &             * ( M3DRY_FINAL( : ) 
     &             / REAL( CHEM_M3DRY_INIT( C,R,L,: ) ) ) ** TWOTHIRDS

               ! Update the Aerosol Surface Area making sure to multiply
               ! the 2nd moment by Pi to convert properly
               DO M = 1, N_MODE
                 CGRID( C,R,L, aerosrf_map( M ) ) = 
     &                        PI * M2DRY_FINAL( M )
               END DO

            END DO LOOP_COL
         END DO LOOP_ROW
      END DO LOOP_LAY

      END SUBROUTINE HETCHEM_UPDATE_AERO
!
!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SUM_INLET_PM ( INLET, WETNESS, PM )

!     Calculates the total PM mass below a user-defined cut point D_AD,
!     or Aerodynamic Diameter in um.
!-----------------------------------------------------------------------

      USE AERO_DATA, ONLY : AEROSPC_CONC, AEROSPC, N_MODE, 
     &                      AH2O_IDX, AORGH2O_IDX
      USE ELMO_DATA

      IMPLICIT NONE

      ! Input variables
      INTEGER, INTENT( INOUT ) :: INLET ! Integer prescribing the inlet type
                                        !   (see ELMO_INLET table in ELMO_DATA module)
      INTEGER, INTENT( INOUT ) :: WETNESS ! 1 = Wet Aerosol; 2 = Dry Aerosol

      ! Output variable
      REAL, INTENT( OUT ) :: PM   ! PM Mass below cut point

      INTEGER IM
      REAL    VAL

C ----------------------- Begin solution -------------------------------
      PM = 0.0
      
      DO IM = 1,N_MODE
         CALL GET_AERO_INLET( INLET, IM, WETNESS, VAL )
         PM = PM + VAL * ( SUM( AEROSPC_CONC( :,IM ), 
     &                  MASK = .NOT.AEROSPC(:)%TRACER )
     &                  - AEROSPC_CONC( AH2O_IDX,IM ) )
                    IF ( AORGH2O_IDX .GT. 0 ) PM = PM
     &                  - VAL * AEROSPC_CONC( AORGH2O_IDX,IM ) ! ug m-3
      END DO
 
      END SUBROUTINE SUM_INLET_PM

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GET_AERO_INLET ( INLET, IMODE, WETNESS, FRAC )

!     Calls the AERO_INLET routine for calculating the fraction of each 
!       mode collected by inlet prescribed by INLET. This subroutine is
!       only for PM0.1, PM1, PM2.5, PM10 and PM2.5to10. It is not for
!       AMS inlet calculation. If the user expands the ELMO_INLET
!       table to consider more cutoff ranges, this subroutine can be
!       used to calculate them as well.
!-----------------------------------------------------------------------

      USE ELMO_DATA
      USE AERO_DATA, ONLY : WET_AERO_DIAM, AEROMODE_LNSG, WET_AERO_DENS,
     &                      DRY_AERO_DIAM, DRY_AERO_DENS, AH2O_IDX,
     &                      MOMENT0_CONC, AEROSPC, AEROSPC_CONC,
     &                      WET_AERO_M3, WET_AERO_M2

      IMPLICIT NONE

      ! Input variables
      INTEGER, INTENT( INOUT ) :: INLET ! Integer prescribing the inlet type
                                        !   (see ELMO_INLET table in ELMO_DATA module)
      INTEGER, INTENT( INOUT ) ::  IMODE   ! Aerosol Mode of interest
      INTEGER, INTENT( INOUT ) ::  WETNESS ! 1 = Wet Aerosol; 2 = Dry Aerosol

      ! Output variable
      REAL, INTENT( OUT ) :: FRAC ! Fraction of aerosol mode IM
                                  !   collected by inlet described by INLET

C ----------------------- Begin solution -------------------------------
      
      IF ( INLET .EQ. 0 ) THEN
          FRAC = 1.0
          RETURN
      END IF

      IF ( INLET_FRAC( INLET,IMODE,WETNESS ) .LT. 0. ) THEN
         IF ( INLET .EQ. IPMAMS ) THEN
           CALL AERO_AMS( WET_AERO_M3( IMODE ), WET_AERO_M2( IMODE ),
     &                    MOMENT0_CONC( IMODE ), AEROSPC_CONC( AH2O_IDX,IMODE ),
     &                    WET_AERO_DENS( IMODE ), AEROSPC(AH2O_IDX)%DENSITY,
     &                    FRAC )

         ELSE IF ( WETNESS .EQ. IWET ) THEN
           CALL AERO_INLET( WET_AERO_DIAM( IMODE ), AEROMODE_LNSG( IMODE ),
     &                      WET_AERO_DENS( IMODE ), 
     &                      ELMO_INLET( INLET )%DIAM_LO, 
     &                      ELMO_INLET( INLET )%DIAM_HI, 
     &                      FRAC )
         ELSE
           CALL AERO_INLET( DRY_AERO_DIAM( IMODE ), AEROMODE_LNSG( IMODE ),
     &                      DRY_AERO_DENS( IMODE ), 
     &                      ELMO_INLET( INLET )%DIAM_LO, 
     &                      ELMO_INLET( INLET )%DIAM_HI, 
     &                      FRAC )
         END IF
         
         INLET_FRAC( INLET,IMODE,WETNESS ) = FRAC 
      ELSE
         FRAC = INLET_FRAC( INLET,IMODE,WETNESS )
      END IF
 
      END SUBROUTINE GET_AERO_INLET
 
!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SUM_INLET_NUM ( INLET, WETNESS, NUM )

!     Calculates the total particle number within a user-defined range
!     for each aerosol mode and then sums them up.
!-----------------------------------------------------------------------

      USE AERO_DATA, ONLY : DRY_AERO_DIAM, WET_AERO_DIAM,
     &                      AEROMODE_LNSG, MOMENT0_CONC
      USE ELMO_DATA

      IMPLICIT NONE

      ! Input variables
      INTEGER, INTENT( INOUT ) :: INLET ! Integer prescribing the inlet type
                                        !   (see ELMO_INLET table in ELMO_DATA module)
      INTEGER, INTENT( INOUT ) ::  WETNESS ! 1 = Wet Aerosol; 2 = Dry Aerosol

      ! Output variable
      REAL, INTENT( OUT ) :: NUM   ! PM Mass below cut point

      INTEGER IM
      REAL    FRAC

C ----------------------- Begin solution -------------------------------
      NUM = 0.0
      
      DO IM = 1,N_MODE
         IF ( WETNESS .EQ. IWET ) THEN
           CALL NUM_INLET( WET_AERO_DIAM( IM ), AEROMODE_LNSG( IM ),
     &                      ELMO_INLET( INLET )%DIAM_LO, 
     &                      ELMO_INLET( INLET )%DIAM_HI, 
     &                      FRAC )
         ELSE
           CALL NUM_INLET( DRY_AERO_DIAM( IM ), AEROMODE_LNSG( IM ),
     &                      ELMO_INLET( INLET )%DIAM_LO, 
     &                      ELMO_INLET( INLET )%DIAM_HI, 
     &                      FRAC )
         END IF
 
         NUM = NUM + MOMENT0_CONC( IM ) * FRAC
      END DO
 
      END SUBROUTINE SUM_INLET_NUM

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE NUM_INLET ( DGN, XXLSG, D_ST1, D_ST2, fPM )

C  Calculates the number fraction of a given aerosol mode that is between
C  cutoff diamters D_ST1 and D_ST2. The Stokes diameter used by CMAQ is 
C  assumed to be equivalent to the electrical mobility diameter, reported 
C  by typical SMPS datasets. This is true for spherical particles.
C 
C  CMAQ aerosols are represented with Stokes Diameter. There are many
C  alternate forms of diameter including the following:
C       Volume Equivalent Diameter (D_ve) - the diameter of a sphere with the
C          same volume as the particle.
C       Stokes Diameter (D_st) - the diameter of a sphere with the same
C          terminal velocity as the real particle. If the shape factor
C          is 1, then the Stokes and Volume Equivalent Diameters are
C          equal.
C       Aerodynamic Diameter (D_ad) - the diameter of a sphere with unit
C          density and the same terminal velocity as the real particle.
C          If the density is 1, then the Aerodynamic Diameter and Stokes
C          Diameter are equal.
C       Vacuum Aerodynamic Diameter (D_va) - the diameter of a sphere with very
C          high Knudsen number and thus a simplified relationship with
C          Stokes diameter that is only dependent on density and shape
C          factor, not Slip Correction. The very high Knudsen number
C          could be because the particle is very small or because the
C          system pressure is very low.
C       Electrical Mobility Diameter (D_em) - the diameter of a sphere with the
C          same migration velocity as the real particle. Requires a
C          slip-correction and a shape factor correction when converting
C          from volume equivalent diameter.
 
C  Conversions:
C       Parameters
C         rho  - Density
C         rho0 - Unit Density (1 g cm-3)
C         Cc( ) - Cunningham Slip Correction of a particular diameter
C         X   - Shape factor = (NonSpherical Drag Force)/(Spherical Drag Force)
C       Aerodynamic -> Stokes
C         D_st = D_ad * sqrt(rho0/rho) * sqrt( Cc(D_ad) / Cc(D_st) )
C       Volume Equivalent -> Stokes
C         D_st = D_ve * sqrt(1/X) * sqrt( Cc(D_ve) / Cc(D_st) )
C       Electrical Mobility -> Volume Equivalent
C         D_ve = D_em * [Cc(D_ve) / Cc(D_em)] * 1/X
C             (If X = 1 (i.e. spherical), then D_st = D_ve = D_em )
C       Vacuum Aerodynamic -> Volume Equivalent (DeCarlo et al., 2004)
C         D_ve = D_va * rho0/rho * X
C             (If X = 1 (i.e. spherical), then D_st = D_ve = D_va * rho0/rho )
 
C  Key Subroutines called: none
 
C  Revision History:
C    Coded Jul 2005 by Prakash Bhave
C          Apr 2008 J.Kelly: corrected equation for Dst25 calculation
C          Feb 2016 B.Murphy: modified to output PM1 and PM10 mode
C                             fractions in addition to PM2.5
C          Feb 2020 B.Murphy: Created this number synthesizer
C 
C-----------------------------------------------------------------------

      USE CONST
      IMPLICIT NONE

C    Input variables
      REAL, INTENT( IN ) :: DGN     ! geometric mean Stokes diameter by NUMBER [ m ]
                                    !  Remeber that geometric mean and median are
                                    !  identical for log-normal distributions.
      REAL, INTENT( IN ) :: XXLSG   ! natural log of geometric standard deviation
      REAL, INTENT( IN ) :: D_ST1   ! Lower stokes/electricla mobility diameter cut point [ um ]
      REAL, INTENT( IN ) :: D_ST2   ! Upper stokes/electrical mobility diameter cut point [ um ]

C    Output variable
      REAL, INTENT( OUT ) :: fPM   ! fraction of particulate number transmitted 
                                   ! through size window between D_ST1 and D_ST2

C    Internal variables
      REAL, PARAMETER :: SQRT2 = 1.4142136  !  SQRT( 2 )
      REAL ERF1, ERF2 ! argument of ERF, from Step#6 of Jiang et al. (2006)
      REAL ERFARG
      REAL DG         ! Internal units for median diameter

C ----------------------- Begin solution -------------------------------

C *** Calculate Transmission Fractions for Inlets with Aerodynamic
C     Cutoffs
      DG = DGN  ! [um] The units need to be equivalent with the B parameter

      ! from Meng & Seinfeld (1994) and modified form of Fk(X) equation
      ! in Step#6 of Jiang et al. (2006).
      IF ( D_ST1 .EQ. 0.0 ) THEN
          ERF1 = -1.0
      ELSE
          ! Calculate mass fraction with Dca < SizeCut
          ERFARG = ( LOG( D_ST1 ) - LOG( DG ) ) / ( SQRT2 * XXLSG ) 
          ERF1 = ERF( ERFARG )
      END IF

      ! Calculate mass fraction with Dca < SizeCut
      ERFARG = ( LOG( D_ST2 ) - LOG( DG ) ) / ( SQRT2 * XXLSG ) 
      ERF2 = ERF( ERFARG )

      ! Calculate fraction between Lower and Upper Cut Points
      fPM = 0.5 * ( ERF2 - ERF1 )

      END SUBROUTINE NUM_INLET
 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     
c      [2] write tssa concentration data 
c     
C     Revision history
C     01 Nov 2018: S.Napelenok Updates for cmaq5.3 release 
C     09 May 2019: D.Wong Removed all MY_ clauses
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      SUBROUTINE WR_SA_CGRID ( JDATE, JTIME, TSTEP )

C20140428  Writes full ISAM values to a restart file SA_CGRID_1 which would serve as
C          initial conditions for next day's run
C
C          Called by driver.F

      USE GRID_CONF
      USE UTILIO_DEFN           ! 20120615
c     USE SUBST_MODULES         ! stenex
      USE SA_DEFN               ! Mc06
      USE MIO_ASCII
      USE RUNTIME_VARS, ONLY : RUNLEN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif


      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

C...Arguments Declaration
      INTEGER    JDATE          ! current model date, coded YYYYDDD
      INTEGER    JTIME          ! current model time, coded HHMMSS
      !INTEGER    TSTEP(2)       ! format 10000, 0, 0
      INTEGER    TSTEP          ! format 10000

C...End of argument declaration

C Local variables:
      
c     INTEGER          ALLOCSTAT, LOGDEV
      INTEGER          ALLOCSTAT

      CHARACTER( 16 ) :: PNAME = 'WR_SA_CGRID'
      CHARACTER( 96 ) :: XMSG = ' '
      
c     INTEGER   C,R,S,K,N, L, ITAG, JSPC    ! loop induction variables
      INTEGER   C,R,S,K,N, L, JSPC    ! loop induction variables
      INTEGER, SAVE :: EDATE, ETIME

      REAL, ALLOCATABLE, SAVE :: ISAM_BUFF ( :,:,:,: )
!20140519
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL OK

      INTEGER TSTEP_RF, NTHIK_RF, NCOLS_RF, NROWS_RF, GDTYP_RF
      REAL( 8 ) :: P_ALP_RF, P_BET_RF, P_GAM_RF
      REAL( 8 ) :: XCENT_RF, YCENT_RF
      REAL( 8 ) :: XORIG_RF, YORIG_RF
      REAL( 8 ) :: XCELL_RF, YCELL_RF
      INTEGER VGTYP_RF
      REAL VGTOP_RF

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
        
        FIRSTIME = .FALSE.

        CALL SUBST_BARRIER

!20140519 add subst_global_logical call as done in wr_cgrid
        OK = OPEN3( SA_CGRID_1, FSRDWR3, PNAME )
        CALL SUBST_GLOBAL_LOGICAL( OK, 'AND' )

        IF ( .NOT. OK ) THEN
          XMSG = 'Could not open ' // SA_CGRID_1 // 
     & ' file for update - try to open new'
          CALL M3MESG( XMSG )

          IF ( MYPE .EQ. 0 ) THEN
            ! open sa_conc_1
            IF ( .NOT. OPEN3( SA_CONC_1, FSRDWR3, PNAME ) ) THEN
              XMSG = 'Could not open ' // SA_CONC_1 // 
     & ' file for update '
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ENDIF ! sa_conc_1 opened ?
      
            ! Get description of sa_conc_1
            IF ( .NOT. DESC3( SA_CONC_1 ) ) THEN
              XMSG = 'Could not get file description from ' // SA_CONC_1
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ENDIF ! sa_conc_1 description obtained ?

            EDATE = JDATE
            ETIME = JTIME
            CALL NEXTIME( EDATE, ETIME, RUNLEN )   ! end date & time

            SDATE3D = EDATE
            STIME3D = ETIME
            NLAYS3D = NLAYS

            ! Store MIO Metadata
            NDIMS3D( 1:NVARS3D ) = 4
            L_TSTEP( 1:NVARS3D ) = .True.
            L_LAY  ( 1:NVARS3D ) = .True.
            L_COL  ( 1:NVARS3D ) = .True.
            L_ROW  ( 1:NVARS3D ) = .True.
            L_VEXT ( 1:NVARS3D ) = .False.
            
            CALL LOAD_MIO_FILE ( SA_CGRID_1, NLAYS3D, 1, NLAYS3D,
     &           VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &           VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &           L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &           L_VEXT(1:NVARS3D) )


            ! Create sa_cgrid_1
            IF ( .NOT. OPEN3( SA_CGRID_1, FSNEW3, PNAME ) ) THEN
              XMSG = 'Could not open' // SA_CGRID_1 
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ENDIF !
          ENDIF ! mype0 ?

        ELSE ! 20140519 sa_cgrid already opened by any processor

          IF ( MYPE .EQ. 0 ) THEN

            IF ( .NOT. DESC3( SA_CONC_1 ) ) THEN
              XMSG = 'Could not get' // TRIM(SA_CONC_1) //
     &  'file description'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ENDIF

            TSTEP_RF = TSTEP3D
            NTHIK_RF = NTHIK3D
            NCOLS_RF = NCOLS3D
            NROWS_RF = NROWS3D
            GDTYP_RF = GDTYP3D
            P_ALP_RF = P_ALP3D
            P_BET_RF = P_BET3D
            P_GAM_RF = P_GAM3D
            XCENT_RF = XCENT3D
            YCENT_RF = YCENT3D
            XORIG_RF = XORIG3D
            YORIG_RF = YORIG3D
            XCELL_RF = XCELL3D
            YCELL_RF = YCELL3D
            VGTYP_RF = VGTYP3D
            VGTOP_RF = VGTOP3D

            IF ( .NOT. DESC3( SA_CGRID_1 ) ) THEN
              XMSG = 'Could not get' // TRIM(SA_CGRID_1) // 
     &  'file description'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ENDIF

            IF ( TSTEP_RF .NE. ABS( TSTEP3D ) .OR.
     &           NTHIK_RF .NE. NTHIK3D .OR.
     &           NCOLS_RF .NE. NCOLS3D .OR.
     &           NROWS_RF .NE. NROWS3D .OR.
     &           GDTYP_RF .NE. GDTYP3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( P_ALP_RF .NE. P_ALP3D .OR.
     &           P_BET_RF .NE. P_BET3D .OR.
     &           P_GAM_RF .NE. P_GAM3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XCENT_RF .NE. XCENT3D .OR.
     &           YCENT_RF .NE. YCENT3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XORIG_RF .NE. XORIG3D .OR.
     &           YORIG_RF .NE. YORIG3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XCELL_RF .NE. XCELL3D .OR.
     &           YCELL_RF .NE. YCELL3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( VGTYP_RF .NE. VGTYP3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( VGTOP_RF .NE. VGTOP3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

          ENDIF  ! mype 0

        END IF ! sa_cgrid_1 opened ?

        CALL SUBST_BARRIER

        ALLOCATE ( ISAM_BUFF( NCOLS, NROWS, NLAYS, N_SPCTAG ),
     &     STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating ISAM_BUFF'
          CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        ENDIF

        RETURN   ! Initialization of MIO File

      ENDIF  !firstime

      ISAM_BUFF = 0.0
    
      DO S = 1, N_SPCTAG
        ISAM_BUFF( :,:,:,S ) = ISAM( :,:,:,S_SPCTAG(S),T_SPCTAG(S) )
!20140319        IF ( .NOT. WRITE3( SA_CGRID_1, VNAME3D(S), JDATE, JTIME,
        IF ( .NOT. WRITE3( SA_CGRID_1, VNAM_SPCTAG(S), JDATE, JTIME,
     &          ISAM_BUFF(:,:,:,S)) ) THEN
           XMSG = 'Could not write to ' 
     &           // SA_CGRID_1 
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
      END DO ! S
!      DEALLOCATE( ISAM_BUFF )
      
      return
      end

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE PA_UPDATE
 
      USE GRID_CONF             ! horizontal & vertical domain configuration
      USE CGRID_SPCS, ONLY : N_CGRID_SPC, CGRID_MASK_AERO,N_AE_SPC, N_SPC_DEPV,
     &                       MAP_DEPVtoCGRID, CGRID_MASK_GAS, CGRID_MASK_NR,
     &                       CGRID_MASK_NUM, CGRID_MASK_SRF, CGRID_MASK_TRAC,
     &                       CGRID_MW ! CGRID mechanism species
      USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_MW, DIFF_MASK_NUM, DIFF_MASK_SRF, DIFF_MAP
      USE PA_DEFN               ! Process Anaylsis control and data variables
      USE PAGRD_DEFN            ! PA horiz domain specs
      USE UTILIO_DEFN           ! inherits PARUTILIO
      USE DESID_VARS
      USE CENTRALIZED_IO_MODULE
      USE BUDGET_DEFN
      USE CONST,     ONLY : MWAIR

#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE, SE_DATA_COPY_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE, NOOP_DATA_COPY_MODULE)
#endif
#endif
 
      PUBLIC PA_UPDATE_PROC, PA_UPDATE_EMIS, PA_UPDATE_DDEP,
     &       PA_UPDATE_HADV, PA_UPDATE_AERO

      PRIVATE

      REAL, ALLOCATABLE, SAVE :: CNGRD( :,:,:,: )

      CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PA_UPDATE_PROC( IPR_ID, CGRID, JDATE, JTIME, TSTEP, LCOUPLE )

C-----------------------------------------------------------------------
C Function: Update the Process Analysis output arrays (for IPR only)
 
C Preconditions: None
 
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, July, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified March, 1998 by Jerry Gipson to use units of moles/s for all
C                                       emisssions except aerosols
C  Modified Jun, 1998 by Jerry Gipson to add PING process
C  Modified Jun, 1998 by Jerry Gipson to print warning for unexpected
C                                     processes rather than abort
C  Modified 1/19/99 by David Wong at LM:
C                      -- add DATA_COPY function call to redistribute PA grid
C  Modified 2/26/99 by David Wong at LM:
C                      -- replaced DATA_COPY function with dimension specific
C                         DATA_COPY function and modified its argument list
C                      -- used ifdef statement to distinguish parallel
C                         implementation of IRR calculation which does not
C                         start at the origin
C  Modified 4/13/00 by Jerry Gipson to add AE surface area and correct AE
C                                   deposition sign
C  Modified 4/17/00 by David Wong at LM:
C                      -- bug fix: declare TDDEP as a 2D data rather than 3D,
C                         and use 2DE DATA COPY communication routine rather
C                         than 3D DATA COPY routine
C  Modified 5/4/00 by Jerry Gipson to correct DDEP calculations
C  Modified 22 Nov 00 by J.Young: Dave Wong`s f90 stenex DATA_COPY -
C                                 must explicitlt dimension CGRID, VEMIS, and DDEP
C  Modified 20 Jun 01 by J.Young: VEMIS, assumed shape
C                                 VEMIS assumed converted to ppm/sec form
C                                 NOTE: the arguments to DATA_COPY must have the layer
C                                 dimension the same as the full domain.
C  Modified 28 aug 01 by J.Young: dyn alloc - Use PAGRD_DEFN,
C                                 which uses HGRD_DEFN; replace INTERP3 with INTERPX
C                                 7 Mar 02 - J.Young: add units string variations
C  Modified  9 Oct 03 by J.Gipson: fixed subscript error for NR EMIS IPRs & re-did
C                                  AE EMIS IPRS for VEMIS in ppm units rather than
C                                  ug/m3 units
C  Modified 5 Nov 03 by J. Gipson to fix DDEP IPRs
C  Modified 25 Nov 03 by J Gipson to use step end time for couple/decouple
C  Modified 31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                              domain specifications in one module (GRID_CONF)
C   3 Apr 09 J.Young: replace EMISPRM... include files with simpler implementation
C  21 Jun 10 J.Young: convert for Namelist redesign
C  16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C  11 May 11 D.Wong: incorporated twoway model implementation
C  19 Jan 16 J.Young: flag for couple/decouple
C   6 May 16 J.Young: don`t couple/decouple; copy cgrid locally; only decouple the copy
C  16 Sep 16 J.Young: update for inline procan (IRR)
C  01 Feb 19 D.Wong: Implemented centralized I/O approach
C-----------------------------------------------------------------------


      IMPLICIT NONE 

      ! Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_EMISPRM     ! Emissions processing control parameters
      
      ! Arguments:
      INTEGER, INTENT( IN ) :: IPR_ID   ! Last process called
      REAL   , INTENT( IN ) :: CGRID( :,:,:,: )  ! Conc array
      INTEGER, INTENT( IN ) :: JDATE       !  current date,    format YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME       !  current time,    format HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP( 3 )  ! time step vector (HHMMSS)
                             ! TSTEP(1) = local output step
                             ! TSTEP(2) = sciproc sync. step (chem)
                             ! TSTEP(3) = twoway model time step w.r.t. wrf time
                             !            step and wrf/cmaq call frequency
      LOGICAL, INTENT( IN ) :: LCOUPLE ! Flag for couple/decouple HADV, ZADV, and HDIFF

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      ! Local Variables:
      CHARACTER( 80 ) :: MSG                  ! Message for output log
      CHARACTER( 16 ) :: PNAME = 'PA_UPDATE_PROC'  ! Routine name
      CHARACTER( 16 ) :: UNITS                ! Units of emissions
      CHARACTER( 16 ) :: VNAME                !  input variable name list

      INTEGER ASTAT     ! Allocate status code
      INTEGER C, R, L   ! Loop index for columns
      INTEGER IPRSPC    ! Index for each process species
      INTEGER IPRV      ! Index for each combination of species-process
      INTEGER ISPC      ! Index for each process species within each family
      INTEGER ICG       ! Index for species in cgrid array
      INTEGER ISV       ! Index for species in saved array
      INTEGER MDATE     ! Date of mid-point of timestep
      INTEGER MTIME     ! Time of mid-point of timestep
      INTEGER N         ! Loop index for saved species conc array
      INTEGER PC,PR,PL  ! Index for PA output column
      REAL    DT        ! Timestep in seconds
      INTEGER SDATE     ! Date at end of timestep
      INTEGER STIME     ! Time at end of timestep
      INTEGER I
      LOGICAL LCOUPLE_LOCAL

      REAL :: TCGRID  ( MY_PACOLS,MY_PAROWS,PALEVS )  
      REAL, ALLOCATABLE, SAVE :: D_CNGRD( :,:,:,: )
!-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         IF ( .NOT. ALLOCATED( CNGRD ) ) THEN
           ALLOCATE ( CNGRD( NCOLS,NROWS,NLAYS,N_CGRID_SPC ),
     &                STAT = ASTAT )
           CALL CHECKMEM( ASTAT, 'CNGRD', PNAME )
         END IF
         
         IF ( .NOT. ALLOCATED( CSAV ) ) THEN
           ALLOCATE ( CSAV( NCOLS,NROWS,NLAYS,N_CGRID_SPC ),
     &                STAT = ASTAT )
           CALL CHECKMEM( ASTAT, 'CSAV', PNAME )
         END IF
       
         ALLOCATE ( D_CNGRD( NCOLS,NROWS,NLAYS,N_CGRID_SPC ),
     &              STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'D_CNGRD', PNAME )
      END IF

      ! Load local CGRID Array
      DO I = 1,N_CGRID_SPC
      DO L = 1,NLAYS
      DO R = 1,NROWS
      DO C = 1,NCOLS
         CNGRD(C,R,L,I) = CGRID(C,R,L,I) 
      END DO
      END DO
      END DO
      END DO

      ! Couple all concentrations arrays in decoupled space
      IF ( .NOT. LCOUPLE ) 
     &   CALL COUPLE_PA( IPR_ID, CNGRD, JDATE, JTIME, .FALSE. )      
     
      ! Make sure to couple the saved array if this is VDIFF, the first
      ! process
      IF ( IPR_ID .EQ. IPR_VDIF )
     &   CALL COUPLE_PA( IPR_ID, CSAV, JDATE, JTIME, .FALSE. )      

      ! Calculate Budget Change
      IF (BUDGET_DIAG) CALL STORE_BUDGET( IPR_ID, CNGRD, JDATE, JTIME, .TRUE. )

      ! Calculate change, and save for later. The arrays are in coupled
      ! mass concentration space for all coupled processes and for the
      ! call immediately after the 'decouple' step. Otherwise the arrays
      ! are in decoupled mixing ratio units for gases and decoupled mass
      ! concentration for aerosols.
      DO I = 1,N_CGRID_SPC
      DO L = 1,NLAYS
      DO R = 1,NROWS
      DO C = 1,NCOLS
         D_CNGRD(C,R,L,I) = CNGRD(C,R,L,I) - CSAV(C,R,L,I)
         CSAV(C,R,L,I) = CNGRD(C,R,L,I)
         ! Note that CSAV from the first IPR_ZADV (coupling) process will be
         ! overwritten in pa_update_hadv for use after the main IPR_ZADV
         ! call
      END DO
      END DO
      END DO
      END DO
      
      ! Convert the change in coupled mass concentrations to change in
      ! mixing ratio 
      D_CNGRD( :,:,:,RHOJ_LOC ) = CNGRD( :,:,:,RHOJ_LOC )
      CALL DECOUPLE_PA( IPR_ID, D_CNGRD, JDATE, JTIME, .FALSE. )
          
      ! Compute Contribution for Process Analysis 
      IF ( LIPR ) THEN
         ! Compute delta conc for this process if requested
         DO IPRV = 1,NIPRVAR
            IF ( MASK_IPR_PROC( IPRV,IPR_ID ) ) THEN
               IPRSPC = MAP_IPRVARtoSPC( IPRV )
               DO ISPC = 1, NCGRID( IPRSPC )
                  ICG = MAP_IPRtoCGRID( IPRSPC,ISPC )
        
#ifdef parallel
                  CALL SUBST_DATA_COPY( D_CNGRD, TCGRID, ICG )
#else        
                  TCGRID( :,:,: ) = D_CNGRD( PA_BEGCOL:PA_ENDCOL,PA_BEGROW:PA_ENDROW,
     &                                     PA_BEGLEV:PA_ENDLEV,ICG )
#endif
                  
                  DELC( :,:,:,IPRV ) = DELC( :,:,:,IPRV ) + SPCOEF( IPRSPC,ISPC ) 
     &                 * TCGRID( :,:,: ) 
               END DO
            END IF
         END DO
      END IF


      RETURN
      END SUBROUTINE PA_UPDATE_PROC

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!  Emissions processing section
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE PA_UPDATE_EMIS( VEMIS, JDATE, JTIME, TSTEP )

      IMPLICIT NONE

      ! Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_EMISPRM     ! Emissions processing control parameters
      
      REAL                  :: VEMIS ( :,:,:,: )  ! Emission rates (g/s)
                                                  ! layer dimension
                                                  ! corresponds to NLAYS
      INTEGER, INTENT( IN ) :: JDATE       !  current date,    format YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME       !  current time,    format HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP( 3 )  ! time step vector (HHMMSS)
                             ! TSTEP(1) = local output step
                             ! TSTEP(2) = sciproc sync. step (chem)
                             ! TSTEP(3) = twoway model time step w.r.t. wrf time
                             !            step and wrf/cmaq call frequency

      ! aerosol emission conversion factor terms
      REAL, PARAMETER :: GPKG = 1.0E+03       ! g kg-1
      REAL, PARAMETER :: MGPG = 1.0E+06       ! ug g-1
      REAL, PARAMETER :: REFAC = GPKG / MWAIR ! mol kg -1

      ! ae_conversion factors
      REAL, ALLOCATABLE, SAVE :: PA_EMIS_CONV( : )

      REAL :: DENS    ( NCOLS,NROWS,NLAYS )           ! Density of air
      REAL :: TVEMIS  ( MY_PACOLS,MY_PAROWS,PALEVS )  ! Computed emission rate
       
      INTEGER ASTAT     ! Allocate status code
      INTEGER C, R, L   ! Loop index for columns
      INTEGER IPRSPC    ! Index for each process species
      INTEGER ISPC      ! Index for each process species within each family
      INTEGER IPRV      ! Index for each combination of species-process
      INTEGER ICG       ! Index for species in cgrid array
      INTEGER ISV       ! Index for species in saved array
      INTEGER I
      REAL    DT
      INTEGER MDATE     ! Date of mid-point of timestep
      INTEGER MTIME     ! Time of mid-point of timestep
 
      CHARACTER( 80 ) :: MSG                  ! Message for output log
      CHARACTER( 16 ) :: PNAME = 'PA_UPDATE_EMIS'  ! Routine name
      LOGICAL,SAVE :: FIRST_TIME = .TRUE.

      ! On first call, set pointers to emission species
      IF ( FIRST_TIME ) THEN
         FIRST_TIME = .FALSE.

         IF ( .NOT. ALLOCATED( CNGRD ) ) THEN
           ALLOCATE ( CNGRD( NCOLS,NROWS,NLAYS,N_CGRID_SPC ),
     &                STAT = ASTAT )
           IF ( ASTAT .NE. 0 ) THEN
              MSG = '*** ERROR allocating CNGRD'
              CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
           END IF
         END IF

         ALLOCATE ( PA_EMIS_CONV( N_CGRID_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            MSG = 'Failure allocating PA_EMIS_CONV'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
         END IF

         ! Get conversion factors for aero emissions; incoming
         ! units are in ppmV/sec for ae species, #/mol/sec for
         ! NUM, and m2/mol/sec for SRF. PA_EMIS_CONV Conversion 
         ! factors convert to ug/kg sec, #/kg sec, and m2/kg 
         ! sec, respectively.
         PA_EMIS_CONV = 1.0
         WHERE ( CGRID_MASK_NUM ) 
             PA_EMIS_CONV( : ) = REFAC 
         ELSEWHERE ( CGRID_MASK_SRF ) 
             PA_EMIS_CONV( : ) = REFAC 
         ELSEWHERE
             PA_EMIS_CONV( : ) = REFAC * CGRID_MW( : )
         END WHERE

      END IF  ! LEMFIRST

      ! Compute delta conc due to emissions and adjust vdiff or chem
      ! output if necessary for each output species
      DT = FLOAT( TIME2SEC( TSTEP( 2 ) ) )

      ! Get air density
      call interpolate_var ('DENS', JDATE, JTIME, DENS)
      
      ! Convert Aerosol Emissions To Correct Units and Apply Species
      ! Coefficients. ug m-3 | N m-3 | and m2 m-3. Gas species will
      ! be converted from kmol to kg later in the budget_write step.
      CNGRD = VEMIS  * DT
      DO ICG = 1,N_CGRID_SPC
         IF ( CGRID_MASK_AERO( ICG ) ) 
     &      CNGRD(:,:,:,ICG) = CNGRD(:,:,:,ICG) * 
     &                         DENS( :,:,: ) * PA_EMIS_CONV( ICG )
      END DO
      
      ! Save Changes in Budget Array
      IF (BUDGET_DIAG) CALL STORE_BUDGET( IPR_EMIS, CNGRD, JDATE, JTIME, .FALSE. )

      ! Save Changes in Process Analysis Array
      IF ( LIPR ) THEN

         ! Get midpoint of time step
         MDATE = JDATE
         MTIME = JTIME
         CALL NEXTIME( MDATE, MTIME, SEC2TIME( TIME2SEC( TSTEP( 2 ) ) / 2 ) ) 

         ! Get air density
         call interpolate_var ('DENS', mdate, mtime, DENS)
      
         DO ICG = 1,N_CGRID_SPC
            IF ( CGRID_MASK_AERO( ICG ) ) 
     &         VEMIS(:,:,:,ICG) = VEMIS(:,:,:,ICG) * DT *
     &                            PA_EMIS_CONV(ICG) * DENS( :,:,: )
         END DO
          
         DO IPRV = 1,NIPRVAR
            IF ( MASK_IPR_PROC( IPRV,IPR_VDIF ) .OR. 
     &           MASK_IPR_PROC( IPRV,IPR_EMIS ) ) THEN
               ! Either VDIF or EMIS are needed for this IPR Variable.
               IPRSPC = MAP_IPRVARtoSPC( IPRV ) 
         
               DO ISPC = 1, NCGRID( IPRSPC )       ! foreach species in the family
                  ICG = MAP_IPRtoCGRID( IPRSPC,ISPC )     ! CTM species index in the family
         
                  ! Retrieve Emissions for this Time Step
#ifdef parallel   
                  CALL SUBST_DATA_COPY ( VEMIS, TVEMIS, ICG )
#else           
                  TVEMIS( :,:,: ) = VEMIS( PA_BEGROW:PA_ENDROW,
     &                                  PA_BEGCOL:PA_ENDCOL,
     &                                  PA_BEGLEV:PA_ENDLEV,
     &                                  ICG )
#endif          
                  ! Add up Emissions and/or Vdiff depending on the process mask
                  IF ( MASK_IPR_PROC( IPRV,IPR_EMIS ) )
     &               DELC( :,:,:,IPRV ) = DELC( :,:,:,IPRV ) 
     &                                  + TVEMIS( :,:,: ) * SPCOEF( IPRSPC,ISPC )
                
                  IF ( MASK_IPR_PROC( IPRV,IPR_VDIF ) )
     &               DELC( :,:,:,IPRV ) = DELC( :,:,:,IPRV ) 
     &                                  - TVEMIS( :,:,: ) * SPCOEF( IPRSPC,ISPC )
               END DO
            END IF
         END DO
      END IF

      RETURN
      END SUBROUTINE PA_UPDATE_EMIS
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Dry Deposition processing section
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE PA_UPDATE_DDEP( DDEP, JDATE, JTIME, TSTEP )


      IMPLICIT NONE

      ! Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_EMISPRM     ! Emissions processing control parameters
      
      ! Additional or other Arguments for ENTRY`s
      REAL                  :: DDEP ( :,:,: )     ! Dry dep (Kg/ha)
      INTEGER, INTENT( IN ) :: JDATE       !  current date,    format YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME       !  current time,    format HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP( 3 )  ! time step vector (HHMMSS)
                             ! TSTEP(1) = local output step
                             ! TSTEP(2) = sciproc sync. step (chem)
                             ! TSTEP(3) = twoway model time step w.r.t. wrf time
                             !            step and wrf/cmaq call
                             !            frequency

      ! ae_conversion factors
      REAL, ALLOCATABLE, SAVE :: PA_DEPV_CONV( : )

      REAL, SAVE :: CONVDD       ! Conversion factor for dry dep
      LOGICAL, SAVE :: LDDFIRST = .TRUE. ! Flag for 1st call of ddep processing

      ! 1 hectare = 1.0e4 m**2
      REAL, PARAMETER :: CONVH2M = 1.0E-4

      ! mass to ppm factor
      REAL, PARAMETER :: CONVMW = 1.0E+06 * MWAIR ! ug mol-1

      REAL :: DENS    ( NCOLS,NROWS,NLAYS )  ! Density of air
      REAL :: TDDEP   ( MY_PACOLS,MY_PAROWS )
      REAL :: ZF      ( NCOLS,NROWS,NLAYS )  ! Layer heights

      INTEGER ASTAT     ! Allocate status code
      INTEGER C, R, L   ! Loop index for columns
      INTEGER IPRSPC    ! Index for each process species
      INTEGER ISPC      ! Index for each process species within each family
      INTEGER IPRV      ! Index for each combination of species-process
      INTEGER ICG       ! Index for species in cgrid array
      INTEGER ISV       ! Index for species in saved array
      INTEGER MDATE     ! Date of mid-point of timestep
      INTEGER MTIME     ! Time of mid-point of timestep
      INTEGER I
 
      CHARACTER( 80 ) :: MSG                  ! Message for output log
      CHARACTER( 16 ) :: PNAME = 'PA_UPDATE_DDEP'  ! Routine name
      LOGICAL,SAVE :: FIRST_TIME = .TRUE.


      ! On first call, set pointers to deposition species 
      IF ( FIRST_TIME ) THEN
         FIRST_TIME = .FALSE.           

         ALLOCATE ( PA_DEPV_CONV( N_CGRID_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            MSG = 'Failure allocating PA_DEPV_CONV'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
         END IF

         ! Set layer thickenesses
         CONVDD = 1.0 / ABS ( VGLVS_GD( 2 ) - VGLVS_GD( 1 ) ) 

         PA_DEPV_CONV = 1.0
         DO ICG = 1,N_CGRID_SPC
            ! Initialize DEPV conversion vector assuming all are gases
            IF ( CGRID_MASK_GAS( ICG ) .OR. 
     &           CGRID_MASK_NR( ICG )  .OR.
     &           CGRID_MASK_TRAC( ICG ) ) THEN
               ! Species is a gas
               ! g mol-1 air / g mol -1 species
               IF ( CGRID_MW( ICG ) .GT. 0. ) 
     &            PA_DEPV_CONV( ICG ) = MWAIR / CGRID_MW( ICG ) !* CONVDD

            ELSE IF ( CGRID_MASK_NUM( ICG ) .OR. 
     &                CGRID_MASK_SRF( ICG ) ) THEN
               ! Species is an aerosol number or surface area
               PA_DEPV_CONV( ICG ) = 1.0

            ELSEIF ( CGRID_MASK_AERO( ICG ) ) THEN
               ! Species is an aerosol mass (kg ha-1 -> ug ha-1)
               PA_DEPV_CONV( ICG ) = 1.0E+09
            END IF
         END DO
        
      END IF  ! First Time

      ! Get density x jacobian and layer heights
      call interpolate_var ('DENS', jdate, jtime, DENS)
      call interpolate_var ('ZF', jdate, jtime, ZF)

      ! Convert DDEP to ppm, ug m-3, N m-3, and m2 m-3
      CNGRD(:,:,1,: ) = -DDEP * CONVH2M 
      CNGRD( :,:,2:NLAYS,: ) = 0.0

      DO ICG = 1,N_CGRID_SPC
         IF ( CGRID_MASK_AERO( ICG ) ) THEN
            CNGRD(:,:,1,ICG) = CNGRD(:,:,1,ICG) * PA_DEPV_CONV( ICG ) / ZF( :,:,1 )
         ELSE
            CNGRD(:,:,1,ICG) = 1.0E+06 * CNGRD(:,:,1,ICG) * PA_DEPV_CONV( ICG ) / DENS( :,:,1 ) / ZF(:,:,1)
         END IF
      END DO
 
      ! Save Changes in Budget Array
      IF (BUDGET_DIAG) CALL STORE_BUDGET( IPR_DDEP, CNGRD, JDATE, JTIME, .FALSE. )


C..Store Changes in Process Analysis Array      
      IF ( LIPR .AND. MY_BEGLEV .EQ. 1 ) THEN
C..get midpoint of time step
         MDATE = JDATE
         MTIME = JTIME
         CALL NEXTIME( MDATE, MTIME, SEC2TIME( TIME2SEC( TSTEP( 2 ) ) / 2 ) )

C..get density x jacobian and layer heights
         call interpolate_var ('DENS', mdate, mtime, DENS)
         call interpolate_var ('ZF', mdate, mtime, ZF)

         ! Convert DDEP to ppm, ug m-3, N m-3, and m2 m-3
         DDEP = DDEP * CONVH2M 

         DO ICG = 1,N_CGRID_SPC
            IF ( CGRID_MASK_AERO( ICG ) ) THEN
               DDEP(:,:,ICG) = DDEP(:,:,ICG) * PA_DEPV_CONV( ICG ) / ZF( :,:,1 )
            ELSE
               DDEP(:,:,ICG) = 1.0E+06 * DDEP(:,:,ICG) * PA_DEPV_CONV( ICG ) / DENS( :,:,1 ) / ZF(:,:,1)
            END IF
         END DO
 
         ! Compute delta conc due to ddep and adjust vdiff output if necessary
         DO IPRV = 1, NIPRVAR
            IF ( MASK_IPR_PROC( IPRV,IPR_VDIF ) .OR. 
     &           MASK_IPR_PROC( IPRV,IPR_DDEP ) ) THEN
               ! Either VDIF or EMIS are needed for this IPR Variable.
               IPRSPC = MAP_IPRVARtoSPC( IPRV ) 

               DO ISPC = 1, NCGRID( IPRSPC )                       
                  ICG = MAP_IPRtoCGRID( IPRSPC,ISPC )

#ifdef parallel
                  CALL SUBST_DATA_COPY( DDEP, TDDEP, ICG )
#else
                  TDDEP = DDEP( PA_BEGCOL:PA_ENDCOL,
     &                       PA_BEGROW:PA_ENDROW,
     &                       ICG )
#endif
                  ! Adjust the process analysis output arrays
                  IF ( MASK_IPR_PROC( IPRV,IPR_DDEP ) )
     &                 DELC( :,:,1,IPRV ) = DELC( :,:,1,IPRV ) 
     &                    - TDDEP( :,: ) * SPCOEF( IPRSPC,ISPC )

                  IF ( MASK_IPR_PROC( IPRV,IPR_VDIF ) )
     &                 DELC( :,:,1,IPRV ) = DELC( :,:,1,IPRV ) 
     &                    + TDDEP( :,: ) * SPCOEF( IPRSPC,ISPC )
               END DO   ! ISPC
            END IF
         END DO   ! IPRV
      END IF

      RETURN

      END SUBROUTINE PA_UPDATE_DDEP

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PA_UPDATE_HADV ( CGRID, JDATE, JTIME, TSTEP )

!-----------------------------------------------------------------------
      USE XY_BUDGET
      USE PA_DEFN
      USE UTILIO_DEFN
      USE PAGRD_DEFN
      USE CGRID_SPCS, ONLY : RHOJ_LOC
      use CENTRALIZED_IO_MODULE, only : interpolate_var

      IMPLICIT NONE

      REAL, INTENT( IN )    :: CGRID( :,:,:,: )  ! Conc array
      INTEGER, INTENT( IN ) :: JDATE, JTIME
      INTEGER, INTENT( IN ) :: TSTEP(3)
      INTEGER SDATE     ! Date at end of timestep
      INTEGER STIME     ! Time at end of timestep

      REAL :: TXADV  ( MY_PACOLS,MY_PAROWS,PALEVS )  ! Computed emission rate
      REAL :: TYADV  ( MY_PACOLS,MY_PAROWS,PALEVS )  ! Computed emission rate

      INTEGER :: IPRV
      INTEGER :: ICG, ISPC, IPRSPC, ISV
      LOGICAL,SAVE :: FIRSTIME = .TRUE.
      INTEGER I, L, R, C, ASTAT

      IF ( FIRSTIME ) THEN 
          FIRSTIME = .FALSE.
      END IF

      ! Load scalars in local array 
      DO I = 1,N_CGRID_SPC
      DO L = 1,NLAYS
      DO R = 1,NROWS
      DO C = 1,NCOLS
         CNGRD(C,R,L,I) = CGRID(C,R,L,I)
      END DO
      END DO
      END DO
      END DO
      
      IF ( LIPR ) THEN
         ! Convert X and Y Advection changes to mixing ratio and
         ! concentration units. The DECOUPLE_PA routine needs to have the
         ! correct RHOJ so this is passed from CNGRD
         
         DELC_XADV( :,:,:,RHOJ_LOC ) = CNGRD( :,:,:,RHOJ_LOC )
         CALL DECOUPLE_PA( IPR_XADV, DELC_XADV, JDATE, JTIME, .FALSE. )

         DELC_YADV( :,:,:,RHOJ_LOC ) = CNGRD( :,:,:,RHOJ_LOC )
         CALL DECOUPLE_PA( IPR_YADV, DELC_YADV, JDATE, JTIME, .FALSE. )

         ! Save Changes in Budget Array
         IF (BUDGET_DIAG) CALL STORE_BUDGET( IPR_XADV, DELC_XADV, JDATE, JTIME, .FALSE. )
         IF (BUDGET_DIAG) CALL STORE_BUDGET( IPR_YADV, DELC_YADV, JDATE, JTIME, .FALSE. )

         DO IPRV = 1, NIPRVAR     ! foreach family
            IPRSPC = MAP_IPRVARtoSPC( IPRV ) 
            DO ISPC = 1,NCGRID( IPRSPC )      ! foreach species in the family
               ICG = MAP_IPRtoCGRID( IPRSPC,ISPC )     ! CGRID species index 

#ifdef parallel
               CALL SUBST_DATA_COPY( DELC_XADV, TXADV, ICG )
               CALL SUBST_DATA_COPY( DELC_YADV, TYADV, ICG )
#else
               TXADV = DELC_XADV( PA_BEGCOL:PA_ENDCOL,
     &                         PA_BEGROW:PA_ENDROW,
     &                         PA_BEGLEV:PA_ENDLEV, ICG )
               TYADV = DELC_YADV( PA_BEGCOL:PA_ENDCOL,
     &                         PA_BEGROW:PA_ENDROW,
     &                         PA_BEGLEV:PA_ENDLEV, ICG )
#endif

               ! Modify both the emiss process and the calling process
               IF ( MASK_IPR_PROC( IPRV,IPR_XADV ) ) THEN
                  DELC( :,:,:,IPRV ) = DELC( :,:,:,IPRV )
     &                               + SPCOEF( IPRSPC,ISPC ) * TXADV
               END IF

               IF ( MASK_IPR_PROC( IPRV,IPR_YADV ) ) THEN
                  DELC( :,:,:,IPRV ) = DELC( :,:,:,IPRV )
     &                               + SPCOEF( IPRSPC,ISPC ) * TYADV
               END IF
            END DO
         END DO

         DELC_XADV = 0.0
         DELC_YADV = 0.0
      END IF
      ! Send the scalar array to the budget routine.
      ! Remember these are coupled units coming after horizontal
      ! advection.                   
      IF (BUDGET_DIAG) CALL STORE_BUDGET( BDGSAVE_ID, CNGRD, JDATE, JTIME, .TRUE. )

      ! Save the coupled CNGRD array so it can be differenced and then 
      ! decoupled (converted to mixing ratio) for the IPR_ZADV process
      ! analysis quantityt.
      DO I = 1,N_CGRID_SPC
      DO L = 1,NLAYS
      DO R = 1,NROWS
      DO C = 1,NCOLS
         CSAV(C,R,L,I) = CNGRD(C,R,L,I)
      END DO
      END DO
      END DO
      END DO
      RETURN
 
      END SUBROUTINE PA_UPDATE_HADV
 
!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PA_UPDATE_AERO ( CGRID, JDATE, JTIME )

!-----------------------------------------------------------------------
      USE AERO_BUDGET
      USE PA_DEFN
      USE UTILIO_DEFN
      USE PAGRD_DEFN


      IMPLICIT NONE

      REAL, POINTER         :: CGRID( :,:,:,: )  ! Conc array
      INTEGER, INTENT( IN ) :: JDATE, JTIME

      INTEGER :: ICG, IPRV, IPRSPC, ISPC, ISV
      INTEGER :: I, R, C, L
      LOGICAL,SAVE :: FIRST_TIME = .TRUE.

      REAL :: TCOAG  ( MY_PACOLS,MY_PAROWS,PALEVS )  ! Computed emission ratedd
      REAL :: TCOND  ( MY_PACOLS,MY_PAROWS,PALEVS )  ! Computed emission rate
      REAL :: TNPF   ( MY_PACOLS,MY_PAROWS,PALEVS )  ! Computed emission rate
      REAL :: TGROW  ( MY_PACOLS,MY_PAROWS,PALEVS )  ! Computed emission rate

      ! Allocate some arrays the first time through
      IF ( FIRST_TIME ) THEN
          FIRST_TIME = .FALSE.
      END IF

      IF ( LIPR ) THEN
      DO IPRV = 1, NIPRVAR     ! foreach family
         IPRSPC = MAP_IPRVARtoSPC( IPRV ) 
         DO ISPC = 1,NCGRID( IPRSPC )      ! foreach species in the family
            ICG = MAP_IPRtoCGRID( IPRSPC,ISPC )     ! CGRID species index 

#ifdef parallel
            CALL SUBST_DATA_COPY( AERO_COAG, TCOAG, ICG )
            CALL SUBST_DATA_COPY( AERO_COND, TCOND, ICG )
            CALL SUBST_DATA_COPY( AERO_NPF,  TNPF,  ICG )
            CALL SUBST_DATA_COPY( AERO_GROWTH, TGROW, ICG )
#else
            TCOAG = AERO_COAG( PA_BEGCOL:PA_ENDCOL,
     &                         PA_BEGROW:PA_ENDROW,
     &                         PA_BEGLEV:PA_ENDLEV, ICG )
            TCOND = AERO_COND( PA_BEGCOL:PA_ENDCOL,
     &                         PA_BEGROW:PA_ENDROW,
     &                         PA_BEGLEV:PA_ENDLEV, ICG )
            TNPF  = AERO_NPF ( PA_BEGCOL:PA_ENDCOL,
     &                         PA_BEGROW:PA_ENDROW,
     &                         PA_BEGLEV:PA_ENDLEV, ICG )
            TGROW = AERO_GROWTH( PA_BEGCOL:PA_ENDCOL,
     &                         PA_BEGROW:PA_ENDROW,
     &                         PA_BEGLEV:PA_ENDLEV, ICG )
#endif

            ! Modify both the emiss process and the calling process
            IF ( MASK_IPR_PROC( IPRV,IPR_COAG ) )
     &         DELC( :,:,:,IPRV ) = DELC( :,:,:,IPRV )
     &                           + SPCOEF( IPRSPC,ISPC ) * TCOAG
            IF ( MASK_IPR_PROC( IPRV,IPR_COND ) )
     &         DELC( :,:,:,IPRV ) = DELC( :,:,:,IPRV )
     &                           + SPCOEF( IPRSPC,ISPC ) * TCOND
            IF ( MASK_IPR_PROC( IPRV,IPR_NPF ) )
     &         DELC( :,:,:,IPRV  ) = DELC( :,:,:,IPRV )
     &                           + SPCOEF( IPRSPC,ISPC ) * TNPF
            IF ( MASK_IPR_PROC( IPRV,IPR_GROW ) ) 
     &         DELC( :,:,:,IPRV )= DELC( :,:,:,IPRV )
     &                           + SPCOEF( IPRSPC,ISPC ) * TGROW
         END DO
      END DO
      END IF
 
      ! Convert scalars from trasnport process units to mixing ratio and
      ! concentration units.
      DO I = 1,N_CGRID_SPC
      DO L = 1,NLAYS
      DO R = 1,NROWS
      DO C = 1,NCOLS
         CNGRD(C,R,L,I) = CGRID(C,R,L,I)
      END DO
      END DO
      END DO
      END DO       

      ! Save Changes in Budget Array
      CALL COUPLE_PA( IPR_COAG, AERO_COAG, JDATE, JTIME, .FALSE. )      
      IF (BUDGET_DIAG) CALL STORE_BUDGET( IPR_COAG, AERO_COAG, JDATE, JTIME, .TRUE. )
      
      CALL COUPLE_PA( IPR_COND, AERO_COND, JDATE, JTIME, .FALSE. )      
      IF (BUDGET_DIAG) CALL STORE_BUDGET( IPR_COND, AERO_COND, JDATE, JTIME, .TRUE. )
      
      CALL COUPLE_PA( IPR_NPF, AERO_NPF, JDATE, JTIME, .FALSE. )      
      IF (BUDGET_DIAG) CALL STORE_BUDGET( IPR_NPF,  AERO_NPF, JDATE, JTIME, .TRUE. )
      
      CALL COUPLE_PA( IPR_GROW, AERO_GROWTH, JDATE, JTIME, .FALSE. )      
      IF (BUDGET_DIAG) CALL STORE_BUDGET( IPR_GROW, AERO_GROWTH, JDATE, JTIME, .TRUE. )

      CALL COUPLE_PA( IPR_GROW, CNGRD, JDATE, JTIME, .FALSE. )      
      IF (BUDGET_DIAG) CALL STORE_BUDGET( BDGSAVE_ID, CNGRD, JDATE, JTIME, .TRUE. )

      ! Save Concentration in CSAV Array
      DO I = 1,N_CGRID_SPC
      DO L = 1,NLAYS
      DO R = 1,NROWS
      DO C = 1,NCOLS
         CSAV(C,R,L,I) = CGRID(C,R,L,I)
      END DO
      END DO
      END DO
      END DO
 
      RETURN
 
      END SUBROUTINE PA_UPDATE_AERO

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE DECOUPLE_PA ( IPR_ID, CONC, JDATE, JTIME, LRHOJ )
C-----------------------------------------------------------------------
C Function:
C   Convert units and decouple concentration values in CGRID from transport
C   CONC is a copy of the current CGRID
 
C Preconditions:
 
C Subroutines and functions called:
C   INTERPX, M3EXIT
 
C Revision History:
C  6 May 16 J.Young: initial - part of pa_update.F file
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_MASK_SRF, DIFF_MASK_NUM, DIFF_MAP,
     &                      DIFF_MASK_AERO
      use CENTRALIZED_IO_MODULE, only : interpolate_var

      IMPLICIT NONE   

C Include files:
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:
      REAL,    INTENT( INOUT ) :: CONC( :,:,:,: )   ! concentrations
      INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: IPR_ID     ! Process ID
      LOGICAL, INTENT( IN ) :: LRHOJ      ! Should the advected density be used to decouple

C Parameters:
      REAL, PARAMETER :: GPKG = 1.0E+03   ! g/kg
      REAL, PARAMETER :: MGPG = 1.0E+06   ! micro-g/g
      REAL, PARAMETER :: CONV = GPKG * MGPG

C External Functions:

C File Variables:
      REAL       JACOBM( NCOLS,NROWS,NLAYS )  ! reciprocal midlayer Jacobian
      REAL       RHOJ  ( NCOLS,NROWS,NLAYS )  ! reciprocal Jacobian * air density

C Local Variables:
      CHARACTER( 16 ) :: PNAME = 'DECOUPLE_PA'
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER     V,C,R,L ! loop counters

C-----------------------------------------------------------------------

C retrieve transported RhoJ and Jacobian
      CALL INTERPOLATE_VAR ('JACOBM', JDATE, JTIME, JACOBM)

      IF ( LRHOJ ) THEN
        RHOJ( :,:,: ) = CONC( :,:,:,RHOJ_LOC )
      ELSE
        CALL INTERPOLATE_VAR ('DENSA_J', JDATE, JTIME, RHOJ)
      END IF

C decouple for chemistry and diffusion
C The CONC array is ordered like CGRID but only the DIFF species should
C be modified. Use DIFF_MAP
      DO V = 1,N_CGRID_SPC
          IF ( CGRID_MASK_NUM( V ) .OR. CGRID_MASK_SRF( V ) ) THEN 
            ! Convert to N m-3 and m2 m-3
            DO L = 1,NLAYS
            DO R = 1,NROWS
            DO C = 1,NCOLS
               CONC( C,R,L,V ) = 
     &             CONC( C,R,L,V ) / JACOBM( C,R,L )
            END DO
            END DO
            END DO
          ELSE IF ( CGRID_MASK_AERO( V ) ) THEN
            ! Convert to ug m-3
            DO L = 1,NLAYS
            DO R = 1,NROWS
            DO C = 1,NCOLS
               CONC( C,R,L,V ) = 
     &             CONC( C,R,L,V ) * CONV / JACOBM( C,R,L )
            END DO
            END DO
            END DO
          ELSE IF ( V .NE. RHOJ_LOC ) THEN
            ! Convert to ppmV
            DO L = 1,NLAYS
            DO R = 1,NROWS
            DO C = 1,NCOLS
               CONC( C,R,L,V ) = 
     &             CONC( C,R,L,V ) / RHOJ( C,R,L )
            END DO
            END DO
            END DO
          END IF
      END DO

      RETURN

      END SUBROUTINE DECOUPLE_PA
 
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE COUPLE_PA ( IPR_ID, CONC, JDATE, JTIME, LRHOJ )
C-----------------------------------------------------------------------
C Function:
C   Convert units and couple concentration values in CGRID from transport
C   CONC is a copy of the current CGRID
 
C Preconditions:
 
C Subroutines and functions called:
C   INTERPX, M3EXIT
 
C Revision History:
C  6 May 16 J.Young: initial - part of pa_update.F file
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_MASK_SRF, DIFF_MASK_NUM, DIFF_MAP,
     &                      DIFF_MASK_AERO
      use CENTRALIZED_IO_MODULE, only : interpolate_var

      IMPLICIT NONE   

C Include files:
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:
      REAL,    INTENT( INOUT ) :: CONC( :,:,:,: )   ! concentrations
      INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: IPR_ID     ! Process ID
      LOGICAL, INTENT( IN ) :: LRHOJ      ! Should the advected density be used to decouple

C Parameters:
      REAL, PARAMETER :: GPKG = 1.0E+03   ! g/kg
      REAL, PARAMETER :: MGPG = 1.0E+06   ! micro-g/g
      REAL, PARAMETER :: CONV = GPKG * MGPG

C External Functions:

C File Variables:
      REAL       JACOBM( NCOLS,NROWS,NLAYS )  ! reciprocal midlayer Jacobian
      REAL       RHOJ  ( NCOLS,NROWS,NLAYS )  ! reciprocal Jacobian * air density

C Local Variables:
      CHARACTER( 16 ) :: PNAME = 'COUPLE_PA'
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER     V,C,R,L ! loop counters

C-----------------------------------------------------------------------

C retrieve transported RhoJ and Jacobian
      CALL INTERPOLATE_VAR ('JACOBM', JDATE, JTIME, JACOBM)

      IF ( LRHOJ ) THEN
        RHOJ( :,:,: ) = CONC( :,:,:,RHOJ_LOC )
      ELSE
        CALL INTERPOLATE_VAR ('DENSA_J', JDATE, JTIME, RHOJ)
      END IF

C decouple for chemistry and diffusion
C The CONC array is ordered like CGRID but only the DIFF species should
C be modified. Use DIFF_MAP
      DO V = 1,N_CGRID_SPC
          IF ( CGRID_MASK_NUM( V ) .OR. CGRID_MASK_SRF( V ) ) THEN 
            ! Convert to N m-3 and m2 m-3
            DO L = 1,NLAYS
            DO R = 1,NROWS
            DO C = 1,NCOLS
               CONC( C,R,L,V ) = 
     &             CONC( C,R,L,V ) * JACOBM( C,R,L )
            END DO
            END DO
            END DO
          ELSE IF ( CGRID_MASK_AERO( V ) ) THEN
            ! Convert to ug m-3
            DO L = 1,NLAYS
            DO R = 1,NROWS
            DO C = 1,NCOLS
               CONC( C,R,L,V ) = 
     &             CONC( C,R,L,V ) / CONV * JACOBM( C,R,L )
            END DO
            END DO
            END DO
          ELSE IF ( V .NE. RHOJ_LOC ) THEN
            ! Convert to ppmV
            DO L = 1,NLAYS
            DO R = 1,NROWS
            DO C = 1,NCOLS
               CONC( C,R,L,V ) = 
     &             CONC( C,R,L,V ) * RHOJ( C,R,L )
            END DO
            END DO
            END DO
          END IF
      END DO

      RETURN

      END SUBROUTINE COUPLE_PA
 
      END MODULE PA_UPDATE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE DEPV_DEFN

C-----------------------------------------------------------------------
C Function: deposition velocity interface to the chemistry-transport model

C Revision History:
C   24 Nov 2006 J.Young: initial implementation using Bill Hutzell's and
C                        Tanya Otte's work
C   29 Jan 2010 D. Wong: Eliminate potential race condition at the MYPE = 0
C                        to open the diagnostic file. Eliminate the BARRIER
C                        and the CLOSE3 and OPEN3.
C   21 Jun 2010 J.Young: convert for Namelist redesign
C   27 Jan 2011 J.Young: remove references to AERO3 and AERO4
C   20 Jan 2011 J. Bash: Passed the component fluxes and tstep between vdiff 
C                        & m3dry
C   16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C    5 May 2011 J.Young: remove writing diagnostic output for initial call
C   22 Sep 2011 D. Wong: - incorporated twoway model implemenation
C                        - used a robust way to compute WTIME
C   11 Oct 2011 J.Young: PUBLIC/PRIVATE sections, re-do WTIME computation
C                        and WTIME computation for MOSAIC
C   13 Dec 2011 J.Young: removed separate SOA variables - no longer used
C   18 Sep 2012 D. Wong: invoke INIT_LSM regardless of MOSAIC or ABFLUX option
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C   7 Nov 2014  J. Bash: Modified for the restructuring of vidff. Moved constants and data to 
C                       ASX_DATA_MOD.
C   Aug 2015 D. Wong:    Replaced MYPE with IO_PE_INCLUSIVE to facilitate
C                          parallel I/O implementation
C                        Added a block of code to let non I/O processors to
C                          open CTM_DEPV_DIAG in parallel I/O implementation
C   Feb 2019 D. Wong:    removed all MY_N clauses
C-------------------------------------------------------------------------------
      USE RUNTIME_VARS
      USE CGRID_SPCS, ONLY : N_SPC_DEPV

      IMPLICIT NONE

C no. of deposition velocity model species
      INTEGER, SAVE :: N_GAS_DEPV

C ddep spc conversion factors
      REAL,    ALLOCATABLE, SAVE :: DD_CONV( : )

      PUBLIC DD_CONV, N_GAS_DEPV, DEPV_INIT, GET_DEPV

      PRIVATE

C CGRID for m3dry bi-directional flux calculation
      REAL,    ALLOCATABLE, SAVE :: CGRIDL1( :,:,: )
      REAL,                 SAVE :: DTSEC

C flag for diagnostic DEPV file
      INTEGER, SAVE                      :: N_UNIQUE_GDEPV   ! gas depv
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: UNIQUE_GDEPV( : )
      INTEGER, ALLOCATABLE, SAVE         :: GAS_DEPV_SUR( : )
      LOGICAL, ALLOCATABLE, SAVE         :: GAS_DEPV_FOUND( : )

      INTEGER, SAVE                      :: N_UNIQUE_ADEPV   ! aero depv
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: UNIQUE_ADEPV( : )
      INTEGER, ALLOCATABLE, SAVE         :: AER_DEPV_SUR( : )

      INTEGER, SAVE :: NR_OFFSET            ! Offset to NR start in CGRID

      INTEGER :: GXOFF, GYOFF              ! global origin offset from file
C for INTERPX
      INTEGER, SAVE :: STRTCOLMC2, ENDCOLMC2, STRTROWMC2, ENDROWMC2
      INTEGER, SAVE :: STRTCOLMC3, ENDCOLMC3, STRTROWMC3, ENDROWMC3

      REAL,    ALLOCATABLE, SAVE :: UCROSS( :,:,:)
      REAL,    ALLOCATABLE, SAVE :: VCROSS( :,:,:)
      REAL,    ALLOCATABLE, SAVE :: DLUSE( :,: )
      
      CONTAINS

C-----------------------------------------------------------------------
         FUNCTION DEPV_INIT( JDATE, JTIME, TSTEP, CGRID ) RESULT ( SUCCESS )

         USE HGRD_DEFN
         USE RXNS_DATA           ! chemical mechanism data
         USE CGRID_SPCS          ! CGRID mechanism species
         USE STAGE_DATA
         USE UTILIO_DEFN
         USE LSM_MOD, Only: Init_LSM
         USE MOSAIC_MOD, Only: Tile_Data
         USE BIDI_MOD, Only: Init_Bidi
         USE STAGE_MOD, Only: INIT_STAGE
         USE STAGE_OUTPUT
         USE CONST, ONLY: RGASUNIV, MWAIR

         IMPLICIT NONE

C Includes:
         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:
         INTEGER JDATE, JTIME, TSTEP( 3 )
         REAL, POINTER :: CGRID( :,:,:,: )
         LOGICAL SUCCESS

C Parameters:
         REAL, PARAMETER :: RGAS1 = 1.0 / RGASUNIV ! univ. gas constant reciprocal
         REAL, PARAMETER :: M2PHA = 1.0E+04        ! 1 hectare = 1.0e4 m**2
         REAL, PARAMETER :: CMLMR = 1.0E+06        ! ppmV/Molar Mixing Ratio
         REAL, PARAMETER :: CNVTD = M2PHA / CMLMR / MWAIR ! combined ddep conv factor
 
C Local variables:
         CHARACTER( 16 ), ALLOCATABLE :: ALL_GAS_DEPV( : )
         LOGICAL, ALLOCATABLE         :: AE_DEPV_FOUND( : )
         
         CHARACTER( 16 )  :: PNAME = 'DEPV_INIT'
         CHARACTER( 120 ) :: XMSG = ' '

         INTEGER          NDX, NDX2, NDX3      ! Temp index
         INTEGER          ALLOCSTAT
         INTEGER          J, L, N, S, V, STRT, FINI

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

         N_GAS_DEPV = N_GC_DEPV + N_NR_DEPV + N_TR_DEPV
         N_SPC_DEPV = N_GAS_DEPV + N_AE_DEPV


C Initialize deposition velocities for nondeposited species to zero:
C setting DEPV( N_SPC_DEPV+1,C,R ) = 0.0 accounts for dry dep. species names
C as a subset of the vert. diffused species list
         ALLOCATE ( DD_CONV( N_SPC_DEPV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DD_CONV'
            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

C set dry dep conversion factor (done here so that vdiff doesn`t need the include files)
         S = 0
         DO V = 1, N_GC_DEPV
            S = S + 1
            DD_CONV( S ) = CNVTD * GC_MOLWT( GC_DEPV_MAP( V ) )
         END DO

         DO V = 1, N_AE_DEPV
            S = S + 1
            IF ( AE_SPC( AE_DEPV_MAP( V ) )( 1:3 ) .EQ. 'NUM' ) THEN
               DD_CONV( S ) = M2PHA * 1.0E+03 / MWAIR  ! --> #/Ha
            ELSE IF ( AE_SPC( AE_DEPV_MAP( V ) )( 1:3 ) .EQ. 'SRF' ) THEN
               DD_CONV( S ) = M2PHA * 1.0E+03 / MWAIR  ! --> M**2/Ha
            ELSE
               DD_CONV( S ) = CNVTD * AE_MOLWT( AE_DEPV_MAP( V ) )
            END IF
         END DO

         DO V = 1, N_NR_DEPV
            S = S + 1
            DD_CONV( S ) = CNVTD * NR_MOLWT( NR_DEPV_MAP( V ) )
         END DO

         DO V = 1, N_TR_DEPV
            S = S + 1
            DD_CONV( S ) = CNVTD * TR_MOLWT( TR_DEPV_MAP( V ) )
         END DO

         CALL SUBHFILE ( MET_CRO_2D, GXOFF, GYOFF,
     &                   STRTCOLMC2, ENDCOLMC2, STRTROWMC2, ENDROWMC2 )
         CALL SUBHFILE ( MET_CRO_3D, GXOFF, GYOFF,
     &                   STRTCOLMC3, ENDCOLMC3, STRTROWMC3, ENDROWMC3 )                       

         INIT_GAS_DV:
     &   IF ( N_GAS_DEPV .GT. 0 ) THEN

            ALLOCATE ( ALL_GAS_DEPV( N_GAS_DEPV ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ALL_GAS_DEPV'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            DO V = 1, N_GC_DEPV
               ALL_GAS_DEPV( V ) = GC_DEPV( V )
            END DO
            STRT = N_GC_DEPV
            DO V = 1, N_NR_DEPV
               ALL_GAS_DEPV( V + STRT ) = NR_DEPV( V )
            END DO
            STRT = N_GC_DEPV + N_NR_DEPV
            DO V = 1, N_TR_DEPV
               ALL_GAS_DEPV( V + STRT ) = TR_DEPV( V )
            END DO

C Identify and remove multiple occurrences of gas deposition velocities
            ALLOCATE( GAS_DEPV_FOUND( N_GAS_DEPV ),
     &                GAS_DEPV_SUR  ( N_GAS_DEPV ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating GAS_DEPV_FOUND or GAS_DEPV_SUR'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            GAS_DEPV_FOUND = .FALSE.
            N_UNIQUE_GDEPV = 0

            LOOP_UNIQUE:
     &      DO N = 1, N_GAS_DEPV
               IF ( GAS_DEPV_FOUND( N ) ) CYCLE LOOP_UNIQUE
               DO V = 1, N_GAS_DEPV
                  IF ( ALL_GAS_DEPV( N ) .EQ. ALL_GAS_DEPV( V ) ) THEN
                     IF ( GAS_DEPV_FOUND( V ) ) CYCLE LOOP_UNIQUE
                     N_UNIQUE_GDEPV = N_UNIQUE_GDEPV + 1
                     GAS_DEPV_FOUND( V ) = .TRUE.
                     CYCLE LOOP_UNIQUE
                  END IF
               END DO
            END DO LOOP_UNIQUE

            ALLOCATE( UNIQUE_GDEPV( N_UNIQUE_GDEPV ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating UNIQUE_GDEPV'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

#ifdef Verbose
            write( logdev,* ) ' '
            write( logdev,* ) ' All Gas DEPVs           Requested Gas DEPV'
#endif

            V = 1
            DO N = 1, N_GAS_DEPV
               IF ( GAS_DEPV_FOUND( N ) ) THEN
                  UNIQUE_GDEPV( V ) = ALL_GAS_DEPV( N )
#ifdef Verbose
                  write( logdev,1019 ) n, all_gas_depv( n ), v, unique_gdepv( v )
1019              format( 2x, i5, 1x, a16, 2x, i5, 1x, a16 )
#endif
                  V = V + 1
#ifdef Verbose
               else
                  write( logdev,1019 ) n, all_gas_depv( n ), -1, ' '
#endif
               END IF
            END DO
! Read the CMAQ_Control_STAGE namelist and map deposition species to the
! gas species namelists, and map surrogate species
            Call Map_Stage ( N_UNIQUE_GDEPV, UNIQUE_GDEPV, GAS_DEPV_SUR )

C Identify and remove multiple occurrences of aerosol deposition velocities

            ALLOCATE( AE_DEPV_FOUND( N_AE_DEPV ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating AE_DEPV_FOUND'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
            AE_DEPV_FOUND = .FALSE.
            N_UNIQUE_ADEPV = 0
! use this for mosaic dry deposition
            AERO_UNIQUE:
     &      DO N = 1, N_AE_DEPV
               IF ( AE_DEPV_FOUND( N ) ) CYCLE AERO_UNIQUE
               DO V = 1, N_AE_DEPV
                  IF ( AE_DEPV( N ) .EQ. AE_DEPV( V ) ) THEN
                     IF ( AE_DEPV_FOUND( V ) ) CYCLE AERO_UNIQUE
                     N_UNIQUE_ADEPV = N_UNIQUE_ADEPV + 1
                     AE_DEPV_FOUND( V ) = .TRUE.
                     CYCLE AERO_UNIQUE
                  END IF
               END DO
            END DO AERO_UNIQUE

            ALLOCATE( UNIQUE_ADEPV( N_UNIQUE_ADEPV ) )
            ALLOCATE( AER_DEPV_SUR( N_UNIQUE_ADEPV ) )

#ifdef Verbose
            write( logdev,* ) ' '
            write( logdev,* ) ' Requested Aerosol DEPV and pointer'
#endif

            V = 1
            DO N = 1, N_AE_DEPV
               IF ( AE_DEPV_FOUND( N ) ) THEN
                  UNIQUE_ADEPV( V ) = AE_DEPV( N )
                  AER_DEPV_SUR( V ) = N
#ifdef Verbose
                  write( logdev,1021 ) n, v, unique_adepv( v ), aer_depv_sur( v )
1021              format( 2i5, 1x, a16, i5 )
#endif
                  V = V + 1
               END IF
            END DO

#ifdef Verbose
            write( logdev,* ) ' '
#endif

            ALLOCATE ( CGRIDL1   ( N_GAS_DEPV,NCOLS,NROWS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating CGRIDL1 array'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
            CGRIDL1 = 0.0   

         END IF INIT_GAS_DV

         Tile_Data%Vd_name   = 'Empty'
         Tile_Data%Vd_Out    = .FALSE.
         Tile_Data%n_Vd = 0

         N = 0
         STRT = 1
         FINI = N_GC_DEPV
         DO V = STRT, FINI
            N = N + 1
            NDX = GAS_DEPV_SUR( N )      
            Tile_Data%Vd_Name ( NDX ) = GC_DEPV( N )
            Tile_Data%Vd_Fac  ( NDX ) = GC_DEPV_FAC( N )
            Tile_Data%dep2vdiff ( V ) = NDX 
         END DO

         N = 0
         STRT = N_GC_DEPV + N_AE_DEPV + 1
         FINI = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV
         DO V = STRT, FINI
            N = N + 1
            NDX = GAS_DEPV_SUR( N+N_GC_DEPV )
            Tile_Data%Vd_Name ( NDX ) = NR_DEPV( N )
            Tile_Data%Vd_Fac  ( NDX ) = NR_DEPV_FAC( N )
            Tile_Data%dep2vdiff ( V ) = NDX 
         END DO

         N = 0
         STRT = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV + 1
         FINI = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV + N_TR_DEPV
         DO V = STRT, FINI
            N = N + 1
            NDX = GAS_DEPV_SUR( N + N_GC_DEPV + N_NR_DEPV )
            Tile_Data%Vd_Name ( NDX ) = TR_DEPV( N )
            Tile_Data%Vd_Fac  ( NDX ) = TR_DEPV_FAC( N )
            Tile_Data%dep2vdiff ( V ) = NDX 
         END DO                      
         
         IF ( N_AE_DEPV .GT. 0 ) THEN
            STRT = N_GC_DEPV + 1
            FINI = N_GC_DEPV + N_AE_DEPV
            N = 0
            DO V = STRT, FINI
               N = N + 1
               NDX = N_GC_DEPV + N_NR_DEPV + N_TR_DEPV + N
               Tile_Data%Vd_Name ( NDX ) = AE_DEPV( N )
               Tile_Data%Vd_Fac  ( NDX ) = AE_DEPV_FAC( N )
               Tile_Data%dep2vdiff ( V ) = NDX 
            END DO

            DEP_UNIQUE: DO N = 1, N_SPC_DEPV
               IF( Tile_Data%Vd_Out( N ) ) CYCLE DEP_UNIQUE
               DO V = 1, N_SPC_DEPV
                  IF ( Tile_Data%Vd_Name( N ) .EQ. Tile_Data%Vd_NAME( V ) .AND.
     &                 Tile_Data%Vd_Name( V ) .NE. 'Empty') THEN
                     IF ( Tile_Data%Vd_Out( V ) ) CYCLE DEP_UNIQUE
                     Tile_Data%n_Vd = Tile_Data%n_Vd + 1
                     Tile_Data%Vd_Out( V ) = .TRUE.
                     CYCLE DEP_UNIQUE
                  END IF
               End DO
            END DO DEP_UNIQUE
         END IF
!*****************************

         Call INIT_STAGE( JDATE, JTIME )
            
         IF ( ( DEPV_DIAG .Or. MOSAIC ) .And. IO_PE_INCLUSIVE ) THEN
            CALL OPEN_DEPV( JDATE, JTIME, TSTEP( 1 ) )
         END IF                           

         END FUNCTION DEPV_INIT
C-----------------------------------------------------------------------


         SUBROUTINE GET_DEPV( JDATE, JTIME, TSTEP, CGRID )
C-----------------------------------------------------------------------

         USE CONST
         USE HGRD_DEFN
         USE CGRID_SPCS          ! CGRID mechanism species
         USE UTILIO_DEFN
         USE Mosaic_Mod
         USE ASX_DATA_MOD, Only: GRID_DATA, MOSAIC_DATA
         Use STAGE_OUTPUT
         Use STAGE_MOD,    Only: GAS_X, AERO_X

         IMPLICIT NONE

C Arguments:
         INTEGER, INTENT( IN ) :: JDATE, JTIME     ! simulation date&time, tstep
         INTEGER, INTENT( IN ) :: TSTEP( 3 )       ! time step vector (HHMMSS)
                                                   ! TSTEP(1) = local output step
                                                   ! TSTEP(2) = sciproc sync. step (chem)
                                                   ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                                   !            step and wrf/cmaq call frequency

         REAL, POINTER         :: CGRID( :,:,:,: ) ! concentrations

         INCLUDE SUBST_FILES_ID  ! file name parameters

C Parameters:
         REAL, PARAMETER :: RGAS1 = 1.0 / RGASUNIV ! univ. gas constant reciprocal
         REAL, PARAMETER :: H_VAP = 156.0E+03      ! enthalpy of vaporization (J/mol)
         REAL, PARAMETER :: TREF = 298.0           ! Reference temperature for Cstar
         REAL, PARAMETER :: TREF1 = 1.0 / TREF     ! Reciprocal ref temperature

C Local variables:
         INTEGER          STRT, FINI
         LOGICAL       :: WRITE_TIME_MOS ! write to file flag
         INTEGER, SAVE :: WSTEP = 0      ! local write counter [HHMMSS]
         INTEGER, SAVE :: WSTEP_MOS = 0  ! local write counter [HHMMSS]
         INTEGER       :: CDATE, CTIME   ! step beginning date and time
         INTEGER       :: WDATE, WTIME   ! write date and time

         CHARACTER( 16 )  :: PNAME = 'GET_DEPV        '
         CHARACTER( 120 ) :: XMSG = ' '

         INTEGER C, R, N, V, NDX, J

         LOGICAL, SAVE :: FIRSTIME = .TRUE.

#ifdef Verbose
         integer cw, rw
#endif

         INTERFACE
            SUBROUTINE CGRID_DEPV( GAS_DEPV_FOUND, GAS_DEPV_SUR, CGRID, CGRIDL1 )
               LOGICAL, INTENT( IN )  :: GAS_DEPV_FOUND( : )
               INTEGER, INTENT( IN )  :: GAS_DEPV_SUR( : )
               REAL,    POINTER       :: CGRID( :,:,:,: )
               REAL,    INTENT( OUT ) :: CGRIDL1( :,:,: )
            END SUBROUTINE CGRID_DEPV
         END INTERFACE

C-----------------------------------------------------------------------       

! Made default for Hg bidi JOB 9/12/11
         CALL CGRID_DEPV( GAS_DEPV_FOUND, GAS_DEPV_SUR, CGRID, CGRIDL1 )

         DTSEC  = FLOAT( TIME2SEC( TSTEP( 2 ) ) )
         DO R = 1, NROWS
            DO C = 1, NCOLS
               CALL GAS_X ( JDATE, JTIME, DTSEC, C, R, CGRIDL1( :,C, R ) )
               IF ( N_AE_DEPV .GT. 0 ) CALL AERO_X( CGRID, C, R )
            END DO
         END DO

         IF ( DEPV_DIAG .Or. MOSAIC ) THEN

            WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )         
            IF ( Write_time( WSTEP, TIME2SEC( TSTEP( 1 ) ) ) ) THEN
               WDATE = JDATE; WTIME = JTIME
               CALL NEXTIME( WDATE, WTIME, TSTEP( 2 ) )
               IF ( .NOT. CURRSTEP( WDATE, WTIME, STDATE, STTIME, TSTEP( 1 ),
     &                              CDATE, CTIME ) ) THEN
                  XMSG = 'Cannot get step date and time'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               END IF
               WDATE = CDATE; WTIME = CTIME
               WSTEP = 0

#ifdef parallel_io
               IF ( FIRSTIME ) THEN
                  FIRSTIME = .FALSE.
                  IF ( DEPV_DIAG ) THEN
                     IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                        IF ( .NOT. OPEN3( CTM_DEPV_DIAG, FSREAD3, PNAME ) ) THEN
                           XMSG = 'Could not open ' // TRIM( CTM_DEPV_DIAG )
                           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                        END IF
                     END IF
                  END IF

                  IF ( MOSAIC ) THEN
                     IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                        IF ( .NOT. OPEN3( CTM_DEPV_MOS, FSREAD3, PNAME ) ) THEN
                           XMSG = 'Could not open ' // TRIM( CTM_DEPV_MOS )
                           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                        END IF
                     END IF
                  END IF
               END IF
#endif
            Call Write_depv( WDATE, WTIME )

            END IF ! Write time
         END IF ! DEPV_DIAG .Or. MOSAIC         

         END SUBROUTINE GET_DEPV

      END MODULE DEPV_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/chkgrid.F,v 1.5 2011/10/21 16:10:17 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      FUNCTION CHKGRID( FNAME ) RESULT( SUCCESS )

C-----------------------------------------------------------------------
 
C  Description:
C    Check the grid information and against the first file referenced, and
C    update for next check
 
C  Preconditions:
C    FDESC3 common already loaded from call to DESC3 before calling this routine
 
C  Subroutines and Functions Called:
 
C  Revision History:
C    Oct 2007 Jeff: Make a function and simplify for inline BEIS in CMAQ
C    Feb 2011 S.Roselle: Replaced I/O API include files with UTILIO_DEFN
C    10 May 2011 D.Wong: incorporated twoway model implementation
 
C-----------------------------------------------------------------------
C Modified from:

C Project Title: EDSS Tools Library
C File: @(#)$Id: chkgrid.F,v 1.5 2011/10/21 16:10:17 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/chkgrid.F,v $
C Last updated: $Date: 2011/10/21 16:10:17 $
C-----------------------------------------------------------------------

      USE UTILIO_DEFN

      IMPLICIT NONE

C Includes:

C Arguments:
      CHARACTER( * ), INTENT( IN )  :: FNAME   ! File name
      LOGICAL                       :: SUCCESS ! true: comparison succeeded

C External Functions:

C Parameters:
      CHARACTER( 10 ), PARAMETER :: BLANK10  = ' '

C Local variables:
      CHARACTER( 16 ), SAVE :: GRDNM = ' ' ! grid nam
      INTEGER,   SAVE :: GDTYP  = -1       ! i/o api grid type code
      INTEGER,   SAVE :: NCOLS  = 0        ! number of columns in grid
      INTEGER,   SAVE :: NROWS  = 0        ! number of rows in grid
      REAL( 8 ), SAVE :: XORIG  = 0.D0     ! x-origin of grid
      REAL( 8 ), SAVE :: YORIG  = 0.D0     ! y-origin of grid
      REAL( 8 ), SAVE :: XCENT  = 0.D0     ! x-center of projection
      REAL( 8 ), SAVE :: YCENT  = 0.D0     ! y-center of projection
      REAL( 8 ), SAVE :: XCELL  = 0.D0     ! x-dim of cells
      REAL( 8 ), SAVE :: YCELL  = 0.D0     ! y-dim of cells
      REAL( 8 ), SAVE :: P_ALP  = 0.D0     ! projection alpha
      REAL( 8 ), SAVE :: P_BET  = 0.D0     ! projection beta
      REAL( 8 ), SAVE :: P_GAM  = 0.D0     ! projection gamma
      LOGICAL,   SAVE :: OFFLAG = .FALSE.  ! true: subgrid offset has been set
      INTEGER,   SAVE :: XOFF   = 0        ! subgrid offset (x-sub = x - xoff)
      INTEGER,   SAVE :: YOFF   = 0        ! subgrid offset
      INTEGER,   SAVE :: XOFF_A = 0        ! tmp subgrid offset (x-sub = x - xoff)
      INTEGER,   SAVE :: YOFF_A = 0        ! tmp subgrid offset
!     INTEGER       L       ! length of file description
      INTEGER       NC                     ! test number of columns
      INTEGER       NR                     ! test number of rows
      INTEGER       XO                     ! test x-offset  
      INTEGER       YO                     ! test y-offset  

      REAL( 8 )     :: CHK_X   ! test val for checking subgrid even with grid
      REAL( 8 )     :: CHK_Y   ! test val for checking subgrid even with grid

      LOGICAL, SAVE :: GINIT  = .FALSE. ! true: grid settings have been initialized

      CHARACTER(  12 ) :: FILETYPE = 'gridded file'
      CHARACTER( 300 ) :: MESG     ! message buffer

      CHARACTER( 16 ) :: PNAME = 'CHKGRID' ! procedure name

C-----------------------------------------------------------------------

      SUCCESS = .TRUE.

#ifndef mpas
      NC = NCOLS3D
      NR = NROWS3D

C If grid information has already been initialized, then compare existing to this file
      IF ( GINIT ) THEN

#ifndef twoway
C Check settings that must be consistent for exact grid match
         IF ( NC .NE. NCOLS            .OR.
     &        NR .NE. NROWS            .OR.
     &        DBLERR( XORIG3D, XORIG ) .OR.
     &        DBLERR( YORIG3D, YORIG ) ) THEN
            SUCCESS = .TRUE.
            MESG = 'WARNING: Columns, rows, x-origin, or ' //
     &             'y-origin for ' // FNAME // ' in ' //
     &             CRLF() // BLANK10 // FILETYPE // 
     &             ' are inconsistent with GRID NAME: ' // 
     &             TRIM( GRDNM )
            CALL M3MSG2( MESG ) 
         END IF
#endif

         XOFF = 0
         YOFF = 0

C Check settings that must be consistent for grids and subgrids
         IF ( GDTYP3D .NE. GDTYP        .OR.
     &        DBLERR( XCELL3D, XCELL  ) .OR.
     &        DBLERR( YCELL3D, YCELL  ) .OR.
     &        DBLERR( XCENT3D, XCENT  ) .OR.
     &        DBLERR( YCENT3D, YCENT  ) .OR.
     &        DBLERR( P_ALP3D, P_ALP  ) .OR.
     &        DBLERR( P_BET3D, P_BET  ) .OR.
     &        DBLERR( P_GAM3D, P_GAM  ) ) THEN
            SUCCESS = .FALSE.
            MESG = 'ERROR: Grid type, cell sizes, or ' //
     &             'grid projection for ' // FNAME // ' in '//
     &              CRLF() // BLANK10 // FILETYPE // 
     &             ' are inconsistent with with GRID NAME: ' 
     &             // TRIM( GRDNM )
            CALL M3MSG2( MESG ) 
         END IF

C Ensure that origins are compatible with each other by making sure they line up
C based on the cell sizes
         CHK_X  = ( XORIG3D - XORIG ) / XCELL
         CHK_X  = CHK_X - INT( CHK_X )
         CHK_Y  = ( YORIG3D - YORIG ) / YCELL
         CHK_Y  = CHK_Y - INT( CHK_Y )
         IF ( DBLERR( CHK_X, 0.D0 ) .OR.
     &        DBLERR( CHK_Y, 0.D0 ) ) THEN
            SUCCESS = .FALSE.
            MESG = 'ERROR: Grid origins not compatible ' //
     &             'between ' // FNAME // ' in ' // 
     &             CRLF() // BLANK10 // FILETYPE // 
     &             ' and set by GRID NAME: ' // TRIM( GRDNM )
            CALL M3MSG2( MESG ) 
         END IF

C If offset has been set, then check to ensure its the same
         IF ( OFFLAG ) THEN

C If file has different origin from the subgrid...
            IF ( XORIG3D .NE. XORIG .OR. 
     &           YORIG3D .NE. YORIG ) THEN

               XO = INT( ( XORIG3D - XORIG ) / XCELL )
               YO = INT( ( YORIG3D - YORIG ) / YCELL )
               IF ( XOFF .NE. XO .OR.
     &              YOFF .NE. YO ) THEN
                  SUCCESS = .FALSE.
                  MESG = 'WARNING: Subgrid offset for ' //
     &                   FNAME // ' in ' // CRLF() // BLANK10// 
     &                   FILETYPE // 'is ' //
     &                  'inconsistent with with GRID NAME: ' 
     &                   // TRIM( GRDNM )
                  CALL M3MSG2( MESG ) 
               END IF

C If file has same origin as subgrid
            ELSE



C Check that current subgrid is the same as the previous subgrid
               IF ( NC .NE. NCOLS            .OR.
     &              NR .NE. NROWS            .OR.
     &              DBLERR( XORIG3D, XORIG ) .OR.
     &              DBLERR( YORIG3D, YORIG ) ) THEN
                  SUCCESS = .FALSE.
                  MESG = 'WARNING: Columns, rows, x-origin, ' //
     &                   'or y-origin for ' // FNAME // ' in ' 
     &                   // CRLF() // BLANK10 // FILETYPE // 
     &                   'are inconsistent with values from ' // 
     &                   TRIM( GRDNM)
                  CALL M3MSG2( MESG ) 
               END IF

            END IF

C If offset for final subgrid hasn't been set yet...
         ELSE

C Compute possible offset from upper right hand corner, and if there is one, set flag
!?          XOFF_A = INT( ( XORIG   + NCOLS * XCELL   )
!?   &                  - ( XORIG3D +    NC * XCELL3D ) ) / XCELL
!?          YOFF_A = INT( ( YORIG   + NROWS * YCELL   )
!?   &                  - ( YORIG3D +    NR * YCELL3D ) ) / YCELL

C Compute possible offset from origin, and if so, set flag
            XOFF_A = INT( ( XORIG3D - XORIG ) / XCELL )
            YOFF_A = INT( ( YORIG3D - YORIG ) / YCELL )
               
C Reset origin and number of cells to latest grid
            GRDNM = GDNAM3D

C Store grid and offset parameters
            XOFF = XOFF_A
            YOFF = YOFF_A
            IF ( XOFF .NE. 0 .OR. YOFF .NE. 0 ) OFFLAG = .TRUE.
            XORIG = XORIG3D
            YORIG = YORIG3D
            NCOLS = NC
            NROWS = NR

         END IF

C Store initial grid information
      ELSE

         GINIT = .TRUE.
         GRDNM = GDNAM3D
         GDTYP = GDTYP3D
         P_ALP = P_ALP3D
         P_BET = P_BET3D
         P_GAM = P_GAM3D
         XCENT = XCENT3D
         YCENT = YCENT3D
         XORIG = XORIG3D
         YORIG = YORIG3D
         XCELL = XCELL3D
         YCELL = YCELL3D
         NCOLS = NC
         NROWS = NR

         MESG = 'NOTE: Grid settings initialized using ' // 
     &          TRIM( FNAME ) // ' in ' // CRLF() // BLANK10 // 
     &          FILETYPE // ' GRID NAME: ' // TRIM( GRDNM )

         CALL M3MSG2( MESG )

      END IF

      IF ( .NOT. SUCCESS ) THEN

         MESG = 'ERROR: Grid parameters for ' // FNAME // ' in ' //
     &          CRLF() // BLANK10 // FILETYPE //
     &          ' are inconsistent with GRID NAME: ' // TRIM( GRDNM )
         CALL M3MSG2( MESG )

      END IF
#endif

      RETURN

      CONTAINS

         LOGICAL FUNCTION DBLERR( PD, QD )

         IMPLICIT NONE

         REAL( 8 ), INTENT( IN ) :: PD
         REAL( 8 ), INTENT( IN ) :: QD

         DBLERR = ( ( PD - QD )*( PD - QD ) .GT. 1.0D-12 * ( PD*PD + QD*QD + 1.0D-5 ) )

         RETURN

         END FUNCTION DBLERR

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C......................................................................
      MODULE PA_GLOBAL
 
C Contains: Mech and Grid data used in the Process Analysis Control Program
 
C Dependent Upon: Nothing
C Revision History
C Prototype created by Bill Hutzell, June, 2014 based in PA_GLOBAL.EXT
C  from PROCAN version 5.0.2
C PA_GLOBAL.EXT History:
C  Created by Jerry Gipson, May, 1997
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified May 2002 by Jerry Gipson to increase number of products (for saprc99)
C  Aug 2011 Jeff Young: Removed domain data
  
C......................................................................

      USE RXNS_DATA, Only: ! chemical mechanism arrays and data 
     & NRXNS, MXPRD, NUMB_MECH_SPC,
     & RXLABEL, IRR, CHEMISTRY_SPC, NREACT, IRXBITS, SC, NPRDCT

      IMPLICIT NONE


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Dimensioning parameters for species and mechanism data
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER, PARAMETER :: MXSPEC = 1000 ! Number of species in mechanism
      
      INTEGER, PARAMETER :: MXALLSPC = 4 * MXSPEC + 1

      INTEGER, PARAMETER :: MXRXNS   = NRXNS ! Maximum number of Reactions in mechanism
      
      INTEGER, PARAMETER :: MXRPP    = MXPRD + 3 ! Maximum number of Products and reactants

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Declarations for species and mechanism data
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      END MODULE PA_GLOBAL
 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE  CZANGLE( JDATE, JTIME, NX, NY )

C----------------------------------------------------------------------
C Description:
C   Computes cosine of zenith angle for routine HRBIO()
C   The zenith angle is the angle measured from the zenith to the line of
C   sight to the sun
 
C Preconditions:
C   JDATE:JTIME represented in GMT
 
C Subroutines and Functions called:  none
 
C Revision History:
C Revision History:
C   Prototype 12/95 by Carlie J Coats, Jr., adapted from UAM-BEIS
C       subroutines SOLAR() and ZANGLE() for SMOKE-BEIS2:  produces
C       COS( ZENITH )
C
C   Revised 8/96 by SL and CJC: algorithm change to match UAM BEIS2
C       algorithm
C
C   11/99: by Jeff Vukovich taken from v4.2 SMOKE prototype
C   10/06: yoj
C   02/11: Shawn Roselle: Replaced I/O API include files with UTILIO_DEFN
C   03/12: J. Bash: Bound COSZEN against numerical rounding errors
C   11/14: J. Bash: Lat and Lon now stored in ASX_DATA_MOD to reduce redundant
C             memory allocation and reads from file.
C   07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C   07 May 18 D. Schwede: Updated to have coszen defined in ASX_DATA_MOD
C   24 Jul 18 C. Nolte: removed call to INIT_MET that was causing conflict.
C             Met should already be initialized by this point.
C----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling System
C File: @(#)$Id: czangle.F,v 1.4 2012/03/28 16:05:37 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/czangle.F,v $
C Last updated: $Date: 2012/03/28 16:05:37 $ 
C----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE ASX_DATA_MOD, Only: Grid_Data, Met_Data
      USE CONST

      IMPLICIT NONE

C Arguments:

      INTEGER, INTENT( IN )  :: JDATE   ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN )  :: JTIME   ! current simulation time (HHMMSS)
      INTEGER, INTENT( IN )  :: NX      ! no. columns
      INTEGER, INTENT( IN )  :: NY      ! no. rows


C Parameters:
 
      REAL, PARAMETER ::
     &            AA =   0.15,
     &            BB =   3.885,
     &            CC = - 1.253,
     &          SIGA = 279.9348,
     &          SDEC =   0.39784984,  ! SIN (23^26'37.8") the declination angle
     &           D60 = 1.0 / 60.0,
     &           D15 = 1.0 / 15.0,
     &           D24 = 1.0 / 24.0,
     &        ROTDAY = 360.0 / 365.242 ! fraction of a complete rotation per day

C Local variables:

      INTEGER    IOS, R, C
      REAL       SLA, GMT,  TK, DAD, DF,
     &           DESIN, DECOS, DESIN2, DECOS2, SIG, DECSIN, DECCOS,
     &           EQT, TST, HRANGL
                     
      REAL, ALLOCATABLE, SAVE :: SINLAT( :,: )
      REAL, ALLOCATABLE, SAVE :: COSLAT( :,: )  

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 16 ) :: PNAME = 'CZANGLE'   !  procedure name

C----------------------------------------------------------------------

C compute sine of lat and lon first time through

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

         ALLOCATE( SINLAT( NX,NY  ), STAT=IOS )
         CALL CHECKMEM( IOS, 'SINLAT', PNAME )

         ALLOCATE( COSLAT( NX,NY ), STAT=IOS )
         CALL CHECKMEM( IOS, 'COSLAT', PNAME )

         DO R = 1, NY
            DO C = 1, NX
               SLA = PI180 * Grid_Data%LAT( C,R )
               SINLAT( C,R ) = SIN( SLA )
               COSLAT( C,R ) = COS( SLA )
            END DO
         END DO

      END IF   ! if firstime

C Convert time to hours and add time-zone offset
      
      GMT    = FLOAT( JTIME / 10000 )                        !  hr part
     &       + D60 * ( FLOAT( MOD( JTIME / 100 , 100 ) )     !  min part
     &       + D60 *   FLOAT( MOD( JTIME, 100 ) ) )          !  sec part
      DAD    = GMT * D24 + MOD( JDATE, 1000 )
      DF     = ROTDAY * PI180 * DAD      !  The terrestrial-rotation angle
           
      DESIN  = SIN( DF )          !  SINE   of this angle
      DECOS  = COS( DF )          !  COSINE of this angle
           
      DESIN2 = SIN( DF + DF )     !  SINE   of twice the angle
      DECOS2 = COS( DF + DF )     !  COSINE of twice the angle
           
      SIG  =  DF
     &     +  PI180 * ( SIGA
     &                + 1.914827 * DESIN  - 0.079525 * DECOS
     &                + 0.019938 * DESIN2 - 0.00162  * DECOS2 )
           
C The sine and cosine of the declination
      
      DECSIN = SDEC * SIN( SIG )
      DECCOS = SQRT( 1.0 - DECSIN * DECSIN )
           
C The equation of time adjustment
      
      EQT = 0.123470 * DESIN  - 0.004289 * DECOS
     &    + 0.153809 * DESIN2 + 0.060783 * DECOS2

      DO R = 1, NY
         DO C = 1, NX

            TK     =  GMT + Grid_Data%LON( C,R ) * D15 !  Distance in hours from LON=0
            TST    =  TK - EQT                         !  true solar time
            HRANGL =  PI180 * 15.0 * ABS( TST - 12.0 ) !  hour angle
                   
C Compute the cosine of zenith angle (sine of the solar elevation)
          
            MET_DATA%COSZEN( C,R ) = DECSIN * SINLAT( C,R )
     &                    + DECCOS * COSLAT( C,R ) * COS( HRANGL )

C Bound against numerical rounding errors

            MET_DATA%COSZEN( C,R ) = MIN( MAX( MET_DATA%COSZEN( C,R ), -1.0 ), 1.0 )
                   
         END DO
      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE HGSIM

C-----------------------------------------------------------------------
C Function: This module contains the code to predict bidirectional
C          exchanges between the atmosphere and surface media using a two
C          layer resistance-capacitance model. Fluxes are parameterized by
C          applying Fick's law  across the atmospheric surface media
C          concentration gradient.
C
C Revision History:
C      12 Aug  2008  J. Bash initial implementation
C       2 Apr  2009  J. Bash for solar irradation on the order of 1e-3 w/m2
C                           the mercury surface water photo redox scheme
C                           became unstable. A conditional statement was
C                           added to correct this instability.
C       4 June 2009 J. Bash Corrected the time stamp on WRASX_MEDIA to be
C                           consistant with other CMAQ modules reported by
C                          (T.Myers)
C     22 Oct   2009 J. Bash Corrected a units conversion error in ASWX and ATX
C                           reported by (P. Pongprueksa) and added a more
C                           robust soil diffusion model adapted from the
C                           Community Land Model 3.5.
C     13 Sept 2011  J. Bash Updated the Hg bidi model to share data with the 
C                           NH3 bidirectional exchange model in a more general
C                           framework using BIDI_MOD.F and LSM_MOD.F modules. 
C                           Hg bidirectional exchange is now a run time option. 
C     17 Jan  2012  J. Bash Removed the dependence on the LAPACK libraries
C                           and found analytical solutions to all the Hg
C                           exchange equations.
C     14 Feb 2013   J. Bash Added support for the NLCD 40 (2006) land use data
C     10 Feb 2019   D. Wong Implemented centralized I/O approach, removed all MY_N clauses
C
C  References:
C
C  Bash, J.O. 2010, Description and initial simulaiton of a dynamic bi-directional 
C     surface exchange model for mercury in CMAQ, J. Geophys.
C     Res., 115, D06305
C  Mason, R.P., J.R. Reinfelder, F.M.M. Morel, 1996, Uptake, toxicity, and
C     trophic transfer of mercury in a coastal diatom, Environ. Sci. Technol.
C     30, 1835-1845
C  Scholtz, M.T., B.J. Van Heyst, W.H. Schroeder, 2003, Modelling of mercury
C     emissions from background soils, Sci. Tot. Environ. 304, 185-207
C  Trapp S. and Matthies, 1995, Generic one-compartment model for uptake of
C     organic chemicals by foliar vegetations. Environ. Sci. Technol. 29,
C     2333-2338
C  Trapp, S., 2004, Plant uptake and transport for netural and ionic chemicals,
C     Environ. Sci. Pollut. Res. 11, 33-39
C  Whalin, L., E.-H. Kim, R. Mason, 2007, Factors influencing the oxidation,
C     reduciton, methylation and demethylation of mercury species in costal
C     water, Marine Chem. 107, 278-294
C-----------------------------------------------------------------------
      IMPLICIT NONE

!    Shared variables

!     Private variables used in this routine and
      REAL, ALLOCATABLE, SAVE, PRIVATE :: fevgrn(:,:)  ! fraction of evergreen land use
      REAL, ALLOCATABLE, SAVE, PRIVATE :: f_wat(:,:)   ! fraction of water land use

      REAL, PARAMETER, PRIVATE :: zsurf  = 1.0 ! ocean slab depth (m)
      REAL, PARAMETER, PRIVATE :: ZG = 1.0e-2
      REAL, PARAMETER, PRIVATE :: MWHG   = 200.6
      REAL, PARAMETER, PRIVATE :: MWHGII = 271.5
      CHARACTER( 96 ), PRIVATE :: XMSG = ' '

      CHARACTER( 80 ), SAVE, Private   :: LAND_SCHEME
      REAL, SAVE, PRIVATE  :: ZC, ZM   ! g/m2 of model surface media
      REAL, SAVE, PRIVATE  :: kam      ! Leaf Water partitioning coef mol water g-1 leaf dry mass
      REAL, SAVE, PRIVATE  :: kac      ! mol air g-1 leaf dry mass
      REAL, SAVE, PRIVATE  :: MV_air

! variable needed for analytical solutions of exchange equations
      REAL, PRIVATE :: KO(2,2)
      REAL, PRIVATE :: EIVAL(2)
      REAL, PRIVATE :: VR(2,2)
      REAL, PRIVATE :: ax     ! coefficients used of the  
      REAL, PRIVATE :: bx     ! quadratic and cubic equations
      REAL, PRIVATE :: cx     ! ATX and ASWX
      REAL, PRIVATE :: Qx     ! coefficients used to solve for 
      REAL, PRIVATE :: Rx     ! the roots of the cubic equation
      REAL, PRIVATE :: ev1    ! Temporary variables used to 
      REAL, PRIVATE :: ev2    ! calculate the eigen vectors 
      REAL, PRIVATE :: ev3    ! in ATX and ASWX
      REAL, PRIVATE :: evmax  !
      REAL, PRIVATE :: DetKO  ! Variables used to solve for the 
      REAL, PRIVATE :: DetK1  ! non-homogeneous part of the solution
      REAL, PRIVATE :: DetK2  ! a system of equations 
      REAL, PRIVATE :: DetEV  ! Variables used to solve for the 
      REAL, PRIVATE :: DetE1  ! integration constants in the 
      REAL, PRIVATE :: DetE2  ! system of equations using Cramer's Rule
      
      INTEGER, PRIVATE :: NC
      INTEGER, PRIVATE :: i
      INTEGER, PRIVATE :: j
      
      REAL, PRIVATE :: B( 2 )   ! Surface media concentration vector
      REAL, PRIVATE :: NHS( 2 ) ! non-homogenious solution

C input/output parameters

      INTEGER, PRIVATE :: N_AQ_CONC  ! aqueous media concentrations
      INTEGER, PRIVATE :: N_GAS_CONC ! gaseous media concentrations
      INTEGER, PRIVATE :: N_SOL_CONC ! solid media concentrations

      CHARACTER( 16 ), ALLOCATABLE, PRIVATE :: MEDIA_NAMES( : )

      CONTAINS

         SUBROUTINE INIT_HGSIM( JDATE, JTIME )

         USE HGRD_DEFN           ! horizontal grid specifications
         USE UTILIO_DEFN
         USE ASX_DATA_MOD
         USE LSM_MOD
         USE Bidi_Mod
         Use MOSAIC_MOD, Only: Tile_Data 

         IMPLICIT NONE

         INCLUDE SUBST_FILES_ID  ! file name parameters

         INTEGER, INTENT( IN ) :: JDATE
         INTEGER, INTENT( IN ) :: JTIME

         CHARACTER( 16 ) :: PNAME = 'INIT_HGSIM'
         CHARACTER( 96 ) :: MSG = ' '

         INTEGER  V, L, C, R

C--------------------------------------------------------------------------

         IF ( .NOT. ALLOCATED ( fevgrn ) ) THEN
            ALLOCATE ( fevgrn( NCOLS,NROWS ) )
            fevgrn( :,: ) = 0.0
         END IF
         IF ( .NOT. ALLOCATED ( f_wat ) ) THEN
            ALLOCATE ( f_wat( NCOLS,NROWS ) )
            f_wat( :,: ) = 0.0
         END IF
 
         DO C = 1, NCOLS
            DO R = 1, NROWS
               DO L = 1, Tile_data%N_LUFRAC
                  IF(Tile_data%CAT_LU(L) .EQ. 'EVEFORN' .Or. 
     &               Tile_data%CAT_LU(L) .EQ. 'EVEFORB' ) THEN
                     fevgrn(c,r) = fevgrn(c,r) + Tile_data%lufrac(c,r,l)
                  End IF
                  IF(Tile_data%CAT_LU(L) .EQ. 'MIXFOR') THEN
                     fevgrn(c,r) = fevgrn(c,r) + Tile_data%lufrac(c,r,l)
                  End IF                                    
                  IF(Tile_data%CAT_LU(L) .EQ. 'WATER') THEN
                     f_wat(c,r) = f_wat(c,r) + Tile_data%lufrac(c,r,l)
                  END IF
               END DO
            END DO
         END DO

         RETURN

!------------------------------------------------------------------------------
! Error handling section
!------------------------------------------------------------------------------
1001     CONTINUE
         CALL M3EXIT( pname, jdate, jtime, xmsg, xstat1 )
C-------------------------------------------------------------------------------
C Format statements.
C-------------------------------------------------------------------------------

9001     FORMAT( 'Failure reading ', a, 1x, 'from ', a )

         RETURN

         END SUBROUTINE INIT_HGSIM
!------------------------------------------------------------------------------
! Gets compensation points for STAGE
!------------------------------------------------------------------------------
         Subroutine Get_Hg_Comp( Hg_st, Hg_cut, Hg_grnd, Hg_wat, Hg_atm, H_wat, H_soil, r, c )
 
         USE BIDI_MOD
         USE ASX_DATA_MOD

         IMPLICIT NONE

         REAL,    INTENT( IN )   :: H_wat, H_soil                      ! Effective H for Hg(0)
         REAL,    INTENT( IN )   :: Hg_atm                             ! atm conc and land use fractions
         INTEGER, INTENT( IN )   :: c,r                                ! column and row
         REAL,    INTENT( OUT )  :: Hg_st, Hg_cut, Hg_grnd, Hg_wat     ! compensation points     
!********* reduction and partioning terms *******************************
         REAL :: Kow     ! Hg(0) Octanol water partioning coefficient
         REAL :: Kpwc    ! Hg(0) air-vegetation surface partitioning coefficient
         REAL :: Kpwm    ! Hg(0) air-mesophyll partitioning coefficient
!********* vegetation poperties *****************************************
         REAL :: lm   ! leaf mesophyll lipid fraction
         REAL :: lc   ! cuticular wax mesophyll lipid fraction
         REAL :: Wp   ! water content fraction of the leaf
         REAL :: bc   ! Emprical coefficeint to describe differences in plant lipids
!************************************************************************
         Real    :: del      
         If ( Met_Data%WR( c,r ) .LE. 0.0 ) Then
               del = 0.0
         Else 
               del = Met_Data%WR( c,r ) / ( 0.2e-3 * Met_Data%Veg( c,r ) * Met_Data%LAI( c,r ) )   ! refer to SiB model
               del = min(del,1.0)
         End If
!***************** canopy parameters *********************************
         Kow  = 4.15    ! For Hg, Mason 1996
         lm   = 2.0e-2  ! From Trapp and Matthis 1995
         lc   = 2.0e-2  ! Assumed cuticular wax lipid content
         Wp   = 0.80    ! leaf water fraction, Trapp and Mathis 1996
         bc   = 0.95    ! For barley, Trapp and Mathis 1996
         Kpwc = (Wp+lc*1.0/0.822*Kow**bc)                 ! unitless
         Kpwm = (Wp+lm*1.0/0.822*Kow**bc)                 ! unitless
! Partitioning coeficients following the methodology of the PEM model
         kac = Kpwc*(1.0-del) +  ! evasion from dry cuticles
     &         Kpwc*del*H_soil   ! unitless cuticle surface
         kam = Kpwm*H_soil       ! unitless apoplast solution
C Flux unit conversions
         ZM     = 71.0 * Met_Data%LAI(c,r) / ( 10.0 * Met_Data%Z0(c,r) )! measurements at UCONN's experimental
         ZC     = 71.0 * Met_Data%LAI(c,r) / ( 10.0 * Met_Data%Z0(c,r) )! g/m**3 based off of leaf litter fall
         MV_air = MWAIR / MET_DATA%DENS1( C,R ) / 1.0e3 ! m3/mol
!**************** soil parameters ************************************

         IF( INIT_COMP ) THEN
! Equilibrium Hg(0) mesophyll concentration in a 5 month box model simulation
            If( f_wat( c,r ) .eq. 1.0 ) Then
               CMEDIA( c,r,5 ) = 0.0 ! umol/g bulk leaf concentration
               CMEDIA( c,r,6 ) = 0.0 ! umol/g bulk leaf concentration
               CMEDIA( c,r,3 ) = 0.0 ! umol/g bulk soil concentration
               CMEDIA( c,r,2 ) = 3.57e-6      ! from Whalin et al 2007
               CMEDIA( c,r,1 ) = Hg_atm * 3.0 ! assume 3x eq con.
            Else if( f_wat( c,r ) .gt. 0.0 ) Then
               CMEDIA( c,r,5 ) = fevgrn(c,r)*6.0e-6 + (1.0-fevgrn(c,r))*CMEDIA(c,r,5) ! umol/g bulk leaf concentration
               CMEDIA( c,r,6 ) = fevgrn(c,r)*6.0e-7 + (1.0-fevgrn(c,r))*CMEDIA(c,r,6) ! umol/g bulk leaf concentration
               CMEDIA( c,r,3 ) = Hg_atm                                              ! umol/g bulk soil concentration
               CMEDIA( c,r,2 ) = 3.57e-6      ! from Whalin et al 2007
               CMEDIA( c,r,1 ) = Hg_atm * 3.0 ! assume 3x eq con.
            Else 
               CMEDIA( c,r,5 ) = fevgrn(c,r)*6.0e-6 + (1.0-fevgrn(c,r))*CMEDIA(c,r,5) ! umol g-1 bulk leaf concentration
               CMEDIA( c,r,6 ) = fevgrn(c,r)*6.0e-7 + (1.0-fevgrn(c,r))*CMEDIA(c,r,6) ! umol g-1 bulk leaf concentration
               CMEDIA( c,r,3 ) = Hg_atm                                               ! ppm bulk soil concentration
               CMEDIA( c,r,2 ) = 0.0
               CMEDIA( c,r,1 ) = 0.0
            End If
         End If

         Hg_st     = CMEDIA( c,r,5 ) / kam * ZM * MV_air ! umol g-1 bulk leaf concentration * g m-3 leaf * m3 mol-1
         Hg_cut    = CMEDIA( c,r,6 ) / kac * ZC * MV_air ! umol g-1 bulk leaf concentration * g m-3 leaf * m3 mol-1
         Hg_grnd   = CMEDIA( c,r,3 ) / H_soil         ! ppm bulk soil concentration
         Hg_wat    = CMEDIA( c,r,1 ) / H_wat          ! ppm

         Return

         End Subroutine Get_Hg_Comp

!------------------------------------------------------------------------------
! Updates Hg surface concentrations in STAGE
!------------------------------------------------------------------------------
         SUBROUTINE Hg_Surf_Update (flx_stom, flx_cut, flx_grnd, flx_wat, flx_hgII,
     &                              H_wat, H_soil, dt, c, r, Jdate, Jtime )

         USE BIDI_MOD
         USE ASX_DATA_MOD
         USE UTILIO_DEFN
         Use MOSAIC_MOD, Only: Tile_Data 

         IMPLICIT NONE

         REAL,    INTENT( IN )   :: flx_stom, flx_cut, flx_grnd, flx_wat, flx_hgII         ! fluxes ppm*m/s
         REAL,    INTENT( IN )   :: H_wat, H_soil                                          ! Soil and surface water H
         REAL,    INTENT( IN )   :: dt                                                     ! Intigration time step
         INTEGER, INTENT( IN )   :: c,r                                                    ! column and row
         INTEGER, INTENT( IN )   :: Jdate, Jtime                                           ! Time info

         REAL    :: flux_st, flux_cut, flux_grnd, flux_wat, flux_hgII      ! fluxes ppm*m/s
         REAL    :: Hg_st, Hg_cut, Hg_grnd, Hg_wat     ! compensation points     
         REAL, SAVE :: HgII_grnd, HgII_wat    ! Soil and water Hg(II) concentrations
!********* reduction and partioning terms *******************************
         REAL :: kr         ! soil divalent mercury reduction term
         REAL :: Prod       ! Production umol/s
         REAL :: K_loss     ! Loss Rate 1/s
         REAL :: K_Prod, K_Prod_HgII     ! Relative Production Rate 1/s
!********* Unit conversions *********************
!         REAL, Parameter :: M3MOLVOL = MOLVOL/1.0e3 ! molar volume of air at stp m3/mol      
C*************************** Ocean box parameters ***********************
         REAL, PARAMETER :: satten = 7.58-1
C***** reduction and partioning terms from Whalin et al 2007 ************
         REAL, PARAMETER :: rref  = 240.0  ! referance incoming radiation
                                           ! for redox measurements (w/m2)
         REAL, PARAMETER :: kphot = 6.5-4 ! drm photoreduction rate 1/s
         REAL, PARAMETER :: kox   = 7.2-4 ! dgm photo-oxidation rate 1/s
         CHARACTER( 16 ), PARAMETER :: pname      = 'Hg_Surf_Update'

         Hg_st     = CMEDIA( c,r,5 ) ! umol/g bulk leaf concentration
         Hg_cut    = CMEDIA( c,r,6 ) ! umol/g bulk leaf concentration
         Hg_grnd   = CMEDIA( c,r,3 ) ! umol/g bulk soil concentration
         Hg_wat    = CMEDIA( c,r,1 ) ! ppm
         HgII_wat  = CMEDIA( c,r,2 ) ! ppm
         HgII_grnd = 0.0
         DO i = 1, Tile_Data%n_lufrac
            HgII_grnd = HgII_grnd+Tile_Data%Hg_grnd(i)*Tile_Data%lufrac(c,r,i)
         END DO
C Set floor to smallest terrestrial value
         HgII_grnd = MAX( HgII_grnd, 1.8e1 )                   

! ppm m / s to umol/g/s
         If(ZM .gt. 0.0 )Then
            flux_st  = flx_stom / MV_air / ZM
            flux_cut = flx_cut  / MV_air / ZM 
         Else
            flux_st  = 0.0
            flux_cut = 0.0
         End If
! ppm m/s to ppm/s
         flux_grnd  = flx_grnd / ZG 
         flux_wat   = flx_wat  / zsurf 
         flux_hgII  = flx_HgII / zsurf 

         If( f_wat( c,r ) .gt. 0.0 ) Then ! Water
C in the absence of photo-redox reactions divalent Hg accumulates
            IF ( Met_Data%RGRND(c,r) .LT. 1e-3 ) THEN
               HgII_wat = HgII_wat - flux_hgII / ( f_wat( c,r ) ) * dt
C Find a simple one box solution for elemental Hg
               If( flux_wat .le. 0.0 ) Then ! Deposition
                  Prod = -flux_wat / ( f_wat( c,r ) )
                  Hg_wat = Hg_wat + Prod * dt
               Else
                  K_loss = min(flux_wat / ( CMEDIA( c,r, 1 ) * f_wat( c,r ) ), 0.99)                   
                  K_loss = -log(1.0 - K_loss )
                  Hg_wat = Hg_wat * exp( -K_loss * dt )
               End If
            ELSE If( CMEDIA( c,r,2 ) .Gt. 0.0 ) Then ! photo-redox reactions
               K_Prod_HgII = -flux_hgII / ( f_wat( c,r ) * CMEDIA( c,r,2 ) )
               K_Prod_HgII = log(1.0+K_Prod_HgII)
               If( flux_wat .le. 0.0 ) Then ! Deposition
                  Prod   = -flux_wat/ ( f_wat( c,r ) )
                  K_Prod = log(1.0+Prod/CMEDIA( c,r, 1 ))
                  K_loss = 0.0
               Else
                  Prod = 0.0
                  K_Prod = 0.0
                  K_loss = min( flux_wat / ( CMEDIA( c,r, 1 ) * f_wat( c,r ) ), 0.99 ) 
                  K_loss = -log(1.0-K_loss)
               End If 

               KO = 0.0 

C 240 w/m**2 is the 'typical light spectrum' from Whalin et al 2007 Marine Chem.
C attenuation at 1 m = 1/K (1-exp(-K Z)) = 0.758 using a K of 0.58


               KO( 1,1 )   = -K_loss - kox * satten * Met_Data%RGRND(c,r)/( rref ) + K_prod
               KO( 1,2 )   =  kphot * satten * Met_Data%RGRND(c,r)/( rref )
               KO( 2,1 )   =  kox *   satten * Met_Data%RGRND(c,r)/( rref )
               KO( 2,2 )   = -kphot * satten * Met_Data%RGRND(c,r)/( rref ) + K_Prod_HgII

               NHS = 0.0

               NHS(1) = 0.0!-Prod
               NHS(2) = 0.0!flux_hgII/( f_wat( c,r ) )

               B = 0.0

               B( 1 ) = Hg_wat   
               B( 2 ) = HgII_wat


C*****************************************************************************
! Get eigen values and vectors where the cubic equation is:
! ax*lambda**2+bx*lambda+cx = 0
! and is solved following Numerical recipies for Fortran equations 5.6.2-5.6.5
C*****************************************************************************

               ax = 1.0
               bx = -(KO(1,1)+KO(2,2))
               cx = KO(1,1)*KO(2,2)-KO(1,2)*KO(2,1)
    
               Qx = -0.5*(bx+SIGN(1.0,bx)*SQRT(bx**2-4.0*ax*cx))
    
               EIVAL(1) = Qx/ax
               EIVAL(2) = cx/Qx
    
! Solve for the eigenvectors
               DO i = 1, NC
                  ev1   = 1.0
                  ev2   = -(KO(2,1)*ev1)/(KO(2,2)-EIVAL(i))
                  evmax = max(abs(ev1),abs(ev2))
! scale the eigenvector
                  VR(1,i) = ev1/evmax
                  VR(2,i) = ev2/evmax
               END DO                  
! update the surface array
               Hg_wat   = 0.0
               HgII_wat = 0.0

               DO i = 1, NC
                  Hg_wat   = Hg_wat   + B(i) * VR(1,i) * EXP( EIVAL(i) * dt )
                  HgII_wat = HgII_wat + B(i) * VR(2,i) * EXP( EIVAL(i) * dt )
               END DO

               Hg_wat     = Hg_wat   + NHS(1)
               HgII_wat   = HgII_wat + NHS(2)

            END IF         

            IF ( HgII_wat .LT. 0.0 .OR. Hg_wat .LT. 0.0 ) THEN
            
               XMSG = '*** Negative concentration ***'   
               WRITE(LOGDEV,*) 'Hg_wat',Hg_wat,'HgII_wat',HgII_wat    
               Write(logdev,*) 'K_loss', K_loss
               Write(logdev,*) 'EIVAL', EIVAL(1), EIVAL(2)
               Write(logdev,*) 'EIVEC', VR(1,1), VR(2,2)
               Write(logdev,*) 'NHS', NHS(1), NHS(2)
         
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
   
            END IF       
            CMEDIA( c,r,1 ) = Hg_wat    ! ppm
            CMEDIA( c,r,2 ) = HgII_wat  ! ppm                                                          
         End If
         If( f_wat( c,r ) .lt. 1.0 ) Then ! land
! Soil divalent mercury reduction rate following Scholz et al 2003
            IF(Met_Data%SOIT1(c,r) .GT. 273.15) THEN
               kr     = 8.0e-11
            ELSE ! if the soil is frozen limit diffusion and reduction
               kr     = 0.0
            END IF
            If( Met_Data%LAI(c,r) .Gt. 0.0 ) Then
! Stomatal flux
               If( flux_st .le. 0.0 ) Then ! deposition 
                  Prod = -flux_st / ( (1.0 - f_wat( c,r ) ) )
                  Hg_st = Hg_st + Prod * dt
               Else
                  K_loss  = min( flux_st / ( Hg_st * (1.0 - f_wat( c,r ) ) ), 0.99 ) 
                  K_loss  = -log(1.0 - K_loss)
                  Hg_st = Hg_st * exp( - K_loss * dt ) 
               End If
               CMEDIA( c,r,5 ) = Hg_st
! Cuticular flux
               If( flux_cut .le. 0.0 ) Then ! deposition 
                  Prod = -flux_cut / ( (1.0 - f_wat( c,r ) ) )
                  Hg_cut = Hg_cut + Prod * dt
               Else
                  K_loss  = min(flux_cut / ( Hg_cut * (1.0 - f_wat( c,r ) ) ), 0.99 ) 
                  K_loss  = -log(1.0 - K_loss )
                  Hg_cut = Hg_cut * exp( - K_loss * dt ) 
               End If
               CMEDIA( c,r,6 ) = Hg_cut
            End If
! soil flux
            If( flux_grnd .le. 0.0 ) Then ! deposition 
               Prod = kr * Grid_Data%RHOB( c,r ) * HgII_grnd * ZG /( 1.0e3 * 200.59 ) -
     &                flux_grnd / max((1.0 - f_wat( c,r )),0.001 )
               Hg_grnd = Hg_grnd + Prod * dt
            Else 
               Prod    = kr * Grid_Data%RHOB( c,r ) * HgII_grnd * ZG /( 1.0e3 * 200.59 )
               K_loss  = min( flux_grnd / ( Hg_grnd * max((1.0 - f_wat( c,r )),0.001 ) ), 0.99 ) 
               K_loss  = -log(1.0 - K_loss)
               If( K_loss .eq. 0.0 ) Then ! due to numerical rounding
                  Hg_grnd = Hg_grnd + Prod * dt
               Else
                  Hg_grnd = Prod / K_loss + ( Hg_grnd - Prod / K_loss ) * exp( -K_loss * dt )
               End If
            End If
            CMEDIA( c,r,3 ) = Hg_grnd
! Model layer depths

         End If

         Return
         End Subroutine Hg_Surf_Update

C------------------------------------------------------------------------------

         SUBROUTINE GET_WDEP( CSE, WDEP, C, R )

         Use Const, Only: MWWAT
         Use ASX_DATA_MOD, Only: Grid_Data
         USE BIDI_MOD, Only: CMedia

         IMPLICIT NONE

         CHARACTER( 8 ), INTENT( IN ) :: CSE  ! wet dep sepcies
         REAL,      INTENT( IN ) :: WDEP ! wet deposition in kg/ha
         INTEGER,   INTENT( IN ) :: C
         INTEGER,   INTENT( IN ) :: R
         REAL, PARAMETER :: HAOM2   = 1.0e-4 ! ha/m^2 conversion
         REAL, PARAMETER :: MWHG    = 200.59 ! molecular weight of Hg
         REAL, PARAMETER :: UGOKG   = 1.0e9  ! ug/kg conversion
         REAL, PARAMETER :: GH2ONM3 = 1.0e6  ! g H2O in M^3 H2O
         REAL  WDEP_LOAD   ! loading due to wet deposition


         IF ( f_wat( c,r )  .Gt. 0 ) THEN ! water

         ! convert to umol/m2 pulse input
            WDEP_LOAD = WDEP*HAOM2*UGOKG/MWHG*f_wat( c,r )
         ! convert to added concentration in ppm assuming it remains at the surface
            WDEP_LOAD = WDEP_LOAD/ZSURF/GH2ONM3*MWWAT

            IF( CSE .EQ. 'HG      ' ) THEN

               CMEDIA( C,R,1 ) = CMEDIA( C,R,1 ) + WDEP_LOAD

            END IF

            IF( CSE .EQ. 'HGIIGAS ' ) THEN

               CMEDIA( C,R,2 ) = CMEDIA( C,R,2 ) + WDEP_LOAD

            END IF

         END IF ! water

         RETURN

         END SUBROUTINE GET_WDEP
      END MODULE HGSIM

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SUBHFILE ( FNAME, GXOFF, GYOFF,
     &                      STRTCOL, ENDCOL, STRTROW, ENDROW )

C 11 May 11 D.Wong: incorporated twoway model implementation
C 10 Mar 14 D.Wong: turned off GXOFF and GYOFF check for the twoway model
C                   since METCRO is one grid cell bigger than the other
C                   files to avoid M3EXIT issue
C  1 Feb 19 David Wong: removed all MY_N clauses
C 23 Mar 21 David Wong: modified code to accommodate a flexibility to allow each input
C                       can have different XORIG and YORIG settings than the simulation
C                       domain if it can be overlapped with the simulation domain
C                       perfectly w.r.t. domain resolution

C returns local starting and ending column and row indices for file FNAME

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN

      IMPLICIT NONE
 
C Includes:
 
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

      CHARACTER( 16 ), INTENT( IN )  :: FNAME
      INTEGER,         INTENT( OUT ) :: GXOFF ! X global origin offset from file (.ge. 0)
      INTEGER,         INTENT( OUT ) :: GYOFF ! Y global origin offset from file (.ge. 0)
      INTEGER,         INTENT( OUT ) :: STRTCOL ! local processor start colum in file
      INTEGER,         INTENT( OUT ) ::  ENDCOL ! local processor end colum in file
      INTEGER,         INTENT( OUT ) :: STRTROW ! local processor start row in file
      INTEGER,         INTENT( OUT ) ::  ENDROW ! local processor end row in file

C External Functions:
  
C Parameters

      REAL( 8 ), PARAMETER :: HALF = 0.5D+00
      REAL( 8 ), PARAMETER :: ONE  = 1.0D+00
      REAL( 8 ), PARAMETER :: TEN  = 1.0D+01
      REAL( 8 ), PARAMETER :: ONEK = 1.0D+03
      REAL( 8 ), PARAMETER :: TENK = 1.0D+04
      REAL( 8 ), PARAMETER :: TOL  = ONE / ONEK
      REAL( 8 ), PARAMETER :: THOU = 1.0D-03
      REAL( 8 ), PARAMETER :: MIN_DOUBLE = 1.0D-08

C local variables:

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      INTEGER       :: INDX                 ! because mype starts at 0
      CHARACTER( 16 ) :: PNAME = 'SubhFile_Cell'
      CHARACTER( 16 ) :: BNAME
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER       :: LOC_STRTCOL, LOC_ENDCOL, LOC_STRTROW, LOC_ENDROW

      REAL( 8 ), SAVE :: XORIG_B, YORIG_B
      REAL( 8 ), SAVE :: XCENT_B, YCENT_B
      REAL( 8 ), SAVE :: XCELL_B, YCELL_B
      REAL( 8 ), SAVE :: XORIG_C, YORIG_C  ! from GRIDDESC, in cell coord
      REAL( 8 ), SAVE :: XORIG_F, YORIG_F  ! from file, in cell coord

      INTEGER DOTFILE
      REAL( 8 ) :: RELOFFX, RELOFFY

C-----------------------------------------------------------------------

#ifndef mpas
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

C open cross file for subsequent comparison

!        BNAME = TRIM( GRID_CRO_2D )

!        IF ( .NOT. OPEN3( BNAME, FSREAD3, PNAME ) ) THEN
!           XMSG = 'Could not open '// BNAME
!           CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
!           END IF

!        IF ( .NOT. DESC3( BNAME ) ) THEN
!           XMSG = 'Could not get ' // BNAME // ' file description'
!           CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
!           END IF

C set base header data

         XORIG_B = XORIG3D
!        YORIG_B = YORIG3D
!        XCENT_B = XCENT3D
!        YCENT_B = YCENT3D
!        XCELL_B = XCELL3D
!        YCELL_B = YCELL3D

C Scale resolution

!        XCELL_B = REAL( IDNINT( TENK * XCELL_B ), 8 ) / TENK
!        YCELL_B = REAL( IDNINT( TENK * YCELL_B ), 8 ) / TENK

C Convert to grid cell coord and truncate

!        XORIG_B = XORIG_B / XCELL_B
!        XORIG_B = REAL( IDNINT( ONEK * XORIG_B ), 8 ) / ONEK
!        YORIG_B = YORIG_B / YCELL_B
!        YORIG_B = REAL( IDNINT( ONEK * YORIG_B ), 8 ) / ONEK

         XORIG_C = XORIG_GD / XCELL_GD
         XORIG_C = REAL( IDNINT( ONEK * XORIG_C ), 8 ) / ONEK
         YORIG_C = YORIG_GD / YCELL_GD
         YORIG_C = REAL( IDNINT( ONEK * YORIG_C ), 8 ) / ONEK

      END IF   ! FIRSTIME

C open existing file for readonly access

      IF ( .NOT. OPEN3( FNAME, FSREAD3, PNAME ) ) THEN
         XMSG = 'Could not open '// FNAME
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF

      IF ( .NOT. DESC3( FNAME ) ) THEN
         XMSG = 'Could not get ' // TRIM( FNAME )
     &        // ' file description'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF

C check some header data against the reference file in this met set -
C mother grid center and grid cell resolution

!     IF ( ABS( XCENT3D - XCENT_B ) .GT.
!    &     TOL * ABS( XCENT3D + XCENT_B + TOL ) .OR.
!    &     ABS( YCENT3D - YCENT_B ) .GT.
!    &     TOL * ABS( YCENT3D + YCENT_B + TOL ) .OR.
!    &     ABS( XCELL3D - XCELL_B ) .GT. TOL * XCELL3D .OR.
!    &     ABS( YCELL3D - YCELL_B ) .GT. TOL * YCELL3D ) THEN
!        WRITE( LOGDEV,2003 ) XCENT_B, XCENT3D, YCENT_B, YCENT3D,
!    &                        XCELL_B, XCELL3D, YCELL_B, YCELL3D
!2003     FORMAT(/ 5X, 'XCENT_B:', F20.12, 2X, 'XCENT3D (file):', F20.12 
!    &          / 5X, 'YCENT_B:', F20.12, 2X, 'YCENT3D (file):', F20.12
!    &          / 5X, 'XCELL_B:', F20.12, 2X, 'XCELL3D (file):', F20.12 
!    &          / 5X, 'YCELL_B:', F20.12, 2X, 'YCELL3D (file):', F20.12 )

!        XMSG = 'File header inconsistent with GRID_CRO_2D'
!#ifndef twoway
!        CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
!#endif
!     END IF

C check some header data against GRIDDESC

      IF ( ABS( XCENT3D - XCENT_GD ) .GT.
     &     TOL * ABS( XCENT3D + XCENT_GD + TOL ) .OR.
     &     ABS( YCENT3D - YCENT_GD ) .GT.
     &     TOL * ABS( YCENT3D + YCENT_GD + TOL ) .OR.
     &     ABS( XCELL3D - XCELL_GD ) .GT. TOL * XCELL3D .OR.
     &     ABS( YCELL3D - YCELL_GD ) .GT. TOL * YCELL3D ) THEN
         WRITE( LOGDEV,2003 ) XCENT_GD, XCENT3D, YCENT_GD, YCENT3D,
     &                        XCELL_GD, XCELL3D, YCELL_GD, YCELL3D
 2003     FORMAT(/ 5X, 'XCENT_B:', F20.12, 2X, 'XCENT3D (file):', F20.12 
     &          / 5X, 'YCENT_B:', F20.12, 2X, 'YCENT3D (file):', F20.12
     &          / 5X, 'XCELL_B:', F20.12, 2X, 'XCELL3D (file):', F20.12 
     &          / 5X, 'YCELL_B:', F20.12, 2X, 'YCELL3D (file):', F20.12 )

         XMSG = 'File header inconsistent with GRIDDESC'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF

C Convert to grid cell coord and truncate

      XORIG_F = XORIG3D / XCELL3D
      XORIG_F = REAL( IDNINT( ONEK * XORIG_F ), 8 ) / ONEK
      YORIG_F = YORIG3D / YCELL3D
      YORIG_F = REAL( IDNINT( ONEK * YORIG_F ), 8 ) / ONEK
 
C Check if file (cross or dot) is "lined up"

      RELOFFX = THOU * REAL( IDNINT( ONEK * ( XORIG_C - XORIG_F ) ), 8 )
      RELOFFX = RELOFFX - ONE * REAL( IDNINT( RELOFFX ), 8 )

      IF ( ABS( RELOFFX ) .GT. MIN_DOUBLE ) THEN ! it better be a dot file
         IF ( ABS( RELOFFX ) .LT. HALF - MIN_DOUBLE .OR.
     &        ABS( RELOFFX ) .GT. HALF + MIN_DOUBLE ) THEN
            WRITE( LOGDEV,* ) '    RELOFFX: ', RELOFFX
            WRITE( LOGDEV,* ) '    XORIG_C, XORIG_F: ', XORIG_C, XORIG_F
            XMSG = 'Inconsistent Base/File Xorig'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            END IF
      END IF

      RELOFFY = THOU * REAL( IDNINT( ONEK * ( YORIG_C - YORIG_F ) ), 8 )
      RELOFFY = RELOFFY - ONE * REAL( IDNINT( RELOFFY ), 8 )

      IF ( ABS( RELOFFY ) .GT. MIN_DOUBLE ) THEN ! it better be a dot file
         IF ( ABS( RELOFFY ) .LT. HALF - MIN_DOUBLE .OR.
     &        ABS( RELOFFY ) .GT. HALF + MIN_DOUBLE ) THEN
            WRITE( LOGDEV,* ) '    RELOFFY: ', RELOFFY
            WRITE( LOGDEV,* ) '    YORIG_C, YORIG_F: ', YORIG_C, YORIG_F
            XMSG = 'Inconsistent Base/File Yorig'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            END IF
      END IF
      IF ( ABS( RELOFFX - RELOFFY ) .GT. MIN_DOUBLE ) THEN
         XMSG = 'Inconsistent X- and Y-resolution (file vs. file)'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF

C check the file against the processor setup (COORD.EXT), and get the offsets

      DOTFILE = 0
      RELOFFX = THOU * REAL( IDNINT( ONEK * ( XORIG_C - XORIG_F ) ), 8 )
      RELOFFX = RELOFFX - ONE * REAL( IDNINT( RELOFFX ), 8 )

      IF ( ABS( RELOFFX ) .GT. MIN_DOUBLE ) THEN ! it better be a dot file
         IF ( ABS( RELOFFX ) .LT. HALF - MIN_DOUBLE .OR.
     &        ABS( RELOFFX ) .GT. HALF + MIN_DOUBLE ) THEN
            WRITE( LOGDEV,* ) '    RELOFFX: ', RELOFFX
            WRITE( LOGDEV,* ) '    XORIG_GD, XORIG_F: ', XORIG_C, XORIG_F
            XMSG = 'File Xorig inconsistent with GRIDDESC'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            END IF
      END IF

      RELOFFY = THOU * REAL( IDNINT( ONEK * ( YORIG_C - YORIG_F ) ), 8 )
      RELOFFY = RELOFFY - ONE * REAL( IDNINT( RELOFFY ), 8 )

      IF ( ABS( RELOFFY ) .GT. MIN_DOUBLE ) THEN ! it better be a dot file
         IF ( ABS( RELOFFY ) .LT. HALF - MIN_DOUBLE .OR.
     &        ABS( RELOFFY ) .GT. HALF + MIN_DOUBLE ) THEN
            WRITE( LOGDEV,* ) '    RELOFFY: ', RELOFFY
            WRITE( LOGDEV,* ) '    YORIG_GD, YORIG_F: ', YORIG_C, YORIG_F
            XMSG = 'File Yorig inconsistent with GRIDDESC'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            ELSE
            DOTFILE = 1
            END IF
      END IF
      IF ( ABS( RELOFFX - RELOFFY ) .GT. MIN_DOUBLE ) THEN
         XMSG = 'Inconsistent X- and Y-resolution (file vs. model)'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF

      INDX = MYPE + 1
      GXOFF = IDINT( XORIG_C - XORIG_F )
      LOC_STRTCOL = GXOFF + COLSX_PE( 1,INDX )
      LOC_ENDCOL  = LOC_STRTCOL + NCOLS - 1 + DOTFILE
      GYOFF = IDINT( YORIG_C - YORIG_F )
      LOC_STRTROW = GYOFF + ROWSX_PE( 1,INDX )
      LOC_ENDROW  = LOC_STRTROW + NROWS - 1 + DOTFILE
#ifndef twoway
      IF ( GXOFF .LT. 0 .OR. GYOFF .LT. 0 ) THEN
         XMSG = 'Model domain is outside file domain'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF
#endif

#ifdef twoway
      IF ( ( FNAME .EQ. GRID_CRO_2D ) .OR.
     &     ( FNAME .EQ. GRID_DOT_2D ) ) THEN
         LOC_ENDCOL  = LOC_ENDCOL - LOC_STRTCOL + 1
         LOC_STRTCOL = 1
         LOC_ENDROW  = LOC_ENDROW - LOC_STRTROW + 1
         LOC_STRTROW = 1
      ELSE IF ( ( FNAME .EQ. MET_CRO_2D ) .OR.
     &          ( FNAME .EQ. MET_CRO_3D ) .OR.
     &          ( FNAME .EQ. MET_DOT_3D ) ) THEN
         LOC_ENDCOL  = LOC_ENDCOL - LOC_STRTCOL + 2
         LOC_STRTCOL = 2
         LOC_ENDROW  = LOC_ENDROW - LOC_STRTROW + 2
         LOC_STRTROW = 2
      END IF
#endif

      STRTCOL = LOC_STRTCOL
      ENDCOL  = LOC_ENDCOL
      STRTROW = LOC_STRTROW
      ENDROW  = LOC_ENDROW
#endif

      RETURN
      END SUBROUTINE SUBHFILE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       SUBROUTINE FLCHECK ( STDATE, STTIME, TSTEP )

C-----------------------------------------------------------------------
C Function: To check file header data for consistency with COORD.EXT
C            and runlength; only gridded and boundary files are checked.
 
C Preconditions: None
 
C Key Subroutines/Functions Called:
 
C Revision History: Prototype created by Jerry Gipson, September, 1997
C                   Modified Jun, 1998 by Jerry Gipson to remove PING
C                   and MEPSE files from being checked
C                   Jeff - Nov 2000 - ck only input files for start date/time
C   30 Mar 01 J.Young: elim reference to grid
C    6 Jul 10 J.Young: minor mods - F90-ize
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   11 Apr 16 D.Wong: formulated a robust way to handle a situation when
C                     ACONC file with STIME3 = starting time of the simulation,
C                     and the file is emtpy and requires to go through CHECK3
C-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE RUNTIME_VARS, ONLY : LOG_HEADING, LOG_SUBHEADING, LOG_MESSAGE,
     &                         RUNLEN, FL_ERR_STOP, LOGDEV

      IMPLICIT NONE 

C Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters
      
C Arguments:
      INTEGER, INTENT( IN ) :: STDATE   ! Current date (YYYYDDD)
      INTEGER, INTENT( IN ) :: STTIME   ! Current time (HHMMSS)
      INTEGER, INTENT( IN ) :: TSTEP    ! Current time step (HHMMSS)

C Parameters: None

C External Functions: None

C Saved Local Variables: None
      
C Local Variables:
      CHARACTER( 80 ) :: MSG                ! Message buffer
      CHARACTER( 16 ) :: PNAME = 'FLCHECK'  ! Procedure name
      
      INTEGER JDATE     ! Time step date (YYYYDDD)
      INTEGER JTIME     ! Time step time (HHMMSS)
      INTEGER N         ! Loop index
      INTEGER STATUS    ! Status of returned value

      LOGICAL LERROR    ! Flag to indicate error for 1 or more files
      LOGICAL LOK       ! Flag to indicate error for 1 file

      CHARACTER( 500 )  :: FNAME
      INTEGER           :: LSTAT
      LOGICAL           :: ESTAT

C-----------------------------------------------------------------------

#ifndef mpas
      CALL LOG_HEADING( LOGDEV, 'Check Input File Headers' )

      LERROR = .FALSE.

      DO N = 1, N_FILES      

         ! Detect whether or not this filename logical has been set in the run
         ! script
         CALL GET_ENVIRONMENT_VARIABLE( NAME = LGCL_NAME( N ), 
     &            VALUE = FNAME, STATUS = LSTAT )

         ! Check to see if this file already exists
         INQUIRE( FILE = TRIM( FNAME ), EXIST = ESTAT )
         
         ! skip checking files that were not set in the run script or do 
         ! not exist 
         IF ( LSTAT .LE. 0 .AND. ESTAT ) THEN

            LOK = OPEN3( LGCL_NAME( N ), FSREAD3, PNAME )

            IF ( LOK ) THEN

               IF ( DESC3( LGCL_NAME( N ) ) ) THEN
     
                  ! only check gridded or boundary files
                  IF ( FTYPE3D .EQ. GRDDED3 .OR. FTYPE3D .EQ. BNDARY3 ) THEN

                     MSG = 'Checking header data for file: ' // LGCL_NAME( N )
                     CALL M3MESG( MSG )

                     CALL GRDCHECK ( LGCL_NAME( N ), LOK )

                     ! check time steps for time dependent files
                     IF ( TSTEP3D .GT. 0 ) THEN
                        JDATE = STDATE
                        JTIME = STTIME

                        IF ( .NOT. CHECK3( LGCL_NAME( N ), ALLVAR3,
     &                                     JDATE, JTIME ) ) THEN
                           LOK = .FALSE.
                           MSG = 'Starting time not on file'
                           CALL M3MESG( MSG )
                        END IF
 
                        ! skip checking ending time for output files
                        IF ( IN_MODE( N ) ) THEN
                           CALL NEXTIME ( JDATE, JTIME, RUNLEN )
                           IF ( .NOT. CHECK3( LGCL_NAME( N ), ALLVAR3,
     &                                        JDATE, JTIME ) ) THEN
                              LOK = .FALSE.
                              MSG = 'Ending time not on file'
                              CALL M3MESG( MSG )
                           END IF
                        END IF

                     END IF   ! if TSTEP3D .GT. 0

                     IF ( .NOT. LOK ) LERROR = .TRUE.

                  END IF   ! only check gridded or boundary files

               ELSE

                  LOK = .FALSE.
                  MSG = 'DESC3 failed for ' // LGCL_NAME( N )
                  CALL M3MESG( MSG )

               END IF   ! DESC3 successful

            END IF   ! successful open

         END IF  ! skip files not set in run script or that don't exist

      END DO

      IF ( LERROR ) THEN
         MSG = 'Inconsistent header data on input files'
         IF ( FL_ERR_STOP ) THEN       
            CALL M3EXIT ( PNAME, STDATE, STTIME, MSG, XSTAT2 )
         ELSE
            CALL M3WARN ( PNAME, STDATE, STTIME, MSG )
            RETURN
         END IF
      ELSE
         CALL LOG_MESSAGE( LOGDEV, 'No inconsistent header data found on input files' )
         WRITE( LOGDEV, * )
      END IF
#endif

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PTBILIN

C-----------------------------------------------------------------------
C Function: 3d point source bi-linear interpolation data

C Revision History:
C     20 Nov 2007 J.Young: initial implementation
C     13 Apr 2010 D. Wong: parallel bug fix - in subroutine ungridb2
C                          calculations use the lower left corner of the
C                          original domain
C     27 Jul 2011 David Wong: - fixed the description of XBND
C     12 Aug 2015 David Wong: - Based on the condition of MY_NSRC ( > 0 )
C                               to determine execution of code section
C      1 Feb 19 David Wong: removed all MY_N clauses
C      5 Aub 19 David Wong: removed BILIN_DATA
C-----------------------------------------------------------------------
      USE RUNTIME_VARS

      IMPLICIT NONE

C Arrays which record .true. if local processor contains an exterior boundary
      REAL( 8 )     :: METCXORIG   ! cross point grid X-coord origin of met grid
      REAL( 8 )     :: METCYORIG   ! cross point grid Y-coord origin of met grid
      REAL( 8 )     :: XCELLCG     ! cross point grid X-coordinate cell dimension
      REAL( 8 )     :: YCELLCG     ! cross point grid Y-coordinate cell dimension
      REAL( 8 )     :: METDXORIG   ! dot point grid X-coord origin of met grid
      REAL( 8 )     :: METDYORIG   ! dot point grid Y-coord origin of met grid
      REAL( 8 )     :: XCELLDG     ! dot point grid X-coordinate cell dimension
      REAL( 8 )     :: YCELLDG     ! dot point grid Y-coordinate cell dimension
      REAL( 8 )     :: MY_CXORIG   ! local processor cross point X-coord origin
      REAL( 8 )     :: MY_CYORIG   ! local processor cross point Y-coord origin
      REAL( 8 )     :: MY_DXORIG   ! local processor dot point X-coord origin
      REAL( 8 )     :: MY_DYORIG   ! local processor dot point Y-coord origin

C Allocatable cross- OR dot-point meteorology input buffers

      END MODULE PTBILIN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      REAL FUNCTION ZFDBC (C1, C2, V1, V2)

c Zero Flux Divergence Boundary Condition (See Jon Pleim's JGR (1991) paper)
c To eliminate reflections and other boundary anomalies
C Problem if V1 is outflow, but V2 is inflow

      IMPLICIT NONE
      REAL SMALL
      PARAMETER (SMALL = 1.0E-03 )   ! for small wind speed (m/s)
      REAL C1, C2, V1, V2
 
      IF ( ABS( V1 ) .GE. SMALL ) THEN
         IF ( V1 * V2 .GT. 0.0 ) THEN
            ZFDBC = MAX (0.0, C1 - V2 / V1 * (C2 - C1)) 
         ELSE
            ZFDBC = C1         ! nothing changes for wind divergence at edge
         END IF
      ELSE
         ZFDBC = C1            ! nothing changes for small wind speed
      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C-----------------------------------------------------------------------
      Subroutine aero_nml_modes
          
C         This function expands the AE namelist rows to account for 
C         mode-specific variables. If just one mode is requested for an 
C         aerosol species, then no rows are added. If more than one mode
C         is requested, then rows are added to accomodate those. 
C
C         Ben Murphy 2022-03-25
C-----------------------------------------------------------------------
          Use aero_data, only : n_aerolist, aerolist, modesuff,
     &                          iait, iacc, icor, reqd_modes
          Use runtime_vars, only : log_message, log_subheading, logdev,
     &                             outdev, cmype
          Use cgrid_spcs_types
          Use utilio_defn, only : index1, xstat2, m3exit, m3warn, m3mesg

          Implicit None

          Type(species_data_reg_2) :: aedat( size( ae_species_data,1 ) )
          Type(species_data_reg_2) :: aedat_mode( size( ae_species_data,1 ) )

          integer nsp2, naero

          Integer isp, im, iaer, iost
          Character(300) xmsg
          Character(20) :: pname = 'aero_nml_modes'
          Logical eflag
                    
          aedat = ae_species_data
          aedat_mode = aedat
          nsp2 = 0

          Call log_subheading( LOGDEV, "Add Modal Dimension to CMAQ Aerosol Species" )
          call log_message( LOGDEV,"")

          eflag = .False.
          do isp = 1,size( aedat,1 )
              ! Stop after the last aerosol name
              if ( aedat(isp)%species_name .EQ. '' ) EXIT

              ! Get Index on Aerosol Table
              iaer = index1( aedat(isp)%species_name, 
     &                       n_aerolist, aerolist(:)%bulkname )

              ! Confirm species is known to CMAQ either in the Aerosol
              ! Table or Particle Number or Surface Area
              if ( iaer .eq. 0 ) then
                 if ( trim(aedat(isp)%species_name) .eq. 'NUM' .or.
     &                trim(aedat(isp)%species_name) .eq. 'SRF'     ) then
                   ! Species is a Number or Surface Area Concentration
                   if ( aedat(isp)%lait .neqv. reqd_modes(iait) ) then
                      xmsg = 'Number or Surface Area must have an Aitken-Mode ' //
     &                       'component. Please adjust the aerosol namelist.'
                      Call log_message( OUTDEV, 'Error: '//xmsg )
                      eflag = .True.
                   end if

                   if ( aedat(isp)%lacc .neqv. reqd_modes(iacc) ) then
                      xmsg = 'Number or Surface Area must have an Accumulation-Mode ' //
     &                       'component. Please adjust the aerosol namelist.'
                      Call log_message( OUTDEV, 'Error: '//xmsg )
                      eflag = .True.
                   end if

                   if ( aedat(isp)%lcor .neqv. reqd_modes(icor) ) then
                      xmsg = 'Number or Surface Area must have a Coarse-Mode ' //
     &                       'component. Please adjust the aerosol namelist.'
                      Call log_message( OUTDEV, 'Error: '//xmsg )
                      eflag = .True.
                   end if

                 else
                   ! Species is not a recognized aerosol chemical species or aerosol
                   ! parameter
                   xmsg = 'An aerosol chemical species appears on the AE '//
     &                     'namelist that is not available in AERO_DATA. Please '//
     &                     'see the aerolist table.'
                   Call log_message( OUTDEV, 'Error: '//xmsg )
                   eflag = .True.
                 end if
              else

                  ! Species is a recognized aerosol chemical species
                   if ( aedat(isp)%lait .neqv. aerolist(iaer)%lait ) then
                      xmsg = 'Aitken Flag for '//
     &                       TRIM(aedat(isp)%species_name)//' set incorrectly in the AE namelist.'
                      xmsg = Trim( pname ) // ': ' // xmsg
                      call m3mesg( xmsg )
                      eflag = .True.
                   end if

                   if ( aedat(isp)%lacc .neqv. aerolist(iaer)%lacc ) then
                      xmsg = 'Accumulation Flag for '//
     &                       TRIM(aedat(isp)%species_name)//' set incorrectly in the AE namelist.'
                      xmsg = Trim( pname ) // ': ' // xmsg
                      call m3mesg( xmsg )
                      eflag = .True.
                   end if

                   if ( aedat(isp)%lcor .neqv. aerolist(iaer)%lcor ) then
                      xmsg = 'Coarse Flag for '//
     &                       TRIM(aedat(isp)%species_name)//' set incorrectly in the AE namelist.'
                      xmsg = Trim( pname ) // ': ' // xmsg
                      call m3mesg( xmsg )
                      eflag = .True.
                   end if
              end if

              if( eflag )then
                  xmsg = 'AE Namelist has fatal errors. Check Processor log '
     &                 // Trim( cmype )
                  Call log_message( outdev, 'Error: '//xmsg )
                  xmsg = Trim( pname ) // ': ' // xmsg
                  call m3mesg( xmsg )
                  call m3exit( pname, 0, 0, 'FATAL ERROR', xstat2 )
              end if

              ! If no modes are selected, warn and move on
              if ( .not.aedat(isp)%lait .and. 
     %             .not.aedat(isp)%lacc .and. 
     &             .not.aedat(isp)%lcor ) then
                    xmsg = 'No aerosol modes have been requested for '//
     &                     TRIM(aedat(isp)%species_name)//' on the AE namelist.' 
                    call m3warn( pname, 0, 0, xmsg ) 
              end if

              ! For Aitken-Mode Particles
              if ( aedat(isp)%lait ) then
                 if ( aedat(isp)%species_name .eq. 'NUM' .OR. 
     &                aedat(isp)%species_name .eq. 'SRF' ) THEN
                    ! Add Aitken Mode Number or Surface Area
                    nsp2 = nsp2 + 1
                    aedat_mode(nsp2)%species_name = 
     &                    trim(aedat(isp)%species_name)//'ATKN'
                    aedat_mode(nsp2)%depv_surr = 
     &                    trim(aedat(isp)%depv_surr)//'ATKN'
                    aedat_mode(nsp2)%scav_surr = 
     &                    trim(aedat(isp)%scav_surr)//'_AITKEN'
                    aedat_mode(nsp2)%cloud_surr = 
     &                    trim(aedat(isp)%cloud_surr)//'_AITKEN'
                 elseif ( aerolist(iaer)%lait ) then
                    ! Add Aitken Mode Mass
                    nsp2 = nsp2 + 1
                    aedat_mode(nsp2)%species_name = 
     &                    trim(aedat(isp)%species_name)//modesuff(iait)
                    aedat_mode(nsp2)%depv_surr = aedat(isp)%depv_surr
                    if ( aedat(isp)%depv_surr .ne. '' )
     &                   aedat_mode(nsp2)%depv_surr = 
     &                         trim(aedat(isp)%depv_surr)//'I'
                    aedat_mode(nsp2)%scav_surr = aedat(isp)%scav_surr
                    if ( aedat(isp)%scav_surr .ne. '' )
     &                   aedat_mode(nsp2)%scav_surr = 
     &                         trim(aedat(isp)%scav_surr)//'_AITKEN'
                    aedat_mode(nsp2)%cloud_surr = aedat(isp)%cloud_surr
                    if ( aedat(isp)%cloud_surr .ne. '' )
     &                   aedat_mode(nsp2)%cloud_surr = 
     &                         trim(aedat(isp)%cloud_surr)//'_AITKEN'
                 else
                    ! Mode not allowed for this species. Exit CMAQ
                    xmsg = 'Aitken-mode aerosols have been requested for '//
     &                     TRIM(aedat(isp)%species_name)//
     &                     ' but they are not available for this species. See '//
     &                     'aerolist table in AERO_DATA.'
                    Call log_message( outdev, 'Error: '//xmsg )
                    call m3exit( pname, 0, 0, xmsg, xstat2 ) 
                 end if
 
                 aedat_mode(nsp2)%molwt = aedat(isp)%molwt
                 aedat_mode(nsp2)%lait = .True.
                 aedat_mode(nsp2)%lacc = .False.
                 aedat_mode(nsp2)%lcor = .False.
                 aedat_mode(nsp2)%optics_surr = aedat(isp)%optics_surr
                 aedat_mode(nsp2)%ic_surr     = aedat(isp)%ic_surr
                 aedat_mode(nsp2)%ic_fac      = aedat(isp)%ic_fac
                 aedat_mode(nsp2)%bc_surr     = aedat(isp)%bc_surr
                 aedat_mode(nsp2)%bc_fac      = aedat(isp)%bc_fac
                 aedat_mode(nsp2)%depv_fac    = aedat(isp)%depv_fac
                 aedat_mode(nsp2)%scav_fac    = aedat(isp)%scav_fac
                 aedat_mode(nsp2)%trns_flag   = aedat(isp)%trns_flag
                 aedat_mode(nsp2)%ddep_flag   = aedat(isp)%ddep_flag
                 aedat_mode(nsp2)%wdep_flag   = aedat(isp)%wdep_flag
                 aedat_mode(nsp2)%conc_flag   = aedat(isp)%conc_flag

                 xmsg = 'Added an Aitken Mode for Aerosol Species '//
     &                  trim(aedat_mode(nsp2)%species_name)
                 Call log_message( LOGDEV, xmsg )
 
              end if

              ! For Accumulation-Mode Particles
              if ( aedat(isp)%lacc ) then
                 if ( aedat(isp)%species_name .eq. 'NUM' .OR. 
     &                aedat(isp)%species_name .eq. 'SRF' ) THEN
                    ! Add Accumulation Mode Number or Surface Area
                    nsp2 = nsp2 + 1
                    aedat_mode(nsp2)%species_name = 
     &                    trim(aedat(isp)%species_name)//'ACC'
                    aedat_mode(nsp2)%depv_surr = 
     &                    trim(aedat(isp)%depv_surr)//'ACC'
                    aedat_mode(nsp2)%scav_surr = 
     &                    trim(aedat(isp)%scav_surr)//'_ACCUM'
                    aedat_mode(nsp2)%cloud_surr = 
     &                    trim(aedat(isp)%cloud_surr)//'_ACCUM'
                 elseif ( aerolist(iaer)%lacc ) then
                    ! Add Accumulation Mode Mass
                    nsp2 = nsp2 + 1
                    aedat_mode(nsp2)%species_name = 
     &                    trim(aedat(isp)%species_name)//modesuff(iacc)
                    aedat_mode(nsp2)%depv_surr = aedat(isp)%depv_surr
                    if ( aedat(isp)%depv_surr .ne. '' )
     &                   aedat_mode(nsp2)%depv_surr = 
     &                         trim(aedat(isp)%depv_surr)//'J'
                    aedat_mode(nsp2)%scav_surr = aedat(isp)%scav_surr
                    if ( aedat(isp)%scav_surr .ne. '' )
     &                   aedat_mode(nsp2)%scav_surr = 
     &                         trim(aedat(isp)%scav_surr)//'_ACCUM'
                    aedat_mode(nsp2)%cloud_surr = aedat(isp)%cloud_surr
                    if ( aedat(isp)%cloud_surr .ne. '' )
     &                   aedat_mode(nsp2)%cloud_surr = 
     &                         trim(aedat(isp)%cloud_surr)//'_ACCUM'
                 else
                    ! Mode not allowed for this species. Exit CMAQ
                    xmsg = 'Accumulation-mode aerosols have been requested for '//
     &                     TRIM(aedat(isp)%species_name)//
     &                     ' but they are not available for this species. See '//
     &                     'aerolist table in AERO_DATA.'
                    Call log_message( outdev, 'Error: '//xmsg )
                    call m3exit( pname, 0, 0, xmsg, xstat2 ) 
                 end if
 
                 aedat_mode(nsp2)%molwt = aedat(isp)%molwt
                 aedat_mode(nsp2)%lait = .False.
                 aedat_mode(nsp2)%lacc = .True.
                 aedat_mode(nsp2)%lcor = .False.
                 aedat_mode(nsp2)%optics_surr = aedat(isp)%optics_surr
                 aedat_mode(nsp2)%ic_surr     = aedat(isp)%ic_surr
                 aedat_mode(nsp2)%ic_fac      = aedat(isp)%ic_fac
                 aedat_mode(nsp2)%bc_surr     = aedat(isp)%bc_surr
                 aedat_mode(nsp2)%bc_fac      = aedat(isp)%bc_fac
                 aedat_mode(nsp2)%depv_fac    = aedat(isp)%depv_fac
                 aedat_mode(nsp2)%scav_fac    = aedat(isp)%scav_fac
                 aedat_mode(nsp2)%trns_flag   = aedat(isp)%trns_flag
                 aedat_mode(nsp2)%ddep_flag   = aedat(isp)%ddep_flag
                 aedat_mode(nsp2)%wdep_flag   = aedat(isp)%wdep_flag
                 aedat_mode(nsp2)%conc_flag   = aedat(isp)%conc_flag
                 
                 xmsg = 'Added an Accumulation Mode for Aerosol Species '//
     &                  trim(aedat_mode(nsp2)%species_name)
                 Call log_message( LOGDEV, xmsg )
              end if

              ! For Coarse-Mode Particles
              if ( aedat(isp)%lcor ) then
                 if ( aedat(isp)%species_name .eq. 'NUM' .OR. 
     &                aedat(isp)%species_name .eq. 'SRF' ) THEN
                    ! Add Coarse Mode Number or Surface Area
                    nsp2 = nsp2 + 1
                    aedat_mode(nsp2)%species_name = 
     &                    trim(aedat(isp)%species_name)//'COR'
                    aedat_mode(nsp2)%depv_surr = 
     &                    trim(aedat(isp)%depv_surr)//'COR'
                    aedat_mode(nsp2)%scav_surr = 
     &                    trim(aedat(isp)%scav_surr)//'_COARSE'
                    aedat_mode(nsp2)%cloud_surr = 
     &                    trim(aedat(isp)%cloud_surr)//'_COARSE'

                 elseif ( aerolist(iaer)%lcor ) then
                    ! Add Coarse Mode Mass
                    nsp2 = nsp2 + 1
                    if ( aedat(isp)%species_name .eq. 'ACORS' .OR.
     &                    aedat(isp)%species_name .eq. 'ASOIL' .OR.
     &                    aedat(isp)%species_name .eq. 'ASEACAT' .OR.
     &                    aedat(isp)%species_name .eq. 'ADE_CORS' ) THEN
                       aedat_mode(nsp2)%species_name = 
     &                       trim(aedat(isp)%species_name)
                       aedat_mode(nsp2)%depv_surr = 
     &                       trim(aedat(isp)%depv_surr)//'C'
                       aedat_mode(nsp2)%scav_surr = 
     &                       trim(aedat(isp)%scav_surr)//'_COARSE'
                       aedat_mode(nsp2)%cloud_surr = 
     &                       trim(aedat(isp)%cloud_surr)//'_COARSE' 
                    else  
                       aedat_mode(nsp2)%species_name = 
     &                       trim(aedat(isp)%species_name)//modesuff(icor)
                       aedat_mode(nsp2)%depv_surr = aedat(isp)%depv_surr
                       if ( aedat(isp)%depv_surr .ne. '' )
     &                      aedat_mode(nsp2)%depv_surr = 
     &                            trim(aedat(isp)%depv_surr)//'C'
                       aedat_mode(nsp2)%scav_surr = aedat(isp)%scav_surr
                       if ( aedat(isp)%scav_surr .ne. '' )
     &                      aedat_mode(nsp2)%scav_surr = 
     &                            trim(aedat(isp)%scav_surr)//'_COARSE'
                       aedat_mode(nsp2)%cloud_surr = aedat(isp)%cloud_surr
                       if ( aedat(isp)%cloud_surr .ne. '' )
     &                      aedat_mode(nsp2)%cloud_surr = 
     &                            trim(aedat(isp)%cloud_surr)//'_COARSE'
                    end if
                 else
                    ! Mode not allowed for this species. Exit CMAQ
                    xmsg = 'Coarse-mode aerosols have been requested for '//
     &                     TRIM(aedat(isp)%species_name)//
     &                     ' but they are not available for this species. See '//
     &                     'aerolist table in AERO_DATA.'
                    Call log_message( outdev, 'Error: '//xmsg )
                    call m3exit( pname, 0, 0, xmsg, xstat2 ) 
                 end if

                 aedat_mode(nsp2)%molwt = aedat(isp)%molwt
                 aedat_mode(nsp2)%lait = .False.
                 aedat_mode(nsp2)%lacc = .False.
                 aedat_mode(nsp2)%lcor = .True.
                 aedat_mode(nsp2)%optics_surr = aedat(isp)%optics_surr
                 aedat_mode(nsp2)%ic_surr     = aedat(isp)%ic_surr
                 aedat_mode(nsp2)%ic_fac      = aedat(isp)%ic_fac
                 aedat_mode(nsp2)%bc_surr     = aedat(isp)%bc_surr
                 aedat_mode(nsp2)%bc_fac      = aedat(isp)%bc_fac
                 aedat_mode(nsp2)%depv_fac    = aedat(isp)%depv_fac
                 aedat_mode(nsp2)%scav_fac    = aedat(isp)%scav_fac
                 aedat_mode(nsp2)%trns_flag   = aedat(isp)%trns_flag
                 aedat_mode(nsp2)%ddep_flag   = aedat(isp)%ddep_flag
                 aedat_mode(nsp2)%wdep_flag   = aedat(isp)%wdep_flag
                 aedat_mode(nsp2)%conc_flag   = aedat(isp)%conc_flag
                 
                 xmsg = 'Added a Coarse Mode for Aerosol Species '//
     &                  trim(aedat_mode(nsp2)%species_name)
                 Call log_message( LOGDEV, xmsg )
 
              end if

          end do

          write( xmsg, '(A,I3)' ), 'Total number of aerosol species: ',nsp2
          Call log_message( LOGDEV, '' )
          Call log_message( LOGDEV, xmsg )
          Call log_message( LOGDEV, '' )

          ae_species_data(1:nsp2) = aedat_mode(1:nsp2)

      End Subroutine aero_nml_modes
C----------------------------------------------------------------------- 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HRNO( JDATE, JTIME, TSTEP, NOPOL, L_DESID_DIAG )

C-----------------------------------------------------------------------
C Description:
   
C    Uses new NO algorithm NO = Normalized*Tadj*Padj*Fadj*Cadj
C    to estimate NO emissions 
C    Information needed to estimate NO emissions:
C       Julian Day          (integer)    JDATE
C       Surface Temperature (MCIP field) TA    (K)
C       Rainfall    (MCIP derived field) RAIN  (cm)
C       Soil Moisture       (MCIP field) SOILM (M**3/M**3) (PX_LSM)
C            (ratio of volume of water per volume of soil)
C       Soil Temperature    (MCIP field) SOILT (K)         (PX_LSM)
C       Soil Type           (MCIP field) ISLTYP            (PX_LSM)
C       Saturation values for soil types (constants)       (PX_LSM)
C    FOR PX Version, the Temperature adjustment factor accounts for wet and dry
C    soils and the precipitation adjustment factor accounts for saturated soils
C    FOR the non-PX version, the basic algorithm remains with a temperature
C    adjustment factor (dry soil) and no adjustment for saturated soils
 
C    The following arrays are potentially updated after a call to HRNO:
C       PTYPE     type of NO emission pulse 
C       PULSEDATE julian date for the beginning of an NO pulse 
C       PULSETIME        time for the beginning of an NO pulse
   
C    The calculation are based on the following paper:
C    J.J. Yienger and H. Levy II, Journal of Geophysical Research, vol 100,
C    11447-11464, 1995
 
C    The Temperature Adjustment Factor is based on section 4.2 for wet and dry
C    soils with the following modification (PX version):
C       Instead of classifying soils as either 'wet' or 'dry', the wet and dry
C       adjustment is calculated at each grid cell.  A linear interpolation between
C       the wet and dry adjustment factor is made using the relative amount of soil
C       moisture in the top layer (1cm) as the interpolating factor.  The relative
C       amount of soil moisture is determined by taking the MCIP soil moisture field
C       and dividing by the saturation value defined for each soil type in the PX
C       version of MCIP. The soil temperature is used in PX version
 
C    The Precipation Adjustment factor is based on section 4.1 with the following
C    modifications:
C       The rainrate is computed from the MCIP directly using a 24 hr daily total. 
C       The types of Pulses as described in YL95 were used to estimate the NO
C       emission rate.  
 
C    Also see the following paper for more information:
C    Proceedings of the Air and Waste Management Association/U.S. Environmental
C    Protection Agency EMission Inventory Conference, Raleigh October 26-28, 1999
C    Raleigh NC by Tom Pierce and Lucille Bender       
 
C    References:
 
C    Jacquemin B. and Noilhan J. (1990), Bound.-Layer Meteorol., 52, 93-134.
C    J.J. Yienger and H. Levy II, Journal of Geophysical Research, vol 100,
C    11447-11464, 1995
C    T. Pierce and L. Bender, Examining the Temporal Variability of Ammonia and
C    Nitric Oxide Emissions from Agricultural Processes Proceedings of the Air and
C    Waste Management Association/U.S. Environmental Protection Agency Emission
C    Inventory Conference, Raleigh October 26-28, 1999 Raleigh NC

C Preconditions:
C     Normalized NO emissions, Surface Temperature, Soil Moisture, Soil type,
C     NO emission pulse type, soil moisture from previous time step, julian date
C     of NO emission pulse start, time of NO emission pulse start,
C     soil type, SOIL TYPES, Land use data
 
C Subroutines and Functions Called (directly or indirectly):
C     PRECIP_ADJ     computes precipitation adjustment factor
C     FERTILIZER_ADJ computes fertlizer adjustment factor
C     VEG_ADJ        computes vegetation adjustment factor
C     GROWSEASON     computes Julian day of growing season
C     PRECIPFAC      computes precip adjustment factor from rainfall in last 24 hrs
C                    and time since pulse initiation
C     PULSETYPE      determines type & duration of NO emission pulse from rainrate
      
C Revision History:
C    10/01: Prototype by GAP
C    10/03: modified transition to non growing season for jul-oct of the year
C    08/04: Converted to SMOKE code style by C Seppanen
C   Mar 07: Restructure; J.Young
C   Jan 26: J.Young - move input data reads from tmpbeis;
C                     remove ck & report if TAIR > 315;
C                     restructure growing season, col/row loops;
C                     restructure PRECIP_ADJ
C   Jan 27: D. Wong - Eliminate potential race condition with mype = 0 and
C                     barrier implementation - not needed anyway.
C    02/11: S.Roselle-Replaced I/O API include files with UTILIO_DEFN
C    05/11: D. Wong - incorporated twoway model implementation
C    05/12: J.Young - make PX_LSM the default
C    05/13: D.Wong  - replaced M3EXIT with M3WARN when CHKGRID is called in the twoway model
C    09/13: D.Wong  - made the code more robust by
C                     * allowing simulation start time at any hour rather than 0
C                     * allowing finer met data time step and maintaining an hourly
C                       rainfall bucket
C    07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C    Aug 15 D.Wong:    Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O 
C                      implementation and added code to handle parallel I/O
C    09 Jan 15 J.Young: fix bug of not calculating NOPOL for last sync step of last
C                       run output step; get saturation from LSM module; put PX_LSM
C                       as first conditional clause
C    01 Feb 19 D.Wong: Implemented centralized I/O approach
C    30 June 19 J. Pleim: Corrected Soil Types to 16 and simplified code 
C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling System
C File: @(#)$Id: hrno.F,v 1.6 2011/10/21 16:10:18 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/hrno.F,v $
C Last updated: $Date: 2011/10/21 16:10:18 $ 
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE HGRD_DEFN             ! horizontal domain specifications
      USE BEIS_DEFN, ONLY: NSEF ! beis
      USE ASX_DATA_MOD
      USE UTILIO_DEFN
      USE MIO_ASCII
#ifdef mpas
      use mio_module
      USE util_module, only : NEXTIME, TIME2SEC, SECSDIFF, CURRSTEP, julian
#else
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif
      USE centralized_io_module

      IMPLICIT NONE
        
C Includes:

C Arguments:
      INTEGER, INTENT( IN )  :: JDATE         ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN )  :: JTIME         ! current simulation time (HHMMSS)
      INTEGER, INTENT( IN )  :: TSTEP( 3 )    ! time step vector (HHMMSS)
      REAL,    INTENT( OUT)  :: NOPOL( :,: )  ! output NO emissions
      LOGICAL, INTENT( IN )  :: L_DESID_DIAG  ! flag determining whether or not DESID
                                              !   is in diagnostic mode              
C External Functions
      LOGICAL,         EXTERNAL :: CHKGRID

C Parameters:
      INTEGER, PARAMETER :: MXRHRS = 24     ! no. of rainfall hours for YL95 algorithm
      INTEGER, PARAMETER :: LSM_WATER = 14
      REAL,    PARAMETER :: CFNODRYFC = ( 1.0 / 3.0 ) * ( 1.0 / 30.0 )
        
C Saturation values for 11 soil types from pxpbl.F  (MCIP PX version)
C In LSM_MOD:WSAT
C Pleim-Xiu Land-Surface and PBL Model (PX-LSM)
C See Jacquemin B. and Noilhan J. (1990), Bound.-Layer Meteorol., 52, 93-134.

C Local Variables:

      CHARACTER( 16 ), SAVE :: MNAME   ! logical name for MET_CRO_2D
      CHARACTER( 16 ), SAVE :: SOILINP ! logical name for input NO soil data
      CHARACTER( 16 ), SAVE :: SOILOUT = 'BEIS_SOILOUT' ! logical name for output NO soil data
      CHARACTER( 33 ), SAVE :: DESCSTR = 'hrly cnv. & non-cnv. rainfall for'

      CHARACTER( 16 ) :: VAR        ! variable name

      INTEGER, SAVE :: IHR       ! current simulation hour
      INTEGER          NDX       ! RAINFALL array timestep index

      REAL,    ALLOCATABLE, SAVE :: C_RAINFALL ( :,: ) ! rainfall for current hour
      REAL,    ALLOCATABLE, SAVE :: RNTOT    ( :,: )  ! RN + RC
      INTEGER, SAVE :: RHOURS    ! SOILINP(OUT) file no. of RAINFALL hour variables
      INTEGER, SAVE :: RDATE     ! date to update rainfall
      INTEGER, SAVE :: RTIME     ! time to update rainfall
      INTEGER, SAVE :: EDATE     ! end scenario date
      INTEGER, SAVE :: ETIME     ! end scenario time
      INTEGER, SAVE :: NDATE     ! test date to update rainfall
      INTEGER, SAVE :: NTIME     ! test time to update rainfall
        
      LOGICAL, SAVE :: INITIAL_DAY = .FALSE.  ! true: 1st 24 hours; no previous data
                                              ! false: previous 24 hours of rainfall
                                              ! are available for HRNO

      INTEGER          SOILCAT            ! soil category
      INTEGER, SAVE :: MSTEPS             ! run no. of steps
      INTEGER          I, J, K, R, C, L   ! counters
      LOGICAL          OK
      INTEGER          IOS                ! IO or memory allocation status
      INTEGER, SAVE :: METSTEP            ! met_cro_2d time step
      
      REAL,    SAVE :: EFAC
      REAL             CFNO               ! NO correction factor
      REAL             CFNOGRASS          ! NO correction factor for grasslands
      REAL             TAIR               ! surface temperature
      REAL             TSOI               ! soil temperature
      REAL             CFNOWET, CFNODRY, RATIO
      REAL             FAC1, FAC2, FAC3, FAC4

      LOGICAL, SAVE :: USE_SOILT = .TRUE. ! use soil temperature in PX version
                                          ! rather than estimate as in BEIS2

      LOGICAL, SAVE :: INITTIME = .TRUE.
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL, SAVE :: FIRSTHR  = .TRUE.
      LOGICAL, SAVE :: FIRST_WRITE = .TRUE.
      CHARACTER( 256 ) :: MESG            ! message buffer
      CHARACTER( 16 )  :: PNAME = 'HRNO'  ! procedure name

      INTEGER      GXOFF, GYOFF           ! global origin offset from file
C for INTERPX
      INTEGER       :: STRTCOLSIN, ENDCOLSIN, STRTROWSIN, ENDROWSIN  ! SOILINP

      CHARACTER( 16 ), SAVE :: VNAME_RC, VNAME_RN
      INTEGER :: SPC

#ifdef mpas
      integer :: io_mode
#endif

      LOGICAL, EXTERNAL :: FLUSH3

#ifdef verbose_hrno
      integer mxptype, ncfno0
      real    mxrntot, mxfac1, avgfac2, mxfac3, mxfac4
      real    mxtair, mxcfno
#endif
C-----------------------------------------------------------------------

      IF ( INITTIME ) THEN
        INITTIME = .FALSE.

#ifdef mpas
         if (ncd_64bit_offset) then
            io_mode = ior (nf90_noclobber, nf90_64bit_offset)
         else
            io_mode = nf90_noclobber
         end if

         call mio_fcreate ('SOILOUT', io_mode)
#endif

C Determine last timestamp
         EDATE = STDATE; ETIME = STTIME
         CALL NEXTIME( EDATE, ETIME, RUNLEN )   ! end date & time
         MSTEPS = TIME2SEC( RUNLEN ) / TIME2SEC( TSTEP( 1 ) )

#ifdef mpas
         METSTEP = tstep(3)
#else

C Open met file
         MNAME = PROMPTMFILE(
     &           'Enter name for gridded met input file',
     &           FSREAD3, 'MET_CRO_2D', PNAME )

C Get description of met file
         IF ( .NOT. DESC3( MNAME ) ) THEN
            MESG = 'Could not get description of file "'
     &           // TRIM( MNAME ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF

         METSTEP = TSTEP3D

C Check that grid description matches MET_CRO_2D file
         IF ( .NOT. CHKGRID( MNAME ) ) THEN
            MESG = 'Grid in file "' // TRIM( MNAME )
     &           // '" does not match grid in file ' // TRIM( MNAME ) // '"'
#ifdef twoway
            CALL M3WARN( PNAME, 0, 0, MESG )
#else
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
#endif
         END IF
#endif

         WRITE( MESG, '(A,I0,A,I0)' ),
     &     'NCOLS = ',NCOLS,': NROWS = ',NROWS
         CALL M3MESG( MESG )

         ALLOCATE( RNTOT( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'RNTOT', PNAME )

C Initial run until a full 24 hours has been recorded on the SOIL(OUT/INP) file
C for the Yienger and Levy algorithm
         WRITE( LOGDEV,'(/5X, A)' ) 'Temporal BEIS ...'
         RHOURS = MXRHRS

C If initial run, initialize some variables, otherwise get them from file
         IF ( NEW_START ) THEN

            PULSEDATE = 0   ! array
            PULSETIME = 0   ! array
            PTYPE     = 0   ! array

         END IF   ! initial run

         ALLOCATE( C_RAINFALL( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'RAINFALL', PNAME )
         C_RAINFALL = 0.0 ! array

         RDATE = STDATE; RTIME = STTIME
!        IHR = 0
         EFAC = EXP( -0.103 * 30.0 )

         ! Create rain data file for soil NO
         ! Final timestamp
         NDATE = EDATE; NTIME = ETIME

         ! Build description for, and create/open soil NO emissions output file
         FTYPE3D = GRDDED3
         SDATE3D = NDATE
         STIME3D = NTIME
         TSTEP3D = 0   ! make it a time-independent file
         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D = 1
         NVARS3D = 3 + RHOURS
         MXREC3D = 1
         NTHIK3D = 1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN
        
         VNAME3D = ' '
         VNAME3D( 1 ) = 'PTYPE'
         VNAME3D( 2 ) = 'PULSEDATE'
         VNAME3D( 3 ) = 'PULSETIME'
        
         DO I = 1, RHOURS
            WRITE( VAR, '(A8,I2.2)' ) 'RAINFALL', I
            VNAME3D( I+3 ) = VAR
         END DO
        
         UNITS3D = ' '
         UNITS3D( 1 ) = 'INTEGER'
         UNITS3D( 2 ) = 'YYYYDDD'
         UNITS3D( 3 ) = 'HHMMSS'
         UNITS3D( 4:RHOURS+3 ) = 'cm'
        
         VDESC3D( 1 ) = 'NO emission pulse type'
         VDESC3D( 2 ) = 'CMAQ starting date for NO emission pulse'
         VDESC3D( 3 ) = 'CMAQ starting time for NO emission pulse'
!        VDESC3D( 4:RHOURS+3 ) = 'hourly convective and non-convective rainfall'
         DO I = 1, RHOURS
            VDESC3D( I+3 ) = DESCSTR // DDTTM( I )
         END DO
        
         VTYPE3D = 0
         VTYPE3D( 1 ) = M3INT
         VTYPE3D( 2 ) = M3INT
         VTYPE3D( 3 ) = M3INT
         VTYPE3D( 4:RHOURS+3 ) = M3REAL
        
         FDESC3D = ' '
         FDESC3D( 1 ) = 'Gridded rainfall data for soil NO emissions'
         FDESC3D( 2 ) = '/From/ ' // PNAME
         FDESC3D( 3 ) = '/Version/ CMAQ'
        
         ! Store MIO Metadata
         NDIMS3D( 1:NVARS3D ) = 3
         L_TSTEP( 1:NVARS3D ) = .True.
         L_LAY  ( 1:NVARS3D ) = .False.
         L_COL  ( 1:NVARS3D ) = .True.
         L_ROW  ( 1:NVARS3D ) = .True.
         L_VEXT ( 1:NVARS3D ) = .False.
        
         CALL LOAD_MIO_FILE ( 'SOILOUT', 0, 0, 0,
     &        VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &        VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &        L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &        L_VEXT(1:NVARS3D) )

         ! Open NO rain data save file
         IF ( IO_PE_INCLUSIVE ) THEN
            IF ( .NOT. OPEN3( SOILOUT, FSNEW3, PNAME ) ) THEN
               MESG = 'Could not open "' // TRIM( SOILOUT ) // '" file'
               CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT1 )
            END IF
         END IF

         RETURN

      END IF   ! INITTIME

C Non-convective (RN) and convective (RC) rain is the total amount for the met
C preprocessor's (typically MCIP) output timestep (typically one hour). It doesn't
C make sense to time-interpolate these values, since rain generally does not fall
C at a constant rate for an output timestep.
      IF ( .NOT. CURRSTEP( JDATE, JTIME, STDATE, STTIME, METSTEP,
     &                     NDATE, NTIME ) ) THEN
         MESG = 'Cannot get step date and time'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT3 )
      END IF

C Store current time step rainfall totals
      IF ( NDATE .EQ. RDATE .AND. NTIME .EQ. RTIME ) THEN   ! on the METSTEP

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            IHR = MOD( RTIME / 10000 + 23, 24 )  ! previous hour bin,
                                                 ! to accommodate non-zero start hour
         END IF

C For the first hour of the simulation day, use the previous 24 hour
C data to compute precip adjustment

         NDX = 1 + MOD( IHR, MXRHRS )
         C_RAINFALL = C_RAINFALL + MET_DATA%RN + MET_DATA%RC
         WRITE( DDTTM( NDX ),'(I8,":",I6.6)' ) RDATE, RTIME

         IF ( MOD( NTIME, 10000 ) .EQ. 0 ) THEN    ! at the hourly mark
            RAINFALL( :,:,NDX ) = C_RAINFALL
            C_RAINFALL = 0.0
            IHR = IHR + 1
         END IF

!        CALL NEXTIME( RDATE, RTIME, TSTEP( 1 ) )
         CALL NEXTIME( RDATE, RTIME, METSTEP )

         RNTOT = 0.0   ! array assignment
         IF ( NEW_START ) THEN
            IF ( IHR .LT. MXRHRS ) THEN
               INITIAL_DAY = .TRUE.
            ELSE
               INITIAL_DAY = .FALSE.
            END IF
         ELSE   ! store accumulated rain in RNTOT array
            DO I = 1, MXRHRS
               RNTOT = RNTOT + RAINFALL( :,:,I )
            END DO
         END IF

#ifdef verbose_hrno
         write( logdev,* ) 'hrno - INITIAL_DAY, IHR: ', initial_day, ihr
#endif

      END IF   ! on the METSTEP

C Calculate temporal non-speciated soil NO emissions
 
      IF ( GROWSEASON( JDATE ) .EQ. 0 ) THEN   ! not growing season

#ifdef verbose_hrno
         write( logdev,* ) ' not growing season'
         mxtair = 0.0; mxcfno = 0.0; ncfno0 = 0
#endif

         DO R = 1, NROWS
            DO C = 1, NCOLS
            
               TAIR = MET_DATA%TEMP2( C,R )   ! unit in degree K

C Check min bounds for temperature and limit to 303 deg K
               IF ( TAIR .LT. 200.0 ) THEN
                  WRITE( MESG, 94010 ) 'TAIR=', TAIR,
     &                 'out of range at (C,R)=', C, R
                  CALL M3MESG( MESG )
                  Write( MESG,94010 ) 'Max TAIR: ', Maxval( MET_DATA%TEMP2 ),
     &                 'at (C,R)', Maxloc( MET_DATA%TEMP2 )
                  CALL M3MESG( MESG )
                  Write( MESG,94010 ) 'Min TAIR: ', Minval( MET_DATA%TEMP2 ),
     &                 'at (C,R)', Minloc( MET_DATA%TEMP2 )
                  CALL M3MESG( MESG )
                  CALL M3EXIT( PNAME, JDATE, JTIME, '*** ABORT', 2 )
               END IF
               TAIR = MIN( TAIR, 303.0 )

               IF ( TAIR .GT. 268.8690 ) THEN
                  CFNO = EXP( 0.04686 * TAIR - 14.30579 ) ! grass (from BEIS2)
               ELSE
                  CFNO = 0.0
#ifdef verbose_hrno
                  ncfno0 = ncfno0 + 1
#endif
               END IF

#ifdef verbose_hrno
               mxtair = max( mxtair, tair )
               mxcfno = max( mxcfno, cfno )
#endif

               NOPOL( C,R ) = CFNO * ( NGROWAGNO( C,R )  ! agriculture
     &                             +   NONAGNO( C,R ) )  ! non-agriculture

            END DO  ! columns
         END DO  ! rows

#ifdef verbose_hrno
      write( logdev,2009 ) ncfno0, mxtair, mxcfno
2009  format( ' hrno - NCFNO0, MAX TAIR,CFNO: ', i7, 2f10.5 )
#endif

      ELSE   ! growing season

#ifdef verbose_hrno
         mxptype = 0; mxrntot = 0.0
         mxfac1 = 0.0; avgfac2 = 0.0; mxfac3 = 0.0; mxfac4 = 0.0
#endif

         DO R = 1, NROWS
            DO C = 1, NCOLS
            
               TAIR = MET_DATA%TEMP2( C,R )   ! unit in degree K

C Check min bounds for temperature and limit max to 303 deg K
               IF ( TAIR .LT. 200.0 ) THEN
                  WRITE( MESG, 94010 ) 'TAIR=', TAIR,
     &                 'out of range at (C,R)=', C, R
                  CALL M3EXIT( PNAME, JDATE, JTIME, MESG, 2 )
               END IF
               TAIR = MIN( TAIR, 303.0 )

C Calculate NO emissions by going thru temperature cases

               IF ( PX_LSM .OR. CLM_LSM .OR. NOAH_LSM ) THEN

                  SOILCAT = GRID_DATA%SLTYP( C,R )
                  TSOI = 0.0
                  IF( SOILCAT .NE. LSM_WATER  ) THEN
                     RATIO = MET_DATA%SOIM1( C,R ) / Grid_Data%WSAT( C,R )
                     IF ( USE_SOILT ) THEN
                        TSOI = MET_DATA%SOIT1( C,R )
                     ELSE
                        TSOI = 0.72 * TAIR + 82.28
                     END IF
                     TSOI = MIN( MAX( TSOI, 273.16 ), 303.16 ) - 273.16   ! deg C
                     CFNODRY = CFNODRYFC * TSOI ! see YL 1995 Eqn 9a p. 11452

                     IF ( TSOI .LE. 10.0 ) THEN ! see YL 1995 Eqn 7b
                        CFNOWET = 0.28 * EFAC * TSOI   ! linear cold case
                     ELSE
                        CFNOWET = EFAC * EXP( 0.103 * TSOI )   ! exponential case
                     END IF

                     CFNO = CFNODRY + RATIO * ( CFNOWET - CFNODRY )
                     FAC1 = GROWAGNO( C,R ) * CFNO
     &                    * FERTILIZER_ADJ( JDATE )
     &                    * VEG_ADJ( JDATE )

                  ELSE
                     FAC1 = 0.0
                  END IF

                  IF ( INITIAL_DAY ) THEN
                     FAC2 = 1.0
                     PTYPE( C,R ) = 0
                     PULSEDATE( C,R ) = 0
                     PULSETIME( C,R ) = 0
                  ELSE
                     FAC2 = PRECIP_ADJ_PX( JDATE, JTIME, RNTOT( C,R ),
     &                                     MET_DATA%SOIM1( C,R ),
     &                                     Grid_Data%WSAT( C,R ), PTYPE( C,R ), 
     &                                     PULSEDATE( C,R ), PULSETIME( C,R ) )
                  END IF

               ELSE

                  TSOI = 0.72 * TAIR + 82.28
                  TSOI = MIN( MAX( TSOI, 273.16 ), 303.16 ) - 273.16   ! deg C
                  CFNODRY = CFNODRYFC * TSOI ! see YL 1995 Eqn 9a p. 11452
                  IF ( TSOI .LE. 10.0 ) THEN ! see YL 1995 Eqn 7b
                     CFNOWET = 0.28 * EFAC * TSOI   ! linear cold case
                  ELSE
                     CFNOWET = EFAC * EXP( 0.103 * TSOI )   ! exponential case
                  END IF
                  CFNO = 0.5 * ( CFNOWET + CFNODRY )

                  FAC1 = GROWAGNO( C,R ) * CFNO
     &                 * FERTILIZER_ADJ( JDATE )
     &                 * VEG_ADJ( JDATE )
     
                  IF ( INITIAL_DAY ) THEN
                     FAC2 = 1.0
                     PTYPE( C,R ) = 0
                     PULSEDATE( C,R ) = 0
                     PULSETIME( C,R ) = 0
                  ELSE
                     FAC2 = PRECIP_ADJ( JDATE, JTIME, RNTOT( C,R ),
     &                                  PTYPE( C,R ), PULSEDATE( C,R ),
     &                                  PULSETIME( C,R ) )
                  END IF

               END IF  ! PX version check

               IF ( TAIR .GT. 268.8690 ) THEN  
                  CFNOGRASS = EXP( 0.04686 * TAIR - 14.30579 ) ! grass (from BEIS2)
                  FAC3 = NGROWAGNO( C,R ) * CFNOGRASS 
                  FAC4 = NONAGNO( C,R ) * CFNOGRASS
               ELSE
                  FAC3 = 0.0
                  FAC4 = 0.0
               END IF

#ifdef verbose_hrno
               mxptype = max( mxptype, ptype( c,r ) )
               mxrntot = max( mxrntot, rntot( c,r ) )
               mxfac1 = max( mxfac1, fac1 )
               avgfac2 = avgfac2 + fac2
               mxfac3 = max( mxfac3, fac3 )
               mxfac4 = max( mxfac4, fac4 )
#endif
               IF( TSOI .LE. 0.0 ) THEN
                  NOPOL( C,R ) = 0.0
               ELSE 
                  NOPOL( C,R ) = MAX( ( FAC1 * FAC2 ), FAC3 ) + FAC4
               END IF

            END DO  ! columns
         END DO  ! rows

#ifdef verbose_hrno
      write( logdev,2011 ) mxptype, mxrntot, avgfac2/(ncols*nrows), mxfac1, mxfac3, mxfac4
2011  format( ' hrno MAX PTYPE,RNTOT,AVGFAC2,FAC1,3,4: ', I2, 2f8.3 , 3f10.3 )
#endif

      END IF  ! growing season check

      IF ( SECSDIFF( JDATE,JTIME, EDATE,ETIME ) .GT. TIME2SEC( TSTEP( 2 ) ) .OR. L_DESID_DIAG ) RETURN

#ifdef mpas
      var = 'PTYPE'
      call mio_fwrite ('SOILOUT', var, pname, ptype)

      var = 'PULSEDATE'
      call mio_fwrite ('SOILOUT', var, pname, pulsedate)

      var = 'PULSETIME'
      call mio_fwrite ('SOILOUT', var, pname, pulsetime)

      do i = 1, rhours
         write( var, '(a8,i2.2)' ) 'RAINFALL', I
         call mio_fwrite ('SOILOUT', var, pname, rainfall(1,1,i))
      end do
#else

C Create rain data file for soil NO

C Final timestamp
      NDATE = EDATE; NTIME = ETIME

#ifdef parallel_io
      IF ( IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. FLUSH3 ( SOILOUT ) ) THEN
            MESG = 'Could not sync to disk ' // TRIM( SOILOUT )
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END IF
      CALL SE_BARRIER
      IF ( .NOT. IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( SOILOUT, FSREAD3, PNAME ) ) THEN
            MESG = 'Could not open ' // TRIM( SOILOUT )
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END IF
#endif

C Write soil NO rain data file

      VAR = 'PTYPE'
      IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, PTYPE ) ) THEN
         MESG = 'Could not write "' // TRIM( VAR ) //
     &          '" to file "' // TRIM( SOILOUT ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF

      VAR = 'PULSEDATE'
      IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, PULSEDATE ) ) THEN
         MESG = 'Could not write "' // TRIM( VAR ) //
     &          '" to file "' // TRIM( SOILOUT ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF

      VAR = 'PULSETIME'
      IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, PULSETIME ) ) THEN
         MESG = 'Could not write "' // TRIM( VAR ) //
     &          '" to file "' // TRIM( SOILOUT ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF

      NDX = 1 + MOD( IHR, MXRHRS )
      RAINFALL( :,:,NDX ) = C_RAINFALL
      DO I = 1, RHOURS
         WRITE( VAR, '(A8,I2.2)' ) 'RAINFALL', I
         IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, RAINFALL( :,:,I ) ) ) THEN
            MESG = 'Could not write "' // TRIM( VAR ) //
     &             '" to file "' // TRIM( SOILOUT ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END DO

      WRITE( LOGDEV,94040 )
     &      'Timestep written to', SOILOUT,
     &      'for date and time', NDATE, NTIME
#endif

      RETURN

94010 FORMAT( A, F10.2, 1X, A, I3, ',', I3 )
94040 FORMAT( /5X, 3( A, :, 1X ), I8, ":", I6.6 )

C-----------------------------------------------------------------------

      CONTAINS

         REAL FUNCTION PRECIP_ADJ_PX( JDATE, JTIME, RAIN, SOILM, WSAT,
     &                                PTYPE, PULSEDATE, PULSETIME )

C-----------------------------------------------------------------------
 
C Description:
   
C    Compute precipitation adjustment factor for estimate of NO emissions 
C    Uses: julian day, time, soil moisture
C    Requires the use of three arrays that are re-used each time step:
C    PTYPE, PULSEDATE, PULSETIME 
C    These arrays store the type of NO pulse initiated by the rainfall
C    and the starting date and time of the pulse.
 
C Preconditions:
C    Soil Moisture current time, Soil Moisture previous time,
C    Soil type, Land Use, PTYPE, PULSEDATE, PULSETIME 
 
C Subroutines and Functions Called:
C    precipfact - computes precip adjustment factor from rainrate and time
C                 since pulse initiation
C    pulsetype  - determines type & duration of NO emission pulse from rainrate
 
C Revision History:
C    11/01 : Prototype by GAP
C    3/05  : create separate functions for PX vs non-PX versions
C    1/10  : J.Young - restructure
C    7/31/19 J. Pleim : Corrected Soil Types and Simplified Code
C-----------------------------------------------------------------------

         USE UTILIO_DEFN

         IMPLICIT NONE

C Function arguments:
         INTEGER, INTENT( IN )    :: JDATE, JTIME
         REAL,    INTENT( IN )    :: RAIN
         REAL,    INTENT( IN )    :: SOILM     ! only avilable if PX version
         REAL,    INTENT( IN )    :: WSAT      ! only tested for PX and CLM versions         
         INTEGER, INTENT( INOUT ) :: PTYPE     ! pulse type
         INTEGER, INTENT( INOUT ) :: PULSEDATE ! date of pulse start
         INTEGER, INTENT( INOUT ) :: PULSETIME ! date of pulse end

C External functions:
         
C Parameters:
         REAL, PARAMETER :: SAT_THRES = 0.95

C Local variables:
         INTEGER SOILCAT     ! soil type category
         INTEGER PTYPE_TEST

C-----------------------------------------------------------------------

C Summary of algorithm
C   1. compute rate of change of soil moisture from soil moisture
C   2. estimate rainrate from soil moisture and soil moisture rate
C   3. compute adjustment using pulsetype, rainrate, ptype, and date/time
C        if stronger NO pulse compared to previous time step, then
C        start a new NO emission pulse,
C        otherwise continue present NO pulse
C   4. override adjustment for saturated soils 

         SOILCAT = GRID_DATA%SLTYP( C,R )
         IF ( SOILCAT .NE. LSM_WATER  ) THEN 
            IF ( SOILM .GE. SAT_THRES * WSAT ) THEN
               PRECIP_ADJ_PX = 0.0
            ELSE
               PTYPE_TEST = PULSETYPE( RAIN )
               IF ( PTYPE_TEST .GT. PTYPE ) THEN ! Rainfall class type increases
                  PULSEDATE = JDATE              ! (NO emission pulse generated)
                  PULSETIME = JTIME
                  PTYPE = PTYPE_TEST
               END IF
               PRECIP_ADJ_PX = PRECIPFAC( JDATE, JTIME, PULSEDATE, PULSETIME, PTYPE )
            END IF
         ELSE
            PRECIP_ADJ_PX = 0.0
         END IF

         RETURN
         
         END FUNCTION PRECIP_ADJ_PX
         
C-----------------------------------------------------------------------

         REAL FUNCTION PRECIP_ADJ( JDATE, JTIME, RAIN,
     &                             PTYPE, PULSEDATE, PULSETIME )

C-----------------------------------------------------------------------
C Description:
   
C    Compute precipitation adjustment factor for estimate of NO emissions 
C    Uses: julian day, time, soil moisture
C    Requires the use of three arrays that are re-used each time step:
C    PTYPE, PULSEDATE, PULSETIME 
C    These arrays store the type of NO pulse initiated by the rainfall
C    and the starting date and time of the pulse.
 
C Preconditions:
C    Soil Moisture current time, Soil Moisture previous time,
C    Soil type, Land Use, PTYPE, PULSEDATE, PULSETIME 
 
C Subroutines and Functions Called:
C    precipfact - computes precip adjustment factor from rainrate and time
C                 since pulse initiation
C    pulsetype  - determines type & duration of NO emission pulse from rainrate
 
C Revision History:
C    11/01 : Prototype by GAP
C    3/05  : created a non-PX version of this function 
C    1/10  : J.Young - restructure
  
C-----------------------------------------------------------------------

         USE UTILIO_DEFN

         IMPLICIT NONE

C Function arguments:
         INTEGER, INTENT( IN )    :: JDATE, JTIME
         REAL,    INTENT( IN )    :: RAIN
         INTEGER, INTENT( INOUT ) :: PTYPE     ! pulse type
         INTEGER, INTENT( INOUT ) :: PULSEDATE ! date of pulse start
         INTEGER, INTENT( INOUT ) :: PULSETIME ! time of pulse start

C External functions:

C Local variable
         INTEGER PTYPE_TEST

C-----------------------------------------------------------------------

C Summary of algorithm
C    1. if no rainfall or new rainfall class less than current one, continue
C       existing NO emission pulse
C    2. if new rainfall that increases rainfall class, then create new NO
C       emission pulse using pulsetype, rainrate, ptype, and date/time -
C       if stronger NO pulse compared to previous time step, then start
C       a new NO emission pulse

         PTYPE_TEST = PULSETYPE( RAIN )
         IF ( PTYPE_TEST .GT. PTYPE ) THEN ! Rainfall class type increases
            PULSEDATE = JDATE              ! (NO emission pulse generated)
            PULSETIME = JTIME
            PTYPE = PTYPE_TEST
         END IF

         PRECIP_ADJ = PRECIPFAC( JDATE, JTIME, PULSEDATE, PULSETIME, PTYPE )

         RETURN
         
         END FUNCTION PRECIP_ADJ

C-----------------------------------------------------------------------

         REAL FUNCTION FERTILIZER_ADJ( DATE )

C Compute a fertilizer adjustment factor for the given date in yyyyddd format.
C If it is not growing season, the adjustment factor is 0; otherwise, it
C ranges from 0.0 to 1.0.

         IMPLICIT NONE
         
C Function arguments:
         INTEGER, INTENT( IN ) :: DATE

C Local variables:
         INTEGER  GDAY

C-----------------------------------------------------------------------

         GDAY = GROWSEASON( DATE )
         
         IF ( GDAY .EQ. 0 ) THEN
            FERTILIZER_ADJ = 0.0
         ELSE IF ( GDAY .GE. 1 .AND. GDAY .LT. 30 ) THEN  ! first month of growing season
            FERTILIZER_ADJ = 1.0
         ELSE IF ( GDAY .GE. 30 ) THEN
            FERTILIZER_ADJ = 1.0 + 30.0 / 184.0 - FLOAT( GDAY ) / 184.0
         ELSE
            WRITE( MESG,94010 ) 'Invalid date specified; date = ', DATE,
     &                          'growing season day = ', GDAY
            CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
         END IF

94010    FORMAT( A, I8, 1X, A, I3 )
         
         RETURN
         
         END FUNCTION FERTILIZER_ADJ

C-----------------------------------------------------------------------

         REAL FUNCTION VEG_ADJ( DATE )

C Compute a vegetation adjustment factor for the given date in yyyyddd format.
C The adjustment factor ranges from 0.5 to 1.0.

         IMPLICIT NONE
         
C Function arguments:
         INTEGER, INTENT( IN ) :: DATE

C Local variables:
         INTEGER  GDAY

C-----------------------------------------------------------------------

         GDAY = GROWSEASON( DATE )
         
         IF ( GDAY .LE. 30 ) THEN
            VEG_ADJ = 1.0
         ELSE IF ( GDAY .GT. 30 .AND. GDAY .LT. 60 ) THEN
            VEG_ADJ = 1.5 - ( FLOAT( GDAY ) / 60.0 )
         ELSE IF ( GDAY .GE. 60 ) THEN
            VEG_ADJ = 0.5
         ELSE
            WRITE( MESG,94010 ) 'Invalid date specified; date = ', DATE,
     &                          'growing season day = ', GDAY
            CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
         END IF

94010    FORMAT( A, I8, 1X, A, I3 )

         RETURN
      
         END FUNCTION VEG_ADJ
         
C-----------------------------------------------------------------------

         INTEGER FUNCTION GROWSEASON( DATE )

C Compute the day of the growing season corresponding to the given date
C in yyyyddd format.

         USE UTILIO_DEFN

         IMPLICIT NONE
         
C Function arguments:
         INTEGER, INTENT( IN ) :: DATE   ! YYYYDDD

C External functions:

C Parameters:
         INTEGER, PARAMETER :: GSTART_MONTH  = 04     ! April
         INTEGER, PARAMETER :: GSTART_DAY    = 01
         INTEGER, PARAMETER :: GEND_MONTH    = 10     ! October
         INTEGER, PARAMETER :: GEND_DAY      = 31

C Local variables:
         INTEGER  YEAR, MONTH, DAY
         INTEGER  JDAY, GDAY
         INTEGER  GSJULIAN_START
         INTEGER  GSJULIAN_END
         
C-----------------------------------------------------------------------

         YEAR = INT( FLOAT( DATE ) / 1000.0 )
         JDAY = DATE - YEAR * 1000
         
         GSJULIAN_START = JULIAN( YEAR, GSTART_MONTH, GSTART_DAY )
         GSJULIAN_END = JULIAN( YEAR, GEND_MONTH, GEND_DAY )
         
         IF ( JDAY .GE. GSJULIAN_START .AND. JDAY .LE. GSJULIAN_END ) THEN
            GROWSEASON = JDAY - GSJULIAN_START + 1  ! growing season
         ELSE IF ( JDAY .GE. 1 .AND. JDAY .LE. 366 ) THEN
            GROWSEASON = 0                          ! before or after growing season
         ELSE
            WRITE( MESG,94010 ) 'Invalid date specified; date = ', DATE,
     &                          'jday = ', JDAY
            CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
         END IF

94010    FORMAT( A, I8, 1X, A, I3 )

         RETURN

         END FUNCTION GROWSEASON

C-----------------------------------------------------------------------

         REAL FUNCTION PRECIPFAC( JDATE, JTIME, PDATE, PTIME, PTYPE )

C Compute a precipitation adjustment factor from a previous 24 hour rainfall
C based on YL 1995
C The pulse type is an integer ranging from 0 to 3 indicating the type of
C rainfall rate:
C If rainfall < 0.1 cm in last 24 hr, "reset"
C Else if rainfall < 0.5 cm in last 24 hr, and time since last pulse is .ge. 2 days,
C    reset; else, precipfact=11.19*...
C Else if rainfall < 1.5 cm in last 24 hr, and time since last pulse is .ge. 6 days,
C    reset; else, precipfact=14.68*...
C Else if rainfall >=1.5 cm in last 24 hr, and time since last pulse is .ge. 13 days,
C    reset; else, precipfact=18.46*...

         USE UTILIO_DEFN

         IMPLICIT NONE
         
C Function arguments:
         INTEGER, INTENT( IN )    :: JDATE, JTIME, PDATE, PTIME
         INTEGER, INTENT( INOUT ) :: PTYPE
         
C External functions:

C Parameters:
         REAL, PARAMETER :: DAYPERSEC = 1.0 / ( 24.0 * 3600.0 ) ! = 0.000011574074074

C Local variables:
         REAL DAYDIFF, DAYDIF1
         
C-----------------------------------------------------------------------

         DAYDIFF = FLOAT( SECSDIFF( PDATE, PTIME, JDATE, JTIME ) ) * DAYPERSEC
         DAYDIF1 = DAYDIFF + 1.0
         
         SELECT CASE( PTYPE )
         CASE( 0 )
            PRECIPFAC = 1.0
         CASE( 1 )
            IF ( ( DAYDIFF ) .LT. 2.0 ) THEN
               PRECIPFAC = 11.19 * EXP( -0.805 * DAYDIF1 )
            ELSE
               PTYPE = 0
               PRECIPFAC = 1.0
            END IF
         CASE( 2 )
            IF ( ( DAYDIFF ) .LT. 6.0 ) THEN
               PRECIPFAC = 14.68 * EXP( -0.384 * DAYDIF1 )
            ELSE
               PTYPE = 0
               PRECIPFAC = 1.0
            END IF
         CASE( 3 )
            IF ( ( DAYDIFF ) .LT. 13.0 ) THEN
               PRECIPFAC = 18.46 * EXP( -0.208 * DAYDIF1 )
            ELSE
               PTYPE = 0
               PRECIPFAC = 1.0
            END IF
         CASE DEFAULT
            WRITE( MESG,'( A, I6 )' ) 'Invalid Pulse Type specified ',
     &                                 PTYPE
            CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
         END SELECT
         
         RETURN
         
         END FUNCTION PRECIPFAC
    
C-----------------------------------------------------------------------

         INTEGER FUNCTION PULSETYPE( RAIN )

C Compute the pulse type from the rainfall rate (see YL 1995).

         IMPLICIT NONE
         
C Function arguments
         REAL, INTENT( IN ) :: RAIN   ! [cm/24hr]
         
C-----------------------------------------------------------------------

         IF ( RAIN .LT. 0.1 ) THEN
            PULSETYPE = 0
         ELSE IF ( RAIN .LT. 0.5 ) THEN
            PULSETYPE = 1
         ELSE IF ( RAIN .LT. 1.5 ) THEN
            PULSETYPE = 2
         ELSE
            PULSETYPE = 3
         END IF
         
         RETURN
         
         END FUNCTION PULSETYPE

C-----------------------------------------------------------------------

      END SUBROUTINE HRNO

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE PA_IRR_CLT
     
      IMPLICIT NONE
C-----------------------------------------------------------------------
C Function: Set up for and update the integrated reaction rates 
C           computed by the subroutine pa_irr
             
C Preconditions: None
 
C Key Subroutines/Functions Called: None
 
C Revision History
C  Prototype created by Jerry Gipson, November, 1996
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified 1/19/99 by David Wong at LM:
C                      -- add four include files because of new PA_CMN.EXT
C  Modified 2/26/99 by David Wong at LM:
C                      -- remove SUBST_AE_SPC, SUBST_NR_SPC, SUBST_TR_SPC, 
C                         three .EXT files
C                      -- use ifdef parallel to distinguish the need of
C                         shifting to origin to perform calculation in serial 
C                         but not in parallel
C                      -- change BEG* and END* to corresponding 
C                         MY_IRR_BEG*, and MY_IRR_END*, respectively
C   30 Mar 01 J.Young: Use PAGRD_DEFN, which uses HGRD_DEFN; eliminate
C                      BLKPRM.EXT; Use GRVARS
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module (GRID_CONF)
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Sep 16 J.Young: update for inline procan (IRR)
C    1 Feb 19 David Wong: removed all MY_N clauses
C   17 Jan 24 David Wong: fixed a bug that IRR/IPR process alllows a subset of
C                         level, a..b, where 1 <= a <= b <= NLAYS
C-----------------------------------------------------------------------

      CONTAINS
      
      SUBROUTINE PA_IRR_SETUP( NBLKS, LIRRBLK, LCELL, BLKLEN,
     &                         CCOL, CROW, CLEV )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Flags all blocks that will need IRR/MB calculations
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs

         IMPLICIT NONE 
C..Includes: None

C..Arguments: 
         INTEGER, INTENT( IN    ) :: NBLKS            ! Number of blocks in modeling domain
         LOGICAL, INTENT(   OUT ) :: LIRRBLK( : )     ! Flag for doing IRR
         INTEGER, INTENT( IN    ) :: BLKLEN ( : )     ! Number of cells in each
         INTEGER, INTENT( IN    ) :: LCELL  ( : )     ! Offset to 1st cell in each
         INTEGER, INTENT( IN    ) :: CCOL   ( : )     ! Column pointer for cell
         INTEGER, INTENT( IN    ) :: CROW   ( : )     ! Row pointer for cell
         INTEGER, INTENT( IN    ) :: CLEV   ( : )     ! Level pointer for cell
C..Parameters: None

C..External Functions: None
 
!?..Saved Local Variables:
!?????LOGICAL, SAVE :: LIRRCELL( BLKSIZE )  ! Flag to do IRR for a cell

C..Scratch Local Variables:
         INTEGER BLK            ! Loop index for blocks
         INTEGER CELL           ! Counter of cells in a block
         INTEGER COL, ROW, LEV  ! Column, row, and level indices
         INTEGER ECL            ! Ending cell no. of block
         INTEGER ICL            ! Loop index for cells in a block
         INTEGER NCELL          ! Loop index for cells in a block
         INTEGER PC, PR, PL     ! Column, row, and level indices for PA outputs
         INTEGER NIRR           ! Loop index for IRR variables
         INTEGER SCL            ! Starting cell no. of block
C-----------------------------------------------------------------------

         DO BLK = 1, NBLKS
            SCL = LCELL( BLK ) + 1
            ECL = LCELL( BLK ) + BLKLEN( BLK )
            DO ICL = SCL, ECL
               COL = CCOL( ICL )
               ROW = CROW( ICL )
               LEV = CLEV( ICL )
               IF ( COL .GE. MY_IRR_BEGCOL .AND. COL .LE. MY_IRR_ENDCOL .AND.
     &              ROW .GE. MY_IRR_BEGROW .AND. ROW .LE. MY_IRR_ENDROW .AND.
     &              LEV .GE. MY_IRR_BEGLEV .AND. LEV .LE. MY_IRR_ENDLEV ) 
     &              LIRRBLK( BLK ) = .TRUE.
            END DO
          END DO 
          RETURN
        END SUBROUTINE PA_IRR_SETUP
        SUBROUTINE PA_IRR_CKBLK ( NUMCELLS, LIRRFLAG, OFFSET, CCOL,
     &                            CROW, CLEV, NORDCELL, NIRRCLS, IRRCELL )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Checks a block of cells to see if it has a cell that needs IRR
c  calculations for the case in which when the cell composition of the
c  block can change
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
     
         IMPLICIT NONE
C..Arguments 
         INTEGER, INTENT( IN    ) :: NUMCELLS       ! Number of cells in one block
         LOGICAL, INTENT(   OUT ) :: LIRRFLAG       ! Flag for doing IRR for one block
         INTEGER, INTENT( IN    ) :: OFFSET         ! Offset to 1st cell in a block
         INTEGER, INTENT( IN    ) :: CCOL   ( : )   ! Column pointer for cell
         INTEGER, INTENT( IN    ) :: CROW   ( : )   ! Row pointer for cell
         INTEGER, INTENT( IN    ) :: CLEV   ( : )   ! Level pointer for cell
         INTEGER, INTENT( IN    ) :: NORDCELL( : )  ! Cell number of ordered cells in a block
         INTEGER, INTENT( INOUT ) :: NIRRCLS        ! No. of cells in block for IRR cells
         INTEGER, INTENT( INOUT ) :: IRRCELL( : )   ! Cell No. of an IRR cell

C..Includes: None

C..Scratch Local Variables:
         INTEGER BLK            ! Loop index for blocks
         INTEGER CELL           ! Counter of cells in a block
         INTEGER COL, ROW, LEV  ! Column, row, and level indices
         INTEGER ECL            ! Ending cell no. of block
         INTEGER ICL            ! Loop index for cells in a block
         INTEGER NCELL          ! Loop index for cells in a block
         INTEGER PC, PR, PL     ! Column, row, and level indices for PA outputs
         INTEGER NIRR           ! Loop index for IRR variables
         INTEGER SCL            ! Starting cell no. of block
C-----------------------------------------------------------------------
          NIRRCLS = 0
          DO NCELL = 1, NUMCELLS
             ICL = NORDCELL( OFFSET + NCELL )
             COL = CCOL( ICL )
             ROW = CROW( ICL )
             LEV = CLEV( ICL )
!?????????????LIRRCELL( NCELL ) = .FALSE.
             IF ( COL .GE. MY_IRR_BEGCOL .AND. COL .LE. MY_IRR_ENDCOL .AND.
     &            ROW .GE. MY_IRR_BEGROW .AND. ROW .LE. MY_IRR_ENDROW .AND.
     &            LEV .GE. MY_IRR_BEGLEV .AND. LEV .LE. MY_IRR_ENDLEV ) THEN
                LIRRFLAG = .TRUE.
!????????????????LIRRCELL( NCELL ) = .TRUE.
                NIRRCLS = NIRRCLS + 1
                IRRCELL( NIRRCLS ) = NCELL
             END IF
          END DO
         RETURN            
        END SUBROUTINE PA_IRR_CKBLK
        SUBROUTINE PA_IRR_CKCELLS ( LIRRFLAG )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Checks cells to see which needs IRR calculations
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
     
         IMPLICIT NONE
C..Arguments 
         LOGICAL, INTENT(   OUT ) :: LIRRFLAG( :,:,: ) ! Flag for doing IRR for one block

C..Includes: None

C..Scratch Local Variables:
         INTEGER C, R, L     ! Column, row, and level indices for PA outputs
C-----------------------------------------------------------------------
      
          DO L = 1, NLAYS
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  IF ( C .GE. MY_IRR_BEGCOL .AND. C .LE. MY_IRR_ENDCOL .AND.
     &                 R .GE. MY_IRR_BEGROW .AND. R .LE. MY_IRR_ENDROW .AND.
     &                 L .GE. MY_IRR_BEGLEV .AND. L .LE. MY_IRR_ENDLEV ) THEN
                       LIRRFLAG( C,R,L ) = .TRUE.
                  ELSE
                       LIRRFLAG( C,R,L ) = .FALSE.     
                  END IF
               END DO
            END DO
         END DO
         RETURN            
        END SUBROUTINE PA_IRR_CKCELLS
        SUBROUTINE PA_IRR_BLKSTRT ( NUMCELLS )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Initializes IRRBLK to zero
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
     
         IMPLICIT NONE
C..Arguments 
         INTEGER, INTENT( IN    ) :: NUMCELLS       ! Number of cells in one block

C..Includes: None

C..Scratch Local Variables:
         INTEGER CELL           ! Counter of cells in a block
         INTEGER NIRR           ! Loop index for IRR variables
C-----------------------------------------------------------------------
           DO NIRR = 1, NIRRVAR
              DO CELL = 1, NUMCELLS
                IRRBLK( CELL,NIRR ) = 0.0
             END DO
           END DO
          RETURN
        END SUBROUTINE PA_IRR_BLKSTRT
        SUBROUTINE PA_IRR_BLKENDF( OFFSET, NUMCELLS, CCOL, CROW, CLEV )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Updates the IRROUT array after a block is finished for the case
c  in which the cell composition of the block is fixed
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
     
         IMPLICIT NONE
C..Arguments 
         INTEGER, INTENT( IN    ) :: OFFSET         ! Offset to 1st cell in a block
         INTEGER, INTENT( IN    ) :: NUMCELLS       ! Number of cells in one block
         INTEGER, INTENT( IN    ) :: CCOL   ( : )   ! Column pointer for cell
         INTEGER, INTENT( IN    ) :: CROW   ( : )   ! Row pointer for cell
         INTEGER, INTENT( IN    ) :: CLEV   ( : )   ! Level pointer for cell

C..Includes: None

C..Scratch Local Variables:
         INTEGER BLK            ! Loop index for blocks
         INTEGER CELL           ! Counter of cells in a block
         INTEGER COL, ROW, LEV  ! Column, row, and level indices
         INTEGER ECL            ! Ending cell no. of block
         INTEGER ICL            ! Loop index for cells in a block
         INTEGER NCELL          ! Loop index for cells in a block
         INTEGER PC, PR, PL     ! Column, row, and level indices for PA outputs
         INTEGER NIRR           ! Loop index for IRR variables
         INTEGER SCL            ! Starting cell no. of block
C-----------------------------------------------------------------------
          SCL = OFFSET + 1
          ECL = OFFSET + NUMCELLS
          CELL = 0
          DO ICL = SCL, ECL
            COL = CCOL( ICL )
            ROW = CROW( ICL )
            LEV = CLEV( ICL )
            CELL = CELL + 1
            IF ( COL .GE. MY_IRR_BEGCOL .AND. COL .LE. MY_IRR_ENDCOL .AND.
     &           ROW .GE. MY_IRR_BEGROW .AND. ROW .LE. MY_IRR_ENDROW .AND.
     &           LEV .GE. MY_IRR_BEGLEV .AND. LEV .LE. MY_IRR_ENDLEV ) THEN

#ifdef parallel
               PC = COL
               PR = ROW
#else
C -- serial case, calculations are shifted to the origin but not in
C    parallel implementation
               PC = COL - MY_IRR_BEGCOL + 1
               PR = ROW - MY_IRR_BEGROW + 1
#endif
               PL = LEV - MY_IRR_BEGLEV + 1

               DO NIRR = 1, NIRRVAR
                  IRROUT( PC,PR,PL,NIRR ) = IRROUT( PC,PR,PL,NIRR )
     &                                    + IRRBLK( CELL,NIRR )      
               END DO
            END IF
          END DO

          RETURN
        END SUBROUTINE  PA_IRR_BLKENDF
        SUBROUTINE PA_IRR_CELLENDF( COL, ROW, LEV )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Updates the IRROUT for cell 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
         
         IMPLICIT NONE
C..Arguments 
         INTEGER, INTENT( IN ) :: COL      ! Column pointer for cell
         INTEGER, INTENT( IN ) :: ROW      ! Row pointer for cell
         INTEGER, INTENT( IN ) :: LEV      ! Level pointer for cell

C..Includes: None

C..Scratch Local Variables:
         INTEGER PC, PR, PL     ! Column, row, and level indices for PA outputs
         INTEGER NIRR           ! Loop index for IRR variables
C-----------------------------------------------------------------------
#ifdef parallel
               PC = COL
               PR = ROW
#else
C -- serial case, calculations are shifted to the origin but not in
C    parallel implementation
               PC = COL - MY_IRR_BEGCOL + 1
               PR = ROW - MY_IRR_BEGROW + 1
#endif
               PL = LEV - MY_IRR_BEGLEV + 1

               DO NIRR = 1, NIRRVAR
                  IRROUT( PC,PR,PL,NIRR ) = IRROUT( PC,PR,PL,NIRR )
     &                                    + IRRSUM( NIRR )      
               END DO

          RETURN
        END SUBROUTINE  PA_IRR_CELLENDF
        SUBROUTINE PA_IRR_BLKENDC ( OFFSET, CCOL, CROW, CLEV,
     &                              NORDCELL, NIRRCLS, IRRCELL )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Updates the IRROUT array after a block is finished for the case
c  in which the cell composition of the block can change
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
     
         IMPLICIT NONE
C..Arguments 
         INTEGER, INTENT( IN    ) :: OFFSET         ! Offset to 1st cell in a block
         INTEGER, INTENT( IN    ) :: CCOL   ( : )   ! Column pointer for cell
         INTEGER, INTENT( IN    ) :: CROW   ( : )   ! Row pointer for cell
         INTEGER, INTENT( IN    ) :: CLEV   ( : )   ! Level pointer for cell
         INTEGER, INTENT( IN    ) :: NORDCELL( : )  ! Cell number of ordered cells in a block
         INTEGER, INTENT( INOUT ) :: NIRRCLS        ! No. of cells in block for IRR cells
         INTEGER, INTENT( INOUT ) :: IRRCELL( : )   ! Cell No. of an IRR cell

C..Includes: None

C..Scratch Local Variables:
         INTEGER BLK            ! Loop index for blocks
         INTEGER CELL           ! Counter of cells in a block
         INTEGER COL, ROW, LEV  ! Column, row, and level indices
         INTEGER ECL            ! Ending cell no. of block
         INTEGER ICL            ! Loop index for cells in a block
         INTEGER NCELL          ! Loop index for cells in a block
         INTEGER PC, PR, PL     ! Column, row, and level indices for PA outputs
         INTEGER NIRR           ! Loop index for IRR variables
         INTEGER SCL            ! Starting cell no. of block
C-----------------------------------------------------------------------
         DO NCELL = 1, NIRRCLS
            CELL = IRRCELL( NCELL )
            ICL = NORDCELL( OFFSET + CELL )
            COL = CCOL( ICL )
            ROW = CROW( ICL )
            LEV = CLEV( ICL )

C -- in serial case, calculations are shifted to the origin but not in
C    parallel implementation

#ifdef parallel
            PC = COL
            PR = ROW
#else
            PC = COL - MY_IRR_BEGCOL + 1
            PR = ROW - MY_IRR_BEGROW + 1
#endif
            PL = LEV - MY_IRR_BEGLEV + 1

            DO NIRR = 1, NIRRVAR
               IRROUT( PC,PR,PL,NIRR ) = IRROUT( PC,PR,PL,NIRR )
     &                                 + IRRBLK( NCELL,NIRR )      
            END DO
         END DO

         RETURN

        END SUBROUTINE PA_IRR_BLKENDC

      END MODULE PA_IRR_CLT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE DESID_MODULE

C-----------------------------------------------------------------------
C Function: Detailed Emissions, Scaling, Isolation and Diagnostic Module
C           (DESID) for CMAQ. 

C Revision History:
C     28 Jul 2006 J.Young: initial implementation
C     18 Aug 2007 J.Young: move beis part to separate module; add plume rise
C     23 Sep 2009 B.Hutzell: modified algorithm that loads gas emissions from point
C                 sources into VDEMIS array to enable multi-use of an emission species
C     26 Jan 2010 J.Young: fix bug overwriting point source layer 1 NH3; inline rdemis
C     07 Jan 2011 B.Hutzell: updated for namelist definition of model species
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                            removed deprecated TRIMLEN
C      6 Apr 2011 J.Young, R.Pinder: add lightning NO emissions capability
C     11 May 2011 D.Wong: incorporated twoway model implementation
C      5 Jun 2012 J.Bash: Added support for NH3 bidirectional exchange. Fertilizer
C                         sector emissions are subtracted from the total NH3 emissions
C                         if the CTM_ABFLUX flag is set
C     07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C     24 Feb 16 B.Murphy: Generalize scaling of point source species based on
C                         mapping model species, not point source species
C     03 Mar 16 B.Gantt/G. Sarwar: incorporated halogen emissions
C     08 Aug 2016 B.Murphy: Neglect fire emissions for pcVOC
C     12 Jan 2017 B.Murphy: Remove warning when model species are not
C                           read in correctly. Invoke error and model stop when model 
C                           species are not found on any emission file
C     16 NOv 2018 S.Napelenok: ISAM implementation
C     01 Feb 2019 D.Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses, replaced IOS with LOGDEV when calling GET_ENV
C     15 May 2019 D.Wong: Put the check for using marine gas emission or not in RUNTIME_VAR.F
C     4 Oct 2019 D.Wong: fixed the time advancement, NEXTIME, for a multi-day run in subroutine
C                        GRIDEMIS
C     22 Nov 2019 F. Sidi: Re-introduced date override variable for representative
C                          Day Emissions
C     16 Dec 2019 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C     6 Jul 2021 D.Wong: fixed time marching through a day line during simulation w.r.t.
C                        representative Day Emissions in subroutine GR3D
C     12 July 2022 B.H. Baek & C. Coats: USE METEMIS and related changes
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE GRID_CONF           ! horizontal & vertical domain specifications      
      USE DESID_VARS
      USE DESID_UTIL
      USE VDIFF_MAP, ONLY : N_SPC_DIFF
      USE UTILIO_DEFN

      IMPLICIT NONE

      PUBLIC DESID_INIT, DESID_DRIVER
      
      PRIVATE
      
      CONTAINS

C-----------------------------------------------------------------------
         FUNCTION DESID_INIT ( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )

         USE CGRID_SPCS          ! CGRID mechanism species
         USE MEGAN_DEFN          ! biogenic emissions from MEGAN
         USE MGEMIS              ! marine gas emissions
         USE LTNG_DEFN           ! NO emissions from lightning strikes
         USE PT3D_DEFN           ! plume rise emissions
         USE METEMIS             ! met-modulated (mobile) emissions
         USE UTILIO_DEFN         ! I/O API
         USE AERO_EMIS           ! inherits GRID_CONF
         !USE AERO_DATA           ! access subroutine map_pmemis
         USE CENTRALIZED_IO_MODULE, only : interpolate_var
         USE ASX_DATA_MOD, only: MET_DATA
         USE CONST, only: DG2M, PI180
         USE BEIS_DEFN

#ifdef isam
         USE SA_DEFN, ONLY : SA_VDEMIS_DIFF, NTAG_SA, SA_VDEMIS_CONV, NSPC_SA,
     &                       SA_VDEMIS_CONV_OTHER
#endif

#ifdef sens
        USE DDM3D_DEFN, ONLY: NP, NPMAX, SVDEMIS_DIFF
#endif

#ifdef mpas
        USE COUPLER_MODULE, ONLY : cell_thickness, cell_vol, MPAS_CELL_AREA => CELL_AREA
#endif
         IMPLICIT NONE

C Arguments:
         INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP( 3 )   ! TSTEP is output time step (HHMMSS)
         LOGICAL :: SUCCESS

C Local Variables:

         CHARACTER( 16 ) :: PNAME = 'DESID_INIT'
         CHARACTER( 80 ) :: VARDESC   ! env variable description
         CHARACTER( 120 ) :: XMSG = ' '
         INTEGER V, L, STATUS, ISRM

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

         ! Initialize Emission Variable Molecular Weights
         CALL INIT_DESID_EMVAR_MW()

         ! Define Projected Grid Cell Areas
         ALLOCATE( CELLAREA( NCOLS,NROWS ),STAT=STATUS )
         CALL CHECKMEM( STATUS, 'CELLAREA', PNAME )
         ALLOCATE( CELLHGT( NCOLS, NROWS, NLAYS ),STAT=STATUS )
         CALL CHECKMEM( STATUS, 'CELLHGT', PNAME )
         ALLOCATE( CELLVOL( NCOLS,NROWS,NLAYS ),STAT=STATUS )
         CALL CHECKMEM( STATUS, 'CELLVOL', PNAME )
#ifdef mpas
         CELLAREA(:,:) = MPAS_CELL_AREA(:,:)
         CELLHGT( :,1,: ) = cell_thickness(:,1,:)
         CELLVOL( :,1,: ) = cell_vol(:,1,:)
#else
         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD ! in m.
            DX2 = DG2M * YCELL_GD
     &          * COS( PI180*( YORIG_GD + 
     &            YCELL_GD*FLOAT( GL_NROWS/2 )))! in m.
         ELSE
            DX1 = XCELL_GD        ! in m.
            DX2 = YCELL_GD        ! in m.
         END IF
         CELLAREA(:,:) = REAL( DX1 * DX2, 4 )
         ! Get height of grid cell in each layer in sigma coordinates
         ! Multiply by grid area [m2] to obtain grid volume

         !cellhgt = Met_Data%DZF ! for spatially varying height

         DO L = 1, NLAYS
            CELLHGT( :,:,L ) = X3FACE_GD( L ) - X3FACE_GD( L-1 )
            CELLVOL( :,:,L ) = CELLHGT( :,:,L ) * CELLAREA(:,:)
         END DO
#endif
 
         ! REMINDER: CELLAREA is projected grid cell area (e.g. 12 x 12
         ! km^2). To get real area on the Earth for a conformal grid, you
         ! should divide CELLAREA by the MAP SCALE FACTOR squared, typically
         ! stored in CMAQ as MSFX2

C Retrieve Number of Emission Streams of Various Types (sectors)
         CALL DESID_INIT_STREAMS( JDATE, JTIME )
         IF ( DESID_N_SRM .EQ. 0 ) THEN 
            XMSG = 'No Emissions Streams Have Been Selected.'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .TRUE.; RETURN
         END IF

C Open Area Emissions files
         CALL DESID_OPEN_GR3D ( JDATE, JTIME )

C Get number of emissions layers
         IF ( DESID_MAXLAYS .LE. 0 ) THEN
            ! Find The Largest Gridded Emission Layer And Let That be
            ! the initial top.
            DESID_LAYS = MAXVAL( DESID_GRID_LAYS(:) ) 
            
            ! If there are 3D (inline point or Lightning) sources, 
            ! revise the top to be the model top.
            IF ( NPTGRPS .GT. 0 .OR. LTNG_NO ) DESID_LAYS = NLAYS

            ! Make sure the top is not greater than the model top
            DESID_LAYS = MAX( MIN( DESID_LAYS, NLAYS ), 1 )
         ELSE
           ! Make sure the top is not greater than the model top
           DESID_LAYS = MIN( DESID_MAXLAYS, NLAYS )

         END IF

         WRITE( LOGDEV,1009 ) DESID_LAYS, NLAYS
1009     FORMAT(    5X, 'Number of Emissions Layers:         ', I3
     &           /  5X, 'out of total Number of Model Layers:', I3 )


C Initialize 3D Point Source Emissions 
         CALL LOG_SUBHEADING( LOGDEV, 'Initialize Point Emissions' )
         IF ( .NOT. PT3D_INIT( JDATE, JTIME, TSTEP(1) ) ) THEN
            XMSG = 'Failure initializing plume rise emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( BIOGEMIS_MEGAN ) THEN
C Initialize Online Biogenic Emissions, MEGAN
          CALL LOG_SUBHEADING( LOGDEV, 'Initialize MEGAN Biogenic Emissions' )
          IF ( .NOT. MEGAN_INIT( JDATE, JTIME, TSTEP(1) ) ) THEN
             XMSG = 'Failure initializing biogenics emissions module'
             CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          END IF
         END IF

         IF ( BIOGEMIS_BEIS ) THEN 
C Initialize Online Biogenic Emissions, BEIS
          CALL LOG_SUBHEADING( LOGDEV, 'Initialize BEIS Biogenic Emissions' )
          IF ( .NOT. BEIS_INIT( JDATE, JTIME, TSTEP ) ) THEN
            XMSG = 'Failure initializing biogenics emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          END IF
         END IF

C Initialize Online Marine Gas Emissions
         CALL LOG_SUBHEADING( LOGDEV, 'Initialize Marine Gas Emissions' )
         IF ( .NOT. MGEMIS_INIT( JDATE, JTIME, TSTEP(1) ) ) THEN
            XMSG = 'Failure initializing marine gas emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Initialize Online Lightning NOx Emissions
         CALL LOG_SUBHEADING( LOGDEV, 'Initialize Lightning NO Emissions' )
         IF ( .NOT. LTNG_INIT( JDATE, JTIME, TSTEP(1) ) ) THEN
            XMSG = 'Failure initializing lightning emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Initialize Online Meteorology-Dependent Emissions
         IF ( USE_MET_EMIS ) THEN 
           CALL LOG_SUBHEADING( LOGDEV, 'Initialize Met-Modulated Emissions' )
           IF ( .NOT. METEMIS_INIT( JDATE, JTIME, TSTEP(1) ) ) THEN
              XMSG = 'Failure initializing met-modulated emissions module'
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
           END IF
         END IF

C Initialize Aerosol Emissions         
         CALL LOG_SUBHEADING( LOGDEV,'Process Aerosol Emissions' )
         IF ( .NOT. AERO_EMIS_INIT( JDATE, JTIME, TSTEP(1) ) ) THEN
            XMSG = 'Failure initializing aerosol emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Map the Emission Variables Available on the Input Files To the
C CMAQ Species Identified by the User via the Namelists and Stop the model
C or Print Warnings if Mistakes Are Made.

         CALL DESID_PROCESS_RULES( JDATE, JTIME )
         CALL DESID_INIT_DIAG
#ifndef mpas
         IF ( IO_PE_INCLUSIVE ) CALL DESID_OPEN_DIAG( JDATE, JTIME, TSTEP(1) )
#else
         CALL DESID_OPEN_DIAG( JDATE, JTIME, TSTEP(1) )
#endif

C Allocate Space for Master Emissions Computation
         ALLOCATE ( VDEMIS_DIFF( N_SPC_DIFF,DESID_LAYS,NCOLS,NROWS ),STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
            XMSG = 'VDEMIS_DIFF memory allocation failed'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

#ifdef isam
         ALLOCATE ( SA_VDEMIS_DIFF( NSPC_SA,   DESID_LAYS,NCOLS,NROWS, NTAG_SA ),
     &              SA_VDEMIS_CONV( N_SPC_DIFF,DESID_LAYS,NCOLS,NROWS, NTAG_SA ), 
     &              SA_VDEMIS_CONV_OTHER( N_SPC_DIFF,DESID_LAYS,NCOLS,NROWS ), 
     &                                                  STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
            XMSG = 'SA_VDEMIS_DIFF memory allocation failed'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
#endif

#ifdef sens
         ALLOCATE ( SVDEMIS_DIFF( N_SPC_DIFF,DESID_LAYS,NCOLS,NROWS,NPMAX ),STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
            XMSG = 'SVDEMIS_DIFF memory allocation failed'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
#endif

C Return From Initialization
         SUCCESS = .TRUE.; RETURN

         END FUNCTION DESID_INIT

!-----------------------------------------------------------------------
         SUBROUTINE DESID_DRIVER ( JDATE, JTIME, TSTEP, CGRID )
!-----------------------------------------------------------------------
!        DESID_DRIVER controls whether DESID_GET_EMIS will be 
!        executed to process emissions for input back to vdiff or if 
!        it is being run in diagnostic mode to populate DESID diagnostic
!        output files. 
!        
!        In typical operation, emissions used by CMAQ are calculated at 
!        1/2 time step before the output time step, meaning that any
!        diagnostics output using these values would be quantitatively 
!        inconsistent with the emissions inputs, which are usually
!        tabulated at the output time step (e.g., hourly). By allowing
!        DESID_GET_EMIS to be called in diagnostic mode, with
!        L_DESID_DIAG = .TRUE., DESID can recalculate emissions at
!        exactly the the output time step and populate diagnostic output
!        files with these values. These values are not actually used for
!        emissions calculations within CMAQ. 
!-----------------------------------------------------------------------

         USE UTILIO_DEFN
         USE centralized_io_module
#ifdef mpas
         use util_module, only : time2sec, nextime
#endif
         IMPLICIT NONE

         INTEGER, INTENT( IN ) :: JDATE, JTIME  ! date (YYYYDDD), time (HHMMSS)
         INTEGER, INTENT( IN ) :: TSTEP( 3 )    ! time step vector (HHMMSS)
         REAL, POINTER :: CGRID( :,:,:,: )

         LOGICAL         :: L_DESID_DIAG
         LOGICAL         :: FIRST_TIME = .TRUE.
         INTEGER, SAVE   :: WSTEP, MDATE, MTIME
         LOGICAL         :: WRTIME
         CHARACTER( 200 ):: XMSG
         INTEGER :: l

         CALL LOG_MESSAGE( LOGDEV, '' )
         CALL LOG_MESSAGE( LOGDEV, 'Beginning Emissions' )
         
         IF ( FIRST_TIME ) THEN
            FIRST_TIME = .FALSE.

            ! Initialize Diagnostic Write Counter
            WSTEP = 0 
            MDATE = STDATE
            MTIME = STTIME
           
            ! Execute DESID Emission Processor in Diagnostic Mode
            ! for the Initial Hour of the Simulation (usually 0Z)
            VDEMIS_DIAG = 0.0
            WRITE( XMSG, '(A,I10,A,I10)' ),
     &           '  Calling Diagnostic Emissions at Date: ',MDATE,
     &           '  and time: ',MTIME
            CALL LOG_MESSAGE( LOGDEV, XMSG )
            CALL DESID_GET_EMIS( MDATE, MTIME, TSTEP, CGRID, .TRUE. )
         END IF
         
         ! Increment Diagnostic Counter
         WRTIME = .FALSE.
         WSTEP  = WSTEP + TIME2SEC( TSTEP( 2 ) )
         
         ! Determine whether or not this is a write step
         WRTIME = ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) )
         IF ( WRTIME ) THEN 
           WSTEP = 0
           CALL NEXTIME( MDATE, MTIME,  TSTEP( 1 ) )

           ! Execute DESID Emission Processor in Diagnostic Mode
           VDEMIS_DIAG = 0.0
           WRITE( XMSG, '(A,I10,A,I10)' ),
     &          '  Calling Diagnostic Emissions at Date: ',MDATE,
     &          '  and time: ',MTIME
           CALL LOG_MESSAGE( LOGDEV, XMSG )
           CALL DESID_GET_EMIS( MDATE, MTIME, TSTEP, CGRID, .TRUE. )

         END IF
 
         ! Execute DESID Emission Processor in Real Mode
           WRITE( XMSG, '(A,I10,A,I10)' ),
     &          '  Calling Real Emissions at Date: ',JDATE,
     &          '  and time: ',JTIME
           CALL LOG_MESSAGE( LOGDEV, '' )
           CALL LOG_MESSAGE( LOGDEV, XMSG )

         CALL DESID_GET_EMIS( JDATE, JTIME, TSTEP, CGRID, .FALSE. )

         CALL LOG_MESSAGE( LOGDEV, '' )

         END SUBROUTINE DESID_DRIVER

!-----------------------------------------------------------------------
         SUBROUTINE DESID_GET_EMIS ( JDATE, JTIME, TSTEP, CGRID, L_DESID_DIAG )

         ! Step through all emission sub-modules for each stream
         ! (gridded and point offline, biog, SeaSalt, Dust, Lightning
         ! NO, etc.) and apply scaling factors, unit conversions, etc.

         ! If L_DESID_DIAG = .FALSE. then this is a standard call of
         ! DESID_GET_EMIS and emissions will be returned to VDIFF to
         ! supply the CMAQ system with emissions. If L_DESID_DIAG =
         ! .TRUE., then emissions are calculated and written out to
         ! diagnostic files but not used by VDIFF or any other part of
         ! CMAQ.

         USE CGRID_SPCS          ! CGRID mechanism species
         USE AERO_EMIS           ! inherits GRID_CONF
         USE MEGAN_DEFN          ! biogenic emissions from MEGAN
         USE BEIS_DEFN, ONLY: MSPCS, VDEMIS_BI
         USE SSEMIS
         USE DUST_EMIS
         USE MGEMIS              ! marine gas emissions
         USE PT3D_DEFN           ! plume rise emissions
         USE LTNG_DEFN           ! lightning NO emissions
         USE METEMIS             ! met-modulated emissions
         USE UTILIO_DEFN
         USE HGRD_DEFN
         USE ASX_DATA_MOD, ONLY: MET_DATA, GRID_DATA
         USE AERO_DATA, ONLY : AERONUM_MAP, AEROSRF_MAP, DUSTOUTM

#ifdef isam
         USE SA_DEFN, ONLY : SA_VDEMIS_DIFF, ITAG, NTAG_SA, TAGSTREAMS,
     &                       STREAM_TO_TAG, OTHRTAG, TAGSTREAMS_TEMP,
     &                       TAGSTREAMS_NUM, SA_VDEMIS_CONV,
     &                       SA_VDEMIS_CONV_OTHER,
     &                       MAP_DIFFtoSA, ISAM_SPEC, NSPC_SA,
     &                       ISAMRGN_TEMP, ISAMRGN, ISAMRGN_NUM,
     &                       ISAMRGN_MAP, TAGS_PER_STREAM,
     &                       ISAM_PVO3_MAP, L_OZONE
         USE VDIFF_MAP, ONLY : DIFF_MAP, DIFF_SPC
#endif

#ifdef sens
         USE DDM3D_DEFN, ONLY: NP, NPMAX, SVDEMIS_DIFF, IPT, SENNUM,
     &                         S_STREAMLBL, S_NSTREAMS, IPARM, IREGION,
     &                         STREAM_TO_SENS, SENS_PER_STREAM
         USE VDIFF_MAP, ONLY : DIFF_MAP
#endif
#ifdef mpas
         use util_module, only : index1
#endif
         USE centralized_io_module

         IMPLICIT NONE

C Includes:
         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:
         INTEGER, INTENT( IN ) :: JDATE, JTIME  ! date (YYYYDDD), time (HHMMSS)
         INTEGER, INTENT( IN ) :: TSTEP( 3 )    ! time step vector (HHMMSS)
         REAL, POINTER :: CGRID( :,:,:,: )
         LOGICAL, INTENT( IN ) :: L_DESID_DIAG

C Local Variables:
         REAL             DELT          ! interpolation factor
         INTEGER          C, R, L, N, S, V, ISTR, ISRM, NL, I, J ! loop induction variables
         INTEGER          S_STRT, S_END ! substitute loop induction variables
         REAL, ALLOCATABLE, SAVE :: VDEMIS_READ  ( :,:,:,: ) ! Emissions as they are provided by each stream
         REAL, ALLOCATABLE, SAVE :: VDEMIS_SCALED( :,:,:,: ) ! Emissions after user scaling, and spatial scaling
         REAL, ALLOCATABLE, SAVE :: VDEMIS_CONV  ( :,:,:,: ) ! Emissions after converting to units for VDIFF
         

         CHARACTER( 16 ) :: VNAME
         CHARACTER( 16 ) :: PNAME = 'GET_EMIS'
         CHARACTER( 300 ):: XMSG = ' '
         INTEGER         :: ERROR_NEG
         INTEGER, SAVE   :: WSTEP
         LOGICAL, SAVE   :: FIRST_TIME = .TRUE.
         LOGICAL         :: EFLAG

#ifdef isam
         INTEGER                    :: IDX, SPC, LAYER, RGN, IRGN
         CHARACTER(96)              :: TXTSTRING
         REAL                       :: MINCHECK, TOTAL
#endif
C-----------------------------------------------------------------------

         EFLAG = .FALSE.

         IF ( FIRST_TIME ) THEN
            FIRST_TIME = .FALSE.

            ALLOCATE( VDEMIS_READ  ( DESID_N_ISTR,DESID_LAYS,NCOLS,NROWS ),
     &                VDEMIS_SCALED( DESID_N_ISTR,DESID_LAYS,NCOLS,NROWS ),
     &                VDEMIS_CONV  ( N_SPC_DIFF, DESID_LAYS,NCOLS,NROWS ) )

#ifdef isam
C Map Emissions streams to ISAM tags
            ALLOCATE( STREAM_TO_TAG( DESID_N_SRM, NTAG_SA ),
     &                TAGS_PER_STREAM( DESID_N_SRM ),
     &                MAP_DIFFtoSA ( NSPC_SA  ),
     &                TAGSTREAMS( NTAG_SA, DESID_N_SRM ) )
            STREAM_TO_TAG   = 0
            TAGS_PER_STREAM = 0
            MAP_DIFFtoSA    = 0
            TAGSTREAMS      = 'empty'

            IF ( LPVO3 ) THEN
               ALLOCATE ( ISAM_PVO3_MAP( NTAG_SA ) )
               ISAM_PVO3_MAP = 0
            END IF

            DO ITAG = 1, NTAG_SA-3

C Count the number of streams going to each ISAM tag
              TXTSTRING = TRIM(TAGSTREAMS_TEMP( ITAG ))
              TAGSTREAMS_NUM( ITAG ) = 1 + COUNT(TRANSFER(TXTSTRING, 'A', LEN(TXTSTRING)) == "," )

C Parse out the stream names the user wants tagged
              READ(TXTSTRING, *) TAGSTREAMS(ITAG,1:TAGSTREAMS_NUM( ITAG ))

C Find emissions stream in the list of available streams
              DO ISRM = 1, TAGSTREAMS_NUM( ITAG )
                 IF ( TAGSTREAMS(ITAG,ISRM) .EQ. 'PVO3' ) THEN
                    IF ( LPVO3 ) THEN 
                       IF ( L_OZONE ) THEN
                         ISAM_PVO3_MAP(ITAG) = 1
                         CYCLE
                       ELSE
                         XMSG = " Must specifiy OZONE ISAM TAG CLASS" //
     &                          " in isam_control to track PVO3 "
                         CALL M3EXIT( 'ISAM_PVO3', 1, 1, XMSG, XSTAT1 )
                       ENDIF
                    ELSE
                       XMSG = " To track PVO3, run-script must set CTM_LPVO3" //
     &                        " to Y or T for Yes or True. Check run-script."
                       CALL M3EXIT( 'ISAM_PVO3', 1, 1, XMSG, XSTAT1 )
                    END IF 
                 ENDIF

                 IF ( TAGSTREAMS(ITAG,ISRM) .EQ. 'BIDIRECTIONALNH3' )THEN
                   IF ( ABFLUX ) THEN
                     CYCLE ! don't need a stream for this
                   ELSE
                     XMSG = " BIDIRECTIONALNH3 specified," //
     &                      " but ABLUX set to FALSE "
                     CALL M3EXIT( 'ISAM_PVO3', 1, 1, XMSG, XSTAT1 )
                   ENDIF           
                 END IF

                 IDX = INDEX1(TAGSTREAMS(ITAG,ISRM),DESID_N_SRM,DESID_STREAM_LAB )
                 IF ( IDX .EQ. 0 ) THEN
                   XMSG = " User specified ISAM tag - " //
     &                    TRIM( TAGSTREAMS(ITAG,ISRM) )// 
     &                    " - not found in available emissions streams "
                   CALL M3MESG(XMSG)
                   EFLAG = .TRUE.
                 ELSE
                   TAGS_PER_STREAM( IDX ) = TAGS_PER_STREAM( IDX ) + 1
                   STREAM_TO_TAG(IDX,TAGS_PER_STREAM( IDX )) = ITAG
                 END IF
              END DO

            END DO
            IF( EFLAG )THEN
                WRITE(LOGDEV,'(A)')'Available Emissions Streams'
                DO ITAG = 1,DESID_N_SRM
                   WRITE(LOGDEV,'(4X,A)')DESID_STREAM_LAB(ITAG)
                END DO
                XMSG = 'INCORRECT Emissions Stream used in ISAM control file'
                CALL M3EXIT( 'ISAM_STREAMS', 1, 1, XMSG, XSTAT1 )
            END IF

C Develop a map of emitted/diffused ISAM species
            MAP_DIFFtoSA = 0
            DO SPC = 1, NSPC_SA
              MAP_DIFFtoSA( SPC ) = INDEX1(TRIM(ISAM_SPEC(SPC,1)), N_SPC_DIFF, DIFF_SPC )
            END DO

C Initialize geographic regions for ISAM tagging
            ALLOCATE( ISAMRGN( NTAG_SA, DESID_N_REG ) )
            ISAMRGN = 'EVERYWHERE'
            ALLOCATE( ISAMRGN_MAP( NTAG_SA, DESID_N_REG ) )
            ISAMRGN_MAP = 0
            ISAMRGN_NUM = 0

            DO ITAG = 1, NTAG_SA-3

C Check if the 'EVERYWHERE' keyword is present
              IDX = INDEX(ISAMRGN_TEMP(ITAG),'EVERYWHERE')
              IF ( IDX .NE. 0 ) THEN
                ISAMRGN_NUM( ITAG ) = 0
                CYCLE
              ENDIF

C Count the number of regions for each tag
              TXTSTRING = TRIM(ISAMRGN_TEMP( ITAG ))
              ISAMRGN_NUM( ITAG ) = 1 + COUNT(TRANSFER(TXTSTRING,'A', LEN(TXTSTRING)) == "," )

C Parse out the region names the user wants tagged
              READ(TXTSTRING, *) ISAMRGN(ITAG,1:ISAMRGN_NUM( ITAG ))

C Map the user specified ISAM regions to available CMAQ regions
              DO ISRM = 1, ISAMRGN_NUM(ITAG)
                IDX = INDEX1(ISAMRGN(ITAG,ISRM),DESID_N_REG, DESID_REG%LABEL )
                IF ( IDX .EQ. 0 ) THEN
                  XMSG = " User specified ISAM region - " //
     &                    TRIM( ISAMRGN(ITAG,ISRM) ) //
     &                    " - not found in available emissions regions "
                   CALL M3EXIT( 'ISAM_STREAMS', 1, 1, XMSG, XSTAT1 )
                ELSE
                   ISAMRGN_MAP(ITAG,ISRM) = IDX
                END IF
              END DO

            END DO

#endif

#ifdef sens
            ALLOCATE( STREAM_TO_SENS( DESID_N_SRM, NPMAX ),
     &                SENS_PER_STREAM( DESID_N_SRM ))
            STREAM_TO_SENS = 0
            SENS_PER_STREAM = 0

            DO NP = 1, NPMAX
              IF ( IPT ( NP ) .EQ. 3 ) THEN ! This is an emissions sensitivity
                IF ( S_NSTREAMS(NP) .EQ. 99 ) THEN ! all emissions streams
                  S_NSTREAMS(NP) = DESID_N_SRM
                  S_STREAMLBL(NP,1:DESID_N_SRM)=DESID_STREAM_LAB(1:DESID_N_SRM)
                END IF
                DO ISRM = 1, S_NSTREAMS(NP)
                  SENNUM = INDEX1(S_STREAMLBL(NP,ISRM),DESID_N_SRM,DESID_STREAM_LAB)
                  IF ( SENNUM .EQ. 0 ) THEN
                    XMSG = " User specified DDM Emissions Stream - " //
     &                    TRIM( S_STREAMLBL(NP,ISRM) )//
     &                    " - not found in available emissions streams "
                    CALL M3EXIT( 'ISAM_STREAMS', 1, 1, XMSG, XSTAT1 )
                  ELSE
                    SENS_PER_STREAM( SENNUM ) = SENS_PER_STREAM( SENNUM ) + 1
                    STREAM_TO_SENS(SENNUM,SENS_PER_STREAM( SENNUM )) = NP
                  END IF
                END DO
              END IF
            END DO
#endif
         END IF  ! First Time

C If this is a diagnostic call, and no diagnostics were requested, then
C return
         IF ( L_DESID_DIAG .AND. 
     &        .NOT. ANY(DESID_DIAG_STREAM_MASK(:,:)) ) RETURN

C Initialize Emissions Array
         VDEMIS_DIFF = 0.0
         VDEMIS_CONV = 0.0

#ifdef isam
         SA_VDEMIS_DIFF = 0.0
         SA_VDEMIS_CONV = 0.0
#endif

#ifdef sens
        SVDEMIS_DIFF = 0.0
#endif

C Retrieve Emissions from All Stream Types
         IF ( DESID_N_SRM .GT. 0 ) THEN

         DO ISRM = 1,DESID_N_SRM
           IF ( (L_DESID_DIAG .AND. ANY(DESID_DIAG_STREAM_MASK( ISRM,: ))) 
     &          .OR. .NOT. L_DESID_DIAG ) THEN

             DO R = 1,NROWS
             DO C = 1,NCOLS
             DO J = 1,DESID_LAYS
             DO I = 1,DESID_N_ISTR
               VDEMIS_READ(I,J,C,R) = 0.0
             END DO
             END DO
             END DO
             END DO
             
             SELECT CASE ( DESID_STREAM_ITYPE( ISRM ) )
               
               ! Retrieve Gridded and Tracer Emissions
               CASE ( 1, 3 )
                 NL = DESID_GRID_LAYS( ISRM )
                 CALL GR3D( JDATE, JTIME, TSTEP, DESID_STREAM_NAME( ISRM ), 
     &                          NL, ISRM, VDEMIS_READ, L_DESID_DIAG ) ! mol/s and g/s
                 
                 ! Apply Rules from DESID_${mech} namelist
                 CALL DESID_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
                 
                 ! Calculate Number and Surface Area Emissions for this
                 ! stream. Convert aerosol mass emissions from g/s to
                 ! ug/m3/s.
                 CALL DESID_SIZE_DIST( ISRM, VDEMIS_SCALED, NL )
             
               ! Retrieve Point Source Emissions Streams
               CASE ( 2 )
                 NL = 1
                 CALL GET_PT3D_EMIS ( JDATE, JTIME, TSTEP, LOCAL_EMVAR( :,ISRM ), 
     &                                ISRM, VDEMIS_READ, NL, L_DESID_DIAG )! mol/s and g/s
             
                 ! Apply Rules from DESID_${mech} namelist
                 CALL DESID_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
             
                 ! Calculate Number and Surface Area Emissions for this
                 ! stream. Convert aerosol mass emissions from g/s to
                 ! ug/m3/s.
                 CALL DESID_SIZE_DIST( ISRM, VDEMIS_SCALED, NL )
             
               CASE ( 4 )
                 NL = 1
                 CALL GET_BEIS ( JDATE, JTIME, TSTEP, L_DESID_DIAG ) ! mol/s
                 FORALL( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoEMVAR( ISTR,ISRM ) .GT. 0 )
                    VDEMIS_READ( ISTR,1,:,: ) = VDEMIS_BI( MAP_ISTRtoEMVAR( ISTR,ISRM ),:,: ) 
                 END FORALL
                 
                 ! Apply Rules from DESID_${mech} namelist
                 CALL DESID_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
             
               ! Retrieve Marine Gas Emissions
               CASE ( 5 )
                 NL = 1
                 CALL GET_MGEMIS ( JDATE, JTIME, TSTEP, CGRID, L_DESID_DIAG )! mol/s
             
                 FORALL( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoEMVAR( ISTR,ISRM ) .GT. 0 )
                    VDEMIS_READ( ISTR,1,:,: ) = VDEMIS_MG( MAP_ISTRtoEMVAR( ISTR,ISRM ),:,: ) 
                 END FORALL
             
                 ! Apply Rules from DESID_${mech} namelist
                 CALL DESID_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
             
               ! Retrieve Lightning NO Emissions
               CASE ( 6 )
                 NL = DESID_LAYS
                 CALL GET_LTNG ( JDATE, JTIME, TSTEP, L_DESID_DIAG )  ! mol/s
                 DO L = 1,NL
                    FORALL( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoEMVAR( ISTR,ISRM ) .GT. 0 )
                       VDEMIS_READ( ISTR,L,:,: ) = VDEMIS_LT( :,:,L ) 
                    END FORALL
                 END DO
                 
                 ! Apply Rules from DESID_${mech} namelist
                 CALL DESID_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
             
               ! Retrieve Sea Spray Aerosol Emissions 
               CASE ( 7 )
                 NL = 1
                 CALL GET_SSEMIS ( JDATE, JTIME, TSTEP, CELLVOL( :,:,1 ), 
     &                             CELLHGT( :,:,1 ), L_DESID_DIAG )  ! g/m3/s
             
                 FORALL( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoEMVAR( ISTR,ISRM ) .GT. 0 )
                    VDEMIS_READ( ISTR,1,:,: ) = SSOUTM( MAP_ISTRtoEMVAR( ISTR,ISRM ),:,: ) 
                 END FORALL
             
                 ! Apply Rules from DESID_${mech} namelist
                 CALL DESID_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
             
                 ! Calculate Number and Surface Area Emissions for this
                 ! stream. Convert aerosol mass emissions from g/m3/s to
                 ! ug/m3/s.
                 CALL DESID_SIZE_DIST( ISRM, VDEMIS_SCALED, NL )
             
               ! Retrieve Wind-Blown Dust Emissions
               CASE ( 8 )
                 NL = 1
                 CALL GET_DUST_EMIS ( JDATE, JTIME, TSTEP, Met_data%RJACM( :,:,1 ), 
     &                                CELLVOL( :,:,1 ), CELLHGT( :,:,1 ), L_DESID_DIAG ) ! g/m3/s
                 FORALL( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoEMVAR( ISTR,ISRM ) .GT. 0 )
                    VDEMIS_READ( ISTR,1,:,: ) = DUSTOUTM( MAP_ISTRtoEMVAR( ISTR,ISRM ),:,: ) 
                 END FORALL
                 
                 ! Apply Rules from DESID_${mech} namelist
                 CALL DESID_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
                 
                 ! Calculate Number and Surface Area Emissions for this
                 ! stream. Convert aerosol mass emissions from g/m3/s to
                 ! ug/m3/s.
                 CALL DESID_SIZE_DIST( ISRM, VDEMIS_SCALED, NL )
             
               ! Retrieve MEGAN Emissions
               CASE ( 9 )
                 NL = 1
                 CALL GET_MEGAN ( JDATE, JTIME, TSTEP, L_DESID_DIAG) ! mol/s
                 FORALL( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoEMVAR( ISTR,ISRM ) .GT. 0 )
                    VDEMIS_READ( ISTR,1,:,: ) = VDEMIS_ME( MAP_ISTRtoEMVAR( ISTR,ISRM ),:,: ) 
                 END FORALL
                 
                 ! Apply Rules from DESID_${mech} namelist
                 CALL DESID_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
            
               ! Retrieve Met-Modulated Emissions
               CASE ( 10 )
                 NL = 1
                 CALL GET_METEMIS ( JDATE, JTIME, TSTEP, L_DESID_DIAG)
                 FORALL( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoEMVAR( ISTR,ISRM ) .GT. 0 )
                    VDEMIS_READ( ISTR,1,:,: ) = VDEMIS_MV( MAP_ISTRtoEMVAR( ISTR,ISRM ),:,: ) 
                 END FORALL
                 CALL DESID_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
                 CALL DESID_SIZE_DIST( ISRM, VDEMIS_SCALED, NL )
  
             END SELECT
             
             ! Convert All Emissions to VDIFF Units (ppmv/s for gas and
             ! aerosol masses, m2/mol/s for aerosol surface area, and
             ! N/mol/s for aerosol number)
             CALL DESID_CONV_UNITS( VDEMIS_SCALED, NL, VDEMIS_CONV )
             
             ! Write out diagnostic file (if requested in DESID control
             ! namelist file). This subroutine will only be executed if
             ! DESID is called in diagnostic mode, meaning all input,
             ! scaling, and unit conversions are performed for input to
             ! VDIFF, but values are converted back to mol/s (gas), g/s
             ! (aerosol mass), m2/s (aerosol surface area), and N/s 
             ! (aerosol number) before output.
             IF ( L_DESID_DIAG ) CALL DESID_CALC_DIAG( JDATE, JTIME, VDEMIS_CONV, ISRM, NL )
             
             ! Tools like DDM3D has a need to calculate emissions from 
             ! specific streams and then not apply them to VDIFF. They
             ! should only be added if DESID_STREAM_LAPPLY is true for
             ! this stream.
             IF ( DESID_STREAM_LAPPLY( ISRM ) ) 
     &            VDEMIS_DIFF( :,1:NL,:,: ) = VDEMIS_DIFF( :,1:NL,:,: ) + VDEMIS_CONV( :,1:NL,:,: )
             
#ifdef isam
             IF ( DESID_STREAM_LAPPLY( ISRM ) ) THEN
               ! Populate SA_VDEMIS_CONV, array for carrying tagged
               ! emissions contributions
             
               ! Initialize 
               DO ITAG = 1,NTAG_SA
                 DO R = 1,NROWS
                   DO C = 1,NCOLS
                     DO LAYER = 1,NL
                       DO SPC = 1,N_SPC_DIFF
                         SA_VDEMIS_CONV( SPC,LAYER,C,R,ITAG ) = 0.0
                       END DO
                     END DO
                   END DO
                 END DO
               END DO
             
               ! Determine whether this emission stream corresponds to 
               ! any ISAM tags
               IF ( TAGS_PER_STREAM( ISRM ) .EQ. 0 ) THEN 
                 ! Dump all into 'OTHRTAG'
                 SA_VDEMIS_CONV( :,1:NL,:,:,OTHRTAG ) = 
     &                               VDEMIS_CONV( :,1:NL,:,: )
               ELSE
                 ! Initialize Array for Tracking Residual of Tagged
                 ! Emissions  
                 SA_VDEMIS_CONV_OTHER( :,1:NL,:,: ) = VDEMIS_CONV( :,1:NL,:,: )
             
                 ! Loop through all of the ISAM tags associated with this
                 ! emissions stream. Generally each stream is only
                 ! associated with one tag. The exception is when
                 ! there are multiple tags corresponding to separate regions.
                 DO IDX = 1, TAGS_PER_STREAM( ISRM )
             
                   ! Retrieve A Tag Associated with this Stream
                   ITAG = STREAM_TO_TAG(ISRM,IDX)
             
                   IF ( ISAMRGN_NUM( ITAG ) .LT. 1 ) THEN  
                     ! This tag is capturing 100% of every grid cell in
                     ! the full domain for this stream. We need to assign
                     ! all of the emissions from this stream to this tag
                     ! and the residual is then set to 0.
                     SA_VDEMIS_CONV( :,1:NL,:,:,ITAG ) = 
     &                    SA_VDEMIS_CONV( :,1:NL,:,:,ITAG )
     &                          + VDEMIS_CONV(:,1:NL,:,: )
                     SA_VDEMIS_CONV_OTHER = 0.0
             
                   ELSE
                     ! This tag is capturing some fraction of the stream
                     ! in grid cells across the domain. These fractional
                     ! contributions are applied using the DESID_REG_FAC
                     ! array with corresponding map indices.
                     ! Loop Over Altitude, Species and Regions to Add
                     ! emissions to corresponding tag, ITAG.
                     DO IRGN = 1, ISAMRGN_NUM( ITAG )
                       DO LAYER = 1, NL
                         DO SPC = 1, N_SPC_DIFF
                            SA_VDEMIS_CONV( SPC,LAYER,:,:,ITAG ) = 
     &                                SA_VDEMIS_CONV( SPC,LAYER,:,:,ITAG )
     &                               + VDEMIS_CONV( SPC,LAYER,:,: )
     &                                 * DESID_REG_FAC(:,:,ISAMRGN_MAP(ITAG,IRGN))
             
                            SA_VDEMIS_CONV_OTHER( SPC,LAYER,:,: ) = 
     &                                SA_VDEMIS_CONV_OTHER( SPC,LAYER,:,: )
     &                              - VDEMIS_CONV( SPC,LAYER,:,: )
     &                                * DESID_REG_FAC(:,:,ISAMRGN_MAP(ITAG,IRGN))
             
                         END DO
                       END DO
                     END DO
                   END IF
                 END DO
                 
                 ! Now that emissions from this stream have been assigned
                 ! to all available tags, assess the remainder and assign
                 ! it to the "OTHR" tag if any exists.
                 MINCHECK = MINVAL( SA_VDEMIS_CONV_OTHER( :,1:NL,:,: ) )
                 IF ( MINCHECK .GE. 0.0 ) THEN
                    ! Remainder is Valid. Move it all to the "OTHR" Tag
                    SA_VDEMIS_CONV( :,1:NL,:,:,OTHRTAG ) = 
     &                                  SA_VDEMIS_CONV_OTHER( :,1:NL,:,: )
                 ELSE
                    ! Some Part of the Remainder ("OTHER") is Invalid
                    XMSG = " ISAM mass balance error for emissions stream " //
     &                       TRIM( DESID_STREAM_DESC( ISRM ) ) // 
     &                      " - check isam control file. "
                    CALL M3WARN( 'ISAM_EMISSIONS', 1, 1, XMSG )
             
                    ! Repair OTHER By Distributing Negative Among Populated Tags 
                    ! and assigning positive part to the "OTHR" Tag as
                    ! planned
                    DO R = 1,NROWS
                    DO C = 1,NCOLS
                    DO LAYER = 1,NL
                    DO SPC = 1,N_SPC_DIFF
                       IF ( SA_VDEMIS_CONV_OTHER( SPC,LAYER,C,R ) .LT. 0.0 ) THEN
                          ! Find the total alloted to this (SPC,LAYER,C,R)
                          ! and use it to distribute the error fractionally
                          TOTAL = SUM( SA_VDEMIS_CONV( SPC,LAYER,C,R,: ) )
                          DO ITAG = 1,NTAG_SA 
                            SA_VDEMIS_CONV( SPC,LAYER,C,R,ITAG ) =
     &                        SA_VDEMIS_CONV( SPC,LAYER,C,R,ITAG ) *
     &                        ( 1.0 + SA_VDEMIS_CONV_OTHER( SPC,LAYER,C,R ) / TOTAL )
                          END DO
                       ELSE
                          ! Assign the positive values to the "OTHR" Tag
                          SA_VDEMIS_CONV( SPC,LAYER,C,R,OTHRTAG ) = 
     &                                  SA_VDEMIS_CONV_OTHER( SPC,LAYER,C,R )
                       END IF
                    END DO
                    END DO
                    END DO
                    END DO
                 END IF
             
               END IF
             
               ! Subset the emissions array for ISAM traced species  
               DO SPC = 1, NSPC_SA
                 IF ( MAP_DIFFtoSA( SPC ) .NE. 0 ) THEN
                   DO ITAG = 1,NTAG_SA
                     DO R = 1,NROWS
                       DO C = 1,NCOLS
                         DO LAYER = 1,NL
                           SA_VDEMIS_DIFF( SPC,LAYER,C,R,ITAG ) =  
     &                                  SA_VDEMIS_DIFF( SPC,LAYER,C,R,ITAG )
     &                               +  SA_VDEMIS_CONV( MAP_DIFFtoSA( SPC ),LAYER,C,R,ITAG )
                         END DO
                       END DO
                     END DO
                   END DO
                 END IF
               END DO
             
             END IF
#endif       
             
             
#ifdef sens
             IF ( SENS_PER_STREAM( ISRM ) .GT. 0 ) THEN ! This stream is used by DDM3D
             
               DO SENNUM = 1, SENS_PER_STREAM( ISRM )
                 NP = STREAM_TO_SENS( ISRM,SENNUM )
                 SVDEMIS_DIFF( :,1:NL,:,:,NP ) = SVDEMIS_DIFF( :,1:NL,:,:,NP ) 
     &                                         + VDEMIS_CONV(:,1:NL,:,: )
               END DO
             END IF
#endif       
           END IF  ! If L_DESID_DIAG and this stream is used for one
                   ! or more diagnostic
         END DO  ! Master Loop for Emissions Streams

#ifdef sens
C Subset the emissions array for DDM-3D (by species and region)
         DO NP = 1, NPMAX
           DO S = 1, N_SPC_DIFF
             DO L = 1, DESID_LAYS
               SVDEMIS_DIFF( S,L,:,:,NP ) = 
     &                        SVDEMIS_DIFF( S,L,:,:,NP )
     &                      * IREGION( :,:,L,NP )
     &                      * REAL( IPARM( NP, DIFF_MAP( S ) ), 4 )
             END DO
           END DO
         END DO
#endif

         ! Check for Negative Emissions after scaling rules and unit
         ! conversions are applied.
         CALL DESID_CHECK_NEG( VDEMIS_DIFF, 1, DESID_LAYS )
         
         ! Write Out Aggregate Diagnostic Emissions to Files
         IF ( L_DESID_DIAG ) CALL DESID_WRITE_DIAG( JDATE, JTIME )
         
         END IF  ! DESID_N_SRM

         RETURN

         END SUBROUTINE DESID_GET_EMIS

C------------------------------------------------------------------------------
 
      SUBROUTINE GR3D ( JDATE, JTIME, TSTEP, DESID_FNAME, STREAM_LAYS, 
     &                  FSTREAM, VDEMIS, L_DESID_DIAG )

      USE CGRID_SPCS          ! CGRID mechanism species
      USE ASX_DATA_MOD, ONLY: MET_DATA, GRID_DATA
      USE CENTRALIZED_IO_MODULE, ONLY: interpolate_var
#ifdef mpas
         use util_module, only : nextime
#endif

      !USE EMIS_UTIL
      !USE UTILIO_DEFN

      IMPLICIT NONE

      ! Includes:
      INCLUDE SUBST_FILES_ID  ! file name parameters

      ! Arguments:
      INTEGER, INTENT( IN ) :: JDATE, JTIME         ! date (YYYYDDD), time (HHMMSS)
      INTEGER, INTENT( IN ) :: FSTREAM              ! Stream Counter
      CHARACTER( 100 ), INTENT( IN ) :: DESID_FNAME ! Stream Filename
      INTEGER, INTENT( IN ) :: TSTEP( 3 )           ! time step vector (HHMMSS)
      LOGICAL, INTENT( IN ) :: L_DESID_DIAG         ! Flag for diagnostic operation

      ! Output:
      REAL, INTENT( OUT )  :: VDEMIS( :,:,:,: )     ! Emission Rate Array

      ! Local Variables:
      INTEGER   C, R, L, N, S, V, ISTR 
      INTEGER   S_STRT, S_END, STREAM_LAYS, NDATE, NTIME

      REAL, ALLOCATABLE, SAVE :: BUFF( :,:,: )
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: PNAME = 'GR3D'
      CHARACTER( 200 ) :: XMSG = ' '
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      INTEGER, ALLOCATABLE, SAVE :: LOC_STDATE(:)
      LOGICAL         :: L_NEWDAY

      real*8 :: lDBL_CKSUM
      real :: lsum
      logical :: found
      integer :: mycount

!-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         ! Get Domain Information for Emissions Read Routine

         ! Allocate Persistent Variables
         ALLOCATE( BUFF( NCOLS,NROWS,MAXVAL( DESID_GRID_LAYS ) ) )
         ALLOCATE( LOC_STDATE( SIZE(DESID_STREAM_DATE) ) )

         LOC_STDATE = STDATE
      END IF    !FirstTime
 
      ! Ensure that the model and emissions timestamp dates stay synchronized
      L_NEWDAY = .FALSE.
      IF (LOC_STDATE(FSTREAM) .NE. JDATE ) THEN 
         NDATE = JDATE; NTIME = JTIME
         CALL NEXTIME( NDATE, NTIME, -TSTEP( 1 ) )       ! go back one output tstep
         CALL NEXTIME( DESID_STREAM_DATE( FSTREAM ), NTIME, TSTEP( 1 ) ) ! advance the start date one time step
         LOC_STDATE(FSTREAM) = JDATE
         L_NEWDAY = .TRUE.
      END IF

      ! Read & Interpolate Emissions 
      DO R = 1,NROWS
      DO C = 1,NCOLS
      DO L = 1,DESID_LAYS
      DO ISTR = 1,DESID_N_ISTR
        VDEMIS(ISTR,L,C,R) = 0.0
      END DO
      END DO
      END DO
      END DO

      DO ISTR = 1, DESID_N_ISTR 
        VNAME = LOCAL_EMVAR( ISTR, FSTREAM )
        IF ( VNAME .EQ. '' ) CYCLE

        CALL INTERPOLATE_VAR (VNAME, DESID_STREAM_DATE( FSTREAM ), JTIME, BUFF, DESID_FNAME)

        ! Store all emissions in mol/sec or g/sec and convert to ppmv/s later
        IF ( DESID_LAYS .GE. STREAM_LAYS ) THEN 
          DO L = 1, STREAM_LAYS
             VDEMIS( ISTR,L,:,: ) = BUFF( :,:,L )
          END DO
        ELSE
          DO L = 1, DESID_LAYS
             VDEMIS( ISTR,L,:,: ) = BUFF( :,:,L )
          END DO
          DO L = DESID_LAYS+1,STREAM_LAYS
             VDEMIS( ISTR,DESID_LAYS,:,: ) = VDEMIS( ISTR,DESID_LAYS,:,: ) + BUFF( :,:,L )
          END DO
        END IF
      END DO   ! ISTR

      ! Reset the date of the gridded file if this is diagnostic mode
      ! and the day has advanced
      IF ( L_NEWDAY .AND. L_DESID_DIAG ) THEN
         CALL NEXTIME( DESID_STREAM_DATE( FSTREAM ), NTIME, -TSTEP(1) )
         LOC_STDATE(FSTREAM) = NDATE
      END IF

      RETURN

      END SUBROUTINE GR3D
 
C-----------------------------------------------------------------------
      SUBROUTINE DESID_SCALING( VDEMIS0, ISRM, NL, VDEMIS )

C     Apply region-dependent scaling of emissions rules.
C-----------------------------------------------------------------------
      USE CENTRALIZED_IO_MODULE, ONLY: MSFX2
          
      IMPLICIT NONE

      INTEGER, INTENT( IN )   :: ISRM, NL
      REAL, INTENT( IN )      :: VDEMIS0( :,:,:,: )
      REAL, INTENT( OUT )     :: VDEMIS ( :,:,:,: )

      REAL, ALLOCATABLE, SAVE    :: VDEMIS1( :,:,: )
      INTEGER, ALLOCATABLE, SAVE :: NFAC( : )

      INTEGER ISTR, IFAC, L, NFAC_MAX, IRGN, OP, JSRM, ISTR_TMP, 
     &        NISTR, REG_UNQ, JRGN, K
      INTEGER, ALLOCATABLE :: MAP_FACtoISTR( : )
      REAL, ALLOCATABLE, SAVE :: FAC( :,: )
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL :: LAREA, LAREAADJ


      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         ALLOCATE( NFAC( DESID_N_ISTR ) )
         ALLOCATE( VDEMIS1( NLAYS, NCOLS, NROWS ) )
         ALLOCATE( FAC( NCOLS,NROWS ) )
      END IF   ! First Time

      !! Time-Dependent Portion
      VDEMIS( :,:,:,: ) = 0.0
      NFAC( : ) = DESID_FAC( :,ISRM )%NFAC
      
      ! Skip Streams With no Emissions Whatsoever
      IF ( SUM( NFAC(:) ) .EQ. 0 ) RETURN

      ! Loop through Each Instruction 
      DO ISTR = 1,DESID_N_ISTR
        ! Do Not bother with this row if there is no emission variable to map
        IF ( NFAC( ISTR ) .EQ. 0 ) CYCLE

        ! Loop through each unique Region and Process Instruction's Stacks
        DO JRGN = 1,DESID_FAC( ISTR,ISRM )%NREG
          REG_UNQ = DESID_FAC( ISTR,ISRM )%REG_UNQ( JRGN )

          ! Initialize Region-Dependent Array for this Instruction
          VDEMIS1( :,:,: ) = 0.

          ! Calculate the scale factor needed for this region
          DO IFAC = 1,NFAC( ISTR )      

            FAC(:,:)= DESID_FAC( ISTR,ISRM )%FAC( IFAC )
            OP      = DESID_FAC( ISTR,ISRM )%OP ( IFAC )
            IRGN    = DESID_FAC( ISTR,ISRM )%REG( IFAC )
            LAREA   = DESID_FAC( ISTR,ISRM )%AREA(IFAC )
            LAREAADJ= DESID_FAC( ISTR,ISRM )%AREAADJ(IFAC )

            IF ( IRGN .EQ. REG_UNQ .OR.
     &          DESID_REG_SUB( IRGN,REG_UNQ ) ) THEN
              !Apply scaling for region IRGN using DESID_FAC 

              IF ( OP .EQ. 1 ) THEN ! Add New Emission
#ifndef mpas
                 IF ( LAREA ) FAC = FAC * CELLAREA
                 IF ( LAREAADJ ) FAC = FAC / MSFX2
#endif
                 DO L = 1,NL
                   VDEMIS1( L,:,: ) = VDEMIS1( L,:,: ) +
     &                  VDEMIS0( ISTR,L,:,: ) * FAC
                 END DO

              ELSE IF ( OP.EQ.2 ) THEN ! Multiply Emissions Rule
                 DO L = 1,NL
                   VDEMIS1( L,:,: ) = VDEMIS1( L,:,: ) * FAC
                 END DO

              ELSE IF ( OP.EQ.3 ) THEN ! Overwrite Existing Rule
#ifndef mpas
                 IF ( LAREA ) FAC = FAC * CELLAREA
                 IF ( LAREAADJ ) FAC = FAC / MSFX2
#endif
                 DO L = 1,NL
                   VDEMIS1( L,:,: ) = VDEMIS0( ISTR,L,:,: ) * FAC
                 END DO
             END IF
            END IF
          END DO  ! End Loop through instruction stack

          ! Determine Region Mask to use for this Instruction
          K = DESID_FAC( ISTR,ISRM)%REG_RMDR( JRGN )
          IF ( K .EQ. 0 ) THEN
             ! This region does not have active subsets for this instruction
             ! Integrate Emissions Accounting for Region-based contributions
             DO L = 1,NL
               VDEMIS( ISTR,L,:,: ) = VDEMIS( ISTR,L,:,: ) + 
     &             VDEMIS1( L,:,: ) * DESID_REG_FAC(:,:,REG_UNQ )
             END DO
          ELSE
             ! This region has active subsets for this instruction. Use the 
             ! remainder mask 
             ! Integrate Emissions Accounting for Region-based contributions
             DO L = 1,NL
               VDEMIS( ISTR,L,:,: ) = VDEMIS( ISTR,L,:,: ) + 
     &             VDEMIS1( L,:,: ) * DESID_REG_RMDR( K )%MASK(:,: )
             END DO
          END IF


        END DO    ! End loop through unique regions

      END DO      ! End loop through instructions

      RETURN

      END SUBROUTINE DESID_SCALING


C-----------------------------------------------------------------------
      SUBROUTINE DESID_CONV_UNITS( VDEMIS0, NL, VDEMIS )

C     Convert rate and map to Diffusivity module species order
C-----------------------------------------------------------------------
          
      USE ASX_DATA_MOD, ONLY: MET_DATA, GRID_DATA
      USE AERO_EMIS           ! inherits GRID_CONF
#ifdef mpas
      USE coupler_module, ONLY: inv_cell_vol
#endif

      IMPLICIT NONE

      ! Local Variables
      REAL,ALLOCATABLE, SAVE :: CNVTC( :,:,: ) ! combined conversion factor
      REAL, PARAMETER  :: KGPG = 1.0E-03       ! kg/g
      REAL, PARAMETER  :: MWAIR = 28.9628      ! g/mol
      REAL, PARAMETER  :: AVO  = 6.0221367E23
      REAL, PARAMETER  :: RAVO = 1.0 / AVO
      
      INTEGER, INTENT( IN ) :: NL
      REAL, INTENT( INOUT ) :: VDEMIS0( :,:,:,: )
      REAL, INTENT( OUT ):: VDEMIS ( :,:,:,: )
 
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      INTEGER       :: C, R, L, ISTR, INDX

      ! Get domain decomp info from the emissions file
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         ALLOCATE( CNVTC( DESID_LAYS,NCOLS,NROWS ) )
      END IF    !FirstTime
      
      ! Convert All Emissions to Units Appropriate for the Dispersion Solver

      DO L = 1,NL
#ifdef mpas
        CNVTC( L,:,: ) = (MWAIR * KGPG) * inv_cell_vol(:,1,L) * Met_Data%RRHOJ( :,:,L )  ! 1/mol
#else
        CNVTC( L,:,: ) = (MWAIR * KGPG) / CELLVOL( :,:,L ) * Met_Data%RRHOJ( :,:,L )     ! 1/mol
#endif
      END DO                                                                  

      !MAKE SURE TO APPLY RELEVANT UNIT CONVERSION TO EACH
      !TYPE OF VARIABLE (GAS, AEROSOL MASS, AEROSOL NUMBER,
      !AND AEROSOL SURFACE AREA)
     
      ! Gas Moles:   mol/s -> ppmv/s
      FORALL ( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoGAS( ISTR ) .NE. 0 )
     &    VDEMIS0( ISTR,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * 1.0E6 * VDEMIS0( ISTR,1:NL,:,: )
  
      ! Aer. Mass:   mol/s -> ppmv/s    
      FORALL ( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoAERO( ISTR ) .NE. 0 )
     &    VDEMIS0( ISTR,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * 1.0E6 * VDEMIS0( ISTR,1:NL,:,: )
      
      ! Aer. Surf:   m2/s  -> m2/mol/s
      FORALL ( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoSRF( ISTR ) .NE. 0 )
     &    VDEMIS0( ISTR,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * VDEMIS0( ISTR,1:NL,:,: )
      
      ! Aer. Num:    N/s   -> N/mol/s 
      FORALL ( ISTR = 1:DESID_N_ISTR, MAP_ISTRtoNUM( ISTR ) .NE. 0 )
     &    VDEMIS0( ISTR,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * VDEMIS0( ISTR,1:NL,:,: )

 
      ! zero out emissions values for diffused species not included in emissions list.
      ! ...accounts for emissions species names as a subset of the vert. diffused species list
      DO L = 1,NL
        VDEMIS( :,L,:,: ) = 0.0

        DO ISTR = 1,DESID_N_ISTR 
          IF ( MAP_ISTRtoDIFF( ISTR ) .NE. 0 ) 
     &        VDEMIS( MAP_ISTRtoDIFF( ISTR ),L,:,: ) = 
     &                VDEMIS( MAP_ISTRtoDIFF( ISTR ),L,:,: ) + 
     &                VDEMIS0( ISTR,L,:,: )
        END DO
      END DO

      RETURN
      END SUBROUTINE DESID_CONV_UNITS


!-----------------------------------------------------------------------
      SUBROUTINE DESID_CHECK_NEG( VDEMIS, ISRM, NL )

!     Check Emissions Array for negative values and exit if negative values
!     exceed tolerance of 1.0E-7 for gas or aerosol mass emission rates.
!     This value was chosen through trial and error for detection of
!     obvious issues with negative inputs. Users may adjust this
!     tolerance if it is too stringent for their application.
!          
!     Number and surface area emission rates are scaled up consistent
!     with assuming particles 2 um in diameter. Because there are so
!     many potentially varying parameters (e.g. particle size, density,
!     mode standard deviation, etc.), the relationships between the mass
!     threshold and number/surface area thresholds are somewhat arbitrary. 
!
!     In all cases, thresholds are set to allow slightly negative emission 
!     rates due to numerical roundoff in difference calculations, but
!     the simulation will stop if the threshold is exceeded, which
!     likely indicates a serious error in emissions processing.
!          
!     Emissions that are negative but within tolerance are set to 0.0.
!     VDEMIS is the scaled emissions and VDEMIS0 is the emissions
!     read in from each stream.
!-----------------------------------------------------------------------
      USE UTILIO_DEFN                                             
      USE VDIFF_DATA, only : N_SPC_DIFF
      USE VDIFF_MAP, only : DIFF_SPC, DIFF_MASK_NUM, DIFF_MASK_SRF 

      IMPLICIT NONE

      REAL, INTENT( INOUT ) :: VDEMIS ( :,:,:,: )
      INTEGER, INTENT( IN ) :: NL
      INTEGER, INTENT( IN ) :: ISRM

      INTEGER :: ISPC, ILAY, ICOL, IROW, JCOL, JROW
      INTEGER :: ALOC( 3 ), STAT
      REAL    :: EMIS_MIN
      CHARACTER(250) :: XMSG


      ! If All Values Are Positive then Return Right Away
      EMIS_MIN = MINVAL( VDEMIS( :,1:NL,:,: ) )
      IF ( EMIS_MIN .GE. 0.0 ) RETURN

      STAT = 0

      ! Loop through species to make sure correct threshold is applied
      DO ISPC = 1,N_SPC_DIFF
         EMIS_MIN = MINVAL( VDEMIS( ISPC,1:NL,:,: ) )
         IF ( ( (DIFF_MASK_NUM( ISPC )) .AND. EMIS_MIN .LT. -1.0e11 ) .OR.
     &        ( (DIFF_MASK_SRF( ISPC )) .AND. EMIS_MIN .LT. -0.1   ) .OR.
     &        ( (.NOT.DIFF_MASK_NUM( ISPC ) .AND. .NOT. DIFF_MASK_SRF( ISPC )) 
     &          .AND. EMIS_MIN .LT. -1.0e-7 ) ) THEN

           ! Find Where the Most Negative Value Is and Exit
           ALOC = MINLOC( VDEMIS( ISPC,1:NL,:,: ) )
           ILAY = ALOC( 1 )
           ICOL = ALOC( 2 )
           IROW = ALOC( 3 )
           CALL GET_GLOBAL_COORDS( ICOL, IROW, JCOL, JROW )

           WRITE( LOGDEV, '(/,5x,A,/,5x,A,A,A,A/,5x,A,ES10.3,A,A,/,5x,A1,I3,A1,I3,A1,I2,A2)' ),
     &       'ERROR: At least one invalid negative emission rate has been ',
     &       'detected for CMAQ species ',TRIM(DIFF_SPC( ISPC )),'. The ', 
     &       'most negative emission','rate is ',EMIS_MIN,' at domain-wide gridcell',
     &       ' (COL,ROW,LAY): ','(',JCOL,',',JROW,',',ILAY,').'

           STAT = 1
        ELSE IF ( EMIS_MIN .LT. 0.0 ) THEN
           ! Threshold was not exceeded, but there are negatives that
           ! must be corrected.
           WHERE ( VDEMIS( ISPC,1:NL,:,: ) .LT. 0.0 ) VDEMIS( ISPC,1:NL,:,: ) = 0.0
        END IF

      END DO  
        
      IF ( STAT .EQ. 1 ) THEN
         XMSG = 'Negative Emissions Detected'
         CALL M3EXIT( 'EMISS_NEG_CHECK', 0, 0, XMSG, XSTAT1 )
      END IF

      END SUBROUTINE DESID_CHECK_NEG    

!-----------------------------------------------------------------------
      SUBROUTINE DESID_CALC_DIAG( JDATE, JTIME, VDEMIS0, ISRM, NL ) 

!     Write out emissions diagnostic file
!-----------------------------------------------------------------------
          
      USE ASX_DATA_MOD, ONLY: MET_DATA, GRID_DATA
      USE AERO_EMIS           ! inherits GRID_CONF
      USE GRID_CONF
      USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_MASK_GAS, DIFF_MASK_AERO,
     &                      DIFF_MASK_NUM, DIFF_MASK_SRF, DIFF_MW, DIFF_SPC,
     &                      DIFF_MASK_NR, DIFF_MASK_TRAC
      USE AERO_DATA, ONLY : GPKG
      USE CONST, ONLY: AVO, MWAIR
#ifdef mpas
      USE coupler_module, ONLY: inv_cell_vol
#endif

      IMPLICIT NONE
         
      INTEGER, INTENT( IN ) :: JDATE, JTIME, ISRM
      REAL, INTENT( In )    :: VDEMIS0( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: VDEMIS ( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: VDEMIS_OUT ( :,:,: )

      ! Local Variables
      REAL, PARAMETER  :: RAVO = 1.0 / AVO
      REAL,ALLOCATABLE, SAVE :: CNVTC( :,:,: ) ! combined conversion factor
 
      INTEGER       :: LAYS, L, C, R, IVAR, NL, I
      INTEGER       :: ISPEC, IDIAG, IP, JSPEC, JDIAG, KSPEC

      LOGICAL :: FIRST_TIME = .TRUE.
      CHARACTER( 586 ) :: XMSG

      ! Get pressure info from ASX_DATA_MOD
      IF ( FIRST_TIME ) THEN
         FIRST_TIME = .FALSE.

         ALLOCATE( CNVTC( DESID_LAYS,NCOLS,NROWS ), 
     &             VDEMIS( N_SPC_DIFF,DESID_LAYS,NCOLS,NROWS ),
     &             VDEMIS_OUT( NCOLS,NROWS,DESID_LAYS ) )
      END IF    !FirstTime
      
      VDEMIS     = 0.0
      VDEMIS_OUT = 0.0

      ! Convert All Emissions to Units Appropriate for the Dispersion Solver
      DO L = 1,NL
#ifdef mpas
        CNVTC( L,:,: ) = (GPKG / MWAIR) / inv_cell_vol(:,1,L) / Met_Data%RRHOJ( :,:,L )  ! mol
#else
        CNVTC( L,:,: ) = (GPKG / MWAIR) * CELLVOL( :,:,L ) / Met_Data%RRHOJ( :,:,L )     ! mol
#endif
      END DO                                                              

      !MAKE SURE TO APPLY RELEVANT UNIT CONVERSION TO EACH
      !TYPE OF VARIABLE (GAS, AEROSOL MASS, AEROSOL NUMBER,
      !AND AEROSOL SURFACE AREA)

      ! Gas Moles:   ppmv/s -> mol/s
      FORALL ( I = 1:N_SPC_DIFF, DIFF_MASK_GAS( I ) .OR.
     &                           DIFF_MASK_NR( I )  .OR.
     &                           DIFF_MASK_TRAC( I ) )
     &    VDEMIS( I,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * 1.0E-6 * VDEMIS0( I,1:NL,:,:)

      ! Aer Moles:   ppmv/s -> g/s
      FORALL ( I = 1:N_SPC_DIFF, DIFF_MASK_AERO( I ) .AND.
     &                           .NOT. DIFF_MASK_NUM( I ) .AND.
     &                           .NOT. DIFF_MASK_SRF( I )  )
     &    VDEMIS( I,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * 1.0E-6 * VDEMIS0( I,1:NL,:,:) 
     &                           * DIFF_MW( I )

      ! Aer. Srf:   m2/m3/s -> m2/s
      FORALL ( I = 1:N_SPC_DIFF, DIFF_MASK_SRF( I ) )
     &    VDEMIS( I,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * VDEMIS0( I,1:NL,:,:)

      ! Aer. Num:  N/mol/s -> N/s  
      FORALL ( I = 1:N_SPC_DIFF, DIFF_MASK_NUM( I ) )
     &    VDEMIS( I,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * VDEMIS0( I,1:NL,:,:)

      ! Write out this stream to its diagnostic file or sum emissions
      ! for an aggregate diagnostic
      DO IDIAG = 1,DESID_N_DIAG
        IF ( DESID_DIAG_STREAM_MASK( ISRM,IDIAG ) ) THEN
           ! This Stream Contributes to IDIAG diagnostic
           LAYS = DESID_DIAG_LAYS( IDIAG )

           ! Loop over all diagnostic species
           DO ISPEC = 1,DESID_DIAG_SPEC( IDIAG )%NSPEC

              ! Sum up all of the diffused species relevant for this
              ! diagnostic species
              VDEMIS_OUT( :,:,: ) = 0.0
              DO IP = 1,DESID_DIAG_SPEC( IDIAG )%NPAIRS
                IF ( DESID_DIAG_SPEC( IDIAG )%MAP_toDIAG( IP )
     &                .EQ. ISPEC ) THEN
                  JSPEC = DESID_DIAG_SPEC( IDIAG )%MAP_toDIFF( IP )
                  DO L = 1,NL
                     VDEMIS_OUT( :,:,L ) = 
     &                   VDEMIS_OUT( :,:,L ) + VDEMIS( JSPEC,L,:,: )
                  END DO
                END IF
              END DO

              IF ( DESID_DIAG_FORMAT( IDIAG ) .EQ. 'COLSUM' )
     &             VDEMIS_OUT(:,:,1) = SUM( VDEMIS_OUT( :,:,1:NL ),3 )

              IF ( DESID_DIAG_N_STREAM( IDIAG ) .EQ. 1 ) THEN
                ! Only this stream contributes. Write emisison
                ! rates out directly
#ifndef mpas
                IF ( .NOT. WRITE3( DESID_DIAG_LOGICAL(IDIAG), DESID_DIAG_SPEC(IDIAG)%SPEC(ISPEC),
     &               JDATE, JTIME, VDEMIS_OUT( :,:,1:LAYS ) ) ) THEN
                   XMSG = 'Could not write ' // TRIM( DESID_DIAG_FILENAME(IDIAG) ) // ' file'
                   CALL M3EXIT( 'WRITE_EMISS_DIAG', JDATE, JTIME, XMSG, XSTAT1 )
                END IF
#endif
              ELSE
                ! Other streams contribute as well. Sum these emission
                ! rates to an aggregate array, VDEMIS_DIAG
                KSPEC = MAP_DIAGtoVDEMIS( ISPEC,IDIAG )
                VDEMIS_DIAG( KSPEC,:,:,1:LAYS ) = VDEMIS_DIAG( KSPEC,:,:,1:LAYS ) + 
     &                                            VDEMIS_OUT( :,:,1:LAYS )
              END IF
           END DO
        END IF
      END DO

      END SUBROUTINE DESID_CALC_DIAG
 
!-----------------------------------------------------------------------
      SUBROUTINE DESID_WRITE_DIAG( JDATE, JTIME ) 

!     Write out emissions diagnostic file
!-----------------------------------------------------------------------
          
          IMPLICIT NONE

          INTEGER IDIAG, ISPEC, JSPEC
          INTEGER LAYS
          INTEGER JDATE, JTIME
          CHARACTER(200) :: XMSG

#ifdef mpas
          CHARACTER (20) :: TIME_STAMP
          call mio_time_format_conversion (jdate, jtime, time_stamp)
#endif

          DO IDIAG = 1,DESID_N_DIAG

            IF ( DESID_DIAG_N_STREAM( IDIAG ) .GT. 1 ) THEN
               LAYS = DESID_DIAG_LAYS( IDIAG )


               DO ISPEC = 1,DESID_DIAG_SPEC( IDIAG )%NSPEC
                  ! Write out the emissions data for this aggregate
                  ! diagnostic
                  JSPEC = MAP_DIAGtoVDEMIS( ISPEC,IDIAG )
#ifndef mpas
                  IF ( .NOT. WRITE3( DESID_DIAG_LOGICAL(IDIAG), DESID_DIAG_SPEC( IDIAG )%SPEC( ISPEC ),
     &                     JDATE, JTIME, VDEMIS_DIAG( JSPEC,:,:,1:LAYS ) ) ) THEN
                    XMSG = 'Could not write ' // TRIM( DESID_DIAG_FILENAME(IDIAG) ) // ' file'
                    CALL M3EXIT( 'WRITE_EMISS_DIAG', JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
#else
             call mio_fwrite('EMIS_DIAG',DESID_DIAG_SPEC( IDIAG )%SPEC(ISPEC ), "write_emis",
     &                             VDEMIS_DIAG( JSPEC,:,1,1 ) ,time_stamp)
#endif
               END DO
            END IF
         END DO   


      END SUBROUTINE DESID_WRITE_DIAG

C-----------------------------------------------------------------------
      SUBROUTINE DESID_PROCESS_RULES( JDATE, JTIME )

C Check the chemical species from the namelists and AERO_DATA against
C the species that are available on the actual emissions input files. If
C they do not agree, print warnings or crash the program depending on
C how severe the error is.
C
C    16 Mar 2017  B.Murphy     Created Subroutine
C    10 Sep 2017  B.Murphy     Revised Emissions Mapping Approach
C    08 Nov 2017  B.Murphy     Vectorized Emission Maps to allow for 
C                                unlimited emissions streams
C-----------------------------------------------------------------------

         USE VDIFF_MAP, only : DIFF_SPC, ! Name for every Diffusion Module Species                                  
     &                         DIFF_MASK_GAS, DIFF_MASK_AERO, DIFF_MASK_NR, 
     &                         DIFF_MASK_TRAC, DIFF_MW
         USE UTILIO_DEFN
         USE AERO_DATA, only : N_MODE, AEROSPC,  ! Aerosol Properties Table
     &                         N_AEROSPC, AEROMODE, MODESUFF, DESID_AERO_REF
         USE AERO_EMIS, only : MAP_NUMtoISTR, MAP_SRFtoISTR, MAP_ISTRtoAERO, MAP_ISTRtoMODE, 
     &                         MAP_ISTRtoNUM, MAP_ISTRtoSRF, MAP_ISTRtoSD,
     &                         DESID_STREAM_AERO, SD_SPLIT, DESID_INIT_SIZE_DIST
         USE UDTYPES,   only : CARRY1, LARRY1
         USE UTIL_FAMILY_MODULE
#ifdef mpas
         use util_module, only : index1, upcase
#endif

         IMPLICIT NONE

         INTEGER, INTENT(IN)  :: JDATE, JTIME
         INTEGER    :: N_UNUSED, REGNUM, N_USED

         INTEGER    :: STRT, PTSTRT, ISPC, IDX, IX, IEMVAR, IRULE, IAREA,
     &                 N, IM, IAERO, V, ISRM, NSPC, IA, IDIFF, JDX, JM,
     &                 ISTR, IEM, KDX, JSD, JEM, ISD,
     &                 IFAC, IRGN, ISTRN, NFAC, NREG, NCHEM, ICHEM, IFAM, 
     &                 IRGN2, N_EMVAR_CATCH, ICATCH, F, N_REG_RMDR, JRGN, K,
     &                 KRGN, I, J, JFAC
         REAL       :: AERO_SPLIT, UNIT_FAC_1, UNIT_FAC_2, EMVAR_MW, 
     &                 SPEC_MW, BASIS_FAC, FAC

         LOGICAL    :: LERROR, LFOUND, L_WDIFF, L_WISD, LTEST
         LOGICAL    :: LGAS_DIFF, LGAS_EMVAR, L_CATCH, LSUBSUB
         
         CHARACTER( 16 )  :: SPECNAME, SN, SM, EMVAR_CATCH( 200 )

         CHARACTER( 16 )  :: PNAME = 'DESID_PROCESS_RULES'
         CHARACTER( 100)  :: VARDESC
         INTEGER          :: STATUS

         CHARACTER( 500 ) :: XMSG
         CHARACTER( 16 )  :: B
         CHARACTER( 20 )  :: REFNAME
         
         INTEGER, PARAMETER :: NI0 = 3000
         LOGICAL, ALLOCATABLE, SAVE :: RULE_STREAM( : ), RULE_SPEC( : )
         TYPE( LARRY1 ), ALLOCATABLE, SAVE :: RULE_EMVAR( : ), RULE_PHASE( : )
         INTEGER, PARAMETER :: N_SCALEFAC = 100
         LOGICAL            :: LSPEC_KEY, LEMVAR_KEY
         CHARACTER( 16 )    :: CHEM_NAME( 150 )
         LOGICAL            :: LERROR2, LERROR3( 150 )
        
         INTEGER            :: IC, N_TASKS
         INTEGER, PARAMETER :: NT0 = 4000000
         INTEGER            :: TASK_IDIFF( NT0 )
         INTEGER            :: TASK_ISRM ( NT0 )
         INTEGER            :: TASK_IEMVAR( NT0)
         CHARACTER( 16 )    :: TASK_SPEC ( NT0 )
         CHARACTER( 16 )    :: TASK_EMVAR( NT0 )
         INTEGER            :: TASK_PHASE( NT0 )

         REAL, ALLOCATABLE :: LOCAL_FAC( :,:,: )
         REAL, ALLOCATABLE :: LOCAL_FAC_BULK( :,:,: )
         CHARACTER( 1 ), ALLOCATABLE :: LOCAL_OP( :,:,: )
         CHARACTER( 4 ), ALLOCATABLE :: LOCAL_BASIS( :,:,: )
         REAL,  ALLOCATABLE          :: LOCAL_CONV( :,:,: )
         INTEGER, ALLOCATABLE :: LOCAL_REG( :,:,: )
         INTEGER              :: N_RULE, N_AREA
         LOGICAL              :: LREMOVE, LERROR4
         INTEGER, ALLOCATABLE :: REG_UNQ( : )
         LOGICAL, ALLOCATABLE :: LSUB( : )
         LOGICAL              :: LREG_RMDR
         REAL, ALLOCATABLE    :: RMDR_MASK( :,: )


! Write Out Region Diagnostic Information
         CALL LOG_SUBHEADING( LOGDEV, "Regions Available for Scaling" )

         ! Print Information about All the Available Regions for Scaling
         WRITE( LOGDEV,'(8x,A,2x,A,8x,A,10x,A)' ),'Number','Region Label','File Label','Variable'
         WRITE( LOGDEV,'(8x,A,2x,A,8x,A,10x,A)' ),'------','------------','----------','--------'
         DO IRGN = 1,DESID_N_REG
            WRITE( LOGDEV,'(8x,I3,5x,A18,2x,A18,2x,A)' ),IRGN, DESID_REG(IRGN)%LABEL( 1:18 ),
     &             DESID_REG( IRGN )%File( 1:18 ), TRIM(DESID_REG( IRGN )%VAR ) 
            IF ( DESID_REG(IRGN)%FILE(1:6) .EQ. 'Family' ) THEN
                 F = INDEX1( DESID_REG(IRGN)%LABEL(1:18), DESID_N_REG_FAMS, REGIONFAMILYNAME )
                 DO IRGN2 = 1,REGIONFAMILYNUM( F )
                     WRITE( LOGDEV,'(56x,A)' ), REGIONFAMILYMEMBERS( F,IRGN2 )
                 END DO
            END IF
         END DO

! Retrieve the Emission Variables Available From Emissions Streams
         ! Load Default Molecular Weights and Units based on 
         ! SMOKE/MOVES/SPECIATE specifications
         CALL LOG_MESSAGE( LOGDEV, '' )
         CALL LOG_MESSAGE( LOGDEV, "Map Emissions Variables to Default Units and Molecular Weight" )

         N_EMVAR_CATCH = 0
         DO ISRM = 1,DESID_N_SRM

            IF ( ISRM .EQ. ISEASRM .OR. ISRM .EQ. IBIOSRM .OR. 
     &           ISRM .EQ. IDUSTSRM.OR. ISRM .EQ. ILTSRM  .OR.
     &           ISRM .EQ. IMGSRM  .OR. ISRM .EQ. IMIOGSRM .OR.
     &           ISRM .EQ. IMETSRM ) CYCLE

            ALLOCATE( DESID_EMVAR( ISRM )%MW      ( DESID_EMVAR( ISRM )%LEN ) )
            ALLOCATE( DESID_EMVAR( ISRM )%USED    ( DESID_EMVAR( ISRM )%LEN ) )
            ALLOCATE( DESID_EMVAR( ISRM )%CONV    ( DESID_EMVAR( ISRM )%LEN ) )
            ALLOCATE( DESID_EMVAR( ISRM )%BASIS   ( DESID_EMVAR( ISRM )%LEN ) )
            ALLOCATE( DESID_EMVAR( ISRM )%LAREA   ( DESID_EMVAR( ISRM )%LEN ) )
            ALLOCATE( DESID_EMVAR( ISRM )%LAREAADJ( DESID_EMVAR( ISRM )%LEN ) )
            DESID_EMVAR( ISRM )%USED    = .FALSE.
            DESID_EMVAR( ISRM )%LAREA   = .FALSE.
            DESID_EMVAR( ISRM )%LAREAADJ= .FALSE.

            DO IEMVAR = 1,DESID_EMVAR( ISRM )%LEN
               ! Assign Default Molecular Weight to Each Emision Variable
               B = DESID_EMVAR( ISRM )%ARRY( IEMVAR )
               IA  = INDEX1( B, DESID_N_EMVAR_TABLE, DESID_EMVAR_TABLE( : )%NAME )
               IF ( IA .GT. 0 ) THEN
                  DESID_EMVAR( ISRM )%MW   ( IEMVAR ) = DESID_EMVAR_TABLE( IA )%MW
               ELSE
                  ! Emission Variable is not calculated online nor does it
                  ! belong to the default list of commonly used
                  ! variables.
                  DESID_EMVAR( ISRM )%MW   ( IEMVAR ) = 1.0

                  ! Only Write a Note to the User if this species hasn't
                  ! been caught from a different stream already
                  IF ( N_EMVAR_CATCH .EQ. 0 .OR.
     &                 INDEX1( B, 200, EMVAR_CATCH ) .EQ. 0 ) THEN
                     N_EMVAR_CATCH = N_EMVAR_CATCH + 1
                     EMVAR_CATCH( N_EMVAR_CATCH ) = B
                  END IF
               END IF
            END DO

         END DO

         CALL LOG_MESSAGE( LOGDEV, "Checking Emission Units" )
         DO ISRM = 1,DESID_N_SRM
            DO IEMVAR = 1,DESID_EMVAR( ISRM )%LEN
               ! Check Units and Assign Conversion Factors for
               ! translating [kmol or umol] -> mol, [kg or mg] -> g, and
               ! [s, min, hr] -> s
               CALL CHECK_EMIS_UNITS( ISRM, IEMVAR, 
     &                                DESID_EMVAR( ISRM )%ARRY ( IEMVAR ),
     &                                DESID_EMVAR( ISRM )%UNITS( IEMVAR ), 
     &                                DESID_EMVAR( ISRM )%CONV ( IEMVAR ),
     &                                DESID_EMVAR( ISRM )%BASIS( IEMVAR ),
     &                                DESID_EMVAR( ISRM )%LAREA( IEMVAR ) )
               ! Default for detecting area fluxes is to adjust to
               ! projected grid
               IF ( DESID_EMVAR( ISRM )%LAREA( IEMVAR ) ) 
     &              DESID_EMVAR( ISRM )%LAREAADJ( IEMVAR ) = .TRUE.
            END DO
         END DO

! Process Area Normalization User Controls. Override Automatic defaults
! with forced area normalization and/or projection adjustment.
         N_AREA = 0
         DO IAREA = 1,SIZE( DESID_AREA_NML )
            IF( DESID_AREA_NML( IAREA )%STREAM .EQ. '' ) EXIT
            N_AREA = IAREA
         END DO

         ALLOCATE( RULE_STREAM( DESID_N_SRM   ) )
         DO IAREA = 1,N_AREA
            LREMOVE = .FALSE.
            CALL DESID_GET_RULE_STREAMS( DESID_AREA_NML( IAREA )%STREAM, 
     &              IAREA, RULE_STREAM, LREMOVE, LERROR4 )
            IF ( LREMOVE ) CYCLE

            ! If the 'ALL' keyword was used, set all of the online
            ! sources to false.
            IF ( DESID_AREA_NML(IAREA)%STREAM .EQ. 'ALL' ) THEN
               IF ( ISEASRM .GT. 0 )  RULE_STREAM( ISEASRM  )  = .FALSE. 
               IF ( IBIOSRM .GT. 0 )  RULE_STREAM( IBIOSRM  )  = .FALSE. 
               IF ( IDUSTSRM .GT. 0 ) RULE_STREAM( IDUSTSRM  ) = .FALSE. 
               IF ( ILTSRM .GT. 0 )   RULE_STREAM( ILTSRM  )   = .FALSE. 
               IF ( IMGSRM .GT. 0 )   RULE_STREAM( IMGSRM  )   = .FALSE. 
               IF ( IMIOGSRM .GT. 0 ) RULE_STREAM( IMIOGSRM  ) = .FALSE. 
            ENDIF   
               
            DO ISRM = 1,DESID_N_SRM
               IF ( RULE_STREAM( ISRM ) ) THEN
                  DO IEMVAR = 1,DESID_EMVAR( ISRM )%LEN
                     ! Override Area Normalization if Requested
                     IF ( DESID_AREA_NML( IAREA )%AREA .EQ. 'TRUE' ) THEN
                         DESID_EMVAR( ISRM )%LAREA( IEMVAR ) = .TRUE.
                     ELSEIF (DESID_AREA_NML( IAREA )%AREA .EQ. 'FALSE' ) THEN
                         DESID_EMVAR( ISRM )%LAREA( IEMVAR ) = .FALSE.
                     END IF
                     ! Override Area Adjustment if Requested
                     IF ( DESID_AREA_NML( IAREA )%ADJ .EQ. 'TRUE' ) THEN
                         DESID_EMVAR( ISRM )%LAREAADJ( IEMVAR ) = .TRUE.
                     ELSEIF (DESID_AREA_NML( IAREA )%ADJ .EQ. 'FALSE' ) THEN
                         DESID_EMVAR( ISRM )%LAREAADJ( IEMVAR ) = .FALSE.
                     END IF
                  END DO
               END IF
            END DO

         END DO
 
! Write Out All Available Stream Families to the Log File
         CALL LOG_SUBHEADING( LOGDEV, 'Emission Stream Families' )
         WRITE( LOGDEV,'(8x,A19,15x,A)' ),'Stream Family Label','Stream Family Members'
         WRITE( LOGDEV,'(8x,A19,15x,A)' ),'-------------------','---------------------'
         DO IFAM = 1,DESID_N_STREAM_FAMS
            WRITE( LOGDEV,'(8x,A32,2x,A)' ), STREAMFAMILYNAME( IFAM ), 
     &             STREAMFAMILYMEMBERS( IFAM,1 )
            IF ( STREAMFAMILYNUM( IFAM ) .GT. 1 ) THEN
                DO ISRM = 2,STREAMFAMILYNUM( IFAM )
                   WRITE( LOGDEV,'(42x,A)' ), STREAMFAMILYMEMBERS( IFAM,ISRM )
                END DO
            END IF
         END DO

! Write Out All Available Species Families to the Log File
         CALL LOG_SUBHEADING( LOGDEV, 'Chemical Species and Emission Variable Families')
         WRITE( LOGDEV,'(8x,A20,14x,A)' ),'Species Family Label','Species Family Members'
         WRITE( LOGDEV,'(8x,A20,14x,A)' ),'--------------------','---------------------'
         DO IFAM = 1,N_CHEM_FAMS
            WRITE( LOGDEV,'(8x,A32,2x,A)' ), CHEMFAMILYNAME( IFAM ), 
     &             CHEMFAMILYMEMBERS( IFAM,1 )
            IF ( CHEMFAMILYNUM( IFAM ) .GT. 1 ) THEN
                DO ISRM = 2,CHEMFAMILYNUM( IFAM )
                   WRITE( LOGDEV,'(42x,A)' ), CHEMFAMILYMEMBERS( IFAM,ISRM )
                END DO
            END IF
         END DO

! Set up Stream <-> Size Distribution relationship. This routine
! populates the DESID_STREAM_AERO structure which tells the logic below which
! modes are present on which streams.
         CALL LOG_SUBHEADING( LOGDEV, 'Mapping Particle Size Distributions to Each Emission Stream')
         CALL DESID_INIT_SIZE_DIST( JDATE, JTIME )

! Process Default Emissions Mapping (if requested in namelist; i.e. 
         ALLOCATE( LOCAL_SPEC( NI0 ) )                            ! CMAQ Species Names
         ALLOCATE( LOCAL_EMVAR( NI0,DESID_N_SRM ) )               ! Emission Variable Names
         ALLOCATE( LOCAL_FAC ( NI0,DESID_N_SRM,N_SCALEFAC ) )     ! Scale Factor
         ALLOCATE( LOCAL_FAC_BULK( NI0,DESID_N_SRM,N_SCALEFAC ) ) ! Bulk Scale Factor For Printing to Diagnostic
         ALLOCATE( LOCAL_OP( NI0,DESID_N_SRM,N_SCALEFAC ) )       ! Operator for scaling rule
         ALLOCATE( LOCAL_REG( NI0,DESID_N_SRM,N_SCALEFAC ) )      ! Region Index
         ALLOCATE( LOCAL_BASIS ( NI0,DESID_N_SRM,N_SCALEFAC ) )   ! Mass or Mole Basis for Conversion
         ALLOCATE( LOCAL_CONV ( NI0,DESID_N_SRM,N_SCALEFAC ) )    ! Conversion Factor
         ALLOCATE( MAP_ISTRtoDIFF( NI0 ) )                        ! Map from Instruction to Dispersed species 
         ALLOCATE( MAP_ISTRtoEMVAR(NI0,DESID_N_SRM ) )            ! Map from Instruction to Emission Variable  
         ALLOCATE( MAP_ISTRtoGAS( NI0 ) )                         ! Map from Instruction to Gas Index
         ALLOCATE( MAP_ISTRtoAERO( NI0 ) )                        ! Map from Instruction to Aerosol Index 
         ALLOCATE( MAP_ISTRtoMODE( NI0 ) )                        ! Map from Instruction to Aerosol Mode
         ALLOCATE( MAP_ISTRtoNUM ( NI0 ) )                        ! Map from Instruction to Number Index
         ALLOCATE( MAP_ISTRtoSRF ( NI0 ) )                        ! Map from Instruction to Surface Area Index
         ALLOCATE( MAP_ISTRtoSD  ( NI0,DESID_N_SRM ) )            ! Map from Instruction to Size Distribution Ref
         ALLOCATE( DESID_STREAM_DIFF( N_SPC_DIFF,DESID_N_SRM ) )    
         
         LOCAL_SPEC = ""
         LOCAL_EMVAR = ""
         LOCAL_FAC = 0.0
         LOCAL_FAC_BULK = 0.0      !   Output. Ignores aero_split and unit conversion
         LOCAL_OP = ""             !   Output. Ignores aero_split and unit conversion
         LOCAL_REG = 1             !   Output. Ignores aero_split and unit conversion
         LOCAL_BASIS = ""
         LOCAL_CONV = 1.0
         MAP_ISTRtoDIFF = 0        !   to Diffusion Vector
         MAP_ISTRtoEMVAR= 0        !   to EMission Variabl Location on File
         MAP_ISTRtoGAS = 0         !   to aerosol table
         MAP_ISTRtoAERO = 0        !   to aerosol table
         MAP_ISTRtoMODE = 0        !   to CMAQ aerosol mode
         MAP_ISTRtoNUM  = 0        !   to aerosol number
         MAP_ISTRtoSRF  = 0        !   to aerosol surface area
         MAP_ISTRtoSD  = 0         !   to emissions aerosol mode
         DESID_STREAM_DIFF = .FALSE.

         ! Find all matches between the transported species list and the
         ! available variables from each stream. Apply a scale factor
         ! of 1 to these matches. For aerosols, the CMAQ species name
         ! may or may not include the mode suffix (eg. i, j, or k).
         ! Equivalence tests should be performed without a suffix on the
         ! variable name and with each suffix added in turn.

         DESID_N_ISTR = 0
         SPECNAME = ''

! Insert Emissions Instructions for Aerosol Number and Surface Area,
! if at least one aerosol species is being transported
         IF ( COUNT( DIFF_MASK_AERO ) .GT. 0 ) THEN
            DO IM = 1,N_MODE
               ! Aerosol Number
               LOCAL_SPEC( DESID_N_ISTR+1 ) = AEROMODE( IM )%NUM_NAME
               LOCAL_FAC ( DESID_N_ISTR+1,:,1 ) = 1.0
               LOCAL_FAC_BULK ( DESID_N_ISTR+1,:,1 ) = 1.0         
               LOCAL_BASIS( DESID_N_ISTR+1,:,1 ) = 'UNIT'
               LOCAL_CONV( DESID_N_ISTR+1,:,1 ) = 1.0
               LOCAL_OP ( DESID_N_ISTR+1,:,1 ) = "a"
               LOCAL_REG ( DESID_N_ISTR+1,:,1 ) = 1
               MAP_NUMtoISTR( IM ) = DESID_N_ISTR+1
               MAP_ISTRtoNUM( DESID_N_ISTR+1 ) = IM
               MAP_ISTRtoDIFF( DESID_N_ISTR+1 ) = 
     &            INDEX1( LOCAL_SPEC( DESID_N_ISTR+1 ), N_SPC_DIFF, DIFF_SPC )
               DESID_STREAM_DIFF( MAP_ISTRtoDIFF( DESID_N_ISTR+1 ),: ) = .TRUE.
               MAP_ISTRtoSD( DESID_N_ISTR+1, : ) = 0

               ! Aerosol Surface Area
               LOCAL_SPEC( DESID_N_ISTR+2 ) = AEROMODE( IM )%SRF_NAME
               LOCAL_FAC ( DESID_N_ISTR+2,:,1 ) = 1.0
               LOCAL_FAC_BULK ( DESID_N_ISTR+2,:,1 ) = 1.0         
               LOCAL_BASIS( DESID_N_ISTR+2,:,1 ) = 'UNIT'
               LOCAL_CONV( DESID_N_ISTR+2,:,1 ) = 1.0
               LOCAL_OP ( DESID_N_ISTR+2,:,1 ) = "a"
               LOCAL_REG ( DESID_N_ISTR+2,:,1 ) = 1
               MAP_SRFtoISTR( IM ) = DESID_N_ISTR+2
               MAP_ISTRtoSRF( DESID_N_ISTR+2 ) = IM
               MAP_ISTRtoDIFF( DESID_N_ISTR+2 ) = 
     &            INDEX1( LOCAL_SPEC( DESID_N_ISTR+2 ), N_SPC_DIFF, DIFF_SPC )
               DESID_STREAM_DIFF( MAP_ISTRtoDIFF( DESID_N_ISTR+2 ),: ) = .TRUE.
               MAP_ISTRtoSD( DESID_N_ISTR+2, : ) = 0

               DESID_N_ISTR = DESID_N_ISTR + 2
            END DO
         END IF

! Process User-Defined Emissions Scaling Rules. 
         CALL LOG_SUBHEADING( LOGDEV, 'Reading and Storing Emission Scaling Rules' )

         ! Find Total Number of Rules
         N_RULE = 0
         DO IRULE = 1,SIZE( DESID_RULES_NML )
            IF( DESID_RULES_NML( IRULE )%SPEC .EQ. '' ) EXIT
            N_RULE = IRULE
         END DO

         ! Implement Online Scaling Rules that are less exposed to users
         CALL DESID_GET_ONLINE_RULES( N_RULE )


         ! Allocate Rule->Instruction Transform Masks
         ALLOCATE( RULE_SPEC  ( N_SPC_DIFF ) )
         ALLOCATE( RULE_EMVAR ( DESID_N_SRM ) )
         ALLOCATE( RULE_PHASE ( DESID_N_SRM ) )
         DO ISRM = 1,DESID_N_SRM
           N = DESID_EMVAR( ISRM )%LEN
           RULE_EMVAR( ISRM )%LEN = N
           ALLOCATE( RULE_EMVAR( ISRM )%ARRY( N ) )

           N = DESID_STREAM_AERO( ISRM )%LEN
           RULE_PHASE( ISRM )%LEN = N
           ALLOCATE( RULE_PHASE( ISRM )%ARRY( N ) )
         END DO
 
         ! Loop Through Emission Rules, Test for Fidelity, expand if necessary
         ! and Apply them to the instruction set that currently exists.
         DO IRULE = 1,N_RULE 
            ! Exit this loop if the rule is blank
            IF ( DESID_RULES_NML( IRULE )%SPEC .EQ. '' ) EXIT 

            ! Expand Rule To Individual Instructions. If the CMAQ
            ! Species, Stream Label, and Em. Variable are all single
            ! components, then there will just be one instruction. If
            ! any of them equal 'All' the number of instructions will
            ! grow correspondingly.

            !------   ------   ------   ------   ------   ------   -----
            ! First error check and expand the stream field
            ! This subroutine returns a logical vector, RULE_STREAM,
            ! which identifies which streams are affected by this rule.
            LREMOVE = .FALSE.
            CALL DESID_GET_RULE_STREAMS( DESID_RULES_NML( IRULE )%STREAM, 
     &              IRULE, RULE_STREAM, LREMOVE, LERROR4 )
            IF ( LREMOVE ) CYCLE

            !------   ------   ------   ------   ------   ----  
            ! Now error check and expand the emission variable field
            CALL UPCASE( DESID_RULES_NML( IRULE )%EMVAR )
 
            !Initialize Emission Variable Array for every Stream
            DO ISRM = 1,DESID_N_SRM
              RULE_EMVAR( ISRM )%ARRY = .FALSE.
            END DO
            LEMVAR_KEY = .FALSE.

            LERROR = .TRUE.
            IF ( DESID_RULES_NML( IRULE )%EMVAR .EQ. 'ALL' ) THEN
               ! Expand the Rule to Apply to All Emission Variables
               DO ISRM = 1,DESID_N_SRM
                 IF ( .NOT. RULE_STREAM( ISRM ) ) CYCLE
                 RULE_EMVAR( ISRM )%ARRY = .TRUE.
                 LEMVAR_KEY = .TRUE.
                 LERROR = .FALSE.
               END DO
            ELSE
               ! Determine if the Emission Variable Label Refers to A 
               ! Family and if So, Apply the Rule to all members of that 
               ! Family
               IFAM = INDEX1( DESID_RULES_NML( IRULE )%EMVAR, N_Chem_Fams, ChemFamilyName )
               IAERO = 0
               IF ( IFAM .GT. 0 ) 
     &            IAERO= INDEX1( ChemFamilyName(IFAM), N_AEROSPC, AEROSPC(:)%BULKNAME )
               IF ( IFAM .EQ. 0 .OR. IAERO .NE. 0 ) THEN
                  ! This Emission Variable Label Does not match any families or this is an
                  ! aerosol bulkname. Just look for one variable
                  DO ISRM = 1,DESID_N_SRM
                     IF ( .NOT.RULE_STREAM( ISRM ) ) CYCLE
                     IDX = INDEX1( DESID_RULES_NML( IRULE )%EMVAR, DESID_EMVAR( ISRM )%LEN, 
     &                             DESID_EMVAR( ISRM )%ARRY )
                     IF ( IDX .NE. 0 ) THEN
                        ! A matching Emission variable has been found
                        RULE_EMVAR( ISRM )%ARRY( IDX ) = .TRUE.
                        LERROR = .FALSE.
                     END IF
                 END DO
               END IF

               IF ( IFAM .NE. 0 .AND. IAERO .EQ. 0 ) THEN
                  ! This is not an aerosol bulkname. Loop through all the 
                  ! members to assign emission variables
                  NCHEM = ChemFamilyNum( IFAM )
                  CHEM_NAME(1:NCHEM) = ChemFamilyMembers( IFAM,1:NCHEM )
                  LEMVAR_KEY = .TRUE.
               
                  DO ICHEM = 1,NCHEM
                     LERROR3( ICHEM ) = .FALSE.
                     LERROR2 = .TRUE.
                     DO ISRM = 1,DESID_N_SRM
                        IF ( .NOT. RULE_STREAM( ISRM ) ) CYCLE
                        ! Find the Specific Species this Rule Identifies
                        IDX = INDEX1( CHEM_NAME( ICHEM ), DESID_EMVAR( ISRM )%LEN, 
     &                                DESID_EMVAR( ISRM )%ARRY )
                        IF ( IDX .NE. 0 ) THEN
                           RULE_EMVAR( ISRM )%ARRY( IDX ) = .TRUE.
                           LERROR2 = .FALSE.
                        END IF
                     END DO
                     IF ( LERROR2 ) THEN
                         ! Store the index of the variables not found on
                         ! any emission stream.
                         LERROR3( ICHEM ) = .TRUE.
                     END IF
                  END DO 
                  IF ( .NOT. ANY( LERROR3 ) ) LERROR = .FALSE.
               END IF
               
            END IF
            
            IF ( LERROR ) THEN
              IF ( .NOT. EMISCHK ) THEN
                 WRITE( LOGDEV, '(/,5x,A,/,5x,2A,/,5x,3A,3(/,5x,A))') 
     &                  '*** ATTENTION **********************************************:',
     &                  'The emission variable or member of family ',TRIM( DESID_RULES_NML( IRULE )%EMVAR ),
     &                  'was not found in the emission stream(s) ',TRIM(DESID_RULES_NML(IRULE)%STREAM),'  but the ',
     &                  'CTM_EMISCHK environment variable set to False so simulation ',
     &                  'will proceed.',
     &                  '*************************************************************'
                 IF ( IFAM .NE. 0 ) THEN
                    WRITE( LOGDEV, '(7x,A,/,7x,A,/,7x,A,1x,A )') 
     &                  'The emission variable field applied was a chemical family. The specific',
     &                  'family member(s) that did not appear on requested emission stream(s)',
     &                  'inputs was:'
                    DO ICHEM = 1,NCHEM
                        IF ( LERROR3( ICHEM ) ) WRITE( LOGDEV, '(20x,A)' ) TRIM( CHEM_NAME( ICHEM ) )
                    END DO
                    WRITE( LOGDEV, '(7x,A)' )
     &                  '*************************************************************'
                 END IF
                 CYCLE
              ELSE     
                 WRITE( LOGDEV, '(5x,A,/,5x,2A,/,5x,3A,7(/,5x,A))') 
     &                  '*** ERROR **************************************************************:',
     &                  'The emission variable or member of family ',TRIM( DESID_RULES_NML( IRULE )%EMVAR ),
     &                  ' is not found on the stream(s) ',TRIM(DESID_RULES_NML(IRULE)%STREAM),'.',
     &                  'Use one of the below options to continue.', 
     &                  '1) Change or remove this emission rule so that it refers to an existing emission variable.', 
     &                  'or',
     &                  '2) Change CTM_EMISCHK environment variable to False (F) in the runscript',
     &                  'if model predictions are acceptable without using the above emissions.',
     &                  '*************************************************************************'
                 IF ( IFAM .NE. 0 ) THEN
                    WRITE( LOGDEV, '(7x,A,/,7x,A,/,7x,A,1x,A )') 
     &                  'The emission variable field applied was a chemical family. The specific',
     &                  'family member(s) that did not appear on requested emission stream(s)',
     &                  'inputs was:'
                    DO ICHEM = 1,NCHEM
                        IF ( LERROR3( ICHEM ) ) WRITE( LOGDEV, '(20x,A)' ) TRIM( CHEM_NAME( ICHEM ) )
                    END DO
                    WRITE( LOGDEV, '(7x,A)' )
     &                  '*************************************************************'
                 END IF
                 XMSG = 'Species with the missing emission variable ' 
     &                //'must have a variable found in at least one stream.'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
              END IF
            END IF
 
            !------   ------   ------   ------   ------   ------
            ! Now Error Check and Expand the CMAQ Species Field
            CALL UPCASE( DESID_RULES_NML( IRULE )%SPEC )

            ! Initialize CMAQ Species Array
            RULE_SPEC = .FALSE.
            LSPEC_KEY = .FALSE.

            IF ( DESID_RULES_NML( IRULE )%SPEC .EQ. 'ALL' ) THEN
               ! Expand the Rule to Apply to All Species
               RULE_SPEC = .TRUE.
               LSPEC_KEY = .TRUE.
            ELSE     
               ! Determine if the Species Label Refers to A Family and if So, 
               ! Apply the Rule to all members of that Family
               IFAM = INDEX1( DESID_RULES_NML( IRULE )%SPEC, N_Chem_Fams, ChemFamilyName )
               IF ( IFAM .EQ. 0 ) THEN
                  NCHEM = 1
                  CHEM_NAME(1) = DESID_RULES_NML( IRULE )%SPEC
               ELSE
                  NCHEM = ChemFamilyNum( IFAM )
                  CHEM_NAME(1:NCHEM) = ChemFamilyMembers( IFAM,1:NCHEM )
                  LSPEC_KEY = .TRUE.
               END IF

               DO ICHEM = 1,NCHEM
                 ! Find the Specific Species this Rule Identifies
                 IDX = INDEX1( CHEM_NAME( ICHEM ), N_SPC_DIFF, DIFF_SPC )
                 JDX = INDEX1( CHEM_NAME( ICHEM ), N_AEROSPC,  AEROSPC( : )%BULKNAME )
                 IF ( IDX .NE. 0 ) THEN
                   RULE_SPEC( IDX ) = .TRUE.
                 ELSE IF ( JDX .NE. 0 ) THEN
                   ! This is an aerosol species, and it is being
                   ! identified with a bulk name (no mode suffix). 
                   ! We need to allow for all possible DIFF_SPC with
                   ! all used suffixes
                   SN = CHEM_NAME( ICHEM )
                   DO IM = 1,N_MODE
                     KDX = INDEX1( TRIM( SN )//MODESUFF( IM ), N_SPC_DIFF, DIFF_SPC )
                     IF ( KDX .NE. 0 ) RULE_SPEC( KDX ) = .TRUE.
                   END DO
                 ELSE
                   WRITE( LOGDEV, '(/,5A,/,A,/,A,/,A,/,A)' ),
     &               'Species ',TRIM(DESID_RULES_NML( IRULE )%SPEC),':',
     &               TRIM(CHEM_NAME(ICHEM)),' was used in the Emissions',
     &               ' Control Instructions Namelist but it is not a valid CMAQ ',
     &               'transported species or family. Please add it to one of the ',
     &               'input chemical namelists (ie. GC, AE, etc). Note that aerosol',
     &               'Number and Surface Area Species are not valid for scaling.'
                   XMSG = 'Error in Emissions Map Processing.'
                   CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                 END IF
               END DO
           END IF 
 
            !------   ------   ------   ------   ------   ------
            ! Now Error Check and Expand the Phase Field
            CALL UPCASE( DESID_RULES_NML( IRULE )%PHASE )

            !Initialize Emission Variable Array for every Stream
            DO ISRM = 1,DESID_N_SRM
              RULE_PHASE( ISRM )%ARRY = .FALSE.
            END DO

            LERROR = .TRUE.
            DO ISRM = 1,DESID_N_SRM 
              ! Skip this stream if it is not identified
              IF ( .NOT. RULE_STREAM( ISRM ) ) CYCLE 

              IF ( DESID_RULES_NML( IRULE )%PHASE .EQ. 'ALL' ) THEN
                 ! Expand the Rule to Apply to All Phases and Modes
                 RULE_PHASE( ISRM )%ARRY = .TRUE.
                 LERROR = .FALSE.
              ELSE IF ( DESID_RULES_NML( IRULE )%PHASE .EQ. 'AERO' ) THEN
                 ! Expand the Rule to Apply to All Aerosol Modes
                 RULE_PHASE( ISRM )%ARRY(2:) = .TRUE.
                 LERROR = .FALSE.
              ELSE
                 ! Find the Specific Phase/Mode this Rule Identifies
                 IDX = INDEX1( DESID_RULES_NML( IRULE )%PHASE, DESID_STREAM_AERO( ISRM )%LEN, 
     &                         DESID_STREAM_AERO( ISRM )%NAME )
                 IF ( IDX .NE. 0 ) THEN
                   RULE_PHASE( ISRM )%ARRY( IDX ) = .TRUE.
                   LERROR = .FALSE.
                 END IF
              END IF
            END DO
            
            IF ( LERROR ) THEN
                 WRITE( LOGDEV, '(A,/,2A,/,A,/,A,I3,A1,/,A)') 
     &                  '*****************************ERROR***************************************:',
     &                  'The phase or mode ',TRIM( DESID_RULES_NML( IRULE )%PHASE ),
     &                  ' is not found in any of the emission streams you are requesting for ',
     &                  'emission rule ',IRULE,'.',
     &                  '*************************************************************************'
                 WRITE( LOGDEV, * )
                 XMSG = 'Species with the missing mode ' 
     &                //'must have a mode found in at least one stream.'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
 
            !------   ------   ------   ------   ------   ------
            ! Now Error Check the Region Field
            CALL UPCASE( DESID_RULES_NML( IRULE )%REGION )

            ! Check that the Region has been defined
            LERROR = .TRUE.
            DO IRGN = 1,DESID_N_REG 
              IF ( DESID_RULES_NML( IRULE )%REGION .EQ. 
     &             DESID_REG( IRGN )%LABEL ) THEN 
                 REGNUM = IRGN
                 LERROR = .FALSE.
              END IF
            END DO
            
            IF ( LERROR ) THEN
                 WRITE( LOGDEV, '(A,/,2A,/,A,/,A,/,A)') 
     &                  '*****************************ERROR***************************************:',
     &                  'The Region ',TRIM( DESID_RULES_NML( IRULE )%REGION ),
     &                  ' is not found in any of the regions defined',
     &                  ' in the Emission Control File.',
     &                  '*************************************************************************'
                 WRITE( LOGDEV, * )
                 XMSG = 'Regions used in the Emissions Scaling must ' 
     &                //'be defined on the Emission Control File.'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
 
            !------   ------   ------   ------   ------
            ! Check the Operation Identifier for errors
            IF ( DESID_RULES_NML( IRULE )%OP .NE. 'a' .AND.
     &           DESID_RULES_NML( IRULE )%OP .NE. 'm' .AND.
     &           DESID_RULES_NML( IRULE )%OP .NE. 'o'       ) THEN
               WRITE( LOGDEV, * )
               WRITE( XMSG, '(/,A,A,A,I3,A,A,A)' ),
     &             'The Emissions Operator (',DESID_RULES_NML( IRULE )%OP,
     &             ') applied for Rule ',IRULE,' in the Emissions Control ',
     &             'Namelist does not match any of the allowed values (a, m, or o)',
     &             '. Please check the your emissions control inputs.'
               WRITE( LOGDEV, * )TRIM( XMSG )
               XMSG = 'Error in Emissions Map Processing.'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            
            !------   ------   ------   ------   ------   ------ ------
            ! Order the indivdual tasks in this rule into one
            ! vector of instructions. The operator, scale factor, and
            ! region for each of these tasks will be uniform because 
            ! they apply to the entire rule
            N_TASKS = 0
            DO IDIFF = 1,N_SPC_DIFF
            IF ( RULE_SPEC( IDIFF ) ) THEN
              DO ISRM = 1,DESID_N_SRM
              IF ( RULE_STREAM( ISRM ) ) THEN
                DO IEMVAR = 1,DESID_EMVAR( ISRM )%LEN 
                IF ( RULE_EMVAR( ISRM )%ARRY( IEMVAR ) ) THEN
                  DO ISD = 1,DESID_STREAM_AERO( ISRM )%LEN
                  IF ( RULE_PHASE( ISRM )%ARRY( ISD ) ) THEN

                    LTEST = .TRUE.
                    
                    ! If this task applies to a Gas CMAQ species, make
                    ! sure the aerosol phases are not invoked so that 
                    ! double-counting is avoided
                    IF ( .NOT. DIFF_MASK_AERO( IDIFF ) .AND. 
     &                   DESID_STREAM_AERO( ISRM )%NAME( ISD ) .NE. 'GAS' )
     &                 LTEST = .FALSE.

                    ! If this task applies to an aerosol CMAQ species,
                    ! then make sure that the 'mode' selection will apply
                    ! mass to this CMAQ species, DIFF_SPC( IDIFF ).
                    ! Because CMAQ species are resolved in modes, it
                    ! could be that this 'mode' selection will not put
                    ! any mass in this species. For example, if this
                    ! species is for the Aitken mode, but the selection
                    ! was meant to populate the coarse mode.
                    IF ( DIFF_MASK_AERO( IDIFF ) ) THEN
                        DO IAERO = 1,N_AEROSPC
                           IM = INDEX1( DIFF_SPC( IDIFF ), N_MODE,
     &                                  AEROSPC( IAERO )%NAME( : ) )
                           IF ( IM .GT. 0 ) THEN
                             IF ( DESID_STREAM_AERO( ISRM )%FACNUM( ISD,IM ) 
     &                              .LE. 1.0e-10 ) LTEST = .FALSE.
                           END IF
                        END DO
                    END IF

                    ! If any family name was used for the Emission Variable 
                    ! and Species fields and those family or keyword
                    ! names match, then only exact matches or existing 
                    ! relationships should be populated.
                    IF ( (LEMVAR_KEY .AND. LSPEC_KEY ) .AND.
     &                   (DESID_EMVAR( ISRM )%ARRY( IEMVAR ) .NE. 
     &                      DIFF_SPC( IDIFF ) ) ) THEN
                      ! Look for this relationship in at least one
                      ! of the existing instructions
                      LTEST = .FALSE.
                      DO ISTRN = 1,DESID_N_ISTR
                          IF ( LOCAL_SPEC( ISTRN ) .EQ. DIFF_SPC( IDIFF ) .AND.
     &                         LOCAL_EMVAR( ISTRN,ISRM ) .EQ. 
     &                           DESID_EMVAR( ISRM )%ARRY( IEMVAR ) ) THEN
                            LTEST = .TRUE.
                          END IF
                      END DO
                    END IF

                    ! Add a Task for this combination of CMAQ
                    ! Species, Stream, Em. Variable, and Phase 
                    ! if the test for validity (LTEST) is still 
                    ! TRUE
                    IF ( LTEST ) THEN
                      N_TASKS = N_TASKS + 1
                      TASK_IDIFF( N_TASKS ) = IDIFF
                      TASK_ISRM ( N_TASKS ) = ISRM
                      TASK_IEMVAR(N_TASKS ) = IEMVAR
                      TASK_SPEC ( N_TASKS ) = DIFF_SPC( IDIFF )
                      TASK_EMVAR( N_TASKS ) = DESID_EMVAR(ISRM)%ARRY(IEMVAR)
                      TASK_PHASE( N_TASKS ) = ISD
                    END IF
                  END IF
                  END DO
                END IF
                END DO
              END IF
              END DO
            END IF
            END DO
            
            !------   ------   ------   ------   ------   ------
            ! Modify the Emissions Instruction Set Based on this Rule
            IF ( DESID_RULES_NML( IRULE )%OP .EQ. 'a' ) THEN
               ! Add this rule to existing instructions
               DO IC = 1,N_TASKS
                  ! This entry needs to be created, but first we need
                  ! to check whether to add it as a new row or add it
                  ! to a previous row. We can add to a previous row
                  ! if the CMAQ species matches exactly, there is no 
                  ! em. var present for this stream, and the same
                  ! Emissions Variable is being used for another 
                  ! stream.
                  LFOUND = .FALSE.
                  ! Look For a suitable previous instruction to add to.
                  IF ( DESID_N_ISTR .GT. 0 ) THEN
                  DO ISTRN = 1,DESID_N_ISTR
                    IF ( ! The CMAQ species for this instruction matches
                         ! the CMAQ species in the rule
     &                   LOCAL_SPEC( ISTRN ) .EQ. TASK_SPEC( IC ) .AND.
                         ! The instruction emission file variable
                         ! matches that of the rule
     &                   ( ( LOCAL_EMVAR( ISTRN, TASK_ISRM( IC ) ) .EQ.
     &                       TASK_EMVAR( IC ) ) .OR.
                         ! The instruction has no emission file variable assigned 
                         ! yet and one is available on this stream.
     &                   ( LOCAL_EMVAR( ISTRN, TASK_ISRM( IC ) ) .EQ. '' .AND.
     &                   ANY( LOCAL_EMVAR( ISTRN,: ) .EQ. TASK_EMVAR( IC ))) )
     &                 ) THEN
                      ! Add This Command to Instruction number ISTR
                      ISTR = ISTRN
                      LFOUND = .TRUE.
                    END IF
                  END DO
                  END IF

                  ! If no suitable instruction was found to add to, add a new
                  ! instruction. This means either there was no previous
                  ! instruction with the same CMAQ species and emission variable 
                  ! or there was an instruction with this CMAQ species but it 
                  ! already had an emission variable and scale factor associated 
                  ! with this stream.
                  IF ( .NOT. LFOUND ) THEN
                    DESID_N_ISTR = DESID_N_ISTR + 1
                    ISTR = DESID_N_ISTR

                    LOCAL_SPEC( ISTR )     = TASK_SPEC( IC )
                    MAP_ISTRtoDIFF( ISTR ) = TASK_IDIFF( IC )

                    ! Link this row to the Aerosol or Gas Species
                    IF ( DIFF_MASK_AERO( TASK_IDIFF( IC ) ) ) THEN
                      DO IAERO = 1,N_AEROSPC
                        JM = INDEX1( LOCAL_SPEC( ISTR ), N_MODE, AEROSPC( IAERO )%NAME( : ) )
                        IF ( JM .GT. 0 ) THEN
                          MAP_ISTRtoAERO( ISTR ) = IAERO
                          MAP_ISTRtoMODE( ISTR ) = JM
                        END IF
                      END DO
                    ELSE
                      MAP_ISTRtoGAS( ISTR ) = TASK_IDIFF( IC )
                    END IF
                  END IF
                          
                  ! Now that the instruction location has either been
                  ! found or created, populate it.
                  ISRM   = TASK_ISRM( IC )
                  IEM    = DESID_STREAM_AERO( ISRM )%REF( TASK_PHASE( IC ) )
                  IEMVAR = TASK_IEMVAR( IC )
                    
                  LOCAL_EMVAR( ISTR, ISRM )    = TASK_EMVAR( IC )
                  MAP_ISTRtoEMVAR( ISTR, ISRM ) = IEMVAR
                  DESID_EMVAR( ISRM )%USED( IEMVAR ) = .TRUE.
                  MAP_ISTRtoSD( ISTR, ISRM )         = TASK_PHASE( IC )
                  DESID_STREAM_DIFF( TASK_IDIFF( IC ),ISRM ) = .TRUE.

                  ! Only apply an aerosol size-split parameter if this
                  ! species is an aerosol and if it is not from a dust 
                  ! or sea spray sector
                  AERO_SPLIT = 1.0
                  IF ( DIFF_MASK_AERO( TASK_IDIFF( IC ) ) .AND. 
     &                 ISRM .NE. IDUSTSRM .AND. ISRM .NE. ISEASRM    )
     &                 AERO_SPLIT = SD_SPLIT( TASK_IDIFF( IC ), IEM )

                  ! Determine Next Free Location in Scale Factor Space
                  ! (IFAC) so that the scale factor can be added.
                  DO IFAC = 1,N_SCALEFAC
                      IF ( LOCAL_OP( ISTR, ISRM, IFAC ) .EQ. '' ) THEN

                        CALL CHECK_OP( DESID_RULES_NML( IRULE )%OP, IRULE )
                        CALL CHECK_BASIS( DESID_RULES_NML( IRULE )%BASIS, IRULE )

                        LOCAL_FAC ( ISTR, ISRM, IFAC ) = DESID_RULES_NML( IRULE)%FAC * AERO_SPLIT
                        LOCAL_FAC_BULK(ISTR,ISRM,IFAC )= DESID_RULES_NML( IRULE)%FAC
                        LOCAL_REG( ISTR, ISRM, IFAC )  = REGNUM
                        LOCAL_OP( ISTR, ISRM, IFAC )   = DESID_RULES_NML( IRULE)%OP
                        LOCAL_BASIS( ISTR, ISRM, IFAC )= DESID_RULES_NML( IRULE)%BASIS
                        LOCAL_CONV ( ISTR, ISRM, IFAC )= DESID_EMVAR( ISRM )%CONV( IEMVAR )
                        EXIT
                     END IF
                  END DO
               END DO
            ELSE
               ! Modify All Existing Instructions that Match this
               ! rule's parameters.
               DO IC = 1,N_TASKS
                 ! Loop through existing instructions and find matches
                 IF ( DESID_N_ISTR .GT. 0 ) THEN
                   ISRM = TASK_ISRM( IC )
                   DO ISTR = 1,DESID_N_ISTR
                   IF ( LOCAL_SPEC( ISTR ) .EQ. TASK_SPEC( IC ) ) THEN
                      IF ( LOCAL_EMVAR( ISTR, ISRM ) .EQ. TASK_EMVAR( IC ) .AND.
     &                     MAP_ISTRtoSD( ISTR,ISRM ) .EQ. TASK_PHASE( IC ) ) THEN
                  
                        IEMVAR = TASK_IEMVAR( IC )
                        IEM = DESID_STREAM_AERO( ISRM )%REF( TASK_PHASE( IC ) )
                        AERO_SPLIT = 1.0
                        IF ( DIFF_MASK_AERO( TASK_IDIFF( IC ) ) .AND.
     &                       DESID_RULES_NML( IRULE )%OP .EQ. 'o' ) 
     &                       AERO_SPLIT = SD_SPLIT( TASK_IDIFF( IC ), IEM )

                        ! Determine Next Free Location in Scale Factor Space (IFAC) so 
                        ! that the scale factor can be added.
                        DO IFAC = 1,N_SCALEFAC
                          IF ( LOCAL_OP( ISTR, ISRM, IFAC ) .EQ. '' ) THEN

                             CALL CHECK_OP( DESID_RULES_NML( IRULE )%OP, IRULE )
                             CALL CHECK_BASIS( DESID_RULES_NML( IRULE )%BASIS, IRULE )

                             LOCAL_FAC ( ISTR, ISRM, IFAC )      = DESID_RULES_NML( IRULE )%FAC * AERO_SPLIT
                             LOCAL_FAC_BULK ( ISTR, ISRM, IFAC ) = DESID_RULES_NML( IRULE )%FAC
                             LOCAL_REG( ISTR, ISRM, IFAC )       = REGNUM
                             LOCAL_OP( ISTR, ISRM, IFAC )        = DESID_RULES_NML( IRULE )%OP
                             LOCAL_BASIS( ISTR, ISRM, IFAC )     = DESID_RULES_NML( IRULE )%BASIS
                             LOCAL_CONV( ISTR, ISRM, IFAC )      = DESID_EMVAR( ISRM )%CONV( IEMVAR )
                             EXIT
                          END IF
                        END DO
 
                      END IF
                   END IF
                   END DO
                 ELSE
                   WRITE( LOGDEV, '(5(/,A))' ),
     &              'ATTENTION: The emissions control file is ',
     &              'attempting to modify an existing instruction, but ',
     &              'there are no compatible existing instructions. ',
     &              'Please check the configuration of the emission ',
     &              'control file.'
                 END IF
               END DO
            END IF  ! Operator
         END DO !IRULE

         ! Create Summarized Emission Scale Factor Structure that
         ! can be processed in the Emiss_Scaling subroutine every time
         ! step
         ALLOCATE( DESID_FAC( DESID_N_ISTR,DESID_N_SRM ) )
         ALLOCATE( REG_UNQ( N_SCALEFAC ) )
         ALLOCATE( DESID_REG_RMDR( 1000 ) )
         N_REG_RMDR = 0
         ALLOCATE( RMDR_MASK( NCOLS,NROWS ))
         ALLOCATE( LSUB( DESID_N_REG ) )

         DO ISTR = 1,DESID_N_ISTR
            DO ISRM = 1,DESID_N_SRM
               DESID_FAC( ISTR,ISRM )%NFAC = 0
               IF ( MAP_ISTRtoEMVAR( ISTR,ISRM ) .NE. 0 ) THEN

               ! First determine number of emission scale factors (NFAC) and
               ! number of unique regions (NREG) that are specified for this 
               ! instruction and stream combination
               NFAC = 1
               NREG = 1
               REG_UNQ(:) = 1
               DO IFAC = 2,N_SCALEFAC
                 IF ( LOCAL_OP( ISTR,ISRM,IFAC ) .EQ. '' ) EXIT
                 NFAC = NFAC + 1 
               
                 ! Determine whether the region for this factor is
                 ! unique for this combination of ISTR and ISRM
                 IF ( COUNT( REG_UNQ(1:NREG) .eq. 
     &                       LOCAL_REG( ISTR,ISRM,IFAC ) ) .eq. 0 ) THEN
                   NREG = NREG + 1
                   REG_UNQ( NREG ) = LOCAL_REG( ISTR,ISRM,IFAC )
                 END IF
               END DO

               ! Determine if two active regions contain one or more 
               ! identical Sub-Regions. If they do, then add that common
               ! sub-region as an active region.
               IF ( NREG .GT. 1 ) THEN
                 DO IRGN = 1,NREG-1
                 DO JRGN = IRGN+1,NREG
                   I = REG_UNQ( IRGN )
                   J = REG_UNQ( JRGN )
                   ! Skip if one of these Regions is a Sub-Region of the other
                   IF ( DESID_REG_SUB(I,J) .OR. DESID_REG_SUB(J,I) ) CYCLE
                   DO K = 1,DESID_N_REG
                     ! Check if IRGN and JRGN have a common Sub-Region 
                     ! and that that sub-region is not an active region
                     IF ( DESID_REG_SUB(I,K) .AND. DESID_REG_SUB(J,K) .AND.
#ifndef mpas
     &                    INDEXINT1( K, NREG, REG_UNQ(1:NREG) ) .EQ. 0 ) THEN
#else
     &                    INDEX1( K, NREG, REG_UNQ(1:NREG) ) .EQ. 0 ) THEN
#endif
                       ! Add Sub-Region K to Active Region List
                       NREG = NREG + 1
                       REG_UNQ( NREG ) = K
                       
                       ! Add a factor to zero out this Sub-Region
                       NFAC = NFAC + 1
                       LOCAL_REG( ISTR,ISRM,NFAC ) = K
                       LOCAL_OP ( ISTR,ISRM,NFAC ) = 'o'
                       LOCAL_FAC( ISTR,ISRM,NFAC ) = 0.
                       LOCAL_FAC_BULK( ISTR,ISRM,NFAC ) = 0.
                       LOCAL_BASIS( ISTR,ISRM,NFAC ) = 'UNIT'
                       LOCAL_CONV( ISTR,ISRM,NFAC ) = 1.0
                       
                       ! Add Factors for this Sub-Region to the
                       ! Instruction set
                       DO IFAC = 1,NFAC-1
                           IF ( LOCAL_REG( ISTR,ISRM,IFAC ) .EQ. K .OR.
     &                          DESID_REG_SUB( LOCAL_REG(ISTR,ISRM,IFAC), K) ) THEN
                           ! Region K is a Sub-Region of the Region in this instruction
                           NFAC = NFAC + 1
                           LOCAL_REG( ISTR,ISRM,NFAC )     = K
                           LOCAL_OP ( ISTR,ISRM,NFAC )     = LOCAL_OP ( ISTR,ISRM,IFAC ) 
                           LOCAL_FAC( ISTR,ISRM,NFAC )     = LOCAL_FAC( ISTR,ISRM,IFAC ) 
                           LOCAL_FAC_BULK( ISTR,ISRM,NFAC )= LOCAL_FAC_BULK( ISTR,ISRM,IFAC )
                           LOCAL_BASIS( ISTR,ISRM,NFAC )   = LOCAL_BASIS( ISTR,ISRM,IFAC )  
                           LOCAL_CONV( ISTR,ISRM,NFAC )    = LOCAL_CONV( ISTR,ISRM,IFAC )  
                         END IF    
                       END DO
                     END IF
                   END DO
                 END DO
                 END DO
               END IF

               ! Allocate and Prepopulate Emission Factor Structure
               DESID_FAC( ISTR,ISRM )%NFAC = NFAC
               DESID_FAC( ISTR,ISRM )%NREG = NREG
               ALLOCATE( DESID_FAC( ISTR,ISRM )%FAC( NFAC ) )
               ALLOCATE( DESID_FAC( ISTR,ISRM )%BULK( NFAC ) )
               ALLOCATE( DESID_FAC( ISTR,ISRM )%BASIS( NFAC ) )
               ALLOCATE( DESID_FAC( ISTR,ISRM )%AREA( NFAC ) )
               ALLOCATE( DESID_FAC( ISTR,ISRM )%AREAADJ( NFAC ) )
               ALLOCATE( DESID_FAC( ISTR,ISRM )%REG( NFAC ) )
               ALLOCATE( DESID_FAC( ISTR,ISRM )%OP( NFAC ) )
               ALLOCATE( DESID_FAC( ISTR,ISRM )%REG_UNQ( NREG ) )
               ALLOCATE( DESID_FAC( ISTR,ISRM )%REG_RMDR( NREG ) )

               DESID_FAC( ISTR,ISRM )%FAC  = 0.
               DESID_FAC( ISTR,ISRM )%BULK = 0.
               DESID_FAC( ISTR,ISRM )%BASIS= 1.
               DESID_FAC( ISTR,ISRM )%AREA = .FALSE.
               DESID_FAC( ISTR,ISRM )%AREAADJ = .FALSE.
               DESID_FAC( ISTR,ISRM )%REG  = 1
               DESID_FAC( ISTR,ISRM )%OP   = 0
               DESID_FAC( ISTR,ISRM )%REG_UNQ= REG_UNQ( 1:NREG )
               DESID_FAC( ISTR,ISRM )%REG_RMDR= 0
        
               ! Populate remainder mask array of big regions by subtracting away 
               ! their subsets
               DO IRGN = 1,NREG 
                 ! Move to the next region if this one has no sub-regions
                 IF ( ALL( .NOT. DESID_REG_SUB( REG_UNQ(IRGN),: ) ) ) CYCLE

                 ! Build vector of active sub-regions of this region
                 LSUB(:) = .FALSE.
                 DO JRGN = 1,NREG
                   IF ( DESID_REG_SUB( REG_UNQ(IRGN),REG_UNQ(JRGN) ) )
     &               LSUB( REG_UNQ(JRGN) ) = .TRUE.
                     ! Region JRGN is a subdomain of Region IRGN 
                 END DO
                 IF ( ALL( .NOT. LSUB(:) )) CYCLE ! No active sub-regions

                 ! Check to see if this remainder mask has been calculated already.
                 LREG_RMDR = .FALSE.
                 DO K = 1,N_REG_RMDR
                   IF ( DESID_REG_RMDR( K )%REG .EQ. REG_UNQ(IRGN) .AND.
     &                  ALL( DESID_REG_RMDR( K )%SUB(:) .EQV. LSUB(:) ) ) THEN
                     ! Remainder mask already exists. Map to it.
                     LREG_RMDR = .TRUE.
                     DESID_FAC( ISTR,ISRM )%REG_RMDR( IRGN ) = K
                     EXIT
                   END IF
                 END DO
                 IF ( LREG_RMDR ) CYCLE

                 ! If there's no remainder mask already, add one
                 N_REG_RMDR = N_REG_RMDR + 1
                 ! Identify Large Region
                 DESID_REG_RMDR( N_REG_RMDR )%REG = REG_UNQ(IRGN)
                 
                 ! Identify active sub-regions
                 ALLOCATE( DESID_REG_RMDR( N_REG_RMDR )%SUB( DESID_N_REG ) )
                 DESID_REG_RMDR( N_REG_RMDR )%SUB(:) = LSUB(:)

                 ! Calculate remainder mask
                 ALLOCATE( DESID_REG_RMDR( N_REG_RMDR )%MASK( NCOLS,NROWS ))
                 RMDR_MASK(:,:) = DESID_REG_FAC(:,:,REG_UNQ(IRGN) )
                 DO JRGN = 1,NREG
                   ! Make sure this sub-region is not a sub-region of
                   ! another active sub-region
                   LSUBSUB = .FALSE.
                   DO KRGN = 1,NREG
                     IF ( KRGN .NE. IRGN .AND. LSUB(REG_UNQ(KRGN)) .AND. 
     &                    DESID_REG_SUB( REG_UNQ(KRGN),REG_UNQ(JRGN) ) )
     &                  LSUBSUB = .TRUE.
                   END DO
                   IF ( LSUB(REG_UNQ(JRGN)) .AND. .NOT. LSUBSUB )
     &               RMDR_MASK(:,:) = MAX( 0., RMDR_MASK(:,:) 
     &                         - DESID_REG_FAC(:,:,REG_UNQ(JRGN) ))
                 END DO
                 DESID_REG_RMDR( N_REG_RMDR )%MASK(:,:) = RMDR_MASK(:,:)
                 
                 ! Assign this remainder mask to an active region
                 ! for this factor stack
                 DESID_FAC( ISTR,ISRM )%REG_RMDR( IRGN ) = N_REG_RMDR
               END DO

               ! Populate Local Indices for Chemical Species
               IEMVAR  = MAP_ISTRtoEMVAR( ISTR,ISRM )
               EMVAR_MW= DESID_EMVAR( ISRM )%MW( IEMVAR ) ! MW [g mol-1]
               SPEC_MW = DIFF_MW( MAP_ISTRtoDIFF( ISTR ) )

               ! Populate Emission Factor Structure
               DO IFAC = 1,NFAC
                 DESID_FAC( ISTR,ISRM )%FAC( IFAC )    = LOCAL_FAC ( ISTR, ISRM, IFAC ) 
                 DESID_FAC( ISTR,ISRM )%BULK( IFAC )   = LOCAL_FAC_BULK( ISTR, ISRM, IFAC )
                 DESID_FAC( ISTR,ISRM )%REG( IFAC )    = LOCAL_REG( ISTR, ISRM, IFAC )
                 DESID_FAC( ISTR,ISRM )%AREA( IFAC )   = DESID_EMVAR( ISRM )%LAREA(IEMVAR)
                 DESID_FAC( ISTR,ISRM )%AREAADJ( IFAC )= DESID_EMVAR( ISRM )%LAREAADJ(IEMVAR)
                      
                   SELECT CASE ( LOCAL_OP( ISTR, ISRM, IFAC ) )
                   CASE ( 'a' )
                       DESID_FAC( ISTR,ISRM )%OP( IFAC )    = 1
                   CASE ( 'm' )
                       DESID_FAC( ISTR,ISRM )%OP( IFAC )    = 2
                   CASE ( 'o' )
                       DESID_FAC( ISTR,ISRM )%OP( IFAC )    = 3
                 END SELECT

                 ! Inspect all of the Emissions Instructions for conversion based on 
                 ! mass or moles. If there is a conversion, apply the correct factor
                 ! based on species molecular weights.
                 BASIS_FAC = 1.0
                 IF ( LOCAL_BASIS( ISTR, ISRM, IFAC ) .EQ. 'UNIT' ) THEN
                     BASIS_FAC = BASIS_FAC
                 ELSE IF ( LOCAL_BASIS( ISTR, ISRM, IFAC ) .EQ. 'MOLE' ) THEN
                     IF ( DESID_EMVAR( ISRM )%BASIS( IEMVAR ) .EQ. 'MOLE' ) THEN
                        BASIS_FAC = BASIS_FAC
                     ELSE IF ( DESID_EMVAR( ISRM )%BASIS( IEMVAR ) .EQ. 'MASS' ) THEN
                        ! Convert emission variable rate to moles
                        BASIS_FAC = BASIS_FAC / EMVAR_MW
                     ELSE
                        ! Unknown Basis has been encountered. Need to exit.
                        WRITE( XMSG,'(A,A16,A,I3,A,A,A)' ),
     &                     'ERROR: Emission Variable ',TRIM(DESID_EMVAR(ISRM)%ARRY(IEMVAR) ),
     &                     ' on emission stream ',ISRM, ' has units which are not recognized ',
     &                     'as an emission rate. If you wish to use this variable for ',
     &                     'emissions, please correct the units (e.g. g/s or moles/s).'
                        CALL M3EXIT( 'EMIS_SPC_MAP', 0, 0, XMSG, 2 )
                     END IF
                     
                     ! Check to see if this is an aerosol (mass-based)
                     ! CMAQ species.
                     IF ( .NOT. DIFF_MASK_AERO( MAP_ISTRtoDIFF( ISTR ) ) ) THEN
                        BASIS_FAC = BASIS_FAC
                     ELSE
                        ! Convert species emission rate to mass
                        BASIS_FAC = BASIS_FAC * SPEC_MW
                     END IF

                 ELSE IF ( LOCAL_BASIS( ISTR, ISRM, IFAC ) .EQ. 'MASS' ) THEN
                     IF ( DESID_EMVAR( ISRM )%BASIS( IEMVAR ) .EQ. 'MOLE' ) THEN
                        ! Convert emission variable rate to mass
                        BASIS_FAC = BASIS_FAC * EMVAR_MW
                     ELSE IF ( DESID_EMVAR( ISRM )%BASIS( IEMVAR ) .EQ. 'MASS' ) THEN
                        BASIS_FAC = BASIS_FAC
                     ELSE
                        ! Unknown Basis has been encountered. Need to exit.
                        WRITE( XMSG,'(A,A16,A,I3,A,A,A)' ),
     &                     'ERROR: Emission Variable ',TRIM(DESID_EMVAR(ISRM)%ARRY(IEMVAR) ),
     &                     ' on emission stream ',ISRM, ' has units which are not recognized ',
     &                     'as an emission rate. If you wish to use this variable for ',
     &                     'emissions, please correct the units (e.g. g/s or moles/s).'
                        CALL M3EXIT( 'EMIS_SPC_MAP', 0, 0, XMSG, 2 )
                     END IF

                     ! Check to see if this is an aerosol (mass-based)
                     ! CMAQ species.
                     IF ( .NOT. DIFF_MASK_AERO( MAP_ISTRtoDIFF( ISTR ) ) ) THEN
                        ! Convert species emission rate to moles
                        BASIS_FAC = BASIS_FAC / SPEC_MW
                     ELSE
                        BASIS_FAC = BASIS_FAC
                     END IF
               
                 END IF
                 DESID_FAC( ISTR,ISRM )%BASIS = BASIS_FAC

                 IF ( DESID_FAC( ISTR,ISRM )%OP( IFAC ) .NE. 2 ) 
     &                DESID_FAC( ISTR,ISRM )%FAC( IFAC ) = 
     &                     DESID_FAC( ISTR,ISRM )%FAC( IFAC ) * BASIS_FAC
     &                       * LOCAL_CONV( ISTR, ISRM, IFAC )
              END DO

              END IF
            END DO

        END DO !End Rule Loop

        ! Reduce the size of the Region Remainder Mask
        DESID_REG_RMDR = DESID_REG_RMDR( 1:N_REG_RMDR )


         CALL LOG_SUBHEADING( LOGDEV, 'Error Check Emission Mapping Configuration')

         ! Warn the User if there are no emissions instructions provided        
         IF ( DESID_N_ISTR .LE. 0 ) THEN
            XMSG = 'There are no emissions instructions: VDEMIS is set to zero' ! below
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
         END IF

         ! Print a message for each emissions stream variable that is not used.
         CALL LOG_MESSAGE( LOGDEV, 'Checking for unused Emissions Variables:' )

         LERROR = .FALSE.
         DO ISRM = 1,DESID_N_SRM
             N = DESID_EMVAR( ISRM )%LEN
             N_UNUSED = COUNT( .NOT. DESID_EMVAR( ISRM )%USED( : )
     &                         .AND. DESID_EMVAR(ISRM)%ARRY( 1:N ) .NE. 'NOT_AVAILABLE'  )
             WRITE( LOGDEV, '(5x,4A,I2,A)' ), TRIM( DESID_STREAM_LAB( ISRM )),' | ',
     &              TRIM(DESID_STREAM_DESC( ISRM )),': ', N_UNUSED,' unused variables.'
             IF ( N_UNUSED .GT. 0 ) THEN
                 LERROR = .TRUE.

                 DO IEMVAR = 1,DESID_EMVAR( ISRM )%LEN
                   IF ( .NOT.DESID_EMVAR( ISRM )%USED( IEMVAR )
     &                  .AND.DESID_EMVAR( ISRM )%ARRY( IEMVAR ) .NE. 'NOT_AVAILABLE' ) 
     &               WRITE( LOGDEV, '(10x,A)'), DESID_EMVAR( ISRM )%ARRY( IEMVAR )
                 END DO
             END IF
             WRITE( LOGDEV, '()' )
         END DO
         IF ( LERROR ) WRITE( LOGDEV, '(5x,A,/,5x,A,/,5x,A)' ),
     &       'NOTE: Some Emissions Variables are unused by your current', 
     &       'emission control configuration. You may want to include these ',
     &       'emissions if they are relevant to your application.'

         ! Print a message for every used variable that is not recognized on 
         ! the DESID_EMVAR_TABLE                 
         CALL LOG_MESSAGE( LOGDEV, 'Checking status of used Emissions Variables:')

         DO ICATCH = 1,N_EMVAR_CATCH
             B = EMVAR_CATCH( ICATCH )
             N_USED = 0
             !L_CATCH = .FALSE.
             DO ISRM = 1,DESID_N_SRM
                 N = DESID_EMVAR( ISRM )%LEN
                 N_USED = N_USED + COUNT( DESID_EMVAR(ISRM)%ARRY( 1:N ) .EQ. B 
     &                                    .AND. DESID_EMVAR(ISRM)%USED( 1:N ) )

             END DO
             IF ( N_USED .GT. 0 )
     &           WRITE( LOGDEV, '(/,5x,3A,/,5x,A,/,5x,3A,/,5x,A,/,5x,A,/,5x,A)') 
     &                  'WARNING: Emission Variable ',TRIM(B),' is being used but does not have a',
     &                  '         default entry in the DESID_EMVAR_TABLE in DESID_VARS.F. Currently,',
     &                  '         the molecular weight of ',TRIM(B),' is assumed to be 1.0',
     &                  '         g/mol for any emissions scaling operations requiring mass-mole',
     &                  '         conversions. If you are only prescribing UNIT scaling, then this',
     &                  '         assumption will not be problematic.'
         END DO 

! Resize Important Arrays
         MAP_ISTRtoDIFF = MAP_ISTRtoDIFF( 1:DESID_N_ISTR )
         MAP_ISTRtoNUM  = MAP_ISTRtoNUM ( 1:DESID_N_ISTR )
         MAP_ISTRtoSRF  = MAP_ISTRtoSRF ( 1:DESID_N_ISTR )
         MAP_ISTRtoAERO = MAP_ISTRtoAERO( 1:DESID_N_ISTR )


! An Emissions Scaling Map Now Exists as a 2D Array (NSPECIES x NSTREAMS).
! For every element, there is an associated emission variable and scale factor
! to be applied. For the aerosols, the scale factor will be modified
! later in order to split the mass into the appropriate modes.


! Print out the Tables of CMAQ Emissions Instructions organized by each 
! emission stream and then by CMAQ internal species.

         CALL LOG_MESSAGE( LOGDEV,'' )
         CALL LOG_SUBHEADING( LOGDEV, 'DESID Emission Scaling Report')
         WRITE( LOGDEV,'(7x,A,/,13x,A)' ),'Note: these are populated using rules from the',
     &                              'Emission Control File Supplied by the User.'
         DO ISRM = 1,DESID_N_SRM
           
           ! Print summary information about each Sector including
           ! the label and the available aerosol modes
           WRITE( LOGDEV, '(/,5x,A,A)'   ),'>',REPEAT('-',80 )
           WRITE( LOGDEV,'(5x,A,A,A,A,A2,I2.2,A1)' ),
     &            'Stream Type: "',TRIM(DESID_STREAM_DESC( ISRM )),
     &            '" | Sector Label: ',TRIM(DESID_STREAM_LAB( ISRM ) ),' (',ISRM,')'

           WRITE( LOGDEV, '(/8x,A)' ),'Table of Aerosol Size Distributions Available for Use Sector-Wide.'
           WRITE( LOGDEV, '(8x,A)' ),'Note that Mode 1 is reserved for gas-phase species and emission variable.'
           WRITE( LOGDEV, '(10x,A,2x,A,2x,A)' ), 'Number','Em. Var.  Mode','Reference Mode (see AERO_DATA.F)'
           WRITE( LOGDEV, '(10x,A,2x,A,2x,A)' ), '------','--------------','--------------------------------'
           DO ISD = 2,DESID_STREAM_AERO( ISRM )%LEN
              IEM = DESID_STREAM_AERO( ISRM )%REF( ISD )
              REFNAME = ''
              IF ( IEM .GT. 0 ) THEN
                  REFNAME = DESID_AERO_REF( IEM )%NAME
              END IF

              WRITE( LOGDEV,'(8x,I3,5x,A18,2x,A18,2x,A)' ),ISD, 
     &               DESID_STREAM_AERO( ISRM )%NAME( ISD )( 1:16 ), TRIM( REFNAME )
           END DO


           ! Finally Print Every Instruction for this Stream
           WRITE( LOGDEV, '(/,8x,A,5x,A,2x,A,9x,A,13x,A,2x,A,4x,A,2x,A)' ),
     &            'CMAQ Species','Phase/Mode','Em. Var. ','Region','Op','ScaleFac','Basis','FinalFac'
           WRITE( LOGDEV, '(8x,A,5x,A,2x,A,9x,A,13x,A,2x,A,4x,A,2x,A)' ),
     &            '------------','----------','---------','------','--','--------','-----','--------'

           DO IDIFF = 1,N_SPC_DIFF
             L_WDIFF = .TRUE.
             DO ISD = 1,DESID_STREAM_AERO( ISRM )%LEN
               L_WISD = .TRUE.
               DO ISTR = 1,DESID_N_ISTR
                   IF ( LOCAL_SPEC( ISTR ) .EQ. DIFF_SPC( IDIFF ) .AND.
     &                  MAP_ISTRtoSD( ISTR,ISRM ) .EQ. ISD     ) THEN 
                     IF ( L_WDIFF ) THEN
                        WRITE( LOGDEV, '(10x,A,1x,A,1x,A,1x,A,1x,A,2x,ES9.2,4x,A,2x,ES9.2)' ),
     &                         LOCAL_SPEC( ISTR ),
     &                         DESID_STREAM_AERO( ISRM )%NAME( ISD )(1:10),
     &                         LOCAL_EMVAR( ISTR, ISRM ),
     &                         DESID_REG( DESID_FAC( ISTR,ISRM )%REG( 1 ) )%LABEL(1:18),
     &                         LOCAL_OP( ISTR,ISRM,1 ), 
     &                         DESID_FAC( ISTR, ISRM )%BULK( 1 ), LOCAL_BASIS( ISTR,ISRM,1 ),
     &                         DESID_FAC( ISTR,ISRM )%FAC( 1 ) 
     &                         
                        L_WDIFF = .FALSE.
                        L_WISD  = .FALSE.
                      ELSE IF ( L_WISD ) THEN
                        WRITE( LOGDEV, '(27x,A,1x,A,1x,A,1x,A,2x,ES9.2,4x,A,2x,ES9.2)' ),
     &                         DESID_STREAM_AERO( ISRM )%NAME( ISD )(1:10),
     &                         LOCAL_EMVAR( ISTR, ISRM ),
     &                         DESID_REG( DESID_FAC( ISTR,ISRM )%REG( 1 ) )%LABEL(1:18),
     &                         LOCAL_OP( ISTR,ISRM,1 ),
     &                         DESID_FAC( ISTR, ISRM )%BULK( 1 ), LOCAL_BASIS( ISTR,ISRM,1 ),
     &                         DESID_FAC( ISTR,ISRM )%FAC( 1 )
                        L_WISD = .FALSE.
                      ELSE
                        WRITE( LOGDEV, '(38x,A,1x,A,1x,A,2x,ES9.2,4x,A,2x,ES9.2)' ),
     &                         LOCAL_EMVAR( ISTR, ISRM ),
     &                         DESID_REG( DESID_FAC( ISTR,ISRM )%REG( 1 ) )%LABEL(1:18),
     &                         LOCAL_OP( ISTR,ISRM,1 ), 
     &                         DESID_FAC( ISTR, ISRM )%BULK( 1 ), LOCAL_BASIS( ISTR,ISRM,1 ),
     &                         DESID_FAC( ISTR,ISRM )%FAC( 1 ) 
                      END IF    

                      IF ( DESID_FAC( ISTR,ISRM )%NFAC .GT. 1 ) THEN
                      DO IFAC = 2,DESID_FAC( ISTR,ISRM )%NFAC
                         ! Compute Final Factor taking into account all rules that apply to the
                         ! region associated with each factor.
                         FAC  = 0.0
                         IRGN = DESID_FAC( ISTR,ISRM )%REG( IFAC )
                         DO JFAC = 1,IFAC
                           JRGN = DESID_FAC( ISTR,ISRM )%REG( JFAC )
                           ! If region IRGN and JRGN are connected (i.e. one is a subregion of
                           ! the other) then the final_fac should account for JFAC
                           IF ( IRGN .EQ. JRGN .OR. DESID_REG_SUB( IRGN,JRGN ) 
     &                                         .OR. DESID_REG_SUB( JRGN,IRGN ) ) THEN
                              
                             ! Decide how to modify FAC to account for JFAC
                             IF ( DESID_FAC( ISTR,ISRM )%OP(JFAC) .EQ. 1 ) THEN
                                 ! Add Factor (a)
                                 FAC = FAC + DESID_FAC( ISTR,ISRM )%FAC( JFAC )
                             ELSE IF ( DESID_FAC( ISTR,ISRM )%OP(JFAC) .EQ. 2 ) THEN
                                 ! Multiply Factor (m)
                                 FAC = FAC * DESID_FAC( ISTR,ISRM )%FAC( JFAC )
                             ELSE IF ( DESID_FAC( ISTR,ISRM )%OP(JFAC) .EQ. 3 ) THEN
                                 ! Overwrite Factor (o)
                                 FAC = DESID_FAC( ISTR,ISRM )%FAC( JFAC )
                             END IF
                           END IF
                         END DO
                         WRITE( LOGDEV, '(55x,A,1x,A,2x,ES9.2,4x,A,2x,ES9.2)' ),
     &                          DESID_REG( DESID_FAC( ISTR,ISRM )%REG( IFAC ) )%LABEL(1:18),
     &                          LOCAL_OP( ISTR,ISRM,IFAC ), DESID_FAC( ISTR, ISRM )%BULK( IFAC ), 
     &                          LOCAL_BASIS( ISTR,ISRM,IFAC ), FAC
                      END DO
                      END IF

                   END IF
                 !END DO
               END DO
             END DO
           END DO
         END DO

        END SUBROUTINE DESID_PROCESS_RULES

!-----------------------------------------------------------------------
      SUBROUTINE DESID_INIT_STREAMS( JDATE, JTIME )

! Initialize the counter for the total nbumber of emissions files. Also
! allocate memory for the vectors storing the labels of emission files
! and the maps from master ID number to the relative ID number for each
! gridded and point stream file, i.e. Emissions File 10 is also known as
! Point Source file 2.
!
#ifdef mpas
         use util_module, only : upcase
#endif
  
      IMPLICIT NONE

      INTEGER, INTENT(IN)  :: JDATE, JTIME
  
      INTEGER ISRM, N
  
      CHARACTER( 16 )  :: PNAME = 'DESID_INIT_STREAMS'
      CHARACTER( 20 )  :: VLAB
      INTEGER          :: STATUS
      LOGICAL :: SUCCESS
  
      SUCCESS = .TRUE.
  
      CALL LOG_SUBHEADING( LOGDEV,'Initialize Emissions Input Files' )
   
         ! Calculate the total number of Emission Streams based on the
         ! user options
         ! Add the number of total Emission Streams 
         DESID_N_SRM = N_FILE_GR + NPTGRPS + N_FILE_TR
  
         ! Online Biogenic Emissions
         IF ( BIOGEMIS_BEIS ) DESID_N_SRM = DESID_N_SRM + 1
  
         ! Online Biogenic Emissions from MEGAN
         IF ( BIOGEMIS_MEGAN ) DESID_N_SRM = DESID_N_SRM + 1
  
         ! Marine gas emissions; use online marine gas option only if CB6R5M is used
         IF ( USE_MARINE_GAS_EMISSION ) DESID_N_SRM = DESID_N_SRM + 1
  
         ! Met-Modulated Emissions; use if met-emis is activated
         IF ( USE_MET_EMIS ) DESID_N_SRM = DESID_N_SRM + 1
  
         ! Lightning NO Emissions
         IF ( LTNG_NO ) DESID_N_SRM = DESID_N_SRM + 1
  
         ! Sea Spray Aerosol 
         IF ( OCEAN_CHEM ) DESID_N_SRM = DESID_N_SRM + 1
  
         ! Determine if WindBlown Dust is Requested
         IF ( WB_DUST ) DESID_N_SRM = DESID_N_SRM + 1
  
         ! Turn Back Now if DESID_N_SRM Equals Zero (i.e. there are no emissions
         IF ( DESID_N_SRM .EQ. 0 ) RETURN
  
         ! Allocate Emission File Structure Variables
         Allocate( DESID_STREAM_NAME  ( DESID_N_SRM ) )
         Allocate( DESID_STREAM_LAB   ( DESID_N_SRM ) )
         Allocate( DESID_STREAM_TYPE  ( DESID_N_SRM ) )
         Allocate( DESID_STREAM_ITYPE ( DESID_N_SRM ) )
         Allocate( DESID_STREAM_DESC  ( DESID_N_SRM ) )
         Allocate( DESID_STREAM_LAPPLY( DESID_N_SRM ) )
         Allocate( DESID_STREAM_DATE  ( DESID_N_SRM ) )
         Allocate( DESID_STREAM_SYM_DATE ( DESID_N_SRM ) ) 
         Allocate( DESID_STREAM_FIRE  ( DESID_N_SRM ) )
         Allocate( IGSRM         ( DESID_N_SRM ) )
         Allocate( IPSRM         ( DESID_N_SRM ) )
         Allocate( ITSRM         ( DESID_N_SRM ) )
         Allocate( MAP_PTtoISRM  ( NPTGRPS ) )
         Allocate( DESID_EMVAR  ( DESID_N_SRM ) )
         Allocate( DESID_GRID_LAYS  ( DESID_N_SRM ) )
  
C Assign Attributes to Emission File Records. Other records will be 
C populated in individual subroutines. For example, opemis and
C stkemis_init.
  
         CALL LOG_MESSAGE( LOGDEV, ' ' )
         CALL LOG_MESSAGE( LOGDEV, 'Retrieving Env. Variables for Gridded and Elevated Point Emission Inputs' )
  
         ISRM = 0
         DESID_STREAM_LAPPLY   = .TRUE.
         DESID_STREAM_DATE     = JDATE
         DESID_STREAM_SYM_DATE = EMIS_SYM_DATE ! representative day files (default: false)
         DESID_STREAM_FIRE     = .FALSE.
         DESID_GRID_LAYS       = 0
         
         ! Gridded Emission Files
         IF ( N_FILE_GR .GT. 0 ) THEN
           DESID_STREAM_TYPE( ISRM+1:ISRM+N_FILE_GR ) = 'GRID'
           DESID_STREAM_ITYPE( ISRM+1:ISRM+N_FILE_GR ) = 1
           DO N = 1, N_FILE_GR
              ISRM = ISRM + 1
              IGSRM( ISRM ) = N
  
              ! Create Description of this Emission File for output to
              ! diagnostics
              WRITE( DESID_STREAM_DESC( ISRM ), '(A,I3)' ),
     &           'Gridded Area Emissions File ', N
             
              ! Retrieve Short-Name Label for Each Gridded File
              WRITE( VLAB,'( "GR_EMIS_LAB_",I3.3 )' ) N
              CALL GET_ENV( DESID_STREAM_LAB( ISRM ), TRIM(VLAB),
     &                      DESID_STREAM_LAB( ISRM ), LOGDEV )
              CALL UPCASE( DESID_STREAM_LAB( ISRM ) )
  
              ! Each Gridded File Name is stored already in IO-API as
              ! an object of the form GR_EMIS_XXX
              WRITE( DESID_STREAM_NAME( ISRM ),'( "GR_EMIS_",I3.3 )' ) N
  
              ! Retrieve Toggle for whether or not to apply these
              ! emissions 
              WRITE( VLAB,'( "GR_EMIS_APPLY_",I3.3 )' ) N
              CALL GET_ENV( DESID_STREAM_LAPPLY( ISRM ), TRIM(VLAB), 
     &                      DESID_STREAM_LAPPLY( ISRM ), LOGDEV )
  
              ! Retrieve Toggle for overriding emissions file date with
              ! internal model date
              WRITE( VLAB,'( "GR_EM_SYM_DATE_",I3.3 )' ) N
              CALL GET_ENV( DESID_STREAM_SYM_DATE( ISRM ), TRIM(VLAB), 
     &                      EMIS_SYM_DATE, LOGDEV )
  
           END DO
         END IF
         
         ! In-Line Point Source Files
         IF ( NPTGRPS .GT. 0 ) THEN 
           DESID_STREAM_TYPE( ISRM+1:ISRM+NPTGRPS ) = 'POINT'
           DESID_STREAM_ITYPE( ISRM+1:ISRM+NPTGRPS ) = 2
           DO N = 1, NPTGRPS
              ISRM = ISRM + 1
              IPSRM( ISRM ) = N
              MAP_PTtoISRM( N ) = ISRM
              
              ! Create Description of this Emission File for output to
              ! diagnostics
              WRITE( DESID_STREAM_DESC( ISRM ), '(A,I3)' ),
     &        'Point Emissions File ', IPSRM( ISRM )
             
              ! Retrieve Short-Name Label for Each Inline File
              WRITE( VLAB,'( "STK_EMIS_LAB_",I3.3 )' ) N
              CALL GET_ENV( DESID_STREAM_LAB( ISRM ), TRIM(VLAB), 
     &                      DESID_STREAM_LAB( ISRM ), LOGDEV )
              CALL UPCASE( DESID_STREAM_LAB( ISRM ) )
  
              ! Each Inline File Name is stored already in IO-API as
              ! an object of the form STK_EMIS_XXX
              WRITE( DESID_STREAM_NAME( ISRM ),'( "STK_EMIS_",I3.3 )' ) N
              
              ! Retrieve Toggle for whether or not to apply these
              ! emissions 
              WRITE( VLAB,'( "STK_EMIS_APPLY_",I3.3 )' ) N
              CALL GET_ENV( DESID_STREAM_LAPPLY( ISRM ), TRIM(VLAB), 
     &                      DESID_STREAM_LAPPLY( ISRM ), LOGDEV )
  
              ! Retrieve Toggle for overriding emissions file date with
              ! internal model date
              WRITE( VLAB,'( "STK_EM_SYM_DATE_",I3.3 )' ) N
              CALL GET_ENV( DESID_STREAM_SYM_DATE( ISRM ), TRIM(VLAB), 
     &                      EMIS_SYM_DATE, LOGDEV )
  
           END DO
         END IF
         
         ! Tracer Emissions
         IF ( N_FILE_TR .GT. 0 ) THEN 
           DESID_STREAM_TYPE( ISRM+1:ISRM+N_FILE_TR ) = 'TRAC'
           DESID_STREAM_ITYPE( ISRM+1:ISRM+N_FILE_TR ) = 3
           DO N = 1, N_FILE_TR
              ISRM = ISRM + 1
              ITSRM( ISRM ) = N
  
              ! Create Description of this Emission File for output to
              ! diagnostics
              WRITE( DESID_STREAM_DESC( ISRM ), '(A,I2)' ),
     &          'Gridded Tracer Emissions File ', N
  
              ! Retrieve Short-Name Label for Each Tracer File
              WRITE( VLAB,'( "TR_EMIS_LAB_",I2.2 )' ) N
              CALL GET_ENV( DESID_STREAM_LAB( ISRM ), TRIM(VLAB),
     &                      DESID_STREAM_LAB( ISRM ), LOGDEV )
              CALL UPCASE( DESID_STREAM_LAB( ISRM ) )
  
              ! Each Tracer File Name is stored already in IO-API as
              ! an object of the form TR_EMIS_XXX
              WRITE( DESID_STREAM_NAME( ISRM ),'( "TR_EMIS_",I2.2 )' ) N
  
           END DO
         END IF
  
         ! Online Biogenic Emissions (BEIS)
         IF ( BIOGEMIS_BEIS ) THEN
             ISRM = ISRM + 1
             DESID_STREAM_TYPE( ISRM ) = 'BIOG'
             DESID_STREAM_ITYPE( ISRM ) = 4
             DESID_STREAM_LAB ( ISRM ) = 'BIOG'
             DESID_STREAM_DESC( ISRM ) = 'Biogenic Emissions'
 
             IBIOSRM = ISRM
         END IF
         
         ! Online Biogenic Emissions (MEGAN)
         IF ( BIOGEMIS_MEGAN ) THEN
             ISRM = ISRM + 1
             DESID_STREAM_TYPE( ISRM ) = 'MIOG'
             DESID_STREAM_ITYPE( ISRM ) = 9
             DESID_STREAM_LAB ( ISRM ) = 'MIOG'
             DESID_STREAM_DESC( ISRM ) = 'Megan Biogenic Emissions'
 
             IMIOGSRM = ISRM
         END IF
 
 
         ! Online Marine Gas Emissions
         IF ( USE_MARINE_GAS_EMISSION ) THEN
             ISRM = ISRM + 1
             DESID_STREAM_TYPE( ISRM ) = 'MGEM'
             DESID_STREAM_ITYPE( ISRM ) = 5
             DESID_STREAM_LAB ( ISRM ) = 'MGEM'
             DESID_STREAM_DESC( ISRM ) = 'Marine Gas Emissions'
 
             IMGSRM = ISRM
         END IF
 
         ! Online Lightning NO Emissions
         IF ( LTNG_NO ) THEN
             ISRM = ISRM + 1
             DESID_STREAM_TYPE( ISRM ) = 'LTNG'
             DESID_STREAM_ITYPE( ISRM ) = 6
             DESID_STREAM_LAB ( ISRM ) = 'LTNG'
             DESID_STREAM_DESC( ISRM ) = 'Lightning NO Emissions'
 
             ILTSRM = ISRM
         END IF
 
         ! Sea Spray Aerosol Emissions
         IF ( OCEAN_CHEM ) THEN
             ISRM = ISRM + 1
             DESID_STREAM_TYPE( ISRM ) = 'ASEA'
             DESID_STREAM_ITYPE( ISRM ) = 7
             DESID_STREAM_LAB ( ISRM ) = 'SEASPRAY'
             DESID_STREAM_DESC( ISRM ) = 'Sea Spray Aerosol Emissions'
             
             ISEASRM = ISRM
         END IF
 
         ! Wind-Blown Dust Emissions
         IF ( WB_DUST ) THEN
             ISRM = ISRM + 1
             DESID_STREAM_TYPE( ISRM ) = 'DUST'
             DESID_STREAM_ITYPE( ISRM ) = 8
             DESID_STREAM_LAB ( ISRM ) = 'WBDUST'
             DESID_STREAM_DESC( ISRM ) = 'Wind-Blown Dust Emissions'
             
             IDUSTSRM = ISRM
         END IF
         
         ! Met-Modulated Emissions
         IF ( USE_MET_EMIS ) THEN
           ISRM = ISRM + 1
           DESID_STREAM_TYPE( ISRM ) = 'METEMIS'
           DESID_STREAM_ITYPE( ISRM ) = 10
           DESID_STREAM_LAB ( ISRM ) = 'METEMIS'
           DESID_STREAM_DESC( ISRM ) = 'Met-Modulated Emissions'

           IMETSRM = ISRM
         END IF

        END SUBROUTINE DESID_INIT_STREAMS 
 
!-----------------------------------------------------------------------
        SUBROUTINE DESID_INIT_DIAG
!       This subroutine processes the user input in the Emission Control
!       file and determines how the emission rates are to be output for
!       diagnostics. Rates may be summed, specific species may be 
!       selected or ignored, and rates may be summed into columns, among
!       other features.
!-----------------------------------------------------------------------

#ifdef mpas
         use util_module, only : index1, upcase
#endif
  
        IMPLICIT NONE
  
        CHARACTER( 200 ) :: PREFIX = 'CCTM_DESID'
        CHARACTER( 200 ) :: SUFFIX = '.nc'
        CHARACTER( 200 ) :: XMSG
        INTEGER          :: VALUE
        LOGICAL          :: stream_vector( DESID_N_SRM )
        INTEGER          :: N_Diag_Nml, N_Buff 
        INTEGER          :: IDIAG, NSTREAM, I, ISRM, J, JDIAG,
     &                      NSUM, NSPEC, LAYS, ISPEC, NPAIRS
        LOGICAL          :: LREMOVE, LFOUND, EXPAND_STREAM
        LOGICAL          :: STREAM_VECTOR_TMP( DESID_N_SRM ),
     &                      SPEC_VECTOR( N_SPC_DIFF )
        CHARACTER( 3)    :: CDIAG
        LOGICAL          :: LERROR
   
        N_Diag_Nml = SIZE( Desid_Diag_Fmt_Nml )
        N_Buff = N_Diag_Nml * 20

        ALLOCATE( DESID_DIAG_STREAM_MASK( DESID_N_SRM, N_Buff ) )
        ALLOCATE( DESID_DIAG_SPEC_BUFF ( N_Buff ) )
        ALLOCATE( DESID_DIAG_N_STREAM ( N_Buff ) )
        ALLOCATE( DESID_DIAG_FORMAT ( N_Buff ) )
        ALLOCATE( DESID_DIAG_FILENAME ( N_Buff ) )
        ALLOCATE( DESID_DIAG_LAB ( N_Buff ) )
        ALLOCATE( DESID_DIAG_SUM( N_Buff ) )
        ALLOCATE( DESID_DIAG_LAYS( N_Buff ) )
   
        DESID_DIAG_STREAM_MASK = .FALSE.
        DESID_DIAG_FORMAT      = 'OFF'
        DESID_DIAG_FILENAME    = ''
        DESID_DIAG_N_STREAM    = 0
        DESID_DIAG_LAB         = ''
        DESID_DIAG_LAYS        = NLAYS
        DESID_DIAG_SUM         = 0
   
        ! Set the standard suffix for all Emissions Diagnostic Files
        IF ( APPL_NAME(1:8 ) .NE. 'CTM_APPL' ) SUFFIX = '_' // TRIM(APPL_NAME) // SUFFIX
   
        ! Find Number of Emissions Diagnostic Files Selected. 
        DESID_N_DIAG = 0
        NSUM = 0
        DO IDIAG = 1,N_Diag_Nml
           ! Error Check Value for Emission Diagnostic Format
           CALL UPCASE( Desid_Diag_Fmt_Nml( IDIAG ) )
           IF ( Desid_Diag_Fmt_Nml( IDIAG ) .NE. 'OFF' .AND. 
     &          Desid_Diag_Fmt_Nml( IDIAG ) .NE. '3D' .AND.
     &          Desid_Diag_Fmt_Nml( IDIAG ) .NE. 'COLSUM' .AND. 
     &          Desid_Diag_Fmt_Nml( IDIAG ) .NE. 'LAYER1' ) THEN
               WRITE( LOGDEV, * )
               WRITE( XMSG, '(A,I3,A,A)' ),
     &             'The format for Emission Diagnostic group ',IDIAG,
     &             ' is not allowed. Please correct:',TRIM( Desid_Diag_Fmt_Nml(IDIAG))
               CALL M3EXIT( 'Map_Emiss_Diag', 0, 0, XMSG, XSTAT1 )     
           END IF
   
           ! Determine number of stream labels to expand
           NSTREAM = INDEX1( '', Desid_Max_Diag_Streams, Desid_Diag_Streams_Nml(IDIAG,:) ) - 1
           IF ( NSTREAM .LE. 0 ) THEN
               WRITE( LOGDEV, * )
               WRITE( XMSG, '(A,I3,A)' ),
     &             'No Emission Streams have been selected for group ',IDIAG,
     &             ' of the emission diagnostic input. Please correct.'
               CALL M3EXIT( 'Map_Emiss_Diag', 0, 0, XMSG, XSTAT1 )     
           END IF
   
           ! Expand Desid_Diag_Streams_Nml to discover all matching streams
           STREAM_VECTOR = .FALSE.
           Expand_Stream = .FALSE.
           DO I = 1,NSTREAM
             IF ( Desid_Diag_Streams_Nml( IDIAG,I )(1:1) .EQ. '*' ) THEN
                 Expand_Stream = .TRUE.
                 Desid_Diag_Streams_Nml( IDIAG,I ) = 
     &                 Desid_Diag_Streams_Nml( IDIAG,I )(2:32)//' '
             END IF
             IF ( Desid_Diag_Streams_Nml( IDIAG,I ) .EQ. 'ALL' ) THEN
                 Expand_Stream = .TRUE.
             END IF
             CALL DESID_GET_RULE_STREAMS( Desid_Diag_Streams_Nml( IDIAG,I ),IDIAG,
     &                                    STREAM_VECTOR, LREMOVE, LERROR )

             ! Stop CMAQ if there was an error setting the emission streams
             IF ( LERROR ) THEN
               WRITE( LOGDEV, * )
               WRITE( XMSG, '(A,A,A)' ),
     &             'CMAQ will crash until an error specifying the ',
     &             'DESID diagnostics is fixed. Detailed information is ',
     &             'in the processor log files.'
               CALL M3EXIT( 'Map_Emiss_Diag', 0, 0, XMSG, XSTAT1 )     
             END IF

             ! Determine whether this diagnostic is a sum or not and
             ! assign name accordingly
             IF ( Expand_Stream ) THEN
                 ! Create a separate diagnostic file for every stream
                 ! in stream_vector
                 DO ISRM = 1,DESID_N_SRM
                     IF ( STREAM_VECTOR( ISRM ) ) THEN
                        ! Check for existing entries
                        DESID_N_DIAG = DESID_N_DIAG + 1
                        JDIAG = DESID_N_DIAG
            
                        ! Save the number of
                        ! streams selected for this diagnostic and a mask for
                        ! mapping each stream to each diagnostic
                        DESID_DIAG_N_STREAM( JDIAG ) = 1
                        DESID_DIAG_STREAM_MASK( ISRM,JDIAG ) = .TRUE.
                        DESID_DIAG_FORMAT( JDIAG ) = Desid_Diag_Fmt_Nml( IDIAG )
                        IF ( DESID_DIAG_FORMAT( JDIAG ) .EQ. 'COLSUM' .OR.
     &                       DESID_DIAG_FORMAT( JDIAG ) .EQ. 'LAYER1' ) 
     &                       DESID_DIAG_LAYS( JDIAG ) = 1
   
                        DESID_DIAG_LAB( JDIAG ) = DESID_STREAM_LAB( ISRM )
                        WRITE( CDIAG, '(I0)' ), IDIAG
                        DESID_DIAG_FILENAME( JDIAG ) = TRIM( PREFIX ) // TRIM(CDIAG) //
     &                        '_' // TRIM( DESID_DIAG_LAB( JDIAG ) ) // TRIM( SUFFIX )
                        DESID_DIAG_SUM( JDIAG ) = 0
            
                        ! Build Species Selection Array
                        SPEC_VECTOR = DESID_STREAM_DIFF( :,ISRM )
                        CALL DESID_DIAG_MAP_SPEC( Desid_Diag_Spec_Nml( IDIAG,: ), IDIAG, 
     &                             SPEC_VECTOR, JDIAG )
            
                     END IF
                 END DO
             ELSE
                 ! Check for existing entries. 
                 DESID_N_DIAG = DESID_N_DIAG + 1
                 JDIAG = DESID_N_DIAG
                 NSUM = NSUM + 1
                 DESID_DIAG_SUM( JDIAG ) = NSUM
                 
                 ! Save the number of
                 ! streams selected for this diagnostic and a mask for
                 ! mapping each stream to each diagnostic
                 DESID_DIAG_N_STREAM( JDIAG ) = COUNT( STREAM_VECTOR )
                 DESID_DIAG_STREAM_MASK( :,JDIAG ) = STREAM_VECTOR
                 DESID_DIAG_FORMAT( JDIAG ) = Desid_Diag_Fmt_Nml( IDIAG )
                 IF ( DESID_DIAG_FORMAT( JDIAG ) .EQ. 'COLSUM' .OR.
     &                DESID_DIAG_FORMAT( JDIAG ) .EQ. 'LAYER1' ) 
     &                DESID_DIAG_LAYS( JDIAG ) = 1
   
                 DESID_DIAG_LAB( JDIAG ) = Desid_Diag_Streams_Nml( IDIAG,I )
                 WRITE( CDIAG, '(I0)' ), IDIAG
                 DESID_DIAG_FILENAME( JDIAG ) = TRIM( PREFIX ) // TRIM(CDIAG) //
     &                 '_' // TRIM( DESID_DIAG_LAB( JDIAG ) ) // TRIM( SUFFIX )
   
                 ! Build Species Selection Array
                 SPEC_VECTOR = .FALSE.
                 DO ISRM = 1,DESID_N_SRM
                    IF ( STREAM_VECTOR( ISRM ) ) 
     &                   SPEC_VECTOR = SPEC_VECTOR .OR. DESID_STREAM_DIFF( :,ISRM )
                 END DO
                 CALL DESID_DIAG_MAP_SPEC( Desid_Diag_Spec_Nml( IDIAG,: ), IDIAG, 
     &                     SPEC_VECTOR, JDIAG )
             END IF
   
           END DO
        END DO
        
        ! Reduce size of each vector to length DESID_N_DIAG
        DESID_DIAG_N_STREAM    = DESID_DIAG_N_STREAM( 1:DESID_N_DIAG )
        DESID_DIAG_STREAM_MASK = DESID_DIAG_STREAM_MASK( :,1:DESID_N_DIAG )
        DESID_DIAG_FORMAT      = DESID_DIAG_FORMAT( 1:DESID_N_DIAG )
        DESID_DIAG_FILENAME    = DESID_DIAG_FILENAME( 1:DESID_N_DIAG )
        DESID_DIAG_LAB         = DESID_DIAG_LAB( 1:DESID_N_DIAG )
        DESID_DIAG_LAYS        = DESID_DIAG_LAYS( 1:DESID_N_DIAG )
        DESID_DIAG_SUM         = DESID_DIAG_SUM( 1:DESID_N_DIAG )
   
        ! Populate DESID_DIAG_SPEC from DESID_DIAG_SPEC_BUFF
        ALLOCATE( DESID_DIAG_SPEC( DESID_N_DIAG ) )
        DO IDIAG = 1,DESID_N_DIAG
           NSPEC  = DESID_DIAG_SPEC_BUFF(IDIAG)%NSPEC
           NPAIRS = DESID_DIAG_SPEC_BUFF(IDIAG)%NPAIRS
           DESID_DIAG_SPEC(IDIAG)%NSPEC  = NSPEC
           DESID_DIAG_SPEC(IDIAG)%NPAIRS = NPAIRS

           IF ( NSPEC .GT. 0 ) THEN
               ALLOCATE( DESID_DIAG_SPEC( IDIAG )%SPEC( NSPEC ) )
               ALLOCATE( DESID_DIAG_SPEC( IDIAG )%UNITS( NSPEC ) )
               ALLOCATE( DESID_DIAG_SPEC( IDIAG )%MAP_toDIFF( NPAIRS ) )
               ALLOCATE( DESID_DIAG_SPEC( IDIAG )%MAP_toDIAG( NPAIRS ) )
        
               DESID_DIAG_SPEC(IDIAG)%SPEC  = DESID_DIAG_SPEC_BUFF( IDIAG )%SPEC  
               DESID_DIAG_SPEC(IDIAG)%UNITS = DESID_DIAG_SPEC_BUFF( IDIAG )%UNITS 
               DESID_DIAG_SPEC(IDIAG)%MAP_toDIFF = DESID_DIAG_SPEC_BUFF( IDIAG )%MAP_toDIFF
               DESID_DIAG_SPEC(IDIAG)%MAP_toDIAG = DESID_DIAG_SPEC_BUFF( IDIAG )%MAP_toDIAG
           END IF
        END DO
        DEALLOCATE ( DESID_DIAG_SPEC_BUFF )

        ! Write Details of Diagnostic Output to Log File
        CALL LOG_MESSAGE( LOGDEV,'' )
        CALL LOG_SUBHEADING( LOGDEV, 'DESID Emission Diagnostic Report' )
        
        IF ( DESID_N_DIAG .EQ. 0 ) 
     &       CALL LOG_MESSAGE( LOGDEV, 'No DESID Diagnostic Files Requested')

        DO IDIAG = 1,DESID_N_DIAG
           WRITE( LOGDEV, * )
           WRITE( LOGDEV,'(5x,A19,2x,A)' ),'Diagnostic File: ',TRIM(DESID_DIAG_LAB( IDIAG ))
           WRITE( LOGDEV,'(10x,A)' ), 'Stream Members'
           DO I = 1,DESID_N_SRM
               IF ( DESID_DIAG_STREAM_MASK( I,IDIAG ) ) WRITE( LOGDEV,'(15x,A32)'),DESID_STREAM_LAB(I)
           END DO
           WRITE( LOGDEV,'(10x,A)' ), 'Diagnostic Species'
           DO I = 1,DESID_DIAG_SPEC( IDIAG )%NSPEC
               WRITE( LOGDEV,'(15x,A16)'),DESID_DIAG_SPEC( IDIAG )%SPEC( I )
           END DO
        END DO
        
        ! Create I/O Logicals and Populate with full Filepaths
        ALLOCATE( DESID_DIAG_LOGICAL( DESID_N_DIAG ) )
        DO IDIAG = 1,DESID_N_DIAG
           IF ( OUTDIR .NE. '' ) THEN
             DESID_DIAG_FILENAME(IDIAG) = TRIM( OUTDIR ) // '/' // DESID_DIAG_FILENAME(IDIAG)
           END IF
           WRITE( DESID_DIAG_LOGICAL( IDIAG ),'( "DESID_",I3.3 )' ) IDIAG
#ifndef mpas
           VALUE = SETENVVAR( DESID_DIAG_LOGICAL( IDIAG ), DESID_DIAG_FILENAME( IDIAG ) )
#endif
        END DO
   
        ! Allocate Minimal Necessary Space for VDEMIS_DIAG
        ALLOCATE( MAP_DIAGtoVDEMIS( N_SPC_DIFF,DESID_N_DIAG ) )
        MAP_DIAGtoVDEMIS = 0
        NSPEC = 0
        LAYS = 1
   
        DO IDIAG = 1,DESID_N_DIAG
            IF ( DESID_DIAG_SUM( IDIAG ) .GT. 0 ) THEN
              DO ISPEC = 1,DESID_DIAG_SPEC( IDIAG )%NSPEC
                 NSPEC = NSPEC + 1
                 MAP_DIAGtoVDEMIS( ISPEC,IDIAG ) = NSPEC
              END DO
              IF ( DESID_DIAG_FORMAT( IDIAG ) .EQ. '3D' ) LAYS = NLAYS
            ENDIF
        END DO
        ALLOCATE( VDEMIS_DIAG( NSPEC,NCOLS,NROWS,LAYS ) )
   
        END SUBROUTINE DESID_INIT_DIAG
   
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
       SUBROUTINE DESID_OPEN_GR3D ( JDATE, JTIME )
   
C  7 Mar 02 - J.Young: add units string variations
C 29 Oct 05 - J.Young: dyn. layers
C 19 Feb 08 - David Wong: add DESID_TRAC = .TRUE. when EMIS_TRAC_1 exists
C 21 Jun 10 - J.Young: convert for Namelist redesign
C 16 Feb 11 - S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
  
      USE VGRD_DEFN           ! vertical layer specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      USE AERO_DATA, only : AEROMODE, N_MODE, MGPG, GPKG
      USE VDIFF_MAP, only : N_SPC_DIFF, DIFF_SPC, DIFF_MASK_AERO
#ifdef mpas
      use util_module, only : index1, upcase
      use mio_module
#endif
  
      IMPLICIT NONE
  
      INCLUDE SUBST_FILES_ID  ! file name parameters
  
C Arguments:
  
      INTEGER      JDATE      ! current model date, coded YYYYDDD
      INTEGER      JTIME      ! current model time, coded HHMMSS
      INTEGER      NLAY_FILE  ! keep a running maximum of the layers from the gridded files
  
C Local variables:
  
      CHARACTER( 16 ) :: PNAME = 'OPEMIS'
      CHARACTER(200 ) :: XMSG
      CHARACTER( 16 ) :: UNITSCK
  
      LOGICAL ::   LAERO
      LOGICAL ::   WRFLG = .FALSE.
      INTEGER      STATUS, IOS
      INTEGER      V, N, S, ISRM, ITRAC, IGR, IVAR, X    

      integer :: floc, loc_nvars, loc_nlays, loc_date, loc_time
      character (16), allocatable :: loc_vnames(:), loc_units(:)
      logical :: file_exist

C-----------------------------------------------------------------------
  
      CALL LOG_SUBHEADING( LOGDEV,'Open Gridded Emissions' )
  
      DESID_GRID_LAYS = 0
  
C Open All Tracer Emission Files
      DO ISRM = 1,DESID_N_SRM
        IF ( DESID_STREAM_TYPE( ISRM ) .EQ. 'TRAC' ) THEN
           ITRAC = ITSRM( ISRM )
#ifdef mpas
           floc = mio_search (DESID_STREAM_NAME( ISRM ))
           if (floc > 0) then
              file_exist = .true.
              loc_nvars = mio_file_data(floc)%nvars
              loc_nlays = mio_file_data(floc)%nlays
              allocate (loc_vnames(loc_nvars), loc_units(loc_nvars), stat=status)
              loc_vnames = mio_file_data(floc)%var_name
              loc_units  = mio_file_data(floc)%units
           else
              file_exist = .false.
           end if
#else  
           IF ( .NOT. OPEN3( DESID_STREAM_NAME( ISRM ), FSREAD3, PNAME ) ) THEN
              XMSG = 'Could not open tracer file'
              CALL M3MESG( XMSG )
              file_exist = .false.
           ELSE
              file_exist = .true.
             ! Assign Tracer Emissions Species
             IF ( .NOT. DESC3( DESID_STREAM_NAME( ISRM ) ) ) THEN
                XMSG = 'Could not get '// DESID_STREAM_NAME( ISRM ) // ' file description'
                CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
             END IF
  
             loc_nvars = nvars3d
             loc_nlays = nlays3d
             allocate (loc_vnames(loc_nvars), loc_units(loc_nvars), stat=status)
             loc_vnames = VNAME3d(1:loc_nvars)
             loc_units  = UNITS3D(1:loc_nvars)
           END IF
#endif  

           IF (FILE_EXIST) THEN
             ! Save Tracer Variables for Use in Emissions Species Check
             ! Routine
             DESID_EMVAR( ISRM )%LEN = loc_nvars
             ALLOCATE ( DESID_EMVAR( ISRM )%ARRY( loc_nvars ), STAT = STATUS )
             ALLOCATE ( DESID_EMVAR( ISRM )%UNITS( loc_nvars ), STAT = STATUS )

             DESID_EMVAR( ISRM )%ARRY = loc_vnames
  
             ! Assign Layers to Common Vector
             DESID_GRID_LAYS( ISRM ) = loc_nlays
              
             ! Check Units For Consistency
             UNITSCK = 'BLANK'
             DO N = 1, loc_nvars
                V = INDEX1( loc_vnames( N ), N_SPC_DIFF, DIFF_SPC )
                IF ( V .NE. 0 ) THEN
                  IF ( UNITSCK .EQ. 'BLANK' ) UNITSCK = loc_units( N )
                  IF ( loc_units( N ) .NE. UNITSCK ) THEN
                     XMSG = 'Units not uniform on ' // DESID_STREAM_LAB( ISRM )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
                  END IF
                END IF
                DESID_EMVAR( ISRM )%UNITS( N ) = loc_units( N )
             END DO 
           END IF
           deallocate (loc_vnames, loc_units) 
        END IF   ! tracer emissions
      END DO
  
  
C Open Gridded Emission Files (for gas chem, aerosols and non-reactive species)
      DO ISRM = 1,DESID_N_SRM
        IF ( DESID_STREAM_TYPE( ISRM ) .EQ. 'GRID' ) THEN
          IGR = IGSRM( ISRM )

#ifdef mpas 
          floc = mio_search (DESID_STREAM_NAME( ISRM ))
          call mio_timestamp_to_julian (mio_file_data(floc)%timestamp(1), loc_date, loc_time)
          loc_nvars = mio_file_data(floc)%nvars
          loc_nlays = mio_file_data(floc)%nlays
          allocate (loc_vnames(loc_nvars), loc_units(loc_nvars), stat=status)
          loc_vnames = mio_file_data(floc)%var_name
          loc_units  = mio_file_data(floc)%units
#else
          IF ( .NOT. OPEN3( DESID_STREAM_NAME( ISRM ), FSREAD3, PNAME ) ) THEN
              XMSG = 'Could not open file ' // DESID_STREAM_NAME( ISRM )
              CALL M3MESG( XMSG )
          ELSE
  
            IF ( .NOT. DESC3( DESID_STREAM_NAME( ISRM ) ) ) THEN
              XMSG = 'Could not get '// DESID_STREAM_NAME( ISRM ) // ' file description'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
          END IF
          loc_nvars = NVARS3D
          loc_nlays = nlays3d
          allocate (loc_vnames(loc_nvars), loc_units(loc_nvars), stat=status)
          loc_vnames = VNAME3d(1:loc_nvars)
          loc_units  = UNITS3D(1:loc_nvars)
          loc_date   = sdate3d
#endif
            
          ! Let the date for this emission stream come from the model
          ! by default or the file if the user wishes to override the
          ! default for representative day files
          DESID_STREAM_DATE( ISRM ) = JDATE
          IF ( DESID_STREAM_SYM_DATE( ISRM ) )  DESID_STREAM_DATE( ISRM ) = loc_date
 
          ! Save Area Source Species Names For Use in Emissions Species
          ! Check Routine
          DESID_EMVAR( ISRM )%LEN = loc_nvars
          ALLOCATE ( DESID_EMVAR( ISRM )%ARRY( loc_nvars ), STAT = STATUS )
          ALLOCATE ( DESID_EMVAR( ISRM )%UNITS( loc_nvars ), STAT = STATUS )
          DESID_EMVAR( ISRM )%ARRY = loc_vnames
         
          ! Assign Area Source Emission Species
          DESID_GRID_LAYS( ISRM ) = loc_nlays

          ! Assign Units
          DO IVAR = 1,loc_nvars
                ! A match has been found
                UNITSCK = loc_units( IVAR )
                CALL UPCASE( UNITSCK )
                DESID_EMVAR( ISRM )%UNITS( IVAR ) = loc_units( IVAR )
          END DO
          deallocate (loc_vnames, loc_units)
        END IF    ! (gridded emission file)
      END DO
  
      RETURN
      END SUBROUTINE DESID_OPEN_GR3D
  
  
!-----------------------------------------------------------------------
      SUBROUTINE DESID_OPEN_DIAG( JDATE, JTIME, TSTEP )
!       This subroutine opens diagnostic files for printing the
!       emission rates input to CMAQ after scaling by user emission
!       rules. The rates are put on files dedicated to each individual
!       emissions stream. This adds user flexibility in being able to
!       toggle the diagnostic output for streams individually and
!       reduces the storage space needed for most use cases (presumably
!       users will rarely want to output the data from all of the
!       emissions streams).
!-----------------------------------------------------------------------
      USE UTILIO_DEFN
      USE GRID_CONF
      USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_SPC, DIFF_MASK_GAS, DIFF_MASK_NR,
     &                      DIFF_MASK_AERO, DIFF_MASK_NUM, DIFF_MASK_SRF
      USE MIO_ASCII
  
      IMPLICIT NONE
  
      INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP
  
      CHARACTER( 16 ) :: PNAME = 'OPEN_EMISS_DIAG'
      CHARACTER( 200 ) :: XMSG
  
      INTEGER :: IDIAG, IVAR, NLAYERS, V, ISPEC
      
#ifndef mpas
      DO IDIAG = 1,DESID_N_DIAG
      
        ! Test whether or not each file should be opened
        IF ( DESID_DIAG_FORMAT( IDIAG ) .NE. 'OFF' ) THEN
  
          ! Make File 2D by Default, but 3D if the user requests it
          NLAYERS = 1
          IF ( DESID_DIAG_FORMAT( IDIAG ) .EQ. '3D' ) NLAYERS = DESID_LAYS
  
          ! Set output file characteristics based on COORD.EXT and 
          ! open diagnostic file
          FTYPE3D = GRDDED3
          SDATE3D = STDATE
          STIME3D = STTIME
          TSTEP3D = TSTEP
  
          NVARS3D = DESID_DIAG_SPEC( IDIAG )%NSPEC
          NCOLS3D = GL_NCOLS
          NROWS3D = GL_NROWS
          NLAYS3D = NLAYERS
          NTHIK3D = 1
          GDTYP3D = GDTYP_GD
          P_ALP3D = P_ALP_GD
          P_BET3D = P_BET_GD
          P_GAM3D = P_GAM_GD
          XORIG3D = XORIG_GD
          YORIG3D = YORIG_GD
          XCENT3D = XCENT_GD
          YCENT3D = YCENT_GD
          XCELL3D = XCELL_GD
          YCELL3D = YCELL_GD
          VGTYP3D = VGTYP_GD
          VGTOP3D = VGTOP_GD
          VGLVS3D( 1:NLAYS3D+1 ) = VGLVS_GD( 1:NLAYS3D+1 )
          GDNAM3D = GRID_NAME  ! from HGRD_DEFN
  
          V = 0
          DO IVAR = 1,DESID_DIAG_SPEC( IDIAG )%NSPEC
             V = V + 1
  
             VTYPE3D( V ) = M3REAL
             VNAME3D( V ) = DESID_DIAG_SPEC( IDIAG )%SPEC( IVAR )
             UNITS3D( V ) = DESID_DIAG_SPEC( IDIAG )%UNITS( IVAR )
             VDESC3D( V ) = 'Emission Rate of ' // TRIM( VNAME3D( V ) )
     &                       // ' from ' // TRIM(DESID_DIAG_LAB( IDIAG )) // ' emissions'
          END DO
          
          FDESC3D( 1 ) = 'Instantaneous pollutant emissions from stream: ' // 
     &                   TRIM(DESID_DIAG_LAB( IDIAG ) ) 
          FDESC3D( 2:MXDESC3 ) = ''
  
          ! Store MIO Metadata
          NDIMS3D( 1:NVARS3D ) = 4
          L_TSTEP( 1:NVARS3D ) = .True.
          L_LAY  ( 1:NVARS3D ) = .True.
          L_COL  ( 1:NVARS3D ) = .True.
          L_ROW  ( 1:NVARS3D ) = .True.
          L_VEXT ( 1:NVARS3D ) = .False.

          CALL LOAD_MIO_FILE ( DESID_DIAG_LOGICAL( IDIAG ), NLAYS3D, 1, NLAYS3D,
     &         VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &         VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &         L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &         L_VEXT(1:NVARS3D) )

          ! Open emissions stream diagnostic file
          IF ( .NOT. OPEN3( DESID_DIAG_LOGICAL( IDIAG ), FSNEW3, PNAME ) ) THEN
             XMSG = 'Could not create the ' // TRIM( DESID_DIAG_FILENAME( IDIAG ) ) // ' file'
             CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
          END IF
  
        END IF   ! DESID_STREAM_LDIAG?
      END DO     ! IDIAG
#else
         call mio_fcreate ('EMIS_DIAG',512 )
#endif
  
  
      END SUBROUTINE DESID_OPEN_DIAG

  
C-----------------------------------------------------------------------
       END MODULE DESID_MODULE
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module MOSAIC_MOD
      
C Contains the shared variables and subrountes needed estimate the resistances
C from natural and agricultural lands
 
C Revision History: J. Bash June 16 2011:    Created
C                   J. Young Oct 31 2011:    changed lai0, laimn0, rsmin, VEG0, vegmn0,
C                                             z00, & luf_fac to pointers to save memory
C                   D. Schwede Mar 12 2012:  fixed errors in crop lai
C                   D. Schwede Sept 07 2012: updated code for NLCD40 land use classification
C                   J. Bash:   Nov 07  2014: Modified for the restructuring of vidff. Most 
C                                            mosaic variables were moved to ASX_DATA_MOD. 
C                                            Algorithms were restructured using fortran 90 
C                                            array constructs for readability.
C                   D. Wong:   Feb 10  2019: removed all MY_N clauses
C                   D. Wong:   Apr 24  2019: removed unused BUFF2D_2 array
C-------------------------------------------------------------------------------

      Implicit None
      
C Private variables used in this module and subroutines       
      Real, Save, Allocatable, Private :: fseas          ( :,: ) ! Non-agricultural seasonal leaf on/off 0.0-1.0 where 1.0 is leaf on condutions
      Real, Save, Allocatable, Private :: f_land         ( :,: ) ! fraction of the grid cell that is land
      Real, Save, Allocatable, Private :: sum_mos_lai    ( :,: ) ! sum of the land use LAI used for normalization
      Real, Save, Allocatable, Private :: sum_mos_veg    ( :,: ) ! sum of the land use VEG used for normalization
      Real, Save, Allocatable, Private :: vseas          ( :,: ) ! Agricultural seasonal leaf on/off 0.0-1.0 where 1.0 is leaf on condutions
      Real, Save, Allocatable, Private :: znotc          ( :,: ) ! land use surface roughness lenth for momentum (m)
      Real, Save, Allocatable, Private :: lu_mean_ga     ( :,: ) ! mean land use aerodynamic conductance used for normalization (m/s)
      Real, Save, Allocatable, Private :: lu_mean_ustar  ( :,: ) ! mean land use ustar used for normalization (m/s)

      Integer, Save, Allocatable, Private :: lstwetdate( :,: ) ! last wet date
      Integer, Save, Allocatable, Private :: lstwettime( :,: ) ! last wet time 

      Integer,         PRIVATE :: ALLOCSTAT
      Integer, Save, PRIVATE :: l_ag, l_agmos
      Logical, Save, Allocatable,  PRIVATE :: is_ag( : )     ! Agricultural flag
      Logical, Save, Allocatable,  PRIVATE :: is_agmos( : )  ! Agricultural mosaic flag
      Logical, Save, Allocatable,  PRIVATE :: is_water( : )  ! Water flag

C Buffer variables  
      Real, Pointer, Private :: BUFF2D       ( :,: )

      Type :: Tile_Type                
         Integer                      :: n_vd ! number of gas species for tiled output
         Integer                      :: n_lufrac  ! number of land use for tiled output
         Real,            Allocatable :: RSMIN        ( : ) ! minimum stomatal resistance (s/m)
         Real,            Allocatable :: Z00          ( : ) ! momentum roughness length (m)
         Real,            Allocatable :: VEG0         ( : ) ! maximum vegetation coverage (%)
         Real,            Allocatable :: VEGMN0       ( : ) ! minimum vegetation coverage (%)
         Real,            Allocatable :: LAI0         ( : ) ! maximum lai (m2/m2)
         Real,            Allocatable :: LAIMN0       ( : ) ! minimum lai (m2/m2)
         Real,            Allocatable :: NH3_gam_grnd ( : ) ! soil/litter surface NH3 emission potential ([NH4]/[H])
         Real,            Allocatable :: NH3_gam_st   ( : ) ! vegetation NH3 emission potential ([NH4]/[H])
         Real,            Allocatable :: Hg_grnd      ( : ) ! soil Hg concentration (umol/g )
         Real,            Allocatable :: l_width      ( : ) ! aerodynamic leaf width (m)
         Real,            Allocatable :: Alpha        ( : ) ! Emerson et al 2020 PNAS empirical land use factor (unitless)
         Real,            Allocatable :: BAI          ( : ) ! building area index (m2/m2)
         Real,            Allocatable :: Ahair        ( : ) ! leaf hair width (m)
         Real,            Allocatable :: Fhair        ( : ) ! ratio of leaf covered in hairs
         Real,            Allocatable :: Aleaf        ( : ) ! aerodynamic leaf width 
!> Mapping for diagnostic ouputs
         Character( 16 ), Allocatable :: cat_lu       ( : ) ! Tiled LU name
         Character( 16 ), Allocatable :: name_lu      ( : ) ! Land use output name
         Logical,         Allocatable :: gas_out      ( : ) ! vector of length N_SPC_DIFF with TRUE for output
         Character( 16 ), Allocatable :: Vd_Name      ( : ) ! Deposition species output name
         Logical,         Allocatable :: Vd_out       ( : ) ! vector of length N_SPC_DEPV with TRUE for output
         Integer,         Allocatable :: dep2vdiff    ( : ) ! Vdiff location for dep species
         Real,            Allocatable :: Vd_fac       ( : ) ! Vd factor from the GC, NR, and TR namelists
!> Mean grid cell output 
         Real,            Allocatable :: Grd_Vd     ( :,:,: ) ! Grid mean gaseous and aerosol deposition velocity
         Real,            Allocatable :: Bidi_Emis  ( :,:,: ) ! Grid bidirectional Emissions
!> Aggrigated fractional land use       
         Real,            Allocatable :: LUfrac     ( :,:,: ) ! land use fraction (ratio)
!> Sub grid cell output:
         Real,            Allocatable :: Lu_Vd      ( :,:,:,: ) ! gaseous and aerosol deposition velocity
      End Type Tile_Type

      Type( Tile_Type ),     Save :: Tile_Data 
      
      Contains

         Subroutine Init_Mosaic( jdate, jtime, lufrac ) 
       
         Use HGRD_DEFN
         Use LSM_Mod
         Use UTILIO_DEFN
         USE STAGE_DATA, Only:dep_gas_all ! needs to be n_gas_asx to save memory but will require remapping
         USE CGRID_SPCS          ! CGRID mechanism species
         USE RUNTIME_VARS
         USE CENTRALIZED_IO_MODULE, Only: WR_AVAIL
       
         Implicit None    

C...include files

         Include SUBST_FILES_ID   ! file name parameters                 
       
         Integer, Intent( In )  :: jdate
         Integer, Intent( In )  :: jtime
         Real, Intent( In )  :: lufrac( :,:,: )    
         Character( 240 )       :: xmsg = ' '
         Character(  16 ), save :: pname = 'Init_Mosaic'
         Integer n,l,s
         Integer N_GAS_DEPV
         Integer gxoff, gyoff            ! global origin offset from file
         Integer :: strtcolgc2, endcolgc2, strtrowgc2, endrowgc2

! Allocate Tile Data
         ALLOCATE ( Tile_Data%cat_lu       ( n_stage_lu ),
     &              Tile_Data%name_lu      ( n_stage_lu ), 
     &              Tile_Data%RSMIN        ( n_stage_lu ),
     &              Tile_Data%LAI0         ( n_stage_lu ),
     &              Tile_Data%LAIMN0       ( n_stage_lu ),
     &              Tile_Data%VEG0         ( n_stage_lu ),
     &              Tile_Data%VEGMN0       ( n_stage_lu ),
     &              Tile_Data%Z00          ( n_stage_lu ),
     &              Tile_Data%NH3_gam_st   ( n_stage_lu ),
     &              Tile_Data%NH3_gam_grnd ( n_stage_lu ),
     &              Tile_Data%Hg_grnd      ( n_stage_lu ),
     &              Tile_Data%l_width      ( n_stage_lu ),
     &              Tile_Data%Alpha        ( n_stage_lu ),
     &              Tile_Data%BAI          ( n_stage_lu ),
     &              Tile_Data%Ahair        ( n_stage_lu ),
     &              Tile_Data%Fhair        ( n_stage_lu ),
     &              Tile_Data%Aleaf        ( n_stage_lu ),STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating tile land use specific data'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If

! STAGE land use 
         Tile_Data%n_lufrac = n_stage_lu
         Tile_Data%cat_lu       = STAGE_LU_Data( 1:n_stage_lu )%LU_Cat
         Tile_Data%name_lu      = STAGE_LU_Data( 1:n_stage_lu )%LU_Name
         Tile_Data%RSMIN        = STAGE_LU_Data( 1:n_stage_lu )%RSMIN
         Tile_Data%LAI0         = STAGE_LU_Data( 1:n_stage_lu )%LAI0
         Tile_Data%LAIMN0       = STAGE_LU_Data( 1:n_stage_lu )%LAIMN0
         Tile_Data%VEG0         = STAGE_LU_Data( 1:n_stage_lu )%VEG0
         Tile_Data%VEGMN0       = STAGE_LU_Data( 1:n_stage_lu )%VEGMN0
         Tile_Data%Z00          = STAGE_LU_Data( 1:n_stage_lu )%Z00
         Tile_Data%NH3_gam_st   = STAGE_LU_Data( 1:n_stage_lu )%Gamma_NH3_st
         Tile_Data%NH3_gam_grnd = STAGE_LU_Data( 1:n_stage_lu )%Gamma_NH3_grnd
         Tile_Data%Hg_grnd      = STAGE_LU_Data( 1:n_stage_lu )%Hg_grnd
         Tile_Data%l_width      = STAGE_LU_Data( 1:n_stage_lu )%l_width
         Tile_Data%Alpha        = STAGE_LU_Data( 1:n_stage_lu )%Alpha
         Tile_Data%BAI          = STAGE_LU_Data( 1:n_stage_lu )%BAI
         Tile_Data%Ahair        = STAGE_LU_Data( 1:n_stage_lu )%Ahair
         Tile_Data%Fhair        = STAGE_LU_Data( 1:n_stage_lu )%Fhair
         Tile_Data%Aleaf        = STAGE_LU_Data( 1:n_stage_lu )%Aleaf
                                                                                                  
! Allocate buffers
         ALLOCATE ( BUFF2D( ncols,nrows ), STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating 2D Buffers'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If
         
         ALLOCATE ( fseas          ( ncols,nrows ),
     &              f_land         ( ncols,nrows ),
     &              sum_mos_lai    ( ncols,nrows ),
     &              sum_mos_veg    ( ncols,nrows ),  
     &              vseas          ( ncols,nrows ),
     &              znotc          ( ncols,nrows ), 
     &              lu_mean_ga     ( ncols,nrows ), 
     &              lu_mean_ustar  ( ncols,nrows ),  STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating MOSAIC 2D variables'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If
         f_land        = 0.0

         IF( .not. WR_AVAIL ) Then
            ALLOCATE ( lstwetdate     ( ncols,nrows ),
     &                 lstwettime     ( ncols,nrows ), STAT = ALLOCSTAT )
            If ( ALLOCSTAT .Ne. 0 ) Then
               XMSG = 'Failure allocating MOSAIC lstwetdate and lstwettime'
               Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            End If
            lstwetdate  = 0
            lstwettime  = 0
         End If

         N_GAS_DEPV = N_GC_DEPV + N_NR_DEPV + N_TR_DEPV
         Allocate ( Tile_Data%Lu_Vd     ( ncols,nrows,N_SPC_DEPV,Tile_Data%n_lufrac ), 
     &              Tile_Data%Grd_Vd    ( ncols,nrows,N_SPC_DEPV ),  
     &              Tile_Data%Bidi_Emis ( ncols,nrows,N_SPC_DEPV ),
     &              Tile_Data%LUfrac    ( ncols,nrows,Tile_Data%n_lufrac ),
     &              Tile_Data%Vd_Name   ( N_SPC_DEPV ),
     &              Tile_Data%Vd_Fac    ( N_SPC_DEPV ),
     &              Tile_Data%Vd_Out    ( N_SPC_DEPV ),        
     &              Tile_Data%dep2vdiff ( N_SPC_DEPV ),  
     &              STAT = ALLOCSTAT ) 
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating MOSAIC deposition velocities'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If
         Tile_Data%Lu_Vd     = 0.0
         Tile_Data%Grd_Vd    = 0.0
         Tile_Data%Bidi_Emis = 0.0
         Tile_Data%Vd_Fac    = 0.0  
         Tile_Data%dep2vdiff = 0        

! Map Met land use to STAGE land use
         Tile_Data%LUfrac = 0.0
         Do n = 1, n_xref_lu
            s = MET_TO_STAGE_LU( n )%Dep_Index 
            l = MET_TO_STAGE_LU( n )%Met_Index
            Tile_Data%LUfrac(:,:,s) = Tile_Data%LUfrac(:,:,s) +
     &            MET_TO_STAGE_LU( n )%Factor * lufrac(:,:,l)
         End Do

         Allocate ( is_ag    ( Tile_Data%n_lufrac ),
     &              is_agmos ( Tile_Data%n_lufrac ), 
     &              is_water ( Tile_Data%n_lufrac ), STAT = ALLOCSTAT )   
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating is_ag, is_agmos, is_water'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If
         is_ag    = .FALSE.
         is_agmos = .FALSE.
         is_water = .FALSE.

! Get the location of ag and water in the land use fractions
         Do l = 1, Tile_Data%n_lufrac
            If(Tile_Data%cat_lu(l) .Eq. 'AG'   ) Then
               is_ag( l )    = .TRUE.
               l_ag          = l
            End If
            If(Tile_Data%cat_lu(l) .Eq. 'AGMOS') Then
               is_agmos( l ) = .TRUE.
               l_agmos       = l
            End If
            If(Tile_Data%cat_lu(l) .Eq. 'WATER') Then
               is_water( l ) = .TRUE.
            Else
               f_land = f_land + Tile_Data%lufrac(:,:,l)
            End If
         End Do

         Return   
          
         End Subroutine Init_Mosaic
       
         Subroutine calc_lai( jday, jtime, SOIT2, LAI, VEG,
     &                        MOS_VEG, MOS_LAI, MOS_Z0  )

C***********************************************************************
C  Function:
C     Calculate the lai for each LUC in the gridcell
C  Preconditions:  none
C  Subroutines and Functions Called:  none
C  Revision History:
C***********************************************************************

         Use LSM_Mod

         Implicit None

C Arguments:
         Integer, Intent( In )  :: jday
         Integer, Intent( In )  :: jtime     
         Real,    Intent( In )  :: SOIT2( :,: )
         Real,    Intent( In )  :: LAI( :,: )
         Real,    Intent( In )  :: VEG( :,: )
         Real,    Intent( Out ) :: MOS_VEG( :,:,: )
         Real,    Intent( Out ) :: MOS_LAI( :,:,: )
         Real,    Intent( Out ) :: MOS_Z0( :,:,: )

C Local variables:
         Integer :: c,r,j

C Local volatile variables:
         Real, Pointer :: d_past_emer ( :,: )

C initialize
         vseas           = 0.0
         fseas           = 0.0
         znotc           = 0.0
         BUFF2D        = 0.0
         MOS_VEG         = 0.0
         MOS_LAI         = 0.0
         MOS_Z0          = 0.0
         sum_mos_lai     = 0.0
         sum_mos_veg     = 0.0

C calculate fseas based on deep soil temperature
         Where( SOIT2 .Lt. 290.0 .And. SOIT2 .Gt. 282.0 )
            fseas = 1.0 - 0.015625 * ( 290.0 - SOIT2 ) ** 2
         Elsewhere( SOIT2 .Ge. 290.0 )
            fseas = 1.0
         Elsewhere
            fseas = 0.0
         End where
C based on a 10 C germination temperature for 5 cm soil depth reported multiple agricultural extension offices, 
C e.g. https://www.agry.purdue.edu/ext/corn/news/timeless/Emergence.html. 
         Where( SOIT2 .Lt. 290.0 .And. SOIT2 .Gt. 283.0 )
            vseas = 1.0 - ( 290.0 - SOIT2 ) ** 2 / 49.0 
         Elsewhere( SOIT2 .Ge. 290.0 )
            vseas = 1.0
         Elsewhere
            vseas = 0.0
         End where
C find z0_crop by finding days past emergence
         d_past_emer => BUFF2D
         d_past_emer =  0.0
         d_past_emer = ( ( Tile_Data%LAIMN0( l_ag ) + vseas * ( Tile_Data%LAI0( l_ag )
     &                -    Tile_Data%LAIMN0( l_ag ) ) ) ** ( 1.0 / 1.923 ) ) / 2.273
         d_past_emer = max(0.0184 * 0.0184 - 4.0 * 1.057e-4 * d_past_emer,0.0)
         d_past_emer = ( 0.0184 - SQRT( d_past_emer ) ) / ( 2.0 * 1.057E-4 )
         znotc = 0.05
         Where ( d_past_emer .Gt. 87.0 )
            znotc = 0.15
         Elsewhere( d_past_emer .Gt. 0.0 )
            znotc = 5.00 + 0.23 * d_past_emer - 1.32E-3 * d_past_emer**2
            znotc = znotc / 100.0  ! convert to meters
         End Where
         Nullify( d_past_emer )
C get individual LAIs for LUCs for this date 

         Do j = 1, Tile_Data%n_lufrac
            If( is_water( j ) ) Then
               Where( Tile_Data%LUFRAC( :,:,j ) .Gt. 0.0 )
                  MOS_Z0 ( :,:,j )  = Tile_Data%Z00( j )
               End Where
            Else
               If ( .NOT. is_ag( j ) .And. .NOT. is_agmos( j ) ) Then
                  Where( Tile_Data%LUFRAC( :,:,j ) .Gt. 0.0 )
                     MOS_VEG( :,:,j ) = ( Tile_Data%VEGMN0( j ) + 
     &                                  fseas * ( Tile_Data%VEG0( j ) - Tile_Data%VEGMN0( j ) )  )/100.
                     MOS_LAI( :,:,j ) = Tile_Data%LAIMN0( j ) + 
     &                                  fseas * ( Tile_Data%LAI0( j ) - Tile_Data%LAIMN0( j ) )
                     MOS_Z0 ( :,:,j )  = Tile_Data%Z00( j )
                  End Where
               Else If( is_ag( j ) ) Then
                  Where( Tile_Data%LUFRAC( :,:,j ) .Gt. 0.0 )
                     MOS_VEG( :,:,j ) = ( Tile_Data%VEGMN0( j ) + 
     &                                  vseas * ( Tile_Data%VEG0( j ) - Tile_Data%VEGMN0( j ) )  )/100.
                     MOS_LAI( :,:,j ) = Tile_Data%LAIMN0( j ) + 
     &                                  vseas * ( Tile_Data%LAI0( j ) - Tile_Data%LAIMN0( j ) )
                     MOS_Z0 ( :,:,j )  = znotc
                  End Where
               Else If( is_agmos( j ) ) Then ! assume 50% natural and 50% crop
                     MOS_VEG( :,:,j ) = ( Tile_Data%VEGMN0( j ) + 
     &                                  ( vseas + fseas ) / 2.0 * ( Tile_Data%VEG0( j ) - Tile_Data%VEGMN0( j ) )  )/100.
                     MOS_LAI( :,:,j ) = Tile_Data%LAIMN0( j ) + 
     &                                  ( vseas + fseas ) / 2.0 * ( Tile_Data%LAI0( j ) - Tile_Data%LAIMN0( j ) )
                     MOS_Z0 ( :,:,j )  = 0.5 * ( znotc + Tile_Data%Z00( j ) )
               End If
               sum_mos_lai = sum_mos_lai + MOS_LAI( :,:,j ) *  Tile_Data%LUFRAC( :,:,j )
               sum_mos_veg = sum_mos_veg + MOS_VEG( :,:,j ) *  Tile_Data%LUFRAC( :,:,j )
            End If
         End Do
C Now normalize the data to the meteorological LAI and VEG
         Do j = 1, Tile_Data%n_lufrac 
            If( .NOT. is_water( j ) .AND. maxval( Tile_Data%LUFRAC( :,:,j ) ) .Gt. 0.0 ) Then
               Where( sum_mos_lai .Gt. 0.0 .And. LAI .Gt. 0.0 .And. sum_mos_veg .Gt. 0.0 .And. VEG .Gt. 0.0 )
                  MOS_LAI( :,:,j ) = MOS_LAI( :,:,j ) * LAI / sum_mos_lai
                  MOS_VEG( :,:,j ) = MOS_VEG( :,:,j ) * VEG / sum_mos_veg
               End Where
               Where( MOS_LAI( :,:,j ) .Gt. 6.0 )
                  MOS_LAI( :,:,j ) = 6.0
               End Where
               Where( MOS_VEG( :,:,j ) .Gt.  0.999 ) ! not VEG0(j) to support earlier versions of WRF and satellite Veg 
                  MOS_VEG( :,:,j ) =  0.999
               End Where
               Where( MOS_VEG( :,:,j ) .Eq.  0.0 .Or. MOS_LAI( :,:,j ) .Eq.  0.0 )
                  MOS_LAI( :,:,j ) = 0.0
                  MOS_VEG( :,:,j ) = 0.0
               End Where
            End If
         End Do         

         Return

         End Subroutine Calc_LAI      

C*********************************************************************************************
C                    RA_WRF based on PX LSM
C*********************************************************************************************
         Subroutine RA_WRF( MOLI, ZH, RA, Z0, MOS_Z0, USTAR, MOS_USTAR,
     &                      MOS_RA, gamah, betah, karman )   

         Use LSM_Mod

         Implicit None

         Real, Intent( In )     :: gamah              ! MOST coefficient for stability correction for unstable conditions [unitless]
         Real, Intent( In )     :: betah              ! MOST coefficient for stability correction for stable conditions [unitless]
         Real, Intent( In )     :: karman             ! von Karman constant [unitless]
         Real, Intent( In )     :: MOLI( :,: )        ! 1 over the Obukhov length [1/m]
         Real, Intent( In )     :: ZH( :,:,: )        ! mid-layer height above ground [m]
         Real, Intent( In )     :: RA( :,: )          ! grid aerodynamic resistance [s/m]
         Real, Intent( In )     :: Z0( :,: )          ! grid momentum roughness length [m]
         Real, Intent( In )     :: USTAR( :,: )       ! grid friction velocity [m/s]
         Real, Intent( InOut )  :: MOS_Z0( :,:,: )    ! land use momentum roughness length [m]
         Real, Intent( InOut )  :: MOS_USTAR( :,:,: ) ! land use friction velocity [m/s]
         Real, Intent( InOut )  :: MOS_RA( :,:,: )    ! land use aerodynamic resistance [s/m]

         Integer            :: j
         Real, Parameter    :: pr0        = 0.95      ! turbulent Prandtl number

C local volatile variable
         Real, Pointer :: PSIH   ( :,: ) ! Stability correction to the vertical wind profile

         lu_mean_ga    = 0.0
         lu_mean_ustar = 0.0
C Get surface flux variables
         Do j = 1, Tile_Data%n_lufrac
            Where( Tile_Data%LUFRAC( :,:,j ) .EQ. 1.0 .OR. ZH( :,:,1 ) .EQ. MOS_Z0( :,:,j ) )
                   MOS_USTAR( :,:,j ) = USTAR
                   MOS_Z0( :,:,j )    = Z0
            Elsewhere( Tile_Data%LUFRAC( :,:,j ) .Gt. 0.0 )
                   MOS_USTAR( :,:,j ) = USTAR * SQRT( LOG( ZH( :,:,1 ) / Z0 )
     &                                / LOG( ZH( :,:,1 ) / MOS_Z0( :,:,j ) ) )
            End Where
         End Do  

         PSIH => BUFF2D
         PSIH = 0.0
         Do j = 1,Tile_Data%n_lufrac
            Where( MOLI .Lt. 0.0 ) ! checked against PX
               PSIH = 2.0 * Log( ( Sqrt( 1.0 - gamah * ZH( :,:,1 ) * MOLI ) + 1.0 ) / 
     &                              ( Sqrt( 1.0 - gamah * MOS_Z0( :,:,j ) * MOLI ) + 1.0 ) )
            Else Where ( ( ZH( :,:,1 ) - MOS_Z0( :,:,j ) ) * MOLI .Le. 1.0 )
               PSIH = -betah * ( ZH( :,:,1 ) - MOS_Z0( :,:,j ) ) * MOLI
            Else Where
               PSIH = 1.0 - betah - ( ZH( :,:,1 ) - MOS_Z0( :,:,j ) ) * MOLI
            End Where
            Where ( Tile_Data%LUFRAC( :,:,j ) .Eq. 1.0 ) 
               MOS_RA( :,:,j ) = RA
            Elsewhere( Tile_Data%LUFRAC( :,:,j ) .Gt. 0.0 )
               MOS_RA( :,:,j ) = pr0 * ( Log( ZH( :,:,1 ) / MOS_Z0( :,:,j ) ) - PSIH ) / 
     &                                 ( karman * MOS_USTAR( :,:,j ) )
            End Where
         End Do
         Nullify( PSIH )
! Normalization loops
         Do j = 1,Tile_Data%n_lufrac
            Where( Tile_Data%LUFRAC( :,:,j ) .Gt. 0.0 )
               lu_mean_ga    = lu_mean_ga    + Tile_Data%LUFRAC( :,:,j ) / MOS_RA( :,:,j )
               lu_mean_ustar = lu_mean_ustar + Tile_Data%LUFRAC( :,:,j ) * MOS_USTAR( :,:,j )
            End Where
         End Do
         Do j = 1,Tile_Data%n_lufrac
            Where( Tile_Data%LUFRAC( :,:,j ) .Gt. 0.0 )
               MOS_RA( :,:,j )    = RA    * MOS_RA( :,:,j )    * lu_mean_ga
               MOS_USTAR( :,:,j ) = USTAR * MOS_USTAR( :,:,j ) / lu_mean_ustar
            End Where
         End Do         
         
         Return
         End Subroutine RA_WRF

C*********************************************************************************************
C                    MOS_Rst
C*********************************************************************************************
         Subroutine MOS_RSTW(MOS_LAI, RGRND, SOIM2, WWLT, WFC, TEMP2, MOS_RA, MOS_USTAR, 
     &                       QSS_GRND, QV, RST, MOS_RST)

         Use LSM_Mod
         Use GRID_CONF           ! horizontal & vertical domain specifications

         Implicit None

         Real, Intent( In )  :: MOS_LAI( :,:,: )
         Real, Intent( In )  :: RGRND( :,: )
         Real, Intent( In )  :: SOIM2( :,: )
         Real, Intent( In )  :: WWLT( :,: )
         Real, Intent( In )  :: WFC( :,: )
         Real, Intent( In )  :: TEMP2( :,: )
         Real, Intent( In )  :: MOS_RA( :,:,: )
         Real, Intent( In )  :: MOS_USTAR( :,:,: )
         Real, Intent( In )  :: QSS_GRND( :,: )
         Real, Intent( In )  :: QV( :,:,: )
         Real, Intent( In )  :: RST( :,: )
         Real, Intent( Out ) :: MOS_RST( :,:,: )

         Real :: f1, f1max, par      ! radiation variables
         Real :: f2, w2avail, w2mxav ! soil moisture variables
         Real :: f3, gs, ga, raw     ! humidity variables
         Real :: f4                  ! temperature variables
         Real :: ftot, fshelt        ! combined Jarvis variables
         Real :: lu_tot              ! total land use where Rst is estiamted
         Real :: cor_fact            ! correction factor to match met model RST
         Real, Parameter :: f3min      = 0.25
         Real, Parameter :: ftmin      = 0.0000001  ! m/s
         Real, Parameter :: rsmax      = 5000.0     ! s/m
         Real            :: max_mos_gst, mos_gst   ! area weighted conductance
         Integer         :: c, r, j                 ! loop induction variables
         
         DO c = 1, NCOLS
            DO r = 1, NROWS
              lu_tot       = 0.0             
              If( f_land( c,r ) .Gt. 0.0 .And. RST( c,r ) .Ge. 1.0e30 ) Then
!-SOIL MOISTURE
                  w2avail = SOIM2( c,r ) - WWLT( c,r )
                  w2mxav  = WFC ( c,r ) - WWLT( c,r )
                  f2      = 1.0 / ( 1.0 + EXP( -5.0 * ( w2avail / w2mxav -
     &                    ( w2mxav / 3.0 + WWLT( c,r ) ) ) ) )    ! according JP, 9/94
!-AIR TEMP
!... according to Avissar (1985) and AX 7/95
                  IF ( TEMP2( c,r ) .LE. 302.15 ) THEN
                     f4 = 1.0 / ( 1.0 + EXP( -0.41 * (TEMP2( c,r ) - 282.05 ) ) )
                  ELSE
                     f4 = 1.0 / ( 1.0 + EXP( 0.5 * (TEMP2( c,r ) - 314.0 ) ) )
                  END IF
!-RADIATION
                  par = 0.45 * RGRND( c,r ) * 4.566
                  DO j = 1, Tile_Data%n_lufrac
                     IF ( Tile_Data%LUFRAC( c,r,j ) .GT. 0.0 .AND. MOS_LAI( c,r,j ) .LT. 0.00001 ) THEN
                           MOS_RST( c,r,j ) = rsmax
                     ELSE IF ( Tile_Data%LUFRAC( c,r,j ) .GT. 0.0 ) THEN
                        IF ( Tile_Data%rsmin( j ) .GT. 130.0 ) THEN
                           f1max = 1.0-0.02*MOS_LAI( c,r,j )
                        ELSE
                           f1max = 1.0-0.07*MOS_LAI( c,r,j )
                        END IF
                        f1  = f1max * ( 1.0 - exp( -0.0017 * par ) )
                        f1  = amax1( f1, Tile_Data%rsmin( j ) / rsmax )
                        ftot = MOS_LAI( c,r,j ) * f1 * f2 * f4
                        ftot = MAX( ftot,ftmin )
                        fshelt = 1.0   ! go back to NP89
                        gs     = ftot / ( Tile_Data%rsmin( j ) * fshelt )
                        raw    = MOS_RA( c,r,j ) + 4.503 / MOS_USTAR( c,r,j )
                        ga     = 1.0 / raw
!-- Compute humidity effect according to RH at leaf surf
                        f3 = 0.5 * ( gs - ga + SQRT( ga * ga + ga * gs
     &                   * ( 4.0 * QV( c,r,1 ) / QSS_GRND( c,r ) - 2.0 ) + gs * gs ) ) / gs
                        f3 = MIN ( MAX( f3, f3min ), 1.0 )
                        MOS_RST( c,r,j ) = 1.0 / ( gs * f3 )
                     END IF
                  END DO ! lufrac
               Else If( f_land( c,r ) .Gt. 0.0 ) Then
! Simply weight Rst by land use Rst_min. The weighting must be done as a conductance following Ohm's law
! as the deposition pathways are in parallel
                  max_mos_gst = Sum( Tile_Data%LUFRAC( c,r,: ) / Tile_Data%rsmin)
! Normalize to the mean meterological model grid cell value               
                  DO j = 1, Tile_Data%n_lufrac
                     mos_gst          = 1.0 / RST( c,r ) / ( max_mos_gst * Tile_Data%rsmin( j ) )
                     MOS_RST( c,r,j ) = 1.0 / mos_gst 
                     If( MOS_RST( c,r,j ) * MOS_LAI( c,r,j ) .Lt. Tile_Data%rsmin( j )  .And. 
     &                   MOS_LAI( c,r,j ) .Gt. 0.0 ) Then
                        MOS_RST( c,r,j ) = Tile_Data%rsmin( j ) / MOS_LAI( c,r,j )
                     Else If ( MOS_LAI( c,r,j ) .Eq. 0.0 ) Then
! this does not impact results but reset the RST to the maximum value if there is no veg
                        MOS_RST( c,r,j ) = 1.0e6
                     End If
                  End Do
               END IF ! LWMASK
            END DO ! rows
         END DO ! cols
         Return
         End Subroutine MOS_RSTW

C*********************************************************************************************
C                    MOS_CanWat
C*********************************************************************************************
         Subroutine MOS_CanWat(MOS_VEG, MOS_LAI, WR, MOS_DELTA, WR_AVAIL, Q2, QSS_Grnd,
     &                         Rn, Rc, Wspd, Rgrnd, jdate, jtime)

         Use LSM_Mod
         Use GRID_CONF           ! horizontal & vertical domain specifications
         Use UTILIO_DEFN

         Implicit None

         Real,    Intent( In )  :: MOS_VEG( :,:,: )
         Real,    Intent( In )  :: MOS_LAI( :,:,: )
         Real,    Intent( In )  :: WR( :,: )
         Real,    Intent( In )  :: Q2( :,: )
         Real,    Intent( In )  :: QSS_Grnd( :,: )
         Real,    Intent( In )  :: Rn( :,: )
         Real,    Intent( In )  :: Rc( :,: )
         Real,    Intent( In )  :: Wspd( :,: )
         Real,    Intent( In )  :: Rgrnd( :,: )
         Logical, Intent( In )  :: WR_AVAIL
         Integer, Intent( In )  :: jdate
         Integer, Intent( In )  :: jtime
         Real,    Intent( Out ) :: MOS_DELTA( :,:,: )

         Real            :: rh_grnd
         Integer         :: c,r,j                 ! loop induction variables
         Integer         :: elapsedsec            ! seconds from last precip

         IF ( .NOT. WR_AVAIL ) THEN  ! approx canopy wetness - dew from Wesely
            ! canopy is wet if > trace precip. or moist with light winds
            DO r = 1, nrows
            DO c = 1, ncols
               rh_grnd  = 100.0 * Q2( c,r ) / QSS_Grnd( c,r )
               rh_grnd  = MIN( 100.0, rh_grnd )
               IF ( ( Rn( c,r ) + Rc( c,r ) .GT. 0.025 ) .OR.
     &              ( (0.6 + Wspd( c,r ))*(100.0-rh_grnd) .LE. 19.0 ) ) THEN

                  MOS_DELTA( c,r,: ) = 1.0
                  lstwetdate( c,r )  = jdate
                  lstwettime( c,r )  = jtime

               ELSE

                  IF ( Rgrnd( c,r ) .GT. 5.0 ) THEN  ! day (if at night, persist delta)

                  ! Determine if canopy was recently wet.

                     IF ( ( lstwetdate( c,r ) .GT. 0 ) .AND.
     &                    ( lstwettime( c,r ) .GT. 0 ) ) THEN  ! canopy recently wet

                        elapsedsec = secsdiff ( lstwetdate( c,r ),
     &                                          lstwettime( c,r ),
     &                                          jdate, jtime )

                        IF ( ( elapsedsec .GT.     0 ) .AND.    ! assume canopy stays
     &                       ( elapsedsec .LE. 7200 ) ) THEN    ! wet for 2 h
                           MOS_DELTA( c,r,: ) = 1.0
                        ELSE IF ( ( elapsedsec .GT.  7200 ) .AND.     ! ramp down DELTA
     &                            ( elapsedsec .LT. 10800 ) ) THEN    ! between 2 & 3 h
                           MOS_DELTA( c,r,: ) = ( 10800.0 - FLOAT( elapsedsec ) ) / 3600.0
                        ELSE
                           MOS_DELTA( c,r,: ) = 0.0
                           lstwetdate( c,r )  = 0
                           lstwettime( c,r )  = 0
                        END IF
                     END IF
                  END IF
               END IF
            End Do ! col
            End Do ! row
            Where ( MOS_LAI .LE. 0.0 )
               MOS_DELTA = 0.0
            End Where
         Else
            DO j = 1, Tile_Data%n_lufrac
               Where ( ( WR .LE. 0.0 ) .or. ( MOS_LAI(:,:,j) .LE. 0.0 ) )
                  MOS_DELTA( :,:,j ) = 0.0
               Elsewhere( Tile_Data%LUFRAC( :,:,j ) .Gt. 0.0 )
                  MOS_DELTA( :,:,j ) = WR / ( 0.2e-3 * MOS_VEG(:,:,j) * MOS_LAI(:,:,j) )   ! refer to SiB model
               End Where
            End Do
         End If
         Where( MOS_DELTA .GT. 1.0 ) 
            MOS_DELTA = 1.0
         ElseWhere( MOS_DELTA .LT. 0.0 ) 
            MOS_DELTA = 0.0
         End Where               

         Return
         End Subroutine MOS_CanWat
      
      End Module Mosaic_Mod

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
      MODULE ELMO_INIT_DEFN

      USE ELMO_DATA
      USE RUNTIME_VARS, ONLY : LOGDEV,LOG_MESSAGE,LOG_HEADING,LOG_SUBHEADING
      
      CONTAINS
!-------------------------------------------------------------------------
      SUBROUTINE ELMO_INIT( TSTEP )
      ! This subroutine calls subroutines that read user input and build
      ! the ELMO_TABLE. It then maps output file variables to the ELMO
      ! TABLE and creates the ELMO_LOCAL vector for efficient storage of
      ! ELMO results, with maps to the calculation IDs and output file
      ! vectors.
!-------------------------------------------------------------------------
   
      USE ELMO_DERIVED_DEFN, ONLY : ELMO_MAP_DERIVED
      USE GRID_CONF, ONLY : NCOLS, NROWS
      USE ELMO_COMPOSITES, ONLY : ELMO_MAP_COMPOSITES, ELMO_READ_COMPOSITES
      USE AERO_DATA, ONLY : N_MODE
#ifdef isam
      USE SA_DEFN, ONLY : NTAG_SA
#endif
#ifdef sens
      USE DDM3D_DEFN, ONLY : NPMAX
#endif

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: TSTEP
      INTEGER N, M, P, J, IM, ILIST, S, F, NLAYS, N_VARS
      INTEGER ID, IV, ISRC, IT, IS, NM, NS, IVAR, IFL
      INTEGER N1, N2, N3, MX_SRC
      CHARACTER( 16 ), SAVE :: PNAME = 'ELMO_INIT'
      CHARACTER( 500 ) :: XMSG
      INTEGER ALLOCSTAT, IOS, IERROR
      INTEGER :: N_MAP_MODE_SOURCE, N_MAP_MODE, N_MAP_SOURCE

      CALL LOG_MESSAGE( LOGDEV,'' )
      CALL LOG_HEADING( LOGDEV, 'Initialize ELMO Module' )

      ! Read User-Input from Namelist input file (CMAQ Control File)
      CALL READ_ELMO_NML(TSTEP)
      IF ( .NOT. L_ELMO ) RETURN
      
      ! Initialize Shared Output Variables like AOD, Extinction, and
      ! other Global Variables
      CALL ELMO_INIT_SHARED()

      ! Read Mechanism-Specific Composite Variables so they may be added
      ! to the ELMO Table next
      CALL LOG_SUBHEADING( LOGDEV, 'Reading and Mapping ELMO variables' )
      CALL ELMO_READ_COMPOSITES()

      ! Initialize ELMO Table for all possible output variables
      CALL LOG_MESSAGE( LOGDEV, 'Building ELMO Table' )
      CALL BUILD_ELMO_TABLE()

      ! Map Special Indices for ELMO Derived Variable components
      CALL LOG_MESSAGE( LOGDEV, 'Mapping ELMO Derived Variable Components' )
      CALL ELMO_MAP_DERIVED()

      ! Map All Table Variables to their components, if applicable
      CALL LOG_MESSAGE( LOGDEV, 'Map ELMO Composite Variables' )
      CALL LOG_MESSAGE( LOGDEV, 'Mapping ELMO Composites' )
      CALL ELMO_MAP_COMPOSITES()

      ! ELMO FILE INITIALIZATION
      ! Determine which ELMO_TABLE variables belong on each output file
      ALLOCATE( L_ELMO_TABLE_USED( N_ELMO_TABLE ), STAT=IOS )
      CALL CHECKMEM( IOS, 'L_ELMO_TABLE_USED',PNAME ) 
      L_ELMO_TABLE_USED(:) = .FALSE.

      ALLOCATE( L_ELMO_TABLE_OUT( N_ELMO_TABLE ), STAT=IOS )
      CALL CHECKMEM( IOS, 'L_ELMO_TABLE_OUT',PNAME ) 

      ALLOCATE( ELMO_OUT( N_ELMO_FILES ), STAT=IOS )
      CALL CHECKMEM( IOS, 'ELMO_OUT',PNAME ) 

      L_ELMO_DDEP = .FALSE.
      L_ELMO_WDEP = .FALSE.

      DO IFL = 1,N_ELMO_FILES
         L_ELMO_TABLE_OUT = .FALSE.
         CALL MAP_ELMO_NML( IFL, L_ELMO_TABLE_OUT, IERROR )
         IF ( IERROR .GT. 0 ) THEN
            ! Entry Doesn't Match any variable on the ELMO table. Crash the model.
            XMSG = 'An ELMO variable has been requested that does not exist.'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF
         
         ! Identify which ELMO_TABLE variables are Used and
         ! allocate/map ELMO_USED vector
         L_ELMO_TABLE_USED(:) = L_ELMO_TABLE_USED .OR. L_ELMO_TABLE_OUT

         ! Populate ELMO FILE Mapping Indices
         ELMO_FILE(IFL)%N_VARS = COUNT( L_ELMO_TABLE_OUT(:) )
         N_VARS = ELMO_FILE(IFL)%N_VARS
         ALLOCATE( ELMO_FILE(IFL)%TABID( N_VARS ),
     &             ELMO_FILE(IFL)%USEDID( N_VARS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'ELMO_FILE IDs',PNAME ) 
         ELMO_FILE( IFL )%TABID = 0
         ELMO_FILE( IFL )%USEDID = 0

         N = 0
         DO J = 1,N_ELMO_TABLE
             IF ( L_ELMO_TABLE_OUT( J ) ) THEN 
                 N = N + 1
                 ELMO_FILE( IFL )%TABID( N ) = J
         
                 ! Check that all components are defined
                 IF ( ELMO_TABLE( J )%VAR_TYPE .EQ. ET_CMPST .OR.
     &                ELMO_TABLE( J )%VAR_TYPE .EQ. ET_CMPST_DEP .OR.
     &                ELMO_TABLE( J )%VAR_TYPE .EQ. ET_ISAM_CMPST .OR.
     &                ELMO_TABLE( J )%VAR_TYPE .EQ. ET_ISAM_CMPST_DEP .OR.
     &                ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DDM_CMPST .OR.
     &                ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DDM_CMPST_DEP ) THEN
                    DO IVAR = 1,ELMO_COMP( J )%N_VARS
                       IF ( ELMO_COMP( J )%TABID( IVAR ) .EQ. 0 ) THEN
                          WRITE( XMSG, '(3A,I2,A,I2,6A)' ) 'The ELMO COMPOSITE variable ',
     &                         TRIM( ELMO_TABLE( J )%NAME ),' requested on file ',
     &                         IFL,' has a component (#',
     &                         IVAR,') that is not available on the comprehensive ', 
     &                         'ELMO Table. If this is a source-resolved ISAM COMPOSITE, ',
     &                         'then it is recommended to check that the components ',
     &                         'of this COMPOSITE are activated in the ISAM control ', 
     &                         'file. If this is not an ISAM simulation, check to ', 
     &                         'make sure all components are defined.'
                          CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
                       END IF
                    END DO
                 END IF
             END IF
         END DO
         
         ! Allocate space for this file's data array
         NLAYS = ELMO_FILE( IFL )%NLAYS
         N_VARS = ELMO_FILE( IFL )%N_VARS
         ALLOCATE( ELMO_OUT( IFL )%DATA( 
     &               NCOLS,NROWS,NLAYS,N_VARS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'ELMO_OUT', PNAME )
         ELMO_OUT( IFL )%DATA(:,:,:,:) = 0.0
      END DO

      LAY_TOP_MAX = MAXVAL( ELMO_FILE( : )%LAY_TOP )
      LAY_BOT_MIN = MINVAL( ELMO_FILE( : )%LAY_BOT )

      N_ELMO_USED = COUNT( L_ELMO_TABLE_USED )
      ALLOCATE( ELMO_USED( N_ELMO_USED ), STAT=IOS )
      CALL CHECKMEM( IOS, 'ELMO_USED',PNAME ) 
      ELMO_USED = 0.0
      ALLOCATE( MAP_USEDtoTABLE( N_ELMO_USED ), STAT=IOS )
      CALL CHECKMEM( IOS, 'MAP_USEDtoTABLE',PNAME ) 
      MAP_USEDtoTABLE = 0
      ALLOCATE( MAP_TABLEtoUSED( N_ELMO_TABLE ), STAT=IOS )
      CALL CHECKMEM( IOS, 'MAP_TABLEtoUSED',PNAME ) 
      MAP_TABLEtoUSED = 0

      N = 0
      DO J = 1,N_ELMO_TABLE
          IF ( L_ELMO_TABLE_USED( J ) ) THEN
              N = N + 1
              MAP_TABLEtoUSED( J ) = N
              MAP_USEDtoTABLE( N ) = J

              DO IFL = 1,N_ELMO_FILES
                DO IVAR = 1,ELMO_FILE( IFL )%N_VARS
                  IF ( ELMO_FILE( IFL )%TABID( IVAR ) .EQ. J ) 
     &               ELMO_FILE( IFL )%USEDID( IVAR ) = N 
                END DO
              END DO
          END IF    
      END DO

      ! Allocate array for tracking whether or not a variable has been
      ! calculated each time step.
      ALLOCATE( L_CALCULATED( N_ELMO_USED ), 
     &          ELMO_USED_UNIT( N_ELMO_USED ), STAT=IOS )
      CALL CHECKMEM( IOS, 'L_CALCULATED',PNAME )
      L_CALCULATED = .FALSE.
      ELMO_USED_UNIT = 0


      ! Write Output Variable Information to Log File
      CALL ELMO_WRITE_LOG()

      END SUBROUTINE ELMO_INIT
 
!-------------------------------------------------------------------------
      SUBROUTINE READ_ELMO_NML( TSTEP )
!     This subroutine maps the ELMO variables that the user has
!       requested to the entries in the ELMO_DATA table.
!-------------------------------------------------------------------------
      
      USE RUNTIME_VARS, ONLY: CMAQ_CTRL, APPL_NAME, OUTDIR
      
      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: TSTEP
      INTEGER               :: FUNIT
      INTEGER               :: STAT

      INTEGER IVAR, N_MX_VARS, N_FILES, N_MAX_OUTPUT_VARIABLES,
     &        N_KEYWORDS, N_MAX_KEYWORD_VARIABLES, N_MX_KEYVARS
      CHARACTER(30), ALLOCATABLE :: FLABEL( : )
      CHARACTER(16), ALLOCATABLE :: FTYPE( : )
      INTEGER, ALLOCATABLE       :: FTSTEP( : )
      CHARACTER(10), ALLOCATABLE :: TMODE( : )
      INTEGER, ALLOCATABLE       :: LAY_BOT( : )
      INTEGER, ALLOCATABLE       :: LAY_TOP( : )
      CHARACTER(32), ALLOCATABLE :: FILE_VARS(:,:)
      CHARACTER(32), ALLOCATABLE :: KEYWD_NAME( : )
      CHARACTER(32), ALLOCATABLE :: KEYWD(:,:)
                       
      CHARACTER( 200 ) :: SUFFIX = '.nc'
      CHARACTER( 16 ), SAVE :: PNAME = 'READ_ELMO_NML'
      CHARACTER( 200 )   :: XMSG
      CHARACTER( 200 )   :: TMPLINE
      INTEGER IOS, IFL, N_VARS, VALUE, N, IKEY
      CHARACTER( 5 )     :: CFIL

      NAMELIST / ELMO_INIT  / N_Files, N_Max_Output_Variables,
     &                        N_Keywords, N_Max_Keyword_Variables
      NAMELIST / ELMO_FILES / Flabel, Tmode, 
     &                       Lay_Bot, Lay_Top, File_Vars,
     &                       Keywd_name, Keywd

      L_ELMO = .TRUE.

      CALL LOG_SUBHEADING( LOGDEV, 'Reading ELMO File Specifications '//
     &                             'from CMAQ Control Namelist')
 
      ! Set the standard suffix for all ELMO Output Files
      IF ( APPL_NAME(1:8 ) .NE. 'CTM_APPL' ) SUFFIX = '_' // TRIM(APPL_NAME) // SUFFIX
        
      ! Retrieve the Name of the CMAQ Control File
      IF ( CMAQ_CTRL .EQ. "CMAQ_CTRL_NML" ) THEN
          WRITE( LOGDEV, "(5x,A,/,5x,A,/,5x,A)"),
     &           'You have chosen not to indicate the location of a',
     &           'CMAQ_Control.nml namelist file. No ELMO output files ',
     &           'will be created.'
          N_ELMO_FILES = 0
          L_ELMO = .FALSE.
          RETURN
      END IF
 
      ! Open Mechanism-Specific Control File
      FUNIT = JUNIT()
      OPEN( FILE = CMAQ_CTRL, UNIT = FUNIT, STATUS = 'OLD',
     &      POSITION = 'REWIND', FORM='FORMATTED', IOSTAT = STAT )

      ! Check for Error in File Open Process
      IF ( STAT .NE. 0 ) THEN
          WRITE( XMSG, '(A,A,A)' ),'ERROR: Could not read ',
     &           'CMAQ Control namelist file: ',TRIM( CMAQ_CTRL )
          CALL M3EXIT( PNAME,0,0,XMSG,1 )
      END IF

      ! Read the number of ELMO Composite Variables
      N_FILES = 0
      N_MAX_OUTPUT_VARIABLES = 40
      N_KEYWORDS = 0
      N_MAX_KEYWORD_VARIABLES = 40

      REWIND( FUNIT )
      READ( NML = ELMO_INIT, UNIT = FUNIT, IOSTAT=STAT )
      IF ( STAT .EQ. -1 ) THEN
          ! The Number of Files was completely missing
          XMSG = 'WARNING: Number of ELMO Files was not specified. '//
     &           'If you intended to specify composite variables for ELMO, '//
     &           'check the CMAQ Control Namelist file. CMAQ will not '//
     &           'write any ELMO output files.'
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          N_ELMO_FILES = 0
          N_KEY = 0
          L_ELMO = .FALSE.
          RETURN

      ELSE IF ( STAT .NE. 0 ) THEN
          ! Read Error detected for ELMO_INIT
          backspace( FUNIT )
          read( FUNIT, fmt='(A)' ) tmpline
          XMSG = 'ERROR: There was a syntax error reading the number of '//
     &           'ELMO Files. Please '//
     &           'check the format of each line for syntax errors. The '//
     &           'invalid line was likely: '
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE
          CALL M3EXIT ( PNAME, 0, 0, 'CMAQ must Crash until you '//
     &                  'fix the specification.', 1 )
      END IF

      ! If there are no files, then just return
      N_ELMO_FILES = N_FILES
      N_MX_VARS = N_MAX_OUTPUT_VARIABLES
      N_KEY = N_KEYWORDS
      N_MX_KEYVARS = N_MAX_KEYWORD_VARIABLES
      IF ( N_ELMO_FILES .LE. 0 ) THEN
          L_ELMO = .FALSE.
          RETURN
      END IF

      ! Allocate and Initialize Namelist Variables
      ALLOCATE( FLABEL( N_FILES ), FTYPE( N_FILES ), FTSTEP( N_FILES ),
     &          TMODE( N_FILES ), LAY_BOT( N_FILES ),
     &          LAY_TOP( N_FILES ), FILE_VARS( N_FILES, N_MX_VARS ),
     &          KEYWD_NAME( N_KEY ), KEYWD( N_KEY,N_MX_KEYVARS ),
     &          STAT=STAT )
      CALL CHECKMEM( STAT, 'ELMO_FILE_NML',PNAME)
      FILE_VARS = ''
      KEYWD = ''
      FTSTEP(:) = TSTEP

      ! Read User-Specified ELMO file data from input namelist
      REWIND( FUNIT )
      READ( NML = ELMO_FILES, UNIT = FUNIT, IOSTAT=STAT )
      IF ( STAT .NE. 0 ) THEN
          ! Read Error detected for ELMO_INIT
          backspace( FUNIT )
          read( FUNIT, fmt='(A)' ) tmpline
          XMSG = 'ERROR: There was a syntax error reading the  '//
     &           'ELMO File Data. Please check the format of each '//
     &           'line for syntax errors. The invalid line was likely: '
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE
          CALL M3EXIT ( PNAME, 0, 0, 'CMAQ must Crash until you '//
     &                  'fix the specification.', 1 ) 
      END IF

      ! Populate ELMO_FILE Structure
      ALLOCATE( ELMO_FILE( N_ELMO_FILES ), STAT=STAT )
      CALL CHECKMEM( STAT, 'ELMO_FILE',PNAME)

      DO IFL = 1,N_ELMO_FILES
        ! Type of Grid
        FTYPE(:) = 'GRIDDED'
        CALL UPCASE( FTYPE( IFL ) )
        IF ( FTYPE( IFL ) .EQ. 'GRIDDED' ) THEN
            ELMO_FILE( IFL )%STRUCT     = 0
        ELSE IF ( FTYPE( IFL ) .EQ. 'UNSTRUCTURED' ) THEN
            ELMO_FILE( IFL )%STRUCT     = 1
        ELSE
            WRITE( XMSG, "(A,I3.3,A)"),
     &             'An ELMO file may only be gridded or unstructured.  '//
     &             'Please revise the value of Ftype(',IFL,') in ELMO_FILE.'
            CALL M3EXIT ( PNAME, 0, 0, XMSG, 1 ) 
        END IF

        ! Set ELMO Output File Name with Path and File Logical      
        WRITE( CFIL, '(I0)' ), IFL
        ELMO_FILE( IFL )%SHORTNAME = 'ELMO' // TRIM(CFIL) // '_' //
     &                              TRIM( FLABEL(IFL) ) 
        ELMO_FILE( IFL )%FILENAME = 'CCTM_ELMO' // TRIM(CFIL) // '_' //
     &                              TRIM( FLABEL(IFL) ) // TRIM( SUFFIX )
        WRITE( ELMO_FILE( IFL )%FLOGICAL, '( "ELMO_",I3.3 )' ) IFL
        IF ( OUTDIR .NE. '' ) THEN
            ELMO_FILE( IFL )%FILENAME = TRIM( OUTDIR ) // '/' // 
     &                                  TRIM( ELMO_FILE( IFL )%FILENAME )
        END IF
#ifndef mpas
        VALUE = SETENVVAR( ELMO_FILE( IFL )%FLOGICAL, ELMO_FILE( IFL )%FILENAME )
#endif

        ! Output Time Step
        ELMO_FILE( IFL )%TSTEP = FTSTEP( IFL )
        CALL UPCASE( TMODE( IFL ) )
        IF ( TMODE( IFL ) .EQ. 'INSTANT' ) THEN
           ELMO_FILE( IFL )%TMODE = 0
        ELSE IF ( TMODE( IFL ) .EQ. 'AVERAGE' ) THEN
           ELMO_FILE( IFL )%TMODE = 1
        ELSE
            WRITE( XMSG, "(A,I3.3,A)")
     &             'An ELMO file may only be average or instantaneous.  '//
     &             'Please revise the value of Tmode(',IFL,') in ELMO_FILE.'
            CALL M3EXIT ( PNAME, 0, 0, XMSG, 1 ) 
        END IF

        ! Layers
        CALL ELMO_CHECK_LAYERS( LAY_TOP( IFL ), LAY_BOT( IFL ), IFL )
        ELMO_FILE( IFL )%LAY_BOT = LAY_BOT( IFL )
        ELMO_FILE( IFL )%LAY_TOP = LAY_TOP( IFL )
        ELMO_FILE( IFL )%NLAYS   = LAY_TOP( IFL ) - LAY_BOT( IFL ) + 1

        ! Allocate Field for Input Variables
        ELMO_FILE( IFL )%N_VARS     = 0 
        ELMO_FILE( IFL )%N_VARS_IN = N_MX_VARS
        ALLOCATE( ELMO_FILE( IFL )%VARS_IN( N_MX_VARS ), STAT = IOS )
        CALL CHECKMEM( IOS, 'ELMO_FILE%VARS_IN',PNAME ) 
        ELMO_FILE( IFL )%VARS_IN(1:N_MX_VARS) = 
     &       FILE_VARS( IFL,1:N_MX_VARS )

      END DO
      
      ! Populate KeyWords and Contents
      ALLOCATE( ELMO_KEY( N_KEY ), STAT=IOS )
      CALL CHECKMEM( IOS, 'ELMO_KEY',PNAME )

      DO IKEY = 1,N_KEY
         ELMO_KEY( IKEY )%WORD = KEYWD_NAME( IKEY )

         N = 0
         DO IVAR = 1,N_MX_KEYVARS
            IF ( KEYWD( IKEY,IVAR ) .NE. '' ) N = N + 1
         END DO

         ELMO_KEY( IKEY )%N = N
         ALLOCATE( ELMO_KEY( IKEY )%LIST( N ), STAT=IOS )
         CALL CHECKMEM( IOS, 'ELMO_KEY%LIST',PNAME )
         DO IVAR = 1,N
            ELMO_KEY( IKEY )%LIST( IVAR ) = KEYWD( IKEY,IVAR )
         END DO
      END DO

      END SUBROUTINE READ_ELMO_NML

!-------------------------------------------------------------------------
      SUBROUTINE BUILD_ELMO_TABLE()
!     This subroutine creates the main table of all possible output
!     variables including ELMO variables, bulk aerosol species, CGRID
!     species, and chemical families
!-------------------------------------------------------------------------

      USE AERO_DATA, ONLY: N_MODE, AEROMODE, N_AEROSPC, AEROSPC,
     &                     AEROSPC_MW
      USE CGRID_SPCS, ONLY : N_CGRID_SPC, CGRID_NAME, CGRID_MW,
     &                       CGRID_UNITS, CGRID_CONC_DESC,
     &                       CGRID_MASK_NUM, CGRID_MASK_SRF,
     &                       CGRID_MASK_AERO,
     &                       WDEP_SPC, N_SPC_WDEP, MAP_WDEPtoCGRID,
     &                       MAP_DDEPtoCGRID, N_SPC_DDEP
      USE VDIFF_MAP, ONLY : DDEP_SPC
      USE ELMO_COMPOSITES, ONLY : N_COMPOSITES, CMPST
      USE GRID_CONF, ONLY : MYPE
      USE UTILIO_DEFN

#ifdef isam
      USE SA_DEFN, ONLY : TAGNAME, NSPC_SA, NTAG_SA, ISAM_SPEC,
     &                    MAP_SAtoCGR, MAP_AEROtoSA
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY : NPMAX, SEN_PAR, N_ASENS_VARS
#endif

      IMPLICIT NONE

      INTEGER       :: ILIST, IUNIT, IFAM, S, IM, ICGRID,
     &                 IWDEP, IDDEP, ICMPST, IMODE, ISPC
      INTEGER       :: VAR_TYPE
      INTEGER       :: N, IAERO, IOS, ITAG, ISPEC, NP, INDX,
     &                 N_TABLE
      CHARACTER(32) :: PNAME = 'BUILD_ELMO_TABLE'
      CHARACTER(200):: XMSG

      N = 0
      N_TABLE = 2000

#ifdef isam 
      N_TABLE = N_TABLE * NTAG_SA
#elif defined( sens )
      N_TABLE = N_TABLE * NPMAX
#endif
      ALLOCATE( ELMO_TABLE( N_TABLE ), STAT=IOS )
      CALL CHECKMEM( IOS, 'ELMO_TABLE',PNAME ) 

      ! Initialize Mode and Source Attributes
      ELMO_TABLE(:)%IM = 0
      ELMO_TABLE(:)%SOURCE = 0

      ! Load the ELMO Derived Variables into the ELMO_Table
      DO ILIST = 1,N_ELMO_LIST
         N = N + 1
         ELMO_TABLE( N )%NAME = ELMO_LIST( ILIST )%NAME
         ELMO_TABLE( N )%OUT_NAME = ELMO_LIST( ILIST )%NAME
         ELMO_TABLE( N )%OUT_TYPE = M3REAL
         ELMO_TABLE( N )%VAR_TYPE = ELMO_LIST( ILIST )%VAR_TYPE
         ELMO_TABLE( N )%ID = ELMO_LIST( ILIST )%ID
         ELMO_TABLE( N )%CUNIT = ELMO_LIST( ILIST )%UNIT
         CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                        ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
         ELMO_TABLE( N )%IUNIT = IUNIT
         ELMO_TABLE( N )%DESC = ELMO_LIST( ILIST )%DESC
         ELMO_TABLE( N )%MW   = 0.0
            
         IF ( ELMO_LIST( ILIST )%L_MODE ) THEN
           ! Set Mode-Dependent Properties for this variables first mode
           ELMO_TABLE( N )%IM = 1
           ELMO_TABLE( N )%OUT_NAME = TRIM(ELMO_LIST( ILIST)%NAME)//'_'//aeromode( 1 )%suff 
           ELMO_TABLE( N )%DESC = TRIM(ELMO_LIST( ILIST )%DESC) // ' for mode ' //
     &                            aeromode(1)%suff
           
           ! Define ELMO Variables for all remaining modes
           DO IM = 2,N_MODE
             N = N + 1
             ELMO_TABLE( N ) = ELMO_TABLE( N-1 )
             ELMO_TABLE( N )%IM = IM
             ELMO_TABLE( N )%OUT_NAME = TRIM(ELMO_LIST( ILIST )%NAME)//
     &                                      '_' // aeromode( IM )%suff
             ELMO_TABLE( N )%DESC = TRIM(ELMO_LIST( ILIST )%DESC) // ' for mode ' //
     &                              aeromode(IM)%suff
           END DO
         END IF
      END DO

#ifdef isam                     
      ! Load the source-resolvable Derived variables into the ELMO Table
      ! to enable ISAM output.
      DO ILIST = 1,N_ELMO_LIST
        IF ( ELMO_LIST( ILIST )%VAR_TYPE .EQ. ET_DRVD .OR.
     &       ELMO_LIST( ILIST )%VAR_TYPE .EQ. ET_DRVD_DDEP .OR.
     &       ELMO_LIST( ILIST )%VAR_TYPE .EQ. ET_DRVD_WDEP ) THEN
           ! Define ELMO Variables for all ISAM sources
           DO ITAG = 1,NTAG_SA
             N = N + 1
             ELMO_TABLE( N )%NAME = TRIM(ELMO_LIST( ILIST )%NAME)
     &                              // '_ISAM'
             ELMO_TABLE( N )%OUT_NAME = TRIM(ELMO_LIST( ILIST )%NAME) 
     &                              // '_' // TRIM(TAGNAME( ITAG ))
             ELMO_TABLE( N )%OUT_TYPE = M3REAL
             ELMO_TABLE( N )%VAR_TYPE = ELMO_LIST( ILIST )%VAR_TYPE + 10
             ELMO_TABLE( N )%ID = ELMO_LIST( ILIST )%ID
             ELMO_TABLE( N )%CUNIT =  ELMO_LIST( ILIST )%UNIT
             CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                            ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
             ELMO_TABLE( N )%IUNIT = IUNIT

             ELMO_TABLE( N )%SOURCE = ITAG
             ELMO_TABLE( N )%DESC = ELMO_LIST( ILIST )%DESC // 
     &             ' for source ' // TRIM(TAGNAME( ITAG ))
             ELMO_TABLE( N )%MW   = 0.0
           END DO 
           
           ! Set Source-Dependent Properties for the sum of sources
           N = N + 1
           ELMO_TABLE( N ) = ELMO_TABLE( N-1 )
           ELMO_TABLE( N )%OUT_NAME = TRIM(ELMO_LIST( ILIST )%NAME) // '_TAGS'
           ELMO_TABLE( N )%SOURCE = NTAG_SA + 1
           ELMO_TABLE( N )%DESC = ELMO_LIST( ILIST )%DESC // 
     &           ' for the sum of all sources.'
        END IF
      END DO
#endif         

#ifdef sens
      ! Load the source-resolvable Derived variables into the ELMO Table
      ! to enable ISAM output.
      DO ILIST = 1,N_ELMO_LIST
        IF ( ELMO_LIST( ILIST )%VAR_TYPE .EQ. ET_DRVD .OR.
     &       ELMO_LIST( ILIST )%VAR_TYPE .EQ. ET_DRVD_DDEP .OR.
     &       ELMO_LIST( ILIST )%VAR_TYPE .EQ. ET_DRVD_WDEP ) THEN
           
           ! Define ELMO Variables for all remaining DDM3D sources
           DO NP = 1,NPMAX
             N = N + 1
             ELMO_TABLE( N )%NAME = TRIM(ELMO_LIST( ILIST )%NAME)
     &                              // '_DDM'
             ELMO_TABLE( N )%OUT_NAME = TRIM(ELMO_LIST( ILIST )%NAME)
     &                              // '_' // TRIM( SEN_PAR( NP ) )
             ELMO_TABLE( N )%OUT_TYPE = M3REAL
             ELMO_TABLE( N )%VAR_TYPE = ELMO_LIST( ILIST )%VAR_TYPE + 20
             ELMO_TABLE( N )%ID = ELMO_LIST( ILIST )%ID
             ELMO_TABLE( N )%SOURCE = NP
             ELMO_TABLE( N )%CUNIT =  ELMO_LIST( ILIST )%UNIT
             CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                            ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
             ELMO_TABLE( N )%IUNIT = IUNIT
             ELMO_TABLE( N )%DESC = 'Sensitivity of ' // ELMO_LIST( ILIST )%DESC // 
     &             ' to ' // TRIM( SEN_PAR( NP ) )
             ELMO_TABLE( N )%MW   = 0.0
           END DO
         END IF
      END DO
#endif         
 
      ! Load CGRID Species into ELMO_Table
      DO ICGRID = 1,N_CGRID_SPC
         IF ( CGRID_NAME( ICGRID ) .NE. 'RHOJ' ) THEN
            N = N + 1
            ELMO_TABLE( N )%NAME = CGRID_NAME( ICGRID )
            ELMO_TABLE( N )%OUT_NAME = CGRID_NAME( ICGRID )
            ELMO_TABLE( N )%OUT_TYPE = M3REAL
            ELMO_TABLE( N )%VAR_TYPE = ET_CONC
            ELMO_TABLE( N )%ID = ICGRID
           
            DO IMODE = 1,N_MODE
              DO ISPC = 1,N_AEROSPC
                IF ( CGRID_NAME( ICGRID ) .EQ. AEROSPC(ISPC)%NAME(IMODE) )
     &             ELMO_TABLE( N )%IM = IMODE
              END DO
            END DO
           
            ELMO_TABLE( N )%CUNIT = CGRID_UNITS( ICGRID )
            CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                           ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
            ELMO_TABLE( N )%IUNIT = IUNIT
            ELMO_TABLE( N )%DESC = CGRID_CONC_DESC( ICGRID )
            ELMO_TABLE( N )%MW   = CGRID_MW( ICGRID )
         END IF
      END DO    

      ! Load Deposition Variables into ELMO_Table
      ! Load Wet Deposition Fluxes
      DO IWDEP = 1,N_SPC_WDEP
        N = N + 1
        ELMO_TABLE( N )%NAME = 'WD_' // WDEP_SPC( IWDEP )
        ELMO_TABLE( N )%OUT_NAME = 'WD_' // WDEP_SPC( IWDEP )
        ELMO_TABLE( N )%OUT_TYPE = M3REAL
        ELMO_TABLE( N )%VAR_TYPE = ET_WDEP

        DO IMODE = 1,N_MODE
          DO ISPC = 1,N_AEROSPC
            IF ( WDEP_SPC( IWDEP ) .EQ. AEROSPC(ISPC)%NAME(IMODE) )
     &         ELMO_TABLE( N )%IM = IMODE
          END DO
        END DO

        ICGRID = MAP_WDEPtoCGRID( IWDEP )
        ELMO_TABLE( N )%ID = ICGRID
        ELMO_TABLE( N )%MW  = CGRID_MW( ICGRID )
        IF ( CGRID_MASK_NUM( ICGRID ) ) THEN
           ELMO_TABLE( N )%CUNIT = 'ha-1'
        ELSE IF ( CGRID_MASK_SRF( ICGRID ) ) THEN
           ELMO_TABLE( N )%CUNIT = 'm2 ha-1'
        ELSE
           ELMO_TABLE( N )%CUNIT = 'kg ha-1'
        END IF
        CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                       ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
        ELMO_TABLE( N )%IUNIT = IUNIT
        ELMO_TABLE( N )%DESC = 'Wet Deposition for Species '//
     &                         TRIM( WDEP_SPC( IWDEP ) )
      END DO

      ! Load Dry Deposition Fluxes
      DO IDDEP = 1,N_SPC_DDEP
        N = N + 1
        ELMO_TABLE( N )%NAME = 'DD_' // DDEP_SPC( IDDEP )
        ELMO_TABLE( N )%OUT_NAME = 'DD_' // DDEP_SPC( IDDEP )
        ELMO_TABLE( N )%OUT_TYPE = M3REAL
        ELMO_TABLE( N )%VAR_TYPE = ET_DDEP

        DO IMODE = 1,N_MODE
          DO ISPC = 1,N_AEROSPC
            IF ( DDEP_SPC( IDDEP ) .EQ. AEROSPC(ISPC)%NAME(IMODE) )
     &         ELMO_TABLE( N )%IM = IMODE
          END DO
        END DO

        ICGRID = MAP_DDEPtoCGRID( IDDEP )
        ELMO_TABLE( N )%ID = ICGRID
        ELMO_TABLE( N )%MW  = CGRID_MW( ICGRID )
        IF ( CGRID_MASK_NUM( ICGRID ) ) THEN
           ELMO_TABLE( N )%CUNIT = 'ha-1'
        ELSE IF ( CGRID_MASK_SRF( ICGRID ) ) THEN
           ELMO_TABLE( N )%CUNIT = 'm2 ha-1'
        ELSE
           ELMO_TABLE( N )%CUNIT = 'kg ha-1'
        END IF
        CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                       ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
        ELMO_TABLE( N )%IUNIT = IUNIT
        ELMO_TABLE( N )%DESC = 'Dry Deposition Flux for Species '//
     &                         TRIM( DDEP_SPC( IDDEP ) )
      END DO
 
#ifdef isam
      ! Load ISAM CGRID Variables into ELMO Table
      DO ISPEC = 1,NSPC_SA
        DO ITAG = 1,NTAG_SA
           N = N + 1
           ELMO_TABLE( N )%NAME = TRIM(ISAM_SPEC( ISPEC,ITAG ))
     &                            // '_ISAM'
           ELMO_TABLE( N )%OUT_NAME = TRIM(ISAM_SPEC( ISPEC,ITAG ))
     &                            // '_' // TRIM(TAGNAME( ITAG )) 
           ELMO_TABLE( N )%OUT_TYPE = M3REAL
           ELMO_TABLE( N )%VAR_TYPE = ET_ISAM_CONC
           ELMO_TABLE( N )%ID = ISPEC
           ELMO_TABLE( N )%SOURCE = ITAG
           ICGRID = MAP_SAtoCGR( ISPEC )
           IF ( CGRID_MASK_AERO( ICGRID ) ) THEN
              ELMO_TABLE( N )%CUNIT = 'ug m-3'
           ELSE
              ELMO_TABLE( N )%CUNIT = 'ppmV'
           END IF
        
           DO IMODE = 1,N_MODE
             DO ISPC = 1,N_AEROSPC
               IF ( ISAM_SPEC( ISPEC,ITAG ) .EQ. AEROSPC(ISPC)%NAME(IMODE) )
     &            ELMO_TABLE( N )%IM = IMODE
             END DO
           END DO

           CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                          ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
           ELMO_TABLE( N )%IUNIT = IUNIT
           ELMO_TABLE( N )%DESC = 'ISAM Concentration of Species '//
     &                     TRIM( ISAM_SPEC( ISPEC,ITAG ) ) //
     &                     ' from source ' // TRIM(TAGNAME( ITAG ))
           ELMO_TABLE( N )%MW  = CGRID_MW( ICGRID )
        END DO

        N = N + 1
        ELMO_TABLE( N ) = ELMO_TABLE( N-1 )
        ELMO_TABLE( N )%OUT_NAME = TRIM(ISAM_SPEC( ISPEC,1 )) //'_TAGS'
        ELMO_TABLE( N )%SOURCE = NTAG_SA + 1
        ELMO_TABLE( N )%DESC = 'ISAM Concentration of Species '//
     &                  TRIM( ISAM_SPEC( ISPEC,1 ) ) //
     &                  ' from the sum of sources.'
      END DO


      ! Load ISAM Wet Deposition Fluxes into ELMO Table
      DO IWDEP = 1,N_SPC_WDEP
        DO ISPEC = 1,NSPC_SA
          IF ( ISAM_SPEC( ISPEC,1 ) .EQ. WDEP_SPC( IWDEP ) ) THEN
          DO ITAG = 1,NTAG_SA
             N = N + 1
             ELMO_TABLE( N )%NAME = 'WD_' //TRIM( WDEP_SPC( IWDEP ) )
     &                              // '_ISAM'
             ELMO_TABLE( N )%OUT_NAME = 'WD_' // TRIM( WDEP_SPC( IWDEP ) )
     &                              // '_' // TRIM(TAGNAME( ITAG )) 
             ELMO_TABLE( N )%OUT_TYPE = M3REAL
             ELMO_TABLE( N )%VAR_TYPE = ET_ISAM_WDEP
             ELMO_TABLE( N )%ID = ISPEC
             ELMO_TABLE( N )%SOURCE = ITAG
             ICGRID = MAP_WDEPtoCGRID( IWDEP )
             IF ( CGRID_MASK_NUM( ICGRID ) ) THEN
                ELMO_TABLE( N )%CUNIT = 'ha-1'
             ELSE IF ( CGRID_MASK_SRF( ICGRID ) ) THEN
                ELMO_TABLE( N )%CUNIT = 'm2 ha-1'
             ELSE
                ELMO_TABLE( N )%CUNIT = 'kg ha-1'
             END IF
             
             DO IMODE = 1,N_MODE
               DO ISPC = 1,N_AEROSPC
                 IF ( WDEP_SPC( IWDEP ) .EQ. AEROSPC(ISPC)%NAME(IMODE) )
     &              ELMO_TABLE( N )%IM = IMODE
               END DO
             END DO
          
             CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                            ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
             ELMO_TABLE( N )%IUNIT = IUNIT
             ELMO_TABLE( N )%DESC = 'Tagged Wet Deposition Flux of '//
     &          TRIM( WDEP_SPC( IWDEP ) ) //' from '// TRIM( TAGNAME( ITAG ) ) 
             ELMO_TABLE( N )%MW  = CGRID_MW( ICGRID )
          END DO 
          
          N = N + 1
          ELMO_TABLE( N ) = ELMO_TABLE( N-1 )
          ELMO_TABLE( N )%OUT_NAME = 'WD_' // TRIM( WDEP_SPC( IWDEP ) ) // '_TAGS'
          ELMO_TABLE( N )%SOURCE = NTAG_SA + 1
          ELMO_TABLE( N )%DESC = 'Tagged Wet Deposition Flux of '//
     &       TRIM( WDEP_SPC( IWDEP ) ) //' from all sources.'
          END IF
        END DO
      END DO

      ! Load ISAM Dry Deposition Fluxes into ELMO Table
      DO IDDEP = 1,N_SPC_DDEP
        DO ISPEC = 1,NSPC_SA 
          IF ( ISAM_SPEC( ISPEC,1 ) .EQ. DDEP_SPC( IDDEP ) ) THEN
          DO ITAG = 1,NTAG_SA
             N = N + 1
             ELMO_TABLE( N )%NAME = 'DD_' //TRIM(DDEP_SPC( IDDEP ))
     &                              // '_ISAM'
             ELMO_TABLE( N )%OUT_NAME = 'DD_' // TRIM(DDEP_SPC( IDDEP ))
     &                              // '_' // TRIM(TAGNAME( ITAG )) 
             ELMO_TABLE( N )%OUT_TYPE = M3REAL
             ELMO_TABLE( N )%VAR_TYPE = ET_ISAM_DDEP
             ELMO_TABLE( N )%ID = ISPEC
             ELMO_TABLE( N )%SOURCE = ITAG
             ICGRID = MAP_DDEPtoCGRID( IDDEP )
             IF ( CGRID_MASK_NUM( ICGRID ) ) THEN
                ELMO_TABLE( N )%CUNIT = 'ha-1'
             ELSE IF ( CGRID_MASK_SRF( ICGRID ) ) THEN
                ELMO_TABLE( N )%CUNIT = 'm2 ha-1'
             ELSE
                ELMO_TABLE( N )%CUNIT = 'kg ha-1'
             END IF
           
             DO IMODE = 1,N_MODE
               DO ISPC = 1,N_AEROSPC
                 IF ( DDEP_SPC( IDDEP ) .EQ. AEROSPC(ISPC)%NAME(IMODE) )
     &              ELMO_TABLE( N )%IM = IMODE
               END DO
             END DO

             CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                            ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
             ELMO_TABLE( N )%IUNIT = IUNIT
             ELMO_TABLE( N )%DESC = 'Tagged Dry Deposition Flux of '//
     &          TRIM( DDEP_SPC( IDDEP ) ) //' from '//
     &          TRIM( TAGNAME( ITAG ) ) 
             ELMO_TABLE( N )%MW  = CGRID_MW( ICGRID )
          END DO

          N = N + 1
          ELMO_TABLE( N ) = ELMO_TABLE( N-1 )
          ELMO_TABLE( N )%OUT_NAME = 'DD_' // TRIM(DDEP_SPC( IDDEP ))//'_TAGS'
          ELMO_TABLE( N )%SOURCE = NTAG_SA + 1
          ELMO_TABLE( N )%DESC = 'Tagged Dry Deposition Flux of '//
     &       TRIM( DDEP_SPC( IDDEP ) ) //' from all sources.'

          END IF
        END DO
      END DO
#endif 

#ifdef sens
      ! Load DDM Variables into ELMO Table
      DO ICGRID = 1,N_CGRID_SPC
        IF ( CGRID_NAME( ICGRID ) .NE. 'RHOJ' ) THEN
           DO NP = 1,NPMAX
              N = N + 1
              ELMO_TABLE( N )%NAME = TRIM( CGRID_NAME(ICGRID) ) 
     &                                   // '_DDM'
              ELMO_TABLE( N )%OUT_NAME = TRIM( CGRID_NAME(ICGRID) ) 
     &                                   // '_' // TRIM( SEN_PAR(NP) )
              ELMO_TABLE( N )%OUT_TYPE = M3REAL
              ELMO_TABLE( N )%VAR_TYPE = ET_DDM_CONC
              ELMO_TABLE( N )%ID = ICGRID
              ELMO_TABLE( N )%SOURCE = NP
              ELMO_TABLE( N )%MW  = CGRID_MW( ICGRID )
          
              DO IMODE = 1,N_MODE
                DO ISPC = 1,N_AEROSPC
                  IF ( CGRID_NAME( ICGRID ) .EQ. AEROSPC(ISPC)%NAME(IMODE) )
     &               ELMO_TABLE( N )%IM = IMODE
                END DO
              END DO
          
              IF ( CGRID_MASK_NUM( ICGRID ) ) THEN
                 ELMO_TABLE( N )%CUNIT = 'm-3'
              ELSE IF ( CGRID_MASK_SRF( ICGRID ) ) THEN
                 ELMO_TABLE( N )%CUNIT = 'm2 m-3'
              ELSE IF ( CGRID_MASK_AERO( ICGRID ) ) THEN
                 ELMO_TABLE( N )%CUNIT = 'ug m-3'
              ELSE
                 ELMO_TABLE( N )%CUNIT = 'ppmV'
              END IF
              CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                             ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
              ELMO_TABLE( N )%IUNIT = IUNIT
              ELMO_TABLE( N )%DESC = 'Sensitivity of '//
     &           TRIM( CGRID_NAME( ICGRID ) ) //' to '//
     &           TRIM( SEN_PAR(NP) )
          
           END DO
        END IF
      END DO

      ! Load DDM3D Wet Deposition Fluxes into ELMO Table
      DO IWDEP = 1,N_SPC_WDEP
        DO NP = 1,NPMAX
           N = N + 1
           ELMO_TABLE( N )%NAME = 'WD_' // TRIM( WDEP_SPC( IWDEP ) )
     &                     // '_DDM' 
           ELMO_TABLE( N )%OUT_NAME = 'WD_' // TRIM(WDEP_SPC( IWDEP ))
     &                     // '_' // TRIM( SEN_PAR(NP) )
           ELMO_TABLE( N )%OUT_TYPE = M3REAL
           ELMO_TABLE( N )%VAR_TYPE = ET_DDM_WDEP
           ELMO_TABLE( N )%SOURCE = NP

           DO IMODE = 1,N_MODE
             DO ISPC = 1,N_AEROSPC
               IF ( WDEP_SPC( IWDEP ) .EQ. AEROSPC(ISPC)%NAME(IMODE) )
     &            ELMO_TABLE( N )%IM = IMODE
             END DO
           END DO

           ICGRID = MAP_WDEPtoCGRID( IWDEP )
           ELMO_TABLE( N )%ID = ICGRID
           ELMO_TABLE( N )%MW  = CGRID_MW( ICGRID )
           IF ( CGRID_MASK_NUM( ICGRID ) ) THEN
              ELMO_TABLE( N )%CUNIT = 'ha-1'
           ELSE IF ( CGRID_MASK_SRF( ICGRID ) ) THEN
              ELMO_TABLE( N )%CUNIT = 'm2 ha-1'
           ELSE
              ELMO_TABLE( N )%CUNIT = 'kg ha-1'
           END IF
           CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                          ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
           ELMO_TABLE( N )%IUNIT = IUNIT
           ELMO_TABLE( N )%DESC = 'Sensitivity of '//
     &        TRIM( WDEP_SPC( IWDEP ) ) //' wet deposition to '//
     &        TRIM( SEN_PAR(NP) ) // ' from all cloud types'
        END DO
      END DO

      ! Load DDM3D Dry Deposition Fluxes into ELMO Table
      DO IDDEP = 1,N_SPC_DDEP
        DO NP = 1,NPMAX
           N = N + 1
           ELMO_TABLE( N )%NAME = 'DD_' // TRIM(DDEP_SPC( IDDEP ))
     &                                // '_DDM'
           ELMO_TABLE( N )%OUT_NAME = 'DD_' // TRIM(DDEP_SPC( IDDEP ))
     &                                // '_' // TRIM( SEN_PAR(NP) )
           ELMO_TABLE( N )%OUT_TYPE = M3REAL
           ELMO_TABLE( N )%VAR_TYPE = ET_DDM_DDEP
           ELMO_TABLE( N )%SOURCE = NP

           DO IMODE = 1,N_MODE
             DO ISPC = 1,N_AEROSPC
               IF ( DDEP_SPC( IDDEP ) .EQ. AEROSPC(ISPC)%NAME(IMODE) )
     &            ELMO_TABLE( N )%IM = IMODE
             END DO
           END DO

           ICGRID = MAP_DDEPtoCGRID( IDDEP )
           ELMO_TABLE( N )%ID = ICGRID
           ELMO_TABLE( N )%MW  = CGRID_MW( ICGRID )
           IF ( CGRID_MASK_NUM( ICGRID ) ) THEN
              ELMO_TABLE( N )%CUNIT = 'ha-1'
           ELSE IF ( CGRID_MASK_SRF( ICGRID ) ) THEN
              ELMO_TABLE( N )%CUNIT = 'm2 ha-1'
           ELSE
              ELMO_TABLE( N )%CUNIT = 'kg ha-1'
           END IF
           CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                          ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
           ELMO_TABLE( N )%IUNIT = IUNIT
           ELMO_TABLE( N )%DESC = 'Sensitivity of '//
     &        TRIM( DDEP_SPC( IDDEP ) ) //' dry deposition to '//
     &        TRIM( SEN_PAR(NP) ) // ' from all cloud types'
        END DO
      END DO
#endif
 
      ! Load The Composite List into the ELMO Table
      DO ICMPST = 1,N_COMPOSITES
         INDX = INDEX1( CMPST( ICMPST )%NAME, N, ELMO_TABLE(:)%NAME )
         IF ( INDX .GT. 0 ) THEN
            XMSG = 'ELMO Composite ' // TRIM( ELMO_TABLE(INDX)%NAME) // ' is invalid ' // 
     &             'because the name is already a variable available in ELMO. Please ' // 
     &             'rename this composite.'
            CALL M3EXIT ( 'BUILD_ELMO_TABLE',0,0,XMSG,1)
         END IF

         N = N + 1
         ELMO_TABLE( N )%NAME = CMPST( ICMPST )%NAME
         ELMO_TABLE( N )%OUT_NAME = CMPST( ICMPST )%NAME
         ELMO_TABLE( N )%OUT_TYPE = M3REAL

         IF ( CMPST( ICMPST )%CMPST_TYPE(1:3) .EQ. 'DEP' ) THEN
             ELMO_TABLE( N )%VAR_TYPE = ET_CMPST_DEP
         ELSE
             ELMO_TABLE( N )%VAR_TYPE = ET_CMPST
         END IF
         ELMO_TABLE( N )%ID = ICMPST
         ELMO_TABLE( N )%CUNIT = CMPST( ICMPST )%CUNIT
         CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                        ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
         ELMO_TABLE( N )%IUNIT = IUNIT
         ELMO_TABLE( N )%DESC = CMPST( ICMPST )%DESC
         ELMO_TABLE( N )%MW   = 0.0
      END DO
 
#ifdef isam
      ! Apply Composites to ISAM source resolution and add to ELMO Table
      DO ICMPST = 1,N_COMPOSITES
         ! Define ELMO Variables for all ISAM sources
         DO ITAG = 1,NTAG_SA
           N = N + 1
           ELMO_TABLE( N )%NAME = TRIM(CMPST( ICMPST )%NAME)
     &                            // '_ISAM'
           ELMO_TABLE( N )%OUT_NAME = TRIM(CMPST( ICMPST )%NAME) 
     &                            // '_' // TRIM(TAGNAME( ITAG ))
           ELMO_TABLE( N )%OUT_TYPE = M3REAL
         
           IF ( CMPST( ICMPST )%CMPST_TYPE(1:3) .EQ. 'DEP' ) THEN
               ELMO_TABLE( N )%VAR_TYPE = ET_ISAM_CMPST_DEP
           ELSE
               ELMO_TABLE( N )%VAR_TYPE = ET_ISAM_CMPST
           END IF
           ELMO_TABLE( N )%ID = ICMPST
           ELMO_TABLE( N )%CUNIT =  CMPST( ICMPST )%CUNIT
           CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                          ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
           ELMO_TABLE( N )%IUNIT = IUNIT

           ELMO_TABLE( N )%SOURCE = ITAG
           ELMO_TABLE( N )%DESC = CMPST( ICMPST )%DESC // 
     &           ' for source ' // TRIM(TAGNAME( ITAG ))
           ELMO_TABLE( N )%MW   = 0.0
         END DO 
         
         ! Set Source-Dependent Properties for the sum of sources
         N = N + 1
         ELMO_TABLE( N ) = ELMO_TABLE( N-1 )
         ELMO_TABLE( N )%OUT_NAME = TRIM(CMPST( ICMPST )%NAME) // '_TAGS'
         ELMO_TABLE( N )%SOURCE = NTAG_SA + 1
         ELMO_TABLE( N )%DESC = CMPST( ICMPST )%DESC // 
     &         ' for the sum of all sources.'
      END DO
#endif         

#ifdef sens
      ! Apply Composites to DDM3D source resolution and add to ELMO Table
      DO ICMPST = 1,N_COMPOSITES
         ! Define ELMO Variables for all remaining DDM3D sources
         DO NP = 1,NPMAX
           N = N + 1
           ELMO_TABLE( N )%NAME = TRIM(CMPST( ICMPST )%NAME)
     &                            // '_DDM'
           ELMO_TABLE( N )%OUT_NAME = TRIM(CMPST( ICMPST )%NAME)
     &                            // '_' // TRIM( SEN_PAR( NP ) )
           ELMO_TABLE( N )%OUT_TYPE = M3REAL
           
           IF ( CMPST( ICMPST )%CMPST_TYPE(1:3) .EQ. 'DEP' ) THEN
               ELMO_TABLE( N )%VAR_TYPE = ET_DDM_CMPST_DEP
           ELSE
               ELMO_TABLE( N )%VAR_TYPE = ET_DDM_CMPST
           END IF
           ELMO_TABLE( N )%ID = ICMPST
           ELMO_TABLE( N )%SOURCE = NP
           ELMO_TABLE( N )%CUNIT =  CMPST( ICMPST )%CUNIT
           CALL MAP_ELMO_UNITS( ELMO_TABLE(N)%CUNIT, IUNIT, 
     &                          ELMO_TABLE( N )%NAME, ELMO_TABLE( N )%VAR_TYPE )
           ELMO_TABLE( N )%IUNIT = IUNIT
           ELMO_TABLE( N )%DESC = 'Sensitivity of ' // CMPST( ICMPST )%DESC // 
     &           ' to ' // TRIM( SEN_PAR( NP ) )
           ELMO_TABLE( N )%MW   = 0.0
         END DO
      END DO
#endif         
 
      ! Summarize Total number of ELMO Table entries and subset Table to
      ! just the populated rows.
      N_ELMO_TABLE = N
      ELMO_TABLE = ELMO_TABLE( 1:N_ELMO_TABLE ) 

      ! Initialize all ELMO Variables as Detailed calculations (i.e.
      ! L_COMP = FALSE). If they appear in ELMO_MAP_VARIABLES, then
      ! their L_COMP attribute will be set to True.
      ELMO_TABLE(:)%L_COMP = .FALSE.
      ALLOCATE( ELMO_COMP( N_ELMO_TABLE ) )

      END SUBROUTINE BUILD_ELMO_TABLE

!-------------------------------------------------------------------------
      SUBROUTINE OPEN_ELMO ( JDATE, JTIME, TSTEP )
!-------------------------------------------------------------------------

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE MIO_ASCII

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID  ! file name parameters

      !...Arguments:

        INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
        INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
        INTEGER, INTENT( IN ) :: TSTEP      ! output time step

      !...Local variables:

        CHARACTER( 16 ), SAVE :: PNAME = 'OPEN_ELMO'
        CHARACTER( 96 ) :: XMSG = ' '

        INTEGER :: L          ! loop induction variables
        INTEGER :: MDATE, MTIME, IFL, IVAR, J, ICOMP
        INTEGER :: LAY_BOT, LAY_TOP

      CALL LOG_MESSAGE( LOGDEV,'' )
      CALL LOG_SUBHEADING( LOGDEV, 'Open ELMO Output Files' )

#ifndef mpas
      ! Define General Output File Parameters
      FTYPE3D = GRDDED3
      GDNAM3D = GRID_NAME  ! from HGRD_DEFN
      TSTEP3D = TSTEP
      NCOLS3D = GL_NCOLS
      NROWS3D = GL_NROWS
      GDTYP3D = GDTYP_GD
      P_ALP3D = P_ALP_GD
      P_BET3D = P_BET_GD 
      P_GAM3D = P_GAM_GD
      XORIG3D = XORIG_GD
      YORIG3D = YORIG_GD
      XCENT3D = XCENT_GD
      YCENT3D = YCENT_GD
      XCELL3D = XCELL_GD
      YCELL3D = YCELL_GD
      VGTYP3D = VGTYP_GD
      VGTOP3D = VGTOP_GD
      NTHIK3D =     1
#endif
      DO IFL = 1,N_ELMO_FILES
#ifndef mpas
         ! Try to open existing file for update
         IF ( IO_PE_INCLUSIVE ) THEN

            ! Open or append ELMO Output file in read/write mode for I/O
            ! Processors
            IF ( .NOT. OPEN3( ELMO_FILE(IFL)%FLOGICAL, FSRDWR3, PNAME ) ) THEN
               
               ! Set output file characteristics based on COORD.EXT and 
               ! open the ELMO file
               SDATE3D = JDATE
               STIME3D = JTIME
               
               IF ( ELMO_FILE( IFL )%TMODE .EQ. 1 ) THEN
                 ! Recalculate Date/Time Applicable for an Average file
                 MDATE = JDATE; MTIME = JTIME
                 IF ( END_TIME ) CALL NEXTIME ( MDATE, MTIME, TSTEP )
               
                 SDATE3D = MDATE
                 STIME3D = MTIME
               END IF
               
               ! Specify Layers
               NLAYS3D = ELMO_FILE(IFL)%NLAYS
               LAY_BOT = ELMO_FILE( IFL )%LAY_BOT
               LAY_TOP = ELMO_FILE( IFL )%LAY_TOP
               DO L = LAY_BOT, LAY_TOP + 1
                  VGLVS3D( L ) = VGLVS_GD( L )
               END DO
               
               ! Specify Variables and their Properties
               NVARS3D = ELMO_FILE( IFL )%N_VARS 
               DO IVAR = 1,NVARS3D
                 J = ELMO_FILE( IFL )%TABID( IVAR )
                 VTYPE3D( IVAR ) = ELMO_TABLE( J )%OUT_TYPE
                 VNAME3D( IVAR ) = ELMO_TABLE( J )%OUT_NAME
                 UNITS3D( IVAR ) = ELMO_TABLE( J )%CUNIT
                 VDESC3D( IVAR ) = ELMO_TABLE( J )%DESC
               END DO
               
               FDESC3D( 1 ) = 'Variables Relevant for PM Formation and Distribution'
               DO L = 2, MXDESC3
                  FDESC3D( L ) = ' '
               END DO
               
               ! Store MIO Metadata
               NDIMS3D( 1:NVARS3D ) = 4
               L_TSTEP( 1:NVARS3D ) = .True.
               L_LAY  ( 1:NVARS3D ) = .True.
               L_COL  ( 1:NVARS3D ) = .True.
               L_ROW  ( 1:NVARS3D ) = .True.
               L_VEXT ( 1:NVARS3D ) = .False.
               
               CALL LOAD_MIO_FILE ( ELMO_FILE( IFL )%FLOGICAL, NLAYS3D, 
     &              LAY_BOT, LAY_TOP,
     &              VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &              VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &              L_LAY(1:NVARS3D),   L_COL(1:NVARS3D), L_ROW(1:NVARS3D),
     &              L_VEXT(1:NVARS3D) )
               
               ! Open the Instantaneous ELMO File
               IF ( .NOT. OPEN3( ELMO_FILE(IFL)%FLOGICAL, FSNEW3, PNAME ) ) THEN
                   XMSG = 'Could not create '// 
     &                    ELMO_FILE( IFL )%FLOGICAL // ' file'
                  CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
               END IF
               
            END IF 

         ELSE

           ! Open ELMO Output files in read mode for non-I/O processors  
           IF ( .NOT. OPEN3( ELMO_FILE(IFL)%FLOGICAL, FSREAD3, PNAME ) ) THEN
              XMSG = 'Could not open ' // TRIM( ELMO_FILE(IFL)%FLOGICAL )
              CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
           END IF

         END IF
#endif
      END DO
 
      END SUBROUTINE OPEN_ELMO 

!-------------------------------------------------------------------------
      SUBROUTINE ELMO_WRITE_LOG ( )
!-------------------------------------------------------------------------
    
      USE AERO_DATA, ONLY : N_MODE, AEROSPC, AERO_MISSING, AEROMODE,
     &                      CMODE, N_AEROSPC, MAP_MODE_MASK
      USE SOA_DEFN,  ONLY : N_OA, OASPC, MAP_AEROtoOA, MAP_ORG_MASK

      IMPLICIT NONE

      INTEGER IFL, IVAR, ICOMP, J, TABID, IFILE, AERO_ID, 
     &        IMODE, INLET, IOA, IM, K, IAER
      CHARACTER( 3000 ) :: FORMULA
      CHARACTER(    2 ) :: CSIGN
      CHARACTER(   70 ) :: FTEMP
      INTEGER FORM_SIZE, LAST_SPACE
      LOGICAL L_MODE,L_SPEC
      LOGICAL :: MODE_MASK( N_MODE ), ORG_MASK( N_OA )
      INTEGER :: ORG_OP

      INTEGER, EXTERNAL :: FINDEX

      ! Write out all ELMO variables organized by output file
      CALL LOG_MESSAGE( LOGDEV,'' )
      CALL LOG_SUBHEADING( LOGDEV, 'ELMO Output Variable Report' )
      WRITE( LOGDEV,'(7x,A,8(/,13x,A))' ),
     &                              'Note: these are populated using rules from the',
     &                              'CMAQ Control File supplied by the User. ',
     &                              'When variables are indented, they are components ',
     &                              'of the most recent non-indented variable. Becuase ',
     &                              'their output units should either match the output ',
     &                              'variable or be converted to its units, the third ',
     &                              'column reports any coefficients used when applying ',
     &                              'these components to the sum, excluding molecular ',
     &                              'weight, air density, etc.'


      DO IFL = 1,N_ELMO_FILES
         
         ! Header and File Metadata
         WRITE( LOGDEV, '(/,5x,A,A)'   ),'>',REPEAT('-',80 )
         WRITE( LOGDEV,'(5x,A,I2,A,A,/,5x,A,A,/,8x,A,I2,A,I2,/,8x,A,I5)' ),
     &       'Output File Num: "',IFL,'" | Temporality: ','Average',
     &       'Output Filename: ',TRIM(ELMO_FILE(IFL)%SHORTNAME),
     &       ' Bottom Layer: ',ELMO_FILE( IFL )%LAY_BOT,
     &       ' Top Layer: ',ELMO_FILE( IFL )%LAY_TOP,
     &       ' Number of Variables: ',ELMO_FILE( IFL )%N_VARS

         ! Print all variables on the file and their contents if they have
         ! components 
         WRITE( LOGDEV, '(/,8x,A,12x,A,12x,A,8x,A)' ),
     &       'Variable','Type','Unit','Description'
         WRITE( LOGDEV, '(8x,A,3x,A,2x,A,4x,A)' ),
     &       '-----------------','--------------','--------','--------------'

         DO IVAR = 1,ELMO_FILE( IFL )%N_VARS 
            J = ELMO_FILE( IFL )%TABID( IVAR )
            WRITE ( LOGDEV,'(8x,A16,4x,A14,2x,A8,4x,A)'),
     &              ELMO_TABLE( J )%OUT_NAME,
     &              CETYPE( ELMO_TABLE( J )%VAR_TYPE ),
     &              ELMO_TABLE( J )%CUNIT,
     &              TRIM( ELMO_TABLE( J )%DESC )

            FORMULA = ''

            ! Determine type of variable in order to make formula
            ! correctly
            IF ( ELMO_TABLE( J )%VAR_TYPE .EQ. ET_CMPST .OR.
     &           ELMO_TABLE( J )%VAR_TYPE .EQ. ET_ISAM_CMPST .OR.
     &           ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DDM_CMPST .OR.
     &           ELMO_TABLE( J )%VAR_TYPE .EQ. ET_CMPST_DEP .OR.
     &           ELMO_TABLE( J )%VAR_TYPE .EQ. ET_ISAM_CMPST_DEP .OR.
     &           ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DDM_CMPST_DEP ) THEN

               ! Make Formula of Composite Variable from Components
               DO ICOMP = 1,ELMO_COMP( J )%N_VARS
                  TABID = ELMO_COMP( J )%TABID( ICOMP )
                  IMODE = ELMO_TABLE( TABID )%IM
                  INLET = ELMO_COMP( J )%INLET

                  L_MODE = .TRUE.
                  IF ( IMODE .NE. 0 ) L_MODE = ELMO_COMP( J )%L_MODE( IMODE )

                  IF ( L_MODE ) THEN
                     WRITE( FORMULA, '(A,A1,SPES9.2,A1,A)' ),TRIM(FORMULA),
     &                  ' ',ELMO_COMP( J )%COEFF(ICOMP),'*',
     &                  TRIM( ELMO_TABLE( TABID )%OUT_NAME )

                     ! If this is an aerosol with a size cutoff, make sure
                     ! to add the FPM[dp]_[mode] to the formula
                     IF ( ELMO_TABLE( TABID )%VAR_TYPE .EQ. ET_CONC .AND.
     &                    IMODE .NE. 0 .AND.INLET .NE. 0 ) THEN
                        WRITE( FORMULA, '(A,A2,A,A1,A)' ),TRIM(FORMULA),'*F',
     &                     TRIM( ELMO_INLET(INLET)%CINLET ),'_',
     &                     TRIM(AEROMODE( IMODE )%SUFF)
                     END IF
                  END IF
               END DO

            ELSE IF ( ELMO_TABLE( J )%DRVD_TAB .GT. 0 ) THEN
               
               ! Make Formula for Derived Variable Based on Derived
               ! Variable Parameter Table
               K = ELMO_TABLE( J )%DRVD_TAB

               CALL MAP_MODE_MASK( ELMO_DRVD_TAB( K )%MODE, MODE_MASK )
               CALL MAP_ORG_MASK ( ELMO_DRVD_TAB( K )%ORG_MASK, ORG_MASK )
               INLET  = ELMO_DRVD_TAB( K )%INLET
               ORG_OP = ELMO_DRVD_TAB( K )%ORG_OP

               ! Write the formula for total aerosol metrics
               IF ( ORG_OP .EQ. OT_OMOC .OR. ORG_OP .EQ. OT_OTOC ) THEN
                   ! Begin with a parenthesis
                   WRITE( FORMULA, '(A,A2)' ),TRIM(FORMULA),'( '
               END IF

               ! Add each aerosol species
               DO IAER = 1,N_AEROSPC
                  L_SPEC = .NOT. AEROSPC(IAER)%TRACER .AND. 
     &                     .NOT. AEROSPC(IAER)%NO_M2WET
                  IF ( ORG_OP .GT. 0 ) THEN
                      IOA = MAP_AEROtoOA( IAER )
                      IF ( IOA .EQ. 0 ) THEN
                         L_SPEC = .FALSE.
                      ELSE 
                         L_SPEC = L_SPEC .AND. ORG_MASK( IOA )
                         IF ( (ORG_OP.EQ.OT_OMOC .AND. OASPC(IOA)%OMtoOC.LE.1.0) .OR. 
     &                        (ORG_OP.EQ.OT_OTOC .AND. OASPC(IOA)%OTOC.LE.0.0)   .OR.
     &                        (ORG_OP.EQ.OT_OC   .AND. OASPC(IOA)%OMtoOC.LE.0.0) .OR.
     &                        (ORG_OP.EQ.OT_DD_OC.AND. OASPC(IOA)%OMtoOC.LE.0.0) .OR.
     &                        (ORG_OP.EQ.OT_WD_OC.AND. OASPC(IOA)%OMtoOC.LE.0.0) )
     &                      L_SPEC = .FALSE.
                      END IF
                  END IF
                  IF ( .NOT. L_SPEC ) CYCLE
                  
                  DO IM = 1,N_MODE
                     IF ( MODE_MASK( IM ) .AND. .NOT. AERO_MISSING(IAER,IM) ) THEN

                        ! Add Deposition Prefixes if applicable
                        IF ( ORG_OP .EQ. OT_DD_OA .OR. ORG_OP .EQ. OT_DD_OC ) THEN
                           WRITE( FORMULA, '(A,A5)' ),TRIM(FORMULA),' +DD_'
                        ELSE IF ( ORG_OP .EQ. OT_WD_OA. OR. ORG_OP .EQ. OT_WD_OC) THEN
                           WRITE( FORMULA, '(A,A5)' ),TRIM(FORMULA),' +WD_'
                        ELSE
                           WRITE( FORMULA, '(A,A2)' ),TRIM(FORMULA),' +'
                        END IF

                        ! Add Species Name and Coefficient
                        IF ( ORG_OP .EQ. 0 .OR. ORG_OP .EQ. OT_OA .OR.
     &                       ORG_OP .EQ. OT_DD_OA .OR. ORG_OP .EQ. OT_WD_OA ) THEN 
                           WRITE( FORMULA, '(A,A)' ),TRIM(FORMULA),
     &                        TRIM( AEROSPC(IAER)%NAME(IM) )
                        ELSE IF ( ORG_OP .EQ. OT_OC .OR. ORG_OP .EQ. OT_DD_OC .OR. 
     &                            ORG_OP .EQ. OT_WD_OC ) THEN
                           WRITE( FORMULA, '(A,A,A1,ES8.2)' ),TRIM(FORMULA),
     &                        TRIM( AEROSPC(IAER)%NAME(IM) ),'/',OASPC(IOA)%OMtoOC
                        ELSE IF ( ORG_OP .EQ. OT_OMOC ) THEN
                           WRITE( FORMULA, '(A,ES8.2,A1,A)' ),TRIM(FORMULA),
     &                        OASPC(IOA)%OMtoOC,'*',TRIM(AEROSPC(IAER)%NAME(IM) )
                        ELSE IF ( ORG_OP .EQ. OT_OTOC ) THEN
                           WRITE( FORMULA, '(A,ES8.2,A1,A)' ),TRIM(FORMULA),
     &                        OASPC(IOA)%OtoC,'*',TRIM( AEROSPC(IAER)%NAME(IM) )
                        END IF

                        ! Multiply by inlet fraction if applicable
                        IF ( INLET .GT. 0 ) 
     &                     WRITE( FORMULA, '(A,A2,A,A1,A)' ),TRIM(FORMULA),'*F',
     &                        TRIM( ELMO_INLET(INLET)%CINLET ),'_',
     &                        TRIM(AEROMODE( IM )%SUFF)
                     END IF
                  END DO
               END DO
               
               ! Add Denominator For OM:OC and O:C
               IF ( ORG_OP .EQ. OT_OMOC .OR. ORG_OP .EQ. OT_OTOC ) THEN
                   ! Begin with a parenthesis
                   WRITE( FORMULA, '(A,A5)' ),TRIM(FORMULA),') / ('
                   IF ( INLET .EQ. 0 ) 
     &                WRITE( FORMULA, '(A,A,A1)' ),TRIM(FORMULA),
     &                   TRIM( CMODE( ELMO_DRVD_TAB(K)%MODE ) ),'_'
                   WRITE( FORMULA, '(A,A2)' ),TRIM(FORMULA),'OA'
                   IF ( INLET .NE. 0 ) 
     &                WRITE( FORMULA, '(A,A2,A)' ),TRIM(FORMULA),'*F',
     &                   TRIM( ELMO_INLET(INLET)%CINLET )
                   WRITE( FORMULA, '(A,A1)' ),TRIM(FORMULA),')'
               END IF

            END IF  
 
            ! Write Formula to Log File Table
            IF ( FORMULA .NE. '' ) THEN   
               ! Parse Formula so that it prints correctly to screen
               FORMULA = '='//FORMULA( 1:LEN(FORMULA) )
               FORM_SIZE = LEN_TRIM( FORMULA )
               DO WHILE ( FORM_SIZE .GT. 70 )
                  ! Isolate a line of text before a + or - sign
                  LAST_SPACE = INDEX( FORMULA( 1:70 )," ", BACK=.TRUE. )

                  FTEMP = FORMULA( 1:LAST_SPACE )

                  WRITE( LOGDEV, '(10x,A)'), FTEMP
                  FORMULA = '  '//FORMULA( LAST_SPACE+1:LEN(FORMULA) )
                  FORM_SIZE = LEN_TRIM( FORMULA )
               
               END DO

               ! Write Last Line
               WRITE( LOGDEV, '(10x,A)' ), FORMULA(1:FORM_SIZE)
            END IF
            WRITE( LOGDEV, * )
         END DO
      END DO

      WRITE( LOGDEV, * )

      END SUBROUTINE ELMO_WRITE_LOG

      END MODULE ELMO_INIT_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/init/yamo/grdcheck.F,v 1.3 2011/10/21 16:11:24 yoj Exp $ 

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

       SUBROUTINE GRDCHECK ( FNAME, LOK )

C----------------------------------------------------------------------
C Function: To check files and COORD.EXT for consistency
 
C Preconditions: None
 
C Key Subroutines/Functions Called:
 
C Revision History:
C    Prototype created by Jerry Gipson, September, 1997
C    eliminate EMISLYRS, Jeff, Oct 97
C    2 October, 1998 by Al Bourgeois at LM: parallel implementation
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C    6 Sep 06 J.Young: ensure LNLAYSOK is initialized - Michael Bane's suggestion
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN

      IMPLICIT NONE 

C..INCLUDES:
      INCLUDE SUBST_FILES_ID    ! file name parameters
       
C..ARGUMENTS:
      CHARACTER*(*) FNAME     ! File Name
      LOGICAL LOK             ! Flag to indicate error found

C..PARAMETERS: None

C..EXTERNAL FUNCTIONS: None

C..SAVED LOCAL VARIABLES: None
      
C..SCRATCH LOCAL VARIABLES:
      CHARACTER*20 CHR1      ! Value of variable 1 in character data
      CHARACTER*20 CHR2      ! Value of variable 1 in character data
      CHARACTER*80 MSG       ! Message

      INTEGER LAY       ! Loop index for layers
      INTEGER NCOLS_DOT ! No. of columns for a dot file
      INTEGER NLAYS_FL  ! No. of layers expected on 3D file
      INTEGER NLAYS2CK  ! No. of layers to check vertical levels
      INTEGER NROWS_DOT ! No. of rows for a dot file

      LOGICAL LDIFF     ! Flag for difference in vertical levels
      LOGICAL LNLAYSOK  ! Flag to indicate no. of vert. layers OK

      REAL*8 XORIG_FL   ! Computed XORIG for dot file
      REAL*8 YORIG_FL   ! Computed YORIG for dot file

C----------------------------------------------------------------------

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Check horizontal grid structure
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

#ifndef mpas
C...For DOT files only
      IF(INDEX( FNAME, '_DOT_' ) .NE. 0 ) THEN

         IF( GL_NCOLS + 1 .NE. NCOLS3D ) THEN
            NCOLS_DOT = GL_NCOLS + 1
            CALL INTDIFF( 'GL_NCOLS', NCOLS3D, NCOLS_DOT )
            LOK = .FALSE.
         END IF

         IF( GL_NROWS + 1 .NE. NROWS3D ) THEN
            NROWS_DOT = GL_NROWS + 1
            CALL INTDIFF( 'GL_NROWS', NROWS3D,  NROWS_DOT )
            LOK = .FALSE.
         END IF

C...Skip PDM files
      ELSEIF( INDEX( FNAME, 'PDM_' ) .NE. 0) THEN

C...Skip PING files
      ELSEIF( INDEX( FNAME, '_PING_' ) .NE. 0) THEN

C...Skip IPR files
      ELSEIF( INDEX( FNAME, '_IPR_' ) .NE. 0) THEN

C...Skip IRR files
      ELSEIF( INDEX( FNAME, '_IRR_' ) .NE. 0) THEN

C...All other files
      ELSE

         IF( GL_NCOLS .NE. NCOLS3D ) THEN
            CALL INTDIFF( 'GL_NCOLS', NCOLS3D, GL_NCOLS )
            LOK = .FALSE.
         END IF

         IF( GL_NROWS .NE. NROWS3D ) THEN
            CALL INTDIFF( 'GL_NROWS', NROWS3D, GL_NROWS )
            LOK = .FALSE.
         END IF
 
      END IF

C...Check Number of vertical layers only for true 3D files

      LNLAYSOK = .TRUE.

      IF( INDEX( FNAME,   'PDM_' ) .EQ. 0 .AND.
     &    INDEX( FNAME, '_PING_' ) .EQ. 0 .AND. NLAYS3D .GT. 1 )  THEN

         IF( INDEX( FNAME,  'EMIS' ) .GT. 0 .OR.
     &       INDEX( FNAME, 'MEPSE' ) .GT. 0 .OR.
     &       INDEX( FNAME, '_IPR_' ) .GT. 0 .OR.
     &       INDEX( FNAME, '_IRR_' ) .GT. 0 ) THEN
!           NLAYS_FL = EMISLYRS
            NLAYS_FL = NLAYS3D   ! don't check this file
         ELSE
            NLAYS_FL = NLAYS
         END IF

         IF( NLAYS_FL .NE. NLAYS3D ) THEN
            CALL INTDIFF( 'NLAYS', NLAYS3D, NLAYS_FL )
            LOK = .FALSE.
            LNLAYSOK = .FALSE.
         END IF

         IF( NTHIK .NE. NTHIK3D ) THEN
            CALL INTDIFF( 'NTHIK', NTHIK3D, NTHIK )
            LOK = .FALSE.
         END IF
             
      END IF
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Check Map projection
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF( GDTYP_GD .NE. GDTYP3D ) THEN
         CALL INTDIFF( 'GDTYP', GDTYP_GD, GDTYP3D )
         LOK = .FALSE.
      END IF

C...Check P_ALPHA only for Lambert, Mercator, Stereographic and UTM
      IF( GDTYP_GD .GE. 2 .AND. GDTYP_GD .LE. 5 ) THEN      
         WRITE( CHR1, 94020 ) P_ALP3D
         WRITE( CHR2, 94020 ) P_ALP_GD
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'P_ALP', CHR1, CHR2 )
            LOK = .FALSE.
        END IF
      END IF

C...Check P_BETA only for Lambert, Mercator, and Stereographic
      IF( GDTYP_GD .GE. 2 .AND. GDTYP_GD .LE. 4 ) THEN      
         WRITE( CHR1, 94020 ) P_BET3D
         WRITE( CHR2, 94020 ) P_BET_GD
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'P_BET', CHR1,  CHR2 )
            LOK = .FALSE.
        END IF
      END IF

C...Check P_GAMMA only for Lambert, Mercator, and Stereographic
      IF( GDTYP_GD .GE. 2 .AND. GDTYP_GD .LE. 4 ) THEN      
         WRITE( CHR1, 94020 ) P_GAM3D
         WRITE( CHR2, 94020 ) P_GAM_GD
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'P_GAM', CHR1,  CHR2 )
            LOK = .FALSE.
         END IF
      END IF

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Check for horizontal grid location and size
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C...Check XORG & YORG only for Lambert, Mercator, Stereographic and UTM
      IF( GDTYP_GD .GE. 2 .AND. GDTYP_GD .LE. 5 ) THEN      
         IF( INDEX( FNAME, '_DOT_' ) .GT. 0 ) THEN
            XORIG_FL = XORIG_GD - 0.5 * XCELL_GD
            YORIG_FL = YORIG_GD - 0.5 * YCELL_GD
         ELSE
            XORIG_FL = XORIG_GD 
            YORIG_FL = YORIG_GD 
         END IF
         WRITE( CHR1, 94020 ) XORIG3D
         WRITE( CHR2, 94020 ) XORIG_FL
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'XORIG', CHR1,  CHR2 )
            LOK = .FALSE.
         END IF
         WRITE( CHR1, 94020 ) YORIG3D
         WRITE( CHR2, 94020 ) YORIG_FL
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'YORIG', CHR1,  CHR2 )
            LOK = .FALSE.
         END IF
      END IF

C...Check XCENT & YCENT only for Lambert, Mercator, and Stereographic
      IF( GDTYP_GD .GE. 2 .AND. GDTYP_GD .LE. 4 ) THEN      
         WRITE( CHR1, 94020 ) XCENT3D
         WRITE( CHR2, 94020 ) XCENT_GD
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'XCENT', CHR1,  CHR2 )
            LOK = .FALSE.
         END IF

         WRITE( CHR1, 94020 ) YCENT3D
         WRITE( CHR2, 94020 ) YCENT_GD
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'YCENT', CHR1,  CHR2 )
            LOK = .FALSE.
         END IF
      END IF

      WRITE( CHR1, 94020 ) XCELL3D
      WRITE( CHR2, 94020 ) XCELL_GD
      IF( CHR1 .NE. CHR2 ) THEN
         CALL CHRDIFF( 'XCELL', CHR1,  CHR2 )
         LOK = .FALSE.
      END IF

      WRITE( CHR1, 94020 ) YCELL3D
      WRITE( CHR2, 94020 ) YCELL_GD
      IF( CHR1 .NE. CHR2 ) THEN
         CALL CHRDIFF( 'YCELL', CHR1,  CHR2 )
         LOK = .FALSE.
      END IF
 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Check vertical structure (only for "true" 3D files
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF( INDEX( FNAME,   'PDM_' ) .EQ. 0 .AND.
     &    INDEX( FNAME, '_PING_' ) .EQ. 0 .AND.
     &    NLAYS3D .GT. 1 .AND. LNLAYSOK )  THEN

         IF( VGTYP_GD .NE. VGTYP3D ) THEN
            CALL INTDIFF( 'VGTYP', VGTYP3D, VGTYP_GD )
            LOK = .FALSE.
         END IF

C..Check for vtop for sigma-p coordinates only
         IF( VGTYP3D .GE. 1 .AND. VGTYP3D .LE. 2 ) THEN  
            WRITE( CHR1, 94020 ) VGTOP3D
            WRITE( CHR2, 94020 ) VGTOP_GD
            IF( CHR1 .NE. CHR2 ) THEN
               CALL CHRDIFF( 'VGTOP', CHR1,  CHR2 )
               LOK = .FALSE.
            END IF
         END IF

C..Check vertical levels for 3D files only

         LDIFF = .FALSE.

         IF( INDEX( FNAME, 'EMIS' ) .GT. 0 ) THEN
!           NLAYS2CK = EMISLYRS
            NLAYS2CK = NLAYS3D
         ELSE
            NLAYS2CK = NLAYS
         END IF

         DO LAY = 1 , NLAYS2CK
            WRITE( CHR1, 94020 ) VGLVS3D( LAY )
            WRITE( CHR2, 94020 ) VGLVS_GD( LAY )
            IF( CHR1 .NE. CHR2 ) LDIFF = .TRUE.
         END DO

         IF( LDIFF ) THEN    
            MSG = '    Inconsistent value for vertical level'
            CALL M3MESG( MSG )
            LOK = .FALSE.
         END IF

      END IF
#endif

      RETURN

94020 FORMAT( 1PE20.4 )

      END
         

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HADV ( CGRID, JDATE, JTIME, TSTEP, ASTEP )

C-----------------------------------------------------------------------
C Function:
C   Advection in the horizontal plane
C   The process time step is set equal to TSTEP(2). Boundary concentrations
C   are coupled in RDBCON with SqRDMT = Sq. Root [det ( metric tensor )]
C   = Jacobian / (map scale factor)**2
C   where Air Density X SqRDMT is loaded into last BCON slot for advection.
      
C Preconditions:
C   Dates and times represented YYYYDDD:HHMMSS.
C   No "skipped" dates and times.  All boundary input variables have the
C   same boundary perimeter structure with a thickness of 1
C   CGRID in transport units: SQRT{DET[metric tensor]}*concentration (Mass/Vol)
      
C Subroutines and functions called:
 
C Revision history:
C  19 Jan 2004: Jeff Young
C   7 Jul 2007: Jeff Young - declare MTRHOJ dimensions properly in order to retain
C                            them as declared in X_YAMO and Y_YAMO
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   May 2019 j. pleim:  removed yamo hadvect subroutines
C   11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
      
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE XY_BUDGET
      USE PA_DEFN, ONLY: LIPR
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE, SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE, NOOP_UTIL_MODULE)
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY:SENGRID, NPMAX, NP, BSEN
#endif 

      IMPLICIT NONE
      
C Includes:

      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction

C Arguments:
      
      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER     JDATE         ! current model date, coded YYYYDDD
      INTEGER     JTIME         ! current model time, coded HHMMSS
      INTEGER     TSTEP( 3 )    ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency

      INTEGER     ASTEP( : )    ! layer advection time step

C External Functions: None
      
C Parameters:

C Advected species dimension

      INTEGER, SAVE :: N_SPC_ADV

C File Variables:

      REAL, ALLOCATABLE, SAVE :: BCON( :,: )    ! boundary concentrations

C Local Variables:


      INTEGER       ALLOCSTAT

      CHARACTER( 16 ) :: PNAME = 'HADVPPM'
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL, ALLOCATABLE, SAVE :: XYFIRST( : )
      REAL, ALLOCATABLE, SAVE :: CGRID0( :,:,: ), XADV(:,:,:), YADV(:,:,:)


      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER( 199 ) :: XMSG2 = ' '

      INTEGER      STEP                         ! ASTEP( L ), (dt) in sec
      INTEGER      DSTEP                        ! dt accumulator
      INTEGER      FDATE                        ! interpolation date
      INTEGER      FTIME                        ! interpolation time
      INTEGER      SYNCSTEP

      INTEGER      LVL                ! loop counters
      LOGICAL      L_WRITE_WARNING

C Required interface for allocatable array dummy arguments

      INTERFACE
         SUBROUTINE RDBCON ( FDATE, FTIME, TSTEP, LVL, BCON,
     &                       L_WRITE_WARNING )
            INTEGER, INTENT( IN )  :: FDATE, FTIME, TSTEP, LVL
            REAL,    INTENT( OUT ) :: BCON( :,: )
            LOGICAL, INTENT( INOUT ) :: L_WRITE_WARNING
         END SUBROUTINE RDBCON
         SUBROUTINE X_PPM ( CGRID, FDATE, FTIME, TSTEP, LVL, BCON )
            REAL, POINTER          :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )  :: FDATE, FTIME, TSTEP, LVL
!           REAL,    INTENT( IN )  :: BCON( NBNDY,* )
            REAL,    INTENT( IN )  :: BCON( :,: )
         END SUBROUTINE X_PPM
         SUBROUTINE Y_PPM ( CGRID, FDATE, FTIME, TSTEP, LVL, BCON )
            REAL, POINTER          :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )  :: FDATE, FTIME, TSTEP, LVL
!           REAL,    INTENT( IN )  :: BCON( NBNDY,: )
            REAL,    INTENT( IN )  :: BCON( :,: )
         END SUBROUTINE Y_PPM
!        SUBROUTINE LCKSUMMER ( PNAME, CGRID, JDATE, JTIME, LVL )
!           CHARACTER( * ), INTENT( IN ) :: PNAME
!           REAL, POINTER                :: CGRID( :,:,:,: )
!           INTEGER, INTENT( IN )        :: JDATE, JTIME, LVL
!        END SUBROUTINE LCKSUMMER
      END INTERFACE
C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         ALLOCATE( XYFIRST( NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating XYFIRST'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         XYFIRST( : ) = .TRUE.

C Get CGRID offsets

         N_SPC_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV + 1
                                                  ! add 1 for advecting RHOJ
         ALLOCATE ( BCON( NBNDY,N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BCON'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( LIPR ) THEN
            ALLOCATE ( DELC_XADV( NCOLS,NROWS,NLAYS,NSPCSD ),
     &                 DELC_YADV( NCOLS,NROWS,NLAYS,NSPCSD ),
     &                 XADV( NCOLS,NROWS,NSPCSD ),
     &                 YADV( NCOLS,NROWS,NSPCSD ),
     &                 CGRID0( NCOLS,NROWS,NSPCSD ) )
         END IF

#ifdef sens
         ALLOCATE ( BSEN( NBNDY,N_SPC_ADV,NPMAX ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BSEN'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
#endif

      END IF                    ! if firstime

      SYNCSTEP = TIME2SEC( TSTEP( 2 ) )

      ! Initialize Budget Variables
      IF (LIPR) THEN
        DELC_XADV = 0.0
        DELC_YADV = 0.0
      END IF

      L_WRITE_WARNING = .TRUE.
      DO 301 LVL = 1, NLAYS

         STEP = TIME2SEC ( ASTEP( LVL ) )
         DSTEP = STEP
         FDATE = JDATE
         FTIME = JTIME

         IF ( LIPR ) THEN
            XADV = 0.0
            YADV = 0.0
         END IF

101      CONTINUE

         CALL RDBCON ( FDATE, FTIME, ASTEP( LVL ), LVL, BCON, L_WRITE_WARNING )

         IF ( LIPR ) CGRID0( :,:,: ) = CGRID( :,:,LVL,: )

         IF ( XYFIRST( LVL ) ) THEN

            XYFIRST( LVL ) = .FALSE.

            CALL X_PPM ( CGRID, FDATE, FTIME, ASTEP( LVL ), LVL, BCON )
!           CALL LCKSUMMER ( 'X_PPM', CGRID, FDATE, FTIME, LVL )
            IF ( LIPR ) THEN
               XADV( :,:,: ) = XADV( :,:,: ) + CGRID( :,:,LVL,: ) - CGRID0( :,:,: )
               CGRID0( :,:,: ) = CGRID( :,:,LVL,: )
            END IF

            CALL Y_PPM ( CGRID, FDATE, FTIME, ASTEP( LVL ), LVL, BCON )
!           CALL LCKSUMMER ( 'Y_PPM', CGRID, FDATE, FTIME, LVL )
            IF ( LIPR ) THEN
               YADV( :,:,: ) = YADV( :,:,: ) + CGRID( :,:,LVL,: ) - CGRID0( :,:,: )
               CGRID0( :,:,: ) = CGRID( :,:,LVL,: )
            END IF

         ELSE

            XYFIRST( LVL ) = .TRUE.

            CALL Y_PPM ( CGRID, FDATE, FTIME, ASTEP( LVL ), LVL, BCON )
!           CALL LCKSUMMER ( 'Y_PPM', CGRID, FDATE, FTIME, LVL )
            IF ( LIPR ) THEN
               YADV( :,:,: ) = YADV( :,:,: ) + CGRID( :,:,LVL,: ) - CGRID0( :,:,: )
               CGRID0( :,:,: ) = CGRID( :,:,LVL,: )
            END IF

            CALL X_PPM ( CGRID, FDATE, FTIME, ASTEP( LVL ), LVL, BCON )
!           CALL LCKSUMMER ( 'X_PPM', CGRID, FDATE, FTIME, LVL )
            IF ( LIPR ) THEN
               XADV( :,:,: ) = XADV( :,:,: ) + CGRID( :,:,LVL,: ) - CGRID0( :,:,: )
               CGRID0( :,:,: ) = CGRID( :,:,LVL,: )
            END IF

         END IF

         DSTEP = DSTEP + STEP
         IF ( DSTEP .LE. SYNCSTEP ) THEN
            CALL NEXTIME( FDATE, FTIME, SEC2TIME( STEP ) )
            GO TO 101
         END IF

         IF (LIPR ) THEN
           DELC_XADV( :,:,LVL,: ) = DELC_XADV( :,:,LVL,: ) + XADV( :,:,: )
           DELC_YADV( :,:,LVL,: ) = DELC_YADV( :,:,LVL,: ) + YADV( :,:,: )
         END IF
301   CONTINUE
 
      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_gather_module.f,v 1.2 2006/02/15 14:41:56 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   use F90 module feature to include all routines to perform data gather 
C function in one module and use F90 interface feature to achieve "faked" 
C polymorphism for data gather routine
C
C   there are two major routines: se_setup_gather and se_gather[n] where [n] 
C denotes the dimensionality of the data
C
C   se_setup_gather:
C      -- to setup source PE of communication for I/O PE, namely PE 0
C
C      details description is provided with the routine
C
C   se_gather[n]:
C      -- to gather n-dimensional array data from all PEs who hold information 
C         that need to be output, and store in the I/O PE namely PE 0
C
C   Subroutine parameter description:
C
C     In:  data     -- original data
C          pec      -- indicator of where data is locator in
C          ptr      -- address of data that need to be gathered
C          n        -- number of data need to be gethered in a processor
C          sdim     -- slicing data dimension, i.e. the dimenison of the data
C                      that are located in various processor
C
C     Out: data     -- original data after communication
C
C   Local variable description:
C
C      locpec     -- local copy of pec
C      locptr     -- local copy of ptr
C      i, j       -- loop indexes
C      gn         -- global n
C      locn       -- local copy of n
C
C   Example:
C
C     given four PEs, a 3D data array A(m, n, 6) where m and n are integers, and
C   the last dimension was distributed: PE 0 has 5, PE 1 has 1, 2, 3, 4, PE 2 
C   has 6, and PE 3 has nothing. Let data 1, 3, 6 be the ones that need output. 
C   So PEC will be 0 1 1 1 1 2; PRT for PE 1 and PE 2 are 1, 2 and 6, 
C   respectively, PE 0 and PE 3's PRT will be all -1; N for PE 0 to 3 are 0, 2, 
C   1, and 0, respectively. In this example, sdim is 3. Overall picture is, 
C   PE 0 will collect data from PE 1 and 2 in this example.
C
C   Include file:
C
C      se_pe_info_ext
C      se_slice_module
C      se_global_sum_module
C
C   Subroutine/Function call:
C
C     se_global_isum
C     se_slice[n]
C     setup_info
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C   Add integer data 12/16/00 by Jeff Young
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C --------------------------------------------------------------------------

        module se_gather_module

        implicit none

        private :: se_setup_gather

        interface se_gather
          module procedure se_gather1i, se_gather1r, 
     &                     se_gather2i, se_gather2r,
     &                     se_gather3i, se_gather3r, 
     &                     se_gather4i, se_gather4r
        end interface

        contains

C --------------------------------------------------------------------------
C Purpose:
C
C   to setup source PE of communication for I/O PE, namely PE 0
C
C Revision history:
C
C   Orginal version: 7/14/99 by David Wong 
C
C                    11/05/99 by David Wong
C                      -- redesign the code using OO-Based approach in F90
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Subroutine parameter description:
C
C   In:  ptr      -- address of data that need to be gathered
C        pec      -- indicator of where data is locator in
C        n        -- number of data point in a processor
C        gn       -- total number of data point among all processors
C
C   Out: locptr   -- local ptr
C        locpec   -- local pec
C        locn     -- local n
C
C Local variable description:
C
C    bufptr     -- buffer to hold ptr from all PEs
C    locnarray  -- an array to hold n from all PEs
C    i, k       -- loop index
C    j          -- position of locptr in PE 0 during compact process
C    low, high  -- starting and ending point in bufptr for each PE
C    error      -- error code for mpi call
C
C Example: Given 4 PEs, and only PE 1 and 2 have two and one data point,
C          respectively. Let prt in each PE are:
C
C          0: 0 0 0 0 ...
C          1: 1 3 0 0 ...
C          2: 6 0 0 0 ...
C          3: 0 0 0 0 ...
C
C          Then bufptr in PE 0 will be:
C
C          0: 0 0 0 1 3 0 6 0 0 0 0 0 ...
C
C Subroutine/Function call:
C
C   mpi_gather
C
C --------------------------------------------------------------------------

        subroutine se_setup_gather (ptr, locptr, pec, locpec, gn, n, locn)

        use se_pe_info_ext

        integer, intent(in) :: ptr(:), pec(:), gn, n 
        integer, intent(out) :: locptr(:), locpec(:), locn

        include "mpif.h"

        integer, allocatable :: bufptr(:), locnarray(:)
        integer :: i, j, k, low, high, error, allocate_status

C -- allocate data
        allocate (bufptr(gn*se_numworkers), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SETUP_GATHER: ',
     &              ' allocation error in bufptr'
           stop
        end if

C -- allocate data
        allocate (locnarray(0:se_numworkers-1), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SETUP_GATHER: ',
     &              ' allocation error in locnarray'
           stop
        end if

C -- PE 0 colloect ptr information from each PE
        call mpi_gather (ptr, gn, mpi_integer, bufptr, gn,
     &                   mpi_integer, 0, se_worker_comm, error)

C -- PE 0 colloect n from each PE
        call mpi_gather (n, 1, mpi_integer, locnarray(se_myworker_pe), 1,
     &                   mpi_integer, 0, se_worker_comm, error)

        if (se_myworker_pe .eq. 0) then

C -- PE 0 filters and compacts PEC and PTR array data. 

           j = 0
           do i = 0, se_numworkers-1
              low = i * gn + 1
              high = low + locnarray(i) - 1
              do k = low, high
                 j = j + 1
                 locptr(j) = bufptr(k)
                 locpec(j) = i
              end do
           end do
           locn = gn
        else
           do i = 1, gn
              if (i .le. n) then
                 locptr(i) = ptr(i)
                 locpec(i) = pec(ptr(i))
              else
                 locptr(i) = -1
                 locpec(i) = -1
              end if
           end do
           locn = n
        end if

        deallocate (bufptr)
        deallocate (locnarray)

        return
        end subroutine se_setup_gather

C --------------------------------------------------------------------------
        subroutine se_gather1r (data, pec, ptr, n, sdim)

        use se_pe_info_ext
        use se_slice_module
        use se_global_sum_module

        implicit none

        real, intent(inout) :: data(:)
        integer, intent(in) :: pec(:), ptr(:), n, sdim

        integer :: locpec(size(pec))
        integer :: locptr(size(ptr))

        integer :: i, j, gn, locn

        gn = se_global_sum(n)

        call se_setup_gather (ptr, locptr, pec, locpec, gn, n, locn)

C -- gathering data by using se_slice function
        do j = 1, locn
           i = locptr(j) 
           if ((locpec(j) .ge. 0) .or. (se_myworker_pe .eq. 0)) then
              call se_slice (data, locpec(j), 0, sdim, i, i)
           end if
        end do

        return
        end subroutine se_gather1r

C --------------------------------------------------------------------------
        subroutine se_gather2r (data, pec, ptr, n, sdim)

        use se_pe_info_ext
        use se_slice_module
        use se_global_sum_module

        implicit none

        real, intent(inout) :: data(:,:)
        integer, intent(in) :: pec(:), ptr(:), n, sdim

        integer :: locpec(size(pec))
        integer :: locptr(size(ptr))

        integer :: i, j, gn, locn

        gn = se_global_sum(n)

        call se_setup_gather (ptr, locptr, pec, locpec, gn, n, locn)

C -- gathering data by using se_slice function
        do j = 1, locn
           i = locptr(j) 
           if ((locpec(j) .ge. 0) .or. (se_myworker_pe .eq. 0)) then
              call se_slice (data, locpec(j), 0, sdim, i, i)
           end if
        end do

        return
        end subroutine se_gather2r

C --------------------------------------------------------------------------
        subroutine se_gather3r (data, pec, ptr, n, sdim)

        use se_pe_info_ext
        use se_slice_module
        use se_global_sum_module

        implicit none

        real, intent(inout) :: data(:,:,:)
        integer, intent(in) :: pec(:), ptr(:), n, sdim

        integer :: locpec(size(pec))
        integer :: locptr(size(ptr))

        integer :: i, j, gn, locn

        gn = se_global_sum(n)

        call se_setup_gather (ptr, locptr, pec, locpec, gn, n, locn)

C -- gathering data by using se_slice function
        do j = 1, locn
           i = locptr(j) 
           if ((locpec(j) .ge. 0) .or. (se_myworker_pe .eq. 0)) then
              call se_slice (data, locpec(j), 0, sdim, i, i)
           end if
        end do

        return
        end subroutine se_gather3r

C --------------------------------------------------------------------------
        subroutine se_gather4r (data, pec, ptr, n, sdim)

        use se_pe_info_ext
        use se_slice_module
        use se_global_sum_module

        implicit none

        real, intent(inout) :: data(:,:,:,:)
        integer, intent(in) :: pec(:), ptr(:), n, sdim

        integer :: locpec(size(pec))
        integer :: locptr(size(ptr))

        integer :: i, j, gn, locn

        gn = se_global_sum(n)

        call se_setup_gather (ptr, locptr, pec, locpec, gn, n, locn)

C -- gathering data by using se_slice function
        do j = 1, locn
           i = locptr(j) 
           if ((locpec(j) .ge. 0) .or. (se_myworker_pe .eq. 0)) then
              call se_slice (data, locpec(j), 0, sdim, i, i)
           end if
        end do

        return
        end subroutine se_gather4r

C --------------------------------------------------------------------------
        subroutine se_gather1i (data, pec, ptr, n, sdim)

        use se_pe_info_ext
        use se_slice_module
        use se_global_sum_module

        implicit none

        integer, intent(inout) :: data(:)
        integer, intent(in) :: pec(:), ptr(:), n, sdim

        integer :: locpec(size(pec))
        integer :: locptr(size(ptr))

        integer :: i, j, gn, locn

        gn = se_global_sum(n)

        call se_setup_gather (ptr, locptr, pec, locpec, gn, n, locn)

C -- gathering data by using se_slice function
        do j = 1, locn
           i = locptr(j) 
           if ((locpec(j) .ge. 0) .or. (se_myworker_pe .eq. 0)) then
              call se_slice (data, locpec(j), 0, sdim, i, i)
           end if
        end do

        return
        end subroutine se_gather1i

C --------------------------------------------------------------------------
        subroutine se_gather2i (data, pec, ptr, n, sdim)

        use se_pe_info_ext
        use se_slice_module
        use se_global_sum_module

        implicit none

        integer, intent(inout) :: data(:,:)
        integer, intent(in) :: pec(:), ptr(:), n, sdim

        integer :: locpec(size(pec))
        integer :: locptr(size(ptr))

        integer :: i, j, gn, locn

        gn = se_global_sum(n)

        call se_setup_gather (ptr, locptr, pec, locpec, gn, n, locn)

C -- gathering data by using se_slice function
        do j = 1, locn
           i = locptr(j) 
           if ((locpec(j) .ge. 0) .or. (se_myworker_pe .eq. 0)) then
              call se_slice (data, locpec(j), 0, sdim, i, i)
           end if
        end do

        return
        end subroutine se_gather2i

C --------------------------------------------------------------------------
        subroutine se_gather3i (data, pec, ptr, n, sdim)

        use se_pe_info_ext
        use se_slice_module
        use se_global_sum_module

        implicit none

        integer, intent(inout) :: data(:,:,:)
        integer, intent(in) :: pec(:), ptr(:), n, sdim

        integer :: locpec(size(pec))
        integer :: locptr(size(ptr))

        integer :: i, j, gn, locn

        gn = se_global_sum(n)

        call se_setup_gather (ptr, locptr, pec, locpec, gn, n, locn)

C -- gathering data by using se_slice function
        do j = 1, locn
           i = locptr(j) 
           if ((locpec(j) .ge. 0) .or. (se_myworker_pe .eq. 0)) then
              call se_slice (data, locpec(j), 0, sdim, i, i)
           end if
        end do

        return
        end subroutine se_gather3i

C --------------------------------------------------------------------------
        subroutine se_gather4i (data, pec, ptr, n, sdim)

        use se_pe_info_ext
        use se_slice_module
        use se_global_sum_module

        implicit none

        integer, intent(inout) :: data(:,:,:,:)
        integer, intent(in) :: pec(:), ptr(:), n, sdim

        integer :: locpec(size(pec))
        integer :: locptr(size(ptr))

        integer :: i, j, gn, locn

        gn = se_global_sum(n)

        call se_setup_gather (ptr, locptr, pec, locpec, gn, n, locn)

C -- gathering data by using se_slice function
        do j = 1, locn
           i = locptr(j) 
           if ((locpec(j) .ge. 0) .or. (se_myworker_pe .eq. 0)) then
              call se_slice (data, locpec(j), 0, sdim, i, i)
           end if
        end do

        return
        end subroutine se_gather4i

        end module se_gather_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_global_sum_module.f,v 1.2 2006/02/15 14:41:56 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   use F90 interface feature to achieve "faked" polymorphism for global sum
C   routine
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Parameter List:
C
C   In: var -- sum variable
C
C Local Variable:
C
C   sum         -- local variable for computing global sum
C   error       -- error code for mpi call
C
C Include Files:
C
C   mpif.h
C   se_pe_info_ext:
C -----------------------------------------------------------------------------

        module se_global_sum_module

        implicit none

        interface se_global_sum
          module procedure se_global_isum, se_global_rsum,
     &                     se_global_iasum, se_global_rasum
        end interface

        contains

C -----------------------------------------------------------------------------
        function se_global_isum (var) result (se_global_isum_result)

        use se_pe_info_ext

        implicit none

        integer :: se_global_isum_result
        integer, intent(in) :: var

        include "mpif.h"

        integer :: sum, error

        call mpi_reduce (var, sum, 1, mpi_integer, mpi_sum, 0,
     &                   se_worker_comm, error)

        if (se_myworker_pe .eq. 0) then
           se_global_isum_result = sum
        end if

        call mpi_bcast (se_global_isum_result, 1, mpi_integer, 0, 
     &                  se_worker_comm, error)

        return
        end function se_global_isum

C -----------------------------------------------------------------------------
        function se_global_rsum (var) result (se_global_rsum_result)

        use se_pe_info_ext

        implicit none

        real :: se_global_rsum_result
        real, intent(in) :: var

        include "mpif.h"

        real sum
        integer error

        call mpi_reduce (var, sum, 1, mpi_real, mpi_sum, 0,
     &                   se_worker_comm, error)

        if (se_myworker_pe .eq. 0) then
           se_global_rsum_result = sum
        end if

        call mpi_bcast (se_global_rsum_result, 1, mpi_real, 0, 
     &                  se_worker_comm, error)

        return
        end function se_global_rsum

C -----------------------------------------------------------------------------
        function se_global_iasum (var) result (se_global_iasum_result)

        use se_pe_info_ext

        implicit none

        integer, intent(in) :: var(:)
        integer :: se_global_iasum_result(size(var))

        include "mpif.h"

        integer :: sum(size(var)), error, n

        n = size(var)

        call mpi_reduce (var, sum, n, mpi_integer, mpi_sum, 0,
     &                   se_worker_comm, error)

        if (se_myworker_pe .eq. 0) then
           se_global_iasum_result = sum
        end if

        call mpi_bcast (se_global_iasum_result, n, mpi_integer, 0, 
     &                  se_worker_comm, error)

        return
        end function se_global_iasum

C -----------------------------------------------------------------------------
        function se_global_rasum (var) result (se_global_rasum_result)

        use se_pe_info_ext

        implicit none

        real, intent(in) :: var(:)
        real :: se_global_rasum_result(size(var))

        include "mpif.h"

        real sum(size(var))
        integer error, n

        n = size(var)

        call mpi_reduce (var, sum, n, mpi_real, mpi_sum, 0,
     &                   se_worker_comm, error)

        if (se_myworker_pe .eq. 0) then
           se_global_rasum_result = sum
        end if

        call mpi_bcast (se_global_rasum_result, n, mpi_real, 0, 
     &                  se_worker_comm, error)

        return
        end function se_global_rasum

        end module se_global_sum_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module lus_defn
C Land Use/Cover Schema

C Revision History:
C   10 Nov 2011: J.Young - Created
C   10 Dec 2011: J.Young - fix for two-way application (Tanya Spero`s help)
C    2 Feb 2019:  D. Wong - Implemented centralized I/O approach, removed all 
C                           MY_N clauses, with new re-structure of LUS_DEFN, 
C                           most of the data declaration has been moved to 
C                           lus_data_module (model_data_module.f)
C    3 Mar 2022: J. Willison - Remove ctm_wbdust_beld option

      implicit none

      public lus_init
      private

      contains

#ifdef mpas
         function lus_init( mminlu_in, landusef_in ) result ( success )
#else
         function lus_init( jdate, jtime ) result ( success )
#endif

         use hgrd_defn           ! horizontal domain specifications
#ifdef twoway
         use twoway_data_module, only : mminlu, num_land_cat
#endif
         use utilio_defn
         use lus_data_module

         implicit none

#ifdef mpas
         character (*), intent( in ) :: mminlu_in
         real, intent( in ) :: landusef_in(:,:)

         integer, allocatable :: lu_ind(:)
         integer :: j
         logical :: found

         character (16) :: mminlu
         integer :: num_land_cat
#else
         integer, intent( in ) :: jdate      ! current model date, coded YYYYDDD
         integer, intent( in ) :: jtime      ! current model time, coded HHMMSS
#endif

C Includes:
         include SUBST_FILES_ID  ! file name parameters

         logical :: success

         integer :: gxoff, gyoff             ! global origin offset from file
         integer, save :: strtcol_01, endcol_01, strtrow_01, endrow_01
         integer, save :: strtcol_02, endcol_02, strtrow_02, endrow_02

         character( 16 ) :: pname = 'LUS_INIT'
         character( 128 ) :: vardesc = ' '
         character( 128 ) :: xmsg = ' '
         character( 24 ) :: strg = 'incorrect num_land_cat, '
         real( 8 ) :: tland
         integer i, c, r, err

#ifdef mpas
         mminlu = mminlu_in
         if (mminlu .eq. 'USGS') then
            num_land_cat = 24
         else if (mminlu .eq. 'NLCD40') then
            num_land_cat = size(landusef_in,1)
         end if
         dust_land_scheme = mminlu_in
#endif

         success = .true.

            ladut = 100.0 * ladut   ! array assignment
            lut   = 100.0 * lut     ! array assignment

C Merge fractional landuse categories into 4 groups for dust transport factors
         select case( dust_land_scheme )

            case( 'USGS24' )
            do r = 1, nrows
            do c = 1, ncols
C           water & barren surrounding
               uland( c,r,1 ) = lut( c,r,8 )   ! Shrubland
     &                        + lut( c,r,16 )  ! Water
     &                        + lut( c,r,19 )  ! Barren or Sparsely Vegetated
     &                        + lut( c,r,22 )  ! Mixed Tundra
     &                        + lut( c,r,23 )  ! Bare Ground Tundra
     &                        + lut( c,r,24 )  ! Snow and Ice

C           grass & crop surrounding
               uland( c,r,2 ) = lut( c,r,2 )   ! Dryland Cropland and Pasture
     &                        + lut( c,r,3 )   ! Irrigated Cropland and Pasture
     &                        + lut( c,r,4 )   ! Mixed Dryland and Irrigated Cropland and Pasture
     &                        + lut( c,r,5 )   ! Cropland-Grassland Mosaic
     &                        + lut( c,r,6 )   ! Cropland-Woodland Mosaic
     &                        + lut( c,r,7 )   ! Grassland
     &                        + lut( c,r,9 )   ! Mixed Shrubland-Grassland
     &                        + lut( c,r,10 )  ! Savannah
     &                        + lut( c,r,17 )  ! Herbaceous Wetland
     &                        + lut( c,r,20 )  ! Herbaceous Tundra

C           building surrounding
               uland( c,r,3 ) = lut( c,r,1 )   ! Urban Land

C           forest surrounding
               uland( c,r,4 ) = lut( c,r,11 )  ! Deciduous Broadleaf Forest
     &                        + lut( c,r,12 )  ! Deciduous Needleleaf Forest
     &                        + lut( c,r,13 )  ! Evergreen Broadleaf Forest
     &                        + lut( c,r,14 )  ! Evergreen Needleleaf Forest
     &                        + lut( c,r,15 )  ! Mixed Forest
     &                        + lut( c,r,18 )  ! Wooded Wetland
     &                        + lut( c,r,21 )  ! Wooded Tundra
            end do
            end do

!           case( 'MODIS' )
!           do r = 1, nrows
!           do c = 1, ncols
!              uland( c,r,1 ) = lut( c,r,> )
!           end do
!           end do

            case( 'NLCD40' )
            do r = 1, nrows
            do c = 1, ncols
C           water & barren surrounding
               uland( c,r,1 ) = lut( c,r,21 )   ! Open Water
     &                        + lut( c,r,22 )   ! Perennial Ice-Snow
     &                        + lut( c,r,27 )   ! Barren Land (Rock-Sand-Clay)
     &                        + lut( c,r,31 )   ! Dwarf Scrub
     &                        + lut( c,r,32 )   ! Shrub-Scrub
     &                        + lut( c,r,15 )   ! Permanent Snow and Ice
     &                        + lut( c,r,16 )   ! Barren or Sparsely Vegetated
     &                        + lut( c,r,17 )   ! IGBP Water

C           grass & crop surrounding
               uland( c,r,2 ) = lut( c,r,33 )  ! Grassland-Herbaceous
     &                        + lut( c,r,34 )  ! Sedge-Herbaceous
     &                        + lut( c,r,35 )  ! Lichens
     &                        + lut( c,r,36 )  ! Moss
     &                        + lut( c,r,37 )  ! Pasture-Hay
     &                        + lut( c,r,38 )  ! Cultivated Crops
     &                        + lut( c,r,6  )  ! Closed Shrublands
     &                        + lut( c,r,7  )  ! Open Shrublands
     &                        + lut( c,r,9  )  ! Savannas
     &                        + lut( c,r,10 )  ! Grasslands
     &                        + lut( c,r,12 )  ! Croplands
     &                        + lut( c,r,14 )  ! Cropland-Natural Vegetation Mosaic

C           building surrounding
               uland( c,r,3 ) = lut( c,r,24 )   ! Developed Low Intensity
     &                        + lut( c,r,25 )   ! Developed Medium Intensity
     &                        + lut( c,r,26 )   ! Developed High Intensity
     &                        + lut( c,r,13 )   ! Urban and Built Up

C           forest surrounding
               uland( c,r,4 ) = lut( c,r,28 )  ! Deciduous Forest
     &                        + lut( c,r,29 )  ! Evergreen Forest
     &                        + lut( c,r,30 )  ! Mixed Forest
     &                        + lut( c,r,39 )  ! Woody Wetlands
     &                        + lut( c,r,40 )  ! Emergent Herbaceous Wetlands
     &                        + lut( c,r,1  )  ! Evergreen Needleleaf Forest
     &                        + lut( c,r,2  )  ! Evergreen Broadleaf Forest
     &                        + lut( c,r,3  )  ! Deciduous Needleleaf Forest
     &                        + lut( c,r,4  )  ! Deciduous Broadleaf Forest
     &                        + lut( c,r,5  )  ! Mixed Forests
     &                        + lut( c,r,8  )  ! Woody Savannas
     &                        + lut( c,r,11 )  ! Permanent Wetlands
            end do
            end do

            case( 'NLCD-MODIS', 'NLCD50' )
            do r = 1, nrows
            do c = 1, ncols
C           water & barren surrounding
               uland( c,r,1 ) = lut( c,r,1 )   ! Open Water
     &                        + lut( c,r,2 )   ! Perennial Ice-Snow
     &                        + lut( c,r,7 )   ! Barren Land (Rock-Sand-Clay)
     &                        + lut( c,r,12 )  ! Dwarf Scrub
     &                        + lut( c,r,13 )  ! Shrub-Scrub
     &                        + lut( c,r,18 )  ! Tundra
     &                        + lut( c,r,31 )  ! Water
     &                        + lut( c,r,46 )  ! Permanent Snow and Ice
     &                        + lut( c,r,47 )  ! Barren or Sparsely Vegetated
     &                        + lut( c,r,48 )  ! IGBP Water

C           grass & crop surrounding
               uland( c,r,2 ) = lut( c,r,14 )  ! Grassland-Herbaceous
     &                        + lut( c,r,15 )  ! Sedge-Herbaceous
     &                        + lut( c,r,16 )  ! Lichens
     &                        + lut( c,r,17 )  ! Moss
     &                        + lut( c,r,19 )  ! Pasture-Hay
     &                        + lut( c,r,20 )  ! Cultivated Crops
     &                        + lut( c,r,37 )  ! Closed Shrublands
     &                        + lut( c,r,38 )  ! Open Shrublands
     &                        + lut( c,r,40 )  ! Savannas
     &                        + lut( c,r,41 )  ! Grasslands
     &                        + lut( c,r,43 )  ! Croplands
     &                        + lut( c,r,45 )  ! Cropland-Natural Vegetation Mosaic

C           building surrounding
               uland( c,r,3 ) = lut( c,r,4 )   ! Developed Low Intensity
     &                        + lut( c,r,5 )   ! Developed Medium Intensity
     &                        + lut( c,r,6 )   ! Developed High Intensity
     &                        + lut( c,r,44 )  ! Urban and Built Up

C           forest surrounding
               uland( c,r,4 ) = lut( c,r,9 )   ! Deciduous Forest
     &                        + lut( c,r,10 )  ! Evergreen Forest
     &                        + lut( c,r,11 )  ! Mixed Forest
     &                        + lut( c,r,21 )  ! Woody Wetlands
     &                        + lut( c,r,22 )  ! Palustrine Forested Wetland
     &                        + lut( c,r,24 )  ! Estuarine Forested Wetland
     &                        + lut( c,r,32 )  ! Evergreen Needleleaf Forest
     &                        + lut( c,r,33 )  ! Evergreen Broadleaf Forest
     &                        + lut( c,r,34 )  ! Deciduous Needleleaf Forest
     &                        + lut( c,r,35 )  ! Deciduous Broadleaf Forest
     &                        + lut( c,r,36 )  ! Mixed Forests
     &                        + lut( c,r,39 )  ! Woody Savannas
     &                        + lut( c,r,42 )  ! Permanent Wetlands
            end do
            end do

            case( 'MODIS_NOAH' )
            do r = 1, nrows
            do c = 1, ncols
C           water & barren surrounding
               uland( c,r,1 ) = lut( c,r,6 )   ! Closed Shrublands
     &                        + lut( c,r,7 )   ! Open Shrublands
     &                        + lut( c,r,15 )  ! Snow and Ice
     &                        + lut( c,r,16 )  ! Barren or Sparsely Vegetated
     &                        + lut( c,r,17 )  ! Water
     &                        + lut( c,r,19 )  ! Mixed Tundra
     &                        + lut( c,r,20 )  ! Barren Tundra

C           grass & crop surrounding
               uland( c,r,2 ) = lut( c,r,8 )   ! Woody Savannas
     &                        + lut( c,r,9 )   ! Savannas
     &                        + lut( c,r,10 )  ! Grasslands
     &                        + lut( c,r,12 )  ! Croplands
     &                        + lut( c,r,14 )  ! Cropland-Natural Vegetation Mosaic
     &                        + lut( c,r,18 )  ! Wooded Tundra

C           building surrounding
               uland( c,r,3 ) = lut( c,r,13 )  ! Urban and Built-Up

C           forest surrounding
               uland( c,r,4 ) = lut( c,r,1 )   ! Evergreen Needleleaf Forest
     &                        + lut( c,r,2 )   ! Evergreen Broadleaf Forest
     &                        + lut( c,r,3 )   ! Deciduous Needleleaf Forest
     &                        + lut( c,r,4 )   ! Deciduous Broadleaf Forest
     &                        + lut( c,r,5 )   ! Mixed Forests
     &                        + lut( c,r,11 )  ! Permanent Wetlands
            end do
            end do

         end select

         do r = 1, nrows
         do c = 1, ncols

            tland = 0.0d0
            do i = 1, 4
               uland( c,r,i ) = max( 0.0, min( 100.0, uland( c,r,i ) ) )
               tland = tland + real( uland( c,r,i ), 8 )
            end do

            if ( tland .gt. 100.0d0 ) then
#ifdef dbg_wbdust
               write( logdev,* ) ' >>> tland:', c, r, tland
#endif
               do i = 1, 4
                  uland( c,r,i ) = uland( c,r,i ) * real( 100.0d0 / tland, 4 )
               end do
            end if

         end do
         end do

         deallocate( lut )

         return
         end function lus_init

      end module lus_defn

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_init_module.F,v 1.1 2006/02/15 14:56:48 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C-----------------------------------------------------------------------

      module se_init_module

      implicit none

      private :: se_dim_init
      private :: cal_size 

      contains

C-----------------------------------------------------------------------
C Purpose:
C   initialize variables for stencil exchange library
 
C Revision history:
C   Orginal version: 7/10/98 by David Wong
C                    2/15/99 by David Wong
C                      -- add se_global_map call to determine processor
C                         configuration and global domain map
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    10/13/00 by David Wong
C                      -- rename row with dimi and col with dimj and use 
C                         data_ori to determine the order of column and
C                         row input
C                    12/12/00 by David Wong
C                      -- use f90 function ALLOCATED to determine an array has
C                         been allocated or not rather than a logical variable.
C                    12/04/00 by David Wong
C                      -- modified the routine to accommodate: 1. the 
C                         worker and I/O processors partition scheme and 2.
C                         data structure reordering
C                    12/29/05 by Jeff Young
C                      -- annotate
C                    08/24/11 by David Wong
C                      -- eliminated data and geo orientation
 
C Local variable description:
C   i, j      -- loop index
C   leng      -- length of the character string, decompstr
C   decompstr -- a character string indicateing which dimension(s) is/are
C                decomposed
C   loci      -- Cartesian coordinate of mype x-axis
C   locj      -- Cartesian coordinate of mype y-axis
C   pos       -- position in the conversion table
C   conv      -- a conversion table
C conversion table layout
C   (loci-1, locj-1) (loci-1, locj) (loci-1, locj+1)                8  1  2
C   ( loci,  locj-1) ( loci,  locj) ( loci,  locj+1) equivalent to  7     3
C   (loci+1, locj-1) (loci+1, locj) (loci+1, locj+1)                6  5  4
 
C Include files:
C   se_domain_info.ext
C   se_pe_info.ext
C   se_comm_info.ext
C   se_disp_info_ext
 
C Subroutine/Function call:
C   se_dim_init
C-----------------------------------------------------------------------

! #ifdef slcr
!       subroutine se_init (numprocs, npdimi, npdimj, gl_ndimks, gl_ndimls, 
!    &                      gl_ndimis, gl_ndimjs, my_pe,
!    &                      mndis, medis, msdis, mwdis, data_ori, geo_ori)
! #else
        subroutine se_init (numprocs, npdimi, npdimj, gl_ndimis, gl_ndimjs,
     &                      gl_ndimks, gl_ndimls, my_pe,
     &                      mndis, medis, msdis, mwdis, data_ori, geo_ori)
! #endif

        use se_pe_info_ext
        use se_domain_info_ext
        use se_comm_info_ext
        use se_disp_info_ext
        use se_bndy_copy_info_ext
!       use se_ori_ext
        use se_internal_util_module

        implicit none

        include 'mpif.h'

        integer, intent( in ) :: numprocs, npdimi, npdimj
        integer, intent( in ) :: gl_ndimis, gl_ndimjs, gl_ndimks, gl_ndimls
        integer, intent( in ) :: my_pe
        integer, intent( in ) :: mndis, medis, msdis, mwdis
        character( 2 ), optional, intent( in ) :: data_ori
        integer, optional, intent( in ) :: geo_ori

        integer :: i, j, leng
        character( 10 ) :: decompstr
        integer :: loci, locj, pos, allocate_status
        integer :: conv( 8 )

        integer :: se_world_group, se_io_group, se_worker_group, error
c       integer, allocatable :: ranks(:)
 
        data conv / 8, 1, 2, 7, 3, 6, 5, 4 /

C 1 = initialize data in module se_pe_info_ext
C 2 = initialize data in module se_domain_info_ext.f
C 3 = initialize data in module se_comm_info_ext.f
C 4 = initialize data in module se_disp_info_ext
C 5 = initialize data in module se_bndy_copy_info_ext
C 6 = initialize data in module se_ori_ext

!       if (present(data_ori)) then 
!          if ((data_ori .eq. "cr") .or. (data_ori .eq. "CR")) then
!             se_npcol = npdimi                       ! 1
!             se_nprow = npdimj                       ! 1
!             se_gl_ncols = gl_ndimis                 ! 2
!             se_gl_nrows = gl_ndimjs                 ! 2
!          else
!             se_npcol = npdimj                       ! 1
!             se_nprow = npdimi                       ! 1
!             se_gl_ncols = gl_ndimjs                 ! 2
!             se_gl_nrows = gl_ndimis                 ! 2
!          end if
!       else
           se_npcol = npdimi                       ! 1
           se_nprow = npdimj                       ! 1
           se_gl_ncols = gl_ndimis                 ! 2
           se_gl_nrows = gl_ndimjs                 ! 2
!       end if

        se_numworkers = se_npcol * se_nprow        ! 1
        se_numiopes   = numprocs - se_numworkers   ! 1

        se_my_pe = my_pe                           ! 1

        if ( se_numiopes .gt. 0 ) then
           se_partition_mode = 2                   ! 1
           if ( my_pe .lt. se_numiopes ) then
              se_myworker_pe = -1                  ! 1
              se_myio_pe = my_pe                   ! 1
           else
              se_myworker_pe = my_pe - se_numiopes ! 1
              se_myio_pe = -1                      ! 1
           end if
        else
           se_partition_mode = 1                   ! 1
           se_myworker_pe = my_pe                  ! 1
           se_myio_pe = -1                         ! 1
        end if

        call mpi_comm_dup ( mpi_comm_world, se_world_comm, error )  ! 1

        if ( se_partition_mode .eq. 2 ) then
           call mpi_comm_group ( mpi_comm_world, se_world_group, error )

           allocate ( ranks( se_numiopes ), stat=allocate_status )

           do i = 1, se_numiopes
              ranks( i ) = i - 1                   ! 1
           end do

           call mpi_group_incl ( se_world_group, se_numiopes, ranks, 
     &                           se_io_group, error )
           call mpi_group_excl ( se_world_group, se_numiopes, ranks, 
     &                           se_worker_group, error )

           call mpi_comm_create ( mpi_comm_world, se_io_group, 
     &                            se_io_comm, error )                   ! 1
           call mpi_comm_create ( mpi_comm_world, se_worker_group, 
     &                            se_worker_comm, error )               ! 1
        else
           call mpi_comm_dup ( mpi_comm_world, se_worker_comm, error )  ! 1
        end if

        se_gl_nlays = gl_ndimks                   ! 2
        se_gl_nspcs = gl_ndimls                   ! 2

        se_mndis = mndis                          ! 4
        se_medis = medis                          ! 4
        se_msdis = msdis                          ! 4
        se_mwdis = mwdis                          ! 4

C       call pxfgetenv ('decompstr', 0, decompstr, leng, 0)

        decompstr = ' 1 1 0 0'   ! horizontal decomp (cols X rows)
        leng = 8

        se_numprocs = numprocs                    ! 1
        se_numdim = leng / 2                      ! 3
        se_decompstr = decompstr                  ! 3

!       if (present(data_ori)) then 
!          se_data_ori = data_ori                 ! 6
!       else
!          se_data_ori = 'CR'                     ! 6
!       end if
!       if (present(geo_ori)) then 
!          se_geo_ori = geo_ori                   ! 6
!       else
!          se_geo_ori = 0                         ! 6
!       end if

C -- initialize ngb_pe

        se_ngb_pe = -1                            ! 3

        if ( ( se_myworker_pe .eq. my_pe ) .or. ( se_myio_pe .eq. -1 ) ) then
           loci = se_myworker_pe / se_npcol
           locj = mod ( se_myworker_pe, se_npcol )
           pos = 0
           do i = loci-1, loci+1
              do j = locj-1, locj+1
                 if ( ( i .ne. loci ) .or. ( j .ne. locj ) ) then
                    pos = pos + 1
                    if ( ( i .ge. 0 ) .and. ( i .lt. se_nprow ) .and.
     &                   ( j .ge. 0 ) .and. ( j .lt. se_npcol ) ) then
                       se_ngb_pe( conv( pos ) ) = i * se_npcol + j   ! 3
                    else
                       se_ngb_pe( conv( pos ) ) = -1                 ! 3
                    end if
                 end if
              end do
           end do

C -- initialize boundary ngb_pe

        se_bngb_pe = -1                           ! 5

           if ( se_myworker_pe .lt. se_npcol ) then
              se_bngb_pe( 5 ) = (se_nprow - 1) * se_npcol + se_myworker_pe ! 5
           end if

           if ( se_myworker_pe .ge. (se_nprow - 1) * se_npcol ) then
              se_bngb_pe( 1 ) = mod(se_myworker_pe, se_npcol)              ! 5
           end if

           if ( mod(se_myworker_pe, se_npcol) .eq. 0 ) then
              se_bngb_pe( 3 ) = se_myworker_pe + se_npcol - 1              ! 5
           end if

           if ( mod(se_myworker_pe, se_npcol) .eq. (se_npcol - 1) ) then
              se_bngb_pe( 7 ) = se_myworker_pe / se_npcol * se_npcol       ! 5
           end if

           if ( se_myworker_pe .eq. 0 ) then
              se_bngb_pe( 4 ) = se_npcol * se_nprow - 1                    ! 5
           end if

           if ( se_myworker_pe .eq. se_npcol - 1 ) then
              se_bngb_pe( 6 ) = se_npcol * (se_nprow - 1)                  ! 5
           end if

           if ( se_myworker_pe .eq. (se_nprow - 1) * se_npcol ) then
              se_bngb_pe( 2 ) = se_npcol - 1                               ! 5
           end if

           if ( se_myworker_pe .eq. se_npcol * se_nprow - 1 ) then
              se_bngb_pe( 8 ) = 0                                          ! 5
           end if

        end if

        call se_dim_init

C -- figure out the low and high column and row index of the
C    original grid, respectively

        if ( .not. allocated( se_gl_ind ) ) then
C -- allocate data
           allocate (se_gl_ind(2, 2, 0:se_numworkers-1), stat=allocate_status)
           if ( allocate_status .ne. 0 ) then
              print *, ' Allocation error in subroutine SE_INIT'
              stop
           end if
        end if

        se_gl_ind_ptr => se_gl_ind

        call se_generate_map ( 1, se_gl_nrows, 1, se_gl_ncols,
     &                         se_nprow, se_npcol, se_gl_ind_ptr )   ! 2

        return
        end subroutine se_init 

C-----------------------------------------------------------------------
C Purpose:
C   1. determine which dimension(s) is/are distributed 
C   2. determine local PE work load of a distributed array 
 
C Revision history:
C   Orginal version: 8/10/98 by David Wong
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
 
C Local variable description:
C   i       -- loop index
C   ldecomp -- an array indicating which dimension(s) is/are distributed
C   ldim    -- an array holding the global dimension
C   pos1    -- first distributed dimension
C   pos2    -- second distributed dimension
C   first   -- a boolean variable
 
C Include files:
C   se_pe_info.ext
C   se_domain_info.ext
C   se_comm_info.ext
 
C Subroutine/Function call:
C   cal_size
C-----------------------------------------------------------------------

        subroutine se_dim_init

        use se_domain_info_ext
        use se_pe_info_ext
        use se_comm_info_ext

        implicit none

        integer :: i
        integer :: ldecomp( 4 ), ldim( 4 )
        integer :: pos1, pos2
        logical :: first

        first = .true.

        ldim( 1 ) = se_gl_nrows
        ldim( 2 ) = se_gl_ncols
        ldim( 3 ) = se_gl_nlays
        ldim( 4 ) = se_gl_nspcs

        pos1 = 0
        pos2 = 0

        read( se_decompstr, 10 ) ( ldecomp( i ), i = 1, se_numdim )
10      format( 5i2 )

C -- extract the distributed dimension(s)
        do i = 1, se_numdim
           if ( ldecomp( i ) .eq. 1 ) then
              if ( first ) then
                 pos1 = i
                 first = .false.
              else 
                 pos2 = i
              end if
           end if
        end do

C -- row x column
        if ( ((pos1 .eq. 1) .and. (pos2 .eq. 2)) .or.
     &       ((pos1 .eq. 1) .and. (pos2 .eq. 0)) ) then
            se_nrows = (se_gl_nrows - 1) / se_nprow + 1      ! 2
            se_ncols = (se_gl_ncols - 1) / se_npcol + 1      ! 2
            se_nlays = se_gl_nlays                           ! 2
            se_nspcs = se_gl_nspcs                           ! 2
C -- column x layer
        else if ( ((pos1 .eq. 2) .and. (pos2 .eq. 3)) .or.
     &            ((pos1 .eq. 2) .and. (pos2 .eq. 0)) ) then
            se_nrows = se_gl_nrows                           ! 2
            se_ncols = (se_gl_ncols - 1) / se_nprow + 1      ! 2
            se_nlays = (se_gl_nlays - 1) / se_npcol + 1      ! 2
            se_nspcs = se_gl_nspcs                           ! 2
C -- layer x row
        else if ( ((pos1 .eq. 3) .and. (pos2 .eq. 1)) .or.
     &            ((pos1 .eq. 3) .and. (pos2 .eq. 0)) ) then
            se_nrows = (se_gl_nrows - 1) / se_nprow + 1      ! 2
            se_ncols = se_gl_ncols                           ! 2
            se_nlays = (se_gl_nlays - 1) / se_nprow + 1      ! 2
            se_nspcs = se_gl_nspcs                           ! 2
C -- species x layer
        else if ( ((pos1 .eq. 4) .and. (pos2 .eq. 3)) .or.
     &            ((pos1 .eq. 4) .and. (pos2 .eq. 0)) ) then
            se_nrows = se_gl_nrows                           ! 2
            se_ncols = se_gl_ncols                           ! 2
            se_nlays = (se_gl_nlays - 1) / se_npcol + 1      ! 2
            se_nspcs = (se_gl_nspcs - 1) / se_nprow + 1      ! 2
C -- row x species
        else if ( (pos1 .eq. 1) .and. (pos2 .eq. 4) ) then
            se_nrows = (se_gl_nrows - 1) / se_nprow + 1      ! 2
            se_ncols = se_gl_ncols                           ! 2
            se_nlays = se_gl_nlays                           ! 2
            se_nspcs = (se_gl_nspcs - 1) / se_npcol + 1      ! 2
C -- column x species
        else
            se_nrows = se_gl_nrows                           ! 2
            se_ncols = (se_gl_ncols - 1) / se_nprow + 1      ! 2
            se_nlays = se_gl_nlays                           ! 2
            se_nspcs = (se_gl_nspcs - 1) / se_npcol + 1      ! 2
        end if

C -- determine what type of domain decomposition, logically, the first and 
C    second one become the row and column dimension, respectively
        if ( pos2 .gt. 0 ) then
           if ( ((pos1 .eq. 1) .and. (pos2 .eq. 3)) .or.
     &          ((pos1 .eq. 3) .and. (pos2 .eq. 4)) ) then
              ldecomp( pos2 ) = 1
              ldecomp( pos1 ) = 2
           else
              ldecomp( pos1 ) = 1
              ldecomp( pos2 ) = 2
           end if
        else
           ldecomp( pos1 ) = 1
        end if

C -- determine the actual size of each dimension locally
        call cal_size ( ldim, ldecomp,
     &                  se_my_nrows, se_my_ncols, se_my_nlays, se_my_nspcs ) ! 2

        do i = 1, 4
           ldim( i ) = ldim( i ) + 1
        end do

C -- determine the actual size of each dimension locally when the global
C    dimension increases by one
        call cal_size ( ldim, ldecomp,
     &                  se_my_nrowsp1, se_my_ncolsp1, se_my_nlaysp1, se_my_nspcsp1 ) ! 2

        return
        end subroutine se_dim_init

C-----------------------------------------------------------------------
C Purpose:
C   to determine local work load dimensions each PE owns, of a distributed
C   array
 
C Revision history:
C   Orginal version: 8/10/98 by David Wong
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
 
C Parameter list:
C   IN:  ldim    -- global dimension values
C        ldecomp -- indicator of which dimension(s) is/are distributed
C   OUT: rows    -- number of rows in a PE
C        cols    -- number of columns in a PE 
C        lays    -- number of layers in a PE
C        spcs    -- number of species in a PE
 
C Local variable description:
C   i     -- loop index
C   temp  -- a temporary variable
C   tldim -- local copy of ldim
 
C Include files:
C   se_comm_info.ext
C   se_pe_info.ext
C-----------------------------------------------------------------------

        subroutine cal_size ( ldim, ldecomp, rows, cols, lays, spcs )

        use se_comm_info_ext
        use se_pe_info_ext

        implicit none

        integer, intent( in ) :: ldim( 4 ), ldecomp( 4 )
        integer, intent( out ) :: rows, cols, lays, spcs

        integer :: i, temp
        integer :: tldim( 4 )

        do i = 1, se_numdim
           tldim( i ) = ldim( i )
           if (ldecomp( i ) .eq. 1) then
C -- calculating the size of the logical row dimension
              temp = ldim( i )
              tldim( i ) = tldim( i ) / se_nprow
              temp = (temp - tldim( i ) * se_nprow) * se_npcol
              if (se_myworker_pe .lt. temp) then
                 tldim( i ) = tldim( i ) + 1
              end if
           else if (ldecomp( i ) .eq. 2) then
C -- calculating the size of the logical column dimension
              temp = ldim( i )
              tldim( i ) = tldim( i ) / se_npcol
              temp = temp - tldim( i ) * se_npcol
              if (mod(se_myworker_pe, se_npcol) .lt. temp) then
                 tldim( i ) = tldim( i ) + 1
              end if
           end if
        end do

        rows = tldim( 1 )
        cols = tldim( 2 )
        lays = tldim( 3 )
        spcs = tldim( 4 )

        return
        end subroutine cal_size

        end module se_init_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PT3D_DEFN

C-----------------------------------------------------------------------
C Function: 3d point source emissions interface to the chemistry-transport model

C Revision History:
C     21 Nov 2007 J.Young: initial implementation
C     1  Jun 2010 David Wong: In subroutine GET_PT3D_EMIS, removed a IF-THEN
C                             block of code since the argument for TIME2SEC is in
C                             HHMMSS format rather than day format and also
C                             STKDATE is already set correctly
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     11 May 2011 David Wong: incorporated twoway model implementation
C     27 Jul 2011 David Wong: 1. in subroutine GET_PT3D_EMIS, use PRE_JDATE, and
C                                LOC_STKDATE to track change of date during a
C                                simulation when the start time is not 0, so
C                                correct data can be pulled by INTERPX routine
C                             2. used WINDOW logical variable (in subroutine
C                                PT3D_INIT) to determine x and y orig information
C                                and in subroutine READGC3, do not expand the
C                                STATCOL and STRTROw in the west and south direction
C     29 Oct 2011 J.Young: fix domain windowing
C     30 Apr 2012 C.Nolte: fix number of substeps, NTICS to be the number of
C                          synchronization time steps rather than the number of seconds. 
C     19 Dec 2013 D. Wong: used WRTIME, a robust way to determine when to write the 
C                          PT3D diagnostic file instead of relying on NTICS in particular
C                          for the twoway model where a time step can be sub-divided.
C     29 Jul 2014 D. Wong: check MET_CRO_3D and MET_DOT_3D separately for domain windowing
C     12 Aug 2015 D. Wong: - Used assumed shape array declaration and declared associated 
C                            subroutines in INTERFACE block
C                          - Replaced BMATVEC with BMATVECN which will call with a 1d or 
C                            2d argument subroutine by F90 poly-morphism feature
C                          - Based on the condition of MY_NSRC ( > 0 or not) to determine 
C                            execution of certain section of code or not
C     30 Apr 2016 J.Young: add multiple fire source capability, in affiliation with
C                          Yongtao Hu (Georgia Tech)
C     22 Jun 2016 B.Hutzell: Fixed issue where single emis species maps to multiple model
C                            species
C     08 Aug 2016 B.Murphy: Neglect fire emissions for pcVOC
C     16 Aug 2017 B.Murphy: Pull plume height calc. to separate subroutine.
C     01 Feb 2019 D.Wong: Implemented centralized I/O approach and removed everything 
C                         related to ZSTATIC
C     05 June 2019 F. Sidi: Bugfix related to Parallel I/O Implementation
C     05 Aug  2019 D. Wong: Removed USE BMATVEC_MODULE statement and PTBILIIN
C     19 Sep  2019 D. Wong: Fixed the way to advance to next day on an emission file, DESID_STREAM_DATE
C-----------------------------------------------------------------------

      USE UDTYPES, ONLY: RARRY1

      IMPLICIT NONE


      PUBLIC PT3D_INIT, GET_PT3D_EMIS
      PRIVATE

C Output layer fractions, dimensioned NSRC, DESID_LAYS, and for diagnostic file
      REAL,    ALLOCATABLE, SAVE :: LFRAC( :,: ) ! per source local layer fractn
      REAL,    ALLOCATABLE, SAVE :: TFRAC( :,: ) ! Temporary LFRAC

C debugging zplume
      REAL,    ALLOCATABLE, SAVE :: ZPLUM( :,: ) ! has to be 2D for play file

C Wildfire emissions source parameters
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: ACRES( : )   ! acres burned
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: BFLUX( : )   ! Briggs buoyancy flux

C Vertical coord values
      REAL,    ALLOCATABLE, SAVE :: VGLVSXG( : )

C Play report log
      INTEGER, ALLOCATABLE, SAVE :: RDEV( : )
C Play files source id file
#ifdef srcid
      INTEGER, ALLOCATABLE, SAVE :: LDEV( : )
#endif
C Plume rise info report files
      CHARACTER( 13 ), ALLOCATABLE, SAVE :: REPTNAME( : )
      CHARACTER( 11 )                    :: REPSTR

C Layer fractions matrix output files
      CHARACTER(  16 ), ALLOCATABLE, SAVE :: PLAYNAME( : )
C Layer fractions source id output files
      CHARACTER(  16 ), ALLOCATABLE, SAVE :: PLAY_SRCID_NAME( : )

C Point source 3d emis diagnostic file names
!     CHARACTER( 16 ),               SAVE :: PT3DNAME
C Point source 3d emis diagnostic integral average write buffers
      REAL,    ALLOCATABLE, SAVE :: VDEMIS_BUF( :,:,:,: )
C Diagnostic file avg factor
      REAL                       :: DIVFAC


C Stack parameters
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: STK_DM( : )
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: STK_HT( : )
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: STK_TK( : )
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: STK_VEL( : )

C Private Parameters:
      CHARACTER(  10 ), PARAMETER :: BLANK10 = '          '

C cross-point layered grid file name
      CHARACTER(  16 ),     SAVE :: GC3NAME

C hourly stack emissions file names
      CHARACTER(  16 ), ALLOCATABLE, SAVE :: STKENAME( : )

      CHARACTER( 240 )           :: XMSG = ' '
          
      CONTAINS

C=======================================================================

         FUNCTION PT3D_INIT ( JDATE, JTIME, TSTEP )
     &                       RESULT ( SUCCESS )

         USE GRID_CONF, ONLY: NLAYS, VGTYP_GD
         USE STK_PRMS, ONLY: SOURCE, STK_PRMS_INIT, MY_NSRC
         USE STK_EMIS, ONLY: DESID_STREAM_NAME, NSRC_EMIS, FIREFLAG,
     &                       MAP_PTtoISRM, STK_EMIS_INIT
         USE PTMET, ONLY: PTMET_DATA, MC2NAME, MC3NAME, MD3NAME, PTMET_INIT
         USE PTBILIN, ONLY: NPTGRPS, 
     &                      METCXORIG, METCYORIG, XCELLCG, YCELLCG, 
     &                      METDXORIG, METDYORIG, XCELLDG, YCELLDG

         USE UTILIO_DEFN
         USE RUNTIME_VARS, ONLY: LOGDEV, MYPE, PT3DFRAC, PT_DATE, STDATE, STTIME,
     &                           PT_TIME, PT_NSTEPS, REP_LAYR
         USE DESID_VARS, ONLY: DESID_LAYS, DESID_MAXLAYS
         USE stack_group_data_module
         USE centralized_io_module, only : window

         IMPLICIT NONE

C Includes:
         INCLUDE SUBST_FILES_ID  ! file name parameters (for CTM_PT3D_DIAG)

C Arguments:
         INTEGER          JDATE      ! Julian date (YYYYDDD)
         INTEGER          JTIME      ! time (HHMMSS)
         INTEGER          TSTEP      ! output time step
         LOGICAL          SUCCESS

C Parameters:

C Local Variables:
         CHARACTER( 16 )       :: PNAME = 'PT3D_INIT       ' ! procedure name
         CHARACTER( 16 )       :: VNAME    ! variable name buffer
!        CHARACTER( 16 ), SAVE, ALLOCATABLE :: STKGNAME( : ) ! stack groups file name

         INTEGER          METCCOLS       ! cross point grid number of columns
         INTEGER          METCROWS       ! cross point grid number of rows
         INTEGER          METDCOLS       ! dot point grid number of columns
         INTEGER          METDROWS       ! dot point grid number of rows
         INTEGER          IOS            ! i/o and allocate memory status
         INTEGER          NDATE          ! next timestep file Julian date (YYYYDDD)
         INTEGER          NTIME          ! next timestep file time (HHMMSS)

         INTEGER I, J, K, L, M, N, P, S, SRC, V, ISRM  ! counters and indices

         INTEGER :: GXOFF, GYOFF
         INTEGER :: STRTCOLMC, ENDCOLMC, STRTROWMC, ENDROWMC

         INTERFACE
            SUBROUTINE DELTA_ZS( DESID_LAYS, MY_NSRC, SRC_MAP, STKHT, ZF, ZSTK, DDZF )
               INTEGER, INTENT( IN )  :: DESID_LAYS, MY_NSRC
               INTEGER, INTENT( IN )  :: SRC_MAP( : )
               REAL,    INTENT( IN )  :: STKHT( : )
               REAL,    INTENT( IN )  :: ZF  ( :,: )
               REAL,    INTENT( OUT ) :: ZSTK( :,: )
               REAL,    INTENT( OUT ) :: DDZF( :,: )
            END SUBROUTINE DELTA_ZS
            SUBROUTINE OPENLAYOUT( NDATE, NTIME, TSTEP, EMLAYS, VGLVSXG, NPTGRPS,
     &                             MY_NSRC, PLAYNAME )
               INTEGER,        INTENT( IN )  :: NDATE
               INTEGER,        INTENT( IN )  :: NTIME
               INTEGER,        INTENT( IN )  :: TSTEP
               INTEGER,        INTENT( IN )  :: EMLAYS
               REAL,           INTENT( IN )  :: VGLVSXG( 0: )
               INTEGER,        INTENT( IN )  :: NPTGRPS
               INTEGER,        INTENT( IN )  :: MY_NSRC( : )
               CHARACTER( * ), INTENT( OUT ) :: PLAYNAME( : )
            END SUBROUTINE OPENLAYOUT
         END INTERFACE

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

C In-line 3D point source emissions?
         IF ( NPTGRPS .GT. 0 ) THEN
            XMSG = 'Using in-line 3d point source emissions option'
            CALL M3MSG2( XMSG )
         ELSE
            RETURN
         END IF


C Cannot use default and cannot set to less than 4 because of limits of plume
C rise algorithm
         IF ( DESID_MAXLAYS .GT. 0 .AND. DESID_MAXLAYS .LT. 4 ) THEN
            XMSG = 'Environment variable CTM_DESID_LAYS must be set to ' //
     &             'a number from 4 to the ' // CRLF() // BLANK10 //
     &             'number of layers in the meteorology inputs.'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
C get diagnostic files options
         IF ( REP_LAYR .LT. 1 ) THEN
            XMSG = 'NOTE: Environment variable REP_LAYR_MIN is ' //
     &             'less than 1.  Turning off reporting...'
         ELSE IF ( REP_LAYR .GT. DESID_LAYS ) THEN
            WRITE( XMSG,94010 )
     &             'NOTE: Environment variable REP_LAYR_MIN is '//
     &             'greater than the number of emissions ' //
     &             CRLF() // BLANK10 // 'layers (', DESID_LAYS, '). '//
     &             'Resetting to number of emissions layers.'
            REP_LAYR = DESID_LAYS
         ELSE
            WRITE( XMSG,94010 )
     &             'logging stack data for plume rise .ge. layer', REP_LAYR

         END IF

         CALL M3MSG2( XMSG )
#ifndef mpas
#ifdef srcid
         IF ( PT3DFRAC ) THEN   ! save local source id's
            ALLOCATE ( LDEV( NPTGRPS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'LDEV', PNAME )
            LDEV = 0   ! array
            WRITE( XMSG,94010 ) "Enter logical name for file containing " //
     &                          "source id's of play files"
            ALLOCATE ( PLAY_SRCID_NAME( NPTGRPS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'PLAY_SRCID_NAME', PNAME )
            DO N = 1, NPTGRPS
               WRITE( REPSTR,'( "SRCIDLAY", I2.2, "_" )' ) N
               WRITE( PLAY_SRCID_NAME( N ),'( A, I2.2 )' ) REPSTR, MYPE   ! limited to 99 PE's
               LDEV( N ) = PROMPTFFILE( XMSG, .FALSE., .TRUE.,
     &                                  PLAY_SRCID_NAME( N ), PNAME )
            END DO
         END IF
#endif

         ALLOCATE ( RDEV( NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'RDEV', PNAME )
         RDEV = 0   ! array
         IF ( REP_LAYR .GT. 0 ) THEN
            WRITE( XMSG,94010 ) 'Enter logical name for report of ' //
     &                          'plumes exceeding layer', REP_LAYR
            ALLOCATE ( REPTNAME( NPTGRPS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'REPTNAME', PNAME )
            DO N = 1, NPTGRPS
               WRITE( REPSTR,'( "REPRTLAY", I2.2, "_" )' ) N
               WRITE( REPTNAME( N ),'( A, I2.2 )' ) REPSTR, MYPE   ! limited to 99 PE's
               RDEV( N ) = PROMPTFFILE( XMSG, .FALSE., .TRUE., REPTNAME( N ), PNAME )
            END DO
         END IF

C get scenario timing

         PT_DATE = JDATE 
         PT_TIME = JTIME

C open met files

         MC2NAME = PROMPTMFILE( 'Enter name for CROSS-POINT SURFACE MET file',
     &                          FSREAD3, 'MET_CRO_2D', PNAME )

         MC3NAME = PROMPTMFILE( 'Enter name for CROSS-POINT LAYERED MET file',
     &                          FSREAD3, 'MET_CRO_3D', PNAME )

         MD3NAME = PROMPTMFILE( 'Enter name for DOT-POINT LAYERED MET file',
     &                          FSREAD3, 'MET_DOT_3D', PNAME )

C Get grid parameters from 3-d cross-point met file and store header information.
C Use time parameters for time defaults.
         CALL RETRIEVE_IOAPI_HEADER( MC3NAME, JDATE, JTIME )

         CALL SUBHFILE ( MC3NAME, GXOFF, GYOFF,
     &                   STRTCOLMC, ENDCOLMC, STRTROWMC, ENDROWMC )

C Initialize reference grid with met file
         XCELLCG = XCELL3D
         YCELLCG = YCELL3D
         METCCOLS = NCOLS3D
         METCROWS = NROWS3D
         METCXORIG = XORIG3D
         METCYORIG = YORIG3D

         IF ( ( GXOFF .GT. 0 ) .AND. ( GYOFF .GT. 0 ) ) THEN
            METCXORIG = XORIG3D + REAL( GXOFF,8 ) * XCELL3D
            METCYORIG = YORIG3D + REAL( GYOFF,8 ) * YCELL3D
         ELSE
            METCXORIG = XORIG3D
            METCYORIG = YORIG3D
         END IF

!!!!!!^^^^^^^!!!! THESE NEED TO BE CHECKED AGAINST GRIDDESC

C Get grid parameters from 3-d dot-point met file and store header information.
C (declared and stored in PTBILIN module)
         CALL RETRIEVE_IOAPI_HEADER( MD3NAME, JDATE, JTIME )
         XCELLDG = XCELL3D
         YCELLDG = YCELL3D
         METDXORIG = XORIG3D
         METDYORIG = YORIG3D
         METDCOLS = NCOLS3D
         METDROWS = NROWS3D

         CALL SUBHFILE ( MD3NAME, GXOFF, GYOFF,
     &                   STRTCOLMC, ENDCOLMC, STRTROWMC, ENDROWMC )

         IF ( ( GXOFF .GT. 0 ) .AND. ( GYOFF .GT. 0 ) ) THEN
            METDXORIG = XORIG3D + REAL( GXOFF,8 ) * XCELL3D
            METDYORIG = YORIG3D + REAL( GYOFF,8 ) * YCELL3D
         ELSE
            METDXORIG = XORIG3D
            METDYORIG = YORIG3D
         END IF

C Compare number of meteorology layers to number of emissions layers
!         IF ( DESID_LAYS .LE. NLAYS ) THEN
!            WRITE( XMSG,94010 ) 'NOTE: The number of emission layers ' //
!     &                          'is', DESID_LAYS, ', and the maximum ' // CRLF()
!     &                          // BLANK10 // 'possible layers is', NLAYS
!            CALL M3MSG2( XMSG )
!         ELSE
!            WRITE( XMSG,94010 ) 'Resetting number of emission layers ' //
!     &                          'from', DESID_LAYS, 'to number of ' // CRLF() //
!     &                          BLANK10 // 'layers in the meteorology file,', NLAYS
!            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
!            DESID_LAYS = NLAYS
!         END IF

         ALLOCATE( VGLVSXG( 0:MXLAYS3 ), STAT = IOS )
         CALL CHECKMEM( IOS, 'VGLVSXG', PNAME )

C Store local layer information
         J = LBOUND( VGLVS3D, 1 )   ! F90 array intrinsic
         VGLVSXG( 0 ) = VGLVS3D( J )
         DO L = 1, NLAYS
            J = J + 1
            VGLVSXG( L ) = VGLVS3D( J )
         END DO

         IF ( PT_NSTEPS .GT. MXREC3D ) THEN
            WRITE( XMSG,94010 ) 'Requested output time steps > those on met file '
     &                          // CRLF() // BLANK10 // 'reset to ', MXREC3D
            PT_NSTEPS = MXREC3D
         END IF

C Get stack data
!        ALLOCATE ( STKGNAME( NPTGRPS ), STAT = IOS )   ! stk parms files array
!        CALL CHECKMEM( IOS, 'STKGNAME', PNAME )
!        STKGNAME = ' '   ! array

!        DO N = 1, NPTGRPS
!           WRITE( VNAME,'( "STK_GRPS_",I3.3 )' ) N
!           STKGNAME( N ) = PROMPTMFILE( 'Enter name for stack groups file',
!    &                                   FSREAD3, VNAME, PNAME )
!        END DO

!        IF ( .NOT. STK_PRMS_INIT( STKGNAME ) ) THEN
!           XMSG = 'Could not initialize stack parameters'
!           CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
!           SUCCESS = .FALSE.; RETURN
!        END IF
#endif

#ifdef srcid
         IF ( PT3DFRAC ) THEN
            DO N = 1, NPTGRPS
               WRITE( LDEV( N ),93053 ) N, MY_NSRC( N ), MY_STRT_SRC( N )
               DO S = 1, MY_NSRC( N )
                  WRITE( LDEV( N ),93057 ) S, SOURCE( N )%ARRY( S ) + MY_STRT_SRC( N ) - 1
               END DO
            END DO
         END IF
#endif

C Initialize stack emissions data
         ALLOCATE ( STKENAME( NPTGRPS ), STAT = IOS )   ! stk emis files array
         CALL CHECKMEM( IOS, 'STKENAME', PNAME )
         STKENAME = ' '   ! array

         ! Retrive Point Source Filenames from Emissions Filename Vector
         DO N = 1, NPTGRPS
            ISRM = MAP_PTtoISRM( N )
            STKENAME( N ) = DESID_STREAM_NAME( ISRM )
         END DO

         ! Initialize Point Source Emissions
         IF ( .NOT. STK_EMIS_INIT( STKENAME, JDATE, JTIME ) ) THEN
            XMSG = 'Could not initialize stack parameters'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

         ! Check that the number of individual sources on each point
         ! emissions file is consistent.
         DO N = 1, NPTGRPS
            IF ( NSRC( N ) .NE. NSRC_EMIS( N ) ) THEN
               WRITE( LOGDEV,* ) 'NSRC vs. NSRC_EMIS:', N, NSRC( N ), NSRC_EMIS( N )
               XMSG = 'No. of sources for stack files don''t match'
               CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
         END DO

C Open diagnostic layer fractions file?
         IF ( PT3DFRAC ) THEN
            ALLOCATE ( PLAYNAME( NPTGRPS ), STAT = IOS )   ! stk parms files array
            CALL CHECKMEM( IOS, 'PLAYNAME', PNAME )
            PLAYNAME = ' '   ! array
            NDATE = PT_DATE; NTIME = PT_TIME
            CALL NEXTIME( NDATE, NTIME, TSTEP ) ! advance one output tstep
            CALL OPENLAYOUT( NDATE, NTIME, TSTEP, DESID_LAYS, VGLVSXG, NPTGRPS,
     &                       MY_NSRC, PLAYNAME )
         END IF

         IF ( .NOT. PTMET_INIT ( ) ) THEN
            XMSG = 'Could not initialize stack met data'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

         ALLOCATE( STK_DM( NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'STK_DM', PNAME )

         ALLOCATE( STK_HT( NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'STK_HT', PNAME )

         ALLOCATE( STK_TK( NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'STK_TK', PNAME )

         ALLOCATE( STK_VEL( NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'STK_VEL', PNAME )

         ALLOCATE( ACRES (NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'ACRES', PNAME )

         ALLOCATE( BFLUX (NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'BFLUX', PNAME )

         DO N = 1, NPTGRPS

C Allocate and set stack parameters

            IF ( MY_NSRC( N ) .GT. 0 ) THEN
               ALLOCATE( STK_DM( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
               CALL CHECKMEM( IOS, 'STK_DM', PNAME )
               STK_DM( N )%ARRY = 0.0   ! 1D array
               STK_DM( N )%LEN = MY_NSRC( N )

               ALLOCATE( STK_HT( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
               CALL CHECKMEM( IOS, 'STK_HT', PNAME )
               STK_HT( N )%ARRY = 0.0   ! 1D array
               STK_HT( N )%LEN = MY_NSRC( N )

               ALLOCATE( STK_TK( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
               CALL CHECKMEM( IOS, 'STK_TK', PNAME )
               STK_TK( N )%ARRY = 0.0   ! 1D array
               STK_TK( N )%LEN = MY_NSRC( N )

               ALLOCATE( STK_VEL( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
               CALL CHECKMEM( IOS, 'STK_VEL', PNAME )
               STK_VEL( N )%ARRY = 0.0   ! 1D array
               STK_VEL( N )%LEN = MY_NSRC( N )
 
               DO S = 1, MY_NSRC( N )
#ifdef mpas
                  SRC = S
#else
                  SRC = SOURCE( N )%ARRY( S )
#endif
                  STK_DM( N )%ARRY( S )  = STKDIAM( N )%ARRY( SRC )
                  STK_HT( N )%ARRY( S )  = STKHT( N )%ARRY( SRC )
                  STK_TK( N )%ARRY( S )  = STKTK( N )%ARRY( SRC )
                  STK_VEL( N )%ARRY( S ) = STKVEL( N )%ARRY( SRC )
               END DO

C If wildfires, allocate fire parameters
               IF ( FIREFLAG( N ) ) THEN

                  ALLOCATE( ACRES( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
                  CALL CHECKMEM( IOS, 'ACRES', PNAME )
                  ACRES( N )%ARRY  = 0.0   ! 1D array
                  ACRES( N )%LEN = MY_NSRC( N )

                  DO S = 1, MY_NSRC( N )
#ifdef mpas
                     SRC = S
#else
                     SRC = SOURCE( N )%ARRY( S )
#endif
                     ACRES( N )%ARRY( S ) = ACRES_BURNED( N )%ARRY( SRC )
                  END DO

                  ALLOCATE( BFLUX( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
                  CALL CHECKMEM( IOS, 'BFLUX', PNAME )
                  BFLUX( N )%ARRY = 0.0   ! 1D array
                  BFLUX( N )%LEN = MY_NSRC( N )

               END IF
            END IF   ! MY_NSRC > 0

         END DO

         SUCCESS = .TRUE.; RETURN

93053    FORMAT("#  Src Id's for play file", I2, ', with', I10, ' total sources',
     &          ", and my_strt_src:", I10 )
93057    FORMAT( I6, I8 )
94010    FORMAT( 12( A, :, I8, :, 1X ) )

         END FUNCTION PT3D_INIT

C=======================================================================

         SUBROUTINE GET_PT3D_EMIS ( JDATE, JTIME, TSTEP, EMVAR_PT, ISRM,
     &                            VDEMIS_PT, PTLAYS, L_DESID_DIAG )

! Revision History.
!     Aug 12, 15 D. Wong: added code to handle parallel I/O implementation
!     Jun 05, 19 F. Sidi: Bugfix related to Parallel I/O Implementation

!-----------------------------------------------------------------------

! Time step part of laypoint

         USE GRID_CONF, ONLY:  NCOLS, NROWS, IO_PE_INCLUSIVE
         USE STK_PRMS, ONLY :  MY_NSRC, MY_STRT_SRC, MY_END_SRC, 
     &                         MY_STKCOL, MY_STKROW, SOURCE,
#ifdef mpas
     &                         MY_STKBUFF, MY_COLBUFF, MY_ROWBUFF, my_nsrc_mesh_index
#else
     &                         MY_STKBUFF, MY_COLBUFF, MY_ROWBUFF
#endif
         USE STK_EMIS, ONLY :  IPSRM, DESID_N_ISTR, DESID_EMVAR, DESID_STREAM_DATE, 
     &                         STKBUFF, NSRC_EMIS
         USE PRECURSOR_DATA, ONLY : PRECURSOR_MW, SULF_IDX
         USE RUNTIME_VARS, ONLY : LOGDEV, PT3DDIAG, PT3DFRAC, STDATE, STTIME
         USE CENTRALIZED_IO_MODULE
         USE UTILIO_DEFN
#ifdef mpas
         use util_module, only : nextime
         USE PTMET, ONLY    :  DESID_LAYS, PTMET_CONVT_MPAS
#else
         USE PTMET, ONLY    :  DESID_LAYS, PTMET_CONVT
#endif

         IMPLICIT NONE

! Includes:
         INCLUDE SUBST_FILES_ID  ! file name parameters (for CTM_PT3D_DIAG)

! Arguments:
         CHARACTER(16), INTENT( IN ) :: EMVAR_PT( : )
         INTEGER               :: JDATE, JTIME
         INTEGER, INTENT( IN ) :: TSTEP( 3 )
         INTEGER, INTENT( IN ) :: ISRM
         INTEGER, INTENT( OUT) :: PTLAYS
         REAL, INTENT(INOUT)  :: VDEMIS_PT( :,:,:,: ) 

! Parameters:

         LOGICAL,         EXTERNAL :: WRITE3_DISTR   ! calls WRITE3 directly

! Local variables:
         INTEGER          CDATE      ! previous step start date
         INTEGER          CTIME      ! previous step start time
         INTEGER, SAVE :: LDATE = 0  ! previous date
         INTEGER          LTOP       ! layer containing plume top
         INTEGER          SRC        ! source pointer in this proc sub-domain
         INTEGER          MY_DELTA   ! total number of sources on this processor
         REAL             LFRC       ! intermediate LFRAC
         REAL             TSUM       ! tmp layer frac sum for renormalizing
         REAL, ALLOCATABLE, SAVE :: MY_STKEMIS( :,:,: )

         CHARACTER(  8 ) :: CINT     ! integer to character buffer for warning messages
         CHARACTER( 16 ) :: PNAME = 'GET_PT3D_EMIS   '   ! procedure name
         CHARACTER( 16 ) :: VNAME    ! variable name buffer

         INTEGER          IOS        ! i/o and allocate memory status
         INTEGER          L, S, V    ! counters
         INTEGER          C, R, I, J, K, N, ISPC

         INTEGER, SAVE :: WSTEP = 0
         INTEGER          WDATE, WTIME
         LOGICAL, SAVE :: WRTIME
         INTEGER, SAVE :: NTICS = 0      ! no. of substeps within an output tstep
         LOGICAL, SAVE :: FIRSTIME = .TRUE.
         LOGICAL       :: L_DESID_DIAG ! flag determining whether or not DESID
                                       !   is in diagnostic mode              
         LOGICAL       :: L_NEWDAY

         INTEGER       :: NDATE, NTIME
         INTEGER, ALLOCATABLE, SAVE :: PRE_DESID_STREAM_DATE(:)
         
#ifdef Verbose1
         real mxzplm
#endif

C-----------------------------------------------------------------------

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            
            ALLOCATE ( MY_STKEMIS( DESID_LAYS,NCOLS,NROWS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'MY_STKEMIS', PNAME )
              
            ! Set up and open 3d point source emissions diagnostic file?
            IF ( PT3DDIAG ) THEN
              NDATE = STDATE; NTIME = STTIME
              CALL NEXTIME( NDATE, NTIME, TSTEP(1) ) ! advance one output tstep
              CALL OPPT3D_DIAG( CTM_PT3D_DIAG, TSTEP(1), 
     &                   DESID_EMVAR( ISRM )%LEN, DESID_EMVAR( ISRM )%ARRY( : ),
     &                   DESID_EMVAR( ISRM )%UNITS( : ) )
 

              ALLOCATE ( VDEMIS_BUF( DESID_N_ISTR,DESID_LAYS,NCOLS,NROWS ), STAT = IOS )
              CALL CHECKMEM( IOS, 'VDEMIS_BUF', PNAME )
              VDEMIS_BUF = 0.0   ! array
              
              WRITE( LOGDEV,'(/5X, A /5X, A )' )
     &                        'Recording 3d point source emissions diagnostics',
     &                        'as a linear average over the output timestep'
#ifdef parallel_io
               IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                  IF ( .NOT. OPEN3( CTM_PT3D_DIAG, FSREAD3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM(CTM_PT3D_DIAG)
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
                  END IF
               END IF
#endif
            END IF
            ALLOCATE (PRE_DESID_STREAM_DATE(SIZE(DESID_STREAM_DATE)), STAT=IOS)
            PRE_DESID_STREAM_DATE = STDATE
         END IF

C Based on the current time step, find whether or not a report should be written

!         WRITE( XMSG,'(A, I7.6)' )
!     &   'Calculating emissions point source layer fractions for', JTIME
!         WRITE( LOGDEV,* ) ' '
!         CALL M3MSG2( XMSG )
!
!         IF ( LDATE .NE. JDATE ) THEN  ! write day and date to stdout & XMSG
!            CALL WRDAYMSG( JDATE, XMSG )
!            LDATE = JDATE
!            WRITE( LOGDEV,'(9X, "at time ", A)' ) HHMMSS( JTIME )
!         END IF
!         WRTIME = .FALSE.
!         WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )
!         IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
!            WDATE = JDATE; WTIME = JTIME
!            CALL NEXTIME( WDATE, WTIME, TSTEP( 2 ) )
!            IF ( .NOT. CURRSTEP( WDATE, WTIME, SDATE, STIME, TSTEP( 1 ),
!     &                           CDATE, CTIME ) ) THEN
!               XMSG = 'Cannot get step date and time'
!               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
!            END IF
!            WDATE = CDATE; WTIME = CTIME
!            WSTEP = 0
!            WRTIME = .TRUE.
!            DO N = 1, NPTGRPS
!               IF ( RDEV( N ) .GT. 0 ) THEN    ! write day, date and time to report file
!                  WRITE( CINT,'( I8 )' ) REP_LAYR
!                  CALL WRDAYMSG( WDATE, XMSG )
!                  XMSG = XMSG( 1:LEN_TRIM( XMSG ) )
!     &                    // ' at time ' // HHMMSS( WTIME )
!     &                    // 'for ltop .ge. ' // TRIM( ADJUSTL( CINT ) )
!                  WRITE( RDEV( N ),93000 ) XMSG( 1:LEN_TRIM( XMSG ) )
!               END IF
!            END DO
!         END IF

C Initialize Output Array
         !VDEMIS_PT = 0.0   ! array assignment

         N = IPSRM( ISRM )

C Convert pt source met data to bi-linear interpolated data
#ifdef mpas
         CALL PTMET_CONVT_MPAS ( N )
#else
         CALL PTMET_CONVT( JDATE, JTIME, N )
#endif

         PTLAYS = 1       ! Initialize Point Layers at lowest possible value

         IF ( MY_NSRC( N ) .LE. 0 ) RETURN

         IF ( PT3DFRAC ) THEN   ! Store layer fractions
            ALLOCATE( LFRAC( MY_NSRC( N ),DESID_LAYS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'LFRAC', PNAME )
            ALLOCATE( ZPLUM( MY_NSRC( N ),DESID_LAYS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'ZPLUM', PNAME )
            LFRAC = 0.0   ! 2-D array - Initialize layer fraction
            ZPLUM = 0.0   ! 2-D array - Initialize plume centroid height
         END IF

C Ensure that the model and stack groups emissions timestamp dates stay synchronized
         L_NEWDAY = .FALSE.
         IF ( PRE_DESID_STREAM_DATE(ISRM) .NE. JDATE ) THEN 
            L_NEWDAY = .TRUE.
            NDATE = JDATE; NTIME = JTIME
            CALL NEXTIME( NDATE, NTIME, -TSTEP( 1 ) )       ! go back one output tstep
            CALL NEXTIME( DESID_STREAM_DATE( ISRM ), NTIME, TSTEP( 1 ) ) ! advance the start date one time step
            PRE_DESID_STREAM_DATE(ISRM) = JDATE
         END IF

C Allocate Array to Store the Layer Heights of All Stacks (i.e. sources)
C from this Point Group (i.e. ptgrp)
         IF (MY_NSRC( N ) .GT. 0) THEN
            ALLOCATE( TFRAC( DESID_LAYS,MY_NSRC( N ) ), STAT = IOS )
            CALL CHECKMEM( IOS, 'TFRAC', PNAME )
            TFRAC = 0.0   ! array

C Calculate Plume Heights for All Point Sources on this File
            CALL CALC_PLUME_HEIGHT( DESID_STREAM_DATE( ISRM ), JDATE, JTIME, WRTIME, N   )

            ! Floor TFRAC to zero in case there are negatives and 
            ! renormalize positive values so the sum is 1.0
            If ( MINVAL( TFRAC ) .LT. 0.0 ) THEN

                WHERE ( TFRAC( :,: ) .LT. 0.0 ) TFRAC( :,: ) = 0.0

                DO S = 1,MY_NSRC( N )
                   TFRAC( :,S ) = TFRAC( :,S ) / SUM( TFRAC(:,S) )
                END DO
            END IF

            ! Calculate Maximum Layer Height across all source Plumes
            DO L = DESID_LAYS,1,-1
                PTLAYS = L
                IF ( COUNT( TFRAC(L,:) .EQ. 0.0 ) .LT. MY_NSRC( N ) ) EXIT
            END DO
         END IF

C Read Emissions for all sources on File N            
         DO ISPC = 1, DESID_N_ISTR
            VNAME = EMVAR_PT( ISPC )
            IF ( VNAME .EQ. '' ) CYCLE

            call interpolate_var (STKENAME(N), VNAME, DESID_STREAM_DATE( ISRM ), JTIME, STKBUFF(1:NSRC_EMIS(N)) )

            MY_STKEMIS( 1:PTLAYS,:,: ) = 0.0

            DO S = 1,MY_NSRC( N )
#ifdef mpas
                C = my_nsrc_mesh_index( S, N )
                R = 1
                MY_STKBUFF( S ) = STKBUFF( S )
#else
                SRC = SOURCE( N )%ARRY( S )
                MY_STKBUFF( S ) = STKBUFF( SRC )
                MY_COLBUFF( S ) = MY_STKCOL( N )%ARRY( S )
                MY_ROWBUFF( S ) = MY_STKROW( N )%ARRY( S )

                C = MY_COLBUFF( S )
                R = MY_ROWBUFF( S )
#endif

                MY_STKEMIS( 1:PTLAYS,C,R ) = MY_STKEMIS( 1:PTLAYS,C,R )
     &                     +  MY_STKBUFF( S ) * TFRAC( 1:PTLAYS,S )
            END DO

            ! Save Emissions in Common Array
            VDEMIS_PT( ISPC,1:PTLAYS,:,: ) = MY_STKEMIS( 1:PTLAYS,:,: )

         END DO ! End Loop on Species

         IF (MY_NSRC( N ) .GT. 0) DEALLOCATE( TFRAC )
         
         ! Reset the date of the gridded file if this is diagnostic mode
         ! and the day has advanced
         IF ( L_NEWDAY .AND. L_DESID_DIAG ) THEN
            CALL NEXTIME( DESID_STREAM_DATE( ISRM ), NTIME, -TSTEP(1) )
            PRE_DESID_STREAM_DATE( ISRM ) = DESID_STREAM_DATE( ISRM )
         END IF
 
C Write Out Diagnostic Info            
         IF ( PT3DFRAC .AND. WRTIME ) THEN     ! Write out layer fractions
            IF ( .NOT. WRITE3_DISTR( PLAYNAME( N ), 'LFRAC', WDATE, WTIME,
     &                               MY_NSRC( N ), DESID_LAYS, LFRAC ) ) THEN
               XMSG = 'Error writing "LFRAC" to file "' //
     &                 PLAYNAME( N )( 1:LEN_TRIM( PLAYNAME( N ) ) ) // '."'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( .NOT. WRITE3_DISTR( PLAYNAME( N ), 'ZPLUME', WDATE, WTIME,
     &                               MY_NSRC( N ), DESID_LAYS, ZPLUM ) ) THEN
               XMSG = 'Error writing "ZPLUM" to file "' //
     &                 PLAYNAME( N )( 1:LEN_TRIM( PLAYNAME( N ) ) ) // '."'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            WRITE( LOGDEV,94030 )
     &         'Timestep written to', TRIM( PLAYNAME( N ) ),
     &         'for date and time', WDATE, WTIME
         END IF

         IF ( PT3DFRAC ) THEN
            DEALLOCATE( LFRAC )
            DEALLOCATE( ZPLUM )
         END IF


C Write Out Diagnostic Info         
         IF ( PT3DDIAG ) THEN  ! store 3d point source emissions
            NTICS = NTICS + 1
            VDEMIS_BUF = VDEMIS_BUF + VDEMIS_PT   ! array assignmnt
            IF ( WRTIME ) THEN
               DIVFAC = 1.0 / FLOAT( NTICS )
               WRITE( LOGDEV,94030 )
     &               'Timestep written to', CTM_PT3D_DIAG,
     &               'for date and time', WDATE, WTIME
            VDEMIS_BUF = 0.0   ! array
            NTICS = 0
            END IF
         END IF

         RETURN

C------------------  FORMAT  STATEMENTS   ------------------------------

93000    FORMAT( A / 1X, 'source', 3X, 'ht', 3X, 'lpbl', 1X, 'lbot', 1X, 'ltop',
     &               3X, 'vel', 4X, 'windspeed', 2X, 'StkTemp', 3X, 'AmbTemp' )

93040    FORMAT( 'Sources with top of plume greater than layer', I3, //,
     &           'Src ID, ', A, ', H[m], ', 'V[m/s], ', 'Ts[K], ',
     &           'Ta[K], ', 'U[m/s], ', 'LPBL, ', 'LTOP' )

93042    FORMAT( '( I6, ",", I6.6, ",", A', I2.2, ', ","', I2.2, '(A',
     &           I2.2, ',", ") , F6.1, ", ", F6.2, ", ", F6.1, ", ",',
     &           'F5.1, ", ", F6.2, ", ", I3, ", ", I3 )' )

93044    FORMAT( I6, ",", I6.6, F6.1, ", ", F6.2, ", ", F6.1, ", ",
     &           F5.1, ", ", F6.2, ", ", I3, ", ", I3 )


94030    FORMAT( /5X, 3( A, :, 1X ), I8, ":", I6.6 )

         END SUBROUTINE GET_PT3D_EMIS

C-------------- Subprograms used by GET_PT3D_EMIS ----------------------

C=======================================================================

      SUBROUTINE CALC_PLUME_HEIGHT( LOC_STKDATE, JDATE, JTIME, WRTIME, N )

! Revision History.
!     Aug 18, 17 B.Murphy: Separated plume height calculation from the
!                          point source allocation algorithm

C-----------------------------------------------------------------------

      USE VGRD_DEFN, ONLY : VGTOP_GD
      USE STK_EMIS, ONLY : FIREVAR, FIREFLAG
#ifdef mpas
      USE STK_PRMS, ONLY : MY_STRT_SRC, MY_END_SRC, MY_NSRC, SOURCE, my_nsrc_pressure, my_nsrc_mesh_index
#else
      USE STK_PRMS, ONLY : MY_STRT_SRC, MY_END_SRC, MY_NSRC, SOURCE
#endif
      USE PTMET, ONLY : DESID_LAYS, P_D => PTMET_DATA
      USE RUNTIME_VARS, ONLY : LOGDEV, IPVERT, PT3DFRAC, REP_LAYR, LOG_MESSAGE
      USE UTILIO_DEFN
      USE CENTRALIZED_IO_MODULE, only : interpolate_var
      USE CONST, only: CPD
#ifdef mpas
      USE coupler_module
      USE util_module, only : crlf
#endif

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: LOC_STKDATE
      INTEGER, INTENT( IN ) :: JDATE, JTIME
         
      LOGICAL, INTENT( IN ) :: WRTIME
      INTEGER, INTENT( IN ) :: N       ! Point Source File Number

#ifdef mpas
      INTEGER, PARAMETER :: DEG = 3
#endif

      CHARACTER( 16 ) :: PNAME = 'CALC_PLUME_HEIGHT'   ! procedure name
      CHARACTER( 16 ) :: VNAME 
      CHARACTER(  8 ) :: CINT     ! integer to character buffer for warning messages

      REAL,            PARAMETER :: USTARMIN = 0.1   ! Min valid value for USTAR
      REAL,            PARAMETER :: CONVPA = 1.0E-2  ! convert Pa to mb
      REAL,            PARAMETER :: BTU2M4PS3 = 9.2752E-03 ! convert BTU/s to m**4/s**3
      REAL,            PARAMETER :: BFACPHR = BTU2M4PS3 / 3600.0 ! m**4/s**3 per hour
                                 ! assumes heat flux from fire pt src file is in BTU/hr
      REAL             PSFC      ! surface pressure [Pa]
      REAL             USTMP      ! temp storage for ustar [m/s]
      REAL             HFLX       ! converted heat flux
      REAL             ZBOT       ! plume bottom elevation [m]
      REAL             ZTOP       ! plume top    elevation [m]
      REAL             ZPLM       ! plume centerline height above stack [m]
      REAL             ZDIFF      ! ZTOP - ZBOT
      REAL             DDZ        ! 1 / ZDIFF
      REAL             TSTK       ! temperature at top of stack [K]
      REAL             WSTK       ! wind speed  at top of stack [m/s]
      REAL             MV         ! mininum LFRAC 
      REAL             BESIZE     ! effective size of the fire buoyant core
      REAL             SFRACT     ! smoldering fraction size (1-BESIZE)
 
      INTEGER          LBOT       ! layer containing plume bottom
      INTEGER          LPBL       ! first L: ZF(L) above mixing layer - ONLY for REPORT
      INTEGER          LSTK       ! first L: ZF(L) > STKHT

      INTEGER :: S, L, SRC, M, STAT
      INTEGER :: LTOP, LACRESBURNED
      REAL    :: DELZ, DELFH
      REAL, ALLOCATABLE, SAVE :: TV( : )   ! Virtual temperature
      REAL, ALLOCATABLE, SAVE :: TF( : )   ! Full-layer height temperatures
      real, allocatable :: tdata(:)
      LOGICAL :: DETERMINED
      REAL    :: THV1
      REAL    :: THVK

      INTERFACE
           SUBROUTINE PREPLM( FIREFLG, DESID_LAYS, HMIX, HTS, PSFC, TS, DDZF, QV,
     &                        TA, UW, VW, ZH, ZF, PRES, LSTK, LPBL, TSTK,
     &                        WSTK, DTHDZ, WSPD )
             LOGICAL, INTENT( IN )  :: FIREFLG
             INTEGER, INTENT( IN )  :: DESID_LAYS
             REAL,    INTENT( IN )  :: HMIX
             REAL,    INTENT( IN )  :: HTS
             REAL,    INTENT( IN )  :: PSFC
             REAL,    INTENT( IN )  :: TS
             REAL,    INTENT( IN )  :: DDZF( : )
             REAL,    INTENT( IN )  :: QV  ( : )
             REAL,    INTENT( IN )  :: TA  ( : )
             REAL,    INTENT( IN )  :: UW  ( : )
             REAL,    INTENT( IN )  :: VW  ( : )
             REAL,    INTENT( IN )  :: ZH  ( : )
             REAL,    INTENT( IN )  :: ZF  ( : )
             REAL,    INTENT( IN )  :: PRES( 0: )
             INTEGER, INTENT( OUT ) :: LSTK
             INTEGER, INTENT( OUT ) :: LPBL
             REAL,    INTENT( OUT ) :: TSTK
             REAL,    INTENT( OUT ) :: WSTK
             REAL,    INTENT( OUT ) :: DTHDZ( : )
             REAL,    INTENT( OUT ) :: WSPD ( : )
           END SUBROUTINE PREPLM

           SUBROUTINE PLMRIS( DESID_LAYS, LSTK, HFX, HMIX,
     &                        STKDM, STKHT, STKTK, STKVE,
     &                        TSTK, USTAR, DTHDZ, TA, WSPD,
     &                        ZF, ZH, ZSTK, WSTK, ZPLM )
             INTEGER, INTENT( IN )  :: DESID_LAYS
             INTEGER, INTENT( IN )  :: LSTK
             REAL,    INTENT( IN )  :: HFX
             REAL,    INTENT( IN )  :: HMIX
             REAL,    INTENT( IN )  :: STKDM
             REAL,    INTENT( IN )  :: STKHT
             REAL,    INTENT( IN )  :: STKTK
             REAL,    INTENT( IN )  :: STKVE
             REAL,    INTENT( IN )  :: TSTK
             REAL,    INTENT( IN )  :: USTAR
             REAL,    INTENT( IN )  :: DTHDZ( : )
             REAL,    INTENT( IN )  :: TA   ( : )
             REAL,    INTENT( IN )  :: WSPD ( : )
             REAL,    INTENT( IN )  :: ZF ( 0:  )
             REAL,    INTENT( IN )  :: ZH   ( : )
             REAL,    INTENT( IN )  :: ZSTK ( : )
             REAL,    INTENT( INOUT ) :: WSTK
             REAL,    INTENT( OUT ) :: ZPLM 
           END SUBROUTINE PLMRIS

           SUBROUTINE FIRE_PLMRIS( DESID_LAYS, LSTK, HFX, HMIX,
     &                             BFLX, TSTK, USTAR, DTHDZ,
     &                             TA, WSPD, ZF, WSTK, ZPLM )
             INTEGER, INTENT( IN )  :: DESID_LAYS
             INTEGER, INTENT( IN )  :: LSTK
             REAL,    INTENT( IN )  :: HFX
             REAL,    INTENT( IN )  :: HMIX
             REAL,    INTENT( IN )  :: BFLX
             REAL,    INTENT( IN )  :: TSTK
             REAL,    INTENT( IN )  :: USTAR
             REAL,    INTENT( IN )  :: DTHDZ( : )
             REAL,    INTENT( IN )  :: TA   ( : )
             REAL,    INTENT( IN )  :: WSPD ( : )
             REAL,    INTENT( IN )  :: ZF ( 0:  )
             REAL,    INTENT( INOUT):: WSTK
             REAL,    INTENT( OUT ) :: ZPLM
           END SUBROUTINE FIRE_PLMRIS

           SUBROUTINE PLSPRD( DTHDZ, ZF, KZ, CEFSTK, PLTOP, PLBOT )
             REAL,    INTENT ( IN ) :: DTHDZ( : )
             REAL,    INTENT ( IN ) :: ZF( 0:  )
             INTEGER, INTENT ( IN ) :: KZ
             REAL,    INTENT ( IN ) :: CEFSTK
             REAL,    INTENT( OUT ) :: PLTOP
             REAL,    INTENT( OUT ) :: PLBOT
           END SUBROUTINE PLSPRD
       END INTERFACE
      
#ifdef mpas
       IF (.NOT. ALLOCATED(TV)) THEN
          ALLOCATE (TV(DESID_LAYS),
     &              TF(DESID_LAYS),
     &              STAT=STAT)
       END IF
#endif

      ! If The Point File is for Fires, read and save the H-Flux Data in a
      ! Dedicated Variable, BFLUX
      LACRESBURNED = 0
      IF ( FIREFLAG( N ) ) THEN
#ifdef mpas
         allocate (tdata(MY_NSRC( N )), stat=stat)
         call interpolate_var (STKENAME(N), 'HFLUX', LOC_STKDATE, JTIME, tdata)

         DO S = 1, MY_NSRC( N )
            FIREVAR(N)%ARRY(S) = tdata(s)
         END DO
         deallocate (tdata)
#else
         call interpolate_var (STKENAME(N), 'HFLUX', LOC_STKDATE, JTIME, FIREVAR(N)%ARRY)
#endif

         DO S = 1, MY_NSRC( N )
#ifdef mpas
            SRC = S
#else
            SRC = SOURCE( N )%ARRY( S )
#endif
            BFLUX( N )%ARRY( S ) = FIREVAR( N )%ARRY( SRC ) * BTU2M4PS3
         END DO

         !Initialize negative ACRES-BURNED counter
      END IF
 
C Loop through sources and compute plume rise
      DO S = 1, MY_NSRC( N )

         IF ( FIREFLAG( N ) ) THEN
            IF ( BFLUX( N )%ARRY( S ) .LE. 0.0 ) THEN
               TFRAC( 1,S ) = 1.0
               TFRAC( 2:DESID_LAYS,S ) = 0.0
               LTOP = 1
               GO TO 201
            END IF
         END IF

         P_D( N )%ZZF( 0 ) = 0.0
         P_D( N )%ZZF( 1:DESID_LAYS ) = P_D( N )%ZF( 1:DESID_LAYS,S )  ! array of layers

C Get pressures: Use SIGMA values and surface pres. p=sigma*(psfc-ptop)+ptop
#ifdef mpas
         PSFC = my_nsrc_pressure(1,s,n)

         P_D( N )%PRESF( 0 ) = 0.0
         P_D( N )%PRESF( 1:DESID_LAYS ) = my_nsrc_pressure(1:DESID_LAYS,s,n)

         IF ( FIREFLAG( N ) ) THEN
            LSTK = 1
         ELSE
            P_D( N )%ZSTK( :,S ) = P_D( N )%ZF( :,S ) - STK_HT( N )%ARRY(S)
            L = 1
            DETERMINED = .FALSE.
            DO WHILE ((.NOT. DETERMINED) .AND. (L .LE. DESID_LAYS))
               IF ( P_D( N )%ZF( L,S ) .GT. STK_HT( N )%ARRY( S )) THEN
                  LSTK = L
                  DETERMINED = .TRUE.
               ELSE
                  L = L + 1
               END IF
            END DO
         END IF

         P_D( N )%WSPD = g3ddata(my_nsrc_mesh_index(s, n),1,:,wspd_ind)

         P_D( N )%DDZF( 1,S ) = 1.0 / P_D( N )%ZF( 1,S )
         DO L = 2, DESID_LAYS
            P_D( N )%DDZF( L,S ) = 1.0 / ( P_D( N )%ZF( L,S ) - P_D( N )%ZF( L-1,S ) )
         END DO

         IF ( FIREFLAG( N ) ) THEN
            TSTK = g2ddata(my_nsrc_mesh_index(s, n),1,temp2_ind)
            WSTK = P_D( N )%WSPD (1)
         ELSE
            m = MAX( 1, LSTK - DEG - 1 )
            TSTK = g3ddata(my_nsrc_mesh_index(s, n),1,m,temp_ind)
            WSTK = P_D( N )%WSPD (m)
         END IF

         DO L = 1, DESID_LAYS
            TV( L ) = P_D( N )%TA( L,S ) * ( 1.0 + 0.622 *
     &                (   g3ddata(my_nsrc_mesh_index(s, n),1,L,qv_ind)
     &                  / ( 1.0 + g3ddata(my_nsrc_mesh_index(s, n),1,L,qv_ind) ) ) )
         END DO

         DO L = 1, DESID_LAYS - 1
            DELZ  = g3ddata(my_nsrc_mesh_index(s, n),1,L+1,zh_ind) - g3ddata(my_nsrc_mesh_index(s, n),1,L,zh_ind)
            DELFH = g3ddata(my_nsrc_mesh_index(s, n),1,L,zf_ind) - g3ddata(my_nsrc_mesh_index(s, n),1,L,zh_ind)
            TF( L ) = TV( L ) + ( TV( L+1 ) - TV( L ) ) * DELFH / DELZ
         END DO
         L = DESID_LAYS
         DELZ  = g3ddata(my_nsrc_mesh_index(s, n),1,L,zh_ind) - g3ddata(my_nsrc_mesh_index(s, n),1,L-1,zh_ind)
         DELFH = g3ddata(my_nsrc_mesh_index(s, n),1,L,zf_ind) - g3ddata(my_nsrc_mesh_index(s, n),1,L,zh_ind)
         TF( L ) = TV( L ) + ( TV( L ) - TV( L-1 ) ) * DELFH / DELZ

         THV1  = TF( 1 ) * ( 1000.0 / P_D( N )%PRESF( 1 ) ) ** 0.286
         DO L = 2, DESID_LAYS
            THVK = TF( L ) * ( 1000.0 / P_D( N )%PRESF( L ) ) ** 0.286
            P_D( N )%DTHDZ( L ) = P_D( N )%DDZF( L,S ) * ( THVK - THV1 )
            THV1 = THVK
         END DO
         P_D( N )%DTHDZ( 1 ) = P_D( N )%DTHDZ( 2 )

#else

         PSFC = P_D( N )%PRSFC( S )
         DO L = 0, DESID_LAYS
            P_D( N )%PRESF( L ) = ( VGLVSXG( L ) * ( PSFC - VGTOP_GD )
     &                          +   VGTOP_GD ) * CONVPA
         END DO

C Set surface pressure (convert to mb from Pa)
         PSFC = CONVPA * PSFC

C Compute derived met vars needed before layer assignments
         CALL PREPLM( FIREFLAG( N ), DESID_LAYS,
     &                P_D( N )%HMIX( S ), STK_HT( N )%ARRY( S ), PSFC,
     &                P_D( N )%TSFC( S ),    P_D( N )%DDZF( :,S ),
     &                P_D( N )%QV( :,S ),    P_D( N )%TA( :,S ),
     &                P_D( N )%UWIND( :,S ), P_D( N )%VWIND( :,S ),
     &                P_D( N )%ZH( :,S ),    P_D( N )%ZF( :,S ),
     &                P_D( N )%PRESF, LSTK,  LPBL, TSTK, WSTK,
     &                P_D( N )%DTHDZ,        P_D( N )%WSPD )
#endif

C Trap USTAR at a minimum realistic value
         USTMP = MAX( P_D( N )%USTAR( S ), USTARMIN )

C Convert heat flux (watts/m2 to m K /s )
         HFLX = P_D( N )%HFX( S ) / ( CPD * P_D( N )%DENS( 1,S ) )

         IF ( .NOT. FIREFLAG( N ) ) THEN
            CALL PLMRIS( DESID_LAYS, LSTK, HFLX, P_D( N )%HMIX( S ),
     &                   STK_DM( N )%ARRY( S ), STK_HT( N )%ARRY( S ),
     &                   STK_TK( N )%ARRY( S ), STK_VEL( N )%ARRY( S ),
     &                   TSTK, USTMP,
     &                   P_D( N )%DTHDZ,     P_D( N )%TA( :,S ),
     &                   P_D( N )%WSPD,      P_D( N )%ZZF,
     &                   P_D( N )%ZH( :,S ), P_D( N )%ZSTK( :,S ),
     &                   WSTK, ZPLM )
         ELSE
            CALL FIRE_PLMRIS( DESID_LAYS, LSTK, HFLX, P_D( N )%HMIX( S ),
     &                   BFLUX( N )%ARRY( S ),
     &                   TSTK, USTMP,
     &                   P_D( N )%DTHDZ,     P_D( N )%TA( :,S ),
     &                   P_D( N )%WSPD,      P_D( N )%ZZF,
     &                   WSTK, ZPLM )
         END IF

#ifdef Verbose1
         if ( zplm .gt. mxzplm ) mxzplm = zplm
#endif

C Determine the bottom and top heights of the plume.
         IF ( IPVERT .EQ. 0 ) THEN
C Default Turner approach.  Plume thickness = amount of plume rise
C Plume rise DH = ZPLM minus the stack height STKHT
            IF ( FIREFLAG( N ) ) THEN
               ZTOP = 1.5 * ZPLM 
               ZBOT = 0.5 * ZPLM
            ELSE
               ZTOP = STK_HT( N )%ARRY( S )
     &              + 1.5 * ( ZPLM - STK_HT( N )%ARRY( S ) )
               ZBOT = STK_HT( N )%ARRY( S )
     &              + 0.5 * ( ZPLM - STK_HT( N )%ARRY( S ) )
            END IF
         ELSE
C Alternative method to compute plume top/bot heights
            CALL PLSPRD( P_D( N )%DTHDZ, P_D( N )%ZZF, DESID_LAYS,
     &                   ZPLM, ZTOP, ZBOT )
         END IF

C Set up for computing plume fractions, assuming uniform distribution in pressure
C (~mass concentration -- minor hydrostatic assumption) from bottom to top.

         IF ( ZTOP .LT. STK_HT( N )%ARRY( S ) ) THEN
            WRITE( CINT,'( I8 )' ) S
            WRITE( XMSG,94010 ) 'ERROR: Top of plume is less than '
     &                          // 'top of stack for source:' // CINT
            CALL M3MESG( XMSG )
            WRITE( LOGDEV,* ) '    Zbot: ', ZBOT, ' Ztop: ', ZTOP
            WRITE( LOGDEV,* ) '    Stack Top: ', STK_HT( N )%ARRY( S ),
     &                        ' Plume Top: ', ZPLM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF

C Allocate plume to layers (compute layer plume fractions)

!              CALL POSTPLM( DESID_LAYS, ZBOT, ZTOP, PRESF, ZZF, TA( 1,S ), ZH( 1,S ),
!    &                       LTOP, TFRAC )

C Compute LBOT, LTOP such that
C  ZZF( LBOT-1 ) <= ZBOT < ZZF( LBOT ) and
C  ZZF( LTOP-1 ) <= ZTOP < ZZF( LTOP )

         DO L = 1, DESID_LAYS - 1
            IF ( ZBOT .LE. P_D( N )%ZZF( L ) ) THEN
               LBOT = L
               GO TO  122
            ELSE
               TFRAC( L,S ) = 0.0             ! fractions below plume
            END IF
         END DO
         LBOT = DESID_LAYS                      !  fallback

122      CONTINUE                           !  loop exit:  bottom found at LBOT

         IF ( ZTOP .LE. P_D( N )%ZZF( LBOT ) ) THEN  ! plume in this layer

            TFRAC( LBOT,S ) = 1.0
            LTOP = LBOT

            DO L = LBOT + 1, DESID_LAYS         ! fractions above plume
               TFRAC( L,S ) = 0.0
            END DO

         ELSE IF ( LBOT .EQ. DESID_LAYS ) THEN  ! plume above top layer

            TFRAC( LBOT,S ) = 1.0

            DO L = 1, DESID_LAYS - 1            ! fractions below plume
               TFRAC( L,S ) = 0.0
            END DO

         ELSE                               ! plume crosses layers

            DO L = LBOT + 1, DESID_LAYS
               IF ( ZTOP .LE. P_D( N )%ZZF( L ) ) THEN
                  LTOP = L
                  GO TO 126
               END IF
            END DO
            LTOP = DESID_LAYS                   !  fallback

126         CONTINUE

            ZDIFF = ZTOP - ZBOT
            IF ( ZDIFF .GT. 0.0 ) THEN

               DDZ  = 1.0 / ZDIFF
               TFRAC( LBOT,S ) = DDZ * ( P_D( N )%ZZF( LBOT ) - ZBOT )
               TFRAC( LTOP,S ) = DDZ * ( ZTOP - P_D( N )%ZZF( LTOP-1 ) )

            ELSE   ! ZDIFF .le. 0

               WRITE( CINT,'( I8 )' ) S
               WRITE( XMSG,94020 )
     &            'Infinitely small plume created for source:,'
     &            // CINT // CRLF() // BLANK10
     &            // 'All emissions put in first layer.'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               LBOT = 1; LTOP = 1
               TFRAC( LBOT,S ) = 1.0

            END IF

            DO L = LBOT + 1, LTOP - 1       ! layers in plume
               TFRAC( L,S ) = DDZ * ( P_D( N )%ZZF( L ) - P_D( N )%ZZF( L-1 ) )
            END DO

            DO L = LTOP + 1, DESID_LAYS         ! fractions above plume
               TFRAC( L,S ) = 0.0
            END DO

         END IF

C If layer fractions are negative, put in the first layer
         MV = MINVAL( TFRAC( 1:DESID_LAYS,S ) )
         IF ( MV .LT. 0.0 ) THEN

            WRITE( CINT,'( I8 )' ) S
            WRITE( XMSG,94010 ) 'WARNING: One or more negative plume '
     &               // 'fractions found for source:' // CINT
     &               // CRLF() // BLANK10 // 'Plume reset to '
     &               // 'put all emissions in surface layer.'
            CALL M3MESG( XMSG )

            TFRAC( 1,S ) = 1.0
            TFRAC( 2:DESID_LAYS,S ) = 0.0

         END IF

         IF ( FIREFLAG( N ) ) THEN
C If source is a fire, adjust for fire smoldering effects (include fractions below LBOT)
C calculate smoldering fraction:

             IF ( ACRES( N )%ARRY ( S ) .GT. 0.0 ) THEN
                BESIZE = 0.0703 * LOG( ACRES( N )%ARRY( S ) ) + 0.3
                BESIZE = MIN( BESIZE, 1.0 )
                SFRACT = 1.0 - BESIZE
             ELSE
                SFRACT = 1.0
                LACRESBURNED = LACRESBURNED + 1
             END IF

             ZDIFF = ZBOT - P_D( N )%ZZF( 0 )   ! Note: ZDIFF redefined
             IF ( ZDIFF .GT. 0.0 ) THEN
                DDZ  = 1.0 / ZDIFF
                DO L = 1, LBOT - 1
                  TFRAC( L,S ) = DDZ * ( P_D( N )%ZZF( L ) - P_D( N )%ZZF( L-1 ) )
     &                       * SFRACT
                END DO
                TFRAC( LBOT,S ) = TFRAC( LBOT,S )
     &                        + ( DDZ * ( ZBOT - P_D( N )%ZZF( LBOT-1 ) )
     &                          - TFRAC( LBOT,S ) ) * SFRACT
             ELSE   ! LBOT = 1
!               TFRAC( 1:LBOT-1 ) = 0.0
                TFRAC( LBOT,S ) = TFRAC( LBOT,S ) * ( 1.0 - SFRACT )
             END IF

             DO L = LBOT + 1, LTOP
                TFRAC( L,S ) = TFRAC( L,S ) * ( 1.0 - SFRACT )
             END DO

         END IF

201      CONTINUE
 
         IF ( PT3DFRAC ) THEN   ! Store layer fractions
            LFRAC( S,1:DESID_LAYS ) = TFRAC( 1:DESID_LAYS,S )  ! array
            ZPLUM( S,1 ) = ZPLM
         END IF

#ifndef mpas
C Possible report to REPRTLAY
         IF ( LTOP .GE. REP_LAYR .AND. RDEV( N ) .GT. 0 .AND. WRTIME ) THEN
              WRITE( RDEV( N ),93048 ) S, STK_HT( N )%ARRY( S ), LPBL,
     &                                     LBOT, LTOP, STK_VEL( N )%ARRY( S ), WSTK,
     &                                     STK_TK( N )%ARRY( S ), TSTK
         END IF
#endif

      END DO    ! end loop on sources S

      ! Print warning if any ACRES-BURNED values were negative
      IF ( LACRESBURNED .GT. 0 ) THEN
           write( XMSG,'(A,I8,A,I8,A)') "Warning: the value of ACRESBURNED for ",LACRESBURNED, " fire sources on stream ",
     &                     N, " is negative. CMAQ will set the smodlering fraction equal to 1.0 for these cases." 
           call log_message( logdev, xmsg )
      END IF
     
94010 FORMAT( 12( A, :, I8, :, 1X ) )
94020 FORMAT( 10( A, :, I7, :, 1X ) )
93048 FORMAT( I6, F8.2, 3I4, 4F10.2 )


      END SUBROUTINE CALC_PLUME_HEIGHT

C-----------------------------------------------------------------------

#ifndef mpas
         SUBROUTINE RETRIEVE_IOAPI_HEADER( FNAME, JDATE, JTIME )


            USE UTILIO_DEFN, ONLY : DESC3, XSTAT2

            IMPLICIT NONE

            CHARACTER( * ) :: FNAME
            INTEGER        :: JDATE, JTIME

            CHARACTER( 16 )  :: PNAME = 'RETRVE_IOAPI_HDR'   ! procedure name
            CHARACTER( 120 ) :: XMSG = ' '

            IF ( .NOT. DESC3( FNAME ) ) THEN
               XMSG = 'Could not get description of file "' //
     &                FNAME( 1:LEN_TRIM( FNAME ) ) // '"'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            RETURN

         END SUBROUTINE RETRIEVE_IOAPI_HEADER
#endif

C-----------------------------------------------------------------------

      END MODULE PT3D_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!-----------------------------------------------------------------------
      MODULE ELMO_PROC
!-----------------------------------------------------------------------
! This module will:
!      - collect all procedures used for subsetting the ELMO variables 
!        requested by the user. 
!      - open the ELMO output files and populate with metadata
!        reflecting the user-requested ELMO variables
!      - Calculate values of ELMO variables during the CCTM runtime
!
! Revision History:
! Ben Murphy 2020 Feb: Created
!-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE ELMO_DATA
      USE GRID_CONF, ONLY: NCOLS, NROWS, NLAYS, IO_PE_INCLUSIVE
      USE RUNTIME_VARS

      IMPLICIT NONE

      CONTAINS

!-------------------------------------------------------------------------
      SUBROUTINE ELMO_DRIVER( CGRID, JDATE, JTIME, TSTEP, INIT_TIME_IN )
!     This subroutine maps the PM diagnostic variables that the user has
!       requested to the entries in the ELMO_DATA table.
!-------------------------------------------------------------------------

      USE AERO_DATA, ONLY: AEROMODE_LNSG, DRY_AERO_DIAM, WET_AERO_DIAM,
     &                     DRY_AERO_M2, WET_AERO_M2, DRY_AERO_M3, 
     &                     WET_AERO_M3, N_MODE, MOMENT0_CONC, MOMENT2_CONC,
     &                     MOMENT3_CONC, WET_AERO_DENS, AEROSPC_CONC,
     &                     AH2O_IDX, AEROSPC, CALC_AERODIST_PARAMS,
     &                     Extract_Aero
      USE SOA_DEFN, ONLY : Extract_Soa
      USE AEROSOL_CHEMISTRY, ONLY: HETCHEM_RATES
      USE AEROMET_DATA, ONLY: AIRRH, AIRTEMP, AIRQV, AIRDENS, AIRPRES,
     &                        SRFTEMP, H2OVP, H2OSATVP 
      USE CGRID_SPCS, ONLY : N_CGRID_SPC, N_SPC_WDEP, N_SPC_DDEP
      !USE VDIFF_MAP, ONLY : N_SPC_DDEP
      use centralized_io_module, only : interpolate_var, pv_avail,
     &                                  wdir10_avail
      Use phot_mod, Only: init_phot_shared
      Use ASX_DATA_MOD, Only : GET_MET, MET_DATA
      Use WVEL_DEFN

#ifdef isam
      USE SA_DEFN, ONLY : NTAG_SA, ISAM, NSPC_SA
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY : SENGRID, NPMAX
#endif 
      USE CONST, ONLY : ESATL, MWWAT, MWAIR


      IMPLICIT NONE

      REAL, POINTER         :: CGRID( :,:,:,: ) ! Master concentration grid
      INTEGER, INTENT( IN ) :: JDATE, JTIME     ! Date and time inputs to 
                                                ! determine whether to write 
                                                ! concentrations
      INTEGER, INTENT( IN ) :: TSTEP(3)
      LOGICAL, INTENT( IN ) :: INIT_TIME_IN     ! Is this the first time step 
                                                !   of the simulation
      LOGICAL :: INIT_STEP        ! Is the time step beginning

      ! Variable to set time step for writing visibility file
      INTEGER, SAVE :: WSTEP  = 0          ! local write counter
      LOGICAL, SAVE :: WRITE_STEP =.FALSE. ! local write flag

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
    
      ! Statement Function **************
      REAL, PARAMETER :: EPSWATER = MWWAT / MWAIR
      REAL TT

      INTEGER C, R, L, IOS
      CHARACTER(16) :: PNAME = 'ELMO_DRIVER'

      REAL, ALLOCATABLE, SAVE :: PVS(:,:,:),
     &                           WDIR10S(:,:)

      IF ( FIRSTIME ) THEN
          FIRSTIME = .FALSE.
          ! Initialize Number of Steps Used for Calculating Average
          ELMO_NSTEP = 0

          ALLOCATE( PVS( NCOLS, NROWS, NLAYS ),
     &              WDIR10S( NCOLS,NROWS ) ) 
         
         ! Allocate local image of CGRID so it can be used each time step
         ALLOCATE( CONC_VEC( N_CGRID_SPC ), 
     &             WDEP_VEC( N_CGRID_SPC ),
     &             DDEP_VEC( N_CGRID_SPC ),
     &             STAT=IOS )
         CALL CHECKMEM( IOS, 'ELMOS_VECTORS',PNAME )

#ifdef isam
         ALLOCATE( ISAM_VEC( NSPC_SA,NTAG_SA ),
     &             ISAM_WDEP_VEC( NSPC_SA,NTAG_SA), 
     &             ISAM_DDEP_VEC( NSPC_SA,NTAG_SA ),
     &             STAT=IOS )
         CALL CHECKMEM( IOS, 'ISAM_ELMO_VECTORS',PNAME )
#endif

#ifdef sens
         ALLOCATE( DDM_VEC( NPMAX,N_CGRID_SPC ),
     &             DDM_WDEP_VEC( N_CGRID_SPC,NPMAX ), 
     &             DDM_DDEP_VEC( N_CGRID_SPC,NPMAX ),
     &             STAT=IOS )
         CALL CHECKMEM( IOS, 'ISAM_ELMO_VECTORS',PNAME )
#endif

      END IF

      ! Determine if this is a write step
      INIT_TIME = INIT_TIME_IN
      WRITE_STEP = .FALSE.
      INIT_STEP  = .FALSE.
      IF ( ELMO_NSTEP .LT. 1 ) THEN
         WSTEP = 0
         INIT_STEP = .TRUE.
      ELSE
         WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )
         IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) )
     &        WRITE_STEP = .TRUE.
      END IF
      ELMO_NSTEP = ELMO_NSTEP + 1

      ! Get Meteorological Variables
      CALL GET_MET( JDATE, JTIME, TSTEP(2) )

      ! get Wind Direction at 10 m (degrees)
      if ( wdir10_avail ) then
           call interpolate_var ('WDIR10', jdate, jtime, WDIR10S)
      else
           WDIR10S = ELMO_BLANK
      end if

      ! retrieve potential vorticity
      if ( pv_avail ) then
           call interpolate_var ('PV', jdate, jtime, PVS)
      else
           PVS = ELMO_BLANK
      end if
      
      ! Calculate Heterogeneous Chemistry Rates
      CALL INIT_PHOT_SHARED()
      CALL HETCHEM_RATES( MET_DATA%TA, MET_DATA%PRES, MET_DATA%QV,
     &                    CGRID, MET_DATA%DENS )

      ! Loop over grid cells to process ELMO output
      DO L = 1,NLAYS
      DO R = 1,NROWS
      DO C = 1,NCOLS
         ! Grid cell meteorological data.
         AIRTEMP  = MET_DATA%TA   ( C,R,L )
         SRFTEMP  = MET_DATA%TEMP2( C,R )     ! 2-meter temperature (K)
         AIRPRES  = MET_DATA%PRES ( C,R,L )   ! Note pascals
         AIRQV    = MET_DATA%QV   ( C,R,L )
         AIRDENS  = MET_DATA%DENS ( C,R,L )
         H2OSATVP = ESATL( AIRTEMP )
         H2OVP    = AIRPRES * AIRQV / ( EPSWATER  + AIRQV )
         AIRRH    = MAX( 0.005, MIN( 0.99, H2OVP / H2OSATVP ) ) ! 0-1
         IF ( L .EQ. 1 ) THEN
             WDIR10   = WDIR10S( C,R )
         ELSE
             WDIR10  = ELMO_BLANK
         END IF
         PV       = PVS( C,R,L )

         ! Extract Aerosols
#ifdef sens
         CALL EXTRACT_AERO( CGRID( C,R,L,: ), .TRUE., SENGRID( C,R,L,:,: ), .TRUE. )
         CALL EXTRACT_SOA( CGRID( C,R,L,: ), SENGRID( C,R,L,:,: ), .TRUE. )
#else
         CALL EXTRACT_AERO( CGRID( C,R,L,: ), .TRUE. )
         CALL EXTRACT_SOA( CGRID( C,R,L,: ) )
#endif   
         ! Load All Raw Concentrations and Fluxes
         CONC_VEC(:) = CGRID(C,R,L,:)

         IF ( L_ELMO_WDEP ) THEN
            IF ( L .EQ. 1 ) THEN
              WDEP_VEC(:) = ELMO_WDEP(C,R,:)  ! N_CGRID_SPC
            ELSE
              WDEP_VEC(:) = 0.0
            END IF
         END IF
         IF ( L_ELMO_DDEP ) THEN
            IF ( L .EQ. 1 ) THEN
              DDEP_VEC(:) = ELMO_DDEP(C,R,:)  ! N_CGRID_SPC
            ELSE
              DDEP_VEC(:) = 0.0
            END IF
         END IF

#ifdef isam                        
         ! Load All Raw Concentrations and Fluxes
         ISAM_VEC(:,:) = ISAM(C,R,L,:,:)

         IF ( L.EQ.1 .AND. L_ELMO_WDEP )
     &        ISAM_WDEP_VEC(:,:) = ELMO_ISAM_WDEP(C,R,:,:) ! NSPC_SA, NTAG_SA
         IF ( L.EQ.1 .AND. L_ELMO_DDEP )
     &        ISAM_DDEP_VEC(:,:) = ELMO_ISAM_DDEP(C,R,:,:) ! NSPC_SA, NTAG_SA
#endif

#ifdef sens
         ! Load All Raw Concentrations and Fluxes
         DDM_VEC(:,:) = SENGRID(C,R,L,:,:)  ! NPMAX, N_CGRID_SPC

         IF ( L.EQ.1 .AND. L_ELMO_WDEP )
     &        DDM_WDEP_VEC(:,:) = ELMO_DDM_WDEP(C,R,:,:) ! N_CGRID_SPC, NPMAX
         IF ( L.EQ.1 .AND. L_ELMO_DDEP )
     &        DDM_DDEP_VEC(:,:) = ELMO_DDM_DDEP(C,R,:,:) ! N_CGRID_SPC, NPMAX
#endif

         ! Populate Diagnostic Arrays
         CALL LOAD_ELMO( C,R,L, WRITE_STEP, INIT_STEP )

      END DO
      END DO
      END DO

      END SUBROUTINE ELMO_DRIVER

!-------------------------------------------------------------------------
      SUBROUTINE LOAD_ELMO( C,R,L,WRITE_STEP, INIT_STEP )
!     This subroutine maps the PM diagnostic variables that the user has
!       requested to the entries in the ELMO_DATA table.
!-------------------------------------------------------------------------

      USE AERO_DATA, ONLY: AEROMODE_LNSG, DRY_AERO_DIAM, WET_AERO_DIAM,
     &                     DRY_AERO_M2, WET_AERO_M2, DRY_AERO_M3, 
     &                     WET_AERO_M3, N_MODE, MOMENT0_CONC, MOMENT2_CONC,
     &                     MOMENT3_CONC, WET_AERO_DENS, AEROSPC_CONC, DRY_AERO_DENS,
     &                     AH2O_IDX, AEROSPC, CALC_AERODIST_PARAMS
      USE AEROMET_DATA, ONLY: AIRRH

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: C, R, L
      INTEGER IDG, IM, OL, IUSED, ILOC, J, IV, IVAR, IERR, IFL, U

      LOGICAL, INTENT( IN ) :: WRITE_STEP
      LOGICAL, INTENT( IN ) :: INIT_STEP
      REAL                  :: DIVFAC

      CHARACTER(250) :: XMSG
      INTEGER        :: XSTAT1

      ! Initalize Local Parameters
      C1                = C
      R1                = R
      L1                = L
      ELMO_USED( : )   = 0.0
      INLET_FRAC(:,:,:) = -1.
      L_CALCULATED      = .FALSE.
      ELMO_USED_UNIT    = 0

      ! Check to make sure the current layer is requested for diagnostic
      ! output.
      IF ( L1 .GE. LAY_BOT_MIN .AND. L1 .LE. LAY_TOP_MAX ) THEN
       
        ! Calculate All Aerosol Size Distribution Parameters
        CALL CALC_AERODIST_PARAMS( INIT_TIME )
      
        ! Loop Through Used Variables List and Call ELMO Functions 
        ! to fill in Local Array. ELMO_LOCAL is the same length as the
        ! ELMO_LIST and is ordered by the ELMO ID numbers so that it
        ! can be used seamlessly with the CALC_ELMO internal order.
        DO ILOC = 1,N_ELMO_USED
           J = MAP_USEDtoTABLE( ILOC ) 
           CALL CALC_ELMO( OUTVAL=ELMO_USED( ILOC ), J=J,
     &                     OUT_UNIT=ELMO_TABLE( J )%IUNIT,IERR=IERR )
           IF ( IERR .EQ. 1 ) THEN
              ! Invalid Variable Type
              WRITE ( XMSG, '(A,I3,A)'),'A user-requested variable for ',
     &                'ELMO cannot be found. Please check that it is ',
     &                'defined correctly. It is number ',J,' on the used ',
     &                'variable list.'
              CALL LOG_MESSAGE( LOGDEV, XMSG )
              CALL M3EXIT( 'LOAD_ELMO', 0, 0, '', XSTAT1 ) 
           END IF
        END DO

      ELSE
        ! This grid layer is not requested for output
        RETURN
      END IF

      DO IFL = 1,N_ELMO_FILES
        IF ( L1 .GE. ELMO_FILE( IFL )%LAY_BOT .AND.
     &       L1 .LE. ELMO_FILE( IFL )%LAY_TOP ) THEN

          SELECT CASE ( ELMO_FILE( IFL )%TMODE )
          CASE( 0 ) 
             ! *** Populate Diagnostic Variables to Instantaneous 
             !     Array if this is a write step
             IF ( INIT_TIME .OR. WRITE_STEP ) THEN
               OL = L1 - ELMO_FILE( IFL )%LAY_BOT + 1
               DO IVAR = 1,ELMO_FILE( IFL )%N_VARS
                   ELMO_OUT( IFL )%DATA( C1,R1,OL,IVAR ) = ELMO_USED( ELMO_FILE(IFL)%USEDID( IVAR ) )
               END DO
             END IF
 
          CASE ( 1 )
             ! *** Aggregate Diagnostic Variables in Average Array
             !     using trapezoidal rule
             OL = L1 - ELMO_FILE( IFL )%LAY_BOT + 1
             DIVFAC = 1.0
             IF ( WRITE_STEP ) DIVFAC = 0.5 / FLOAT( ELMO_NSTEP - 1 )

             DO  IVAR = 1,ELMO_FILE( IFL )%N_VARS
                J   = ELMO_FILE( IFL )%TABID( IVAR )
                U   = ELMO_FILE( IFL )%USEDID( IVAR )
                IV  = ELMO_TABLE( J )%VAR_TYPE
                IDG = ELMO_TABLE( J )%ID
              
                IF ( (IV .EQ. ET_DRVD .OR. IV .EQ. ET_ISAM_DRVD 
     &                                .OR. IV .EQ. ET_DDM_DRVD ) .AND.
     &               IDG .EQ. ID_PMF_PH .AND.
     &               ELMO_USED( U ) .LT. -100. ) THEN
                   ! Special Averaging for Particle pH
                   ! Add whatever the current average is right now.
                   ! Certainly this is problematic, particularly
                   ! at the beginning of an hour where ELMO_AVRG =
                   ! 0. It's best to either use the instantaneous
                   ! value or recalculate the average fine particle acidity
                   ! offline.
                   IF ( INIT_STEP ) THEN
                      ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) = 3.5  ! Assume relatively acidic particles
                   ELSE IF ( WRITE_STEP ) THEN
                       ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) = DIVFAC * 
     &                          ( ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) 
     &                        + 2.0 * ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) - ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) )
                   ELSE 
                       ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) =
     &                          ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) 
     &                        + 2.0 * ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR )
                   END IF
              
                ELSE IF ( IV .EQ. ET_DDEP .OR.
     &                    IV .EQ. ET_ISAM_DDEP .OR.
     &                    IV .EQ. ET_DDM_DDEP .OR.
     &                    IV .EQ. ET_WDEP .OR. 
     &                    IV .EQ. ET_ISAM_WDEP .OR. 
     &                    IV .EQ. ET_DDM_WDEP .OR.
     &                    IV .EQ. ET_CMPST_DEP .OR.
     &                    IV .EQ. ET_ISAM_CMPST_DEP .OR.
     &                    IV .EQ. ET_DDM_CMPST_DEP .OR.
     &                    IV .EQ. ET_DRVD_DDEP .OR.
     &                    IV .EQ. ET_ISAM_DRVD_DDEP .OR.
     &                    IV .EQ. ET_DDM_DRVD_DDEP .OR.
     &                    IV .EQ. ET_DRVD_WDEP .OR.
     &                    IV .EQ. ET_ISAM_DRVD_WDEP .OR.
     &                    IV .EQ. ET_DDM_DRVD_WDEP ) THEN
                   ! This is a deposition species so we should be
                   ! computing a cumulative sum, not an average by default
                   IF ( INIT_STEP ) THEN
                      ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) = 0.0 !ELMO_USED( U )
                   ELSE   
                      ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) = 
     &                     ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) + ELMO_USED( U )
                   END IF
              
                ELSE
                   ! For all other variables, apply trapezoidal rule for averaging.
                   IF ( INIT_STEP ) THEN
                      ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) = ELMO_USED( U ) 
                   ELSE IF ( WRITE_STEP ) THEN
                      ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) = DIVFAC *
     &                     ( ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) + 2.0 * ELMO_USED( U ) - ELMO_USED( U ) )
                   ELSE
                      ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) = 
     &                     ELMO_OUT(IFL)%DATA( C1,R1,OL,IVAR ) + 2.0 * ELMO_USED(U)
                   END IF 
                END IF
             END DO
          END SELECT
        END IF
      END DO

      END SUBROUTINE LOAD_ELMO
 
!-------------------------------------------------------------------------
      RECURSIVE SUBROUTINE CALC_ELMO( OUTVAL, OUT_UNIT, J, IERR )
!     This subroutine sums aggregate PM diagnostic parameters using the
!         ELMO_COEFFS structure as a guide for summing aerosol
!         components.          
!-------------------------------------------------------------------------
      USE AERO_DATA, ONLY : WET_AERO_M3, WET_AERO_M2, MOMENT0_CONC,
     &                      AH2O_IDX, AEROSPC, AEROSPC_CONC,
     &                      WET_AERO_DENS, N_MODE, AERO_MISSING,
     &                      AEROMODE, AEROSPC_MAP
      USE PRECURSOR_DATA, ONLY : PRECURSOR_CONC
      USE AEROMET_DATA, ONLY : AIRDENS
#ifdef isam
      USE SA_DEFN, ONLY : MAP_AEROtoSA, NTAG_SA
#endif
      USE CONST, ONLY : PI

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: J        ! Table Index
      INTEGER               :: IERR     ! Error Code
      REAL, INTENT( INOUT ) :: OUTVAL   ! Output Value
      INTEGER, INTENT( IN ) :: OUT_UNIT ! The desired output unit
      INTEGER ID, VAR_TYPE
      REAL VAL2
      INTEGER IVAR, ILIST, ILOC, IX1, IX2
      INTEGER WETNESS, ISPEC, INLET, IMODE, ISC
      INTEGER ISA, DSA
      LOGICAL LMODE
      REAL    FRAC( N_MODE ), FRAC1, FAC

      CHARACTER( 500 ) :: XMSG
  
      ! Stop CALC_ELMO and return an error code if the Table Index
      ! is equal to or less than zero.
      IERR = 0
      IF ( J .LE. 0 ) THEN
         IERR = 1
         RETURN
      END IF

      ! Determine if this variable has been mapped already. If it
      ! has, send it back
      ILOC = MAP_TABLEtoUSED( J )
      !IF ( ILOC .GT. 0 ) THEN
      !  IF ( L_CALCULATED( ILOC ) .AND. 
      !&       ELMO_USED_UNIT( ILOC ) .EQ. OUT_UNIT ) THEN
      !     OUTVAL = ELMO_USED( ILOC )
      !     RETURN
      !  END IF
      !END IF
 
      ! For most variables, the ELMO_TABLE and ELMO_COMP structures 
      ! will define all of the mappings and coefficients needed for
      ! a particular summation. This can therefore be used in most 
      ! cases. Variables in this category are linear combinations 
      ! of CMAQ species. For example, PMF_SO4 = ASO4I + ASO4J.
 
      ! Initialize value of aggregate variable
      OUTVAL = 0.0
      ID  = ELMO_TABLE( J )%ID             ! Map to ELMO Variable ID numbers
      VAR_TYPE  = ELMO_TABLE( J )%VAR_TYPE ! Specify Variable Type (e.g. CGRID, FAM, 
                                           !   ISAM)
 
      ! Retrieve value from corresponding array. These can come from
      ! CGRID, the Detailed ELMO variables, linear combinations of CGRID
      ! variables, deposition arrays, ISAM arrays, or DDM3D arrays.
      SELECT CASE ( VAR_TYPE ) 
         CASE ( ET_CONC )
            ! Variable is in CGRID - look up value in CONC_VEC
            OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, CONC_VEC( ID ) )
         
         CASE ( ET_CMPST, ET_ISAM_CMPST, ET_DDM_CMPST,
     &          ET_CMPST_DEP, ET_ISAM_CMPST_DEP, ET_DDM_CMPST_DEP )      
            ! Sum up Composite Variable
            ! Compute mode-dependent fraction from size cutoff if applicable
            FRAC = 1.0
            INLET = ELMO_COMP( J )%INLET
            WETNESS = ELMO_COMP( J )%WETNESS
            DO IMODE = 1,N_MODE
              IF ( INLET .NE. 0 ) THEN
                 CALL GET_AERO_INLET( INLET, IMODE, WETNESS, FRAC( IMODE ) )
              END IF
            END DO

            DO IVAR = 1,ELMO_COMP( J )%N_VARS
              IX1 = ELMO_COMP( J )%TABID(IVAR)
              IMODE = ELMO_TABLE( IX1 )%IM
              FRAC1 = 1.0
              LMODE = .FALSE.
              IF ( IMODE .NE. 0 ) THEN
                  FRAC1 = FRAC( IMODE )
                  LMODE = ELMO_COMP( J )%L_MODE( IMODE )
              END IF

              IF ( IMODE .EQ. 0 .OR. LMODE ) THEN

                CALL CALC_ELMO( OUTVAL=VAL2, OUT_UNIT=OUT_UNIT, J=IX1, IERR=IERR )
                IF ( IERR .EQ. 1 ) THEN
                   ! Invalid Variable Type
                   WRITE ( XMSG, '(2A,I3,4A)'),'There was an error processing ', 
     &                     'component number ',IVAR,' of the composite ',
     &                     TRIM(ELMO_TABLE( J )%NAME),'. Please check ',
     &                     'its definition.'
                   CALL LOG_MESSAGE( LOGDEV, XMSG )
                   CALL M3EXIT( 'CALC_ELMO', 0, 0, '', XSTAT1 ) 
                END IF 

                OUTVAL = OUTVAL + VAL2 * 
     &                   ELMO_COMP( J )%COEFF(IVAR) * FRAC1

              END IF
            END DO

         CASE ( ET_DRVD, ET_ISAM_DRVD, ET_DDM_DRVD,
     &          ET_DRVD_DDEP, ET_ISAM_DRVD_DDEP, ET_DDM_DRVD_DDEP,
     &          ET_DRVD_WDEP, ET_ISAM_DRVD_WDEP, ET_DDM_DRVD_WDEP,
     &          ET_AEROPROP, ET_CHEM, ET_MET, ET_PHOT )
            ! Retrieve Derived ELMO Variable
            CALL ELMO_DERIVED_CALC( VAL2, J )
            OUTVAL = OUTVAL + ELMO_UNIT_CONV( J, OUT_UNIT, VAL2 )

         CASE ( ET_WDEP )
            ! Variable is a Wet Deposition Flux
            OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, WDEP_VEC( ID ) ) 
         
         CASE ( ET_DDEP )
            ! Variable is a Dry Deposition Flux
            OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, DDEP_VEC( ID ) ) 

#ifdef isam
         CASE ( ET_ISAM_CONC )
            ! Variable is in the ISAM Array
            ISC = ELMO_TABLE( J )%SOURCE
            IF ( ISC .LE. NTAG_SA ) THEN
                OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, ISAM_VEC( ID,ISC ) ) 
            ELSE
                OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, SUM(ISAM_VEC( ID,: )) ) 
            END IF
         
         CASE ( ET_ISAM_WDEP )
            ! Variable is in the ISAM WetDep Array
            ISC = ELMO_TABLE( J )%SOURCE
            IF ( ISC .LE. NTAG_SA ) THEN
              OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, ISAM_WDEP_VEC( ID,ISC ) ) 
            ELSE
              OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, SUM( ISAM_WDEP_VEC( ID,: )) ) 
            END IF
         
         CASE ( ET_ISAM_DDEP )
            ! Variable is in the ISAM DryDep Array
            ISC = ELMO_TABLE( J )%SOURCE
            IF ( ISC .LE. NTAG_SA ) THEN
              OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, ISAM_DDEP_VEC( ID,ISC ) ) 
            ELSE
              OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, SUM( ISAM_DDEP_VEC( ID,: )) ) 
            END IF
#endif
#ifdef sens
         CASE ( ET_DDM_CONC )
            ! Variable is in the DDM3D Array
            ISC = ELMO_TABLE( J )%SOURCE
            OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, DDM_VEC( ISC,ID ) ) 

         CASE ( ET_DDM_WDEP )
            ! Variable is in the DDM3D WetDep Array
            ISC = ELMO_TABLE( J )%SOURCE
            OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, DDM_WDEP_VEC( ID,ISC ) ) 

         CASE ( ET_DDM_DDEP )
            ! Variable is in the DDM3D DryDep Array
            ISC = ELMO_TABLE( J )%SOURCE
            OUTVAL = ELMO_UNIT_CONV( J, OUT_UNIT, DDM_DDEP_VEC( ID,ISC ) ) 
#endif

         CASE DEFAULT

            ! Invalid Variable Type
            XMSG = 'ELMO variable ' // TRIM( ELMO_TABLE( J )%NAME ) //
     &             ' has an invalid variable type. Please check that it is '//
     &             'mapped correctly.'
            CALL LOG_MESSAGE( LOGDEV, XMSG )
            CALL M3EXIT( 'CALC_ELMO', 0, 0, '', XSTAT1 )
      END SELECT
      
      ! Save the fact that this variable has been calculated
      !IF ( ILOC .GT. 0 ) THEN
        !L_CALCULATED( ILOC ) = .TRUE.
        !ELMO_USED_UNIT( ILOC ) = OUT_UNIT
        !ELMO_USED( ILOC ) = OUTVAL
      !END IF

      END SUBROUTINE CALC_ELMO
 
      END MODULE ELMO_PROC

       MODULE RXNS_FUNCTION


       IMPLICIT NONE



! Name of Mechanism CB6R5PFAS_AE7_AQ

       PUBLIC             :: CALC_RCONST, SPECIAL_RATES, MAP_CHEMISTRY_SPECIES

       CONTAINS


       REAL( 8 ) FUNCTION POWER_T02( TEMPOT300,A0,B0 )
         IMPLICIT NONE
! rate constant for CMAQ Arrhenuis reaction type 2
! Arguements:
         REAL( 8 ), INTENT( IN ) :: TEMPOT300
         REAL( 8 ), INTENT( IN ) :: A0
         REAL( 8 ), INTENT( IN ) :: B0
         ! Local: None
         POWER_T02 =  A0 * TEMPOT300**B0
         RETURN
       END FUNCTION POWER_T02
       REAL( 8 ) FUNCTION ARRHENUIS_T04( INV_TEMP,TEMPOT300,A0,B0,C0 )
         IMPLICIT NONE
! rate constant for CMAQ Arrhenuis reaction type 4
! Arguements:
         REAL( 8 ), INTENT( IN ) :: INV_TEMP
         REAL( 8 ), INTENT( IN ) :: TEMPOT300
         REAL( 8 ), INTENT( IN ) :: A0
         REAL( 8 ), INTENT( IN ) :: B0
         REAL( 8 ), INTENT( IN ) :: C0
         ! Local:
         INTRINSIC DEXP
         ARRHENUIS_T04 =  A0 * DEXP( B0 * INV_TEMP ) * TEMPOT300**C0
         RETURN
       END FUNCTION ARRHENUIS_T04
       REAL( 8 ) FUNCTION ARRHENUIS_T03( INV_TEMP,A0,B0 )
! rate constant for CMAQ Arrhenuis reaction type 3
         IMPLICIT NONE
! Arguements:
         REAL( 8 ),   INTENT( IN ) ::  INV_TEMP
         REAL( 8 ),     INTENT(IN) ::  A0
         REAL( 8 ),     INTENT(IN) ::  B0
         ! Local:
         INTRINSIC DEXP
         ARRHENUIS_T03 =  A0 * DEXP( B0 * INV_TEMP )
         RETURN
       END FUNCTION ARRHENUIS_T03 
       REAL( 8 ) FUNCTION FALLOFF_T08(INV_TEMP,CAIR,A0,C0,A2,C2,A3,C3)
! rate constant for CMAQ fall off reaction type 8
         IMPLICIT NONE
! Arguements:
         REAL( 8 ), INTENT( IN ) :: INV_TEMP
         REAL( 8 ), INTENT( IN ) :: CAIR
         REAL( 8 ), INTENT( IN ) :: A0
         REAL( 8 ), INTENT( IN ) :: C0
         REAL( 8 ), INTENT( IN ) :: A2
         REAL( 8 ), INTENT( IN ) :: C2
         REAL( 8 ), INTENT( IN ) :: A3
         REAL( 8 ), INTENT( IN ) :: C3
         ! Local:
         REAL( 8 ) K0
         REAL( 8 ) K2
         REAL( 8 ) K3
         INTRINSIC DEXP
         K0 = A0 * DEXP( C0 * INV_TEMP )
         K2 = A2 * DEXP( C2 * INV_TEMP )
         K3 = A3 * DEXP( C3 * INV_TEMP )
         K3 = K3 * CAIR
         FALLOFF_T08 = K0 + K3/( 1.0D0 + K3/K2 )
         RETURN
       END FUNCTION FALLOFF_T08
       REAL( 8 ) FUNCTION FALLOFF_T09(INV_TEMP,CAIR,A1,C1,A2,C2)
! rate constant for CMAQ fall off reaction type 9
         IMPLICIT NONE
! Arguements:
         REAL( 8 ), INTENT( IN ) :: INV_TEMP
         REAL( 8 ), INTENT( IN ) :: CAIR
         REAL( 8 ), INTENT( IN ) :: A1
         REAL( 8 ), INTENT( IN ) :: C1
         REAL( 8 ), INTENT( IN ) :: A2
         REAL( 8 ), INTENT( IN ) :: C2
         !  Local:
         REAL( 8 ) K1
         REAL( 8 ) K2
         INTRINSIC DEXP
         K1 = A1 * DEXP( C1 * INV_TEMP )
         K2 = A2 * DEXP( C2 * INV_TEMP )
         FALLOFF_T09 = K1 + K2 * CAIR
         RETURN
       END FUNCTION FALLOFF_T09
       REAL( 8 ) FUNCTION FALLOFF_T10(INV_TEMP,TEMPOT300,CAIR,A0,B0,C0,A1,B1,C1,CE,CF)
         IMPLICIT NONE
! rate constant for CMAQ fall off reaction type 10
! Arguements:
         REAL( 8 ), INTENT( IN ) :: INV_TEMP
         REAL( 8 ), INTENT( IN ) :: TEMPOT300
         REAL( 8 ), INTENT( IN ) :: CAIR
         REAL( 8 ), INTENT( IN ) :: A0
         REAL( 8 ), INTENT( IN ) :: B0
         REAL( 8 ), INTENT( IN ) :: C0
         REAL( 8 ), INTENT( IN ) :: A1
         REAL( 8 ), INTENT( IN ) :: B1
         REAL( 8 ), INTENT( IN ) :: C1
         REAL( 8 ), INTENT( IN ) :: CE
         REAL( 8 ), INTENT( IN ) :: CF
         ! Local:
         REAL( 8 ) K0
         REAL( 8 ) K1
         REAL( 8 ) KEND
         K0 = A0 * CAIR * DEXP(B0*INV_TEMP)* TEMPOT300**C0
         K1 = A1 * DEXP(B1*INV_TEMP) * TEMPOT300**C1
         KEND = ( ( 1.0D0 + ( ( 1.0D0 / CE ) * DLOG10( K0 / K1 ) ) ** 2.0D0 ) )
         KEND = 1.0D0 / KEND
         FALLOFF_T10 = ( K0 / ( 1.0D0 + K0/K1 ) ) * CF ** KEND
         RETURN
       END FUNCTION FALLOFF_T10
       REAL( 8 ) FUNCTION FALLOFF_T11(INV_TEMP,TEMPOT300,CAIR,A1,B1,C1,A2, B2, C2, D1, D2)
! rate constant for CMAQ fall off reaction type 11
! actually expanded form of type 9
         IMPLICIT NONE
! Arguements:
         REAL( 8 ), INTENT( IN ) :: INV_TEMP
         REAL( 8 ), INTENT( IN ) :: TEMPOT300
         REAL( 8 ), INTENT( IN ) :: CAIR
         REAL( 8 ), INTENT( IN ) :: A1
         REAL( 8 ), INTENT( IN ) :: B1
         REAL( 8 ), INTENT( IN ) :: C1
         REAL( 8 ), INTENT( IN ) :: A2
         REAL( 8 ), INTENT( IN ) :: B2
         REAL( 8 ), INTENT( IN ) :: C2
         REAL( 8 ), INTENT( IN ) :: D1
         REAL( 8 ), INTENT( IN ) :: D2
         !  Local:
         REAL( 8 ) K1
         REAL( 8 ) K2
         REAL( 8 ) K3
         INTRINSIC DEXP
         K1 = A1 * DEXP( C1 * INV_TEMP ) * TEMPOT300**B1
         K2 = A2 * DEXP( C2 * INV_TEMP ) * TEMPOT300**B2
         K3 = D1 * DEXP( D2 * INV_TEMP )
         FALLOFF_T11 = K1 + K2 * CAIR + K3
         RETURN
       END FUNCTION FALLOFF_T11
       REAL( 8 ) FUNCTION HALOGEN_FALLOFF(PRESS,A1,B1,A2,B2,A3)
         IMPLICIT NONE
         REAL( 8 ), INTENT( IN ) :: PRESS
         REAL( 8 ), INTENT( IN ) :: A1
         REAL( 8 ), INTENT( IN ) :: B1
         REAL( 8 ), INTENT( IN ) :: A2
         REAL( 8 ), INTENT( IN ) :: B2
         REAL( 8 ), INTENT( IN ) :: A3 ! Maximum loss rate (1/sec)
         INTRINSIC DEXP
         HALOGEN_FALLOFF = A1 * DEXP( B1 * PRESS ) + A2 * DEXP( B2 * PRESS )
         HALOGEN_FALLOFF = DMIN1 (A3, HALOGEN_FALLOFF )
         RETURN
       END FUNCTION HALOGEN_FALLOFF

       SUBROUTINE SPECIAL_RATES( NUMCELLS, Y, TEMP, DENS, RKI )
! Purpose: calculate special rate operators and update
!         appropriate rate constants

       USE RXNS_DATA
       IMPLICIT NONE

! Arguments:
       INTEGER,      INTENT( IN  )   :: NUMCELLS        ! Number of cells in block 
       REAL( 8 ),    INTENT( IN )    :: Y( :, : )       ! species concs
       REAL( 8 ),    INTENT( IN )    :: TEMP( : )       ! air temperature, K 
       REAL( 8 ),    INTENT( IN )    :: DENS( : )       ! air density, Kg/m3
       REAL( 8 ),    INTENT( INOUT ) :: RKI( :, : )     ! reaction rate constant, ppm/min 
! Local:
       REAL( 8 ), PARAMETER :: DENSITY_TO_NUMBER = 2.07930D+19 ! Kg/m3 to molecules/cm3

       INTEGER   :: NCELL
       REAL( 8 ) :: INV_TEMP
       REAL( 8 ) :: CAIR
       REAL( 8 ) :: CFACT         ! scales operator if not multiplied by RKI, cm^3/(molecule) to 1/(ppm)
       REAL( 8 ) :: CFACT_SQU     ! scales operator if not multiplied by RKI, cm^6/(molec^2) to 1/(ppm^2)
! special rate operators listed below



       DO NCELL = 1, NUMCELLS
          INV_TEMP  = 1.0D0 / TEMP( NCELL )
          CAIR      = DENSITY_TO_NUMBER * DENS( NCELL )
          CFACT     = 1.0D-06 * CAIR
          CFACT_SQU = 1.0D-12 * CAIR * CAIR


! define special rate operators


! define rate constants in terms of special rate operators 

       END DO

       RETURN
       END SUBROUTINE SPECIAL_RATES
 
       SUBROUTINE CALC_RCONST( BLKTEMP, BLKPRES, BLKH2O, RJBLK, BLKHET, LSUNLIGHT, SEAWATER, RKI, NUMCELLS )

!**********************************************************************

!  Function: To compute thermal and photolytic reaction rate
!            coefficients for each reaction.

!  Preconditions: Photolysis rates for individual species must have
!                 been calculated and stored in RJPHOT. Expects
!                 temperature in deg K, pressure in atm., water
!                 vapor in ppmV, and J-values in /min.
!  Key Subroutines/Functions Called: POWER_02, ARRHRENUIS_T0*, FALLOFF_T*, HALOGEN_FALLOFF 
!***********************************************************************




       USE RXNS_DATA

        IMPLICIT NONE  

!  Arguements: None 

        REAL( 8 ),           INTENT( IN  ) :: BLKTEMP( : )      ! temperature, deg K 
        REAL( 8 ),           INTENT( IN  ) :: BLKPRES( : )      ! pressure, Atm
        REAL( 8 ),           INTENT( IN  ) :: BLKH2O ( : )      ! water mixing ratio, ppm 
        REAL( 8 ),           INTENT( IN  ) :: RJBLK  ( :, : )   ! photolysis rates, 1/min 
        REAL( 8 ),           INTENT( IN  ) :: BLKHET ( :, : )   ! heterogeneous rate constants, ???/min
        INTEGER,             INTENT( IN  ) :: NUMCELLS          ! Number of cells in block 
        LOGICAL,             INTENT( IN  ) :: LSUNLIGHT         ! Is there sunlight? 
        REAL( 8 ),           INTENT( IN  ) :: SEAWATER( : )     ! fractional area of OPEN+SURF 
        REAL( 8 ),           INTENT( OUT ) :: RKI ( :, : )      ! reaction rate constant, ppm/min 
!..Parameters: 

        REAL( 8 ), PARAMETER :: COEF1  = 7.33981D+15     ! Molec/cc to ppm conv factor 
        REAL( 8 ), PARAMETER :: CONSTC = 0.6D+0          ! Constant for reaction type 7
        REAL( 8 ), PARAMETER :: TI300  = 1.0D+0/300.0D+0 ! reciprocal of 300 deg K
        REAL( 8 ), PARAMETER :: SFACT  = 60.D+0          ! seconds per minute 
!..External Functions: None

!..Local Variables:

        INTEGER   :: NRT           ! Loop index for reaction types 
        INTEGER   :: IRXN          ! Reaction number
        INTEGER   :: JNUM          ! J-value species # from PHOT)
        INTEGER   :: KNUM          ! Reaction # for a relative rate coeff.
        INTEGER   :: N             ! Loop index for reactions
        INTEGER   :: NCELL         ! Loop index for # of cells in the block
        REAL( 8 ) :: CAIR          ! air number density (wet) [molec/cm^3]
        REAL( 8 ) :: CFACT         ! Convertor cm^3/(molec*sec) to 1/(ppm*min)
        REAL( 8 ) :: CFACT_SQU     ! Convertor cm^6/(molec^2*sec) to 1/(ppm^2*min)
        REAL( 8 ) :: INV_CFACT     ! ppm/min to molec/(cm^3*sec)
        REAL( 8 ) :: TEMPOT300     ! temperature divided by 300 K, dimensionaless 
        REAL( 8 ) :: INV_TEMP      ! reciprocal of air temperature, K-1
        REAL( 8 ) :: INV_CAIR      ! reciprocal of air number density (wet), [cm^3/molec]
        REAL( 8 ) :: TEMP          ! air temperature, K
        REAL( 8 ) :: PRESS         ! pressure [Atm] 
        REAL( 8 ) :: INV_RFACT     ! ppm/min to molec/(cm^3*min)
        REAL( 8 ) :: RFACT_SQU     ! cm^6/(molec^2*min) to 1/(ppm^2*min)
        REAL( 8 ) :: RFACT         ! cm^3/(molec*min) to 1/(ppm*min)
        REAL( 8 ) :: H2O           ! concentration, [molec/cm^3] 

        RKI = 0.0D0 

! All rate constants converted from  molec/cm3 to ppm
! and 1/sec to 1/min

        IF( LSUNLIGHT )THEN 
            DO NCELL = 1, NUMCELLS 

!  Reaction Label R1              
                RKI( NCELL,    1) =  RJBLK( NCELL, IJ_NO2_IUPAC10 )
!  Reaction Label R8              
                RKI( NCELL,    8) =  RJBLK( NCELL, IJ_O3_O3P_IUPAC10 )
!  Reaction Label R9              
                RKI( NCELL,    9) =  RJBLK( NCELL, IJ_O3_O1D_IUPAC10 )
!  Reaction Label R21             
                RKI( NCELL,   21) =  RJBLK( NCELL, IJ_H2O2_IUPAC10 )
!  Reaction Label R27             
                RKI( NCELL,   27) =  RJBLK( NCELL, IJ_NO3NO2_06 )
!  Reaction Label R28             
                RKI( NCELL,   28) =  RJBLK( NCELL, IJ_NO3NO_06 )
!  Reaction Label R38             
                RKI( NCELL,   38) =  RJBLK( NCELL, IJ_N2O5_IUPAC10 )
!  Reaction Label R43             
                RKI( NCELL,   43) =  RJBLK( NCELL, IJ_HONO_IUPAC10 )
!  Reaction Label R47             
                RKI( NCELL,   47) =  RJBLK( NCELL, IJ_HNO3_IUPAC10 )
!  Reaction Label R50             
                RKI( NCELL,   50) =  RJBLK( NCELL, IJ_PNA_IUPAC10 )
!  Reaction Label R56             
                RKI( NCELL,   56) =  RJBLK( NCELL, IJ_PAN_IUPAC10 )
!  Reaction Label R64             
                RKI( NCELL,   64) =  RJBLK( NCELL, IJ_PAN_IUPAC10 )
!  Reaction Label R88             
                RKI( NCELL,   88) =  RJBLK( NCELL, IJ_MEPX_IUPAC10 )
!  Reaction Label R90             
                RKI( NCELL,   90) =  RJBLK( NCELL, IJ_MEPX_IUPAC10 )
!  Reaction Label R92             
                RKI( NCELL,   92) =  RJBLK( NCELL, IJ_NTR_IUPAC10 )
!  Reaction Label R97             
                RKI( NCELL,   97) =  RJBLK( NCELL, IJ_FORM_R_IUPAC13 )
!  Reaction Label R98             
                RKI( NCELL,   98) =  RJBLK( NCELL, IJ_FORM_M_IUPAC13 )
!  Reaction Label R108            
                RKI( NCELL,  108) =  RJBLK( NCELL, IJ_ALD2_R_IUPAC13 )
!  Reaction Label R112            
                RKI( NCELL,  112) =  RJBLK( NCELL, IJ_ALDX_R_IUPAC13 )
!  Reaction Label R114            
                RKI( NCELL,  114) =  RJBLK( NCELL, IJ_GLYD_IUPAC13 )
!  Reaction Label R117            
                RKI( NCELL,  117) =  RJBLK( NCELL, IJ_GLY_R_IUPAC13 )
!  Reaction Label R119            
                RKI( NCELL,  119) =  RJBLK( NCELL, IJ_MGLY_IUPAC10 )
!  Reaction Label R128            
                RKI( NCELL,  128) =  RJBLK( NCELL, IJ_KET_IUPAC10 )
!  Reaction Label R129            
                RKI( NCELL,  129) =  RJBLK( NCELL, IJ_ACET_IUPAC10 )
!  Reaction Label R161            
                RKI( NCELL,  161) =  RJBLK( NCELL, IJ_ISPD )
!  Reaction Label R163            
                RKI( NCELL,  163) =  RJBLK( NCELL, IJ_HPALD )
!  Reaction Label R196            
                RKI( NCELL,  201) =  RJBLK( NCELL, IJ_NTR_IUPAC10 )
!  Reaction Label R197            
                RKI( NCELL,  202) =   5.0000D-02 * RJBLK( NCELL, IJ_NO2_IUPAC10 )
!  Reaction Label R201            
                RKI( NCELL,  206) =   2.8000D-02 * RJBLK( NCELL, IJ_NO2_IUPAC10 )
!  Reaction Label CL1             
                RKI( NCELL,  226) =  RJBLK( NCELL, IJ_CL2_IUPAC04 )
!  Reaction Label CL2             
                RKI( NCELL,  227) =  RJBLK( NCELL, IJ_HOCL_IUPAC04 )
!  Reaction Label CL9             
                RKI( NCELL,  234) =  RJBLK( NCELL, IJ_FMCL_IUPAC04 )
!  Reaction Label CL27            
                RKI( NCELL,  252) =  RJBLK( NCELL, IJ_CLNO2_IUPAC13 )
!  Reaction Label CL30            
                RKI( NCELL,  254) =  RJBLK( NCELL, IJ_CLONO2_1 )
!  Reaction Label CL31            
                RKI( NCELL,  255) =  RJBLK( NCELL, IJ_CLONO2_2 )
!  Reaction Label BP71mtp         
                RKI( NCELL,  291) =  RJBLK( NCELL, IJ_IC3ONO2 )
!  Reaction Label T04             
                RKI( NCELL,  317) =  RJBLK( NCELL, IJ_FORM_R_IUPAC13 )
!  Reaction Label T05             
                RKI( NCELL,  318) =  RJBLK( NCELL, IJ_FORM_M_IUPAC13 )
!  Reaction Label T09             
                RKI( NCELL,  323) =  RJBLK( NCELL, IJ_ALD2_R_IUPAC13 )
!  Reaction Label T16             
                RKI( NCELL,  332) =  RJBLK( NCELL, IJ_ACRO_09 )
!  Reaction Label T20             
                RKI( NCELL,  337) =  RJBLK( NCELL, IJ_ACRO_09 )

                IF ( SEAWATER (NCELL) .GT. 0.001D0 ) THEN
!  Reaction Label HAL_Ozone       
                   RKI( NCELL,  279) = SEAWATER (NCELL) *  SFACT * HALOGEN_FALLOFF( BLKPRES( NCELL ),   6.7006D-11,   1.0743D+01,  & 
     &                                                           3.4153D-08,  -6.7130D-01,         2.0000D-06 )
                ELSE
                   RKI( NCELL,  279) = 0.0D0 
                END IF

            END DO 
       END IF 

        DO NCELL = 1, NUMCELLS 
!  Set-up conversion factors 
             INV_TEMP  = 1.0D+00 / BLKTEMP( NCELL ) 
             CAIR      = 1.0D+06 * COEF1 * BLKPRES( NCELL ) * INV_TEMP 
             CFACT     = 6.0D-05 * CAIR
             CFACT_SQU = 6.0D-11 * CAIR * CAIR 
             INV_CAIR  = 1.0D0 / CAIR 
             INV_CFACT = 6.0D+07 * INV_CAIR 
             TEMP      = BLKTEMP( NCELL ) 
             TEMPOT300 = BLKTEMP( NCELL ) * TI300 
             RFACT     = 1.0D+06 * INV_CAIR 
             RFACT_SQU = 1.0D+12 * INV_CAIR * INV_CAIR 

!  Reaction Label R2              
             RKI( NCELL,    2) =  CFACT_SQU * POWER_T02( TEMPOT300,   6.0000D-34,  -2.6000D+00 )
!  Reaction Label R3              
             RKI( NCELL,    3) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.0700D-12,  -1.4000D+03 )
!  Reaction Label R4              
             RKI( NCELL,    4) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.0000D-31,   0.0000D+00,  -1.6000D+00,  & 
     &                                                 5.0000D-11,   0.0000D+00,   3.0000D-01,  & 
     &                                                 8.4000D-01,   8.5000D-01 )
!  Reaction Label R5              
             RKI( NCELL,    5) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.1000D-12,   1.9800D+02 )
!  Reaction Label R6              
             RKI( NCELL,    6) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.3000D-31,   0.0000D+00,  -1.5000D+00,  & 
     &                                                 2.3000D-11,   0.0000D+00,   2.4000D-01,  & 
     &                                                 1.0300D+00,   6.0000D-01 )
!  Reaction Label R7              
             RKI( NCELL,    7) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.0000D-12,  -2.0600D+03 )
!  Reaction Label R10             
             RKI( NCELL,   10) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.2300D-11,   1.1500D+02 )
!  Reaction Label R11             
             RKI( NCELL,   11) =   2.1400D-10 * CFACT 
!  Reaction Label R12             
             RKI( NCELL,   12) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.7000D-12,  -9.4000D+02 )
!  Reaction Label R13             
             RKI( NCELL,   13) =  CFACT * ARRHENUIS_T04( INV_TEMP,  TEMPOT300, & 
     &                                                   2.0300D-16,   6.9300D+02,   4.5700D+00 )
!  Reaction Label R14             
             RKI( NCELL,   14) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.4000D-11,   1.1000D+02 )
!  Reaction Label R15             
             RKI( NCELL,   15) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.0000D-11,   2.0000D+02 )
!  Reaction Label R16             
             RKI( NCELL,   16) =  CFACT * ARRHENUIS_T04( INV_TEMP,  TEMPOT300, & 
     &                                                   6.2000D-14,   9.4500D+02,   2.6000D+00 )
!  Reaction Label R17             
             RKI( NCELL,   17) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 9.0000D-31,   0.0000D+00,  -3.2000D+00,  & 
     &                                                 3.9000D-11,   0.0000D+00,  -4.7000D-01,  & 
     &                                                 1.2300D+00,   4.2000D-01 )
!  Reaction Label R18             
             RKI( NCELL,   18) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.8000D-11,   2.5000D+02 )
!  Reaction Label R19             
             RKI( NCELL,   19) =  CFACT * FALLOFF_T09( INV_TEMP,  CAIR, & 
     &                                                 2.2000D-13,   6.0000D+02,   1.9000D-33,  & 
     &                                                 9.8000D+02 )
!  Reaction Label R20             
             RKI( NCELL,   20) =  CFACT_SQU * FALLOFF_T09( INV_TEMP,  CAIR, & 
     &                                                 3.0800D-34,   2.8000D+03,   2.6600D-54,  & 
     &                                                 3.1800D+03 )
!  Reaction Label R22             
             RKI( NCELL,   22) =   1.8000D-12 * CFACT 
!  Reaction Label R23             
             RKI( NCELL,   23) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-12,  -2.0000D+03 )
!  Reaction Label R24             
             RKI( NCELL,   24) =  CFACT_SQU * ARRHENUIS_T03( INV_TEMP,  4.2500D-39,   6.6400D+02 )
!  Reaction Label R25             
             RKI( NCELL,   25) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.4500D-12,   2.7000D+02 )
!  Reaction Label R26             
             RKI( NCELL,   26) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-13,  -2.4700D+03 )
!  Reaction Label R29             
             RKI( NCELL,   29) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8000D-11,   1.1000D+02 )
!  Reaction Label R30             
             RKI( NCELL,   30) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.5000D-14,  -1.2600D+03 )
!  Reaction Label R31             
             RKI( NCELL,   31) =   1.7000D-11 * CFACT 
!  Reaction Label R32             
             RKI( NCELL,   32) =   2.0000D-11 * CFACT 
!  Reaction Label R33             
             RKI( NCELL,   33) =   4.0000D-12 * CFACT 
!  Reaction Label R34             
             RKI( NCELL,   34) =   1.0000D-17 * CFACT 
!  Reaction Label R35             
             RKI( NCELL,   35) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.5000D-13,  -2.4500D+03 )
!  Reaction Label R36             
             RKI( NCELL,   36) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 3.6000D-30,   0.0000D+00,  -4.1000D+00,  & 
     &                                                 1.9000D-12,   0.0000D+00,   2.0000D-01,  & 
     &                                                 1.3300D+00,   3.5000D-01 )
!  Reaction Label R37             
             RKI( NCELL,   37) =  SFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.3000D-03,  -1.1000D+04,  -3.5000D+00,  & 
     &                                                 9.7000D+14,  -1.1080D+04,   1.0000D-01,  & 
     &                                                 1.3300D+00,   3.5000D-01 )
!  Reaction Label R39             
             RKI( NCELL,   39) =   1.0000D-22 * CFACT 
!  Reaction Label R40             
             RKI( NCELL,   40) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 7.4000D-31,   0.0000D+00,  -2.4000D+00,  & 
     &                                                 3.3000D-11,   0.0000D+00,  -3.0000D-01,  & 
     &                                                 8.7000D-01,   8.1000D-01 )
!  Reaction Label R41             
             RKI( NCELL,   41) =   5.0000D-40 * CFACT_SQU 
!  Reaction Label R42             
             RKI( NCELL,   42) =   1.0000D-20 * CFACT 
!  Reaction Label R44             
             RKI( NCELL,   44) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.5000D-12,   2.6000D+02 )
!  Reaction Label R45             
             RKI( NCELL,   45) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.8000D-30,   0.0000D+00,  -3.0000D+00,  & 
     &                                                 2.8000D-11,   0.0000D+00,   0.0000D+00,  & 
     &                                                 1.0000D+00,   6.0000D-01 )
!  Reaction Label R46             
             RKI( NCELL,   46) =  CFACT * FALLOFF_T08( INV_TEMP,  CAIR, & 
     &                                                 2.4000D-14,   4.6000D+02,   2.7000D-17,  & 
     &                                                 2.1990D+03,   6.5000D-34,   1.3350D+03 )
!  Reaction Label R48             
             RKI( NCELL,   48) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.4000D-31,   0.0000D+00,  -3.1000D+00,  & 
     &                                                 4.0000D-12,   0.0000D+00,   0.0000D+00,  & 
     &                                                 1.2600D+00,   4.0000D-01 )
!  Reaction Label R49             
             RKI( NCELL,   49) =  SFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 4.1000D-05,  -1.0650D+04,   0.0000D+00,  & 
     &                                                 6.0000D+15,  -1.1170D+04,   0.0000D+00,  & 
     &                                                 1.2600D+00,   4.0000D-01 )
!  Reaction Label R51             
             RKI( NCELL,   51) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.2000D-13,   6.9000D+02 )
!  Reaction Label R52             
             RKI( NCELL,   52) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 2.8000D-31,   0.0000D+00,  -2.6000D+00,  & 
     &                                                 2.0000D-12,   0.0000D+00,   0.0000D+00,  & 
     &                                                 1.1000D+00,   5.3000D-01 )
!  Reaction Label R53             
             RKI( NCELL,   53) =  CFACT * ARRHENUIS_T03( INV_TEMP,  7.5000D-12,   2.9000D+02 )
!  Reaction Label R54             
             RKI( NCELL,   54) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 3.6100D-28,   0.0000D+00,  -6.8700D+00,  & 
     &                                                 1.2400D-11,   0.0000D+00,  -1.1050D+00,  & 
     &                                                 1.4100D+00,   3.0000D-01 )
!  Reaction Label R55             
             RKI( NCELL,   55) =  SFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.1000D-05,  -1.0100D+04,   0.0000D+00,  & 
     &                                                 1.9000D+17,  -1.4100D+04,   0.0000D+00,  & 
     &                                                 1.4100D+00,   3.0000D-01 )
!  Reaction Label R57             
             RKI( NCELL,   57) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.1400D-12,   5.8000D+02 )
!  Reaction Label R58             
             RKI( NCELL,   58) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.4000D-13,   1.0700D+03 )
!  Reaction Label R59             
             RKI( NCELL,   59) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.9000D-12,   5.0000D+02 )
!  Reaction Label R60             
             RKI( NCELL,   60) =   RKI( NCELL,   59 ) 
!  Reaction Label R61             
             RKI( NCELL,   61) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.7000D-12,   3.4000D+02 )
!  Reaction Label R62             
             RKI( NCELL,   62) =   8.4000D-01 * RKI( NCELL,   54 ) 
!  Reaction Label R63             
             RKI( NCELL,   63) =   8.4000D-01 * RKI( NCELL,   55 ) 
!  Reaction Label R65             
             RKI( NCELL,   65) =   RKI( NCELL,   57 ) 
!  Reaction Label R66             
             RKI( NCELL,   66) =   RKI( NCELL,   58 ) 
!  Reaction Label R67             
             RKI( NCELL,   67) =   RKI( NCELL,   59 ) 
!  Reaction Label R68             
             RKI( NCELL,   68) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.4000D-12,   3.6000D+02 )
!  Reaction Label R69             
             RKI( NCELL,   69) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.8000D-13,   8.0000D+02 )
!  Reaction Label R70             
             RKI( NCELL,   70) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.5000D-14,   5.0000D+02 )
!  Reaction Label R71             
             RKI( NCELL,   71) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.3000D-12,   3.6000D+02 )
!  Reaction Label R72             
             RKI( NCELL,   72) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.8000D-13,   7.8000D+02 )
!  Reaction Label R73             
             RKI( NCELL,   73) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.0000D-12,   5.0000D+02 )
!  Reaction Label R74             
             RKI( NCELL,   74) =   RKI( NCELL,   70 ) 
!  Reaction Label R75             
             RKI( NCELL,   75) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label R76             
             RKI( NCELL,   76) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.8000D-13,   8.0000D+02 )
!  Reaction Label R77             
             RKI( NCELL,   77) =   RKI( NCELL,   58 ) 
!  Reaction Label R78             
             RKI( NCELL,   78) =   RKI( NCELL,   70 ) 
!  Reaction Label R79             
             RKI( NCELL,   79) =   RKI( NCELL,   75 ) 
!  Reaction Label R80             
             RKI( NCELL,   80) =   RKI( NCELL,   76 ) 
!  Reaction Label R81             
             RKI( NCELL,   81) =   RKI( NCELL,   58 ) 
!  Reaction Label R82             
             RKI( NCELL,   82) =   RKI( NCELL,   70 ) 
!  Reaction Label R83             
             RKI( NCELL,   83) =   RKI( NCELL,   75 ) 
!  Reaction Label R84             
             RKI( NCELL,   84) =   RKI( NCELL,   76 ) 
!  Reaction Label R85             
             RKI( NCELL,   85) =   RKI( NCELL,   58 ) 
!  Reaction Label R86             
             RKI( NCELL,   86) =   RKI( NCELL,   70 ) 
!  Reaction Label R87             
             RKI( NCELL,   87) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.3000D-12,   1.9000D+02 )
!  Reaction Label R89             
             RKI( NCELL,   89) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.3000D-12,   1.9000D+02 )
!  Reaction Label R91             
             RKI( NCELL,   91) =   2.0000D-12 * CFACT 
!  Reaction Label R93             
             RKI( NCELL,   93) =   4.5000D-13 * CFACT 
!  Reaction Label R94             
             RKI( NCELL,   94) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.0000D-14,   8.5000D+02 )
!  Reaction Label R95             
             RKI( NCELL,   95) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.3000D-12,   1.9000D+02 )
!  Reaction Label R96             
             RKI( NCELL,   96) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.4000D-12,   1.3500D+02 )
!  Reaction Label R99             
             RKI( NCELL,   99) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.4000D-11,  -1.6000D+03 )
!  Reaction Label R100            
             RKI( NCELL,  100) =   5.5000D-16 * CFACT 
!  Reaction Label R101            
             RKI( NCELL,  101) =  CFACT * ARRHENUIS_T03( INV_TEMP,  9.7000D-15,   6.2500D+02 )
!  Reaction Label R102            
             RKI( NCELL,  102) =  SFACT * ARRHENUIS_T03( INV_TEMP,  2.4000D+12,  -7.0000D+03 )
!  Reaction Label R103            
             RKI( NCELL,  103) =   5.6000D-12 * CFACT 
!  Reaction Label R104            
             RKI( NCELL,  104) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.6000D-15,   2.3000D+03 )
!  Reaction Label R105            
             RKI( NCELL,  105) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8000D-11,  -1.1000D+03 )
!  Reaction Label R106            
             RKI( NCELL,  106) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.7000D-12,   3.4500D+02 )
!  Reaction Label R107            
             RKI( NCELL,  107) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-12,  -1.8600D+03 )
!  Reaction Label R109            
             RKI( NCELL,  109) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.3000D-11,  -8.7000D+02 )
!  Reaction Label R110            
             RKI( NCELL,  110) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.9000D-12,   4.0500D+02 )
!  Reaction Label R111            
             RKI( NCELL,  111) =   6.3000D-15 * CFACT 
!  Reaction Label R113            
             RKI( NCELL,  113) =   8.0000D-12 * CFACT 
!  Reaction Label R115            
             RKI( NCELL,  115) =   RKI( NCELL,  107 ) 
!  Reaction Label R116            
             RKI( NCELL,  116) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.1000D-12,   3.4000D+02 )
!  Reaction Label R118            
             RKI( NCELL,  118) =   4.0000D-16 * CFACT 
!  Reaction Label R120            
             RKI( NCELL,  120) =   5.0000D-16 * CFACT 
!  Reaction Label R121            
             RKI( NCELL,  121) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-12,   5.7500D+02 )
!  Reaction Label R122            
             RKI( NCELL,  122) =  CFACT * ARRHENUIS_T03( INV_TEMP,  7.7000D-12,  -2.1000D+03 )
!  Reaction Label R123            
             RKI( NCELL,  123) =  CFACT * FALLOFF_T09( INV_TEMP,  CAIR, & 
     &                                                 1.4400D-13,   0.0000D+00,   3.4300D-33,  & 
     &                                                 0.0000D+00 )
!  Reaction Label R124            
             RKI( NCELL,  124) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8500D-12,  -1.6900D+03 )
!  Reaction Label R125            
             RKI( NCELL,  125) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.9000D-12,  -1.0000D+03 )
!  Reaction Label R126            
             RKI( NCELL,  126) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.8500D-12,  -3.4500D+02 )
!  Reaction Label R127            
             RKI( NCELL,  127) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.0000D-12,   2.0000D+01 )
!  Reaction Label R130            
             RKI( NCELL,  130) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4100D-12,  -6.2060D+02 )
!  Reaction Label R131            
             RKI( NCELL,  131) =  CFACT * ARRHENUIS_T03( INV_TEMP,  7.6000D-12,  -5.8500D+02 )
!  Reaction Label R132            
             RKI( NCELL,  132) =   8.1000D-13 * CFACT 
!  Reaction Label R133            
             RKI( NCELL,  133) =  SFACT * ARRHENUIS_T03( INV_TEMP,  5.7000D+12,  -5.7800D+03 )
!  Reaction Label R134            
             RKI( NCELL,  134) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.5000D-14,  -2.0000D+02 )
!  Reaction Label R135            
             RKI( NCELL,  135) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.6000D-12,   4.0000D+02 )
!  Reaction Label R136            
             RKI( NCELL,  136) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 5.0000D-30,   0.0000D+00,  -1.5000D+00,  & 
     &                                                 1.0000D-12,   0.0000D+00,   0.0000D+00,  & 
     &                                                 1.3000D+00,   3.7000D-01 )
!  Reaction Label R137            
             RKI( NCELL,  137) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.0400D-11,  -7.9200D+02 )
!  Reaction Label R138            
             RKI( NCELL,  138) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 8.6000D-29,   0.0000D+00,  -3.1000D+00,  & 
     &                                                 9.0000D-12,   0.0000D+00,  -8.5000D-01,  & 
     &                                                 1.1500D+00,   4.8000D-01 )
!  Reaction Label R139            
             RKI( NCELL,  139) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.8200D-15,  -2.5000D+03 )
!  Reaction Label R140            
             RKI( NCELL,  140) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.3000D-12,  -2.8800D+03 )
!  Reaction Label R141            
             RKI( NCELL,  141) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.0000D-11,  -2.8000D+02 )
!  Reaction Label R142            
             RKI( NCELL,  142) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 8.0000D-27,   0.0000D+00,  -3.5000D+00,  & 
     &                                                 3.0000D-11,   0.0000D+00,  -1.0000D+00,  & 
     &                                                 1.1300D+00,   5.0000D-01 )
!  Reaction Label R143            
             RKI( NCELL,  143) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.5000D-15,  -1.8800D+03 )
!  Reaction Label R144            
             RKI( NCELL,  144) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.6000D-13,  -1.1550D+03 )
!  Reaction Label R145            
             RKI( NCELL,  145) =   2.3000D-11 * CFACT 
!  Reaction Label R146            
             RKI( NCELL,  146) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.0500D-11,   5.1900D+02 )
!  Reaction Label R147            
             RKI( NCELL,  147) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.7000D-15,  -1.0130D+03 )
!  Reaction Label R148            
             RKI( NCELL,  148) =   3.7000D-13 * CFACT 
!  Reaction Label R149            
             RKI( NCELL,  149) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-11,   3.9000D+02 )
!  Reaction Label R150            
             RKI( NCELL,  150) =   3.0000D-11 * CFACT 
!  Reaction Label R151            
             RKI( NCELL,  151) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.3900D-12,   3.6500D+02 )
!  Reaction Label R152            
             RKI( NCELL,  152) =  CFACT * ARRHENUIS_T03( INV_TEMP,  7.4300D-13,   7.0000D+02 )
!  Reaction Label R153            
             RKI( NCELL,  153) =   RKI( NCELL,   58 ) 
!  Reaction Label R154            
             RKI( NCELL,  154) =   RKI( NCELL,   70 ) 
!  Reaction Label R155            
             RKI( NCELL,  155) =  SFACT * ARRHENUIS_T03( INV_TEMP,  3.3000D+09,  -8.3000D+03 )
!  Reaction Label R156            
             RKI( NCELL,  156) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.0300D-14,  -1.9950D+03 )
!  Reaction Label R157            
             RKI( NCELL,  157) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.0300D-12,  -4.4800D+02 )
!  Reaction Label R158            
             RKI( NCELL,  158) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.5800D-12,   5.1100D+02 )
!  Reaction Label R159            
             RKI( NCELL,  159) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.8800D-15,  -1.7700D+03 )
!  Reaction Label R160            
             RKI( NCELL,  160) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.1000D-12,  -1.8600D+03 )
!  Reaction Label R162            
             RKI( NCELL,  162) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.2300D-11,   3.7200D+02 )
!  Reaction Label R164            
             RKI( NCELL,  164) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.0000D-12,  -1.8600D+03 )
!  Reaction Label R165            
             RKI( NCELL,  165) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.7800D-11,  -4.0000D+02 )
!  Reaction Label R166            
             RKI( NCELL,  166) =  CFACT * ARRHENUIS_T03( INV_TEMP,  7.4300D-13,   7.0000D+02 )
!  Reaction Label R167            
             RKI( NCELL,  167) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.3900D-12,   3.6500D+02 )
!  Reaction Label R168            
             RKI( NCELL,  168) =   RKI( NCELL,   58 ) 
!  Reaction Label R169            
             RKI( NCELL,  169) =   RKI( NCELL,   70 ) 
!  Reaction Label R170            
             RKI( NCELL,  170) =   3.1000D-11 * CFACT 
!  Reaction Label R171            
             RKI( NCELL,  171) =   3.6000D-11 * CFACT 
!  Reaction Label R172            
             RKI( NCELL,  172) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.5000D-11,   4.4900D+02 )
!  Reaction Label R173            
             RKI( NCELL,  173) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.2000D-15,  -8.2100D+02 )
!  Reaction Label R174            
             RKI( NCELL,  174) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.7000D-12,   1.7500D+02 )
!  Reaction Label R171a           
             RKI( NCELL,  175) =   3.6000D-11 * CFACT 
!  Reaction Label R172a           
             RKI( NCELL,  176) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.5000D-11,   4.4900D+02 )
!  Reaction Label R173a           
             RKI( NCELL,  177) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.2000D-15,  -8.2100D+02 )
!  Reaction Label R174a           
             RKI( NCELL,  178) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.7000D-12,   1.7500D+02 )
!  Reaction Label R175            
             RKI( NCELL,  179) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.3000D-12,  -1.9000D+02 )
!  Reaction Label R176            
             RKI( NCELL,  180) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label R177            
             RKI( NCELL,  181) =   RKI( NCELL,   58 ) 
!  Reaction Label R178            
             RKI( NCELL,  182) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label R179            
             RKI( NCELL,  183) =   RKI( NCELL,   70 ) 
!  Reaction Label R180            
             RKI( NCELL,  184) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8000D-12,   3.4000D+02 )
!  Reaction Label R181            
             RKI( NCELL,  185) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label R182            
             RKI( NCELL,  186) =   RKI( NCELL,   58 ) 
!  Reaction Label R183            
             RKI( NCELL,  187) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label R184            
             RKI( NCELL,  188) =   RKI( NCELL,   70 ) 
!  Reaction Label R185            
             RKI( NCELL,  189) =   1.8500D-11 * CFACT 
!  Reaction Label R185a           
             RKI( NCELL,  190) =   1.8500D-11 * CFACT 
!  Reaction Label R186            
             RKI( NCELL,  191) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label R187            
             RKI( NCELL,  192) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label R188            
             RKI( NCELL,  193) =   RKI( NCELL,   58 ) 
!  Reaction Label R189            
             RKI( NCELL,  194) =   RKI( NCELL,   70 ) 
!  Reaction Label R190            
             RKI( NCELL,  195) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.7000D-12,   9.5000D+02 )
!  Reaction Label R191            
             RKI( NCELL,  196) =   1.4000D-11 * CFACT 
!  Reaction Label R192            
             RKI( NCELL,  197) =   2.1000D-12 * CFACT 
!  Reaction Label R193            
             RKI( NCELL,  198) =   5.5000D-12 * CFACT 
!  Reaction Label R194            
             RKI( NCELL,  199) =   1.5300D-12 * CFACT 
!  Reaction Label R195            
             RKI( NCELL,  200) =   3.8000D-12 * CFACT 
!  Reaction Label R198            
             RKI( NCELL,  203) =   9.0000D-11 * CFACT 
!  Reaction Label R199            
             RKI( NCELL,  204) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.0800D-16,  -5.0000D+02 )
!  Reaction Label R200            
             RKI( NCELL,  205) =   3.0000D-12 * CFACT 
!  Reaction Label R202            
             RKI( NCELL,  207) =   4.4000D-11 * CFACT 
!  Reaction Label R203            
             RKI( NCELL,  208) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.4000D-17,  -5.0000D+02 )
!  Reaction Label R204            
             RKI( NCELL,  209) =   3.8000D-12 * CFACT 
!  Reaction Label R205            
             RKI( NCELL,  210) =   5.0000D-11 * CFACT 
!  Reaction Label R206            
             RKI( NCELL,  211) =   1.7000D-10 * CFACT 
!  Reaction Label R207            
             RKI( NCELL,  212) =   RKI( NCELL,   61 ) 
!  Reaction Label R208            
             RKI( NCELL,  213) =   RKI( NCELL,   62 ) 
!  Reaction Label R209            
             RKI( NCELL,  214) =   RKI( NCELL,   63 ) 
!  Reaction Label R210            
             RKI( NCELL,  215) =   RKI( NCELL,   57 ) 
!  Reaction Label R211            
             RKI( NCELL,  216) =   RKI( NCELL,   59 ) 
!  Reaction Label R212            
             RKI( NCELL,  217) =   RKI( NCELL,   58 ) 
!  Reaction Label R213            
             RKI( NCELL,  218) =   3.6000D-11 * CFACT 
!  Reaction Label R214            
             RKI( NCELL,  219) =   3.0000D-12 * CFACT 
!  Reaction Label R216            
             RKI( NCELL,  220) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8500D-12,  -1.6900D+03 )
!  Reaction Label R217            
             RKI( NCELL,  221) =  SFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 2.3700D-21,   0.0000D+00,   0.0000D+00,  & 
     &                                                 4.0700D-01,   0.0000D+00,  -8.0000D+00,  & 
     &                                                 1.0000D+00,   4.1000D-01 )
!  Reaction Label R218            
             RKI( NCELL,  222) =   1.0000D+00 * SFACT 
!  Reaction Label R219            
             RKI( NCELL,  223) =  SFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 4.8100D-20,   0.0000D+00,   0.0000D+00,  & 
     &                                                 4.0700D-01,   0.0000D+00,  -8.0000D+00,  & 
     &                                                 1.0000D+00,   4.1000D-01 )
!  Reaction Label R220            
             RKI( NCELL,  224) =   1.0000D+00 * SFACT 
!  Reaction Label R221            
             RKI( NCELL,  225) =   1.1000D-30 * CFACT_SQU 
!  Reaction Label CL3             
             RKI( NCELL,  228) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.3000D-11,  -2.0000D+02 )
!  Reaction Label CL4             
             RKI( NCELL,  229) =   1.6300D-14 * CFACT 
!  Reaction Label CL5             
             RKI( NCELL,  230) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.4000D-12,   2.9000D+02 )
!  Reaction Label CL6             
             RKI( NCELL,  231) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.2000D-12,   3.4000D+02 )
!  Reaction Label CL7             
             RKI( NCELL,  232) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.2000D-12,  -1.1000D+02 )
!  Reaction Label CL8             
             RKI( NCELL,  233) =   5.0000D-13 * CFACT 
!  Reaction Label CL10            
             RKI( NCELL,  235) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.6000D-12,  -1.2400D+03 )
!  Reaction Label CL11            
             RKI( NCELL,  236) =   5.0000D-11 * CFACT 
!  Reaction Label CL12            
             RKI( NCELL,  237) =   1.4000D-10 * CFACT 
!  Reaction Label CL13            
             RKI( NCELL,  238) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.3000D-11,  -1.0000D+02 )
!  Reaction Label CL14            
             RKI( NCELL,  239) =   1.0700D-10 * CFACT 
!  Reaction Label CL15            
             RKI( NCELL,  240) =   2.5000D-10 * CFACT 
!  Reaction Label CL16            
             RKI( NCELL,  241) =   3.5000D-10 * CFACT 
!  Reaction Label CL17            
             RKI( NCELL,  242) =   4.3000D-10 * CFACT 
!  Reaction Label CL18            
             RKI( NCELL,  243) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.2000D-11,  -3.4000D+01 )
!  Reaction Label CL19            
             RKI( NCELL,  244) =   7.9000D-11 * CFACT 
!  Reaction Label CL20            
             RKI( NCELL,  245) =   1.3000D-10 * CFACT 
!  Reaction Label CL21            
             RKI( NCELL,  246) =   5.5000D-11 * CFACT 
!  Reaction Label CL22            
             RKI( NCELL,  247) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.2000D-11,   4.5000D+01 )
!  Reaction Label CL23            
             RKI( NCELL,  248) =  CFACT * ARRHENUIS_T04( INV_TEMP,  TEMPOT300, & 
     &                                                   6.5800D-13,   5.8000D+01,   1.1600D+00 )
!  Reaction Label CL24            
             RKI( NCELL,  249) =   6.1000D-11 * CFACT 
!  Reaction Label CL25            
             RKI( NCELL,  250) =   1.2000D-10 * CFACT 
!  Reaction Label CL26            
             RKI( NCELL,  251) =   1.2000D-10 * CFACT 
!  Reaction Label CL28            
             RKI( NCELL,  253) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.8000D-31,   0.0000D+00,  -3.4000D+00,  & 
     &                                                 1.5000D-11,   0.0000D+00,  -1.9000D+00,  & 
     &                                                 1.0000D+00,   6.0000D-01 )
!  Reaction Label HET_CLNO3_WAI   
             RKI( NCELL,  256) =  BLKHET(  NCELL, IK_HETERO_CLNO3_WAI )
!  Reaction Label HET_CLNO3_WAJ   
             RKI( NCELL,  257) =  BLKHET(  NCELL, IK_HETERO_CLNO3_WAJ )
!  Reaction Label SA01            
             RKI( NCELL,  258) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label SA02            
             RKI( NCELL,  259) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label SA03            
             RKI( NCELL,  260) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label SA04            
             RKI( NCELL,  261) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label SA06            
             RKI( NCELL,  262) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label SA07            
             RKI( NCELL,  263) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label SA08            
             RKI( NCELL,  264) =   1.1600D-14 * CFACT 
!  Reaction Label SA09            
             RKI( NCELL,  265) =   1.9700D-10 * CFACT 
!  Reaction Label SA10            
             RKI( NCELL,  266) =   1.9000D-11 * CFACT 
!  Reaction Label SA11            
             RKI( NCELL,  267) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label SA12            
             RKI( NCELL,  268) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label SA13            
             RKI( NCELL,  269) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.7400D+02 )
!  Reaction Label HET_NTR2        
             RKI( NCELL,  270) =   1.4000D+00 * BLKHET( NCELL, IK_HETERO_NTR2 )
!  Reaction Label HET_N2O5IJ      
             RKI( NCELL,  271) =  BLKHET(  NCELL, IK_HETERO_N2O5IJ )
!  Reaction Label HET_N2O5K       
             RKI( NCELL,  272) =  BLKHET(  NCELL, IK_HETERO_N2O5K )
!  Reaction Label HET_H2NO3PIJA   
             RKI( NCELL,  273) =  BLKHET(  NCELL, IK_HETERO_H2NO3PAIJ )
!  Reaction Label HET_H2NO3PKA    
             RKI( NCELL,  274) =  BLKHET(  NCELL, IK_HETERO_H2NO3PAK )
!  Reaction Label HET_H2NO3PIB    
             RKI( NCELL,  275) =  BLKHET(  NCELL, IK_HETERO_H2NO3PBIJ )
!  Reaction Label HET_H2NO3PJB    
             RKI( NCELL,  276) =  BLKHET(  NCELL, IK_HETERO_H2NO3PBIJ )
!  Reaction Label HET_H2NO3PKB    
             RKI( NCELL,  277) =  BLKHET(  NCELL, IK_HETERO_H2NO3PBK )
!  Reaction Label HET_N02         
             RKI( NCELL,  278) =  BLKHET(  NCELL, IK_HETERO_NO2 )
!  Reaction Label HET_IEPOX       
             RKI( NCELL,  280) =  BLKHET(  NCELL, IK_HETERO_IEPOX )
!  Reaction Label HET_IEPOXOS     
             RKI( NCELL,  281) =  BLKHET(  NCELL, IK_HETERO_IEPOXOS )
!  Reaction Label HET_TETROL      
             RKI( NCELL,  282) =  BLKHET(  NCELL, IK_HETERO_TETROL )
!  Reaction Label HET_GLY         
             RKI( NCELL,  283) =  BLKHET(  NCELL, IK_HETERO_GLY )
!  Reaction Label HET_MGLY        
             RKI( NCELL,  284) =  BLKHET(  NCELL, IK_HETERO_MGLY )
!  Reaction Label BL18a           
             RKI( NCELL,  285) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.6000D-12,   3.8000D+02 )
!  Reaction Label BL18b           
             RKI( NCELL,  286) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.6500D-13,   1.3000D+03 )
!  Reaction Label BL18c           
             RKI( NCELL,  287) =   2.3000D-12 * CFACT 
!  Reaction Label BL18d           
             RKI( NCELL,  288) =   3.5000D-14 * CFACT 
!  Reaction Label CP07mtp         
             RKI( NCELL,  289) =   1.9200D-10 * CFACT 
!  Reaction Label BP70mtp         
             RKI( NCELL,  290) =   7.2000D-12 * CFACT 
!  Reaction Label HYD_MT          
             RKI( NCELL,  292) =   9.2590D-05 * SFACT 
!  Reaction Label OLIG_AROMATIC1  
             RKI( NCELL,  293) =   9.4882D-06 * SFACT 
!  Reaction Label OLIG_AROMATIC2  
             RKI( NCELL,  294) =   9.4882D-06 * SFACT 
!  Reaction Label OLIG_AROMATIC3  
             RKI( NCELL,  295) =   9.4882D-06 * SFACT 
!  Reaction Label OLIG_ISOPRENE1  
             RKI( NCELL,  296) =   9.4882D-06 * SFACT 
!  Reaction Label OLIG_ISOPRENE2  
             RKI( NCELL,  297) =   9.4882D-06 * SFACT 
!  Reaction Label OLIG_SESQT1     
             RKI( NCELL,  298) =   9.4882D-06 * SFACT 
!  Reaction Label RPOAGEPI        
             RKI( NCELL,  299) =   2.5000D-12 * CFACT 
!  Reaction Label RPOAGELI        
             RKI( NCELL,  300) =  BLKHET(  NCELL, IK_HETERO_PNCOMLI )
!  Reaction Label RPOAGEPJ        
             RKI( NCELL,  301) =   2.5000D-12 * CFACT 
!  Reaction Label RPOAGELJ        
             RKI( NCELL,  302) =  BLKHET(  NCELL, IK_HETERO_PNCOMLJ )
!  Reaction Label PCSOA           
             RKI( NCELL,  303) =   1.2500D-11 * CFACT 
!  Reaction Label POA_AGE1        
             RKI( NCELL,  304) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE2        
             RKI( NCELL,  305) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE3        
             RKI( NCELL,  306) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE4        
             RKI( NCELL,  307) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE5        
             RKI( NCELL,  308) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE6        
             RKI( NCELL,  309) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE7        
             RKI( NCELL,  310) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE8        
             RKI( NCELL,  311) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE9        
             RKI( NCELL,  312) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE10       
             RKI( NCELL,  313) =   4.0000D-11 * CFACT 
!  Reaction Label T01             
             RKI( NCELL,  314) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.4000D-12,   1.3500D+02 )
!  Reaction Label T02             
             RKI( NCELL,  315) =   5.5000D-16 * CFACT 
!  Reaction Label T03             
             RKI( NCELL,  316) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.4000D-11,  -1.6000D+03 )
!  Reaction Label TCL1            
             RKI( NCELL,  319) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.2000D-11,  -3.4000D+01 )
!  Reaction Label T06             
             RKI( NCELL,  320) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.7000D-12,   3.4500D+02 )
!  Reaction Label T07             
             RKI( NCELL,  321) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-12,  -1.8600D+03 )
!  Reaction Label T08             
             RKI( NCELL,  322) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8000D-11,  -1.1000D+03 )
!  Reaction Label TCL2            
             RKI( NCELL,  324) =   7.9000D-11 * CFACT 
!  Reaction Label T10             
             RKI( NCELL,  325) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4800D-11,   4.4800D+02 )
!  Reaction Label T11             
             RKI( NCELL,  326) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.3400D-14,  -2.2830D+03 )
!  Reaction Label T12             
             RKI( NCELL,  327) =   1.7900D-13 * CFACT 
!  Reaction Label TCL3            
             RKI( NCELL,  328) =   2.5100D-10 * CFACT 
!  Reaction Label T13             
             RKI( NCELL,  329) =   2.0000D-11 * CFACT 
!  Reaction Label T14             
             RKI( NCELL,  330) =   2.6100D-19 * CFACT 
!  Reaction Label T15             
             RKI( NCELL,  331) =   1.1500D-15 * CFACT 
!  Reaction Label TCL4            
             RKI( NCELL,  333) =   2.3700D-10 * CFACT 
!  Reaction Label T17             
             RKI( NCELL,  334) =   2.0000D-11 * CFACT 
!  Reaction Label T18             
             RKI( NCELL,  335) =   2.6100D-19 * CFACT 
!  Reaction Label T19             
             RKI( NCELL,  336) =   1.1500D-15 * CFACT 
!  Reaction Label TCL5            
             RKI( NCELL,  338) =   2.3700D-10 * CFACT 
!  Reaction Label T21             
             RKI( NCELL,  339) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8000D-12,   3.4000D+02 )
!  Reaction Label TCL6            
             RKI( NCELL,  340) =   6.1000D-11 * CFACT 
!  Reaction Label HG1             
             RKI( NCELL,  341) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.1100D-18,  -1.2565D+03 )
!  Reaction Label HG2             
             RKI( NCELL,  342) =   2.6000D-18 * CFACT 
!  Reaction Label HG3             
             RKI( NCELL,  343) =   8.5000D-19 * CFACT 
!  Reaction Label HG4             
             RKI( NCELL,  344) =   7.7000D-14 * CFACT 
!  Reaction Label HG5             
             RKI( NCELL,  345) =  CFACT_SQU * ARRHENUIS_T03( INV_TEMP,  2.2500D-33,   6.8000D+02 )
!  Reaction Label DMS1            
             RKI( NCELL,  346) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.1200D-11,  -2.5000D+02 )
!  Reaction Label DMS2            
             RKI( NCELL,  347) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.9900D-39,   5.2700D+03,   0.0000D+00,  & 
     &                                                 1.2600D-10,  -3.4000D+02,   0.0000D+00,  & 
     &                                                 1.0000D+00,   1.0000D+00 )
!  Reaction Label DMS3            
             RKI( NCELL,  348) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   5.2000D+02 )
!  Reaction Label DMS4            
             RKI( NCELL,  349) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.4000D-13,   2.0810D+03 )
!  Reaction Label PFAS1           
             RKI( NCELL,  350) =   7.8600D-26 * CFACT 
!  Reaction Label PFAS2           
             RKI( NCELL,  351) =  BLKHET(  NCELL, IK_HETERO_HFPODAF )
!  Reaction Label PFAS3           
             RKI( NCELL,  352) =  BLKHET(  NCELL, IK_HETERO_COF2 )
!  Reaction Label PFAS4           
             RKI( NCELL,  353) =  BLKHET(  NCELL, IK_HETERO_PFMOAF )

        END DO  
!  Multiply rate constants by [M], [O2], [N2], [H2O], [H2], or [CH4]
!  where needed and return
       IF ( NWM .GT. 0 ) THEN
          DO NRT = 1, NWM
             IRXN = NRXWM( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * ATM_AIR
             END DO
          END DO
       END IF
       IF ( NWO2 .GT. 0 ) THEN
          DO NRT = 1, NWO2
             IRXN = NRXWO2( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * ATM_O2
             END DO
          END DO
       END IF
       IF ( NWN2 .GT. 0 ) THEN
          DO NRT = 1, NWN2
             IRXN = NRXWN2( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * ATM_N2
             END DO
          END DO
       END IF
       IF ( NWW .GT. 0 ) THEN
          DO NRT = 1, NWW
             IRXN = NRXWW( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * BLKH2O( NCELL )
             END DO
          END DO
       END IF
       IF ( NWH2 .GT. 0 ) THEN
          DO NRT = 1, NWH2
             IRXN = NRXWH2( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * ATM_H2
             END DO
          END DO
       END IF
       IF ( NWCH4 .GT. 0 ) THEN
          DO NRT = 1, NWCH4
             IRXN = NRXWCH4( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * ATM_CH4
             END DO
          END DO
       END IF
       RETURN
       END SUBROUTINE CALC_RCONST
         FUNCTION MAP_CHEMISTRY_SPECIES() RESULT ( SUCCESS )

! Purpose find or test the CGRID Index, Species Type, and Conversion Factor
! for the Mechanism against the CMAQ namelists

            USE UTILIO_DEFN
            USE CGRID_SPCS
            USE RXNS_DATA

            IMPLICIT NONE

!Parameters:
            CHARACTER(  1 ), PARAMETER :: BL = ' '
            INTEGER,         PARAMETER :: SPC_DIM = 200
!Local:

            LOGICAL SUCCESS
            INTEGER I, IOS, J
            INTEGER I1, I2, I3, I4      ! SURROGATE TYPE 1 COUNTERS
            INTEGER J1, J2              ! SURROGATE TYPE 2 COUNTERS
            INTEGER K1, K2, K3, K4, K5  ! CONTROL TYPE COUNTERS
            INTEGER ICALL

            LOGICAL :: ORDER = .TRUE.
            LOGICAL :: FOUND = .TRUE.

            CHARACTER( 120 ) :: XMSG

            CHARACTER( 16 ), ALLOCATABLE     :: CGRID_SPC  ( : )
            CHARACTER( 16 ), ALLOCATABLE     :: NML_SPC    ( : )
            CHARACTER(  2 ), ALLOCATABLE     :: NML_TYPE   ( : )
            INTEGER,         ALLOCATABLE     :: NML_INDEX  ( : )
            LOGICAL,         ALLOCATABLE     :: NML_CONVERT( : )
            REAL,            ALLOCATABLE     :: NML_MOLWT  ( : )
            REAL                             :: DELTA            ! fractional difference

            LOGICAL, SAVE :: INITIALIZED = .FALSE.

            IF( INITIALIZED )RETURN

            INITIALIZED = .TRUE.
            SUCCESS     = .TRUE.


            ALLOCATE ( CGRID_SPC( NSPCSD - 1 ),    &
     &                 NML_SPC  ( NSPCSD - 1 ),    &
     &                 NML_INDEX( NSPCSD - 1 ),    &
     &                 NML_TYPE( NSPCSD - 1 ),     &
     &                 NML_CONVERT( NSPCSD - 1 ),  &
     &                 NML_MOLWT( NSPCSD - 1 ),    &
     &                 STAT = IOS )


            J = 0


            NML_INDEX     = -1
            TYPE_INDEX    = -1
            NML_TYPE      = '??'
            NML_CONVERT   = .FALSE.

            DO I = 1, N_GC_SPC ! load gc names and indices
               J = J + 1
               CGRID_SPC( I )     = GC_SPC( I )
               NML_INDEX( J )     = I + GC_STRT -1
               NML_TYPE( J )      = 'GC'
               NML_MOLWT( J )     = GC_MOLWT( I )
            END DO

            DO I = 1, N_AE_SPC ! load ae names and indices
               J = J + 1
               CGRID_SPC( J )     = AE_SPC( I )
               NML_INDEX( J )     = I + AE_STRT - 1
               NML_TYPE( J )      = 'AE'
               NML_CONVERT( J )   = .TRUE.
               NML_MOLWT( J )     = AE_MOLWT( I )
            END DO

            DO I = 1, N_NR_SPC ! load nr names and indices
               J = J + 1
               CGRID_SPC( J )     = NR_SPC( I )
               NML_INDEX( J )     = I + NR_STRT - 1
               NML_TYPE( J )      = 'NR'
               NML_MOLWT( J )     = NR_MOLWT( I )
            END DO

            DO I = 1, N_TR_SPC ! load tr names and indices
               J = J + 1
               CGRID_SPC( J )     = TR_SPC( I )
               NML_INDEX( J )     = I + TR_STRT - 1
               NML_TYPE( J )      = 'TR'
               NML_MOLWT( J )     = TR_MOLWT( I )
            END DO

            NML_SPC( 1:(NSPCSD-1) ) = CGRID_SPC( 1:(NSPCSD-1) )


! determine if mechanism species are in cgrid species

            DO I = 1, NUMB_MECH_SPC
! set species informations arrays using SPECIES_LIST array before mapping
               CHEMISTRY_SPC( I ) = SPECIES_LIST( I )%CHEMISTRY_SPC
               CGRID_INDEX  ( I ) = SPECIES_LIST( I )%CGRID_INDEX
               SPECIES_TYPE ( I ) = SPECIES_LIST( I )%SPECIES_TYPE
               CONVERT_CONC ( I ) = SPECIES_LIST( I )%CONVERT_CONC
               SPECIES_MOLWT( I ) = SPECIES_LIST( I )%SPECIES_MOLWT

               I1 = INDEX1R( CHEMISTRY_SPC( I ), (NSPCSD-1), CGRID_SPC )
               IF ( I1 .LT. 1 ) THEN
                  FOUND = .FALSE.
               ELSE
                  FOUND = .TRUE.
                  IF( .NOT. MAPPED_TO_CGRID )THEN
                      CGRID_INDEX( I )   = NML_INDEX( I1 )
                      SPECIES_TYPE( I )  = NML_TYPE ( I1 )
                      SPECIES_MOLWT( I ) = NML_MOLWT( I1 )
                      CONVERT_CONC( I )  = NML_CONVERT( I1 )
                  ELSE
                      IF(CGRID_INDEX( I ) .NE. NML_INDEX( I1 ))THEN
                         SUCCESS = .FALSE.
                         XMSG = '*** For Species ' // TRIM( CHEMISTRY_SPC( I ) ) &
    &                        // ' cgrid index does not match mechanism value.'
                         WRITE( LOGDEV,'( /5X, A )' ) TRIM( XMSG )
                         WRITE( XMSG,'(A,I3,1X,I3)')'CGRID Indices: Mechanism and NML Values are ',    &
    &                    CGRID_INDEX( I ),NML_INDEX( I1 )
                         WRITE( LOGDEV,'( 5X, A )' )XMSG
                      END IF
                      IF(CONVERT_CONC( I ) .NEQV. NML_CONVERT( I1 ))THEN
                         SUCCESS = .FALSE.
                         XMSG = '*** For Species ' // TRIM( CHEMISTRY_SPC( I ) ) &
    &                        // ' species unit conversion flag does not match mechanism value.'
                         WRITE( LOGDEV,'( /5X, A )' ) TRIM( XMSG )
                         WRITE( XMSG,'(A,1X,L21X,L2)')'CONVERSION FLAGS: Mechanism and NML Values are ', &
    &                    CONVERT_CONC( I ),NML_CONVERT( I1 )
                         WRITE( LOGDEV,'( 5X, A )' )XMSG
                         WRITE( XMSG,'(A,1X,A3,1X,A3)')'SPECIES TYPE: Mechanism and NML Values are ',    &
    &                    SPECIES_TYPE( I ),NML_TYPE( I1 )
                         WRITE( LOGDEV,'( 5X, A )' )XMSG
                      END IF
                      DELTA = ( SPECIES_MOLWT( I ) - NML_MOLWT( I1 ) )/MAX(NML_MOLWT( I1 ),1.0E-20)
                      IF( ABS( DELTA ) .GE. 0.05 )THEN
                         IF( CONVERT_CONC( I ) )SUCCESS = .FALSE.
                         XMSG = '*** For Species ' // TRIM( CHEMISTRY_SPC( I ) ) &
    &                        // ' species molecular weight does not match mechanism value.'
                         WRITE( LOGDEV,'( /5X, A )' ) TRIM( XMSG )
                         WRITE( XMSG,'(A,2(ES12.4,1X))')'Molecular Weight: Mechanism and NML Values are ', &
    &                    SPECIES_MOLWT( I ), NML_MOLWT( I1 )
                         WRITE( LOGDEV,'( 5X, A )' )XMSG
                      END IF
                 END IF
              END IF
              IF( INDEX( CHEMISTRY_SPC( I ), 'SRF') .GT. 0 )THEN
                  SUCCESS = .FALSE.
                  XMSG = '*** reactions cannot use modal aerosol surface area as species'
                  WRITE( LOGDEV,'( /5X, A )' ) TRIM( XMSG )
                  XMSG = TRIM( CHEMISTRY_SPC( I ) )
                  WRITE( LOGDEV,'( 2X, A )' ) TRIM( XMSG )
              END IF
              IF( INDEX( CHEMISTRY_SPC( I ), 'NUM') .GT. 0 )THEN
                  SUCCESS = .FALSE.
                  XMSG = '*** reactions cannot use modal aerosol number density as species'
                  WRITE( LOGDEV,'( /5X, A )' ) TRIM( XMSG )
                  XMSG = TRIM( CHEMISTRY_SPC( I ) )
                  WRITE( LOGDEV,'( 2X, A )' ) TRIM( XMSG )
              END IF
              IF ( .NOT. FOUND ) THEN
                 XMSG = 'Fatal error: Mechanism Species found not in species namelist:'
                 WRITE( LOGDEV,'( /5X, A )', ADVANCE = 'NO' ) TRIM( XMSG )
                 XMSG = TRIM( CHEMISTRY_SPC( I ) )
                 WRITE( LOGDEV,'( 2X, A )' ) TRIM( XMSG )
                 SUCCESS = .FALSE.
              END IF
            END DO

            IF( SUCCESS )RETURN

            WRITE(LOGDEV,99901)TRIM( MECHNAME )
            XMSG = 'The FATAL errors found in namelist used. Check ' &
      &          //  'the log of exiting processor if more details are needed.'
            CALL M3WARN('MAP_CHEMISTRY_SPECIES',0,0,XMSG)


99901       FORMAT( / 'FATAL error(s) found in the namelists used. Check that ' &
     &     /  'these namelists contain the above data as the respective files ' &
     &     /  'in the respository version of the mechanism: ' , A )

         RETURN

         END FUNCTION MAP_CHEMISTRY_SPECIES
!----------------------------------------------------------------------------------------
         INTEGER FUNCTION INDEX1R ( NAME, N, NLIST )
            IMPLICIT NONE
            CHARACTER( * ) NAME        ! character string being searched for
            INTEGER N                  ! length of array to be searched
            CHARACTER( * ) NLIST( : )  ! array to be searched

            INTEGER I

            DO I = 1, N
               IF ( NAME .EQ. NLIST( I ) ) THEN
                  INDEX1R = I
                  RETURN
               END IF
           END DO
           INDEX1R = 0
           RETURN

          END FUNCTION INDEX1R
          SUBROUTINE RESET_SPECIES_POINTERS( IOLD2NEW )

             USE RXNS_DATA
             IMPLICIT NONE
             INTEGER, INTENT( IN ) :: IOLD2NEW( :,: ) 


             INDEX_NO2          = IOLD2NEW( INDEX_NO2         , 1 )
             INDEX_NO           = IOLD2NEW( INDEX_NO          , 1 )
             INDEX_O            = IOLD2NEW( INDEX_O           , 1 )
             INDEX_O3           = IOLD2NEW( INDEX_O3          , 1 )
             INDEX_NO3          = IOLD2NEW( INDEX_NO3         , 1 )
             INDEX_O1D          = IOLD2NEW( INDEX_O1D         , 1 )
             INDEX_OH           = IOLD2NEW( INDEX_OH          , 1 )
             INDEX_HO2          = IOLD2NEW( INDEX_HO2         , 1 )
             INDEX_H2O2         = IOLD2NEW( INDEX_H2O2        , 1 )
             INDEX_N2O5         = IOLD2NEW( INDEX_N2O5        , 1 )
             INDEX_HNO3         = IOLD2NEW( INDEX_HNO3        , 1 )
             INDEX_HONO         = IOLD2NEW( INDEX_HONO        , 1 )
             INDEX_PNA          = IOLD2NEW( INDEX_PNA         , 1 )
             INDEX_SO2          = IOLD2NEW( INDEX_SO2         , 1 )
             INDEX_SULF         = IOLD2NEW( INDEX_SULF        , 1 )
             INDEX_SULRXN       = IOLD2NEW( INDEX_SULRXN      , 1 )
             INDEX_C2O3         = IOLD2NEW( INDEX_C2O3        , 1 )
             INDEX_MEO2         = IOLD2NEW( INDEX_MEO2        , 1 )
             INDEX_RO2          = IOLD2NEW( INDEX_RO2         , 1 )
             INDEX_PAN          = IOLD2NEW( INDEX_PAN         , 1 )
             INDEX_PACD         = IOLD2NEW( INDEX_PACD        , 1 )
             INDEX_AACD         = IOLD2NEW( INDEX_AACD        , 1 )
             INDEX_CXO3         = IOLD2NEW( INDEX_CXO3        , 1 )
             INDEX_ALD2         = IOLD2NEW( INDEX_ALD2        , 1 )
             INDEX_XO2H         = IOLD2NEW( INDEX_XO2H        , 1 )
             INDEX_PANX         = IOLD2NEW( INDEX_PANX        , 1 )
             INDEX_FORM         = IOLD2NEW( INDEX_FORM        , 1 )
             INDEX_MEPX         = IOLD2NEW( INDEX_MEPX        , 1 )
             INDEX_MEOH         = IOLD2NEW( INDEX_MEOH        , 1 )
             INDEX_ROOH         = IOLD2NEW( INDEX_ROOH        , 1 )
             INDEX_XO2          = IOLD2NEW( INDEX_XO2         , 1 )
             INDEX_XO2N         = IOLD2NEW( INDEX_XO2N        , 1 )
             INDEX_NTR1         = IOLD2NEW( INDEX_NTR1        , 1 )
             INDEX_NTR2         = IOLD2NEW( INDEX_NTR2        , 1 )
             INDEX_FACD         = IOLD2NEW( INDEX_FACD        , 1 )
             INDEX_CO           = IOLD2NEW( INDEX_CO          , 1 )
             INDEX_HCO3         = IOLD2NEW( INDEX_HCO3        , 1 )
             INDEX_ALDX         = IOLD2NEW( INDEX_ALDX        , 1 )
             INDEX_GLYD         = IOLD2NEW( INDEX_GLYD        , 1 )
             INDEX_GLY          = IOLD2NEW( INDEX_GLY         , 1 )
             INDEX_MGLY         = IOLD2NEW( INDEX_MGLY        , 1 )
             INDEX_ETHA         = IOLD2NEW( INDEX_ETHA        , 1 )
             INDEX_ETOH         = IOLD2NEW( INDEX_ETOH        , 1 )
             INDEX_KET          = IOLD2NEW( INDEX_KET         , 1 )
             INDEX_PAR          = IOLD2NEW( INDEX_PAR         , 1 )
             INDEX_ACET         = IOLD2NEW( INDEX_ACET        , 1 )
             INDEX_PRPA         = IOLD2NEW( INDEX_PRPA        , 1 )
             INDEX_XPRP         = IOLD2NEW( INDEX_XPRP        , 1 )
             INDEX_XPAR         = IOLD2NEW( INDEX_XPAR        , 1 )
             INDEX_ROR          = IOLD2NEW( INDEX_ROR         , 1 )
             INDEX_ETHY         = IOLD2NEW( INDEX_ETHY        , 1 )
             INDEX_ETH          = IOLD2NEW( INDEX_ETH         , 1 )
             INDEX_OLE          = IOLD2NEW( INDEX_OLE         , 1 )
             INDEX_IOLE         = IOLD2NEW( INDEX_IOLE        , 1 )
             INDEX_ISOP         = IOLD2NEW( INDEX_ISOP        , 1 )
             INDEX_ISO2         = IOLD2NEW( INDEX_ISO2        , 1 )
             INDEX_ISOPRXN      = IOLD2NEW( INDEX_ISOPRXN     , 1 )
             INDEX_ISPD         = IOLD2NEW( INDEX_ISPD        , 1 )
             INDEX_INTR         = IOLD2NEW( INDEX_INTR        , 1 )
             INDEX_ISPX         = IOLD2NEW( INDEX_ISPX        , 1 )
             INDEX_HPLD         = IOLD2NEW( INDEX_HPLD        , 1 )
             INDEX_OPO3         = IOLD2NEW( INDEX_OPO3        , 1 )
             INDEX_EPOX         = IOLD2NEW( INDEX_EPOX        , 1 )
             INDEX_EPX2         = IOLD2NEW( INDEX_EPX2        , 1 )
             INDEX_TERP         = IOLD2NEW( INDEX_TERP        , 1 )
             INDEX_TRPRXN       = IOLD2NEW( INDEX_TRPRXN      , 1 )
             INDEX_TERPNRO2     = IOLD2NEW( INDEX_TERPNRO2    , 1 )
             INDEX_APIN         = IOLD2NEW( INDEX_APIN        , 1 )
             INDEX_BENZENE      = IOLD2NEW( INDEX_BENZENE     , 1 )
             INDEX_CRES         = IOLD2NEW( INDEX_CRES        , 1 )
             INDEX_BZO2         = IOLD2NEW( INDEX_BZO2        , 1 )
             INDEX_OPEN         = IOLD2NEW( INDEX_OPEN        , 1 )
             INDEX_BENZRO2      = IOLD2NEW( INDEX_BENZRO2     , 1 )
             INDEX_TOL          = IOLD2NEW( INDEX_TOL         , 1 )
             INDEX_TO2          = IOLD2NEW( INDEX_TO2         , 1 )
             INDEX_TOLRO2       = IOLD2NEW( INDEX_TOLRO2      , 1 )
             INDEX_XOPN         = IOLD2NEW( INDEX_XOPN        , 1 )
             INDEX_XYLMN        = IOLD2NEW( INDEX_XYLMN       , 1 )
             INDEX_XLO2         = IOLD2NEW( INDEX_XLO2        , 1 )
             INDEX_XYLRO2       = IOLD2NEW( INDEX_XYLRO2      , 1 )
             INDEX_NAPH         = IOLD2NEW( INDEX_NAPH        , 1 )
             INDEX_PAHRO2       = IOLD2NEW( INDEX_PAHRO2      , 1 )
             INDEX_CRO          = IOLD2NEW( INDEX_CRO         , 1 )
             INDEX_CAT1         = IOLD2NEW( INDEX_CAT1        , 1 )
             INDEX_CRON         = IOLD2NEW( INDEX_CRON        , 1 )
             INDEX_OPAN         = IOLD2NEW( INDEX_OPAN        , 1 )
             INDEX_ECH4         = IOLD2NEW( INDEX_ECH4        , 1 )
             INDEX_CL2          = IOLD2NEW( INDEX_CL2         , 1 )
             INDEX_CL           = IOLD2NEW( INDEX_CL          , 1 )
             INDEX_HOCL         = IOLD2NEW( INDEX_HOCL        , 1 )
             INDEX_CLO          = IOLD2NEW( INDEX_CLO         , 1 )
             INDEX_FMCL         = IOLD2NEW( INDEX_FMCL        , 1 )
             INDEX_HCL          = IOLD2NEW( INDEX_HCL         , 1 )
             INDEX_CLNO2        = IOLD2NEW( INDEX_CLNO2       , 1 )
             INDEX_CLNO3        = IOLD2NEW( INDEX_CLNO3       , 1 )
             INDEX_SVAVB2       = IOLD2NEW( INDEX_SVAVB2      , 1 )
             INDEX_SVAVB3       = IOLD2NEW( INDEX_SVAVB3      , 1 )
             INDEX_SVAVB4       = IOLD2NEW( INDEX_SVAVB4      , 1 )
             INDEX_SVAVB1       = IOLD2NEW( INDEX_SVAVB1      , 1 )
             INDEX_SESQ         = IOLD2NEW( INDEX_SESQ        , 1 )
             INDEX_SESQRXN      = IOLD2NEW( INDEX_SESQRXN     , 1 )
             INDEX_SOAALK       = IOLD2NEW( INDEX_SOAALK      , 1 )
             INDEX_H2NO3PIJ     = IOLD2NEW( INDEX_H2NO3PIJ    , 1 )
             INDEX_H2NO3PK      = IOLD2NEW( INDEX_H2NO3PK     , 1 )
             INDEX_ACLI         = IOLD2NEW( INDEX_ACLI        , 1 )
             INDEX_ACLJ         = IOLD2NEW( INDEX_ACLJ        , 1 )
             INDEX_ACLK         = IOLD2NEW( INDEX_ACLK        , 1 )
             INDEX_IEPOXP       = IOLD2NEW( INDEX_IEPOXP      , 1 )
             INDEX_ASO4J        = IOLD2NEW( INDEX_ASO4J       , 1 )
             INDEX_AISO3J       = IOLD2NEW( INDEX_AISO3J      , 1 )
             INDEX_AGLYJ        = IOLD2NEW( INDEX_AGLYJ       , 1 )
             INDEX_MTNO3        = IOLD2NEW( INDEX_MTNO3       , 1 )
             INDEX_AMTNO3J      = IOLD2NEW( INDEX_AMTNO3J     , 1 )
             INDEX_AMTHYDJ      = IOLD2NEW( INDEX_AMTHYDJ     , 1 )
             INDEX_AAVB2J       = IOLD2NEW( INDEX_AAVB2J      , 1 )
             INDEX_AOLGAJ       = IOLD2NEW( INDEX_AOLGAJ      , 1 )
             INDEX_AAVB3J       = IOLD2NEW( INDEX_AAVB3J      , 1 )
             INDEX_AAVB4J       = IOLD2NEW( INDEX_AAVB4J      , 1 )
             INDEX_AISO1J       = IOLD2NEW( INDEX_AISO1J      , 1 )
             INDEX_AOLGBJ       = IOLD2NEW( INDEX_AOLGBJ      , 1 )
             INDEX_AISO2J       = IOLD2NEW( INDEX_AISO2J      , 1 )
             INDEX_ASQTJ        = IOLD2NEW( INDEX_ASQTJ       , 1 )
             INDEX_APOCI        = IOLD2NEW( INDEX_APOCI       , 1 )
             INDEX_APNCOMI      = IOLD2NEW( INDEX_APNCOMI     , 1 )
             INDEX_APOCJ        = IOLD2NEW( INDEX_APOCJ       , 1 )
             INDEX_APNCOMJ      = IOLD2NEW( INDEX_APNCOMJ     , 1 )
             INDEX_PCVOC        = IOLD2NEW( INDEX_PCVOC       , 1 )
             INDEX_PCSOARXN     = IOLD2NEW( INDEX_PCSOARXN    , 1 )
             INDEX_VLVPO1       = IOLD2NEW( INDEX_VLVPO1      , 1 )
             INDEX_VSVPO1       = IOLD2NEW( INDEX_VSVPO1      , 1 )
             INDEX_VSVPO2       = IOLD2NEW( INDEX_VSVPO2      , 1 )
             INDEX_VSVPO3       = IOLD2NEW( INDEX_VSVPO3      , 1 )
             INDEX_VIVPO1       = IOLD2NEW( INDEX_VIVPO1      , 1 )
             INDEX_VLVOO1       = IOLD2NEW( INDEX_VLVOO1      , 1 )
             INDEX_VLVOO2       = IOLD2NEW( INDEX_VLVOO2      , 1 )
             INDEX_VSVOO2       = IOLD2NEW( INDEX_VSVOO2      , 1 )
             INDEX_VSVOO3       = IOLD2NEW( INDEX_VSVOO3      , 1 )
             INDEX_VSVOO1       = IOLD2NEW( INDEX_VSVOO1      , 1 )
             INDEX_FORM_PRIMARY = IOLD2NEW( INDEX_FORM_PRIMARY, 1 )
             INDEX_ALD2_PRIMARY = IOLD2NEW( INDEX_ALD2_PRIMARY, 1 )
             INDEX_BUTADIENE13  = IOLD2NEW( INDEX_BUTADIENE13 , 1 )
             INDEX_ACROLEIN     = IOLD2NEW( INDEX_ACROLEIN    , 1 )
             INDEX_ACRO_PRIMARY = IOLD2NEW( INDEX_ACRO_PRIMARY, 1 )
             INDEX_TOLU         = IOLD2NEW( INDEX_TOLU        , 1 )
             INDEX_HG           = IOLD2NEW( INDEX_HG          , 1 )
             INDEX_HGIIAER      = IOLD2NEW( INDEX_HGIIAER     , 1 )
             INDEX_HGIIGAS      = IOLD2NEW( INDEX_HGIIGAS     , 1 )
             INDEX_DMS          = IOLD2NEW( INDEX_DMS         , 1 )
             INDEX_MSA          = IOLD2NEW( INDEX_MSA         , 1 )
             INDEX_HFPODAF      = IOLD2NEW( INDEX_HFPODAF     , 1 )
             INDEX_AHFJ         = IOLD2NEW( INDEX_AHFJ        , 1 )
             INDEX_HFPODAghyd   = IOLD2NEW( INDEX_HFPODAghyd  , 1 )
             INDEX_AHFPODAphydJ = IOLD2NEW( INDEX_AHFPODAphydJ, 1 )
             INDEX_COF2         = IOLD2NEW( INDEX_COF2        , 1 )
             INDEX_AFCOOHphydJ  = IOLD2NEW( INDEX_AFCOOHphydJ , 1 )
             INDEX_PFMOAF       = IOLD2NEW( INDEX_PFMOAF      , 1 )
             INDEX_APFMOAAphydJ = IOLD2NEW( INDEX_APFMOAAphydJ, 1 )
          END SUBROUTINE RESET_SPECIES_POINTERS
       END MODULE RXNS_FUNCTION

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C......................................................................
      MODULE PA_PARSE
 
C Contains: data used by parsing routines in the Process Analysis Control Program
 
C methods: rdline, getchr, getword, eatcom, getreal, getlabel, getquote, catstring
 
C Revision History:
C  Based on code created by Jerry Gipson, 1996, 1997
C  PA_PARSE.F module; 13 Jul 2016; Jeff Young
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C......................................................................

      IMPLICIT NONE

C Parameters:
      INTEGER, PARAMETER :: BUFLEN = 81  ! Length of one input line
      INTEGER, PARAMETER :: LABLEN = 16  ! Label character length
      INTEGER, PARAMETER :: WRDLEN = 16  ! Word character length
      INTEGER, PARAMETER :: IZERO = 0    ! Integer zero

C Variables:
      CHARACTER(   1 )    :: CHR   ! Last character read from input buffer
      CHARACTER( 200 )    :: MSG   ! Error message output buffer 
      CHARACTER(  60 )    :: QUOTE ! String found by GETQUOTE
      CHARACTER( BUFLEN ) :: INBUF ! Input line
      CHARACTER( LABLEN ) :: LABEL ! Label found by getlabel  
      CHARACTER( WRDLEN ) :: WORD  ! Word found by GETWORD
    
      INTEGER IEOL       ! Position of last non-blank character
      INTEGER IFILE      ! Unit number of input ASCII File
      INTEGER LINNUM     ! Number of last line read 
      INTEGER LPOINT     ! Pointer to location of last character read

      REAL NUMBER        ! Real number found by GETREAL

      CONTAINS
C=======================================================================
         SUBROUTINE RDLINE

C......................................................................
C Function: Reads one line from a file and stores it in INBUF.
C           The position of the last non-blank character is stored
C           in IEOL. All blank lines and lines with a ! in the first
C           column are skipped. The line count is stored in LINNUM.
C......................................................................

         USE UTILIO_DEFN

         IMPLICIT NONE
C.......................................................................

c..Read the first non-comment line and find the last non-blank character
c..in that line
20       CONTINUE
         READ( IFILE, '( A )', END = 999 ) INBUF
         LINNUM = LINNUM + 1
         IF ( INBUF( 1:1 ) .EQ. '!' ) THEN
            GO TO 20
         ELSE
            IEOL = LEN_TRIM( INBUF )
            IF ( IEOL .EQ. 1 .AND. INBUF( 1:1 ) .EQ. ' ' ) THEN
               GO TO 20
            ELSE
               LPOINT = 0
               RETURN
            END IF
         END IF

999      CONTINUE
c..eof file encountered -- exit program
         WRITE( MSG, 94000 )
         CALL M3MESG( MSG )
         WRITE( MSG, 94020 )
         CALL M3MESG( MSG )
         CALL M3EXIT( 'RDLINE', IZERO, IZERO, ' ', XSTAT2 )

94000    FORMAT( 'ERROR: End of file reached on the Process Analysis',
     &           ' command file' )
94020    FORMAT( 10X, 'ENDPA must be the last command' )

         END SUBROUTINE RDLINE

C=======================================================================
         SUBROUTINE GETCHR

C......................................................................
C Function: Returns the next non-blank character in the input buffer,
C           excluding those in comments

C Key Subroutines/Functions Called: EATCOM, RDLINE
C......................................................................

         IMPLICIT NONE
C.......................................................................

20       CONTINUE
         LPOINT = LPOINT + 1
         IF ( LPOINT .GT. IEOL ) THEN
            CALL RDLINE
            GO TO 20
         ELSE
            CHR = INBUF( LPOINT : LPOINT )
            IF ( CHR .EQ. ' ' ) THEN
               GO TO 20
            ELSE IF ( CHR .EQ. '(' .OR. CHR .EQ. '{' ) THEN
               CALL EATCOM
               GO TO 20
            END IF
         END IF

         RETURN
         END SUBROUTINE GETCHR

C=======================================================================
         SUBROUTINE GETWORD

C......................................................................
C Function: Get the next word from the input buffer starting
C           with the current character; the word can be any length,
C           but only the first sixteen characters are retained.  The
C           first character must be alphabetic.

C Preconditions: None

C Key Subroutines/Functions Called: EATCOM, GETCHR, RDLINE
C......................................................................

         USE UTILIO_DEFN

         IMPLICIT NONE

C Local Variables:
         CHARACTER( BUFLEN ) :: SAVBUF  ! Saved input buffer

         INTEGER START     ! Starting position in input buffer
         INTEGER LENGTH    ! Length of word
C.......................................................................

c..Setup and make sure the first character is alphabetic
         LENGTH = 0
         START  = LPOINT
         SAVBUF = INBUF
         IF ( ( CHR .LT. 'A' .OR. CHR .GT. 'Z' ) .AND.
     &        ( CHR .LT. 'a' .OR. CHR .GT. 'z' ) ) THEN
            WRITE( MSG, 94000 )
            CALL M3MESG( MSG )
            WRITE( MSG, 94020 ) LINNUM, INBUF
            CALL M3MESG( MSG )
            WRITE( MSG, 94040 ) CHR
            CALL M3MESG( MSG )
            CALL M3EXIT( 'GETWORD', IZERO, IZERO, ' ', XSTAT2 )
         END IF

c..Get the remaining characters; stop if a word spans a line
20       CONTINUE
         LENGTH = LENGTH + 1
         LPOINT = LPOINT + 1

c..Get the next line if necessary (word wrap not allowed)
         IF ( LPOINT .GT. IEOL ) THEN
            CALL RDLINE
            CALL GETCHR
            CHR = INBUF( LPOINT:LPOINT )
            IF ( ( CHR .GE. 'A' .AND. CHR .LE. 'Z' ) .OR.
     &          ( CHR .GE. 'a' .AND. CHR .LE. 'z' ) .OR.
     &          ( CHR .EQ. ':' ) .OR. ( CHR .EQ. '_' ) )THEN
               WRITE( MSG, 94060 )
               CALL M3MESG( MSG )
               WRITE( MSG, 94020 ) LINNUM, SAVBUF
               CALL M3EXIT( 'GETWORD', IZERO, IZERO, ' ', XSTAT2 )
            ELSE
               GO TO 40  ! Word does not wrap around line
            END IF
         END IF

c..Include all characters in word that are valid; stop reading on an
c..ivalid character
         CHR = SAVBUF( LPOINT:LPOINT )
         IF ( CHR .GE. 'A' .AND. CHR .LE. 'Z' ) GO TO 20
         IF ( CHR .GE. 'a' .AND. CHR .LE. 'z' ) GO TO 20
         IF ( CHR .GE. '0' .AND. CHR .LE. '9' ) GO TO 20
         IF ( CHR .EQ. ':' ) GO TO 20
         IF ( CHR .EQ. '_' ) GO TO 20
         IF ( CHR .EQ. '('  .OR. CHR .EQ. '{' ) THEN
            LENGTH = LENGTH - 1
            CALL EATCOM
            GO TO 20
         END IF

c..Truncate the word and get the next character if necessary
40       CONTINUE
         LENGTH = MIN( LENGTH, WRDLEN )
         WORD = SAVBUF( START:START+LENGTH-1 )
         IF ( CHR .EQ. ' ' ) CALL GETCHR

         RETURN

94000    FORMAT( 'ERROR: The first character of a word must be alphabetic' )
94020    FORMAT( '   Line No. ', I4, ': ', A )
94040    FORMAT( '   First character: ', A )
94060    FORMAT( 'ERROR: A word cannot span two lines' )

         END SUBROUTINE GETWORD

C=======================================================================
         SUBROUTINE EATCOM

C.......................................................................
C Function: EATCOM reads past all characters in comments; comments are
C              enclosed in () or {}
 
C Key Subroutines/Functions Called: GETCHR, RDLINE
C.......................................................................
 
         IMPLICIT NONE
C.......................................................................
         
20    CONTINUE
         LPOINT = LPOINT + 1
         IF ( LPOINT .GT. IEOL ) THEN
            CALL RDLINE
            CALL GETCHR
            GO TO 20
         ELSE
            CHR = INBUF( LPOINT:LPOINT )
            IF( CHR .NE. ')' .AND. CHR .NE. '}' ) GO TO 20
         END IF

         RETURN

         END SUBROUTINE EATCOM

C=======================================================================
         SUBROUTINE PA_GETREAL

C.......................................................................
C Function: get the next word from the input buffer starting
C              with the current character; the word can be any length,
C              but only the first sixteen characters are retained.  The
C              first character must be alphabetic.
C.......................................................................
         USE UTILIO_DEFN

         IMPLICIT NONE
         
C Local Variables:
         CHARACTER( 15 ) ::        NUMSTRING  ! String holding number

         INTEGER ICHR      ! ASCII code number of character
         INTEGER LENGTH    ! Length of numeric string
         INTEGER NOSIGNS   ! Number of pos or neg signs found
         INTEGER START     ! Starting position in input buffer

         LOGICAL LDECIMAL  ! Flag to indicate decimal point found
         LOGICAL LEXP      ! Flag to indicate exponent found
C.......................................................................
            
         START    = LPOINT
         LENGTH   = 0
         NOSIGNS  = 0
         LDECIMAL = .FALSE.
         LEXP     = .FALSE.

c..Top of loop for getting characters in the number string
10       CONTINUE

         IF ( LENGTH .NE. 0 ) THEN
            LPOINT = LPOINT + 1
            IF ( LPOINT .GT. IEOL ) THEN
               CHR = ' '
            ELSE
               CHR = INBUF( LPOINT:LPOINT )
            END IF
         END IF

         ICHR = ICHAR( CHR )
         LENGTH = LENGTH + 1

c..Check for decimal point
         IF ( CHR .EQ. '.' ) THEN
            IF ( .NOT. LDECIMAL ) THEN
               LDECIMAL = .TRUE.
               GO TO 10
            ELSE
               WRITE( MSG, 94000 ) 
               CALL M3MESG( MSG )
               WRITE( MSG, 94500 ) LINNUM, INBUF
               CALL M3MESG( MSG )
               WRITE( MSG, 94520 ) INBUF( START:LPOINT )
               CALL M3MESG( MSG )
               CALL M3EXIT( 'GETREAL', IZERO, IZERO,' ', XSTAT2 )
            END IF        
         END IF   

c..If numeric value, get next character
         IF ( ICHR .GE. 48 .AND. ICHR .LE. 57 ) GO TO 10

c..Check for exponent term
         IF ( CHR .EQ. 'E' .OR. CHR .EQ. 'e' ) THEN
            IF ( .NOT. LEXP ) THEN
               LEXP = .TRUE.
               GO TO 10
            ELSE
               WRITE( MSG, 94020 ) 
               CALL M3MESG( MSG )
               WRITE( MSG, 94500 ) LINNUM, INBUF
               CALL M3MESG( MSG )
               WRITE( MSG, 94520 ) INBUF( START:LPOINT )
               CALL M3MESG( MSG )
               CALL M3EXIT( 'GETREAL', IZERO, IZERO, ' ', XSTAT2 )
            END IF
         END IF
         
c..check for sign
         IF ( CHR .EQ. '+' .OR. CHR .EQ. '-' ) THEN
            NOSIGNS = NOSIGNS + 1
            IF ( NOSIGNS .LE. 2 ) THEN
               GO TO 10
            ELSE
               WRITE( MSG, 94040 ) 
               CALL M3MESG( MSG )
               WRITE( MSG, 94500 ) LINNUM, INBUF
               CALL M3MESG( MSG )
               WRITE( MSG, 94520 ) INBUF( START:LPOINT )
               CALL M3MESG( MSG )
               CALL M3EXIT( 'GETREAL', IZERO, IZERO, ' ', XSTAT2 )
            END IF
         END IF

c..End of the numeric string; convert to real number
         NUMSTRING = INBUF( START:LPOINT-1 )
         LENGTH = LENGTH - 1
         IF ( ( .NOT. LEXP ) .AND. ( .NOT. LDECIMAL ) ) THEN
            NUMSTRING = NUMSTRING( 1:LENGTH ) // '.'
            LENGTH = LENGTH + 1
         END IF

         READ( NUMSTRING( 1:LENGTH ), '( E20.6 )', ERR = 999 ) NUMBER
         IF ( LPOINT .GT. IEOL ) CALL RDLINE
         IF ( CHR .EQ. ' ' ) CALL GETCHR

         RETURN

c..Error converting numeric string to real number
999      CONTINUE
         WRITE( MSG, 94060 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) INBUF( START:LPOINT )
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETREAL', IZERO, IZERO, ' ', XSTAT2 )
         
94000    FORMAT( 'ERROR: Two decimal points found in a numeric field' )
94020    FORMAT( 'ERROR: More than one E or e found in a numeric field' )
94040    FORMAT( 'ERROR: Too many + or - signs found in a numeric field' )
94060    FORMAT( 'ERROR: Numeric field contains an invalid character' )
94500    FORMAT( '          Line No. ', I4, ': ', A )
94520    FORMAT( '          Numeric field: ', A )

         END SUBROUTINE PA_GETREAL

C=======================================================================
         SUBROUTINE GETLABEL

C.......................................................................
C Function: get all characters except blanks between the
C              delimiters <> or []. Line wrap is allowed. The maximum
C              label length is sixteen characters.
                
C Key Subroutines/Functions Called: EATCOM, GETCHR
C.......................................................................
 
         USE UTILIO_DEFN

         IMPLICIT NONE
         
C Local Variables:
         CHARACTER( 1 ) :: BEGCHR   ! Starting delimiter for label
         CHARACTER( 1 ) :: ENDCHR   ! Ending delimiter for label

         INTEGER LENGTH    ! Length of label
C.......................................................................
            
c..Set beginning and and ending characters delineating the label
         LABEL  = ''
         LENGTH = 0
         IF ( CHR .EQ. '<' ) THEN
            BEGCHR = '<'
            ENDCHR = '>'
         ELSE
            BEGCHR = '['
            ENDCHR = ']'
         END IF
 
c..top of loop for getting next character
20       CONTINUE
         CALL GETCHR

c..if the end of the label has not been reached, store the character
         IF ( CHR .NE. ENDCHR ) THEN
            IF ( CHR .EQ. '(' .OR. CHR .EQ. '{' ) CALL EATCOM
            LENGTH = LENGTH + 1 
            IF ( LENGTH .GT. 16 ) THEN
               WRITE( MSG, 94000 ) 
               CALL M3MESG( MSG )
               WRITE( MSG, 94020 ) LINNUM, INBUF
               CALL M3MESG( MSG )
               WRITE( MSG, 94040 ) BEGCHR, LABEL
               CALL M3MESG( MSG )
               CALL M3EXIT( 'PA_GETLABEL', IZERO, IZERO, ' ', XSTAT2 )
            END IF
            LABEL( LENGTH : LENGTH ) = CHR
            GO TO 20
         END IF

         CALL GETCHR

         RETURN
         
94000    FORMAT( 'ERROR: A Reaction label or operator option exceeds 16',
     &                 ' characters' )
94020    FORMAT( '          Line No. ', I4, ': ', A )
94040    FORMAT( '          Label found : ', A, A )

         END SUBROUTINE GETLABEL

C=======================================================================
         SUBROUTINE GETQUOTE

C.......................................................................
C Function: get all characters between apostrophes. 
C           Embedded apostrophes indicated by double apostrophes.
C           Line wrap is allowed.
  
C Key Subroutines/Functions Called: RDLINE, GETCHR
C.......................................................................
 
         USE UTILIO_DEFN

         IMPLICIT NONE
         
C Local Variables:
         CHARACTER(   1 ) :: APOS = ''''  ! Apostrophe (') character
         CHARACTER( 132 ) :: STRING       ! Holder for qoute

         INTEGER LENGTH    ! Length of quote
         INTEGER NXTPOS    ! Next character position in input buffer

         LOGICAL LCONT     ! Flag to continue parsing input buffer
C.......................................................................

         LENGTH = 0

c..Top of loop for reading quote
20       CONTINUE
         LPOINT = LPOINT + 1

c..get the next line if necessary
         IF ( LPOINT .GT. IEOL ) THEN
            CALL RDLINE
            CALL GETCHR
         END IF

c..get the next character
         CHR = INBUF( LPOINT:LPOINT )

c..check for leading/endiung double apostrophes and get the next character
         IF ( CHR .NE. APOS ) THEN
            LCONT = .TRUE.
         ELSE
            IF ( LPOINT + 1 .GT. IEOL ) THEN
               CALL RDLINE
               NXTPOS = 1
            ELSE
               NXTPOS = LPOINT + 1
            END IF
            IF ( INBUF( NXTPOS : NXTPOS ) .EQ. APOS ) THEN
               LCONT  = .TRUE.
               LPOINT = LPOINT + 1
               CHR = INBUF( LPOINT:LPOINT )
            ELSE
               LCONT = .FALSE.
               CALL GETCHR
            END IF
         END IF

c..if continuing, add current character to the output string if 
c..length is OK
         IF ( LCONT ) THEN               
            LENGTH = LENGTH + 1
            IF ( LENGTH .GT. 132 ) THEN
               WRITE( MSG, 94000 ) 
               CALL M3MESG( MSG )
               WRITE( MSG, 94020 ) LINNUM, INBUF
               CALL M3MESG( MSG )
               CALL M3EXIT( 'PA_GETQUOTE', IZERO, IZERO, ' ', XSTAT2 )
            END IF

            IF ( LENGTH .EQ. 1 ) THEN
               STRING( 1:1 ) = CHR
            ELSE
               STRING( 1:LENGTH ) = STRING( 1:LENGTH-1 ) // CHR
            END IF     
            GO TO 20
         END IF

c..Linit output string to 60 characters
         LENGTH = MIN( LENGTH, 60 )
         QUOTE = STRING( 1:LENGTH )

         RETURN

94000    FORMAT( 'ERROR: Quote exceeds maximum allowable 132 characters' )
94020    FORMAT( '         Line No. ', I4, ': ', A )

         END SUBROUTINE GETQUOTE

C=======================================================================
         SUBROUTINE CATSTRING( NUMSTRNGS, STRING, STROUT, MAXLEN )

C.......................................................................
C Function: Concatenate a series of strings, eliminating trailing
C           blanks, but leaving a space between each string 
C.......................................................................

         IMPLICIT NONE
         
C Arguments:
         INTEGER NUMSTRNGS              ! Number of strings to concatenate
         CHARACTER( * ) :: STRING( * )  ! Strings to concatenate 
         CHARACTER( * ) :: STROUT       ! Concatenated string output
         INTEGER MAXLEN                 ! Maximum length of output string
                                           
C Local Variables:
         INTEGER LPOS       ! Last position in output string
         INTEGER N          ! Loop index for number of strings to concatenate
         INTEGER NEWLEN     ! Length of string to be concatenated
         LOGICAL LRETURN    ! Flag to return because of truncation
C.......................................................................

         LRETURN = .FALSE.
         STROUT = STRING( 1 )
         LPOS = LEN_TRIM( STRING( 1 ) ) + 1
         IF ( NUMSTRNGS .EQ. 1 ) RETURN
         DO N = 2, NUMSTRNGS
            NEWLEN = LEN_TRIM( STRING( N ) )
            IF ( ( LPOS + NEWLEN ) .GE. MAXLEN ) THEN
               NEWLEN = MAXLEN - LPOS
               WRITE( MSG, 94000 ) 
               CALL M3MESG( MSG )
               LRETURN = .TRUE.
            END IF
            STROUT = STROUT( 1:LPOS ) // STRING( N )( 1:NEWLEN )
            IF ( LRETURN ) THEN
               RETURN
            ELSE
               LPOS = LPOS + NEWLEN + 1
            END IF
         END DO
         DO N = 1, NUMSTRNGS
            STRING( N ) = ''
         END DO

         RETURN
         
94000    FORMAT( 1X,'WARNING: A string has been truncated because of ',
     &              'excessive length in concatenation' )

         END SUBROUTINE CATSTRING

      END MODULE PA_PARSE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_COMPMECH

C-----------------------------------------------------------------------
C Function: To produce a compressed mechanism structure for the PA
C           output listing program
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Dec. 7, 2000 by Jerry Gipson to correct problem in getting
C  character length of a species name used in the compressed mechanism
C  Modified May 2002 by Jerry Gipson to increase number of reaction lines
C  (for saprc99)
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI's M3UTILIO
C  Jul 2016 Jeff Young: Inline Function TRIMCOEF; fix bug if 5 dec. pt. coeff
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------

      USE UTILIO_DEFN   
      USE PA_GLOBAL     ! Mech data used 
      USE PA_VARS
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
C Arguments: None
C Parameters: None
C External Functions: None

C Local Variables:
      CHARACTER( 72 ) :: LINOUT  ! line of mechanism text
      CHARACTER( 10 ) :: COUT    ! Coefficient in character representation
      CHARACTER(  1 ) :: SIGNC   ! Sign character
      CHARACTER( 16 ) :: SPCNAM  ! Species name
      CHARACTER( LABLEN ) :: TEMPSTR  ! Temporary holder of right-justified label

      INTEGER COUTLEN  ! Length of character based coefficient
      INTEGER ENDPOS   ! Ending position on line for next product
      INTEGER EQPOS    ! Position of equals sign
      INTEGER EXPOS    ! Exclamation point position 
      INTEGER IE1, IE2 ! Ending position of characters in a string
      INTEGER IEND     ! Position of last non-blank character in LINOUT
      INTEGER INDX     ! Index for species name
      INTEGER IS1, IS2 ! Starting position of characters in a string
      INTEGER ISTAR    ! Counter for sign
      INTEGER LEN1     ! Actual label length
      INTEGER :: LINLEN = 72   ! Max length of line of mechanism text
      INTEGER MAXLEN   ! Max length of a label on output
      INTEGER NRX      ! Loop index for reactions
      INTEGER N        ! Loop index
      INTEGER NFAM     ! Loop index for familys 
      INTEGER OUTLEN   ! Number of characters in output string

      REAL SPCOEF      ! Single Precision coefficient

C-----------------------------------------------------------------------
      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Find the longest reaction label length and trim to six characters
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      MAXLEN = 0
      DO NRX = 1, NRXNS
         MAXLEN = MAX( MAXLEN, LEN_TRIM( RXLABEL( NRX ) ) )
      END DO
      IF ( MAXLEN .GT. 6 ) MAXLEN = 6

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Set the compressed mechanism list for each reaction
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO 100 NRX = 1, NRXNS

c..First get the reaction label right justified
                  !123456789012345678901234 
         LINOUT = '     &              IRR<'
         IEND = LEN_TRIM( LINOUT )
         DO N = 1, LABLEN
            TEMPSTR( N:N ) = ' '
         END DO
         IS1 = LBLANK( RXLABEL( NRX ) ) + 1
         IE1 = LEN_TRIM( RXLABEL( NRX ) )
         LEN1 = IE1 - IS1 + 1
         LEN1 = MIN( MAXLEN, LEN1 )
         IE1 = IS1 + LEN1 - 1
         IE2 = LABLEN
         IS2 = LABLEN - LEN1 + 1
         TEMPSTR( IS2:IE2 ) = RXLABEL( NRX )( IS1:IE1 ) 
         IS2 = LABLEN - MAXLEN + 1          
         LINOUT = LINOUT( 1 : IEND ) // TEMPSTR( IS2:IE2 ) // '> !'
         IEND = LEN_TRIM( LINOUT ) + 1
         EXPOS = IEND - 1
          
c..List reactants
         DO N = 1, NREACT( NRX )
            INDX = IRR( NRX, N )
            SPCNAM = CHEMISTRY_SPC( INDX )
            OUTLEN = MIN( 6, LEN_TRIM( SPCNAM ) )
            IF ( N .EQ. 1 ) THEN
               LINOUT = LINOUT( 1:IEND ) // SPCNAM( 1:OUTLEN )
            ELSE
               LINOUT = LINOUT( 1:IEND ) // '+' // 
     &                  SPCNAM( 1:OUTLEN )
            END IF
            IEND = LEN_TRIM( LINOUT )
         END DO

c..Add hv, H2O, M, N2 or O2
         IF ( BTEST( IRXBITS( NRX ), 1 ) ) THEN
            LINOUT = LINOUT( 1:IEND ) // '+hv'
            IEND = LEN_TRIM( LINOUT )
         END IF
         IF ( BTEST( IRXBITS( NRX ), 2 ) ) THEN
            LINOUT = LINOUT( 1:IEND ) // '+M'
            IEND = LEN_TRIM( LINOUT )
         END IF
         IF ( BTEST( IRXBITS( NRX ), 3 ) ) THEN
            LINOUT = LINOUT( 1:IEND ) // '+H2O'
            IEND = LEN_TRIM( LINOUT )
         END IF
         IF ( BTEST( IRXBITS( NRX ), 4 ) ) THEN
            LINOUT = LINOUT( 1:IEND ) // '+O2'
            IEND = LEN_TRIM( LINOUT )
         END IF
         IF ( BTEST( IRXBITS( NRX ), 5 ) ) THEN
            LINOUT = LINOUT( 1:IEND ) // '+N2'
            IEND = LEN_TRIM( LINOUT )
         END IF
         EQPOS = IEND + 1                
         LINOUT = LINOUT( 1:IEND ) // '='
         IEND = IEND + 1               

c..List products
         LINNUM = 1
         DO N = 1, NPRDCT( NRX )
            INDX = IRR( NRX,N + 3 )
            SPCNAM = CHEMISTRY_SPC( INDX )
            OUTLEN = MIN( 6, LEN_TRIM( SPCNAM ) )
            SPCOEF = SC( NRX,N )
            IF ( SPCOEF .NE. 1.0 ) THEN
               COUT = TRIMCOEF( SPCOEF )
               COUTLEN = LEN_TRIM( COUT )
               ISTAR = 1
            ELSE
               COUTLEN = 0
               ISTAR = 0
            END IF                
            ENDPOS = IEND + 1 + COUTLEN + OUTLEN
            IF ( ENDPOS .GT. LINLEN ) THEN
               MECLINE( NRX,LINNUM ) = LINOUT
               LINNUM = LINNUM + 1
               IF ( LINNUM .GT. MXMECHLINE ) THEN
                  WRITE( MSG, 94000 )
                  CALL M3MESG( MSG )
                  CALL M3EXIT( 'MECHCOMP', IZERO, IZERO, ' ', XSTAT2 )
               END IF
               LINOUT = ''
               LINOUT( 1:1 ) = ' '
               LINOUT( EXPOS:EXPOS ) = '!'
               IEND = EXPOS + 6
            END IF
            IF ( SPCOEF .LT. 0.0 ) THEN
               SIGNC = '-'
            ELSE
               SIGNC = '+'
            END IF
            IF ( N .NE. 1 .OR. SIGNC .EQ. '-' ) THEN
               LINOUT = LINOUT( 1:IEND ) // SIGNC
               IEND = IEND + 1
            END IF
            IF ( SPCOEF .EQ. 1.0 ) THEN
               LINOUT = LINOUT( 1:IEND ) // SPCNAM( 1:OUTLEN )
            ELSE
               LINOUT = LINOUT( 1:IEND ) // COUT( 1:COUTLEN ) //
     &                 '*' // SPCNAM( 1:OUTLEN )
            END IF
            IEND = LEN_TRIM( LINOUT )
         END DO             
         MECLINE( NRX, LINNUM ) = LINOUT 
         MECNUMLNS( NRX ) = LINNUM 
100   CONTINUE      

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Now get a compressed list of Family definitions
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO 200 NFAM = 1, NFAMLYS
         IEND = LEN_TRIM( FAMNAME( NFAM ) )
         LINOUT = '     ' // FAMNAME( NFAM )( 1:IEND ) // '='
         IEND = LEN_TRIM( LINOUT )
         EQPOS = IEND
         LINNUM = 1
         DO N = 1, NUMFAMMEM( NFAM )
            SPCNAM = FAMMEMNAM( NFAM, N )
            OUTLEN = MIN( 6, LEN_TRIM( SPCNAM ) )
            IF ( FAMSC( NFAM, N ) .NE. 1.0 ) THEN
               COUT = TRIMCOEF( FAMSC( NFAM, N ) )  
               COUTLEN = LEN_TRIM( COUT )
               ISTAR = 1
            ELSE
               COUTLEN = 0
               ISTAR = 0
            END IF             
            ENDPOS = IEND + 1 + COUTLEN + OUTLEN
            IF ( ENDPOS .GT. LINLEN ) THEN
               FAMLINE( NFAM, LINNUM ) = LINOUT
               LINNUM = LINNUM + 1
               IF ( LINNUM .GT. MXFAMLINE ) THEN
                   WRITE( MSG, 94020 )
                   CALL M3MESG( MSG )
                   CALL M3EXIT( 'MECHCOMP', IZERO, IZERO, ' ', XSTAT2 )
               END IF
               LINOUT = ''
               LINOUT( 1:1 ) = ' '
               IEND = EQPOS
            END IF
            IF ( FAMSC( NFAM, N ) .LT. 0.0 ) THEN
               SIGNC = '-'
            ELSE
               SIGNC = '+'
            END IF
            IF ( N .NE. 1 .OR. SIGNC .EQ. '-' ) THEN
               LINOUT = LINOUT( 1:IEND ) // SIGNC
               IEND = IEND + 1
            END IF
            IF ( FAMSC( NFAM, N ) .EQ. 1.0 ) THEN
               LINOUT = LINOUT( 1:IEND ) // SPCNAM( 1:OUTLEN )
            ELSE
               LINOUT = LINOUT( 1:IEND ) // COUT( 1:COUTLEN ) //
     &                  '*' // SPCNAM( 1:OUTLEN )
            END IF
            IEND = LEN_TRIM( LINOUT )
         END DO    
         FAMLINE( NFAM, LINNUM ) = LINOUT 
         FAMNUMLNS( NFAM ) = LINNUM 
200   CONTINUE

C----------------------- FORMAT Statements -----------------------------
94000 FORMAT( 'ERROR: Maximum number of lines for compressed',
     &          ' mechanism exceeded' )
94020 FORMAT( 'ERROR: Maximum number of lines for compressed',
     &          ' family definition exceeded' )
C-----------------------------------------------------------------------

      RETURN

      CONTAINS

         FUNCTION TRIMCOEF( COEFF ) RESULT( CHRCOEF )

C-----------------------------------------------------------------------
C Function: Convert a real number to character representation using
C           the fewest number of characters  
C-----------------------------------------------------------------------
 
         IMPLICIT NONE
         
C Arguments:
         REAL   COEFF                ! Real number to convert
         CHARACTER( 10 ) :: CHRCOEF  ! Character coefficient holder

C Local Variables:
         INTEGER COEFLEN    ! Max number of characters in coefficient
         INTEGER ENDPOS     ! Position of last significant haracter
         INTEGER SPOS       ! Position of first significant character
         INTEGER OFFSET     ! Justification offset
         INTEGER POS        ! Loop index for string position

C-----------------------------------------------------------------------

         WRITE( CHRCOEF, '( F10.5 )' ) COEFF
         COEFLEN = 10

c..Strip Trailing zeroes
         ENDPOS = COEFLEN
         DO POS = COEFLEN, 6, -1
             IF ( CHRCOEF( POS:POS ) .EQ. '0' ) THEN
                ENDPOS = POS
                CHRCOEF( POS:POS ) = ' '
             ELSE
                GO TO 40
             END IF
         END DO
40       CONTINUE

c..Strip decimal point if not needed
         IF ( ENDPOS .EQ. 6 ) THEN 
            CHRCOEF( 5:5 ) = ' '
            ENDPOS = ENDPOS - 1
         END IF

c..Strip leading any leading signs
         DO POS = 1, 3
            IF ( CHRCOEF( POS:POS ) .EQ. '+' .OR. 
     &           CHRCOEF( POS:POS ) .EQ. '-' ) THEN
              CHRCOEF( POS:POS ) = ' '
              GO TO 80
            END IF
         END DO
80       CONTINUE
               
c..Strip any leading zeros          
         IF ( ABS( COEFF ) .GT. 0.0 .AND. COEFF .LT. 1.0 ) THEN
            DO POS = 4, 1, -1
               IF ( CHRCOEF( POS:POS ) .EQ. '0' )
     &              CHRCOEF( POS:POS ) = ' '
            END DO
         END IF

c..Left justify character string and return
         DO POS = 1, COEFLEN
            IF ( CHRCOEF( POS:POS ) .NE. ' ' ) THEN
               SPOS = POS
               GO TO 120
            END IF
         END DO
120      CONTINUE

         OFFSET = SPOS - 1

         DO POS = 1, COEFLEN
            IF ( POS + OFFSET .LE. ENDPOS ) THEN
               CHRCOEF( POS:POS ) = CHRCOEF( POS+OFFSET:POS+OFFSET )
            ELSE
               CHRCOEF( POS:POS ) = ' '
            END IF
         END DO

         RETURN
         END FUNCTION TRIMCOEF

      END SUBROUTINE PA_COMPMECH

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE ACMCLD ( NSP, NLAYS, F, C, DZH, CBELOW, CLBASE, CLTOP,
     &                    FRAC, TCLIFE, DTCLD )
C-----------------------------------------------------------------------
C
C  FUNCTION:  Subroutine to compute convective mixing in the CBL
C             according to the Asymmetrical Convective Model (ACM).
C             Ref: Pleim and Chang (1992)
C
C  SUMMARY:
C   ACM is based on the Blackadar non-local convective model which is
C   used in HIRPBL where upward mixing similar to Blackadar but
C   downward mixing is to the next lower level representing more
C   realistic gradual subsidence.
C
C  REVISION  HISTORY:
C      Date   Who             What
C    -------- ---             -----------------------------------------
C     06/2005 J.Pleim         Initial version
C     07/2005 J.Young         Clean up for CMAQ-F
C     05/2015 J.Young         Clean up for CMAQv5.1
C     01/2018 J.Pleim         Convert from sigma to Z for MPAS
C-----------------------------------------------------------------------\

      IMPLICIT NONE

C Arguments

      INTEGER, INTENT( IN ) :: NSP            ! no. of species
      INTEGER, INTENT( IN ) :: NLAYS          ! no. of model layers
      REAL, INTENT( IN )    :: F( : )         ! entrainment fraction
      REAL, INTENT( INOUT ) :: C( :, : )      ! species concentration
      REAL, INTENT( IN )    :: DZH( : )
      REAL, INTENT( INOUT ) :: CBELOW( : )    ! spec conc in layer below cld base
      INTEGER, INTENT( IN ) :: CLBASE
      INTEGER, INTENT( IN ) :: CLTOP
      REAL, INTENT( IN )    :: FRAC           ! grid cell fractional cloud cover
      REAL, INTENT( IN )    :: TCLIFE         ! cloud lifetime (s)
      REAL, INTENT( IN )    :: DTCLD          ! cloud integration time step

C Parameters

      REAL, PARAMETER :: HALF = 0.5
      REAL, PARAMETER :: CRANKP = 0.5

C Local variables

      INTEGER NLP, K, NL, S          ! index variables
      INTEGER KB

      REAL DTLIM, F1
      REAL DTS, DELC, M1UP
      REAL( 8 ), ALLOCATABLE, SAVE :: AI( : ), BI( : ), EI( : )
      REAL( 8 ), ALLOCATABLE, SAVE :: DI( : ), UI( : )
      REAL( 8 ) :: ALPHA, BETA, GAMA
      REAL, ALLOCATABLE, SAVE :: VCI( :,: )
      REAL, ALLOCATABLE, SAVE :: MBARKS( : ), MDWN( : )

!--Local Arrays for MPAS implementation
      REAL, ALLOCATABLE, SAVE     :: DZHI  ( : )               ! 1/DZH

      INTEGER :: ALLOCSTAT
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER (LEN = 80) :: XMSG

C-----------------------------------------------------------------------

      IF (FIRSTIME) THEN
         ALLOCATE (AI( NLAYS ), 
     &             BI( NLAYS ), 
     &             EI( NLAYS ),
     &             DI( NLAYS ), 
     &             UI( NLAYS ),
     &             VCI( NLAYS,NSP ),
     &             MBARKS( NLAYS ), 
     &             MDWN( NLAYS ),
     &             DZHI  ( NLAYS ),
     &             STAT=ALLOCSTAT)
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'EXIT: Failure allocating AI, BI, EI, DI, UI, VCI, MBARKS, MDWN or DZHI'
            write (6, *) trim(xmsg); stop
         END IF
         FIRSTIME = .FALSE. 
      END IF

      DTLIM = DTCLD
      MDWN ( CLTOP + 1 ) = 0.0
      M1UP = 0.0
      DZHI = 1.0 / DZH ! array assignment
      KB  = CLBASE - 1
      DZHI( KB ) = 1.0 / DZH( KB )

C Compute ACM mixing rate

      DO K = CLTOP, CLBASE, -1
        MBARKS( K ) = ( 1.0 - F( K ) ) * FRAC / TCLIFE
        MDWN  ( K ) = MBARKS( K ) + MDWN( K + 1 ) * DZH( K + 1 ) * DZHI( K )
        M1UP  = M1UP + MBARKS( K ) * DZH( K )
        DTLIM = MIN( HALF / ( M1UP * DZHI( K ) ), DTLIM )
      END DO
      DTLIM = MIN( HALF / ( M1UP * DZHI( KB ) ), DTLIM )

      DO S = 1, NSP
        VCI( KB, S ) = CBELOW( S )
        VCI( CLTOP+1,S ) = 9999.0
        DO K = CLBASE, CLTOP
          VCI( K,S ) = C( S,K )
          UI( K )  = 0.0           ! init variable for use below
        END DO
      END DO

      NLP = INT( DTCLD / DTLIM + 1.0 )
      DTS = ( DTCLD / NLP )
      DO 2000 NL = 1, NLP      ! loop over sub timestep
        DO 1000 S = 1, NSP     ! loop over species
                                                                              
C Compute tendency of CBL concentrations - Semi-Implicit solution

          DO K = CLBASE, CLTOP
            DELC = DTS
     &           * ( MBARKS( K ) * VCI( KB,S )
     &           -   MDWN( K ) * VCI( K,S )
     &           +   DZH( K+1 ) * DZHI( K ) * MDWN( K+1 ) * VCI( K+1,S ) )
            DI( K ) = VCI( K,S ) + ( 1.0 - CRANKP ) * DELC
            EI( K ) = -CRANKP * MDWN( K ) * DTS * DZH( K ) * DZHI( K-1 )
            BI( K ) = 1.0 + CRANKP * MDWN( K ) * DTS
            AI( K ) = -CRANKP * MBARKS( K ) * DTS
          END DO

          BI( KB ) = 1.0 + CRANKP * M1UP * DTS * DZHI( KB )
          F1 = M1UP * VCI( KB,S )
     &       - MDWN( CLBASE ) * VCI( CLBASE,S ) * DZH( CLBASE )
          DI( KB ) = VCI( KB,S ) - ( 1.0 - CRANKP ) * F1 * DZHI( KB ) * DTS

C Define arrays A,B,E which make up matrix and D which is RHS

          BETA = DI( KB )
          GAMA = BI( KB )
          ALPHA = 1.0
          DO K = CLBASE, CLTOP
            ALPHA = -ALPHA * EI( K ) / BI( K )
            BETA  = ALPHA * DI( K ) + BETA
            GAMA  = ALPHA * AI( K ) + GAMA
          END DO
          UI( KB )   = BETA / GAMA
          UI( CLTOP ) = ( DI( CLTOP ) - AI( CLTOP ) * UI( KB ) ) / BI( CLTOP )

          BETA = DI( KB )
          GAMA = BI( KB )
          ALPHA = 1.0

C Back substitution:
          DO K = CLTOP - 1, CLBASE, -1
            UI( K ) = ( DI( K ) - AI( K ) * UI( KB ) - EI( K+1 ) * UI( K+1 ) )
     &              / BI( K )
          END DO

C Update concentrations
          DO K = KB, CLTOP
            VCI( K,S ) = REAL( UI( K ), 4 )
          END DO

1000    CONTINUE   ! end loop for species
2000  CONTINUE   ! end timestep loop

      DO S = 1, NSP

        CBELOW( S ) = VCI( KB,S )

        DO K = CLBASE, CLTOP
          C( S,K ) = VCI( K,S )
        END DO

      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CKSUMMER ( SCIPROC, CGRID, JDATE, JTIME )

C Function:
C     Sum concentrations over entire grid.

C Revision History:
C   Original version ???
C   2 October, 1998 by Al Bourgeois at LM: parallel implementation
C         and fix bug by SAVEing DEVNAME.

C   1/22/99 David Wong at LM: compute global sum for variables: GC_CKSUM,
C                             AE_CKSUM, NR_CKSUM, and TR_CKSUM

C   1/28/99 David Wong at LM: compute global sum for GCELLS

C   15 Dec 00 J.Young: move CGRID_MAP into f90 module
C                      GLOBAL_RSUM -> Dave Wong`s f90 stenex GLOBAL_SUM
C   Jeff - Feb 01 - assumed shape arrays
C   23 Mar 01 J.Young: Use HGRD_DEFN
C   31 May 02 J.Young: REAL*8 reduction accumulator (avoid 32 bit roundoff)
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C    4 Feb 08 J.Young: checksums based on local processor
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   10 Aug 11 David Wong: reset output format 1PEw.d to meet the standard
C                         w-d > 6
C    9 Apr 15 J.Bash: Use F90 MINVAL to speed up execution
C   18 Mar 16 J.Young: Add "INTENT" attribute; remove commented out code;
C                      rearrange logic for efficiency
C-----------------------------------------------------------------------

      USE GRID_CONF, ONLY:  NCOLS, NROWS, NLAYS
      USE CGRID_SPCS, ONLY: N_GC_SPC, GC_STRT, GC_SPC, 
     &                      N_AE_SPC, AE_STRT, AE_SPC,
     &                      N_NR_SPC, NR_STRT, NR_SPC,
     &                      N_TR_SPC, TR_STRT, TR_SPC
      USE RUNTIME_VARS, ONLY: LOGDEV, OUTDEV, CMYPE, APPL_NAME

      USE UTILIO_DEFN
#ifndef mpas
#ifdef parallel
      USE SE_MODULES          ! stenex (using SE_GLOBAL_SUM_MODULE)
#else
      USE NOOP_MODULES        ! stenex (using NOOP_GLOBAL_SUM_MODULE)
#endif
#endif

      IMPLICIT NONE

C Arguments:

      CHARACTER( * ), INTENT( IN ) :: SCIPROC  ! science process name
      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME        ! current model time, coded HHMMSS

C Parameters:

      REAL, PARAMETER :: CMIN = 0.0

C Local variables:
 
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      CHARACTER( 16 ), SAVE :: PNAME = 'CKSUMMER'
      CHARACTER(  6 ) :: PRESTR = 'FLOOR_'
      CHARACTER( 96 ), SAVE :: DEVNAME ! Name of output file.

      INTEGER, SAVE :: FLOORDEV    ! FORTRAN unit number for neg conc ascii file

      LOGICAL ::  RDONLY = .FALSE.
      LOGICAL ::  FMTTED = .TRUE.

      INTEGER     S, V, L, C, R
      REAL( 8 ) :: DBL_CKSUM
      REAL         GC_CKSUM, AE_CKSUM, NR_CKSUM, TR_CKSUM
      REAL, SAVE :: LCELLS

      LOGICAL, SAVE :: OPFLG = .TRUE.               ! open file flag
      LOGICAL     EXFLG                             ! write header flag

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         LCELLS = FLOAT( NCOLS * NROWS * NLAYS )
         DEVNAME = PRESTR // CMYPE // '.' // TRIM( APPL_NAME )

      END IF

      IF ( MINVAL( CGRID ) .LT. CMIN ) THEN

         EXFLG = .TRUE.

         DBL_CKSUM = 0.0
         IF ( N_GC_SPC .GT. 0 ) THEN

            V = 0
            DO S = GC_STRT, GC_STRT - 1 + N_GC_SPC
               V = V + 1
               DO L = 1, NLAYS
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        DBL_CKSUM = DBL_CKSUM + CGRID( C,R,L,S )
                        IF ( CGRID( C,R,L,S ) .LT. CMIN ) THEN
                           IF ( EXFLG ) THEN
                              EXFLG = .FALSE.
                              IF ( OPFLG ) THEN   ! open output ASCII file
                                 OPFLG = .FALSE.
                                 FLOORDEV = GETEFILE ( DEVNAME, RDONLY, FMTTED, PNAME )
                              END IF
                              WRITE( FLOORDEV,1001 ) CMIN, SCIPROC
                           END IF
                           WRITE( FLOORDEV,1003 ) JDATE, JTIME, C, R, L, S,
     &                                          GC_SPC( V ), CGRID( C,R,L,S )
                           CGRID( C,R,L,S ) = CMIN
                        END IF
                     END DO
                  END DO
               END DO
            END DO

            GC_CKSUM = REAL( DBL_CKSUM, 4 )
 
         ELSE

            GC_CKSUM = 0.0
 
         END IF
     
         DBL_CKSUM = 0.0
         IF ( N_AE_SPC .GT. 0 ) THEN

            V = 0
            DO S = AE_STRT, AE_STRT - 1 + N_AE_SPC
               V = V + 1
               DO L = 1, NLAYS
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        DBL_CKSUM = DBL_CKSUM + CGRID( C,R,L,S )
                        IF ( CGRID( C,R,L,S ) .LT. CMIN ) THEN
                           IF ( EXFLG ) THEN
                              EXFLG = .FALSE.
                              IF ( OPFLG ) THEN   ! open output ASCII file
                                 OPFLG = .FALSE.
                                 FLOORDEV = GETEFILE ( DEVNAME, RDONLY, FMTTED, PNAME )
                              END IF
                              WRITE( FLOORDEV,1001 ) CMIN, SCIPROC
                           END IF
                           WRITE( FLOORDEV,1003 ) JDATE, JTIME, C, R, L, S,
     &                                          AE_SPC( V ), CGRID( C,R,L,S )
                           CGRID( C,R,L,S ) = CMIN
                        END IF
                     END DO
                  END DO
               END DO
            END DO

            AE_CKSUM = REAL( DBL_CKSUM, 4 )
  
         ELSE

            AE_CKSUM = 0.0
 
         END IF

         DBL_CKSUM = 0.0
         IF ( N_NR_SPC .GT. 0 ) THEN
 
            V = 0
            DO S = NR_STRT, NR_STRT - 1 + N_NR_SPC
               V = V + 1
               DO L = 1, NLAYS
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        DBL_CKSUM = DBL_CKSUM + CGRID( C,R,L,S )
                        IF ( CGRID( C,R,L,S ) .LT. CMIN ) THEN
                           IF ( EXFLG ) THEN
                              EXFLG = .FALSE.
                              IF ( OPFLG ) THEN   ! open output ASCII file
                                 OPFLG = .FALSE.
                                 FLOORDEV = GETEFILE ( DEVNAME, RDONLY, FMTTED, PNAME )
                              END IF
                              WRITE( FLOORDEV,1001 ) CMIN, SCIPROC
                           END IF
                           WRITE( FLOORDEV,1003 ) JDATE, JTIME, C, R, L, S,
     &                                          NR_SPC( V ), CGRID( C,R,L,S )
                           CGRID( C,R,L,S ) = CMIN
                        END IF
                     END DO
                  END DO
               END DO
            END DO

            NR_CKSUM = REAL( DBL_CKSUM, 4 )
  
         ELSE

            NR_CKSUM = 0.0
 
         END IF
     
         DBL_CKSUM = 0.0
         IF ( N_TR_SPC .GT. 0 ) THEN
 
            V = 0
            DO S = TR_STRT, TR_STRT - 1 + N_TR_SPC
               V = V + 1
               DO L = 1, NLAYS
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        DBL_CKSUM = DBL_CKSUM + CGRID( C,R,L,S )
                        IF ( CGRID( C,R,L,S ) .LT. CMIN ) THEN
                           IF ( EXFLG ) THEN
                              EXFLG = .FALSE.
                              IF ( OPFLG ) THEN   ! open output ASCII file
                                 OPFLG = .FALSE.
                                 FLOORDEV = GETEFILE ( DEVNAME, RDONLY, FMTTED, PNAME )
                              END IF
                              WRITE( FLOORDEV,1001 ) CMIN, SCIPROC
                           END IF
                           WRITE( FLOORDEV,1003 ) JDATE, JTIME, C, R, L, S,
     &                                          TR_SPC( V ), CGRID( C,R,L,S )
                           CGRID( C,R,L,S ) = CMIN
                        END IF
                     END DO
                  END DO
               END DO
            END DO

            TR_CKSUM = REAL( DBL_CKSUM, 4 )
  
         ELSE

            TR_CKSUM = 0.0
 
         END IF

      ELSE   ! MINVAL( CGRID ) .GE. CMIN

         GC_CKSUM = SUM( CGRID( :,:,:,GC_STRT : ( GC_STRT - 1 + N_GC_SPC ) ) ) 
         AE_CKSUM = SUM( CGRID( :,:,:,AE_STRT : ( AE_STRT - 1 + N_AE_SPC ) ) ) 
         NR_CKSUM = SUM( CGRID( :,:,:,NR_STRT : ( NR_STRT - 1 + N_NR_SPC ) ) ) 
         IF ( N_TR_SPC .GT. 0 ) THEN
            TR_CKSUM = SUM( CGRID( :,:,:,TR_STRT : ( TR_STRT - 1 + N_TR_SPC ) ) ) 
         END IF
     
      END IF

      IF ( N_TR_SPC .EQ. 0 ) THEN
         WRITE( LOGDEV,1005 ) SCIPROC,
     &                        GC_CKSUM / LCELLS,
     &                        AE_CKSUM / LCELLS,
     &                        NR_CKSUM / LCELLS
         IF ( ( GC_CKSUM .NE. GC_CKSUM ) .OR. ( GC_CKSUM*2. .EQ. GC_CKSUM ) .OR.
     &        ( AE_CKSUM .NE. AE_CKSUM ) .OR. ( AE_CKSUM*2. .EQ. AE_CKSUM ) .OR.
     &        ( NR_CKSUM .NE. NR_CKSUM ) .OR. ( NR_CKSUM*2. .EQ. NR_CKSUM ) ) THEN
              WRITE( OUTDEV, '(7x,A,A)' ),'NaN or Infinity detected on processor ',TRIM(CMYPE)
              WRITE( OUTDEV,1008 ) SCIPROC,GC_CKSUM/LCELLS,AE_CKSUM/LCELLS,NR_CKSUM/LCELLS
              CALL M3EXIT( PNAME, jdate, jtime,'NaN or Infinity detected in '//SCIPROC, 1 )
         END IF
 
      ELSE
         WRITE( LOGDEV,1007 ) SCIPROC,
     &                        GC_CKSUM / LCELLS,
     &                        AE_CKSUM / LCELLS,
     &                        NR_CKSUM / LCELLS,
     &                        TR_CKSUM / LCELLS
         IF ( ( GC_CKSUM .NE. GC_CKSUM ) .OR. ( GC_CKSUM*2. .EQ. GC_CKSUM ) .OR.
     &        ( AE_CKSUM .NE. AE_CKSUM ) .OR. ( AE_CKSUM*2. .EQ. AE_CKSUM ) .OR.
     &        ( NR_CKSUM .NE. NR_CKSUM ) .OR. ( NR_CKSUM*2. .EQ. NR_CKSUM ) .OR.
     &        ( TR_CKSUM .NE. TR_CKSUM ) .OR. ( TR_CKSUM*2. .EQ. TR_CKSUM ) ) THEN
              WRITE( OUTDEV, '(7x,A,A)' ),'NaN or Infinity detected on processor ',TRIM(CMYPE)
              WRITE( OUTDEV,1009 ) SCIPROC,GC_CKSUM/LCELLS,AE_CKSUM/LCELLS,NR_CKSUM/LCELLS,TR_CKSUM/LCELLS
              CALL M3EXIT( PNAME, jdate, jtime,'NaN or Infinity detected in '//SCIPROC, 1 )
         END IF
      END IF

      RETURN

1001  FORMAT(  5X, 'Concentrations less than, but reset to', 1PE11.3,
     &         1X, 'in', A16
     &       / 9X, 'Date:Time',
     &         5X, 'Col', 2X, 'Row', 1X, 'Layer', 1X, 'Species',
     &         13X, 'Value before reset' )

1003  FORMAT( 5X, I8, ':', I6.6, 4I5, 1X, '(', A16, ')', 1PE12.3)

1005  FORMAT( 5X, 'After',
     &        1X, A12, 1X, ':  Gas ', 1PE10.3,
     &                 1X, ' | Aer ', 1PE10.3,
     &                 1X, ' | Non ', 1PE10.3 )

1007  FORMAT( 5X, 'After',
     &        1x, A12, 1X, ':  Gas ', 1PE10.3,
     &                 1X, ' | Aer ', 1PE10.3,
     &                 1X, ' | Non ', 1PE10.3,
     &                 1X, ' | Trc ', 1PE10.3 )
 
1008  FORMAT( 7X, 'During',
     &        1X, A12, 1X, ':  Gas ', 1PE10.3,
     &                 1X, ' | Aer ', 1PE10.3,
     &                 1X, ' | Non ', 1PE10.3 )

1009  FORMAT( 7X, 'During',
     &        1x, A12, 1X, ':  Gas ', 1PE10.3,
     &                 1X, ' | Aer ', 1PE10.3,
     &                 1X, ' | Non ', 1PE10.3,
     &                 1X, ' | Trc ', 1PE10.3 )
 
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PHOTOLYSIS_ALBEDO
 
C-----------------------------------------------------------------------
C  FUNCTION: Module contains a function and subroutine use to calculate the diffuse
C  and direct spectral albedo based on the fractional land use for each grid cell
C
C  History:
C  06/04/13 Bill Hutzell - Initial based on the albedo algorithm from phot.F
C                          from CMAQ 5.01
C  08/08/14 Bill Hutzell - 1) commented out snow effect for water surfaces based on 
C                          assumption that snow disolves on contact and causes no
C                          change on reflectivity
C                          2) changed how snow correction for land and sea ice takes
C                          place. The change uses a snow albedo, computed in the
C                          initialization routine instead of using the the snow
C                          correction factor at each call for the surface albedo
C                          calculation. The goal is to make the code easier to modify.
C  02/01/19 David Wong   - Implemented centralized I/O approach, removed all MY_N
C                          clauses
C-----------------------------------------------------------------------

         IMPLICIT NONE 

         REAL, ALLOCATABLE :: SURFACE_ALBEDO( :,:,: ) ! time dependent surface albedo
         REAL, ALLOCATABLE :: DIFFUSE_ALBEDO( :,:,: ) ! time dependent surface albedo
         REAL, ALLOCATABLE :: WATER_FRACTION( :,: )   ! cell fraction covered by water or ocean
         REAL, ALLOCATABLE :: SEAICE        ( :,: )   ! sea ice cover (fraction)
         REAL, ALLOCATABLE :: SNOCOV        ( :,: )   ! snow cover (fractional)

         INTEGER :: STDATE ! starting GMT [YYYYDDD]
         INTEGER :: STTIME ! starting time [HHMMSS]
         INTEGER :: STRTHR ! starting GMT hour [HH]
         REAL    :: JYFREQ ! 2PI/(# days in JYEAR)

! public variables:
         PUBLIC SURFACE_ALBEDO, DIFFUSE_ALBEDO, WATER_FRACTION, SEAICE, SNOCOV,
     &          STDATE, STTIME, STRTHR, JYFREQ

! public procedures:
         PUBLIC INITIALIZE_ALBEDO, GET_ALBEDO

         PRIVATE

         REAL, PARAMETER :: SEAICE_POINT = 271.36 ! [K] -threshold to form sea ice
                                                  ! based 2005 WRF model Documentation

         CHARACTER( 80 )      :: LAND_SCHEME
         INTEGER              :: NUMB_LANDUSE
         INTEGER              :: N_LAND_CLASSES            ! number of land classes in scheme
         INTEGER              :: N_WATER_CLASSES           ! number of water classes in scheme

         REAL,    ALLOCATABLE :: LANDMASK( :,: )           ! land-water mask: 1 for land and 0 for water
         INTEGER, ALLOCATABLE :: ALBMAP_TO_REF( : )        ! map from reference to used landuse for albedo
         REAL,    ALLOCATABLE :: ALBFAC_TO_REF( : )        ! factor from reference to used landuse for albedo

         REAL,    ALLOCATABLE :: LAND_ANNUAL   ( :,:,:,: ) ! annual average of land albedo weighted by class
         REAL,    ALLOCATABLE :: WATER_ANNUAL  ( :,:,:,: ) ! annual average for water albedo weighted class
         REAL,    ALLOCATABLE :: LAND_SNOW     ( :,:,:,: ) ! snow covered albedo for land weighted by class
         REAL,    ALLOCATABLE :: MAXIMUM_ALBEDO( : )       ! maximum allowed albedo per wavelength
         REAL,    ALLOCATABLE :: WATER_SEASONAL( : )   ! seasonal coefficient for water albedo
         REAL,    ALLOCATABLE :: WATER_ZENITH  ( : )   ! solar zenith coefficient for water albedo

         REAL,    ALLOCATABLE :: LAND_SEASONAL ( : )   ! seasonal coefficient for land albedo
         REAL,    ALLOCATABLE :: LAND_ZENITH   ( : )   ! solar zenith coefficient for land albedo

         REAL,    ALLOCATABLE :: SEAICE_ANNUAL ( : )     ! annual average for sea ice 
         REAL,    ALLOCATABLE :: SEAICE_SNOW   ( : )     ! snow covered albedo for sea ice 
         REAL                 :: SEAICE_SEASONAL          ! seasonal coefficient for sea ice albedo
         REAL                 :: SEAICE_ZENITH            ! solar zenith coefficient for sea ice albedo
 
         REAL,    ALLOCATABLE :: SFACTOR_LAND ( : )   ! seasonal correction for land albedo for land class
         REAL,    ALLOCATABLE :: SFACTOR_WATER( : )   ! seasonal correction for water albedo for water class
         REAL,    ALLOCATABLE :: ZFACTOR_LAND ( : )   ! combined seasonal and solar zenith angle correction for land class
         REAL,    ALLOCATABLE :: ZFACTOR_WATER( : )   ! combined seasonal and solar zenith angle correction for water class
         REAL,    ALLOCATABLE    :: TEMPG  ( :,: )       ! ground surface temperature [K]

         REAL WATER_SCALE     ! water scaling factor used to calculate surface albedo
         REAL SEASONAL_COEFF  ! coefficient for seasonal correction to surface albedo
         REAL ZENITH_COEFF    ! coefficient for zenith angle correction to surface albedo
         REAL SNOW_COEFF      ! coefficient for snow cover correction to surface albedo
         REAL SEA_MODULATE    ! seasonal modulation in surface albedo
         REAL ZEN_MODULATE    ! zenith angle modulation in surface albedo

      CONTAINS

         FUNCTION INITIALIZE_ALBEDO( MDATE, MTIME ) RESULT ( SUCCESS )
C...        Function sets up arrays and data needed to calculate surface albedos
C           use in radiative transfer calculation for actinic fluxes

            USE UTILIO_DEFN       ! IOAPI declaratiion and utilities
#ifndef mpas
#ifdef parallel
            USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
            USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif
            USE PHOT_MOD          ! photolysis in-line module
            USE PCGRID_DEFN       ! get cgrid

            USE LSM_MOD, ONLY: N_LUFRAC, LSM_SCHEME => LAND_SCHEME

            USE CENTRALIZED_IO_MODULE, only : interpolate_var, LWMASK, LUFRAC, HAS_SEAICE

            IMPLICIT NONE

            INCLUDE SUBST_FILES_ID   ! file name parameters

C...Arguments:

            INTEGER, INTENT( IN ) :: MDATE     ! Julian date (YYYYDDD)
            INTEGER, INTENT( IN ) :: MTIME     ! time        (HHMMSS)

C...Local:
            REAL                       :: JYEAR                      ! year, ADE
            REAL                       :: MSCALE                    ! scaling factor 
            REAL, ALLOCATABLE          :: FRACTION_LANDUSE( :,:,: ) ! fractional cover for a landuse

            LOGICAL                    :: SUCCESS
            CHARACTER(  2 )            :: LU_INDEX
            CHARACTER( 17 ), PARAMETER :: PNAME  = 'INITIALIZE_ALBEDO' 
            CHARACTER( 16 )            :: VARNM
            CHARACTER( 240 )           :: XMSG   = ' '

            INTEGER                    :: ROW
            INTEGER                    :: COL
            INTEGER                    :: LEV
            INTEGER                    :: SPC
            INTEGER                    :: L
            INTEGER                    :: NL, NW
            INTEGER                    :: V, N, MODE
            INTEGER                    :: ALLOCSTAT
            INTEGER                    :: IWAVE

            LOGICAL, SAVE :: INITIALIZED  = .FALSE.

            IF ( INITIALIZED ) THEN
               RETURN
            END IF

C...compute start time data and frequency of annual cycle considering leap year

            STDATE = MDATE
            STTIME = MTIME
            STRTHR =  MTIME / 10000
            JYEAR  = FLOAT( MDATE / 1000 )   !   Check this more carefully

            IF ( MOD( JYEAR, 4.0 ) .EQ. 0.0 ) THEN
               JYFREQ = 2.0 * PI / 366.0
            ELSE
               JYFREQ = 2.0 * PI / 365.0
            END IF

            SELECT CASE( LSM_SCHEME )
               CASE( 'USGS24' )
                  NUMB_LANDUSE = NUMB_LANDUSE_USGS  ! 24
                  LAND_SCHEME  = LSM_SCHEME
               CASE( 'MODIS' )
                  NUMB_LANDUSE = NUMB_LANDUSE_MODIS ! 33
                  LAND_SCHEME  = LSM_SCHEME
               CASE( 'NLCD50' )
                  NUMB_LANDUSE = NUMB_LANDUSE_NLCD50  ! 50
                  LAND_SCHEME  = LSM_SCHEME
               CASE( 'NLCD40' )
                  NUMB_LANDUSE = NUMB_LANDUSE_NLCD40  ! 40
                  LAND_SCHEME  = LSM_SCHEME
                  IF ( NO_NLCD40 ) THEN
                     XMSG =  'GRID_CRO_2D uses NLCD40 landuse scheme but '
     &                    // 'CSQY_FILE does not have albedo factors for '
     &                    // 'NLCD40'
                     WRITE( LOGDEV,'( A )' ) TRIM( PNAME ) // ' : ' // XMSG
                     SUCCESS = .FALSE.
                     RETURN
                  END IF
               CASE DEFAULT
                  LAND_SCHEME = 'UNKNOWN'
                  NUMB_LANDUSE = 2 ! simple land-water surface albedo
            END SELECT

            IF ( NUMB_LANDUSE .NE. 2 ) THEN ! test N_LUFRAC
               IF ( NUMB_LANDUSE .NE. N_LUFRAC ) THEN
                  XMSG =  TRIM( LAND_SCHEME ) // ' Landuse Scheme from (LSM) does '
     &                 // 'not match number of classes expected in PHOT_OPTICS_DATA '
     &                 // 'file'
                  WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                  WRITE(LOGDEV,'( 2(A,I4) )')'PHOT_OPTICS_DATA Value: ',NUMB_LANDUSE,
     &            ' Value from Land Surface Module (LSM): ', N_LUFRAC
                  IF( TRIM( LAND_SCHEME ) .EQ. 'MODIS' .AND. N_LUFRAC .EQ. 20 )THEN
                      NUMB_LANDUSE = 20
                      XMSG = 'Special Case MODIS landuse: MET data has only first 20 classes'
                      WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                      XMSG = 'Albedo calculations use only these classes'
                      WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                  ELSE
                      SUCCESS = .FALSE.
                      RETURN
                  END IF
               END IF
            END IF

            ALLOCATE ( ALBMAP_TO_REF( NUMB_LANDUSE ), ALBFAC_TO_REF( NUMB_LANDUSE ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ALBMAP_TO_REF and ALBFAC_TO_REF'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( FRACTION_LANDUSE( NUMB_LANDUSE,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating FRACTION_LANDUSE'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            FRACTION_LANDUSE = 0.0
            ALBMAP_TO_REF    = -1
            ALBFAC_TO_REF    = 0.0

            SELECT CASE( LAND_SCHEME )
               CASE( 'USGS24' )
                  ALBMAP_TO_REF( 1:NUMB_LANDUSE ) = ALBMAP_REF2USGS( 1:NUMB_LANDUSE )
                  ALBFAC_TO_REF( 1:NUMB_LANDUSE ) = ALBFAC_REF2USGS( 1:NUMB_LANDUSE )
               CASE( 'MODIS' )
                  ALBMAP_TO_REF( 1:NUMB_LANDUSE ) = ALBMAP_REF2MODIS( 1:NUMB_LANDUSE )
                  ALBFAC_TO_REF( 1:NUMB_LANDUSE ) = ALBFAC_REF2MODIS( 1:NUMB_LANDUSE )
               CASE( 'NLCD50' )
                  ALBMAP_TO_REF( 1:NUMB_LANDUSE ) = ALBMAP_REF2NLCD50( 1:NUMB_LANDUSE )
                  ALBFAC_TO_REF( 1:NUMB_LANDUSE ) = ALBFAC_REF2NLCD50( 1:NUMB_LANDUSE )
               CASE( 'NLCD40' )
                  ALBMAP_TO_REF( 1:NUMB_LANDUSE ) = ALBMAP_REF2NLCD40( 1:NUMB_LANDUSE )
                  ALBFAC_TO_REF( 1:NUMB_LANDUSE ) = ALBFAC_REF2NLCD40( 1:NUMB_LANDUSE )
               CASE DEFAULT
                  ALBMAP_TO_REF( 1 ) = INDEX_GRASSLAND_REF
                  ALBFAC_TO_REF( 1 ) = 1.0
                  ALBMAP_TO_REF( 2 ) = INDEX_OCEAN_REF
                  ALBFAC_TO_REF( 2 ) = 1.0
                  N_WATER_CLASSES = 1
                  N_LAND_CLASSES  = 1
            END SELECT

            IF ( LAND_SCHEME .NE. 'UNKNOWN' ) THEN
               WRITE( LOGDEV,'( 5X, A /5X, A )' ) TRIM( PNAME )
     &              // ': Identified ' // TRIM( LAND_SCHEME ) // ' land use scheme',
     &                 ' for surface albedo used by inline photolysis calculation.'

               N_WATER_CLASSES = 0
               DO V = 1, NUMB_LANDUSE
                  IF ( ALBMAP_TO_REF( V ) .EQ. INDEX_OCEAN_REF ) THEN
                      N_WATER_CLASSES = N_WATER_CLASSES + 1
                  END IF
                  DO ROW = 1, NROWS
                     DO COL = 1, NCOLS
                        FRACTION_LANDUSE( V,COL,ROW ) = LUFRAC( COL,ROW,V )
                     END DO
                  END DO
               END DO
               N_LAND_CLASSES = NUMB_LANDUSE - N_WATER_CLASSES
               
               IF ( N_LAND_CLASSES .LE. 0 .OR. N_WATER_CLASSES .GE. NUMB_LANDUSE ) THEN
                    WRITE(LOGDEV,'( A, I3,1X,I3 )')' N_WATER_CLASSES, N_LAND_CLASSES = ',
     &              N_WATER_CLASSES, N_LAND_CLASSES
                    XMSG = 'No Land classes found in ' // GRID_CRO_2D //
     &              'as expected for the ' // TRIM( LAND_SCHEME ) // ' land use scheme'
                    WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                    SUCCESS = .FALSE.
                    RETURN
               END IF
               IF ( N_LAND_CLASSES .GE. NUMB_LANDUSE .OR. N_WATER_CLASSES .LE. 0 ) THEN
                  WRITE(LOGDEV,'( A, I3,1X,I3 )')' N_WATER_CLASSES, N_LAND_CLASSES = ',
     &            N_WATER_CLASSES, N_LAND_CLASSES
                  XMSG = 'No water classes found in ' // GRID_CRO_2D //
     &            'as expected for the ' // TRIM( LAND_SCHEME ) // ' land use scheme'
                  WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                  SUCCESS = .FALSE.
                  RETURN
               END IF
            ELSE
               XMSG = ': Undentified ' // TRIM( LAND_SCHEME )
     &              // ' land use scheme for inline photolysis calculation.'
     &              // ' Using default land-water albedo for inline photolysis'
     &              // ' calculation.'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               DO ROW = 1, NROWS
                  DO COL = 1, NCOLS
                     IF ( LWMASK( COL,ROW ) .LT. 0.5 ) THEN
                        FRACTION_LANDUSE( 2,COL,ROW ) = 1.0
                     ELSE
                        FRACTION_LANDUSE( 1,COL,ROW ) = 1.0
                     END IF
                  END DO
               END DO
            END IF

            ALLOCATE ( SNOCOV( NCOLS,NROWS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating SNOCOV array'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( SEAICE( NCOLS,NROWS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating SEAICE array'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            IF ( .NOT. HAS_SEAICE ) THEN
               XMSG = 'MET_CRO_2D DOES NOT CONTAIN SEA ICE DATA. THE SURFACE ALBEDO '
     &              // 'DOES NOT INCLUDE ITS EFFECTS. Setting to one if water surface '
     &              // 'temperaure is less than 271.36K (WRF formation threshold).'
               WRITE( LOGDEV, '(A)' ) XMSG
               ALLOCATE ( TEMPG( NCOLS,NROWS  ), STAT = ALLOCSTAT )
               IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating TEMPG array'
                  WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                  SUCCESS = .FALSE.
                  RETURN
               END IF
            END IF

            ALLOCATE ( MAXIMUM_ALBEDO( NWL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating MAXIMUM_ALBEDO'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( SURFACE_ALBEDO( NWL,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating SURFACE_ALBEDO'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( DIFFUSE_ALBEDO( NWL,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DIFFUSE_ALBEDO'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( LAND_ANNUAL ( N_LAND_CLASSES,NWL,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating LAND_ANNUAL'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( LAND_SEASONAL( N_LAND_CLASSES ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating LAND_SEASONAL'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( LAND_ZENITH( N_LAND_CLASSES ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ALBEDO_ZENITH'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( LAND_SNOW( N_LAND_CLASSES,NWL,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ALBEDO_SNOW'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( SFACTOR_LAND( N_LAND_CLASSES ), ZFACTOR_LAND( N_LAND_CLASSES ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating SFACTOR_LAND and ZFACTOR_LAND'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( WATER_ANNUAL( N_WATER_CLASSES,NWL,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating WATER_ANNUAL'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE( SFACTOR_WATER( N_LAND_CLASSES ), ZFACTOR_WATER( N_WATER_CLASSES ),
     &                STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating SFACTOR_WATER and ZFACTOR_WATER'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( SEAICE_ANNUAL( NWL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating SEAICE_ANNUAL'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( SEAICE_SNOW( NWL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating SEAICE_SNOW'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( WATER_FRACTION( NCOLS,NROWS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating WATER_FRACTION'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( WATER_SEASONAL( N_WATER_CLASSES ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating WATER_SEASONAL'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( WATER_ZENITH( N_WATER_CLASSES ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating WATER_ZENITH'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            SURFACE_ALBEDO  = 0.0
            DIFFUSE_ALBEDO  = 0.0
            LAND_ANNUAL     = 0.0
            LAND_SEASONAL   = 0.0
            LAND_ZENITH     = 0.0
            LAND_SNOW       = 0.0

C...determine average albedo and its adjustment factors for zenith angle, season and snow cover

            WATER_FRACTION = 0.0

            WATER_SEASONAL = 1.0
            WATER_ZENITH   = 0.0
            WATER_ANNUAL   = 0.0

            LAND_SEASONAL  = 1.0
            LAND_ZENITH    = 0.0
            LAND_SNOW      = 0.0
            LAND_ANNUAL    = 0.0

            MAXIMUM_ALBEDO = 0.0

            NW = 0
            NL = 0
            DO V = 1, NUMB_LANDUSE
! set values for maximum allowed albedo; should correspond to fresh snow           
               L = ALBMAP_TO_REF( V )
               DO IWAVE = 1, NWL
                  MAXIMUM_ALBEDO( IWAVE ) = MAX( MAXIMUM_ALBEDO( IWAVE ),
     &                                      ALBFAC_TO_REF( V )* SPECTRAL_ALBEDO_REF( IWAVE, L ) )
               END DO                 
               IF ( L .EQ. INDEX_OCEAN_REF ) THEN
                  NW = NW + 1
                  WATER_SEASONAL( NW ) = SEASON_COEFF_REF( L )
                  WATER_ZENITH  ( NW ) = ZENITH_COEFF_REF( L )
                  DO ROW = 1, NROWS
                     DO COL = 1, NCOLS
                        WATER_FRACTION( COL,ROW ) = WATER_FRACTION( COL,ROW )
     &                                             + FRACTION_LANDUSE( V,COL,ROW )
                        WATER_SCALE = ALBFAC_TO_REF( V ) * FRACTION_LANDUSE( V,COL,ROW )
                        DO IWAVE = 1, NWL
                           WATER_ANNUAL( NW,IWAVE,COL,ROW ) = WATER_SCALE * SPECTRAL_ALBEDO_REF( IWAVE, L )
                        END DO          
                     END DO
                  END DO 
               ELSE
                  NL = NL + 1
                  LAND_SEASONAL( NL ) = SEASON_COEFF_REF( L )
                  LAND_ZENITH  ( NL ) = ZENITH_COEFF_REF( L )
                  DO ROW = 1, NROWS
                     DO COL = 1, NCOLS
                        MSCALE = ALBFAC_TO_REF( V ) * FRACTION_LANDUSE( V, COL, ROW )
                        DO IWAVE = 1, NWL
                           LAND_ANNUAL( NL,IWAVE,COL,ROW ) = MSCALE * SPECTRAL_ALBEDO_REF( IWAVE, L )
                           LAND_SNOW  ( NL,IWAVE,COL,ROW ) = SNOW_COEFF_REF( L ) * LAND_ANNUAL( NL,IWAVE,COL,ROW )
                        END DO
                     END DO
                  END DO 
               END IF
            END DO                       
         
C...set up sea ice annual and snow albedos along with correction factors

            L = INDEX_SEA_ICE
            SEAICE_SEASONAL = SEASON_COEFF_REF( L )
            SEAICE_ZENITH   = ZENITH_COEFF_REF( L )
            DO IWAVE = 1, NWL
               SEAICE_ANNUAL( IWAVE ) = SPECTRAL_ALBEDO_REF( IWAVE, L )
               SEAICE_SNOW  ( IWAVE ) = SNOW_COEFF_REF( L ) * SEAICE_ANNUAL( IWAVE )
!              write(logdev,*)'SEAICE, SEAICE_ANNUAL, SEAICE_SNOW, SEAICE_SEASONAL, SEAICE_ZENITH = ', 
!     &         SEAICE_ANNUAL( IWAVE), SEAICE_SNOW( IWAVE ),SEAICE_SEASONAL
            END DO
         
            SUCCESS = .TRUE.
            
            RETURN
            
         END FUNCTION INITIALIZE_ALBEDO
            
         SUBROUTINE GET_ALBEDO( MDATE, MTIME, COSZENS, LAT, LON )
            
C... Subroutine calculates diffuse and direct surface albedo versus wavelength over a set of
C    latitudes and longitudes

            USE UTILIO_DEFN       ! IOAPI declaratiion and utilities
            USE PHOT_MOD          ! photolysis in-line module
#ifndef mpas
#ifdef parallel
            USE SE_MODULES        ! stenex (using SE_UTIL_MODULE)
#else
            USE NOOP_MODULES      ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif
            USE PCGRID_DEFN       ! get cgrid
            USE CENTRALIZED_IO_MODULE, only : interpolate_var, HAS_SEAICE

            IMPLICIT NONE

            INCLUDE SUBST_FILES_ID   ! file name parameters

C arguments:

            INTEGER, INTENT( IN ) :: MDATE            ! Julian date (YYYYDDD)
            INTEGER, INTENT( IN ) :: MTIME            ! time        (HHMMSS)
            REAL,    INTENT( IN ) :: COSZENS( :,: )   ! cosine of the solar zenith angle
            REAL,    INTENT( IN ) :: LAT( :,: )       ! north lat at cell center [deg]
            REAL,    INTENT( IN ) :: LON( :,: )       ! west long at cell center [deg] 

C local:
            REAL                        :: CURRENT_HOUR  ! current GMT hour [sec]
            REAL                        :: JULIAN_DAY    ! julian day       [days]
            REAL                        :: CURRHR_LST    ! local standard time at each grid cell
            REAL                        :: EQUATION_TIME ! equation of time
            REAL                        :: COSZEN        ! working cosine of the solar zenith angle
            REAL                        :: SINLAT        ! sine of latitude
            REAL                        :: COSLAT        ! cosine of latitude
            REAL                        :: MSCALE        ! scaling factor 

            REAL                        :: ALBEDO_LAND   ! scratch variable for land fraction
            REAL                        :: ALBEDO_WATER  ! scratch variable for water fraction
            REAL                        :: ALBEDO_SEAICE ! scratch variable for seaice fraction

            REAL                        :: SFACTOR_SEAICE ! seasonal correction for seaice albedo
            REAL                        :: ZFACTOR_SEAICE ! solar zenith angle correction for seaice albedo
            REAL                        :: SNOW_FREE      ! snow free fraction of cell
            REAL                        :: ICE_FREE       ! water fraction free sea ice 
            CHARACTER(  17 ), PARAMETER :: PNAME  = 'GET_ALBEDO'
            CHARACTER(  16 )            :: VARNM
            CHARACTER( 240 )            :: XMSG   = ' '

            INTEGER                     :: ROW
            INTEGER                     :: COL
            INTEGER                     :: LEV
            INTEGER                     :: SPC
            INTEGER                     :: L
            INTEGER                     :: IWAVE
            INTEGER                     :: NW, NL
            INTEGER                     :: V, N, MODE
            INTEGER                     :: ALLOCSTAT

C...Read & Interpolate SNOCOV

            call interpolate_var ('SNOCOV', mdate, mtime, SNOCOV)

            IF ( HAS_SEAICE ) THEN

               call interpolate_var ('SEAICE', mdate, mtime, SEAICE)

            ELSE

               call interpolate_var ('TEMPG', mdate, mtime, TEMPG)

            END IF

C...Calculate current hour in GMT and julian day

            CURRENT_HOUR = REAL( STRTHR, 4 )
     &                   + REAL( SECSDIFF( STDATE, STTIME, MDATE, MTIME ), 4 )
     &                   / 3600.0

            JULIAN_DAY   = REAL(MOD( MDATE, 1000 ), 4 )

C...Calculate cosines of the zenith angles

            DO ROW = 1, NROWS
               DO COL = 1, NCOLS

                  SINLAT = SIN( PI180 * LAT ( COL,ROW ) )
                  COSLAT = COS( PI180 * LAT ( COL,ROW ) )

C...correct  CURRHR for current *positive* West longitude convention
C...  to obtain LST.

C...this convention on longititude should be reexamined for different domains

                  CURRHR_LST = CURRENT_HOUR + LON( COL,ROW ) / 15.0

                  IF ( .NOT. HAS_SEAICE ) THEN ! determine sea ice can form
                     IF ( TEMPG( COL,ROW ) .LT. SEAICE_POINT .AND.
     &                    WATER_FRACTION( COL,ROW ) .GE. 0.95 ) THEN
                        SEAICE( COL,ROW ) = 1.0
                     ELSE
                        SEAICE( COL,ROW ) = 0.0
                     END IF
                  END IF

C...determine seasonal and snow corrections to surface albedo
C...  convert julian into time of year for grid cell
C...  seasonal adjustment has an 11 day phase delay in the solar cycle

                  IF ( LAT( COL,ROW ) .GE. 0.0 ) THEN
                     SEA_MODULATE = COS( JYFREQ * ( JULIAN_DAY + CURRHR_LST / 24.0 + 11.0 ) )
                  ELSE
                     SEA_MODULATE = COS( JYFREQ * ( JULIAN_DAY + CURRHR_LST / 24.0 + 11.0 ) + PI )
                  END IF

                  IF ( SEA_MODULATE .GE. 0.0 ) THEN
                     MSCALE = 0.5 * ( 1.0 + SQRT( SEA_MODULATE ) )
                  ELSE
                     SEA_MODULATE = ABS( SEA_MODULATE )
                     MSCALE = 0.5 * ( 1.0 - SQRT( SEA_MODULATE ) )
                  END IF

!.. MSCALE equals 1 and 0 on winter and summer soltices, respectively
!... Note that seasonal factors are equal to or less than 1.0
 
                  FORALL ( NL = 1:N_LAND_CLASSES )
                     SFACTOR_LAND( NL ) = 1.0 /( 1.0 + MSCALE * (LAND_SEASONAL ( NL ) - 1.0) )
                  END FORALL
! assume that open water has no other effect than sea ice that is a seasonal effect
!                 FORALL ( NW = 1:N_WATER_CLASSES )
!                    SFACTOR_WATER( NW ) = 1.0 /( 1.0 + MSCALE * (WATER_SEASONAL( NW ) - 1.0) )
!                 END FORALL
!                 SFACTOR_SEAICE = 1.0 /( 1.0 + MSCALE * (SEAICE_SEASONAL-1.0) )

C..Determine zenith angle correction to albedos
C...First, test whether zenith angle is greater than 90 degrees.
                  IF ( COSZENS( COL,ROW ) .LE. 0.0 ) THEN
                     FORALL ( NL = 1:N_LAND_CLASSES )
                        ZFACTOR_LAND( NL ) = MAX( 0.8, ( 1.0 + LAND_ZENITH( NL ) ) )
                        ZFACTOR_LAND( NL ) = ZFACTOR_LAND( NL ) * SFACTOR_LAND( NL )
                     END FORALL
! Note that water zenith correction is later combined with seasonal correction
                     FORALL ( NW = 1:N_WATER_CLASSES )
                        ZFACTOR_WATER( NW ) = MAX( 0.8,( 1.0 + WATER_ZENITH( NW ) ) )
                     END FORALL
                     ZFACTOR_SEAICE = MAX( 0.8, ( 1.0 + SEAICE_ZENITH ) )
                  ELSE
                     FORALL ( NL = 1:N_LAND_CLASSES )
                        ZFACTOR_LAND( NL ) = MAX( 0.8, ( 1.0 + LAND_ZENITH( NL ) )
     &                                     / ( 1.0 + 2.0 * COSZENS( COL,ROW ) * LAND_ZENITH( NL ) ) )
                        ZFACTOR_LAND( NL ) = ZFACTOR_LAND( NL ) * SFACTOR_LAND( NL )
                     END FORALL
! Note that water zenith correction is later combined with seasonal correction
                     FORALL ( NW = 1:N_WATER_CLASSES )
                        ZFACTOR_WATER( NW ) = MAX( 0.8, ( 1.0 + WATER_ZENITH( NW ) )
     &                                      / ( 1.0 + 2.0 * COSZENS( COL,ROW ) * WATER_ZENITH( NW ) ) )
                     END FORALL
                     ZFACTOR_SEAICE = MAX( 0.8, ( 1.0 + SEAICE_ZENITH )
     &                              / ( 1.0 + 2.0 * COSZENS( COL,ROW ) * SEAICE_ZENITH ) )
                  END IF

                  SNOW_FREE = MAX( ( 1.0 - SNOCOV( COL,ROW ) ), 0.0 )
                  ICE_FREE  = MAX( ( 1.0 - SEAICE( COL,ROW ) ), 0.0 )

!...Update the season and zenith corrections for water and sea ice based on ice and water coverage, in
!...the case for sea ice  
 
                  FORALL ( NW = 1:N_WATER_CLASSES )
                     SFACTOR_WATER( NW ) = ICE_FREE  !!! * SFACTOR_WATER( NW )
                     ZFACTOR_WATER( NW ) = ZFACTOR_WATER( NW ) * SFACTOR_WATER( NW )
                  END FORALL

                  SFACTOR_SEAICE = SEAICE( COL,ROW ) * WATER_FRACTION( COL,ROW )

                  DO IWAVE = 1, NWL

C...compute seasonal diffuse albedos for land, water and seaice separately

                     ALBEDO_LAND  = 0.0
                     ALBEDO_WATER = 0.0

                     DO NL = 1, N_LAND_CLASSES
                        IF ( LAND_ANNUAL( NL,IWAVE,COL,ROW ) .LT. 1.0E-6 ) CYCLE
                        ALBEDO_LAND  = ALBEDO_LAND +  SFACTOR_LAND( NL )
     &                               * ( SNOW_FREE * LAND_ANNUAL( NL,IWAVE,COL,ROW )
     &                               +   SNOCOV( COL,ROW ) * LAND_SNOW( NL,IWAVE,COL,ROW ) )
                     END DO
                     DO NW = 1, N_WATER_CLASSES
                        IF ( WATER_ANNUAL( NW,IWAVE,COL,ROW ) .LT. 1.0E-6 ) CYCLE
                        ALBEDO_WATER = ALBEDO_WATER  
     &                               + SFACTOR_WATER( NW ) * WATER_ANNUAL( NW,IWAVE,COL,ROW )
                     END DO

                     ALBEDO_SEAICE = SFACTOR_SEAICE
     &                             * ( SNOW_FREE * SEAICE_ANNUAL( IWAVE )
     &                             +   SNOCOV( COL,ROW ) * SEAICE_SNOW( IWAVE ) )

C...sum for net diffuse albedo

                     DIFFUSE_ALBEDO( IWAVE,COL,ROW ) = ALBEDO_LAND 
     &                                               + ALBEDO_WATER 
     &                                               + ALBEDO_SEAICE

                     MSCALE = MAXIMUM_ALBEDO( IWAVE )

                     DIFFUSE_ALBEDO( IWAVE,COL,ROW ) = MIN( MSCALE, DIFFUSE_ALBEDO( IWAVE,COL,ROW ) )

C...Calculate albedos for combined correction from solar zenith angle and season

                     ALBEDO_LAND  = 0.0
                     ALBEDO_WATER = 0.0

                     DO NL = 1, N_LAND_CLASSES
                        IF ( LAND_ANNUAL( NL,IWAVE,COL,ROW ) .LT. 1.0E-6 ) CYCLE
                        ALBEDO_LAND = ALBEDO_LAND + ZFACTOR_LAND( NL ) 
     &                              * ( SNOW_FREE * LAND_ANNUAL( NL,IWAVE,COL,ROW )
     &                              +   SNOCOV( COL,ROW ) * LAND_SNOW( NL,IWAVE,COL,ROW ) )
                     END DO
                     DO NW = 1, N_WATER_CLASSES
                        IF ( WATER_ANNUAL( NW,IWAVE,COL,ROW ) .LT. 1.0E-6 ) CYCLE
                        ALBEDO_WATER = ALBEDO_WATER 
     &                               + ZFACTOR_WATER( NW ) * WATER_ANNUAL(NW,IWAVE,COL,ROW )
                     END DO

                     ALBEDO_SEAICE = ZFACTOR_SEAICE * ALBEDO_SEAICE

C....sum for net direct albedo

                     SURFACE_ALBEDO( IWAVE,COL,ROW ) = ALBEDO_LAND 
     &                                               + ALBEDO_WATER 
     &                                               + ALBEDO_SEAICE

                     SURFACE_ALBEDO( IWAVE,COL,ROW ) = MIN( MSCALE, SURFACE_ALBEDO( IWAVE,COL,ROW ) )

                  END DO   ! iwave

               END DO   ! col
            END DO   ! row

            RETURN

         END SUBROUTINE GET_ALBEDO

      END MODULE PHOTOLYSIS_ALBEDO

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE SA_ARRAY_INIT(CGRID )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c20140428 If cold start, write ICON values to ISAM; otherwise,
c         write to ISAM those ISAM values from last hour of previous day
c           Called by initscen.F
c
C     01 Nov 2018: S.Napelenok Updates for cmaq5.3 release 
C     09 May 2019: D.Wong Removed all MY_ clauses
C     13 May 2019: D.Wong Moved environment variable ISAM_NEW_START to RUNTIME_VARS
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      USE GRID_CONF
      USE UTILIO_DEFN           ! replaces ioparms, iofdesc, iodecl
      USE CGRID_SPCS            ! covers all kinds of species mapping
      USE SA_DEFN               ! Mc06
      USE RUNTIME_VARS, only : ISAM_NEW_START
      
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif


      implicit none
      
      INCLUDE SUBST_FILES_ID    ! file name parameters

c.....arguments

      REAL, POINTER :: CGRID( :,:,:,: ) ! for initial CONC

c.....local variables

      INTEGER          C, R, L, S, K              ! loop index
      INTEGER          N, NSPC, JVOC              ! 20140123

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     program entry
c.........................................................
c.....update isam array according to isam ICON source tag


      IF( ISAM_NEW_START == 'Y') THEN
                                !.....map N_SPC_ADV to the user-query species
        DO S = 1, NSPC_SA

          N = MAP_SAtoCGR( S )
          DO L = 1, NLAYS
            DO R = 1, NROWS
              DO C = 1, NCOLS
                ISAM(C,R,L,S,ICONTAG) = CGRID(C,R,L,N)
              END DO ! R
            END DO ! C
          END DO ! L
        END DO ! S
      ELSE
        ! Initialize ISAM array by isam output from previous day
        CALL CREATE_ICON( )

      END IF

      return

      end

C=======================================================================

      SUBROUTINE CREATE_ICON( )
      
C**********************************************************************
C
C  FUNCTION: [1] read in a ISAM IOAPI output file
C            [2] Load the last step's ISAM data into ISAM buffer array 
C
C
C**********************************************************************

      USE GRID_CONF
      USE UTILIO_DEFN   ! replaces ioparms, iofdesc, iodecl
      USE SA_DEFN   ! Mc06
      USE RUNTIME_VARS
      
      IMPLICIT NONE 

      
C.....argument:

c.....local variables:
      
      CHARACTER( 16 ), PARAMETER :: PNAME   = 'create_icon'
      CHARACTER( 16 ), PARAMETER :: INNAME  = 'ISAM_PREVDAY'
      
      
      INTEGER       ::  JDATE   ! current model date, coded YYYYDDD
      INTEGER       ::   JTIME   ! midpoint model time, coded HHMMSS

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      INTEGER       :: GXOFF, GYOFF              ! global origin offset from file
      INTEGER, SAVE :: STARTCOL, ENDCOL, STARTROW, ENDROW

      INTEGER       ::   LOGENV
      INTEGER       ::   C,R,L,S,K,I

      INTEGER       :: IBGN, JSPCTAG, NSPCTAG
      
      CHARACTER( 16 )    :: SPCNAME1( NSPC_SA ) 
      CHARACTER( 16 )    :: NAME_TAG
      CHARACTER( 99 )    :: XMSG
      
      LOGICAL            :: EFLAG = .FALSE.
      
      REAL, ALLOCATABLE  :: TEMP( :,:,: )      

C**********************************************************************
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         LOGENV = INIT3()
C Get domain decomp info from the emissions file
         CALL SUBHFILE ( INNAME, GXOFF, GYOFF,
     &                   STARTCOL, ENDCOL, STARTROW, ENDROW )
      END IF                    ! FIRSTIME
      
      EFLAG = .FALSE.
      
      IF ( .NOT. OPEN3( INNAME, FSREAD3, PNAME) )THEN 
         WRITE(LOGDEV, *) 'Error: open file failed', INNAME
         CALL M3EXIT( 'READ_ISAM_ICON', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )
      ENDIF 
      
      
      IF ( .NOT. DESC3( INNAME ) ) THEN
         WRITE(LOGDEV, *) 'Error: read', INNAME, 'failed'
         CALL M3EXIT( 'READ_ISAM_ICON', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )
      ENDIF 

cyqwang...begin  Get The last step data

      DO I = 1, MXREC3D-1
        CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D )
      END DO

cyqwang...end
      
      JDATE = SDATE3D
      JTIME = STIME3D
      NSPCTAG = NVARS3D

Ckrt....assign ISAM_SPEC( nspc_sa, ntag_sa ) to spcname1( nspc_sa )
      DO S = 1, NSPC_SA
        SPCNAME1( S ) = ISAM_SPEC( S, NTAG_SA )
      ENDDO ! s

Ckrt allocate data-loading array 
      ALLOCATE( TEMP( NCOLS, NROWS, NLAYS3D ) )
      TEMP = 0.0
      
      DO JSPCTAG = 1, NSPCTAG
        !KRT: extract sa_conc_1 from previous day
        IF ( .NOT. XTRACT3( INNAME, VNAME3D( JSPCTAG ), 
     &       1, NLAYS3D, STARTROW, ENDROW, STARTCOL, ENDCOL,
     &       JDATE, JTIME, TEMP ) ) THEN
               XMSG = 'Read failure:  file ' // INNAME // 
     &         ' variable ' // VNAME3D( JSPCTAG ) //
     &         ' end of file...'
                WRITE(LOGDEV,*) PNAME, JDATE, JTIME,
     &          TRIM( XMSG )
             CALL M3EXIT( 'READ_ISAM_ICON', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )             
        END IF
        !KRT: identify isam indices from input species names
        IBGN = INDEX( VNAME3D( JSPCTAG ),'_', BACK = .TRUE. )
        S = INDEX1( VNAME3D( JSPCTAG )( 1:IBGN-1 ),NSPC_SA,SPCNAME1 )
        K = INDEX1( VNAME3D( JSPCTAG )( IBGN+1:LEN_TRIM(VNAME3D(JSPCTAG))),
     &        NTAG_SA, TAGNAME )
        NAME_TAG = VNAME3D(JSPCTAG)(IBGN+1:LEN_TRIM(VNAME3D(JSPCTAG)))
        IF ( S .GT. 0 ) THEN
          IF ( K .GT. 0 ) THEN
            DO C = 1, NCOLS
              DO R = 1, NROWS
                DO L = 1, NLAYS3D
                  ISAM( C,R,L,S,K ) = TEMP( C,R,L )
                END DO
              END DO
            END DO
          ELSE ! bcon, othr, or icon tags            
            CK_SUFFX: SELECT CASE ( NAME_TAG )
            CASE ( 'BCON', 'BCO' )
              K = NTAG_SA - 2
            CASE ( 'OTHR', 'OTH' )
              K = NTAG_SA - 1
            CASE ( 'ICON', 'ICO' )
              K = NTAG_SA
            END SELECT CK_SUFFX
            IF ( K .LE. 0 ) THEN
              WRITE(LOGDEV,*)'ISAM ICON Species ', TRIM( VNAME3D(JSPCTAG) ), ' has bad tagname set to ',
     &        TRIM( NAME_TAG )            
              EFLAG = .TRUE.      
            ELSE
               DO L = 1, NLAYS3D
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        ISAM( C,R,L,S,K ) = TEMP( C,R,L )
                     END DO
                  END DO
               END DO
            END IF
          ENDIF ! emission tags
        ENDIF ! species exist in tags
      END DO ! jspctag

      IF ( EFLAG ) THEN
         CALL M3EXIT( 'READ_ISAM_ICON', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )
      END IF
      
      DEALLOCATE(TEMP)

      If ( .NOT. CLOSE3( INNAME ) ) Then
         WRITE ( *,* )
     &     '>>--> ISAM PREVDAY output not closed properly <--<<'
      End if
      RETURN
           
      END
     

C=======================================================================
      MODULE PA_DEFN
 
C Contains: Control parameters for Process Analysis
C
C Dependent On: Mechanism Input file
C
C Created By: Process Analysis Control Program
C           11:05:01 EDT  July 15, 2016

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  The following variables are used to control calls to the Integrated
c  Process Rate and Integrated Reaction Rate routines:
c     LIPR = Flag for calculating Integrated Process Rates
c     LIRR = Flag for calculating Integrated Reaction Rates
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c these are set in pa_read.F
      LOGICAL :: LIPR = .FALSE.
      LOGICAL :: LIRR = .FALSE.

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  The following variables are used in the output file descriptions
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     NIPRVAR = Number of IPR output variables
c     NIRRVAR = Number of IRR output variables
c     IPRNAME = Name of IPR output variable
c     IRRNAME = Name of IRR output variable
c     IPRDESC = Extended name of IPR output variable
c     IRRDESC = Extended name of IRR output variable
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c these are set in pa_setup_ipr.F, pa_read.F, respectively
c   change to pa_read
      INTEGER :: NIPRVAR = 0
      INTEGER :: NIRRVAR = 0

c these are set in pa_setup_ipr.F, pa_getirrout.F (pa_setup_irr.F)
c   allocate in pa_read
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: IPRNAME( : ) ! IPRNAME( NIPRVAR )
      CHARACTER( 60 ), ALLOCATABLE, SAVE :: IPRDESC( : ) ! IPRDESC( NIPRVAR )
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: IRRNAME( : ) ! IRRNAME( NIRRVAR )
      CHARACTER( 60 ), ALLOCATABLE, SAVE :: IRRDESC( : ) ! IRRDESC( NIRRVAR )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  The following variables are used in the integrated process rate 
c  computations.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c    NPRCS     = No. of science processes that can be monitored
c    PROCNAME  =
c    N_IPR_SPC = Number of families for IPR
c    NCSAVE    = Number of CTM species concs to save for IPR
c    MXCGRID   = Max number of CTM species in an IPR family
c    LPROCOUT  =
c    NCGRID    = Array of no. of CTM species in an IPR family
c    IPROUT    = Array of IPR output variable indices
c    IPR2GRD   = Array of CTM species indices for IPR families
c    IPR2SAV   = Array of saved species indices for IPR families
c    SV2GRD    = Array of CTM indicies for saved concs
c    SPCOEF    = Array of coefficients for IPR familys
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      INTEGER, PARAMETER :: NPRCS = 14
 
      INTEGER, PARAMETER :: IPR_XADV = 1
      INTEGER, PARAMETER :: IPR_YADV = 2
      INTEGER, PARAMETER :: IPR_ZADV = 3
      INTEGER, PARAMETER :: IPR_HDIF = 4
      INTEGER, PARAMETER :: IPR_VDIF = 5
      INTEGER, PARAMETER :: IPR_EMIS = 6
      INTEGER, PARAMETER :: IPR_DDEP = 7
      INTEGER, PARAMETER :: IPR_PVO3 = 8
      INTEGER, PARAMETER :: IPR_CLDS = 9
      INTEGER, PARAMETER :: IPR_CHEM = 10
      INTEGER, PARAMETER :: IPR_COND = 11
      INTEGER, PARAMETER :: IPR_COAG = 12
      INTEGER, PARAMETER :: IPR_NPF  = 13
      INTEGER, PARAMETER :: IPR_GROW = 14
 
      CHARACTER(4), PARAMETER :: PROCNAME( NPRCS ) =
     & (/'XADV','YADV','ZADV','HDIF','VDIF','EMIS','DDEP',
     &   'PVO3','CLDS','CHEM','COND','COAG','NPF ','GROW' /)

      REAL, ALLOCATABLE, SAVE :: CSAV( :,:,:,: )

      LOGICAL, SAVE :: COUPLE_WRF = .FALSE.

c this is set in pa_getiprout.F, pa_errcheck.F?
      INTEGER :: N_IPR_SPC = 0
c these are set in pa_setup_ipr.F
      INTEGER :: MXCGRID   = 0

c these are allocated in pa_setpadefn.F
      INTEGER, ALLOCATABLE, SAVE :: MAP_IPRVARtoSPC( : )  ! ( NIPRVAR )
      INTEGER, ALLOCATABLE, SAVE :: NCGRID ( : )          ! ( N_IPR_SPC )
      INTEGER, ALLOCATABLE, SAVE :: MAP_SAVEtoCGRID( : )  ! ( NCSAVE )
      INTEGER, ALLOCATABLE, SAVE :: MAP_IPRtoCGRID( :,: ) ! ( N_IPR_SPC,MXCGRID )
      INTEGER, ALLOCATABLE, SAVE :: MAP_IPRtoSAVE( :,: )  ! ( N_IPR_SPC,MXCGRID )
      REAL,    ALLOCATABLE, SAVE :: SPCOEF ( :,: )  ! ( N_IPR_SPC,MXCGRID )
      LOGICAL, ALLOCATABLE, SAVE :: MASK_IPR_PROC( :,: )

      LOGICAL, SAVE              :: BUDGET_DIAG = .FALSE.
      LOGICAL, SAVE              :: BUDGET_HPPM = .FALSE.
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: BUDGETVARIABLES( : )
      INTEGER, PARAMETER :: MAX_BUDGET_VARS_NML = 200

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  The following variables are used in the integrated reaction rate
c  computations.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c    LFULLIRR     = Flag for computing IRRs for every reaction
c    LPARTIRR     = Flag for computing IRRs for selected reactions
c    NUMOUTPOS    = No. of temp. IRR terms to add iff the IRR > 0
c    NUMOUTNEG    = No. of temp. IRR terms to add iff the IRR < 0
c    NUMOUTIND    = No. of temp. IRR terms to add regardless of sign
c    MXNIRRRXNS   = Max no. of reaction terms in an output IRR
c    MXTEMPTRMS   = Max no. of reaction terms in a temp. IRR
c    NIRRRXNS     = Vector of no. of reaction terms in an output IRR
c    TEMPTERMS    = Vector of no. of terms in a temporary IRR
c    TEMPOUTPOS   = Vector of no. of IRR terms to add if IRR > 0
c    TEMPOUTNEG   = Vector of no. of IRR terms to add if IRR < 0
c    TEMPOUTIND   = Vector of no. of IRR terms to add regardless of sign
c    INDXOUTPOS   = Vector of indices pointing to IRR output variable
c    INDXOUTNEG   = Vector of indices pointing to IRR output variable
c    INDXOUTIND   = Vector of indices pointing to IRR output variable
c    COEFOUTPOS   = Vector of temp IRR coefficients
c    COEFOUTNEG   = Vector of temp IRR coefficients
c    COEFOUTIND   = Vector of temp IRR coefficients
c    NUMTEMPS     = No. of temporary intermediate IRRs to compute
c    TEMPRXN      = Array of reaction nos. for a temp. IRR
c    IRRRXN       = Array of reaction nos. for an output IRR
c    TEMPCOEF     = Array of reaction coefficients for a temp IRR
c    IRRCOEF      = Array of reaction coefficients for an output IRR
c    IRRSTEP      = Array of output IRRs for one time step
c    IRRBLK       = Array of output IRRs for a block of cells
c    IRROUT       = Array of IRRs to output
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c these are set in pa_read.F
      LOGICAL, SAVE :: LFULLIRR = .FALSE.
      LOGICAL, SAVE :: LPARTIRR = .FALSE.

c these are set in pa_setup_irr.F, pa_errcheck.F
      INTEGER, SAVE :: NUMOUTPOS  = 0
      INTEGER, SAVE :: NUMOUTNEG  = 0
      INTEGER, SAVE :: NUMOUTIND  = 0
      INTEGER, SAVE :: MXNIRRRXNS = 0
      INTEGER, SAVE :: NUMTEMPS   = 0
      INTEGER, SAVE :: MXTEMPTRMS = 0

c this is set in the Model`s GRID_CONF
      INTEGER, SAVE :: BLKSIZED = 50

c these are allocated in pa_setup_irr.F
      INTEGER, ALLOCATABLE, SAVE :: NIRRRXNS  ( : )    ! ( NIRRVAR )
      INTEGER, ALLOCATABLE, SAVE :: IRRRXN    ( :,: )  ! ( NIRRVAR,MXNIRRRXNS )
      INTEGER, ALLOCATABLE, SAVE :: TEMPOUTPOS( : )    ! ( NUMOUTPOS )
      INTEGER, ALLOCATABLE, SAVE :: INDXOUTPOS( : )    ! ( NUMOUTPOS )
      INTEGER, ALLOCATABLE, SAVE :: TEMPOUTNEG( : )    ! ( NUMOUTNEG )
      INTEGER, ALLOCATABLE, SAVE :: INDXOUTNEG( : )    ! ( NUMOUTNEG )
      INTEGER, ALLOCATABLE, SAVE :: TEMPOUTIND( : )    ! ( NUMOUTIND )
      INTEGER, ALLOCATABLE, SAVE :: INDXOUTIND( : )    ! ( NUMOUTIND )
      INTEGER, ALLOCATABLE, SAVE :: TEMPTERMS ( : )    ! ( NUMTEMPS )
      INTEGER, ALLOCATABLE, SAVE :: TEMPRXN   ( :,: )  ! ( NUMTEMPS,MXTEMPTRMS )

      REAL,    ALLOCATABLE, SAVE :: COEFOUTPOS( : )    ! ( NUMOUTPOS )
      REAL,    ALLOCATABLE, SAVE :: COEFOUTNEG( : )    ! ( NUMOUTNEG )
      REAL,    ALLOCATABLE, SAVE :: COEFOUTIND( : )    ! ( NUMOUTIND )
      REAL,    ALLOCATABLE, SAVE :: TEMPCOEF  ( :,: )  ! ( NUMTEMPS,MXTEMPTRMS )
      REAL,    ALLOCATABLE, SAVE :: IRRCOEF   ( :,: )  ! ( NIRRVAR,MXNIRRRXNS )
      REAL,    ALLOCATABLE, SAVE :: IRRSTEP   ( :,: )  ! ( BLKSIZED,NIRRVAR )
      REAL,    ALLOCATABLE, SAVE :: IRRBLK    ( :,: )  ! ( BLKSIZED,NIRRVAR )
      REAL,    ALLOCATABLE, SAVE :: IRRDEL    ( : )    ! ( NIRRVAR )
      REAL,    ALLOCATABLE, SAVE :: IRRSUM    ( : )    ! ( NIRRVAR )

      END MODULE PA_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
      Module Resist_Funcs
!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! This module contains functions and subroutines to calculate variables
! used to estimate the air-surface exchange using the STAGE deposition option
!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Use ASX_DATA_MOD, only:pr, twothirds
      
      Implicit None
      Real, Parameter, Private :: a0         = 8.0        ! [dim'less]

      Contains 
!--------------------------------------------------------------------------------------------------
! Calculate soil dry diffusive length until saturation
!--------------------------------------------------------------------------------------------------
         Pure Function Calc_ldry( sm_v1cm, sm_v5cm, sm_vsat, zsoil1 ) Result( ldry )

         Implicit None        

         Real, Intent( IN ) :: sm_v1cm ! Volumetric soil moisture at -1 cm (m3/m3)
         Real, Intent( IN ) :: sm_v5cm ! Volumetric soil moisture at -5 cm (m3/m3)
         Real, Intent( IN ) :: sm_vsat ! Volumetric soil moisture saturation point (m3/m3)
         Real, Intent( IN ) :: zsoil1  ! Model depth of soil layer 1
         Real, Parameter    :: ldry_max = 0.02 ! maximum dry diffusion length based on measurements of Kondo et al 1990
         Real               :: ldry    ! Length of dry layer soil diffusion distance (m)
    
! The following resistance parameterization is derived from measurements with soil samples of 2 cm thick (Kondo et al 1990)
! https://doi.org/10.1175/1520-0450(1990)029<0385:APOEFB>2.0.CO;2 as discussed in Sakaguchi and Zeng 2009 JGR 
! https://doi.org/10.1029/2008JD010834 According to Swenson and Lawrence 2014 (https://doi.org/10.1002/2014JD022314) and the 
! references therein the dry layer thickness varies from 1 to 3 cm. 
! From Sakaguchi and Zeng 2009 JGR Equation 10
         ldry = ldry_max * ( Exp( ( 1.0 - sm_v1cm / sm_vsat ) ** 5 ) - 1.0 ) / 1.718

         If(ldry .gt. zsoil1) Then
            ldry = zsoil1 + ( ldry_max - zsoil1 ) * ( Exp( ( 1.0 - sm_v5cm / sm_vsat ) ** 5 ) - 1.0 ) / 1.718
         End If

         End Function Calc_ldry
!--------------------------------------------------------------------------------------------------
! Calculate Quasi-laminar boundary layer resistance to deposition to water surfaces
!--------------------------------------------------------------------------------------------------
         Pure Function Calc_Rbw( ustar, scc_pr_23 ) Result( Rbw )
! Returns the quasi-laminar boundary layer resistance for a flat surface based on 
! Wesely and Hicks 1977  https://doi.org/10.1080/00022470.1977.10470534 equation 13

         Implicit None
         
         Real, Intent( IN ) :: ustar
         Real, Intent( IN ) :: scc_pr_23
         Real               :: Rbw

         Rbw = 5.0 / ustar * scc_pr_23
         End Function Calc_Rbw

!--------------------------------------------------------------------------------------------------
! Calculate Resistance to deposition to surface waters
! 
! References: 
! Chang et al., Ozone deposition to the sea surface: chemical enhancement and wind speed 
!    dependence, Atmos. Environ., 38(7), 1053-1059, https://doi.org/10.1016/j.atmosenv.2003.10.050, 
!    2004
! Garland et al., The mechanism for dry deposition of ozone to seawater surface, J. Geophys. Res,
!    85, 7488-7492, https://doi.org/10.1029/JC085iC12p07488, 1980
! Hayduk, W., and H. Laudie, Prediction of diffusion coefficients for nonelectrolytes indilute 
!    aqueous solutions, AIChE. J., 20, 611-615, https://doi.org/10.1002/aic.690200329, 1974
! Rebello et al., The Cycling of Iodine as Iodate and Iodide in a Tropical Estuarine System, 
!    Marine Chem. 29, 77-93, https://doi.org/10.1016/0304-4203(90)90007-Y, 1990
! 
!--------------------------------------------------------------------------------------------------
         Pure Function Calc_Rwater( ustar, q_2m, temp_2m, temp_g, tw, MVol, H, O3_Hit, 
     &                         Hg_Hit, sea_ice  ) Result( Rwater )         
         USE CONST, only: stdtemp

         Implicit None

         Real, Intent( IN ) :: ustar   ! Surface friction velocity (m/s)
         Real, Intent( IN ) :: q_2m    ! temp water vapor mixing ratio
         Real, Intent( IN ) :: temp_2m ! 2m temp (K)
         Real, Intent( IN ) :: temp_g  ! surface temp (K)
         Real, Intent( IN ) :: tw      ! water skin temp (K)
         Real, Intent( IN ) :: H       ! Effective Henry's Constant (unitless)
         Real, Intent( IN ) :: MVol    ! Molar volume (LeBas) (L/mol)
         logical, Intent( IN ) :: O3_Hit  ! O3 index
         logical, Intent( IN ) :: Hg_Hit  ! Hg index
         logical, Intent( IN ) :: sea_ice ! sea ice coverage (ratio)
         Real, Parameter :: rt25inK    = 1.0/(stdtemp + 25.0) ! 1/298.15K (1/K)
         Real, Parameter :: d3         = 1.38564e-2           ! Empirical coefficient (unitless)
         Real            :: pChang, kwChang  ! Air-water partitioning coefficients (unitless)
         Real            :: ciodide, qiodide ! Iodide in sea-water based on SST  (mol / L)
         Real            :: dw25, dw, kvisw  ! Trace gase diffusivity (at 25C and tw) in water and kinematic viscosity of water (cm2/s)
         Real            :: scw_pr_23    ! (SCC/PR)**2/3, fn of DIF0
         Real            :: Rwater       ! Resistance of deposition to sea surfaces (s/m)

! from Hayduk and Laudie
         dw25 = 13.26e-5 / ( 0.8904**1.14 * MVol**0.589 )
         kvisw = 0.017 * EXP( -0.025 * ( tw - stdtemp ) )
         dw    = dw25 * ( tw * rt25inK ) * ( 0.009025 / kvisw )
         scw_pr_23 = ( ( kvisw / dw ) / pr ) ** twothirds
! All species but Hg and O3
         Rwater = scw_pr_23 / ( H * d3 * ustar )

         IF ( O3_Hit ) THEN   !implement Chang et al(2004)
c        pChang is a/H or alpha/H which would be 1/H in current model
c        note that in Chang et al (2004) and Garland et al (1980) their H is Cair/Cwater which is
c        the inverse of heff
            pChang = 1.75
            kwChang = (d3*ustar)/scw_pr_23

c        If a file of chlorophyll concentrations is provided, Iodide concentrations are estimated from
c        a fit to the Rebello et al 1990 data. The slope and correlation are given in the paper
c        but not the intercept, so the data in Tables 3 & 4 were fit to get the relationship below.
c        The regression gives the concentration in umol/L and is converted to mol/L for use in Chang et al eq.
c        The slope and correlation are slightly different than in Table 5.
c        If chlorophyll concs are not available, a constant value for [I-] of 100e-9 mol/l is used
c        Use ocean file variables to determine if the water cell is ocean or lake; method is only for ocean cells

            IF ( sea_ice ) THEN
! O3 over sea ice
               Rwater   = scw_pr_23 / ( H * d3 * ustar )
            ELSE                  
c        Iodide in sea-water based on SST  (mol /dm-3)
               ciodide = 1.46E6 * EXP( -9134.0 / temp_g)
               qiodide = sqrt( 2.0e9 * ciodide * dw * 1.0e-4 ) * H
               Rwater = 1.0 / ( pChang * kwchang + qiodide )
            END IF
         End IF 
         IF( Hg_Hit ) THEN
            Rwater = 1.0e6 ! surface waters are typically enriched in Hg(0) and act as an emission source
         END IF

         End Function Calc_Rwater
!--------------------------------------------------------------------------------------------------
! Calculate Resistance to deposition to ice surfaces
!--------------------------------------------------------------------------------------------------
         Pure Function Calc_Rice( Rx ) Result( Rice )

         Implicit None
         
         Real, Intent( IN ) :: Rx   ! Relative reactivivity (unitless)
         Real               :: Rice ! Resistance of deposition to ice surfaces (s/m)
         Real, Parameter    :: rsnow0     = 10000.0    ! Empirical scaling coefficient set to
                                                       ! approximately match D Helmig et al. 2007 for O3
                                                    
         Rice = rsnow0 * a0 / Rx                                                   

         End Function Calc_Rice

!--------------------------------------------------------------------------------------------------
! Calculate resistance to snow-covered surfaces
!--------------------------------------------------------------------------------------------------
         Pure Function Calc_Rsnow( temp_g, snow, molwt, M_ac, heff, dif_T, rel_rx ) Result( Rsnow )
         Use const, only: stdtemp

         Implicit None

         Real, Intent( IN ) :: temp_g ! surface temperature (K) 
         Real, Intent( IN ) :: snow   ! snow coverage (ratio)
         Real, Intent( IN ) :: molwt  ! molar mass (g/mol)
         Real, Intent( IN ) :: M_ac   ! Mass accommodation coefficient (ratio)
         Real, Intent( IN ) :: heff   ! Effective henry's constant (unitless)
         Real, Intent( IN ) :: dif_T  ! Mass diffusivity of the trace gas (m2/s) 
         Real, Intent( IN ) :: rel_rx ! Relative reactivivity (unitless)
         Real               :: Rwet   ! Resistance of deposition to water surfaces (s/m)
         Real               :: Rice   ! Resistance of deposition to ice surfaces (s/m)
         Real               :: Rsnow  ! Resistance of deposition to snow surfaces (s/m)
         Real               :: melt_snow, ice_snow ! Ration of snow with semi-solid melted and ice surfaces (ratio)
         Real, Parameter    :: rsndiff    = 10.0   ! snow diffusivity fac (s/m)

         Rwet = Calc_Rwet( temp_g, molwt, M_ac, heff, dif_T )
         Rice = Calc_Rice( rel_rx )
! Liquid snow fraction modeled as a system dominated by van der Waals forces following Dash et al. 1999 S. Rep. Prog. Phys. 
! with a maximum fraction of the disordered interface acting as an aqueous solution as 20% following Conklin et al 1993 with
! the negligible impact of the disordered interface depth of 2 nm following Roth et al 2004. The 2 nm depth was approximated 
! to be around 263 degrees Celsius interpolated from figure 3 in Huthwelker et al 2006 doi:10.1021/cr020506v
         IF( snow .GT. 0.0 ) Then
            IF( stdtemp-temp_g .GT. 0.002 ) THEN
               melt_snow = 0.025 / (stdtemp-temp_g)**(1.0/3.0)
               melt_snow = MIN (melt_snow, 0.2)
               melt_snow = MAX (melt_snow, 0.01)
            ELSE
               melt_snow = 0.2
            ENDIF
         Else
            melt_snow = 0.0
         End IF
! frozen snow fraction
         ice_snow  = 1.0 - melt_snow               

         Rsnow = 1.0 / ( ice_snow / Rice + melt_snow / ( rsndiff + rwet ) )                                 

         End Function Calc_Rsnow

!-------------------------------------------------------------------------------------------------
! Resistance to air-wet surface exchange
!-------------------------------------------------------------------------------------------------
         Pure Function Calc_Rwet( temp_g, MW, ac, H, dif_T ) Result( Rwet )
         Use Const, only: RGASUNIV

         Implicit None

         Real,    Intent( IN ) :: temp_g
         Real,    Intent( IN ) :: H
         Real,    Intent( IN ) :: dif_T
         Real,    Intent( IN ) :: MW
         Real,    Intent( IN ) :: ac
         Real, Parameter :: rad_wat     = 1.9e-4    ! water droplet radius (m)
         Real            :: Rwet
         Real            :: rmsv
         Real            :: rawmt

         rmsv    = sqrt( 3.0 * RGASUNIV * 1.0e3 * temp_g / MW) 
         rawmt   = rad_wat / dif_T  + 4.0 / ( rmsv  * ac )
         Rwet   = rawmt + rawmt/( H * rad_wat )

         End Function Calc_Rwet

!-------------------------------------------------------------------------------------------------
! Quasi-Laminar Resistance to leaf following Jensen and Hummelshoj 1995/1997 doi:10.1016/0168-1923(94)05083-I
!-------------------------------------------------------------------------------------------------
         Pure Function Calc_Rb_leaf( k_vis, dif_T, ustar, l_leaf, lai ) Result( Rb_leaf )

         Implicit None

         Real, Intent( IN ) :: k_vis
         Real, Intent( IN ) :: dif_T
         Real, Intent( IN ) :: ustar
         Real, Intent( IN ) :: l_leaf
         Real, Intent( IN ) :: lai
         Real               :: Rb_leaf
         Real, Parameter    :: C0 = 100.0 ! From Jensen and Hummelshoj 1997 errata

! Note that LAI**2 comes from the drag coefficient in Jensen and Hummelshoj 1995 and the 
! parameterization should be divided by LAI for a bulk canopy resistance         
         Rb_leaf = k_vis / ( dif_T * ustar * max( lai, 1.0 ) ) * 
     &           ( C0 * l_leaf * ustar / (k_vis * max(lai,1.0)**2 ) )**(1.0/3.0)

         End Function Calc_Rb_leaf

!-------------------------------------------------------------------------------------------------
! Resistance to air-stomatal exchange
!-------------------------------------------------------------------------------------------------
         Pure Function Calc_Rst( Rstw, dwat_T, dif_T, H, f_mes, lai ) Result( Rst )

         Implicit None
   
         Real, Intent( IN ) :: Rstw
         Real, Intent( IN ) :: dwat_T
         Real, Intent( IN ) :: dif_T
         Real, Intent( IN ) :: H
         Real, Intent( IN ) :: f_mes
         Real, Intent( IN ) :: lai
         Real               :: Rst

         Rst = Rstw * dwat_T / dif_T + 1.0 / ( H / 3000.0 + 100.0 * f_mes ) / lai

         End Function Calc_Rst
!-------------------------------------------------------------------------------------------------
! Resistance to air-cuticular exchange
!-------------------------------------------------------------------------------------------------
         Pure Function Calc_Rcut( temp_g, Rx, molwt, M_ac, heff, dif_T, a_cut,  
     &                            snow, no_snow, dry, wet, rh, lai, O3_hit, NH3_hit, ABFLUX ) Result( Rcut )

         Use const, only: stdtemp
         Implicit None

         Real, Intent( IN ) :: temp_g
         Real, Intent( IN ) :: a_cut
         Real, Intent( IN ) :: snow
         Real, Intent( IN ) :: no_snow
         Real, Intent( IN ) :: dry
         Real, Intent( IN ) :: wet
         Real, Intent( IN ) :: rh
         Real, Intent( IN ) :: lai
         Real, Intent( IN ) :: Rx
         Real, Intent( IN ) :: molwt 
         Real, Intent( IN ) :: M_ac 
         Real, Intent( IN ) :: heff 
         Real, Intent( IN ) :: dif_T
!         Real, Intent( IN ) :: Rice
!         Real, Intent( IN ) :: Rsnow
         Logical, Intent( IN ) :: O3_hit
         Logical, Intent( IN ) :: NH3_hit
         Logical, Intent( IN ) :: ABFLUX

         Real            :: Rcut
         Real            :: Rsnow
         Real            :: rcdry
         Real            :: rwet
         Real            :: rh_func
         Real, Parameter :: rcut0   = 3000.0     ! [s/m]
         Real, Parameter :: rwm     = 31.5              ! Minimum NH3 cuticle resistance [s/m] from Massad et al. 2010

C Calculate Rcut
         ! wet Cuticle
         ! If the surface is cold and wet, use dry snow.                   
         rcdry = rcut0 * a0 / Rx
         Rsnow = Calc_Rsnow( temp_g, snow, molwt, M_ac, heff, dif_T, Rx )
         IF ( temp_g .GE. stdtemp ) THEN 
!            Rwet= Rwet0         
            Rwet = Calc_Rwet( temp_g, molwt, M_ac, heff, dif_T ) 
         ELSE ! temp_g .Lt. stdtemp
!            rwet = Rice
            rwet = Calc_Rice( Rx )
         END IF ! temp 
         IF ( O3_hit ) THEN 
         ! Canopy level wet resistence Rwet to ozone was found to be about 200 s/m on basis of Keysburg exp
         ! Using LAI(1-sided) of about 6.25 measured at Keysburg gives leaf level rwet about 1250 s/m
            rwet = 1250.0    ! s/m
         ! Leaf level rwet estimated from Altimir et al 2006 gives about 1350 s/m  
         ! Dry cuticle
            rh_func = max( 0.0,( rh - 70.0 )/30.0 )
            rcdry   = 1.0 / ( ( 1.0 -rh_func) / ( rcut0 * a0 / Rx )  + rh_func / rwet )               
         End If
         If ( NH3_hit .And. ABFLUX ) Then
         ! Massad et al. 2010 Cuticular resistance
            rcdry = rwm * EXP( a_cut * ( 100.0 - rh ) )    
         End If ! O3

         Rcut = no_snow / ( lai * ( dry / rcdry     +  ! Dry Cuticle 
     &                               wet / rwet ) ) +  ! Wet Cuticle 
     &          snow * Rsnow                           ! Snow

         End Function Calc_Rcut
!-------------------------------------------------------------------------------------------------
! In-Canopy Aerodynamics Resistance
!-------------------------------------------------------------------------------------------------
         Pure Function Calc_Rinc( Ra, lai ) Result( Rinc )

         Implicit None

         Real, Intent( IN ) :: Ra
         Real, Intent( IN ) :: lai
         Real               :: Rinc

! Calculate in canopy aerodynamic resistance based on the momentum attenuation coefficient derived 
! by Yi 2008 https://doi.org/10.1175/2007JAMC1667.1
         Rinc =  Ra * ( Exp( lai / 2.0 ) - 1.0 )

         End Function Calc_Rinc
!-------------------------------------------------------------------------------------------------
! Soil Quasi-laminar boundary layer Resistance
!-------------------------------------------------------------------------------------------------
         Pure Function Calc_Rbg( k_vis, dif_T, lai, ustar ) Result( Rbg )

         Implicit None

         Real, Intent( IN ) :: k_vis
         Real, Intent( IN ) :: dif_T
         Real, Intent( IN ) :: lai
         Real, Intent( IN ) :: ustar
         Real               :: Rbg
         Real               :: scn
         Real               :: del0
         Real               :: ustg
         Real, Parameter    :: karman = 0.4 ! add to stage data and move functions to new module STAGE_OPS

C Calculate Canopy Covered Soil Resistance Nemitz et al 2000 https://doi.org/10.1016/S0168-1923(00)00206-9
         ! Soil quazi laminar boundary layer resistance with canopy 
         scn    = k_vis / dif_T
         ! ustar at the soil surface following Yi 2008 https://doi.org/10.1175/2007JAMC1667.1
         ustg   = max( ustar * EXP( -lai / 2.0 ), 0.001 )         
         del0   = dif_T / ( karman * ustg )
         Rbg    = ( scn - LOG( del0 / 0.10 ) ) / ( karman * ustg )
         End Function Calc_Rbg

!-------------------------------------------------------------------------------------------------
! Net resistance for deposition to soil surfaces
!-------------------------------------------------------------------------------------------------
         Pure Function Calc_Rg( dif_T, k_vis, Rx, Ra, ustar, lai, temp_g, molwt, M_ac, heff, sm_v1cm,
     &                          sm_v5cm, sm_vsat, sm_vfc, sm_vwlt, sm_vres, sm_bslp, zsoil, frac_ir,
     &                          dry, wet, snow, no_snow, O3_Hit, NH3_Hit, ABFLUX ) Result( Rgc )

         Use Const, only: grav, pi
         Implicit None

         Real, Intent   ( IN ) :: dif_T
         Real, Intent   ( IN ) :: k_vis
         Real, Intent   ( IN ) :: Rx
         Real, Intent   ( IN ) :: Ra
         Real, Intent   ( IN ) :: ustar
         Real, Intent   ( IN ) :: lai
         Real, Intent   ( IN ) :: temp_g
         Real, Intent   ( IN ) :: molwt 
         Real, Intent   ( IN ) :: M_ac 
         Real, Intent   ( IN ) :: heff
         Real, Intent   ( IN ) :: sm_v1cm
         Real, Intent   ( IN ) :: sm_v5cm
         Real, Intent   ( IN ) :: sm_vsat
         Real, Intent   ( IN ) :: sm_vfc
         Real, Intent   ( IN ) :: sm_vwlt
         Real, Intent   ( IN ) :: sm_vres
         Real, Intent   ( IN ) :: sm_bslp
         Real, Intent   ( IN ) :: zsoil
         Real, Intent   ( IN ) :: frac_ir
         Real, Intent   ( IN ) :: dry, wet, snow, no_snow
         Logical, Intent( IN ) :: O3_Hit, NH3_Hit, ABFLUX
         
         Real               :: Rg
         Real               :: Rgc
         Real               :: Rbgc
         Real               :: Rinc
         Real               :: Rwet
         Real               :: Rsnow
         Real               :: sm_v1cm_ir, sm_v5cm_ir, sm_v10cm
         Real               :: sm_func
         Real               :: ldry
         Real               :: dp, rgdry
         Real               :: p_wet ! wet soil surface
         Real               :: p_dry ! dry soil surface
         Real, Parameter    :: ldry_max = 0.02
         Real, Parameter    :: rg0      = 1000.0     ! [s/m]

         Rwet  = Calc_Rwet( temp_g, molwt, M_ac, heff, dif_T )
         Rsnow = Calc_Rsnow( temp_g, snow, molwt, M_ac, heff, dif_T, Rx )

         If(ABFLUX .And. NH3_Hit) Then
! Updated based on EPIC 5cm soil moisture estimates where the 25% percentile of the irrigated crop fractional soil moisture was 
! approximately equal to 60% of the field capacity.  
            If ( frac_ir .Gt. 0.0 .And. sm_v5cm .LE.  0.60 * sm_vfc ) Then            
               sm_v1cm_ir = ( 1.0 - frac_ir ) * sm_v1cm + frac_ir * 0.60 * sm_vfc
               sm_v5cm_ir = ( 1.0 - frac_ir ) * sm_v5cm + frac_ir * 0.60 * sm_vfc
            Else
               sm_v1cm_ir = sm_v1cm
               sm_v5cm_ir = sm_v5cm
            End If
            
! The following resistance parameterization is derived from measurements with soil samples of 2 cm thick (Kondo et al 1990)
! https://doi.org/10.1175/1520-0450(1990)029<0385:APOEFB>2.0.CO;2 as discussed in Sakaguchi and Zeng 2009 JGR 
! https://doi.org/10.1029/2008JD010834 According to Swenson and Lawrence 2014 (https://doi.org/10.1002/2014JD022314) and the 
! references therein the dry layer thickness varies from 1 to 3 cm. 
! From Sakaguchi and Zeng 2009 JGR Equation 10
            ldry = Calc_ldry( sm_v1cm_ir, sm_v5cm_ir, sm_vsat, zsoil )         
            dp  = dif_T * sm_vsat**2 * ( 1.0 - sm_vres / sm_vsat ) ** ( 2.0 + 3.0 / sm_bslp )         
            rgdry = max(ldry / dp,1.0e-6)
! Assumes that the soil water is an emission source. Air-soil water gradient replaces the empirical resistance to water
            Rg = no_snow * rgdry + snow * Rsnow 

         Else If ( O3_Hit ) Then
! Following based on measurements Fares et al 2014 https://doi.org/10.1016/j.agrformet.2014.08.014 for sandy soil 
! forests at 10cm measured soil moisture and Fumagalli et al. 20016 https://doi.org/10.1016/j.agrformet.2016.07.011 for sandy loam soils
! Here an asymptotic function was applied to set lower and upper bounds in the resistance as reported by Fumagalli et al. 2016
            sm_v10cm = min(sm_v1cm * exp( 0.09 * GRAV )**(1.0/sm_bslp), sm_vsat )
            sm_func = max( tiny(0.0)**(1.0/sm_bslp) * PI , ( sm_v10cm-sm_vwlt ) / sm_vfc )
            rgdry   = 250.0 + 2000.0 * atan( sm_func**sm_bslp ) /PI  

            Rg = no_snow * ( 1.0/ ( dry / rgdry + wet / rwet ) ) + snow * Rsnow   
         Else 
            rgdry  = rg0 * a0 / Rx
            Rg = no_snow * ( 1.0/ ( dry / rgdry + wet / rwet ) ) + snow * Rsnow  
         End If
         Rinc =  Calc_Rinc( Ra, lai )
         Rbgc = Calc_Rbg( k_vis, dif_T, lai, ustar )

         Rgc = Rg + Rbgc + Rinc 

         End Function Calc_Rg

!-------------------------------------------------------------------------------------------------
! CMAQ v5.3 Aerosol Deposition Velocity parameterization. Note that this is the v5.3 implementation
! in the STAGE deposition option, evaluated in Appel et al. 2021 and Benish et al. 2022, and differs 
! from Shu et al. in the land use tiling and implementaiton of the vegetation factor
! 
! References: 
! Appel, K.W., et. al., The Community Multiscale Air Quality (CMAQ) model versions 5.3 and 5.3. 1: 
!    system updates and evaluation. Geosci. Model Dev. 14, 2867-2897, 
!    https://doi.org/10.5194/gmd-14-2867-2021, 2021
! Benish, S.E., et al., Long-term Regional Trends of Nitrogen and Sulfur Deposition in the United 
!    States from 2002 to 2017, Atmos. Phys. Chem. Discussions, https://doi.org/10.5194/acp-2022-201,
!    2022
! Shu et al., Particle dry deposition algorithms in CMAQ version 5.3: characterization of critical 
!    parameters and land use dependence using DepoBoxTool version 1.0, Geosci. Model Dev. Discussions, 
!    https://doi.org/10.5194/gmd-2021-129, 2021
! 
!-------------------------------------------------------------------------------------------------
!-------------------------------------------------------------------------------------------------
! Aerosol surface resistance for vegetative surfaces
!-------------------------------------------------------------------------------------------------
         Pure Function RD_Veg(Vghat, ustar, SC,l_width, lai) Result( RD )
                  
         Use Const, only: GRAV
         Implicit None

         Real, Intent( IN ) :: Vghat
         Real, Intent( IN ) :: ustar
         Real, Intent( IN ) :: SC
         Real, Intent( IN ) :: l_width
         Real, Intent( IN ) :: lai
         Real               :: RD
         Real               :: V_fac
         Real               :: ST
         Real               :: EIM
         Real               :: EIB

         V_fac   = max( lai, 1.0 )
         ST      = Vghat * ustar / ( GRAV * l_width )
         EIB     = Calc_EIB( SC )
         EIM     = EIM_Veg( ST )
         RD      = 1.0 / ( V_fac * ustar * ( EIB + EIM ) )

         End Function RD_Veg
!-------------------------------------------------------------------------------------------------
! Aerosol surface resistance for water and bare soil surfaces
!-------------------------------------------------------------------------------------------------
         Pure Function RD_Smooth(Vghat, ustar, SC, nu ) Result( RD )

         USE CONST, ONLY: GRAV                  
         Implicit None

         Real, Intent( IN ) :: Vghat
         Real, Intent( IN ) :: ustar
         Real, Intent( IN ) :: SC
         Real, Intent( IN ) :: nu
         Real               :: RD
         Real               :: ST
         Real               :: EIM
         Real               :: EIB

         ST      = Vghat * ustar**2 / ( GRAV * nu )
         EIB     = Calc_EIB( SC )
         EIM     = EIM_Smooth( ST )
         RD      = 1.0 / ( ustar * ( EIB + EIM ) )

         End Function RD_Smooth
!-------------------------------------------------------------------------------------------------
! CMAQ v5.3 Aerosol Deposition Velocity parameterization. 
! 
! Reference:
! Venkatram, A. and Pleim, J.: The electrical analogy does not apply to modeling dry deposition of 
!    particles, Atmos. Environ., 33, 30753076, https://doi.org/10.1016/S1352-2310(99)00094-1, 1999.
! 
!-------------------------------------------------------------------------------------------------
         Pure Function aero_depv(veg, Ra, Vghat, ustar, SC, NU, l_aero, lai ) Result( depv )
                  
         Implicit None

         Real, Intent( IN ) :: veg
         Real, Intent( IN ) :: Ra
         Real, Intent( IN ) :: Vghat
         Real, Intent( IN ) :: ustar
         Real, Intent( IN ) :: SC
         Real, Intent( IN ) :: NU
         Real, Intent( IN ) :: l_aero
         Real, Intent( IN ) :: lai
         Real               :: RD_Can
         Real               :: RD_Smth
         Real               :: depv


         If( veg .Gt. 0.0  ) Then
            RD_Can = RD_Veg( Vghat, ustar, SC,l_aero, lai)
         Else
            RD_Can = 1.0e6          
         End If
         RD_Smth = RD_Smooth(Vghat, ustar, SC, NU )

         depv =         veg   * Vghat / ( 1.0 - EXP( -Vghat * ( Ra + RD_Can ) ) ) + 
     &          ( 1.0 - veg ) * Vghat / ( 1.0 - EXP( -Vghat * ( Ra + RD_Smth ) ) )

         End Function aero_depv
!-------------------------------------------------------------------------------------------------
! Brownian Diffusion Collection Efficiency
!-------------------------------------------------------------------------------------------------
         Pure Function Calc_EIB( SC ) Result( EIB )

         Implicit None

         Real, Intent( IN ) :: SC
         Real               :: EIB

         EIB = SC ** (-twothirds)

         End Function Calc_EIB
!-------------------------------------------------------------------------------------------------
! Impaction Collection Efficiency for vegetation following Slinn 1982
!-------------------------------------------------------------------------------------------------
         Pure Function EIM_Veg( ST ) Result( EIM )

         Implicit None

         Real, Intent( IN ) :: ST
         Real               :: EIM

         EIM     = ST**2 / ( 1.0 + ST**2 ) ! Slinn 1982 equation 28           

         End Function EIM_Veg
!-------------------------------------------------------------------------------------------------
! Impaction Collection Efficiency for water and soil surfaces following Giorgi 1986
!-------------------------------------------------------------------------------------------------
         Pure Function EIM_Smooth( ST ) Result( EIM )

         Implicit None

         Real, Intent( IN ) :: ST
         Real               :: EIM

         EIM     = ST**2 / ( 400.0 + ST**2 ) ! Giorgi 1986 Equation 17     

         End Function EIM_Smooth
!-------------------------------------------------------------------------------------------------
!                           Aerosol Dry Deposition Code Following
!         Emerson et al 2020 PNAS https://www.pnas.org/cgi/doi/10.1073/pnas.2014761117
! 
! This code follows the Emerson et al 2020 parameterization with modifications to account for
! seasonality due to changing LAI and continuous scaling from vegetated to non-vegetated surfaces
! This parmaterization matches Emerson et al 2020 when LAI is approximately 5 for vegetation 
! categories and for non-vegitated surfaces.  
!
! Refernces: 
! Emerson et al., Revisiting particle dry deposition and its role in radiative effect estimates, 
!    Proc. Natl. Acad. Sci., 117, 26076-26082, https://www.pnas.org/cgi/doi/10.1073/pnas.2014761117, 
!    2020
! Zhang et al. A size-segregated particle dry depositionscheme for an atmospheric aerosol module. 
!    Atmos. Environ.35, 549560, https://doi.org/10.1016/S1352-2310(00)00326-5, 2001 
!-------------------------------------------------------------------------------------------------
! Aerosol surface resistance for vegetative surfaces
!-------------------------------------------------------------------------------------------------
         Pure Function RD_Veg_E20(Vghat, ustar, SC,l_width, lai, Dp, wet, Alpha, EINHAT) Result( RD )
         Use Const, only: grav
         
         Implicit None

         Real, Intent( IN ) :: Vghat
         Real, Intent( IN ) :: ustar
         Real, Intent( IN ) :: SC
         Real, Intent( IN ) :: l_width
         Real, Intent( IN ) :: lai
         Real, Intent( IN ) :: alpha
         Real, Intent( IN ) :: Dp
         Real, Intent( IN ) :: wet
         Real, Intent( IN ) :: EINHAT
         Real               :: RD
         Real               :: veg_ustar ! intgrated lai * ustar through the canopy is equal to 3 * ustar at lai = 5.5
         Real               :: ST
         Real               :: EIM ! Impaction Collection Efficiency for vegetation following Emerson et al. 2020
         Real               :: EIN ! Interception Collection Efficiency for vegetation following Emerson et al 2020
         Real               :: EIB ! Brownian Diffusion Collection Efficiency Following Emerson et al. 2020
         Real               :: R1  ! collection efficiency following Slinn 1982

! Integration of lai(z)/hc u*(z) from 0 to hc.   
         veg_ustar = max((4.0 - (2.0 * lai + 4.0) * exp( -lai/2.0 )) * ustar, 1.0e-3) ! Replaces the constant 3 in Zhang et 2001
         ST        = Vghat * ustar / ( GRAV * l_width )
         R1        = max( Exp( -SQRT( ST ) ), 1.0e-20) ! only apply to particles with diameter larger than 5 um Zhang et al 2001
         EIB       = Calc_EIB_E20( SC )
         EIN       = EIN_Veg_E20( Dp, l_width ) * EINHAT
         EIM       = EIM_Veg_E20( ST, alpha )
         RD        = 1.0 / (      wet  * ( veg_ustar * ( EIB + EIN + EIM ) ) +      ! Wet surface
     &                     (1.0 - wet) * ( veg_ustar * ( EIB + EIN + EIM ) * R1 ) ) ! Dry surface

         End Function RD_Veg_E20
!-------------------------------------------------------------------------------------------------
! Aerosol surface resistance for water and bare soil surfaces
!-------------------------------------------------------------------------------------------------
         Pure Function RD_Smooth_E20(Vghat, ustar, lai, SC, nu, wet ) Result( RD )
                  
         Use Const, only: grav
         Implicit None

         Real, Intent( IN ) :: Vghat
         Real, Intent( IN ) :: ustar
         Real, Intent( IN ) :: lai
         Real, Intent( IN ) :: SC
         Real, Intent( IN ) :: nu
         Real, Intent( IN ) :: wet
         Real               :: ustg ! ustar at ground = ustar if lai=0
         Real               :: RD
         Real               :: ST
         Real               :: EIM
         Real               :: EIB
         Real               :: R1

         ustg    = max( ustar * exp( -lai/2.0 ), 0.001 )
         ST      = Vghat * ustg**2 / ( GRAV * nu )
         R1      = max( Exp( -SQRT( ST ) ), 1.0e-20) ! only apply to particles with diameter larger than 5 um Zhang et al 2001
         EIB     = Calc_EIB_E20( SC )
         EIM     = EIM_SMOOTH_E20( ST )
         RD      = 1.0 / (        wet  * ( 3.0 * ustg * ( EIB + EIM ) ) +      ! Wet surface
     &                     (1.0 - wet) * ( 3.0 * ustg * ( EIB + EIM ) * R1 ) ) ! Dry Surface

         End Function RD_Smooth_E20
!-------------------------------------------------------------------------------------------------
! Aerosol Deposition Velocity
!-------------------------------------------------------------------------------------------------
         Pure Function aero_depv_E20(veg, lai, Ustar, Ra, wet, l_aero, Alpha, DG, SC, NU, VGHAT, EINHAT)
     &                               Result( depv )
                  
         Implicit None

         Real, Intent( IN ) :: veg
         Real, Intent( IN ) :: lai
         Real, Intent( IN ) :: Ustar
         Real, Intent( IN ) :: Ra
         Real, Intent( IN ) :: wet
         Real, Intent( IN ) :: l_aero
         Real, Intent( IN ) :: Alpha
         Real, Intent( IN ) :: DG
         Real, Intent( IN ) :: SC
         Real, Intent( IN ) :: NU
         Real, Intent( IN ) :: Vghat
         Real, Intent( IN ) :: EINHAT ! interception modal integration term
         Real               :: depv
         Real               :: RD_VegL   ! Resistance to vegetation leaves
         Real               :: RD_VegG   ! Resistance to vegetation ground
         Real               :: RD_GW  ! Resistance to non-vegetated ground or water
         Real               :: Rc     ! Two layer canopy resitance
         Real               :: Rinc   ! In canopy resistance for two layer model 

         RD_GW = RD_Smooth_E20(VGHAT, Ustar, 0.0, SC, NU, wet )
         If( lai .gt. 0.0 .and. veg .gt. 0.0 ) Then
            Rinc      = Calc_Rinc( Ra, lai )
            RD_VegL   = RD_Veg_E20( Vghat, Ustar, SC,l_aero, lai, DG, wet, Alpha, EINHAT )
            RD_VegG   = RD_Smooth_E20(VGHAT, Ustar, lai, SC, NU, wet )
! Resistance to:                  Soil              Canopy
            Rc   = 1.0 /( 1.0/(Rinc + RD_VegG) + 1.0/RD_VegL )  
            depv =       veg   * Vghat / ( 1.0 - EXP( -Vghat * ( Ra + Rc ) ) ) +  
     &           ( 1.0 - veg ) * Vghat / ( 1.0 - EXP( -Vghat * ( Ra + RD_GW ) ) )
         Else
            depv = Vghat / ( 1.0 - EXP( -Vghat * ( Ra + RD_GW ) ) )
         End If
         End Function aero_depv_E20
!-------------------------------------------------------------------------------------------------
! Brownian Diffusion Collection Efficiency 
! Following Emerson et al 2020 PNAS https://www.pnas.org/cgi/doi/10.1073/pnas.2014761117
!-------------------------------------------------------------------------------------------------
         Pure Function Calc_EIB_E20( SC ) Result( EIB )

         Implicit None

         Real, Intent( IN ) :: SC
         Real               :: EIB
         Real, Parameter    :: CIB = 0.2

         EIB = CIB * SC ** (-twothirds)

         End Function Calc_EIB_E20
!-------------------------------------------------------------------------------------------------
! Impaction Collection Efficiency for vegetation
! Following Emerson et al 2020 PNAS https://www.pnas.org/cgi/doi/10.1073/pnas.2014761117
!-------------------------------------------------------------------------------------------------
         Pure Function EIM_Veg_E20( ST, Alpha ) Result( EIM )

         Implicit None

         Real, Intent( IN ) :: ST
         Real, Intent( IN ) :: Alpha        ! Zhang et al 2010 Table 3
         Real               :: EIM
         Real, Parameter    :: CIM = 0.4    ! Emerson et al. 2020 (Table S1)
         Real, Parameter    :: Beta = 1.7

         EIM     = CIM * ( ST /( Alpha + ST ) ) ** Beta ! Emerson et al 2020 equation 4           

         End Function EIM_Veg_E20
!-------------------------------------------------------------------------------------------------
! Impaction Collection Efficiency for water and soil surfaces following Giorgi 1986
!-------------------------------------------------------------------------------------------------
         Pure Function EIM_Smooth_E20( ST ) Result( EIM )

         Implicit None

         Real, Intent( IN ) :: ST
         Real               :: EIM
         Real, Parameter    :: CIM = 0.4     ! Emerson et al 2020 (Table S1)
         Real, Parameter    :: Alpha = 100.0 ! Zhang et al. 2001 Table 3
         Real, Parameter    :: Beta = 1.7

         EIM     = CIM * ( ST /( Alpha + ST ) ) ** Beta ! Emerson et al 2020 equation 4           

         End Function EIM_Smooth_E20

!-------------------------------------------------------------------------------------------------
! Interception Collection Efficiency for vegetation following Emerson et al 2020
!-------------------------------------------------------------------------------------------------
         Pure Function EIN_Veg_E20( Dp,l_aero ) Result( EIN )

         Implicit None

         Real, Intent( IN ) :: Dp
         Real, Intent( IN ) :: l_aero
         Real               :: EIN
         Real, Parameter    :: CIN = 2.5

         EIN     = CIN * ( Dp / l_aero ) ** 0.8 ! Emerson et al 2020 equation            

         End Function EIN_Veg_E20

!-------------------------------------------------------------------------------------------------
!                           Aerosol Dry Deposition Code Following
!         Pleim et al 2022 
! 
!-------------------------------------------------------------------------------------------------
!-------------------------------------------------------------------------------------------------
! Aerosol Deposition Velocity
!-------------------------------------------------------------------------------------------------
         Pure Function aero_depv_P22(veg, lai, bai, Ustar, Ubar, Ra, Water, aleaf, ahair, fhair, SC,
     &                               NU, VGHAT, SeaIce, SST) Result( depv )

         Implicit None

         Real,    Intent( IN ) :: veg
         Real,    Intent( IN ) :: lai
         Real,    Intent( IN ) :: bai
         Real,    Intent( IN ) :: Ustar
         Real,    Intent( IN ) :: Ubar
         Real,    Intent( IN ) :: Ra
         Logical, Intent( IN ) :: Water
         Real,    Intent( IN ) :: aleaf
         Real,    Intent( IN ) :: ahair
         Real,    Intent( IN ) :: fhair
         Real,    Intent( IN ) :: SC
         Real,    Intent( IN ) :: NU
         Real,    Intent( IN ) :: Vghat
         Real,    Intent( IN ) :: SeaIce
         Real,    Intent( IN ) :: SST
         Real                  :: depv
         Real                  :: RD_Can   ! Resistance to vegetation leaves
         Real                  :: RD_Smth   ! Resistance to vegetation ground
         Real                  :: Vdv    ! Vegetation deposition velocity
         Real                  :: Vdnv   ! Non-Vegetation depositon velocity
         
         Vdv  = 0.0
         Vdnv = 0.0
         If( lai .gt. 0.0 .and. veg .gt. 0.0 ) Then
            RD_Can    = RD_Veg_P22( Vghat, Ustar, SC, aleaf, ahair, fhair, lai )
            Vdv = Vghat  / ( 1.0 - EXP( -Vghat * ( Ra + RD_Can ) ) )
         End If
         If( 1.0 - veg .gt. 0.001 ) Then
            RD_Smth = RD_Smooth_P22(VGHAT, Ustar, Ubar, BAI, SC, NU, SST, SeaIce, Water )
            Vdnv      = Vghat / ( 1.0 - EXP( -Vghat * ( Ra + RD_Smth ) ) )
         End If
         depv = veg * Vdv + (1.0-veg)*Vdnv
         End Function aero_depv_P22

         Pure Function RD_Veg_P22(Vghat, ustar, SC, aleaf, ahair, fhair, lai ) Result( RD )
         
         Use Const, only: GRAV         
         Implicit None

         Real, Intent( IN ) :: Vghat
         Real, Intent( IN ) :: ustar
         Real, Intent( IN ) :: SC
         Real, Intent( IN ) :: aleaf
         Real, Intent( IN ) :: ahair
         Real, Intent( IN ) :: fhair
         Real, Intent( IN ) :: lai
         Real               :: RD
         Real               :: veg_ustar 
         Real               :: ST1
         Real               :: ST2
         Real               :: EIM 
         Real               :: EIB 

! Integration of lai(z)/hc u*(z) from 0 to hc.   
         veg_ustar = max(1.0,lai) * ustar ! Replaces the constant 3 in Zhang et 2001
         ST1       = Vghat * ustar / ( GRAV * aleaf )
         ST2       = Vghat * ustar / ( GRAV * ahair )
         EIB       = Calc_EIB_Land_P22( SC )
         EIM       = EIM_Veg_P22( ST1, ST2, fhair )
         RD        = 1.0 / ( veg_ustar * ( EIB + EIM ) )

         End Function RD_Veg_P22

!-------------------------------------------------------------------------------------------------
! Aerosol surface resistance for water and bare soil surfaces
!-------------------------------------------------------------------------------------------------
         Pure Function RD_Smooth_P22(Vghat, ustar, Ubar, BAI, SC, nu, SST, SeaIce, water ) Result( RD )
                  
         Use CONST, ONLY: GRAV
         Implicit None

         Real,    Intent( IN ) :: Vghat
         Real,    Intent( IN ) :: ustar
         Real,    Intent( IN ) :: Ubar
         Real,    Intent( IN ) :: BAI
         Real,    Intent( IN ) :: SC
         Real,    Intent( IN ) :: nu
         Real,    Intent( IN ) :: SST
         Real,    Intent( IN ) :: SeaIce
         Logical, Intent( IN ) :: Water
         Real                  :: RD
         Real                  :: ST
         Real                  :: EIM
         Real                  :: EIB

         ST      = Vghat * ustar**2 / ( GRAV * nu )
         If( Water .and. SST .gt. -31.0 .And. SeaIce .lt. 0.5 ) Then
            EIB  = Calc_EIB_Water_P22( SC, Ubar, ustar, SST )
         Else 
            EIB  = Calc_EIB_Land_P22( SC )
         End If
         EIM     = EIM_SMOOTH_P22( ST )
         RD      = 1.0 / ( ustar * BAI * ( EIB + EIM ) )

         End Function RD_Smooth_P22
!-------------------------------------------------------------------------------------------------
         Pure Function Calc_EIB_Land_P22( SC ) Result( EIB )

         Implicit None

         Real, Intent( IN ) :: SC
         Real               :: EIB
         Real, Parameter    :: CIB = 1.0/3.0

         EIB = CIB * SC ** (-twothirds)

         End Function Calc_EIB_Land_P22

! For water include effects of whitecaps - Hummelshoj et al. (1992)
         Pure Function Calc_EIB_Water_P22( SC, Ubar, ustar, SST ) Result( EIB )

         Implicit None

         Real, Intent( IN ) :: SC
         Real, Intent( IN ) :: Ubar
         Real, Intent( IN ) :: ustar
         Real, Intent( IN ) :: SST
         Real               :: EIB
         Real               :: alfbob
         Real               :: awc
         Real               :: bwc
         Real               :: Ewc 
         Real, Parameter    :: CIB = 1.0/3.0
         
         awc    = 8.46e-5 + 1.63e-6 * SST - 3.35e-8 * SST**2
         bwc    = 3.354 - 0.062 * SST
         alfbob = awc * ( Ubar + bwc )**2   ! Albert 2016 with SST deg-C
         Ewc    = alfbob * ustar/Ubar
         EIB    = CIB * (1.0-alfbob) * SC ** (-twothirds) + Ewc

         End Function Calc_EIB_Water_P22
!-------------------------------------------------------------------------------------------------
         Pure Function EIM_Veg_P22( ST1, ST2, fhair ) Result( EIM )

         Implicit None

         Real, Intent( IN ) :: ST1
         Real, Intent( IN ) :: ST2
         Real, Intent( IN ) :: fhair 
         Real               :: EIM

         EIM     = ( 1.0 - fhair ) * ST1**2 /( 1.0 + ST1**2 ) + 
     &                     fhair   * ST2**2 /( 1.0 + ST2**2 )

         End Function EIM_Veg_P22

!-------------------------------------------------------------------------------------------------
         Pure Function EIM_SMOOTH_P22( ST ) Result( EIM )

         Implicit None

         Real, Intent( IN ) :: ST
         Real               :: EIM

         EIM     = 10.0**(-3.0/ST)

         End Function EIM_SMOOTH_P22

      End Module Resist_Funcs

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
       SUBROUTINE PA_OUTPUT( CGRID, JDATE, JTIME )

C-----------------------------------------------------------------------
C Function: Output the Process Analysis and/or Integrated Reaction Rate data           
 
C Preconditions: None
 
C Key Subroutines/Functions Called: M3EXIT
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  allow env var for file names Jeff, Dec, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified 1/19/99 by David Wong at LM:
C        -- add four include files because of new PA_CMN.EXT
C        -- add DATA_COPY function call to redistribute PA grid
C  Modified 2/26/99 by David Wong at LM:
C        -- remove SUBST_AE_SPC, SUBST_NR_SPC, SUBST_TR_SPC,
C           three .EXT files
C        -- replaced DATA_COPY function with dimension specific
C           DATA_COPY function and modified its argument list
C        -- used ifdef statement to distinguish parallel
C           implementation of IRR calculation which does not
C           start at the origin
C  Modified 22 Nov 00 by J.Young: Dave Wong's f90 stenex DATA_COPY
C  30 Mar 01 J.Young: dyn alloc - Use PAGRD_DEFN, which Uses
C                                 HGRD_DEFN; requires DBUFF for WRITE3
C  10 Oct 01 David Wong
C        -- use DBUFF to hold the output data for IRR data since
C           parallel WRITE3 can't output subsection of data
C        -- removed the usage of DBUFF for PA output
C        -- used a new formula to compute number of indexes in
C           each IPR and IRR output file rather than file header
C           to remove the call of DESC3 and use IPRFNAM and 
C           IRRNAME to determine variable name
C  10 Sep 02 J.Young: fix bug in IPRNAME, IRRNAME index
C  31 Jan 05 J.Young: dyn alloc - establish both horizontal &
C                     vertical domain specifications in one module (GRID_CONF)
C  23 Aug 05 David Wong
C        -- inserted PIO_INIT subroutine calls before and after
C           outputing PA data which is smaller than the model
C           domain size, to compute data indices correctly in each
C           processor for the entire PARIO library functions
C  15 Feb 06 J.Young: new pario PIO_RE_INIT from PIO_INIT to add flag
C                     to control printing decomposition map
C  10 Jul 10 J.Young: restructure so as to not keep reallocating DBUFF for IRR
C  16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C  26 Jan 16 J.Young: consolidated pio_init, flag for couple/decouple
C  16 Sep 16 J.Young: update for inline procan
C   7 Oct 16 J.Young: write domain re-decomp to log only on first call
C  17 Jan 24 D. Wong: fixed a bug that IRR/IPR process alllows a subset of
C                     level, a..b, where 1 <= a <= b <= NLAYS
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE PAGRD_DEFN            ! PA horiz domain specs
      USE UTILIO_DEFN           ! inherits PARUTILIO
#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE, SE_DATA_COPY_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE, NOOP_DATA_COPY_MODULE)
#endif
#endif
      USE PA_DEFN               ! Process Anaylsis control and data variables

      IMPLICIT NONE 

C Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:
      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: JDATE    ! current model date, format YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME    ! current model time, format HHMMSS

C Parameters: None 

C External Functions: None 

C Local Variables: 
      CHARACTER( 16 ), SAVE :: PNAME = 'PA_OUTPUT'
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: IPRFNAM( : )  ! IPR output file names
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: IRRFNAM( : )  ! IRR output file names
      INTEGER, SAVE :: NIPRFLS          ! Number of IPR output files
      INTEGER, SAVE :: NIRRFLS          ! Number of IRR output files
      LOGICAL, SAVE :: LFIRST = .TRUE.  ! Flag for first call

      CHARACTER( 80 ) ::  XMSG = ' '    ! Error message buffer

      INTEGER C         ! Loop index for columns
      INTEGER ICG       ! Index for species in cgrid array
      INTEGER L         ! Loop index for layers
      INTEGER NIRR      ! Loop index for IRR output variables
      INTEGER NFL       ! Loop index for no. of files
      INTEGER NOUT      ! Loop index for PA output variables
      INTEGER R         ! Loop index for rows
#ifndef parallel
      INTEGER PC        ! index for window column
      INTEGER PR        ! index for window row
      INTEGER PL        ! index for window level
#endif
      INTEGER VARINDX   ! Index for output variable
      INTEGER NVARINDX  ! number of output variable
      INTEGER allocstat
     
#ifdef parallel
      CHARACTER( 2 ) :: COLROW = 'CR'  ! col/row arg list order for pio_re_init
      LOGICAL :: WFLG                  ! pio_init - print decomposition
#endif

C-----------------------------------------------------------------------

#ifndef mpas
      if (.not. allocated(IPRFNAM)) then
         allocate (IPRFNAM( MXFILE3 ),
     $             IRRFNAM( MXFILE3 ),
     $             stat=allocstat)
      end if

#ifdef parallel
      IF ( .NOT. LFIRST ) THEN
C Reset decomposition map
         IF ( .NOT. PIO_INIT( COLROW, PACOLS, PAROWS, PALEVS, NTHIK,
     &                        MY_PACOLS, MY_PAROWS, NPCOL, NPROW, NPCOL*NPROW,
     &                        MYPE ) ) THEN
            XMSG = 'Failed to re-initialize parallel I/O library.'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            RETURN
         END IF
      END IF
#endif

C On first call, get and save the output file names 
      IF ( LFIRST ) THEN

#ifdef parallel
C Reset decomposition map
         IF ( .NOT. PIO_INIT( COLROW, PACOLS, PAROWS, PALEVS, NTHIK,
     &                        MY_PACOLS, MY_PAROWS, NPCOL, NPROW, NPCOL*NPROW,
     &                        MYPE, WFLG = .TRUE. ) ) THEN
            XMSG = 'Failed to re-initialize parallel I/O library.'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            RETURN
         END IF
#endif

         IF ( LIPR .AND. NIPRVAR. GT. 0 ) THEN

            IF ( MOD( NIPRVAR, MXVARS3 ) .EQ. 0 ) THEN
               NIPRFLS = NIPRVAR / MXVARS3
            ELSE
               NIPRFLS = ( NIPRVAR / MXVARS3 ) + 1
            END IF

            DO NFL = 1, NIPRFLS

               IF ( NFL .EQ. 1 ) THEN
                  IPRFNAM( NFL ) = CTM_IPR_1
               ELSE IF ( NFL .EQ. 2 ) THEN
                  IPRFNAM( NFL ) = CTM_IPR_2
               ELSE IF ( NFL .EQ. 3 ) THEN
                  IPRFNAM( NFL ) = CTM_IPR_3
               ELSE IF ( NFL .GT. 3 ) THEN
                  XMSG = 'Maximum number of IPR output files exceeded'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF

               IF ( MYPE .EQ. 0 ) THEN
                  IF ( .NOT. OPEN3( IPRFNAM( NFL ), FSRDWR3, PNAME ) ) THEN
                     XMSG = 'Could not open Integrated Process Rate Output File: '
     &                    // IPRFNAM( NFL )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               END IF

            END DO

         END IF

         IF ( LIRR .AND. NIRRVAR. GT. 0 ) THEN

            IF ( MOD( NIRRVAR, MXVARS3 ) .EQ. 0 ) THEN
               NIRRFLS = NIRRVAR / MXVARS3
            ELSE
               NIRRFLS = ( NIRRVAR / MXVARS3 ) + 1
            END IF

            DO NFL = 1, NIRRFLS
  
               IF ( NFL .EQ. 1 ) THEN
                  IRRFNAM( NFL ) = CTM_IRR_1
               ELSE IF ( NFL .EQ. 2 ) THEN
                  IRRFNAM( NFL ) = CTM_IRR_2
               ELSE IF ( NFL .EQ. 3 ) THEN
                  IRRFNAM( NFL ) = CTM_IRR_3
               ELSE IF ( NFL .GT. 3 ) THEN
                  XMSG = 'Maximum number of IRR output files exceeded'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF

               IF ( MYPE .EQ. 0 ) THEN
                  IF ( .NOT. OPEN3( IRRFNAM( NFL ), FSRDWR3, PNAME ) ) THEN
                     XMSG = 'Could not open Integrated Reaction Rate Output File: '
     &                    // IRRFNAM( NFL )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               END IF

            END DO

         END IF

      END IF    ! LFIRST

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Output Process analysis data and re-initialize arrays
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LIPR ) THEN

         DO NFL = 1, NIPRFLS

            NVARINDX = MIN ( MXVARS3, NIPRVAR - (NFL - 1) * MXVARS3 )

            DO NOUT = 1, NVARINDX
               VARINDX = ( NFL - 1 ) * MXVARS3 + NOUT

               IF ( .NOT. WRITE3( IPRFNAM( NFL ), IPRNAME( VARINDX ),
     &                 JDATE, JTIME, DELC( :,:,:,VARINDX ) ) ) THEN 
                  XMSG = 'Could not write ' // IPRFNAM( NFL )
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

            END DO

            WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &            'Timestep written to', IPRFNAM( NFL ),
     &            'for date and time', JDATE, JTIME
         END DO

         DO NOUT = 1, NIPRVAR
            DO L = 1, PALEVS
               DO R = 1, MY_PAROWS
                  DO C = 1, MY_PACOLS
                     DELC( C,R,L,NOUT ) = 0.0
                  END DO
               END DO
            END DO
         END DO

      END IF   ! IPR

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Output the IRR data and re-initialize arrays
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LIRR ) THEN

         DO NFL = 1, NIRRFLS

            NVARINDX = MIN (MXVARS3, NIRRVAR - (NFL - 1) * MXVARS3)

            DO NOUT = 1, NVARINDX
               VARINDX = ( NFL - 1 ) * MXVARS3 + NOUT

#ifdef parallel
!              write( logdev,* ) 'paout-nout,varindx,my_pacols,etc,sizes: ',
!    &         nout, varindx, my_pacols, my_parows, palevs,
!    &         size( irrout,1 ), size( irrout,2 ), size( irrout,3 ),
!    &         size( irrout,4 ), size( tirrout,1 ), size( tirrout,2 ),
!    &         size( tirrout,3 ), size( dbuff,1 ), size( dbuff,2 ),
!    &         size( dbuff,3 ) 
               CALL SUBST_DATA_COPY ( IRROUT, DBUFF, VARINDX, 1 )
#else
               DBUFF = IRROUT( 1:MY_PACOLS,1:MY_PAROWS,1:PALEVS,VARINDX )
#endif
               IF ( .NOT. WRITE3( IRRFNAM( NFL ), IRRNAME( VARINDX ),
     &              JDATE, JTIME, DBUFF ) ) THEN 
                  XMSG = 'Could not write ' // IRRFNAM( NFL )
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

            END DO

            WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &            'Timestep written to', IRRFNAM( NFL ),
     &            'for date and time', JDATE, JTIME

         END DO

         DO NIRR = 1, NIRRVAR
         DO L = 1, PALEVS
#ifdef parallel
            DO R = MY_IRR_BEGROW, MY_IRR_ENDROW
               DO C = MY_IRR_BEGCOL, MY_IRR_ENDCOL
#else
            DO R = 1, MY_PAROWS
               DO C = 1, MY_PACOLS
#endif
                      IRROUT( C,R,L,NIRR ) = 0.0
                  END DO
               END DO
            END DO
         END DO

      END IF   ! IRR

#ifdef parallel
      IF ( .NOT. LFIRST ) THEN
C Reset decomposition map
         IF ( .NOT. PIO_INIT( COLROW, GL_NCOLS, GL_NROWS, NLAYS, NTHIK,
     &                        NCOLS, NROWS, NPCOL, NPROW, NPCOL*NPROW,
     &                        MYPE ) ) THEN
            XMSG = 'Failed to re-initialize parallel I/O library.'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            RETURN
         END IF
      ELSE
         IF ( .NOT. PIO_INIT( COLROW, GL_NCOLS, GL_NROWS, NLAYS, NTHIK,
     &                        NCOLS, NROWS, NPCOL, NPROW, NPCOL*NPROW,
     &                        MYPE, WFLG = .TRUE. ) ) THEN
            XMSG = 'Failed to re-initialize parallel I/O library.'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            RETURN
         END IF
      END IF
#endif
#endif

      IF ( LFIRST ) THEN
         LFIRST = .FALSE.
      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE ADVSTEP( JDATE, JTIME, TSTEP, ASTEP, NREPS )

C-----------------------------------------------------------------------
C Function:
C    Use Courant-number conditions to determine the (time-splitting) model
C    base synchronization time step TSTEP(2) and number NREPS of sync time
C    steps per output time step TSTEP(1). The base synchronization time step
C    is considered to be the Courant condition safe advection time step.
C    Minimum returned sync time step = 900 sec
C    Determines a Courant condition safe advection step in TSTEP(3) with
C    respect to a user-defined minimum sync time step [TSTEP(2)].

C    June 2003 J.Young
C    Restructure to produce layer dependent advection step
C    change arguments:
C       TSTEP( 1 ) = output timestep (same) - input
C       TSTEP( 2 ) = synchronization timestep (same) - output
C       eliminate TSTEP( 3 ). Add new argument ASTEP( NLAYS ) - output

C Preconditions:

C Subroutines and functions called:
C    SEC2TIME, TIME2SEC, DESC3, M3EXIT, HVELOC

C Revision history:
C    prototype 2/93 by CJC
C    configuration management prototype 6/94 by Dongming Hwang

C    Apr 15, 1996 by M. Talat Odman at NCSC:  the number of model time
C    steps is made even to assure symmetry of transport operators within
C    each output time step.

C    Jan 20, 1996 by M. Talat Odman at NCSC:  now applies the CFL condition
C    independently in all three contravariant directions and
C    finds minimum time step.

C    22 Apr 97 Jeff: only for horizontal advection
C                    keep Talat's even step mod for symmetric sciproc
C     2 Sep 97 Jeff: calc. separate sync and adv time steps, TSTEP(3)
C    12 Feb 98 Jeff: make sync step = chem step
C    27 Jun 98 Jeff: allow for constant vel field (time-independent file)

C    2 October, 1998 by Al Bourgeois at LM: parallel implementation
C
C    8 Jan 99 by David Wong at LM: GLOBAL_MAX function call is added
C
C    1/19/99 David Wong
C      -- add a loop_index call
C      -- change loop index ending point to avoid accessing invalid region.
C         (reason to do this is to prevent using boundary data from PINTERP,
C          which sets pseudo-boundary data to 0)
C
C    9 Jun 99 by David Wong at LM: change GLOBAL_MAX to GLOBAL_RMAX
C    21 Nov 00 J.Young: GLOBAL_RMAX -> Dave Wong's f90 stenex GLOBAL_MAX
C    Jeff - Feb 01 - module LOCALFILE to set CCTM IOAPI file defn's
C                  - assumed shape arrays
C   30 Mar 01 J.Young: Use HGRD_DEFN; replace INTERP3 with INTERPX
C    9 Sep 03 J.Young: return layer dependent advection tstep, ASTEP
C   27 Aug 03 J.Young: symmetric processing is now deprecated
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   26 Jul 06 J.Young: add WRF sigma VGTYP
C   27 Apr 07 J.Young: Using Peter Percell's (UH) two timestep max wind
C   20 Jan 09 J.Young: In addition to the CFL criterion, use horizontal divergence
C                      to establish safe advection time step
C   28 Oct 09 J.Young: Revert back from Percell's algorithm to Talat's fix for
C                      multiple adv steps per sync step
C   16 Mar 10 J.Young: Fix hdiv bug for MPI by communicating ghost cell data using
C                      new hveloc to add hdiv and replace hcontvel
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   10 May 11 D.Wong: incorporated twoway model implementation
C    6 Apr 12 J.Young: changed default HDIV_LIM to 0.9; made CFL an env var
C    1 Nov 18 David Wong: removed MY_N clause for NCOLS and NROWS
C    1 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C   20 Nov 19 F. Sidi: Updated MET STIME, SDATE, TSTEP, XCELL, YCELL to correspond
C                      to updates in Centralized I/O 
C   10 Feb 20 D. Wong: Updated sync step calculation to include input 
C                      meterology temporal frequency, to allow running with
C                      finer temporal scale.
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_GLOBAL_MAX_MODULE, SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_GLOBAL_MAX_MODULE, NOOP_UTIL_MODULE)
#endif
      USE centralized_io_module
      USE CONST, ONLY: DG2M, PI180

      IMPLICIT NONE

C Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:
      INTEGER, INTENT( IN ) :: JDATE ! current model simulation date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME ! current model simulation time (HHMMSS)
      INTEGER, INTENT( INOUT ) :: TSTEP( 3 ) ! time step vector (HHMMSS)
                                ! TSTEP( 1 ) = local output step - INTENT( IN )
                                ! TSTEP( 2 ) = sciproc sync. step (chem) - INTENT( OUT )
                                ! TSTEP( 3 ) = twoway model time step w.r.t. wrf time
                                !              step and wrf/cmaq call frequency
      INTEGER, INTENT( OUT ) :: ASTEP( : )   ! layer advection sub-steps per sync step
                                             ! (HHMMSS)
      INTEGER, INTENT( OUT ) :: NREPS        ! no. of sync steps per output step

C Parameters:

C External Functions:

C Local Variables:
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      INTEGER, SAVE :: ADVLAYR       ! adv=sync at least up to this level

      INTEGER, SAVE :: WSTEP = 0     ! wind file interpolation time step
      INTEGER, SAVE :: SDATE, STIME  ! wind file start date and time
      INTEGER, SAVE :: FDATE, FTIME  ! wind file current date and time
      INTEGER, SAVE :: FSTEP         ! wind file time step
      INTEGER, SAVE :: OSTEP         ! output time step (sec)

      REAL,    SAVE :: IDX1, IDX2    ! 1/dx1, 1/dx2

      INTEGER :: MINSECS             ! effective MINSYNC (sec) that divides TSTEP(1)
 
      INTEGER :: C, R, L, K  ! loop counters
      INTEGER :: EDATE, ETIME
      INTEGER :: SYNC, SUB, REP      ! loop variables
      INTEGER :: ADV, TADV           ! test sub adv step
      INTEGER :: NADVS( NLAYS )      ! no. of advection sub-steps per sync step
      REAL    :: RSYNC
      REAL    :: MXUOVDX             ! max ( WIND / DS ) all layers 1, ADVLAYR
      LOGICAL :: ADJFLG

      REAL    :: UWIND( NCOLS+1,NROWS+1,NLAYS )
      REAL    :: VWIND( NCOLS+1,NROWS+1,NLAYS )
      REAL    :: HDIV( NCOLS,NROWS,NLAYS )
                                                    ! MAX ( WIND / DS ) ...
      REAL, ALLOCATABLE, SAVE :: WIND_IDX_BEG( : )  ! at beginning of output step
      REAL, ALLOCATABLE, SAVE :: WIND_IDX_END( : )  ! at end of output step
      REAL, ALLOCATABLE, SAVE :: WIND_IDX    ( : )  ! for whole output step
      REAL, ALLOCATABLE, SAVE :: MX_HDIV_BEG( : )   ! at beginning of output step
      REAL, ALLOCATABLE, SAVE :: MX_HDIV_END( : )   ! at end of output step
      REAL, ALLOCATABLE, SAVE :: MX_HDIV    ( : )   ! for whole output step

      REAL(8), PARAMETER :: TOL = 1.D-3 ! Tolerance Parameter for checking that grid 
                                        ! specifications from input files match those 
                                        ! in the model. Units are in meters.

      CHARACTER( 16 ) :: PNAME = 'ADVSTEP'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER :: ALLOCSTAT

      CHARACTER( 80 ) :: VARDESC  ! environment variable description

      INTERFACE
        SUBROUTINE HVELOC( FDATE, FTIME, FSTEP, UWIND, VWIND, HDIV )
            INTEGER, INTENT( IN )  :: FDATE, FTIME, FSTEP
            REAL,    INTENT( OUT ) :: UWIND( :,:,: ), VWIND( :,:,: )
            REAL,    INTENT( OUT ) :: HDIV( :,:,: )
         END SUBROUTINE HVELOC
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         CALL LOG_HEADING( LOGDEV, 'INITIALIZE ADVECTION STEPPING' )

         IF ( SIGST .GT. VGLVS_GD( 2 ) .OR.
     &        SIGST .LT. VGLVS_GD( NLAYS + 1 ) ) THEN
            WRITE(XMSG, '(A, 1PE12.3)') 'SIGMA_SYNC_TOP incorrect', SIGST
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF

         IF ( SIGST .EQ. VGLVS_GD( NLAYS + 1 ) ) THEN
            L = NLAYS
         ELSE
            DO K = 1, NLAYS
               IF ( SIGST .GE. VGLVS_GD( K+1 ) ) THEN
                  IF ( SIGST - VGLVS_GD( K+1 ) .LE.
     &                 VGLVS_GD( K ) - SIGST )  THEN
                     L = K
                  ELSE
                     L = K - 1
                  END IF
                  EXIT
               END IF
            END DO
         END IF

         ADVLAYR = L
         WRITE( LOGDEV,92005 ) ADVLAYR

         SDATE = FILE_SDATE(F_MET)
         STIME = FILE_STIME(F_MET)
         FSTEP = FILE_TSTEP(F_MET)

C Check file data against COORD.EXT

         IF ( ABS( FILE_XCELL(F_MET) - XCELL_GD ) .GT. TOL .OR.
     &        ABS( FILE_YCELL(F_MET) - YCELL_GD ) .GT. TOL      ) THEN
            WRITE( LOGDEV,* ) 'XCELL3D, XCELL_GD, YCELL3D, YCELL_GD: '
            WRITE( LOGDEV,* ) XCELL3D, XCELL_GD, YCELL3D,YCELL_GD
            XMSG = 'File grid sizes do not match CTM domain definition'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

C Get cell size in meters (from COORD.EXT)

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            IDX2 = 1.0 / ( DG2M * YCELL_GD )
            IDX1 = 1.0 / ( DG2M * XCELL_GD
     &           * COS( PI180*( YORIG_GD + YCELL_GD*FLOAT( NROWS/2 ) ) ) )
         ELSE
            IDX1 = 1.0 / XCELL_GD
            IDX2 = 1.0 / YCELL_GD
         END IF

C Get the time of starting wind field: do not interpolate
         IF ( .NOT. CURRSTEP( JDATE, JTIME, SDATE, STIME, FSTEP,
     &                        FDATE, FTIME) ) THEN
            XMSG = 'Cannot get step-starting date and time'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

         ALLOCATE( WIND_IDX_BEG( NLAYS ),
     &             WIND_IDX_END( NLAYS ),
     &             WIND_IDX    ( NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating WIND_IDX*'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE( MX_HDIV_BEG( NLAYS ),
     &             MX_HDIV_END( NLAYS ),
     &             MX_HDIV    ( NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating MX_HDIV*'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
 
         IF ( .NOT. COLUMN_MODEL ) THEN

            CALL HVELOC( FDATE, FTIME, WSTEP, UWIND, VWIND, HDIV )

            DO L = 1, NLAYS
               WIND_IDX_BEG( L ) = 0.0
               MX_HDIV_BEG( L ) = 0.0
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     WIND_IDX_BEG( L ) = MAX( WIND_IDX_BEG( L ),
     &                                   ABS( UWIND( C,R,L ) ) * IDX1,
     &                                   ABS( VWIND( C,R,L ) ) * IDX2 )
                     MX_HDIV_BEG( L ) = MAX( MX_HDIV_BEG( L ), HDIV( C,R,L ) )
                  END DO
               END DO
               WIND_IDX_BEG( L ) = SUBST_GLOBAL_MAX( WIND_IDX_BEG( L ) )
               MX_HDIV_BEG( L )  = SUBST_GLOBAL_MAX( MX_HDIV_BEG( L ) )
            END DO

         ELSE

            UWIND = 0.0
            VWIND = 0.0
            HDIV  = 0.0
            WIND_IDX     = 0.0
            MX_HDIV      = 0.0
            WIND_IDX_BEG = 0.0
            WIND_IDX_END = 0.0
            MX_HDIV_END  = 0.0
            MX_HDIV_BEG  = 0.0

         END IF
      END IF   ! FIRSTIME

C Compute the least number of equal time steps that satisfy the Courant
C condition (force TSTEP(2) to be no greater than MAXSYNC):

#ifdef twoway
      OSTEP = TIME2SEC( TSTEP( 3 ) )
#else
      OSTEP = TIME2SEC( min(TSTEP( 1 ), FSTEP) )
#endif
      MAXSYNC = MIN( OSTEP, MAXSYNC )

C Make sure MINSYNC <= output time step
      IF ( MINSYNC .GT. OSTEP ) THEN
         WRITE( LOGDEV,92009 ) OSTEP, MINSYNC
         XMSG = ' '
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      END IF

C Make sure MINSYNC <= MAXSYNC
      IF ( MINSYNC .GT. MAXSYNC ) THEN
         WRITE( LOGDEV,92010 ) MAXSYNC, MINSYNC
         XMSG = ' '
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      END IF

C Determine MINSECS, the smallest time step (sec) between MINSYNC and MAXSYNC
C that divides the output step
      IF ( MINSYNC .LE. 1 ) THEN
         MINSECS = 1
      ELSE
         DO MINSECS = MINSYNC, MAXSYNC
            IF ( MOD( OSTEP, MINSECS ) .EQ. 0 ) THEN
               IF ( MINSECS .NE. MINSYNC )
     &              WRITE( LOGDEV,92011 ) JDATE, JTIME, MINSYNC, MINSECS
               EXIT
            ELSE IF ( MINSECS .LT. MAXSYNC ) THEN
               CYCLE
            END IF
C A satisfactory MINSECS could not be found
            WRITE( XMSG,92012 ) MINSYNC, OSTEP
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END DO
      END IF

C Establish ending time for this Courant number calculation:
      EDATE = JDATE
      ETIME = JTIME
#ifdef twoway
      CALL NEXTIME( EDATE, ETIME, TSTEP( 3 ) )
#else
      CALL NEXTIME( EDATE, ETIME, min(TSTEP( 1 ), FSTEP) )
#endif

      IF ( SECSDIFF( FDATE, FTIME, EDATE, ETIME ) .GT. 0 )
C Get the next wind field: do not interpolate
     &   CALL NEXTIME( FDATE, FTIME, FSTEP )

      IF ( .NOT. COLUMN_MODEL ) THEN

         CALL HVELOC( FDATE, FTIME, WSTEP, UWIND, VWIND, HDIV )

         DO L = 1, NLAYS
            WIND_IDX_END( L ) = 0.0
            MX_HDIV_END( L ) = 0.0
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  WIND_IDX_END( L ) = MAX( WIND_IDX_END( L ),
     &                                ABS( UWIND( C,R,L ) ) * IDX1,
     &                                ABS( VWIND( C,R,L ) ) * IDX2 )
                   MX_HDIV_END( L ) = MAX( MX_HDIV_END( L ), HDIV( C,R,L ) )
               END DO
            END DO
            WIND_IDX_END( L ) = SUBST_GLOBAL_MAX( WIND_IDX_END( L ) )
            MX_HDIV_END( L )  = SUBST_GLOBAL_MAX( MX_HDIV_END( L ) )
         END DO

      END IF

      WIND_IDX = MAX( WIND_IDX_BEG, WIND_IDX_END ) ! array
      WIND_IDX_BEG = WIND_IDX_END                  ! save for next call
      MX_HDIV = MAX( MX_HDIV_BEG, MX_HDIV_END )    ! array
      MX_HDIV_BEG = MX_HDIV_END                    ! save for next call

C Determine the synchronization timestep, TSTEP(2), and NREPS, the corresponding
C number of sync steps per output timestep

C Find the largest timestep that satisfies the Courant condition in all of the
C lower ADVLAYR layers. If this is smaller than MINSECS, then set the sync step
C to MINSECS. Otherwise, set the sync step to the largest time step that both
C satisfies the Courant condition and is an integer divisor of the output step
C (existence of such a sync step is guaranteed because, at this point, MINSECS
C satisfies both conditions).
      MXUOVDX = MAXVAL( WIND_IDX( 1:ADVLAYR ) )
      ADJFLG = .FALSE.
      DO REP = 1, OSTEP
         IF ( MOD( OSTEP, REP ) .EQ. 0 ) THEN   ! make TSTEP(2) divide TSTEP(1)
            SYNC = OSTEP / REP
            IF ( SYNC .LE. MAXSYNC ) THEN   ! enforce max TSTEP(2)
               ADV = SYNC
               IF ( MXUOVDX * REAL( ADV ) .LT. CFL ) THEN   ! CFL satisfied
                  IF ( SYNC .GE. MINSECS ) THEN   ! force min TSTEP(2)
                     NREPS = REP
                     GO TO 301
                  ELSE   ! multiple adv steps per sync step (= MINSECS)
                     SYNC = MINSECS
                     NREPS = OSTEP / MINSECS
                     DO SUB = 1, MINSECS
                        IF ( MOD( MINSECS, SUB ) .EQ. 0 ) THEN  ! make ADV divide TSTEP(2)
                           TADV = MINSECS / SUB
                           IF ( TADV .LE. ADV ) THEN
                              ADV = TADV
                              ADJFLG = .TRUE.
                              GO TO 301
                           END IF
                        END IF
                     END DO
                     GO TO 291   ! No solution
                  END IF
               END IF    ! if Courant condition satisfied
            END IF    ! if SYNC .le. MAXSYNC
         END IF    ! if REP divides STEP evenly
      END DO    ! REP loop

291   continue

C If you get here: could not determine satisfactory advection time step.

      WRITE( LOGDEV,94011 ) min(TSTEP( 1 ), FSTEP), MXUOVDX
      XMSG = ' '
      CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )

301   CONTINUE

      TSTEP( 2 ) = SEC2TIME( SYNC )
      DO L = 1, ADVLAYR
         ASTEP( L ) = SEC2TIME( ADV )
         NADVS( L ) = SYNC / ADV
      END DO

      IF ( ADJFLG ) THEN
         WRITE( LOGDEV,92019 ) MINSECS, TSTEP( 2 ), NREPS
      ELSE
         WRITE( LOGDEV,92021 ) TSTEP( 2 ), NREPS
      END IF

      DO L = ADVLAYR + 1, NLAYS
         DO REP = 1, SYNC
            IF ( MOD( SYNC, REP ) .EQ. 0 ) THEN
               ADV = SYNC / REP
               IF ( WIND_IDX( L ) * REAL( ADV ) .LT. CFL ) THEN  ! Layer CFL satisfied
                  NADVS( L ) = REP
                  ASTEP( L ) = SEC2TIME( ADV )
                  GO TO 401
               END IF   ! if courant condition satisfied
            END IF   !  if rep divides step
         END DO

C If you get here: could not determine satisfactory advection time step.

         WRITE( LOGDEV,94013 ) min(TSTEP( 1 ), FSTEP), L, WIND_IDX( L )
         XMSG = ' '
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )

401      CONTINUE

      END DO   ! layer loop

C For each layer ensure that Max(HDIV)*ADV < 1.

      WRITE( LOGDEV,92025 )
      DO L = NLAYS, 1, -1   ! start at the top, purely for the 92027, 92029 write
         ADV = TIME2SEC( ASTEP( L ) )
         IF ( REAL( ADV ) * MX_HDIV( L ) .LT. HDIV_LIM ) THEN
            WRITE( LOGDEV,92027 ) L, ASTEP( L ), NADVS( L )
            CYCLE
         ELSE
            SUB = ADV
            DO WHILE ( SUB .GT. 0 )
               SUB = SUB - 1
               IF ( MOD( SYNC, SUB ) .EQ. 0 ) THEN
                  ASTEP( L ) = SEC2TIME( SUB )
                  NADVS( L ) = SYNC / SUB
                  GO TO 501
               END IF
            END DO
C If you get here: could not determine satisfactory advection time step.

            WRITE( LOGDEV,94013 ) min(TSTEP( 1 ), FSTEP), L, WIND_IDX( L )
            XMSG = ' '
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )

501         CONTINUE
            WRITE( LOGDEV,92029 ) L, ASTEP( L ), NADVS( L )
         END IF
      END DO

      RETURN

C------------------  FORMAT  STATEMENTS   ------------------------------

92005 FORMAT(   5X, 'Top layer thru which sync step determined:', I3 )

92009 FORMAT( / 5X, 'Output time step:', I8,
     &          1X, 'less than minimum synchronization step:', I8 )

92010 FORMAT( / 5X, 'Maximum synchronization step:', I8,
     &          1X, 'less than minimum synchronization step:', I8 )

92011 FORMAT( / 5X, 'From ADVSTEP - date/time: ', I8, '/', I6.6
     &        / 5X, 'Minimum Synchronization Step adjusted from:', I8,
     &          1X, 'to:', I8 )

92012 FORMAT( / 5X, 'Starting from:', I6, ',',
     &          1X, 'could not determine minimum step that divides TSTEP',
     &          1X, 'for model step:', I7.6, ' HHMMSS' )

92019 FORMAT( / 5X, 'Synchronization step adjusted up to minimum (SEC):', I7
     &        /46X, '(HHMMSS): ', I6.6
     &        / 5X, 'Number of Synchronization steps:', I5  )

92021 FORMAT(   5X, 'Computed synchronization step (HHMMSS): ', I6.6
     &        / 5X, 'Number of Synchronization steps:', I5  )

92025 FORMAT( / 5X, 'Layer', 3X, 'Advection', 3X, 'per Sync'
     &        /11X, 'Step (HHMMSS)', 2X, 'Step' )

92027 FORMAT(   5X, I4, 6X, I6.6, 6X, I2 )
92029 FORMAT(   5X, I4, 6X, I6.6, 6X, I2, 2X, '<- Hdiv adjusted' )

94011 FORMAT( / 5X, 'Could not determine Courant-condition safe sync step',
     &          1X, 'for model step:', I7.6, ' HHMMSS',
     &        / 5X, '(Max vel)/(dX) =', 1PE10.3)

94013 FORMAT( / 5X, 'Could not determine Courant-condition safe sync step',
     &          1X, 'for model step:', I7.6, ' HHMMSS',
     &          1X, 'in layer:', I3
     &        / 5X, '(Max vel)/(dX) =', 1PE10.3)

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE RESCLD ( CGRD, JDATE, JTIME, TSTEP,
     &                    DEP, RESTRANS )

C-----------------------------------------------------------------------
C  FUNCTION: Resolved-scale CLOUD processor Models-3 science process:
 
C  Revision History:
C      No   Date   Who   What
C      -- -------- ---  -----------------------------------------
C       0 01/15/98 sjr  created program
C       1 03/09/98 sjr  made several revisions: fix to read sub-hourly
C                       rainfall data, reordered some of the code
C       2 12/15/98 David Wong at LM
C           -- changed division of GPKG to multiplication of GPKG reciprocal
C           -- interchanged loops structure in line 317
C       3 03/18/99 David Wong at LM
C           -- replace "* M2PHA * ONE_OVER_GPKG" by "* M2PHA_OVER_GPKG" which
C              is a new constant defined as M2PHA / GPKG
C       4 08/30/99 sjr  revised for new aerosol model (with 2nd moments)
C       5 Dec 00   Jeff move CGRID_MAP into f90 module
C       6 01/04/01 sjr  added QS and QI to total water content calcul.
C       7 Sep 01   Jeff Dyn Alloc - Use HGRD_DEFN
C       8 12/18/03 sjr & jp added QG in the water content calc
C       9 07 Dec 04 J.Young: Vert Dyn Alloc - Use VGRD_DEFN
C      10 31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                            domain specifications in one module
C      11 25 Mar 08 sjr fixed bug in the precipitation flux calculation:
C                       layer thickness now included in column integrated
C                       water content and in precipitation flux 
C                       calculations (bug reported by Raymond D Wright)
C      12 12 Aug 10 J.Young: replace CGRID mechanism include files with
C                    namelists and merge Shawn Roselle's, Sergey Napelenok's
C                    and Steve Howard's aerosol reengineering
C      13 01 Mar 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                    removed deprecated TRIMLEN
C      14 11 May D.Wong: incorporated twoway model implementation
C      15 01 Jul 11 G. Sarwar: calculate zenith angle to determine daytime and  
C                    nightime needed for sulfur oxidation via metal catalysis
C      16 02Aug12 S.Roselle:  instrumented to calculate and return
C                             transmissivity for resolved clouds
C      07 Nov 14 J.Bash: Updated call to czangle.F for the ASX_DATA_MOD shared data module. 
C      07 May 18 D. Schwede: Removed call to CZANGLE. COSZEN now calculated in ASX_DATA_MOD
C      26 Nov 18 S. Napelenok: ISAM implementation
C       1 Feb 19 D. Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C      01 AUG 19 D. Wong: Modified code to work with two-way model
C      11 Nov 19 F. Sidi: Changed MSTEP to accomdate Centralized I/O changesC      
C      30 Dec 19 S. Napelenok: ddm-3d implementaiton for version 5.3.1


C  Called by:  CLDPROC
 
C  Calls the following subroutines:  SCAVWDEP and AQ_MAP
C-----------------------------------------------------------------------

      USE RUNTIME_VARS, ONLY: STM
      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      USE AQ_DATA,       ONLY: JH2O2_HYDROMETEORS,  JHNO3_HYDROMETEORS
      USE AERO_DATA, ONLY : ASO4GAS_IDX, MAP_AERO, AEROSPC_MAP
      USE PRECURSOR_DATA, ONLY: SULF_IDX, PRECURSOR_MAP, MAP_PRECURSOR
      USE ASX_DATA_MOD,  ONLY: MET_DATA
      USE PHOT_MOD,      ONLY: RJ, RJ_RES, RJ_SUB, LH2O2, LHNO3
      USE CENTRALIZED_IO_MODULE
      USE CONST
#ifdef isam
      USE SA_DEFN, ONLY: ISAM, NSPC_SA, NTAG_SA, MAP_SAtoCGR, OTHRTAG, 
     &                   ISAM_SPEC, DEPSUM_SAVE, DS4_SAVE, REMOV_SAVE,
     &                   ITAG,TOT_SADEP,
     &                   DEPSUM_AORGC_SAVE, DGLY1_SAVE, DMGLY1_SAVE,
     &                   REMOV_AORGC_SAVE
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY: SENGRID, NP, NPMAX, S_CONDEP, S_POLC, 
     &                      S_CEND, S_REMOV, S_REMOVAC, S_CONDEP, 
     &                      S_TOTDEP
#endif 

#ifdef mpas
      use util_module, only : nextime, sec2time, TIME2SEC, currstep
#endif

      IMPLICIT NONE

C...........Includes:

      INCLUDE SUBST_FILES_ID             ! file name parameters

C...........Arguments:
      REAL, INTENT( INOUT )    :: CGRD( :,:,:,: ) ! concentrations
      INTEGER, INTENT( IN )    :: JDATE            ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )    :: JTIME            ! current model time, coded HHMMSS
      INTEGER, INTENT( IN )    :: TSTEP( 3 )       ! model time steps, coded HHMMSS
      REAL,    INTENT( INOUT ) :: DEP( :,:,: )     ! wet deposition
      REAL,    INTENT( OUT )   :: RESTRANS( :,: )  ! resolved cloud transmissivity

      CHARACTER( 120 ) :: XMSG  = ' '    ! Exit status message

C...........Parameters:
      REAL, PARAMETER :: PERMIN_TO_PERSEC = 1.0 / 60.0
      REAL, PARAMETER :: GPKG = 1.0E+03  ! g/kg
      REAL, PARAMETER :: M2PHA = 1.0E+04 ! 1 hectare = 1.0e4 m**2
      REAL, PARAMETER :: M2PHA_OVER_GPKG = M2PHA / GPKG

C Number of species in CGRID
      INTEGER, SAVE :: MXSPCS


C...........Local Variables:

      LOGICAL, SAVE :: FIRSTIME = .TRUE.   ! flag for first pass thru

      CHARACTER( 16 ), SAVE :: PNAME = 'RESCLD'    ! process name
      CHARACTER( 16 ), SAVE :: VNAME_RN

      INTEGER       COL                 ! column loop counter
      INTEGER       ROW                 ! row loop counter
      INTEGER       LAY                 ! layer loop counter
      INTEGER       FINI                ! ending position
      INTEGER       MDATE               ! process date (yyyyddd)
      INTEGER, SAVE :: MSTEP            ! met file time step (hhmmss)
      INTEGER       MTIME               ! process time (hhmmss)
      INTEGER, SAVE :: SDATE            ! met file start date
      INTEGER       SPC                 ! liquid species loop counter
      INTEGER       STRT                ! starting position
      INTEGER, SAVE :: STIME            ! met file start time
      INTEGER       TCLD                ! cloud lifetime (sec)
      INTEGER       VAR                 ! variable loop counter
      INTEGER       ALLOCSTAT           ! memory allocation status
      INTEGER       I

      REAL          AIRM                ! total airmass (mol/m2) in cloudy air
      REAL          ALFA0               ! aitken mode number scavenging coef
      REAL          ALFA2               ! aitken mode sfc area scavenging coef
      REAL          ALFA3               ! aitken mode mass scavenging coef
      REAL          CTHK1               ! cloud thickness (m)
      REAL          METSTEP             ! timestep on the met file (hr)
      SAVE          METSTEP
      REAL          PBARC               ! mean cloud pressure (Pa)
      REAL          PRATE1              ! storm rainfall rate (mm/hr)
      REAL          QCRGCOL             ! vert column integrated liquid water content
      REAL          QCRISGCOL           ! vert column integrated total water content
      REAL          QRSGCOL             ! vert column integrated precip content
      REAL          QCICOL              ! vert column integrated cloud content
      REAL          RAIN                ! non-conv rainfall rate (mm/hr)
      REAL          REMOVAC             ! variable storing H+ deposition
      REAL          TAUCLD              ! cloud lifetime (sec)
      REAL          TBARC               ! mean cloud temp (K)
      REAL          WCBAR               ! liq water content of cloud (kg/m3)
      REAL          WPBAR               ! precipitation water content (kg/m3)
      REAL          WTBAR               ! total water content of cloud (kg/m3)
      REAL          LWP, CLOD

      REAL, ALLOCATABLE, SAVE :: POLC ( : )   ! incloud conc (mol/mol)
      REAL, ALLOCATABLE, SAVE :: CEND ( : )   ! ending conc (mol/mol)
      REAL, ALLOCATABLE, SAVE :: REMOV( : )   ! moles/m2 or mm*mol/lit scavenged

      REAL          RN   ( NCOLS, NROWS ) ! non-convective rainfall (cm)
      REAL          DENS ( NCOLS, NROWS, NLAYS )  ! air density (kg/m3)
      REAL          DZZ  ( NCOLS, NROWS, NLAYS )  ! layer thickness (m)
      REAL          PRES ( NCOLS, NROWS, NLAYS )  ! air pressure (Pa)
      REAL          QC   ( NCOLS, NROWS, NLAYS )  ! cloud water content (kg/kg)
      REAL          QG   ( NCOLS, NROWS, NLAYS )  ! graupel content (kg/kg)
      REAL          QI   ( NCOLS, NROWS, NLAYS )  ! ice content (kg/kg)
      REAL          QR   ( NCOLS, NROWS, NLAYS )  ! rain water content (kg/kg)
      REAL          QS   ( NCOLS, NROWS, NLAYS )  ! snow content (kg/kg)
      REAL          TA   ( NCOLS, NROWS, NLAYS )  ! air temperature (K)
      REAL          ZF   ( NCOLS, NROWS, NLAYS )  ! level/layer-face height (m)

C Gridded meteorology data:
C Latitude and longitude for zenith angle calculation: Golam Sarwar * July 1, 2011 
      REAL          COSZ                            ! local cosine of zenith angle
      REAL          JH2O2                           ! H2O2 photolysis rate, 1/min 
      REAL          JHNO3                           ! HNO3 photolysis rate, 1/min 

#ifdef isam
      INTEGER, SAVE           :: S_SO2, S_SO4J, S_SULF
      INTEGER, SAVE           :: C_SO2, C_SO4J, C_SULF
      REAL, ALLOCATABLE, SAVE :: SA_POLC   ( :,: )
      REAL, ALLOCATABLE, SAVE :: SA_CEND   ( :,: )
      INTEGER                 :: CSPC
      REAL, ALLOCATABLE, SAVE :: SA_DS4    ( : )
      REAL                    :: SA_SUM
      REAL, ALLOCATABLE, SAVE :: SA_REMOV  ( :,: )
      INTEGER, SAVE           :: S_GLY, S_MGLY, S_AORGCJ
      INTEGER, SAVE           :: C_GLY, C_MGLY, C_AORGCJ
      REAL, ALLOCATABLE, SAVE :: SA_DCSOA_GLY    ( : )
      REAL, ALLOCATABLE, SAVE :: SA_DCSOA_MGLY   ( : )
#endif

C...........External Functions:

      INTERFACE
        SUBROUTINE SCAVWDEP ( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                        CTHK1, AIRM, PRATE1, TAUCLD, POLC, CEND,
     &                        REMOV, REMOVAC, ALFA0, ALFA2, ALFA3 )
           INTEGER, INTENT( IN )  :: JDATE, JTIME
           REAL,    INTENT( IN )  :: WTBAR, WCBAR, TBARC, PBARC,
     &                               CTHK1, AIRM, PRATE1, TAUCLD
           REAL,    INTENT( IN )  :: POLC ( : )
           REAL,    INTENT( OUT ) :: REMOVAC
           REAL,    INTENT( OUT ) :: CEND( : ), REMOV( : )
           REAL,    INTENT( OUT ) :: ALFA0, ALFA2, ALFA3
        END SUBROUTINE SCAVWDEP
        SUBROUTINE AQ_MAP( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                     CTHK1, AIRM, PRATE1, TAUCLD, POLC, CEND,
     &                     REMOV, REMOVAC, ALFA0, ALFA2, ALFA3, COSZ )
           INTEGER, INTENT( IN )    :: JDATE, JTIME
           REAL,    INTENT( IN )    :: WTBAR, WCBAR, TBARC, PBARC,
     &                                 CTHK1, AIRM, PRATE1, TAUCLD
           REAL,    INTENT( IN )    :: POLC ( : )
           REAL,    INTENT( INOUT ) :: REMOVAC
           REAL,    INTENT( INOUT ) :: CEND( : ), REMOV( : )
           REAL,    INTENT( IN )    :: ALFA0, ALFA2, ALFA3, COSZ	
        END SUBROUTINE AQ_MAP
      END INTERFACE
C-----------------------------------------------------------------------

C...Initialization

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

C...Sulfur tracking
        IF ( STM ) THEN
          CALL MAP_AERO()
          CALL MAP_PRECURSOR()
        END IF

        IF (RNA_AVAIL) THEN
           VNAME_RN = 'RNA'
        ELSE
           VNAME_RN = 'RN'
        END IF

C...store met file time, date, and step information and compute
C...  the met timestep in hours

        SDATE = cio_model_sdate
        STIME = cio_model_stime
        MSTEP = file_tstep(f_met)

        METSTEP = FLOAT( TIME2SEC( MSTEP ) ) / 3600.0

        if ( .not. QI_AVAIL) then
          write (logdev, '(a)') 'Parameter QI (cloud ice) was not found on file '
          WRITE( LOGDEV, '(3(/10X,A),(/10X,3(A,1X)),(/10X,A))' )
     &           'YOU SHOULD VERIFY that the cloud microphysics scheme used',
     &           'in the Meteorological Model did not include ice/snow.  If',
     &           'it did, then you need to reprocess the meteorological data',
     &           'through MCIP and pass QI to file ',
     &           TRIM( MET_CRO_3D ), ' to avoid',
     &           'errors in the wet deposition.'
          WRITE( LOGDEV, '((/5X,A),/)' )
     &           'Processing will continue with QI set to ZERO.  <<---<<'
        END IF

        if ( .not. QS_AVAIL) then
          write (logdev, '(a)') 'Parameter QS (snow) was not found on file '
          WRITE( LOGDEV, '(3(/10X,A),(/10X,3(A,1X)),(/10X,A))' )
     &           'YOU SHOULD VERIFY that the cloud microphysics scheme used',
     &           'in the Meteorological Model did not include ice/snow.  If',
     &           'it did, then you need to reprocess the meteorological data',
     &           'through MCIP and pass QS to file ',
     &           TRIM( MET_CRO_3D ), ' to avoid',
     &           'errors in the wet deposition.'
          WRITE( LOGDEV, '((/5X,A),/)' )
     &           'Processing will continue with QS set to ZERO.  <<--<<'
        END IF

        MXSPCS = N_GC_SPCD + N_AE_SPC + N_NR_SPC + N_TR_SPC

        ALLOCATE ( CEND ( MXSPCS ),
     &             POLC ( MXSPCS ),
     &             REMOV( MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating CEND, POLC or REMOV'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

#ifdef isam
! move all this somewhere else eventually

        S_SO2  = INDEX1( 'SO2', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )
        S_SO4J = INDEX1( 'ASO4J', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )
        S_SULF = INDEX1( 'SULF', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )

        C_SO2  = INDEX1( 'SO2',   N_GC_SPC, GC_SPC )
        C_SO4J = INDEX1( 'ASO4J', N_AE_SPC, AE_SPC ) + 1 + N_GC_SPC
        C_SULF = INDEX1( 'SULF',  N_GC_SPC, GC_SPC )

        ALLOCATE ( SA_POLC  ( NSPC_SA, NTAG_SA ),
     &             SA_CEND  ( NSPC_SA, NTAG_SA ),
     &             SA_DS4   ( NTAG_SA ),
     &             SA_REMOV ( NSPC_SA, NTAG_SA ),
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating SA_POLC or SA_CEND'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        S_GLY    = INDEX1( 'GLY', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )
        S_MGLY   = INDEX1( 'MGLY', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )
        S_AORGCJ = INDEX1( 'AORGCJ', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )

        C_GLY    = INDEX1( 'GLY',   N_GC_SPC, GC_SPC )
        C_MGLY   = INDEX1( 'MGLY', N_GC_SPC, GC_SPC )
        C_AORGCJ = INDEX1( 'AORGCJ',  N_AE_SPC, AE_SPC ) + 1 + N_GC_SPC
        ALLOCATE ( SA_DCSOA_GLY ( NTAG_SA ),
     &             SA_DCSOA_MGLY ( NTAG_SA ),
     &             STAT = ALLOCSTAT )
#endif

#ifdef sens
        IF ( .NOT. ALLOCATED( S_CEND ) ) ALLOCATE ( S_CEND ( NPMAX, MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_CEND'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( .NOT. ALLOCATED( S_POLC ) ) ALLOCATE ( S_POLC ( NPMAX, MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_POLC'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( .NOT. ALLOCATED( S_REMOV ) ) ALLOCATE ( S_REMOV ( NPMAX, MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_REMOV'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( .NOT. ALLOCATED( S_REMOVAC ) ) ALLOCATE ( S_REMOVAC ( NPMAX ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_REMOVAC'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF 
        S_REMOVAC = 0.0
#endif

      END IF  ! FIRSTIME

      MDATE = JDATE
      MTIME = JTIME

C...set the cloud lifetime (=adv timestep)

      TCLD = TIME2SEC( TSTEP( 2 ) )
      TAUCLD = REAL( TCLD )

C...set time to the midpoint of this timestep for data interpolation

      CALL NEXTIME ( MDATE, MTIME, SEC2TIME( TCLD / 2 ) )

C...Actual Science Process (loop on internal process time steps):
C...  Interpolate time dependent layered input variables
C...  (reading those variables for which it is necessary)

C...  Get ambient temperature (K)

      call interpolate_var ('TA', mdate, mtime, TA)

C...Get resolved cloud water mixing ratio (kg H2O / kg air)

      call interpolate_var ('QC', MDATE, MTIME, QC )

C...Get resolved rain water mixing ratio (kg H2O / kg air)

      call interpolate_var ('QR', MDATE, MTIME, QR )

C...read resolved ice mixing ratio (kg H2O / kg air) from the met
C...  file if it is available

      IF ( QI_AVAIL ) THEN

        call interpolate_var ('QI', MDATE, MTIME, QI )

      ELSE

        QI = 0.0    ! otherwise fill the array with zeros

      END IF

C...read resolved snow mixing ratio (kg H2O / kg air) from the met
C...  file if it is available

      IF ( QS_AVAIL ) THEN

        call interpolate_var ('QS', MDATE, MTIME, QS )

      ELSE

        QS = 0.0    ! otherwise fill the array with zeros

      END IF

C...read graupel mixing ratio (kg H2O / kg air) from the met
C...  file if it is available

      IF ( QG_AVAIL ) THEN

         call interpolate_var ('QG', MDATE, MTIME, QG )

      ELSE

        QG = 0.0    ! otherwise fill the array with zeros

      END IF

C...Get level heights / layer faces (m)

      call interpolate_var ('ZF', MDATE, MTIME, ZF )

C...Get pressure (Pa)

      call interpolate_var ('PRES', MDATE, MTIME, PRES )

C...Get air density (kg/m3)

      call interpolate_var ('DENS', MDATE, MTIME, DENS )

C...compute layer thicknesses (m)

      DO ROW = 1, NROWS
        DO COL = 1, NCOLS
          DZZ( COL, ROW, 1 ) = ZF( COL, ROW, 1 )
          DO LAY = 2, NLAYS
            DZZ( COL, ROW, LAY ) = ZF( COL, ROW, LAY )
     &                           - ZF( COL, ROW, LAY - 1 )
          END DO
        END DO
      END DO

C...advance the MDATE and MTIME to the next time on the met file
C...  to get ready to read the precipitation amounts.
C...  Precipitation data WILL NOT BE INTERPOLATED!  Precipitation data
C...  on the input file are amounts within the metfiles timestep.

      IF ( .NOT. CURRSTEP( JDATE, JTIME, SDATE, STIME, MSTEP,
     &                     MDATE, MTIME ) ) THEN
        XMSG = 'Cannot get step-starting date and time'
        CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      END IF

      CALL NEXTIME ( MDATE, MTIME, MSTEP )  ! set mdate:mtime to the hour

C...Get nonconvective precipitation amount (cm)

      call interpolate_var (VNAME_RN, MDATE, MTIME, RN )

C...Loop through all grid cells

      DO ROW = 1, NROWS
        DO COL = 1, NCOLS

C...Convert the rainfall into a rainfall rate (mm/hr)

          RAIN = 10.0 * RN( COL, ROW ) / METSTEP

          IF ( RAIN .LT. 0.0 ) THEN
            XMSG = 'NEGATIVE RAIN...PROBABLE BAD MET DATA...'
     &              // MET_CRO_2D
            CALL M3EXIT ( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
          END IF

C...calculate the integrated column cloud+rain water content
C... JP & SJR:  treat graupel as rainwater until we have a more
C...            advanced cloud microphysics scheme
C... include layer thickness in the column integration

          QCRGCOL   = 0.0
          QCRISGCOL = 0.0
          QRSGCOL   = 0.0
          QCICOL    = 0.0
          DO LAY = 1, NLAYS
            QC( COL, ROW, LAY ) = MAX( QC( COL, ROW, LAY ), 0.0 )
            QR( COL, ROW, LAY ) = MAX( QR( COL, ROW, LAY ), 0.0 )
            QI( COL, ROW, LAY ) = MAX( QI( COL, ROW, LAY ), 0.0 )
            QS( COL, ROW, LAY ) = MAX( QS( COL, ROW, LAY ), 0.0 )
            QG( COL, ROW, LAY ) = MAX( QG( COL, ROW, LAY ), 0.0 )
            QCRGCOL   = QCRGCOL   + DENS( COL, ROW, LAY )
     &                * DZZ( COL, ROW, LAY )
     &                * ( QC( COL, ROW, LAY ) + QR( COL, ROW, LAY )
     &                +   QG( COL, ROW, LAY ) )
            QCRISGCOL = QCRISGCOL + DENS( COL, ROW, LAY )
     &                * DZZ( COL, ROW, LAY )
     &                * ( QC( COL, ROW, LAY ) + QR( COL, ROW, LAY )
     &                +   QI( COL, ROW, LAY ) + QS( COL, ROW, LAY )
     &                +   QG( COL, ROW, LAY ) )
            QRSGCOL   = QRSGCOL   + DENS( COL, ROW, LAY )
     &                * DZZ( COL, ROW, LAY )
     &                * ( QR( COL, ROW, LAY ) + QS( COL, ROW, LAY )
     &                +   QG( COL, ROW, LAY ) )
            QCICOL    = QCICOL + DENS( COL, ROW, LAY )
     &                * DZZ( COL, ROW, LAY )
     &                * ( QC( COL, ROW, LAY ) + QI( COL, ROW, LAY ) )
          END DO

C...Calculate the cloud optical depth using a formula derived from
C...  Stephens (1978), JAS(35), pp2111-2132.
C...  only calculate the cloud optical depth when the liquid water
C...  path is >= 10 g/m2

          LWP = QCICOL * 1000.0  ! converts to g/m2
          IF ( LWP .GE. 10.0 ) THEN
             CLOD = 10.0**( 0.2633 + 1.7095 * LOG( LOG10( LWP ) ) )
          ELSE
             CLOD = 0.0
          END IF

C...If no cloud or optical depth < 5, set clear sky values.
C...  (i.e. don't do anything)

          IF ( CLOD .GE. 5.0 ) THEN

             RESTRANS( COL, ROW ) = ( 5.0 - EXP ( -CLOD ) ) / ( 4.0 + 0.42 * CLOD )
              
          END IF

C...loop through layers

          IF ( QCRGCOL .GT. 0.0 ) THEN
            DO LAY = 1, NLAYS

C...Compute cloud quantities

              IF ( ( QC( COL, ROW, LAY ) + QR( COL, ROW, LAY )
     &               + QG( COL, ROW, LAY ) ) .GT. 0.00005 ) THEN

                TBARC = TA( COL, ROW, LAY )

                PBARC = PRES( COL, ROW, LAY )

                CTHK1 = DZZ( COL, ROW, LAY )

                AIRM = PBARC * CTHK1 * 1.0E3 / ( RDGAS * MWAIR * TBARC )

                WCBAR = ( QC( COL, ROW, LAY ) + QR( COL, ROW, LAY )
     &                +   QG( COL, ROW, LAY ) ) * DENS( COL, ROW, LAY )

                WTBAR = ( QC( COL, ROW, LAY ) + QR( COL, ROW, LAY )
     &                +   QI( COL, ROW, LAY ) + QS( COL, ROW, LAY ) 
     &                +   QG( COL, ROW, LAY ) ) * DENS( COL, ROW, LAY )

C...Compute precipitation flux
C...  include layer thickness in the calculation

                IF ( QRSGCOL .GT. 0.0 ) THEN
                  WPBAR = ( QR( COL, ROW, LAY ) + QS( COL, ROW, LAY )
     &                  +   QG( COL, ROW, LAY ) ) * DENS( COL, ROW, LAY )
                  PRATE1 = RAIN * WPBAR * CTHK1 / QRSGCOL  ! convert to mm/hr
                ELSE
                  PRATE1 = RAIN * WTBAR * CTHK1 / QCRISGCOL  ! convert to mm/hr
                END IF

C...Finally, get in-cloud pollutant concentrations in moles sp
C...  per mole air

                DO SPC = 1, NSPCSD
                  POLC ( SPC ) = CGRD( COL, ROW, LAY, SPC )
                  CEND ( SPC ) = POLC( SPC )
                  REMOV( SPC ) = 0.0
                END DO

#ifdef isam
                DO SPC = 1, NSPC_SA
                  DO ITAG = 1, NTAG_SA
                    SA_POLC( SPC, ITAG ) = ISAM( COL,ROW,LAY,SPC,ITAG )
                    SA_CEND( SPC, ITAG ) = SA_POLC( SPC, ITAG )
                    SA_REMOV( SPC, ITAG ) = 0.0
                  END DO
                END DO
#endif 

#ifdef sens
                DO NP = 1, NPMAX
                  DO SPC = 1, NSPCSD
                    S_POLC ( NP, SPC ) = SENGRID( COL, ROW, LAY, NP, SPC )
                    S_CEND ( NP, SPC ) = S_POLC( NP, SPC)
                    S_REMOV( NP, SPC ) = 0.0
                  END DO
                END DO
#endif

C...perform scavenging and aqueous chemistry within the cloud
C...  and re-adjust the ending and removed amounts for those species
C...  that were scavenged or that participated in cloud chemistry

                CALL SCAVWDEP ( JDATE, JTIME, WTBAR, WCBAR, TBARC,
     &                          PBARC, CTHK1, AIRM, PRATE1, TAUCLD,
     &                          POLC, CEND, REMOV, REMOVAC, ALFA0,
     &                          ALFA2, ALFA3 )

#ifdef isam
                DO SPC = 1, NSPC_SA
                  CSPC = MAP_SAtoCGR(SPC)
                  SA_SUM = SUM ( SA_POLC( SPC,: ) )
c                 IF ( POLC( CSPC ) .GT. 1.0E-30 .AND. CEND( CSPC ) .GT. 1.0E-09 ) THEN
c                 IF ( POLC( CSPC ) .GT. 1.0E-30 ) THEN
                  IF ( SA_SUM .GT. 1.0E-25 ) THEN
                    DO ITAG = 1, NTAG_SA
                      SA_CEND( SPC, ITAG ) = SA_POLC( SPC, ITAG )
     &                                     * ( CEND( CSPC )
c    &                                       / POLC( CSPC ) )
     &                                       / SA_SUM )
                      SA_REMOV( SPC, ITAG ) = SA_POLC( SPC, ITAG )
     &                                      * ( REMOV( CSPC )
c    &                                        / POLC( CSPC ) )
     &                                        / SA_SUM )
                    END DO
                  ELSE ! no update
                    DO ITAG = 1, NTAG_SA
                      SA_CEND( SPC, ITAG )  = 0.0
                      SA_REMOV( SPC, ITAG ) = 0.0
                    END DO
                  END IF
                END DO
#endif

C...if the liquid water content is above the specified threshold
C...  then perform the aqueous chemistry within the cloud and
C...  re-adjust the ending and removed amounts for those species
C...  that participated in cloud chemistry

                IF ( WCBAR .GT. 1.0E-5 ) THEN

C...  calculate cosine of zenith angle for the cell and determine day or night; Golam Sarwar 

                  COSZ = MET_DATA%COSZEN( COL, ROW )
                  IF ( COSZ .LE. 0.0 ) THEN 
                    JH2O2_HYDROMETEORS = 0.0D0
                    JHNO3_HYDROMETEORS = 0.0D0
                  ELSE
                    JH2O2 = RJ_RES( COL, ROW, LAY, LH2O2 )
                    JHNO3 = RJ_RES( COL, ROW, LAY, LHNO3 )
                    JH2O2_HYDROMETEORS = REAL( JH2O2*PERMIN_TO_PERSEC, 8 )
                    JHNO3_HYDROMETEORS = REAL( JHNO3*PERMIN_TO_PERSEC, 8 )
                  END IF

C...in aqchem, H2SO4 gas is added to ASO4J
C...  mimic this for the ASO4GASJ tracking species
                  IF ( STM ) THEN
                    POLC( AEROSPC_MAP( ASO4GAS_IDX, 2 ) ) = POLC( AEROSPC_MAP( ASO4GAS_IDX, 2 ) )
     &                                                    + POLC( PRECURSOR_MAP( SULF_IDX ) )
                    CEND( AEROSPC_MAP( ASO4GAS_IDX, 2 ) ) = POLC( AEROSPC_MAP( ASO4GAS_IDX, 2 ) )
                  END IF

                  CALL AQ_MAP ( JDATE, JTIME, WTBAR, WCBAR, TBARC,
     &                          PBARC, CTHK1, AIRM, PRATE1, TAUCLD,
     &                          POLC, CEND, REMOV, REMOVAC, ALFA0,
     &                          ALFA2, ALFA3, COSZ )

#ifdef isam
                  DO SPC = 1, NSPC_SA ! general case
                    CSPC = MAP_SAtoCGR(SPC)
                    SA_SUM = SUM ( SA_POLC( SPC,: ) )
                    DO ITAG = 1, NTAG_SA
c                     IF ( POLC( CSPC ) .GT. 1.0E-30 ) THEN
                      IF ( SA_SUM .GT. 1.0E-25 ) THEN
                        SA_CEND( SPC, ITAG ) = SA_POLC( SPC,ITAG )
     &                                       * ( CEND( CSPC )
c    &                                         / MAX( 1.0E-25, POLC( CSPC ) ) )
     &                                         / SA_SUM )
                        SA_REMOV( SPC, ITAG ) = SA_POLC( SPC, ITAG )
     &                                        * ( REMOV( CSPC )
c    &                                          / MAX( 1.0E-25, POLC( CSPC ) ) )
     &                                          / SA_SUM )
                      ELSE !
                        SA_CEND( SPC, ITAG )  = 0.0
                        SA_REMOV( SPC, ITAG ) = 0.0
                      END IF
                    END DO
                  END DO

                  IF (S_SO4J .NE. 0 ) THEN ! sulfate case

                    DO ITAG = 1, NTAG_SA  ! sulfate from H2SO4
                      SA_DS4( ITAG ) = SA_POLC( S_SULF,ITAG )
                      SA_CEND( S_SULF,ITAG )  = 1.0E-30
                    END DO

                    DO ITAG = 1, NTAG_SA
                      SA_DS4( ITAG ) = SA_DS4( ITAG ) + DS4_SAVE ! total sulfate produced
     &                               * SA_POLC( S_SO2,ITAG )
     &                               / SUM ( SA_POLC( S_SO2,: ) )
                      SA_CEND( S_SO4J,ITAG ) = SA_POLC( S_SO4J,ITAG )  ! sulfate before removal
     &                                       + SA_DS4( ITAG )
                    END DO
 
                    SA_SUM = SUM ( SA_CEND( S_SO4J,: ) ) ! total apportioned sulfate before removal

                    DO ITAG = 1, NTAG_SA ! final sulfate removal and concentration
                      SA_REMOV( S_SO4J,ITAG ) = REMOV_SAVE
     &                                        * SA_CEND( S_SO4J,ITAG )
     &                                        / SA_SUM
                      SA_CEND( S_SO4J,ITAG ) = SA_CEND( S_SO4J,ITAG )
     &                                       - DEPSUM_SAVE
     &                                       * SA_CEND( S_SO4J,ITAG )
     &                                       / SA_SUM
                      SA_CEND( S_SO4J,ITAG ) = MAX ( SA_CEND( S_SO4J,ITAG ), 1.0E-30 )
                    END DO
          
                  END IF

                  IF (S_AORGCJ .NE. 0 ) THEN ! AORGCJ case
                    SA_DCSOA_GLY = 0.0
                    SA_DCSOA_MGLY = 0.0
                    DO ITAG = 1, NTAG_SA
                      IF ( S_GLY .NE. 0 ) THEN
                        SA_DCSOA_GLY( ITAG ) = DGLY1_SAVE
     &                               * SA_POLC( S_GLY,ITAG )
     &                               / MAX( 1.0E-25, SUM ( SA_POLC( S_GLY,: ) ) )
                      END IF
                      IF ( S_MGLY .NE. 0 ) THEN
                        SA_DCSOA_MGLY( ITAG ) = DMGLY1_SAVE
     &                               * SA_POLC( S_MGLY,ITAG )
     &                               / MAX( 1.0E-25, SUM ( SA_POLC( S_MGLY,: ) ) )
                      END IF
                      SA_CEND( S_AORGCJ,ITAG ) = SA_POLC( S_AORGCJ,ITAG ) ! AORGCJ before removal
     &                                         + SA_DCSOA_GLY( ITAG )
     &                                         + SA_DCSOA_MGLY( ITAG )
                    END DO
                    SA_SUM = MAX( 1.0E-25, SUM ( SA_CEND( S_AORGCJ,: ) ) ) ! total apportioned AORGCJ before removal
                    DO ITAG = 1, NTAG_SA ! final AORGCJ removal and concentration
                      SA_REMOV( S_AORGCJ,ITAG ) = REMOV_AORGC_SAVE
     &                                        * SA_CEND( S_AORGCJ,ITAG )
     &                                        / SA_SUM
                      SA_CEND( S_AORGCJ,ITAG ) = SA_CEND( S_AORGCJ,ITAG )
     &                                       - DEPSUM_AORGC_SAVE
     &                                       * SA_CEND( S_AORGCJ,ITAG )
     &                                       / SA_SUM
                      SA_CEND( S_AORGCJ,ITAG ) = MAX ( SA_CEND( S_AORGCJ,ITAG ), 1.0E-30 )
                    END DO
                  END IF
#endif
                END IF

C...convert removal change from moles/m**2 to kg/m**2 and kg/m**2 to kg/hectare

                DO I = 1,N_CGRID_SPC
                  IF ( CGRID_MASK_NUM( I ) .OR.
     &                 CGRID_MASK_SRF( I ) ) THEN
                     ! Aerosol Number (N m-2 -> N ha-1)
                     ! Aerosol Surface Area (m2 m-2 -> m2 ha-1)
                     REMOV( I ) = REMOV( I ) * M2PHA
#ifdef sens
                     DO NP = 1, NPMAX
                       S_REMOV( NP,I ) = S_REMOV( NP,I ) * M2PHA
                     END DO
#endif
                     ! ISAM does not track aerosol number or surface
                     ! area

                  ELSE
                     ! Gas and Aerosol Mass (moles m-2 -> kg ha-1)
                     REMOV( I ) = REMOV( I ) * CGRID_MW( I ) * M2PHA_OVER_GPKG
#ifdef sens
                     DO NP = 1, NPMAX
                       S_REMOV( NP,I ) = S_REMOV( NP,I ) * CGRID_MW( I ) * M2PHA_OVER_GPKG
                     END DO
#endif
#ifdef isam
                     CSPC = 0
                     CSPC = INDEXINT1(I,NSPC_SA,MAP_SAtoCGR(:))
                     IF ( CSPC .GT. 0 ) THEN
                       DO ITAG = 1, NTAG_SA
                         SA_REMOV( CSPC,ITAG ) = SA_REMOV( CSPC,ITAG ) * CGRID_MW( I )
     &                                          * M2PHA_OVER_GPKG
                       END DO
                     END IF
#endif
                  END IF


                END DO

C...load deposition amounts into the DEP array

                DO VAR = 1, N_SPC_WDEP
                  DEP( COL, ROW, VAR ) = DEP( COL, ROW, VAR )
     &                                 + REMOV( MAP_WDEPtoCGRID( VAR ) )
                END DO

C...load H+ concentration into the deposition array as well

                DEP( COL, ROW, N_SPC_WDEP+1 ) =
     &                         DEP( COL, ROW, N_SPC_WDEP+1 ) + REMOVAC
 
C...set cgrid to the ending concentrations

                DO SPC = 1, NSPCSD
                  IF ( SPC .NE. N_GC_SPCD ) THEN
                    CGRD( COL, ROW, LAY, SPC ) = CEND( SPC )
                  END IF
                END DO

#ifdef isam
                DO SPC = 1, NSPC_SA
                  DO ITAG = 1, NTAG_SA
                    TOT_SADEP( COL, ROW, SPC, ITAG ) = TOT_SADEP( COL, ROW, SPC, ITAG )
     &                                    + SA_REMOV( SPC, ITAG )
                    ISAM( COL,ROW,LAY,SPC,ITAG ) = SA_CEND( SPC, ITAG )
                  END DO
                END DO
#endif

#ifdef sens
                DO NP = 1, NPMAX

                  DO VAR = 1, N_SPC_WDEP
                    S_TOTDEP( COL, ROW, NP, VAR ) = S_TOTDEP( COL, ROW, NP, VAR )
     &                                            + S_REMOV( NP, MAP_WDEPtoCGRID( VAR ) )
                  END DO

                  S_TOTDEP( COL, ROW, NP, N_SPC_WDEP+1 ) =
     &                     S_TOTDEP( COL, ROW, NP, N_SPC_WDEP+1 ) + S_REMOVAC( NP )

                  DO SPC = 1, NSPCSD
                    IF ( SPC .NE. N_GC_SPCD ) THEN
                      SENGRID( COL, ROW, LAY, NP, SPC ) = S_CEND( NP, SPC )
                    END IF
                  END DO

                END DO
#endif

              END IF        ! Sum( QC,QR,QG ) > 0.00005 ?
            END DO       ! lay
          END IF      ! QCRGCOL > 0 ?

        END DO   ! col
      END DO   ! row

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE WVEL_DEFN

C Function: capture the derived vertical velocity component to write to the
C           conc file
C
C Revision history:
C   1 Feb 19 David Wong: Implemented centralized I/O approach, removed
C                        all MY_N clauses
C   6 Sep 19 F. Sidi   : Removed USE STD_CONC and USE AVG_CONC statements
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      IMPLICIT NONE

      REAL, ALLOCATABLE, SAVE :: WVEL( :,:,: )
      REAL, ALLOCATABLE, SAVE :: WY( :,:,: ) ! Diagnosed vert vel ala yamo

      CONTAINS

         FUNCTION WVEL_INIT () RESULT ( SUCCESS )

         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE UTILIO_DEFN

         LOGICAL SUCCESS

         CHARACTER( 16 ) :: PNAME = 'WVEL_INIT'
         CHARACTER( 16 ) :: CTM_WVEL = 'CTM_WVEL'
         CHARACTER( 96 ) :: XMSG = ' '

         INTEGER ALLOCSTAT, IERR
         INTEGER :: JDATE = 0, JTIME = 0

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

         IF ( W_VEL ) THEN

            ALLOCATE ( WVEL( NCOLS,NROWS,NLAYS ), 
     &                 WY( NLAYS,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'WVEL memory allocation failed'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
            
            WVEL = 0.0
            WY = 0.0
         
         END IF

         END FUNCTION WVEL_INIT

C-----------------------------------------------------------------------

      SUBROUTINE GET_WVEL( JDATE, JTIME )

      USE GRID_CONF
      USE UTILIO_DEFN
      Use CENTRALIZED_IO_MODULE, only : MSFX2, JACOBF_AVAIL, interpolate_var

      include SUBST_FILES_ID

      INTEGER     JDATE         ! current model date, coded YYYYDDD
      INTEGER     JTIME         ! current model time, coded HHMMSS 
      
      INTEGER       MTIME, MDATE, LVL
      LOGICAL, SAVE :: FIRST_TIME  = .TRUE.

      INTEGER       ALLOCSTAT
      CHARACTER( 16 ) :: PNAME = 'GET_WVEL'
      CHARACTER( 200 ) :: XMSG
      REAL, ALLOCATABLE, SAVE :: DBUFF ( :,:,: )  ! input for W_VEL
      REAL, ALLOCATABLE, SAVE :: JACF  ( :,:,: )  ! full-layer Jacobian
                                         
      IF ( FIRST_TIME ) THEN
            FIRST_TIME = .FALSE.

            ALLOCATE ( JACF( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )

            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating JACF'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

      END IF
 
#ifdef mpas
      WVEL = 0.0
#else
      IF (JACOBF_AVAIL) THEN 
         ! Time-Dependent Part of Vertical Velocity Retrieval
         call interpolate_var ('JACOBF', jdate, jtime, JACF)
      ELSE
         IF ( .NOT. ALLOCATED( DBUFF ) ) THEN
            ALLOCATE ( DBUFF( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DBUFF'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

         call interpolate_var ('JACOBM', jdate, jtime, DBUFF)

         JACF( :,:,1:NLAYS-1 ) = 0.5 * ( DBUFF( :,:,1:NLAYS-1 ) 
     &                              + DBUFF( :,:,2:NLAYS ) )
         JACF( :,:,NLAYS ) = 0.4 * JACF( :,:,NLAYS-1 )
     &                              + DBUFF( :,:,NLAYS )
      END IF

      ! convert from contravariant vertical velocity component to true wind
      DO LVL = 1, NLAYS
         WVEL( :,:,LVL ) = JACF( :,:,LVL )
     &                     * MSFX2( :,: ) * WY( LVL,:,: )
      END DO 
#endif

      END SUBROUTINE GET_WVEL    

      END MODULE WVEL_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE STK_EMIS

C-----------------------------------------------------------------------
C Function: stack emissions by source from stack emissions file and
C           3d point source emissions

C Revision History:
C     16 Jan 2007 J.Young: initial implementation
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     30 Apr 2016 J.Young: add multiple fire source capability, in affiliation with
C                          Yongtao Hu (Georgia Tech)
C-----------------------------------------------------------------------

      USE UDTYPES, ONLY: RARRY1, CARRY1
      USE DESID_VARS

      IMPLICIT NONE

      INTEGER,        ALLOCATABLE, SAVE :: NSRC_EMIS( : )   ! no. of pt sources
      INTEGER,        ALLOCATABLE, SAVE :: NVARS_EMIS( : )  ! no. of species
      INTEGER, PARAMETER                :: NVARS_FIRE = 1   ! default

      LOGICAL,        ALLOCATABLE, SAVE :: FIREFLAG( : )    ! which is the fire file?

      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: STKEMIS( : )   ! stack emissions [mol/s]
      TYPE( CARRY1 ), ALLOCATABLE, SAVE :: STKSPC( : )    ! emitted species names
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: FIREVAR( : )   ! fire variables, just H-Flux

      REAL, ALLOCATABLE, SAVE :: STKBUFF( : )

      INTEGER FGRPS

      CONTAINS

C-----------------------------------------------------------------------

         FUNCTION STK_EMIS_INIT ( STKENAME, JDATE, JTIME ) RESULT ( SUCCESS )

         USE UTILIO_DEFN
         USE AERO_DATA, ONLY : MGPG, GPKG
#ifdef mpas
         USE mio_module
#endif

         IMPLICIT NONE

         CHARACTER( 16 ), INTENT( IN ) :: STKENAME( : )  ! stack groups emis file names
         INTEGER, INTENT( IN )         :: JDATE, JTIME
         LOGICAL SUCCESS

         INTEGER I, J, N, NGRPS, LEN1, LEN2, ISRM, X, loc_sdate,
     &           loc_nsrcs, loc_nvars, loc
         integer :: loc_tflag(2), floc
         character (16), allocatable :: loc_vname(:), loc_units(:)

         INTEGER ASTAT
         CHARACTER( 96 ) :: XMSG = ' '
         CHARACTER( 16 ) :: PNAME = 'STK_EMIS_INIT'
         CHARACTER( 16 ) :: UNITSCK

         SUCCESS = .TRUE.

         NGRPS = SIZE( STKENAME )
         FGRPS = NGRPS

         ALLOCATE ( NSRC_EMIS( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'NSRC_EMIS', PNAME )

         ALLOCATE ( NVARS_EMIS( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'NVARS_EMIS', PNAME )

         ALLOCATE ( STKEMIS( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKEMIS', PNAME )

         ALLOCATE ( STKSPC( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKSPC', PNAME )

         ALLOCATE ( FIREFLAG( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'FIREFLAG', PNAME )
         FIREFLAG = .FALSE.   ! array

         ALLOCATE ( FIREVAR( FGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'FIREVAR', PNAME )

         DO N = 1, NGRPS
            ISRM = MAP_PTtoISRM( N )

#ifdef mpas
            floc = mio_search (STKENAME( N ))
            call mio_time_format_conversion (mio_file_data(floc)%timestamp(1), loc_tflag(1), loc_tflag(2))

            loc_sdate = loc_tflag(1)

            loc_nsrcs = mio_file_data(floc)%gl_nrows
            loc_nvars = mio_file_data(floc)%nvars

            allocate (loc_vname(loc_nvars), loc_units(loc_nvars), stat=astat)
            loc_vname = mio_file_data(floc)%var_name
            loc_units = mio_file_data(floc)%units
#else

            IF ( .NOT. OPEN3( STKENAME( N ), FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open '// TRIM( STKENAME( N ) ) // ' file'
               CALL M3MESG( XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            IF ( .NOT. DESC3( STKENAME( N ) ) ) THEN
               XMSG = 'Could not get ' // TRIM( STKENAME( N ) ) // ' file description'
               CALL M3MESG( XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            ! Each file will use the default jdate, unless specified by the user 
            ! that the file is a representative day file
            loc_sdate = JDATE
            IF ( DESID_STREAM_SYM_DATE( ISRM ) ) loc_sdate = SDATE3D

            loc_nsrcs = NROWS3D
            loc_nvars = NVARS3D

            allocate (loc_vname(loc_nvars), loc_units(loc_nvars), stat=astat)
            loc_vname = vname3d(1:loc_nvars)
            loc_units = units3d(1:loc_nvars)
#endif

            DESID_STREAM_DATE( ISRM ) = loc_sdate

            NSRC_EMIS( N ) = loc_nsrcs
            NVARS_EMIS( N ) = loc_nvars
            LEN1 = NSRC_EMIS( N )
            LEN2 = NVARS_EMIS( N )
            DO I = 1, LEN2
               ! Use HFLUX to determine Fire sources in PT3D_DEFN via
               ! the FIRENAM variable
               IF ( loc_vname( I ) .EQ. 'HFLUX' ) THEN
                   FIREFLAG( N ) = .TRUE.
                   DESID_STREAM_FIRE( ISRM ) = .TRUE.
               END IF
            END DO
            IF ( FIREFLAG( N ) ) THEN   ! subtract off 'HFLUX'
               LEN2 = LEN2 - NVARS_FIRE
               NVARS_EMIS( N ) = LEN2
            END IF

            STKEMIS( N )%LEN = LEN1
            ALLOCATE ( STKEMIS( N )%ARRY( LEN1 ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'STKEMIS', PNAME )
            STKEMIS( N )%ARRY = 0.0   ! array

            DESID_EMVAR( ISRM )%LEN = LEN2
            ALLOCATE ( DESID_EMVAR( ISRM )%ARRY( LEN2 ), STAT = ASTAT )
            ALLOCATE ( DESID_EMVAR( ISRM )%UNITS( LEN2 ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'DESID_EMVAR', PNAME )

            IF ( FIREFLAG( N ) ) THEN   ! subtract and save off 'HFLUX'
               ALLOCATE ( FIREVAR( N )%ARRY( LEN1 ), STAT = ASTAT )
               CALL CHECKMEM( ASTAT, 'FIREVAR', PNAME )
               I = 0
               DO J = 1, loc_nvars
                  IF ( loc_vname( J ) .NE. 'HFLUX' ) THEN
                     I = I + 1
                     DESID_EMVAR( ISRM )%ARRY( I ) = loc_vname( J )
                     DESID_EMVAR( ISRM )%UNITS( I )= loc_units( J )
                  END IF
               END DO
               FIREVAR( N )%LEN = LEN1
            ELSE
               DO J = 1, DESID_EMVAR( ISRM )%LEN
                  DESID_EMVAR( ISRM )%ARRY( J ) = loc_vname( J )
                  DESID_EMVAR( ISRM )%UNITS( J )= loc_units( J )
               END DO
            END IF

            deallocate (loc_vname, loc_units)
         END DO

          ALLOCATE( STKBUFF( MAXVAL( NSRC_EMIS(:) ) ) )
             CALL CHECKMEM( ASTAT, 'NSRC_EMIS', PNAME )

         RETURN

         END FUNCTION STK_EMIS_INIT

      END MODULE STK_EMIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE COUPLE ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Convert units and couple concentration values in CGRID for transport
 
C Preconditions:
 
C Subroutines and functions called:
C   INTERPX, M3EXIT
 
C Revision History:
C    Jeff Sep 97 - leave gas chem, non-reactive and tracer species in
C                  standard (ppmV) units for transport
C    2 October, 1998 by Al Bourgeois at LM: parallel implementation
C   Jeff - Dec 00 - move CGRID_MAP into f90 module
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX
C        - Jun 01 - update units conversion calls and comments
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                      removed deprecated TRIMLEN
C   16 Sep 11 S.Roselle: for Pleim`s zadv-wrf blend
C   11 Oct 11 J.Young: eliminate ppmv_msmr
C   15 Nov 2018: L.Zhou, S.Napelenok: isam implementation
C   01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all
C                     MY_N clauses
C   10 July 19 F. Sidi: Renamed Subroutine
C   09 Dec 19 S.L.Napelenok: ddm-3d implementation for cmaq v5.3.1
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      use CENTRALIZED_IO_MODULE, only : interpolate_var
      USE PA_DEFN, ONLY : COUPLE_WRF
#ifdef isam
      USE SA_DEFN, ONLY: ISAM, NSPC_SA, NTAG_SA, MAP_SAtoCGR, TRANSPORT_SPC, ITAG
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY:SENGRID, NPMAX, NP
#endif 


      IMPLICIT NONE   

C Include files:
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:
!     REAL      :: CGRID( :,:,:,: )  ! concentrations
      REAL, POINTER :: CGRID( :,:,:,: )   ! concentrations
      INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP( 3 ) ! time step vector (HHMMSS)
                                          ! TSTEP(1) = local output step
                                          ! TSTEP(2) = sciproc sync. step (chem)
                                          ! TSTEP(3) = twoway model time step w.r.t.
                                          ! wrf time step and wrf/cmaq call frequency
C Parameters:
      REAL, PARAMETER :: GPKG = 1.0E+03   ! g/kg
      REAL, PARAMETER :: MGPG = 1.0E+06   ! micro-g/g
      REAL, PARAMETER :: CONV = GPKG * MGPG

C External Functions:

C File Variables:
      REAL     :: JACOBM( NCOLS,NROWS,NLAYS )  !"total" Jacobian
      REAL     :: RHOJ  ( NCOLS,NROWS,NLAYS )  !"total" Jacobian * air density

C Local Variables:
      CHARACTER( 16 ) :: PNAME = 'COUPLE'
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 96 ) :: XMSG = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      INTEGER, SAVE :: NQAE              ! number of micro-grams/m**3 species
      INTEGER, SAVE :: NNAE              ! number of #/m**3 species
      INTEGER, SAVE :: NSAE              ! number of m**2/m**3 species
      INTEGER, ALLOCATABLE, SAVE :: QAE( : ) ! CGRID pointer to micro-grams/m**3 species
      INTEGER, ALLOCATABLE, SAVE :: NAE( : ) ! CGRID pointer to #/m**3 species
      INTEGER, ALLOCATABLE, SAVE :: SAE( : ) ! CGRID pointer to m**2/m**3 species

      INTEGER     ALLOCSTAT

      INTEGER     OFF              ! loop offset to CGRID species
      INTEGER     C, R, L, SPC, V  ! loop counters

#ifdef isam
      INTEGER  :: SPC_CGRID
#endif

C-----------------------------------------------------------------------

C If ISPCA .ne. 0, then air is advected and concs. are adjusted

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         COUPLE_WRF = .TRUE.
         IF ( N_AE_SPC .GT. 0 ) THEN
C create aerosol species pointers to distinguish micro-grams/m**3,
C #/m**3 (number density), and m**2/m**3 (surface area) species
 
            ALLOCATE ( QAE( N_AE_SPC ),
     &                 NAE( N_AE_SPC ),
     &                 SAE( N_AE_SPC ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating QAE, NAE, or SAE'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            NQAE = 0       ! no. of micro-grams/m**3 species
            NNAE = 0       ! no. of #/m**3 species
            NSAE = 0       ! no. of m**2/m**3 species
!           OFF = AE_STRT - 1
            OFF = 0
            DO SPC = 1, N_AE_SPC
               IF ( AE_SPC( SPC )( 1:3 ) .EQ. 'NUM' ) THEN
                  NNAE = NNAE + 1
                  NAE( NNAE ) = OFF + SPC
               ELSE IF ( AE_SPC( SPC )( 1:3 ) .EQ. 'SRF' ) THEN
                  NSAE = NSAE + 1
                  SAE( NSAE ) = OFF + SPC
               ELSE
                  NQAE = NQAE + 1
                  QAE( NQAE ) = OFF + SPC
               END IF
            END DO

         END if

      END IF       ! if firstime

C Read Jacobian X Air Density (Jacobian =  sq. root det. metric tensor)

      call interpolate_var ('DENSA_J', jdate, jtime, RHOJ)
 
      call interpolate_var ('JACOBM', jdate, jtime, JACOBM)

C couple for advection - use density times the square root of the determinant
C of the metric tensor (the Jacobian) = RHOJ

C CGRID in mixing ratio [ppmV] -> (air density X "total" Jacobian) X mixing ratio [ppmV]
      IF ( N_GC_SPC .GT. 0 ) THEN
         OFF = GC_STRT - 1
         DO V = 1, N_GC_TRNS
            SPC = OFF + GC_TRNS_MAP( V )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) * RHOJ( C,R,L )
#ifdef sens
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) * RHOJ( C,R,L )
                     END DO
#endif
                  END DO
               END DO
            END DO
         END DO
      END IF
 
C initialize RhoJ from MCIP - done once per sync step
      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS
               CGRID( C,R,L,RHOJ_LOC ) = RHOJ( C,R,L )
#ifdef sens
                  DO NP = 1, NPMAX
                     SENGRID( C,R,L,NP,RHOJ_LOC ) = 0.0
                  END DO
#endif
            END DO
         END DO
      END DO

      OFF = AE_STRT - 1
C CGRID in ug/m**3 -> ("total" Jacobian [m]) X [Kg/m**3]
      IF ( NQAE .GT. 0 ) THEN
         DO V = 1, NQAE
            SPC = OFF + AE_TRNS_MAP( QAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = JACOBM( C,R,L ) * CGRID( C,R,L,SPC ) / CONV
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = JACOBM( C,R,L ) * SENGRID(C,R,L,NP,SPC)  / CONV
                     END DO
#endif
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in #/m**3 -> ("total" Jacobian [m]) X [#/m**3]
      IF ( NNAE .GT. 0 ) THEN
         DO V = 1, NNAE
            SPC = OFF + AE_TRNS_MAP( NAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = JACOBM( C,R,L ) * CGRID( C,R,L,SPC )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = JACOBM( C,R,L ) * SENGRID(C,R,L,NP,SPC)
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in m**2/m**3 -> ("total" Jacobian [m]) X [m**2/m**3]
      IF ( NSAE .GT. 0 ) THEN
         DO V = 1, NSAE
            SPC = OFF + AE_TRNS_MAP( SAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = JACOBM( C,R,L ) * CGRID( C,R,L,SPC )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = JACOBM( C,R,L ) * SENGRID(C,R,L,NP,SPC)
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in mixing ratio [ppmV] -> (air density X "total" Jacobian) X mixing ratio [ppmV]
      IF ( N_NR_SPC .GT. 0 ) THEN
         OFF = NR_STRT - 1
         DO V = 1, N_NR_TRNS
            SPC = OFF + NR_TRNS_MAP( V )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) * RHOJ( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC)* RHOJ( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF
 
C CGRID in mixing ratio [ppmV] -> (air density X "total" Jacobian) X mixing ratio [ppmV]
      IF ( N_TR_SPC .GT. 0 ) THEN
         OFF = TR_STRT - 1
         DO V = 1, N_TR_SPC
            SPC = OFF + V
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) * RHOJ( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) * RHOJ( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

#ifdef isam
      DO SPC = 1, NSPC_SA
        IF ( TRANSPORT_SPC( SPC ) ) THEN
          SPC_CGRID = MAP_SAtoCGR(SPC)
          IF ( SPC_CGRID .LE. N_GC_SPC .OR. SPC_CGRID .GE. NR_STRT ) THEN ! this is not an aerosol
            DO ITAG = 1, NTAG_SA
              DO L = 1, NLAYS
                 DO R = 1, NROWS
                    DO C = 1, NCOLS
                      ISAM( C,R,L,SPC,ITAG ) = ISAM( C,R,L,SPC,ITAG ) * RHOJ( C,R,L )
                    END DO
                 END DO
              END DO
            END DO
          ELSE ! this is an aerosol (mass only)
            DO ITAG = 1, NTAG_SA
              DO L = 1, NLAYS
                 DO R = 1, NROWS
                    DO C = 1, NCOLS
                      ISAM( C,R,L,SPC,ITAG ) = JACOBM( C,R,L ) * ISAM( C,R,L,SPC,ITAG ) / CONV
                    END DO
                 END DO
              END DO
            END DO
          END IF
        ENDIF
      END DO
#endif

      RETURN
 
C............................................................................
C entry DECOUPLE
 
      ENTRY DECOUPLE ( CGRID, JDATE, JTIME, TSTEP )

      call interpolate_var ('JACOBM', jdate, jtime, JACOBM)
 
C retrieve transported RhoJ
      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS
               RHOJ( C,R,L ) = CGRID( C,R,L,RHOJ_LOC )
            END DO
         END DO
      END DO
      !call interpolate_var ('DENSA_J', JDATE, JTIME, RHOJ)

C decouple for chemistry and diffusion
 
C CGRID in mixing ratio [ppmV] X (air density X "total" Jacobian) -> mixing ratio [ppmV]
      IF ( N_GC_SPC .GT. 0 ) THEN
         OFF = GC_STRT - 1
         DO V = 1, N_GC_TRNS
            SPC = OFF + GC_TRNS_MAP( V )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) / RHOJ( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) / RHOJ( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF
 
      OFF = AE_STRT - 1
C CGRID in Jacobian [m]) X [Kg/m**3] -> [ug/m**3]
      IF ( NQAE .GT. 0 ) THEN
         DO V = 1, NQAE
            SPC = OFF + AE_TRNS_MAP( QAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CONV * CGRID( C,R,L,SPC ) / JACOBM( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = CONV * SENGRID(C,R,L,NP,SPC) / JACOBM( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in Jacobian [m] X [#/m**3] -> #/m**3
      IF ( NNAE .GT. 0 ) THEN
         DO V = 1, NNAE
            SPC = OFF + AE_TRNS_MAP( NAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) / JACOBM( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) / JACOBM( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in Jacobian [m] X [m**2/m**3] -> m**2/m**3
      IF ( NSAE .GT. 0 ) THEN
         DO V = 1, NSAE
            SPC = OFF + AE_TRNS_MAP( SAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) / JACOBM( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) / JACOBM( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in mixing ratio [ppmV] X (air density X "total" jacobian) -> mixing ratio [ppmV]
      IF ( N_NR_SPC .GT. 0 ) THEN
         OFF = NR_STRT - 1
         DO V = 1, N_NR_TRNS
            SPC = OFF + NR_TRNS_MAP( V )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) / RHOJ( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) / RHOJ( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF
 
C CGRID in mixing ratio [ppmV] X (air density X "total" jacobian) -> mixing ratio [ppmV]
      IF ( N_TR_SPC .GT. 0 ) THEN
         OFF = TR_STRT - 1
         DO V = 1, N_TR_SPC
            SPC = OFF + V
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) / RHOJ( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) / RHOJ( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

#ifdef isam
      DO SPC = 1, NSPC_SA
        IF ( TRANSPORT_SPC( SPC ) ) THEN
          SPC_CGRID = MAP_SAtoCGR(SPC)
          IF ( SPC_CGRID .LE. N_GC_SPC .OR. SPC_CGRID .GE. NR_STRT ) THEN ! this is not an aerosol
            DO ITAG = 1, NTAG_SA
              DO L = 1, NLAYS
                 DO R = 1, NROWS
                    DO C = 1, NCOLS
                      ISAM( C,R,L,SPC,ITAG ) = ISAM( C,R,L,SPC,ITAG ) / RHOJ( C,R,L )
                    END DO
                 END DO
              END DO
            END DO
          ELSE ! this is an aerosol (mass only)
            DO ITAG = 1, NTAG_SA
              DO L = 1, NLAYS
                 DO R = 1, NROWS
                    DO C = 1, NCOLS
                      ISAM( C,R,L,SPC,ITAG ) = CONV * ISAM( C,R,L,SPC,ITAG ) / JACOBM( C,R,L )
                    END DO
                 END DO
              END DO
            END DO
          END IF
        END IF
      END DO
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module dust_emis
     
C-----------------------------------------------------------------------
C Description:
C * Extracts selected landuse categories from BELD01 and BELD03 and merges
C * the selections into a dust-related landuse array (ULAND).


C Function: 3d point source emissions interface to the chemistry-transport model

C Revision History:
C 16 Dec 10 J.Young: Adapting Daniel Tong`s work on windblown dust
C 21 Apr 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C 11 May 11 D.Wong: incorporated twoway model implementation
C  8 Jul 11 J.Young: unified string lengths in character lists for compiler compatibility
C 11 Nov 11 J.Young: generalizing land use/cover
C  8 Jun 12 J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2
C 13 Jul 12 J.Young: following Daniel Tong: changed clayc, siltc, sandc units from mass
C                    fraction to %; adjusted F/G (vertical to horizontal flux) ratio
C                    to be continuous for clay content > 20%
C 30 Sep 13 J.Young: corrected diag file units description; added snow cover adjustment;
C                    adjusted F/G (vertical to horizontal flux) ratio to be continuous
C                    for clay content > 0.2; convert volumetric soil moisture to
C                    gravimetric water content; corrected soil moisture factor (fmoit);
C                    use lwmask>0 rather than sltyp>0 (non-existent) for over water test
C 15 Sep 15 H.Foroutan: revised threshold friction velocity parameterization
C 20 Oct 15 H.Foroutan: Updated the calculation of the threshold velocity(U*t), which is
C                       now based on dust particle size, following Shao and Lu [JGR,2000].
C                       Implemented a dynamic vegetation fraction based on the MODIS FPAR.
C                       Introduced a new parametrization for surface roughness (z0)
C                       applicable to dust emission schemes, and accordingly calculated
C                       the friction velocity (U*) at the surface using 10m wind speed
C                       and the new (microspcopic) surface roughness.
C                       Surface roughness adjusted for estimated annual vegetation height.
C                       Included drag partitioning coefficient. Updated the calculation of
C                       the vertical-to-horizontal flux based on Lu and Shao [JGR,1999].
C                       Updated the dust diag output file accordingly.
C  8 Jan 16 J.Young: Changes for computational efficiency
C  2 Feb 16 J.Young: move dust aero speciation table to AERO_DATA
C  01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all MY_N clauses
C  9 Jul 19 Gilliam: Removed a lot of old commented out legacy tables. 
C                    Removed the direct read of FPAR MODIS file as this data comes 
C                    directly from WRF LSM models that have access to MODIS veg data now.
C                    Number of soil types fixed to 16 to match WRF and tables updated.
C  3 Mar 22 Gilliam and Willison: Removed fugitive dust capture from canopies
C                   (tfa and tfb terms). Added soil texture information from PX when available.
C                   Removed deprecated option concerning erodable agland. Removed BELD as an option
C                   for input.
C-----------------------------------------------------------------------
      use lus_defn
      use aero_data
      use desid_vars

      implicit none 

      public ndust_spc, dust_spc,
     &       dust_emis_init, get_dust_emis
      private

      real, allocatable, save :: dust_em( :,: )  ! total dust emissions [g/m**3/s]

C updated values of mass fraction for "freshly emitted dust"
C based on Kok [PNAS, 2011] and Nabat et al. [ACP, 2012]
      real, parameter :: fracmj = 0.07  ! mass fraction assigned to accum mode
      real, parameter :: fracmk = 0.93  ! mass fraction assigned to coarse mode

C diam`s from fracmj,fracmk-weighted 2 2-bin averages of geom means
C 2 J-mode bins: 0.1-1.0, 1.0-2.5 um
C 2 K-mode bins: 2.5-5.0, 5.0-10.0 um
      real, parameter :: dgvj = 1.3914  ! geom mean diam of accum mode [um]
      real, parameter :: dgvk = 5.2590  ! geom mean diam of coarse mode [um]
      real, parameter :: sigj = 2.0000  ! geom std deviation of accum mode flux
      real, parameter :: sigk = 2.0000  ! geom std deviation of coarse mode flux

C Local Variables:

C Factors for converting 3rd moment emission rates into number and 2nd moment
C emission rates.  (Diameters in [um] changed to [m] ) See Equations 7b and 7c
C of Binkowski & Roselle (2003)
      real       :: l2sgj    ! [ln( sigj )] ** 2
      real       :: l2sgk    ! [ln( sigk )] ** 2
      real, save :: factnumj ! = exp( 4.5 * l2sgj ) / dgvj ** 3 * 1.0e18
      real, save :: factnumk ! = exp( 4.5 * l2sgk ) / dgvk ** 3 * 1.0e18
      real, save :: factm2j  ! = exp( 0.5 * l2sgj ) / dgvj * 1.0e6
      real, save :: factm2k  ! = exp( 0.5 * l2sgk ) / dgvk * 1.0e6
      real, save :: factsrfj ! = pi * factm2j
      real, save :: factsrfk ! = pi * factm2k

      real       :: sumsplit, sumfrac
      integer    :: n, idx

C Number of soil types: For WRF there are 16 types;
      integer, parameter :: nsltyp = 16

C Variables for the windblown dust diagnostic file:
      integer, parameter :: fndust_diag = 17 ! number of fixed diagnostic output vars
      integer, save      :: ndust_diag       ! number of diagnostic output vars
      real, allocatable, save :: diagv( : )  ! diagnostic output variables
      real, allocatable, save :: dustbf( :,:,: ) ! diagnostic accumulate buffer

#ifdef verbose_wbdust
      real, allocatable, save :: sdiagv( : )  ! global sum of each diag output var
#endif

      type diag_type
         character( 16 ) :: var
         character( 16 ) :: units
         character( 80 ) :: desc
      end type diag_type

      type( diag_type ), allocatable, save :: diagnm( : )
      type( diag_type ), allocatable, save :: vdiagnm_emis( : )
      type( diag_type ), allocatable, save :: vdiagnm_frac( : )
      type( diag_type ), allocatable, save :: vdiagnm_ustar( : )
      type( diag_type ), allocatable, save :: vdiagnm_kvh( : )
      type( diag_type ), allocatable, save :: vdiagnm_rough( : )

      character( 10 ) :: truncnm
      character( 16 ) :: vnm

      type( diag_type ), parameter :: fdiagnm( fndust_diag ) = (/
C                      var              units                 desc
C                 ----------------    --------    -------------------------------------------
     & diag_type( 'Cropland_Emis   ', 'g m-3 s-1', 'emissions for cropland landuse type        '),
     & diag_type( 'Desertland_Emis ', 'g m-3 s-1', 'total emis for desert types and cropland   '),
     & diag_type( 'Cropland_Frac   ', 'percent  ', 'cropland erodible landuse fraction (%)     '),
     & diag_type( 'Desertland_Frac ', 'percent  ', 'total desert fraction (%)                  '),
     & diag_type( 'Cropland_Ustar  ', 'm s-1    ', 'u* for cropland                            '),
     & diag_type( 'Cropland_kvh    ', 'm-1      ', 'cropland vert to horiz flux ratio          '),
     & diag_type( 'Cropland_Rough  ', '         ', 'cropland surface roughness factor          '),
     & diag_type( 'Soil_Moist_Fac  ', '         ', 'soil moisture factor for threshold u*      '),
     & diag_type( 'Soil_Erode_Pot  ', '1        ', 'soil -> dust erodiblity potential          '),
     & diag_type( 'Mx_Adsrb_H2O_Frc', '1        ', 'max adsorbed water fraction                '),
     & diag_type( 'Vegetation_Frac ', '1        ', 'vegetation land coverage                   '),
     & diag_type( 'Urban_Cover     ', 'percent  ', 'urban land coverage                        '),
     & diag_type( 'Forest_Cover    ', 'percent  ', 'forest land coverage                       '),
     & diag_type( 'ANUMJ           ', 's-1', 'accumulation mode number                   '),
     & diag_type( 'ANUMK           ', 's-1', 'coarse mode number                         '),
     & diag_type( 'ASRFJ           ', 'm2 s-1   ', 'accumulation mode surface area             '),
     & diag_type( 'ASRFK           ', 'm2 s-1   ', 'coarse mode surface area                   ')/)
  
C Module shared variables:
      real, allocatable, save :: wmax  ( :,: )   ! max adsorb water percent
      real, allocatable, save :: kvh   ( :,:,: ) ! ratio of vertical flux / horizontal (k factor)
      real, allocatable, save :: sd_ep ( :,: )   ! soil->dust erodiblity potential

      real :: eropot( 3 ) =     ! erodible potential of soil components
     &        (/ 0.08,   ! clay
     &           1.00,   ! silt
     &           0.12 /) ! sand

      CONTAINS

C=======================================================================
         function dust_emis_init( jdate, jtime, tstep ) result( success )

C Revision History.
C   Aug 12, 15 D. Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O
C   implementation

         use hgrd_defn        ! horizontal domain specifications
         use aero_data        ! aerosol species definitions
         use asx_data_mod     ! meteorology data
         use utilio_defn
         use lus_data_module
         use centralized_io_module

C Arguments:
         integer, intent( in ) :: jdate   ! current model date, coded YYYYDDD
         integer, intent( in ) :: jtime   ! current model time, coded HHMMSS
         integer, intent( in ) :: tstep   ! output time step
         logical      success

C Includes:
         include SUBST_FILES_ID  ! file name parameters

C Local variables:
         character( 16 ) :: pname = 'DUST_EMIS_INIT'
         character( 16 ) :: vname
         character( 80 ) :: vardesc
         character( 250 ) :: xmsg = ' '

         integer status
         integer c, r, i, j, k, l, n, im
         integer idiag, idust, spc
         integer n_mass_emissions

         character( 16 ) :: sn

         type( diag_type ), allocatable :: diagnm_swap( : )


C-----------------------------------------------------------------------

         success = .true.

         CALL LOG_MESSAGE( LOGDEV, 'Initialize Wind-Blown Dust Emissions' )

C...Populate Master Emissions Map Vector So That Diagnostics 
C   can be printed in EMIS_MAP
         DESID_EMVAR( IDUSTSRM )%len = ndust_spc*2
         Allocate( DESID_EMVAR( IDUSTSRM )%arry( ndust_spc*2 ) )
         Allocate( DESID_EMVAR( IDUSTSRM )%units( ndust_spc*2 ) )
         Allocate( DESID_EMVAR( IDUSTSRM )%mw   ( ndust_spc*2 ) )
         Allocate( DESID_EMVAR( IDUSTSRM )%used ( ndust_spc*2 ) )
         Allocate( DESID_EMVAR( IDUSTSRM )%conv ( ndust_spc*2 ) )
         Allocate( DESID_EMVAR( IDUSTSRM )%basis( ndust_spc*2 ) )
         Allocate( DESID_EMVAR( IDUSTSRM )%larea( ndust_spc*2 ) )
         Allocate( DESID_EMVAR( IDUSTSRM )%lareaadj( ndust_spc*2 ) )
         DESID_EMVAR( IDUSTSRM )%arry( : ) = 'NOT_AVAILABLE'
         do i = 1,ndust_spc
            IF ( dust_spc( i )%spcfac(1) .NE. 0.0 ) 
     &         DESID_EMVAR( IDUSTSRM )%arry( i )  = 
     &                    'PMFINE_' // dust_spc(i)%name
            IF ( dust_spc( i )%spcfac(2) .NE. 0.0 ) 
     &         DESID_EMVAR( IDUSTSRM )%arry( i+ndust_spc )  = 
     &                    'PMCOARSE_' // dust_spc(i)%name
            DESID_EMVAR( IDUSTSRM )%mw( i )  = dust_spc(i)%mw
            DESID_EMVAR( IDUSTSRM )%mw( i+ndust_spc )  = dust_spc(i)%mw
         end do
         DESID_EMVAR( IDUSTSRM )%units( : ) = 'G/S'
         DESID_EMVAR( IDUSTSRM )%used ( : ) = .FALSE.
         DESID_EMVAR( IDUSTSRM )%conv ( : ) = 1.0
         DESID_EMVAR( IDUSTSRM )%basis( : ) = 'MASS'
         DESID_EMVAR( IDUSTSRM )%larea( : ) = .FALSE.
         DESID_EMVAR( IDUSTSRM )%lareaadj( : ) = .FALSE.
 
C...Count the number of mass emissions species
        n_mass_emissions = 0
        do i = 1, ndust_spc
           do j = 1, 2
              if( dust_spc( i )%spcfac( j )  .gt. 0. ) 
     &               n_mass_emissions = n_mass_emissions + 1  
           end do
        end do                     
        allocate ( dustoutm( ndust_spc*2,ncols,nrows ),
     &              dustoutn( 2,ncols,nrows ),
     &              dustouts( 2,ncols,nrows ), stat = status )
         if ( status .ne. 0 ) then
            xmsg = '*** Failure allocating DUSTOUTM, DUSTOUTN, or DUSTOUTS'
            call m3warn ( pname, jdate, jtime, xmsg )
            success = .false.; return
         end if

C Allocate emissions array
         allocate( dust_em( ncols,nrows ), stat = status )
         if ( status .ne. 0 ) then
            xmsg = '*** Failure allocating DUST_EM'
            call m3warn( pname, jdate, jtime, xmsg )
            success = .false.; return
         end if

C Allocate private arrays
         allocate( wmax  ( ncols,nrows ),
     &             sd_ep ( ncols,nrows ), stat = status)
         if ( status .ne. 0 ) then
            xmsg = '*** Failure allocating WMAX, or SD_EP'
            call m3warn( pname, jdate, jtime, xmsg )
            success = .false.; return
         end if
         wmax   = 0.0   ! array assignment
         sd_ep  = 0.0   ! array assignment

#ifndef mpas
C Initialize land use/cover variables
         if ( .not. lus_init( jdate, jtime ) ) then
            xmsg = 'Failure initializing land use module'
            call m3exit( pname, jdate, jtime, xmsg, xstat2 )
         end if
#endif

         if ( dustem_diag ) then    ! Open the emissions diagnostic file

C Set up variable diagnostic names (from LUS_DEFN)
            allocate( vdiagnm_emis ( n_dlcat ),
     &                vdiagnm_frac ( n_dlcat ),
     &                vdiagnm_kvh  ( n_dlcat ),
     &                vdiagnm_rough( n_dlcat ),
     &                vdiagnm_ustar( n_dlcat ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure allocating VDIAGNM_*'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
            vdiagnm_emis  = diag_type( ' ', ' ', ' ' )  ! array assignment
            vdiagnm_frac  = diag_type( ' ', ' ', ' ' )  ! array assignment
            vdiagnm_ustar = diag_type( ' ', ' ', ' ' )  ! array assignment
            vdiagnm_kvh   = diag_type( ' ', ' ', ' ' )  ! array assignment
            vdiagnm_rough = diag_type( ' ', ' ', ' ' )  ! array assignment

C...Set Up Diagnostic Species Variables
            ndust_diag = fndust_diag + 5 * n_dlcat + n_mass_emissions 

            do i = 1, n_dlcat
               truncnm = vnmld( i )%desc   ! char( 10 )
C...           replace embedded spaces (within 16 chars) with "_"
C...           replace embedded dashes (within 16 chars) with "_"
               l = len_trim( truncnm )
               do k = 1, l
                  if ( truncnm( k:k ) .eq. " " .or.
     &                 truncnm( k:k ) .eq. "-" ) truncnm( k:k ) = "_"
               end do
               vnm = trim( truncnm ) // '_Emis'    ! char( 16 )
               vdiagnm_emis( i ) = diag_type( vnm, 'g/m**2/s', vnmld( i )%desc )
               vnm = trim( truncnm ) // '_Frac'    ! char( 16 )
               vdiagnm_frac( i ) = diag_type( vnm, 'percent', vnmld( i )%desc )
               vnm = trim( truncnm ) // '_Ustr'    ! char( 16 )
               vdiagnm_ustar( i ) = diag_type( vnm, 'm/s', vnmld( i )%desc )
               vnm = trim( truncnm ) // '_Kvh'    ! char( 16 )
               vdiagnm_kvh( i ) = diag_type( vnm, '1/m', vnmld( i )%desc )
               vnm = trim( truncnm ) // '_Rough'    ! char( 16 )
               vdiagnm_rough( i ) = diag_type( vnm, '   ', vnmld( i )%desc )
            end do

C Allocate diagnostic emissions arrays
            allocate( diagnm( ndust_diag ),    ! diag_type
     &                diagv ( ndust_diag ),
     &                dustbf( ndust_diag,ncols,nrows ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure allocating DIAGNM, DIAGV or DUSTBF'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if

#ifdef verbose_wbdust
            allocate( sdiagv( ndust_diag ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure allocating SDIAGV'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
#endif

C Build the complete diagnostic name array                     n for MODIS NOAH
            do i = 1, n_dlcat                                ! 4
               diagnm( i ) = vdiagnm_emis( i )
            end do
            n = n_dlcat + 1
            diagnm( n ) = fdiagnm( 1 )    ! Cropland_Emis
            n = n + 1
            diagnm( n ) = fdiagnm( 2 )    ! Desertland_Emis

            do i = 1, n_dlcat
               diagnm( i+n ) = vdiagnm_frac( i )
            end do
            n = n + n_dlcat + 1
            diagnm( n ) = fdiagnm( 3 )    ! Cropland_Frac
            n = n + 1
            diagnm( n ) = fdiagnm( 4 )    ! Desertland_Frac

            do i = 1, n_dlcat
               diagnm( i+n ) = vdiagnm_ustar( i )
            end do
            n = n + n_dlcat + 1
            diagnm( n ) = fdiagnm( 5 )    ! Cropland_Ustar

            do i = 1, n_dlcat
               diagnm( i+n ) = vdiagnm_kvh( i )
            end do
            n = n + n_dlcat + 1
            diagnm( n ) = fdiagnm( 6 )    ! Cropland_Kvh

            do i = 1, n_dlcat
               diagnm( i+n ) = vdiagnm_rough( i )
            end do
            n = n + n_dlcat + 1
            diagnm( n ) = fdiagnm( 7 )    ! Cropland_Rough

            n = n - 7                     ! add remaining variables in fdiagnm
            do i = 8, fndust_diag 
               idiag = i+n
               diagnm( idiag ) = fdiagnm( i )
            end do

C...append diagnostic variables with mass emissions species
            do j = 1, 2
               do i = 1, ndust_spc
                  if( dust_spc( i )%spcfac( j ) .eq. 0. ) cycle 
                    n = 0
                    do k = 1, idiag   ! determine if dust emissions is already added to diagnostic output
                       if( trim( DESID_EMVAR( IDUSTSRM )%ARRY( (j-1)*ndust_spc+i )) 
     &                     .Eq. diagnm( k )%var ) Then
                         n = k
                         exit
                     end if
                  end do
                  if( n .gt. 0  ) cycle ! skip already added 
                  
                  idiag = idiag + 1
                  diagnm( idiag )%var = DESID_EMVAR( IDUSTSRM )%ARRY( (j-1)*ndust_spc+i ) 
                  diagnm( idiag )%units = 'g/m**3/s'

                  Select Case( j ) ! assumes only two aerosol modes dust emissions
                     Case( 1 )
                        diagnm( idiag )%desc = 'fine mode' 
                     Case( 2 )
                        diagnm( idiag )%desc = 'coarse mode' 
                  end Select
                  diagnm( idiag )%desc = Trim( diagnm( idiag )%desc )
     &                                   // ' emissions for '  
     &                                   // Trim( dust_spc( i )%description )
               end do
            end do
            
! remove unused space in diagnm by deallocated and reallocating to idiag value
            allocate( diagnm_swap( ndust_diag ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure allocating DIAGNM_SWAP'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
            diagnm_swap = diagnm 

            deallocate( diagnm )

            ndust_diag = idiag
            allocate( diagnm( ndust_diag ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure reallocating DIAGNM'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
            diagnm( 1:ndust_diag ) = diagnm_swap( 1:ndust_diag )
            deallocate( diagnm_swap )

            if ( io_pe_inclusive )
     &         call opdust_emis ( stdate, sttime, tstep, ndust_diag, diagnm )

         end if   ! dustem_diag

         l2sgj = log( sigj ) * log( sigj )
         l2sgk = log( sigk ) * log( sigk )

C Factors for converting 3rd moment emission rates into number and 2nd moment
C emission rates.  (Diameters in [um] changed to [m] ) See Equations 7b and 7c
C of Binkowski & Roselle (2003)
         factnumj = 1.0e18 * exp( 4.5 * l2sgj ) / dgvj ** 3
         factnumk = 1.0e18 * exp( 4.5 * l2sgk ) / dgvk ** 3
         factm2j  = 1.0e06 * exp( 0.5 * l2sgj ) / dgvj
         factm2k  = 1.0e06 * exp( 0.5 * l2sgk ) / dgvk
         factsrfj = pi * factm2j
         factsrfk = pi * factm2k

#ifdef verbose_wbdust
         write( logdev,* ) ' '
         write( logdev,* ) '    l2sgj,l2sgk:         ', l2sgj, l2sgk
         write( logdev,* ) '    factnumj,factnumk:   ', factnumj, factnumk
         write( logdev,* ) '    factm2j,factm2k:     ', factm2j, factm2k
         write( logdev,* ) '    factsrfj,factsrfk:   ', factsrfj, factsrfk
         write( logdev,* ) ' '
#endif

         end function dust_emis_init

C=======================================================================
         subroutine opdust_emis ( jdate, jtime, tstep, ndust_var, dust_var )

C   27 Dec 10 J.Young: initial

         use grid_conf           ! horizontal & vertical domain specifications
         use utilio_defn
         use mio_ascii

         implicit none

         include SUBST_FILES_ID  ! file name parameters

C Arguments:
         integer, intent( in ) :: jdate      ! current model date, coded YYYYDDD
         integer, intent( in ) :: jtime      ! current model time, coded HHMMSS
         integer, intent( in ) :: tstep      ! output time step
         integer, intent( in ) :: ndust_var
         type( diag_type ), intent( in ) :: dust_var( : )

C Local variables:
         character( 16 ) :: pname = 'OPDUST_EMIS'
         character( 96 ) :: xmsg = ' '

         integer      v, l       ! loop induction variables

C-----------------------------------------------------------------------

#ifndef mpas
C Try to open existing file for update
         if ( .not. open3( ctm_dust_emis_1, fsrdwr3, pname ) ) then
            xmsg = 'Could not open CTM_DUST_EMIS_1 for update - '
     &           // 'try to open new'
            call m3mesg( xmsg )

C Set output file characteristics based on COORD.EXT and open diagnostic file
            ftype3d = grdded3
            sdate3d = jdate
            stime3d = jtime
            tstep3d = tstep
            call nextime( sdate3d, stime3d, tstep3d ) !  start the next hour

            nvars3d = ndust_var
            ncols3d = gl_ncols
            nrows3d = gl_nrows
            nlays3d = 1
            nthik3d = 1
            gdtyp3d = gdtyp_gd
            p_alp3d = p_alp_gd
            p_bet3d = p_bet_gd
            p_gam3d = p_gam_gd
            xorig3d = xorig_gd
            yorig3d = yorig_gd
            xcent3d = xcent_gd
            ycent3d = ycent_gd
            xcell3d = xcell_gd
            ycell3d = ycell_gd
            vgtyp3d = vgtyp_gd
            vgtop3d = vgtop_gd
!           vgtpun3d = vgtpun_gd ! currently, not defined
            do l = 1, nlays3d + 1
               vglvs3d( l ) = vglvs_gd( l )
            end do
            gdnam3d = grid_name  ! from HGRD_DEFN

            do v = 1, nvars3d
               vtype3d( v ) = m3real
               vname3d( v ) = dust_var( v )%var
               units3d( v ) = dust_var( v )%units
               vdesc3d( v ) = dust_var( v )%desc
            end do

            fdesc3d( 1 ) = 'windblown dust parameters, variables, and'
            fdesc3d( 2 ) = 'hourly layer-1 windblown dust emission rates'
            do l = 3, mxdesc3
               fdesc3d( l ) = ' '
            end do

            ! Store MIO Metadata
            NDIMS3D( 1:NVARS3D ) = 3
            L_TSTEP( 1:NVARS3D ) = .True.
            L_LAY  ( 1:NVARS3D ) = .False.
            L_COL  ( 1:NVARS3D ) = .True.
            L_ROW  ( 1:NVARS3D ) = .True.
            L_VEXT ( 1:NVARS3D ) = .False.

            CALL LOAD_MIO_FILE ( 'CTM_DUST_EMIS_1', 0, 0, 0,
     &           VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &           VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &           L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &           L_VEXT(1:NVARS3D) )
            
C Open windblown dust emissions diagnostic file
            if ( .not. open3( ctm_dust_emis_1, fsnew3, pname ) ) then
               xmsg = 'Could not create the CTM_DUST_EMIS_1 file'
               call m3exit( pname, sdate3d, stime3d, xmsg, xstat1 )
            end if

         end if
#endif

         return

         end subroutine opdust_emis

C=======================================================================
         subroutine get_dust_emis( jdate, jtime, tstep, rjacm, cellvol,
     &                             cellhgt, l_desid_diag)

         use grid_conf        ! horizontal & vertical domain specifications
         use asx_data_mod     ! meteorology data
         use aero_data
         use const, only: f6pi
         use utilio_defn
         use lus_data_module
         use centralized_io_module
         use RUNTIME_VARS, only: WRF_V4P
#ifdef mpas
         use util_module, only : index1, time2sec
#endif

C       8/18/11 D.Wong: incorporated twoway model implementation and change
C                       RC -> RCA and RN -> RNA and made it backward compatible
C       8/12/15 D.Wong: added code to handle parallel I/O implementation

C Arguments:
         integer, intent( in ) :: jdate        ! current model date, coded YYYYDDD
         integer, intent( in ) :: jtime        ! current model time, coded HHMMSS
         integer, intent( in ) :: tstep( 3 )   ! output time step, sync step, 2way step
         real,    intent( in ) :: rjacm( ncols,nrows ) ! reciprocal Jacobian [1/m]
         real,    intent( in ) :: cellvol(:,:) ! grid-cell volume [m2*sigma]
         real,    intent( in ) :: cellhgt(:,:) ! grid-cell height [sigma]
         logical, intent( in ) :: l_desid_diag ! flag determining whether or not DESID 
                                               !   is in diagnostic mode

C Includes:
         include SUBST_FILES_ID  ! file name parameters

C External Functions:
               
C Parameters:
         integer, parameter :: ndp = 4     ! number of soil texture type particle sizes:
                                           !  1  Coarse sand
                                           !  2  Fine-medium sand
                                           !  3  Silt
                                           !  4  Clay

         real, parameter :: mv    = 0.16
         real, parameter :: sigv  = 1.45
         real, parameter :: betav = 202.0
         real, parameter :: sigv_mv  = sigv * mv   ! = 0.232
         real, parameter :: betav_mv = betav * mv  ! = 32.32
         real, parameter :: mb    = 0.5
         real, parameter :: sigb  = 1.0
         real, parameter :: betab = 90.0
         real, parameter :: sigb_mb  = sigb * mb   ! = 0.5
         real, parameter :: betab_mb = betab * mb  ! = 45.0

         character( 16 ) :: pname = 'GET_DUST_EMIS'
         character( 16 ) :: vname
         character( 96 ) :: xmsg
         integer status
         integer c, r, j, m, n, v, isd

         integer, save   :: wstep = 0      ! local write counter
         integer         :: mdate, mtime   ! diagnostic file write date&time

                       ! automatic arrays
         real       :: fmoit  ( ncols,nrows )      ! factor of soil moisture on u*t
         real       :: soimt  ( ncols,nrows )      ! gravimetric soil moisture (Kg/Kg)
         real       :: wrbuf  ( ncols,nrows )      ! diagnositc write buffer
         real       :: vegfrac( ncols,nrows )      ! vegetation fraction
         real       :: vegfree                     ! 1.0 - vegfrac for this col, row
         real       :: lai    ( ncols,nrows )      ! leaf area index

         real, allocatable, save :: ustr  ( :,:,: ) ! U* [m/s]
         real, allocatable, save :: qam   ( :,:,: ) ! emis for landuse type [g/m**3/s]
         real, allocatable, save :: elus  ( :,:,: ) ! erodible landuse percent (0~100)
         real, allocatable, save :: fruf  ( :,:,: ) ! surface roughness factor
         real, allocatable, save :: gsfac ( :,: )   ! [m3]

         real       :: edust( 2 )       ! mass emis rate [g/s] per mode (only accum & coarse)
         real       :: sumdfr           ! sum var for desert fraction
         real       :: rlay1hgt         ! reciprocal of layer-1 height [1/m]
         real       :: m3j              ! 3rd moment accumulation (J) mode emis rates [m3/m3/s]
         real       :: m3k              ! 3rd moment coarse mode (K) emis rates [m3/m3/s]
         real       :: fruf2            ! surface roughness factor squared

         character( 16 ), save :: rc_name, rn_name    ! new names: RC -> RCA, RN -> RNA
         logical, save :: firstime = .true.

         real       :: lambda, vegheight
         real       :: z0
         real       :: lambdav           ! vegetation roughness density - Shao et. al [Aus. J. Soil Res., 1996]
         real       :: flxfac1, flxfac2  ! combined soli type mapping factors
         real       :: hflux, vflux      ! horizontal and vertical dust flux
         real       :: jday
         integer    :: emap( n_dlcat+1 )

C---Height for veg elements
         real :: hv( 4 )

C---Roughness density for solid elements
C from Darmenova et al. [JGR,2009] and Xi and Sokolik [JGR,2015]
        real :: lambdab( 4 ) =
     &           (/ 0.03,     ! shrubland
     &              0.04,     ! shrubgrass
     &              0.0001,   ! barrenland
     &              0.15 /)   ! cropland

C---Compound for computational efficiency
         real :: hb_lambdab( 4 ) =
     &           (/ 6.0e-04,   ! shrubland
     &              8.0e-04,   ! shrubgrass
     &              2.0e-06,   ! barrenland
     &              3.0e-03 /) ! cropland

C converted to gravimetric [kg/kg]
         real :: soilml1( nsltyp ) =
     &           (/ 0.242,     ! Sand
     &              0.257,     ! Loamy Sand
     &              0.286,     ! Sandy Loam
     &              0.350,     ! Silt Loam
     &              0.350,     ! Silt
     &              0.307,     ! Loam
     &              0.277,     ! Sandy Clay Loam
     &              0.350,     ! Silty Clay Loam
     &              0.332,     ! Clay Loam
     &              0.284,     ! Sandy Clay
     &              0.357,     ! Silty Clay
     &              0.344,     ! Clay
     &              0.329,     ! Organic Material
     &              0.000,     ! Water
     &              0.170,     ! BedRock
     &              0.280 /)   ! Other

C---Soil texture: the amount of
C   1: Coarse sand, 2: Fine-medium sand, 3: Silt, 4: Clay
C   in each soil type [Kg/Kg]. from Menut et al. [JGR,2013]
         real :: soiltxt( nsltyp,ndp ) = reshape (
     &           (/ 0.46,   0.46,   0.05,   0.03,     ! Sand
     &              0.41,   0.41,   0.18,   0.00,     ! Loamy Sand
     &              0.29,   0.29,   0.32,   0.10,     ! Sandy Loam
     &              0.00,   0.17,   0.70,   0.13,     ! Silt Loam
     &              0.00,   0.10,   0.85,   0.05,     ! Silt
     &              0.00,   0.43,   0.39,   0.18,     ! Loam
     &              0.29,   0.29,   0.15,   0.27,     ! Sandy Clay Loam
     &              0.00,   0.10,   0.56,   0.34,     ! Silty Clay Loam
     &              0.00,   0.32,   0.34,   0.34,     ! Clay Loam
     &              0.00,   0.52,   0.06,   0.42,     ! Sandy Clay
     &              0.00,   0.06,   0.47,   0.47,     ! Silty Clay
     &              0.00,   0.22,   0.20,   0.58,     ! Clay
     &              0.00,   0.00,   0.00,   0.00,     ! Organic Material
     &              0.00,   0.00,   0.00,   0.00,     ! Water
     &              0.00,   0.00,   0.00,   0.00,     ! BedRock
     &              0.00,   0.00,   0.00,   0.00 /),  ! Other
     &           (/ nsltyp,4 /), order = (/ 2,1 /) ) ! fill columns first


C---Mean mass median particle diameter (m) for each soil texture type
C   Chatenet et al. [Sedimentology,1996] and Menut et al. [JGR,2013]
         real :: dp( ndp ) =
     &           (/ 690.0E-6,     ! Coarse sand
     &              210.0E-6,     ! Fine-medium sand
     &              125.0E-6,     ! Silt
     &                2.0E-6 /)   ! Clay
C---Soil texture vars of the grid cell
         real :: soiltxt_gcell( ndp )
         real :: clay, csand, fmsand, sandf, siltf


#ifdef verbose_wbdust
         integer dryhit
         integer dusthit
#endif

C-----------------------------------------------------------------------

         if ( firstime ) then
            firstime = .false.
            allocate ( ustr( ncols,nrows,n_dlcat+1 ),
     &                  qam( ncols,nrows,n_dlcat+1 ),
     &                 fruf( ncols,nrows,n_dlcat+1 ),
     &                  kvh( ncols,nrows,n_dlcat+1 ),
     &                 elus( ncols,nrows,n_dlcat+1 ),
     &                 gsfac(ncols,nrows ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure allocating USTR, QAM, FRUF, KVH, or ELUS'
               call m3exit( pname, jdate, jtime, xmsg, xstat1 )
            end if
         end if


C---Get Julian day number in year
         jday = float( mod( jdate,1000 ) )

C---Vegetation height dynamically changed based on the month of the year
C   Veg. heights in [m] for 1: Shrubland 2: shrubgrass 3: barrenland 4: Cropland
C   following the idea of Xi and Sokolik [JGR,2015]
         if ( jday .gt. 59 .and. jday .le. 90 ) then         ! Mar
            hv = (/ 0.15 , 0.05 , 0.10 , 0.05 /)
         else if ( jday .gt. 90 .and. jday .le. 120 ) then   ! Apr
            hv = (/ 0.15 , 0.10 , 0.10 , 0.05 /)
         else if ( jday .gt. 120 .and. jday .le. 151 ) then  ! May
            hv = (/ 0.12 , 0.20 , 0.10 , 0.10 /)
         else if ( jday .gt. 151 .and. jday .le. 181 ) then  ! Jun
            hv = (/ 0.12 , 0.15 , 0.10 , 0.30 /)
         else if ( jday .gt. 181 .and. jday .le. 212 ) then  ! Jul
            hv = (/ 0.10 , 0.12 , 0.10 , 0.50 /)
         else if ( jday .gt. 212 .and. jday .le. 243 ) then  ! Aug
            hv = (/ 0.10 , 0.12 , 0.10 , 0.50 /)
         else if ( jday .gt. 243 .and. jday .le. 273 ) then  ! Sep
            hv = (/ 0.10 , 0.10 , 0.10 , 0.30 /)
         else if ( jday .gt. 273 .and. jday .le. 304 ) then  ! Oct
            hv = (/ 0.05 , 0.08 , 0.10 , 0.10 /)
         else                                                ! Nov-Feb
            hv = (/ 0.05 , 0.05 , 0.05 , 0.05 /)
         end if

#ifdef verbose_wbdust
         dryhit = 0
         dusthit = 0
#endif

C Initialize windblown dust diagnostics output buffer
         if ( dustem_diag .and. wstep .eq. 0 .and. .not. l_desid_diag ) then
            dustbf = 0.0   ! array assignment
#ifdef verbose_wbdust
            sdiagv = 0.0   ! array assignment
#endif
         end if

C set erodible landuse map
         do m = 1, n_dlcat
            emap( m ) = dmap( m )  ! dmap maps to one of the 3 BELD3 desert types
         end do
         emap( n_dlcat+1 ) = 4
C   Check PX soil texture data flag and log a message if or if not used in WB dust
         if(PXSOIL_AVAIL) then
            CALL LOG_MESSAGE( LOGDEV, '==================  Windblown Dust Message =====================' )
            CALL LOG_MESSAGE( LOGDEV, '  WRFV4.1+ inputs have extra PX LSM soil texture and props used.' )
            CALL LOG_MESSAGE( LOGDEV, ' Clay, coarse and fine-medium sand from PX LSM not lookup tables.' )
         else
            CALL LOG_MESSAGE( LOGDEV, '==================  Windblown Dust Message =====================' )
            CALL LOG_MESSAGE( LOGDEV, '   Clay, coarse and fine-medium sand from internal lookup table.' )
         end if

         ! Calculate conversion factor from volume-based to total emission rate
         gsfac( :,: ) = cellvol( :,: ) / rjacm( :,: ) ! [g/m3/s] to [g/s]
         
C --------- ###### Start Main Loop ###### ---------
 
         do r = 1, nrows
         do c = 1, ncols
            dust_em( c,r ) = 0.0
            soimt( c,r )   = 0.0
            fmoit( c,r )   = 0.0   ! for diagnostic output visualization
            vegfrac( c,r ) = 0.0
            do m = 1, n_dlcat+1
               ustr( c,r,m ) = 0.0   ! for diagnostic output visualization
               qam ( c,r,m ) = 0.0
               elus( c,r,m ) = 0.0
               fruf( c,r,m ) = 0.0
               kvh ( c,r,m ) = 0.0
            end do
 
            rlay1hgt = rjacm ( c,r ) / cellhgt(c,r)


C--- Set Clay, coarse and fine/medium sand fractions.
C--- If value from WRF is missing (-9999.) use old table values
C--  If value from WRF is from WRFV4.1 PX LSM csand_px, etc use those
            j = Grid_Data%sltyp( c,r )

            if (.not. WRF_V4P) then
C    Adjust WRF soil definitions to match internal Menut et al. [JGR,2013] Table
             if ( j .gt. 4 ) j = j + 1   
             if ( j .gt. 13 ) j = 13   
            end if

            if(PXSOIL_AVAIL) then
              clay   = Grid_Data%clay_px(c,r)
              csand  = Grid_Data%csand_px(c,r)
              fmsand = Grid_Data%fmsand_px(c,r)
            else
              csand  = soiltxt(j,1)
              fmsand = soiltxt(j,2)
              clay   = soiltxt(j,4)
            end if

            sandf = csand + fmsand
            siltf = 1.0 - clay - sandf


C---Vegetation fraction based on the WRF/MCIP VEG variable. In WRF that would be VEGF_PX
C-- for the case of PX and VEGFRA in the case of other LSMs. In more recent WRFv4+ versions
C-- high resolution MODIS veg data is availiable and can be used in PX with pxlsm_modis_veg = 1
            vegfrac( c,r ) = max( min( Met_Data%veg(c,r), 0.95 ), 0.005)
            vegfree = 1.0 - vegfrac( c,r )
            lambdav = -0.35 * log( vegfree ) ! Shao et al. [Aus. J. Soil Res.,1996]

C---Dust possiblity only if 1. not over water 
C                           2. rain < 1/100 in. (1 in. = 2.540 cm)
C                           3. not snow-covered
C                           4. if soimt <= limit
C                           5. desert type or ag landuse
C                           6. erodible landuse
C                           7. friction velocity > threshold

            if ( ( Grid_Data%lwmask( c,r ) .gt. 0.0 ) .and.
     &           ( Met_Data%rn( c,r ) + Met_Data%rc( c,r ) .le. 0.0254 ) .and. ! rn, rc = [cm]
     &           ( Met_Data%snocov( c,r ) .lt. 0.001 ) ) then ! less than 0.1% snow coverage
C---Dust possiblity 1,2,3


C Calculate maximum amount of the adsorbed water
C    w` = 0.0014(%clay)**2 + 0.17(%clay) - w` in %
C    Fecan et al. [1999,Annales Geophys.,17,144-157]
               wmax( c,r ) = ( 14.0 *  clay + 17.0 ) * clay   ! [%]

!              write( logdev,'( 2x, a, i8.6, f12.5 )' ) 'max wmax:', jtime, maxval( wmax )

C Change soil moisture units from volumetric (m**3/m**3) to gravimetric (Kg/Kg)
               soimt( c,r ) = Met_Data%soim1( c,r ) 
     &                      * 1000.0 / ( 2650.0 * ( 0.511 + 0.126 * sandf  ) )

               if ( soimt( c,r ) .le. soilml1( j ) ) then
C---Dust possiblity 4

#ifdef verbose_wbdust
                  dryhit = dryhit + 1
#endif

C---Soil moisture effect on U*t
                  if ( soimt( c,r ) .le. 0.01 * wmax( c,r ) ) then   ! wmax in [%]
                     fmoit( c,r ) = 1.0
                  else
                     fmoit( c,r ) = sqrt( 1.0 + 1.21
     &                            * ( 100.0 * soimt( c,r ) - wmax( c,r ) ) ** 0.68 )
                  end if

C---Erodibility potential of soil component
                  sd_ep( c,r ) = clay * eropot( 1 )
     &                         + siltf * eropot( 2 ) + sandf * eropot( 3)

C---Lu and Shao [JGR,1999] and Kang et al. [JGR,2011]
C   First, mapping soil types into 4 main soil types following Kang et al. [JGR,2011]
                  select case ( j )
                     case( 1, 2 )          ! sand
                  !     pp = 5000.0
                  !     calpha = 0.001
                  !     pfrac = 0.06
                  !     flxfac1 = calpha * 9.81 * pfrac * 500.0 / pp
                        flxfac1 = 5.886e-05
                  !     flxfac2 = 2.09 * sqrt( 2650.0 / pp )
                        flxfac2 = 1.5215430
                     case( 3, 4, 6, 8, 9 ) ! loam
                  !     pp = 10000.0
                  !     calpha = 0.0006
                  !     pfrac = 0.18
                  !     flxfac1 = calpha * 9.81 * pfrac * 500.0 / pp
                        flxfac1 = 5.2974e-05
                  !     flxfac2 = 2.09 * sqrt( 2650.0 / pp )
                        flxfac2 = 1.0758933
                     case( 7 )             ! sandy clay loam
                  !     pp = 10000.0
                  !     calpha = 0.0006
                  !     pfrac = 0.32
                  !     flxfac1 = calpha * 9.81 * pfrac * 500.0 / pp
                        flxfac1 = 9.4176e-05
                  !     flxfac2 = 2.09 * sqrt( 2650.0 / pp )
                        flxfac2 = 1.0758933
                     case( 5, 10, 11, 12 ) ! clay
                  !     pp = 30000.0
                  !     calpha = 0.0002
                  !     pfrac = 0.72
                  !     flxfac1 = calpha * 9.81 * pfrac * 500.0 / pp
                        flxfac1 = 2.3544e-05
                  !     flxfac2 = 2.09 * sqrt( 2650.0 / pp )
                        flxfac2 = 0.1964303
                     case default          ! others -- no dust
                  !     pp = 100000.0
                  !     calpha = 1.0
                  !     pfrac = 0.0
                  !     flxfac1 = calpha * 9.81 * pfrac * 500.0 / pp
                        flxfac1 = 0.0
                  !     flxfac2 = 2.09 * sqrt( 2650.0 / pp )
                        flxfac2 = 0.3402273
                  end select

                  do m = 1, n_dlcat     ! desert type landuse category
                     elus( c,r,m ) = ladut( c,r,m ) * vegfree   ! desert land [%]
                  end do
 
C ------- Start Loop Over Erodible Landuse ----
 
                  do m = 1, n_dlcat+1   ! desert type & crop landuse categories

                     if ( elus( c,r,m ) .gt. 100.0 .or. elus( c,r,m ) .lt. 0.0 ) then
                        write( xmsg,2009 ) elus( c,r,m ), c, r, m
                        call m3exit( pname, jdate, jtime, xmsg, xstat1 )
                     end if

                     if ( elus( c,r,m ) .gt. 0.0 ) then

                        n = emap( m )
                        lambda    = lambdab( n ) + lambdav
                        vegheight = ( hb_lambdab( n ) + hv( n ) * lambdav ) / lambda

C---New parametrization for surface roughness by H. Foroutan - Oct. 2015
                        if ( lambda .le. 0.2 ) then
                           z0 = 0.96  * ( lambda ** 1.07 )  * vegheight 
                        else
                           z0 = 0.083 * ( lambda ** ( -0.46 ) ) * vegheight 
                        end if

C---Calculate friction velocity (U*) at the surafce applicable to dust emission 
                        ustr( c,r,m ) = karman * Met_Data%WSPD10( c,r ) / log ( 10.0 / z0 )

C---Roughness effect on U*t (Drag partitioning)
C   Xi and Sokolik [JGR,2015]
                        fruf2  = ( 1.0 - sigv_mv  * lambdav )
     &                     *     ( 1.0 + betav_mv * lambdav )
     &                     *     ( 1.0 - sigb_mb  * lambdab( n ) / vegfree ) 
     &                     *     ( 1.0 + betab_mb * lambdab( n ) / vegfree )

                        if( fruf2 .gt. 1.0 ) then

                           fruf( c,r,m ) = sqrt( fruf2 )
                        else 
                           fruf( c,r,m ) = 10.0
                        end if

C---Vert-to-Horiz dust flux ratio : Kang et al. [JGR, 2011] : Eq. (12)
!                       kvh( c,r,m ) = ( calpha * 9.81 * pfrac * 1000.0 / 2.0 / pp )
!    &                               * ( 0.24 + 2.09 * ustr( c,r,m ) * sqrt( 2650.0 / pp ) )
                        kvh( c,r,m ) = flxfac1 * ( 0.24 + flxfac2 * ustr( c,r,m ) )
                        soiltxt_gcell(1) = csand
                        soiltxt_gcell(2) = fmsand
                        soiltxt_gcell(3) = siltf
                        soiltxt_gcell(4) = clay
                        hflux = dust_hflux( ndp, dp,
     &                                      soiltxt_gcell( : ),
     &                                      fmoit( c,r ),
     &                                      fruf( c,r,m ),
     &                                      ustr( c,r,m ),
     &                                      sd_ep( c,r ),
     &                                      Met_Data%dens1( c,r ) )
                        vflux = hflux * kvh( c,r,m )                    ! [g/m**2/s]
                        qam( c,r,m ) = qam( c,r,m ) + vflux * rlay1hgt
     &                               * ( elus( c,r,m ) * 0.01 )         ! [g/m**3/s]
                     end if  ! if erodible land

                     if ( elus( c,r,m ) .eq. 0.0 .and. qam( c,r,m ) .ne. 0.0 ) then
                        xmsg = 'Erodible land use = 0, but emissions .ne. 0'
                        call m3exit( pname, jdate, jtime, xmsg, xstat1 )
                     end if

                     dust_em( c,r ) = dust_em( c,r ) + qam( c,r,m )

                  end do   ! m landuse
 
C ------- End Loop Over Erodible Landuse ----
 

               end if   ! if soil moisture
            end if   ! if rain & land & snow

         end do   ! c
         end do   ! r

C --------- ###### End Main Loop ##### ---------

#ifdef verbose_wbdust
         write( logdev,'( /5x, a, 1x, 2i8 )' ) 'dry hit count, 
     &                                          out of total cells:',
     &                                          dryhit, (c-1)*(r-1)
#endif

         ! Calculate Dust emission output and print diagnostic, if
         ! requested
         do r = 1, nrows
         do c = 1, ncols

C J/K mass emis rate [g/m3/s]  (edust( 1 ) not used)
            edust( 1 ) = fracmj * dust_em( c,r )
            edust( 2 ) = fracmk * dust_em( c,r )

            do n = 1,2
               do v = 1, ndust_spc
                  dustoutm( (n-1)*ndust_spc+v,c,r ) = 
     &                     edust( n ) * dust_spc( v )%spcfac( n )
               end do
            end do

C J/K 3rd moment emis rate [m3/m3/s] (needed for number and surface)
            m3j = edust( 1 ) * f6pi / ( gpkg * dust_dens( 1 ) ) + TINY(0.0)
            m3k = edust( 2 ) * f6pi / ( gpkg * dust_dens( 2 ) ) + TINY(0.0)

C Mode-specific emission rates of particle number [1/m3/s]
            dustoutn( 1,c,r ) = m3j * factnumj
            dustoutn( 2,c,r ) = m3k * factnumk

C Mode-specific dry surface area emission rates [m**2/m3/s].
C 2nd moment multiplied by PI to obtain the surface area emissions rate.
            dustouts( 1,c,r ) = m3j * factsrfj
            dustouts( 2,c,r ) = m3k * factsrfk

! Propagate Number and Surface Area Scaling Factors back to Emissions
! Module so that the dust emissions can be scaled appropriately            
            ISD = INDEX1( 'FINE', DESID_STREAM_AERO( IDUSTSRM )%LEN, 
     &                    DESID_STREAM_AERO( IDUSTSRM )%NAME )
            DESID_STREAM_AERO( IDUSTSRM )%FACNUM( ISD,2 ) = FACTNUMJ
            DESID_STREAM_AERO( IDUSTSRM )%FACSRF( ISD,2 ) = FACTSRFJ
            
            ISD = INDEX1( 'COARSE', DESID_STREAM_AERO( IDUSTSRM )%LEN, 
     &                    DESID_STREAM_AERO( IDUSTSRM )%NAME )
            DESID_STREAM_AERO( IDUSTSRM )%FACNUM( ISD,3 ) = FACTNUMK
            DESID_STREAM_AERO( IDUSTSRM )%FACSRF( ISD,3 ) = FACTSRFK

#ifdef verbose_wbdust
            if ( m3j .ne. 0.0 ) dusthit = dusthit + 1
#endif

            if ( dustem_diag .and. .not. l_desid_diag ) then
               do m = 1, n_dlcat+1
                  diagv( m ) = qam( c,r,m )             ! g/m**3/s
               end do
               n = n_dlcat + 2
               diagv( n ) = dust_em( c,r )              ! g/m**3/s

               sumdfr = 0.0
               do m = 1, n_dlcat+1
                  diagv( m+n ) = elus( c,r,m )
                  sumdfr = sumdfr + elus( c,r,m )
               end do
               n = n + n_dlcat + 2
               diagv( n ) = sumdfr

               do m = 1, n_dlcat+1
                  diagv( m+n ) = ustr( c,r,m )
               end do
               n = n + n_dlcat + 1

               do m = 1, n_dlcat+1
                  diagv( m+n ) = kvh( c,r,m )
               end do
               n = n + n_dlcat + 1

               do m = 1, n_dlcat+1
                  diagv( m+n ) = fruf( c,r,m )
               end do
               n = n + n_dlcat + 1

               diagv( n+1  ) = fmoit( c,r )       ! 'Soil_Moist_Fac  '
               diagv( n+2  ) = sd_ep( c,r )       ! 'Soil_Erode_Pot  '
               diagv( n+3  ) = wmax ( c,r )       ! 'Mx_Adsrb_H2O_Frc'
               diagv( n+4  ) = vegfrac( c,r )     ! 'Vegetation_Frac '
               diagv( n+5  ) = uland( c,r,3 )     ! 'Urban_Cover     '
               diagv( n+6  ) = uland( c,r,4 )     ! 'Forest_Cover    '

               n = n + 6

! accum and coarse mode number density emissions
               diagv( n+1 ) = dustoutn( 1,c,r )
               diagv( n+2 ) = dustoutn( 2,c,r )
! accum and coarse mode surface area density emissions
               diagv( n+3 ) = dustouts( 1,c,r )
               diagv( n+4 ) = dustouts( 2,c,r )
              
               n = n + 4
               m = 0
               do v = 1, ndust_spc
                  if ( dust_spc( v )%spcfac( 1 ) .gt. 0. ) then  ! accum. mode mass emissions
                     m = m + 1
                     diagv( m+n ) = dustoutm( v,c,r )
                  end if
               end do

               do v = 1, ndust_spc
                  if ( dust_spc( v )%spcfac( 2 ) .gt. 0. ) then  ! coarse mode mass emissions
                     m = m + 1
                     diagv( m+n ) = dustoutm( v+ndust_spc,c,r )
                  end if
               end do

               n = n + m

C Multiply by sync step because when write to output we divide by the output step
C to get a timestep average.
               do v = 1, ndust_diag
                  dustbf( v,c,r ) = dustbf( v,c,r ) + diagv( v )
     &                            * float( time2sec( tstep( 2 ) ) )
#ifdef verbose_wbdust
                  sdiagv( v ) = sdiagv( v ) + diagv( v )
     &                                      * float( time2sec( tstep( 2 ) ) )
#endif
               end do
            end if   ! dustem_diag

            ! Convert Dust emissions from tendencies [e.g. g/m3/s] to
            ! emission rates [e.g. g/s]
            do n = 1,2
              do v = 1, ndust_spc
                 dustoutm( (n-1)*ndust_spc+v,c,r ) = 
     &                     dustoutm( (n-1)*ndust_spc+v,c,r ) * gsfac( c,r )
              end do
            
              dustoutn( n,c,r ) = dustoutn( n,c,r ) * gsfac( c,r )
              dustouts( n,c,r ) = dustouts( n,c,r ) * gsfac( c,r )
            end do
 
         end do   ! col
         end do   ! row

#ifdef verbose_wbdust
         write( logdev,'( 5x, a, 2i8 / )' ) 'dust hit count, out of total cells:',
     &                                       dusthit, (c-1)*(r-1)
#endif

#ifndef mpas
         if ( dustem_diag .and. .not. l_desid_diag ) then

C If last call this hour, write out the windblown dust emissions dignostics.
C Then reset the emissions array and local write counter.

            wstep = wstep + time2sec( tstep( 2 ) )

            if ( wstep .ge. time2sec( tstep( 1 ) ) ) then
               if ( .not. currstep( jdate, jtime, stdate, sttime, tstep( 1 ),
     &                              mdate, mtime ) ) then
                  xmsg = 'Cannot get step date and time'
                  call m3exit( pname, jdate, jtime, xmsg, xstat3 )
               end if
               call nextime( mdate, mtime, tstep( 1 ) )

#ifdef verbose_wbdust
               sdiagv = sdiagv / float( wstep )   ! array assignment
               write( logdev,2015 ) jdate, jtime
               do v = 1, ndust_diag
                  if ( diagnm( v )%var(1:4) .ne. 'ANUM' ) then
                     write( logdev,2019 ) v, diagnm( v )%var, sdiagv( v )
                  else
                     write( logdev,2023 ) v, diagnm( v )%var, sdiagv( v )
                  end if
               end do
               sdiagv = 0.0   ! array assignment
#endif
               do v = 1, ndust_diag
                  do r = 1, nrows
                     do c = 1, ncols
                        wrbuf( c,r ) = dustbf( v,c,r ) / float( wstep )
                     end do
                  end do

                  if ( .not. WRITE3( ctm_dust_emis_1, diagnm( v )%var,
     &                       mdate, mtime, wrbuf ) ) then
                     xmsg = 'Could not write ' // trim( diagnm( v )%var )
     &                    // ' to CTM_DUST_EMIS_1'
                     call m3exit( pname, mdate, mtime, xmsg, xstat1 )
                  end if
               end do
               write( logdev,'( /5x, 2( a, 1x ), i8, ":", i6.6 )' )
     &               'Timestep written to CTM_DUST_EMIS_1',
     &               'for date and time', mdate, mtime
               wstep = 0
               dustbf = 0.0   ! array assignment
            end if   !  time to write
         end if   ! dustem_diag
#endif



2009     Format( '*** Erodible landuse incorrect ', 1pe13.5, 1x, 'at: ', 3i4 )
2015     format( /5x, 'Total grid time-avg sum of dust emis variables at:',
     &            1x, i8, ":", I6.6  )
2019     format( i10, 1x, a, f20.5 )
2023     format( i10, 1x, a, e20.3 )

         end subroutine get_dust_emis

C=======================================================================
         function dust_hflux( ndp, dp, soiltxt, fmoit, fruf, ustr, sd_ep, dens )
     &      result( hflux )

C usage: hflux = dust_flux( ndp, dp,
C                           soiltxt2( : ),
C                           fmoit( c,r ),
C                           fruf( c,r,m ),
C                           ustr( c,r,m ),
C                           sd_ep( c,r ),
C                           dens( c,r ) )

            use const, only: grav
            implicit none

            integer, intent( in ) :: ndp
            real,    intent( in ) :: dp( ndp )
            real,    intent( in ) :: soiltxt( ndp )
            real,    intent( in ) :: fmoit, fruf, ustr, sd_ep, dens
            real hflux

            real, parameter :: amen = 1.0          ! Marticorena and Bergametti [JGR,1997]
            real, parameter :: cfac = 1000.0 * amen / grav
            real, parameter :: A = 260.60061       ! 0.0123 * 2650.0 * 9.81 / 1.227
            real, parameter :: B = 1.6540342e-06   ! 0.0123 * 0.000165 / 1.227
            real utstar                            ! threshold U* [m/s]
            real utem                              ! U term [(m/s)**3]
            real fac
            integer n

! I can't initialize dp this way - it has to be passed in since ndp is variable

C---Mean mass median diameter (m) for each soil texture
C   [Chatenet et al., Sedimentology 1996 and Menut et al., JGR 2013]
!           real :: dp( ndp ) =
!    &              (/ 690.0E-6,     ! Coarse sand
!    &                 210.0E-6,     ! Fine-medium sand
!    &                 125.0E-6,     ! Silt
!    &                   2.0E-6 /)   ! Clay

            fac = cfac * dens * sd_ep
            utem    = 0.0
            utstar  = 0.0
            hflux   = 0.0
            do n = 1, ndp   ! loop over dust particle size
!              utstar = sqrt( 0.0123 * ( 2650.0 * 9.81 * dp( n ) / 1.227 + 0.000165
!              / 1.227 / dp( n ) ) )              ! X roughness & moisture effects
               utstar = sqrt( A * dp( n ) + B / dp( n ) ) * fmoit * fruf !Shao and Lu [JGR,2000]
               if ( ustr .gt. utstar ) then  ! wind erosion occurs only if U* > U*t
C---Horiz. Flux from White (1979)
                  utem = ( ustr + utstar ) * ( ustr * ustr - utstar * utstar )
C---Horiz. Flux from Owen (1964)
!                 utem = ustr * ( ustr * ustr - utstar * utstar )
                  hflux = hflux
     &                  + fac * utem * soiltxt( n )   !  [g/m/s]
               end if
            end do   ! dust particle size

         end function dust_hflux

      end module dust_emis

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      module get_env_module

! Function: get environment variables

! Revision History:
!        2010 D.Wong: initial implementation
!  2 Feb 2010 D.Wong: provided an optional outputing device option,
!                     absorbed get_envlist function

        implicit none

        integer, parameter :: max_str_len = 10000

        character (max_str_len) :: loc_str

        interface get_env
          module procedure get_env_int,      &
                           get_env_float,    &
                           get_env_double,   &
                           get_env_char,     &
                           get_env_logical
        end interface

        contains

! --------------------------------------------------------------------------------
        subroutine get_env_int (env_value, env_var, default_env_value, logdev)

          integer, intent(out)      :: env_value
          character (*), intent(in) :: env_var
          integer, intent(in)       :: default_env_value
          integer, intent(in), optional :: logdev

          integer :: loc_logdev
          logical :: default, regular

          call getenv (env_var, loc_str)

          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

          regular = .false.
          default = .false.

          if (len(trim(loc_str)) == 0) then
             env_value = default_env_value
             default = .true.
          else
             read (loc_str, *) env_value
             regular = .true.
          end if

          if ( loc_logdev .gt. 0 ) then
             if (default) then
                write( loc_logdev, '(5x,A21,2x,A,2x,i10, 1x, a9)' ), env_var,'|', env_value, '(default)'
             else if (regular) then
                write( loc_logdev, '(5x,A21,2x,A,2x,i10)' ), env_var,'|', env_value
             end if
          end if

        end subroutine get_env_int

! --------------------------------------------------------------------------------
        subroutine get_env_float (env_value, env_var, default_env_value, logdev)

          real, intent(out)         :: env_value
          character (*), intent(in) :: env_var
          real, intent(in)          :: default_env_value
          integer, intent(in), optional :: logdev

          integer :: loc_logdev
          logical :: default, regular

          call getenv (env_var, loc_str)

          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

          regular = .false.
          default = .false.

          if (len(trim(loc_str)) == 0) then
             env_value = default_env_value
             default = .true.
          else
             read (loc_str, *) env_value
             regular = .true.
          end if

          if ( loc_logdev .gt. 0 ) then
             if (default) then
                write( loc_logdev, '(5x,A21,2x,A,2x,e10.3, 1x, a9)' ), env_var,'|', env_value, '(default)'
             else if (regular) then
                write( loc_logdev, '(5x,A21,2x,A,2x,e10.3)' ), env_var,'|', env_value
             end if
          end if

        end subroutine get_env_float

! --------------------------------------------------------------------------------
        subroutine get_env_double (env_value, env_var, default_env_value, logdev)

          real (8), intent(out)     :: env_value
          character (*), intent(in) :: env_var
          real (8), intent(in)          :: default_env_value
          integer, intent(in), optional :: logdev

          integer :: loc_logdev
          logical :: default, regular

          call getenv (env_var, loc_str)

          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

          regular = .false.
          default = .false.

          if (len(trim(loc_str)) == 0) then
             env_value = default_env_value
             default = .true.
          else
             read (loc_str, *) env_value
             regular = .true.
          end if

          if ( loc_logdev .gt. 0 ) then
             if (default) then
                write( loc_logdev, '(5x,A21,2x,A,2x,e10.3, 1x, a9)' ), env_var,'|', env_value, '(default)' 
             else if (regular) then
                write( loc_logdev, '(5x,A21,2x,A,2x,e10.3)' ), env_var,'|', env_value
             end if
          end if

        end subroutine get_env_double

! --------------------------------------------------------------------------------
        subroutine get_env_char (env_value, env_var, default_env_value, logdev)

          character (*), intent(out) :: env_value
          character (*), intent(in)  :: env_var
          character (*), intent(in)  :: default_env_value
          integer, intent(in), optional :: logdev

          integer :: loc_logdev, length
          logical :: default, regular
          character (50) :: myfmt

          call getenv (env_var, loc_str)

          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

          regular = .false.
          default = .false.

          if (len(trim(loc_str)) == 0) then
             env_value = default_env_value
             default = .true.
          else
             env_value = loc_str
             regular = .true.
          end if

          if ( loc_logdev .gt. 0 ) then
             length = len_trim(env_value)
             if (default) then
                if (length .eq. 0) then
                   write( loc_logdev, '(5x,A21, 2x, A, 13x, a9)') env_var, '|', '(default)'
                else
                   write (myfmt, '(a22, i3.3, a9)') '(5x, A21, 2x, A, 2x, A', length, ', 1x, a9)'
                   write( loc_logdev, myfmt) env_var, '|', env_value, '(default)'
                end if
             else if (regular) then
                write (myfmt, '(a22, i3.3, a1)') '(5x, A21, 2x, A, 2x, A', length, ')'
                write( loc_logdev, myfmt) env_var,'|', env_value
             end if
          end if

        end subroutine get_env_char

! --------------------------------------------------------------------------------
        subroutine get_env_logical (env_value, env_var, default_env_value, logdev)

          logical, intent(out)      :: env_value
          character (*), intent(in) :: env_var
          logical, intent(in)       :: default_env_value
          integer, intent(in), optional :: logdev

          integer :: length
          integer :: loc_logdev
          logical :: default, regular

          call getenv (env_var, loc_str)

          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

          length = len(trim(loc_str))
          regular = .false.
          default = .false.

          if (length <= 0) then
             env_value = default_env_value
             default = .true.
          else if ((length == 1) .and. ((loc_str(1:1) .eq. 'Y') .or.       &
                                        (loc_str(1:1) .eq. 'y') .or.       &
                                        (loc_str(1:1) .eq. 'T') .or.       &
                                        (loc_str(1:1) .eq. 't'))) then
             env_value = .true.
             regular = .true.
          else if ((length == 1) .and. ((loc_str(1:1) .eq. 'N') .or.       &
                                        (loc_str(1:1) .eq. 'n') .or.       &
                                        (loc_str(1:1) .eq. 'F') .or.       &
                                        (loc_str(1:1) .eq. 'f'))) then
             env_value = .false.
             regular = .true.
          else if ((trim(loc_str) == '.TRUE.') .or.                        &
                   (trim(loc_str) == '.true.') .or.                        &
                   (trim(loc_str) == '.True.') .or.                        &
                   (trim(loc_str) == 'TRUE') .or.                          &
                   (trim(loc_str) == 'true') .or.                          &
                   (trim(loc_str) == 'True') .or.                          &
                   (trim(loc_str) == 'YES') .or.                           &
                   (trim(loc_str) == 'yes') .or.                           &
                   (trim(loc_str) == 'Yes')) then
             env_value = .true.
             regular = .true.
          else if ((trim(loc_str) == '.FALSE.') .or.                       &
                   (trim(loc_str) == '.false.') .or.                       &
                   (trim(loc_str) == '.False.') .or.                       &
                   (trim(loc_str) == 'FALSE') .or.                         &
                   (trim(loc_str) == 'false') .or.                         &
                   (trim(loc_str) == 'False') .or.                         &
                   (trim(loc_str) == 'NO') .or.                            &
                   (trim(loc_str) == 'no') .or.                            &
                   (trim(loc_str) == 'No')) then
             env_value = .false.
             regular = .true.
          else
             write (loc_logdev, *) ' Note: Variable ', trim(env_var), ' improperly formatted'
             env_value = default_env_value
             default = .true.
          end if

          if ( loc_logdev .gt. 0 ) then
             if (default) then
                write( loc_logdev, '(5x,A21,2x,A,10x,L, 1x, a9)' ), env_var,'|', env_value, '(default)'
             else if (regular) then
                write( loc_logdev, '(5x,A21,2x,A,10x,L)' ), env_var,'|', env_value
             end if
          end if

        end subroutine get_env_logical

! --------------------------------------------------------------------------------
        subroutine get_envlist ( env_var, nvars, val_list, in_logdev )

! get a list env var (quoted string of items delimited by white space,
! commas or semi-colons) and parse out the items into variables. Two data
! types: character strings and integers (still represented as strings in
! the env var vaules).
! Examples:
! 1)   setenv AVG_CONC_VARS "O3 NO NO2"
! 2)   setenv AVG_CONC_LAYS "2 5"          < start at two, end at 5
! 3)   setenv NPCOLSXNPROWS "4 3"
! 4)   setenv BCOL_ECOL "3 8"
! 5)   setenv BROW_EROW "2 10"
! 6)   setenv BLAY_ELAY "1 5"

! In example (1), not only parse out the named items "O3", "NO" and "NO2",
! but also obtain the count on the number of items (=3).

! Revision: 2013/02/11 David Wong: increased the max env var length from 256 to 1000
! 13 Dec 2013 J.Young: 1000 breaks BUFLEN in IOAPI's envgets.c. Change to 512.
! 17 Jun 2016 J.Young: IOAPI's envgets.c BUFLEN has been increased to 10000.
! 20 Jun 2016 J.Young: Forget IOAPI's envgets.c: use Fortran GETENV

#ifndef mpas
          use utilio_defn
#endif

          character( * ),  intent ( in )  :: env_var
          integer,         intent ( out ) :: nvars
          character( 16 ), intent ( out ) :: val_list( : )
          integer, intent(in), optional :: in_logdev

          integer             :: max_len
          character( 16 )     :: pname = 'GET_ENVLIST'
          character( 16*size( val_list ) ) :: e_val
          character(  1 )     :: chr
          character( 96 )     :: xmsg

          integer :: jp( 16*size( val_list ) ), kp( 16*size( val_list ) ), status
          integer ip, v

          integer :: loc_logdev
 
          if (present(in_logdev)) then
             loc_logdev = in_logdev
          else
             loc_logdev = 6
          end if

           max_len = 16 * size( val_list )

          call get_env( e_val, env_var, ' ', loc_logdev )

          if ( e_val .eq. " " ) then
             xmsg = 'Environment variable ' // env_var // ' not set'
#ifndef mpas
             call m3warn( pname, 0, 0, xmsg )
#endif
             nvars = 0
             val_list = ''
             return
          end if

          nvars = 1

          ip = 0

101   continue
          ip = ip + 1
          if ( ip .gt. max_len ) go to 301
          chr = e_val( ip:ip )
          if ( chr .eq. ' ' .or. ichar ( chr ) .eq. 09 ) go to 101
          jp( nvars ) = ip   ! 1st char

201   continue
          ip = ip + 1
          if ( ip .gt. max_len ) then
             xmsg = 'Environment variable value too long'
#ifndef mpas
             call m3exit( pname, 0, 0, xmsg, 2 )
#endif
          end if
          chr = e_val( ip:ip )
          if ( chr .ne. ' ' .and.    &
               chr .ne. ',' .and.    &
               chr .ne. ';' .or.     &
               ichar ( chr ) .eq. 09 ) then  ! 09 = horizontal tab
             go to 201
          else
             kp( nvars ) = ip - 1 ! last char in this item
             nvars = nvars + 1
          end if

          go to 101

301       continue
          nvars = nvars - 1

          do v = 1, nvars
             val_list( v ) = e_val( jp( v ):kp( v ) )
          end do

        end subroutine get_envlist
        function get_free_iounit() result ( iounit )

! function finds and return a free IO unit
! adapted from D.Wong's mio library

           implicit none

           integer :: iounit
           logical :: found, opened

           iounit = 99
           found = .false.
           do while ((.not. found) .and. (iounit .le. 100000))
              inquire (unit=iounit, opened=opened)
              if (.not. opened) then
                 found = .true.
              else
                 iounit = iounit + 1
              end if
           end do


        end function get_free_iounit


      end module get_env_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker] 
C $Header: /project/work/rep/PARIO/src/pio_re_init.f,v 1.6 2011/03/30 18:13:02 sjr Exp $

      LOGICAL FUNCTION PIO_INIT ( COLROW, GL_NCOLS, GL_NROWS, NLAYS,
     &                            NTHIK, NCOLS, NROWS, NPCOL, NPROW,
     &                            NPROCS, MYPE, WFLG, IO_PE_INCLUSIVE )
C ....................................................................
 
C  PURPOSE:    Initialize parallel Models-3 I/O API library routines.
C              This includes starting up the I/O API and calculating
C              processor-to-subdomain maps.
 
C  RETURN VALUE: The function as written always returns a value of TRUE.
C       (i.e., this could have been written as a subroutine, but is
C       written as a FUNCTION in the anticipation that failure conditions
C       will be added.) If subroutine ALLOINT a non-zero error code,
C       M3WARN is called and execution is terminated. Subroutine
C       SUBDMAP will also terminate program execution if an error is
C       detected during memory allocation.
 
C  REVISION HISTORY: 
C       Original version  2/96 by Al Bourgeois for parallel implementation
C       Modified 6/98 by AJB for PAR_IO library, added error code
C       Modified 07/08/1998 by AJB to set IO_GRP and MY_IO_PE
C       Modified 07/29/1998 by AJB to allow setting of NPROW, NPCOL outside
C                Also added synchronization of return code across processors
C       Modified 08/25/1998 to remove MPI initialization, and to pass in
C                grid decomposition variables through the argument list
C       Modified 12/07/1998 by Al Bourgeois to add EXTERNAL declarations
C       Modified 01/26/1999 by Al Bourgeois to allocate memory for write maps
C       Modified 06/16/1999 by Al Bourgeois to remove interprocessor
C          synchronization. This removes the guarantee that all processors
C          return the same error code, and a "hang" state can occur if
C          PM3EXIT is not called on the condition that this function fails
C       Modified 08/06/1999 by Al Bourgeois to simplify error handling
C                12 Apr 2001 by J. Young to eliminate I/O processors
C       Modified 02/06/2004 by David Wong
C          -- uses f90 syntax to allocate memory to avoid using DYNMEM
C             library
C       Modified 08/26/2004 by David Wong
C          -- added a statement to check whether allocated memory is already
C             exist
C                01/07/2006 Jeff Young, add arg list flag to optionally print
C                decomposition map
C       Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with M3UTILIO
C       Modified 12/05/2015 by David Wong
C          -- Initialized PIO_GL_NCOLS and PIO_GL_NROWS
C       Modified 12/09/2015 by David Wong
C          -- Added an optional argument in PIO_RE_INIT routine
C       Modified 01/26/2016 by Jeff Young
C          -- Change WFLG to an optional argument and make PIO_RE_INIT the only
C             PIO_INIT routine
 
C  ARGUMENT LIST DESCRIPTION:
C  IN:
C     CHARACTER( 2 ) :: COLROW   ! Columns/Rows orientation check
C     INTEGER GL_NCOLS           ! Number of columns in entire grid
C     INTEGER GL_NROWS           ! Number of rows in entire grid
C     INTEGER NLAYS              ! Number of layers in entire grid
C     INTEGER NTHIK              ! Cell thickness of grid boundary
C     INTEGER NPCOL              ! Number of processors across grid columns
C     INTEGER NPROW              ! Number of processors across grid rows
C     INTEGER NCOLS              ! Column dimension of local-processor arrays
C     INTEGER NROWS              ! Row dimension of local-processor arrays
C     INTEGER NPROCS             ! Number of processors
C     INTEGER MYPE               ! Local processor id
C     LOGICAL WFLG               ! If present print out decompostion map
C     LOGICAL IO_PE_INCLUSIVE    ! If present
 
C  OUT:
C   COMMON BLOCK PIOGRID:
C     INTEGER  NPCOLD            ! Number of processors across grid columns
C     INTEGER  NPROWD            ! Number of processors across grid rows
C     INTEGER  GNCOLS            ! Number of columns in global grid
C     INTEGER  GNROWS            ! Number of rows in global grid
C     INTEGER  BTHICK            ! Cell thickness of grid boundary
C     INTEGER  NUMCOLS           ! Column dimension of local-processor arrays
C     INTEGER  NUMROWS           ! Row dimension of local-processor arrays
C     INTEGER  MY_NCOLS          ! Local number of grid columns
C     INTEGER  MY_NROWS          ! Local number of grid rows
C     INTEGER  MAXCELLS          ! Maximum subdomain size over PEs
C     INTEGER  NGB_PE(8)         ! PE neighborhood, first north then clockwise
 
C   COMMON BLOCK PIOVARS:
C     INTEGER  MY_PE             ! Local processor id
C     INTEGER  IO_PE             ! Id of processor used for file I/O
 
C   COMMON BLOCK PIOMAPS:
C     INTEGER  NUMPROCS             ! Number of processors
C     INTEGER  NCOLS_PE(NUMPROCS)   ! Number columns in each processor
C     INTEGER  NROWS_PE(NUMPROCS)   ! Number rows in each processor
C     INTEGER  COLSX_PE(2,NUMPROCS) ! Column range for each PE
C     INTEGER  ROWSX_PE(2,NUMPROCS) ! Row range for each PE
         
C  LOCAL VARIABLE DESCRIPTION:  see below
 
C  CALLS:  SUBDMAP, WRSUBDMAP, ALLOINT, SETINT, M3WARN
 
C  NOTES: Uses dynamic memory allocation for processor-to-subdomain
C    maps NROWS_PE, ROWSX_PE, NCOLS_PE, and COLSX_PE
 
C    To hide parallelism, domain decomposition information is maintained
C    via COMMON blocks instead of subroutine arguments.
 
C    The group-I/O flag, IO_GRP, determines if a processor will partici-
C    pate in file reading operations. This depends on the arrangement
C    of processors distributed across grid rows (NPROW). The following
C    diagram shows the situation for an example subdomain layout. In the
C    example, IO_GRP would be set to 1 on PE 0 and PE 4, and set to 0 on
C    all other PEs.
 
C                                                    NPCOL
C  Example subdomain layout         _____________________________________
C  for 8 processors with           |         |         |        |        |
C  NPROW=2, NPCOL=4                | I/O     |         |        |        |
C                                  |    4    |    5    |    6   |    7   |
C  PE 0 will read                  |         |         |        |        |
C  for PEs 0,1,2,3          NPROW  |_________|_________|________|________|
C                                  |         |         |        |        |
C  PE 4 will read                  | I/O     |         |        |        |
C  for PEs 4,5,6,7                 |    0    |    1    |    2   |    3   |
C                                  |         |         |        |        |
C                                  |         |         |        |        |
C                                  |_________|_________|________|________|
 
C .......................................................................

      USE PIOMAPS_MODULE
      USE M3UTILIO              ! i/o api

      IMPLICIT  NONE

C INCLUDE FILES

      INCLUDE 'PIOGRID.EXT'      ! Parallel grid dimensions
      INCLUDE 'PIOVARS.EXT'      ! Parameters for parallel implementation
!     INCLUDE 'PIOMAPS.EXT'      ! Parallel processor-to-subdomain maps

C ARGUMENTS:

      CHARACTER( 2 ), INTENT( INOUT ) :: COLROW  ! Columns/Rows orientation check
      INTEGER, INTENT( IN ) :: GL_NCOLS ! Number of columns in entire grid
      INTEGER, INTENT( IN ) :: GL_NROWS ! Number of rows in entire grid
      INTEGER, INTENT( IN ) :: NLAYS    ! Number of layers in entire grid
      INTEGER, INTENT( IN ) :: NTHIK    ! Cell thickness of grid boundary
      INTEGER, INTENT( IN ) :: NPCOL    ! Number of processors across grid cols
      INTEGER, INTENT( IN ) :: NPROW    ! Number of processors across grid rows
      INTEGER, INTENT( IN ) :: NCOLS    ! Col dimension of local-processor arrays
      INTEGER, INTENT( IN ) :: NROWS    ! Row dimension of local-processor arrays
      INTEGER, INTENT( IN ) :: NPROCS   ! Number of processors
      INTEGER, INTENT( IN ) :: MYPE     ! Local processor id
      LOGICAL, INTENT( IN ), OPTIONAL :: WFLG  ! If present print out decomposition map
      LOGICAL, INTENT( IN ), OPTIONAL :: IO_PE_INCLUSIVE

C EXTERNAL FUNCTIONS:

      EXTERNAL      SUBDMAP, WRSUBDMAP  ! Parallel M3IO library

C LOCAL VARIABLES: 

      INTEGER I                  ! Loop index
      INTEGER J                  ! Loop index
      INTEGER LOCI               ! Row index of MYPE in Cartesian coordinate
      INTEGER LOCJ               ! Col. index of MYPE in Cartesian coordinate
      INTEGER POS                ! Index into neighborhood conversion table
      INTEGER CONV( 8 )          ! Processor neighborhood conversion table
      INTEGER IERROR             ! Error code
      INTEGER LOGDEV             ! FORTRAN unit number for log file
      CHARACTER( 80 ) :: MSG     ! For message issued from M3WARN
      CHARACTER( 16 ), SAVE :: PNAME = 'PIO_INIT'
      LOGICAL, SAVE   :: FIRST_TIME = .TRUE.

C   Equivalence of the conversion table:
C
C   (LOCI+1, LOCJ-1) (LOCI+1, LOCJ) (LOCI+1, LOCJ+1)                8  1  2
C   ( LOCI,  LOCJ-1) ( LOCI,  LOCJ) ( LOCI,  LOCJ+1) equivalent to  7     3
C   (LOCI-1, LOCJ-1) (LOCI-1, LOCJ) (LOCI-1, LOCJ+1)                6  5  4
      DATA CONV / 8, 1, 2, 7, 3, 6, 5, 4 /

C .......................................................................

C Initialize return value and error code
      CALL UPCASE ( COLROW )
      IF ( COLROW .eq. 'CR' ) THEN
         PIO_INIT = .TRUE.
      ELSE
         MSG = 'Argument list must have cols/rows orientation.'
         CALL M3WARN( PNAME, 0, 0, MSG )
         PIO_INIT = .FALSE.; RETURN
      END IF
      IERROR = 0

C Set COMMON block variables.
      NUMPROCS = NPROCS      ! Number of processors                      A
      MY_PE    = MYPE        ! Local processor id                        B
      IO_PE    = 0           ! I/O processor id                          B
      NPCOLD   = NPCOL       ! Number of processors across grid columns  C
      NPROWD   = NPROW       ! Number of processors across grid rows     C
      GNCOLS   = GL_NCOLS    ! Number of columns in global grid          C
      GNROWS   = GL_NROWS    ! Number of rows in global grid             C
      GNLAYS   = NLAYS       ! Number of layers in global grid           C
      BTHICK   = NTHIK       ! Cell thickness of grid boundary           C
      NUMCOLS  = NCOLS       ! Number of columns in local subgrid        C
      NUMROWS  = NROWS       ! Number of rows in local subgrid           C
      PIO_GL_NCOLS = GL_NCOLS  ! Number of columns in global grid        C
      PIO_GL_NROWS = GL_NROWS  ! Number of rows in global grid           C
C A - PIOMAPS_MODULE
C B - PIOVARS.EXT
C C - PIOGRID.EXT

C set flag in PIOMAPS_MODULE for PSHUT3

      IF ( PRESENT( IO_PE_INCLUSIVE ) ) THEN
         PARIO_IO_PE_INCLUSIVE = IO_PE_INCLUSIVE
      END IF

C Compute processor neighborhood

      LOCI = MY_PE / NPCOL
      LOCJ = MOD ( MY_PE, NPCOL )
      POS = 0
      DO I = LOCI+1, LOCI-1, -1
         DO J = LOCJ-1, LOCJ+1
            IF ( ( I .NE. LOCI ) .OR. ( J .NE. LOCJ ) ) THEN
               POS = POS + 1
               IF ( ( I .GE. 0 )     .AND.
     &              ( I .LT. NPROW ) .AND.
     &              ( J .GE. 0 )     .AND.
     &              ( J .LT. NPCOL ) ) THEN
                  NGB_PE( CONV( POS ) ) = I * NPCOL + J
               ELSE
                  NGB_PE( CONV( POS ) ) = -1
               END IF
            END IF
         END DO
      END DO

C Allocate memory for processor-to-subdomain maps

      IF ( .NOT. ALLOCATED ( NCOLS_PE ) ) THEN
         ALLOCATE ( NCOLS_PE( NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating NCOLS_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( NROWS_PE( NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating NROWS_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( COLSX_PE( 2,NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating COLSX_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( ROWSX_PE( 2,NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating ROWSX_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

C Allocate memory for processor-to-subdomain write maps

         ALLOCATE ( WR_NCOLS_PE( NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating WR_NCOLS_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( WR_NROWS_PE( NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating WR_NROWS_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( WR_COLSX_PE( 2,NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating WR_COLSX_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( WR_ROWSX_PE( 2,NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating WR_ROWSX_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

      END IF

C Calculate processor-to-subdomain maps

      CALL SUBDMAP ( NUMPROCS, GL_NCOLS, GL_NROWS, NLAYS, NPCOL, NPROW,
     &               NCOLS_PE, NROWS_PE, COLSX_PE, ROWSX_PE,
     &               MAXCELLS, IERROR )
      IF ( IERROR .NE. 0 ) THEN
         MSG = 'Error in SUBDMAP'
         CALL M3WARN( PNAME, 0, 0, MSG )
         PIO_INIT = .FALSE.; RETURN
      END IF

C Write out processor-to-subdomain map

      IF ( MY_PE .EQ. IO_PE ) THEN
         IF ( PRESENT( WFLG ) .AND. FIRST_TIME ) THEN
            FIRST_TIME = .FALSE.
            CALL WRSUBDMAP ( NUMPROCS, NCOLS_PE, NROWS_PE, COLSX_PE, ROWSX_PE )
         END IF
      END IF

C Set number of rows and columns for (this) local processor

      MY_NCOLS = NCOLS_PE( MY_PE+1 )   ! COMMON block
      MY_NROWS = NROWS_PE( MY_PE+1 )   ! COMMON block

      RETURN
      END FUNCTION PIO_INIT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE DEGRADE_SETUP_TOX
C**********************************************************************
C
C  FUNCTION:  Define arrays that identify species within CGRID used
C             based on input arrays
C
C  REVISION HISTORY: 07/29/05 : B.Hutzell - Initial version
C                    06 May 11: B.Hutzell: convert for Namelist redesign
C                    09 May 11: B.Hutzell: enabled a degraded species to
C                               be missing from namelists
C
C**********************************************************************

      USE GRID_CONF, ONLY: BLKSIZE ! vertical and horizontal domain specs
      USE CGRID_SPCS               ! CGRID species number and offsets
      USE UTILIO_DEFN              ! IOAPI declarations and definitions
      USE DEGRADE_PARAMETERS
      USE CONST

      IMPLICIT NONE

      REAL(8)              :: EFFECTIVE_ZERO
      REAL(8)              :: LOG_EFFECTIVE_ZERO
      REAL(8)              :: INFINITY


C..arrays to store indices to CGRID

      INTEGER, ALLOCATABLE :: RXTANT_MAP   ( : )
      INTEGER, ALLOCATABLE :: DEGRADE_INDEX( : )
      INTEGER, ALLOCATABLE :: PROD_MAP( :,: )
      INTEGER, ALLOCATABLE :: RAD_MAP( :,: )
      INTEGER, ALLOCATABLE :: RAD2_MAP( :,:,: )
      INTEGER, ALLOCATABLE :: PHOTO_MAP( :,: )
      
      INTEGER :: DEGRADE_STEP
      INTEGER :: SA_DEGRADE_STEP = 0      

C..saved cell concentrations

      REAL( 8 ), ALLOCATABLE :: OLD_CONC( : )
      REAL( 8 ), ALLOCATABLE :: NEW_CONC( : )
#ifdef sens
      REAL,      ALLOCATABLE :: SENS_CONC( :,: )
#endif
      REAL( 8 )              :: TEMP_AIR            ! cell temperature [ K ]
      REAL( 8 )              :: CONC_AIR            ! cell air number density [ 1/CM^3 ]
      REAL( 8 )              :: CONC_N2             ! cell N2 number density [ 1/CM^3 ]
      REAL( 8 )              :: CONC_O2             ! cell O2 number density [ 1/CM^3 ]
      REAL( 8 )              :: CONC_CH4            ! cell CH4 number density [ 1/CM^3 ]
      REAL( 8 )              :: CONC_H2             ! cell H2 number density [ 1/CM^3 ]
      REAL( 8 )              :: CONC_H2O            ! cell H2O number density [ 1/CM^3 ]

C..saved blocked cells concentrations

      REAL( 8 ), ALLOCATABLE :: PREV_CONC( :,: )   
      REAL( 8 ), ALLOCATABLE :: CURR_CONC( :,: )
#ifdef sens
      REAL,      ALLOCATABLE :: SENS_BLK( :,:,: )
#endif
      REAL( 4 ), ALLOCATABLE :: AERO_BLK ( :,: )
      REAL( 8 ), ALLOCATABLE :: TEMP( : )           ! cell temperature [ K ]
      REAL( 8 ), ALLOCATABLE :: PRESS( : )          ! cell Pressure    [ Pa ]
      REAL( 8 ), ALLOCATABLE :: INV_TEMP( : )       ! cell inverse temperature [ 1/K ]
      REAL( 8 ), ALLOCATABLE :: NUMB_DENS( : )      ! cell air number density [ 1/CM^3 ]
      REAL( 8 ), ALLOCATABLE :: NUMB_H2O( : )       ! cell H2O number density [ 1/CM^3 ]
      REAL( 8 ), ALLOCATABLE :: CONV_FACT( : )      ! conversion factor from ppm to molecules/cm^3

      REAL(8), ALLOCATABLE :: CHANGE_CONC( : )    ! cell concentration changes predicted by degrade routine
      REAL(8), ALLOCATABLE :: DELT_CONC( :,: )    ! block concentration changes predicted by degrade routine

      REAL(8), ALLOCATABLE :: CELL_RKI( :,: )     ! cell rate constant for species
      REAL(8), ALLOCATABLE :: RATE_CONST( :,:,: ) ! block rate constants for species
      REAL(8), ALLOCATABLE :: RATE_YIELD( :,: )   ! product yield from reaction

#ifdef isam
      INTEGER                      :: ISAM_DEGRADED_SPC     ! number of ISAM species with degradation
      INTEGER,         ALLOCATABLE :: ISAM_DEGRADE_MAP( : ) ! index in ISAM species array to extract conc
      INTEGER,         ALLOCATABLE :: ISAM_TO_DEGRADED( : ) ! index in REACT concentation array
      INTEGER,         ALLOCATABLE :: ISAM_TO_REACTANT( : ) ! index in REACT data array to determine degradation
      REAL(8),         ALLOCATABLE :: CELL_ISAM( :,: )      ! concentrations apportioned to sources
      CHARACTER( 16 ), ALLOCATABLE :: ISAM_DEGRADED( : )    ! names of degraded isam species
#endif

      LOGICAL, ALLOCATABLE :: IS_AERO_ORGANIC( : )  ! is aerosol species as OA and not a tracer


      INTEGER :: NCELLS  = 0                        ! number of cells in block
C.. variables used to write cell results
      INTEGER :: DEG_LAY = 0
      INTEGER :: DEG_ROW = 0
      INTEGER :: DEG_COL = 0
C.. variable used to write a cell in a block
      INTEGER :: ICELL_WRITE = 1
      LOGICAL :: WRITE_BLOCK = .FALSE.
      LOGICAL, ALLOCATABLE :: WRITE_CELL( : )       ! write cell value used for debugging and QA


C**********************************************************************

      CONTAINS
      

         SUBROUTINE DEGRADE_MAP( JDATE, JTIME )
C**********************************************************************
C
C  Function:  Determine CGRID indices used in DEGRADE routine.
C             Check decay and degradation rates for negative values.
C
C  CALLED BY: INIT_DEGRADE
C
C**********************************************************************

         USE RXNS_DATA
#ifdef mpas
      use util_module, only : index1, upcase
#endif

         IMPLICIT NONE

C.....INCLUDES:


C.....ARGUMENTS:

         INTEGER, INTENT( IN ) :: JDATE        ! current model date , coded YYYYDDD
         INTEGER, INTENT( IN ) :: JTIME        ! current model time , coded HHMMSS

C.....PARAMETERS:

         REAL(8), PARAMETER :: TEMP_298K  = 298.15        ! K

C.....LOCAL VARIABLES:

         CHARACTER(  16 ) :: PNAME =  'DEGRADE_MAP    '     ! name of routine
         CHARACTER(  16 ) :: EMTPTY
         CHARACTER(  16 ) :: WNAME, XNAME                   ! SCRATCH variables
         CHARACTER(  16 ) :: VNAME( N_PROCESSES+1 )         ! SCRATCH variable
         CHARACTER( 128 ) :: XMSG = 'FATAL ERROR in DEGRADE_SETUP'

         INTEGER :: MARKER, N, M       ! indexes
         INTEGER :: I, J, K, L         ! loop counters
         INTEGER :: LEN_NAME           ! number of nonblank characters in species name
         INTEGER :: ICOUNT 
          
         REAL(8), PARAMETER :: INV_T298K = 1.0D0 / TEMP_298K   ! K^-1

         LOGICAL, SAVE :: INITIALIZED = .FALSE.

C.....EXTERNAL FUNCTIONS:

C**********************************************************************

         IF( INITIALIZED )RETURN
      
         INITIALIZED = .FALSE.
C..arrays to store indices to CGRID

         ALLOCATE( RXTANT_MAP   ( N_REACT ) )
         ALLOCATE( DEGRADE_INDEX( N_REACT ) )
         ALLOCATE( PROD_MAP  ( N_PROCESSES, N_REACT  ) )
         ALLOCATE( RAD_MAP   ( N_BI_LOSS + N_LANHIN_LOSS, N_REACT ) )
         ALLOCATE( RAD2_MAP  ( 2, N_TRI_LOSS, N_REACT ) )
         ALLOCATE( PHOTO_MAP ( N_PHOTO_LOSS, N_REACT ) )

         ALLOCATE( RATE_YIELD( N_PROCESSES, N_REACT ) )

C..Initialize maps

         RXTANT_MAP    = -1
         DEGRADE_INDEX = -1
         RAD_MAP     = -1
         RAD2_MAP    = -1
         PROD_MAP    = -1
         PHOTO_MAP   = -1

         RATE_YIELD = 1.0D0

C..save number of photolysis rates in mechanism

         N_PHOTO_TAB = NPHOTAB

C..Quality control on pairs of Reactant and Products

         WRITE( LOGDEV,* ) 'Comments on Species in degradation routines'

         N_REACT_FOUND = 0

         LOOP_REACT : DO I = 1, N_REACT

            VNAME( 1 ) = REACT( I )
            

            VNAME( UNI_START+1  :  UNI_STOP+1 )   = UNI_PROD  ( 1:N_UNI_LOSS, I )
            VNAME( BI_START+1   :   BI_STOP+1 )   = BI_PROD   ( 1:N_BI_LOSS, I  )
            VNAME( TRI_START+1  :  TRI_STOP+1 )   = TRI_PROD  ( 1:N_TRI_LOSS, I )
            VNAME( PHOTO_START+1:PHOTO_STOP+1 )   = PHOTO_PROD( 1:N_PHOTO_LOSS, I )
            VNAME( LANHIN_START+1:LANHIN_STOP+1 ) = LH_PROD   ( 1:N_LANHIN_LOSS, I )

            RATE_YIELD( UNI_START:UNI_STOP, I ) = UNI_YIELD( 1:N_UNI_LOSS, I )
            RATE_YIELD( BI_START:BI_STOP,   I ) = BI_YIELD ( 1:N_BI_LOSS, I  )
            RATE_YIELD( TRI_START:TRI_STOP, I ) = TRI_YIELD( 1:N_TRI_LOSS, I )
            RATE_YIELD( PHOTO_START:PHOTO_STOP, I ) = PHOTO_YIELD( 1:N_PHOTO_LOSS, I )
            RATE_YIELD( LANHIN_START:LANHIN_STOP, I ) = LH_YIELD( 1:N_LANHIN_LOSS, I )


            CALL UPCASE( VNAME( 1 ) )

            LEN_NAME = LEN_TRIM( VNAME( 1 ) )

            IF ( LEN_NAME < 1 ) THEN
               WRITE( LOGDEV,* ) 'A Reactant has no name.'
     &              // ' Check file degrade module'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            ENDIF
            
            DO K = 1, N_REACT

               WNAME = REACT( K )
               CALL UPCASE( WNAME )
               
               DO J = 2, N_PROCESSES+1
                  XNAME = VNAME( J ) 
                  IF( TRIM( WNAME ) == TRIM( XNAME ) )THEN
                     WRITE( XMSG,* ) 'ERROR: ',
     &                 TRIM( VNAME( 1 ) ), ' is a destroyed  and produced.'
     &                 // ' The property is not allowed because it'
     &                 // ' breaks linear assumptions used.'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
                  END IF
               END DO    
            
            END DO

            DO K = 1, N_BI_LOSS
               IF ( VNAME( 1 ) == BICAUSE( K, I ) ) THEN
                  WRITE( XMSG,* ) 'ERROR: ',
     &                 TRIM( VNAME( 1 ) ), ' has same name'
     &                 // ' as a species causing its bimolecular loss.'
     &                 // ' This breaks linear assumptions used.'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               ENDIF
            ENDDO

            DO K = 1, N_TRI_LOSS
               IF ( VNAME( 1 ) == TRICAUSE( 1, K, I ) .OR.
     &              VNAME( 1 ) == TRICAUSE( 2, K, I ) ) THEN
                  WRITE( XMSG,* ) 'ERROR: ',
     &                 TRIM( VNAME( 1 ) ), ' has same name as'
     &                 // ' a species causing its trimolecular loss.'
     &                 // ' This breaks linear assumptions used.'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               ENDIF
            ENDDO

            DO K = 1, N_LANHIN_LOSS
               IF ( VNAME( 1 ) == LHCAUSE( K, I ) ) THEN
                  WRITE( XMSG,* ) 'ERROR: ',
     &                 VNAME( 1 )( 1:LEN_NAME ), ' has'
     &                 // ' same name as a species causing its Langmuir'
     &                 // '-Hinshwood loss. This breaks linear assumptions used. '
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               ENDIF
            ENDDO



C..Set up indices that point to concentrations in CGRID.

            DO 20 J = 1, N_PROCESSES+1

               WNAME = VNAME( J )      ! note that reactant occupies VNAME(1)
               LEN_NAME = LEN_TRIM( WNAME )
               CALL UPCASE( WNAME )

               IF ( LEN_NAME > 0 ) THEN ! search gas species for index
                  N = INDEX1( WNAME, N_GC_SPC, GC_SPC )
                  MARKER = GC_STRT

                  IF ( N == 0 ) THEN  ! search aerosol them  non-reactive species for index

                     N = INDEX1( WNAME, N_AE_SPC, AE_SPC )
                     MARKER = AE_STRT
                     IF ( N == 0 ) THEN
                        N = INDEX1( WNAME, N_NR_SPC, NR_SPC )
                        MARKER = NR_STRT
                        IF ( N == 0 ) THEN
#ifdef verbose_deg
                           WRITE( LOGDEV,'(a)' ) TRIM( WNAME ), ' is not '
     &                          // 'in gas or nonreactive species table.'
     &                          // 'its loss processes not calculated '
#endif     
                           RXTANT_MAP( I ) = -1
                           CYCLE
                        ENDIF
                     ENDIF

                  ENDIF
         
                  N_REACT_FOUND   = N_REACT_FOUND + 1
               ELSE
                  VNAME( J ) = 'NONE'
                  CYCLE
               ENDIF

C..write degrade data table

               IF ( N_REACT_FOUND == 1 ) THEN
                  WRITE( LOGDEV,* ) 'TABLE on Degradation Simulated.'
                  WRITE( LOGDEV,* ) 'Note: Rates use units of cm, sec, and molecules.'
                  WRITE( LOGDEV,* )
                  WRITE( LOGDEV,1600 )
               ENDIF

C..set map values

               IF ( J < 2 ) THEN
                  DEGRADE_INDEX( N_REACT_FOUND ) = I
                  RXTANT_MAP ( I ) = N + MARKER - 1
               ELSE
                  PROD_MAP( J-1, I ) = N + MARKER - 1
               ENDIF

20          CONTINUE

C..cycle N_REACT LOOP

           IF( RXTANT_MAP( I ) .LT. 1 )CYCLE LOOP_REACT

C..check UNIMOLECULAR decay rates

            K = 0

            DO J = 1, N_UNI_LOSS

               IF ( UNIRATE( J, I ) < 0.0 ) THEN
                  WRITE( LOGDEV,* ) 'Species ', REACT( I ), ' has a'
     &                 // 'negative rate for unimolecular decay.'
     &                 // 'Check degrade module'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               ENDIF

               WRITE( LOGDEV,1100 ) VNAME( 1 ), RXTANT_MAP( I ),
     &              ' Unimolecular ',
     &              UNIRATE( J, I ) * (TEMP_298K*INV_T298K)**UNI_TEXP( J, I )
     &              * EXP( -UNI_ACT( J, I ) * INV_T298K ),
     &              VNAME( J+1 ), PROD_MAP( J, I )

            ENDDO

            K = K + N_UNI_LOSS

C..locating degradation causes in CGRID

            DO 40 J = 1, N_BI_LOSS

C..checking degradation rates

               IF ( BIRATE( J, I ) < 0.0 ) THEN
                  WRITE( LOGDEV,* ) 'Species ', REACT( I ), 'has a negative'
     &                 // ' rate for degradation by ', WNAME( 1:LEN_NAME ), '.'
     &                 // ' Check degrade module.'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               ENDIF

               WNAME = BICAUSE( J, I )

               CALL UPCASE( WNAME )

               LEN_NAME = LEN_TRIM( WNAME )

               IF ( LEN_NAME < 1 ) CYCLE
               MARKER = 0

               IF ( WNAME == 'DENSITY' .OR. WNAME == 'M' ) THEN      ! special case rate proportion to air density
                  RAD_MAP( J, I ) = 9999
               ENDIF

               IF ( WNAME == 'N2' ) THEN      ! special case rate proportion to molecular nitrogen
                  RAD_MAP( J, I ) = 9998
               ENDIF

               IF ( WNAME == 'O2' ) THEN      ! special case rate proportion to molecular oxygen
                  RAD_MAP( J, I ) = 9997
               ENDIF

               IF ( WNAME == 'CH4' ) THEN      ! special case rate proportion to methane
                  RAD_MAP( J, I ) = 9996
               ENDIF

               IF ( WNAME == 'H2' ) THEN      ! special case rate proportion to hydrogen
                  RAD_MAP( J, I ) = 9995
               ENDIF

               IF ( WNAME == 'H2O' ) THEN      ! special case rate proportion to water vapor
                  RAD_MAP( J, I ) = 9994
               ENDIF

               IF ( RAD_MAP( J, I ) < 0 ) THEN ! search model species
                  N = INDEX1( WNAME, N_GC_SPC, GC_SPC )   ! gas species for index
                  IF ( N == 0 ) THEN                      ! non-reactive species
                     N = INDEX1( WNAME, N_NR_SPC, NR_SPC )
                     IF ( N > 0 ) THEN
                        MARKER = NR_STRT
                     END IF
                  ELSE   
                     MARKER = GC_STRT
                  ENDIF 
                  RAD_MAP( J, I ) = N + MARKER - 1
               END IF   

               IF ( RAD_MAP( J, I ) > 0 ) THEN
                  WRITE( LOGDEV,1200 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                 ' Bimolecular ', WNAME, RAD_MAP( J, I ),
     &                 BIRATE( J, I ) * (TEMP_298K*INV_T298K)**BI_TEXP( J, I )
     &                 * EXP( -BI_ACT( J, I ) * INV_T298K ),
     &                 VNAME( J+K+1 ), PROD_MAP( J+K, I )
               ELSE
                   WRITE( LOGDEV,1200 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                 'NOT INCLUDED', WNAME, RAD_MAP( J, I ),
     &                  BIRATE( J,I ) * (TEMP_298K*INV_T298K)**BI_TEXP( J, I )
     &                  * EXP( -BI_ACT( J, I ) * INV_T298K ),
     &                  VNAME( J+K+1 ), PROD_MAP( J+K, I )
               END IF

40          CONTINUE

            K = K + N_BI_LOSS

            DO 50 J = 1, N_TRI_LOSS

C..checking degradation rates

               IF ( TRIRATE( J, I ) < 0.0D0 ) THEN
                  WRITE( LOGDEV,* ) 'Species ', REACT( I ), 'has a negative'
     &                 // ' rate for trimolecular degradation.'
     &                 // ' Check degrade module.'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               ENDIF

               ICOUNT = 0
               
               DO 60 L = 1, 2

                  WNAME = TRICAUSE( L, J, I )

                  CALL UPCASE( WNAME )

                  LEN_NAME = LEN_TRIM( WNAME )
    
                  IF ( LEN_NAME < 1 ) CYCLE

                  ICOUNT  = ICOUNT + 1
                  MARKER  = 0

                  IF ( WNAME == 'DENSITY' .OR. WNAME == 'M' ) THEN      ! special case rate proportion to air density
                     RAD2_MAP( L, J, I ) = 9999
                  ENDIF
              
                  IF ( WNAME == 'N2' ) THEN      ! special case rate proportion to molecular nitrogen
                     RAD2_MAP( L, J, I  ) = 9998
                  ENDIF
              
                  IF ( WNAME == 'O2' ) THEN      ! special case rate proportion to molecular oxygen
                     RAD2_MAP( L, J, I  ) = 9997
                  ENDIF
              
                  IF ( WNAME == 'CH4' ) THEN      ! special case rate proportion to methane
                     RAD2_MAP( L, J, I  ) = 9996
                  ENDIF
              
                  IF ( WNAME == 'H2' ) THEN      ! special case rate proportion to hydrogen
                     RAD2_MAP( L, J, I  ) = 9995
                  ENDIF
              
                  IF ( WNAME == 'H2O' ) THEN      ! special case rate proportion to water vapor
                     RAD2_MAP( L, J, I  ) = 9994
                  ENDIF

                  IF ( RAD2_MAP( L, J, I  ) < 0 ) THEN ! search model species
                     N = INDEX1( WNAME, N_GC_SPC, GC_SPC )   ! gas species for index
                     IF ( N == 0 ) THEN                      ! non-reactive species
                        N = INDEX1( WNAME, N_NR_SPC, NR_SPC )
                        IF ( N > 0 ) THEN
                           MARKER = NR_STRT
                        END IF
                    ELSE   
                       MARKER = GC_STRT
                    ENDIF 
                    RAD2_MAP( L, J, I ) = N + MARKER - 1
                 END IF   

60             CONTINUE

               IF ( RAD2_MAP( 1, J, I ) > 0 .AND. RAD2_MAP( 2, J, I ) > 0 ) THEN
                  WRITE( LOGDEV,1300 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                 ' Trimolecular ', TRICAUSE( 1, J, I ), RAD2_MAP( 1, J, I ),
     &                 TRICAUSE( 2, J, I ), RAD2_MAP( 2, J, I ),
     &                 TRIRATE( J, I ) * (TEMP_298K*INV_T298K)**TRI_TEXP( J, I )
     &                 * EXP( -TRI_ACT( J, I ) * INV_T298K ),
     &                 VNAME( J+K+1 ), PROD_MAP( J+K, I )
               ELSE IF ( ICOUNT .GT. 0 ) THEN
                  WRITE( LOGDEV,1300 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                 ' NOT INCLUDED ', TRICAUSE( 1, J, I ), RAD2_MAP( 1, J, I ),
     &                 TRICAUSE( 2, J, I ), RAD2_MAP( 2, J, I ),
     &                 TRIRATE( J, I ) * (TEMP_298K*INV_T298K)**TRI_TEXP( J, I )
     &                 * EXP( -TRI_ACT( J, I ) * INV_T298K ),
     &                 VNAME( J+K+1 ), PROD_MAP( J+K, I )
               ENDIF

50          CONTINUE

            LEN_NAME = LEN_TRIM( REACT( I ) )

            K = K + N_TRI_LOSS

            DO 70 J = 1, N_PHOTO_LOSS

               WNAME = PHOTO_NAME( J, I )

               CALL UPCASE( WNAME )

               N = INDEX1( WNAME, NPHOTAB, PHOTAB )

               IF ( LEN_TRIM( WNAME ) < 2 ) CYCLE

               IF ( N < 1 ) THEN
                  WRITE( LOGDEV,1350 ) 'Photolysis rate, ', TRIM( WNAME ), ' for ',
     &            TRIM( REACT( I ) ), ' is not JTABLE and is not included. '
                  CYCLE
               ENDIF

               PHOTO_MAP( J, I ) = N

               WRITE( LOGDEV,1400 ) VNAME( 1 ), RXTANT_MAP( I ),
     &              ' Photolysis ', PHOTAB( N ), PHOTO_MAP( J, I ), 'times', ' ',
     &              A_PHOTO( J, I ),
     &              VNAME( J+K+1 ), PROD_MAP( J+K, I )
!  adjust A_PHOT to account for units of calculated photolysis frequencies (min-1)
                    A_PHOTO( J, I ) = A_PHOTO( J, I )/60.0D0

70          CONTINUE

            K = K + N_PHOTO_LOSS

C..locating degradation causes in CGRID

            DO 80 J = 1, N_LANHIN_LOSS

C..checking degradation rates

               IF ( LHRATE( J, I ) < 0.0 ) THEN
                  WRITE( LOGDEV,* ) 'Species ', REACT( I ), 'has a negative'
     &                 // ' rate for degradation by ', WNAME( 1:LEN_NAME ), '.'
     &                 // ' Check degrade module.'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               ENDIF

               WNAME = LHCAUSE( J, I )

               CALL UPCASE( WNAME )

               LEN_NAME = LEN_TRIM( WNAME )

               IF ( LEN_NAME < 1 ) CYCLE

               MARKER = 0
               IF ( WNAME == 'DENSITY' .OR. WNAME == 'M' ) THEN      ! special case rate proportion to air density
                  RAD_MAP( J + N_BI_LOSS, I ) = 9999
               ENDIF

               IF ( WNAME == 'N2' ) THEN      ! special case rate proportion to molecular nitrogen
                  RAD_MAP( J + N_BI_LOSS, I ) = 9998
               ENDIF

               IF ( WNAME == 'O2' ) THEN      ! special case rate proportion to molecular oxygen
                  RAD_MAP( J + N_BI_LOSS, I ) = 9997
               ENDIF

               IF ( WNAME == 'CH4' ) THEN      ! special case rate proportion to methane
                  RAD_MAP( J + N_BI_LOSS, I ) = 9996
               ENDIF

               IF ( WNAME == 'H2' ) THEN      ! special case rate proportion to hydrogen
                  RAD_MAP( J + N_BI_LOSS, I ) = 9995
               ENDIF

               IF ( WNAME == 'H2O' ) THEN      ! special case rate proportion to water vapor
                  RAD_MAP( J + N_BI_LOSS, I ) = 9994
               ENDIF

               IF ( RAD_MAP( J + N_BI_LOSS, I ) < 0 ) THEN ! search model species
                  N = INDEX1( WNAME, N_GC_SPC, GC_SPC )   ! gas species for index
                  IF ( N == 0 ) THEN                      ! non-reactive species
                     N = INDEX1( WNAME, N_NR_SPC, NR_SPC )
                     IF ( N > 0 ) THEN
                        MARKER = NR_STRT
                     END IF
                  ELSE   
                     MARKER = GC_STRT
                  ENDIF 
                  RAD_MAP( J + N_BI_LOSS, I ) = N + MARKER - 1
               END IF   

               IF ( RAD_MAP( J + N_BI_LOSS, I ) > 0 ) THEN
                  WRITE( LOGDEV,1200 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                 ' Langm-Hinsh ', WNAME, RAD_MAP( J + N_BI_LOSS, I  ),
     &                 LHRATE( J, I ) * LH_EQU( J, I ),
     &                 VNAME( J+K+1 ), PROD_MAP( J+K, I )
               ELSE
                  WRITE( LOGDEV,1200 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                 'NOT INCLUDED', WNAME, RAD_MAP( J + N_BI_LOSS, I ),
     &                 LHRATE( J, I ) * LH_EQU( J, I ),
     &                 VNAME( J+K+1 ), PROD_MAP( J+K, I )
               ENDIF

80          CONTINUE

         END DO LOOP_REACT

         IF( N_REACT_FOUND .LT. 1 )RETURN

         WRITE( LOGDEV,'(A)' ) 'Note: If INDEX of CAUSE A OR B equals -1, the '
     &        // 'process is dropped from degradation '
     &        // 'calculation.'

         WRITE( LOGDEV,* ) BLANK

#ifdef isam         
         CALL SA_DEGRADE_INIT
#endif

1000     FORMAT(A20,1X,A5,1X,A20,1X,2(A20,1X,A5,1X),A12,1X,A20,1X,A5)
1100     FORMAT(A20,1X,I5,1X,A20,1X,2(21X,6X),ES12.4,1X,A20,1X,I5)
1200     FORMAT(A20,1X,I5,1X,A20,1X,A20,1X,I5,1X,21X,6X,ES12.4,1X,A20,1X,I5)
1300     FORMAT(A20,1X,I5,1X,A20,1X,2(A20,1X,I5,1X),ES12.4,1X,A20,1X,I5)
1350     FORMAT(A,A,A,A16,A)
1400     FORMAT(A20,1X,I5,1X,A20,1X,(A20,1X,I5,1X),(A20,1X,A5,1X),ES12.4,1X,A20,1X,I5)
1600     FORMAT('       DEGRADED      ',' Index',
     &              '       Process      ','        Cause A      ',
     &              ' Index', '       Cause B      ',' Index',
     &              '    Rate at 298K    ', '       Product      ',
     &              ' Index')

         RETURN

         END SUBROUTINE DEGRADE_MAP

#ifdef isam

         SUBROUTINE SA_DEGRADE_INIT

           USE SA_DEFN
C Initialize arrays and maps that relate ISAM species to degaded species
C
C         Called by DEGRADE_MAP

           IMPLICIT NONE

C..Includes: None
 
           CHARACTER( 16 ), PARAMETER :: PNAME = 'SA_DEGRADE_INIT'     ! Program name
 
           INTEGER :: I, J, RXN, IP, IL 
           INTEGER :: IOSTAT
           INTEGER :: C, L, R, S   ! Loop indices
           INTEGER :: SPC          ! array index
           INTEGER :: IOS


           CHARACTER( 132 ) :: MSG           ! Message text
! temporary arrays to set maps between isam to chemistry species
           INTEGER, ALLOCATABLE :: ISAM_SPC_IDX ( : )
           INTEGER, ALLOCATABLE :: ISAM_2_DEGRAD( : )
           INTEGER, ALLOCATABLE :: REACT_INDEX  ( : )
           LOGICAL, ALLOCATABLE :: NOT_DEGRADED ( : )

           CHARACTER(16), ALLOCATABLE :: FIND_IN_ISAM( : )

         
C=======================================================

                   
           ALLOCATE( ISAM_2_DEGRAD( NSPC_SA + 1 ) )
           ALLOCATE( ISAM_SPC_IDX( NSPC_SA + 1 ) )
           ALLOCATE( REACT_INDEX( NSPC_SA + 1 ) )
           ALLOCATE( NOT_DEGRADED( NSPC_SA + 1 ) )
           ALLOCATE( FIND_IN_ISAM( NSPC_SA + 1 ) )

! Identify species index in ISAM array
           ISAM_SPC_IDX  = 0
           ISAM_2_DEGRAD = 0
           REACT_INDEX   = 0
           NOT_DEGRADED = .TRUE.
           FIND_IN_ISAM = ' '
           
           DO S = 1, NSPC_SA
              FIND_IN_ISAM( S ) = ISAM_SPEC( S,OTHRTAG )
              ISAM_SPC_IDX( S ) = S
           END DO

! find tagged species in REACT array 
           SPC = NSPC_SA
           ISAM_DEGRADED_SPC = 0
           DO S = 1, NSPC_SA
              R  = INDEX1( TRIM(FIND_IN_ISAM( S )), N_REACT, REACT )
              IF ( R .LE. 0 ) THEN
                 MSG = 'ISAM SPECIES: ' 
     &              // TRIM( FIND_IN_ISAM( S ) ) 
     &              // ' not found in  REACT array  '
!                CALL M3WARN( PNAME, 0, 0, MSG )
                 CYCLE
              END IF
              IF( RXTANT_MAP( R ) .LT. 1 )CYCLE
              ISAM_DEGRADED_SPC  = ISAM_DEGRADED_SPC + 1           
              REACT_INDEX  ( S ) = R
              ISAM_2_DEGRAD( S ) = RXTANT_MAP( R )
              NOT_DEGRADED ( S ) = .FALSE.
           END DO
           
           IF( ANY(  .NOT. NOT_DEGRADED ) )THEN
C..Save pointer for isam species found in chemistry species
               ALLOCATE( CELL_ISAM( NTAG_SA,ISAM_DEGRADED_SPC ) )
               CELL_ISAM = 0.0D0
               ALLOCATE( ISAM_TO_DEGRADED( ISAM_DEGRADED_SPC ) )
               ALLOCATE( ISAM_DEGRADE_MAP( ISAM_DEGRADED_SPC ) )
               ALLOCATE( ISAM_TO_REACTANT( ISAM_DEGRADED_SPC ) )
               ALLOCATE( ISAM_DEGRADED   ( ISAM_DEGRADED_SPC ) )
               ISAM_TO_DEGRADED = -1
               ISAM_DEGRADE_MAP = -1
               ISAM_DEGRADED    = "XundefinedX"
               
               WRITE(LOGDEV,'(/A)')'Below isam species have a linear decay based on photochemistry '
               WRITE(LOGDEV,'("IDX, ISAM_SPC, IDX, DEGRADE_SPC  ")')
               L = 0 
               DO S = 1, NSPC_SA
                   IF ( .NOT. NOT_DEGRADED( S ) ) THEN
                       L = L + 1
                       C = ISAM_SPC_IDX ( S )
                       R = ISAM_2_DEGRAD( S )
                       SPC = REACT_INDEX( S )
                       ISAM_DEGRADE_MAP( L ) = ISAM_SPC_IDX( S )
                       ISAM_TO_DEGRADED( L ) = ISAM_2_DEGRAD( S )
                       ISAM_TO_REACTANT( L ) = REACT_INDEX( S )     
                       ISAM_DEGRADED   ( L ) = REACT( SPC )
                       WRITE(LOGDEV,'(I3,1X,A16,1x,I3,1X,A16)') 
     &                   C, FIND_IN_ISAM( S ), R, REACT( SPC )
                   END IF
               END DO
               IF( L .NE. ISAM_DEGRADED_SPC )THEN
                   MSG = 'ERROR mapping isam to chemistry species: inconsistent number found'
                   CALL M3EXIT ( PNAME, 0, 0, MSG, XSTAT1 )
               END IF
           ELSE
               MSG = 'NO ISAM species are degraded '
               CALL M3WARN ( PNAME, 0, 0, MSG )
           END IF
           L = 0
           DO S = 1, NSPC_SA
               IF( NOT_DEGRADED( S ) )THEN
                   C = ISAM_SPC_IDX( S )
                   IF( C .LE. 0 )CYCLE
                   L = L + 1
                   IF( L .LT. 2 )THEN
                       WRITE(LOGDEV,'(/A)')'Below isam species DO NOT have a linear decay based on photochemistry'
                       WRITE(LOGDEV,'("SPC     ISAM_SPC")')
                   END IF    
                       WRITE(LOGDEV,'(I3,1X,A16,1x,I3,A16)') C, FIND_IN_ISAM( S )
                   END IF
           END DO

           DEALLOCATE( ISAM_2_DEGRAD )
           DEALLOCATE( ISAM_SPC_IDX )
           DEALLOCATE( NOT_DEGRADED )
        
        END SUBROUTINE SA_DEGRADE_INIT
        SUBROUTINE SA_DEGRADE_EXTRACT( COL, ROW, LAY, DENS )
                
          USE SA_DEFN  

          IMPLICIT NONE

!..Arguments:
         INTEGER,   INTENT( IN ) ::  COL        ! cell column index
         INTEGER,   INTENT( IN ) ::  ROW        ! cell row index 
         INTEGER,   INTENT( IN ) ::  LAY        ! cell layer index      
         REAL,      INTENT( IN ) ::  DENS       ! air mass density, kg/m3

C..Includes: None

!..Local:
         CHARACTER( 32 ), PARAMETER :: PNAME = 'SA_DEGRAGE_EXTRACT'     ! Program name

         REAL( 8 ), PARAMETER  :: ONE       = 1.0D0
         REAL( 8 ), PARAMETER  :: ZERO      = 0.0D0

         REAL      :: FACTOR2
         REAL( 8 ) :: INV_DENS       ! one over air mass density, m3/kg

         INTEGER :: JSPC, KTAG
         INTEGER :: SPC, S          ! array index
         
          IF( ISAM_DEGRADED_SPC .LT. 1 )RETURN
          
          INV_DENS = REAL( ONE/DENS, 8 )
          
          DO JSPC = 1, ISAM_DEGRADED_SPC
             S       = ISAM_TO_DEGRADED( JSPC )
             SPC     = ISAM_DEGRADE_MAP( JSPC )
             LOAD_SOLD: DO KTAG = 1, NTAG_SA
                 FACTOR2 = ISAM( COL,ROW,LAY,SPC,KTAG )
                 CELL_ISAM( KTAG, JSPC ) = REAL( FACTOR2,8 )
             END DO LOAD_SOLD ! ktag loop
          END DO ! loop jspc

        END SUBROUTINE SA_DEGRADE_EXTRACT
        SUBROUTINE SA_DEGRADE_UPLOAD( COL, ROW, LAY, DENS )
                
            USE SA_DEFN  
            
            IMPLICIT NONE

!..Arguments:
            INTEGER,   INTENT( IN ) ::  COL        ! cell column index
            INTEGER,   INTENT( IN ) ::  ROW        ! cell row index 
            INTEGER,   INTENT( IN ) ::  LAY        ! cell layer index      
            REAL,      INTENT( IN ) ::  DENS       ! air mass density, kg/m3

C..Includes: None

!..Local:
            CHARACTER( 32 ), PARAMETER :: PNAME = 'SA_DEGRAGE_UPLOAD'     ! Program name
            
            REAL( 8 ), PARAMETER  :: ONE       = 1.0D0
            REAL( 8 ), PARAMETER  :: ZERO      = 0.0D0
            
            REAL      :: FACTOR2
            REAL( 8 ) :: TOTAL, FACTOR1, FACTOR3, FACTOR
!            REAL( 8 ) :: INV_DENS       ! one over air mass density, m3/kg
            
            INTEGER :: JSPC, KTAG, I_RAD, I_RXT
            INTEGER :: S, SPC          ! array index
            
            IF( ISAM_DEGRADED_SPC .LT. 1 )RETURN
             
#ifdef verbose_isam
      IF( DEG_LAY .EQ. 1 .AND. DEG_ROW .EQ. 1 .AND. DEG_COL .EQ. 1 )THEN
         WRITE(LOGDEV,'(6x,A)')'SA_DEGRADE_UPLOAD'
         WRITE(LOGDEV,'(//,6X,A16,(1X,A12),1X,A18,2(1X,A18))')'isam_degraded', 'factor', 'react',
     &   'INIT_CONC','FINAL_CONC'
      END IF
#endif
             DO JSPC = 1, ISAM_DEGRADED_SPC
                S       = ISAM_TO_DEGRADED( JSPC )
                SPC     = ISAM_DEGRADE_MAP( JSPC )
#ifdef verbose_isam
               IF( DEG_LAY .EQ. 1 .AND. DEG_ROW .EQ. 1 .AND. DEG_COL .EQ. 1)THEN 
                    I_RXT = ISAM_TO_DEGRADED( JSPC )
                    I_RAD = ISAM_TO_REACTANT( JSPC )
                    FACTOR2 = SUM(ISAM( COL,ROW,LAY,SPC,1:NTAG_SA ))
                    FACTOR3 = SUM(CELL_ISAM( 1:NTAG_SA,JSPC ))
                    FACTOR  = 1.0 + (FACTOR3-FACTOR2)/MAX(FACTOR2,1.0E-30)
                  WRITE(LOGDEV,'(6X,A16,1X,ES18.10,1X,A16,2(1X,ES18.10))')ISAM_DEGRADED( JSPC ), FACTOR, REACT( I_RAD ),
     &            FACTOR2, FACTOR3
               END IF
#endif               
                LOAD_ISAM: DO KTAG = 1, NTAG_SA
                    FACTOR1 =  CELL_ISAM( KTAG,JSPC )
                    ISAM( COL,ROW,LAY,SPC,KTAG ) = REAL( FACTOR1 )
                END DO LOAD_ISAM ! ktag loop
             END DO ! loop jspc

          END SUBROUTINE SA_DEGRADE_UPLOAD
#endif
                
      END MODULE DEGRADE_SETUP_TOX

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WR_INIT ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Create the IO/API netCDF header and open the output CONC file

C Revision history:
C   Dec 15 D.Wong: Created for writing initial data to CONC file
C   Apr 16 D.Wong: Added INTEN attribute for arguments JDATE, JTIME, and TSTEP
C                  so they match with the interface block in INITSCEN.F
C   Feb 19 D.Wong: removed all MY_N clauses
C   June 19 F. Sidi: Replaced BADVAL3 for TA, RH, & PRES with MET DATA
C   Sept 19 F. Sidi: Replaced L_CONC_WVEL(depreciated) with W_VEL 
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE WVEL_DEFN             ! derived vertical velocity component
      USE STD_CONC              ! standard CONC
      USE UTILIO_DEFN
#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif
      USE CENTRALIZED_IO_MODULE
      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID    ! file name parameters
      
C Arguments:

      REAL, POINTER :: CGRID( :,:,:,: )  ! for initial CONC
      INTEGER, INTENT( IN ) :: JDATE     ! starting date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME     ! starting time (HHMMSS)
      INTEGER, INTENT( IN ) :: TSTEP     ! output timestep (HHMMSS)

C Local Variables:

      REAL, ALLOCATABLE :: DBUFF( :,:,: ), DBUFFP( :, :, :),
     &                     DBUFFTA( :, :, :), DBUFFQV(:, :, :)

      INTEGER      ALLOCSTAT

      CHARACTER( 16 ) :: PNAME = 'OPCONC'
      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER( 28 ) :: SSTR = ' species saved to CONC file:'

C environment variable for no. of layers from bottom to save on CONC file
      CHARACTER( 16 ) :: NLAYS_CONC = 'NLAYS_CONC'

C  environment variable description
      CHARACTER( 80 ) :: VARDESC

      INTEGER      K, KD, L, SPC, V   ! loop counters
      INTEGER      STRT, FINI         ! loop counters
      INTEGER      INDX

      LOGICAL, EXTERNAL :: FLUSH3

C-----------------------------------------------------------------------

#ifndef mpas
#ifdef parallel_io
      CALL SUBST_BARRIER
      IF ( .NOT. IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( CTM_CONC_1, FSREAD3, PNAME ) ) THEN
            XMSG = 'Could not open ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF
#endif

C write the initial concentrations as step 0 on the conc file
C (inital data assumed to be in correct output units)

      ALLOCATE ( DBUFF( NCOLS,NROWS,C_NLAYS ), DBUFFP( NCOLS, NROWS,
     &           C_NLAYS), DBUFFTA( NCOLS, NROWS, C_NLAYS), 
     &           DBUFFQV( NCOLS, NROWS, C_NLAYS), STAT = ALLOCSTAT )
      IF ( ALLOCSTAT .NE. 0 ) THEN
         XMSG = 'Failure allocating DBUFF(s)'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF

      WRITE( LOGDEV,* ) ' '

      V = 0

      IF ( N_C_GC_SPC .NE. 0 ) WRITE( LOGDEV,'( /5X, "Gas Chem", A )' ) SSTR

      DO SPC = 1, N_C_GC_SPC
         V = V + 1
         INDX = CONC_MAP( V )

         DBUFF = CGRID( 1:NCOLS,1:NROWS,CONC_BLEV:CONC_ELEV,INDX )

         IF ( .NOT. WRITE3( CTM_CONC_1, C_GC_SPC( SPC ),
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write ' //
     &             TRIM( C_GC_SPC( SPC ) ) //
     &             ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV,'( 5X, I4, " (", I3, ") ", A )' )
     &                SPC, V, TRIM( C_GC_SPC( SPC ) )

      END DO

      IF ( N_C_AE_SPC .NE. 0 ) WRITE( LOGDEV,'( /5X, "Aerosol", A )' ) SSTR

      DO SPC = 1, N_C_AE_SPC
         V = V + 1
         INDX = CONC_MAP( V )

         DBUFF = CGRID( 1:NCOLS,1:NROWS,CONC_BLEV:CONC_ELEV,INDX )

         IF ( .NOT. WRITE3( CTM_CONC_1, C_AE_SPC( SPC ),
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write ' //
     &             TRIM( C_AE_SPC( SPC ) ) //
     &             ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV,'( 5X, I4, " (", I3, ") ", A )' )
     &                SPC, V, TRIM( C_AE_SPC( SPC ) )

      END DO

      IF ( N_C_NR_SPC .NE. 0 ) WRITE( LOGDEV,'( /5X, "Non-reactive", A )' ) SSTR

      DO SPC = 1, N_C_NR_SPC
         V = V + 1
         INDX = CONC_MAP( V )

         DBUFF = CGRID( 1:NCOLS,1:NROWS,CONC_BLEV:CONC_ELEV,INDX )

         IF ( .NOT. WRITE3( CTM_CONC_1, C_NR_SPC( SPC ),
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write ' //
     &             TRIM( C_NR_SPC( SPC ) ) //
     &             ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV,'( 5X, I4, " (", I3, ") ", A )' )
     &                SPC, V, TRIM( C_NR_SPC( SPC ) )
      END DO

      IF ( N_C_TR_SPC .NE. 0 ) WRITE( LOGDEV,'( /5X, "Inert tracer", A )' ) SSTR

      DO SPC = 1, N_C_TR_SPC
         V = V + 1
         INDX = CONC_MAP( V )

         DBUFF = CGRID( 1:NCOLS,1:NROWS,CONC_BLEV:CONC_ELEV,INDX )

         IF ( .NOT. WRITE3( CTM_CONC_1, C_TR_SPC( SPC ),
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write ' //
     &             TRIM( C_TR_SPC( SPC ) ) //
     &             ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV,'( 5X, I4, " (", I3, ") ", A )' )
     &                SPC, V, TRIM( C_TR_SPC( SPC ) )

      END DO
 
      IF ( W_VEL ) THEN   ! Vertical Velocity Calculated from Advection

         DBUFF = BADVAL3

         IF ( .NOT. WRITE3( CTM_CONC_1, 'W_VEL',
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write Vertical Velocity (W_VEL) to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF
 
       IF ( L_CONC_TA ) THEN   ! for Temperature
      
      CALL interpolate_var ('TA', JDATE, JTIME, DBUFFTA)
         
         IF ( .NOT. WRITE3( CTM_CONC_1, 'TA',
     &                      JDATE, JTIME, DBUFFTA ) ) THEN
            XMSG = 'Could not write Temperature to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF

      IF ( L_CONC_PRES ) THEN   ! for Pressure
      
      CALL interpolate_var ('PRES', JDATE, JTIME, DBUFFP)
      
         IF ( .NOT. WRITE3( CTM_CONC_1, 'PRES',
     &                      JDATE, JTIME, DBUFFP ) ) THEN
            XMSG = 'Could not write Pressure to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF


      IF ( L_CONC_RH ) THEN   ! for Relative Humidity

      CALL interpolate_var ('QV', JDATE, JTIME, DBUFFQV)

         DBUFF = DBUFFQV * DBUFFP / ( DBUFFQV + 0.622015 ) /
     &                 ( 610.94 * EXP( 17.625 * ( DBUFFTA - 273.15 ) / 
     &                                 ( DBUFFTA - 273.15 + 243.04 ) ) )
         DBUFF = MIN( 0.9999, MAX( 0.001, DBUFF) )

         IF ( .NOT. WRITE3( CTM_CONC_1, 'RH',
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write Relative Humidity to ' // CTM_CONC_1

            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF


      DEALLOCATE ( DBUFF, DBUFFP, DBUFFTA, DBUFFQV)

      WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &  'Timestep written to', CTM_CONC_1,
     &  'for date and time', JDATE, JTIME
      WRITE( LOGDEV, '(  5X,  A, 1X, I8, ":", I6.6 )' )
     &  'from timestep on initial data files for date and time',
     &   JDATE, JTIME
#endif

      RETURN
      END SUBROUTINE WR_INIT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE INITSCEN ( CGRID, TSTEP)

C-----------------------------------------------------------------------
C Function:
C   Initialize simulation time period and time stepping constants for
C   core model driver
C   Environment variable can reference a previous CONC file to use as
C   initial data.
C   Write initial conc data as step "0" on output conc file
 
C Preconditions:
 
C Subroutines and functions called:
C   M3EXIT, OPEN3, CLOSE3, DESC3, TIME2SEC, HHMMSS
 
C Revision history:
C   prototype 6/92 by CJC for "concept model"
C   revised   2/93 by CJC for initial M3 Prototype Alpha
C   revised   6/14/94 by Dongming Hwang for configuration management prototype
C   revised   8/30/94 by Dongming Hwang: If CTM_CONC_1 file doesn't exist,
C             use header info from CHEMINIT3D file.
 
C Interim Version ... (Jeff)

C   revised  6/12/97 by Jerry Gipson: Get ICs by species name, by surrogate
C            name, or zero
C   Jeff - Aug 97 - fixed problems, cleaned up
C   Jeff - Dec 97 - add CMIN
C   Jeff - Dec 97 - put in aerosol sulfate inititalization
C   Jeff - Feb 98 - close init cond files after reading
C   2 October, 1998 by Al Bourgeois at LM: parallel implementation
C   revised 10/7/99 by Shawn Roselle: added surface area species to
C            aerosol species types
C   Jeff - Dec 00 - check if append, split out opconc and load_cgrid
C                 - move CGRID_MAP into f90 module
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; assumed shape arrays
C   17 Mar 03 D.Wong: move barrier to avoid race conditions
C   28 Aug 03 J.Young: following Zion Wang at CERT, only pe 0 closes
C   30 May 05 J.Young: add call to load RHOJ into CGRID
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   Aug 15 D.Wong:    Added two new subroutine calls to open ACONC and WDEP files
C   Dec 15 D.Wong: new routine wr_init to write the initial data to the CONC file
C   1 Feb 19 David Wong: Implemented centralized I/O approach, removed
C                        all MY_N clauses
C   29 Oct 18 L.Zhou, S.Napelenok: isam implementation
C   26 Nov 19 S. Napelenok: DDM3D implementation for CMAQ v5.3.1
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE HGRD_DEFN             ! horizontal domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      USE ELMO_DATA, ONLY : L_ELMO, ELMO_NSTEP 
      USE ELMO_INIT_DEFN, ONLY : OPEN_ELMO
#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
      USE VERTEXT_MODULE
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif

#ifdef isam
      USE SA_DEFN
#endif

#ifdef sens
      USE DDM3D_DEFN
      USE VGRD_DEFN, ONLY: NLAYS
#endif

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

!     REAL      :: CGRID( :,:,:,: )  ! for initial CONC
      REAL, POINTER :: CGRID( :,:,:,: )  ! for initial CONC
      INTEGER      TSTEP( 3 )   ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency
!     INTEGER      NSTEPS       ! run duration, as number of output time steps

C Parameters:

      REAL, PARAMETER :: CMIN = 1.0E-30

C Local Variables
      CHARACTER( 16 ) :: PNAME = 'INITSCEN'
      CHARACTER( 16 ) :: FNAME
      CHARACTER( 96 ) :: MSG = ' '

      INTEGER      STEPSECS          ! seconds per time step
      INTEGER      TOTSECS           ! run duration seconds

#ifdef Verbose3
      real sumcg
      integer c, r, l, s, v
#endif

#ifdef sens
      integer COL,ROW,LAY,SPC
#endif

      INTERFACE
         SUBROUTINE LOAD_CGRID ( FNAME, SPC_CAT, CMIN, CGRID )
            CHARACTER( 16 ), INTENT( IN ) :: FNAME
            CHARACTER(  2 ), INTENT( IN ) :: SPC_CAT
            REAL,    INTENT( IN )         :: CMIN
            REAL, POINTER                 :: CGRID( :,:,:,: )
         END SUBROUTINE LOAD_CGRID
         SUBROUTINE WR_INIT ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER                 :: CGRID(:,:,:,:)
            INTEGER, INTENT( IN )         :: JDATE
            INTEGER, INTENT( IN )         :: JTIME
            INTEGER, INTENT( IN )         :: TSTEP
         END SUBROUTINE WR_INIT
#ifdef isam
         SUBROUTINE SA_ARRAY_INIT ( CGRID )
            IMPLICIT NONE
            REAL, POINTER                 :: CGRID( :,:,:,: )
         END SUBROUTINE SA_ARRAY_INIT
         SUBROUTINE OP_SA ( JDATE, JTIME, TSTEP, NSTEPS, FNAME )
            IMPLICIT NONE
            INTEGER :: JDATE, JTIME
            INTEGER :: TSTEP(2)
            INTEGER :: NSTEPS
            CHARACTER( 16 ) :: FNAME
         END SUBROUTINE OP_SA
         SUBROUTINE SA_OPWDDEP ( SADEPFILE, JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            CHARACTER( 16 ) :: SADEPFILE ! Dry or wet dep file for tags
            INTEGER         :: JDATE, JTIME, TSTEP
         END SUBROUTINE SA_OPWDDEP
#endif
#ifdef sens
         SUBROUTINE LOAD_SENGRID ( FNAME, STDATE, STTIME, SPC_CAT )
            IMPLICIT NONE
            CHARACTER( 16 ), INTENT( IN ) :: FNAME
            INTEGER, INTENT( IN )         :: STDATE, STTIME
            CHARACTER(  2 ), INTENT( IN ) :: SPC_CAT
         END SUBROUTINE LOAD_SENGRID
#endif
      END INTERFACE

C-----------------------------------------------------------------------

      TSTEP( 1 ) = LOCAL_TSTEP 

#ifdef isam
      IF ( MYPE .EQ. 0 ) THEN
         WRITE( LOGDEV,* ) 'Entered INITSCEN...'
         WRITE( LOGDEV,* ) 'NSPC_SA, NTAG_SA:', NSPC_SA, NTAG_SA
      END IF
#endif

C Initialize the CGRID array
      CGRID = CMIN

C Load CGRID
      IF ( N_GC_SPC .GT. 0 ) THEN
         FNAME = INIT_CONC_1
         CALL LOAD_CGRID ( FNAME, 'GC', CMIN, CGRID )
#ifdef Verbose3
         write( logdev,'(/"@@@c ", i8, i7.6)') stdate, sttime
         l = 1
         do v = gc_strt, gc_fini
            s = v + 1 - gc_strt
            sumcg = 0.0
            do r = 1, nrows
               do c = 1, ncols
                  sumcg = sumcg + cgrid( c,r,l,v )
               end do
            end do
            write( logdev,'("@@@c ", a, i5, g16.6)') gc_spc( s ), s, sumcg
         end do
#endif
      END IF  ! N_GC_SPC > 0

C load rhoj
      FNAME = MET_CRO_3D
      CALL LOAD_CGRID ( FNAME, 'RJ', CMIN, CGRID )

C Get aerosols IC's
      IF ( N_AE_SPC .GT. 0 ) THEN
         FNAME = INIT_CONC_1
         CALL LOAD_CGRID ( FNAME, 'AE', CMIN, CGRID )
      END IF  ! N_AE_SPC > 0

C Get non-reactives IC's
      IF ( N_NR_SPC .GT. 0 ) THEN
         FNAME = INIT_CONC_1
         CALL LOAD_CGRID ( FNAME, 'NR', CMIN, CGRID )
      END IF  ! N_NR_SPC > 0

C Get tracer IC's
      IF ( N_TR_SPC .GT. 0 ) THEN
         FNAME = INIT_CONC_1
         CALL LOAD_CGRID ( FNAME, 'TR', CMIN, CGRID )
      END IF  ! N_TR_SPC > 0

C Test opening existing conc file for update
      CALL LOG_HEADING( LOGDEV, "Open/Create Concentration File" )

C *** Open the aerosol parameters file (diameters and standard deviations).
      !IF ( L_ELMO .AND. IO_PE_INCLUSIVE ) THEN
      !     CALL OPEN_ELMO ( STDATE, STTIME, TSTEP( 1 ) )
      !     ELMO_NSTEP = 0.0
      !END IF

#ifndef mpas
      IF ( .NOT. OPEN3( CTM_CONC_1, FSRDWR3, PNAME ) ) THEN

#ifndef twoway
         BACKSPACE( LOGDEV )
#endif
         MSG = 'Could not open ' // TRIM( CTM_CONC_1 ) // ' for update - '
     &        // 'try to open new'
         CALL M3MESG( MSG )
         ! Open the file new
         CALL SUBST_BARRIER
         CALL OPCONC ( STDATE, STTIME, TSTEP( 1 ) )
#ifdef parallel
         CALL OPVEXT ( STDATE, STTIME, TSTEP( 1 ) )
#endif
      END IF

      CALL WR_INIT ( CGRID, STDATE, STTIME, TSTEP( 1 ) )
      
      CALL LOG_HEADING( LOGDEV, "Open/Create Average Concentration File" )
      CALL OPACONC ( STDATE, STTIME, TSTEP( 1 ) )
      
      CALL LOG_HEADING( LOGDEV, "Open/Create Wet Deposition File" )
      CALL OPWDEP  ( STDATE, STTIME, TSTEP( 1 ) )

#ifdef sens
      CALL OPASENS( STDATE, STTIME, TSTEP( 1 ) )
#endif

#ifdef isam
C Initialize ISAM array
      CALL SA_ARRAY_INIT ( CGRID )

C Open SA_CONC_1 and SA_CGRID_1
      CALL OP_SA ( STDATE, STTIME, TSTEP, 1, SA_CONC_1 )
      IF ( MYPE .EQ. 0 ) CALL SA_OPWDDEP ( SA_WD_1, STDATE, STTIME, TSTEP( 1 ) )
#endif

#ifdef sens
      IF ( RST ) THEN ! Load SENGRID from a file

         IF ( N_GC_SPC .GT. 0 ) THEN
            FNAME = INIT_SENS_1
            CALL LOAD_SENGRID ( FNAME, STDATE, STTIME, 'GC' )
         END IF  ! N_GC_SPC > 0

         FNAME = MET_CRO_3D
         CALL LOAD_SENGRID ( FNAME, STDATE, STTIME, 'RJ' )

         IF ( N_AE_SPC .GT. 0 ) THEN
            FNAME = INIT_SENS_1
            CALL LOAD_SENGRID ( FNAME, STDATE, STTIME, 'AE')
         END IF  ! N_AE_SPC > 0

         IF ( N_NR_SPC .GT. 0 ) THEN
            FNAME = INIT_SENS_1
            CALL LOAD_SENGRID ( FNAME, STDATE, STTIME, 'NR' )
         END IF  ! N_NR_SPC > 0

         IF ( N_TR_SPC .GT. 0 ) THEN
            FNAME = INIT_SENS_1
            CALL LOAD_SENGRID ( FNAME, STDATE, STTIME, 'TR' )
         END IF  ! N_TR_SPC > 0

      ELSE  ! Set to initial conditions or 0.0

         DO NP = 1, NPMAX
            IF ( IPT( NP ) .EQ. 1 ) THEN
               DO SPC = 1, NSPCSD
                  DO LAY = 1, NLAYS
                     DO ROW = 1, NROWS
                        DO COL = 1, NCOLS
                           SENGRID( COL, ROW, LAY, NP, SPC) =
     &                               CGRID( COL, ROW, LAY, SPC )
     &                             * REAL( IPARM( NP, SPC ) )
     &                             * IREGION( COL, ROW, LAY, NP )
                        END DO
                     END DO
                  END DO
               END DO
            ELSE
               DO SPC = 1, NSPCSD
                  DO LAY = 1, NLAYS
                     DO ROW = 1, NROWS
                        DO COL = 1, NCOLS
                           SENGRID( COL, ROW, LAY, NP, SPC) = 0.0
                        END DO
                     END DO
                  END DO
               END DO
            END IF
         END DO

      END IF
#endif

      CALL SUBST_BARRIER

#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PHOT ( CGRID, JDATE, JTIME, DTSTEP )

!-----------------------------------------------------------------------
!
! Function:  Calculates the photolysis rate constant to be used by the
!     chemical solver.  It calculates these rates at each gridcell using
!     codes adapted from JPROC.  Cloud correction now called within the
!     loops over MY-ROW & MY_COLS
!
! Preconditions: HGRD_INIT() called from PAR_INIT, which is called from
!     DRIVER
!
! Subroutines/Functions called: M3EXIT, SUBHFILE, CGRID_MAP,
!     OPPHOT, LOAD_CSQY_DATA, LOAD_OPTICS_DATA, INITIALIZE_ALBEDO, 
!     GET_PHOT_MET, UPDATE_SUN, GET_ALBEDO, GET_DROPLET_OPTICS, 
!     GET_ICE_OPTICS, GET_AGGREGATE_OPTICS, CLEAR_HYDROMETEOR_OPTICS, 
!     GET_AERO_DATA, O3TOTCOL, and NEW_OPTICS
!
! Revision History.
!     Started 10/08/2004 with existing PHOT and JPROC coded by
!         Dr. Francis S. Binkowski
!         Carolina Environmental Program
!         University of North Carolina at Chapel Hill
!         email: frank_binkowski@unc.edu
!     August 2005, Sarav Arunachalam, CEP, UNC-CH
!       - Minor revisions while integrating with CMAQ
!       - Error check for NPHOTS added (this version works only for SAPRC-99)
!       - Added creation of new file CTM_RJ_1 to write out RJ values
!         for O3 and NO2 (both clear sky and cloud effects), and
!         ETOT_SFC, TAU_AERO, TAU_TOT and TAUO3_TOP values for 7 wavelengths
!     June 2007, David Wong
!       -- inline with CMAQ
!       - declare RJ as assumed shape array to match with the caller routine
!       - allow PE 0 only to open the output file
!       - output species: NO2_CLOUD and O3_CLOUD with AMISS value when all cells
!         are dark and JTIME_CHK = 0
!       - output species: NO2_CLOUD and O3_CLOUD with AMISS value when CLDATT is
!         0 and JTIME_CHK = 0
!     December 2007, Francis Binkowski
!         code has been modified to call the new on-line version that
!         has the cloud effects built in.  new photolysis routine to
!         replace PHOT in CMAQ
!     January 2008, Shawn Roselle
!       - reformatted for inclusion in CMAQ
!       - added additional 3-d photolysis rate diagnostic file
!       - moved code for opening the diagnostic files to a separate subroutine
!       - moved aerosol pointer evaluation to a FORTRAN module
!       - simplified code for writing the diagnostic file
!       - changed code to call NEW_OPTICS twice, once for clear sky and
!         another time for the cloudy fraction of the grid cell.  RJ's are
!         computed based on the cloud fraction weighting.
!      March 2011, Bill Hutzell
!       - enable wavelength dependent arrays to have an allocatable number
!         of wavelength bins
!       - added data structure and algorithm to compute a surface albedo that
!         depends on time and landuse catagory based on work by John Striecher
!         (AMAD/USEPA)
!       - revised writing to RJ1 file to include surface albedo
!       - moved photolysis and opacity data from CSQY module to an ASCII input
!         file
!       - added routine called LOAD_REF_DATA (inside the PHOT_MOD module) that i
!         reads this input file
!       - added call to a routine called AERO_PHOTDATA that returns opacity data
!         on the aerosol distribution
!       - revised NEW_OPTICS' arguments based on aerosol redesign in CMAQ
!         version 5.0
!     March 29, 2011 S.Roselle
!       - Replaced I/O API include files with UTILIO_DEFN
!     07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
!     26 Sep 14 B.Hutzell: 1) moved calculation of surface albedo to its own
!                             fortran module
!                          2) changed loading procedure for loading optical data;
!                             two files now used
!                          3) reading and calculation of met and geo data
!                             now acomplished by a fortran module
!                          4) changed description and accounting of cloud effects
!                             from 2D liquid water clouds to 3D resolved and subgrid
!                             clouds with multi-phases of water
!                          5) inserted calculation of aerosol optical properties via
!                             fortran module to improve efficiency in radiative
!                             transfer solution
!                          6) moved the O3TOTCOL routine from the PHOT_MOD to simplify
!                             the NEW_OPTICS routine
!                          7) Several miscellaneous changes attempting to improve efficiency
!     June 10 15 J.Young: Modified diagnostic output timestamp to fix for other than one
!                         hour time steps.
!     Aug 12, 15 D. Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O implementation
!     Feb 01, 19 David Wong: Implemented centralized I/O approach, removed all MY_N
!                            clauses

!----------------------------------------------------------------------

C...modules

      USE RUNTIME_VARS, ONLY : START_DATE => STDATE, START_TIME => STTIME
      USE RXNS_DATA            ! chemistry varaibles and data
      USE GRID_CONF            ! horizontal & vertical domain specifications
      USE CGRID_SPCS           ! CGRID species number and offsets
      USE UTILIO_DEFN
      USE AERO_DATA            ! describes aerosol distribution
      USE PHOT_MOD             ! photolysis in-line module - inherits CSQY_DATA module
      USE AERO_PHOTDATA        ! arrays and routines for aerosol dimensions and refractive indices
      USE PHOTOLYSIS_ALBEDO    ! surface albedo data and routines
      USE PHOT_MET_DATA        ! Met and Grid data
      USE CLOUD_OPTICS         ! data and routines for optics of cloud hydrometeors
      USE SEAS_STRAT_O3_MIN    ! monthly minimum fraction of ozone column density above Pressure TOP
      USE CENTRALIZED_IO_MODULE, ONLY : LAT, LON, HT
      USE ELMO_DATA, ONLY : ELMO_AOD_550, ELMO_EXT_550, ELMO_NO2COL,ELMO_SO2COL, ELMO_HCHOCOL, ELMO_COCOL

#ifdef mpas
      use mio_module
      use coupler_module
#else
#ifdef parallel
      USE SE_MODULES           ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES         ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif

      IMPLICIT NONE

!...include files

      INCLUDE SUBST_FILES_ID   ! file name parameters

!...arguments

      REAL,    POINTER      :: CGRID( :,:,:,: )  ! Species concentrations
      INTEGER, INTENT( IN ) :: JDATE         ! current Julian date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME         ! current time (HHMMSS)
      INTEGER, INTENT( IN ) :: DTSTEP( : )   ! time step vector (HHMMSS)


!...parameters

      LOGICAL, PARAMETER :: CLDATT = .TRUE.   ! include cloud attenuation

      REAL, PARAMETER :: DENS_CONV = ( 1.0E+03 * AVO / MWAIR ) * 1.0E-06  ! convert from kg/m**3 to #/cc
      REAL, PARAMETER :: PPM_MCM3  = 1.0E-06  ! convert from ppm to molecules / cc mol_Spec/mol_Air = ppm * 1E-06
      REAL, PARAMETER :: PRES_CONV = 1.0 / STDATMPA ! conversion factor Pa to atm
      REAL, PARAMETER :: ZTOA      = 50.0E3   ! height of top of atmosphere [ m ] (=50km)
                                              ! based a 2005 WRF model Documentation

      REAL, PARAMETER   :: EPSLON  = 1.0E-30  ! Small number

!...external functions: none

!...local variables

      LOGICAL, SAVE :: FIRSTIME = .TRUE.  ! Flag for first call to PHOT

      LOGICAL, SAVE :: CALL_INIT_ALBEDO = .TRUE.
      LOGICAL, SAVE :: CALL_GET_ALBEDO  = .TRUE.

      LOGICAL       :: ZERO_ICE

      CHARACTER(   3 ), ALLOCATABLE, SAVE :: WLTXT( : )
      CHARACTER(  16 )                    :: VARNM
      CHARACTER(  16 ), SAVE              :: PNAME = 'PHOT'
      CHARACTER(  16 )                    :: V_LIST( 2 )
      CHARACTER(  16 )                    :: REQUESTED_WAVE
      CHARACTER(  16 ), ALLOCATABLE       :: WAVE_LIST( : )

      CHARACTER(  80 ) :: VARDESC  ! environment variable description
      CHARACTER( 240 ) :: XMSG = ' '

      INTEGER,    SAVE :: LGC_O3   = 0 ! pointer to O3 in CGRID
      INTEGER,    SAVE :: LGC_NO2  = 0 ! pointer to NO2 in CGRID
      INTEGER,    SAVE :: LGC_CO   = 0 ! pointer to CO in CGRID
      INTEGER,    SAVE :: LGC_SO2  = 0 ! pointer to SO2 in CGRID
      INTEGER,    SAVE :: LGC_HCHO = 0 ! pointer to formaldehyde  in CGRID
      INTEGER,    SAVE :: TSTEP    ! output timestep in sec

      INTEGER ESTAT                ! status from environment var check
      INTEGER IPHOT                ! photolysis rate loop index
      INTEGER ROW
      INTEGER COL
      INTEGER LEV
      INTEGER SPC
      INTEGER IWL
      INTEGER L
      INTEGER V, N, MODE
      
      LOGICAL :: JTIME_CHK   ! To check for JTIME to write RJ values
      INTEGER, SAVE :: ODATE ! output date
      INTEGER, SAVE :: OTIME ! output time
      INTEGER, SAVE :: OSTEP ! time since last write diagnostics  

      INTEGER ALLOCSTAT

      INTEGER ITMSTEP              ! one half synchronization timestep (sec)
      INTEGER MIDDATE              ! Date at time step midpoint
      INTEGER MIDTIME              ! Time at time step midpoint

      INTEGER, SAVE :: TDATE
      INTEGER, SAVE :: PECOL_OFFSET        ! Local Column Offset for processor
      INTEGER, SAVE :: PEROW_OFFSET        ! Local Column Offset for processor
      INTEGER, SAVE :: TSTEP_COUNT         ! counter between calls to write diagnostics

      REAL CURRHR          ! current GMT hour
      REAL JULIAN_DAY      ! time of year [days]
      REAL CURRHR_LST      ! local standard time at each grid cell
      REAL CTOP            ! cloud top in single dimension
      REAL CBASE           ! cloud base in single dimension
      REAL ZLEV            ! height in single dimension
      REAL ZEN             ! cosine of zenith angle
      REAL SINLAT          ! sine of latitude
      REAL COSLAT          ! cosine of latitude
      REAL RSQD            ! square of soldist
      REAL ZSFC            ! surface height (msl) [ m ]
      REAL EQT             ! equation of time
      REAL SOLDIST         ! solar distance [ au ]
      REAL SINDEC          ! sine of the solar declination
      REAL COSDEC          ! cosine of the solar declination
      REAL COSZEN          ! working cosine of the solar zenith angle
      REAL SINZEN          ! working sine of the solar zenith angle
      REAL LATCR           ! local latitude
      REAL LONCR           ! local longitude
      REAL OWATER_FRAC     ! Open water fraction
      REAL SNOW_FRAC       ! Snow fractional coverage
      REAL SEAICE_FRAC     ! Sea Ice fraction
      REAL RES_SKY_REFLECT ! reflection coefficient based on resolved sky
      REAL RES_SKY_TRANS   ! diffuse transmission coefficient based on resolved sky
      REAL RES_SKY_TRANSD  ! direct transmission coefficient based on resolved sky

      REAL                    :: TOTAL_O3_COLUMN ! total ozone column density, DU

      REAL,              SAVE :: JYEAR          = 0.0 ! year
      REAL,              SAVE :: JD_STRAT_O3MIN = 0.0 ! Julian day (YYYYDDD) of min fraction for stratos ozone

      INTEGER, PARAMETER  :: DAYS( 12 ) = (/ 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30 /)
      INTEGER, SAVE       :: IMONTH = 0

      REAL, ALLOCATABLE, SAVE :: ETOT_SFC ( : )      ! total downward irradiance at sfc [ Watts / m**2  ]
      REAL, ALLOCATABLE, SAVE :: TAUO3_TOP( : )      ! optical depth of ozone above model domain
      REAL, ALLOCATABLE, SAVE :: TAU_RAY  ( : )      ! Rayleigh optical depth above model domain
      REAL, ALLOCATABLE, SAVE :: TAUC_AERO( :,: )    ! aerosol optical depth at layer bottom
      REAL, ALLOCATABLE, SAVE :: TAU_TOT  ( :,: )    ! total optical depth at layer bottom
      REAL, ALLOCATABLE, SAVE :: TAU_CLOUD( :,: )    ! cloud optical depth at layer bottom

      REAL, ALLOCATABLE, SAVE :: SSA      ( : ) ! aerosol single scattering albedo, column average

      REAL MSCALE          ! combined factor to scale ppm to Molecules / cm**3
                           ! and correct for ambient temperaure and pressure

! FSB new arrays for new on-line cloud version

      REAL, ALLOCATABLE, SAVE :: LWC    ( : )      ! cloud liquid water content [ g/m**3 ]
      REAL, ALLOCATABLE, SAVE :: RWC    ( : )      ! rain water content [ g/m**3 ]
      REAL, ALLOCATABLE, SAVE :: IWC    ( : )      ! ice liquid water content [ g/m**3 ]
      REAL, ALLOCATABLE, SAVE :: SWC    ( : )      ! snow content [ g/m**3 ]
      REAL, ALLOCATABLE, SAVE :: GWC    ( : )      ! graupel content [ g/m**3 ]
      REAL, ALLOCATABLE, SAVE :: CLDFRAC( : )      ! fractional cloud cover
      REAL, ALLOCATABLE, SAVE :: BLKPRS ( : )      ! Air pressure in [ Pa ]
      REAL, ALLOCATABLE, SAVE :: BLKTA  ( : )      ! Air temperature [ K ]
      REAL, ALLOCATABLE, SAVE :: BLKDENS( : )      ! Air density  [ molecules / m**3 ]
      REAL, ALLOCATABLE, SAVE :: BLKZH  ( : )      ! layer half-height [ m ]
      REAL, ALLOCATABLE, SAVE :: BLKO3  ( : )      ! O3 concentration [ molecules/cm**3 ]
      REAL, ALLOCATABLE, SAVE :: BLKNO2 ( : )      ! NO2 concentration [ molecules/cm**3 ]
      REAL, ALLOCATABLE, SAVE :: BLKZF  ( : )      ! layer full-height [ m ]

      REAL, ALLOCATABLE, SAVE :: BLKRJ_RES( :, : ) ! photolysis rates
      REAL, ALLOCATABLE, SAVE :: BLKRJ_ACM( :, : ) ! photolysis rates

      LOGICAL, ALLOCATABLE, SAVE :: CLOUDS( : )    ! Does layer have clouds?
      LOGICAL                    :: NEW_PROFILE    ! Has atmospheric temperature and density profile changed?
      LOGICAL                    :: DARK           ! Are this processor's cells in darkness?

!...Variables for diagnostic outputs

      REAL, ALLOCATABLE, SAVE :: N_EXCEED_TROPO3( :,: )  ! Number of adjustments tropospheric ozone optical depth

      REAL, ALLOCATABLE, SAVE :: TOTAL_OC( :,: )         ! total ozone column [DU]
      REAL, ALLOCATABLE, SAVE :: TROPO_OC( :,: )         ! tropospheric ozone column [DU]
      REAL, ALLOCATABLE, SAVE :: NO2_COLUMN ( :,: )      ! tropospheric NO2 column []
      REAL, ALLOCATABLE, SAVE :: CO_COLUMN  ( :,: )      ! tropospheric CO column  []
      REAL, ALLOCATABLE, SAVE :: HCHO_COLUMN( :,: )      ! tropospheric HCHO column [DU]
      REAL, ALLOCATABLE, SAVE :: SO2_COLUMN ( :,: )      ! tropospheric SO2 column [DU]
      REAL, ALLOCATABLE, SAVE :: TROPO_O3_EXCEED( :,: )   ! Factor used to adjust tropospheric ozone optical depth
      REAL, ALLOCATABLE, SAVE :: TRANSMIS_DIFFUSE( :,: ) ! diffuse transmission coefficient at surface
      REAL, ALLOCATABLE, SAVE :: TRANSMIS_DIRECT( :,: )  ! direct transmission coefficient at surface
      REAL, ALLOCATABLE, SAVE :: REFLECT_COEFF( :,: )    ! reflection coefficient at top of atmosphere
      REAL, ALLOCATABLE, SAVE :: TAU_AERO_WL ( :,:,: )   ! total aerosol optical depth
      REAL, ALLOCATABLE, SAVE :: TAU_ABS_AERO( :,:,: )   ! aerosol absorpion optical depth
      REAL, ALLOCATABLE, SAVE :: TAU_CLOUD_WL( :,:,: )   ! total cloud optical depth
      REAL, ALLOCATABLE, SAVE :: CLR_TRANSMISSION( :,: ) ! diffuse transmission coefficient of clouds
      REAL, ALLOCATABLE, SAVE :: CLR_REFLECTION  ( :,: ) ! reflection coefficient of cloud
      REAL, ALLOCATABLE, SAVE :: CLR_TRANS_DIRECT( :,: ) ! direct transmission coefficient of clouds
#ifdef phot_debug
      REAL, ALLOCATABLE, SAVE :: ASY_CLOUD_WL( :,:,: ) ! columm average of cloud asymmetry factor
      REAL, ALLOCATABLE, SAVE :: SSA_CLOUD_WL( :,:,: ) ! columm average of cloud single scattering albedo
#endif
      REAL, ALLOCATABLE, SAVE :: TAU_TOT_WL  ( :,:,: ) ! total optical depth
      REAL, ALLOCATABLE, SAVE :: TAUO3_TOP_WL( :,:,: ) ! optical depth of ozone above model domain

      REAL, ALLOCATABLE, SAVE :: AERO_SCAT ( :,:,:,: ) ! aerosol scattering for layer [1/Km]
      REAL, ALLOCATABLE, SAVE :: AERO_ASYM ( :,:,:,: ) ! aerosol asymmetry factor
      REAL, ALLOCATABLE, SAVE :: TOT_EXT   ( :,:,:,: ) ! total extinction for layer [1/Km]
      REAL, ALLOCATABLE, SAVE :: GAS_EXT   ( :,:,:,: ) ! clear sky extinction for layer [1/Km]
      REAL, ALLOCATABLE, SAVE :: AERO_EXT  ( :,:,:,: ) ! aerosol extinction for layer [1/Km]
      REAL, ALLOCATABLE, SAVE :: ACTINIC_FX( :,:,:,: ) ! net actinic flux [watts/m**2]
      REAL, ALLOCATABLE, SAVE :: OUTPUT_BUFF ( :,:,: ) ! output buffer for DIAG2 and DIAG3 files

#ifdef mpas
! this is for creating the output name list
      character (512) :: fname
      character (30), allocatable, save :: name_list(:)
      character (30) :: oname
      character (120) :: buf, buf2
      integer, save :: loc_n
      integer :: loc_nvars, stat, k, fnum
      logical :: found
      character (20) :: time_stamp

      integer, save :: gcount = 0
#endif

      INTERFACE
         SUBROUTINE O3TOTCOL ( LATITUDE, LONGITUDE, JDATE, JTIME, OZONE )
            INTEGER, INTENT( IN )    :: JDATE      ! Julian day of the year (yyyyddd)
            INTEGER, INTENT( IN )    :: JTIME      ! time (hhmmss)
            REAL,    INTENT( IN )    :: LATITUDE   ! latitude of point on earth's surface
            REAL,    INTENT( IN )    :: LONGITUDE  ! longitude of point on earth's surface
            REAL,    INTENT( INOUT ) :: OZONE      ! total column ozone [DU]
         END SUBROUTINE O3TOTCOL
         SUBROUTINE CONVCLD_PROP_ACM( JDATE, JTIME, TSTEP )
            INTEGER, INTENT( IN )    :: JDATE
            INTEGER, INTENT( IN )    :: JTIME
            INTEGER, INTENT( IN )    :: TSTEP( 3 )
         END SUBROUTINE CONVCLD_PROP_ACM
      END INTERFACE

! ----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

         TSTEP  = TIME2SEC( DTSTEP( 1 ) ) ! output timestep for phot diagnostic files

!...Set flag to initialize calculating aerosol extinction at 550 nm via Angstrom Exponents
         CALCULATE_EXT_550 = .TRUE. !PHOTDIAG

#ifdef mpas
         PECOL_OFFSET = 0
         PEROW_OFFSET = 0
#else
         PECOL_OFFSET = COLSD_PE( 1, MYPE+1 ) - 1
         PEROW_OFFSET = ROWSD_PE( 1, MYPE+1 ) - 1
#endif

         CALL INIT_PHOT_SHARED()

!...Allocate array needed to calculation aerosol and cloud optical properties

         CALL INIT_AERO_DATA(  )

         CALL INIT_CLOUD_OPTICS(  )

! set cosine values for sun effectively below horizon
         COS85 = COS( 85.0 * PI180 )

!...Initialize Surface albedo method

         IF ( .NOT. INITIALIZE_ALBEDO( JDATE, JTIME ) ) THEN
              XMSG = 'Failure initializing photolysis surface albedo algorithm'
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE( ETOT_SFC ( NWL ) )

         ALLOCATE( LWC    ( NLAYS ) )
         ALLOCATE( RWC    ( NLAYS ) )
         ALLOCATE( IWC    ( NLAYS ) )
         ALLOCATE( SWC    ( NLAYS ) )
         ALLOCATE( GWC    ( NLAYS ) )
         ALLOCATE( BLKPRS ( NLAYS ) )
         ALLOCATE( BLKTA  ( NLAYS ) )
         ALLOCATE( BLKDZ  ( NLAYS ) )
         ALLOCATE( BLKDENS( NLAYS ) )
         ALLOCATE( BLKZH  ( NLAYS ) )
         ALLOCATE( BLKO3  ( NLAYS ) )
         ALLOCATE( BLKNO2 ( NLAYS ) )
         ALLOCATE( BLKZF  ( NLAYS+1 ) )
         ALLOCATE( CLOUDS ( NLAYS ) )
         ALLOCATE( CLDFRAC( NLAYS ) )

         ALLOCATE( BLKRJ_RES( NLAYS,NPHOTAB ) )
         ALLOCATE( BLKRJ_ACM( NLAYS,NPHOTAB ) )

         ALLOCATE( TAUO3_TOP( NWL ) )
         ALLOCATE( TAU_RAY  ( NWL ) )
         ALLOCATE( SSA      ( NWL ) )

         ALLOCATE( TAU_CLOUD( NLAYS,NWL ) )
         ALLOCATE( TAUC_AERO( NLAYS,NWL ) )
         ALLOCATE( TAU_TOT  ( NLAYS,NWL ) )

         ALLOCATE( TOTAL_OC ( NCOLS,NROWS ) )
         ALLOCATE( TAU_ABS_AERO_550( NCOLS,NROWS ) )
         ALLOCATE( TAU_AERO_550    ( NCOLS,NROWS ) )
         TAU_AERO_550     = 0.0
         TAU_ABS_AERO_550 = 0.0

         IF ( PHOTDIAG ) THEN

            ALLOCATE( TROPO_OC   ( NCOLS,NROWS ) )
            ALLOCATE( CO_COLUMN  ( NCOLS,NROWS ) )
            ALLOCATE( SO2_COLUMN ( NCOLS,NROWS ) )
            ALLOCATE( NO2_COLUMN ( NCOLS,NROWS ) )
            ALLOCATE( HCHO_COLUMN( NCOLS,NROWS ) )
            ALLOCATE( TROPO_O3_EXCEED( NCOLS,NROWS ) )
            ALLOCATE( N_EXCEED_TROPO3( NCOLS,NROWS ) )
            ALLOCATE( TRANSMIS_DIFFUSE( NCOLS,NROWS ) )
            ALLOCATE( TRANSMIS_DIRECT ( NCOLS,NROWS ) )
            ALLOCATE( REFLECT_COEFF   ( NCOLS,NROWS ) )
            ALLOCATE( CLR_TRANSMISSION( NCOLS,NROWS ) )
            ALLOCATE( CLR_TRANS_DIRECT( NCOLS,NROWS ) )
            ALLOCATE( CLR_REFLECTION  ( NCOLS,NROWS ) )
            ALLOCATE( TAU_AERO_WL     ( NCOLS,NROWS,NWL ) )
            ALLOCATE( TAU_ABS_AERO    ( NCOLS,NROWS,NWL ) )
            ALLOCATE( TAU_CLOUD_WL    ( NCOLS,NROWS,NWL ) )
#ifdef phot_debug
            ALLOCATE( SSA_CLOUD_WL( NCOLS,NROWS,NWL ) )
            ALLOCATE( ASY_CLOUD_WL( NCOLS,NROWS,NWL ) )
#endif
            ALLOCATE( TAU_TOT_WL  ( NCOLS,NROWS,NWL ) )
            ALLOCATE( TAUO3_TOP_WL( NCOLS,NROWS,NWL ) )

            N_EXCEED_TROPO3 = 0.0
            TROPO_O3_EXCEED = 0.0
            TSTEP_COUNT     = 0
            TROPO_OC        = 0.0
            CO_COLUMN       = 0.0
            SO2_COLUMN      = 0.0
            NO2_COLUMN      = 0.0
            HCHO_COLUMN     = 0.0
            TAU_ABS_AERO    = 0.0
     
   
!...write wavelength data to a character array

            ALLOCATE ( WLTXT( NWL ) )

            DO IWL = 1, NWL
               WRITE( WLTXT( IWL ),'(I3.3)' ) INT( WAVELENGTH( IWL ) )
            END DO

! get wanted number of layers for PHOTDIAG2 and PHOTDIAG3 files 
            IF ( NLAYS_DIAG .EQ. 0 ) NLAYS_DIAG = NLAYS
            NLAYS_DIAG = MAX( 1, MIN( NLAYS_DIAG, NLAYS))

! get wanted wavelengths for PHOTDIAG2 and PHOTDIAG3 files
            ALLOCATE( WAVE_LIST( NWL ) )
            WAVE_LIST( : ) = ''
            IF ( NWAVE .GT. NWL )
     &          CALL LOG_MESSAGE( LOGDEV, 'Error: the number of ' //
     &          'wavelengths the user has requested for diagnostic ' //
     &          'photolysis output exceeds the number of internal model ' //
     &          'wavelengths.' )
            IF ( NWAVE .EQ. 0 ) THEN ! use all wavelenghts
               N_DIAG_WVL = NWL
               ALLOCATE ( DIAG_WVL( N_DIAG_WVL ) , STAT = ALLOCSTAT )
               IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating DIAG_WVL'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
               DO IWL = 1, NWL
                  DIAG_WVL( IWL )  = IWL
               END DO
               WRITE(LOGDEV,'(5X,A,I3)')'Environment Variable NWAVE_PHOTDIAG not found '
     &      // 'setting PHOTDIAG2 and PHOTDIAG3 to output all wavelengths. Integer '
     &      // 'truncated values are below.'
               DO IWL = 1, N_DIAG_WVL
                  SPC = DIAG_WVL( IWL )
                  WRITE(LOGDEV,'(5X,I3,1X,A16)')IWL, WLTXT(SPC)
               END DO
            ELSE ! use the environment list
                WAVE_LIST( 1:NWAVE ) = WAVE_ENV( 1:NWAVE )
                N_DIAG_WVL = 0
                 ! first remove identical values
                DO V = 1, NWAVE-1
                   DO L = (V+1), NWAVE
                      IF( TRIM( WAVE_LIST( V ) ) .EQ. TRIM( WAVE_LIST( L ) ) )THEN
                         WAVE_LIST( L ) = " "
                      END IF
                   END DO
                END DO
                 ! Now count number of unique values
                DO V = 1, NWAVE
                   IF( LEN_TRIM( WAVE_LIST( V ) ) .GT. 0 )N_DIAG_WVL = N_DIAG_WVL + 1
                END DO
                ALLOCATE ( DIAG_WVL( N_DIAG_WVL ) , STAT = ALLOCSTAT )
                IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating DIAG_WVL'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
                ! Next find unique list value in wavelenght spectrum
               IWL = 0
               DO V = 1, NWAVE
                   IF( LEN_TRIM( WAVE_LIST( V ) ) .LT. 1 )CYCLE
                   IWL = IWL + 1
                   DIAG_WVL( IWL )  = INDEXR ( TRIM( WAVE_LIST( V ) ), NWL, WLTXT )
                   IF ( DIAG_WVL( IWL ) .LT. 1 ) THEN
                      WRITE(LOGDEV,'(5X,A)')'PHOT: Cannot find requested wavelength, '
     &                              // TRIM(  WAVE_LIST( IWL ) ) // ' for DIAG2 and DIAG3 files '
     &                              // ' in spectrum '
                   END IF
               END DO
               IF( MINVAL( DIAG_WVL ) .LT. 1 )THEN
                  XMSG = 'FAILED TO find the above requested wavelenght spectrum '
                  WRITE( LOGDEV,'(5X,A)')XMSG
                  XMSG = 'Permitted integer truncated values of wavelenght spectrum '
                  DO IWL = 1, NWL
                     WRITE(LOGDEV,'(10X,I3,1X,A16)')IWL, WLTXT(IWL)
                  END DO
                  XMSG = 'ERROR using the environment variable, NWAVE_PHOTDIAG '
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               ELSE
                  WRITE(LOGDEV,'(5X,A,I3)')'Environment Variable NWAVE_PHOTDIAG found '
     &      //    'setting PHOTDIAG2 and PHOTDIAG3 to output below wavelenghts'
                  DO IWL = 1, N_DIAG_WVL
                     SPC = DIAG_WVL( IWL )
                     WRITE(LOGDEV,'(5X,I3,1X,A16)')IWL, WLTXT(SPC)
                  END DO
               END IF
            END IF
            WRITE(LOGDEV,'(/)')


            ALLOCATE ( AERO_ASYM( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D AERO_ASYM'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( AERO_SCAT( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D AERO_SCAT'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( AERO_EXT( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D AERO_EXT'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( TOT_EXT( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D TOT_EXT'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( GAS_EXT( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D GAS_EXT'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( ACTINIC_FX( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACTINIC_FX'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( OUTPUT_BUFF( NCOLS,NROWS,NLAYS_DIAG ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating OUTPUT_BUFF'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'CO'
            LGC_CO = INDEX1( VARNM, N_GC_SPC, GC_SPC )
            IF ( LGC_CO .LE. 0 ) THEN
               XMSG = 'Could not find ' // VARNM // 'in species table'
               CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
               WRITE(LOGDEV,95101)
            END IF
            
            VARNM = 'SO2'
            LGC_SO2 = INDEX1( VARNM, N_GC_SPC, GC_SPC )
            IF ( LGC_SO2 .LE. 0 ) THEN
               XMSG = 'Could not find ' // VARNM // 'in species table'
               CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
               WRITE(LOGDEV,95101)
            END IF
            
            VARNM = 'HCHO'
            LGC_HCHO = INDEX1( VARNM, N_GC_SPC, GC_SPC )
            IF ( LGC_HCHO .LE. 0 ) THEN
               VARNM = 'FORM'
               LGC_HCHO = INDEX1( VARNM, N_GC_SPC, GC_SPC )
               IF ( LGC_HCHO .LE. 0 ) THEN
                  XMSG = 'Could not find HCHO or FORM, i.e., formaldehyde, in species table'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  WRITE(LOGDEV,95101)
               END IF
            END IF
         
!...open the photolysis diagnostic files
            ODATE = START_DATE; OTIME = START_TIME; OSTEP = 0
#ifndef mpas
#ifdef phot_write_start
            IF ( IO_PE_INCLUSIVE ) CALL OPPHOT ( ODATE, OTIME, DTSTEP( 1 ) )
#else
            CALL NEXTIME ( ODATE, OTIME, DTSTEP( 1 ) )  ! output timestamp ending time
            IF ( IO_PE_INCLUSIVE ) CALL OPPHOT ( ODATE, OTIME, DTSTEP( 1 ) )
! reset ODATE and OTIME for counting 
            ODATE = START_DATE; OTIME = START_TIME
#endif
#endif

         END IF  ! photdiag
#ifndef mpas
         CALL SUBST_BARRIER
#endif

         ALLOCATE ( AERO_EXT_550( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
             XMSG = 'Failure allocating 3D AERO_EXT_550'
             CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
!...set pointers to species O3 and NO2 in CGRID

         VARNM = 'O3'
         LGC_O3 = INDEX1( VARNM, N_GC_SPC, GC_SPC )
         IF ( LGC_O3 .LE. 0 ) THEN
            XMSG = 'Could not find ' // VARNM // 'in species table'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

         VARNM = 'NO2'
         LGC_NO2 = INDEX1( VARNM, N_GC_SPC, GC_SPC )
         IF ( LGC_NO2 .LE. 0 ) THEN
            XMSG = 'Could not find ' // VARNM // 'in species table'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

#ifdef mpas
! this is for creating the output name list
         found = .false.
         fnum = 0
         do while ((.not. found) .and. (fnum < mio_outfile_def_info%num_of_file_definitions))
            fnum = fnum + 1
            if ('CTM_OUT' == mio_outfile_def_info%flist(fnum)%fname) then
               found = .true.
            end if
         end do
         if (.not. found) then
            write (logdev, *) ' Abort: file CTM_OUT not on the file_input.txt'
            stop
         end if

         loc_nvars = mio_outfile_def_info%flist(fnum)%nvars

         loc_n = 0
         if (found) then
            allocate (name_list(loc_nvars), stat=stat)
            do n = 1, loc_nvars
               buf = mio_outfile_def_info%flist(fnum)%vlist(n)
               found = .false.
               k = 0
               do while (.not. found)
                  k = k + 1
                  if (buf(k:k) == ' ') then
                     found = .true.
                  end if
               end do
               if (buf(1:3) == 'PD_') then
                  loc_n = loc_n + 1
                  name_list(loc_n) = buf(4:k-1)
               end if
            end do
         end if
#endif

         RETURN ! Added for MIO Implementation
      END IF  ! firstime

      IF ( INT ( JD_STRAT_O3MIN ) .NE. JDATE ) THEN
!...set minimum fraction of ozone column above PTOP
         CALL SEASONAL_STRAT_O3( JDATE, JTIME )
         MIN_STRATO3_FRAC = MONTH_STRAT_03_FRAC
         MAX_TROPOO3_FRAC = MAX( 1.0 - MONTH_STRAT_03_FRAC, 0.0 )
         JD_STRAT_O3MIN = REAL( JDATE, 4)
      END IF
!...initialize variables tracking whether stratosphere ozone column satisfies
!...climatological averages.

      O3_TOGGLE_AVE     = 0.0
      O3_TOGGLE_MIN     = 1.0
      N_TROPO_O3_TOGGLE = 0
      TSTEP_COUNT       = TSTEP_COUNT + 1

      MIDDATE = JDATE
      MIDTIME = JTIME
      ITMSTEP = TIME2SEC( DTSTEP( 2 ) ) / 2
      CALL NEXTIME( MIDDATE, MIDTIME, SEC2TIME( ITMSTEP ) )

      CALL CONVCLD_PROP_ACM( JDATE, JTIME, DTSTEP )
      CALL GET_PHOT_MET( JDATE, JTIME, MIDDATE, MIDTIME )

!...Get cosine of solar parameters and set DARK

      CALL UPDATE_SUN( JDATE, JTIME, MIDDATE, MIDTIME )

      RSQD = DIST_TO_SUN * DIST_TO_SUN

      IF ( MAXVAL( COSINE_ZENITH ) .LE. 0.0 ) THEN
         DARK = .TRUE.
      ELSE
         DARK = .FALSE.
      END IF

!...set surface albedos

      CALL GET_ALBEDO( MIDDATE, MIDTIME, COSINE_ZENITH, LAT, LON )

!...SA  Write COSINE_ZENITH array at the end of each output tstep

      JTIME_CHK         = .FALSE.
      OSTEP  = OSTEP + TIME2SEC( DTSTEP( 2 ) )
      JTIME_CHK = ( OSTEP .GE. TIME2SEC( DTSTEP( 1 ) ) )
      IF ( JTIME_CHK ) THEN 
        OSTEP = 0
        CALL NEXTIME( ODATE, OTIME, DTSTEP( 1 ) )
      END IF
#ifdef phot_write_start
      JTIME_CHK = ( ODATE .EQ. STDATE .AND. OTIME .EQ. STTIME )
#endif 

      IF ( PHOTDIAG ) THEN
#ifdef parallel_io
         IF ( .NOT. IO_PE_INCLUSIVE ) THEN
            IF ( .NOT. OPEN3( CTM_RJ_1, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // TRIM(CTM_RJ_1)
               CALL M3EXIT( PNAME, ODATE, OTIME, XMSG, XSTAT1 )
            END IF
            IF ( .NOT. OPEN3( CTM_RJ_2, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // TRIM(CTM_RJ_2)
               CALL M3EXIT( PNAME, ODATE, OTIME, XMSG, XSTAT1 )
            END IF
            IF ( .NOT. OPEN3( CTM_RJ_3, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // TRIM(CTM_RJ_3)
               CALL M3EXIT( PNAME, ODATE, OTIME, XMSG, XSTAT1 )
            END IF
         END IF
#endif
      END IF

      CALCULATE_EXT_550 = .TRUE. !JTIME_CHK

!...If sun below horizon at all cells, zero photolysis rates & exit
!...  (assumes sun below horizon at *all* levels!)

      IF ( DARK ) THEN

         RJ = 0.0
         RJ_SUB = 0.0
         RJ_RES = 0.0
         ETOT_SFC_WL  = 0.0
         AERO_EXT_550 = 0.0
         TAU_AERO_550 = 0.0
         TAU_ABS_AERO_550 = 0.0

!...Initialize ETOT_SFC, TAU_AERO, TAU_TOT, TAUO3_TOP to 0.0

!...Write data to output diagnostic file

         IF ( JTIME_CHK .AND. PHOTDIAG ) THEN

            TAUO3_TOP_WL = 0.0
            TAU_AERO_WL  = 0.0
            TAU_ABS_AERO = 0.0
            TAU_CLOUD_WL = 0.0
#ifdef phot_debug
            SSA_CLOUD_WL = 0.0
            ASY_CLOUD_WL = 0.0
#endif
            TAU_TOT_WL   = 0.0
            TOT_EXT      = 0.0
            GAS_EXT      = 0.0
            AERO_EXT     = 0.0
            AERO_SCAT    = 0.0
            AERO_ASYM    = 0.0
            ACTINIC_FX   = 0.0

            TRANSMIS_DIFFUSE  = 0.0
            TRANSMIS_DIRECT   = 0.0
            REFLECT_COEFF     = 0.0
            CLR_TRANSMISSION  = 0.0
            CLR_TRANS_DIRECT  = 0.0
            CLR_REFLECTION    = 0.0

            DO ROW = 1, NROWS
               DO COL = 1, NCOLS
                  BLKDENS( 1 ) = DENS ( COL,ROW,1 ) * DENS_CONV ! [molecules / cm**3]
                  BLKDZ  ( 1 ) = ZFULL( COL,ROW,1 )
                  DO L = 2, NLAYS
                     BLKDENS( L ) = DENS( COL,ROW,L ) * DENS_CONV ! [molecules / cm**3]
                     BLKDZ  ( L ) = ZFULL( COL,ROW,L ) - ZFULL( COL,ROW,L-1 )
                  END DO
                  MSCALE = 1.0E-19 ! 100.0*10E-15*PPM_MCM3, so units are petamolecules/cm2
                  CALL COLUMN_GAS( IGAS=LGC_CO,   UNIT_FACTOR=MSCALE, COLUMN_DENSITY=CO_COLUMN   )
                  CALL COLUMN_GAS( IGAS=LGC_SO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=SO2_COLUMN  )
                  CALL COLUMN_GAS( IGAS=LGC_NO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=NO2_COLUMN  )
                  CALL COLUMN_GAS( IGAS=LGC_HCHO, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=HCHO_COLUMN )
                  MSCALE = 1.0E-4 * CONC_TO_DU ! so units are Dobsons
                  CALL COLUMN_GAS( IGAS=LGC_O3, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=TROPO_OC )                     
!...get total ozone column based on OMI observations
                  CALL O3TOTCOL ( LAT( COL,ROW ), LON( COL,ROW ), MIDDATE, MIDTIME, TOTAL_OC( COL,ROW ) )
               END DO
            END DO   
         ELSE
           DO ROW = 1, NROWS
              DO COL = 1, NCOLS
!...get total ozone column based on OMI observations
                  CALL O3TOTCOL ( LAT( COL,ROW ), LON( COL,ROW ), MIDDATE,MIDTIME, TOTAL_OC( COL,ROW ) )
              END DO
           END DO
         END IF  ! if JTIME_CHK and PHOTDIAG

      ELSE  ! all cells not dark
   
!...MAIN loop over all rows and columns
         LOOP_ROWS: DO ROW = 1, NROWS
            LOOP_COLS: DO COL = 1, NCOLS

               PHOT_COL = COL + PECOL_OFFSET
               PHOT_ROW = ROW + PEROW_OFFSET

               COSZEN = COSINE_ZENITH( COL,ROW ) ! local cosine of solar zenith angle

               TAU_AERO_550( COL,ROW ) = 0.0
               AERO_EXT_550( COL,ROW,: ) = 0.0
               TAU_ABS_AERO_550( COL,ROW ) = 0.0
               IF ( COSZEN .LE. 0.0 ) THEN
!...the cell is dark: set variables to zero and cycle
                  RJ( COL,ROW, :,: ) = 0.0
                  RJ_RES( COL,ROW, :,: ) = 0.0
                  RJ_SUB( COL,ROW, :,: ) = 0.0
                  ETOT_SFC_WL ( COL,ROW, : ) = 0.0

                  IF ( JTIME_CHK .AND. PHOTDIAG ) THEN
                     TAUO3_TOP_WL( COL,ROW, : ) = 0.0
                     TAU_AERO_WL ( COL,ROW, : ) = 0.0
                     TAU_ABS_AERO( COL,ROW, : ) = 0.0
                     TAU_CLOUD_WL( COL,ROW, : ) = 0.0
#ifdef phot_debug
                     SSA_CLOUD_WL( COL,ROW, : ) = 0.0
                     ASY_CLOUD_WL( COL,ROW, : ) = 0.0
#endif
                     TAU_TOT_WL  ( COL,ROW, : )   = 0.0
                     TOT_EXT     ( COL,ROW, :,: ) = 0.0
                     GAS_EXT     ( COL,ROW, :,: ) = 0.0
                     AERO_EXT    ( COL,ROW, :,: ) = 0.0
                     AERO_SCAT   ( COL,ROW, :,: ) = 0.0
                     AERO_ASYM   ( COL,ROW, :,: ) = 0.0
                     ACTINIC_FX  ( COL,ROW, :,: ) = 0.0

!                     TROPO_O3_EXCEED( COL,ROW )  = 0.0
                     TRANSMIS_DIFFUSE( COL,ROW ) = 0.0
                     TRANSMIS_DIRECT ( COL,ROW ) = 0.0
                     REFLECT_COEFF   ( COL,ROW ) = 0.0
                     CLR_TRANSMISSION( COL,ROW ) = 0.0
                     CLR_TRANS_DIRECT( COL,ROW ) = 0.0
                     CLR_REFLECTION  ( COL,ROW ) = 0.0
                     
                     BLKDENS( 1 ) = DENS ( COL,ROW,1 ) * DENS_CONV ! [molecules / cm**3]
                     BLKDZ  ( 1 ) = ZFULL( COL,ROW,1 )
                     DO L = 2, NLAYS
                        BLKDENS( L ) = DENS( COL,ROW,L ) * DENS_CONV ! [molecules / cm**3]
                        BLKDZ  ( L ) = ZFULL( COL,ROW,L ) - ZFULL( COL,ROW,L-1 )
                     END DO
                     MSCALE = 1.0E-19 ! 100.0*10E-15*PPM_MCM3, so units are petamolecules/cm2
                     CALL COLUMN_GAS( IGAS=LGC_CO,   UNIT_FACTOR=MSCALE, COLUMN_DENSITY=CO_COLUMN   )
                     CALL COLUMN_GAS( IGAS=LGC_SO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=SO2_COLUMN  )
                     CALL COLUMN_GAS( IGAS=LGC_NO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=NO2_COLUMN  )
                     CALL COLUMN_GAS( IGAS=LGC_HCHO, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=HCHO_COLUMN )
                     MSCALE = 1.0E-4 * CONC_TO_DU ! so units are Dobsons
                     CALL COLUMN_GAS( IGAS=LGC_O3, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=TROPO_OC )                     
!...get total ozone column based on OMI observations
                     CALL O3TOTCOL ( LAT( COL,ROW ), LON( COL,ROW ), MIDDATE, MIDTIME, TOTAL_OC( COL,ROW ) )
                  END IF   

                  CYCLE LOOP_COLS

               END IF

!...initialize BLKRJ using F90 array operations.

               BLKRJ_RES = 0.0
               BLKRJ_ACM = 0.0

!...Set height of lowest level to zero

               BLKZF( 1 ) = 0.0

               ZSFC   = HT( COL,ROW ) ! surface height [m]
               SINZEN = SQRT( 1.0 - COSZEN * COSZEN ) ! sine of zenith angle

!...get total ozone column based on OMI observations
               CALL O3TOTCOL ( LAT( COL,ROW ), LON( COL,ROW ), MIDDATE, MIDTIME, TOTAL_O3_COLUMN )

               IF ( USE_ACM_CLOUD .OR. CLDATT ) THEN
                  OWATER_FRAC = MAX( ( 1.0 - SEAICE( COL,ROW ) ), 0.0 )
     &                        * WATER_FRACTION( COL,ROW )
                  SEAICE_FRAC = SEAICE( COL,ROW ) * WATER_FRACTION( COL,ROW )
                  SNOW_FRAC   = SNOCOV( COL,ROW )
                  COL_CLOUD   = PHOT_COL
                  ROW_CLOUD   = PHOT_ROW
               END IF

!...loop over vertical layers ambient air conditions and gas concentration
               DO L = 1, NLAYS
!...Fetch the grid cell ambient data at each layer.

                  BLKTA  ( L )   = TA   ( COL,ROW,L ) ! temperature [K]
                  BLKPRS ( L )   = PRES ( COL,ROW,L ) / STDATMPA  ! [atmospheres]
                  BLKDENS( L )   = DENS ( COL,ROW,L ) * DENS_CONV ! [molecules / cm**3]
                  BLKZH  ( L )   = ZM   ( COL,ROW,L ) ! mid layer height [m]
                  BLKZF  ( L+1 ) = ZFULL( COL,ROW,L ) ! full layer height [m]

!...set scale factor for [ppm] -> [molecule / cm**3]
!...  To go from ppm to molecule/cc:
!...  molecule/cc = ppm *  1.0E-06 * DENS (given in molecule/cc)

                  MSCALE = BLKDENS( L ) * PPM_MCM3

!...fetch ozone and no2 and convert to [ molecules / cm **3 ]
!...  and adjust the volume for ambient temperature and pressure.

                  BLKO3 ( L ) = CGRID( COL,ROW,L,LGC_O3  ) * MSCALE
                  BLKNO2( L ) = CGRID( COL,ROW,L,LGC_NO2 ) * MSCALE
                  ZLEV = BLKZF( L )
               END DO ! loop on layers ambient conditions and gases

               IF ( CLDATT .AND. CFRAC_2D( COL,ROW ) .GT. 0.0 ) THEN
                  DO L = 1, NLAYS

                     IF ( CFRAC_3D( COL,ROW,L ) .GT. 0.0 ) THEN
                        CLOUDS ( L )        = .TRUE.
                        CLOUD_LAYERING( L ) = .TRUE.
                        CLDFRAC( L )        = CFRAC_3D( COL,ROW,L )
!... set hydrometeor concentrations for resolved cloud
                        MSCALE   = 1.0E+3 * DENS ( COL,ROW,L )
                        IWC( L ) = MSCALE * QI( COL,ROW,L )
                        GWC( L ) = MSCALE * QG( COL,ROW,L )
                        SWC( L ) = MSCALE * QS( COL,ROW,L )
                        LWC( L ) = MSCALE * QC( COL,ROW,L )
                        RWC( L ) = MSCALE * QR( COL,ROW,L )
                     ELSE
                        CLOUDS ( L )        = .FALSE.
                        CLOUD_LAYERING( L ) = .FALSE.
                        CLDFRAC( L )        = 0.0
                        IWC( L ) = 0.0
                        GWC( L ) = 0.0
                        SWC( L ) = 0.0
                        LWC( L ) = 0.0
                        RWC( L ) = 0.0
                     END IF
                  END DO ! loop on layers clouds
! get optical properties of resolved cloud hydrometeors
                  CALL GET_DROPLET_OPTICS( NLAYS, BLKTA, OWATER_FRAC, SEAICE_FRAC, SNOW_FRAC, LWC )
                  CALL GET_ICE_OPTICS( NLAYS, BLKTA, IWC )
                  CALL GET_AGGREGATE_OPTICS( NLAYS, RWC, SWC, GWC )
               ELSE
                  CLOUDS         = .FALSE.
                  CLOUD_LAYERING = .FALSE.
                  CLDFRAC        = 0.0
!  hydrometeor concentrations
                  LWC = 0.0
                  IWC = 0.0
                  GWC = 0.0
                  RWC = 0.0
                  SWC = 0.0
                  RWC = 0.0
                  CALL CLEAR_HYDROMETEOR_OPTICS()
               END IF

!..calculate needed aerosol properties in column

!              IF ( CORE_SHELL ) THEN
                  CALL GET_AERO_DATA ( COL,ROW, NLAYS, DENS, CGRID )
!              ELSE
!                 CALL AERO_OPTICS_INTERNAL( COL,ROW, NLAYS, CGRID )
!              END IF

! set surface albedo

               DO IWL = 1, NWL
                  ALB( IWL ) = SURFACE_ALBEDO( IWL, COL,ROW )
               END DO
!...calculate resolved-sky photolysis rates at all layers:

               NEW_PROFILE    = .TRUE.
               ONLY_SOLVE_RAD = .FALSE.

               CALL NEW_OPTICS ( JDATE, JTIME, NLAYS,
     &                           BLKTA, BLKPRS, BLKDENS, BLKZH, BLKZF,
     &                           BLKO3, BLKNO2,
     &                           ZSFC, COSZEN, SINZEN, RSQD,
     &                           NEW_PROFILE, CLOUDS, CLDFRAC,
     &                           BLKRJ_RES, TAUC_AERO, TAU_TOT, TAUO3_TOP,
     &                           TAU_RAY, SSA, TAU_CLOUD, TOTAL_O3_COLUMN )

!...load diagnostic file arrays
               ! Aerosol extinction and optical depth are saved every
               ! time step
               FORALL ( L = 1:NLAYS )
                  AERO_EXT_550( COL,ROW,L ) = 1000.0 * AERO_EXTI_550( L )
               END FORALL
               DO LEV = 1, NLAYS
                  TAU_AERO_550 ( COL,ROW ) = TAU_AERO_550 ( COL,ROW )
     &                                     + AERO_EXTI_550( LEV ) * BLKDZ( LEV )
                  TAU_ABS_AERO_550 ( COL,ROW ) = TAU_ABS_AERO_550 ( COL,ROW )
     &                                         + AERO_ABSO_550( LEV ) * BLKDZ( LEV )
               END DO

               IF ( PHOTDIAG .AND. .NOT. STRATO3_MINS_MET ) THEN
                    N_EXCEED_TROPO3( COL,ROW ) =  N_EXCEED_TROPO3( COL,ROW ) + 1.0
                    TROPO_O3_EXCEED( COL,ROW ) = TROPO_O3_COLUMN/(MAX_TROPOO3_FRAC*TOTAL_O3_COLUMN) - 1.0
     &                                         + TROPO_O3_EXCEED( COL,ROW )
               END IF

               FORALL ( IWL = 1:NWL )
                  ETOT_SFC_WL ( COL,ROW,IWL ) = IRRADIANCE( 1,IWL )
               END FORALL   

               IF ( JTIME_CHK .AND. PHOTDIAG  ) THEN
                  TOTAL_OC( COL,ROW )         = TOTAL_O3_COLUMN
                  TRANSMIS_DIFFUSE( COL,ROW ) = TRANSMISSION
                  TRANSMIS_DIRECT( COL,ROW )  = TRANS_DIRECT
                  REFLECT_COEFF( COL,ROW )    = REFLECTION


                  DO IWL = 1, NWL
                     TAUO3_TOP_WL( COL,ROW,IWL )     = TAUO3_TOP( IWL )
                     TAU_AERO_WL ( COL,ROW,IWL )     = TAUC_AERO( 1,IWL )
                     TAU_ABS_AERO( COL,ROW,IWL )     = 0.0
                     TAU_TOT_WL  ( COL,ROW,IWL )     = TAU_TOT  ( 1,IWL )
                     TAU_CLOUD_WL( COL,ROW,IWL )     = TAU_CLOUD( 1,IWL )
#ifdef phot_debug
                     SSA_CLOUD_WL( COL,ROW,IWL ) = AVE_SSA_CLD  ( IWL )
                     ASY_CLOUD_WL( COL,ROW,IWL ) = AVE_ASYMM_CLD( IWL )
#endif
                  END DO

                  DO IWL = 1, NWL
                     DO LEV = 1, NLAYS
                        TAU_ABS_AERO( COL,ROW,IWL ) = TAU_ABS_AERO( COL,ROW,IWL )
     &                                              + AERO_ABSO_COEF( LEV,IWL ) * BLKDZ( LEV )
                     END DO
                  END DO

                  DO L = 1, N_DIAG_WVL
                     IWL = DIAG_WVL( L )
                     FORALL ( LEV = 1:NLAYS_DIAG )
                        ACTINIC_FX( COL,ROW,LEV,L )  = ACTINIC_FLUX( LEV,IWL )
                        TOT_EXT ( COL,ROW,LEV,L )    = 1000.0 * EXTINCTION( LEV,IWL )
                        GAS_EXT ( COL,ROW,LEV,L )    = 1000.0 * GAS_EXTINCTION( LEV,IWL )
                        AERO_EXT( COL,ROW,LEV,L )    = 1000.0 * AERO_EXTI_COEF( LEV,IWL )
                        AERO_SCAT ( COL,ROW,LEV,L )  = 1000.0 * AERO_SCAT_COEF( LEV,IWL )
                     END FORALL
                     FORALL ( LEV = 1:NLAYS_DIAG, AERO_EXTI_COEF( LEV,IWL ) .GT. EPSLON )
                        AERO_ASYM( COL,ROW,LEV,L ) = AERO_ASYM_FAC( LEV,IWL )
                     END FORALL
                     FORALL ( LEV = 1:NLAYS_DIAG, AERO_EXTI_COEF( LEV,IWL ) .LE. EPSLON )
                        AERO_ASYM( COL,ROW,LEV,L ) = 0.0
                     END FORALL
                  END DO
                  IF ( COSZEN .LE. COS85 ) THEN 
                     ! calculate because NEW_OPTICS sets BLKDZ and TROPO_O3_COLUMN to zero
                     BLKDZ( 1 ) = BLKZF( 2 )
                     DO L = 2, NLAYS
                        BLKDZ( L ) = BLKZF( L+1 ) - BLKZF( L )
                     END DO
                     MSCALE = 1.0E-4 * CONC_TO_DU ! so units are Dobsons
                     CALL COLUMN_GAS( IGAS=LGC_O3, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=TROPO_OC )
                  ELSE
                     TROPO_OC( COL,ROW ) = TROPO_O3_COLUMN
                  END IF   
                  MSCALE = 1.0E-19 ! 100.0*10E-15*PPM_MCM3, so units are petamolecules/cm2
                  CALL COLUMN_GAS( IGAS=LGC_CO,   UNIT_FACTOR=MSCALE, COLUMN_DENSITY=CO_COLUMN   )
                  CALL COLUMN_GAS( IGAS=LGC_SO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=SO2_COLUMN  )
                  CALL COLUMN_GAS( IGAS=LGC_NO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=NO2_COLUMN  )
                  CALL COLUMN_GAS( IGAS=LGC_HCHO, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=HCHO_COLUMN )
               END IF

!Set Photolysis rates to resolved sky values
               FORALL ( L = 1:NLAYS, IPHOT = 1:NPHOTAB )
                  RJ( COL,ROW, L,IPHOT ) = 60.0 * BLKRJ_RES( L,IPHOT )
               END FORALL ! Loop on layers and NPHOTAB
               FORALL ( L = 1:NLAYS, IPHOT = 1:NPHOTAB )
                  RJ_RES( COL,ROW, L,IPHOT ) = 60.0 * BLKRJ_RES( L,IPHOT )
               END FORALL  ! Loop on layers and NPHOTAB

               IF ( USE_ACM_CLOUD ) THEN
                  IF ( ACM_CLOUDS( COL,ROW ) .GT. 0.0 ) THEN
! save resolved sky reflection and transmission coefficients for possible latter use
                     RES_SKY_REFLECT = REFLECTION
                     RES_SKY_TRANS   = TRANSMISSION
                     RES_SKY_TRANSD  = TRANS_DIRECT
!...find the highest layer of the sub-grid (convective) cloud
                     DO LEV = NLAYS, 1, -1
                        IF ( ACM_CFRAC( LEV, COL,ROW ) .GT. 0.0 ) EXIT
                     END DO
!...replace the lower layers with sub-grid cloud properties
                     DO L = 1, LEV
                        SWC( L ) = 0.0
                        IF ( ACM_CFRAC( L,COL,ROW ) .GT. 0.0 ) THEN
                           CLOUDS ( L ) = .TRUE.
                           CLDFRAC( L ) = 1.0
                           MSCALE = 1.0E+3 * DENS ( COL,ROW, L )
                           LWC( L ) = MSCALE * ACM_QC( L,COL,ROW )
                           IWC( L ) = MSCALE * ACM_QI( L,COL,ROW )
                           RWC( L ) = MSCALE * ACM_QR( L,COL,ROW )
                           GWC( L ) = MSCALE * ACM_QG( L,COL,ROW )
                        ELSE
                           CLOUDS( L )  = .FALSE.
                           CLDFRAC( L ) = 0.0
                           LWC( L )     = 0.0
                           IWC( L )     = 0.0
                           RWC( L )     = 0.0
                           GWC( L )     = 0.0
                        END IF
                        CLOUD_LAYERING( L ) = .FALSE.
                     END DO

! get optical properties of of subgrid cloud hydrometeors
                     CALL GET_DROPLET_OPTICS( LEV, BLKTA, OWATER_FRAC, SEAICE_FRAC, SNOW_FRAC, LWC )
                     CALL GET_ICE_OPTICS( LEV, BLKTA, IWC )
                     CALL GET_AGGREGATE_OPTICS( LEV, RWC, SWC, GWC )

!...calculate the acm-cloud photolysis rates for all layers:
                     NEW_PROFILE = .FALSE.
                     CALL NEW_OPTICS ( JDATE, JTIME, NLAYS,
     &                                 BLKTA, BLKPRS, BLKDENS, BLKZH, BLKZF,
     &                                 BLKO3, BLKNO2,
     &                                 ZSFC, COSZEN, SINZEN, RSQD,
     &                                 NEW_PROFILE, CLOUDS, CLDFRAC,
     &                                 BLKRJ_ACM, TAUC_AERO, TAU_TOT, TAUO3_TOP,
     &                                 TAU_RAY, SSA, TAU_CLOUD, TOTAL_O3_COLUMN )

!...load diagnostic file arrays
!...compute a cloud-fraction weighted average of ETOT_SFC and TAU_TOT
!...  note that both TAUC_AERO and TAUO3_TOP are the same for clear and
!...  cloudy regions
                     MSCALE = MAX( 1.0 - ACM_CLOUDS( COL,ROW ), 0.0 )
                     DO IWL = 1, NWL
                       ETOT_SFC_WL ( COL,ROW,IWL ) = MSCALE * ETOT_SFC_WL( COL,ROW,IWL )
     &                                             + ACM_CLOUDS( COL,ROW ) * IRRADIANCE( 1,IWL )
                     END DO

                     IF ( JTIME_CHK .AND. PHOTDIAG ) THEN

                        TRANSMIS_DIRECT( COL,ROW )  = MSCALE * TRANSMIS_DIRECT( COL,ROW )
     &                                              + ACM_CLOUDS( COL,ROW ) * TRANS_DIRECT
                        TRANSMIS_DIFFUSE( COL,ROW ) = MSCALE * TRANSMIS_DIFFUSE( COL,ROW )
     &                                              + ACM_CLOUDS( COL,ROW ) * TRANSMISSION
                        REFLECT_COEFF( COL,ROW )    = MSCALE * REFLECT_COEFF( COL,ROW )
     &                                              + ACM_CLOUDS( COL,ROW ) * REFLECTION
                        DO IWL = 1, NWL
                           TAU_TOT_WL  ( COL,ROW,IWL ) = MSCALE * TAU_TOT_WL( COL,ROW,IWL )
     &                                                 + ACM_CLOUDS( COL,ROW ) * TAU_TOT( 1,IWL )
                           TAU_CLOUD_WL( COL,ROW,IWL ) = MSCALE * TAU_CLOUD_WL( COL,ROW,IWL )
     &                                                 + ACM_CLOUDS( COL,ROW ) * TAU_CLOUD( 1,IWL )
#ifdef phot_debug
                           SSA_CLOUD_WL( COL,ROW,IWL ) = MSCALE * SSA_CLOUD_WL( COL,ROW,IWL )
     &                                                 + ACM_CLOUDS( COL,ROW ) * AVE_SSA_CLD ( IWL )
                           ASY_CLOUD_WL( COL,ROW,IWL ) = MSCALE * ASY_CLOUD_WL( COL,ROW,IWL )
     &                                                 + ACM_CLOUDS( COL,ROW ) * AVE_ASYMM_CLD( IWL )
#endif
                        END DO   ! iwl

                        DO LEV = 1, NLAYS_DIAG
                           DO L = 1, N_DIAG_WVL
                              IWL = DIAG_WVL( L )
                              TOT_EXT( COL,ROW,LEV,L )    = MSCALE * TOT_EXT( COL,ROW,LEV,L )
     &                                                    + ACM_CLOUDS( COL,ROW ) * EXTINCTION( LEV,IWL )
                              ACTINIC_FX( COL,ROW,LEV,L ) = MSCALE * ACTINIC_FX( COL,ROW,LEV,L )
     &                                                    + ACM_CLOUDS( COL,ROW ) * ACTINIC_FLUX( LEV,IWL )
                           END DO
                        END DO
                     END IF  ! photdiag
!Photolysis rates become a weighted average of the values from resolved and ACM skies
                     FORALL ( L = 1:NLAYS, IPHOT = 1:NPHOTAB )
                         RJ_SUB( COL,ROW, L, IPHOT ) = 60.0 * BLKRJ_ACM( L,IPHOT )
                         RJ( COL,ROW, L, IPHOT )     = ACM_CLOUDS( COL,ROW ) *  RJ_SUB( COL,ROW, L, IPHOT )
     &                                               + MSCALE * RJ( COL,ROW,L,IPHOT )
                     END FORALL ! Loop on layers and PHOT
                  END IF
               END IF ! not USE_ACM_CLOUD and  ACM_CLOUDS > 0

               IF ( JTIME_CHK .AND. PHOTDIAG ) THEN ! compute clear sky reflection and transmission coefficients
                  IF ( ANY( CLOUDS ) ) THEN
                     IF ( CFRAC_2D( COL,ROW ) .GT. 0.0 ) THEN ! resolved and subgrid clouds exist
                        CLOUDS         = .FALSE.
                        NEW_PROFILE    = .FALSE.
                        ONLY_SOLVE_RAD = .TRUE.
                        CALL NEW_OPTICS ( JDATE, JTIME, NLAYS,
     &                                    BLKTA, BLKPRS, BLKDENS, BLKZH, BLKZF,
     &                                    BLKO3, BLKNO2,
     &                                    ZSFC, COSZEN, SINZEN, RSQD,
     &                                    NEW_PROFILE, CLOUDS, CLDFRAC,
     &                                    BLKRJ_RES, TAUC_AERO, TAU_TOT, TAUO3_TOP,
     &                                    TAU_RAY, SSA, TAU_CLOUD, TOTAL_O3_COLUMN)
                        CLR_REFLECTION  ( COL,ROW ) = REFLECTION
                        CLR_TRANSMISSION( COL,ROW ) = TRANSMISSION
                        CLR_TRANS_DIRECT( COL,ROW ) = TRANS_DIRECT
                     ELSE ! only subgrid clouds exist
                        CLR_REFLECTION  ( COL,ROW ) = RES_SKY_REFLECT
                        CLR_TRANSMISSION( COL,ROW ) = RES_SKY_TRANS
                        CLR_TRANS_DIRECT( COL,ROW ) = RES_SKY_TRANSD
                     END IF
                  ELSE ! no cloud in vertical column
                     CLR_REFLECTION  ( COL,ROW ) = REFLECTION
                     CLR_TRANSMISSION( COL,ROW ) = TRANSMISSION
                     CLR_TRANS_DIRECT( COL,ROW ) = TRANS_DIRECT
                  END IF
               END IF

            END DO LOOP_COLS
         END DO LOOP_ROWS

      END IF
         
      ! Store PM Diagnostic AOD and extinction
      ELMO_AOD_550 = TAU_AERO_550
      ELMO_EXT_550 = AERO_EXT_550

      IF ( PHOTDIAG ) THEN
          ELMO_NO2COL  = NO2_COLUMN
          ELMO_SO2COL  = SO2_COLUMN
          ELMO_HCHOCOL = HCHO_COLUMN
          ELMO_COCOL   = CO_COLUMN
      END IF

!...report on whether stratospheric ozone column satisfies climatological minimums
      IF( N_TROPO_O3_TOGGLE .GT. 0 )THEN
         O3_TOGGLE_AVE = O3_TOGGLE_AVE / REAL( N_TROPO_O3_TOGGLE )
         WRITE( LOGDEV, 9500 )'PHOT: Exceedance of tropospheric ozone column ',
     &   'or below top of model domains based on stratospheric column minimum ',
     &   'at date and time; ', JDATE, JTIME, N_TROPO_O3_TOGGLE, (1.0/O3_TOGGLE_AVE - 1.0),
     &    (1.0/O3_TOGGLE_MIN - 1.0)
      END IF

!...write diagnostic data to output file at the end of every output tstep

      IF ( JTIME_CHK ) THEN
        IF ( PHOTDIAG ) THEN

#ifdef mpas
         if ((loc_n > 0) .and. mpas_diag) then
            time_stamp = ctm_out_clock

            oname = 'PD_AOD_W550_ANGST'
            gcount = gcount + 1
            call mio_fwrite ('CTM_OUT', oname, pname, TAU_AERO_550(:,1), TIME_STAMP)
            TAU_AERO_550 = 0.0
            oname = 'PD_TROP_O3_COLUMN'
            call mio_fwrite ('CTM_OUT', oname, pname, TROPO_OC(:,1), TIME_STAMP)
            oname = 'PD_CO_COLUMN'
            call mio_fwrite ('CTM_OUT', oname, pname, CO_COLUMN(:,1), TIME_STAMP)
            oname = 'PD_NO2_COLUMN'
            call mio_fwrite ('CTM_OUT', oname, pname, NO2_COLUMN(:,1), TIME_STAMP)
            oname = 'PD_HCHO_COLUMN'
            call mio_fwrite ('CTM_OUT', oname, pname, HCHO_COLUMN(:,1), TIME_STAMP)
            oname = 'PD_SO2_COLUMN'
            call mio_fwrite ('CTM_OUT', oname, pname, SO2_COLUMN(:,1), TIME_STAMP)
         end if
#else

         VARNM = 'COSZENS'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME,
     &                     COSINE_ZENITH ) ) THEN
             XMSG = 'Error writing variable ' // VARNM
             CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'OZONE_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TOTAL_OC ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'CO_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, CO_COLUMN ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         VARNM = 'SO2_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, SO2_COLUMN ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         VARNM = 'NO2_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, NO2_COLUMN ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         VARNM = 'HCHO_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, HCHO_COLUMN ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'TROPO_O3_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TROPO_OC ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF


         VARNM = 'TRANS_DIFFUSE'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TRANSMIS_DIFFUSE ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'TRANS_DIRECT'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TRANSMIS_DIRECT ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'REFLECTION'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, REFLECT_COEFF ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'CLR_TRANS_DIF'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, CLR_TRANSMISSION ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'CLR_TRANS_DIR'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, CLR_TRANS_DIRECT ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'CLR_REFLECTION'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, CLR_REFLECTION ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'TROPO_O3_EXCEED'
         TROPO_O3_EXCEED = TROPO_O3_EXCEED / REAL( MAX(1, TSTEP_COUNT) )
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TROPO_O3_EXCEED ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         TROPO_O3_EXCEED = 0.0 ! reset sum and counter
         TSTEP_COUNT     = 0

         VARNM = 'N_EXCEED_TROPO3'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, N_EXCEED_TROPO3 ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         N_EXCEED_TROPO3 = 0.0 ! reset counter

         VARNM = 'JNO2'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, RJ( :,:,1, LNO2 ) ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'JO3O1D'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, RJ( :,:,1,LO3O1D ) ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'RESOLVED_CFRAC'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, CFRAC_2D ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'RESOLVED_WBAR'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, AVE_HYDROMETEORS ) ) THEN
             XMSG = 'Error writing variable ' // VARNM
             CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( USE_ACM_CLOUD ) THEN
             VARNM = 'SUBGRID_CFRAC'
             IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, ACM_CLOUDS ) ) THEN
                XMSG = 'Error writing variable ' // VARNM
                CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
             END IF
             VARNM = 'SUBGRID_WBAR'
             IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, ACM_AVE_H2O ) ) THEN
                XMSG = 'Error writing variable ' // VARNM
                CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
             END IF
         END IF

         DO IWL = 1, NWL

            VARNM = 'ETOT_SFC_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, ETOT_SFC_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, ODATE, OTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'AOD_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, TAU_AERO_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'AOD_ABS_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, TAU_ABS_AERO( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'TAU_CLOUD_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, TAU_CLOUD_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

#ifdef phot_debug
            VARNM = 'SSA_CLOUD_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, SSA_CLOUD_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'ASY_CLOUD_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, ASY_CLOUD_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
#endif

            VARNM = 'TAU_TOT_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, TAU_TOT_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'TAUO3_TOP_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, TAUO3_TOP_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'ALBEDO_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME,
     &                         SURFACE_ALBEDO( IWL,:,: ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         END DO  ! iwl

         VARNM = 'AOD_W550_ANGST'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TAU_AERO_550 ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'AAOD_W550_ANGST'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TAU_ABS_AERO_550 ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &          'Photolysis Surface Summary written to', CTM_RJ_1,
     &          'for date and time', ODATE, OTIME

         DO IPHOT = 1, NPHOTAB
            OUTPUT_BUFF( 1:NCOLS,1:NROWS,1:NLAYS_DIAG ) = RJ( 1:NCOLS,1:NROWS,1:NLAYS_DIAG,IPHOT )
            IF ( .NOT. WRITE3( CTM_RJ_2, PHOTAB( IPHOT ), ODATE,
     &                         OTIME, OUTPUT_BUFF  ) ) THEN
               XMSG = 'Could not write ' // CTM_RJ_2 // ' file'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END DO

         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &          'Photolysis Rates written to', CTM_RJ_2,
     &          'for date and time', ODATE, OTIME

         VARNM = 'CFRAC_3D'
         OUTPUT_BUFF( 1:NCOLS,1:NROWS,1:NLAYS_DIAG ) = CFRAC_3D( 1:NCOLS,1:NROWS,1:NLAYS_DIAG )
         IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, OUTPUT_BUFF ) ) THEN
              XMSG = 'Could not write ' // TRIM( VARNM ) // ' to ' // CTM_RJ_3 // ' file'
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         DO L = 1, N_DIAG_WVL
            IWL = DIAG_WVL( L )

            VARNM = 'ACTINIC_FX_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, ACTINIC_FX( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'AERO_SCAT_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, AERO_SCAT( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'AERO_ASYM_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, AERO_ASYM( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'EXT_AERO_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, AERO_EXT( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'EXT_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, TOT_EXT( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'GAS_EXT_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, GAS_EXT( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END DO

         VARNM = 'EXT_AERO_W550'
         IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, AERO_EXT_550( :,:,: ) ) ) THEN
             XMSG = 'Error writing variable ' // VARNM
             CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &          'Radiative and Optical Data written to', CTM_RJ_3,
     &          'for date and time', ODATE, OTIME
#endif

        END IF   ! PHOTDIAG
      END IF   ! if JTIME_CHK
      TAU_AERO_550 = 0.0

1003  FORMAT( 8X, 'Processor ',I4.4,' is in darkness at ', I8.7, ':', I6.6,
     &        1X, 'GMT - no photolysis')
9500  FORMAT(3(/ A), I7, 1X, I6.6, 1X, / "Total Number: ", I9, ";Mean Value: ", F9.6,
     &       "; Max Value: ",F9.6 /)

95101 FORMAT('Diagnostic Output will have zero values for the column density.',
     &     / 'The lack of information does not affect model predictions.' )
      
      CONTAINS      
          SUBROUTINE COLUMN_GAS( IGAS, UNIT_FACTOR, COLUMN_DENSITY )
! Purpose: calculates column density in unit based on the value of UNIT_FACTOR
             IMPLICIT NONE
! argument:          
               INTEGER, INTENT( IN  ) :: IGAS                  ! species index in CGRID
               REAL,    INTENT( OUT ) :: COLUMN_DENSITY( :,: ) ! units determined by inputs
               REAL,    INTENT( IN  ) :: UNIT_FACTOR           ! converts from 10E6*molecules*cm-2
! local parameter:                
!               REAL, PARAMETER :: UNIT_FACTOR = 1.0E-6 * CONC_TO_DU ! unit conversion factor
               
               IF( IGAS .LE. 0 )RETURN ! assumes column_density set to zero at allocation
               
               COLUMN_DENSITY( COL,ROW ) = 0.0
               DO LEV = 1, NLAYS
                  COLUMN_DENSITY( COL,ROW ) = ( UNIT_FACTOR * BLKDENS( LEV ) )
     &                                      * CGRID( COL,ROW,LEV,IGAS  ) * BLKDZ ( LEV )
     &                                      + COLUMN_DENSITY( COL,ROW )                  
               END DO
               
          END SUBROUTINE COLUMN_GAS              
      END SUBROUTINE PHOT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_modules.f,v 1.1 2004/03/26 16:16:47 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   to provide an interface between the stencil exchange library and the
C application code
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C                    02/27/01 by David Wong
C                      -- include two use statements: use se_term_module and
C                         use se_reconfig_grid_module
C                    11/27/01 by David Wong
C                      -- include a new module: se_bndy_copy_module
C                    08/24/11 by David Wong
C                      -- include a new module: se_twoway_comm_module for
C                         the WRF-CMAQ twoway model
C --------------------------------------------------------------------------

        module se_modules

          use se_init_module
          use se_term_module

          use se_util_module

          use se_comm_module
          use se_slice_module
          use se_data_copy_module
          use se_gather_module

          use se_reconfig_grid_module

          use se_bndy_copy_module

          use se_global_max_module
          use se_global_min_module
          use se_global_sum_module

          use se_global_gather_module
          use se_global_bcast_module

          use se_twoway_comm_module

        end module se_modules

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE GETDESC( LASTCMND )

C-----------------------------------------------------------------------
C Function: To process the DESC command 
 
C Preconditions: None
  
C Key Subroutines/Functions Called: GETCHR
C                                   GETQUOTE
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI's M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
      USE UTILIO_DEFN
      USE PA_GLOBAL     ! Mech data used 
      USE PA_VARS, Only: NIRROUT
      USE PA_DEFN
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
      
C Arguments:
      CHARACTER( 16 ) :: LASTCMND  ! Previous command
                                        
C Parameters: None

C External Functions: None

C Local Variables:
      CHARACTER( 1 ) :: APOSTROPHE = "'"

C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Make sure the = sign is there
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( CHR .NE. '=' ) THEN
         WRITE( MSG, 94000 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETDESC', IZERO, IZERO, ' ', XSTAT2 )
      ELSE
         CALL GETCHR
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Check for a leading apostrophe and get the description
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( CHR .NE. APOSTROPHE ) THEN
         WRITE( MSG, 94020 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETDESC', IZERO, IZERO, ' ', XSTAT2 )
      ELSE
         CALL GETQUOTE
         IF ( LASTCMND .EQ. 'IRR_OUTPUT' ) THEN
            IRRDESC( NIRROUT ) = QUOTE
         ELSE
            WRITE( MSG, 94600 ) 
            CALL M3MESG( MSG )
            WRITE( MSG, 94500 ) LINNUM, INBUF
            CALL M3MESG( MSG )
         END IF
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Check for the ending semicolon
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( CHR .NE. ';' ) THEN
         WRITE( MSG, 94040 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETDESC', IZERO, IZERO, ' ', XSTAT2 )
      ELSE
         CALL GETCHR
         RETURN
      END IF
      
C----------------------- FORMAT Statements ----------------------------- 
      
94000 FORMAT( 'ERROR: Equal sign must follow the DESCRIPTION command' )
94020 FORMAT( 'ERROR: Apostrophe expected after the = sign in the',
     &              ' DESCRIPTION command' )
94040 FORMAT( 'ERROR: The DESCRIPTION command must be terminated by a ;' )
94500 FORMAT( '       Line No. ', I4, ': ', A )
94520 FORMAT( '       Character found: ', A )
94600 FORMAT( 'WARNING: DESCRIPTION command ignored, does not follow',
     &                ' an IRR_OUTPUT command' )

      END SUBROUTINE GETDESC

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/vdiff/acm2/matrix.F,v 1.5 2011/10/21 16:11:45 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE MATRIX1 ( KL, A, B, E, D, X )

C Rather than solving the ACM2 banded tridiagonal matrix using LU decomposition,
C it is much faster to split the solution into the ACM1 convective solver followed
C by the tridiagonal solver
C MATRIX1 is the ACM1 solver. When the PBL is convective, this solver is called
C followed by TRI. If not convective, only TRI is called.

C-- ACM1 Matrix is in this form (there is no subdiagonal:
C   B1 E2                     <- note E2 (flux from layer above), not E1
C   A2 B2 E3
C   A3    B3 E4
C   A4       B4 E5
C   A5          B5 E6
C   A6             B6

      USE VGRD_DEFN           ! vertical layer specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN

      IMPLICIT NONE

C Includes:
      INTEGER, SAVE :: N_SPC_DIFF    ! global diffusion species

C Arguments:
      INTEGER, INTENT( IN )  :: KL         ! CBL sigma height
      REAL,    INTENT( IN )  :: A( : )     ! matrix column one
      REAL,    INTENT( IN )  :: B( : )     ! diagonal
      REAL,    INTENT( IN )  :: E( : )     ! superdiagonal
      REAL,    INTENT( IN )  :: D( :,: )   ! R.H.S
      REAL,    INTENT( OUT ) :: X( :,: )   ! returned solution

C Locals:
      REAL, ALLOCATABLE, SAVE :: BETA( : )
      REAL  ALPHA, GAMA 

      INTEGER L, V, IOS

      CHARACTER( 120 ) :: XMSG = ' '
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         N_SPC_DIFF = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_DIFF
         ALLOCATE ( BETA( N_SPC_DIFF ), STAT = IOS )
         IF ( IOS .NE. 0 ) THEN
            XMSG = 'Failure allocating BETA'
            CALL M3EXIT( 'MATRIX', 0, 0, XMSG, XSTAT1 )
         END IF
      END IF   ! FIRSTIME

C-- ACM1 matrix solver

      DO V = 1, N_SPC_DIFF
         BETA( V ) = D( V,1 )
      END DO
      GAMA = B( 1 )
      ALPHA = 1.0

      DO L = 2, KL
         ALPHA = -ALPHA * E( L ) / B( L )
         DO V = 1, N_SPC_DIFF
            BETA( V ) = ALPHA * D( V,L ) + BETA( V )
         END DO
         GAMA = GAMA + ALPHA * A( L )
      END DO

      DO V = 1, N_SPC_DIFF
         X( V,1 )  = BETA( V ) / GAMA
         X( V,KL ) = ( D( V,KL ) - A( KL ) * X( V,1 ) ) / B( KL )
      END DO

C-- Back sub for Ux=y

      DO L = KL-1, 2, -1
         DO V = 1, N_SPC_DIFF
            X( V,L ) = ( D( V,L ) - A( L ) * X( V,1 ) - E( L+1 ) * X( V,L+1 ) ) / B( L )
         END DO
      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE SA_DEFN

! KWOK: Define tagging emissions, species, dimensions, etc, based on user-supplied sa_io_list
! KWOK: Created Oct 5, 2010
! 29 Oct 18 L.Zhou, S.Napelenok: update for cmaq 5.3 release
! 35 Mar 19 S.Napelenok: recode REGION handling and clean-up for release
! 10 Jun 21 G. Sarwar: Added CB6R3M
! 23 Jun 21 G. Sarwar: Replaced CB6R3M with CB6R5M
! 25 June 21 G. Sarwar: Removed CB6R3_AE6_AQ since it is not suported in CMAQ any more
! 26 Apr 22 G. Sarwar: Added DMS

      USE RUNTIME_VARS, ONLY : VOC_NOX_TRANS, ISAM_NOX_CASE, ISAM_VOC_CASE
      
      IMPLICIT NONE

      SAVE

      PUBLIC

      INTEGER ITAG

c...Tagging maps
      CHARACTER( 16 ), ALLOCATABLE :: ISAM_SPEC( :,: )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_SAtoCGR( : )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_CGRtoSA( : )
      LOGICAL, ALLOCATABLE, SAVE   :: L_ISAM_AERO( : )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_ISAMtoAERO( : )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_AEROtoSA( :,: )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_AEROGAStoSA( : )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_AEROCTRtoSA( : )
      LOGICAL, ALLOCATABLE, SAVE   :: IS_SPC_AEROSOL( :,: )
      LOGICAL, ALLOCATABLE, SAVE   :: TRANSPORT_SPC ( : )
      LOGICAL, ALLOCATABLE, SAVE   :: ISAM_SPECIES_BIAS( :,: )
      INTEGER, ALLOCATABLE, SAVE   :: STREAM_TO_TAG ( :,: )
      INTEGER, ALLOCATABLE, SAVE   :: TAGS_PER_STREAM( : )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_DIFFtoSA( : )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_ADVtoSA( : )
 
      INTEGER, ALLOCATABLE, SAVE   :: ISAM_TO_AERO( : )  ! maps tracked species to bulk concentration if aerosol species
      INTEGER, ALLOCATABLE, SAVE   :: SA_AERO_INDX( : )  ! index of tracked aerosol in ISAM concentration array

      INTEGER, ALLOCATABLE, SAVE   :: ISAM_PVO3_MAP( : ) ! potential vorticity map

      INTEGER ::     NSPC_SA_AE        ! number of tracked species that are aerosols
      INTEGER ::     N_SA_AEROSPC      ! number of unique aerospc in all tracked aerosols

      INTEGER, SAVE ::     NSPC_SA
      INTEGER, SAVE ::     NTAG_SA
      INTEGER, SAVE ::     NSPC_TRANSPORT
      INTEGER, PARAMETER :: NBIAS = 4 
      INTEGER, SAVE ::     N_VOC_BIAS
      INTEGER, SAVE ::     N_NOY_BIAS

c...Define Allocatable Apportionment Arrays
      REAL, POINTER :: ISAM  ( :,:,:,:,: )
      REAL, ALLOCATABLE :: AISAM ( :,:,:,:,: )
      REAL, ALLOCATABLE :: TOT_SADEP ( :,:,:,: )
      REAL, ALLOCATABLE :: TOT_SADEP0( :,:,:,: )
      REAL, ALLOCATABLE :: CONV_SADEP ( :,:,:,: )
      REAL, ALLOCATABLE :: SA_VDEMIS_CONV( :,:,:,:,: ) ! full emissions array mapped to diffused species
      REAL, ALLOCATABLE :: SA_VDEMIS_CONV_OTHER( :,:,:,: ) ! emissions left for 'OTHRTAG'
      REAL, ALLOCATABLE :: SA_VDEMIS_DIFF( :,:,:,:,: ) 

c...Variables regarding the tag list
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: TAGNAME( : )
      CHARACTER( 96 )                    :: TAGCLASSES = ' '
      CHARACTER( 96 ), ALLOCATABLE, SAVE :: TAGSTREAMS_TEMP( : )
      CHARACTER( 96 ), ALLOCATABLE, SAVE :: TAGSTREAMS( :, : )
      INTEGER, ALLOCATABLE, SAVE         :: TAGSTREAMS_NUM( : )

      CHARACTER( 96 ), ALLOCATABLE, SAVE :: ISAMRGN_TEMP( : )
      CHARACTER( 96 ), ALLOCATABLE, SAVE :: ISAMRGN( :, : )
      INTEGER, ALLOCATABLE, SAVE         :: ISAMRGN_NUM( : )
      INTEGER, ALLOCATABLE, SAVE         :: ISAMRGN_MAP( :, : )

c...Logical values for tagging species
      LOGICAL, SAVE :: L_EC      = .FALSE.
      LOGICAL, SAVE :: L_OC      = .FALSE.
      LOGICAL, SAVE :: L_SO4     = .FALSE.
      LOGICAL, SAVE :: L_NO3     = .FALSE.
      LOGICAL, SAVE :: L_NH4     = .FALSE.
      LOGICAL, SAVE :: L_PM25    = .FALSE.
      LOGICAL, SAVE :: L_OZONE   = .FALSE.
      LOGICAL, SAVE :: L_VOC     = .FALSE.
      LOGICAL, SAVE :: L_CL      = .FALSE.
      
      LOGICAL, SAVE :: SA_BIDI = .FALSE.

! Chemical Mechanism Lists for Populating ISAM Species Arrays
      TYPE ISAM_LIST
         CHARACTER( 16 ), ALLOCATABLE  :: LIST( : )
      END TYPE ISAM_LIST

      TYPE( ISAM_LIST ), ALLOCATABLE :: ISAM_SPEC_OZONE( : ),
     &              ISAM_SPEC_NO3( : ), ISAM_SPEC_VOC( : ),
     &              ISAM_SPEC_SO4( : ), ISAM_SPEC_HAPGAS( : ),
     &              ISAM_BIAS_VOC( : ), ISAM_BIAS_NOY( : )

! Full chemistry commented out because it produced floating
! point error in advection when using debug flags.
!     LOGICAL, SAVE :: L_CHEMISTRY

! Cloud Module variables - sln 4 june 2018
      REAL, SAVE :: DEPSUM_SAVE = 0.0
      REAL, SAVE :: DS4_SAVE    = 0.0
      REAL, SAVE :: REMOV_SAVE  = 0.0

      REAL, SAVE :: DEPSUM_AORGC_SAVE = 0.0
      REAL, SAVE :: DGLY1_SAVE        = 0.0 
      REAL, SAVE :: DMGLY1_SAVE       = 0.0  
      REAL, SAVE :: REMOV_AORGC_SAVE  = 0.0

c...Final, combined tags
      INTEGER                      :: N_SPCTAG
      INTEGER,         ALLOCATABLE :: S_SPCTAG( : )
      INTEGER,         ALLOCATABLE :: T_SPCTAG( : )
      CHARACTER( 16 ), ALLOCATABLE :: VNAM_SPCTAG( : )

C ...Tagging indices for bcon, others, icon
      INTEGER, SAVE :: BIDITAG = 0
      INTEGER, SAVE :: BCONTAG = 0
      INTEGER, SAVE :: OTHRTAG = 0
      INTEGER, SAVE :: ICONTAG = 0

      REAL, PRIVATE, ALLOCATABLE :: BUFF2( :,: )

! Diffusion module variables
      REAL, ALLOCATABLE, SAVE :: SA_DDEP( :,:,: ), SA_DDEP0( :,:,: )

! Advection module variables
      LOGICAL, ALLOCATABLE, SAVE :: BCON_SPC( : )

        INTEGER, PARAMETER, PRIVATE :: MAX_STRING     = 32  ! max length of tagclass name
        INTEGER, PARAMETER, PRIVATE :: MAX_TAGCLASSES = 200 ! max number of tagclasses
        INTEGER, PARAMETER, PRIVATE :: NUMB_CLASSES   = 19  ! number of defined tagclasses
        
        CHARACTER( MAX_STRING ), PARAMETER, PRIVATE :: DEFINED_CLASSES( NUMB_CLASSES ) = 
     & (/ 'AMMONIUM    ',
     &    'OA_TOT      ',
     &    'NVPOA       ',
     &    'CHLORINE    ',
     &    'EC          ',
     &    'SULFATE     ',
     &    'OZONE       ',
     &    'NITRATE     ',
     &    'VOC         ',
     &    'PM_IONS     ',
     &    'ALL         ',
     &    'PM_TOT      ',
     &    'HAP_GAS     ',
     &    'HAP_AERO    ',
     &    'HAP_TOT     ',
     &    'URBAN_TOXICS',
     &    'PAH_TEQ     ',
     &    'BENAPYRENE  ',
     &    'MERCURY     '/)
        
      
      CONTAINS

C============================================================

        SUBROUTINE CNT_SA_IO_LIST ( NTAGS )

C20140428  Counts the number of emissions tags in the input control file
C         Called by sa_dim.F
C
C

        USE UTILIO_DEFN     ! 20120615
c       USE HGRD_DEFN    
        USE RUNTIME_VARS, ONLY: ABFLUX, MYPE, LOGDEV
                
        IMPLICIT NONE

        CHARACTER( 16 ) :: PNAME = 'CNT_SA_IO_LIST'
        CHARACTER( 256 ) :: EQNAME 
        INTEGER INPUT_UNIT
        INTEGER IOST
        CHARACTER( 80 ) :: XMSG   
C external functions
        INTEGER LEN_TRIM

        INTEGER, INTENT( OUT ) :: NTAGS
        INTEGER ILINE
        CHARACTER( 180 ) :: TXTLINE
        
C-----------------------------------------------------------
        CALL NAMEVAL( 'SA_IOLIST', EQNAME )
        INPUT_UNIT = JUNIT()
         
        OPEN ( UNIT = INPUT_UNIT, FILE = EQNAME, STATUS = 'OLD', IOSTAT = IOST )
        XMSG = 'Error Opening ' // TRIM( EQNAME ) // ', the SA_IOLIST file'
        IF ( IOST .NE. 0 ) THEN
          CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
        ENDIF

        IF ( MYPE .EQ. 0 ) THEN        
          WRITE(LOGDEV, *) TRIM( EQNAME ) // ': Sucessfully Opened'
          WRITE(LOGDEV, *) 'Start counting the list...'
        ENDIF
        NTAGS = 0
        COUNTTAG: DO 
          READ ( INPUT_UNIT, '(A)' ) TXTLINE
          IF ( TXTLINE( 1:7 ) .EQ. 'ENDLIST' ) EXIT COUNTTAG
          IF ( TXTLINE( 1:7 ) .EQ. 'TAG NAM' ) THEN
            NTAGS = NTAGS + 1
            !IF ( MYPE .EQ. 0 ) PRINT*, TXTLINE
          ENDIF ! if tag_name
c check to see if bidirectional tag is necessary
          IF ( ABFLUX ) THEN
            IF ( INDEX( TXTLINE, 'TAG CLASSES') .GT. 0 ) THEN
              IOST = INDEX( TXTLINE,'AMMONIUM', BACK = .FALSE. )
              IF ( IOST .NE. 0 ) THEN
                SA_BIDI = .TRUE.
                NTAGS   = NTAGS + 1
              END IF
            END IF
          END IF
        ENDDO COUNTTAG

        IF ( SA_BIDI ) BIDITAG = NTAGS ! set to last tag

        CLOSE( INPUT_UNIT )

        END SUBROUTINE CNT_SA_IO_LIST
C============================================================

        SUBROUTINE RD_SA_IO_LIST ( NTAGS )

C20140428  Read entries in each emissions tag in the input control file
C         Called by sa_dim.F
C
C
C 05 Nov 2018: L.Zhou, S.Napelenok: Reorganized the control file
c 

        USE UTILIO_DEFN 
        USE RUNTIME_VARS, ONLY: ABFLUX, MYPE, LOGDEV

        IMPLICIT NONE
C arguments
        INTEGER, INTENT( IN ) :: NTAGS

        CHARACTER( 16 )    :: PNAME = 'RD_SA_IO_LIST'
        CHARACTER( 256 )   :: EQNAME 
        INTEGER INPUT_UNIT
        INTEGER IOST
        CHARACTER( 120 ) :: XMSG   
C external functions
        INTEGER LEN_TRIM

        INTEGER ILINE
        INTEGER ITAG, TAGLOOP
        CHARACTER( 128 ) :: TXTLINE

C...multi-sectors-for-a-single-tag 20130702
        INTEGER ISGSTK
        CHARACTER( 2 )  :: CSGSTK
        CHARACTER( 16 ) :: FNAME
        INTEGER DELIMINATOR_INDEX 
        INTEGER BGN_SG
        INTEGER I, J ,k
        CHARACTER(1) :: CHR

C-----------------------------------------------------------
        CALL NAMEVAL( 'SA_IOLIST', EQNAME )
        INPUT_UNIT = JUNIT()

        OPEN ( UNIT = INPUT_UNIT, FILE = EQNAME, STATUS = 'OLD', IOSTAT = IOST )
        XMSG = 'Error Opening ' // TRIM( EQNAME ) // ', the SA_IOLIST file'
        IF ( IOST .NE. 0 ) THEN
          CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
        ENDIF

        CHR = CHAR(124)
101     READ ( INPUT_UNIT, '(A)' ) TXTLINE
        IF ( TXTLINE(1:3) .EQ. '!!!' .OR. TXTLINE(1:3) .EQ. '' ) GOTO 101
        IF( INDEX( TXTLINE, 'TAG CLASSES' ) .GE. 1 )THEN
           DELIMINATOR_INDEX = INDEX( TXTLINE, CHAR( 124 ) ) + 1
           IF(  DELIMINATOR_INDEX .LE. 1 )THEN
              XMSG = 'ISAM ERROR: TAG CLASSES line missing the "|" deliminator'
              CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
           END IF 
           TAGCLASSES = TXTLINE( DELIMINATOR_INDEX:LEN_TRIM( TXTLINE ) )
           IF( LEN_TRIM( TAGCLASSES ) .LT. 1 )THEN
              XMSG = "ISAM ERROR: TAGCLASSES in control file is blank. "
              CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
           END IF
        ELSE   
           XMSG = "ISAM ERROR: First Nonblank or Noncomment line "
     &         // "in control file must define TAG CLASSES. "
           CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
        END IF

        IF ( MYPE .eq. 0 ) then
          WRITE(LOGDEV, *) 'Reading ISAM control file'
          WRITE(LOGDEV, *) 'TAGCLASSES = ',TRIM(TAGCLASSES)
          WRITE(LOGDEV, *) '  for ', NTAGS, ' tags'
        ENDIF

        IF ( SA_BIDI ) THEN
          TAGLOOP = NTAGS -1
        ELSE
          TAGLOOP = NTAGS
        ENDIF

        DO ITAG = 1, ( TAGLOOP )
        
          TAGNAME( ITAG )         = ' '
          ISAMRGN_TEMP( ITAG )    = ' '
          TAGSTREAMS_TEMP( ITAG ) = ' '
          
102       READ ( INPUT_UNIT, '(A)' ) TXTLINE
          IF ( TXTLINE(1:3) .EQ. '!!!' .OR. TXTLINE(1:3) .EQ. '' ) GOTO 102
          IF( INDEX( TXTLINE, 'TAG NAME' ) .GE. 1 )THEN
              DELIMINATOR_INDEX = INDEX( TXTLINE, CHAR( 124 ) ) + 1
              IF(  DELIMINATOR_INDEX .LE. 1 )THEN
                 XMSG = 'ISAM ERROR: "TAG NAME" line missing the "|" deliminator'
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF 
              TAGNAME( ITAG ) = TXTLINE( DELIMINATOR_INDEX:LEN_TRIM( TXTLINE ) )
              IF( LEN_TRIM( TAGNAME( ITAG ) ) .LT. 1 )THEN
                 XMSG = 'ISAM ERROR: a "TAG NAME" in control file is blank. '
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF
              IF( INDEX( TAGNAME( ITAG ), "_", BACK = .FALSE. ) .GT. 0 )THEN
                 XMSG = 'ISAM ERROR: TAG NAME: ' // TRIM( TAGNAME( ITAG ) ) 
     &               // ' cannot use the underscore character.'
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF
          ELSE   
              XMSG = "ISAM ERROR: First line defining a TAG "
     &            // 'in control file must contain the "TAG NAME" ' 
              CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
          END IF

103       READ ( INPUT_UNIT, '(A)' ) TXTLINE
          IF ( TXTLINE(1:3) .EQ. '!!!' .OR. TXTLINE(1:3) .EQ. '' ) GOTO 103
          IF( INDEX( TXTLINE, 'REGION' ) .GE. 1 )THEN
              DELIMINATOR_INDEX = INDEX( TXTLINE, CHAR( 124 )  ) + 1
              IF(  DELIMINATOR_INDEX .LE. 1 )THEN
                 XMSG = 'ISAM ERROR: a "REGION(s)" line missing the "|" deliminator'
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF 
              ISAMRGN_TEMP( ITAG ) = TXTLINE( DELIMINATOR_INDEX:LEN_TRIM( TXTLINE ) )
              IF( LEN_TRIM( ISAMRGN_TEMP( ITAG ) ) .LT. 1 )THEN
                 XMSG = 'ISAM ERROR: a "REGION(s)" in control file is blank. '
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF
          ELSE   
              XMSG = "ISAM ERROR: Second line defining a TAG "
     &            // 'in control file must contain the "REGION(s)" ' 
              CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
          END IF

104       READ ( INPUT_UNIT, '(A)' ) TXTLINE
          IF ( TXTLINE(1:3) .EQ. '!!!' .OR. TXTLINE(1:3) .EQ. '' ) GOTO 104
          IF( INDEX( TXTLINE, 'EMIS STREAM' ) .GE. 1 )THEN
              DELIMINATOR_INDEX = INDEX( TXTLINE, CHAR( 124 )  ) + 1
              IF(  DELIMINATOR_INDEX .LE. 1 )THEN
                 XMSG = 'ISAM ERROR: a "EMIS STREAM(s)" line missing the "|" deliminator'
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF 
              TAGSTREAMS_TEMP( ITAG ) = TXTLINE( DELIMINATOR_INDEX:LEN_TRIM( TXTLINE ) )
              IF( LEN_TRIM( TAGSTREAMS_TEMP( ITAG ) ) .LT. 1 )THEN
                 XMSG = 'ISAM ERROR: a "EMIS STREAM(s)" in control file is blank. '
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF
          ELSE   
              XMSG = "ISAM ERROR: Third line defining a TAG "
     &            // 'in control file must contain the "EMIS STREAM(s)" ' 
              CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
          END IF

        END DO
        
c add a bidirectional tag if necesssary
        IF ( SA_BIDI ) THEN
          TAGNAME( NTAGS )         = 'BID' 
          ISAMRGN_TEMP( NTAGS )    = 'EVERYWHERE'
          TAGSTREAMS_TEMP( NTAGS ) = 'BIDIRECTIONALNH3'
        ENDIF

        END SUBROUTINE RD_SA_IO_LIST
C============================================================
        
        SUBROUTINE GET_NSPC_SA ()

C20140428  Determine number of ISAM species
C         Called by sa_dim.F
C

        USE RUNTIME_VARS
        USE RXNS_DATA,  ONLY : MECHNAME  !Get Chemical Mechanism Name
        USE CGRID_SPCS, ONLY : NSPCSD, CGRID_NAME, N_AE_SPC, AE_SPC,
     &                         N_NR_SPC, NR_SPC, CGRID_MASK_GAS,
     &                         CGRID_MASK_NR 

        USE AERO_DATA
        USE SOA_DEFN
        USE UTILIO_DEFN

        IMPLICIT NONE

        INTEGER :: ITAG, IMECH, IAERO, JAERO, ISPEC, IMODE
        INTEGER :: I, J, K
        INTEGER :: N_ISAM_MECH, NVL_RESET

        LOGICAL,         ALLOCATABLE  :: MERCURY_MECH ( : )
        CHARACTER( 32 ), ALLOCATABLE  :: ISAM_MECHLIST( : )

        TYPE( ISAM_LIST ) :: ISAM_SPEC_HAPAERO, ISAM_SPEC_TOXICS,
     &                       ISAM_SPEC_PAHTEQ,  ISAM_SPEC_MERCURY

        LOGICAL :: EFLAG          = .FALSE. 
        LOGICAL :: FOUND_SPECIES  = .FALSE.
        INTEGER :: CLASSES_FOUND  = 0
        
        CHARACTER( 400 ) :: XMSG
        CHARACTER( 16 )  :: GASNAME, CTRNAME

        INTEGER :: IOST
        CHARACTER( MAX_STRING ), ALLOCATABLE :: CLASS_NAMES( : )
        INTEGER :: NCLASSES = 0
        
c----------------------------------------------------------

        N_ISAM_MECH = 6
        ALLOCATE( ISAM_MECHLIST( N_ISAM_MECH ),   MERCURY_MECH ( N_ISAM_MECH ),
     &            ISAM_SPEC_OZONE( N_ISAM_MECH ), ISAM_SPEC_VOC( N_ISAM_MECH ), 
     &            ISAM_SPEC_NO3  ( N_ISAM_MECH ), ISAM_SPEC_SO4( N_ISAM_MECH ), 
     &            ISAM_SPEC_HAPGAS( N_ISAM_MECH ),
     &            ISAM_BIAS_VOC( N_ISAM_MECH ),   ISAM_BIAS_NOY( N_ISAM_MECH ) )

       
        ISAM_MECHLIST = (/'CB6R5_AE7_AQ      ', 'CB6R5M_AE7_AQ     ', 
     &                    'SAPRC07TC_AE6_AQ  ', 'SAPRC07TIC_AE7I_AQ', 
     &                    'CRACMM2           ', 'CRACMM3           '/ )  

        MERCURY_MECH = (/  .TRUE.,  .TRUE.,
     &                     .FALSE., .FALSE., 
     &                     .FALSE., .FALSE. / )  

        ! Detect Mechanism Number
        IMECH = INDEX1( MECHNAME, N_ISAM_MECH, ISAM_MECHLIST )

        ! When Prescribing Species for Ozone, Nitrate and VOCs, do not
        ! worry about double-counting. The algorithm will look for each
        ! species in the ISAM_SPEC array before adding it. Put all of
        ! the species in each category that you think you will need.

        ! PRESCRIBE OZONE SPECIES
        DO J = 1,N_ISAM_MECH
          ALLOCATE( ISAM_SPEC_OZONE( J )%LIST( 4 ) )
        END DO
        !CB6R5_AE7_AQ
        ISAM_SPEC_OZONE( 1 )%LIST = (/'O3 ','O1D','HO2','O  '/)
        
        !CB6R5M_AE7_AQ
        ISAM_SPEC_OZONE( 2 )%LIST = (/'O3 ','O1D','HO2','O  '/)
        
        !SAPRC07TC_AE6_AQ
        ISAM_SPEC_OZONE( 3 )%LIST = (/'O3 ','O1D','HO2','O3P'/)
        
        !SAPRC07TIC_AE7I_AQ
        ISAM_SPEC_OZONE( 4 )%LIST = (/'O3 ','O1D','HO2','O3P'/)
        
        !CRACMM2
        ISAM_SPEC_OZONE( 5 )%LIST = (/'O3 ','O1D','HO2','O3P'/)

        !CRACMM3
        ISAM_SPEC_OZONE( 6 )%LIST = (/'O3 ','O1D','HO2','O3P'/)

        ! PRESCRIBE VOC SPECIES
        !CB6R5_AE7_AQ
        ALLOCATE( ISAM_SPEC_VOC( 1 )%LIST( 28 ) )
        ISAM_SPEC_VOC( 1 )%LIST = (/'ALD2   ','ALDX   ','ETH    ',
     &          'ETHA   ','ETOH   ','FORM   ','IOLE   ','ISOP   ',
     &          'MEOH   ','OLE    ','PAR    ','TERP   ','TOL    ',
     &          'XYLMN  ','NAPH   ','ETHY   ','PRPA   ','ACET   ',
     &          'KET    ','GLY    ','BENZENE','GLYD   ','MEPX   ',
     &          'APIN   ','SOAALK ','ECH4   ','CO     ','MGLY   '/)

        !CB6R5M_AE7_AQ
        ALLOCATE( ISAM_SPEC_VOC( 2 )%LIST( 28 ) )
        ISAM_SPEC_VOC( 2 )%LIST = (/'ALD2   ','ALDX   ','ETH    ',
     &          'ETHA   ','ETOH   ','FORM   ','IOLE   ','ISOP   ',
     &          'MEOH   ','OLE    ','PAR    ','TERP   ','TOL    ',
     &          'XYLMN  ','NAPH   ','ETHY   ','PRPA   ','ACET   ',
     &          'KET    ','GLY    ','BENZENE','GLYD   ','MEPX   ',
     &          'APIN   ','SOAALK ','ECH4   ','CO     ','MGLY   '/)

        !SAPRC07TC_AE6_AQ
        ALLOCATE( ISAM_SPEC_VOC( 3 )%LIST( 41 ) )
        ISAM_SPEC_VOC( 3 )%LIST = (/'HCHO       ','CCHO       ',
     &  'RCHO       ','xHCHO      ','xCCHO      ','xRCHO      ',
     &  'ALK1       ','ALK2       ','ALK3       ','ALK4       ',
     &  'ALK5       ','ETHENE     ','ACETYLENE  ','PROPENE    ',
     &  'ISOPRENE   ','TERP       ','SESQ       ','APIN       ',
     &  'OLE1       ','OLE2       ','ETOH       ','MEOH       ',
     &  'GLY        ','MGLY       ','BENZENE    ','TMBENZ124  ',
     &  'TOLUENE    ','MXYL       ','OXYL       ','PXYL       ',
     &  'NAPHTHAL   ','ARO1       ','ARO2MN     ','BUTADIENE13',
     &  'ACROLEIN   ','ACETONE    ','MEK        ','MVK        ',
     &  'MACR       ','SOAALK     ','CO         '/ )

        !SAPRC07TIC_AE7I_AQ
        ALLOCATE( ISAM_SPEC_VOC( 4 )%LIST( 41 ) )
        ISAM_SPEC_VOC( 4 )%LIST = (/'HCHO       ','CCHO       ',
     &  'RCHO       ','xHCHO      ','xCCHO      ','xRCHO      ',
     &  'ALK1       ','ALK2       ','ALK3       ','ALK4       ',
     &  'ALK5       ','ETHENE     ','ACETYLENE  ','PROPENE    ',
     &  'ISOPRENE   ','TERP       ','SESQ       ','APIN       ',
     &  'OLE1       ','OLE2       ','ETOH       ','MEOH       ',
     &  'GLY        ','MGLY       ','BENZENE    ','TMBENZ124  ',
     &  'TOLUENE    ','MXYL       ','OXYL       ','PXYL       ',
     &  'NAPHTHAL   ','ARO1       ','ARO2MN     ','BUTADIENE13',
     &  'ACROLEIN   ','ACETONE    ','MEK        ','MVK        ',
     &  'MACR       ','SOAALK     ','CO         '/ )

        !CRACMM2
        ALLOCATE( ISAM_SPEC_VOC( 5 )%LIST( 98 ) )
        ISAM_SPEC_VOC( 5 )%LIST = (/'ACD       ','ACE       ','ACRO      ',
     &    'ACT       ','ALD       ','API       ','BALD      ','BDE13     ',
     &    'BEN       ','CSL       ','DCB1      ','DCB2      ','DCB3      ',
     &    'EBZ       ','ELHOM     ','EOH       ','ETE       ','ETEG      ',
     &    'ETH       ','FURAN     ','FURANONE  ','GLY       ','HOM       ',
     &    'HC3       ','HC5       ','HC10      ','HCHO      ','HKET      ',
     &    'HONIT     ','IEPOX     ','ISHP      ','IPX       ','ISO       ',
     &    'KET       ','LIM       ','LIMAL     ','MACR      ','MAHP      ',
     &    'MCT       ','MEK       ','MGLY      ','MOH       ','MVK       ',
     &    'NAPH      ','OLI       ','OLT       ','OP1       ','OP2       ',
     &    'OP3       ','OPB       ','ORA1      ','ORA2      ','PINAL     ',
     &    'PHEN      ','PROG      ','ROH       ','SESQ      ','SLOWROC   ',
     &    'STY       ','TOL       ','UALD      ','XYL       ','PAA       ',
     &    'PAN       ','PPN       ','MPAN      ','ONIT      ','ISON      ',
     &    'TRPN      ','VROCIOXY  ','VROCP5ARO ','VROCP6ARO ','VROCN2ALK ',
     &    'VROCN1ALK ','VROCP0ALK ','VROCP1ALK ','VROCP2ALK ','VROCP3ALK ',
     &    'VROCP4ALK ','VROCP5ALK ','VROCP6ALK ','VROCN2OXY2','VROCN2OXY4',
     &    'VROCN2OXY8','VROCN1OXY1','VROCN1OXY3','VROCN1OXY6','VROCP0OXY2',
     &    'VROCP0OXY4','VROCP1OXY1','VROCP1OXY3','VROCP2OXY2','VROCP3OXY2',
     &    'VROCP4OXY2','VROCP5OXY1','VROCP6OXY1','ECH4      ','CO        '/ )

        !CRACMM3
        ALLOCATE( ISAM_SPEC_VOC( 10 )%LIST( 98 ) )
        ISAM_SPEC_VOC( 10 )%LIST = (/'ACD       ','ACE       ','ACRO      ',
     &    'ACT       ','ALD       ','API       ','BALD      ','BDE13     ',
     &    'BEN       ','CSL       ','DCB1      ','DCB2      ','DCB3      ',
     &    'EBZ       ','ELHOM     ','EOH       ','ETE       ','ETEG      ',
     &    'ETH       ','FURAN     ','FURANONE  ','GLY       ','HOM       ',
     &    'HC3       ','HC5       ','HC10      ','HCHO      ','HKET      ',
     &    'HONIT     ','IEPOX     ','ISHP      ','IPX       ','ISO       ',
     &    'KET       ','LIM       ','LIMAL     ','MACR      ','MAHP      ',
     &    'MCT       ','MEK       ','MGLY      ','MOH       ','MVK       ',
     &    'NAPH      ','OLI       ','OLT       ','OP1       ','OP2       ',
     &    'OP3       ','OPB       ','ORA1      ','ORA2      ','PINAL     ',
     &    'PHEN      ','PROG      ','ROH       ','SESQ      ','SLOWROC   ',
     &    'STY       ','TOL       ','UALD      ','XYL       ','PAA       ',
     &    'PAN       ','PPN       ','MPAN      ','ONIT      ','ISON      ',
     &    'TRPN      ','VROCIOXY  ','VROCP5ARO ','VROCP6ARO ','VROCN2ALK ',
     &    'VROCN1ALK ','VROCP0ALK ','VROCP1ALK ','VROCP2ALK ','VROCP3ALK ',
     &    'VROCP4ALK ','VROCP5ALK ','VROCP6ALK ','VROCN2OXY2','VROCN2OXY4',
     &    'VROCN2OXY8','VROCN1OXY1','VROCN1OXY3','VROCN1OXY6','VROCP0OXY2',
     &    'VROCP0OXY4','VROCP1OXY1','VROCP1OXY3','VROCP2OXY2','VROCP3OXY2',
     &    'VROCP4OXY2','VROCP5OXY1','VROCP6OXY1','ECH4      ','CO        '/ )

        !PRESCRIBE NITRATE SPECIES
        !CB6R5_AE7_AQ
        ALLOCATE( ISAM_SPEC_NO3( 1 )%LIST( 22 ) )
        ISAM_SPEC_NO3( 1 )%LIST = (/'HNO3 ','NO   ','NO2  ','NO3  ',
     &      'HONO ','N2O5 ','PAN  ','XO2N ','NTR1 ','NTR2 ','INTR ',
     &      'PNA  ','PANX ','CLNO2','CLNO3','XO2  ','XO2H ','MEO2 ',
     &      'ISO2 ','C2O3 ','CXO3 ','ROR  '/ )
        
        !CB6R5M_AE7_AQ
        ALLOCATE( ISAM_SPEC_NO3( 2 )%LIST( 27 ) )
        ISAM_SPEC_NO3( 2 )%LIST = (/'HNO3 ','NO   ','NO2  ','NO3  ',
     &      'HONO ','N2O5 ','PAN  ','XO2N ','NTR1 ','NTR2 ','INTR ',
     &      'PNA  ','PANX ','CLNO2','CLNO3','BRNO2','BRNO3','INO  ',
     &      'INO2 ','INO3 ','XO2  ','XO2H ','MEO2 ','ISO2 ','C2O3 ',
     &      'CXO3 ','ROR  '/ )

        !SAPRC07TC_AE6_AQ
        ALLOCATE( ISAM_SPEC_NO3( 3 )%LIST( 25 ) )
        ISAM_SPEC_NO3( 3 )%LIST = (/'HNO3  ','NO    ','NO2   ','NO3   ',
     &   'HONO  ','N2O5  ','PAN   ','HNO4  ','RNO3  ','PAN2  ','CLNO  ',
     &   'CLONO ','CLONO2','xNO2  ','MEO2  ','xMEO2 ','RO2C  ','RO2XC ',
     &   'MECO3 ','xMECO3','RCO3  ','xRCO3 ','BZCO3 ','PBZN  ','MACO3 '/ )

        !SAPRC07TIC_AE7I_AQ
        ALLOCATE( ISAM_SPEC_NO3( 4 )%LIST( 40 ) )
        ISAM_SPEC_NO3( 4 )%LIST = (/'HNO3    ','NO      ','NO2     ',
     &        'NO3     ','HONO    ','N2O5    ','PAN     ','HNO4    ',
     &        'RNO3    ','PAN2    ','CLNO    ','CLONO   ','CLONO2  ',
     &        'ETHLN   ','IMAE    ','IMAPAN  ','ISOPNN  ','MACRN   ',
     &        'NIT1    ','MVKN    ','PROPNN  ','MTNO3   ','xNO2    ',
     &        'MEO2    ','xMEO2   ','RO2C    ','RO2XC   ','MECO3   ',
     &        'xMECO3  ','RCO3    ','xRCO3   ','BZCO3   ','PBZN    ',
     &        'MACO3   ','TERPNRO2','ISOPO2  ','NISOPO2 ','MVKOO   ',
     &        'MACROO  ','RNO3I   '/)

        !CRACMM2
        ALLOCATE( ISAM_SPEC_NO3( 5 )%LIST( 27 ) )
        ISAM_SPEC_NO3( 5 )%LIST = (/   'HNO3 ','NO   ','NO2  ','NO3  ','HONO ',
     &         'N2O5 ','PAN  ','HNO4 ','ONIT ','MPAN ','PPN  ','ISON ','TRPN ',
     &         'INALD','ACO3 ','MO2  ','HC3P ','HC5P ','HC10P','KETP ','ISOP ',
     &         'ETHP ','RCO3 ','XYLP ','TR2  ','BENP ','ETEP '/ )
       
        !CRACMM3
        ALLOCATE( ISAM_SPEC_NO3( 6 )%LIST( 27 ) )
        ISAM_SPEC_NO3( 6 )%LIST = (/   'HNO3 ','NO   ','NO2  ','NO3  ','HONO ',
     &         'N2O5 ','PAN  ','HNO4 ','ONIT ','MPAN ','PPN  ','ISON ','TRPN ',
     &         'INALD','ACO3 ','MO2  ','HC3P ','HC5P ','HC10P','KETP ','ISOP ',
     &         'ETHP ','RCO3 ','XYLP ','TR2  ','BENP ','ETEP '/ )
 
        !PRESCRIBE SPECIES RELEVANT FOR ASSIGNING BIAS TO VOCs
        !CB6R5_AE7_AQ
        ALLOCATE( ISAM_BIAS_VOC( 1 )%LIST( 10 ) )
        ISAM_BIAS_VOC( 1 )%LIST = (/'ALD2','ALDX','FORM','ACET',
     &                'KET ','XO2 ','XO2H','ISO2','C2O3','CXO3'/ )
        
        !CB6R5M_AE7_AQ
        ALLOCATE( ISAM_BIAS_VOC( 2 )%LIST( 10 ) )
        ISAM_BIAS_VOC( 2 )%LIST = (/'ALD2','ALDX','FORM','ACET',
     &                'KET ','XO2 ','XO2H','ISO2','C2O3','CXO3'/ )

        !SAPRC07TC_AE6_AQ
        ALLOCATE( ISAM_BIAS_VOC( 3 )%LIST( 12 ) )
        ISAM_BIAS_VOC( 3 )%LIST = (/'HCHO    ','CCHO    ','RCHO    ',
     &        'xHCHO   ','xCCHO   ','xRCHO   ','ACROLEIN','ACETONE ',
     &        'MECO3   ','xMECO3  ','RCO3    ','xRCO3   '/ )

        !SAPRC07TIC_AE7I_AQ
        ALLOCATE( ISAM_BIAS_VOC( 4 )%LIST( 14 ) )
        ISAM_BIAS_VOC( 4 )%LIST = (/'HCHO    ','CCHO    ','RCHO    ',
     &        'xHCHO   ','xCCHO   ','xRCHO   ','ACROLEIN','ACETONE ',
     &        'RO2C    ','RO2XC   ','MECO3   ','xMECO3  ','RCO3    ',
     &        'xRCO3   '/ )
        
        !CRACMM2
        ALLOCATE( ISAM_BIAS_VOC( 5 )%LIST( 12 ) )
        ISAM_BIAS_VOC( 5 )%LIST = (/'HCHO ','ACD  ','ALD  ','UALD ',
     &      'KET  ','ACO3 ','HC3P ','HC5P ','HC10P','ISOP ','RCO3 ',
     &      'XYLP '/ )

        !CRACMM3
        ALLOCATE( ISAM_BIAS_VOC( 6 )%LIST( 12 ) )
        ISAM_BIAS_VOC( 6 )%LIST = (/'HCHO ','ACD  ','ALD  ','UALD ',
     &      'KET  ','ACO3 ','HC3P ','HC5P ','HC10P','ISOP ','RCO3 ',
     &      'XYLP '/ )

        !PRESCRIBE SPECIES RELEVANT FOR ASSIGNING BIAS TO NOx EMISSIONS
        !CB6R5_AE7_AQ
        ALLOCATE( ISAM_BIAS_NOY( 1 )%LIST( 6 ) )
        ISAM_BIAS_NOY( 1 )%LIST = (/'HNO3','NO  ','NO2 ','NO3 ',
     &                              'HONO','N2O5'/ )

        !CB6R5M_AE7_AQ
        ALLOCATE( ISAM_BIAS_NOY( 2 )%LIST( 6 ) )
        ISAM_BIAS_NOY( 2 )%LIST = (/'HNO3','NO  ','NO2 ','NO3 ',
     &                              'HONO','N2O5'/ )

        !SAPRC07TC_AE6_AQ
        ALLOCATE( ISAM_BIAS_NOY( 3 )%LIST( 6 ) )
        ISAM_BIAS_NOY( 3 )%LIST = (/'HNO3','NO  ','NO2 ','NO3 ',
     &                              'HONO','N2O5'/ )

        !SAPRC07TIC_AE7I_AQ
        ALLOCATE( ISAM_BIAS_NOY( 4 )%LIST( 7 ) )
        ISAM_BIAS_NOY( 4 )%LIST = (/'HNO3','NO  ','NO2 ','NO3 ',
     &                              'HONO','N2O5','xNO2'/ )

        !CRACMM2
        ALLOCATE( ISAM_BIAS_NOY( 5 )%LIST( 6 ) )
        ISAM_BIAS_NOY( 5 )%LIST = (/'HNO3','NO  ','NO2 ','NO3 ',
     &                              'HONO','N2O5' / )

        !CRACMM3
        ALLOCATE( ISAM_BIAS_NOY( 6 )%LIST( 6 ) )
        ISAM_BIAS_NOY( 6 )%LIST = (/'HNO3','NO  ','NO2 ','NO3 ',
     &                              'HONO','N2O5' / )

        !PRESCRIBE SULFATE SPECIES
        !CB6R5_AE7_AQ
        ALLOCATE( ISAM_SPEC_SO4( 1 )%LIST( 1 ) )
        ISAM_SPEC_SO4( 1 )%LIST = (/'SO2', 'DMS'/ )
        
        !CB6R5M_AE7_AQ
        ALLOCATE( ISAM_SPEC_SO4( 2 )%LIST( 2 ) )
        ISAM_SPEC_SO4( 2 )%LIST = (/'SO2','DMS'/ )

        !SAPRC07TC_AE6_AQ
        ALLOCATE( ISAM_SPEC_SO4( 3 )%LIST( 1 ) )
        ISAM_SPEC_SO4( 3 )%LIST = (/'SO2'/ )

        !SAPRC07TIC_AE7I_AQ
        ALLOCATE( ISAM_SPEC_SO4( 4 )%LIST( 1 ) )
        ISAM_SPEC_SO4( 4 )%LIST = (/'SO2'/ )

        !CRACMM2
        ALLOCATE( ISAM_SPEC_SO4( 5 )%LIST( 1 ) )
        ISAM_SPEC_SO4( 5 )%LIST = (/'SO2'/ )

        !CRACMM3
        ALLOCATE( ISAM_SPEC_SO4( 6 )%LIST( 1 ) )
        ISAM_SPEC_SO4( 6 )%LIST = (/'SO2'/ )

        !PRESCRIBE HAP SPECIES
        !CB6R5_AE7_AQ
        ALLOCATE( ISAM_SPEC_HAPGAS( 1 )%LIST( 7 ) )
        ISAM_SPEC_HAPGAS( 1 )%LIST = (/'FORM_PRIMARY','ALD2_PRIMARY',
     &                  'ACROLEIN    ','BUTADIENE13 ','ACRO_PRIMARY',
     &                  'TOLU        ','CL2         '/)

        !CB6R5M_AE7_AQ
        ALLOCATE( ISAM_SPEC_HAPGAS( 2 )%LIST( 7 ) )
        ISAM_SPEC_HAPGAS( 2 )%LIST = (/'FORM_PRIMARY','ALD2_PRIMARY',
     &                  'ACROLEIN    ','BUTADIENE13 ','ACRO_PRIMARY',
     &                  'TOLU        ','CL2         '/)

        !SAPRC07TC_AE6_AQ
        ALLOCATE( ISAM_SPEC_HAPGAS( 3 )%LIST( 6 ) )
        ISAM_SPEC_HAPGAS( 3 )%LIST = (/'HCHO_PRIMARY','CCHO_PRIMARY',
     &                  'ACROLEIN    ','BUTADIENE13 ','ACRO_PRIMARY',
     &                  'CL2         '/)

        !SAPRC07TIC_AE7I_AQ
        ALLOCATE( ISAM_SPEC_HAPGAS( 4 )%LIST( 6 ) )
        ISAM_SPEC_HAPGAS( 4 )%LIST = (/'HCHO_PRIMARY','CCHO_PRIMARY',
     &                  'ACROLEIN    ','BUTADIENE13 ','ACRO_PRIMARY',
     &                  'CL2         '/)

        !CRACMM2
        ALLOCATE( ISAM_SPEC_HAPGAS( 5 )%LIST( 1 ) )
        ISAM_SPEC_HAPGAS( 5 )%LIST = (/'HCHO        '/)

        !CRACMM3
        ALLOCATE( ISAM_SPEC_HAPGAS( 6 )%LIST( 1 ) )
        ISAM_SPEC_HAPGAS( 6 )%LIST = (/'HCHO        '/)

        !AEROSOL HAPS
        ALLOCATE( ISAM_SPEC_HAPAERO%LIST( 14 ) )
        ISAM_SPEC_HAPAERO%LIST = (/'ANI     ','ACR_VI  ','ACR_III ','ABE     ',
     &                             'APB     ','ADE_OTHR','ADE_EC  ','ADE_OC  ',
     &                             'ADE_NO3 ','ADE_SO4 ','ADE_CORS','ACADMIUM',
     &                             'AMN_HAPS','AAS     ' /)

        !NONREACTIVE TEQ TRACERS for Polycylic Aromatic Hydrocarbons
        ALLOCATE( ISAM_SPEC_PAHTEQ%LIST( 9 ) )
        ISAM_SPEC_PAHTEQ%LIST = ( /'PAH_000E0','PAH_176E5','PAH_880E5','PAH_176E4',
     &                             'PAH_176E3','PAH_192E3','PAH_101E2','PAH_176E2',
     &                             'PAH_114E1'/)   

       ALLOCATE( ISAM_SPEC_TOXICS%LIST( 30 ) )
       ISAM_SPEC_TOXICS%LIST( 1:30 ) = (/'ACRY_NITRILE','CARBONTET   ','PROPYL_DICL ',
     &     'DICL_PROPENE','CL4_ETHANE  ','CHCL3       ','BR2_C2_12   ','CL2_C2_12   ',
     &     'ETOX        ','ACET_NITRILE','XYLENE      ','STYRENE     ','ACRYACID    ',
     &     'HEXANE      ','METHCHLORIDE','CARBSULFIDE ','CHLOROPRENE ','ETHYLBENZENE',
     &     'HEXMETH_DIS ','HYDRAZINE   ','MAL_ANHYDRID','CL_ETHE     ','NAPHTHALENE ',
     &     'QUINOLINE   ','TOL_DIIS    ','TRIETHYLAMIN','DICL_BENZENE','CL2_ME      ',
     &     'CL4_ETHE    ','CL3_ETHE    '/)


        ALLOCATE( ISAM_SPEC_MERCURY%LIST( 4 ) )
        ISAM_SPEC_MERCURY%LIST = ( /'HG       ','HGIIGAS  ', 'HGIIAER  ',
     &                              'APHG     '/)
 
 
        ! Allocate Vectors for Species Names and Aerosol Precursors
        ALLOCATE ( ISAM_SPEC( NSPCSD, NTAG_SA ), STAT = IOST )
        CALL CHECKMEM( IOST, 'ISAM_SPEC', 'GET_NSPC_SA' )
        ISAM_SPEC = ''

        ALLOCATE ( MAP_ISAMtoAERO( NSPCSD ), STAT = IOST )
        CALL CHECKMEM( IOST, 'MAP_ISAMtoAERO', 'GET_NSPC_SA' )
        MAP_ISAMtoAERO = 0

        ALLOCATE ( MAP_AEROtoSA( N_AEROSPC, N_MODE ), STAT = IOST )
        CALL CHECKMEM( IOST, 'MAP_AEROtoSA', 'GET_NSPC_SA' )
        MAP_AEROtoSA = 0

        ALLOCATE ( MAP_AEROGAStoSA( N_AEROSPC ), STAT = IOST )
        CALL CHECKMEM( IOST, 'MAP_AEROGAStoSA', 'GET_NSPC_SA' )
        MAP_AEROGAStoSA = 0

        ALLOCATE ( MAP_AEROCTRtoSA( N_AEROSPC ), STAT = IOST )
        CALL CHECKMEM( IOST, 'MAP_AEROCTRtoSA', 'GET_NSPC_SA' )
        MAP_AEROCTRtoSA = 0

        ALLOCATE ( L_ISAM_AERO( N_AEROSPC ), STAT = IOST )
        CALL CHECKMEM( IOST, 'L_ISAM_AERO', 'GET_NSPC_SA' )
        L_ISAM_AERO = .FALSE.
 
        ! Allocate ISAM_SPECIES_BIAS array
        ALLOCATE ( ISAM_SPECIES_BIAS( NBIAS,NSPCSD ), STAT = IOST )
        ISAM_SPECIES_BIAS = .FALSE.
        IF ( IMECH .GT. 0 ) THEN
            N_VOC_BIAS = SIZE( ISAM_BIAS_VOC( IMECH )%LIST )
            N_NOY_BIAS = SIZE( ISAM_BIAS_NOY( IMECH )%LIST )
        END IF

        ! Retrieve User-Defined Tag-Classes and Print Errors/Crash CMAQ
        ! if the User is requesting tag-classes that aren't defined
        ALLOCATE( CLASS_NAMES( MAX_TAGCLASSES ) )
        CALL CHECKMEM( IOST, 'CLASS_NAMES', 'GET_NSPC_SA' )
        CALL PARSE_STRING( TAGCLASSES, NCLASSES, CLASS_NAMES )
                
        IF( NCLASSES .LT. 1 )THEN
           XMSG = "ISAM ERROR: TAGCLASSES in control file incorrectly defined. "
           CALL M3EXIT('GET_NSPC_SA', 0, 0, XMSG, XSTAT2 )
        END IF
        
        DO J = 1, NCLASSES
           K = INDEX1( CLASS_NAMES( J ), NUMB_CLASSES, DEFINED_CLASSES )
           IF( K .LT. 1 )THEN
              XMSG = "ISAM ERROR: unknown tagclass: " // TRIM( CLASS_NAMES( J ) )
              WRITE(LOGDEV,'(A)')TRIM(XMSG )
              EFLAG = .TRUE. 
           ELSE
              CLASSES_FOUND = CLASSES_FOUND + 1   
           END IF       
        END DO
        
        IF( EFLAG .OR. CLASSES_FOUND .LT. 1 )THEN
           XMSG = 'ISAM ERROR: problem defining tagclasses'
           WRITE(LOGDEV,'(A)')TRIM(XMSG )
           XMSG = 'Permitted TAGCLASSES listed below:'
           WRITE(LOGDEV,'(A)')TRIM(XMSG )
           DO J = 1, NUMB_CLASSES
              WRITE(LOGDEV,'(2X,A)')TRIM( DEFINED_CLASSES( J ) )
           END DO
           XMSG = 'Above fatal error(s) in setting up ISAM'
           CALL M3EXIT('GET_NSPC_SA', 0, 0, XMSG, XSTAT2 )
        END IF 

        ! Initialize Control Variables
        L_VOC      = .FALSE.   
        L_NO3      = .FALSE.
        L_NH4      = .FALSE.
        L_OZONE    = .FALSE.
        L_SO4      = .FALSE.
        L_CL       = .FALSE.


        ! Initalize Number of ISAM Species
        NSPC_SA = 0

        ! Activate All Species if Requested
        IF ( INDEX( TAGCLASSES,'ALL' ) .NE. 0 ) THEN
          ! Add All Particle Species
          L_ISAM_AERO = .TRUE. 

          ! Add All Gas Species
          DO ISPEC = 1,NSPCSD
             IF ( INDEX1( CGRID_NAME(ISPEC), NSPC_SA, ISAM_SPEC(:,1) ) .EQ. 0
     &            .AND. ( CGRID_MASK_GAS( ISPEC ) .OR. 
     &                    CGRID_MASK_NR( ISPEC ) )      ) THEN
                NSPC_SA = NSPC_SA + 1
                ISAM_SPEC( NSPC_SA,: ) = CGRID_NAME( ISPEC )
             END IF
          END DO  
        ENDIF
 
        ! Activate All Particulate Species if Requested
        IF ( INDEX( TAGCLASSES,'PM_TOT' ) .NE. 0 ) THEN
          L_ISAM_AERO = .TRUE.
          L_VOC = .TRUE.
          L_NO3 = .TRUE.
          L_NH4 = .TRUE.
          L_SO4 = .TRUE.
          L_CL  = .TRUE.
        ENDIF
 
        ! Activate Particulate Ions if Requested
        IF ( INDEX( TAGCLASSES,'PM_IONS' ) .NE. 0 ) THEN
          FOUND_SPECIES = .FALSE.
          CALL ADD_ISAM_SPEC( 'ANA', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'AMG', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'AK', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'ACA', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'AFE', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'AAL', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'ASI', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'ATI', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'AMN', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'AOTHR', FOUND_SPECIES, IMECH )
          
          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'PM_IONS', FOUND_SPECIES, EFLAG )
        ENDIF
 
        ! Activate Particulate Chlorine if Requested
        IF ( INDEX( TAGCLASSES,'CHLORINE' ) .NE. 0 .OR. L_CL ) THEN
          FOUND_SPECIES = .FALSE.
          CALL ADD_ISAM_SPEC( 'ACL', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'HCL', FOUND_SPECIES, IMECH )
          
          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'CHLORINE', FOUND_SPECIES, EFLAG )
        ENDIF

        ! Activate Elemental Carbon if Requested
        IF ( INDEX( TAGCLASSES,'EC' ) .NE. 0 ) THEN
          FOUND_SPECIES = .FALSE.
          CALL ADD_ISAM_SPEC( 'AEC', FOUND_SPECIES, IMECH )
          
          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'EC', FOUND_SPECIES, EFLAG )
        ENDIF
 
        ! Activate Non-Volatile Primary Organic Aerosol if Requested
        IF ( INDEX( TAGCLASSES,'NVPOA' ) .NE. 0 ) THEN
          FOUND_SPECIES = .FALSE.

          CALL ADD_ISAM_SPEC( 'APOC', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'APNCOM', FOUND_SPECIES, IMECH )
          
          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'NVPOA', FOUND_SPECIES, EFLAG )
        END IF
 
        ! Activate Organic Aerosol if Requested
        IF ( INDEX( TAGCLASSES,'OA_TOT' ) .NE. 0 ) THEN
          L_VOC = .TRUE.
          FOUND_SPECIES = .FALSE.

          DO IAERO = 1,N_AEROSPC
             IF ( AEROSPC( IAERO )%OM )
     &          CALL ADD_ISAM_SPEC( AEROSPC(IAERO)%BULKNAME, 
     &                              FOUND_SPECIES, IMECH )
          END DO
          
          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'OA_TOT', FOUND_SPECIES, EFLAG )
        END IF

        ! Activate Particulate Sulfate if Requested
        IF ( INDEX( TAGCLASSES,'SULFATE' ) .NE. 0 .OR. L_SO4  ) THEN
          
          FOUND_SPECIES = .FALSE.
          
          CALL ADD_ISAM_SPEC( 'ASO4', FOUND_SPECIES, IMECH )
          CALL CHECK_MECH( 'SULFATE', IMECH, MECHNAME, EFLAG )
          DO ISPEC = 1,SIZE( ISAM_SPEC_SO4( IMECH )%LIST )
            CALL ADD_ISAM_SPEC( ISAM_SPEC_SO4(IMECH)%LIST(ISPEC), 
     &                          FOUND_SPECIES, IMECH )
          END DO
          
          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'SULFATE', FOUND_SPECIES, EFLAG )
        ENDIF

        ! Activate Particulate Ammonium if Requested
        IF ( INDEX( TAGCLASSES,'AMMONIUM' ) .NE. 0 .OR. L_NH4 ) THEN
          FOUND_SPECIES = .FALSE.
          CALL ADD_ISAM_SPEC( 'ANH4', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'NH3', FOUND_SPECIES, IMECH )
          
          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'AMMONIUM', FOUND_SPECIES, EFLAG )
        ENDIF
 
        ! Add Carbon Monoxide if Requested                       
        IF ( INDEX( TAGCLASSES,'CO' ) .NE. 0 ) THEN
          FOUND_SPECIES = .FALSE.
          CALL ADD_ISAM_SPEC( 'CO', FOUND_SPECIES, IMECH )
          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'CO', FOUND_SPECIES, EFLAG )
        ENDIF
 

        ! Add HAP Gases
        IF ( INDEX( TAGCLASSES,'HAP_GAS' ) .NE. 0 .OR. 
     &       INDEX( TAGCLASSES,'HAP_TOT' ) .NE. 0  ) THEN
          ! set ozone tracking to true for accurate tracking secondary production of HCHO and CH3CHO
          L_OZONE = .TRUE.
          FOUND_SPECIES = .FALSE.
          
          CALL CHECK_MECH( 'GASEOUS HAPS', IMECH, MECHNAME, EFLAG )

          ! Add each VOC Species according to fields ISAM_SPEC_GASHAPS arrays
          DO ISPEC = 1,SIZE( ISAM_SPEC_HAPGAS( IMECH )%LIST )
             CALL ADD_ISAM_SPEC( ISAM_SPEC_HAPGAS(IMECH)%LIST(ISPEC), 
     &                           FOUND_SPECIES, IMECH )
          END DO 

          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'GASEOUS HAPS', FOUND_SPECIES, EFLAG )
        ENDIF
 

        ! Add Ozone if Requested
        IF ( INDEX( TAGCLASSES,'OZONE' ) .NE. 0 .OR. L_OZONE ) THEN

          L_OZONE   = .TRUE.
          L_NO3     = .TRUE.
          L_VOC     = .TRUE.
          FOUND_SPECIES = .FALSE.
          
          CALL CHECK_MECH( 'OZONE', IMECH, MECHNAME, EFLAG )
          
          ! Add Ozone-Relevant Species
          DO ISPEC = 1,SIZE( ISAM_SPEC_OZONE( IMECH )%LIST )
             CALL ADD_ISAM_SPEC( ISAM_SPEC_OZONE(IMECH)%LIST(ISPEC), 
     &                           FOUND_SPECIES, IMECH )
          END DO

          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'OZONE', FOUND_SPECIES, EFLAG )
        END IF       

        ! Add Nitrate Species
        IF ( INDEX( TAGCLASSES,'NITRATE' ) .NE. 0 .OR. L_NO3 ) THEN 
          L_NO3 = .TRUE. 
          FOUND_SPECIES = .FALSE.

          ! Check that the chemical mechanism name is valid
          CALL CHECK_MECH( 'NITRATE', IMECH, MECHNAME, EFLAG )

          ! Add Aerosol Species
          CALL ADD_ISAM_SPEC( 'ANO3', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'AMTNO3', FOUND_SPECIES, IMECH )
          CALL ADD_ISAM_SPEC( 'AISOPNN', FOUND_SPECIES, IMECH )

          ! Add Nitrate-Relevant Gas Species
          DO ISPEC = 1,SIZE( ISAM_SPEC_NO3( IMECH )%LIST )
             CALL ADD_ISAM_SPEC( ISAM_SPEC_NO3(IMECH)%LIST(ISPEC), 
     &                           FOUND_SPECIES, IMECH )
          END DO 

          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'NITRATE', FOUND_SPECIES, EFLAG )
        ENDIF


        ! Add VOC Species for VOC Tag-Class
        IF ( INDEX( TAGCLASSES,'VOC' ) .NE. 0 .OR. L_VOC ) THEN
          CALL CHECK_MECH( 'VOC', IMECH, MECHNAME, EFLAG )

          ! Add each VOC Species according to fields ISAM_SPEC_VOC arrays
          DO ISPEC = 1,SIZE( ISAM_SPEC_VOC( IMECH )%LIST )
             CALL ADD_ISAM_SPEC( ISAM_SPEC_VOC(IMECH)%LIST(ISPEC), 
     &                           FOUND_SPECIES, IMECH )
          END DO 
          
          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'VOC', FOUND_SPECIES, EFLAG )
        END IF
 

        ! Add HAP Aerosols
        IF ( INDEX( TAGCLASSES,'HAP_AERO') .NE. 0 .OR. 
     &       INDEX( TAGCLASSES,'HAP_TOT' ) .NE. 0  ) THEN

          FOUND_SPECIES = .FALSE.
          DO I = 1,SIZE( ISAM_SPEC_HAPAERO%LIST )
             CALL ADD_ISAM_SPEC( ISAM_SPEC_HAPAERO%LIST(I), 
     &                           FOUND_SPECIES, IMECH )
          END DO

          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'HAP_AERO', FOUND_SPECIES, EFLAG )
        END IF
 

        ! Activate BaP tracking if Requested
        IF ( INDEX( TAGCLASSES,'BENAPYRENE' ) .NE. 0 .OR. 
     &       INDEX( TAGCLASSES,'HAP_TOT' ) .NE. 0 ) THEN
          
          FOUND_SPECIES = .FALSE.

          ! Find aerosol phase and add if found
          CALL ADD_ISAM_SPEC( 'ABENAPY', FOUND_SPECIES, IMECH )

          ! Add Vapor-Phase Benzo[a]Pyrene
          CALL ADD_ISAM_SPEC( 'BENAPY', FOUND_SPECIES, IMECH )
          
          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'BENAPYRENE', FOUND_SPECIES, EFLAG )
        END IF


        ! Activate TEQ PAHs tracking if Requested
        IF ( INDEX( TAGCLASSES,'PAH_TEQ' ) .NE. 0 .OR. 
     &       INDEX( TAGCLASSES,'HAP_TOT' ) .NE. 0 ) THEN
          
          FOUND_SPECIES = .FALSE.

          ! Scan for NonReactive PAH tracers
          DO I = 1,SIZE( ISAM_SPEC_PAHTEQ%LIST )
            CALL ADD_ISAM_SPEC( ISAM_SPEC_PAHTEQ%LIST(I), 
     &                          FOUND_SPECIES, IMECH )
          END DO

          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'PAH TEQ', FOUND_SPECIES, EFLAG )
        END IF
        
        ! Activate Classic Urban Air Toxics tracking if Requested
        IF ( INDEX( TAGCLASSES,'URBAN_TOXICS' ) .NE. 0 .OR. 
     &       INDEX( TAGCLASSES,'HAP_TOT' ) .NE. 0 ) THEN
        
          FOUND_SPECIES = .FALSE.

          ! Scan for NonReactive PAH tracers
          DO I = 1,SIZE( ISAM_SPEC_TOXICS%LIST )
             CALL ADD_ISAM_SPEC( ISAM_SPEC_TOXICS%LIST(I), 
     &                           FOUND_SPECIES, IMECH )
          END DO

          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'URBAN AIR TOXICS', FOUND_SPECIES, EFLAG )
        END IF


        ! Activate Mercury Toxics
        IF ( INDEX( TAGCLASSES,'MERCURY' ) .NE. 0 .OR. 
     &       INDEX( TAGCLASSES,'HAP_TOT' ) .NE. 0 ) THEN
          
          FOUND_SPECIES = .FALSE.

          ! Find aerosol phase and add if found
          CALL ADD_ISAM_SPEC( 'APHG', FOUND_SPECIES, IMECH )

          ! Add gas-phase mercury species
          DO ISPEC = 1,(SIZE( ISAM_SPEC_MERCURY%LIST ) ) 
            CALL ADD_ISAM_SPEC( ISAM_SPEC_MERCURY%LIST(ISPEC), FOUND_SPECIES, IMECH )
          END DO 

          ! Warn if all species are missing
          CALL ISAM_SPECIES_WARN( 'MERCURY', FOUND_SPECIES, EFLAG )
        END IF


        ! Add Requested Aerosol Species as defined in L_ISAM_AERO
        ! Part of this procedure involves distributing the aerosol bulknames 
        ! associated with L_ISAM_AERO into mode-dependent names needed
        ! for ISAM_SPEC. This section will also associate each ISAM
        ! aerosol species with its volatility type and gas-phase
        ! counterparts and precursors, if applicable.
        DO IAERO = 1,N_AEROSPC
           IF ( L_ISAM_AERO( IAERO ) ) THEN
              DO IMODE = 1,N_MODE
                 ! If the aerosol exists in a particular mode, then add
                 ! its name, the name of its counterpart vapor, any
                 ! reaction counters and the type of partitioning (i.e.
                 ! reversible, irreversible, or nonvolatile)
                 IF ( .NOT.AERO_MISSING( IAERO,IMODE ) ) THEN
                   MAP_ISAMtoAERO( NSPC_SA ) = IAERO

                   !Add aerosol name
                   NSPC_SA = NSPC_SA + 1
                   ISAM_SPEC( NSPC_SA,: ) = AEROSPC( IAERO )%NAME( IMODE )
                   MAP_AEROtoSA( IAERO,IMODE ) = NSPC_SA

                   !Populate Chemistry Bias Arrays if Applicable
                   IF ( IMECH .GT. 0 ) THEN
                     ISPEC = INDEX1( AEROSPC(IAERO)%BULKNAME, N_VOC_BIAS, 
     &                               ISAM_BIAS_VOC(IMECH)%LIST )
                     IF ( ISPEC .GT. 0 ) ISAM_SPECIES_BIAS( 3:4,NSPC_SA ) = .TRUE.
                     ISPEC = INDEX1( AEROSPC(IAERO)%BULKNAME, N_NOY_BIAS, 
     &                               ISAM_BIAS_NOY(IMECH)%LIST )
                     IF ( ISPEC .GT. 0 ) ISAM_SPECIES_BIAS( 2:3,NSPC_SA ) = .TRUE.
                   END IF

                   IF ( AEROSPC( IAERO )%VOLTYPE .NE. 'NVL' ) THEN 
                      NVL_RESET = 0

                      ! Add condensable vapor species
                      IF ( AEROSPC(IAERO)%GASNAME .NE. '' ) THEN
                         IF ( INDEX1( AEROSPC(IAERO)%GASNAME, 
     &                        NSPCSD, CGRID_NAME ) .GT. 0 ) THEN
                           IF ( INDEX1( AEROSPC(IAERO)%GASNAME, 
     &                               NSPC_SA, ISAM_SPEC(:,1) ) .EQ. 0 ) THEN
                              NSPC_SA = NSPC_SA + 1
                              ISAM_SPEC( NSPC_SA,:) = AEROSPC( IAERO )%GASNAME
                              MAP_AEROGAStoSA( IAERO ) = NSPC_SA
                           ELSE 
                              MAP_AEROGAStoSA( IAERO ) = 
     &                           INDEX1( AEROSPC(IAERO)%GASNAME, NSPC_SA, ISAM_SPEC(:,1) )
                           END IF
                         ELSE
                           NVL_RESET = NVL_RESET + 1
                         END IF
                      END IF
                      ! Add reaction counter species
                      IF ( AEROSPC(IAERO)%CTRNAME .NE. '' ) THEN
                         IF ( INDEX1( AEROSPC(IAERO)%CTRNAME, 
     &                             NSPCSD, CGRID_NAME ) .GT. 0 ) THEN
                           IF ( INDEX1( AEROSPC(IAERO)%CTRNAME, 
     &                               NSPC_SA, ISAM_SPEC(:,1) ) .EQ. 0 ) THEN
                              NSPC_SA = NSPC_SA + 1
                              ISAM_SPEC( NSPC_SA,:) = AEROSPC( IAERO )%CTRNAME
                              MAP_AEROCTRtoSA( IAERO ) = NSPC_SA
                           ELSE
                              MAP_AEROCTRtoSA( IAERO ) =
     &                          INDEX1( AEROSPC(IAERO)%CTRNAME, NSPC_SA, ISAM_SPEC(:,1) )

                           END IF
                         ELSE
                           NVL_RESET = NVL_RESET + 1
                         END IF
                      END IF

                      ! If neither the condensable vapor nor the
                      ! reaction counter are present in the gas species
                      ! list, then reset the aerosol species to
                      ! nonvolatile and print a note to the log
                      IF ( NVL_RESET .EQ. 2 ) THEN
                        AEROSPC( IAERO )%VOLTYPE = 'NVL'
                        GASNAME = AEROSPC(IAERO)%GASNAME
                        CTRNAME = AEROSPC(IAERO)%CTRNAME
                        IF ( GASNAME .EQ. '' ) GASNAME = 'NONE'
                        IF ( CTRNAME .EQ. '' ) CTRNAME = 'NONE'

                        XMSG = 'Attention: The ISAM aerosol species ' //
     &                         TRIM(AEROSPC( IAERO )%NAME( IMODE )) //
     &                         ' has been defined in AERO_DATA with condensable ' //
     &                         'vapor species ' // TRIM(GASNAME) // ' and/or '//
     &                         'reaction counter species ' // TRIM(CTRNAME) //
     &                         ' but neither of these are activated as ISAM ' //
     &                         'species (e.g. in the ISAM control file. The aerosol '//
     &                         'species will be assumed nonvolatile for ISAM.'
                        CALL LOG_MESSAGE( LOGDEV, XMSG )
                      END IF
                   END IF

                 END IF
              END DO
           END IF
        END DO
        
        ! Resize ISAM_SPEC to NSPC_SA
        ISAM_SPEC = ISAM_SPEC( 1:NSPC_SA,: )
        ISAM_SPECIES_BIAS = ISAM_SPECIES_BIAS( :,1:NSPC_SA )

        ! Exit CMAQ if There has been a fatal ISAM Error
        IF ( EFLAG ) THEN
          CALL M3EXIT( 'GET_NSPC_SA', 0, 0, 'Above Fatal ISAM ERROR(s) Encountered', XSTAT2 )
        END IF 

        END SUBROUTINE GET_NSPC_SA

! --------------------------------------------------------------------------------
        SUBROUTINE PARSE_STRING ( ENV_VAL, NVARS, VAL_LIST, LOGDEV )

! takes a string of items delimited by white space,
! commas or semi-colons) and parse out the items into variables. Two data
! types: character strings and integers (still represented as strings in
! the env var vaules).
          USE UTILIO_DEFN 
          
          IMPLICIT NONE

          CHARACTER( * ), INTENT ( IN )           :: ENV_VAL
          INTEGER,        INTENT ( OUT )          :: NVARS
          CHARACTER( * ), INTENT ( OUT )          :: VAL_LIST( : )
          INTEGER,        INTENT ( IN ), OPTIONAL :: LOGDEV

          INTEGER             :: MAX_LEN
          INTEGER             :: LEN_EVAL
          CHARACTER( 16 )     :: PNAME = 'PARSE_STRING'
          CHARACTER(  1 )     :: CHR
          CHARACTER( 96 )     :: XMSG

          INTEGER :: JP( MAX_STRING*SIZE( VAL_LIST ) )
          INTEGER :: KP( MAX_STRING*SIZE( VAL_LIST ) )
          INTEGER :: STATUS
          INTEGER :: IP, V

          INTEGER :: LOC_LOGDEV
 
          IF (PRESENT(LOGDEV)) THEN
             LOC_LOGDEV = LOGDEV
          ELSE
             LOC_LOGDEV = 6
          END IF

          MAX_LEN = MAX_STRING * ( SIZE( VAL_LIST ) + 1 ) ! extra character allows deliminator

C Parse:

           NVARS = 0

C do not count until 1st char in string
           
           IP = 0
           KP = 1
           JP = 1
           LEN_EVAL = LEN_TRIM( ENV_VAL ) 
           IF ( LEN_EVAL .GT. MAX_LEN ) THEN
              XMSG = TRIM( PNAME ) // ': The Environment variable, '
     &            // TRIM( ENV_VAL ) // ',  has too long, greater than ' 
              WRITE(LOGDEV,'(A,I8)')TRIM( XMSG ), MAX_LEN
              XMSG = 'Above fatal error encountered '
              CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )                     
           END IF
101        LOOP_101: DO  ! read list
              IP = IP + 1
              IF ( IP .GT. LEN_EVAL ) EXIT LOOP_101
              CHR = ENV_VAL( IP:IP )
              IF ( CHR .EQ. ' ' .OR. ICHAR ( CHR ) .EQ. 09 ) CYCLE LOOP_101
              IF( NVARS .GT. SIZE( VAL_LIST ) )THEN
                 XMSG = TRIM( PNAME ) // ':ERROR: Number of values in List, ' 
     &                //  TRIM( ENV_VAL ) 
     &                // ', greater than the size of its storage array, '
                  WRITE(LOGDEV,'(A,I4)')TRIM( XMSG ), SIZE( VAL_LIST )
                  XMSG = 'Above fatal error encountered '
                  CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )                     
              END IF
              NVARS = NVARS + 1
              JP( NVARS ) = IP   ! 1st char
              IF( IP .EQ. LEN_EVAL )THEN ! word one character long          
                  KP( NVARS ) = IP
                  V = 1
                  EXIT LOOP_101
              END IF     
201           LOOP_201: DO ! read word
                 IP = IP + 1
                 CHR = ENV_VAL( IP:IP )
                 IF ( CHR .NE. ' ' .AND.
     &                CHR .NE. ',' .AND.
     &                CHR .NE. ';' .OR.
     &                ICHAR ( CHR ) .EQ. 09 ) THEN  ! 09 = horizontal tab
                    CYCLE LOOP_201
                 ELSE                               ! last char in word
                    KP( NVARS ) = IP - 1 
                    V = JP( NVARS ) - IP
                    IF( V .GT. MAX_STRING )THEN
                      XMSG =  'The word, ' // ENV_VAL( JP(NVARS):KP(NVARS) ) 
     &                     // ', in list, ' // TRIM( ENV_VAL )
     &                     // ', is too long, '
                      WRITE(LOGDEV,'(A,1X,I2,A,I2)')TRIM( XMSG ), V, ' max allowed ',
     &                MAX_STRING
                      XMSG = 'Above fatal error encountered '
                      CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )                     
                    END IF
                    EXIT LOOP_201
                 END IF 
                 IF ( IP .GE. LEN_EVAL ) EXIT LOOP_101
              END DO LOOP_201
           END DO LOOP_101
           
           IF( NVARS .GT. SIZE( VAL_LIST ) )THEN
              XMSG = TRIM( PNAME ) // ':ERROR: Number of values in List, ' 
     &             //  TRIM( ENV_VAL ) // ', greater than '
              WRITE(LOGDEV,'(A,I4)')TRIM( XMSG ), SIZE( VAL_LIST )
              XMSG = 'Above fatal error encountered '
              CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )                     
           END IF
           DO V = 1, NVARS
              VAL_LIST( V ) = ENV_VAL( JP( V ):KP( V ) )
           END DO

           RETURN
           
        END SUBROUTINE PARSE_STRING

c===============================================================

        SUBROUTINE GET_MAP_SAtoCGR ()

C20140428  Map CGRID species index to ISAM tracer species index
C         Called by driver.F
C

        USE CGRID_SPCS     
        USE RXNS_DATA,    ONLY : MECHNAME, NUMB_MECH_SPC, CHEMISTRY_SPC 
!        USE DEGRADE_PARAMETERS
        USE UTILIO_DEFN    

        IMPLICIT NONE
      
        INTEGER J_SPC, N, ITAG, I2, ISUM
        INTEGER N_OZN     ! index of ozone in gc_spc list
        INTEGER IOST

        CHARACTER( 16 ), ALLOCATABLE, SAVE :: CMAQ_ADV_NAMES( : ) 
        
        INTEGER FRST, LAST, CMAQ_ADV

        INTEGER I_SPC, K_SPC, NLIST
         
        CHARACTER( 132 ) :: XMSG
        INTEGER ALLOCSTAT

        LOGICAL FOUND
        LOGICAL TRANS_WARN
        LOGICAL EFLAG
c----------------------------------------------------------
        

        ! Initialize number of tags * species        
        N_SPCTAG = NSPC_SA * NTAG_SA
    
        ! Allocate vectors and arrays for ISAM species names and property
        ! fields
        ALLOCATE ( MAP_SAtoCGR( NSPC_SA ), STAT = ALLOCSTAT )
        CALL CHECKMEM( ALLOCSTAT, 'MAP_SAtoCGR', 'GET_MAP_SAtoCGR' )
        MAP_SAtoCGR = -1
        ALLOCATE ( IS_SPC_AEROSOL( NSPC_SA,NTAG_SA ), STAT = ALLOCSTAT )
        CALL CHECKMEM( ALLOCSTAT, 'IS_SPC_AEROSOL', 'IS_SPC_AEROSOL' )
        IS_SPC_AEROSOL = .FALSE.
        ALLOCATE ( TRANSPORT_SPC( N_SPCTAG ), STAT = ALLOCSTAT )
        CALL CHECKMEM( ALLOCSTAT, 'TRANSPORT_SPC', 'TRANSPORT_SPC' )
        TRANSPORT_SPC = .TRUE.

        ! Determine which ISAM species are aerosols and are transported
        ! set species names
        NSPC_TRANSPORT = 0
        ISUM  = 0
        DO ITAG = 1, NTAG_SA
           DO J_SPC = 1, NSPC_SA
              ISUM = ISUM + 1
              DO N = 1, N_AE_SPC
                 IF( TRIM( ISAM_SPEC( J_SPC,ITAG ) ) .EQ. TRIM( AE_SPC( N ) ))THEN
                     IS_SPC_AEROSOL( J_SPC,ITAG ) = .TRUE.
                     IF ( ITAG .LT. 2 ) NSPC_SA_AE = NSPC_SA_AE + 1
                 END IF
              END DO
              DO N = 1, N_AE_SPC
                 IF( TRIM( ISAM_SPEC( J_SPC,ITAG ) ) .EQ. TRIM( AE_SPC( N ) ) )THEN
                     IS_SPC_AEROSOL( J_SPC,ITAG ) = .TRUE.
                 END IF
              END DO
              FOUND = .FALSE.        
              DO N = 1, N_GC_TRNS
                 IF( ISAM_SPEC( J_SPC,ITAG ) .EQ. GC_TRNS( N ) )FOUND = .TRUE.
              END DO
              DO N = 1, N_AE_TRNS
                 IF( ISAM_SPEC( J_SPC,ITAG ) .EQ. AE_TRNS( N ) )FOUND = .TRUE.
              END DO
              DO N = 1, N_NR_TRNS
                 IF( ISAM_SPEC( J_SPC,ITAG ) .EQ. NR_TRNS( N ) )FOUND = .TRUE.
              END DO
              DO N = 1, N_TR_ADV
                 IF( ISAM_SPEC( J_SPC,ITAG ) .EQ. TR_ADV( N ) )FOUND = .TRUE.
              END DO
              TRANSPORT_SPC( ISUM ) = FOUND
              IF( FOUND )NSPC_TRANSPORT = NSPC_TRANSPORT + 1
           END DO  
        END DO

        ALLOCATE ( ISAM_TO_AERO( NSPC_SA_AE ), STAT = ALLOCSTAT )
        CALL CHECKMEM( ALLOCSTAT, 'ISAM_TO_AERO', 'GET_SPC_INDEX' )
        ISAM_TO_AERO = -1
        ALLOCATE ( SA_AERO_INDX( NSPC_SA_AE ), STAT = ALLOCSTAT )
        CALL CHECKMEM( ALLOCSTAT, 'SA_AERO_INDX', 'GET_SPC_INDEX' )
        SA_AERO_INDX = -1

        ITAG = 1
        N = 0
        DO J_SPC = 1, NSPC_SA
           IF( .NOT. IS_SPC_AEROSOL( J_SPC,ITAG ) )CYCLE
           N = N + 1
           DO I_SPC = 1, N_AE_SPC
               IF( TRIM( ISAM_SPEC( J_SPC,ITAG ) ) .NE. TRIM( AE_SPC( I_SPC ) ) ) CYCLE
               ISAM_TO_AERO( N ) = I_SPC ! + AE_STRT - 1
               SA_AERO_INDX( N ) = J_SPC
               WRITE(LOGDEV,'(A,I4,1X,I5,1X,A16,I3,1X,A16)')
     &         'ISAM SPECIES, AEROSOL SPECIES = ',N,SA_AERO_INDX( N ),ISAM_SPEC( J_SPC,ITAG ),
     &         ISAM_TO_AERO( N ),AE_SPC( I_SPC )
           END DO
        END DO


C...Assign species index with CMAQ species mappings
        ! Assign species index with CMAQ species mappings
        ALLOCATE( MAP_CGRtoSA( NSPCSD ) )
        MAP_CGRtoSA = 0

        DO N = 1, NSPCSD
           DO J_SPC = 1, NSPC_SA
             IF ( ISAM_SPEC( J_SPC,ICONTAG ) .EQ. CGRID_NAME( N ) ) THEN  
               MAP_SAtoCGR( J_SPC ) = N
               MAP_CGRtoSA( N ) = J_SPC
             END IF ! ISAM_SPEC and gc_spc match
           END DO
        END DO ! number of tagging species

        EFLAG = .FALSE.
        DO J_SPC = 1, NSPC_SA
          IF ( MAP_SAtoCGR( J_SPC ) .LT. 1 ) THEN
             write(logdev,'(A,A,A)')'Tracked species '
     &       // TRIM( ISAM_SPEC( J_SPC,ICONTAG ) ) //
     &          ' not found among model species '
             EFLAG = .TRUE.
          END IF
        END DO 
        IF ( EFLAG ) THEN
          CALL M3EXIT( 'GET_MAP_SAtoCGR', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )
        END IF 

C...Map SA species for Advection
        ALLOCATE( MAP_ADVtoSA ( N_SPCTAG ) )
           
        CMAQ_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV
        ALLOCATE( CMAQ_ADV_NAMES( CMAQ_ADV ) )

        FRST = 0
        LAST = 0
        IF ( N_GC_TRNS .NE. 0 ) THEN 
           FRST = 1
           LAST = N_GC_TRNS
           CMAQ_ADV_NAMES( FRST:LAST ) = GC_TRNS(1:N_GC_TRNS)
        ENDIF

        IF ( N_AE_TRNS .NE. 0 ) THEN
           FRST = LAST + 1
           LAST = LAST + N_AE_TRNS
           CMAQ_ADV_NAMES( FRST:LAST ) = AE_TRNS(1:N_AE_TRNS)
        END IF

        IF ( N_NR_TRNS .NE. 0 ) THEN
           FRST = LAST + 1
           LAST = LAST + N_NR_TRNS
           CMAQ_ADV_NAMES( FRST:LAST ) = NR_TRNS(1:N_NR_TRNS)
        END IF

        IF ( N_TR_ADV .NE. 0 ) THEN
           FRST = LAST + 1
           LAST = LAST + N_TR_ADV
           CMAQ_ADV_NAMES( FRST:LAST ) = TR_ADV(1:N_TR_ADV)
        END IF

        MAP_ADVtoSA = -1
        N = 0
        TRANS_WARN = .FALSE.
        DO ITAG = 1, NTAG_SA
           DO J_SPC = 1, NSPC_SA
              N = N + 1
              MAP_ADVtoSA(N) = INDEX1( ISAM_SPEC(J_SPC,1), CMAQ_ADV, CMAQ_ADV_NAMES )
              IF( MAP_ADVtoSA(N) .LT. 1 .AND. ITAG .LT. 2 )THEN
                 TRANS_WARN = .TRUE.
                 XMSG = 'ISAM WARNING: Tagged Species, ' // TRIM( ISAM_SPEC(J_SPC,1) ) 
     &               // ' not transported. Modify species namelist(s) to include process.'
                 WRITE(LOGDEV,'(A)')TRIM( XMSG )
              END IF
           END DO
        END DO
        
        IF ( TRANS_WARN ) THEN
          CALL M3WARN( 'GET_MAP_SAtoCGR', 0, 0, 'Species above are not transported.' )
        END IF

95000    FORMAT(2(I3,1X),A,L4,1X,I4)


C...Map SA species for DEPV
C
C...  DO THIS LATER IF NEEDED FOR THE GENERAL CASE - RIGHT NOW ONLY DO AMMONIA
c       ALLOCATE( MAP_DEPVtoSA ( N_SPCTAG ) )

c       CMAQ_DEPV = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV + N_TR_DEPV
c       ALLOCATE( CMAQ_DEPV_NAMES( CMAQ_DEPV ) )

c       FRST = 0
c       LAST = 0
c       IF ( N_GC_DEPV .NE. 0 ) THEN
c          FRST = 1
c          LAST = N_GC_DEPV
c          CMAQ_DEPV_NAMES( FRST:LAST ) = GC_DEPV(1:N_GC_DEPV)
c       ENDIF

c       IF ( N_AE_DEPV .NE. 0 ) THEN
c          FRST = LAST + 1
c          LAST = LAST + N_AE_DEPV
c          CMAQ_DEPV_NAMES( FRST:LAST ) = AE_DEPV(1:N_AE_DEPV)
c       END IF

c       IF ( N_NR_DEPV .NE. 0 ) THEN
c          FRST = LAST + 1
c          LAST = LAST + N_NR_DEPV
c          CMAQ_DEPV_NAMES( FRST:LAST ) = NR_DEPV(1:N_NR_DEPV)
c       END IF

c       IF ( N_TR_DEPV .NE. 0 ) THEN
c          FRST = LAST + 1
c          LAST = LAST + N_TR_DEPV
c          CMAQ_DEPV_NAMES( FRST:LAST ) = TR_DEPV(1:N_TR_DEPV)
c       END IF

c       MAP_DEPVtoSA = -1
c       N = 0
!       DO ITAG = 1, NTAG_SA
c          DO J_SPC = 1, NSPC_SA
c             N = N + 1
c             MAP_DEPVtoSA(N) = INDEX1( ISAM_SPEC(J_SPC,1), CMAQ_DEPV, CMAQ_DEPV_NAMES )
c             IF( MAP_DEPVtoSA(N) .LT. 1 )THEN
c                XMSG = 'ISAM WARNING: Tagged Species, ' // TRIM( ISAM_SPEC(J_SPC,1) )
c    &               // ' not in DEPV list.'
c                CALL M3EXIT ( 'MAP_DEPVtoSA', 0, 0, XMSG, XSTAT1 )
c             END IF
c          END DO
!       END DO

        END SUBROUTINE GET_MAP_SAtoCGR

      !-------------------------------------------------------------------------------------------   
        SUBROUTINE CHECK_MECH( TAG_NAME, IMECH, MECHNAME, EFLAG )
      !-------------------------------------------------------------------------------------------   
      !  This subroutine checks whether or not the chemical mechanism
      !  that the user has supplied is active for ISAM and reports an
      !  error if not.
      !-------------------------------------------------------------------------------------------   
        USE RUNTIME_VARS
        
        IMPLICIT NONE

        INTEGER       :: IMECH
        CHARACTER(*)  :: TAG_NAME
        CHARACTER(32) :: MECHNAME
        LOGICAL       :: EFLAG
        CHARACTER(400):: XMSG

        IF ( IMECH .EQ. 0 ) THEN
           XMSG = "ISAM ERROR: The " // TRIM(TAG_NAME) // " tag group has been selected but the species "
     &         // "for the " // TRIM( MECHNAME ) // " mechanism are not defined. Modify GET_NSPC_SA "
     &         // "and GET_SPC_INDEX  subroutines to include MECHNAME cases for it."
                CALL LOG_MESSAGE( LOGDEV, XMSG )  
           EFLAG = .TRUE.
        END IF
        END SUBROUTINE CHECK_MECH
 
      !-------------------------------------------------------------------------------------------   
        SUBROUTINE ADD_ISAM_SPEC( CHEM_NAME, FOUND_SPECIES, IMECH )
      !-------------------------------------------------------------------------------------------   
      !  This subroutine adds an aerosol or gas-phase species to the
      !  ISAM species array and sends back a TRUE value for
      !  FOUND_SPECIES if the input CHEM_NAME is a CMAQ modeled
      !  species.
      !-------------------------------------------------------------------------------------------   
        USE CGRID_SPCS
        USE UTILIO_DEFN 
        USE AERO_DATA, only : N_AEROSPC, AEROSPC
        
        IMPLICIT NONE

        CHARACTER(*)  :: CHEM_NAME
        LOGICAL       :: FOUND_SPECIES

        INTEGER ISPEC, IAERO, IMECH, J_SPC
 
        ! Find Species Index
        ISPEC = INDEX1( CHEM_NAME, NSPCSD, CGRID_NAME )
        IAERO = INDEX1( CHEM_NAME, N_AEROSPC, AEROSPC%BULKNAME )
 
        IF ( IAERO .GT. 0 ) THEN
           ! Species is an aerosol model species
           L_ISAM_AERO( IAERO ) = .TRUE.
           FOUND_SPECIES = .TRUE.

        ELSE IF ( ISPEC .GT. 0 ) THEN
           IF ( .NOT. CGRID_MASK_AERO( ISPEC ) ) THEN
              ! Species is a gas model species
              IF ( INDEX1( CHEM_NAME, NSPC_SA, ISAM_SPEC(:,1) ) .EQ. 0 ) THEN
                 NSPC_SA = NSPC_SA + 1
                 ISAM_SPEC( NSPC_SA,: ) = CHEM_NAME

                 ! Populate Chemistry Bias Arrays, if Applicable
                 IF ( IMECH .NE. 0 ) THEN
                   J_SPC = INDEX1( CHEM_NAME, N_VOC_BIAS, ISAM_BIAS_VOC(IMECH)%LIST )
                   IF ( J_SPC .GT. 0 ) ISAM_SPECIES_BIAS( 3:4,NSPC_SA ) = .TRUE.
                   J_SPC = INDEX1( CHEM_NAME, N_NOY_BIAS, ISAM_BIAS_NOY(IMECH)%LIST )
                   IF ( J_SPC .GT. 0 ) ISAM_SPECIES_BIAS( 2:3,NSPC_SA ) = .TRUE.
                 END IF

              END IF 
              FOUND_SPECIES = .TRUE.
           END IF

        END IF   

        END SUBROUTINE ADD_ISAM_SPEC

      !-------------------------------------------------------------------------------------------   
        SUBROUTINE ISAM_SPECIES_WARN( TAG_NAME, FOUND_SPECIES, EFLAG )
      !-------------------------------------------------------------------------------------------   
      !  This subroutine prints a warning if no species in a tag class
      !  are found on CMAQ modeled species list.
      !-------------------------------------------------------------------------------------------   
        USE RUNTIME_VARS
        
        IMPLICIT NONE

        CHARACTER(*)  :: TAG_NAME
        LOGICAL       :: FOUND_SPECIES
        LOGICAL       :: EFLAG
        CHARACTER(400):: XMSG


        IF ( .NOT. FOUND_SPECIES ) THEN
           EFLAG = .TRUE.
           XMSG = " ISAM ERROR: No member of "//TRIM(TAG_NAME)//" tag class found "
     &          // "in species namelists but control file requests the class."
           CALL LOG_MESSAGE( LOGDEV, XMSG )
        END IF
 
        END SUBROUTINE ISAM_SPECIES_WARN
 


      END MODULE SA_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CONV_CGRID ( CGRID, JDATE, JTIME, CNGRD )

C-----------------------------------------------------------------------
C Function:
C   Convert decoupled aerosol species to molar units (ppm and m**2/mol)
C   and reorder dimensions

C Revision History:
C   Written by: J.Young 21 Aug 03
C   J.Young 31 Jan 05: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all
C                     MY_N clauses
C-----------------------------------------------------------------------

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      USE VDIFF_MAP
      use CENTRALIZED_IO_MODULE, only : interpolate_var
      use CONST
#ifdef isam
      USE SA_DEFN
#endif

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

      REAL, POINTER :: CGRID( :,:,:,: )            ! concentrations
      INTEGER, INTENT( IN )    :: JDATE            ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )    :: JTIME            ! current model time, coded HHMMSS
      REAL,    INTENT( INOUT ) :: CNGRD( :,:,:,: ) ! cgrid replacement
#ifdef isam
      INTEGER IBGN, JSPCTAG
      LOGICAL, SAVE :: ISAM_FIRSTIME = .TRUE.
      LOGICAL, ALLOCATABLE, SAVE :: CONVERT_TAG_SPC ( : )
      REAL,    ALLOCATABLE, SAVE :: CFAC_TAG_SPC   ( : )
#endif

C Parameters:
      REAL, PARAMETER :: MWAIR_SI = MWAIR / 1.0E+03 ! kg mol-1

C Local Variables:

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 16 ), SAVE :: PNAME = 'CONV_CGRID'
      CHARACTER( 96 ) :: XMSG = ' '

      REAL      DENS( NCOLS,NROWS,NLAYS )  ! air density (kg m-3)
      REAL      FAC1( NCOLS,NROWS,NLAYS )  ! conversion factor

      INTEGER   NSPCS, OFF
      INTEGER   C, R, L, S, V, I           ! loop induction variables
      INTEGER IOS

      REAL    CONV            ! temp var

C-----------------------------------------------------------------------

      call interpolate_var ('DENS', jdate, jtime, DENS) ! kg m-3
      FAC1 = MWAIR_SI / DENS  ! m3 mol-1

C Convert non-molar mixing ratio species and re-order CGRID
      DO L = 1, NLAYS

        DO I = 1,N_CGRID_SPC
            ! Gas - no conversion
            IF ( CGRID_MASK_GAS( I ) .OR.
     &           CGRID_MASK_NR( I )  .OR.
     &           CGRID_MASK_TRAC( I ) )
     &         CNGRD( I,L,:,: ) = CGRID( :,:,L,I )

            ! Aerosol Mass: ug/m3 -> ppmv
            IF ( CGRID_MASK_AERO( I ) .AND.
     &           .NOT. CGRID_MASK_NUM( I ) .AND.
     &           .NOT. CGRID_MASK_SRF( I )  )
     &         CNGRD( I,L,:,: ) = CGRID( :,:,L,I ) 
     &                          * FAC1( :,:,L ) / CGRID_MW( I )

            ! Aerosol Number: N m-3 -> N mol-1
            ! Aerosol Surface Area: m2/m3 -> m2 / mol air
            IF ( CGRID_MASK_NUM( I ) .OR.
     &           CGRID_MASK_SRF( I )      )
     &         CNGRD( I,L,:,: ) = CGRID( :,:,L,I ) * FAC1( :,:,L )
        END DO
      
      END DO

#ifdef isam
      ! Convert PM Mass Only
      IF( ISAM_FIRSTIME )THEN
         ALLOCATE( CONVERT_TAG_SPC( N_SPCTAG ) )
         ALLOCATE( CFAC_TAG_SPC   ( N_SPCTAG ) )
         SET_CONV_SPCTAG: DO JSPCTAG = 1, N_SPCTAG
            IBGN = INDEX( VNAM_SPCTAG( JSPCTAG ), '_', BACK = .TRUE. ) - 1
            S = INDEX1( VNAM_SPCTAG( JSPCTAG )( 1:IBGN ), N_AE_SPC, AE_SPC )
            IF ( S .GT. 0 ) THEN
              CFAC_TAG_SPC( JSPCTAG )    = AE_MOLWT( S )
              CONVERT_TAG_SPC( JSPCTAG ) = .TRUE.  
            ELSE
              CFAC_TAG_SPC( JSPCTAG )    = 1.0
              CONVERT_TAG_SPC( JSPCTAG ) = .FALSE.
            END IF
         END DO SET_CONV_SPCTAG
         ISAM_FIRSTIME = .FALSE.
      END IF
      CONV_SPCTAG: DO JSPCTAG = 1, N_SPCTAG
         IF ( CONVERT_TAG_SPC( JSPCTAG ) ) THEN
            DO L = 1, NLAYS
               ISAM( :,:,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) =
     &            ISAM( :,:,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) )
     &              * FAC1( :,:,L ) / CFAC_TAG_SPC( JSPCTAG ) 
            END DO 
         END IF
      END DO CONV_SPCTAG
#endif

      RETURN

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      ENTRY REV_CGRID ( CNGRD, JDATE, JTIME, CGRID )

C Revert non-molar mixing ratio species and re-order CGRID

      call interpolate_var ('DENS', jdate, jtime, DENS) ! kg m-3
      FAC1 = DENS / MWAIR_SI  ! mol m-3

       DO L = 1, NLAYS
         DO I = 1,N_CGRID_SPC
             ! Gas - no conversion
             IF ( CGRID_MASK_GAS( I ) .OR.
     &            CGRID_MASK_NR( I )  .OR.
     &            CGRID_MASK_TRAC( I ) )
     &          CGRID( :,:,L,I ) = CNGRD( I,L,:,: )

             ! Aerosol Mass:  ppmv -> ug m-3
             IF ( CGRID_MASK_AERO( I ) .AND.
     &            .NOT. CGRID_MASK_NUM( I ) .AND.
     &            .NOT. CGRID_MASK_SRF( I )  )
     &          CGRID( :,:,L,I ) = CNGRD( I,L,:,: ) 
     &                           * FAC1( :,:,L ) * CGRID_MW( I )

             ! Aerosol Number: N mol-1 -> N m-3
             ! Aerosol Surface Area: m2 mol-1 -> m2 m-3
             IF ( CGRID_MASK_NUM( I ) .OR.
     &            CGRID_MASK_SRF( I )      )
     &          CGRID( :,:,L,I ) = CNGRD( I,L,:,: ) * FAC1( :,:,L )
         END DO
      END DO
#ifdef isam
Ckrt....JSPCTAG loop on PM mass only.....
      REV_SPCTAG: DO JSPCTAG = 1, N_SPCTAG
         IF ( CONVERT_TAG_SPC( JSPCTAG ) ) THEN
            DO L = 1, NLAYS
                ISAM( :,:,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) =
     &             ISAM( :,:,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) )
     &              * FAC1( :,:,L ) * CFAC_TAG_SPC( JSPCTAG ) 
            END DO
         END IF
      END DO REV_SPCTAG
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker] 
C $Header: /project/work/rep/PARIO/src/pwrgrdd.f,v 1.11 2012/01/26 20:14:28 sjr Exp $

      LOGICAL FUNCTION PWRGRDD( FILNAME, VARNAME, DATE, TIME, BUFFER,
     &                          NCOLS3D, NROWS3D, NLAYS3D,
     &                          NCOLS, NROWS, NP )
C.....................................................................
 
C  PURPOSE:   Perform Models-3 file-write operation in a parallel
C             environment. Values of variable VARNAME on each processor
C             subdomain region are collected, via MPI calls, by the
C             primary I/O processor and the full grid of values are
C             written to file.
 
C  RETURN VALUE:  The function fails if M3IO routine WRITE3 fails. If
C       an MPI error occurs, the program is aborted with a call to
C       PM3EXIT. 
 
C  REVISION  HISTORY:
C       07/1998 Original version by Al Bourgeois for parallel implementation.
C       Renamed  10/07/1998 by AJB from PWRITE3 to PRDGRDD, to be called
C                by PWRITE3.
C       Modified 11/09/1998 by AJB to save RBUFSIZ.
C       Modified 12/04/1998 by Al Bourgeois to add EXTERNAL declarations.
C       Modified 01/26/1999 by Al Bourgeois to allow writing to a subgrid.
C       Modified 06/22/1999 by Al Bourgeois to synchronize I/O processors
C          with their target (non-I/O) processors. If the I/O processor fails
C          on WRITE3, all processors will return a value of FALSE. This
C          routine now calls pm3exit if an MPI error occurs.
C       Modified 02/05/2004 by David Wong
C          -- use f90 allocatable structure, collect all and write once
C       Modified 09/08/2005 by David Wong
C          -- re-allocate WRITBUF when the size is changed so a subgrid data
C             can be output correctly
C       6 May 06 J.Young
C       Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with M3UTILIO; removed
C             deprecated TRIMLEN
C       Modified 01/24/2012 by David Wong
C          -- Only let IO PE to allocate WRITBUF and RECVBUF to reduce overall
C             memory requirement
C       Modified 12/05/2015 by David Wong
C          -- Fixed bug so the code handle dot file correctly
 
C  ARGUMENT LIST DESCRIPTION:
C  M1 in PIOMAPS_MODULE
C  M2 in ALLOC_DATA_MODULE
C  E3 in PIOVARS.EXT
C  IN:
C    CHARACTER*(*)  FILNAME        ! Name of file containing variable VARNAME
C    CHARACTER*(*)  VARNAME        ! Name of file variable to write
C    INTEGER        DATE           ! Date, formatted YYYYDDD
C    INTEGER        TIME           ! Time, formatted HHMMSS
C    REAL           BUFFER(NCOLS, NROWS, NLAYS3D)
C                                  ! Buffer holding (local) array to be written
C    INTEGER  NCOLS3D              ! Column dimension of file variables
C    INTEGER  NROWS3D              ! Row dimension of file variables
C    INTEGER  NLAYS3D              ! Layer dimension of file variables
C    INTEGER  NCOLS                ! Column dimension of local-processor arrays
C    INTEGER  NROWS                ! Row dimension of local-processor arrays
C    INTEGER  NP                   ! Number of processors
C x  INTEGER  WR_NCOLS_PE(NP)   M1 ! No. cols of each PE subgrid to write
C x  INTEGER  WR_NROWS_PE(NP)   M1 ! No. rows of each PE subgrid to write
C x  INTEGER  WR_COLSX_PE(2,NP) M1 ! Col range of each PE subgrid to write
C x  INTEGER  WR_ROWSX_PE(2,NP) M1 ! Row range of each PE subgrid to write
C
C x  REAL WRITBUF(NCOLS3D, NROWS3D, NLAYS3D) M2
C                                  ! Buffer for writing an array.
C
C x  REAL RECVBUF(NCOLS, NROWS, NLAYS3D)   M2
C                                  ! Buffer for message passing an array.
C
C x  INTEGER  MY_PE    E3          ! Local processor id, ranging 0 to NP-1.
C x  INTEGER  IO_PE    E3          ! Id of primary processor used for file I/O.
 
C  OUT: none
 
C  LOCAL VARIABLE DESCRIPTION:  see below
 
C  CALLS: WRITE3, PM3WARN, PM3EXIT, TRIMLEN, MPI_SEND, MPI_RECV, MPI_BCAST
 
C  NOTES: (1) Only the primary I/O processor does the file writing. Input
C             arguments FILNAME, VARNAME, DATE, and TIME are meaningful
C             only to the I/O processor.
 
C         (2) This routine handles only gridded variables. The BUFFER is
C             assumed to be declared as BUFFER( NCOLS, NROWS, NLAYS3D ),
C             where NCOLS and NROWS are the local PE grid subdomain
C             dimensions and NLAYS3D is the file variable layer dimension.
C             BUFFER is assumed to be filled as BUFFER(1:C,1:R,1:NLAYS3D),
C             where C = WR_COLSX_PE(2,MY_PE+1), R = WR_ROWSX_PE(2,MY_PE+1).
C-----------------------------------------------------------------------

      USE PIOMAPS_MODULE
      USE ALLOC_DATA_MODULE
      USE M3UTILIO, ONLY : WRITE3              ! i/o api

      IMPLICIT NONE

C Include Files

      INCLUDE 'mpif.h'            ! MPI definitions and parameters
      INCLUDE 'PIOVARS.EXT'

C Arguments

      CHARACTER( * ) :: FILNAME   ! Name of file containing variable VARNAME
      CHARACTER( * ) :: VARNAME   ! Name of file variable to write
      INTEGER  DATE               ! Date, formatted YYYYDDD
      INTEGER  TIME               ! Time, formatted HHMMSS 
      INTEGER  NCOLS3D            ! Column dimension of file variables
      INTEGER  NROWS3D            ! Row dimension of file variables
      INTEGER  NLAYS3D            ! Layer dimension of file variables
      INTEGER  NCOLS              ! Column dimension of local-processor arrays
      INTEGER  NROWS              ! Row dimension of local-processor arrays
      INTEGER  NP                 ! Number of processors
 
      REAL BUFFER( NCOLS,NROWS,NLAYS3D )   ! Buffer holding (local) array 
                                           ! to be written

      INTEGER, SAVE :: WRITBUF_SIZE = 0
      INTEGER, SAVE :: RECVBUF_SIZE = 0
      INTEGER :: WSIZE, RSIZE

C External Functions:

      EXTERNAL PM3WARN        ! Parallel M3IO library

C Local Variables:

      INTEGER        MSGSIZE       ! Message size of subgrid to receive
      INTEGER        IPE           ! For loop over processors
      INTEGER        WHO           ! For identifying sending processor
      INTEGER        STATUS( MPI_STATUS_SIZE )   ! MPI status code
      INTEGER        IERROR        ! MPI error code
      LOGICAL        LERROR        ! LOCAL ERROR
      LOGICAL        RERROR        ! LOCAL MPI ALLREDUCE ERROR
      INTEGER        IR            ! Loop counter over grid rows
      INTEGER        IC            ! Loop counter over grid columns
      INTEGER        IL            ! Loop counter over grid layers
      INTEGER        C0            ! First column in global grid
      INTEGER        R0            ! First row in global grid
      INTEGER        NC            ! Number of columns in local grid
      INTEGER        NR            ! Number of rows in local grid
      CHARACTER( 16 ) :: FIL16     ! Scratch area for file-name
      CHARACTER( 16 ) :: VAR16     ! Scratch area for vble-name
      CHARACTER( 80 ) :: MSG       ! Message issued from PM3WARN routine

      INTEGER, PARAMETER :: TAG1 = 901 ! MPI message tag for processor ID
      INTEGER, PARAMETER :: TAG2 = 902 ! MPI message tag for data array.

      INTEGER  LOC

      LOGICAL :: DOT_FILE
      INTEGER :: DOT

C........................................................................

C Initialize return value and error code
      PWRGRDD = .TRUE.
      LERROR  = .FALSE.
      IERROR = 0

      IF ( ( NCOLS3D - PIO_GL_NCOLS .EQ. 1 ) .AND. 
     &     ( NROWS3D - PIO_GL_NROWS .EQ. 1 ) ) THEN
         DOT_FILE = .TRUE.
         DOT = 1
      ELSE
         DOT_FILE = .FALSE.
         DOT = 0
      END IF

      IF ( MY_PE .EQ. IO_PE ) THEN    ! I/O processor collects and writes data
         WSIZE = NCOLS3D * NROWS3D * NLAYS3D 
         RSIZE = ( NCOLS + DOT ) * ( NROWS + DOT ) * NLAYS3D

         IF ( WRITBUF_SIZE .NE. WSIZE ) THEN
            IF ( ALLOCATED ( WRITBUF ) ) DEALLOCATE ( WRITBUF )
            ALLOCATE ( WRITBUF  ( NCOLS3D, NROWS3D, NLAYS3D ), STAT = IERROR )
            IF ( IERROR .NE. 0 ) THEN
               MSG = 'Failure allocating WRITBUF '
               CALL M3EXIT( 'PWRGRDD', DATE, TIME, MSG, 1 )
            END IF
            WRITBUF_SIZE = WSIZE
         END IF

         IF ( RECVBUF_SIZE .LT. RSIZE ) THEN
            IF ( ALLOCATED ( RECVBUF ) ) DEALLOCATE ( RECVBUF )
            ALLOCATE ( RECVBUF  ( RSIZE ), STAT = IERROR )
            IF ( IERROR .NE. 0 ) THEN
               MSG = 'Failure allocating RECVBUF '
               CALL M3EXIT( 'PWRGRDD', DATE, TIME, MSG, 1 )
            END IF
            RECVBUF_SIZE = RSIZE
         END IF

C Gather the array and write it to file.

!     IF ( MY_PE .EQ. IO_PE ) THEN    ! I/O processor collects and writes data

C I/O PE copies its own local array into output buffer

         C0 = WR_COLSX_PE( 1,IO_PE+1 )
         R0 = WR_ROWSX_PE( 1,IO_PE+1 )
         NC = WR_NCOLS_PE( IO_PE+1 )
         NR = WR_NROWS_PE( IO_PE+1 )

         DO IL = 1, NLAYS3D
            DO IR = 1, NR
               DO IC = 1, NC 
                  WRITBUF( C0+IC-1,R0+IR-1,IL ) = BUFFER( IC,IR,IL )
               END DO    
            END DO    
         END DO

C I/O PE receives array from all other processors and copies it to the output
C buffer. Arrays are received in a first-come-first-serve order.  

         DO IPE = 1, NP - 1

            CALL MPI_RECV( WHO, 1, MPI_INTEGER, MPI_ANY_SOURCE, 
     &                     TAG1, MPI_COMM_WORLD, STATUS, IERROR )

            IF ( IERROR .NE. 0 ) THEN
               MSG = 'MPI error receiving processor id WHO.'
               CALL PM3WARN( 'PWRGRDD', DATE, TIME, MSG )
               LERROR = .TRUE.
            END IF

            C0 = WR_COLSX_PE( 1,WHO+1 )
            R0 = WR_ROWSX_PE( 1,WHO+1 )
            NC = WR_NCOLS_PE( WHO+1 )
            NR = WR_NROWS_PE( WHO+1 )

            MSGSIZE = NC * NR * NLAYS3D

            CALL MPI_RECV( RECVBUF, MSGSIZE, MPI_REAL, WHO,
     &                     TAG2, MPI_COMM_WORLD, STATUS, IERROR )
            IF ( IERROR .NE. 0 ) THEN
               MSG = 'MPI error receiving data array RECVBUF.'
               CALL PM3WARN( 'PWRGRDD', DATE, TIME, MSG )
               LERROR = .TRUE.
            END IF

            LOC = 0
            DO IL = 1, NLAYS3D
               DO IR = 1, NR
                  DO IC = 1, NC
                     LOC = LOC + 1
                     WRITBUF( C0+IC-1,R0+IR-1,IL ) = RECVBUF( LOC )
                  END DO    
               END DO    
            END DO

         END DO

C Write the accumulated array to file

         FIL16 = FILNAME
         VAR16 = VARNAME
         IF ( .NOT. WRITE3( FIL16, VAR16, DATE, TIME, WRITBUF ) ) THEN
            MSG = 'Could not write '
     &            // TRIM( VARNAME ) //
     &            ' to file '// TRIM( FIL16 )

            CALL PM3WARN( 'PWRGRDD', DATE, TIME, MSG )
            LERROR = .TRUE.
         END IF

      ELSE      ! Non-I/O processors send data

C Each processor, except for the I/O processor, sends its local array to
C the I/O processor.

         WHO = MY_PE
         MSGSIZE = NCOLS * NROWS * NLAYS3D

         CALL MPI_SEND( WHO, 1, MPI_INTEGER, IO_PE, TAG1,
     &                  MPI_COMM_WORLD, IERROR )

         IF ( IERROR .NE. 0 ) THEN
            MSG = 'MPI error sending processor id WHO.'
            CALL PM3WARN( 'PWRGRDD', DATE, TIME, MSG )
            LERROR = .TRUE.
         END IF

         CALL MPI_SEND( BUFFER, MSGSIZE, MPI_REAL, IO_PE, TAG2,
     &                  MPI_COMM_WORLD, IERROR )

         IF ( IERROR .NE. 0 ) THEN
            MSG = 'MPI error sending data array BUFFER.'
            CALL PM3WARN( 'PWRGRDD', DATE, TIME, MSG )
            LERROR = .TRUE.
         END IF

      END IF     ! if( my_pe .eq. io_pe )

C Notify non-I/O processors of failure

      CALL MPI_ALLREDUCE( LERROR, RERROR, 1, MPI_LOGICAL, MPI_LAND, 
     &                    MPI_COMM_WORLD, IERROR )

      IF ( IERROR .NE. 0 ) THEN
         MSG = 'MPI Allreduce error.'
         CALL PM3WARN( 'PWRGRDD', DATE, TIME, MSG )
         LERROR = .TRUE.
      END IF

      IF ( RERROR ) THEN
         MSG = 'Failed to write '
     &        // TRIM( VARNAME ) //
     &        ' from file '// TRIM( FILNAME )
         CALL PM3WARN( 'PWRGRDD', DATE, TIME, MSG )
         PWRGRDD = .FALSE.
         RETURN        ! Write failed, so return.
      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /amber/home/krt/cmq471/models/CCTM/src/vdiff/acm2_inline/opddep.F,v 1.1.1.1 2010/06/14 16:03:07 sjr Exp $
 
C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%
 
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SA_OPWDDEP ( SADEPFILE, JDATE, JTIME, TSTEP )

C20140428  Open dry or wet deposition file (SA_DD_1 or SA_WD_1 as SADEPFILE)
C          for ISAM tracers.
C
C          Called by vdiffproc.F (dry) or initscen.F (wet)

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE UTILIO_DEFN         ! 20120712 replaces ioparms, iofdesc, iodecl
      USE SA_DEFN             ! Mc06
      USE MIO_ASCII
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif


      IMPLICIT NONE
 
      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

      CHARACTER( 16 )  SADEPFILE ! Either SA_DD_1 or SA_WD_1
      INTEGER      JDATE      ! current model date, coded YYYYDDD
      INTEGER      JTIME      ! current model time, coded HHMMSS
      INTEGER      TSTEP      ! output time step

C Local variables:

      CHARACTER( 16 ) :: PNAME = 'OPWDDEP'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER      V, L     ! loop induction variables
      INTEGER      JSPCTAG  ! loop induction for the Tags

C-----------------------------------------------------------------------

C Try to open existing file for update

      IF ( .NOT. OPEN3( SADEPFILE, FSRDWR3, PNAME ) ) THEN

         XMSG = 'Could not open ' // SADEPFILE // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG( XMSG )

C Set output file characteristics based on COORD.EXT and open the dry dep file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = 10000 * ( JTIME / 10000 )   ! Clear MMSS fields
         TSTEP3D = TSTEP
         CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

         NVARS3D = N_SPCTAG  
         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D =     1
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD 
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
!        VGTPUN3D = VGTPUN_GD ! currently, not defined
         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO
!        GDNAM3D = GDNAME_GD
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         IF ( SADEPFILE .EQ. SA_DD_1 ) THEN
           XMSG = ' RADM dry '
         ELSEIF ( SADEPFILE .EQ. SA_WD_1 ) THEN
           XMSG = ' wet '
         ENDIF

         DO JSPCTAG = 1, N_SPCTAG
           VTYPE3D( JSPCTAG ) = M3REAL
           VNAME3D( JSPCTAG ) = VNAM_SPCTAG( JSPCTAG )
           UNITS3D( JSPCTAG ) = 'kg/hectare'
           VDESC3D( JSPCTAG ) = 'hourly' // XMSG( 1:LEN_TRIM(XMSG) )
     &                  // 'deposition values'
           !write(*,*) VNAM_SPCTAG( JSPCTAG ),VNAME3D(JSPCTAG), UNITS3D( JSPCTAG ),VDESC3D( JSPCTAG )
         END DO

         FDESC3D( 1 ) = 
     &      'hourly 1-layer X-point' // XMSG( 1:LEN_TRIM(XMSG) ) 
     &      // 'dep data for Tags'
         DO L = 2, MXDESC3
           FDESC3D( L ) = ' '
         END DO

         ! Store MIO Metadata
         NDIMS3D( 1:NVARS3D ) = 3
         L_TSTEP( 1:NVARS3D ) = .True.
         L_LAY  ( 1:NVARS3D ) = .False.
         L_COL  ( 1:NVARS3D ) = .True.
         L_ROW  ( 1:NVARS3D ) = .True.
         L_VEXT ( 1:NVARS3D ) = .False.
         
         CALL LOAD_MIO_FILE ( SADEPFILE, 0, 0, 0,
     &        VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &        VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &        L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &        L_VEXT(1:NVARS3D) )

C    Open dry deposition file

         IF ( .NOT. OPEN3( SADEPFILE, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// SADEPFILE // ' file'
            CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module ASX_DATA_MOD

C-----------------------------------------------------------------------
C Function: User-defined types

C Revision History:
C     19 Aug 2014 J.Bash: initial implementation
C     17 July 2015 H.Foroutan: Updated the calculation of MOL, MOLI, HOL, and WSTAR
C     25 Aug 2015 H. Pye: Added IEPOX, HACET surrogates
C                         modified PROPNN and H2O2
C                         Increased ar for ozone from 8 to 12.
C                         Change meso from 0.1 to 0 for some org. nitrates
C                         Changes based on Nguyen et al. 2015 PNAS and SOAS
C
C---------Notes
C  * Updates based on literature review 7/96 JEP
C  # Diff and H based on Wesely (1988) same as RADM
C  + Estimated by JEP 2/97
C  @ Updated by JEP 9/01
C  ~ Added by YW 1/02.  Dif0 based on Massman (1998).  Henry's Law constant
C    is defined here as: h=cg/ca, where cg is the concentration of a species
C    in gas-phase, and ca is its aqueous-phase concentration.  The smaller h,
C    the larger solubility.  Henry's Law constant in another definition (KH):
C    KH = ca/pg [M/atm], KH = KH0 * exp(-DKH/R(1/T-1/T0)), where KH0 and -DKH
C    values are from Rolf Sander (1999).  h=1/(KH*R*T).
C ** Update by DBS based on estimates by JEP 1/03
C ^^ From Bill Massman, personal communication 4/03
C ## Diffusivity calculated by SPARC, reactivity = other aldehydes
C ++ Dif0 in Massman is diffusivity at temperature 0C and 1 atm (101.325kPa), so
C    chemicals that were not in Massman's paper need to be adjusted.  We assume
C    JEP's original values were for 25C and 1 atm.
C  % Added by G. Sarwar (10/04)
C  $ Added by R. Bullock (02/05) HG diffusivity is from Massman (1999).
C    HGIIGAS diffusivity calculated from the HG value and a mol. wt. scaling
C    factor of MW**(-2/3) from EPA/600/3-87/015. ORD, Athens, GA.  HGIIGAS
C    mol.wt. used is that of HgCl2.  Reactivity of HG is 1/20th of NO and NO2
C    values based on general atmospheric lifetimes of each species.  Reactivity
C    of HGIIGAS is based on HNO3 surrogate.
C @@ Mesophyll resistances for NO, NO2, and CO added by J. Pleim (07/07) based
C    on values in Pleim, Venkatram, and Yamartino, 1984:  ADOM/TADAP Model
C    Development Program, Volume 4, The Dry Deposition Module.  ERT, Inc.,
C    Concord, MA (peer reviewed).
C ~~ Reactivity for PAN changed from 4.0 to 16.0 by J. Pleim (07/07) based on
C    comparisons with Turnipseed et al., JGR, 2006.
C %% Species ICL1 and ICL2 are removed, not used in CB05.  G. Sarwar (07/07)
C <> Hazardous Air Pollutants that are believed to undergo significant dry
C    deposition. Hydrazine and triethylamine reactivities are based on analogies
C    to NH3. Maleic anhydride reactivity is assumed similar to aldehydes.
C    Toluene diisocyanate and hexamethylene diisocyanate reactivities are
C    assumed to be similar to SO2. Diffusivities are calculated with standard
C    formulas.  W. Hutzell (04/08)
C %% G. Sarwar: added data for iodine and bromine species (03/2016)
C    D. Wong: Implemented centralized I/O approach, removed all MY_N clauses (02/2019)
C    R. Gilliam: Include PX soil texture information when available (03/2022)
C-------------------------------------------------------------------------------

      Use GRID_CONF           ! horizontal & vertical domain specifications
      Use LSM_MOD             ! Land surface data
      use centralized_io_module
      USE CONST
      Use WVEL_DEFN

      Implicit None

      Type :: MET_Type
!> 2-D meteorological fields:
         Real,    Allocatable :: RDEPVHT  ( :,: )  ! reciprocal layer 1 height [m-1]
         Real,    Allocatable :: DENS1    ( :,: )  ! layer 1 air density
         Real,    Allocatable :: PRSFC    ( :,: )  ! surface pressure [Pa]
         Real,    Allocatable :: Q2       ( :,: )  ! 2 meter water vapor mixing ratio [kg/kg]
         Real,    Allocatable :: QSS_GRND ( :,: )  ! ground saturation water vapor mixing ratio [kg/kg]
         Real,    Allocatable :: RH2      ( :,: )  ! relative humidity [percent]
         Real,    Allocatable :: RA       ( :,: )  ! aerodynamic resistance [s/m]
         Real,    Allocatable :: RS       ( :,: )  ! stomatal resistance [s/m]
         Real,    Allocatable :: RC       ( :,: )  ! convective precipitation [cm]
         Real,    Allocatable :: RN       ( :,: )  ! non-convective precipitation [cm]
         Real,    Allocatable :: RGRND    ( :,: )  ! Solar radiation at the ground [W/m**2]
         Real,    Allocatable :: HFX      ( :,: )  ! Sensible heat flux [W/m**2]
         Real,    Allocatable :: LH       ( :,: )  ! Latent heat flux [W/m**2]
         Real,    Allocatable :: SNOCOV   ( :,: )  ! Snow cover [1=yes, 0=no]
         Real,    Allocatable :: TEMP2    ( :,: )  ! two meter temperature [K]
         Real,    Allocatable :: TEMPG    ( :,: )  ! skin temperature [K]
         Real,    Allocatable :: TSEASFC  ( :,: )  ! SST [K]
         Real,    Allocatable :: USTAR    ( :,: )  ! surface friction velocity [m/s]
         Real,    Allocatable :: VEG      ( :,: )  ! fractional vegetation coverage [ratio]
         Real,    Allocatable :: LAI      ( :,: )  ! grid cell leaf area index [m**2/m**2]
         Real,    Allocatable :: WR       ( :,: )  ! precip intercepted by canopy [m]
         Real,    Allocatable :: WSPD10   ( :,: )  ! 10-m wind speed [m/s]
         Real,    Allocatable :: WSTAR    ( :,: )  ! convective velocity scale [m/s]
         Real,    Allocatable :: Z0       ( :,: )  ! roughness length [m]
         Real,    Allocatable :: SOIM1    ( :,: )  ! 1 cm soil moisture [m**3/m**3]
         Real,    Allocatable :: SOIM2    ( :,: )  ! 1 m soil moisture  [m**3/m**3]
         Real,    Allocatable :: SOIT1    ( :,: )  ! 1 cm soil temperature [K]
         Real,    Allocatable :: SOIT2    ( :,: )  ! 1 m soil temperature [K]
         Real,    Allocatable :: SEAICE   ( :,: )  ! Sea ice coverage [%]
         Real,    Allocatable :: MOL      ( :,: )  ! Monin-Obukhov length [m]
         Real,    Allocatable :: MOLI     ( :,: )  ! inverse of Monin-Obukhov length [m]
         Real,    Allocatable :: HOL      ( :,: )  ! PBL over Obukhov length
         Real,    Allocatable :: XPBL     ( :,: )  ! PBL sigma height
         Integer, Allocatable :: LPBL     ( :,: )  ! PBL layer
         Logical, Allocatable :: CONVCT   ( :,: )  ! convection flag
         Real,    Allocatable :: PBL      ( :,: )  ! pbl height (m)
         Real,    Allocatable :: NACL_EMIS( :,: )  ! NACL mass emission rate of particles with d <10 um (g/m2/s)
         Real,    Allocatable :: COSZEN   ( :,: )  ! Cosine of the zenith angle
         Real,    Allocatable :: CFRAC    ( :,: )  ! cloud fraction
!> U and V wind components on the cross grid points
         Real,    Allocatable :: UWIND    ( :,:,: )  ! [m/s]
         Real,    Allocatable :: VWIND    ( :,:,: )  ! [m/s]                    
!> 3-D meteorological fields:
         Real,    Allocatable :: KZ       ( :,:,: )  ! Kz [m**2/s]
         Real,    Allocatable :: KZMIN    ( :,:,: )  ! minimum Kz [m**2/s]
         Real,    Allocatable :: PRES     ( :,:,: )  ! pressure [Pa]
         Real,    Allocatable :: QV       ( :,:,: )  ! water vapor mixing ratio
         Real,    Allocatable :: QC       ( :,:,: )  ! cloud water mixing ratio
         Real,    Allocatable :: THETAV   ( :,:,: )  ! potential temp
         Real,    Allocatable :: TA       ( :,:,: )  ! temperature (K)
         Real,    Allocatable :: RH       ( :,:,: )  ! relative humidity (ratio)
         Real,    Allocatable :: ZH       ( :,:,: )  ! mid-layer height above ground [m]
         Real,    Allocatable :: ZF       ( :,:,: )  ! layer height [m]
         Real,    Allocatable :: DZF      ( :,:,: )  ! layer thickness
         Real,    Allocatable :: DENS     ( :,:,: )  ! air density
         Real,    Allocatable :: RJACM    ( :,:,: )  ! reciprocal mid-layer Jacobian
         Real,    Allocatable :: RJACF    ( :,:,: )  ! reciprocal full-layer Jacobian
         Real,    Allocatable :: RRHOJ    ( :,:,: )  ! reciprocal density X Jacobian
         Real,    Allocatable :: WVEL     ( :,:,: )  ! vertical velocity
      End Type MET_Type
      
      Type :: GRID_Type
!> Grid infomation:
!> Vertical information
         Real,    Allocatable :: DX3F   ( : )     ! sigma layer surface thickness ! vdiffacmx.F
         Real,    Allocatable :: RDX3F  ( : )     ! reciprocal sigma layer thickness ! EMIS_DEFN.F, sedi.F, vdiffacmx.F, vdiffproc.F
         Real,    Allocatable :: RDX3M  ( : )     ! reciprocal sigma midlayer thickness ! vdiffproc.F
!> Horizontal Information:
         Real,    Allocatable :: RMSFX4 ( :,: )  ! inverse map scale factor ** 4
         Real,    Allocatable :: LON    ( :,: )  ! longitude
         Real,    Allocatable :: LAT    ( :,: )  ! latitude
         Real,    Allocatable :: LWMASK ( :,: )  ! land water mask
         Real,    Allocatable :: OCEAN  ( :,: )  ! Open ocean
         Real,    Allocatable :: SZONE  ( :,: )  ! Surf zone
         Real,    Allocatable :: PURB   ( :,: )  ! percent urban [%]
         Integer, Allocatable :: SLTYP  ( :,: )  ! soil type [category]
         Real,    Allocatable :: WSAT   ( :,: )  ! volumetric soil saturation concentration
         Real,    Allocatable :: WWLT   ( :,: )  ! soil wilting point
         Real,    Allocatable :: BSLP   ( :,: )  ! B Slope 
         Real,    Allocatable :: WRES   ( :,: )  ! Soil residual moisture point
         Real,    Allocatable :: WFC    ( :,: )  ! soil field capacity 
         Real,    Allocatable :: CLAY_PX  ( :,: )  ! Clay fraction from PX LSM 
         Real,    Allocatable :: CSAND_PX ( :,: )  ! Coarse sand fraction from PX LSM
         Real,    Allocatable :: FMSAND_PX( :,: )  ! Fine-medium sand fraction from PX LSM
         Real,    Allocatable :: RHOB   ( :,: )  ! soil bulk density
         Real,    Allocatable :: LUFRAC ( :,:,: ) ! land use fraction (col,row,lu_type)[ratio]
C Land use information:
!         Character( 16 ), Allocatable   :: NAME    ( : )     ! LU name
!         Character( 16 ), Allocatable   :: LU_Type ( : )     ! general land use type e.g. water, forest, etc.
      End Type GRID_Type

      Type :: MOSAIC_Type                 ! (col,row,lu)
         Character( 16 ), Allocatable :: NAME    ( : ) ! LU name
         Character( 16 ), Allocatable :: LU_Type ( : ) ! general land use type e.g. water, forest, etc.
!> Sub grid cell meteorological variables:
         Real, Allocatable :: USTAR ( :,:,: )   ! surface friction velocity [m/s]
         Real, Allocatable :: LAI   ( :,:,: )   ! leaf area index [m**2/m**2]
         Real, Allocatable :: VEG   ( :,:,: )   ! vegetation fraction [ratio]
         Real, Allocatable :: Z0    ( :,:,: )   ! momentum roughness length [m]
         Real, Allocatable :: DELTA ( :,:,: )   ! Surface wetness [ratio]
!> Sub grid cell resistances
         Real, Allocatable :: RA    ( :,:,: )    ! aerodynamic resistance [s/m]
         Real, Allocatable :: RSTW  ( :,:,: )    ! Stomatal Resistance of water [s/m]
      End Type MOSAIC_Type

      Type( MET_Type ),     Save :: Met_Data 
      Type( GRID_Type ),    Save :: Grid_Data 
      Type( MOSAIC_Type ),  Save :: Mosaic_Data

!> asx constants
      Real, Parameter :: a0         = 8.0        ! [dim'less]
      Real, Parameter :: d3         = 1.38564e-2 ! [dim'less]
      Real, Parameter :: dwat       = 0.2178     ! [cm^2/s] at 273.15K
      Real, Parameter :: hplus_ap   = 1.0e-6     ! pH=6.0 leaf apoplast solution Ph (Massad et al 2008)      
      Real, Parameter :: hplus_def  = 1.0e-5     ! pH=5.0
      Real, Parameter :: hplus_east = 1.0e-5     ! pH=5.0
      Real, Parameter :: hplus_h2o  = 7.94328e-9 ! 10.0**(-8.1)
      Real, Parameter :: hplus_west = 3.16228e-6 ! 10.0**(-5.5)
      Real, Parameter :: kvis       = 0.132      ! [cm^2 / s] at 273.15K
      Real, Parameter :: pr         = 0.709      ! [dim'less]
      Real, Parameter :: rcut0      = 3000.0     ! [s/m]
      Real, Parameter :: rcw0       = 125000.0   ! acc'd'g to Padro and
      Real, Parameter :: resist_max = 1.0e30     ! maximum resistance
      Real, Parameter :: rg0        = 1000.0     ! [s/m]
      Real, Parameter :: rgwet0     = 25000.0    ! [s/m]
      Real, Parameter :: rsndiff    = 10.0       ! snow diffusivity fac
      Real, Parameter :: rsnow0     = 1000.0
      Real, Parameter :: svp2       = 17.67      ! from MM5 and WRF
      Real, Parameter :: svp3       = 29.65      ! from MM5 and WRF
      Real, Parameter :: rt25inK    = 1.0/(stdtemp + 25.0) ! 298.15K = 25C
      Real, Parameter :: twothirds  = 2.0 / 3.0
      Real, Parameter :: betah      = 5.0       ! MOST coefficient for stability correction for stable conditions 
      Real, Parameter :: gamah      = 16.0      ! MOST coefficient for stability correction for unstable conditions
      Real, Parameter :: karman     = 0.40      ! von Karman constant

      Logical, Save :: MET_INITIALIZED = .false.
      Real,    Save :: zsoil1             ! Layer 1 soil depth
      Real,    Save :: zsoil2             ! Layer 2 soil depth
      Logical, Save :: CSTAGUV            ! Winds are available with C stagger?

      Public        :: INIT_MET, GET_MET

      Integer,         Private :: C, R, L, S               ! loop induction variables
      Integer,         Private :: SPC
      Character( 16 ), Private, Save :: vname_rc, vname_rn, vname_uc, vname_vc

      Real, allocatable, Private :: BUFF1D( : )     ! 1D temp var number of layers
      Real, allocatable, Private :: BUFF2D( :,: )   ! 2D temp var
      Real, allocatable, Private :: BUFF3D( :,:,: ) ! 3D temp var

      CONTAINS

C=======================================================================
         Subroutine INIT_MET ( JDATE, JTIME )

C-----------------------------------------------------------------------
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX;
C                      allocatable RDEPVHT, RJACM, RRHOJ
C   14 Nov 03 J.Young: add reciprocal vertical Jacobian product for full and
C                      mid-layer
C   Tanya took JACOBF out of METCRO3D! Improvise
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   25 Jul 19 D.Wong: used N_SOIL_TYPE defined in LSM_Mod to handle
C                     various number of soil type from different WRF version
C-----------------------------------------------------------------------

         Use UTILIO_DEFN
         Use MOSAIC_MOD, Only: Init_Mosaic, Tile_Data
         Use LSM_Mod, only : N_SOIL_TYPE

         Implicit None
 
         Include SUBST_FILES_ID  ! file name parameters

C Arguments:
         Integer, Intent( IN ) :: JDATE, JTIME      ! internal simulation date&time

C File variables:
         Real, Pointer    :: SOILCAT ( :,: )

C Local variables:
         Character( 16 ) :: PNAME = 'INIT_MET'
         Character( 16 ) :: VNAME
         CHARACTER( 16 ) :: UNITSCK
         CHARACTER( 30 ) :: MSG1 = ' Error interpolating variable '
         Character( 96 ) :: XMSG = ' '

C for INTERPX
         Integer V
         Integer ALLOCSTAT

C-----------------------------------------------------------------------

         If ( MET_INITIALIZED ) Return

!> Allocate buffers
         ALLOCATE ( BUFF1D( NLAYS ),
     &              BUFF2D( NCOLS,NROWS ),
     &              BUFF3D( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating Buffers'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If

         BUFF1D = 0.0
         BUFF2D = 0.0
         BUFF3D = 0.0

!> Allocate shared arrays
!> Met_Data
         ALLOCATE( Met_Data%RDEPVHT  ( NCOLS,NROWS ),
     &             Met_Data%DENS1    ( NCOLS,NROWS ),
     &             Met_Data%PRSFC    ( NCOLS,NROWS ),
     &             Met_Data%Q2       ( NCOLS,NROWS ),
     &             Met_Data%QSS_GRND ( NCOLS,NROWS ),
     &             Met_Data%RH2      ( NCOLS,NROWS ),
     &             Met_Data%RA       ( NCOLS,NROWS ),
     &             Met_Data%RS       ( NCOLS,NROWS ),
     &             Met_Data%RC       ( NCOLS,NROWS ),
     &             Met_Data%RN       ( NCOLS,NROWS ),
     &             Met_Data%RGRND    ( NCOLS,NROWS ),
     &             Met_Data%HFX      ( NCOLS,NROWS ),
     &             Met_Data%LH       ( NCOLS,NROWS ),
     &             Met_Data%SNOCOV   ( NCOLS,NROWS ),
     &             Met_Data%TEMP2    ( NCOLS,NROWS ),
     &             Met_Data%TEMPG    ( NCOLS,NROWS ),
     &             Met_Data%TSEASFC  ( NCOLS,NROWS ),
     &             Met_Data%USTAR    ( NCOLS,NROWS ),
     &             Met_Data%VEG      ( NCOLS,NROWS ),
     &             Met_Data%LAI      ( NCOLS,NROWS ),
     &             Met_Data%WR       ( NCOLS,NROWS ),
     &             Met_Data%WSPD10   ( NCOLS,NROWS ),
     &             Met_Data%WSTAR    ( NCOLS,NROWS ),
     &             Met_Data%Z0       ( NCOLS,NROWS ),
     &             Met_Data%SOIM1    ( NCOLS,NROWS ),
     &             Met_Data%SOIT1    ( NCOLS,NROWS ),
     &             Met_Data%SEAICE   ( NCOLS,NROWS ),
     &             Met_Data%MOL      ( NCOLS,NROWS ),
     &             Met_Data%MOLI     ( NCOLS,NROWS ),
     &             Met_Data%HOL      ( NCOLS,NROWS ),
     &             Met_Data%XPBL     ( NCOLS,NROWS ),
     &             Met_Data%LPBL     ( NCOLS,NROWS ),
     &             Met_Data%CONVCT   ( NCOLS,NROWS ),
     &             Met_Data%PBL      ( NCOLS,NROWS ),
     &             Met_Data%NACL_EMIS( NCOLS,NROWS ),
     &             Met_Data%COSZEN   ( NCOLS,NROWS ),
     &             Met_Data%CFRAC    ( NCOLS,NROWS ),
     &             Met_Data%UWIND    ( NCOLS+1,NROWS+1,NLAYS ),
     &             Met_Data%VWIND    ( NCOLS+1,NROWS+1,NLAYS ),
     &             Met_Data%KZ       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%KZMIN    ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%PRES     ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%QV       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%QC       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%THETAV   ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%TA       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%RH       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%ZH       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%ZF       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%DZF      ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%DENS     ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%RJACM    ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%RJACF    ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%RRHOJ    ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%WVEL     ( NCOLS,NROWS,NLAYS ),
     &             STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating met vars'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If

         Met_Data%KZ = 0.0

         ALLOCATE( Grid_Data%DX3F      ( NLAYS ),
     &             Grid_Data%RDX3F     ( NLAYS ),
     &             Grid_Data%RDX3M     ( NLAYS ),
     &             Grid_Data%RMSFX4    ( NCOLS,NROWS ),
     &             Grid_Data%LON       ( NCOLS,NROWS ),
     &             Grid_Data%LAT       ( NCOLS,NROWS ),
     &             Grid_Data%LWMASK    ( NCOLS,NROWS ),
     &             Grid_Data%OCEAN     ( NCOLS,NROWS ),
     &             Grid_Data%SZONE     ( NCOLS,NROWS ),
     &             Grid_Data%PURB      ( NCOLS,NROWS ),
     &             Grid_Data%SLTYP     ( NCOLS,NROWS ),
     &             Grid_Data%WSAT      ( NCOLS,NROWS ),
     &             Grid_Data%WWLT      ( NCOLS,NROWS ),
     &             Grid_Data%BSLP      ( NCOLS,NROWS ),
     &             Grid_Data%WRES      ( NCOLS,NROWS ),
     &             Grid_Data%WFC       ( NCOLS,NROWS ),
     &             Grid_Data%CLAY_PX   ( NCOLS,NROWS ),
     &             Grid_Data%CSAND_PX  ( NCOLS,NROWS ),
     &             Grid_Data%FMSAND_PX ( NCOLS,NROWS ),
     &             Grid_Data%RHOB      ( NCOLS,NROWS ),
     &             Grid_Data%LUFRAC    ( NCOLS,NROWS,n_lufrac ),

     &             STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating grid vars'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If
         Grid_Data%WSAT    = 0.0
         Grid_Data%WWLT    = 0.0
         Grid_Data%WFC     = 0.0
         Grid_Data%CLAY_PX   = 0.0
         Grid_Data%CSAND_PX  = 0.0
         Grid_Data%FMSAND_PX = 0.0
         Grid_Data%RHOB    = 0.0
         Grid_Data%WRES    = 0.0
         Grid_Data%BSLP    = 0.0

         ALLOCATE( Met_Data%SOIM2    ( NCOLS,NROWS ),
     &             Met_Data%SOIT2    ( NCOLS,NROWS ),
     &             STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating mosaic met vars'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If

         Grid_Data%WSAT    = 0.0
         Grid_Data%WWLT    = 0.0
         Grid_Data%WFC     = 0.0
         Grid_Data%RHOB    = 0.0
         Grid_Data%WRES    = 0.0
         Grid_Data%BSLP    = 0.0

!> ccccccccccccccccccccc enable backward compatiblity ccccccccccccccccccccc

         IF (RCA_AVAIL) THEN
            vname_rc = 'RCA'
         Else
            vname_rc = 'RC'
         End If

         IF (RNA_AVAIL) THEN
            vname_rn = 'RNA'
         Else
            vname_rn = 'RN'
         End If

         If (UWINDC_AVAIL) Then
            vname_uc = 'UWINDC'
            CSTAGUV  = .TRUE.
         Else
            vname_uc = 'UWIND'
            CSTAGUV  = .FALSE.
         End If

         If (VWINDC_AVAIL) Then
            vname_vc = 'VWINDC'
         Else
            vname_vc = 'VWIND'
         End If

         If ( .Not. MINKZ ) Then
            XMSG = 'This run uses Kz0UT, *NOT* KZMIN in subroutine edyintb.'
            Write( LOGDEV,'(/5X, A, /)' ) XMSG
         End If

!> Open the met files
        
         Do L = 1, NLAYS
            Grid_Data%DX3F( L )  = X3FACE_GD( L ) - X3FACE_GD( L-1 )
            Grid_Data%RDX3F( L ) = 1.0 / Grid_Data%DX3F( L )
            BUFF1D( L ) = 0.5 * ( X3FACE_GD( L ) + X3FACE_GD( L-1 ) )
         End Do
         Do L = 1, NLAYS - 1
            Grid_Data%RDX3M( L ) = 1.0 / ( BUFF1D( L+1 ) - BUFF1D( L ) )
         End Do
         Grid_Data%RDX3M( NLAYS ) = 0.0

!> reciprical of msfx2**2
         Grid_Data%RMSFX4 = 1.0 / ( MSFX2**2 )

         Grid_Data%LON = LON

         Grid_Data%LAT = LAT

         Grid_Data%LWMASK = LWMASK

         Grid_Data%PURB = PURB

         Grid_Data%SLTYP = NINT( SOILCAT_A )

         Grid_Data%LUFRAC = LUFRAC

         If( PX_LSM ) Then
            Write(Logdev,*) 'MCIP/WRF used the PX LSM'
            zsoil1 = 0.01
            zsoil2 = 0.05 ! For abflux estimated from 1cm and 1 meter 
! Estimate a constistent soil hydrolic suction at saturation using the JN90 properties to
! calculate soil hydrolic proerties constistant with JN90 data. Note that the suction at 
! feild capacity is typically 33 kPa, wilting point is 1500 kPa and residual water content
! is between 1.0e5 and 1.0e6 kPa and 3.0e5 kPa is used here following Campbell and Norman 1998             
            Psi_Sat =1500.0 * ( WWLT_PX / WSAT_PX )**BSLP_PX 
            WFC_PX  = WSAT_PX * ( 33.0 / Psi_sat )**(-1.0/BSLP_PX)
            WRES_PX = WSAT_PX * ( 3.0e5 / Psi_sat )**(-1.0/BSLP_PX)

            Forall( C = 1:NCOLS, R = 1:NROWS, Grid_Data%SLTYP(C,R) .Le. N_SOIL_TYPE )
               Grid_Data%WSAT( C,R ) = WSAT_PX( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WWLT( C,R ) = WWLT_PX( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WFC ( C,R ) = WFC_PX ( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WRES( C,R ) = WRES_PX( Grid_Data%SLTYP( C,R ) )
               Grid_Data%BSLP( C,R ) = BSLP_PX( Grid_Data%SLTYP( C,R ) )
               Grid_Data%RHOB( C,R ) = RHOB_PX( Grid_Data%SLTYP( C,R ) )
            End Forall
! for cases where the default soil is water but fractional land use may not be water
! use sandy loam
            Forall( C = 1:NCOLS, R = 1:NROWS, Grid_Data%SLTYP(C,R) .Gt. N_SOIL_TYPE )
               Grid_Data%WSAT( C,R ) = WSAT_PX( 3 )
               Grid_Data%WWLT( C,R ) = WWLT_PX( 3 )
               Grid_Data%WFC ( C,R ) = WFC_PX ( 3 )
               Grid_Data%WRES( C,R ) = WRES_PX( 3 )
               Grid_Data%BSLP( C,R ) = BSLP_PX( 3 )
               Grid_Data%RHOB( C,R ) = RHOB_PX( 3 )
            End Forall
         Else If( Noah_LSM ) Then
            Write(Logdev,*) 'MCIP/WRF used the Noah LSM'
            zsoil1 = 0.01 ! Adjusted based on Darmenova et al. 2009 doi:10.1029/2008JD011236
            zsoil2 = 0.05 ! For abflux estimated from 1cm and 1 meter 
            Forall( C = 1:NCOLS, R = 1:NROWS )
               Grid_Data%WSAT( C,R ) = WSAT_NOAH( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WWLT( C,R ) = WWLT_NOAH( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WFC ( C,R ) = WFC_NOAH ( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WRES( C,R ) = WRES_NOAH( Grid_Data%SLTYP( C,R ) )
               Grid_Data%BSLP( C,R ) = BSLP_NOAH( Grid_Data%SLTYP( C,R ) )
               Grid_Data%RHOB( C,R ) = RHOB_NOAH( Grid_Data%SLTYP( C,R ) )
            End Forall
         Else If( CLM_LSM ) Then
            Write(Logdev,*) 'MCIP/WRF used the CLM LSM'
            zsoil1 = 0.0175
            zsoil2 = 0.0451
            Forall( C = 1:NCOLS, R = 1:NROWS )
               Grid_Data%WSAT( C,R ) = WSAT_CLM( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WWLT( C,R ) = WWLT_CLM( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WFC ( C,R ) = WFC_CLM ( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WRES( C,R ) = WRES_CLM( Grid_Data%SLTYP( C,R ) )
               Grid_Data%BSLP( C,R ) = BSLP_CLM( Grid_Data%SLTYP( C,R ) )
               Grid_Data%RHOB( C,R ) = RHOB_CLM( Grid_Data%SLTYP( C,R ) )
            End Forall                            
        End If

         Grid_Data%OCEAN = ocean

         Grid_Data%SZONE = szone

         CALL INIT_MOSAIC( JDATE, JTIME, Grid_Data%LUFRAC )

         ALLOCATE( Mosaic_Data%USTAR   ( NCOLS,NROWS,Tile_Data%n_lufrac ),
     &             Mosaic_Data%LAI     ( NCOLS,NROWS,Tile_Data%n_lufrac ),
     &             Mosaic_Data%DELTA   ( NCOLS,NROWS,Tile_Data%n_lufrac ),
     &             Mosaic_Data%VEG     ( NCOLS,NROWS,Tile_Data%n_lufrac ),
     &             Mosaic_Data%Z0      ( NCOLS,NROWS,Tile_Data%n_lufrac ),
     &             Mosaic_Data%RA      ( NCOLS,NROWS,Tile_Data%n_lufrac ),
     &             Mosaic_Data%RSTW    ( NCOLS,NROWS,Tile_Data%n_lufrac ),
     &             Mosaic_Data%NAME    ( Tile_Data%n_lufrac ),
     &             Mosaic_Data%LU_Type ( Tile_Data%n_lufrac ),
     &             STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating mosaic vars'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If
         Mosaic_Data%USTAR   = 0.0
         Mosaic_Data%LAI     = 0.0
         Mosaic_Data%DELTA   = 0.0
         Mosaic_Data%VEG     = 0.0
         Mosaic_Data%Z0      = 0.0
         Mosaic_Data%RSTW    = 1.0e6
         Mosaic_Data%RA      = 1.0e6
         Mosaic_Data%NAME    = Tile_Data%name_lu
         Mosaic_Data%LU_Type = Tile_Data%cat_lu     

         MET_INITIALIZED = .true.

         Return
         End Subroutine INIT_MET

C=======================================================================
         Subroutine GET_MET ( JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX;
C                      allocatable RDEPVHT, RJACM, RRHOJ
C   14 Nov 03 J.Young: add reciprocal vertical Jacobian product for full and
C                      mid-layer
C   Tanya took JACOBF out of METCRO3D! Improvise
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------

         USE GRID_CONF       ! horizontal & vertical domain specifications
         Use UTILIO_DEFN
         USE MOSAIC_MOD
#ifdef parallel
         USE SE_MODULES      ! stenex (using SE_COMM_MODULE)
#else
         USE NOOP_MODULES    ! stenex (using NOOP_COMM_MODULE)
#endif

         Implicit None
 
         Include SUBST_FILES_ID  ! file name parameters
         Include SUBST_PE_COMM   ! PE communication displacement and direction

C Arguments:

         Integer, Intent( IN ) :: JDATE, JTIME, TSTEP      ! internal simulation date&time

C Parameters:
         Real, Parameter :: cond_min = 1.0 / resist_max ! minimum conductance [m/s]
         Real, Parameter :: KZMAXL = 500.0    ! upper limit for min Kz [m]
         Real, Parameter :: KZ0UT  = 1.0      ! minimum eddy diffusivity [m**2/sec] KZ0
         Real, Parameter :: KZL    = 0.01     ! lowest KZ
         Real, Parameter :: KZU    = 1.0      ! 2.0  ! highest KZ
         Real, Parameter :: EPS    = 1.0E-08  ! small number for temperature difference

C Local variables:
         Real    FINT
         Real    CPAIR, LV, QST 
         Real    TMPFX, TMPVTCON, TST, TSTV
         Integer LP
         Integer C, R, L         ! loop induction variables

         Character( 16 ) :: PNAME = 'GET_MET'
         Character( 16 ) :: VNAME
         CharactER( 30 ) :: MSG1 = ' Error interpolating variable '
         Character( 96 ) :: XMSG = ' '

C-----------------------------------------------------------------------
C Check consistency with WRF LSM and CMAQ options
C-----------------------------------------------------------------------
         If( .Not. PX_LSM .And. .Not. CLM_LSM .And. .Not. NOAH_LSM ) Then
            XMSG = 'WRF LSM is not supported. PX, CLM and NOAH are supported'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            If( ABFLUX ) Then
               XMSG = 'NH3 bidirectional exchange is not supported using this WRF LSM option. Set CTM_ABFLUX to N.'
               Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            End IF
            If( HGBIDI ) Then
               XMSG = 'Hg bidirectional exchange is not supported using this WRF LSM option. Set CTM_HGBIDI to N.'
               Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            End IF
         End IF

C-----------------------------------------------------------------------
C Interpolate file input variables and format for output
C-------------------------------- MET_CRO_3D --------------------------------
      
         call interpolate_var ('ZH', jdate, jtime, Met_Data%ZH)

         call interpolate_var ('PRES', jdate, jtime, Met_Data%PRES)

         call interpolate_var ('ZF', jdate, jtime, Met_Data%ZF)

         call interpolate_var ('DENS', jdate, jtime, Met_Data%DENS)

         Met_Data%DENS1 = Met_Data%DENS( :,:,1 )

         call interpolate_var ('JACOBM', jdate, jtime, Met_Data%RJACM)
     
         call interpolate_var ('JACOBF', jdate, jtime, Met_Data%RJACF)

         ! Calculate Vertical Velocity
         ! RJACM and RJACF are not yet reciprocals. They are the actual
         ! Jacobians.
         IF ( W_VEL ) THEN
            DO L = 1,NLAYS
               IF ( JACOBF_AVAIL ) THEN
                  Met_Data%WVEL( :,:,L ) = MSFX2( :,: ) * WY( L,:,: ) * Met_Data%RJACF( :,:,L )
               ELSE
                  If ( L .LT. NLAYS ) THEN
                     Met_Data%WVEL( :,:,L ) = MSFX2( :,: ) * WY( L,:,: ) * 0.5 *
     &                                         ( Met_Data%RJACM(:,:,L) +
     &                                           Met_Data%RJACM(:,:,L+1) )
                  ELSE
                     Met_Data%WVEL( :,:,L ) = MSFX2( :,: ) * WY( L,:,: ) * 0.4 *
     &                                         ( Met_Data%RJACF(:,:,L-1)+
     &                                           Met_Data%RJACM(:,:,L)   )
                  END IF
               END IF
            END DO
         ELSE
            Met_Data%WVEL = 0.0
         END IF
         
         ! Now convert RJACM and RJACF to reciprocals 
         Met_Data%RJACM = 1.0 / Met_Data%RJACM
         Met_Data%RJACF = 1.0 / Met_Data%RJACF 


         call interpolate_var ('DENSA_J', jdate, jtime, Met_Data%RRHOJ)

         Met_Data%RRHOJ = 1.0 / Met_Data%RRHOJ

         call interpolate_var ('TA', jdate, jtime, Met_Data%TA)

         call interpolate_var ('QV', jdate, jtime, Met_Data%QV)

         call interpolate_var ('QC', jdate, jtime, Met_Data%QC)

C-------------------------------- MET_CRO_2D --------------------------------
C Vegetation and surface vars
         call interpolate_var ('LAI', jdate, jtime, Met_Data%LAI)

         call interpolate_var ('VEG', jdate, jtime, Met_Data%VEG)

         call interpolate_var ('ZRUF', jdate, jtime, Met_Data%Z0)

C Soil vars
         call interpolate_var ('SOIM1', jdate, jtime, Met_Data%SOIM1)

         call interpolate_var ('SOIM2', jdate, jtime, Met_Data%SOIM2)

         call interpolate_var ('SOIT2', jdate, jtime, Met_Data%SOIT2)

         call interpolate_var ('SOIT1', jdate, jtime, Met_Data%SOIT1)

         call interpolate_var ('SEAICE', jdate, jtime, Met_Data%SEAICE)

C met vars

         call interpolate_var ('PRSFC', jdate, jtime, Met_Data%PRSFC)

         call interpolate_var ('RGRND', jdate, jtime, Met_Data%RGRND)

         call interpolate_var ('SNOCOV', jdate, jtime, Met_Data%SNOCOV)

         Where( Met_Data%SNOCOV .Lt. 0.0 )
            Met_Data%SNOCOV = 0.0
         End Where

         call interpolate_var ('TEMP2', jdate, jtime, Met_Data%TEMP2)

         call interpolate_var ('TEMPG', jdate, jtime, Met_Data%TEMPG)

         call interpolate_var ('USTAR', jdate, jtime, Met_Data%USTAR)

         call interpolate_var ('WSPD10', jdate, jtime, Met_Data%WSPD10)

         call interpolate_var ('HFX', jdate, jtime, Met_Data%HFX)

         If ( LH_AVAIL ) Then
            call interpolate_var ('LH', jdate, jtime, Met_Data%LH)
         Else   ! for backward compatibility
            call interpolate_var ('QFX', jdate, jtime, Met_Data%LH)
         End If

         call interpolate_var ('PBL', jdate, jtime, Met_Data%PBL)

C Update for WRFV4.1+ PX LSM runs that have soil texture in output for
C  CMAQ dust scheme. These are initialized to 0 if not present in MCIP.
C  DUST_EMIS.F will use table lookup values if 0 (old WRF or other LSMs).  
         If ( PXSOIL_AVAIL ) Then
            call interpolate_var ('CLAY_PX',   jdate, jtime, Grid_Data%CLAY_PX)
            call interpolate_var ('CSAND_PX',  jdate, jtime, Grid_Data%CSAND_PX)
            call interpolate_var ('FMSAND_PX', jdate, jtime, Grid_Data%FMSAND_PX)
            call interpolate_var ('WSAT_PX', jdate, jtime, Grid_Data%WSAT)
            call interpolate_var ('WFC_PX',  jdate, jtime, Grid_Data%WFC)
            call interpolate_var ('WWLT_PX', jdate, jtime, Grid_Data%WWLT)
         End If

C Met_cro_2D variables that have recently changed due to MCIP or WRF/CMAQ

         call interpolate_var (vname_rn, jdate, jtime, Met_Data%RN)

         call interpolate_var (vname_rc, jdate, jtime, Met_Data%RC)

         ! Comment out for 1 km North Carolina domain with no CFRAC on
         ! the METCRO2D file.
         !call interpolate_var ('CFRAC', jdate, jtime, Met_Data%CFRAC)

         If ( WR_AVAIL ) Then
            call interpolate_var ('WR', jdate, jtime, Met_Data%WR)
         Else 
            Met_Data%WR = 0.0 
         End If

         If ( TSEASFC_AVAIL ) Then
            call interpolate_var ('TSEASFC', jdate, jtime, Met_Data%TSEASFC)
         Else
            Met_Data%TSEASFC = Met_Data%TEMPG
         End If

         If ( .not. RA_RS_AVAIL ) Then
            call interpolate_var ('RADYNI', jdate, jtime, Met_Data%RA)

            Where( Met_Data%RA .Gt. cond_min ) 
               Met_Data%RA = 1.0/Met_Data%RA
            Elsewhere
               Met_Data%RA = resist_max
            End Where

            call interpolate_var ('RSTOMI', jdate, jtime, Met_Data%RS)

            Where( Met_Data%RS .Gt. cond_min ) 
               Met_Data%RS = 1.0 / Met_Data%RS
            Elsewhere 
               Met_Data%RS = resist_max
            End Where

         Else 

            call interpolate_var ('RA', jdate, jtime, Met_Data%RA)

            call interpolate_var ('RS', jdate, jtime, Met_Data%RS)

         End If

         If ( Q2_AVAIL ) Then  ! Q2 in METCRO2D
            call interpolate_var ('Q2', jdate, jtime, Met_Data%Q2)
         Else
            Met_Data%Q2 = Met_Data%QV( :,:,1 )
         End If
         
         Where( Met_Data%TEMPG .Lt. stdtemp )
            BUFF2D = vp0 *Exp( 22.514 - ( 6.15e3 / Met_Data%TEMPG ) )
         Elsewhere
            BUFF2D = vp0 *Exp( svp2 * ( Met_Data%TEMPG -stdtemp ) / ( Met_Data%TEMPG -svp3 ) ) 
         End Where
         Met_Data%QSS_GRND = BUFF2D * 0.622 / ( Met_Data%PRSFC - BUFF2D )

         Where( Met_Data%TEMP2 .Lt. stdtemp )
            BUFF2D = vp0 *Exp( 22.514 - ( 6.15e3 / Met_Data%TEMP2 ) )
         Elsewhere
            BUFF2D = vp0 *Exp( svp2 * ( Met_Data%TEMP2 -stdtemp ) / ( Met_Data%TEMP2 -svp3 ) ) 
         End Where

         ! Calculate Relative Humidity at 2m
         Met_Data%RH2 = Met_Data%Q2 / ( BUFF2D * 0.622 / ( Met_Data%PRSFC - BUFF2D ) ) * 100.0
         Where( Met_Data%RH2 .Gt. 100.0 )
            Met_Data%RH2 = 100.0
         Elsewhere( Met_Data%RH2 .lt. 0.0 )
            Met_Data%RH2 = 0.0
         End Where

         ! Calculate 3D Relative Humidity at Grid Scale
         MET_DATA%RH = MET_DATA%QV * MET_DATA%PRES / ( MET_DATA%QV + 0.622015 ) /
     &                 ( 610.94 * EXP( 17.625 * ( MET_DATA%TA - 273.15 ) / 
     &                                 ( MET_DATA%TA - 273.15 + 243.04 ) ) )
         MET_DATA%RH = MIN( 0.9999, MAX( 0.001, MET_DATA%RH ) )
 

C-------------------------------- MET_DOT_3D --------------------------------
         call interpolate_var (vname_uc, jdate, jtime, Met_Data%UWIND)

         call interpolate_var (vname_vc, jdate, jtime, Met_Data%VWIND)

C get ghost values for wind fields in case of free trop.
         CALL SUBST_COMM ( Met_Data%UWIND, DSPL_N0_E1_S0_W0, DRCN_E )
         CALL SUBST_COMM ( Met_Data%VWIND, DSPL_N1_E0_S0_W0, DRCN_N )

C-------------------------------- Calculated Variables --------------------------------
         Met_Data%DZF = Met_Data%ZF - EOSHIFT(Met_Data%ZF, Shift = -1, Boundary = 0.0, Dim = 3)

         Met_Data%RDEPVHT = 1.0 / Met_Data%ZF( :,:,1 )

         IF ( MINKZ ) THEN
            Met_Data%KZMIN = KZL
            DO L = 1, NLAYS
               Where( Met_Data%ZF( :,:,L ) .LE. KZMAXL )
                  Met_Data%KZMIN( :,:,L ) = KZL + ( KZU - KZL ) * 0.01 * Grid_data%PURB
               End Where
            End Do
         ELSE
            Met_Data%KZMIN = KZ0UT
         END IF

         BUFF3D = Met_Data%TA * ( 1.0 + 0.608 * Met_Data%QV )
         Met_Data%THETAV = BUFF3D * ( P0 / Met_Data%PRES ) ** 0.286

C------  Updating MOL, then WSTAR, MOLI, HOL 
         DO R = 1, NROWS
            DO C = 1, NCOLS
               CPAIR    = CPD * ( 1.0 + 0.84 * Met_Data%QV( C,R,1 ) )   ! J/(K KG)
               TMPFX    = Met_Data%HFX( C,R ) / ( CPAIR * Met_Data%DENS( C,R,1 ) )
               TMPVTCON = 1.0 + 0.608 * Met_Data%QV( C,R,1 )  ! Conversion factor for virtual temperature
               TST      = -TMPFX / Met_Data%USTAR( C,R )
               IF ( Met_Data%TA( C,R,1 ) .GT. STDTEMP ) THEN
                  LV = LV0 - ( 0.00237 * ( Met_Data%TA( C,R,1 ) - STDTEMP ) ) * 1.0E6
               ELSE
                  LV = 2.83E6     ! Latent heat of sublimation at 0C from Stull (1988) (J/KG)
               END IF
               QST  = -( Met_Data%LH( C,R ) / LV )
     &              / ( Met_Data%USTAR( C,R ) * Met_Data%DENS( C,R,1 ) )
               TSTV = TST * TMPVTCON + Met_Data%THETAV( C,R,1 ) * 0.608 * QST
               IF ( ABS( TSTV ) .LT. 1.0E-6 ) THEN
                  TSTV = SIGN( 1.0E-6, TSTV )
               END IF
               Met_Data%MOL( C,R ) = Met_Data%THETAV( C,R,1 )
     &                             * Met_Data%USTAR( C,R ) ** 2 / ( karman * GRAV * TSTV )
               IF ( Met_Data%MOL( C,R ) .LT. 0.0 ) THEN
                  Met_Data%WSTAR( C,R ) = Met_Data%USTAR( C,R ) * ( Met_Data%PBL( C,R )
     &                                  / ( karman * ABS( Met_Data%MOL( C,R ) ) ) ) ** 0.333333
               ELSE
                  Met_Data%WSTAR( C,R ) = 0.0
               END IF

            END DO
         END DO
   
         Met_Data%MOLI  = 1.0 / Met_Data%MOL 
         Met_Data%HOL   = Met_Data%PBL / Met_Data%MOL
C------

         Met_Data%CONVCT = .FALSE.
         DO R = 1, NROWS
            DO C = 1, NCOLS
               DO L = 1, NLAYS
                  IF ( Met_Data%PBL( C,R ) .LT. Met_Data%ZF( C,R,L ) ) THEN
                     LP = L; EXIT
                  END IF
               END DO

               Met_Data%LPBL( C,R ) = LP
               If ( LP .Eq. 1 ) Then
                  FINT = ( Met_Data%PBL( C,R ) )
     &                 / ( Met_Data%ZF( C,R,LP ) )
                  Met_Data%XPBL( C,R ) = FINT * ( X3FACE_GD( LP ) - X3FACE_GD( LP-1 ) )
     &                        + X3FACE_GD( LP-1 )
               Else
                  FINT = ( Met_Data%PBL( C,R )   - Met_Data%ZF( C,R,LP-1 ) )
     &                 / ( Met_Data%ZF( C,R,LP ) - Met_Data%ZF( C,R,LP-1 ) )
                  Met_Data%XPBL( C,R ) = FINT * ( X3FACE_GD( LP ) - X3FACE_GD( LP-1 ) )
     &                        + X3FACE_GD( LP-1 )
               End If
            END DO
         END DO
         Where( Met_Data%THETAV( :,:,1 ) - Met_Data%THETAV( :,:,2 ) .Gt. EPS .And.
     &          Met_Data%HOL .Lt. -0.02 .And. Met_Data%LPBL .Gt. 3 )
            Met_Data%CONVCT = .True.
         End Where

C-------------------------------- TILE_CRO_2D --------------------------------
C read in land use specific meteorology from WRF Noah or Ruc mosaic options

         CALL CALC_LAI( JDATE, JTIME, MET_DATA%SOIT2, MET_DATA%LAI,
     &                  MET_DATA%VEG, MOSAIC_DATA%VEG, MOSAIC_DATA%LAI, MOSAIC_DATA%Z0 )

         CALL ra_wrf( MET_DATA%MOLI, MET_DATA%ZH, MET_DATA%RA, MET_DATA%Z0, 
     &                MOSAIC_DATA%Z0, MET_DATA%USTAR, MOSAIC_DATA%USTAR,
     &                MOSAIC_DATA%RA, gamah, betah, karman )       

         CALL MOS_RSTW( MOSAIC_DATA%LAI, Met_Data%RGRND, Met_Data%SOIM2, 
     &                  Grid_Data%WWLT, Grid_Data%WFC, Met_Data%TEMP2, MOSAIC_DATA%RA, MOSAIC_DATA%USTAR, 
     &                  MET_DATA%QSS_GRND, MET_DATA%QV, Met_Data%RS, Mosaic_Data%RSTW )

         CALL MOS_CanWat( MOSAIC_DATA%VEG, MOSAIC_DATA%LAI, Met_Data%WR, Mosaic_Data%DELTA, 
     &                    WR_AVAIL, Met_Data%Q2, Met_Data%QSS_GRND, Met_Data%RN, Met_Data%RC, Met_Data%WSPD10, 
     &                    Met_Data%RGRND, jdate, jtime)

!        Calculate the cosine of the zenith angle 
         CALL CZANGLE( JDATE, JTIME, NCOLS, NROWS )

         Return
         End Subroutine GET_MET

      End Module ASX_DATA_MOD

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C=======================================================================
      SUBROUTINE PA_MKHDR ( TYPE, NFL, OUTFNAME, SDATE, STIME, TSTEP )

C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   16 Sep 16 J.Young: update for inline procan

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      USE PA_DEFN               ! Process Anaylsis control and data variables
      USE PAGRD_DEFN            ! PA horiz domain specs
      USE MIO_ASCII

      IMPLICIT NONE

C used in pa_init
C FIRSTIME gets some FDESC3 common variables from GRID_CONF to be used
C for both IPR and IRR if needed.

C Arguments:
      CHARACTER( 3 ) ::  TYPE   ! IPR or IRR
      INTEGER NFL               ! file sequence no.
      CHARACTER( 16 ) :: OUTFNAME  ! Assigned IPR or IRR output file name
      INTEGER SDATE             ! starting date,    format YYYYDDD
      INTEGER STIME             ! starting time,    format HHMMSS
      INTEGER TSTEP( 3 )        ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency

C Local Variables:
      INTEGER AE_INDX   ! Index for aerosol species
      INTEGER IPRSPC    ! Index for IPR species
      INTEGER PL        ! Index for PA output level
      INTEGER VARINDX   ! Index for output variable
      INTEGER L, NOUT   ! Loop indicies
      INTEGER NSP, NPR  ! Loop indices for finding IPR species
      INTEGER ICG       ! species pointer

      CHARACTER( 16 ) ::  PNAME = 'PA_MKHDR'  ! Subroutine Name

C-----------------------------------------------------------------------

#ifndef mpas
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Get file header description from GRID_CONF and reconfigure output domain
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      P_ALP3D = P_ALP_GD
      P_BET3D = P_BET_GD
      P_GAM3D = P_GAM_GD

      XCENT3D = XCENT_GD
      YCENT3D = YCENT_GD
      XORIG3D = XORIG_GD
      YORIG3D = YORIG_GD
      XCELL3D = XCELL_GD
      YCELL3D = YCELL_GD

      VGTYP3D = VGTYP_GD
      VGTOP3D = VGTOP_GD

      FTYPE3D = GRDDED3
      GDNAM3D = GDNAME_GD
      UPNAM3D = PNAME

      SDATE3D = SDATE
      STIME3D = STIME
      CALL NEXTIME( SDATE3D, STIME3D, TSTEP( 1 ) )
      TSTEP3D = TSTEP( 1 )

      NCOLS3D = PACOLS
      NROWS3D = PAROWS
      NLAYS3D = PALEVS

      XORIG3D = XORIG3D + DBLE( PA_BEGCOL - 1 ) * XCELL3D
      YORIG3D = YORIG3D + DBLE( PA_BEGROW - 1 ) * YCELL3D

      DO L = PA_BEGLEV, PA_ENDLEV + 1
         PL = L - PA_BEGLEV + 1
         VGLVS3D ( PL ) = VGLVS_GD( L )
      END DO

      IF ( TYPE .EQ. 'IPR' ) THEN

         FDESC3D( 1 ) = 'Integrated Process Rates Output File ' // OUTFNAME
         NVARS3D = MIN( MXVARS3 , ( NIPRVAR - ( NFL - 1 ) * MXVARS3 ) )

         DO NOUT = 1, NVARS3D
            VARINDX = ( NFL - 1 ) * MXVARS3 + NOUT
            VNAME3D( NOUT ) = IPRNAME( VARINDX )
            VTYPE3D( NOUT ) = M3REAL
            VDESC3D( NOUT ) = IPRDESC( VARINDX )

            ! Find the IPR species to set correct units descriptor
            IPRSPC = MAP_IPRVARtoSPC( VARINDX )
            ICG = MAP_IPRtoCGRID( IPRSPC, 1 )

            IF ( CGRID_MASK_NUM( ICG ) ) THEN
               UNITS3D( NOUT ) = 'm-3'
            ELSE IF ( CGRID_MASK_SRF( ICG ) ) THEN
               UNITS3D( NOUT ) = 'm2 m-3'
            ELSE IF ( CGRID_MASK_AERO( ICG ) ) THEN
               UNITS3D( NOUT ) = 'ug m-3'
            ELSE 
               UNITS3D( NOUT ) = 'ppmV'
            END IF

         END DO

      ELSE IF ( TYPE .EQ. 'IRR' ) THEN

         FDESC3D( 1 ) = 'Integrated Reaction Rate Output File ' // OUTFNAME
         NVARS3D = MIN( MXVARS3 , ( NIRRVAR - ( ( NFL - 1 ) * MXVARS3 ) ) )

         DO NOUT = 1, NVARS3D
            VARINDX = ( NFL - 1 ) * MXVARS3 + NOUT
            VNAME3D( NOUT ) = IRRNAME( VARINDX )
            VTYPE3D( NOUT ) = M3REAL
            UNITS3D( NOUT ) = 'ppmV'
            VDESC3D( NOUT ) = IRRDESC( VARINDX )
         END DO

      ELSE

         CALL M3EXIT( PNAME, SDATE, STIME,
     &        'Incorrect process analysis type specified', 2 )

      END IF

      ! Store MIO Metadata
      NDIMS3D( 1:NVARS3D ) = 4
      L_TSTEP( 1:NVARS3D ) = .True.
      L_LAY  ( 1:NVARS3D ) = .True.
      L_COL  ( 1:NVARS3D ) = .True.
      L_ROW  ( 1:NVARS3D ) = .True.
      L_VEXT ( 1:NVARS3D ) = .False.

      CALL LOAD_MIO_FILE ( OUTFNAME, NLAYS3D, PA_BEGLEV, PA_ENDLEV,
     &     VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &     VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &     L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &     L_VEXT(1:NVARS3D) )


#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module sedimentation

C Revision History:
C 03 Jul 15 J.Young: initial

      use const

      implicit none

      public sedi

      private

      include SUBST_FILES_ID  ! file name parameters

      real,    allocatable, save :: cgrd( :,: )   ! density units
      real,    allocatable, save :: conc( :,: )   ! mixing ratio units
#ifdef isam
      real(8), allocatable, save :: conc_isam( :,:,: )      ! extracted isam mixing ratio units
#endif

      real,    allocatable, save :: ldens( : )    ! local density kg m-3

      integer, save :: nqae              ! number of micro-grams/m**3 species
      integer, save :: nnae              ! number of #/m**3 species
      integer, save :: nsae              ! number of m**2/m**3 species
      integer, save :: cg_off            ! cngrd offset to aero species
      integer, allocatable, save :: qae( : ) ! cgrd pointer to micro-grams/m**3 species
      integer, allocatable, save :: nae( : ) ! cgrd pointer to #/m**3 species
      integer, allocatable, save :: sae( : ) ! cgrd pointer to m**2/m**3 species
      real,    allocatable, save :: molwt( : ) ! only for "qae" species
!     integer, save :: odate, otime
      real    conv, fac            ! temp var
      integer ios

      integer gxoff, gyoff         ! global origin offset from file
C for interpx
      integer, save :: strtcolmc3, endcolmc3, strtrowmc3, endrowmc3
      integer, allocatable, save :: map_sedi2cgrid( : )
      integer, save :: n_sedi_map   ! aero species, all modes
#ifdef isam
      integer,              save :: n_isam_sedi_map  ! isam aero species, all modes
      integer, allocatable, save :: isam_sedi_map( : )
#endif

      contains

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine sedi ( jdate, jtime, dtsec, sedvel, cgrid, cngrd )
C Revision History:
C           J.Young, J.Pleim: inital
C 07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C 05 Mar 15 J.Pleim: correct layer thickness index off by 1
C 15 Jul 15 J.Young: correct sub timestep calculation and apply Martin Otte`s
C                    correction for the first-order upstream sedimentation
C  1 Feb 19 David Wong: removed all MY_N clauses
C-----------------------------------------------------------------------

      use cgrid_spcs          ! cgrd mechanism species
      use grid_conf
      use asx_data_mod
      use vdiff_map
      use utilio_defn
      use vdiff_diag, dtccr => dtccr_mean
#ifdef isam
      use sa_defn
#endif

      implicit none

C Arguments:
      integer, intent( in )    :: jdate, jtime       !
      real,    intent( in )    :: dtsec              ! model time step in seconds
C grav settling velocity applies only to coarse mode aerosols (J-,K-mode), but the VGS
C array is filled for *all* cgrd diffused species. VGS is set to zero for all the non-
C coarse mode aerosols.
      real,    intent( out )   :: sedvel( :,:,:,: )  ! grav settling vel. for diagnostic
      real,    pointer         :: cgrid ( :,:,:,: )
      real,    intent( inout ) :: cngrd ( :,:,:,: )  ! cgrid replacement

c Parameters:
      real, parameter :: alpha = 1.1
!     real, parameter :: alpha = 2.0

c External Functions:

C Local Variables:

      character( 120 ) :: xmsg = ' '
      character( 16 ), save :: pname = 'SEDI'
      logical, save :: firstime = .TRUE.

      real,    allocatable, save :: vsed    ( :,: ) ! settling vel.
      real,    allocatable, save :: vsed_ae ( :,: ) ! settling vel.
      real,    allocatable, save :: dtsvsed ( :,: ) ! settling vel. factor
      real,    allocatable, save :: sumvsed ( :,: ) ! for diagnostics
      real,    allocatable, save :: rdl     ( : )   ! subloop var
      real,    allocatable, save :: rrhodz  ( : )   ! reciprocal rho * deltaZ
      integer, allocatable, save :: sedi_map( : )
      integer, allocatable, save :: conc_map( : )
#ifdef isam
      integer, allocatable, save :: map_sedi_to_isam( : )
      real,    allocatable, save :: isam_dtsvsed ( : ) ! isam settling vel. factor
#endif
      real       adts, dts, rdts
      real       ldt, fs
      integer    off, dtc, iter 
      integer    c, r, l, n, s, v
      integer    astat
      integer    mdate, mtime

      interface   ! for external procedures
         subroutine aero_sedv ( col, row, cgrd, vsed_ae )
            integer, intent( in )  :: col, row
            real,    intent( in )  :: cgrd( :,: )
            real,    intent( out ) :: vsed_ae( :,: )
         end subroutine aero_sedv
      end interface

C-----------------------------------------------------------------------

      if ( firstime ) then

         firstime = .false.

         mdate = 0; mtime = 0

c sedi_map - from ae_trns to ae_spc (currently, all ae spc`s are transported)
c conc_map - from cgrid to ae_trns species
         allocate ( sedi_map( n_ae_spc ),
     &              map_sedi2cgrid( n_cgrid_spc ),
     &              conc_map( n_ae_spc ),  stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating VSED_MAP or CONC_MAP'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if
#ifdef isam
         allocate ( isam_sedi_map( nspc_sa_ae ),
     &              map_sedi_to_isam( nspc_sa_ae ),  stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating map_sedi_to_isam or isam_sedi_map'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if
         isam_sedi_map = 0
         map_sedi_to_isam = 0
         n_isam_sedi_map = 0
#endif
         map_sedi2cgrid = 0
         off = n_gc_trns   
         cg_off = ae_strt - 1   
         n_sedi_map = 0
         do v = 1, n_ae_spc
            n = index1( ae_spc( v ), n_ae_trns, ae_trns )
            if ( n .gt. 0 ) then
               n_sedi_map = n_sedi_map + 1
               sedi_map( n_sedi_map ) = n
               map_sedi2cgrid( n_sedi_map ) = n+cg_off
               conc_map( n_sedi_map ) = diff_map( n + off )
#ifdef isam
               do s = 1, nspc_sa_ae
                  if(  isam_to_aero( s ) .eq. sedi_map( n_sedi_map ) ) then
                     n_isam_sedi_map =  n_isam_sedi_map + 1
                     isam_sedi_map(  n_isam_sedi_map ) = sedi_map( n_sedi_map )   
                     map_sedi_to_isam(  n_isam_sedi_map ) = sa_aero_indx( s )   
                  end if
               end do
#endif
            end if
         end do
         write( logdev,'( 19x, "SEDI_MAP", 4x, "CONC_MAP" )' )
         do v = 1, n_sedi_map
            write( logdev,* ) v, sedi_map( v ), conc_map( v )
         end do
#if defined(verbose_isam) && defined(isam)
         write(logdev,'("ISAM Aerosol Sedimentation Mapping")')
         write( logdev,'( A4,1X,2(A16,1X),3(A8,1x) )' )"  N ","   Bulk AERO   ","    ISAM AERO   ",
     &   "SEDI_MAP", "CONC_MAP","MOLE_WGT"
         do v = 1, n_isam_sedi_map
            write( logdev,'( I4,1X,2(A16,1X),2(I8,1x),F8.2 )' ) v, ae_spc( isam_sedi_map( v ) ),
     &      isam_spec( map_sedi_to_isam( v ),1 ), isam_sedi_map( v ), map_sedi_to_isam( v ),
     &      CGRID_MW( MAP_SEDI2CGRID(isam_sedi_map( v )) )
         end do
#endif

         allocate ( vsed_ae( n_ae_spc,nlays ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating VSED_AE'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if
         vsed_ae = 0.0  ! array assignment

         allocate ( cgrd( nlays,size( cgrid,4 ) ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating CGRD'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if

         allocate ( conc( n_sedi_map,nlays ),
     &              vsed( n_sedi_map,nlays ),
     &              dtsvsed( n_sedi_map,nlays ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating CONC, VSED,  or DTSVSED'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if
#ifdef isam
         allocate ( conc_isam( n_isam_sedi_map,nlays,ntag_sa ), 
     &              isam_dtsvsed( nlays ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating CONC0,CONC_ISAM'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if
#endif

         conc = 0.0  ! array assignment
         vsed = 0.0  ! array assignment

         allocate ( rdl( nlays ),
     &              rrhodz( nlays ),
     &              ldens( nlays ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating RDL, RRHODZ, or LDENS'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if

         if ( vdiffdiag ) then
            allocate ( sumvsed( n_ae_spc,nlays ), stat = astat )
            if ( astat .ne. 0 ) then
               xmsg = 'Failure allocating SUMVSED'
               call m3exit( pname, mdate, mtime, xmsg, xstat1 )
            end if
         end if

      end if   !  if firstime

      do 345 r = 1, nrows
      do 344 c = 1, ncols

C subset all the layers and species in cgrid for this grid cell
         do v = 1, size( cgrid,4 )
            do l = 1, nlays
               cgrd( l,v ) = cgrid( c,r,l,v )
            end do
         end do

#ifdef isam
         do v = 1,  n_isam_sedi_map
            n = map_sedi_to_isam( v )
            do l = 1, nlays
               do itag = 1,ntag_sa
! used upper case to not conflict with CCP flag
                  conc_isam( v,l,itag ) = ISAM( c,r,l,n,itag )
               end do
            end do
         end do
#endif
         do l = 1, nlays
#ifdef mpas
            rdl( l ) = alpha * Met_Data%rjacf( c,r,l ) * inv_cell_thickness(c, r, l)
            rrhodz( l ) = Met_Data%rrhoj( c,r,l ) * inv_cell_thickness(c, r, l)
#else
            rdl( l ) = alpha * Met_Data%rjacf( c,r,l ) * Grid_Data%rdx3f( l )
            rrhodz( l ) = Met_Data%rrhoj( c,r,l ) * Grid_Data%rdx3f( l )
#endif

            ldens( l ) = Met_Data%dens( c,r,l )
         end do

         if ( vdiffdiag ) then
            sumvsed = 0.0   ! array assignment
         end if
         adts = 0.0; dtc = 0; iter = 0

         do while ( adts .lt. dtsec .and. iter .le. 10 )
            iter = iter + 1

            call aero_sedv( c, r, cgrd, vsed_ae )
            if ( vdiffdiag ) sumvsed = sumvsed + vsed_ae

            ! cgrd -> conc: from density units to mixing ratio units
            call conv_cgrd( )

            do v = 1, n_sedi_map
               vsed( v,: ) = vsed_ae( sedi_map( v ),: )
            end do

            ! Assess reciprocal of the time step and increase it if
            ! one of the surrogates shows a very fast sedimentation 
            ! velocity
            rdts = 1.0 / dtsec
            do l = 1, nlays
               do v = 1, n_sedi_map
                  fs = rdl( l ) * vsed( v,l )
                  if ( rdts .lt. fs ) rdts = fs
               end do
            end do
            dts = 1.0 / rdts
            
            ! Add the new time step increment
            adts = adts + dts
            if ( adts .gt. dtsec ) then   ! don`t overshoot the timestep
               dts = dtsec - (adts - dts)
               adts = dtsec
            end if

            dtc = dtc + 1

            ! Integrate sedimentation velocity change in time
            do l = 1, nlays
               ldt = dts * ldens( l )
               do v = 1, n_sedi_map
                  dtsvsed( v,l ) = ldt * vsed( v,l )
               end do
            end do

            ! Important Issue: Are these rrhodz values being applied
            ! correctly or should they be matched to each layer?

            ! Apply sedimentation from layer 2 to layer 1, only
            ! production
            l = 1
            do v = 1, n_sedi_map
               conc( v,l ) = conc( v,l )
     &                     + dtsvsed( v,l+1 ) * conc( v,l+1 ) * rrhodz( l )
            end do
#ifdef isam
            do v = 1, n_isam_sedi_map
               s = isam_sedi_map( v )
               do itag = 1,ntag_sa
                  conc_isam( v,l,itag ) = conc_isam( v,l,itag )
     &                                  + dtsvsed( s,l+1 ) * conc_isam( v,l+1,itag ) * rrhodz( l )
               end do
            end do
#endif

            ! Apply production and loss to layers 2 through NZ-1
            do l = 2, nlays-1
               do v = 1, n_sedi_map
                  conc( v,l ) = conc( v,l )
     &                        + ( dtsvsed( v,l+1 ) * conc( v,l+1 )
     &                        -   dtsvsed( v,l )   * conc( v,l ) ) * rrhodz( l )
               end do
#ifdef isam
                do v = 1, n_isam_sedi_map
                   s = isam_sedi_map( v )
                   do itag = 1,ntag_sa
                      conc_isam( v,l,itag ) = conc_isam( v,l,itag )
     &                                      + dtsvsed( s,l+1 ) * conc_isam( v,l+1,itag ) * rrhodz( l )
     &                                      - dtsvsed( s,l )   * conc_isam( v,l,itag   ) * rrhodz( l )

                   end do
                end do
#endif
            end do

            ! Apply only loss to layer NZ
            l = nlays
            do v = 1, n_sedi_map
               conc( v,l ) = conc( v,l )
     &                     - dtsvsed( v,l ) * conc( v,l ) * rrhodz( l )
            end do
#ifdef isam
             do v = 1, n_isam_sedi_map
                s = isam_sedi_map( v )
                do itag = 1,ntag_sa
                   conc_isam( v,l,itag ) = conc_isam( v,l,itag )
     &                                   - dtsvsed( s,l ) * conc_isam( v,l,itag ) * rrhodz( l )
                end do 
             end do
#endif

            ! conc -> cgrd: from mixing ratio units to density units
            call conv_conc( )
         end do   ! while
         if ( vdiffdiag ) then
            dtccr( c,r ) = real( dtc )
            do l = 1, nlays
               do v = 1, n_ae_spc
                  sedvel( v,l,c,r ) = sumvsed( v,l ) / real( dtc )
               end do
            end do
         end if

         do l = 1, nlays
            do v = 1, n_sedi_map
               cngrd( conc_map( v ),l,c,r ) = conc( v,l )
            end do
         end do
#ifdef isam
         do v = 1,  n_isam_sedi_map
            n = map_sedi_to_isam( v )
            do l = 1, nlays
               do itag = 1,ntag_sa
! used upper case to not conflict with CCP flag
                  ISAM( c,r,l,n,itag ) = conc_isam( v,l,itag )
               end do
            end do
         end do
#endif
#if defined(isam) && defined(verbose_isam)
         if( c .eq. 1 .and. r .eq. 1 )then
            write( logdev,'("ISAM Aerosol Sedimentation Results for col and row equal 1")')
            write( logdev,'( A4,1X,2(A16,1X),2(A12,1x) )' )"  N ","   Bulk AERO ","    ISAM AERO   ",
     &      "SUM_BULK ", "SUM_ISAM "
            do v = 1, n_isam_sedi_map
               write( logdev,'( I4,1X,2(A16,1X),2(ES12.4,1x) )' ) v, ae_spc( isam_sedi_map( v ) ),
     &         isam_spec( map_sedi_to_isam( v ),1 ), sum( conc( isam_sedi_map( v ),1:nlays ) ), 
     &         sum(conc_isam( v,1:nlays,1:ntag_sa ))
            end do
         end if
#endif


344   continue         !  end loop on col C
345   continue         !  end loop on row R

      return
      end subroutine sedi

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      subroutine conv_cgrd( )
         use cgrid_spcs          ! cgrd mechanism species
         use grid_conf        ! horizontal & vertical domain specifications
         use utilio_defn
         use asx_data_mod
         use vdiff_map

         implicit none

         integer   i, l, v            ! loop induction variables
         real FAC1( nlays )
         real, parameter :: mwair_si = mwair * 1.0e-3

C-----------------------------------------------------------------------

      FAC1 = MWAIR_SI / LDENS  ! kg m-3 -> m3 mol-1

      DO I = 1,N_SEDI_MAP
          ! Aerosol Mass: ug/m3 -> ppmv
          IF ( CGRID_MASK_AERO( MAP_SEDI2CGRID(I) ) .AND.
     &         .NOT. CGRID_MASK_NUM( MAP_SEDI2CGRID(I) ) .AND.
     &         .NOT. CGRID_MASK_SRF( MAP_SEDI2CGRID(I) )  )
     &       CONC( I,: ) = CGRD( :,MAP_SEDI2CGRID(I) ) 
     &                    *FAC1( : ) / CGRID_MW( MAP_SEDI2CGRID(I) )

          ! Aerosol Number: N m-3 -> N mol-1
          ! Aerosol Surface Area: m2/m3 -> m2 / mol air
          IF ( CGRID_MASK_NUM( MAP_SEDI2CGRID(I) ) .OR.
     &         CGRID_MASK_SRF( MAP_SEDI2CGRID(I) )      )
     &       CONC( I,: ) = CGRD( :,MAP_SEDI2CGRID(I) ) * FAC1( : )

      END DO

      RETURN

      end subroutine conv_cgrd

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      subroutine conv_conc ( )
         use cgrid_spcs          ! cgrd mechanism species
         use grid_conf        ! horizontal & vertical domain specifications
         use vdiff_map


         implicit none

         integer   i, l, v            ! loop induction variables
         real, parameter :: mwair_si = mwair * 1.0e-3
         real fac1( nlays )

C-----------------------------------------------------------------------
      FAC1 = LDENS / MWAIR_SI  ! kg m-3 -> mol m-3

      DO I = 1,N_SEDI_MAP
          ! Aerosol Mass: ug/m3 -> ppmv
          IF ( CGRID_MASK_AERO( MAP_SEDI2CGRID(I) ) .AND.
     &         .NOT. CGRID_MASK_NUM( MAP_SEDI2CGRID(I) ) .AND.
     &         .NOT. CGRID_MASK_SRF( MAP_SEDI2CGRID(I) )  )
     &      CGRD( :,MAP_SEDI2CGRID(I) ) = CONC( I,: ) * FAC1( : ) 
     &                                  * CGRID_MW( MAP_SEDI2CGRID(I) )

          ! Aerosol Number: N m-3 -> N mol-1
          ! Aerosol Surface Area: m2/m3 -> m2 / mol air
          IF ( CGRID_MASK_NUM( MAP_SEDI2CGRID(I) ) .OR.
     &         CGRID_MASK_SRF( MAP_SEDI2CGRID(I) )      ) 
     &      CGRD( :,MAP_SEDI2CGRID(I) ) = CONC( I,: ) * FAC1( : )

      END DO
 
      RETURN

      end subroutine conv_conc

      end module sedimentation

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

        SUBROUTINE PM3WARN( CALLER, JDATE, JTIME, ERRTXT )
C.....................................................................
C
C  PURPOSE:   Wrapper for M3WARN in parallel environment, to 
C             add the processor-id suffix to the name of the
C             caller.
C
C
C  PRECONDITIONS REQUIRED:  Same as for M3WARN.
C
C
C  REVISION  HISTORY:
C       Original version 07/1998 by Al Bourgeois.
C       Modified 12/07/1998 by Al Bourgeois to add EXTERNAL declarations.
C       Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with M3UTILIO; removed
C             deprecated TRIMLEN
C
C
C  ARGUMENT LIST DESCRIPTION:
C  IN:
C     CHARACTER*(*)   CALLER          ! Name of the caller.
C     INTEGER         JDATE           ! Model date for the error.
C     INTEGER         JTIME           ! Model time for the error.
C     CHARACTER*(*)   ERRTXT          ! Error message.
C
C     COMMON BLOCK PIOVARS:
C     INTEGER  MY_PE               !  Local processor id.
C
C
C  SUBROUTINES AND FUNCTIONS CALLED:  M3WARN.
C
C***********************************************************************

      USE M3UTILIO              ! i/o api

      IMPLICIT NONE

C...........   INCLUDES:

      INCLUDE 'PIOVARS.EXT'      ! Parameters for parallel implementation.


C...........   ARGUMENTS and their descriptions:

      CHARACTER*(*)   CALLER          ! Name of the caller.
      INTEGER         JDATE           ! Model date for the error.
      INTEGER         JTIME           ! Model time for the error.
      CHARACTER*(*)   ERRTXT          ! Error message.


C...........   LOCAL VARIABLES

      INTEGER      LENSTR       ! String length of CALLER.
      CHARACTER*3  CMYPE        ! Processor ID string.
      CHARACTER*7  PE_STR       ! String suffix to go with processor ID.
      CHARACTER*16 CALL16       ! First 16 characters of CALLER.
      CHARACTER*26 PCALLER      ! New caller string with PE information.

C.............................................................................
C   begin subroutine PM3WARN
  

C.......  Create strings to append to CALLER.
      WRITE (PE_STR,'(A7)') ' on PE '
      WRITE(CMYPE,'(I3.3)') MY_PE


C.......  Construct new CALLER string.
      LENSTR = MIN( 16, LEN_TRIM(CALLER) )
      CALL16 = CALLER( 1: LENSTR )
      PCALLER = CALL16(1:LENSTR)//PE_STR//CMYPE

C.......  Pass the new sting to M3WARN.
      CALL M3WARN( PCALLER, JDATE, JTIME, ERRTXT )

      RETURN
      END
  

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/parsline.f,v 1.3 2011/10/21 16:10:18 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

        SUBROUTINE PARSLINE( LINE, N, SEGMENT )

C-----------------------------------------------------------------------
C  Description:
C    Separates a "list-formatted" line of strings in which
C    the segments may or may not have quotes.  Although fortran requires
C    the quotes for true list-formatting, this subroutine can be used when
C    the quotes are only present to enclose a character (such as space, comma,
C    or semi-colon) that would otherwise be a delimiter.  If an "!" is 
C    encountered, everything after it is treated as a comment.
 
C  Preconditions:
 
C  Subroutines and Functions Called:
 
C  Revision History:
C    Created by M. Houyoux 3/99
C    02/11: S.Roselle-Replaced I/O API include files with UTILIO_DEFN
C    01/14: D.Wong-Reduced NDELIM to 3 and use only 3 delimiters (comma, blank
C           space and semicolon) since it only deals with one character when calling
C           FINDC. DELIMLST is now standard compliant (gfortran happy)
C    02/19: D.Wong-removed some unnecessary calculation
 
C-----------------------------------------------------------------------
C Modified from:

C Project Title: EDSS Tools Library
C File: @(#)$Id: parsline.f,v 1.3 2011/10/21 16:10:18 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/parsline.f,v $
C Last updated: $Date: 2011/10/21 16:10:18 $ 
C-----------------------------------------------------------------------

      USE UTILIO_DEFN

      IMPLICIT NONE

C Arguments:
      CHARACTER( * ), INTENT ( IN ) :: LINE         ! character string to parse
      INTEGER,        INTENT ( IN ) :: N            ! no. of segments to parse ("fields")
      CHARACTER( * ), INTENT( OUT ) :: SEGMENT( N ) ! parsed string

C External Functions:

C Local parameters:
      INTEGER,   PARAMETER :: NDELIM = 3
!     CHARACTER, PARAMETER :: DELIMLST( NDELIM ) = (/ ',', ' ', ';' /)
      CHARACTER, PARAMETER :: DELIMLST( NDELIM ) = (/ ' ', ',', ';' /)

C Arrays for sorting non-delimiters on a per-machine basis:
!     INTEGER            NDINDX  ( NDELIM )
!     CHARACTER, SAVE :: DELIMSRT( NDELIM )

C Other local variables:
      INTEGER          I, J, L, L1, L2    ! counters and indices
      INTEGER          IXP                ! index to non-delimiters
      INTEGER          NCNT               ! count of fields

      LOGICAL          ALPHA              ! true when within alpha-numeric 
      LOGICAL          DELIM              ! true when within or past delimiter 
      LOGICAL       :: PREVDELIM = .TRUE. ! true when last char was a delim
      LOGICAL          NUMBER             ! true when within number in string 
      LOGICAL          QUOTED             ! true when within quotes in string
      LOGICAL          ISANMBR            ! true if character is a numeral
      LOGICAL, SAVE :: FIRSTIME = .TRUE.  ! true first time routine is called

      CHARACTER        CBUF               ! test buffer
      CHARACTER     :: DOUBLEQ = '"'
      CHARACTER     :: SINGLEQ = "'"
      CHARACTER     :: PERIOD  = '.'
      CHARACTER     :: SPACE   = ' '
      CHARACTER        QUOTVAL            ! value of starting quote

      CHARACTER( 300 ) :: MESG            ! message buffer
      CHARACTER(  16 ) :: PNAME = 'PARSLINE' ! procedure name

C-----------------------------------------------------------------------

C The first time the routine is called, sort the list of delimiters
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
!        DO I = 1, NDELIM 
!           NDINDX( I ) = I
!        END DO

!        print *, ' ==d== insert a ', DELIMLST
!        CALL SORTIC( NDELIM, NDINDX, DELIMLST )
!        print *, ' ==d== insert b ', DELIMLST

!        DO I = 1, NDELIM 
!           J = NDINDX( I )
!           DELIMSRT( I ) = DELIMLST( J )
!        END DO

!        print *, ' ==d== insert c ', DELIMSRT

!        DELIMSRT = DELIMLST

      END IF

      L2 = LEN_TRIM( LINE )

C Check for comments, and use to set the end of the line
      L = INDEX( LINE( 1:L2 ), '!' )

      IF ( L .LE. 0 ) THEN
         L = L2
      ELSE
         L = L - 1
      END IF

C Skip blank lines
      IF ( L .EQ. 0 ) RETURN

C Initialize count, flags, and segments (note, initializing in the variable
C definitions is insufficient)
      NCNT    = 0
      SEGMENT = ' ' ! array
      ALPHA   = .FALSE.
      DELIM   = .TRUE.
      NUMBER  = .FALSE.
      QUOTED  = .FALSE.

C Process LINE one character at a time
      DO I = 1, L

         CBUF = LINE( I:I )

C Look for character in delimiters
         IXP = FINDC( CBUF, NDELIM, DELIMLST )

C Evaluate the current character for number or not
         ISANMBR = ( CBUF .GE. '0' .AND. CBUF .LE. '9' )

C Waiting for next field...
         IF ( DELIM ) THEN

            NUMBER = ISANMBR
            ALPHA  = ( .NOT. NUMBER .AND. IXP .LE. 0 )

            IF ( CBUF .EQ. SINGLEQ ) THEN
               QUOTED  = .TRUE.
               DELIM   = .FALSE.
               QUOTVAL = SINGLEQ
               PREVDELIM = .FALSE.
               L1      = I + 1
               NCNT    = NCNT + 1

            ELSE IF ( CBUF .EQ. DOUBLEQ ) THEN
               QUOTED  = .TRUE.
               DELIM   = .FALSE.
               QUOTVAL = DOUBLEQ
               PREVDELIM = .FALSE.
               L1      = I + 1
               NCNT    = NCNT + 1

            ELSE IF ( ALPHA .OR. NUMBER ) THEN
               DELIM = .FALSE.
               PREVDELIM = .FALSE.
               L1    = I
               NCNT  = NCNT + 1

C If another delimeter, then another field, but last field was blank
C UNLESS delim is a space
            ELSE IF ( CBUF .NE. SPACE ) THEN
               IF ( PREVDELIM ) THEN
                  NCNT = NCNT + 1
               ELSE
                  PREVDELIM = .TRUE.
               END IF
            END IF  ! Else its a space delimiter

C In a quoted field, skip everything unless it is an end quote
         ELSE IF ( QUOTED ) THEN
            IF ( CBUF .EQ. QUOTVAL ) THEN
               QUOTED  = .FALSE.
               DELIM   = .TRUE.
               PREVDELIM = .FALSE.
               L2      = I - 1
               CALL STORE_SEGMENT( NCNT, N, L1, L2, LINE, SEGMENT( NCNT ) )
            END IF

C If start of field was a number, but adjacent character is not a delimiter,
C then turn field into an alpha
         ELSE IF ( NUMBER .AND. .NOT. ISANMBR .AND. IXP .LE. 0 ) THEN
            ALPHA  = .TRUE.
            NUMBER = .FALSE.

C If start of field was a number or alpha, and this is a delimiter, then end
C of number has been reached
         ELSE IF ( IXP .GT. 0 ) THEN
            ALPHA = .FALSE.
            NUMBER = .FALSE.
            DELIM  = .TRUE.
            PREVDELIM = .TRUE.
            L2     = I - 1
            CALL STORE_SEGMENT( NCNT, N, L1, L2, LINE, SEGMENT( NCNT ) )
         END IF

      END DO

C Store final segment
      IF ( CBUF .EQ. QUOTVAL ) L = L - 1
      L2 = L

      IF ( IXP .LE. 0 ) THEN
         CALL STORE_SEGMENT( NCNT, N, L1, L2, LINE, SEGMENT( NCNT ) )
      END IF

      RETURN

C-------------------- Format Statements --------------------------------

94010 FORMAT( 10( A, :, I8, :, 1X ) )

C------------------- Internal Subprogram -------------------------------

      CONTAINS

C Store the segment from the input string
         SUBROUTINE STORE_SEGMENT( NSEG, MXSEG, I1, I2, STRNG, SEGMNT )

         IMPLICIT NONE

         INTEGER,        INTENT(  IN ) :: NSEG, MXSEG, I1, I2
         CHARACTER( * ), INTENT(  IN ) :: STRNG         ! character string to parse
         CHARACTER( * ), INTENT( OUT ) :: SEGMNT        ! parsed string

         CHARACTER( 128 ) :: MESG = ' '
         CHARACTER(  16 ) :: PNAME = 'PARSLINE_STORE_S' ! procedure name

         IF ( NSEG .LE. MXSEG ) THEN

            SEGMNT = ADJUSTL( STRNG( I1:I2 ) )

         ELSE

            MESG = 'ERROR: Overflow prevented while ' //
     &             'parsing line ' // PNAME
            CALL M3MSG2( MESG )
            MESG = 'First 200 characters of line contents are:'
            CALL M3MSG2( MESG )
            MESG = STRNG( 1:200 )
            CALL M3MSG2( MESG )

            MESG = 'Formatting problem'
            CALL M3EXIT( PNAME, 0, 0, MESG, 2 )

         END IF

         END SUBROUTINE STORE_SEGMENT

      END SUBROUTINE PARSLINE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


       SUBROUTINE HRSOLVER( JDATE, JTIME, C, R, L )


C**********************************************************************
C
C  FUNCTION: EBI solver
C
C  PRECONDITIONS: For the CB6R5PFAS_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED:  HRRATES, HRG1, HRG2, HRG3
C                                     HRG4, HRPRODLOSS
C                                     DEGRADE
C
C  REVISION HISTORY: Created by EBI solver program, Jun 26, 2025
C   21 Jun 10 J.Young: convert for Namelist redesign
C   18 Jul 14 B.Hutzell: revised 1) to use the RXNS_DATA and RXNS_FUNCTION
C                        modules instead of include files and 2) to use
C                        real(8) variables
C**********************************************************************

      USE RUNTIME_VARS
      USE UTILIO_DEFN
      USE RXNS_DATA
      USE HRDATA
      USE PA_IRR_MODULE
#ifdef isam
      USE SA_IRR_DEFN
      USE ELMO_DATA, ONLY : ELMO_VOC_NOX
#endif
#ifdef sens
      USE DDM3D_CHEM, ONLY: YCDDM
      USE CGRID_SPCS, ONLY: GC_SPC
#endif
      USE DEGRADE_ROUTINES, ONLY : DEGRADE, SA_DEGRADE_STEP


      IMPLICIT NONE

C..INCLUDES:


C..ARGUMENTS:
      INTEGER, INTENT( IN ) :: JDATE    ! Current date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME    ! Current time (HHMMSS)
      INTEGER, INTENT( IN ) :: C, R, L  ! Cell col, row, lev

C..PARAMETERS:
      INTEGER, PARAMETER :: MXBKUPS = 5  ! Max no. of back-ups allowed
      INTEGER, PARAMETER :: STAT = 1     ! Status code

      REAL( 8 ), PARAMETER :: DTMIN   = 1.0D-08    ! Smallest time step allowed, min
      REAL( 8 ), PARAMETER :: EPSLON  = 1.0D-30    ! Small number
      REAL( 8 ), PARAMETER :: MAXPRED = 1.0D+03    ! Upper limit on predicted conc
      REAL( 8 ), PARAMETER :: ZERO    = 1.0D-40    ! effective zero
      REAL( 8 ), PARAMETER :: FLOOR   = 1.0D-08    ! Min conc for RTOL

C..EXTERNAL FUNCTIONS:


C..SAVED LOCAL VARIABLES:
      CHARACTER( 16 ),      SAVE :: PNAME  = 'HRSOLVER' ! Program name
      LOGICAL,              SAVE :: LFIRST = .TRUE.     ! Flag for first call
      LOGICAL, ALLOCATABLE, SAVE :: LEBISPFL( : )       ! Convergence Error Flag for EBI species
      LOGICAL, ALLOCATABLE, SAVE :: MAXCONC ( : )       ! MAXCONC ERROR Flag for EBI species
      LOGICAL, ALLOCATABLE, SAVE :: NOTMAX  ( : )       ! Initial concentration not greater than MAXPRED

      REAL( 8 ), ALLOCATABLE, SAVE :: RERROR  ( : )     ! Relative Error
      REAL( 8 ), ALLOCATABLE, SAVE :: AERROR  ( : )     ! Absolute Error


C..SCRATCH LOCAL VARIABLES:

      CHARACTER( 132 ) :: MSG           ! Message text

      INTEGER CELLNO          ! Cell no. fo debug output
      INTEGER ITER            ! Loop index for Backward Euler iterations
      INTEGER S               ! Loop index for species
      INTEGER SP              ! Imbedded loop index for species
      INTEGER NEBI            ! Loop index for time steps
      INTEGER NINR            ! No. of inner time steps
#ifdef hrdebug
      INTEGER N               ! Loop index
#endif
      INTEGER M               ! species index
      INTEGER EBI             ! Loop index
      INTEGER NBKUPS          ! No. of times time step reduced
      INTEGER ERR             ! Allocate error flag


      LOGICAL LEBI_CONV          ! Flag for EBI convergence
      LOGICAL MXFL               ! hit MAXPRED flag

      REAL( 8 ) DTC              ! Time step to take
      REAL( 8 ) DTG         ! Time step in degrade routines, sec
      REAL( 8 ) FXDLOSS          ! Total loss due to negative stoichiometry
      REAL( 8 ) VARLOSS          ! Loss excluding negative stoichiometry


#ifdef hrdebug
      CHARACTER( 8 ) :: NOTE  ! Convergence fail note

      INTEGER COL             ! Column to generate deboug output for
      INTEGER ROW             ! Row to generate deboug output for
      INTEGER LEV             ! Level to generate deboug output for
      INTEGER DBGOUT          ! Output unit for debu outpt

      LOGICAL LDEBUG          ! Debug output flag
      LOGICAL, SAVE  :: LOPEN = .FALSE.
#endif


C**********************************************************************


       IF( LFIRST ) THEN
          LFIRST = .FALSE.

          ALLOCATE ( LEBISPFL( NUMB_MECH_SPC ), STAT = ERR )
          IF ( ERR .NE. 0 ) THEN
             MSG = 'Error allocating LEBISPFL'
             CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
          END IF

          ALLOCATE ( MAXCONC( NUMB_MECH_SPC ), STAT = ERR )
          IF ( ERR .NE. 0 ) THEN
             MSG = 'Error allocating MAXCONC'
             CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
          END IF

          ALLOCATE ( NOTMAX( NUMB_MECH_SPC ), STAT = ERR )
          IF ( ERR .NE. 0 ) THEN
             MSG = 'Error allocating NOTMAX'
             CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
          END IF

          ALLOCATE ( RERROR( NUMB_MECH_SPC ), STAT = ERR )
          IF ( ERR .NE. 0 ) THEN
             MSG = 'Error allocating ERROR'
             CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
          END IF

          ALLOCATE ( AERROR( NUMB_MECH_SPC ), STAT = ERR )
          IF ( ERR .NE. 0 ) THEN
             MSG = 'Error allocating AERROR'
             CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
          END IF

       END IF

#ifdef sens
       YCDDM = 0.0D0
#endif

c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++
#ifdef hrdebug
      COL = 0
      ROW = 0
      LEV = 0
      IF( C .EQ. COL .AND. R .EQ. ROW .AND. L .EQ. LEV ) THEN
c      IF( JTIME .EQ. 160000 ) THEN
         LDEBUG = .TRUE.
      ELSE
         LDEBUG = .FALSE.
      END IF

      IF( LDEBUG ) THEN
           IF( .NOT. LOPEN ) THEN
              DBGOUT = JUNIT()
              OPEN( UNIT = DBGOUT, FILE = 'debug.out' )
              LOPEN = .TRUE.
           END IF

           WRITE( DBGOUT, '( A, 2I4, I3, 1X, I7, 1X, I6 ) ' )
     &             'Debug output for col/row/lev/date/time:',
     &              C, R, L, JDATE, JTIME
           WRITE( DBGOUT, '( A, F7.2) ' )
     &             'EBI_TMSTEP = ', EBI_TMSTEP
           WRITE( DBGOUT, '( A )' ) 'Starting concs and rate constants'
           DO N = 1, NUMB_MECH_SPC
             WRITE( DBGOUT,  '( A, I3, 1X, A, 1X, 1PD13.5 )' )
     &                     'SP ',N, CHEMISTRY_SPC( N ), YC( N )
           END DO
           DO N = 1, N_RXNS
             WRITE( DBGOUT, '( A, I3, 1X, 1PD13.5 )' )
     &                     'RKI ', N, RKI(  N )
           END DO
      END IF
#endif
c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++



      DTC         = EBI_TMSTEP

      N_EBI_IT    = 0
      NBKUPS      = 0
      N_INR_STEPS = 1
      NEBI        = 1
      LEBI_CONV   = .TRUE.
#ifdef isam
      UPDATE_SOLD = .FALSE.
      UPDATE_PROBABILITIES = .TRUE.
      CALL SA_IRR_UNBLOCKED ( .TRUE., RKI, YC, DTC )
#endif


      DO S = 1, NUMB_MECH_SPC
         IF( YC( S ) .LE. MAXPRED )THEN
           NOTMAX( S ) = .TRUE.
         ELSE
           NOTMAX( S ) = .FALSE.
           WRITE(LOGDEV,91000)C, R, L, CHEMISTRY_SPC(S), YC(S)
         END IF
      END DO

! Initial PA_IRR
      IF( CALL_IRR ) CALL PA_IRR ( .TRUE., RKI, YC, DTC )
      SA_DEGRADE_STEP = 0
      TSTEP_EBI: DO    ! EBI time-step loop

         SUBSTEP_EBI: DO NINR = 1, N_INR_STEPS   ! time substeps loop
!  first attempt is sub time-step equals EBI time-step

            IF( LEBI_CONV ) YC0 = YC   ! Set ICs for EBI iterations

            ITER_SUBSTEP: DO ITER = 1, NEBITER  ! iteration loop solving for sub time-step


               N_EBI_IT = N_EBI_IT + 1
               CALL HRRATES

c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++
#ifdef hrdebug
               IF( LDEBUG ) THEN
                  WRITE( DBGOUT, '( A, I5 )' ) 'ITER NO ', ITER
                  WRITE( DBGOUT, '( A, F12.5 )' )
     &               ' DTC=', DTC

                  IF( ITER .EQ. 1 ) THEN
                     WRITE( DBGOUT, '( A )' ) 'Starting reaction rates'
                     DO N = 1, N_RXNS
                        WRITE( DBGOUT, '( A, I3, 1X, 1PD13.5 )' )
     &                        'RXRAT ', N, RXRAT( NCELL, N )
                     END DO
                  END IF
               END IF
#endif
c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Call routines to compute concentrations of groups 1-4
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

               CALL HRG1( DTC )

               CALL HRG2( DTC )

               CALL HRG3( DTC )

               CALL HRG4( DTC )


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Do the Euler backward method
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
               CALL HRPRODLOSS

               DO EBI = 1, N_EBISP
                  S = EBISP( EBI )
                  YCP( S ) =  YC( S )*( ( YC0( S ) + PROD( S ) * DTC )
     &                     / ( YC( S ) + LOSS( S ) * DTC ) )
               END DO

c..Special treatment of PAR because of negative product stoichiometry
               IF( PNEG( PAR ) .GT. 0.0D0 ) THEN
                  FXDLOSS = PNEG( PAR ) * DTC
                  IF( FXDLOSS .GE. YC0( PAR ) + PROD( PAR ) * DTC ) THEN
                     YCP( PAR ) = 0.0D0
                  ELSE
                     VARLOSS = MAX( LOSS( PAR ) - PNEG( PAR ) , ZERO )
                     YCP( PAR ) = ( YC0( PAR ) + PROD( PAR ) * DTC  - 
     &             FXDLOSS ) / ( 1.0D0 + VARLOSS * DTC / YC( PAR ) )
                  END IF
               END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check for convergence
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
               LEBI_CONV = .TRUE.
               MXFL      = .FALSE.

               DO S = 1, NUMB_MECH_SPC
                  LEBISPFL( S ) = .FALSE.
                  YCP( S ) = MAX( ZERO, YCP( S ) )
                  AERROR( S ) = MAX( ABS( YC(S)-YCP(S) ), EPSLON )
                  RERROR( S ) = AERROR( S ) / MAX( FLOOR, ABS( YC(S)+YCP(S) ) )
                  IF( RERROR( S ) .GT. RTOL(S) .OR. AERROR( S ) .GT. 1.0D-5 )THEN
                     LEBI_CONV     = .FALSE.
                     LEBISPFL( S ) = .TRUE.
                  END IF
c..test if predictions growing too large
                  IF( YCP( S ) .GT. MAXPRED .AND. NOTMAX( S ) ) THEN
                     MXFL          = .TRUE.
                     LEBI_CONV     = .FALSE.
                     LEBISPFL( S ) = .TRUE.
                  END IF
                  YC( S ) = YCP( S )
               END DO
c..test if predictions growing too large, abort interation loop
               IF( MXFL ) EXIT ITER_SUBSTEP

c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++
#ifdef hrdebug
               IF( LDEBUG ) THEN
                  WRITE( DBGOUT, '( A, I5 )' ) 'Concs after ITER= ', ITER
                  DO S = 1, NUMB_MECH_SPC

                     IF( LEBISPFL( S ) ) THEN
                        NOTE = 'CONV FAIL'
                     ELSE
                        NOTE = '         '
                     END IF

                     WRITE( DBGOUT, '( I3, 1X, A, 1PD13.5, 1X, A )' )
     &                            S, CHEMISTRY_SPC( S ), YC( S ), NOTE
                  END DO
                  IF( LEBI_CONV ) WRITE( DBGOUT, '( A )' )
     &                 '****Convergence achieved'
               END IF
#endif
c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++

               IF( LEBI_CONV ) THEN

                DTG = 60.0D0 * DTC
                DO S = 1, NUMB_MECH_SPC
                   M = CGRID_INDEX( S )
                   YCCELL( M ) = YC( S )
                END DO
#if defined(isam) || defined(verbose_isam)
                SA_DEGRADE_STEP = SA_DEGRADE_STEP + 1
#endif
                IF( CALL_DEG )CALL DEGRADE(YCCELL, DTG, JDATE, JTIME) ! :WTH Call degradation routine

                 IF( CALL_IRR ) CALL PA_IRR ( .FALSE., RKI, YC, DTC )
#ifdef isam
                 IF( NEBI .EQ. N_EBI_STEPS )UPDATE_SOLD = .TRUE.
                 CALL SA_IRR_UNBLOCKED ( .FALSE., RKI, YC, DTC )
                 UPDATE_PROBABILITIES = .FALSE.
                 ELMO_VOC_NOX( C,R,L )  = VOC_TO_NOX
#endif

#ifdef sens
C Update the sum for the average over the chemistry integration
                 YCDDM = YCDDM
     &                 + ( ( 0.5D0 * DTC ) * ( YC + YC0 )  )
#endif

                 CYCLE SUBSTEP_EBI ! solve for next sub time-step

               END IF

            END DO ITER_SUBSTEP
! interating for substep failed, attempt to increase number of sub time-steps
            NBKUPS = NBKUPS + 1

!            IF( NBKUPS .LE. MXBKUPS ) THEN
            IF ( DTC .GT. DTMIN ) THEN
! reset YC and cut sub time-step in half
               IF ( MXFL ) THEN
                  WRITE( LOGDEV, 92008 ) NBKUPS
                  WRITE( LOGDEV, 92009 ) C+PECOL_OFFSET, R+PEROW_OFFSET, L
                  DO S = 1, NUMB_MECH_SPC
                     IF( LEBISPFL( S ) )WRITE( LOGDEV, 92010 )TRIM( CHEMISTRY_SPC( S ) ),
     &               YC0(S), YCP(S)
                  END DO
               ELSE
                  WRITE( LOGDEV, 92000 ) C+PECOL_OFFSET, R+PEROW_OFFSET, L, NBKUPS
                  DO S = 1, NUMB_MECH_SPC
                     IF( LEBISPFL( S ) )WRITE( LOGDEV, 92010 )TRIM( CHEMISTRY_SPC( S ) ),
     &               YC0(S), YCP(S)
                  END DO
               END IF

               YC = YC0   ! Set ICs for EBI time-step

               DTC = 0.5D0 * DTC

               N_INR_STEPS = 2 ** NBKUPS

               EXIT SUBSTEP_EBI

            ELSE

               WRITE( LOGDEV, 92040 ) C+PECOL_OFFSET, R+PEROW_OFFSET, L

               WRITE( LOGDEV, 92060 )
               DO S = 1, NUMB_MECH_SPC
                  IF( LEBISPFL( S ) ) WRITE( LOGDEV, 92080 ) CHEMISTRY_SPC( S ),
     &            YC0(S), YCP(S)
               END DO

               MSG = 'ERROR: Stopping because of EBI convergence failures'
               CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT2 )

            END IF

         END DO SUBSTEP_EBI

         IF( LEBI_CONV )THEN
             NEBI        = 1 + NEBI
! test for completing final EBI time-step
             IF( NEBI .GT. N_EBI_STEPS )EXIT TSTEP_EBI
! test whether backups were done
             IF( NBKUPS .EQ. 0 )CYCLE TSTEP_EBI
! Reset NBKUPS, N_INR_STEPS and sub-time step
             NBKUPS      = 0
             N_INR_STEPS = 1
             DTC         = EBI_TMSTEP
         END IF

      END DO TSTEP_EBI

#ifdef sens
! Compute average over integration and filter values
      YCDDM = YCDDM / CHEMSTEP
      WHERE (  YCDDM .LT. 1.0D-25 ) YCDDM = 0.0D0
#endif


      RETURN


91000 FORMAT( 'WARNING: EBI solver in cell (',2(I4,','),I4,') Init.Conc. for ',
     &         A16, ' = ', ES12.4,' ppmV')

92000 FORMAT( 'WARNING: EBI Euler convergence failure' /
     &        '         Reducing EBI time step because of ',
     &        '         convergence failure in ' /
     &        '         Cell (', I3, ', ', I3, ', ', I3, ')' ,
     &        '         Solution Attempt #', I2 /
     &        '         Below Species Causing Error: Init.Conc, Pred.Conc.'  )

92008 FORMAT( 'WARNING: At solution attempt #', I2  )
92009 FORMAT( 'WARNING: EBI Euler convergence failure' /
     &        '         Reducing EBI time step because of ',
     &        '         MAXPRED failure in ' /
     &        '         Cell (', I3, ', ', I3, ', ', I3, ')' ,
     &        '         for the below species: : Init.Conc, Pred.Conc.')
92010 FORMAT( A16, 2(1X,ES12.4), ' ppmV'  )

92040 FORMAT( 'ERROR: Max number of EBI time step reductions exceeded'
     &      / '      Convergence failure for cell (', I3, ', ', I3,
     &                ', ', I3, ')' )

92060 FORMAT( '      Convergence failure for the following species:',
     &        'Init.Conc, Pred.Conc.' )

92080 FORMAT( 10X, A, 2(1X,ES12.4), ' ppmV ' )

92061 FORMAT( '      Convergence failure for the following species:',
     &        'Init.Conc, Pred.Conc.,Rel.Error,' )

92081 FORMAT( 10X, A, 2(1X,ES12.4), ' ppmV ', ES12.4,'%' )

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_util_module.f,v 1.3 2006/02/17 12:54:05 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   use F90 interface feature to achieve "faked" polymorphism for data
C   initialization routine and use F90 module feature to collect a set of 
C   utility routines which consists of:
C
C       se_init_array
C       se_hi_lo_bnd_pe
C       se_loop_index
C       se_barrier
C       se_global_min_data
C       se_global_to_local_coord
C       se_subgrid_index
C       se_sum_chk
C       se_my_region
C       se_global_logical
C       se_in_syn
C
C that are used directly from the application
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C                    02/11/00 by David Wong
C                      -- include a new module, se_csg_index.f
C                    04/24/00 by David Wong
C                      -- include a new module, se_global_logical.f
C                    11/05/00 by David Wong
C                      -- use F90 interface construct to distinguish integer or
C                         real array initialization
C                      -- use F90 interface construct to distinguish integer or
C                         real check sum
C                    08/24/11 by David Wong
C                      -- eliminated data orientation
C -----------------------------------------------------------------------------

        module se_util_module

        implicit none

        interface se_init_array
          module procedure se_init_iarray, se_init_rarray
        end interface

        interface se_sum_chk
          module procedure se_isum_chk, se_rsum_chk
        end interface

        interface se_subgrid_index
          module procedure se_subgrid_index_2,  se_subgrid_index_3,
     &                     se_subgrid_index_n2, se_subgrid_index_n3
        end interface

        contains

C -----------------------------------------------------------------------------
C Purpose:
C
C   initialize an array with a specific integer value 
C
C Subroutine parameter description:
C
C   In: wpe -- input array
C       val -- initial value
C
C  Out: wpe
C
C  Local variable: i -- loop index
C
C Revision history:
C
C   Orginal version: 6/18/99 by David Wong
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C -----------------------------------------------------------------------------

        subroutine se_init_iarray ( wpe, val )

        implicit none

        integer, intent(out) :: wpe(:) 
        integer, intent(in) :: val

        integer i

        do i = 1, size(wpe,1)
           wpe(i) = val
        end do

        return
        end subroutine se_init_iarray

C -----------------------------------------------------------------------------
C Purpose:
C
C   initialize an array with a specific real value
C
C Subroutine parameter description:
C
C   In: wpe -- input array
C       val -- initial value
C
C  Out: wpe
C
C  Local variable: i -- loop index
C
C Revision history:
C
C   Orginal version: 10/05/00 by David Wong
C -----------------------------------------------------------------------------

        subroutine se_init_rarray ( wpe, val )

        implicit none

        real, intent(out) :: wpe(:)
        real, intent(in) :: val

        integer i

        do i = 1, size(wpe,1)
           wpe(i) = val
        end do

        return
        end subroutine se_init_rarray

C -----------------------------------------------------------------------------
C Purpose:
C
C   To determine if a processor contains global boundary cells and if the
C   processor is a low boundary or high boundary processor according to the
C   domain decomposition.
C
C   For example, suppose there are 4 processors with 1 x 4 processor
C    configuration as follows:
C
C     0  1  2  3
C
C   In row orientation, PE 0 is a low boundary processor, and PE 3 is a high 
C   boundary processor.
C
C   In column orientation, PE 0 is both a low and a high boundary processor.
C
C Revision history:
C
C   Orginal version: 1/19/99 by David Wong
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    11/05/00 by David Wong
C                      -- replaced 'R' with 'Y' (Y-axis) and 'C' with 'X' 
C                         (X-axis) to provide a better description of variable 
C                         ori
C                    12/20/00 by Jeff Young
C                      -- add optional 'R' or 'Y' and 'C' or 'X'
C                    08/24/11 by David Wong
C                      -- removed se_ori_ext to eliminate data and geo orientation
C
C Subroutine parameter description:
C
C   In:  ori    -- orientation of 1-D data from the grid domain, row or column
C        
C   Out: low_index  -- logical variable to indicate processor along North or 
C                      West boundary depends on the orientation
C        high_index -- logical variable to indicate processor along South or 
C                      East boundary depends on the orientation
C
C Local variable description:
C
C   top -- position of the North of West direction in the se_nbg_pe array
C   bot -- position of the South of East direction in the se_nbg_pe array
C
C Include files:
C
C   se_comm_info_ext
C -----------------------------------------------------------------------------

        subroutine se_hi_lo_bnd_pe (ori, low_index, high_index)

        use se_comm_info_ext
!       use se_ori_ext

        implicit none

        character, intent(in) :: ori
        logical, intent(out) :: low_index, high_index

        integer :: top, bot

        if (ori .eq. 'Y' .or. ori .eq. 'R') then
           top = 1
           bot = 5
        else
           top = 7
           bot = 3
        end if

        low_index  = .false.
        high_index = .false.

        if (se_ngb_pe(top) .eq. -1) then
           low_index = .true.
        end if

        if (se_ngb_pe(bot) .eq. -1) then
           high_index = .true.
        end if

        return
        end subroutine se_hi_lo_bnd_pe

C -----------------------------------------------------------------------------
C Purpose:
C
C   To map loop indexes INDEX1..INDEX2 in the serial code to the corresponding
C   starting and ending loop indexes in the parallel code, when a 1-D array,
C   extracted for a row or a column of the grid domain is passed into an
C   advection subroutine.  These indexes depend on processor location in the
C   domain decomposition  processor map and whether the processor contains an
C   exterior boundary.
C   The following description illustrates mapping serial loop indexes to
C   parallel code loop indexes:
C
C   serial loop       parallel local
C      index            loop index
C
C        a                   1
C       a+1                  2
C        .                   .
C        .                   .
C        .                   .
C       a+i                 i+1
C  ------------ processor boundary ----------
C      a+i+1                 1
C        .                   .
C        .                   .
C        .                   .
C       a+j                 j-i
C  ------------ processor boundary ----------
C      a+j+1                 1
C        .                   .
C        .                   .
C        .                   .
C      a+n-1               n-j-1
C       a+n                 n-j
C 
C
C   Here is an example: given 16 processors with a 4 x 4 processor map, and a 
C   domain grid size 18 x 25 (row x column), so
C 
C   processor map:  12  13  14  15
C                    8   9  10  11
C                    4   5   6   7
C                    0   1   2   3
C
C   proc #           nrows x ncols      my_nrows x my_ncols
C   -------------------------------------------------------
C   0,4                  5 x 7                 5 x 7 
C   1,2,3,5,6,7          5 x 7                 5 x 6 
C   8,12                 5 x 7                 4 x 7 
C   9,10,11,13,14,15     5 x 7                 4 x 6
C
C   For a row of the 2D domain (in xadv*.F), processors 0, 4, 8, and 12 are
C   BNDY_LO_PE's, processors 3, 7, 11, and 15 are BNDY_HI_PE's, and the rest
C   of the processors are interior processors. If for the serial code, a loop
C   runs from 3 to 22, then the starting and ending indexes are:
C
C   proc #                starting index      ending index
C   ------------------------------------------------------
C   0,4,8,12                    3                  7
C   1,2,5,6,9,10,13,14          1                  6
C   3,7,11,15                   1                  3
C
C   For a column of the 2D domain (in yadv*.F), processors 0, 1, 2, and 3 are
C   BNDY_LO_PE's, processors 12, 13, 14, and 15 are BNDY_HI_PE's, and the rest
C   of the processors are interior processors. If for the serial code, a loop
C   runs from 2 to 17, then the starting and ending indexes are:
C
C   proc #                starting index      ending index
C   ------------------------------------------------------
C   0,1,2,3                     2                  5
C   4,5,6,7                     1                  5
C   8,9,10,11                   1                  4
C   12,13,14,15                 1                  3
C
C
C Revision history:
C
C   Orginal version: 9/14/98 by David Wong
C                  : 1/19/99 by David Wong
C                    took away lo and hi boundary pe calculation, calculate dif
C                    locally
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/20/00 by Jeff Young
C                      -- add optional 'R' or 'Y' and 'C' or 'X'
C                    08/24/11 by David Wong
C                      -- removed se_ori_ext to eliminate data and geo orientation
C
C Subroutine parameter description:
C
C   In:  ori    -- orientation of 1-D data from the grid domain, row or column
C        gstart -- original starting point of the loop
C        gend   -- original data dimension
C        dif    -- difference in ending dimension for a loop, such that
C                  GEND + DIF is the orginal ending point
C        
C   Out: my_nn  -- number of data points in the processor
C        start  -- loop starting index of data in the processor
C        end    -- loop ending index of data in the processor
C
C Local variable description:
C
C   top -- position of the North of West direction in the se_nbg_pe array
C   bot -- position of the South of East direction in the se_nbg_pe array
C   dif -- difference in the original loop ending count
C
C Include files:
C
C   se_domain_info_ext
C -----------------------------------------------------------------------------

        subroutine se_loop_index (ori, gstart, gend, dif, my_nn, start, end)

        use se_domain_info_ext
        use se_comm_info_ext
!       use se_ori_ext

        implicit none

        integer, intent(out) :: my_nn, start, end
        character, intent(in) :: ori
        integer, intent(in) :: gstart, gend, dif

        integer :: top, bot

        if (ori .eq. 'Y' .or. ori .eq. 'R') then
           top = 1
           bot = 5
           my_nn = se_my_nrows
        else
           top = 7
           bot = 3
           my_nn = se_my_ncols
        end if

        start = 1
        end = my_nn

        if (se_ngb_pe(top) .eq. -1) then
           start = gstart
        end if

        if (se_ngb_pe(bot) .eq. -1) then
           end = my_nn + dif
        end if

        return
        end subroutine se_loop_index

C --------------------------------------------------------------------------
C Purpose:
C
C   to set a barrier for synchronization purpose (hiding details from user and
C   avoid to include any MPI header files in the original code).
C
C Local variable description:
C
C   error -- return error of calling MPI subroutine
C
C Revision history:
C
C   Orginal version: 9/14/98 by David Wong
C
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/04/02 by David Wong
C                      -- modified the routine to accommodate worker and 
C                         I/O processors partition scheme
C                    01/30/17 by David Wong
C                      -- modified the routine to avoid unnecessary creating
C                         and destroying communicator
C --------------------------------------------------------------------------

        subroutine se_barrier (flag)

        use se_pe_info_ext

        implicit none

        character, optional, intent(in) :: flag

        include "mpif.h"

        integer :: local_comm, error

        if (present(flag)) then
           call mpi_comm_dup (se_worker_comm, local_comm, error)
           call mpi_barrier (local_comm, error)
           call mpi_comm_free (local_comm, error)
        else
           call mpi_barrier (mpi_comm_world, error)
        end if

        return
        end subroutine se_barrier

C -----------------------------------------------------------------------------
C Purpose: 
C
C   to determine the global minimum of variable VAR and broadcast data which are
C associated with the minimum VAR
C
C Note: this is a specific subroutine for 11 associated data. If the number of
C       associated data is changed, a new subroutin is needed.
C
C Revision history:
C
C   Orginal version: 2/15/99 by David Wong
C 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C 
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C 
C Parameter List:
C
C   In: var -- distributed variable which needs be determined the min value
C              among all processors
C
C  Out: col,
C       row, 
C       lvl, 
C       meddyv, 
C       never,
C       mtrop,
C       ftrop,
C       mth1,
C       mth2,
C       mrib,
C       mws     -- data which are associated with the minimum var
C
C Local Variable:
C
C   num_item -- number of associated variables
C   datain   -- an array holds var and its associated PE number
C   dataout  -- an array holds the minimum of var and its associated PE number
C               in PE 0 only
C   packdata -- an array holds all the associated data
C   min_pe   -- PE number assoicated with minimum var
C   error    -- error code of mpi call
C
C Include Files:
C
C   mpif.h
C   se_pe_info_ext
C   se_domain_info_ext
C -----------------------------------------------------------------------------

        subroutine se_global_min_data (var, col, row, lvl, meddyv, never,
     &                                 mtrop, ftrop, mth1, mth2, mrib, mws)

        use se_pe_info_ext
        use se_domain_info_ext

        implicit none

        real, intent(in) :: var 
        real, intent(inout) :: meddyv, mth1, mth2, mrib, mws
        integer, intent(inout) :: col, row, lvl, mtrop
        logical, intent(inout) :: never, ftrop

        include "mpif.h"

        integer :: num_item = 11

        real :: datain(2), dataout(2) 
        real, allocatable :: packdata(:)
        integer :: min_pe, error, allocate_status

C -- allocate data
        allocate (packdata(num_item), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error in subroutine SE_GLOBAL_MIN_DATA'
           stop
        end if

        datain(1) = var
        datain(2) = float(se_myworker_pe)

        call mpi_reduce (datain, dataout, 1, mpi_2real, MPI_MINLOC, 0, 
     &                   se_worker_comm, error)

        call mpi_bcast (dataout(2), 1, mpi_real, 0, se_worker_comm, error)

        min_pe = dataout(2)

        packdata(1) = col + se_gl_ind(1, 2, min_pe) - 1
        packdata(2) = row + se_gl_ind(1, 1, min_pe) - 1
        packdata(3) = lvl
        packdata(4) = meddyv
        if (never) then
           packdata(5) = 0.0
        else
           packdata(5) = 1.0
        end if
        packdata(6) = float(mtrop)
        if (ftrop) then
           packdata(7) = 0.0
        else
           packdata(7) = 1.0
        end if
        packdata(8) = mth1
        packdata(9) = mth2
        packdata(10) = mrib
        packdata(11) = mws

        call mpi_bcast (packdata, num_item, mpi_real, min_pe, se_worker_comm, 
     &                  error)

        col  = packdata(1)
        row  = packdata(2)
        lvl  = packdata(3)
        meddyv = packdata(4)
        if (packdata(5) .eq. 0.0) then
           never = .true.
        else
           never = .false.
        end if
        mtrop = packdata(6)
        if (packdata(7) .eq. 0.0) then
           ftrop = .true. 
        else
           ftrop = .false. 
        end if
        mth1 = packdata(8) 
        mth2 = packdata(9)
        mrib = packdata(10)
        mws  = packdata(11)
        
        deallocate(packdata)
 
        return
        end subroutine se_global_min_data

C --------------------------------------------------------------------------
C Purpose:
C
C   to convert global grid coordinate to local grid coordinate with respect to
C the thickness of ghost zone. The subroutine will return (-999, -999) if the 
C global grid point does not fall in the sub domain that a PE owns.
C
C Revision history:
C
C   Orginal version: 6/18/99 by David Wong 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                      -- moved the data orientation dependency to higher level
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C                    12/27/05 by David Wong
C                       -- made the routine more robust to avoid IO processor
C                          to access non-existence memory
C
C Subroutine parameter description:
C
C   In:  x     -- global grid x coordiate
C        y     -- global grid y coordiate
C        nthick -- thickness of ghost zone, if nthick = 0, there is no ghost 
C                  zone
C
C   Out: my_x  -- local grid x coordiate
C        my_y  -- local grid y coordiate
C
C Local variable description:
C
C    not_in_my_pe   -- a constant to indicate the grid point is not in the
C                      local processor grid region
C
C    loc_x, loc_y -- output copy the local grid coordination 
C
C Example:
C
C   given 21 x 21 data domain with 4 x 2 PE configuration and "cr" orientation, 
C let global grid point be (8,15), local grid point will be (2, 4) in PE 5 and
C (0, 0) elsewhere. 
C
C Include file:
C
C    se_pe_info_ext
C    se_domain_info_ext
C
C --------------------------------------------------------------------------

        subroutine se_global_to_local_coord (x, y, my_x, my_y, nthick)

        use se_pe_info_ext
        use se_domain_info_ext

        implicit none

        integer, intent(in) :: x, y, nthick
        integer, intent(inout) :: my_x, my_y

        integer, parameter :: not_in_my_pe = -999

        integer :: loc_x, loc_y

        loc_x = not_in_my_pe
        loc_y = not_in_my_pe

        if (se_myworker_pe .ge. 0) then
           if (((se_gl_ind(1,1,se_myworker_pe) - nthick) .le. x) .and. 
     &         (x .le. (se_gl_ind(2,1,se_myworker_pe) + nthick))) then
              loc_x = x - se_gl_ind(1,1,se_myworker_pe) + 1
           end if

           if (((se_gl_ind(1,2,se_myworker_pe) - nthick) .le. y) .and. 
     &         (y .le. (se_gl_ind(2,2,se_myworker_pe) + nthick))) then
              loc_y = y - se_gl_ind(1,2,se_myworker_pe) + 1
           end if

           if (loc_x .eq. not_in_my_pe) then
              loc_y = not_in_my_pe
           else if (loc_y .eq. not_in_my_pe) then
              loc_x = not_in_my_pe
           end if
        end if

        my_x = loc_x
        my_y = loc_y

        return
        end subroutine se_global_to_local_coord

C -- Fortran functions

C -----------------------------------------------------------------------------
C Purpose: determine the logical relationship between var1 and var2 according
C          to the operator, op, i.e. checking var1 op var2 is true or not
C
C   Orginal version: 2/15/99 by David Wong
C
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C
C                    10/05/00 by David Wong
C                      -- expanded to distinguish integer or real variable
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C
C Parameter List:
C
C   In: var1 -- variable one
C       var2 -- variable two
C       op   -- logical operator, EQ, GT, GE, LT, and LE
C
C Local Variable:
C
C   sum          -- local variable for computing global sum
C   lse_isum_chk -- local variable for holding the logical relationship
C   error        -- error code for mpi call
C
C Include Files:
C
C   se_pe_info.ext:
C -----------------------------------------------------------------------------

        function se_isum_chk (var1, op, var2) result (se_isum_chk_result)

        use se_pe_info_ext

        implicit none

        logical :: se_isum_chk_result
        integer, intent(in) :: var1, var2
        character (len = 2), intent(in) :: op

        include "mpif.h"

        integer :: sum, error
        logical :: lse_isum_chk

        call mpi_reduce (var1, sum, 1, mpi_integer, mpi_sum, 0,
     &                   se_worker_comm, error)

        if (se_myworker_pe .eq. 0) then
           lse_isum_chk = .false.
           if (op .eq. 'EQ') then
              if (sum .eq. var2) then
                 lse_isum_chk = .true.
              end if
           else if (op .eq. 'GT') then
              if (sum .gt. var2) then
                 lse_isum_chk = .true.
              end if
           else if (op .eq. 'GE') then
              if (sum .ge. var2) then
                 lse_isum_chk = .true.
              end if
           else if (op .eq. 'LT') then
              if (sum .lt. var2) then
                 lse_isum_chk = .true.
              end if
           else 
              if (sum .le. var2) then
                 lse_isum_chk = .true.
              end if
           end if
           se_isum_chk_result = lse_isum_chk
        end if

        call mpi_bcast (se_isum_chk_result, 1, mpi_logical, 0, 
     &                  se_worker_comm, error)

        return
        end function se_isum_chk

C -----------------------------------------------------------------------------
C Purpose: determine the logical relationship between var1 and var2 according
C          to the operator, op, i.e. checking var1 op var2 is true or not
C
C   Orginal version: 2/15/99 by David Wong
C
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C
C                    10/05/00 by David Wong
C                      -- expanded to distinguish integer or real variable
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C
C                    05/19/03 by David Wong
C                       -- fixed a bug which declared sum in the wrong type
C
C Parameter List:
C
C   In: var1 -- variable one
C       var2 -- variable two
C       op   -- logical operator, EQ, GT, GE, LT, and LE
C
C Local Variable:
C
C   sum          -- local variable for computing global sum
C   lse_rsum_chk -- local variable for holding the logical relationship
C   error        -- error code for mpi call
C
C Include Files:
C
C   se_pe_info.ext:
C -----------------------------------------------------------------------------

        function se_rsum_chk (var1, op, var2) result (se_rsum_chk_result)

        use se_pe_info_ext

        implicit none

        logical :: se_rsum_chk_result
        real, intent(in) :: var1, var2
        character (len = 2), intent(in) :: op

        include "mpif.h"

        real    :: sum
        integer :: error
        logical :: lse_rsum_chk

        call mpi_reduce (var1, sum, 1, mpi_real, mpi_sum, 0,
     &                   se_worker_comm, error)

        if (se_myworker_pe .eq. 0) then
           lse_rsum_chk = .false.
           if (op .eq. 'EQ') then
              if (sum .eq. var2) then
                 lse_rsum_chk = .true.
              end if
           else if (op .eq. 'GT') then
              if (sum .gt. var2) then
                 lse_rsum_chk = .true.
              end if
           else if (op .eq. 'GE') then
              if (sum .ge. var2) then
                 lse_rsum_chk = .true.
              end if
           else if (op .eq. 'LT') then
              if (sum .lt. var2) then
                 lse_rsum_chk = .true.
              end if
           else
              if (sum .le. var2) then
                 lse_rsum_chk = .true.
              end if
           end if
           se_rsum_chk_result = lse_rsum_chk
        end if

        call mpi_bcast (se_rsum_chk_result, 1, mpi_logical, 0,
     &                  se_worker_comm, error)

        return
        end function se_rsum_chk

C -----------------------------------------------------------------------------
C Purpose: 
C
C   to determine where a global grid point is reside in local processor when
C the global domain is decomposed
C
C  Revision history:
C
C   Orginal version: 6/18/99 by David Wong
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                      -- moved the data orientation dependency to higher level
C                    12/03/01 by David Wong
C                      -- modified the algorithm to set variable WPE negative
C                         if coordinate (x, y) is not in the domain
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C                    12/27/05 by David Wong
C                       -- made the routine more robust to avoid IO processor
C                          to access non-existence memory
C
C Parameter List:
C
C   In: x -- x coordinate of a global grid point
C       y -- y coordinate of a global grid point
C
C  Out: wpe -- PE number
C
C Local Variable:
C
C   lwpe   -- local PE number
C
C -----------------------------------------------------------------------------

        function se_my_region (x, y, wpe) result (se_my_region_result)

        use se_pe_info_ext
        use se_domain_info_ext

        implicit none

        include "mpif.h"

        integer, intent(in) :: x, y
        integer, intent(out) :: wpe
        logical :: se_my_region_result

        integer :: lwpe, error

        se_my_region_result = .false.
        lwpe = 0

        if (se_myworker_pe .ge. 0) then
           if ((se_gl_ind(1,1,se_myworker_pe) .le. x) .and.
     &         (x .le. se_gl_ind(2,1,se_myworker_pe)) .and.
     &         (se_gl_ind(1,2,se_myworker_pe) .le. y) .and.
     &         (y .le. se_gl_ind(2,2,se_myworker_pe))) then
              se_my_region_result = .true.
              lwpe = se_myworker_pe + 1
           end if
        end if

        call mpi_reduce (lwpe, wpe, 1, mpi_integer, mpi_sum, 0,
     &                   se_worker_comm, error)

        if (wpe .eq. 0) then
           wpe = -1
        else
           wpe = wpe - 1
        end if

        call mpi_bcast (wpe, 1, mpi_integer, 0, se_worker_comm, error)

        return
        end function se_my_region

C -----------------------------------------------------------------------------
C Purpose:
C
C   determine the global logical operation which can be AND, OR
C
C Revision history:
C
C   Orginal version: 04/24/00 by David Wong
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C
C Parameter List:
C
C   InOut: var      -- distributed variable which needs be determined the
C                      logical value among all processors
C   In   : operator -- operator type
C
C Local Variable:
C
C   temp_var -- local temporary copy of var
C   error    -- error code of mpi call
C
C Include Files:
C
C   mpif.h
C -----------------------------------------------------------------------------

        subroutine se_global_logical (var, op)

        use se_pe_info_ext

        implicit none

        logical var
        character*3 op

        include "mpif.h"

        logical temp_var
        integer error

        temp_var = var

        if ((op .eq. 'AND') .or. (op .eq. 'and')) then
           call mpi_reduce (var, temp_var, 1, mpi_logical, MPI_LAND, 0,
     &                      se_worker_comm, error)
        else if ((op .eq. 'OR') .or. (op .eq. 'or')) then
           call mpi_reduce (var, temp_var, 1, mpi_logical, MPI_LOR, 0,
     &                      se_worker_comm, error)
        end if

        call mpi_bcast (temp_var, 1, mpi_logical, 0, se_worker_comm, error)

        var = temp_var

        return
        end subroutine se_global_logical

C -----------------------------------------------------------------------------
C Purpose:
C
C   given starting point and ending point in terms of column and row number in
C original grid domain, determine a sub-grid mapping with re-distribution of
C data for a 2-D data structure. The routine provides a flexibility that the
C sub-grid has a different resolution indicates with optional variables: 
C nrows_in and ncols_in.
C
C Revision history:
C
C   Orginal version: 10/26/00 by David Wong
C
C                    1/23/01  by David Wong
C                      -- deallocate se_lgl_ind
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C
C                    12/27/05 by David Wong
C                       -- made the routine more robust to avoid IO processor
C                          to access non-existence memory
C
C                    08/24/11 by David Wong
C                      -- removed se_ori_ext to eliminate data and geo orientation
C
C Parameter List:
C
C   In  : begrow -- starting row number in the original grid
C         endrow -- ending row number in the original grid
C         begcol -- starting column number in the original grid
C         endcol -- ending column number in the original grid
C
C   Out : my_begrow -- starting row number of the sub-grid in a processor
C         my_endrow -- end row number of the sub-grid in a processor
C         my_begcol -- starting column number of the sub-grid in a processor
C         my_endcol -- end column number of the sub-grid in a processor
C         my_subgrid_rows -- number of sub-grid rows in a processor
C         my_subgrid_cols -- number of sub-grid columns in a processor
C
C  In (optional) : nrows_in -- number of rows in the sub-grid
C                  ncols_in -- number of columns in the sub-grid
C
C Local Variable:
C
C   intersect       -- intersection indicator
C   se_lgl_ind      -- local global index
C   se_lgl_ind_ptr  -- local global index pointer
C   i               -- loop index
C   allocate_status -- memory allocation error indicator
C
C -----------------------------------------------------------------------------

        subroutine se_subgrid_index_2 (begrow, endrow, begcol, endcol, 
     &                                 my_begrow, my_endrow, 
     &                                 my_begcol, my_endcol,
     &                                 my_subgrid_rows, my_subgrid_cols,
     &                                 nrows_in, ncols_in)

        use se_pe_info_ext
        use se_domain_info_ext
        use se_subgrid_info_ext
!       use se_ori_ext
        use se_internal_util_module

        implicit none

        integer, intent(in) :: begrow, endrow, begcol, endcol
        integer, intent(out) :: my_begrow, my_endrow, my_begcol, my_endcol
        integer, intent(out) :: my_subgrid_rows, my_subgrid_cols
        integer, optional, intent(in) :: nrows_in, ncols_in

        integer :: i, allocate_status

        integer, allocatable, target :: se_lgl_ind(:,:,:)
        integer, pointer :: se_lgl_ind_ptr(:,:,:)

        logical :: intersect

C -- allocate data
        allocate (se_subgrid_send_ind(2, 4, 0:se_numworkers-1), 
     &            stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              ' allocation erorr in se_subgrid_send_ind'
           stop
        end if

        allocate (se_subgrid_recv_ind(2, 4, 0:se_numworkers-1), 
     &            stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              ' allocation erorr in se_subgrid_recv_ind'
           stop
        end if

        allocate (se_subgrid_send(0:se_numworkers-1), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              'allocation erorr in se_subgrid_send'
           stop
        end if

        allocate (se_subgrid_recv(0:se_numworkers-1), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              'allocation erorr in se_subgrid_recv'
           stop
        end if

        se_subgrid_send_ind_ptr => se_subgrid_send_ind
        se_subgrid_recv_ind_ptr => se_subgrid_recv_ind
        se_subgrid_send_ptr => se_subgrid_send
        se_subgrid_recv_ptr => se_subgrid_recv

C -- allocate data
        allocate (se_subgrid_ind(2, 2, 0:se_numworkers-1), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error in subroutine SE_SUBGD_INDEX'
           stop
        end if

        se_subgrid_ind_ptr => se_subgrid_ind

        allocate (se_lgl_ind(2, 2, 0:se_numworkers-1), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error in subroutine SE_SUBGD_INDEX'
           stop
        end if
        se_lgl_ind_ptr => se_lgl_ind

        if (present(nrows_in)) then
!          if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
              call se_generate_map (1, ncols_in, 1, nrows_in, 
     &                              se_nprow, se_npcol, se_lgl_ind_ptr)
!          else
!             call se_generate_map (1, nrows_in, 1, ncols_in, 
!    &                              se_nprow, se_npcol, se_lgl_ind_ptr)
!          end if

C -- figure out the low and high column and row index of the
C    processor analysis (PA) grid, respectively

!          if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
              call se_generate_map (begcol, endcol, begrow, endrow,
     &                              se_nprow, se_npcol, se_subgrid_ind_ptr, 0)
!          else
!             call se_generate_map (begrow, endrow, begcol, endcol,
!    &                              se_nprow, se_npcol, se_subgrid_ind_ptr, 0)
!          end if

        else

           se_lgl_ind = se_gl_ind

C -- figure out the low and high column and row index of the
C    fine sub grid, respectively

!          if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
              call se_generate_map (begcol, endcol, begrow, endrow,
     &                              se_nprow, se_npcol, se_subgrid_ind_ptr)
!          else
!             call se_generate_map (begrow, endrow, begcol, endcol,
!    &                              se_nprow, se_npcol, se_subgrid_ind_ptr)
!          end if
        end if

        if (se_myworker_pe .ge. 0) then
           do i = 0, se_numworkers-1
              intersect = .true.
              if (     (se_subgrid_ind(1,1,i) .gt. se_subgrid_ind(2,1,i))
     &            .or. (se_subgrid_ind(1,2,i) .gt. se_subgrid_ind(2,2,i))
     &            .or. (se_lgl_ind(1,1,se_myworker_pe) .gt. se_subgrid_ind(2,1,i))
     &            .or. (se_lgl_ind(2,1,se_myworker_pe) .lt. se_subgrid_ind(1,1,i))) then
                 intersect = .false.
              else
                 if (     (se_lgl_ind(1,2,se_myworker_pe) .gt. se_subgrid_ind(2,2,i))
     &               .or. (se_lgl_ind(2,2,se_myworker_pe) .lt. se_subgrid_ind(1,2,i))) 
     &                    then
                    intersect = .false.
                 end if
              end if

              if (intersect) then
                 se_subgrid_send_ind(1,1,i) = max(se_lgl_ind(1,1,se_myworker_pe),
     &                                        se_subgrid_ind(1,1,i))
     &                                   - se_lgl_ind(1,1,se_myworker_pe) + 1
                 se_subgrid_send_ind(2,1,i) = min(se_lgl_ind(2,1,se_myworker_pe),
     &                                        se_subgrid_ind(2,1,i))
     &                                   - se_lgl_ind(1,1,se_myworker_pe) + 1
                 se_subgrid_send_ind(1,2,i) = max(se_lgl_ind(1,2,se_myworker_pe),
     &                                        se_subgrid_ind(1,2,i))
     &                                   - se_lgl_ind(1,2,se_myworker_pe) + 1
                 se_subgrid_send_ind(2,2,i) = min(se_lgl_ind(2,2,se_myworker_pe),
     &                                        se_subgrid_ind(2,2,i))
     &                                   - se_lgl_ind(1,2,se_myworker_pe) + 1
                 se_subgrid_send(i) = i
              else
                 se_subgrid_send(i) = -1
              end if
           end do

C -- determine data is going to receive from which PE, and corresponding local
C    index

           do i = 0, se_numworkers-1
              intersect = .true.
              if (     (se_subgrid_ind(1,1,se_myworker_pe) .gt. 
     &                     se_subgrid_ind(2,1,se_myworker_pe))
     &            .or. (se_subgrid_ind(1,2,se_myworker_pe) .gt. 
     &                     se_subgrid_ind(2,2,se_myworker_pe))
     &            .or. (se_lgl_ind(1,1,i) .gt. se_subgrid_ind(2,1,se_myworker_pe))
     &            .or. (se_lgl_ind(2,1,i) .lt. se_subgrid_ind(1,1,se_myworker_pe))) then
                 intersect = .false.
              else
                 if (     (se_lgl_ind(1,2,i) .gt. se_subgrid_ind(2,2,se_myworker_pe))
     &               .or. (se_lgl_ind(2,2,i) .lt. se_subgrid_ind(1,2,se_myworker_pe))) 
     &                    then
                    intersect = .false.
                 end if
              end if

              if (intersect) then
                 se_subgrid_recv_ind(1,1,i) = max(se_lgl_ind(1,1,i),
     &                                        se_subgrid_ind(1,1,se_myworker_pe))
     &                                      - se_subgrid_ind(1,1,se_myworker_pe) + 1
                    se_subgrid_recv_ind(2,1,i) = min(se_lgl_ind(2,1,i),
     &                                        se_subgrid_ind(2,1,se_myworker_pe))
     &                                   - se_subgrid_ind(1,1,se_myworker_pe) + 1
                 se_subgrid_recv_ind(1,2,i) = max(se_lgl_ind(1,2,i),
     &                                        se_subgrid_ind(1,2,se_myworker_pe))
     &                                   - se_subgrid_ind(1,2,se_myworker_pe) + 1
                 se_subgrid_recv_ind(2,2,i) = min(se_lgl_ind(2,2,i),
     &                                        se_subgrid_ind(2,2,se_myworker_pe))
     &                                   - se_subgrid_ind(1,2,se_myworker_pe) + 1
                 se_subgrid_recv(i) = i
              else
                 se_subgrid_recv(i) = -1
              end if
           end do

C -- determine begining and ending row and column indexes, respectively

           my_begrow = 1
           my_begcol = 1
           my_endrow = se_subgrid_ind(2,1,se_myworker_pe) - 
     &                 se_subgrid_ind(1,1,se_myworker_pe) + 1
           my_endcol = se_subgrid_ind(2,2,se_myworker_pe) - 
     &                 se_subgrid_ind(1,2,se_myworker_pe) + 1

C -- if row or column is not included in a processor, set column or row
C    outside the range, respectively

           if (my_endrow .eq. 0) then
              my_endcol = 0
           else if (my_endcol .eq. 0) then
              my_endrow = 0
           end if

           my_subgrid_rows = my_endrow - my_begrow + 1
           my_subgrid_cols = my_endcol - my_begcol + 1
        else
           my_begrow = -1
           my_begcol = -1
           my_endcol = -1
           my_endrow = -1
           my_subgrid_rows = -1
           my_subgrid_cols = -1
        end if

        deallocate (se_lgl_ind)

        return
        end subroutine se_subgrid_index_2

C -----------------------------------------------------------------------------
C Purpose:
C
C   given starting point and ending point in terms of column, row, and level 
C number in original grid domain, determine a sub-grid mapping with 
C re-distribution of data for a 3-D data structure. The routine provides a 
C flexibility that the sub-grid has a different resolution indicates with 
C optional variables: nrows_in, ncols_in, and nlevs_in.
C
C Revision history:
C
C   Orginal version: 10/26/00 by David Wong
C                    12/18/00 by Jeff Young
C                    -- remove my_subgrid_levs to make backwardly compatible w/
C                       CCTM code - can't decompose in this dimension now.
C
C                    1/23/01  by David Wong
C                      -- deallocate se_lgl_ind
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C
C                    12/27/05 by David Wong
C                       -- made the routine more robust to avoid IO processor
C                          to access non-existence memory
C
C                    08/24/11 by David Wong
C                      -- removed se_ori_ext to eliminate data and geo orientation
C
C Parameter List:
C
C   In  : begrow -- starting row number in the original grid
C         endrow -- ending row number in the original grid
C         begcol -- starting column number in the original grid
C         endcol -- ending column number in the original grid
C         beglev -- starting level number in the original grid
C         endlev -- ending level number in the original grid
C
C  In (optional) : nrows_in -- number of rows in the sub-grid
C                  ncols_in -- number of columns in the sub-grid
C                  nlevs_in -- number of levels in the sub-grid
C
C   Out : my_begrow -- starting row number of the sub-grid in a processor
C         my_endrow -- end row number of the sub-grid in a processor
C         my_begcol -- starting column number of the sub-grid in a processor
C         my_endcol -- end column number of the sub-grid in a processor
C         my_beglev -- starting level number of the sub-grid in a processor
C         my_endlev -- end level number of the sub-grid in a processor
C         my_subgrid_rows -- number of sub-grid rows in a processor
C         my_subgrid_cols -- number of sub-grid columns in a processor
C
C         my_subgrid_levs -- number of sub-grid levels in a processor
C         ^^^^^^^^^^^^^^^  eliminated for now, maybe implement later
C
C Local Variable:
C
C   intersect       -- intersection indicator
C   se_lgl_ind      -- local global index
C   se_lgl_ind_ptr  -- local global index pointer
C   i               -- loop index
C   allocate_status -- memory allocation error indicator
C
C -----------------------------------------------------------------------------

        subroutine se_subgrid_index_3
     &      ( begrow, endrow, begcol, endcol, beglev, endlev,
     &        my_begrow, my_endrow, my_begcol, my_endcol, my_beglev, my_endlev,
!    &        my_subgrid_rows, my_subgrid_cols, my_subgrid_levs, 
     &        my_subgrid_rows, my_subgrid_cols, 
     &        nrows_in, ncols_in, nlevs_in )

        use se_pe_info_ext
        use se_domain_info_ext
        use se_subgrid_info_ext
!       use se_ori_ext
        use se_internal_util_module

        implicit none

        integer, intent(in) :: begrow, endrow, begcol, endcol, beglev, endlev
        integer, intent(out) :: my_begrow, my_endrow, my_begcol, my_endcol
        integer, intent(out) :: my_beglev, my_endlev
        integer, intent(out) :: my_subgrid_rows, my_subgrid_cols
!    &                          my_subgrid_levs
        integer, optional, intent(in) :: nrows_in, ncols_in, nlevs_in

        integer :: i, allocate_status

        integer, allocatable, target :: se_lgl_ind(:,:,:)
        integer, pointer :: se_lgl_ind_ptr(:,:,:)

        logical :: intersect

C -- allocate data
        allocate (se_subgrid_send_ind(2, 4, 0:se_numworkers-1), 
     &            stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              ' allocation erorr in se_subgrid_send_ind'
           stop
        end if

        allocate (se_subgrid_recv_ind(2, 4, 0:se_numworkers-1), 
     &            stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              ' allocation erorr in se_subgrid_recv_ind'
           stop
        end if

        allocate (se_subgrid_send(0:se_numworkers-1), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              'allocation erorr in se_subgrid_send'
           stop
        end if

        allocate (se_subgrid_recv(0:se_numworkers-1), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              'allocation erorr in se_subgrid_recv'
           stop
        end if

        se_subgrid_send_ind_ptr => se_subgrid_send_ind
        se_subgrid_recv_ind_ptr => se_subgrid_recv_ind
        se_subgrid_send_ptr => se_subgrid_send
        se_subgrid_recv_ptr => se_subgrid_recv

C -- allocate data
        allocate (se_subgrid_ind(2, 2, 0:se_numworkers-1), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error in subroutine SE_SUBGD_INDEX'
           stop
        end if

        se_subgrid_ind_ptr => se_subgrid_ind

        allocate (se_lgl_ind(2, 2, 0:se_numworkers-1), stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error in subroutine SE_SUBGD_INDEX'
           stop
        end if
        se_lgl_ind_ptr => se_lgl_ind

        if (present(nrows_in)) then
!          if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
              call se_generate_map (1, ncols_in, 1, nrows_in, 
     &                              se_nprow, se_npcol, se_lgl_ind_ptr)
!          else
!             call se_generate_map (1, nrows_in, 1, ncols_in, 
!    &                              se_nprow, se_npcol, se_lgl_ind_ptr)
!          end if

C -- figure out the low and high column and row index of the
C    processor analysis (PA) grid, respectively

!          if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
              call se_generate_map (begcol, endcol, begrow, endrow,
     &                              se_nprow, se_npcol, se_subgrid_ind_ptr, 0)
!          else
!             call se_generate_map (begrow, endrow, begcol, endcol,
!    &                              se_nprow, se_npcol, se_subgrid_ind_ptr, 0)
!          end if

        else

           se_lgl_ind = se_gl_ind

C -- figure out the low and high column and row index of the
C    fine sub grid, respectively

!          if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
              call se_generate_map (begcol, endcol, begrow, endrow,
     &                              se_nprow, se_npcol, se_subgrid_ind_ptr)
!          else
!             call se_generate_map (begrow, endrow, begcol, endcol,
!    &                              se_nprow, se_npcol, se_subgrid_ind_ptr)
!          end if
        end if

        if (se_myworker_pe .ge. 0) then
           do i = 0, se_numworkers-1
              intersect = .true.
              if (     (se_subgrid_ind(1,1,i) .gt. se_subgrid_ind(2,1,i))
     &            .or. (se_subgrid_ind(1,2,i) .gt. se_subgrid_ind(2,2,i))
     &            .or. (se_lgl_ind(1,1,se_myworker_pe) .gt. se_subgrid_ind(2,1,i))
     &            .or. (se_lgl_ind(2,1,se_myworker_pe) .lt. se_subgrid_ind(1,1,i))) then
                 intersect = .false.
              else
                 if (     (se_lgl_ind(1,2,se_myworker_pe) .gt. se_subgrid_ind(2,2,i))
     &               .or. (se_lgl_ind(2,2,se_myworker_pe) .lt. se_subgrid_ind(1,2,i))) 
     &                    then
                    intersect = .false.
                 end if
              end if

              if (intersect) then
                 se_subgrid_send_ind(1,1,i) = max(se_lgl_ind(1,1,se_myworker_pe),
     &                                        se_subgrid_ind(1,1,i))
     &                                   - se_lgl_ind(1,1,se_myworker_pe) + 1
                 se_subgrid_send_ind(2,1,i) = min(se_lgl_ind(2,1,se_myworker_pe),
     &                                        se_subgrid_ind(2,1,i))
     &                                      - se_lgl_ind(1,1,se_myworker_pe) + 1
                 se_subgrid_send_ind(1,2,i) = max(se_lgl_ind(1,2,se_myworker_pe),
     &                                        se_subgrid_ind(1,2,i))
     &                                   - se_lgl_ind(1,2,se_myworker_pe) + 1
                 se_subgrid_send_ind(2,2,i) = min(se_lgl_ind(2,2,se_myworker_pe),
     &                                        se_subgrid_ind(2,2,i))
     &                                   - se_lgl_ind(1,2,se_myworker_pe) + 1
                 se_subgrid_send(i) = i
              else
                 se_subgrid_send(i) = -1
              end if
           end do

C -- determine data is going to receive from which PE, and corresponding local
C    index

           do i = 0, se_numworkers-1
              intersect = .true.
              if (     (se_subgrid_ind(1,1,se_myworker_pe) .gt. 
     &                     se_subgrid_ind(2,1,se_myworker_pe))
     &            .or. (se_subgrid_ind(1,2,se_myworker_pe) .gt. 
     &                     se_subgrid_ind(2,2,se_myworker_pe))
     &            .or. (se_lgl_ind(1,1,i) .gt. se_subgrid_ind(2,1,se_myworker_pe))
     &            .or. (se_lgl_ind(2,1,i) .lt. se_subgrid_ind(1,1,se_myworker_pe))) then
                 intersect = .false.
              else
                 if (     (se_lgl_ind(1,2,i) .gt. se_subgrid_ind(2,2,se_myworker_pe))
     &               .or. (se_lgl_ind(2,2,i) .lt. se_subgrid_ind(1,2,se_myworker_pe))) 
     &                    then
                    intersect = .false.
                 end if
              end if

              if (intersect) then
                 se_subgrid_recv_ind(1,1,i) = max(se_lgl_ind(1,1,i),
     &                                        se_subgrid_ind(1,1,se_myworker_pe))
     &                                   - se_subgrid_ind(1,1,se_myworker_pe) + 1
                 se_subgrid_recv_ind(2,1,i) = min(se_lgl_ind(2,1,i),
     &                                        se_subgrid_ind(2,1,se_myworker_pe))
     &                                   - se_subgrid_ind(1,1,se_myworker_pe) + 1
                 se_subgrid_recv_ind(1,2,i) = max(se_lgl_ind(1,2,i),
     &                                        se_subgrid_ind(1,2,se_myworker_pe))
     &                                   - se_subgrid_ind(1,2,se_myworker_pe) + 1
                 se_subgrid_recv_ind(2,2,i) = min(se_lgl_ind(2,2,i),
     &                                        se_subgrid_ind(2,2,se_myworker_pe))
     &                                   - se_subgrid_ind(1,2,se_myworker_pe) + 1
                 se_subgrid_recv(i) = i
              else
                 se_subgrid_recv(i) = -1
              end if
           end do

C -- determine begining and ending row and column indexes, respectively

           my_begrow = 1
           my_begcol = 1
           my_endrow = se_subgrid_ind(2,1,se_myworker_pe) - 
     &                 se_subgrid_ind(1,1,se_myworker_pe) + 1
           my_endcol = se_subgrid_ind(2,2,se_myworker_pe) - 
     &                 se_subgrid_ind(1,2,se_myworker_pe) + 1

C -- if row or column is not included in a processor, set column or row
C    outside the range, respectively

           if (my_endrow .eq. 0) then
              my_endcol = 0
           else if (my_endcol .eq. 0) then
              my_endrow = 0
           end if

           my_subgrid_rows = my_endrow - my_begrow + 1
           my_subgrid_cols = my_endcol - my_begcol + 1

           my_beglev = beglev
           my_endlev = endlev
!          my_subgrid_levs = my_endlev - my_beglev + 1

           if (present(nrows_in)) then
              se_my_subgrid_beglev = 1
              se_my_subgrid_endlev = se_my_nlays
           else
              se_my_subgrid_beglev = beglev
              se_my_subgrid_endlev = endlev
           end if
c          my_subgrid_levs = se_my_subgrid_endlev - se_my_subgrid_beglev + 1
        else
           my_begrow = -1
           my_begcol = -1
           my_endrow = -1
           my_endcol = -1
           my_beglev = -1
           my_endlev = -1
           my_subgrid_rows = -1
           my_subgrid_cols = -1
c          my_subgrid_levs = -1
        end if

!       print*, '  myworker_pe: ', se_myworker_pe
!       do i = 0, se_numworkers-1
!          print*, ' i, se_lgl_ind( 1,1,i ): ',          i, se_lgl_ind( 1,1,i )
!          print*, ' i, se_lgl_ind( 2,1,i ): ',          i, se_lgl_ind( 2,1,i )
!          print*, ' i, se_lgl_ind( 1,2,i ): ',          i, se_lgl_ind( 1,2,i )
!          print*, ' i, se_lgl_ind( 2,2,i ): ',          i, se_lgl_ind( 2,2,i )
!          print*, ' i, se_subgrid_ind( 1,1,i ): ',      i, se_subgrid_ind( 1,1,i )
!          print*, ' i, se_subgrid_ind( 2,1,i ): ',      i, se_subgrid_ind( 2,1,i )
!          print*, ' i, se_subgrid_ind( 1,2,i ): ',      i, se_subgrid_ind( 1,2,i )
!          print*, ' i, se_subgrid_ind( 2,2,i ): ',      i, se_subgrid_ind( 2,2,i )
!          print*, ' i, se_subgrid_send( i ): ',         i, se_subgrid_send( i )
!          print*, ' i, se_subgrid_recv( i ): ',         i, se_subgrid_recv( i )
!          print*, ' i, se_subgrid_send_ind( 1,1,i ): ', i, se_subgrid_send_ind( 1,1,i )
!          print*, ' i, se_subgrid_send_ind( 2,1,i ): ', i, se_subgrid_send_ind( 2,1,i )
!          print*, ' i, se_subgrid_send_ind( 1,2,i ): ', i, se_subgrid_send_ind( 1,2,i )
!          print*, ' i, se_subgrid_send_ind( 2,2,i ): ', i, se_subgrid_send_ind( 2,2,i )
!          print*, ' i, se_subgrid_recv_ind( 1,1,i ): ', i, se_subgrid_recv_ind( 1,1,i )
!          print*, ' i, se_subgrid_recv_ind( 2,1,i ): ', i, se_subgrid_recv_ind( 2,1,i )
!          print*, ' i, se_subgrid_recv_ind( 1,2,i ): ', i, se_subgrid_recv_ind( 1,2,i )
!          print*, ' i, se_subgrid_recv_ind( 2,2,i ): ', i, se_subgrid_recv_ind( 2,2,i )
!       end do

        deallocate (se_lgl_ind)

        return
        end subroutine se_subgrid_index_3

C -----------------------------------------------------------------------------
C Purpose:
C
C   given starting point and ending point in terms of column and row number in
C original grid domain, determine a sub-grid mapping without re-distribution of
C data for a 2-D data structure.
C
C Revision history:
C
C   Orginal version: 10/26/00 by David Wong
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C
C                    08/24/11 by David Wong
C                      -- removed se_ori_ext to eliminate data and geo orientation
C
C Parameter List:
C
C   In  : begrow -- starting row number in the original grid
C         endrow -- ending row number in the original grid
C         begcol -- starting column number in the original grid
C         endcol -- ending column number in the original grid
C         flag   -- an indicator of no re-distribution
C
C   Out : my_begrow -- starting row number of the sub-grid in a processor
C         my_endrow -- end row number of the sub-grid in a processor
C         my_begcol -- starting column number of the sub-grid in a processor
C         my_endcol -- end column number of the sub-grid in a processor
C
C Local Variable:
C
C   tpe           -- temporary processor number
C   mpe           -- processor number form by modulus arithmetic
C   dpe           -- processor number form by integer division arithmetic
C   col_ind       -- column index
C   row_ind       -- row index
C   loc_begrow    -- local starting row number
C   loc_endrow    -- local ending row number
C   loc_begcol    -- local starting column number
C   loc_endcol    -- local ending column number
C   loc_my_begrow -- local starting row number in a processor
C   loc_my_endrow -- local ending row number in a processor
C   loc_my_begcol -- local starting column number in a processor
C   loc_my_endcol -- local ending column number in a processor
C
C -----------------------------------------------------------------------------

        subroutine se_subgrid_index_n2 (begrow, endrow, begcol, endcol, 
     &                                  my_begrow, my_endrow, 
     &                                  my_begcol, my_endcol, flag)

        use se_pe_info_ext
!       use se_ori_ext
        use se_domain_info_ext

        implicit none

        integer, intent(in) :: begrow, endrow, begcol, endcol
        integer, intent(out) ::  my_begrow, my_endrow, my_begcol, my_endcol
        character, intent(in) :: flag

        integer :: col_ind(2), row_ind(2)
        integer :: tpe, mpe, dpe
        integer :: loc_my_begrow, loc_my_endrow,
     &             loc_my_begcol, loc_my_endcol
        integer :: loc_begrow, loc_endrow, loc_begcol, loc_endcol

!       if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
           loc_begcol = begrow
           loc_endcol = endrow
           loc_begrow = begcol
           loc_endrow = endcol
!       else
!          loc_begcol = begcol
!          loc_endcol = endcol
!          loc_begrow = begrow
!          loc_endrow = endrow
!       end if

C -- figure out the low and high column index of the original grid

        tpe = mod(se_gl_ncols, se_npcol)
        mpe = mod(se_myworker_pe, se_npcol)
        col_ind(1) = 1 + min(mpe, tpe) * se_ncols + max(mpe-tpe,0) * se_my_ncols
        col_ind(2) = min(mpe+1, tpe) * se_ncols + max(mpe-tpe+1,0) * se_my_ncols
C -- determine the mapping of column of the PA grid to each processor

        if ((col_ind(2) .lt. loc_begcol) .or. (col_ind(1) .gt. loc_endcol)) then
           loc_my_begcol = 0
           loc_my_endcol = -1
        else if ((col_ind(1) .lt. loc_begcol) .and. (loc_begcol .le. col_ind(2))
     &           .and. (loc_endcol .gt. col_ind(2))) then
           loc_my_begcol = loc_begcol - col_ind(1) + 1
           loc_my_endcol = col_ind(2) - col_ind(1) + 1
        else if ((col_ind(1) .le. loc_endcol) .and. (loc_endcol .lt. col_ind(2))
     &           .and. (loc_begcol .lt. col_ind(1))) then
           loc_my_begcol = 1
           loc_my_endcol = loc_endcol - col_ind(1) + 1
        else
           loc_my_begcol = max(loc_begcol-col_ind(1)+1, 1)
           loc_my_endcol = loc_my_begcol + min(col_ind(2)-col_ind(1),
     &                                         loc_endcol-loc_begcol)
        end if

C -- figure out the low and high row index of the original grid

        tpe = mod(se_gl_nrows, se_nprow)
        dpe = se_myworker_pe / se_npcol
        row_ind(1) = 1 + min(dpe, tpe) * se_nrows + max(dpe-tpe,0) * se_my_nrows
        row_ind(2) = min(dpe+1, tpe) * se_nrows + max(dpe-tpe+1,0) * se_my_nrows
C -- determine the mapping of row of the PA grid to each processor

        if ((row_ind(2) .lt. loc_begrow) .or. (row_ind(1) .gt. loc_endrow)) then
           loc_my_begrow = 0
           loc_my_endrow = -1
        else if ((row_ind(1) .lt. loc_begrow) .and. (loc_begrow .le. row_ind(2))
     &           .and. (loc_endrow .gt. row_ind(2))) then
           loc_my_begrow = loc_begrow - row_ind(1) + 1
           loc_my_endrow = row_ind(2) - row_ind(1) + 1
        else if ((row_ind(1) .le. loc_endrow) .and. (loc_endrow .lt. row_ind(2))
     &           .and. (loc_begrow .lt. row_ind(1))) then
           loc_my_begrow = 1
           loc_my_endrow = loc_endrow - row_ind(1) + 1
        else
           loc_my_begrow = max(loc_begrow-row_ind(1)+1, 1)
           loc_my_endrow = loc_my_begrow + min(row_ind(2)-row_ind(1),
     &                                         loc_endrow-loc_begrow)
        end if

C -- if row or column is not within the PA grid dimensions, set column or row
C    outside the range, respectively

        if (loc_my_begrow .eq. 0) then
           loc_my_begcol = 0
           loc_my_endcol = -1
        else if (loc_my_begcol .eq. 0) then
           loc_my_begrow = 0
           loc_my_endrow = -1
        end if

!       if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
           my_begrow = loc_my_begcol
           my_endrow = loc_my_endcol
           my_begcol = loc_my_begrow
           my_endcol = loc_my_endrow
!       else
!          my_begrow = loc_my_begrow
!          my_endrow = loc_my_endrow
!          my_begcol = loc_my_begcol
!          my_endcol = loc_my_endcol
!       end if

        return
        end subroutine se_subgrid_index_n2

C -----------------------------------------------------------------------------
C Purpose:
C
C   given starting point and ending point in terms of column, row, and level 
C number in original grid domain, determine a sub-grid mapping without 
C re-distribution of data for a 3-D data structure.
C
C Revision history:
C
C   Orginal version: 10/26/00 by David Wong
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C
C                    08/24/11 by David Wong
C                      -- removed se_ori_ext to eliminate data and geo orientation
C
C Parameter List:
C
C   In  : begrow -- starting row number in the original grid
C         endrow -- ending row number in the original grid
C         begcol -- starting column number in the original grid
C         endcol -- ending column number in the original grid
C         beglev -- starting level number in the original grid
C         endlev -- ending level number in the original grid
C         flag   -- an indicator of no re-distribution
C
C   Out : my_begrow -- starting row number of the sub-grid in a processor
C         my_endrow -- end row number of the sub-grid in a processor
C         my_begcol -- starting column number of the sub-grid in a processor
C         my_endcol -- end column number of the sub-grid in a processor
C         my_beglev -- starting level number of the sub-grid in a processor
C         my_endlev -- end level number of the sub-grid in a processor
C
C Local Variable:
C
C   tpe           -- temporary processor number
C   mpe           -- processor number form by modulus arithmetic
C   dpe           -- processor number form by integer division arithmetic
C   col_ind       -- column index
C   row_ind       -- row index
C   loc_begrow    -- local starting row number
C   loc_endrow    -- local ending row number
C   loc_begcol    -- local starting column number
C   loc_endcol    -- local ending column number
C   loc_my_begrow -- local starting row number in a processor
C   loc_my_endrow -- local ending row number in a processor
C   loc_my_begcol -- local starting column number in a processor
C   loc_my_endcol -- local ending column number in a processor
C
C -----------------------------------------------------------------------------

        subroutine se_subgrid_index_n3 (begrow, endrow, begcol, endcol, 
     &                                  beglev, endlev,
     &                                  my_begrow, my_endrow, 
     &                                  my_begcol, my_endcol, 
     &                                  my_beglev, my_endlev, flag)

        use se_pe_info_ext
!       use se_ori_ext
        use se_domain_info_ext

        implicit none

        integer, intent(in) :: begrow, endrow, begcol, endcol, beglev, endlev
        integer, intent(out) ::  my_begrow, my_endrow, my_begcol,
     &                           my_endcol, my_beglev, my_endlev
        character, intent(in) :: flag

        integer :: col_ind(2), row_ind(2)
        integer :: tpe, mpe, dpe
        integer :: loc_my_begrow, loc_my_endrow,
     &             loc_my_begcol, loc_my_endcol
        integer :: loc_begrow, loc_endrow, loc_begcol, loc_endcol

!       if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
           loc_begcol = begrow
           loc_endcol = endrow
           loc_begrow = begcol
           loc_endrow = endcol
!       else
!          loc_begcol = begcol
!          loc_endcol = endcol
!          loc_begrow = begrow
!          loc_endrow = endrow
!       end if

C -- figure out the low and high column index of the original grid

        tpe = mod(se_gl_ncols, se_npcol)
        mpe = mod(se_myworker_pe, se_npcol)
        col_ind(1) = 1 + min(mpe, tpe) * se_ncols + max(mpe-tpe,0) * se_my_ncols
        col_ind(2) = min(mpe+1, tpe) * se_ncols + max(mpe-tpe+1,0) * se_my_ncols
C -- determine the mapping of column of the PA grid to each processor

        if ((col_ind(2) .lt. loc_begcol) .or. (col_ind(1) .gt. loc_endcol)) then
           loc_my_begcol = 0
           loc_my_endcol = -1
        else if ((col_ind(1) .lt. loc_begcol) .and. (loc_begcol .le. col_ind(2))
     &           .and. (loc_endcol .gt. col_ind(2))) then
           loc_my_begcol = loc_begcol - col_ind(1) + 1
           loc_my_endcol = col_ind(2) - col_ind(1) + 1
        else if ((col_ind(1) .le. loc_endcol) .and. (loc_endcol .lt. col_ind(2))
     &           .and. (loc_begcol .lt. col_ind(1))) then
           loc_my_begcol = 1
           loc_my_endcol = loc_endcol - col_ind(1) + 1
        else
           loc_my_begcol = max(loc_begcol-col_ind(1)+1, 1)
           loc_my_endcol = loc_my_begcol + min(col_ind(2)-col_ind(1),
     &                                         loc_endcol-loc_begcol)
        end if

C -- figure out the low and high row index of the original grid

        tpe = mod(se_gl_nrows, se_nprow)
        dpe = se_myworker_pe / se_npcol
        row_ind(1) = 1 + min(dpe, tpe) * se_nrows + max(dpe-tpe,0) * se_my_nrows
        row_ind(2) = min(dpe+1, tpe) * se_nrows + max(dpe-tpe+1,0) * se_my_nrows
C -- determine the mapping of row of the PA grid to each processor

        if ((row_ind(2) .lt. loc_begrow) .or. (row_ind(1) .gt. loc_endrow)) then
           loc_my_begrow = 0
           loc_my_endrow = -1
        else if ((row_ind(1) .lt. loc_begrow) .and. (loc_begrow .le. row_ind(2))
     &           .and. (loc_endrow .gt. row_ind(2))) then
           loc_my_begrow = loc_begrow - row_ind(1) + 1
           loc_my_endrow = row_ind(2) - row_ind(1) + 1
        else if ((row_ind(1) .le. loc_endrow) .and. (loc_endrow .lt. row_ind(2))
     &           .and. (loc_begrow .lt. row_ind(1))) then
           loc_my_begrow = 1
           loc_my_endrow = loc_endrow - row_ind(1) + 1
        else
           loc_my_begrow = max(loc_begrow-row_ind(1)+1, 1)
           loc_my_endrow = loc_my_begrow + min(row_ind(2)-row_ind(1),
     &                                         loc_endrow-loc_begrow)
        end if

C -- if row or column is not within the PA grid dimensions, set column or row
C    outside the range, respectively

        if (loc_my_begrow .eq. 0) then
           loc_my_begcol = 0
           loc_my_endcol = -1
        else if (loc_my_begcol .eq. 0) then
           loc_my_begrow = 0
           loc_my_endrow = -1
        end if

!       if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
           my_begrow = loc_my_begcol
           my_endrow = loc_my_endcol
           my_begcol = loc_my_begrow
           my_endcol = loc_my_endrow
!       else
!          my_begrow = loc_my_begrow
!          my_endrow = loc_my_endrow
!          my_begcol = loc_my_begcol
!          my_endcol = loc_my_endcol
!       end if

        my_beglev = beglev
        my_endlev = endlev

        return
        end subroutine se_subgrid_index_n3

C -----------------------------------------------------------------------------
C Purpose:
C
C   synchronizes the value of var in all the processors according to the value
C   in processor pe
C
C Revision history:
C
C   Orginal version: 12/04/01 by David Wong
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C
C Parameter List:
C
C   InOut : var -- logical value
C   In    : pe  -- processor number
C -----------------------------------------------------------------------------

        subroutine se_in_syn (var, pe)

        use se_pe_info_ext

        implicit none

        logical, intent(inout) :: var
        integer, intent(in) :: pe

        integer :: error
 
        include "mpif.h"

        if (pe .ge. 0) then
           call mpi_bcast (var, 1, mpi_logical, pe, se_worker_comm, error)
        end if

        return
        end subroutine se_in_syn

C -----------------------------------------------------------------------------
C Purpose:
C
C   synchronizes the value of var in all the processors according to the value
C   in processor pe
C
C Revision history:
C
C   Orginal version: 12/04/01 by David Wong
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C
C Parameter List:
C
C   InOut : var -- logical value
C   In    : pe  -- processor number
C -----------------------------------------------------------------------------

        subroutine se_collect (ncols, nrows, ncols_pe, nrows_pe)

        use se_pe_info_ext

        implicit none

        include "mpif.h"

        integer, intent(inout) :: ncols, nrows
        integer, intent(out) :: ncols_pe(:), nrows_pe(:)

        integer :: sdata(2), rdata(2)
        integer :: i, error, status(MPI_STATUS_SIZE)

        if (se_my_pe .eq. 0) then
           ncols_pe = 0
           nrows_pe = 0
           do i = 1, se_numprocs-1
              call mpi_recv (rdata, 2, mpi_integer, i,
     &                       i, se_world_comm, status, error)
              ncols_pe(i+1) = rdata(1)
              nrows_pe(i+1) = rdata(2)
           end do
           ncols = maxval(ncols_pe)
           nrows = maxval(nrows_pe)
        else
           sdata(1) = ncols
           sdata(2) = nrows
           call mpi_send (sdata, 2, mpi_integer, 0, se_my_pe, se_world_comm, error)
        end if
        
        end subroutine se_collect

        end module se_util_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/PARIO/src/alloc_data_mod.f,v 1.2 2006/06/05 17:36:42 yoj Exp $ 

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C....................................................................
C  CONTAINS:  Allocated variables used by pwrgrdd
              
C  REVISION HISTORY:
C       Original version 01/10/05 by David Wong
C....................................................................

      MODULE ALLOC_DATA_MODULE

      REAL, ALLOCATABLE, SAVE :: WRITBUF( :,:,: )
      REAL, ALLOCATABLE, SAVE :: RECVBUF( : )

      END MODULE ALLOC_DATA_MODULE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains key component from EMIS_DEFN.F to facilitate 
! centralized I/O implementation by avoiding cyclic data dependence

! Revision History:
!  01 Feb 2019 D.Wong initial implementation, 
!------------------------------------------------------------------------!

      module desid_param_module

        INTEGER :: DESID_N_SRM   ! number of DESID emissions streams
        INTEGER :: DESID_N_ISTR  ! number of emissions instruction stacks
        INTEGER :: DESID_N_REG   ! number of region masks
        INTEGER :: DESID_N_DIAG  ! number of DESID Diagnostic files

        INTEGER, ALLOCATABLE :: DESID_GRID_LAYS(:) ! Number of Grid Layers 
                                                   !   for each stream
        INTEGER              :: DESID_MAXLAYS = 0  ! Maximum Emission Layers

        ! Define Data Structure for Reading Emission Control Namelist Input
        TYPE DESID_RULES_TYPE
            CHARACTER( 32 ) :: REGION
            CHARACTER( 32 ) :: STREAM
            CHARACTER( 16 ) :: EMVAR
            CHARACTER( 16 ) :: SPEC
            CHARACTER( 16 ) :: PHASE
            REAL            :: FAC
            CHARACTER( 4  ) :: BASIS
            CHARACTER( 1  ) :: OP
        END TYPE DESID_RULES_TYPE
        INTEGER :: DESID_MAX_RULES
        TYPE( DESID_RULES_TYPE ), ALLOCATABLE :: DESID_RULES_NML(:)

        ! Define Structure for Reading Area Normalization Namelist
        ! input
        TYPE DESID_AREA_TYPE
            CHARACTER( 32 ) :: STREAM
            CHARACTER( 32 ) :: AREA
            CHARACTER( 32 ) :: ADJ
        END TYPE DESID_AREA_TYPE
        TYPE( DESID_AREA_TYPE ), ALLOCATABLE :: DESID_AREA_NML(:)

        ! Define Structure for Reading Ragion Mask Input
        TYPE DESID_REG_NML_TYPE
            CHARACTER( 32 ) :: LABEL
            CHARACTER( 32 ) :: FILE
            CHARACTER( 32 ) :: VAR
        END TYPE DESID_REG_NML_TYPE
        TYPE( DESID_REG_NML_TYPE ), ALLOCATABLE :: DESID_REG_NML(:)
        INTEGER                                 :: DESID_MAX_REG

        ! Define Structure for Storing Region Masks
        TYPE DESID_REG_TYPE
            CHARACTER( 32 ) :: LABEL
            CHARACTER( 32 ) :: FILE
            CHARACTER( 32 ) :: VAR
            INTEGER         :: FILENUM
        END TYPE DESID_REG_TYPE

        TYPE( DESID_REG_TYPE ), ALLOCATABLE :: DESID_REG( : )
        REAL, ALLOCATABLE           :: DESID_REG_FAC( :,:,: )
        LOGICAL, ALLOCATABLE        :: DESID_REG_SUB( :,: )

        ! Define Structure for Reading Size Distribution Namelist
        ! Input
        TYPE DESID_SD_TYPE
            CHARACTER( 32 ) :: STREAM
            CHARACTER( 16 ) :: MODE
            CHARACTER( 16 ) :: MODE_REF
        END TYPE DESID_SD_TYPE
        TYPE( DESID_SD_TYPE ), ALLOCATABLE :: DESID_SD_NML(:)

        ! Define Variables for Storing Emissions Diagnostic
        ! Parameters
        Integer                      :: Desid_Max_Diag_Streams = 20
        Integer                      :: Desid_Max_Diag_Spec = 80
        Character( 32 ), Allocatable :: Desid_Diag_Streams_Nml(:,:)
        Character( 6  ), Allocatable :: Desid_Diag_Fmt_Nml(:)       
        Character( 16 ), Allocatable :: Desid_Diag_Spec_Nml(:,:) 

      end module desid_param_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      INTEGER FUNCTION INDEXN ( NAME1, N, NAME2, INDICES )

C***********************************************************************
C
C  FUNCTION:
C
C    This routine searches for all occurrences of NAME1 in list NAME2
C
C  REVISION HISTORY:
C
C    5/88   Modified for ROMNET
C
C  ARGUMENT LIST DESCRIPTION:
C
C    Input arguments:
C
C      NAME1       Character string being searched for
C      N           Length of array to be searched
C      NAME2       Character array to be searched
C      INDICES     Index array of all occurrences
C
C    Output arguments:
C
C      INDEXN      The number of occurrences of NAME1 within the NAME2
C                  array.  If string was not found, INDEXN = 0
C
C  LOCAL VARIABLE DESCRIPTION:
C
C      None
C
C***********************************************************************

      IMPLICIT NONE

      INTEGER     N
      INTEGER     I
      INTEGER     INDICES(*)

      CHARACTER*(*) NAME1
      CHARACTER*(*) NAME2(*)

C...Assume NAME1 is not in list NAME2    

      INDEXN = 0

      DO I = 1, N

        IF ( INDEX( NAME2( I ), NAME1 ) .GT. 0 ) THEN
          INDEXN = INDEXN + 1
          INDICES( INDEXN ) = I
        END IF

      END DO

      RETURN
      END              

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine wrsubdmap ( nprocs, ncols_pe, nrows_pe, colsx_pe, rowsx_pe )

      implicit none

!> layout parallel decomp subdomains given processor decomp and grid dimensions

      integer, intent( in ) :: nprocs   ! npcol*nprow
      integer, intent( in ) :: ncols_pe( nprocs ) ! No. of 1st dimension elements per PE
      integer, intent( in ) :: nrows_pe( nprocs ) ! No. of 2nd dimension elements per PE
      integer, intent( in ) :: colsx_pe( 2,nprocs ) ! 1st dimension index range per PE
      integer, intent( in ) :: rowsx_pe( 2,nprocs ) ! 2nd dimension index range per PE

      character( 49 ) :: colrow = '  PE    #Cols    Col_Range     #Rows    Row_Range'
      character( 49 ) :: title

      integer i               ! loop counter.

      title = colrow

      write( *,* )
      write( *,* ) '         -=-  MPP Processor-to-Subdomain Map  -=-'
      write( *,'(A,I3)' ) '                 Number of Processors = ',nprocs
      write( *,* ) '   ____________________________________________________'
      write( *,* ) '   |                                                  |'
      write( *,* ) '   |' // title // ' |'
      write( *,* ) '   |__________________________________________________|'
      write( *,* ) '   |                                                  |'
      do i = 1, nprocs
         write( *,1003 ) i-1, ncols_pe(i), colsx_pe(1,i), colsx_pe(2,i),
     &                        nrows_pe(i), rowsx_pe(1,i), rowsx_pe(2,i)
      end do
      write( *,* ) '   |__________________________________________________|'
      write( *,* )

1003  format('    |', i3, 5x, i4, 3x, i4, ':', i4,
     &                    7x, i4, 3x, i4, ':', i4, '   |')

      end subroutine wrsubdmap

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/par/mpi/mpcomm_init.F,v 1.4 2011/10/21 16:11:25 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE MPCOMM_INIT( NPROCS, MYPE, CLOCK, IERR )
C.......................................................................
C
C Purpose:   Initialization for parallel execution of CMAQ
 
C Revision History: 
C      Original version  5/09 Jeff Young - modified from par_init
C      Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with UTILIO_DEFN
C      Modified 08/10/2011 by David Wong
C          -- Called MPI_INIT if it is a regular CMAQ run
C      Modified 08/2011 by David Wong
C          -- Replaced SUBST_MPI with mpif.h
 
C Argument List Description:
C  In:
C     INTEGER NLAYS             ! Number of layers in entire grid
C     INTEGER NSPCS             ! Number of species in CGRID
 
C  Out:
C     REAL    CLOCK             ! Wall-clock time (sec) at MPI initialization
C     INTEGER IERR              ! Error code: 0 for ok, 1 for fail
 
C Local Variable Description:
 
C  Other Local Variable Descriptions:  see below

C Calls: M3WARN, MPI_INIT, MPI_COMM_RANK, MPI_COMM_SIZE, MPI_WTIME
 
C........................................................................

      USE UTILIO_DEFN

      IMPLICIT  NONE

C Include Files

!     INCLUDE SUBST_MPI         ! MPI definitions and parameters
      include 'mpif.h'

C Arguments

      INTEGER, INTENT( OUT ) :: NPROCS  ! number of parallel processors
      INTEGER, INTENT( OUT ) :: MYPE    ! this parallel processor
      REAL(8), INTENT( OUT ) :: CLOCK   ! Wall-clock time (sec) at MPI initialization
      INTEGER, INTENT( OUT ) :: IERR    ! error code

C Local Variables 

      INTEGER FLAG

      CHARACTER( 80 ) :: XMSG     ! Message issued from M3WARN routine
      CHARACTER( 16 ) :: PNAME = 'MPCOMM_INIT'

C------------------------------------------------------------------------

      IERR = 0

C Start up MPI
#if !defined(twoway) && !defined(mpas)
      CALL MPI_INIT( FLAG )
      IF ( FLAG .NE. 0 ) THEN
         WRITE( XMSG,'(I6, A)' ) FLAG, 'Error in MPI_INIT.'
         CALL M3WARN ( PNAME, 0, 0, XMSG )
         IERR = 1; RETURN
      END IF
#endif

C Get wall-clock time
      CLOCK = MPI_WTIME()

C Get number of processors
      CALL MPI_COMM_SIZE( MPI_COMM_WORLD, NPROCS, FLAG )
      IF ( FLAG .NE. 0 ) THEN
         WRITE( XMSG,'(I6, A)' ) FLAG, 'Error in MPI_COMM_SIZE.'
         CALL M3WARN ( PNAME, 0, 0, XMSG )
         IERR = 1; RETURN
      END IF

C Get my processor rank (i.e., get ID of this processor)
      CALL MPI_COMM_RANK( MPI_COMM_WORLD, MYPE, FLAG )
      IF ( FLAG .NE. 0 ) THEN
         WRITE( XMSG,'(I6, A)' ) FLAG, 'Error in MPI_COMM_RANK.'
         CALL M3WARN ( PNAME, 0, 0, XMSG )
         IERR = 1; RETURN
      END IF

#ifdef cluster
C Distribute run time environment variables to other machines - by bo wang
      CALL distr_env ( MYPE, NPROCS )
#endif

      RETURN
      END

       module wrf_fast_mie
       
       integer, parameter :: lunerr = -1

       REAL( 8 ), PUBLIC :: CPU_TIME_DELTA1 = 0.0D0 ! Timing individual
       REAL( 8 ), PUBLIC :: CPU_TIME_DELTA2 = 0.0D0 ! Timing individual
       REAL( 8 ), PUBLIC :: CPU_TIME_DELTA3 = 0.0D0 ! Timing individual
       
       public fast_mieaer_modal, aero_optics_tabular
       
!      integer, private :: logdev

       real(8),parameter,private :: pii = 3.14159265358979323846264338327950288419716939937510582097494D0
       real,   parameter,private :: pi  = 3.14159265
       real,   parameter,private :: sqrtpi = pi**(0.5) 
       real,   parameter,private :: sqrtpi1 = 1.0 / sqrtpi
       real,   parameter,private :: sqrt2   = 2.0**(0.5)
       real,   parameter,private :: three_pi_two = 3.0 * pi / 2.0 

      Logical, Parameter, Private :: Use_Odd_Quadrature = .True.
       Integer, Parameter, Private :: Quadrature_Points = 3
!      Integer, Parameter, Private :: Quadrature_Points = 1
      
!B.Hutzell One point quadature IGH = 1

       real, parameter, Private :: ghxi_1(1) = 0.00000000000
       real, parameter, Private :: ghwi_1(1) = 1.77245385091
       
!B.Hutzell Three point quadature IGH = 3
       real, parameter, Private :: ghxi_3(3) = (/ -1.22474487139, 
     &                                     0.00000000000,   
     &                                     1.22474487139 /)

       real, parameter, Private :: ghwi_3(3) = (/ 0.295408975151,  
     &                                    1.181635900000,  
     &                                    0.295408975151 /)
                                         
!B.Hutzell Five point quadature IGH = 5
       real(8), parameter, Private :: ghxi_5(5) = (/ -2.02018287046d0,  
     &                                       -0.958572464614d0, 
     &                                        0.00000000000d0,  
     &                                        0.958572464614d0, 
     &                                        2.02018287046d0 /)

       real(8), parameter, Private :: ghwi_5(5) = (/ 0.019953242059d0,   
     &                                       0.393619323152d0,  
     &                                       0.945308720483d0,   
     &                                       0.393619323152d0,   
     &                                       0.019953242059d0 /)

                                         

!B.Hutzell Nine point quadature IGH = 9 points
!No.  Abscissas  Weight  Total Weight  
       real, parameter, Private :: ghxi_9(9) = (/ -3.19099320178,   
     &                                    -2.26658058453,   
     &                                    -1.46855328922,   
     &                                    -0.72355101875,  
     &                                     0.00000000000,   
     &                                     0.72355101875,  
     &                                     1.46855328922,   
     &                                     2.26658058453,    
     &                                     3.19099320178 /)  

       real, parameter, Private :: ghwi_9(9) = (/ 3.96069772633E-5, 
     &                                    0.00494362428,    
     &                                    0.08847452739,    
     &                                    0.43265155900,    
     &                                    0.72023521561,    
     &                                    0.43265155900,    
     &                                    0.08847452739,    
     &                                    0.004943624275,   
     &                                    3.96069772633E-5 /)

         Type :: Optics_Tables
            integer :: nradii
            real :: rmin
            real :: rmax
            real :: bma
            real :: bpa
            real :: xrmin
            real :: xrmax
            real :: xr
            real, allocatable ::  extp( :,:,:,: )       ! specific extinction
            real, allocatable ::  albp( :,:,:,: )       ! single scat alb
            real, allocatable ::  asmp( :,:,:,: )       ! asymmetry factor
            real, allocatable ::  ascat( :,:,:,: )      ! scattering efficiency, JCB 2004/02/09
            real, allocatable ::  pmom2( :,:,:,: )      ! phase function expansion, #2
            real, allocatable ::  pmom3( :,:,:,: )      ! phase function expansion, #3
            real, allocatable ::  pmom4( :,:,:,: )      ! phase function expansion, #4
            real, allocatable ::  pmom5( :,:,:,: )      ! phase function expansion, #5
            real, allocatable ::  pmom6( :,:,:,: )      ! phase function expansion, #6
            real, allocatable ::  pmom7( :,:,:,: )      ! phase function expansion, #7
            real, allocatable ::  sback2p( :,:,:,: )    ! backscatter
         end Type
         
       
         Type :: Optics_Tables_MP
            integer :: nradii
            real :: rmin
            real :: rmax
            real :: bma
            real :: bpa
            real :: xrmin
            real :: xrmax
            real :: xr
            real, allocatable ::  extp( :,:,: )       ! specific extinction
            real, allocatable ::  albp( :,:,: )       ! single scat alb
            real, allocatable ::  asmp( :,:,: )       ! asymmetry factor
            real, allocatable ::  ascat( :,:,: )      ! scattering efficiency, JCB 2004/02/09
!            real, allocatable ::  pmom2( :,:,: )      ! phase function expansion, #2
!            real, allocatable ::  pmom3( :,:,: )      ! phase function expansion, #3
!            real, allocatable ::  pmom4( :,:,: )      ! phase function expansion, #4
!            real, allocatable ::  pmom5( :,:,: )      ! phase function expansion, #5
!            real, allocatable ::  pmom6( :,:,: )      ! phase function expansion, #6
!            real, allocatable ::  pmom7( :,:,: )      ! phase function expansion, #7
            real, allocatable ::  sback2p( :,:,: )    ! backscatter
         end Type

         Type(Optics_Tables_MP), Allocatable, Private :: Modal_Tables( : )
         Type(Optics_Tables_MP), Allocatable, Private :: Modal_Tables_Check( : )

         integer, parameter, private :: prefr=22,prefi=33
         integer, parameter, private :: nsiz=200,nlog=30

         integer, private :: nbin_a_maxd ! Max # of aerosol bins or modes
         integer, private :: nspint      ! Num of spectral intervals across
         integer, private :: ncoef=40    ! number of chebychev polynomials used
         integer, private :: nrefr,nrefi ! number of step between max/min of real and imaginary refractive indices 

!         integer, parameter :: nsizes(n_mode) = (/ 200,200,200 /)
         integer, allocatable, private :: nsizes( : ) 
         
         real, private :: sback_bhmie ! aerosol backscattering coefficient
         real, private :: refrmin     ! minimum of real part of refractive index
         real, private :: refrmax     ! maximum of real part of refractive index
         real, private :: refimin     ! minimum of imag part of refractive index
         real, private :: refimax     ! maximum of imag part of refractive index
         real, private :: drefr       ! increment in real part of refractive index
         real, private :: drefi       ! increment in imag part of refractive index


         real, private :: reciprocal_drefr  ! reciprocal of increment in real part of refractive index
         real, private :: reciprocal_drefi  ! reciprocal of increment in  imag part of refractive index
         real, private :: reciprocal_drefri ! reciprocal of real times imag increments of refractive index

         real, allocatable, private :: wavmid( : ) ! wavelenghts, cm
         real, allocatable, private :: refrtab(:) ! table of real refractive indices for aerosols
         real, allocatable, private :: refitab(:) ! table of imag refractive indices for aerosols

  
  

          logical :: BHMIE_SUCCESS      = .True.
          Logical :: Create_Table       = .false.
          Logical :: eflag_wrf_fast_mie = .false.
         
       contains

! ------------------------------------------------------------------
       subroutine aero_optics_tabular( mode,iwave, crefin, Vol, dgn, 
     &                                  sig, bext, bscat, gfac)

! FSB NOTE: this subroutine calculates for single mode     
     
! *** calculate the extinction and scattering coefficients and
!     assymetry factors for each wavelength as a sum over the 
!     individual lognormal modes. Each mode may have a different 
!     set of refractive indices.

      USE CSQY_DATA,  ONLY : NWL => NWL_REF, WAVELENGTH => EFFWL_REF
         
      IMPLICIT NONE

! *** input variables
      integer, intent(in)    :: mode       ! aerosol mode index
      integer, intent(in)    :: iwave      ! index in wavelength array
      complex, intent(in)    :: crefin     ! Complex refractive index 
      real,    intent(in)    :: Vol        ! modal aerosol volumes [m**3 /m**3]
      real,    intent(in)    :: dgn        ! modal geometric mean diameter [m]
      real,    intent(in)    :: sig        ! geometric standard deviation 
      
! *** output variables 
      real, intent(out)    :: bext         ! extinction coefficient [ 1 / m ]
      real, intent(out)    :: bscat        ! scattering coefficient [ 1 / m ]
      real, intent(out)    :: gfac         ! assymetry factor for Mie and molecular scattering

      
       character( 32 ), parameter :: pname = 'aero_optics_tabular'
       
! FSB define parameters 
       real, parameter :: integral_factor = three_pi_two * sqrtpi1 


! *** internal variables
      real :: beta_Sc       ! aerosol scattering coefficient  
      real :: beta_Ex       ! aerosol extinction coefficients       
      real :: G             ! modal aerosol assymetry factors
      real :: sum_g
      real :: LSIGX
      real :: lambdam1       ! 1/ lambda (m)
      real :: dgv            ! geometric mean of volume distribution (m)
      real :: mie_volume_parameter ! Mie size parameter for volume distribution
      real :: vfac
      real :: bscoef         ! backscatter efficiency

       real    :: dgv_p, dgv_m             ! diameters at quadature points
       real    :: mie_par_top, mie_par_bot ! mie parameter at quadature points
     
! variable for integration over volume distribution     
       real    :: nr
       real    :: aa1
       real    :: xlnsig
       real    :: sum_e,sum_s, xi,wxi,xf
       real    :: sum_sg
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e ! extinction  
       real    :: qalfip_s, qalfim_s ! scattering
       real    :: gsalfp, gsalfm     ! scattering times asymmetry factor

      integer :: i
      real,    allocatable,  save  :: GHXI(:), GHWI(:) ! weight and abscissas
      integer, save  :: IGH                            ! number of weights and abscissa
      integer, save  :: NMAX                           ! optimumized number of weights and abscissa

       Logical, Save :: Initialize = .True.
      
       If( Initialize )Then
          Select Case( Quadrature_Points )
            Case( 1,3,5,9 )
              IGH = Quadrature_Points
            Case Default
              IGH = 3
          End Select

          NMAX = Max( Int( IGH / 2 ), 0)
          
          Allocate( GHXI( NMAX + 1 ), GHWI( NMAX + 1 ) )
 
          Select Case ( IGH ) 
            Case ( 1 )
              GHXI(1)  = ghxi_1(1)
              GHWI(1)  = ghwi_1(1)
            Case ( 3 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_3(i)
                GHWI(i) = ghwi_3(i)
              end do 
            Case ( 5 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_5(i)
                GHWI(i) = ghwi_5(i)
              end do 
            Case ( 9 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_9(i)
                GHWI(i) = ghwi_9(i)
              end do 
          end select 
       
          Initialize = .False.
          
       End If

! Algorithm based on 04/15/2012 codes       
!     by Dr. Francis S. Binkowski
!     Center for Environmental Modeling for Policy Development
!     Institute for the Environment
!     University of North Carolina at Chapel Hill
!     email: frank_binkowski@unc.edu

! *** initialize variables
       lambdam1 = 1.0e9 / wavelength(iwave)  ! lambdam1 in [ m^(-1) ]
       bext  = 0.0
       bscat = 0.0
       sum_g = 0.0

       LSIGX = log(sig)
       
!     calculate Mie size parameter for volume distribution
!     exp(3.0 * xlnsig*xlnsig)  converts dgn to dgv (volume diameter)
       dgv =  dgn * exp(3.0 * LSIGX * LSIGX)      
       mie_volume_parameter =  pi * dgv * lambdam1

       nr = real(crefin)      

      
! Integration code over modal volume distribution
       aa1 = sqrt2 * lsigx
! This 1.0 / Sqrt( A ) in derivation of the integral where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! For wet_diameter in fast_mieaer call
! Need wet_diameter corresponding xi or Gauss-Hermite Quadrature point
! dgv * exp[ u / sqrt(A) ] where u = xi Gauss-Hermite Quadrature
! Therefore, xf = exp( xi / sqrt(A) ) or xf = exp( xi * aa1 ) 

       bext    = 1.0e-30  ! [ 1 / m ]
       bscat   = 1.0e-30    ! [ 1 / m ]
       gfac    = 0.0
!       return

!start integration at zero point
       xi      = 0.0
       wxi     = GHWI(NMAX+1)
       xf      = 1.0

       
! fetch the effficiencies at zero point
        call fast_mieaer_modal( mie_volume_parameter,crefin,qalfip_e,qalfip_s,gsalfp,bscoef )
       
       sum_e  = wxi * qalfip_e
       sum_s  = wxi * qalfip_s
       sum_sg = wxi * gsalfp

! FSB do NMAX calls to the MIE codes      
       do i = 1, NMAX
          xi      = GHXI(i)
          wxi     = GHWI(i)
          xf      = exp( xi * aa1 )
          dgv_p   = dgv * xf
          dgv_m   = dgv / xf ! division cheaper than another exp()
          mie_par_top = mie_volume_parameter * xf
          mie_par_bot = mie_volume_parameter / xf
! *** call subroutine to fetch the effficiencies


          call fast_mieaer_modal( mie_par_top,crefin,qalfip_e,qalfip_s,gsalfp,bscoef )
          call fast_mieaer_modal( mie_par_bot,crefin,qalfim_e,qalfim_s,gsalfm,bscoef )

          sum_e  = sum_e + wxi  * ( qalfip_e + qalfim_e ) 
          sum_s  = sum_s + wxi  * ( qalfip_s + qalfim_s ) 
          sum_sg = sum_sg + wxi * ( gsalfp + gsalfm ) 

       end do
       

       G        = sum_sg / sum_s ! this is <cos>
       beta_Ex  = integral_factor * sum_e  ! 
       beta_Sc  = integral_factor * sum_s  
       

! *** bhmie driver returns values divided by mie_vol_parameter
!     Calculate the actual extinction and scattering coefficients 
!     by multplying by the modal volume and dividing by the wavelength
                  
       vfac  =  Vol * lambdam1         
       bext    = vfac * beta_Ex  ! [ 1 / m ]
       bscat   = vfac * beta_Sc  ! [ 1 / m ]
       gfac    = G
       
99501  Format(I2,' Quadrature Points for Volume Averaged Aerosol Optics')
99504  Format('Even Number Quadrature Points for Volume Averaged Aerosol Optics')
       
       END SUBROUTINE aero_optics_tabular

        subroutine fast_mieaer_modal( mie_parameter,refindx,extaer,scataer,gaer,bscoef )

!!!!!    USE UTILIO_DEFN
         USE AERO_DATA           ! aero variable data
         USE CSQY_DATA,  ONLY : NWL => NWL_REF, NUM_REFRACTIVE, REFRACTIVE_INDEX,
     &                          WAVELENGTH => EFFWL_REF, FIRST_DAY => NEW_START

         use get_env_module
        
        IMPLICIT NONE
!***********************************************************************
! Purpose:  calculate aerosol scattering albedo, asymmetry factor, and 
!   extinction efficencies. If Two_Stream is true, sets Legendre coefficients. 
!   The method parameterizes aerosol coefficients using chebychev polynomials
!   requires double precision on 32-bit machines uses Wiscombe's (1979) mie
!   scattering code or Bohren-Huffman (1983) Mie scattering
!   subroutine, bhmie, to calculates efficiencies by a homogenous
!   isotropic sphere. The latter subroutine is used if RadTran solution is a
!   Two Stream Method.
!
! INPUT
!       mie_parameter -- 2*pi*wet diameter/wavelength
!       refindx      -- volume averaged complex index of refraction
! OUTPUT:
!   real sactaer ! aerosol single scattering efficiency
!        gaer    ! aerosol asymmetery factor
!        extaer  ! aerosol extinction efficiency, 
!        bscoef  ! aerosol backscatter efficiency, to convert steradian divide by 4*PI
!----------------------------------------------------------------------

! arguments:
        real,    intent(in)                   :: mie_parameter
        complex, intent(in)                   :: refindx

        real, intent(out) :: extaer,scataer,gaer
        real, intent(out) :: bscoef

!local variables
         character( 32 ), parameter :: pname = 'fast_mieaer_modal'
         

         real weighte, weights
! various bookeeping variables         
         integer, parameter :: ltype = 1  ! total number of indicies of refraction

         real x
         real thesum ! for normalizing things
         real sizem ! size in microns
         integer kcallmieaer
!
         integer m, j, nc, klevel
         real, save :: pscat !scattering cross section
         real, save :: pext  ! parameterized specific extinction (cm2/g)
         real, save :: pasm  ! parameterized asymmetry factor
         real, save :: pd_pscat !scattering cross section
         real, save :: pd_pext  ! parameterized specific extinction (cm2/g)
         real, save :: pd_pasm  ! parameterized asymmetry factor


         real ppmom2     ! 2 Lengendre expansion coefficient (numbered 0,1,2,...)
         real ppmom3     ! 3     ...
         real ppmom4     ! 4     ...
         real ppmom5     ! 5     ...
         real ppmom6     ! 6     ...
         real ppmom7     ! 7     ...
         real sback2     ! JCB 2007/02/01 sback*conjg(sback)
         
         integer ns            ! Spectral loop index
         integer i             ! Longitude loop index
         integer k       ! Level loop index
         
         integer, save :: isecfrm0 = 0

 


         integer            :: ncoef_check   ! number of chebychev polynomials used
         integer, save      :: numang=0,nmom=7,ipolzn=0,momdim=7
         integer            :: nrefr_check,nrefi_check

         integer            :: nsize
         integer            :: nr,ni
         
!        
         real(8)       :: pmom(0:7,1)
         real(8), save :: xmu(1) = 1.0d0
         real(8), save :: mimcut = 0.0d0
         
         complex(8) :: sforw,sback,tforw(2),tback(2)
         complex(8) :: s1(1),s2(1)

         logical, save :: perfct  = .false.
         logical, save :: anyang  = .false.
         logical, save :: prnt(2) = (/ .false., .false./)
         logical, save :: first   = .true.
         logical, save :: TWO_STREAM = .true.
         logical       :: search
         logical       :: exists
         
         real ::  aero_radius

         integer itab,jtab
         integer itabp,jtabp
         
         real ttab,utab
         
!        nsiz = number of wet particle sizes
!        crefin = complex refractive index
         integer n
         real(8), allocatable :: qext( : )   ! array of extinction efficiencies
         real(8), allocatable :: qsca( : )   ! array of scattering efficiencies
         real(8), allocatable :: gqsc( : )   ! array of asymmetry factor * scattering efficiency
         real, allocatable    :: asymm( : )  ! array of asymmetry factor
         real, allocatable    :: scat( : )   ! JCB 2004/02/09
         real, allocatable    :: sb2( : )    ! JCB 2007/02/01 - 4*abs(sback)^2/(size parameter)^2 backscattering efficiency
         real, allocatable    :: qextr4( : ) !  extinction, real*4
         real, allocatable    :: rs( : )     ! surface mode radius (cm)

         real, allocatable, save :: cext     (:)
         real, allocatable, save :: casm     (:)
         real, allocatable, save :: cpmom2   (:)
         real, allocatable, save :: cscat    (:)                      
         real, allocatable, save :: cpsback2p(:)                      

         real(8) :: thesize        ! 2 pi radpart / waveleng = size parameter

         complex(8)       :: crefin,crefd
         complex(8), save :: crefw
         real, save :: rmin=0.005e-4,rmax=50.e-4   ! min, max aerosol size bin

         
         real bma,bpa
         
         real, save :: xrmin,xrmax,xr
         real xrad      ! normalized aerosol radius
         
         real, save :: rhoh2o = 1.0     ! density of liquid water (g/cm3)
         
         real refr         ! real part of refractive index
         real refi         ! imaginary part of refractive index
         
         real thesize_bhmie    ! 2 pi radpart / waveleng = size parameter
         real qext_bhmie       ! array of extinction efficiencies
         real qsca_bhmie       ! array of scattering efficiencies
         real qback_bhmie      ! array of scattering efficiencies
         real gsca_bhmie       ! array of asymmetry factor * scattering efficiency
         complex refrel_bhmie

         real :: weight_real   ! nomralized real part refractive index difference used in bilinear interpolation 
         real :: weight_imag   ! nomralized imaginary part refractive index difference used in bilinear interpolation
         real :: wrwi          ! weighting factors used on bilinear interpolation points
         real :: wr_wrwi       ! weighting factors used on bilinear interpolation points
         real :: wi_wrwi       ! weighting factors used on bilinear interpolation points
         real :: one_wrwi_wi   ! weighting factors used on bilinear interpolation points

         real :: quadrature_factor
         real :: max_quad_point

         real :: reciprocal_drefr_check  ! reciprocal of increment in real part of refractive index
         real :: reciprocal_drefi_check  ! reciprocal of increment in  imag part of refractive index
         real :: reciprocal_drefri_check ! reciprocal of real times imag increments of refractive index
         real :: refrmin_check ! minimum of real part of refractive index
         real :: refrmax_check ! maximum of real part of refractive index
         real :: refimin_check ! minimum of imag part of refractive index
         real :: refimax_check ! maximum of imag part of refractive index
         real :: drefr_check   ! increment in real part of refractive index
         real :: drefi_check   ! increment in imag part of refractive index

         real, allocatable :: refrtab_check(:) ! table of real refractive indices for aerosols
         real, allocatable :: refitab_check(:) ! table of imag refractive indices for aerosols
         real, allocatable, save :: ch(:)      ! values of chebychev polynomials

         real, parameter :: pie   = pi
         real, parameter :: third = 1.0/3.0
         
         integer :: irams, jrams
! diagnostic declarations
         integer :: kcallmieaer2
         integer :: ibin, imode
         integer :: mie_unit
         integer :: astat
         character(150) :: msg
         CHARACTER(600) :: MIE_TABLE


       if(first)then
          
          first = .false.
          
!       parameterize aerosol radiative properties in terms of
!       relative humidity, surface mode wet radius, aerosol species,
!       and wavelength
!       first find min,max of real and imaginary parts of refractive index
         crefw=cmplx(1.33,0.0)
         refrmin=real(crefw)
         refrmax=real(crefw)

! change Rahul's imaginary part of the refractive index from positive to negative
         refimin=-imag(crefw)
         refimax=-imag(crefw)
         nspint = nwl
         allocate( wavmid( nwl ) )
         wavmid(1:nwl) =  1.0e-7*wavelength(1:nwl)                         

         allocate( nsizes( n_mode ) )
         
         nsizes = (/ 200,200,200 /)
         
         allocate( Modal_Tables( N_MODE ) )
         
         Select Case ( Quadrature_Points ) 
         Case ( 1 )
             max_quad_point = ghxi_1(1)
         Case ( 3 )
             max_quad_point = ghxi_3(3)
         Case ( 5 )
             max_quad_point = ghxi_5(5)
         Case ( 9 )
             max_quad_point = ghxi_9(9)
         end select 

         nbin_a_maxd = n_mode
         
         call get_env( mie_table, 'MIE_TABLE', 'MIE_TABLE',logdev )
         inquire( file=trim(mie_table),exist=exists)
         if( .not. exists )then
             Create_Table = .true.
         else
             Create_Table = .false.
         endif

         if( Create_Table )then

            Create_table = .false.
               
            
            do i=1,NUM_REFRACTIVE
               refrmin = amin1( refrmin,MINVAL( REFRACTIVE_INDEX( i )%REAL_PART( :,: ) ))
               refrmax = amax1( refrmax,MAXVAL( REFRACTIVE_INDEX( i )%REAL_PART( :,: ) ))
               refimin = amin1( refimin,-MINVAL( REFRACTIVE_INDEX( i )%IMAG_PART( :,: ) ))  
               refimax = amax1( refimax,-MAXVAL( REFRACTIVE_INDEX( i )%IMAG_PART( :,: ) ))
            enddo
            
             rmax = amax1(rmax,60.0*MAXVAL(max_dg_wet))
             rmin = amin1(rmin,40.0*MINVAL(min_dg_dry))
             drefr=(refrmax-refrmin)
             if(drefr.gt.1.e-4)then
                nrefr=prefr
                drefr=drefr/(nrefr-1)
             else
                nrefr=1
             endif
           
             drefi=(refimax-refimin)
             if(drefi.gt.1.e-4)then
                nrefi=prefi
                drefi=drefi/(nrefi-1)
             else
                nrefi=1
             endif
           
           
             reciprocal_drefr  = 1.0/drefr
             reciprocal_drefi  = 1.0/drefi
             reciprocal_drefri = reciprocal_drefr * reciprocal_drefi
           
!          
             
             bma=0.5*alog(rmax/rmin) ! JCB
             bpa=0.5*alog(rmax*rmin) ! JCB
             xrmin=alog(rmin)
             xrmax=alog(rmax)
           
             quadrature_factor = exp( sqrt2 * log( max_sigma_g ) * max_quad_point )
             
             do ns = 1,n_mode
                Modal_Tables(ns)%nradii = nsizes(ns)
                Modal_Tables(ns)%rmax = 60.0*max_dg_wet(ns)*quadrature_factor
!                if( ns .eq. n_mode )Modal_Tables(ns)%rmax = 4.0*Modal_Tables(ns)%rmax
! convert modal rmax into Mie Parameter            
                Modal_Tables(ns)%rmax = 2.0*pi*Modal_Tables(ns)%rmax/minval( wavmid )
                Modal_Tables(ns)%rmin = 40.0*min_dg_dry(ns)/quadrature_factor
! convert modal rmin into Mie Parameter            
                Modal_Tables(ns)%rmin = 2.0*pi*Modal_Tables(ns)%rmin/maxval( wavmid )
                Modal_Tables(ns)%bma=0.5*log(Modal_Tables(ns)%rmax/Modal_Tables(ns)%rmin)
                Modal_Tables(ns)%bpa=0.5*log(Modal_Tables(ns)%rmax*Modal_Tables(ns)%rmin)
                Modal_Tables(ns)%xrmin=log(Modal_Tables(ns)%rmin)
                Modal_Tables(ns)%xrmax=log(Modal_Tables(ns)%rmax)
                allocate( Modal_Tables(ns)%extp(ncoef,prefr,prefi),      
     &                    Modal_Tables(ns)%albp(ncoef,prefr,prefi),   
     &                    Modal_Tables(ns)%asmp(ncoef,prefr,prefi),   
     &                    Modal_Tables(ns)%ascat(ncoef,prefr,prefi),  
     &                    Modal_Tables(ns)%sback2p(ncoef,prefr,prefi) )
             end do

! check if coverage of mie parameter is continuous between Modal_Tables 
             do ns = 2,n_mode
             
                if( Modal_Tables(ns-1)%rmax .ne. Modal_Tables(ns)%rmin )then
                    Modal_Tables(ns-1)%rmax  = Modal_Tables(ns)%rmin
                    Modal_Tables(ns-1)%xrmax = log(Modal_Tables(ns-1)%rmax)
                    Modal_Tables(ns-1)%bma=0.5*log(Modal_Tables(ns-1)%rmax/Modal_Tables(ns-1)%rmin)
                    Modal_Tables(ns-1)%bpa=0.5*log(Modal_Tables(ns-1)%rmax*Modal_Tables(ns-1)%rmin)
                end if
            
             end do
            
             
             nsize = MAXVAL( Modal_Tables(1:n_mode)%nradii )
             
             allocate( qext( nsize ),
     &                 qsca( nsize ),
     &                 gqsc( nsize ) )
            
             allocate( asymm( nsize ),
     &                  scat( nsize ),
     &                   sb2( nsize ),
     &                qextr4( nsize ),
     &                    rs( nsize ) )          
            
          
!         calibrate parameterization with range of refractive indices 

            allocate( refrtab(nrefr),
     &                refitab(nrefi),
     &                ch(ncoef))
     
            do 120 ni=1,nrefi
              do 120 nr=1,nrefr                                        

               refrtab(nr)=refrmin+(nr-1)*drefr
               refitab(ni)=refimin+(ni-1)*drefi
               crefd=dcmplx(real(refrtab(nr),8),real(refitab(ni),8))
!              mie calculations of optical efficiencies
               loop_modes: do imode = 1,n_mode
                  nsize = Modal_Tables(imode)%nradii ! nsizes( imode )
                  do n=1,nsize
                  
                     xr=cos(pie*(real(n)-0.5)/real(nsize))
                     rs(n)=real(exp(xr*Modal_Tables(imode)%bma+Modal_Tables(imode)%bpa),8)
!                    size parameter and weighted refractive index
                     thesize=real(rs(n),8)
                  
! backscattering efficiency, Bohren and Huffman, page 122
! as stated by Bohren and Huffman, this is 4*pie times what is should be
! may need to be smoothed - a very rough function - for the time being we won't apply smoothing
! and let the integration over the size distribution be the smoothing
                            
                     thesize_bhmie = real( thesize )
                     refrel_bhmie  = cmplx(real(refrtab(nr)),-real(refitab(ni)))
                     call driver_bhmie_flexy(thesize_bhmie,refrel_bhmie,qext_bhmie,qsca_bhmie,gsca_bhmie) 
                     asymm(n) = gsca_bhmie/qsca_bhmie 
                     qextr4(n)= qext_bhmie*thesize_bhmie
                     scat(n)  = qsca_bhmie*thesize_bhmie 
                     sback    = sback_bhmie
                     sb2(n)   = 4.0*sback*dconjg(sback)
     &                         / (thesize_bhmie*thesize_bhmie) ! JCB 2007/02/01  
                         
                  
                  enddo
  100             continue

                  call fitcurv(rs,qextr4,Modal_Tables(imode)%extp(:,nr,ni),ncoef,nsize)
                  call fitcurv(rs,scat,Modal_Tables(imode)%ascat(:,nr,ni),ncoef,nsize) 
                  call fitcurv(rs,asymm,Modal_Tables(imode)%asmp(:,nr,ni),ncoef,nsize)
                  call fitcurv(rs,sb2,Modal_Tables(imode)%sback2p(:,nr,ni),ncoef,nsize)           
                                       
               enddo loop_modes

120         continue

            If( MYPE .eq. 0 )Then
            
                mie_unit = get_free_iounit()
                open(unit=mie_unit,file=trim(mie_table),form='FORMATTED',status='REPLACE',
     &               iostat=astat)
                if( astat .ne. 0 )then
                  msg = 'Error creating Mie Lookup Table, ' // trim(mie_table)
     &               // 'and new start is true.'  
                  eflag_wrf_fast_mie = .True.
                  return
                endif
                write(mie_unit,'(a)')'real and imaginary part of minimum refractive index '
                write(mie_unit,'(a)')'imaginary part uses negative sign convention so reverse sign common value'
                write(mie_unit,'(2(es12.4,1x))')refrtab(1),refitab(1)
                write(mie_unit,'(a)')'real and imaginary part of maximum refractive index'
                write(mie_unit,'(es12.4,1x,es12.4)')refrtab(nrefr),refitab(nrefi)
                write(mie_unit,'(a)')'number real and imaginary parts'
                write(mie_unit,'(i4,1x,i4)')nrefr,nrefi
                write(mie_unit,'(a)')'minimum mie parameter for each mode '
                write(mie_unit,'(3(es16.7,1x))')Modal_Tables(1:n_mode)%rmin
                write(mie_unit,'(a)')'maximum mie parameters for each mode' 
                write(mie_unit,'(3(es16.7,1x))'),Modal_Tables(1:n_mode)%rmax
                write(mie_unit,'(a)')'number coefficients for chebyshev polynomials for each fit= '
                write(mie_unit,'(i4)')ncoef
                do ni=1,nrefi
                   do nr=1,nrefr
                     write(mie_unit,'(a,es12.4,a2,es12.4,a5)')'! refractive index = ( ',refrtab(nr),', ',refitab(ni),' ) '
                     write(mie_unit,'(a)')'! ext, scat, asym, and backscat coefficients for chebyshev polynomials'
                     do nc = 1,ncoef
                        write(mie_unit,'(21(es16.7,1x))')
     &                  (Modal_Tables(imode)%extp(nc,nr,ni),
     &                   Modal_Tables(imode)%ascat(nc,nr,ni),
     &                   Modal_Tables(imode)%asmp(nc,nr,ni),
     &                   Modal_Tables(imode)%sback2p(nc,nr,ni),imode=1,n_mode)
                     end do
                   end do
                 end do 
                 close(mie_unit)
            End If

            deallocate( qext,
     &                  qsca,
     &                  gqsc  )
          
            deallocate( asymm, 
     &                   scat, 
     &                    sb2, 
     &                 qextr4, 
     &                     rs  ) 
     
           
        else ! read table from ascii file     

           inquire( file=trim(mie_table),exist=exists)
           if( .not. exists )then
              msg = 'Mie Lookup Table, ' // trim(mie_table)
     &            // ' not found and new start is false.' 
              eflag_wrf_fast_mie = .True.
              return
           end if
           mie_unit = get_free_iounit()
           open(unit=mie_unit,file=trim(mie_table),form='FORMATTED',status='OLD',
     &          iostat=astat)
           if( astat .ne. 0 )then
              msg = 'Error reading Mie Lookup Table, ' // trim(mie_table) 
              eflag_wrf_fast_mie = .True.
              return
           endif
           read(mie_unit,'(a)')msg
           read(mie_unit,'(a)')msg
           read(mie_unit,'(2(es12.4,1x))')refrmin,refimin
           read(mie_unit,'(a)')msg
           read(mie_unit,'(es12.4,1x,es12.4)')refrmax,refimax
           read(mie_unit,'(a)')msg
           read(mie_unit,'(i4,1x,i4)')nrefr,nrefi
           read(mie_unit,'(a)')msg
           read(mie_unit,'(3(es16.7,1x))')Modal_Tables(1:n_mode)%rmin
           read(mie_unit,'(a)')msg
           read(mie_unit,'(3(es16.7,1x))'),Modal_Tables(1:n_mode)%rmax
           read(mie_unit,'(a)')msg
           read(mie_unit,'(i4)')ncoef

            do ns = 1,n_mode
               Modal_Tables(ns)%nradii = nsizes(ns)
               Modal_Tables(ns)%bma=0.5*log(Modal_Tables(ns)%rmax/Modal_Tables(ns)%rmin)
               Modal_Tables(ns)%bpa=0.5*log(Modal_Tables(ns)%rmax*Modal_Tables(ns)%rmin)
               Modal_Tables(ns)%xrmin=log(Modal_Tables(ns)%rmin)
               Modal_Tables(ns)%xrmax=log(Modal_Tables(ns)%rmax)
               allocate( Modal_Tables(ns)%extp(ncoef,nrefr,nrefi),      
     &                   Modal_Tables(ns)%albp(ncoef,nrefr,nrefi),   
     &                   Modal_Tables(ns)%asmp(ncoef,nrefr,nrefi),   
     &                   Modal_Tables(ns)%ascat(ncoef,nrefr,nrefi),  
     &                   Modal_Tables(ns)%sback2p(ncoef,nrefr,nrefi) )
            end do


            drefr=(refrmax-refrmin)
            if(drefr.gt.1.e-4)then
               drefr=drefr/(nrefr-1)
            endif
            
            drefi=(refimax-refimin)
            if(drefi.gt.1.e-4)then
               drefi=drefi/(nrefi-1)
            endif
            
            reciprocal_drefr  = 1.0/drefr
            reciprocal_drefi  = 1.0/drefi
            reciprocal_drefri = reciprocal_drefr * reciprocal_drefi

            allocate( refrtab(nrefr),
     &                refitab(nrefi),
     &                ch(ncoef))

            do ni=1,nrefi
              do nr=1,nrefr
                refrtab(nr)=refrmin+(nr-1)*drefr
                refitab(ni)=refimin+(ni-1)*drefi
                read(mie_unit,'(a)')msg
                read(mie_unit,'(a)')msg
                do nc = 1,ncoef
                   read(mie_unit,'(21(es16.7,1x))')
     &             (Modal_Tables(imode)%extp(nc,nr,ni),
     &              Modal_Tables(imode)%ascat(nc,nr,ni),
     &              Modal_Tables(imode)%asmp(nc,nr,ni),
     &              Modal_Tables(imode)%sback2p(nc,nr,ni),imode=1,n_mode)
                end do
               end do
            end do 
            close(mie_unit)
           
        end if

        allocate( cext     (ncoef), 
     &            casm     (ncoef),
     &            cpmom2   (ncoef),
     &            cscat    (ncoef),
     &            cpsback2p(ncoef))
        
        return
                 
      endif ! end first call block
      
         aero_radius = mie_parameter 
         ns         = 1
         do m = 1,n_mode
            if( aero_radius .le. Modal_Tables(m)%rmax)exit
         end do
         m = min(m,n_mode)
         
               gaer=0.0
               extaer=0.0
               bscoef=0.0        ! JCB 2007/02/01 - backscattering coefficient
! loop over the bins
                  sizem=aero_radius ! radius in cm
! check against limits of mie parameter
                  if(aero_radius.le.Modal_Tables(m)%rmin)then
                    aero_radius=1.01*Modal_Tables(m)%rmin
                    write( msg, '(a, 1x, es11.4, a, 1x, es11.4 )' )       
     &              'In ' // Trim( pname ) // ':aerosol mie parameter set to ',
     &              aero_radius, ' from ', mie_parameter
                     write(logdev,'(a)')TRim( msg )
                  endif
!
                  if(aero_radius.ge.Modal_Tables(m)%rmax)then
                    aero_radius=0.99*Modal_Tables(m)%rmax
                    write( msg, '(a, 1x, es11.4, a, 1x, es11.4 )' )       
     &              'In ' // Trim( pname ) // ':aerosol mie parameter set to ',
     &              aero_radius, ' from ', mie_parameter
                     write(logdev,'(a)')Trim( msg )
                  endif


                  crefin=refindx
                  refr=real(crefin)
! change Rahul's imaginary part of the index of refraction from positive to negative
                  refi=-imag(crefin)

                  x=alog(aero_radius) ! radius in cm
                  xrad=x
! normalize size parameter
                  xrad=(2*xrad-Modal_Tables(m)%xrmax-Modal_Tables(m)%xrmin)
     &                /(Modal_Tables(m)%xrmax-Modal_Tables(m)%xrmin)
     
! retain this diagnostic code
                  if(abs(refr).gt.10.0.or.abs(refr).le.0.001)then
                      write( msg, '(a,1x, e14.5)' )  
     &               'FASTJ mie /refr/ outside range 1e-3 to 10 refr= ', refr
                      write(logdev,'(a)')Trim( msg )
                  endif
                  if(abs(refi).gt.10.0)then
                     write( msg, '(a,1x, e14.5)' )  
     &              'FASTJ mie /refi/ >10 refi', refi
                     write(logdev,'(a)')Trim( msg )
                  endif

! interpolate coefficients linear in refractive index
! first call calcs itab,jtab,ttab,utab
                  itab=0
                  search = .true.
                  
                  search = .false.
                  
                  itab = int( (refr-refrmin)*reciprocal_drefr ) + 1
                  itab = min( nrefr,max( itab,1 ) )
                  jtab = int( (refi-refimin)*reciprocal_drefi ) + 1
                  jtab = min( nrefi,max( jtab,1 ) )

                  if( itab .eq. 1 .or. itab .eq. nrefr )then
                      weight_real = 0.0                                      
                      itabp = itab                                      
                  else
                      weight_real = (refr-refrtab(itab))
     &                            *  reciprocal_drefr                 
                      itabp = itab + 1
                  end if
                  if( jtab .eq. 1 .or. jtab .eq. nrefi )then
                      weight_imag = 0.0
                      jtabp = jtab                                      
                  else
                      weight_imag = (refi-refitab(jtab))
     &                            *  reciprocal_drefi                
                      jtabp = jtab + 1
                  end if

                  wrwi    = weight_real*weight_imag
                  wr_wrwi = weight_real - wrwi
                  one_wrwi_wi = 1.0 - wr_wrwi - weight_imag
                  wi_wrwi     = weight_imag - wrwi
                  
 
                  do nc=1,ncoef
                  
                     cext(nc)  = one_wrwi_wi*Modal_Tables(m)%extp(nc,itab,jtab)
     &                         + wr_wrwi*Modal_Tables(m)%extp(nc,itabp,jtab)
     &                         +          wrwi*Modal_Tables(m)%extp(nc,itabp,jtabp)
     &                         + wi_wrwi*Modal_Tables(m)%extp(nc,itab,jtabp)                     
     
                     
                     cscat(nc) = one_wrwi_wi*Modal_Tables(m)%ascat(nc,itab,jtab)
     &                         + wr_wrwi*Modal_Tables(m)%ascat(nc,itabp,jtab)
     &                         +         wrwi*Modal_Tables(m)%ascat(nc,itabp,jtabp)
     &                         + wi_wrwi*Modal_Tables(m)%ascat(nc,itab,jtabp)                     
     
                     casm(nc)  = one_wrwi_wi*Modal_Tables(m)%asmp(nc,itab,jtab)
     &                         + wr_wrwi*Modal_Tables(m)%asmp(nc,itabp,jtab)
     &                         +       wrwi*Modal_Tables(m)%asmp(nc,itabp,jtabp)
     &                         + wi_wrwi*Modal_Tables(m)%asmp(nc,itab,jtabp)                     
                     
                     cpsback2p(nc)  = one_wrwi_wi*Modal_Tables(m)%sback2p(nc,itab,jtab)
     &                              +    wr_wrwi*Modal_Tables(m)%sback2p(nc,itabp,jtab)
     &                              +      wrwi*Modal_Tables(m)%sback2p(nc,itabp,jtabp)
     &                              +    wi_wrwi*Modal_Tables(m)%sback2p(nc,itab,jtabp)                     
                  enddo
                  
!                 chebyshev polynomials
                  ch(1)=1.
                  ch(2)=xrad
                  do nc=3,ncoef
                     ch(nc)=2.*xrad*ch(nc-1)-ch(nc-2)
                  enddo


!                 parameterized optical properties
                  pext=0.5*cext(1)
                  pscat=0.5*cscat(1)
                  pasm=0.5*casm(1)
                  sback2=0.5*cpsback2p(1) ! JCB 2007/02/01 - backscattering efficiency
                  do nc=2,ncoef
                      pext=pext+ch(nc)*cext(nc)
                      pscat=pscat+ch(nc)*cscat(nc)
                      pasm=pasm+ch(nc)*casm(nc)
                      sback2=sback2+ch(nc)*cpsback2p(nc)
                  enddo
                  pext=exp(pext)
                  pscat=exp(pscat)
                  pasm=exp(pasm)
                  sback2=max( exp(sback2),0.0 )


               thesize = mie_parameter
                  
               pext  = pext/thesize 
               pscat = pscat/thesize 
               pasm  = pasm * pscat
               extaer  = pext
               scataer = pscat
               gaer    = pasm
! convert backscattering efficiency to backscattering coefficient, units (cm)^-1
               bscoef= sback2/thesize
               
               
      return
      end subroutine fast_mieaer_modal                    

      function binarysearch(length, array, value)
        ! Given an array and a value, returns the index of the element that
        ! is closest to, but less than, the given value.
        ! Uses a binary search algorithm.
        ! "delta" is the tolerance used to determine if two values are equal
        ! if ( abs(x1 - x2) <= delta) then
        !    assume x1 = x2
        ! endif

        implicit none
        integer, intent(in) :: length
        real,    intent(in) :: array(length)
        real,    intent(in) :: value

        integer :: binarysearch

        integer :: left, middle, right

        real, parameter :: d = 1.0e-9

        if ( value .ge. array(length) ) then
             binarysearch = length
             return
        end if
        if ( value .le. array(1) ) then
             binarysearch = 1
             return
        end if
        
        left = 1
        right = length
        do
            if (left .gt. right) then
                exit
            end if
            middle = nint((left+right) / 2.0)
            if ( abs(array(middle) - value) .le. d) then
                binarySearch = middle
                return
            else if (array(middle) .gt. value) then
                right = middle - 1
            else
                left = middle + 1
            end if
        end do
        binarysearch = right

       end function binarysearch

       real function interpolate(x_len, x_array, y_len, y_array, f, x, y )
        ! This function uses bilinear interpolation to estimate the value
        ! of a function f at point (x,y)
        ! f is assumed to be sampled on a regular grid, with the grid x values specified
        ! by x_array and the grid y values specified by y_array
        ! Reference: http://en.wikipedia.org/wiki/Bilinear_interpolation
        implicit none
        integer, intent(in) :: x_len, y_len           
        real, intent(in) :: x_array(x_len)
        real, intent(in) :: y_array(y_len)
        real, intent(in) :: f(x_len, y_len)
        real, intent(in) :: x,y

        real :: denom, x1, x2, y1, y2
        integer :: i,j

        i = binarysearch(x_len, x_array, x)
        j = binarysearch(y_len, y_array, y)

        x1 = x_array(i)
        x2 = x_array(i+1)

        y1 = y_array(j)
        y2 = y_array(j+1)
        
        denom = (x2 - x1)*(y2 - y1)

        interpolate = (f(i,j)*(x2-x)*(y2-y) + f(i+1,j)*(x-x1)*(y2-y) + 
     &                 f(i,j+1)*(x2-x)*(y-y1) + f(i+1, j+1)*(x-x1)*(y-y1))/denom

        end function interpolate
!****************************************************************
      subroutine fitcurv(rs,yin,coef,ncoef,maxm)

!     fit y(x) using Chebychev polynomials
!     wig 7-Sep-2004: Removed dependency on pre-determined maximum
!                     array size and replaced with f90 array info.

!      USE module_peg_util, only:  peg_message

      IMPLICIT NONE

      integer, intent(in) :: maxm, ncoef
      real, intent(in)    :: rs(:), yin(:)
      real, intent(inout) :: coef(:)
!local: 
       real x(size(rs)),y(size(yin))

      integer m
      real xmin, xmax
      character(80) msg


 
      do 100 m=1,maxm
      x(m)=alog(rs(m))
      y(m)=alog(yin(m))
  100 continue

      xmin=x(1)
      xmax=x(maxm)
      do 110 m=1,maxm
      x(m)=(2*x(m)-xmax-xmin)/(xmax-xmin)
  110 continue

      call chebft(coef,ncoef,maxm,y)

      return
      end subroutine fitcurv                        

!**************************************************************
      subroutine fitcurv_nolog(rs,yin,coef,ncoef,maxm)

!     fit y(x) using Chebychev polynomials
!     wig 7-Sep-2004: Removed dependency on pre-determined maximum
!                     array size and replaced with f90 array info.

      IMPLICIT NONE

      integer, intent(in) :: maxm, ncoef
      real, intent(in)    :: rs(:), yin(:)
      real, intent(inout) :: coef(:) 
!local:      
      real x(size(rs)),y(size(yin))

      integer m
      real xmin, xmax
      character*80 msg
           

      do 100 m=1,maxm
      x(m)=alog(rs(m))
      y(m)=yin(m) ! note, no "alog" here
  100 continue

      xmin=x(1)
      xmax=x(maxm)
      do 110 m=1,maxm
      x(m)=(2*x(m)-xmax-xmin)/(xmax-xmin)
  110 continue

      call chebft(coef,ncoef,maxm,y)

      return
      end subroutine fitcurv_nolog                        
!************************************************************************
      subroutine chebft(c,ncoef,n,f)
!     given a function f with values at zeroes x_k of Chebychef polynomial
!     T_n(x), calculate coefficients c_j such that
!     f(x)=sum(k=1,n) c_k t_(k-1)(y) - 0.5*c_1
!     where y=(x-0.5*(xmax+xmin))/(0.5*(xmax-xmin))
!     See Numerical Recipes, pp. 148-150.

      IMPLICIT NONE
      real pi
      integer, intent( in ) :: ncoef, n
      real, intent( out ) :: c(:)
      real, intent( in  ) :: f(:)

! local variables      
!      parameter (pi=3.14159265)
      real(8) :: fac, thesum
      integer j, k
      
      fac=2.0d0/real( n,8 )
      do j=1,ncoef
         thesum=0.0d0
         do k=1,n
            thesum=thesum
     &            +real(f(k),8)
     &            *dcos((pii*real((j-1),8))*((real(k,8)-0.5)/real(n,8)))
         enddo
         c(j)=real(fac*thesum)
      enddo
      return
      end subroutine chebft             
! ------------------------------------------------------------------
      subroutine driver_bhmie_flexy(xx, crefin, qextalf, qscatalf, gscatalfg)
           implicit none
           
           real, intent(in)     :: XX 
           real, intent(out)    :: qextalf, qscatalf, gscatalfg
           complex, intent(in)  :: CREFIN
!local            
           real( 8 ), parameter  :: one_third = 1.0d0 / 3.0d0
           integer              :: NXX
           integer              :: nstop, modulus
           
           real :: QEXTI, QSCA, QBACK, G_MIE, xx1
           
           real( 8 )    :: x
           complex( 8 ) :: refractive_index
           
           x = real( XX, 8 )
           refractive_index = dcmplx( real( CREFIN ), imag( CREFIN ) )
           
           modulus = int( abs( x * refractive_index ) )      
           nstop = int( x + 4.0d0 * x**one_third + 2.0d0 )
           
           nxx = max( modulus, nstop ) + 15
       
           xx1 = 1.0 / XX
           
           CALL BHMIE_FLEXY(XX, NXX, NSTOP, CREFIN,QEXTI,QSCA,QBACK,G_MIE)
           
           qextalf   = QEXTI * xx1
           qscatalf  = QSCA * xx1
           gscatalfg = qscatalf * G_MIE
           sback_bhmie = QBACK * xx1
        
!           write(6,'(a,12(ES12.4,1X))',advance='NO')'WRF BHMIE_FLEXY: XX, QEXT,QSCA,G_MIE = ',
!    &      xx,qextalf,qscatalf,gscatalfg

       end subroutine driver_bhmie_flexy
! ------------------------------------------------------------------
       SUBROUTINE BHMIE_FLEXY (X,  NMX, NSTOP, REFREL, QQEXT, QQSCA, QBACK, GSCA)

! FSB Changed the call vector to return only QEXT, QSCAT QBACK GSCA
!     and ignore NANG, S1 and S2 and all calculations for them

          implicit none 

! Arguments:
          real,    intent(in) :: X        ! X = pi*particle_diameter / Wavelength
          integer, intent(in) :: NMX      ! maximum number of terms in Mie series 
          integer, intent(in) :: NSTOP    ! minumum number of terms in Mie series 
          complex, intent(in) :: REFREL   ! refractive index

!    REFREL = (complex refr. index of sphere)/(real index of medium)
!    in the current use the index of refraction of the the medium
!    i taken at 1.0 real.
!
!    Output

       real,    intent(out) :: QQEXT, QQSCA, QBACK, GSCA

!     QQEXT   Efficiency factor for extinction
!     QQSCA   Efficiency factor for scattering
!     QQBACK  Efficiency factor for back scatter
!     GSCA    asymmetry factor <cos>
!     SUCCESS flag for successful calculation
! REFERENCE: 
!  Bohren, Craig F. and Donald R. Huffman, Absorption and 
!    Scattering of Light by Small Particles, Wiley-Interscience
!    copyright 1983. Paperback Published 1998.
! FSB
!    This code was originally listed in Appendix A. pp 477-482.
!    As noted below, the original code was subsequently 
!    modified by Prof. Bruce T. Drain of Princetion University.
!    The code was further modified for a specific application
!    in a large three-dimensional code requiring as much 
!    computational efficiency as possible. 
!    Prof. Francis S. Binkowski of The University of North
!    Carolina at Chapel Hill. 

! Declare parameters:
! Note: important that MXNANG be consistent with dimension of S1 and S2
!       in calling routine!

          integer, parameter    :: MXNANG=10, NMXX=150000   ! FSB new limits
          integer, parameter    :: NANG  = 2
!          real*8, parameter     :: PII = 3.1415916536D0
          real*8, parameter     :: ONE = 1.0D0, TWO = 2.0D0
!          real(8),parameter     :: ONE_THIRD = 1.0D0/3.0D0
          complex*16, parameter :: COMPLEX_DZERO = (0.0D0,0.0D0)
          complex,    parameter :: COMPLEX_ZERO  = (0.0,0.0)

! Local variables:
          integer    :: N, NN
          real*8     :: QSCA, QEXT, DX1, DXX1      
          real*8     :: CHI,CHI0,CHI1,DX,EN,P,PSI,PSI0,PSI1,XSTOP,YMOD               
          real*8     :: TWO_N_M_ONE, TWO_N_P_ONE, EN1, FACTOR
          complex*16 :: AN,AN1,BN,BN1,DREFRL,XI,XI1,Y, Y1, DREFRL1
          complex*16 :: D(NMX)
          complex*16 :: FAC1, FAC2
          complex*16 :: XBACK


!***********************************************************************
! Subroutine BHMIE is the Bohren-Huffman Mie scattering subroutine
!    to calculate scattering and absorption by a homogenous isotropic
!    sphere.
! Given:
!    X = 2*pi*a/lambda
!    REFREL = (complex refr. index of sphere)/(real index of medium)
!    real refractive index of medium taken as 1.0 
! Returns:
!    QEXT  = efficiency factor for extinction
!    QSCA  = efficiency factor for scattering
!    QBACK = efficiency factor for backscatter
!            see Bohren & Huffman 1983 p. 122
!    GSCA = <cos> asymmetry for scattering
!
! Original program taken from Bohren and Huffman (1983), Appendix A
! Modified by Prof. Bruce T.Draine, Princeton Univ. Obs., 90/10/26
! in order to compute <cos(theta)>
! 91/05/07 (BTD): Modified to allow NANG=1
! 91/08/15 (BTD): Corrected error (failure to initialize P)
! 91/08/15 (BTD): Modified to enhance vectorizability.
! 91/08/15 (BTD): Modified to make NANG=2 if called with NANG=1
! 91/08/15 (BTD): Changed definition of QBACK.
! 92/01/08 (BTD): Converted to full double precision and double complex
!                 eliminated 2 unneed lines of code
!                 eliminated redundant variables (e.g. APSI,APSI0)
!                 renamed RN -> EN = double precision N
!                 Note that DOUBLE COMPLEX and DCMPLX are not part
!                 of f77 standard, so this version may not be fully
!                 portable.  In event that portable version is
!                 needed, use src/bhmie_f77.f
! 93/06/01 (BTD): Changed AMAX1 to generic function MAX
! FSB April 09,2012 This code was modified by: 
! Prof.  Francis S. Binkowski University of North Carolina at
! Chapel Hill, Institue for the Environment.
!
! The modifications were made to enhance computation speed 
! for use in a three-dimensional code. This was done by
! removing code that calculated angular scattering. The method
! of calculating QEXT, QBACK was also changed. 
 
!***********************************************************************
!*** Safety checks



           BHMIE_SUCCESS = .TRUE.
!           NANG = 2 ! FSB only this value 
! IF(NANG.GT.MXNANG)STOP'***Error: NANG > MXNANG in bhmie'
!         IF (NANG .LT. 2) NANG = 2

          DX = REAL( X, 8 )
! FSB D efine reciprocals so that divisions can be replaced by multiplications.      
           DX1  = ONE / DX
           DXX1 = DX1 * DX1
           DREFRL = DCMPLX( REAL( REFREL ), IMAG( REFREL ) )
           DREFRL1 = ONE / DREFRL
           Y = DX * DREFRL
           Y1 = ONE / Y
!           YMOD = ABS(Y)
 
!*** Series expansion terminated after NSTOP terms
!    Logarithmic derivatives calculated from NMX on down
!          XSTOP = X + 4.0 * X**0.3333 + 2.0
!          NMX  = MAX(XSTOP,YMOD) + 15

! BTD experiment 91/1/15: add one more term to series and compare results
!      NMX=AMAX1(XSTOP,YMOD)+16
! test: compute 7001 wavelengths between .0001 and 1000 micron
! for a=1.0micron SiC grain.  When NMX increased by 1, only a single
! computed number changed (out of 4*7001) and it only changed by 1/8387
! conclusion: we are indeed retaining enough terms in series!

          FACTOR = 1.0D0
 
!          IF (NMX .GT. NMXX) THEN
!             WRITE(6,*)'Error: NMX > NMXX=',NMXX,' for |m|x=',YMOD
!             BHMIE_SUCCESS = .FALSE.
!             RETURN
!          END IF

! FSB all code relating to scattering angles is removed out for
!     reasons of efficiency when running in a three-dimensional 
!     code. We only need QQSCA, QQEXT, GSCA AND QBACK

 
!*** Logarithmic derivative D(J) calculated by downward recurrence
!    beginning with initial value (0.,0.) 
 
          D(NMX) = COMPLEX_DZERO
          NN = NMX - 1
          DO N = 1,NN
             EN  = REAL( NMX - N + 1, 8 )
! FSB In the following division by Y has been replaced by 
!     multiplication by Y1, the reciprocal of Y.          
             D(NMX-N) = ( EN * Y1 ) - (ONE / ( D(NMX-N+1) + EN * Y1)) 
          END DO
 
!*** Riccati-Bessel functions with real argument X
!    calculated by upward recurrence
 
          PSI0 =  COS(DX)
          PSI1 =  SIN(DX)
          CHI0 = -SIN(DX)
          CHI1 =  PSI0
          XI1  =  DCMPLX(PSI1,-CHI1)
          QSCA =  0.0D0
          GSCA =  0.0D0
          QEXT =  0.0D0
          P    = -ONE
          XBACK = COMPLEX_DZERO

! FSB Start main loop       
          DO N = 1,NSTOP
             EN        = REAL( N, 8 )
             EN1       = ONE / EN
             TWO_N_M_ONE = TWO * EN - ONE
! for given N, PSI  = psi_n        CHI  = chi_n
!              PSI1 = psi_{n-1}    CHI1 = chi_{n-1}
!              PSI0 = psi_{n-2}    CHI0 = chi_{n-2}
! Calculate psi_n and chi_n
             PSI = TWO_N_M_ONE * PSI1 * DX1 - PSI0
             CHI = TWO_N_M_ONE * CHI1 * DX1 - CHI0
             XI  = DCMPLX(PSI,-CHI)
 
!*** Compute AN and BN:
! FSB Rearrange to get common terms
             FAC1 = D(N) * DREFRL1 + EN * DX1 
             AN   = (FAC1) * PSI - PSI1
             AN   = AN / ( (FAC1 )* XI - XI1 )
             FAC2 = ( DREFRL * D(N) + EN * DX1)
             BN   = ( FAC2) * PSI -PSI1
             BN   = BN / ((FAC2) * XI - XI1 )

! FSB calculate sum for QEXT as done by Wiscombe
!     get common factor
             TWO_N_P_ONE = (TWO * EN + ONE)
             QEXT = QEXT + (TWO_N_P_ONE) * (REAL(AN) + REAL(BN) ) 
             QSCA = QSCA + (TWO_N_P_ONE) * ( ABS(AN)**2 + ABS(BN)**2 )
          
! FSB calculate XBACK from B & H Page 122          
             FACTOR = -1.0d0 * FACTOR  ! calculate (-1.0 ** N)
             XBACK  = XBACK + (TWO_N_P_ONE) * factor * (AN - BN)
          
! FSB calculate asymmetry factor   
             
             GSCA = GSCA + REAL((TWO_N_P_ONE)/(EN * (EN + ONE)) * 
     &                (REAL(AN)*REAL(BN)+IMAG(AN)*IMAG(BN)))
             
              IF (N .GT. 1)THEN
                GSCA = GSCA + REAL((EN - EN1) 
     &                *  (REAL(AN1)*REAL(AN) + IMAG(AN1)*IMAG(AN) 
     &                +   REAL(BN1)*REAL(BN) + IMAG(BN1)*IMAG(BN)))
             ENDIF

!*** Store previous values of AN and BN for use in computation of g=<cos(theta)>
             AN1 = AN
             BN1 = BN

! FSB set up for next iteration
             PSI0 = PSI1
             PSI1 = PSI
             CHI0 = CHI1
             CHI1 = CHI
             XI1  = DCMPLX(PSI1,-CHI1)
          
          END DO   ! main  loop on n
 
!*** Have summed sufficient terms.

!    Now compute QQSCA,QQEXT,QBACK,and GSCA
          GSCA  = REAL( TWO / QSCA ) * GSCA

! FSB in the following, divisions by DX * DX has been replaced by
!      multiplication by DXX1 the reciprocal of 1.0 / (DX *DX)           
          QQSCA = REAL( TWO * QSCA * DXX1 )
          QQEXT = REAL( TWO * QEXT * DXX1 )
          QBACK = REAL( REAL( 0.5D0 * XBACK * CONJG(XBACK), 8 ) * DXX1 ) ! B&H Page 122

       END subroutine BHMIE_FLEXY

      end module wrf_fast_mie

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C-----------------------------------------------------------------------
      SUBROUTINE PA_ERRCHECK

C-----------------------------------------------------------------------
C Function: To check the Process Analysis inputs for errors
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified by Jerry Gipson April, 1997 to add ADJC process and to add
C  species = all for IPR outputs
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Dec. 1, 1998 to correct operator name check problem
C  Modified Apr 11, 2000 to account for AE species w/ surface area units
C  J.Young: fix LCHEMFAM array index bug, fix N_IPR_SPC value for no ipr,
C  fix blank in 'Air density' species name (found by Michael Bane in UK)
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI`s M3UTILIO
C  Jul 2016 Jeff Young: modify for model inline
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------

      USE UTILIO_DEFN   
      USE PA_GLOBAL     ! Mech and Grid data used 
      USE CGRID_SPCS, Only: N_CGRID_SPC, CGRID_NAME
      USE PA_IPRVARS
      USE PA_VARS
      USE PA_PARSE
      USE PA_DEFN

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables
      CHARACTER(  4 ) :: TYPE       ! Operator type
      CHARACTER(  7 ) :: PNFLAG     ! Initialization flag
      CHARACTER( 16 ) :: FAM_UNITS  ! Units for first species in a family
      CHARACTER( 16 ) :: VALNAME( MAXDEFNAMES )  ! Vector of valid defined names
      CHARACTER( 16 ) :: SP_UNITS(  MAXFAMMEM )  ! Units for each species

      LOGICAL LDIFF      ! Flag for difference found
      LOGICAL LERROR     ! Flag for an error found
      LOGICAL LFOUND     ! Flag for a name found
      LOGICAL LFIRST     ! Flag for first time
      LOGICAL :: LERREND = .FALSE.   ! Flag to stop processing because of errors
      LOGICAL :: LCHEMFAM( 0:MAXFAMLYS ) ! Flag for gas-chem species family
      LOGICAL LRXINC( MXRXNS )     ! Flag for rxns included in cycles
      LOGICAL LCYUSED( MAXCYCLES ) ! Flag to indicate cycle referenced
      LOGICAL LRXUSED( MAXRXNSUM ) ! Flag to indicate rxnsum referenced
     
      INTEGER CINDX      ! Current index for IPR arrays
      INTEGER HINDX      ! Index for rearranging IPR arrays
      INTEGER INDX       ! Index returned from function INDEX1
      INTEGER JNDX       ! Index returned from function INDEX1
      INTEGER IRRIND     ! Index for IRR reaction number
      INTEGER LINDX      ! Index for rearranging IPR arrays
      INTEGER N          ! Loop index for specis and defined names
      INTEGER NCYC       ! Loop index for number of cycles
      INTEGER NEWNPASP   ! Number of IPR species after ALL species option
      INTEGER NFAM       ! Loop index for number of families
      INTEGER NMEM       ! Loop index for number of family members
      INTEGER NOP        ! Loop index for number of IPR operators
      INTEGER NOPS       ! Number of IPR_OUTPUT operators
      INTEGER NOUT       ! Loop index for number of output requests
      INTEGER NR         ! No. of Rxns found by getrxns
      INTEGER NRX        ! Loop index for reactions
      INTEGER NRXS       ! Loop index for number of reaction sums
      INTEGER NTERM      ! Loop index for number of terms
      INTEGER NUMRXNS    ! No. of IRR reactions
      INTEGER NVALID     ! Number of valid defined names
      INTEGER OFFSET     ! Offset use to compute IPR output index
      INTEGER PAINDX     ! Index for IPR outputs
      INTEGER :: RXNUMS( MXRXNS ) ! Rxn nos. of Rxns found bt getrxns
      INTEGER ASTAT      ! Memory

      REAL    :: COEFFS( MXRXNS )    ! Coefficient found with getrxns
         
C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write log header message
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      WRITE( MSG, 93000 )
      CALL M3MESG( MSG )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check that all family names are valid
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      NVALID = 0
      INDX = 0
      LCHEMFAM( 0 ) = .FALSE.
      DO 40 NFAM = 1, NFAMLYS
         INDX = INDEX1( FAMNAME( NFAM ), N_CGRID_SPC, CGRID_NAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94000 ) NFAM, FAMNAME( NFAM )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         INDX = INDEX1( FAMNAME( NFAM ), NVALID, VALNAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94020 ) NFAM, FAMNAME( NFAM )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         LCHEMFAM( NFAM ) = .TRUE.
         DO NMEM = 1, NUMFAMMEM( NFAM )
            INDX = INDEX1( FAMMEMNAM( NFAM,NMEM ), N_CGRID_SPC, CGRID_NAME ) 
            IF ( INDX .NE. 0 ) THEN               
               FAMSPIDS( NFAM, NMEM ) = INDX
               JNDX = INDEX1( FAMMEMNAM( NFAM,NMEM ), NUMB_MECH_SPC, CHEMISTRY_SPC )              
               IF ( JNDX .EQ. 0 ) LCHEMFAM( NFAM ) = .FALSE.
            ELSE
               WRITE( MSG, 94040 ) NFAM, FAMNAME( NFAM ),
     &                             FAMMEMNAM( NFAM,NMEM )
               CALL M3MESG( MSG )
               LERROR = .TRUE.
            END IF
         END DO

         IF ( .NOT. LERROR ) THEN
            NVALID = NVALID + 1
            VALNAME( NVALID ) = FAMNAME( NFAM )
         END IF
40    CONTINUE
      IF ( LERROR ) LERREND = .TRUE. 
     
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check rxnsums inputs
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      DO 80 NRXS = 1, NRXSUMS
         LRXUSED( NRXS ) = .FALSE.

         INDX = INDEX1( RXSUMNAME( NRXS ), N_CGRID_SPC, CGRID_NAME )
         IF ( INDX .NE. 0 ) THEN 
            WRITE( MSG, 94060 ) NRXS, RXSUMNAME( NRXS )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         INDX = INDEX1( RXSUMNAME( NRXS ), NVALID, VALNAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94080 ) NRXS, RXSUMNAME( NRXS )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         DO NTERM = 1, NRXTERMS( NRXS )
            INDX = INDEX1( RXSUMLBL( NRXS,NTERM ), NRXNS, RXLABEL ) 
            IF ( INDX .NE. 0 ) THEN
               RXSUMRN( NRXS, NTERM ) = INDX
            ELSE
               WRITE( MSG, 94100 )
               CALL M3MESG( MSG )
               WRITE( MSG, 94105 ) NRXS, RXSUMNAME( NRXS )
               CALL M3MESG( MSG )
               WRITE( MSG, 94110 ) RXSUMLBL( NRXS,NTERM )
               CALL M3MESG( MSG )
               LERROR = .TRUE.
            END IF
         END DO

         IF ( .NOT. LERROR ) THEN
            NVALID = NVALID + 1
            VALNAME( NVALID ) = RXSUMNAME( NRXS )
         END IF
80    CONTINUE

      IF ( LERROR ) LERREND = .TRUE. 
      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check cycle names and cycle species names
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      DO 100 NCYC = 1, NCYCLES
         LCYUSED( NCYC ) = .FALSE.

         INDX = INDEX1( CYCLNAME( NCYC ), N_CGRID_SPC, CGRID_NAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94120 ) NCYC, CYCLNAME( NCYC )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         INDX = INDEX1( CYCLNAME( NCYC ), NVALID, VALNAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94140 ) NCYC, CYCLNAME( NCYC )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         LFOUND = .FALSE.
         INDX = INDEX1( CYCLSPEC( NCYC ), NUMB_MECH_SPC, CHEMISTRY_SPC )
         IF ( INDX .NE. 0 ) THEN
            LFOUND = .TRUE.
            CYSPTYP( NCYC ) = 'MECH'
            CYSPNUM( NCYC ) = INDX
         END IF

         INDX = INDEX1( CYCLSPEC( NCYC ), NFAMLYS, FAMNAME ) 
         IF ( INDX .NE. 0 ) THEN
            LFOUND = .TRUE.
            CYSPTYP( NCYC ) = 'FAM'
            CYSPNUM( NCYC ) = INDX
         END IF

         IF ( .NOT. LFOUND ) THEN
            WRITE( MSG, 94160 ) NCYC, CYCLNAME( NCYC ), CYCLSPEC( NCYC )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF
100   CONTINUE
      IF ( LERROR ) LERREND = .TRUE. 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check IRR_OUTPUT species names and reaction labels
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      DO 140 NOUT = 1, NIRROUT

c..check that the output name itself is unique
         INDX = INDEX1( IRRNAME( NOUT ), N_CGRID_SPC, CGRID_NAME )
         IF ( INDX .NE. 0 ) THEN 
            WRITE( MSG, 94180 ) NOUT, IRRNAME( NOUT )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF
         
         INDX = INDEX1( IRRNAME( NOUT ), NVALID, VALNAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94200 ) NOUT, IRRNAME( NOUT )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         IF ( .NOT. LERROR ) THEN
            NVALID = NVALID + 1
            VALNAME( NVALID ) = IRRNAME( NOUT )
         END IF

         DO 120 NTERM = 1, NIRRTERMS( NOUT )

c...check names used in production/loss/net operators
            TYPE = OUTTYPE( NOUT,NTERM )
            IF ( TYPE .EQ. 'PROD' .OR. TYPE .EQ. 'NETP' .OR. 
     &           TYPE .EQ. 'LOSS' .OR. TYPE .EQ. 'NETL' .OR.
     &           TYPE .EQ. 'NET' ) THEN

               LFOUND = .FALSE.

               INDX = INDEX1( OUTSPEC1( NOUT,NTERM ), NUMB_MECH_SPC, CHEMISTRY_SPC )
               IF ( INDX .NE. 0 ) THEN
                  LFOUND = .TRUE.
                  OUTS1TYP( NOUT, NTERM ) = 'MECH'
                  OUTS1NUM( NOUT, NTERM ) = INDX
               END IF

               INDX = INDEX1( OUTSPEC1( NOUT,NTERM ), NFAMLYS, FAMNAME )
               IF ( INDX .NE. 0 .AND. LCHEMFAM( INDX ) ) THEN
                  LFOUND = .TRUE.
                  OUTS1TYP( NOUT, NTERM ) = 'FAM'
                  OUTS1NUM( NOUT, NTERM ) = INDX
               END IF
 
               IF ( .NOT. LFOUND ) THEN
                  LERROR = .TRUE.
                  IF ( INDX .NE. 0 .AND. .NOT. LCHEMFAM( INDX ) ) THEN
                     WRITE( MSG, 94220 )
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94260 ) NOUT, IRRNAME( NOUT ) 
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94230 ) OUTSPEC1( NOUT, NTERM )
                     CALL M3MESG( MSG )
                  ELSE
                     WRITE( MSG, 94240 )
                     CALL M3MESG( MSG )
                     WRITE( MSG,94260 ) NOUT, IRRNAME( NOUT ) 
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94280 ) OUTSPEC1( NOUT, NTERM )
                     CALL M3MESG( MSG )
                  END IF
               END IF

               IF ( OUTSPEC2( NOUT,NTERM ) .NE. '' .AND. 
     &              ( TYPE .EQ. 'PROD' .OR. TYPE .NE. 'NETP' ) ) THEN
                  LFOUND = .FALSE.
                  INDX = INDEX1( OUTSPEC2( NOUT,NTERM ), NUMB_MECH_SPC, CHEMISTRY_SPC )
                  IF ( INDX .NE. 0 ) THEN
                     LFOUND = .TRUE.
                     OUTS2TYP( NOUT,NTERM ) = 'MECH'
                     OUTS2NUM( NOUT,NTERM ) = INDX
                  END IF

                  INDX = INDEX1( OUTSPEC2( NOUT,NTERM ), NFAMLYS, FAMNAME )
                  IF ( INDX .NE. 0 .AND. LCHEMFAM( INDX ) ) THEN
                     LFOUND = .TRUE.
                     OUTS2TYP( NOUT,NTERM ) = 'FAM'
                     OUTS2NUM( NOUT,NTERM ) = INDX
                  END IF

                  IF ( OUTSPEC2( NOUT,NTERM ) .EQ. 'hv' ) THEN
                     LFOUND = .TRUE.
                     OUTS2TYP( NOUT,NTERM ) = 'MECH'
                     OUTS2NUM( NOUT,NTERM ) = 0
                  END IF
                        
                  IF ( .NOT. LFOUND ) THEN
                     LERROR = .TRUE.
                     IF ( INDX .NE. 0 .AND. .NOT. LCHEMFAM( INDX ) ) THEN
                        WRITE( MSG, 94220 )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94260 ) NOUT, IRRNAME( NOUT ) 
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94230 ) OUTSPEC2( NOUT,NTERM )
                        CALL M3MESG( MSG )
                     ELSE
                        WRITE( MSG, 94240 )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94260 ) NOUT, IRRNAME( NOUT )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94280 ) OUTSPEC2( NOUT,NTERM )
                        CALL M3MESG( MSG )
                     END IF
                  END IF
               END IF
               
               IF ( OUTSPEC3( NOUT, NTERM ) .NE. '' .AND. 
     &                TYPE .NE. 'NET' ) THEN
                  LFOUND = .FALSE.
                  INDX = INDEX1( OUTSPEC3( NOUT,NTERM ), NUMB_MECH_SPC, CHEMISTRY_SPC )
                  IF ( INDX .NE. 0 ) THEN
                     LFOUND = .TRUE.
                     OUTS3TYP( NOUT,NTERM ) = 'MECH'
                     OUTS3NUM( NOUT,NTERM ) = INDX
                  END IF

                  INDX = INDEX1( OUTSPEC3( NOUT,NTERM ), NFAMLYS, FAMNAME )
                  IF ( INDX .NE. 0 .AND. LCHEMFAM( INDX ) ) THEN
                     LFOUND = .TRUE.
                     OUTS3TYP( NOUT,NTERM ) = 'FAM'
                     OUTS3NUM( NOUT,NTERM ) = INDX
                  END IF

                  IF ( OUTSPEC3( NOUT,NTERM ) .EQ. 'hv ' ) THEN
                     LFOUND = .TRUE.
                     OUTS3TYP( NOUT,NTERM ) = 'MECH'
                     OUTS3NUM( NOUT,NTERM ) = 0
                  END IF
                    
                  IF ( .NOT. LFOUND ) THEN
                     LERROR = .TRUE.
                     IF ( INDX .NE. 0 .AND. .NOT. LCHEMFAM( INDX ) ) THEN
                        WRITE( MSG, 94220 )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94260 ) NOUT, IRRNAME( NOUT ) 
                        CALL M3MESG( MSG )
                        WRITE( MSG,94230 ) OUTSPEC2( NOUT,NTERM )
                        CALL M3MESG( MSG )
                     ELSE
                        WRITE( MSG, 94240 )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94260 ) NOUT, IRRNAME( NOUT )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94280 ) OUTSPEC3( NOUT,NTERM ) 
                        CALL M3MESG( MSG )
                     END IF
                  END IF
               END IF

c..check cycle names or reaction sum names
            ELSE IF ( TYPE .EQ. 'NAME' ) THEN
               LFOUND = .FALSE.
               INDX = INDEX1( OUTSPEC1( NOUT,NTERM ), NRXSUMS, RXSUMNAME )
               IF ( INDX .NE. 0 ) THEN               
                  LFOUND = .TRUE.
                  OUTS1TYP( NOUT, NTERM ) = 'RXSM'
                  OUTS1NUM( NOUT, NTERM ) = INDX
                  LRXUSED( INDX ) = .TRUE.
               END IF
               INDX = INDEX1( OUTSPEC1( NOUT,NTERM ), NCYCLES, CYCLNAME )
               IF ( INDX .NE. 0 ) THEN               
                  LFOUND = .TRUE.
                  OUTS1TYP( NOUT,NTERM ) = 'CYCL'
                  OUTS1NUM( NOUT,NTERM ) = INDX
                  LCYUSED( INDX ) = .TRUE.
               END IF

               IF ( .NOT. LFOUND ) THEN
                  WRITE( MSG, 94300 )
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94320 ) NOUT, IRRNAME( NOUT ) 
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94340 ) OUTSPEC1( NOUT,NTERM )
                  CALL M3MESG( MSG )
                  LERROR = .TRUE.
               END IF

c..check for reaction label name
            ELSE IF ( TYPE .EQ. 'RXN' ) THEN
               LFOUND = .FALSE.
               INDX = INDEX1( OUTRXLBL( NOUT,NTERM ), NRXNS, RXLABEL )
               IF ( INDX .NE. 0 ) THEN               
                  LFOUND = .TRUE.
                  OUTRN( NOUT,NTERM ) = INDX
               END IF

               IF ( .NOT. LFOUND ) THEN
                  WRITE( MSG, 94360 )
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94380 ) NOUT, IRRNAME( NOUT ) 
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94400 ) OUTRXLBL( NOUT,NTERM )
                  CALL M3MESG( MSG )
                  LERROR = .TRUE.
               END IF
            ELSE
               WRITE( MSG, 94420 )
               CALL M3MESG( MSG )
               WRITE( MSG, 94440 ) NOUT, IRRNAME( NOUT )
               CALL M3MESG( MSG )
               WRITE( MSG, 94460 ) TYPE
               CALL M3MESG( MSG )
               LERROR = .TRUE.
            END IF
120      CONTINUE
140   CONTINUE         
      IF ( LERROR ) LERREND = .TRUE.

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check IPR_OUTPUT species names
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      IF ( N_IPR_SPC .GT. 0 ) THEN
         OFFSET = 0
         NEWNPASP = N_IPR_SPC
         DO 160 NOUT = 1, N_IPR_SPC
            PAINDX = NOUT + OFFSET 
            LFOUND = .FALSE.
            INDX = INDEX1( IPR_SPNAM( PAINDX ), N_CGRID_SPC, CGRID_NAME )
            IF ( INDX .NE. 0 ) THEN 
               LFOUND = .TRUE.
               IPR_SPTYPE( PAINDX ) = 'SPEC'
               IPR_SPNUM( PAINDX ) = INDX
            END IF
  
            IF ( .NOT. LFOUND ) THEN
               INDX = INDEX1( IPR_SPNAM( PAINDX ), NFAMLYS, FAMNAME )
               IF ( INDX .NE. 0 ) THEN 
                  LFOUND = .TRUE.
                  IPR_SPTYPE( PAINDX ) = 'FAM'
                  IPR_SPNUM( PAINDX ) = INDX
               END IF
            END IF

c..If all species requested, insert all species into position
            IF ( .NOT. LFOUND. AND. 
     &            ( IPR_SPNAM( PAINDX )( 1:3 ) .EQ. 'ALL' .OR.
     &              IPR_SPNAM( NOUT )( 1:3 ) .EQ. 'all' ) ) THEN
               LFOUND = .TRUE.
               NEWNPASP = PAINDX - 1 + N_CGRID_SPC + ( N_IPR_SPC - NOUT )
               IF ( NEWNPASP .GT. MAXIPRSPC ) THEN
                  WRITE( MSG, 94800 )
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94820 ) MAXIPRSPC
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94840 )
                  CALL M3MESG( MSG )
                  CALL M3EXIT( 'ERRCHECK', IZERO, IZERO, ' ', XSTAT1 )
               END IF

               OFFSET = PAINDX - 1 + N_CGRID_SPC - NOUT
               IF ( N_IPR_SPC .GT. NOUT ) THEN
                  CINDX = PAINDX
                  DO N = NOUT + 1, N_IPR_SPC
                     CINDX = CINDX + 1
                     HINDX = N + OFFSET
                     IPR_SPNAM( HINDX ) = IPR_SPNAM( CINDX )
                     N_IPR_OPS( HINDX ) = N_IPR_OPS( CINDX )
                     IF ( N_IPR_OPS( HINDX ) .GT. 0 ) THEN
                        DO NOP = 1, N_IPR_OPS( HINDX )
                           IPR_OPNAME( HINDX, NOP ) = IPR_OPNAME( CINDX,NOP )
                        END DO
                     END IF
                  END DO
               END IF

               LINDX = PAINDX
               DO N = 1, N_CGRID_SPC
                  IPR_SPNAM( LINDX )  = CGRID_NAME( N )
                  N_IPR_OPS( LINDX )  = N_IPR_OPS( PAINDX )
                  IPR_SPTYPE( LINDX ) = 'SPEC'
                  IPR_SPNUM( LINDX )  = N
                  DO NOP = 1, N_IPR_OPS( LINDX )
                     IPR_OPNAME( LINDX,NOP ) = IPR_OPNAME( PAINDX,NOP )
                  END DO
                  LINDX = LINDX + 1
               END DO
            END IF
                         
            IF ( .NOT. LFOUND ) THEN
               WRITE( MSG, 94480 )
               CALL M3MESG( MSG )
               WRITE( MSG, 94500 ) IPR_SPNAM( PAINDX )
               CALL M3MESG( MSG )
               LERROR = .TRUE.
            END IF
160      CONTINUE
         N_IPR_SPC = NEWNPASP
      END IF               
      IF ( LERROR ) LERREND = .TRUE.

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check IPR_OUTPUT operators
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      DO 180 NOUT = 1, N_IPR_SPC
         NOPS = N_IPR_OPS( NOUT )
         IF ( NOPS .EQ. 0 ) THEN
            DO N = 1, NPRCS
               IPR_OPNAME( NOUT,N ) = PROCNAME( N )
            END DO
            N_IPR_OPS( NOUT ) = NPRCS
         END IF
180   CONTINUE

      IF ( LERROR ) LERREND = .TRUE.
               
      IF ( LERROR .OR. LERREND ) GO TO 999  ! If errors, skip next error checks

c determine NIRRRXNS
      ALLOCATE( NIRRRXNS( NIRRVAR ), STAT = ASTAT )   ! NIRRVAR .ge. NIRROUT
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 1 allocating IRR variables'
         CALL M3EXIT ( 'PA_ERRCHECK', 0, 0, MSG, XSTAT2 )
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Get IRR reaction numbers excluding those included in CYCLES & RXNSUMS 
c  and check dimension magnitudes
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      MXNIRRRXNS = 0
      DO 300 NOUT = 1, NIRROUT
         NIRRRXNS( NOUT ) = 0
         
c..Flag reactions included in Cycles for elimination in operators
         DO NRX = 1, NRXNS
            LRXINC( NRX ) = .TRUE.
         END DO

         IF ( NOUTCYCS( NOUT ) .GT. 0 ) THEN
            DO N = 1, NOUTCYCS( NOUT )
               NCYC = OUTCYCS( NOUT, N )
               DO NTERM = 1, NCYTERMS( NCYC )
                  INDX = CYRXNUM( NCYC,NTERM )
                  LRXINC( INDX ) = .FALSE.
               END DO
            END DO
         END IF

         DO 280 NTERM = 1, NIRRTERMS( NOUT )
            TYPE = OUTTYPE( NOUT, NTERM ) 
            IF ( TYPE .NE. 'NAME' .AND. TYPE .NE. 'RXN' ) THEN             
               CALL GETRXNS( NOUT, NTERM, NR, RXNUMS, COEFFS, LRXINC )
               IF ( NR .GT. 0 ) THEN
                  NUMRXNS = NIRRRXNS( NOUT ) + NR
                  IF ( NUMRXNS .GT. MAXTERMS ) THEN
                     WRITE( MSG, 94560 )
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94580 ) NOUT, IRRNAME( NOUT )
                     CALL M3MESG( MSG )
                     LERROR = .TRUE.
                     GO TO 300
                  END IF
                  DO NRX = 1, NR
                     INDX = RXNUMS( NRX )
                     IRRIND = NIRRRXNS( NOUT ) + NRX
                     IRRRXN_TMP( NOUT,IRRIND ) = INDX
                     IRRCOEF_TMP( NOUT,IRRIND ) = COEFFS( NRX ) * OUTSC( NOUT,NTERM ) 
                  END DO                     
                  NIRRRXNS( NOUT ) = NIRRRXNS( NOUT ) + NR
               END IF
            ELSE IF ( TYPE .EQ. 'RXN' ) THEN
               NUMRXNS = NIRRRXNS( NOUT ) + 1
               IF ( NUMRXNS .GT. MAXTERMS ) THEN
                  WRITE( MSG, 94560 )
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94580 ) NOUT, IRRNAME( NOUT )
                  CALL M3MESG( MSG )
                  LERROR = .TRUE.
                  GO TO 300 
               END IF
               NIRRRXNS( NOUT ) = NIRRRXNS( NOUT ) + 1                  
               IRRRXN_TMP(  NOUT,NIRRRXNS( NOUT ) ) = OUTRN( NOUT,NTERM ) 
               IRRCOEF_TMP( NOUT,NIRRRXNS( NOUT ) ) = OUTSC( NOUT,NTERM )
            END IF
280      CONTINUE
         MXNIRRRXNS = MAX( MXNIRRRXNS, NIRRRXNS( NOUT ) ) 
300   CONTINUE

      ALLOCATE( IRRRXN( NIRRVAR,MXNIRRRXNS ),
     &          IRRCOEF( NIRRVAR,MXNIRRRXNS ), STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 2 allocating IRR variables'
         CALL M3EXIT ( 'PA_ERRCHECK', 0, 0, MSG, XSTAT2 )
      END IF

      IRRRXN  = IRRRXN_TMP( 1:NIRRVAR,1:MXNIRRRXNS )
      IRRCOEF = IRRCOEF_TMP( 1:NIRRVAR,1:MXNIRRRXNS )

      IF ( LERROR ) LERREND = .TRUE.

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check some dimension limits, saving some info
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      NUMOUTPOS = 0
      NUMOUTNEG = 0
      NUMOUTIND = 0
      DO NOUT = 1, NIRROUT
         DO NTERM = 1, NIRRTERMS( NOUT )
            TYPE = OUTS1TYP( NOUT, NTERM )
            IF ( TYPE .EQ. 'CYCL' .OR. TYPE .EQ. 'RXSM' ) THEN            
               PNFLAG = OUTPNFLAG( NOUT,NTERM )
               IF ( PNFLAG .EQ. 'POSONLY' ) THEN
                  NUMOUTPOS = NUMOUTPOS + 1
               ELSE IF ( PNFLAG .EQ. 'NEGONLY' ) THEN
                  NUMOUTNEG = NUMOUTNEG + 1
               ELSE IF ( PNFLAG .EQ. '' ) THEN
                  NUMOUTIND = NUMOUTIND + 1
               END IF 
            END IF
         END DO
      END DO

      IF ( NUMOUTPOS .GT. MAXTERMS .OR. NUMOUTNEG .GT. MAXTERMS .OR.
     &     NUMOUTIND .GT. MAXTERMS ) THEN
         WRITE( MSG, 94600 )  MAXTERMS
         CALL M3MESG( MSG )
         LERREND = .TRUE.
      END IF

      IF ( LFULLIRR .AND. NRXNS .GT. MAXIRROUT ) THEN
         WRITE( MSG, 94610 )  MAXIRROUT
         CALL M3MESG( MSG )
         LERREND = .TRUE.
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check to see that a species is not named more than once in a FAMILY
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      LFIRST = .TRUE.
      DO NFAM = 1, NFAMLYS
         DO NMEM = 1, NUMFAMMEM( NFAM )
            DO N = 1, NUMFAMMEM( NFAM )
               IF ( NMEM .NE. N ) THEN
                  IF ( FAMMEMNAM( NFAM,NMEM ) .EQ. 
     &                FAMMEMNAM( NFAM,N ) ) THEN
                     IF ( LFIRST ) THEN
                        WRITE( MSG, 94620 ) 
                        CALL M3MESG( MSG )
                        LFIRST = .FALSE.
                     END IF
                     WRITE( MSG, 94640 ) NFAM, FAMNAME( NFAM ), 
     &                                   FAMMEMNAM( N,NMEM )
                     CALL M3MESG( MSG )
                     LERROR = .TRUE.
                  END IF
               END IF
            END DO
         END DO
      END DO
      IF ( LERROR ) LERREND = .TRUE. 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check to see that all species in a FAMILY have the same units
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      DO NFAM = 1, NFAMLYS
         LDIFF = .FALSE.
         DO NMEM = 1, NUMFAMMEM( NFAM )
            SP_UNITS( NMEM ) = 'ppm'
            INDX = INDEX1( FAMMEMNAM( NFAM,NMEM ), N_CGRID_SPC, CGRID_NAME )
            IF ( NMEM .EQ. 1 ) THEN
               FAM_UNITS = SP_UNITS( NMEM )
            ELSE
               IF ( SP_UNITS( NMEM ) .NE. FAM_UNITS ) LDIFF = .TRUE.   
            END IF
         END DO

         IF ( LDIFF ) THEN
            LERROR = .TRUE.
            WRITE( MSG, 94650 ) NFAM, FAMNAME( NFAM ) 
            CALL M3MESG( MSG )
            DO NMEM = 1, NUMFAMMEM( NFAM )
               WRITE( MSG,94652 ) NMEM, FAMMEMNAM( NFAM,NMEM ), SP_UNITS( NMEM ) 
               CALL M3MESG( MSG )
            END DO
         END IF
      END DO                   
      IF ( LERROR ) LERREND = .TRUE. 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check to see if any defined CYCLES or RXNSUMS are not used
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LFIRST = .TRUE.
      DO NCYC = 1, NCYCLES
         IF ( .NOT. LCYUSED( NCYC ) ) THEN
            IF ( LFIRST ) THEN 
               WRITE( MSG, 94660 ) 
               CALL M3MESG( MSG )
               LFIRST = .FALSE.
            END IF
            WRITE( MSG, 94680 ) NCYC, CYCLNAME( NCYC )
            CALL M3MESG( MSG )
         END IF
      END DO

      LFIRST = .TRUE.
      DO NRXS = 1, NRXSUMS
         IF ( .NOT. LRXUSED( NRXS ) ) THEN
            IF ( LFIRST ) THEN 
               WRITE( MSG, 95700 ) 
               CALL M3MESG( MSG )
               LFIRST = .FALSE.
            END IF
            WRITE( MSG, 95720 ) NRXS, RXSUMNAME( NRXS )
            CALL M3MESG( MSG )
         END IF
      END DO

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Return or stop
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
999   CONTINUE
      IF ( LERREND ) THEN
         WRITE( MSG, 95740 )
         CALL M3MESG( MSG )
         CALL M3EXIT( 'ERRCHECK', IZERO, IZERO, ' ', XSTAT1 )
      ELSE
         WRITE( MSG, 95760 )
         CALL M3MESG( MSG )
         RETURN
      END IF
 
C---------------------- Format Statements -----------------------------     
      
93000 FORMAT( 'Entering the Process Analysis error checking routine' )
94000 FORMAT( 'ERROR: FAMILY name ', I3, ' ', A16, 
     &               ' duplicates a species name' )
94020 FORMAT( 'ERROR: FAMILY name ', I3, ' ', A16, ' duplicates another',
     &               ' DEFINEd name' )
94040 FORMAT( 'ERROR: Invalid member name for FAMILY ', I3, ' ', A16,
     &               ':', A16 )
94060 FORMAT( 'ERROR: RXNSUM name ', I3, ' ', A16,
     &               ' duplicates a species name' )
94080 FORMAT( 'ERROR: RXNSUM name ', I3, ' ', A16,' duplicates another',
     &               ' DEFINEd name' )
94100 FORMAT( 'ERROR: Invalid reaction label for RXNSUM' )
94105 FORMAT( '       RXNSUM name ', I3, ': ', A16 )
94110 FORMAT( '       Invalid reaction label: ', A16 )         
94120 FORMAT( 'ERROR: CYCLE name ', I3, ' ', A16,
     &               ' duplicates a species name' )
94140 FORMAT( 'ERROR: CYCLE name ', I3, ' ', A16, ' duplicates another',
     &               ' DEFINEd name' )
94160 FORMAT( 'ERROR: Invalid species name for CYCLE ', I3,' ',A16,
     &               ': ', A16 ) 
94180 FORMAT( 'ERROR: IRR_OUTPUT name ', I3, ' ', A16, ' duplicates',
     &               ' a species name' )
94200 FORMAT( 'ERROR: IRR_OUTPUT name ', I3, ' ', A16, ' duplicates',
     &               ' another DEFINEd name' )
94220 FORMAT( 'ERROR: Family in an IRR_OUTPUT operator contains a non-',
     &               'gas chemistry species' )
94230 FORMAT( '       Family name: ', A16 )
94240 FORMAT( 'ERROR: Invalid species name in an IRR_OUTPUT operator' )
94260 FORMAT( '       IRR_OUTPUT name ', I3, ': ', A16 )
94280 FORMAT( '       Invalid name: ', A16 ) 
94300 FORMAT( 'ERROR: Invalid CYCLE or RXNSUM name in an IRR_OUTPUT' )
94320 FORMAT( '       IRR_OUTPUT name ', I3, ': ', A16 )
94340 FORMAT( '       Invalid name: ', A16 )
94360 FORMAT( 'ERROR: Invalid reaction label for an IRR_OUTPUT' )
94380 FORMAT( '       IRR_OUTPUT name ', I3, ': ', A16 )
94400 FORMAT( '       Invalid reaction label: ', A16 ) 
94420 FORMAT( 'ERROR: Invalid operation type for IRR_OUTPUT' )
94440 FORMAT( '       IRR_OUTPUT name ', I3, ': ', A16 )
94460 FORMAT( '       Invalid operation name: ', A16 ) 
94480 FORMAT( 'ERROR: Invalid species name for IPR_OUTPUT operation' )
94500 FORMAT( '       Invalid name: ', A16 )
94560 FORMAT( 'ERROR: The total number of reactions in the IRR_OUTPUT',
     &               ' operation exceeds the maximum allowable of 500' )
94580 FORMAT( '       IRR_OUTPUT name ', I3, ': ', A16 )
94600 FORMAT( 'ERROR: The number of CYCLEs plus RXSUMs exceeds the',
     &               ' maximum allowable of 500' )
94610 FORMAT( 'ERROR: The number of reactions for IRRTYPE=FULL exceeds',
     &               ' the maximum allowable of 500' )
94620 FORMAT( 'ERROR: A species is listed more than once in a FAMILY' )
94640 FORMAT( '       FAMILY ', I3, ': ', A,'   SPECIES: ', A )
94650 FORMAT( 'ERROR: Inconsistent species units in FAMILY ', I3, ': ', A )
94652 FORMAT( '       SPECIES ', I3, ': ', A, '    UNITS: ', A )
94660 FORMAT( 'WARNING: The following cycles were defined but not used:' )
94680 FORMAT( '         CYCLE ', I3, ': ', A )
95700 FORMAT( 'WARNING: The following rxsums were defined but not used:' )
95720 FORMAT( '         RXSUM ', I3, ': ', A )
95740 FORMAT( 'STOPPING in ERRCHECK because of errors' )
95760 FORMAT( 'No input errors detected, continuing....' ) 
94800 FORMAT( 'ERROR: Maximum number of PA species exceeded' )
94820 FORMAT( '       Modify PARAMETER ( MAXIPRSPC =', I3,' ) or decrease',
     &              ' the number of PA species' )
94840 FORMAT( '       Error occurred while processing species option ',
     &               ' ALL' )

      END SUBROUTINE PA_ERRCHECK

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE GETCOEF( COEF )

C-----------------------------------------------------------------------
C Function: To get a coefficient from the input buffer
 
C Preconditions: None
  
C Key Subroutines/Functions Called: GETCHR
C                                   PA_GETREAL
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI's M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------

      USE UTILIO_DEFN, Only: M3MESG, M3EXIT, XSTAT2      ! IOAPI module
      USE PA_GLOBAL     ! Mech data used 
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
      
C Arguments:
      REAL    COEF        ! Returned coefficient
                                        
C Parameters: None

C External Functions: None

C Local Variables:
      INTEGER INTCHR            ! Integer ASCII code of a character
      LOGICAL LNEG              ! Flag for negative coefficient
      
C-----------------------------------------------------------------------
      COEF = 1.0
      LNEG = .FALSE.

      IF ( CHR .EQ. '+' .OR. CHR .EQ. '-' ) THEN
         IF ( CHR .EQ. '-' ) LNEG = .TRUE.
         CALL GETCHR
      END IF 

      INTCHR = ICHAR( CHR )

      IF ( ( INTCHR .GE. 48 .AND. INTCHR .LE. 57 ) .OR.
     &      CHR .EQ. '.' ) THEN
         CALL PA_GETREAL
         COEF = NUMBER
         IF ( CHR .EQ. '*' ) THEN
            CALL GETCHR
         ELSE
            WRITE( MSG, 94000 ) 
            CALL M3MESG( MSG )
            WRITE( MSG, 94500 ) LINNUM, INBUF
            CALL M3MESG( MSG )
            WRITE( MSG, 94520 ) CHR
            CALL M3MESG( MSG )
            CALL M3EXIT( 'GETCOEF', IZERO, IZERO, ' ', XSTAT2 )
         END IF
      END IF
      IF ( LNEG ) COEF = -COEF

      RETURN

C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( 'ERROR: An asterisk (*) must follow a coefficient' )
94500 FORMAT( '       Line No. ', I4, ': ', A )
94520 FORMAT( '       Character found: ', A )

      END SUBROUTINE GETCOEF

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      subroutine o3totcol ( latitude, longitude, jdate, jtime, ozone )

!----------------------------------------------------------------------
! Function:
!    This subroutine returns total column ozone [DU] for any lat, lon, and date,
!    by interpolating spacially and temporally between OMI/TOMS data in file
!    OMI.  The interpolation of ozone between lat, lon, and time is linear.
!    If missing data are encourntered (designated as -1.0 in OMI), the 
!    interpolation proceeds with available contiguous and conterminous data.
!
! Revision history:
!     Aug 11 J.Streicher: initial version
!     Dec 2013 S.Roselle: time-records adjusted to input file provided;
!                         improved logfile reporting
!     Jun 2015 J.Young: maintain code stnds
!----------------------------------------------------------------------

      use runtime_vars
      use utilio_defn

      implicit none

! arguments

      integer, intent( in ) :: jdate      ! Julian day of the year (yyyyddd)
      integer, intent( in ) :: jtime      ! time (hhmmss)

      real, intent( in )    :: latitude   ! latitude of point on earth's surface
      real, intent( in )    :: longitude  ! longitude of point on earth's surface
      real, intent( inout ) :: ozone      ! total column ozone [DU]

! parameters

       real,    parameter :: sec2day = 1.0 / 8.64E+4
! local variables

      character( 16 ), save :: tmfile = 'OMI'
      character( 16 ), save :: pname = 'O3TOTCOL'
      character( 96 ) :: xmsg = ' '
      character( 96 ) :: xmsgs( 3 )

      integer :: allocstat
      integer :: ilat
      integer :: ilon
      integer :: i
      integer :: icount
      integer :: ios
      integer :: nrecs
      integer :: jyear
      integer :: time

      integer, save :: nlat ! = 17 ! or 19
      integer, save :: nlon ! = 17
      integer, save :: nt
      integer, save :: it
      integer, save :: icolumn_prev = 1 
      integer, save :: icolumn_next = 2
      integer, save :: tmunit
      integer, save :: jdate_prev = 0
      integer, save :: jtime_prev = 0
      integer, save :: jstdate, jenddate, jtdate_temp

      real :: flag( 8 )
      real :: x2
      real :: x3
      real :: np_oz
      real :: sp_oz
      real :: total
      real :: latitudem
      real :: tdate_temp, tdate

      real, save :: x1
      real, save :: strdate, enddate
      real, save :: max_lat, min_lat

      real, allocatable, save :: t( : )
      real, allocatable, save :: lat( : )
      real, allocatable, save :: lon( : )
      real, allocatable, save :: oz( :, :, : ) ! two timesteps for interpolation

      logical, save :: firsttime = .true.

!----------------------------------------------------------------------

      if ( firsttime ) then
      
        firsttime = .false.

        tmunit = getefile( tmfile, .true., .true., pname )

        if ( tmunit .lt. 0 ) then
          xmsg = 'Error opening ' // tmfile
          call m3exit ( pname, jdate, 0, xmsg, xstat1 )
        end if

        read( tmunit, '(5x,i7)') nlat
        read( tmunit, '(5x,i7)') nlon

        write(logdev,'(a,i7,a,i7)')'OMI Ozone column data has Lat by Lon Resolution: ',
     &  nlat,'X',nlon

        allocate ( lat( nlat ), stat = allocstat )
        if ( allocstat .ne. 0 ) then
          xmsg = 'Failure allocating lat'
          call m3exit ( pname, jdate, 0, xmsg, xstat1 )
        end if

        allocate ( lon( nlon ), stat = allocstat )
        if ( allocstat .ne. 0 ) then
          xmsg = 'Failure allocating lon'
          call m3exit ( pname, jdate, 0, xmsg, xstat1 )
        end if
        
! Assign values to array of longitudes: lon
        x2 = 360.0 / real( nlon - 1 )
        do ilon = 1, nlon
          lon( ilon ) = -180.0 + x2 * real( ilon - 1 )
        end do

        nrecs = 0
        read( tmunit, * ) ! skip header record
        do
          read( tmunit, *, iostat=ios )
          if ( ios .ne. 0 ) exit
          nrecs = nrecs + 1
        end do
        if ( nrecs .gt. 0 ) nt = nrecs / nlat

        allocate ( t( nt ), stat = allocstat )
        if ( allocstat .ne. 0 ) then
          xmsg = 'Failure allocating T'
          call m3exit ( pname, jdate, 0, xmsg, xstat1 )
        end if

        allocate ( oz( nlat, nlon, 2 ), stat = allocstat )
        if ( allocstat .ne. 0 ) then
          xmsg = 'Failure allocating oz '
          call m3exit ( pname, jdate, 0, xmsg, xstat1 )
        end if

        rewind( tmunit )
        read( tmunit, * )
        read( tmunit, * )
        read( tmunit, * )

! When adding x lines of data to OMI.dat, increase upper limit by x
! Note: ilat(1) => North to South in degrees
! Note: ilon(1) = International Dateline (ID) = ilon(nlon); ilon(2)=> West of ID 

! Read in array of dates (format: yyyy.yyy)

        do it = 1, nt
          do ilat = 1, nlat
            read( tmunit,* ) t( it ), lat( ilat )
          end do
        end do

        max_lat = maxval( lat )
        min_lat = minval( lat )
        strdate  = minval( t )
        enddate = maxval( t )

      end if ! firsttime

      if ( jdate .ne. jdate_prev .or. jtime .ne. jtime_prev ) then
! Use a temporary dummy variable jdate_temp so as not to overwrite jdate
        jtime_prev = jtime

        jyear = jdate / 1000
        time  = mod(jtime, 100) + 60*mod(jtime/100, 100)+ 3600*(jtime/10000)

        tdate = real( jyear ) 
     &        + ( real( jdate - jyear * 1000 ) + real( time ) * sec2day ) * yr2day( jyear )

        tdate_temp = tdate

! Determine if the ozone database includes the requested jdate
           if ( tdate .ge. enddate ) then
! Submitted date is outside of ozone database range.
!     Total column ozone will be estimated from the corresponding Julian Day
!     of the prior year
             tdate_temp = aint( enddate ) + ( tdate - aint( tdate ) )
             if ( tdate_temp .gt. enddate ) then
               tdate_temp = tdate_temp - 1.0
             end if
             jenddate = int( enddate ) * 1000
     &                + int( ( 1.0 / yr2day( int( enddate ) ) )
     &                  * ( enddate - aint( enddate ) ) )
             jtdate_temp = int( tdate_temp ) * 1000
     &                   + nint( ( 1.0 / yr2day( int( tdate_temp ) ) )
     &                   * ( tdate_temp - aint( tdate_temp ) ) )
             if( jdate_prev .ne. jdate )then ! write message to log
                xmsg = 'Requested date is beyond available data on OMI file:  <' 
     &              // dt2str( jenddate, 0 )
                call m3warn ( pname, jdate, 0, xmsg )
                xmsgs( 1 ) = 'Total column ozone will be estimated from the corresponding Julian Day '
                xmsgs( 2 ) = 'of the last available year on the '
     &                    // 'OMI input file:' // dt2str( jtdate_temp, 0 ) // '<<---<<'
                write(xmsgs( 3 ),'(A,F14.8)')'Exact date: ',tdate_temp
                call m3parag ( 3, xmsgs )
             end if
           else if ( tdate .le. strdate ) then
! Submitted date is outside of ozone database range.
!     Total column ozone will be estimated from the corresponding Julian Day of
!     the subsequent year
             tdate_temp = real( int( strdate ) ) + ( tdate - real( int( tdate ) ) )
             if ( tdate_temp .lt. strdate ) then
               tdate_temp = tdate_temp + 1.0
             end if
             jstdate = int( strdate ) * 1000
     &               + int( ( 1.0 / yr2day( int( strdate ) ) )
     &               * ( strdate - aint( strdate ) ) )
             jtdate_temp = int( tdate_temp ) * 1000
     &                   + nint( ( 1.0 / yr2day( int( tdate_temp ) ) )
     &                   * ( tdate_temp - aint( tdate_temp ) ) )
             if( jdate_prev .ne. jdate )then ! write message to log
                xmsg = 'Requested date preceeds available data on OMI file:  >' 
     &              // dt2str( jstdate, 0 )
                call m3warn ( pname, jdate, 0, xmsg )
                xmsgs( 1 ) = 'Total column ozone will be estimated from the corresponding Julian Day'
                xmsgs( 2 ) = 'of the next available year on the OMI input file:'
     &                 // dt2str( jtdate_temp, 0 ) // '<<---<<'
                xmsgs( 3 ) = ' '
                call m3parag ( 3, xmsgs )
             end if

! Submitted date falls within the satellite data measurement gap beginning
!     on 24 Nov 1994 and ending on 22 Jul 1996.

           else if ( ( tdate .ge. 1994.899 ) .and. 
     &               ( tdate .le. 1996.557 ) ) then
        
             if ( tdate .le. 1995.738 ) then
               tdate_temp = tdate - 1.0  ! use previous year
             else
               tdate_temp = tdate + 1.0  ! use subsequent year
             end if
             jtdate_temp = int( tdate_temp ) * 1000
     &                + nint( ( 1.0 / yr2day( int( tdate_temp ) ) )
     &                 * ( tdate_temp - aint( tdate_temp ) ) )
             if( jdate_prev .ne. jdate )then ! write message to log
                xmsg = 'Requested date falls within satellite data'
     &              // ' measurement gap: 24 Nov 1994 - 22 Jul 1996'
                call m3warn ( pname, jdate, 0, xmsg )
                xmsgs( 1 ) = 'Total column ozone will be estimated from the corresponding Julian Day'
                xmsgs( 2 ) = 'of the closest available year on the OMI input file:'
     &                     // dt2str( jtdate_temp, 0 ) // '<<---<<'
                xmsgs( 3 ) = ' '
                call m3parag ( 3, xmsgs )
             end if
           else
             if( jdate_prev .ne. jdate )then ! write message to log
               xmsgs( 1 ) = 'Total column ozone will be interpolated to day '
     &                    // dt2str( jdate, 0 )
               xmsgs( 2 ) = 'from data available on the OMI input file'
               xmsgs( 3 ) = ' '
               call m3parag ( 3, xmsgs )
             end if  
           end if

        if( jdate_prev .ne. jdate )then ! need to update day interpolation points
           jdate_prev = jdate
           oz = 0.0

! When adding x lines of data to OMI.dat, increase upper limit by x
! and increase the dimension of t as needed

! Determine the specific dates in the database that bound the requested jdate
! i.e.  (it) < (jdate_temp) < (it+1)
! where it is the index var for the database
! and determine the interpolation factor ?x1? between the bounding dates
! reset oz and jdate_prev

           x1 = 0.0
           x1loop: do it = 1, nt-1
             if ( ( tdate_temp .ge. t( it ) ) .and. 
     &              ( tdate_temp .le. t( it+1 ) ) ) then
                icolumn_prev = it
                icolumn_next = it + 1
                exit x1loop
              end if
            end do x1loop
! Determine the corresponding bounding ozone values for all lats and lons
           rewind( tmunit )
           read( tmunit,* )
           read( tmunit,* )
           read( tmunit,* )
   
           do i = 1, it-1
             do ilat = 1, nlat
               read( tmunit,* )
             end do
           end do
   
           do ilat = 1, nlat
             read( tmunit,* ) t( it ), lat( ilat ), ( oz( ilat, ilon, 1 ), ilon=1,(nlon-1) )
             oz( ilat, nlon, 1 ) = oz( ilat, 1, 1 )
           end do
   
           do ilat = 1, nlat
             read( tmunit,* ) t( it+1 ), lat( ilat ), ( oz( ilat, ilon, 2 ), ilon=1,(nlon-1) )
             oz( ilat, nlon, 2 ) = oz( ilat, 1, 2 )
           end do
        end if 

        x1 = ( tdate_temp - t( icolumn_prev ) ) / ( t( icolumn_next ) - t( icolumn_prev ) )
   
      end if   ! jdate .ne. jdate_prev and jtime .ne. jday

      flag  = 0.0
      ozone = 0.0
      latitudem = 0.0
      x2 = 0.0
      x3 = 0.0

! Handle the special case of lat > max_lat or lat < min_lat.
! use a dummy latitude variable latitudem so as to prevent overwriting latitude

      if ( latitude .gt. max_lat ) then
        latitudem = max_lat
      else if ( latitude .lt. min_lat ) then
        latitudem = min_lat
      else
        latitudem = latitude
      end if

! Identify the database latitudes that bound the requested latitude
! Determine the proportionality x2

      x2loop: do ilat = 1, nlat-1
        if ( ( latitudem .le. lat( ilat ) ) .and. 
     &       ( latitudem .ge. lat( ilat+1 ) ) ) then
          x2 = ( latitudem - lat( ilat+1 ) ) / ( lat( ilat ) - lat( ilat+1 ) )
          exit x2loop
        end if
      end do x2loop

! Analogously determine the proportionality x3 fot longitude

      x3loop: do ilon = 1, nlon-1
        if ( ( longitude .ge. lon( ilon ) ) .and. 
     &       ( longitude .le. lon( ilon+1 ) ) ) then
          x3 = ( longitude - lon( ilon ) ) / ( lon( ilon+1 ) - lon( ilon ) )
          exit x3loop
        end if
      end do x3loop

      ozone = 0.0

! Determine the interpolated ozone, with consideration that some of the 8 ozone values
! of the data cube may be missing.  Construct the estimate from those values that are     ! available

      flag = 1.0

      if ( oz( ilat, ilon+1, 2 ) .le. 0.0 ) then
        oz( ilat, ilon+1, 2 ) = 0.0
        flag( 1 ) = 0.0
      else
        flag( 1 ) = x1 * x2 * x3
      end if

      if ( oz( ilat, ilon, 2 ) .le. 0.0 ) then
        oz( ilat, ilon, 2 ) = 0.0
        flag( 2 ) = 0.0
      else
        flag( 2 ) = x1 * x2 * ( 1.0 - x3 )
      end if

      if ( oz( ilat+1, ilon+1, 2 ) .le. 0.0 ) then
        oz( ilat+1, ilon+1, 2 ) = 0.0
        flag( 3 ) = 0.0
      else
        flag( 3 ) = x1 * ( 1.0 - x2 ) * x3
      end if

      if ( oz( ilat+1, ilon, 2 ) .le. 0.0 ) then
        oz( ilat+1, ilon, 2 ) = 0.0
        flag( 4 ) = 0.0
      else
        flag( 4 ) = x1 * ( 1.0 - x2 ) * ( 1.0 - x3 )
      end if

      if ( oz( ilat, ilon+1, 1 ) .le. 0.0 ) then
        oz( ilat, ilon+1, 1 ) = 0.0
        flag( 5 ) = 0.0
      else
        flag( 5 ) = ( 1.0 - x1 ) * x2 * x3
      end if

      if ( oz( ilat, ilon, 1 ) .le. 0.0 ) then
        oz( ilat, ilon, 1 ) = 0.0
        flag( 6 ) = 0.0
      else
        flag( 6 ) = ( 1.0 - x1 ) * x2 * ( 1.0 - x3 )
      end if

      if ( oz( ilat+1, ilon+1, 1 ) .le. 0.0 ) then
        oz( ilat+1, ilon+1, 1 ) = 0.0
        flag( 7 ) = 0.0
      else
        flag( 7 ) = ( 1.0 - x1 ) * ( 1.0 - x2 ) * x3
      end if

      if ( oz( ilat+1, ilon, 1 ) .le. 0.0 ) then
        oz( ilat+1, ilon, 1 ) = 0.0
        flag( 8 ) = 0.0
      else
        flag( 8 ) = ( 1.0 - x1 ) * ( 1.0 - x2 ) * ( 1.0 - x3 )
      end if

      ozone = (     x1 ) * (     x2 ) * (     x3 ) * oz( ilat  , ilon+1, 2 )
     &       +(     x1 ) * (     x2 ) * ( 1.0-x3 ) * oz( ilat  , ilon  , 2 )
     &       +(     x1 ) * ( 1.0-x2 ) * (     x3 ) * oz( ilat+1, ilon+1, 2 )
     &       +(     x1 ) * ( 1.0-x2 ) * ( 1.0-x3 ) * oz( ilat+1, ilon  , 2 )
     &       +( 1.0-x1 ) * (     x2 ) * (     x3 ) * oz( ilat  , ilon+1, 1 )
     &       +( 1.0-x1 ) * (     x2 ) * ( 1.0-x3 ) * oz( ilat  , ilon  , 1 )
     &       +( 1.0-x1 ) * ( 1.0-x2 ) * (     x3 ) * oz( ilat+1, ilon+1, 1 )
     &       +( 1.0-x1 ) * ( 1.0-x2 ) * ( 1.0-x3 ) * oz( ilat+1, ilon  , 1 )

      total = sum( flag )

! Special case of min_lat > lat or lat > max_lat

      if ( latitude .ge. max_lat ) then

        np_oz = 0.0
        icount = 0

        do ilon = 1, nlon
          if ( ( ( oz( 1, ilon, 1 ) ) .le. 0.0 ) .or. 
     &         ( ( oz( 1, ilon, 2 ) ) .le. 0.0 ) ) then
            cycle
          else
            icount = icount + 1
            np_oz = np_oz + ( ( 1.0 - x1 ) * oz( 1, ilon, 1 )
     &                      +         x1   * oz( 1, ilon, 2 ) )
          end if
        end do

        if ( icount .eq. 0 ) then
          go to 899
        end if

        np_oz = np_oz / real( icount )

      else if ( latitude .le. min_lat ) then

        sp_oz = 0.0
        icount = 0

        do ilon = 1, nlon
          if ( ( ( oz( nlat, ilon, 1 ) ) .le. 0.0 ) .or. 
     &         ( ( oz( nlat, ilon, 2 ) ) .le. 0.0 ) ) then
            cycle
          else
            icount = icount + 1
            sp_oz = sp_oz + ( ( 1.0 - x1 ) * oz( nlat, ilon, 1 )
     &                    +           x1   * oz( nlat, ilon, 2 ) )
          end if
        end do

        if ( icount .eq. 0 ) then
          go to 899
        end if

        sp_oz = sp_oz / real( icount )

      end if    ! Special case of abs(lat) > 80 is complete

! When no contiguous and conterminous data are available, default to 300 DU:

      if ( total .le. 0.0 ) then
        ozone = 300.0
      else
        if ( latitude .ge. max_lat ) then
          np_oz = np_oz / total
          ozone = ( ( latitude - max_lat ) * 0.1 ) * np_oz
     &          + ( 1.0 - ( ( ( latitude - max_lat ) * 0.1 ) ) ) * ozone / total
        
        else if ( latitude .le. min_lat ) then
          sp_oz = sp_oz / total
          ozone = ( ( latitude - min_lat ) * 0.1 ) * sp_oz
     &          + ( 1.0 - ( ( ( latitude - min_lat ) * 0.1 ) ) ) * ozone / total
        
        else
          ozone = ozone / total
        end if
      end if

899   if ( ozone .lt. 100.0 ) then
        ozone = 100.0
!        xmsg = 'interpolated ozone column below 100 DU'
!        write(logdev,'(A,20(F10.4,1X))')'For time:',tdate_temp
!        write(logdev,'(A,20(F10.4,1X))')'At lat,lon:',latitude,longitude
!        write(logdev,'(A,20(F10.4,1X))')'Intepolated data'
!        write(logdev,'(A,20(F10.4,1X))')'Time Point 1',
!     &       t( icolumn_prev ),lat( ilat ),lat( ilat+1 ),lon( ilon),lon( ilon+1 ),
!     &       oz( ilat,   ilon+1, 1 ), oz( ilat  , ilon  , 1 ), 
!     &       oz( ilat+1, ilon+1, 1 ), oz( ilat+1, ilon  , 1 )
!        write(logdev,'(A,20(F10.4,1X))')'Time Point 2',
!     &       t( icolumn_next ),lat( ilat ),lat( ilat+1 ),lon( ilon),lon( ilon+1 ),
!     &       oz( ilat,   ilon+1, 2 ), oz( ilat  , ilon  , 2 ), 
!     &       oz( ilat+1, ilon+1, 2 ), oz( ilat+1, ilon  , 2 )
!        write(logdev,'(A,20(F10.4,1X))')'Weights, x1, x2,x3: ',x1, x2,x3
!        CALL M3EXIT( 'o3totcol', JDATE, JTIME, XMSG, XSTAT1 )
      else if ( ozone .gt. 800.0 ) then
!        xmsg = 'interpolated ozone column above 800 DU'
!        write(logdev,'(A,20(F10.4,1X))')'For time:',tdate_temp
!        write(logdev,'(A,20(F10.4,1X))')'At lat,lon:',latitude,longitude
!        write(logdev,'(A,20(F10.4,1X))')'Intepolated data'
!        write(logdev,'(A,20(F10.4,1X))')'Time Point 1',
!     &       t( icolumn_prev ),lat( ilat ),lat( ilat+1 ),lon( ilon),lon( ilon+1 ),
!     &       oz( ilat,   ilon+1, 1 ), oz( ilat  , ilon  , 1 ), 
!     &       oz( ilat+1, ilon+1, 1 ), oz( ilat+1, ilon  , 1 )
!        write(logdev,'(A,20(F10.4,1X))')'Time Point 2',
!     &       t( icolumn_next ),lat( ilat ),lat( ilat+1 ),lon( ilon),lon( ilon+1 ),
!     &       oz( ilat,   ilon+1, 2 ), oz( ilat  , ilon  , 2 ), 
!     &       oz( ilat+1, ilon+1, 2 ), oz( ilat+1, ilon  , 2 )
!        write(logdev,'(A,20(F10.4,1X))')'Weights, x1, x2,x3: ',x1, x2,x3
!        CALL M3EXIT( 'o3totcol', JDATE, JTIME, XMSG, XSTAT1 )
        ozone = 800.0
      end if

      return

      end subroutine o3totcol

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE DEGRADE_PARAMETERS
C**********************************************************************
C
C  FUNCTION:  Define arrays that identify species within CGRID used
C             based on input arrays
C
C  REVISION HISTORY: 07/29/05 : B.Hutzell - Initial version
C                    06 May 11: B.Hutzell: convert for Namelist redesign
C                    09 May 11: B.Hutzell: enabled a degraded species to
C                               be missing from namelists
C
C**********************************************************************

      IMPLICIT NONE

C.....INCLUDES:


C..declare and define variables used by maps and data

      INTEGER, PARAMETER :: N_REACT       = 38   ! number of  species being degraded
      INTEGER, PARAMETER :: N_UNI_LOSS    = 1     ! Number of Unimolecular Loss Processes
      INTEGER, PARAMETER :: N_BI_LOSS     = 5     ! Number of Bimolcular Loss processes
      INTEGER, PARAMETER :: N_TRI_LOSS    = 2     ! Number of Bimolcular Loss processes
      INTEGER, PARAMETER :: N_PHOTO_LOSS  = 5     ! Number of Photolysis Loss processes
      INTEGER, PARAMETER :: N_LANHIN_LOSS = 1     ! Number of Langmuir-Hinshelwood Loss Processes

! Total number of Loss processes      
      INTEGER, PARAMETER :: N_PROCESSES  = N_UNI_LOSS
     &                                   + N_BI_LOSS
     &                                   + N_PHOTO_LOSS
     &                                   + N_TRI_LOSS
     &                                   + N_LANHIN_LOSS

      CHARACTER(16), PARAMETER :: BLANK = ' '  ! default value for characters

      INTEGER, SAVE :: N_PHOTO_TAB    ! Number of photolysis rates in mechanism
      INTEGER, SAVE :: N_REACT_FOUND  ! Number ofreact species found in namelists

C..looping data

      INTEGER :: UNI_START
      INTEGER :: BI_START
      INTEGER :: TRI_START
      INTEGER :: PHOTO_START
      INTEGER :: LANHIN_START

      INTEGER :: UNI_STOP
      INTEGER :: BI_STOP
      INTEGER :: TRI_STOP
      INTEGER :: PHOTO_STOP
      INTEGER :: LANHIN_STOP

      CHARACTER(16), ALLOCATABLE :: REACT( : )         ! names of species being degraded
      CHARACTER(16), ALLOCATABLE :: BICAUSE( :,: )     ! species name that cause degradation
      CHARACTER(16), ALLOCATABLE :: LHCAUSE( :,: )     ! species name that cause degradation
      CHARACTER(16), ALLOCATABLE :: TRICAUSE( :,:,: )  ! species name that cause degradation
      CHARACTER(16), ALLOCATABLE :: PHOTO_NAME( :,: )  ! name of photolysis rate for react(i)

      CHARACTER(16), ALLOCATABLE :: BI_PROD   ( :,: )  ! name of daughter product for react(i)
      CHARACTER(16), ALLOCATABLE :: TRI_PROD  ( :,: )  ! name of daughter product for react(i)
      CHARACTER(16), ALLOCATABLE :: PHOTO_PROD( :,: )  ! name of daughter product for react(i)
      CHARACTER(16), ALLOCATABLE :: UNI_PROD  ( :,: )  ! name of daughter product for react(i)
      CHARACTER(16), ALLOCATABLE :: LH_PROD  ( :,: )   ! name of daughter product for react(i)

      REAL(8), ALLOCATABLE :: UNIRATE  ( :,: ) ! rate for unimolecular decay for react(i) [molecules/sec^1]
      REAL(8), ALLOCATABLE :: UNI_ACT  ( :,: ) ! activation energy for UNIRATE(I) [K]. Positive if exothermic
      REAL(8), ALLOCATABLE :: UNI_TEXP ( :,: ) ! exponent of Temperature
      REAL,    ALLOCATABLE :: UNI_YIELD( :,: ) ! production yield

      REAL(8), ALLOCATABLE :: BIRATE  ( :,: )  ! degradation rates for bimolecular reactions,  [cm^3/(sec*molecules)]
      REAL(8), ALLOCATABLE :: BI_ACT  ( :,: )  ! activation energy for BIRATE(I) [K]. Positive if exothermic
      REAL(8), ALLOCATABLE :: BI_TEXP ( :,: )  ! exponent of Temperature
      REAL,    ALLOCATABLE :: BI_YIELD( :,: )  ! production yield

      REAL(8), ALLOCATABLE :: TRIRATE  ( :,: ) ! degradation rates for trimolecular reactions,  [cm^3/(sec*molecules)]
      REAL(8), ALLOCATABLE :: TRI_ACT  ( :,: ) ! activation energy for TRIRATE(I) [K]. Positive if exothermic
      REAL(8), ALLOCATABLE :: TRI_TEXP ( :,: ) ! exponent of Temperature
      REAL,    ALLOCATABLE :: TRI_YIELD( :,: ) ! production yield

      REAL(8), ALLOCATABLE :: A_PHOTO    ( :,: ) ! multiplier of photolysis rates
      REAL,    ALLOCATABLE :: PHOTO_YIELD( :,: ) ! production yield

! Heterogeneous loss of aerosol species with Relative Humidity and Temperature cut-off. It uses an
! Langmuir-Hinshelwood isotherm to calculate the rate 
      REAL(8), ALLOCATABLE :: LHRATE  ( :,: )  ! degradation rates for Langmuir-Hinshelwood reactions,  [1/sec]
      REAL(8), ALLOCATABLE :: LH_EQU  ( :,: )  ! reactant adsorption and diffusion equilibruim constant, [cm^3/molecules]
      REAL,    ALLOCATABLE :: LH_YIELD( :,: )  ! production yield
      REAL,    ALLOCATABLE :: LH_RHMIN( :,: )  ! Minimum Relative Humidity for nonzero rate [fractional]
      REAL,    ALLOCATABLE :: LH_TAMIN( :,: )  ! Minimum Air temperature for nonzero rate   [K]
      
      INTEGER :: NDEGRADED_FOUND = 0
      CHARACTER( 16 ), ALLOCATABLE :: DEGRADED_SPECIES( : )

C**********************************************************************
      CONTAINS
      
         SUBROUTINE DEGRADE_DATA()
C**********************************************************************
C
C  FUNCTION:  Allocate arrays and define data used by degradation routines
C
C    react(i) does not need the maximum number of causes for degradation.
C    Set "un-used" causes to "' '".
C
C    Note, OH and HO both refer to hydroxyl concentrations. The redundancy exists because
C    current mechanisms for gas chemistry use OH or HO to refer to the radical.
C
C  CALLED BY: INIT_DEGRADE
C
C  REVISION HISTORY: : 07/29/05 : B.Hutzell - Initial version
C                      10/23/07 : B.Hutzell - added CL reactions for specific HAPs
C                      04/14/08 : B.Hutzell - Removed Benzene for AERO5 module
C                      08/31/11 : B.Hutzell - Removed removed capabilities with previous 
C                                             HAPs mechanisms
C**********************************************************************

            USE CGRID_SPCS           ! CGRID species number and offsets
            USE RXNS_DATA,  ONLY: MECHNAME
            
            IMPLICIT NONE
            
            LOGICAL, SAVE :: INITIALIZED = .FALSE.

            INTEGER :: MARKER, N, M       ! indexes
            INTEGER :: I, J, K, L         ! loop counters
            
            INTEGER, ALLOCATABLE :: INDEX_FOUND( : )

C**********************************************************************

            IF( INITIALIZED )RETURN
      
            INITIALIZED = .TRUE.

C..looping data

            UNI_START    = 1
            BI_START     = UNI_START + N_UNI_LOSS
            TRI_START    = BI_START  + N_BI_LOSS
            PHOTO_START  = TRI_START + N_TRI_LOSS
            LANHIN_START = PHOTO_START + N_PHOTO_LOSS
            
            UNI_STOP    = BI_START     - 1
            BI_STOP     = TRI_START    - 1
            TRI_STOP    = PHOTO_START  - 1
            PHOTO_STOP  = LANHIN_START - 1
            LANHIN_STOP = N_PROCESSES
            
            ALLOCATE( REACT     ( N_REACT ) )                 ! names of species being degraded
            ALLOCATE( BICAUSE   ( N_BI_LOSS, N_REACT ) )      ! species name that cause degradation
            ALLOCATE( TRICAUSE  ( 2, N_TRI_LOSS, N_REACT ) )  ! species name that cause degradation
            ALLOCATE( PHOTO_NAME( N_PHOTO_LOSS, N_REACT ) )   ! name of photolysis rate for react(i)
            ALLOCATE( LHCAUSE   ( N_LANHIN_LOSS, N_REACT ) )  ! species name that cause degradation
            
            ALLOCATE( UNIRATE  ( N_UNI_LOSS, N_REACT ) )  ! rate for unimolecular decay for react(i) [molecules/sec^1]
            ALLOCATE( UNI_ACT  ( N_UNI_LOSS, N_REACT ) )  ! activation energy for UNIRATE(I) [K]. Positive if exothermic
            ALLOCATE( UNI_TEXP ( N_UNI_LOSS, N_REACT ) )  ! exponent of Temperature and UNIRATE(I) factored by (1/298)**UNI_TEXP
            ALLOCATE( UNI_PROD ( N_UNI_LOSS, N_REACT ) )  ! name of daughter product for react(i)
            ALLOCATE( UNI_YIELD( N_UNI_LOSS, N_REACT ) )  ! yield of daughter product for react(i)
            
            ALLOCATE( BIRATE  ( N_BI_LOSS, N_REACT ) )  ! degradation rates for bimolecular reactions,  [cm^3/(sec*molecules)]
            ALLOCATE( BI_ACT  ( N_BI_LOSS, N_REACT ) )  ! activation energy for BIRATE(I) [K]. Positive if exothermic
            ALLOCATE( BI_TEXP ( N_BI_LOSS, N_REACT ) )  ! exponent of Temperature and BIRATE(I) factored by (1/298)**BI_TEXP
            ALLOCATE( BI_PROD ( N_BI_LOSS, N_REACT ) )  ! name of daughter product for react(i)
            ALLOCATE( BI_YIELD( N_BI_LOSS, N_REACT ) )  ! yield of daughter product for react(i)
            
            ALLOCATE( TRIRATE  ( N_TRI_LOSS, N_REACT ) )  ! degradation rates for trimolecular reactions,  [cm^3/(sec*molecules)]
            ALLOCATE( TRI_ACT  ( N_TRI_LOSS, N_REACT ) )  ! activation energy for TRIRATE(I) [K]. Positive if exothermic
            ALLOCATE( TRI_TEXP ( N_TRI_LOSS, N_REACT ) )  ! exponent of Temperature and TRIRATE(I) factored by (1/298)**TRI_TEXP
            ALLOCATE( TRI_PROD ( N_TRI_LOSS, N_REACT ) )  ! name of daughter product for react(i)
            ALLOCATE( TRI_YIELD( N_TRI_LOSS, N_REACT ) )  ! yield of daughter product for react(i)
            
            ALLOCATE( A_PHOTO    ( N_PHOTO_LOSS, N_REACT ) )  ! multiplier of photolysis rates
            ALLOCATE( PHOTO_PROD ( N_PHOTO_LOSS, N_REACT  ) )  ! name of daughter product for react(i)
            ALLOCATE( PHOTO_YIELD( N_PHOTO_LOSS, N_REACT  ) )  ! yield of daughter product for react(i)
            
            
            ALLOCATE( LHRATE  ( N_LANHIN_LOSS, N_REACT ) )  
            ALLOCATE( LH_EQU  ( N_LANHIN_LOSS, N_REACT ) )  
            ALLOCATE( LH_PROD ( N_LANHIN_LOSS, N_REACT ) )  
            ALLOCATE( LH_YIELD( N_LANHIN_LOSS, N_REACT ) )  
            ALLOCATE( LH_RHMIN( N_LANHIN_LOSS, N_REACT ) )
            ALLOCATE( LH_TAMIN( N_LANHIN_LOSS, N_REACT ) )
                        

            ALLOCATE( INDEX_FOUND( N_REACT ) )
            
            INDEX_FOUND = -1 
            REACT       = BLANK
            PHOTO_NAME  = BLANK
            BICAUSE     = BLANK
            TRICAUSE    = BLANK
            LHCAUSE     = BLANK
            
            UNI_ACT   = 0.0D0
            UNIRATE   = 0.0D0
            UNI_TEXP  = 0.0D0
            UNI_YIELD = 0.0
            
            BI_ACT   = 0.0D0
            BIRATE   = 0.0D0
            BI_TEXP  = 0.0D0
            BI_YIELD = 0.0
            
            TRI_ACT   = 0.0D0
            TRIRATE   = 0.0D0
            TRI_TEXP  = 0.0D0
            TRI_YIELD = 0.0
            
            A_PHOTO     = 0.0D0
            PHOTO_YIELD = 0.0
            
            LH_EQU   = 0.0D0
            LHRATE   = 0.0D0
            LH_YIELD = 0.0
            LH_RHMIN = 0.0
            LH_TAMIN = 0.0
            
! product are unused aspect and results not returned cgrid 
            UNI_PROD   = BLANK
            BI_PROD    = BLANK
            TRI_PROD   = BLANK
            PHOTO_PROD = BLANK
            LH_PROD    = BLANK


C..toxic VOC's

C.. ACRYLONITRILE

            REACT(1)       = 'ACRY_NITRILE'
            BICAUSE(1:5,1) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,1)  = (/ 4.8D-12, 4.8D-12, 1.9D-19, 6.3D-18, 5.2D-14/)
            BI_ACT(1:5,1)  = (/   0.0D0,   0.0D0, 0.0D0, 0.0D0, -1.4D+3/)

C.. CARBON TETRACHLORIDE

            REACT(2)       = 'CARBONTET'
            BICAUSE(1:5,2) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,2)  = (/ 1.0D-12, 1.0D-12, 0.0D0, 0.0D0, 9.55D-11/)
            BI_ACT(1:5,2)  = (/2300.0D0,2300.0D0, 0.0D0, 0.0D0, 7.80D+03/)

C.. PROPYLENE DICHLORIDE

            REACT(3)       = 'PROPYL_DICL'
            BICAUSE(1:5,3) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,3)  = (/ 2.2D-13, 2.2D-13, 0.0D0, 0.0D0, 1.1D-11/)
            BI_ACT(1:5,3)  = (/   0.0D0,   0.0D0, 0.0D0, 0.0D0, 0.0D0/)

C.. DICHLORIPROPENE

            REACT(4)       = 'DICL_PROPENE'
            BICAUSE(1:4,4) = (/'OH ','HO ','O3 ','NO3'/)
            BIRATE(1:4,4)  = (/1.04D-11, 1.04D-11, 4.10D-19, 0.0D0/)
            BI_ACT(1:4,4)  = (/   0.0D0,    0.0D0, 0.0D0, 0.0D0/)

C.. 1,1,2,2TETRACHLOROETHANE

            REACT(5)       = 'CL4_ETHANE'
            BICAUSE(1:5,5) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,5)  = (/2.46D-13, 2.46D-13, 0.0D0, 0.0D0, 1.91D-13/)
            BI_ACT(1:5,5)  = (/   0.0D0,    0.0D0, 0.0D0, 0.0D0, 0.00D0/)

C.. CHLOROFORM

            REACT(6)       = 'CHCL3'
            BICAUSE(1:5,6) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,6)  = (/6.30D-18, 6.30D-18, 0.0D0, 0.0D0, 4.9D-12/)
            BI_ACT(1:5,6)  = (/  504.D0,   504.D0, 0.0D0, 0.0D0, 1.24D+3/)
            BI_TEXP(1:2,6) = (/   2.0D0,    2.0D0/)

C.. 1,2DIBROMOETHANE

            REACT(7)       = 'BR2_C2_12'
            BICAUSE(1:4,7) = (/'OH ','HO ','O3 ','NO3'/)
            BIRATE(1:4,7)  = (/1.03D-17, 1.03D-17, 0.0D0, 0.0D0/)
            BI_ACT(1:4,7)  = (/  422.D0,   422.D0, 0.0D0, 0.0D0/)
            BI_TEXP(1:2,7) = (/   2.0D0,    2.0D0/)

C.. 1,2DICHLOROTHANE

            REACT(8)       = 'CL2_C2_12'
            BICAUSE(1:5,8) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,8)  = (/1.10D-17, 1.10D-17, 0.0D0, 0.0D0, 4.93D-11/)
            BI_ACT(1:5,8)  = (/  409.D0,   409.D0, 0.0D0, 0.0D0, 1.09D+3/)
            BI_TEXP(1:2,8) = (/   2.0D0,    2.0D0/)

C.. ETHYLENE OXIDE

            REACT(9)       = 'ETOX'
            BICAUSE(1:5,9) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,9)  = (/7.60D-14, 7.60D-14, 0.0D0, 0.0D0, 5.0D-12/)
            BI_ACT(1:5,9)  = (/   0.0D0,    0.0D0, 0.0D0, 0.0D0, 0.0D0/)

C.. METHYLENE CHLORIDE

            REACT(10)       = 'CL2_ME'
            BICAUSE(1:5,10) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,10)  = (/8.54D-18, 8.54D-18, 0.0D0, 0.0D0, 2.81D-11/)
            BI_ACT(1:5,10)  = (/  500.D0,   500.D0, 0.0D0, 0.0D0, 1.3D+3/)
            BI_TEXP(1:2,10) = (/   2.0D0,    2.0D0/)

C.. PERCHLOROETHYLENE

            REACT(11)       = 'CL4_ETHE'
            BICAUSE(1:5,11) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,11)  = (/9.64D-12, 9.64D-12, 0.0D0, 0.0D0, 3.72D-8/)
            BI_ACT(1:5,11)  = (/ 1209.D0,  1209.D0, 0.0D0, 0.0D0, 0.0D0/)
            BI_TEXP(1:5,11) = (/   0.0D0,    0.0D0, 0.0D0, 0.0D0,-1.2D0/)

C.. TRICHLOROETHYLENE

            REACT(12)       = 'CL3_ETHE'
            BICAUSE(1:5,12) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,12)  = (/5.63D-13, 5.63D-13, 0.0D0, 0.0D0, 8.07D-11/)
            BI_ACT(1:5,12)  = (/ -427.D0,  -427.D0, 0.0D0, 0.0D0, 0.0D0/)

C.. VINYL CHLORIDE

            REACT(13)       = 'CL_ETHE'
            BICAUSE(1:5,13) = (/'OH ','HO ','O3 ','NO3', 'CL '/)
            BIRATE(1:5,13)  = (/1.69D-12, 1.69D-12, 0.0D0,1.84D-13, 1.27D-10/)
            BI_ACT(1:5,13)  = (/ -422.D0,  -422.D0, 0.0D0, 1764.D0, 0.0D0/)

C.. NAPHTHALENE

            REACT(14)       = 'NAPHTHALENE'
            BICAUSE(1:3,14) = (/'OH ','HO ','O3 '/)
            BIRATE(1:3,14)  = (/1.05D-12, 1.05D-12, 2.01D-19/)
            BI_ACT(1:3,14)  = (/ -901.D0,  -901.D0,    0.0D0/)
            TRICAUSE(1:2,1,14) = (/'NO3 ','NO2 '/)
            TRIRATE( 1,14)     =  3.94D-34
            TRI_ACT( 1,14)     = -4.10D+03

C.. QUINOLINE

            REACT(15)       = 'QUINOLINE'
            BICAUSE(1:4,15) = (/'OH ','HO ','O3 ','NO2'/)
            BIRATE(1:4,15)  = (/1.16D-11, 1.16D-11, 1.00D-19, 1.60D-20/)

C.. HEXAMETHYLENE DIISOCAYNATE

            REACT(16)       = 'HEXMETH_DIS'
            BICAUSE(1:2,16) = (/'OH ','HO '/)
            BIRATE(1:2,16)  = (/7.94D-12, 7.94D-12/)

C.. HYDRAZINE

            REACT(17)       = 'HYDRAZINE'
            BICAUSE(1:3,17) = (/'OH ','HO ','O3 '/)
            BIRATE(1:3,17)  = (/3.60D-11, 3.60D-11, 3.00D-17/)

C.. MALEIC ANHYDRIDE

            REACT(18)       = 'MAL_ANHYDRID'
            BICAUSE(1:3,18) = (/'OH  ','HO  ','NO3 '/)
            BIRATE(1:3,18)  = (/1.45D-12, 1.45D-12, 1.02D-13/)

C.. TOULENE DIISOCYANATE 

            REACT(19)       = 'TOL_DIIS'
            BICAUSE(1:2,19) = (/'OH ','HO '/)
            BIRATE(1:2,19)  = (/7.41D-12, 7.41D-12/)

C.. TRIETHYLAMINE

            REACT(20)       = 'TRIETHYLAMIN'
            BICAUSE(1:5,20) = (/'OH  ','HO  ','O   ','O3P ', 'O3  '/)
            BIRATE(1:5,20)  = (/3.60D-11, 3.60D-11, 1.09D-11, 1.09D-11, 7.84D-18/)

C.. P-DICHLOROBENZENE 

            REACT(21)       = 'DICL_BENZENE'
            BICAUSE(1:2,21) = (/'OH ','HO '/)
            BIRATE(1:2,21)  = (/3.60D-13, 3.60D-13/)

C.. XYLENE

            REACT(22)       = 'XYLENE         '
            BICAUSE(1:3,22) = (/'OH','HO','CL'/)
            BIRATE(1:3,22)  = (/1.717D-11, 1.717D-11, 1.433D-10/)

C.. STYRENE

            REACT(23)       = 'STYRENE        '
            BICAUSE(1:5,23) = (/'OH ','HO ','NO3','O3 ','CL '/)
            BIRATE(1:5,23)  = (/1.02D-11, 1.02D-11, 1.51D-13, 1.4D-17, 3.6D-10/)
            BI_ACT(1:2,23)  = (/    -532.0D0,   -532.0D0/)

C.. ACETONITRILE

            REACT(24)       = 'ACET_NITRILE   '
            BICAUSE(1:3,24) = (/'OH','HO','CL'/)
            BIRATE(1:3,24)  = (/          8.31D-13,          8.31D-13,          1.60D-11/)
            BI_ACT(1:3,24)  = (/          1080.0D0,          1080.0D0,          2140.0D0/)

C.. ACRYACID

            REACT(25)       = 'ACRYACID       '
            BICAUSE(1:4,25) = (/'OH','HO','O3','CL'/)
            BIRATE(1:4,25)  = (/1.75D-11, 1.75D-11, 6.50D-19, 4.00D-10/)

C.. HEXANE 
 
            REACT(26)       = 'HEXANE         '
            BICAUSE(1:3,26) = (/'OH','HO','CL'/)
            BIRATE(1:3,26)  = (/          1.98D-11,          1.91D-11,          3.30D-10/)
            BI_ACT(1:2,26)  = (/           394.0D0,           394.0D0/)

C.. METHCHLORIDE
 
            REACT(27)       = 'METHCHLORIDE   '
            BICAUSE(1:3,27) = (/'OH','HO','CL'/)
            BIRATE(1:3,27)  = (/          2.10D-12,          2.10D-12,          1.80D-11/)
            BI_ACT(1:3,27)  = (/          1210.0D0,          1210.0D0,            1081D0/)

C.. CARBSULFIDE

            REACT(28)       = 'CARBSULFIDE    '
            BICAUSE(1:3,28) = (/'OH','HO','O3'/)
            BIRATE(1:3,28)  = (/          1.10D-13,          1.10D-13,           3.01D-16/)
            BI_ACT(1:2,28)  = (/          1200.0D0,          1200.0D0/)

C.. CHLOROPRENE

           REACT(29)       = 'CHLOROPRENE    '
           BICAUSE(1:5,29) = (/'OH ','HO ','O3 ','NO3','CL '/)
           BIRATE(1:5,29)  = (/          6.20D-11,          6.20D-11,          1.40D-16,
     &                                   3.60D-13,          3.62D-10/)

C.. ETHYLBENZENE

           REACT(30)       = 'ETHYLBENZENE   '
           BICAUSE(1:4,30) = (/'OH ','HO ','NO3','CL '/)
           BIRATE(1:4,30)  = (/ 7.00D-12, 7.00D-12, 5.70D-16, 1.15D-10/)

C.. BENZO[A]PYRENE    

           REACT(31)       = 'BENAPY         '
           BICAUSE(1:2,31) = (/'OH ','HO '/)
           BIRATE(1:2,31)  = (/ 5.00D-11,   5.00D-11/)

C.. BENZO[A]PYRENE, accumulation mode

           REACT(32)       = 'ABENAPYJ       '
           LHCAUSE(1,32) = 'O3 '
!           LHRATE(1,32)  =  5.40D-02  ! average between 0% and 70%  Rel. Hum. Points in Owususa et al. (2004)
!           LH_EQU(32)  =  2.00D-15    ! average between 0% and 70%  Rel. Hum. Points in Owususa et al. (2004)
           LHRATE(1,32)  = 3.10D-02   ! average between 50% and 70% Rel. Hum. Points in Zhou et al. (2013) for organic shell around NH4SO4 core
           LH_EQU(1,32)  = 10.1D-15   ! average between 50% and 70% Rel. Hum. Points in Zhou et al. (2013) for organic shell around NH4SO4 core
           LH_TAMIN(1,32)  =  275.15  ! based on New-Shield BaP heteorogeneous oxidation treatment in Shrivastava et al. (2017)
           LH_RHMIN(1,32)  =  0.50    ! based on New-Shield BaP heteorogeneous oxidation treatment in Shrivastava et al. (2017)

C.. BENZO[A]PYRENE, Aitken mode

           REACT(33)       = 'ABENAPYI       '
           LHCAUSE(1,33) = 'O3 '
!           LHRATE(1,33)  = 5.40D-02 ! average between 0% and 70% Rel. Hum. Points in Owususa et al. (2004)
!           LH_EQU(1,33)  = 2.00D-15 ! average between 0% and 70% Rel. Hum. Points in Owususa et al. (2004)
           LHRATE(1,33)  = 3.10D-02  ! average between 50% and 70% Rel. Hum. Points in Zhou et al. (2013)
           LH_EQU(1,33)  = 10.1D-15  ! average between 50% and 70% Rel. Hum. Points in Zhou et al. (2013)
           LH_TAMIN(1,33)  =  275.15 ! based on New-Shield BaP heteorogeneous oxidation treatment in Shrivastava et al. (2017)
           LH_RHMIN(1,33)  =  0.50   ! based on New-Shield BaP heteorogeneous oxidation treatment in Shrivastava et al. (2017)

C.. CARBON TETRACHLORIDE without boundary conditions

            REACT(34)       = 'CARB_TET_NBC'
            BICAUSE(1:5,34) = (/'OH ','HO ','O3 ','NO3','CL '/)
            BIRATE(1:5,34)  = (/ 1.0D-12, 1.0D-12, 0.0D0, 0.0D0, 9.55D-11/)
            BI_ACT(1:5,34)  = (/2300.0D0,2300.0D0, 0.0D0, 0.0D0, 7.80D+03/)


C.. Tracer for formaldehyde emissions
            REACT(35)       = 'HCHO_PRIM'
            IF( INDEX(MECHNAME,'CB6R') .GT. 0 )THEN
               BICAUSE(1:4,35) = (/'OH ','O  ', 'NO3', 'CL '/)
               BIRATE(1:4,35)  = (/ 5.4D-12, 3.4D-11, 5.5D-16, 8.20D-11 /)
               BI_ACT(1:4,35)  = (/ -1.35D2,  1.60D3,   0.0D0,  3.4D1 /) 
               PHOTO_NAME(1:4,35 ) = (/"FORM_R_IUPAC13","FORM_M_IUPAC13","FORM_R_IUPAC10","FORM_M_IUPAC10" /)
               A_PHOTO(1:4,35)     = 1.0D0
            ELSE IF( INDEX(MECHNAME,'SAPRC07T') .GT. 0 )THEN
               BICAUSE(1:3,35) = (/'OH ',      'NO3', 'CL '/)
               BIRATE(1:3,35)  = (/ 5.4D-12, 2.0D-12, 8.10D-11 /) 
               BI_ACT(1:3,35)  = (/ -1.35D2, 2.431D3,  3.0D1 /)  
               PHOTO_NAME(1:2,35 ) = (/"HCHOR_06","HCHOM_06" /)
               A_PHOTO(1:2,35)     = 1.0D0
            ELSE IF( INDEX(MECHNAME,'RACM2') .GT. 0 )THEN
               BICAUSE(1:3,35) = (/'OH ',      'NO3', 'CL '/)
               BIRATE(1:3,35)  = (/ 5.5D-12, 2.0D-12, 8.10D-11 /) 
               BI_ACT(1:3,35)  = (/ -1.25D2, 2.431D3,  3.0D1 /)  
               PHOTO_NAME(1:2,35 ) = (/"HCHO_MOL_JPL19","HCHO_RAD_JPL19" /)
               A_PHOTO(1:2,35)     = 1.0D0
            ELSE ! cracmm1 by default
               BICAUSE(1:3,35) = (/'HO ', 'NO3', 'CL '/)
               BIRATE(1:3,35)  = (/  5.5D-12, 2.0D-12, 8.10D-11 /) 
               BI_ACT(1:3,35)  = (/  -1.25D2,  2.44D3, 3.0D1 /)   
               PHOTO_NAME(1:2,35 ) = (/"HCHO_MOL_JPL19","HCHO_RAD_JPL19" /)
               A_PHOTO(1:2,35)     = 1.0D0
            END IF

C.. Tracer for acetaldehyde emissions
            REACT(36)        = 'CH3CHO_PRIM'
            IF( INDEX(MECHNAME,'CB6R') .GT. 0 )THEN
              BICAUSE(1:4,36)  = (/     'OH ',  'O  ',   'NO3',      'CL ' /)
              BIRATE(1:4,36)   = (/ 4.7D-12, 1.8D-11, 1.4D-12, 7.90D-11 /)
              BI_ACT(1:4,36)   = (/ -3.45D2,  1.10D3,  1.86D3,    0.0D0 /)
              PHOTO_NAME(1:2,36 ) = (/"ALD2_R_IUPAC13","ALD2_R_IUPAC10"/)
              A_PHOTO(1:2,36)     = 1.0D0
            ELSE IF( INDEX(MECHNAME,'SAPRC07T') .GT. 0 )THEN
              BICAUSE(1:3,36)  = (/     'OH ',     'NO3',       'CL ' /)
              BIRATE(1:3,36)   = (/ 4.4D-12,     1.4D-12,   8.0D-11 /)
              BI_ACT(1:3,36)   = (/ -3.65D2,      1.86D3,     0.0D0 /)
              PHOTO_NAME(1:1,36 ) = (/"CCHO_R"/)
              A_PHOTO(1:1,36)     = 1.0D0
            ELSE IF( INDEX(MECHNAME,'RACM2') .GT. 0 )THEN 
              BICAUSE(1:3,36)  = (/     'HO ',   'NO3',     'CL ' /)
              BIRATE(1:3,36)   = (/   4.7D-12, 1.4D-12, 7.90D-11 /)
              BI_ACT(1:3,36)   = (/   -3.45D2,   1.9D3,    0.0D0 /)
              PHOTO_NAME(1:1,36 ) = (/"CH3CHO_RACM2"/)
              A_PHOTO(1:1,36)     = 1.0D0
            ELSE ! cracmm1 by default
              BICAUSE(1:3,36)  = (/     'HO ',   'NO3',     'CL ' /)
              BIRATE(1:3,36)   = (/   4.7D-12, 1.4D-12, 7.90D-11 /)
              BI_ACT(1:3,36)   = (/   -3.45D2,   1.9D3,    0.0D0 /)
              PHOTO_NAME(1:1,36 ) = (/"CH3CHO_RACM2"/)
              A_PHOTO(1:1,36)     = 1.0D0
            END IF

C.. Tracer for acrolein emissions
            REACT(37)        = 'ACRO_PRIM'
            IF( INDEX(MECHNAME,'CB6R') .GT. 0 )THEN
               BICAUSE(1:4,37)  = (/   'OH ',    'O3 ',    'NO3',     'CL '/)
               BIRATE(1:4,37)   = (/ 2.0D-11,2.61D-19, 1.15D-15, 2.37D-10/)
               BI_ACT(1:4,37)   = (/  0.00D0,   0.0D0,    0.0D0,    0.0D0/)
            ELSE IF( INDEX(MECHNAME,'SAPRC07T') .GT. 0 )THEN
               BICAUSE(1:5,37)  = (/   'OH ',    'O3 ',    'NO3',     'CL ',     'O3P'/)
               BIRATE(1:5,37)   = (/ 2.0D-11, 2.37D-15, 1.18D-15, 2.94D-10, 2.37D-12/)
               BI_ACT(1:5,37)   = (/  0.00D0,  2.528D3,    0.0D0,    0.0D0,    0.0D0/)
               BI_ACT(1:5,37)   = (/  0.00D0,  2.528D3,    0.0D0,    0.0D0,    0.0D0/)
            ELSE  ! cracmm1 by default
               BICAUSE(1:4,37)  = (/    'HO ',     'O3 ',    'NO3',     'CL '/)
               BIRATE(1:4,37)   = (/ 8.0D-12, 2.90D-19, 3.40D-15, 2.23D-10/)
               BI_ACT(1:4,37)   = (/  -3.8D2,    0.0D0,    0.0D0,    0.0D0/)
            END IF
            PHOTO_NAME(1:1,37 ) = (/"ACRO_09"/)
            A_PHOTO(1:1,37)     = 1.0D0


C..hydrogen cyanide
            REACT(38)        = 'HYD_CYANIDE'
            BICAUSE(1:2,38)  = (/   'OH ',    'HO '/)
            BIRATE(1:2,38)   = (/  1.20D-13, 1.20D-13/)
            BI_ACT(1:2,38)   = (/  4.0005D2, 4.0005D2/)
        

           NDEGRADED_FOUND = 0
           DO I = 1, N_REACT
               N = 0
               DO J = 1, N_GC_SPC
                  IF ( TRIM( REACT( I ) ) == TRIM( GC_SPC( J ) ) ) THEN
                     N = J
                     EXIT
                  END IF
               END DO
               IF ( N == 0 ) THEN  ! search aerosol them  non-reactive species for index
                  DO J = 1, N_AE_SPC
                     IF ( TRIM( REACT( I ) ) ==  TRIM( AE_SPC( J ) ) ) THEN
                       N = J
                       EXIT
                     END IF
                  END DO
                  IF ( N == 0 ) THEN
                     DO J = 1, N_NR_SPC
                        IF ( TRIM( REACT( I ) ) == TRIM( NR_SPC( J ) ) ) THEN
                          N = J
                          EXIT
                        END IF
                     END DO
                  ENDIF
                ENDIF
                IF ( N == 0 ) CYCLE
                NDEGRADED_FOUND = NDEGRADED_FOUND + 1 
                INDEX_FOUND( NDEGRADED_FOUND ) = I
           END DO
           IF ( NDEGRADED_FOUND .GT. 0 ) THEN
              ALLOCATE( DEGRADED_SPECIES( NDEGRADED_FOUND ) )
              DO I = 1, NDEGRADED_FOUND 
                 DEGRADED_SPECIES( I ) = REACT( INDEX_FOUND( I ) )
              END DO
           END IF
           
           DEALLOCATE( INDEX_FOUND )
                  
         RETURN
         END SUBROUTINE DEGRADE_DATA
      
      END MODULE DEGRADE_PARAMETERS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PTMET

C-----------------------------------------------------------------------
C Function: 3d point source emissions met data

C Revision History:
C     20 Nov 2007 J.Young: initial implementation
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     27 Jul 2011 D.Wong: removed calculation which extends SRTCOL and STRTROW
C                         to the west and south direction in subroutines: 
C                         READMC2, READMC3, and READMD3
C     12 Aug 2015 D.Wong: - Used assumed shape array declaration and declared 
C                           associated subroutines in INTERFACE block
C                         - Replaced BMATVEC with BMATVECN which will call
C                           with a 1d or 2d argument subroutine by F90 
C                           poly-morphism feature
C                         - Based on the condition of MY_NSRC ( > 0 or not) to 
C                           determine execution of certain section of code or not
C                         - fixed a bug of incorrect assignment:
C                           PTMET_DATA%LEN1 = DESID_LAYS, PTMET_DATA%LEN2 = MSRC
C     01 Feb 2019 D.Wong: - Implemented centralized I/O approach and removed 
C                           ZSTATIC implementation
C     05 Aug 2019 D.Wong: - Used met information in the cell where a point source resides
C                           rather than using bi-linear interpolation (call BMATVECN) to
C                           obtain met information for that point source
C     06 Aug 2019 D.Wong: - For two-way model, use UWIND/VWIND (wind U/V component on the
C                           mass point and in offline CMAQ model, use average value of
C                           UWINDC/VWINDC to approximate UWIND/VWIND. Hence no longer
C                           need UWINDC_AVAIL/VWINDC_AVAIL
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE UDTYPES, ONLY: PTMET_TYPE
      USE DESID_VARS, ONLY : DESID_LAYS

      IMPLICIT NONE

c     TYPE :: PTMET_TYPE
c        INTEGER          :: LEN1, LEN2
C Allocatable per-source meteorology variables
c        REAL,    POINTER :: HFX( : )        ! sensible heat flux [watts/m**2]
c        REAL,    POINTER :: HMIX( : )       ! mixing height [m]
c        REAL,    POINTER :: TSFC( : )       ! surface temperature [degK]
c        REAL,    POINTER :: USTAR( : )      ! friction velocity [m/s]
c        REAL,    POINTER :: PRSFC( : )      ! surface pressure [Pa]
C Allocatable temporary per-layer variables from 1:DESID_LAYS
c        REAL,    POINTER :: WSPD( : )       ! wind speed [m/s]
c        REAL,    POINTER :: DTHDZ( : )      ! virtual pot temp gradient [degK/m]
C Allocatable temporary per-layer variables from 0:DESID_LAYS
c        REAL,    POINTER :: PRESF( : )      ! pressure at full-levels
c        REAL,    POINTER :: ZZF( : )        ! per src elevn at full-levels
c Allocatable per-source and per layer meteorology variables.
C Dimensioned by layers, then sources
c!       REAL,    POINTER :: DDZH ( :,: )    ! 1/( ZH(L) - ZH(L-1) )
c        REAL,    POINTER :: DDZF ( :,: )    ! 1/( ZF(L) - ZF(L-1) )
c        REAL,    POINTER :: PRES ( :,: )    ! pressure [Pa]
c        REAL,    POINTER :: DENS ( :,: )    ! air density [kg/m**3]
c        REAL,    POINTER :: QV   ( :,: )    ! moisture mixing ratio [kg/kg]
c        REAL,    POINTER :: TA   ( :,: )    ! temperature [degK]
c        REAL,    POINTER :: UWIND( :,: )    ! x-component wind speed [m/s]
c        REAL,    POINTER :: VWIND( :,: )    ! y-component wind speed [m/s]
c        REAL,    POINTER :: ZF   ( :,: )    ! full layer height [m]
c        REAL,    POINTER :: ZH   ( :,: )    ! mid layer height [m]
c        REAL,    POINTER :: ZSTK ( :,: )    ! ZF( L,S ) - STKHT(S) [m]
c     END TYPE PTMET_TYPE

      TYPE( PTMET_TYPE ), ALLOCATABLE, SAVE :: PTMET_DATA( : )

C cross-point surface met file name
      CHARACTER(  16 ),              SAVE :: MC2NAME
C cross-point layered met file name
      CHARACTER(  16 ),              SAVE :: MC3NAME
C dot-point layered met file name
      CHARACTER(  16 ),              SAVE :: MD3NAME

C-----------------------------------------------------------------------
      CONTAINS

         FUNCTION PTMET_INIT ( ) RESULT ( SUCCESS )

         USE UTILIO_DEFN
         USE STK_PRMS, ONLY: MY_NSRC         

         IMPLICIT NONE

         LOGICAL               :: SUCCESS                          

         INTEGER N, MSRC, IOS
         CHARACTER( 16 ) :: PNAME = 'PTMET_INIT'   ! procedure name

         SUCCESS = .TRUE.
         ALLOCATE( PTMET_DATA( NPTGRPS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'PTMET_DATA', PNAME )

         DO N = 1, NPTGRPS

            MSRC = MY_NSRC( N )
            PTMET_DATA(N)%LEN1 = DESID_LAYS; PTMET_DATA(N)%LEN2 = MSRC

            IF ( MY_NSRC( N ) .GT. 0 ) THEN
C Allocate per-source arrays
               ALLOCATE( PTMET_DATA( N )%HFX  ( MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'HFX', PNAME )
               ALLOCATE( PTMET_DATA( N )%HMIX ( MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'HMIX', PNAME )
               ALLOCATE( PTMET_DATA( N )%TSFC ( MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'TSFC', PNAME )
               ALLOCATE( PTMET_DATA( N )%USTAR( MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'USTAR', PNAME )
               ALLOCATE( PTMET_DATA( N )%PRSFC( MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'PRSFC', PNAME )

C Allocate per-source and per-layer arrays
               ALLOCATE( PTMET_DATA( N )%DDZF ( DESID_LAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'DDZF', PNAME )
               ALLOCATE( PTMET_DATA( N )%PRES ( DESID_LAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'PRES', PNAME )
               ALLOCATE( PTMET_DATA( N )%DENS ( DESID_LAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'DENS', PNAME )
               ALLOCATE( PTMET_DATA( N )%QV   ( DESID_LAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'QV', PNAME )
               ALLOCATE( PTMET_DATA( N )%TA   ( DESID_LAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'TA', PNAME )
               ALLOCATE( PTMET_DATA( N )%UWIND( DESID_LAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'UWIND', PNAME )
               ALLOCATE( PTMET_DATA( N )%VWIND( DESID_LAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'VWIND', PNAME )
               ALLOCATE( PTMET_DATA( N )%ZF   ( DESID_LAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'ZF', PNAME )
               ALLOCATE( PTMET_DATA( N )%ZH   ( DESID_LAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'ZH', PNAME )
               ALLOCATE( PTMET_DATA( N )%ZSTK ( DESID_LAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'ZSTK', PNAME )

C Allocate per-layer arrays from 1:DESID_LAYS
               ALLOCATE( PTMET_DATA( N )%WSPD ( DESID_LAYS ), STAT=IOS )
               CALL CHECKMEM( IOS, 'WSPD', PNAME )
               ALLOCATE( PTMET_DATA( N )%DTHDZ( DESID_LAYS ), STAT=IOS )
               CALL CHECKMEM( IOS, 'DTHDZ', PNAME )

C Allocate per-layer arrays from 0:DESID_LAYS
               ALLOCATE( PTMET_DATA( N )%PRESF( 0:DESID_LAYS ), STAT=IOS )
               CALL CHECKMEM( IOS, 'PRESF', PNAME )
               ALLOCATE( PTMET_DATA( N )%ZZF  ( 0:DESID_LAYS ), STAT=IOS )
               CALL CHECKMEM( IOS, 'ZZF', PNAME )
            END IF ! (MY_NSRC( N ) > 0)

         END DO

         END FUNCTION PTMET_INIT 

C-----------------------------------------------------------------------
#ifdef mpas
         SUBROUTINE PTMET_CONVT_MPAS ( N )

         USE STK_PRMS, ONLY: MY_NSRC, SOURCE, my_nsrc_mesh_index
         USE stack_group_data_module, ONLY: STKHT
         USE coupler_module

         IMPLICIT NONE

         integer, intent(in) :: n

         INTEGER S

         IF ( MY_NSRC( N ) .GT. 0 ) THEN
            DO S = 1, MY_NSRC( N )
               PTMET_DATA( N )%USTAR( S )  = g2ddata(my_nsrc_mesh_index(s, n),1,ustar_ind)
               PTMET_DATA( N )%HFX( S )    = g2ddata(my_nsrc_mesh_index(s, n),1,hfx_ind)
               PTMET_DATA( N )%HMIX( S )   = g2ddata(my_nsrc_mesh_index(s, n),1,pbl_ind)

               PTMET_DATA( N )%TA( :,S )   = g3ddata(my_nsrc_mesh_index(s, n),1,:,temp_ind)
               PTMET_DATA( N )%ZH( :,S )   = g3ddata(my_nsrc_mesh_index(s, n),1,:,zh_ind)
               PTMET_DATA( N )%ZF( :,S )   = g3ddata(my_nsrc_mesh_index(s, n),1,:,zf_ind)
               PTMET_DATA( N )%DENS( :,S ) = g3ddata(my_nsrc_mesh_index(s, n),1,:,dens_ind)
            END DO
         END IF

         END SUBROUTINE PTMET_CONVT_MPAS

#else
C-----------------------------------------------------------------------

         SUBROUTINE PTMET_CONVT( JDATE, JTIME, N )

         USE STK_PRMS, ONLY: MY_NSRC, SOURCE, MY_STKCOL, MY_STKROW
         USE STACK_GROUP_DATA_MODULE, ONLY: STKHT
         USE CENTRALIZED_IO_MODULE, ONLY : INTERPOLATE_VAR
         USE HGRD_DEFN, ONLY : NCOLS, NROWS
         USE VGRD_DEFN, ONLY : NLAYS

         IMPLICIT NONE

         INTEGER, INTENT( IN ) :: JDATE, JTIME
         INTEGER, INTENT( IN ) :: N              ! Point Source File Number

         INTEGER         :: L, MSRC, S
         CHARACTER( 16 ) :: PNAME = 'PTMET_CONVT'   ! PROCEDURE NAME

         INTEGER :: MYC, MYR, STAT
         
         REAL, ALLOCATABLE, SAVE:: LOC_ZH(:,:,:),
     &                             LOC_ZF(:,:,:),
     &                             LOC_HFX(:,:),
     &                             LOC_PBL(:,:),
     &                             LOC_TEMP2(:,:),
     &                             LOC_USTAR(:,:),
     &                             LOC_PRSFC(:,:),
     &                             LOC_TA(:,:,:),
     &                             LOC_QV(:,:,:),
     &                             LOC_PRES(:,:,:),
     &                             LOC_DENS(:,:,:),
     &                             LOC_UWIND(:,:,:),
     &                             LOC_VWIND(:,:,:)

         LOGICAL, SAVE :: INITIALIZE = .TRUE.
         
         INTERFACE
            SUBROUTINE DELTA_ZS( DESID_LAYS, MY_NSRC, SRC_MAP, STKHT, ZF, ZSTK, DDZF )
               INTEGER, INTENT( IN )  :: DESID_LAYS, MY_NSRC
               INTEGER, INTENT( IN )  :: SRC_MAP( : )
               REAL,    INTENT( IN )  :: STKHT( : )
               REAL,    INTENT( IN )  :: ZF  ( :,: )
               REAL,    INTENT( OUT ) :: ZSTK( :,: )
               REAL,    INTENT( OUT ) :: DDZF( :,: )
            END SUBROUTINE DELTA_ZS
         END INTERFACE

C-----------------------------------------------------------------------

         IF ( INITIALIZE ) THEN
         
            ALLOCATE ( LOC_ZH(NCOLS,NROWS,NLAYS),
     &                 LOC_ZF(NCOLS,NROWS,NLAYS),
     &                 LOC_HFX(NCOLS,NROWS),
     &                 LOC_PBL(NCOLS,NROWS),
     &                 LOC_TEMP2(NCOLS,NROWS),
     &                 LOC_USTAR(NCOLS,NROWS),
     &                 LOC_PRSFC(NCOLS,NROWS),
     &                 LOC_TA(NCOLS,NROWS,NLAYS),
     &                 LOC_QV(NCOLS,NROWS,NLAYS),
     &                 LOC_PRES(NCOLS,NROWS,NLAYS),
     &                 LOC_DENS(NCOLS,NROWS,NLAYS),
     &                 LOC_UWIND(NCOLS+1,NROWS+1,NLAYS),
     &                 LOC_VWIND(NCOLS+1,NROWS+1,NLAYS),
     &                 STAT=STAT)
     
           INITIALIZE = .FALSE.
           
         END IF

         CALL INTERPOLATE_VAR ('ZH', JDATE, JTIME, LOC_ZH)
         CALL INTERPOLATE_VAR ('ZF', JDATE, JTIME, LOC_ZF)
         CALL INTERPOLATE_VAR ('HFX', JDATE, JTIME, LOC_HFX)
         CALL INTERPOLATE_VAR ('PBL', JDATE, JTIME, LOC_PBL)
         CALL INTERPOLATE_VAR ('TEMP2', JDATE, JTIME, LOC_TEMP2)
         CALL INTERPOLATE_VAR ('USTAR', JDATE, JTIME, LOC_USTAR)
         CALL INTERPOLATE_VAR ('PRSFC', JDATE, JTIME, LOC_PRSFC)
         CALL INTERPOLATE_VAR ('TA', JDATE, JTIME, LOC_TA)
         CALL INTERPOLATE_VAR ('QV', JDATE, JTIME, LOC_QV)
         CALL INTERPOLATE_VAR ('PRES', JDATE, JTIME, LOC_PRES)
         CALL INTERPOLATE_VAR ('DENS', JDATE, JTIME, LOC_DENS)
#ifdef twoway
         CALL INTERPOLATE_VAR ('UWIND', JDATE, JTIME, LOC_UWIND)
         CALL INTERPOLATE_VAR ('VWIND', JDATE, JTIME, LOC_VWIND)
#else
         CALL INTERPOLATE_VAR ('UWINDC', JDATE, JTIME, LOC_UWIND)
         CALL INTERPOLATE_VAR ('VWINDC', JDATE, JTIME, LOC_VWIND)
#endif
         !DO N = 1, NPTGRPS

            MSRC = MY_NSRC( N )

            DO S = 1, MY_NSRC (N )

               MYC = MY_STKCOL( N )%ARRY( S )
               MYR = MY_STKROW( N )%ARRY( S )

               PTMET_DATA( N )%HFX(S) = LOC_HFX(MYC, MYR)

               PTMET_DATA( N )%HMIX(S) = LOC_PBL(MYC, MYR)

               PTMET_DATA( N )%TSFC(S) = LOC_TEMP2(MYC, MYR)

               PTMET_DATA( N )%USTAR(S) = LOC_USTAR(MYC, MYR)

               PTMET_DATA( N )%PRSFC(S) = LOC_PRSFC(MYC, MYR)

               DO L = 1, NLAYS
               
                  PTMET_DATA( N )%ZH(L,S)    = LOC_ZH(MYC, MYR, L)
                  
                  PTMET_DATA( N )%ZF(L,S)    = LOC_ZF(MYC, MYR, L)
                  
                  PTMET_DATA( N )%TA(L,S)    = LOC_TA(MYC, MYR, L)
                  
                  PTMET_DATA( N )%QV(L,S)    = LOC_QV(MYC, MYR, L)
                  
                  PTMET_DATA( N )%PRES(L,S)  = LOC_PRES(MYC, MYR, L)
                  
                  PTMET_DATA( N )%DENS(L,S)  = LOC_DENS(MYC, MYR, L)
#ifdef twoway
                  PTMET_DATA( N )%UWIND(:,S) = LOC_UWIND(MYC, MYR, L)

                  PTMET_DATA( N )%VWIND(:,S) = LOC_VWIND(MYC, MYR, L)
#else
                  PTMET_DATA( N )%UWIND(L,S) = 0.5*( LOC_UWIND(MYC, MYR, L)
     &                                       +       LOC_UWIND(MYC+1, MYR, L) )
               
                  PTMET_DATA( N )%VWIND(L,S) = 0.5*( LOC_VWIND(MYC, MYR, L)
     &                                       +       LOC_VWIND(MYC, MYR+1, L) )
#endif                
               END DO

            END DO

            IF ( MY_NSRC( N ) .GT. 0 ) THEN ! Compute ZSTK, DDZF
               CALL DELTA_ZS( DESID_LAYS, MSRC,
     &                        SOURCE( N )%ARRY, STKHT( N )%ARRY,
     &                        PTMET_DATA( N )%ZF,
     &                        PTMET_DATA( N )%ZSTK,
     &                        PTMET_DATA( N )%DDZF )
            END IF ! MY_NSRC( N ) > 0

         !END DO   ! NPTGRPS

         END SUBROUTINE PTMET_CONVT
#endif

C-----------------------------------------------------------------------

      END MODULE PTMET

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/getparb.f,v 1.2 2011/10/21 16:10:18 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
        SUBROUTINE GETPARB( RSOLAR, PRES, COSZ, PARDB, PARDIF )

C-----------------------------------------------------------------------
C Description:
C   Compute direct and diffuse photosynthetically active radiation (PAR).
C   Based on code from Bart Brashers (10/2000), which was based on
C   code from Weiss and Norman (1985).  
 
C Preconditions:
C   Solar radiation (W/m2) and pressure (mb)
 
C Subroutines and Functions Called:
 
C Revision History:
C   3/01 Prototype by JMV
C  10/17 J.Young: rename, optimize
C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling System
C File: @(#)$Id: getparb.f,v 1.2 2011/10/21 16:10:18 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/getparb.f,v $
C Last updated: $Date: 2011/10/21 16:10:18 $ 
C-----------------------------------------------------------------------

      IMPLICIT NONE

C Arguments:
      REAL, INTENT ( IN ) :: RSOLAR   ! modeled or observed total radiation [W/m2]
      REAL, INTENT ( IN ) :: PRES     ! atmospheric pressure [mb]
      REAL, INTENT ( IN ) :: COSZ     ! cosine of solar zenith angle
      REAL, INTENT( OUT ) :: PARDB    ! direct beam PAR [umol/m2-s]
      REAL, INTENT( OUT ) :: PARDIF   ! diffuse PAR [umol/m2-s]

C Parameters:
      REAL, PARAMETER :: WATT2UMOL = 4.6  ! convert W/m^2 to umol/m^2-s

C Local Variables:
      REAL RATIO              ! transmission fraction for total radiation
      REAL OT                 ! optical thickness
C     REAL RDVIS              ! possible direct visible beam [(W/m^2]
C     REAL RFVIS              ! possible visible diffuse [(W/m^2]
      REAL WA                 ! water absorption in near-IR [(W/m^2]
C     REAL RDIR               ! direct beam in near-IR [(W/m^2]
C     REAL RFIR               ! diffuse near-IR [(W/m^2]
C     REAL RVT                ! total possible visible radiation [(W/m^2]
C     REAL RIRT               ! total possible near-IR radiation [(W/m^2]
C     REAL FVIS               ! fraction of visible to total 
C     REAL FVB                ! fraction of visible that is direct beam
C     REAL FVD                ! fraction of visible that is diffuse
      REAL FAC                ! direct beam factor / combination factor

      REAL A, B, C, DEN, RW   ! replacement composite variables

      CHARACTER(  16 ) :: PNAME = 'GETPAR'   ! procedure name
      CHARACTER( 256 ) :: MESG = ' '

C-----------------------------------------------------------------------

C   Original implementation ............................

C (ZEN was originally an argument, but replaced by COS(ZEN) = COSZ)

C Assume that PAR = 0 if zenith angle is greater than 87 degrees (1.51844 radians)
C or if solar radiation is zero
C     IF ( ZEN .GE. 1.51844 .OR. RSOLAR .LE. 0.0 ) THEN
C        PARDB  = 0.0
C        PARDIF = 0.0
C        RETURN
C     END IF

C Compute clear sky (aka potential) radiation terms
C     OT    = PRES / 1013.25 / COSZ                ! Atmospheric Optical thickness
C     RDVIS = 600.0 * EXP( -0.185 * OT ) * COSZ    ! Direct visible beam, eqn (1)
C     RFVIS = 0.42 * ( 600.0 - RDVIS ) * COSZ      ! Visible Diffuse, eqn (3)
C     WA    = 1320.0 * 0.077 * ( 2.0 * OT ) ** 0.3 ! water absorption in near-IR, eqn (6)
C     RDIR  = ( 720.0 * EXP( -0.06 * OT ) - WA ) * COSZ ! Direct beam near-IR, eqn (4)
C     RFIR  = 0.65 * ( 720.0 - WA - RDIR ) * COSZ  ! Diffuse near-IR, eqn (5)

C     RVT   = RDVIS + RFVIS            ! Total visible radiation, eqn (9)
C     RIRT  = RDIR + RFIR              ! Total near-IR radiation, eqn (10) 
C     FVIS  = RVT / ( RIRT + RVT )     ! Fraction of visible to total radiation, eqn 7
C     RATIO = RSOLAR / ( RIRT + RVT )  ! Ratio of "actual" to clear sky solar radiation

C Compute fraction of visible that is direct beam
C     IF ( RATIO .GE. 0.89 ) THEN
C        FVB = RDVIS / RVT * 0.941124
C     ELSE IF ( RATIO .LE. 0.21 ) THEN
C        FVB = RDVIS / RVT * 9.55E-3
C     ELSE
C        FVB = RDVIS / RVT * ( 1.0 - ( ( 0.9 - RATIO ) / 0.7 ) ** 0.666667 )
C     END IF
C     FVD = 1.0 - FVB

C Compute PAR (direct beam and diffuse) in umol/m2-sec
C     PARDB  = RSOLAR * FVIS * FVB * WATT2UMOL
C     PARDIF = RSOLAR * FVIS * FVD * WATT2UMOL      

C   New implementation .................................

      IF ( COSZ .LE. 0.052336 .OR. RSOLAR .LE. 0.0 ) THEN
         PARDB  = 0.0
         PARDIF = 0.0
         RETURN
      END IF

      OT = PRES / 101325.0 / COSZ   ! PRES in Pa
      A = 600.0 * EXP( -0.185 * OT )
      WA = 125.1335182 * ( OT ) ** 0.3
      B = 720.0 * EXP( -0.06 * OT ) - WA
      C = ( 1.0 - 0.42 * COSZ ) * A
      DEN = 720.0 + C - 0.65 * WA + ( 1.0 - 0.65 * COSZ ) * B
      RATIO = RSOLAR / DEN / COSZ
      IF ( RATIO .GE. 0.89 ) THEN
         FAC = 0.941124
      ELSE IF ( RATIO .LE. 0.21 ) THEN
         FAC = 9.55E-3
      ELSE
         FAC = 1.0 - ( 1.42857143 * ( 0.9 - RATIO ) ) ** 0.666667
      END IF
      RW = RATIO * WATT2UMOL * COSZ
      PARDB = RW * FAC * A
      PARDIF = RW * ( 252.0 + C ) - PARDB

      RETURN 

      END SUBROUTINE GETPARB

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C......................................................................
      MODULE PA_IPRVARS

C Contains: data used in the Process Analysis Control Program

C Dependent Upon: None

C Revision History:
C......................................................................

      USE PA_GLOBAL, Only: MXSPEC
      USE PA_VARS, Only: MAXTERMS

      INTEGER, PARAMETER :: MAXIPRSPC = 600    ! Max no. of IPR species

      INTEGER, PARAMETER :: MAXIPROUT = MAXIPRSPC * 10   ! Max no. IPR outputs


      CHARACTER(  4 ) :: IPR_SPTYPE( MAXIPRSPC )   ! Type of mass balance species
      CHARACTER( 16 ) :: IPR_SPNAM ( MAXIPRSPC )   ! Name of mass balance species
      CHARACTER( 16 ) :: IPR_OPNAME( MAXIPRSPC,MAXTERMS )  ! Input IPR op names

      INTEGER :: N_IPR_OPS ( MAXIPRSPC )   ! No. of input IPR operation names
      INTEGER :: IPR_SPNUM ( MAXIPRSPC )   ! Species or family-name number

      END MODULE PA_IPRVARS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
       SUBROUTINE CONVCLD_ACM ( CGRD, JDATE, JTIME, TSTEP,
     &                         CONV_DEP, SUBTRANS )

C-----------------------------------------------------------------------
C
C  FUNCTION: Convective cloud processor Models-3 science process:
C       MAIN ROUTINE calculates cloud characteristics, and uses them
C       to generate cumulative and net timestep deposition, cloud top,
C       cloud bottom, and pressure at the lifting level.
C
C       ICLDTYPE = 1 => computes raining cloud physics, mixing, chemistry,
C                       wet dep
C       ICLDTYPE = 2 => does the same for non-precip clouds utilizing saved
C                       info from RNCLD in the case of co-existing clouds
C
C  PRECONDITIONS REQUIRED:
C       Dates and times represented YYYYDDD:HHMMSS.
C
C  IDEA:   Aqueous chemistry operates on the half-hour for an internal
C          time step of one hour.
C
C  REVISION  HISTORY:
C       Adapted 3/93 by CJC from science module template
C       Version 3/3/93 with complete LCM aqueous chem by JNY.
C       Modified 6/3-7/93 by CJC & JNY to correct treatment of half layers
C       vs. full layers in loop 255:  calculation of DTDP centered at
C       quarter-layers using PSTAR; corresponding revisions to TLCL, TSAT.
C       Uses 4th order R-K solver there.
C       Version 6/5/93 by CJC using relative rainout rates.
C       Version 7/6/93 by CJC using INTERP3()
C       Adapted from LCM aqueous chemistry, initial version, 9/93
C              by JNY and CJC
C       Completion of EM cloud mixing, JNY 12/93
C       Inclusion of EM aqueous chemistry JNY 12/93
C       UPGRADE TO FULL RADM CLOUD MODULE EMULATION, JNY 4/94
C       8/16/94 by Dongming Hwang Configuration management template
C       Adapted 10/96 by S.Roselle for Models-3
C       1/97 s.roselle added McHenry`s well mixed assumption code
C       8/97 S.Roselle revised cgrid units, pressure units, rainfall
C              to hourly amounts, built indices for wet dep species,
C              scavenged species, and aqueous species, built wrapper
C              around aqueous chemistry module
C       10/97 S.Roselle removed McHenry`s well mixed assumption code
C              and put back the below cloud concentration scaling
C       11/97 S.Roselle moved the wet deposition output to the calling
C              routine--CLDPROC
C       01/98 S.Roselle moved indexing code to AQINTER, also
C              moved scavenging to SCAVWDEP
C       03/98 S.Roselle read sub-hourly rainfall data
C       12/98 David Wong at LM:
C             -- changed division of 8000, 2, 1000 to its corresponding
C                reciprocal
C              -- added INT in the expression STEP * 0.5 when calling SEC2TIME
C       03/99 David Wong at LM:
C             -- replaced "/ FRAC * .001" by "/ ( FRAC * 1000.0 )" to minimize
C                lost of significant digits in calculation
C       Jeff - Dec 00 - move CGRID_MAP into f90 module
C       Jeff - Sep 01 - Dyn Alloc - Use HGRD_DEFN
C       4/02 S.Roselle changed minimum horizontal resolution for subgrid
C             clouds from 12km to 8km.
C       1/05 J.Young: dyn alloc - establish both horizontal & vertical
C                     domain specifications in one module
C       5/05 J.Pleim Replaced cloud mixing algorithm with ACM
C       6/05 S.Roselle added new cloud diagnostic variables
C       7/05 J.Young: clean up and mod for CMAQ-F
C       7/06 S.Roselle Modified for sulfate tracking model
C       8/10 J.Young: replace chem mechanism include files with namelists
C                    and accomodate Shawn Roselle`s, Sergey Napelenok`s
C                    and Steve Howard`s aerosol reengineering
C       3/11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C       5/11/11 D.Wong: incorporated twoway model implementation
C       7/11 G. Sarwar: calculate zenith angle to determine daytime and nightime 
C                    needed for sulfur oxidation via metal catalysis
C       9/11 S.Roselle: enable CMAQ subgrid cloud model only when met. driver
C             uses a convective cloud parameterization (removed minimum
C             horizontal grid resolution restriction)
C       02Aug12 S.Roselle:  instrumented to calculate and return
C                           transmissivity for convective clouds
C       04Apr14 B.Hutzell:  Added routine call to capture cloud fractions,
C                           water, and ice mixing ratios
C       11Feb15 J.Young: Updated call to czangle.F which uses the ASX_DATA_MOD shared
C                        data module (Implemented by J.Bash on 07 Nov 14)
C       09/04/15 D.Wong: - Made variable declaration method consistent in the caller
C                          and calling routines
C                        - Used a variable rather than an array in calculation to
C                          reduce memory footprint and to increase code efficiency
C       28May15 J.Young: cleanup
C       12Jun15 B.Hutzell: Moved call to CLEAR_ACM_CLOUD to after FIRSTIME block to
C                          insure results from previous time step are removed
C       12Jan16 D.Wong: Fixed a bug that causes different result when code run with 
C                       different domain decomposition
C       4Apr16 J.Bash      Calculate the Sundqvist et al. 1989 threshold humidities 
C                          for cloud formation based on Mocko and Cotton (1995) to be
C                          More consistent with WRF
C       7May 18 D. Schwede: Removed call to CZANGLE. COSZEN now calculated in ASX_DATA_MOD
C       Aug 2018 J. Pleim: convert to Z coords
C       Oct 2018 D. Wong: Declared array, F as allocatable and added subroutine ACMCLD 
C                         in the interface block
C       26 Nov 2018 S. Napelenok: ISAM implementation
C       Feb 2019 D. Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C       01 AUG 19 D.Wong: Modified code to work with two-way model and 
C       11 Nov 19 F. Sidi: Changed MSTEP to accomdate Centralized I/O changes       
C       30 Dec 19 S.L.Napelenok:  ddm-3d implementaiton for version 5.3.1
C       10 Jun 21 G. Sarwar: Replaced CB6R3M with CB6R5M

C-----------------------------------------------------------------------

      USE RUNTIME_VARS, ONLY: STM, CONVECTIVE_SCHEME
      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      USE AQ_DATA
      USE AERO_DATA, ONLY : ASO4_IDX, ASO4AQH2O2_IDX, ASO4AQO3_IDX,
     &                      ASO4AQFEMN_IDX, ASO4AQMHP_IDX, ASO4AQPAA_IDX,
     &                      ASO4GAS_IDX, ASO4EMIS_IDX, ASO4ICBC_IDX,
     &                      OSO4AQH2O2_IDX, OSO4AQO3_IDX, OSO4AQFEMN_IDX,
     &                      OSO4AQMHP_IDX, OSO4AQPAA_IDX, OSO4_IDX, 
     &                      OSO4GAS_IDX, OSO4EMIS_IDX, OSO4ICBC_IDX,
     &                      AEROSPC_MAP, N_MODE, AE6ISOA, MAP_AERO
      USE PRECURSOR_DATA, ONLY: SULF_IDX, PRECURSOR_MAP, MAP_PRECURSOR
      USE RXNS_DATA, ONLY: MECHNAME       ! chemical mechanism data
      USE ASX_DATA_MOD,  ONLY: GRID_DATA, MET_DATA
      USE PHOT_MOD,      ONLY: RJ, RJ_RES, RJ_SUB, LH2O2_PHOTOLYSIS => LH2O2,
     &                   LHNO3_PHOTOLYSIS => LHNO3
      USE CENTRALIZED_IO_MODULE
#ifdef isam
      USE SA_DEFN, ONLY: ISAM, NSPC_SA, NTAG_SA, MAP_SAtoCGR, OTHRTAG,
     &                   ISAM_SPEC, DEPSUM_SAVE, DS4_SAVE, REMOV_SAVE,
     &                   ITAG, CONV_SADEP,
     &                   DEPSUM_AORGC_SAVE, DGLY1_SAVE, DMGLY1_SAVE,
     &                   REMOV_AORGC_SAVE
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY: SENGRID, NP, NPMAX, S_CONDEP, S_POLC,
     &                      S_CEND, S_REMOV, S_REMOVAC, S_CONDEP, 
     &                      S_TOTDEP, S_CCR, S_CBELOW, IPT,
     &                      S_CONC, S_BMOL, S_CBASE0, S_CBASEF,
     &                      S_BCLDWT, S_INCLOUD, S_OUTCLOUD, S_PCLD,
     &                      S_CONDIS, DDM3D_CONCMINL
#endif

#ifdef mpas
      use util_module, only : nextime, time2sec, sec2time, secsdiff, currstep
#endif
      USE CONST

      IMPLICIT NONE

C...........INCLUDES

      INCLUDE SUBST_FILES_ID            ! file name parameters

C...........Arguments

      REAL, INTENT( INOUT )    :: CGRD( :,:,:,: )
      INTEGER, INTENT( IN )    :: JDATE
      INTEGER, INTENT( IN )    :: JTIME
      INTEGER, INTENT( IN )    :: TSTEP( 3 )

#ifdef mpas
      integer, save :: mpas_cmaq_freq
#endif
      REAL,    INTENT( INOUT ) :: CONV_DEP( :,:,: )
      REAL,    INTENT( OUT )   :: SUBTRANS( :,:,: )

C...........Parameters


#ifdef mpas
C critical rel humidity for land (fraction)
      REAL, ALLOCATABLE, SAVE      :: RCRITL(:,:)

C critical rel humidity for water (fraction)
      REAL, ALLOCATABLE, SAVE      :: RCRITW(:,:)
#else
C critical rel humidity for land (fraction)
      REAL, SAVE      :: RCRITL

C critical rel humidity for water (fraction)
      REAL, SAVE      :: RCRITW

#endif
C intermediate factor
      REAL            :: XKM

C factor convert 1/min to 1/sec
      REAL, PARAMETER :: MINPERSEC = 1.0 / 60.0 

C param contlng sidewall entrainment function for raining clouds
      REAL, PARAMETER :: SIDEFAC = 0.5

C storm rainout efficiency
      REAL, PARAMETER :: STORME  = 0.3

C emp sat vapor press constant from RADM
      REAL, PARAMETER :: C303 = 19.83

C emp sat vapor press constant from RADM
      REAL, PARAMETER :: C302 = 5417.4

C g/kg
      REAL, PARAMETER :: GPKG = 1.0E+03

C 1 hectare = 1.0e4 m**2
      REAL, PARAMETER :: M2PHA = 1.0E+04
      REAL, PARAMETER :: M2PHA_OVER_GPKG = 10.0

C subgrid scale temp perturb (deg K)
      REAL, PARAMETER :: PERT = 1.5

C wvp mix ratio perturb (dimensionless)
      REAL, PARAMETER :: PERQ = 1.5E-3

C rainfall threshold (mm/hr)
      REAL, PARAMETER :: RTHRESH = 0.1

C vapor press of water at 0 C (Pa)
      REAL, PARAMETER :: VP0PA = 611.2

C 1.0 / (vapor press of water @ 0 C) (1/Pa)
      REAL, PARAMETER :: VPINV = 1.0 / VP0PA

C converg. crit. for entrainment solver
      REAL, PARAMETER :: TST = 0.01

C assumed cloud lifetime for convective clouds (sec)
      REAL, PARAMETER :: TCLIFE = 3600.0

C ratio of mol wt of water vapor to mol wt of air
      REAL, PARAMETER :: MVOMA = MWWAT / MWAIR

C ratio of dry gas const to specific heat
      REAL, PARAMETER :: ROVCP = RDGAS / CPD

C ratio of latent heat of vap to specific heat
      REAL, PARAMETER :: LVOCP = LV0 / CPD

C dry adiabatic lapse rate (deg K/m)
      REAL, PARAMETER :: DALR = GRAV / CPD

C Number of species in CGRID
      INTEGER, SAVE :: MXSPCS

C parameter to control frequency of convective cloud processing
C   SYNCCLD=.TRUE.  : every synchronization timestep
C   SYNCCLD=.FALSE. : every hour on the half hour
      LOGICAL, PARAMETER :: SYNCCLD = .TRUE. ! default to sync timestep

      INTEGER       ICLDTYPE            ! 1: raining, 2: either CNP or PFW

C...........Local Variables

C-------for ACM version - jp 2/05        REAL DPB
      REAL, ALLOCATABLE, SAVE :: DZH( : )
      REAL, ALLOCATABLE, SAVE :: CCR ( :,: )
      REAL, ALLOCATABLE, SAVE :: CONC( :,: )
      REAL, ALLOCATABLE, SAVE :: CBELOW( : )
C-------------------------------------------

      LOGICAL, SAVE :: FIRSTIME = .TRUE. ! flag for first pass thru

      CHARACTER( 16 ) :: PNAME = 'CONVCLD_ACM'   ! process name
      CHARACTER( 16 ) :: VARNM          ! variable name for IOAPI to get

      CHARACTER( 16 ), SAVE :: RC_NAME  ! RC name: old is RC and new is RCA

      INTEGER, ALLOCATABLE, SAVE :: SURCLDMX( : ) ! cloud mixing surrogate for stm

      INTEGER          ATIME            ! time diff from half-hour
      INTEGER          CLTOP            ! model LAY containing cloud top
      INTEGER          COL              ! column loop counter
      INTEGER          ROW              ! row loop counter
      INTEGER          CTOP             ! dummy variable for cloud top layer
      INTEGER          FINI             ! ending position
      INTEGER          I599C            ! entrainment solver iteration counter
      INTEGER          LAY              ! layer loop counter
      INTEGER          M                ! mode index
      INTEGER          MDATE            ! process date
      INTEGER          MTIME            ! process time (half-hour)
      INTEGER, SAVE :: MSTEP            ! met file time step (hhmmss)
      INTEGER, SAVE :: SDATE            ! met file start date
      INTEGER          SPC              ! liquid species loop counter
      INTEGER          STEP             ! step loop counter
      INTEGER          STRT             ! starting position
      INTEGER, SAVE :: STIME            ! met file start time
      INTEGER          VAR              ! variable loop counter
      INTEGER          I                ! variable loop counter

      INTEGER          CLBASE           ! cld base layer
      INTEGER          CLTOPUSTBL       ! unstable cld top layer
      INTEGER          ISOUND           ! flag for sounding stability
      INTEGER          SRCLAY           ! cloud source level vert index

      REAL             AIRM             ! total air mass (mol/m2) in cloudy air
      REAL             AIRMB0           ! mol/m2 air below cloud
      REAL             AIRMBI           ! inverse mol/m2 air below cloud
      REAL             ALFA0            ! aitken mode number scavenging coef
      REAL             ALFA2            ! aitken mode sfc area scavenging coef
      REAL             ALFA3            ! aitken mode mass scavenging coef
      REAL             ARPRES           ! ave cloud pres in atm
      REAL             CONDIS           !
      REAL             CTHK             ! cloud thickness (m)
      REAL             CTHK1            ! aq chem calc cloud thickness
      REAL             DAMDP            ! dry adiabatic minus dew point lapse rate
      REAL             DP               ! pressure increment along moist adiabat
      REAL             DPLR             ! dew point lapse rate
      REAL             DQI              ! change in ice mix ratio due to melting caused by entrainment
      REAL             DQL              ! change in liq wat mix ratio due to evap caused by entrainment
      REAL             DTCLD            ! cloud integration timestep (s)
      REAL             DTDP             ! moist adiabatic lapse rate
      REAL             DZLCL            ! height increment to LCL above source level
      REAL             ZLCL             ! height of LCL above ground
      REAL             EMAX             ! water vapor pressure at source level
      REAL             EQTH             ! parcel equivalent potential temperature
      REAL             EQTHM            ! parcel equivalent potential temp
      REAL             FA               ! entrainment functional value at TEMPA
      REAL             FB               ! entrainment functional value at TEMPB
      REAL             FRAC             ! cloud fractional coverage
      REAL             FTST             ! functional product in Walcek bisection solver
      REAL             HTST             ! temp diff in Walcek bisection solver
      REAL             JH2O2_BAR        ! mean H2O2 photolysis rate in subgrid cloud, 1/min
      REAL             JHNO3_BAR        ! mean HNO3 photolysis rate in subgrid cloud, 1/min
      REAL, SAVE    :: METSTEP          ! timestep on the met file
      REAL             P1               ! intermediate pressure used in calculating WL
      REAL             P2               ! intermediate pressure used in calculating WL
      REAL             P3               ! intermediate pressure used in calculating WL
      REAL             PBAR             ! mean pressure in vertical increments up from LCL along moist adiabat
      REAL             PBARC            ! mean cloud pressure (Pa)
      REAL             PMAX             ! parcel pressure
      REAL             PP               ! scratch pressure variable
      REAL             PRATE            ! total rainfall (mm/hr)
      REAL             PRATE1           ! storm rainfall rate (mm/hr)
      REAL             QENT             ! wat vap mix ratio due to cld sidewall entrainmt
      REAL             QP               ! perturbed water vap mix ratio of parcel
      REAL             QXS              ! int. excess wat ov grid cell needed for rainout
      REAL             REMOVAC          ! variable storing H+ deposition
      REAL             RHOAIR           ! air density in kg/m3
      REAL             RLH              ! relative humidity
      REAL             RLHSRC           ! relative humidity at cld src level
      REAL             RTCH             ! chemical gas const times temp
      REAL             T1               ! perturbed temp to calc neutral buoyancy also used as max temp in cell comparing cloud with environment
      REAL             TBAR             ! mean temp in vertical increments up from LCL along moist adiabat
      REAL             TBARC            ! mean cloud temp (K)
      REAL             TBASE            ! iterative temp along moist adiabat
      REAL             TDMAX            ! dew point at source level
      REAL             TEMPA            ! lower limit on temp for entrainment solver
      REAL             TEMPB            ! upper limit on temp for entrainment solver
      REAL             TEMPC            ! scratch temp solved for cloudy air parcel
      REAL             TENT             ! temp accounting for cld sidewall entrainment
      REAL             THMAX            ! parcel potential temperature
      REAL             TI               ! init temp of cloud air before evap of water
      REAL             TLCL             ! temp at LCL
      REAL             TMAX             ! perturbed temp of parcel
      REAL             TP               ! perturbed temp of parcel
      REAL             TTOP             ! scr vbl used in application of Eq. 7, W&T
      REAL             TWC              ! tot wat cont in cloud (kg H2O/m3 air)
      REAL             WCBAR            ! liq water content of cloud (kg/m3)
      REAL             WL               ! Warner profile (an earlier version appears appears in Walcek and Taylor (JAS, 1986)
      REAL             WTBAR            ! total wat cont (kg/m2) int. thru cloud depth
      REAL             X1               ! intermediate vbles in lapse rate calculation X1 also reused as scratch vble in mixing
      REAL             QDIF             ! scratch vbl used in entrainment solver
      REAL             CLOD
      REAL             LWP
      REAL             STRNS            ! intermediate to set subgrid cld transmissivity
      REAL, ALLOCATABLE, SAVE :: AECONCMIN( : ) ! array of minimum concentrations
      REAL, ALLOCATABLE, SAVE :: BMOL   ( : )   ! mol/m2 species below cloud
      REAL, ALLOCATABLE, SAVE :: CBASE0 ( : )   ! initial ave trace gas mix rat below cld
      REAL, ALLOCATABLE, SAVE :: CBASEF ( : )   ! final ave trac gas mix rat blw cld (mol/mol)
      REAL, ALLOCATABLE, SAVE :: CEND   ( : )   ! ending equiv gas phase conc (mol/mol)
      REAL, ALLOCATABLE, SAVE :: POLC   ( : )   ! ave vert conc incloud mol sp/m2 and mol sp/ mol air
      REAL, ALLOCATABLE, SAVE :: REMOV  ( : )   ! mol/m2 or mm*mol/lit scavenged
      REAL          :: DENSL( NLAYS )           ! air density (kg/m3)
      REAL, ALLOCATABLE, SAVE :: F      ( : )   ! cloud entrainment fraction to be solved for
      REAL          :: FSIDE( NLAYS )           ! sidewall entrainment vertical profile
      REAL          :: LWC  ( NLAYS )           ! liq wat cont of cloud in kg H2O/m3 air
      REAL, ALLOCATABLE, SAVE :: QICE ( : )     ! ice mixing ratio in cloud
      REAL, ALLOCATABLE, SAVE :: QLQD ( : )     ! actual liq. wat. mix ratio in cloud
      REAL          :: QVC  ( NLAYS )      ! saturation wat vap mix ratio at T1
      REAL          :: QWAT ( NLAYS )      ! liq wat mix rat, taken as total condensed water (ice + liq) profile (Eq.4, W&T)
      REAL          :: RHOM2( NLAYS )      ! mol/m2 air
      REAL          :: TCLD ( NLAYS )      ! temp of cloudy air parcel

      REAL             FRACMAX             ! max frac cov for NP cld
      REAL             PLCL                ! pressure at LCL
      REAL             QMAX                ! pertbd w.. mix rat of parcel
      REAL          :: RAIN( NCOLS,NROWS ) ! this timestep rainfall (mm/hr)
      REAL             BCLDWT              ! below cloud weighting function
      REAL, ALLOCATABLE, SAVE :: CONCMINL( :,: ) ! minimum concentrations for each species and layer
      REAL             INCLOUD        ! final conc in cloud after mix and chem [mol/mol]
      REAL             OUTCLOUD       ! final conc outside    "    "   "   "     "
      REAL, ALLOCATABLE, SAVE :: PCLD    ( :,: ) ! mol sp/mol air in cloud

      REAL          :: RC   ( NCOLS,NROWS )        ! hourly convective rainfall (cm)
      REAL          :: PBL  ( NCOLS,NROWS )        ! PBL height (m)
      REAL          :: DZZ  ( NCOLS,NROWS,NLAYS )  ! computed gridded vble
      REAL          :: DZZL ( NLAYS )              ! grid cell delta Z
      REAL          :: PRES ( NCOLS,NROWS,NLAYS )  ! file gridded vble
      REAL          :: PRESL( NLAYS )              ! grid cell pressure
      REAL          :: JH2O2( NLAYS )              ! H2O2 photolysis rate (1/min)   
      REAL          :: JHNO3( NLAYS )              ! HNO3 photolysis rate (1/min)   
      REAL          :: QAD  ( NLAYS )              ! moist adiab. sat. mix ratio
      REAL          :: QV   ( NCOLS,NROWS,NLAYS )  ! input gridded vble
      REAL          :: QVL  ( NLAYS )              ! grid cell sp. hum.
      REAL          :: TA   ( NCOLS,NROWS,NLAYS )  ! input gridded vble
      REAL          :: TAL  ( NLAYS )              ! grid cell temp
      REAL          :: TSAT ( NLAYS )              ! parcel temp along moist adiabat @ half levels
      REAL          :: ZH   ( NCOLS,NROWS,NLAYS )  ! mid-layer height (m)
      REAL          :: ZF   ( NCOLS,NROWS,NLAYS )  ! level/layer-face height (m)

      INTEGER         ALLOCSTAT

C Gridded meteorology data: Golam Sarwar, July 1, 2011 
C Latitude and longitude for zenith angle calculation:     
      REAL             COSZ                        ! local cosine of zenith angle

      CHARACTER( 120 ) :: XMSG = ' '   ! Exit status message


C...........Statement Functions

      REAL             ESAT            ! sat vap pres (Pa) as fn of T (deg K)
      REAL             QSAT            ! sat water vapor mixing ratio

      REAL             T               ! temperature dummy arg
      REAL             E               ! sat vapor pressure dummy arg
      REAL             P               ! pressure dummy arg

#ifdef isam
      REAL, ALLOCATABLE, SAVE :: SA_BASE0  ( :,: )
      REAL, ALLOCATABLE, SAVE :: SA_POLC   ( :,: )
      REAL, ALLOCATABLE, SAVE :: SA_CEND   ( :,: )
      REAL, ALLOCATABLE, SAVE :: SA_PCLD   ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_BASEF  ( :,: )
      REAL, ALLOCATABLE, SAVE :: SA_CCR    ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_CBELOW ( :,: )
      REAL, ALLOCATABLE, SAVE :: SA_REMOV  ( :,: )
      REAL, ALLOCATABLE, SAVE :: SA_BMOL   ( :,: )
      REAL, ALLOCATABLE, SAVE :: SA_CONC   ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_DS4    ( : )
      REAL, ALLOCATABLE, SAVE :: SA_INCLOUD( : )

      INTEGER, SAVE           :: S_SO2, S_SO4J, S_SULF, S_N2O5
      INTEGER, SAVE           :: C_SO2, C_SO4J, C_SULF
      INTEGER, SAVE           :: S_GLY, S_MGLY, S_AORGCJ
      INTEGER, SAVE           :: C_GLY, C_MGLY, C_AORGCJ
      REAL, ALLOCATABLE, SAVE :: SA_DCSOA_GLY    ( : )
      REAL, ALLOCATABLE, SAVE :: SA_DCSOA_MGLY   ( : )
      INTEGER CSPC

      REAL BLNC
      REAL                    :: SA_SUM
#endif


      INTERFACE
        SUBROUTINE ACMCLD ( NSP, NLAYS, F, C, DZH, CBELOW, CLBASE, CLTOP,
     &                      FRAC, TCLIFE, DTCLD )
          INTEGER, INTENT( IN ) :: NSP
          INTEGER, INTENT( IN ) :: NLAYS
          REAL, INTENT( IN )    :: F( : )
          REAL, INTENT( INOUT ) :: C( :, : )
          REAL, INTENT( IN )    :: DZH( : )
          REAL, INTENT( INOUT ) :: CBELOW( : )
          INTEGER, INTENT( IN ) :: CLBASE
          INTEGER, INTENT( IN ) :: CLTOP
          REAL, INTENT( IN )    :: FRAC
          REAL, INTENT( IN )    :: TCLIFE
          REAL, INTENT( IN )    :: DTCLD
        END SUBROUTINE ACMCLD

        SUBROUTINE SCAVWDEP ( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                        CTHK1, AIRM, PRATE1, TAUCLD, POLC, CEND,
     &                        REMOV, REMOVAC, ALFA0, ALFA2, ALFA3 )
          INTEGER, INTENT( IN )  :: JDATE, JTIME
          REAL,    INTENT( IN )  :: WTBAR, WCBAR, TBARC, PBARC,
     &                              CTHK1, AIRM, PRATE1, TAUCLD
          REAL,    INTENT( IN )  :: POLC ( : )
          REAL,    INTENT( OUT ) :: CEND( : ), REMOV( : )
          REAL,    INTENT( OUT ) :: REMOVAC
          REAL,    INTENT( OUT ) :: ALFA0, ALFA2, ALFA3
        END SUBROUTINE SCAVWDEP

        SUBROUTINE AQ_MAP( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                     CTHK1, AIRM, PRATE1, TAUCLD, POLC, CEND,
     &                     REMOV, REMOVAC, ALFA0, ALFA2, ALFA3, COSZ )
          INTEGER, INTENT( IN )    :: JDATE, JTIME
          REAL,    INTENT( IN )    :: WTBAR, WCBAR, TBARC, PBARC,
     &                                CTHK1, AIRM, PRATE1, TAUCLD
          REAL,    INTENT( IN )    :: POLC ( : )
          REAL,    INTENT( INOUT ) :: CEND( : ), REMOV( : )
          REAL,    INTENT( INOUT ) :: REMOVAC
          REAL,    INTENT( IN )    :: ALFA0, ALFA2, ALFA3, COSZ
        END SUBROUTINE AQ_MAP
      END INTERFACE

      ESAT( T ) = VP0PA * EXP( C303 - ( C302 / T ) )

      QSAT( E, P ) = MVOMA * ( E / ( P - E ) )

C-----------------------------------------------------------------------
C  begin body of subroutine CONVCLD_ACM

C...INITIALIZATION for the CONVCLD_ACM module:
C...  event-statistics variables.

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

C...Sulfur tracking
        IF ( STM ) THEN
          CALL MAP_AERO()
          CALL MAP_PRECURSOR()
        END IF

        IF ( N_AE_SPC .GT. 0 ) THEN
          ALLOCATE ( AECONCMIN( N_AE_SPC ), STAT = ALLOCSTAT )
          IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AECONCMIN'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          END IF
          CALL SET_AECONCMIN ( AECONCMIN )

        END IF

C cccccccccccccccccccc enable backward compatiblity ccccccccccccccccccccc

         IF (RCA_AVAIL) THEN
           RC_NAME = 'RCA'
        ELSE
           RC_NAME = 'RC'
        END IF

C...store met file time, date, and step information and compute
C...  the met timestep in hours

        SDATE = cio_model_sdate
        STIME = cio_model_stime
        MSTEP = file_tstep(f_met) 

#ifdef mpas
          call get_env (mpas_cmaq_freq, 'mpas_cmaq_freq', 1)
          METSTEP = (FLOAT( TIME2SEC( MSTEP ) )/FLOAT(mpas_cmaq_freq)) / 3600.0
          !metstep is coupling frequency but rain is per mpas time step
#else

        METSTEP = FLOAT( TIME2SEC( MSTEP ) ) / 3600.0
#endif

C...check convective precipitation on met files to determine if WRF used
C...  a convective parameterization
C...in coordination with MCIPv4.0, negative values will be loaded into the RC
C...  field if a convective parameterization was not used in the WRF simulation

        call interpolate_var (RC_NAME, sdate, stime, RC)

        IF ( .NOT. CONVECTIVE_SCHEME) RETURN

C...allocate saved arrays

        ALLOCATE ( F( NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating F'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE ( DZH( NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating DZH'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        MXSPCS = NSPCSD

        ALLOCATE ( CCR   ( MXSPCS,NLAYS ),
     &             CONC  ( MXSPCS,NLAYS ),
     &             CBELOW( MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating CCR, CONC or CBELOW'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE ( BMOL   ( MXSPCS ),
     &             CBASE0 ( MXSPCS ),
     &             CBASEF ( MXSPCS ),
     &             CEND   ( MXSPCS ),
     &             POLC   ( MXSPCS ),
     &             REMOV  ( MXSPCS ), 
     &             QLQD   ( NLAYS ), 
     &             QICE   ( NLAYS ), 
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating BMOL, CBASE0, CBASEF, CEND, POLC, REMOV,'
     &         // ' QLQD or QICE'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE ( CONCMINL( MXSPCS,NLAYS ),
     &             PCLD    ( MXSPCS,NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating CONCMINL or PCLD'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

C...Calculate the Sundqvist et al. 1989 threshold humidities for cloud formation based on 
C...Mocko and Cotton (1995)
#ifdef mpas
        ALLOCATE ( RCRITL( NCOLS,NROWS ),
     &             RCRITW( NCOLS,NROWS ),
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'EXIT: Failure allocating RCRITL, RCRITW'
           call prog_interrupt (PNAME, JDATE, JTIME, XMSG, 1)
        END IF
      DO ROW = 1, NROWS
        DO COL = 1, NCOLS
          XKM = (cell_area(COL,ROW)**0.5)/1000
          RCRITW(COL,ROW) = 0.879 + SQRT( 1.0 / ( 100.0 + XKM * XKM  ))
          RCRITL(COL,ROW) = 0.839 + SQRT( 1.0 / ( 50.0 + 0.5 * XKM ** 3 ) )
        END DO
      END DO
#else
        XKM = REAL( XCELL_GD / 1000 )
        RCRITW = 0.879 + SQRT( 1.0 / ( 100.0 + XKM * XKM ) )
        RCRITL = 0.839 + SQRT( 1.0 / ( 50.0 + 0.5 * XKM ** 3 ) )
#endif

C...Sulfur tracking
        IF ( STM ) THEN

C...initialize surrogate array
          ALLOCATE ( SURCLDMX( MXSPCS ), STAT = ALLOCSTAT )
          DO SPC = 1, NSPCSD
            SURCLDMX( SPC ) = SPC
          END DO

C...set cloud mixing surrogates for the sulfate tracking species

          DO M = 1, N_MODE

            SURCLDMX( AEROSPC_MAP( ASO4GAS_IDX, M ) ) = AEROSPC_MAP( ASO4_IDX,M )
            SURCLDMX( AEROSPC_MAP( ASO4EMIS_IDX,M ) ) = AEROSPC_MAP( ASO4_IDX,M )
            SURCLDMX( AEROSPC_MAP( ASO4ICBC_IDX,M ) ) = AEROSPC_MAP( ASO4_IDX,M )

C...  for the accumulation mode, add aqueous tracked species

            IF ( M .EQ. 2 ) THEN

              SURCLDMX( AEROSPC_MAP( ASO4AQH2O2_IDX,M ) ) = AEROSPC_MAP( ASO4_IDX,M )
              SURCLDMX( AEROSPC_MAP( ASO4AQO3_IDX,  M ) ) = AEROSPC_MAP( ASO4_IDX,M )
              SURCLDMX( AEROSPC_MAP( ASO4AQFEMN_IDX,M ) ) = AEROSPC_MAP( ASO4_IDX,M )
              SURCLDMX( AEROSPC_MAP( ASO4AQMHP_IDX, M ) ) = AEROSPC_MAP( ASO4_IDX,M )
              SURCLDMX( AEROSPC_MAP( ASO4AQPAA_IDX, M ) ) = AEROSPC_MAP( ASO4_IDX,M )

            END IF

            IF ( ( AE6ISOA ) .OR.
     &           ( INDEX( MECHNAME, 'CB6R5_AE7'  ) .GT. 0 ) .OR.
     &           ( INDEX( MECHNAME, 'CB6R5M_AE7' ) .GT. 0 ) ) THEN
    
C...  for the accumulation mode, add aqueous tracked species

              IF ( M .EQ. 2 ) THEN

                SURCLDMX( AEROSPC_MAP( OSO4GAS_IDX,   M ) ) = AEROSPC_MAP( OSO4_IDX,M )
                SURCLDMX( AEROSPC_MAP( OSO4EMIS_IDX,  M ) ) = AEROSPC_MAP( OSO4_IDX,M )
                SURCLDMX( AEROSPC_MAP( OSO4ICBC_IDX,  M ) ) = AEROSPC_MAP( OSO4_IDX,M )
                SURCLDMX( AEROSPC_MAP( OSO4AQH2O2_IDX,M ) ) = AEROSPC_MAP( OSO4_IDX,M )
                SURCLDMX( AEROSPC_MAP( OSO4AQO3_IDX,  M ) ) = AEROSPC_MAP( OSO4_IDX,M )
                SURCLDMX( AEROSPC_MAP( OSO4AQFEMN_IDX,M ) ) = AEROSPC_MAP( OSO4_IDX,M )
                SURCLDMX( AEROSPC_MAP( OSO4AQMHP_IDX, M ) ) = AEROSPC_MAP( OSO4_IDX,M )
                SURCLDMX( AEROSPC_MAP( OSO4AQPAA_IDX, M ) ) = AEROSPC_MAP( OSO4_IDX,M )

              END IF

            END IF

          END DO

          SPC = 0
          STRT = AE_STRT
          FINI = AE_STRT - 1 + N_AE_SPC
          DO VAR = STRT, FINI
            SPC = SPC + 1
            WRITE( XMSG, '(i6,1x,A16,1x,i6,1x,a16)') VAR, AE_SPC( SPC ), SURCLDMX( VAR ), AE_SPC( SURCLDMX( VAR )-AE_STRT+1 )
             CALL M3MESG ( XMSG )
          END DO

        END IF ! stm

#ifdef isam
C Move this to a better place later
        S_SO2  = INDEX1( 'SO2', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )
        S_SO4J = INDEX1( 'ASO4J', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )
        S_SULF = INDEX1( 'SULF', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )
        S_N2O5 = INDEX1( 'N2O5', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )

        C_SO2  = INDEX1( 'SO2',   N_GC_SPC, GC_SPC )
        C_SO4J = INDEX1( 'ASO4J', N_AE_SPC, AE_SPC ) + 1 + N_GC_SPC
        C_SULF = INDEX1( 'SULF',  N_GC_SPC, GC_SPC )

        ALLOCATE ( SA_BASE0  ( NSPC_SA, NTAG_SA ),
     &             SA_BASEF  ( NSPC_SA, NTAG_SA ),
     &             SA_POLC   ( NSPC_SA, NTAG_SA ),
     &             SA_CEND   ( NSPC_SA, NTAG_SA ),
     &             SA_PCLD   ( NSPC_SA, NLAYS, NTAG_SA ),
     &             SA_CCR    ( NSPC_SA, NLAYS, NTAG_SA ),
     &             SA_CBELOW ( NSPC_SA, NTAG_SA ),
     &             SA_REMOV  ( NSPC_SA, NTAG_SA ),
     &             SA_BMOL   ( NSPC_SA, NTAG_SA ),
     &             SA_CONC   ( NSPC_SA, NLAYS, NTAG_SA ),
     &             SA_DS4    ( NTAG_SA ),
     &             SA_INCLOUD( NTAG_SA ),
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating SA arrays'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        S_GLY    = INDEX1( 'GLY', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )
        S_MGLY   = INDEX1( 'MGLY', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )
        S_AORGCJ = INDEX1( 'AORGCJ', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )

        C_GLY    = INDEX1( 'GLY',   N_GC_SPC, GC_SPC )
        C_MGLY   = INDEX1( 'MGLY', N_GC_SPC, GC_SPC )
        C_AORGCJ = INDEX1( 'AORGCJ',  N_AE_SPC, AE_SPC ) + 1 + N_GC_SPC
        ALLOCATE ( SA_DCSOA_GLY ( NTAG_SA ),
     &             SA_DCSOA_MGLY ( NTAG_SA ),
     &             STAT = ALLOCSTAT )
#endif

#ifdef sens
        IF ( .NOT. ALLOCATED( S_CEND ) ) ALLOCATE ( S_CEND ( NPMAX, MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_CEND'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( .NOT. ALLOCATED( S_POLC ) ) ALLOCATE ( S_POLC ( NPMAX, MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_POLC'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( .NOT. ALLOCATED( S_REMOV ) ) ALLOCATE ( S_REMOV ( NPMAX, MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_REMOV'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( .NOT. ALLOCATED( S_REMOVAC ) ) ALLOCATE ( S_REMOVAC ( NPMAX ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_REMOVAC'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        S_REMOVAC = 0.0

        IF ( .NOT. ALLOCATED( S_CCR ) ) ALLOCATE ( S_CCR ( NPMAX,MXSPCS,NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_CCR'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        S_CCR = 0.0D0

        IF ( .NOT. ALLOCATED( S_CBELOW ) ) ALLOCATE ( S_CBELOW ( NPMAX,MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_REMOVAC'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        S_CBELOW = 0.0D0

        ALLOCATE ( S_CONC  ( NPMAX,MXSPCS,NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_CONC'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE ( S_BMOL   ( NPMAX,MXSPCS ),
     &             S_CBASE0 ( NPMAX,MXSPCS ),
     &             S_CBASEF ( NPMAX,MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_BMOL, S_CBASE0, or S_CBASEF'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE ( S_BCLDWT  ( NPMAX,MXSPCS,NLAYS ),
     &             S_INCLOUD ( NPMAX,MXSPCS,NLAYS ),
     &             S_OUTCLOUD( NPMAX,MXSPCS,NLAYS ),
     &             S_PCLD    ( NPMAX,MXSPCS,NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_BCLDWT, S_INCLOUD, S_OUTCLOUD or S_PCLD'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
#endif

      END IF   ! Firstime

      IF ( .NOT. CONVECTIVE_SCHEME) RETURN

C...check option for processing clouds on the synchronization timestep

      IF ( SYNCCLD ) THEN

        MDATE = JDATE
        MTIME = JTIME

C...set the cloud timestep (=adv timestep)

        STEP  = TIME2SEC( TSTEP( 2 ) )         ! synchronization timestep
        DTCLD = REAL( STEP )

C...set time to the midpoint of this timestep for data interpolation

        CALL NEXTIME ( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

C...otherwise, revert back to processing convective cloud once per hour
C...  on the half hour

      ELSE

C...Check to see if this time step contains the half-hour
C...  if it does not, then return

        MDATE = JDATE
        MTIME = 10000 * ( JTIME / 10000 )      ! on the current hour
        STEP  = TIME2SEC( TSTEP( 2 ) )         ! synchronization timestep
        DTCLD = TCLIFE

C...  set mdate:mtime to one-half step before the half-hour

        CALL NEXTIME ( MDATE, MTIME, SEC2TIME( 1800 - ( STEP / 2 ) ) )

        ATIME = SECSDIFF( MDATE, MTIME, JDATE, JTIME )

        IF ( ( ATIME .LT. 0 ) .OR. ( ATIME .GE. STEP ) ) RETURN

C...the current timestep overlaps the half hour point
C...  set the time to the half hour for data interpolation

        MTIME = 10000 * ( JTIME / 10000 ) + 3000
      
      END IF

C...clear arrays that capture ACM cloud results

C...ACTUAL SCIENCE PROCESS (loop on internal process time steps):
C...  Interpolate time dependent layered input variables
C...  (reading those variables for which it is necessary)

C...  Get ambient temperature (K)
      call interpolate_var ('TA', mdate, mtime, TA)

C...Get specific humidity (kg H2O / kg air)
      call interpolate_var ('QV', mdate, mtime, QV)

C...Get level heights / layer faces (m)
      call interpolate_var ('ZF', mdate, mtime, ZF)

C...Get mid-layer heights (m)
      call interpolate_var ('ZH', mdate, mtime, ZH)

C...Get pressure (Pa)
      call interpolate_var ('PRES', mdate, mtime, PRES)

C...compute layer thicknesses (m)
      DO ROW = 1, NROWS
        DO COL = 1, NCOLS
          DZZ( COL,ROW, 1 ) = ZF( COL,ROW, 1 )
          DO LAY = 2, NLAYS
            DZZ( COL,ROW,LAY ) = ZF( COL,ROW,LAY ) - ZF( COL,ROW,LAY - 1 )
          END DO
        END DO
      END DO

C...Get PBL height (m)
      call interpolate_var ('PBL', mdate, mtime, PBL)

C...advance the MDATE and MTIME to the next time on the met file
C...  to get ready to read the precipitation amounts.
C...  Precipitation data WILL NOT BE INTERPOLATED!  Precipitation data
C...  on the input file are amounts within the metfiles timestep.

      IF ( .NOT. CURRSTEP( JDATE, JTIME, SDATE, STIME, MSTEP,
     &                     MDATE, MTIME ) ) THEN
        XMSG = 'Cannot get step-starting date and time'
        CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      END IF

      CALL NEXTIME ( MDATE, MTIME, MSTEP )  ! set mdate:mtime to the hour

C...Get convective precipitation amount (cm)

      call interpolate_var (RC_NAME, mdate, mtime, RC)

C...Convert the rainfall rate into mm/hr, then set a flag noting the
C...  presence of raining clouds if the rainfall is above the specified
C...  threshold

      DO ROW = 1, NROWS
        DO COL = 1, NCOLS
          RAIN( COL,ROW ) = 10.0 * RC( COL,ROW ) / METSTEP
        END DO
      END DO
      IF ( MINVAL( RAIN ) .LT. 0.0 ) THEN
        XMSG = 'NEGATIVE RAIN...PROBABLY BAD MET DATA... in' // MET_CRO_2D
        CALL M3EXIT ( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
      END IF
      WHERE ( RAIN .GE. RTHRESH ) CONV_DEP( :,:,N_SPC_WDEP + 6 ) = 1.0

C...Loop through all grid cells

      DO ROW = 1, NROWS
        DO COL = 1, NCOLS

          QLQD = 0.0
          QICE = 0.0

          CLBASE = NLAYS
          CLTOPUSTBL = NLAYS
          QMAX  = 0.0
          PLCL  = 0.0
          SRCLAY = NLAYS

          DO LAY = 1, NLAYS
            QAD( LAY ) = 0.0
            PRESL( LAY ) = PRES( COL,ROW,LAY )
            TAL( LAY )   = TA( COL,ROW,LAY )
            QVL( LAY )   = QV( COL,ROW,LAY )
            DZZL( LAY )  = DZZ( COL,ROW,LAY )
            DENSL( LAY ) = PRESL( LAY )
     &                   / ( RDGAS * TAL( LAY ) * ( 1.0 + RWVAP * QVL( LAY ) / RDGAS ) )
            JH2O2( LAY ) = RJ_SUB( COL,ROW,LAY,LH2O2_PHOTOLYSIS )
            JHNO3( LAY ) = RJ_SUB( COL,ROW,LAY,LHNO3_PHOTOLYSIS )
          END DO

C...load aerosol minimum concentrations into the "CONCMINL" array
C...  initialize all species to CMIN

!         CONCMINL = CMIN
          CONCMINL = 1.0E-25

#ifdef sens
          DDM3D_CONCMINL = 1.0D-15
#endif

C...  set minimum for aerosol species

          SPC = 0
          STRT = AE_STRT
          FINI = AE_STRT - 1 + N_AE_SPC
          DO VAR = STRT, FINI
            SPC = SPC + 1
            DO LAY = 1, NLAYS
              CONCMINL( VAR,LAY ) = AECONCMIN( SPC ) / DENSL( LAY )
            END DO
          END DO

          DO LAY = 1, NLAYS
            DO SPC = 1, NSPCSD
              CONC( SPC,LAY ) = MAX( CGRD( COL,ROW,LAY,SPC ),
     &                                  CONCMINL( SPC,LAY ) )
#ifdef sens
              DO NP = 1, NPMAX
                IF ( CGRD( COL,ROW,LAY,SPC ) .LT. CONCMINL( SPC, LAY ) ) THEN
                  S_CONC( NP, SPC, LAY ) = 0.0D0
                ELSE
                  S_CONC( NP, SPC, LAY ) = REAL ( SENGRID( COL, ROW, LAY, NP, SPC ), 8 )
                END IF
              END DO
#endif
            END DO
          END DO

#ifdef isam         
          DO SPC = 1, NSPC_SA
            CSPC = MAP_SAtoCGR(SPC)
            DO ITAG = 1, NTAG_SA
              DO LAY = 1, NLAYS
                SA_CONC( SPC,LAY,ITAG ) = MAX( ISAM( COL,ROW,LAY,SPC,ITAG ),
c    &                                    CONCMINL( CSPC,LAY ) )
     &                                    1.0E-30 )
              END DO
            END DO
          END DO
#endif


C...Test for raining clouds
C...If the rainfall amount is below the specified threshold, then set
C...  values for some of the parameters which will be used when the
C...  routine is called again for non-precipitating clouds...then
C...  skip to the next grid cell.

          IF ( RAIN( COL,ROW ) .GE. RTHRESH ) THEN
            ICLDTYPE = 1
            PRATE = RAIN( COL,ROW )
            FRACMAX = 0.0
          ELSE
            ICLDTYPE = 2
            FRACMAX = 0.5
          END IF

C...Determine cloud source level by determining equivalent
C...   potential temperature profile given perturbed temperature
C...   and water vapor to account for local hot spots which
C...   initiate convection.  Layer with maximum equivalent
C...   potential temperature is cloud source layer.

          SRCLAY = 1
          TMAX  = TAL( 1 ) + PERT
          QMAX  = QVL( 1 ) + PERQ
          PMAX  = PRESL( 1 )
          THMAX = TMAX * ( 1.0E+05 / PMAX ) ** ROVCP
          EQTHM = THMAX * EXP( LVOCP * QMAX / TMAX )

          DO LAY = 2, NLAYS

            PP = PRESL( LAY )

            IF ( ZH( COL,ROW,LAY ) .GT. 3000.0 ) EXIT   ! 650 mb

            TP = TAL( LAY ) + PERT
            QP = QVL( LAY ) + PERQ
            THMAX = TP * ( 1.0E+05 / PP ) ** ROVCP
            EQTH = THMAX * EXP( LVOCP * QP / TP )

            IF ( EQTH .GT. EQTHM ) THEN
              TMAX = TP
              SRCLAY = LAY
              QMAX  = QP
              PMAX = PP
              EQTHM = EQTH
            END IF

          END DO

C...Equivalent potential temp max is now known between LAY 1
C...   and 650 mb. We now proceed to compute lifting condensation
C...   level. First, compute vapor pressure at the source level.
C...   Find dewpoint using empirical relationship, avoiding
C...   supersaturation. Then compute dew point lapse rate -
C...   see Walcek and Taylor, 1986.

          EMAX  = QMAX * PMAX / ( MVOMA + QMAX )
          TDMAX = C302 / ( C303 - LOG( EMAX * VPINV ) )
          TDMAX = MIN( TDMAX, TMAX )
          DPLR  = ( GRAV * TDMAX * TDMAX ) / ( MVOMA * LV0 * TMAX )

c...Compute difference between dry adiabatic and dew point lapse
C...   rate, height increment above source level to reach LCL,
C...   then calculate value of pressure at LCL.  Save result
C...   in CONV_DEP( *,*,N_SPC_WDEP+2 ).

          DAMDP = DALR - DPLR

          IF ( DAMDP .LE. 0.0 ) THEN

            DZLCL = 0.0
            PLCL = PMAX
C...walcek formula
            TLCL = TMAX
C...walcek formula

          ELSE

            DZLCL = ( TMAX - TDMAX ) / DAMDP
C...walcek formula
            TLCL = TMAX - DALR * DZLCL
C...walcek formula
            TBAR = TMAX - 0.5 * DALR * DZLCL   !  midpt of TMAX, TLCL
            TBAR = MAX( TBAR , 150.0 )
            PLCL = PMAX * EXP( -( GRAV / RDGAS ) * DZLCL / TBAR )
            ZLCL = DZLCL + ZH( COL,ROW, SRCLAY )

          END IF

          CONV_DEP( COL,ROW, N_SPC_WDEP + 2 ) = PLCL

C...Determine cloud base at LAY in  which LCL resides,
C...  but not below layer 2.

C...plcl above middle of top layer

          IF ( PRESL( NLAYS ) .GE. PLCL ) THEN
            PLCL = PRESL( NLAYS )
            CLBASE = NLAYS
            CLTOP = CLBASE
            WRITE( LOGDEV,* ) ' WARNING: PLCL above top: Continuing'

C...search loop to find CLBASE

          ELSE

            CLBASE = NLAYS
            DO LAY = NLAYS, 2, -1
              IF ( PRESL( LAY ) .LE. PLCL ) CLBASE = LAY
            END DO

          END IF      ! if plcl < ptop or , or ...

C...CLBASE is LAY of LCL. Now, determine cloud top by following
C...   moist adiabat up from CLBASE. Assume a stable sounding
C...   (ISOUND=0) at first.  Moist adiabat solver calculates
C...   saturation temperatures TF at the full levels and TSAT( COL,ROW,LAY )
C...   at the half-levels, using a 2nd order Runge method employing
C...   temperatures and pressures at the quarter-levels.

          ISOUND = 0
          DO 255 LAY = CLBASE, NLAYS

C...walcek formulas

            DP   = PRESL( LAY - 1 ) - PRESL( LAY )
            PBAR = PRESL( LAY - 1 ) - DP * 0.5
            IF ( LAY .EQ. CLBASE ) THEN
              DP    = PLCL - PRESL( LAY )
              PBAR  = PLCL - DP * 0.5
              TBASE = TLCL
            END IF

            TBAR = MAX( TBASE - 0.00065 * DP, 150.0 )
            X1 = LV0 * QSAT( ESAT( TBAR ), PBAR ) / ( RDGAS * TBAR ) ! Walcek's
            DTDP = ( ( RDGAS * TBAR ) / ( PBAR * CPD ) )             ! original
     &           * ( ( 1.0 + X1 )                                    ! formulas
     &           / ( 1.0 + ( 0.622 * LVOCP / TBAR ) * X1 ) )
            TSAT( LAY ) = MAX( TBASE - DP * DTDP, 150.0 )
            QAD ( LAY ) = QSAT( ESAT( TSAT( LAY ) ), PRESL( LAY ) )
            TBASE = TSAT( LAY )

C...end Walcek formulas

C...QAD is the moist adiabatic saturation mixing ratio, needed
C...  for the entrainment solver
C...  Now make choice on stability of sounding, comparing parcel
C...  temperature TSAT with environmental temperature TA.
C...  ISOUND is index for sounding stability. If ISOUND=0,
C...  moist adiabat never warmer than environment (stable).
C...  ISOUND=1, moist adiabat becomes warmer than environment
C...  (unstable).

            IF ( ISOUND .EQ. 0 ) THEN
              IF ( TSAT( LAY ) .GT. TAL( LAY ) ) ISOUND = 1
            ELSE           ! cloud top determined by neutral bouyancy
              T1 = TSAT( LAY ) ! - 0.5 * PERT
              IF ( T1 .LT. TAL( LAY ) ) THEN
                CLTOP = LAY - 1
                GO TO 256
              END IF
            END IF

255       CONTINUE            !  end loop following moist adiabat

          CLTOP = NLAYS - 1   !  if you get here:  cloud stable or no top

256       CONTINUE

C...At this point, if ISOUND has not been set to 1, we have a
C...  "stable" cloud. In this case, we find cloud top by relative
C...   humidity criterion, or, not let cloud top go above 600mb.

          IF ( ISOUND .EQ. 0 ) THEN
            IF ( ICLDTYPE .NE. 1 ) CYCLE ! Loop to next row-column coordinate

            DO 265 LAY = CLBASE + 1, NLAYS
              IF ( PRESL( LAY ) .LE. 60000.0 ) THEN
                CLTOP = LAY - 1
                GO TO 267        ! loop exit
              END IF
              RLH = QVL( LAY ) / QSAT( ESAT( TAL( LAY ) ), PRESL( LAY ) )
              IF ( RLH .LT. 0.65 ) THEN
                CLTOP = LAY - 1
                GO TO 267        ! loop exit
              END IF
265         CONTINUE

            CLTOP = NLAYS - 1   ! if you get here:  top never found

          ELSE

            CLTOPUSTBL = CLTOP  ! store unstable cloud top

          END IF

267       CONTINUE   ! loop exit target

          CONV_DEP( COL,ROW, N_SPC_WDEP + 3 ) = FLOAT( CLBASE )

          IF ( ICLDTYPE .EQ. 1 ) THEN    !  store raining cloud top and proceed

            CONV_DEP( COL,ROW, N_SPC_WDEP + 4 ) = FLOAT( CLTOP )

          ELSE                      !  get cloud top for either CNP or PFW

            IF ( ZLCL .GT. PBL( COL,ROW ) ) CYCLE ! Loop to next row-column coordinate

C...compute relative humidity at the cloud source level

            RLHSRC = MIN( 1.0, QVL( SRCLAY )
     &                        / QSAT( ESAT( TAL( SRCLAY ) ), PRESL( SRCLAY ) ) )

C...If all tests pass, then a CNP or PFW cloud exists
C...  Proceed to find CLTOP for CNP or PFW; don`t allow
C...  cloud top to exceed 500mb, or, when RH falls below
C...  65%, cloud top found

C...Distiguish between CNP and PFW by whether rain is falling
C...  in the cell; if PFW, limit depth and find new CLTOP,
C...  else leave CLTOP alone

            IF ( CLTOP .EQ. CLBASE ) THEN
              GO TO 322
            ELSE                   ! confine PFW to 1500 meters
              CTOP = CLTOP

              DO LAY = CTOP, CLBASE, -1
                IF ( ZH( COL,ROW,LAY ) - ZH( COL,ROW,CLBASE ) .LE. 3000.0 ) THEN
                  CLTOP = LAY
                  GO TO 322   ! exit loop
                END IF
              END DO

            END IF

322         CONTINUE     ! loop exit for PFW cloud

C...If unstable CNP or PFW, limit CLTOP to CLTOPUSTBL so that
C...  QAD profile is known through cloud depth for entrainment
C...  solver

            IF ( ISOUND .EQ. 1 ) CLTOP = MIN( CLTOP, CLTOPUSTBL )

C...Now compute fractional coverage for either CNP or PFW:
C...Now based on Sunqdvist et al. 1989 DOI: 10.1175/1520-0493(1989)117<1641:CACPSW>2.0.CO;2 
            FRAC = 0.0
            IF ( GRID_DATA%LWMASK( COL,ROW ) .EQ. 1.0 ) THEN   ! land
#ifdef mpas
               IF ( RLHSRC .GE. RCRITL(COL,ROW) )
     &            FRAC = 1.0 - SQRT( ( 1.0 - RLHSRC ) / ( 1.0 - RCRITL(COL,ROW) ) )
            ELSE   ! water
               IF ( RLHSRC .GE. RCRITW(COL,ROW) )
     &            FRAC = 1.0 - SQRT( ( 1.0 - RLHSRC ) / ( 1.0 - RCRITW(COL,ROW) ) )
#else
               IF ( RLHSRC .GE. RCRITL )
     &            FRAC = 1.0 - SQRT( ( 1.0 - RLHSRC ) / ( 1.0 - RCRITL ) )
            ELSE   ! water
               IF ( RLHSRC .GE. RCRITW )
     &            FRAC = 1.0 - SQRT( ( 1.0 - RLHSRC ) / ( 1.0 - RCRITW ) )
#endif
            END IF
            FRAC = MAX( 0.0, MIN( FRAC, 0.95 ) )

            IF ( FRAC .LT. 0.01 ) CYCLE  ! Loop to next row-column coordinate

            CONV_DEP( COL,ROW, N_SPC_WDEP + 5 ) = FLOAT( CLTOP ) ! store NP cloud top
            CONV_DEP( COL,ROW, N_SPC_WDEP + 8 ) = FRAC

          END IF  ! end of existence, depth and frac cov calc for
                  ! either PFW or CNP clouds

C...Now cloud existence is established, initialize various
C...  variables needed for rest of computations

C...First, get mol air/m2 at each layer, initialize FSIDE

          DO LAY = 1, NLAYS
            RHOM2( LAY ) = DENSL( LAY ) * DZZL( LAY ) * 1.0E3 / MWAIR
            FSIDE( LAY ) = 0.0
          END DO

          DO SPC = 1, NSPCSD
            REMOV( SPC ) = 0.0  ! mol/m2 or mm*mol/lit scavenged
            CEND ( SPC ) = 0.0  ! ending equiv gas phase conc (mol/mol)
            BMOL ( SPC ) = 0.0  ! mol/m2 species below cloud
            POLC ( SPC ) = 0.0  ! mol/m2 species in cloud

            DO LAY = 1, NLAYS
              PCLD( SPC,LAY ) = 0.0  ! mol sp/mol air in cloud
            END DO

          END DO

#ifdef sens
          S_REMOV  = 0.0D0
          S_CEND   = 0.0D0
          S_BMOL   = 0.0D0
          S_POLC   = 0.0D0
          S_BCLDWT = 0.0D0
          S_PCLD   = 0.0D0
#endif

C...compute no. of moles air below cloud base and inverse

          AIRMB0 = 0.0
          DO LAY = 1, CLBASE - 1
            AIRMB0 = AIRMB0 + RHOM2( LAY )
          END DO

C...take the inverse

          AIRMBI = 1.0 / AIRMB0

C...below cloud base

          DO LAY = 1, CLBASE - 1

C...determine no. of mol/m2 of trace gas

            DO SPC = 1, NSPCSD
              BMOL( SPC ) = BMOL( SPC ) + CONC( SPC,LAY ) * RHOM2( LAY )
#ifdef sens
              DO NP = 1, NPMAX
                S_BMOL( NP,SPC ) = S_BMOL( NP,SPC )
     &                    + S_CONC( NP,SPC,LAY ) * REAL ( RHOM2( LAY ), 8 )
              END DO
#endif
            END DO

          END DO

C...determine average trace gas mixing ratio below cloud level

          DO SPC = 1, NSPCSD
            CBASE0( SPC ) = BMOL( SPC ) * AIRMBI
            CBASEF( SPC ) = CBASE0( SPC )
#ifdef sens
            DO NP = 1, NPMAX
              S_CBASE0( NP,SPC ) = S_BMOL( NP,SPC ) * REAL ( AIRMBI, 8 )
              S_CBASEF( NP,SPC ) = S_CBASE0( NP,SPC )
            END DO
#endif
          END DO

#ifdef isam
          SA_BMOL  = 0.0
          SA_REMOV = 0.0
          SA_CEND  = 0.0
          SA_PCLD  = 0.0
          SA_POLC  = 0.0

          DO ITAG = 1, NTAG_SA
            DO LAY = 1, CLBASE - 1
              DO SPC = 1, NSPC_SA
                SA_BMOL( SPC,ITAG ) = SA_BMOL( SPC,ITAG ) +
     &                              + SA_CONC( SPC,LAY,ITAG )
     &                              * RHOM2( LAY )
              END DO
            END DO
          END DO

          DO ITAG = 1, NTAG_SA
            DO SPC = 1, NSPC_SA
              SA_BASE0(SPC,ITAG) = SA_BMOL( SPC,ITAG ) * AIRMBI
              SA_BASEF(SPC,ITAG) = SA_BASE0(SPC,ITAG)
            END DO
          END DO
#endif


C...Initialize variables needed for entrainment and in-cloud properties solver

          QXS =   0.0  ! integrated excess water over grid cell nec. for rnout
          AIRM =  0.0  ! total air mass (mol/m2) in cloudy layers
          PBARC = 0.0  ! in-cloud average pressure
          CTHK  = 0.0  ! cloud thickness (m)
          WCBAR = 0.0  ! condensed wat cont (kg/m2) integ. thru cloud depth
          WTBAR = 0.0  ! total wat cont (kg/m2) integrated thru cloud depth
          TBARC = 0.0  ! cloud mean temp (K)
          JH2O2_BAR = 0.0 ! cloud H2O2 photolysis, 1/min
          JHNO3_BAR = 0.0 ! cloud HNO3 photolysis, 1/min


C...Determine condensed water content and entrainment at each cloud level
C...Determine FSIDE profile for raining clouds; side entrainment
C...  only for PFW and CNP clouds

          IF ( ICLDTYPE .EQ. 1 ) THEN   ! raining cloud

            IF ( CLBASE .EQ. CLTOP ) THEN
              FSIDE( CLBASE ) = 1.0
            ELSE

              DO LAY = CLBASE, CLTOP
                FSIDE( LAY ) = 1.0
              END DO

            END IF

          ELSE                    ! CNP or PFW

            DO LAY = CLBASE, CLTOP
              FSIDE( LAY ) = 1.0
            END DO

          END IF

C...Use Warner profile to close system of conservation and
C...  thermodynamic equations solved iteratively, using Secant solver

          DO LAY = CLBASE, CLTOP
            WL = 0.7 * EXP( ( PRESL( LAY ) - PLCL ) * 0.000125 ) + 0.2

            IF ( LAY .EQ. CLBASE ) THEN
              P1 = 0.5 * ( PRESL( LAY ) + PRESL( LAY - 1 ) )

              IF ( PLCL .LT. P1 ) THEN
                P2 = 0.5 * ( PRESL( LAY + 1 ) + PRESL( LAY ) )
                P3 = ( P2 + PLCL ) * 0.5
                WL = 0.7 * EXP( ( P3 - PLCL ) * 0.000125 ) + 0.2
              END IF

            END IF

c...original Walcek bisection solver

            QWAT( LAY ) = WL * ( QMAX - QAD( LAY ) )
            QWAT( LAY ) = MAX( QWAT( LAY ), 1.0E-20 )

            TEMPA = TSAT( LAY ) - 20.0
            TEMPB = TSAT( LAY ) + 10.0

            QENT = FSIDE( LAY ) * QVL( LAY )
     &           + ( 1.0 - FSIDE( LAY ) ) * QVL( CLTOP )
            QDIF = QENT - QMAX
            IF ( QDIF .EQ. 0.0 ) QDIF = 1.0E-10
            F( LAY ) = ( QSAT( ESAT( TEMPA ), PRESL( LAY ) )
     &               + QWAT( LAY ) - QMAX ) / QDIF
            F( LAY ) = MIN( F( LAY ), 1.0 )
            F( LAY ) = MAX( F( LAY ), 0.0 )

            TTOP = TAL( CLTOP ) * ( PRESL( LAY ) / PRESL( CLTOP ) ) ** ROVCP
            TENT = TTOP * ( 1.0 - FSIDE( LAY ) ) + TAL( LAY ) * FSIDE( LAY )

            TI = TSAT( LAY ) * ( 1.0 - F( LAY ) ) + TENT * F( LAY )
            DQL = ( QMAX - QAD( LAY ) ) * ( 1.0 - F( LAY ) - WL )
            DQI = 0.0

            IF ( TEMPA .LT. 273.15 ) THEN
              DQI = -QWAT( LAY ) * ( TEMPA - 273.15 ) / 18.0
              IF ( TEMPA .LE. 255.15 ) DQI = QWAT( LAY )
            END IF

            FA = CPD * ( TEMPA - TI ) + LV0 * DQL + LF0 * DQI

C...test for convergence, then cut the interval in half

            I599C = 0

599         CONTINUE

            HTST = TEMPB - TEMPA
            IF ( HTST .LT. TST ) GO TO 595   ! convergence
            I599C = I599C + 1

            IF ( I599C .GT. 1000 ) THEN
              WRITE( XMSG, 91010 )
     &             'NO CONVERGENCE IN ENTRAINMENT SOLVER AT COL= ',
     &             COL, ' ROW= ',  ROW, ' ICLDTYPE= ', ICLDTYPE
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            TEMPC = ( TEMPA + TEMPB ) * 0.5
            QENT = FSIDE( LAY ) * QVL( LAY )
     &           + ( 1.0 - FSIDE( LAY ) ) * QVL( CLTOP )
            QDIF = QENT - QMAX
            IF ( QDIF .EQ. 0.0 ) QDIF = 1.0E-10
            F( LAY ) = ( QSAT( ESAT( TEMPC ), PRESL( LAY ) )
     &               + QWAT( LAY ) - QMAX ) / QDIF
            F( LAY ) = MIN( F( LAY ), 0.99 )
            F( LAY ) = MAX( F( LAY ), 0.01 )
            TTOP = TAL( CLTOP ) * ( PRESL( LAY ) / PRESL( CLTOP ) ) ** ROVCP
            TENT = TTOP * ( 1.0 - FSIDE( LAY ) ) + TAL( LAY ) * FSIDE( LAY )
            TI = TSAT( LAY ) * ( 1.0 - F( LAY ) ) + TENT * F( LAY )
            DQL = ( QMAX - QAD( LAY ) ) * ( 1.0 - F( LAY ) - WL )
            DQI = 0.0

            IF ( TEMPC .LT. 273.15 ) THEN
              DQI = -QWAT( LAY ) * ( TEMPC - 273.15 ) / 18.0
              IF ( TEMPC .LE. 255.15 ) DQI = QWAT( LAY )
            END IF

            FB = CPD * ( TEMPC - TI ) + LV0 * DQL + LF0 * DQI

            FTST = FA * FB

C...if fa*fb < 0 then zero lies between ta & tc
C...if fa*fb > 0 then zero lies between tc & tb

            IF ( FTST .LE. 0.0 ) THEN
              TEMPB = TEMPC
            ELSE
              TEMPA = TEMPC
            END IF
            GO TO 599

595         CONTINUE   ! exit from iterator, convergence achieved

C...we have obtained parcel temp TEMPC at layer LAY
C...and entrainment fraction F(LAY)

C...end of Walcek bisection solver

            TCLD( LAY ) = MAX( TEMPC, 150.0 )

C...ice load in cloud is a function of temperature below freezing

            IF ( TCLD( LAY ) .LT. 273.15 ) THEN
              QICE( LAY ) = -QWAT( LAY ) * ( TCLD( LAY ) - 273.15 ) / 18.0
              IF ( TCLD( LAY ) .LE. 255.15 ) QICE( LAY ) = QWAT( LAY )
            END IF

C...After determining the ice fraction, compute the actual
C...  liquid water mixing ratio:

            QLQD( LAY ) = QWAT( LAY ) - QICE( LAY )

C...compute the Liquid Water Content (LWC) by taking the
C...  product of the liquid wat mix ratio and the air density
C...  LWC in kg H2O per m**3 air:

            RHOAIR = PRESL( LAY ) / ( RDGAS * TCLD( LAY ) )
            LWC( LAY ) = QLQD( LAY ) * RHOAIR
            LWC( LAY ) = MAX( 5.0E-6, LWC( LAY ) )  ! lower limit
            TWC = QWAT( LAY ) * RHOAIR         ! total water content

C...Now perform vertical integration, weighting by liquid water
C...  content so that averaged quantities (used in Aqueous
C...  Chemistry) get the greatest weight where the liquid
C...  water content is greatest.

C...weighted cloud temp
            TBARC = TBARC + TCLD( LAY ) * DZZL( LAY ) * LWC( LAY )

C...weighted cloud pres
            PBARC = PBARC + PRESL( LAY ) * DZZL( LAY ) * LWC( LAY )

C...weighted photolysis rate 
            JH2O2_BAR = JH2O2_BAR + JH2O2( LAY ) * DZZL( LAY ) * LWC( LAY )     
            JHNO3_BAR = JHNO3_BAR + JHNO3( LAY ) * DZZL( LAY ) * LWC( LAY )     

C...integrated liquid water content (kg/m3)
            WCBAR = WCBAR + DZZL( LAY ) * LWC( LAY )

C...integrated total water content
            WTBAR = WTBAR + DZZL( LAY ) * TWC
            CTHK = CTHK + DZZL( LAY )   ! Cloud thickness

C...Now compute integrated excess water over grid cell
C...  average necessary for rainout, through cloud depth.
C...  First, get max temp in the cell (either in cloud or env.)

            T1 = MAX( TCLD( LAY ), TAL( LAY ) )

C...get saturation water vapor mixing ratio at that temp:

            QVC( LAY ) = QSAT( ESAT( T1 ), PRESL( LAY ) )

C...excess water is the sum of total condensed and saturated
C...  vapor minus grid cell average mixing ratio: QXS in kg/m2:
C...  integrated through cloud depth

            QXS = QXS
     &          + ( QWAT( LAY ) + QVC( LAY ) - QVL( LAY ) )
     &          * RHOAIR * DZZL( LAY )

C...get total air mass in cloudy layers:

            AIRM = AIRM + RHOM2( LAY )

          END DO

C...Now begin to split calculations for non-raining and raining
C...  clouds depending on inner loop index ICLDTYPE (1 = raining,
C...  2 = nonraining: either CNP of PFW:)

          IF ( ICLDTYPE .EQ. 2 ) THEN   ! no precip or excess water
            PRATE1 = 1.0E-30
            PRATE  = 1.0E-30
            QXS    = 1.0E-30
          ELSE

C...continue here for raining cloud...

C...get PRATE1, storm rainout rate in mm/hour, noting that 1 kg
C...  of water occupies a 1 mm thick layer of water in a square meter
C...  of ground (accounts for density of water = 1000 kg/m3)

            PRATE1 = STORME * QXS * 3600.0 / TCLIFE
            IF ( PRATE1 .LE. 1.001 * PRATE ) THEN
              FRAC = 0.999                ! Changed back to .999 - jp 6/05
              PRATE1 = PRATE / FRAC
            ELSE
              FRAC = PRATE / PRATE1
            END IF
            IF ( FRAC .LT. 0.01 ) CYCLE ! Loop to next row-column coordinate

C...for raining cloud, compute water properties of interest
C...  below cloud base. First, parameterize total water content

            TWC = ( 0.067 * PRATE ** ( 0.846 ) ) / ( FRAC * 1000.0 ) ! tot wat cont kg/m3
         
            DO LAY = 1, CLBASE - 1
              TCLD( LAY ) = TAL( LAY )
              RHOAIR = PRESL( LAY ) / ( RDGAS * TCLD( LAY ) )
              QWAT( LAY ) = TWC / RHOAIR    ! kg H2O / kg air

C...again partition into ice and liquid

              IF ( TCLD( LAY ) .LT. 273.15 ) THEN
                QICE( LAY) = -QWAT( LAY ) * ( TCLD( LAY ) - 273.15 ) / 18.0
                IF ( TCLD( LAY ) .LE. 255.15 ) QICE( LAY ) = QWAT( LAY )
              END IF
       
              QLQD( LAY ) = QWAT( LAY ) - QICE( LAY )
              LWC ( LAY ) = QLQD( LAY ) * RHOAIR
              LWC ( LAY ) = MAX( 5.0E-06, LWC( LAY ) )         ! lower limit
              PBARC = PBARC + PRESL( LAY ) * DZZL( LAY ) * LWC( LAY )
              TBARC = TBARC + TCLD( LAY ) * DZZL( LAY ) * LWC( LAY )
              WCBAR = WCBAR + DZZL( LAY ) * LWC( LAY )
              WTBAR = WTBAR + DZZL( LAY ) * TWC
              CTHK = CTHK + DZZL( LAY )
              JH2O2_BAR = JH2O2_BAR + JH2O2( LAY ) * DZZL( LAY ) * LWC( LAY )
              JHNO3_BAR = JHNO3_BAR + JHNO3( LAY ) * DZZL( LAY ) * LWC( LAY )
C...excess water is all rain

              QXS = QXS + QWAT( LAY ) * RHOAIR * DZZL( LAY )
            
            END DO

C...Final calc of storm rainfall rate and frac area (raining clds)

            PRATE1 = STORME * QXS * 3600.0 / TCLIFE
          
            IF ( PRATE1 .LE. 1.001 * PRATE ) THEN
              FRAC = 0.999        ! Changed back to .999 - jp 6/05
              PRATE1 = PRATE / FRAC
            ELSE
              FRAC = PRATE / PRATE1
            END IF
            IF ( FRAC .LT. 0.01 ) CYCLE ! Loop to next row-column coordinate
            
            CONV_DEP( COL,ROW, N_SPC_WDEP + 7 ) = FRAC

          END IF                        ! target of cloudtype split


C...Begin mixing section, perform first for raining clouds using
C...  modified form of original Walcek mixing for RADM: mixing
C...  limited to 1 layer above cloud top; next for CNP or PFW clouds
C...  using direct exchange mixing mechanism by McHenry.

          DO SPC = 1, MXSPCS
            DO LAY = 1, NLAYS
              CCR( SPC, LAY ) = CONC( SPC,LAY )
#ifdef sens
              DO NP = 1, NPMAX
                S_CCR( NP,SPC, LAY ) = S_CONC( NP,SPC,LAY )
              END DO
#endif
            END DO
            CBELOW( SPC ) = CBASE0( SPC )
#ifdef sens
            DO NP = 1, NPMAX
              S_CBELOW( NP,SPC ) = S_CBASE0( NP,SPC )
            END DO
#endif 
          END DO

! -- Need to use dens * delz for ACM mixing
          DO LAY = 1, NLAYS
            DZH(LAY) = RHOM2( LAY )
          ENDDO
          LAY = CLBASE - 1

          DZH(LAY) = AIRMB0

#ifdef isam
          DO ITAG = 1, NTAG_SA
            DO SPC = 1, NSPC_SA
              DO LAY = 1, NLAYS
                SA_CCR( SPC, LAY,ITAG ) = SA_CONC( SPC,LAY,ITAG )
              END DO
              SA_CBELOW( SPC,ITAG ) = SA_BASE0( SPC, ITAG )
            END DO
          END DO
#endif

          CALL ACMCLD ( NSPCSD, NLAYS, F, CCR, DZH, CBELOW, CLBASE, CLTOP,
     &                  FRAC, TCLIFE, DTCLD )

#ifdef isam
          DO ITAG = 1, NTAG_SA
            CALL ACMCLD ( NSPC_SA, NLAYS, F, SA_CCR(:,:,ITAG), DZH, 
     &                    SA_CBELOW(:,ITAG), CLBASE, CLTOP,
     &                    FRAC, TCLIFE, DTCLD )
          END DO
#endif

          DO SPC = 1, MXSPCS
            CBASEF( SPC ) =  CBELOW( SPC ) 
#ifdef sens
            DO NP = 1, NPMAX
              S_CBASEF( NP,SPC ) =  S_CBELOW( NP,SPC )
            END DO
#endif
          END DO

#ifdef isam
          DO ITAG = 1, NTAG_SA
            DO SPC = 1, NSPC_SA
              SA_BASEF( SPC,ITAG ) =  SA_CBELOW( SPC,ITAG )
            END DO
          END DO
#endif

          DO LAY = CLTOP, CLBASE, -1
            DO SPC = 1, NSPCSD
              CONDIS = CONC( SPC,LAY )
              PCLD( SPC,LAY ) = F( LAY ) * ( FSIDE( LAY ) * CONDIS )
     &                        + ( 1.0 - F( LAY ) ) * CBASE0( SPC )
              PCLD( SPC,LAY ) = MIN( PCLD( SPC,LAY ), CCR( SPC,LAY ) / FRAC )

#ifdef sens
              DO NP = 1, NPMAX
                S_CONDIS = S_CONC( NP, SPC, LAY )
                S_PCLD( NP, SPC, LAY ) = F( LAY ) * ( FSIDE( LAY ) * S_CONDIS )
     &                         + ( 1.0 - F( LAY ) ) * S_CBASE0( NP,SPC )
                IF ( PCLD( SPC, LAY ) .EQ. ( CCR( SPC, LAY ) / FRAC ) ) THEN
                   S_PCLD( NP, SPC, LAY ) = S_CCR( NP, SPC, LAY ) / FRAC
                END IF

              END DO
#endif

C...POLC in mol sp/m2

              POLC( SPC ) = POLC( SPC )
     &                    + PCLD( SPC,LAY ) * RHOM2( LAY )
#ifdef isam
              CSPC = 0
              CSPC = INDEXINT1(SPC,NSPC_SA,MAP_SAtoCGR(:))

              IF ( CSPC .NE. 0) THEN
                DO ITAG = 1, NTAG_SA
                  CONDIS = SA_CONC( CSPC,LAY,ITAG )

                  SA_PCLD( CSPC,LAY,ITAG ) = F( LAY ) * ( FSIDE( LAY ) * CONDIS )
     &                                     + ( 1.0 - F( LAY ) ) * SA_BASE0( CSPC,ITAG )
c                 IF ( ( CCR( SPC,LAY ) / FRAC) .EQ. PCLD( SPC,LAY ) ) THEN
c                   SA_PCLD( CSPC,LAY,ITAG ) = SA_CCR( CSPC,LAY,ITAG ) / FRAC 
c                 END IF

                  SA_PCLD( CSPC,LAY,ITAG ) = MIN( SA_PCLD( CSPC,LAY,ITAG ), SA_CCR( CSPC,LAY,ITAG ) / FRAC )

                  SA_POLC( CSPC,ITAG ) = SA_POLC( CSPC,ITAG )
     &                              + SA_PCLD( CSPC,LAY,ITAG ) * RHOM2( LAY )
                END DO
              END IF
#endif

#ifdef sens
              DO NP = 1, NPMAX
                S_POLC( NP, SPC ) = S_POLC( NP, SPC )
     &                            + S_PCLD( NP, SPC, LAY ) * REAL ( RHOM2( LAY ), 8 )
              END DO
#endif

            END DO
          END DO

C...Now compute for raining region below cloud which is also considered
C...  to be part of the aqueous reaction chamber

            DO LAY = 1, CLBASE - 1
              AIRM = AIRM + RHOM2( LAY )

              DO SPC = 1, NSPCSD
                IF ( CBASE0( SPC ) .GT. 0.0 ) THEN
                  BCLDWT = CONC( SPC,LAY ) / MAX( CBASE0( SPC ), 1.0E-30 )
#ifdef sens
                  DO NP = 1, NPMAX
                     IF ( CBASE0( SPC ) .GT. 1.0E-30 ) THEN

                        IF ( S_CBASE0( NP, SPC ) .LT. DDM3D_CONCMINL ) THEN
c                         S_BCLDWT( NP, SPC, LAY ) = 1.0D0
                          S_BCLDWT( NP, SPC, LAY ) =  0.0D0
                        ELSE
                          S_BCLDWT( NP, SPC, LAY ) = S_CONC( NP, SPC,LAY ) 
     &                                            / S_CBASE0( NP, SPC )
                        END IF
                     ELSE
c                       S_BCLDWT( NP, SPC, LAY ) = S_CONC( NP, SPC, LAY)
c    &                                           / DDM3D_CONCMINL
c                       S_BCLDWT( NP, SPC, LAY ) = 1.0D0
                        S_BCLDWT( NP, SPC, LAY ) =  0.0D0
                     END IF
                  END DO
#endif          
                ELSE
                  BCLDWT = 1.0
#ifdef sens
                  DO NP = 1, NPMAX
                     S_BCLDWT( NP, SPC, LAY ) =  1.0
                  END DO
#endif
                END IF

                IF ( STM ) THEN
                  IF ( SPC .NE. SURCLDMX( SPC ) ) THEN      ! use its mixing surrogate
                    IF ( CBASE0( SURCLDMX( SPC ) ) .GT. 0.0 ) THEN
                      BCLDWT = CONC( SURCLDMX( SPC ),LAY ) / MAX( CBASE0( SURCLDMX( SPC ) ), 1.0E-30 )
                    ELSE
                      BCLDWT = 1.0
                    END IF
                  END IF
                END IF ! stm
  
                PCLD( SPC,LAY ) = BCLDWT * CBASEF( SPC )

#ifdef sens
                DO NP = 1, NPMAX
                   S_PCLD( NP, SPC, LAY ) = S_CBASEF( NP, SPC ) * S_BCLDWT( NP, SPC, LAY )
                END DO
#endif

C...Necessary because CBASEF and CBASE0 are the ending vertical averages
C...  below cloud concentrations in mol sp/mol air

                IF ( ICLDTYPE .EQ. 1 ) THEN
                  POLC( SPC ) = POLC( SPC ) + PCLD( SPC, LAY ) * RHOM2( LAY )
#ifdef sens
                  DO NP = 1, NPMAX
                    S_POLC( NP, SPC ) = S_POLC( NP, SPC )
     &                        + S_PCLD( NP, SPC, LAY ) * REAL ( RHOM2( LAY ), 8 )
                  END DO
#endif
                END IF

#ifdef isam
                CSPC = 0
                CSPC = INDEXINT1(SPC,NSPC_SA,MAP_SAtoCGR(:))
                IF ( CSPC .NE. 0) THEN
                  DO ITAG = 1, NTAG_SA

c                    BCLDWT = SA_CONC( CSPC,LAY,ITAG ) / MAX( SA_BASE0( CSPC, ITAG ),1.0E-30 )
                     SA_PCLD( CSPC,LAY, ITAG ) = BCLDWT * SA_BASEF( CSPC,ITAG )

                     IF ( ICLDTYPE .EQ. 1 ) THEN
                       SA_POLC( CSPC, ITAG ) = SA_POLC( CSPC, ITAG )
     &                                       + SA_PCLD( CSPC, LAY, ITAG)
     &                                       * RHOM2( LAY )
                     END IF
                  END DO
                END IF
#endif

              END DO

            END DO

C...Compute cloud mean quantities

          AIRM  = MAX( AIRM, 1.0E-30 )   ! tot. air mass in cloudy layers in mol/m2

          WCBAR = MAX( WCBAR, 1.0E-30 )  ! liq.wat. content in kg/m3 * CTHK

          WTBAR = MAX( WTBAR, 1.0E-30 )  ! condensed wat cnt: kg/m3 * CTHK

          CTHK  = MAX( CTHK, 1.0E-30 )   ! cloud thickness, meters

          TBARC = TBARC / WCBAR          ! deg K (note WCBAR has hidden factor CTHK in it)
          PBARC = PBARC / WCBAR          ! avg cloud pres, Pa

          JH2O2_BAR = JH2O2_BAR / WCBAR  ! avg H2O2 photolysis, 1/min
          JHNO3_BAR = JHNO3_BAR / WCBAR  ! avg HNO3 photolysis, 1/min

          WCBAR = WCBAR / CTHK           ! avg liq wat content in kg/m3

          WTBAR = WTBAR / CTHK           ! avg con wat content in kg/m3

C...Calculate the cloud optical depth using a formula derived from
C...  Stephens (1978), JAS(35), pp2111-2132.
C...  only calculate the cloud optical depth when the liquid water
C...  path is >= 10 g/m2

          LWP = WTBAR * CTHK * 1000.0    ! converts to g/m2
          IF ( LWP .GE. 10.0 ) THEN
             CLOD = 10.0 ** ( 0.2633 + 1.7095 * LOG( LOG10( LWP ) ) )
          ELSE
             CLOD = 0.0
          END IF

C...If no cloud or optical depth < 5, set clear sky values.
C...  (i.e. don`t do anything)

          IF ( CLOD .GE. 5.0 ) THEN

                STRNS = 1.0 + FRAC * ( ( 5.0 - EXP ( -CLOD ) )
     &                                 / ( 4.0 + 0.42 * CLOD ) - 1.0 )

             IF ( ICLDTYPE .EQ. 1 ) THEN  ! precipitating cloud
                SUBTRANS( COL,ROW,1 ) = STRNS
             ELSE
                SUBTRANS( COL,ROW,2 ) = STRNS
             END IF
              
          END IF

C...Finally, get in cloud pollutant concentrations in mol sp per mol air

          DO SPC = 1, NSPCSD
            POLC ( SPC ) = POLC( SPC ) / AIRM
            CEND ( SPC ) = POLC( SPC )
            REMOV( SPC ) = 0.0
#ifdef sens
            DO NP = 1, NPMAX
              S_POLC ( NP, SPC ) = S_POLC( NP, SPC ) / REAL ( AIRM, 8 )
              S_CEND ( NP, SPC ) = S_POLC( NP, SPC )
              S_REMOV( NP, SPC ) = 0.0D0
            END DO
#endif
          END DO

          REMOVAC = 0.0
#ifdef sens
          S_REMOVAC = 0.0D0
#endif

          ARPRES = PBARC / STDATMPA
          RTCH = ( MOLVOL / STDTEMP ) * TBARC
          CTHK1 = AIRM * RTCH / ( ARPRES * 1000.0 )

#ifdef isam
          DO SPC = 1, NSPC_SA
            DO ITAG = 1, NTAG_SA
              SA_POLC( SPC, ITAG ) = SA_POLC( SPC, ITAG ) / AIRM
              SA_CEND( SPC, ITAG ) = SA_POLC( SPC, ITAG )
            END DO
          END DO
          SA_REMOV = 0.0
#endif 

          CALL SCAVWDEP ( JDATE, JTIME, WTBAR,
     &                    WCBAR, TBARC, PBARC,
     &                    CTHK1, AIRM, PRATE1, DTCLD, POLC, CEND,
     &                    REMOV, REMOVAC, ALFA0, ALFA2, ALFA3 )

#ifdef isam
          DO SPC = 1, NSPC_SA
             CSPC = MAP_SAtoCGR(SPC)
             SA_SUM = SUM ( SA_POLC( SPC,: ) )
c            IF ( POLC( CSPC ) .GT. 1.0E-30 .AND. CEND( CSPC ) .GT. 1.0E-09 ) THEN
c            IF ( POLC( CSPC ) .GT. 1.0E-30 ) THEN 
             IF ( SA_SUM .GT. 1.0E-25 ) THEN
                DO ITAG = 1, NTAG_SA
                   SA_CEND( SPC, ITAG ) = SA_POLC( SPC, ITAG )
     &                                  * ( CEND( CSPC )
c    &                                    / POLC( CSPC ) )
     &                                    / SA_SUM )
                   SA_REMOV( SPC, ITAG ) = SA_POLC( SPC, ITAG )
     &                                   * ( REMOV( CSPC )
c    &                                     / POLC( CSPC ) )
     &                                     / SA_SUM )
                END DO
             ELSE 
                DO ITAG = 1, NTAG_SA
                   SA_CEND( SPC, ITAG )  = 0.0
                   SA_REMOV( SPC, ITAG ) = 0.0
                END DO
             END IF
          END DO
#endif

C...if the liquid water content is above the specified threshold
C...  then perform the aqueous chemistry within the cloud and
C...  re-adjust the ending and removed amounts for those species
C...  that participated in cloud chemistry

          IF ( WCBAR .GT. 1.0E-05 ) THEN
 
C...  determine day or night from cosine of zenith angle for the cell; Golam Sarwar

            COSZ = MET_DATA%COSZEN( COL,ROW )

            IF ( COSZ .LE. 0.0 ) THEN
C...set mean photolysis rates to zero
              JH2O2_HYDROMETEORS = 0.0D0 
              JHNO3_HYDROMETEORS = 0.0D0
            ELSE
C...convert mean photolysis rates to 1/sec
              JH2O2_HYDROMETEORS = REAL( JH2O2_BAR * MINPERSEC, 8 ) 
              JHNO3_HYDROMETEORS = REAL( JHNO3_BAR * MINPERSEC, 8 )
            END IF

C...in aqchem, H2SO4 gas is added to ASO4J
C...  mimic this for the ASO4GASJ tracking species
            IF ( STM ) THEN
              POLC( AEROSPC_MAP( ASO4GAS_IDX, 2 ) ) = POLC( AEROSPC_MAP( ASO4GAS_IDX, 2 ) )
     &                                              + POLC( PRECURSOR_MAP( SULF_IDX ) )
              CEND( AEROSPC_MAP( ASO4GAS_IDX, 2 ) ) = POLC( AEROSPC_MAP( ASO4GAS_IDX, 2 ) )
            END IF

            CALL AQ_MAP ( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                    CTHK1, AIRM, PRATE1, DTCLD, POLC, CEND,
     &                    REMOV, REMOVAC, ALFA0, ALFA2, ALFA3, COSZ )


#ifdef isam
            DO SPC = 1, NSPC_SA ! general case
              CSPC = MAP_SAtoCGR(SPC)
              SA_SUM = SUM ( SA_POLC( SPC,: ) )
              DO ITAG = 1, NTAG_SA
c               IF ( POLC( CSPC ) .GT. 1.0E-30 ) THEN
                IF ( SA_SUM .GT. 1.0E-25 ) THEN
                  SA_CEND( SPC,ITAG ) = SA_POLC( SPC,ITAG )
     &                                * ( CEND( CSPC )
c    &                                  / MAX( 1.0E-26,POLC( CSPC ) ) )
     &                                  / SA_SUM )
                  SA_REMOV( SPC,ITAG ) = SA_POLC( SPC, ITAG )
     &                                 * ( REMOV( CSPC )
c    &                                   / MAX( 1.0E-25, POLC( CSPC ) ))
     &                                   / SA_SUM )
                ELSE
                  SA_CEND( SPC,ITAG )  = 0.0
                  SA_REMOV( SPC,ITAG ) = 0.0
                END IF
              END DO
            END DO
            IF ( S_N2O5 .NE. 0 ) THEN
              DO ITAG = 1, NTAG_SA
                SA_CEND( S_N2O5,ITAG )  = 0.0
              END DO
            END IF
            IF (S_SO4J .NE. 0 ) THEN ! sulfate case

              DO ITAG = 1, NTAG_SA  ! sulfate from H2SO4
                SA_DS4( ITAG ) = SA_POLC( S_SULF,ITAG )
                SA_CEND( S_SULF,ITAG )  = 1.0E-30
              END DO

              DO ITAG = 1, NTAG_SA
                SA_DS4( ITAG ) = SA_DS4( ITAG ) + DS4_SAVE ! total sulfate produced
     &                         * ( SA_POLC( S_SO2,ITAG )
     &                           / SUM ( SA_POLC( S_SO2,: ) ) )
                SA_CEND( S_SO4J,ITAG ) = SA_POLC( S_SO4J,ITAG )  ! sulfate before removal
     &                                       + SA_DS4( ITAG )
              END DO

              SA_SUM = SUM ( SA_CEND( S_SO4J,: ) ) ! total apportioned sulfate before removal
 
              DO ITAG = 1, NTAG_SA ! final sulfate removal and concentration
                SA_REMOV( S_SO4J,ITAG ) = REMOV_SAVE
     &                                  * ( SA_CEND( S_SO4J,ITAG )
     &                                    / SA_SUM )
                SA_CEND( S_SO4J,ITAG ) = SA_CEND( S_SO4J,ITAG )
     &                                 - DEPSUM_SAVE
     &                                 * ( SA_CEND( S_SO4J,ITAG )
     &                                   / SA_SUM )
                SA_CEND( S_SO4J,ITAG ) = MAX ( SA_CEND( S_SO4J,ITAG ), 1.0E-30 )
              END DO

            END IF

            IF (S_AORGCJ .NE. 0 ) THEN ! AORGCJ case
               SA_DCSOA_GLY = 0.0
               SA_DCSOA_MGLY = 0.0
               DO ITAG = 1, NTAG_SA
                  IF ( S_GLY .NE. 0 ) THEN
                    SA_DCSOA_GLY( ITAG ) = DGLY1_SAVE
     &                               * SA_POLC( S_GLY,ITAG )
     &                               / MAX( 1.0E-25, SUM ( SA_POLC( S_GLY,: ) ) )
                  END IF
                  IF ( S_MGLY .NE. 0 ) THEN
                     SA_DCSOA_MGLY( ITAG ) = DMGLY1_SAVE
     &                               * SA_POLC( S_MGLY,ITAG )
     &                               / MAX( 1.0E-25, SUM ( SA_POLC( S_MGLY,: ) ) )
                  END IF
                  SA_CEND( S_AORGCJ,ITAG ) = SA_POLC( S_AORGCJ,ITAG ) ! AORGCJ before removal
     &                                         + SA_DCSOA_GLY( ITAG )
     &                                         + SA_DCSOA_MGLY( ITAG )
               END DO
               SA_SUM = MAX( 1.0E-25, SUM ( SA_CEND( S_AORGCJ,: ) ) ) ! total apportioned AORGCJ before removal
               DO ITAG = 1, NTAG_SA ! final AORGCJ removal and concentration
                  SA_REMOV( S_AORGCJ,ITAG ) = REMOV_AORGC_SAVE
     &                                        * SA_CEND( S_AORGCJ,ITAG )
     &                                        / SA_SUM
                  SA_CEND( S_AORGCJ,ITAG ) = SA_CEND( S_AORGCJ,ITAG )
     &                                       - DEPSUM_AORGC_SAVE
     &                                       * SA_CEND( S_AORGCJ,ITAG )
     &                                       / SA_SUM
                  SA_CEND( S_AORGCJ,ITAG ) = MAX ( SA_CEND( S_AORGCJ,ITAG ), 1.0E-30 )
               END DO
            END IF
#endif
          END IF

          DO SPC = 1, N_CGRID_SPC
            IF ( CEND( SPC ) .LT. 0.0 ) 
     &                               WRITE( LOGDEV,* ) ' CEND,R,C,SP=',
     &                               CEND( SPC ), ROW, COL, SPC
          END DO

C...weight the removed amount by the cloud fraction and convert
C...  from mol/m2 to kg/m2 and kg/m2 to kg/hectare

C...convert removal change from moles/m**2 to kg/m**2 and kg/m**2 to kg/hectare

                DO I = 1,N_CGRID_SPC
                  IF ( CGRID_MASK_NUM( I ) .OR.
     &                 CGRID_MASK_SRF( I ) ) THEN
                     ! Aerosol Number (N m-2 -> N ha-1)
                     ! Aerosol Surface Area (m2 m-2 -> m2 ha-1)
                     REMOV( I ) = REMOV( I ) * M2PHA * FRAC
#ifdef sens
                     DO NP = 1, NPMAX
                       S_REMOV( NP,I ) = S_REMOV( NP,I ) * REAL( M2PHA * FRAC, 8 )
                     END DO
#endif
                     ! ISAM does not track aerosol number or surface
                     ! area

                  ELSE
                     ! Gas and Aerosol Mass (moles m-2 -> kg ha-1)
                     REMOV( I ) = REMOV( I ) * CGRID_MW( I ) * M2PHA_OVER_GPKG * FRAC
#ifdef sens
                     DO NP = 1, NPMAX
                       S_REMOV( NP,I ) = S_REMOV( NP,I ) * CGRID_MW( I ) * M2PHA_OVER_GPKG * FRAC
                     END DO
#endif
#ifdef isam
                     CSPC = 0
                     CSPC = INDEXINT1(I,NSPC_SA,MAP_SAtoCGR(:))
                     IF ( CSPC .GT. 0 ) THEN
                       DO ITAG = 1, NTAG_SA
                         SA_REMOV( CSPC,ITAG ) = SA_REMOV( CSPC,ITAG ) * CGRID_MW( I )
     &                                          * M2PHA_OVER_GPKG * FRAC
                       END DO
                     END IF
#endif
                  END IF


                END DO

C...add deposition amounts into the DEP array

          DO VAR = 1, N_SPC_WDEP
            CONV_DEP( COL,ROW,VAR ) = CONV_DEP( COL,ROW,VAR )
     &                              + REMOV( MAP_WDEPtoCGRID( VAR ) )
#ifdef sens
            DO NP = 1, NPMAX
              S_CONDEP( COL, ROW, NP, VAR ) = S_CONDEP( COL, ROW, NP,VAR )
     &                                      + S_REMOV( NP, MAP_WDEPtoCGRID( VAR ) )
            END DO
#endif
          END DO

C...  and load H+ concentration into the deposition array as well

          CONV_DEP( COL,ROW,N_SPC_WDEP+1 ) = CONV_DEP( COL,ROW,N_SPC_WDEP+1 )
     &                                     + REMOVAC

#ifdef sens
          DO NP = 1, NPMAX
            S_CONDEP( COL,ROW,NP,N_SPC_WDEP+1 ) = S_CONDEP( COL,ROW,NP,N_SPC_WDEP+1 )
     &                                          + S_REMOVAC( NP )
          END DO
#endif


#ifdef isam
          DO ITAG = 1, NTAG_SA
            DO SPC = 1, NSPC_SA
              CONV_SADEP( COL,ROW,SPC,ITAG ) = CONV_SADEP( COL,ROW,SPC,ITAG )
     &                                       + SA_REMOV( SPC,ITAG )
            END DO
          END DO
#endif

C...Compute concentration changes in the grid column resulting
C...  from subgrid scale vertical mixing:

C...first, below cloud base,
C...   include raining region below cld base

          IF ( ICLDTYPE .EQ. 1 ) THEN   ! raining cloud
            DO LAY = 1, CLBASE - 1
              DO SPC = 1, NSPCSD
                IF ( SPC .NE. N_GC_SPCD ) THEN
                  INCLOUD = PCLD( SPC,LAY ) * CEND( SPC )
     &                    / MAX( POLC( SPC ), CONCMINL( SPC,LAY ) )

                  IF ( STM ) THEN
                    IF ( SPC .NE. SURCLDMX( SPC ) ) THEN       ! use its surrogate
                      IF ( POLC( SURCLDMX( SPC ) ) .GT. 0.0 ) THEN
                        INCLOUD = PCLD( SURCLDMX( SPC ),LAY ) * CEND( SPC )
     &                          / MAX( POLC( SURCLDMX( SPC ) ), CONCMINL( SURCLDMX( SPC ),LAY ) )
                      ELSE
                        INCLOUD = CEND( SPC )
                      END IF
                    END IF
                  END IF ! stm

                  OUTCLOUD = PCLD( SPC,LAY )
                  CGRD( COL,ROW,LAY,SPC ) = FRAC * INCLOUD
     &                                     + ( 1.0 - FRAC ) * OUTCLOUD

#ifdef sens
                  DO NP = 1, NPMAX
                    IF( ABS( S_POLC( NP, SPC ) ) .LT. DDM3D_CONCMINL ) THEN
                      S_INCLOUD( NP, SPC, LAY ) = 0.0D0
                    ELSE
                      S_INCLOUD( NP, SPC, LAY ) = S_PCLD( NP,SPC,LAY ) * S_CEND( NP,SPC )
     &                                        / S_POLC( NP, SPC )
                    ENDIF
                    S_OUTCLOUD( NP, SPC, LAY ) = S_PCLD( NP,SPC, LAY )
                    SENGRID( COL, ROW, LAY, NP, SPC ) =
     &                        S_INCLOUD ( NP, SPC, LAY ) * FRAC
     &                      + S_OUTCLOUD( NP, SPC, LAY ) * ( 1.0 - FRAC )
                  END DO
#endif
                END IF
              END DO
#ifdef isam
              DO SPC = 1, NSPC_SA ! general case
                CSPC = MAP_SAtoCGR(SPC)
 
                IF ( CEND( CSPC ) .GT. 1.0E-09) THEN
                DO ITAG = 1, NTAG_SA
                  INCLOUD = SA_PCLD( SPC, LAY, ITAG )
     &                    * ( SA_CEND( SPC, ITAG )
     &                      / MAX( SA_POLC( SPC, ITAG ), CONCMINL( CSPC,LAY ) ) )
                  OUTCLOUD = SA_PCLD( SPC, LAY, ITAG )
                  ISAM( COL,ROW,LAY,SPC,ITAG ) = FRAC * INCLOUD
     &                                         + ( 1.0 - FRAC ) * OUTCLOUD
                END DO
                END IF
              END DO

              IF (S_SO4J .NE. 0 ) THEN ! sulfate case

                CONDIS = 0.0
                DO ITAG = 1, NTAG_SA
                  SA_INCLOUD( ITAG ) = PCLD( C_SO4J,LAY ) * ( SA_CEND( S_SO4J,ITAG ) 
     &                    / MAX( POLC( C_SO4J ), CONCMINL( C_SO4J,LAY ) ) )
     &                    - ( PCLD( C_SO4J,LAY ) * CEND( C_SO4J ) / MAX( POLC( C_SO4J ), CONCMINL( C_SO4J,LAY ) ) )
     &                    * SA_POLC( S_SO4J,ITAG ) / MAX( POLC( C_SO4J ), CONCMINL( C_SO4J,LAY ) )
     &                    + SA_PCLD( S_SO4J,LAY,ITAG ) * CEND( C_SO4J ) / MAX( POLC( C_SO4J ), CONCMINL( C_SO4J,LAY ) )
                  IF ( SA_INCLOUD( ITAG ) .LT. 0.0 ) THEN
                    CONDIS = CONDIS + SA_INCLOUD( ITAG )
                    SA_INCLOUD( ITAG )  = 0.0
                  END IF
                END DO

                IF ( CONDIS .NE. 0.0 ) THEN
                 BLNC = ( CONDIS + SUM( SA_INCLOUD( : ) ) ) / MAX( SUM( SA_INCLOUD( : ) ), CONCMINL( C_SO4J,LAY ) )
                  DO ITAG = 1, NTAG_SA
                    IF ( SA_INCLOUD( ITAG ) .GT. 0.0 ) THEN
                      SA_INCLOUD( ITAG ) = BLNC * SA_INCLOUD( ITAG )
                    END IF
                  END DO
                END IF

                DO ITAG = 1, NTAG_SA
                  OUTCLOUD = SA_PCLD( S_SO4J,LAY,ITAG )
                  ISAM( COL,ROW,LAY,S_SO4J,ITAG ) = FRAC * SA_INCLOUD( ITAG )
     &                                       + ( 1.0 - FRAC ) * OUTCLOUD
                  ISAM( COL,ROW,LAY,S_SO4J,ITAG ) = MAX( ISAM( COL,ROW,LAY,S_SO4J,ITAG ), 1.0E-30 )
                END DO

              END IF

              IF (S_AORGCJ .NE. 0 ) THEN ! AORGCJ case

                CONDIS = 0.0
                DO ITAG = 1, NTAG_SA
                  SA_INCLOUD( ITAG ) = PCLD( C_AORGCJ,LAY ) * ( SA_CEND( S_AORGCJ,ITAG ) 
     &                    / MAX( POLC( C_AORGCJ ), CONCMINL( C_AORGCJ,LAY ) ) )
     &                    - ( PCLD( C_AORGCJ,LAY ) * CEND( C_AORGCJ ) / MAX( POLC( C_AORGCJ ), CONCMINL( C_AORGCJ,LAY ) ) )
     &                    * SA_POLC( S_AORGCJ,ITAG ) / MAX( POLC( C_AORGCJ ), CONCMINL( C_AORGCJ,LAY ) )
     &                    + SA_PCLD( S_AORGCJ,LAY,ITAG ) * CEND( C_AORGCJ ) / MAX( POLC( C_AORGCJ ), CONCMINL( C_AORGCJ,LAY ) )
                  IF ( SA_INCLOUD( ITAG ) .LT. 0.0 ) THEN
                    CONDIS = CONDIS + SA_INCLOUD( ITAG )
                    SA_INCLOUD( ITAG )  = 0.0
                  END IF
                END DO

                IF ( CONDIS .NE. 0.0 ) THEN
                 BLNC = ( CONDIS + SUM( SA_INCLOUD( : ) ) ) / MAX( SUM( SA_INCLOUD( : ) ), CONCMINL( C_AORGCJ,LAY ) )
                  DO ITAG = 1, NTAG_SA
                    IF ( SA_INCLOUD( ITAG ) .GT. 0.0 ) THEN
                      SA_INCLOUD( ITAG ) = BLNC * SA_INCLOUD( ITAG )
                    END IF
                  END DO
                END IF

                DO ITAG = 1, NTAG_SA
                  INCLOUD = SA_PCLD( S_AORGCJ,LAY,ITAG ) * SA_CEND( S_AORGCJ,ITAG )
     &                  / MAX( SA_POLC( S_AORGCJ,ITAG ), CONCMINL( SPC,LAY ) )
c                 INCLOUD = MAX( INCLOUD, CONCMINL( C_AORGCJ,LAY ) )
                  OUTCLOUD = SA_PCLD( S_AORGCJ,LAY,ITAG )
                  ISAM( COL,ROW,LAY,S_AORGCJ,ITAG ) = FRAC * SA_INCLOUD( ITAG )
     &                                       + ( 1.0 - FRAC ) * OUTCLOUD
                  ISAM( COL,ROW,LAY,S_AORGCJ,ITAG ) = MAX( ISAM( COL,ROW,LAY,S_AORGCJ,ITAG ), 1.0E-30 )
                END DO

              END IF

#endif
            END DO
          ELSE
            DO LAY = 1, CLBASE - 1
              DO SPC = 1, NSPCSD
                CGRD( COL,ROW,LAY,SPC ) = PCLD( SPC,LAY )
#ifdef sens
                DO NP = 1, NPMAX
                  SENGRID( COL, ROW, LAY, NP, SPC ) = REAL ( S_PCLD( NP, SPC, LAY ), 4 )
                END DO
#endif 
              END DO
#ifdef isam
              DO SPC = 1, NSPC_SA
c               IF (PCLD( MAP_SAtoCGR(SPC),LAY ) .GT. 1.0E-09) THEN
                DO ITAG = 1, NTAG_SA
                  ISAM( COL,ROW,LAY,SPC,ITAG ) = SA_PCLD( SPC, LAY, ITAG )
                END DO
c               END IF
              END DO
#endif
            END DO
          END IF

C...Now do changes in cloudy layers:

          DO LAY = CLBASE, CLTOP
            DO SPC = 1, NSPCSD
              IF ( SPC .NE. N_GC_SPCD ) THEN
                INCLOUD = PCLD( SPC,LAY ) * CEND( SPC )
     &                  / MAX( POLC( SPC ), CONCMINL( SPC,LAY ) )

                IF ( STM ) THEN
                  IF ( SPC .NE. SURCLDMX( SPC ) ) THEN       ! use its surrogate
                    IF ( POLC( SURCLDMX( SPC ) ) .GT. 0.0 ) THEN
                      INCLOUD = PCLD( SURCLDMX( SPC ),LAY ) * CEND( SPC )
     &                        / MAX( POLC( SURCLDMX( SPC ) ), CONCMINL( SURCLDMX( SPC ),LAY ) )
                    ELSE
                      INCLOUD = CEND( SPC )
                    END IF
                  END IF
                END IF ! stm

                OUTCLOUD = ( CCR( SPC,LAY ) - FRAC * PCLD( SPC,LAY ) )
     &                   / ( 1.0 - FRAC )
                OUTCLOUD = MAX( OUTCLOUD, CONCMINL( SPC,LAY ) )
                CGRD( COL,ROW,LAY,SPC ) = FRAC * INCLOUD 
     &                                   + ( 1.0 - FRAC ) * OUTCLOUD
#ifdef sens
                DO NP = 1, NPMAX
                  IF( ABS( S_POLC( NP, SPC ) ) .LT. DDM3D_CONCMINL ) THEN
                    S_INCLOUD( NP, SPC, LAY ) = 0.0D0
                  ELSE
                    S_INCLOUD( NP, SPC, LAY ) = S_PCLD( NP,SPC,LAY ) * S_CEND( NP,SPC )
     &                                      / S_POLC( NP, SPC )
                  END IF
                  S_OUTCLOUD( NP, SPC, LAY ) = ( S_CCR( NP, SPC, LAY ) - S_PCLD( NP, SPC,LAY ) * REAL( FRAC, 8 ) )
     &                                       / ( 1.0D0 - REAL ( FRAC, 8 ) )
                  IF ( OUTCLOUD .EQ. CONCMINL( SPC, LAY ) ) THEN
                    S_OUTCLOUD( NP, SPC, LAY ) = 0.0D0
                  END IF
                  SENGRID( COL, ROW, LAY, NP, SPC ) =
     &                        S_INCLOUD ( NP, SPC, LAY ) * FRAC
     &                      + S_OUTCLOUD( NP, SPC, LAY ) * ( 1.0 - FRAC )
                END DO
#endif
              END IF
            END DO
#ifdef isam
            DO SPC = 1, NSPC_SA ! general case
              CSPC = MAP_SAtoCGR(SPC)
c             IF (CEND( MAP_SAtoCGR(SPC) ) .GT. 1.0E-09) THEN
              DO ITAG = 1, NTAG_SA
                INCLOUD = SA_PCLD( SPC,LAY,ITAG ) * ( SA_CEND( SPC,ITAG )
     &                  / MAX( SA_POLC( SPC,ITAG ), CONCMINL( CSPC,LAY ) ) )

                OUTCLOUD = ( SA_CCR( SPC,LAY,ITAG ) - FRAC * SA_PCLD( SPC,LAY,ITAG ) )
     &                   / ( 1.0 - FRAC )

                OUTCLOUD = MAX( OUTCLOUD, CONCMINL( CSPC,LAY ) )
                ISAM( COL,ROW,LAY,SPC,ITAG ) = FRAC * INCLOUD
     &                                       + ( 1.0 - FRAC ) * OUTCLOUD
              END DO
c             END IF
            END DO

            IF (S_SO4J .NE. 0 ) THEN ! sulfate case
              DO ITAG = 1, NTAG_SA

                INCLOUD = PCLD( C_SO4J,LAY ) * SA_CEND( S_SO4J,ITAG ) / MAX( POLC( C_SO4J ), CONCMINL( C_SO4J,LAY ) )
     &                  - ( PCLD( C_SO4J,LAY ) * CEND( C_SO4J ) / MAX( POLC( C_SO4J ), CONCMINL( C_SO4J,LAY ) ) )
     &                  * SA_POLC( S_SO4J,ITAG ) / MAX( POLC( C_SO4J ), CONCMINL( C_SO4J,LAY ) ) 
     &                  + SA_PCLD( S_SO4J,LAY,ITAG ) * CEND( C_SO4J ) / MAX( POLC( C_SO4J ), CONCMINL( C_SO4J,LAY ) )
                INCLOUD = MAX( INCLOUD, CONCMINL( C_SO4J,LAY ) )

                OUTCLOUD = ( SA_CCR( S_SO4J,LAY,ITAG ) - FRAC * SA_PCLD( S_SO4J,LAY,ITAG ) )
     &                   / ( 1.0 - FRAC )
                OUTCLOUD = MAX( OUTCLOUD, CONCMINL( CSPC,LAY ) )

                ISAM( COL,ROW,LAY,S_SO4J,ITAG ) = FRAC * INCLOUD
     &                                       + ( 1.0 - FRAC ) * OUTCLOUD
              END DO
            END IF


            IF (S_AORGCJ .NE. 0 ) THEN ! AORGCJ case
              DO ITAG = 1, NTAG_SA
                INCLOUD = PCLD( C_AORGCJ,LAY ) * SA_CEND( S_AORGCJ,ITAG ) / MAX( POLC( C_AORGCJ ), CONCMINL( C_AORGCJ,LAY ) )
     &                  - ( PCLD( C_AORGCJ,LAY ) * CEND( C_AORGCJ ) / MAX( POLC( C_AORGCJ ), CONCMINL( C_AORGCJ,LAY ) ) )
     &                  * SA_POLC( S_AORGCJ,ITAG ) / MAX( POLC( C_AORGCJ ), CONCMINL( C_AORGCJ,LAY ) ) 
     &                  + SA_PCLD( S_AORGCJ,LAY,ITAG ) * CEND( C_AORGCJ ) / MAX( POLC( C_AORGCJ ), CONCMINL( C_AORGCJ,LAY ) )

                INCLOUD = SA_PCLD( S_AORGCJ,LAY,ITAG ) * SA_CEND( S_AORGCJ,ITAG )
     &                  / MAX( SA_POLC( S_AORGCJ,ITAG ), CONCMINL( SPC,LAY ) )
c               INCLOUD = MAX( INCLOUD, CONCMINL( C_AORGCJ,LAY ) )

                OUTCLOUD = ( SA_CCR( S_AORGCJ,LAY,ITAG ) - FRAC * SA_PCLD( S_AORGCJ,LAY,ITAG ) )
     &                   / ( 1.0 - FRAC )
                OUTCLOUD = MAX( OUTCLOUD, CONCMINL( CSPC,LAY ) )

                ISAM( COL,ROW,LAY,S_AORGCJ,ITAG ) = FRAC * INCLOUD
     &                                       + ( 1.0 - FRAC ) * OUTCLOUD

              END DO
            END IF
#endif
          END DO

        END DO        !  end loop on columns COL
      END DO        !  end loop on rows    ROW

      RETURN          !  from main routine CLDPROC

91010 FORMAT( 3( A, :, I3, : ) )

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE RDBCON ( JDATE, JTIME, TSTEP, LVL, BCON,
     &                    L_WRITE_WARNING )

C-----------------------------------------------------------------------
C Function:
C   Read boundary concentrations data for advection and couple with
C   SqRDMT, Where SqRDMT = Sq. Root [det ( metric tensor )]
C                        = Vertical Jacobian / (map scale factor)**2
C   Load Air Density X SqRDMT = RHOJ into last BCON slot for advection

C Preconditions:

C Subroutines and Functions Called:
C   INTERPX, INTERPB, M3EXIT, TRIMLEN, ADVBC_MAP, TIME2SEC, SEC2TIME, NEXTIME

C Revision History:
C   Jeff - Aug 1997 Based on beta version, keep in ppmV units (not aerosols)
C   Jeff - Dec 97 - add CMIN
C   Jeff - Apr 98 - fix conversion/coupling for aerosol number species
C   Jeff - Apr 01 - dyn alloc - Use PINTERB for boundary data - assume the met
C                   data could come from a larger file, but not the conc cata
C   23 Jun 03 J.Young: for layer dependent advection tstep
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                      removed deprecated TRIMLEN
C   08 Jun 12 J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2
C   14 Sep 15 J.Young: change Fortran string comparison to logical from advbc_map
C   01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all MY_N
C                     clauses
C   11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1

C-----------------------------------------------------------------------

      USE GRID_CONF            ! horizontal & vertical domain specifications
      USE CGRID_SPCS           ! CGRID mechanism species
      USE UTILIO_DEFN
      USE AERO_DATA, only : CHECK_AERO_ICBC, N_MODE
      use CENTRALIZED_IO_MODULE, only : interpolate_var, window
      use RUNTIME_VARS, only : BC_AERO_M2WET, BC_AERO_M2USE
#ifdef sens
      USE DDM3D_DEFN, ONLY:SENGRID, NPMAX, NP, BSEN, SEN_PAR, BCS
#endif 

      IMPLICIT NONE
 
C Includes:
      INCLUDE SUBST_FILES_ID   ! file name parameters

C Arguments:
      INTEGER, INTENT( IN ) :: JDATE       ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME       ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP       ! timestep
      INTEGER, INTENT( IN ) :: LVL         ! layer
      REAL,    INTENT( OUT ) :: BCON( :,: ) ! boundary concentrations
      LOGICAL, INTENT( INOUT ) :: L_WRITE_WARNING ! Write Aerosol BC Warning

C Parameters:
      REAL, PARAMETER :: KGPMG = 1.0E-09  ! Kg / micro-gram
      REAL, PARAMETER :: CMIN = 1.0E-30

      CHARACTER( 16 ) :: CONCMIN

C File variables:
      REAL, ALLOCATABLE, SAVE :: JACOBM_BND( :,: ) ! boundary Jacobian
      REAL, ALLOCATABLE, SAVE :: RHOJ_BND  ( :,: ) ! mid-layer boundary RhoJ

      REAL, ALLOCATABLE, SAVE :: JACOBM_BUF( :,: ) ! grid Jacobian
      REAL, ALLOCATABLE, SAVE :: RHOJ_BUF  ( :,: ) ! mid-layer grid RhoJ

      REAL, ALLOCATABLE, SAVE :: BBUF      ( :,: ) ! bcon file buffer
      REAL, ALLOCATABLE, SAVE :: BBUF_TMP  ( :,: ) ! bcon file buffer

C External Functions: None

C Local variables:
      CHARACTER( 16 ) :: PNAME = 'RDBCON'
      CHARACTER( 16 ) :: VNAME

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      CHARACTER( 16 ) :: BLNK = ' '
      CHARACTER( 16 ) :: BCNAME_TMP = ' '
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: BCNAME( : )  ! BC name for adv species
      REAL,            ALLOCATABLE, SAVE :: BCFAC( : )   ! Scale factor for BCs
      LOGICAL,         ALLOCATABLE, SAVE :: ONFILE( : )  ! BC species on the file

      CHARACTER( 96 )  :: XMSG = ' '
      CHARACTER( 199 ) :: XMSG2 = ' '
      INTEGER          :: STAT( N_MODE )

      INTEGER, SAVE :: N_SPC_ADV

      INTEGER   MDATE             ! mid-advection date
      INTEGER   MTIME             ! mid-advection time
      INTEGER   STEP              ! advection time step in seconds

      INTEGER   BND, VAR, SPC     ! loop counters
      INTEGER   COL, ROW, IMODE   ! loop counters
      INTEGER   STRT, FINI, IAER, J
      INTEGER   ALLOCSTAT

      INTEGER   COUNT             ! Counter for constructing boundary arrays

#ifdef sens
      INTEGER SENNUM
      CHARACTER(16 ) :: SNAME    ! Name of sens bc parameter
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: S_BCNAME( :,: )
#endif

      INTERFACE
         SUBROUTINE ADVBC_MAP( CONCMIN, BCNAME, BCFAC, ONFILE )
            CHARACTER( 16 ), INTENT( IN )  :: CONCMIN
            CHARACTER( 16 ), INTENT( OUT ) :: BCNAME( : )
            REAL,            INTENT( OUT ) :: BCFAC ( : )
            LOGICAL,         INTENT( OUT ) :: ONFILE( : )
         END SUBROUTINE ADVBC_MAP
      END INTERFACE

#ifdef verbose_rdbcon
      real sumbc
      integer s
#endif
C-----------------------------------------------------------------------
 
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         WRITE( CONCMIN,'(1PE9.2)' ) CMIN

         ALLOCATE ( BBUF( NBNDY,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BBUF'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         ALLOCATE ( BBUF_TMP( NBNDY,NLAYS ), STAT = ALLOCSTAT )

         N_SPC_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV + 1
                                                  ! add 1 for advecting RHOJ


         ALLOCATE ( BCNAME( N_SPC_ADV ),
     &              BCFAC ( N_SPC_ADV ),
     &              ONFILE( N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BCNAME, BCFAC, or ONFILE'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C create advected species map to bc`s
 
         CALL ADVBC_MAP ( CONCMIN, BCNAME, BCFAC, ONFILE )

         ALLOCATE ( JACOBM_BND( NBNDY,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating JACOBM_BND'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( RHOJ_BND( NBNDY,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating RHOJ_BND'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( WINDOW ) THEN

            ALLOCATE ( JACOBM_BUF( 0:NCOLS+1,0:NROWS+1 ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating JACOBM_BUF'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( RHOJ_BUF( 0:NCOLS+1,0:NROWS+1 ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating RHOJ_BUF'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         END IF

#ifdef sens
         ALLOCATE ( S_BCNAME( N_SPC_ADV,NPMAX ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating S_BCNAME'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( BCS ) THEN
            DO NP = 1, NPMAX
               FINI = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV
               DO VAR = 1, FINI
                  S_BCNAME( VAR,NP ) = TRIM( BCNAME( VAR ) ) // '_' // SEN_PAR( NP )
               END DO
            END DO
         ENDIF
#endif

      END IF                    ! if FIRSTIME

      MDATE  = JDATE
      MTIME  = JTIME
      STEP   = TIME2SEC( TSTEP )
      CALL NEXTIME( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

C Read & interpolate boundary SqrDMT, and RhoJ
C According to the METBDY3D File, variables have the following units:
C    JACOBM  - Meters
C    DENSA_J - KG M-2

      IF ( WINDOW ) THEN

         RHOJ_BUF = 0.0
         call interpolate_var ('DENSA_J', mdate, mtime, RHOJ_BUF, slay=lvl)

         call interpolate_var ('JACOBM', mdate, mtime, JACOBM_BUF, slay=lvl)

C Fill in DENSJ array for boundaries
         COUNT = 0
         DO ROW = 0, 0                                ! South
            DO COL = 1, NCOLS+1
               COUNT = COUNT + 1
               JACOBM_BND( COUNT,LVL ) = JACOBM_BUF( COL,ROW )
               RHOJ_BND  ( COUNT,LVL ) = RHOJ_BUF  ( COL,ROW )
            END DO
         END DO
         DO ROW = 1, NROWS+1                       ! East
            DO COL = NCOLS+1, NCOLS+1
               COUNT = COUNT + 1
               JACOBM_BND( COUNT,LVL ) = JACOBM_BUF( COL,ROW )
               RHOJ_BND  ( COUNT,LVL ) = RHOJ_BUF  ( COL,ROW )
            END DO
         END DO
         DO ROW = NROWS+1, NROWS+1              ! North
            DO COL = 0, NCOLS
               COUNT = COUNT + 1
               JACOBM_BND( COUNT,LVL ) = JACOBM_BUF( COL,ROW )
               RHOJ_BND  ( COUNT,LVL ) = RHOJ_BUF  ( COL,ROW )
            END DO
         END DO
         DO ROW = 0, NROWS                         ! West
            DO COL = 0, 0
               COUNT = COUNT + 1
               JACOBM_BND( COUNT,LVL ) = JACOBM_BUF( COL,ROW )
               RHOJ_BND  ( COUNT,LVL ) = RHOJ_BUF  ( COL,ROW )
            END DO
         END DO

      ELSE

#ifdef parallel
         call interpolate_var ('JACOBM', mdate, mtime, JACOBM_BND, 'b', lvl)
#else
         call interpolate_var ('JACOBM', mdate, mtime, JACOBM_BND, 'b')
#endif

#ifdef parallel
         call interpolate_var ('DENSA_J', mdate, mtime, RHOJ_BND, 'b', lvl)
#else
         call interpolate_var ('DENSA_J', mdate, mtime, RHOJ_BND, 'b')
#endif

      END IF   ! WINDOW

      BCON = 0.0

C Read & interpolate boundary concentrations
      ! Gas-Phase Species
      STRT = 1
      FINI = N_GC_TRNS
      DO 141 VAR = STRT, FINI
         IF ( ONFILE( VAR ) ) THEN
            BBUF = 0.0   ! array assignment
#ifdef parallel
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b', lvl)
#else
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b')
#endif
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = BCFAC( VAR ) * BBUF( BND,LVL )
     &                         * RHOJ_BND( BND,LVL )
            END DO
         ELSE
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = CMIN
            END DO
         END IF
141   CONTINUE

#ifdef verbose_rdbcon
      if ( lvl .eq. 1 ) then
         write( logdev,'(/"@@@b ", i8, i7.6)') jdate, jtime
         do var = strt, fini
            sumbc = 0.0
            do bnd = 1, nbndy
               sumbc = sumbc + bcon( bnd,var )
            end do
            write( logdev,'("@@@b ", a, g16.6)') bcname( var ), sumbc
         end do
      end if
#endif

      ! Particle Species
      SPC = 0
      STRT = N_GC_TRNS + 1
      FINI = N_GC_TRNS + N_AE_TRNS
      DO 151 VAR = STRT, FINI
         SPC = SPC + 1
         IF ( ONFILE( VAR ) ) THEN
            BBUF = 0.0   ! array assignment
#ifdef parallel
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b', lvl)
#else
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b')
#endif
            ! Add Non-Carbon Mass to Carbon Mass if the model is
            ! running semivolatile POA
            IF ( BCNAME( VAR )( 1:4 ) .EQ. 'APOC' .AND.
     &           AE_TRNS( SPC )( 1:4 ) .NE. 'APOC' ) THEN 
                 BBUF_TMP = 0.0
                 BCNAME_TMP = 'APNCOM' // BCNAME( VAR )( 5:5 )
#ifdef parallel
                 call interpolate_var (BCNAME_TMP, mdate, mtime, BBUF_TMP, 'b', lvl)
#else
                 call interpolate_var (BCNAME_TMP, mdate, mtime, BBUF_TMP, 'b')
#endif
                 BBUF = BBUF + BBUF_TMP
            END IF

            ! Units of JACOBM_BND are Meters, according to the input
            ! file. Units of BBUF are ug m-3 ( m2 m-3 for surface
            ! area and N m-3 for number).
            BCON( 1:NBNDY,VAR ) = BCFAC( VAR ) * BBUF( 1:NBNDY,LVL ) 
     &                               * JACOBM_BND( 1:NBNDY,LVL )
                  
            ! Found bc's (microgram/m**3, m**2/m**3, or number/m**3)
            ! Also Do a Mass conversion as long as this particle
            ! species is not Number or Surface Area.
            IF ( AE_TRNS( SPC )( 1:3 ) .NE. 'NUM' .AND.
     &           AE_TRNS( SPC )( 1:3 ) .NE. 'SRF'      ) THEN
               BCON( 1:NBNDY,VAR ) = BCON( 1:NBNDY,VAR ) * KGPMG
            END IF
                
         ELSE                                
            BCON( 1:NBNDY,VAR ) = CMIN
         END IF
151   CONTINUE
      
      WHERE( BCON .NE. BCON ) BCON = 0.0

      !Check Aerosol Size Distributions and Warn 
      !the User if They Are Not Robust.
      !This routine outputs aerosol surface area consistent with
      !the BC_AERO_M2WET specification.
      DO BND = 1,NBNDY
        CALL CHECK_AERO_ICBC( BCON( BND,STRT:FINI ), BC_AERO_M2WET,
     &                        BC_AERO_M2USE, .TRUE., 
     &                        L_WRITE_WARNING,1,BND,LVL )
      END DO

#ifdef verbose_rdbcon
      if ( lvl .eq. 1 ) then
         do var = strt, fini
            sumbc = 0.0
            do bnd = 1, nbndy
               sumbc = sumbc + bcon( bnd,var )
            end do
            write( logdev,'("@@@b ", a, g16.6)') bcname( var ), sumbc
         end do
      end if
#endif

      ! Non-Reactive Species
      STRT = N_GC_TRNS + N_AE_TRNS + 1
      FINI = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS
      DO 161 VAR = STRT, FINI
         IF ( ONFILE( VAR ) ) THEN
            BBUF = 0.0   ! array assignment
#ifdef parallel
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b', lvl)
#else
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b')
#endif
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = BCFAC( VAR ) * BBUF( BND,LVL )
     &                           * RHOJ_BND( BND,LVL )
            END DO
         ELSE
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = CMIN
            END DO
         END IF
161   CONTINUE

#ifdef verbose_rdbcon
      if ( lvl .eq. 1 ) then
         do var = strt, fini
            sumbc = 0.0
            do bnd = 1, nbndy
               sumbc = sumbc + bcon( bnd,var )
            end do
            write( logdev,'("@@@b ", a, g16.6)') bcname( var ), sumbc
         end do
      end if
#endif

      ! Tracer Species
      STRT = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + 1
      FINI = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV
      DO 171 VAR = STRT, FINI
         IF ( ONFILE( VAR ) ) THEN
            BBUF = 0.0   ! array assignment
#ifdef parallel
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b', lvl)
#else
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b')
#endif
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = BCFAC( VAR ) * BBUF( BND,LVL )
     &                         * RHOJ_BND( BND,LVL )
            END DO
         ELSE
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = CMIN
            END DO
         END IF
171   CONTINUE

#ifdef verbose_rdbcon
      if ( lvl .eq. 1 ) then
         do var = strt, fini
            sumbc = 0.0
            do bnd = 1, nbndy
               sumbc = sumbc + bcon( bnd,var )
            end do
            write( logdev,'("@@@b ", a, g16.6)') bcname( var ), sumbc
         end do
      end if
#endif

C for advecting Air Density X Jacobian

      DO BND = 1, NBNDY
         BCON( BND,N_SPC_ADV ) = RHOJ_BND( BND,LVL )
      END DO

#ifdef sens
C Initialize BSEN as zero, if flag is set for using bc files, use those,
C otherwise skip all of this.'

      BSEN = 0.0

c     IF ( BCS ) THEN
c        DO NP = 1, NPMAX

c           STRT = 1
c           FINI = N_GC_TRNS
c           DO 241 VAR = STRT, FINI
c              IF ( ONFILE( VAR ) ) THEN
c                 BBUF = 0.0   ! array assignment
c                 IF ( .NOT. INTERPB( BNDY_SENS_1, S_BCNAME( VAR,NP ), PNAME,
c    &                                MDATE, MTIME, NBNDY*NLAYS, BBUF ) ) THEN
c                    XMSG = 'Could not read ' // TRIM( S_BCNAME( VAR,NP ) ) // ' from '
c    &                    // BNDY_SENS_1
c                    CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
c                 ELSE   ! found bc's (PPM) on file; convert
c                    DO BND = 1, NBNDY
c                       BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL )
c    &                                     * RHOJ_BND( BND,LVL )
c                    END DO
c                 END IF
c              ELSE
c                 DO BND = 1, NBNDY
c                    BSEN( BND,VAR,NP ) = 0.0
c                 END DO
c              END IF
c241         CONTINUE

c           SPC = 0
c           STRT = N_GC_TRNS + 1
c           FINI = N_GC_TRNS + N_AE_TRNS
c           DO 251 VAR = STRT, FINI
c              SPC = SPC + 1
c              IF ( ONFILE( VAR ) ) THEN
c                 BBUF = 0.0   ! array assignment
c                 IF ( .NOT. INTERPB ( BNDY_SENS_1, S_BCNAME( VAR,NP ), PNAME,
c    &                                 MDATE, MTIME, NBNDY*NLAYS, BBUF ) ) THEN
c                    XMSG = 'Could not read ' // TRIM( S_BCNAME ( VAR,NP ) ) // ' from '
c    &                    // BNDY_SENS_1
c                    CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
c                 ELSE   ! found bc's (microgram/m**3, m**2/m**3, or number/m**3)
c                           ! on file; convert
c                    IF ( AE_TRNS( SPC )( 1:3 ) .EQ. 'NUM' ) THEN
c                       DO BND = 1, NBNDY
c                          BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL )
c    &                                        * JACOBM_BND( BND,LVL )
c                       END DO
c                    ELSE IF ( AE_TRNS( SPC )( 1:3 ) .EQ. 'SRF' ) THEN
c                       DO BND = 1, NBNDY
c                          BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL )
c    &                                        * JACOBM_BND( BND,LVL )
c                       END DO
c                    ELSE
c                       DO BND = 1, NBNDY
c                          BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL ) * KGPMG
c    &                                        * JACOBM_BND( BND,LVL )
c                       END DO
c                    END IF
c                 END IF
c              ELSE
c                 DO BND = 1, NBNDY
c                    BSEN( BND,VAR,NP ) = 0.0
c                 END DO
c              END IF
c251         CONTINUE

c           STRT = N_GC_TRNS + N_AE_TRNS + 1
c           FINI = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS
c           DO 261 VAR = STRT, FINI
c              IF ( ONFILE( VAR ) ) THEN
c                 BBUF = 0.0   ! array assignment
c                 IF ( .NOT. INTERPB ( BNDY_SENS_1, S_BCNAME( VAR,NP ), PNAME,
c    &                                 MDATE, MTIME, NBNDY*NLAYS, BBUF ) ) THEN
c                    XMSG = 'Could not read ' // TRIM( S_BCNAME( VAR,NP ) ) // ' from '
c    &                    // BNDY_SENS_1
c                    CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
c                    ELSE   ! found bc's (PPM) on file; convert
c                    DO BND = 1, NBNDY
c                       BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL )
c    &                                     * RHOJ_BND( BND,LVL )
c                       END DO
c                    END IF
c              ELSE
c                 DO BND = 1, NBNDY
c                    BSEN( BND,VAR,NP ) = 0.0
c                 END DO
c              END IF
c261         CONTINUE

c           STRT = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + 1
c           FINI = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV
c           DO 271 VAR = STRT, FINI
c              IF ( ONFILE( VAR ) ) THEN
c                 BBUF = 0.0   ! array assignment
c                 IF ( .NOT. INTERPB ( BNDY_SENS_1, S_BCNAME( VAR,NP ), PNAME,
c    &                                 MDATE, MTIME, NBNDY*NLAYS, BBUF ) ) THEN
c                    XMSG = 'Could not read ' // TRIM( S_BCNAME( VAR,NP ) ) // ' from '
c    &                    // BNDY_SENS_1
c                    CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
c                 ELSE   ! found bc's (PPM) on file; convert
c                    DO BND = 1, NBNDY
c                       BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL )
c    &                                     * RHOJ_BND( BND,LVL )
c                    END DO
c                 END IF
c              ELSE
c                 DO BND = 1, NBNDY
c                    BSEN( BND,VAR,NP ) = 0.0
c                 END DO
c              END IF
c271         CONTINUE

c           DO BND = 1, NBNDY
c              BSEN( BND,N_SPC_ADV,NP ) = 0.0
c           END DO

c        END DO
c     ENDIF
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HDIFF ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Horizontal diffusion with constant eddy diffusivity - gen. coord.
C   The process time step is set equal to TSTEP(2). Boundary concentrations
C   are set using a Dirichlet (no flux) condition
      
C Preconditions:
C   Dates and times represented YYYYDDD:HHMMSS.
C   No "skipped" dates and times.  All boundary input variables have the
C   same boundary perimeter structure with a thickness of 1
C   CGRID in ppm units or micro-g/m**3, #/m**3 for aerosols
      
C Subroutines and functions called:
C   TIME2SEC, SEC2TIME, CGRID_MAP, NEXTIME, RHO_J, 
C   HCDIFF3D
 
C Revision history:
C   Jeff - 5 Nov 97, 1 Jan 98
C   DWB  - 1 Feb 98, use simple B/C (no conc gradient at domain boundary)

C   David Wong Sep. 1998
C     -- parallelized the code
C     -- removed the intermediate constant CRHOJ_Q and placed the answer of
C        the calculation directly into CGRID. Removed the next immediate
C        loop completely.

C   David Wong 1/19/99
C      -- add a loop_index call
C      -- change loop index ending point to avoid accessing invalid region.
C         (reason to do this is to prevent using boundary data from PINTERP,
C          which sets pseudo-boundary data to 0)
 
C   Daewon Byun 10/10/2000
C      -- generalized 3d horizontal diffusivity module
C      -- accomdates 3d hdiff values

C    15 Dec 00 J.Young: PE_COMM3 -> Dave Wong's f90 stenex COMM 
C     6 Aug 01 J.Young: Use HGRD_DEFN
C    25 Mar 04 G.Hammond: RK11/RK22 ghost cell updates moved outside main loop;
C                         use explicit boundary arrays for CGRID ghost cells;
C                         use SNL's "swap3d".
C    31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                       domain specifications in one module
C    17 Dec 09 J.Young: fix CONC initializing error for sub-cycling timesteps (DO 344)
C                       reported by Talat Odman and Yongtao Hu of GA tech.
C    21 Jun 10 J.Young: convert for Namelist redesign
C    16 Feb 11 S. Roselle: replaced I/O-API include files w/UTILIO_DEFN
C    11 May 11 D.Wong: incorporated twoway model implementation
C    29 Nov 17 D.Wong: removed all SWAP routines and replaced with SE_COMM
C    18 Nov 18 S. Napelenok: ISAM implementation
C    01 Feb 19 David Wong: removed all MY_N clauses
C    11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C-----------------------------------------------------------------------
      
      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE, SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE, NOOP_UTIL_MODULE)
#endif

#ifdef isam
      USE SA_DEFN, Only: ISAM, N_SPCTAG, S_SPCTAG, T_SPCTAG, TRANSPORT_SPC
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY: SENGRID, NPMAX, NP
#endif
      USE CONST, only: DG2M, PI180

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction

C Arguments:
      
      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP( 3 ) ! time step vector (HHMMSS)
                                          ! TSTEP(1) = local output step
                                          ! TSTEP(2) = sciproc sync. step (chem)
                                          ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                          !            step and wrf/cmaq call frequency

C External Functions: None
           
C Parameters:

C Advected species dimension

      INTEGER, SAVE :: N_SPC_DIFF
 
C File Variables:
 
      REAL          CONC  ( 0:NCOLS+1,0:NROWS+1 )   ! conc working array
      REAL          RHOJ  ( 0:NCOLS+1,0:NROWS+1,NLAYS ) ! density X Jacobian
      CHARACTER( 8 ), SAVE :: COMMSTR                 ! for both CONC and RHOJ
      REAL          RK11  (   NCOLS+1,NROWS+1,NLAYS ) ! initially used as RHOJ
                              ! at x1 cell face, then finally as 11 eddy diff. factor
      REAL          RK22  (   NCOLS+1,NROWS+1,NLAYS ) ! initially used as RHOJ
                              ! at x2 cell face, then finally as 22 eddy diff. factor
      REAL          K11BAR3D ( NCOLS+1,NROWS+1,NLAYS ) ! ave. Cx11 eddy diff
      REAL          K22BAR3D ( NCOLS+1,NROWS+1,NLAYS ) ! ave. Cx22 eddy diff
      REAL          DT                          ! diffusion time step
      REAL          CRHOJ_Q                     ! intermediate, coupled conc.

C Local Variables:

      CHARACTER( 16 ) :: PNAME = 'HDIFF'
      
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      REAL          DX1                         ! dx1 (meters)
      REAL          DX2                         ! dx2 (meters)
      REAL, SAVE :: RDX1S                       ! reciprocal dx1*dx1
      REAL, SAVE :: RDX2S                       ! reciprocal dx2*dx2
      
      REAL          DTDX1S                      ! dt/dx1**2
      REAL          DTDX2S                      ! dt/dx2**2
      REAL          DTSEC                       ! model time step in seconds
      INTEGER       NSTEPS                      ! diffusion time steps
      INTEGER       STEP                        ! FIX dt
      INTEGER       FDATE                       ! interpolation date
      INTEGER       FTIME                       ! interpolation time

      REAL,    ALLOCATABLE, SAVE :: HALO_SOUTH( :,:,: )
      REAL,    ALLOCATABLE, SAVE :: HALO_NORTH( :,:,: )
      REAL,    ALLOCATABLE, SAVE :: HALO_WEST ( :,:,: )
      REAL,    ALLOCATABLE, SAVE :: HALO_EAST ( :,:,: )
      REAL,    ALLOCATABLE, SAVE :: BUF_NS    ( :,:,: )
      REAL,    ALLOCATABLE, SAVE :: BUF_EW    ( :,:,: )

      INTEGER, ALLOCATABLE, SAVE :: DIFF_MAP( : )   ! global diff map to CGRID

      INTEGER      C, R, L, S, V, N            ! loop counters
      INTEGER      D2C, IOS

      CHARACTER( 96 ) :: XMSG = ' '
     
      INTEGER MY_TEMP
      INTEGER, SAVE :: STARTROW, ENDROW
      INTEGER, SAVE :: STARTCOL, ENDCOL

#ifdef isam
      INTEGER      JSPCTAG
      REAL         SA_CONC ( 0:NCOLS+1,0:NROWS+1 )   ! sa_conc working array
      REAL, ALLOCATABLE, SAVE :: SA_HALO_SOUTH( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_HALO_NORTH( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_HALO_WEST ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_HALO_EAST ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_BUF_NS    ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_BUF_EW    ( :,:,: )
#endif

#ifdef sens
      REAL, ALLOCATABLE, SAVE :: S_HALO_SOUTH( :,:,:,: ) ! ( NCOLS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL, ALLOCATABLE, SAVE :: S_HALO_NORTH( :,:,:,: ) ! ( NCOLS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL, ALLOCATABLE, SAVE :: S_HALO_WEST ( :,:,:,: ) ! ( NROWS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL, ALLOCATABLE, SAVE :: S_HALO_EAST ( :,:,:,: ) ! ( NROWS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL, ALLOCATABLE, SAVE :: S_BUF_NS    ( :,:,:,: ) ! ( NCOLS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL, ALLOCATABLE, SAVE :: S_BUF_EW    ( :,:,:,: ) ! ( NROWS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL SENSWORK  ( 0:NCOLS+1,0:NROWS+1,NPMAX )   ! sens working array
#endif



      INTERFACE
         SUBROUTINE RHO_J ( JDATE, JTIME, TSTEP, RHOJ )
            INTEGER, INTENT( IN )  :: JDATE, JTIME, TSTEP( 3 )
            REAL,    INTENT( OUT ) :: RHOJ( :,:,: )
         END SUBROUTINE RHO_J
         SUBROUTINE HCDIFF3D ( JDATE, JTIME, K11BAR, K22BAR, DT )
            INTEGER, INTENT( IN )  :: JDATE, JTIME
            REAL,    INTENT( OUT ) :: K11BAR( :,:,: ), K22BAR( :,:,: )
            REAL,    INTENT( OUT ) :: DT
         END SUBROUTINE HCDIFF3D
      END INTERFACE
 
C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

C Get dx1 from COORD include file

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD
     &          * COS( PI180*( YORIG_GD + YCELL_GD*FLOAT( GL_NROWS/2 ))) ! in m.
            DX2 = DG2M * YCELL_GD   ! in m.
         ELSE
            DX1 = XCELL_GD          ! in m.
            DX2 = YCELL_GD          ! in m.
         END IF

         RDX1S = 1.0 / ( DX1 * DX1 )
         RDX2S = 1.0 / ( DX2 * DX2 )

         N_SPC_DIFF = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_DIFF

         ALLOCATE ( HALO_SOUTH( NCOLS,NLAYS,N_SPC_DIFF ),
     &              HALO_NORTH( NCOLS,NLAYS,N_SPC_DIFF ),
     &              HALO_WEST ( NROWS,NLAYS,N_SPC_DIFF ),
     &              HALO_EAST ( NROWS,NLAYS,N_SPC_DIFF ),
     &              BUF_NS    ( NCOLS,NLAYS,N_SPC_DIFF ),
     &              BUF_EW    ( NROWS,NLAYS,N_SPC_DIFF ), STAT = IOS )
         IF ( IOS .NE. 0 ) THEN
            XMSG = 'Failure allocating HALO_SOUTH, HALO_NORTH, HALO_WEST, HALO_EAST, BUF_NS, or BUF_EW'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF

#ifdef isam
         ALLOCATE ( SA_HALO_SOUTH( NCOLS,NLAYS,N_SPCTAG ),
     &              SA_HALO_NORTH( NCOLS,NLAYS,N_SPCTAG ),
     &              SA_HALO_WEST ( NROWS,NLAYS,N_SPCTAG ),
     &              SA_HALO_EAST ( NROWS,NLAYS,N_SPCTAG ),
     &              SA_BUF_NS    ( NCOLS,NLAYS,N_SPCTAG ),
     &              SA_BUF_EW    ( NROWS,NLAYS,N_SPCTAG ), STAT = IOS )
         IF ( IOS .NE. 0 ) THEN
            XMSG = 'Failure allocating SA_HALO_SOUTH, SA_HALO_NORTH,'
     &           // ' SA_HALO_WEST, SA_HALO_EAST, SA_BUF_NS, or SA_BUF_EW'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
#endif

#ifdef sens
         ALLOCATE ( S_HALO_SOUTH( NCOLS,NLAYS,N_SPC_DIFF,NPMAX ),
     &              S_HALO_NORTH( NCOLS,NLAYS,N_SPC_DIFF,NPMAX ),
     &              S_HALO_WEST ( NROWS,NLAYS,N_SPC_DIFF,NPMAX ),
     &              S_HALO_EAST ( NROWS,NLAYS,N_SPC_DIFF,NPMAX ),
     &              S_BUF_NS    ( NCOLS,NLAYS,N_SPC_DIFF,NPMAX ),
     &              S_BUF_EW    ( NROWS,NLAYS,N_SPC_DIFF,NPMAX ), STAT = IOS )
         IF ( IOS .NE. 0 ) THEN
            XMSG = 'Failure allocating S_HALO_SOUTH, S_HALO_NORTH,'
     &           // ' S_HALO_WEST, S_HALO_EAST, S_BUF_NS, or S_BUF_EW'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
#endif


         ALLOCATE ( DIFF_MAP( N_SPC_DIFF ), STAT = IOS )
         IF ( IOS .NE. 0 ) THEN
            XMSG = 'Failure allocating DIFF_MAP'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF

C Create global map to CGRID
 
         S = 0
         DO V = 1, N_GC_TRNS
            S = S + 1
            DIFF_MAP( S ) = GC_STRT - 1 + GC_TRNS_MAP( V )
         END DO
         DO V = 1, N_AE_TRNS
            S = S + 1
            DIFF_MAP( S ) = AE_STRT - 1 + AE_TRNS_MAP( V )
         END DO
         DO V = 1, N_NR_TRNS
            S = S + 1
            DIFF_MAP( S ) = NR_STRT - 1 + NR_TRNS_MAP( V )
         END DO
         DO V = 1, N_TR_DIFF
            S = S + 1
            DIFF_MAP( S ) = TR_STRT - 1 + TR_DIFF_MAP( V )
         END DO
 
C Get file start and end indices for subdomain
 
         CALL SUBST_LOOP_INDEX ( 'C', 1, NCOLS, 1, MY_TEMP, STARTCOL, ENDCOL )
         CALL SUBST_LOOP_INDEX ( 'R', 1, NROWS, 1, MY_TEMP, STARTROW, ENDROW )

         WRITE( COMMSTR,'(4I2)' )  1, 0, 2, 0

      END IF                    ! if firstime
                                     
      DTSEC = FLOAT( TIME2SEC( TSTEP( 2 ) ) )
      FDATE = JDATE
      FTIME = JTIME
 
C Get the computational grid ( rho X Jacobian ) for this step

      CALL RHO_J ( FDATE, FTIME, TSTEP, RHOJ )

      CALL SUBST_COMM ( RHOJ, DSPL_N0_E0_S1_W1, DRCN_S_W, COMMSTR )

C initialize RK11, RK22 with face values for RHOJ (assumes dx1 = dx2)

      RK11 = 0.0   ! array assignment
      RK22 = 0.0   ! array assignment
      DO L = 1, NLAYS
         DO R = STARTROW, ENDROW        !  DO R = 1, NROWS + 1
            DO C = STARTCOL, ENDCOL     !     DO C = 1, NCOLS + 1
               RK11( C,R,L ) = 0.5 * ( RHOJ( C,R,L ) + RHOJ( C-1,R,  L ) )
               RK22( C,R,L ) = 0.5 * ( RHOJ( C,R,L ) + RHOJ( C,  R-1,L ) )
            END DO
         END DO
      END DO

C Do the gridded computation for horizontal diffusion

C Get the contravariant eddy diffusivities

      CALL HCDIFF3D ( FDATE, FTIME, K11BAR3D, K22BAR3D, DT )

C get number of steps based on eddy time 
 
      NSTEPS = INT ( DTSEC / DT ) + 1
      DT = DTSEC / FLOAT( NSTEPS )
 
      DTDX1S = DT * RDX1S
      DTDX2S = DT * RDX2S

      DO L = 1, NLAYS
         DO R = STARTROW, ENDROW        !  DO R = 1, NROWS + 1
            DO C = STARTCOL, ENDCOL     !     DO C = 1, NCOLS + 1
               RK11( C,R,L ) = RK11( C,R,L ) * K11BAR3D( C,R,L )
               RK22( C,R,L ) = RK22( C,R,L ) * K22BAR3D( C,R,L )
            END DO
         END DO
      END DO

      CALL SUBST_COMM ( RK11, DSPL_N0_E1_S0_W0, DRCN_E )
      CALL SUBST_COMM ( RK22, DSPL_N1_E0_S0_W0, DRCN_N )

      DO S = 1, N_SPC_DIFF
         D2C = DIFF_MAP( S )
         DO L = 1, NLAYS
            DO C = 1, NCOLS
               HALO_SOUTH( C,L,S ) = CGRID( C,1,L,D2C ) / RHOJ( C,1,L )
               HALO_NORTH( C,L,S ) = CGRID( C,NROWS,L,D2C ) / RHOJ( C,NROWS,L )
               BUF_NS( C,L,S ) = HALO_NORTH( C,L,S )
            END DO
         END DO
      END DO

      CALL SUBST_COMM (HALO_SOUTH, HALO_NORTH, DSPL_N1_E0_S0_W0, DRCN_N)
      CALL SUBST_COMM (BUF_NS,     HALO_SOUTH, DSPL_N0_E0_S1_W0, DRCN_S)

#ifdef sens
      DO NP = 1, NPMAX

        DO S = 1, N_SPC_DIFF
           D2C = DIFF_MAP( S )
           DO L = 1, NLAYS
              DO C = 1, NCOLS
                 S_HALO_SOUTH( C,L,S,NP ) = SENGRID( C,1,L,NP,D2C ) / RHOJ( C,1,L )
                 S_HALO_NORTH( C,L,S,NP ) = SENGRID( C,NROWS,L,NP,D2C ) / RHOJ( C,NROWS,L )
                 S_BUF_NS( C,L,S,NP ) = S_HALO_NORTH( C,L,S,NP )
              END DO
           END DO
        END DO

        CALL SUBST_COMM (S_HALO_SOUTH(:,:,:,NP), S_HALO_NORTH(:,:,:,NP),
     &                   DSPL_N1_E0_S0_W0, DRCN_N)
        CALL SUBST_COMM (S_BUF_NS(:,:,:,NP),     S_HALO_SOUTH(:,:,:,NP),
     &                   DSPL_N0_E0_S1_W0, DRCN_S)

      END DO
#endif

      DO S = 1, N_SPC_DIFF
         D2C = DIFF_MAP( S )
         DO L = 1, NLAYS
            DO R = 1, NROWS
               HALO_WEST( R,L,S ) = CGRID( 1,R,L,D2C ) / RHOJ( 1,R,L )
               HALO_EAST( R,L,S ) = CGRID( NCOLS,R,L,D2C ) / RHOJ( NCOLS,R,L )
               BUF_EW( R,L,S ) = HALO_EAST( R,L,S )
            END DO
         END DO
      END DO

      CALL SUBST_COMM (HALO_WEST, HALO_EAST, DSPL_N0_E1_S0_W0, DRCN_E)
      CALL SUBST_COMM (BUF_EW,    HALO_WEST, DSPL_N0_E0_S0_W1, DRCN_W)

#ifdef sens
      DO NP = 1, NPMAX

        DO S = 1, N_SPC_DIFF
           D2C = DIFF_MAP( S )
           DO L = 1, NLAYS
              DO R = 1, NROWS
                 S_HALO_WEST( R,L,S,NP ) = SENGRID( 1,R,L,NP,D2C ) / RHOJ( 1,R,L )
                 S_HALO_EAST( R,L,S,NP ) = SENGRID( NCOLS,R,L,NP,D2C ) / RHOJ( NCOLS,R,L )
                 S_BUF_EW( R,L,S,NP ) = S_HALO_EAST( R,L,S,NP )
              END DO
           END DO
        END DO

        CALL SUBST_COMM (S_HALO_WEST(:,:,:,NP), S_HALO_EAST(:,:,:,NP),
     &                   DSPL_N0_E1_S0_W0, DRCN_E)
        CALL SUBST_COMM (S_BUF_EW(:,:,:,NP),    S_HALO_WEST(:,:,:,NP),
     &                   DSPL_N0_E0_S0_W1, DRCN_W)

      END DO
#endif

#ifdef isam
      DO JSPCTAG = 1, N_SPCTAG
         DO L = 1, NLAYS
            DO C = 1, NCOLS
               SA_HALO_SOUTH( C,L,JSPCTAG ) =
     &            ISAM( C,1,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) / RHOJ( C,1,L )
               SA_HALO_NORTH( C,L,JSPCTAG ) =
     &            ISAM( C,NROWS,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) / RHOJ( C,NROWS,L )
               SA_BUF_NS( C,L,JSPCTAG ) = SA_HALO_NORTH( C,L,JSPCTAG )
             END DO
         END DO
      END DO

      CALL SUBST_COMM (SA_HALO_SOUTH, SA_HALO_NORTH, DSPL_N1_E0_S0_W0, DRCN_N)
      CALL SUBST_COMM (SA_BUF_NS,     SA_HALO_SOUTH, DSPL_N0_E0_S1_W0, DRCN_S)

      DO JSPCTAG = 1, N_SPCTAG
         DO L = 1, NLAYS
            DO R = 1, NROWS
               SA_HALO_WEST( R,L,JSPCTAG ) =
     &            ISAM( 1,R,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) / RHOJ( 1,R,L )
               SA_HALO_EAST( R,L,JSPCTAG ) =
     &            ISAM( NCOLS,R,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) / RHOJ( NCOLS,R,L )
               SA_BUF_EW( R,L,JSPCTAG ) = SA_HALO_EAST( R,L,JSPCTAG )
            END DO
         END DO
      END DO

      CALL SUBST_COMM (SA_HALO_WEST, SA_HALO_EAST, DSPL_N0_E1_S0_W0, DRCN_E)
      CALL SUBST_COMM (SA_BUF_EW,    SA_HALO_WEST, DSPL_N0_E0_S0_W1, DRCN_W)

#endif

C Loop over species, layers, nsteps

      DO 366 S = 1, N_SPC_DIFF
         D2C = DIFF_MAP( S )

         DO 355 L = 1, NLAYS

            DO 344 N = 1, NSTEPS

C Load working array (CGRID is coupled, CONC is mixing ratio)

               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CONC( C,R ) = CGRID( C,R,L,D2C ) / RHOJ( C,R,L )
                  END DO
               END DO

#ifdef sens
               DO NP = 1, NPMAX
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        SENSWORK( C,R,NP ) = SENGRID( C,R,L,NP,D2C ) / RHOJ( C,R,L )
                     END DO
                  END DO
               END DO
#endif

               DO C = 1, NCOLS
                  CONC( C,0 )       = HALO_SOUTH( C,L,S )
                  CONC( C,NROWS+1 ) = HALO_NORTH( C,L,S )
               END DO

               DO R = 1, NROWS
                  CONC( 0,R )       = HALO_WEST( R,L,S )
                  CONC( NCOLS+1,R ) = HALO_EAST( R,L,S )
               END DO

#ifdef sens
               DO NP = 1, NPMAX
                  DO C = 1, NCOLS
                     SENSWORK( C,0,NP ) = S_HALO_SOUTH( C,L,S,NP )
                     SENSWORK( C,NROWS+1,NP ) = S_HALO_NORTH( C,L,S,NP )
                  END DO

                  DO R = 1, NROWS
                     SENSWORK( 0,R,NP ) = S_HALO_WEST( R,L,S,NP )
                     SENSWORK( NCOLS+1,R,NP ) = S_HALO_EAST( R,L,S,NP )
                  END DO
               END DO
#endif

C Update CGRID

               DO R = 1, NROWS
                  DO C = 1, NCOLS

                     CGRID( C,R,L,D2C ) = RHOJ( C,R,L ) * CONC( C,R )
     &                                  + DTDX1S
     &                                  * ( RK11( C+1,R,L )
     &                                  * ( CONC( C+1,R ) - CONC( C,R ) )
     &                                  - RK11( C,R,L )
     &                                    * ( CONC( C,R )   - CONC( C-1,R ) ) )
     &                                  + DTDX2S
     &                                  * ( RK22( C,R+1,L )
     &                                    * ( CONC( C,R+1 ) - CONC( C,R ) )
     &                                    - RK22( C,R,L )
     &                                    * ( CONC( C,R )   - CONC( C,R-1 ) ) )

#ifdef sens
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,D2C ) = RHOJ( C,R,L ) * SENSWORK( C,R,NP )
     &                                          + DTDX1S
     &                                          * ( RK11( C+1,R,L )
     &                                          * ( SENSWORK( C+1,R,NP ) - SENSWORK( C,R,NP ) )
     &                                          - RK11( C,R,L )
     &                                          * ( SENSWORK( C,R,NP ) - SENSWORK( C-1,R,NP )))
     &                                          + DTDX2S
     &                                          * ( RK22( C,R+1,L )
     &                                          * ( SENSWORK( C,R+1,NP ) - SENSWORK( C,R,NP ) )
     &                                          - RK22( C,R,L )
     &                                          * ( SENSWORK( C,R,NP ) - SENSWORK( C,R-1,NP )))
                     END DO

#endif
                  END DO
               END DO

344         CONTINUE

355      CONTINUE
366   CONTINUE

#ifdef isam
      DO 766 JSPCTAG = 1, N_SPCTAG
        IF( TRANSPORT_SPC( JSPCTAG ) )THEN
          DO 755 L = 1, NLAYS
            DO 744 N = 1, NSTEPS

C Load working array (ISAM is coupled, SA_CONC is mixing ratio)

               DO R = 1, NROWS
                   DO C = 1, NCOLS
                      SA_CONC( C,R ) =
     &                ISAM( C,R,L,S_SPCTAG(JSPCTAG),T_SPCTAG(JSPCTAG) ) / RHOJ( C,R,L )
                   END DO ! C
               END DO ! R

C Fill 4 boundaries of working array SA_CONC: south, north, west, east
               DO C = 1, NCOLS
                  SA_CONC( C,0 )       = SA_HALO_SOUTH( C,L,JSPCTAG )
                  SA_CONC( C,NROWS+1 ) = SA_HALO_NORTH( C,L,JSPCTAG )
               END DO ! C

               DO R = 1, NROWS
                  SA_CONC( 0,R )       = SA_HALO_WEST( R,L,JSPCTAG )
                  SA_CONC( NCOLS+1,R ) = SA_HALO_EAST( R,L,JSPCTAG )
               END DO ! R

C Update ISAM
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     ISAM( C,R,L,S_SPCTAG(JSPCTAG),T_SPCTAG(JSPCTAG) ) =
     &                                RHOJ( C,R,L ) * SA_CONC( C,R )
     &                                + DTDX1S
     &                                * ( RK11( C+1,R,L )
     &                                * ( SA_CONC( C+1,R ) - SA_CONC( C,R ) )
     &                                - RK11( C,R,L )
     &                                * ( SA_CONC( C,R )   - SA_CONC( C-1,R ) ) )
     &                                + DTDX2S
     &                                * ( RK22( C,R+1,L )
     &                                * ( SA_CONC( C,R+1 ) - SA_CONC( C,R ) )
     &                                - RK22( C,R,L )
     &                                * ( SA_CONC( C,R )   - SA_CONC( C,R-1 ) ) )

                  END DO
               END DO

744         CONTINUE
755       CONTINUE
        END IF
766   CONTINUE
#endif


      RETURN

1001  FORMAT( 5X, 'Negative concentrations reset to', 1PE11.3 )
1003  FORMAT( 1X, 4I7, 9X, 1PE11.3)

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE ELMO_COMPOSITES

      USE ELMO_DATA
      USE RUNTIME_VARS, ONLY : LOGDEV, CMAQ_CHEM_CTRL, 
     &                         LOG_MESSAGE, LOG_SUBHEADING

      IMPLICIT NONE
 
      INTEGER, SAVE ::  N_COMPOSITES
      INTEGER, SAVE ::  N_MAX_COMPONENTS
      INTEGER, PARAMETER ::  N_MAX_FORMULA = 1024

      TYPE COMPOSITE_NML
          CHARACTER(LEN = 16) :: NAME
          CHARACTER(LEN = 100) :: DESC
          CHARACTER(LEN = 16) :: CUNIT
          CHARACTER(LEN = 16) :: CMPST_TYPE
          CHARACTER(LEN = N_MAX_FORMULA) :: FORMULA
      END TYPE COMPOSITE_NML

      TYPE( COMPOSITE_NML ), ALLOCATABLE, SAVE :: CMPST( : )
 
      CONTAINS

!-------------------------------------------------------------------------
      SUBROUTINE ELMO_READ_COMPOSITES()
!     This subroutine reads the mechanism-specific namelist file and
!     processes the composite variables defined there. The information
!     provided by the namelist file includes the name of the variable,
!     its units, a variable type (CONC or DEP), a long description, and
!     an formula for the variable based on other available variables.
!     These data are checked for basic errors and compiled into a list
!     so that they may be added to the ELMO_TABLE.
!-------------------------------------------------------------------------

      USE AERO_DATA, ONLY : AEROSPC, N_AEROSPC, N_MODE, AERO_MISSING
      USE CGRID_SPCS, ONLY : WDEP_SPC, N_SPC_WDEP, CGRID_NAME,
     &                       N_CGRID_SPC, N_SPC_DDEP
      USE VDIFF_MAP, ONLY : DDEP_SPC

      IMPLICIT NONE

      CHARACTER( 300 ) :: XMSG

      INTEGER FUNIT
      INTEGER IOST, IW, ID
      CHARACTER( 200 ) :: TMPLINE1, TMPLINE2, TMPLINE3
      CHARACTER( 40 )  :: PNAME = 'ELMO_READ_COMPOSITES'
      INTEGER IAERO, IAER, ICOMP, IM, INDX
      INTEGER N_MAX_COMPOSITES

      ! Define Namelist Input from Mechanism-Specific Control File
      Namelist / COMPOSITE_INIT / N_MAX_COMPOSITES, N_MAX_COMPONENTS
      Namelist / ELMO_COMPOSITES / CMPST

      CALL LOG_SUBHEADING( LOGDEV, 'Reading ELMO Composites '//
     &                             'from Mechanism-Specific Namelist')

      ! Retrieve the Name of the Mechanism-Specific Control File
      IF ( CMAQ_CHEM_CTRL .EQ. "CMAQ_CH_CTRL_NML" ) THEN
          XMSG = 'You have chosen not to indicate the location of a ' //
     &           'mechanism-specific control namelist file for ELMO '//
     &           'and DESID. You must give a value for the CMAQ_CH_CTRL_NML '//
     &           'variable in the CMAQ runscript.'
          CALL M3EXIT( PNAME,0,0,XMSG,1 )
      END IF

      ! Open Mechanism-Specific Control File
      FUNIT = JUNIT()
      OPEN( FILE = CMAQ_CHEM_CTRL, UNIT = FUNIT, STATUS = 'OLD',
     &      POSITION = 'REWIND', FORM='FORMATTED', IOSTAT = IOST )

      ! Check for Error in File Open Process
      IF ( IOST .NE. 0 ) THEN
          WRITE( XMSG, '(A,A,A)' ),'ERROR: Could not read ',
     &           'CMAQ CHemical Control namelist file: ',TRIM( CMAQ_CHEM_CTRL )
          CALL M3EXIT( PNAME,0,0,XMSG,1 )
      END IF

      ! Read the number of ELMO Composite Variables
      N_MAX_COMPOSITES = 0
      N_MAX_COMPONENTS = 1
      REWIND( FUNIT )
      READ( NML = COMPOSITE_INIT, UNIT = FUNIT, IOSTAT=IOST )
      IF ( IOST .EQ. -1 ) THEN
          ! The Number of Composites was completely missing
          XMSG = 'WARNING: Number of ELMO Composites was not specified. '//
     &           'If you intended to specify composite variables for ELMO, '//
     &           'check the CMAQ Chemical Control Namelist file.'
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )

      ELSE IF ( IOST .NE. 0 ) THEN
          ! Read Error detected for COMPOSITES_INIT
          backspace( FUNIT )
          read( FUNIT, fmt='(A)' ) tmpline1
          XMSG = 'ERROR: There was a syntax error reading the number of '//
     &           'composite variables for use by the ELMO module. Please '//
     &           'check the format of each line for syntax errors. The '//
     &           'invalid line was likely: '
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE1
          CALL M3EXIT ( PNAME, 0, 0, 'CMAQ must Crash until you '//
     &                  'fix the specification.', 1 )
      END IF

      ! Allocate and Initialize Namelist Variables
      ALLOCATE( CMPST( N_MAX_COMPOSITES + N_AEROSPC*3 ),
     &          STAT=IOST )
      CALL CHECKMEM( IOST, 'CMPST',PNAME)

      ! Read the Composite Definition Section
      CMPST%NAME       = ''
      CMPST%CUNIT      = ''
      CMPST%CMPST_TYPE = ''
      CMPST%DESC       = ''
      CMPST%FORMULA    = ''

      REWIND( FUNIT )
      READ( NML = ELMO_COMPOSITES, UNIT = FUNIT, IOSTAT=IOST )
      IF ( IOST .EQ. -1 ) THEN
          ! The ELMO Composites Section was completely missing
          XMSG = 'WARNING: There were no valid composite variables specified '//
     &           'for use by the ELMO module. If you intended to specify '//
     &           'diagnostic output in the emission control interface, check the '//
     &           'file you have provided for CMAQ_CH_CTRL_NML.'
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
      ELSE IF ( IOST .NE. 0 ) THEN
          ! Read Error for Composite Variables
          backspace( FUNIT )
          backspace( FUNIT )
          backspace( FUNIT )
          read( FUNIT, fmt='(A)' ) tmpline1
          read( FUNIT, fmt='(A)' ) tmpline2
          read( FUNIT, fmt='(A)' ) tmpline3
          XMSG = 'ERROR: There was a syntax error reading Composite '//
     &           'Variables for output by the ELMO module. Please check the format of '//
     &           'each line for syntax errors. The invalid line was likely the last '//
     &           'of this selection: '
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE1
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE2
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE3
          CALL M3EXIT ( 'DESID_READ_NAMELIST', 0, 0, 'CMAQ must Crash until you '//
     &                  'fix the Composite Variable Specification.', 1 )
      END IF

      ! Check that all user-defined Composites are populated
      N_COMPOSITES = 0
      DO ICOMP = 1,N_MAX_COMPOSITES
         IF ( CMPST(ICOMP)%NAME .NE. '' ) THEN
            N_COMPOSITES = N_COMPOSITES + 1
         END IF
      END DO

      CALL LOG_MESSAGE( LOGDEV, 'Completed Reading ELMO Composites '//
     &                             'from Mechanism-Spcific Namelist')

      ! Check that No Composite names are equal to any CGRID name
      DO ICOMP = 1,N_COMPOSITES
         INDX = INDEX1( CMPST(ICOMP)%NAME, N_CGRID_SPC, CGRID_NAME )
         IF ( INDX .NE. 0 ) THEN
            XMSG = 'The name of a Composite: ' // TRIM( CMPST(ICOMP)%NAME ) //
     &             ' is the same as a gas or particle species in CGRID. This is ' //
     &             'not allowed. Either delete this Composite or rename it.'
            CALL M3EXIT ( 'DESID_READ_NAMELIST', 0, 0, XMSG, 1 ) 
         END IF
      END DO

      ! Add Bulk Aerosols to Composite List
      DO IAERO = 1,N_AEROSPC
      
         ! Add this Aerosol Concentration to the Composite List
         IAER = INDEX1( AEROSPC(IAERO)%BULKNAME, N_COMPOSITES, CMPST%NAME )
         IF ( IAER .EQ. 0 ) THEN
            N_COMPOSITES = N_COMPOSITES + 1
            CMPST( N_COMPOSITES )%NAME = AEROSPC(IAERO)%BULKNAME
            CMPST( N_COMPOSITES )%CUNIT = 'ug m-3'
            CMPST( N_COMPOSITES )%CMPST_TYPE = 'TSP'
            CMPST( N_COMPOSITES )%DESC = 'Total ' // TRIM(AEROSPC(IAERO)%BULKNAME) //
     &           ' across all modes.'
            DO IM = 1,N_MODE
              IF ( .NOT. AERO_MISSING( IAERO, IM ) .AND. 
     &             AEROSPC( IAERO )%NAME(IM) .NE. AEROSPC(IAERO)%BULKNAME ) THEN
                CMPST( N_COMPOSITES )%FORMULA = 
     &                 TRIM( CMPST( N_COMPOSITES )%FORMULA ) //
     &                 ' + ' // TRIM(AEROSPC( IAERO )%NAME( IM ))
              END IF
            END DO
            IF ( CMPST( N_COMPOSITES )%FORMULA .EQ. '' ) N_COMPOSITES = N_COMPOSITES - 1
         END IF
   
         ! Add this Aerosol Wet Dep to the Composite List
         IAER = INDEX1( 'WD_'//AEROSPC(IAERO)%BULKNAME, N_COMPOSITES, CMPST%NAME )
         IF ( IAER .EQ. 0 ) THEN
            N_COMPOSITES = N_COMPOSITES + 1
            CMPST( N_COMPOSITES )%NAME = 'WD_' // AEROSPC(IAERO)%BULKNAME
            CMPST( N_COMPOSITES )%CUNIT = 'kg ha-1'
            CMPST( N_COMPOSITES )%CMPST_TYPE = 'DEP'
            CMPST( N_COMPOSITES )%DESC = 'Total ' // TRIM(AEROSPC(IAERO)%BULKNAME) //
     &           ' wet deposition across all modes.'
            DO IM = 1,N_MODE
              IF ( .NOT. AERO_MISSING( IAERO, IM ) .AND.
     &             AEROSPC( IAERO )%NAME(IM) .NE. AEROSPC(IAERO)%BULKNAME ) THEN
                IW = INDEX1( TRIM(AEROSPC( IAERO )%NAME( IM )), N_SPC_WDEP, WDEP_SPC )
                IF ( IW .NE. 0 ) 
     &               CMPST( N_COMPOSITES )%FORMULA = 
     &                    TRIM( CMPST( N_COMPOSITES )%FORMULA ) //
     &                    ' + ' // 'WD_' // TRIM(AEROSPC( IAERO )%NAME( IM ))
              END IF
            END DO
            IF ( CMPST( N_COMPOSITES )%FORMULA .EQ. '' ) N_COMPOSITES = N_COMPOSITES - 1
         END IF
         
         ! Add this Aerosol Dry Deposition to the Composite List
         IAER = INDEX1( 'DD_'//AEROSPC(IAERO)%BULKNAME, N_COMPOSITES, CMPST%NAME )
         IF ( IAER .EQ. 0 ) THEN
            N_COMPOSITES = N_COMPOSITES + 1
            CMPST( N_COMPOSITES )%NAME = 'DD_' // AEROSPC(IAERO)%BULKNAME
            CMPST( N_COMPOSITES )%CUNIT = 'kg ha-1'
            CMPST( N_COMPOSITES )%CMPST_TYPE = 'DEP'
            CMPST( N_COMPOSITES )%DESC = 'Total ' // TRIM(AEROSPC(IAERO)%BULKNAME) //
     &           ' dry deposition across all modes.'
            DO IM = 1,N_MODE
              IF ( .NOT. AERO_MISSING( IAERO, IM ) .AND.
     &             AEROSPC( IAERO )%NAME(IM) .NE. AEROSPC(IAERO)%BULKNAME ) THEN
                ID = INDEX1( TRIM(AEROSPC( IAERO )%NAME( IM )), N_SPC_DDEP+1, DDEP_SPC )
                IF ( ID .NE. 0 ) 
     &               CMPST( N_COMPOSITES )%FORMULA = 
     &                    TRIM( CMPST( N_COMPOSITES )%FORMULA ) //
     &                    ' + ' // 'DD_' // TRIM(AEROSPC( IAERO )%NAME( IM ))
              END IF
            END DO
            IF ( CMPST( N_COMPOSITES )%FORMULA .EQ. '' ) N_COMPOSITES = N_COMPOSITES - 1
         END IF
      END DO

      CLOSE( UNIT = FUNIT )

      ! Reduce the size of CMPST from N_MAX_COMPOSITES to N_COMPOSITES
      CMPST = CMPST( 1:N_COMPOSITES )

      END SUBROUTINE ELMO_READ_COMPOSITES

!-------------------------------------------------------------------------
      SUBROUTINE ELMO_MAP_COMPOSITES()
!     This subroutine maps the ELMO variables that the user has
!       requested to the entries in the ELMO_DATA table.
!-------------------------------------------------------------------------
      
      IMPLICIT NONE

      INTEGER N_VARS, J, ID, IVAR
      CHARACTER( 32 ) :: COMPS ( N_MAX_COMPONENTS )
      REAL            :: COEFFS( N_MAX_COMPONENTS )

      ! Loop through all available ELMO_TABLE Variables
      DO J = 1,N_ELMO_TABLE
          ID = ELMO_TABLE( J )%ID

          IF ( ELMO_TABLE( J )%VAR_TYPE .EQ. ET_CMPST .OR.
     &         ELMO_TABLE( J )%VAR_TYPE .EQ. ET_ISAM_CMPST .OR.
     &         ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DDM_CMPST .OR.
     &         ELMO_TABLE( J )%VAR_TYPE .EQ. ET_CMPST_DEP .OR.
     &         ELMO_TABLE( J )%VAR_TYPE .EQ. ET_ISAM_CMPST_DEP .OR.
     &         ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DDM_CMPST_DEP ) THEN
            
            CALL LOG_MESSAGE( LOGDEV, '   Reading Formula for Composite: '//
     &           TRIM( ELMO_TABLE( J )%OUT_NAME ) )


            ! Parse Formula from CMAQ Chemical Control Namelist
            CALL ELMO_PARSE_FORMULA( ID, N_VARS, COMPS, COEFFS )

            ! Account for Bulk Aerosol Names being used. Expand them if
            ! they are detected.
            CALL ELMO_EXPAND_AERO( N_VARS, COMPS, COEFFS )

            ! Map Composite
            CALL ELMO_INIT_COMPOSITE( J, N_VARS, CMPST( ID )%CMPST_TYPE )
            DO IVAR = 1,N_VARS
              CALL ELMO_SET_COMPONENTS( J, N_VARS, IVAR, COMPS( IVAR ), COEFFS( IVAR ) )
            END DO

         END IF
      END DO

      END SUBROUTINE ELMO_MAP_COMPOSITES

!-------------------------------------------------------------------------
      SUBROUTINE ELMO_INIT_COMPOSITE( J, N_VARS, AEROTYPE_TMP )
!     This subroutine allocates and initalizes all of the elements of an 
!        index IDG within the ELMO_COEFFS structure
!
!     IDG - the index of this ELMO variable in the space defined
!           by the integer index variables like ID_PMF_POC, etc.
!     N_VARS - Number of variables used to create this aggregate variable. 
!           Does not include the number of modes. For example, ASO4I+ASO4J 
!           counts as 1 variable (ASO4). It will be expanded to modes later.
!     AEROTYPE - Aerosol size range or mode to be calculated. This defines 
!           the modes considered and the inlet type if any. Options
!           include:
!             ALL, NONE, ULTRAFINE, FINE, COARSE, NUCLEATION, AITKEN,
!             ACCUMULATION, PM01, PM1, PM25, PM10, PM25to10 and PMAMS
!     
!-------------------------------------------------------------------------

      USE AERO_DATA, ONLY : N_MODE, AEROMODE
#ifdef isam
      USE SA_DEFN, ONLY : NTAG_SA
#elif sens
      USE DDM3D_DEFN, ONLY : NPMAX
#endif

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: J 
      INTEGER, INTENT( IN ) :: N_VARS
      CHARACTER( * ), INTENT( IN ) :: AEROTYPE_TMP
      CHARACTER( 20 ) AEROTYPE
      INTEGER VAR_TYPE, ISRC

      CHARACTER( 200 ) XMSG
      CHARACTER(16), SAVE :: PNAME = 'INIT_ELMO_COEF'
      INTEGER ALLOCSTAT

      ! Initialize All Components of ELMO_COEFFS
      ELMO_TABLE( J )%L_COMP = .TRUE.
      ELMO_COMP( J )%N_VARS = N_VARS
      ALLOCATE( ELMO_COMP( J )%L_MODE  ( N_MODE ),
#ifdef isam    
     &          ELMO_COMP( J )%L_SOURCE( NTAG_SA+1 ),
#elif sens
     &          ELMO_COMP( J )%L_SOURCE( NPMAX ),
#else
     &          ELMO_COMP( J )%L_SOURCE( 1 ),
#endif
     &          ELMO_COMP( J )%MW      ( N_VARS ),
     &          ELMO_COMP( J )%SPC_UNIT( N_VARS ),
     &          ELMO_COMP( J )%ID      ( N_VARS ),
     &          ELMO_COMP( J )%TABID   ( N_VARS ),
     &          ELMO_COMP( J )%VAR_TYPE( N_VARS ),
     &          ELMO_COMP( J )%COEFF   ( N_VARS ),
     &          STAT=ALLOCSTAT )
      IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating ELMO_COMP' 
           CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF

      ELMO_COMP( J )%L_MODE  ( : )  = .FALSE.
      ELMO_COMP( J )%L_SOURCE( : )  = .FALSE.
      ELMO_COMP( J )%MW      ( : )  = 0.
      ELMO_COMP( J )%SPC_UNIT( : )  = 0
      ELMO_COMP( J )%ID      ( : )  = 0
      ELMO_COMP( J )%TABID   ( : )  = 0
      ELMO_COMP( J )%VAR_TYPE( : )  = 0
      ELMO_COMP( J )%COEFF   ( : )  = 0.
      ELMO_COMP( J )%INLET          = 0
      ELMO_COMP( J )%WETNESS        = IWET

      ! Specify the Aerosol Modes Needed and Inlet Type based on User
      ! Input through the AEROTYPE variable.
      AEROTYPE = AEROTYPE_TMP
      CALL UPCASE( AEROTYPE )
      SELECT CASE ( AEROTYPE )
         CASE ('ULTRAFINE' )
             ELMO_COMP( J )%L_MODE( : ) = AEROMODE(:)%ULTRAFINE_MASK
         CASE ('FINE' )
             ELMO_COMP( J )%L_MODE( : ) = AEROMODE(:)%FINE_MASK
         CASE ('COARSE' )
             ELMO_COMP( J )%L_MODE( : ) = AEROMODE(:)%COARSE_MASK
         CASE ('NUCLEATION' )
             ELMO_COMP( J )%L_MODE( : ) = AEROMODE(:)%NUC_MASK
         CASE ('AITKEN' )
             ELMO_COMP( J )%L_MODE( : ) = AEROMODE(:)%AITKEN_MASK
         CASE ('ACCUMULATION' )
             ELMO_COMP( J )%L_MODE( : ) = AEROMODE(:)%ACCUM_MASK
         CASE ('PM01' )
             ELMO_COMP( J )%L_MODE( : ) = .TRUE.
             ELMO_COMP( J )%INLET = IPM01
             ELMO_COMP( J )%WETNESS = IWET
         CASE ('PM1' )
             ELMO_COMP( J )%L_MODE( : ) = .TRUE.
             ELMO_COMP( J )%INLET = IPM1
             ELMO_COMP( J )%WETNESS = IWET
         CASE ('PM25' )
             ELMO_COMP( J )%L_MODE( : ) = .TRUE.
             ELMO_COMP( J )%INLET = IPM25
             ELMO_COMP( J )%WETNESS = IWET
         CASE ('PM10' )
             ELMO_COMP( J )%L_MODE( : ) = .TRUE.
             ELMO_COMP( J )%INLET = IPM10
             ELMO_COMP( J )%WETNESS = IWET
         CASE ('PM25TO10' )
             ELMO_COMP( J )%L_MODE( : ) = .TRUE.
             ELMO_COMP( J )%INLET = IPM25to10
             ELMO_COMP( J )%WETNESS = IWET
         CASE ('PMAMS' )
             ELMO_COMP( J )%L_MODE( : ) = .TRUE.
             ELMO_COMP( J )%INLET = IPMAMS
             ELMO_COMP( J )%WETNESS = IWET
         CASE ('ALL' )
             ! This is a bulk quantity. All modes are selected.
             ELMO_COMP( J )%L_MODE( : ) = .TRUE.
         CASE ('TSP' )
             ! This is a bulk quantity. All modes are selected.
             ELMO_COMP( J )%L_MODE( : ) = .TRUE.
         CASE ('GAS')
             ! No Aerosol Parameters need to be set since
             ! this aggregate will be all gas.
         CASE ('DEP')
             ! Deposition will consist of particles from 
             ! the entire size range
             ELMO_COMP( J )%L_MODE( : ) = .TRUE.
         CASE ('DEP_FINE')
             ! Deposition will consist of particles from 
             ! the fine mode range
             ELMO_COMP( J )%L_MODE( : ) = AEROMODE(:)%FINE_MASK
         CASE ('DEP_COARSE')
             ! Deposition will consist of particles from 
             ! the coarse mode range
             ELMO_COMP( J )%L_MODE( : ) = AEROMODE(:)%COARSE_MASK
         CASE ('DEP_AITKEN')
             ! Deposition will consist of particles from 
             ! the Aitken mode range
             ELMO_COMP( J )%L_MODE( : ) = AEROMODE(:)%AITKEN_MASK
         CASE ('DEP_ACCUMULATION')
             ! Deposition will consist of particles from 
             ! the accumulation mode range
             ELMO_COMP( J )%L_MODE( : ) = AEROMODE(:)%ACCUM_MASK
         CASE DEFAULT
             XMSG = 'An aerosol descriptor (' // trim(AEROTYPE) // ') has been given ' //
     &              'for the mapping of an ELMO composite variable. It is not recognized.'
             CALL M3EXIT( 'ELMO_INIT_COMPOSITE', 0, 0, XMSG, XSTAT1 )
      END SELECT

      ! Determine the Variable Type
      VAR_TYPE = ELMO_TABLE( J )%VAR_TYPE
      
      ! If this variable is an ISAM or DDM variable, inherit the Source 
      ! for this Component from the Composite
      IF ( VAR_TYPE .EQ. ET_ISAM_CMPST    .OR. VAR_TYPE .EQ. ET_ISAM_CONC 
     & .OR. VAR_TYPE .EQ. ET_ISAM_CMPST_DEP
     & .OR.VAR_TYPE .EQ. ET_ISAM_WDEP     .OR. VAR_TYPE .EQ. ET_ISAM_DDEP
     & .OR.VAR_TYPE .EQ. ET_DDM_CMPST     .OR. VAR_TYPE .EQ. ET_DDM_CONC
     & .OR. VAR_TYPE .EQ. ET_DDM_CMPST_DEP 
     & .OR.VAR_TYPE .EQ. ET_DDM_WDEP      .OR. VAR_TYPE .EQ. ET_DDM_DDEP 
     &        ) THEN
            
         ! The only options are one source or all sources summed
         ! together (SOURCE from the ELMO Table variable = 0). 
         ! Future versions may expand the feature to allow subsets 
         ! of sources to be summed together.
         ISRC = ELMO_TABLE( J )%SOURCE
         IF ( ISRC .EQ. 0 ) THEN
            ELMO_COMP( J )%L_SOURCE(:) = .TRUE.
         ELSE
            ELMO_COMP( J )%L_SOURCE( ISRC ) = .TRUE.
         END IF
      END IF                                                                                                
      END SUBROUTINE ELMO_INIT_COMPOSITE 

!-------------------------------------------------------------------------
      SUBROUTINE ELMO_SET_COMPONENTS( J, N_VARS, IVAR, CSPEC_IN, COEFF )
!     This subroutine maps the variables in CSPEC to the ELMO Table and
!     stores IDs, variable properties, and coefficients for calculation
!     of ELMO variables during runtime.
!-------------------------------------------------------------------------

      USE PRECURSOR_DATA, ONLY : N_PRECURSOR, PRECURSOR
      USE AERO_DATA, ONLY : N_AEROSPC, AEROSPC
      IMPLICIT NONE

      INTEGER, INTENT( IN ) ::  J, IVAR
      INTEGER, INTENT( INOUT ) :: N_VARS
      CHARACTER( 32 ), INTENT( IN ) :: CSPEC_IN
      CHARACTER( 32 ) CSPEC
      REAL, INTENT( IN ) :: COEFF
      INTEGER  ISPEC, JSPEC, IAERO, ICGRID, IELMO
      INTEGER  I0, I1, I2, VAR_TYPE, ISRC, K
      CHARACTER( 1000 ) :: XMSG
      CHARACTER( 30 ),PARAMETER :: PNAME = 'ELMO_SET_COMPONENTS'

      ! Initialize Index for this COMPOSITE Component
      ELMO_COMP( J )%TABID( IVAR ) = 0

      ! Details in the processing of the components of variable J rely
      ! on knowing what type of variable it is
      VAR_TYPE = ELMO_TABLE( J )%VAR_TYPE

      CSPEC = CSPEC_IN
      
      ! Find this component in the ELMO_TABLE
      I1 = INDEX1( CSPEC, N_ELMO_TABLE, ELMO_TABLE(:)%OUT_NAME )
      !I2 = INDEX1( CSPEC, N_ELMO_TABLE, ELMO_TABLE(:)%NAME )

      ! For ISAM ELMO Variables, we need to make sure the components
      ! match the source number, or apply to all sources (i.e. ISAM
      ! Bulk)
      IF ( VAR_TYPE .EQ. ET_ISAM_CMPST .OR. 
     &     VAR_TYPE .EQ. ET_ISAM_CMPST_DEP ) THEN
#ifdef isam      
         CSPEC = TRIM(CSPEC) // '_ISAM'
         ISRC = ELMO_TABLE( J )%SOURCE
         DO K = 1,N_ELMO_TABLE
           IF ( ELMO_TABLE( K )%NAME .EQ. CSPEC .AND.
     &          ELMO_TABLE( K )%SOURCE .EQ. ISRC     ) THEN
              ! This component matches an ELMO Table Output Name
              ELMO_COMP( J )%TABID( IVAR )    = K
              ELMO_COMP( J )%ID( IVAR )       = ELMO_TABLE( K )%ID
              ELMO_COMP( J )%VAR_TYPE( IVAR ) = VAR_TYPE
              ELMO_COMP( J )%MW( IVAR )       = ELMO_TABLE( K )%MW
              CALL MAP_ELMO_UNITS( ELMO_TABLE( K )%CUNIT,
     &                       ELMO_COMP( J )%SPC_UNIT( IVAR ),
     &                       ELMO_TABLE( K )%NAME,
     &                       ELMO_TABLE( K )%VAR_TYPE )
              ELMO_COMP( J )%COEFF( IVAR )    = COEFF
           END IF
         END DO
#endif

      ELSE IF  ( VAR_TYPE .EQ. ET_DDM_CMPST .OR. 
     &           VAR_TYPE .EQ. ET_DDM_CMPST_DEP ) THEN
#ifdef sens
         CSPEC = TRIM(CSPEC) // '_DDM'
         ISRC = ELMO_TABLE( J )%SOURCE
         DO K = 1,N_ELMO_TABLE
           IF ( ELMO_TABLE( K )%NAME .EQ. CSPEC .AND.
     &          ELMO_TABLE( K )%SOURCE .EQ. ISRC     ) THEN
              ! This component matches an ELMO Table Output Name
              ELMO_COMP( J )%TABID( IVAR )    = K
              ELMO_COMP( J )%ID( IVAR )       = ELMO_TABLE( K )%ID
              ELMO_COMP( J )%VAR_TYPE( IVAR ) = VAR_TYPE
              ELMO_COMP( J )%MW( IVAR )       = ELMO_TABLE( K )%MW
              CALL MAP_ELMO_UNITS( ELMO_TABLE( K )%CUNIT,
     &                       ELMO_COMP( J )%SPC_UNIT( IVAR ),
     &                       ELMO_TABLE( K )%NAME,
     &                       ELMO_TABLE( K )%VAR_TYPE )
              ELMO_COMP( J )%COEFF( IVAR )    = COEFF
           END IF
         END DO 
#endif

      ELSE IF ( I1 .GT. 0 ) THEN
        ! This component matches an ELMO Table Output Name
        ELMO_COMP( J )%TABID( IVAR )    = I1
        ELMO_COMP( J )%ID( IVAR )       = ELMO_TABLE( I1 )%ID
        ELMO_COMP( J )%VAR_TYPE( IVAR ) = ELMO_TABLE( I1 )%VAR_TYPE
        ELMO_COMP( J )%MW( IVAR )       = ELMO_TABLE( I1 )%MW
        CALL MAP_ELMO_UNITS( ELMO_TABLE( I1 )%CUNIT,
     &                       ELMO_COMP( J )%SPC_UNIT( IVAR ),
     &                       ELMO_TABLE( I1 )%NAME,
     &                       ELMO_TABLE( I1 )%VAR_TYPE )
        ELMO_COMP( J )%COEFF( IVAR )    = COEFF
        
       !ELSE IF ( I2 .GT. 0 ) THEN
       ! ! This component matches an ELMO Table Name  
       ! ELMO_COMP( J )%TABID( IVAR )    = I2
       ! ELMO_COMP( J )%ID( IVAR )       = ELMO_TABLE( I2 )%ID
       ! ELMO_COMP( J )%VAR_TYPE( IVAR ) = ELMO_TABLE( I2 )%VAR_TYPE
       ! ELMO_COMP( J )%MW( IVAR )       = ELMO_TABLE( I2 )%MW
       ! CALL MAP_ELMO_UNITS( ELMO_TABLE( I2 )%CUNIT,
     & !                      ELMO_COMP( J )%SPC_UNIT( IVAR ),
     & !                      ELMO_TABLE( I2 )%NAME,
     & !                      ELMO_TABLE( I2 )%VAR_TYPE )
       ! ELMO_COMP( J )%COEFF( IVAR )    = COEFF
        
      ELSE
        ! Component Not found on the ELMO_TABLE. Crash CMAQ gracefully.
        XMSG = 'Component '//TRIM( CSPEC )//' of composite ' //
     &         TRIM( ELMO_TABLE(J)%OUT_NAME )//' is not valid. '//
     &         'Please correct the formula in the CMAQ Chemical '//
     &         'Control File.'
          CALL M3EXIT( PNAME,0,0,XMSG,1 )
      END IF
 



      !CALL LOG_MESSAGE( LOGDEV, '      Component: '//CSPEC )

      END SUBROUTINE ELMO_SET_COMPONENTS

!-------------------------------------------------------------------------
      SUBROUTINE ELMO_PARSE_FORMULA( ICMP, N_VARS, COMPS, COEFFS )
!     This subroutine interprets the formulae specifying the ELMO
!     composite variables in the CMAQ Chemical Control File.
!-------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER ICMP        ! Index of Composite
      INTEGER N_VARS      ! Number of Components in formula
      CHARACTER( 32 )  :: COMPS( N_MAX_COMPONENTS )
      REAL             :: COEFFS( N_MAX_COMPONENTS )
      CHARACTER( N_MAX_FORMULA ) :: FORMULA
      INTEGER          :: IX, IY, LENGTH, ICHR, ICHR2
      LOGICAL          :: LNEG, LEND, LCOEFF
      CHARACTER( 1 )   :: CHR, CHR2
      CHARACTER( 1000 ) :: XMSG
      CHARACTER( 30 ),PARAMETER :: PNAME = 'ELMO_PARSE_FORMULA'

      FORMULA = CMPST( ICMP )%FORMULA

      !WRITE( LOGDEV, '(6x,A)' )'Formula: '//FORMULA

      COMPS( 1:N_MAX_COMPONENTS ) = ''
      COEFFS( 1:N_MAX_COMPONENTS ) = 1.0
      N_VARS = 0
      LNEG = .FALSE.
      LCOEFF = .FALSE.
      IX = 1
      DO WHILE ( IX .LT. N_MAX_FORMULA )
         CHR = FORMULA( IX:IX ) 
         ICHR = ICHAR( CHR )

         IF ( CHR .EQ. ' ' .OR. CHR .EQ. '+' .or. CHR .EQ. '*' ) THEN
            ! This is a space, plus, or multiplication
            ! so proceed to the next character

         ELSE IF ( CHR .EQ. '-' ) THEN
            ! The next variable should be negative 
            LNEG = .TRUE.
         
         ELSE IF ( ICHR .GE. 48 .AND. ICHR .LE. 57 ) THEN
            ! This is a number. Find out what it is.
            ! Determine the coefficient of this component.
            N_VARS = N_VARS + 1
            LCOEFF = .TRUE.
            CALL ELMO_GETREAL( FORMULA, N_MAX_FORMULA, IX, LNEG,
     &                         COEFFS( N_VARS ) )
         ELSE
            ! This is a letter. Determine the component name
            IF ( LCOEFF ) THEN
               LCOEFF = .FALSE.
            ELSE
               N_VARS = N_VARS + 1
               IF ( LNEG ) THEN
                  COEFFS( N_VARS ) = -1.0
                  LNEG = .FALSE.
               END IF
            END IF

            LENGTH = 0
            LEND = .FALSE.
            IY = IX
            DO WHILE ( IY .LT. N_MAX_FORMULA .AND. .NOT.LEND )
               CHR2 = FORMULA( IY:IY )
               ICHR2 = ICHAR( CHR2 )

               ! Check if this character is not a space or a
               ! special character
               IF ( ( ICHR2 .GE. 65 .AND. ICHR2 .LE. 90 ) .OR. 
     &              ( ICHR2 .GE. 97 .AND. ICHR2 .LE. 122 ) .OR.
     &              ( ICHR2 .GE. 48 .AND. ICHR2 .LE. 57 ) .OR.
     &              ( ICHR2 .EQ. 95 ) ) THEN
                  LENGTH = LENGTH + 1
                  COMPS( N_VARS )( LENGTH:LENGTH ) = CHR2
               ELSE
                  LEND = .TRUE.
               END IF
               IY = IY + 1
            END DO
            IX = IY - 2
            
         END IF

         ! Go to the next character
         IX = IX + 1

      END DO    

      IF ( N_VARS .EQ. 0 ) THEN
         ! No variables found in this formula
         XMSG = 'A formula for an ELMO composite has an error or has '//
     &          'exceeded the allowed length specified by N_MAX_FORMULA. '//
     &          'The formula is: '//TRIM(FORMULA)
         CALL M3EXIT( PNAME,0,0,XMSG,XSTAT1 ) 
      END IF

      END SUBROUTINE ELMO_PARSE_FORMULA
 
!-------------------------------------------------------------------------
      SUBROUTINE ELMO_GETREAL( F, MX, IX, LNEG, COEF )
!     This subroutine parse ELMO composite definitions from the CMAQ
!     Chemical Control namelist and determines what the Real-type
!     coefficient is of a particular component.
!-------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER MX, IX
      CHARACTER( LEN=MX ) :: F
      LOGICAL LNEG
      REAL COEF
      CHARACTER( 16 ), SAVE :: PNAME = 'ELMO_GETREAL'
      CHARACTER( 300 ) XMSG
            
      INTEGER ICHR, LENGTH, NOSIGNS
      LOGICAL LDECIMAL, LEXP
      CHARACTER( 20 ) :: NUMSTRING
      CHARACTER(  1 ) :: CHR
      LOGICAL LSIGN

      LENGTH    = 0
      LDECIMAL  = .FALSE.
      LEXP      = .FALSE.
      NUMSTRING = ''
      LSIGN = .FALSE.

      DO WHILE ( IX .LT. MX )
        CHR = F( IX:IX )
        ICHR = ICHAR( CHR )

        ! Check if this character is a number
        IF ( ICHR .GE. 48 .AND. ICHR .LE. 57 ) THEN
           LENGTH = LENGTH + 1 
           NUMSTRING( LENGTH:LENGTH ) = CHR

        ! Check if this character is a decimal
        ELSE IF ( CHR .EQ. '.' ) THEN
           IF ( LDECIMAL ) THEN
              ! Too many decimals
              XMSG = 'Too many decimals have been used to specify '//
     &               'a coefficient in an ELMO Composite formula. '//
     &               'The formaula is: '//TRIM(F)
              CALL M3EXIT( 'ELMO_GETREAL',0,0,XMSG,XSTAT1 )
           ELSE
              LDECIMAL = .TRUE.
              LENGTH = LENGTH + 1 
              NUMSTRING( LENGTH:LENGTH ) = '.'
           END IF
              
        ! Check if this is an exponent
        ELSE IF ( CHR .EQ. 'E' .OR. CHR .EQ. 'e' ) THEN
           IF ( LEXP ) THEN
              ! Too many exponents
              XMSG = 'Too many exponents have been used to specify '//
     &               'a coefficient in an ELMO Composite formula. '//
     &               'The formula is: '//TRIM(F)
              CALL M3EXIT( PNAME,0,0,XMSG,XSTAT1 )
           ELSE
              LEXP = .TRUE.
              LENGTH = LENGTH + 1 
              NUMSTRING( LENGTH:LENGTH ) = 'e'
           END IF

        ! Check for sign
        ELSE IF ( CHR .EQ. '+' .OR. CHR .EQ. '-' ) THEN
           IF ( LSIGN ) THEN
              ! Too many signs
              XMSG = 'Too many signs have been used to specify '//
     &               'a coefficient in an ELMO Composite formula. '//
     &               'The formula is: '//TRIM(F)
              CALL M3EXIT( PNAME,0,0,XMSG,XSTAT1 )
           ELSE
              LSIGN = .TRUE.
              LENGTH = LENGTH + 1 
              NUMSTRING( LENGTH:LENGTH ) = CHR
           END IF

        ! If None of these, then we have reached the end of the
        ! coefficient
        ELSE
           IF ( ( .NOT. LEXP ) .AND. ( .NOT. LDECIMAL ) ) THEN
              LENGTH = LENGTH + 1
              NUMSTRING( LENGTH:LENGTH ) = '.'
           END IF
        
           ! Convert number string to real and resolve possible negative
           ! sign
           READ( NUMSTRING, '(E20.6)' ) COEF
           IF ( LNEG ) THEN
               COEF = COEF * -1.0
               LNEG = .FALSE.
           END IF

           RETURN
        END IF

        IX = IX + 1

      END DO

      ! If this point is reached, then IX exceeds the maximum of the
      ! allowed formula length. CMAQ should crash
      XMSG = 'A formula for an ELMO composite has an error or has '//
     &       'exceeded the allowed length specified by N_MAX_FORMULA. '//
     &       'The formula is: '//TRIM(F)

      CALL M3EXIT( PNAME,0,0,XMSG,XSTAT1 )

      END SUBROUTINE ELMO_GETREAL          
       
!-------------------------------------------------------------------------
      SUBROUTINE ELMO_EXPAND_AERO( N_VARS, COMPS, COEFFS )
!     This subroutine parse ELMO composite definitions from the CMAQ
!     Chemical Control namelist and determines what the Real-type
!     coefficient is of a particular component.
!-------------------------------------------------------------------------

      USE AERO_DATA, ONLY : N_AEROSPC, AEROSPC, N_MODE, AERO_MISSING,
     &                      MODESUFF

      IMPLICIT NONE
      
      INTEGER N_VARS      ! Number of Components in formula
      CHARACTER( 32 )  :: COMPS( N_MAX_COMPONENTS )
      CHARACTER( 32 )  :: COMPS_OUT( N_MAX_COMPONENTS )
      REAL             :: COEFFS( N_MAX_COMPONENTS )
      REAL             :: COEFFS_OUT( N_MAX_COMPONENTS )
      CHARACTER( 32 )  :: CSPEC
      INTEGER IVAR, I0, IM
      INTEGER O_VARS, JVAR
       
      IVAR = 1
      JVAR = 1
      O_VARS = N_VARS
      COMPS_OUT = COMPS
      COEFFS_OUT = COEFFS

      DO WHILE ( IVAR .LE. N_VARS )

         ! First Determine if this component is a bulk aerosol concentration 
         ! or deposition. If it is, then it needs to be expanded to add
         ! N_MODE variables to the components list.
         CSPEC = COMPS( IVAR )
         IF ( CSPEC(1:3) .EQ. 'DD_' .OR. CSPEC(1:3) .EQ. 'WD_' ) 
     &      CSPEC = CSPEC(4:32) // '   '
         
         I0 = INDEX1( CSPEC, N_AEROSPC, AEROSPC(:)%BULKNAME )
         IF ( I0 .NE. 0 ) THEN
            ! This is a Bulk Aerosol Species
            ! Add each available mode
            O_VARS = O_VARS - 1
            JVAR = JVAR - 1
            DO IM = 1,N_MODE
               IF ( .NOT. AERO_MISSING( I0,IM ) ) THEN
                  O_VARS = O_VARS + 1
                  JVAR = JVAR + 1
                  IF ( CSPEC .EQ. 'ASEACAT' .OR. CSPEC .EQ. 'ASOIL'
     &             .OR.CSPEC .EQ. 'ACORS'   .OR. CSPEC .EQ. 'ADE_CORS' ) THEN
                     COMPS_OUT( JVAR ) = COMPS( IVAR )
                  ELSE
                     COMPS_OUT( JVAR ) = TRIM( COMPS( IVAR ) ) // MODESUFF( IM )
                  END IF
                  COEFFS_OUT( JVAR ) = COEFFS( IVAR )
               END IF
            END DO
         ELSE 
            ! This is not a Bulk Aerosol Species.
            ! Just pass it through.
            COMPS_OUT( JVAR )  = COMPS( IVAR )
            COEFFS_OUT( JVAR ) = COEFFS( IVAR )

         END IF
         IVAR = IVAR + 1
         JVAR = JVAR + 1
      END DO

      N_VARS = O_VARS
      COMPS = COMPS_OUT
      COEFFS = COEFFS_OUT

      END SUBROUTINE ELMO_EXPAND_AERO
 
      END MODULE ELMO_COMPOSITES

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/wrdaymsg.f,v 1.3 2011/10/21 16:10:18 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WRDAYMSG( JDATE, MESG )

C-----------------------------------------------------------------------
C  Description:
C    Writes a text message to stdout and log file about which day is
C    being processed
C  Preconditions:
C  Subroutines and Functions Called:
C  Revision History:
C    Created 9/99 by M. Houyoux
C    02/11: S.Roselle-Replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling System
C File: @(#)$Id: wrdaymsg.f,v 1.3 2011/10/21 16:10:18 yoj Exp $
C COPYRIGHT (C) 2002, MCNC Environmental Modeling Center
C All Rights Reserved
C See file COPYRIGHT for conditions of use.
C Environmental Modeling Center
C MCNC
C P.O. Box 12889
C Research Triangle Park, NC  27709-2889
C smoke@emc.mcnc.org
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/wrdaymsg.f,v $
C Last updated: $Date: 2011/10/21 16:10:18 $ 
C-----------------------------------------------------------------------

      USE UTILIO_DEFN

      IMPLICIT NONE

C Includes:

C External Functions:

C Arguments:
      INTEGER       , INTENT(  IN ) :: JDATE    ! Julian date
      CHARACTER( * ), INTENT( OUT ) :: MESG     ! message buffer

C Parameters:
      CHARACTER( 9 ), PARAMETER :: WKDAYS( 7 ) =
     &                 ( / 'Monday   ', 'Tuesday  ', 'Wednesday', 'Thursday ',
     &                     'Friday   ', 'Saturday ', 'Sunday   ' / )

C Local variables:
      INTEGER         DAY          !  day of week number
      INTEGER         L            !  length of day name

      CHARACTER( 16 ) :: PNAME = 'WRDAYMSG' ! procedure name

C-----------------------------------------------------------------------

      DAY = WKDAY( JDATE )

      L = LEN_TRIM( WKDAYS( DAY ) )
      MESG = '>>> Processing ' // WKDAYS( DAY )( 1:L ) // ' ' // MMDDYY( JDATE )
      CALL M3MSG2( MESG )

      RETURN

      END SUBROUTINE WRDAYMSG

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module cgrid_spcs_types

      implicit none

      save

      ! Namelist Registry Format for Gases and Nonreactives
      TYPE SPECIES_DATA_REG_1
          CHARACTER( 16 ) :: SPECIES_NAME  ! CMAQ Species Name
          REAL            :: MOLWT         ! g mol-1
          CHARACTER( 16 ) :: IC_SURR       ! IC Surrogate
          REAL            :: IC_FAC        ! IC Scale Factor
          CHARACTER( 16 ) :: BC_SURR       ! BC Surrogate
          REAL            :: BC_FAC        ! BC Scale Factor
          CHARACTER( 16 ) :: DEPV_SURR     ! Dry Deposition Surrogate
          REAL            :: DEPV_FAC      ! Dry Deposition Scale Factor
          CHARACTER( 16 ) :: SCAV_SURR     ! Wet Scavenging Surrogate
          REAL            :: SCAV_FAC      ! Wet Scavenging Scale Factor
          CHARACTER( 16 ) :: AERO_SURR     ! Aerosol Module Surrogate
          CHARACTER( 16 ) :: CLOUD_SURR    ! Cloud Chemistry Surrogate
          CHARACTER( 16 ) :: TRNS_FLAG     ! Do Transport (ADV + DIFF)?
          CHARACTER( 16 ) :: DDEP_FLAG     ! Output Dry Deposition Velocities
          CHARACTER( 16 ) :: WDEP_FLAG     ! Output Wet Scavenging Fluxes
          CHARACTER( 16 ) :: CONC_FLAG     ! Output Concentration
      END TYPE SPECIES_DATA_REG_1
 
      ! Namelist Registry Format for Aerosols
      TYPE SPECIES_DATA_REG_2
          CHARACTER( 16 ) :: SPECIES_NAME  ! CMAQ Species Name
          REAL            :: MOLWT         ! g mol-1
          LOGICAL         :: LAIT          ! Aitken-Mode Presence
          LOGICAL         :: LACC          ! Accumulation -Mode Presence
          LOGICAL         :: LCOR          ! Coarse-Mode Presence
          CHARACTER( 16 ) :: OPTICS_SURR   ! material's refractive index surrogate
          CHARACTER( 16 ) :: IC_SURR       ! IC Surrogate
          REAL            :: IC_FAC        ! IC Scale Factor
          CHARACTER( 16 ) :: BC_SURR       ! BC Surrogate
          REAL            :: BC_FAC        ! BC Scale Factor
          CHARACTER( 16 ) :: DEPV_SURR     ! Dry Deposition Surrogate
          REAL            :: DEPV_FAC      ! Dry Deposition Scale Factor
          CHARACTER( 16 ) :: SCAV_SURR     ! Wet Scavenging Surrogate
          REAL            :: SCAV_FAC      ! Wet Scavenging Scale Factor
          CHARACTER( 16 ) :: CLOUD_SURR    ! Cloud Chemistry Surrogate
          CHARACTER( 16 ) :: TRNS_FLAG     ! Do Transport?
          CHARACTER( 16 ) :: DDEP_FLAG     ! Output Dry Deposition Velocities
          CHARACTER( 16 ) :: WDEP_FLAG     ! Output Wet Scavenging Fluxes
          CHARACTER( 16 ) :: CONC_FLAG     ! Output Concentration
      END TYPE SPECIES_DATA_REG_2

      ! Namelist Registry Format for Tracers
      TYPE SPECIES_DATA_REG_3
          CHARACTER( 16 ) :: SPECIES_NAME  ! CMAQ Species Name
          REAL            :: MOLWT         ! g mol-1
          CHARACTER( 16 ) :: IC_SURR       ! IC Surrogate
          REAL            :: IC_FAC        ! IC Scale Factor
          CHARACTER( 16 ) :: BC_SURR       ! BC Surrogate
          REAL            :: BC_FAC        ! BC Scale Factor
          CHARACTER( 16 ) :: DEPV_SURR     ! Dry Deposition Surrogate
          REAL            :: DEPV_FAC      ! Dry Deposition Scale Factor
          CHARACTER( 16 ) :: SCAV_SURR     ! Wet Scavenging Surrogate
          REAL            :: SCAV_FAC      ! Wet Scavenging Scale Factor
          CHARACTER( 16 ) :: AERO_SURR     ! Aerosol Module Surrogate
          CHARACTER( 16 ) :: CLOUD_SURR    ! Cloud Chemistry Surrogate
          CHARACTER( 16 ) :: ADVC_FLAG     ! Do Advection?
          CHARACTER( 16 ) :: DIFF_FLAG     ! Do Dispersion (i.e. Diffusion)?
          CHARACTER( 16 ) :: DDEP_FLAG     ! Output Dry Deposition Velocities
          CHARACTER( 16 ) :: WDEP_FLAG     ! Output Wet Scavenging Fluxes
          CHARACTER( 16 ) :: CONC_FLAG     ! Output Concentration
      END TYPE SPECIES_DATA_REG_3

      TYPE (SPECIES_DATA_REG_2), ALLOCATABLE :: AE_SPECIES_DATA(:)

      END MODULE CGRID_SPCS_TYPES

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine get_global_coords ( local_col, local_row, global_col, global_row )

      ! This subroutine returns the global column and row coordinates
      ! when given the local coordinates on the current processor.

      USE RUNTIME_VARS, ONLY : NPROCS, MYPE
      USE PIOMAPS_MODULE

      implicit none
      
      integer, intent( in ) :: local_col  ! Column on PE
      integer, intent( in ) :: local_row  ! Row on PE
      integer, intent( out) :: global_col ! Column in Full Domain
      integer, intent( out) :: global_row ! Row in Full Domain

      integer i

      if ( nprocs .eq. 1 ) then
          global_col = local_col
          global_row = local_row
      else
          i = mype + 1
          global_col = colsx_pe( 1,i ) - 1 + local_col
          global_row = rowsx_pe( 1,i ) - 1 + local_row
      end if

      end subroutine get_global_coords

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine get_local_coords ( global_col, global_row, local_col, local_row )

      ! This subroutine returns the local column and row coordinates
      ! when given the global coordinates on the current processor.

      USE RUNTIME_VARS, ONLY : NPROCS, MYPE
      USE PIOMAPS_MODULE

      implicit none
      
      integer, intent( out) :: local_col  ! Column on PE
      integer, intent( out) :: local_row  ! Row on PE
      integer, intent( in ) :: global_col ! Column in Full Domain
      integer, intent( in ) :: global_row ! Row in Full Domain

      integer i

      if ( nprocs .eq. 1 ) then
          local_col = global_col
          local_row = global_row
      else
          i = mype + 1
          local_col = global_col - colsx_pe( 1,i ) + 1
          local_row = global_row - rowsx_pe( 1,i ) + 1
      end if

      end subroutine get_local_coords 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/PARIO/src/piomaps_mod.f,v 1.2 2006/06/05 17:36:43 yoj Exp $ 

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C....................................................................
 
C  CONTAINS:  Processor-to-subdomain maps for parallel Models-3
C             I/O routines.
 
C  DEPENDENT UPON:  none 
 
C  REVISION HISTORY:
C       Original version 02/04 by David Wong
C       Modified 12/05/2015 by David Wong
C          -- Added two new varaible PIO_GL_NCOLS and PIO_GL_NROWS
C       Modified 12/09/2015 by David Wong
C          -- Introduced a new variable PARIO_IO_PE_INCLUSIVE to determine
C             which procesor involves in file closing process
 
C  NOTES:  The mapping assumes 2-dimensional subdomain decomposition,
C          over grid rows and columns.
C....................................................................

C  ----------------------------------------------------
C  The arrays below are allocated by function PIO_INIT.
C  ----------------------------------------------------

C    INTEGER  NUMPROCS              Number of processors.

C    INTEGER  NCOLS_PE( NUMPROCS )      Number grid columns in the processor
C    INTEGER  NROWS_PE( NUMPROCS )      Number grid rows in the processor
C    INTEGER  COLSX_PE( 2,NUMPROCS )    Processor column range:
C                                       COLSX_PE(1,*) = start column index
C                                       COLSX_PE(2,*) = end column index
C    INTEGER  ROWSX_PE( 2,NUMPROCS )    Processor row range:
C                                       ROWSX_PE(1,*) = start row index
C                                       ROWSX_PE(2,*) = end row index
C    INTEGER  WR_NCOLS_PE( NUMPROCS )   Number of columns in the processor
C                                       subgrid to write
C    INTEGER  WR_NROWS_PE( NUMPROCS )   Number of rows in the processor
C                                       subgrid to write
C                                       ROWSX_PE(2,*) = end row index
C    INTEGER  WR_COLSX_PE( 2,NUMPROCS ) Column range of the processor subgrid
C                                       to write
C                                       COLSX_PE(1,*) = start column index
C                                       COLSX_PE(2,*) = end column index
C    INTEGER  WR_ROWSX_PE( 2,NUMPROCS ) Row range of the processor subgrid
C                                       to write
C                                       ROWSX_PE(1,*) = start row index

C....................................................................

      MODULE PIOMAPS_MODULE

      INTEGER  NUMPROCS
  
      INTEGER, ALLOCATABLE :: NCOLS_PE( : )
      INTEGER, ALLOCATABLE :: COLSX_PE( :,: )

      INTEGER, ALLOCATABLE :: NROWS_PE( : )
      INTEGER, ALLOCATABLE :: ROWSX_PE( :,: )

      INTEGER, ALLOCATABLE :: WR_NCOLS_PE( : )
      INTEGER, ALLOCATABLE :: WR_COLSX_PE( :,: )

      INTEGER, ALLOCATABLE :: WR_NROWS_PE( : )
      INTEGER, ALLOCATABLE :: WR_ROWSX_PE( :,: )

      integer :: pio_gl_ncols
      integer :: pio_gl_nrows

      LOGICAL :: PARIO_IO_PE_INCLUSIVE

      END MODULE PIOMAPS_MODULE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      REAL FUNCTION MOLCPROD( NAMETYP, NAMINDX, NRX, NPFND )

C-----------------------------------------------------------------------
C Function: To find the number of species/family molecules produced in a reaction 
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C-----------------------------------------------------------------------
 
      USE PA_GLOBAL     ! Mech and Grid data used 
      USE PA_VARS

      IMPLICIT NONE
      
C Includes: None
      
C Arguments:
      CHARACTER( * ) :: NAMETYP  ! Type of name (mechanism species of family)
      INTEGER NAMINDX    ! Index for species or family name location
      INTEGER NRX        ! Reaction number
      INTEGER NPFND      ! Number of products found
                                        
C Parameters: None

C External Functions: None 

C Local Variables:

      CHARACTER( 16 ) :: SPECIS    ! Species name to check

      INTEGER INDX       ! Pointer to reactant name
      INTEGER IRRPNTR    ! Pointer to product species in IRR array
      INTEGER N          ! Loop index for number of family members
      INTEGER NPR        ! Loop index for number of reactants
      INTEGER NUMSPEC    ! Number of species to check

      REAL    SUM        ! Sum of molecular production and loss
      REAL    COEF       ! Defined stoichiometric coefficient
         
C-----------------------------------------------------------------------
      NPFND = 0
      SUM = 0.0

c..Determine loop index for family name versus mechanism species
      IF ( NAMETYP .EQ. 'FAM' ) THEN
         NUMSPEC = NUMFAMMEM( NAMINDX )
      ELSE
         NUMSPEC = 1
      END IF
      
c..Add the number of species/family member molecules lost in this reaction
      DO NPR = 1, NPRDCT( NRX )
         IRRPNTR = NPR + 3
         INDX = IRR( NRX, IRRPNTR )
         IF ( INDX .NE. 0 ) THEN
            DO N = 1, NUMSPEC
               IF ( NAMETYP .EQ. 'FAM' ) THEN
                  SPECIS = FAMMEMNAM( NAMINDX, N )
                  COEF = FAMSC( NAMINDX,N )
               ELSE
                  SPECIS = CHEMISTRY_SPC( NAMINDX )
                  COEF = 1.0
               END IF
               IF ( CHEMISTRY_SPC( INDX ) .EQ. SPECIS ) THEN
                  SUM = SUM + COEF * SC( NRX,NPR ) 
                  NPFND = NPFND + 1
               END IF    
            END DO
          END IF
      END DO

      MOLCPROD = SUM

      RETURN

      END FUNCTION MOLCPROD

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HPPM ( NI, NJ, CON, VEL, DT, DS, ORI,
     &                  F_LO_IN, F_LO_OUT, F_HI_IN, F_HI_OUT )
      
C----------------------------------------------------------------------
C Function      
C   This is the one-dimensional implementation of piecewise parabolic
C   method.  Variable grid spacing is allowed. The scheme is positive
C   definite and monotonic. It is conservative, and causes small
C   numerical diffusion.
      
C   A piecewise continuous parabola is used as the intepolation polynomial.
C   The slope of the parabola at cell edges are computed from a cumulative
C   function of the advected quantity.  These slopes are further modified
C   so that the interpolation function is monotone. For more detailed
C   information see:
      
C   Colella, P., and P. L. Woodward, (1984), "The Piecewise Parabolic
C   Method (PPM) for Gas-Dynamical Simulations," J. Comput. Phys. 54,
C   174-201.
      
C   The concentrations at boundary cells (i.e., at 1 and NI) are not
C   computed here.  They should be updated according to the boundary
C   conditions.
      
C   The following definitions are used:
     
C              |---------------> Positive direction
C     
C  -->|Boundary|<----------------Main Grid----------------->|Boundary|<--
C     
C     |<------>|<------>|       ~|<------>|~       |<------>|<------>|
C       CON(0)   CON(1)            CON(i)            CON(n)  CON(n+1)
C     
C     VEL(1)-->|        VEL(i)-->|        |-->VEL(i+1)      |-->VEL(n+1)
C    
C      FP(0)-->|       FP(i-1)-->|        |-->FP(i)         |-->FP(n)
C     
C      FM(1)<--|         FM(i)<--|        |<--FM(i+1)       |<--FM(n+1)
C    
C                             -->| DS(i)  |<--
      
C----------------------------------------------------------------------
      
C Revision History:
      
C   20 April, 1993 by M. Talat Odman at NCSC: 
C   Created based on Colella and Woodward (1984)
      
C   15 Sept., 1993 by Daewon Byun at EPA:
C   Original code obtained from Phillip Colella at Berkeley
      
C   29 Nov.,  1993 by M. Talat Odman at NCSC:
C   Found no difference from original code
      
C   05 Oct.,  1993 by M. Talat Odman at NCSC:
C   Modified for EDSS archive, made discontinuity capturing an option

C   Sep 97 Jeff
C   Aug 98 - Jeff - optimize for mesh coefficients      

C   David Wong - Sep. 1998
C     -- parallelized the code
C     -- Expanded the one-level nested loop which involves either with row or
C        column, into a three-level nested loop with layers and species.
C        Corresponding arrays' dimensions were adjusted accordingly
C   Jeff - optimize for mesh coefficients
C
C   David Wong - 1/8/99
C     -- BARRIER is removed
C
C   David Wong - 1/12/99
C     -- inside BNDY_HI_PE conditional code segment, NI is changed to MY_NI
C
C   David Wong - 1/12/99
C     -- change se_loop_index argument list
C     -- add new subroutine call to determine lo and hi boundary processor

C   22 Nov 00 J.Young: PE_COMM2E -> Dave Wong's f90 stenex COMM
C                      PE_COMM3E -> Dave Wong's f90 stenex COMM

C   23 Feb 01 J.Young: allocatable arrays ...
C                      Since F90 does not preserve dummy argument array
C                      indices, CONI( 1:NI+2,, ) is copied into local array
C                      CON( 0:NI+1,, ).
C                      The caller of HPPM dimensions the actual argument,
C                      as CON( -NTHIK+1:MY_NCOLS+NTHIK,, ).

C   3 Sep 01 David Wong
C     -- use "dynamic" data structure instead of F90 ALLOCATE statement to
C        avoid memory fragmentation which eventually leads to not enough
C        contigous memory (F90 bug?)
C   24 Mar 04 G.Hammond: moved all mpi communication to caller

C   06/16/04 by Peter Percell & Daewon Byun at UH-IMAQS: 
C     - Fixed bug in using fluxes in non-uniform grids to update concentrations

C   14 Feb 05 J.Young: fix DS dimension bug
C   11 Oct 05 J.Young: re-dimension lattice arrays to one
C    1 Nov 06 J.Young: Following Glenn Hammond, moved all communication
C   out of HPPM; using "swap_sandia" communication in caller; update only
C   local values in the CGRID array within a time step, discarding previous
C   ghost values.
C    1 May 07 J.Young: Following Peter Percell, eliminate CONI,DSI using interface
C   specification in caller
C   11 May 09 J.Young: Simplify - remove STEEPEN option (never used); assume constant
C                      cell widths, DS( i )
C   11 May 10 D.Wong: Change local dynamic arrays: make allocatable to enable proper
C                     PGI compiliation; fix a max first dimension
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN

C----------------------------------------------------------------------
      
      USE HGRD_DEFN
      USE UTILIO_DEFN
      USE PA_DEFN, ONLY : BUDGET_DIAG, BUDGET_HPPM
#ifdef parallel
      USE SE_MODULES          ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES        ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

C Includes:
      
! #ifdef parallel
      INTEGER, PARAMETER :: SWP = 3
      INTEGER, PARAMETER :: X1 = 1
      INTEGER, PARAMETER :: X2 = 2
      INTEGER, PARAMETER :: X3 = 3
! #else
!     INTEGER, PARAMETER :: SWP = 1
!     INTEGER, PARAMETER :: X1 = 0
!     INTEGER, PARAMETER :: X2 = 0
!     INTEGER, PARAMETER :: X3 = 0
! #endif

C Arguments:
 
      INTEGER, INTENT( IN )    :: NI, NJ      ! number of zones (cells)
      REAL,    INTENT( INOUT ) :: CON( 1-SWP:,1: ) ! conc's in the zones (cells)
      REAL,    INTENT( IN )    :: VEL( : )    ! velocities at zone (cell) boundaries
      REAL,    INTENT( IN )    :: DT          ! time step
      REAL,    INTENT( IN )    :: DS          ! distance between zone (cell) boundaries
      CHARACTER, INTENT( IN )  :: ORI         ! orientation of advection ('C'-x or 'R'-y)

C Parameters:
      
      REAL, PARAMETER :: TWO3RDS = 2.0 / 3.0
      REAL, PARAMETER :: SIXTH   = 1.0 / 6.0

C Local variables:

      CHARACTER, SAVE :: FIRSTORI = ' '   ! for test if Col or Row orientation change
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      
      INTEGER, SAVE :: NSPCS
      INTEGER, SAVE :: NSPCS_BUDGET = 0

!     REAL :: FM    (    1:NI+1,   SIZE( CON,2 ) ) ! outflux from left or bottom of cell
!     REAL :: FP    (    0:NI,     SIZE( CON,2 ) ) ! outflux from right or top of cell

!     REAL :: CM    ( 1-X1:NI+X1+1,SIZE( CON,2 ) ) ! zone R.H. trial intercept
!     REAL :: CL    ( 1-X1:NI+X1 )                 ! zone L.H. intercept
!     REAL :: CR    ( 1-X1:NI+X1 )                 ! zone R.H. intercept
!     REAL :: DC    ( 0-X1:NI+X1+1,SIZE( CON,2 ) ) ! CR - CL
!     REAL :: C6    ( 1-X1:NI+X1 )                 ! coefficient of second-order term

      REAL, ALLOCATABLE, SAVE :: FM( :,: ) ! outflux from left or bottom of cell
      REAL, ALLOCATABLE, SAVE :: FP( :,: ) ! outflux from right or top of cell

      REAL, ALLOCATABLE, SAVE :: CM( :,: ) ! zone R.H. trial intercept
      REAL, ALLOCATABLE, SAVE :: CL( : )   ! zone L.H. intercept
      REAL, ALLOCATABLE, SAVE :: CR( : )   ! zone R.H. intercept
      REAL, ALLOCATABLE, SAVE :: DC( :,: ) ! CR - CL
      REAL, ALLOCATABLE, SAVE :: C6( : )   ! coefficient of second-order term
      REAL C0, C1

      ! Boundary fluxes returned for budget calculations
      ! Units of boundary fluxes are assumed to be 
      ! density (aerosols) or mixing ratio (gases). These values
      ! are in 'coupled' space, meaning they need to be decoupled
      ! using the Jacobian and map scale factor in order to properly
      ! contribute to total mass calculations.
      REAL, INTENT( OUT) :: F_LO_IN( : )  ! influx to domain from left of row or bottom of column
      REAL, INTENT( OUT) :: F_LO_OUT(: ) ! outflux to domain from left of row or bottom of column
      REAL, INTENT( OUT) :: F_HI_IN( : )  ! influx to domain from right of row or bottom of top
      REAL, INTENT( OUT) :: F_HI_OUT(: ) ! outflux to domain from right of row or bottom of top

      LOGICAL, SAVE :: BNDY_LO_PE, BNDY_HI_PE

      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER( 16 ) :: PNAME = 'HPPM'

      REAL X, Y                 ! Courant number
      INTEGER NMX, ASTAT
      
      INTEGER I, S              ! loop indices

C----------------------------------------------------------------------

#ifdef isam
      FIRSTIME = .TRUE.
#else
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
#endif
         NMX = MAX( NI,NJ )
         NSPCS = SIZE ( CON,2 )
         ALLOCATE( FM(     1:NMX+1,    NSPCS ),
     &             FP(     0:NMX,      NSPCS ),
     &             CM(  1-X1:NMX+X1+1, NSPCS ),
     &             CL(  1-X1:NMX+X1 ),
     &             CR(  1-X1:NMX+X1 ),
     &             DC(  0-X1:NMX+X1+1, NSPCS ),
     &             C6(  1-X1:NMX+X1 ), 
     &             STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = '*** Error allocating FM, FP, CM, CL, CR, DC, or C6'
            CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF
         
#ifdef isam
#else
      END IF   ! Firstime
#endif

      IF ( ORI .NE. FIRSTORI ) THEN
         FIRSTORI = ORI
         CALL SUBST_HI_LO_BND_PE ( ORI, BNDY_LO_PE, BNDY_HI_PE )
      END IF   ! FIRSTORI

C Set all fluxes to zero. Either positive or negative flux will remain zero
C depending on the sign of the velocity.

      FM( 1:NI+1,: ) = 0.0
      FP( 0:NI,: ) = 0.0

! #ifndef parallel
C If PE near bottom or left domain boundary...
C Zeroth order polynomial at the boundary cells
C First order polynomial at the next cells, no monotonicity constraint needed
!     IF ( BNDY_LO_PE ) THEN
!        DO S = 1, NSPCS
!           CM( 1,S ) = CON( 1,S )
!           CM( 2,S ) = 0.5 * ( CON( 1,S ) + CON( 2,S ) )
!        END DO
!     END IF

C If PE near top or right domain boundary...
C Zeroth order polynomial at the boundary cells
C First order polynomial at the next cells, no monotonicity constraint needed
!     IF ( BNDY_HI_PE ) THEN
!        DO S = 1, NSPCS
!           CM( NI+1,S ) = CON( NI,S )
!           CM( NI,S )   = 0.5 * ( CON( NI,S ) + CON( NI-1,S ) )
!        END DO
!     END IF
! #endif
      
C Second order polynomial inside the domain
      
      DO S = 1, NSPCS
         DO I = 2 - X3, NI + X3 - 1
      
C Compute average slope in the i'th zone
      
C Equation (1.7)
            C0 = CON( I,S )   - CON( I-1,S )
            C1 = CON( I+1,S ) - CON( I,S )
            DC( I,S ) = 0.5 * ( C0 + C1 )
      
C Guarantee that CM lies between CON(I) and CON(I+1) - monotonicity constraint

C Equation (1.8)
            IF ( C0 * C1 .GT. 0.0 ) THEN
               DC( I,S ) = SIGN( 1.0, DC( I,S ) )
     &                   * MIN(      ABS( DC( I,S ) ),
     &                         2.0 * ABS( C0 ),
     &                         2.0 * ABS( C1 ) )
            ELSE
               DC( I,S ) = 0.0
            END IF

         END DO   ! I

C Equation (1.6)
         DO I = 3 - X3, NI + X3 - 1
            CM( I,S ) = 0.5 * ( CON( I,S ) + CON( I-1,S ) )
     &                - SIXTH * ( DC( I,S ) - DC( I-1,S ) )
         END DO

      END DO   ! S

C Generate piecewise parabolic distributions

      DO S = 1, NSPCS

         DO I = 1 - X1, NI + X1

C Equation (1.15)
            CR( I ) = CM( I+1,S )
            CL( I ) = CM( I,S )
 
C Monotonicity
 
            IF ( ( CR( I ) - CON( I,S ) )
     &        * ( CON( I,S ) - CL( I ) ) .GT. 0.0 ) THEN

C Temporary computation of DC and C6
               DC( I,S ) = CR( I ) - CL( I )
               C6( I ) = 6.0 * ( CON( I,S ) - 0.5 * ( CL( I ) + CR( I ) ) )

C overshoot cases - Equation (1.10)
               IF ( DC( I,S ) * C6( I ) .GT.
     &              DC( I,S ) * DC( I,S ) ) THEN
                  CL( I ) = 3.0 * CON( I,S ) - 2.0 * CR( I )
               ELSE IF ( -DC( I,S ) * DC( I,S ) .GT.
     &                    DC( I,S ) * C6( I ) ) THEN
                  CR( I ) = 3.0 * CON( I,S ) - 2.0 * CL( I )
               END IF

            ELSE                   ! Local extremum: Interpolation  
                                   ! function is set to be a constant
               CL( I ) = CON( I,S )
               CR( I ) = CL( I )

            END IF

            DC( I,S ) = CR( I ) - CL( I )      ! Equation (1.5)
            C6( I ) = 6.0 * ( CON( I,S ) - 0.5 * ( CL( I ) + CR( I ) ) )

         END DO   ! I

C Compute fluxes from the parabolic distribution as in Equation (1.12)

! #ifdef parallel
!        I = 0
!        IF ( VEL( I+1 ) .GT. 0.0 ) THEN
!           Y = VEL( I+1 ) * DT
!           X = Y / DS
!           FP( I,S ) = Y * ( CR( I ) - 0.5 * X * ( DC( I,S )
!    &                - C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
!        END IF
! #endif
      
!        IF ( BNDY_LO_PE ) THEN
            I = 0
            IF ( VEL( I+1 ) .GT. 0.0 ) THEN
               Y = VEL( I+1 ) * DT
               X = Y / DS
               FP( I,S ) = Y * ( CR( I ) - 0.5 * X * ( DC( I,S )
     &                   - C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF
!        END IF

         DO I = 1, NI

C function for mass leaving interval I at lower face (I-1/2)
C = length of segment leaving * integral average concentration in that segment
            IF ( VEL( I ) .LT. 0.0 ) THEN
               Y = -VEL( I ) * DT
               X = Y / DS
               FM( I,S ) = Y * ( CL( I ) + 0.5 * X * ( DC( I,S )
     &                   + C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF

C function for mass leaving interval I at upper face (I+1/2)
            IF ( VEL( I+1 ) .GT. 0.0 ) THEN
               Y = VEL( I+1 ) * DT
               X = Y / DS
               FP( I,S ) = Y * ( CR( I ) - 0.5 * X * ( DC( I,S )
     &                   - C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF

         END DO   ! I

! #ifdef parallel
!        I = NI + 1
!        IF ( VEL( I ) .LT. 0.0 ) THEN
!           Y = -VEL( I ) * DT
!           X = Y / DS
!           FM( I,S ) = Y * ( CL( I ) + 0.5 * X * ( DC( I,S )
!    &                + C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
!        END IF
! #endif
!        IF ( BNDY_HI_PE ) THEN
            I = NI + 1
            IF ( VEL( I ) .LT. 0.0 ) THEN
               Y = -VEL( I ) * DT
               X = Y / DS
               FM( I,S ) = Y * ( CL( I ) + 0.5 * X * ( DC( I,S )
     &                   + C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF
!        END IF

      END DO   ! S

C Compute fluxes from boundary cells
      
C If PE near top or left boundary...
      IF ( BNDY_LO_PE ) THEN
         IF ( VEL( 1 ) .GT. 0.0 ) THEN
            Y = VEL( 1 ) * DT
            DO S = 1, NSPCS
               FP( 0,S ) = Y * CON( 0,S )
            END DO
         END IF
      END IF

C If PE near bottom or right boundary...
      IF ( BNDY_HI_PE ) THEN
         IF ( VEL( NI+1 ) .LT. 0.0 ) THEN
            Y = -VEL( NI+1 ) * DT
            DO S = 1, NSPCS
               FM( NI+1,S ) = Y * CON( NI+1,S )
            END DO
         END IF
      END IF

C Update concentrations as in Equation (1.13)
      DO S = 1, NSPCS
         DO I = 1, NI
            CON( I,S ) = CON( I,S )
     &                 + ( FP( I-1,S ) - FP( I,S ) + FM( I+1,S ) - FM( I,S ) ) / DS
         END DO
      END DO

C Store boundary fluxes in budget variables
C   Units: change in density (aerosols) or mixing ratio (gases)
      IF ( BUDGET_HPPM ) THEN
         NSPCS_BUDGET = MIN( NSPCS,SIZE( F_LO_IN ) )
         F_LO_IN ( 1:NSPCS_BUDGET ) = FP( 0,1:NSPCS_BUDGET ) / DS
         F_LO_OUT( 1:NSPCS_BUDGET ) = FM( 1,1:NSPCS_BUDGET ) / DS
         F_HI_OUT( 1:NSPCS_BUDGET ) = FP( NI,1:NSPCS_BUDGET ) / DS
         F_HI_IN ( 1:NSPCS_BUDGET ) = FM( NI+1,1:NSPCS_BUDGET ) / DS
      END IF

#ifdef isam
Ckrt...deallocate local arrays....20140126
         IF ( ALLOCATED( FM ) ) DEALLOCATE( FM )

         IF ( ALLOCATED( FP ) ) DEALLOCATE( FP )

         IF ( ALLOCATED( CM ) ) DEALLOCATE( CM )

         IF ( ALLOCATED( CL ) ) DEALLOCATE( CL )

         IF ( ALLOCATED( CR ) ) DEALLOCATE( CR )

         IF ( ALLOCATED( DC ) ) DEALLOCATE( DC )

         IF ( ALLOCATED( C6 ) ) DEALLOCATE( C6 )
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

        SUBROUTINE PM3ERR( CALLER, JDATE, JTIME, ERRTXT, FATAL )
C.....................................................................
C
C  PURPOSE:   Provides M3ERR functionality in a parallel environment.
C             The processor-id suffix is appended to the name of the
C             caller. Generate simple error messages for Models-3, and
C             terminate program execution via MPI_ABORT iff FATAL.
C
C
C  PRECONDITIONS REQUIRED:  Same as for M3EXIT.
C
C
C  REVISION  HISTORY:
C       Original version 07/1999 by Al Bourgeois to provide proper
C           program exiting in parallel environment.
C       Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with M3UTILIO; removed
C             deprecated TRIMLEN
C
C
C  ARGUMENT LIST DESCRIPTION:
C  IN:
C     CHARACTER*(*)   CALLER       ! Name of the caller.
C     INTEGER         JDATE        ! Model date for the error.
C     INTEGER         JTIME        ! Model time for the error.
C     CHARACTER*(*)   ERRTXT       ! Error message.
C     LOGICAL         FATAL        ! Terminate program iff TRUE.
C
C     COMMON BLOCK PIOVARS:
C     INTEGER  MY_PE               !  Local processor id.
C
C  OUT: none
C
C  SUBROUTINES AND FUNCTIONS CALLS:  INIT3, SHUT3, MPI_ABORT, INQUIRE.
C
C***********************************************************************

      USE M3UTILIO              ! i/o api
      USE RUNTIME_VARS

      IMPLICIT NONE

C...........   INCLUDES:

      INCLUDE 'mpif.h'           ! MPI definitions and parameters.
      INCLUDE 'PIOVARS.EXT'      ! Parameters for parallel implementation.


C...........   ARGUMENTS and their descriptions:

      CHARACTER*(*)   CALLER       ! Name of the caller.
      INTEGER         JDATE        ! Model date for the error.
      INTEGER         JTIME        ! Model time for the error.
      CHARACTER*(*)   ERRTXT       ! Error message.
      LOGICAL         FATAL        ! Terminate program iff TRUE.


C...........   LOCAL VARIABLES

      INTEGER      LENSTR       ! String length of CALLER.
      INTEGER      IDEV         ! Loop counter over FORTRAN unit numbers.
      INTEGER      ERRCODE      ! Error code from abort attempt.
      INTEGER      IERROR       ! Error from MPI_ABORT routine.
      LOGICAL      OFLAG        ! Flag for indicating file open.
      CHARACTER*24 DTBUF        ! Scratch area for date string.
      CHARACTER*7  PE_STR       ! String suffix to go with processor ID.
      CHARACTER*16 CALL16       ! First 16 characters of CALLER.
      CHARACTER*26 PCALLER      ! New caller string with PE information.

C.............................................................................
C   begin subroutine PM3ERR
      errcode = 1               ! arbitrary

C.......  Construct new CALLER string.
      WRITE (PE_STR,'(A7)') ' on PE '


C.......  Construct new CALLER string.
      LENSTR = MIN( 16, LEN_TRIM( CALLER ) )
      CALL16 = CALLER( 1: LENSTR )
      PCALLER = CALL16(1:LENSTR)//PE_STR//CMYPE


C.......  Do M3ERR tasks.

        IF ( FATAL ) THEN     ! Print error messages and exit.

            WRITE( LOGDEV,91010 ) PCALLER, TRIM( ERRTXT )

            IF ( JDATE .GT. 0  .OR.  JTIME .GT. 0 ) THEN
                DTBUF = DT2STR( JDATE, JTIME )
                WRITE( LOGDEV,* ) 'PM3ERR:  DTBUF ', DTBUF
                WRITE( LOGDEV,91011 ) DTBUF, JDATE, JTIME
            ELSE
                WRITE( LOGDEV,* )  'PM3ERR:  date&time specified as 0'
                WRITE( LOGDEV,91012 ) 'Date&time specified as 0'
            END IF

            IF ( .NOT. SHUT3() ) THEN
                WRITE( LOGDEV,91000 )
     &              'Could not shut down I/ O API files correctly',
     &              ' ', ' '
            END IF

            DO  11  IDEV = 10, 99
                INQUIRE( UNIT = IDEV, OPENED = OFLAG )
                IF ( OFLAG ) CLOSE( IDEV )
11          CONTINUE


C.......  Abort all parallel tasks.
          CALL MPI_ABORT( MPI_COMM_WORLD, ERRCODE, IERROR )



        ELSE    !  Print error message but do not exit.


            WRITE( LOGDEV,91020 ) PCALLER, TRIM( ERRTXT )

            IF ( JDATE .GT. 0  .OR.  JTIME .GT. 0 )  THEN
                WRITE( LOGDEV,91011 )
     &             DT2STR( JDATE, JTIME ), JDATE, JTIME
            END IF

            RETURN


        END IF

C******************  FORMAT  STATEMENTS   ******************************

C...........   Error and warning message formats..... 91xxx

91000   FORMAT ( //5X , '*** ERROR ABORT in subroutine PM3ERR ***',
     &            /5X , A , // )

91010   FORMAT ( //5X , '*** ERROR ABORT in subroutine ', A,
     &            /5X , A )

91011   FORMAT ( 5X , 'Date and time ', A, :,
     &                  ' (', I7, ':', I6.6, ')' )

91012   FORMAT ( 5X , A )

91020   FORMAT (  /5X , '>>--->> WARNING in subroutine ', A,
     &            /5X , A )

        END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       SUBROUTINE HRG4( DTC )

C**********************************************************************
C
C  FUNCTION:  To solve for the concentration of NO3 and N2O5
C
C  PRECONDITIONS: For the CB6R5PFAS_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, Jun 26, 2025
C
C   18 Jul 14 B.Hutzell: revised to use real(8) variables
C**********************************************************************
      USE HRDATA

      IMPLICIT NONE


C..INCLUDES: NONE


C..ARGUMENTS:
      REAL( 8 ), INTENT( IN ) :: DTC             ! Time step


C..PARAMETERS: NONE


C..EXTERNAL FUNCTIONS: NONE


C..SAVED LOCAL VARIABLES:
!     CHARACTER( 16 ), SAVE   ::  PNAME = 'HRG4'    ! Program name


C..SCRATCH LOCAL VARIABLES:
      REAL( 8 ) ::   A, B, C, Q   ! Quadratic equation terms
      REAL( 8 ) ::   CMN          ! Temp scalar
      REAL( 8 ) ::   L15          ! Loss of NO3
      REAL( 8 ) ::   L16          ! Loss of N2O5
      REAL( 8 ) ::   P15          ! Production of NO3
      REAL( 8 ) ::   K15_15       ! Kno3+no3 * delta t
      REAL( 8 ) ::   R15_16       ! Kn2o5-->no3 * delta t
      REAL( 8 ) ::   R16_15       ! Kno3+no2-->n2o5[NO2] * delta t


C**********************************************************************


c..Production of NO3 (except from N2O5 )
      P15 =                 RKI(     6 ) * YCP( O            ) * YCP( NO2          )      ! O+NO2=NO3
     &    +                 RKI(    26 ) * YCP( NO2          ) * YCP( O3           )      ! NO2+O3=NO3
     &    +                 RKI(    46 ) * YC ( HNO3         ) * YCP( OH           )      ! HNO3+OH=NO3
     &    +    4.1000D-01 * RKI(    50 ) * YC ( PNA          )                            ! PNA=0.4100D+00*NO3+0.5900D+...
     &    +    4.0000D-01 * RKI(    56 ) * YC ( PAN          )                            ! PAN=0.4000D+00*NO3+0.6000D+...
     &    +    4.0000D-01 * RKI(    64 ) * YC ( PANX         )                            ! PANX=0.4000D+00*NO3+...
     &    +    1.8500D-01 * RKI(   170 ) * YC ( INTR         ) * YCP( OH           )      ! INTR+OH=0.1850D+00*NO3+...
     &    +                 RKI(   255 ) * YC ( CLNO3        )                            ! CLNO3=NO3+CL

c..Loss frequency of NO3 ( except NO3 + NO3 if present )
      L15 =                 RKI(    27 )                         ! NO3=NO2+O
     &    +                 RKI(    28 )                         ! NO3=NO
     &    +                 RKI(    29 ) * YCP( NO           )   ! NO3+NO=0.2000D+...
     &    +                 RKI(    30 ) * YCP( NO2          )   ! NO3+NO2=NO+NO2
     &    +                 RKI(    31 ) * YCP( O            )   ! NO3+O=NO2
     &    +                 RKI(    32 ) * YCP( OH           )   ! NO3+OH=HO2+NO2
     &    +                 RKI(    33 ) * YCP( HO2          )   ! NO3+HO2=OH+NO2
     &    +                 RKI(    34 ) * YCP( O3           )   ! NO3+O3=NO2
     &    +                 RKI(    36 ) * YCP( NO2          )   ! NO3+NO2=N2O5
     &    +                 RKI(   100 ) * YC ( FORM         )   ! NO3+FORM=HNO3+HO2+CO
     &    +                 RKI(   107 ) * YC ( ALD2         )   ! NO3+ALD2=C2O3+HNO3
     &    +                 RKI(   111 ) * YC ( ALDX         )   ! NO3+ALDX=CXO3+HNO3
     &    +                 RKI(   115 ) * YC ( GLYD         )   ! NO3+GLYD=HNO3+C2O3
     &    +                 RKI(   118 ) * YC ( GLY          )   ! NO3+GLY=HNO3+...
     &    +                 RKI(   120 ) * YC ( MGLY         )   ! NO3+MGLY=HNO3+...
     &    +                 RKI(   140 ) * YC ( ETH          )   ! NO3+ETH=0.5000D+...
     &    +                 RKI(   144 ) * YC ( OLE          )   ! NO3+OLE=0.5000D+...
     &    +                 RKI(   148 ) * YC ( IOLE         )   ! NO3+IOLE=0.5000D+...
     &    +                 RKI(   157 ) * YC ( ISOP         )   ! NO3+ISOP=0.3500D+...
     &    +                 RKI(   160 ) * YC ( ISPD         )   ! NO3+ISPD=0.7170D+...
     &    +                 RKI(   164 ) * YC ( HPLD         )   ! NO3+HPLD=HNO3+ISPD
     &    +                 RKI(   174 ) * YC ( TERP         )   ! NO3+TERP=0.4700D+...
     &    +                 RKI(   178 ) * YC ( APIN         )   ! NO3+APIN=0.4700D+...
     &    +                 RKI(   196 ) * YC ( CRES         )   ! NO3+CRES=0.3000D+...
     &    +                 RKI(   200 ) * YC ( CRON         )   ! NO3+CRON=NTR2+...
     &    +                 RKI(   205 ) * YC ( XOPN         )   ! NO3+XOPN=0.5000D+...
     &    +                 RKI(   209 ) * YC ( OPEN         )   ! NO3+OPEN=OPO3+HNO3
     &    +                 RKI(   211 ) * YC ( CAT1         )   ! NO3+CAT1=CRO+HNO3
     &    +                 RKI(   348 ) * YC ( DMS          )   ! NO3+DMS=SO2+HNO3+...

c..Loss frequency of N2O5
      L16 =                 RKI(    37 )                         ! N2O5=NO3+NO2
     &    +                 RKI(    38 )                         ! N2O5=NO2+NO3
     &    +                 RKI(    39 )                         ! N2O5=0.2000D+01*HNO3
     &    +                 RKI(   271 )                         ! N2O5=HNO3+H2NO3PIJ
     &    +                 RKI(   272 )                         ! N2O5=HNO3+H2NO3PK

c..K15_15, R15_16, and R16_15 terms
      K15_15  = RKI(    35 ) * DTC

      R15_16  = ( RKI(    37 )
     &        +   RKI(    38 ) ) * DTC 


      R16_15  = RKI(    36 ) * YCP( NO2 ) * DTC

c..Solution of quadratic equation to get NO3 & N2O5
      CMN = 1.0D0 + L16 * DTC
      A = 2.0D0 * K15_15 * CMN
      B = CMN * ( 1.0D0 + L15 * DTC ) - R15_16 * R16_15
      C = CMN * ( YC0( NO3 ) + P15 * DTC ) +  R15_16 * YC0( N2O5 )

      Q = -0.5D0 * ( B + SIGN( 1.0D0, B ) * SQRT( B * B + 4.0D0 * A * C ) )
      YCP( NO3 ) = MAX( Q / A , -C / Q  )
      YCP( N2O5 ) = ( YC0( N2O5 ) + R16_15 * YCP( NO3 ) ) / CMN

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE STAGE_MOD 

C-------------------------------------------------------------------------------
C Name:     Surface Tiled Aerosol and Gaseous Exchange (STAGE)
C Purpose:  Computes aerosol and gaseous air surface exchange for sub-
C           grid land use categories. All gaseous species are treated 
C           as having bidirectional exchange following the two layer 
C           model from Nemitz et al. 2001 and aerosol species deposition 
C           follows Binkowski and Shankar 1995. Note that the Nemitz et al.            
C           parameterization reduces to a standard deposition velocity
C           if the pollutant concentration on the leaf, in the leaf stomata, 
C           and in the soil are zero.
C 
C References:
C          Nemitz et al. 2001 Q. J. R. Meteorol. Soc DOI: 10.1002/qj.49712757306
C          Binkowski and Shankar 1995 JGR  DOI: 10.1029/95JD02093
C          Galmarini et al. 2012 Atmos. Chem. Phys. https://doi.org/10.5194/acp-21-15663-2021
C          Appel et al. 2021 Geosci. Model Dev. https://doi.org/10.5194/gmd-14-2867-2021
C          Fuller et al. 1966 Ind. Eng. Chem. https://doi.org/10.1021/ie50677a007
C          Massman 1999 Atmos. Environ. https://doi.org/10.1016/S1352-2310(98)00204-0 
C Default variables output area weighted Vd
C Optional variables output land use specific LAI, RA, U*, Z0, and Vd
C
C Revised:  1 Dec 2017  Original version.  (J. Bash)
C-------------------------------------------------------------------------------

      Use GRID_CONF           ! horizontal & vertical domain specifications
      Use LSM_MOD             ! Land surface data
      Use ASX_DATA_MOD
      USE UTILIO_DEFN      
      USE CGRID_SPCS          ! CGRID mechanism species
      USE STAGE_DATA
      USE AERO_DATA, Only: N_MODE
      USE CENTRALIZED_IO_MODULE, Only: WR_AVAIL

      IMPLICIT NONE

C shared variables 
      INTEGER, ALLOCATABLE, SAVE :: DEPV_SUR( : )   ! pointer to surrogate
      REAL,    ALLOCATABLE, SAVE :: VDEP( : )    ! deposition  velocity [ m/s ]
      REAL,    ALLOCATABLE, SAVE :: VDEPJ( :,: ) ! deposition  velocity [ m/s ]
      REAL,    SAVE              :: xcent
      REAL,    SAVE              :: ycent
      INTEGER, PARAMETER         :: N_AE_DEP_SPC = 9 
C land use indexes
      Logical, Allocatable, Save :: Water( : )
      Logical, Allocatable, Save :: Ag( : )
      Real,    Allocatable, Save :: a_cut( : )     ! NH3 cuticular resistance exponential term Massad et al. 2010 Table 8
      Integer, Save              :: l_ag
C gas phase species indices
      Integer, Save              :: n_HONO         ! index in depv
      Integer, Save              :: s_HONO         ! index in dep_gas_all
      Integer, Save              :: n_NO2          ! index in depv
      Integer, Save              :: s_NO2          ! index in dep_gas_all
      Integer, Save              :: n_O3           ! index in depv
      Integer, Save              :: s_O3           ! index in dep_gas_all
      Integer, Save              :: n_NH3          ! index in depv
      Integer, Save              :: s_NH3          ! index in dep_gas_all
      Integer, Save              :: n_HG           ! index in depv
      Integer, Save              :: s_HG           ! index in dep_gas_all
      Integer, Save              :: n_HGII         ! index in depv
      Integer, Save              :: s_HGII         ! index in dep_gas_all
      Integer, PRIVATE           :: ALLOCSTAT
      CHARACTER( 96 )            :: xmsg = ' '
C Aerosol deposition arrays
      REAL, ALLOCATABLE, SAVE  :: XXLSG( : ) ! log of standard deviation
      REAL, ALLOCATABLE, SAVE  :: DG( : )    ! geometric mean diameter
      REAL, ALLOCATABLE, SAVE  :: PDENS( : ) ! particle density         


      Contains
         SUBROUTINE INIT_STAGE ( JDATE, JTIME )

C-----------------------------------------------------------------------
C  This subroutine sets up the mapping and options for the STAGE gaseous 
C  and aerosol exchange subroutines. 
C-----------------------------------------------------------------------
         USE NH3_BIDI_MOD
         USE MOSAIC_MOD, Only: Tile_Data
         USE CONST

         Implicit None        
 
         Include SUBST_FILES_ID  ! file name parameters

C Arguments:
         Integer, Intent( IN ) :: JDATE, JTIME      ! internal simulation date&time
         integer               :: c, r, l, n, s, n_diag_dep
         CHARACTER( 16 ), PARAMETER :: pname      = 'INIT_STAGE'        
         CHARACTER( 16 )       :: gc_depv_name( dep_gas_all )
         CHARACTER( 16 )       :: gc_scav_name( dep_gas_all )
         Logical               :: unique_gc_depv( n_gc_depv )
C Local variables:

         CHARACTER( 16 ) :: VDAE_NAME( N_AE_DEP_SPC )! dep vel surrogate name table
C                                       1234567890123456
         DATA         VDAE_NAME( 1 ) / 'VNUMATKN        ' /
         DATA         VDAE_NAME( 2 ) / 'VNUMACC         ' /
         DATA         VDAE_NAME( 3 ) / 'VNUMCOR         ' /
         DATA         VDAE_NAME( 4 ) / 'VMASSI          ' /
         DATA         VDAE_NAME( 5 ) / 'VMASSJ          ' /
         DATA         VDAE_NAME( 6 ) / 'VMASSC          ' /
         DATA         VDAE_NAME( 7 ) / 'VSRFATKN        ' /
         DATA         VDAE_NAME( 8 ) / 'VSRFACC         ' /
         DATA         VDAE_NAME( 9 ) / 'VSRFCOR         ' /

         xcent = real( file_xcell(f_met), 4 )
         ycent = real( file_ycell(f_met), 4 )
C Check aerosol deposition options 
         If( ( STAGE_E20 .And. STAGE_P22 ) ) Then
            XMSG = 'Both CTM_STAGE_E20 and CTM_STAGE_P22 aerosol dry ' //
     &             ' deposition options were set to Y. Please select one. '
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         Else If ( STAGE_E20 .And. STAGE_S22 ) Then
            XMSG = 'Both CTM_STAGE_E20 and CTM_STAGE_S22 aerosol dry ' //
     &             ' deposition options were set to Y. Please select one. '
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         Else If ( STAGE_P22 .And. STAGE_S22 ) Then
            XMSG = 'Both CTM_STAGE_S22 and CTM_STAGE_P22 aerosol dry ' //
     &             ' deposition options were set to Y. Please select one. '
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If
C if abflux this specifies soil, vegetation and water compensation points for NH3
         IF ( abflux ) THEN
            CALL Init_NH3_Bidi( jdate, jtime )
         END IF
C  Allocate arrays
         Allocate ( Water  ( Tile_Data%n_lufrac ),
     &              Ag     ( Tile_Data%n_lufrac ),
     &              a_cut  ( Tile_Data%n_lufrac ),STAT = ALLOCSTAT )

         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating Water, Ag, or a_cut'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
                         
         ALLOCATE ( VDEP( N_AE_DEP_SPC ), 
     &              VDEPJ( Tile_Data%n_lufrac,N_AE_DEP_SPC ), 
     &              DEPV_SUR( N_AE_DEPV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating VDEP, VDEPJ, DEPV_SUR'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( DG( N_MODE ), XXLSG( N_MODE ), PDENS( N_MODE), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DG, XXLSG, or PDENS'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Set the dep vel surrogate pointers
         DO S = 1, N_AE_DEPV
            N = INDEX1( AE_DEPV( S ), N_AE_DEP_SPC, VDAE_NAME )
            IF ( N .NE. 0 ) THEN
               DEPV_SUR( S ) = N
            ELSE
               XMSG = 'Could not find ' // AE_DEPV( S ) // ' in aerosol' //
     &                ' surrogate table. >>> Dep vel set to zero <<< '
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               DEPV_SUR( S ) = 0
            END IF
         END DO                               

C-----------------------------------------------------------------
C        Species maps
C-----------------------------------------------------------------
         s_HONO = 0
         n_HONO = 0
         s_NO2  = 0
         n_NO2  = 0
         s_O3   = 0
         n_O3   = 0
         s_NH3  = 0
         n_NH3  = 0
         s_HG   = 0
         n_HG   = 0
         s_HGII = 0
         n_HGII = 0

         n = 0
         maploop: DO s = 1, dep_gas_all
            IF ( .NOT. asx_run_map( s ) ) CYCLE maploop
            n = n + 1

            If ( vd_name( s ) .EQ. 'NO2' ) THEN
               s_NO2 = s
               n_NO2 = n
            End If
            If ( vd_name( s ) .EQ. 'HONO' ) THEN
               s_HONO = s
               n_HONO = n
            End If
            If ( vd_name( s ) .EQ. 'O3' ) THEN
               s_O3 = s
               n_O3 = n
            End If
            If ( vd_name( s ) .EQ. 'NH3' ) THEN
               s_NH3 = s
               n_NH3 = n
            End If
            If ( vd_name( s ) .EQ. 'HG' ) THEN
               s_HG = s
               n_HG = n
            End If
            If ( vd_name( s ) .EQ. 'HGIIGAS' ) THEN
               s_HGII = s
               n_HGII = n
            End If
         END DO maploop

         Water  = .FALSE.
         Ag     = .FALSE.
         l_ag   = 0
         DO l = 1, Tile_Data%n_lufrac
            Select Case( trim( Tile_Data%cat_lu( l ) ) )
               Case( 'WATER' )
                  Water( l ) = .TRUE.
                  a_cut( l )  = 0.0
               Case( 'AG'    )
                  l_ag       = l
                  ag( l )    = .TRUE.
                  a_cut( l )  = 0.148
               Case( 'AGMOS' )
                  ag( l )    = .TRUE.
                  a_cut( l )  = 0.148
               Case( 'HAY'   )
                  ag( l )    = .TRUE.
                  a_cut( l )  = 0.148
               Case( 'URBAN' )
                  a_cut( l )  = 0.120
               Case( 'DECFORB','DECFORN','EVEFORB','EVEFORN','MIXFOR')
                  a_cut( l )  = 0.0318
               Case( 'HERB','SHRUB' )
                  a_cut( l )  = 0.120
               Case( 'GRASS' )
                  a_cut( l )  = 0.176
               Case( 'WETLAND' )
                  a_cut( l )  = 0.0318
               Case Default
                  a_cut( l )  = 0.120
            End Select
         END DO

         END SUBROUTINE INIT_STAGE
!------------------------------------------------------------------------------
! ******** Calculate deposition velocity for trace gas species ********
! 
! Applies Ohms law and the first Kirchhoff current law to estimate trace gas 
! dry deposition velocities and canopy/vegetation/soil concentrations following
! the framework of Nemitz et al., 2000 and Massad et al 2010
! 
! References: 
!  
! Nemitz et al. Resistance modelling of ammonia exchange over oilseed rape, Ag.
!    Forest Met. 105, 405-425 https://doi.org/10.1016/S0168-1923(00)00206-9, 2000
! Massad et al. Review and parameterisation of bi-directional ammonia exchange 
!    between vegetation and the atmosphere, Atmos. Chem. Phys., 10, 10359-10386
!    https://doi.org/10.5194/acp-10-10359-2010, 2010
!------------------------------------------------------------------------------


         SUBROUTINE GAS_X( JDate, JTime, TStep, c, r, cgridl1 )        
        
         Use NH3_BIDI_MOD
         Use MOSAIC_MOD, Only: Tile_Data 
         Use HGSIM
         Use Resist_Funcs
         Use HLCONST_MOD

         Implicit None

         Integer, Intent( IN )  :: JDate, JTime, c, r      ! internal simulation date&time
         REAL,    Intent( IN )  :: cgridl1( : )    ! layer 1 concentrations
         REAL,    Intent( IN )  :: TStep           ! Time step in seconds
C Parameters specific to gas_x. Currently based on m3dry but subject to change
         Real, Parameter :: d3         = 1.38564e-2 ! [dim'less]
         Real, Parameter :: hplus_ap   = 1.0e-6     ! pH=6.0 leaf apoplast solution Ph (Massad et al 2008)      
         Real, Parameter :: hplus_def  = 1.0e-5     ! pH=5.0
         Real, Parameter :: hplus_east = 1.0e-5     ! pH=5.0
         Real, Parameter :: hplus_h2o  = 7.94328e-9 ! 10.0**(-8.1)
         Real, Parameter :: hplus_west = 3.16228e-6 ! 10.0**(-5.5)
C Fuller-Schettler-Giddings (https://doi.org/10.1021/ie50677a007; Table I) Diffusion Volume for air 
         Real, Parameter :: Diff_Vol   = 20.1       ! cm3/mol

! Heterogeneous HONO
         Real            :: surf_bldg, surf_leaf    ! HONO building and leaf surface area/voluem (1/
         Real            :: kno2, conc_no2          ! pseudo-first order reaction NO2 + H2O -> HONO  (1/s), NO2 (ppm)
! Physical Chemistry variables
         Real            :: heff_ap, heff_wat, heff ! Henry's constant for leaf apoplast, surface water, and wet surfaces
         Real            :: hplus                   ! H+ in aqueous media
         LOGICAL         :: effective               ! true=compute effective Henry's Law const
         Real            :: scc_pr_23               ! (SCC/PR)**2/3, fn of DIF0
         Real            :: dif_T, k_vis, dwat_T    ! Trace gas diffusivity, kinematic viscosity of air, and diffusivity of water vapor in air (m2/s)
! Soil properties
         Real            :: sm_v5cm, sm_v1cm        ! Soil moisture at 5 and 1 cm (m3/m3)
         Real            :: sm_vsat                 ! volumetric soil saturation (m3/m3)
         Real            :: sm_vfc                  ! volumetric field capacity (m3/m3)
         Real            :: sm_vwlt                 ! volumetric wilting point (m3/m3)
         Real            :: sm_vres                 ! volumetric residual water (m3/m3)
         Real            :: sm_bslp                 ! slope of the saturation water retention curve (ratio)
! meteorological variables
         Real            :: temp_g, temp_2m  ! Soil and 2m temperature (K)
         Real            :: q_2m             ! water vapor mixing ratio at 2m ()
         Real            :: rh               ! relative humidity (%) and surface friction velocity (m/s) 
         Real            :: ustar            ! surface friction velocity (m/s)
! Canopy variables
         Real            :: l_leaf          ! leaf aerodynamic width (m)
         Real            :: lai             ! leaf area index (m2/m2)
! Land use variables
         Real            :: snow, no_snow, wet, dry, veg, no_veg, frac_lu    ! fractional land coverage (ratio)
         Real            :: ir_frac                                          ! Irrigated fraction (bidi NH3 only : ratio)
         Logical         :: sea_ice
! Deposition velocity, conductances and resistances
         Real            :: vd      ! deposition velocity (m/s)
         Real            :: Ra      ! aerodynamic resistance (s/m)
         Real            :: Rb      ! quasi-laminar soil/water resistance (s/m)
         Real            :: Rb_leaf ! quasi-laminary leaf resistance (s/m)
         Real            :: Rst     ! Stomatal resistance (s/m)
         Real            :: Rcut    ! cuticlular resistance (s/m)
         Real            :: Rgc     ! under canopy soil resistance (s/m)
         Real            :: Rg      ! soil resistance (s/m)
         Real            :: Rwat    ! surface water resistance (s/m)
! Flux estiamtes
         Real            :: soil_flux        ! soil emission and deposition for soil biogeochem (ppm m/s)
         Real            :: LU_Flux, LU_Emis ! land use flux and land use emissions (ppm m/s)     
         Real            :: f_wat            ! Air-surface water flux (c_atm-c_wat)/Rwat (ppm m/s)
         Real            :: f_stom           ! Air-stomatal flux      (c_leaf - c_stom)/Rst (ppm m/s)
         Real            :: f_cut            ! Air-cuticular flux     (c_leaf - c_cut)/Rcut (ppm m/s)
         Real            :: f_soil           ! Air-soil flux          (c_z0 - cgrnd)/Rgc    (ppm m/s)
         Real            :: flux_ag          ! Flux for agricultural land use, BIDI NH3 only (ppm m/s)             
! Concentrations and compensation points
         Real            :: c_atm            ! ambient atmospheric concentration (ppm) 
         Real            :: c_z0             ! Canopy concentration at z0 (ppm) 
         Real            :: c_leaf           ! Leaf concentration at z0 (ppm)  
         Real            :: c_stom           ! Stomatal concentration at z0 (ppm)  
         Real            :: c_cut            ! Concentration at the cuticular surface (ppm)  
         Real            :: c_grnd           ! Concentration in the soil air space, no veg canopy (ppm)  
         Real            :: c_ll             ! Concentration in the soil air space, veg canopy (ppm)   
         Real            :: c_wat            ! Concentration in surface waters (ppm)    
! Air-sea exchange
         Real            :: ctemp2, lv, cp_air, tw              ! 2 meter temp (C), latent heat of vaporization [J/kg/K], specific heat capacity of air [J/kg/K], water temperature (K),
! indexes
         integer         :: i, l, n, s, n_diag
         Logical         :: NH3_hit, O3_hit, Hg_hit ! logical vars for special cases

! Hg bidi variables 
         Real            :: Hg_st, Hg_cut, Hg_grnd, Hg_wat, flux_hgII
   
         effective = .TRUE.
         NH3_hit = .FALSE.
         O3_hit = .FALSE.
         Hg_hit = .FALSE.  

! grid cell met variables 
         temp_2m = Met_Data%TEMP2(c,r)
         q_2m    = MET_DATA%Q2( c,r )
         temp_g  = MET_DATA%TEMPG( c,r )
         rh      = MET_DATA%RH2( c,r )
         sm_vsat = GRID_DATA%WSAT( c,r )
         sm_vfc  = GRID_DATA%WFC( c,r )
         sm_vwlt = GRID_DATA%WWLT( c,r )
         sm_vres = GRID_DATA%WRES( c,r )
         sm_bslp = max(GRID_DATA%BSLP( c,r ),1.0)
         sm_v1cm = min(MET_DATA%SOIM1( c,r ),sm_vsat)
         sm_v1cm = max(sm_v1cm,sm_vres)
         If( ABFLUX ) Then
            ir_frac = frac_ir( c,r )
         Else
            ir_frac = 0.0 ! no data available
         End If
         If( PX_LSM ) Then
! simplified from Darcy's law assuming stationarity and only gravitational draining with the Campbell hydrological functions applied
            sm_v5cm = sm_v1cm * exp( (0.05-zsoil1) * GRAV )**(1.0/sm_bslp)
            sm_v5cm = Min( sm_v5cm, sm_vsat )
            sm_v5cm = Max( sm_v5cm, sm_vres )
         Else If( CLM_LSM .OR. NOAH_LSM ) Then
            sm_v5cm = MET_DATA%SOIM2( c,r )
            sm_v5cm = Min( sm_v5cm, sm_vsat )
            sm_v5cm = Max( sm_v5cm, sm_vres )
         End If

         snow    = max( 0.0, MET_DATA%SNOCOV( c,r ) )
! total snow fraction
         no_snow = 1.0 - snow

         sea_ice = .TRUE.
         IF (((GRID_DATA%OCEAN(c,r) + GRID_DATA%SZONE(c,r)) .GT. 0.0) .AND. (MET_DATA%SEAICE(c,r) .LE. 0.0)) THEN
            sea_ice = .FALSE.
         End If
!
         IF ( ( ycent .GE.   30.0 ) .AND. ( ycent .LE.  45.0 ) .AND.
     &        ( xcent .GE. -120.0 ) .AND. ( xcent .LE. -70.0 ) ) THEN
            IF ( GRID_DATA%LON( c,r ) .GT. -100.0 ) THEN
               hplus = hplus_east
            ELSE
               hplus = hplus_west
            END IF
         ELSE
            hplus = hplus_def
         END IF
! moved water temperature here to reduce redundancy and facilitate moving the hlconst 
! subroutine out of the land use loop for better vectorization.
         ctemp2 = temp_2m - stdtemp
         lv     = lv0 - dlvdt * ctemp2
         cp_air = CPD * ( 1.0 + 0.84 * q_2m )               ! [J/kg/K]
         tw     = ( ( 4.71e4 * cp_air / lv ) - 0.870 ) + stdtemp  ! [K]
         k_vis  = kvis*1.0e-4 * ( temp_2m/STDTEMP )**1.81 ! Following Massman 1999
         dwat_T = dwat*1.0e-4 * ( temp_2m/STDTEMP )**1.81 ! Following Massman 1999
         n = 0
         n_diag = 0
         spc_loop: Do s = 1, dep_gas_all
            IF ( asx_run_map( s ) ) Then
            n = n + 1
            Tile_Data%Grd_Vd( C, R, n )    = 0.0
            Tile_Data%Bidi_Emis( C, R, n ) = 0.0
! Special cases
            if( s .eq. s_NH3 ) NH3_hit = .True.
            if( s .eq. s_O3 ) O3_hit  = .True.
            if( s .eq. s_Hg ) Hg_hit  = .True.
! Following Fuller et al 1966 (https://doi.org/10.1021/ie50677a007) and using the FSG-LeBas method from the
! EPA OnSite toolbox (https://www3.epa.gov/ceampubl/learn2model/part-two/onsite/ed-background.html). 
            dif_T     = 1.0e-7*temp_2m**1.75 * sqrt( 1.0/MWAIR + 1.0/molwt_all( s ) ) / 
     &                ( Diff_Vol**(1.0/3.0) + LeBasM( s )**(1.0/3.0) )**2 
            scc_pr_23 = ( ( k_vis / dif_T ) / pr ) ** twothirds

            c_atm = max( cgridl1( n ), 1.0e-30 )
            f_stom    = 0.0
            f_cut     = 0.0
            f_soil    = 0.0
            flux_ag   = 0.0
            f_wat     = 0.0
            soil_flux = 0.0
            heff_wat  = hlconst( hlind( s ), tw, effective, hplus_h2o )* 0.08205 * tw
            heff_ap   = hlconst( hlind( s ), temp_2m, effective, hplus_ap )
            heff      = hlconst( hlind( s ), temp_2m, effective, hplus )* 0.08205 * temp_2m
            If ( HGBIDI .And. Hg_Hit ) Then
               Call  Get_Hg_Comp( Hg_st, Hg_cut, Hg_grnd, Hg_wat, c_atm, heff_wat, heff, r, c )
            End If
            lu_loop: Do l = 1, Tile_Data%n_lufrac
               c_z0    = 0.0
               c_leaf  = 0.0
               LU_Emis = 0.0
               If( HGBIDI .And. Hg_Hit) Then
                  c_stom = Hg_st
                  c_cut  = Hg_cut
                  c_grnd = Hg_grnd
                  c_ll   = Hg_grnd
                  c_wat  = Hg_wat
               Else
                  c_stom = 0.0
                  c_cut  = 0.0
                  c_grnd = 0.0
                  c_ll   = 0.0
                  c_wat  = 0.0
               End If
               Rb     = 0.0
               Rb_leaf= 0.0
               Rst    = 0.0
               Rcut   = 0.0
               Rg     = 0.0
               Rgc    = 0.0                  
C land use specific area fraction 
               frac_lu = Tile_Data%LUFRAC( c,r,l )  
               If( frac_lu .Gt. 0.0 ) Then
C land use specific met data
               ustar   = MOSAIC_DATA%USTAR( c,r,l )
               lai     = MOSAIC_DATA%LAI( c,r,l )
C land use specific land cover data
               wet     = Mosaic_Data%DELTA( c,r,l )
               dry     = 1.0 - wet
               veg     = MOSAIC_DATA%VEG( c,r,l ) 
               no_veg  = 1.0 - veg
               l_leaf  = Tile_Data%l_width( l )
C Get Ra
               Ra = MOSAIC_DATA%RA( c,r,l )

!-------------------------------------------------------------------------------------------------
! Quasi-laminar boundary layer resistance
!-------------------------------------------------------------------------------------------------
               Rb  = Calc_Rbw( ustar, scc_pr_23 )
!-------------------------------------------------------------------------------------------------
! Air-water exchange
!-------------------------------------------------------------------------------------------------
               If( Water( l ) ) Then
!-------------------------------------------------------------------------------------------------
! Resistance to surface water
!-------------------------------------------------------------------------------------------------
                  Rwat = Calc_Rwater( ustar, q_2m, temp_2m, temp_g, tw,  LeBasM( s ), heff_wat, O3_hit, 
     &                                Hg_hit, sea_ice  )

                  If(c_wat .Gt. 0.0 ) Then
                     LU_Emis = c_wat / ( Ra + Rb + Rwat )
                  End If

                  Tile_Data%Lu_Vd( c,r,n,l ) = 1.0 / ( Ra + Rb + Rwat )  
                  f_wat  = f_wat  + frac_lu * ( c_wat - c_atm ) / ( Ra + Rb + Rwat )   
               Else 
!-------------------------------------------------------------------------------------------------
! Air-land exchange
!-------------------------------------------------------------------------------------------------
! Resistance to air-canopy exchange
!-------------------------------------------------------------------------------------------------
C Calculate Rst
                  If( lai .Gt. 0.0 ) Then
!-------------------------------------------------------------------------------------------------
! Quasi Laminar Resistance to leaf 
!-------------------------------------------------------------------------------------------------
                     Rb_leaf = Calc_Rb_leaf( k_vis, dif_T, ustar, l_leaf, lai )
!-------------------------------------------------------------------------------------------------
! Resistance to air-stomatal exchange
!-------------------------------------------------------------------------------------------------
                     Rst = Calc_Rst( Mosaic_Data%RSTW( c,r,l ), dwat_T, dif_T, heff_ap, f0( s ), lai )

!-------------------------------------------------------------------------------------------------
! Resistance to air-cuticle exchange
!-------------------------------------------------------------------------------------------------
                     Rcut = Calc_Rcut( temp_g, rel_rx(s), molwt_all( s ), M_ac( s ), heff, dif_T, 
     &                            a_cut( l ), snow, no_snow, dry, wet, rh, lai, O3_hit, NH3_hit, ABFLUX )

!-------------------------------------------------------------------------------------------------
! Resistance to air-canopy covered soil exchange
!-------------------------------------------------------------------------------------------------
                  Else ! LAI = 0.0
                     Rst     = 1.0e6
                     Rcut    = 1.0e6
                     Rb_leaf = 1.0e6
                  End If ! LAI    
!-------------------------------------------------------------------------------------------------
! Resistance to air-base soil exchange
!-------------------------------------------------------------------------------------------------
                  If( ABFLUX .And. NH3_Hit ) Then
                     Call Get_NH3_Comp( c_stom, c_ll, c_grnd, dif_T, r, c, l, l_ag )  ! Quasi Laminar Boundary Layer resistance
                  End If ! ABFLUX and NH3

                  Rgc = Calc_Rg( dif_T, k_vis, rel_rx( s ), Ra, ustar, lai, temp_g, molwt_all( s ), M_ac( s ), 
     &                           heff, sm_v1cm,sm_v5cm, sm_vsat, sm_vfc, sm_vwlt, sm_vres, sm_bslp, zsoil1,
     &                           ir_frac, dry, wet, snow, no_snow, O3_Hit, NH3_Hit, ABFLUX )

                  Rg  = Calc_Rg( dif_T, k_vis, rel_rx( s ), Ra, ustar, 0.0, temp_g, molwt_all( s ), M_ac( s ), 
     &                           heff, sm_v1cm,sm_v5cm, sm_vsat, sm_vfc, sm_vwlt, sm_vres, sm_bslp, zsoil1,
     &                           ir_frac, dry, wet, snow, no_snow, O3_Hit, NH3_Hit, ABFLUX )

!-------------------------------------------------------------------------------------------------
! Calculate the compensation points following Nimitz et al 2001
!-------------------------------------------------------------------------------------------------
! Leaf compensation point
!-------------------------------------------------------------------------------------------------
                  c_leaf = (c_atm/(Ra*Rb_leaf)+                                                        ! Atmospheric Component
     &                      c_stom*(1.0/(Ra*Rst)+1.0/(Rb_leaf*Rst)+1.0/(Rgc*Rst))+                     ! Stomatal Component
     &                      c_cut*(1.0/(Ra*Rcut)+1.0/(Rb_leaf*Rcut)+1.0/(Rgc*Rcut))+                   ! Cuticular Component
     &                      c_ll/(Rb_leaf*Rgc))/                                                       ! Under Canopy Surface Component
     &            (1.0/(Ra*Rb_leaf) +1.0/(Ra*Rst) +1.0/(Ra*Rcut)+1.0/(Rb_leaf*Rgc)+1.0/(Rb_leaf*Rcut) + 
     &             1.0/(Rb_leaf*Rst)+1.0/(Rgc*Rst)+1.0/(Rgc*Rcut))                                     ! Least common denominator
!-------------------------------------------------------------------------------------------------
! Compensation point at z0
!-------------------------------------------------------------------------------------------------
                  c_z0     = (c_atm/Ra+c_leaf/Rb_leaf+c_ll/Rgc)/(1.0/Ra+1.0/Rb_leaf+1.0/Rgc)           
!-------------------------------------------------------------------------------------------------
! Estimate air-surface flux
!-------------------------------------------------------------------------------------------------         
! positive values for deposition                 
                  LU_Flux     = veg * (c_atm-c_z0)/Ra +                 ! air-vegetation flux
     &                       no_veg * (c_atm-c_grnd)/( Ra + Rg )        ! air-soil flux
!-------------------------------------------------------------------------------------------------
! Deposition velocity
!-------------------------------------------------------------------------------------------------                                                               
                  vd = veg / (Ra + 1.0/(1.0/(Rb_leaf+1.0/(1.0/Rcut+1.0/Rst))+1.0/Rgc)) +
     &              no_veg / (Ra + Rg)
!-------------------------------------------------------------------------------------------------
! NH3 bidirectional exchange diagnostic fluxes
!-------------------------------------------------------------------------------------------------                                                               
                  If(ABFLUX .And. NH3_Hit ) Then     
                    If( Ag( l ) ) Then
                       soil_flux  = soil_flux + veg * ( c_ll - c_z0 ) / Rgc
     &                            + no_veg * ( c_grnd  - c_atm ) / ( Ra + Rg ) 
                    End If
                  End If ! ABFLUX and NH3
                  If( c_stom .Gt. 0.0 .Or. c_cut .Gt. 0.0 .Or. c_grnd .Gt. 0.0 .Or. c_ll .Gt. 0.0 ) Then
!-------------------------------------------------------------------------------------------------
! Bidirectional exchange
!-------------------------------------------------------------------------------------------------                                                               
                     LU_Emis = max( vd * c_atm - LU_Flux, 0.0 )                         ! should always be greater than 0
                     Tile_Data%Lu_Vd( c,r,n,l ) = vd                                    ! Deposition velocity
                     f_soil = f_soil + frac_lu * ( veg * ( ( c_ll - c_z0 ) / Rgc ) +    ! LU_Flux = f_soil + f_stom + f_cut
     &                                         no_veg * (c_grnd - c_atm)/( Ra + Rg ) )  ! air-soil exchange
                     f_stom = f_stom + frac_lu * veg * ( c_stom - c_leaf ) / Rst        ! air-stomatal exchange
                     f_cut  = f_cut  + frac_lu * veg * ( c_cut  - c_leaf ) / Rcut       ! air-cuticular exchange
                  Else
!-------------------------------------------------------------------------------------------------
! Non bidirectional exchange
!-------------------------------------------------------------------------------------------------   
                     Tile_Data%Lu_Vd( c,r,n,l ) =  vd
                  End If ! compensation points greater than 0
               End If ! Water    
! Generalization of the production and deposition velocity terms
               Tile_Data%Bidi_Emis( C, R, n ) = Tile_Data%Bidi_Emis( C, R, n )  + 
     &                                          frac_lu * LU_Emis
               Tile_Data%Grd_Vd( C, R, n ) = Tile_Data%Grd_Vd( C, R, n ) + 
     &                           frac_lu * Tile_Data%Lu_Vd( c,r,n,l )
            End If ! frac_lu > 0

            End Do lu_loop
            If(ABFLUX .And. NH3_Hit ) Then
               If( sum(Tile_Data%LUFRAC(c,r,:),mask=Ag) .Gt. 0.0 ) Then 
                  Call Calc_Nitrif ( TStep, C, R, l_ag, soil_flux )
               End If
            End If
            If(HGBIDI .And. Hg_Hit ) Then
               flux_hgII = 0.0 
! negative values are deposition fluxes
               flux_hgII = -Sum( Tile_Data%Lu_Vd( c,r,n_HgII,: ) * Tile_Data%LUFRAC( c,r,: ), mask = WATER)

               Call Hg_Surf_Update ( f_stom, f_cut, f_soil, f_wat, flux_hgII, 
     &                               Heff_wat, Heff, TStep, c, r, Jdate, Jtime )
            End If
C--------------------------------------------------------------------------
            IF ( sfc_hono ) THEN

C HONO production via heterogeneous reaction on ground surfaces,
C 2NO2 = HONO + HNO3
C Rate constant for the reaction = (3.0E-3/60)* (A/V),
C where A/V is surface area/volume ratio
C HONO is produced and released into the atmosphere
C NO2 is lost via chemical reaction
C HNO3 is sticky and stays on the surfaces

C Calculate A/V for leaves.
C LAI was multiplied by 2 to account for the fact that surface area
C is provided by both sides of the leaves.
C Matthew Jones, Ammonia deposition to semi-natural vegetation,
C PhD dissertation, University of Dundee, Scotland, 2006

               surf_leaf = 2.0 * MET_DATA%LAI( c,r ) / MET_DATA%ZF( c,r,1 )

C Calculate A/V for buildings and other structures.
C Buildings and other structures can provide additional surfaces in
C urban areas for the heterogeneous reaction to occur. However, such
C information is not readily available; in the absence of such information,
C it is scaled to purb(c,r). Svensson et al., (1987) suggests a typical value
C of 0.2 for A/V for buildings in urban environments. A maximum value of 0.2
C for A/V for buildings is assigned to the grid cell containing the highest
C purb(c,r) i.e., 100.0. A/V for buildings for other grid-cell is calculated
C as purb(c,r)*(0.2/100.0); Cai et al. (2006) used a value of 1.0 for their
C study at New York (total A/V)

               surf_bldg = GRID_DATA%PURB( c,r ) * 0.002

C Calculate rate constant for the reaction (pseudo-first order reaction,
C unit per second). Calculate pseudo-first order rate constant using Eq 1
C of Vogel et al. (2003).  Unit of KNO2 is in 1/min in the paper; divide it
C by 60 to convert it into 1/sec.

               kno2 = MAX( 0.0, 5.0E-5 * (surf_leaf + surf_bldg) )

C Determine NO2 concentration needed for HONO production term.

               IF ( s .EQ. s_NO2 ) THEN
                  conc_no2 = cgridl1( n )

               END IF
C Calculate production (bidi_emis) for HONO; unit = ppm * m/s
               IF ( s .EQ. s_HONO ) Then
                  Tile_Data%Bidi_Emis( C, R, n ) = kno2 * conc_no2 * MET_DATA%ZF( c,r,1 )
               END IF 
            END IF

            ! Check for negative values or NaN's                  
            if(isnan(Tile_Data%Bidi_Emis( C, R, n ))) write(logdev,*) 'NaN in ',vd_name( s ),' production term'
            if(isnan(Tile_Data%Grd_Vd( C, R, n ))) write(logdev,*) 'NaN in ',vd_name( s ),' Vd term'
            NH3_hit = .False.
            O3_hit  = .False.
            Hg_hit  = .False.
            End If 
         End Do spc_loop

         Return         
         END SUBROUTINE GAS_X

         SUBROUTINE AERO_X(CGRID, C, R )

C *** Calculate deposition velocity for Aitken, accumulation, and
C     coarse modes.
C     Reference:
C     Binkowski F. S., and U. Shankar, The regional particulate
C     model 1. Model description and preliminary results.
C     J. Geophys. Res., 100, D12, 26191-26209, 1995.
 
C    May 05 D.Schwede: added impaction term to coarse mode dry deposition
C 25 May 05 J.Pleim:  Updated dry dep velocity calculation for aerosols
C                     to Venkatram and Pleim (1999)
C 20 Jul 05 J.Pleim:  Changed impaction term using modal integration of
C                     Stokes**2 / 400 (Giorgi, 1986, JGR)
C 14 Apr 08 J.Kelly:  Added code to calculate deposition velocity of
C                     coarse surface area and to account for variable
C                     standard deviation of the coarse mode.
C 08 Sep 08 P.Bhave:  Backward compatibility with AE4 mechanisms
C                     standardized names of all coarse-mode variables
C-----------------------------------------------------------------------

         USE AERO_DATA           ! aero variable data   
         USE AEROMET_DATA        ! Includes CONST module
         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE RXNS_DATA           ! chemical mechanism data
         Use MOSAIC_MOD, Only: Tile_Data 
         Use Resist_Funcs, Only: Aero_Depv, Aero_Depv_E20, Aero_Depv_P22

         IMPLICIT NONE

C Includes:

         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments
         REAL,    POINTER       :: CGRID( :,:,:,: )
         INTEGER, INTENT( IN )  :: C,R                 ! Column and Row

C *** array indices hardcoded to match SUBROUTINE AERO_DEPV
      INTEGER, PARAMETER, DIMENSION( 3 ) :: 
     &                      VDN = (/ 1,2,3 /) , 
     &                      VDM = (/ 4,5,6 /) , 
     &                      VDS = (/ 7,8,9 /)  

C Meteorological variables

         CHARACTER( 16 ), SAVE :: AE_VRSN ! Aerosol version name

         INTEGER, SAVE :: NCELLS              ! number of cells per layer

         REAL, SAVE  :: XLM        ! mean free path [ m ]
         REAL, SAVE  :: AMU        ! dynamic viscosity [ kg m**-1 s**-1 ]

         REAL M3_WET, M3SUBT, M3_DRY
         REAL M2_WET, M2_DRY

         CHARACTER( 16 ), SAVE :: PNAME = 'AERO_X'
         CHARACTER( 16 ) :: VNAME            ! variable name
         CHARACTER( 96 ) :: XMSG = ' '

         INTEGER  V, N, L, NDX          ! loop counters
         INTEGER  n_diag
         INTEGER  SPC, S                ! species loop counter
         INTEGER  ALLOCSTAT

C modal Knudsen numbers
         REAL KN

C modal particle diffusivities for number, 2nd, and 3rd moment, or mass:
         REAL DCHAT0
         REAL DCHAT2
         REAL DCHAT3

C modal sedimentation velocities for number, 2nd, and 3rd moment, or mass:
         REAL VGHAT0
         REAL VGHAT2
         REAL VGHAT3

         INTEGER NCELL, J, IM

         REAL DCONST,  DCONST1
         REAL DCONST2, DCONST3
         REAL EINHAT0, EINHAT2, EINHAT3 ! Interception integration terms
         REAL SC0                      ! Schmidt numbers for number
         REAL SC2                      ! Schmidt numbers for 2ND MOMENT
         REAL SC3                      ! Schmidt numbers for 3rd moment
         REAL NU                       ! kinematic viscosity [ m**2 s**-1 ]
         REAL TWOXLM                   ! 2 X atmospheric mean free path
         REAL Ra, Ustar, lai           ! Land use specific environmental variables
         REAL Ubar, SeaIce, SST        ! Grid scale meteorological variables
         REAL Lu_frac, Veg, wet        ! Land use and vegetation coverage fraction
         REAL l_width, Alpha           ! Emerson et al. 2020 land use variables
         REAL BAI, Ahair, Fhair, Aleaf ! Pleim et al. 2022 land use variables

C Parameters
         REAL, PARAMETER :: BHAT    = 1.246    ! Slope of the linearized Cunningham slip correction 
         REAL, PARAMETER :: IHAT    = 0.8473   ! Intercept of the linearized Cunningham slip correction 
         REAL, PARAMETER :: T0      = 288.15   ! [ K ] ! starting standard surface temp.
         REAL, PARAMETER :: THREEPI = 3.0 * PI

C Scalar variables for VARIABLE standard deviations.

         REAL    L2SG

         REAL    E1                  ! mode exp( log^2( sigmag )/8 )
         REAL    ES04                !        " **4
         REAL    ES08                !        " **8
         REAL    ES12                !        " **12
         REAL    ES16                !        " **16
         REAL    ES20                !        " **20
         REAL    ES28                !        " **28
         REAL    ES32                !        " **32
         REAL    ES36                !        " **36
         REAL    ES48                !        " **48
         REAL    ES64                !        " **64
         REAL    ESM12               !        " **(-12)
         REAL    ESM16               !        " **(-16)
         REAL    ESM20               !        " **(-20)
         REAL    ESM32               !        " **(-32)

C-----------------------------------------------------------------------

         VDEP  = 0.0   ! array assignment
         VDEPJ = 0.0   ! array assignment

C ***    Set meteorological data for the grid cell.
         AIRDENS = Met_Data%DENS1( C,R )
         AIRTEMP = Met_Data%TEMP2( C,R )
         AIRPRES = Met_Data%PRSFC( C,R )
         Ubar    = Met_Data%WSPD10( C,R )
         SeaIce  = Met_Data%SEAICE( C,R )
         SST     = Met_Data%TSEASFC( C,R ) - 273.15

C ***    extract grid cell concentrations of aero species from CGRID
C        into aerospc_conc in aero_data module
C        Also determines second moment from surface area and adds wet
C        species
         CALL EXTRACT_AERO( CGRID( C,R,1,: ), .TRUE. )

C ***    Calculate geometric mean diameters and standard deviations of the
C        "wet" size distribution
         CALL GETPAR( .FALSE. )     

C        Save getpar values to arrays
         DO IM = 1,N_MODE
            XXLSG( IM ) = AEROMODE_LNSG( IM )   
            DG( IM )    = AEROMODE_DIAM( IM )
            PDENS( IM ) = AEROMODE_DENS( IM )
         END DO
 
C        Calculate mean free path [ m ]:
         XLM = 6.6328E-8 * STDATMPA * AIRTEMP / ( T0 * AIRPRES )

C ***    Calculate dynamic and kinematic viscosity [ kg m**-1 s**-1 ]:
         AMU = 1.458E-6 * AIRTEMP * SQRT( AIRTEMP )
     &                 / ( AIRTEMP + 110.4 )
         NU = AMU / Met_Data%DENS1( C,R )   

C *** Calculate Knudsen numbers
         TWOXLM = XLM + XLM
         DO IM = 1, N_MODE
            KN = TWOXLM / DG( IM )

C *** Calculate functions of variable standard deviation.

            L2SG = XXLSG( IM ) ** 2
            
            E1   = EXP( 0.125 * L2SG )
            ES04 = E1 ** 4
            ES08 = ES04 ** 2
            ES12 = ES04 * ES08
            ES16 = ES08 ** 2
            ES20 = ES16 * ES04
            ES28 = ES20 * ES08
            ES32 = ES16 ** 2
            ES36 = ES16 * ES20
            ES48 = ES36 * ES12
            ES64 = ES32 ** 2

C *** calculate inverses:

            ESM12 = 1.0 / ES12
            ESM16 = 1.0 / ES16
            ESM20 = 1.0 / ES20
            ESM32 = 1.0 / ES32

            DCONST  = DKBOLTZ * Met_Data%TEMP2( C,R ) / ( THREEPI * AMU )
            DCONST1 = DCONST / DG( IM )

            DCONST2 = GRAV / ( 18.0 * AMU )
            DCONST3 = DCONST2 * PDENS( IM ) * DG( IM ) ** 2 ! Gravitational settling 
C Calculate characteristic parameters
            DCHAT0  = DCONST1 * ( ES04  + BHAT * KN * ES16 )
            DCHAT2  = DCONST1 * ( ESM12 + BHAT * KN * ESM16 )
            DCHAT3  = DCONST1 * ( ESM20 + BHAT * KN * ESM32 )
            VGHAT0  = DCONST3 * ( ES16  + BHAT * KN * ES04 )
            VGHAT2  = DCONST3 * ( ES48  + BHAT * KN * ES20 )
            VGHAT3  = DCONST3 * ( ES64  + BHAT * KN * ES28 )  

C Integrated Emerson et al 2020 Interception term.
            EINHAT0 = EXP(L2SG*((0.64)/2.0))
            EINHAT2 = EXP(L2SG*((1.6*2.0 + 0.64)/2.0))
            EINHAT3 = EXP(L2SG*((1.6*3.0 + 0.64)/2.0))

            SC0 = NU / DCHAT0
            SC2 = NU / DCHAT2   
            SC3 = NU / DCHAT3


            lu_loop: DO L = 1, Tile_Data%n_lufrac
C ***    Land use parameters
               Veg     = Mosaic_Data%VEG( C,R,L )
               wet     = Mosaic_Data%DELTA( c,r,l )
               Ustar   = Mosaic_Data%USTAR( C,R,L )
               lai     = Mosaic_Data%LAI( C,R,L )
               Ra      = Mosaic_Data%RA( C,R,L )
               lu_frac = Tile_Data%LUFRAC( C,R,L )
               l_width = Tile_Data%l_width( L )
               Alpha   = Tile_Data%Alpha( L )
               BAI     = Tile_Data%BAI( L )
               Ahair   = Tile_Data%Ahair( L )
               Fhair   = Tile_Data%Fhair( L )
               Aleaf   = Tile_Data%Aleaf( L )
               IF( water( L ) ) wet = 1.0
               IF ( lu_frac .Eq. 0.0 ) Cycle lu_loop

C now calculate the deposition velocities

C Parallel conductances are additive. Thus, the vegetated and non-vegetated deposition velocities are added. 
C first do 0th moment (number), second do 2nd moment (surface area), third do 3rd moment (mass)
C Emerson et al 2020 PNAS https://www.pnas.org/cgi/doi/10.1073/pnas.2014761117
               If( STAGE_E20 ) Then
                  VDEPJ( L,VDN( IM ) ) = aero_depv_e20(veg, lai, Ustar, Ra, wet, l_width, Alpha, 
     &                                             DG(IM), SC0, NU, VGHAT0, EINHAT0 ) ! Number
                  VDEPJ( L,VDS( IM ) ) = aero_depv_e20(veg, lai, Ustar, Ra, wet, l_width, Alpha,
     &                                             DG(IM), SC2, NU, VGHAT2, EINHAT2 ) ! Surface area
                  VDEPJ( L,VDM( IM ) ) = aero_depv_e20(veg, lai, Ustar, Ra, wet, l_width, Alpha, 
     &                                             DG(IM), SC3, NU, VGHAT3, EINHAT3 ) ! Mass
C Pleim et al 2022
               Else If( STAGE_P22 ) Then 
                  VDEPJ( L,VDN( IM ) ) = aero_depv_p22(veg, lai, BAI, Ustar, Ubar, Ra, Water(L), Aleaf, 
     &                                             Ahair, Fhair, SC0, NU, VGHAT0, SeaIce, SST ) ! Number
                  VDEPJ( L,VDS( IM ) ) = aero_depv_p22(veg, lai, BAI, Ustar, Ubar, Ra, Water(L), Aleaf, 
     &                                             Ahair, Fhair, SC2, NU, VGHAT2, SeaIce, SST ) ! Surface area
                  VDEPJ( L,VDM( IM ) ) = aero_depv_p22(veg, lai, BAI, Ustar, Ubar, Ra, Water(L), Aleaf, 
     &                                             Ahair, Fhair, SC3, NU, VGHAT3, SeaIce, SST ) ! Mass
               Else
C CMAQ v5.3
                  VDEPJ( L,VDN( IM ) ) = aero_depv(veg, Ra, VGHAT0, Ustar, SC0, NU, l_width, lai ) ! Number
                  VDEPJ( L,VDS( IM ) ) = aero_depv(veg, Ra, VGHAT2, Ustar, SC2, NU, l_width, lai ) ! Surface area
                  VDEPJ( L,VDM( IM ) ) = aero_depv(veg, Ra, VGHAT3, Ustar, SC3, NU, l_width, lai ) ! Mass
               End If

C now integrate to the area weighted grid cell
               VDEP( VDN( IM ) )    =  VDEP( VDN( IM ) ) + Lu_Frac * VDEPJ( L,VDN( IM ) ) ! Number
               VDEP( VDS( IM ) )    =  VDEP( VDS( IM ) ) + Lu_Frac * VDEPJ( L,VDS( IM ) ) ! Surface area
               VDEP( VDM( IM ) )    =  VDEP( VDM( IM ) ) + Lu_Frac * VDEPJ( L,VDM( IM ) ) ! Mass

            END DO lu_loop ! Tile_Data%n_lufrac
         END DO ! aerosol mode

C Return dry deposition velocities for aerosols (first layer only).
         n_diag = 0
         DO V = 1, N_AE_DEPV
            NDX = N_GC_DEPV + N_NR_DEPV + N_TR_DEPV + V
            IF ( DEPV_SUR( V ) .GT. 0 ) THEN
               Tile_Data%Grd_Vd( C,R,NDX )   = VDEP( DEPV_SUR( V ) ) 
               Tile_Data%Lu_Vd( C,R,NDX,: )  = VDEPJ( :,DEPV_SUR( V ) )
            ELSE
               Tile_Data%Grd_Vd( C,R,NDX ) = 0.0
               Tile_Data%Lu_Vd( C,R,NDX,: )  = 0.0  
            END IF 
         END DO
                    
         Return
         END SUBROUTINE AERO_X

      END MODULE STAGE_MOD

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/plrise/smoke/plsprd.f,v 1.2 2011/10/21 16:11:31 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!      SUBROUTINE PLSPRD( DTHDZ, ZF, KZ, CEFSTK, HTMIX, PLTOP, PLBOT )
       SUBROUTINE PLSPRD( DTHDZ, ZF, KZ, CEFSTK,        PLTOP, PLBOT )
     
C-----------------------------------------------------------------------
C Description:  
C   Calculates the initial vertical spread of a plume; modified
C   from Gillani's model.
 
C Preconditions:
 
C Subroutines and Functions Called:
 
C Revision History:
C   Initially provided by J. Godowitch ( EPA, 9/03 )
C   Aug 2015, D. Wong: Used assumed shape array declaration
 
C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling
C                System
C File: @(#)$Id: plsprd.f,v 1.2 2011/10/21 16:11:31 yoj Exp $
C COPYRIGHT (C) 2003, MCNC Environmental Modeling Center
C All Rights Reserved
C See file COPYRIGHT for conditions of use.
C Environmental Modeling Center
C MCNC
C P.O. Box 12889
C Research Triangle Park, NC  27709-2889
C smoke@emc.mcnc.org
C Pathname: $Source: /project/yoj/arc/CCTM/src/plrise/smoke/plsprd.f,v $
C Last updated: $Date: 2011/10/21 16:11:31 $ 
C-----------------------------------------------------------------------

       IMPLICIT NONE
       
C Arguments:

       REAL,    INTENT ( IN ) :: DTHDZ( : )  ! potential temperature lapse rate (K/m)
       REAL,    INTENT ( IN ) :: ZF( 0:  )   ! full-layer heights (m)
       INTEGER, INTENT ( IN ) :: KZ          ! number of emissions layers
       REAL,    INTENT ( IN ) :: CEFSTK      ! effective stack height (m)
!      REAL,    INTENT ( IN ) :: HTMIX       ! mixing height (m)
       REAL,    INTENT( OUT ) :: PLTOP       ! plume top (m)
       REAL,    INTENT( OUT ) :: PLBOT       ! plume bottom (m)
       
C Parameters:
       REAL, PARAMETER :: SZ0FAC = 3.545     ! factor used to derive plume depth
       REAL, PARAMETER :: SPRFAC = 15.       ! empirical coefficient for vertical spread
       REAL, PARAMETER :: GAMMA  = -0.0098   ! adiabatic lapse rate (K/m)
       
C Local Variables:
       INTEGER K
       
       REAL    SIGZ0
       REAL    DTDZ
       REAL    DPTH
       
C-----------------------------------------------------------------------

C Get ambient temperature above plume rise height (effective stack height)
      K = 0
      DO 
         K = K + 1
         IF ( K .EQ. KZ .OR. CEFSTK .LE. ZF( K ) ) EXIT
      END DO
      DTDZ  = DTHDZ( K ) + GAMMA
       
C Compute initial vertical spread
      SIGZ0 = MAX( 10.0, SPRFAC * EXP( -117.0 * DTDZ ) )
      DPTH  = SZ0FAC * SIGZ0
       
C Compute plume top and bottom heights; plume is either completely
C within or outside mixing layer
      PLTOP = CEFSTK + DPTH / 2.0
      PLBOT = CEFSTK - DPTH / 2.0
       
C Make sure plume bottom is at least zero
      PLBOT = MAX( 0.0, PLBOT )
       
C Make sure that plume top and bottom height < ZF (KZ) .       
      PLTOP = MIN( ZF( KZ ), PLTOP )
      PLBOT = MIN( ZF( KZ )-1.0, PLBOT )

      RETURN
       
      END SUBROUTINE PLSPRD

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE INIT_CCTM_MODULES ( CGRID, JDATE, JTIME, TSTEP, ASTEP )

      USE RUNTIME_VARS, ONLY : COLUMN_MODEL
      USE ELMO_DATA, ONLY : L_ELMO, ELMO_NSTEP
      USE ELMO_PROC, ONLY : ELMO_DRIVER  
      USE ELMO_INIT_DEFN, ONLY : ELMO_INIT, OPEN_ELMO
      USE PA_DEFN, ONLY : BUDGET_DIAG
      USE BUDGET_DEFN, ONLY : BUDGET_INIT
      USE GRID_CONF, ONLY: IO_PE_INCLUSIVE

      IMPLICIT NONE

C Arguments:
      REAL, POINTER :: CGRID( :,:,:,: )

      INTEGER, INTENT(IN)    :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT(IN)    :: JTIME        ! current model time, coded HHMMSS
      INTEGER, INTENT(IN)    :: TSTEP( 3 )   ! time step vector (HHMMSS)
                                             ! TSTEP(1) = local output step
                                             ! TSTEP(2) = sciproc sync. step (chem)
                                             ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                             !            step and wrf/cmaq call frequency

      INTEGER, INTENT(IN)    :: ASTEP( : )   ! layer advection time step
      

      INTERFACE
#ifndef mpas
         SUBROUTINE HADV ( CGRID, JDATE, JTIME, TSTEP, ASTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
            INTEGER, INTENT( IN )     :: ASTEP( : )
         END SUBROUTINE HADV
         SUBROUTINE ZADV ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE ZADV
         SUBROUTINE COUPLE ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE COUPLE
         SUBROUTINE DECOUPLE ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE DECOUPLE
         SUBROUTINE HDIFF ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE HDIFF
#endif
         SUBROUTINE VDIFF ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE VDIFF
         SUBROUTINE PHOT ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( : )
         END SUBROUTINE PHOT
         SUBROUTINE CLDPROC ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE CLDPROC
         SUBROUTINE CHEM ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE CHEM
         SUBROUTINE PVO3 ( CGRID, JDATE, JTIME )
            IMPLICIT NONE
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
         END SUBROUTINE PVO3
         SUBROUTINE AERO ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE AERO

      END INTERFACE

      ! Calculate Vertical Diffusion, Dry Deposition, and Emissions
      CALL VDIFF ( CGRID, JDATE, JTIME, TSTEP )

      IF ( .NOT. COLUMN_MODEL ) THEN

          !CALL HADV ( CGRID, JDATE, JTIME, TSTEP, ASTEP )
          !CALL ZADV ( CGRID, JDATE, JTIME, TSTEP )
          !CALL HDIFF ( CGRID, JDATE, JTIME, TSTEP )

      END IF
          
      CALL PHOT ( CGRID, JDATE, JTIME, TSTEP )    
      CALL CLDPROC ( CGRID, JDATE, JTIME, TSTEP )
      !CALL CHEM ( CGRID, JDATE, JTIME, TSTEP )
      !CALL AERO ( CGRID, JDATE, JTIME, TSTEP )

      ! Write CGRID state file for subsequent runs
      CALL WR_CGRID ( CGRID, JDATE, JTIME, TSTEP( 1 ) )
#ifdef isam
      CALL WR_SA_CGRID ( JDATE, JTIME, TSTEP( 1 ) )
#endif
#ifdef sens
      CALL WR_SENGRID ( JDATE, JTIME, TSTEP( 1 )  )
#endif

      ! Open ISAM and DDM Concentration Files
#ifdef isam
      ! Write out ISAM source-resolved concentrations
      CALL WR_AVG_SA ( JDATE, JTIME, TSTEP( 1 ) )
#endif

      ! Initialize ELMO Arrays and Maps
      CALL ELMO_INIT( TSTEP(1) )
      
      ! Compute ELMO Values at Beginning of Main Time Step
      IF ( L_ELMO ) THEN

        ! Open the aerosol parameters file (diameters and standard deviations).
        IF ( IO_PE_INCLUSIVE ) THEN
           CALL OPEN_ELMO ( JDATE, JTIME, TSTEP( 1 ) )
           ELMO_NSTEP = 0.0
        END IF

        ! Calculate all ELMO variables for both Instantaneous and
        ! Average parameters
        CALL ELMO_DRIVER( CGRID, JDATE, JTIME, TSTEP, INIT_TIME_IN=.TRUE.)
        
        ! Print Instantaneous Values at first time step
        CALL WRITE_ELMO( JDATE, JTIME, TSTEP, .TRUE. )

      END IF

      ! Initialize Budget Output File and Concentration Array
      IF ( BUDGET_DIAG ) CALL BUDGET_INIT( CGRID, JDATE, JTIME, TSTEP )
 
      END SUBROUTINE INIT_CCTM_MODULES

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
module megan_fx
    
      USE ASX_DATA_MOD, ONLY : Grid_Data
      USE HGRD_DEFN, ONLY: NCOLS,NROWS
! Aggregated code from MEGAN3.0 by Francis S.Binkowski 
! with minor modifications where noted below.
! Implemented for CMAQ 5.4 and proofed by Jeff Willison.

      IMPLICIT NONE
      
      REAL , PARAMETER :: CONVERTWM2TOUMOLM2S = 4.5 ,                   &
                          SOLARCONSTANT = 1367. ,                        &
                          WATERAIRRATIO = 18.016/28.97
                                              ! Ratio between water and air molecules
 
! Canopy characteristics for MEGCAN canopy types
      INTEGER , PARAMETER :: NRTYP = 6          ! Number of canopy types
      INTEGER , PARAMETER :: NRCHA = 17         ! Number of canopy characteristics
! 16 variables are assigned for each canopy type
! 1  = canopy depth
! 2  = leaf width
! 3  = leaf length
! 4  = canopy height
! 5  = scattering coefficient for PPFD
! 6  = scattering coefficient for near IR
! 7  = reflection coefficient for diffuse PPFD
! 8  = reflection coefficient for diffuse near IR
! 9  = clustering coefficient (accounts for leaf clumping influence on mean
!    projected leaf area in the direction of the suns beam)
! 10 = leaf IR emissivity
! 11 = leaf stomata and cuticle factor: 1=hypostomatous, 2=amphistomatous,
!     1.25=hypostomatous but with some transpiration through cuticle
! 12 = daytime temperature lapse rate (K m-1)
! 13 = nighttime temperature lapse rate (K m-1)
! 14 = warm (>283K) canopy total humidity change (Pa)
! 15 = cool (>= 283K) canopy total humidity change (Pa)
! 16 = normalized canopy depth where wind is negligible
! 17 = canopy transparency
!
! Six canopy types currently used in MEGCAN:
! 1  = Needleleaf trees
! 2  = Tropical forest trees,
! 3  = Temperate broadleaf trees
! 4  = shrubs
! 5  = herbaceous
! 6  = crops
 
      REAL , DIMENSION(NRCHA,NRTYP) :: Canopychar = reshape((/16.,16., &
                                      16.,1.,0.5,1.,0.005,0.05,0.05,   &
                                      0.015,0.01,0.02,0.1,0.1,0.1,0.1, &
                                      0.15,0.15,24.,24.,24.,2.,0.5,1.0,&
                                      0.2,0.2,0.2,0.2,0.2,0.2,0.8,0.8, &
                                      0.8,0.8,0.8,0.8,0.057,0.057,     &
                                      0.057,0.057,0.057,0.057,0.389,   &
                                      0.389,0.389,0.389,0.389,0.389,   &
                                      0.85,1.1,0.9,0.85,0.7,0.65,0.95, &
                                      0.95,0.95,0.95,0.95,0.95,1.25,   &
                                      1.25,1.25,1.,1.25,1.25,0.06,0.06,&
                                      0.06,0.06,0.06,0.06,-0.06,-0.06, &
                                      -0.06,-0.06,-0.06,-0.06,700.,    &
                                      700.,700.,700.,700.,700.,150.,   &
                                      150.,150.,150.,150.,150.,0.7,0.7,&
                                      0.7,0.7,0.7,0.7,0.2,0.2,0.2,0.2, &
                                      0.2,0.2/),SHAPE=(/NRCHA,NRTYP/), &
                                      ORDER=(/2,1/))
 
!   for Soil NOx 
! =======================================================================
!  MEGSEA.EXT
!  This include file contains wilting point information
!  for calculating soil moisture activity factor
!
! Created by Alex Guenther and Ling Huang in March 2017
!=======================================================================

!      INTEGER, PARAMETER :: NrTyp = 6          ! Number of canopy types
      REAL,   PARAMETER  :: d1 = 0.04

!-- WWLT is wilting point (M^3/M^3) (JN90)

!      REAL, PARAMETER  ::    WWLT(16) = (/               &        
!                            0.068, 0.075, 0.114, 0.179,  &
!                            0.155, 0.175, 0.218, 0.250,  &
!                            0.219, 0.283, 0.286, 0.286,  &
!                            0.286, 0.286, 0.286, 0.286   /)           
!     REAL, PARAMETER  ::    WWLT(16) =   (/  
!                            0.068, 0.075, 0.114, 0.179,  & 
!                            0.150, 0.155, 0.175, 0.218,  &
!                            0.250, 0.219, 0.283, 0.286,  &
!                            0.155, 0.286, 0.286, 0.175 /)
!

    !   Based upon  MEGVEA.EXT includes suggestions from CJC

    !=======================================================================
    !  MEGVEA.EXT
    !  This include file contains information required
    !  for running MEGEAV module for calculating emission activity responses

    !  Created by Alex Guenther and Ling Huang in Feb 2017
    !
    ! 
    !=======================================================================



    !Number of emission classes
    INTEGER, PARAMETER :: NCLASS = 19
    INTEGER, PARAMETER :: NEMIS  = NCLASS
    ! number of emission classes

    ! CO2 related emission activity factor parameters
    REAL,PARAMETER :: CO2   = 400.0
    REAL,PARAMETER :: ISmax =   1.344
    REAL,PARAMETER :: CO2h  =   1.4614
    REAL,PARAMETER :: Cstar = 585.0

    ! PSTD
    REAL,PARAMETER :: PSTD = 200

    ! canopy depth emission response
    REAL,PARAMETER :: CCD1 = -0.2
    REAL,PARAMETER :: CCD2 =  1.3

    !Light and temperature emission activity response coefficients for each emission class
    !LDF: light dependent fraction
    REAL           LDF(NCLASS)
    !CT1: temperature coefficient (emission type 1: light dependent)
    REAL           CT1(NCLASS)
    !Cleo: temperature coefficient (emission type 1: light dependent)
    REAL           Cleo(NCLASS)
    !beta: temperature coefficient (emission type 2: light independent)
    REAL           beta(NCLASS)

      DATA    beta(1),LDF(1),CT1(1),Cleo(1)        /  0.13,1.0,95,2  /
      DATA    beta(2),LDF(2),CT1(2),Cleo(2)        /  0.13,1.0,95,2  /
      DATA    beta(3),LDF(3),CT1(3),Cleo(3)        /  0.10,0.6,80,1.83  /
      DATA    beta(4),LDF(4),CT1(4),Cleo(4)        /  0.10,0.9,80,1.83  /
      DATA    beta(5),LDF(5),CT1(5),Cleo(5)        /  0.10,0.2,80,1.83  /
      DATA    beta(6),LDF(6),CT1(6),Cleo(6)        /  0.10,0.4,80,1.83  /
      DATA    beta(7),LDF(7),CT1(7),Cleo(7)        /  0.10,0.1,80,1.83  /
      DATA    beta(8),LDF(8),CT1(8),Cleo(8)        /  0.10,0.0,80,1.83  /
      DATA    beta(9),LDF(9),CT1(9),Cleo(9)        /  0.17,0.5,130,2.37  /
      DATA    beta(10),LDF(10),CT1(10),Cleo(10)    /  0.17,0.4,130,2.37  /
      DATA    beta(11),LDF(11),CT1(11),Cleo(11)    /  0.08,0.8,60,1.6  /
      DATA    beta(12),LDF(12),CT1(12),Cleo(12)    /  0.10,0.2,80,1.83  /
      DATA    beta(13),LDF(13),CT1(13),Cleo(13)    /  0.13,0.8,95,2  /
      DATA    beta(14),LDF(14),CT1(14),Cleo(14)    /  0.13,0.8,95,2  /
      DATA    beta(15),LDF(15),CT1(15),Cleo(15)    /  0.10,0.2,80,1.83  /
      DATA    beta(16),LDF(16),CT1(16),Cleo(16)    /  0.10,0.2,80,1.83  /
      DATA    beta(17),LDF(17),CT1(17),Cleo(17)    /  0.10,0.8,80,1.83  /
      DATA    beta(18),LDF(18),CT1(18),Cleo(18)    /  0.10,0.1,80,1.83  /
      DATA    beta(19),LDF(19),CT1(19),Cleo(19)    /  0.08,1.0,60,1.6  /



    ! Parameters for leaf age algorithm for each emission activity classes
    REAL           Anew(NCLASS)
    REAL           Agro(NCLASS)
    REAL           Amat(NCLASS)
    REAL           Aold(NCLASS)

      DATA    Anew(  1),  Agro(  1),  Amat(  1),  Aold(  1) &
          /  0.05     ,  0.6      ,  1.0    ,  0.9       /

      DATA    Anew(  2),  Agro(  2),  Amat(  2),  Aold(  2) &
          /  0.05     ,  0.6      ,  1.0     , 0.9       /

      DATA    Anew(  3),  Agro(  3),  Amat(  3),  Aold(  3) &
          /  2.0      ,  1.8      ,  1.0     ,  1.05       /

      DATA    Anew(  4),  Agro(  4),  Amat(  4),  Aold(  4) &
          /  2.0      ,  1.8      ,  1.0     ,  1.05       /

      DATA    Anew(  5),  Agro(  5),  Amat(  5),  Aold(  5) &
          /  2.0      ,  1.8      ,  1.0     ,  1.05       /

      DATA    Anew(  6),  Agro(  6),  Amat(  6),  Aold(  6) &
          /  2.0      ,  1.8      ,  1.0     ,  1.05       /

      DATA    Anew(  7),  Agro(  7),  Amat(  7),  Aold(  7) &
          /  2.0      ,  1.8      ,  1.0     ,  1.05       /

      DATA    Anew(  8),  Agro(  8),  Amat(  8),  Aold(  8) &
          /  1.0      ,  1.0      ,  1.0      ,  1.0       /

      DATA    Anew(  9),  Agro(  9),  Amat(  9),  Aold(  9) &
          /  0.4      ,  0.6      ,  1.0     ,  0.95       /

      DATA    Anew( 10),  Agro( 10),  Amat( 10),  Aold( 10) &
          /  0.4      ,  0.6      ,  1.0    ,  0.95       /

      DATA    Anew( 11),  Agro( 11),  Amat( 11),  Aold( 11) &
          /  3.5      ,  3.0      ,  1.0    ,  1.2        /

      DATA    Anew( 12),  Agro( 12),  Amat( 12),  Aold( 12) &
          /  1.0      ,  1.0      ,  1.0    ,  1.0       /

      DATA    Anew( 13),  Agro( 13),  Amat( 13),  Aold( 13) &
          /  1.0      ,  1.0      ,  1.0    ,  1.0       /

      DATA    Anew( 14),  Agro( 14),  Amat( 14),  Aold( 14) &
          /  1.0      ,  1.0      ,  1.0    ,  1.0       /

      DATA    Anew( 15),  Agro( 15),  Amat( 15),  Aold( 15) &
          /  1.0      ,  1.0      ,  1.0      ,  1.0       /

      DATA    Anew( 16),  Agro( 16),  Amat( 16),  Aold( 16) &
          /  1.0      ,  1.0      ,  1.0      ,  1.0       /

      DATA    Anew( 17),  Agro( 17),  Amat( 17),  Aold( 17) &
          /  1.0      ,  1.0      ,  1.0      ,  1.0       /

      DATA    Anew( 18),  Agro( 18),  Amat( 18),  Aold( 18) &
          /  1.0      ,  1.0      ,  1.0      ,  1.0       /

      DATA    Anew( 19),  Agro( 19),  Amat( 19),  Aold( 19) &
          /  1.0      ,  1.0      ,  1.0      ,  1.0       /


    !stress emission activity response coefficients for each emission class
    !CAQ: coefficient for poor Air Quality stress
    REAL           CAQ(NCLASS)
    !CHW: coefficient for high wind speed stress
    REAL           CHW(NCLASS)
    !CHT: coefficient for high temperature stress
    REAL           CHT(NCLASS)
    !CLT: coefficient for high temperature stress
    REAL           CLT(NCLASS)



      DATA    CAQ(1),CHW(1),CHT(1),CLT(1)           /  1,1,1,1  /
      DATA    CAQ(2),CHW(2),CHT(2),CLT(2)           /  1,1,1,1  /
      DATA    CAQ(3),CHW(3),CHT(3),CLT(3)           /  1,5,1,1  /
      DATA    CAQ(4),CHW(4),CHT(4),CLT(4)           /  5,5,5,5  /
      DATA    CAQ(5),CHW(5),CHT(5),CLT(5)           /  1,5,1,1  /
      DATA    CAQ(6),CHW(6),CHT(6),CLT(6)           /  1,5,1,1  /
      DATA    CAQ(7),CHW(7),CHT(7),CLT(7)           /  1,5,1,1  /
      DATA    CAQ(8),CHW(8),CHT(8),CLT(8)           /  1,1,1,1  /
      DATA    CAQ(9),CHW(9),CHT(9),CLT(9)           /  5,5,5,5  /
      DATA    CAQ(10),CHW(10),CHT(10),CLT(10)       /  5,5,5,5  /
      DATA    CAQ(11),CHW(11),CHT(11),CLT(11)       /  1,1,1,1  /
      DATA    CAQ(12),CHW(12),CHT(12),CLT(12)       /  1,1,1,1  /
      DATA    CAQ(13),CHW(13),CHT(13),CLT(13)       /  1,1,1,1  /
      DATA    CAQ(14),CHW(14),CHT(14),CLT(14)       /  1,1,1,1  /
      DATA    CAQ(15),CHW(15),CHT(15),CLT(15)       /  1,1,1,1  /
      DATA    CAQ(16),CHW(16),CHT(16),CLT(16)       /  1,1,1,1  /
      DATA    CAQ(17),CHW(17),CHT(17),CLT(17)       /  5,5,5,5  /
      DATA    CAQ(18),CHW(18),CHT(18),CLT(18)       /  1,1,1,1  /
      DATA    CAQ(19),CHW(19),CHT(19),CLT(19)       /  1,1,1,1  /

    !TAQ: threshold for poor Air Quality stress (ppm-hours)
    REAL           TAQ(NCLASS)
    !THW: threshold for high wind speed stress (m/s)
    REAL           THW(NCLASS)
    !THT: threshold for high temperature stress (Celsius degree)
    REAL           THT(NCLASS)
    !TLT: threshold for high temperature stress (Celsius degree)
    REAL           TLT(NCLASS)

      DATA    TAQ(1),THW(1),THT(1),TLT(1)           /  20,12,40,10  /
      DATA    TAQ(2),THW(2),THT(2),TLT(2)           /  20,12,40,10  /
      DATA    TAQ(3),THW(3),THT(3),TLT(3)           /  20,12,40,10  /
      DATA    TAQ(4),THW(4),THT(4),TLT(4)           /  20,12,40,10  /
      DATA    TAQ(5),THW(5),THT(5),TLT(5)           /  20,12,40,10  /
      DATA    TAQ(6),THW(6),THT(6),TLT(6)           /  20,12,40,10  /
      DATA    TAQ(7),THW(7),THT(7),TLT(7)           /  20,12,40,10  /
      DATA    TAQ(8),THW(8),THT(8),TLT(8)           /  20,12,40,10  /
      DATA    TAQ(9),THW(9),THT(9),TLT(9)           /  20,12,40,10  /
      DATA    TAQ(10),THW(10),THT(10),TLT(10)       /  20,12,40,10  /
      DATA    TAQ(11),THW(11),THT(11),TLT(11)       /  20,12,40,10  /
      DATA    TAQ(12),THW(12),THT(12),TLT(12)       /  20,12,40,10  /
      DATA    TAQ(13),THW(13),THT(13),TLT(13)       /  20,12,40,10  /
      DATA    TAQ(14),THW(14),THT(14),TLT(14)       /  20,12,40,10  /
      DATA    TAQ(15),THW(15),THT(15),TLT(15)       /  20,12,40,10  /
      DATA    TAQ(16),THW(16),THT(16),TLT(16)       /  20,12,40,10  /
      DATA    TAQ(17),THW(17),THT(17),TLT(17)       /  20,12,40,10  /
      DATA    TAQ(18),THW(18),THT(18),TLT(18)       /  20,12,40,10  /
      DATA    TAQ(19),THW(19),THT(19),TLT(19)       /  20,12,40,10  /


    !stress emission activity delta thresholds for each emission class
    !DTAQ: delta threshold for poor Air Quality stress (ppm-hours)
    REAL           DTAQ(NCLASS)
    !DTHW: delta threshold for high wind speed stress (m/s)
    REAL           DTHW(NCLASS)
    !DTHT: delta threshold for high temperature stress (Celsius degree)
    REAL           DTHT(NCLASS)
    !DTLT: delta threshold for low temperature stress (Celsius degree)
    REAL           DTLT(NCLASS)

      DATA    DTAQ(1),DTHW(1),DTHT(1),DTLT(1)               /  30,8,8,8  /
      DATA    DTAQ(2),DTHW(2),DTHT(2),DTLT(2)               /  30,8,8,8  /
      DATA    DTAQ(3),DTHW(3),DTHT(3),DTLT(3)               /  30,8,8,8  /
      DATA    DTAQ(4),DTHW(4),DTHT(4),DTLT(4)               /  30,8,8,8  /
      DATA    DTAQ(5),DTHW(5),DTHT(5),DTLT(5)               /  30,8,8,8  /
      DATA    DTAQ(6),DTHW(6),DTHT(6),DTLT(6)               /  30,8,8,8  /
      DATA    DTAQ(7),DTHW(7),DTHT(7),DTLT(7)               /  30,8,8,8  /
      DATA    DTAQ(8),DTHW(8),DTHT(8),DTLT(8)               /  30,8,8,8  /
      DATA    DTAQ(9),DTHW(9),DTHT(9),DTLT(9)               /  30,8,8,8  /
      DATA    DTAQ(10),DTHW(10),DTHT(10),DTLT(10)           /  30,8,8,8  /
      DATA    DTAQ(11),DTHW(11),DTHT(11),DTLT(11)           /  30,8,8,8  /
      DATA    DTAQ(12),DTHW(12),DTHT(12),DTLT(12)           /  30,8,8,8  /
      DATA    DTAQ(13),DTHW(13),DTHT(13),DTLT(13)           /  30,8,8,8  /
      DATA    DTAQ(14),DTHW(14),DTHT(14),DTLT(14)           /  30,8,8,8  /
      DATA    DTAQ(15),DTHW(15),DTHT(15),DTLT(15)           /  30,8,8,8  /
      DATA    DTAQ(16),DTHW(16),DTHT(16),DTLT(16)           /  30,8,8,8  /
      DATA    DTAQ(17),DTHW(17),DTHT(17),DTLT(17)           /  30,8,8,8  /
      DATA    DTAQ(18),DTHW(18),DTHT(18),DTLT(18)           /  30,8,8,8  /
      DATA    DTAQ(19),DTHW(19),DTHT(19),DTLT(19)           /  30,8,8,8  /

    ! MEGAN species
    ! Based on Alex Guenther's "Description Class.xlsx" for MEGANv3

!      DATA     MGN_SPC(  1)  / 'ISOP            '/      ! isoprene
!      DATA     MGN_SPC(  2)  / 'MBO             '/      ! MBO
!      DATA     MGN_SPC(  3)  / 'MT_PINE         '/      ! monoterpenes: pines (alpha and beta)
!      DATA     MGN_SPC(  4)  / 'MT_ACYC         '/      ! monoterpenes: acyclic, 3 = (e.g., myrcene, ocimenes)
!      DATA     MGN_SPC(  5)  / 'MT_CAMP         '/      ! monoterpenes: carene, camphene, others
!      DATA     MGN_SPC(  6)  / 'MT_SABI         '/      ! monoterpenes: sabinene, limonene, terpinenes, others
!      DATA     MGN_SPC(  7)  / 'MT_AROM         '/      ! C10 aromatic: cymenes, cymenenes & C8-C13 oxygenated (e.g., camphor)
!      DATA     MGN_SPC(  8)  / 'NO              '/      ! Nitric oxide
!      DATA     MGN_SPC(  9)  / 'SQT_HR          '/      ! Highly reactive SQT (e.g., caryophyllene)
!      DATA     MGN_SPC( 10)  / 'SQT_LR          '/      ! less reactive SQT (e.g., longifolene, copaene) and salates
!      DATA     MGN_SPC( 11)  / 'MEOH            '/      ! methanol
!      DATA     MGN_SPC( 12)  / 'ACTO            '/      ! acetone
!      DATA     MGN_SPC( 13)  / 'ETOH            '/      ! acetaldehyde and ethanol
!      DATA     MGN_SPC( 14)  / 'ACID            '/      ! organic acids: formicacid, acetic acid, pyruvic acid
!      DATA     MGN_SPC( 15)  / 'LVOC            '/      ! C2 to C4 HC (e.g.,ethene, ethane)
!      DATA     MGN_SPC( 16)  / 'OXPROD          '/      ! oxidation products:aldehydes
!      DATA     MGN_SPC( 17)  / 'STRESS          '/      ! Stress compounds(e.g., linalool)
!      DATA     MGN_SPC( 18)  / 'OTHER           '/      ! other VOC (e.g.,indole, pentane, methyl bromide)
!      DATA     MGN_SPC( 19)  / 'CO              '/      ! carbon monoxide




CONTAINS    !!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

        
! ______________ SUBROUTINE get_CBETA_____________
! This subroutine calculates the solar zenith angle , its sine and the eccentricity
!    INPUT variables:
!    JD       current Julian Day.
!    LAT      current latitude [deg]
!    HOUR     current hour [ hr ] 

!    OUTPUT variables:
!    BETA            curent solar zenith angle
!    SINBETA         Sine of zenith angle
!    ECCEBTRICITY    orbital eccentricity (solar distance) [ AU ] 
!  coded by Dr. Francis S.Binkowski on April 2, 2019, modified Abril 4, 2019
!  based upon earlier code and updated to latest algorithms from USNO

!   Reference:
!   The algorithm for the solar position  are from 
!   https://aa.usno.navy.mil/faq/docs/SunApprox.php
!   Us NAVAL OBSERVATORY The acuracy is good for two centuries 
!   before and after 2000 CE. 

      SUBROUTINE get_BETA( JD, LAT, HOUR, BETA, SINBETA, ECCENTRICITY )
      IMPLICIT NONE
!*--CALCBETA575
! INPUTS: 
      REAL, INTENT(IN) :: JD   ! True Julian day of interest
      REAL, INTENT(IN) :: LAT  ! Latitude [ degrees ]
      REAL, INTENT(IN) :: HOUR ! local standard time
      
! OUTPUT:
      REAL, INTENT(OUT) :: BETA ! the zenith angle of the sun at lat, hour in degrees
      REAL, INTENT(OUT) :: SINBETA ! sine of BETA
      REAL, INTENT(OUT) :: ECCENTRICITY ! orbital eccentricity 
                                        ! earth distance from sun {AU}
! LOCAL VARIBLES            
      REAL :: sindelta , cosdelta , a , b ,  D, R, num, den, decl
      REAL :: sinepsilon, cosepsilon, sinlamda, coslamda, RA, EQT, hangle
      REAL :: g, q, L, lamda, epsilon, e, sing, singsq, sin2g, cosg, cos2g, latrad      
      REAL, PARAMETER :: PI = 4.0 * ATAN(1.0), twopi = 2.0 * PI
      REAL, PARAMETER :: twopi_24 = twopi / 24.0 ! eliminates runtime division
      REAL, PARAMETER :: RAD2DEG = 180.0 / PI,  DEG2RAD = 1.0 / RAD2DEG
      REAL, PARAMETER :: JD0 = 2451545.5 ! True Julian day for January 1, 2000
      REAL, PARAMETER :: ONE15 = 1.0  / 15.0        
      REAL, PARAMETER :: RADCONV = RAD2DEG * ONE15       

       
!--------------------------------------------------------------------

      D = JD  - JD0 
      
      g = 357.529 + 0.98560028 * D  ! Mean anomaly of the Sun

      g = MODULO(g,360.0)
      IF ( g.LT.0.0 ) g = g + 360.0
 
      g = deg2RAD * g   ! g in radians now

!     calculate trig functions of g using identities
!     this speeds up the calculations
 
      sing = SIN(g)
      singsq = sing * sing
      cosg  = sqrt( 1 - singsq)
      sin2g = 2.0 * sing * cosg
      cos2g = cosg*cosg - sing*sing

      q = 280.459 + 0.98564736 *  D     ! Mean longitude of the Sun:

! *** now force L to be betweeon 0.0 and 360. degrees
      q = MODULO( q,360.0)
      IF ( q.LT.0.0 ) q = q + 360.0

      lamda = q + 1.915 * sing + 0.020 * sin2g ! apparent longitude of the sun
      lamda = MODULO(lamda,360.0)
      IF ( lamda.LT.0.0 ) lamda = lamda + 360.0     
      
!     epsilon = 23.429 - 4.0E-7 * D  ! obliquity of ecliptic
      epsilon = 23.439 - 3.6e-7 * D  ! obliquity of ecliptic

!   convert to radian
       epsilon   = DEG2RAD * epsilon
       lamda     = DEG2RAD * lamda
      
      sinepsilon = SIN(epsilon)  
      sinlamda   = SIN(lamda)
      coslamda   = SQRT( 1.0 - sinlamda *sinlamda )
            
      sindelta = sinepsilon * sinlamda           ! sine of solar declination
      cosdelta = SQRT(1.0 - sindelta * sindelta) ! cosine of solar declination

      cosepsilon = SQRT( 1.0 - sinepsilon * sinepsilon )      
      
!   calculate Right Ascension of the sun

       num = cosepsilon * sinlamda
       den = coslamda
       RA  = atan2(num,den)

!   Ignore EQT.  It adds at most plus or minus 16 minutes over the year
!      hangle = (twopi * (HOUR-12.0) / 24.0 ) ! hour angle in radians
!   eliminate runtime division to save time
      hangle = (twopi_24 * (HOUR-12.0) ) ! hour angle in radians

      latrad = DEG2RAD * LAT

 
      a = SIN(latrad) * sindelta
      b = COS(Latrad) * cosdelta
      SINBETA = a + b * COS( hangle) 
      
      BETA = ASIN(SINBETA) * RAD2DEG ! [ degrees]
     
!   calculate solar distance [ Astronomical Units ] This does
!     change over the seasons and more importantly over
!     annual and longer time scales because it is a function of
!     the Mean anomaly of the Sun.

      R            = 1.00014 - 0.01671*cosg - 0.00014*cos2g 
      ECCENTRICITY = R    
      RETURN
      END SUBROUTINE  get_BETA
 


     REAL FUNCTION getJD (YEAR,MONTH,DAY)
!
!---COMPUTES THE JULIAN DATE (JD) GIVEN A GREGORIAN CALENDAR
!   DATE (YEAR,MONTH,DAY).

!   REFERENCE:
!   Reda,Ibrahim, and Andreas Afshin, 2008, Solar position algorithm for solar
!    radiation applications, NREL/TP-550-34302, Revised January 2008l, National 
!    Renewable Energy Laboratory, Golden CO. 
!    Coded April 10, 2019 by Dr. Francis S. Binkowski 
 
    REAL YEAR,MONTH,DAY,Y, M, D, A, B,  JD
!
    Y  = YEAR
    M  = MONTH
    D  = DAY

!   The following is from Equation (4) on Page 3 of the reference.
  
    A  = AINT( Y / 100.0)
    B = 2.0 -A +AINT(A/4) 
    
  getJD = AINT( 365.25 *( Y + 4716.0 ) ) + AINT( 30.6001*( M + 1.0) ) + D    &
            + B - 1524.5
!
    RETURN
    END FUNCTION getJD  





!///////////////_______----------------------- 
!              This SUBROUTINE converts a date on the Gregorian
!                 calendar to a day of the year.
! REFERENCE:

! Original  Programmer:   David G. Simpson
!                NASA Goddard Space Flight Center
!                Greenbelt, Maryland  2077  Date:         November 20, 2001


!  Modified April 13, 2019 by Dr Francis S. Binkowski to do only Gregorian years


      SUBROUTINE get_DOY( YEAR, MONTH, DAY, DOY)

      IMPLICIT NONE
!   INPUT:      
      REAL, INTENT(IN)  :: YEAR, MONTH, DAY   ! GREGORIAN DATE                                                    

!   OUTPUT:
      INTEGER, INTENT(OUT)  :: DOY                ! DAY OF the YEAR
      
!   LOCAL:
      
      INTEGER :: Y                               ! year
      INTEGER :: M                               ! month (1-12)
      INTEGER :: D                               ! day of month 
      INTEGER :: K
   
      
      LOGICAL :: LEAP

!   BEGIN CODE:
     
       Y = YEAR
       M = MONTH
       D = DAY
       
      LEAP = .FALSE.
      
!   TEST FOR LEAP YEARS
      
      IF ( MOD(Y,4)   .EQ. 0) LEAP = .TRUE.
      IF ( MOD(Y,100) .EQ. 0) LEAP = .FALSE.
      IF  (MOD(Y,400) .EQ. 0) LEAP = .TRUE.

      IF (LEAP) THEN
         K = 1
      ELSE
         K = 2
      END IF

!   CALCULATE DAY OF THE YEAR using INTEGER arithmetic

      DOY = ( ( 275 * M) / 9 ) - K * ( ( M + 9) / 12 ) + D - 30

      RETURN
      
      END SUBROUTINE get_DOY
      
     SUBROUTINE get_date(YEAR,DOY,MM,DD)
     
!=============WHEN GIVEN A VALID YEAR, YYYY, AND DAY OF THE
!             YEAR, DDD, RETURNS THE MONTH, MM, AND DAY OF THE
!             MONTH, DD.

! REference:
!             SEE ACM ALGORITHM 398, TABLELESS DATE CONVERSION, BY
!            {*filter*} STONE, CACM 13(10):621.ACM 1970; DOI:10.1145/355598.362779. 7. 
!            Summary We have introduced a formalism which allows us to 
!            explicate certain rather gross properties of language ...

!   Modified to f90 by Dr. Francis S. Binkowski on April 13, 2019

!      INPUT:
      REAL, INTENT(in)  ::  YEAR, DOY    ! year and day of year 
      
!      OUTPUT:      
      INTEGER, INTENT(out) :: MM , DD

!     LOCAL:       
      INTEGER              :: T
      INTEGER              ::  YYYY , DDD

!   Start code 

      YYYY = YEAR
      DDD  = DOY 
      T    = 0
      
      IF( MOD(YYYY,4) .EQ. 0)  T = 1 ! test for leap year
      
!-----------THE FOLLOWING STATEMENT IS NECESSARY IF YYYY IS LESS TNAN
!           1900 OR GREATER THAN 2100.

      IF( MOD(YYYY,400) .NE.0 .AND. MOD(YYYY,100) .EQ. 0 ) T = 0
      
      DD = DDD
      
      IF( DDD.GT. 59 + T ) DD = DD + 2 - T
      
      MM =  (  (DD + 91 ) * 100 ) / 3055
      
      DD = ( DD + 91 ) - ( MM * 3055 ) / 100
      
      MM = MM - 2
!----------MM WILL BE CORRECT IFF DDD IS CORRECT FOR YYYY.
      
      RETURN
      
     
      END  SUBROUTINE get_date
      
     
      
      
!   These subroutines are from MEGCAN
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   SUBROUTINE GaussianDist
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      SUBROUTINE GAUSSIANDIST(Distgauss,Layers)
 
      IMPLICIT NONE
!*--GAUSSIANDIST91
 
      INTEGER , INTENT(IN) :: Layers
 
      REAL , DIMENSION(Layers) , INTENT(OUT) :: Distgauss
 
! local variables
      INTEGER :: i
!----------------------------------------------------------------
 
      IF ( Layers.EQ.1 ) THEN
         Distgauss(1) = 0.5
      ELSEIF ( Layers.EQ.3 ) THEN
         Distgauss(1) = 0.112702
         Distgauss(2) = 0.5
         Distgauss(3) = 0.887298
      ELSEIF ( Layers.EQ.5 ) THEN
         Distgauss(1) = 0.0469101
         Distgauss(2) = 0.2307534
         Distgauss(3) = 0.5
         Distgauss(4) = 0.7692465
         Distgauss(5) = 0.9530899
      ELSE
         DO i = 1 , Layers
            Distgauss(i) = (i-0.5)/Layers
         ENDDO
      ENDIF
      
      RETURN
      
      END  SUBROUTINE GAUSSIANDIST
 
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   SUBROUTINE SolarFractions
!   Based on actual and potential max solar radiation:
!   Determine the fraction of solar radiation that is
!   diffuse PPFD, direct PPFD, diffuse near IR, direct near IR
!
!   Originally developed by Alex Guenther in 1990s
!   Modified in 2010
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      SUBROUTINE SOLARFRACTIONS(Solar,Maxsolar,Qdiffv,Qbeamv,Qdiffn,    &
                              & Qbeamn)
 
      IMPLICIT NONE
!*--SOLARFRACTIONS137
 
      REAL , INTENT(IN) :: Solar , Maxsolar
      REAL , INTENT(OUT) :: Qdiffv , Qbeamv , Qdiffn , Qbeamn
      REAL :: fracdiff , ppfdfrac , ppfddiffrac , qv , qn
! internal variables
      REAL :: transmis
!-----------------------------------------------------
      IF ( Maxsolar<=0 ) THEN
         transmis = 0.5
      ELSEIF ( Maxsolar<Solar ) THEN
         transmis = 1.0
      ELSE
         transmis = Solar/Maxsolar
      ENDIF
 
!FracDiff is based on Lizaso 2005
      fracdiff = 0.156 + 0.86/(1+EXP(11.1*(transmis-0.53)))
 
!PPFDfrac is based on Goudrian and Laar 1994
      ppfdfrac = 0.55 - transmis*0.12
 
!PPFDdifFrac is based on data in Jacovides 2007
      ppfddiffrac = fracdiff*(1.06+transmis*0.4)
 
! Calculate  Qdiffv,Qbeamv, Qdiffn, Qbeamn in the subroutine
 
      IF ( ppfddiffrac>1.0 ) ppfddiffrac = 1.0
 
      qv = ppfdfrac*Solar
      Qdiffv = qv*ppfddiffrac
      Qbeamv = qv - Qdiffv
      qn = Solar - qv
      Qdiffn = qn*fracdiff
      Qbeamn = qn - Qdiffn
 
      RETURN
 
      END  SUBROUTINE SOLARFRACTIONS
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo!
!   Subroutine CanopyRad
!
!   Canopy light environment model
!   Code originally developed by Alex Guenther in 1990s
!   Coded into FORTRAN by Xuemei Wang
!   based on Spitters et al. (1986), 
!   Goudrian and van Laar (1994), Leuning (1997)
!   Initial code 8-99, 
!   modified 7-2000, 12-2001, 1-2017
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo

      SUBROUTINE CanopyRad(Distgauss, Layers, LAI, Sinbeta,   &
                 Qbeamv, Qdiffv, Qbeamn, Qdiffn, Cantype,     &
                 Canopychar, Sunfrac, QbAbsV, QdAbsV, QsAbsV, &
                 QbAbsn, QdAbsn, QsAbsn, SunQv,               &
                 ShadeQv, SunQn, ShadeQn, SunPPFD, ShadePPFD, &
                 NrCha, NrTyp)

      IMPLICIT NONE

! input
      INTEGER,INTENT(IN) :: Layers, NrCha, NrTyp, Cantype
      REAL,INTENT(IN) :: Qbeamv,Qdiffv,Sinbeta,LAI,Qbeamn,Qdiffn
      REAL,DIMENSION(Layers),INTENT(IN) :: Distgauss

! output
      REAL,INTENT(OUT) :: QbAbsV, QbAbsn

      REAL,DIMENSION(Layers),INTENT(OUT) :: ShadePPFD, SunPPFD, & 
                     QdAbsv, QsAbsv, QsAbsn, ShadeQv,  SunQn,  &  
                     QdAbsn, SunQv, ShadeQn, Sunfrac

      REAL,DIMENSION(NrCha,NrTyp), INTENT(IN) :: Canopychar

! internal variables
      INTEGER :: i
      REAL :: ScatV, ScatN, RefldV, RefldN, ReflbV, ReflbN,     & 
              Kb, Kd, KbpV, KbpN, KdpV, KdpN, LAIdepth, Cluster,& 
              QdAbsVL, QsAbsVL, QdAbsNL, QsAbsNL, CANTRAN, LAIadj

! Stefan-boltzman constant  W m-2 K-4
      REAL,PARAMETER :: Sb = 0.0000000567    
      REAL,PARAMETER :: ConvertShadePPFD = 4.6
      REAL,PARAMETER :: ConvertSunPPFD = 4.0
!---------------------------------------------------------------------
        
! adjust LAI for canopy transparency
      CANTRAN = Canopychar(17,Cantype)
      LAIadj = LAI / ( 1 - CANTRAN )

      IF (((Qbeamv  + Qdiffv ) > 0.001) .AND.   & 
          (Sinbeta  > 0.002) .AND.             & 
          (LAIadj  > 0.001)) THEN       ! Daytime

! Scattering coefficients (scatV,scatN), diffuse and beam reflection 
! coefficients (ref..) for visible or near IR
        ScatV   = Canopychar(5,Cantype)
        ScatN   = Canopychar(6,Cantype)
        RefldV  = Canopychar(7,Cantype)
        RefldN  = Canopychar(8,Cantype)
        Cluster = Canopychar(9,Cantype)
!        print*,'cluster',  Cluster
! Extinction coefficients for black leaves for beam (kb) or diffuse (kd)
        Kb = Cluster * 0.5 / Sinbeta 
! (0.5 assumes a spherical leaf angle distribution (0.5 = cos (60 deg))
        Kd = 0.8 * Cluster              
! (0.8 assumes a spherical leaf angle distribution)

        Call CalcExtCoeff(Qbeamv,ScatV,Kb,Kd,ReflbV,KbpV,KdpV,QbAbsV)
        Call CalcExtCoeff(Qbeamn,ScatN,Kb,Kd,ReflbN,KbpN,KdpN,QbAbsn)

        DO i = 1,layers
! LAI depth at this layer
          LAIdepth   = LAIadj  * Distgauss(i)  
!fraction of leaves that are sunlit
          Sunfrac(i) = EXP(-Kb * LAIdepth)  

          Call CalcRadComponents(Qdiffv , Qbeamv , kdpV,  &
                               kbpV, kb, scatV, refldV,  &
                               reflbV, LAIdepth, QdAbsVL, QsAbsVL)

          Call CalcRadComponents(Qdiffn , Qbeamn , kdpN,  &
                               kbpN, kb, scatN, refldN,  &
                               reflbN, LAIdepth, QdAbsNL, QsAbsNL)

       ShadePPFD(i) = (QdAbsVL + QsAbsVL) * ConvertShadePPFD/(1 - scatV)
       SunPPFD(i) = ShadePPFD(i) + (QbAbsV* ConvertSunPPFD/(1 - scatV))
          QdAbsV(i) = QdAbsVL
          QsAbsV(i) = QsAbsVL
          QdAbsn(i) = QdAbsNL
          QsAbsn(i) = QsAbsNL
          ShadeQv(i) = QdAbsVL + QsAbsVL
          SunQv(i)   = ShadeQv(i) + QbAbsV 
          ShadeQn(i) = QdAbsNL + QsAbsNL
          SunQn(i)   = ShadeQn(i) + QbAbsn 
        ENDDO

      ELSE                           ! Night time

        QbAbsV  = 0
        QbAbsn   = 0

        Sunfrac(:)   = 0.2
        SunQn(:)     = 0
        ShadeQn(:)   = 0
        SunQv(:)     = 0
        ShadeQv(:)   = 0
        SunPPFD(:)   = 0
        ShadePPFD(:) = 0
        QdAbsV(:)    = 0
        QsAbsV(:)    = 0
        QdAbsn(:)    = 0
        QsAbsn(:)    = 0

      ENDIF
         
      RETURN
      END SUBROUTINE CanopyRad
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   Subroutine CalcExtCoeff
!   Calculate light extinction coefficients
!   Code originally developed by Alex Guenther in 1990s
!   Coded into FORTRAN by Xuemei Wang
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      SUBROUTINE CALCEXTCOEFF(Qbeam,Scat,Kb,Kd,Reflb,Kbp,Kdp,           &
                            & Qbeamabsorb)
 
      IMPLICIT NONE
!*--CALCEXTCOEFF308
 
      REAL , INTENT(IN) :: Qbeam , Scat , Kb , Kd
      REAL , INTENT(OUT) :: Reflb , Kbp , Kdp , Qbeamabsorb
 
! local variables
      REAL :: p
!-------------------------------------------------------------------
 
      p = (1-Scat)**0.5
      Reflb = 1 - EXP((-2*((1-p)/(1+p))*Kb)/(1+Kb))
 
! Extinction coefficients
      Kbp = Kb*p
      Kdp = Kd*p
! Absorbed beam radiation
      Qbeamabsorb = Kb*Qbeam*(1-Scat)

      RETURN
 
      END  SUBROUTINE CALCEXTCOEFF
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   Subroutine CalcRadComponents
!   Code originally developed by Alex Guenther in 1990s
!   Coded into FORTRAN by Xuemei Wang
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      SUBROUTINE CALCRADCOMPONENTS(Qdiff,Qbeam,Kdp,Kbp,Kb,Scat,Refld,   &
                                  Reflb,Laidepth,Qdabs,Qsabs)
 
      IMPLICIT NONE
!*--CALCRADCOMPONENTS340
 
      REAL , INTENT(IN) :: Qdiff , Qbeam , Kdp , Kbp , Kb , Scat ,      &
                           Refld , Reflb , Laidepth
      REAL , INTENT(OUT) :: Qdabs , Qsabs
!-------------------------------------------------------------------
 
      Qdabs = Qdiff*Kdp*(1-Refld)*EXP(-Kdp*Laidepth)
      Qsabs = Qbeam*((Kbp*(1-Reflb)*EXP(-Kbp*Laidepth))                 &
              -(Kb*(1-Scat)*EXP(-Kb*Laidepth)))
      
      RETURN
      
      END  SUBROUTINE CALCRADCOMPONENTS
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   Subroutine CanopyEB
!
!   Canopy energy balance model for estimating leaf temperature
!   Coded into FORTRAN by Xuemei Wang
!   Code developed by Alex Guenther in 1990s
!   based on Goudrian and Laar (1994) and Leuning (1997)
!   Initial code 8-99, modified 7-2000 and 12-2001
!   Modified in 1-2017 by Alex Guenther and Ling Huang
!   to correct IR balance and atmos. emissivity
!   Note: i denotes an array containing a vertical profile
!         through the canopy with 0 (above canopy conditions)
!         plus 1 to number of canopy layers
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      SUBROUTINE CANOPYEB(Trate,Layers,Distgauss,Canopychar,Cantype,   &
                         Tairk,Humidairpa,Ws,Sunppfd,Shadeppfd,Sunqv,  &
                         Shadeqv,Sunqn,Shadeqn,Sunleaftk,Sunleafsh,    &
                         Sunleaflh,Sunleafir,Shadeleaftk,Shadeleafsh,  &
                         Shadeleaflh,Shadeleafir,Nrcha,Nrtyp,Ws0,      &
                         Tairk0,Humidairpa0)
 
      IMPLICIT NONE
!*--CANOPYEB377
 
! inputs
      INTEGER , INTENT(IN) :: Nrcha , Nrtyp , Layers , Cantype
      REAL , INTENT(IN) :: Trate , Tairk0 , Humidairpa0 , Ws0
      REAL , DIMENSION(Layers) , INTENT(IN) :: Distgauss , Sunqv ,      &
                                       Shadeqv , Sunqn , Shadeqn ,     &
                                       Sunppfd , Shadeppfd
      REAL , DIMENSION(Nrcha,Nrtyp) , INTENT(IN) :: Canopychar
 
! outputs
      REAL , DIMENSION(Layers) , INTENT(OUT) :: Humidairpa , Ws ,      &
                                       Sunleaftk , Sunleafsh ,         &
                                       Sunleaflh , Sunleafir , Tairk , &
                                       Shadeleaftk , Shadeleafsh ,     &
                                       Shadeleaflh , Shadeleafir
 
! local variables
      INTEGER :: i
!     &         Deltah, UnexposedLeafIRin, ExposedLeafIRin, IRin,IRout
      REAL :: cdepth , lwidth , llength , cheight , eps ,               &
               transpiretype , deltah , emissatm , irin , irout
      REAL , DIMENSION(Layers) :: ldepth , wsh, wsh1
!-----------------------------------------------------------------------
 
      cdepth = Canopychar(1,Cantype)
      lwidth = Canopychar(2,Cantype)
      llength = Canopychar(3,Cantype)
      cheight = Canopychar(4,Cantype)
      eps = Canopychar(10,Cantype)
      transpiretype = Canopychar(11,Cantype)
 
      IF ( Tairk0>288 ) THEN
! Pa m-1  (humidity profile for T < 288)
         deltah = Canopychar(14,Cantype)/cheight
      ELSEIF ( Tairk0>278 ) THEN
         deltah = (Canopychar(14,Cantype)-((288-Tairk0)/10)             &
                  *(Canopychar(14,Cantype)-Canopychar(15,Cantype)))     &
                  /cheight
      ELSE
! Pa m-1  (humidity profile for T <278)
         deltah = Canopychar(15,Cantype)/cheight
      ENDIF
 
      ldepth(:) = cdepth*Distgauss(:)
      Tairk(:) = Tairk0 + (Trate*ldepth(:))               ! check this
      Humidairpa(:) = Humidairpa0 + (deltah*ldepth(:))
 
      wsh(:)  = (cheight-ldepth(:)) - (Canopychar(16,Cantype)*cheight)

      wsh1(:) = wsh(:)
      WHERE(wsh(:)<0.001)Wsh1(:) = 0.0009 ! to avoid undef for LOG(negative)

      Ws(:) = (Ws0*LOG(wsh1(:))/LOG(cheight-Canopychar(16,Cantype)*      &
            & cheight))
      WHERE(wsh(:)<0.001)Ws(:) = 0.05
 
      DO i = 1 , Layers
 
! REVISE - Replace UnexposedLeafIR with LeafIR
 
!        IRin     = UnexposedLeafIRin(TairK(i), Eps)
!        ShadeleafIR(i) = 2 * IRin
!        SunleafIR(i) = 0.5*ExposedLeafIRin(HumidairPa0,TairK0)+1.5*IRin
 
! Apparent atmospheric emissivity for clear skies:
! function of water vapor pressure (Pa)
! and ambient Temperature (K) based on Brutsaert(1975)
! referenced in Leuning (1997)
         emissatm = 0.642*(Humidairpa(i)/Tairk(i))**(1./7.)
         irin = LEAFIR(Tairk(i),emissatm)
         Shadeleafir(i) = irin
         Sunleafir(i) = irin
 
      ! Sun
         CALL LEAFEB(Sunppfd(i),Sunqv(i)+Sunqn(i),Sunleafir(i),eps,     &
                     transpiretype,lwidth,llength,Tairk(i),Humidairpa(i)&
                     ,Ws(i),Sunleaftk(i),Sunleafsh(i),Sunleaflh(i),     &
                     irout)
 
         Sunleafir(i) = Sunleafir(i) - irout
 
      ! Shade
         CALL LEAFEB(Shadeppfd(i),Shadeqv(i)+Shadeqn(i),Shadeleafir(i), &
                     eps,transpiretype,lwidth,llength,Tairk(i),         &
                     Humidairpa(i),Ws(i),Shadeleaftk(i),Shadeleafsh(i), &
                     Shadeleaflh(i),irout)
 
         Shadeleafir(i) = Shadeleafir(i) - irout
      ENDDO
      
      RETURN
      
      END  SUBROUTINE CANOPYEB
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   Subroutine LeafEB
!
!   Leaf energy balance
!   Code originally developed by Alex Guenther in 1990s
!   Coded into FORTRAN by Xuemei Wang
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      SUBROUTINE LEAFEB(Ppfd,Q,Irin,Eps,Transpiretype,Lwidth,Llength,   &
                        Tairk,Humidairpa,Ws,Tleaf,Sh,Lh,Irout)
 
      IMPLICIT NONE
!*--LEAFEB480
 
      REAL , INTENT(IN) :: Eps , Transpiretype , Lwidth , Llength ,     &
                           Ppfd , Q , Irin , Tairk , Humidairpa , Ws
      REAL , INTENT(OUT) :: Irout , Tleaf , Sh , Lh
 
! local variables
 
      INTEGER :: i
!     &        LHairT,Tdelt,Balance,LeafBLC,LeafH,LeafLE,LeafIRout,
      REAL :: humidairkgm3 , ghforced , stomres , iroutairt ,     &
              lathv , ws1 , lhairt , tdelt , balance , gh1 , sh1 , lh1 , e1 ,   &
              irout1 , gh
!----------------------------------------------------
 
      IF ( Ws<=0 ) THEN
         ws1 = 0.001
      ELSE
         ws1 = Ws
      ENDIF
 
      ! Air vapor density kg m-3
      humidairkgm3 = CONVERTHUMIDITYPA2KGM3(Humidairpa,Tairk)
 
      ! Heat convection coefficient (W m-2 K-1) for forced convection.
      ! Nobel page 366
      ghforced = 0.0259/(0.004*((Llength/Ws1)**0.5))
 
      ! Stomatal resistence s m-1
      stomres = RESSC(Ppfd)
 
! REVISE - Replace LeafIRout with LeafIR
!      IRoutairT = LeafIROut(tairK, eps)
!      iroutairt = LEAFIR(Tairk+tdelt,Eps)
       IRoutairT = LeafIR(TairK, Eps)

 
      ! Latent heat of vaporization (J Kg-1)
      lathv = LHV(Tairk)
 
      ! Latent heat flux
      lhairt = LEAFLE(Tairk,humidairkgm3,lathv,ghforced,stomres,        &
               Transpiretype)
 
      e1 = (Q+Irin-iroutairt-lhairt)
      IF ( e1.EQ.0. ) e1 = -1.
 
      tdelt = 1.
      balance = 10.
      DO i = 1 , 10
         IF ( ABS(balance)>2 ) THEN
          ! Boundary layer conductance
            gh1 = LEAFBLC(ghforced,tdelt,Llength)
          ! Convective heat flux
            sh1 = LEAFH(tdelt,gh1)
          ! Latent heat of vaporization (J Kg-1)
            lathv = LHV(Tairk+tdelt)
            Lh = LEAFLE(Tairk+tdelt,humidairkgm3,lathv,gh1,stomres,     &
                 Transpiretype)
            lh1 = Lh - lhairt
 
! REVISE - Replace LeafIROut with LeafIR
!          IRout  = LeafIROut(TairK + Tdelt, Eps)
            Irout = LEAFIR(Tairk+tdelt,Eps)
            irout1 = Irout - iroutairt
            tdelt = e1/((sh1+lh1+irout1)/tdelt)
            balance = Q + Irin - Irout - sh1 - Lh
         ENDIF
      ENDDO
 
      IF ( tdelt>10 ) tdelt = 10
      IF ( tdelt<-10 ) tdelt = -10
 
      Tleaf = Tairk + tdelt
      gh = LEAFBLC(ghforced,Tleaf-Tairk,Llength)
      Sh = LEAFH(Tleaf-Tairk,gh)
      Lh = LEAFLE(Tleaf,humidairkgm3,lathv,gh,stomres,Transpiretype)
 
! REVISE - Replace LeafIROut with LeafIR
!      IRout = LeafIROut(Tleaf, Eps)
      Irout = LEAFIR(Tleaf,Eps)
      
      RETURN
      
      END  SUBROUTINE LEAFEB
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION Calcbeta
!   Calculates the solar zenith angle
!   Code originally developed by Alex Guenther in 1990s
!   Coded into FORTRAN by Xuemei Wang
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION CALCBETA(Day,Lat,Hour)
 
      IMPLICIT NONE
!*--CALCBETA575
 
      REAL :: Day
 
      REAL :: Hour , Lat , sindelta , cosdelta , a , b , sinbeta ,      &
              CALCBETA
      REAL , PARAMETER :: PI = 3.14159 , RPI180 = 57.29578
!--------------------------------------------------------------------
      !sindelta = -SIN(0.40907*COS(6.28*(Day+10)/(365)))
      sindelta = -SIN(0.40907)*COS(6.28*(Day+10)/(365))
      cosdelta = (1-sindelta**2.)**0.5
 
      a = SIN(Lat/RPI180)*sindelta
      b = COS(Lat/RPI180)*cosdelta
      sinbeta = a + b*COS(2*PI*(Hour-12)/24)
      CALCBETA = ASIN(sinbeta)*57.29578
 
      END FUNCTION CALCBETA
 
! The following is the original code for eccentricity.
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION CalcEccentricity
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION CALCECCENTRICITY(Day)
 
      IMPLICIT NONE
!*--CALCECCENTRICITY605
      REAL :: Day
      REAL :: CALCECCENTRICITY
!----------------------------------------------------------------
 
      CALCECCENTRICITY = 1 + 0.033*COS(2*3.14*(Day-10)/365)
 
      END  FUNCTION CALCECCENTRICITY
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION WaterVapPres
!
!   Convert water mixing ratio (kg/kg) to water vapor pressure
!   (Pa or Kpa depending on units of input )
!   Mixing ratio (kg/kg), temp (C), pressure (KPa)
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION WATERVAPPRES(Dens,Pres,Waterairratio)
 
      IMPLICIT NONE
!*--WATERVAPPRES627
      REAL :: Dens , Pres , WATERVAPPRES , Waterairratio
!----------------------------------------------------------------
 
      WATERVAPPRES = (Dens/(Dens+Waterairratio))*Pres
 
      END FUNCTION WATERVAPPRES
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION Stability
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION STABILITY(Canopychar,Cantype,Solar,Nrcha,Nrtyp)
 
      IMPLICIT NONE
!*--STABILITY644
      INTEGER :: Cantype , Nrcha , Nrtyp
      REAL :: Solar , trateboundary , STABILITY
      REAL , DIMENSION(Nrcha,Nrtyp) :: Canopychar
!----------------------------------------------------------------
 
      trateboundary = 500
 
      IF ( Solar>trateboundary ) THEN
            ! Daytime temperature lapse rate
         STABILITY = Canopychar(12,Cantype)
      ELSEIF ( Solar>0 ) THEN
         STABILITY = Canopychar(12,Cantype)                             &
                     - ((trateboundary-Solar)/trateboundary)            &
                     *(Canopychar(12,Cantype)-Canopychar(13,Cantype))
      ELSE
            ! Nightime temperature lapse rate
         STABILITY = Canopychar(13,Cantype)
      ENDIF
 
      END  FUNCTION STABILITY
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION ConvertHumidityPa2kgm3
!
!   Saturation vapor density  (kg/m3)
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION CONVERTHUMIDITYPA2KGM3(Pa,Tk)
 
      IMPLICIT NONE
!*--CONVERTHUMIDITYPA2KGM3677
      REAL :: CONVERTHUMIDITYPA2KGM3 , Pa , Tk
!--------------------------------------------------------------------
 
      CONVERTHUMIDITYPA2KGM3 = 0.002165*Pa/Tk
 
      END FUNCTION CONVERTHUMIDITYPA2KGM3
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION ResSC
!
!   Leaf stomatal cond. resistance s m-1
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION RESSC(Par)
 
      IMPLICIT NONE
!*--RESSC696
      REAL :: Par , scadj , RESSC
!----------------------------------------------------------------
 
      scadj = ((0.0027*1.066*Par)/((1+0.0027*0.0027*Par**2.)**0.5))
 
      IF ( scadj<0.1 ) THEN
         RESSC = 2000.0
      ELSE
         RESSC = 200.0/scadj
      ENDIF
 
      END  FUNCTION RESSC
 
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION LeafIR
!
!   Calculate IR transfer between leaf and air
!   Added by Alex Guenther and Ling Huang to replace previous
!   MEGAN2.1 IR balance functions
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION LEAFIR(Tk,Eps)
 
      IMPLICIT NONE
!*--LEAFIR723
      REAL :: Eps , Tk , LEAFIR
! Stefan-boltzman constant  W m-2 K-4
      REAL , PARAMETER :: SB = 0.0000000567
!----------------------------------------------------------------
 
      LEAFIR = Eps*SB*(2*(Tk**4.))
 
      END FUNCTION LEAFIR
 
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION LHV
!
!   Latent Heat of vaporization(J Kg-1) from Stull p641
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION LHV(Tk)
 
      IMPLICIT NONE
!*--LHV745
      REAL :: Tk , LHV
!----------------------------------------------------------------
 
! REVISE - Replace 273 with 273.15
!      LHV = 2501000 - (2370 * (Tk - 273))
      LHV = 2501000 - (2370*(Tk-273.15))
 
      END  FUNCTION LHV
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION LeafLE
!
!   Latent energy term in Energy balance
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION LEAFLE(Tleaf,Ambvap,Lathv,Gh,Stomres,Transpiretype)
 
      IMPLICIT NONE
!*--LEAFLE766
      REAL :: Tleaf , Ambvap , Lathv , Gh , Stomres , Transpiretype ,   &
              leafres , vapdeficit , LEAFLE , le
!----------------------------------------------------------------
 
      leafres = (1/(1.075*(Gh/1231))) + Stomres
      vapdeficit = (SVDTK(Tleaf)-Ambvap)
 
! Latent heat of vap (J Kg-1) * vap deficit(Kg m-3) /
!                 leaf resistence (s m-1)
      le = Transpiretype*(1/leafres)*Lathv*vapdeficit
      IF ( le<0 ) THEN
         LEAFLE = 0
      ELSE
         LEAFLE = le
      ENDIF
 
      END FUNCTION LEAFLE
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION LeafBLC
!
!   Boundary layer conductance
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION LEAFBLC(Ghforced,Tdelta,Llength)
 
      IMPLICIT NONE
!*--LEAFBLC796
      REAL :: Ghforced , Tdelta , Llength , ghfree , LEAFBLC
!----------------------------------------------------------------
 
! This is based on Leuning 1995 p.1198 except using molecular
! conductivity (.00253 W m-1 K-1 Stull p 640) instead of molecular
! diffusivity so that you end up with a heat convection coefficient
! (W m-2 K-1) instead of a conductance for free convection
 
      IF ( Tdelta>=0 ) THEN
         ghfree = 0.5*0.00253*((160000000*Tdelta/(Llength**3.))**0.25)  &
                  /Llength
      ELSE
         ghfree = 0
      ENDIF
      LEAFBLC = Ghforced + ghfree
 
      END  FUNCTION LEAFBLC
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION LeafH
!
!   Convective energy term in Energy balance (W m-2 heat flux
!      from both sides of leaf)
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION LEAFH(Tdelta,Gh)
 
      IMPLICIT NONE
!*--LEAFH827
      REAL :: Tdelta , Gh , LEAFH
!----------------------------------------------------------------
 
! 2 sides X conductance X Temperature gradient
      LEAFH = 2.0 * Gh * Tdelta
 
      END FUNCTION LEAFH
 
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
!
!   FUNCTION SvdTk
!
!   Saturation vapor density  (kg/m3)
!
!ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
 
      FUNCTION SVDTK(Tk)
 
      IMPLICIT NONE
!*--SVDTK847
      REAL :: Tk , svp , SVDTK
!----------------------------------------------------------------
 
! Saturation vapor pressure (millibars)
      svp = 10**((-2937.4/Tk)-(4.9283*LOG10(Tk))+23.5518)
      SVDTK = 0.2165*svp/Tk
 
      END  FUNCTION SVDTK


    !   These subroutines were in file megvea.f

    !----------------------------------------------------------------
    !
    !   SUBROUTINE GAMMA_CD
    !       Emission response to canopy depath
    !----------------------------------------------------------------
    SUBROUTINE GAMMA_CD(NCOLS,NROWS,Layers,LAI,CDEA)

        IMPLICIT NONE
        ! input
        INTEGER,INTENT(IN)                             :: NCOLS,NROWS,Layers
        REAL,DIMENSION(NCOLS,NROWS),INTENT(IN)         :: LAI
        ! output
        REAL,DIMENSION(NCOLS,NROWS,Layers),INTENT(OUT) :: CDEA

        ! local
        REAL,DIMENSION(Layers) :: Cdepth
        REAL                   :: LAIdepth
        INTEGER                 :: I,J,K

        IF ( Layers .EQ. 5 ) THEN
            Cdepth (1)   = 0.0469101
            Cdepth (2)   = 0.2307534
            Cdepth (3)   = 0.5
            Cdepth (4)   = 0.7692465
            Cdepth (5)   = 0.9530899
        ELSE
            DO K = 1,Layers
                Cdepth(K) =(K - 0.5) /Layers
            END DO
        ENDIF

        DO K = 1, Layers
        DO J = 1, NROWS
        DO I = 1, NCOLS
            LAIdepth = MIN( LAI(I,J) * Cdepth(K), 3.0 )
            CDEA(I,J,K) = CCD1 * LAIdepth + CCD2
        END DO
        END DO
        END DO

        RETURN

    END SUBROUTINE GAMMA_CD
    !----------------------------------------------------------------

    !----------------------------------------------------------------
    !
    !   FUNCTION GAMTLD
    !       EA Temperature response (light dependent emission)
    !----------------------------------------------------------------
    FUNCTION GAMTLD(T1,T24,S)

        IMPLICIT NONE
        REAL,PARAMETER :: Ct2 = 230
        INTEGER        :: S
        REAL           :: T1,T24,T240,Topt, X, Eopt, GAMTLD

        T240 = T24

        IF (T1 < 260.0) THEN
            GAMTLD = 0.0
        ELSE
            ! Temperature at which maximum emission occurs
            Topt = 312.5 + 0.6 * (T240 - 297.0)
            X    = ((1.0 / Topt) - (1.0 / T1)) / 0.00831
            ! Maximum emission (relative to emission at 30 C)
            Eopt = Cleo(S) * EXP(0.05 * (T24 - 297.0)) *          &
                  Exp(0.05*(T240-297.0))

            GAMTLD= Eopt * Ct2 * Exp(Ct1(S) * X) /                &
                  (Ct2 - Ct1(S) * (1.0 - EXP(Ct2 * X)))
        ENDIF

    END FUNCTION GAMTLD
    !----------------------------------------------------------------

    !----------------------------------------------------------------
    !
    !   FUNCTION GAMTLI
    !       EA Temperature response (light independent emission)
    !----------------------------------------------------------------


    FUNCTION GAMTLI(temp,S)

        IMPLICIT NONE

        REAL           :: temp, GAMTLI
        REAL,PARAMETER :: Ts = 303.15
        INTEGER        :: S

        GAMTLI = exp( beta(S)*(temp-Ts) )

    END FUNCTION GAMTLI
    !----------------------------------------------------------------


    !----------------------------------------------------------------
    !
    !   FUNCTION GAMP
    !       EA Light response
    !----------------------------------------------------------------

    FUNCTION GAMP(PPFD1,PPFD24)

        IMPLICIT NONE
        REAL            :: PPFD1, PPFD24, Alpha, C1, GAMP

        IF (PPFD24 < 0.01) THEN
            GAMP= 0.0
        ELSE
            Alpha  = 0.004
            !        C1     = 0.0468 * EXP(0.0005 * (PPFD24 - PSTD))
            !     &          * (PPFD24 ** 0.6)
            C1 = 1.03
            !        GAMP= (Alpha * C1 * PPFD1) / ((1 + Alpha**2. * PPFD1**2.)**0.5)
            
!   use SQRT her for clarity and efficiency
            
            GAMP= (Alpha * C1 * PPFD1) / SQRT(1.0 + Alpha**2 * PPFD1**2)
        ENDIF

    END FUNCTION GAMP

    !----------------------------------------------------------------
    !
    !   SUBROUTINE GAMMA_HT
    !   EA response to high temperature
    !
    !----------------------------------------------------------------

    SUBROUTINE GAMMA_HT(NCOLS, NROWS, S, MaxT, GAMHT)

        IMPLICIT NONE
        ! input
        INTEGER,INTENT(IN)                            :: NCOLS, NROWS, S
        REAL,DIMENSION(NCOLS,NROWS),INTENT(IN)        :: MaxT
        ! output
        REAL,DIMENSION(NCOLS,NROWS),INTENT(OUT)       :: GAMHT
        ! local
        INTEGER     :: I,J
        REAL        :: THTK, t1

        DO J = 1,NROWS
        DO I = 1,NCOLS
            THTK = 273.15 + THT(S)
            t1 = THTK + DTHT(S)
            IF (MaxT(I,J) <= THTK) THEN
                GAMHT(I,J) = 1.0
            ELSE IF ( MaxT(I,J) < t1) THEN
                GAMHT(I,J) = 1.0 + (CHT(S) - 1.0)* (MaxT(I,J) -  THTK)/DTHT(S)
            ELSE
                GAMHT(I,J) = CHT(S)
            ENDIF
        END DO
        END DO

        RETURN
    END SUBROUTINE GAMMA_HT
    !----------------------------------------------------------------

    !----------------------------------------------------------------
    !
    !   SUBROUTINE GAMMA_LT
    !   EA response to low temperature
    !
    !----------------------------------------------------------------

    SUBROUTINE GAMMA_LT(NCOLS, NROWS, S, MinT, GAMLT)

        IMPLICIT NONE
        ! input
        INTEGER,INTENT(IN)                       :: NCOLS, NROWS, S
        REAL,DIMENSION(NCOLS,NROWS),INTENT(IN)   :: MinT
        ! output
        REAL,DIMENSION(NCOLS,NROWS),INTENT(OUT)  :: GAMLT
        ! local
        INTEGER      :: I,J
        REAL         :: TLTK, t1

        DO J = 1,NROWS
        DO I = 1,NCOLS
            TLTK = 273.15 + TLT(S)
            t1 = TLTK - DTLT(S)
            IF (MinT(I,J) >= TLTK) THEN
                GAMLT(I,J) = 1.0
            ELSE IF ( MinT(I,J) > t1) THEN
                GAMLT(I,J) = 1.0 + (CLT(S) - 1.0)* (TLTK - MinT(I,J))/DTLT(S)
            ELSE
                GAMLT(I,J) = CLT(S)
            ENDIF
        END DO
        END DO

        RETURN
    END SUBROUTINE GAMMA_LT
    !----------------------------------------------------------------


    !----------------------------------------------------------------
    !
    !   SUBROUTINE GAMMA_HW
    !   EA response to high wind speed
    !
    !----------------------------------------------------------------

    SUBROUTINE GAMMA_HW(NCOLS, NROWS, S, MaxWS, GAMHW)

        IMPLICIT NONE
        ! input
        INTEGER,INTENT(IN)                        :: NCOLS, NROWS, S
        REAL,DIMENSION(NCOLS,NROWS),INTENT(IN)    :: MaxWS
        ! output
        REAL,DIMENSION(NCOLS,NROWS),INTENT(OUT)   :: GAMHW
        ! local
        INTEGER     :: I,J
        REAL        :: t1

        DO J = 1,NROWS
        DO I = 1,NCOLS
            t1 = THW(S) + DTHW(S)
            IF (MaxWS(I,J) <= THW(S)) THEN
                GAMHW(I,J) = 1.0
            ELSE IF ( MaxWS(I,J) < t1) THEN
                GAMHW(I,J) = 1.0 + (CHW(S) - 1.0)* (MaxWs(I,J) - THW(S))/ DTHW(S)
            ELSE
                GAMHW(I,J) = CHW(S)
            ENDIF
        END DO
        END DO

        RETURN
    END SUBROUTINE GAMMA_HW
    !----------------------------------------------------------------



    !----------------------------------------------------------------
    !
    !   SUBROUTINE GAMMA_AQ
    !   EA response to air quality
    !
    !----------------------------------------------------------------

    SUBROUTINE GAMMA_AQ(NCOLS, NROWS, S, AQI, GAMAQ)

        IMPLICIT NONE
        ! input
        INTEGER, INTENT(IN)                       :: NCOLS, NROWS, S
        REAL, DIMENSION(NCOLS,NROWS),INTENT(IN)   :: AQI
        ! output
        REAL, DIMENSION(NCOLS,NROWS),INTENT(OUT)   :: GAMAQ
        ! local
        INTEGER    :: I,J
        REAL       :: t1


        DO J = 1, NROWS
        DO I = 1, NCOLS
            t1 = TAQ(S) + DTAQ(S)
            IF (AQI(I,J) <= TAQ(S)) THEN
                GAMAQ(I,J) = 1.0
            ELSE IF ( AQI(I,J) < t1) THEN
                GAMAQ(I,J) = 1.0 + (CAQ(S) - 1.0)* (AQI(I,J) - TAQ(S))/DTAQ(S)
            ELSE
                GAMAQ(I,J) = CAQ(S)
            ENDIF
        END DO
        END DO

        RETURN
    END SUBROUTINE GAMMA_AQ
    !-----------------------------------------------------------------------

    !-----------------------------------------------------------------------
    !
    ! Subroutine GAMMA_CO2
    !-----------------------------------------------------------------------
    !From Alex Guenther 2017-03-11
    SUBROUTINE GAMMA_CO2( NCOLS, NROWS, GAMCO2 )

        IMPLICIT NONE

        INTEGER, INTENT(IN)                         :: NCOLS, NROWS
        REAL,DIMENSION(NCOLS,NROWS),INTENT(OUT)     :: GAMCO2

        ! local
        REAL    :: Ci, CO2temp, cxxx, cyyy
        INTEGER :: C, R

        CO2temp = CO2
        Ci      = 0.7 * CO2

        IF ( CO2 .EQ. 400.0 ) THEN
            GAMCO2 = 1.0
        ELSE
            DO R = 1, NROWS
            DO C = 1, NCOLS
!   set common factors for pipeline                 
            
                cxxx =  Ci**CO2h
                cyyy =  Cstar**CO2h
                
     !      GAMCO2 = ISmax- ((ISmax * Ci**CO2h ) / (Cstar**CO2h + Ci **CO2h))
                GAMCO2(C,R) = ISmax- ((ISmax * cxxx) / (cyyy + cxxx))
                
            END DO
            END DO
        END IF

        RETURN

    END SUBROUTINE GAMMA_CO2

    !-----------------------------------------------------------------------


    !-----------------------------------------------------------------------
    !
    ! Subroutine GAMMA_LAIbidir(gam_LAIbidir,LAI)
    !-----------------------------------------------------------------------
    !From Alex Guenther 2010-01-26
    !If lai < 2 Then
    !gammaLAIbidir= 0.5 * lai
    !ElseIf lai <= 6 Then
    !gammaLAIbidir= 1 - 0.0625 * (lai - 2)
    !Else
    !gammaLAIbidir= 0.75
    !End If
    !
    !     SUBROUTINE GAMMA_LAIbidir returns the gam_LAIbidir values
    !    Xuemei Wang-2010-01-28
    !
    !-----------------------------------------------------------------------
    SUBROUTINE GAMMA_LAIbidir(NCOLS, NROWS,LAI,GAMBD)

        IMPLICIT NONE
        ! input
        INTEGER,INTENT(IN)                          :: NCOLS, NROWS
        REAL,DIMENSION(NCOLS, NROWS),INTENT(IN)     ::  LAI

        ! output
        REAL,DIMENSION(NCOLS, NROWS),INTENT(OUT)    :: GAMBD

        ! local
        INTEGER                                     :: I,J

        DO J = 1, NROWS
        DO I = 1, NCOLS

            IF(LAI(I,J) < 2) THEN
                GAMBD(I,J) =  0.5 * LAI(I,J)
            ELSEIF (LAI(I,J) .LE. 6 ) THEN
                GAMBD(I,J) = 1 - 0.0625 * (LAI(I,J) - 2)
            ELSE
                GAMBD(I,J) = 0.75
            ENDIF

        END DO
        END DO

        RETURN
    END SUBROUTINE GAMMA_LAIbidir
    !----------------------------------------------------------------


    !----------------------------------------------------------------
    !
    !   SUBROUTINE GAMLA
    !
    !     EA leaf age response
    !----------------------------------------------------------------
    !
    !       GAMLA = Fnew*Anew + Fgro*Agro + Fmat*Amat + Fold*Aold
    !       where Fnew = new foliage fraction
    !             Fgro = growing foliage fraction
    !             Fmat = mature foliage fraction
    !             Fold = old foliage fraction
    !             Anew = emission activity for new foliage
    !             Agro = emission activity for growing foliage
    !             Amat = emission activity for mature foliage
    !             Aold = emission activity for old foliage
    !           Age class fractions are determined from LAI changes
    !             LAIc = current LAI
    !             LAIp = past LAI
    !             t  = length of the time step (days)
    !             ti = days between budbreak and emission induction
    !             tm = days between budbreak and peak emission
    !             Tt = average above canopy temperature (K)
    !
    !----------------------------------------------------------------

    SUBROUTINE GAMMA_A( NCOLS, NROWS, S,                      &
          LAIp, LAIc, D_TEMP, GAMLA )

        USE RUNTIME_VARS, ONLY: USE_MEGAN_LAI

        IMPLICIT NONE
 ! input
        INTEGER,INTENT(IN)                       :: NCOLS,NROWS, S
        REAL,DIMENSION(NCOLS,NROWS),INTENT(IN)   :: D_TEMP, LAIp, LAIc
 ! output
        REAL,DIMENSION(NCOLS,NROWS),INTENT(OUT)  :: GAMLA

        INTEGER :: C, R

        REAL :: Fnew, Fgro, Fmat, Fold
        REAL :: ti,tm
        REAL :: Tt

        REAL       :: TSTLEN  

        !Time step of LAI data
        if (USE_MEGAN_LAI) THEN
          TSTLEN = 8.0 ! 8 daily from MEGAN file
        else
          TSTLEN = 1.0 ! 1 Daily from soilout/metcro
        end if

        !---------------------------------------------------
        ! local parameter arrays
        
        DO R = 1, NROWS
        DO C = 1, NCOLS

            Tt = D_TEMP(C,R)

            !... Calculate foliage fraction

            IF (LAIp(C,R) .LT. LAIc(C,R)) THEN

                !        Calculate ti and tm
                IF (Tt .LE. 303.0) THEN
                    ti = 5.0 + 0.7*(300-Tt)
                ELSE
                    ti = 2.9
                END IF
                tm = 2.3*ti

                !       Calculate Fnew and Fmat, then Fgro and Fold
                !       Fnew
                IF (ti .GE. TSTLEN) THEN
                    Fnew = 1.0 - (LAIp(C,R)/LAIc(C,R))
                ELSE
                    Fnew = (ti/TSTLEN) * ( 1-(LAIp(C,R)/LAIc(C,R)) )
                END IF

                !       Fmat
                IF (tm .GE. TSTLEN) THEN
                    Fmat = LAIp(C,R)/LAIc(C,R)
                ELSE
                    Fmat = (LAIp(C,R)/LAIc(C,R)) +                             &
                          ( (TSTLEN-tm)/TSTLEN ) * ( 1-(LAIp(C,R)/LAIc(C,R)) )
                END IF

                Fgro = 1.0 - Fnew - Fmat
                Fold = 0.0

            ELSE IF (LAIp(C,R) .EQ. LAIc(C,R)) THEN

                Fnew = 0.0
                Fgro = 0.1
                Fmat = 0.8
                Fold = 0.1

            ELSE IF (LAIp(C,R) .GT. LAIc(C,R)) THEN

                Fnew = 0.0
                Fgro = 0.0
                Fold = ( LAIp(C,R)-LAIc(C,R) ) / LAIp(C,R)
                Fmat = 1-Fold

            END IF

            !...  Calculate GAMLA
            GAMLA(C,R) = Fnew*Anew(S) + Fgro*Agro(S) + Fmat*Amat(S) + Fold*Aold(S)
        
        END DO
        END DO

        RETURN
    END SUBROUTINE GAMMA_A

!   subroutines used by MEGSEA

!=======================================================================
!=======================================================================
      REAL FUNCTION FERTLZ_ADJ( DATE, LAT )

!***********************************************************************
!  DESCRIPTION:
!    This internal function computes a fertilizer adjustment factor
!    for the given date in yyyyddd format. If it is not growing 
!    season, the adjustment factor is 0; otherwise, it ranges from
!    0.0 to 1.0.
!
!  CALL:
!    GROWSEASON
!
!  HISTORY:
!    07/21/11 : Imported from SMOKE-BEIS v3.14 and modified  (Tan)
!***********************************************************************

      IMPLICIT NONE
            
!.... Function arguments
      INTEGER, INTENT(IN) :: DATE
      REAL,    INTENT(IN) :: LAT

!.... Local variables
      INTEGER  GDAY, GLEN

      CHARACTER(256)  MESG         ! message buffer
!-----------------------------------------------------------------------------

      CALL GROWSEASON( DATE, LAT, GDAY, GLEN )
          FERTLZ_ADJ = 0. !INITIALIZE
      IF( GDAY == 0 ) THEN
          FERTLZ_ADJ = 0.
      ELSE IF( GDAY >= 1 .AND. GDAY < 30 ) THEN
          ! first month of growing season
          FERTLZ_ADJ = 1.
      ELSE IF( GDAY >= 30 .AND. GDAY <= 366) THEN
          ! later month of growing season
          FERTLZ_ADJ = 1. + 30. / FLOAT(GLEN) - FLOAT(GDAY) / FLOAT(GLEN)
      ENDIF

!******************  FORMAT  STATEMENTS   ******************************
94010 FORMAT( A, F10.2, 1X, A, I3, ',', I3 )


      RETURN

      END FUNCTION FERTLZ_ADJ
!=======================================================================
!=======================================================================


!=======================================================================
!=======================================================================
      REAL FUNCTION VEG_ADJ( LAI )

!***********************************************************************
!  DESCRIPTION
!    This internal function computes a vegetation adjustment factor
!    based on LAIv.  See Yienger and Levy 1995
!    VEG_ADJ = (EXP(-0.24*LAIv)+EXP(-0.0525*LAIv))*0.5 
!
!  CALL
!    NONE
!
!  HISTORY:
!***********************************************************************

      IMPLICIT NONE
      
!...  Function arguments
      REAL,    INTENT(IN) :: LAI

!-----------------------------------------------------------------------------
      VEG_ADJ = 0.0
      VEG_ADJ = (EXP(-0.24*LAI)+EXP(-0.0525*LAI))*0.5 

!******************  FORMAT  STATEMENTS   ******************************

      RETURN
      END FUNCTION VEG_ADJ
!=======================================================================
!=======================================================================
            


!=======================================================================
!=======================================================================

!=======================================================================
!=======================================================================
      SUBROUTINE GROWSEASON ( DATE, LAT, GDAY, GLEN )

!***********************************************************************
!  DESCRIPTION
!    This internal function computes the day of the growing season
!    corresponding to the given date in yyyyddd format.
!
!  CALL
!    G2J
!
!  HISTORY:
!    07/21/11 : Imported from SMOKE-BEIS v3.14 and modified  (Tan)
!               Variation of growing season depends on latitude
!               (Guenther)
!    04/22/2019 Converted to 90 format and redid error repotring
!               modified G2j to be completely internal. 
!               DR. FRANCIS S. BINKOWSKI, IE, UNC-CHAPEL HILL
!***********************************************************************

      IMPLICIT NONE

!.......  Function arguments
      INTEGER, INTENT(IN)  :: DATE
      REAL,    INTENT(IN)  :: LAT
      INTEGER, INTENT(OUT) :: GDAY, GLEN 
!.......  External functions

!.......  Local parameters
      INTEGER            :: GSEASON_START
      INTEGER            :: GSEASON_END

!.......  Local variables
      INTEGER  YEAR, MONTH, DAY
      INTEGER  JDAY
      INTEGER  GSJULIAN_START
      INTEGER  GSJULIAN_END
!-----------------------------------------------------------------------------
!   NOTE: The use of "julian Day" to describe the day of tHE year is
!     technically incorrect. 

 ! The Julian Day Number (JDN) is the integer assigned to a whole solar 
 ! day in the Julian day count starting from noon Universal time, with 
 ! Julian day number 0 assigned to the day starting at noon on Monday, 
 ! January 1, 4713 BCE, proleptic Julian calendar (November 24, 4714 BCE, 
 ! in the proleptic Gregorian calendar), a date at which three 
 ! multi-year cycles started (which are: Indiction, Solar, and Lunar cycles)
 !  and which preceded any dates in recorded history. 
 !
 !  For example for January 1st, 2000 CE  at 00:00:00.0 UT1 the Julian Day 
 !  is 2451544.500000 according to  the U.S. Naval Observatory.



      YEAR = INT( FLOAT( DATE ) / 1000. )
      JDAY = DATE - YEAR * 1000

      IF ( LAT .LE. 23.0 .AND. LAT .GE. -23.0 ) THEN
      ! tropical regions, year round
         GSEASON_START = 0101
         GSEASON_END   = 1231

         GSJULIAN_START = G2J(YEAR, GSEASON_START)
         GSJULIAN_END   = G2J(YEAR, GSEASON_END)
         GDAY = JDAY - GSJULIAN_START + 1
         GLEN = GSJULIAN_END - GSJULIAN_START + 1
      ELSE IF ( LAT .LT. -23.0 ) THEN
      ! southern hemisphere
         IF ( LAT .LT. -60.0 ) THEN
         ! antarctic start = 0 end = 0, no growing
            GDAY = 0
            GLEN = 0
         ELSE
         ! southern hemisphere temperate, NOV, DEC, JAN-MAY
            IF (JDAY .GE. 1101 .AND. JDAY .LE. 1231 ) THEN
              GSEASON_START = 1101
              GSEASON_END   = 1231

              GSJULIAN_START = G2J(YEAR, GSEASON_START)
              GSJULIAN_END   = G2J(YEAR, GSEASON_END)
              GDAY = JDAY - GSJULIAN_START + 1
            ELSE IF (JDAY .GE. 0101 .AND. JDAY .LE. 0531) THEN
              GSEASON_START = 0101
              GSEASON_END   = 0531

              GSJULIAN_START = G2J(YEAR, GSEASON_START)
              GSJULIAN_END   = G2J(YEAR, GSEASON_END)
              GDAY = JDAY - GSJULIAN_START + 1 + 61
            ELSE
              GDAY = 0
            ENDIF
            GLEN = 30 + 31 + G2J(YEAR,0531) - G2J(YEAR,0101) + 1

         ENDIF
      ELSE IF ( LAT .GT. 23.0 ) THEN
      ! northern hemisphere
         IF ( LAT .GT. 65.0 ) THEN
         ! arctic start = 0 end = 0, no growing season
            GDAY = 0
            GLEN = 0
         ELSE
         ! northern hemisphere temperate
         ! start= (lat-23)*4.5            189
         ! end = 365 -((lat-23)*3.3)      226
            GSEASON_START = 0
            GSEASON_END   = 1231

            GSJULIAN_START = 0
            GSJULIAN_END   = G2J(YEAR, GSEASON_END)

            GSJULIAN_START = INT( (LAT-23.0) * 4.5 )
            GSJULIAN_END   = GSJULIAN_END - INT( (LAT-23.0) * 3.3 )
            
            ! UNC added to avoid GDAY excede 366
            IF ( JDAY == 366 .AND. GSJULIAN_START==0 ) GSJULIAN_END = GSJULIAN_END - 1
                        
            IF (JDAY .GE. GSJULIAN_START .AND. JDAY .LE. GSJULIAN_END) THEN
               GDAY = JDAY - GSJULIAN_START + 1
            ELSE
               GDAY = 0
            ENDIF
            GLEN = GSJULIAN_END - GSJULIAN_START + 1
         ENDIF
      ENDIF
  
     RETURN

      END SUBROUTINE GROWSEASON

!=======================================================================
!=======================================================================
      
!   This is a modified version of function G2J.

      
      INTEGER FUNCTION G2J( YYYY, MMDD )
      IMPLICIT NONE

!.......  Function arguments
      INTEGER, INTENT(IN) :: YYYY
      INTEGER, INTENT(IN) :: MMDD


!.......  Local parameters
      INTEGER :: MM
      INTEGER :: DD
      INTEGER :: K
      INTEGER :: DOY
      LOGICAL :: LEAP


      MM = INT( FLOAT( MMDD ) / 100.0 )
      DD = MMDD - MM * 100

!   use internal code to get G2j

 !     G2J = JULIAN( YYYY, MM , DD )

!   The following code is taken from NASA subroutine get_DOY 
! Original  Programmer:   David G. Simpson
!            NASA Goddard Space Flight Center
!            Greenbelt, Maryland  2077  Date:         November 20, 2001
!  Modified April 13, 2019 by Dr Francis S. Binkowski to do only Gregorian years


          LEAP = .FALSE.
      
!   TEST FOR LEAP YEARS
      
      IF ( MOD(YYYY,4)   .EQ. 0) LEAP = .TRUE.
      IF ( MOD(YYYY,100) .EQ. 0) LEAP = .FALSE.
      IF  (MOD(YYYY,400) .EQ. 0) LEAP = .TRUE.

      IF (LEAP) THEN
         K = 1
      ELSE
         K = 2
      END IF

!   CALCULATE DAY OF THE YEAR

      DOY = ( ( 275 * MM) / 9 ) - K * ( ( MM + 9) / 12 ) + DD - 30
      
      G2J = DOY  

      END FUNCTION G2J

!=======================================================================



      SUBROUTINE SOILNOX( JDATE, JTIME, NX, NY,            &
                      TA, LSOIL, ISLTYP, SOILM, SOILT,     &
                      LAIc, LAT,                           &
                      PRECADJ,                             &
                      CFNO, CFNOG )

!***********************************************************************
!  DESCRIPTION:
!  
!     Uses new NO algorithm NO = Normalized*Tadj*Padj*Fadj*Cadj
!     to estimate NO emissions 
!     Information needed to estimate NO emissions
!     Julian Day          (integer)    JDATE
!     Surface Temperature (MCIP field) TA    (K)
!     Soil Moisture       (MCIP field) SOILM (M**3/M**3) (LSOIL)
!          (ratio of volume of water per volume of soil)
!     Soil Temperature    (MCIP field) SOILT (K)         (LSOIL)
!     Soil Type           (MCIP field) ISLTYP            (LSOIL)
!
!     saturation values for soil types (constants)       (LSOIL)
!     FOR PX Version, the Temperature adjustment factor accounts for wet and dry soils
!                and  the precipitation adjustment factor accounts for saturated soils
!     FOR the non-PX version, the basic algorithm remains with a temperature adjustment factor (dry soil)
!                     and no adjustment for saturated soils
!
!
!     The following arrays are updated after each call to SOILNOX
!     PULTYPE   type of NO emission pulse 
!     PULSEDATE julian date for the beginning of an NO pulse 
!     PULSETIME        time for the beginning of an NO pulse
!  
!     The calculation are based on the following paper by J.J. Yienger and H. Levy II
!     J.J. Yienger and H. Levy II, Journal of Geophysical Research, vol 100,11447-11464,1995
!
!     The Temperature Adjustment Factor is based on section 4.2 for wet and dry soils with
!       the following modification (PX version):
!       Instead of classifying soils as either 'wet' or 'dry', the wet and dry adjustment is 
!       calculated at each grid cell.  A linear interpolation between the wet and dry adjustment
!       factor is made using the relative amount of soil moisture in the top layer (1cm)
!       as the interpolating factor.  The relative amount of soil moisture is determined by
!       taking the MCIP soil moisture field and dividing by the saturation value defined for each
!       soil type in the PX version of MCIP
!       the soil temperature is used in PX version
!
!     The Precipation Adjustment factor is based on section 4.1 with the following modifications.
!       The rainrate is computed from the MCIP directly using a 24 hr daily total. 
!       THe types of Pulses as described in YL95 were used to estimate the NO emission
!       rate.  
!
!    Also see the following paper for more information:
!    Proceedings of the Air and Waste Management Association/U.S. Environmental Protection
!    Agency EMission Inventory Conference, Raleigh October 26-28, 1999 Raleigh NC
!    by Tom Pierce and Lucille Bender       
!
!    REFERENCES
!
!    JACQUEMIN B. AND NOILHAN J. (1990), BOUND.-LAYER METEOROL., 52, 93-134.
!    J.J. Yienger and H. Levy II, Journal of Geophysical Research, vol 100,11447-11464,1995
!    T. Pierce and L. Bender, Examining the Temporal Variability of Ammonia and Nitric Oxide Emissions from Agricultural Processes
!       Proceedings of the Air and Waste Management Association/U.S. Environmental Protection
!        Agency EMission Inventory Conference, Raleigh October 26-28, 1999 Raleigh NC
!
!  PRECONDITIONS REQUIRED:
!     Normalized NO emissions, Surface Temperature, Soil Moisture, Soil type,
!     NO emission pulse type, soil moisture from previous time step, julian date
!     of NO emission pulse start, time of NO emission pulse start,
!     soil type, SOIL TYPES, Land use data
!
!  SUBROUTINES AND FUNCTIONS CALLED (directly or indirectly):
!     FERTILIZER_ADJ computes fertlizer adjustment factor
!     VEG_ADJ        computes vegatation adjustment factor
!     GROWSEASON     computes day of growing season
!     
!  REVISION  HISTORY:
!    10/01 : Prototype by GAP
!    10/03 : modified transition to non growing season for jul-oct of the year
!    08/04 : Converted to SMOKE code style by C. Seppanen
!    07/21/11 : Imported form SMOKE-BEIS v3.14 for MEGAN v2.10
!    MAY 13, 2019 made inot f90 format and  improved efficiency - 
! 
!***********************************************************************

!        USE SOILNOX_FX

        IMPLICIT NONE
        

!.........  ARGUMENTS and their descriptions
        INTEGER, INTENT (IN)  :: JDATE   !  current simulation date (YYYYDDD)
        INTEGER, INTENT (IN)  :: JTIME   !  current simulation time (HHMMSS)
        INTEGER, INTENT (IN)  :: NX      !  no. columns
        INTEGER, INTENT (IN)  :: NY      !  no. rows

        REAL, INTENT (IN)  ::  TA      ( NX, NY )    !  air temperature (K)
        REAL, INTENT (IN)  ::  SOILM   ( NX, NY )    !  soil moisture (m3/m3)
        REAL, INTENT (IN)  ::  SOILT   ( NX, NY )    !  soil temperature (K)
        REAL, INTENT (IN)  ::  PRECADJ ( NX, NY )    !  precip adjustment
        REAL, INTENT (IN)  ::  LAIc    ( NX, NY )    !  soil temperature (K)
        REAL, INTENT (IN)  ::  LAT     ( NX, NY )    !  Latitude
        REAL, INTENT (IN OUT)  ::  CFNO    ( NX, NY )    !  NO correction factor
        REAL, INTENT (IN OUT)  ::  CFNOG   ( NX, NY )    !  NO correction factor for grass
        
        INTEGER, INTENT (IN)  ::  ISLTYP  ( NX, NY )    !  soil type

        LOGICAL, INTENT (IN) :: LSOIL              ! true: using PX version of MCIP
        
!.........  Local ARRAYS
! Saturation values for 11 soil types from pxpbl.F  (MCIP PX version)
!       PLEIM-XIU LAND-SURFACE AND PBL MODEL (PX-LSM)
! See JACQUEMIN B. AND NOILHAN J. (1990), BOUND.-LAYER METEOROL., 52, 93-134.
        INTEGER, PARAMETER :: MAXSTYPES = 16
!        REAL, PARAMETER    :: SATURATION( MAXSTYPES )     =  (/   &       
!                              0.395, 0.410, 0.435, 0.485,         &
!                              0.451, 0.420, 0.477, 0.476,         &
!                              0.426, 0.482, 0.482            /)       

!.........  SCRATCH LOCAL VARIABLES and their descriptions:
        INTEGER       ::   R, C, L      ! counters
        INTEGER       ::   SOILCAT      ! soil category
        
        REAL          ::   CF           ! NO correction factor
        REAL          ::   CFG          ! NO correction factor for grasslands
        REAL          ::  TAIR         ! surface temperature
        REAL          ::   TSOI         ! soil temperature
        REAL          ::   CFNOWET, CFNODRY, RATIO, FAC1, FAC2 
        REAL, PARAMETER ::  const1 = (1. / 3.0 )  * (1.0 / 30.0)
        REAL, PARAMETER ::  const2 =EXP(-0.103 * 30.0)
        CHARACTER(256)  MESG         ! message buffer
        
        CHARACTER(16) :: PROGNAME = 'SOILNOX'   !  program name

!***********************************************************************

 
!.....  Loop through cells
        DO R = 1, NY
        DO C = 1, NX

          TAIR = TA( C, R )         ! unit in degree K

!.......  Check max bounds for temperature

          IF (TAIR > 315.0 ) THEN
              TAIR = 315.0
          END IF

!.......  CFNOG
          IF( TAIR > 303.00 ) TAIR = 303.00

          IF ( TAIR > 268.8690 ) THEN  
              CFG = EXP( 0.04686 * TAIR - 14.30579 ) ! grass (from BEIS2)
          ELSE
              CFG = 0.0
          END IF

          CFNOG(C,R) = CFG
          
!   pre calculate common factors


              FAC2 = const2

!.......  CFNO
          IF( .NOT. LSOIL ) THEN
          ! no soil

             TSOI = 0.72 * TAIR + 82.28
             IF (TSOI <= 273.16) TSOI = 273.16
             IF (TSOI >= 303.16) TSOI = 303.16
             
              FAC1 = (TSOI- 273.16)

             
              
!             CFNODRY = (1./3.) * (1./30.) * (TSOI-273.16)  ! see YL 1995 Equa 9a p. 11452             
              CFNODRY = const1 * FAC1  ! see YL 1995 Equa 9a p. 11452
            
             IF (TSOI <= 283.16) THEN         ! linear cold case
!                 CFNOWET = (TSOI-273.16)*EXP(-0.103*30.0)*0.28 ! see YL 1995 Equ 7b
                 CFNOWET =  FAC1 * FAC2 * 0.28 ! see YL 1995 Equ 7b
                 
             ELSE                             ! exponential case
!                 CFNOWET = EXP(0.103 * (TSOI-273.16)) *  EXP(-0.103 * 30.0)
                 CFNOWET = EXP(0.103 * FAC1) *  FAC2
             END IF
             CF = 0.5 * CFNOWET + 0.5 * CFNODRY

          ELSE
          ! soil

             TSOI = SOILT( C,R )
             IF (TSOI <= 273.16) TSOI = 273.16
             IF (TSOI >= 303.16) TSOI = 303.16

              FAC1 = (TSOI- 273.16)

!             CFNODRY = (1./3.)*(1./30.)*(TSOI-273.16)  ! see YL 1995 Equa 9a p. 11452
             CFNODRY = const1 * FAC1  ! see YL 1995 Equa 9a p. 11452
                          
             IF (TSOI <= 283.16) THEN         ! linear cold case
!                CFNOWET = (TSOI-273.16)*EXP(-0.103*30.0)*0.28 ! see YL 1995 Equ 7b
                CFNOWET = FAC1 * FAC2 * 0.28 ! see YL 1995 Equ 7b
                
             ELSE                             ! exponential case
!                CFNOWET = EXP(0.103 * (TSOI-273.16)) * EXP(-0.103 * 30.0)
                 CFNOWET = EXP(0.103 * FAC1 ) * FAC2
               
             END IF

             SOILCAT = INT( ISLTYP( C,R ) )
             IF( SOILCAT > 0 .AND. SOILCAT <= MAXSTYPES ) THEN
                 IF(Grid_Data%WSAT(C,R) .eq. 0) THEN
                  ! first ldesid diag call. Do nothing.
                  CF = 0. 
                 ELSE 
                  RATIO = SOILM( C,R ) / Grid_Data%WSAT( C,R )
                  CF = RATIO*CFNOWET + (1.0 - RATIO ) * CFNODRY
                 END IF
             ELSE
             
                 CF = 0.0
                 
             END IF

          END IF  ! Endif LSOIL


!          CFNO(C,R) = CF *                                      &
!                     FERTLZ_ADJ( JDATE, LAT(C,R) ) *           &
!                     VEG_ADJ( LAIc(C,R) ) * PRECADJ(C,R)

          CFNO(C,R) = CF *                                     &
                     FERTLZ_ADJ( JDATE, LAT(C,R) ) *           &
                     VEG_ADJ( LAIc(C,R) ) * PRECADJ(C,R)

          if(cfno(c,r) .lt. 0) then
             cfno(c,r) = 0
          end if

        END DO  ! loop over columns
        END DO  ! loop over rows

        RETURN

        END SUBROUTINE SOILNOX
        
! ///////////////////////////////////////////////////////////////////////////        
        
      SUBROUTINE MEGCANOPY(  YEAR, LAYERS, DOY, ZTIME,     &
                 LAT, LONG, LAIc, TEMP, PAR, WIND, PRES, QV, CTF,        &
                 ShadeleafTK, SunleafTK, SunFrac, SunPPFD, ShadePPFD  )        !

! ----------------------------------------------------------------------------
!   START subroutine MEGCANOPY
!     Coded March 19, 2019 by Dr. Francis S. Binkowski
!     modifies 05/07/2019 by   to correct loop order
!     Institue for the Environment UNC, Chapel Hill

!   Based upon 	PROGRAM MEGCAN

!   Based on code initiated by Alex Guenther in 1990s
!   Coded in FORTRAN by Xuemei Wang--Nov. 2007
!   Revised by Alex Guenther and Ling Huang in Feb 2017
!   to correct, modify, and update the code and make it
!   a stand-alone program
!
!*****************************************************************
!
!*****************************************************************
!   Input varibles
!   
!   NROWs, NCOLS         grid location
!   LAYERS               number of vertical layers in canopy
!   DOY                  day of the year
!   Lat                  Latitude
!   Long                 Longitude
!   ZTIME                Hour of the day (UTC/GMT)
!   TEMP                 Temperature [K]
!   PAR                  Photosynthetically active radiation [ W/m**2]
!   Wind                 Wind speed [m s-1]
!   Humidity             Relative humidity [%]
!   Cantype              Defines set of canopy characteristics
!   LAI                  Leaf area index [m2 per m2 ground area]
!   Pres                 Pressure [Pa]
!
!*****************************************************************
! Variables used
!   PPFD           Incoming photosynthetic active radiation [umol/m2/s1]
!   PPFDfrac             Fraction of solar radiation that is PPFD
!   Solar                Solar radiation [W/m2]
!   Maxsolar             Maximum of solar radiation
!   Sinbeta              Sine of solar angle above horizon
!   Beta                 Solar angle above horizon
!   TairK0               Above canopy air temperature [K]
!   TairK                Array of canopy air temperature [K]
!   Ws0                  Above canopy wind speed [m/s]
!   Ws                   Array of canopy wind speed [m/s]
!   HumidairPA0          Above canopy ambient humidity [Pa]
!   HumidairPa           Array of canopy ambient humidity in [Pa]
!   Transmis             Transmission of PPFD that is diffuse
!   Difffrac             Fraction of PPFD that is diffuse
!   PPFDfrac             Fraction of solar rad that is PPFD
!   Trate			   temperature vertical profile
!   QbAbsV, QbAbsN       Absorbed direct beam visible/near IR
!   QdAbsV, QdAbsN       Absorbed diffuse visible/near IR
!   QsAbsV, QsAbsN       Absorbed scattered visible//near IR
!   QBeamV, QBeamN       Above canopy direct beam visible/near IR
!   QDiffV, QDiffN       Above canopy diffuse visible/near IR
!
! Arrays with values for each canopy layer (vertical profile)
!   SunleafSH            sensible heat flux for sun leaves [W/m2]
!   SunleafLH            latent heat flux for sun leaves [W/m2]
!   SunleafIR            infrared flux for sun leaves [W/m2]
!   ShadeleafSH          sensible heat for shade leaves [W/m2]
!   ShadeleafLH          latent heat flux for shade leaves [W/m2]
!   ShadeleafIR          infrared flux for shade leaves [W/m2]
!   VPgausDis            gaussian weighting factors for distance
!   SunQv                visible radiation on sun leaves
!   ShadeQv              visible radiation on shade leaves
!   SunQn                near IR radiation on sun leaves
!   ShadeQn              near IR radiation on shade leaves
!   sun_ppfd             Array of incoming (NOT absorbed) PPFD on a sun leaf [umol/m2/s]
!   shade_ppfd           Array of incoming (NOT absorbed) PPFD on a shade leaf [umol/m2/s]
!   sun_tk               Array of leaf temperature for sun leaves [K]
!   shade_tk             Array of leaf temperature for shade leaves [K]
!   sun_frac             Array of the fraction of sun leaves. i = 1 is the top canopy layer, 2 is the next layer, etc.

!*****************************************************************
! OUTPUT
! For each time step and location
! Each variable is an array with a value for each canopy layer
!			       (vertical profile)
! i = 1 is the top canopy layer, 2 is the next layer down , etc.
!   ShadeleafTK          leaf temperature for shade leaves [K] (weighted by canopy type)
!   SunleafTK            leaf temperature for sun leaves [K] (weighted by canopy type)
!   SunFrac              fraction of sun leaves (weighted by canopy type)
!   SunPPFD              PPFD on a sun leaf [umol/m2/s] (weighted by canopy type)
!   ShadePPFD            PPFD on a shade leaf [umol/m2/s] (weighted by canopy type)
!
!*****************************************************************
! FUNCTION S
!   Calcbeta             Calculation of solar zenith angle
!   WaterVapPres         Convert water mixing ratio (kg/kg) to water vapor
!   pressure
!   Stability            Temperature lapse rate in canopy
!   get_BETA             solar position 

 !         
      IMPLICIT NONE
     
     
!   INPUT VARIABLES

       INTEGER, INTENT(IN)   :: LAYERS
       REAL, INTENT(IN)      :: YEAR
       REAl, INTENT(IN)      :: DOY
       REAL, INTENT(IN)      :: ZTIME
       REAL, INTENT(IN)      :: LAT ( NCOLS, NROWS )     
       REAL, INTENT(IN)      :: LONG( NCOLS, NROWS )   
       REAL, INTENT(IN)      :: LAIc( NCOLS, NROWS )
       REAL, INTENT(IN)      :: TEMP( NCOLS, NROWS )    
       REAL, INTENT(IN)      :: PAR ( NCOLS, NROWS ) ! comes in as rgrnd from ASX
       REAL, INTENT(IN)      :: WIND( NCOLS, NROWS )
       REAL, INTENT(IN)      :: PRES( NCOLS, NROWS )
       REAL, INTENT(IN)      :: QV  ( NCOLS, NROWS )
       REAL, INTENT(IN)      :: CTF(NrTyp, NCOLS, NROWS ) ! Canopy type factor array

!   OUTPUT VARIABLES 

       REAL, INTENT(OUT)     ::  ShadeleafTK ( NCOLS, NROWS, LAYERS ) 
       REAL, INTENT(OUT)     ::  SunleafTK   ( NCOLS, NROWS, LAYERS ) 
       REAL, INTENT(OUT)     ::  SunFrac     ( NCOLS, NROWS, LAYERS ) 
       REAL, INTENT(OUT)     ::  SunPPFD     ( NCOLS, NROWS, LAYERS ) 
       REAL, INTENT(OUT)     ::  ShadePPFD   ( NCOLS, NROWS, LAYERS ) 

!   LOCAL VARIABLES
      INTEGER                :: I, I_CT, J, MM, DD
      INTEGER                :: IDAY         ! For using original solar method

      REAL                   :: PPFD(NCOLS, NROWS) 
      REAL                   :: TotalCT
      REAL                   :: month, Date, JDAY
      REAL                   :: Sinbeta, Beta, HOUR, DAY
      REAL,DIMENSION(LAYERS) ::  VPgausWt, VPgausDis2,             &
       VPgausDis, VPslwWT,  QdAbsV, QsAbsV, QdAbsn,                &
       QsAbsn, SunQv, ShadeQv, SunQn, ShadeQn,                     &
       TairK, HumidairPa, Ws, SunleafSH, sun_ppfd,shade_ppfd,      &           
       SunleafLH,SunleafIR, ShadeleafSH, sun_tk,shade_tk,sun_frac, &
       ShadeleafLH,ShadeleafIR, sun_ppfd_total, shade_ppfd_total,  &
      sun_tk_total, shade_tk_total, sun_frac_total
  
      REAL :: Solar, Maxsolar, Eccentricity,                       &
              Difffrac, PPFDfrac, QbAbsn,                          &                 
               Trate, Qbeamv,Qdiffv, Qbeamn, Qdiffn,               &
               QbAbsV,Ea1tCanopy, Ea1pCanopy,                      &                 
               TairK0, HumidairPa0, Ws0, SH                         
                       
!      REAL ::  CalcEccentricity,WaterVapPres,                      &      
!               Stability, Calcbeta



!   Start code        

!   calculate the date from Year and day of the year 

      call get_date(YEAR, DOY, MM, DD)
      MONTH = MM ! conver to REAL
      DATE  = DD ! conver to REAL
!   Get authentic  Julian Day Number

      JDAY =  getJD (YEAR,MONTH,Date)
    
       DAY  = DOY 
 
       ppfd=par*4.5*0.45 ! ppfd = par * 4.5
                         ! par = rgrnd * 0.45 

          DO I=1, NCOLS
           DO J=1, NROWS
            SunleafTK(I,J,:)   = TEMP(I,J)
            ShadeleafTK(I,J,:) = TEMP(I,J)
            SunPPFD(I,J,:)     = PPFD(I,J)
            ShadePPFD(I,J,:)   = PPFD(I,J)
            SunFrac(I,J,:)     = 1.0
            TotalCT           = 0.0
            DO I_CT = 1,NRTYP   !canopy types
              TotalCT = TotalCT + CTF(I_CT,I,J) * 0.01
            ENDDO   ! ENDDO I_CT

            IF (TotalCT .GT. 0.0 .AND. LAIc(I,J) .GT. 0.0) THEN
!           only invoke canopy model when both CT and LAI are valid

              sun_ppfd_total     = 0.0
              shade_ppfd_total   = 0.0
              sun_tk_total       = 0.0
              shade_tk_total     = 0.0
              sun_frac_total     = 0.0

              DO I_CT = 1,NRTYP   !canopy types
                IF (CTF(I_CT,I,J) .NE. 0.0) THEN
                sun_ppfd           = 0.0
                shade_ppfd         = 0.0
                sun_tk             = 0.0
                shade_tk           = 0.0
                sun_frac           = 0.0
!            Convert from XXXXXX format to XX.XX (solar hour)
!            HOUR = 0 -> 23.xx
!            Solar hour
               Hour  = ZTIME + LONG(I,J) / 15.0

                IF ( Hour  .LT. 0.0 ) THEN
                  Hour  = Hour  + 24.0
                  Day  = Doy  - 1
                ELSEIF ( Hour  .GT. 24.0 ) THEN
                  Hour  = Hour  - 24.0
                  Day  = Doy  + 1
                ENDIF
!            Solar angle
                Beta   = Calcbeta(Day , Lat(I,J) , Hour )
                Sinbeta    = SIN(Beta  / 57.29578)
                TairK0     = TEMP(I,J)
                Ws0        = WIND(I,J)
!               Solar      = PPFD(I,J)/ConvertWm2toUmolm2s*2
                Solar      = PPFD(I,J)/2.25
                Maxsolar   = Sinbeta  * SolarConstant * CalcEccentricity(Day )
                Call GaussianDist(VPgausDis, Layers)
                Call SolarFractions(Solar, Maxsolar, Qdiffv,Qbeamv,Qdiffn,Qbeamn) 
                Call CanopyRad(VPgausDis, Layers, LAIc(I,J), Sinbeta, Qbeamv, &
                    Qdiffv, Qbeamn, Qdiffn,I_CT ,Canopychar, sun_frac,&
                    QbAbsV, QdAbsV, QsAbsV, QbAbsn, QdAbsn, QsAbsn, SunQv,&
                    ShadeQv, SunQn, ShadeQn, sun_ppfd, shade_ppfd,&
                    NrCha,NrTyp)

                 HumidairPa0  =  WaterVapPres(QV(I,J), PRES(I,J), WaterAirRatio)
                 Trate    =  Stability(Canopychar, I_CT, Solar , NrCha, NrTyp)
                 Call CanopyEB(Trate, Layers, VPgausDis, Canopychar, I_CT,&
                              TairK, HumidairPa, Ws, sun_ppfd,&
                              shade_ppfd, SunQv, ShadeQv, SunQn, ShadeQn,&
                              sun_tk, SunleafSH, SunleafLH, SunleafIR,&
                              shade_tk,ShadeleafSH,ShadeleafLH,ShadeleafIR,&
                              NrCha, NrTyp, Ws0, TairK0, HumidairPa0)
                     sun_ppfd_total(:)   = sun_ppfd_total(:) + &
                                     0.01*CTF(I_CT,I,J)*sun_ppfd(:)
                     shade_ppfd_total(:) = shade_ppfd_total(:) +&
                                     0.01*CTF(I_CT,I,J)*shade_ppfd(:)
                     sun_tk_total(:)     = sun_tk_total(:) +&
                                     0.01*CTF(I_CT,I,J)*sun_tk(:)
                     shade_tk_total(:)   = shade_tk_total(:) +& 
                                     0.01*CTF(I_CT,I,J)*shade_tk(:)
                     sun_frac_total(:)   = sun_frac_total(:) + &
                                     0.01*CTF(I_CT,I,J)*sun_frac(:)
                ENDIF
              ENDDO  ! ENDDO I_CT
              SunleafTK(I,J,:)   = sun_tk_total(:)/TotalCT
              ShadeleafTK(I,J,:) = shade_tk_total(:)/TotalCT
              SunPPFD(I,J,:)     = sun_ppfd_total(:)/TotalCT
              ShadePPFD(I,J,:)   = shade_ppfd_total(:)/TotalCT
              SunFrac(I,J,:)     = sun_frac_total(:)/TotalCT

            ELSEIF( TotalCT .LT. 0.0) THEN

            ELSE
            ! total CT is zero
            SunleafTK(I,J,:)   = TEMP(I,J)
            ShadeleafTK(I,J,:) = TEMP(I,J)
            SunPPFD(I,J,:)     = PPFD(I,J)
            ShadePPFD(I,J,:)   = PPFD(I,J)
            SunFrac(I,J,:)     = 1

            ENDIF
             
           ENDDO   ! ENDDO J
          ENDDO   ! ENDDO I
  RETURN 
      END SUBROUTINE MEGCANOPY 
      
!//////////////////////////////////////////////////////////////////  
    
SUBROUTINE MEGVEA(  LAYERS, JDATE, ZTIME,                &
                    LAIp, LAIc,LDF_in,                              &
                                        GAMSM_in, MaxT, MinT,       &
                    MaxWS,                                          &
!AQI, 
                    D_TEMP, D_PPFD, SUNT, SHAT,         &
                    SUNF, SUNP, SHAP,ER, NON_DIMGARMA  )
! PURPOSE: Calculate Vegetation emission activity (EA) for each emission
!		class as the product of EA for individual drivers
!		calculated by the following functions
!
! Vegetation Emission Activity (EA) algorithm FUNCTIONS
!
!   GAMTLD: EA Temperature response (light dependent emission) 
!   GAMTLI: EA Temperature response (light independent emission)
!   GAMP: EA Light response
!   GAMTP: combines GAMLD, GAMLI, GAMP to get canopy average
!
!   GAMLA: EA leaf age response 
!   GAMBD: EA bidirectional exchange LAI response
!
!   CDEA: Canopy depth emission response
!
!   GAMHW: EA response to high wind storms
!   GAMHT: EA resposne to high temperature
!   GAMLT: EA response to low temperature
!
!   GAMAQ: EA response to air pollution
!
!   GAMCO2: EA CO2 response (only applied to isoprene)
!   GAMSM: EA response to soil moisture (multiplied with LDF)
!
! INCLUDE FILES
!     'PARMS3.EXT'   ! I/O API parameters
!     'IODECL3.EXT'  ! I/O API function declarations
!     'FDESC3.EXT'   ! I/O API file desc. data structures
!     'MEGVEA.EXT'    ! coefficients
!
!  INPUT Files
!	Single value for each location
!		LDF: Light dependent fraction (for categories other than
!		monoterpene, use constant values from MEGVEA.EXT)
!		AQ:  Air Quality indicator
!	Time series for each location
!		LAI: Leaf Area Index 
!		GAMSM: emission activity response to soil moisture
!		MaxT: Daily maximum temperature (K)
!		MinT: Daily minimum temperature (K)
!		MaxWS: Daily mximum wind speed (m/s)
!               D_TEMP: Daily average temperature (K)
!               D_PPFD: Daily averaged PPFD (umol/m2.s)
!	Hourly time series for each canopy layer in each location
!		sunfrac: fraction of leaves that are sunlit
!		SUNT: leaf Temperature of sunlit leaves (K)
!		SUNP: sun leaf PPFD visible light (micromol/m2/s)
!		SHAT: leaf Temperature of shade leaves (K)
!		SHAP: shade leaf PPFD visible light (micromol/m2/s)
!	
!  OUTPUT Files
!	Hourly time series for each location 
!		Emission activity for each of the 20 emission types
!
!
! HISTORY:
!   Based on code initiated by Alex Guenther in 1990s
!   Coded in FORTRAN as
!   MEGAN: Jack Chen 11/04
!   MEGANv2.04: Tan 11/21/06
!   MEGANv2.1: X. Wang 11/04/2007
!       Modified by Julia Lee-Taylor 03/18/2008
!       Modified by Xuemei Wang 09/30/2008
!       Modified by Tan 07/28/2011
!   MEGAN3.0:
!   Alex Guenther and Ling Huang Feb 2017
!     converted program to subroutine

    IMPLICIT NONE
! INPUT VARIABLES
    INTEGER, INTENT(IN)  ::  LAYERS
    INTEGER, INTENT(IN)  ::  JDATE
    REAL, INTENT(IN)     ::  ZTIME
    REAL, INTENT(IN)     ::  LAIp       ( NCOLS, NROWS )
    REAL, INTENT(IN)     ::  LAIc       ( NCOLS, NROWS )
    REAL, INTENT(IN)     ::  LDF_in      ( NCOLS, NROWS , 4 ) !only 4 use maps
    REAL, INTENT(IN)     ::  GAMSM_in       ( NCOLS, NROWS )
    REAL, INTENT(IN)     ::  MaxT        ( NCOLS, NROWS )
    REAL, INTENT(IN)     ::  MinT        ( NCOLS, NROWS )
    REAL, INTENT(IN)     ::  MaxWS       ( NCOLS, NROWS )
!    REAL, INTENT(IN)     ::  AQI         ( NCOLS, NROWS )
    REAL, INTENT(IN)     ::  D_TEMP      ( NCOLS, NROWS )
    REAL, INTENT(IN)     ::  D_PPFD      ( NCOLS, NROWS ) ! comes in as rgrnd
    REAL, INTENT(IN)     ::  SUNT        ( NCOLS, NROWS, LAYERS )
    REAL, INTENT(IN)     ::  SHAT        ( NCOLS, NROWS, LAYERS )
    REAL, INTENT(IN)     ::  SUNF        ( NCOLS, NROWS, LAYERS )
    REAL, INTENT(IN)     ::  SUNP        ( NCOLS, NROWS, LAYERS )
    REAL, INTENT(IN)     ::  SHAP       ( NCOLS, NROWS, LAYERS )

! OUTPUT VARIABLES
    REAL, INTENT(OUT)     :: ER(NCOLS, NROWS )
    REAL, INTENT(OUT)     :: NON_DIMGARMA (NCLASS,NCOLS, NROWS)

 !LOCAL VARIABLES

    LOGICAL, PARAMETER    :: GAMBD_YN  = .false.

    LOGICAL, PARAMETER    :: GAMAQ_YN  = .false.
! For the CMAQ implementation of MEGAN  we refer to soil moisture 
! at layer 2, which is 1 meter for PX and 0.5 m for NOAH.
! Keep this in mind when enabling the GAMSM stress.
    LOGICAL, PARAMETER    :: GAMSM_YN  = .false. 
    LOGICAL, PARAMETER    :: GAMHT_YN  = .false.
    LOGICAL, PARAMETER    :: GAMLT_YN  = .false.
    LOGICAL, PARAMETER    :: GAMHW_YN  = .false.
    LOGICAL, PARAMETER    :: GAMCO2_YN = .false.

    REAL                  :: VPGWT(LAYERS), Ea1L, Ea2L

    REAL  :: CDEA   ( NCOLS, NROWS, LAYERS ) ! Emission response to canopy depth


    REAL  :: YEAR
    REAl  :: DOY
    REAL  :: GAMLA  ( NCOLS, NROWS )     ! EA leaf age response
    REAL  :: GAMAQ  ( NCOLS, NROWS )     ! EA response to air pollution
    REAL  :: GAMBD  ( NCOLS, NROWS )     ! EA bidirectional exchange LAI response
    REAL  :: GAMHT  ( NCOLS, NROWS )     ! EA response to high temperature
    REAL  :: GAMLT  ( NCOLS, NROWS )     ! EA response to low temperature

    REAL  :: GAMHW  ( NCOLS, NROWS )     ! EA response to high wind speed
    REAL  :: GAMSM  ( NCOLS, NROWS )     ! EA response to soil moisture
    REAL  :: GAMCO2 ( NCOLS, NROWS )     ! EA response to CO2
    REAL  :: GAMTP                       ! combines GAMLD, GAMLI, GAMP to get canopy average

    REAL  :: LDFMAP ( NCOLS, NROWS )     ! light depenedent fraction map


    REAL ::  SUM1, SUM2




    ! loop indices
    !INTEGER :: IDATE, ITIME
    INTEGER :: S, T, I, J, K 
!         YEAR   = FLOAT( MOD( JDATE, 1000 ) )
!         DOY    = FLOAT( JDATE / 1000  )       
! these are backwards I think. don't need them anyway

            

    ! EA response to canopy temperature/light

    IF ( Layers .EQ. 5 ) THEN
        VPGWT(1) = 0.1184635
        VPGWT(2) = 0.2393144
        VPGWT(3) = 0.284444444
        VPGWT(4) = 0.2393144
        VPGWT(5) = 0.1184635
    ELSE
        DO K = 1,Layers
            VPGWT(K) = 1.0 / FLOAT( Layers )
        END DO
    ENDIF

! First process Factors independent of species emission classes S :
    
    ! Emission response to canopy depth
    CALL GAMMA_CD( NCOLS, NROWS, Layers, LAIc, CDEA )

    ! EA bidirectional exchange LAI response
    IF ( GAMBD_YN ) THEN
        CALL GAMMA_LAIbidir(NCOLS, NROWS, LAIc, GAMBD)
    ELSE
        GAMBD = 1.0
    ENDIF

    IF ( GAMCO2_YN ) THEN
        CALL GAMMA_CO2(NCOLS, NROWS, GAMCO2)
    ELSE
        GAMCO2 = 1.0
    ENDIF

!  Now process all factors dependent on S:

    DO S = 1,NEMIS  ! Loop over all the emission classes

        IF ( S .EQ. 3 .OR. S .EQ. 4 .OR. S .EQ. 5 .OR. S .EQ. 6 ) THEN
!    otherwise use the input values.           
            LDFMAP = LDF_IN(:,:,S-2) ! only LDF 3, 4, 5, and 6 in file
        ELSE
!  For these species,  Read LDF from previous MEGVEA.EXT 
            LDFMAP = LDF(S)

        ENDIF


        ! leaf age activity factor:  dependent upon S
        CALL GAMMA_A( NCOLS, NROWS, S, LAIp, LAIc, D_TEMP, GAMLA )

        ! emission activity response to air quality

        IF ( GAMAQ_YN ) THEN
!            CALL GAMMA_AQ(NCOLS, NROWS, S, AQI, GAMAQ)
        ELSE
            GAMAQ = 1.0
        ENDIF

        IF ( GAMSM_YN ) THEN
            GAMSM = GAMSM_in
        ELSE
            GAMSM = 1.0
        ENDIF

        ! EA response to high temperature
        IF ( GAMHT_YN ) THEN
            CALL GAMMA_HT(NCOLS, NROWS, S, MaxT, GAMHT)
        ELSE
            GAMHT = 1.0
        ENDIF

        ! EA response to low temperature
        IF ( GAMLT_YN ) THEN
            CALL GAMMA_LT(NCOLS, NROWS, S, MinT, GAMLT)
        ELSE
            GAMLT = 1.0
        ENDIF

        ! EA response to high wind speed
        IF ( GAMHW_YN ) THEN
            CALL GAMMA_HW(NCOLS, NROWS, S, MaxWS, GAMHW)
        ELSE
            GAMHW = 1.0
        ENDIF


!

! THe following code has bee revised for efficiency and clarity.
!          DO I = 1, NCOLS
!            DO J = 1, NROWS
!
!              DO K = 1, Layers
!
!
!                Ea1L(K)  = CDEA(I,J,K) *                              &
!                      GAMTLD(SunT(I,J,K),D_TEMP(I,J),S) *             &
!                      GAMP(SunP(I,J,K),D_PPFD(I,J)) *  SunF(I,J,K) +  &
!                      GAMTLD(ShaT(I,J,K),D_TEMP(I,J),S) *             &
!                      GAMP(ShaP(I,J,K),D_PPFD(I,J))                   &
!                      * (1-SunF(I,J,K))
!
!                Ea2L(K) = GAMTLI(SunT(I,J,K),S)* SunF(I,J,K)+         &
!                   GAMTLI(ShaT(I,J,K),S)*(1-SunF(I,J,K))
!
!              ENDDO   ! ENDDO canopy layers
!              
!            GAMTP(I,J)=SUM((Ea1L(:)*LDFMAP(I,J) +                   &
!                            Ea2L(:)*(1-LDFMAP(I,J)))* VPGWT( : )) )
!            ENDDO   ! NROWS
!          ENDDO ! NCOLS



  
        DO J = 1, NROWS
        DO I = 1, NCOLS! Preserve stride 1 for output arrays

            SUM1 = 0.0
            SUM2 = 0.0

            DO K = 1, Layers
! 2.025 is the conversion to PPFD. 
! SWDNB*.45 = PAR (Wm-2)
! PAR*4.5 = PPFD (umol/m2/s)
                Ea1L = CDEA(I,J,K) *                                  &
                      GAMTLD(SunT(I,J,K),D_TEMP(I,J),S) *             &
              GAMP(SunP(I,J,K),D_PPFD(I,J)*2.025) *  SunF(I,J,K) +    &
                      GAMTLD(ShaT(I,J,K),D_TEMP(I,J),S) *             &
                  GAMP(ShaP(I,J,K),D_PPFD(I,J)*2.025)                 &
                      * (1.0-SunF(I,J,K))
                SUM1 = SUM1 + Ea1L*VPGWT(K)

                Ea2L = GAMTLI(SunT(I,J,K),S)* SunF(I,J,K) +           &
                      GAMTLI(ShaT(I,J,K),S)*(1.0-SunF(I,J,K))
                SUM2 = SUM2 + Ea2L*VPGWT(K)

            END DO   ! END DO canopy layers

            GAMTP = SUM1*LDFMAP(I,J) + SUM2*( 1.0-LDFMAP(I,J) )

 ! ... Calculate emission activity factors
 
            IF ( S .EQ. 1 ) THEN
!    GAMCO2 only applied to isoprene
                ER(:,:) = LAIc(I,J) * GAMTP * GAMCO2(I,J) * GAMLA(I,J) *       &
                          GAMHW(I,J) * GAMAQ(I,J) * GAMHT(I,J) * GAMLT(I,J) *  &
                          GAMSM(I,J) 

            ELSE IF ( S .EQ. 13 ) THEN
            
 !   GAMBD only applied to ethanol and acetaldehyde
            
                ER(I,J) = LAIc(I,J) * GAMTP * GAMBD(I,J) * GAMLA(I,J) *        &
                      GAMHW(I,J) * GAMAQ(I,J) * GAMHT(I,J) * GAMLT(I,J) *      &
                      GAMSM(I,J) 

            ELSE
!  Process remaining species            
            
                ER(I,J) = LAIc(I,J) * GAMTP * GAMLA(I,J) *                            &
                      GAMHW(I,J) * GAMAQ(I,J) * GAMHT(I,J) * GAMLT(I,J) *             &
                       GAMSM(I,J) 

            END IF
            IF ( ER(I,J).GT.0.0 ) THEN
                NON_DIMGARMA (S,I,J) = ER(I,J)
            ELSE
                NON_DIMGARMA (S,I,J) = 0.0
            END IF

        END DO   ! NCOLS
        END DO ! NROWS

    END DO  ! End loop of species (S)
 
    RETURN
    
   END SUBROUTINE MEGVEA

! ///////////////////////////////////////////////////////////////////////////
      SUBROUTINE MEGVSA (IDATE,ITIME,TSTEP,JYEAR,JDAY,                       &
                    L_DESID_DIAG,SLTYP, CTF,LAIc, LAT,           &
                    TEMP, SOILM1,SOILM2, SOILT, PRECADJ,           &
                    CFNO, CFNOG, GAMSM, GAMNO, BDSNP_NO )


!***********************************************************************
!   This subroutine computes soil NO emission activity factor and isoprene
!   soil moisture activity using MCIP output variables.
!
!  DESCRIPTION:
!
!     Uses new NO algorithm NO = Normalized*Tadj*Padj*Fadj*Cadj
!     to estimate NO emissions
!     Information needed to estimate NO emissions
!     Julian Day          (integer)    JDATE
!     Surface Temperature (MCIP field) TA    (K)
!     Soil Moisture       (MCIP field) SOILM (M**3/M**3) (LSOIL)
!          (ratio of volume of water per volume of soil)
!     Soil Temperature    (MCIP field) SOILT (K)         (LSOIL)
!     Soil Type           (MCIP field) ISLTYP            (LSOIL)
!
!     saturation values for soil types (constants)       (LSOIL)
!     FOR PX Version, the Temperature adjustment factor accounts for wet
!     and dry soils
!                and  the precipitation adjustment factor accounts for
!                saturated soils
!     FOR the non-PX version, the basic algorithm remains with a
!     temperature adjustment factor (dry soil)
!                     and no adjustment for saturated soils
!
!     The following arrays are updated after each call to SOILNOX
!     PULTYPE   type of NO emission pulse
!     PULSEDATE julian date for the beginning of an NO pulse
!     PULSETIME        time for the beginning of an NO pulse
!
!     The calculation are based on the following paper by J.J. Yienger
!     and H. Levy II
!     J.J. Yienger and H. Levy II, Journal of Geophysical Research, vol
!     100,11447-11464,1995
!
!     The Temperature Adjustment Factor is based on section 4.2 for wet
!     and dry soils with the following modification (PX version):
!       Instead of classifying soils as either 'wet' or 'dry', the wet
!       and dry adjustment is calculated at each grid cell.  A linear 
!       interpolation between the wet and dry adjustment factor is made 
!       using the relative amount of soil moisture in the top layer (1cm)
!       as the interpolating factor.  The relative amount of soil moisture 
!       is determined by taking the MCIP soil moisture field and dividing by the
!       saturation value defined for each soil type in the PX version of MCIP
!       the soil temperature is used in PX version
!
!     The Precipation Adjustment factor is based on section 4.1 with the
!     following modifications.
!       The rainrate is computed from the MCIP directly using a 24 hr daily total.
!       THe types of Pulses as described in YL95 were used to estimate
!       the NO emission rate.
!
!    Also see the following paper for more information:
!    Proceedings of the Air and Waste Management Association/U.S. Environmental Protection
!    Agency EMission Inventory Conference, Raleigh October 26-28, 1999 Raleigh NC
!    by Tom Pierce and Lucille Bender
!
!    REFERENCES
!
!    JACQUEMIN B. AND NOILHAN J. (1990), BOUND.-LAYER METEOROL., 52, 93-134.
!    J.J. Yienger and H. Levy II, Journal of Geophysical Research, vol 100,11447-11464,1995
!    T. Pierce and L. Bender, Examining the Temporal Variability of Ammonia and 
!      Nitric Oxide Emissions from Agricultural Proc Proceedings of the Air and Waste 
!      Management Association/U.S. Environmental Protection Agency EMission Inventory 
!      Conference, Raleigh October 26-28, 1999 Raleigh NC
!  PRECONDITIONS REQUIRED:
!     Normalized NO emissions, Surface Temperature, Soil Moisture, Soil type,
!     NO emission pulse type, soil moisture from previous time step, julian date
!     of NO emission pulse start, time of NO emission pulse start, soil type, 
!     SOIL TYPES, Land use data
!
!  SUBROUTINES AND FUNCTIONS CALLED (directly or indirectly):
!     FERTILIZER_ADJ computes fertlizer adjustment factor
!     VEG_ADJ        computes vegatation adjustment factor
!     GROWSEASON     computes day of growing season
!
! HISTORY:
!   07/21/11: Imported from SMOKE-BEIS v3.14 for MEGEAN v2.10 (Tan)
!   03/19/17: Make as an indpendent program (MEGSEA) (Ling Huang)
!   03/31/17: Add calculation for soil moisture activity (Ling Huang)
!   06/10/19: Add an option to use BDSNP model to calculate soil NO
!             emissions (Ling Huang) 
!*********************************************************************

      USE BDSNP_MOD
      USE RUNTIME_VARS, ONLY: BDSNP_MEGAN

      IMPLICIT NONE
 


!    input variables
     
     INTEGER, INTENT(IN) :: IDATE, ITIME, TSTEP(3)  
     LOGICAL, INTENT( IN ) :: L_DESID_DIAG
     
      INTEGER, INTENT(IN) :: SLTYP  (NCOLS, NROWS)  ! soil type
      REAL, INTENT(IN)    :: JYEAR, JDAY
      REAL, INTENT(IN)    :: CTF( NrTyp, NCOLS, NROWS ) ! Canopy type factor arra
      REAL, INTENT(IN)    :: LAIc( NCOLS, NROWS )    ! Current time step LAI
      REAL, INTENT(IN)    :: LAT (NCOLS, NROWS )    ! Latitude
      REAL, INTENT(IN)    :: TEMP (NCOLS, NROWS)   ! Temperautre (K)

      REAL, INTENT(IN)    :: SOILM1  (NCOLS, NROWS)  ! soil moisture
      REAL, INTENT(IN)    :: SOILM2  (NCOLS, NROWS)  ! soil moisture
      REAL, INTENT(IN)    :: SOILT  (NCOLS, NROWS)  ! soil temperature
      REAL, INTENT(IN)    :: PRECADJ (NCOLS, NROWS)   

!     output variable
      REAL, INTENT(OUT)   :: CFNO  (NCOLS, NROWS)       ! Emission activity for crop
      REAL, INTENT(OUT)   :: CFNOG  (NCOLS, NROWS)      ! Emission activity for grass
      REAL, INTENT(OUT)   :: GAMSM  (NCOLS, NROWS)      ! Soil moisture activity for isoprene
      REAL, INTENT(OUT)   :: GAMNO  (NCOLS, NROWS)      ! Final NO emission activity
      REAL, INTENT(OUT)   :: BDSNP_NO (NCOLS, NROWS)    ! BDSNP NO emissions(nmol/s/m2)



! Local variables and their descriptions:
      CHARACTER*16  :: GDNAM
      CHARACTER*16  :: CNAME        ! Coord name





      INTEGER :: GDAY, GLEN
      INTEGER :: MXLAI,MXCT
      REAL :: t1,wilt,TMO1,TMO2

      LOGICAL :: LSOIL = .TRUE.

      INTEGER :: T,I,J,MM,DD,I_CT
        
                 CFNO = 0.0 ! INITIALIZE
                 CFNOG = 0.0 ! INITIALIZE

         if (BDSNP_MEGAN) then

          call get_date(JYEAR, JDAY, MM, DD)

          CALL HRNOBDSNP( IDATE,ITIME,TSTEP,MM,  &
                    L_DESID_DIAG,SOILM1,SOILT,SLTYP,LAIc,    &
                                            bdsnp_no)

        else


          CALL SOILNOX(IDATE,ITIME,NCOLS,NROWS,            &
                     TEMP,LSOIL,SLTYP, SOILM1, SOILT,     &
                     LAIc, LAT, PRECADJ,                 &
                     CFNO, CFNOG )

        DO I = 1,NCOLS
          DO J = 1,NROWS
            CALL GROWSEASON(IDATE,LAT(I,J),GDAY,GLEN)
            IF (GDAY .EQ. 0) THEN
             ! non growing season
             ! CFNOG for everywhere
               GAMNO(I,J) = CFNOG(I,J)

             ELSE IF (GDAY .GT. 0 .AND. GDAY .LE. 366) THEN
             ! growing season
             ! CFNOG for everywhere except crops
             TMO1 = 0.
             TMO2 = 0.
             DO I_CT = 1,5
               TMO1 = TMO1 + CTF(I_CT,I,J)
               TMO2 = TMO2 + CTF(I_CT,I,J) * CFNOG(I,J)
             ENDDO
             ! CFNO for crops
             TMO1 = TMO1 + CTF(6,I,J)
             TMO2 = TMO2 + CTF(6,I,J) * CFNO(I,J)
             IF (TMO1 .EQ. 0.0) THEN
                GAMNO(I,J) = 0.0
             ELSE
                GAMNO(I,J) = TMO2 / TMO1
             ENDIF
             ENDIF
 
           ENDDO  !NCOLS
        ENDDO  !NROWS

        END IF ! YL or BDSNP


           DO I = 1, NCOLS
             DO J = 1, NROWS

               !wilt = WWLT(SLTYP(I,J))
               wilt = Grid_Data%WWLT(I,J)
               t1 = wilt + d1
               IF ( SOILM2(I,J) < wilt ) THEN
                   GAMSM(I,J) = 0
               ELSE IF ( SOILM2(I,J) >= wilt .AND. SOILM2(I,J) < t1 ) THEN
                   GAMSM(I,J) = (SOILM2(I,J) - wilt)/d1
               ELSE
                   GAMSM(I,J) = 1
               END IF
             END DO ! NCOLS
           END DO ! NROWS
         
         
  END SUBROUTINE MEGVSA


  subroutine convert2mech(no_in,inper,outer)
         USE centralized_io_module
         use hgrd_defn, only : ncols, nrows
         USE MEGAN_GSPRO
!***********************************************************************
!   This program does chemical speciation and MECHANISM conversion.
!   The output from megan.f is converted from 19 to 201 species which
!   are then lumped according to the MECHANISM assigned in the run script.  
!   The program loops through all timesteps of the input file.
!
!   Procedure
!   1) File set up and assign I/O parameters
!   2) Conversion from MGN 19 to speciated 201
!   3) Conversion from speciated species to MECHANISM species
!   4) Convert to tonne/hour if needed
!
!   The input file gives variables in units of g-species/sec.
!   All outputs are in mole/sec or tonne/hr depending on assignment.
!
!
!   INPUT:
!           1) MEGVEA output (netCDF-ioapi)
!           2) MEGSEA output (netCDF-ioapi)
!
!   OUTPUT:
!           1) MEGAN speciation or MECHANISM species (netCDF-ioapi)
!
!   Requirement:
!      Requires libnetcdf.a and libioapi.a to compile
!
!      setenv MGERFILE    <DEFANGED_input MEGAN output for emission activity factors>  
!      setenv OUTPFILE    <output speciated emission>
!
!   CALLS:  CHECKMEM
!
!   Originally created by Jack Chen 11/04 for MEGAN v.0
!   For MEGAN v2.0 created by Tan 12/01/06
!   For MEGAN v2.1 created by Xuemei Wang 11/04/07
!   For MEGAN v2.1 to use 150 species created by Xuemei Wang 09/30/09
!   For MEGAN v3 to use 201 species created by Alex Guenther 03/19/17
!
!  History:
!  08/14/07 Tan    - Move to MEGANv2.02 with no update
!  08/29/07 modified by A. Guenther to correct error in assigning   
!           emission factor. This version is called MEGANv2.03
!  10/29/07 modified by A. Guenther to correct omission of diurnal variation    
!           factor. This version is called MEGANv2.04
!  11/04/07 modified by Xuemei Wang to give two options for MAP or lookup table for
!           the emission factors. Also gives options for different chemical MECHANISMs
!           in the code: user modifies the external script to assign MECHANISM.
!           This version is called MEGANv2.1.0
!  06/04/08 modified by J. Lee-Taylor to accept vegetation-dependent speciation factors
!           in table format (RESHAPE tables) rather than from DATA statements.
!  09/30/08  modified by Xuemei Wang to give options for input file and test different mechanisms
!  09/27/11  Tan&Xuemei MEGANv2.10 includes soil NOx adjustment and a lot of updates
!  03/19/17  Ling Huang MEGANv3 (a) updates vegetation emission factors and
!            add additional compounds; (b) emission factor unit from
!            ug/m2/hr to nanomoles/m2/s; (c) fix NO emission bug
!  06/08/17  Ling Huang updated/added new mechanism for MEGAN3
!  08/10/19  Ling Huang updated for BDSNP option for MEGAN3.1
!***********************************************************************

      USE RUNTIME_VARS, ONLY: BDSNP_MEGAN
      IMPLICIT NONE



!...  Program I/O files
! Program name
      CHARACTER*16 :: PROGNAME = 'MGN2MECH'


!...  Internal parameters
! internal paramters (status and buffer)


! local variables and their descriptions:
      INTEGER :: t, s, I, N                   ! Counters
      INTEGER :: nmpmg, nmpsp, nmpmc          ! Counters

      REAL, ALLOCATABLE :: tmper(:,:,:)       ! Temp emission buffer


      REAL :: GAMNO(ncols,nrows)         ! NO emission factor
      REAL :: BDSNP_NO(ncols,nrows)      ! NO emissions for BDSNP algorithm (nanomol/m^2/s)

      REAL, INTENT(IN)     ::  inper       (19, NCOLS, NROWS )
      REAL, INTENT(IN)     ::  NO_IN       (NCOLS, NROWS )
      REAL, INTENT(OUT)    ::  outer       (NMGNSPC, NCOLS, NROWS ) ! CB6

      INTEGER :: INO,ios

      REAL, PARAMETER :: nmol2mol   = 1E-9    ! convert nanomoles to moles

      

!***********************************************************************

!=======================================================================
!...  Begin program
!=======================================================================



!.....2) Conversion from MGN 20 to speciated 201
!-----------------------------------------------------------------------
!...  Allocate memory
      ALLOCATE ( tmper( n_spca_spc, ncols, nrows ), STAT = ios )

       INO = 8 ! this was 20 for megan 3.1 

        tmper = 0.
        outer = 0.

        IF ( .NOT. BDSNP_MEGAN ) THEN
          GAMNO = NO_IN
        ELSE
          BDSNP_NO = NO_IN
        ENDIF

        DO s = 1, N_SMAP_SPC
          nmpmg = mg20_map(s)
          nmpsp = spca_map(s)
         IF ( nmpmg .NE. INO ) then
           !...  Not NO
           tmper(nmpsp,:,:) = inper(nmpmg,:,:) * efmaps(:,:,nmpmg)  &
                               * effs_all(s)
         ELSEIF ( nmpmg .EQ. INO ) then

!!-----------------NO Stuff-----------------------
           IF ( .NOT. BDSNP_MEGAN ) THEN
!     GAMNO is emission activity factor
              tmper(nmpsp,:,:) = GAMNO(:,:) * efmaps(:,:,INO)   &
                                * effs_all(s)
           ELSE

! directly use BDSNP soil NO
             tmper(nmpsp,:,:) = BDSNP_NO(:,:)
           ENDIF 
!-----------------end of NO----------------------
         ENDIF     !IF ( nmpmg .NE. INO ) then

        ENDDO ! End species loop

!-----------------------------------------------------------------------
!.....3) Conversion from speciated species to MECHANISM species
!-----------------------------------------------------------------------
        DO s = 1, n_spca_spc
           tmper(s,:,:) = tmper(s,:,:) * nmol2mol 
        ENDDO

          ! lumping to MECHANISM species

          DO s = 1, n_scon_spc
            nmpsp = spmh_map(s)         ! Mapping value for SPCA
            nmpmc = mech_map(s)         ! Mapping value for MECHANISM

           IF ( nmpmc .NE. 999 ) THEN

            outer(nmpmc,:,:) = outer(nmpmc,:,:) +     &
                    (tmper(nmpsp,:,:) * conv_fac(s))
           ENDIF
          ENDDO ! End species loop


      end subroutine convert2mech


!-----------------------------------------------------------------------
!   Created by Tan 07/28/11
!   Updated by Ling Huang 02/18/17 for MEGAN3: LAI data is saved as
!   LAI1, LAI2, ... LAIS92, instead of one variable with multiple time
!   step.
!-----------------------------------------------------------------------
      SUBROUTINE FINDLAI( IDATE, MXLAI, NLAI, LAIp_I, LAIc_I)

      IMPLICIT NONE

! input
      INTEGER,INTENT(IN) :: IDATE  ! YYYYJJJ
      INTEGER,INTENT(IN) :: MXLAI, NLAI
! output
      INTEGER,INTENT(OUT) :: LAIp_I, LAIc_I
! Local
      INTEGER :: JJJ
      REAL    :: XXX

! Calculation


      JJJ = MOD(IDATE,1000)
      IF ( NLAI .EQ. 46 ) THEN
        XXX = JJJ/8.0
        LAIc_I = CEILING(XXX)
      ELSE IF ( NLAI .EQ. 37 ) THEN
        XXX = JJJ/10.0
        LAIc_I = CEILING(XXX)
      !ELSE IF ( NLAI .EQ. 12 ) THEN
      !  CALL DAYMON(IDATE, MM, DAY)
      !  LAIc_I = MM
      ENDIF

      IF (LAIc_I .EQ. 1) THEN
        LAIp_I = MXLAI
      ELSE
        LAIp_I = LAIc_I - 1
      ENDIF


      RETURN
      END SUBROUTINE FINDLAI
!-----------------------------------------------------------------------`


end module megan_fx

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_data_copy_module.f,v 1.2 2006/02/15 14:41:56 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   use F90 interface feature to achieve "faked" polymorphism for data
C   copy routine which performs interior sub-grid data communication (data 
C   re-distribution)
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C
C                    10/09/00 by David Wong
C                      -- unified fsg and csg data structures into one,
C                         subgrid
C
C                    07/23/01 by David Wong
C                      -- redesign the message sending and receiving algorithm
C
C                    03/06/02 David Wong
C                      -- use blocking communication scheme
C                      -- use array copy mechanism when communicates to itself
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C                    01/04/23 by David Wong
C                       -- modified routines to handle any level range setting
C                          defined by PA_BLEV PA_ELEV in the run script properly
C
C                    01/17/24 by David Wong
C                       -- fixed a bug that IRR/IPR process alllows a subset of
C                          level, a..b, where 1 <= a <= b <= NLAYS
C
C Note:
C
C   se_[n]d[e]_data_copy where [n] denotes the dimensionality of the data
C   and [e] is optional, indicates the first two dimensions are both decomposed
C   or not
C
C Subroutine parameter description:
C
C   In:  data1     -- original data
C        spc       -- (use as needed) a specific species in the original data
C        des       -- (use as needed) species number in the recipient data
C        grid_type -- optional input, to indicate the data is from coarse
C                     grid 'c', 'C' or not
C
C   Out: data2   -- recipient of original data
C
C Local variable description:
C
C    sdir, rdir -- loop indexes which indicate send to or recvd from
C    tag        -- message tag
C    i          -- local loop index
C
C Include file:
C
C   se_pe_info_ext
C   se_data_send_module
C   se_data_recv_module
C
C --------------------------------------------------------------------------

        module se_data_copy_module

        implicit none

        interface se_data_copy
          module procedure se_2d_data_copy, se_2de_data_copy, 
     &                     se_3d_data_copy, se_3de_data_copy, 
     &                     se_4d_data_copy, se_4de_data_copy
        end interface

        contains

C --------------------------------------------------------------------------
        subroutine se_2d_data_copy (data1, data2)

        use se_subgrid_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :)
        real, intent(out) :: data2(:, :)

        integer :: sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     $              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir))
     $        =
     $        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     $              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr, 
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr, 
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_2d_data_copy

C --------------------------------------------------------------------------
        subroutine se_2de_data_copy (data1, data2, spc)

        use se_subgrid_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :, :)
        real, intent(out) :: data2(:, :)
        integer, intent(in) :: spc

        integer :: i, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, se_numworkers-1
           se_subgrid_send_ind(1,3,i) = spc
           se_subgrid_send_ind(2,3,i) = spc
        end do

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     $              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir))
     $        =
     $        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     $              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir),
     $              se_subgrid_send_ind(1,3,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr, 
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr, 
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_2de_data_copy

C --------------------------------------------------------------------------
        subroutine se_3d_data_copy (data1, data2)

        use se_subgrid_info_ext
        use se_domain_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :, :)
        real, intent(out) :: data2(:, :, :)

        integer :: i, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, se_numworkers-1
           se_subgrid_send_ind(1,3,i) = se_my_subgrid_beglev
           se_subgrid_send_ind(2,3,i) = se_my_subgrid_endlev
           se_subgrid_recv_ind(1,3,i) = 1
           se_subgrid_recv_ind(2,3,i) = se_my_subgrid_endlev - se_my_subgrid_beglev + 1
        end do

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     &              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir),
     &              se_subgrid_recv_ind(1,3,sdir):se_subgrid_recv_ind(2,3,sdir))
     &        =
     &        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     &              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir),
     &              se_subgrid_send_ind(1,3,sdir):se_subgrid_send_ind(2,3,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr,
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr,
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if

        end do

        return
        end subroutine se_3d_data_copy

C --------------------------------------------------------------------------
        subroutine se_3de_data_copy (data1, data2, spc, flag)

        use se_subgrid_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :, :, :)
        real, intent(out) :: data2(:, :, :)
        integer, intent(in) :: spc
        integer, intent(in), optional :: flag

        integer :: i, sdir, rdir, tag, loc_beglev, loc_endlev
        integer :: request, status(MPI_STATUS_SIZE), error

        if (present(flag)) then
           ! this indicates data1 is in subset level configuration and
           ! indiex starting from 1
           loc_beglev = 1
           loc_endlev = se_my_subgrid_endlev - se_my_subgrid_beglev + 1
        else
           loc_beglev = se_my_subgrid_beglev
           loc_endlev = se_my_subgrid_endlev
        end if

        do i = 0, se_numworkers-1
           se_subgrid_send_ind(1,3,i) = loc_beglev
           se_subgrid_send_ind(2,3,i) = loc_endlev
           se_subgrid_send_ind(1,4,i) = spc
           se_subgrid_send_ind(2,4,i) = spc

           se_subgrid_recv_ind(1,3,i) = 1
           se_subgrid_recv_ind(2,3,i) = se_my_subgrid_endlev - se_my_subgrid_beglev + 1
        end do

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     &              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir),
     &              se_subgrid_recv_ind(1,3,sdir):se_subgrid_recv_ind(2,3,sdir))
     &        =
     &        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     &              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir),
     &              se_subgrid_send_ind(1,3,sdir):se_subgrid_send_ind(2,3,sdir),
     &              se_subgrid_send_ind(1,4,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr, 
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr, 
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_3de_data_copy

C --------------------------------------------------------------------------
        subroutine se_4d_data_copy (data1, data2)

        use se_subgrid_info_ext
        use se_pe_info_ext
        use se_domain_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :, :, :)
        real, intent(out) :: data2(:, :, :, :)

        integer :: i, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, se_numworkers-1
           se_subgrid_send_ind(1,3,i) = 1
           se_subgrid_send_ind(2,3,i) = se_my_nlays
           se_subgrid_send_ind(1,4,i) = 1
           se_subgrid_send_ind(2,4,i) = se_my_nspcs
           se_subgrid_recv_ind(1,3,i) = 1
           se_subgrid_recv_ind(2,3,i) = se_my_nlays
           se_subgrid_recv_ind(1,4,i) = 1
           se_subgrid_recv_ind(2,4,i) = se_my_nspcs
        end do

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     &              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir),
     &              se_subgrid_recv_ind(1,3,sdir):se_subgrid_recv_ind(2,3,sdir),
     &              se_subgrid_recv_ind(1,4,sdir):se_subgrid_recv_ind(2,4,sdir))
     &        =
     &        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     &              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir),
     &              se_subgrid_send_ind(1,3,sdir):se_subgrid_send_ind(2,3,sdir),
     &              se_subgrid_send_ind(1,4,sdir):se_subgrid_send_ind(2,4,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr,
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr,
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_4d_data_copy

C --------------------------------------------------------------------------
        subroutine se_4de_data_copy (data1, data2, spc, des)

        use se_subgrid_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :, :, :)
        real, intent(out) :: data2(:, :, :, :)
        integer, intent(in) :: spc, des

        integer :: i, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, se_numworkers-1
           se_subgrid_send_ind(1,3,i) = se_my_subgrid_beglev
           se_subgrid_send_ind(2,3,i) = se_my_subgrid_endlev
           se_subgrid_send_ind(1,4,i) = spc
           se_subgrid_send_ind(2,4,i) = spc

           se_subgrid_recv_ind(1,3,i) = 1
           se_subgrid_recv_ind(2,3,i) = se_my_subgrid_endlev - se_my_subgrid_beglev + 1
           se_subgrid_recv_ind(1,4,i) = des
           se_subgrid_recv_ind(2,4,i) = des
        end do

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     &              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir),
     &              se_subgrid_recv_ind(1,3,sdir):se_subgrid_recv_ind(2,3,sdir),
     &              se_subgrid_recv_ind(1,4,sdir))
     &        =
     &        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     &              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir),
     &              se_subgrid_send_ind(1,3,sdir):se_subgrid_send_ind(2,3,sdir),
     &              se_subgrid_send_ind(1,4,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr, 
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr, 
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_4de_data_copy

        end module se_data_copy_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AQCHEM ( JDATE, JTIME, TEMP, PRES_PA, TAUCLD, PRCRATE,
     &                    WCAVG, WTAVG, AIRM, ALFA0, ALFA2, ALFA3, GAS,
     &                    AEROSOL, GASWDEP, AERWDEP, HPWDEP, BETASO4, COSZ)

C-----------------------------------------------------------------------
C  Description:
C    Compute concentration changes in cloud due to aqueous chemistry,
C    scavenging and wet deposition amounts.
C
C  Revision History:
C      No   Date   Who  What
C      -- -------- ---  -----------------------------------------
C      0  / /86    CW   BEGIN PROGRAM - Walceks's Original Code
C      1  / /86    RB   INCORPORATE INTO RADM
C      2  03/23/87 DH   REFORMAT
C      3  04/11/88 SJR  STREAMLINED CODE - ADDED COMMENTS
C      4  08/27/88 SJR  COMMENTS, MODIFIED FOR RPM
C      4a 03/15/96 FSB  Scanned hard copy to develop Models3
C                       Version.
C      5  04/24/96 FSB  Made into Models3 Format
C      6  02/18/97 SJR  Revisions to link with Models3
C      7  08/12/97 SJR  Revised for new concentration units (moles/mole)
C                       and new treatment of nitrate and nitric acid
C      8  01/15/98 sjr  revised to add new aitken mode scavenging
C                       and aerosol number scavenging
C      9  12/15/98 David Wong at LM:
C             -- change division of XL, TEMP to multiplication of XL, TEMP
C                reciprocal, respectively
C             -- change / TOTOX / TSIV to / ( TOTOX * TSIV )
C     10  03/18/99 David Wong at LM:
C             -- removed "* 1.0" redundant calculation at TEMP1 calculation
C     11  04/27/00 sjr  Added aerosol surface area as modeled species
C     12  12/02    sjr  changed calls to HLCONST and updated the dissociation
C                       constants
C     13  06/26/03 sjr  revised calculations of DTW based on CMAS website
C                       discussions
C     14  08/05/03 sjr  revision made to the coarse aerosol number washout
C     15  04/20/05  us  revisions to add sea salt species in the fine and
C                       coarse aerosol modes, and HCl dissolution/dissociation
C         08/01/05 sjr  Modified for sulfate tracking model
C     16  10/13/05 sjr  fixed bug in the integration time step calculation
C                       (reported by Bonyoung Koo)
C     17  03/01/06 sjr  added elemental carbon aerosol; organic aerosols
C                       replaced with primary, secondary biogenic, and
C                       secondary anthropogenic; fixed 3rd moment calc to
C                       include EC and primary organics (not secondary);
C                       re-arranged logic for setting Cl & Na ending conc;
C                       added pointers/indirect addressing for arrays WETDEP
C                       and LIQUID
C     16  03/30/07 sjr  Limit integration timestep by cloud washout time
C     17  04/10/07 sjr  increased loop limits as follows: I20C <10000,
C                       I7777C <10000, I30C <10000, ICNTAQ <60000
C     18  01/10/07 agc  added organic chemistry for GLY and MGLY oxidation
C     19  09/10/07 sln  updated SOA species list for AE5
C     20  01/29/08 agc  updated DOHDT calculation
C     21  04/14/08 jtk  added coding for coarse NH4 and scavenging of
c                       coarse surface area
C     22  05/20/08 agc  for CB05, use the Henry's Law constant for glyoxal
C                       as a surrogate for methyl glyoxal
C     23  04/15/09 sjr& Several changes made to improve mass conservation in the
C                  agc  solver.  (1) OH concentration is now considered to be
C                       steady state; (2) only allow sulfur oxidation to affect
C                       time step; (3) implemented mass conservation checks -
C                       limit oxidation rates by the available mass for the
C                       specified timestep.
C   10 Oct 10 J.Young:  update to use aero_reeng by Steve Howard, Prakash Bhave,
C                       Jeff Young, Sergey Napelenok, and Shawn Roselle
C   01 Mar 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C    9 Mar 11 S.Napelenok: update for AE6 - pH calculation now expanded to
C                       include Ca Mg K SOIL CORS SEAS
C   23 May 11 G.Sarwar: update S(VI) production rate via H2O2, O3, MHP, PAA
C                       pathways (Jacobson 1997)
C   23 May 11 G.Sarwar: update S(VI) production rate via O2 pathway (metal
C                       catalysis) (Martin and Goodman, 1991)
C   01 Jul 11 G.Sarwar: Incorporate day and night dependent Fe III oxidation
C                       state (Alexander et al.,  2009)
C   12 Aug 11 G.Sarwar: Revise Fe and Mn solubility based on
C                       Alexander et al., 2009
C
C    8 Mar 12 J.Bash:   FE_OX and MN_OX were calculated from FE and MN before
C                       a floor value of 0.0 was established for these
C                       concentrations sometimes resulting in negative
C                       concentrations and model crashes. The code used to
C                       estimate FE_OX and MN_OX was moved to be after a floor
C                       value for FE and MN was set. Also the washout rate was
C                       removed from the calculation of the estimate for doubling
C                       the time step based on sulfur oxidized < 5%.
C   28 Nov 12 G.Sarwar: Sulfate inhibition effect is implemented in the metal catalysis pathway
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C   12 Feb 15 B.Hutzell: reduced number of exp(...) calculations for scavenging aitken
C                        aerosols to improve efficiency
C   15 Jun 15 J.Young:  Fixed bug found by Martin Otte in calculations for scavenging
C                       aitken aerosols
C   15 Apr 16 J.Young:  Use aerosol factors from AERO_DATA module named constants
C   19 Apr 18 K.Fahey:  For species with both gas phase and coarse mode aerosol components, avoid
C                       introducing extra mass when the coarse mode concentration is greater than 
C                       the total amount left in the aqueous phase after redistribution between the 
C                       phases. 
C   26 Nov 18 S.Napelenok: ISAM implementation
C   31 Dec 19 S.Napelenok: DDM-3D implementation for version 5.3.1

C
C  References:
C     Walcek & Taylor, 1986, A theoretical Method for computing
C        vertical distributions of acidity and sulfate within cumulus
C        clouds, J. Atmos Sci.,  Vol. 43, no. 4 pp 339 - 355
C     Carlton, A.G., B.J. Turpin, K.E. Altieri, S.P. Seitzinger, R. Mathur,
C        S.J. Roselle, and R.J. Weber, CMAQ Model Performance Enhanced When
C        In-Cloud Secondary Organic Aerosol is Included:  Comparison of Organic
C        Carbon Predictions with Measurements, Environ. Sci. Technol., 42(23),
C        8798-8802, 2008.
C     Jacobson, M., Development and application of a new air pollution modeling
C        system II. Aerosol module structure and design, Atmospheric
C        Environment, 31, 131-144, 1997
C     Martin, R.L. and T.W. Good, catalyzed oxidation of sulfur dioxide in
C        solution: the iron-manganese synercism, Atmospheric Environment, 25A,
C        2395-2399, 1991
C     Alexander, B., R.J. Park, D.J. jacob, S. Gong, Transition metal-catalyzed
C        oxidation of atmospheric sulfur: global implications for the sulfur
C        budget, GRL, 114, D02309, 2009

C  Called by:  AQMAP

C  Calls the following subroutines:  none

C  Calls the following functions:  HLCONST

C  Arguments     Type      I/O       Description
C  ---------     ----  ------------  --------------------------------
C  GAS(N_AQ_GAS)     real  input&output  Concentration for species i=1,15
C  GASWDEP(N_AQ_GAS) real     output     wet deposition for species

C  AEROSOL(N_AQ_AER,nmodes) real input&output   Concentration for species i=1,51
C  AERWDEP(N_AQ_AER,nmodes) real     output     wet deposition for species
C-----------------------------------------------------------------------

      USE RXNS_DATA       ! chemical mechanism data
      USE AQ_DATA         ! doesn't inherit; gets only n_aerospc, conmin from AERO_DATA
      USE AERO_DATA
      USE UTILIO_DEFN
      USE CONST
      USE HLCONST_MOD
#ifdef isam
      USE SA_DEFN, ONLY: DEPSUM_SAVE, DS4_SAVE, REMOV_SAVE,
     &                   DEPSUM_AORGC_SAVE, DGLY1_SAVE, DMGLY1_SAVE,
     &                   REMOV_AORGC_SAVE
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, S_POLC, S_CEND, S_REMOV,
     &                       S_REMOVAC, S_HPWDEP, S_GAS, S_GASWDEP,
     &                       S_AEROSOL, S_AERWDEP, IHIGH, IPT
#endif

      IMPLICIT NONE

      CHARACTER( 120 ) :: XMSG = ' '  ! Exit status message

C...........Parameters:

      INTEGER, PARAMETER :: NUMOX = 5          ! number of oxidation reactions

      REAL( 8 ), PARAMETER :: H2ODENS = 1000.0D0   ! water density at 20 C and 1 ATM (kg/m3)
      REAL( 8 ), PARAMETER :: SEC2HR  = 1.0D0 / 3600.0D0 ! convert seconds to hours
      REAL( 8 ), PARAMETER :: SCVEFF  = 100.0D0    ! Scavenging efficiency (%)

C...........Arguments:

      INTEGER,   INTENT( IN )  :: JDATE  ! current model date, coded YYYYDDD
      INTEGER,   INTENT( IN )  :: JTIME  ! current model time, coded HHMMSS

      REAL,      INTENT( IN )  :: AIRM      ! total air mass in cloudy layers (mol/m2)
      REAL,      INTENT( IN )  :: ALFA0     ! scav coef for aitken aerosol number
      REAL,      INTENT( IN )  :: ALFA2     ! scav coef for aitken aerosol sfc area
      REAL,      INTENT( IN )  :: ALFA3     ! scav coef for aitken aerosol mass
      REAL,      INTENT( OUT ) :: HPWDEP    ! hydrogen wet deposition (mm mol/liter)
      REAL( 8 ), INTENT( OUT ) :: BETASO4
      REAL,      INTENT( IN )  :: PRCRATE   ! precip rate (mm/hr)
      REAL,      INTENT( IN )  :: PRES_PA   ! pressure (Pa)
      REAL,      INTENT( IN )  :: TAUCLD    ! timestep for cloud (s)
      REAL,      INTENT( IN )  :: TEMP      ! temperature (K)
      REAL,      INTENT( IN )  :: WCAVG     ! liquid water content (kg/m3)
      REAL,      INTENT( IN )  :: WTAVG     ! total water content (kg/m3)
      REAL( 8 ), INTENT( INOUT ) :: GAS    ( : )   ! gas phase concentrations (mol/molV)
      REAL( 8 ), INTENT( INOUT ) :: AEROSOL( :,: ) ! aerosol concentrations (mol/molV)
      REAL( 8 ), INTENT( INOUT ) :: GASWDEP( : )   ! gas phase wet deposition array (mm mol/liter)
      REAL( 8 ), INTENT( INOUT ) :: AERWDEP( :,: ) ! aerosol wet deposition array (mm mol/liter)
      REAL,      INTENT( IN )    :: COSZ     ! cosine solar zenith angle
      

C...........Local Variables (scalars):

      LOGICAL, SAVE :: FIRSTIME = .TRUE. ! flag for first pass thru
      LOGICAL :: DARK

      CHARACTER( 16 ), SAVE :: PNAME = 'AQCHEM'             ! driver program name

      INTEGER      ISPC            ! loop counter for species
      INTEGER      I20C            ! loop counter for do loop 20
      INTEGER      I30C            ! loop counter for do loop 30
      INTEGER      ITERAT          ! # iterations of aqueous chemistry solver
      INTEGER      I7777C          ! aqueous chem iteration counter
      INTEGER      ICNTAQ          ! aqueous chem iteration counter
      INTEGER      LIQ             ! loop counter for liquid species
      INTEGER      IGAS            ! loop counter for gas species
      INTEGER      IOX             ! index over oxidation reactions

      REAL( 8 ) :: DEPSUM
      REAL( 8 ) :: A               ! iron's anion concentration
      REAL( 8 ) :: HPLUS           ! H+ concentration in cloudwater (mol/liter)
      REAL( 8 ) :: ACT1            ! activity correction factor, single ions
      REAL( 8 ) :: ACT2            ! activity factor correction, double ions
      REAL( 8 ) :: ACTB            !
      REAL( 8 ) :: AE              ! guess for H+ conc in cloudwater (mol/liter)
      REAL( 8 ) :: B               ! manganese's anion concentration
      REAL( 8 ) :: PRES_ATM        ! pressure (Atm)
      REAL( 8 ) :: BB              ! lower limit guess of cloudwater pH
      REAL( 8 ) :: CA              ! Calcium conc in cloudwater (mol/liter)
      REAL( 8 ) :: CL              ! total Cl-  conc in cloudwater (mol/liter)
      REAL( 8 ) :: CLACC           ! fine Cl- in cloudwater (mol/liter)
      REAL( 8 ) :: CLCOR           ! coarse Cl-  conc in cloudwater (mol/liter)
      REAL( 8 ) :: CO2H            ! Henry's Law constant for CO2
      REAL( 8 ) :: CO21            ! First dissociation constant for CO2
      REAL( 8 ) :: CO22            ! Second dissociation constant for CO2
      REAL( 8 ) :: CO212           ! CO21*CO22
      REAL( 8 ) :: CO212H          ! CO2H*CO21*CO22
      REAL( 8 ) :: CO21H           ! CO2H*CO21
      REAL( 8 ) :: CO2L            ! CO2 conc in cloudwater (mol/liter)
      REAL( 8 ) :: CO3             ! CO3= conc in cloudwater (mol/liter)
      REAL( 8 ) :: CTHK1           ! cloud thickness (m)
      REAL( 8 ) :: DSIV_SCALE      ! mass conservation scale factor for S(IV)
      REAL( 8 ) :: DTRMV           !
      REAL( 8 ) :: DTS6            !
      REAL( 8 ) :: DGLYDT          ! change in GLY (mol/liter/sec)
      REAL( 8 ) :: DMGLYDT         ! change in MGLY (mol/liter/sec)
!     REAL( 8 ) :: DOHDT           ! change in OH
      REAL( 8 ) :: DGLY1           ! change due to Rxn. in GLY for DTW(0) time step
      REAL( 8 ) :: DMGLY1          ! change due to Rxn. in MGLY for DTW(0) time step
!     REAL( 8 ) :: DOH1            ! change in OH for DTW(0) time step
      REAL( 8 ) :: DORGC           ! change in ORGC for DTW(0) time step (mol/liter)
      REAL( 8 ) :: EBETASO4T       ! EXP( -BETASO4 * TAUCLD )
      REAL( 8 ) :: EALFA0T         ! EXP( -ALFA0 * TAUCLD )
      REAL( 8 ) :: EALFA2T         ! EXP( -ALFA2 * TAUCLD )
      REAL( 8 ) :: EALFA3T         ! EXP( -ALFA3 * TAUCLD )
      REAL( 8 ) :: EC              ! elemental carbon acc+akn aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: FA              ! functional value ??
      REAL( 8 ) :: FB              ! functional value ??
      REAL( 8 ) :: FCLCOR          ! frac weight of coarse CL to (acc+coarse) CL
      REAL( 8 ) :: FE              ! Fe+++ conc in cloudwater (mol/liter)
      REAL( 8 ) :: FHNO3           ! frac weight of HNO3 to total NO3
      REAL( 8 ) :: FNH3            ! frac weight of NH3 to total ammonia
      REAL( 8 ) :: FNH4ACC         ! frac weight of NH4 acc to total ammonia
      REAL( 8 ) :: FNH4COR         ! frac weight of coarse NH4 to (acc+coarse) NH4
      REAL( 8 ) :: FNO3ACC         ! frac weight of NO3 acc to total NO3     
      REAL( 8 ) :: FNO3COR         ! frac weight of coarse NO3 to (acc+coarse) NO3
      REAL( 8 ) :: FRACLIQ         ! fraction of water in liquid form
      REAL( 8 ) :: FOA1            ! First dissociation constant for FOA (Formic Acid)
      REAL( 8 ) :: FOAH            ! Henry's Law constant for FOA
      REAL( 8 ) :: FOA1H           ! FOAH*FOA1
      REAL( 8 ) :: FOAL            ! FOA conc in cloudwater (mol/liter)
      REAL( 8 ) :: FTST            !
      REAL( 8 ) :: GLYH            ! Henry's Law constant for glyoxal
      REAL( 8 ) :: GLYL            ! glyoxal conc in cloud water (mol/liter)
      REAL( 8 ) :: GM              !
      REAL( 8 ) :: GM1             !
      REAL( 8 ) :: GM1LOG          !
      REAL( 8 ) :: GM2             ! activity correction factor
      REAL( 8 ) :: GM2LOG          !
      REAL( 8 ) :: HA              !
      REAL( 8 ) :: HB              !
      REAL( 8 ) :: H2OW            !
      REAL( 8 ) :: H2O2H           ! Henry's Law Constant for H2O2
      REAL( 8 ) :: H2O2L           ! H2O2 conc in cloudwater (mol/liter)
      REAL( 8 ) :: HCLH            ! Henry's Law Constant for HCL
      REAL( 8 ) :: HCL1            ! First dissociation constant for HCL
      REAL( 8 ) :: HCL1H           ! HCL1*HCLH
      REAL( 8 ) :: HCLL            ! HCl  conc in  cloudwater (mol/liter)
      REAL( 8 ) :: HCO2            ! HCO2 conc in cloudwater (mol/liter)
      REAL( 8 ) :: HCO3            ! HCO3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: HNO3H           ! Henry's Law Constant for HNO3
      REAL( 8 ) :: HNO31           ! First dissociation constant for HNO3
      REAL( 8 ) :: HNO31H          !
      REAL( 8 ) :: HNO3L           ! HNO3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: HOH             ! Henry's Law Constant for HO
      REAL( 8 ) :: HSO3            ! HSO3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: HSO4            ! HSO4 concn in cloudwater (mol/liter)
      REAL( 8 ) :: HSO4ACC         ! accumulation mode HSO4 concn in cloudwater (mol/liter)
      REAL( 8 ) :: HSO4COR         ! coarse HSO4 concn in cloudwater (mol/liter)
      REAL( 8 ) :: HTST            !
      REAL( 8 ) :: K               ! K conc in cloudwater (mol/liter)
      !REAL( 8 ) :: LGTEMP          ! log of TEMP
      REAL( 8 ) :: MG              !
      REAL( 8 ) :: MGLYH           ! Henry's Law Constant for methylglyoxal
      REAL( 8 ) :: MGLYL           ! MGLY conc in cloud water (mol/liter)
      REAL( 8 ) :: MHPH            ! Henry's Law Constant for MHP
      REAL( 8 ) :: MHPL            ! MHP conc in cloudwater (mol/liter)
      REAL( 8 ) :: MN              ! Mn++ conc in cloudwater (mol/liter)
      REAL( 8 ) :: NA              ! Na conc in cloudwater (mol/liter)
      REAL( 8 ) :: NAACC           ! Na in cloudwater (mol/liter)
      REAL( 8 ) :: NACOR           ! coarse Na in cloudwater (mol/liter)
      REAL( 8 ) :: NH31            ! First dissociation constant for NH3
      REAL( 8 ) :: NH3H            ! Henry's Law Constant for NH3
      REAL( 8 ) :: NH3DH20         !
      REAL( 8 ) :: NH31HDH         !
      REAL( 8 ) :: NH3L            ! NH3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: NH4             ! NH4+ conc in cloudwater (mol/liter)
      REAL( 8 ) :: NH4ACC          ! NH4 acc conc in cloudwater (mol/liter)
      REAL( 8 ) :: NH4COR          ! NH4 coarse conc in cloudwater (mol/liter)
      !REAL( 8 ) :: NITAER          ! total aerosol nitrate
      REAL( 8 ) :: NO3             ! NO3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: NO3ACC          ! NO3 acc conc in cloudwater (mol/liter)
      REAL( 8 ) :: NO3COR          ! NO3 coarse conc in cloudwater (mol/liter)
      REAL( 8 ) :: NUMCOR          ! coarse aerosol number in cloudwater (mol/liter)
      REAL( 8 ) :: O3H             ! Henry's Law Constant for O3
      REAL( 8 ) :: O3L             ! O3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: OH              ! OH conc in cloudwater (mol/liter)
      REAL( 8 ) :: OHL             ! OH radical conc in cloudwater (mol/liter)
      REAL( 8 ) :: SOA             ! secondary organic aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: ORGC            ! cloud-produced SOA in cloudwater (treated as primary)
      REAL( 8 ) :: POA             ! primary organic aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: PAAH            ! Henry's Law Constant for PAA
      REAL( 8 ) :: PAAL            ! PAA conc in cloudwater (mol/liter)
      REAL( 8 ) :: PCO2F           ! gas only CO2 partial pressure (atm)
      REAL( 8 ) :: PFOAF           ! gas only ORGANIC ACID partial press (atm)
      REAL( 8 ) :: PGLYF           ! gas only GLY partial pressure (atm)
      REAL( 8 ) :: PH2O2F          ! gas only H2O2 partial pressure (atm)
      REAL( 8 ) :: PHCLF           ! gas only HCL partial pressure (atm)
      REAL( 8 ) :: PHNO3F          ! gas only HNO3 partial pressure (atm)
      REAL( 8 ) :: PHOF            ! gas only HO partial pressure (atm)
      REAL( 8 ) :: PMGLYF          ! gas only MGLY parital pressure (atm)
      REAL( 8 ) :: PMHPF           ! gas only MHP partial pressure (atm)
      REAL( 8 ) :: PNH3F           ! gas only NH3 partial pressure (atm)
      REAL( 8 ) :: PO3F            ! gas only O3 partial pressure (atm)
      REAL( 8 ) :: PPAAF           ! gas only PAA partial pressure (atm)
      REAL( 8 ) :: PRIM            ! PRIMARY acc+akn aerosol in cloudwater (mol/liter)
!     REAL( 8 ) :: PRIMCOR         ! PRIMARY coarse aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: PSO2F           ! gas only SO2 partial pressure (atm)
      !REAL( 8 ) :: RATE            !
      REAL( 8 ) :: RECIPA1         !
      REAL( 8 ) :: RECIPA2         !
      REAL( 8 ) :: RECIPAP1        ! one over pressure (/atm)
      REAL( 8 ) :: RGLY3           ! liter/(mol sec)
      REAL( 8 ) :: RH2O2           !
      REAL( 8 ) :: RMGLY3          ! liter/(mol sec)
      REAL( 8 ) :: RMHP            !
      REAL( 8 ) :: RPAA            !
      REAL( 8 ) :: RT              ! gas const * temperature (liter atm/mol)
      REAL( 8 ) :: SIV             ! dissolved so2 in cloudwater (mol/liter)
      REAL( 8 ) :: SK6             !
      REAL( 8 ) :: SK6TS6          !
      REAL( 8 ) :: SO21            ! First dissociation constant for SO2
      REAL( 8 ) :: SO22            ! Second dissociation constant for SO2
      REAL( 8 ) :: SO2H            ! Henry's Law Constant for SO2
      REAL( 8 ) :: SO212           ! SO21*SO22
      REAL( 8 ) :: SO212H          ! SO21*SO22*SO2H
      REAL( 8 ) :: SO21H           ! SO21*SO2H
      REAL( 8 ) :: SO2L            ! SO2 conc in cloudwater (mol/liter)
      REAL( 8 ) :: SO3             ! SO3= conc in cloudwater (mol/liter)
      REAL( 8 ) :: SO4             ! SO4= conc in cloudwater (mol/liter)
      REAL( 8 ) :: SO4ACC          ! accumulation mode SO4= conc in cloudwater (mol/liter)
      REAL( 8 ) :: SO4COR          ! coarse SO4= conc in cloudwater (mol/liter)
      REAL( 8 ) :: STION           ! ionic strength
      REAL( 8 ) :: TAC             !
      REAL( 8 ) :: TCLa            ! sum of accumulation and coarse mode chloride
      REAL( 8 ) :: TEMP1           ! (1/T) - (1/298) (1/K)
      REAL( 8 ) :: TIMEW           ! cloud chemistry clock (sec)
!     REAL( 8 ) :: THO             ! total hydroxyl radical available for oxidation
      REAL( 8 ) :: TGLY            ! total glyoxal available for oxidation
      REAL( 8 ) :: TMGLY           ! total methylglyoxal available for oxidation
      !REAL( 8 ) :: TOTOX           !
      REAL( 8 ) :: TH2O2
      REAL( 8 ) :: TO3
      REAL( 8 ) :: TMHP      
      REAL( 8 ) :: TNH4a           ! sum of accumulation and coarse mode ammonium
      REAL( 8 ) :: TNO3a           ! sum of accumulation and coarse mode nitrate      
      REAL( 8 ) :: TPAA
      REAL( 8 ) :: TOTAMM          ! total ammonium
      REAL( 8 ) :: TOTNIT          ! total nitrate (excluding coarse mode)
      REAL( 8 ) :: TS6             ! SO4 conc in cloudwater (mol/liter)
      REAL( 8 ) :: TS6ACC          ! SO4 acc conc in cloudwater (mol/liter)
      REAL( 8 ) :: TS6COR          ! coarse SO4 conc in cloudwater   (mol/liter)
C...for sulfur tracking
      REAL( 8 ) :: TS6AQH2O2       ! SO4 conc from reaction 1 (mol/liter)
      REAL( 8 ) :: TS6AQO3         ! SO4 conc from reaction 2 (mol/liter)
      REAL( 8 ) :: TS6AQFEMN       ! SO4 conc from reaction 3 (mol/liter)
      REAL( 8 ) :: TS6AQMHP        ! SO4 conc from reaction 4 (mol/liter)
      REAL( 8 ) :: TS6AQPAA        ! SO4 conc from reaction 5 (mol/liter)

      REAL( 8 ) :: TSIV            ! total S(iv) available for oxidation
      REAL( 8 ) :: TST             !
      REAL( 8 ) :: TWASH           ! washout time for clouds (sec)
      REAL( 8 ) :: WETFAC          ! converts mol/l to mm-mol/l based on precip
      REAL( 8 ) :: XC1             ! (/mm)
      REAL( 8 ) :: XC2             ! (liter-atm/mol/mm)
      REAL( 8 ) :: XL              ! conversion factor (liter-atm/mol)
      REAL( 8 ) :: ONE_OVER_XL     ! 1.0 / XL
      REAL( 8 ) :: PRES_ATM_OVER_XL ! PRES_ATM / XL
      REAL( 8 ) :: SCAVENGED       ! aitken scavenging factor by cloud water
      REAL( 8 ) :: XLCO2           !
      REAL( 8 ) :: XLH2O2          !
      REAL( 8 ) :: XLHCL           ! const in calc of HCL final partial pres
      REAL( 8 ) :: XLHNO3          !
      REAL( 8 ) :: XLMHP           !
      REAL( 8 ) :: XLNH3           !
      REAL( 8 ) :: XLO3            !
      REAL( 8 ) :: XLPAA           !
      REAL( 8 ) :: XLSO2           !
      REAL( 8 ) :: CAACC           ! accumulation mode Calcium (AE6) SLN 16March2011
      REAL( 8 ) :: MGACC           ! accumulation mode Magnesium (AE6) SLN 16March2011
      REAL( 8 ) :: KACC            ! accumulation mode Potassium (AE6) SLN 16March2011
      REAL( 8 ) :: CACOR           ! coarse mode Calcium (AE6) SLN 16March2011
      REAL( 8 ) :: MGCOR           ! coarse mode Magnesium (AE6) SLN 16March2011
      REAL( 8 ) :: KCOR            ! coarse mode Potassium (AE6) SLN 16March2011
      REAL( 8 ) :: SOILCOR         ! coarse mode SOIL (AE6) SLN 16March2011
      REAL( 8 ) :: ANTHCOR         ! coarse mode CORS (AE6) SLN 16March2011
      REAL( 8 ) :: SEASCOR         ! coarse mode SEAS (AE6) SLN 16March2011
      REAL( 8 ) :: FEACC           ! accumulation mode Fe (AE6) SLN 22March2011
      REAL( 8 ) :: MNACC           ! accumulation mode Mn (AE6) SLN 22March2011
      REAL( 8 ) :: FECOR           ! coarse mode Fe (AE6) SLN 22March2011
      REAL( 8 ) :: MNCOR           ! coarse mode Mn (AE6) SLN 22March2011
      REAL( 8 ) :: FE_OX           ! Fe(III) available for sulfate oxidation
      REAL( 8 ) :: MN_OX           ! Mn(II) available for sulfate oxidation
      REAL( 8 ) :: FE_III          ! Fractional Fe(III) partitioning, GS - July 1, 2011
      REAL( 8 ) :: MN_II           ! Fractional Mn(II) partitioning, GS - July 1, 2011

      REAL( 8 ) :: FE_SOL          ! Fractional Fe solubility, GS - July 1, 2011
      REAL( 8 ) :: MN_SOL          ! Fractional Mn solubility, GS - July 1, 2011
					    
      REAL( 8 ) :: TRACI, POAI, PRII, SOAI

C...for PFAS
      REAL( 8 ) :: RHFPODAF        ! HFPO-DAF hydrolysis rate, sec-1
      REAL( 8 ) :: DHFPODAchyd1    ! production of HFPO-DA (mol/L)
      REAL( 8 ) :: DHFPODAF1       ! loss of HFPO-DAF (mol/L)
      REAL( 8 ) :: HFPODAchyd_xi   ! HFPODAF cloud hydrolysis product gas-phase fraction, unitless
      REAL( 8 ) :: HFPODAF_xi      ! HFPODAF gas-phase fraction, unitless
      REAL( 8 ) :: HFPODAchydH     ! Henry's law (M / atm)
      REAL( 8 ) :: HFPODAFH        ! Henry's law (M / atm)
      REAL( 8 ) :: PHFPODAchydF    ! gas pressure (atm)
      REAL( 8 ) :: PHFPODAFF       ! gas pressure (atm)
      REAL( 8 ) :: THFPODAF        ! total HFPODAF available for oxidation (unit??)
      REAL( 8 ) :: DHFPODADT       ! GenX formation rate (mol/L/s)
      REAL( 8 ) :: HFPODAF_L       ! HFPODAF conc in cloud water (moles/liter)
      REAL( 8 ) :: HFPODAchyd_L    ! HFPODA in cloud water (moles/liter)
      REAL( 8 ) :: RCOF2           ! COF2 hydrolysis rate, sec-1
      REAL( 8 ) :: DFCOOHchyd1     ! production of FCOOH (mol/L)
      REAL( 8 ) :: DCOF21          ! loss of COF2 (mol/L)
      REAL( 8 ) :: FCOOHchyd_xi    ! COF2 cloud hydrolysis product gas-phase fraction, unitless
      REAL( 8 ) :: COF2_xi         ! COF2 gas-phase fraction, unitless
      REAL( 8 ) :: FCOOHchydH      ! Henry's law (M / atm)
      REAL( 8 ) :: COF2H           ! Henry's law (M / atm)
      REAL( 8 ) :: PFCOOHchydF     ! gas pressure (atm)
      REAL( 8 ) :: PCOF2F          ! gas pressure (atm)
      REAL( 8 ) :: TCOF2           ! total COF2 available for oxidation (unit??)
      REAL( 8 ) :: DFCOOHDT        ! GenX formation rate (mol/L/s)
      REAL( 8 ) :: COF2_L          ! COF2 conc in cloud water (moles/liter)
      REAL( 8 ) :: FCOOHchyd_L     ! FCOOH in cloud water (moles/liter)
      REAL( 8 ) :: RPFMOAF         ! COF2 hydrolysis rate, sec-1
      REAL( 8 ) :: DPFMOAAchyd1    ! production of FCOOH (mol/L)
      REAL( 8 ) :: DPFMOAF1        ! loss of COF2 (mol/L)
      REAL( 8 ) :: PFMOAAchyd_xi   ! PFMOAF cloud hydrolysis product gas-phase fraction, unitless
      REAL( 8 ) :: PFMOAF_xi       ! PFMOAF gas-phase fraction, unitless
      REAL( 8 ) :: PFMOAAchydH     ! Henry's law (M / atm)
      REAL( 8 ) :: PFMOAFH         ! Henry's law (M / atm)
      REAL( 8 ) :: PPFMOAAchydF    ! gas pressure (atm)
      REAL( 8 ) :: PPFMOAFF        ! gas pressure (atm)
      REAL( 8 ) :: TPFMOAF         ! total COF2 available for oxidation (unit??)
      REAL( 8 ) :: DPFMOAADT       ! GenX formation rate (mol/L/s)
      REAL( 8 ) :: PFMOAF_L        ! COF2 conc in cloud water (moles/liter)
      REAL( 8 ) :: PFMOAAchyd_L    ! FCOOH in cloud water (moles/liter)


      REAL( 8 ), SAVE :: SOIL_FE_FAC  ! Fe molar fraction of ASOIL
      REAL( 8 ), SAVE :: CORS_FE_FAC  ! Fe molar fraction of ACORS
      REAL( 8 ), SAVE :: SOIL_MN_FAC  ! etc.
      REAL( 8 ), SAVE :: CORS_MN_FAC
      REAL( 8 ), SAVE :: SEAS_NA_FAC  ! Na molar fraction of ASEACAT
      REAL( 8 ), SAVE :: SOIL_NA_FAC
      REAL( 8 ), SAVE :: CORS_NA_FAC
      REAL( 8 ), SAVE :: SEAS_MG_FAC
      REAL( 8 ), SAVE :: SOIL_MG_FAC
      REAL( 8 ), SAVE :: CORS_MG_FAC
      REAL( 8 ), SAVE :: SEAS_CA_FAC
      REAL( 8 ), SAVE :: SOIL_CA_FAC
      REAL( 8 ), SAVE :: CORS_CA_FAC
      REAL( 8 ), SAVE :: SEAS_K_FAC
      REAL( 8 ), SAVE :: SOIL_K_FAC
      REAL( 8 ), SAVE :: CORS_K_FAC

C...........Local Variables (arrays):

      REAL( 8 ) :: LOADING( N_AQ_AER, N_MODE ) ! aerosol loading (mol/liter)
      REAL( 8 ) :: INITGAS( N_AQ_GAS ) ! initial gas partial pressure (atm)
      REAL( 8 ) :: LIQUID( N_AQ_LIQS ) ! wet deposition array (mm mol/liter)
      REAL( 8 ) :: WETDEP( N_AQ_LIQS ) ! wet deposition array (mm mol/liter)
      REAL( 8 ) :: DSIVDT( 0:NUMOX ) ! rate of so2 oxid incloud (mol/liter/sec)
      REAL( 8 ) :: DS4   ( 0:NUMOX ) ! S(IV) oxidized over timestep DTW(0)
      REAL( 8 ) :: DTW   ( 0:NUMOX ) ! cloud chemistry timestep (sec)

      REAL( 8 ) :: ONE_OVER_TEMP     ! 1.0 / TEMP

!For Variable used by TXHG Version
      !LOGICAL, SAVE :: TRUST_TXHG_CHEM = .TRUE.  ! allow effects for TXHG version on ion and ph
      REAL( 8 ) :: TRACER           ! TRACER acc+akn aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: TRACERCOR        ! TRACER coarse aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: HGFINE           ! mercury PM acc+akn aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: HGCOR            ! mercury PM coarse aerosol in cloudwater (mol/liter)


#ifdef sens
      INCLUDE 'AQCHEM_DDM3D.EXT'   ! ddm-3d variables 
#endif


C*********************************************************************

C...Initialization

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

C... set MW ratios and speciation factors for molar concentrations of coarse
C... soluble aerosols

        SOIL_FE_FAC = ASOIL_FE_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AFE_IDX ), 8 ) / ASOIL_RENORM
        CORS_FE_FAC = ACORS_FE_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AFE_IDX ), 8 ) / ACORSEM_RENORM

        SOIL_MN_FAC = ASOIL_MN_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AMN_IDX ), 8 ) / ASOIL_RENORM
        CORS_MN_FAC = ACORS_MN_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AMN_IDX ), 8 ) / ACORSEM_RENORM

        SEAS_NA_FAC = ASCAT_NA_FAC * REAL( AEROSPC_MW( ASEACAT_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ANA_IDX ), 8 )
        SOIL_NA_FAC = ASOIL_NA_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ANA_IDX ), 8 ) / ASOIL_RENORM
        CORS_NA_FAC = ACORS_NA_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ANA_IDX ), 8 ) / ACORSEM_RENORM

        SEAS_MG_FAC = ASCAT_MG_FAC * REAL( AEROSPC_MW( ASEACAT_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AMG_IDX ), 8 )
        SOIL_MG_FAC = ASOIL_MG_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AMG_IDX ), 8 ) / ASOIL_RENORM
        CORS_MG_FAC = ACORS_MG_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AMG_IDX ), 8 ) / ACORSEM_RENORM

        SEAS_CA_FAC = ASCAT_CA_FAC * REAL( AEROSPC_MW( ASEACAT_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ACA_IDX ), 8 )
        SOIL_CA_FAC = ASOIL_CA_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ACA_IDX ), 8 ) / ASOIL_RENORM
        CORS_CA_FAC = ACORS_CA_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ACA_IDX ), 8 ) / ACORSEM_RENORM

        SEAS_K_FAC = ASCAT_K_FAC * REAL( AEROSPC_MW( ASEACAT_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AK_IDX ), 8 )
        SOIL_K_FAC = ASOIL_K_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AK_IDX ), 8 ) / ASOIL_RENORM
        CORS_K_FAC = ACORS_K_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AK_IDX ), 8 ) / ACORSEM_RENORM

        
      END IF    ! FIRSTIME

      ONE_OVER_TEMP = 1.0D0 / TEMP

C...check for bad temperature, cloud air mass, or pressure

      IF ( TEMP .LE. 0.0D0 .OR. AIRM .LE. 0.0D0 .OR. PRES_PA .LE. 0.0D0 ) THEN
        XMSG = 'MET DATA ERROR'
        CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
      END IF

C...  determine day or night from cosine of zenith angle for the cell; Golam Sarwar

            IF ( COSZ .LE. 0.0 ) THEN
              DARK = .TRUE.   ! night
            ELSE
              DARK = .FALSE.  ! day
            END IF

C...initialize counters and compute several conversion factors

      ICNTAQ     = 0
      ITERAT     = 0
      DSIV_SCALE = 1.0D0
      RT         = ( MOLVOL / STDTEMP ) * TEMP         ! R * T (liter atm / mol)
      PRES_ATM   = PRES_PA /  STDATMPA                 ! pressure (atm)
      CTHK1      = AIRM * RT / ( PRES_ATM * 1000.0D0 ) ! cloud thickness (m)
      XL         = WCAVG * RT / H2ODENS                ! conversion factor (l-atm/mol)
      ONE_OVER_XL      = 1.0D0 / XL
      PRES_ATM_OVER_XL = PRES_ATM / XL
      TST       = 0.999D0
      GM        = SCVEFF / 100.0D0
      ACT1      = 1.0D0
      ACT2      = 1.0D0
      GM2       = 1.0D0
      TIMEW     = 0.0D0
      RECIPAP1  = 1.0D0 / PRES_ATM
      XC1       = 1.0D0 / ( WCAVG * CTHK1 )
      XC2       = RT / ( 1000.0D0 * CTHK1 )
      FRACLIQ   = WCAVG / WTAVG
      TWASH     = WTAVG * 1000.0D0 * CTHK1 * 3600.0D0
     &          / ( H2ODENS * MAX( 1.0D-20, REAL( PRCRATE,8 ) ) )

C...set equilibrium constants as a function of temperature
C...   Henry`s law constants

      SO2H  = HLCONST( HLC_SO2       , TEMP, .FALSE., 0.0 )
      CO2H  = HLCONST( HLC_CO2       , TEMP, .FALSE., 0.0 )
      NH3H  = HLCONST( HLC_NH3       , TEMP, .FALSE., 0.0 )
      H2O2H = HLCONST( HLC_H2O2      , TEMP, .FALSE., 0.0 )
      O3H   = HLCONST( HLC_O3        , TEMP, .FALSE., 0.0 )
      HCLH  = HLCONST( HLC_HCL       , TEMP, .FALSE., 0.0 )
      HNO3H = HLCONST( HLC_HNO3      , TEMP, .FALSE., 0.0 )
      MHPH  = HLCONST( HLC_MHYDPOX   , TEMP, .FALSE., 0.0 )
      PAAH  = HLCONST( HLC_PEROXYACET, TEMP, .FALSE., 0.0 )
      FOAH  = HLCONST( HLC_HCOOH     , TEMP, .FALSE., 0.0 )
      GLYH  = HLCONST( HLC_GLY       , TEMP, .FALSE., 0.0 )
      MGLYH = HLCONST( HLC_MGLY      , TEMP, .FALSE., 0.0 )
      HOH   = HLCONST( HLC_OH        , TEMP, .FALSE., 0.0 )

      TEMP1 = ONE_OVER_TEMP - 1.0D0 / 298.0D0

C...dissociation constants

      FOA1  = 1.80D-04 * EXP( -2.00D+01 * TEMP1 )      ! Martell and Smith (1977)
      SK6   = 1.02D-02 * EXP(  2.72D+03 * TEMP1 )      ! Smith and Martell (1976)
      SO21  = 1.30D-02 * EXP(  1.96D+03 * TEMP1 )      ! Smith and Martell (1976)
      SO22  = 6.60D-08 * EXP(  1.50D+03 * TEMP1 )      ! Smith and Martell (1976)
      CO21  = 4.30D-07 * EXP( -1.00D+03 * TEMP1 )      ! Smith and Martell (1976)
      CO22  = 4.68D-11 * EXP( -1.76D+03 * TEMP1 )      ! Smith and Martell (1976)
      H2OW  = 1.00D-14 * EXP( -6.71D+03 * TEMP1 )      ! Smith and Martell (1976)
      NH31  = 1.70D-05 * EXP( -4.50D+02 * TEMP1 )      ! Smith and Martell (1976)
      HCL1  = 1.74D+06 * EXP(  6.90D+03 * TEMP1 )      ! Marsh and McElroy (1985)
      HNO31 = 1.54D+01 * EXP(  8.70D+03 * TEMP1 )      ! Schwartz (1984)

C...Kinetic oxidation rates

C...   From Jacobson  (1997)

      RH2O2 = 7.45D+07 * EXP( -15.96D0 * ( ( 298.0D0 / TEMP )  - 1.0D0 ) )
      RMHP  = 1.90D+07 * EXP( -12.75D0 * ( ( 298.0D0 / TEMP )  - 1.0D0 ) )
      RPAA  = 3.60D+07 * EXP( -13.42D0 * ( ( 298.0D0 / TEMP )  - 1.0D0 ) )

C...From Carlton et al. (2007)

      RGLY3  = 3.0D+10   ! rate constant measured at 298K
      RMGLY3 = 3.0D+10   ! assumed to be the same as GLY
                         ! units = L/mol/s

C...Define Hydrolysis Rate Constant
      RHFPODAF = 8.3D-1*55.6   ! s-1, calculated by Ivan, 01/31/2025
      RCOF2    = 8.3D-1*55.6   ! s-1, calculated by Ivan, 01/31/2025
      RPFMOAF  = 8.3D-1*55.6   ! s-1, calculated by Ivan, 01/31/2025
!55.6 is multiplying the second-order rate constant (in units of s-1 M-1)
!calculated by Ivan by the bulk water concentration in units of M

C...make initializations

      WETDEP  = 0.0D0
      LOADING = 0.0D0
      INITGAS = 0.0D0

      DSIVDT = 0.0D0
      DTW    = 0.0D0
      DS4    = 0.0D0

      DGLY1  = 0.0D0
      DMGLY1 = 0.0D0
      DORGC  = 0.0D0

      DHFPODAchyd1 = 0.0D0
      DHFPODAF1    = 0.0D0
      DFCOOHchyd1  = 0.0D0
      DCOF21       = 0.0D0
      DPFMOAAchyd1 = 0.0D0
      DPFMOAF1     = 0.0D0

#ifdef sens 
      S_WETDEP = 0.0D0
      S_LOADING = 0.0D0
      S_INITGAS = 0.0D0

      S_DSIVDT = 0.0D0
      S_DS4    = 0.0D0

      S_DGLY1  = 0.0D0
      S_DMGLY1 = 0.0D0
      S_DORGC  = 0.0D0
#endif

#ifdef isam
      DGLY1_SAVE = 0.0D0
      DMGLY1_SAVE = 0.0D0
#endif

C...compute fractional weights for several species

      TOTNIT = GAS( LHNO3 ) + AEROSOL( LNO3, IACC )
      IF ( TOTNIT .GT. 0.0D0 ) THEN
        FHNO3   = GAS( LHNO3 ) / TOTNIT
        FNO3ACC = AEROSOL( LNO3, IACC ) / TOTNIT
      ELSE
        FHNO3   = 1.0D0
        FNO3ACC = 0.0D0
      END IF

      TOTAMM = GAS( LNH3 ) + AEROSOL( LNH4, IACC )
      IF ( TOTAMM .GT. 0.0D0 ) THEN
        FNH3    = GAS( LNH3 ) / TOTAMM
        FNH4ACC = AEROSOL( LNH4, IACC ) / TOTAMM
      ELSE
        FNH3    = 1.0D0
        FNH4ACC = 0.0D0
      END IF

      TNO3a = AEROSOL( LNO3, IACC ) + AEROSOL( LNO3, ICOR ) 
      IF ( TNO3a .GT. 0.0D0) THEN
         FNO3COR = AEROSOL( LNO3, ICOR ) / TNO3a
      ELSE
         FNO3COR = 0.0D0
      END IF
      
      TNH4a = AEROSOL( LNH4, IACC ) + AEROSOL( LNH4, ICOR )
      IF ( TNH4a .GT. 0.0D0) THEN
         FNH4COR = AEROSOL( LNH4, ICOR ) / TNH4a
      ELSE
         FNH4COR = 0.0D0
      END IF
      
      TCLa  = AEROSOL( LCL, IACC )  + AEROSOL( LCL, ICOR )
      IF ( TCLa .GT. 0.0D0) THEN
         FCLCOR = AEROSOL( LCL, ICOR ) / TCLa
      ELSE
         FCLCOR = 0.0D0
      END IF

#ifdef sens
      DO NP = 1, NPMAX

        S_TOTNIT( NP ) = S_GAS( NP, LHNO3 ) + S_AEROSOL( NP, LNO3, IACC )
        IF ( S_TOTNIT( NP ) .NE. 0.0D0 ) THEN
          S_FHNO3( NP )   = S_GAS( NP,LHNO3 ) / S_TOTNIT( NP )
          S_FNO3ACC( NP ) = S_AEROSOL( NP,LNO3, IACC ) / S_TOTNIT( NP )
        ELSE
          S_FHNO3( NP )   = 1.0D0
          S_FNO3ACC( NP ) = 0.0D0
        END IF

        S_TOTAMM( NP ) = S_GAS( NP, LNH3 ) + S_AEROSOL( NP, LNH4, IACC )
        IF ( S_TOTAMM( NP ) .NE. 0.0D0 ) THEN
          S_FNH3( NP )    = S_GAS( NP, LNH3 ) / S_TOTAMM( NP )
          S_FNH4ACC( NP ) = S_AEROSOL( NP, LNH4, IACC ) / S_TOTAMM( NP )
        ELSE
          S_FNH3( NP )    = 1.0D0
          S_FNH4ACC( NP ) = 0.0D0
        END IF

      END DO
#endif
      
C...Assign fraction partitioning of FE(III) and MN(II)

      IF ( DARK ) THEN
        FE_III = 0.9D0  ! Night time, GS 01July2011
      ELSE
        FE_III = 0.1D0  ! Day time, GS 01July2011
      END IF

      MN_II = 1.0D0                     ! Same for day and night, GS  01July2011

C...Assign solubility of Fe and Mn

      FE_SOL = 0.1D0                   ! GS 01July2011
      MN_SOL = 0.5D0                   ! GS 28July2011

C...initial concentration from accumulation-mode aerosol loading (mol/liter)
C...  an assumption is made that all of the accumulation-mode
C...  aerosol mass in incorporated into the cloud droplets

      DO ISPC = 1, N_AQ_AER
        LOADING( ISPC, IACC ) = AEROSOL( ISPC, IACC ) * PRES_ATM_OVER_XL
      END DO

      LOADING( LSO4, IACC ) = ( AEROSOL( LSO4, IACC ) + GAS( LH2SO4 ) ) * PRES_ATM_OVER_XL

#ifdef sens
      DO NP = 1, NPMAX
        DO ISPC = 1, N_AQ_AER
           S_LOADING( NP,ISPC, IACC ) = S_AEROSOL( NP,ISPC, IACC ) * PRES_ATM_OVER_XL
        END DO
        S_LOADING( NP,LSO4, IACC ) = ( S_AEROSOL( NP,LSO4, IACC ) + S_GAS( NP,LH2SO4 ) ) * PRES_ATM_OVER_XL
      END DO
#endif

C...initial concentration from coarse-mode aerosol loading (mol/liter)
C...  an assumption is made that all of the coarse-mode
C...  aerosol mass in incorporated into the cloud droplets

      DO ISPC = 1, N_AQ_AER
        LOADING( ISPC, ICOR ) = AEROSOL( ISPC, ICOR ) * PRES_ATM_OVER_XL
      END DO

#ifdef sens
      DO NP = 1, NPMAX
        DO ISPC = 1, N_AQ_AER
          S_LOADING( NP, ISPC, ICOR ) = S_AEROSOL( NP,ISPC, ICOR ) * PRES_ATM_OVER_XL
        END DO
      END DO
#endif

C...set constant factors that will be used in later multiplications (moles/atm)

      XLH2O2  = H2O2H * XL
      XLO3    = O3H   * XL
      XLMHP   = MHPH  * XL
      XLPAA   = PAAH  * XL
      XLSO2   = SO2H  * XL
      XLNH3   = NH3H  * XL
      XLHCL   = HCLH  * XL
      XLHNO3  = HNO3H * XL
      XLCO2   = CO2H  * XL

      SO212   = SO21  * SO22
      SO21H   = SO21  * SO2H
      SO212H  = SO212 * SO2H
      CO212   = CO21  * CO22
      CO21H   = CO21  * CO2H
      CO212H  = CO22  * CO21H
      NH3DH20 = NH31  / H2OW
      NH31HDH = NH3H  * NH3DH20
      FOA1H   = FOA1  * FOAH
      HCL1H   = HCL1  * HCLH
      HNO31H  = HNO31 * HNO3H

      ! particle-phase fraction of carb acid produced in the cloud and
      ! primary acyl fluoride
      ! values are unitless
      HFPODAchyd_xi = (LOADING( LHFPODAchyd_p, iacc )) 
     &                / ((GAS( LHFPODAchyd_g ) * PRES_ATM) + 
     &                (LOADING( LHFPODAchyd_p, iacc )) + 1.0E-24 )  
      HFPODAF_xi    = (LOADING( LHFPODAF_p, iacc )) 
     &                / ((GAS( LHFPODAF_g ) * PRES_ATM) + 
     &                (LOADING( LHFPODAF_p, iacc )) + 1.0E-24 )
      FCOOHchyd_xi = (LOADING( LFCOOHchyd_p, iacc ))
     &                / ((GAS( LFCOOHchyd_g ) * PRES_ATM) +
     &                (LOADING( LFCOOHchyd_p, iacc )) + 1.0E-24 )
      COF2_xi    = (LOADING( LCOF2_p, iacc ))
     &                / ((GAS( LCOF2_g ) * PRES_ATM) +
     &                (LOADING( LCOF2_p, iacc )) + 1.0E-24 )
      PFMOAAchyd_xi = (LOADING( LPFMOAAchyd_p, iacc ))
     &                / ((GAS( LPFMOAAchyd_g ) * PRES_ATM) +
     &                (LOADING( LPFMOAAchyd_p, iacc )) + 1.0E-24 )
      PFMOAF_xi    = (LOADING( LPFMOAF_p, iacc ))
     &                / ((GAS( LPFMOAF_g ) * PRES_ATM) +
     &                (LOADING( LPFMOAF_p, iacc )) + 1.0E-24 )

C...loop If kinetic calculations are made, return to this point

      DO I20C = 1, 10001

        IF ( I20C .GE. 10000 ) THEN
          XMSG = 'EXCESSIVE LOOPING AT I20C'
          CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
        END IF

C...set aitken-mode aerosol loading (mol/liter)

        SCAVENGED = PRES_ATM_OVER_XL * ( 1.0D0 - EXP( -REAL( ALFA3, 8 ) * TIMEW ) )
        DO ISPC = 1, N_AQ_AER
          LOADING( ISPC, IAIT ) = AEROSOL( ISPC, IAIT ) * SCAVENGED
        END DO

#ifdef sens
        DO NP = 1, NPMAX
          DO ISPC = 1, N_AQ_AER
            S_LOADING( NP, ISPC, IAIT ) = S_AEROSOL( NP, ISPC, IAIT ) * SCAVENGED
          END DO
        END DO
#endif

C...Initial gas phase partial pressures (atm)
C...   = initial partial pressure - amount deposited partial pressure

        INITGAS( LSO2 )  = GAS( LSO2  ) * PRES_ATM
     &                   + DS4( 0 ) * XL
     &                   - ( WETDEP( LSO3L ) + WETDEP( LHSO3L ) + WETDEP( LSO2L ) ) * XC2
        INITGAS( LNH3 )  = GAS( LNH3  ) * PRES_ATM
     &                   + ( LOADING( LNH4, IACC ) + LOADING( LNH4, ICOR ) + LOADING( LNH4, IAIT ) ) * XL
     &                   - ( WETDEP( LNH4ACCL ) + WETDEP( LNH3L ) + WETDEP( LNH4CORL ) ) * XC2
        INITGAS( LHNO3 ) = ( GAS( LHNO3 ) + 2.0 * GAS( LN2O5 ) ) * PRES_ATM
     &                   + ( LOADING( LNO3, IACC ) + LOADING( LNO3, ICOR ) + LOADING( LNO3, IAIT ) ) * XL
     &                   - ( WETDEP( LNO3ACCL ) + WETDEP( LHNO3L ) + WETDEP( LNO3CORL ) ) * XC2
        INITGAS( LHCL )  = GAS(  LHCL ) * PRES_ATM
     &                   + ( LOADING( LCL, IACC ) + LOADING( LCL, ICOR ) + LOADING( LCL, IAIT ) ) * XL ! new for sea salt
     &                   - ( WETDEP( LCLACCL ) + WETDEP( LHCLL ) + WETDEP( LCLCORL ) ) * XC2
        INITGAS( LH2O2 ) = GAS( LH2O2 ) * PRES_ATM - WETDEP( LH2O2L ) * XC2
        INITGAS( LO3 )   = GAS( LO3   ) * PRES_ATM - WETDEP( LO3L   ) * XC2
        INITGAS( LFOA )  = GAS( LFOA  ) * PRES_ATM
     &                   - ( WETDEP( LFOAL ) + WETDEP( LHCO2L ) ) * XC2
        INITGAS( LMHP )  = GAS( LMHP  ) * PRES_ATM - WETDEP( LMHPL  ) * XC2
        INITGAS( LPAA )  = GAS( LPAA  ) * PRES_ATM - WETDEP( LPAAL  ) * XC2
        INITGAS( LCO2 )  = GAS( LCO2  ) * PRES_ATM
!    &                   + ( LOADING( LCACO3, COR ) + LOADING( LMGCO3, COR ) ) * XL
     &                   - ( WETDEP( LCO3L ) + WETDEP( LHCO3L ) + WETDEP( LCO2L ) ) * XC2
        INITGAS( LGLY )  = GAS( LGLY  ) * PRES_ATM
     &                   + DGLY1 * XL
     &                   - WETDEP( LGLYL ) * XC2
        INITGAS( LMGLY ) = GAS( LMGLY  ) * PRES_ATM
     &                   + DMGLY1 * XL
     &                   - WETDEP( LMGLYL ) * XC2
        INITGAS( LHO )   = GAS( LHO ) * PRES_ATM
!steadystate     &                   + DOH1 * XL
!steadystate     &                   - WETDEP( LOHL ) * XC2


! calculate total available GenX and assign it to the gas phase
        INITGAS( LHFPODAchyd_g )  = GAS( LHFPODAchyd_g  ) * PRES_ATM 
     &                   + LOADING ( LHFPODAchyd_p, IACC ) * XL
     &                   + DHFPODAchyd1 * XL
     &                   - WETDEP( LHFPODAchyd_l ) * XC2
        INITGAS( LHFPODAF_g )  = GAS( LHFPODAF_g  ) * PRES_ATM
     &                   + LOADING ( LHFPODAF_p, IACC ) * XL
     &                   + DHFPODAF1 * XL
     &                   - WETDEP( LHFPODAF_l ) * XC2
        INITGAS( LFCOOHchyd_g )  = GAS( LFCOOHchyd_g  ) * PRES_ATM
     &                   + LOADING ( LFCOOHchyd_p, IACC ) * XL
     &                   + DFCOOHchyd1 * XL
     &                   - WETDEP( LFCOOHchyd_l ) * XC2
        INITGAS( LCOF2_g )  = GAS( LCOF2_g  ) * PRES_ATM
     &                   + LOADING ( LCOF2_p, IACC ) * XL
     &                   + DCOF21 * XL
     &                   - WETDEP( LCOF2_l ) * XC2
        INITGAS( LPFMOAAchyd_g )  = GAS( LPFMOAAchyd_g  ) * PRES_ATM
     &                   + LOADING ( LPFMOAAchyd_p, IACC ) * XL
     &                   + DPFMOAAchyd1 * XL
     &                   - WETDEP( LPFMOAAchyd_l ) * XC2
        INITGAS( LPFMOAF_g )  = GAS( LPFMOAF_g  ) * PRES_ATM
     &                   + LOADING ( LPFMOAF_p, IACC ) * XL
     &                   + DPFMOAF1 * XL
     &                   - WETDEP( LPFMOAF_l ) * XC2

#ifdef sens
        DO NP = 1, NPMAX
          S_INITGAS( NP, LSO2 )  = S_GAS( NP, LSO2  ) * PRES_ATM
     &                           + S_DS4( NP, 0 ) * XL
     &                           - ( S_WETDEP( NP, LSO3L ) + S_WETDEP( NP, LHSO3L ) + S_WETDEP( NP, LSO2L ) ) * XC2
          S_INITGAS( NP, LNH3 )  = S_GAS( NP,LNH3  ) * PRES_ATM
     &              + ( S_LOADING( NP, LNH4, IACC ) + S_LOADING( NP, LNH4, ICOR ) + S_LOADING( NP, LNH4, IAIT ) ) * XL
     &              - ( S_WETDEP( NP, LNH4ACCL ) + S_WETDEP( NP, LNH3L ) + S_WETDEP( NP, LNH4CORL ) ) * XC2
          S_INITGAS( NP, LHNO3 ) = ( S_GAS( NP, LHNO3 ) + 2.0 * S_GAS( NP, LN2O5 ) ) * PRES_ATM
     &              + ( S_LOADING( NP, LNO3, IACC ) + S_LOADING( NP, LNO3, ICOR ) + S_LOADING( NP, LNO3, IAIT ) ) * XL
     &              - ( S_WETDEP( NP, LNO3ACCL ) + S_WETDEP( NP, LHNO3L ) + S_WETDEP( NP, LNO3CORL ) ) * XC2
          S_INITGAS( NP, LHCL )  = S_GAS(  NP, LHCL ) * PRES_ATM
     &              + ( S_LOADING( NP, LCL, IACC ) + S_LOADING( NP, LCL, ICOR ) + S_LOADING( NP, LCL, IAIT ) ) * XL ! new for sea salt
     &              - ( S_WETDEP( NP, LCLACCL ) + S_WETDEP( NP, LHCLL ) + S_WETDEP( NP, LCLCORL ) ) * XC2
          S_INITGAS( NP, LH2O2 ) = S_GAS( NP, LH2O2 ) * PRES_ATM - S_WETDEP( NP, LH2O2L ) * XC2
          S_INITGAS( NP, LO3 )   = S_GAS( NP, LO3   ) * PRES_ATM - S_WETDEP( NP, LO3L   ) * XC2
          S_INITGAS( NP, LFOA )  = S_GAS( NP, LFOA  ) * PRES_ATM
     &                           - ( S_WETDEP( NP, LFOAL ) + S_WETDEP( NP, LHCO2L ) ) * XC2
          S_INITGAS( NP, LMHP )  = S_GAS( NP, LMHP  ) * PRES_ATM - S_WETDEP( NP, LMHPL  ) * XC2
          S_INITGAS( NP, LPAA )  = S_GAS( NP, LPAA  ) * PRES_ATM - S_WETDEP( NP, LPAAL  ) * XC2
          S_INITGAS( NP, LCO2 )  = S_GAS( NP, LCO2  ) * PRES_ATM
     &                           - ( S_WETDEP( NP, LCO3L ) + S_WETDEP( NP, LHCO3L ) + S_WETDEP( NP, LCO2L ) ) * XC2
          S_INITGAS( NP, LGLY )  = S_GAS( NP, LGLY  ) * PRES_ATM
     &                           + S_DGLY1( NP ) * XL
     &                           - S_WETDEP( NP, LGLYL ) * XC2
          S_INITGAS( NP, LMGLY ) = S_GAS( NP, LMGLY  ) * PRES_ATM
     &                           + S_DMGLY1( NP ) * XL
     &                           - S_WETDEP( NP, LMGLYL ) * XC2
          S_INITGAS( NP, LHO )   = S_GAS( NP, LHO ) * PRES_ATM
        END DO
#endif


C...don`t allow gas concentrations to go below zero

C...Molar concentrations of soluble aerosols
C...   = Initial amount - amount deposited  (mol/liter)

        TS6COR  = MAX( LOADING( LSO4,  ICOR ) - WETDEP( LTS6CORL ) * XC1, 0.0D0 )
        NO3COR  = MAX( LOADING( LNO3,  ICOR ) - WETDEP( LNO3CORL ) * XC1, 0.0D0 )
        CLCOR   = MAX( LOADING( LCL,   ICOR ) - WETDEP( LCLCORL  ) * XC1, 0.0D0 )
        NH4COR  = MAX( LOADING( LNH4,  ICOR ) - WETDEP( LNH4CORL ) * XC1, 0.0D0 )
        SOILCOR = MAX( LOADING( LSOIL, ICOR ) - WETDEP( LSOILCL  ) * XC1, 0.0D0 ) ! SLN 16March2011
        ANTHCOR = MAX( LOADING( LANTH, ICOR ) - WETDEP( LANTHCL  ) * XC1, 0.0D0 ) ! SLN 16March2011
        SEASCOR = MAX( LOADING( LSEAS, ICOR ) - WETDEP( LSEASCL  ) * XC1, 0.0D0 ) ! SLN 16March2011
        FECOR   = SOIL_FE_FAC * SOILCOR + CORS_FE_FAC * ANTHCOR     ! SLN 22Mar2011
        MNCOR   = SOIL_MN_FAC * SOILCOR + CORS_MN_FAC * ANTHCOR
        NACOR   = SEAS_NA_FAC * SEASCOR + SOIL_NA_FAC * SOILCOR + CORS_NA_FAC * ANTHCOR
        MGCOR   = SEAS_MG_FAC * SEASCOR + SOIL_MG_FAC * SOILCOR + CORS_MG_FAC * ANTHCOR
        CACOR   = SEAS_CA_FAC * SEASCOR + SOIL_CA_FAC * SOILCOR + CORS_CA_FAC * ANTHCOR
        KCOR    = SEAS_K_FAC  * SEASCOR + SOIL_K_FAC  * SOILCOR + CORS_K_FAC  * ANTHCOR

        TS6     = LOADING( LSO4,  IAIT ) + LOADING( LSO4, IACC ) + TS6COR
     &          - ( WETDEP( LSO4ACCL ) + WETDEP( LHSO4ACCL ) ) * XC1
     &          - DS4( 0 )
        IF ( STM ) THEN
          TS6AQH2O2 = LOADING( LSO4AQH2O2, IACC ) - WETDEP( LTS6AQH2O2L ) * XC1
     &              - DS4( 1 )
          TS6AQO3   = LOADING( LSO4AQO3, IACC ) - WETDEP( LTS6AQO3L ) * XC1
     &              - DS4( 2 )
          TS6AQFEMN = LOADING( LSO4AQFEMN, IACC ) - WETDEP( LTS6AQFEMNL ) * XC1
     &              - DS4( 3 )
          TS6AQMHP  = LOADING( LSO4AQMHP, IACC ) - WETDEP( LTS6AQMHPL ) * XC1
     &              - DS4( 4 )
          TS6AQPAA  = LOADING( LSO4AQPAA, IACC ) - WETDEP( LTS6AQPAAL ) * XC1
     &              - DS4( 5 )
        END IF

        NA      = LOADING( LNA,   IACC ) + LOADING( LNA, IAIT ) + NACOR
     &          - WETDEP( LNAACCL ) * XC1
        CA      = LOADING( LCA,   IACC) - WETDEP( LCAACCL ) * XC1 + CACOR
        MG      = LOADING( LMG,   IACC) - WETDEP( LMGACCL ) * XC1 + MGCOR
        K       = LOADING( LK,    IACC) - WETDEP( LKACCL  ) * XC1 + KCOR
        FE      = LOADING( LFE,   IACC) - WETDEP( LFEACCL ) * XC1 + FECOR
        MN      = LOADING( LMN,   IACC) - WETDEP( LMNACCL ) * XC1 + MNCOR
        SOA     = LOADING( LSOA,  IACC ) + LOADING( LSOA, IAIT ) - WETDEP( LSOAL  ) * XC1
        ORGC    = LOADING( LORGC, IACC ) + DORGC - WETDEP( LORGCL ) * XC1             ! new in-cloud organic
        POA     = LOADING( LPOA,  IACC ) + LOADING( LPOA, IAIT ) - WETDEP( LPOAL ) * XC1
        EC      = LOADING( LEC,   IACC ) + LOADING( LEC,  IAIT ) - WETDEP( LECL   ) * XC1
        PRIM    = LOADING( LPRI,  IACC ) + LOADING( LPRI, IAIT ) - WETDEP( LPRIML ) * XC1
        NUMCOR  = LOADING( LNUM,  ICOR ) - WETDEP( LNUMCORL  ) * XC1
!       A       = 3.0D0 * FE
!       B       = 2.0D0 * MN
	
        TRACI = LOADING( LTRACER, IAIT ) - WETDEP( LTRACIL ) * XC1
        POAI = LOADING( LPOA, IAIT ) - WETDEP( LPOAIL ) * XC1
        PRII = LOADING( LPRI, IAIT ) - WETDEP( LPRIIL ) * XC1
        SOAI = LOADING( LSOA, IAIT ) - WETDEP( LSOAIL ) * XC1

!       FE_OX = 0.5D0 * 0.62D0 * FE      ! SLN 28March2011
!       MN_OX = 1.0D0 * 0.84D0 * MN      ! SLN 28March2011

# ifdef sens
        DO NP = 1, NPMAX
          S_TS6COR(NP)  = S_LOADING( NP, LSO4,  ICOR ) - S_WETDEP( NP, LTS6CORL ) * XC1
          S_NO3COR(NP)  = S_LOADING( NP, LNO3,  ICOR ) - S_WETDEP( NP, LNO3CORL ) * XC1
          S_CLCOR(NP)   = S_LOADING( NP, LCL,   ICOR ) - S_WETDEP( NP, LCLCORL  ) * XC1
          S_NH4COR(NP)  = S_LOADING( NP, LNH4,  ICOR ) - S_WETDEP( NP, LNH4CORL ) * XC1
          S_SOILCOR(NP) = S_LOADING( NP, LSOIL, ICOR ) - S_WETDEP( NP, LSOILCL  ) * XC1
          S_ANTHCOR(NP) = S_LOADING( NP, LANTH, ICOR ) - S_WETDEP( NP, LANTHCL  ) * XC1
          S_SEASCOR(NP) = S_LOADING( NP, LSEAS, ICOR ) - S_WETDEP( NP, LSEASCL  ) * XC1
          S_FECOR(NP)   = SOIL_FE_FAC * S_SOILCOR( NP ) + CORS_FE_FAC * S_ANTHCOR( NP )
          S_MNCOR(NP)   = SOIL_MN_FAC * S_SOILCOR( NP ) + CORS_MN_FAC * S_ANTHCOR( NP )
          S_NACOR(NP)   = SEAS_NA_FAC * S_SEASCOR( NP ) + SOIL_NA_FAC * S_SOILCOR( NP ) + CORS_NA_FAC * S_ANTHCOR( NP )
          S_MGCOR(NP)   = SEAS_MG_FAC * S_SEASCOR( NP ) + SOIL_MG_FAC * S_SOILCOR( NP ) + CORS_MG_FAC * S_ANTHCOR( NP )
          S_CACOR(NP)   = SEAS_CA_FAC * S_SEASCOR( NP ) + SOIL_CA_FAC * S_SOILCOR( NP ) + CORS_CA_FAC * S_ANTHCOR( NP )
          S_KCOR(NP)    = SEAS_K_FAC  * S_SEASCOR( NP ) + SOIL_K_FAC  * S_SOILCOR( NP ) + CORS_K_FAC  * S_ANTHCOR( NP )

          S_TS6(NP)     = S_LOADING( NP, LSO4,  IAIT ) + S_LOADING( NP, LSO4, IACC ) + S_TS6COR( NP )
     &            - ( S_WETDEP( NP, LSO4ACCL ) + S_WETDEP( NP, LHSO4ACCL ) ) * XC1
     &            - S_DS4( NP, 0 )
          S_NA(NP)      = S_LOADING( NP, LNA,   IACC ) + S_LOADING( NP, LNA, IAIT ) + S_NACOR( NP )
     &            - S_WETDEP( NP, LNAACCL ) * XC1
          S_CA(NP)      = S_LOADING( NP, LCA,   IACC) - S_WETDEP( NP, LCAACCL ) * XC1 + S_CACOR( NP )
          S_MG(NP)      = S_LOADING( NP, LMG,   IACC) - S_WETDEP( NP, LMGACCL ) * XC1 + S_MGCOR( NP )
          S_K(NP)       = S_LOADING( NP, LK,    IACC) - S_WETDEP( NP, LKACCL  ) * XC1 + S_KCOR( NP )
          S_FE(NP)      = S_LOADING( NP, LFE,   IACC) - S_WETDEP( NP, LFEACCL ) * XC1 + S_FECOR( NP )
          S_MN(NP)      = S_LOADING( NP, LMN,   IACC) - S_WETDEP( NP, LMNACCL ) * XC1 + S_MNCOR( NP )
          S_SOA(NP)     = S_LOADING( NP, LSOA,  IACC ) + S_LOADING( NP, LSOA, IAIT ) - S_WETDEP( NP, LSOAL  ) * XC1
          S_ORGC(NP)    = S_LOADING( NP, LORGC, IACC ) + S_DORGC( NP ) - S_WETDEP( NP, LORGCL ) * XC1
          S_POA(NP)     = S_LOADING( NP, LPOA,  IACC ) + S_LOADING( NP, LPOA, IAIT ) - S_WETDEP( NP, LPOAL ) * XC1
          S_EC(NP)      = S_LOADING( NP, LEC,   IACC ) + S_LOADING( NP, LEC,  IAIT ) - S_WETDEP( NP, LECL   ) * XC1
          S_PRIM(NP)    = S_LOADING( NP, LPRI,  IACC ) + S_LOADING( NP, LPRI, IAIT ) - S_WETDEP( NP, LPRIML ) * XC1
          S_NUMCOR(NP)  = S_LOADING( NP, LNUM,  ICOR ) - S_WETDEP( NP, LNUMCORL  ) * XC1

        END DO
#endif


C...don't allow aerosol concentrations to go below zero

        TS6     = MAX( TS6,     0.0D0 )
        IF ( STM ) THEN
          TS6AQH2O2 = MAX( TS6AQH2O2, 0.0D0 )
          TS6AQO3   = MAX( TS6AQO3,   0.0D0 )
          TS6AQFEMN = MAX( TS6AQFEMN, 0.0D0 )
          TS6AQMHP  = MAX( TS6AQMHP,  0.0D0 )
          TS6AQPAA  = MAX( TS6AQPAA,  0.0D0 )
        END IF
        NA      = MAX( NA,      0.0D0 )
        CA      = MAX( CA,      0.0D0 )
        MG      = MAX( MG,      0.0D0 )
        K       = MAX( K,       0.0D0 )
        FE      = MAX( FE,      0.0D0 )
        MN      = MAX( MN,      0.0D0 )
        SOA     = MAX( SOA,     0.0D0 )
        ORGC    = MAX( ORGC,    0.0D0 )
        POA     = MAX( POA,     0.0D0 )
        EC      = MAX( EC,      0.0D0 )
        PRIM    = MAX( PRIM,    0.0D0 )
!       PRIMCOR = MAX( PRIMCOR, 0.0D0 )
        NUMCOR  = MAX( NUMCOR,  0.0D0 )
	
        TRACI    = MAX( TRACI,     0.0D0 )
        POAI     = MAX( POAI,     0.0D0 )
        PRII     = MAX( PRII,     0.0D0 )
        SOAI     = MAX( SOAI,     0.0D0 )
	
        FE_OX = FE_III * FE_SOL * FE     ! GS 01July2011
        MN_OX = MN_II  * MN_SOL * MN     ! GS 01July2011

        A = 3.0D0 * FE_OX
        B = 2.0D0 * MN_OX

        SK6TS6 = SK6 * TS6

#ifdef sens
        IF ( TS6 .EQ. 0.0D0 ) THEN
          DO NP =1 , NPMAX
            S_TS6( NP ) = 0.0D0
          END DO
        END IF

        IF ( NA .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_NA( NP ) = 0.0D0
          END DO
        END IF

        IF ( CA .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_CA( NP ) = 0.0D0
          END DO
        END IF

        IF ( MG .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_MG( NP ) = 0.0D0
          END DO
        END IF

        IF ( K .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_K( NP ) = 0.0D0
          END DO
        END IF

        IF ( FE .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_FE( NP ) = 0.0D0
          END DO
        END IF

        IF ( MN .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_MN( NP ) = 0.0D0
          END DO
        END IF

        IF ( SOA .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_SOA( NP ) = 0.0D0
          END DO
        END IF

        IF ( ORGC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_ORGC( NP ) = 0.0D0
          END DO
        END IF

        IF ( POA .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_POA( NP ) = 0.0D0
          END DO
        END IF

        IF ( EC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_EC( NP ) = 0.0D0
          END DO
        END IF

        IF ( PRIM .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_PRIM( NP ) = 0.0D0
          END DO
        END IF

        IF ( NUMCOR .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_NUMCOR( NP ) = 0.0D0
          END DO
        END IF

        DO NP = 1, NPMAX

          S_FE_OX( NP ) = FE_III * FE_SOL * S_FE( NP )
          S_MN_OX( NP ) = MN_II  * MN_SOL * S_MN( NP )

          S_A( NP ) = 3.0D0 * S_FE_OX( NP )
          S_B( NP ) = 2.0D0 * S_MN_OX( NP )

          S_SK6TS6( NP ) = SK6 * S_TS6( NP )

        END DO
#endif


C...find solution of the equation using a method of reiterative
C...  bisections Make initial guesses for pH:   between .01  to  10.

        HA =  0.01D0
        HB = 10.0D0

C...don't allow gas concentrations to go below zero

        DO IGAS = 1, N_AQ_GAS
          INITGAS( IGAS ) = MAX( INITGAS( IGAS ), 0.0D0 )
        END DO

#ifdef sens
        DO IGAS = 1, N_AQ_GAS
          IF ( INITGAS( IGAS ) .EQ. 0.0D0 ) THEN
            DO NP = 1, NPMAX
              S_INITGAS( NP, IGAS ) = 0.0D0
            END DO
          END IF
        END DO
#endif

C...Aerosol specific to TXHG Versions

        TRACER     = LOADING( LTRACER,  IACC ) + LOADING( LTRACER,  IAIT )
     &             - WETDEP( LTRACERL ) * XC1
        TRACER    = MAX( TRACER,    0.0D0 )
        
        TRACERCOR  = LOADING( LTRACER,  ICOR ) - WETDEP( LTRACERCORL ) * XC1
        TRACERCOR = MAX( TRACERCOR, 0.0D0 )
 
        HGFINE    = LOADING( LPHG,  IACC ) + LOADING( LPHG,  IAIT )
     &             - WETDEP( LPHGFINEL ) * XC1
        HGFINE    = MAX( HGFINE,    0.0D0 )

        HGCOR     = LOADING( LPHG, ICOR ) - WETDEP( LPHGCORL ) * XC1
        HGCOR     = MAX( HGCOR ,     0.0D0 )

        DO I7777C = 1, 10001

          IF ( I7777C .GE. 10000 ) THEN
            XMSG = 'EXCESSIVE LOOPING AT I7777C'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
          END IF

          HA = MAX( HA - 0.8D0, 0.1D0 )
          HB = MIN( HB + 0.8D0, 9.9D0 )
          AE = 10.0D0 ** ( -HA )

          RECIPA1 = 1.0D0 / ( AE * ACT1 )
          RECIPA2 = 1.0D0 / ( AE * AE * ACT2 )

C...calculate final gas phase partial pressure of SO2, NH3, HNO3
C...  HCOOH, and CO2 (atm)

          PSO2F = INITGAS( LSO2 ) / ( 1.0D0 + XLSO2 * ( 1.0D0 + SO21 * RECIPA1
     &          + SO212 * RECIPA2 ) )

          PNH3F = INITGAS( LNH3 ) / ( 1.0D0 + XLNH3 * ( 1.0D0 + NH3DH20 * AE ) )

          PHCLF = INITGAS( LHCL ) / ( 1.0D0 + XLHCL *  ( 1.0D0 + HCL1 * RECIPA1 ) )

          PFOAF = INITGAS( LFOA ) / ( 1.0D0 + XL * ( FOAH + FOA1H * RECIPA1 ) )

          PHNO3F = INITGAS( LHNO3 ) / ( 1.0D0 + XLHNO3 * ( 1.0D0 + HNO31 * RECIPA1 ) )

          PCO2F = INITGAS( LCO2 ) / ( 1.0D0 + XLCO2 * ( 1.0D0 + CO21 * RECIPA1
     &          + CO212 * RECIPA2 ) )

C...calculate liquid phase concentrations (moles/liter)

          SO4  = SK6TS6 / ( AE * GM2 + SK6 )
          HSO4 = TS6 - SO4
          SO3  = SO212H  * PSO2F  * RECIPA2
          HSO3 = SO21H   * PSO2F  * RECIPA1
          CO3  = CO212H  * PCO2F  * RECIPA2
          HCO3 = CO21H   * PCO2F  * RECIPA1
          OH   = H2OW    * RECIPA1
          NH4  = NH31HDH * PNH3F  * AE
          HCO2 = FOA1H   * PFOAF  * RECIPA1
          NO3  = HNO31H  * PHNO3F * RECIPA1
          CL   = HCL1H   * PHCLF  * RECIPA1 ! new for sea salt

C...compute functional value

          FA = AE + NH4 + NA + K + 2.0D0 * ( CA + MG - CO3 - SO3 - SO4 )  ! SLN 16March2011
     &       - OH - HCO3 - HSO3 - NO3 - HSO4 - HCO2 - CL

C...Start iteration and bisection ****************
          DO I30C = 1, 10000

            IF ( I30C .GE. 10000 ) THEN
              XMSG = 'EXCESSIVE LOOPING AT I30C'
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            BB = ( HA + HB ) / 2.0D0
            AE = 10.0D0 ** ( -BB )

            ICNTAQ = ICNTAQ + 1
            IF ( ICNTAQ .GE. 60000 ) THEN
              XMSG = 'Maximum AQCHEM total iterations exceeded'
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            RECIPA1 = 1.0D0 / ( AE * ACT1 )
            RECIPA2 = 1.0D0 / ( AE * AE * ACT2 )

C...calculate final gas phase partial pressure of SO2, NH3, HCL, HNO3
C...  HCOOH, and CO2 (atm)

            PSO2F = INITGAS( LSO2 ) / ( 1.0D0 + XLSO2
     &            * ( 1.0D0 + SO21 * RECIPA1 + SO212 * RECIPA2 ) )

            PNH3F = INITGAS( LNH3 ) / ( 1.0D0 + XLNH3 * ( 1.0D0 + NH3DH20 * AE ) )

            PHCLF = INITGAS( LHCL ) / ( 1.0D0 + XLHCL *  ( 1.0D0 + HCL1 * RECIPA1 ) )

            PHNO3F = INITGAS( LHNO3 ) / ( 1.0D0 + XLHNO3 * ( 1.0D0 + HNO31 * RECIPA1 ) )

            PFOAF = INITGAS( LFOA ) / ( 1.0D0 + XL * ( FOAH + FOA1H * RECIPA1 ) )

            PCO2F = INITGAS( LCO2 ) / ( 1.0D0 + XLCO2 * ( 1.0D0 + CO21 * RECIPA1
     &            + CO212 * RECIPA2 ) )

C...calculate liquid phase concentrations (moles/liter)

            SO4  = SK6TS6 / ( AE * GM2 + SK6 )
            HSO4 = TS6 - SO4
            SO3  = SO212H  * PSO2F  * RECIPA2
            HSO3 = SO21H   * PSO2F  * RECIPA1
            CO3  = CO212H  * PCO2F  * RECIPA2
            HCO3 = CO21H   * PCO2F  * RECIPA1
            OH   = H2OW    * RECIPA1
            NH4  = NH31HDH * PNH3F  * AE
            HCO2 = FOA1H   * PFOAF  * RECIPA1
            NO3  = HNO31H  * PHNO3F * RECIPA1
            CL   = HCL1H   * PHCLF  * RECIPA1 ! new for sea salt

C...compute functional value
            FB = AE + NH4 + NA + K + 2.0D0 * ( CA + MG - CO3 - SO3 - SO4 )  ! SLN 16March2011
     &         - OH - HCO3 - HSO3 - NO3 - HSO4 - HCO2 - CL

C...Calculate and check the sign of the product of the two functional values

            FTST = FA * FB
            IF ( FTST .LE. 0.0D0 ) THEN
              HB = BB
            ELSE
              HA = BB
              FA = FB
            END IF

C...Check convergence of solutions

            HTST = HA / HB
            IF ( HTST .GT. TST ) EXIT  ! exit loop I30C
          END DO   ! I30C

C...end of zero-finding routine ****************

C...compute Ionic strength and activity coefficient by the Davies equation

          STION = 0.5D0
     &          * ( AE + NH4 + OH + HCO3 + HSO3
     &              + 4.0D0 * ( SO4 + CO3 + SO3 + CA + MG + MN_OX )
     &              + NO3 + HSO4 + 9.0D0 * FE_OX + NA + K + CL + A + B + HCO2 ) ! KMF 08September2011
          GM1LOG = -0.509D0 * ( SQRT( STION )
     &           / ( 1.0D0 + SQRT( STION ) ) - 0.2D0 * STION )
          GM2LOG = GM1LOG * 4.0D0
          GM1  = 10.0D0 ** GM1LOG
          GM2  = MAX( 10.0D0 ** GM2LOG, 1.0D-30 )
          ACTB = ACT1
          ACT1 = MAX( GM1 * GM1, 1.0D-30 )
          ACT2 = MAX( GM1 * GM1 * GM2, 1.0D-30 )

#ifdef verbose
          if ( stion .gt. 1.0 ) then
             write( logdev,'( /5x, a, 2i4, i10.6 )' )
     &                     'aqchem-I7777C,I20C: ', i7777c, i20c, jtime
             write( logdev,'( 5x, a, e10.3 )' ) 'stion: ', stion
             write( logdev,'( 5x, a, e10.3 )' ) 'AE:   ', ae
             write( logdev,'( 5x, a, e10.3 )' ) 'NH4:  ', nh4
             write( logdev,'( 5x, a, e10.3 )' ) 'OH:   ', oh
             write( logdev,'( 5x, a, e10.3 )' ) 'HCO3: ', hco3
             write( logdev,'( 5x, a, e10.3 )' ) 'HSO3: ', hso3
             write( logdev,'( 5x, a, e10.3 )' ) 'SO4:  ', so4
             write( logdev,'( 5x, a, e10.3 )' ) 'CO3:  ', co3
             write( logdev,'( 5x, a, e10.3 )' ) 'SO3:  ', so3
             write( logdev,'( 5x, a, e10.3 )' ) 'CA:   ', ca
             write( logdev,'( 5x, a, e10.3 )' ) 'MG:   ', mg
             write( logdev,'( 5x, a, e10.3 )' ) 'MN:   ', mn
             write( logdev,'( 5x, a, e10.3 )' ) 'NO3:  ', no3
             write( logdev,'( 5x, a, e10.3 )' ) 'HSO4: ', hso4
             write( logdev,'( 5x, a, e10.3 )' ) 'FE:   ', fe
             write( logdev,'( 5x, a, e10.3 )' ) 'NA:   ', na
             write( logdev,'( 5x, a, e10.3 )' ) 'K:    ', k
             write( logdev,'( 5x, a, e10.3 )' ) 'CL:   ', cl
             write( logdev,'( 5x, a, e10.3 )' ) 'A:    ', a
             write( logdev,'( 5x, a, e10.3 )' ) 'B:    ', b
             write( logdev,'( 5x, a, e10.3 )' ) 'HCO2: ', hco2
             write( logdev,'( 5x, a, e10.3 )' ) 'gm1log:', gm1log
             write( logdev,'( 5x, a, e10.3 )' ) 'gm2log:', gm2log
             write( logdev,'( 5x, a, e10.3 )' ) 'gm1:   ', gm1
             write( logdev,'( 5x, a, e10.3 )' ) 'gm2:   ', gm2
             write( logdev,'( 5x, a, e10.3 )' ) 'actb:  ', actb
             write( logdev,'( 5x, a, e10.3 )' ) 'act1:  ', act1
             write( logdev,'( 5x, a, e10.3 )' ) 'act2:  ', act2
          end if
#endif

C...check for convergence and possibly go to I7777C, to recompute
C...  Gas and liquid phase concentrations

          TAC = ABS( ACTB - ACT1 ) / ACTB
          IF ( TAC .LT. 1.0D-2 ) EXIT    ! exit loop I7777C
        END DO     ! end of do loop I7777C

C...return an error if the pH is not in range

        IF ( ( HA .LT. 0.1D0 ) .OR. ( HA .GT. 9.9D0 ) ) THEN
!         write( logdev,* ) ha
          XMSG = 'PH VALUE OUT OF RANGE'
          CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
        END IF

#ifdef sens
        DO NP = 1, NPMAX
C...calculate final gas phase partial pressure of SO2, NH3, HCL, HNO3
C...  HCOOH, and CO2 (atm)
            S_PSO2F( NP ) = S_INITGAS( NP, LSO2 ) / ( 1.0D0 + XLSO2
     &                    * ( 1.0D0 + SO21 * RECIPA1 + SO212 * RECIPA2 ) )
            S_PNH3F( NP ) = S_INITGAS( NP, LNH3 ) / ( 1.0D0 + XLNH3 * ( 1.0D0 + NH3DH20 * AE ) )
            S_PHCLF( NP ) = S_INITGAS( NP, LHCL ) / ( 1.0D0 + XLHCL *  ( 1.0D0 + HCL1 * RECIPA1 ) )
            S_PHNO3F( NP ) = S_INITGAS( NP, LHNO3 ) / ( 1.0D0 + XLHNO3 * ( 1.0D0 + HNO31 * RECIPA1 ) )
            S_PFOAF( NP ) = S_INITGAS( NP, LFOA ) / ( 1.0D0 + XL * ( FOAH + FOA1H * RECIPA1 ) )
            S_PCO2F( NP ) = S_INITGAS( NP, LCO2 ) / ( 1.0D0 + XLCO2 * ( 1.0D0 + CO21 * RECIPA1
     &                    + CO212 * RECIPA2 ) )
C...calculate liquid phase concentrations (moles/liter)
            S_SO4( NP )  = S_SK6TS6( NP ) / ( AE * GM2 + SK6 )
            S_HSO4( NP ) = S_TS6( NP ) - S_SO4( NP )
            S_SO3( NP )  = SO212H  * S_PSO2F( NP )  * RECIPA2
            S_HSO3( NP ) = SO21H   * S_PSO2F( NP )  * RECIPA1
            S_CO3( NP )  = CO212H  * S_PCO2F( NP )  * RECIPA2
            S_HCO3( NP ) = CO21H   * S_PCO2F( NP )  * RECIPA1
            S_NH4( NP )  = NH31HDH * S_PNH3F( NP )  * AE
            S_HCO2( NP ) = FOA1H   * S_PFOAF( NP )  * RECIPA1
            S_NO3( NP )  = HNO31H  * S_PHNO3F( NP ) * RECIPA1
            S_CL( NP )   = HCL1H   * S_PHCLF( NP )  * RECIPA1
        END DO
#endif

C...Make those concentration calculations which can be made outside
C...  of the function.

        SO2L = SO2H * PSO2F
        HPLUS = 10.0D0 ** ( -BB )  ! Hydrogen Ion Concentration in mol/L
        SIV = SO3 + HSO3 + SO2L

C...Calculate final gas phase concentrations of oxidants (atm)

        PH2O2F = ( INITGAS( LH2O2 ) + XL * DS4( 1 ) ) / ( 1.0D0 + XLH2O2 )
        PO3F   = ( INITGAS( LO3 )   + XL * DS4( 2 ) ) / ( 1.0D0 + XLO3   )
        PMHPF  = ( INITGAS( LMHP )  + XL * DS4( 4 ) ) / ( 1.0D0 + XLMHP  )
        PPAAF  = ( INITGAS( LPAA )  + XL * DS4( 5 ) ) / ( 1.0D0 + XLPAA  )
        PGLYF  = ( INITGAS( LGLY )                  ) / ( 1.0D0 + GLYH * XL )
        PMGLYF = ( INITGAS( LMGLY )                 ) / ( 1.0D0 + MGLYH * XL )
        PHOF   = ( INITGAS( LHO )                   ) / ( 1.0D0 + HOH * XL)

        PH2O2F = MAX( PH2O2F, 0.0D0 )
        PO3F   = MAX( PO3F,   0.0D0 )
        PMHPF  = MAX( PMHPF,  0.0D0 )
        PPAAF  = MAX( PPAAF,  0.0D0 )

        ! Calculate Henry's Law and Gas Pressure of carb acids & Acid Fluoride
        HFPODAchydH = REAL( HLCONST( HLC_HFPODA,  TEMP, .TRUE., REAL(HPLUS,4)),8) ! M /atm
        HFPODAFH    = REAL( HLCONST( HLC_HFPODAF, TEMP, .TRUE., REAL(HPLUS,4)),8) ! M /atm

        PHFPODAchydF = ( INITGAS( LHFPODAchyd_g ) ) / ( 1.0D0 + HFPODAchydH * XL ) ! atm
        PHFPODAFF    = ( INITGAS( LHFPODAF_g    ) ) / ( 1.0D0 + HFPODAFH* XL ) ! atm

        FCOOHchydH = REAL( HLCONST( HLC_FCOOH, TEMP, .TRUE., REAL(HPLUS,4)),8) ! M /atm
        COF2H      = REAL( HLCONST( HLC_COF2, TEMP, .TRUE., REAL(HPLUS,4)),8) ! M /atm

        PFCOOHchydF = ( INITGAS( LFCOOHchyd_g ) ) / ( 1.0D0 + FCOOHchydH * XL ) ! atm
        PCOF2F      = ( INITGAS( LCOF2_g      ) ) / ( 1.0D0 + COF2H* XL ) ! atm

        PFMOAAchydH = REAL( HLCONST( HLC_PFMOAA, TEMP, .TRUE., REAL(HPLUS,4)),8) ! M /atm
        PFMOAFH     = REAL( HLCONST( HLC_PFMOAF, TEMP, .TRUE., REAL(HPLUS,4)),8) ! M /atm

        PPFMOAAchydF = ( INITGAS( LPFMOAAchyd_g ) ) / ( 1.0D0 + PFMOAAchydH * XL ) ! atm
        PPFMOAFF     = ( INITGAS( LPFMOAF_g      ) ) / ( 1.0D0 + PFMOAFH* XL ) ! atm

C...Calculate liquid phase concentrations of oxidants (moles/liter)

        H2O2L = PH2O2F * H2O2H
        O3L   = PO3F   * O3H
        MHPL  = PMHPF  * MHPH
        PAAL  = PPAAF  * PAAH
        FOAL  = PFOAF  * FOAH
        NH3L  = PNH3F  * NH3H
        CO2L  = PCO2F  * CO2H
        HCLL  = PHCLF  * HCLH
        HNO3L = PHNO3F * HNO3H
        GLYL  = PGLYF  * GLYH
        MGLYL = PMGLYF * MGLYH
        OHL   = PHOF   * HOH

        HFPODAchyd_L = PHFPODAchydF * HFPODAchydH
        HFPODAF_L    = PHFPODAFF * HFPODAFH
        FCOOHchyd_L = PFCOOHchydF * FCOOHchydH
        COF2_L    = PCOF2F * COF2H
        PFMOAAchyd_L = PPFMOAAchydF * PFMOAAchydH
        PFMOAF_L    = PPFMOAFF * PFMOAFH

C...compute modal concentrations

        SO4COR  = SK6 * TS6COR / ( AE * GM2 + SK6 )
        HSO4COR = MAX( TS6COR - SO4COR, 0.0D0 )

        TS6ACC  = MAX( TS6  - TS6COR,   0.0D0 )
        SO4ACC  = MAX( SO4  - SO4COR,   0.0D0 )
        HSO4ACC = MAX( HSO4 - HSO4COR,  0.0D0 )
        NAACC   = MAX( NA   - NACOR,    0.0D0 )
        CAACC   = MAX( CA   - CACOR,    0.0D0 ) ! AE6
        MGACC   = MAX( MG   - MGCOR,    0.0D0 ) ! AE6
        KACC    = MAX( K    - KCOR,     0.0D0 ) ! AE6
        FEACC   = MAX( FE   - FECOR,    0.0D0 ) ! AE6
        MNACC   = MAX( MN   - MNCOR,    0.0D0 ) ! AE6

#ifdef sens
        DO NP = 1, NPMAX
          S_SO2L( NP )    = SO2H * S_PSO2F( NP )
          S_SIV( NP )     = S_SO3( NP ) + S_HSO3( NP ) + S_SO2L( NP )

          S_PH2O2F( NP )  = ( S_INITGAS( NP, LH2O2 ) + XL * S_DS4( NP, 1 ) ) / ( 1.0D0 + XLH2O2 )
          S_PO3F( NP )    = ( S_INITGAS( NP, LO3 )   + XL * S_DS4( NP, 2 ) ) / ( 1.0D0 + XLO3   )
          S_PMHPF( NP )   = ( S_INITGAS( NP, LMHP )  + XL * S_DS4( NP, 4 ) ) / ( 1.0D0 + XLMHP  )
          S_PPAAF( NP )   = ( S_INITGAS( NP, LPAA )  + XL * S_DS4( NP, 5 ) ) / ( 1.0D0 + XLPAA  )
          S_PGLYF( NP )   = ( S_INITGAS( NP, LGLY ) ) / ( 1.0D0 + GLYH * XL )
          S_PMGLYF( NP )  = ( S_INITGAS( NP, LMGLY ) ) / ( 1.0D0 + MGLYH * XL )
          S_PHOF( NP )    = ( S_INITGAS( NP, LHO ) ) / ( 1.0D0 + HOH * XL)
        END DO

        IF ( PH2O2F .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_PH2O2F( NP ) = 0.0D0
          END DO
        END IF

        IF ( PO3F .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_PO3F( NP ) = 0.0D0
          END DO
        END IF

        IF ( PMHPF .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_PMHPF( NP ) = 0.0D0
          END DO
        END IF

        IF ( PPAAF .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_PPAAF( NP ) = 0.0D0
          END DO
        END IF

        DO NP = 1, NPMAX
          S_H2O2L( NP )   = S_PH2O2F( NP ) * H2O2H
          S_O3L( NP )     = S_PO3F( NP )   * O3H
          S_MHPL( NP )    = S_PMHPF( NP )  * MHPH
          S_PAAL( NP )    = S_PPAAF( NP )  * PAAH
          S_FOAL( NP )    = S_PFOAF( NP )  * FOAH
          S_NH3L( NP )    = S_PNH3F( NP )  * NH3H
          S_CO2L( NP )    = S_PCO2F( NP )  * CO2H
          S_HCLL( NP )    = S_PHCLF( NP )  * HCLH
          S_HNO3L( NP )   = S_PHNO3F( NP ) * HNO3H
          S_GLYL( NP )    = S_PGLYF( NP )  * GLYH
          S_MGLYL( NP )   = S_PMGLYF( NP ) * MGLYH
          S_OHL( NP )     = S_PHOF( NP )   * HOH

          S_SO4COR( NP )  = SK6 * S_TS6COR( NP ) / ( AE * GM2 + SK6 )
          S_HSO4COR( NP ) = S_TS6COR( NP ) - S_SO4COR( NP )
          S_TS6ACC( NP )  = S_TS6( NP )    - S_TS6COR( NP )
          S_SO4ACC( NP )  = S_SO4( NP )    - S_SO4COR( NP )
          S_HSO4ACC( NP ) = S_HSO4( NP )   - S_HSO4COR( NP )
          S_NO3ACC( NP )  = S_NO3( NP )    - S_NO3COR( NP )
          S_NAACC( NP )   = S_NA( NP )     - S_NACOR( NP )
          S_CLACC( NP )   = S_CL( NP )     - S_CLCOR( NP )
          S_NH4ACC( NP )  = S_NH4( NP )    - S_NH4COR( NP )
          S_CAACC( NP )   = S_CA( NP )     - S_CACOR( NP )
          S_MGACC( NP )   = S_MG( NP )     - S_MGCOR( NP )
          S_KACC( NP )    = S_K( NP )      - S_KCOR( NP )
          S_FEACC( NP )   = S_FE( NP )     - S_FECOR( NP )
          S_MNACC( NP )   = S_MN( NP )     - S_MNCOR( NP )
        END DO

c       IF ( HSO4COR .EQ. 0.0D0 ) THEN
c         DO NP = 1, NPMAX
c           S_HSO4COR( NP ) = 0.0D0
c         END DO
c       END IF

        IF ( TS6ACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_TS6ACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( SO4ACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_SO4ACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( HSO4ACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_HSO4ACC( NP ) = 0.0D0
          END DO
        END IF

c       IF ( NO3ACC .EQ. 0.0D0 ) THEN
c         DO NP = 1, NPMAX
c           S_NO3ACC( NP ) = 0.0D0
c         END DO
c       END IF

        IF ( NAACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_NAACC( NP ) = 0.0D0
          END DO
        END IF

c       IF ( CLACC .EQ. 0.0D0 ) THEN
c         DO NP = 1, NPMAX
c           S_CLACC( NP ) = 0.0D0
c         END DO
c       END IF

c       IF ( NH4ACC .EQ. 0.0D0 ) THEN
c         DO NP = 1, NPMAX
c           S_NH4ACC( NP ) = 0.0D0
c         END DO
c       END IF

        IF ( CAACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_CAACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( MGACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_MGACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( KACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_KACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( FEACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_FEACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( MNACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_MNACC( NP ) = 0.0D0
          END DO
        END IF
#endif

C...Avoid adding mass when the coarse mode concentration is greater
C...  than the total amount left in the aqueous phase after redistribution
C...  of a species between the gas/aqueous phases

        IF ( NO3COR .GT. NO3 ) then
           NO3ACC = (1.0D0 - FNO3COR) * NO3
           NO3COR = FNO3COR * NO3
        ELSE
           NO3ACC  = MAX( NO3  - NO3COR,   0.0D0 )
        END IF

        IF ( CLCOR .GT. CL ) then
           CLACC = (1.0D0 - FCLCOR) * CL
           CLCOR = FCLCOR * CL
        ELSE
           CLACC   = MAX( CL   - CLCOR,    0.0D0 )
        END IF

        IF ( NH4COR .GT. NH4 ) THEN
           NH4ACC = (1.0D0 - FNH4COR) * NH4
           NH4COR = FNH4COR * NH4
        ELSE
           NH4ACC  = MAX( NH4  - NH4COR,   0.0D0 )
        END IF

C...load the liquid concentration array with current values

        LIQUID( LACL      ) = HPLUS
        LIQUID( LNH4ACCL  ) = NH4ACC
        LIQUID( LCACORL   ) = CACOR
        LIQUID( LNAACCL   ) = NAACC
        LIQUID( LOHL      ) = OHL
        LIQUID( LSO4ACCL  ) = SO4ACC
        LIQUID( LHSO4ACCL ) = HSO4ACC
        LIQUID( LSO3L     ) = SO3
        LIQUID( LHSO3L    ) = HSO3
        LIQUID( LSO2L     ) = SO2L
        LIQUID( LCO3L     ) = CO3
        LIQUID( LHCO3L    ) = HCO3
        LIQUID( LCO2L     ) = CO2L
        LIQUID( LNO3ACCL  ) = NO3ACC
        LIQUID( LNH3L     ) = NH3L
        LIQUID( LCLACCL   ) = CLACC
        LIQUID( LH2O2L    ) = H2O2L
        LIQUID( LO3L      ) = O3L
        LIQUID( LFECORL   ) = FECOR
        LIQUID( LMNCORL   ) = MNCOR
        LIQUID( LAL       ) = A
        LIQUID( LFOAL     ) = FOAL
        LIQUID( LHCO2L    ) = HCO2
        LIQUID( LMHPL     ) = MHPL
        LIQUID( LPAAL     ) = PAAL
        LIQUID( LHCLL     ) = HCLL
        LIQUID( LPRIML    ) = PRIM
        LIQUID( LMGCORL   ) = MGCOR
        LIQUID( LKCORL    ) = KCOR
        LIQUID( LBL       ) = B
        LIQUID( LHNO3L    ) = HNO3L
        LIQUID( LNUMCORL  ) = NUMCOR
        LIQUID( LTS6CORL  ) = TS6COR
        LIQUID( LNACORL   ) = NACOR
        LIQUID( LCLCORL   ) = CLCOR
        LIQUID( LNO3CORL  ) = NO3COR
        LIQUID( LNH4CORL  ) = NH4COR
        LIQUID( LPOAL     ) = POA
        LIQUID( LECL      ) = EC
        LIQUID( LSOAL     ) = SOA
        LIQUID( LORGCL    ) = ORGC
        LIQUID( LGLYL     ) = GLYL
        LIQUID( LMGLYL    ) = MGLYL
        LIQUID( LCAACCL   ) = CAACC   ! AE6 - SLN 16March2011
        LIQUID( LMGACCL   ) = MGACC   ! AE6 - SLN 16March2011
        LIQUID( LKACCL    ) = KACC    ! AE6 - SLN 16March2011
        LIQUID( LSOILCL   ) = SOILCOR ! AE6 - SLN 16March2011
        LIQUID( LANTHCL   ) = ANTHCOR ! AE6 - SLN 16March2011
        LIQUID( LSEASCL   ) = SEASCOR ! AE6 - SLN 16March2011
        LIQUID( LFEACCL   ) = FEACC   ! AE6 - SLN 22March2011
        LIQUID( LMNACCL   ) = MNACC   ! AE6 - SLN 22March2011
	
        LIQUID( LTRACIL ) = TRACI
        LIQUID( LPOAIL ) = POAI
        LIQUID( LPRIIL ) = PRII
        LIQUID( LSOAIL ) = SOAI
        
        IF ( STM ) THEN
          LIQUID( LTS6AQH2O2L   ) = TS6AQH2O2
          LIQUID( LTS6AQO3L     ) = TS6AQO3
          LIQUID( LTS6AQFEMNL   ) = TS6AQFEMN
          LIQUID( LTS6AQMHPL    ) = TS6AQMHP
          LIQUID( LTS6AQPAAL    ) = TS6AQPAA
        END IF

       LIQUID ( LHFPODAchyd_l ) = HFPODAchyd_l
       LIQUID ( LHFPODAF_l )    = HFPODAF_l 
       LIQUID ( LFCOOHchyd_l )  = FCOOHchyd_l
       LIQUID ( LCOF2_l )       = COF2_l
       LIQUID ( LPFMOAAchyd_l ) = PFMOAAchyd_l
       LIQUID ( LPFMOAF_l )     = PFMOAF_l

#ifdef sens
        S_LIQUID = 0.0D0
        DO NP = 1, NPMAX
c         S_LIQUID( NP, LACL      ) = S_AC( NP )    
          S_LIQUID( NP, LNH4ACCL  ) = S_NH4ACC( NP)
          S_LIQUID( NP, LCACORL   ) = S_CACOR( NP )
          S_LIQUID( NP, LNAACCL   ) = S_NAACC( NP )
          S_LIQUID( NP, LOHL      ) = S_OHL( NP )
          S_LIQUID( NP, LSO4ACCL  ) = S_SO4ACC( NP )
          S_LIQUID( NP, LHSO4ACCL ) = S_HSO4ACC( NP )
          S_LIQUID( NP, LSO3L     ) = S_SO3( NP )
          S_LIQUID( NP, LHSO3L    ) = S_HSO3( NP )
          S_LIQUID( NP, LSO2L     ) = S_SO2L( NP )
          S_LIQUID( NP, LCO3L     ) = S_CO3( NP )
          S_LIQUID( NP, LHCO3L    ) = S_HCO3( NP )
          S_LIQUID( NP, LCO2L     ) = S_CO2L( NP )
          S_LIQUID( NP, LNO3ACCL  ) = S_NO3ACC( NP )
          S_LIQUID( NP, LNH3L     ) = S_NH3L( NP )
          S_LIQUID( NP, LCLACCL   ) = S_CLACC( NP )
          S_LIQUID( NP, LH2O2L    ) = S_H2O2L( NP )
          S_LIQUID( NP, LO3L      ) = S_O3L( NP )
          S_LIQUID( NP, LFECORL   ) = S_FECOR( NP )
          S_LIQUID( NP, LMNCORL   ) = S_MNCOR( NP )
c         S_LIQUID( NP, LAL       ) = S_A( NP )
          S_LIQUID( NP, LFOAL     ) = S_FOAL( NP )
          S_LIQUID( NP, LHCO2L    ) = S_HCO2( NP )
          S_LIQUID( NP, LMHPL     ) = S_MHPL( NP )
          S_LIQUID( NP, LPAAL     ) = S_PAAL( NP )
          S_LIQUID( NP, LHCLL     ) = S_HCLL( NP )
          S_LIQUID( NP, LPRIML    ) = S_PRIM( NP )
          S_LIQUID( NP, LMGCORL   ) = S_MGCOR( NP )
          S_LIQUID( NP, LKCORL    ) = S_KCOR( NP )
c         S_LIQUID( NP, LBL       ) = S_B( NP )
          S_LIQUID( NP, LHNO3L    ) = S_HNO3L( NP )
          S_LIQUID( NP, LNUMCORL  ) = S_NUMCOR( NP )
          S_LIQUID( NP, LTS6CORL  ) = S_TS6COR( NP )
          S_LIQUID( NP, LNACORL   ) = S_NACOR( NP )
          S_LIQUID( NP, LCLCORL   ) = S_CLCOR( NP )
          S_LIQUID( NP, LNO3CORL  ) = S_NO3COR( NP )
          S_LIQUID( NP, LNH4CORL  ) = S_NH4COR( NP )
          S_LIQUID( NP, LPOAL     ) = S_POA( NP )
          S_LIQUID( NP, LECL      ) = S_EC( NP )
          S_LIQUID( NP, LSOAL     ) = S_SOA( NP )
          S_LIQUID( NP, LORGCL    ) = S_ORGC( NP )
          S_LIQUID( NP, LGLYL     ) = S_GLYL( NP )
          S_LIQUID( NP, LMGLYL    ) = S_MGLYL( NP )
          S_LIQUID( NP, LCAACCL   ) = S_CAACC( NP )
          S_LIQUID( NP, LMGACCL   ) = S_MGACC( NP )
          S_LIQUID( NP, LKACCL    ) = S_KACC( NP )
          S_LIQUID( NP, LSOILCL   ) = S_SOILCOR( NP )
          S_LIQUID( NP, LANTHCL   ) = S_ANTHCOR( NP )
          S_LIQUID( NP, LSEASCL   ) = S_SEASCOR( NP )
          S_LIQUID( NP, LFEACCL   ) = S_FEACC( NP )
          S_LIQUID( NP, LMNACCL   ) = S_MNACC( NP )
        END DO
#endif

C...Load array variable TXHG Version

        LIQUID( LTRACERL    )  = TRACER
        LIQUID( LTRACERCORL )  = TRACERCOR
        LIQUID( LPHGFINEL   )  = HGFINE
        LIQUID( LPHGCORL    )  = HGCOR


C...if the maximum cloud lifetime has not been reached, then compute
C...  the next timestep, else exit loop 20.

        IF ( TIMEW .GE. TAUCLD ) EXIT   ! exit 20 loop

C...make kinetics calculations
C...  note: DS4(i) and DSIV(I) are negative numbers!

        DTRMV = TAUCLD / 3.0D0
        IF ( ( CTHK1 .GT. 1.0D-10 ) .AND. ( PRCRATE .GT. 1.0D-10 ) )
     &     DTRMV = 3.6D0 * WTAVG * 1000.0D0 * CTHK1 / PRCRATE  ! <<<uma found bug, was .36
        DTRMV = MIN( DTRMV, 300.0D0 )
        ITERAT = ITERAT + 1

C...Define the total S(iv) available for oxidation

        TSIV = INITGAS( LSO2 ) * ONE_OVER_XL

#ifdef sens
        DO NP = 1, NPMAX
          S_TSIV( NP ) = S_INITGAS( NP,LSO2 ) * ONE_OVER_XL
        END DO
#endif

C...Calculate sulfur iv oxidation rate due to H2O2 (Jacobson, 1997)

        DSIVDT( 1 ) = -RH2O2 * H2O2L * HSO3 * HPLUS / ( 1.0D0 + 13.0D0 * HPLUS )
        TH2O2 = INITGAS( LH2O2 ) * ONE_OVER_XL
        IF ( ( DSIVDT( 1 ) .EQ. 0.0D0 ) .OR.
     &       ( TSIV  .LE. CONMIN ) .OR.
     &       ( TH2O2 .LE. CONMIN ) ) THEN
          DTW( 1 ) = DTRMV
        ELSE
          DTW( 1 ) = -0.05D0 * MIN( TH2O2, TSIV ) / DSIVDT( 1 )
        END IF

#ifdef sens
C... no sensitivity to pH now
        DO NP = 1, NPMAX
          S_TH2O2( NP ) = S_INITGAS( NP, LH2O2 ) * ONE_OVER_XL
          C1 = -RH2O2 * HPLUS / ( 1.0D0 + 13.0D0 * HPLUS )
          IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
            IP1 = IHIGH(NP,1)
            IP2 = IHIGH(NP,2)
            S_DSIVDT( NP,1 ) = C1 * ( S_H2O2L( NP )  * HSO3          + S_H2O2L( IP1 ) * S_HSO3( IP2 )
     &                              + S_H2O2L( IP2 ) * S_HSO3( IP1 ) + H2O2L          * S_HSO3( NP )  )
          ELSE
            S_DSIVDT( NP,1 ) = C1 * ( S_H2O2L( NP ) * HSO3 + H2O2L * S_HSO3( NP ) )
          END IF
        END DO
#endif

C...Calculate sulfur iv oxidation rate due to O3 (Jacobson, 1997)

        DSIVDT( 2 ) = -( 2.4D4 * SO2L                                          +
     &                   3.7D5 * EXP( -18.56 * ( ( 298.0D0 / TEMP ) - 1.0D0 ) ) * HSO3 +
     &                   1.5D9 * EXP( -17.72 * ( ( 298.0D0 / TEMP ) - 1.0D0 ) ) * SO3 ) * O3L

        TO3 = INITGAS( LO3 ) * ONE_OVER_XL
        IF ( ( DSIVDT( 2 ) .EQ. 0.0D0 ) .OR.
     &       ( TSIV  .LE. CONMIN ) .OR.
     &       ( TO3 .LE. CONMIN ) ) THEN
          DTW( 2 ) = DTRMV
        ELSE
          DTW( 2 ) = -0.01D0 * MIN( TO3, TSIV ) / DSIVDT( 2 )
        END IF

#ifdef sens
        C1 = 2.4D4
        C2 = 3.7D5 * EXP( -18.56 * ( ( 298.0D0 / TEMP ) - 1.0D0 ) )
        C3 = 1.5D9 * EXP( -17.72 * ( ( 298.0D0 / TEMP ) - 1.0D0 ) )
        DO NP = 1, NPMAX
          S_TO3( NP ) = S_INITGAS( NP, LO3 ) * ONE_OVER_XL
          IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
            IP1 = IHIGH(NP,1)
            IP2 = IHIGH(NP,2)
            S_DSIVDT( NP,2 ) =  -C1 * ( S_SO2L( NP )  * O3L          + S_SO2L( IP1 ) * S_O3L( IP2 )
     &                                + S_SO2L( IP2 ) * S_O3L( IP1 ) + SO2L          * S_O3L( NP ) )
     &                         - C2 * ( S_HSO3( NP )  * O3L          + S_HSO3( IP1 ) * S_O3L( IP2 )
     &                                + S_HSO3( IP2 ) * S_O3L( IP1 ) + HSO3          * S_O3L( NP ) )
     &                         - C3 * ( S_SO3 ( NP )  * O3L          + S_SO3 ( IP1 ) * S_O3L( IP2 )
     &                                + S_SO3 ( IP2 ) * S_O3L( IP1 ) + SO3           * S_O3L( NP ) )
          ELSE
            S_DSIVDT( NP,2 ) =  -C1 * ( S_SO2L( NP ) * O3L + SO2L * S_O3L( NP ) )
     &                         - C2 * ( S_HSO3( NP ) * O3L + HSO3 * S_O3L( NP ) )
     &                         - C3 * ( S_SO3 ( NP ) * O3L + SO3  * S_O3L( NP ) )
          END IF
        END DO
#endif

C...Calculate sulfur iv oxidation rate due to 02 catalyzed by Mn++ and Fe+++
C...(Martin and Goodman, 1991)
C...Implement sulfate inhibition based on Martin and Good, 1991

        DSIVDT( 3 ) = - ( 750.0D0  * MN_OX * SIV +                 ! GS 4May2011
     &                    2600.0D0 * FE_OX * SIV +                 ! GS 4May2011
     &                    1.0D10   * MN_OX * FE_OX * SIV )         ! GS 4May2011
     &                / ( 1.0D0 + 75.0D0 *( TS6**0.67D0 ))         ! GS 28Nov2012     

        IF ( ( DSIVDT( 3 ) .EQ. 0.0D0 ) .OR. ( TSIV .LE. CONMIN ) ) THEN
          DTW( 3 ) = DTRMV
        ELSE
          DTW( 3 ) = -0.1D0 * TSIV / DSIVDT( 3 )
        END IF

#ifdef sens
        DO NP = 1, NPMAX
          IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
            IP1 = IHIGH(NP,1)
            IP2 = IHIGH(NP,2)
            IF (TS6 .GT. 0.0) THEN
              pwr1D = -(0.33D0*TS6**(-1.33D0)*S_TS6(IP2))
            ELSE
              pwr1D = 0.0
            END IF
            pwr1 = TS6**(-0.33D0)
            S_DSIVDT( NP, 3 ) = -((((750.0D0*(S_MN_OX(NP)*SIV+S_MN_OX(IP1)*S_SIV(IP2)+S_MN_OX(IP2)*S_SIV(IP1)+
     &        MN_OX*S_SIV(NP))+2600.0D0*(S_FE_OX(NP)*SIV+S_FE_OX(IP1)*S_SIV(IP2)+S_FE_OX(IP2)*S_SIV(IP1)+
     &        FE_OX*S_SIV(NP))+1.0D10*((S_MN_OX(NP)*FE_OX+S_MN_OX(IP1)*S_FE_OX(IP2)+S_MN_OX(IP2)*
     &        S_FE_OX(IP1)+MN_OX*S_FE_OX(NP))*SIV+(S_MN_OX(IP1)*FE_OX+MN_OX*S_FE_OX(IP1))*S_SIV(IP2)+(
     &        S_MN_OX(IP2)*FE_OX+MN_OX*S_FE_OX(IP2))*S_SIV(IP1)+MN_OX*FE_OX*S_SIV(NP)))*(1.0D0+
     &        75.0D0*TS6**0.67D0)+(750.0D0*(S_MN_OX(IP1)*SIV+MN_OX*S_SIV(IP1))+2600.0D0*(
     &        S_FE_OX(IP1)*SIV+FE_OX*S_SIV(IP1))+1.0D10*((S_MN_OX(IP1)*FE_OX+MN_OX*S_FE_OX(IP1))*SIV+
     &        MN_OX*FE_OX*S_SIV(IP1)))*75.0D0*0.67D0*TS6**(-0.33D0)*S_TS6(IP2)-75.0D0*
     &        0.67D0*((750.0D0*(S_MN_OX(IP2)*SIV+MN_OX*S_SIV(IP2))+2600.0D0*(S_FE_OX(IP2)*SIV
     &        +FE_OX*S_SIV(IP2))+1.0D10*((S_MN_OX(IP2)*FE_OX+MN_OX*S_FE_OX(IP2))*SIV+MN_OX*
     &        FE_OX*S_SIV(IP2)))*pwr1*S_TS6(IP1)+(750.0D0*MN_OX*SIV+2600.0D0*FE_OX*SIV+
     &        1.0D10*MN_OX*FE_OX*SIV)*(pwr1D*S_TS6(IP1)+pwr1*S_TS6(NP))))*(1.0D0+75.0D0*
     &        TS6**0.67D0)**2-((750.0D0*(S_MN_OX(IP1)*SIV+MN_OX*S_SIV(IP1))+2600.0D0*(
     &        S_FE_OX(IP1)*SIV+FE_OX*S_SIV(IP1))+1.0D10*((S_MN_OX(IP1)*FE_OX+MN_OX*S_FE_OX(IP1))*SIV+
     &        MN_OX*FE_OX*S_SIV(IP1)))*(1.0D0+75.0D0*TS6**0.67D0)-(750.0D0*MN_OX*SIV
     &        +2600.0D0*FE_OX*SIV+1.0D10*MN_OX*FE_OX*SIV)*75.0D0*0.67D0*pwr1*
     &        S_TS6(IP1))*2*(1.0D0+75.0D0*TS6**0.67D0)*75.0D0*0.67D0*TS6**(-0.33D0)*
     &        S_TS6(IP2))/((1.0D0+75.0D0*TS6**0.67D0)**2)**2)
          ELSE
            S_DSIVDT( NP, 3 ) = -(((750.0D0*(S_MN_OX(NP)*SIV+MN_OX*S_SIV(NP))+2600.0D0*(S_FE_OX(NP)*SIV
     &        +FE_OX*S_SIV(NP))+1.0D10*((S_MN_OX(NP)*FE_OX+MN_OX*S_FE_OX(NP))*SIV+MN_OX*FE_OX
     &        *S_SIV(NP)))*(1.0D0+75.0D0*TS6**0.67D0)-(750.0D0*MN_OX*SIV+2600.0D0*
     &        FE_OX*SIV+1.0D10*MN_OX*FE_OX*SIV)*75.0D0*0.67D0*TS6**(-0.33D0)*
     &        S_TS6(NP))/(1.0D0+75.0D0*TS6**0.67D0)**2)
          END IF
        END DO
#endif

C...Calculate sulfur oxidation rate due to MHP (Jacobson,  1997)

        DSIVDT( 4 ) = -RMHP * HPLUS * MHPL * HSO3
        TMHP = INITGAS( LMHP ) * ONE_OVER_XL
        IF ( ( DSIVDT( 4 ) .EQ. 0.0D0 ) .OR.
     &       ( TSIV  .LE. CONMIN ) .OR.
     &       ( TMHP .LE. CONMIN ) ) THEN
          DTW( 4 ) = DTRMV
        ELSE
          DTW( 4 ) = -0.1D0 * MIN( TMHP, TSIV ) / DSIVDT( 4 )
        END IF

#ifdef sens
c... no sensitivity to pH now
        DO NP = 1, NPMAX
          S_TMHP( NP ) = S_INITGAS( NP, LMHP ) * ONE_OVER_XL
          C1 = -RMHP * HPLUS
          IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
            IP1 = IHIGH(NP,1)
            IP2 = IHIGH(NP,2)
            S_DSIVDT( NP, 4 ) = C1 * ( S_MHPL( NP )  * HSO3          + S_MHPL( IP1 ) * S_HSO3( IP2 )
     &                               + S_MHPL( IP2 ) * S_HSO3( IP1 ) + MHPL          * S_HSO3( NP )  )
          ELSE
            S_DSIVDT( NP, 4 ) = C1 * ( S_MHPL( NP ) * HSO3 + MHPL * S_HSO3( NP ) )
          END IF
        END DO
#endif

C...Calculate sulfur oxidation due to PAA (Jacobson,  1997)

        DSIVDT( 5 ) = -( RPAA * HPLUS + 7.00D2 ) * HSO3 * PAAL
        TPAA = INITGAS( LPAA ) * ONE_OVER_XL
        IF ( ( DSIVDT( 5 ) .EQ. 0.0D0 ) .OR.
     &       ( TSIV  .LE. CONMIN ) .OR.
     &       ( TPAA .LE. CONMIN ) ) THEN
          DTW( 5 ) = DTRMV
        ELSE
          DTW( 5 ) = -0.1D0 * MIN( TPAA, TSIV ) / DSIVDT( 5 )
        END IF

#ifdef sens
c... no sensitivity to pH now
        DO NP = 1, NPMAX
          S_TPAA( NP ) = S_INITGAS( NP, LPAA ) * ONE_OVER_XL
          IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
            IP1 = IHIGH(NP,1)
            IP2 = IHIGH(NP,2)
            C1 = -( RPAA * HPLUS + 7.00D2 )
            S_DSIVDT( NP, 5 ) = C1 * ( S_HSO3( NP )  * PAAL          + S_HSO3( IP1 ) * S_PAAL( IP2 )
     &                               + S_HSO3( IP2 ) * S_PAAL( IP1 ) + HSO3          * S_PAAL( NP )  )
          ELSE
            S_DSIVDT( NP, 5 ) = C1 * ( S_HSO3( NP ) * PAAL + HSO3 * S_PAAL( NP ) )
          END IF
        END DO
#endif

C...Calculate total sulfur iv oxidation rate

        DSIVDT( 0 ) = 0.0D0
        DO IOX = 1, NUMOX
          DSIVDT( 0 ) = DSIVDT( 0 ) + DSIVDT( IOX )
        END DO

#ifdef sens
        S_DSIVDT( :, 0 ) = 0.0D0
        DO NP = 1, NPMAX
          DO IOX = 1, NUMOX
            S_DSIVDT( NP,0 ) = S_DSIVDT( NP, 0 ) + S_DSIVDT( NP, IOX )
          END DO
        END DO
#endif

C...Calculate a minimum time step required

        DTW( 0 ) = MIN( DTW( 1 ), DTW( 2 ), DTW( 3 ),
     &                  DTW( 4 ), DTW( 5 ) )

C...check for large time step

        IF ( DTW( 0 ) .GT. 8.0D+37 ) THEN
          WRITE(LOGDEV,1001) PRCRATE, DSIVDT(0), TS6, DTW(0), CTHK1, WTAVG
        ELSE

C...CALCULATE IN-CLOUD SOA PRODUCTION
C...  Reference:  Carlton, A.G., B.J. Turpin, K.E. Altieri, A. Reff,
C...  S. Seitzinger, H.J. Lim, and B. Ervens (2007), Atmospheric Oxalic
C...  Acid and SOA Production from Glyoxal: Results of Aqueous
C...  Photooxidation Experiments, Atmos. Environ., 41(35), 7588-7602.

C...Define the total glyoxal available for oxidation

          TGLY = INITGAS( LGLY ) * ONE_OVER_XL

C...Calculate GLY oxidation due to OH

          DGLYDT = -RGLY3 * GLYL * OHL

C...Define the total methylglyoxal available for oxidation

          TMGLY = INITGAS( LMGLY ) * ONE_OVER_XL

C...Calculate MGLY oxidation due to OH

          DMGLYDT = -RMGLY3 * MGLYL * OHL

C... Define total HFPODAF available for oxidaiton
          THFPODAF = INITGAS ( LHFPODAF_G ) * ONE_OVER_XL
C... Calculate GenX formation rate through hydrolysis
          DHFPODADT = -RHFPODAF * HFPODAF_l ! mol/L/s
          
C... Define total COF2 available for oxidaiton
          TCOF2 = INITGAS ( LCOF2_G ) * ONE_OVER_XL
C... Calculate formation rate through hydrolysis
          DFCOOHDT = -RCOF2 * COF2_l ! mol/L/s

C... Define total PFMOAF available for oxidaiton
          TPFMOAF = INITGAS ( LPFMOAF_G ) * ONE_OVER_XL
C... Calculate formation rate through hydrolysis
          DPFMOAADT = -RPFMOAF * PFMOAF_l ! mol/L/s

!ccC...Define the total OH available for oxidation
!cc
!cc          THO = PHO0 * ONE_OVER_XL

C...Calculate OH consumption

!steadystate          DOHDT = -( RGLY3 * GLYL + RMGLY3 * MGLYL ) * OHL

#ifdef sens
          DO NP = 1, NPMAX
            S_TGLY( NP )  = S_INITGAS( NP, LGLY ) * ONE_OVER_XL
            S_TMGLY( NP ) = S_INITGAS( NP, LMGLY ) * ONE_OVER_XL
c           IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
c             IP1 = IHIGH(NP,1)
c             IP2 = IHIGH(NP,2)
c             S_DGLYDT( NP ) = -RGLY3 * ( S_GLYL( NP )  * OHL          + S_GLYL( IP1 ) * S_OHL( IP2 )
c    &                                  + S_GLYL( IP2 ) * S_OHL( IP1 ) + GLYL          * S_OHL( NP ) )
c             S_DMGLYDT( NP ) = -RMGLY3 * ( S_MGLYL( NP )  * OHL + S_MGLYL( IP1 ) * S_OHL( IP2 )
c    &                                    + S_MGLYL( IP2 ) * S_OHL( IP1 ) + MGLYL          * S_OHL( NP ) )
c           ELSE
c             S_DGLYDT( NP ) = -RGLY3 * ( S_GLYL( NP ) * OHL + GLYL * S_OHL( NP ) )
c             S_DMGLYDT( NP ) = -RMGLY3 * ( S_MGLYL( NP ) * OHL + MGLYL * S_OHL( NP ) )
c           ENDIF

c assume no OH sensitivity for now, because it causes instability in sensitvities
            S_DGLYDT( NP ) = -RGLY3 * S_GLYL( NP ) * OHL
            S_DMGLYDT( NP ) = -RMGLY3 * S_MGLYL( NP ) * OHL

          END DO
#endif

C...calculate the change in sulfur iv for this time step

60        CONTINUE
          DTS6 = ABS( DTW( 0 ) * DSIVDT( 0 ) )

C...If DSIV(0), sulfur iv oxidized during this time step would be
C... less than 5% of sulfur oxidized since time 0, then double DT

          IF ( DTW( 0 ) .LE. TAUCLD ) THEN
            IF ( DTS6 .LT. 0.05D0 * TS6 ) THEN
              DTW( 0 ) = DTW( 0 ) * 2.0D0
              GO TO 60
            END IF
          END IF
        END IF
        DTW( 0 ) = MIN( DTW( 0 ), DTRMV )

C...Limit the timestep to prevent negative SO2 concentrations and mass creation
C...  for sulfate (suggested by Bonyoung Koo)

        IF ( DSIVDT( 0 ) .LT. 0.0D0 ) THEN
          DTW( 0 ) = MIN( DTW( 0 ), -TSIV / DSIVDT( 0 ) )
        END IF

C...If the total time after this time increment will be greater than
C...  TAUCLD sec., then set DTW(0) so that total time will be TAUCLD

        IF ( TIMEW + DTW( 0 ) .GT. TAUCLD ) DTW( 0 ) = TAUCLD - TIMEW
        IF ( ITERAT .GT. 100 ) DTW( 0 ) = MAX( 1.0D0, DTW( 0 ) )

C...limit timestep to no more than the washout time

        DTW( 0 ) = MIN( DTW( 0 ), TWASH )

C...force mass balance for the specified timestep
C...  for GLY and MGLY, assume that OH is in steady state

        DGLYDT  = MAX( DGLYDT,  -TGLY  / DTW( 0 ) )
        DMGLYDT = MAX( DMGLYDT, -TMGLY / DTW( 0 ) )

C... Force chyd production to be less than the total available acyl fluoride
        DHFPODADT = MAX ( DHFPODADT, -THFPODAF / DTW ( 0 ) ) 
        DFCOOHDT = MAX ( DFCOOHDT, -TCOF2 / DTW ( 0 ) )
        DPFMOAADT = MAX ( DPFMOAADT, -TPFMOAF / DTW ( 0 ) )

C...  for S(IV), also limit by oxidants (except assume O2 in steady state)

        DSIVDT( 1 ) = MAX( DSIVDT( 1 ), -MIN( TSIV, TH2O2 ) / DTW( 0 ) )
        DSIVDT( 2 ) = MAX( DSIVDT( 2 ), -MIN( TSIV, TO3   ) / DTW( 0 ) )
        DSIVDT( 3 ) = MAX( DSIVDT( 3 ), -TSIV / DTW( 0 ) )
        DSIVDT( 4 ) = MAX( DSIVDT( 4 ), -MIN( TSIV, TMHP  ) / DTW( 0 ) )
        DSIVDT( 5 ) = MAX( DSIVDT( 5 ), -MIN( TSIV, TPAA  ) / DTW( 0 ) )

#ifdef sens
        DO NP = 1, NPMAX

          IF ( DGLYDT .EQ. -TGLY  / DTW( 0 ) ) THEN
            S_DGLYDT( NP ) = -S_TGLY( NP ) / DTW( 0 )
          END IF

          IF ( DMGLYDT .EQ. -TMGLY / DTW( 0 ) ) THEN
            S_DMGLYDT( NP ) = - S_TMGLY( NP ) / DTW( 0 )
          END IF

          IF ( DSIVDT( 1 ) .EQ. -MIN( TSIV, TH2O2 ) / DTW( 0 ) ) THEN
              S_DSIVDT( NP, 1 ) = 0.D0
          END IF

          IF ( DSIVDT( 2 ) .EQ. -MIN( TSIV, TO3   ) / DTW( 0 ) ) THEN
              S_DSIVDT( NP, 2 ) = 0.D0
          END IF

          IF ( DSIVDT( 3 ) .EQ. -TSIV / DTW( 0 ) ) THEN
              S_DSIVDT( NP, 3 ) = 0.D0
          END IF

          IF ( DSIVDT( 4 ) .EQ. -MIN( TSIV, TMHP  ) / DTW( 0 ) ) THEN
              S_DSIVDT( NP, 4 ) = 0.D0
          END IF

          IF ( DSIVDT( 5 ) .EQ. -MIN( TSIV, TPAA  ) / DTW( 0 ) ) THEN
              S_DSIVDT( NP, 5 ) = 0.D0
          END IF

        END DO
#endif

C...  recalculate the total S(iv) oxidation rate

        DSIVDT( 0 ) = 0.0
        DO IOX = 1, NUMOX
          DSIVDT( 0 ) = DSIVDT( 0 ) + DSIVDT( IOX )
        END DO

#ifdef sens
        S_DSIVDT( :, 0 ) = 0.0D0
        DO NP = 1, NPMAX
          DO IOX = 1, NUMOX
            S_DSIVDT( NP,0 ) = S_DSIVDT( NP, 0 ) + S_DSIVDT( NP, IOX )
          END DO
        END DO
#endif

C...  if the total S(iv) oxidation rate over the timestep exceeds the amount of
C...    S(iv) available then scale the rates to conserve mass

        IF ( -DSIVDT( 0 ) * DTW( 0 ) .GT. TSIV ) THEN
          DSIV_SCALE = TSIV / ( -DSIVDT( 0 ) * DTW( 0 ) )
          DSIVDT( 0 ) = DSIVDT( 0 ) * DSIV_SCALE
          DSIVDT( 1 ) = DSIVDT( 1 ) * DSIV_SCALE
          DSIVDT( 2 ) = DSIVDT( 2 ) * DSIV_SCALE
          DSIVDT( 3 ) = DSIVDT( 3 ) * DSIV_SCALE
          DSIVDT( 4 ) = DSIVDT( 4 ) * DSIV_SCALE
          DSIVDT( 5 ) = DSIVDT( 5 ) * DSIV_SCALE
#ifdef sens
          DO NP = 1, NPMAX
            S_DSIVDT( NP, 0 ) = S_DSIVDT( NP, 0 ) * DSIV_SCALE
            S_DSIVDT( NP, 1 ) = S_DSIVDT( NP, 1 ) * DSIV_SCALE
            S_DSIVDT( NP, 2 ) = S_DSIVDT( NP, 2 ) * DSIV_SCALE
            S_DSIVDT( NP, 3 ) = S_DSIVDT( NP, 3 ) * DSIV_SCALE
            S_DSIVDT( NP, 4 ) = S_DSIVDT( NP, 4 ) * DSIV_SCALE
            S_DSIVDT( NP, 5 ) = S_DSIVDT( NP, 5 ) * DSIV_SCALE
          END DO
#endif
        END IF

C...Set DSIV(I), I = 0,NUMOX, the amount of S(IV) oxidized by each
C... individual oxidizing agent, as well as the total.

        DO IOX = 0, NUMOX
          DS4( IOX ) = DS4( IOX ) + DTW( 0 ) * DSIVDT( IOX )
        END DO

        DGLY1  = DGLY1  + DTW( 0 ) * DGLYDT

        DMGLY1 = DMGLY1 + DTW( 0 ) * DMGLYDT

        DHFPODAF1    = DHFPODAF1 + DTW( 0 ) * DHFPODADT    ! loss of HFPODAF ( mol/L)
        DHFPODAchyd1 = DHFPODAchyd1 - DTW( 0 ) * DHFPODADT ! production of HFPO-DA (mol/L)
        DCOF21       = DCOF21 + DTW( 0 ) * DFCOOHDT        ! loss of COF2 ( mol/L)
        DFCOOHchyd1  = DFCOOHchyd1 - DTW( 0 ) * DFCOOHDT   ! production of FCOOH (mol/L)
        DPFMOAF1     = DPFMOAF1 + DTW( 0 ) * DPFMOAADT     ! loss of PFMOAF ( mol/L)
        DPFMOAAchyd1 = DPFMOAAchyd1 - DTW( 0 ) * DPFMOAADT ! production of PFMOAA (mol/L)

csteadystate        DOH1   = DOH1   + DTW( 0 ) * DOHDT

C...Calculate AORGC Production:  4% SOAcld (ORGC) yield from glyoxal
C...  and methylglyoxal is assumed

        DORGC = DORGC - ( 0.04D0 * ( DGLYDT + DMGLYDT ) * DTW( 0 ) )

#ifdef isam
        DGLY1_SAVE  = DGLY1_SAVE  - 0.04D0 * DGLYDT  * DTW( 0 )
        DMGLY1_SAVE = DMGLY1_SAVE - 0.04D0 * DMGLYDT * DTW( 0 )
#endif


#ifdef sens
        DO NP = 1, NPMAX

          DO IOX = 0, NUMOX
            S_DS4( NP, IOX ) = S_DS4( NP, IOX ) + DTW( 0 ) * S_DSIVDT( NP, IOX )
          END DO

          S_DGLY1( NP )  = S_DGLY1( NP )  + DTW( 0 ) * S_DGLYDT( NP )

          S_DMGLY1( NP ) = S_DMGLY1( NP ) + DTW( 0 ) * S_DMGLYDT( NP )

          S_DORGC( NP )  = S_DORGC( NP ) - ( 0.04D0 * ( S_DGLYDT( NP ) + S_DMGLYDT( NP ) ) * DTW( 0 ) )

        END DO
#endif

C...Compute depositions and concentrations for each species

        WETFAC = ( 1.0D0 - EXP( -DTW( 0 ) / TWASH ) ) / XC1  !!!new analytic soln to be used in CMAQv5.0

        DO LIQ = 1, N_AQ_LIQS
          WETDEP( LIQ ) = WETDEP( LIQ ) + LIQUID( LIQ ) * WETFAC
        END DO

        TIMEW = TIMEW + DTW( 0 )

#ifdef sens
        DO NP = 1, NPMAX
          DO LIQ = 1, N_AQ_LIQS
            S_WETDEP( NP, LIQ ) = S_WETDEP( NP, LIQ ) + S_LIQUID( NP, LIQ ) * WETFAC
          END DO
        END DO
#endif

      END DO     ! I20C loop

C...At this point, TIMEW=TAUCLD
C...  compute the scavenging coefficient for SO4 which will be used for
C...  scavenging aerosol number in the accumulation mode

      DEPSUM = ( WETDEP( LSO4ACCL ) + WETDEP( LHSO4ACCL ) ) * XC1

      IF ( ( LOADING( LSO4, IACC ) + LOADING( LSO4, IAIT ) - DS4( 0 ) ) .NE. 0.0D0 ) THEN
        BETASO4 = DEPSUM / ( ( LOADING( LSO4, IACC ) + LOADING( LSO4, IAIT ) - DS4( 0 ) ) * TAUCLD )
      ELSE
        BETASO4 = 0.0D0
      END IF

      EBETASO4T = EXP( -BETASO4 * TAUCLD )
      EALFA0T   = EXP( -ALFA0 * TAUCLD )
      EALFA2T   = EXP( -ALFA2 * TAUCLD )
      EALFA3T   = EXP( -ALFA3 * TAUCLD )

C...Compute the output concentrations and wet deposition amounts

      TOTAMM = ( PNH3F  + ( NH4ACC + NH3L  ) * XL ) * RECIPAP1
      TOTNIT = ( PHNO3F + ( NO3ACC + HNO3L ) * XL ) * RECIPAP1

#ifdef sens
      DO NP = 1, NPMAX
         S_TOTAMM( NP ) = ( S_PNH3F( NP )  + ( S_NH4ACC( NP ) + S_NH3L( NP )  ) * XL ) * RECIPAP1
         S_TOTNIT( NP ) = ( S_PHNO3F( NP ) + ( S_NO3ACC( NP ) + S_HNO3L( NP ) ) * XL ) * RECIPAP1
      END DO
#endif

C...gas-phase species wet deposition (mm mol/lit)

      GASWDEP( LSO2   ) = WETDEP( LSO3L  ) + WETDEP( LHSO3L )
     &                  + WETDEP( LSO2L  )
      GASWDEP( LNH3   ) = WETDEP( LNH3L  )
      GASWDEP( LH2O2  ) = WETDEP( LH2O2L )
      GASWDEP( LO3    ) = WETDEP( LO3L   )
      GASWDEP( LCO2   ) = WETDEP( LCO3L  ) + WETDEP( LHCO3L )
     &                  + WETDEP( LCO2L  )
      GASWDEP( LFOA   ) = WETDEP( LFOAL  ) + WETDEP( LHCO2L )
      GASWDEP( LMHP   ) = WETDEP( LMHPL  )
      GASWDEP( LPAA   ) = WETDEP( LPAAL  )
      GASWDEP( LHCL   ) = WETDEP( LHCLL  )
      GASWDEP( LHNO3  ) = WETDEP( LHNO3L )
      GASWDEP( LN2O5  ) = 0.0D0
      GASWDEP( LH2SO4 ) = 0.0D0
      GASWDEP( LGLY   ) = WETDEP( LGLYL  )
      GASWDEP( LMGLY  ) = WETDEP( LMGLYL ) 

!wet deposition from the gas phase is the amount in the liquid phase times the gas-phase fraction
      GASWDEP( LHFPODAchyd_g ) = WETDEP( LHFPODAchyd_l ) * (1.0 - HFPODAchyd_xi )
      GASWDEP( LHFPODAF_g )    = WETDEP( LHFPODAF_l ) * (1.0 - HFPODAF_xi ) 
      GASWDEP( LFCOOHchyd_g )  = WETDEP( LFCOOHchyd_l ) * (1.0 - FCOOHchyd_xi )
      GASWDEP( LCOF2_g )       = WETDEP( LCOF2_l ) * (1.0 - COF2_xi )
      GASWDEP( LPFMOAAchyd_g ) = WETDEP( LPFMOAAchyd_l ) * (1.0 - PFMOAAchyd_xi )
      GASWDEP( LPFMOAF_g )   = WETDEP( LPFMOAF_l ) * (1.0 - PFMOAF_xi )

#ifdef sens
      DO NP = 1, NPMAX
        S_GASWDEP( NP, LSO2   ) = S_WETDEP( NP, LSO3L  ) + S_WETDEP( NP, LHSO3L )
     &                          + S_WETDEP( NP, LSO2L  )
        S_GASWDEP( NP, LNH3   ) = S_WETDEP( NP, LNH3L  )
        S_GASWDEP( NP, LH2O2  ) = S_WETDEP( NP, LH2O2L )
        S_GASWDEP( NP, LO3    ) = S_WETDEP( NP, LO3L   )
        S_GASWDEP( NP, LCO2   ) = S_WETDEP( NP, LCO3L  ) + S_WETDEP( NP, LHCO3L )
     &                          + S_WETDEP( NP, LCO2L  )
        S_GASWDEP( NP, LFOA   ) = S_WETDEP( NP, LFOAL  ) + S_WETDEP( NP, LHCO2L )
        S_GASWDEP( NP, LMHP   ) = S_WETDEP( NP, LMHPL  )
        S_GASWDEP( NP, LPAA   ) = S_WETDEP( NP, LPAAL  )
        S_GASWDEP( NP, LHCL   ) = S_WETDEP( NP, LHCLL  )
        S_GASWDEP( NP, LHNO3  ) = S_WETDEP( NP, LHNO3L )
        S_GASWDEP( NP, LN2O5  ) = 0.0D0
        S_GASWDEP( NP, LH2SO4 ) = 0.0D0
        S_GASWDEP( NP, LGLY   ) = S_WETDEP( NP, LGLYL  )
        S_GASWDEP( NP, LMGLY  ) = S_WETDEP( NP, LMGLYL )
      END DO
#endif

C...gas concentrations (mol/molV)

      GAS( LSO2   ) = ( PSO2F  + XL *  SIV )   * RECIPAP1
      GAS( LH2O2  ) = ( PH2O2F + XL *  H2O2L ) * RECIPAP1
      GAS( LO3    ) = ( PO3F   + XL *  O3L )   * RECIPAP1
      GAS( LCO2   ) = ( PCO2F  + XL *  CO2L )  * RECIPAP1
      GAS( LFOA   ) = ( PFOAF  + XL * ( FOAL + HCO2 ) ) * RECIPAP1
      GAS( LMHP   ) = ( PMHPF  + XL *  MHPL )  * RECIPAP1
      GAS( LPAA   ) = ( PPAAF  + XL *  PAAL )  * RECIPAP1
      GAS( LHCL   ) = ( PHCLF  + XL *  HCLL )  * RECIPAP1
      GAS( LGLY   ) = ( PGLYF  + XL *  GLYL )  * RECIPAP1
      GAS( LMGLY  ) = ( PMGLYF + XL *  MGLYL)  * RECIPAP1

      GAS( LNH3   ) = FNH3  * TOTAMM
      GAS( LHNO3  ) = FHNO3 * TOTNIT
      GAS( LN2O5  ) = 0.0D0 ! assume all into aerosol
      GAS( LH2SO4 ) = 0.0D0 ! assume all into aerosol

      GAS( LHFPODAchyd_g ) = PHFPODAchydF * RECIPAP1 ! mol/mol units
      GAS( LHFPODAF_g )    = PHFPODAFF    * RECIPAP1 ! mol/mol units
      GAS( LFCOOHchyd_g )  = PFCOOHchydF  * RECIPAP1 ! mol/mol units
      GAS( LCOF2_g )       = PCOF2F       * RECIPAP1 ! mol/mol units
      GAS( LPFMOAAchyd_g ) = PPFMOAAchydF * RECIPAP1 ! mol/mol units
      GAS( LPFMOAF_g )    = PPFMOAFF    * RECIPAP1 ! mol/mol units

#ifdef sens
      DO NP = 1, NPMAX
        S_GAS( NP, LSO2   ) = ( S_PSO2F( NP )  + XL *  S_SIV( NP ) )   * RECIPAP1
c       S_GAS( NP, LH2O2  ) = ( S_PH2O2F( NP ) + XL *  S_H2O2L( NP ) ) * RECIPAP1
c       S_GAS( NP, LO3    ) = ( S_PO3F( NP )   + XL *  S_O3L( NP ) )   * RECIPAP1
c       S_GAS( NP, LCO2   ) = ( S_PCO2F( NP )  + XL *  S_CO2L( NP ) )  * RECIPAP1
c       S_GAS( NP, LFOA   ) = ( S_PFOAF( NP )  + XL * ( S_FOAL( NP ) + S_HCO2( NP ) ) ) * RECIPAP1
c       S_GAS( NP, LMHP   ) = ( S_PMHPF( NP )  + XL *  S_MHPL( NP ) )  * RECIPAP1
c       S_GAS( NP, LPAA   ) = ( S_PPAAF( NP )  + XL *  S_PAAL( NP ) )  * RECIPAP1
c       S_GAS( NP, LHCL   ) = ( S_PHCLF( NP )  + XL *  S_HCLL( NP ) )  * RECIPAP1
        S_GAS( NP, LGLY   ) = ( S_PGLYF( NP )  + XL *  S_GLYL( NP ) )  * RECIPAP1
        S_GAS( NP, LMGLY  ) = ( S_PMGLYF( NP ) + XL *  S_MGLYL( NP ))  * RECIPAP1
c       S_GAS( NP, LNH3   ) = S_FNH3( NP )  * S_TOTAMM( NP )
c       S_GAS( NP, LHNO3  ) = S_FHNO3( NP ) * S_TOTNIT( NP )
        S_GAS( NP, LN2O5  ) = 0.0D0 ! assume all into aerosol
        S_GAS( NP, LH2SO4 ) = 0.0D0 ! assume all into aerosol
      END DO
#endif

C...aerosol species wet deposition (mm mol/lit)
C...  there is no wet deposition of aitken particles, they attached
C...  to the accumulation mode particles

      AERWDEP( LSO4, IAIT ) = 0.0D0
      AERWDEP( LNH4, IAIT ) = 0.0D0
      AERWDEP( LNO3, IAIT ) = 0.0D0
      AERWDEP( LEC,  IAIT ) = 0.0D0
      AERWDEP( LPRI, IAIT ) = 0.0D0

      AERWDEP( LPOA, IAIT ) = 0.0D0
      AERWDEP( LSOA, IAIT ) = 0.0D0

      AERWDEP( LSO4, IACC ) = WETDEP( LSO4ACCL ) + WETDEP( LHSO4ACCL )
      IF ( STM ) THEN
        AERWDEP( LSO4AQH2O2, IACC ) = WETDEP( LTS6AQH2O2L )
        AERWDEP( LSO4AQO3,   IACC ) = WETDEP( LTS6AQO3L   )
        AERWDEP( LSO4AQFEMN, IACC ) = WETDEP( LTS6AQFEMNL )
        AERWDEP( LSO4AQMHP,  IACC ) = WETDEP( LTS6AQMHPL  )
        AERWDEP( LSO4AQPAA,  IACC ) = WETDEP( LTS6AQPAAL  )
      END IF
      AERWDEP( LNH4, IACC ) = WETDEP( LNH4ACCL )
      AERWDEP( LNO3, IACC ) = WETDEP( LNO3ACCL )
      AERWDEP( LEC,  IACC ) = WETDEP( LECL     )
      AERWDEP( LPRI, IACC ) = WETDEP( LPRIML   )

      AERWDEP( LSOA,  IACC ) = WETDEP( LSOAL  )
      AERWDEP( LORGC, IACC ) = WETDEP( LORGCL )
      AERWDEP( LPOA,  IACC ) = WETDEP( LPOAL )

      AERWDEP( LSO4, ICOR ) = WETDEP( LTS6CORL  )
      AERWDEP( LNO3, ICOR ) = WETDEP( LNO3CORL  )
      AERWDEP( LNH4, ICOR ) = WETDEP( LNH4CORL  )

      AERWDEP( LNA, IAIT  ) = 0.0D0
      AERWDEP( LCL, IAIT  ) = 0.0D0
      AERWDEP( LNA, IACC  ) = WETDEP( LNAACCL )
      AERWDEP( LCL, IACC  ) = WETDEP( LCLACCL )
      AERWDEP( LCL, ICOR  ) = WETDEP( LCLCORL )

      AERWDEP( LCA,   IACC ) = WETDEP( LCAACCL )  ! AE6 - SLN 16March2011
      AERWDEP( LMG,   IACC ) = WETDEP( LMGACCL )  ! AE6 - SLN 16March2011
      AERWDEP( LK,    IACC ) = WETDEP( LKACCL  )  ! AE6 - SLN 16March2011
      AERWDEP( LSOIL, ICOR ) = WETDEP( LSOILCL )  ! AE6 - SLN 16March2011
      AERWDEP( LANTH, ICOR ) = WETDEP( LANTHCL )  ! AE6 - SLN 16March2011
      AERWDEP( LSEAS, ICOR ) = WETDEP( LSEASCL )  ! AE6 - SLN 16March2011
      AERWDEP( LFE,   IACC ) = WETDEP( LFEACCL )  ! AE6 - SLN 22March2011
      AERWDEP( LMN,   IACC ) = WETDEP( LMNACCL )  ! AE6 - SLN 22March2011
                      
      AERWDEP( LHFPODAchyd_p, IACC ) = WETDEP( LHFPODAchyd_l ) * HFPODAchyd_xi
      AERWDEP( LHFPODAF_p,    IACC ) = WETDEP( LHFPODAF_l ) * HFPODAF_xi
      AERWDEP( LFCOOHchyd_p, IACC )  = WETDEP( LFCOOHchyd_l ) * FCOOHchyd_xi
      AERWDEP( LCOF2_p,    IACC )    = WETDEP( LCOF2_l ) * COF2_xi
      AERWDEP( LPFMOAAchyd_p, IACC ) = WETDEP( LPFMOAAchyd_l ) * PFMOAAchyd_xi
      AERWDEP( LPFMOAF_p,    IACC )  = WETDEP( LPFMOAF_l ) * PFMOAF_xi

#ifdef sens
      DO NP = 1, NPMAX
        S_AERWDEP( NP, LSO4, IAIT )  = 0.0D0
        S_AERWDEP( NP, LNH4, IAIT )  = 0.0D0
        S_AERWDEP( NP, LNO3, IAIT )  = 0.0D0
        S_AERWDEP( NP, LEC,  IAIT )  = 0.0D0
        S_AERWDEP( NP, LPRI, IAIT )  = 0.0D0
        S_AERWDEP( NP, LPOA, IAIT )  = 0.0D0
        S_AERWDEP( NP, LSOA, IAIT )  = 0.0D0
        S_AERWDEP( NP, LSO4, IACC )  = S_WETDEP( NP, LSO4ACCL ) + S_WETDEP( NP, LHSO4ACCL )
        S_AERWDEP( NP, LNH4, IACC )  = S_WETDEP( NP, LNH4ACCL )
        S_AERWDEP( NP, LNO3, IACC )  = S_WETDEP( NP, LNO3ACCL )
        S_AERWDEP( NP, LEC,  IACC )  = S_WETDEP( NP, LECL     )
        S_AERWDEP( NP, LPRI, IACC )  = S_WETDEP( NP, LPRIML   )
        S_AERWDEP( NP, LSOA, IACC )  = S_WETDEP( NP, LSOAL  )
        S_AERWDEP( NP, LORGC,IACC )  = S_WETDEP( NP, LORGCL )
        S_AERWDEP( NP, LPOA, IACC )  = S_WETDEP( NP, LPOAL )
        S_AERWDEP( NP, LSO4, ICOR )  = S_WETDEP( NP, LTS6CORL  )
        S_AERWDEP( NP, LNO3, ICOR )  = S_WETDEP( NP, LNO3CORL  )
        S_AERWDEP( NP, LNH4, ICOR )  = S_WETDEP( NP, LNH4CORL  )
        S_AERWDEP( NP, LNA , IAIT )  = 0.0D0
        S_AERWDEP( NP, LCL , IAIT )  = 0.0D0
        S_AERWDEP( NP, LNA,  IACC )  = S_WETDEP( NP, LNAACCL )
        S_AERWDEP( NP, LCL,  IACC )  = S_WETDEP( NP, LCLACCL )
        S_AERWDEP( NP, LCL,  ICOR )  = S_WETDEP( NP, LCLCORL )
        S_AERWDEP( NP, LCA,  IACC ) = S_WETDEP( NP, LCAACCL )
        S_AERWDEP( NP, LMG,  IACC ) = S_WETDEP( NP, LMGACCL )
        S_AERWDEP( NP, LK,   IACC ) = S_WETDEP( NP, LKACCL  )
        S_AERWDEP( NP, LSOIL,ICOR ) = S_WETDEP( NP, LSOILCL )
        S_AERWDEP( NP, LANTH,ICOR ) = S_WETDEP( NP, LANTHCL )
        S_AERWDEP( NP, LSEAS,ICOR ) = S_WETDEP( NP, LSEASCL )
        S_AERWDEP( NP, LFE,  IACC ) = S_WETDEP( NP, LFEACCL )
        S_AERWDEP( NP, LMN,  IACC ) = S_WETDEP( NP, LMNACCL )
      END DO
#endif

C...Compute for Aerosol species in  TXHG Version

      AERWDEP( LTRACER, IAIT ) = 0.0D0
      AERWDEP( LTRACER, IACC ) = WETDEP( LTRACERL )
      AERWDEP( LTRACER, ICOR ) = WETDEP( LTRACERCORL )
      AERWDEP( LPHG,    IAIT ) = 0.0D0
      AERWDEP( LPHG,    IACC ) = WETDEP( LPHGFINEL )
      AERWDEP( LPHG,    ICOR ) = WETDEP( LPHGCORL )

C...aerosol concentrations (mol/molV)

      AEROSOL( LSO4, IAIT ) = AEROSOL( LSO4, IAIT ) * EALFA3T
      AEROSOL( LNH4, IAIT ) = AEROSOL( LNH4, IAIT ) * EALFA3T
      AEROSOL( LNO3, IAIT ) = AEROSOL( LNO3, IAIT ) * EALFA3T
      AEROSOL( LEC,  IAIT ) = AEROSOL( LEC,  IAIT ) * EALFA3T
      AEROSOL( LPRI, IAIT ) = AEROSOL( LPRI, IAIT ) * EALFA3T

      AEROSOL( LPOA, IAIT ) = AEROSOL( LPOA, IAIT ) * EALFA3T
      AEROSOL( LSOA, IAIT ) = AEROSOL( LSOA, IAIT ) * EALFA3T

      AEROSOL( LSO4, IACC ) = TS6ACC * XL * RECIPAP1
      IF ( STM ) THEN
        AEROSOL( LSO4AQH2O2, IACC ) = TS6AQH2O2  * XL * RECIPAP1
        AEROSOL( LSO4AQO3,   IACC ) = TS6AQO3    * XL * RECIPAP1
        AEROSOL( LSO4AQFEMN, IACC ) = TS6AQFEMN  * XL * RECIPAP1
        AEROSOL( LSO4AQMHP,  IACC ) = TS6AQMHP   * XL * RECIPAP1
        AEROSOL( LSO4AQPAA,  IACC ) = TS6AQPAA   * XL * RECIPAP1
      END IF
      AEROSOL( LEC,  IACC ) = EC     * XL * RECIPAP1
      AEROSOL( LPRI, IACC ) = PRIM   * XL * RECIPAP1

      AEROSOL( LSOA,  IACC ) = SOA  * XL * RECIPAP1
      AEROSOL( LORGC, IACC ) = ORGC * XL * RECIPAP1
      AEROSOL( LPOA,  IACC ) = POA  * XL * RECIPAP1

      AEROSOL( LNH4, IACC ) = FNH4ACC * TOTAMM
      AEROSOL( LNO3, IACC ) = FNO3ACC * TOTNIT

      AEROSOL( LSO4, ICOR )    = TS6COR * XL * RECIPAP1
      AEROSOL( LNO3, ICOR )    = NO3COR * XL * RECIPAP1
      AEROSOL( LNH4, ICOR )    = NH4COR * XL * RECIPAP1

      AEROSOL( LNA, IAIT  ) = AEROSOL( LNA, IAIT ) * EALFA3T
      AEROSOL( LCL, IAIT  ) = AEROSOL( LCL, IAIT ) * EALFA3T
      AEROSOL( LNA, IACC  ) = NAACC * XL * RECIPAP1
      AEROSOL( LCL, IACC  ) = CLACC * XL * RECIPAP1
      AEROSOL( LCL, ICOR  ) = CLCOR * XL * RECIPAP1

      AEROSOL( LNUM, IAIT ) = AEROSOL( LNUM, IAIT ) * EALFA0T
      AEROSOL( LNUM, IACC ) = AEROSOL( LNUM, IACC ) * EBETASO4T
      AEROSOL( LNUM, ICOR ) = AEROSOL( LNUM, ICOR ) * EXP(-TAUCLD / TWASH )

      AEROSOL( LCA,   IACC ) = CAACC   * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LMG,   IACC ) = MGACC   * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LK,    IACC ) = KACC    * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LSOIL, ICOR ) = SOILCOR * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LANTH, ICOR ) = ANTHCOR * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LSEAS, ICOR ) = SEASCOR * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LFE,   IACC ) = FEACC   * XL * RECIPAP1 ! AE6 - SLN 22March2011
      AEROSOL( LMN,   IACC ) = MNACC   * XL * RECIPAP1 ! AE6 - SLN 22March2011

      AEROSOL( LHFPODAchyd_p, IACC ) = HFPODAchyd_l * XL * RECIPAP1
      AEROSOL( LHFPODAF_p, IACC )    = HFPODAF_l * XL * RECIPAP1
      AEROSOL( LFCOOHchyd_p, IACC )  = FCOOHchyd_l * XL * RECIPAP1
      AEROSOL( LCOF2_p, IACC )       = COF2_l * XL * RECIPAP1
      AEROSOL( LPFMOAAchyd_p, IACC ) = PFMOAAchyd_l * XL * RECIPAP1
      AEROSOL( LPFMOAF_p, IACC )     = PFMOAF_l * XL * RECIPAP1

#ifdef sens
      DO NP =1, NPMAX
        S_AEROSOL( NP, LSO4, IAIT )   = S_AEROSOL( NP, LSO4, IAIT ) * EALFA3T
        S_AEROSOL( NP, LNH4, IAIT )   = S_AEROSOL( NP, LNH4, IAIT ) * EALFA3T
        S_AEROSOL( NP, LNO3, IAIT )   = S_AEROSOL( NP, LNO3, IAIT ) * EALFA3T
        S_AEROSOL( NP, LEC,  IAIT )   = S_AEROSOL( NP, LEC,  IAIT ) * EALFA3T
        S_AEROSOL( NP, LPRI, IAIT )   = S_AEROSOL( NP, LPRI, IAIT ) * EALFA3T
        S_AEROSOL( NP, LPOA, IAIT )   = S_AEROSOL( NP, LPOA, IAIT ) * EALFA3T
        S_AEROSOL( NP, LSOA, IAIT )   = S_AEROSOL( NP, LSOA, IAIT ) * EALFA3T
        S_AEROSOL( NP, LSO4, IACC )   = S_TS6ACC( NP ) * XL * RECIPAP1
        S_AEROSOL( NP, LEC,  IACC )   = S_EC( NP )     * XL * RECIPAP1
        S_AEROSOL( NP, LPRI, IACC )   = S_PRIM( NP )   * XL * RECIPAP1
        S_AEROSOL( NP, LSOA, IACC )   = S_SOA( NP )  * XL * RECIPAP1
        S_AEROSOL( NP, LORGC,IACC )   = S_ORGC( NP ) * XL * RECIPAP1
        S_AEROSOL( NP, LPOA, IACC )   = S_POA( NP )  * XL * RECIPAP1
        S_AEROSOL( NP, LSO4, ICOR )   = S_TS6COR( NP ) * XL * RECIPAP1
      END DO
#endif

C...Compute for Aerosol species in  TXHG Version

      AEROSOL( LTRACER, IAIT ) = AEROSOL( LTRACER, IAIT ) * EALFA3T
      AEROSOL( LTRACER, IACC ) = TRACER    * XL * RECIPAP1
      AEROSOL( LTRACER, ICOR ) = TRACERCOR * XL * RECIPAP1
      AEROSOL( LPHG, IAIT )    = AEROSOL( LPHG, IAIT ) * EALFA3T
      AEROSOL( LPHG, IACC )    = HGFINE * XL * RECIPAP1
      AEROSOL( LPHG, ICOR )    = HGCOR * XL * RECIPAP1
     
C...Store the fraction of aitken-mode associated mass in the 
C   bulk aerosol aqueous chemistry tracer
      FRACAIT( : ) = 0.d0
      IF( AEROSOL(LTRACER, IACC) .GT. 0.d0 ) 
     &   FRACAIT( LTRACER )  = MIN((TRACI  * XL * RECIPAP1) / 
     &                         AEROSOL(LTRACER, IACC), 1.0D0) 
      
      IF( AEROSOL(LPOA, IACC) .GT. 0.d0 ) 
     &   FRACAIT( LPOA ) = MIN((POAI  * XL * RECIPAP1) / 
     &                     AEROSOL(LPOA, IACC), 1.0D0)
      
      IF( AEROSOL(LPRI, IACC) .GT. 0.d0 ) 
     &   FRACAIT( LPRI ) = MIN((PRII  * XL * RECIPAP1) / 
     &                     AEROSOL(LPRI, IACC), 1.0D0)
      
      IF( AEROSOL(LSOA, IACC) .GT. 0.d0 ) 
     &   FRACAIT( LSOA ) = MIN((SOAI  * XL * RECIPAP1) / 
     &                     AEROSOL(LSOA, IACC), 1.0D0)

C...store the amount of hydrogen deposition

      HPWDEP = REAL( WETDEP( LACL ), 4 )
#ifdef sens
      DO NP =1, NPMAX
        S_HPWDEP( NP ) = S_WETDEP( NP, LACL )
      END DO
#endif

#ifdef isam
C... store sulfate production/loss quantities
      DEPSUM_SAVE =        DEPSUM * XL * RECIPAP1
      DS4_SAVE    = -1.0 * DS4(0) * XL * RECIPAP1
      REMOV_SAVE  = WETDEP( LSO4ACCL ) + WETDEP( LHSO4ACCL )

C... store AORGC production/loss quantities      
      DEPSUM_AORGC_SAVE = WETDEP( LORGCL ) * XC1 * XL * RECIPAP1
      DGLY1_SAVE        = DGLY1_SAVE  * XL * RECIPAP1
      DMGLY1_SAVE       = DMGLY1_SAVE * XL * RECIPAP1
      REMOV_AORGC_SAVE  = WETDEP( LORGCL )
#endif

      RETURN

C...formats

1001  FORMAT ( 1X, 'STORM RATE=', F6.3, 'DSIVDT(0) =', F10.5,
     &       'TS6=', F10.5, 'DTW(0)=', F10.5, 'CTHK1=', F10.5,
     &       'WTAVG=', F10.5 )

C1002  FORMAT( 65(1X, ES12.4, 4X) )
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

        SUBROUTINE PM3EXIT( CALLER, JDATE, JTIME, MSGTXT, EXITSTAT )
C.....................................................................
C
C  PURPOSE:   Provides M3EXIT functionality in a parallel environment.
C             The processor-id suffix is appended to the name of the
C             caller. Generate simple error messages for Models-3.
C             Program execution is terminated via exit(0) if exitstat
C             is zero and by MPI_ABORT otherwise.
C
C
C  PRECONDITIONS REQUIRED:  Same as for M3EXIT.
C
C
C  REVISION  HISTORY:
C       Original version 07/1998 by Al Bourgeois.
C       Modified 12/07/1998 by Al Bourgeois to add EXTERNAL declarations.
C       Modified 06/11/1999 by Al Bourgeois to cause all processors to exit.
C       Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with M3UTILIO; removed
C             deprecated TRIMLEN
C       Modified 09/19/2011 by David Wong
C          -- Replaced MPI_FINALIZE with MPI_ABORT to avoid hanging situation
C
C
C  ARGUMENT LIST DESCRIPTION:
C  IN:
C     CHARACTER*(*)   CALLER       ! Name of the caller.
C     INTEGER         JDATE        ! Model date for the error.
C     INTEGER         JTIME        ! Model time for the error.
C     CHARACTER*(*)   MSGTXT       ! Error message.
C     INTEGER         EXITSTAT     ! Exit status for program.
C
C     COMMON BLOCK PIOVARS:
C     INTEGER  MY_PE               !  Local processor id.
C
C  OUT: none
C
C  SUBROUTINES AND FUNCTIONS CALLS:  INIT3, SHUT3, MPI_ABORT, INQUIRE.
C
C***********************************************************************

      USE M3UTILIO              ! i/o api
      USE RUNTIME_VARS

      IMPLICIT NONE

C...........   INCLUDES:

      INCLUDE 'mpif.h'           ! MPI definitions and parameters.
      INCLUDE 'PIOVARS.EXT'      ! Parameters for parallel implementation.


C...........   ARGUMENTS and their descriptions:

      CHARACTER*(*)   CALLER       ! Name of the caller.
      INTEGER         JDATE        ! Model date for the error.
      INTEGER         JTIME        ! Model time for the error.
      CHARACTER*(*)   MSGTXT       ! Error message.
      INTEGER         EXITSTAT     ! Exit status for program.


C...........   LOCAL VARIABLES

      INTEGER      LENSTR       ! String length of CALLER.
      INTEGER      IDEV         ! Loop counter over FORTRAN unit numbers.
      INTEGER      ERRCODE      ! Error code from abort attempt.
      INTEGER      IERROR       ! Error from MPI_ABORT routine.
      LOGICAL      OFLAG        ! Flag for indicating file open.
      CHARACTER*24 DTBUF        ! Scratch area for date string.
      CHARACTER*7  PE_STR       ! String suffix to go with processor ID.
      CHARACTER*16 CALL16       ! First 16 characters of CALLER.
      CHARACTER*26 PCALLER      ! New caller string with PE information.

C.............................................................................
C   begin subroutine PM3EXIT
      errcode = 1               ! arbitrary

C.......  Construct new CALLER string.
      WRITE (PE_STR,'(A7)') ' on PE '


C.......  Construct new CALLER string.
      LENSTR = MIN( 16, LEN_TRIM(CALLER) )
      CALL16 = CALLER( 1: LENSTR )
      PCALLER = CALL16(1:LENSTR)//PE_STR//CMYPE


C.......  Do M3EXIT tasks.

      IF ( EXITSTAT .NE. 0 ) THEN     ! Print messages for abnormal abort. 

          WRITE( OUTDEV,91010 ) PCALLER, TRIM( MSGTXT )

          WRITE( LOGDEV,91010 ) PCALLER, TRIM( MSGTXT )
          FLUSH( LOGDEV )

          IF ( JDATE .GT. 0  .OR.  JTIME .GT. 0 ) THEN
              DTBUF = DT2STR( JDATE, JTIME )
              IF ( LOGDEV .NE. 6 )
     &            WRITE( LOGDEV,* ) 'PM3EXIT:  DTBUF ', DTBUF
              WRITE( LOGDEV,92020 ) DTBUF, JDATE, JTIME
          ELSE
              IF ( LOGDEV .NE. 6 )
     &            WRITE( LOGDEV,* )  'PM3EXIT:  date&time specified as 0'
              WRITE( LOGDEV,92000 )
     &                'Date&time specified as 0', ' ', ' '
          END IF


      ELSE        ! Print message for normal completion.

            WRITE( LOGDEV,92010 ) PCALLER, TRIM( MSGTXT )

            IF ( JDATE .GT. 0  .OR.  JTIME .GT. 0 ) THEN
                WRITE( LOGDEV,92020 )
     &             DT2STR( JDATE, JTIME ), JDATE, JTIME
            END IF

      END IF


C.......  Shut down the I/O API.
      IF ( .NOT. SHUT3() ) THEN
         WRITE( LOGDEV,91000 )
     &   'Could not shut down I/O API files correctly'
      END IF


C.......  Close all files.
      DO IDEV = 10, 99
         INQUIRE( UNIT = IDEV, OPENED = OFLAG )
         IF ( OFLAG ) CLOSE( IDEV )
      END DO

      
      IF ( EXITSTAT .NE. 0 ) THEN    ! Abnormal abort.

C.......  Abort all parallel tasks.
          CALL MPI_ABORT( MPI_COMM_WORLD, ERRCODE, IERROR )
!         CALL MPI_FINALIZE( IERROR )

          STOP

      ELSE    !  exitstat = 0:  successful completion.

          CALL EXIT( EXITSTAT )

      ENDIF



C******************  FORMAT  STATEMENTS   ******************************

C...........   Error and warning message formats..... 91xxx

91000   FORMAT ( //5X , '*** ERROR ABORT in subroutine PM3EXIT ***',
     &            /5X , A , // )

91010   FORMAT ( //5X , '*** ERROR ABORT in subroutine ', A,
     &            /5X , A )


C...........   Informational (LOG) message formats... 92xxx

92000   FORMAT ( 5X , A )

92010   FORMAT ( //5X , '--->>  Normal Completion of program ', A,
     &            /5X , A )

92020   FORMAT ( 5X , 'Date and time ', A, :,
     &                  ' (', I7, ':', I6.6, ')' )

      END
  
         

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WR_CGRID ( CGRID, JDATE, JTIME, TSTEP )

C Save the instantaneous state of CGRID in an I/O-API "circular buffer"
C file to use for restart/continuation for subsequent simulation. This
C file will replace the CONC file for such use, allowing users to reduce
C the number of variables and/or layers saved to the CONC file.

C Revision History:
C      May 06 J.Young: initial
C      Feb 08 J.Young: fix VDESC3D bug
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   12 Aug 15 D.Wong:  Replaced MYPE with IO_PE_INCLUSIVE and added code
C                        to handle parallel I/O implementation
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      USE MIO_ASCII
      USE RUNTIME_VARS, ONLY : RUNLEN
#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif

      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! file name parameters

      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER      JDATE        ! current model date, coded YYYYDDD
      INTEGER      JTIME        ! current model time, coded HHMMSS
      INTEGER      TSTEP        ! output timestep (HHMMSS)

C Local variables:

      CHARACTER( 16 ) :: PNAME = 'WR_CGRID'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER K, MXK, SPC, VAR
      INTEGER ALLOCSTAT

      INTEGER TSTEP_RF, NTHIK_RF, NCOLS_RF, NROWS_RF, GDTYP_RF
      REAL( 8 ) :: P_ALP_RF, P_BET_RF, P_GAM_RF
      REAL( 8 ) :: XCENT_RF, YCENT_RF
      REAL( 8 ) :: XORIG_RF, YORIG_RF
      REAL( 8 ) :: XCELL_RF, YCELL_RF
      INTEGER VGTYP_RF
      REAL VGTOP_RF
      INTEGER, SAVE :: EDATE, ETIME

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL OK

      LOGICAL, EXTERNAL :: FLUSH3

C-----------------------------------------------------------------------

#ifndef mpas
      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

C Try to open existing file for update

         CALL SUBST_BARRIER

         OK = OPEN3( S_CGRID, FSRDWR3, PNAME )
         CALL SUBST_GLOBAL_LOGICAL( OK, 'AND' )
         IF ( .NOT. OK ) THEN

            XMSG = 'Could not open ' // TRIM( S_CGRID )
     &           // ' file for update - try to open new'
            CALL M3MESG( XMSG )

            IF ( IO_PE_INCLUSIVE ) THEN

C Get default file header attibutes from CONC file (assumes file already open)

               IF ( .NOT. DESC3( CTM_CONC_1 ) ) THEN
                  XMSG = 'Could not get '
     &                 // TRIM( CTM_CONC_1 )
     &                 // ' file description'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

C Set tstep negative to create "circular buffer" type file
!              TSTEP3D = -TSTEP

               EDATE = JDATE
               ETIME = JTIME
               CALL NEXTIME( EDATE, ETIME, RUNLEN )   ! end date & time

               SDATE3D = EDATE
               STIME3D = ETIME

C Get CGRID nvars

               NVARS3D = NSPCSD
               NLAYS3D = NLAYS

C Set file header attributes that differ from CONC and open the file

               FDESC3D = ' '
               FDESC3D( 1 ) = 'Computational grid instantaneous concentrations'
               FDESC3D( 2 ) = '- for scenario continuation.'

               WRITE( LOGDEV,* ) ' '
               WRITE( LOGDEV,* ) '       State CGRID File Header Description:'
               DO K = 1, 2
                  WRITE( LOGDEV,* ) '    => ',
     &            TRIM( FDESC3D( K ) )
               END DO

               VAR = 0

               DO SPC = 1, N_GC_SPC
                  VAR = VAR + 1
                  VTYPE3D( VAR ) = M3REAL
                  VNAME3D( VAR ) = GC_SPC( SPC )
                  UNITS3D( VAR ) = 'ppmV'
                  VDESC3D( VAR ) = 'Variable ' // VNAME3D( VAR )
               END DO

C pick up transported RHOJ

               VAR = VAR + 1
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = 'RHOJ'
               UNITS3D( VAR ) = 'm kg m-3'
               VDESC3D( VAR ) = 'Variable ' // VNAME3D( VAR )

               DO SPC = 1, N_AE_SPC
                  VAR = VAR + 1
                  VTYPE3D( VAR ) = M3REAL
                  VNAME3D( VAR ) = AE_SPC( SPC )
                  IF ( VNAME3D( VAR )(1:3) .EQ. 'NUM' ) THEN
                     UNITS3D( VAR ) = 'm-3'
                  ELSE IF ( VNAME3D( VAR )(1:3) .EQ. 'SRF' ) THEN
                     UNITS3D( VAR ) = 'm2 m-3'
                  ELSE
                     UNITS3D( VAR ) = 'ug m-3'
                  END IF
                  VDESC3D( VAR ) = 'Variable ' // VNAME3D( VAR )
               END DO

               DO SPC = 1, N_NR_SPC
                  VAR = VAR + 1
                  VTYPE3D( VAR ) = M3REAL
                  VNAME3D( VAR ) = NR_SPC( SPC )
                  UNITS3D( VAR ) = 'ppmV'
                  VDESC3D( VAR ) = 'Variable ' // VNAME3D( VAR )
               END DO

               DO SPC = 1, N_TR_SPC
                  VAR = VAR + 1
                  VTYPE3D( VAR ) = M3REAL
                  VNAME3D( VAR ) = TR_SPC( SPC )
                  UNITS3D( VAR ) = 'ppmV'
                  VDESC3D( VAR ) = 'Variable ' // VNAME3D( VAR )
               END DO

               WRITE( LOGDEV,* ) ' '
               WRITE( LOGDEV,* ) '       State CGRID File Variable List:'
               DO SPC = 1, VAR
                  WRITE( LOGDEV,'( 5X, "=> VNAME3D(", I3, " ): ", A )' )
     &                   SPC, VNAME3D( SPC )
               END DO

               ! Store MIO Metadata
               NDIMS3D( 1:NVARS3D ) = 4
               L_TSTEP( 1:NVARS3D ) = .True.
               L_LAY  ( 1:NVARS3D ) = .True.
               L_COL  ( 1:NVARS3D ) = .True.
               L_ROW  ( 1:NVARS3D ) = .True.
               L_VEXT ( 1:NVARS3D ) = .False.
           
               CALL LOAD_MIO_FILE ( 'S_CGRID', NLAYS3D, 1, NLAYS3D,
     &              VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &              VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &              L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &              L_VEXT(1:NVARS3D) )

               IF ( .NOT. OPEN3( S_CGRID, FSNEW3, PNAME ) ) THEN
                  XMSG = 'Could not open '
     &                 // TRIM( S_CGRID ) // ' file'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

            END IF   ! IO_PE_INCLUSIVE

         ELSE

C File exists. Check header data with CONC file as reference. Currently only
C proc 0 has CTM_CONC_1 open

            IF ( IO_PE_INCLUSIVE ) THEN

               IF ( .NOT. DESC3( CTM_CONC_1 ) ) THEN
                  XMSG = 'Could not get '
     &                 // TRIM( CTM_CONC_1 )
     &                 // ' file description'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

               TSTEP_RF = TSTEP3D
               NTHIK_RF = NTHIK3D
               NCOLS_RF = NCOLS3D
               NROWS_RF = NROWS3D
               GDTYP_RF = GDTYP3D
               P_ALP_RF = P_ALP3D
               P_BET_RF = P_BET3D
               P_GAM_RF = P_GAM3D
               XCENT_RF = XCENT3D
               YCENT_RF = YCENT3D
               XORIG_RF = XORIG3D
               YORIG_RF = YORIG3D
               XCELL_RF = XCELL3D
               YCELL_RF = YCELL3D
               VGTYP_RF = VGTYP3D
               VGTOP_RF = VGTOP3D

               IF ( .NOT. DESC3( S_CGRID ) ) THEN
                  XMSG = 'Could not get '
     &                 // TRIM( S_CGRID )
     &                 // ' file description'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

               IF ( TSTEP_RF .NE. ABS( TSTEP3D ) .OR.
     &              NTHIK_RF .NE. NTHIK3D .OR.
     &              NCOLS_RF .NE. NCOLS3D .OR.
     &              NROWS_RF .NE. NROWS3D .OR.
     &              GDTYP_RF .NE. GDTYP3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( P_ALP_RF .NE. P_ALP3D .OR.
     &              P_BET_RF .NE. P_BET3D .OR.
     &              P_GAM_RF .NE. P_GAM3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( XCENT_RF .NE. XCENT3D .OR.
     &              YCENT_RF .NE. YCENT3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( XORIG_RF .NE. XORIG3D .OR.
     &              YORIG_RF .NE. YORIG3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( XCELL_RF .NE. XCELL3D .OR.
     &              YCELL_RF .NE. YCELL3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( VGTYP_RF .NE. VGTYP3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( VGTOP_RF .NE. VGTOP3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF

            END IF   ! IO_PE_INCLUSIVE

         END IF   ! .NOT. OPEN S_CGRID

         RETURN

      END IF   ! FIRSTIME

#ifdef parallel_io
      IF ( IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. FLUSH3 ( S_CGRID ) ) THEN
            XMSG = 'Could not sync to disk ' // TRIM( S_CGRID )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF
      CALL SUBST_BARRIER
      IF ( .NOT. IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( S_CGRID, FSREAD3, PNAME ) ) THEN
            XMSG = 'Could not open ' // TRIM( S_CGRID )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF

      IF ( .NOT. WRITE3( S_CGRID, ALLVAR3, JDATE, JTIME, CGRID ) ) THEN
         XMSG = 'Could not write S_CGRID'
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
#else

#ifdef parallel
      IF ( .NOT. PTRWRITE3( S_CGRID, ALLVAR3, JDATE, JTIME, CGRID ) ) THEN
         XMSG = 'Could not write S_CGRID'
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
#else
      IF ( .NOT. WRITE3( S_CGRID, ALLVAR3, JDATE, JTIME, CGRID ) ) THEN
         XMSG = 'Could not write S_CGRID'
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
#endif

#endif

      WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &      'Timestep written to', S_CGRID,
     &      'for date and time', JDATE, JTIME
#endif

      RETURN 
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CMAQ_DRIVER ( MODEL_STDATE, MODEL_STTIME, MODEL_TSTEP,
     $                         MODEL_JDATE, MODEL_JTIME, LAST_STEP,
     $                         COUPLE_TSTEP, NCOLS_IN, NLAYS_IN)

C-----------------------------------------------------------------------
C Function:
C    CMAQ CTM driver
 
C Preconditions:
C    Initialized file CONCFILE for output; completed
C    files HISTORY containing initial conditions, SPCCONST for
C    conversion of concentration field from computational units
C    to output units.
 
C Subroutines and functions called:
C    INITSCEN, ADVSTEP, M3EXIT, WRITE3
C    science processes SCIPROC, PA_OUTPUT
 
C Revision History:
C    prototype 6/92 by CJC for proof-of-concept
C    Revised   2/93 by CJC for initial LCM Prototype Alpha
 
C    31 August, 1995 by M. Talat Odman at NCSC: special version for one 
C    single grid
 
C    16 April 1995 by M. Talat Odman at NCSC: write (or rewrite if restart)
C    initial conditions to the output file

C    Jeff
C    18 June 98 - put load of mechanism common here because of ping/ping_noop,
C    chem/chem_noop options

C    2 October, 1998 by Al Bourgeois at LM: parallel implementation
C    Jeff - Dec 00 - move CGRID_MAP into f90 module, re-order cols/rows in
C    call to PAR_INIT
C    Jeff - Jul 01 - enable integral average conc data
C    Sep 01  J. Young        Dyn Alloc - Use HGRD_DEFN

C    3 Sep 01 David wong
C      -- removed M3IO SHUT3 call which is done in PAR_TERM
C      -- removed SET_CTMFILE call

C   23 Jun 03 J.Young: for layer dependent advection tstep
C   18 Aug 03 J. Pleim - move vdiff before advection
C   07 Dec 04 J.Young: for layer dyn alloc - Use VGRD_DEFN
C   30 May 05 J.Young: mass-conserving advection (yamo)
C   20 Jan 06 J.Young: add circular buffer CGRID state file
C   24 May 06 J.Young: par_init/pio_init col/row order check
C    6 Sep 06 J.Young: one-write cgrid file; SGRID in module
C   27 May 09 J.Young: re-do parallel processing initialization
C   21 Jun 10 J.Young: convert for Namelist redesign
C   20 Jul 10 J.Young: re-do serial processing termination (eliminate par_noop)
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   24 Aug 11 D.Wong: eliminated data and geo orientation in se_init call
C    8 Jan 13 C.Nolte: fixed load AGRID bug if TSTEP(1) .ne. 010000 hhmmss
C   24 Sep 13 D.Wong:  Computed AGRID at the output mark of the model
C                      indicated in TSTEP(1) for twoway model
C   21 Apr 14 D.Wong:  Removed M3EXIT call in SHUT3 block
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C   10 Aug 15 D.Wong:  Replaced MYPE with IO_PE_INCLUSIVE for parallel
C                      I/O implementation
C   10 Dec 15 D.Wong:  Moved the code which determines which processors are involved
C                      in I/O processing in front of routine PIO_RE_INIT and passed
C                      that information into PIO_RE_INIT
C   26 Jan 16 J.Young: Consolidate PIO_INIT, use keywords for optional arguments
C   28 Jan 16 D.Wong:  Add SAVE attribute to TSTEP for the two-way model implementation
C   16 Sep 16 J.Young: update for inline procan (IRR)
C   29 Nov 17 D. Wong: removed all SWAP routines and replaced with SE_COMM
C   29 Oct 18 L.Zhou, S.Napelenok: isam implementation
C   31 Jan 19 D. Wong: adopted the idea to process all twoway related environment
C                      variables in one place
C   01 Feb 19 D. Wong: made this as a subroutine rather than the main program to
C                      accommodate interface with global, regional and offlice mode,
C                      implemented centralized I/O approach, removed all MY_N clauses,
C                      with new re-structure of LUS_DEFN, most of the data declaration 
C                      has been moved to lus_data_module (model_data_module.f) and to
C                      call lus_setup to setup land use information according to land
C                      use scheme
C   02 Aug 19 F. Sidi: Restored serial processing option
C   03 AUG 19 D.Wong:  Modified code to work with two-way model
C   09 Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL
C   21 Nov 19 S.L.Napelenok: Include DDM3D for versions 5.3.1
C-----------------------------------------------------------------------

      USE RXNS_DATA             ! chemical mechanism data
      USE CENTRALIZED_IO_MODULE
      USE ASX_DATA_MOD, Only : MET_DATA, INIT_MET, GET_MET
      USE LSM_MOD
      USE WVEL_DEFN             ! derived vertical velocity component
      USE BUDGET_DEFN
      USE AERO_DATA
      USE SOA_DEFN, ONLY : MAP_OA
      USE ELMO_DATA, ONLY : L_ELMO, ELMO_NSTEP, ELMO_INIT_SHARED
      USE ELMO_PROC, ONLY : ELMO_DRIVER
      USE UTILIO_DEFN
      USE util_Family_module
      USE RUNTIME_VARS
      USE STD_CONC              ! standard CONC
      USE CGRID_SPCS            ! CGRID mechanism species
#ifdef mpas
      USE HGRD_DEFN, ONLY: MYPE
      use coupler_module
      use VGRD_DEFN, ONLY : NLAYS
      use HGRD_DEFN, ONLY : NCOLS, NROWS

      use mydata_module
      use get_env_module
      use lus_defn
      use mio_module
#else
      USE PCGRID_DEFN           ! inherits GRID_CONF
      USE AVG_CONC              ! integral average CONC
      USE PA_DEFN, Only: LIPR, LIRR  ! Process Anaylsis control and data variables
      USE PAGRD_DEFN            ! Process Anaylsis horiz domain specs

      USE BIDI_MOD, Only : INIT_BIDI

#ifdef isam
c     USE SA_LAYERS
      USE SA_DEFN
      USE PISAM_DEFN            ! SA array definition (borrowed )
c     USE PMFRC_DEFN            ! MAPFRAC array definition ( adapted )
#endif

#ifdef sens
      USE DDM3D_DEFN
      USE S_PCGRID_DEFN
#endif

#ifdef parallel
      USE VERTEXT_MODULE
#endif
      USE lus_data_module

#ifdef twoway
      use twoway_data_module
      use sd_time_series_module
#endif

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_INIT_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_INIT_MODULE)
#endif
#endif   ! end mpas

      USE MIO_ASCII
      USE HLCONST_MOD

      IMPLICIT NONE

      INTEGER, INTENT( IN )  :: MODEL_STDATE, MODEL_STTIME, MODEL_TSTEP
      INTEGER, INTENT( OUT ) :: MODEL_JDATE, MODEL_JTIME
      LOGICAL, INTENT( IN )  :: LAST_STEP
      INTEGER, INTENT( IN ), OPTIONAL :: COUPLE_TSTEP
      INTEGER, INTENT( IN ), OPTIONAL :: NCOLS_IN, NLAYS_IN

#ifdef mpas
      real, parameter :: cmin = 1.0E-30

      integer :: ncols_gl
#endif

C Include Files:
      INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

#ifdef parallel
!     INCLUDE SUBST_MPI         ! MPI definitions and parameters
      INCLUDE 'mpif.h'
#endif

C Local variables:

      INTEGER, SAVE :: TSTEP( 3 ) ! time step vector (HHMMSS)
                                  ! TSTEP(1) = local output step
                                  ! TSTEP(2) = sciproc sync. step (chem)
                                  ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                  !            step and wrf/cmaq call frequency

      INTEGER, ALLOCATABLE, SAVE :: ASTEP( : )
      INTEGER, SAVE :: NREPS    ! number of model time steps per output step
      INTEGER          ISTEP    ! current output time step number
      INTEGER          IREP     ! model step number within this output step
      INTEGER, SAVE :: JDATE    ! current model date, coded YYYYDDD
      INTEGER, SAVE :: JTIME    ! current model time, coded HHMMSS
      INTEGER          C, R, L, K, S, V     ! loop induction variables
      INTEGER          ALLOCSTAT
      INTEGER          NFILE, IFILE
      LOGICAL          EXST, OPD
      CHARACTER( 1000 ) :: CFILE
      CHARACTER(   16 ) :: ACT
      REAL( 8 )         :: CPU_TIME_START, CPU_TIME_FINISH
      REAL              :: REAL_TIME


      CHARACTER(  2 ) :: COLROW = 'CR'  ! col/row arg list order
      CHARACTER( 16 ) :: PNAME = 'DRIVER'
      CHARACTER( 96 ) :: XMSG = ' '

      REAL, SAVE, POINTER     :: CGRID( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: AGRID( :,:,:,: )
      REAL    DIVFAC      ! trapezoidal average factor

      LOGICAL, SAVE :: FIRST_RUN = .TRUE.  ! used for twoway model
      LOGICAL, SAVE :: L_INIT    = .TRUE.  ! used for MIO File Input Initialization
      LOGICAL       :: WFLG = .TRUE.       ! turn on write subdmap in pio_init

      INTEGER, SAVE :: myNREPS = 0
      INTEGER       :: STATUS

#ifdef mpas

      integer :: io_mode

      INTEGER      SPC_STRT, SPC_FINI, J
      LOGICAL      LSTAT
      INTEGER      STAT                       ! Status reported by Aerosol Dist Checker

      INTEGER      LMODE    !Identifies the problematic mode from
                                !the BC Check routine
      REAL         AER_PAR( 2, N_MODE,5 )  !Modal parameter after the BC 
                                           !check (N, dg, sg)
                                           !      (N, M2, M3) -
                                           !      Before
                                           !      (N, M2, M3) -
                                           !      After
      REAL,ALLOCATABLE :: AECON( : )

      REAL( 8 ) :: BEGTIME     ! Wall-clock time (sec) at MPI initialization
      LOGICAL       :: L_WRITE_WARNING


#endif

      INTERFACE
         SUBROUTINE INITSCEN ( CGRID, TSTEP )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( OUT )   :: TSTEP( 3 )
         END SUBROUTINE INITSCEN
#ifndef mpas
         SUBROUTINE ADVSTEP ( JDATE, JTIME, TSTEP, ASTEP, NREPS )
            INTEGER, INTENT( IN )    :: JDATE, JTIME
            INTEGER, INTENT( INOUT ) :: TSTEP( 3 )
            INTEGER, INTENT( OUT )   :: ASTEP( : )
            INTEGER, INTENT( OUT )   :: NREPS
         END SUBROUTINE ADVSTEP
         SUBROUTINE CKSUMMER ( PRNAME, CGRID, JDATE, JTIME )
            CHARACTER( * ), INTENT( IN ) :: PRNAME
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME
         END SUBROUTINE CKSUMMER
         SUBROUTINE PA_INIT ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP( 3 )
         END SUBROUTINE PA_INIT
         SUBROUTINE WR_ACONC ( AGRID, JDATE, JTIME, TSTEP )
            REAL,    INTENT( IN )    :: AGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_ACONC
         SUBROUTINE WR_CGRID ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_CGRID
         SUBROUTINE PA_OUTPUT ( CGRID, JDATE, JTIME )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME
         END SUBROUTINE PA_OUTPUT
#ifdef isam
         SUBROUTINE WR_SA ( JDATE, JTIME, TSTEP, NSTEPS )
            IMPLICIT NONE
            INTEGER                  :: JDATE, JTIME, TSTEP( 3 )
            INTEGER                  :: NSTEPS
         END SUBROUTINE WR_SA
         SUBROUTINE WR_AVG_SA ( JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            INTEGER                  :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_AVG_SA
         SUBROUTINE WR_SA_CGRID ( JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            INTEGER                  :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_SA_CGRID
#endif
#ifdef sens
         SUBROUTINE WR_SENGRID ( JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_SENGRID
         SUBROUTINE WR_ASENS ( JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_ASENS
#endif
#endif

         SUBROUTINE SCIPROC ( CGRID, JDATE, JTIME, TSTEP, ASTEP )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( INOUT ) :: JDATE, JTIME
            INTEGER, INTENT( IN )    :: TSTEP( 3 ), ASTEP( : )
         END SUBROUTINE SCIPROC
         SUBROUTINE INIT_CCTM_MODULES ( CGRID, JDATE, JTIME, TSTEP, ASTEP )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( INOUT ) :: JDATE, JTIME
            INTEGER, INTENT( IN )    :: TSTEP( 3 ), ASTEP( : )
         END SUBROUTINE INIT_CCTM_MODULES
#ifdef mpas
         SUBROUTINE UNLOAD_CGRID ( CGRID )
            REAL, INTENT(IN)  :: CGRID( :,:,:,: )
         END SUBROUTINE UNLOAD_CGRID
#endif
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRST_RUN ) THEN

         ! Initialize variables for passing file data to MIO
         CALL INIT_MIO_FILE_DATA()

         TSTEP = 0
#ifdef mpas
         CALL INIT_ENV_VARS( 0, 0 )
#else
         STDATE     = MODEL_STDATE
         STTIME     = MODEL_STTIME
#endif

#ifdef twoway
         TSTEP( 1 ) = LOCAL_TSTEP
         TSTEP( 3 ) = SEC2TIME(MODEL_TSTEP)
#else
         TSTEP( 1 ) = MODEL_TSTEP
#endif

         IF (PRESENT (COUPLE_TSTEP)) THEN
            TSTEP( 3 ) = SEC2TIME( COUPLE_TSTEP )
            MPAS_TSTEP = TSTEP( 3 )
         END IF

         IF (PRESENT(NCOLS_IN)) THEN
            NCOLS = NCOLS_IN
            NROWS = 1
            NLAYS = NLAYS_IN
            TSTEP( 2 ) = SEC2TIME( COUPLE_TSTEP )
         END IF

#ifdef mpas
         CALL MPCOMM_INIT( NPROCS, MYPE, BEGTIME, LMODE )

         IO_PE_INCLUSIVE = .TRUE.

         call mpi_allreduce (ncols, ncols_gl, 1, mpi_int, mpi_sum, mpi_comm_world, status)

         call mio_init (NPROCS, 1, ncols_gl, nrows, logdev=logdev)

C Set CGRID mechanism
         IF ( .NOT. CGRID_SPCS_INIT() ) THEN
            XMSG = 'Error in CGRID_SPCS:CGRID_SPCS_INIT'
            call M3EXIT (PNAME, JDATE, JTIME, XMSG, 1)
         END IF

         CALL GET_ENV ( LAND_SCHEME, 'LAND_SCHEME', 'NLCD40', LOGDEV )

         ALLOCATE (CGRID ( NCOLS,NROWS,NLAYS,NSPCSD ), STAT = ALLOCSTAT)

         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'CGRID memory allocation failed'
            call M3EXIT (PNAME, JDATE, JTIME, XMSG, 1)
         END IF

C Set up horizontal domain, calculate processor-to-subdomain maps
C and define vertical layer structure (in module GRID_CONF)
         IF ( .NOT. GRID_INIT ( NPROCS, MYPE ) ) THEN
            XMSG = '*** Failure defining domain configuration'
            call M3EXIT (PNAME, JDATE, JTIME, XMSG, 1)
         END IF

#else
#ifdef twoway
C Initialize Environment Variables
         JDATE = 0
         JTIME = 0
         CALL INIT_ENV_VARS( JDATE, JTIME )
#endif

C Set up horizontal domain, calculate processor-to-subdomain maps
C and define vertical layer structure (in module GRID_CONF)
         IF ( .NOT. GRID_INIT ( NPROCS, MYPE ) ) THEN
            XMSG = '*** Failure defining domain configuration'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#ifdef verbose_driver
         write( logdev,* ) ' MYPE -> NPROCS:   ', mype, nprocs
         write( logdev,* ) ' MYPE -> NPCOL:    ', mype, npcol
         write( logdev,* ) ' MYPE -> NPROW:    ', mype, nprow
         write( logdev,* ) ' MYPE -> MY_NCOLS: ', mype, ncols
         write( logdev,* ) ' MYPE -> MY_NROWS: ', mype, nrows
         write( logdev,* ) ' MYPE -> GL_NCOLS: ', mype, gl_ncols
         write( logdev,* ) ' MYPE -> GL_NROWS: ', mype, gl_nrows
         write( logdev,* ) ' MYPE -> NLAYS:    ', mype, nlays
         write( logdev,* ) ' MYPE -> NBNDY:    ', mype, nbndy
#endif

C Set CGRID mechanism
         IF ( .NOT. CGRID_SPCS_INIT() ) THEN
            XMSG = 'Error in CGRID_SPCS:CGRID_SPCS_INIT'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, 1 )
         END IF

#ifdef sens
C Initialize ddm3d calculations
         CALL INIT_DDM3D
#endif

        CALL MAP_AERO()
        CALL MAP_OA()


C Initialize Global Arrays for Storing Chemical, Regional, Process,
C and Emission Stream Families
         call read_families

#ifdef verbose_driver
         write( logdev,* ) ' MYPE -> NSPCS:    ', mype, nspcsd
#endif

#ifdef parallel_io
         IF ( MOD( MYPE, NPCOL ) .EQ. 0 ) THEN
#else
         IF ( MYPE .EQ. 0 ) THEN
#endif
            IO_PE_INCLUSIVE = .TRUE.
         ELSE
            IO_PE_INCLUSIVE = .FALSE.
         END IF

#ifdef parallel
C Initialize PARIO
         IF ( .NOT. PIO_INIT( COLROW, GL_NCOLS, GL_NROWS, NLAYS, NTHIK,
     &                        NCOLS, NROWS, NPCOL, NPROW, NPROCS, MYPE,
     &                        wflg = WFLG, io_pe_inclusive = IO_PE_INCLUSIVE ) ) THEN
            XMSG = 'Failed to initialize parallel I/O library.'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#endif
C Initialize stencil exchange
         CALL SUBST_SE_INIT( NPROCS, NPCOL, NPROW, GL_NCOLS, GL_NROWS, NLAYS,
     &                       NSPCSD, MYPE, MNDIS, MEDIS, MSDIS, MWDIS )


#ifdef verbose_driver
         write( logdev,* ) ' MYPE -> MNDIS:    ', mype, mndis
         write( logdev,* ) ' MYPE -> MEDIS:    ', mype, medis
         write( logdev,* ) ' MYPE -> MSDIS:    ', mype, msdis
         write( logdev,* ) ' MYPE -> MWDIS:    ', mype, mwdis
#endif

C Generate the process analysis data: load PA_DEFN module
         CALL PA_DATAGEN( )

C Abort if the number of output variables exceeds the maximum allowed
C by I/O-API
         IF ( NSPCSD .GT. MXVARS3 ) THEN
            WRITE( XMSG,'(5X, A, I5, A)' ) 'The number of variables,', NSPCSD,
     &      ' to be written to the State CGRID File'
            CALL LOG_MESSAGE( LOGDEV, XMSG )
            WRITE( XMSG,'(5X, A, I5)' ) 'exceeds the I/O-API limit:', MXVARS3
            CALL LOG_MESSAGE( LOGDEV, XMSG )
            XMSG = 'Recompile with an I/O-API lib having a larger MXVARS3'
            CALL LOG_MESSAGE( LOGDEV, XMSG )
            CALL M3EXIT( PNAME, JDATE, JTIME, ' ', XSTAT1 )
         END IF

C Initialize PCGRID
         IF ( .NOT. PCGRID_INIT () ) THEN
            XMSG = 'Failure defining horizontal domain'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2  )
         END IF
      
         CGRID => PCGRID( 1:NCOLS,1:NROWS,:,: )   ! required for PinG

C Initalize CONC definitions (in STD_CONC F90 module)
         CALL CONC_DEFN ()

C Get avg CONC definitions, species and layer pointers (in AVG_CONC F90 module)
         CALL A_CONC_DEFN ()

#ifdef isam
c        CALL GET_SA_LAYS ()
         CALL SA_DIM()

C Initialize PISAM
         IF ( .NOT. PISAM_INIT ( NSPC_SA, NTAG_SA ) ) THEN
            XMSG = 'Failure in defining SA horizontal domain'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2  )
         END IF
         ISAM => PISAM( 1:NCOLS,1:NROWS,:,:,: )

#endif

C Initialize optional derived vertical velocity writes to conc file
         IF ( .NOT. WVEL_INIT () ) THEN
            XMSG = 'Failure initializing derived vertical velocity writes'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2  )
         END IF

#ifdef sens
C Initialize ddm3d calculations
         IF ( .NOT. S_PCGRID_IN( NPMAX ) ) THEN
            XMSG = 'Failure defining horizontal sens domain'
            CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT2  )
         END IF

         SENGRID => S_PCGRID(1:NCOLS,1:NROWS,:,:,:)
         SENGRID_TEMP => S_PCGRID_TEMP(1:NCOLS,1:NROWS,:,:)

         ALLOCATE ( SAGRID( NCOLS,NROWS,A_NLYS,NPMAX,N_ASPCS ), STAT = STATUS)
         IF ( STATUS .NE. 0 ) THEN
            XMSG = 'SAGRID memory allocation failed'
            CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF

         SAGRID = 0.0
#endif


#endif  ! end of mpas


C Initiliaze IO Arrays and Open Files
#ifdef mpas
         call centralized_io_init (NCOLS_IN)
#else
         call centralized_io_init
#endif

C Initialize conc field: Copy IC's to CONC file as step 0
C Convention: the input file concentration units are always ppmV.

         CALL INITSCEN ( CGRID, TSTEP )
         JDATE = STDATE; JTIME = STTIME

#ifdef sens
         STARTDATE = STDATE   ! save variable into DDM3D module
#endif

#ifndef mpas
         CALL LOG_HEADING( LOGDEV, "Check Initial Concentrations" )
         CALL CKSUMMER ( 'INITSCEN', CGRID, JDATE, JTIME )

         IF ( LIPR .OR. LIRR ) CALL PA_INIT ( CGRID, JDATE, JTIME, TSTEP )

         ALLOCATE ( AGRID( NCOLS,NROWS,A_NLYS,N_ASPCS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'AGRID memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( ASTEP( NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'ASTEP memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#ifdef isam
         ALLOCATE ( AISAM( NCOLS,NROWS,NLAYS,NSPC_SA,NTAG_SA ),STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'AISAM memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         AISAM = 0.
#endif



#ifdef twoway
         IF ( SD_TIME_SERIES ) THEN
            CALL SD_TIME_SERIES_INIT ( LOGDEV, TSTEP( 3 ) )
            CALL OUTPUT_SD_TIME_SERIES ( CGRID, JDATE, JTIME )
         END IF

         IF ( CMAQ_WRF_FEEDBACK ) THEN
            CALL FEEDBACK_SETUP ( JDATE, JTIME, TSTEP( 3 ) )
         END IF
#endif
#else
!       if (.not. lus_init (mminlu_mpas, lufrac_data(:,:,1)) ) then
!          CALL M3EXIT( 'DRIVER',JDATE,JTIME,'ERROR: Cannot initialize Land Use Category', 2)
!       end if

        if (ncd_64bit_offset) then
            io_mode = ior (nf90_noclobber, nf90_64bit_offset)
         else
            io_mode = nf90_noclobber
         end if

        call mio_setfile ('GR_EMIS_001')

        if (L_ELMO) then
           call mio_fcreate (CTM_ELMO_1, io_mode)
        end if

         call get_env (mpas_diag, 'mpas_diag', .false.)

         if (mpas_diag) then
            call mio_fcreate ('CTM_OUT', io_mode)
         end if


!       call mio_fcreate (CTM_DRY_DEP_1, io_mode)
!       call mio_fcreate (CTM_WET_DEP_1, io_mode)

        if ( depv_diag ) then
            call mio_fcreate (CTM_DEPV_DIAG, io_mode)
        end if

        if ( cld_diag ) then
            call mio_fcreate (CTM_WET_DEP_2, io_mode)
        end if

!       if (photdiag) then
!          call mio_fcreate (CTM_RJ_1, io_mode)
!          call mio_fcreate (CTM_RJ_2, io_mode)
!       end if

#endif

C Initialize Shared Global Output Variables used for 
C ELMO (e.g. AOD, extinction, Kz, etc.)
         CALL ELMO_INIT_SHARED()

C Initialize Meteorology Structures
         CALL INIT_LSM( JDATE, JTIME )
#ifndef mpas
         CALL INIT_BIDI( )
#endif
         CALL INIT_MET( JDATE, JTIME )

         CALL GET_MET ( JDATE, JTIME, 0 )

         IF ( W_VEL ) CALL GET_WVEL( JDATE, JTIME ) ! If the user wants vertical velocity written to file, retrieve it.

         call hlconst_init

         FIRST_RUN = .FALSE.

C Main processing loop:
         IF ( MYPE. EQ. 0 ) CALL LOG_HEADING( OUTDEV, "Time Integration" )

      END IF ! first_run

      MODEL_JDATE = JDATE
      MODEL_JTIME = JTIME

#ifdef mpas

      mpas_cmaq_last_step = LAST_STEP

      v = size(cgrid, 4)

      DO L = 1, NLAYS
         DO C = 1, NCOLS
            CGRID( C,1,L,1:N_GC_SPC ) = cmaq_species( c,1,l,1:N_GC_SPC )
            CGRID( C,1,L,N_GC_SPC+2:v ) = cmaq_species( c,1,l,N_GC_SPC+1:v-1 )
         END DO
      END DO


      ! If this run is not a restart, then check the initial conditions
      ! to make sure they are physically realistic. Check Aerosol Size 
      ! Distributions and Warn the User if They Are Not Robust.
      call get_env (NEW_START, 'NEW_START', .false.)
      IF ( NEW_START ) THEN
         ALLOCATE( AECON( N_AE_SPC ) )
         SPC_STRT = AE_STRT
         SPC_FINI = AE_STRT + N_AE_SPC - 1
         LSTAT    = .FALSE.
         DO L = 1, NLAYS
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  AECON( 1:N_AE_SPC ) = CGRID( C,R,L,SPC_STRT:SPC_FINI )
                  CALL CHECK_AERO_ICBC( AECON, .FALSE., .TRUE., .FALSE., L_WRITE_WARNING, C, R, L)
                  CGRID( C,R,L,SPC_STRT:SPC_FINI ) = AECON( 1:N_AE_SPC )
                  IF ( STAT .GT. 0 ) THEN
                     LSTAT = .TRUE.
                  ENDIF
               END DO
            END DO
         END DO
    
         !Print warning if any aerosol ICs violated the size
         !distribution parameters
         IF ( LSTAT ) THEN
            WRITE( XMSG, '(A,A)' ),
     &         'Applying fix to aerosol Initial Conditions for aerosol',
     &         ' modes.'
            print *, trim(xmsg)
         END IF
      END IF
 
      NREPS = 1
#else
      ! Get synchronization and advection time steps, TSTEP(2), ASTEP(L) and NREPS
      CALL ADVSTEP ( JDATE, JTIME, TSTEP, ASTEP, NREPS )

      ! Initialize arrays for storing output data averaged across the
      ! synchornization time step
      IF ( MOD( TIME2SEC( JTIME ), TIME2SEC( TSTEP( 1 ) ) ) .EQ. 0 ) THEN
         DO V = 1, N_ASPCS
            S = AVG_CONC_MAP( V )
            AGRID( :,:,:,V ) = CGRID( :,:,ACONC_BLEV:ACONC_ELEV,S )
#ifdef sens
            DO NP = 1, NPMAX
               SAGRID( :,:,:,NP,V ) = SENGRID( :,:,ACONC_BLEV:ACONC_ELEV,NP,S )
            END DO
#endif if
         END DO
#ifdef isam
            IF ( AISAM_ELEV .EQ. -1 ) AISAM_ELEV = NLAYS

            DO ITAG = 1, NTAG_SA ! average isam
               DO V = 1, NSPC_SA
                  L = 0
                  DO K = AISAM_BLEV, AISAM_ELEV
                     L = L + 1
                     DO R = 1, NROWS
                        DO C = 1, NCOLS
                           AISAM( C,R,L,V,ITAG ) = ISAM( C,R,K,V,ITAG )
                        END DO
                     END DO
                  END DO
               END DO
            END DO
#endif

         IF ( W_VEL )
     &      AVG_WVEL( :,:,: ) = WVEL( :,:,ACONC_BLEV:ACONC_ELEV )
         IF ( L_ACONC_RH )
     &      AVG_RH( :,:,: ) = MET_DATA%RH( :,:,ACONC_BLEV:ACONC_ELEV)
         IF ( L_ACONC_TA )
     &      AVG_TA( :,:,: ) = MET_DATA%TA( :,:,ACONC_BLEV:ACONC_ELEV)
         IF ( L_ACONC_PRES )
     &      AVG_PRES( :,:,: ) = MET_DATA%PRES( :,:,ACONC_BLEV:ACONC_ELEV )
      END IF
#endif

C Initialize Modules
      IF ( L_INIT ) THEN
          L_INIT = .FALSE.
          call init_cctm_modules( CGRID, JDATE, JTIME, TSTEP, ASTEP )
          if ( MYPE .EQ. 0 .AND. CTM_MIO_FILE ) call write_mio_ascii( 'mio_file_input' )

          CALL LOG_HEADING( LOGDEV, 'Time Integration' )

      ELSE IF ( L_ELMO .AND. ELMO_NSTEP .LT. 1.0 ) THEN
          ! Calculate all ELMO Variables for averaging but do not output them
          CALL ELMO_DRIVER( CGRID, JDATE, JTIME, TSTEP, INIT_TIME_IN=.FALSE. )

      END IF

      ! science process sequence:
         
      myNREPS = myNREPS + NREPS

      DO IREP = 1, NREPS

         ! Execute time-split science processes (e.g. VDIFF, HADV,
         ! CHEM, CLD_PROC, etc.)
         CALL SCIPROC ( CGRID, JDATE, JTIME, TSTEP, ASTEP )

#ifndef mpas
         ! Use trapezoidal rule to time-average data
         DO V = 1, N_ASPCS
            S = AVG_CONC_MAP( V )
            AGRID( :,:,:,V ) = AGRID( :,:,:,V )
     &            + 2.0 * CGRID( :,:,ACONC_BLEV:ACONC_ELEV,S )
#ifdef sens
            DO NP = 1, NPMAX
               SAGRID( :,:,:,NP,V ) = SAGRID( :,:,:,NP,V )
     &            + 2.0 * SENGRID( :,:,ACONC_BLEV:ACONC_ELEV,NP,S )
            END DO
#endif 
         END DO
         IF ( W_VEL )
     &      AVG_WVEL( :,:,: ) = AVG_WVEL + 2.0 * WVEL( :,:,ACONC_BLEV:ACONC_ELEV )
         IF ( L_ACONC_RH )
     &      AVG_RH( :,:,: ) = AVG_RH + 2.0 * MET_DATA%RH( :,:,ACONC_BLEV:ACONC_ELEV )
         IF ( L_ACONC_TA )
     &      AVG_TA( :,:,: ) = AVG_TA + 2.0 * MET_DATA%TA( :,:,ACONC_BLEV:ACONC_ELEV )
         IF ( L_ACONC_PRES )
     &      AVG_PRES( :,:,: ) = AVG_PRES + 2.0 * MET_DATA%PRES( :,:,ACONC_BLEV:ACONC_ELEV )

#ifdef isam
         ! average isam
         DO ITAG = 1, NTAG_SA
            DO V = 1, NSPC_SA
               L = 0
               DO K = AISAM_BLEV, AISAM_ELEV
                  L = L + 1
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        AISAM( C,R,L,V,ITAG ) = AISAM( C,R,L,V,ITAG )
     &                                        + 2.0 * ISAM( C,R,K,V,ITAG )
                     END DO
                  END DO
               END DO
            END DO
         END DO
#endif

#endif
         ! Output ELMO Diagnostic Information
         IF ( L_ELMO ) CALL ELMO_DRIVER( CGRID, JDATE, JTIME, TSTEP, INIT_TIME_IN=.FALSE. )

      END DO

#ifndef mpas 
      ! Store CGRID data in SGRID array for desired output species and
      ! model layers to be written to the CONC output file
      DO V = 1, N_CSPCS
         S = CONC_MAP( V )
         SGRID( :,:,:,V ) = CGRID( :,:,CONC_BLEV:CONC_ELEV,S )
      END DO

      ! Finalize calculation of output data accumulated across the
      ! synchronization time step
      IF ( MOD( TIME2SEC( JTIME ), TIME2SEC( TSTEP( 1 ) ) ) .EQ. 0 ) THEN
         DIVFAC = 0.5 / FLOAT( myNREPS )
         myNREPS = 0

         DO V = 1, N_ASPCS
            S = AVG_CONC_MAP( V )
            AGRID( :,:,:,V ) = DIVFAC * ( AGRID( :,:,:,V )
     &           - CGRID( :,:,ACONC_BLEV:ACONC_ELEV,S ) )
#ifdef sens
            DO NP = 1, NPMAX
               SAGRID( :,:,:,NP,V ) = DIVFAC * ( SAGRID( :,:,:,NP,V )
     &           - SENGRID( :,:,ACONC_BLEV:ACONC_ELEV,NP,S ) )
            END DO
#endif
         END DO
         IF ( W_VEL )
     &         AVG_WVEL( :,:,: ) = DIVFAC * ( AVG_WVEL( :,:,: ) - WVEL( :,:,ACONC_BLEV:ACONC_ELEV ) )
         IF ( L_ACONC_RH )
     &         AVG_RH( :,:,: ) = DIVFAC * ( AVG_RH( :,:,: ) - MET_DATA%RH( :,:,ACONC_BLEV:ACONC_ELEV ) )
         IF ( L_ACONC_TA )
     &         AVG_TA( :,:,: ) = DIVFAC * ( AVG_TA - MET_DATA%TA( :,:,ACONC_BLEV:ACONC_ELEV ) )
         IF ( L_ACONC_PRES )
     &         AVG_PRES( :,:,: ) = DIVFAC * ( AVG_PRES - MET_DATA%PRES( :,:,ACONC_BLEV:ACONC_ELEV ) )

#ifdef isam
         DO ITAG = 1, NTAG_SA ! average isam
            DO V = 1, NSPC_SA
               L = 0
               DO K = AISAM_BLEV, AISAM_ELEV
                  L = L + 1
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        AISAM( C,R,L,V,ITAG ) = DIVFAC * ( AISAM(C,R,L,V,ITAG )
     &                                        -            ISAM( C,R,K,V,ITAG ) )
                     END DO
                  END DO
               END DO
            END DO
         END DO
#endif

      END IF

C Write Data to Output Files

      IF ( MOD( TIME2SEC( JTIME ), TIME2SEC( TSTEP( 1 ) ) ) .EQ. 0 ) THEN
#ifdef parallel
         CPU_TIME_START =  MPI_WTIME()
         IF ( LVEXT ) CALL WR_VEXT ( CGRID, JDATE, JTIME, TSTEP( 1 ) )
#else
         CALL CPU_TIME( REAL_TIME )
         CPU_TIME_START = REAL( REAL_TIME,8 )
#endif
         ! Write CONC and ACONC output data
         CALL WR_CONC ( JDATE, JTIME, TSTEP( 1 ) )
         CALL WR_ACONC ( AGRID, JDATE, JTIME, TSTEP( 1 ) )

#ifdef isam
         ! Write out ISAM source-resolved concentrations
         CALL WR_SA     ( JDATE, JTIME, TSTEP, 1 )
         CALL WR_AVG_SA ( JDATE, JTIME, TSTEP( 1 ) )
#endif

#ifdef sens
         ! Write out DDM3D sensitivities
         CALL WR_ASENS ( JDATE, JTIME, TSTEP( 1 ) )
#endif
         ! Write output generated from ELMO module
         IF ( L_ELMO ) CALL WRITE_ELMO( JDATE, JTIME, TSTEP, .FALSE. )

         ! Write out process analysis and budget diagnostics
         IF ( LIPR .OR. LIRR ) CALL PA_OUTPUT ( CGRID, JDATE, JTIME )
         IF ( BUDGET_DIAG ) CALL WRITE_BUDGET ( CGRID, JDATE, JTIME, TSTEP )

         ! Print wall-clock time to write output
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 3 )
         
      END IF

#ifdef twoway
      IF ( SD_TIME_SERIES ) THEN
         CALL OUTPUT_SD_TIME_SERIES ( CGRID, JDATE, JTIME )
      END IF
#endif

#else
      CALL UNLOAD_CGRID (CGRID)
#endif

      IF ( LAST_STEP ) THEN
#ifdef mpas
         call mio_shutdown()
#else
C write CGRID state file for subsequent runs
         CALL WR_CGRID ( CGRID, JDATE, JTIME, TSTEP( 1 ) )
#ifdef isam
         CALL WR_SA_CGRID ( JDATE, JTIME, TSTEP( 1 ) )
#endif
#ifdef sens
         CALL WR_SENGRID ( JDATE, JTIME, TSTEP( 1 )  )
#endif

C Shut down IOAPI
         IF ( SHUT3() ) THEN
            WRITE( LOGDEV, * )
            CALL LOG_HEADING( LOGDEV, 'Program Completed Successfully' )
            WRITE( XMSG, '(A,A,A,I7,A,I6.6,A)' ) 'Date and time ',
     &             DT2STR( JDATE, JTIME ), ' (',JDATE,':',JTIME,')' 
            CALL LOG_MESSAGE( LOGDEV, XMSG ) 

            IF ( MYPE .EQ. 0 ) WRITE( OUTDEV, * )
            IF ( MYPE .EQ. 0 ) CALL LOG_HEADING( OUTDEV, 'Program Completed Successfully' )
            IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
         ELSE
            CALL LOG_MESSAGE( LOGDEV, ' *** FATAL ERROR shutting down Models-3 I/O *** ' )
         END IF
#endif
      END IF

      ! Output Verification of MIO Input File
      IF ( MYPE .EQ. 0 .AND. CTM_MIO_FILE ) call write_mio_ascii( 'mio_file_input_check' )

      END SUBROUTINE CMAQ_DRIVER        

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/vdiff/acm2/tri.F,v 1.4 2011/10/21 16:11:46 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE TRI ( L, D, U, B, X )

C-----------------------------------------------------------------------
C Function:
C    Solves tridiagonal system by Thomas algorithm.  Algorithm fails
C    ( M3ERR ) if first pivot is zero.  In that case, rewrite the
C    equation as a set of order KMAX-1, with X(2) trivially eliminated.
C The associated tri-diagonal system is stored in 3 arrays
C   D : diagonal
C   L : sub-diagonal
C   U : super-diagonal
C   B : right hand side function
C   X : return solution from tridiagonal solver

C   [ D(1) U(1) 0    0    0 ...       0     ]
C   [ L(2) D(2) U(2) 0    0 ...       .     ]
C   [ 0    L(3) D(3) U(3) 0 ...       .     ]
C   [ .       .     .     .           .     ] X(i) = B(i)
C   [ .             .     .     .     0     ]
C   [ .                   .     .     .     ]
C   [ 0                           L(n) D(n) ]

C   where n = NLAYS

C Preconditions:

C Subroutines and Functions Called:

C Revision History:
C    No.   Date      Who     What
C    __    ____      ___     ____
C    6     Jun 10    yoj  convert for Namelist redesign
C    5     Apr 06    JEP  adapted tridiag for use with ACM2
C    4     Aug 96    yoj  cleaner
C    3     8/16/94   XKX  configuration management include statements
C    2     3/15/92   CJC  For use in Models-3 LCM.
C    1     10/19/89  JKV  converted for use on IBM
C    0      3/89     BDX  Initial version
C-----------------------------------------------------------------------

      USE VGRD_DEFN           ! vertical layer specifications
      USE CGRID_SPCS          ! CGRID mechanism species

      IMPLICIT NONE

C Includes: None

C Arguments:

      REAL, INTENT( IN )  :: L( : )        ! subdiagonal
      REAL, INTENT( IN )  :: D( : )        ! diagonal
      REAL, INTENT( IN )  :: U( : )        ! superdiagonal
      REAL, INTENT( IN )  :: B( :,: )      ! R.H. side
      REAL, INTENT( OUT ) :: X( :,: )      ! solution

C Local Variables:

      INTEGER, SAVE :: N_SPC_DIFF          ! global diffusion species
      REAL        GAM( NLAYS )
      REAL        BET
      INTEGER     V, K
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         N_SPC_DIFF = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_DIFF
      END IF   ! FIRSTIME

C Decomposition and forward substitution:
      BET = 1.0 / D( 1 )
      DO V = 1, N_SPC_DIFF
         X( V,1 ) = BET * B( V,1 )
      END DO

      DO K = 2, NLAYS
         GAM( K ) = BET * U( K-1 )
         BET = 1.0 / ( D( K ) - L( K ) * GAM( K ) )
         DO V = 1, N_SPC_DIFF
            X( V,K ) = BET * ( B( V,K ) - L( K ) * X( V,K-1 ) )
         END DO
      END DO

C Back-substitution:

      DO K = NLAYS - 1, 1, -1
         DO V = 1, N_SPC_DIFF
            X( V,K ) = X( V,K ) - GAM( K+1 ) * X( V,K+1 )
         END DO
      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SETUP_LOGDEV () 

C Purpose
C   Establish ancillary run time log files for each parallel processor
C   Effectively no operation, if serial

C Revision History:
C   ???      J.Young - initial
C   26 Dec, 01 David Wong
C      -- removed MPI_INIT call since the same function has been called in
C         subroutine PAR_INIT
C   11 Jun 02 J.Young - minor mods
C   23 Feb 11 J.Young - SETENVVAR is a function, not a subroutine
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   12 Aug 15 D.Wong:   Replaced SUBST_MPI with mpif.h

      USE RUNTIME_VARS
      USE UTILIO_DEFN

      IMPLICIT NONE

#ifdef parallel      
      include 'mpif.h'
#endif
      INTEGER, PARAMETER :: MAXLEN_CTM_LOG   = MAXLEN_CCTM_APPL + 11

      CHARACTER(  8 ) :: PRESTR  = 'CTM_LOG_'
      CHARACTER( MAXLEN_CTM_LOG ) :: IOLOGEQ

      INTEGER :: IOST, IHEAD, ITOC
      INTEGER :: NIOAPI_HEAD, NCMAQ_HEAD, NCMAQ_TOC
      INTEGER, PARAMETER :: NTXT = 200
      CHARACTER( 90 ) :: CMAQ_HEADER( NTXT ), CMAQ_TOC( NTXT )
      CHARACTER( 90 ) :: IOAPI_HEADER( NTXT )

      integer :: i
      logical :: found, opened

      ! Fetch CMAQ Header
      CALL LOAD_HEADER( CMAQ_HEADER, NCMAQ_HEAD, CMAQ_TOC, NCMAQ_TOC )

#ifdef mpas
      write ( cmype, '(I3.3)' ) mype
      iologeq = 'CTM_LOG_' // cmype

      i = 99
      found = .false.
      do while ((.not. found) .and. (i .le. 150))
         inquire (unit=i, opened=opened)
         if (.not. opened) then
            found = .true.
         else
            i = i + 1
         end if
      end do

      logdev = i

      open ( unit    =  logdev,
     &       iostat  =  iost,
     &       file    =  iologeq,
     &       status  =  'new',
     &       access  =  'sequential')

#else

      ! Create Log Filename using the processor rank and initialize
      ! I/O-API and Logs
      WRITE ( CMYPE, '(I3.3)' ) MYPE
      IOLOGEQ = PRESTR // CMYPE // '.' // TRIM( APPL_NAME )
      IF ( .NOT. SETENVVAR ( 'LOGFILE', IOLOGEQ ) ) THEN
         WRITE( *,* ) '*** Could not set environment variable for ' // IOLOGEQ
         CALL M3EXIT( 'SETUP_LOGDEV', 0, 0, '', 2 )
      END IF

#ifndef twoway
      ! Write CMAQ Header to Screen
      IF ( MYPE .EQ. 0 ) THEN
         DO IHEAD = 1,NCMAQ_HEAD
            WRITE( OUTDEV, '(A)' ) CMAQ_HEADER( IHEAD )
         END DO
      END IF
#endif

      ! Redirect Standard Output
      IF ( MYPE .NE. 0 ) OPEN( UNIT = 6, FILE = "/dev/null", STATUS = "OLD" )
               
      IF ( MYPE .EQ. 0 ) CALL LOG_HEADING( OUTDEV, 'Initialize I/O-API' )
      LOGDEV = INIT3() 

      ! Put Standard Output Back to File Unit 6 By Closing File Unit 6
      IF ( MYPE .NE. 0 ) CLOSE( 6 ) 

      ! Fetch I/O-API Header
#ifndef twoway
      NIOAPI_HEAD = 200
      REWIND( LOGDEV )
      DO IHEAD = 1,200
          READ( LOGDEV, '(A)', IOSTAT=IOST ), IOAPI_HEADER( IHEAD )
          ! Check for End of File
          IF ( IOST .LT. 0 ) THEN
             NIOAPI_HEAD = IHEAD - 1
             EXIT
          END IF
      END DO
      REWIND( LOGDEV )
#endif
#endif

      ! Write CMAQ Header and then I/O-API Header
      DO IHEAD = 1,NCMAQ_HEAD
          WRITE( LOGDEV, '(A)' ) CMAQ_HEADER( IHEAD )
      END DO
      DO ITOC = 1,NCMAQ_TOC
          WRITE( LOGDEV, '(A)' ) CMAQ_TOC( ITOC )
      END DO
#ifndef mpas
#ifndef twoway
      CALL LOG_HEADING( LOGDEV, 'Initialize I/O-API' )
      DO IHEAD = 1,NIOAPI_HEAD
          WRITE( LOGDEV, '(A)' ) IOAPI_HEADER( IHEAD )
      END DO
#endif
#endif

      END SUBROUTINE SETUP_LOGDEV 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!-----------------------------------------------------------------------
      Module AERO_BUDGET

!  Collects Aerosol Microphysical Process Rates
!
!-----------------------------------------------------------------------

      Implicit None

      SAVE

      ! These Arrays are sorted in the same manner as CGRID so they may
      ! be directly applied in modules like Process Analysis and ISAM
      REAL, ALLOCATABLE :: AERO_COAG  ( :,:,:,: )   ! Change in Species due to Coagulation
      REAL, ALLOCATABLE :: AERO_COND  ( :,:,:,: )   ! Change in Species due to Condensation
      REAL, ALLOCATABLE :: AERO_NPF   ( :,:,:,: )   ! Change in Species due to NPF
      REAL, ALLOCATABLE :: AERO_GROWTH( :,:,:,: )   ! Change in species due to aerosol 
                                                    !   renaming (mode merging)

!      Contains

C-----------------------------------------------------------------------

      End Module AERO_BUDGET

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE VGRD_DEFN

C Define the vertical layer structure (replaces COORD.EXT and VGRD.EXT)
C Revision History: Jeff Young: 6 Dec 04: created
C                              26 Jul 06: comments in line with PARMS3.EXT
C                   S. Roselle 29 Mar 11: Replaced I/O API include files
C                                         with UTILIO_DEFN
C                   D. Wong    11 May 11: incorporated twoway model implementation
C.......................................................................

      USE RUNTIME_VARS

      IMPLICIT NONE

      INTEGER, SAVE :: NLAYS = 0

      REAL, ALLOCATABLE, SAVE :: VGLVS_GD( : )  ! vert layer surface values
      REAL, ALLOCATABLE, SAVE :: X3FACE_GD( : ) ! mono. incr. vert coord values
                                                ! = 1 - VGLVS_GD
      CHARACTER( 16 ), SAVE :: GDNAME_GD

C The definitions and declarations in this F90 Module follow those
C given in the I/O-API include file FDESC3C.EXT and replace similar
C definitions. This F90 Module is compatible with FDESC3C.EXT.

C VGTYP_GD:
C The vertical grid type:
C  1: VGSGPH3 : hydrostatic sigma-P
C  2: VGSGPN3 : non-h sigma-P
C  3: VGSIGZ3 : sigma-Z
C  4: VGPRES3 : pressure (mb)
C  5: VGZVAL3 : Z (m) (above sea lvl)
C  6: VGHVAL3 : H (m) (above ground)
C  7: VGWRFEM : WRF mass-core sigma
C  8: VGWRFNM : WRF NMM
C  9: IMISS3 for vertical coordinates not stored in VGLVSD
C            (e.g., temporally or spatially changing vertical coordinates)

      INTEGER, SAVE :: VGTYP_GD

C VGTPUN_GD:
C The units of the vertical coordinate top.

      CHARACTER( 16 ), SAVE :: VGTPUN_GD

C VGTOP_GD:
C The value for the model top used in the definition of the sigma coordinate
C systems in the VGTPUN_GD units.

      REAL, SAVE :: VGTOP_GD

C For sigma-P, the relationship between pressure levels P and sigma-P is
C given by:
C    sigma-P = ( P - VGTOP_GD ) / (P_srf - VGTOP_GD ),
C    where P_srf is the surface pressure.

C VGLVUN_GD:
C The units of the vertical coordinate surface values,

      CHARACTER( 16 ) :: VGLVUN_GD

C-----------------------------------------------------------------------

      CONTAINS

         FUNCTION VGRD_INIT ( ) RESULT ( SUCCESS )

            USE UTILIO_DEFN

            IMPLICIT NONE

            LOGICAL :: SUCCESS

            LOGICAL, SAVE :: FIRSTIME = .TRUE.
            CHARACTER( 96 ) :: XMSG = ' '
!           CHARACTER( 16 ) :: LAYER_FILE = 'LAYER_FILE'
            CHARACTER( 16 ) :: LAYER_FILE = 'MET_CRO_3D'

            INTEGER L, ALLOCSTAT

C This function is expected to be called only once - at startup

            IF ( FIRSTIME ) THEN
               FIRSTIME = .FALSE.
               SUCCESS = .TRUE.

#ifndef mpas

C get vert layer definition from LAYER_FILE
               IF ( .NOT. OPEN3( LAYER_FILE, FSREAD3, 'VGRD_INIT' ) ) THEN
                  XMSG = 'Could not open '// LAYER_FILE
                  CALL M3WARN ( 'VGRD_INIT', 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
                  END IF

               IF ( .NOT. DESC3( LAYER_FILE ) ) THEN
                  XMSG = 'Could not get ' // LAYER_FILE // ' file description'
                  CALL M3WARN ( 'VGRD_INIT', 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
                  END IF

               GDNAME_GD = GDNAM3D

               NLAYS = NLAYS3D

               VGTYP_GD  = VGTYP3D
               VGTOP_GD  = VGTOP3D
               VGTPUN_GD = 'Pa'
               VGLVUN_GD = 'none'

               ALLOCATE ( VGLVS_GD( NLAYS + 1 ), STAT = ALLOCSTAT )
               ALLOCATE ( X3FACE_GD( 0:NLAYS ), STAT = ALLOCSTAT )
               IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating VGLVS_GD, X3FACE_GD'
                  CALL M3WARN ( 'VGRD_INIT', 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
                  END IF

               DO L = 1, NLAYS + 1
                  VGLVS_GD( L ) = VGLVS3D( L )
                  END DO

C set layer layer thickenesses

               DO L = 0, NLAYS
                  X3FACE_GD( L ) = 1.0 - VGLVS_GD( L + 1 )
                  END DO

            ELSE
            XMSG = 'Vertical layer structure already defined'
            CALL M3WARN ( 'VGRD_INIT', 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN

#endif

            END IF   ! FIRSTIME

         RETURN
         END FUNCTION VGRD_INIT

      END MODULE VGRD_DEFN

C  21   VGLVS_GD   X3FACE_GD
C  
C   1     1.0       0.0
C   2     0.995     0.005
C   3     0.99      0.01
C   4     0.985     0.015
C   5     0.98      0.02
C   6     0.97      0.03
C   7     0.96      0.04
C   8     0.945     0.055
C   9     0.93      0.07
C  10     0.91      0.09
C  11     0.89      0.11
C  12     0.865     0.135
C  13     0.84      0.16
C  14     0.78      0.22
C  15     0.7       0.3
C  16     0.6       0.4
C  17     0.5       0.5
C  18     0.4       0.6
C  19     0.3       0.7
C  20     0.2       0.8
C  21     0.1       0.9
C  22     0.0       1.0

      subroutine LOAD_HEADER( HEADER_TXT, N_HEADER_TXT, TOC_TXT, N_TOC_TXT )

      IMPLICIT NONE

      CHARACTER( 90 ) :: HEADER_TXT( 200 ), TOC_TXT( 200 )
      INTEGER         :: N_HEADER_TXT, N_TOC_TXT

      N_HEADER_TXT = 21
      HEADER_TXT( : ) = ''
      N_TOC_TXT = 19
      TOC_TXT( : ) = ''

      HEADER_TXT( 1:N_HEADER_TXT ) = (/   
     &   '#================================================================================#', 
     &   '#|                                                                              |#', 
     &   '#|               The Community Multiscale Air Quality (CMAQ) Model              |#', 
     &   '#|                                   Version 5.5                                |#', 
     &   '#|                                                                              |#', 
     &   '#|                          Built and Maintained by the                         |#', 
     &   '#|                        Office of Research and Development                    |#', 
     &   '#|                   United States Environmental Protection Agency              |#', 
     &   '#|                                                                              |#', 
     &   '#|                            https://www.epa.gov/cmaq                          |#', 
     &   '#|                                                                              |#', 
     &   '#|       Source Code:   https://www.github.com/USEPA/cmaq/tree/master           |#', 
     &   '#|       Documentation: https://www.github.com/USEPA/cmaq/tree/master/DOCS      |#', 
     &   '#|                                                                              |#', 
     &   '#|         The CMAQ Model is tested and released with cooperation from          |#', 
     &   '#|         the Community Modeling and Analysis System (CMAS) Center via         |#', 
     &   '#|         contract support. CMAS is managed by the Institute for the           |#', 
     &   '#|         Environment, University of North Carolina at Chapel Hill.            |#', 
     &   '#|         CMAS URL: (https://www.cmascenter.org)                               |#', 
     &   '#|                                                                              |#', 
     &   '#================================================================================#'  
     &      /)


      TOC_TXT( 1:N_TOC_TXT ) = (/   
     &   '                                                                                  ',
     &   '     -----------------------                                                      ',
     &   '     |>>   Please Note   <<|                                                      ',
     &   '     -----------------------                                                      ',
     &   '                                                                                  ',
     &   '     Search for the headings below to jump to error checks, reports, and          ', 
     &   '     diagnostic tables documenting emission input, prediction output, etc.        ',
     &   '                                                                                  ',
     &   '     ** It is CRITICALLY IMPORTANT that users check these sections when           ', 
     &   '        configuring a new scenario or beginning production-level simulations. **  ',
     &   '                                                                                  ',
     &   '     -> INITIALIZE DESID EMISSION MODULE                                          ',
     &   '         - Error Check Emission Mapping Configuration                             ',
     &   '         - DESID Emission Scaling Report                                          ',
     &   '         - DESID Emission Diagnostic Report                                       ',
     &   '     -> INITIALIZE ELMO MODULE                                                    ',
     &   '         - Reading ELMO Composites from Mechanism-Specific Namelist               ',
     &   '         - ELMO Output Variable Report                                            ',
     &   '    ------------------------------------------------------------------------------'
     &      /)

       end subroutine LOAD_HEADER 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module precursor_data

C  Defines gas phase aerosol precursor data.

C  Contains:
C     Subroutine extract_precursor
C     Subroutine map_precursor
C     Subroutine update_precursor
C     Function findPrecursor

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C HS  03/10/11 Made OH a required species
C    -added OH to "precursor" array (set rxncounter to .FALSE.);
C    -added "update" column to precursor array to note which species
C     concentrations will be affected by aerosol routines
C    -added req_OH and OH_idx variables
C    -changed precursor_conc to Real(8)

C H.Pye 05/22/11: added ALK5RXN to precursor list for SAPRC mechanisms
 
C JY  06/08/12 remove full character blank padding put in for GNU Fortran (GCC) 4.1.2
C H. Pye 09/2014: added alkane and PAH SOA precursor

C D.Wong  02/01/19 added one more variable in the USE clause
C-----------------------------------------------------------------------

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX
      Use aero_ddm3d, ONLY : init_aero_ddm3d, s_precursor_conc, ae_ddm3d_ready
#endif 

      Implicit None

      Integer, Parameter :: n_precursor = 24   ! # of precursors

      Type precursor_type
         Character( 16 ) :: name               ! species name
         Logical         :: rxncounter         ! flag to reset counter species
         Logical         :: update             ! update precursor concentration
                                               ! in cgrid after aeroproc
         Logical         :: required           ! required for model run
      End Type precursor_type

      Type ( precursor_type ) :: precursor( n_precursor ) = (/
C                       Name    RxnCounter  Update  Required
C                    ---------   ---------- ------  ------
     & precursor_type( 'NO2    ', .False. , .True., .True.  ),
     & precursor_type( 'N2O5   ', .False. , .True., .True.  ),
     & precursor_type( 'HNO3   ', .False. , .True., .True.  ),
     & precursor_type( 'HONO   ', .False. , .True., .True.  ),
     & precursor_type( 'ISOPRXN', .True.  , .True., .False. ),
     & precursor_type( 'TRPRXN ', .True.  , .True., .False. ),
     & precursor_type( 'SULF   ', .False. , .True., .True.  ),
     & precursor_type( 'SULPRD ', .True.  , .True., .True.  ),
     & precursor_type( 'HCL    ', .False. , .True., .True.  ),
     & precursor_type( 'ALK5RXN', .True.  , .True., .False. ),
     & precursor_type( 'ALKRXN ', .True.  , .True., .False. ),
     & precursor_type( 'TOLNRXN', .True.  , .True., .False. ),
     & precursor_type( 'TOLHRXN', .True.  , .True., .False. ),
     & precursor_type( 'XYLNRXN', .True.  , .True., .False. ),
     & precursor_type( 'XYLHRXN', .True.  , .True., .False. ),
     & precursor_type( 'BNZNRXN', .True.  , .True., .False. ),
     & precursor_type( 'BNZHRXN', .True.  , .True., .False. ),
     & precursor_type( 'SESQRXN', .True.  , .True., .False. ),
     & precursor_type( 'NH3    ', .False. , .True.,  .True. ),
     & precursor_type( 'OH     ', .False. , .False., .True. ),
     & precursor_type( 'PAHNRXN', .True.  , .True., .False. ),
     & precursor_type( 'PAHHRXN', .True.  , .True., .False. ),
     & precursor_type( 'PCSOARXN',.True.  , .True., .False. ),
     & precursor_type( 'PHGRXN ', .True.  , .True., .False. )/)

C Required species
      Character( 16 ), Private, Parameter :: req_NO2    = 'NO2'
      Character( 16 ), Private, Parameter :: req_N2O5   = 'N2O5'
      Character( 16 ), Private, Parameter :: req_HNO3   = 'HNO3'
      Character( 16 ), Private, Parameter :: req_HONO   = 'HONO'
      Character( 16 ), Private, Parameter :: req_SULF   = 'SULF'
      Character( 16 ), Private, Parameter :: req_SULPRD = 'SULPRD'
      Character( 16 ), Private, Parameter :: req_HCL    = 'HCL'
      Character( 16 ), Private, Parameter :: req_NH3    = 'NH3'
      Character( 16 ), Private, Parameter :: req_OH     = 'OH'
      Character( 16 ), Private, Parameter :: req_PHGRXN = 'PHGRXN'

C Indices of required species
      Integer :: NO2_idx
      Integer :: N2O5_idx
      Integer :: HNO3_idx
      Integer :: HONO_idx
      Integer :: SULF_idx
      Integer :: SULPRD_idx
      Integer :: HCL_idx
      Integer :: NH3_idx
      Integer :: OH_idx
      Integer :: PHGRXN_idx

      Real( 8 ) :: precursor_mw( n_precursor )   ! mol wt from cgrid_spcs [g/mol]

      Real( 8 ) :: precursor_conc( n_precursor ) ! precursor concentration [ug/m^3]

      Real    :: so4rate                       ! sulfate gas-phase production rate [ug/m^3*s]
      Real    :: phg_rate                      ! particulate mercury gas-phase production rate [ug/m^3*s]

C Private variables for loading and unloading to CGRID array
      Integer          :: precursor_map( n_precursor )  ! pointers to CGRID
      Logical, Private, Save :: mapped          = .False.
      Logical, Private, Save :: Precursor_eflag = .False.

      Character( 16 ), Private, Save :: pname = 'precursor_data'

      Contains

C-----------------------------------------------------------------------
      Subroutine map_precursor()

C  Defines mapping from CGRID for species concentration and moments.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C HS  03/10/11 Changed vtmp to real(8)
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C----------------------------------------------------------------------

      Use rxns_data, only:  mechname
      Use aero_data, only: ae6hg, aphgj_idx
      Use cgrid_spcs, only: n_gc_g2ae, gc_g2ae, gc_g2ae_map, gc_molwt, gc_strt,
     &                      n_nr_n2ae, nr_n2ae, nr_n2ae_map, nr_molwt, nr_strt
      Use utilio_defn, only: index1, xstat3, m3warn, m3exit
      Use runtime_vars, only: logdev, log_subheading

      Implicit None

C Local Variables:
      Character( 180 ) :: xmsg
      Integer          :: n
      Integer          :: spc

C If the species are mapped already, skip the mapping algorithm
      If ( mapped ) Return
      CALL LOG_SUBHEADING( LOGDEV, 'Map Inorganic and Organic Particle Precursors' )

C Initialize Precursor Map Variables
      precursor_mw = 0.0d0
      precursor_map = 0

C Build mapping to CGRID for each precursor species
      Do spc = 1, n_precursor
         n = index1( precursor( spc )%name, n_gc_g2ae, gc_g2ae )
         If ( n .Ne. 0 ) Then
            precursor_mw( spc ) = real( gc_molwt( gc_g2ae_map( n ) ), 8 )
            precursor_map( spc ) = gc_strt - 1 + gc_g2ae_map( n )
            write(logdev,99902) Trim( precursor( spc )%name )
         Else
            n = index1( precursor( spc )%name, n_nr_n2ae, nr_n2ae )
            If ( n .Ne. 0 ) Then
               precursor_mw( spc ) = real( nr_molwt( nr_n2ae_map( n ) ), 8 )
               precursor_map( spc ) = nr_strt - 1 + nr_n2ae_map( n )
               write(logdev,99902) Trim( precursor( spc )%name )
            Else
                If ( precursor( spc )%required ) Then
                  Precursor_eflag = .True.
                  xmsg = 'FATAL: Simulation requires a species in GC or NR namelist ' //
     &                   'to have its G2AE or N2AE value set to ' // Trim( precursor( spc )%name )
                  Call m3warn( 'map_precursor', 0, 0, xmsg )
                End If 
            End If
         End If
      End Do

C Find indices of required species
      NO2_idx    = findPrecursor( req_NO2,    .true.)
      N2O5_idx   = findPrecursor( req_N2O5,   .true.)
      HNO3_idx   = findPrecursor( req_HNO3,   .true.)
      HONO_idx   = findPrecursor( req_HONO,   .true.)
      SULF_idx   = findPrecursor( req_SULF,   .true.)
      SULPRD_idx = findPrecursor( req_SULPRD, .true.)
      HCL_idx    = findPrecursor( req_HCL,    .true.)
      NH3_idx    = findPrecursor( req_NH3,    .true.)
      OH_idx     = findPrecursor( req_OH,     .true.)
      If( ae6hg )then
         PHGRXN_idx = findPrecursor( req_phgrxn,  .false.)
         If(   precursor_map( PHGRXN_idx ) .Lt. 1  )Then
           xmsg = ' Gas Phase Precursor ' // Trim( req_PHGRXN )
     &         // ' not found -> NO gas production of APHG species'
           Call m3warn( 'map_precursor', 0, 0, xmsg )
         End If 
#ifdef verbose_aero
      Else 
         xmsg = ' NO particulate mercury in model.'
         Call m3warn( 'map_precursor', 0, 0, xmsg )
         PHGRXN_idx = 0
#endif
      end if

#ifdef verbose_aero
      Write( logdev,'( /5x, a )' ) 'map_precursor required species'
      Write( logdev,'( 5x, a, i4 )' ) 'NO2_idx:    ', NO2_idx
      Write( logdev,'( 5x, a, i4 )' ) 'N2O5_idx:   ', N2O5_idx
      Write( logdev,'( 5x, a, i4 )' ) 'HNO3_idx:   ', HNO3_idx
      Write( logdev,'( 5x, a, i4 )' ) 'HONO_idx:   ', HONO_idx
      Write( logdev,'( 5x, a, i4 )' ) 'SULF_idx:   ', SULF_idx
      Write( logdev,'( 5x, a, i4 )' ) 'SULPRD_idx: ', SULPRD_idx
      Write( logdev,'( 5x, a, i4 )' ) 'HCL_idx:    ', HCL_idx
      Write( logdev,'( 5x, a, i4 )' ) 'NH3_idx:    ', NH3_idx
      Write( logdev,'( 5x, a, i4 )' ) 'OH_idx:     ', OH_idx
      if( aphgj_idx .gt. 0 )then
          Write( logdev,'( 5x, a, i4 )' ) 'PHGRXN_idx:     ', PHGRXN_idx
      end if
#endif

      If( Precursor_eflag )Then
         Write(logdev,99901) Trim( mechname )
             xmsg = 'FATAL errors found in namelist used. Check '
     &          //  'the log of exiting processor if more details are needed.'
         Call m3exit( pname, 0, 0, xmsg, xstat3 )
      End If 

      mapped = .True.

#ifdef sens
      Allocate ( s_precursor_conc( n_precursor,npmax ) )
#endif

99901 Format( 'FATAL error(s) found in the GC and/or NR namelists used. Check that '
     &     /  'these namelists contain the above required data as the respective files '
     &     /  'in the repository version of the mechanism: ' , a )
99902 Format( 5x,'Particle precursor species ', a, ' is found in G2AE or N2AE values of ',
     &        'the GC or NR namelist.' )

      Return
      End Subroutine map_precursor

C-----------------------------------------------------------------------
#ifdef sens
      Subroutine extract_precursor( conc,s_conc )
#else
      Subroutine extract_precursor( conc )
#endif

C  Extracts the required precursor data from CGRID into conc.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C SH  03/10/11 Renamed met_data to aeromet_data
C HS  03/10/11 Changed vtmp and gasconv to real(8)
C-----------------------------------------------------------------------

      Use aeromet_data, only: airdens, min_gasconc
      Use const, only: inv_mwair

      Implicit None

C Arguments:
      Real, Intent( In ) :: conc( : )
#ifdef sens
      Real, Intent( In ) :: s_conc( :,: )
#endif

C Local Variables:
      Real( 8 )       :: gasconv       ! converts from [ppm] to [ug/m^3]
      Real( 8 )       :: vtmp
      Integer         :: n
      Integer         :: spc

#ifdef sens
      If ( .Not. ae_ddm3d_ready ) Then
         Call init_aero_ddm3d()
      End If
#endif

      Call map_precursor()

C Compute gas conversion constant
      gasconv = Real( airdens * inv_mwair, 8 )

C Copy grid cell concentrations of precursor species
      precursor_conc = 0.0d0
#ifdef sens
      s_precursor_conc = 0.0D0
#endif

      Do spc = 1, n_precursor
         n = precursor_map( spc )
         If ( n .Ne. 0 ) Then
            vtmp = gasconv * precursor_mw( spc )
            precursor_conc( spc ) = Max( Real( conc( n ), 8) * vtmp, Real( min_gasconc, 8) )
#ifdef sens 
            Do np = 1, npmax
               If ( precursor_conc( spc ) .Eq. min_gasconc ) Then
                  s_precursor_conc( spc,np ) = 0.0D0
               Else
                  s_precursor_conc( spc,np ) = vtmp * Real( s_conc( np,n ), 8 )
               End If
            End Do
#endif
         End If
      End Do

      Return
      End Subroutine extract_precursor

C------------------------------------------------------------------------
#ifdef sens
      Subroutine update_precursor( conc, s_conc )
#else
      Subroutine update_precursor( conc )
#endif

C  Updates CGRID aerosol precursor values from the conc array.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C SH  03/10/11 Renamed met_data to aeromet_data
C HS  03/10/11 Only update conc for species with "update" = .TRUE.;
C    -changed vtmp and gasconv to real(8)
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------

      Use aeromet_data, only: airdens, min_gasconc
      Use const, only: inv_mwair
      Use utilio_defn, only: xstat3, m3exit
      Use aero_data, only : COND_BUDGET, COAG_BUDGET, NPF_BUDGET, GROWTH_BUDGET

      Implicit None

C arguments:
      Real, Intent( Out ) :: conc( : )
#ifdef sens
      Real, Intent( Out ) :: s_conc( :,: )
#endif

C local variables:
      Character( 80 ) :: xmsg
      Real( 8 )       :: gasconv       ! converts from [ppm] to [ug/m^3]
      Real( 8 )       :: vtmp
      Integer         :: n
      Integer         :: spc

      If ( .Not. mapped ) Then
         xmsg = 'CGRID Species has not been mapped'
         Call m3exit( 'update_precursor', 0, 0, xmsg, xstat3 )
      End If

C compute gas conversion constant
      gasconv = Real( airdens * inv_mwair, 8 )

C copy precursor_conc back to grid cell concentrations
      Do spc = 1, n_precursor
         n = precursor_map( spc )
         If ( n .Ne. 0 ) Then
            If ( precursor( spc )%update ) Then
               If ( precursor( spc )%rxncounter ) Then
                  vtmp = precursor_mw( spc ) * gasconv
                  conc( n ) = Max( real( precursor_conc( spc ) / vtmp, 4 ), min_gasconc  )
                  COND_BUDGET( n )   = -1.0 *  conc( n ) 
                  conc( n ) = 0.0
#ifdef sens
                  do np = 1, npmax
                     s_conc( np,n ) = 0.0
                  end do
#endif
               Else
                  vtmp = precursor_mw( spc ) * gasconv
                  conc( n ) = Max( real( precursor_conc( spc ) / vtmp, 4 ), min_gasconc  )
          
                  ! Convert Budget Process Numbers from ug m-3 to ppmv
                  ! for application to process analysis and ISAM
                  COND_BUDGET( n )   = COND_BUDGET( n )   / vtmp
                  NPF_BUDGET( n )    = NPF_BUDGET( n )    / vtmp
#ifdef sens
                  do np = 1, npmax
                     If ( conc( n ) .Eq. min_gasconc ) Then
                        s_conc( np,n ) = 0.0
                     Else
                        s_conc( np,n ) = Real( (s_precursor_conc( spc,np )/vtmp), 4 )
                     End If
                  end do
#endif                  
               End If
            End If
         End If
      End Do

      Return
      End Subroutine update_precursor

C-----------------------------------------------------------------------
      Function findPrecursor( vname, required ) Result ( ndx )

C  Finds the index of 'required' aerosol species in the precursor list

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------

      use utilio_defn

      Implicit None

C Arguments:
      Character( * ) :: vname
      Logical        :: required
      
      Integer ndx

C Local Variables:
      Integer         :: spc
      Character( 80 ) :: xmsg

      ndx = 0
      
      Do spc = 1, n_precursor
         If ( Index( precursor( spc )%name, trim(vname) ) .Gt. 0 ) Then
            ndx = spc
            Return
         End If
      End Do

      xmsg = 'FATAL: ' // Trim( vname )
     &    // ' is not found in the G2AE or N2AE values of GC or NR namelists'
      Precursor_eflag  = .True.
      Call m3warn( pname, 0, 0, xmsg )

      Return
      End Function findPrecursor

      End Module precursor_data

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       SUBROUTINE CHEM( CGRID, JDATE, JTIME, TSTEP )
C**********************************************************************
C
C  FUNCTION: Driver subroutine for Euler Backward Iterative solver
C
C  PRECONDITIONS: For the CB6R5PFAS_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED:  HRINIT, HRCALCKS, HRSOLVER
C                                     FIND_DEGRADED, INIT_DEGRADE, FINAL_DEGRADE
C
C  REVISION HISTORY: Created by EBI solver program, Jun 26, 2025
C                       Based on the algorithm in "Test of Two Numerical
C                       Schemes for Use in Atmospheric Transport-Chemistry
C                       Models", O. Hertel, R. Berkowicz, J. Christensen,
C                       and O. Hov, Atm Env., Vol. 27A, No. 16, 1993.
C                       Original MEBI code developed by Ho-Chun Huang,
C                       SUNY, Albany -- "On the performance of numerical
C                       solvers for a chemistry submodel in three-dimensional
C                       air quality models 1. Box model simulations",
C                       H. Huang and J.S. Chang, JGR, Vol 106, No. D17, 2001.
C                       This version replaces Huang and Chang use of numerical
C                       solutions with analytical solutions derived in
C                       Hertel et al.
C   21 Jun 10 J.Young: convert for Namelist redesign
C   11 May 11 D.Wong: incorporated twoway model implementation
C   27 Sep 11 B.Hutzell: revised method for defining CALL_DEG variable
C   18 Jul 14 B.Hutzell: revised: 1) to use the RXNS_DATA and RXNS_FUNCTION
C                        modules instead of include files, 2) to enable
C                        reactions between species types, 3) to calculate
C                        heterogeneous rate constants via AEROSOL_CHEMISTRY
C                        module, 4) to replace call to HRCALCKS with
C                        subroutine in RXNS_FUNCTION module and 5) to change
C                        how degrade routines are used, if present
C   02 Dec 14 B.Hutzell: 1) added terrestrial data to conduct surface
C                        dependent reactions and 2) modified the call CALC_RCONST
C                        routine
C   01 Feb 19 D.Wong:    Implemented centralized I/O approach, removed all MY_N
C                        clauses
C**********************************************************************

      USE HGRD_DEFN             ! horizontal domain specifications
      USE VGRD_DEFN             ! vertical layer specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN           ! IOAPI parameters and functions declarations
      USE RXNS_DATA
      USE AEROSOL_CHEMISTRY
      USE RXNS_FUNCTION
#ifdef isam
      USE SA_IRR_DEFN
      USE SA_DEFN
#endif
      USE HRDATA
      USE PHOT_MOD, Only: INIT_PHOT_SHARED, RJ     ! photolysis rate, in-line module
      USE PA_DEFN, Only: LIRR                      ! Process Analysis control and data variable
      USE PA_IRR_CLT
#ifndef isam
      USE DEGRADE_ROUTINES, ONLY : N_REACT, RXTANT_MAP, DEG_LAY, DEG_COL, DEG_ROW,
     &                              FIND_DEGRADED, INIT_DEGRADE, FINAL_DEGRADE
#else
      USE DEGRADE_ROUTINES, ONLY : N_REACT, RXTANT_MAP, SA_DEGRADE_EXTRACT,
     &                              FIND_DEGRADED, INIT_DEGRADE, FINAL_DEGRADE,
     &                              SA_DEGRADE_UPLOAD, DEG_LAY, DEG_COL, DEG_ROW
#endif
      USE CENTRALIZED_IO_MODULE, ONLY : INTERPOLATE_VAR, OCEAN, SZONE
#ifdef sens
      USE DDM3D_CHEM
      Use DDM3D_DEFN, Only: DATENUM, STARTDATE, IPT, IDATE, HIGH, NP, NPMAX, CKTIME
#endif
      USE CONST, ONLY: MWAIR, MWWAT, STDATMPA

      IMPLICIT NONE

C..Includes:
      INCLUDE SUBST_FILES_ID  ! CMAQ files
      INCLUDE SUBST_EMISPRM   ! Emissions processing control parameters

C..Arguments:
      REAL, POINTER :: CGRID( :,:,:,: )  ! Species concentrations
      INTEGER JDATE           ! Current date (YYYYDDD)
      INTEGER JTIME           ! Current time (HHMMSS)
      INTEGER TSTEP( 3 )      ! Time step vector (HHMMSS)

C..Parameters:
      REAL( 8 ), PARAMETER :: DCONMIN = 1.0D-30               ! minimum species concentration allowed
      REAL,      PARAMETER :: CONCMIN = 1.0E-30               ! minimum species concentration allowed
      REAL,      PARAMETER :: MAOMV   = 1.0E6 * MWAIR / MWWAT ! Mol Wt of air over Mol Wt of water times 1.0E6

C..External Functions:


C..Saved Local Variables:

      CHARACTER( 16 ), SAVE :: PNAME = 'HRDRIVER'     ! Program name

      INTEGER, SAVE :: ISTFL            ! Unit no. of iteration stat output file
      LOGICAL, SAVE :: LFIRST = .TRUE.  ! Flag for first call to this subroutine

      REAL( 8 ), SAVE :: PA2ATM   ! Pascal to atm conv fac

C..Scratch Local Variables:
      CHARACTER( 132 ) :: MSG           ! Message text
      CHARACTER(  16 ) :: VNAME         ! Name of I/O API data variable

      INTEGER C, E, L, R, S   ! Loop indices
      INTEGER ISP             ! array index

      INTEGER AVGEBI          ! Average no. of EBI iterations
      INTEGER DELT_SEC        ! EBI max time step in seconds
      INTEGER ESP             ! Loop index for emissions species
      INTEGER ITMSTEP         ! Chemistry integration interval (sec)
      INTEGER LEV             ! Layer index
      INTEGER MIDDATE         ! Date at time step midpoint
      INTEGER MIDTIME         ! Time at time step midpoint
      INTEGER NPH             ! Index for number of phot. rxns in PHOT
      INTEGER SPC             ! Species loop index
#ifdef hrstats
      INTEGER MNEBI           ! Min no. of EBI iterations
      INTEGER MXEBI           ! Max no. of EBI iterations
#endif

      LOGICAL LSUNLIGHT       ! Flag for sunlight

      REAL       INV_DENS     ! reciprocal of air mass density, m3/Kg
#ifdef hrstats
      REAL       SUMEBI       ! Sum of EBI iterations
#endif

      INTERFACE
        SUBROUTINE HRSOLVER( JDATE, JTIME, C, R, L )
           INTEGER, INTENT( IN ) :: JDATE    ! Current date (YYYYDDD)
           INTEGER, INTENT( IN ) :: JTIME    ! Current time (HHMMSS)
           INTEGER, INTENT( IN ) :: C, R, L  ! Cell col, row, lev
        END SUBROUTINE HRSOLVER
        SUBROUTINE HETCHEM_UPDATE_AERO( CGRID )
           REAL, POINTER :: CGRID( :,:,:,: )  !  species concentration in cell
        END SUBROUTINE HETCHEM_UPDATE_AERO
      END INTERFACE

C**********************************************************************

      IF( NUMB_MECH_SPC .EQ. 0 ) RETURN

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  On first call, call routines to set-up for EBI solver
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF( LFIRST ) THEN

         IF( MECHNAME .NE. 'CB6R5PFAS_AE7_AQ' ) THEN
             MSG = 'This version of the EBI solver can only be used with'
     &            // ' the CB6R5PFAS_AE7_AQ chemical mechanism'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
         END IF

#ifdef emis_chem
         EMISVD = .FALSE.
#else
         EMISVD = .TRUE.
#endif

         IF( INDEX( MECHNAME, 'AE' ) .NE. 0 ) THEN
           L_AE_VRSN = .TRUE.
         ELSE
           L_AE_VRSN = .FALSE.
         END IF

         IF( INDEX( MECHNAME, 'AQ' ) .NE. 0 ) THEN
           L_AQ_VRSN = .TRUE.
         ELSE
           L_AQ_VRSN = .FALSE.
         END IF

         IF( LIRR ) THEN
            CALL_IRR = .TRUE.
         ELSE
            CALL_IRR = .FALSE.
         END IF

         MODEL_SPECIES = NSPCSD    ! WTH: find number of model species

! Determine whether DEGRADE rountines are needed.

         CALL FIND_DEGRADED( JDATE, JTIME, CALL_DEG )
         IF( CALL_DEG )THEN
            WRITE(LOGDEV,*)'TX DEGRADE ROUTINES USED'
            WRITE(LOGDEV,*)'Mechanism contains degraded species'
#ifdef verbose_gas
         ELSE
            WRITE(LOGDEV,*)'TX DEGRADE ROUTINES OMITTED'
            WRITE(LOGDEV,*)'MECHANISM does not include degraded species'
#endif
         END IF

         CALL HRINIT

         ITMSTEP = TIME2SEC( TSTEP( 2 ) )
         CHEMSTEP = REAL( ITMSTEP, 8 ) / 60.0D0
         WRITE( LOGDEV, 92000 ) CHEMSTEP, DELTAT

         WRITE( LOGDEV, 92020 )
         DO SPC = 1, NUMB_MECH_SPC
            WRITE( LOGDEV, 92040 ) CHEMISTRY_SPC( SPC ), RTOL( SPC )
         END DO

         PA2ATM =  REAL( 1.0 / STDATMPA, 8)

c..If emissions processing requested stop
         IF( .NOT. EMISVD ) THEN  ! assumes emis processing in gas chem

            MSG = 'ERROR: EBI solver not configured to '//
     &            'process emissions in chemistry'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )

         END IF   ! End if doing emissions


#ifdef hrstats
         ISTFL = JUNIT()
         OPEN( UNIT=ISTFL, FILE='iterstat.dat' )
         WRITE( ISTFL, 94020 )
#endif
C Define processor offsets

         PECOL_OFFSET = COLSD_PE( 1, MYPE+1 ) - 1
         PEROW_OFFSET = ROWSD_PE( 1, MYPE+1 ) - 1

         ALLOCATE( SEAWATER_ZONE( NCOLS, NROWS ) )
         DO R = 1, NROWS
            DO C = 1, NCOLS
               SEAWATER_ZONE( C,R ) =  OCEAN( C,R ) + SZONE( C,R )
             END DO
         END DO

         ALLOCATE( DENS( NCOLS, NROWS, NLAYS ), PRES( NCOLS, NROWS, NLAYS ),
     &             QV  ( NCOLS, NROWS, NLAYS ), TA  ( NCOLS, NROWS, NLAYS ),
     &             SEAICE( NCOLS, NROWS ) )

C..Initialize shared photolysis data
         CALL INIT_PHOT_SHARED()

C..Determine which cells need IRR
         ALLOCATE( LFLAGIRR ( NCOLS, NROWS, NLAYS ) )
         CALL      PA_IRR_CKCELLS ( LFLAGIRR )

#ifdef isam
        NUMB_ISAM_CELLS = 1.0D0 / ( NCOLS * NROWS * NLAYS )
        CALL SA_IRR_INIT
#endif

#ifdef sens
         CALL INIT_DDM3D_CHEM()

C For higher order sensitivities
         IF ( HIGH ) THEN
            DO RXN = 1, NRXNS
               IF( NREACT( RXN ) .EQ. 1 ) THEN
                  ORDER1( RXN ) = .TRUE.
               ELSE
                  ORDER1( RXN ) = .FALSE.
               END IF
            END DO
         END IF
#endif

         LFIRST = .FALSE.

      END IF      ! First time

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Set date and time to center of time step, get necessary physical
C  data
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      MIDDATE = JDATE
      MIDTIME = JTIME
      ITMSTEP = TIME2SEC( TSTEP( 2 ) )
      CHEMSTEP = REAL( ITMSTEP, 8 ) / 60.0D0
      CALL NEXTIME( MIDDATE, MIDTIME, SEC2TIME( ITMSTEP / 2 ) )

C.. Compute number of time step loops and step size for EBI solver
      DELT_SEC = INT( DELTAT * 60.0D0 + 0.1D0 )
      IF( DELT_SEC .GE. ITMSTEP ) THEN
         N_EBI_STEPS = 2
         EBI_TMSTEP  = 0.5D0 * CHEMSTEP
      ELSE
         IF( MOD( ITMSTEP, DELT_SEC ) .EQ. 0 ) THEN
            N_EBI_STEPS = ITMSTEP / DELT_SEC
         ELSE
            N_EBI_STEPS = ITMSTEP / DELT_SEC + 1
         END IF
         EBI_TMSTEP =  CHEMSTEP / REAL( N_EBI_STEPS, 8 )
      END IF

      N_INR_STEPS = 1


C.. Get fractional seaice coverage from the METCRO2D file.

      CALL INTERPOLATE_VAR ('SEAICE', MIDDATE, MIDTIME, SEAICE)

C.. Get ambient temperature in K

      CALL INTERPOLATE_VAR ('TA', MIDDATE, MIDTIME, TA)

C.. Get specific humidity in Kg H2O / Kg air
      CALL INTERPOLATE_VAR ('QV', MIDDATE, MIDTIME, QV)

! Get ambient MASS DENSITY in Kg/m^3
      CALL INTERPOLATE_VAR ('DENS', MIDDATE, MIDTIME, DENS)

C.. Get pressure in Pascals
      CALL INTERPOLATE_VAR ('PRES', MIDDATE, MIDTIME, PRES)

C.. Get Heteorogeneous rates and Update Aerosol Distribution Properties
      CALL HETCHEM_RATES( TA, PRES, QV, CGRID, DENS )

#ifdef sens
      DATENUM = 1 + JDATE - STARTDATE !  Set the date and hour counters used in sensitivity calls

C For reaction rate sensitivities
      DO NP = 1, NPMAX
         IF ( IPT( NP ) .EQ. 5 ) THEN
            CALL CKTIME( JDATE,JTIME,NP,RXNFLAG(NP) ) ! Rxnflag set to true iff ipt=5 and time, date within bounds
            IF ( IDATE( NP, DATENUM ) .NE. 1 ) RXNFLAG( NP ) = .FALSE.
         ELSE
            RXNFLAG( NP ) = .FALSE.
         END IF
      END DO

#endif sens

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Top of loop over cells
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

#ifdef hrstats
      MNEBI = 1000
      MXEBI = 0
      SUMEBI = 0.0
#endif

      NCELL = 1

      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS

               DEG_LAY = L
               DEG_ROW = R
               DEG_COL = C

c..reset CALL_IRR based on cell's values
               CALL_IRR = LFLAGIRR( C,R,L )

c..Load ICs
               INV_DENS = 1.0 / DENS( C,R,L )
               DO SPC = 1, NUMB_MECH_SPC
                  S = CGRID_INDEX( SPC )
                  IF( CONVERT_CONC( SPC ) )THEN
                      YC( SPC ) = REAL( MAX( CONCMIN,
     &                            INV_DENS*FORWARD_CONV( SPC )*CGRID( C,R,L,S )), 8 )
                  ELSE
                      YC( SPC ) = REAL( MAX( CGRID( C,R,L,S ), CONCMIN), 8 )
                  END IF
               END DO

c..Set physical quantities
               TEMP( NCELL )     = REAL( TA( C,R,L ), 8)
               DENSITY( NCELL )  = REAL( DENS( C,R,L ), 8)
!                PRESCELL( NCELL ) = REAL( PRES( C,R,L ), 8)
               ATMPRES( NCELL )  = PA2ATM * REAL( PRES( C,R,L ), 8)
               H2O( NCELL )      = REAL( MAX ( MAOMV * QV( C,R,L ), 0.0 ), 8)
               SEAWATER (NCELL)      = MAX ( 0.0D0, ( REAL( SEAWATER_ZONE( C,R ) - SEAICE (C,R) ,8) ) )

c..Get rate constants
               LSUNLIGHT = .FALSE.
               FORALL( NPH = 1:NPHOTAB ) RJIN( NCELL,NPH ) = REAL( RJ( C,R,L,NPH ), 8)
               IF( MAXVAL(RJIN) .GT. 0.0D0 ) LSUNLIGHT = .TRUE.

               FORALL ( NPH = 1:NHETERO )HET( NCELL,NPH ) = REAL( KHETERO( NPH,C,R,L ), 8)

               CALL CALC_RCONST( TEMP, ATMPRES, H2O, RJIN, HET, LSUNLIGHT, SEAWATER, RKI_SAV, NCELL )
               FORALL( NPH = 1:NRXNS )RKI( NPH ) = RKI_SAV( NCELL, NPH )

               IF(CALL_DEG)THEN ! INITIALIZE degradation routines

                  YCCELL = 0.0D0
                  DO S = 1, MODEL_SPECIES
                     YCCELL( S ) = REAL( CGRID(C,R,L,S), 8)
                  END DO
                  CALL INIT_DEGRADE(YCCELL,TA(C,R,L),DENS(C,R,L),PRES(C,R,L),QV(C,R,L),RJIN(NCELL,:),
     &                              JDATE, JTIME)

#ifdef isam
                  CALL SA_DEGRADE_EXTRACT( C,R,L,DENS(C,R,L) )
#endif
               END IF

#ifdef isam
#if defined(isam) || defined(verbose_isam)
C...For diagnosing IRR calculations in log files
                IF( CHECK_ISAM )THEN
                   WRITE_CELL = .FALSE.
                   IF( C .EQ. MAX(1, NCOLS/2) .AND. R .EQ. MAX(1,NROWS/2) .AND. L .EQ. 1 )THEN
                        WRITE_CELL = .TRUE.
                        WRITE(LOGDEV,*)'WRITE_CELL = .TRUE.'
                   ELSE
                        WRITE_CELL = .FALSE.
                   END IF
                END IF
#endif
               CALL SA_IRR_EXTRACT( C, R, L, DENS( C,R,L ),YC )
#endif

c..Call EBI solver
               N_EBI_IT = 0

               CALL HRSOLVER( JDATE, JTIME, C, R, L )

#ifdef hrstats
               MXEBI  = MAX( MXEBI, N_EBI_IT )
               MNEBI  = MIN( MNEBI, N_EBI_IT )
               SUMEBI = SUMEBI + REAL( N_EBI_IT )
#endif


c..Update concentration array
               DO SPC = 1, NUMB_MECH_SPC
                  S = CGRID_INDEX( SPC )
                  IF( CONVERT_CONC( SPC ) )THEN
                      CGRID( C,R,L,S ) = REAL( REVERSE_CONV( SPC ) * DENS( C,R,L )
     &                                 * MAX( YC( SPC ), DCONMIN), 4)
                  ELSE
                      CGRID( C,R,L,S ) = REAL( MAX( YC( SPC ), DCONMIN), 4)
                  END IF
               END DO

               IF(CALL_DEG)THEN  ! WTH: update based on degrade routines
                  CALL FINAL_DEGRADE(YCCELL)
                  UPDATE_DEGRADED: DO SPC = 1, N_REACT
                     ISP = RXTANT_MAP( SPC )
                     IF( ISP .LE. 0 )CYCLE UPDATE_DEGRADED
                     DO S = 1, NUMB_MECH_SPC
                        IF(  CGRID_INDEX( S ) .EQ. ISP )CYCLE UPDATE_DEGRADED
                     END DO
                     CGRID(C,R,L,ISP) = REAL( YCCELL(ISP), 4)
                  END DO UPDATE_DEGRADED
#ifdef isam
                  CALL SA_DEGRADE_UPLOAD( C,R,L,DENS(C,R,L) )
#endif
               END IF

#ifdef isam
               CALL SA_IRR_UPLOAD( C, R, L, DENS( C,R,L ), YC )
#endif

c..update irrout arrays if needed
               IF ( LFLAGIRR( C,R,L ) )CALL PA_IRR_CELLENDF( C, R, L )
#ifdef sens
               DO RXN = 1, NRXNS
                  SRK( RXN ) = RKI( RXN )
                  IF ( HIGH ) THEN
                     IF ( ORDER1 (RXN ) ) THEN
                        SRK2( RXN ) = 0.0
                     ELSE
                        SRK2( RXN ) = RKI( RXN )
                     END IF
                  END IF
               END DO


               CALL SOLVE_DDM3D_CHEM( C,R,L,CHEMSTEP )
#endif

            END DO
         END DO
      END DO

!  Update Aerosol Surface Area
      CALL HETCHEM_UPDATE_AERO( CGRID )

#ifdef hrstats
      AVGEBI = SUMEBI / REAL( NCOLS * NROWS * NLAYS )
      WRITE( ISTFL, 94040 ) JDATE, JTIME, MNEBI, AVGEBI, MXEBI
#endif

      RETURN

C*********************** FORMAT STATEMENTS ****************************

92000 FORMAT( / 10X, 'Euler Backward Iterative Parameters -'
     &        / 10X, 'Chemistry Integration Time Interval (min):', F12.4,
     &        / 10X, 'EBI maximum time step (min):              ', F12.4 )

92020 FORMAT( //10X, 'Species convergence tolerances:' )

92040 FORMAT(   10X, A16, 2X, 1PE12.2 )

92060 FORMAT( / 10X, 'Emissions Processing in Chemistry ...'
     &        / 10X, 'Number of Emissions Layers:         ', I3
     &        / 10X, 'out of total Number of Model Layers:', I3 )


94020 FORMAT( 'DATE      TIME ', 'MNEBI AVEBI MXEBI' )

94040 FORMAT( I7, 1X, I6, 1X, 3( I5, 1X ) )
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! complex number general function

! Revision History:
!   2012/07/31 David Wong Original version
!   2012/10/22 David Wong Added treatment to avoid division by 0
!   2013/11/20 David Wong modified the way to compute
!              max(abs(c_div_cc%real_part), min_val) in subroutine
!              c_div_cc to satisfy absoft compiler requirement
!   2015/12/16 David Wong renamed argument list for c_add_cr, c_add_rc,
!              c_sub_cr and c_sub_rc to avoid gfortran not able to 
!              distinguish those routines in the interface block issue
!   2016/02/23 David Wong extracted the entire module and put it in a
!              file alone.

        module complex_number_module

        implicit none

!       integer, parameter :: loc_real_precision = selected_real_kind(p=16, r=60)
        integer, parameter :: loc_real_precision = 8

        real (kind=loc_real_precision), parameter, private :: min_val = 1.0e-30_loc_real_precision

        type complex_number
          real(kind=loc_real_precision) :: real_part, imag_part
        end type complex_number

        interface c_add
          module procedure c_add_cc,    &      ! z1 + z2
                           c_add_cr,    &      ! z1 + num, where num is a real number
                           c_add_rc            ! num + z1, where num is a real number
        end interface

        interface c_sub
          module procedure c_sub_cc,    &      ! z1 - z2
                           c_sub_cr,    &      ! z1 - num, where num is a real number
                           c_sub_rc            ! num - z1, where num is a real number
        end interface

        interface c_mul
          module procedure c_mul_cc,    &      ! z1 * z2
                           c_mul_rc            ! num * z1, where num is a real number
        end interface

        interface c_div
          module procedure c_div_cc,    &      ! z1 / z2
                           c_div_rc            ! num / z1, where num is a real number
        end interface

        contains

! --------------------------------------------------------------------------
        type (complex_number) function c_set (x, y)

! initialize a complex number

          real(kind=loc_real_precision), intent(in) :: x, y

          character (len = 80) :: str

          write (str, *) x
          read(str, *) c_set%real_part
          write (str, *) y
          read(str, *) c_set%imag_part

        end function c_set

! --------------------------------------------------------------------------
        type (complex_number) function c_add_cc (z1, z2)

          type (complex_number), intent(in) :: z1, z2

          c_add_cc%real_part = z1%real_part + z2%real_part
          c_add_cc%imag_part = z1%imag_part + z2%imag_part

        end function c_add_cc

! --------------------------------------------------------------------------
        type (complex_number) function c_add_cr (z3, num1)

          type (complex_number),         intent(in) :: z3
          real(kind=loc_real_precision), intent(in) :: num1

          c_add_cr%real_part = z3%real_part + num1
          c_add_cr%imag_part = z3%imag_part

        end function c_add_cr

! --------------------------------------------------------------------------
        type (complex_number) function c_add_rc (num2, z4)

          type (complex_number),         intent(in) :: z4
          real(kind=loc_real_precision), intent(in) :: num2

          c_add_rc%real_part = z4%real_part + num2
          c_add_rc%imag_part = z4%imag_part

        end function c_add_rc

! --------------------------------------------------------------------------
        type (complex_number) function c_sub_cc (z1, z2)

          type (complex_number), intent(in) :: z1, z2

          c_sub_cc%real_part = z1%real_part - z2%real_part
          c_sub_cc%imag_part = z1%imag_part - z2%imag_part

        end function c_sub_cc

! --------------------------------------------------------------------------
        type (complex_number) function c_sub_cr (z3, num1)

          type (complex_number),         intent(in) :: z3
          real(kind=loc_real_precision), intent(in) :: num1

          c_sub_cr%real_part = z3%real_part - num1
          c_sub_cr%imag_part = z3%imag_part

        end function c_sub_cr

! --------------------------------------------------------------------------
        type (complex_number) function c_sub_rc (num2, z4)

          type (complex_number),         intent(in) :: z4
          real(kind=loc_real_precision), intent(in) :: num2

          c_sub_rc%real_part = num2 - z4%real_part
          c_sub_rc%imag_part = - z4%imag_part

        end function c_sub_rc

! --------------------------------------------------------------------------
        type (complex_number) function c_mul_cc (z1, z2)

          type (complex_number), intent(in) :: z1, z2

          c_mul_cc%real_part =   z1%real_part * z2%real_part    &
                               - z1%imag_part * z2%imag_part
          c_mul_cc%imag_part =   z1%real_part * z2%imag_part    &
                               + z1%imag_part * z2%real_part

        end function c_mul_cc

! --------------------------------------------------------------------------
        type (complex_number) function c_mul_rc (x, z1)

          type (complex_number),         intent(in) :: z1
          real(kind=loc_real_precision), intent(in) :: x

          c_mul_rc%real_part = z1%real_part * x
          c_mul_rc%imag_part = z1%imag_part * x

        end function c_mul_rc

! --------------------------------------------------------------------------
        type (complex_number) function c_div_cc (z1, z2)

          type (complex_number), intent(in) :: z1, z2

          real(kind=loc_real_precision) :: denom
          real(kind=loc_real_precision) :: temp(2)

          denom = 1.0 / (  z2%real_part * z2%real_part &
                         + z2%imag_part * z2%imag_part)

          c_div_cc%real_part = (  z1%real_part * z2%real_part          &
                                + z1%imag_part * z2%imag_part) * denom

          temp(1) = abs(c_div_cc%real_part)
          temp(2) = min_val

          c_div_cc%real_part = sign(maxval(temp), c_div_cc%real_part)

          c_div_cc%imag_part = (  z1%imag_part * z2%real_part          &
                                - z1%real_part * z2%imag_part) * denom

          temp(1) = abs(c_div_cc%imag_part)

          c_div_cc%imag_part = sign(maxval(temp), c_div_cc%imag_part)

        end function c_div_cc

! --------------------------------------------------------------------------
        type (complex_number) function c_div_rc (num, z1)

! compute 1 / z1

          real(kind=loc_real_precision), intent(in) :: num
          type (complex_number),         intent(in) :: z1

          real(kind=loc_real_precision) :: denom, temp

          temp = z1%real_part * z1%real_part + z1%imag_part * z1%imag_part
          temp = sign(max(abs(temp), min_val), temp)

          denom = num / temp
          c_div_rc%real_part = z1%real_part * denom
          c_div_rc%imag_part = -1.0 * z1%imag_part * denom

        end function c_div_rc

! --------------------------------------------------------------------------
        type (complex_number) function c_sin (z1)

! compute sin of a complex number

          type (complex_number), intent(in) :: z1

          c_sin%real_part = sin(z1%real_part) * cosh(z1%imag_part)
          c_sin%imag_part = cos(z1%real_part) * sinh(z1%imag_part)

        end function c_sin

! --------------------------------------------------------------------------
        type (complex_number) function c_cos (z1)

          type (complex_number), intent(in) :: z1

          c_cos%real_part = cos(z1%real_part) * cosh(z1%imag_part)
          c_cos%imag_part = -1.0 * sin(z1%real_part) * sinh(z1%imag_part)

        end function c_cos

! --------------------------------------------------------------------------
        real(kind=loc_real_precision) function c_abs (z1)

! computer absolute value of a complex number

          type (complex_number), intent(in) :: z1

          c_abs = sqrt(z1%real_part**2 + z1%imag_part**2)

        end function c_abs

        end module complex_number_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module soa_defn

C  Defines aerosol species arrays and parameters required in SOA processing.

C  Contains:
C     Subroutine extract_soa
C     Subroutine update_orgvapor
C     Function findVapor
C     Function findOrgprod
C     Subroutine orgaer

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C HP  03/11/11 Updated monoterpene SOA alphas and Cstars to Carlton et al. 2010 values
C HP  07/24/11 Changed aromatic SOA alphas for consistency with updated reaction counters
C               BNZ, TOL, XYL numbers now match Ng et al. 2007 Atmos. Chem. Phys.
C 08 Jun 12 J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2
C 13 Aug 13 H. Pye: Xylene and toluene low-NOx yields switched. Values now
C               follow experimental data of Ng et al. 2007 ACP as shown in Table 3.
C               Values in Table 6 of Ng et al. (previously used) are incorrect.
C 18 Dec 13 G.Sarwar: added orgprod parent names based on RACM2
C 07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C 21 Jul 14 B.Hutzell: used ifdef statement to make oligomerization
C                      optional because process represented in chemical
C                      mechanism
C 26 Sep 14 H. Pye: Added isoprene + NO3 SOA (see mech.def, no changes
C                   here). When IEPOX uptake present in gas phase for
C                   cb05e51, replace preivous acid enhanced isoprene SOA
C                   with IEPOX uptake SOA now handled as a heterogeneous
C                   rxn. For saprc07tic_ae6i, perform more detailed
C                   IEPOX and MAE uptake and do not do Carlton et al. 2010
C                   acid enhancement. Note that saprc07tic_ae6i is a research
C                   version and it is unclear how duplicative AISO1+AISO2+their oligomers
C                   are with  IEPOX+MAE uptake and their oligomers.
C                   Both pathways occur with sarpc07tic_ae6i. To turn AISO1+AISO2
C                   oligomers off, set "Decay" in oaspc to 0.0 for SV_ISO1/2.
C 27 Sep 14 H. Pye: Added alkane and PAH SOA (Pye and Pouliot 2012 ES&T)
C 15 Jul 15 G. Sarwar: updated SOA from alkane, PAH, and isoprene for RACM2
C 03/03/16  D. Luecken: added capability for CB6
C 24 Mar 16 G. Sarwar: updated for CB05EH51
C    May 16 B. Murphy, H. Pye: updated treatment of aerosol moments
C    Jan 18 H. Pye: updated monoterpene photoxidation SOA: Xu et al. 2018 ACPD
C                   AMT1-7 will replace ATRP1-2 when fully implemented
C                   across mechanisms. 
C    Aug 18 M. Qin, H. Pye: Removed oligomerization option here. Oligomerization
C                   must be done in gas chemistry (mech.def). Added anthropogenic
C                   SOA condensation for aero7.
C   29 Aug 18 G. Sarwar: updated for CB6R3M
C 17 Jan 20 B.Hutzell -Added algorithm to handle tracer species and
C                     -added benzo[a]pyrene to oa_list. Its cstar is based
C                      on the subcooled vapor pressure in Lei et. al (2002)
C   15 Sep 23 G. Sarwar: updated for CRACMM2
C 28 Nov 23 N. Skipper: added new species for CRACMM2
C-----------------------------------------------------------------------
#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX
      Use aero_ddm3d, ONLY : init_aero_ddm3d, ae_ddm3d_ready, og_sens, rog_dsens
#endif 
      Implicit None

      ! Define Logical values as T and F for the OA table
      Logical, Parameter, Private :: T = .true.
      Logical, Parameter, Private :: F = .false.

      Integer, Parameter :: n_oa_list = 85   ! # of potential partitioning SVOCs
      Integer, Save      :: n_oa             ! Total # of simulated SOA vapors
      Integer, Save      :: n_oa_NotTracers  ! # of simulated SOA vapors that are not tracers
      Integer, Save      :: n_oa_tracers      ! # of simulated SOA vapors that are tracers

      Type oa_type
         Character( 16 ) :: name        ! Organic Aerosol Species Name
         Character( 16 ) :: gas_name    ! Condensable Vapor Species Name
         Character( 16 ) :: ctr_name    ! Reaction Counter Name
         Real            :: alpha       ! Mass-based stoichiometric coefficients [ug/m^3]/[ug/m^3]
         Real            :: cstar       ! Effective saturation concentrations [ug/m^3] at 298 K
         Real            :: enth        ! Enthalphy of Vaporization [J/mol]
         Real            :: otoc        ! O:C - Ratio of Oxygen and to Carbon
         Real            :: OMtoOC      ! OM:OC - Ratio of Total Organic Mass to Organic Carbon Mass
         Logical         :: primary     ! Flag identifying primary species
         Logical         :: anthro      ! Flag identifying anthropogenic species
         Logical         :: biog        ! Flag identifying biogenic species
         Logical         :: nonvol      ! Flag identifying nonvolatile species
      End Type oa_type

      Type( oa_type ), Allocatable, Save :: oaspc( : )

      Type( oa_type ), Save :: oa_list( n_oa_list ) = (/
      !                                                                                  ANTHROPOGENIC
      !                                                                                      | BIOGENIC
      !         PM          Vapor       Rxn Cntr     Alpha   CStar^    Enth-   O:C OM:OC     |   |   Nonvol-     
      !         Name        Name        Name*                           alpy             POA |   |   atile        
      !        ----------  ----------  ----------   ------  --------  -------  --- ----- --- --- --- ---    
     & oa_type('AALK1  ', 'SVALK1  ', 'ALKRXN  ',  0.0334,   0.1472,  53.0E3, .315,1.56, F,  T,  F,  F ),
     & oa_type('AALK2  ', 'SVALK2  ', 'ALKRXN  ',  0.2164,  51.8775,  53.0E3, .203,1.42, F,  T,  F,  F ),
     & oa_type('AXYL1  ', 'SVXYL1  ', 'XYLNRXN ',  0.0310,   1.3140,  32.0E3,1.002,2.42, F,  T,  F,  F ),
     & oa_type('AXYL2  ', 'SVXYL2  ', 'XYLNRXN ',  0.0900,  34.4830,  32.0E3, .611,1.93, F,  T,  F,  F ),
     & oa_type('ATOL1  ', 'SVTOL1  ', 'TOLNRXN ',  0.0580,   2.3260,  18.0E3, .875,2.26, F,  T,  F,  F ),
     & oa_type('ATOL2  ', 'SVTOL2  ', 'TOLNRXN ',  0.1130,  21.2770,  18.0E3, .523,1.82, F,  T,  F,  F ),
     & oa_type('ABNZ1  ', 'SVBNZ1  ', 'BNZNRXN ',  0.0720,   0.3020,  18.0E3,1.211,2.68, F,  T,  F,  F ),
     & oa_type('ABNZ2  ', 'SVBNZ2  ', 'BNZNRXN ',  0.8880, 111.1100,  18.0E3, .851,2.23, F,  T,  F,  F ),
     & oa_type('APAH1  ', 'SVPAH1  ', 'PAHNRXN ',  0.2100,   1.6598,  18.0E3, .371,1.63, F,  T,  F,  F ),
     & oa_type('APAH2  ', 'SVPAH2  ', 'PAHNRXN ',  1.0700, 264.6675,  18.0E3, .259,1.49, F,  T,  F,  F ),
     & oa_type('ATRP1  ', 'SVTRP1  ', 'TRPRXN  ',  0.1393,  14.7920,  40.0E3, .539,1.84, F,  F,  T,  F ),
     & oa_type('ATRP2  ', 'SVTRP2  ', 'TRPRXN  ',  0.4542, 133.7297,  40.0E3, .531,1.83, F,  F,  T,  F ),
     & oa_type('AMT1   ', 'SVMT1   ', 'TRPRXN  ',   0.040,    0.010, 102.0E3, .400,1.67, F,  F,  T,  F ),
     & oa_type('AMT2   ', 'SVMT2   ', 'TRPRXN  ',   0.032,    0.100,  91.0E3, .400,1.67, F,  F,  T,  F ),
     & oa_type('AMT3   ', 'SVMT3   ', 'TRPRXN  ',   0.032,    1.000,  80.0E3, .444,1.72, F,  F,  T,  F ),
     & oa_type('AMT4   ', 'SVMT4   ', 'TRPRXN  ',   0.103,   10.000,  69.0E3, .300,1.53, F,  F,  T,  F ),
     & oa_type('AMT5   ', 'SVMT5   ', 'TRPRXN  ',   0.143,  100.000,  58.0E3, .333,1.57, F,  F,  T,  F ),
     & oa_type('AMT6   ', 'SVMT6   ', 'TRPRXN  ',   0.285, 1000.000,  47.0E3, .200,1.40, F,  F,  T,  F ),
     & oa_type('AMT7   ', 'SVMT7   ', 'TRPRXN  ',   0.160,10000.000,  36.0E3, .222,1.43, F,  F,  T,  F ),
     & oa_type('AHOM   ', 'HOM     ', '        ',     0.0,  6.3E-03, 130.0E3, .700,2.08, F,  F,  T,  F ),
     & oa_type('AELHOM ', 'ELHOM   ', '        ',     0.0,  1.0E-05, 160.0E3, .400,1.67, F,  F,  T,  F ),
     & oa_type('AMTNO3 ', 'MTNO3   ', '        ',     0.0,     12.0,  40.0E3, .587,1.90, F,  F,  T,  F ),
     & oa_type('AISOPNN', 'ISOPNN  ', '        ',     0.0,     8.9,   40.0E3,2.107,3.80, F,  F,  T,  F ),
     & oa_type('AMTHYD ', '        ', '        ',     0.0,   1.E-10,   1.0E0, .299,1.54, F,  F,  T,  T ),
     & oa_type('AIETET ', '        ', '        ',     0.0,   1.E-10,   1.0E0, .883,2.27, F,  F,  T,  T ),
     & oa_type('AIEOS  ', '        ', '        ',     0.0,   1.E-10,   1.0E0,1.947,3.60, F,  F,  T,  T ),
     & oa_type('ADIM   ', '        ', '        ',     0.0,   1.E-10,   1.0E0, .723,2.07, F,  F,  T,  T ),
     & oa_type('AIMGA  ', '        ', '        ',     0.0,   1.E-10,   1.0E0,1.067,2.50, F,  F,  T,  T ),
     & oa_type('AIMOS  ', '        ', '        ',     0.0,   1.E-10,   1.0E0,2.403,4.17, F,  F,  T,  T ),
     & oa_type('AISO3NOS','        ','         ',     0.0,   1.e-10,   1.0E0,  0.8,2.27, F,  F,  T,  T ),
     & oa_type('AISO3OS ','        ','         ',     0.0,   1.e-10,   1.0E0,  1.4,3.60, F,  F,  T,  T ),
     & oa_type('AISO1  ', 'SVISO1  ', 'ISOPRXN ',  0.2320, 116.0100,  40.0E3, .827,2.20, F,  F,  T,  F ),
     & oa_type('AISO2  ', 'SVISO2  ', 'ISOPRXN ',  0.0288,   0.6170,  40.0E3, .851,2.23, F,  F,  T,  F ),
     & oa_type('AISO3  ', '        ', '        ',     0.0,   1.e-10,   1.0E0,1.307,2.80, F,  F,  T,  T ),
     & oa_type('ASQT   ', 'SVSQT   ', 'SESQRXN ',  1.5370,  24.9840,  40.0E3, .283,1.52, F,  F,  T,  F ),
     & oa_type('AGLY   ', '        ', '        ',     0.0,   1.E-10,   1.0E0, .771,2.13, F,  F,  F,  T ),
     & oa_type('AORGC  ', '        ', '        ',     0.0,   1.E-10,   1.0E0, .667,2.00, F,  F,  F,  T ),
     & oa_type('AXYL3  ', '        ', 'XYLHRXN ',  0.3600,   1.e-10,   1.0E0, .907,2.30, F,  T,  F,  T ),
     & oa_type('ATOL3  ', '        ', 'TOLHRXN ',  0.3000,   1.e-10,   1.0E0,1.227,2.70, F,  T,  F,  T ),
     & oa_type('ABNZ3  ', '        ', 'BNZHRXN ',  0.3700,   1.e-10,   1.0E0,1.467,3.00, F,  T,  F,  T ),
     & oa_type('APAH3  ', '        ', 'PAHHRXN ',  0.7300,   1.e-10,   1.0E0, .483,1.77, F,  T,  F,  T ),
     & oa_type('APOC   ', '        ', '        ',  0.0   ,   1.e-10,   1.0E0, .000,1.00, T,  T,  F,  T ),
     & oa_type('APNCOM ', '        ', '        ',  0.0   ,   1.e-10,   1.0E0, -1.0,-1.0, T,  T,  F,  T ),
     & oa_type('APCSO  ', 'LVPCSOG ', 'PCSOARXN',  1.0   ,   1.e-05,  40.0E3, .667,2.00, F,  T,  F,  F ),
     & oa_type('ALVPO1 ', 'VLVPO1  ', '        ',  0.0000,    1.e-1,  96.0E3, .185,1.39, T,  T,  F,  F ),
     & oa_type('ASVPO1 ', 'VSVPO1  ', '        ',  0.0000,    1.e+0,  85.0E3, .123,1.32, T,  T,  F,  F ),
     & oa_type('ASVPO2 ', 'VSVPO2  ', '        ',  0.0000,    1.e+1,  74.0E3, .073,1.26, T,  T,  F,  F ),
     & oa_type('ASVPO3 ', 'VSVPO3  ', '        ',  0.0000,    1.e+2,  63.0E3, .032,1.21, T,  T,  F,  F ),
     & oa_type('AIVPO1 ', 'VIVPO1  ', '        ',  0.0000,    1.e+3,  52.0E3, .000,1.17, T,  T,  F,  F ),
     & oa_type('ALVOO1 ', 'VLVOO1  ', '        ',  0.0000,    1.e-2, 107.0E3, .886,2.27, F,  T,  F,  F ),
     & oa_type('ALVOO2 ', 'VLVOO2  ', '        ',  0.0000,    1.e-1,  96.0E3, .711,2.06, F,  T,  F,  F ),
     & oa_type('ASVOO1 ', 'VSVOO1  ', '        ',  0.0000,    1.e+0,  85.0E3, .567,1.88, F,  T,  F,  F ),
     & oa_type('ASVOO2 ', 'VSVOO2  ', '        ',  0.0000,    1.e+1,  74.0E3, .447,1.73, F,  T,  F,  F ),
     & oa_type('ASVOO3 ', 'VSVOO3  ', '        ',  0.0000,    1.e+2,  63.0E3, .345,1.60, F,  T,  F,  F ),
     & oa_type('AAVB1  ', 'SVAVB1  ', '        ',  0.0000,    0.010,  18.0E3,1.227,2.70, F,  T,  F,  F ),
     & oa_type('AAVB2  ', 'SVAVB2  ', '        ',  0.0000,    1.000,  18.0E3, .947,2.35, F,  T,  F,  F ),
     & oa_type('AAVB3  ', 'SVAVB3  ', '        ',  0.0000,   10.000,  18.0E3, .803,2.17, F,  T,  F,  F ),
     & oa_type('AAVB4  ', 'SVAVB4  ', '        ',  0.0000,  100.000,  18.0E3, .659,1.99, F,  T,  F,  F ),
     & oa_type('AOLGA  ', '        ', '        ',  0.0000,   1.e-10,   1.0E0,1.067,2.50, F,  T,  F,  T ),
     & oa_type('AOLGB  ', '        ', '        ',  0.0000,   1.e-10,   1.0E0, .747,2.10, F,  F,  T,  T ),
     & oa_type('AOP3   ', 'OP3     ', '        ',  0.0000,    1.e+1,  81.0E3, .600,1.92, F,  T,  F,  F ),
     & oa_type('ASOAT  ', '        ', '        ',  0.0000,  1.0E-10,   1.0E0,0.857,2.31, F,  T,  F,  T ),
     & oa_type('AROCN2ALK','VROCN2ALK','        ', 0.0000,    1.e-2, 104.0E3, .000,1.39, T,  T,  F,  F ),
     & oa_type('AROCN1ALK','VROCN1ALK','        ', 0.0000,    1.e-1,  96.0E3, .000,1.32, T,  T,  F,  F ),
     & oa_type('AROCP0ALK','VROCP0ALK','        ', 0.0000,    1.e+0,  85.0E3, .000,1.17, T,  T,  F,  F ),
     & oa_type('AROCP1ALK','VROCP1ALK','        ', 0.0000,    1.e+1,  81.0E3, .000,1.17, T,  T,  F,  F ),
     & oa_type('AROCP2ALK','VROCP2ALK','        ', 0.0000,    1.e+2,  77.0E3, .000,1.17, T,  T,  F,  F ),
     & oa_type('AROCP3ALK','VROCP3ALK','        ', 0.0000,    1.e+3,  73.0E3, .000,1.17, T,  T,  F,  F ),
     & oa_type('AROCN2OXY2','VROCN2OXY2','        ',0.0000,   1.e-2,  93.0E3, .200,1.42, F,  T,  F,  F ),
     & oa_type('AROCN2OXY4','VROCN2OXY4','        ',0.0000,   1.e-2,  93.0E3, .400,1.67, F,  T,  F,  F ),
     & oa_type('AROCN2OXY8','VROCN2OXY8','        ',0.0000,   1.e-2,  93.0E3, .800,2.17, F,  T,  F,  F ),
     & oa_type('AROCN1OXY1','VROCN1OXY1','        ',0.0000,   1.e-1,  89.0E3, .100,1.29, F,  T,  F,  F ),
     & oa_type('AROCN1OXY3','VROCN1OXY3','        ',0.0000,   1.e-1,  89.0E3, .300,1.54, F,  T,  F,  F ),
     & oa_type('AROCN1OXY6','VROCN1OXY6','        ',0.0000,   1.e-1,  89.0E3, .600,1.92, F,  T,  F,  F ),
     & oa_type('AROCP0OXY2','VROCP0OXY2','        ',0.0000,   1.e+0,  85.0E3, .200,1.42, F,  T,  F,  F ),
     & oa_type('AROCP0OXY4','VROCP0OXY4','        ',0.0000,   1.e+0,  85.0E3, .400,1.67, F,  T,  F,  F ),
     & oa_type('AROCP1OXY1','VROCP1OXY1','        ',0.0000,   1.e+1,  81.0E3, .100,1.29, F,  T,  F,  F ),
     & oa_type('AROCP1OXY3','VROCP1OXY3','        ',0.0000,   1.e+1,  81.0E3, .300,1.54, F,  T,  F,  F ),
     & oa_type('AROCP2OXY2','VROCP2OXY2','        ',0.0000,   1.e+2,  77.0E3, .200,1.42, F,  T,  F,  F ),
     & oa_type('AROCP3OXY2','VROCP3OXY2','        ',0.0000,   1.e+3,  73.0E3, .200,1.42, F,  T,  F,  F ),
     & oa_type('ABENAPY', 'BENAPY  ', '        ',  0.0000,   0.0396, 105.0E3, .000,1.00, F,  T,  F,  F ),
     & oa_type('AISO4  ','         ','         ',     0.0,   1.e-10,   1.0E0,  1.2,2.80, F,  F,  T,  T ),
     & oa_type('AISO5  ','         ','         ',     0.0,   1.e-10,   1.0E0,  1.0,2.50, F,  F,  T,  T ),
     & oa_type('ATRPN  ','TRPN     ','         ',     0.0,   1410.0,  89.1E3, .400,1.79, F,  F,  T,  F ),
     & oa_type('AHONIT ','HONIT    ','         ',     0.0,   0.0413, 121.0E3, .700,2.21, F,  F,  T,  F ) /)
      ! Table Comments:
      ! *Reaction Counters are only needed if the vapor species is not formed
      !  directly in the gas-phase chemistry mechanism.
      ! ^Nonvolatile species are given a default C* of 1e-10 ug/m3 and
      !  enthalpy of vaporization equal to 1 kJ/mol.
      ! Cstar for BENAPY or benzo[a]pyrene was based on the DMSO partitioning
      ! coefficient in Shrivastave et al. (2017) PNAS, vol 114, 1246-1251. All
      ! OA corresponds to DMSO but its density corresponds to average density
      ! of CMAQ OA, 1.4 g/cm3

      ! Identify Species Required for Isoprene and Monoterpene Chemistry
      Character( 16 ), Private, Parameter :: req_sviso1  = 'SVISO1'
      Character( 16 ), Private, Parameter :: req_sviso2  = 'SVISO2'
      Character( 16 ), Private, Parameter :: req_aeiso1  = 'AISO1'
      Character( 16 ), Private, Parameter :: req_aeiso2  = 'AISO2'
      Character( 16 ), Private, Parameter :: req_aeiso3  = 'AISO3'
      Character( 16 ), Private, Parameter :: req_aeorgc  = 'AORGC'

      ! Variables for Carrying Indices of required species
      Integer :: iso1_idx
      Integer :: iso2_idx
      Integer :: aiso1_idx
      Integer :: aiso2_idx
      Integer :: aiso3_idx
      Integer :: aorgc_idx

      ! Variables for saving properties and concentrations of organic
      ! compounds
      !   Molecular Weights
          Real, Allocatable    :: op_mw    ( : )   ! PM species
          Real, Allocatable    :: og_mw    ( : )   ! Vapor Species
          Real, Allocatable    :: rog_mw   ( : )   ! Precursor Species
                                                   ! that are linked to yields
      !   Concentrations
          Real, Allocatable    :: og_conc  ( : )   ! Vapors
          Real, Allocatable    :: rog_dconc( : )   ! Reaction counters

      ! Variables for mapping OA to aerosol and CGRID arrays
      Integer, Allocatable :: map_OAtoAERO( : )    ! organic aerosol pointers to aerospc
      Integer, Allocatable :: map_AEROtoOA( : )    ! aerospc map to organic aerosol table
      Integer, Allocatable :: map_OAtoCGRID( : )   ! organic aerosol pointers to CGRID
      Integer, Allocatable :: map_OGtoCGRID( : )   ! pointers of vapor species to CGRID
      Integer, Allocatable :: map_ROGtoCGRID( : )  ! pointers of SOA parent species to CGRID
      Integer, Allocatable :: map_OAtoDEPV( : )    ! organic aerosol pointers to DEPV
      Logical, Allocatable :: lnonvol_oa( : )      ! flag identifying non-volatile OA species 
                                                   ! in aerosol array that are not tracers
      Logical, Allocatable :: l_oa( : )            ! flag identifying OA species 
                                                   ! that are not tracers
      ! Variables for controlling behavior of OA module
      Logical, Private, Save :: mapped              = .False.
      Logical, Private, Save :: RXNS_eflag          = .False. ! error flag for RXNS modules used
      Character( 16 ), Private, Save :: pname = 'SOA_DEFN        '

      ! Indices for specifying groups of organics to sum for output
      INTEGER, PARAMETER :: IOA_ALL = 0, IOA_PRI = 1, IOA_SEC = 2,
     &                                   IOA_ANTSEC = 3, IOA_BIOSEC = 4
      
      Contains

      subroutine map_org_mask( org_mask_in, org_mask )

      integer org_mask_in
      logical org_mask( n_oa )

      ! Map ORG_MASK_IN input parameter to a Mask of Organic Aerosol
      ! Variables
      SELECT CASE ( ORG_MASK_IN )
         CASE( IOA_ALL )
            ! All OA
            ORG_MASK = .TRUE.
         CASE( IOA_PRI )
            ! Total Primary
            ORG_MASK = OASPC(:)%PRIMARY
         CASE( IOA_SEC )
            ! Total Secondary
            ORG_MASK = .NOT. OASPC(:)%PRIMARY
         CASE( IOA_ANTSEC )
            ! Anthropogenic Secondary
            ORG_MASK = OASPC(:)%ANTHRO .AND. .NOT. OASPC(:)%PRIMARY
         CASE( IOA_BIOSEC )
            ! Biogenic Secondary
            ORG_MASK = OASPC(:)%BIOG .AND. .NOT. OASPC(:)%PRIMARY
         CASE DEFAULT
            ! No OA
            ORG_MASK = .FALSE.
      END SELECT

      end subroutine map_org_mask


C-----------------------------------------------------------------------
      subroutine map_oa( )
C  Maps all vectors and tables for organic aerosol calculations
C-----------------------------------------------------------------------

      Use rxns_data, only: mechname
      Use aero_data, only: findAero, aerospc_mw, n_aerospc, aerospc,
     &                     npfas, MAP_PFAStoGAS, PFASGAS_CONC
      Use const, only: inv_mwair
      Use cgrid_spcs, only: n_gc_spc, gc_spc, n_gc_g2ae, gc_g2ae, gc_strt, gc_molwt, gc_g2ae_map, 
     &                      n_nr_spc, nr_spc, n_nr_n2ae, nr_n2ae, nr_strt, nr_molwt, nr_n2ae_map,
     &                      n_ae_spc, ae_spc, cgrid_mw
      Use runtime_vars, only: logdev, log_subheading, log_heading
      Use utilio_defn, only: index1, xstat3, m3exit

      Implicit None

      ! Local Variables:
      Character( 300 ):: xmsg
      Real            :: gasconv
      Real            :: vtmp
      Integer         :: n, a, g
      Integer         :: spc, iaer
      Integer         :: map_OAtoOAlist( 200 )

      ! Map All OA Species and Load Properties
          
          call log_heading( logdev, 'Initialize OA Extraction to Aerosol Module')
          call log_subheading( logdev, 'Map Organic Aerosol and Vapor Species')

          ! First, the number and names of present and nontracer OA species must be
          ! determined by checking the AEROSOL Table with the species names
          ! available from the OA_LIST table. 
          n_oa = 0
          Do spc = 1,n_oa_list
             n = findAero( oa_list( spc )%name, .False. )
             If ( n .Gt. 0 ) Then
               If ( aerospc( n )%om .And. .Not. aerospc( n )%tracer ) Then
                  n_oa = n_oa + 1
                  map_OAtoOAlist( n_oa ) = spc
               End If
             End If
          End Do

          ! Place tracers at the end of the list map
          n_oa_tracers = 0
          Do spc = 1,n_oa_list
             n = findAero( oa_list( spc )%name, .False. )
             If ( n .Gt. 0 ) Then
               If ( aerospc( n )%om .And. aerospc( n )%tracer ) Then
                  n_oa = n_oa + 1
                  n_oa_tracers = n_oa_tracers + 1
                  map_OAtoOAlist( n_oa ) = spc
               End If
             End If
          End Do
          
          If ( n_oa .Eq. n_oa_tracers ) Then
              xmsg =  'FATAL: All SOA species are tracers at least '
     &            //  'one SOA species must not be a tracer.'
              write(logdev,'(a)')Trim( xmsg )           
          End If
          
          n_oa_NotTracers = n_oa - n_oa_tracers

          ! Allocate the OA property and mapping variables now that the
          ! number of active OA species has been determined.
          Allocate ( oaspc  ( n_oa ))
          Allocate ( op_mw  ( n_oa ))
          Allocate ( og_mw  ( n_oa ))
          Allocate ( rog_mw ( n_oa ))
          Allocate ( og_conc( n_oa ))
          Allocate ( rog_dconc( n_oa ))
          Allocate ( map_ROGtoCGRID( n_oa ))
          Allocate ( map_OAtoAERO( n_oa ))
          Allocate ( map_AEROtoOA( n_aerospc ))
          Allocate ( map_OGtoCGRID( n_oa ))
          Allocate ( lnonvol_oa( n_aerospc ))
          Allocate ( l_oa( n_aerospc ))

#ifdef sens
          Allocate ( og_sens( n_oa,npmax ) )
          Allocate ( rog_dsens( n_oa,npmax ) )
#endif

          ! Initialize and populate key OA variables
          map_OAtoAERO = 0
          map_AEROtoOA = 0
          op_mw = 200.0
          lnonvol_oa = .false.
          l_oa       = .false.
          Do spc = 1,n_oa
             oaspc( spc ) = oa_list( map_OAtoOAlist( spc ) )
             iaer = findAero( oaspc( spc )%name, .False. )
             If ( iaer .gt. 0 ) then
                map_OAtoAERO( spc ) = iaer
                map_AEROtoOA( iaer ) = spc
                l_oa( iaer ) = ( aerospc(iaer)%om .and. .Not. aerospc(iaer)%tracer )
                op_mw( spc ) = aerospc_mw( iaer )
                lnonvol_oa( iaer ) = ( oaspc( spc )%nonvol .and.
     &                                 .Not. aerospc( iaer )%tracer )
             else 
                write(logdev,99904) Trim( oaspc( spc )%name )
                op_mw( spc ) = 0.0
             end if
          End Do

          ! Determine the location of any reaction counter species on the 
          ! GC Namelist. When a match is found, populate the properties
          ! of that counter species.
          map_ROGtoCGRID = 0
          ROG_mw = 200.0
          Do spc = 1, n_oa
            If( oaspc( spc )%ctr_name == '' ) Cycle
            g = index1( oaspc( spc )%ctr_name, n_gc_spc, gc_spc )
            if ( g .ge. 1 ) then
              ! Populate Mapping Vector for the Precursor Species
              map_ROGtoCGRID( spc ) = gc_strt - 1 + g
              ROG_mw( spc ) = gc_molwt( g )
            else
              ! Log an Error and Halt the model
              write(logdev,99903) Trim( oaspc( spc )%ctr_name ),
     &                            Trim( oaspc( spc )%gas_name )
              call m3exit( pname, 0, 0, 'Please add this critical ' //
     &                      'species to your mechanism', xstat3 )
            End If
         End Do

         ! Determine the location on CGRID of condensable gases in 
         ! equilibrium with OA particle species. When a match is found, 
         ! populate the properties of those gas species.
         map_OGtoCGRID = 0
         og_mw = 200.0 ! Default Molecular Weight for all Organic Vapor Species
         Do spc = 1,n_oa
           If( oaspc( spc )%gas_name == '' ) Cycle

           n = index1( oaspc( spc )%gas_name, n_nr_spc, nr_spc )
           If ( n .ge. 1 ) Then
               map_OGtoCGRID( spc ) = nr_strt - 1 + n
               og_mw( spc ) = nr_molwt( n )
           End If

           g = index1( oaspc( spc )%gas_name, n_gc_spc, gc_spc )
           If ( g .ge. 1 ) Then
               map_OGtoCGRID( spc ) = gc_strt - 1 + g
               og_mw( spc ) = gc_molwt( g )
           End If

           If( n .lt. 1 .and. g .lt. 1 ) Then
               write(logdev,99902) Trim( oaspc( spc )%gas_name ), 
     &                             Trim ( oaspc( spc )%name )
               call m3exit( pname, 0, 0, 'Please add these critical ' //
     &                      'species to your mechanism', xstat3 )
           End If
         End Do

         ! Find indices of required species based on mechname
         If( index( mechname,'CRACMM2' ) .eq. 0 
     &          .and. index( mechname,'CRACMM3') .eq. 0 ) then
             iso1_idx   = findVapor( req_sviso1, .True. )
             iso2_idx   = findVapor( req_sviso2, .True. )
             aiso1_idx  = findAero( req_aeiso1, .True. )
             aiso2_idx  = findAero( req_aeiso2, .True. )
             aiso3_idx  = findAero( req_aeiso3, .True. )
         Else
             iso1_idx   = findVapor( req_sviso1, .False. )
             iso2_idx   = findVapor( req_sviso2, .False. )
             aiso1_idx  = findAero( req_aeiso1, .False. )
             aiso2_idx  = findAero( req_aeiso2, .False. )
             aiso3_idx  = findAero( req_aeiso3, .False. )
         End If

         aorgc_idx  = findAero( req_aeorgc, .True. )

      mapped   = .TRUE.

      return

99902 Format('FATAL: SOA Vapor, ', a, 
     &       ', is not found among the species in '
     &     / 'the NR or GC namelist used. Required for modeling ', a / )
99903 Format( 'FATAL: SOA Reaction Counter, ', a,  
     &        '. is not found among the species',
     &     / 'in GC namelist used. Required for modeling vapor, ', 
     &       a / )
99904 Format(1X,'aerosol product from namelist species: ', a /)
  
      end subroutine map_oa

C-----------------------------------------------------------------------
#ifdef sens
      Subroutine extract_soa( conc, s_conc, schk )
#else
      Subroutine extract_soa( conc )
#endif

C  Extracts the required soa data from CGRID into the conc array.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SH  03/10/11 Renamed met_data to aeromet_data
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C HP  09/27/14 alk_factor removed, updated for alkane/PAH SOA.
C              Conversion of reacted alkane to dodecane equivalent
C              is handled in mech.def. A factor of 0.47 is in use and
C              reflects the fact that alkane SOA precursor
C              emissions are dominated by compounds smaller than dodecane.
C BM  02/19/19 Major Revision to simplify the mapping procedure and
C              remove redundat variables.
C-----------------------------------------------------------------------

      Use aero_data, only: aerospc_mw, npfas, MAP_PFAStoGAS, PFASGAS_CONC
      Use aeromet_data, only: airdens, min_gasconc
      Use const, only: inv_mwair
      Use cgrid_spcs, only:   cgrid_mw

      Implicit None

      ! Arguments:
      Real, Intent( In ) :: conc( : )
#ifdef sens
      Real, Intent( In ) :: s_conc( :,: )
      Logical, Intent( In ) :: schk  ! necessary because some routines don't require sensitivity updates
#endif

      ! Local Variables:
      Real            :: gasconv
      Real            :: vtmp
      Integer         :: n
      Integer         :: spc

#ifdef sens
      If ( .Not. ae_ddm3d_ready ) Then
         Call init_aero_ddm3d()
      End If
#endif

      ! Copy grid cell concentrations of vapor species
      og_conc   = 0.0
      rog_dconc = 0.0
      gasconv = airdens * inv_mwair ! Compute gas conversion constant
#ifdef sens      
      og_sens   = 0.0
      rog_dsens = 0.0
#endif

      Do spc = 1, n_oa
         n = map_OGtoCGRID( spc )
         If ( n .Ne. 0 ) Then
            vtmp = gasconv * og_mw( spc )
            og_conc( spc ) = Max( conc( n ) * vtmp, min_gasconc )
#ifdef sens 
            If (schk ) Then
               Do np = 1, npmax
                  If ( og_conc( spc ) .eq. min_gasconc ) Then
                     og_sens( spc,np ) = 0.0
                  Else
                     og_sens( spc,np ) = s_conc( np,n ) * vtmp
                  Endif
               End Do
            End If
#endif
         End If
         
         n = map_ROGtoCGRID( spc )
         If ( n .Ne. 0 ) Then
            rog_dconc( spc ) = Max( conc( n ), min_gasconc )
#ifdef sens 
            If (schk ) Then
               Do np = 1, npmax
                  If ( rog_dconc( spc ) .eq. min_gasconc ) Then
                     rog_dsens( spc,np ) = 0.0
                  Else
                     rog_dsens( spc,np ) = s_conc( np,n )
                  Endif
               End Do
            End If
#endif
         End If
      End Do

      ! Copy PFAS Gas-Phase Compounds to Local Array
      pfasgas_conc = 0.0
      Do spc = 1,npfas
         n = map_PFAStoGAS( spc )
         if ( n.Ne. 0 ) then
            vtmp = gasconv * cgrid_mw( n )
            pfasgas_conc( spc ) = Max( conc( n ) * vtmp, min_gasconc )
         End If
      End Do

99902 Format('FATAL: SOA Vapor, ', a, 
     &       ', is not found among the species in '
     &     / 'the NR or GC namelist used. Required for modeling ', a / )
99903 Format( 'FATAL: SOA Reaction Counter, ', a,  
     &        '. is not found among the species',
     &     / 'in GC namelist used. Required for modeling vapor, ', 
     &       a / )
99904 Format(1X,'aerosol product from namelist species: ', a /)
  
      Return
      End Subroutine extract_soa

C-----------------------------------------------------------------------
#ifdef sens
      Subroutine update_orgvapor( conc, s_conc )
#else
      Subroutine update_orgvapor( conc )
#endif

C  Populates CGRID from the conc array with updated SOA values.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SH  03/10/11 Renamed met_data to aeromet_data
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------

      Use aero_data, only : cond_budget, npf_budget, npfas, 
     &                      map_PFAStoGAS, PFASGAS_CONC
      Use aeromet_data, only: airdens, min_gasconc
      Use const, only: inv_mwair
      Use utilio_defn, only : xstat3, m3exit
      Use cgrid_spcs, only  : cgrid_mw

      Implicit None

      ! Arguments:
      Real, Intent( Out ) :: conc( : )
#ifdef sens
      Real, Intent( Out ) :: s_conc( :,: )
#endif

      ! Local Variables:
      Character( 80 ) :: xmsg
      Real            :: gasconv
      Real            :: vtmp
      Integer         :: n
      Integer         :: spc

      If ( .Not. mapped ) Then
         xmsg = 'CGRID Species has not been mapped'
         Call m3exit( pname, 0, 0, xmsg, xstat3 )
      End If

      ! Compute gas conversion constant
      gasconv = airdens * inv_mwair

      ! Copy og_conc back to grid cell concentrations
      Do spc = 1, n_oa
         n = map_OGtoCGRID( spc )
         If ( n .Ne. 0 ) Then
            vtmp = og_mw( spc ) * gasconv
            conc( n ) = Max ( og_conc( spc ) / vtmp, min_gasconc )
#ifdef sens
            Do np = 1, npmax
               If ( conc( n ) .Eq. min_gasconc ) Then
                  s_conc( np,n ) = 0.0
               Else
                  s_conc( np,n ) = og_sens( spc,np ) / vtmp
               End If
            End Do
#endif
                  
            ! Convert Budget Process Numbers from ug m-3 to ppmv
            ! for application to process analysis and ISAM
            COND_BUDGET( n )   = COND_BUDGET( n )   / vtmp
            NPF_BUDGET( n )    = NPF_BUDGET( n )    / vtmp
         End If
      End Do
      
      ! Copy PFAS compounds back to grid cell concentrations
      Do spc = 1, npfas
         n = map_PFAStoGAS( spc )
         If ( n .Ne. 0 ) Then
            vtmp = cgrid_mw( n ) * gasconv
            conc( n ) = Max ( pfasgas_conc( spc ) / vtmp, min_gasconc )
         End If
      End Do

      Return
      End Subroutine update_orgvapor

C-----------------------------------------------------------------------
      Function findVapor( vname, required ) Result ( ndx )

C  Finds the index of 'required' semivolatile species in the oaspc list

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------
      Use RUNTIME_VARS, only : logdev
      Use utilio_defn

      Implicit None

      ! Arguments:
      Character( 16 ) :: vname
      Integer ndx
      Logical required

      ! Local Variables:
      Character( 80 ) :: xmsg
      Integer         :: spc

      ndx = 0
      Do spc = 1, n_oa
         If ( oaspc( spc )%gas_name .Eq. vname ) Then
            ndx = spc
            xmsg = 'Optional Species '
     &             // Trim( vname ) // 
     &             ' is found in the G2AE or N2AE values of GC or NR namelists.'
         write(logdev,'(5x,a)') xmsg
            Return
         End If
      End Do

      If ( .Not. required ) Return

      ! This warning should not be encountered since the OA table
      ! already includes these gas-phase counterparts or precursors 
      ! that are mapped to CGRID.
      xmsg = 'FATAL:' // Trim( vname )
     &  // ' is not found in the G2AE or N2AE values of GC or NR namelists.'
      Call m3warn( pname, 0, 0, xmsg )
 

      Return
      End Function findVapor

C-----------------------------------------------------------------------
      Subroutine orgaer( dt, layer )

C Updates CGRID via several pathways for secondary organic aerosol (SOA)
C formation, as recommended by Edney et al. (2007).  These include SOA
C formation from isoprene, monoterpenes, sesquiterpenes, long alkanes, and
C aromatics (incl. benzene).

C Input includes the concentrations of reactive organic gases (ROG)
C that were oxidized during the time step (ORGPROD), the vapor-phase
C concentration of each semi-volatile organic compound, the
C concentration of each SOA species, and the concentration of primary
C organic aerosol (all concentrations are stored in the CBLK array).
C Output includes updated concentrations of SOA species, vapor-phase
C semi-volatile organic compounds, and moments of the accumulation
C mode.  The geometric mean diameter of the accumulation mode is also
C updated.  All SOA formation is restricted to the accumulation mode.

C This code relies on 12 counter species to be incorporated in the
C gas-phase chemical mechanisms to track the amounts of individual
C ROG that reacted during the current time step (i.e., NPREC=10).
C The arrays of length = NPREC include:
C       (1) "long" alkanes  (ALKRXN)
C       (2) low-yield aromatics, high-NOx pathway (XYLNRXN)
C       (3) low-yield aromatics, low-NOx pathway (XYLHRXN)
C       (4) high-yield aromatics, high-NOx pathway (TOLNRXN)
C       (5) high-yield aromatics, low-NOx pathway (TOLHRXN)
C       (6) benzene, high-NOx pathway (BNZNRXN)
C       (7) benzene, low-NOx pathway (BNZHRXN)
C       (8) monoterpenes (TRPRXN)
C       (9) isoprene (ISOPRXN)
C      (10) sesquiterpenes (SESQRXN)
C      (11) PAHs/naphthalene, high-NOx pathway (PAHNRXN)
C      (12) PAHs/naphthalene, low-NOx pathway (PAHHRXN)

C In total, 15 organic species are allowed to partition between the
C vapor and particulate phases (i.e., NCVAP=12). The arrays of
C length = NCVAP include:
C           alkane (2 semi-volatile products)
C           low-yield aromatics, high-NOx pathway (2 products)
C           high-yield aromatics, high-NOx pathway (2 products)
C           benzene, high-NOx pathway (2 products)
C           monoterpenes (2 products)
C           isoprene (2 products)
C           sesquiterpenes (1 product)
C           PAHs/naphthalene, high-NOx pathway (2 products)

C Equilibrium partitioning calculations are based on the absorptive
C partitioning model of Pankow (1994) that was extended by Odum et
C al. (1996).  Saturation vapor pressures (cstar) and mass-based
C stoichiometric yield coefficients (alpha) are obtained from smog-
C chamber studies.  Saturation vapor pressures are modified as a
C function of temperature using eqn 6 of Sheehan & Bowman (2001).

C If the pre-existing organic aerosol concentration is zero,
C gas/particle equilibrium is established only after the organic gas
C concentration reaches the threshold value defined in eqn 9 of
C Schell et al. (2001).  Until this threshold value is reached,
C organic vapors do not partition to the particle phase.  Once the
C organic gas/particle equilibrium has been established, gas and
C particle-phase concentrations of each condensible species are
C calculated iteratively using a globally convergent variation of
C Newtons method (SUBROUTINE NEWT), as described in eqn 8 of Schell
C et al. (2001).

C In addition to the various pathways of semi-volatile SOA formation
C treated in previous versions of the model, four types of non-
C volatile SOA are considered here:
C   (1) aromatic and PAH-derived SOA under low-NOx conditions
C   (2) oligomerization of all particle-phase semi-volatile material
C   (3) SOA formed by in-cloud oxidation  (SUBROUTINE AQCHEM)
C   (4) isoprene IEPOX-derived SOA under acidic conditions (AEROSOL_CHEMISTRY)

C Previous code revision history:
C   Originally coded August 1, 2001 by Dr. Francis S. Binkowski

C   Revised April 4, 2003 by Gerald Gipson to allow for evaporation
C   of organics from aerosols. Now total vapor + aerosol phase is
C   repartitioned at each time step and totorgnv ( Mo ) does not
C   include oldsoa.

C   Revised July 14, 2003 by Dr. Prakash V. Bhave
C   - changed cstar(2,3) from 10.103 & 90.925 to 111.11 & 1000.0
C     because smog chamber data of Kalberer et al. were collected
C     at 298 K (not 310 K, as was previously assumed)
C   - changed mw_vap(9,10) from 184 g/mol to 177 g/mol, to be
C     consistent with mwsoa_b
C   - modified threshold criteria for establishing gas/particle
C     equilibrium by removing the loose criterion involving "mtot"
C   - changed variable names to reflect that the combined vapor +
C     aerosol concentrations are now being repartitioned during
C     each time step (not just the newly formed SVOC's)
C   - added documentation and removed extraneous lines of code

C   Revised December 4, 2003 by Dr. Francis S. Binkowski
C   - output variables ORGRATE and ORGBRATE removed and replaced
C     by SOA_A and SOA_B, the newly equilibrated values of
C     Anthropogenic and Biogenic SOA, respectively.  These are non-
C     negative values.
C   - variable jj also removed

C   Revised January 8, 2004 by Dr. Prakash V. Bhave
C   - removed the output variable YIELD.  It has no physical meaning
C     after the 12/04/2003 revisions.

C   Revised January 12, 2004 by Dr. Chris G. Nolte
C   - for computational efficiency, modified the initial caer guess
C     used as input to NEWT.  If NEWT returns check .eq. true, then
C     NEWT is called again with a guess of caer = 0.5*ctot
C   - removed ITS parameter from NEWT call vector
C   - fixed bug where concentrations less than TOLMIN (i.e., 1.0E-12)
C     were reset to 1.0e-30
C   - removed extraneous code related to "Pandis method" of SVOC
C     partitioning when threshold criterion is not met (i.e.,
C     insufficient organic matter to establish gas/particle
C     equilibrium)  ** results unaffected by this change
C
C   Revised September 7, 2007 by Dr. Sergey L. Napelenok
C   - Replaced old SOA species (SOA_A, SOA_B) with an array of
C     precursor-specific SOA species.  Replaced OLDSOA_A and OLDSOA_B
C     with an array (OLDSOA).  Updated call vector accordingly.
C   - Deleted nole* and nbio* variables (now obsolete)
C   - Increased the dimension of several arrays to accommodate new
C     SOA precursors (benzene, sesquiterpenes) and pathways (low-NOx,
C     acid-catalyzed, oligomers, in-cloud)
C
C   Revised November 29, 2007 by Dr. Prakash V. Bhave
C   - Renamed subroutine from ORGAER3 to ORGAER5
C   - Modified M2 and M3 calculations to account for the updated
C     definition of DRY aerosol (which now includes non-volatile SOA)
C   - Updated Hvap and corresponding cstar values
C   - Added parameters for SOA from isoprene and sesquiterpenes
C   - Updated aromatic SOA scheme to include semi-volatile and non-
C     volatile products that form under high-NOx and low-NOx
C     conditions, respectively
C   - Added oligomerization process
C   - Added enhancement of isoprene SOA under acidic conditions
C
C   Revised June 2, 2008 by Dr. Prakash V. Bhave
C   - Changed h_vap of benzene SOA to match that of toluene SOA, based
C     on consultation with Dr. Ed Edney and Dr. Tad Kleindienst.

C   Revised June 5, 2008 by Drs. Prakash Bhave and Sergey Napelenok
C   - Simplified the code for conserving low-volatility isoprene
C     oxidation products and removed a minor bug in the acid-induced
C     isoprene SOA calculation.
C
C   Revised September 9, 2008 by Dr. Prakash V. Bhave
C   - Increased alpha values for SV_TRP1, SV_TRP2, and SV_SQT by a
C     factor of 1.3 to correct for the implicit assumption of unit
C     density in those SOA yield parameters.
C   - Reduced SOA/SOC ratio of AISO1 and AISO2 from 2.5 to 1.6, and
C     increased SOA/SOC ratio of AISO3 from 2.5 to 2.7.  Accordingly,
C     the molar masses of AISO1 and AISO2 were decreased to 96 g/mol
C     and the molar mass of AISO3 was increased to 162.
C
C   Revised September 26, 2014 by Dr. Havala Pye
C   - Removed previous acid enhanced isoprene SOA. Acid catalyzed
C     isoprene SOA now follows Pye et al. 2013 ES&T uptake of IEPOX.
C     See AEROSOL_CHEMISTRY and mech.def for IEPOX SOA.
C   - Allowed for alternate method to NEWT for solving partitioning
C     equations

C References:
C   1. Edney, E.O., T.E. Kleindienst, M. Lewandowski, and J.H.
C      Offenberg, Updated SOA chemical mechanism for the Community
C      Multi-Scale Air Quality model, EPA 600/X-07/025, U.S. EPA,
C      Research Triangle Park, NC, 2007.

C   2. Pankow, J. F., An absorption model of gas/particle partitioning
C      of organic compounds in the atmosphere, Atmos. Environ., Vol 28,
C      No 2, 185-188, 1994.

C   3. Odum, J. R., T. Hoffmann, F. Bowman, D. Collins, R. C. Flagan,
C      and J. H. Seinfeld, Gas/particle partitioning and secondary
C      organic aerosol yields, Environ. Sci. Technol., Vol 30, No 8,
C      2580-2585, 1996.

C   4. Sheehan, P. E. and F. M. Bowman, Estimated effects of temperature
C      on secondary organic aerosol concentrations, Environ. Sci.
C      Technol., Vol 35, No 11, 2129-2135, 2001.

C   5. Schell, B., I. J. Ackermann, H. Hass, F. S. Binkowski, and
C      A. Abel, Modeling the formation of secondary organic aerosol
C      within a comprehensive air quality modeling system, J. Geophys.
C      Res., Vol 106, No D22, 28275-28293, 2001.

C   6. Strader, R., F. Lurmann, and S. N. Pandis, Evaluation of
C      secondary organic aerosol formation in winter, Atmos. Environ.,
C      Vol 33, 4849-4863, 1999.

C   7. Ng, N. L., J. H. Kroll, A. W. H. Chan, P. S. Chhabra, R. C.
C      Flagan, and J. H. Seinfeld, Secondary organic aerosol formation
C      from m-xylene, toluene, and benzene, Atmos. Chem. Phys., Vol 7,
C      3909-3922, 2007a.

C   8. Griffin, R. J., D. R. Cocker III, R. C. Flagan, and J. H.
C      Seinfeld, Organic aerosol formation from the oxidation of
C      biogenic hydrocarbons, J. Geophys. Res., Vol 104, No D3,
C      3555-3567, 1999.

C   9. Bian, F. and F. M. Bowman, Theoretical method for lumping
C      multicomponent secondary organic aerosol mixtures, Environ.
C      Sci. Technol., Vol 36, No 11, 2491-2497, 2002.

C  10. Offenberg, J. H., T. E. Kleindienst, M. Jaoui, M. Lewandowski,
C      and E. O. Edney, Thermal properties of secondary organic
C      aerosols, Geophys. Res. Lett., Vol 33, L03816, doi:10.1029/
C      2005GL024623, 2006.

C  11. Bahreini, R., M. D. Keywood, N. L. Ng, V. Varutbangkul, S. Gao,
C      R. C. Flagan, J. H. Seinfeld, D. R. Worsnop, and J. L. Jimenez,
C      Measurements of secondary organic aerosol from oxidation of
C      cycloalkenes, terpenes, and m-xylene using an Aerodyne aerosol
C      mass spectrometer, Environ. Sci. Technol., Vol 39, 5674-5688,
C      2005.

C  12. Alfarra, M. R., D. Paulsen, M. Gysel, A. A. Gaforth, J. Dommen,
C      A. S. H. Prevot, D. R. Worsnop, U. Baltensperger, and H. Coe,
C      A mass spectrometric study of secondary organic aerosols formed
C      from the photooxidation of anthropogenic and biogenic precursors
C      in a reaction chamber, Atmos. Chem. Phys., Vol 6, 5279-5293,
C      2006.

C  13. Ng, N. L., P. S. Chhabra, A. W. H. Chan, J. D. Surratt, J. H.
C      Kroll, A. J. Kwan, D. C. McCabe, P. O. Wennberg, A. Sorooshian,
C      S. M. Murphy, N. F. Dalleska, R. C. Flagan, and J. H. Seinfeld,
C      Effect of NOx level on secondary organic aerosol (SOA) formation
C      from the photooxidation of terpenes, Atmos. Chem. Phys., Vol 7,
C      5159-5174, 2007b.

C  14. Kostenidou, E., R. K. Pathak, and S. N. Pandis, An algorithm for
C      the calculation of secondary organic aerosol density combining
C      AMS and SMPS data, Aerosol Sci. Technol., Vol 41, 1002-1010,
C      2007.

C  15. Offenberg, J. H., C. W. Lewis, M. Lewandowski, M. Jaoui, T. E.
C      Kleindienst, and E. O. Edney, Contributions of toluene and
C      alpha-pinene to SOA formed in an irradiated toluene/alpha-pinene/
C      NOx/air mixture: comparison of results using 14C content and SOA
C      organic tracer methods, Environ. Sci. Technol., Vol 41, 3972-
C      3976, 2007.

C  16. Henze, D. K. and J. H. Seinfeld, Global secondary organic aerosol
C      from isoprene oxidation, Geophys. Res. Lett., Vol 33, L09812,
C      doi:10.1029/2006GL025976, 2006.

C  17. Kleindienst, T. E., M. Jaoui, M. Lewandowski, J. H. Offenberg,
C      C. W. Lewis, P. V. Bhave, and E. O. Edney, Estimates of the
C      contributions of biogenic and anthropogenic hydrocarbons to
C      secondary organic aerosol at a southeastern US location, Atmos.
C      Environ., Vol 41, 8288-8300, 2007.

C  18. Kalberer, M., D. Paulsen, M. Sax, M. Steinbacher, J. Dommen,
C      A. S. H. Prevot, R. Fisseha, E. Weingartner, V. Frankevich,
C      R. Zenobi, and U. Baltensperger, Identification of polymers as
C      major components of atmospheric organic aerosols, Science, Vol
C      303, 1659-1662, 2004.

C  19. Turpin, B. J. and H.-J. Lim, Species contributions to PM2.5 mass
C      concentrations: revisiting common assumptions for estimating
C      organic mass, Aero. Sci. Technol., Vol 35, 602-610, 2001.

C  20. Surratt, J. D., M. Lewandowski, J. H. Offenberg, M. Jaoui, T. E.
C      Kleindienst, E. O. Edney, and J. H. Seinfeld, Effect of acidity
C      on secondary organic aerosol formation from isoprene, Environ.
C      Sci. Technol., Vol 41, 5363-5369, 2007.

C  21. Pye et al., Epoxide pathways improve model prediction of isoprene
C      markers and reveal key role of acidity in aerosol formation,
C      Environ. Sci. Technol., 2013.


C Revision History:
C    First orgaer version was coded in April 2010 by Steve Howard with
C    Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SH  03/10/11 Renamed met_data to aeromet_data
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C HOTP 05Aug15 Made the calculation for total number of organic moles more robust
C BNM 11/09/15 Added Some Comments to the SOA Scheme
C HOTP 7/17/18 Added uptake of water onto hydrophillic organics
C-----------------------------------------------------------------------

C Key Subroutines/Functions called:  newt, soabisection

      Use aero_data
      Use aeromet_data
      Use const
      Use utilio_defn

      Implicit None

      ! Arguments:
      Real    :: dt            ! Synchronization time step [ s ]
      Integer :: layer         ! model layer number


      ! Local variables:
      Logical, Save :: first_time     = .True.
      Logical, Save :: solve_orgmoles = .True.
      
      Character( 300 ) :: xmsg
      Integer       :: i, im, indx, ispc, n, nsvol
      Integer, Save :: nsvol_tracers
      Integer, Save :: nsvol_Nottracers
      
      Real, Allocatable, Save ::  mw_inv( : )     ! Inverse MW of SVOCs [ mol/g ]

      Real, Allocatable, Save ::  rog_ppm2ug( : ) ! [ ppm per ug/m3 ] for ORGPROD at
                                        ! reference temperature and pressure

      ! Parameters & variables for adjusting cstar to ambient conditions
      Real, Parameter :: tref   = 298.0          ! reference temperature [ K ]
      Real, Parameter :: trefm1 = 1.0 / tref     ! inverse of reference temperature
      Real, Parameter :: prefm1 = 1.0 / stdatmpa ! inverse of reference pressure
      Real, Parameter :: rgas1  = 1.0 / rgasuniv ! reciprocal of universal gas constant
      Real, Parameter :: kolig  = 0.69314718 / 72000.0  ! 20h half-life of oligomerization rate [ 1/s ]
      Real, Parameter :: olgrat = 2.1            ! SOA/SOC ratio for oligomers
      Real, Parameter :: kacid  = 0.00361        ! acid-induced enhancement factor
      Real, Parameter :: threshmin = 1.0E-19     ! small positive number
      Real, Parameter :: ctolmin = 1.0E-06
      Real, Parameter :: convfac_298 = 101325.0 * rgas1 * trefm1  ! P/RT at 1 atm and 298 K [ mole/m**3 ]
      Real, Parameter :: difforg = 9.36e-6  ! Diffusivity of organics [m2 s-1]
      Real, Parameter :: alphorg = 1.0      ! accomodation coefficient

      Real convfac
      Real tt1, tt2      ! temperature-related factors
      Real tempcorr      ! temperature correction factor for cstar

      ! Variables used in oligomerization calculations
      Real expdt         ! non-dimensional loss coefficient
      Real nsvpa         ! particle-phase anthropogenic SVOC [ umolC/m3 ]
      Real nsvpb         ! particle-phase biogenic SVOC [ umolC/m3 ]

      ! Variables used in acid-enhanced isoprene SOA calculations
      Real hplus         ! accumulation-mode H+ conc [ nmol/m3 ]
      Real aiso12        ! particle-phase isoprene SVOC [ ug/m3 ]
      Real vviso         ! vapor-phase isoprene SVOC [ ug/m3 ]
      Real xiso3         ! newly produced AISO3J [ ug/m3 ]
      Real isofrac       ! ratio for depletion of vapor-phase products

      ! Variables used in equilibrium partitioning calculations
      Real totrog( n_oa ) ! drog conc mapped to each SVOC [ ug/m3 ]
      Real(8) GRtmp( n_mode )   ! Dummy variable for accurate treatment of growth to specific moment
      Real GR3( n_oa,n_mode ) ! 3rd Moment Growth for each mode and compound
      Real GR3FRAC( n_oa,n_mode ) ! Fraction of each mode growing/shrinking
      Real dcaer          ! Change in SVOC conc after partitioning happens[ ug/m3 ]
      Real cbar_org(n_oa) ! On-line molecular speed of each organic
      Real dv_org            ! On-line gas-phase diffusivity of each organic
      Real totorgnv          ! Non-volatile OA [ umole/m3 ]
      Real totorg            ! SOA + POA before time step [ umole/m3 ]
      Real threshold         ! criterion for establishing gas/part equil.
      Real faer              ! fraction of total in aerosol, intermediate value
      Logical check          ! flag to indicate if NEWT subroutine
                             ! converged to a spurious root
      Real totaer            ! total aerosol-phase mass of each semivolaitle component
      Real Phi               ! mass fraction of a semivolatile component
                             ! in each mode
      Character(16), Allocatable, Save :: svname( : )
      Real, Allocatable, Save          :: svmw( : ), svmw_inv( : )
      Real, Allocatable, Save          :: c0    ( : ) ! cstar at AIRTEMP [ ug/m3 ]
      Real, Allocatable, Save          :: caer0 ( : ) ! Particle conc before current time step [ ug/m3 ]
      Real, Allocatable, Save          :: ctoti ( : ) ! Total (g+p) conc before current time step [ ug/m3 ]
      Real, Allocatable, Save          :: prod  ( : ) ! Total G+P produced during current step [ ug/m3 ]
      Real, Allocatable, Save          :: ctotf ( : ) ! Total conc after current time step [ ug/m3 ]
      Real, Allocatable, Save          :: caer  ( : ) ! Particle conc in aerosol phase after current 
                                                      !  step [ ug/m3 ]

      ! Variables for computing the budget
      REAL :: CBUDGET0_NUM ( N_MODE )
      REAL :: CBUDGET0_SRF ( N_MODE )
      REAL :: CBUDGET0_MASS( N_AEROSPC,N_MODE )
      REAL :: CBUDGET0_VAP ( N_OA )


      ! Variables for water uptake onto organics
      Real kappaVorg        ! sum_i(kappa_i*Vorganic_i) [m3 species/m3 air]
      Real overallkappa     ! sum_i(kappa_i*Vorganic_i)/vtot [NA units]
      Real totvol           ! total aerosol volume [m3 species/m3 air]
      Real poa              ! nonvolatile poa concentration [ug/m3]
      Real numparticles     ! number of acc mode particles [#/m3]
      Real diam             ! volume equivalent particle diameter [m]
      Real aw               ! activity of water [fraction]
      Real relhumid         ! relative humidity capped at 95% [fraction]
                            ! Cap represents conservative est of water uptake
                            ! and is consistent with IMPROVE visibility methods
      
      ! Variables for updating 2nd and 3rd moments
      Real(8) m0_init( 2 )  ! initial 0 moment, wet [ mom/m3 ]
      Real(8) m1wet_init( 2 )  ! initial 1st moment, wet [ mom/m3 ]
      Real(8) m2wet_initD( 2 )  ! initial 2nd moment, wet [ mom/m3 ]
      Real m3wet_init( 2 )  ! initial 3rd moment, wet [ mom/m3 ]
      Real m2wet_init( 2 )  ! initial 2nd moment, wet [ mom/m3 ]
      Real m3wet_final( 2 )  ! final 3rd moment with updated SOA [ mom/m3 ]
      Real m2wet_final( 2 )  ! final 2nd moment with updated SOA [ mom/m3 ]

      ! Added for new SOA bisection (hotp 7/6/11)
      Real               :: lowb, upb, orgmoles      ! lower bound, upper bound, total aerosol moles
      Logical, Parameter :: newtpartition = .False.   ! true to use original method, false to use new bisection

#ifdef sens
C Sensitivity variables
      Real( 8 ), Allocatable, Save :: s_totrog( :,: ) ! drog conc mapped to each SVOC [ ug/m3 ]
      Real( 8 ), Allocatable, Save :: s_ctoti ( :,: ) ! Total (g+p) conc before current time step [ ug/m3 ]
      Real( 8 ), Allocatable, Save :: s_prod  ( :,: ) ! Total G+P produced during current step [ ug/m3 ]
      Real( 8 ), Allocatable, Save :: s_ctotf ( :,: ) ! Total sens after current time step [ ug/m3 ]
      Real( 8 ), Allocatable, Save :: s_caer  ( :,: ) ! Particle sens in aerosol phase after current step [ ug/m3 ]
      Real( 4 ), Allocatable, Save :: kpart( : )      ! partitioning factor caer/(ctotf)
      Real( 8 ), Allocatable, Save :: s_dcaer ( : )   ! Change in SVOC sens after partitioning happens[ ug/m3 ]
      Real( 8 ), Allocatable, Save :: s_caer0 ( :,: ) ! Particle sens before current time step [ ug/m3 ]
      Integer allocstat
#endif

C-----------------------------------------------------------------------

      If ( first_time )  Then
         first_time = .False.

         ! Set unit conversion and inverse mw constants. Allocate space
         ! for semivolatile species partitioning variables.
         Allocate( rog_ppm2ug( n_oa ), mw_inv( n_oa ) )
         rog_ppm2ug( : ) = ROG_mw( : ) * convfac_298
         mw_inv( : ) = 1.0 / op_mw( : )

         nsvol         = count( .not.oaspc( : )%nonvol )
         If ( n_oa_tracers .gt. 0 )then
            nsvol_tracers = count( .not.oaspc( (n_oa_NotTracers+1):n_oa )%nonvol )
         Else
            nsvol_tracers = 0
         End If   
         
         nsvol_NotTracers = nsvol - nsvol_tracers
         
         
     
         If ( nsvol_NotTracers .Le. 0 ) Then
            xmsg = 'All semivolatile SOA species are tracers. Not realistic model setup.'
            solve_orgmoles = .False.
            Call m3warn( pname, 0, 0, xmsg )
         End If
         
         Allocate( svname( nsvol ), svmw( nsvol ), svmw_inv( nsvol ),
     &             c0( nsvol ), caer0( nsvol ), ctoti( nsvol ),
     &             prod( nsvol ), ctotf( nsvol ), caer( nsvol ) )

#ifdef sens
         Allocate (
     &              s_totrog( n_oa,npmax ),
     &              s_ctoti( nsvol,npmax ),
     &              s_ctotf( nsvol,npmax ),
     &              s_caer( nsvol,npmax ),    
     &              kpart( nsvol ),
     &              s_prod( nsvol,npmax ),    
     &              s_dcaer( npmax ),
     &              s_caer0( nsvol,npmax ),
     &              stat = allocstat )
         If ( allocstat .Ne. 0 ) Then
            xmsg = 'Failure allocating sensitivity variables in ORGAER'
            Call m3exit ( 'ORGAER', 0, 0, xmsg, xstat1 )
         End If
#endif
      End If ! first_time

      ! Set temperature factors
      tt1 = tref / airtemp
      tt2 = trefm1 - 1.0 / airtemp
      convfac = tt1 * airpres * prefm1

      ! Set Mass Transfer Properties (although each condensing organic
      ! will have its own diffusivity and molecular speed, just assume
      ! as a first guess that they are all uniform and given by a rep-
      ! resentative compound.
      Dv_org = difforg * ( STDATMPA / AIRPRES ) * ( AIRTEMP / 273.16 ) ** 1.75
      cbar_org( : ) = SQRT(8.0 * RGASUNIV * AIRTEMP / ( PI * og_mw(:) * 1.0E-3 ) )
 
      ! Compute 3rd moment, 2nd moment. moment_conc arrays are wet
      Call calcmoments ( .true. )
      Call getpar( FIXED_sg )


      ! Initialize Budget Variables
      CBUDGET0_NUM  = MOMENT0_CONC
      CBUDGET0_SRF  = MOMENT2_CONC
      CBUDGET0_MASS = AEROSPC_CONC
      CBUDGET0_VAP  = OG_CONC

      ! Initialize Local Moment Variables
      m3wet_init( : ) = moment3_conc( 1:2 )
      m2wet_init( : ) = moment2_conc( 1:2 )
        
      ! Calculate total flux associated with each indivual mode 
      ! for the third moment.
      GR3( :,: ) = 0.0
      m0_init( : )    = Real( moment0_conc( 1:2 ), 8 )
      m2wet_initD( : ) = Real( m2wet_init( 1:2 ), 8 )

      Do im = 1,2
        m1wet_init( im ) = m0_init( im ) * aeromode_diam( im ) * 
     &                     exp( 0.5d0 * aeromode_lnsg( im ) ** 2.0d0 )

        Do i = 1, n_oa
          If ( aero_missing( map_OAtoAERO( i ),im ) .or.
     &         oaspc(i)%nonvol ) Cycle
          
          Call HCOND3( m0_init( im ), m1wet_init( im ),
     &                 m2wet_initD( im ), Dv_org, alphorg, 
     &                 cbar_org(i), GRtmp )
          GR3( i,im ) = Real( GRtmp( 2 ), 4 )
        End Do
      End Do
      
      ! Calculate fraction of mass transfer to/from each mode
      GR3FRAC( :,: ) = 0.0
      Where ( GR3( :,1 ) .gt. 0. ) 
     &    GR3FRAC( :,1 ) = GR3( :,1 ) / ( GR3(:,1) + GR3(:,2) ) ! Aitken Growth
      Where ( GR3( :,2 ) .gt. 0. )
     &    GR3FRAC( :,2 ) = GR3( :,2 ) / ( GR3(:,1) + GR3(:,2) ) ! Accumulation Growth

      ! Initialize drog from ORGPROD and change units to [ ug / m**3 ]
      ! Assignment of drog to totrog. This moving mass from the reactive
      ! gas tracer species to the array that will be multiplied by alpha
      ! to give newly formed semivolatile vapors.
      totrog( : ) = rog_dconc( : ) * rog_ppm2ug( : ) * convfac
#ifdef sens
      Do np = 1, npmax
         Do i = 1, n_oa
            s_totrog( i, np ) = rog_dsens( i, np )* rog_ppm2ug( i ) * convfac
         End Do
      End Do
#endif

      ! Transfer non-volatile products directly to aerospc_conc array (2nd mode)
      Do i = 1, n_oa_NotTracers
         If ( oaspc( i )%nonvol .and. oaspc( i )%alpha .gt. 0. ) Then
            aerospc_conc( map_OAtoAERO( i ),2 ) =
     &      aerospc_conc( map_OAtoAERO( i ),2 )
     &      + oaspc( i )%alpha * totrog( i )
#ifdef sens
            Do np = 1, npmax
               s_aerospc_conc( map_OAtoAERO( i ),2,np ) =
     &         s_aerospc_conc( map_OAtoAERO( i ),2,np )
     &         + oaspc( i )%alpha * s_totrog( i,np )
            End Do
#endif
         End If
      End Do

      ! Equilibrium Partitioning Calculations

      ! Initial guess of caer is computed as follows:
      !    From eqn (8) of Schell et al. (2001)
      !    caer = ctotf - c0 * (caer/MW) / totorg
      !    Assuming totorg doesn't change during the timestep,
      !    caer * (1 + c0/MW / totorg) = ctotf
      !    caer = ctotf / ( 1 + c0/MW / totorg )

      threshold = 0.0  ! This threshold will be compared to the
                       ! saturation concentration to determine whether
                       ! or not OA partitioning is even likely.
      upb = 0.0  ! Upper bound for bisection method

      ! Compute the number of nonvolatile and total organic compound
      ! moles in the system
      nsvol    = 0
      totorgnv = sum( sum( aerospc_conc( :,1:2 ),2 ) / aerospc_mw( : ),
     &                     mask=lnonvol_oa( : ) )
      totorg   = sum( sum( aerospc_conc( :,1:2 ),2 ) * aerospc_mwinv( : ),
     &                     mask=(aerospc(:)%om .and. .Not. aerospc(:)%tracer) )

      
     
      ! Calculate the Initial Partitioning of Each Semivolatile
      ! Compound
      Do i = 1, n_oa
        n = map_OAtoAERO( i )
        if ( .not.oaspc( i )%nonvol ) Then
          nsvol = nsvol + 1
          svname( nsvol ) = oaspc( i )%name

          ! Sum particle-phase and total organic mass for this
          ! semivolatile species
          caer0( nsvol ) = aerospc_conc( n,2 ) + aerospc_conc( n,1 )
          ctoti( nsvol ) = og_conc( i )
     &                   + aerospc_conc( n,2 ) + aerospc_conc( n,1 )

#ifdef sens
          Do np = 1, npmax
             s_caer0( nsvol,np ) = s_aerospc_conc( n,2,np ) 
     &                           + s_aerospc_conc( n,1,np )
             s_ctoti( nsvol,np ) = og_sens( i,np )
     &                           + s_aerospc_conc( n,2,np ) 
     &                           + s_aerospc_conc( n,1,np )
          End Do
#endif
          ! Calculate C* at current temperature
          tempcorr      = tt1 * Exp( oaspc( i )%enth * rgas1 * tt2 )
          c0( nsvol )   = oaspc( i )%cstar * tempcorr      ! Satn Conc. [ug/m3]
          prod( nsvol ) = oaspc( i )%alpha * totrog( i )   ! Total Vapor Produced [ug/m3]
          ctotf( nsvol )= ctoti( nsvol ) + prod( nsvol )   ! Vapor + Particle [ug/m3]
#ifdef sens
          Do np = 1, npmax
             s_prod( nsvol,np )  = oaspc( i )%alpha * s_totrog( i,np ) 
             s_ctotf( nsvol,np ) = s_ctoti( nsvol,np ) + s_prod( nsvol,np ) 
          End Do
#endif

          If ( .Not. aerospc( n )%tracer ) Then ! partition only based on NotTracer mass
              threshold  = threshold +  ctotf( nsvol ) / c0( nsvol )
              ! Partition Nontracer semivolatile species accordingly
              faer   = totorg                                  ! initial fraction in aerosol
     &               / (totorg + c0( nsvol ) * mw_inv( i ) ) 
              caer( nsvol )  = ctotf( nsvol ) * faer           ! initial amount in aerosol
#ifdef sens
              Do np = 1, npmax
              s_caer( nsvol,np ) = s_ctotf( nsvol,np ) * faer
              End Do
#endif if
              upb        = upb + ctotf( nsvol ) * mw_inv( i )  ! upper bound: just semivolatile
                                                               !  moles for now. Nonvolatile moles 
                                                               !  will be added later.
          End If
                                                               
          svmw_inv( nsvol ) = mw_inv( i )
          svmw( nsvol ) = op_mw( i )
          
        end if
      End Do

      ! Check If gas/particle equilibrium can be established
      If ( ( threshold .Gt. 1.0 ) .Or. ( totorgnv .Gt. threshmin ) ) Then

           ! Perform one of two methods for partitioning
           If ( newtpartition ) Then

          ! METHOD1
          ! Calculate new SOA by partitioning. This method uses a globally convergent
          ! Newton-Raphson method coded by Dr Benedikt Schell to solve the nonlinear
          ! quadratic system shown in eqn 8 of Schell et al:
          !    A(i)  * caer(i) ** 2 + B * caer(i) + C(i) = 0.0,
          !    where B(i) contains the sum of all caer(j), for j not equal to i.

             Call newt( layer, caer, nsvol_NotTracers, check,
     &                  ctotf, c0, svmw_inv, totorgnv )
             If ( check ) Then
                ! Try again with initial guess of 50/50 gas/aerosol split.
                Do i = 1, nsvol_NotTracers
                   caer( i ) = 0.5 * ctotf( i )
                End Do
                Call newt( layer, caer, nsvol_NotTracers, check,
     &                     ctotf, c0, svmw_inv, totorgnv )
                If ( check ) Then
                   Write( xmsg,'( A,I4 )' ) 
     &                    ' *** Problem in NEWT at Layer = ', layer
                   Call m3exit( pname, 0, 0, xmsg, xstat3 )
                End If
             End If

             If ( nsvol_tracers .Gt. 0 ) Then
! partition tracer semivolatiles based on Schell equation (8)
! assuming:
!   1) the orgmoles from tracer species are already accounted in the orgmoles
!   from non-tracers species.
!   2) tracer is divided between volatile and nonvolatile components.
!   the nonvolatile part can not partition. The division is given by the
!   variable, frac_volatile.
!      shell's visocity
                orgmoles = totorgnv
                Do i = 1, nsvol_NotTracers
                   orgmoles = orgmoles + caer( i ) * mw_inv( i )
                End Do
!                phi = aerospc_conc( aorgh2o_idx, 2 ) * aerospc_mwinv( aorgh2o_idx ) / orgmoles
                Do i = nsvol_NotTracers+1, nsvol
                   faer = svmw(i) * orgmoles 
     &                  / ( c0( i ) + svmw(i) * orgmoles )
                   caer( i )  = ctotf( i ) * faer
! update final concentration with nonvolatile fraction
                   ctotf( i ) = ctotf( i )
                End Do  
             End If   
 
           Else
            
          ! METHOD2
          !      Calculate new SOA by partitioning.
          !      Method uses bisection method to solve for total number of moles
          !      of orgaic aerosol. Caer is then calculated based on that number.
          !         Solve for total number of organic moles in aerosol (hotp 7/5/11)
             lowb      = totorgnv   ! lower: moles of nonvolatile
             upb       = lowb + upb ! upper: all moles (semi and nonvolatile)
             If ( abs( upb - lowb ) .Lt. threshmin ) Then
                ! no SOA to partition
                orgmoles = ( lowb + upb ) / 2.0
             Else
                upb       = upb * ( 2.0 + 1.0e-7 * real(n_oa_NotTracers) ) ! prevent numerical issues
                orgmoles = soabisect( lowb, upb, totorgnv, nsvol_NotTracers, c0, ctotf, svmw )
             End If

             ! Determine concentration of each semivoltile (hotp 7/5/11)
             Do i = 1, nsvol_NotTracers 
               faer = svmw(i) * orgmoles / 
     &                ( c0( i ) + svmw(i) * orgmoles )
               caer( i ) = ctotf( i ) * faer
             End Do
! partition tracer semivolatiles based on Schell equation (8)
! assuming:
!   1) orgmoles already include moles from tracers
              Do i = nsvol_NotTracers+1, nsvol
                 faer = svmw(i) * orgmoles 
     &                / ( c0( i ) + svmw(i) * orgmoles )
                 caer( i ) = ctotf( i ) * faer
! update final concentration with nonvolatile fraction
                 ctotf( i ) = ctotf( i ) 
              End Do  
           End If  ! End OA paritioning solver METHOD selection

#ifdef sens 
c approximate partioning for sensitivities
           kpart = 0.0
           Do i = nsvol_NotTracers+1, nsvol
              If ( ctotf( i ) .gt. 0.0 ) Then
                 kpart( i ) = caer( i ) / ctotf( i )
              Else
                 kpart( i ) = 0.5
              Endif
              kpart( i ) = max( min(kpart( i ),1.0), 0.0 )
           End Do

           Do np = 1, npmax
              Do i = nsvol_NotTracers+1, nsvol
                 s_caer( i,np ) = s_ctotf( i,np ) * Real( kpart( i ),8 )
              End Do
           End Do
#endif

        ! Constrain caer to values between conmin and ctotf
        nsvol = 0
        Do i = 1, n_oa
           If ( oaspc( i )%nonvol ) Cycle
           nsvol = nsvol + 1

           ! Check that the mass of aerosol left has not gone below a
           ! minimum value
           If ( caer( nsvol ) .Lt. tiny(0.0) ) Then
              Write( logdev,* ) 'caer less than zero for OA species: ', 
     &                              oaspc( i )%name, ' ', caer( nsvol ),
     &                              ' reset to evapmin.'
              ctotf( nsvol ) = ctotf( nsvol ) - caer( nsvol ) + evapmin
              caer( nsvol ) = evapmin
#ifdef sens
              Do np = 1, npmax
                 s_ctotf( nsvol,np ) = s_ctotf( nsvol,np ) - s_caer( nsvol,np) 
c                s_ctotf( nsvol,np ) = s_ctotf( nsvol,np ) 
c                                    * ( 1.0 - kpart( nsvol) ) 
                 s_caer( nsvol,np )  = 0.0
              End Do
#endif              
           End If

           ! Check that the mass of aerosol condensed does not exceed
           ! the total
           If ( caer( nsvol ) - ctotf( nsvol ) .Gt. tiny(0.0) ) Then
               Write( logdev,* ) 'caer exceeds ctotf at i = ', i
               Write( logdev,* ) 'caer: ', caer( nsvol ), ' ctotf: ', ctotf( nsvol )
               Write( logdev,* ) 'caer reset to ctotf'
               caer( nsvol ) = ctotf( nsvol )
#ifdef sens
               Do np = 1, npmax
                 s_caer( nsvol,np )  = s_ctotf( nsvol,np ) 
               End Do
#endif                   
           End If

           ! Calculate total change in OA Species Concentration
           dcaer = caer( nsvol ) - caer0( nsvol )  
#ifdef sens
           Do np = 1, npmax
              s_dcaer( np ) = s_caer( nsvol,np ) - s_caer0( nsvol,np )
           End Do
#endif           

           ! Sum the total aerosol mass of this compound across all
           ! aerosol modes
           indx = map_OAtoAERO( i )
           totaer = max( sum( aerospc_conc( indx,: ) , mask = 
     &                 .NOT.aero_missing( indx,: ) ), conmin )
    
           ! Transfer the semivolatile mass
           Do im = 1,2
              If ( aero_missing( indx,im ) ) Cycle
              If ( dcaer .lt. 0.0 ) Then
                 ! Evaporate using mode-dependent mass fraction
                 Phi = aerospc_conc( indx,im ) / totaer
                 aerospc_conc( indx,im ) = 
     &                aerospc_conc( indx,im ) + dcaer * Phi
#ifdef sens
                 Do np = 1, npmax
                    s_aerospc_conc( indx,im,np ) = 
     &                   s_aerospc_conc( indx,im,np ) + s_dcaer( np ) * Phi
                 End Do
#endif
              Else
                 ! Condense using mode-dependent condensaiton flux 
                 ! fraction
                 aerospc_conc( indx,im ) = aerospc_conc( indx,im ) 
     &                + dcaer * GR3FRAC( i,im )
#ifdef sens
                 Do np = 1, npmax
                    s_aerospc_conc( indx,im,np ) = 
     &                   s_aerospc_conc( indx,im,np )
     &                 + s_dcaer( np ) * GR3FRAC( i,im )  
                 End Do
#endif
              End If
           End Do

           og_conc( i ) = ctotf( nsvol ) - caer( nsvol )

#ifdef sens
           Do np = 1, npmax
              og_sens( i,np ) = s_ctotf( nsvol,np ) - s_caer( nsvol,np )
           End Do
#endif
        End Do  ! Partitioning Vapor Loop
 
      Else   ! threshold not exceeded; no material transferred to aerosol phase
        
        nsvol = 0
        Do i = 1, n_oa
            if ( oaspc( i )%nonvol ) Cycle
            nsvol = nsvol + 1
            indx = map_OAtoAERO( i )

            ! Set all semivolatile aerosols to minimum concentration
            aerospc_conc( indx, 1:n_mode ) = conmin
            ! Sum up particle-phase mass to subtract it from available
            ! vapor
            og_conc( i ) = ctotf( nsvol ) -
     &                       sum( aerospc_conc( indx,: ), 
     &                            mask=.not.aero_missing( indx,: ) )
#ifdef sens
            Do np = 1, npmax
               s_aerospc_conc( indx, 1:n_mode,np ) = 0.0
               og_sens( i,np ) = s_ctotf( nsvol,np ) -
     &                       sum( s_aerospc_conc( indx,:,np ), 
     &                            mask=.not.aero_missing( indx,: ) )

            End Do
#endif
        End Do

      End If    ! check on equilibrium threshold


      ! Add uptake of water onto hydrophillic organics (see Petters and
      ! Kreidenweis 2007 ACP and Pye et al. 2017 ACP for method).
      ! Uptake of water onto inorganic species is calculated elsewhere
      ! using ISORROPIA.
      If ( aorgh2o_idx > 0 ) Then

         kappaVorg = 0.0e0 ! units: m3.spec/m3.air
         totvol    = 0.0e0 ! units: m3.particle/m3.air
         aerospc_conc( aorgh2o_idx,: ) = conmin

         im = 2 ! only compute water for accumulation mode OM

         ! Compute sum_i(Kappa_i*Vorg_i) for all OM species except POC 
         ! and PNCOM, which will be handled next.
         Do i = 1, n_aerospc
           If(  aerospc( i )%tracer )cycle
              totvol = totvol + aerospc_conc(i, im ) /
     &                 aerospc( i )%density * 1.0e-9
           If( aerospc( i )%OM .and. 
     &         i .ne. apoc_idx .and. i .ne. apncom_idx ) Then
              kappaVorg = kappaVorg + aerospc( i )%kappaorg *
     &                    aerospc_conc( i, im ) / aerospc( i )%density*1.0e-9
           End If
         End Do

         ! Account for Kappa of Nonvolatile POC and PNCOM species. This
         ! must be done separately because PNCOM has infinite OM:OC
         poa = aerospc_conc( apoc_idx, im ) + aerospc_conc( apncom_idx, im )
         kappaVorg = kappaVorg + 
     &               (0.11*poa / ( aerospc_conc(apoc_idx, im ) + tiny(0.0) ) -0.10)
     &               * (aerospc_conc( apncom_idx, im ) / aerospc( apncom_idx )%density +
     &                  aerospc_conc( apoc_idx,   im ) / aerospc( apoc_idx )%density )*1.0e-9

         ! Calculate Aggregate Kappa and volume Equivalent Diameter
         overallkappa = kappaVorg/totvol
         numparticles = moment0_conc( im )
         diam         = (6.0*totvol/numparticles/ pi ) ** (1.0/3.0)

         ! Compute aerosol water (Eq 3 of Petters and Kreidenweis)
         relhumid = min( airRH, 0.95 ) ! Cap RH at 95% to be conservative regarding uptake
         aw = activityw( relhumid, airtemp, diam ) ! activity of water
         If( overallkappa .gt. 1e-6 ) then ! prevents situation of little uptake
            aerospc_conc( aorgh2o_idx, im ) = aerospc( aorgh2o_idx )%density
     &       * aw/(1.0-aw) * kappaVorg * 1.0e9
         End If

      End If ! End organic water uptake

      ! Update 3rd moment, 2nd moment, and Dg in CBLK array by assuming that SOA
      ! condensation/evaporation does not affect the geometric standard deviation.

      ! Get new third moment of all species, do not get second moment
      ! directly from the calcmoments diagnostic. Instead, update it
      ! manually to account for condensation in ORGAER.
      Call calcmoments( .true. )
      m3wet_final( : ) = moment3_conc( 1:2 )
      m2wet_final( 1 ) = m2wet_init( 1 ) * ( m3wet_final( 1 ) /
     &                     m3wet_init( 1 ) ) ** ( 2.0 / 3.0 )
      m2wet_final( 2 ) = m2wet_init( 2 ) * ( m3wet_final( 2 ) / 
     &                     m3wet_init( 2 ) ) ** ( 2.0 / 3.0 )
      moment2_conc( 1:2 )  = m2wet_final( : )

      ! Update Budget Variables
      DO IM = 1,N_MODE
        ! Update Number and Surface Area
        COND_BUDGET( AERONUM_MAP( IM ) )  = MOMENT0_CONC( IM ) - CBUDGET0_NUM( IM )
        COND_BUDGET( AEROSRF_MAP( IM ) )  = MOMENT2_CONC( IM ) - CBUDGET0_SRF( IM )

        ! Update Organic Particles
        DO ISPC = 1,N_AEROSPC
          IF ( AEROSPC_MAP( ISPC,IM ) .NE. 0 ) 
     &         COND_BUDGET( AEROSPC_MAP( ISPC,IM ) ) = 
     &              AEROSPC_CONC( ISPC,IM ) - CBUDGET0_MASS( ISPC,IM )
        END DO

        ! Update Organic Vapors
        DO ISPC = 1,N_OA
          IF ( MAP_OGtoCGRID( ISPC ) .NE. 0 ) 
     &         COND_BUDGET( MAP_OGtoCGRID( ISPC ) ) = 
     &                 OG_CONC( ISPC ) - CBUDGET0_VAP( ISPC )
        END DO
      END DO

      Return
      End Subroutine orgaer

C-----------------------------------------------------------------------
      SUBROUTINE NEWT( LAYER, X, N, CHECK,
     &                 CTOT, CSAT, IMWCV, MINITW )

C  Description:
C   This subroutine and the underlying subprograms constitute Dr.
C   Benedikt Schell's SOA model.
C
C  Adopted from Numerical Recipes in FORTRAN, Chapter 9.7, 2nd ed.
C
C  Given an initial guess X(1:N) for a root in N dimensions, find
C  the root by a globally convergent Newton's method. The vector of
C  functions to be zeroed, called FVEC(1:N) in the routine below, is
C  returned by a user-supplied subroutine that must be called FUNCV
C  and have the declaration SUBROUTINE FUNCV(N,X,FVEC). The output
C  quantity CHECK is false on a normal return and true if the
C  routine has converged to a local minimum of the function FMINV
C  defined below. In this case, user should try restarting from a
C  different initial guess.
C
C  Key Subroutines Called: FDJAC, FMINV, LNSRCH, LUBKSB, LUDCMP
C
C  Revision History:
C     In CMAQ v4.3 - v4.7.1, this subroutine was embedded in a separate
C     Fortran module entitled SOA_NEWT.  Below, the Revision History from
C     the SOA_NEWT module has been merged with the Revision History from
C     this specific subroutine.
C
C CGN 01/12/04 removed ITS from call vector, added documentation, and
C     removed extraneous lines of code
C
C SLN 09/18/07 updated NP and NPREC for compatibility with new SOA module
C
C PVB 11/19/07 renamed NP to NCVAP for consistency with ORGAER5 subroutine
C
C SH  02/10/10 embedded the old Fortran module, SOA_NEWT, into a new module,
C     SOA_DEFN, so all SOA-related code can be found in one file.  Renamed
C     NCVAP to n_oa.  Its value is now set in SOA_DEFN (instead of inside
C     this subroutine).  Added TOLX to the call vector of Subroutine LNSRCH,
C     since that parameter is now set in this subroutine (instead of in the
C     Fortran module).
C
C  References:
C   1. Schell, B., I. J. Ackermann, H. Hass, F. S. Binkowski, and
C      A. Abel, Modeling the formation of secondary organic aerosol
C      within a comprehensive air quality modeling system, J. Geophys.
C      Res., Vol 106, No D22, 28275-28293, 2001.

      IMPLICIT NONE

C  Arguments

      INTEGER LAYER      ! model layer
      INTEGER N          ! dimension of problem
      REAL X( N )        ! initial guess of CAER
      LOGICAL CHECK
      REAL CTOT( N )     ! total concentration GAS + AER + PROD
      REAL CSAT( N )     ! saturation conc. of cond. vapor [ug/m^3]
      REAL IMWCV( N )    ! inverse molecular weights
      REAL MINITW        ! weighted initial mass

C  Following Numerical recipes

      Integer NN
      REAL :: FVEC( N )               ! vector of functions to be zeroed
      ! COMMON /NEWTV/ FVEC(n_oa), NN
      ! SAVE /NEWTV/

C  Parameters
      INTEGER, PARAMETER :: MAXITS = 100  ! maximum number of iterations
      REAL, PARAMETER :: TOLF = 1.0E-09   ! convergence criterion on fxn values
      REAL, PARAMETER :: TOLMIN = 1.0E-12 ! criterion whether spurious conver-
                                          ! gence to a minimum has occurred
      REAL, PARAMETER :: TOLX = 1.0E-10   ! convergence criterion on delta_x
      REAL, PARAMETER :: STPMX = 100.0    ! scaled maximum step length allowed

C  Local variables
      REAL :: CT( N ), CS( N ), IMW( N ), M
      ! REAL CS
      ! REAL IMW
      ! REAL M
      ! COMMON /NEWTINP/ CT( n_oa ), CS( n_oa ), IMW( n_oa ), M
      ! SAVE /NEWTINP/

      INTEGER I, ITS, J, INDX( N_OA )
      REAL D, DEN, F, FOLD, STPMAX, SUM, TEMP, TEST
      REAL FJAC( N_OA,N_OA )
      REAL G( N_OA), P( N_OA ), XOLD( N_OA )
!     EXTERNAL FDJAC

C-----------------------------------------------------------------------

      CHECK = .FALSE.
      M = MINITW
      DO I = 1, N
         CT( I ) = CTOT( I )
         CS( I ) = CSAT( I )
         IMW( I ) = IMWCV( I )
      END DO

      NN = N
      CALL FMINV( X,F,NN,FVEC,CT,CS,IMW,M )  ! The vector FVEC is also computed by this call
      TEST = 0.0              ! Test for initial guess being a root. Use more
                              ! stringent test than simply TOLF.
      DO I = 1, N
         IF ( ABS( FVEC( I ) ) .GT. TEST ) TEST = ABS( FVEC( I ))
      END DO

      IF ( TEST .LT. 0.01 * TOLF ) RETURN  ! initial guess is a root
      SUM = 0.0                    ! Calculate STPMAX for line searches
      DO I = 1, N
         SUM = SUM + X( I ) ** 2
      END DO
      STPMAX = STPMX * MAX( SQRT( SUM ), FLOAT( N ) )
      DO ITS = 1, MAXITS           ! start of iteration loop
         CALL FDJAC( N, X, FJAC, CT, CS, IMW, M )  ! get Jacobian
         DO I = 1, N               ! compute Delta f for line search
            SUM = 0.0
            DO J = 1, N
               SUM = SUM + FJAC( J,I ) * FVEC( J )
            END DO
            G( I ) = SUM
         END DO
         DO I = 1, N               ! store X
            XOLD( I ) = X( I )
         END DO
         FOLD = F                  ! store F
         DO I = 1, N               ! right-hand side for linear equations
            P( I ) = -FVEC( I )
         END DO
         CALL LUDCMP( FJAC, N, INDX, D ) ! solve linear equations by LU decomposition
         CALL LUBKSB( FJAC, N, INDX, P )
         CALL LNSRCH( CTOT,
     &                N, XOLD, FOLD, G,  ! LNSRCH returns new X and F. It also
     &                P, X, F, STPMAX,   ! calculates FVEC at the new X when it
     &                TOLX, CHECK, FVEC,
     &                CT, CS, IMW, M)      ! calls FMINV
         TEST = 0.0
         DO I = 1, N
            IF ( ABS( FVEC( I ) ) .GT. TEST ) TEST = ABS( FVEC( I ) )
         END DO
         IF ( TEST .LT. TOLF ) THEN
            CHECK = .FALSE.
            RETURN
         END IF
         IF ( CHECK ) THEN        ! Check for gradient of F zero,
            TEST = 0.0            ! i.e., spurious convergence.
            DEN = MAX( F, 0.5 * N )
            DO I = 1, N
               TEMP = ABS( G( I ) ) * MAX( ABS( X( I ) ), 1.0 ) / DEN
               IF ( TEMP .GT. TEST ) TEST = TEMP
            END DO
            IF ( TEST .LT. TOLMIN ) THEN
               CHECK = .TRUE.
            ELSE
               CHECK = .FALSE.
            END IF
            RETURN
         END IF
         TEST = 0.0             ! Test for convergence on delta_x
         DO I = 1, N
            TEMP = ( ABS( X( I ) - XOLD( I ) ) ) / MAX( ABS( X( I ) ), 1.0 )
            IF ( TEMP .GT. TEST ) TEST = TEMP
         END DO
         IF ( TEST .LT. TOLX ) RETURN
      END DO
      WRITE( *,'(a,i2)' ) 'MAXITS exceeded in NEWT ! Layer: ', LAYER
      END SUBROUTINE NEWT

C-----------------------------------------------------------------------
      SUBROUTINE FDJAC( N, X, FJAC, CT, CS, IMW, M )

C  Description:
C    Get the Jacobian of the function

C          ( a1 * X1^2 + b1 * X1 + c1 )
C          ( a2 * X2^2 + b2 * X2 + c2 )
C          ( a3 * X3^2 + b3 * X3 + c3 )
C   F(X) = ( a4 * X4^2 + b4 * X4 + c4 ) = 0.0
C          ( ........................ )
C          ( aN * XN^2 + bN * XN + cN )
C
C    a_i = IMW_i
C    b_i = SUM(X_j * IMW_j)_j.NE.i + CSAT_i * IMW_i  + M
C          - CTOT_i * IMW_i
C
C    c_i = - CTOT_i * [ SUM(X_j * IMW_j)_j.NE.i + M ]
C
C           delta F_i    ( 2. * a_i * X_i + b_i          If i .EQ. j
C   J_ij = ----------- = (
C           delta X_j    ( ( X_i  - CTOT_i ) * IMW_j     If i .NE. j

C Revision History:
C   CGN 01/12/04 changed B1 & B2 to scalars
C   SH  02/10/10 renamed NCVAP to n_oa. Value is inherited from SOA_DEFN.

      IMPLICIT NONE

      INTEGER N                 ! dimension of problem
      REAL X( N )               ! initial guess of CAER

      REAL CT( N )
      REAL CS( N )
      REAL IMW( N )
      REAL M

      REAL FJAC( N,N )

      INTEGER I, J              ! loop index
      REAL A( N_OA )
      REAL B( N_OA )
      REAL B1
      REAL B2
      REAL SUM_JNEI

      DO I = 1, N
         A( I ) = IMW( I )
         SUM_JNEI = 0.0
         DO J = 1, N
            SUM_JNEI = SUM_JNEI + X( J ) * IMW( J )
         END DO
         B1 = SUM_JNEI - ( X( I ) * IMW( I ) )
         B2 = ( CS( I ) - CT( I ) ) * IMW( I ) + M
         B( I ) = B1 + B2
      END DO
      DO J = 1, N
         DO I = 1, N
            IF ( I .EQ. J ) THEN
               FJAC( I,J ) = 2.0 * A( I ) * X( I ) + B( I )
            ELSE
               FJAC( I,J ) = ( X( I ) - CT( I ) ) * IMW( J )
            END IF
         END DO
      END DO

      RETURN
      END SUBROUTINE FDJAC

C-----------------------------------------------------------------------
      SUBROUTINE FMINV( X,F,N,FVEC, CT, CS, IMW, M )

C Description:
C    Returns f = 0.5 * F*F at X. SR FUNCV(N,X,F) is a fixed-name,
C    user-supplied routine that returns the vector of functions at X.
C    The common block NEWTV communicates the function values back to
C    NEWT.

C Adopted from Numerical Recipes in FORTRAN, Chapter 9.7, 2nd ed.

C Key Subroutines Called: FUNCV

C Revision History:
C   YOJ 07/31/02 changed FUNCTION FMIN to SUBROUTINE FMINV to avoid errors
C       with (some) compilers
C   SH  02/10/10 renamed NCVAP to n_oa. Value is inherited from SOA_DEFN.

      IMPLICIT NONE

      INTEGER N

      REAL X( * ), F
      REAL :: FVEC( N ), CT( N ), CS( N ), IMW( N ), M

      INTEGER I
      REAL SUM
      CALL FUNCV( N, X, FVEC, CT, CS, IMW, M )
      SUM = 0.0
      DO I = 1, N
         SUM = SUM + FVEC( I ) ** 2
      END DO
      F = 0.5 * SUM
      RETURN
      END SUBROUTINE FMINV

C-----------------------------------------------------------------------
      SUBROUTINE FUNCV( N, X, FVEC, CT, CS, IMW, M )

C Description:
C   From Equation (8) of Schell et al., 2001:
C     Caer,i = Ctot,i - Csat,i * (Caer,i/MWi) /
C                             ( sum_j (Caer,j/MWj) + Cinit/MWinit)
C   Let Xi  = Caer,i
C       a_i = 1 / MWi
C       M   = Cinit/MWinit
C       CTi = Ctot,i
C       CSi = Csat,i
C   Then,
C       Xi  = CTi - CSi * (a_i * Xi) / ( sum_j (a_j * Xj) + M )
C
C   Multiply above equation by sum_j(a_j*Xj) + M and group terms
C       a_i Xi^2 + ( sum_jnei (a_j*Xj) + M + CSi*a_i - CTi*a_i ) Xi
C                - CTi * ( sum_jnei (a_j*Xj) + M ) = 0
C
C   This equation is of the form F(X) = a_i*Xi^2 + b_i*Xi + c_i = 0.
C     F(X) is stored as FVEC in this subroutine.
C
C   See also FDJAC.

C Key Subroutines Called: none

C Revision History:
C CGN 01/12/04  Added documentation, removed extraneous lines of code
C SH  02/10/10 renamed NCVAP to n_oa.  Value is inherited from SOA_DEFN

C References:
C   1. Schell, B., I. J. Ackermann, H. Hass, F. S. Binkowski, and
C      A. Abel, Modeling the formation of secondary organic aerosol
C      within a comprehensive air quality modeling system, J. Geophys.
C      Res., Vol 106, No D22, 28275-28293, 2001.

      IMPLICIT NONE

      INTEGER N
      REAL X( * )
      REAL FVEC( N )

      REAL CT( N )
      REAL CS( N )
      REAL IMW( N )
      REAL M

      INTEGER I, J
      REAL SUM_JNEI
      REAL A( N )
      REAL B( N )
      REAL C( N )

      DO I = 1, N
         A( I ) = IMW( I )
         SUM_JNEI = 0.0
         DO J  = 1, N
            SUM_JNEI = SUM_JNEI + X( J ) * IMW( J )
         END DO
         SUM_JNEI = SUM_JNEI - ( X( I ) * IMW( I ) )
         B( I ) = SUM_JNEI + M + ( CS( I ) - CT( I ) ) * IMW( I )
         C( I ) = -CT( I ) * ( SUM_JNEI + M )
         FVEC( I ) = X( I ) * ( A( I ) * X( I ) + B( I ) ) + C( I )
      END DO

      RETURN
      END SUBROUTINE FUNCV

C-----------------------------------------------------------------------
      SUBROUTINE LNSRCH( CTOT,
     &                   N, XOLD, FOLD, G, P,
     &                   X, F, STPMAX, TOLX, CHECK, FVEC,
     &                   CT, CS, IMW, M )

C Description:
C   Given an n-dimensional point XOLD(1:N), the value of the function
C   and gradient there, FOLD and G(1:N), and a direction P(1:N),
C   finds a new point X(1:N) along the direction P from XOLD where
C   the function FUNC has decreased 'sufficiently'. The new function
C   value is returned in F. STPMAX is an input quantity that limits
C   the length of the steps so that you do not try to evaluate the
C   function in regions where it is undefined or subject to overflow.
C   P is usually the Newton direction. The output quantity CHECK is
C   false on a normal exit. It is true when X is too close to XOLD.
C   In a minimization algorithm, this usually signals convergence and
C   can be ignored. However, in a zero-finding algorithm the calling
C   program should check whether the convergence is spurious.
C
C  Adopted from Numerical Recipes in FORTRAN, Chapter 9.7, 2nd ed.

C Key Subroutines Called: FUNCV

C Revision History:
C   SH  02/10/10 added TOLX to the call vector.  In previous versions, this
C       parameter was declared in the Module SOA_NEWT (which contained this
C       subroutine).

      IMPLICIT NONE

      INTEGER N
      REAL TOLX
      LOGICAL CHECK
      REAL F, FOLD, STPMAX
      REAL G( N ), P( N ), X( N ), XOLD( N )
      REAL CTOT( N )
      REAL, PARAMETER :: ALF = 1.E-04
      REAL, PARAMETER :: CONMIN = 1.E-30
      REAL :: FVEC( N ), CT( N ), CS( N ), IMW( N ), M

      INTEGER I
      REAL A, ALAM, ALAM2, ALAMIN, B, DISC
      REAL F2, FOLD2, RHS1, RHS2, SLOPE
      REAL SUM, TEMP, TEST, TMPLAM

      CHECK = .FALSE.
      SUM = 0.0
      DO I = 1, N
         SUM = SUM + P( I ) * P( I )
      END DO
      SUM = SQRT( SUM )
      IF ( SUM .GT. STPMAX ) THEN
         DO I = 1, N
            P( I ) = P( I ) * STPMAX / SUM
         END DO
      END IF
      SLOPE = 0.0
      DO I = 1, N
         SLOPE = SLOPE + G( I ) * P( I )
      END DO
      TEST = 0.0
      DO I = 1, N
         TEMP = ABS( P( I ) ) / MAX( ABS( XOLD( I ) ), 1.0 )
         IF ( TEMP .GT. TEST ) TEST = TEMP
      END DO
      ALAMIN = TOLX / TEST
      ALAM = 1.0

101   CONTINUE

C  avoid negative concentrations and set upper limit given by CTOT.

      DO I = 1, N
         X( I ) = XOLD( I ) + ALAM * P( I )
         IF ( X( I ) .LE. 0.0 )       X( I ) = CONMIN
         IF ( X( I ) .GT. CTOT( I ) ) X( I ) = CTOT( I )
      END DO
      CALL FMINV( X,F,N,FVEC,CT,CS,IMW,M )
      IF ( ALAM .LT. ALAMIN ) THEN
         DO I = 1, N
            X( I ) = XOLD( I )
         END DO
         CHECK = .TRUE.
         RETURN
      ELSE IF ( F .LE. FOLD + ALF * ALAM * SLOPE ) THEN
         RETURN
      ELSE
         IF ( ALAM .EQ. 1.0 ) THEN
            TMPLAM = -SLOPE / ( 2.0 * ( F - FOLD - SLOPE ) )
         ELSE
            RHS1 = F - FOLD - ALAM * SLOPE
            RHS2 = F2 - FOLD2 - ALAM2 * SLOPE
            A = ( RHS1 / ALAM ** 2 - RHS2 / ALAM2 ** 2 ) / ( ALAM - ALAM2 )
            B = ( -ALAM2 * RHS1 / ALAM ** 2 + ALAM * RHS2 / ALAM2 ** 2 )
     &        / ( ALAM - ALAM2 )
            IF ( A .EQ. 0.0 ) THEN
               TMPLAM = -SLOPE / ( 2.0 * B )
            ELSE
               DISC  = B * B - 3.0 * A * SLOPE
               TMPLAM = ( -B + SQRT( DISC ) ) / ( 3.0 * A )
            END IF
            IF ( TMPLAM .GT. 0.5 * ALAM ) TMPLAM = 0.5 * ALAM
         END IF
      END IF
      ALAM2 = ALAM
      F2 = F
      FOLD2 = FOLD
      ALAM = MAX( TMPLAM, 0.1 * ALAM )
      GO TO 101

      END SUBROUTINE LNSRCH

C-----------------------------------------------------------------------
      SUBROUTINE LUBKSB( A, N, INDX, B )

C Description:
C   Solves the set of N linear equations A * X = B. Here A is input,
C   not as the matrix A but rather as its LU decomposition,
C   determined by the routine LUDCMP. B(1:N) is input as the right-
C   hand side vector B, and returns with the solution vector X. A, N,
C   and INDX are not modified by this routine and can be left in
C   place for successive calls with different right-hand sides B.
C   This routine takes into account the possibility that B will begin
C   with many zero elements, so it is efficient for use in matrix
C   inversion.
C
C  Adopted from Numerical Recipes in FORTRAN, Chapter 2.3, 2nd ed.
C
C Key Subroutines Called: none
C
C Revision History:
C    call vector modified to remove NCVAP and set dimensions to N.

      IMPLICIT NONE

      INTEGER N, INDX( N )
      REAL A( N,N ), B( N ) ! A now has dimension NxN.

      INTEGER I, II, J, LL
      REAL SUM

      II = 0
      DO I = 1, N
         LL = INDX( I )
         SUM = B( LL )
         B( LL ) = B( I )
         IF ( II .NE. 0 ) THEN
            DO J = II, I-1
               SUM = SUM - A( I,J ) * B( J )
            END DO
         ELSE IF ( SUM .NE. 0 ) THEN
            II = I
         END IF
         B( I ) = SUM
      END DO
      DO I = N, 1, -1
         SUM = B( I )
         DO J = I+1, N
            SUM = SUM - A( I,J ) * B( J )
         END DO
         B( I ) = SUM / A( I,I )
      END DO

      RETURN
      END SUBROUTINE LUBKSB

C-----------------------------------------------------------------------
      SUBROUTINE LUDCMP( A, N, INDX, D )

C Description:
C   Given a matrix A(1:N,1:N), with physical dimension N by N, this
C   routine replaces it by the LU decomposition of a rowwise
C   permutation of itself. A and N are input. A is output arranged as
C   in equation (2.3.14) above; INDX(1:N) is an output vector that
C   records vector that records the row permutation effected by the
C   partial pivoting; D is output as +-1 depending on whether the
C   number of row interchanges was even or odd, respectively. This
C   routine is used in combination with SR LUBKSB to solve linear
C   equations or invert a matrix.
C
C  Adopted from Numerical Recipes in FORTRAN, Chapter 2.3, 2nd ed.

C  Equation (2.3.14) Numerical Recipes, p 36:
C   | b_11 b_12 b_13 b_14 |
C   | a_21 b_22 b_23 b_24 |
C   | a_31 a_32 b_33 b_34 |
C   | a_41 a_42 a_43 b_44 |

C Key Subroutines Called: None

C Revision History:
C    call vector modified to remove NCVAP
C    all dimensions now depend upon N only

      IMPLICIT NONE

      INTEGER N, INDX( N )
!     INTEGER NMAX
!     PARAMETER ( NMAX = 10 )   ! largest expected N
      REAL D, A( N,N )     ! note that A now has dimension NxN
                           ! NCVAP is ignored
      REAL, PARAMETER :: TINY = 1.0E-20

      INTEGER I, IMAX, J, K
      REAL AAMAX, DUM, SUM, VV( N )

      D = 1.0
      DO I = 1, N
         AAMAX = 0.0
         DO J = 1, N
            IF ( ABS(A( I,J ) ) .GT. AAMAX ) AAMAX = ABS( A( I,J ) )
         END DO
         IF ( AAMAX .EQ. 0.0 ) THEN
            WRITE( *,'(a)' ) '*** Singular matrix in ludcmp!'
         END IF
         VV( I ) = 1.0 / AAMAX
      END DO
      DO J = 1, N
         DO I = 1, J-1
            SUM = A( I,J )
            DO K = 1, I-1
               SUM = SUM - A( I,K ) * A( K,J )
            END DO
            A( I,J ) = SUM
         END DO
         AAMAX = 0.0
         DO I = J, N
            SUM = A( I,J )
            DO K = 1, J-1
               SUM = SUM - A( I,K ) * A( K,J )
            END DO
            A( I,J ) = SUM
            DUM = VV( I ) * ABS( SUM )
            IF ( DUM .GE. AAMAX ) THEN
               IMAX = I
               AAMAX = DUM
            END IF
         END DO
         IF ( J .NE. IMAX ) THEN
            DO K = 1, N
               DUM = A( IMAX,K )
               A( IMAX,K ) = A( J,K )
               A( J,K ) = DUM
            END DO
            D = -D
            VV( IMAX ) = VV( J )
         END IF
         INDX( J ) = IMAX
         IF ( A( J,J ) .EQ. 0.0 ) A( J,J ) = TINY
         IF ( J .NE. N ) THEN
            DUM = 1.0 / A( J,J )
            DO I = J+1, N
               A( I,J ) = A( I,J ) * DUM
            END DO
         END IF
      END DO

      RETURN
      END SUBROUTINE LUDCMP

C-----------------------------------------------------------------------
      Function soabisect( lowerb, upperb, nonvolmol, n, cstaratt, totsemivol,
     &                    mlwt) RESULT ( nroot )

C     Determines the root of an equation, nroot, that is located
C     between the lowerb and upperb. The equation of interest is defined
C     in the function soaequation. Before calling soabisect, the threshold 
C     for SOA should have already been checked which should ensure a solution.
C     The recommended lower bound is the number of moles of nonvolatile aerosol
C     and the recommended upper bound is the total number of organic moles
C
C     History
C     Created 7/2011 by HOT Pye

      Use utilio_defn
      Use runtime_vars, only: logdev


      Implicit None

C     Function arguments
      Real, Intent(IN) :: lowerb, upperb      ! lower bound, upper bound 
      Real, Intent(IN) :: nonvolmol           ! nonvolatile aerosol in moles = POA + non-voltile SOA
      Integer, Intent(IN) :: n
      Real, Intent(IN) :: cstaratt(n)   ! Cstars at T of interest
      Real, Intent(IN) :: totsemivol(n) ! total semivolatile to partition in ug/m3 (gas+aer+newlyformed)
      Real, Intent(IN) :: mlwt(n)       ! molecular weight of semivolatiles 

C     Parameters for solution convergenc
      Real             :: FRACTOL = 1.0e-6    ! Solution converged if abs(old-new)/new < FRACTOL
!     Real             :: ABSTOL  = 1.0e-10   ! Solution converged if there are less than ABSTOL umol/m3 in aerosol
      Real             :: ABSTOL  = 1.0e-08   ! Solution converged if there are less than ABSTOL umol/m3 in aerosol

C     Result
      Real             :: nroot               ! solution (final nguess)

C     Local variables
      Real             :: nguess              ! current guess for total moles organic aerosol
      Real             :: oldn, lower, upper, flower, fnguess ! intermediate values
      Real             :: fupper              ! function evaluated at upper bound
      Real             :: ea                  ! difference b/w old and new guesses (umol/m3)
      Real             :: test                ! to detect sign change
      Integer          :: iter                ! counter to prevent infinite loops
      Character( 120 ) :: xmsg

C     Store current lower and upper bound, evaluate at lower bound 
      lower  = lowerb
      upper  = upperb
      flower = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, lowerb )
      fupper = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, upperb )

C     First guess: solution at upperb
      nguess = upperb

C     Counter of iterations to prevent infinite loops
      iter = 0

C     Iterate until the number of moles changes by less than fractol (percent) or
C     abstol (absolute) amount
      Do

        If ( flower * fupper .gt. 0.0 ) Then
           ! function does not change sign between bounds
#ifdef verbose_soa
           nroot = soabisect_debug(lowerb, upperb, nonvolmol, cstaratt, totsemivol, mlwt)
#endif
           Write( xmsg,'(a,2(1pe15.5))' )
     &           'Error: no solution between bounds in soa bisection:', flower, fupper
           Call m3exit( pname, 0, 0, xmsg, xstat3)
        End If

        iter   = iter + 1
        oldn   = nguess                     ! store last guess
        nguess = ( lower + upper ) / 2.0e0  ! new guess is halfway b/w old lower and upper
        fnguess = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, nguess ) ! function evaluated at new guess
        If ( nguess .ne. 0.0 ) Then            ! safe division
           ea = Abs( nguess - oldn ) / nguess  ! fractional diff b/w 2 guesses
        Else
#ifdef verbose_soa
          nroot = soabisect_debug(lowerb, upperb, nonvolmol, cstaratt, totsemivol, mlwt)
          Write( xmsg,'(a,1pe15.5)' )
     &       'Warning: number of organic aerosol moles going to zero in soa bisection:',
     &        nroot
#else
          xmsg = 'Warning: number of organic aerosol moles going to zero in soa bisection'
#endif
          Call m3exit( pname, 0, 0, xmsg, xstat3 )
        End If

        test = fnguess * flower
        If ( test .Lt. 0.0 ) Then         ! if function changes sign b/w guess and lower, guess becomes upper
          upper  = nguess
          fupper = fnguess
        Else If ( test .Gt. 0.0 ) Then    ! if function does not change sign, guess becomes lowerbound
          lower  = nguess
          flower = fnguess
        Else If ( flower .Eq. 0.0 ) Then  ! if the lower bound is the root
          ea      = 0.0
          nguess  = lower
          fnguess = flower
        Else If ( fnguess .Eq. 0.0 ) Then ! guess is the root
          ea      = 0.0
        End If

        ! solution found if error is less than ABSTOL/100 % or N bounded by values less than ABSTOL
        If ( ( ea .Lt. FRACTOL ) .Or. ( ( upper + lower ) .Lt. ABSTOL ) ) Then
          nroot = nguess
          ! double check that the function is approximately zero
          fnguess = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, nguess ) ! function evaluated at new guess
          If ( Abs( fnguess ) .Gt. 1.0e-03 ) Then
!           pfc = pfc + 1
#ifdef verbose_soa
            nroot = soabisect_debug(lowerb, upperb, nonvolmol, cstaratt, totsemivol, mlwt)
!           Write( xmsg,'(a,2(1pe15.5,i8))' )
!    &      'Warning: possible false convergence in soa bisection:', fnguess, nroot, pfc
            Write( xmsg,'(a,2(1pe15.5))' )
     &      'Warning: possible false convergence in soa bisection:', fnguess, nroot
            Call m3warn( pname, 0, 0, xmsg )
#else
            xmsg = 'Warning: possible false convergence in soa bisection'
#endif
!           Call m3warn( pname, 0, 0, xmsg )
          End If

          Return
        End If

        If ( iter .Gt. 1000000 ) Then ! stop infinite loop
#ifdef verbose_soa
          nroot = soabisect_debug(lowerb, upperb, nonvolmol, cstaratt, totsemivol, mlwt)
          Write( xmsg,'(a,i9,1pe15.5)' )
     &      'Error: too many iterations in soa bisection', iter, nroot
#else
          xmsg = 'Error: too many iterations in soa bisection'
#endif
          Call m3exit( pname, 0, 0, xmsg, xstat3 )
        End If
      End Do

      End Function soabisect

C-----------------------------------------------------------------------
      Function soaequation( nonvmol, n, cstar, semivol, mlwt, currentN ) Result ( eqnerror )

C     Evaluates the following function of total aerosol moles, N
C     Function evaluates to zero at equilibrium 
C     
C                      totalsemivol_i        mols nonvolatile POA + SOA
C     f(N) = sum_i (  ----------------   ) + ---------------------------  - 1.0 
C                     cstar_i + mw_i*N                  N
C
C     History
C     Created 7/2011 HOT Pye
      Use runtime_vars, only: logdev

      Implicit None

C     Function inputs and output
      Real, INTENT(IN) :: nonvmol, currentN             ! nonvolatile moles, total moles
      Integer, INTENT(IN) :: n                          ! number of semivolatile species
      Real, INTENT(IN) :: mlwt(:)                    ! molecular weights of semivolatiles
      Real, INTENT(IN) :: semivol(:), cstar(:) ! semivolatile mass, sat conc in ug/m3
      Real             :: eqnerror                         ! result, deviation from 0.0 in equation

C     Local variables
      Real             :: temptot                          ! temporary total
      Integer          :: i                                ! counter

C     Compute function value for current value of N 
      temptot = 0.0e0
      Do i = 1, n
         temptot = temptot + semivol(i) / ( cstar(i) + mlwt(i) * currentN )
      End Do
      eqnerror = temptot + nonvmol / currentN - 1.0e0

      End function soaequation

C-----------------------------------------------------------------------
      Function soabisect_debug( lowerb, upperb, nonvolmol, n, cstaratt, totsemivol,
     &                          mlwt) RESULT ( nroot )

      Use utilio_defn
      Use runtime_vars

      Implicit None

C     Function arguments
      Real, Intent(IN) :: lowerb, upperb      ! lower bound, upper bound
      Real, Intent(IN) :: nonvolmol           ! nonvolatile aerosol in moles = POA + non-voltile SOA
      Integer, Intent(IN) :: n                ! Number of semivolatile species
      Real, Intent(IN) :: cstaratt(:)   ! Cstars at T of interest
      Real, Intent(IN) :: totsemivol(:) ! total semivolatile to partition in ug/m3 (gas+aer+newlyformed)
      Real, Intent(IN) :: mlwt(:)       ! molecular weight of semivolatiles

C     Parameters for solution convergenc
      Real             :: FRACTOL = 1.0e-6    ! Solution converged if abs(old-new)/new < FRACTOL
      Real             :: ABSTOL  = 1.0e-10   ! Solution converged if there are less than ABSTOL umol/m3 in aerosol

C     Result
      Real             :: nroot               ! solution (final nguess)

C External functions:

C     Local variables
      Logical, Save    :: first_time = .True.

      Real             :: nguess              ! current guess for total moles organic aerosol
      Real             :: oldn, lower, upper, flower, fnguess ! intermediate values
      Real             :: fupper              ! function evaluated at upper bound
      Real             :: ea                  ! difference b/w old and new guesses (umol/m3)
      Real             :: test                ! to detect sign change
      Integer          :: iter                ! counter to preventinfinite loops
      Character( 120 ) :: xmsg

      If ( first_time )  Then
        first_time = .False.
      End If

C     Store current lower and upper bound, evaluate at lower bound
      lower  = lowerb
      upper  = upperb
      flower = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, lowerb )
      fupper = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, upperb )

C     First guess: solution at upperb
      nguess = upperb

C     Counter of iterations to prevent infinite loops
      iter = 0

C     Iterate until the number of moles changes by less than fractol
C     (percent) or abstol (absolute) amount
      Do

        If ( flower * fupper .Gt. 0.0 ) Then
          ! function does not change sign between bounds
          xmsg = 'Error: no solution between bounds in soa bisection'
          Write( logdev,* ) xmsg
        End If

        iter    = iter + 1
        oldn    = nguess                    ! store last guess
        nguess  = ( lower + upper ) / 2.0e0 ! new guess is halfway b/w old lower and upper
        fnguess = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, nguess ) ! function evaluated at new guess

        Write( logdev,* ), 'iter   ', iter
        Write( logdev,* ), 'Lower= ', lower, flower
        Write( logdev,* ), 'Upper= ', upper, fupper
        Write( logdev,* ), 'Guess= ', nguess, fnguess

        If ( nguess .Ne. 0.0 ) Then           ! safe division
          ea = ABS( nguess - oldn )/nguess   ! fractional diff b/w 2guesses
        Else
          xmsg = 'Error: number of organic aerosol moles going to zero in soa bisection'
          Write( logdev,* ) xmsg
        End If

        Write( logdev,* ) 'error', ea
        test = fnguess * flower
        If ( test .Lt. 0.0 ) Then           ! if function changes sign b/w guess and lower, guess becomes upper
          upper  = nguess
          fupper = fnguess
        Else If ( test .Gt. 0.0 ) Then      ! if function does not change sign, guess becomes lowerbound
          lower  = nguess
          flower = fnguess
        Else If ( flower .Eq. 0.0 ) Then    ! if the lower bound is the root
          ea      = 0.0
          nguess  = lower
          fnguess = flower
        Else If ( fnguess .Eq. 0.0 ) Then   ! guess is the root
          ea      = 0.0
        End If

        ! solution found if error is less than ABSTOL/100 % or N bounded
        ! by values less than 1e-08
        If ( ( ea .Lt. FRACTOL ) .Or. ( ( upper + lower ) .Lt. ABSTOL ) ) then
          nroot = nguess
          ! double check that the function is approximately zero
          fnguess = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, nguess ) ! function evaluated at new guess
          If ( Abs( fnguess ) .Gt. 1.0e-03 ) Then
             xmsg = 'Warning: possible false convergence in soa bisection'
             Write( logdev,* ) xmsg
          End If

          Return
        End If

        If ( iter .Gt. 1000000 ) Then ! stop infinite loops
          !print*,'current lower, upper, and N: ',lower, upper, nguess
          xmsg = 'Error: too many iterations in soa bisection'
          Write( logdev,* ) xmsg
        End If
      End Do

      End Function soabisect_debug

!-----------------------------------------------

      Function activityw( rh, temp, dtot ) result( aw )

C Function calculates the activity of water
C over an aqueous solution droplet of specified diameter
C Equation 1 of Petters and Kreidenweis 2007 ACP:
C
C                   -4*surftens*Mw
C   aw  = RH * exp( ---------------)
C                     R*T*dens*D
C
C The diameter is the wet, volume equivalent, diameter of the particle.
      USE CONST, ONLY : rgasuniv

      Implicit None
                                       
C     Function arguments
      Real rh      ! RH between 0.005, 0.99 [fraction]
      Real temp    ! temperature [K]
      Real dtot    ! volume equivalent diameter of entire particle [m]

C     Function return value
      Real aw      ! activity of water [fraction]

C     Local variables
      Real partialaw ! intermediate value

C     Parameters
      Real, Parameter :: surftens = 0.072e0  ! surface tension of water [J/m2]
      Real, Parameter :: mwtwater = 0.018e0  ! molecular weight of water [kg/mol]
      Real, Parameter :: denswater = 1000e0  ! density of water [kg/m3]

C     Calculations
      partialaw = 4.0*surftens*mwtwater/(rgasuniv*temp*denswater)
      aw = rh / exp( partialaw/dtot )

      End Function activityw

!-----------------------------------------------

      End Module soa_defn

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module desid_util

!-----------------------------------------------------------------------
! Function: Define Emissions Utility Subroutines

! Revision History:
!     21 July 2020 B.Murphy: Extracted these variables from EMIS_DEFN
!-----------------------------------------------------------------------
      Use desid_vars

      Contains

!-----------------------------------------------------------------------
      SUBROUTINE DESID_GET_RULE_STREAMS( RULE_STREAM_NML0, IRULE, 
     &              RULE_STREAM, LREMOVE, LERROR )
!
! This subroutine analyzes the part of a rule identifying which streams
! to affect and searches for the individual streams, or, if the rule uses
! the 'ALL' keyword, this routine identifies every stream as impacted.
!-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE desid_param_module
      USE UTIL_FAMILY_MODULE


      IMPLICIT NONE

      CHARACTER(32), INTENT( IN ) :: RULE_STREAM_NML0
      CHARACTER(32)               :: RULE_STREAM_NML
      CHARACTER(32)               :: STREAM_NAME( DESID_N_SRM )
      INTEGER, INTENT( IN )       :: IRULE
      LOGICAL, INTENT( INOUT )    :: RULE_STREAM( DESID_N_SRM )
      LOGICAL, INTENT( INOUT )    :: LREMOVE
      LOGICAL, INTENT( INOUT )    :: LERROR

      INTEGER ISRM, IDX, NSRM, IFAM
      CHARACTER( 200 ) :: XMSG
      CHARACTER( 16 )  :: PNAME = "EMIS_SPC_MAP"
      INTEGER  :: JDATE = 0
      INTEGER  :: JTIME = 0

      ! Initialize the output vector
      RULE_STREAM = .FALSE.
      
      ! First Capitalize the Rule so it is easier to error-check
      RULE_STREAM_NML = RULE_STREAM_NML0
      CALL UPCASE( RULE_STREAM_NML )

      LREMOVE = .FALSE.
      LERROR  = .FALSE.

      IF ( RULE_STREAM_NML .EQ. 'ALL' .OR. RULE_STREAM_NML .EQ. 'TOTAL' ) THEN
         ! Special Case Where the Stream Identifier in the rule equals
         ! equals all 'ALL'. Expand the Rule to Apply to All Streams
         ISRM = 0
         IF ( N_FILE_GR .GT. 0 ) THEN
           RULE_STREAM( ISRM+1:N_FILE_GR ) = .TRUE.
           ISRM = ISRM + N_FILE_GR
         END IF

         IF ( NPTGRPS .GT. 0 ) THEN
           RULE_STREAM( ISRM+1:ISRM+NPTGRPS ) = .TRUE.
           ISRM = ISRM + NPTGRPS
         END IF
         IF ( N_FILE_TR .GT. 0 ) RULE_STREAM( ISRM+1:ISRM+N_FILE_TR ) = .TRUE.
         IF ( IBIOSRM .GT.0 ) RULE_STREAM( IBIOSRM  ) = .TRUE.
         IF ( IMGSRM  .GT.0 ) RULE_STREAM( IMGSRM   ) = .TRUE.
         IF ( IMETSRM .GT.0 ) RULE_STREAM( IMETSRM  ) = .TRUE.
         IF ( ILTSRM  .GT.0 ) RULE_STREAM( ILTSRM   ) = .TRUE.
         IF ( ISEASRM .GT.0 ) RULE_STREAM( ISEASRM  ) = .TRUE.
         IF ( IDUSTSRM.GT.0 ) RULE_STREAM( IDUSTSRM ) = .TRUE.
         IF ( IMIOGSRM.GT.0 ) RULE_STREAM( IMIOGSRM ) = .TRUE.


      ELSE
         ! Determine if the Stream Label Refers to A Family and if So, 
         ! Apply the Rule to all members of that Family
         IFAM = INDEX1( RULE_STREAM_NML, Desid_N_Stream_Fams, StreamFamilyName )
         IF ( IFAM .EQ. 0 ) THEN
             NSRM = 1
             STREAM_NAME(1) = RULE_STREAM_NML
         ELSE
             NSRM = StreamFamilyNum( IFAM )
             STREAM_NAME(1:NSRM) = StreamFamilyMembers( IFAM,1:NSRM )
         END IF

         ! Find the Specific Stream this Rule Identifies
         DO ISRM = 1,NSRM
           IDX = INDEX1( STREAM_NAME( ISRM ), DESID_N_SRM, DESID_STREAM_LAB ) 
           IF ( IDX .NE. 0 ) THEN
             RULE_STREAM( IDX ) = .TRUE.
           ELSE 
             ! Print warning that this stream is being ignored
             WRITE( LOGDEV, '(/,5x,3A,I3,/,5x,A,3(/,5x,A))' ),
     &         'Warning: The Emissions Stream Label (',TRIM( RULE_STREAM_NML ),
     &         ') applied for Rule ',IRULE,
     &         ' does not match any of the emissions stream labels or ',
     &         'members of stream families provided to CMAQ. Please check the ',
     &         'runscript against your emissions control inputs',
     &         'confirm that this stream should be ignored.'

             ! Confirm an Error
             LERROR = .TRUE.

             ! Remove this rule from the list of rules
             LREMOVE = .TRUE.
           END IF
         END DO
      END IF
 
      END SUBROUTINE DESID_GET_RULE_STREAMS

!-----------------------------------------------------------------------
      SUBROUTINE DESID_DIAG_MAP_SPEC( Spec, IDIAG, SPEC_VECTOR, JDIAG ) 
!
! This subroutine creates a map of emissions species taking into account 
! any references to chemical families or aerosol bulk names.
!-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE desid_param_module
      USE UTIL_FAMILY_MODULE
      USE VDIFF_MAP, ONLY : DIFF_SPC, N_SPC_DIFF, DIFF_MASK_GAS, 
     &                      DIFF_MASK_NUM, DIFF_MASK_SRF

      IMPLICIT NONE

      CHARACTER(16), INTENT( IN )  :: Spec( DESID_MAX_DIAG_SPEC )
      INTEGER, INTENT( IN )        :: IDIAG, JDIAG
      LOGICAL, INTENT( IN )        :: SPEC_VECTOR( N_SPC_DIFF )

      INTEGER ISRM, IDX, NSRM, IFAM, I, J
      INTEGER NSPEC_NML, NPAIRS, NSPEC
      LOGICAL EXPAND_SPEC
      CHARACTER(16)    :: SPECIES
      CHARACTER( 200 ) :: XMSG
      CHARACTER( 16 )  :: PNAME = "EMIS_SPC_MAP"
      INTEGER  :: JDATE = 0
      INTEGER  :: JTIME = 0
      LOGICAL  :: DIFF_VEC( N_SPC_DIFF )
      INTEGER  :: MAP_toDIFF( DESID_MAX_DIAG_SPEC*50 ), 
     &            MAP_toDIAG( DESID_MAX_DIAG_SPEC*50 )
      CHARACTER(16) :: UNITS( DESID_MAX_DIAG_SPEC*50 ),
     &                 DIAGSPEC( DESID_MAX_DIAG_SPEC*50 )


      ! Determine number of diagnostic species to output
      NSPEC_NML = INDEX1( '', DESID_MAX_DIAG_SPEC, Spec ) - 1
      IF ( NSPEC_NML .LE. 0 ) THEN
          WRITE( LOGDEV, * )
          WRITE( XMSG, '(A,I3,A)' ),
     &        'No Emission Species have been selected for group ',IDIAG,
     &        ' of the emission diagnostic input. Please correct.'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )     
      END IF

      ! Now Error Check and Expand the CMAQ Species Field
      NPAIRS = 0
      NSPEC  = 0
      
      DO I = 1,NSPEC_NML
         SPECIES = SPEC( I )
         Expand_Spec = .FALSE.
         IF ( SPECIES(1:1) .EQ. '*' ) THEN
             Expand_Spec = .TRUE.
             SPECIES(1:15) = SPECIES(2:16)
         END IF
         IF ( TRIM(SPECIES) .EQ. 'ALL' ) THEN
             Expand_Spec = .TRUE.
         END IF

         ! Retrieve logical vector, DIFF_VEC, indicating diffused species
         ! relevant for DiagSpec(I)
         CALL MAP_CHEM_FAMILIES( SPECIES, DIFF_SPC, N_SPC_DIFF, DIFF_VEC )
         DIFF_VEC = DIFF_VEC .AND. SPEC_VECTOR

         ! Save Map to translate each pair to diffused species and
         ! diagnostic species
         IF ( EXPAND_SPEC ) THEN 
            ! Add a Diagnostic Species for every expanded species
            DO J = 1,N_SPC_DIFF
               IF ( DIFF_VEC( J ) ) THEN
                   NSPEC = NSPEC + 1
                   DIAGSPEC( NSPEC ) = DIFF_SPC( J )

                   NPAIRS = NPAIRS + 1
                   MAP_toDIFF( NPAIRS ) = J
                   MAP_toDIAG( NPAIRS ) = NSPEC
                   IF ( DIFF_MASK_GAS( J ) ) THEN
                       ! GAS SPECIES
                       UNITS( NSPEC ) = 'mol s-1'
                   ELSE IF ( DIFF_MASK_NUM( J ) ) THEN
                       ! AEROSOL NUMBER SPECIES
                       UNITS( NSPEC ) = 'particles s-1'
                   ELSE IF ( DIFF_MASK_SRF( J ) ) THEN
                       ! AEROSOL SURFACE AREA SPECIES
                       UNITS( NSPEC ) = 'm2 s-1'
                   ELSE
                       ! AEROSOL MASS SPECIES
                       UNITS( NSPEC ) = 'g s-1'
                   END IF
               END IF
            END DO
         ELSE
            ! Keep only 1 diagnostic species and map all of the diffused
            ! species to it
            IF ( ANY( DIFF_VEC ) ) THEN
               NSPEC = NSPEC + 1
               DIAGSPEC( NSPEC ) = SPECIES
            END IF
            DO J = 1,N_SPC_DIFF
               IF ( DIFF_VEC( J ) ) THEN
                   NPAIRS = NPAIRS + 1
                   MAP_toDIFF( NPAIRS ) = J
                   MAP_toDIAG( NPAIRS ) = NSPEC
                   IF ( DIFF_MASK_GAS( J ) ) THEN
                       ! GAS SPECIES
                       UNITS( NSPEC ) = 'mol s-1'
                   ELSE IF ( DIFF_MASK_NUM( J ) ) THEN
                       ! AEROSOL NUMBER SPECIES
                       UNITS( NSPEC ) = 'particles s-1'
                   ELSE IF ( DIFF_MASK_SRF( J ) ) THEN
                       ! AEROSOL SURFACE AREA SPECIES
                       UNITS( NSPEC ) = 'm2 s-1'
                   ELSE
                       ! AEROSOL MASS SPECIES
                       UNITS( NSPEC ) = 'g s-1'
                   END IF
               END IF
            END DO
         END IF
      END DO

      DESID_DIAG_SPEC_BUFF( JDIAG )%NSPEC = NSPEC
      DESID_DIAG_SPEC_BUFF( JDIAG )%NPAIRS = NPAIRS 
      IF ( NSPEC .GT. 0 ) THEN
        IF ( ALLOCATED( DESID_DIAG_SPEC_BUFF( JDIAG )%SPEC ) )
     &      DEALLOCATE( DESID_DIAG_SPEC_BUFF( JDIAG )%SPEC )
        IF ( ALLOCATED( DESID_DIAG_SPEC_BUFF( JDIAG )%UNITS ) )
     &      DEALLOCATE( DESID_DIAG_SPEC_BUFF( JDIAG )%UNITS )
        IF ( ALLOCATED( DESID_DIAG_SPEC_BUFF( JDIAG )%MAP_toDIFF ) )
     &      DEALLOCATE( DESID_DIAG_SPEC_BUFF( JDIAG )%MAP_toDIFF )
        IF ( ALLOCATED( DESID_DIAG_SPEC_BUFF( JDIAG )%MAP_toDIAG ) ) 
     &      DEALLOCATE( DESID_DIAG_SPEC_BUFF( JDIAG )%MAP_toDIAG )

        ALLOCATE( DESID_DIAG_SPEC_BUFF( JDIAG )%SPEC( NSPEC ) )
        ALLOCATE( DESID_DIAG_SPEC_BUFF( JDIAG )%UNITS( NSPEC ) )
        ALLOCATE( DESID_DIAG_SPEC_BUFF( JDIAG )%MAP_toDIFF( NPAIRS ) )
        ALLOCATE( DESID_DIAG_SPEC_BUFF( JDIAG )%MAP_toDIAG( NPAIRS ) )

        DESID_DIAG_SPEC_BUFF( JDIAG )%SPEC  = DIAGSPEC( 1:NSPEC )
        DESID_DIAG_SPEC_BUFF( JDIAG )%UNITS = UNITS( 1:NSPEC )
        DESID_DIAG_SPEC_BUFF( JDIAG )%MAP_toDIFF = MAP_toDIFF( 1:NPAIRS )
        DESID_DIAG_SPEC_BUFF( JDIAG )%MAP_toDIAG = MAP_toDIAG( 1:NPAIRS )
      END IF

      END SUBROUTINE DESID_DIAG_MAP_SPEC
 
!-----------------------------------------------------------------------
      SUBROUTINE DESID_GET_ONLINE_RULES( N_RULE )
!
!     This subroutine defines several hardcoded rules for emissions
!     scaling that will apply by default. These include subtracting NH3
!     from fertilizer emissions if BiDi is turned on, moving all
!     sulfuric acid vapor to the particle phase upon emission and
!     splitting up the coarse mode anthropogenic emissions mass into
!     speciated compounds.
!-----------------------------------------------------------------------

      USE AERO_DATA, ONLY : ACORSEM_ASO4_FAC

      IMPLICIT NONE
      
      INTEGER,         INTENT( INOUT ) :: N_RULE
      TYPE( DESID_RULES_TYPE )         :: EM_NML( 20 )

      INTEGER :: N_RULE_B, IRULE, ISRM

      N_RULE_B = 0
 
      ! Add a rule For Removing Fertilizer Ammonia if BiDi is
      ! activated and the user has requested the correction
         IF ( ABFLUX ) THEN
            N_RULE_B = N_RULE_B + 1
            EM_NML(N_RULE_B)%SPEC  = 'NH3'
            EM_NML(N_RULE_B)%STREAM= 'ALL'
            EM_NML(N_RULE_B)%PHASE = 'GAS'
            EM_NML(N_RULE_B)%EMVAR = 'NH3_FERT'
            EM_NML(N_RULE_B)%FAC   = -1.0
            EM_NML(N_RULE_B)%BASIS = 'UNIT'
            EM_NML(N_RULE_B)%OP    = 'a'
            EM_NML(N_RULE_B)%REGION= 'EVERYWHERE'
         END IF

      ! sulfur tracking instrument model option
         IF ( STM ) THEN
      ! SULF emissions
            N_RULE_B = N_RULE_B + 1
            EM_NML(N_RULE_B)%SPEC  = 'ASO4EMIS'
            EM_NML(N_RULE_B)%STREAM= 'ALL'
            EM_NML(N_RULE_B)%PHASE = 'FINE'
            EM_NML(N_RULE_B)%EMVAR = 'SULF'
            EM_NML(N_RULE_B)%FAC   = 1.0
            EM_NML(N_RULE_B)%BASIS = 'MASS'
            EM_NML(N_RULE_B)%OP    = 'a' 
            EM_NML(N_RULE_B)%REGION= 'EVERYWHERE'
      !  PSO4 emissions 
            N_RULE_B = N_RULE_B + 1
            EM_NML(N_RULE_B)%SPEC  = 'ASO4EMIS'
            EM_NML(N_RULE_B)%STREAM= 'ALL'
            EM_NML(N_RULE_B)%PHASE = 'FINE'
            EM_NML(N_RULE_B)%EMVAR = 'PSO4'
            EM_NML(N_RULE_B)%FAC   = 1.0
            EM_NML(N_RULE_B)%BASIS = 'UNIT'
            EM_NML(N_RULE_B)%OP    = 'a' 
            EM_NML(N_RULE_B)%REGION= 'EVERYWHERE'
      ! Coarse-Mode Sulfate
            N_RULE_B = N_RULE_B + 1
            EM_NML(N_RULE_B)%SPEC  = 'ASO4EMIS'
            EM_NML(N_RULE_B)%STREAM= 'ALL'
            EM_NML(N_RULE_B)%PHASE = 'COARSE'
            EM_NML(N_RULE_B)%EMVAR = 'PMC'
            EM_NML(N_RULE_B)%FAC   = REAL( ACORSEM_ASO4_FAC, 4 ) 
            EM_NML(N_RULE_B)%BASIS = 'UNIT'
            EM_NML(N_RULE_B)%OP    = 'a' 
            EM_NML(N_RULE_B)%REGION= 'EVERYWHERE'
      !  Wind blown dust and sea spray SO4 emissions 
      !  Fine
            N_RULE_B = N_RULE_B + 1
            EM_NML(N_RULE_B)%SPEC  = 'ASO4EMIS'
            EM_NML(N_RULE_B)%STREAM= 'ALL'
            EM_NML(N_RULE_B)%PHASE = 'FINE'
            EM_NML(N_RULE_B)%EMVAR = 'PMFINE_SO4'
            EM_NML(N_RULE_B)%FAC   = 1.0
            EM_NML(N_RULE_B)%BASIS = 'UNIT'
            EM_NML(N_RULE_B)%OP    = 'a' 
            EM_NML(N_RULE_B)%REGION= 'EVERYWHERE'
      !  Coarse 
            N_RULE_B = N_RULE_B + 1
            EM_NML(N_RULE_B)%SPEC  = 'ASO4EMIS'
            EM_NML(N_RULE_B)%STREAM= 'ALL'
            EM_NML(N_RULE_B)%PHASE = 'COARSE'
            EM_NML(N_RULE_B)%EMVAR = 'PMCOARSE_SO4'
            EM_NML(N_RULE_B)%FAC   = 1.0
            EM_NML(N_RULE_B)%BASIS = 'UNIT'
            EM_NML(N_RULE_B)%OP    = 'a' 
            EM_NML(N_RULE_B)%REGION= 'EVERYWHERE'
         END IF ! stm

      ! Add Rules to Existing List at Beginning
         N_RULE = N_RULE + N_RULE_B
         DO IRULE = N_RULE, N_RULE_B+1, -1
            DESID_RULES_NML( IRULE ) = DESID_RULES_NML( IRULE - N_RULE_B )
         END DO
         DO IRULE = 1,N_RULE_B
            DESID_RULES_NML( IRULE ) = EM_NML( IRULE ) 
         END DO

      END SUBROUTINE DESID_GET_ONLINE_RULES

!-----------------------------------------------------------------------
         SUBROUTINE CHECK_EMIS_UNITS( ISRM, ISUR, SPEC, UNITS, CONV, BASIS,
     &                                LAREA_UNIT )

! This subroutine checks for invalid values of the operation parameter 
! in the rules from the emission control list

         use utilio_defn


         IMPLICIT NONE

         REAL, INTENT( OUT )              :: CONV
         CHARACTER( 16 ) , INTENT( OUT )  :: BASIS
         LOGICAL, INTENT( INOUT )         :: LAREA_UNIT
         CHARACTER( 16 ), INTENT( INOUT ) :: UNITS
         INTEGER, INTENT( IN )            :: ISRM
         INTEGER, INTENT( IN )            :: ISUR
         CHARACTER( 16 ), INTENT( IN )    :: SPEC
         CHARACTER( 400 )      :: XMSG
         INTEGER               :: X, SLASH_IND
         
         CHARACTER( 16 ) :: NUMER
         CHARACTER( 16 ) :: DENOM
         CHARACTER( 16 ) :: DENOM1
         CHARACTER( 16 ) :: DENOM2
         LOGICAL         :: LTIME_UNIT

         REAL, PARAMETER  :: AVO  = 6.0221367E23
         REAL, PARAMETER  :: RAVO = 1.0 / AVO

         ! The Default Finding is an unknown Basis unit and conversion
         ! equal to 1.0
         CONV = 1.0
         LAREA_UNIT = .FALSE.
         LTIME_UNIT = .FALSE.
         BASIS = 'UNKNOWN'
         IF ( UNITS .EQ. '' ) RETURN
         
         ! Capitalize UNITS string and remove any leading spaces 
         CALL UPCASE( UNITS ) 
         DO WHILE ( UNITS(1:1) .EQ. ' ' ) 
             UNITS = UNITS(2:16) // ' '
         END DO

         ! Find First Break between numerator and denominator. If it's not a
         ! slash, then it should be the first space. 
         SLASH_IND = INDEX( UNITS, '/' )
         IF ( SLASH_IND .EQ. 0 ) SLASH_IND = INDEX( UNITS, ' ' )
         X = SLASH_IND - 1
         NUMER = UNITS(1:X)

         ! If there are no slashes or spaces, then exit
         IF ( SLASH_IND .EQ. 0 ) RETURN

         ! Check numerator for molecule units
         ! This has to come before the check for molar units since the
         !   check for mole, moles, or mol will also match molecule
         IF ( NUMER(1:8) .EQ. 'MOLECULE'  .OR.
     &        NUMER(1:9) .EQ. 'MOLECULES' .OR.
     &        NUMER(1:5) .EQ. 'MOLEC'     .OR.
     &        NUMER(1:6) .EQ. 'MOLECS' ) THEN
            ! Convert molecules -> mol
            CONV = RAVO
            BASIS = 'MOLE'
         ! Check Numerator for Molar or Mass Units
         ELSE IF ( NUMER(1:4) .EQ. 'MOLE' .OR. NUMER(1:5) .EQ. 'MOLES' .OR.
     &        NUMER(1:3) .EQ. 'MOL' ) THEN
            ! No Conversion Needed for Moles to Moles
            BASIS = 'MOLE'
         ELSE IF ( NUMER(1:5) .EQ. 'KMOLE' .OR. NUMER(1:6) .EQ. 'KMOLES' .OR.
     &             NUMER(1:4) .EQ. 'KMOL' ) THEN
            ! Convert kmol to mol
            CONV = 1000.0
            BASIS = 'MOLE'
         ELSE IF ( NUMER(1:5) .EQ. 'MMOLE' .OR. NUMER(1:6) .EQ. 'MMOLES' .OR.
     &             NUMER(1:4) .EQ. 'MMOL' ) THEN
            ! Convert mmol to mol
            CONV = 1.0e-3
            BASIS = 'MOLE'
         ELSE IF ( NUMER(1:5) .EQ. 'UMOLE' .OR. NUMER(1:6) .EQ. 'UMOLES' .OR.
     &             NUMER(1:4) .EQ. 'UMOL' ) THEN
            ! Convert umol to mol
            CONV = 1.0e-6
            BASIS = 'MOLE'
         ELSE IF ( NUMER(1:4) .EQ. 'GRAM' .OR. NUMER(1:5) .EQ. 'GRAMS' .OR.
     &             NUMER(1:1) .EQ. 'G'    .OR. NUMER(1:2) .EQ. 'GM'    .OR.
     &             NUMER(1:3) .EQ. 'GMS'  .OR. NUMER(1:2) .EQ. 'GS'  ) THEN
            ! No Conversion Needed for Grams to Grams
            BASIS = 'MASS'
         ELSE IF ( NUMER(1:5) .EQ. 'KGRAM' .OR. NUMER(1:6) .EQ. 'KGRAMS' .OR.
     &             NUMER(1:2) .EQ. 'KG'    .OR. NUMER(1:3) .EQ. 'KGM'    .OR.
     &             NUMER(1:4) .EQ. 'KGMS'  .OR. NUMER(1:3) .EQ. 'KGS' ) THEN
            ! Convert kg -> g
            CONV = 1000.0
            BASIS = 'MASS'
         ELSE IF ( NUMER(1:5) .EQ. 'MGRAM' .OR. NUMER(1:6) .EQ. 'MGRAMS' .OR.
     &             NUMER(1:2) .EQ. 'MG'    .OR. NUMER(1:3) .EQ. 'MGM'    .OR.
     &             NUMER(1:4) .EQ. 'MGMS'  .OR. NUMER(1:3) .EQ. 'MGS' ) THEN
            ! Convert mg -> g
            CONV = 1.0e-3
            BASIS = 'MASS'
         ELSE IF ( NUMER(1:5) .EQ. 'UGRAM' .OR. NUMER(1:6) .EQ. 'UGRAMS' .OR.
     &             NUMER(1:2) .EQ. 'UG'    .OR. NUMER(1:3) .EQ. 'UGM'    .OR.
     &             NUMER(1:3) .EQ. 'UGMS'  .OR. NUMER(1:3) .EQ. 'UGS' ) THEN
            ! Convert ug -> g
            CONV = 1.0e-6
            BASIS = 'MASS'
         ELSE IF ( NUMER(1:5) .EQ. 'NGRAM' .OR. NUMER(1:6) .EQ. 'NGRAMS' .OR.
     &             NUMER(1:2) .EQ. 'NG'    .OR. NUMER(1:3) .EQ. 'NGM'    .OR.
     &             NUMER(1:4) .EQ. 'NGMS'  .OR. NUMER(1:3) .EQ. 'NGS' ) THEN
            ! Convert ng -> g
            CONV = 1.0e-9
            BASIS = 'MASS'
         ELSE
            WRITE( XMSG,'(A,A16,A,I3,A11,A16,A,A,A)' ),
     &              'ERROR: Species ',TRIM(SPEC),' on emission stream ',
     &              ISRM, ' has units ',TRIM(UNITS),' which are not recognized ',
     &              'as an emission rate. If you wish to use this variable for ',
     &              'emissions, please correct the units (e.g. g/s or moles/s).'
            CALL M3WARN( 'CHECK_EMIS_UNITS', 0, 0, XMSG )
            ! No Conversion and and Unknown Basis
            BASIS = 'UNKNOWN'
         END IF
         
         ! Identify Denominator. Return from subroutine if the
         ! denominator is empty.
         DENOM = UNITS(X+2:)
         IF ( DENOM .EQ. '' ) THEN
            WRITE( XMSG,'(A,A16,A,I3,A11,A16,A,A,A,A)' ),
     &              'ERROR: Species ',TRIM(SPEC),' on emission stream ',
     &              ISRM, ' has units ',TRIM(UNITS),' which are not recognized ',
     &              'as an emission rate. If you wish to use this variable for ',
     &              'emissions, please correct the units (e.g. g/s, moles/s, ',
     &              'g/m2/s, or g/s/m2, etc.).'
            CALL M3WARN( 'CHECK_EMIS_UNITS', 0, 0, XMSG )
            ! No Conversion and and Unknown Basis
            BASIS = 'UNKNOWN' 
            RETURN
         END IF

         ! Remove Leading Spaces, if any
         DO WHILE ( DENOM(1:1) .EQ. ' ' ) 
             DENOM = DENOM(2:16) // ' '
         END DO

         ! Now split the Denominator into two parts, before and after
         ! the slash or space. There will be at least one space because the
         ! numerator has been cut from the units string, thus leaving at
         ! least one empty space.
         SLASH_IND = INDEX( DENOM, '/' )
         IF ( SLASH_IND .EQ. 0 ) SLASH_IND = INDEX( DENOM, ' ' )
         X = SLASH_IND - 1 
         DENOM1 = DENOM(1:X)
         DENOM2 = DENOM(X+2:)
         
         ! Parse the first Denominator and return attributes
         CALL CHECK_UNIT_DENOMINATOR( DENOM1, LAREA_UNIT, LTIME_UNIT, 
     &                                BASIS, CONV )
         IF ( BASIS .EQ. 'UNKNOWN' ) THEN
            WRITE( XMSG,'(A,A16,A,I3,A11,A16,A,A,A,A)' ),
     &              'ERROR: Species ',TRIM(SPEC),' on emission stream ',
     &              ISRM, ' has units ',TRIM(UNITS),' which are not recognized ',
     &              'as an emission rate. If you wish to use this variable for ',
     &              'emissions, please correct the units (e.g. g/s, moles/s, ',
     &              'g/m2/s, or g/s/m2, etc.).'
            CALL M3WARN( 'CHECK_EMIS_UNITS', 0, 0, XMSG )
            RETURN
         END IF

         ! Parse the second Denominator and return attributes
         IF ( DENOM2 .NE. '' ) THEN
            CALL CHECK_UNIT_DENOMINATOR( DENOM2, LAREA_UNIT, LTIME_UNIT, 
     &                                   BASIS, CONV )
            IF ( BASIS .EQ. 'UNKNOWN' ) THEN
               WRITE( XMSG,'(A,A16,A,I3,A11,A16,A,A,A,A)' ),
     &                'ERROR: Species ',TRIM(SPEC),' on emission stream ',
     &                ISRM, ' has units ',TRIM(UNITS),' which are not recognized ',
     &                'as an emission rate. If you wish to use this variable for ',
     &                'emissions, please correct the units (e.g. g/s, moles/s, ',
     &                'g/m2/s, or g/s/m2, etc.).'
               CALL M3WARN( 'CHECK_EMIS_UNITS', 0, 0, XMSG )
               RETURN
            END IF
         END IF

         ! Check to make sure the time component has been defined 
         IF ( .NOT. LTIME_UNIT ) THEN
            WRITE( XMSG,'(A,A16,A,I3,A11,A16,A,A,A,A)' ),
     &             'ERROR: Species ',TRIM(SPEC),' on emission stream ',
     &             ISRM, ' has units ',TRIM(UNITS),' which are not recognized ',
     &             'as an emission rate. If you wish to use this variable for ',
     &             'emissions, please correct the units (e.g. g/s, moles/s, ',
     &             'g/m2/s, or g/s/m2, etc.).'
            CALL M3WARN( 'CHECK_EMIS_UNITS', 0, 0, XMSG )
            BASIS = 'UNKNOWN'
            RETURN
         END IF 

         END SUBROUTINE CHECK_EMIS_UNITS
 
!-----------------------------------------------------------------------
         SUBROUTINE CHECK_UNIT_DENOMINATOR( DENOM, LAREA, LTIME, BASIS, CONV)

! This subroutine compares the denominator from the units string of an
! emission variables to potential time and area units and determines how
! to convert the emissions online in DESID.
!-----------------------------------------------------------------------

         IMPLICIT NONE

         CHARACTER(16), INTENT( IN )   :: DENOM
         LOGICAL, INTENT( OUT )        :: LAREA
         LOGICAL, INTENT( OUT )        :: LTIME
         CHARACTER(16), INTENT( INOUT ):: BASIS
         REAL, INTENT( INOUT)          :: CONV

         ! Check 1st Denominator for Time Units
         IF ( DENOM .EQ. 'S' .OR. DENOM .EQ. 'S-1' .OR.
     &        DENOM .EQ. 'SEC'.OR.DENOM .EQ. 'SEC-1' .OR.
     &        DENOM .EQ. 'SECOND'.OR.DENOM .EQ. 'SECOND-1' .OR.
     &        DENOM .EQ. 'SECONDS'.OR.DENOM .EQ. 'SECONDS-1' ) THEN
            ! No Conversion Necessary for seconds -> seconds
            CONV = CONV * 1.0
            LTIME = .TRUE.
         ELSE IF ( DENOM .EQ. 'H' .OR. DENOM .EQ. 'H-1' .OR.
     &             DENOM .EQ. 'HR'.OR.DENOM .EQ. 'HR-1' .OR.
     &             DENOM .EQ. 'HRS'.OR.DENOM .EQ. 'HRS-1' .OR.
     &             DENOM .EQ. 'HOUR'.OR.DENOM .EQ. 'HOUR-1' .OR.
     &             DENOM .EQ. 'HOURS'.OR.DENOM .EQ. 'HOURS-1' ) THEN
            ! Convert hours -> seconds
            CONV = CONV / 3600.0
            LTIME = .TRUE.
         ELSE IF ( DENOM .EQ. 'M' .OR. DENOM .EQ. 'M-1' .OR.
     &             DENOM .EQ. 'MIN'.OR.DENOM .EQ. 'MIN-1' .OR.
     &             DENOM .EQ. 'MINUTE'.OR.DENOM .EQ. 'MINUTE-1' .OR.
     &             DENOM .EQ. 'MINUTES'.OR.DENOM .EQ. 'MINUTES-1' ) THEN
            ! Convert minutes -> seconds
            CONV = CONV / 60.0
            LTIME = .TRUE.
         ELSE IF ( DENOM .EQ. 'M2' .OR. DENOM .EQ. 'M-2' .OR.
     &             DENOM .EQ. 'M^2'.OR.DENOM .EQ. 'METER-2' .OR.
     &             DENOM .EQ. 'METER^2'.OR.DENOM .EQ. 'METER^-2' .OR.
     &             DENOM .EQ. 'METER2'.OR.DENOM .EQ. 'METER-2' .OR.
     &             DENOM .EQ. 'METERS^2'.OR.DENOM .EQ. 'METERS^-2' .OR.
     &             DENOM .EQ. 'METERS2'.OR.DENOM .EQ. 'METERS-2' ) THEN
            ! No conversion necessary for meters^2 -> meters^2
            LAREA = .TRUE. 
         ELSE IF ( DENOM .EQ. 'KM2' .OR. DENOM .EQ. 'KM-2' .OR.
     &             DENOM .EQ. 'KM^2'.OR.DENOM .EQ. 'KM^-2' .OR.
     &             DENOM .EQ. 'KILOMETER2'.OR.DENOM .EQ. 'KILOMETER-2' .OR.
     &             DENOM .EQ. 'KILOMETER^2'.OR.DENOM .EQ. 'KILOMETER^-2' .OR.
     &             DENOM .EQ. 'KILOMETERS2'.OR.DENOM .EQ. 'KILOMETERS-2' .OR.
     &             DENOM .EQ. 'KILOMETERS^2'.OR.DENOM .EQ. 'KILOMETERS-2' ) THEN
            ! Convert kilometers^2 -> meters^2
            CONV = CONV / 1.0E6
            LAREA = .TRUE.
         ELSE IF ( DENOM .EQ. 'CM2' .OR. DENOM .EQ. 'CM-2' .OR.
     &             DENOM .EQ. 'CM^2'.OR.DENOM .EQ. 'CM^-2' .OR.
     &             DENOM .EQ. 'CENTIMETER2'.OR.DENOM .EQ. 'CENTIMETER-2' .OR.
     &             DENOM .EQ. 'CENTIMETER^2'.OR.DENOM .EQ. 'CENTIMETER^-2' .OR.
     &             DENOM .EQ. 'CENTIMETERS2'.OR.DENOM .EQ. 'CENTIMETERS-2' .OR.
     &             DENOM .EQ. 'CENTIMETERS^2'.OR.DENOM .EQ. 'CENTIMETERS-2' ) THEN
            ! Convert centimeters^2 -> meters^2
            CONV = CONV / 1.0E-4
            LAREA = .TRUE.
         ELSE IF ( DENOM .EQ. 'MI2' .OR. DENOM .EQ. 'MI-2' .OR.
     &             DENOM .EQ. 'MI^2'.OR.DENOM .EQ. 'MI^-2' .OR.
     &             DENOM .EQ. 'MILE2'.OR.DENOM .EQ. 'MILE-2' .OR.
     &             DENOM .EQ. 'MILE^2'.OR.DENOM .EQ. 'MILE^-2' .OR.
     &             DENOM .EQ. 'MILES2'.OR.DENOM .EQ. 'MILES-2' .OR.
     &             DENOM .EQ. 'MILES^2'.OR.DENOM .EQ. 'MILES-2' ) THEN
            ! Convert mile^2 -> meters^2
            CONV = CONV / 2.59E6
            LAREA = .TRUE.  
         ELSE IF ( DENOM .EQ. 'HA' .OR. DENOM .EQ. 'HA-1' .OR.
     &             DENOM .EQ. 'HA^1'.OR.DENOM .EQ. 'HA^-1' .OR.
     &             DENOM .EQ. 'HECTARE'.OR.DENOM .EQ. 'HECTARE-1' .OR.
     &             DENOM .EQ. 'HECTARE^1'.OR.DENOM .EQ. 'HECTARE^-1' .OR.
     &             DENOM .EQ. 'HECTARES'.OR.DENOM .EQ. 'HECTARES-1' .OR.
     &             DENOM .EQ. 'HECTARES^1'.OR.DENOM .EQ. 'HECTARES^-1' ) THEN
            ! Convert hectares -> meters^2
            CONV = CONV / 10000.0
            LAREA = .TRUE.   
         ELSE
            ! No Conversion and and Unknown Basis
            CONV = CONV * 1.0e0
            BASIS = 'UNKNOWN'
         END IF

      END SUBROUTINE CHECK_UNIT_DENOMINATOR
 
!-----------------------------------------------------------------------
         SUBROUTINE CHECK_OP( OP, IRULE )

! This subroutine checks for invalid values of the operation parameter 
! in the rules from the emission control list

         use utilio_defn

         IMPLICIT NONE

         CHARACTER( 1 )        :: OP
         INTEGER, INTENT( IN ) :: IRULE
         CHARACTER( 200 )      :: XMSG

         IF ( OP .EQ. 'A' .OR. OP .EQ. 'a' ) THEN
             OP = 'a'
         ELSE IF ( OP .EQ. 'M' .OR. OP .EQ. 'm' ) THEN
             OP = 'm'
         ELSE IF ( OP .EQ. 'O' .OR. OP .EQ. 'o' ) THEN
             OP = 'o'
         ELSE
             WRITE( XMSG,'(A,I3,A,A1)' ),
     &              'ERROR: OP parameter for rule ',IRULE,
     &              ' has invalid value: ',OP
             CALL M3EXIT( 'CHECK_OP (EMIS_DEFN)', 0, 0, XMSG, 2 )
         END IF

         END SUBROUTINE CHECK_OP
 
!-----------------------------------------------------------------------
         SUBROUTINE CHECK_BASIS( BASIS, IRULE )

! This subroutine checks for invalid values of the operation parameter 
! in the rules from the emission control list

         use utilio_defn

         IMPLICIT NONE

         CHARACTER( 4 )        :: BASIS
         INTEGER, INTENT( IN ) :: IRULE
         CHARACTER( 200 )      :: XMSG

         IF ( BASIS .EQ. 'mole' .OR. BASIS .EQ. 'MOLE' .OR.
     &        BASIS .EQ. 'Mole' ) THEN
             BASIS = 'MOLE'
         ELSE IF ( BASIS .EQ. 'mass' .OR. BASIS .EQ. 'MASS' .OR.
     &             BASIS .EQ. 'Mass' ) THEN
             BASIS = 'MASS'
         ELSE IF ( BASIS .EQ. 'unit' .OR. BASIS .EQ. 'UNIT' .OR.
     &             BASIS .EQ. 'Unit' ) THEN
             BASIS = 'UNIT'
         ELSE
             WRITE( XMSG,'(A,I3,A,A4)' ),
     &              'ERROR: BASIS parameter for rule ',IRULE,
     &              ' has invalid value: ',BASIS
             CALL M3EXIT( 'CHECK_BASIS (EMIS_DEFN)', 0, 0, XMSG, 2 )
         END IF

         END SUBROUTINE CHECK_BASIS
 
!-----------------------------------------------------------------------
      FUNCTION RESOLVE_YN_TF_2D3D( ARG ) RESULT( ARGOUT )

!-----------------------------------------------------------------------
        IMPLICIT NONE

        CHARACTER( 6 ) :: ARG, ARGOUT
 
         IF ( ARG .EQ. 'FALSE' .OR. ARG .EQ. 'F' .OR.
     &        ARG .EQ. 'NO'    .OR. ARG .EQ. 'N' ) THEN
            ARGOUT = 'FALSE'
         ELSEIF ( ARG .EQ. 'TRUE' .OR. ARG .EQ. 'T' .OR.
     &            ARG .EQ. 'YES'  .OR. ARG .EQ. 'Y' ) THEN
            ARGOUT = 'TRUE'
         ELSEIF ( ARG .EQ. '2D'  .OR. ARG .EQ. '2d' ) THEN
            ARGOUT = 'TRUE'
         ELSEIF   ( ARG .EQ. '3D'  .OR. ARG .EQ. '3d' ) THEN
            ARGOUT = '3D'
         ELSEIF   ( ARG .EQ. '2DSUM' .OR. ARG .EQ. '2dSUM' .OR.
     &              ARG .EQ. '2dsum' ) THEN
            ARGOUT = '2DSUM'
         END IF
 
         RETURN

      END FUNCTION RESOLVE_YN_TF_2D3D

 
      END MODULE DESID_UTIL

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE SSEMIS
C-----------------------------------------------------------------------
C Description:

C Revision History:
C   04 Apr 11 S.Howard: generalization to accomodate different sea-salt speciation
C                       in aero5 and aero6
C   07 Apr 11 J.Young: additional mods
C   07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module.
C   12 Aug 15 D.Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O implementation
C   09 Dec 15 D.Wong: Open CTM_SSEMIS_1 file in a IO_PE_INCLUSIVE conditional block
C   24 Mar 16 G.Sarwar: updated to calculate NACL emissions (needed for BR2 emissions) 
C   16 Aug 18 G. Sarwar: Removed NACL
C    1 Feb 19 David Wong: removed all MY_N clauses
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE HGRD_DEFN
      USE AERO_DATA, ONLY: N_MODE
      USE DESID_VARS

      IMPLICIT NONE

C Number of chemical species in fresh sea-salt aerosol
      INTEGER :: NSSSPC

C Sea-Salt Emissions Rates
      PUBLIC NSSSPC, SSEMIS_INIT, GET_SSEMIS, SEA_FACTNUM, SEA_FACTSRF, SSOUTM
      PRIVATE

C Variable for converting from volume-normalized emissions to total
C emission rate
      REAL, ALLOCATABLE :: GSFAC( :,: )  ! [m3]

C Position of H2O in sea-salt emission arrays
      INTEGER :: KH2O

C Variables for the sea-salt diagnostic file
      INTEGER :: NSSDIAG                ! number of species in sea-salt
                                        ! diagnostic emission file
      Real,    ALLOCATABLE, SAVE :: SSOUTM( :,:,: )  ! SeaSpray Mass Emiss Rate [ug/m3/s]
      Real,    ALLOCATABLE, SAVE :: SSOUTN( :,:,: )  ! SeaSpray Number Emiss Rate [1/m3/s]
      Real,    ALLOCATABLE, SAVE :: SSOUTS( :,:,: )  ! SeaSpray Surface Area Emiss Rate [m2/m3/s]
      REAL,    ALLOCATABLE       :: SSOUTD( : )   ! emission rates
      REAL,    ALLOCATABLE, SAVE :: SSBF( :,:,: ) ! seasalt emiss accumulator
      REAL,    ALLOCATABLE, SAVE :: WRSS( :,: )   ! seasalt emiss write buffer
      REAL,    ALLOCATABLE, SAVE :: SEA_FACTNUM( :,:,: ) ! Array for scaling Number Emissions
      REAL,    ALLOCATABLE, SAVE :: SEA_FACTSRF( :,:,: ) ! Array for scaling Surface Area Emissions 

C Species names in the speciated sea-salt-emissions
      CHARACTER( 16 ), ALLOCATABLE :: WRSS_SPC( : )  ! species names

C Lognormal parameters fit to the open-ocean flux function
      REAL,    SAVE :: DGNJ( 136 )     ! geom mean diam of accum-mode [um]
      REAL,    SAVE :: DGNK( 136 )     ! geom mean diam of coarse-mode [um]
      REAL,    SAVE :: SIGJ( 136 )     ! geom std deviation of accum-mode flux
      REAL,    SAVE :: SIGK( 136 )     ! geom std deviation of coarse-mode flux
      REAL,    SAVE :: FNJ ( 136 )     ! magnitude of accum-mode flux [1/m2/s]
      REAL,    SAVE :: FNK ( 136 )     ! magnitude of coarse-mode flux [1/m2/s]

C Open-ocean flux numerically integrated over size range of interest
      REAL,    SAVE :: VFLUX( 136 )    ! total particle volume flux [m3/m2/s]

C Polycoeffs from Zhang et al. (2005)
      REAL( 8 ), SAVE :: C0_COEFF( 6 )   ! Eq 8
      REAL( 8 ), SAVE :: X_COEFF( 6 )    ! Eq 1

      INTEGER I

C-------------------------- Data Statements ----------------------------

C RH-dependent values calculated using MATLAB for THETA = 8 from Gong (2003)

C Geometric mean diameter of accumulation mode [um]
      DATA ( DGNJ( I ), I = 1, 136 ) /
     &      0.0913, 0.0917, 0.0921, 0.0925, 0.0929, 0.0933, 0.0938, 0.0942,
     &      0.0946, 0.0951, 0.0956, 0.0961, 0.0967, 0.0972, 0.0977, 0.0984,
     &      0.0990, 0.0996, 0.1002, 0.1010, 0.1017, 0.1024, 0.1032, 0.1040,
     &      0.1048, 0.1058, 0.1067, 0.1077, 0.1087, 0.1098, 0.1110, 0.1123,
     &      0.1136, 0.1150, 0.1165, 0.1181, 0.1198, 0.1217, 0.1237, 0.1259,
     &      0.1283, 0.1309, 0.1338, 0.1371, 0.1407, 0.1448, 0.1453, 0.1457,
     &      0.1462, 0.1466, 0.1471, 0.1476, 0.1481, 0.1486, 0.1491, 0.1496,
     &      0.1501, 0.1506, 0.1511, 0.1517, 0.1522, 0.1528, 0.1533, 0.1539,
     &      0.1545, 0.1551, 0.1557, 0.1563, 0.1570, 0.1576, 0.1582, 0.1589,
     &      0.1596, 0.1603, 0.1610, 0.1617, 0.1624, 0.1631, 0.1639, 0.1647,
     &      0.1655, 0.1663, 0.1671, 0.1679, 0.1688, 0.1697, 0.1706, 0.1715,
     &      0.1724, 0.1734, 0.1744, 0.1754, 0.1764, 0.1775, 0.1786, 0.1797,
     &      0.1809, 0.1821, 0.1833, 0.1845, 0.1858, 0.1872, 0.1885, 0.1899,
     &      0.1914, 0.1929, 0.1945, 0.1961, 0.1978, 0.1995, 0.2013, 0.2032,
     &      0.2052, 0.2072, 0.2093, 0.2115, 0.2138, 0.2162, 0.2188, 0.2214,
     &      0.2243, 0.2272, 0.2304, 0.2336, 0.2371, 0.2409, 0.2449, 0.2492,
     &      0.2538, 0.2587, 0.2641, 0.2702, 0.2765, 0.2837, 0.2918, 0.3009 /

C Geometric mean diameter of coarse mode [um]
      DATA ( DGNK( I ), I = 1, 136 ) /
     &      1.7786, 1.8180, 1.8254, 1.8330, 1.8408, 1.8489, 1.8891, 1.8979,
     &      1.9069, 1.9163, 1.9259, 1.9673, 1.9778, 1.9887, 2.0000, 2.0425,
     &      2.0549, 2.0677, 2.0812, 2.1252, 2.1400, 2.1554, 2.2009, 2.2180,
     &      2.2359, 2.2833, 2.3034, 2.3244, 2.3746, 2.3983, 2.4504, 2.4773,
     &      2.5319, 2.5627, 2.6207, 2.6563, 2.7187, 2.7831, 2.8286, 2.9000,
     &      2.9750, 3.0545, 3.1395, 3.2312, 3.3313, 3.4419, 3.4524, 3.4631,
     &      3.4855, 3.4965, 3.5077, 3.5190, 3.5305, 3.5422, 3.5540, 3.5760,
     &      3.5882, 3.6007, 3.6133, 3.6262, 3.6392, 3.6607, 3.6742, 3.6879,
     &      3.7019, 3.7161, 3.7306, 3.7517, 3.7667, 3.7820, 3.7976, 3.8134,
     &      3.8296, 3.8506, 3.8674, 3.8845, 3.9019, 3.9197, 3.9405, 3.9591,
     &      3.9781, 3.9974, 4.0172, 4.0380, 4.0587, 4.0798, 4.1015, 4.1221,
     &      4.1448, 4.1680, 4.1918, 4.2126, 4.2375, 4.2632, 4.2895, 4.3108,
     &      4.3385, 4.3671, 4.3964, 4.4185, 4.4495, 4.4816, 4.5040, 4.5381,
     &      4.5732, 4.5965, 4.6340, 4.6728, 4.6974, 4.7390, 4.7640, 4.8087,
     &      4.8552, 4.8827, 4.9330, 4.9618, 5.0166, 5.0472, 5.1071, 5.1403,
     &      5.2062, 5.2426, 5.3158, 5.3566, 5.3985, 5.4852, 5.5338, 5.5844,
     &      5.6378, 5.6944, 5.7547, 5.8867, 5.8898, 5.9665, 6.0510, 6.1446 /

C Geometric standard deviation of accumulation mode
      DATA ( SIGJ( I ), I = 1, 136 ) /
     &      2.1420, 2.1442, 2.1442, 2.1442, 2.1442, 2.1442, 2.1464, 2.1464,
     &      2.1464, 2.1464, 2.1464, 2.1485, 2.1485, 2.1485, 2.1485, 2.1506,
     &      2.1506, 2.1506, 2.1506, 2.1526, 2.1526, 2.1526, 2.1545, 2.1545,
     &      2.1545, 2.1564, 2.1564, 2.1564, 2.1582, 2.1582, 2.1599, 2.1599,
     &      2.1616, 2.1616, 2.1632, 2.1632, 2.1647, 2.1661, 2.1661, 2.1674,
     &      2.1687, 2.1698, 2.1709, 2.1719, 2.1727, 2.1735, 2.1735, 2.1735,
     &      2.1742, 2.1742, 2.1742, 2.1742, 2.1742, 2.1742, 2.1742, 2.1747,
     &      2.1747, 2.1747, 2.1747, 2.1747, 2.1747, 2.1752, 2.1752, 2.1752,
     &      2.1752, 2.1752, 2.1752, 2.1756, 2.1756, 2.1756, 2.1756, 2.1756,
     &      2.1756, 2.1758, 2.1758, 2.1758, 2.1758, 2.1758, 2.1760, 2.1760,
     &      2.1760, 2.1760, 2.1760, 2.1760, 2.1760, 2.1760, 2.1760, 2.1759,
     &      2.1759, 2.1759, 2.1759, 2.1757, 2.1757, 2.1757, 2.1757, 2.1754,
     &      2.1754, 2.1754, 2.1754, 2.1750, 2.1750, 2.1750, 2.1745, 2.1745,
     &      2.1745, 2.1739, 2.1739, 2.1739, 2.1731, 2.1731, 2.1723, 2.1723,
     &      2.1723, 2.1713, 2.1713, 2.1703, 2.1703, 2.1691, 2.1691, 2.1679,
     &      2.1679, 2.1665, 2.1665, 2.1651, 2.1636, 2.1636, 2.1619, 2.1602,
     &      2.1584, 2.1566, 2.1546, 2.1546, 2.1506, 2.1484, 2.1462, 2.1440 /

C Geometric standard deviation of coarse mode
      DATA ( SIGK( I ), I = 1, 136 ) /
     &      2.1083, 2.0900, 2.0900, 2.0900, 2.0900, 2.0900, 2.0725, 2.0725,
     &      2.0725, 2.0725, 2.0725, 2.0558, 2.0558, 2.0558, 2.0558, 2.0399,
     &      2.0399, 2.0399, 2.0399, 2.0248, 2.0248, 2.0248, 2.0103, 2.0103,
     &      2.0103, 1.9967, 1.9967, 1.9967, 1.9836, 1.9836, 1.9713, 1.9713,
     &      1.9597, 1.9597, 1.9487, 1.9487, 1.9384, 1.9288, 1.9288, 1.9198,
     &      1.9114, 1.9036, 1.8965, 1.8901, 1.8843, 1.8791, 1.8791, 1.8791,
     &      1.8746, 1.8746, 1.8746, 1.8746, 1.8746, 1.8746, 1.8746, 1.8708,
     &      1.8708, 1.8708, 1.8708, 1.8708, 1.8708, 1.8676, 1.8676, 1.8676,
     &      1.8676, 1.8676, 1.8676, 1.8652, 1.8652, 1.8652, 1.8652, 1.8652,
     &      1.8652, 1.8635, 1.8635, 1.8635, 1.8635, 1.8635, 1.8625, 1.8625,
     &      1.8625, 1.8625, 1.8625, 1.8622, 1.8622, 1.8622, 1.8622, 1.8628,
     &      1.8628, 1.8628, 1.8628, 1.8642, 1.8642, 1.8642, 1.8642, 1.8664,
     &      1.8664, 1.8664, 1.8664, 1.8696, 1.8696, 1.8696, 1.8737, 1.8737,
     &      1.8737, 1.8788, 1.8788, 1.8788, 1.8850, 1.8850, 1.8923, 1.8923,
     &      1.8923, 1.9009, 1.9009, 1.9108, 1.9108, 1.9221, 1.9221, 1.9351,
     &      1.9351, 1.9497, 1.9497, 1.9662, 1.9849, 1.9849, 2.0058, 2.0295,
     &      2.0560, 2.0859, 2.1197, 2.1197, 2.2014, 2.2510, 2.3080, 2.3740 /

C Number flux in accumulation mode at 1 m/s [1/m2/s]
            DATA ( FNJ( I ), I = 1, 136 ) /
     &      1249.0821, 1248.2831, 1248.2831, 1248.2831, 1248.2831, 1248.2831,
     &      1247.4863, 1247.4863, 1247.4863, 1247.4863, 1247.4863, 1246.6948,
     &      1246.6948, 1246.6948, 1246.6948, 1245.9114, 1245.9114, 1245.9114,
     &      1245.9114, 1245.1389, 1245.1389, 1245.1389, 1244.3799, 1244.3799,
     &      1244.3799, 1243.6370, 1243.6370, 1243.6370, 1242.9115, 1242.9115,
     &      1242.2081, 1242.2081, 1241.5281, 1241.5281, 1240.8739, 1240.8739,
     &      1240.2476, 1239.6513, 1239.6513, 1239.0872, 1238.5571, 1238.0628,
     &      1237.6062, 1237.1869, 1236.8099, 1236.4749, 1236.4749, 1236.4749,
     &      1236.1833, 1236.1833, 1236.1833, 1236.1833, 1236.1833, 1236.1833,
     &      1236.1833, 1235.9361, 1235.9361, 1235.9361, 1235.9361, 1235.9361,
     &      1235.9361, 1235.7343, 1235.7343, 1235.7343, 1235.7343, 1235.7343,
     &      1235.7343, 1235.5787, 1235.5787, 1235.5786, 1235.5786, 1235.5786,
     &      1235.5786, 1235.4698, 1235.4698, 1235.4698, 1235.4698, 1235.4698,
     &      1235.4082, 1235.4082, 1235.4082, 1235.4082, 1235.4082, 1235.3941,
     &      1235.3941, 1235.3941, 1235.3941, 1235.4277, 1235.4277, 1235.4277,
     &      1235.4277, 1235.5087, 1235.5087, 1235.5087, 1235.5087, 1235.6351,
     &      1235.6351, 1235.6351, 1235.6351, 1235.8099, 1235.8099, 1235.8099,
     &      1236.0306, 1236.0306, 1236.0306, 1236.2963, 1236.2963, 1236.2963,
     &      1236.6058, 1236.6058, 1236.9575, 1236.9575, 1236.9575, 1237.3498,
     &      1237.3498, 1237.7807, 1237.7807, 1238.2480, 1238.2480, 1238.7491,
     &      1238.7491, 1239.2812, 1239.2812, 1239.8412, 1240.4256, 1240.4256,
     &      1241.0307, 1241.6543, 1242.2878, 1242.9282, 1243.5702, 1243.5702,
     &      1244.8344, 1245.4428, 1246.0247, 1246.5734 /

C Number flux in coarse mode at 1 m/s [1/m2/s]
      DATA ( FNK( I ), I = 1, 136 ) /
     &      11.2976, 11.1324, 11.1324, 11.1324, 11.1324, 11.1324, 10.9787,
     &      10.9787, 10.9787, 10.9787, 10.9787, 10.8356, 10.8356, 10.8356,
     &      10.8356, 10.7024, 10.7024, 10.7024, 10.7024, 10.5785, 10.5785,
     &      10.5785, 10.4632, 10.4632, 10.4632, 10.3561, 10.3561, 10.3561,
     &      10.2565, 10.2565, 10.1641, 10.1641, 10.0786, 10.0786, 9.9994,
     &      9.9994, 9.9263, 9.8591, 9.8591, 9.7973, 9.7408, 9.6894, 9.6430,
     &      9.6011, 9.5640, 9.5315, 9.5315, 9.5315, 9.5034, 9.5034, 9.5034,
     &      9.5034, 9.5034, 9.5034, 9.5034, 9.4797, 9.4797, 9.4797, 9.4797,
     &      9.4797, 9.4797, 9.4604, 9.4604, 9.4604, 9.4604, 9.4604, 9.4604,
     &      9.4455, 9.4455, 9.4455, 9.4455, 9.4455, 9.4455, 9.4351, 9.4351,
     &      9.4351, 9.4351, 9.4351, 9.4291, 9.4291, 9.4291, 9.4291, 9.4291,
     &      9.4278, 9.4278, 9.4278, 9.4278, 9.4311, 9.4311, 9.4311, 9.4311,
     &      9.4393, 9.4393, 9.4393, 9.4393, 9.4523, 9.4523, 9.4523, 9.4523,
     &      9.4708, 9.4708, 9.4708, 9.4948, 9.4948, 9.4948, 9.5247, 9.5247,
     &      9.5247, 9.5608, 9.5608, 9.6036, 9.6036, 9.6036, 9.6536, 9.6536,
     &      9.7112, 9.7112, 9.7773, 9.7773, 9.8524, 9.8524, 9.9376, 9.9376,
     &      10.0336, 10.1418, 10.1418, 10.2634, 10.4001, 10.5533, 10.7252,
     &      10.9184, 10.9184, 11.3807, 11.6576, 11.9718, 12.3303 /

C Volume flux at 1 m/s numerically integrated over full size range [m3/m2/s]
      DATA ( VFLUX( I ), I = 1, 136 ) /
     &      3.5750e-16, 3.5600e-16, 3.6036e-16, 3.6489e-16, 3.6960e-16,
     &      3.7449e-16, 3.7367e-16, 3.7889e-16, 3.8434e-16, 3.9002e-16,
     &      3.9596e-16, 3.9603e-16, 4.0243e-16, 4.0913e-16, 4.1615e-16,
     &      4.1720e-16, 4.2484e-16, 4.3289e-16, 4.4136e-16, 4.4371e-16,
     &      4.5303e-16, 4.6290e-16, 4.6656e-16, 4.7752e-16, 4.8919e-16,
     &      4.9453e-16, 5.0765e-16, 5.2171e-16, 5.2932e-16, 5.4535e-16,
     &      5.5493e-16, 5.7342e-16, 5.8547e-16, 6.0711e-16, 6.2234e-16,
     &      6.4805e-16, 6.6748e-16, 6.8942e-16, 7.2379e-16, 7.5245e-16,
     &      7.8530e-16, 8.2321e-16, 8.6731e-16, 9.1914e-16, 9.8076e-16,
     &      1.0551e-15, 1.0648e-15, 1.0746e-15, 1.0704e-15, 1.0806e-15,
     &      1.0909e-15, 1.1015e-15, 1.1124e-15, 1.1234e-15, 1.1347e-15,
     &      1.1310e-15, 1.1427e-15, 1.1546e-15, 1.1668e-15, 1.1793e-15,
     &      1.1921e-15, 1.1889e-15, 1.2021e-15, 1.2157e-15, 1.2295e-15,
     &      1.2437e-15, 1.2583e-15, 1.2559e-15, 1.2711e-15, 1.2866e-15,
     &      1.3025e-15, 1.3189e-15, 1.3357e-15, 1.3343e-15, 1.3518e-15,
     &      1.3699e-15, 1.3884e-15, 1.4075e-15, 1.4072e-15, 1.4272e-15,
     &      1.4477e-15, 1.4690e-15, 1.4909e-15, 1.4919e-15, 1.5149e-15,
     &      1.5387e-15, 1.5633e-15, 1.5657e-15, 1.5916e-15, 1.6185e-15,
     &      1.6464e-15, 1.6504e-15, 1.6799e-15, 1.7106e-15, 1.7425e-15,
     &      1.7487e-15, 1.7827e-15, 1.8181e-15, 1.8550e-15, 1.8640e-15,
     &      1.9036e-15, 1.9450e-15, 1.9566e-15, 2.0013e-15, 2.0481e-15,
     &      2.0629e-15, 2.1138e-15, 2.1673e-15, 2.1862e-15, 2.2448e-15,
     &      2.2666e-15, 2.3310e-15, 2.3993e-15, 2.4276e-15, 2.5035e-15,
     &      2.5366e-15, 2.6216e-15, 2.6607e-15, 2.7566e-15, 2.8033e-15,
     &      2.9126e-15, 2.9689e-15, 3.0950e-15, 3.1640e-15, 3.2387e-15,
     &      3.3973e-15, 3.4912e-15, 3.5945e-15, 3.7089e-15, 3.8366e-15,
     &      3.9802e-15, 4.2603e-15, 4.3308e-15, 4.5485e-15, 4.8050e-15,
     &      5.1124e-15 /


C Polynomial coefficients from Zhang et al. (2005)         
      DATA C0_COEFF / 28.376D0, -205.44D0, 653.37D0, -1031.7D0, 803.18D0, -247.08D0 /
      DATA X_COEFF  / 3.1657D0, -19.079D0,  55.72D0, -83.998D0, 63.436D0, -19.248D0 /

      CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         FUNCTION SSEMIS_INIT( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )

C Revision History:
C   26 Feb 10 J.Young:  Eliminate BARRIER, etc. to prevent MPI race condition
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   04 Apr 11 S.Howard: dynamic allocation and generalization of indices for
C                       SSOUTD, WRSS_SPC, and SSSPC_MAP
C   11 May 11 D.Wong: incorporated twoway model implementation
C   12 Aug 15 D.Wong: added code to handle parallel I/O implementation

            USE UTILIO_DEFN
            USE AERO_DATA

#ifndef mpas
#ifdef parallel
            USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
            USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif

            IMPLICIT NONE

C Arguments:
            INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP
            LOGICAL :: SUCCESS

C Includes:
            INCLUDE SUBST_FILES_ID  ! file name parameters

C Local Variables:
            CHARACTER( 16 ), SAVE :: PNAME = 'SSEMIS_INIT'
            CHARACTER( 80 ) :: VARDESC
            CHARACTER( 250 ) :: XMSG = ' '
            INTEGER STATUS
            INTEGER S, N, L, ISEA, SPC, IM
            LOGICAL SEA_MATCH
            CHARACTER( 16 ) :: SN

C-----------------------------------------------------------------------

            SUCCESS = .TRUE.

C Map aerospc data
            CALL MAP_AERO()

            CALL LOG_MESSAGE( LOGDEV, 'Initialize Sea Spray Aerosol Emissions' )

            ! Specify H2O in mapping
            KH2O = NSEA_SPC

C Populate Master Emissions Map Vector So That Diagnostics 
C can be printed in EMIS_MAP
            NSSSPC = NSEA_SPC
            DESID_EMVAR( iseasrm )%len = nssspc*2
            Allocate( DESID_EMVAR( iseasrm )%arry ( nssspc*2 ) )
            Allocate( DESID_EMVAR( iseasrm )%units( nssspc*2 ) )
            Allocate( DESID_EMVAR( iseasrm )%mw   ( nssspc*2 ) )
            Allocate( DESID_EMVAR( iseasrm )%used ( nssspc*2 ) )
            Allocate( DESID_EMVAR( iseasrm )%conv ( nssspc*2 ) )
            Allocate( DESID_EMVAR( iseasrm )%basis( nssspc*2 ) )
            Allocate( DESID_EMVAR( iseasrm )%larea( nssspc*2 ) )
            Allocate( DESID_EMVAR( iseasrm )%lareaadj( nssspc*2 ) )
            DESID_EMVAR( iseasrm )%arry( : ) = 'NOT_AVAILABLE'
            do i = 1,nssspc
              IF ( sea_spc( i )%spcfac(1) .NE. 0.0 .or. i .EQ. nssspc ) 
     &           DESID_EMVAR( iseasrm )%arry( i )  =
     &                         "PMFINE_" // sea_spc(i)%name
              IF ( sea_spc( i )%spcfac(2) .NE. 0.0 .or. i .EQ. nssspc ) 
     &           DESID_EMVAR( iseasrm )%arry( i+nssspc )  =
     &                         "PMCOARSE_" // sea_spc(i)%name
               DESID_EMVAR( iseasrm )%mw   ( i ) = sea_spc(i)%mw
               DESID_EMVAR( iseasrm )%mw   ( i+nssspc ) = sea_spc(i)%mw
            end do
            DESID_EMVAR( iseasrm )%units( : ) = 'G/S'
            DESID_EMVAR( iseasrm )%used ( : ) = .FALSE.
            DESID_EMVAR( iseasrm )%conv ( : ) = 1.0
            DESID_EMVAR( iseasrm )%basis( : ) = 'MASS'
            DESID_EMVAR( iseasrm )%larea( : ) = .FALSE.
            DESID_EMVAR( iseasrm )%lareaadj( : ) = .FALSE.
 
C Allocate SS arrays using NSSSPC value
            ALLOCATE ( SSOUTM( NSSSPC*2,NCOLS,NROWS ),
     &                 SSOUTN( 2,NCOLS,NROWS ),
     &                 SSOUTS( 2,NCOLS,NROWS ), 
     &                 SEA_FACTNUM( N_MODE,NCOLS,NROWS ),
     &                 SEA_FACTSRF( N_MODE,NCOLS,NROWS ), 
     &                 GSFAC( NCOLS,NROWS ), STAT = STATUS )
            IF ( STATUS .NE. 0 ) THEN
               XMSG = '*** SSOUTM, SSOUTN or SSOUTS memory allocation failed'
               CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF


            IF ( SSEMDIAG ) THEN    ! Open the sea-salt emission diagnostic file
C Determine number of sea-salt species For diagnostic file
               NSSDIAG = 0
               DO ISEA = 1,NSSSPC
                  NSSDIAG = NSSDIAG + COUNT( SEA_SPC( ISEA )%SPCFAC( : ) .GT. 0. )
               ENDDO
C Include H2O
               NSSDIAG = NSSDIAG + 2   !! count both J and K modes
C Include NUMBER and SURFACE_AREA to diagnostic (J & K)
               NSSDIAG = NSSDIAG + 4

C Allocate diagnostic arrays
               ALLOCATE ( SSOUTD( NSSDIAG ),
     &                    WRSS_SPC( NSSDIAG ), STAT = STATUS )
               IF ( STATUS .NE. 0 ) THEN
                  XMSG = '*** SSOUTD or WRSS_SPC memory allocation failed'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF

C Build diagnostic file write buffer (WRSS_SPC) array
               NSSDIAG = 0
               DO N = 1, 2
                  DO S = 1, NSSSPC
                     IF ( SEA_SPC( S )%SPCFAC( N ) .GT. 0.0 ) THEN
                        NSSDIAG = NSSDIAG + 1
                        WRSS_SPC( NSSDIAG ) = TRIM( SEA_SPC( S )%NAME ) // MODESUFF( N ) 
                     END IF
                  END DO
C Include H2O
                  NSSDIAG = NSSDIAG + 1
                  WRSS_SPC( NSSDIAG ) = 'AH2O' // MODESUFF( N )
               END DO

C Include Mode NUMBER to diagnostic
               NSSDIAG = NSSDIAG + 1
               WRSS_SPC( NSSDIAG ) = "NUMFINE"
               NSSDIAG = NSSDIAG + 1
               WRSS_SPC( NSSDIAG ) = "NUMCOARSE"
 
C Include Mode SURFACE_AREA to diagnostic
               NSSDIAG = NSSDIAG + 1
               WRSS_SPC( NSSDIAG ) = "SRFFINE"
               NSSDIAG = NSSDIAG + 1
               WRSS_SPC( NSSDIAG ) = "SRFCOARSE"

C Open the sea-salt emission dignostic file
               IF ( IO_PE_INCLUSIVE ) CALL OPSSEMIS ( STDATE, STTIME, TSTEP, NSSDIAG, WRSS_SPC )

               ALLOCATE ( SSBF( NSSDIAG,NCOLS,NROWS ),
     &                    WRSS( NCOLS,NROWS ), STAT = STATUS )
               IF ( STATUS .NE. 0 ) THEN
                  XMSG = '*** SSBF or WRSS memory allocation failed'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF

#ifndef mpas
#ifdef parallel_io
               CALL SE_BARRIER
               IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                  IF ( .NOT. OPEN3( CTM_SSEMIS_1, FSREAD3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM(CTM_SSEMIS_1)
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
                  END IF
               END IF
#endif
#endif

            END IF

         END FUNCTION SSEMIS_INIT

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE OPSSEMIS ( JDATE, JTIME, TSTEP, NSSDIAG, WRSS_SPC )

C   16 May 05 P.Bhave: original version, using OPDDEP as a template
C    4 Mar 10 J.Young: accomodate Steve Howard's reengineering
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN
         USE MIO_ASCII

         IMPLICIT NONE

         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:
         INTEGER      JDATE      ! current model date, coded YYYYDDD
         INTEGER      JTIME      ! current model time, coded HHMMSS
         INTEGER      TSTEP      ! output time step
         INTEGER      NSSDIAG
         CHARACTER( 16 ) :: WRSS_SPC( NSSDIAG )

C Local variables:
         CHARACTER( 16 ) :: PNAME = 'OPSSEMIS'
         CHARACTER( 96 ) :: XMSG = ' '

         INTEGER      V, L       ! loop induction variables

C-----------------------------------------------------------------------

#ifndef mpas
C Try to open existing file for update
         IF ( .NOT. OPEN3( CTM_SSEMIS_1, FSRDWR3, PNAME ) ) THEN
            XMSG = 'Could not open CTM_SSEMIS_1 for update - '
     &           // 'try to open new'
            CALL M3MESG( XMSG )

C Set output file characteristics based on COORD.EXT and open diagnostic file
            FTYPE3D = GRDDED3
            SDATE3D = JDATE
            STIME3D = JTIME
            TSTEP3D = TSTEP
            CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

            NVARS3D = NSSDIAG
            NCOLS3D = GL_NCOLS
            NROWS3D = GL_NROWS
            NLAYS3D = 1
            NTHIK3D = 1
            GDTYP3D = GDTYP_GD
            P_ALP3D = P_ALP_GD
            P_BET3D = P_BET_GD
            P_GAM3D = P_GAM_GD
            XORIG3D = XORIG_GD
            YORIG3D = YORIG_GD
            XCENT3D = XCENT_GD
            YCENT3D = YCENT_GD
            XCELL3D = XCELL_GD
            YCELL3D = YCELL_GD
            VGTYP3D = VGTYP_GD
            VGTOP3D = VGTOP_GD
!           VGTPUN3D = VGTPUN_GD ! currently, not defined
            DO L = 1, NLAYS3D + 1
               VGLVS3D( L ) = VGLVS_GD( L )
            END DO
!           GDNAM3D = GDNAME_GD
            GDNAM3D = GRID_NAME  ! from HGRD_DEFN

            DO V = 1, NSSDIAG
               VTYPE3D( V ) = M3REAL
               VNAME3D( V ) = WRSS_SPC( V )
               IF ( VNAME3D( V )(1:3) .EQ. 'NUM' ) THEN
                  UNITS3D( V ) = 's-1'
               ELSE IF ( VNAME3D( V )(1:3) .EQ. 'SRF' ) THEN
                  UNITS3D( V ) = 'm2 s-1'
               ELSE
                  UNITS3D( V ) = 'g s-1'
               END IF
               VDESC3D( V ) = 'hourly ' // TRIM( VNAME3D( V ) )
     &                     // ' sea-salt emission rate'
            END DO

            FDESC3D( 1 ) = 'hourly layer-1 sea-salt emission rates'
            DO L = 2, MXDESC3
               FDESC3D( L ) = ' '
            END DO

            ! Store MIO Metadata
            NDIMS3D( 1:NVARS3D ) = 3
            L_TSTEP( 1:NVARS3D ) = .True.
            L_LAY  ( 1:NVARS3D ) = .False.
            L_COL  ( 1:NVARS3D ) = .True.
            L_ROW  ( 1:NVARS3D ) = .True.
            L_VEXT ( 1:NVARS3D ) = .False.
          
            CALL LOAD_MIO_FILE ( 'CTM_SSEMIS_1', 0, 0, 0,
     &           VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &           VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &           L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &           L_VEXT(1:NVARS3D) )


C Open sea-salt emissions diagnostic file
            IF ( .NOT. OPEN3( CTM_SSEMIS_1, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not create the CTM_SSEMIS_1 file'
               CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
            END IF

         END IF
#endif

         RETURN

         END SUBROUTINE OPSSEMIS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE GET_SSEMIS ( JDATE, JTIME, TSTEP, CELLVOL, CELLHGT,
     &                           L_DESID_DIAG )

C GET_SSEMIS calculates the sea-salt emission rates in a grid cell
C given the fractional grid-cell area covered by open ocean and surf zone
 
C Key Subroutines/Functions Called:  NONE
 
C Revision History:
 
C   13 Jun 05 P.Bhave:  first version for public release
C   11 Apr 08 J.Kelly:  added code for (1) emission of coarse surface area,
C                       (2) emission of coarse water, (3) enhanced surf zone
C                       emissions, and (4) variable coarse std. deviation
C   20 Feb 10 J.Young:  move out of AERO_EMIS proper into this module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   04 Apr 11 S.Howard: moved speciation to AERO_DATA and generalized species
C                       and modal references and density calculation
C   11 May 11 D.Wong: incorporated twoway model implementation
C   08 Aug 14 B.Gantt: added code for (1) increased accumulation mode
C                      emissions, (2) sea surface temperature dependence
C                      of emissions, and (3) reduction of surf zone
C                      emisions
 
C References:
C    Binkowski F.S., S.J. Roselle. Models-3 Community Multiscale Air Quality 
C          (CMAQ) model aerosol component 1: Model Description.  J. Geophys. 
C          Res., Vol 108, No D6, 4183, doi:10.1029/2001JD001409 (2003).
C    Seinfeld, J.H., S.N. Pandis.  "Atmospheric Chemistry and Physics - from
C          air pollution to climate change"  John Wiley & Sons, Inc. (1998).
C    Zhang, K.M., E.M. Knipping, A.S. Wexler, P.V. Bhave, G.S. Tonnesen
C          "Size distribution of sea-salt emissions as a function of relative
C          humidity"  Atmospheric Environment, 39, 3373-3379 (2005).
C    Lewis, E.R. and Schwartz, S.E. "Comment on "Size distribution of sea-salt
C           emissions as a funciton of relative humidity", Atmospheric Environment,
C           40, 588-590 (2006)
C    Zhang, K.M., E.M. Knipping, A.S. Wexler, P.V. Bhave, G.S. Tonnesen, "Reply
C           to comment on "Size distribution of sea-salt emissions as a funciton 
C           of relative humidity", Atmospheric Environment, 40, 591-592 (2006)
C    Clarke, A.D., S.R. Owens, and J. Zhou "An ultrafine sea-salt flux from
C          breaking waves: Implications for cloud condensation nuclei in the
C          remote marine atmosphere" J. Geophys. Res. (2006)
C    Gong, S. L., A parameterization of sea-salt aerosol source function
C          for sub- and super-micron particles, Global Biogeochem. Cycles, 17,
C          1097, (2003).
C    Jaeglé, L., P. K. Quinn, T. S. Bates, B. Alexander, and J. T. Lin, Global 
C          distribution of sea salt aerosols: New constraints from in situ and
C          remote sensing observations, Atmos. Chem. Phys., 11, 3137–3157,
C          (2011).
C    Ovadnevaite, J., Manders, A., de Leeuw, G., Ceburnis, D., Monahan, C., 
C          Partanen, A.-I., Korhonen, H., and O'Dowd, C. D.: A sea spray 
C          aerosol flux parameterization encapsulating wave state, Atmos. 
C          Chem. Phys., 14, 1837-1852, (2014).
C-----------------------------------------------------------------------

            USE UTILIO_DEFN
            USE AERO_DATA
            USE AEROMET_DATA   
            USE CONST, ONLY: PI, F6PI, STDTEMP, MWWAT, MWAIR, VP0
            USE ASX_DATA_MOD, ONLY: MET_DATA, GRID_DATA, svp2, svp3
#ifdef mpas
            use coupler_module, only : cell_vol, cell_thickness
#endif

            IMPLICIT NONE

C Arguments
            INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP( 3 )
            REAL,    INTENT( IN ) :: CELLVOL(:,:)          ! grid-cell volume [m2*sigma]
            REAL,    INTENT( IN ) :: CELLHGT(:,:) ! grid-cell height [sigma] 
            LOGICAL, INTENT( IN ) :: L_DESID_DIAG ! flag for whether or not DESID 
                                                  !     is in diagnostic mode
C Includes:
            INCLUDE SUBST_FILES_ID  ! file name parameters

C Local Variables:
            REAL    :: OFRAC              ! fractional seawater cover
            REAL    :: SFRAC              ! fractional surf-zone cover
            REAL    :: BLKPRS             ! atmospheric pressure [Pa]
            REAL    :: BLKTA              ! air temperature [K]
            REAL    :: BLKQV              ! H2O mass mixing ratio [ kg/kg ]
            REAL    :: U10                ! wind speed at 10m [m/s]
            REAL    :: RLAY1HT            ! reciprocal of layer-1 height [1/m]
            REAL    :: AIRVOL             ! grid-cell volume [m3]
            REAL    :: SST                ! sea surface temperature[C]

            CHARACTER( 16 ), SAVE :: PNAME = 'GET_SSEMIS'
            CHARACTER( 96 ) :: XMSG = ' '
            INTEGER C, R, L, N, V, S         ! loop indices

C Variables for calculating ambient RH
            REAL, PARAMETER :: EPSWATER = MWWAT / MWAIR
            REAL      :: ESAT             ! saturation vapor pressure
            REAL      :: BLKRH            ! fractional relative humidity

C Variables for calculating solute mass fraction & size-correction factors
            REAL( 8 ), PARAMETER :: ONE3  = 1.0D0 / 3.00D0
            REAL( 8 ), PARAMETER :: A0    = 1.0D0 / 3.70D0
            REAL( 8 ), PARAMETER :: A80   = 3.7D0 / 1.82D0
            REAL      :: RH               ! BLKRH constrained to 45-99% range
            REAL( 8 ) :: DRH              ! double precision RH
            REAL( 8 ) :: C0               ! (Diam @ formation) / (Diam @ ambient RH)
            REAL( 8 ) :: C80              ! (Diam @ 80% RH) / (Diam @ ambient RH)    
            REAL( 8 ) :: XSW              ! fractional solute weight fraction

C Density of dry sea salt [kg/m3] using volume additivity
            REAL( 8 )       :: RHOSW( 2 ) ! sea-salt particle density at ambient RH [g/m3]

C Maximum and minimum diameters for emission-flux integrations [m]
            REAL, PARAMETER :: DPMAX = 20.0E-6 ! upper limit used for the
                                               ! numerical integrations
            REAL      :: DPMINO           ! minimum diameter for open-ocean flux
            REAL      :: DPMAXO           ! maximum diameter for open-ocean flux
   
C Wind-speed-dependent scaling factors for emissions flux functions
            REAL      :: WDSCALO          ! Gong-Monahan open-ocean flux

C SST-dependent scaling factor for emissions flux functions
            REAL      :: SSTSCALO          ! Jaegle flux

C Fraction of whitecap coverage
            REAL      :: WCAP

C Lognormal parameters and numerically-integrated fluxes at ambient RH
            INTEGER   :: IPOS             ! position of ambient RH in data arrays
            REAL      :: DGNJRH           ! geometric mean of accum-mode flux [m]
            REAL      :: DGNKRH           ! geometric mean of coarse-mode flux [m]
            REAL      :: SIGJRH           ! geom std deviation of accum-mode flux
            REAL      :: SIGKRH           ! geom std deviation of coarse-mode flux
            REAL      :: FNJRH            ! magnitude of accum-mode flux [1/m2/s]
            REAL      :: FNKRH            ! magnitude of coarse-mode flux [1/m2/s]
            REAL      :: VFLXRH           ! total particle volume [m3/m2/s]

C Alternate forms of geometric std devs stored for efficiency
            REAL      :: LNSGJ, LNSGK     ! natural log of std dev
            REAL      :: RDIVJ, RDIVK     ! reciprocal of sqrt(2)*lnsg

C Geometric mean diameters by volume/mass [m]
            REAL      :: DGVJRH           ! accumulation mode
            REAL      :: DGVKRH           ! coarse mode

C Variables for converting 3rd moment emission rates to M0 and M2 rates
            REAL      :: FACTNUMJ         ! conversion for accumulation mode M0
            REAL      :: FACTNUMK         ! conversion for coarse mode M0
            REAL      :: FACTM2J          ! conversion for accumulation mode M2
            REAL      :: FACTM2K          ! conversion for coarse mode M2 

C Variables for calculating fraction of mass emissions assigned to each mode
            REAL      :: FFINJ            ! finite integral for accumulation mode
            REAL      :: FFINK            ! finite integral for coarse mode
            REAL      :: FRACMJ           ! mass fraction assigned to accumulation mode
            REAL      :: FRACMK           ! mass fraction assigned to coarse mode

C Mode-specific sea-salt mass emission rates [g/m3/s]
            REAL( 8 ) :: ESEASJ           ! accumulation mode
            REAL( 8 ) :: ESEASK           ! coarse mode

C 3rd moment emission rates [m3/m3/s]
            REAL      :: M3J              ! accumulation mode, 3rd moment
            REAL      :: M3K              ! coarse mode, 3rd moment
         
C Variables for calculating dry surface-area emission rate for accum mode
            REAL      :: WET_M3J, DRY_M3J ! wet & dry 3rd moment emis rates [m3/m3/s] 
            REAL      :: WET_M2J, DRY_M2J ! wet & dry 2nd moment emis rates [m3/m3/s] 
            REAL      :: WET_M3K, DRY_M3K ! wet & dry 3rd moment emis rates [m3/m3/s] 
            REAL      :: WET_M2K, DRY_M2K ! wet & dry 2nd moment emis rates [m3/m3/s] 

            INTEGER, SAVE     :: WSTEP  = 0    ! local write counter
            INTEGER           :: MDATE, MTIME  ! SSEMIS write date&time

            LOGICAL, SAVE :: FIRSTIME      = .TRUE.

C Mathematical constants
            REAL, PARAMETER      :: TWO3 = 2.0 / 3.0

C----------------------------- Begin calc ------------------------------

C Initialize sea-salt output buffer
            IF ( SSEMDIAG .AND. WSTEP .EQ. 0 .AND. .NOT. L_DESID_DIAG ) SSBF = 0.0
            SEA_FACTNUM = 0.0
            SEA_FACTSRF = 0.0

            ! Calculate conversion factor from volume-based to total emission rate
            GSFAC( :,: )  = CELLVOL( :,: ) / MET_DATA%RJACM( :,:,1 ) ! [g/m3/s] to [g/s]

            ! Begin Main Loop over Grid Cells
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  IF ( Grid_Data%OCEAN( C,R ) + Grid_Data%SZONE( C,R ) .GT. 0.0 ) THEN
                     OFRAC   = Grid_Data%OCEAN     ( C,R )
                     SFRAC   = Grid_Data%SZONE     ( C,R )
                     BLKPRS  = Met_Data%PRES       ( C,R,1 )
                     BLKTA   = Met_Data%TA         ( C,R,1 )
                     BLKQV   = Met_Data%QV         ( C,R,1 )
                     U10     = Met_Data%WSPD10     ( C,R )
                     SST     = max(Met_Data%TSEASFC( C,R ) - 273.15, 0.0 )
#ifdef mpas
                     RLAY1HT = Met_Data%RJACM ( C,R,1 ) / cell_thickness(C,1,1)
#else
                     RLAY1HT = Met_Data%RJACM ( C,R,1 ) / CELLHGT(c,r)
#endif
                  ELSE
                     DO N = 1, 2
                        DO S = 1, NSSSPC
                           SSOUTM( (N-1)*NSSSPC+S,C,R ) = 0.0
                        END DO
                        SSOUTN( N,C,R ) = 0.0
                        SSOUTS( N,C,R ) = 0.0
                     END DO
                     CYCLE
                  END IF

C Calculate fractional relative humidity in the grid cell
C Follow the same methodology as in WRF and MM5 for the 10m RH
                  If ( BLKTA .Lt. stdtemp ) Then
                     ESAT = vp0 *Exp( 22.514 - ( 6.15e3 / BLKTA ) )
                  Else
                     ESAT = vp0 *Exp( svp2 * ( BLKTA -stdtemp ) / ( BLKTA -svp3 ) ) 
                  End If
                  BLKRH = BLKPRS * BLKQV / ( ( EPSWATER + BLKQV ) *  ESAT )       
                  BLKRH = MIN( 0.99, MAX( 0.005, BLKRH ) )

C Calculate RH-dependent size-correction factors and solute mass fraction
C using equations from Zhang et al. (2005), which are valid over the
C 45-99% RH range.  Store powers of RH for polynomial calculations.
                  RH = BLKRH
                  RH = MAX( 0.45, MIN( 0.99, RH ) )
                  DRH = REAL( RH, 8 )

C Calculate inverse of size-correction factors from Equation 3 of Lewis & Schwartz 2006 and Zhang et al 2006 equation 2. 
!                  C0  = 3.70D0 * ( (1.0D0-DRH) / (2.0D0-DRH) ) ** (1.0D0/3.0D0)
!                  C80 = 1.82D0 * ( (1.0D0-DRH) / (2.0D0-DRH) ) ** (1.0D0/3.0D0)
                  C0  = A0  * ( (2.0D0-DRH) / (1.0D0-DRH) ) ** ONE3
                  C80 = A80 * C0

C Calculate solute mass fraction using Equation 1 of Zhang et al.
                  XSW =         X_COEFF( 1 )
     &                + DRH * ( X_COEFF( 2 )
     &                + DRH * ( X_COEFF( 3 )
     &                + DRH * ( X_COEFF( 4 )
     &                + DRH * ( X_COEFF( 5 )
     &                + DRH * ( X_COEFF( 6 ) ) ) ) ) )


C Calculate sea-salt-particle density [g/m3] at ambient RH, assuming
C volume additivity of dry salt plus water
                  RHOSW( 1 ) = 1.0D+3 
     &                  / ( XSW / SEASPRAY_DENS( 2 ) + ( 1.0D0 - XSW ) * SPECIFIC_VOL_H2O )
                  RHOSW( 2 ) = 1.0D+3 
     &                  / ( XSW / SEASPRAY_DENS( 3 ) + ( 1.0D0 - XSW ) * SPECIFIC_VOL_H2O )

C Set minimum and maximum diameters for integration using the size-
C correction factors of Zhang et al. (2005)

C Gong-Monahan flux function is valid from 0.005-5.0 um dry radius;
C multiply by 4 to get wet diameter at 80% RH
!                  DPMINO = 2.0E-8 / REAL( C80, 4 )
!                  DPMAXO = MIN( DPMAX, DPMAX / REAL( C80, 4 ) )
                  DPMINO = 2.0E-8 * REAL( C80, 4 )
                  DPMAXO = MIN( DPMAX, DPMAX * REAL( C80, 4 ) )


C deLeeuw flux function is valid from 1.6-20 um diameter at formation
!                 DPMINS = 1.6E-6 * C0 
!                 DPMAXS = MIN( DPMAX, DPMAX * C0 )
            
C Calculate scaling factors to correct the tabulated fluxes for the 10m
C wind speed in this cell.  Note: tabulated values are based on 1 m/s.
                  WDSCALO = MIN( U10, 20.0 ) ** 3.41        ! Gong-Monahan flux function
!                 WDSCALS = EXP( 0.23 * MIN( U10, 9.0 ) )   ! deLeeuw flux function

C SST scaling factor based on Jaegle et al. (2011)
C linearized by Ovadnevaite et al. (2014)
                  SSTSCALO = 0.38 + 0.054 * SST

C Calculate whitecap coverage fraction 
                  WCAP = 3.84E-6 * WDSCALO ! Eq. 5, Clarke et al. (2006) JGR

C Find position in the data arrays that corresponds to ambient RH in this
C grid cell and set the appropriate data values
                  IF ( BLKRH .LE. 0.45 ) THEN
                     IPOS = 1
                  ELSE IF ( BLKRH .LE. 0.90 ) THEN
                     IPOS = NINT( 100.0 * BLKRH - 44.0 )
                  ELSE IF ( BLKRH .LE. 0.99 ) THEN
                     IPOS = NINT( 1000.0 * BLKRH - 854.0 )
                  ELSE
                     IPOS = 136
                  END IF

                  DGNJRH = DGNJ ( IPOS ) * 1.0E-6   ! convert to [m]
                  DGNKRH = DGNK ( IPOS ) * 1.0E-6   ! convert to [m]
                  SIGJRH = SIGJ ( IPOS )
                  SIGKRH = SIGK ( IPOS ) 
                  FNJRH  = FNJ  ( IPOS )
                  FNKRH  = FNK  ( IPOS )
                  VFLXRH = VFLUX( IPOS ) * ( OFRAC * SSTSCALO
     &            + (SFRAC * 0.5) / WCAP )

C Save certain functions of the geometric standard deviations for later use
                  LNSGJ  = LOG( SIGJRH )
                  LNSGK  = LOG( SIGKRH )
                  RDIVJ  = 1.0 / ( SQRT( 2.0 ) * LNSGJ )
                  RDIVK  = 1.0 / ( SQRT( 2.0 ) * LNSGK )

C Calculate geometric-mean diameters by volume using Equation 7.52 of
C Seinfeld & Pandis (1998).
                  DGVJRH = DGNJRH * EXP( 3.0 * LNSGJ * LNSGJ )
                  DGVKRH = DGNKRH * EXP( 3.0 * LNSGK * LNSGK )

C Calculate modal volume fluxes [m3/m2/s] by evaluating finite integrals 
C from DPMIN to DPMAX over each lognormal distribution.  Use resulting
C values to calculate the fraction of the total number emissions to 
C assign to each mode.  See Equations 19 and 20 of Uma Shankar`s
C "Integration of Sea-Salt Fluxes" memo.
                  FFINJ  = 0.5 * FNJRH * DGVJRH ** 3 * EXP( -4.5 * LNSGJ * LNSGJ )
     &                         * ( ERF( LOG( DPMAXO / DGVJRH ) * RDIVJ )  
     &                           - ERF( LOG( DPMINO / DGVJRH ) * RDIVJ ) )
                  FFINK  = 0.5 * FNKRH * DGVKRH ** 3 * EXP( -4.5 * LNSGK * LNSGK )
     &                         * ( ERF( LOG( DPMAXO / DGVKRH ) * RDIVK )  
     &                           - ERF( LOG( DPMINO / DGVKRH ) * RDIVK ) )
                  FRACMJ = FFINJ / ( FFINJ + FFINK )
                  FRACMK = 1.0 - FRACMJ

C Calculate mode-specific mass emission rates [g/m3/s], by multiplying
C numerically-integrated volume fluxes by the modal volume fractions,
C scaling for wind speed, dividing by grid-cell height, and multiplying
C by particle density.  Multiply by chemical speciation factors to
C obtain speciated mass emissions.

                  ESEASJ = VFLXRH * FRACMJ * WDSCALO * RLAY1HT * REAL( RHOSW( 1 ), 4 )

                  ESEASK = VFLXRH * FRACMK * WDSCALO * RLAY1HT * REAL( RHOSW( 2 ), 4 )

                  DO S = 1, NSSSPC
                     IF ( S .EQ. KH2O ) THEN    ! Water
                        SSOUTM( S,C,R ) = ESEASJ * REAL( ( 1.0D0 - XSW ), 4 )
                        SSOUTM( S+NSSSPC,C,R ) = ESEASK * REAL( ( 1.0D0 - XSW ), 4 )
                     ELSE
                        SSOUTM( S,C,R ) = ESEASJ * REAL( XSW, 4 )
     &                                    * SEA_SPC( S )%SPCFAC( 1 )
                        SSOUTM( S+NSSSPC,C,R ) = ESEASK * REAL( XSW, 4 )
     &                                    * SEA_SPC( S )%SPCFAC( 2 )
                     END IF

                  END DO

C Calculate mode-specific 3rd moment emission rates [m3/m3/s]
                  M3J = ESEASJ * F6PI / REAL( RHOSW( 1 ), 4 ) + TINY(0.0)
                  M3K = ESEASK * F6PI / REAL( RHOSW( 2 ), 4 ) + TINY(0.0)

C Calculate factors for converting 3rd moment emission rates into number
C and 2nd moment emission rates.  See Equations 7b and 7c of Binkowski &
C Roselle (2003)
                  FACTNUMJ = EXP( 4.5 * LNSGJ * LNSGJ ) / DGVJRH ** 3
                  FACTNUMK = EXP( 4.5 * LNSGK * LNSGK ) / DGVKRH ** 3
                  FACTM2J  = EXP( 0.5 * LNSGJ * LNSGJ ) / DGVJRH
                  FACTM2K  = EXP( 0.5 * LNSGK * LNSGK ) / DGVKRH 

C Calculate mode-specific emission rates of particle number [1/s]
                  SSOUTN( 1,C,R ) = M3J * FACTNUMJ
                  SSOUTN( 2,C,R ) = M3K * FACTNUMK

C Calculate mode-specific dry surface area emission rates [m2/m3/s].  
C Subtract water from 3rd moment to obtain dry 3rd moment emission rate.  
C Calculate dry 2nd moment while holding the standard deviation constant.
C Multiply dry 2nd moment by PI to obtain dry surface area emission rate.
                  WET_M3J = M3J 
                  WET_M2J = M3J * FACTM2J
                  DRY_M3J = WET_M3J - F6PI * SSOUTM( KH2O,C,R ) * 1.0E-06
                  DRY_M2J = WET_M2J * ( DRY_M3J / WET_M3J ) ** TWO3

                  WET_M3K = M3K
                  WET_M2K = M3K * FACTM2K
                  DRY_M3K = WET_M3K - F6PI * SSOUTM( KH2O+NSSSPC,C,R ) * 1.0E-06
                  DRY_M2K = WET_M2K * ( DRY_M3K / WET_M3K ) ** TWO3

                  SSOUTS( 1,C,R ) = PI * DRY_M2J
                  SSOUTS( 2,C,R ) = PI * DRY_M2K

! Propagate Number and Surface Area Scaling Factors back to Emissions
! Module so that the sea spray emissions can be scaled appropriately            
                  SEA_FACTNUM( 1,C,R ) = 0.0
                  SEA_FACTNUM( 2,C,R ) = FACTNUMJ
                  SEA_FACTNUM( 3,C,R ) = FACTNUMK
                  SEA_FACTSRF( 1,C,R ) = 0.0
                  SEA_FACTSRF( 2,C,R ) = SSOUTS( 1,C,R ) / M3J
                  SEA_FACTSRF( 3,C,R ) = SSOUTS( 2,C,R ) / M3K

C Update the SSBF array, for writing the diagnostic sea-salt-emission file.
                  IF ( SSEMDIAG .AND. .NOT. L_DESID_DIAG ) THEN
                     V = 0
                     DO N = 1, 2
                        DO S = 1, NSSSPC
                           IF ( S .EQ. KH2O .OR. SEA_SPC( S )%SPCFAC( N ) .GT. 0 ) THEN
                              V = V + 1
                              SSOUTD( V ) = SSOUTM( (N-1)*NSSSPC+S,C,R )
                           END IF
                        END DO
                     END DO

                     DO N = 1, 2
                        V = V + 1
                        SSOUTD( V ) = SSOUTN( N,C,R )
                     END DO

                     DO N = 1, 2
                        V = V + 1
                        SSOUTD( V ) = SSOUTS( N,C,R )
                     END DO

#ifdef mpas
                     DO S = 1, NSSDIAG
                        SSBF( S,C,R ) = SSBF( S,C,R ) + SSOUTD( S ) * cell_vol(c,1,1)
     &                                * FLOAT( TIME2SEC ( TSTEP( 2 ) ) )
                     END DO
#else
                     AIRVOL = CELLVOL(C,R) / Met_Data%RJACM( C,R,1 )

                     DO S = 1, NSSDIAG
                        SSBF( S,C,R ) = SSBF( S,C,R ) + SSOUTD( S ) * AIRVOL
     &                                * FLOAT( TIME2SEC ( TSTEP( 2 ) ) )
                     END DO
#endif

                  END IF  ! SSEMDIAG

                  ! Convert from volume-normalized to total Emission
                  ! rate [e.g. g/m3/s to g/s]
                  DO N = 1,2
                      DO S = 1,NSSSPC
                        SSOUTM( (N-1)*NSSSPC+S,C,R ) = 
     &                     SSOUTM( (N-1)*NSSSPC+S,C,R ) * GSFAC( C,R ) ! g/s
                      END DO
                      SSOUTN( N,C,R ) = SSOUTN( N,C,R ) * GSFAC( C,R ) ! N/s
                      SSOUTS( N,C,R ) = SSOUTS( N,C,R ) * GSFAC( C,R ) ! m2/s
                  END DO

               END DO   ! C
            END DO   ! R

C If last call this hour, write out the total sea-salt emissions [g/s].
C Then reset the sea-salt emissions array and local write counter.
#ifndef mpas
            IF ( SSEMDIAG .AND. .NOT. L_DESID_DIAG ) THEN

#ifdef parallel_io
               IF ( FIRSTIME ) THEN
                  FIRSTIME = .FALSE.
                  IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                     IF ( .NOT. OPEN3( CTM_DRY_DEP_1, FSREAD3, PNAME ) ) THEN
                        XMSG = 'Could not open ' // TRIM( CTM_DRY_DEP_1 )
                        CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                     END IF
                  END IF
               END IF
#endif

               WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )

               IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
                  IF ( .NOT. CURRSTEP( JDATE, JTIME, STDATE, STTIME, TSTEP( 1 ),
     &                                 MDATE, MTIME ) ) THEN
                     XMSG = 'Cannot get step date and time'
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
                  END IF
                  CALL NEXTIME( MDATE, MTIME, TSTEP( 1 ) )
                  DO V = 1, NSSDIAG
                     DO R = 1, NROWS
                        DO C = 1, NCOLS
                           WRSS( C,R ) = SSBF( V,C,R ) / FLOAT( WSTEP )
                        END DO
                     END DO
                     IF ( .NOT. WRITE3( CTM_SSEMIS_1, WRSS_SPC( V ),
     &                          MDATE, MTIME, WRSS ) ) THEN
                        XMSG = 'Could not write ' // CTM_SSEMIS_1 // ' file'
                        CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
                     END IF
                  END DO
                  WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &                  'Timestep written to', CTM_SSEMIS_1,
     &                  'for date and time', MDATE, MTIME
                  WSTEP = 0
                  SSBF = 0.0
               END IF

            END IF  ! SSEMDIAG
#endif

            RETURN
            
         END SUBROUTINE GET_SSEMIS

      END MODULE SSEMIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPACONC ( JDATE, JTIME, TSTEP )

! Revision History:
!   D. Wong - July 15: initial version
!   D. Wong 19 May 2016 - renamed ACONC_END_TIME to AVG_FILE_ENDTIME
!   F. Sidi 09 Sep 2019 - Replaced L_ACONC_WVEL(depreciated) with W_VEL
!-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE AVG_CONC              ! integral average CONC
      USE UTILIO_DEFN
      USE MIO_ASCII
#ifndef mpas
#ifdef parallel    
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif

      IMPLICIT NONE

! Include Files:

      INCLUDE SUBST_FILES_ID    ! file name parameters

      INTEGER, INTENT (IN ) :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT (IN ) :: JTIME        ! current model time, coded HHMMSS
      INTEGER, INTENT (IN ) :: TSTEP        ! output timestep (HHMMSS)

! Local variables:

      INTEGER      MDATE        ! modified model date, coded YYYYDDD
      INTEGER      MTIME        ! modified model time, coded HHMMSS

      CHARACTER( 16 ) :: PNAME = 'OPACONC'
      CHARACTER( 80 ) :: VARDESC = ' '
      CHARACTER( 96 ) :: XMSG = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL OK

      INTEGER      L, K, KD, VAR, SPC ! loop counters
      INTEGER      STATUS

      INTEGER TSTEP_RF, NTHIK_RF, NCOLS_RF, NROWS_RF, GDTYP_RF
      REAL( 8 ) :: P_ALP_RF, P_BET_RF, P_GAM_RF
      REAL( 8 ) :: XCENT_RF, YCENT_RF
      REAL( 8 ) :: XORIG_RF, YORIG_RF
      REAL( 8 ) :: XCELL_RF, YCELL_RF
      INTEGER VGTYP_RF
      REAL VGTOP_RF
!-----------------------------------------------------------------------

! Change output date/time to starting date/time - e.g. timestamp 1995196:090000
! represents data computed from time 1995196:090000 to 1995196:100000

#ifndef mpas 
! Override default beginning time timestamp for ACONC?      
      IF ( END_TIME ) THEN   ! ending time timestamp
         MDATE = JDATE; MTIME = JTIME
         CALL NEXTIME ( MDATE, MTIME, TSTEP )
      ELSE                   ! beginning time timestamp
         MDATE = JDATE; MTIME = JTIME
      END IF
 

! Try to open existing file for update
      OK = OPEN3( A_CONC_1, FSRDWR3, PNAME )
      CALL SUBST_GLOBAL_LOGICAL( OK, 'AND' )
      IF ( .NOT. OK ) THEN
#ifndef twoway
         BACKSPACE( LOGDEV )
#endif
         XMSG = 'Could not open ' // TRIM( A_CONC_1 )
     &        // ' file for update - try to open new'
         CALL M3MESG( XMSG )

         IF ( IO_PE_INCLUSIVE ) THEN

! Get default file header attibutes from CONC file (assumes file already open)

            IF ( .NOT. DESC3( CTM_CONC_1 ) ) THEN
               XMSG = 'Could not get '
     &              // TRIM( CTM_CONC_1 )
     &              // ' file description'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

! Set file header attributes that differ from CONC and open the file

            SDATE3D = MDATE
            STIME3D = MTIME
            TSTEP3D = TSTEP
            NVARS3D = N_ACONC_VARS
            NLAYS3D = A_NLYS

            L = 0
            DO K = ACONC_BLEV, ACONC_ELEV + 1
               L = L + 1
               VGLVS3D( L ) = VGLVS_GD( K )
            END DO
!           GDNAM3D = GDNAME_GD
            GDNAM3D = GRID_NAME  ! from HGRD_DEFN

            FDESC3D( 1 ) = 'Concentration file output '
            FDESC3D( 2 ) = 'Averaged over the synchronization time steps '
            FDESC3D( 3 ) = 'Timestamp represents beginning computed date/time '
            FDESC3D( 4 ) = 'Layer mapping (CGRID to AGRID):'
            KD = 4
            VAR = ACONC_BLEV
            L = 0
            DO K = KD + 1, MIN ( A_NLYS + KD, MXDESC3 )
               L = L + 1
               WRITE( FDESC3D( K ),'( "Layer", I3, " to", I3, " " )' )
     &         VAR + L - 1, L
            END DO
            IF ( ( KD + 1 + L ) .LT. MXDESC3 ) THEN
               DO K = KD + 1 + L, MXDESC3
                  FDESC3D( K ) = ' '
               END DO
            END IF

            WRITE( LOGDEV,* ) 
            WRITE( LOGDEV, '(5x,A)' ) 'Avg Conc File Header Description:'
            DO K = 1, KD + L
               WRITE( LOGDEV,'(7x,A)' ) TRIM( FDESC3D( K ) )
            END DO

            VAR = 0

            DO SPC = 1, N_A_GC_SPC
               VAR = VAR + 1
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = A_GC_SPC( SPC )
               UNITS3D( VAR ) = 'ppmV'
               VDESC3D( VAR ) = 'Average Molar Mixing Ratio of ' // VNAME3D( VAR )
            END DO

            DO SPC = 1, N_A_AE_SPC
               VAR = VAR + 1
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = A_AE_SPC( SPC )
               IF ( VNAME3D( VAR )(1:3) .EQ. 'NUM' ) THEN
                  UNITS3D( VAR ) = 'm-3'
               ELSE IF ( VNAME3D( VAR )(1:3) .EQ. 'SRF' ) THEN
                  UNITS3D( VAR ) = 'm2 m-3'
               ELSE
                  UNITS3D( VAR ) = 'ug m-3'
               END IF
               VDESC3D( VAR ) = 'Average Concentrations of ' // VNAME3D( VAR )
            END DO

            DO SPC = 1, N_A_NR_SPC
               VAR = VAR + 1
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = A_NR_SPC( SPC )
               UNITS3D( VAR ) = 'ppmV'
               VDESC3D( VAR ) = 'Average Molar Mixing Ratio of ' // VNAME3D( VAR )
            END DO

            DO SPC = 1, N_A_TR_SPC
               VAR = VAR + 1
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = A_TR_SPC( SPC )
               UNITS3D( VAR ) = 'ppmV'
               VDESC3D( VAR ) = 'Average Molar Mixing Ratio of ' // VNAME3D( VAR )
            END DO

            IF ( W_VEL ) THEN
               VAR = VAR + 1 
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = 'W_VEL'
               UNITS3D( VAR ) = 'm s-1'
               VDESC3D( VAR ) = 'Vertical Wind Velocity'
            END IF
             
            IF ( L_ACONC_RH ) THEN
               VAR = VAR + 1 
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = 'RH'
               UNITS3D( VAR ) = '1'
               VDESC3D( VAR ) = 'Fractional Relative Humidity'
            END IF
             
            IF ( L_ACONC_TA ) THEN
               VAR = VAR + 1 
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = 'TA'
               UNITS3D( VAR ) = 'K'
               VDESC3D( VAR ) = 'Air Temperature'
            END IF
          
            IF ( L_ACONC_PRES ) THEN
               VAR = VAR + 1 
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = 'PRES'
               UNITS3D( VAR ) = 'Pa'
               VDESC3D( VAR ) = 'Air Pressure'
            END IF

            DO SPC = 1, VAR
               WRITE( LOGDEV,'( 7X, "=> VNAME3D(", I3, " ): ", A )' )
     &                SPC, VNAME3D( SPC )
            END DO

            ! Store MIO Metadata
            NDIMS3D( 1:NVARS3D ) = 4
            L_TSTEP( 1:NVARS3D ) = .True.
            L_LAY  ( 1:NVARS3D ) = .True.
            L_COL  ( 1:NVARS3D ) = .True.
            L_ROW  ( 1:NVARS3D ) = .True.
            L_VEXT ( 1:NVARS3D ) = .False.
            
            CALL LOAD_MIO_FILE ( 'A_CONC_1', NLAYS3D, ACONC_BLEV, ACONC_ELEV,
     &           VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D), 
     &           VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D), 
     &           L_LAY(1:NVARS3D),   L_COL(1:NVARS3D), L_ROW(1:NVARS3D),
     &           L_VEXT(1:NVARS3D) )

            ! Open Output File
            IF ( .NOT. OPEN3( A_CONC_1, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not open '
     &              // TRIM( A_CONC_1 ) // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF

         END IF   ! MYPE = 0

      ELSE

! File exists. Make sure it matches requested output.

         IF ( .NOT. DESC3( CTM_CONC_1 ) ) THEN
            XMSG = 'Could not get '
     &           // TRIM( CTM_CONC_1 )
     &           // ' file description'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         TSTEP_RF = TSTEP3D
         NTHIK_RF = NTHIK3D
         NCOLS_RF = NCOLS3D
         NROWS_RF = NROWS3D
         GDTYP_RF = GDTYP3D
         P_ALP_RF = P_ALP3D
         P_BET_RF = P_BET3D
         P_GAM_RF = P_GAM3D
         XCENT_RF = XCENT3D
         YCENT_RF = YCENT3D
         XORIG_RF = XORIG3D
         YORIG_RF = YORIG3D
         XCELL_RF = XCELL3D
         YCELL_RF = YCELL3D
         VGTYP_RF = VGTYP3D
         VGTOP_RF = VGTOP3D

         IF ( .NOT. DESC3( A_CONC_1 ) ) THEN
            XMSG = 'Could not get '
     &           // TRIM( A_CONC_1 )
     &           // ' file description'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( N_ACONC_VARS .NE. NVARS3D ) THEN
            WRITE( XMSG, '( A, 2I6 )' )
     &      'Number of variables don''t match file: ', N_ACONC_VARS, NVARS3D
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF

         DO SPC = 1, N_ASPCS
            DO VAR = 1, NVARS3D
               IF ( ACONC_FILE_SPCS( SPC ) .EQ. VNAME3D( VAR ) ) GO TO 101
            END DO
            XMSG = 'Could not find ' // ACONC_FILE_SPCS( SPC )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
101         CONTINUE
         END DO

         IF ( A_NLYS .NE. NLAYS3D ) THEN
            WRITE( XMSG, '( A, 2I6 )' )
     &      'Number of layers don''t match file: ', A_NLYS, NLAYS3D
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF

! Check other header data with CONC file as reference

         IF ( TSTEP_RF .NE. TSTEP3D .OR.
     &        NTHIK_RF .NE. NTHIK3D .OR.
     &        NCOLS_RF .NE. NCOLS3D .OR.
     &        NROWS_RF .NE. NROWS3D .OR.
     &        GDTYP_RF .NE. GDTYP3D ) THEN
              XMSG = 'Header inconsistent on existing A_CONC_1'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( P_ALP_RF .NE. P_ALP3D .OR.
     &        P_BET_RF .NE. P_BET3D .OR.
     &        P_GAM_RF .NE. P_GAM3D ) THEN
              XMSG = 'Header inconsistent on existing A_CONC_1'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( XCENT_RF .NE. XCENT3D .OR.
     &        YCENT_RF .NE. YCENT3D ) THEN
              XMSG = 'Header inconsistent on existing A_CONC_1'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( XORIG_RF .NE. XORIG3D .OR.
     &        YORIG_RF .NE. YORIG3D ) THEN
            XMSG = 'Header inconsistent on existing A_CONC_1'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( XCELL_RF .NE. XCELL3D .OR.
     &        YCELL_RF .NE. YCELL3D ) THEN
            XMSG = 'Header inconsistent on existing A_CONC_1'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( VGTYP_RF .NE. VGTYP3D ) THEN
            XMSG = 'Header inconsistent on existing A_CONC_1'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( VGTOP_RF .NE. VGTOP3D ) THEN
            XMSG = 'Header inconsistent on existing A_CONC_1'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF

      END IF   ! .NOT. OPEN A_CONC_1
#endif

      END SUBROUTINE OPACONC

      SUBROUTINE SA_WRAP_AE( CGRID0, CGRID, JDATE, JTIME, TSTEP )

!*************************************************************
!20140428 As a wrapper to apportion the tags with bulk conc after AERO process
!
!     Called by sciproc.F

! Revision History:
!
!   13 May 19 David Wong: Implemented centralized I/O approach
!*************************************************************
      USE GRID_CONF
      USE CGRID_SPCS
      USE SA_DEFN
      USE UTILIO_DEFN
      USE AERO_BUDGET
      USE AERO_DATA, ONLY : AERO_MISSING, AEROSPC_MAP, N_MODE,
     &                      N_AEROSPC, AEROSPC, AEROSPC_MWINV,
     &                      AEROSPC_MW
      USE CENTRALIZED_IO_MODULE, only : interpolate_var
      USE CONST, ONLY: MWAIR

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID

! Arguments
      REAL, POINTER             :: CGRID( :,:,:,: )
      REAL                      :: CGRID0( :,:,:,: )
      INTEGER, INTENT( IN )     :: JDATE
      INTEGER, INTENT( IN )     :: JTIME
      INTEGER, INTENT( IN )     :: TSTEP( 3 )

! Scratch
      CHARACTER( 16 ), SAVE :: PNAME = 'SA_WRAP_AE'
      REAL(8), ALLOCATABLE, SAVE :: BULK0( :,:,:,: )
      REAL(8), ALLOCATABLE, SAVE :: CCOND( :,:,:,: )

! for interpx
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      REAL DENS ( NCOLS,NROWS,NLAYS )
      INTEGER MDATE, MTIME, MSTEP
      CHARACTER( 96 ) :: XMSG = ' '

! ppm2mole conversion
      REAL(8) ppm2mole( NCOLS,NROWS,NLAYS )

! Identify ISAM species indices 20130529
      INTEGER :: ISA1, ISA2, ICG1, ICG2, IAER, IM, K, C, R, L
      INTEGER :: JGAS, CGAS, JCTR, CCTR, JAER( N_MODE ), CAER( N_MODE )
      LOGICAL :: OMH2O

! Arrays for combined ammonium, combined nitrates, and combined sulfates

      REAL(8), ALLOCATABLE, SAVE :: SPEC_BULK0(:,:,:)
      REAL(8), ALLOCATABLE, SAVE :: TAG_FRAC(:,:,:)
      REAL(8), ALLOCATABLE, SAVE :: TAG_FRAC2(:,:,:)
      REAL(8), ALLOCATABLE, SAVE :: BULK1(:,:,:)
      REAL(8), ALLOCATABLE, SAVE :: BULK_TRANS_SRC(:,:,:)

      REAL(8), ALLOCATABLE, SAVE :: ISAM0(:,:,:,:,:)
      REAL(8), ALLOCATABLE, SAVE :: ISAM1(:,:,:,:,:)

      LOGICAL, ALLOCATABLE, SAVE :: L_MASK_AERO( : ), L_MASK_OM( : )
      CHARACTER( 3 ), ALLOCATABLE, SAVE :: L_MASK_TYPE( : )
      INTEGER, ALLOCATABLE, SAVE :: L_MASK_IM( : )

      REAL(8), PARAMETER :: MIN_VAL = 1.0E-25
      REAL(8), SAVE :: MIN_TAGTOT 

      INTEGER ALLOCSTAT
!-------------------------------------------------------------------


Ckrt Identify species index in ISAM array
      IF ( FIRSTIME ) THEN
        FIRSTIME = .FALSE.

        MIN_TAGTOT = MIN_VAL * NTAG_SA
  
        ALLOCATE( 
     &     CCOND( NCOLS,NROWS,NLAYS,NSPCSD ),
     &     SPEC_BULK0( NCOLS,NROWS,NLAYS ),
     &     BULK0( NCOLS,NROWS,NLAYS,NSPC_SA ),
     &     BULK1( NCOLS,NROWS,NLAYS ),
     &     BULK_TRANS_SRC( NCOLS,NROWS,NLAYS ),
     &     TAG_FRAC( NCOLS,NROWS,NLAYS ),
     &     TAG_FRAC2( NCOLS,NROWS,NLAYS ),
     &     ISAM0( NCOLS,NROWS,NLAYS,NSPC_SA,NTAG_SA ),
     &     ISAM1( NCOLS,NROWS,NLAYS,NSPC_SA,NTAG_SA ),
     &     STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating CCOND, SPEC_BULK0, '
     &          //'BULK0, BULK1, BULK_TRANS_SRC, TAG_FRAC, '
     &          //'ISAM0, or ISAM1.'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ! Store Masks for Aerosol features in vectors of length NSPC_SA
        ALLOCATE( L_MASK_AERO( NSPC_SA ), L_MASK_TYPE( NSPC_SA ), 
     &            L_MASK_OM( NSPC_SA )  , L_MASK_IM( NSPC_SA ) )
        L_MASK_AERO = .FALSE.
        L_MASK_TYPE = ''
        L_MASK_OM   = .FALSE.
        L_MASK_IM   = 0
        DO IAER = 1,N_AEROSPC
           JAER( : ) = MAP_AEROtoSA( IAER,: ) 
           DO IM = 1,N_MODE
              IF ( JAER(IM)  .NE. 0 ) THEN 
                 L_MASK_AERO( JAER(IM) ) = .TRUE.
                 L_MASK_TYPE( JAER(IM) ) = AEROSPC( IAER )%VOLTYPE
                 L_MASK_OM  ( JAER(IM) ) = AEROSPC( IAER )%OM
                 L_MASK_IM  ( JAER(IM) ) = IM
              END IF
           END DO
        END DO   

      ENDIF ! firstime ?

      ! Extract Density for gas conversion to umol/m3
      MDATE = JDATE
      MTIME = JTIME
      MSTEP = TIME2SEC( TSTEP( 2 ) )
      CALL NEXTIME ( MDATE, MTIME, SEC2TIME( MSTEP/2 ) )

      ! Get Air Density in kg/m3
      call interpolate_var ('DENS', MDATE, MTIME, DENS)

      ! Conversion factor to move gases from ppmv to umol/m3
      ppm2mole( :,:,: ) = DBLE( MAX( DENS( :,:,: ) * 1000. / MWAIR, 1e-10 ) )
      
      ! Sum up pre-process tags for each species at each grid cell
c     ISAM0(:,:,:,:,:) = MAX( DBLE( ISAM(:,:,:,:,:) ), MIN_VAL )
      ISAM0(:,:,:,:,:) = DBLE( ISAM(:,:,:,:,:) ) 
      ISAM1(:,:,:,:,:) = ISAM0(:,:,:,:,:)
      BULK0( :,:,:,: ) = SUM( ISAM0( :,:,:,:,: ),5 )

      CCOND = DBLE( CGRID0 + AERO_COND + AERO_NPF )

 
      !------------------------!
      !>>>>> CONDENSATION <<<<<!
      DO IAER = 1,N_AEROSPC
          IF ( .NOT.L_ISAM_AERO( IAER ) ) CYCLE
          JAER( : ) = MAP_AEROtoSA( IAER,: )
          CAER( : ) = AEROSPC_MAP( IAER,: )

          ! Reversible Partitioning
          IF ( AEROSPC( IAER )%VOLTYPE .EQ. 'REV' ) THEN
             ! Load Indices for Vapor-Phase Species and Reaction
             ! Counter, if present
             JGAS = MAP_AEROGAStoSA( IAER )
             CGAS = MAP_SAtoCGR( JGAS )
             JCTR = MAP_AEROCTRtoSA( IAER )
             CCTR = 0
             IF ( JCTR .GT. 0 ) CCTR = MAP_SAtoCGR( JCTR )

             ! First Move Apportionment to/from the coarse mode
             ! explicitly, if it exists.
             IF ( JAER(3) .GT. 0 ) THEN
                DO K = 1,NTAG_SA
                   TAG_FRAC( :,:,: ) = ISAM0( :,:,:,JGAS,K ) / BULK0( :,:,:,JGAS )
     &                                * DBLE( AERO_COND( :,:,:,CAER(3) ) )
                   TAG_FRAC2( :,:,: )= ISAM0( :,:,:,JAER(3),K ) / BULK0( :,:,:,JAER(3) )
     &                                * DBLE( AERO_COND( :,:,:,CAER(3) ) * -1.0 )
                   DO C = 1,NCOLS
                   DO R = 1,NROWS
                   DO L = 1,NLAYS
                     IF ( AERO_COND( C,R,L,CAER(3) ) .GT. 0.0 ) THEN 
                        ! Condensation - Gas-phase drives attribution
                        TAG_FRAC( C,R,L ) = MIN( TAG_FRAC( C,R,L ), 
c    &                                           ISAM1( C,R,L,JGAS,K )-MIN_VAL )
     &                                           ISAM1( C,R,L,JGAS,K ) )
                        ISAM1( C,R,L,JAER(3),K ) = 
     &                         ISAM1( C,R,L,JAER(3),K ) + TAG_FRAC( C,R,L ) 
                        ISAM1( C,R,L,JGAS,K ) = 
     &                         ISAM1( C,R,L,JGAS,K ) - TAG_FRAC( C,R,L )
                     ELSE   
                        ! Evaporation - Aerosol drives attribution
                        TAG_FRAC2( C,R,L ) = MIN( TAG_FRAC2( C,R,L ), 
c    &                                           ISAM1( C,R,L,JAER(3),K )-MIN_VAL )
     &                                           ISAM1( C,R,L,JAER(3),K ) )
                        ISAM1( C,R,L,JAER(3),K ) = 
     &                         ISAM1( C,R,L,JAER(3),K ) - TAG_FRAC2( C,R,L )
                        ISAM1( C,R,L,JGAS,K ) = 
     &                         ISAM1( C,R,L,JGAS,K ) + TAG_FRAC2( C,R,L )
                     END IF
                   END DO
                   END DO
                   END DO
                END DO
                BULK0( :,:,:,JGAS ) = SUM( ISAM1(:,:,:,JGAS,:),4 )
             END IF

             ! Then apply apportionment uniformly across the gas and 
             ! fine modes, if they exist since they are at equilibrium.

             ! Sum up Initial Bulk Gas plus Bulk Particle
             SPEC_BULK0 = 0.0
             DO IM = 1,2
                IF ( JAER(IM) .GT. 0 ) THEN
                   SPEC_BULK0 = SPEC_BULK0 
     &                  + BULK0( :,:,:,JAER(IM)) 
                END IF
             END DO
             SPEC_BULK0( :,:,: ) = SPEC_BULK0( :,:,: ) * DBLE( AEROSPC_MWINV( IAER ) ) ! umol m-3
             
             ! Add mass from condensable vapor
             SPEC_BULK0 = BULK0( :,:,:,JGAS ) * ppm2mole + SPEC_BULK0( :,:,: )  ! umol m-3
             
             ! Add condensation from reaction counter, if applicable
             IF ( JCTR .GT. 0 ) 
     &          SPEC_BULK0 = SPEC_BULK0 
     &             +BULK0( :,:,:,JCTR ) * ppm2mole 
     &              * DBLE( AEROSPC( IAER )%CTR_YIELD 
     &                     *CGRID_MW( CCTR ) / AEROSPC_MW( IAER ) ) ! umol m-3

             ! For each tag, find fraction of bulk condensable species in gas and 
             ! particle phases and apply that fraction to the species in all phases 
             ! for this tag.
             DO K = 1,NTAG_SA
                ! Add Aerosol Species for each mode if they exist
                TAG_FRAC = 0.0
                DO IM = 1,2
                   IF ( JAER(IM) .GT. 0 ) THEN
                      TAG_FRAC( :,:,: ) = TAG_FRAC( :,:,: ) +
     &                     ISAM0( :,:,:,JAER(IM),K )
                   END IF
                END DO
                TAG_FRAC( :,:,: ) = TAG_FRAC * DBLE( AEROSPC_MWINV( IAER ) ) ! umol m-3

                ! Add condensable vapor - use ISAM1 here instead of
                ! ISAM0 in case gas has been updated in the coarse mode
                ! section.
                TAG_FRAC( :,:,: ) = TAG_FRAC + ISAM1( :,:,:,JGAS,K ) * ppm2mole  ! umol m-3 /
                
                ! Add condensation from reaction counter, if applicable
                IF ( JCTR .GT. 0 ) 
     &               TAG_FRAC( :,:,: ) = TAG_FRAC 
     &                      +ISAM0( :,:,:,JCTR,K ) * ppm2mole 
     &                       * DBLE( AEROSPC(IAER)%CTR_YIELD
     &                              *CGRID_MW( CCTR ) / AEROSPC_MW( IAER ) ) ! umol m-3

                ! Calculate Fraction of source k in bulk
                TAG_FRAC = TAG_FRAC / SPEC_BULK0 ! umol m-3

                ! Propagate source apportionment based on aerosol condensation changes to 
                ! semivolatile vapor and aerosol.
                DO IM = 1,2
                   IF ( JAER(IM) .NE. 0 ) 
     &                ISAM1( :,:,:,JAER(IM),K ) = 
     &                    TAG_FRAC( :,:,: ) * CCOND( :,:,:,CAER(IM) ) ! ug m-3
                END DO
                
                ! Caclulate Apportionment for Condensable Vapor
                ISAM1( :,:,:,JGAS,K ) = TAG_FRAC( :,:,: ) * CGRID( :,:,:,CGAS ) ! ppmv
                
                ! Reset Reaction Counter if it is defined
                IF ( JCTR .GT. 0 ) ISAM1( :,:,:,JCTR,K ) = MIN_VAL

             END DO

          ! Irreversible Partitioning
          ELSE IF ( AEROSPC( IAER )%VOLTYPE .EQ. 'IRV' ) THEN
             ! Retrieve index of reaction counter relevant for this
             ! irreversible partioning species. This index is in terms
             ! of the location of the counter in the ISAM array. Also
             ! retrieve low-volaitlity vapor index.
             JCTR = MAP_AEROCTRtoSA( IAER )
             JGAS = MAP_AEROGAStoSA( IAER )

             DO K = 1,NTAG_SA
               ! Find Source Apportionment of the low volatility vapor species
               ! or, if it doesn't exist, the reaction counter
               IF ( JGAS .GT. 0 ) THEN
                  TAG_FRAC( :,:,: ) = ISAM0( :,:,:,JGAS,K ) / ( BULK0( :,:,:,JGAS ) + MIN_VAL )
               ELSE  IF ( JCTR .GT. 0 ) THEN
                  TAG_FRAC( :,:,: ) = ISAM0( :,:,:,JCTR,K ) / ( BULK0( :,:,:,JCTR ) + MIN_VAL )
               ELSE
                  XMSG = 'Either a Low-Volatility Gas or a Reaction Counter ' //
     &                   'must be defined for Irreversible Aerosol Species '// 
     &                   'source apporitonment. Please check the AERO_DATA '//
     &                   'aerosol properties table (gasname, ctrname).'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

               ! Apportion condensed mass based on gas apporitonment
               DO IM = 1,N_MODE
                  IF ( JAER(IM) .NE. 0 ) 
     &               ISAM1( :,:,:,JAER(IM),K ) = 
     &                    ISAM0( :,:,:,JAER(IM),K )
     &                  + DBLE( AERO_COND( :,:,:,CAER(IM) )
     &                         +AERO_NPF ( :,:,:,CAER(IM) ) )
     &                    * TAG_FRAC( :,:,: )              
               END DO

               ! Apportion the change in the low volaitlity vapor
               IF ( JGAS .GT. 0 ) THEN
                  CGAS = MAP_SAtoCGR( JGAS )
                  ISAM1( :,:,:,JGAS,K ) = CGRID( :,:,:,CGAS ) * TAG_FRAC( :,:,: )
               END IF

               ! Reset the reaction counter
               IF ( JCTR .GT. 0 ) ISAM1( :,:,:,JCTR,K ) = MIN_VAL

             END DO

          ! Water Species
          ELSE IF ( AEROSPC( IAER )%VOLTYPE .EQ. 'H2O' ) THEN
             ! Water Vapor Species is not explicitly tracked so special
             ! care must be taken for this species.
             DO IM = 1,N_MODE
                BULK_TRANS_SRC = 0.0
                IF ( JAER(IM) .NE. 0 ) THEN
                   BULK_TRANS_SRC( :,:,: ) = AERO_COND( :,:,:,CAER(IM) )
     &                              + AERO_NPF ( :,:,:,CAER(IM) )
                   OMH2O = .FALSE.
                   IF ( ISAM_SPEC( JAER(IM),1 )(1:4) .EQ. 'AORG' ) OMH2O = .TRUE.
                END IF

                DO C = 1,NCOLS
                DO R = 1,NROWS
                DO L = 1,NLAYS
                   IF ( BULK_TRANS_SRC( C,R,L ) .LT. 0.0 ) THEN
                     ! Assume that net losses pull proportionally from water species
                     IF ( JAER(IM) .NE. 0 ) THEN
                       SPEC_BULK0( C,R,L ) = SUM( ISAM0( C,R,L,JAER(IM),: ) )
                       ISAM1( C,R,L,JAER(IM),: ) = ISAM0( C,R,L,JAER(IM),: ) *
     &                       ( 1.0 + BULK_TRANS_SRC( C,R,L )/
     &                       ( SPEC_BULK0( C,R,L ) + MIN_VAL ) )
                     END IF
                   ELSE
                     ! Assume that net gains are apportioned like current non-water aerosol
                     ! Determine the total non-water mass separating
                     ! inorganic and organic
                     SPEC_BULK0( C,R,L ) = SUM( SUM( ISAM0( C,R,L,:,: ), DIM=2),
     &                      MASK = (L_MASK_AERO .AND. 
     &                            L_MASK_TYPE .NE. 'H2O'  .AND.
     &                            OMH2O .EQV. L_MASK_OM   .AND.
     &                            IM .EQ. L_MASK_IM   ) )
                     DO K = 1,NTAG_SA
                       IF ( JAER(IM) .NE. 0 ) THEN
                          ISAM1( C,R,L,JAER(IM),K ) = ISAM0( C,R,L,JAER(IM),K ) +
     &                      SUM( ISAM0( C,R,L,:,K ),
     &                          MASK = (L_MASK_AERO .AND. 
     &                                L_MASK_TYPE .NE. 'H2O'  .AND.
     &                                OMH2O .EQV. L_MASK_OM   .AND. 
     &                                IM .EQ. L_MASK_IM  ) )
     &                           * BULK_TRANS_SRC( C,R,L )
     &                           / ( SPEC_BULK0( C,R,L ) + MIN_VAL )
                       END IF
                     END DO
                   END IF
                END DO
                END DO
                END DO
             END DO                       

          ! Nonvolatile Species (VOLTYPE = 'NVL')
          ELSE
             ! Nothing to be done for Nonvolatile Species
          END IF
      END DO

      ISAM1 = MAX( ISAM1, MIN_VAL )

c  !-----------------------!
c  !>>>>> COAGULATION <<<<<!
      ! Propagate source apportionment changes through coagulation and
      ! growth processes
      DO IAER = 1,N_AEROSPC
          IF ( AERO_MISSING( IAER,1 ) ) CYCLE

          ! Account for Loss of Aitken Mode from Coagulation and Growth
          ! Move source contribution from Aitken mode to Accumulation
          ! mode
          ISA1 = MAP_AEROtoSA( IAER,1 )  ! Index of source particles (1=Aitken)
          IF ( ISA1 .EQ. 0 ) CYCLE

          ISA2 = MAP_AEROtoSA( IAER,2 )  ! Index of destination particles (2=Accumulation)
          ICG1 = AEROSPC_MAP( IAER,1 )   ! Index of source in CGRID and process analysis arrays
          ICG2 = AEROSPC_MAP( IAER,2 )   ! Index of destination in CGRID and  process analysis arrays
          
          BULK1( :,:,: ) = SUM( ISAM1( :,:,:,ISA1,: ),4 ) 
          BULK_TRANS_SRC( :,:,: ) = -1.0 * DBLE( AERO_COAG( :,:,:,ICG1 ) + AERO_GROWTH(:,:,:,ICG1 ) )
          DO K = 1,NTAG_SA
             ! Calculate Apportioned mass leaving the source mode using the
             ! COAG and GROWTH process analysis arrays
             TAG_FRAC( :,:,: ) = MIN( ISAM1(:,:,:,ISA1,K) / BULK1(:,:,:) 
     &                                * BULK_TRANS_SRC( :,:,: ), 
     &                               ISAM1( :,:,:,ISA1,K ) - MIN_VAL )
             ISAM1( :,:,:,ISA1,K ) = ISAM1( :,:,:,ISA1,K ) - TAG_FRAC( :,:,: )

             ! Add that mass to the destination mode and recalculate
             ! apportionment
             ISAM1( :,:,:,ISA2,K ) = ISAM1( :,:,:,ISA2,K ) + TAG_FRAC( :,:,: ) 
          END DO

      END DO

      ! Update global ISAM array with modified attribution array ISAM1
      ISAM = ISAM1
      


      END 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains key component from NH3_BIDI_MOD.F to facilitate 
! centralized I/O implementation by avoiding cyclic data dependence

! Revision History:
!  01 Feb 2019 D.Wong initial implementation, 
!------------------------------------------------------------------------!

          module depv_data_module

            use Bidi_Mod, Only: gamma1, gamma2

            implicit none

            Integer, Parameter :: e2c_cats = 42   ! number of crop catigories

            Real, Allocatable :: Beld_ag ( :,:,: )
            Real, Allocatable :: pHs1    ( :,:,: )
            Real, Allocatable :: pHs2    ( :,:,: )
            Real, Allocatable :: NH4ps1  ( :,:,: ) ! Initial Soil NH4
            Real, Allocatable :: NH4ps2  ( :,:,: ) ! Initial Soil NH4

            Real, Allocatable :: Nit1    ( :,:,: ) ! Epic Nitrification layer 1
            Real, Allocatable :: Nit2    ( :,:,: ) ! Epic Nitrification layer 2
            Real, Allocatable :: L1_ON   ( :,:,: ) ! Epic Layer 1 organic N
            Real, Allocatable :: L2_ON   ( :,:,: ) ! Epic Layer 2 organic N

            Real, Allocatable :: GMN     ( :,:,: ) ! Epic Layer 1 and 2 N mineralized in Fest-C 1.4

            Real, Allocatable :: BDc1    ( :,:,: ) ! crop soil bulk density kg/ha
            Real, Allocatable :: BDc2    ( :,:,: ) ! crop soil bulk density kg/ha   

            Real, Allocatable :: F1_NH4  ( :,:,: ) ! fertlizer application to layer 1 
            Real, Allocatable :: F2_NH4  ( :,:,: ) ! fertlizer application to layer 2

            Real, Allocatable :: L1_ON_Yest ( :,:,: ) ! Epic Layer 1 organic N
            Real, Allocatable :: L2_ON_Yest ( :,:,: ) ! Epic Layer 2 organic N
            Real, Allocatable :: F1_ON      ( :,:,: ) ! Epic Layer 1 organic N Fertilization 
            Real, Allocatable :: F2_ON      ( :,:,: ) ! Epic Layer 2 organic N Fertilization 

            Character( 20 )            :: Beld_Names( e2c_cats )

C Some compilers do not pad with blank characters in data initialization
C                          '12345678901234567890'
         Data Beld_Names / 'Hay                 ',  !  1
     &                     'Hay_ir              ',  !  2
     &                     'Alfalfa             ',  !  3
     &                     'Alfalfa_ir          ',  !  4
     &                     'Other_Grass         ',  !  5
     &                     'Other_Grass_ir      ',  !  6
     &                     'Barley              ',  !  7
     &                     'Barley_ir           ',  !  8
     &                     'BeansEdible         ',  !  9
     &                     'BeansEdible_ir      ',  ! 10
     &                     'CornGrain           ',  ! 11
     &                     'CornGrain_ir        ',  ! 12
     &                     'CornSilage          ',  ! 13
     &                     'CornSilage_ir       ',  ! 14
     &                     'Cotton              ',  ! 15
     &                     'Cotton_ir           ',  ! 16
     &                     'Oats                ',  ! 17
     &                     'Oats_ir             ',  ! 18
     &                     'Peanuts             ',  ! 19
     &                     'Peanuts_ir          ',  ! 20
     &                     'Potatoes            ',  ! 21
     &                     'Potatoes_ir         ',  ! 22
     &                     'Rice                ',  ! 23
     &                     'Rice_ir             ',  ! 24
     &                     'Rye                 ',  ! 25
     &                     'Rye_ir              ',  ! 26
     &                     'SorghumGrain        ',  ! 27
     &                     'SorghumGrain_ir     ',  ! 28
     &                     'SorghumSilage       ',  ! 29
     &                     'SorghumSilage_ir    ',  ! 30
     &                     'Soybeans            ',  ! 31
     &                     'Soybeans_ir         ',  ! 32
     &                     'Wheat_Spring        ',  ! 33
     &                     'Wheat_Spring_ir     ',  ! 34
     &                     'Wheat_Winter        ',  ! 35
     &                     'Wheat_Winter_ir     ',  ! 36
     &                     'Other_Crop          ',  ! 37
     &                     'Other_Crop_ir       ',  ! 38
     &                     'Canola              ',  ! 39
     &                     'Canola_ir           ',  ! 40
     &                     'Beans               ',  ! 41
     &                     'Beans_ir            ' / ! 42

          end module depv_data_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module aeromet_data

C Some parameters and meteorological variables required in aerosol
C processing.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SH  03/10/11 renamed file and module from MET_DATA to AEROMET_DATA
C----------------------------------------------------------------------

      Implicit None

C Concentration lower limit used for gas species
      Real,      Parameter :: min_gasconc = 1.0E-30        ! [ ug/m^3 ]

C Meteorological variables 
      Real :: airtemp      ! air temp [ K ] :from MET_CRO_3D File
      Real :: srftemp      ! 2-meter temp [ K ] :from MET_CRO_2D File
      Real :: airpres      ! air pressure [ Pa]
      Real :: airdens      ! air density [ kg/m^3]
      Real :: airRH        ! fractional relative humidity
      Real :: airQV        ! water vapor mass mixing ratio [ kg_H2O/kg_air ]
      Real :: H2OsatVP     ! saturation water vapor pressure [ Pa ]
      Real :: H2OVP        ! ambient water vapor pressure [ Pa ]

      End Module aeromet_data

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_global_min_module.f,v 1.2 2006/02/15 14:41:56 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   use F90 interface feature to achieve "faked" polymorphism for global min
C   determining routine
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Parameter List:
C
C   In: var -- distributed variable which needs be determined the min value
C              among all processors
C
C Local Variable:
C
C   min   -- minimum value among all processors
C   error -- error code of mpi call
C
C Include Files:
C
C   mpif.h
C -----------------------------------------------------------------------------

        module se_global_min_module

        use se_pe_info_ext

        implicit none

        interface se_global_min
          module procedure se_global_imin, se_global_rmin
        end interface

        contains

C -----------------------------------------------------------------------------
        function se_global_imin (var) result (se_global_imin_result)

        implicit none

        integer :: se_global_imin_result
        integer, intent(in) :: var

        include "mpif.h"

        integer min
        integer error

        call mpi_reduce (var, min, 1, mpi_integer, MPI_MIN, 0, 
     &                   se_worker_comm, error)

        call mpi_bcast (min, 1, mpi_integer, 0, se_worker_comm, error)

        se_global_imin_result = min

        return
        end function se_global_imin

C -----------------------------------------------------------------------------
        function se_global_rmin (var) result (se_global_rmin_result)

        implicit none

        real :: se_global_rmin_result
        real, intent(in) :: var

        include "mpif.h"

        real min
        integer error

        call mpi_reduce (var, min, 1, mpi_real, MPI_MIN, 0, 
     &                   se_worker_comm, error)

        call mpi_bcast (min, 1, mpi_real, 0, se_worker_comm, error)

        se_global_rmin_result = min

        return
        end function se_global_rmin

        end module se_global_min_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/beis3.f,v 1.2 2011/10/21 16:10:17 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE BEIS( JDATE, JTIME, NX, NY, MSPCS, SEMIS, BIPOL )

C-----------------------------------------------------------------------
C Description:
 
C   Uses PAR and sfc temperature data to calculate
C   biogenic ISOP and MBO emissions.  Other emissions are
C   calculated using the temperature data only.
 
C Preconditions:
C   PAR and Surface Temperature
 
C Subroutines and Functions Called:
 
C Revision History:
C   4/01 : Prototype by JMV
C   6/05 : updates for BEIS3.3 by D. Schwede (BEIS3.13)
C   8/05 : additional diagnostic messages for PAR out of bounds (G. Pouliot)
C  10/06 : yoj
C   1/10 : yoj remove ck & report if TAIR > 315
C   7/14 : JOB added leaf temperature and two layer canopy model
C  11/07 : JOB updated for ASX_DATA_MOD and corrected the Cl algorithm 
C          to be consitent with Gunther et al. 1999 doi:10.1029/1999JD900391
C  5/7/18: D. Schwede Removed call to CZANGLE. COSZEN now calculated in ASX_DATA_MOD
C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling
C              System
C File: @(#)$Id: beis3.f,v 1.2 2011/10/21 16:10:17 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/beis3.f,v $
C Last updated: $Date: 2011/10/21 16:10:17 $
C-----------------------------------------------------------------------

      USE BEIS_DEFN, ONLY: NSEF, NLAI, LAITYPES
      Use ASX_DATA_MOD

      IMPLICIT NONE
C Includes:

C Arguments:
      INTEGER, INTENT( IN ) :: JDATE   ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME   ! current simulation time (HHMMSS)
      INTEGER, INTENT( IN ) :: NX      ! no. columns
      INTEGER, INTENT( IN ) :: NY      ! no. rows
      INTEGER, INTENT( IN ) :: MSPCS   ! no. of output species

      REAL,    INTENT( IN ) :: SEMIS ( :,:,: ) ! normalized emissions
      REAL,    INTENT( OUT ) :: BIPOL( :,:,: ) ! output emissions

C Local Variables:
      INTEGER        R, C, L, I   ! counters

      REAL           CFOTHR       ! isop corr fac -- non-forest
      REAL           CFCLAI       ! isop corr fac -- LAI
      REAL           CFNO         ! NO correction factor
      REAL           CFOVOC       ! non-isop corr fac
      REAL           CFSESQT      ! sesquiterpene corr fac
      REAL           PAR          ! photo. actinic flux (UE/M**2-S) (UE=micro-einsteins)
      REAL           CT_SUN       ! temperature correction
      REAL           DT_SUN       ! temperature correction
      REAL           CT_SHADE     ! temperature correction       
      REAL           DT_SHADE     ! temperature correction      
      REAL           TAIR         ! local 2 meter temperature
      REAL           DTLEAF_SUN   ! Difference between mean canopy leaf and ambient temperature [K]
      REAL           DTLEAF_SHADE ! Difference between mean canopy leaf and ambient temperature [K]      
      REAL           TLEAF_SUN    ! Mean canopy leaf temperature [K]
      REAL           TLEAF_SHADE  ! Mean canopy leaf temperature [K]
      REAL           RBW          ! Quasi-laminar boundary layer resistance for water vapor [s/m]
      REAL           RBH          ! Quasi-laminar boundary layer resistance for heat [s/m]     
      REAL           RH           ! Relative humidity [ratio 0-1]
      REAL           ES           ! Saturation vapor pressure for 2 meter T  [Pa]          
      REAL           SHF          ! Soil heat flux [W/m**2]    
      REAL           DVAP         ! vapor pressure deficit [Pa/Pa]  
      REAL           SSVP         ! Slope of the saturation vapor pressure curve over P [1/K] 
      REAL           GVAP         ! canopy water vapor conuctance m/s
      REAL           GHT          ! canopy heat conductance m/s      
      REAL           CPAIR        ! specific heat of air
      REAL           LHV          ! Latent heat of vaporization       
      REAL           CPOT         ! potential temperature conversion 
      REAL           DENS         ! Dry air density kg/m**3
      REAL           LHSH_DIV     ! W/m**2 to K units conversion 
      REAL           LHSH_COMP    ! latent/sensible heat flux component of leaf energy bal
      REAL           RK           ! k from Geron and Guenther
      REAL           CSUBL_SUN    ! C sub l
      REAL           CSUBL_SHADE  ! C sub l
      REAL           FRACSUN      ! Fraction sun
      REAL           FRACSHADE    ! Fraction shade            
      REAL           TLAI         ! local LAI
      REAL           SOLRAD       ! local solar radiation [W/m**2]
      REAL           PSFC         ! local sfc pressure (mb)
      REAL           ZEN          ! zenith angle
      REAL           PARDB        ! PAR direct beam
      REAL           PARDIF       ! PAR diffuse
      REAL           COSZ         ! local cosine of zenith angle
      
      REAL, PARAMETER :: CV     = 8.0e-6  ! Resistance to soil heat conductance under vegetation [s/m]
      REAL, PARAMETER :: RRAD   = 230.0   ! Atmospheric radiative resistance Monteith 1973 [s/m]
      REAL, PARAMETER :: SCW    = KVIS / DWAT ! schmidt number for water vapor
      REAL, PARAMETER :: REFLDV = 0.057 ! visible light reflection coefficient from MEGAN 2.10 

      CHARACTER( 5 )   :: BTMP    ! temporary variable name
      CHARACTER( 256 ) :: MESG    ! message buffer

      CHARACTER( 16 )  :: PROCNAME = 'BEIS'   ! procedure name

C-----------------------------------------------------------------------
      
C Loop through cells
      DO R = 1, NY
         DO C = 1, NX

            TAIR = MET_DATA%TEMP2( C,R )         ! unit in degree K
            COSZ = MET_DATA%COSZEN( C,R )            

C Check min bounds for temperature
C Note we no longer cap temperature for isoprene
            IF ( TAIR .LT. 200.0 ) THEN
               WRITE( MESG, 94010 ) 'TAIR=', TAIR,
     &              'out of range at (C,R)=', C, R
               CALL M3EXIT( PROCNAME, JDATE, JTIME, MESG, 2 )
            END IF

            SOLRAD = MET_DATA%RGRND( C,R )

C Cosine of zenith angle to zenith angle (radians)
            ZEN =  ACOS( COSZ )
            PSFC = MET_DATA%PRSFC( C,R )
    
C atmospheric water vapor variables used for leaf latent heat flux
            IF ( TAIR .LE. STDTEMP ) THEN
               ES = VP0 * EXP( 22.514 - (6.15e3 / TAIR) )
            ELSE
               ES = VP0 * EXP( SVP2 * (TAIR - STDTEMP) /
     &                                (TAIR - SVP3) )
            END IF
            RH   = MET_DATA%RH2( C,R ) / 100.0
            DVAP = ES*(1.0-RH)/PSFC
            SSVP = (SVP2*(STDTEMP-SVP3)*ES/(TAIR-SVP3)**2)/
     &              PSFC

C calculate the soil heaf flux under a canopy folowing WRF3.4.1 PX
            SHF = -2.0*PI/SIDAY*(MET_DATA%TEMPG( C,R ) - TAIR)/CV

C calculate the heat and water vapor quasilaminar boundary layer resistance
            RBH = 5.0/MET_DATA%USTAR( C,R )
            RBW = RBH*(SCW/PR)**TWOTHIRDS
   
C calculate the specific heat of air and latent heat of vaporization
            CPAIR = CPD * (1.0 + 0.84 * MET_DATA%Q2( C,R ))
            LHV   = LV0 - 2370.0 * (TAIR - STDTEMP)

C calculate the leaf  water vapor and heat conductance 
            GHT  = 1 / (MET_DATA%RA( C,R ) + RBH  ) + 1/RRAD
            GVAP = 1 / (MET_DATA%RA( C,R ) + RBW + MET_DATA%RS( C,R ) * MET_DATA%LAI( C,R ))

C Calculate the potential temperature conversion from the sensible heat flux in WRF 3.4.1
            CPOT = (STDATMPA/PSFC)**(RDGAS/CPAIR)

C Calculate the solar radiation and soil heat flux of the leaf energy budget
            DENS     =  PSFC /( RDGAS * TAIR )
            LHSH_DIV =  DENS * CPOT * CPAIR * (GHT + 1 / (MET_DATA%RA( C,R ) + RBH  )) + 
     &                  DENS * LHV * SSVP * GVAP

C calculate the latent heat flux portion of the leaf energy budget 
            LHSH_COMP = SHF - LHV * DENS * GVAP * ( ES - RH * ES) / PSFC

C Direct and diffuse photosynthetically active radiation
            CALL GETPARB( SOLRAD, PSFC, COSZ, PARDB, PARDIF )

            PAR = PARDB + PARDIF

C Check max/min bounds of PAR and calculate biogenic ISOP
            IF ( PAR .LT. 0.0 .OR. PAR .GT. 2600.0 ) THEN
               
               WRITE( MESG, 94030 ) 'PAR=', PAR,
     &              'out of range at (C,R)=', C, R,
     &              'PARDB  = ', PARDB,
     &              'PARDIF = ', PARDIF,
     &              'SOLRAD = ', SOLRAD,
     &              'PSFC   = ', PSFC,
     &              'ZEN    = ', ZEN
    
                CALL M3MSG2( MESG )
            END IF
            TLAI = MET_DATA%LAI( C,R )
C Compute ISOP and MBO and METH emissions first
C Note assumption that these are the first 3 species in LAITYPE and BIOTYPE
C arrays
            DO I = 1, NLAI

               BTMP = LAITYPES( I )
C Adjust methanol based on T. Pierce recommendation (1-16-03)
               IF ( BTMP == 'METH' ) THEN
                  TLAI = MAX( 3.0, TLAI )
               END IF

               IF ( TLAI .GT. 10.0 ) THEN
                  WRITE( MESG, 94010 ) 'LAI=', TLAI,
     &              'out of range at (C,R)=', C, R
                  CALL M3EXIT( PROCNAME, JDATE, JTIME, MESG, 2 )
               END IF

C Initialize csubl
               CSUBL_SUN   = 0.0
               CSUBL_SHADE = 0.0       

               IF ( PARDB + PARDIF .EQ. 0.0 ) THEN
                  BIPOL( C,R,I ) = 0.0
               ELSE
                  CALL CLNEW_SUB( ZEN, PARDB, PARDIF, TLAI, LHSH_DIV,
     &                            LHSH_COMP, DTLEAF_SUN, DTLEAF_SHADE, 
     &                            CSUBL_SUN, CSUBL_SHADE, FRACSUN, FRACSHADE,
     &                            SOLRAD, REFLDV )

                  TLEAF_SUN   = DTLEAF_SUN   + TAIR
                  TLEAF_SHADE = DTLEAF_SHADE + TAIR
C Calculate temperature correction term
                  DT_SUN   = 28668.514 / TLEAF_SUN
                  DT_SHADE = 28668.514 / TLEAF_SHADE 
                  CT_SUN   = EXP( 37.711 - 0.398570815 * DT_SUN ) /
     &                          ( 1.0 + EXP( 91.301 - DT_SUN ) )
                  CT_SHADE = EXP( 37.711 - 0.398570815 * DT_SHADE ) /
     &                          ( 1.0 + EXP( 91.301 - DT_SHADE ) )     
                  BIPOL( C,R,I ) = SEMIS( C,R,I )*( FRACSUN   * CT_SUN   * CSUBL_SUN + 
     &                                              FRACSHADE * CT_SHADE * CSUBL_SHADE )
               END IF

            END DO ! end ISOP and MBO calculations loop
C Only estimate BCOV emissions for vegitation
            IF( TLAI .GT. 0.0 ) THEN

               CALL CLNEW_SUB( ZEN, PARDB, PARDIF, TLAI, LHSH_DIV,
     &                         LHSH_COMP, DTLEAF_SUN, DTLEAF_SHADE, 
     &                         CSUBL_SUN, CSUBL_SHADE, FRACSUN, FRACSHADE,
     &                         SOLRAD, REFLDV )
     
               TLEAF_SUN   = TAIR + DTLEAF_SUN
               TLEAF_SHADE = TAIR + DTLEAF_SHADE
C Calculate other biogenic emissions except NO
C Note not speciated here
C Limit temerature to 315 K for monoterpenes and other VOCs
               TLEAF_SUN   = MIN( TLEAF_SUN, 315.0 )
               TLEAF_SHADE = MIN( TLEAF_SHADE, 315.0 )    

               CFOVOC  = FRACSUN   * EXP( 0.09 * ( TLEAF_SUN   - 303.0 ) ) + 
     &                   FRACSHADE * EXP( 0.09 * ( TLEAF_SHADE - 303.0 ) ) 
               CFSESQT = FRACSUN   * EXP( 0.17 * ( TLEAF_SUN   - 303.0 ) ) + 
     &                   FRACSHADE * EXP( 0.17 * ( TLEAF_SHADE - 303.0 ) )
            ELSE
C If LAI = 0 zero out emission factors
               CFOVOC  = 0.0
               CFSESQT = 0.0
            END IF

            DO I = NLAI + 1, NSEF - 2
               BIPOL( C,R,I ) = SEMIS( C,R,I ) * CFOVOC
            END DO

            I = NSEF - 1
            BIPOL( C,R,I ) = SEMIS( C,R,I ) * CFSESQT

         END DO ! end loop over columns
      END DO ! end loop over rows

      RETURN

C-----------------------------------------------------------------------

94010 FORMAT( 1X, A, F10.2, 1X, A, I3, ',', I3 )
94020 FORMAT( 1X, A, F10.2, 1X, A, I3, ',', I3, A )
94030 FORMAT( 1X, A, F10.2, 1X, A, I3, ',', I3, 1X, 5(A, F10.2) )

C-----------------------------------------------------------------------
      CONTAINS

C Function to calculate csubl based on zenith angle, par, and lai
         SUBROUTINE CLNEW_SUB( ZEN, PARDB, PARDIF, TLAI, LHSH_DIV,
     &                              LHSH_COMP, DTLSUN, DTLSHADE, 
     &                              CSUBL_SUN, CSUBL_SHADE, FRACSUN, FRACSHADE,
     &                              SOLRAD, REFLDV )

         IMPLICIT NONE

C Function arguments:
         REAL, INTENT( IN )  :: PARDB    ! direct beam PAR( umol/m2-s)
         REAL, INTENT( IN )  :: PARDIF   ! diffuse PAR ( umol/m2-s)
         REAL, INTENT( IN )  :: ZEN      ! solar zenith angle (radians)
         REAL, INTENT( IN )  :: TLAI     ! leaf area index for grid cell
         REAL, INTENT( IN )  :: LHSH_DIV  
         REAL, INTENT( IN )  :: LHSH_COMP
         REAL, INTENT( IN )  :: SOLRAD
         REAL, INTENT( IN )  :: REFLDV
         REAL, INTENT( OUT ) :: CSUBL_SUN
         REAL, INTENT( OUT ) :: CSUBL_SHADE
         REAL, INTENT( OUT ) :: DTLSUN           ! Sun leaf temperature [K]
         REAL, INTENT( OUT ) :: DTLSHADE         ! Sun leaf temperature [K]
         REAL, INTENT( OUT ) :: FRACSUN          ! fraction of leaves that are sunlit
         REAL, INTENT( OUT ) :: FRACSHADE        ! fraction of leaves that are shaded

C Parameters:
         REAL, PARAMETER :: ALPHA = 0.8 ! leaf absorptivity
         REAL, PARAMETER :: KD = 0.68   ! extinction coefficient for diffuse radiation
         
         
C Local variables:
         REAL, SAVE :: SQALPHA ! square root of alpha
         REAL KBE              ! extinction coefficient for direct beam
         REAL CANPARSCAT       ! exponentially wtd scattered PAR (umol/m2-s)
         REAL CANPARDIF_SUN    ! exponentially wtd diffuse PAR at the top of the canopy (umol/m2-s)
         REAL CANPARDIF_SHADE  ! exponentially wtd diffuse PAR in the shaded part of the canopy (umol/m2-s)
         REAL PARSHADE         ! PAR on shaded leaves (umol/m2-s)
         REAL PARSUN           ! PAR on sunlit leaves (umol/m2-s)
         REAL SOLSUN           ! RS transmitted to sunlit leaves W/m**2
         REAL SOLSHADE         ! RS transmitted to shaded leaves W/m**2
         REAL LAISUN           ! LAI that is sunlit
         REAL LAISHADE         ! LAI that is shaded


         LOGICAL, SAVE :: FIRSTIME = .TRUE.

C-----------------------------------------------------------------------
         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            SQALPHA = SQRT( ALPHA )
         END IF
C CN98 - eqn 15.4, assume x=1 (can use a table or atributes to change this)
C Set a ceiling for KBE to prevent a blow up at high zenith angles. This has
C little impact on the results because direct PAR is low under these conditions
         IF( ZEN .GE. 1.57 ) THEN
            KBE = 627.9
         ELSE
            KBE = 0.5 * SQRT( 1.0 + TAN( ZEN )**2 )
         END IF
         IF ( TLAI .GT. 0.1 ) THEN
            IF ( PARDB + PARDIF .GT. 0.0 ) THEN

C CN98 p-259 Sun and shaded areas of the canopy
               LAISUN     = ( 1.0 - EXP( -1.0 * KBE * TLAI ) ) / KBE
               LAISHADE   = MAX( TLAI - LAISUN, 0.0 )
               FRACSUN    = LAISUN / TLAI             
               FRACSHADE  = 1.0 - FRACSUN

C CN98 - p. 261 (this is usually small)
               CANPARSCAT = 0.5 * PARDB * ( EXP( -1.0 * SQALPHA * KBE * TLAI )
     &                    - EXP( -1.0 * KBE * TLAI ) )

C CN98 - p. 261 (assume exponentially wtd avg)
               CANPARDIF_SUN    = PARDIF * ( 1.0 - EXP( -1.0 * SQALPHA * KD * LAISUN ) )
     &                                   / ( SQALPHA * KD * LAISUN )

               CANPARDIF_SHADE  = CANPARDIF_SUN * ( EXP( -1.0 * SQALPHA * KD * LAISUN ) 
     &                                            - EXP( -1.0 * SQALPHA * KD * TLAI ) )
     &                                   / ( SQALPHA * KD * (TLAI - LAISUN) )

C CN98 - p. 261 (for next 3 eqns)
C note that we use the incoming (not absorbed) PAR
               PARSHADE   = CANPARDIF_SHADE + CANPARSCAT
               PARSUN     = KBE * PARDB + CANPARDIF_SUN + CANPARSCAT
     
C calculate the leaf temperature following Campbel and Norman 1998 eq 14.6 
C with the addition of incomming atmospheric long wave irradiation resulting 
C in the cacelation of the long wave radiation budget
         
               SOLSUN    = SOLRAD * PARSUN / ( PARSUN + PARSHADE )
               SOLSHADE  = SOLRAD * PARSHADE / ( PARSUN + PARSHADE )
               DTLSUN    = ((1.0 - REFLDV) * SOLSUN + LHSH_COMP ) / LHSH_DIV
               DTLSHADE  = ((1.0 - REFLDV) * SOLSHADE + LHSH_COMP ) / LHSH_DIV
               DTLSUN    = MIN(DTLSUN,  10.0) 
               DTLSUN    = MAX(DTLSUN, -10.0) 
               DTLSHADE  = MIN(DTLSHADE,  10.0) 
               DTLSHADE  = MAX(DTLSHADE, -10.0) 

C cguen is Guenther's eqn for computing light correction as a function of
C PAR...fracSun should probably be higher since sunlit leaves tend to be
C thicker than shaded leaves. But since we need to make crude assumptions
C regarding leaf orientation (x=1), we will not attempt to fix at the moment.

               CSUBL_SUN   = CGUEN( PARDB + PARDIF, 0.0, LAISUN, KBE )
C By definition diffusive radiation, use the diffusive attenuation coefficient and 
C Diffusive par at the bottom of the sunlit layer
               CSUBL_SHADE = CGUEN( CANPARDIF_SUN, LAISUN, TLAI, KD )
            
            ELSE ! to prevent divide by 0 when there is no solar rad
               CSUBL_SUN   = 0.0
               CSUBL_SHADE = 0.0
               FRACSUN     = 0.2
               FRACSHADE   = 0.8
               DTLSUN      = LHSH_COMP / LHSH_DIV
               DTLSHADE    = LHSH_COMP / LHSH_DIV
               DTLSUN      = MIN(DTLSUN,  10.0) 
               DTLSUN      = MAX(DTLSUN, -10.0) 
               DTLSHADE    = MIN(DTLSHADE,  10.0) 
               DTLSHADE    = MAX(DTLSHADE, -10.0) 
            END IF       
    
         ELSE 
            CSUBL_SUN   = CGUEN( PARDB + PARDIF, 0.0, TLAI, KBE )
            CSUBL_SHADE = 0.0
            FRACSUN     = 1.0
            FRACSHADE   = 0.0
            DTLSUN      = ((1.0 - REFLDV) * SOLRAD + LHSH_COMP ) / LHSH_DIV
            DTLSHADE    = 0.0
            DTLSUN      = MIN(DTLSUN,  10.0) 
            DTLSUN      = MAX(DTLSUN, -10.0)      
         END IF

         END SUBROUTINE CLNEW_SUB

C-----------------------------------------------------------------------

C Function to calculate Guenther's equation for computing light correction
         REAL FUNCTION CGUEN( PAR, LAI1, LAI2, KBE )

C 11/14 J. Bash - Updated to Niinemets et al. 2010a doi:10.1029/2010JG001436 
C                 Big leaf model which updates Guenther et al. 1993 doi:10.1029/93JD00527 for 
C                 in-canopy gradients

         IMPLICIT NONE

C Function arguments:
         REAL, INTENT( IN ) :: PAR
         REAL, INTENT( IN ) :: LAI1 ! top of the layer LAI
         REAL, INTENT( IN ) :: LAI2 ! bottom of the layer LAI
         REAL, INTENT( IN ) :: KBE  ! light extenction coefficient

C Parameters: updated to Niinemets et al. 2010b https://doi.org/10.5194/bg-7-1809-2010 to be 
C consistent with Niinemets et al. 2010a
         REAL, PARAMETER :: ALPHA = 0.0015 ! Mean of reported Quercus rubra and Liquidambar styraciflua
         REAL, PARAMETER :: CL    = 1.2716 ! Calculated according Niinemets et al. 2010b to return 1 at
                                           ! standard conditions ( PAR=1000, KBE = 0.68 )

C-----------------------------------------------------------------------
         IF ( PAR .LE. 0.01 ) THEN
            CGUEN = 0.0
         ELSE
C Niinemets et al. 2010 equation A9 integrated from LAI1 to LAI2
            CGUEN = CL * ( SQRT(1+ALPHA**2 * PAR**2 * EXP(-2*LAI1*KBE)) -
     &                     SQRT(1+ALPHA**2 * PAR**2 * EXP(-2*LAI2*KBE)) ) /
     &                   ( ALPHA * KBE * PAR )
         END IF

         RETURN

         END FUNCTION CGUEN

C-----------------------------------------------------------------------

      END SUBROUTINE BEIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       MODULE VERTEXT_MODULE

         USE STD_CONC, ONLY: N_C_GC_SPC, C_GC_SPC, N_C_AE_SPC, C_AE_SPC,  
     &                       N_C_NR_SPC, C_NR_SPC, N_C_TR_SPC, C_TR_SPC,
     &                       N_CSPCS, L_CONC_RH, L_CONC_TA,
     &                       L_CONC_PRES

         INTEGER              :: NVERTEXT
         INTEGER, ALLOCATABLE :: VERTEXTJ(:), VERTEXTI(:), VERT_SEQ(:)
 
         INTEGER                      :: NVERTEXT_SPCS = 0
         CHARACTER( 16 ), ALLOCATABLE :: VERTEXT_SPCS( : )

! for parallel implementation
         INTEGER              :: MY_NVERTEXT
         INTEGER, ALLOCATABLE :: MY_VERTEXTJ(:), MY_VERTEXTI(:), PE_NVERTEXT(:,:)

#ifndef mpas
         PRIVATE :: PWRVEC
#endif

         CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE OPVEXT ( JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Create the IO/API netCDF header and open the output VEXT file

C Revision history:
C   24 Nov 17 B.Henderson: copied from OPCONC.
C   09 Jan 18 D.Wong: put in parallel implementation
C   01 Feb 19 D.Wong: removed USE ALLOC_DATA_MODULE clause
C   09 Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL
C-----------------------------------------------------------------------

         USE GRID_CONF
         USE RUNTIME_VARS, ONLY: LOGDEV, LVEXT, N_CONC_VARS, W_VEL
         USE UTILIO_DEFN
#ifndef mpas
#ifdef parallel
         USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
         USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif
         USE MIO_ASCII

         IMPLICIT NONE
C        INTERFACE
C            SUBROUTINE GET_LONLAT(NVERT, VERTLAT, VERTLON)
C             REAL, ALLOCATABLE, INTENT(INOUT) :: VERTLAT(:), VERTLON(:)
C             INTEGER, INTENT(INOUT) :: NVERT
C            END SUBROUTINE GET_LONLAT
C        END INTERFACE

         INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

         INTEGER, INTENT(IN) :: JDATE        ! starting date (YYYYDDD)
         INTEGER, INTENT(IN) :: JTIME        ! starting time (HHMMSS)
         INTEGER, INTENT(IN) :: TSTEP        ! output timestep (HHMMSS)

C Local Variables:

         CHARACTER( 16 ) :: PNAME = 'OPVEXT'
         CHARACTER( 96 ) :: XMSG = ' '
         CHARACTER( 28 ) :: SSTR = ' species saved to VEXTfile:'

C environment variable for no. of layers from bottom to save on VEXT file
         CHARACTER( 16 ) :: NLAYS_VEXT = 'NLAYS_VEXT'

C  environment variable description
         CHARACTER( 80 ) :: VARDESC

         INTEGER :: K, KD, L, SPC, V, VAR   ! loop counters
         INTEGER :: STRT, FINI         ! loop counters
         INTEGER :: STATUS
         INTEGER :: GDTYP2 = 1
         REAL, ALLOCATABLE  :: VERTEXTLAT(:), VERTEXTLON(:)
         REAL, ALLOCATABLE :: VERTEXTJR(:), VERTEXTIR(:)

         LOGICAL, EXTERNAL :: FLUSH3
         CHARACTER( 16 ) :: DOVERTNAME = 'DOVERTEXT'
         CHARACTER( 16 ) :: VERTEXTLATNAME = 'VERTEXTLAT'
         CHARACTER( 16 ) :: VERTEXTLONNAME = 'VERTEXTLON'

         INTEGER :: PE
         LOGICAL :: FOUND, PRJSET

         CHARACTER (30) :: MYFMT

C-----------------------------------------------------------------------

#ifndef mpas
         IF (.not. LVEXT) RETURN
         CALL GET_LONLAT(NVERTEXT, VERTEXTLON, VERTEXTLAT)

         ALLOCATE ( 
     &              VERTEXTJR(NVERTEXT), 
     &              VERTEXTIR(NVERTEXT), 
     &              VERTEXTJ(NVERTEXT), 
     &              VERTEXTI(NVERTEXT), 
     &              MY_VERTEXTJ(NVERTEXT), 
     &              MY_VERTEXTI(NVERTEXT), 
     &              PE_NVERTEXT(0:NVERTEXT, 0:NPCOL*NPROW-1), 
     &              VERT_SEQ(NVERTEXT), 
     &              STAT = STATUS)

         WRITE(LOGDEV, *)'IN', NVERTEXT

C Set output file characteristics from GRID_CONF and open 

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME + TSTEP
         TSTEP3D = TSTEP
         NVARS3D = N_CONC_VARS
         NCOLS3D = 1
         NROWS3D = NVERTEXT
         NLAYS3D = NLAYS
         NTHIK3D = 1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD 
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
         DO L = 1, NLAYS + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         FDESC3D( 1 ) = 'Concentration file output'
         FDESC3D( 2 ) = 'From CMAQ model dyn alloc version CTM'
         FDESC3D( 3 ) = 'Set of variables (possibly) reduced from CGRID'
         FDESC3D( 4 ) = 'For next scenario continuation runs,'
         FDESC3D( 5 ) = 'use the "one-step" CGRID file'
         KD = 5
         L = 0
         DO K = KD + 1, MIN ( NLAYS + KD, MXDESC3 )
            L = L + 1
            WRITE( FDESC3D( K ),'( "Layer", I3, " to", I3, " " )' )
     &      L - 1, L
         END DO
!        IF ( ( KD + 1 + L ) .LT. MXDESC3 ) THEN
!           DO K = KD + 1 + L, MXDESC3
!              FDESC3D( K ) = ' '
!           END DO
!        END IF
         WRITE (MYFMT, '(a10, i3, a6)') '(A16, 1X, ', NVERTEXT, 'f12.6)'
         WRITE (FDESC3D(KD + 2 + L), MYFMT) 'Latitude  list: ', VERTEXTLAT(1:NVERTEXT)
         WRITE (FDESC3D(KD + 3 + L), MYFMT) 'Longitude list: ', VERTEXTLON(1:NVERTEXT)
         CALL LONLAT2XY(NVERTEXT, VERTEXTLON, VERTEXTLAT,
     &                  VERTEXTIR, VERTEXTJR)
         WRITE (MYFMT, '(a10, i3, a6)') '(A16, 1X, ', NVERTEXT, 'f12.6)'
         WRITE (FDESC3D(KD + 4 + L), myfmt) 'Y list: ', VERTEXTJR(1:NVERTEXT)
         WRITE (FDESC3D(KD + 5 + L), myfmt) 'X list: ', VERTEXTIR(1:NVERTEXT)
         
         
         STATUS = 0
         MY_NVERTEXT = 0
         PE_NVERTEXT = 0
         VERT_SEQ = -1
         DO V = 1, NVERTEXT
            VERTEXTI(V) = INT((VERTEXTIR(V) - XORIG3D) / XCELL3D) + 1
            VERTEXTJ(V) = INT((VERTEXTJR(V) - YORIG3D) / YCELL3D) + 1
            IF ((VERTEXTI(V) .gt. GL_NCOLS) .or. (VERTEXTI(V) .lt. 1) .or.
     &          (VERTEXTJ(V) .gt. GL_NROWS) .or. (VERTEXTJ(V) .lt. 1)) THEN
               STATUS = STATUS + 1
               WRITE( LOGDEV, '( /5X, A, F10.4, F10.4, A, I8, I8)' )
     &              'Outside domain', VERTEXTLON(V), VERTEXTLAT(V),
     &              'COL/ROW', VERTEXTI(V), VERTEXTJ(V)
            ELSE 
               FOUND = .FALSE.
               PE = 0
               DO WHILE (.NOT. FOUND)
                  PE = PE + 1
                  IF ((VERTEXTI(V) .GE. COLSX_PE(1, PE)) .and. 
     &                (VERTEXTI(V) .LE. COLSX_PE(2, PE)) .and.
     &                (VERTEXTJ(V) .GE. ROWSX_PE(1, PE)) .and.
     &                (VERTEXTJ(V) .LE. ROWSX_PE(2, PE))) THEN
                      VERT_SEQ(V) = PE - 1
                      PE_NVERTEXT(0, PE-1) = PE_NVERTEXT(0, PE-1) + 1
                      K = PE_NVERTEXT(0, PE-1)
                      PE_NVERTEXT(K, PE-1) = V
                      FOUND = .TRUE.
                  END IF
               END DO
               IF (MYPE .EQ. VERT_SEQ(V)) THEN 
                  MY_NVERTEXT = MY_NVERTEXT + 1
                  MY_VERTEXTI(MY_NVERTEXT) = VERTEXTI(V) - COLSX_PE(1, MYPE+1) + 1
                  MY_VERTEXTJ(MY_NVERTEXT) = VERTEXTJ(V) - ROWSX_PE(1, MYPE+1) + 1

                  WRITE(LOGDEV, *)'IN', VERTEXTLON(V), VERTEXTLAT(V)
                  WRITE(LOGDEV, *) 'OUT', VERTEXTI(V), VERTEXTJ(V)
               END IF
            ENDIF
         END DO

         WRITE (MYFMT, '(a10, i3, a6)') '(A16, 1X, ', NVERTEXT, 'I6)'
         WRITE (FDESC3D(KD + 6 + L), MYFMT) 'J list: ', VERTEXTJ(1:NVERTEXT)
         WRITE (FDESC3D(KD + 7 + L), MYFMT) 'I list: ', VERTEXTI(1:NVERTEXT)
         WRITE( LOGDEV,* ) ' '
         WRITE( LOGDEV,* ) '      VEXT  File Header Description:'
         DO K = 1, KD + L
            WRITE( LOGDEV,* ) '    => ', TRIM( FDESC3D( K ) )
         END DO

         V = 0
         STRT = 1
         FINI = N_C_GC_SPC
         DO SPC = STRT, FINI
            V = V + 1
            VTYPE3D( SPC ) = M3REAL
            VNAME3D( SPC ) = C_GC_SPC( V )
            UNITS3D( SPC ) = 'ppmV'
            VDESC3D( SPC ) = 'Variable ' // VNAME3D( SPC )
         END DO

         V = 0
         STRT = FINI + 1
         FINI = FINI + N_C_AE_SPC
         DO SPC = STRT, FINI
            V = V + 1
            VTYPE3D( SPC ) = M3REAL
            VNAME3D( SPC ) = C_AE_SPC( V )
            IF ( VNAME3D( SPC )(1:3) .EQ. 'NUM' ) THEN
               UNITS3D( SPC ) = 'm-3'
            ELSE IF ( VNAME3D( SPC )(1:3) .EQ. 'SRF' ) THEN
               UNITS3D( SPC ) = 'm2 m-3'
            ELSE
               UNITS3D( SPC ) = 'ug m-3'
            END IF
            VDESC3D( SPC ) = 'Variable ' // VNAME3D( SPC )
         END DO

         V = 0
         STRT = FINI + 1
         FINI = FINI + N_C_NR_SPC
         DO SPC = STRT, FINI
            V = V + 1
            VTYPE3D( SPC ) = M3REAL
            VNAME3D( SPC ) = C_NR_SPC( V )
            UNITS3D( SPC ) = 'ppmV'
            VDESC3D( SPC ) = 'Variable ' // VNAME3D( SPC )
         END DO

         V = 0
         STRT = FINI + 1
         FINI = FINI + N_C_TR_SPC ! write all TR species
         DO SPC = STRT, FINI
            V = V + 1
            VTYPE3D( SPC ) = M3REAL
            VNAME3D( SPC ) = C_TR_SPC( V )
            UNITS3D( SPC ) = 'ppmV'
            VDESC3D( SPC ) = 'Molar Mixing Ratio for species ' // VNAME3D( SPC )
         END DO
 
         VAR = FINI
         IF ( W_VEL ) THEN   ! for W_YAMO
            VAR = VAR + 1
            VTYPE3D( VAR ) = M3REAL
            VNAME3D( VAR ) = 'W_VEL'
            UNITS3D( VAR ) = 'm s-1'
            VDESC3D( VAR ) = 'Derived vertical velocity component'
         END IF
      
         IF ( L_CONC_RH ) THEN   ! for Relative Humidity
            VAR = VAR + 1 
            VTYPE3D( VAR ) = M3REAL
            VNAME3D( VAR ) = 'RH'
            UNITS3D( VAR ) = '1'
            VDESC3D( VAR ) = 'Fractional Relative Humidity'
         END IF
       
         IF ( L_CONC_TA ) THEN   ! for Temperature
            VAR = VAR + 1 
            VTYPE3D( VAR ) = M3REAL
            VNAME3D( VAR ) = 'TA'
            UNITS3D( VAR ) = 'K'
            VDESC3D( VAR ) = 'Air Temperature'
         END IF
       
         IF ( L_CONC_PRES ) THEN   ! for Pressure
            VAR = VAR + 1 
            VTYPE3D( VAR ) = M3REAL
            VNAME3D( VAR ) = 'PRES'
            UNITS3D( VAR ) = 'Pa'
            VDESC3D( VAR ) = 'Air Pressure'
         END IF
 
         NVERTEXT_SPCS = NVARS3D
         ALLOCATE( VERTEXT_SPCS( NVERTEXT_SPCS ), STAT = STATUS )
         VERTEXT_SPCS( 1:NVERTEXT_SPCS ) = VNAME3D( 1:NVERTEXT_SPCS ) 

         ! Store MIO Metadata
         NDIMS3D( 1:NVARS3D ) = 3
         L_TSTEP( 1:NVARS3D ) = .True.
         L_LAY  ( 1:NVARS3D ) = .True.
         L_COL  ( 1:NVARS3D ) = .False.
         L_ROW  ( 1:NVARS3D ) = .False.
         L_VEXT ( 1:NVARS3D ) = .True.

         CALL LOAD_MIO_FILE ( 'CTM_VEXT_1', NLAYS3D, 1, NLAYS3D,
     &        VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &        VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &        L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &        L_VEXT(1:NVARS3D) )


C create header

         IF ( IO_PE_INCLUSIVE ) THEN   ! open new

            IF ( .NOT. OPEN3( CTM_VEXT_1, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not open ' // CTM_VEXT_1
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            IF ( .NOT. FLUSH3 ( CTM_VEXT_1 ) ) THEN
               XMSG = 'Could not sync to disk ' // CTM_VEXT_1
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         END IF

         DEALLOCATE(VERTEXTLAT, VERTEXTLON, VERTEXTJR, VERTEXTIR)
#endif

         END SUBROUTINE OPVEXT

#ifndef mpas
#ifdef parallel
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         LOGICAL FUNCTION PWRVEC( FILNAME, VARNAME, DATE, TIME,
     &                            BUFFER, NLAYS,
     &                            NCOLS, NROWS, NP, 
     &                            NVERTEXT, VERTEXTII, VERTEXTJI)
C.....................................................................
  
C  PURPOSE:   Perform Models-3 file-write operation in a parallel
C             environment for a vector. Values of variable VARNAME on each processor
C             subdomain region are collected, via MPI calls, by the
C             primary I/O processor and the full grid of values are
C             written to file.

C  RETURN VALUE:  The function fails if M3IO routine WRITE3 fails. If
C       an MPI error occurs, the program is aborted with a call to
C       PM3EXIT. 
  
C  REVISION  HISTORY:
C       Copied 11/29/2017 by Barron Henderson
C          -- Copied from PWRGRDD
C   09 Jan 18 D.Wong: put in parallel implementation
  
C  ARGUMENT LIST DESCRIPTION:
C  M1 in PIOMAPS_MODULE
C  M2 in ALLOC_DATA_MODULE
C  E3 in PIOVARS.EXT
C  IN:
C    CHARACTER*(*)  FILNAME        ! Name of file containing variable VARNAME
C    CHARACTER*(*)  VARNAME        ! Name of file variable to write
C    INTEGER        DATE           ! Date, formatted YYYYDDD
C    INTEGER        TIME           ! Time, formatted HHMMSS
C    REAL           BUFFER(NCOLS, NROWS, NLAYS)
C                                  ! Buffer holding (local) array to be written
C    INTEGER  NLAYS                ! Layer dimension of file variables
C    INTEGER  NCOLS                ! Column dimension of local-processor arrays
C    INTEGER  NROWS                ! Row dimension of local-processor arrays
C    INTEGER  NP                   ! Number of processors
C    INTEGER  NVERTEXT             ! Number of Lat/Lon pairs
C    INTEGER  VERTEXTII            ! Vertice location
C    INTEGER  VERTEXTJI            ! Vertice location
 
C  OUT: none
 
C  LOCAL VARIABLE DESCRIPTION:  see below
 
C  CALLS: WRITE3, PM3WARN, PM3EXIT, MPI_SEND, MPI_RECV, MPI_BCAST
 
C  NOTES: (1) Only the primary I/O processor does the file writing. Input
C             arguments FILNAME, VARNAME, DATE, and TIME are meaningful
C             only to the I/O processor.
 
C         (2) This routine handles only gridded variables. The BUFFER is
C             assumed to be declared as BUFFER( NCOLS, NROWS, NLAYS ),
C             where NCOLS and NROWS are the local PE grid subdomain
C             dimensions and NLAYS is the file variable layer dimension.
C             BUFFER is assumed to be filled as BUFFER(1:C,1:R,1:NLAYS),
C             where C = WR_COLSX_PE(2,MY_PE+1), R = WR_ROWSX_PE(2,MY_PE+1).
C-----------------------------------------------------------------------

         USE PIOMAPS_MODULE
         USE M3UTILIO, ONLY : WRITE3              ! i/o api

         IMPLICIT NONE

C Include Files

         INCLUDE 'mpif.h'            ! MPI definitions and parameters
         INCLUDE 'PIOVARS.EXT'

C Arguments

         CHARACTER( * ), INTENT(IN) :: FILNAME   ! Name of file containing variable VARNAME
         CHARACTER( * ), INTENT(IN) :: VARNAME   ! Name of file variable to write
         INTEGER, INTENT(IN)        :: DATE      ! Date, formatted YYYYDDD
         INTEGER, INTENT(IN)        :: TIME      ! Time, formatted HHMMSS 
         INTEGER, INTENT(IN)        :: NLAYS     ! Layer dimension of file variables
         INTEGER, INTENT(IN)        :: NCOLS     ! Column dimension of local-processor arrays
         INTEGER, INTENT(IN)        :: NROWS     ! Row dimension of local-processor arrays
         INTEGER, INTENT(IN)        :: NP        ! Number of processors
         INTEGER, INTENT(IN)        :: NVERTEXT  ! Number of vertices
         INTEGER, INTENT(IN)        :: VERTEXTII(:),VERTEXTJI(:) ! vertex locations
         REAL, INTENT(IN)           :: BUFFER( :,:,: )           ! Buffer holding (local) array 

         REAL, ALLOCATABLE, SAVE :: WRITVBUF( :,:,: )
         REAL, ALLOCATABLE       :: RECVVBUF( :,: )
         REAL, ALLOCATABLE       :: SENDVBUF(:,:)     ! to be written

C External Functions:

         EXTERNAL PM3WARN                    ! Parallel M3IO library

C Local Variables:

         INTEGER         :: MSGSIZE   ! Message size of subgrid to receive
         INTEGER         :: IPE       ! For loop over processors
         INTEGER         :: IERROR    ! MPI error code
         LOGICAL         :: LERROR    ! LOCAL ERROR
         LOGICAL         :: RERROR    ! LOCAL MPI ALLREDUCE ERROR
         INTEGER         :: TC,TR     ! This cell position
         INTEGER         :: IG        ! Loop counter over grid layers
         CHARACTER( 16 ) :: FIL16     ! Scratch area for file-name
         CHARACTER( 16 ) :: VAR16     ! Scratch area for vble-name
         CHARACTER( 80 ) :: MSG       ! Message issued from PM3WARN routine
         INTEGER         :: STATUS( MPI_STATUS_SIZE )   ! MPI status code
         INTEGER         :: N, POS

         INTEGER, PARAMETER :: TAG1 = 901 ! MPI message tag for processor ID

C........................................................................

C Initialize return value and error code
         PWRVEC = .TRUE.
         LERROR = .FALSE.
         IERROR = 0
         
         IF ( MY_PE .EQ. IO_PE ) THEN    ! I/O processor collects and writes data

            IF (.NOT. ALLOCATED(WRITVBUF)) THEN
               ALLOCATE ( WRITVBUF  ( 1, NVERTEXT, NLAYS ), STAT = IERROR )
               IF ( IERROR .NE. 0 ) THEN
                  MSG = 'Failure allocating WRITVBUF '
                  CALL M3EXIT( 'PWRVEC', DATE, TIME, MSG, 1 )
               END IF
            END IF

C Gather the array and write it to file.

C I/O PE copies its own local array into output buffer

            DO N = 1, MY_NVERTEXT
               POS = PE_NVERTEXT(N, MY_PE)
               TC  = MY_VERTEXTI(N)
               TR  = MY_VERTEXTJ(N)

               WRITVBUF( 1, POS, : ) = BUFFER(TC, TR, :)
            END DO
 
C I/O PE receives array from all other processors and copies it to the output
C buffer. Arrays are received in a first-come-first-serve order.  

            DO IPE = 1, NP - 1

               IF (PE_NVERTEXT(0, IPE) .GT. 0) THEN
                  ALLOCATE ( RECVVBUF  ( PE_NVERTEXT(0, IPE), NLAYS ), STAT = IERROR )
                  IF ( IERROR .NE. 0 ) THEN
                     MSG = 'Failure allocating RECVVBUF '
                     CALL M3EXIT( 'PWRVEC', DATE, TIME, MSG, 1 )
                  END IF

                  MSGSIZE = PE_NVERTEXT(0, IPE) * NLAYS  

                  CALL MPI_RECV( RECVVBUF, MSGSIZE, MPI_REAL, IPE,
     &                           TAG1, MPI_COMM_WORLD, STATUS, IERROR )
                  IF ( IERROR .NE. 0 ) THEN
                     MSG = 'MPI error receiving data array RECVVBUF.'
                     CALL PM3WARN( 'PWRVEC', DATE, TIME, MSG )
                     LERROR = .TRUE.
                  END IF

                  DO N = 1, PE_NVERTEXT(0, IPE)
                     POS = PE_NVERTEXT(N, IPE)
                     TC  = MY_VERTEXTI(N)
                     TR  = MY_VERTEXTJ(N)

                     WRITVBUF( 1, POS, : ) = RECVVBUF(N,:)
                  END DO
                  DEALLOCATE (RECVVBUF)
               END IF
            END DO

C Write the accumulated array to file

            FIL16 = FILNAME
            VAR16 = VARNAME
            IF ( .NOT. WRITE3( FIL16, VAR16, DATE, TIME, WRITVBUF ) ) THEN
               MSG = 'Could not write '
     &               // TRIM( VARNAME ) //
     &               ' to file '// TRIM( FIL16 )

               CALL PM3WARN( 'PWRVEC', DATE, TIME, MSG )
               LERROR = .TRUE.
            END IF

         ELSE      ! Non-I/O processors send data

C Each processor, except for the I/O processor, sends its local array to
C the I/O processor.

            IF (MY_NVERTEXT .GT. 0) THEN
               IF (.NOT. ALLOCATED(SENDVBUF)) THEN
                  ALLOCATE ( SENDVBUF  ( MY_NVERTEXT, NLAYS   ), STAT = IERROR )
                  IF ( IERROR .NE. 0 ) THEN
                     MSG = 'Failure allocating SENDVBUF '
                     CALL M3EXIT( 'PWRVEC', DATE, TIME, MSG, 1 )
                  END IF
               END IF

               DO IG = 1, MY_NVERTEXT
                  TC = MY_VERTEXTI(IG)
                  TR = MY_VERTEXTJ(IG)

                  SENDVBUF( IG, : ) = BUFFER(TC, TR, :)
               END DO

               MSGSIZE = MY_NVERTEXT * NLAYS  

               CALL MPI_SEND( SENDVBUF, MSGSIZE, MPI_REAL, IO_PE, TAG1,
     &                        MPI_COMM_WORLD, IERROR )

               IF ( IERROR .NE. 0 ) THEN
                  MSG = 'MPI error sending data array WRITVBUF.'
                  CALL PM3WARN( 'PWRVEC', DATE, TIME, MSG )
                  LERROR = .TRUE.
               END IF
            END IF

         END IF     ! if( my_pe .eq. io_pe )

C Notify non-I/O processors of failure

         CALL MPI_ALLREDUCE( LERROR, RERROR, 1, MPI_LOGICAL, MPI_LAND, 
     &                       MPI_COMM_WORLD, IERROR )

         IF ( IERROR .NE. 0 ) THEN
            MSG = 'MPI Allreduce error.'
            CALL PM3WARN( 'PWRVEC', DATE, TIME, MSG )
            LERROR = .TRUE.
         END IF

         IF ( RERROR ) THEN
            MSG = 'Failed to write '
     &           // TRIM( VARNAME ) //
     &           ' from file '// TRIM( FILNAME )
            CALL PM3WARN( 'PWRVEC', DATE, TIME, MSG )
            PWRVEC = .FALSE.
         END IF

         END FUNCTION PWRVEC

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE WR_VEXT( CGRID, JDATE, JTIME, TSTEP )

C Revision History:
C   24 Nov 17 B.Henderson: copied from WR_CONC
C   24 Jul 18 C. Nolte: removed call to INIT_MET that was causing conflict.
C             Met should already be initialized by this point.
C   09 Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL
C-----------------------------------------------------------------------

         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE RUNTIME_VARS
         USE STD_CONC              ! standard CONC
         USE PIOMAPS_MODULE
         USE UTILIO_DEFN
         USE ASX_DATA_MOD, Only: Met_Data
         USE WVEL_DEFN, Only : WVEL

         IMPLICIT NONE

C Include Files:

         INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

         REAL,    POINTER    :: CGRID( :,:,:,: )  ! Species concentrations

         INTEGER, INTENT(IN) :: JDATE             ! current model date, coded YYYYDDD
         INTEGER, INTENT(IN) :: JTIME             ! current model time, coded HHMMSS
         INTEGER, INTENT(IN) :: TSTEP             ! output timestep (HHMMSS)

C Local variables:

         CHARACTER( 16 ) :: PNAME = 'WR_VEXT'
         CHARACTER( 96 ) :: XMSG = ' '

         REAL, ALLOCATABLE :: DBUFF ( :,: )     ! input for W_VEL
         INTEGER           :: ALLOCSTAT

         LOGICAL, SAVE :: FIRSTIME = .TRUE.

C for INTERPX

         INTEGER      :: C, R, K, L, V,GI   ! loop induction variables
         INTEGER      :: C0, CN, R0, RN
         INTEGER      :: INDX, VAR
!        CHARACTER( 16 ), ALLOCATABLE, SAVE :: VNAME( : )
!        INTEGER, SAVE :: NVARS

C-----------------------------------------------------------------------
         IF ( FIRSTIME ) THEN

            FIRSTIME = .FALSE.

C open vext file for update

            IF ( .NOT. IO_PE_INCLUSIVE ) THEN
               IF ( .NOT. OPEN3( CTM_VEXT_1, FSREAD3, PNAME ) ) THEN
                  XMSG = 'Could not open ' // CTM_VEXT_1 //
     &                    ' file for update'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
            END IF

!           IF ( .NOT. DESC3( CTM_VEXT_1 ) ) THEN
!              XMSG = 'Could not get file description from ' // CTM_VEXT_1
!              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
!           END IF
!           NVARS = NVARS3D
!           ALLOCATE ( VNAME( NVARS ), STAT=ALLOCSTAT )
!           VNAME = VNAME3D( 1:NVARS )
!           WRITE(LOGDEV, *) 'WR_VEXT:NVARS', NVARS


            IF ( .NOT. ALLOCATED( DBUFF ) ) THEN
               ALLOCATE ( DBUFF( NVERTEXT, NLAYS ), STAT = ALLOCSTAT )
               IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating DBUFF'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
            END IF

         END IF   ! firstime

         DO V = 1, N_CSPCS
            INDX = CONC_MAP( V )
            IF ( .NOT. PWRVEC(CTM_VEXT_1, CONC_FILE_SPCS( V ), JDATE, JTIME,
     &                        CGRID(:, :, :, INDX), NLAYS,
     &                        NCOLS, NROWS, NUMPROCS, 
     &                        NVERTEXT, VERTEXTI, VERTEXTJ     ) ) THEN
               XMSG = 'PWRGRDD failed writing variable '
     &              // TRIM( CONC_FILE_SPCS(V) ) //
     &              ' to file '// TRIM( CTM_VEXT_1 )
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ELSE
               XMSG = 'PWRGRDD wrote variable '
     &              // TRIM( CONC_FILE_SPCS(V) ) //
     &              ' to file '// TRIM( CTM_VEXT_1 )
               WRITE( LOGDEV, '(A)') XMSG
            END IF
         END DO
 
         IF ( W_VEL ) THEN
         IF ( .NOT. PWRVEC(CTM_VEXT_1, 'W_VEL', JDATE, JTIME,
     &                     WVEL(:, :, :), NLAYS,
     &                     NCOLS, NROWS, NUMPROCS, 
     &                     NVERTEXT, VERTEXTI, VERTEXTJ     ) ) THEN
            XMSG = 'PWRGRDD failed writing variable WVEL'
     &          // ' to file '// TRIM( CTM_VEXT_1 )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         END IF
         
         IF ( L_CONC_RH ) THEN
         IF ( .NOT. PWRVEC(CTM_VEXT_1, 'RH', JDATE, JTIME,
     &                     MET_DATA%RH(:, :, :), NLAYS,
     &                     NCOLS, NROWS, NUMPROCS, 
     &                     NVERTEXT, VERTEXTI, VERTEXTJ     ) ) THEN
            XMSG = 'PWRGRDD failed writing variable RH'
     &          // ' to file '// TRIM( CTM_VEXT_1 )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         END IF
         
 
         IF ( L_CONC_PRES ) THEN
         IF ( .NOT. PWRVEC(CTM_VEXT_1, 'PRES', JDATE, JTIME,
     &                     Met_Data%PRES(:, :, :), NLAYS,
     &                     NCOLS, NROWS, NUMPROCS, 
     &                     NVERTEXT, VERTEXTI, VERTEXTJ     ) ) THEN
            XMSG = 'PWRGRDD failed writing variable PRES'
     &          // ' to file '// TRIM( CTM_VEXT_1 )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         END IF
         
         IF ( L_CONC_TA ) THEN
         IF ( .NOT. PWRVEC(CTM_VEXT_1, 'TA', JDATE, JTIME,
     &                     Met_Data%TA(:, :, :), NLAYS,
     &                     NCOLS, NROWS, NUMPROCS, 
     &                     NVERTEXT, VERTEXTI, VERTEXTJ     ) ) THEN
            XMSG = 'PWRGRDD failed writing variable TA '
     &          // ' to file '// TRIM( CTM_VEXT_1 )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         END IF

         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &         'Timestep written to', CTM_VEXT_1,
     &         'for date and time', JDATE, JTIME

         END SUBROUTINE WR_VEXT
#endif
#endif
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE GET_LONLAT(NVERT, VERTLON, VERTLAT)
C-----------------------------------------------------------------------
C Function:
C   Get LON/LAT pairs from file
C Revision history:
C   09 Mar 18 B.Henderson: 
C-----------------------------------------------------------------------
         USE UTILIO_DEFN
         USE RUNTIME_VARS
         IMPLICIT NONE
         INTEGER :: STATUS, FUNIT, I
         INTEGER, INTENT(INOUT) :: NVERT
         REAL, ALLOCATABLE, INTENT(INOUT) :: VERTLAT(:), VERTLON(:)
        !  environment variable description
         CHARACTER( 80 ) :: VARDESC
         CHARACTER( 16 ) :: DEFTXT = ''
         CHARACTER( 16 ) :: PNAME = 'OPVEXT'
         CHARACTER( 96 ) :: XMSG = ' '

#ifndef mpas
         FUNIT = 100
! OPEN FORMATTED FILE
! EXPECTED FORMAT 
! REC1: N
! REC2-N+1: LON LAT
         OPEN(UNIT=FUNIT, FILE=VEXT_COORD_PATH, STATUS='OLD',
     &        FORM = 'FORMATTED', IOSTAT = STATUS)

         IF ( STATUS .NE. 0 ) THEN
            XMSG = TRIM(VEXT_COORD_PATH) //
     &             ' Could not be opened'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF
! READ NUMBER OF VERTICES
         READ(FUNIT, *, IOSTAT=STATUS) NVERT
         IF ( STATUS .NE. 0 ) THEN
            XMSG = TRIM(VEXT_COORD_PATH) //
     &             ' did not contain one integer on the first line'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF
! ALLOCATE OUTPUT VARIABLES
         ALLOCATE ( VERTLAT(NVERT), VERTLON(NVERT), STAT = STATUS )
! FOR EACH INPUT LINE READ LON,LAT
         DO I=1,NVERT
            READ(FUNIT, *, IOSTAT=STATUS) VERTLON(I), VERTLAT(I)
            IF ( STATUS .NE. 0 ) THEN
               WRITE(XMSG, '(I6)') I
               XMSG = TRIM(VEXT_COORD_PATH) //
     &                ' did not contain two reals on line: ' //
     &                TRIM(XMSG)
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
            END IF
         ENDDO
! CLOSE FILE
         CLOSE(FUNIT)
#endif

         END SUBROUTINE GET_LONLAT

         SUBROUTINE LONLAT2XY(NVERTEXT, VERTEXTLON, VERTEXTLAT,
     &                        VERTEXTIR, VERTEXTJR)
         USE UTILIO_DEFN
         USE GRID_CONF             ! horizontal & vertical domain specifications
         IMPLICIT NONE
         INTEGER, INTENT(in) :: NVERTEXT
         REAL, INTENT(in) :: VERTEXTLON(NVERTEXT), VERTEXTLAT(NVERTEXT)
         REAL, INTENT(inout) :: VERTEXTIR(NVERTEXT), VERTEXTJR(NVERTEXT)
         CHARACTER( 16 ) :: PNAME = 'LONLAT2XY'
         CHARACTER( 96 ) :: XMSG = ' '
         LOGICAL :: PRJSET, LSTAT
         REAL :: JR, IR
         INTEGER :: V
!         IOAPI 3.2 has an explicit function, but many users are likely
!         using 3.1, so I basically rewrote LL2XY
!         CALL XY2XY( GDTYP_GD, P_ALP_GD, P_BET_GD, P_GAM_GD, XCENT_GD, YCENT_GD,
!     &               1      ,    0.d0,    0.d0,    0.d0,    0.d0,    0.d0,
!     &               NVERTEXT, VERTEXTLON, VERTEXTLAT, VERTEXTIR, VERTEXTJR )
#ifndef mpas
         IF ( GDTYP3D .EQ. LAMGRD3 ) THEN
             PRJSET = SETLAM( REAL(P_ALP_GD), REAL(P_BET_GD), REAL(P_GAM_GD),
     &                         REAL(XCENT_GD), REAL(YCENT_GD))
             DO V=1,NVERTEXT
                 LSTAT = LL2LAM( VERTEXTLON(V), VERTEXTLAT(V), IR, JR ) 
                 VERTEXTIR(V) = IR
                 VERTEXTJR(V) = JR
             ENDDO
         ELSEIF ( GDTYP_GD .EQ. POLGRD3 ) THEN
             PRJSET = SETPOL( REAL(P_ALP_GD), REAL(P_BET_GD), REAL(P_GAM_GD),
     &                         REAL(XCENT_GD), REAL(YCENT_GD))
             DO V=1,NVERTEXT
                 LSTAT = LL2POL( VERTEXTLON(V), VERTEXTLAT(V), IR, JR ) 
                 VERTEXTIR(V) = IR
                 VERTEXTJR(V) = JR
             ENDDO
         ELSEIF ( GDTYP_GD .EQ. EQMGRD3 ) THEN
             PRJSET = SETEQM( REAL(P_ALP_GD), REAL(P_BET_GD), REAL(P_GAM_GD),
     &                         REAL(XCENT_GD), REAL(YCENT_GD))
             DO V=1,NVERTEXT
                 LSTAT = LL2EQM( VERTEXTLON(V), VERTEXTLAT(V), IR, JR ) 
                 VERTEXTIR(V) = IR
                 VERTEXTJR(V) = JR
             ENDDO
         ELSEIF ( GDTYP_GD .EQ. TRMGRD3 ) THEN
             PRJSET = SETTRM( REAL(P_ALP_GD), REAL(P_BET_GD), REAL(P_GAM_GD),
     &                         REAL(XCENT_GD), REAL(YCENT_GD))
             DO V=1,NVERTEXT
                 LSTAT =  LL2TRM( VERTEXTLON(V), VERTEXTLAT(V), IR, JR )
                 VERTEXTIR(V) = IR
                 VERTEXTJR(V) = JR
             ENDDO
         ELSEIF ( GDTYP_GD .EQ. ALBGRD3 ) THEN
             PRJSET = SETALB( REAL(P_ALP_GD), REAL(P_BET_GD), REAL(P_GAM_GD),
     &                         REAL(XCENT_GD), REAL(YCENT_GD))
             DO V=1,NVERTEXT
                 LSTAT = LL2ALB( VERTEXTLON(V), VERTEXTLAT(V), IR, JR )
                 VERTEXTIR(V) = IR
                 VERTEXTJR(V) = JR
             ENDDO
         ELSE
             XMSG = 'Unsupported coordinate system type'
             CALL M3EXIT(PNAME, 0, 0, XMSG, XSTAT2)
         END IF
#endif

         END SUBROUTINE LONLAT2XY

       END MODULE VERTEXT_MODULE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

        LOGICAL FUNCTION PWRITE3( FNAME, VNAME, JDATE, JTIME, BUFFER )

C-----------------------------------------------------------------------
C Function: Writes grided data BUFFER to the Models-3 data file with logical 
C           name FNAME by collecting from each PE.

C Return Value: TRUE iff the operation succeeds

C Preconditions: FNAME is a Models-3 data file already opened for write
C                access by OPEN3() or by CREATE3()

C Postconditions: Subsequent call to SHUT3() to flush the file to disk

C Revision History:
C   prototype 08/01 by David Wong, Lockheed Martin
C             10/01 by David Wong
C             -- expanded functionality to handle PING file
C             -- adjusted SIZE according to VID
C             -- modified the routine to accommodate writing sub-grid data
C             12/02 by David Wong
C             -- exteneded to write dot file
C             01/03 by David Wong
C             -- inserted WRTFLAG function to output time step info
C             02/04 by David Wong
C             -- collect all subdomain data and call WRITE3 once
C             02/11 by Shawn Roselle
C             -- Replaced I/O API include files with M3UTILIO; removed
C                deprecated TRIMLEN
C             08/11 by David Wong
C             -- extended to handle window met_cro_3d file
C             09/14 by David Wong
C             -- Removed redundant INCLUDE NETCDF.EXT statement
C-----------------------------------------------------------------------

      USE PIOMAPS_MODULE
      USE M3UTILIO              ! i/o api
      USE RUNTIME_VARS , ONLY : PWRTFLAG

      IMPLICIT NONE

C Includes:

      INCLUDE 'STATE3.EXT'

      INCLUDE 'PIOVARS.EXT'      ! Parameters for parallel implementation.
      INCLUDE 'PIOGRID.EXT'      ! Parallel grid dimensions.
!     INCLUDE 'PIOMAPS.EXT'      ! Parallel processor-to-subdomain maps.

      INCLUDE 'mpif.h'

C Arguments:

      CHARACTER( * ) :: FNAME       ! logical file name
      CHARACTER( * ) :: VNAME       ! logical file name
      INTEGER           JDATE       ! date, formatted YYYYDDD
      INTEGER           JTIME       ! time, formatted HHMMSS
      REAL              BUFFER( * ) ! output buffer array

C Local Variables:

      INTEGER       IDUM            ! holds return value for INIT3()
      INTEGER       FID             ! file-subscript for STATE3 arrays
      INTEGER       STEP            ! time step record number
      INTEGER       STEP2           ! 1 or 2, according to step mod 2
      INTEGER       TFLAG( 2 )      ! ( JDATE=yyyyddd, JTIME=hhmmss )
      INTEGER       IERR            ! netCDF error status return
      CHARACTER( 16 ) :: FIL16      ! scratch file-name     buffer
      CHARACTER( 16 ) :: VAR16      ! scratch variable-name buffer

C Static Variables:
      LOGICAL        FLCHANGE      ! File-changed indicator.

C File written to on previous call to pwrite3.
      CHARACTER( 16 ), SAVE :: PREVFILE = '????????????????'
      CHARACTER( 80 ) :: MSG       ! Buffer for building error messages.

      INTEGER        ERROR
      INTEGER        NVARS         ! Number of file variables to read.
      INTEGER        IV            ! Loop counter over file variables.
      INTEGER        BUFSTEP       ! Buffer stride length.
      INTEGER        BP            ! Position in buffer for specific variable.

      INTEGER        PACKAGE( 4 )  ! MPI broadcast data

      CHARACTER( 16 ) :: VNAM16    ! Scratch area for variable name.

      LOGICAL, EXTERNAL :: PWRGRDD ! Parallel write for gridded data files.

C-----------------------------------------------------------------------

C Check that Models-3 I/O has been initialized:

      PWRITE3 = .TRUE.

      IF ( .NOT. FINIT3 ) THEN
         IDUM = INIT3()
         WRITE( LOGDEV,91010 ) 'WRITE3():  I/O API not yet initialized.'
         PWRITE3 = .FALSE.
         RETURN
      END IF

C Find netCDF index for the file, and check time step availability:

      IF ( LEN( FNAME ) .GT. 16 ) THEN
         WRITE( LOGDEV,91001 )
     &       'File "', FNAME, '"',
     &       'Max file name length 16; actual:', LEN( FNAME )
         PWRITE3 = .FALSE.
         RETURN
      END IF

      IF ( LEN( VNAME ) .GT. 16 ) THEN
         WRITE( LOGDEV,91002 )
     &       'File "', FNAME, '"',
     &       'Variable "', VNAME, '"',
     &       'Max variable name length 16; actual:', LEN( VNAME )
         PWRITE3 = .FALSE.
         RETURN
      END IF

      VAR16 = VNAME   ! fixed-length-16 scratch copy of name
      FIL16 = FNAME   ! fixed-length-16 scratch copy of name
      FID   = INDEX1 ( FIL16, COUNT3, FLIST3 )

      IF ( FNAME .EQ. PREVFILE ) THEN
         FLCHANGE = .FALSE.
      ELSE
         FLCHANGE = .TRUE.
         PREVFILE = FNAME
      END IF

      IF ( MY_PE .EQ. IO_PE ) THEN
         STEP = JSTEP3 ( JDATE, JTIME, SDATE3( FID ), STIME3( FID ),
     &                   ABS( TSTEP3( FID ) ) )
      END IF

      CALL MPI_BCAST ( STEP, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, ERROR )

      IF ( STEP .LT. 0 ) THEN      
         WRITE( LOGDEV,91020 )
     &       'Time step error writing file:  ' // FIL16 ,
     &       'Requested date & time:    ', JDATE, JTIME ,
     &       'File starting date & time:',
     &       SDATE3( FID ), STIME3( FID ),
     &       'File time step:           ', TSTEP3( FID )
         PWRITE3 = .FALSE.
         RETURN
      END IF
            
      IF ( MY_PE .EQ. IO_PE ) THEN

         IF ( TSTEP3( FID ) .LT. 0 ) THEN
            STEP2 = 1 + MOD ( STEP-1, 2 )
            TFLAG( 1 ) = JDATE
            TFLAG( 2 ) = JTIME
         ELSE IF ( TSTEP3( FID ) .EQ. 0 ) THEN
            STEP2 = STEP
            TFLAG( 1 ) = 0
            TFLAG( 2 ) = 0
         ELSE
            STEP2 = STEP
            TFLAG( 1 ) = JDATE
            TFLAG( 2 ) = JTIME
         END IF

C Get file description.
         IF ( .NOT. DESC3( FNAME ) ) THEN
             MSG = 'Could not get '// TRIM( FNAME )
     &           // ' file description'
             CALL M3WARN( 'PWRITE3', JDATE, JTIME, MSG )
         END IF

      END IF

      CALL MPI_BCAST ( UPNAM3D, 16, MPI_CHARACTER, 0, MPI_COMM_WORLD, ERROR )
      CALL MPI_BCAST ( FTYPE3D, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, ERROR )

C Operation valid only for gridded files.
      IF ( FTYPE3D .EQ. GRDDED3 ) THEN

         IF ( UPNAM3D .EQ. 'PDM' .OR.
     &        UPNAM3D .EQ. 'READ_PTX2'.OR.
     &        UPNAM3D .EQ. 'FAKE_GRIDDED' ) THEN

            IF ( MY_PE .EQ. IO_PE ) THEN
               IF ( .NOT. WRITE3 ( FNAME, VNAME, JDATE, JTIME, BUFFER ) ) THEN
                  MSG = 'WRITE3 failed writing variable '
     &                // TRIM( VNAME )
     &                // ' to file '// TRIM( FNAME )
                  CALL M3WARN( 'PWRITE3', JDATE, JTIME, MSG )
                  PWRITE3 = .FALSE.
               END IF
            END IF

         ELSE
      
            IF ( MY_PE .EQ. IO_PE ) THEN
               PACKAGE( 1 ) = NCOLS3D
               PACKAGE( 2 ) = NROWS3D
               PACKAGE( 3 ) = NLAYS3D
               PACKAGE( 4 ) = NVARS3D
            END IF

            CALL MPI_BCAST ( PACKAGE, 4, MPI_INTEGER, 0, MPI_COMM_WORLD, ERROR )

            IF ( MY_PE .NE. IO_PE ) THEN
               NCOLS3D = PACKAGE( 1 )
               NROWS3D = PACKAGE( 2 )
               NLAYS3D = PACKAGE( 3 )
               NVARS3D = PACKAGE( 4 )
            END IF

            IF ( VAR16 .EQ. ALLVAR3 ) THEN
               NVARS = NVARS3D
            ELSE
               NVARS = 1
            END IF

            IF ( FLCHANGE ) THEN
               CALL GET_WRITE_MAP ( NUMPROCS, NPCOLD, NPROWD,
     &                              NCOLS3D, NROWS3D, NLAYS3D )
            END IF 

C Calculate buffer stride.
!           BUFSTEP = NUMCOLS * NUMROWS * NLAYS3D
            BUFSTEP =  WR_NCOLS_PE( MY_PE+1 ) * WR_NROWS_PE( MY_PE+1 ) * NLAYS3D

C Loop over file variables.
            DO IV = 1, NVARS

               IF ( VAR16 .EQ. ALLVAR3 ) THEN
                  VNAM16 = VNAME3D( IV )
               ELSE
                  VNAM16 = VAR16
               END IF

C Calculate buffer position.
               BP = BUFSTEP * ( IV-1 ) + 1

               IF ( .NOT. PWRGRDD( FIL16, VNAM16, JDATE, JTIME, BUFFER( BP ),
     &                             NCOLS3D, NROWS3D, NLAYS3D,
     &                             WR_NCOLS_PE( MY_PE+1 ), 
     &                             WR_NROWS_PE( MY_PE+1 ), NUMPROCS ) ) THEN
!    &                             NUMCOLS, NUMROWS, NUMPROCS ) ) THEN
                  MSG = 'PWRGRDD failed writing variable '
     &                  // TRIM( VNAM16 ) //
     &                  ' to file '// TRIM( FIL16 )
                  CALL PM3WARN( 'PWRITE3', JDATE, JTIME, MSG )
                  PWRITE3 = .FALSE.
                  RETURN
               END IF

            END DO

         END IF   ! fake-gridded

      ELSE     ! This is not a gridded file.

         MSG = 'PWRITE3 can not handle this type of data.'
         CALL PM3WARN( 'PWRITE3', JDATE, JTIME, MSG )
         PWRITE3 = .FALSE.
         RETURN

      END IF   ! gridded file

      CALL MPI_BCAST ( PWRITE3, 1, MPI_LOGICAL, 0, MPI_COMM_WORLD, ERROR )

      IF ( .NOT. PWRITE3 ) THEN            !  failure
         IF ( MY_PE .EQ. IO_PE ) THEN
            IF ( TSTEP3( FID ) .EQ. 0 ) THEN
               WRITE( LOGDEV, 92030 ) 'Error writing', VNAME, 'to', FNAME
            ELSE
               WRITE( LOGDEV, 92030 ) 
     &         'Error writing', VNAME, 'to', FNAME, 'for', JDATE, JTIME
            END IF
         END IF
         RETURN
      END IF                        !  if failure
        
      IF ( MY_PE .EQ. IO_PE ) THEN
         MXREC3( FID ) = MAX( MXREC3( FID ), ABS( STEP ) )

         IF ( PWRTFLAG ) THEN   ! log successful writes
            IF ( VAR16 .NE. ALLVAR3 ) THEN   ! single variable written
               IF ( TSTEP3( FID ) .EQ. 0 ) THEN
                  WRITE( LOGDEV,92020 ) VNAME, 'written to', FNAME
               ELSE
                  WRITE( LOGDEV, 92020 ) 
     &                   VNAME, 'written to', FNAME, 'for', JDATE, JTIME
               END IF
            ELSE            ! vid <= 0:  entire timestamp written
               IF ( TSTEP3( FID ) .EQ. 0 ) THEN
                  WRITE( LOGDEV,92010 ) 'Record written to', FNAME
               ELSE
                  WRITE( LOGDEV,92010 ) 'Timestep written to', FNAME,
     &                     'for date and time', JDATE, JTIME
               END IF
            END IF          ! if single variable write, or timestamp write
         END IF          ! if PWRTFLAG
      END IF

      RETURN

C-----------------------------------------------------------------------

C Error and warning message formats... 91xxx

91001 FORMAT ( //5X , '>>> WARNING in subroutine WRITE3 <<<',
     &          /5X , 3A, /5X , A , I5, // )
91002 FORMAT ( //5X , '>>> WARNING in subroutine WRITE3 <<<',
     &          /5X , 3A, /5X , 3A, /5X , A , I5, // )
91010 FORMAT ( //5X , '>>> WARNING in subroutine WRITE3 <<<',
     &          3 ( /5X , A , : ) , I5, // )
91020 FORMAT ( //5X , '>>> WARNING in subroutine WRITE3 <<<',
     &          /5X , A , 2 ( /5X , A , :, I9, :, ':' , I6.6 ),
     &          /5X , A , 10X, I6.6,  // )
91030 FORMAT ( //5X , '>>> WARNING in subroutine WRITE3 <<<',
     &          /5X , A , I5 , : , /5X , A )

C Log message formats... 91xxx

92010 FORMAT ( /5X, 3( A, :, 1X ), I8, ':', I6.6 )
92020 FORMAT ( /5X, 4( A, :, 1X ), I8, ':', I6.6 )
92030 FORMAT ( /5X, 5( A, :, 1X ), I8, ':', I6.6 )

        END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/plrise/smoke/delta_zs.f,v 1.2 2011/10/21 16:11:30 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE DELTA_ZS( EMLAYS, MY_NSRC, SRC_MAP, STKHT, ZF, ZSTK, DDZF )

C-----------------------------------------------------------------------
C Function: Compute ZSTK and DDZF

C Revision History:
C     20 Nov 2007 J.Young: initial implementation
C     Aug 2015 D. Wong:    Used assumed shape array declaration

C-----------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER, INTENT( IN )  :: EMLAYS
      INTEGER, INTENT( IN )  :: MY_NSRC
      INTEGER, INTENT( IN )  :: SRC_MAP( : )
      REAL,    INTENT( IN )  :: STKHT( : )
      REAL,    INTENT( IN )  :: ZF  ( :,: )
      REAL,    INTENT( OUT ) :: ZSTK( :,: )
      REAL,    INTENT( OUT ) :: DDZF( :,: )

      REAL    ZF0, ZF1
      INTEGER L, S, SRC

      DO S = 1, MY_NSRC
         SRC = SRC_MAP( S )

         ZF0 = ZF( 1,S )
         ZSTK( 1,S ) = ZF0 - STKHT( SRC )
         DDZF( 1,S ) = 1.0 / ZF0

         DO L = 2, EMLAYS
            ZF1 = ZF( L,S )
            ZSTK( L,S ) = ZF1 - STKHT( SRC )
            DDZF( L,S ) = 1.0 / ( ZF1 - ZF0 )
            ZF0 = ZF1
         END DO

      END DO

      RETURN

      END SUBROUTINE DELTA_ZS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/arc/CCTM/src/depv/m3dry/LSM_MOD.F,v 1.5 2012/01/19 14:23:58 yoj Exp $

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module LSM_Mod
       
C------------------------------------------------------------------------------
C Revision History: 
C      June 16 11  Created by J. Bash
C      April 19 12  J. Bash    Updated the LU_FAC data arrays to be a function
C                              of the annual total N deposition following 
C                              Massad et al 2010 doi:10.5194/acp-10-10359-2010
C                              The annual 2002 deposition fields from a previous bi-
C                              directional model run using values ~ 100 was used. 
C                              The model is not very sensitive to this parameter
C                              and using different annual deposition fileds would
C                              result in small changes. 
C      Sept 12 12  D. Schwede  Added NLCD40 land use classification.
C                              Also some changes made to values in tables for NLCD50.
C                              Maintain compatability with previous versions of MCIP and detect NLCD-MODIS
C                              as the same as NLCD50
C      Nov  5  12  D. Schwede  Modified albedo for NLCD pasture and grass categories so that they are more
C                              consistent with the MODIS and USGS values
C      Apr  4  13 J. Bash      Added general water, forest, shrub, grass, snow/ice, 
C                              agricultural land use classification in a land use type 
C                              to simplify how bidirectional NH3 code handles different 
C                              land use data sets. 
C      Aug  22 14 J. Bash      Moved all the data to defined data types for easier updates and data access. 
C      Feb. 2019  D. Wong      Implemented centralized I/O approach
C      25 Jul 19 D.Wong        Based on logical variable WRF_V4P defined in RUNTIME_VARS to handle
C                              various number of soil type from different WRF version
C References:
C Noilhan, J., Planton, S., A Simple Parameterization of Land Surface Processes for Meteorological Models
C         Monthly Weather Review, 117(3), 536-549, https://doi.org/10.1175/1520-0493(1989)117%3C0536:ASPOLS%3E2.0.CO;2
C         1989
C Jacquemin, B., Noilhan, J., Sensitivity study and validation of a land surface parameterization using the HAPEX-MOBILHY 
C         data set, Boundary-Layer Meteorology, 52, 93-234, https://doi.org/10.1007/BF00123180, 1990
C Campbell, G.S., Norman, J.M., An Introduction to Environmental Biophysics, Springer, New York, NY, 286 pages, 
C         ISBN: 978-1-4612-1626-1 
C------------------------------------------------------------------------------
       
      Implicit None
      
      INTEGER, PARAMETER :: N_SOIL_TYPE_WRFV4P = 16
      INTEGER, PARAMETER :: N_SOIL_TYPE_WRFV3  = 11
      INTEGER :: N_SOIL_TYPE

      REAL, ALLOCATABLE          :: wwlt_px (:)    ! Soil volumetric wilting point (m3/m3)
      REAL, ALLOCATABLE          :: wsat_px (:)    ! Soil volumetric saturation (m3/m3)
      REAL, ALLOCATABLE          :: bslp_px (:)    ! Slope of the soil water retention curve on a loglog scale 
      REAL, ALLOCATABLE          :: wres_px (:)    ! Soil volumetric residual moisture (m3/m3) 
      REAL, ALLOCATABLE          :: wfc_px  (:)    ! Soil volumetric field capacity (m3/m3) 
      REAL, ALLOCATABLE          :: rhob_px (:)    ! Soil bulk density (kg/L)
      REAL, ALLOCATABLE          :: psi_sat (:)    ! Soil matric potential at saturation (kPa)
      REAL,   SAVE               :: wwlt_clm (19)  ! Soil volumetric wilting point (m3/m3)
      REAL,   SAVE               :: wsat_clm (19)  ! Soil volumetric saturation (m3/m3)
      REAL,   SAVE               :: bslp_clm (19)  ! Slope of the soil water retention curve on a loglog scale 
      REAL,   SAVE               :: wres_clm (19)  ! Soil volumetric residual moisture (m3/m3) 
      REAL,   SAVE               :: wfc_clm  (19)  ! Soil volumetric field capacity (m3/m3) 
      REAL,   SAVE               :: rhob_clm (19)  ! Soil bulk density (kg/L)
      REAL,   SAVE               :: wwlt_noah (19) ! Soil volumetric wilting point (m3/m3)
      REAL,   SAVE               :: wsat_noah (19) ! Soil volumetric saturation (m3/m3)
      REAL,   SAVE               :: bslp_noah (19) ! Slope of the soil water retention curve on a loglog scale 
      REAL,   SAVE               :: wres_noah (19) ! Soil volumetric residual moisture (m3/m3) 
      REAL,   SAVE               :: wfc_noah  (19) ! Soil volumetric field capacity (m3/m3) 
      REAL,   SAVE               :: rhob_noah (19) ! Soil bulk density (kg/L)
      INTEGER, SAVE              :: n_lufrac
      CHARACTER( 80 ), SAVE      :: LAND_SCHEME

      INTEGER, SAVE               :: n_xref_lu
      INTEGER, SAVE               :: n_stage_lu
      INTEGER, PRIVATE, PARAMETER :: N_Map_Max = 200
      INTEGER, PRIVATE            :: ALLOCSTAT
      
      TYPE DEP_MOD_LU_DATA
         Character( 16 ) :: LU_Name
         CHARACTER( 16 ) :: lu_cat
         Real            :: RSMIN           ! Minimum stomatal resistance (s/m)
         Real            :: Z00             ! Momentum roughness length (cm)
         Real            :: VEG0            ! Maximum vegetation fraction (%)
         Real            :: VEGMN0          ! Minimum vegetation fraction (%)
         Real            :: LAI0            ! Maximum single sided LAI (m2/m2)
         Real            :: LAIMN0          ! Minimum single sided LAI (m2/m2)
         Real            :: Gamma_NH3_grnd  ! Under canopy NH3 emission potential ([mol NH4+]/[mol H+])
         Real            :: Gamma_NH3_st    ! Vegetation NH3 emission potential ([mol NH4+]/[mol H+])
         Real            :: Hg_grnd         ! Soil Hg concentration (umol/g)
         Real            :: l_width         ! leaf width (m)
         Real            :: Alpha           ! Zhang et al. 2003/Emerson et al. 2020 empirical land use parameter (unitless)
         Real            :: BAI             ! Building area index (m2/m2)
         Real            :: Ahair           ! Leaf hair width (m)
         Real            :: Fhair           ! Leaf hair fraction (ratio)
         Real            :: Aleaf           ! Leaf aerodynamic width (m)
         Integer         :: LU_Index
      END TYPE
      TYPE( DEP_MOD_LU_DATA ) STAGE_LU_DATA( N_Map_Max )

      TYPE MET_MOD_LU_DATA
         Character(20) :: Met_LU_Name
         Integer       :: Met_Index
         Character(20) :: Dep_LU_Name
         Integer       :: Dep_Index
         Real          :: Factor
         Character(30) :: Description
      END TYPE
      TYPE( MET_MOD_LU_DATA ) MET_TO_STAGE_LU( N_Map_Max )

C-------------------------------------------------------------------------------
C Soil Characteristics by Type from WRF 3.8.1 PX
C
C   #  SOIL TYPE  WSAT  WFC  WWLT  BSLP  CGSAT   JP   AS   C2R  C1SAT  WRES
C   _  _________  ____  ___  ____  ____  _____   ___  ___  ___  _____  ____
C   1  SAND       .395 .135  .068  4.05  3.222    4  .387  3.9  .082   .020
C   2  LOAMY SAND .410 .150  .075  4.38  3.057    4  .404  3.7  .098   .035
C   3  SANDY LOAM .435 .195  .114  4.90  3.560    4  .219  1.8  .132   .041
C   4  SILT LOAM  .485 .255  .179  5.30  4.418    6  .105  0.8  .153   .015
C   5  LOAM       .451 .240  .155  5.39  4.111    6  .148  0.8  .191   .027
C   6  SND CLY LM .420 .255  .175  7.12  3.670    6  .135  0.8  .213   .068
C   7  SLT CLY LM .477 .322  .218  7.75  3.593    8  .127  0.4  .385   .040
C   8  CLAY LOAM  .476 .325  .250  8.52  3.995   10  .084  0.6  .227   .075
C   9  SANDY CLAY .426 .310  .219 10.40  3.058    8  .139  0.3  .421   .109
C  10  SILTY CLAY .482 .370  .283 10.40  3.729   10  .075  0.3  .375   .056
C  11  CLAY       .482 .367  .286 11.40  3.600   12  .083  0.3  .342   .090
C
C-------------------------------------------------------------------------------

!-- WSAT is saturated soil moisture (M^3/M^3) (JN90)
      REAL, PARAMETER :: WSAT_PX_WRFV3(N_SOIL_TYPE_WRFV3) =  
     &      (/ 0.395, 0.410, 0.435, 0.485, 0.451, 0.420, 0.477,
     &         0.476, 0.426, 0.482, 0.482 /)
!-- WWLT is wilting point (M^3/M^3) (JN90)
      REAL, PARAMETER :: WWLT_PX_WRFV3(N_SOIL_TYPE_WRFV3) =
     &      (/ 0.068, 0.075, 0.114, 0.179, 0.155, 0.175, 0.218,
     &         0.250, 0.219, 0.283, 0.286 /)
!-- B is slope of the retention curve (NP89)
      REAL, PARAMETER :: BSLP_PX_WRFV3(N_SOIL_TYPE_WRFV3) =
     &      (/  4.05,  4.38,  4.90,  5.30,  5.39,  7.12,  7.75,
     &          8.52, 10.40, 10.40, 11.40 /)
! -- RHOB is the soil bulk density 
      REAL, PARAMETER :: RHOB_PX_WRFV3(N_SOIL_TYPE_WRFV3) =
     &      (/ 1.59e6, 1.55e6, 1.53e6, 1.53e6, 1.55e6, 1.62e6, 1.67e6,
     &         1.66e6, 1.83e6, 1.78e6, 1.83e6 /)

C-------------------------------------------------------------------------------
C Soil Characteristics by Type for WRF4+ PX
C
C   #  SOIL TYPE  WSAT  WFC  WWLT  BSLP  CGSAT   JP   AS   C2R  C1SAT  WRES
C   _  _________  ____  ___  ____  ____  _____   ___  ___  ___  _____  ____
C   1  SAND       .395 .135  .068  4.05  3.222    4  .387  3.9  .082   .020
C   2  LOAMY SAND .410 .150  .075  4.38  3.057    4  .404  3.7  .098   .035
C   3  SANDY LOAM .435 .195  .114  4.90  3.560    4  .219  1.8  .132   .041
C   4  SILT LOAM  .485 .255  .179  5.30  4.418    6  .105  0.8  .153   .015
C   5  SILT       .480 .260  .150  5.30  4.418    6  .105  0.8  .153   .020
C   6  LOAM       .451 .240  .155  5.39  4.111    6  .148  0.8  .191   .027
C   7  SND CLY LM .420 .255  .175  7.12  3.670    6  .135  0.8  .213   .068
C   8  SLT CLY LM .477 .322  .218  7.75  3.593    8  .127  0.4  .385   .040
C   9  CLAY LOAM  .476 .325  .250  8.52  3.995   10  .084  0.6  .227   .075
C  10  SANDY CLAY .426 .310  .219 10.40  3.058    8  .139  0.3  .421   .109
C  11  SILTY CLAY .482 .370  .283 10.40  3.729   10  .075  0.3  .375   .056
C  12  CLAY       .482 .367  .286 11.40  3.600   12  .083  0.3  .342   .090
C  13  ORGANICMAT .451 .240  .155  5.39  4.111    6  .148  0.8  .191   .027
C  14  WATER      .482 .367  .286 11.40  3.600   12  .083  0.3  .342   .090
C  15  BEDROCK    .482 .367  .286 11.40  3.600   12  .083  0.3  .342   .090
C  16  OTHER      .420 .255  .175  7.12  3.670    6  .135  0.8  .213   .068
C-------------------------------------------------------------------------------

!-- WSAT is saturated soil moisture (M^3/M^3) (JN90)
      REAL, PARAMETER :: WSAT_PX_WRFV4P(N_SOIL_TYPE_WRFV4P) =  
     &      (/  0.395, 0.410, 0.435, 0.485, 0.480, 0.451, 0.420, 0.477,
     &          0.476, 0.426, 0.482, 0.482, 0.451, 0.482, 0.482, 0.420 /)
!-- WWLT is wilting point (M^3/M^3) (JN90)
      REAL, PARAMETER :: WWLT_PX_WRFV4P(N_SOIL_TYPE_WRFV4P) =  
     &      (/  0.068, 0.075, 0.114, 0.179, 0.150, 0.155, 0.175, 0.218,
     &          0.250, 0.219, 0.283, 0.286, 0.155, 0.286, 0.286, 0.175 /)
!-- B is slop of the retention curve (NP89)
      REAL, PARAMETER :: BSLP_PX_WRFV4P(N_SOIL_TYPE_WRFV4P) =  
     &      (/  4.05,  4.38,  4.90,  5.30,  5.30,  5.39,  7.12,  7.75,
     &          8.52, 10.40, 10.40, 11.40,  5.39, 11.40, 11.40,  7.12 /)
! -- RHOB is the soil bulk density 
      REAL, PARAMETER :: RHOB_PX_WRFV4P(N_SOIL_TYPE_WRFV4P) =  
     &      (/  1.59e6, 1.55e6, 1.53e6, 1.53e6, 1.53e6, 1.55e6, 1.62e6, 1.67e6,
     &          1.66e6, 1.83e6, 1.78e6, 1.83e6, 1.62e6, 1.83e6, 1.83e6, 1.67e6 /)

C-------------------------------------------------------------------------------
C Soil hydrolic properties as calculated from soil sand and clay fractions 
C in WRF-CLM in WRF 3.7.1-3.8.1. 
C WRES is calculated as WSAT*(psi_air_dry/psi_sat)^(-1.0/BSLP) following CLM soil hydraulic 
C relationships. Note that this is a common paramterization, e.g. Campbell and Norman (1998)
C    where psi_air_dry = -300,000 kPa
C
C   #  SOIL TYPE  WSAT  WFC  WWLT  BSLP  CGSAT   JP   AS   C2R  C1SAT  WRES
C   _  _________  ____  ___  ____  ____  _____   ___  ___  ___  _____  ____
C   1  SAND       .373 .135  .029  3.30  3.222    4  .387  3.9  .082   .016
C   2  LOAMY SAND .388 .156  .042  3.65  3.057    4  .404  3.7  .098   .025
C   3  SANDY LOAM .406 .192  .071  4.47  3.560    4  .219  1.8  .132   .049
C   4  SILT LOAM  .464 .269  .138  5.40  4.418    6  .105  0.8  .153   .108
C   5  SILT       .483 .250  .096  3.87                                .075
C   6  LOAM       .435 .248  .127  5.80  4.111    6  .148  0.8  .191   .096
C   7  SND CLY LM .413 .249  .143  7.16  3.670    6  .135  0.8  .213   .109
C   8  SLT CLY LM .476 .331  .225  8.25  3.593    8  .127  0.4  .385   .185
C   9  CLAY LOAM  .449 .299  .195  8.19  3.995   10  .084  0.6  .227   .157
C  10  SANDY CLAY .425 .288  .195  9.38  3.058    8  .139  0.3  .421   .156
C  11  SILTY CLAY .481 .360  .270 10.46  3.729   10  .075  0.3  .375   .227
C  12  CLAY       .461 .351  .270 12.14  3.600   12  .083  0.3  .342   .227
C  13  ORGANIC    .439 .241  .115  5.29                                .086
C  14  WATER      .489 .229  .066  3.10  1.0      0  .0    0.0  .0     .052
C  15  BEDROCK    .363 .114  .017  2.80                                .008
C  16  OTHER      .421 .200  .073  4.27  3.222    4  .387  3.9  .082   .051
C  17  PLAYA      .468 .353  .296 11.53                                .227 
C  18  LAVA       .363 .114  .017  2.80                                .001
C  19  WHITE SAND .373 .135  .029  3.30                                .016
C-------------------------------------------------------------------------------
!-- WSAT is saturated soil moisture (M^3/M^3)
      DATA WSAT_CLM  /  0.373, 0.388, 0.406, 0.464, 0.483, 0.435, 0.413, 0.476,
     &                  0.449, 0.425, 0.481, 0.461, 0.439, 0.489, 0.363, 0.421, 
     &                  0.468, 0.363, 0.373 /
!-- WFC is soil field capacity      
      DATA WFC_CLM   /  0.135, 0.156, 0.192, 0.269, 0.250, 0.248, 0.249, 0.331,
     &                  0.299, 0.288, 0.360, 0.351, 0.241, 0.229, 0.114, 0.200,
     &                  0.353, 0.114, 0.135 /
!-- WWLT is wilting point (M^3/M^3)
      DATA WWLT_CLM  /  0.029, 0.042, 0.071, 0.138, 0.096, 0.127, 0.143, 0.225,
     &                  0.195, 0.195, 0.270, 0.270, 0.115, 0.066, 0.017, 0.073,
     &                  0.269, 0.017, 0.029 /
!-- B is slope of the retention curve
      DATA BSLP_CLM  /  3.30,  3.65,  4.47,  5.40,  3.87, 5.80,  7.16,  8.25,
     &                  8.19,  9.38, 10.46, 12.14,  5.29, 3.10,  2.80,  4.27,
     &                 11.53,  2.80,  3.30 /
!-- WRES is residual soil moisture
      DATA WRES_CLM  /  0.016, 0.025, 0.049, 0.108, 0.075, 0.096, 0.109, 0.185,
     &                  0.157, 0.156, 0.227, 0.227, 0.086, 0.052, 0.008, 0.051,
     &                  0.227, 0.008, 0.016 /
! -- RHOB is the soil bulk density
      DATA RHOB_CLM  /  1.69e6, 1.65e6, 1.60e6, 1.45e6, 1.40e6, 1.53e6, 1.58e6, 1.41e6,
     &                  1.49e6, 1.55e6, 1.40e6, 1.45e6, 1.51e6, 1.38e6, 1.72e6, 1.56e6,
     &                  1.44e6, 1.72e6, 1.69e6 /


C-------------------------------------------------------------------------------
C Soil hydraulic properties updated (Patrick Campbell & Jesse Bash,Dec 2016) using obs/models in Kishne et al. (2017):
C "Evaluation and improvement of the default soil hydraulic parameters for the Noah Land Surface Model"
C The updated variables should match with representative run/SOILPARM.TBL for WRF NOAH, such that -->
C WSAT_NOAH = MAXSMC, WFC_NOAH = REFSMC, WWLT_NOAH = WLTSMC, and BSLP_NOAH = BB  
C Note:  Categories of Organic material, Water, Bedrock, Other (land-ice), Playa, and White sand 
C are not updated because no soil characterization data or insufficient number of samples are available. 
C WRES is calculated as (psi_air_dry/psi_sat)^(-1.0/BSLP)*WSAT following CLM soil hydrology 
C relationships, but with updated NOAH values. Note that this is a common paramterization, e.g. Campbell and Norman (1998)
C    where psi_air_dry = -300,000 kPa
C   #  SOIL TYPE  WSAT  WFC  WWLT  BSLP  CGSAT   JP   AS   C2R  C1SAT  WRES
C   _  _________  ____  ___  ____  ____  _____   ___  ___  ___  _____  ____
C   1  SAND       .402 .086  .024  3.36  3.222    4  .387  3.9  .082   .004
C   2  LOAMY SAND .396 .142  .057  4.06  3.057    4  .404  3.7  .098   .010
C   3  SANDY LOAM .413 .213  .081  4.85  3.560    4  .219  1.8  .132   .016
C   4  SILT LOAM  .456 .303  .123  5.72  4.418    6  .105  0.8  .153   .023
C   5  SILT       .438 .346  .064  4.18                                .010
C   6  LOAM       .440 .274  .128  6.01  4.111    6  .148  0.8  .191   .022
C   7  SND CLY LM .416 .288  .168  7.03  3.670    6  .135  0.8  .213   .029
C   8  SLT CLY LM .457 .350  .212  8.49  3.593    8  .127  0.4  .385   .039
C   9  CLAY LOAM  .449 .335  .196  8.20  3.995   10  .084  0.6  .227   .036
C  10  SANDY CLAY .425 .355  .239  8.98  3.058    8  .139  0.3  .421   .037
C  11  SILTY CLAY .467 .392  .264 10.24  3.729   10  .075  0.3  .375   .052
C  12  CLAY       .506 .428  .285 11.56  3.600   12  .083  0.3  .342   .058
C  13  ORGANIC    .439 .286  .118  5.25                                .003
C  14  WATER      .489 .229  .066  3.10  1.0      0  .0    0.0  .0     .052
C  15  BEDROCK    .200 .050  .009  2.79                                .001
C  16  OTHER      .421 .145  .049  4.26  3.222    4  .387  3.9  .082   .010
C  17  PLAYA      .468 .395  .264 11.55                                .147 
C  18  LAVA       .200 .050  .009  2.79                                .001
C  19  WHITE SAND .339 .084  .015  2.79                                .001
C-------------------------------------------------------------------------------
!-- WSAT is saturated soil moisture (M^3/M^3)
      DATA WSAT_NOAH /  0.402, 0.396, 0.413, 0.456, 0.438, 0.440, 0.416, 0.457, 
     &                  0.449, 0.425, 0.467, 0.506, 0.439, 0.489, 0.200, 0.421,
     &                  0.468, 0.200, 0.339 /
!-- WFC is soil field capacity      
      DATA WFC_NOAH  /  0.086, 0.142, 0.213, 0.303, 0.346, 0.274, 0.288, 0.350,
     &                  0.335, 0.355, 0.392, 0.428, 0.286, 0.229, 0.050, 0.145, 
     &                  0.395, 0.050, 0.084 /
!-- WWLT is wilting point (M^3/M^3)
      DATA WWLT_NOAH /  0.024, 0.057, 0.081, 0.123, 0.064, 0.128, 0.168, 0.212, 
     &                  0.196, 0.239, 0.264, 0.285, 0.118, 0.066, 0.009, 0.049,
     &                  0.264, 0.009, 0.015 /
!-- B is slope of the retention curve
      DATA BSLP_NOAH /   3.36,  4.06,  4.85,  5.72,  4.18,  6.01,  7.03,  8.49,
     &                   8.20, 8.98, 10.24, 11.56,  5.25,  3.10,  2.79,  4.26,
     &                  11.55,  2.79,  2.79 /
!-- WRES is residual soil moisture
      DATA WRES_NOAH /  0.004, 0.010, 0.016, 0.023, 0.010, 0.022, 0.029, 0.039,
     &                  0.036, 0.037, 0.052, 0.058, 0.003, 0.052, 0.001, 0.010,
     &                  0.147, 0.001, 0.001 / 
! -- RHOB is the soil bulk density
      DATA RHOB_NOAH /  1.69e6, 1.65e6, 1.60e6, 1.45e6, 1.40e6, 1.53e6, 1.58e6, 1.41e6,
     &                  1.49e6, 1.55e6, 1.40e6, 1.45e6, 1.51e6, 1.38e6, 1.72e6, 1.56e6,
     &                  1.44e6, 1.72e6, 1.69e6 /

      CONTAINS                                 
         SUBROUTINE INIT_LSM( JDate, JTime )   
                                               
         USE HGRD_DEFN                         
         USE UTILIO_DEFN                       
         USE RUNTIME_VARS, ONLY : WRF_V4P
#ifdef twoway                                  
         USE twoway_data_module, ONLY : num_land_cat
#endif                                         
                                               
         IMPLICIT NONE                         
                                               
         INCLUDE SUBST_FILES_ID  ! file name parameters         
                                               
         INTEGER, INTENT( In )  :: jdate       
         INTEGER, INTENT( In )  :: jtime  
         CHARACTER( 240 )       :: XMSG = ' '  
         CHARACTER(  16 ), SAVE :: PNAME = 'Init_LSM'
         INTEGER l                             
         INTEGER :: STAT

         LOGICAL, SAVE :: INITIALIZED = .FALSE.

         IF( INITIALIZED ) RETURN
         INITIALIZED = .TRUE.

         IF (WRF_V4P) THEN
            N_SOIL_TYPE = N_SOIL_TYPE_WRFV4P
         ELSE
            N_SOIL_TYPE = N_SOIL_TYPE_WRFV3
         END IF

         ALLOCATE (WSAT_PX(N_SOIL_TYPE),
     &             WFC_PX(N_SOIL_TYPE),
     &             WWLT_PX(N_SOIL_TYPE),
     &             BSLP_PX(N_SOIL_TYPE),
     &             WRES_PX(N_SOIL_TYPE),
     &             RHOB_PX(N_SOIL_TYPE),
     &             PSI_SAT(N_SOIL_TYPE),
     &             STAT=STAT)

         IF (WRF_V4P) THEN
            WSAT_PX = WSAT_PX_WRFV4P
            WWLT_PX = WWLT_PX_WRFV4P
            BSLP_PX = BSLP_PX_WRFV4P
            RHOB_PX = RHOB_PX_WRFV4P
         ELSE
            WSAT_PX = WSAT_PX_WRFV3
            WWLT_PX = WWLT_PX_WRFV3
            BSLP_PX = BSLP_PX_WRFV3
            RHOB_PX = RHOB_PX_WRFV3
         END IF

#ifdef twoway                                  
         IF ( NUM_LAND_CAT .EQ. 24 ) THEN      
            LAND_SCHEME = 'USGS24'             
         ELSE IF ( NUM_LAND_CAT .EQ. 20 ) THEN 
            LAND_SCHEME = 'MODIS'              
         ELSE IF ( NUM_LAND_CAT .EQ. 50 ) THEN 
            LAND_SCHEME = 'NLCD50'         
         ELSE IF ( NUM_LAND_CAT .EQ. 40 ) THEN 
            LAND_SCHEME = 'NLCD40'         
         END IF                                
#endif                                         
         Call STAGE_LU_MAPPER                           
                                               
         END SUBROUTINE Init_LSM               
         
         SUBROUTINE STAGE_LU_MAPPER
            
            USE RUNTIME_VARS, ONLY: STAGECTRL, LOGDEV
            use UTILIO_DEFN
      
            IMPLICIT NONE

            Logical            :: n_stage_end
            Logical            :: n_xref_end
            CHARACTER( 200 )   :: XMSG
            INTEGER            :: DEPCTRL_NML
            INTEGER            :: LU_NML
            INTEGER            :: STAT
       
            NAMELIST / STAGE_LU         / STAGE_LU_DATA
            NAMELIST / STAGE_MODIS_20   / MET_TO_STAGE_LU
            NAMELIST / STAGE_NLCD_40    / MET_TO_STAGE_LU
            NAMELIST / STAGE_NLCD_50    / MET_TO_STAGE_LU
            NAMELIST / STAGE_USGS_24    / MET_TO_STAGE_LU
            NAMELIST / STAGE_CUSTOM     / MET_TO_STAGE_LU

            
            STAGE_LU_DATA%LU_Name        = 'N/A'
            STAGE_LU_DATA%LU_Cat         = 'N/A'
            STAGE_LU_DATA%RSMIN          = 9999.0
            STAGE_LU_DATA%Z00            = 0.0
            STAGE_LU_DATA%VEG0           = 0.0
            STAGE_LU_DATA%VEGMN0         = 0.0
            STAGE_LU_DATA%LAI0           = 0.0
            STAGE_LU_DATA%LAIMN0         = 0.0
            STAGE_LU_DATA%Gamma_NH3_grnd = 0.0
            STAGE_LU_DATA%Gamma_NH3_st   = 0.0
            STAGE_LU_DATA%Hg_grnd        = 0.0
            STAGE_LU_DATA%l_width        = 0.0
            STAGE_LU_DATA%Alpha          = 0.0
            STAGE_LU_DATA%BAI            = 0.0
            STAGE_LU_DATA%Ahair          = 0.0
            STAGE_LU_DATA%Fhair          = 0.0
            STAGE_LU_DATA%Aleaf          = 0.0
            STAGE_LU_DATA%LU_Index       = 0

            MET_TO_STAGE_LU%Met_LU_Name = 'N/A'
            MET_TO_STAGE_LU%Met_Index   = 0
            MET_TO_STAGE_LU%Dep_LU_Name = 'N/A'
            MET_TO_STAGE_LU%Dep_Index   = 0
            MET_TO_STAGE_LU%Factor      = 0.0
            MET_TO_STAGE_LU%Description = 'N/A'                  

      ! Retrieve the Name of the STAGE Control File
            IF ( STAGECTRL .EQ. "STAGECTRL_NML" ) THEN
            XMSG = 'You have chosen not to indicate the location of a ' //
     &             'STAGE deposition Control namelist file. This file ' //
     &             'is required by the STAGE dry deposition module.'
               CALL M3EXIT( 'STAGE_LU_MAPPER',0,0,XMSG,1 )
            END IF

      ! Open STAGE Control Namelist File
            DEPCTRL_NML = JUNIT()
            OPEN( FILE = STAGECTRL, UNIT = DEPCTRL_NML, STATUS = 'OLD',
     &            POSITION = 'REWIND', FORM='FORMATTED', IOSTAT = STAT )

      ! Check for Error in File Open Process
            IF ( STAT .NE. 0 ) THEN
               WRITE( XMSG, '(A,A,A)' ),'ERROR: Could not read ',
     &                 'STAGE control namelist file: ',TRIM( STAGECTRL )
               CALL M3EXIT( 'STAGE_LU_MAPPER',0,0,XMSG,1 )
            END IF

            REWIND( DEPCTRL_NML )
            READ( NML = STAGE_LU, UNIT = DEPCTRL_NML, IOSTAT=STAT )
            IF ( STAT .NE. 0 ) THEN
               WRITE( LOGDEV, "(5x,A,/,5x,A,/,5x,A,/,5x,A)" ),
     &           'Warning! Something went wrong while reading the ',
     &           'STAGE land use section of the STAGE ',
     &           'Control Namelist. Default values for this section ',
     &           'will be assumed.'
            END IF

            n_stage_lu = maxval(STAGE_LU_DATA%LU_Index)

            REWIND( DEPCTRL_NML )        

            WRITE( LOGDEV,*) 'Mapping ', LAND_SCHEME, ' to STAGE land use categories.'  
  
            SELECT CASE( LAND_SCHEME )            
               CASE( 'MODIS' )       
                  READ( NML = STAGE_MODIS_20, UNIT = DEPCTRL_NML, IOSTAT=STAT )
                  IF ( STAT .NE. 0 ) THEN
                     WRITE( LOGDEV, "(A,A,A)" ),
     &                 'ERROR: Something went wrong while reading the ',
     &                 'STAGE land use mapping section for MODIS 20 data ',
     &                 'of the STAGE Control Namelist.', TRIM( STAGECTRL )
                     CALL M3EXIT( 'STAGE_LU_MAPPER',0,0,XMSG,1 )
                  END IF

                  n_xref_lu   = 1
                  n_xref_end = .TRUE. ! rename
                  Do While( n_xref_end )
                     If( MET_TO_STAGE_LU(n_xref_lu)%Met_LU_Name .Eq. 'N/A' ) Then
                        n_xref_end = .FALSE.
                        n_xref_lu = n_xref_lu - 1
                     Else
                        n_xref_lu = n_xref_lu + 1
                     End If
                  End Do

               CASE( 'NLCD40' )  
                  READ( NML = STAGE_NLCD_40, UNIT = DEPCTRL_NML, IOSTAT=STAT )
                  IF ( STAT .NE. 0 ) THEN
                     WRITE( LOGDEV, "(A,A,A)" ),
     &                 'ERROR: Something went wrong while reading the ',
     &                 'STAGE land use mapping section for NLCD 40 data ',
     &                 'of the STAGE Control Namelist.', TRIM( STAGECTRL )
                     CALL M3EXIT( 'STAGE_LU_MAPPER',0,0,XMSG,1 )
                  END IF

                  n_xref_lu   = 1
                  n_xref_end = .TRUE. ! rename
                  Do While( n_xref_end )
                     If( MET_TO_STAGE_LU(n_xref_lu)%Met_LU_Name .Eq. 'N/A' ) Then
                        n_xref_end = .FALSE.
                        n_xref_lu = n_xref_lu - 1
                     Else
                        n_xref_lu = n_xref_lu + 1
                     End If
                  End Do
               CASE( 'NLCD50' )
                  READ( NML = STAGE_NLCD_50, UNIT =DEPCTRL_NML, IOSTAT=STAT )
                  IF ( STAT .NE. 0 ) THEN
                     WRITE( LOGDEV, "(A,A,A)" ),
     &                 'ERROR: Something went wrong while reading the ',
     &                 'STAGE land use mapping section for NLCD 50 data ',
     &                 'of the STAGE Control Namelist.', TRIM( STAGECTRL )
                     CALL M3EXIT( 'STAGE_LU_MAPPER',0,0,XMSG,1 )
                  END IF

                  n_xref_lu   = 1
                  n_xref_end = .TRUE. ! rename
                  Do While( n_xref_end )
                     If( MET_TO_STAGE_LU(n_xref_lu)%Met_LU_Name .Eq. 'N/A' ) Then
                        n_xref_end = .FALSE.
                        n_xref_lu = n_xref_lu - 1
                     Else
                        n_xref_lu = n_xref_lu + 1
                     End If
                  End Do
               CASE( 'USGS24' )
                  READ( NML = STAGE_USGS_24, UNIT = DEPCTRL_NML, IOSTAT=STAT )
                  IF ( STAT .NE. 0 ) THEN
                     WRITE( LOGDEV, "(A,A,A)" ),
     &                 'ERROR: Something went wrong while reading the ',
     &                 'STAGE land use mapping section for USGS 24 data ',
     &                 'of the STAGE Control Namelist.', TRIM( STAGECTRL )
                     CALL M3EXIT( 'STAGE_LU_MAPPER',0,0,XMSG,1 )
                  END IF

                  n_xref_lu   = 1
                  n_xref_end = .TRUE. ! rename
                  Do While( n_xref_end )
                     If( MET_TO_STAGE_LU(n_xref_lu)%Met_LU_Name .Eq. 'N/A' ) Then
                        n_xref_end = .FALSE.
                        n_xref_lu = n_xref_lu - 1
                     Else
                        n_xref_lu = n_xref_lu + 1
                     End If
                  End Do
      
               CASE DEFAULT      
                  READ( NML = STAGE_CUSTOM, UNIT = DEPCTRL_NML, IOSTAT=STAT )
                  IF ( STAT .NE. 0 ) THEN
                     WRITE( LOGDEV, "(A,A,A)" ),
     &                 'ERROR: Something went wrong while reading the ',
     &                 'STAGE land use mapping section for Custom LU data ',
     &                 'of the STAGE Control Namelist.', TRIM( STAGECTRL )
                     CALL M3EXIT( 'STAGE_LU_MAPPER',0,0,XMSG,1 )
                  END IF

                  n_xref_lu   = 1
                  n_xref_end = .TRUE. ! rename
                  Do While( n_xref_end )
                     If( MET_TO_STAGE_LU(n_xref_lu)%Met_LU_Name .Eq. 'N/A' ) Then
                        n_xref_end = .FALSE.
                        n_xref_lu = n_xref_lu - 1
                     Else
                        n_xref_lu = n_xref_lu + 1
                     End If
                  End Do

            END SELECT                                                                                       
            CLOSE( UNIT = DEPCTRL_NML )  
            n_lufrac = maxval(MET_TO_STAGE_LU%Met_Index)
         END SUBROUTINE STAGE_LU_MAPPER
                                               
      END MODULE LSM_Mod                       

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE PA_IRR_MODULE 
      
      IMPLICIT NONE
      
      INTERFACE PA_IRR
          MODULE PROCEDURE PA_IRR_BLOCKED, PA_IRR_UNBLOCKED
      END INTERFACE

      CONTAINS
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PA_IRR_BLOCKED ( LSTART, LCHGVL, RK, CONC, DELT, NUMCELLS, ICLND )

C-----------------------------------------------------------------------
C  Function: Integrate chemical rates of reaction for an IRR/MB analysis
 
C  Preconditions: None
 
C  Key Subroutines/Functions Called: None
 
C  Revision History:
C   Prototype created by Jerry Gipson, September, 1996
C   global BLKPRM Jeff Dec 96
C   Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C   Modified Jun, 1998 by Jerry Gipson to add reaction number error checks
C   Modified 1/19/99 by David Wong at LM:
C                      -- add four include files because of new PA_CMN.EXT
C   Modified 2/26/99 by David Wong at LM:
C                      -- remove SUBST_AE_SPC, SUBST_NR_SPC, SUBST_TR_SPC,
C                         three .EXT files
C   31 Mar 01 J.Young: Use HGRD_DEFN; eliminate BLKPRM.EXT
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   19 Aug 11 J.Young: Replaced I/O API include files with UTILIO_DEFN
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module

C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE RXNS_DATA             ! chemical mechanism data
      USE CGRID_SPCS            ! CGRID mechanism species
      USE PA_DEFN               ! Process Anaylsis control and data variables
      USE UTILIO_DEFN

      IMPLICIT NONE 

C..Includes: None
      
C..Arguments: 
      LOGICAL, INTENT( IN ) :: LSTART   ! Flag to indicate start of chemical integration period
      LOGICAL, INTENT( IN ) :: LCHGVL   ! Flag to indicate vector length is changing

      REAL(8), INTENT( IN ) :: RK( :,: )    ! Reaction rate coefficients
      REAL(8), INTENT( IN ) :: CONC( :,: )  ! Species concentrations
      REAL(8), INTENT( IN ) :: DELT         ! Chemistry integration time size
      INTEGER, INTENT( IN ) :: NUMCELLS     ! Number of cells to process
      INTEGER, INTENT( IN ) :: ICLND( : )   ! Original cell number 

C..Parameters: None

C..External Functions: None
 
C..Saved Local Variables:
      CHARACTER( 16 ) , SAVE :: PNAME = 'PA_IRR'   ! Program name
      CHARACTER( 132)        :: MSG

      LOGICAL, SAVE :: LFIRST = .TRUE.   ! Flag for first call to subroutine
C..Scratch Local Variables:
      INTEGER ISP1, ISP2, ISP3  ! Species indices
      INTEGER NCELL             ! Loop index for cells
      INTEGER NIRR              ! Loop index for IRR outputs
      INTEGER NOUT              ! IRR output index
      INTEGER NRX               ! Loop index for reactions
      INTEGER NTEMP             ! Loop index for temp IRRs
      INTEGER NTERM             ! Loop index for terms
      INTEGER ASTAT             ! allocation status

      REAL(8)  ::    COEFF                           ! Coefficient of IRR term
C..Saved Local Variables:
      LOGICAL, ALLOCATABLE, SAVE :: LINTRXN( : )  ! Flag for reaction integration

      REAL(8), ALLOCATABLE, SAVE :: RXOLD  ( :,: )
      REAL(8), ALLOCATABLE, SAVE :: RXSAV  ( :,: )       
      REAL(8), ALLOCATABLE, SAVE :: RXRAT  ( :,: )     ! Calculated reaction rates
      REAL(8), ALLOCATABLE, SAVE :: INTRXN ( :,: )     ! Integrated reaction rates
      REAL(8), ALLOCATABLE, SAVE :: TEMPIRR( :,: )     ! Array of computed temp IRRs

C-----------------------------------------------------------------------

      IF ( LFIRST ) THEN
C Allocate PA_DEFN arrays:
         ALLOCATE ( IRRSTEP( BLKSIZE,NIRRVAR ),
     &              IRRBLK ( BLKSIZE,NIRRVAR ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            MSG = 'Failure initializing IRRSTEP of IRRBLK'
            CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
         END IF
C  On first call, flag the reactions for which to calculate IRRs
        ALLOCATE( LINTRXN( NRXNS ),
     &            RXOLD  ( BLKSIZE, NRXNS ),
     &            RXSAV  ( BLKSIZE, NRXNS ),
     &            RXRAT  ( BLKSIZE, NRXNS ),
     &            INTRXN ( BLKSIZE, NRXNS ),
     &            TEMPIRR( BLKSIZE, NRXNS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating PA_IRR variables'
           CALL M3EXIT ( 'PA_IRR', 0, 0, MSG, XSTAT2 )
         END IF
     
         IF ( LFULLIRR .AND. NIRRVAR .NE. NRXNS ) THEN
            MSG = 'Number of reactions for PA does not match number of ' //
     &            'reactions in mechanism'
            CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT2 )
         END IF
 
         IF ( LFULLIRR ) THEN
            LINTRXN = .TRUE.
         ELSE
            LINTRXN = .FALSE.
            IF ( NUMTEMPS .GT. 0 ) THEN            
               DO NTEMP = 1, NUMTEMPS 
                  DO NTERM = 1, TEMPTERMS( NTEMP )
                     NRX = TEMPRXN( NTEMP,NTERM )
                     IF ( NRX .GT. NRXNS ) THEN
                        MSG = 'Number of reactions for PA does not match ' //
     &                        'number of reactions in mechanism'
                        CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT2 )
                     END IF
                     LINTRXN( NRX ) = .TRUE.
                  END DO
               END DO
            END IF

            IF ( NIRRVAR .GT. 0 ) THEN
               DO NOUT = 1, NIRRVAR
                  IF ( NIRRRXNS( NOUT ) .GT. 0 ) THEN
                     DO NTERM = 1, NIRRRXNS( NOUT )
                        NRX = IRRRXN( NOUT,NTERM )
                        IF ( NRX .GT. NRXNS ) THEN
                           MSG = 'Number of reactions for PA does not match ' //
     &                           'number of reactions in mechanism'
                           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT2 )
                        END IF
                        LINTRXN( NRX ) = .TRUE.
                     END DO
                  END IF
               END DO
            END IF

         END IF
         
         LFIRST = .FALSE.                

      END IF ! LFIRST
    
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Loop over reactions and calculate rate of reaction with current
c  concentrations (This needs to be optimized for small NUMCELLS)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NRX = 1, NRXNS
         IF ( LINTRXN( NRX ) ) THEN
            IF ( NREACT( NRX ) .EQ. 1 ) THEN
               ISP1 = IRR( NRX,1 )
               DO NCELL = 1, NUMCELLS
                  RXRAT( NCELL,NRX ) = RK( NCELL,NRX )
     &                               * CONC( NCELL,ISP1 )
               END DO
            ELSE IF ( NREACT( NRX ) .EQ. 2 ) THEN
               ISP1 = IRR( NRX,1 )
               ISP2 = IRR( NRX,2 )
               DO NCELL = 1, NUMCELLS
                  RXRAT( NCELL,NRX ) = RK( NCELL,NRX )
     &                               * CONC( NCELL,ISP1 )
     &                               * CONC( NCELL,ISP2 ) 
               END DO
            ELSE IF ( NREACT( NRX ) .EQ. 3 ) THEN
               ISP1 = IRR( NRX,1 )
               ISP2 = IRR( NRX,2 )
               ISP3 = IRR( NRX,3 )
               DO  NCELL = 1, NUMCELLS
                  RXRAT( NCELL,NRX ) = RK( NCELL,NRX )
     &                               * CONC( NCELL,ISP1 )
     &                               * CONC( NCELL,ISP2 )
     &                               * CONC( NCELL,ISP3 ) 
               END DO 
            ELSE IF (NREACT( NRX ) .EQ. 0 ) THEN
               DO NCELL = 1, NUMCELLS
                  RXRAT( NCELL,NRX ) = RK( NCELL,NRX )
               END DO
            END IF
         END IF         
100   END DO

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c If this is the start of the chemistry integration period, save the 
c reaction rates, and return
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LSTART ) THEN
         DO NRX = 1, NRXNS
            IF ( LINTRXN( NRX ) ) THEN
               DO NCELL = 1, NUMCELLS
                  RXOLD( NCELL,NRX ) = RXRAT( NCELL,NRX )
                  RXSAV( NCELL,NRX ) = RXRAT( NCELL,NRX )
               END DO 
            END IF
         END DO
        IF ( LCHGVL ) THEN
c..For changing block lengths
           DO NIRR = 1, NIRRVAR
              DO NCELL = 1, NUMCELLS
                 IRRBLK( ICLND( NCELL ),NIRR ) = 0.0
              END DO
           END DO
         ELSE
           DO NIRR = 1, NIRRVAR
             DO NCELL = 1, NUMCELLS
                IRRBLK( NCELL,NIRR ) = 0.0
             END DO
           END DO
         END IF
         RETURN
      END IF ! LSTART
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Initialize calculated IRRs to zero and get the reaction rate at
c  the previous step if the cell vector length is changing
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NIRR = 1, NIRRVAR
         DO NCELL = 1, NUMCELLS
            IRRSTEP( NCELL,NIRR ) = 0.0D0
         END DO
      END DO

      IF ( LCHGVL ) THEN
         DO NIRR = 1, NRXNS
            IF ( LINTRXN( NIRR ) ) THEN
                DO NCELL = 1, NUMCELLS
                   RXOLD( NCELL,NIRR ) = RXSAV( ICLND( NCELL ),NIRR )
                END DO
             END IF
         END DO
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Compute integrated reaction rates for each reaction and return
c  if a Full IRR analysis is being done 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NRX = 1, NRXNS
         IF ( LINTRXN( NRX ) ) THEN
            DO NCELL = 1, NUMCELLS
               INTRXN( NCELL,NRX ) = 0.5D0 * DELT
     &                             * ( RXOLD( NCELL,NRX )
     &                             +   RXRAT( NCELL,NRX ) )
            END DO
         END IF
      END DO

      IF ( LFULLIRR ) THEN
         DO NRX = 1, NRXNS
            DO NCELL = 1, NUMCELLS
               IRRSTEP( NCELL,NRX ) = INTRXN( NCELL,NRX ) 
            END DO
         END DO
      ELSE   
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Compute the temporary IRRs that are used below
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NUMTEMPS .GT. 0 ) THEN         
            DO NTEMP = 1, NUMTEMPS
               DO NCELL = 1, NUMCELLS
                  TEMPIRR( NCELL,NTEMP ) = 0.0D0
               END DO
            END DO         
            DO NTEMP =1, NUMTEMPS                    
               DO NTERM = 1, TEMPTERMS( NTEMP )
                  NRX = TEMPRXN( NTEMP,NTERM )
                  COEFF = REAL( TEMPCOEF( NTEMP, NTERM ), 8)
                  DO NCELL = 1, NUMCELLS
                     TEMPIRR( NCELL,NTEMP ) = TEMPIRR( NCELL,NTEMP )
     &                                      + COEFF * INTRXN( NCELL,NRX )
                  END DO
               END DO
            END DO         
         END IF         
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Sum up all IRRs for the output IRR for this step
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c..Add required temporary IRRs if they are positive
c
         IF ( NUMOUTPOS .GT. 0 ) THEN
            DO NTERM = 1, NUMOUTPOS
               NTEMP = TEMPOUTPOS( NTERM )
               NOUT  = INDXOUTPOS( NTERM )
               COEFF = REAL( COEFOUTPOS( NTERM ), 8)
               DO NCELL = 1, NUMCELLS
                  IF ( TEMPIRR( NCELL,NTEMP ) .GT. 0.0D0 ) THEN
                     IRRSTEP( NCELL,NOUT ) = IRRSTEP( NCELL,NOUT )
     &                                     + COEFF * TEMPIRR( NCELL,NTEMP )
                  END IF
               END DO
            END DO
         END IF         
c..Add required temporary IRRs if they are negative
         IF ( NUMOUTNEG .GT. 0 ) THEN
            DO NTERM = 1, NUMOUTNEG
               NTEMP = TEMPOUTNEG( NTERM )
               NOUT  = INDXOUTNEG( NTERM )
               COEFF = REAL( COEFOUTNEG( NTERM ), 8)
               DO NCELL = 1, NUMCELLS
                  IF ( TEMPIRR( NCELL,NTEMP ) .LT. 0.0D0 ) THEN
                     IRRSTEP( NCELL,NOUT ) = IRRSTEP( NCELL,NOUT )
     &                                     + COEFF * ABS( TEMPIRR( NCELL,NTEMP ) )
                  END IF
               END DO
            END DO
         END IF
c..Add temporary IRRs that do not depend on sign
         IF ( NUMOUTIND .GT. 0 ) THEN
            DO NTERM = 1, NUMOUTIND
               NTEMP = TEMPOUTIND( NTERM )
               NOUT  = INDXOUTIND( NTERM )
               COEFF = REAL( COEFOUTIND( NTERM ), 8 )
               DO NCELL = 1, NUMCELLS
                  IRRSTEP( NCELL,NOUT ) = IRRSTEP( NCELL,NOUT )
     &                                  + COEFF * TEMPIRR( NCELL,NTEMP )
               END DO
            END DO
         END IF
c..Add all remaining IRRs terms
         DO NOUT = 1, NIRRVAR
            IF ( NIRRRXNS( NOUT ) .GT. 0 ) THEN
               DO NTERM = 1, NIRRRXNS( NOUT )
                  COEFF = REAL( IRRCOEF( NOUT,NTERM ), 8)
                  NRX   = IRRRXN( NOUT,NTERM )
                  DO NCELL = 1, NUMCELLS
                     IRRSTEP( NCELL,NOUT ) = IRRSTEP( NCELL,NOUT )
     &                                     + COEFF * INTRXN( NCELL,NRX )
                  END DO
               END DO
            END IF
         END DO
      END IF
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Update the array holding the cumulative results over all steps and
c  save the rxrates for the next step
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LCHGVL ) THEN
c..For changing block lengths
         DO NIRR = 1, NIRRVAR
            DO NCELL = 1, NUMCELLS
               IRRBLK( ICLND( NCELL ),NIRR ) = IRRBLK( ICLND( NCELL ),NIRR )
     &                                       + REAL( IRRSTEP( NCELL,NIRR ) )
            END DO
         END DO
         DO NIRR = 1, NRXNS
            IF ( LINTRXN( NIRR ) ) THEN
               DO NCELL = 1, NUMCELLS
                  RXSAV( ICLND( NCELL ),NIRR ) = RXRAT( NCELL,NIRR )
               END DO
            END IF
         END DO
      ELSE
c..For static block lengths
         DO NIRR = 1, NIRRVAR
            DO NCELL = 1, NUMCELLS
               IRRBLK( NCELL,NIRR ) = IRRBLK( NCELL,NIRR )
     &                              + REAL( IRRSTEP( NCELL,NIRR ) )
            END DO
         END DO
         DO NIRR = 1, NRXNS
            IF ( LINTRXN( NIRR ) ) THEN
               DO NCELL = 1, NUMCELLS
                  RXOLD( NCELL,NIRR ) = RXRAT( NCELL,NIRR )
               END DO
            END IF
         END DO
      END IF

      RETURN
      END SUBROUTINE PA_IRR_BLOCKED
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PA_IRR_UNBLOCKED ( LSTART, RK, CONC, DELT )

C-----------------------------------------------------------------------
C  Function: Integrate chemical rates of reaction for an IRR/MB analysis
 
C  Preconditions: None
 
C  Key Subroutines/Functions Called: None
 
C  Revision History:
C   Prototype created by Jerry Gipson, September, 1996
C   global BLKPRM Jeff Dec 96
C   Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C   Modified Jun, 1998 by Jerry Gipson to add reaction number error checks
C   Modified 1/19/99 by David Wong at LM:
C                      -- add four include files because of new PA_CMN.EXT
C   Modified 2/26/99 by David Wong at LM:
C                      -- remove SUBST_AE_SPC, SUBST_NR_SPC, SUBST_TR_SPC,
C                         three .EXT files
C   31 Mar 01 J.Young: Use HGRD_DEFN; eliminate BLKPRM.EXT
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   19 Aug 11 J.Young: Replaced I/O API include files with UTILIO_DEFN
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module

C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE RXNS_DATA             ! chemical mechanism data
      USE CGRID_SPCS            ! CGRID mechanism species
      USE PA_DEFN               ! Process Anaylsis control and data variables
      USE UTILIO_DEFN

      IMPLICIT NONE 

C..Includes: None
      
C..Arguments: 
      LOGICAL, INTENT( IN ) :: LSTART   ! Flag to indicate start of chemical integration period

      REAL( 8 ),    INTENT( IN ) :: RK  ( : )    ! Reaction rate coefficients
      REAL( 8 ),    INTENT( IN ) :: CONC( : )    ! species concentrations
      REAL( 8 ),    INTENT( IN ) :: DELT         ! Chemistry integration time size

C..Parameters: None

C..External Functions: None
 
      CHARACTER( 16 ) , SAVE :: PNAME = 'PA_IRR'   ! Program name
      CHARACTER( 132)        :: MSG

      LOGICAL, SAVE :: LFIRST = .TRUE.   ! Flag for first call to subroutine

C..Scratch Local Variables:
      INTEGER ISP1, ISP2, ISP3  ! Species indices
      INTEGER NCELL             ! Loop index for cells
      INTEGER NIRR              ! Loop index for IRR outputs
      INTEGER NOUT              ! IRR output index
      INTEGER NRX               ! Loop index for reactions
      INTEGER NTEMP             ! Loop index for temp IRRs
      INTEGER NTERM             ! Loop index for terms
      INTEGER ASTAT             ! allocation status


      REAL( 8 ) ::    COEFF                           ! Coefficient of IRR term
C..Saved Local Variables:
      LOGICAL, ALLOCATABLE, SAVE :: LINTRXN( : )  ! Flag for reaction integration

      REAL(8), ALLOCATABLE, SAVE :: RXRAT  ( : )     ! Calculated reaction rates
      REAL(8), ALLOCATABLE, SAVE :: INTRXN ( : )     ! Integrated reaction rates
      REAL(8), ALLOCATABLE, SAVE :: TEMPIRR( : )     ! Array of computed temp IRRs

C-----------------------------------------------------------------------

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  On first call, flag the reactions for which to calculate IRRs
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LFIRST ) THEN

C Allocate PA_DEFN arrays:
        ALLOCATE (  IRRDEL( NIRRVAR ),
     &              IRRSUM( NIRRVAR ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
            MSG = 'Failure initializing IRRSTEP of IRRBLK'
            CALL M3EXIT( 'PA_IRR', 0, 0, MSG, XSTAT1 )
        END IF

        ALLOCATE( LINTRXN( NRXNS ),
     &            RXRAT  ( NRXNS ),
     &            INTRXN ( NRXNS ),
     &            TEMPIRR( NRXNS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating PA_IRR variables'
           CALL M3EXIT ( 'PA_IRR', 0, 0, MSG, XSTAT2 )
         END IF
    
         IF ( LFULLIRR .AND. NIRRVAR .NE. NRXNS ) THEN
            CALL M3EXIT( PNAME, 0, 0,
     &        'Number of reactions for PA does not match number of ' //
     &        'reactions in mechanism', XSTAT2 )
         END IF
 
         IF ( LFULLIRR )THEN
              LINTRXN = .TRUE.
         ELSE
            LINTRXN = .FALSE.
            IF ( NUMTEMPS .GT. 0 ) THEN            
               IF( ANY( TEMPRXN .GT. NRXNS ) )THEN 
                   CALL M3EXIT( PNAME, 0, 0,
     &             'Number of reactions for PA does not match ' //
     &             'number of reactions in mechanism', XSTAT2 )
               END IF
               DO NTEMP = 1, NUMTEMPS 
                  DO NTERM = 1, TEMPTERMS( NTEMP )
                     NRX = TEMPRXN( NTEMP,NTERM )
                     LINTRXN( NRX ) = .TRUE.
                  END DO
               END DO
            END IF
            IF ( NIRRVAR .GT. 0 ) THEN
               IF( ANY( NIRRRXNS .GT. NRXNS ) )THEN 
                   CALL M3EXIT( PNAME, 0, 0,
     &             'Number of reactions for PA does not match ' //
     &             'number of reactions in mechanism', XSTAT2 )
               END IF
               DO NOUT = 1, NIRRVAR
                  IF ( NIRRRXNS( NOUT ) .GT. 0 ) THEN
                     DO NTERM = 1, NIRRRXNS( NOUT )
                        NRX = IRRRXN( NOUT,NTERM )
                        LINTRXN( NRX ) = .TRUE.
                     END DO
                  END IF
               END DO
            END IF
         END IF
         
         LFIRST = .FALSE.

      END IF ! LFIRST
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Loop over reactions and calculate rate of reaction with current
c  concentrations (This needs to be optimized for small NUMCELLS)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO 100 NRX = 1, NRXNS
         IF ( LINTRXN( NRX ) ) THEN
            IF ( NREACT( NRX ) .EQ. 1 ) THEN
               ISP1 = IRR( NRX,1 )
               RXRAT( NRX ) = RK( NRX )
     &                      * CONC( ISP1 )
            ELSE IF ( NREACT( NRX ) .EQ. 2 ) THEN
               ISP1 = IRR( NRX,1 )
               ISP2 = IRR( NRX,2 )
               RXRAT( NRX ) = RK( NRX )
     &                      * CONC( ISP1 )
     &                      * CONC( ISP2 ) 
            ELSE IF ( NREACT( NRX ) .EQ. 3 ) THEN
               ISP1 = IRR( NRX,1 )
               ISP2 = IRR( NRX,2 )
               ISP3 = IRR( NRX,3 )
               RXRAT( NRX ) = RK( NRX )
     &                      * CONC( ISP1 )
     &                      * CONC( ISP2 )
     &                      * CONC( ISP3 ) 
            ELSE IF (NREACT( NRX ) .EQ. 0 ) THEN
                  RXRAT( NRX ) = RK( NRX )
            END IF
         END IF         
100   CONTINUE

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c If this is the start of the chemistry integration period, save the 
c reaction rates, and return
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LSTART ) THEN
         IRRSUM = 0.0
         RETURN
      END IF

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Initialize calculated IRRs to zero and get the reaction rate at
c  the previous step if the cell vector length is changing
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IRRDEL = 0.0D0

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Compute integrated reaction rates for each reaction and return
c  if a Full IRR analysis is being done 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NRX = 1, NRXNS
         IF ( LINTRXN( NRX ) ) THEN
            INTRXN( NRX ) = DELT * RXRAT( NRX ) 
         END IF
      END DO

      IF ( LFULLIRR ) THEN
         DO NRX = 1, NRXNS
            IRRDEL( NRX ) = INTRXN( NRX ) 
         END DO
      ELSE     

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Compute the temporary IRRs that are used below
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        IF ( NUMTEMPS .GT. 0 ) THEN
           TEMPIRR = 0.0D0
           DO NTEMP = 1, NUMTEMPS             
              DO NTERM = 1, TEMPTERMS( NTEMP )
                 NRX = TEMPRXN( NTEMP,NTERM )
                 COEFF = REAL( TEMPCOEF( NTEMP, NTERM ), 8)        
                 TEMPIRR( NTEMP ) = TEMPIRR( NTEMP )
     &                            + COEFF * INTRXN( NRX )
              END DO
           END DO
        END IF         
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Sum up all IRRs for the output IRR for this step
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c..Add required temporary IRRs if they are positive
c
        IF ( NUMOUTPOS .GT. 0 ) THEN
             DO NTERM = 1, NUMOUTPOS
              NTEMP = TEMPOUTPOS( NTERM )
              NOUT  = INDXOUTPOS( NTERM )
              COEFF = REAL( COEFOUTPOS( NTERM ), 8)
               IF ( TEMPIRR( NTEMP ) .GT. 0.0D0 ) THEN
                   IRRDEL( NOUT ) = IRRDEL( NOUT )
     &                            + COEFF * TEMPIRR( NTEMP )
             END IF
           END DO
        END IF        
c..Add required temporary IRRs if they are negative
        IF ( NUMOUTNEG .GT. 0 ) THEN
             DO NTERM = 1, NUMOUTNEG
                NTEMP = TEMPOUTNEG( NTERM )
                NOUT  = INDXOUTNEG( NTERM )
                COEFF = REAL( COEFOUTNEG( NTERM ), 8 )
                IF ( TEMPIRR( NTEMP ) .LT. 0.0D0 ) THEN
                  IRRDEL( NOUT ) = IRRDEL( NOUT )
     &                           + COEFF * ABS( TEMPIRR( NTEMP ) )
                END IF
           END DO
        END IF        
c..Add temporary IRRs that do not depend on sign
        IF ( NUMOUTIND .GT. 0 ) THEN
           DO NTERM = 1, NUMOUTIND
              NTEMP = TEMPOUTIND( NTERM )
              NOUT  = INDXOUTIND( NTERM )
              COEFF = REAL( COEFOUTIND( NTERM ), 8)
              IRRDEL( NOUT ) = IRRDEL( NOUT )
     &                       + COEFF * TEMPIRR( NTEMP )
           END DO
        END IF        
c..Add all remaining IRRs terms
        DO NOUT = 1, NIRRVAR
           IF ( NIRRRXNS( NOUT ) .GT. 0 ) THEN
              DO NTERM = 1, NIRRRXNS( NOUT )
                 COEFF = REAL( IRRCOEF( NOUT,NTERM ), 8)
                 NRX   = IRRRXN( NOUT,NTERM )
                 IRRDEL( NOUT ) = IRRDEL( NOUT )
     &                          + COEFF * INTRXN( NRX )
              END DO
           END IF
        END DO
      END IF
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Update the array holding the cumulative results over all steps and
c  save the rxrates for the next step
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NIRR = 1, NIRRVAR
         IRRSUM( NIRR ) = IRRSUM ( NIRR ) + REAL( IRRDEL( NIRR ) )
      END DO

      RETURN
      END SUBROUTINE PA_IRR_UNBLOCKED

      END MODULE PA_IRR_MODULE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
      MODULE ELMO_DERIVED_DEFN

      USE ELMO_DATA

      IMPLICIT NONE

      PUBLIC

      SAVE

      INTEGER  :: MX_SRC

      ! Allocate variables needed for referencing specific components of
      ! DERIVED variable calculations
      INTEGER,ALLOCATABLE :: J_PMF_MASS(:)
      INTEGER,ALLOCATABLE :: J_PMF_SO4(:)
      INTEGER,ALLOCATABLE :: J_PMF_NO3(:)
      INTEGER,ALLOCATABLE :: J_PMF_NH4(:)
      INTEGER,ALLOCATABLE :: J_PM25_SO4(:)
      INTEGER,ALLOCATABLE :: J_PM25_NO3(:)
      INTEGER,ALLOCATABLE :: J_PM25_NH4(:)
      INTEGER,ALLOCATABLE :: J_PMF_HP(:)
      INTEGER,ALLOCATABLE :: J_PMF_HPMOLAL(:)
      INTEGER,ALLOCATABLE :: J_PMF_H2O(:)
      INTEGER,ALLOCATABLE :: J_PMF_BENAPY(:)
      INTEGER,ALLOCATABLE :: J_GAS_BENAPY(:)
      INTEGER,ALLOCATABLE :: J_PFAS_GAS(:)
      INTEGER,ALLOCATABLE :: J_PFAS_AER(:)
      INTEGER,ALLOCATABLE :: J_DD_PFAS_GAS(:)
      INTEGER,ALLOCATABLE :: J_DD_PFAS_AER(:)
      INTEGER,ALLOCATABLE :: J_WD_PFAS_GAS(:)
      INTEGER,ALLOCATABLE :: J_WD_PFAS_AER(:)
      

      CONTAINS

!-------------------------------------------------------------------------
      SUBROUTINE ELMO_MAP_DERIVED( )
!     This subroutine maps the DERIVED ELMO variables.
!-------------------------------------------------------------------------

#ifdef isam
      USE SA_DEFN, ONLY : NTAG_SA
#endif
#ifdef sens
      USE DDM3D_DEFN, ONLY : NPMAX
#endif

      IMPLICIT NONE    

      INTEGER J, IOS, ISRC, K
      
      MX_SRC = 0
#ifdef isam
      MX_SRC = NTAG_SA
#endif
#ifdef sens
      MX_SRC = NPMAX 
#endif
      MX_SRC = MX_SRC + 1

      ! Allocate indices for saving ELMO TABLE location of DERIVED
      ! variable components
      ALLOCATE( J_PMF_MASS(MX_SRC),  J_PMF_SO4(MX_SRC),
     &          J_PMF_NO3(MX_SRC),   J_PMF_NH4(MX_SRC),
     &          J_PM25_SO4(MX_SRC),  J_PM25_NO3(MX_SRC),
     &          J_PM25_NH4(MX_SRC),  J_PMF_HP(MX_SRC),
     &          J_PMF_HPMOLAL(MX_SRC),   J_PMF_H2O(MX_SRC),
     &          J_PMF_BENAPY(MX_SRC) ,J_GAS_BENAPY(MX_SRC),
     &          J_PFAS_GAS(MX_SRC),  J_PFAS_AER(MX_SRC),
     &          J_DD_PFAS_GAS(MX_SRC), J_DD_PFAS_AER(MX_SRC),
     &          J_WD_PFAS_GAS(MX_SRC), J_WD_PFAS_AER(MX_SRC),
     &          STAT = IOS )
      CALL CHECKMEM( IOS, 'J DERIVED COMPONENTS','ELMO_MAP_DERIVED' )

      ! Initialize Derived Variable Location Pointers
      J_PMF_MASS    = 0
      J_PMF_SO4     = 0
      J_PMF_NO3     = 0
      J_PMF_NH4     = 0
      J_PM25_SO4    = 0
      J_PM25_NO3    = 0
      J_PM25_NH4    = 0
      J_PMF_HP      = 0
      J_PMF_HPMOLAL = 0
      J_PMF_H2O     = 0
      J_PMF_BENAPY  = 0
      J_GAS_BENAPY  = 0
      J_PFAS_GAS    = 0
      J_PFAS_AER    = 0
      J_DD_PFAS_GAS = 0
      J_DD_PFAS_AER = 0
      J_WD_PFAS_GAS = 0
      J_WD_PFAS_AER = 0

      ! Search for source-dependent indices in ELMO TABLE
      DO ISRC = 0,MX_SRC
        DO J = 1,N_ELMO_TABLE
          IF ( ELMO_TABLE( J )%SOURCE .EQ. ISRC ) THEN
            SELECT CASE ( ELMO_TABLE( J )%NAME )
              CASE ( 'PMF' )
                J_PMF_MASS( ISRC+1 ) = J
              CASE ( 'PMF_SO4' )
                J_PMF_SO4( ISRC+1 ) = J
              CASE ( 'PMF_NO3' ) 
                J_PMF_NO3( ISRC+1 ) = J
              CASE ( 'PMF_NH4' ) 
                J_PMF_NH4( ISRC+1 ) = J
              CASE ( 'PM25_SO4' )
                J_PM25_SO4( ISRC+1 ) = J
              CASE ( 'PM25_NO3' )
                J_PM25_NO3( ISRC+1 ) = J
              CASE ( 'PM25_NH4' ) 
                J_PM25_NH4( ISRC+1 ) = J
              CASE ( 'PMF_HP' ) 
                J_PMF_HP( ISRC+1 ) = J
              CASE ( 'PMF_HPMOLAL' ) 
                J_PMF_HPMOLAL( ISRC+1 ) = J
              CASE ( 'PMF_H2O' )
                J_PMF_H2O( ISRC+1 ) = J
              CASE ( 'PMF_BENAPY' ) 
                J_PMF_BENAPY( ISRC+1 ) = J
              CASE ( 'GAS_BENAPY' ) 
                J_GAS_BENAPY( ISRC+1 ) = J
              CASE ( 'PFAS_GAS' ) 
                J_PFAS_GAS( ISRC+1 ) = J
              CASE ( 'PFAS_AER' ) 
                J_PFAS_AER( ISRC+1 ) = J
              CASE ( 'DD_PFAS_GAS' ) 
                J_DD_PFAS_GAS( ISRC+1 ) = J
              CASE ( 'DD_PFAS_AER' ) 
                J_DD_PFAS_AER( ISRC+1 ) = J
              CASE ( 'WD_PFAS_GAS' ) 
                J_WD_PFAS_GAS( ISRC+1 ) = J
              CASE ( 'WD_PFAS_AER' ) 
                J_WD_PFAS_AER( ISRC+1 ) = J
            END SELECT                
          END IF
        END DO
      END DO

      ! Map Derived Concentration and Deposition ELMO Variables to the
      ! ELMO Derived Parameters Table
      DO J = 1,N_ELMO_TABLE
         ELMO_TABLE( J )%DRVD_TAB = 0
         IF ( ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DRVD .OR.
     &        ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DRVD_DDEP .OR.
     &        ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DRVD_WDEP .OR.
     &        ELMO_TABLE( J )%VAR_TYPE .EQ. ET_ISAM_DRVD .OR.
     &        ELMO_TABLE( J )%VAR_TYPE .EQ. ET_ISAM_DRVD_DDEP .OR.
     &        ELMO_TABLE( J )%VAR_TYPE .EQ. ET_ISAM_DRVD_WDEP .OR.
     &        ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DDM_DRVD .OR.
     &        ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DDM_DRVD_DDEP .OR.
     &        ELMO_TABLE( J )%VAR_TYPE .EQ. ET_DDM_DRVD_WDEP .OR.
     &        ELMO_TABLE( J )%VAR_TYPE .EQ. ET_AEROPROP ) THEN

            DO K = 1,N_ELMO_DRVD
               IF ( ELMO_TABLE( J )%ID .EQ. ELMO_DRVD_TAB( K )%ID ) THEN
                  ELMO_TABLE( J )%DRVD_TAB = K
               END IF
            END DO
         END IF
      END DO

      END SUBROUTINE ELMO_MAP_DERIVED

      END MODULE ELMO_DERIVED_DEFN
      

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SUBHDOMAIN ( NPROCS, NPCOL, NPROW, NCOLS, NROWS,
     &                        NCOLS_PE, NROWS_PE, COLSX_PE, ROWSX_PE )

C----------------------------------------------------------------------
C  Purpose:   Subroutine to construct the horizontal
C             processor-to-subdomain map.
 
C  Revision History: 
C       Original version  12/05 by J Young - modified from pario's SUBDMAP
C       16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
 
C  Argument List Description:
C  In:
C        INTEGER    NPROCS                 ! Number of processors
C        INTEGER    NPCOL                  ! Number of PEs across grid cols
C        INTEGER    NPROW                  ! Number of PEs across grid rows
C        INTEGER    NCOLS                  ! Total number of columns in grid
C        INTEGER    NROWS                  ! Total number of rows in grid
C  Out:
C        INTEGER    NCOLS_PE( NPROCS )     ! Number of columns for each PE
C        INTEGER    NROWS_PE( NPROCS )     ! Number of rows for each PE
C        INTEGER    COLSX_PE( 2,NPROCS )   ! Column index range for each PE
C        INTEGER    ROWSX_PE( 2,NPROCS )   ! Row index range for each PE
 
C----------------------------------------------------------------------

      USE UTILIO_DEFN

      IMPLICIT  NONE

C Arguments:

      INTEGER NPROCS, NCOLS, NROWS, NPCOL, NPROW
      INTEGER NCOLS_PE( NPROCS ), NROWS_PE( NPROCS )
      INTEGER COLSX_PE( 2,NPROCS ), ROWSX_PE( 2,NPROCS )

C Include Files:

C External Functions:

C Local Variables: 

      INTEGER I                  ! Loop counter 
      INTEGER NDX                ! Temporary index for processors row, column 
      INTEGER NCOLX              ! Used for computing columns per domain 
      INTEGER NROWX              ! Used for computing rows per domain 
      CHARACTER( 80 ) :: XMSG    ! Message issued from M3EXIT routine 
      CHARACTER( 16 ) :: PNAME = 'SUBHDOMAIN'
      INTEGER ASTAT              ! allocate/deallocate error status

C Dynamic arrays.

      INTEGER, ALLOCATABLE :: NCOLS_WE( : ) ! No. columns in west-to-east subdomains
      INTEGER, ALLOCATABLE :: NROWS_SN( : ) ! No. rows in south-to-north subdomains
 
C----------------------------------------------------------------------

      ALLOCATE ( NCOLS_WE( NPCOL ),
     &           NROWS_SN( NPROW ), STAT=ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         XMSG = 'Error allocating NCOLS_WE or NCOLS_SN'
         CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT2 )
         RETURN
      END IF

C Construct the processor-to-subdomain map

      NCOLX = NCOLS / NPCOL
      NROWX = NROWS / NPROW

      DO I = 1 , NPCOL
         NCOLS_WE( I ) = NCOLX
      END DO

      DO I = 1 , NPROW
         NROWS_SN( I ) = NROWX
      END DO

      DO I = 1, NCOLS - NPCOL*NCOLX            ! Spread out remaining columns
         NCOLS_WE( I ) = NCOLS_WE( I ) + 1
      END DO

      DO I = 1, NROWS - NPROW*NROWX
         NROWS_SN( I ) = NROWS_SN( I ) + 1     ! Spread out remaining rows
      END DO
       
C Assign the number of rows and columns for each PE subdomain, 
C and calculate the index range into the global domain

C                                                    NPCOL
C  Example subdomain layout         _____________________________________
C  for 8 processors with           |         |         |        |        |
C  NPCOL=4, NPROW=2.               |         |         |        |        |
C                                  |    4    |    5    |    6   |    7   |
C                                  |         |         |        |        |
C                           NPROW  |_________|_________|________|________|
C                                  |         |         |        |        |
C                                  |         |         |        |        |
C                                  |    0    |    1    |    2   |    3   |
C                                  |         |         |        |        |
C                                  |         |         |        |        |
C                                  |_________|_________|________|________|

      DO I = 1, NPROCS

C Set NDX to the subdomain column index for processor I
         NDX = MOD ( I,NPCOL )
         IF ( NDX .EQ. 0 ) NDX = NPCOL

C Assign the number of columns in this PE
         NCOLS_PE( I ) = NCOLS_WE( NDX )

C Calculate column range of this PE in the global domain
         IF ( NDX .EQ. 1 ) THEN
            COLSX_PE( 1,I ) = 1
            COLSX_PE( 2,I ) = NCOLS_PE( I )
         ELSE
            COLSX_PE( 1,I ) = COLSX_PE( 2,I-1 ) + 1
            COLSX_PE( 2,I ) = COLSX_PE( 2,I-1 ) + NCOLS_PE( I ) 
         END IF

C Set NDX to the subdomain row number for processor I
         NDX = ( I - 1 ) / NPCOL + 1

C Calculate number of rows in this PE
         NROWS_PE( I ) = NROWS_SN( NDX )

C Calculate row range of this PE in the global domain
         IF ( I .LE. NPCOL ) THEN
            ROWSX_PE( 1,I ) = 1
            ROWSX_PE( 2,I ) = NROWS_PE( I )
         ELSE
            ROWSX_PE( 1,I ) = ROWSX_PE( 2,I-NPCOL ) + 1
            ROWSX_PE( 2,I ) = ROWSX_PE( 2,I-NPCOL ) + NROWS_PE( I ) 
         END IF

      END DO

      DEALLOCATE ( NCOLS_WE,
     &             NROWS_SN, STAT=ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         XMSG = 'Error deallocating NCOLS_WE or NROWS_SN'
         CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF


      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE LSTEPF ( FNAME, LDATE, LTIME )

C returns the last data date & time on file FNAME
C specifically used only for input files

      USE UTILIO_DEFN

      IMPLICIT NONE
 
C Includes:
 
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

      CHARACTER( 16 ) :: FNAME
      INTEGER      LDATE        ! last file data date, coded YYYYDDD
      INTEGER      LTIME        ! last file data time, coded HHMMSS

C External Functions:
  
C local variables:

      CHARACTER( 16 ) :: PNAME = 'LSTEPF'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER      LSTEP

C-----------------------------------------------------------------------

C open existing file for readonly access

#ifndef mpas
      IF ( .NOT. OPEN3( FNAME, FSREAD3, PNAME ) ) THEN
         XMSG = 'Could not open '// FNAME
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF

      IF ( .NOT. DESC3( FNAME ) ) THEN
         XMSG = 'Could not get ' // FNAME // ' file description'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
         END IF
 
      LSTEP = SEC2TIME( ( MXREC3D - 1 ) * TIME2SEC( TSTEP3D ) )
      LDATE = SDATE3D
      LTIME = STIME3D
      CALL NEXTIME( LDATE, LTIME, LSTEP )
#endif
 
      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C >>> 08/04/2000 Changes necessary to be able to read and process
C two different types of emissions files.
C the first type is the existing opperational PM2.5 & PM10 unspeciated
C file. The new file format has speciated emissions.
C >>> This version uses the FORTRAN 90 feature for runtime memory
C allocation.

C 1/12/99 David Wong at LM:
C   -- introduce new variable MY_NUMBLKS (eliminate NUMBLKS)
C   -- re-calculate NOXYZ accordingly
C FSB Updated for inclusion of surface area / second moment
C 25 Sep 00 (yoj) various bug fixes, cleanup to coding standards
C   Jeff - Dec 00 - move CGRID_MAP into f90 module
C FSB/Jeff - May 01 - optional emissions processing
C   Jerry Gipson - Jun 01 - added SOA linkages for saprc99
C   Bill Hutzell - Jun 01 - simplified CBLK mapping
C   Jerry Gipson - Jun 03 - modified for new soa treatment
C   Jerry Gipson - Aug 03 - removed SOA prod form alkenes & added
C       emission adjustment factors for ALK & TOL ( RADM2 & SAPRC99 only)
C   Shawn Roselle - Jan 04
C   - removed SOA from transported aerosol surface area
C   - fixed bug in calculation of wet parameters.  Previously, DRY aerosol
C      parameters were being written to the AERDIAG files and mislabeled
C      as WET.
C   Prakash Bhave - May 04
C   - changed AERODIAG species (added RH; removed M0 & M2dry)
C   Jeff Young - Jan 05 - dyn alloc
C   - establish both horizontal & vertical domain specifications in one module
c   Uma Shankar and Prakash Bhave - Jun 05
c   - added code to handle the following species: ANAI, ANAJ, ANAK, ACLI,
c     ACLJ, ACLK, ASO4K, AH2OK, ANO3K, and HCL; removed code for ASEAS
c   - removed obsolete MW variables
C   Prakash Bhave - Jul 05 - added PM25 mass-fraction calculations
C   Jeff Young - Feb 06 - trap fractional humidity above 0.005
C   Prakash Bhave - Apr 06 - added GAMMA_N2O5 to the AEROPROC call vector
C       and the aerosol diagnostic file
C   Prakash Bhave - May 06 - changed units of DG variables from m to um in
C       the aerosol diagnostic file as suggested by Dr. Bill Hutzell
C   Sergey Napelenok - Sep 07 - SOA updates
C   - added code to handle the following species: AALKJ, ATOL1J, ATOL2J,
C     ATOL3J, AXYL1J, AXYL2J, AXYL3J, ABNZ1J, ABNZ2J, ABNZ3J, AISO1J, AISO2J,
C     AISO3J, ATRP1J, ATRP2J, ASQTJ, AORGCJ, TOLNRXN, TOLHRXN, XYLNRXN,
C     XYLHRXN, BNZNRXN, BNZHRXN, ISOPRXN, and SESQRXN
C   - removed following species: AORGAI, AORGAJ, AORGBI, AORGBJ, OLIRXN,
C     CSLRXN, TOLRXN, XYLRXN
C   Prakash Bhave - Oct 07 - SOA updates
C   - added semi-volatile vapors to the CBLK array; moved ppm -> ug/m3 unit
C     conversion from the ORGAER subroutine to this program
C   - updated definition of DRY aerosol to include nonvolatile SOA species
C   - removed adjustment factors for TOLAER (SPTOL, RDTOL) because benzene is
C     now an explicit species so all of the reacted TOL can produce SOA
C   - removed code to handle TERPSP (obsolete); renamed TERPRXN as TRPRXN
C   David Wong - Jan 08 - rearranged calculation of dry 3rd moments to avoid
C      NaN on some compilers (using the M3SUBT variable)
C   Prakash Bhave - Jan 08 - updated MECHNAME check from AE4 to AE5
C   Golam Sarwar -  Mar 08 - added a heterogeneous reaction producing HONO
C   Jim Kelly - Apr 08 - coarse mode updates
C   - added code to account for new species (ANH4K & SRFCOR) and variable
C     coarse std. deviation
C   - removed MW coding now located in AERO_INFO.f
C   - added FIXED_sg flag for call to GETPAR
C   Jeff Young - Aug 10 - convert for Namelist redesign (replace include files)
C   Steve Howard - Mar 11 - Renamed met_data to aeromet_data
C   S.Roselle- Mar 11 - replaced I/O API include files with UTILIO_DEFN
C   David Wong - Aug 11 - put in twoway model implementation
C   David Wong - Oct 11 - extended the twoway implementation to handle finer
C                         time resolution
C
C   Bill Hutzell - Sept 13 - inserted module for AEROSOL_CHEMISTRY to support
C                            diagnostic outputs on reaction gamma and yield 
C                            values 
C   HOT Pye - Jan 13 - Additional information for IEPOX aerosol 
C                      written to AERODIAG file
C   David Wong - Aug 15 - Used IO_PE_INCLUSIVE rather than MYPE to facilitate
C                         parallel I/O implementation
C                       - Used a new logical variable, FIRST_CTM_VIS_1 to
C                         determine when to open CTM_VIS_1 
C  B.Hutzell 22 Feb 16 - Added test to determine to write diagnostics from aerosol
C                        chemistry
C  H Pye and B Murphy April 2016 - Updated dry/wet moment process to use
C                        Extract_aero and Update_aero for getting moment/saving surface area
C  D. Wong 10 May 2016 - added calculation of average PMDIAG species w.r.t.
C                        environment variable CTM_PMDIAG, APMDIAG_BLEV_ELEV, 
C                        and AVG_PMDIAG_SPCS
C                      - added calculation of average visibility species w.r.t.
C                        environment variable CTM_AVISDIAG
C                      - renamed AERODIAM to PMDIAG and CTM_AERDIAG to CTM_PMDIAG
C                      - added flexibility to handle AE6 and AE6i
C                      - renamed DIAM to PMDIAG
C  D. Wong 19 May 2016 - renamed ACONC_END_TIME to AVG_FILE_ENDTIME
C                      - updated the way to define NUM_PMDIAG_SPC
C                      - set CTM_PMDIAG default value to .TRUE.
C  D. Wong 31 Jan 2019 - adopted the idea to process all twoway related environment
C                        variables in one place
C    1 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C    1 Aug 19 David Wong: Added a few more variables in the USE Only blcok for two-way model
C   30 Dec 19 S. Napelenok: ddm-3d implementation for v 5.3.1
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AERO ( CGRID, JDATE, JTIME, TSTEP )

      USE GRID_CONF, ONLY: NCOLS, NROWS, NLAYS, IO_PE_INCLUSIVE
      USE AERO_DATA, ONLY: COAG_BUDGET, COND_BUDGET, GROWTH_BUDGET, NPF_BUDGET,
     &                     FIXED_sg, AEROMODE_DIAM, AEROMODE_LNSG, AEROMODE_DENS,
     &                     MOMENT0_CONC, MOMENT2_CONC, MOMENT3_CONC,
     &                     AEROSPC, AEROSPC_CONC, N_MODE, AH2O_IDX,
     &                     EXTRACT_AERO, UPDATE_AERO, CALCMOMENTS
      USE PRECURSOR_DATA, ONLY: SULPRD_IDX, SO4RATE, PRECURSOR_CONC,
     &                          PHGRXN_IDX, PHG_RATE,
     &                          EXTRACT_PRECURSOR, UPDATE_PRECURSOR
      USE SOA_DEFN, ONLY: EXTRACT_SOA, UPDATE_ORGVAPOR
      USE AEROMET_DATA, ONLY: AIRTEMP, AIRPRES, AIRQV, AIRDENS, AIRRH, 
     &                        H2OSATVP, H2OVP, SRFTEMP
      USE CONST, ONLY: ESATL, MWWAT, MWAIR
      USE UTILIO_DEFN, ONLY: XSTAT1, TIME2SEC, SEC2TIME, index1, nextime
#ifdef twoway
     &                       , INDEX1, XSTAT3
#endif
      USE CGRID_SPCS, ONLY: NSPCSD, N_CGRID_SPC
#ifdef twoway
     &                      , N_GC_CONC, GC_CONC, GC_STRT, GC_CONC_MAP
#endif
      USE RUNTIME_VARS, ONLY: LOGDEV, END_TIME
      USE AERO_BUDGET, ONLY: AERO_COAG, AERO_COND, AERO_GROWTH, AERO_NPF

#ifdef twoway
      USE twoway_data_module
#endif
      use CENTRALIZED_IO_MODULE, only : interpolate_var

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, SENGRID
      Use aero_ddm3d, ONLY : s_so4rate, s_precursor_conc, s_aerospc_conc, s_phg_rate
#endif 


      IMPLICIT NONE

C *** Includes:

      INCLUDE SUBST_FILES_ID  ! file name parameters (req IOPARMS)

C *** Arguments:

C *** CGRID is conc field (including gas and aerosol variables)
      REAL, POINTER :: CGRID( :,:,:,: )              !  concentrations
      INTEGER      JDATE        ! Current model date , coded YYYYDDD
      INTEGER      JTIME        ! Current model time , coded HHMMSS
      INTEGER      TSTEP( 3 )   ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency

C *** Local Variables:

      CHARACTER( 16 ), SAVE :: PNAME = 'AERO_DRIVER'
      CHARACTER( 16 ) :: VNAME            ! variable name
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER   MDATE, MTIME, MSTEP  ! julian date, time and
                                     ! timestep in sec
      INTEGER   C, R, L, V, N        ! loop counters
      INTEGER   SPC                  ! species loop counter
      INTEGER   STRT, FINI           ! loop induction variables
      INTEGER   ALLOCSTAT            ! memory allocation status

      LOGICAL   LERROR               ! Error flag

C *** Grid Description
      REAL DX1                 ! Cell x-dimension
      REAL DX2                 ! Cell y-dimension

C *** Variable to set time step for writing visibility file
      INTEGER, SAVE :: WSTEP  = 0   ! local write counter

C *** meteorological variables
      REAL PRES   ( NCOLS,NROWS,NLAYS )  ! Atmospheric pressure [ Pa ]
      REAL TA     ( NCOLS,NROWS,NLAYS )  ! Air temperature [ K ]
      REAL TEMP2  ( NCOLS,NROWS )        ! 2-meter temperature [ K ]
      REAL DENS   ( NCOLS,NROWS,NLAYS )  ! Air density [ kg/m**-3 ]
      REAL QV     ( NCOLS,NROWS,NLAYS )  ! Water vapor mixing ratio [ kg/kg ]

C *** variables computed and output but not carried in CGRID

C *** atmospheric properties
      REAL XLM             ! atmospheric mean free path [ m ]
      REAL AMU             ! atmospheric dynamic viscosity [ kg/m s ]

C *** mass fraction of each mode less than Specified Aerodynamic Diameters
      REAL fPM1 ( N_MODE )  ! PM1 fraction
      REAL fPM25( N_MODE )  ! PM2.5 fraction
      REAL fPM10( N_MODE )  ! PM10 fraction
      REAL fAMS ( N_MODE )  ! AMS Transmission Fraction

C *** visual range information
      REAL BLKDCV1         ! block deciview (Mie)
      REAL BLKEXT1         ! block extinction [ km**-1 ] (Mie)

      REAL BLKDCV2         ! block deciview (Reconstructed)
      REAL BLKEXT2         ! block extinction [ km**-1 ] (Reconstructed)


C *** other internal aerosol variables
      INTEGER IND                         ! index to be used with INDEX1
      INTEGER IM

C *** synchronization time step [ s ]
      REAL DT

C *** variables to set up for "dry transport "
      REAL M3_WET( N_MODE ), M3_DRY( N_MODE )   ! third moment with and without water
      REAL M2_WET( N_MODE ), M2_DRY( N_MODE )   ! second moment with and without water

C *** variables aerosol diagnostic file flag
      INTEGER      STATUS            ! ENV... status
      CHARACTER( 80 ) :: VARDESC     ! environment variable description

C *** first pass flag
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

C *** ratio of molecular weights of water vapor to dry air = 0.622015
      REAL, PARAMETER :: EPSWATER = MWWAT / MWAIR

C *** dry moment factor
      REAL, PARAMETER :: TWOTHIRDS = 2.0 / 3.0

      LOGICAL :: TIME_TO_CALL_FEEDBACK_WRITE
      INTEGER, SAVE :: O3

#ifdef twoway
      INTERFACE
        SUBROUTINE FEEDBACK_WRITE (C, R, L, CGRID_DATA, O3_VALUE, JDATE, JTIME)
          REAL, INTENT( IN ) :: CGRID_DATA(:), O3_VALUE
          INTEGER, INTENT( IN ) :: C, R, L, JDATE, JTIME
        END SUBROUTINE FEEDBACK_WRITE
      END INTERFACE
#endif

C ------------------ begin body of AERO_DRIVER -------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         ALLOCATE ( AERO_COND(   NCOLS,NROWS,NLAYS,NSPCSD ),
     &              AERO_COAG(   NCOLS,NROWS,NLAYS,NSPCSD ),
     &              AERO_NPF (    NCOLS,NROWS,NLAYS,NSPCSD ),
     &              AERO_GROWTH ( NCOLS,NROWS,NLAYS,NSPCSD ),
     &              COND_BUDGET( NSPCSD ),
     &              COAG_BUDGET( NSPCSD,N_MODE ),
     &              NPF_BUDGET( NSPCSD ),
     &              GROWTH_BUDGET( NSPCSD ),
     &              STAT=ALLOCSTAT)

#ifdef twoway
! -- this is for twoway
         VNAME = 'O3'
         N = INDEX1( VNAME, N_GC_CONC, GC_CONC )
         IF ( N .NE. 0 ) THEN
            O3 = GC_STRT - 1 + GC_CONC_MAP( N )
         ELSE
            XMSG = 'Could not find ' // VNAME // 'in gas chem aerosol table'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF
#endif

      END IF    ! FIRSTIME

      MDATE  = JDATE
      MTIME  = JTIME
      MSTEP = TIME2SEC( TSTEP( 2 ) )
      CALL NEXTIME ( MDATE, MTIME, SEC2TIME( MSTEP / 2 ) )

C *** Set floating point synchronization time step:
      DT = FLOAT( MSTEP ) ! set time step in seconds

C *** Get Meteorological Variables

C *** pressure [Pa]
      call interpolate_var ('PRES', mdate, mtime, PRES)

C *** temperature [K]
      call interpolate_var ('TA', mdate, mtime, TA)       ! Grid Cell Temp
      call interpolate_var ('TEMP2',mdate, mtime, TEMP2 ) ! 2-m Temp

C *** specific humidity [g H2O/g air]
      call interpolate_var ('QV', mdate, mtime, QV)

C *** air density [kg/m3]
      call interpolate_var ('DENS', mdate, mtime, DENS)

#ifdef twoway
! call FEEDBACK_WRITE when JTIME is mulitple of WRF time step
      IF ( CMAQ_WRF_FEEDBACK ) THEN
         IF ( MOD( TIME2SEC(MOD( JTIME, 10000 )), TIME2SEC(TSTEP( 3 )) ) .EQ. 0 ) THEN
            TIME_TO_CALL_FEEDBACK_WRITE = .TRUE.
         ELSE
            TIME_TO_CALL_FEEDBACK_WRITE = .FALSE.
         END IF
      END IF
#endif

! *** Initialize Shared Arrays for Aerosol Budget
      AERO_COND     = 0.
      AERO_COAG     = 0.
      AERO_NPF      = 0.
      AERO_GROWTH   = 0.

C --------------------- Begin loops over grid cells --------------------------

      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS

C *** Grid cell meteorological data.
               AIRTEMP  = TA   ( C,R,L )
               SRFTEMP  = TEMP2( C,R )     ! 2-meter temperature (K)
               AIRPRES  = PRES ( C,R,L )   ! Note pascals
               AIRQV    = QV   ( C,R,L )
               AIRDENS  = DENS ( C,R,L )
               H2OSATVP = ESATL( AIRTEMP )
               H2OVP    = AIRPRES * AIRQV / ( EPSWATER  + AIRQV )
               AIRRH    = MAX( 0.005, MIN( 0.99, H2OVP / H2OSATVP ) ) ! 0-1

! *** Initialize aerosol process variables
               COND_BUDGET = 0.
               COAG_BUDGET = 0.
               NPF_BUDGET = 0.
               GROWTH_BUDGET = 0.

C *** Extract grid cell concentrations of aero species from CGRID
C     into aerospc_conc in aero_data module (set minimum)
#ifdef sens
               CALL EXTRACT_AERO( CGRID( C,R,L,: ), .TRUE., SENGRID( C,R,L,:,: ), .TRUE. )
#else
               CALL EXTRACT_AERO( CGRID( C,R,L,: ), .TRUE. )
#endif

C *** Extract grid cell concentrations of gas precursors from CGRID (ppm)
C     into precursr_conc in precursor_data
#ifdef sens
               CALL EXTRACT_PRECURSOR( CGRID( C,R,L,: ), SENGRID( C,R,L,:,: ) )
#else
               CALL EXTRACT_PRECURSOR( CGRID( C,R,L,: ) )
#endif

C *** Calculate SO4RATE stored in module
               SO4RATE = REAL( PRECURSOR_CONC( SULPRD_IDX ), 4 ) / DT
#ifdef sens
               DO NP = 1, NPMAX
                  S_SO4RATE( NP ) =  S_PRECURSOR_CONC( SULPRD_IDX,NP ) / DT
               END DO
#endif
               IF ( PHGRXN_IDX .GT. 0 ) THEN
C *** Calculate PHG_RATE stored in module
                  PHG_RATE = REAL( PRECURSOR_CONC( PHGRXN_IDX ), 4 ) / DT
#ifdef sens
                  DO NP = 1, NPMAX
                     S_PHG_RATE( NP ) = S_PRECURSOR_CONC( PHGRXN_IDX,NP ) / DT
                  END DO
#endif
               ELSE
                  PHG_RATE = 0.0
#ifdef sens
                  S_PHG_RATE = 0.0
#endif
          END IF

C *** Extract soa concentrations from CGRID and 
C     convert M2 to wet
#ifdef sens
               CALL EXTRACT_SOA( CGRID( C,R,L,: ), SENGRID( C,R,L,:,: ), .TRUE. )
#else
               CALL EXTRACT_SOA( CGRID( C,R,L,: ) )
#endif

C *** Aerosol process routines
               CALL AEROPROC( DT, C, R, L )

C *** Update aerosol variables conc back into CGRID (set minimum) 
C     and convert M2 to dry and save as surface area
#ifdef sens
               CALL UPDATE_AERO( CGRID( C,R,L,: ), .TRUE., SENGRID(C,R,L,:,: ) )
#else
               CALL UPDATE_AERO( CGRID( C,R,L,: ), .TRUE. )
#endif

C *** Update precursor variables conc back into CGRID
#ifdef sens
               CALL UPDATE_PRECURSOR( CGRID( C,R,L,: ), SENGRID( C,R,L,:,: ) )
#else
               CALL UPDATE_PRECURSOR( CGRID( C,R,L,: ) )
#endif

C *** Update gas soa concentrations back to CGRID
#ifdef sens
               CALL UPDATE_ORGVAPOR( CGRID( C,R,L,: ), SENGRID( C,R,L,:,: ) )
#else
               CALL UPDATE_ORGVAPOR( CGRID( C,R,L,: ) )
#endif

C *** OUTPUT DIAGNOSTIC INFORMATION
C *** Get wet moment info (dry will be converted to wet)
               CALL calcmoments( .true. )
               CALL GETPAR( FIXED_sg ) ! update AEROMODE_DIAM,DENS,SDEV

! *** Calculate 2nd and 3rd moments of the "dry" aerosol distribution
!     NOTE! "dry" aerosol excludes both H2O and SOA  (Jan 2004 --SJR)
!     EXCEPT nonvolatile SOA is part of dry aerosol (Oct 2007 --PVB)
!               CALL CALCMOMENTS( .FALSE. )
!               CALL GETPAR( FIXED_sg ) ! update AEROMODE_DIAM,DENS,SDEV

! *** Collect Aerosol Sub-Process Rates in shared arrays
               DO V = 1,N_CGRID_SPC
                  AERO_COAG  ( C,R,L,V ) = SUM( COAG_BUDGET( V,: ) )
                  AERO_COND  ( C,R,L,V ) = COND_BUDGET( V )
                  AERO_NPF   ( C,R,L,V ) = NPF_BUDGET( V )
                  AERO_GROWTH( C,R,L,V ) = GROWTH_BUDGET( V )
               END DO
#ifdef twoway
               IF ( CMAQ_WRF_FEEDBACK ) THEN
                  IF ( TIME_TO_CALL_FEEDBACK_WRITE ) THEN
                     CALL FEEDBACK_WRITE ( C, R, L, CGRID(C,R,L,:), CGRID(C,R,L,O3),
     &                                     JDATE, JTIME )
                  END IF
               END IF
#endif

            END DO ! loop on COLS
         END DO ! loop on ROWS
      END DO ! loop on NLAYS

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module aero_data

C  Defines aerosol species arrays and the parameters required in aerosol
C  processing.

C  Contains:
C     Subroutine map_aero
C     Subroutine extract_aero
C     Subroutine update_aero
C     Function findAero

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C HS = Heather Simon; GS = Golam Sarwar; SH = Steve Howard; SR = Shawn Roselle;
C JY = Jeff Young; HOTP = Havala Pye; KF = Kathleen Fahey, CGN = Chris Nolte;
C PL = Peng Liu; BM = Ben Murphy; BH = Bill Hutzell, NS = Nash Skipper

C HS  01/24/11 Updated to initial AERO6; PMOTHR -> 9 species
C GS  03/02/11 Revised parameters for Mg, K, and Ca
C SH  03/10/11 Inserted functionality of PMEM_DEFN
C    -new subroutine map_pmemis
C HS  03/10/11 Made PNCOM a required species
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C SH  04/04/11 Added sea-salt speciation factors
C GS  04/09/11 Updated sea-salt speciation; replaced ANAK with ASEACAT;
C              made MG, K, CA, SEACAT required species;
C JY  04/21/11 Added optional log messages (verbose_aero)
C JY  05/02/11 Added Reshape to aerospc_ssf initialization for pgf90 compiler
C BH  08/31/11 Adapted for mercury and HAP mechanisms
C JY  06/08/12 remove full character blank padding put in for GNU Fortran (GCC) 4.1.2
C HOTP 01/16/13 Removed isoprene acid enhanced aerosol and added new isoprene aerosol
C HOTP 01/18/13 Added information for particle phase reaction of isoprene products
C               based on Eddingsaas et al. 2010
C KF  09/17/14 Changed emitted modal PM mass fractions and geometric mean diameter and
C              geometric standard deviation of emitted particles according to
C              Elleman and Covert (2010)
C HOTP 09/27/14 Added alkane and PAH SOA species. PAH SOA densities follow Chan et al.
C JY  08/24/15 Changed visual index factors
C HOTP 2/17/2016 Updated SOA densities. BTX follows Ng et al. 2007.
C                1.4 g/cm3 used by default.
C JY  02/17/16 Created named constants for speciation and other factors for AERO_EMIS,
C              DUST_EMIS, aero_subs:VOLINORG, and aqchem
C CGN 04/14/16 Changed AMGJ speciation factor from 0.0 to 0.019 following Upadhyay et al.
C HOTP,BM  5/20/16 Updated to work with all ae6 mechs (6, 6i, 6mp)
C PL 05/15/16 Update visual_idx, and add visual_idx_large in spcs_type, due to ammonium sulfate, nitrate and OM
C             are split into small and large modes.
C             visual_idx for ammonium is zero, because it will be treated together with sulfate and nitrate
C             see Pitchford et al., Journal of the Air & Waste Management Association (57)(2007), pp 1326
C PL 05/15/16 Add "om" in spcs_type, to flag organic aerosols, which
C             will be used to calculate total mass of organic aerosls for estimating
C             aerosol extinction efficiency
C HOTP 7/17/2018 Added kappaorg hygroscopicity parameter (Petters and
C             Kreidenweis 2007 ACP) for organic aerosols. kappa should be zero for
C             species that are not organic. Water uptake onto inorganics calculated using ISORROPIA.
C             POC+NCOM kappa is set to zero and calculated in SOA_DEFN if those species are in use.
C             Current kappaorg values are based on species specific
C             OM/OC ratios (Pye et al. 2017 ACP).
C GS  08/17/81 Added bromide in seasalt
C SR 12/14/2018 Added sulfur tracking option
C SLN 12/30/2019 ddm-3d implementaiton for v 5.3.1
C     10 Mar 2021 G. Sarwar: Changed CB6R3M_AE7_KMTBR to CB6R3M_AE7_AQ
C     10 June 2021 G. Sarwar: Added CB6R5M_AE7_AQ
C 23 Jun 21 G. Sarwar: Replaced CB6R3M with CB6R5M
C NS 11/28/2023 CRACMM2 updates
C GS 07/31/2024  Added ASEAST

C References:
C 1. Eddingsaas, N. C., Vandervelde, D. G., Wennberg, P. O., "Kinetics and
C    products of the acid-catalyzed ring-opening of atmospherically relevant
C    butyl epoxy alcohols," J. Phys. Chem. A., 2010, 114, 8106-8113.
C 2. Chan, et al., "Secondary organic aerosol formation from photooxidation
C    of naphthalene and alkylnaphthalenes: implications for oxidation of
C    intermediate volatility organic compounds (IVOCs)", Atmos. Chem. Phys.,
C    2009, 9, 3049-3060.
C 3. Ng, N. L., Kroll, J. H., Chan, A. W. H., Chhabra, P. S., Flagan, R.
C    C., and Seinfeld, J. H.: Secondary organic aerosol formation from
C    m-xylene, toluene, and benzene, Atmos. Chem. Phys., 7, 3909-3922,
C    doi:10.5194/acp-7-3909-2007, 2007.
C 4. Elleman and Covert, "Aerosol size distribution modeling with the Community Multiscale
C    Air Quality modeling system in the Pacific Northwest: 3. Size distribution of
C    particles emitted into a mesoscale model", JGR, 115, D03204, 2010
C 5. Simon, et al., "The development and uses of EPA's SPECIATE database",
C    Atmos. Poll. Res., 1, 196-206, 2010
C 6. Upadhyay, et al., "Size-Differentiated Chemical Composition of Re-Suspended Soil
C    Dust from the Desert Southwest United States," Aero. and AQ Res., 2015, 387-398

C JY: From Christian Hogrefe...
C Based on Malm and Hand (Atmos. Env. 41, 3407-3427, 2007), the revised
C IMPROVE extinction calculation includes coarse particles, sea salt, and
C a relative humidity correction for sea salt. Also, the factor for "LAC"
C (light absorbing carbon, i.e. AECI and AECJ) should be 10, not 0 since
C both scattering and absorption contribute to total extinction.
C ASEACAT includes all sea-salt cations in coarse mode (Na, Ca, K, and Mg)
C Also note...
C In the Fortran user-derived spcs_type, below, visual_idx is an optimal dry mass
C extinction efficiency [m^2/g], see White, Atmos.Env., 294(10)(1990), pp 2673-1672
C and Malm, et al., JGR, 99(D1)(1994), pp 1347-1370
C----------------------------------------------------------------------
      USE RUNTIME_VARS
      Use utilio_defn
#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX
      Use aero_ddm3d, ONLY : s_aerospc_conc, ae_ddm3d_ready,
     &                       init_aero_ddm3d
#endif 


      Implicit None

C Define Logical values as T and F for the aerospc table
      Logical, Parameter, Private :: T = .true.
      Logical, Parameter, Private :: F = .false.

C Number of aerosol species and modes

      Integer, Parameter :: n_aerolist = 182    ! number of aero species
      Integer, Parameter :: n_mode = 3          ! number of modes:
      Integer, Parameter :: iait = 1            ! 1 = Aitken       
      Integer, Parameter :: iacc = 2            ! 2 = accumulation 
      Integer, Parameter :: icor = 3            ! 3 = coarse       
      
      Logical, Parameter :: reqd_modes( n_mode ) = (/ T,T,T /)
      Character(1), Parameter :: modesuff( n_mode ) = (/ 'I','J','K' /)
      Character(6), Parameter :: modename( n_mode ) = (/'AITKEN','ACCUM ','COARSE'/)

      Integer, Save :: n_aerospc ! number of aero species

C Default minimum concentration
      Real,    Parameter :: conmin  = 1.0E-23    ! [ ug m-3 ]
      Real(8), Parameter :: conminD = 1.0D-23    ! [ ug m-3 ]
      Real,    Parameter :: evapmin = 1.0E-20    ! [ ug m-3 ]
      Real(8), Parameter :: evapminD= 1.0D-20    ! [ ug m-3 ]
      Real,    Parameter :: cm_set( n_mode ) = (/conmin, conmin, conmin/)
      Real,    Parameter :: cm_so4( n_mode ) = (/conmin, conmin, conmin/)
      Real,    Parameter :: cm_cor( n_mode ) = (/conmin, conmin, conmin/)

      Real,    Parameter :: def_diam( n_mode )   = (/ 15.0E-9, 80.0E-9,  600.0E-9 /)  ! default background mean diameter for each mode
      Real,    Parameter :: min_dg_dry( n_mode ) = (/ 1.0E-9,  30.0E-9,  120.0E-9 /)
      Real,    Parameter :: max_dg_dry( n_mode ) = (/ 80.0E-9, 500.0E-9, 100.0E-6 /)
      Real,    Parameter :: min_dg_wet( n_mode ) = (/ 1.0E-9,  30.0E-9,  120.0E-9 /)
      Real,    Parameter :: max_dg_wet( n_mode ) = (/ 160.0E-9,1500.0E-9,300.0E-6 /)

      Real,    Parameter :: def_sigma_g( n_mode ) = (/ 1.70, 2.0, 2.2 /)       ! default background sigma-g for each mode
      Real,    Parameter :: min_sigma_g = 1.05
      Real,    Parameter :: max_sigma_g = 2.5001
      Real,    Save      :: def_l2sg( n_mode ), max_l2sg, min_l2sg   

C If FIXED_sg = T, atkn & accum std. dev. are not changed by GETPAR
C If FIXED_sg = F, the second moment will be adjusted if the standard
C                  deviation (sigma_g) is outside of the bounds specified 
C                  by min_sigma_g and max_sigma_g.
      LOGICAL, PARAMETER :: FIXED_sg = .FALSE.

C Flag to obtain coagulation coefficients
C by analytical approximation (True) or by Gauss-Hermite quadrature (False)
      Logical, Parameter :: fastcoag_flag = .True.
      Integer, Parameter :: coag_moments = 2      ! Number of moments to consider 
                                                  ! for coagulation 
                                                  ! 2 = number and volume
                                                  ! 3 = number, volume, and surface area

C-------------------------------------------------------------------------------------------------------

      Type spcs_type
         Character( 16 ) :: name( n_mode )       ! mode-dependent names of aerosol species
         Character( 16 ) :: bulkname             ! mode-independent names of aerosol species
         Logical         :: lait                 ! Available in Aitken Mode
         Logical         :: lacc                 ! Available in Accumulation Mode
         Logical         :: lcor                 ! Available in Coarse Mode
         Real            :: min_conc( n_mode )   ! minimum concentration values for each mode
         Real            :: density              ! density [ kg m-3 ]
         Character( 16 ) :: gasname              ! Gas species in equilibrium with this aerosol component
         Character( 16 ) :: ctrname              ! Rxn Counter Species used to calculate production of 
                                                 !   this component if irreversible partitioning is assumed
         Real            :: ctr_yield            ! Yield of Reaction Counter when forming condensed mass
         Character( 3  ) :: voltype              ! Type of production to be implemented for this species. 
                                                 !   Options are: REV = Reversible, IRV = Irreversible, 
                                                 !                NVL = Nonvolatile
         Logical         :: no_M2Wet             ! flag to exclude from 2nd moment during transport
         Logical         :: tracer               ! tracer flag; does have not mass
         Integer         :: charge               ! electroneutrality charge
         Real            :: visual_idx           ! visual index factor [ m2 g-1 ]
         Real            :: visual_idx_large     ! visual index factor [ m2 g-1 ] for large mode, if not applicable, same value as visual_idx
         Logical         :: om                   ! flag for organic aerosols
         Character( 16 ) :: optic_surr           ! optical surrogate name
         Real            :: kappaorg             ! hygroscopicity parameter for organic aerosol (excluding POC+NCOM which must be calculated)
      End Type spcs_type
      Type( spcs_type ), Allocatable, Save :: aerospc ( : )
 

      ! Master List of Aerosol Species and Properties
      Type spcs_list_type
         Character( 16 ) :: bulkname             ! mode-independent names of aerosol species
         Logical         :: lait                 ! Available in Aitken Mode
         Logical         :: lacc                 ! Available in Accumulation Mode
         Logical         :: lcor                 ! Available in Coarse Mode
         Real            :: min_conc( n_mode )   ! minimum concentration values for each mode
         Real            :: density              ! density [ kg m-3 ]
         Character( 16 ) :: gasname              ! Gas species in equilibrium with this aerosol component
         Character( 16 ) :: ctrname              ! Rxn Counter Species used to calculate production of 
                                                 !   this component if irreversible partitioning is assumed
         Real            :: ctr_yield            ! Yield of Reaction Counter when forming condensed mass
         Character( 3  ) :: voltype              ! Type of production to be implemented for this species. 
                                                 !   Options are: REV = Reversible, IRV = Irreversible, 
                                                 !                NVL = Nonvolatile
         Logical         :: no_M2Wet             ! flag to exclude from 2nd moment during transport
         Logical         :: tracer               ! tracer flag; does have not mass
         Integer         :: charge               ! electroneutrality charge
         Real            :: visual_idx           ! visual index factor [ m2 g-1 ]
         Real            :: visual_idx_large     ! visual index factor [ m2 g-1 ] for large mode, if not applicable, same value as visual_idx
         Logical         :: om                   ! flag for organic aerosols
         Character( 16 ) :: optic_surr           ! optical surrogate name
         Real            :: kappaorg             ! hygroscopicity parameter for organic aerosol (excluding POC+NCOM which must be calculated)
      End Type spcs_list_type

      Type( spcs_list_type ), Parameter :: aerolist( n_aerolist ) = (/
C                                                                                           Visidx_Large
C                                                                               no_M2Wet Tracer        |
C                                                                                       | | Charge      | OM           
C                      Name      T A C Min_Con Density Gas-Name   CTR-Name  Yield Vol   | |   | Visidx  |  |  OptSurr   korg  
C                     ---------- - - - ------- ------- ---------- --------- ----- ----- + +   + ------ --- +  -------- ----- 
     & spcs_list_type('ASO4    ',T,T,T, cm_so4, 1800.0, 'SULF   ','SULRXN ',1.0  ,'IRV',F,F, -2,  2.2, 4.8,F, 'SOLUTE', 0.00), ! Sulfate
     & spcs_list_type('ANO3    ',T,T,T, cm_set, 1800.0, 'HNO3   ','       ',0.0  ,'REV',F,F, -1,  2.4, 5.1,F, 'SOLUTE', 0.00), ! Nitrate
     & spcs_list_type('ACL     ',T,T,T, cm_set, 2200.0, 'HCL    ','       ',0.0  ,'REV',F,F, -1,  1.7, 1.7,F, 'SOLUTE', 0.00), ! Chloride
     & spcs_list_type('ANH4    ',T,T,T, cm_set, 1800.0, 'NH3    ','       ',0.0  ,'REV',F,F,  1,  0.0, 0.0,F, 'SOLUTE', 0.00), ! Ammonium
     & spcs_list_type('ANA     ',T,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  1,  1.7, 1.7,F, 'SOLUTE', 0.00), ! Sodium
     & spcs_list_type('AMG     ',F,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  2,  1.0, 1.0,F, 'DUST  ', 0.00), ! Magnesium
     & spcs_list_type('AK      ',F,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  1,  1.0, 1.0,F, 'DUST  ', 0.00), ! Potassium
     & spcs_list_type('ACA     ',F,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  2,  1.0, 1.0,F, 'DUST  ', 0.00), ! Calcium
     & spcs_list_type('APOC    ',T,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.00), ! POA Carbon
     & spcs_list_type('APNCOM  ',T,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.00), ! POA Non-Carbon          #10
     & spcs_list_type('AEC     ',T,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  0, 10.0,10.0,F, 'SOOT  ', 0.00), ! Elemental (Black) Carbon
     & spcs_list_type('AFE     ',F,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Iron
     & spcs_list_type('AOTHR   ',T,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Other 
     & spcs_list_type('AAL     ',F,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Aluminum
     & spcs_list_type('ASI     ',F,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Silicon
     & spcs_list_type('ATI     ',F,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Titanium
     & spcs_list_type('AMN     ',F,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Manganese
     & spcs_list_type('AH2O    ',T,T,T, cm_set, 1000.0, '       ','       ',0.0  ,'H2O',T,F,  0,  0.0, 0.0,F, 'WATER ', 0.00), ! Water
     & spcs_list_type('AORGH2O ',F,T,F, cm_set, 1000.0, '       ','       ',0.0  ,'H2O',T,F,  0,  0.0, 0.0,F, 'WATER ', 0.00), ! Organic Water
     & spcs_list_type('AH3OP   ',T,T,T, cm_set, 1000.0, '       ','       ',0.0  ,'H2O',T,T,  0,  0.0, 0.0,F, 'WATER ', 0.00), ! Hydronium               #20
     & spcs_list_type('AALK1   ',F,T,F, cm_set, 1400.0, 'SVALK1 ','ALKRXN ',.0334,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.07), ! Alkane SOA 1            
     & spcs_list_type('AALK2   ',F,T,F, cm_set, 1400.0, 'SVALK2 ','ALKRXN ',.2164,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.06), ! Alkane SOA 2
     & spcs_list_type('AXYL1   ',F,T,F, cm_set, 1480.0, 'SVXYL1 ','XYLNRXN',.0310,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.17), ! Xylene SOA 1
     & spcs_list_type('AXYL2   ',F,T,F, cm_set, 1480.0, 'SVXYL2 ','XYLNRXN',.0900,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.11), ! Xylene SOA 2
     & spcs_list_type('AXYL3   ',F,T,F, cm_set, 1330.0, '       ','XYLHRXN',.3600,'IRV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Xylene SOA 3
     & spcs_list_type('ATOL1   ',F,T,F, cm_set, 1240.0, 'SVTOL1 ','TOLNRXN',.0580,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Toluene SOA 1
     & spcs_list_type('ATOL2   ',F,T,F, cm_set, 1240.0, 'SVTOL2 ','TOLNRXN',.1130,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.10), ! Toluene SOA 2
     & spcs_list_type('ATOL3   ',F,T,F, cm_set, 1450.0, '       ','TOLHRXN',.3000,'IRV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.20), ! Toluene SOA 3
     & spcs_list_type('ABNZ1   ',F,T,F, cm_set, 1400.0, 'SVBNZ1 ','BNZNRXN',.0720,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.19), ! Benzene SOA 1
     & spcs_list_type('ABNZ2   ',F,T,F, cm_set, 1400.0, 'SVBNZ2 ','BNZNRXN',.8880,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Benzene SOA 2           #30
     & spcs_list_type('ABNZ3   ',F,T,F, cm_set, 1400.0, '       ','BNZHRXN',.3700,'IRV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.23), ! Benzene SOA 3           
     & spcs_list_type('ATRP1   ',F,T,F, cm_set, 1400.0, 'SVTRP1 ','TRPRXN ',.1393,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.10), ! Terpene SOA 1
     & spcs_list_type('ATRP2   ',F,T,F, cm_set, 1400.0, 'SVTRP2 ','TRPRXN ',.4542,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.10), ! Terpene SOA 2
     & spcs_list_type('AISO1   ',F,T,F, cm_set, 1400.0, 'SVISO1 ','ISOPRXN',.2320,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.14), ! Isoprene SOA 1
     & spcs_list_type('AISO2   ',F,T,F, cm_set, 1400.0, 'SVISO2 ','ISOPRXN',.0288,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Isoprene SOA 2
     & spcs_list_type('AISO3   ',F,T,F, cm_set, 1400.0, '       ','       ',.0000,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.21), ! Isoprene SOA 3
     & spcs_list_type('ASQT    ',F,T,F, cm_set, 1400.0, 'SVSQT  ','SESQRXN',1.537,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.07), ! Sesquiterpene SOA
     & spcs_list_type('AHOM    ',F,T,F, cm_set, 1400.0, 'HOM    ','       ',0.0 ,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.13), ! HOM SOA
     & spcs_list_type('AELHOM  ',F,T,F, cm_set, 1400.0, 'ELHOM  ','       ',0.0 ,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.09), ! ELHOM SOA
     & spcs_list_type('APAH1   ',F,T,F, cm_set, 1480.0, 'SVPAH1 ','PAHNRXN',0.210,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.08), ! PAH SOA 1
     & spcs_list_type('APAH2   ',F,T,F, cm_set, 1480.0, 'SVPAH2 ','PAHNRXN',1.070,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.06), ! PAH SOA 2
     & spcs_list_type('APAH3   ',F,T,F, cm_set, 1550.0, '       ','PAHHRXN',0.730,'IRV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.09), ! PAH SOA 3               #40
     & spcs_list_type('AOLGA   ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.18), ! Anth. Oligomer SOA      
     & spcs_list_type('AOLGB   ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.13), ! Biogenic Oligomer SOA
     & spcs_list_type('AORGC   ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.12), ! Cloud-Processed SOA
     & spcs_list_type('ASOIL   ',F,F,T, cm_set, 2600.0, '       ','       ',0.0  ,'NVL',F,F,  0,  0.6, 0.6,F, 'DUST  ', 0.00), ! Soil
     & spcs_list_type('ACORS   ',F,F,T, cm_cor, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  0,  0.6, 0.6,F, 'DUST  ', 0.00), ! Coarse PM
     & spcs_list_type('ASEACAT ',F,F,T, cm_cor, 2200.0, '       ','       ',0.0  ,'NVL',F,F,  1,  1.7, 1.7,F, 'SOLUTE', 0.00), ! SeaSpray Cations
     & spcs_list_type('ASEAST  ',F,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T, -1,  1.7, 1.7,F, 'SOLUTE', 0.00), ! seasalt tracer        
                                                                                         
       ! Associated with ae6i                                                                
     & spcs_list_type('AMTNO3  ',F,T,F, cm_set, 1400.0, 'MTNO3  ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.11), ! Monoterpene Nitrate SOA
     & spcs_list_type('AISOPNN ',F,T,F, cm_set, 1400.0, 'ISOPNN ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.32), ! Isoprene Nitrate SOA
     & spcs_list_type('AMTHYD  ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.07), ! 
     & spcs_list_type('AIETET  ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Iso. Tetrol SOA         #50
     & spcs_list_type('AIEOS   ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.30), ! Iso. Organosulfate SOA  
     & spcs_list_type('ADIM    ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.13), !
     & spcs_list_type('AIMGA   ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.18), !
     & spcs_list_type('AIMOS   ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.36), !

       ! Associated with cracmm1
     & spcs_list_type('AISO3NOS',F,T,F,cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Iso. nonsulfated SOA
     & spcs_list_type('AISO3OS ',F,T,F,cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.30), ! Iso. Organosulfate SOA

       ! Updated monoterpene SOA following Saha and Grieshop ES&T 2016                  
     & spcs_list_type('AMT1    ',F,T,F, cm_set, 1400.0, 'SVMT1  ','TRPRXN ',0.040,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.08), ! MT SOA Lowest Volatility
     & spcs_list_type('AMT2    ',F,T,F, cm_set, 1400.0, 'SVMT2  ','TRPRXN ',0.032,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.08), ! 
     & spcs_list_type('AMT3    ',F,T,F, cm_set, 1400.0, 'SVMT3  ','TRPRXN ',0.032,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.09), !
     & spcs_list_type('AMT4    ',F,T,F, cm_set, 1400.0, 'SVMT4  ','TRPRXN ',0.103,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.07), !
     & spcs_list_type('AMT5    ',F,T,F, cm_set, 1400.0, 'SVMT5  ','TRPRXN ',0.143,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.07), !
     & spcs_list_type('AMT6    ',F,T,F, cm_set, 1400.0, 'SVMT6  ','TRPRXN ',0.285,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.05), !                         #60
     & spcs_list_type('AMT7    ',F,T,F, cm_set, 1400.0, 'SVMT7  ','TRPRXN ',0.160,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.06), ! MT SOA Highest Volatility
                                                                                       
       ! ae6i and cb6                                                                 
     & spcs_list_type('AGLY    ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.13), ! Glyoxal SOA
                                                                                      
       ! Semivolatile POA                                                             
     & spcs_list_type('ALVPO1  ',T,T,F, cm_set, 1400.0, 'VLVPO1 ','       ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.05), ! LV-POA
     & spcs_list_type('ASVPO1  ',T,T,F, cm_set, 1400.0, 'VSVPO1 ','       ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.05), ! SV-POA 1
     & spcs_list_type('ASVPO2  ',T,T,F, cm_set, 1400.0, 'VSVPO2 ','       ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.04), ! SV-POA 2
     & spcs_list_type('ASVPO3  ',F,T,F, cm_set, 1400.0, 'VSVPO3 ','       ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.03), ! SV-POA 3
     & spcs_list_type('AIVPO1  ',F,T,F, cm_set, 1400.0, 'VIVPO1 ','       ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.03), ! IV-POA 
     & spcs_list_type('ALVOO1  ',T,T,F, cm_set, 1400.0, 'VLVOO1 ','       ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.15), ! LV-SOA 1                
     & spcs_list_type('ALVOO2  ',T,T,F, cm_set, 1400.0, 'VLVOO2 ','       ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.13), ! LV-SOA 2
     & spcs_list_type('ASVOO1  ',T,T,F, cm_set, 1400.0, 'VSVOO1 ','       ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.11), ! SV-SOA 1                #70
     & spcs_list_type('ASVOO2  ',T,T,F, cm_set, 1400.0, 'VSVOO2 ','       ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.09), ! SV-SOA 2
     & spcs_list_type('ASVOO3  ',F,T,F, cm_set, 1400.0, 'VSVOO3 ','       ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.08), ! SV-SOA 3
     & spcs_list_type('APCSO   ',F,T,F, cm_set, 1400.0, 'LVPCSOG','PCSOARXN',1.0 ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.12), ! pcSOA
                                                                                  
       ! Lumped anthropogenic SOA (introduced aero7, M. Qin, 8/2018)
     & spcs_list_type('AAVB1   ',F,T,F, cm_set, 1400.0, 'SVAVB1 ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.20),
     & spcs_list_type('AAVB2   ',F,T,F, cm_set, 1400.0, 'SVAVB2 ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15),
     & spcs_list_type('AAVB3   ',F,T,F, cm_set, 1400.0, 'SVAVB3 ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.14),
     & spcs_list_type('AAVB4   ',F,T,F, cm_set, 1400.0, 'SVAVB4 ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.12),
                                                          
       ! CRACMM SVOCs and LVOCs                                                             
     & spcs_list_type('AOP3      ',F,T,F,cm_set,1400.0,'OP3      ','      ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.05), ! 
     & spcs_list_type('AROCN2ALK ',T,T,F,cm_set,1400.0,'VROCN2ALK','      ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.05), ! 
     & spcs_list_type('AROCN1ALK ',T,T,F,cm_set,1400.0,'VROCN1ALK','      ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.05), ! 
     & spcs_list_type('AROCP0ALK ',T,T,F,cm_set,1400.0,'VROCP0ALK','      ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.04), !   
     & spcs_list_type('AROCP1ALK ',T,T,F,cm_set,1400.0,'VROCP1ALK','      ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.03), ! 
     & spcs_list_type('AROCP2ALK ',F,T,F,cm_set,1400.0,'VROCP2ALK','      ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.03), ! 
     & spcs_list_type('AROCP3ALK ',F,T,F,cm_set,1400.0,'VROCP3ALK','      ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.03), ! 
     & spcs_list_type('AROCN2OXY2',T,T,F,cm_set,1400.0,'VROCN2OXY2','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.15), ! 
     & spcs_list_type('AROCN2OXY4',T,T,F,cm_set,1400.0,'VROCN2OXY4','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.15), ! 
     & spcs_list_type('AROCN2OXY8',T,T,F,cm_set,1400.0,'VROCN2OXY8','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.15), ! 
     & spcs_list_type('AROCN1OXY1',T,T,F,cm_set,1400.0,'VROCN1OXY1','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.13), ! 
     & spcs_list_type('AROCN1OXY3',T,T,F,cm_set,1400.0,'VROCN1OXY3','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.13), ! 
     & spcs_list_type('AROCN1OXY6',T,T,F,cm_set,1400.0,'VROCN1OXY6','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.13), ! 
     & spcs_list_type('AROCP0OXY2',T,T,F,cm_set,1400.0,'VROCP0OXY2','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.11), !   
     & spcs_list_type('AROCP0OXY4',T,T,F,cm_set,1400.0,'VROCP0OXY4','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.11), ! 
     & spcs_list_type('AROCP1OXY1',T,T,F,cm_set,1400.0,'VROCP1OXY1','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.09), ! 
     & spcs_list_type('AROCP1OXY3',T,T,F,cm_set,1400.0,'VROCP1OXY3','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.09), ! 
     & spcs_list_type('AROCP2OXY2',F,T,F,cm_set,1400.0,'VROCP2OXY2','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.08), ! 
     & spcs_list_type('AROCP3OXY2',F,T,F,cm_set,1400.0,'VROCP3OXY2','     ',0.0  ,'REV',F,F,  0,  4.0, 6.1,T, 'DUST  ', 0.08), ! 
              
       ! The following species are associated with the Multi-Pollutant code
     & spcs_list_type('ANI     ',T,T,T, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Nickel
     & spcs_list_type('ACR_VI  ',T,T,T, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Chromium 6
     & spcs_list_type('ACR_III ',T,T,T, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Chromium 3              #80
     & spcs_list_type('ABE     ',T,T,T, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Beryllium
     & spcs_list_type('APB     ',T,T,T, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Lead                     
     & spcs_list_type('ADE_OTHR',T,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Fine PM          
     & spcs_list_type('ADE_EC  ',T,T,F, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Black Carbon
     & spcs_list_type('ADE_OC  ',T,T,F, cm_set, 2000.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Organic Carbon
     & spcs_list_type('ADE_NO3 ',F,T,F, cm_set, 1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Nitrate
     & spcs_list_type('ADE_SO4 ',F,T,F, cm_set, 1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Sulfate
     & spcs_list_type('ADE_CORS',F,F,T, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Coarse PM
     & spcs_list_type('ACADMIUM',T,T,T, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Cadmium
     & spcs_list_type('AMN_HAPS',T,T,T, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Manganese               #90
     & spcs_list_type('APHG    ',T,T,T, cm_set, 2200.0, 'HGIIAER','PHGRXN ',1.0  ,'IRV',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Mercury
     & spcs_list_type('AAS     ',T,T,T, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Arsenic                 #92
     & spcs_list_type('ABENAPY ',T,T,F, cm_set, 1400.0, 'BENAPY ','       ',1.0  ,'REV',F,T,  0,  0.0, 0.0,T, 'DUST  ', 0.00), ! Benzo[a]pyrene          #93
                                                          
       ! adding PFAS species
     & spcs_list_type('APFOA   ',F,T,F, cm_set, 1300.0, 'PFOA   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AHFPODA ',F,T,F, cm_set, 1300.0, 'HFPODA ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AHFPODAF',F,T,F, cm_set, 1850.0, 'HFPODAF','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('ATFE    ',F,T,F, cm_set, 1300.0, 'TFE    ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('AHFPO   ',F,T,F, cm_set, 1300.0, 'HFPO   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('AHFP    ',F,T,F, cm_set, 1583.0, 'HFP    ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AE2     ',F,T,F, cm_set, 1659.0, 'E2     ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('APSEPVE ',F,T,F, cm_set, 1700.0, 'PSEPVE ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('APAF    ',F,T,F, cm_set, 1400.0, 'PAF    ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('ACH3F   ',F,T,F, cm_set, 1167.0, 'CH3F   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('APPVE   ',F,T,F, cm_set, 1530.0, 'PPVE   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('APMVE   ',F,T,F, cm_set, 1430.0, 'PMVE   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('APEVE   ',F,T,F, cm_set, 1445.0, 'PEVE   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('APFB    ',F,T,F, cm_set, 1530.0, 'PFB    ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('APMPF   ',F,T,F, cm_set, 1600.0, 'PMPF   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('ATAF2   ',F,T,F, cm_set, 1600.0, 'TAF2   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),  !assume density of 1.6 based on EVE, E1&2, and HFPOTA which are ~similar structures
     & spcs_list_type('AEVE    ',F,T,F, cm_set, 1592.0, 'EVE    ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('ACOF2   ',F,T,F, cm_set, 1139.0, 'COF2   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AE1     ',F,T,F, cm_set, 1538.0, 'E1     ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('APEPF   ',F,T,F, cm_set, 1700.0, 'PEPF   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('ADA     ',F,T,F, cm_set, 1800.0, 'DA     ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AHFPOTA ',F,T,F, cm_set, 1700.0, 'HFPOTA ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('ATAF    ',F,T,F, cm_set, 1500.0, 'TAF    ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), 
     & spcs_list_type('AMA     ',F,T,F, cm_set, 1800.0, 'MA     ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AF113   ',F,T,F, cm_set, 1700.0, 'F113   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('ACF3H   ',F,T,F, cm_set, 1100.0, 'CF3H   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('ATFF4   ',F,T,F, cm_set, 1800.0, 'TFF4   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AHF     ',F,T,F, cm_set, 1160.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('APFASOTHER',F,T,F,cm_set,1570.0, 'PFASOTHER','     ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02), !average density of all "other" compounds <100lbs/2017
     & spcs_list_type('APFASGP ',F,T,F,cm_set,  1370.0, 'PFASGP ','       ',0.0  ,'REV',F,T,  0,  2.8, 6.1,F, 'DUST  ', 0.02), !average density of all compounds
     & spcs_list_type('APFASAERO',F,T,F,cm_set, 1370.0, '       ','       ',0.0  ,'NVL',F,T,  0,  2.8, 6.1,F, 'DUST  ', 0.02), !average density of all compounds
     & spcs_list_type('APFAS_EXPTDAERO',F,T,F,cm_set,1600.0,'   ','       ',0.0  ,'NVL',F,T,  0,  2.8, 6.1,F, 'DUST  ', 0.02), !average density of all compounds expected to be in particle phase
     & spcs_list_type('AHFPODAghyd',F,T,F, cm_set, 1300.0, 'HFPODAghyd',' ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AHFPODAphyd',F,T,F, cm_set, 1300.0, 'HFPODAphyd',' ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AHFPODAchyd',F,T,F, cm_set, 1300.0, 'HFPODAchyd',' ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AFCOOH  ',F,T,F, cm_set, 1400.0, 'FCOOH  ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AFCOOHphyd',F,T,F, cm_set, 1400.0, 'FCOOHphyd','   ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('AFCOOHchyd',F,T,F, cm_set, 1400.0, 'FCOOHchyd','   ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('APFMOAF ',F,T,F, cm_set, 1500.0, 'PFMOAF','        ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('APFMOAA ',F,T,F, cm_set, 1700.0, 'PFMOAA','        ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('APFMOAAphyd',F,T,F, cm_set, 1700.0, 'PFMOAAphyd',' ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),
     & spcs_list_type('APFMOAAchyd',F,T,F, cm_set, 1700.0, 'PFMOAAchyd',' ',0.0  ,'REV',F,F,  0,  2.8, 6.1,F, 'DUST  ', 0.02),

       ! The following species are associated with the marine chemistry code
     & spcs_list_type('ABR     ',F,T,T, cm_set, 2200.0, '       ','       ',0.0  ,'NVL',F,F, -1,  1.7, 1.7,F, 'SOLUTE', 0.00), ! Bromide 
      ! Species created for CRACMM
     & spcs_list_type('ASOAT   ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.13), ! Lumped SOA not otherwise specified, OM/OC=2.1

      ! The following species are associated with the sulfur tracking model
     & spcs_list_type('ASO4AQH2O2',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous H2O2 rxn
     & spcs_list_type('ASO4AQO3  ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous O3 rxn
     & spcs_list_type('ASO4AQFEMN',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous FEMN cat rxn
     & spcs_list_type('ASO4AQMHP ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous MHP rxn
     & spcs_list_type('ASO4AQPAA ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous PAA rxn
     & spcs_list_type('ASO4GAS   ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from gas rxn
     & spcs_list_type('ASO4EMIS  ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! emitted SO4
     & spcs_list_type('ASO4ICBC  ',T,T,T,cm_so4,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from ICBCs
                                                          
      ! The following species are associated with the sulfur tracking model, representing loss of tracked species to organosulfate
     & spcs_list_type('OSO4      ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 loss to organosulfate
     & spcs_list_type('OSO4AQH2O2',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous H2O2 rxn loss to organosulfate
     & spcs_list_type('OSO4AQO3  ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous O3 rxn loss to organosulfate
     & spcs_list_type('OSO4AQFEMN',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous FEMN cat rxn loss to organosulfate
     & spcs_list_type('OSO4AQMHP ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous MHP rxn loss to organosulfate
     & spcs_list_type('OSO4AQPAA ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous PAA rxn loss to organosulfate
     & spcs_list_type('OSO4GAS   ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from gas rxn loss to organosulfate
     & spcs_list_type('OSO4EMIS  ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from emitted SO4 loss to organosulfate
     & spcs_list_type('OSO4ICBC  ',T,T,T,cm_set,1800.0, '       ','       ',0.0  ,'NVL',F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from ICBCs loss to organosulfate
     
      ! The following species are associated with CRACMM2
     & spcs_list_type('AISO4   ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.21), ! from heterogeneous uptake of IPX
     & spcs_list_type('AISO5   ',F,T,F, cm_set, 1400.0, '       ','       ',0.0  ,'NVL',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.18), ! from heterogeneous uptake of INALD
     & spcs_list_type('ATRPN   ',F,T,F, cm_set, 1400.0, 'TRPN   ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.10), ! SOA from first generation monoterpene nitrate
     & spcs_list_type('AHONIT  ',F,T,F, cm_set, 1400.0, 'HONIT  ','       ',0.0  ,'REV',F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.14)  ! SOA from second generation monoterpene nitrate
     & /)                                                 
 
! Define Reference Emissions Size Distributions
!   Geometric mean (or median) diameter by volume (or mass) of emitted particles in
!   each mode [ m ] and geometric standard deviation of emitted particles.  
!   See paragraph #14 of Binkowski & Roselle (2003).
!   09/17/14 change by Kathleen Fahey - see Revision History, above.
      TYPE em_aero
          Character( 20 ) :: name
          Real            :: split( n_mode )  ! dimensionless
          Real            :: dgvem( n_mode )  ! meters
          Real            :: sgem ( n_mode )  ! dimensionless
      END TYPE em_aero
      INTEGER, PARAMETER  :: desid_n_aero_ref = 11

      TYPE( em_aero ), Parameter :: desid_aero_ref( desid_n_aero_ref ) = (/

!              ----Name----     -----Split-----    ---Geo. Mean Diameter---   ---Stnd Dev.---
     & em_aero('FINE_REF       ',(/0.1,0.9,0.0/),(/0.06E-6,0.28E-6 ,6.0E-6 /),(/1.7,1.7,2.2/)), ! Default Accum and Aitken Mode
     & em_aero('ACC_REF        ',(/0.0,1.0,0.0/),(/0.06E-6,0.28E-6 ,6.0E-6 /),(/1.7,1.7,2.2/)), ! Just Accumulation Mode
     & em_aero('COARSE_REF     ',(/0.0,0.0,1.0/),(/0.06E-6,0.28E-6 ,6.0E-6 /),(/1.7,1.7,2.2/)), ! Just Coarse Mode
     & em_aero('UNITY_REF      ',(/1.0,1.0,1.0/),(/0.06E-6,0.28E-6 ,6.0E-6 /),(/1.7,1.7,2.2/)), ! Used for online sectors (e.g. SeaSpray)
     & em_aero('PFAS_REF       ',(/0.329,0.671,0.0/),(/0.1E-6,5.0E-6 ,6.0E-6 /),(/1.6,2.1,2.1/)), ! Default Accum and Aitken Mode
     & em_aero('PFAS_REF_UF    ',(/1.0,0.0,0.0/),(/0.02E-6,5.0E-6 ,6.0E-6 /),(/1.3,2.1,2.1/)), ! Default Accum and Aitken Mode
     & em_aero('ZERO_REF       ',(/0.0,0.0,0.0/),(/0.06E-6,0.28E-6 ,6.0E-6 /),(/1.7,1.7,2.2/)), ! Zero out the emissions
     & em_aero('FINE_WBDUST    ',(/0.0,1.0,0.0/),(/0.06E-6,1.391E-6,5.26E-6/),(/1.7,2.0,2.0/)), ! Default Fine Wind-Blown Dust Parameterization
     & em_aero('COARSE_WBDUST  ',(/0.0,0.0,1.0/),(/0.06E-6,1.391E-6,5.26E-6/),(/1.7,2.0,2.0/)), ! Default Coarse Wind-Blown Dust Param.
     & em_aero('FINE_SEASPRAY  ',(/0.0,1.0,0.0/),(/0.06E-6,1.391E-6,5.26E-6/),(/1.7,2.0,2.0/)), ! Fine Sea Spray Parameterization is Dynamic. 
     & em_aero('COARSE_SEASPRAY',(/0.0,0.0,1.0/),(/0.06E-6,1.391E-6,5.26E-6/),(/1.7,2.0,2.0/))  ! Coarse Sea Spray Parameterization is Dynamic. 
                                                                                                !  The values here are not actually used but
                                                                                                !  are replaced in SSEMIS when FACNUM and FACSRF
                                                                                                !  are calculated online.
     & /)

      ! List of PFAS Properties for Use in Partitioning Calculations
      Type pfas_type
         Character( 16 ) :: gasname             ! gaseous vapor species name
         Character( 16 ) :: aername             ! mode-independent names of aerosol species
         Real            :: pKa                 ! acid dissociation constant, pKa 
         Real            :: Cstar               ! Saturation Concentration (C*) [ug m-3]
         Real            :: dHvap               ! Enthalpy of Vaporization [J/mol]
         Integer         :: HLC                 ! Index of Henry's Law Parameters in hlconst
         Logical         :: virtual             ! Is the species representing total PFAS?
      End Type pfas_type

      Integer, Parameter :: npfas = 39
      Type( pfas_type ), Save :: pfas( npfas ) = (/

        ! if one of the names is blank, code won't read the pKa, 
        ! Cstar, Hvap values so doesn't matter what they are

C                GasName     | AerName     | pKa   | Cstar   | Hvap   | Henry | Virtual
C                ----------   ------------  --------------------------------------
     & pfas_type('PFOA     ' ,'APFOA      ',  0.34 ,   2.12e7,  46.4E3, 0,     F), ! Perfluorooctanoic Acid
     & pfas_type('HFPODA   ' ,'AHFPODA    ',  2.84 ,   9.8E+5,  46.7E3, 0,     F), ! HFPO-Dimer Acid
     & pfas_type('HFPODAF  ' ,'AHFPODAF   ', -999. ,  3.07E+9,  34.5E3, 0,     F), ! HFPO-Dimer Acid Fluoride
     & pfas_type('TFE      ' ,'ATFE       ', -999. , 2.66E+10,  17.8E3, 0,     F), ! Tetratefluoroethene
     & pfas_type('HFPO     ' ,'AHFPO      ', -999. , 1.14E+10,  20.5E3, 0,     F), ! Hexafluoropropylene Oxide
     & pfas_type('HFP      ' ,'AHFP       ', -999. , 4.03E+10,  21.5E3, 0,     F), ! Hexafluoropropene
     & pfas_type('E2       ' ,'AE2        ', -999. , 3.941E+9,  37.4E3, 0,     F), ! HFPO-TA Decarboxyl
     & pfas_type('PSEPVE   ' ,'APSEPVE    ', -999. , 1.906E+7,  43.5E3, 0,     F), ! Nafion Monomer
     & pfas_type('PAF      ' ,'APAF       ', -999. , 3.98E+10,  25.9E3, 0,     F), ! Trifluoroacetyl Fluoride
     & pfas_type('CH3F     ' ,'ACH3F      ', -999. , 8.606E+9,  17.7E3, 0,     F), ! Fluoromethane
     & pfas_type('PPVE     ' ,'APPVE      ', -999. , 3.035E+9,  28.3E3, 0,     F), ! Perfluoropropoxyethylene
     & pfas_type('PMVE     ' ,'APMVE      ', -999. , 1.15E+10,  25.1E3, 0,     F), ! Perfluoro(methyl vinyl ether)
     & pfas_type('PEVE     ' ,'APEVE      ', -999. , 1.24E+10,  26.7E3, 0,     F), ! Perfluoroethyl trifluorovinyl ether
     & pfas_type('PFB      ' ,'APFB       ', -999. , 2.69E+10,  24.6E3, 0,     F), ! Octafluoro-2-butene
     & pfas_type('PMPF     ' ,'APMPF      ', -999. , 3.958E+9,  29.3E3, 0,     F), ! Perfluoro-2-methoxypropionyl fluoride
     & pfas_type('TAF2     ' ,'ATAF2      ', -999. ,   1.1E+8,    30E3, 0,     F), ! TAF2
     & pfas_type('EVE      ' ,'AEVE       ', -999. , 1.669E+6,  50.3E3, 0,     F), ! Ester Vinyl Ether
     & pfas_type('COF2     ' ,'ACOF2      ', -999. , 9.63E+10,  18.0E3, 0,     F), ! Carbonyl Fluoride
     & pfas_type('E1       ' ,'AE1        ', -999. , 4.433E+9,  28.3E3, 0,     F), ! Heptafluoropropyl1,2,2,
                                                                                   !   2-tetrafluoroethylether
     & pfas_type('PEPF     ' ,'APEPF      ', -999. , 5.949E+9,  33.3E3, 0,     F), ! Propanoyl fluoride, 
                                                                                   !   2,3,3,3-tetrafluoro-
                                                                                   !   2-(pentafluoroethoxy)-
     & pfas_type('DA       ' ,'ADA        ', -999. , 1.097E+7,  49.6E3, 0,     F), ! 8-Fluorosulfonylperfluoro(2,5-dimethyl-3,
                                                                                   !   6-dioxaoctanoyl) fluoride
     & pfas_type('HFPOTA   ' ,'AHFPOTA    ', -999. , 3.082E+9,  43.3E3, 0,     F), ! Hexafluoropropylene Oxide Trimer
     & pfas_type('TAF      ' ,'ATAF       ', -999. , 1.05E+10,  24.9E3, 0,     F), ! Fluoroformic acid trifluoromethyl ester
     & pfas_type('MA       ' ,'AMA        ', -999. , 8.436E+8,  41.8E3, 0,     F), ! 2,3,3,3-Tetrafluoro-2-[1,1,2,2-tetrafluoro-
                                                                                   !   2-(fluorosulfonyl)ethoxy]propionyl 
                                                                                   !   fluoride
     & pfas_type('F113     ' ,'AF113      ', -999. ,  4.86E+9,    27E3, 0,     F), ! Trichlorotrifluoroethane (CFC-113)
     & pfas_type('TFF4     ' ,'ATFF4      ', -999. ,  3.96E+7,  36.9E3, 0,     F), ! TFF4
     & pfas_type('CF3H     ' ,'ACF3H      ', -999. ,  8.7E+10,  17.2E3, 0,     F), ! Trifluoromethane
     & pfas_type('         ' ,'AHF        ', -999. ,    -999.,   -999., 0,     F), ! Hydrofluoric Acid
     & pfas_type('PFASOTHER' ,'APFASOTHER ', -999. , 6.636E+5,  35.6E3, 0,     F), ! Other PFAS
     & pfas_type('HFPODAghyd','AHFPODAghyd',  2.84 ,   9.8E+5,  46.7E3, 0,     F), ! HFPO-Dimer Acid produced from gas phase hydrolysis
     & pfas_type('HFPODAchyd','AHFPODAchyd',  2.84 ,   9.8E+5,  46.7E3, 0,     F), ! HFPO-Dimer Acid produced from cloud hydrolysis
     & pfas_type('HFPODAphyd','AHFPODAphyd',  2.84 ,   9.8E+5,  46.7E3, 0,     F), ! HFPO-Dimer Acid produced from particle phase hydrolysis
     & pfas_type('FCOOH     ','AFCOOH     ',  1.00 ,   1.2E+7,  41.4E3, 0,     F), ! CHFO2, carboxylic acid form of COF2
     & pfas_type('FCOOHphyd ','AFCOOHphyd ',  1.00 ,   1.2E+7,  41.4E3, 0,     F), ! CHFO2, carboxylic acid form of COF2 produced from particle hydrolysis
     & pfas_type('FCOOHchyd ','AFCOOHchyd ',  1.00 ,   1.2E+7,  41.4E3, 0,     F), ! CHFO2, carboxylic acid form of COF2 produced from cloud hydrolysis
     & pfas_type('PFMOAF    ','APFMOAF    ', -999. ,   6.4E+9,  31.9E3, 0,     F), ! PFMOAF
     & pfas_type('PFMOAA    ','APFMOAA    ',  2.84 ,   9.8E+5,  38.9E3, 0,     F), ! PFMOAA
     & pfas_type('PFMOAAphyd','APFMOAAphyd',  2.84 ,   9.8E+5,  38.9E3, 0,     F), ! PFMOAA produced from particle hydrolysis
     & pfas_type('PFMOAAchyd','APFMOAAchyd',  2.84 ,   9.8E+5,  38.9E3, 0,     F)/)! PFMOAA produced from cloud hydrolysis 
                                                                      
       Integer, Save :: MAP_PFAStoAERO( NPFAS )                       
       Integer, Save :: MAP_PFAStoGAS ( NPFAS )                       
       Logical, Parameter :: LPFAS_PARTITIONING = .TRUE. ! Flag for turning on/off online 
                                                         ! partitioning of PFAS compounds to
                                                         ! aerosol water
       REAL, SAVE    :: PFASGAS_CONC( NPFAS )

! Primary Organic Aerosol Volatility Distributions
      Integer, Parameter :: n_vbs_bin = 5
      Character( 10 ) :: poa_name( n_vbs_bin ) = (/ 'LVPO1', 'SVPO1', 'SVPO2', 'SVPO3', 'IVPO1' /)
      Real, Parameter :: poa_op_vf( n_vbs_bin ) = (/ 0.09,  0.09,  0.14,  0.18,  0.5 /)  ! Aggregated

! The Following Volatility Distributions are alternative options
! but at this point can only be implemented indivdually for the
! entire POA suite of compounds.
!     Real, Parameter :: poa_gv_vf(n_vbs_bin) = (/0.27,  0.15,   0.26,   0.15,   0.17/) ! Gasoline
!     Real, Parameter :: poa_dv_vf(n_vbs_bin) = (/0.03,  0.25,   0.37,   0.24,   0.11/) ! Diesel
!     Real, Parameter :: poa_bb_vf(n_vbs_bin) = (/0.2,   0.1,    0.1,    0.2,    0.4/)  ! Biomass Burning
!     Real, Parameter :: poa_nv_vf(n_vbs_bin) = (/1.0,   0.0,    0.0,    0.0,    0.0/)  ! Nonvolatile
!     Real, Parameter :: poa_mc_vf(n_vbs_bin) = (/0.35,  0.35,   0.1,    0.1,    0.1/)  ! Meat Cooking

! POA_AMF is the fraction of total emissions in the particle phase.
! This parameter is for distributing the total emissions between
! gas and particle BEFORE the aerosol size distribution is applied.
! This helps prevent numerical issues with shrinking the particles
! instantaneously.
      Real, Parameter :: poa_amf( n_vbs_bin ) = (/ 1.0, 0.5, 0.0, 0.0, 0.0 /)
      Real, Parameter :: pog_amf( n_vbs_bin ) = (/ 0.0, 0.5, 1.0, 1.0, 1.0 /)
 
! PCVOC_FAC is the scale factor for deriving PCVOC emissions from POA
! emissions. PCVOC is the vapor precursor to pcSOA formation.
      Real, Parameter :: PCVOC_FAC = 6.579  ! Scale factor for PCVOC/POA
                                            ! Murphy et al., 2017

C number of lognormal modes in windblown dust aerosol = n_mode
C - but only accumulation and coarse modes used
      Type emis_table
         Character( 16 ) :: description       ! Species Long Name
         Character( 16 ) :: name              ! Species Name
         Real            :: mw                ! Molecular weight (g/mol)
         Real            :: spcfac( 2 )       ! Speciation Factor for fine and coarse modes (g/g)
      End type emis_table

C For the wind-blown dust speciation factors, we used the median of the Desert Soil
C profiles 3398, 3403, 3408, and 3413 for the J mode from the SPECIATE database and
C profiles 3399, 3404, 3409, and 3414 for coarse PM. (G. Pouliot - private communication)
C See Ref. (4), above and https://cfpub.epa.gov/si/speciate/
! For toxic metal species, more recent sources were consulted because the above profiles give large uncertainties in their 
! speciation factors
! For the air toxics version of manganese, nickel, chromium(III), arsenic, and lead:
!    Table 2 in Y. Su, and R. Yang., Background concentrations of elements in surface soils and 
!    their changes as affected by agriculture use in the desert-oasis ecotone in the middle of Heihe
!    River Basin, North-west China, Journal of Geochemical Exploration, 98, 2008, 57–64 was used.
!    The table represents natural desert soils prior to cultivation. Note that all chromium is 
!    to be trivalent based on assuming low pH or anoxics conditions. 
! For cadmium:
!    The background mixing ratio was used from Table 3 in Su, C., Jiang, L.,and Zhang, W., 
!    A review on heavy metal contamination in the soil worldwide: Situation, impact and 
!    remediation techniques, Environmental Skeptics and Critics, 2014, 3(2): 24-38. 
!    The table reviews worldwide cultivation soils.
! For mercury:
!    Table 2 in D. Obrist et al., A synthesis of terrestrial mercury in the western United States: 
!    Spatial distribution defined by land cover and plant productivity, Science of the Total Environment, 
!    568, 2016, 522–535.
!    Factors were based on mixing ratios for barren and cultivated land cover type
! Speciation factors between j and k modes were assumed constant because no data was found.

C maximum number of chemical species in windblown dust aerosol
      Integer, Parameter :: ndust_spc = 28

       
      Type( emis_table ) :: dust_spc( ndust_spc ) = (/
C                    --description-- -- Species -- --MW--   ------ spcfac ------
C                                                             fine    coarse
     &   emis_table( 'Sulfate       ',  'SO4    ',  96.0, (/ 0.02250, 0.02655/) ),   ! Sulfate
     &   emis_table( 'Nitrate       ',  'NO3    ',  62.0, (/ 0.00020, 0.00160/) ),   ! Nitrate
     &   emis_table( 'Chlorine      ',  'CL     ',  35.5, (/ 0.00945, 0.01190/) ),   ! Chlorine
     &   emis_table( 'Ammonium      ',  'NH4    ',  18.0, (/ 0.00005, 0.0    /) ),   ! Ammonium
     &   emis_table( 'Sodium        ',  'NA     ',  23.0, (/ 0.03935, 0.0    /) ),   ! Sodium
     &   emis_table( 'Calcium       ',  'CA     ',  40.1, (/ 0.07940, 0.0    /) ),   ! Calcium
     &   emis_table( 'Magnesium     ',  'MG     ',  24.3, (/ 0.01900, 0.0    /) ),   ! Magnesium
     &   emis_table( 'Potassium     ',  'K      ',  39.1, (/ 0.03770, 0.0    /) ),   ! Potassium
     &   emis_table( 'Org. Carbon   ',  'POC    ', 220.0, (/ 0.01075, 0.0    /) ),   ! Organic Carbon
     &   emis_table( 'NonCarbon Org.',  'PNCOM  ', 220.0, (/ 0.00430, 0.0    /) ),   ! Non-Carbon Organic Matter
     &   emis_table( 'Low-Vol. POA  ',  'LVPO1  ', 218.0, (/ 0.01501, 0.0    /) ),   ! Non-Carbon Organic Matter
     &   emis_table( 'Low-Vol. OOA  ',  'LVOO1  ', 136.0, (/ 2.23E-5, 0.0    /) ),   ! Non-Carbon Organic Matter
     &   emis_table( 'Black Carbon  ',  'EC     ',  12.0, (/ 0.0,     0.0    /) ),   ! Black or Elemental Carbon
     &   emis_table( 'Iron          ',  'FE     ',  55.8, (/ 0.03355, 0.0    /) ),   ! Iron
     &   emis_table( 'Aluminum      ',  'AL     ',  27.0, (/ 0.05695, 0.0    /) ),   ! Aluminum
     &   emis_table( 'Silicon       ',  'SI     ',  28.1, (/ 0.19425, 0.0    /) ),   ! Silicon
     &   emis_table( 'Titanium      ',  'TI     ',  47.9, (/ 0.00280, 0.0    /) ),   ! Titanium
     &   emis_table( 'Manganese     ',  'MN     ',  54.9, (/ 0.00115, 0.0    /) ),   ! Manganese
     &   emis_table( 'Water         ',  'H2O    ',  18.0, (/ 0.00541, 0.00637/) ),   ! Water
     &   emis_table( 'Undefined Mass',  'OTHR   ', 200.0, (/ 0.48319, 0.0    /) ),   ! Other
     &   emis_table( 'Non-Anion Dust',  'SOIL   ', 100.0, (/ 0.0,     0.95358/) ),   ! Non-Anion Dust
     &   emis_table( 'Air Toxics Mn ',  'MN_HAPS',  54.9, (/ 0.00041, 0.00041/) ),   ! Air toxics Manganese J and K mode
     &   emis_table( 'Nickel        ',  'NI     ',  58.7, (/ 2.0E-05, 2.0E-05/) ),   ! Nickel J and K mode
     &   emis_table( 'Chromium III  ',  'CR_III ',  52.0, (/ 5.6E-05, 5.6E-05/) ),   ! Trivalent Chromium J and K mode
     &   emis_table( 'Arsenic       ',  'AS     ',  74.92,(/ 5.5E-06, 5.5E-06/) ),   ! Arsenic J and K mode
     &   emis_table( 'Lead          ',  'PB     ', 207.2, (/ 1.6E-05, 1.6E-05/) ),   ! Lead J and K mode
     &   emis_table( 'Cadmium       ',  'CD     ', 112.4, (/ 9.7E-08, 9.7E-08/) ),   ! Cadmium J and K mode
     &   emis_table( 'Mercury       ',  'PHG    ', 200.5, (/ 1.4E-08, 1.4E-08/) ) /) ! Mercury J and K mode

      ! Manually Enter the mode-dependent Density of the Dust Particles using the mass fractions in 
      ! the dust_spc table and user-defined densities for each component. You may reference the aerolist 
      ! for densities as well. Units are [kg/m3]. The appropriate calculation is:
      !    dust_dens = sum( frac_i ) / sum( frac_i / dens_i )
      ! Make sure to ignore any tracer species when performing this calculation.
      Real, Parameter :: dust_dens( n_mode ) = (/ 2200.0, 2156.55, 2536.92 /)

      Real, ALLOCATABLE, SAVE    :: DUSTOUTM( :,:,: ) ! Wind-Blown Dust Mass Emiss Rate [ug/m3/s]
      Real, ALLOCATABLE, SAVE    :: DUSTOUTN( :,:,: )   ! Wind-Blown Dust Number Emiss Rate [1/m3/s]
      Real, ALLOCATABLE, SAVE    :: DUSTOUTS( :,:,: )   ! Wind-Blown Dust Surface Area Emiss Rate [m2/m3/s]

C Sea-Spray Aerosol Speciation factors based on seawater composition:
! For toxic metal species, Use Table 1 in K.W. Bruland and M.C. Lohan, 6.02 - Controls of Trace Metals in Seawater, 
! In Treatise on Geochemistry, edited by Heinrich D. Holland and Karl K. Turekian, Pergamon, Oxford, 2003, Pages 23-47,
! ISBN 9780080437514, http://dx.doi.org/10.1016/B0-08-043751-6/06105-3.

C number of chemical species in seawater aerosol composition
      integer, parameter :: nsea_spc = 18

      Type( emis_table ), Parameter :: sea_spc( nsea_spc ) = (/
C                     -description--  -- Species -- --MW--  ------ spcfac ------
C                                                              fine    coarse
     &   emis_table( 'Sulfate       ',   'SO4    ',  96.0, (/ 0.07760, 0.07760/) ),   ! Sulfate
     &   emis_table( 'Chlorine      ',   'CL     ',  35.5, (/ 0.55380, 0.55380/) ),   ! Chlorine
     &   emis_table( 'Sodium        ',   'NA     ',  23.0, (/ 0.30860, 0.0    /) ),   ! Sodium
     &   emis_table( 'Calcium       ',   'CA     ',  40.1, (/ 0.01180, 0.0    /) ),   ! Calcium
     &   emis_table( 'Magnesium     ',   'MG     ',  24.3, (/ 0.03680, 0.0    /) ),   ! Magnesium
     &   emis_table( 'Potassium     ',   'K      ',  39.1, (/ 0.01140, 0.0    /) ),   ! Potassium
     &   emis_table( 'SeaSalt_Cation',   'SEACAT ',  23.75,(/ 0.0    , 0.36860/) ),   ! Sea-Salt Cations
     &   emis_table( 'Chromium VI   ',   'CR_VI  ',  52.0, (/ 5.95E-9, 5.95E-9/) ),   ! Hexavalent Chromium
     &   emis_table( 'Nickel        ',   'NI     ',  58.7, (/ 1.34E-8, 1.34E-8/) ),   ! Nickle
     &   emis_table( 'Arsenic       ',   'AS     ',  74.92,(/ 4.93E-8, 4.93E-8/) ),   ! Arsenic
     &   emis_table( 'Beryllium     ',   'BE     ',   9.0, (/ 5.2E-11, 5.2E-11/) ),   ! Beryllium
     &   emis_table( 'Mercury       ',   'PHG    ', 200.5, (/ 5.8E-11, 5.8E-11/) ),   ! Mercury
     &   emis_table( 'Lead          ',   'PB     ', 207.2, (/ 6.0E-11, 6.0E-11/) ),   ! Lead
     &   emis_table( 'Cadmium       ',   'CD     ', 112.4, (/ 1.93E-9, 1.93E-9/) ),   ! cadmium
     &   emis_table( 'Air Toxics Mn ',   'MN_HAPS',  54.9, (/ 4.7E-11, 4.7E-11/) ),   ! Air toxics Manganese
     &   emis_table( 'seasalt tracer',   'SEAST  ',  31.3, (/ 1.00000, 0.00000/) ),   ! seasalt tracer
     &   emis_table( 'Bromine       ',   'BR     ',  79.9, (/ 0.00190, 0.00190/) ),   ! Bromine 
     &   emis_table( 'Water         ',   'H2O    ',  18.0, (/ 0.0    , 0.0    /) ) /) ! Water (uptake is calculated online)
 
      ! MAKE SURE WATER IS THE LAST COMPONENT IN THE TABLE ABOVE OR YOU
      ! WILL ENCOUNTER ISSUES WITH THE SEA SPRAY EMISSIONS MODULE.

      ! Manually Enter the mode-dependent density of the Sea Spray Particles using the mass fractions in 
      ! the sea_spc table and user-defined densities for each component. You may reference the aerolist 
      ! for densities as well. Units are [kg m-3]. The appropriate calculation is:
      !    seaspray_dens = sum( frac_i ) / sum( frac_i / dens_i )
      ! Make sure to ignore any tracer species when performing this calculation.
      Real, Parameter :: seaspray_dens( n_mode ) = (/ 2162.7, 2162.7, 2162.7 /)
      Real, Parameter :: specific_vol_h2o = 0.001  !Inverse Density of Particulate Water
 
C Constants used for simulating the ionic effects of sea-spray,
C windblown dust and anthropogenic dust in the coarse mode. These cation
C species are not transported individually in the domain but their
C relative abundance is assumed to be constant and scaled to the total
C SeaSalt_Cation, ASOIL, or Coarse-Mode Dust present.

      Real( 8 ), Parameter :: asoil_renorm = 1.0D0 - 0.04642D0  ! = 0.95358, same as ASOIL speciation factor in the dust_spc table above

      Real( 8 ), Parameter :: ascat_na_fac = 0.8373D0    ! for NA in coarse sea-spray aerosol
      Real( 8 ), Parameter :: asoil_na_fac = 0.0626D0    ! for NA in windblown dust
      Real( 8 ), Parameter :: acors_na_fac = 0.0023D0    ! for NA in anthropogenic coarse

      Real( 8 ), Parameter :: ascat_mg_fac = 0.0997D0    ! for MG in coarse sea-spray aerosol
      Real( 8 ), Parameter :: asoil_mg_fac = 0.0170D0    ! for MG in windblown dust
      Real( 8 ), Parameter :: acors_mg_fac = 0.0032D0    ! for MG in anthropogenic coarse

      Real( 8 ), Parameter :: ascat_k_fac =  0.0310D0    ! for K in coarse sea-spray aerosol
      Real( 8 ), Parameter :: asoil_k_fac =  0.0242D0    ! for K in windblown dust
      Real( 8 ), Parameter :: acors_k_fac =  0.0176D0    ! for K in anthropogenic coarse

      Real( 8 ), Parameter :: ascat_ca_fac = 0.0320D0    ! for CA in coarse sea spray aerosol
      Real( 8 ), Parameter :: asoil_ca_fac = 0.0838D0    ! for CA in windblown dust
      Real( 8 ), Parameter :: acors_ca_fac = 0.0562D0    ! for CA in anthropogenic coarse


      Real( 8 ), Parameter :: asoil_fe_fac = 0.02695D0   ! for FE in windblown dust
      Real( 8 ), Parameter :: acors_fe_fac = 0.0467D0    ! for FE in anthropogenic coarse

      Real( 8 ), Parameter :: asoil_mn_fac = 0.00075D0   ! for MN in windblown dust
      Real( 8 ), Parameter :: acors_mn_fac = 0.0011D0    ! for MN in anthropogenic coarse
 
C Coarse mode PMC speciation based on anthropogenic inventory composite from various
C sources (G. Pouliot - private communication):

      Real( 8 ), Parameter :: acorsem_aso4_fac = 0.00100D0
      Real( 8 ), Parameter :: acorsem_ano3_fac = 0.00048D0
      Real( 8 ), Parameter :: acorsem_acl_fac  = 0.00145D0
      Real( 8 ), Parameter :: acorsem_ah2o_fac = 0.00032D0
      Real( 8 ), Parameter :: acorsem_renorm   = 1.0D0
     &                                     - acorsem_aso4_fac
     &                                     - acorsem_ano3_fac
     &                                     - acorsem_acl_fac
     &                                     - acorsem_ah2o_fac
 
C Required species
      Character( 16 ), Private, Parameter :: req_so4    = 'ASO4'
      Character( 16 ), Private, Parameter :: req_no3    = 'ANO3'
      Character( 16 ), Private, Parameter :: req_cl     = 'ACL'
      Character( 16 ), Private, Parameter :: req_nh4    = 'ANH4'
      Character( 16 ), Private, Parameter :: req_na     = 'ANA'
      Character( 16 ), Private, Parameter :: req_mg     = 'AMG'
      Character( 16 ), Private, Parameter :: req_k      = 'AK'
      Character( 16 ), Private, Parameter :: req_ca     = 'ACA'
      Character( 16 ), Private, Parameter :: req_fe     = 'AFE'
      Character( 16 ), Private, Parameter :: req_mn     = 'AMN'
      Character( 16 ), Private, Parameter :: req_poc    = 'APOC'
      Character( 16 ), Private, Parameter :: req_ncom   = 'APNCOM'
      Character( 16 ), Private, Parameter :: req_h2o    = 'AH2O'
      Character( 16 ), Private, Parameter :: req_h3op   = 'AH3OP'
      Character( 16 ), Private, Parameter :: req_soil   = 'ASOIL'
      Character( 16 ), Private, Parameter :: req_cors   = 'ACORS'
      Character( 16 ), Private, Parameter :: req_seacat = 'ASEACAT'
      Character( 16 ), Private, Parameter :: req_seast  = 'ASEAST'

C Indices of required species
      Integer :: aso4_idx
      Integer :: ano3_idx
      Integer :: acl_idx
      Integer :: anh4_idx
      Integer :: ana_idx
      Integer :: amg_idx
      Integer :: ak_idx
      Integer :: aca_idx
      Integer :: afe_idx
      Integer :: amn_idx
      Integer :: apoc_idx
      Integer :: apncom_idx
      Integer :: ah2o_idx
      Integer :: ah3op_idx
      Integer :: asoil_idx
      Integer :: acors_idx
      Integer :: aseacat_idx
      Integer :: aseast_idx

C Flag if optional species present
      Logical :: ae6isoa = .False.
      Logical :: ae6hg   = .False.
      Logical :: ae7orgh2o = .False.
      Logical :: marine  = .False.

C Optional Species
      Character( 16 ), Private, Parameter :: req_ietet  = 'AIETET'
      Character( 16 ), Private, Parameter :: req_ieos   = 'AIEOS'
      Character( 16 ), Private, Parameter :: req_dim    = 'ADIM'
      Character( 16 ), Private, Parameter :: req_imga   = 'AIMGA'
      Character( 16 ), Private, Parameter :: req_imos   = 'AIMOS'
      Character( 16 ), Private, Parameter :: req_phgj   = 'APHGJ'
      Character( 16 ), Private, Parameter :: req_orgh2o = 'AORGH2O'
      Character( 16 ), Private, Parameter :: req_br     = 'ABR' 
      Character( 16 ), Private, Parameter :: req_so4aqh2o2 = 'ASO4AQH2O2'
      Character( 16 ), Private, Parameter :: req_so4aqo3   = 'ASO4AQO3'
      Character( 16 ), Private, Parameter :: req_so4aqfemn = 'ASO4AQFEMN'
      Character( 16 ), Private, Parameter :: req_so4aqmhp  = 'ASO4AQMHP'
      Character( 16 ), Private, Parameter :: req_so4aqpaa  = 'ASO4AQPAA'
      Character( 16 ), Private, Parameter :: req_so4gas    = 'ASO4GAS'
      Character( 16 ), Private, Parameter :: req_so4emis   = 'ASO4EMIS'
      Character( 16 ), Private, Parameter :: req_so4icbc   = 'ASO4ICBC'
      Character( 16 ), Private, Parameter :: req_oso4       = 'OSO4'
      Character( 16 ), Private, Parameter :: req_oso4aqh2o2 = 'OSO4AQH2O2'
      Character( 16 ), Private, Parameter :: req_oso4aqo3   = 'OSO4AQO3'
      Character( 16 ), Private, Parameter :: req_oso4aqfemn = 'OSO4AQFEMN'
      Character( 16 ), Private, Parameter :: req_oso4aqmhp  = 'OSO4AQMHP'
      Character( 16 ), Private, Parameter :: req_oso4aqpaa  = 'OSO4AQPAA'
      Character( 16 ), Private, Parameter :: req_oso4gas    = 'OSO4GAS'
      Character( 16 ), Private, Parameter :: req_oso4emis   = 'OSO4EMIS'
      Character( 16 ), Private, Parameter :: req_oso4icbc   = 'OSO4ICBC'

C Indices of Optional species
      Integer :: aietet_idx = 0
      Integer :: aieos_idx  = 0
      Integer :: adim_idx   = 0
      Integer :: aimga_idx  = 0
      Integer :: aimos_idx  = 0
      Integer :: aphgj_idx  = 0
      Integer :: aorgh2o_idx= 0
      Integer :: abr_idx    = 0
C Indices of Optional sulfur tracking species
      Integer :: aso4aqh2o2_idx = 0
      Integer :: aso4aqo3_idx   = 0
      Integer :: aso4aqfemn_idx = 0
      Integer :: aso4aqmhp_idx  = 0
      Integer :: aso4aqpaa_idx  = 0
      Integer :: aso4gas_idx    = 0
      Integer :: aso4emis_idx   = 0
      Integer :: aso4icbc_idx   = 0
      Integer :: oso4_idx       = 0
      Integer :: oso4aqh2o2_idx = 0
      Integer :: oso4aqo3_idx   = 0
      Integer :: oso4aqfemn_idx = 0
      Integer :: oso4aqmhp_idx  = 0
      Integer :: oso4aqpaa_idx  = 0
      Integer :: oso4gas_idx    = 0
      Integer :: oso4emis_idx   = 0
      Integer :: oso4icbc_idx   = 0

C Common Arrays for Aerosol Data
      Real, Allocatable :: aerospc_mw( : )     ! molecular weights (from AE_SPC Namelist) [ g/mol ]
      Real, Allocatable :: aerospc_mwinv( : )  ! reciprocal MWs (from AE_SPC Namelist) [ mol/g ]
      Real, Allocatable :: aerospc_conc( :,: ) ! aero species concentration [ ug/m^3 ]

C Common factors
      Real( 8 ) :: h2ofac                      ! converts mass concentrations [ug/m3] to 3rd moment concentrations [m3/m3]

C Variables for converting emission rates into molar-mixing-ratio units
      REAL,    PARAMETER :: GPKG = 1.0E+03     ! kg -> g
      REAL,    PARAMETER :: MGPG = 1.0E+06     ! g -> ug

C-------------------------------------------------------------------------------------------------------
      Type mode_type
         Character( 3  ) :: suff         ! Suffix
         Character( 16 ) :: num_name     ! name of aerosol number variable
         Character( 16 ) :: srf_name     ! name of aerosol surface area variable
         Logical         :: all_mask     ! is this mode ultrafine PM?
         Logical         :: ultrafine_mask ! is this mode ultrafine PM?
         Logical         :: fine_mask    ! is this mode fine PM?
         Logical         :: coarse_mask  ! is this mode coarse PM?
         Logical         :: accum_mask   ! is this accumulation-mode PM?
         Logical         :: aitken_mask  ! is this aitken-mode PM?
         Logical         :: nuc_mask     ! is this nucleation-mode PM?
         Real            :: min_numconc  ! minimum number concentration
         Real            :: min_m2conc   ! minimum 2nd moment concentration
         Real            :: min_m3conc   ! minimum 3rd moment concentration
      End Type mode_type

      Type ( mode_type ), Parameter  :: aeromode( n_mode ) = (/
C                  suffix   number     surface         Masks       minimum minimum minimum
C                            name       name     ALL U  F  C AC AI NU  numconc  m2conc  m3conc
C                  ------- ----------  -------   --- -  -  - -- -- --  -------- -------  ------
     &   mode_type('AIT'  ,'NUMATKN', 'SRFATKN', T,  T, T, F, F, T, F, conmin,  conmin, conmin),
     &   mode_type('ACC'  ,'NUMACC ', 'SRFACC ', T,  F, T, F, T, F, F, conmin,  conmin, conmin),
     &   mode_type('COR'  ,'NUMCOR ', 'SRFCOR ', T,  F, F, T, F, F, F, conmin,  conmin, conmin)/)


      ! Indices for mode masks
      INTEGER, PARAMETER :: IM_ALL = 1, IM_UF = 2, IM_F = 3, IM_C = 4,
     &                      IM_ACC = 5, IM_AIT = 6, IM_NUC = 7

      CHARACTER( 5 ), PARAMETER :: CMODE(7) = (/ 'TSP  ','PMU  ','PMF  ','PMC  ',
     &                                           'PMACC','PMAIT','PMNUC'/)

      Real          :: moment0_conc( n_mode )     ! 0th moment concentration
      Real          :: moment2_conc( n_mode )     ! 2nd moment concentration
      Real          :: moment3_conc( n_mode )     ! 3rd moment concentration
      Logical, save :: wet_moments_flag           ! T if M2 and M3 are wet, F otherwise

C Mass concentration (calculated by GETPAR)
      Real :: aeromode_mass( n_mode )   ! [ ug/m^3 ]

C Particle density (calculated by GETPAR)
      Real :: aeromode_dens( n_mode )   ! [ kg/m^3 ]

C Geometric mean diameter (calculated by GETPAR) for the NUMBER
C distribution. Remember that for log-normal distributions the geometric
C mean and the median are identical!
      Real :: aeromode_diam( n_mode )   ! [ m ]

C Log of geometric standard deviation (calculated by GETPAR ) for the
C NUMBER distribution.
      Real :: aeromode_lnsg( n_mode )

C Minimum number (calculated in map_aero routine)
      Real :: aeromode_minNum( n_mode )

C Minimum 2nd moment (calculated in map_aero routine)
      Real :: aeromode_minM2( n_mode )

C Mapping for loading from and unloading to CGRID array
      Integer, Allocatable :: aerospc_map( :,: )     ! indices of aero species to CGRID
      Integer              :: aeronum_map( n_mode )  ! indices of aero number variable to CGRID
      Integer              :: aerosrf_map( n_mode )  ! indices of aero surf area variable to CGRID

! Diagnostic Aerosol Distribution Parameters 
      Real :: wet_aero_diam( n_mode )
      Real :: dry_aero_diam( n_mode )
      Real :: wet_aero_m2  ( n_mode )
      Real :: dry_aero_m2  ( n_mode )
      Real :: wet_aero_m3  ( n_mode )
      Real :: dry_aero_m3  ( n_mode )
      Real :: wet_aero_dens( n_mode )
      Real :: dry_aero_dens( n_mode )

C Missing aerosol species map
      Logical, Allocatable :: aero_missing( :,: )  
      Logical, Save :: AE_eflag            = .False. ! error flag for AERO_DATA

C IC/BC Correction Mapping
      !The following vectors store masks of the aerosol species
      !identities for the AE_SPC and AE_TRNS vectors. For example, 
      !L_AESP_NUM stores 1's for every species on AE_SPC that
      !represents an aerosol number concentration and 0's otherwise.
      !   L_AESP_NUM - Number Concentration
      !   L_AESP_SURF - Surface Area Concentration
      !   L_AESP_MASS - Mass Concentration
      !   L_AESP_MODE - Mask for each aerosol mode
      LOGICAL, ALLOCATABLE, SAVE :: L_AESP_NUM(:),    L_AESP_SRF(:), L_AESP_MASS(:),
     &                              L_AESP_MODE(:,:), L_AESP_DRY(:)
      LOGICAL, ALLOCATABLE, SAVE :: L_AETR_NUM(:),    L_AETR_SRF(:), L_AETR_MASS(:),
     &                              L_AETR_MODE(:,:), L_AETR_DRY(:)
      REAL, ALLOCATABLE, SAVE :: AEROCGRID_RHOINV( : ) !
      
C Private variables for loading from and unloading to CGRID array
      Logical, Private, Save :: mapped    = .False.
      Character( 16 ), Private, Save :: pname = 'Aero_Data'

! Variables for collecting tendencies for aerosol sub-processes and
! passing back to modules like Process analysis and ISAM. These vectors
! should be sized to the same length as the CGRID species dimension and
! be mapped to CGRID species order. Units for each are total
! concentration or mixing ratio gained or lost. These are not normalized
! by the time step. Ex (ppmv, ug m-3, N m-3, or m2 m-3)
      REAL, ALLOCATABLE, SAVE :: COND_BUDGET( : )
      REAL, ALLOCATABLE, SAVE :: COAG_BUDGET( :,: )
      REAL, ALLOCATABLE, SAVE :: NPF_BUDGET( : )
      REAL, ALLOCATABLE, SAVE :: GROWTH_BUDGET( : )

! Initial Reference Values for M2 and M3 used for Heterogenous Chemistry
! Module.
      REAL( 8 ), ALLOCATABLE, SAVE :: CHEM_M2DRY_INIT( :,:,:,: ),
     &                          CHEM_M3DRY_INIT( :,:,:,: )

      Contains



C-----------------------------------------------------------------------
      Subroutine map_mode_mask( mode_mask_in, mode_mask )
C     Maps the mode mask indices to a vector of logicals correpsonding
C     to the mode mask.
C-----------------------------------------------------------------------
      IMPLICIT NONE

      integer :: mode_mask_in
      logical :: mode_mask( n_mode )

      ! Select Correct Mode Mask
      SELECT CASE ( MODE_MASK_IN )
         CASE( IM_ALL )
            MODE_MASK = AEROMODE%ALL_MASK
         CASE( IM_UF )
            MODE_MASK = AEROMODE%ULTRAFINE_MASK
         CASE( IM_F )
            MODE_MASK = AEROMODE%FINE_MASK
         CASE( IM_C )
            MODE_MASK = AEROMODE%COARSE_MASK
         CASE( IM_ACC )
            MODE_MASK = AEROMODE%ACCUM_MASK
         CASE( IM_AIT )
            MODE_MASK = AEROMODE%AITKEN_MASK
         CASE( IM_NUC )
            MODE_MASK = AEROMODE%NUC_MASK
         CASE DEFAULT
            MODE_MASK = .FALSE.
      END SELECT

      End Subroutine map_mode_mask

C-----------------------------------------------------------------------
      Subroutine map_aero()

C  Defines aerosol mapping from CGRID for species concentration and moments.
 
C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C HS  01/24/11 Renamed AORGPA as POC for AERO6
C GS  03/02/11 Find new req`d species for AERO6 (Mg, K, Ca)
C HS  03/10/11 Get index for new required species, PNCOM
C JY  03/22/16 Get index for new required species: Fe, Mn (aqchem)
C HOTP 05/11/16 Add IEPOX derived species
C-----------------------------------------------------------------------

      Use rxns_data       ! chemical mechanism data
      Use cgrid_spcs      ! CGRID mechanism species
      Use const
      Use vdiff_data, only : n_spc_diff, diff_spc
      Use hlconst_mod, only : hlindex
      Implicit None

C Local Variables:
      Character( 256 ) :: xmsg
      Character( 256 ) :: xmsg2
      Real    :: mole_weight( n_aerolist )
      Integer :: map_listtogrid( n_aerolist,n_mode )
      Integer :: map_aerotolist( n_aerolist )

      Integer,       Allocatable :: aerospc_in_dustlist( : )
      Character(16), Allocatable :: refractive_index( : )

      Integer l, m, n, spc, isea, idust, p, ipfas
      Real    so4fac
      Real    anthfac

      Real    POA_OC    ! ratio of Elemental Oxygen to Carbon in POA
      Real    OOA_OC    ! ratio of Elemental Oxygen to Carbon in Oxygenated OA

      Integer dust_org1, dust_org2
      Logical ae6isoa
      Logical ae6hg
      Logical dust_match
      Logical new_bulk_species
      Logical replace_optics_surr
      Logical lerror_hlc

      Character(16) sn

      If ( mapped ) Return

      Call LOG_SUBHEADING( LOGDEV, "Map Aerosol Species" )

      mole_weight = 0.0

      n_aerospc      = 0   ! Number of Used Aerosol Chemical Species
      map_listtogrid = 0   ! Pointer from aerolist to CGRID
      map_aerotolist = 0   ! Pointer from aerospc to aerolist
      AE_eflag       = .False.
      max_l2sg       = ( LOG( max_sigma_g ) ) ** 2
      min_l2sg       = ( LOG( min_sigma_g ) ) ** 2
      def_l2sg( : )  = ( LOG( def_sigma_g( : ) ) ) ** 2
      

      allocate( aerocgrid_rhoinv( n_ae_trns ),
     &          l_aesp_num( n_ae_spc ),
     &          l_aesp_srf( n_ae_spc ), l_aesp_mass( n_ae_spc ),
     &          l_aesp_mode( n_mode,n_ae_spc ), l_aesp_dry( n_ae_spc ),
     &          l_aetr_num( n_ae_trns ),
     &          l_aetr_srf( n_ae_trns ), l_aetr_mass( n_ae_trns ),
     &          l_aetr_mode( n_mode,n_ae_trns ), l_aetr_dry( n_ae_trns ) )

      Allocate( refractive_index( n_aerolist ) )
      refractive_index( : ) = aerolist( : )%optic_surr

      aerocgrid_rhoinv = 0.
      l_aesp_num = .False.
      l_aesp_srf = .False.
      l_aesp_mass= .False.
      l_aesp_mode= .False.
      l_aesp_dry = .False.
      l_aetr_num = .False.
      l_aetr_srf = .False.
      l_aetr_mass= .False.
      l_aetr_mode= .False.
      l_aetr_dry = .False.

C Build mapping to CGRID for each species in the master AeroList
      Do spc = 1, n_aerolist
         ! Check to see if this species is in the namelist
         replace_optics_surr = .False.
         do m = 1,n_mode
            if ( m .eq. n_mode .and. 
     &           (aerolist( spc )%bulkname .eq. 'ACORS'    .or.
     &            aerolist( spc )%bulkname .eq. 'ASOIL'    .or.
     &            aerolist( spc )%bulkname .eq. 'ASEACAT'  .or.
     &            aerolist( spc )%bulkname .eq. 'ADE_CORS' )    ) then
              sn = aerolist( spc )%bulkname
            else
              sn = trim( aerolist( spc )%bulkname ) // modesuff( m )
            end if

            n = index1( sn, n_ae_spc, ae_spc )
            p = index1( sn, n_ae_trns, ae_trns )

            If ( n .Ne. 0 ) Then
               If( Len_Trim( ae_optics( n ) ) .gt. 0 )Then
                  replace_optics_surr  = .True.
               End If   
               ! Species is on the NameList
               new_bulk_species = ( .Not. Any( map_listtogrid( spc,: ) .NE. 0 ) )
               If ( new_bulk_species ) Then
                  ! Add this species to the map if it does not exist already
                  n_aerospc = n_aerospc + 1
                  map_aerotolist( n_aerospc ) = spc
                  ! Set the Molecular Weight
                  mole_weight( spc ) = ae_molwt( n )
                  If( replace_optics_surr )refractive_index( spc ) = ae_optics( n )                      
               Else If ( mole_weight( spc ) .Ne. ae_molwt( n ) ) Then
                  ! If the species already exists and the
                  ! molecular weight from this mode on the
                  ! namelist is not matching the standing
                  ! molecular weight, throw an error
                  xmsg = 'The molecular weight of ' // Trim( sn )
     &                  // ' is different from that of the same species'
     &                  // ' in the same or another mode.'
                  Call m3warn( pname, 0, 0, xmsg )
                  Write( xmsg,* ) 'New Value(', n, ') = ', ae_molwt( n ),
     &                            'Expected value(', spc, ')= ', mole_weight( spc )
                  Call m3warn( pname, 0, 0, xmsg )
                  AE_eflag  = .True.
               Else If ( replace_optics_surr ) Then 
                  If ( refractive_index( spc ) .Ne. ae_optics( n ) ) Then
                     ! If the species already exists and the
                     ! namelist's refractive index for the mode
                     ! does not match the new value,
                     ! write message and set error flag
                     xmsg = 'FATAL ERROR: In AErosol namelist, OPTICS value ' 
     &                    // 'for bulk ' // Trim( aerolist( spc )%bulkname )
     &                    // ' is inconsistent across modes. CORRECT the AE namelist'
                     Call m3mesg( xmsg )
                     If( Len_Trim( ae_optics( n ) ) .lt. 1 ) Then
                        xmsg2 = 'blank'
                     Else
                        xmsg2 = Trim( ae_optics( n ) )
                     End If
                     Write( xmsg,* ) 'Bad Value is ', Trim( xmsg2 ),
     &               '; Expected value is ', Trim( refractive_index( spc ) )
                     Call m3mesg( xmsg )
                     AE_eflag  = .True.
                  End If   
               End If
               ! Update the map from CGRID to AeroList for this mode
               map_listtogrid( spc,m ) = ae_strt - 1 + n
               l_aesp_mode( m,n ) = .True.
               l_aetr_mode( m,p ) = .True.
               If ( .Not. aerolist( spc)%tracer ) then
                   l_aesp_mass( n ) = .True.
                   if ( p .gt. 0 ) l_aetr_mass( p ) = .True.
               End If
               If ( .Not. aerolist( spc)%no_m2wet ) then
                   l_aesp_dry( n ) = .True.
                   if ( p .gt. 0 ) l_aetr_dry( p ) = .True.
               End If
               !Map the CGRID Aerosol Species to their Densities
               aerocgrid_rhoinv( n ) = 1.0 / aerolist( spc )%density

            End If
         End Do
      End Do

      ! Migrate all of the user-requested aerosols from AeroList to
      ! AeroSpc. Begin by allocating all of the new arrays now that we
      ! know the value of n_aerospc
      Allocate ( aerospc       ( n_aerospc ) )
      Allocate ( aerospc_mw    ( n_aerospc ) )
      Allocate ( aerospc_mwinv ( n_aerospc ) )
      Allocate ( aerospc_map   ( n_aerospc, n_mode ) )
      Allocate ( aerospc_conc  ( n_aerospc, n_mode ) )
      Allocate ( aero_missing  ( n_aerospc, n_mode ) )

#ifdef sens
      Allocate ( s_aerospc_conc( n_aerospc,n_mode,npmax ) )
#endif

      aero_missing( :,: ) = .True.
      aerospc_conc( :,: ) = conmin

      Do spc = 1, n_aerospc ! Loop through user-requested chemical species
         l = map_aerotolist( spc )

         ! Map AeroList Contents to AeroSpc
         aerospc( spc )%bulkname   = aerolist( l )%bulkname   
         aerospc( spc )%lait       = aerolist( l )%lait
         aerospc( spc )%lacc       = aerolist( l )%lacc
         aerospc( spc )%lcor       = aerolist( l )%lcor
         aerospc( spc )%min_conc   = aerolist( l )%min_conc
         aerospc( spc )%density    = aerolist( l )%density   
         aerospc( spc )%gasname    = aerolist( l )%gasname   
         aerospc( spc )%ctrname    = aerolist( l )%ctrname   
         aerospc( spc )%ctr_yield  = aerolist( l )%ctr_yield
         aerospc( spc )%voltype    = aerolist( l )%voltype
         aerospc( spc )%no_M2wet   = aerolist( l )%no_M2Wet   
         aerospc( spc )%tracer     = aerolist( l )%tracer     
         aerospc( spc )%charge     = aerolist( l )%charge     
         aerospc( spc )%visual_idx = aerolist( l )%visual_idx 
         aerospc( spc )%visual_idx_large = aerolist( l )%visual_idx_large
         aerospc( spc )%om         = aerolist( l )%om
         aerospc( spc )%optic_surr = refractive_index( l ) 
         aerospc( spc )%kappaorg   = aerolist( l )%kappaorg
         aerospc( spc )%name( : )  = ''

         If ( aerospc( spc )%optic_surr .Ne. aerolist( l )%optic_surr ) Then
            xmsg  = 'For aerosol species, ' // Trim( aerospc( spc )%bulkname )
     &            // ', setting refactive index to '
     &            // Trim( aerospc( spc )%optic_surr ) // ' instead of '
     &            // Trim(  aerolist( l )%optic_surr )
            write(logdev,'(a)')Trim( xmsg )
         End If   

         ! Map mode-independent properties
         aerospc_mw( spc ) = mole_weight( l )
         aerospc_mwinv( spc ) = 1.0E0 / aerospc_mw( spc )

         Do n = 1,n_mode
            ! Map the Modal-Dependent CGRID Pointers from AeroSpc to AeroList
            aerospc_map( spc, n ) = map_listtogrid( l, n )

            ! Remove this Chemical/Mode Combination from the "missing" list 
            ! if it can be mapped to the cgrid list of variables
            if ( aerospc_map( spc,n ) .ne. 0 ) then
                aero_missing( spc,n ) = .False.
                ! Create Mode-Dependent Names
                if ( aerospc( spc )%bulkname .eq. 'ACORS'    .or.
     &               aerospc( spc )%bulkname .eq. 'ASOIL'    .or.
     &               aerospc( spc )%bulkname .eq. 'ASEACAT'  .or.
     &               aerospc( spc )%bulkname .eq. 'ADE_CORS'     ) then
                   aerospc( spc )%name( n ) = trim( aerospc( spc )%bulkname )
                else
                   aerospc( spc )%name( n ) = 
     &                 trim( aerospc( spc )%bulkname ) // modesuff( n )
                end if
            end if
         End Do

      End Do

C Build mapping to CGRID for aero # and surf area variables
      aeronum_map = 0
      aerosrf_map = 0

      Do m = 1, n_mode
         n = index1( aeromode( m )%num_name , n_ae_spc, ae_spc )
         p = index1( aeromode( m )%num_name , n_ae_trns, ae_trns )
         If ( n .Eq. 0 ) Then
            xmsg = 'Species ' // Trim( aeromode( m )%num_name )
     &           //' is not in AE namelist'
            AE_eflag  = .True.
            Call m3warn( pname, 0, 0, xmsg )
!            Call m3exit( pname, 0, 0, xmsg, xstat3 )
         Else
            aeronum_map( m ) = ae_strt - 1 + n
            aerocgrid_rhoinv( n ) = 1.0
            l_aesp_num( n ) = .True.
            l_aesp_mode( m,n ) = .True.
            if ( p .gt. 0 ) then 
               l_aetr_num( p ) = .True.
               l_aetr_mode( m,p ) = .True.
            end if
         End If

         n = index1( aeromode( m )%srf_name , n_ae_spc, ae_spc )
         p = index1( aeromode( m )%srf_name , n_ae_trns, ae_trns )
         If ( n .Eq. 0 ) Then
            xmsg = 'species ' // Trim( aeromode( m )%srf_name )
     &           // ' is not in AE namelist'
            AE_eflag  = .True.
            Call m3warn( pname, 0, 0, xmsg )
         Else
            aerosrf_map( m ) = ae_strt - 1 + n
            aerocgrid_rhoinv( n ) = 1.0
            l_aesp_srf( n ) = .True.
            l_aesp_mode( m,n ) = .True.
            if ( p .gt. 0 ) then 
               l_aetr_srf( p ) = .True.
               l_aetr_mode( m,p ) = .True.
            end if
         End If
      End Do

C Find indices of required species
      aso4_idx    = findAero( req_so4,    .True. )
      ano3_idx    = findAero( req_no3,    .True. )
      acl_idx     = findAero( req_cl,     .True. )
      anh4_idx    = findAero( req_nh4,    .True. )
      ana_idx     = findAero( req_na,     .True. )
      amg_idx     = findAero( req_mg,     .True. )
      ak_idx      = findAero( req_k,      .True. )
      aca_idx     = findAero( req_ca,     .True. )
      afe_idx     = findAero( req_fe,     .True. )
      amn_idx     = findAero( req_mn,     .True. )
      ah2o_idx    = findAero( req_h2o,    .True. )
      ah3op_idx   = findAero( req_h3op,   .True. )
      asoil_idx   = findAero( req_soil,   .True. )
      acors_idx   = findAero( req_cors,   .True. )
      aseacat_idx = findAero( req_seacat, .True. )
      apoc_idx    = findAero( req_poc,    .True. )
      apncom_idx  = findAero( req_ncom,   .True. )

      If ( ( Index( mechname, 'CRACMM3' ) .Gt. 0 ) ) Then
         aseast_idx  = findAero( req_seast,  .True. )
      End If

      If ( ( Index( mechname, 'SAPRC07TIC_AE7I' ) .Gt. 0 ) ) Then
         ae6isoa     = .True.
         aietet_idx  = findAero( req_ietet, ae6isoa )
         aieos_idx   = findAero( req_ieos,  ae6isoa )
         adim_idx    = findAero( req_dim,   ae6isoa )
         aimga_idx   = findAero( req_imga,  ae6isoa )
         aimos_idx   = findAero( req_imos,  ae6isoa )
      Else
         aietet_idx  = 0
         aieos_idx   = 0
         adim_idx    = 0
         aimga_idx   = 0
         aimos_idx   = 0
         ae6isoa     = .False.
      End If

       If ( Index( mechname, 'CB6R5M_AE7_AQ' ) .Gt. 0 ) Then     
         abr_idx     = findAero( req_br,     .True. )
         marine = .True.
      Else
         abr_idx     = 0
         marine = .False.
      End If

      aphgj_idx = findAero( req_phgj,  .False. )
      If ( aphgj_idx .Gt. 0 ) Then
         ae6hg     = .True.
      Else
         aphgj_idx = 0 
         ae6hg     = .False.
      End If

C AORGH2O is not required, but highly recommended for aero7
      aorgh2o_idx = findAero( req_orgh2o,  .False. )
      If ( aorgh2o_idx .Gt. 0 ) Then
         ae7orgh2o   = .True.
      Else
         aorgh2o_idx = 0
         ae7orgh2o   = .False.
      End If

      If ( stm ) Then
         aso4aqh2o2_idx = findAero( req_so4aqh2o2, .True. )
         aso4aqo3_idx   = findAero( req_so4aqo3,   .True. )
         aso4aqfemn_idx = findAero( req_so4aqfemn, .True. )
         aso4aqmhp_idx  = findAero( req_so4aqmhp,  .True. )
         aso4aqpaa_idx  = findAero( req_so4aqpaa,  .True. )
         aso4gas_idx    = findAero( req_so4gas,    .True. )
         aso4emis_idx   = findAero( req_so4emis,   .True. )
         aso4icbc_idx   = findAero( req_so4icbc,   .True. )
         If ( ( ae6isoa ) .OR.
     &        ( Index( mechname, 'CRACMM2'         ) .Gt. 0 ) .OR.
     &        ( Index( mechname, 'CRACMM3'         ) .Gt. 0 ) .OR.
     &        ( Index( mechname, 'CB6R5_AE7'       ) .Gt. 0 ) .OR.
     &        ( Index( mechname, 'CB6R5M_AE7'      ) .Gt. 0 ) ) Then
            oso4_idx       = findAero( req_oso4,       .True. )
            oso4aqh2o2_idx = findAero( req_oso4aqh2o2, .True. )
            oso4aqo3_idx   = findAero( req_oso4aqo3,   .True. )
            oso4aqfemn_idx = findAero( req_oso4aqfemn, .True. )
            oso4aqmhp_idx  = findAero( req_oso4aqmhp,  .True. )
            oso4aqpaa_idx  = findAero( req_oso4aqpaa,  .True. )
            oso4gas_idx    = findAero( req_oso4gas,    .True. )
            oso4emis_idx   = findAero( req_oso4emis,   .True. )
            oso4icbc_idx   = findAero( req_oso4icbc,   .True. )
         EndIf
      EndIf

C Compute common factors
      h2ofac = 1.0D-9 * f6dpi / Real( aerospc( ah2o_idx )%density, 8 )

C compute aeromode_minNum and aeromode_minM2
      so4fac  = 1.0E-9 * Real( f6dpi, 4 ) / aerospc( aso4_idx )%density
      anthfac = 1.0E-9 * Real( f6dpi, 4 ) / aerospc( acors_idx )%density

      Do m = 1, n_mode
         If ( m .Lt. n_mode ) Then
            aeromode_minNum( m ) = aerospc( aso4_idx )%min_conc( m ) /
     &           ( def_diam( m )**3 * Exp( 4.5 * Log( def_sigma_g( m ) )**2 ) )
            aeromode_minNum( m ) = aeromode_minNum( m ) * so4fac 
            aeromode_minNum( m ) = Max( aeromode_minNum( m ), conmin )
         Else
            aeromode_minNum( m ) = aerospc( acors_idx )%min_conc( m ) /
     &           ( def_diam( m )**3 * Exp( 4.5 * Log( def_sigma_g( m ) )**2 ) )
            aeromode_minNum( m ) = aeromode_minNum( m ) * anthfac 
            aeromode_minNum( m ) = Max( aeromode_minNum( m ), conmin )
         End If
         aeromode_minM2( m ) = aeromode_minNum( m ) *
     &             def_diam( m )**2 * Exp( 2.0 * Log( def_sigma_g( m ) )**2 )
      End do

      ! Substitute Gas and Rxn Counter Names for CGRID names
      Do spc = 1,n_aerospc
         If ( aerospc( spc )%gasname .ne. '' ) Then
            Do l = 1,n_gc_g2ae
                If ( aerospc( spc )%gasname .eq. gc_g2ae( l ) )
     &               aerospc( spc )%gasname = gc_spc( gc_g2ae_map(l) )                
            End Do
            Do l = 1,n_nr_n2ae
                If ( aerospc( spc )%gasname .eq. nr_n2ae( l ) )
     &               aerospc( spc )%gasname = nr_spc( nr_n2ae_map(l) )                
            End Do
         End If
         If ( aerospc( spc )%ctrname .ne. '' ) Then
            Do l = 1,n_gc_g2ae
                If ( aerospc( spc )%ctrname .eq. gc_g2ae( l ) )
     &               aerospc( spc )%ctrname = gc_spc( gc_g2ae_map(l) )                
            End Do
            Do l = 1,n_nr_n2ae
                If ( aerospc( spc )%ctrname .eq. nr_n2ae( l ) )
     &               aerospc( spc )%ctrname = nr_spc( nr_n2ae_map(l) )                
            End Do
         End If
      End Do

      ! Exit if Errors are Detected
      if( AE_eflag )Then
         Write(logdev,99901) Trim( mechname )
          xmsg = 'FATAL errors found in namelist used. Check '
     &    //  'the log of exiting processor if more details are needed.'
         Call m3exit( pname, 0, 0, xmsg, xstat3 )
      End If 

      ! Map PFAS Compounds to the Aerosol and Gas Arrays
      MAP_PFAStoAERO = 0
      MAP_PFAStoGAS  = 0
      lerror_hlc = .false.
      do ipfas = 1,npfas
         ! Map PFAS to Aerosol Array
         n = index1( pfas(ipfas)%aername, n_aerospc, aerospc(:)%bulkname )
         if ( n .ne. 0 ) MAP_PFAStoAERO( IPFAS ) = n
         if ( pfas(ipfas)%aername .eq. '' ) MAP_PFAStoAERO( ipfas ) = 0

         ! Map PFAS to CGRID Array for Gases
         n = index1( pfas(ipfas)%gasname, nspcsd, cgrid_name )
         if ( n .ne. 0 ) MAP_PFAStoGAS( IPFAS ) = n
         if ( pfas(ipfas)%gasname .eq. '' ) MAP_PFAStoGAS( ipfas ) = 0

         ! Map Henry's Law Constants
         if ( MAP_PFAStoGAS( ipfas ) .ne. 0 ) then
            sn = cgrid_scav( MAP_PFAStoGAS( ipfas ) )
            if ( sn .ne. '' ) then
               call hlindex( sn, pfas( ipfas )%HLC, lerror_hlc )    
            end if
         end if

      enddo 

      ! Check for missing PFAS Henry's Law Constants
      if ( lerror_hlc ) then
         xmsg = ' Missing PFAS species required for computing Henry''s law constants'
         call m3exit( pname, 0, 0, xmsg, xstat2 )
      end if



      mapped = .True.

99901 Format( 'FATAL Error(s) found in the AE namelist used. Check that' 
     &  /' this AE namelist contains the above required data '
     &  / 'as the file in '
     &  /'the repository version of the mechanism: ', a )
      Return
      End Subroutine map_aero

C-----------------------------------------------------------------------
#ifdef sens
      Subroutine extract_aero( conc, minchk, s_conc, schk )
#else
      Subroutine extract_aero( conc, minchk )
#endif

C  Extracts aerosol data into the AERO_DATA:aerospc_conc array
C  The original idea is that the data for conc comes from CGRID
C  Also transfers dry surface area to wet 2nd moment.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     4/2016: Updated for 2nd moment by H. Pye and B. Murphy
C-----------------------------------------------------------------------

      Use const, only : pi, f6pi

      Implicit None

C Arguments:
      Real,    Intent( In ) :: conc( : )
      Logical, Intent( In ) :: minchk
#ifdef sens
      Real,    Intent( In ) :: s_conc( :,: )
      Logical, Intent( In ) :: schk  ! necessary because some routines don't require sensitivity updates
#endif

C Local Variables:
      Integer m, n, spc

      If ( .Not. mapped ) Then
         Call map_aero()
      End If

#ifdef sens
      If ( schk ) Then
         If ( .Not. ae_ddm3d_ready ) Then
            Call init_aero_ddm3d()
         End If
      End If
#endif

C Copy grid cell concentrations of aero species to aerospc_conc
      aerospc_conc = 0.0
#ifdef sens
      If ( schk ) Then
         s_aerospc_conc = 0.0D0
      End If
#endif
      If ( minchk ) Then
         Do m = 1, n_mode
            Do spc = 1, n_aerospc
               n = aerospc_map( spc,m )
               If ( n .Ne. 0 ) Then
                  aerospc_conc( spc,m ) = Max( conc( n ), aerospc( spc )%min_conc( m ) ) ! [ug/m^3]
#ifdef sens
                  If ( schk ) Then
                     Do np = 1, npmax
                        If ( aerospc_conc( spc,m ) .Eq. aerospc( spc )%min_conc( m ) ) Then
                           s_aerospc_conc( spc,m,np ) = 0.0D0
                        Else
                           s_aerospc_conc( spc,m,np ) = Real( s_conc( np,n ), 8 )
                        End If
                     End Do
                  End If
#endif
               End If
            End Do
         End Do
      Else
         Do m = 1, n_mode
            Do spc = 1, n_aerospc
               n = aerospc_map( spc,m )
               If ( n .Ne. 0 ) Then
                  aerospc_conc( spc,m ) = conc( n )   ! [ug/m^3]
#ifdef sens
                  If ( schk ) Then
                     Do np = 1, npmax
                        s_aerospc_conc( spc,m,np ) = Real( s_conc( np,n ), 8 )
                     End Do
                  End If
#endif
               End If
            End Do
         End Do
      End If

      ! Calculate Dry Third Moment [ m3 / m3 ]
      Do m = 1, n_mode
         moment3_conc( m ) = sum( aerospc_conc(:,m) / aerospc(:)%density,
     &      MASK= ( ( .NOT. aerospc%no_M2wet ) .AND.
     &              ( .NOT. aerospc%Tracer ) ) )
         moment3_conc( m ) = max( moment3_conc( m ) * 1.0E-9 * f6pi,
     &                            aeromode( m )%min_m3conc )
      End Do

C Copy grid cell concentrations of aero # and surf area
C Convert surface area to M2 and set wet_moments_flag

      moment0_conc = 0.0
      moment2_conc = 0.0

      If ( minchk ) Then
         Do m = 1, n_mode
            n = aeronum_map( m )
            moment0_conc( m ) = Max( conc( n ), aeromode( m )%min_numconc )
            n = aerosrf_map( m )
            moment2_conc( m ) = Max( conc( n ) / pi, aeromode( m )%min_m2conc )
         End Do
      Else
         Do m = 1, n_mode
            n = aeronum_map( m )
            moment0_conc( m ) = conc( n )
            n = aerosrf_map( m )
            moment2_conc( m ) = conc( n ) / pi
         End Do
      End If
      wet_moments_flag = .false.

C Convert dry 2,3 moment to wet 2,3 moment
C flag will be set to .true.
      Call calcmoments( .true. )

      Return
      End Subroutine extract_aero

C-----------------------------------------------------------------------
#ifdef sens
      Subroutine update_aero( conc, minchk, s_conc )
#else
      Subroutine update_aero( conc, minchk )
#endif

C  Updates conc from the AERO_DATA:aerospc_conc array.
C  The original idea is that the data in conc updates CGRID
C  Update_aero now also saves the updated surface area back to CGRID as
C  well. Moment2 will be dried if necessary and flag reset.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     4/2016: Updated for 2nd moment by H. Pye and B. Murphy
C-----------------------------------------------------------------------

      Use const, only : pi

      Implicit None

C Arguments:
      Real, Intent( Out ) :: conc( : )
      Logical, Intent( In ) :: minchk
#ifdef sens 
      Real,    Intent( Out ) :: s_conc( :,: )
#endif

C Local variables:
      Character( 80 ) :: xmsg
      Integer m, n, spc

      If ( .Not. mapped ) Then
         xmsg = 'CGRID Species has not been mapped'
         Call m3exit( pname, 0, 0, xmsg, xstat3 )
      End If

C Copy aerospc_conc back to grid cell concentrations

      If ( minchk ) Then
         Do m = 1, n_mode
            Do spc = 1, n_aerospc
               n = aerospc_map( spc,m )
               If ( n .Ne. 0 ) Then
                    conc( n ) = Max( aerospc_conc( spc,m ), aerospc( spc )%min_conc( m ) )
#ifdef sens
                    Do np = 1, npmax
                       If ( conc( n ) .Eq. aerospc( spc )%min_conc( m ) ) Then
                          s_conc( np,n ) = 0.0
                       Else
                          s_conc( np,n ) = Real( s_aerospc_conc( spc,m,np ), 4 )
                       End If
                    End Do
#endif
               End If
            End Do
         End Do
      Else
         Do m = 1, n_mode
            Do spc = 1, n_aerospc
               n = aerospc_map( spc,m )
               If ( n .Ne. 0 ) Then
                    conc( n ) = aerospc_conc( spc,m )
#ifdef sens
                    Do np = 1, npmax
                       s_conc( np,n ) = Real( s_aerospc_conc( spc,m,np ), 4 )
                    End Do
#endif
               End If
            End Do
         End Do
      End If

C Copy aero number and surface area back to grid cell concentrations

      If ( minchk ) Then
         Do m = 1, n_mode
            n = aeronum_map( m )
            conc( n ) = Max( moment0_conc( m ), aeromode( m )%min_numconc )
         End Do
      Else
         Do m = 1, n_mode
            n = aeronum_map( m )
            conc( n ) = moment0_conc( m )
         End Do
      End If

C Save dry second moment to surface area (with pi conversion)
      If ( wet_moments_flag ) Then
         Call calcmoments( .False. ) ! called with the F flag, returns dry moments
      End If

      Do m = 1, n_mode
         n = aerosrf_map( m )
         conc( n ) = Real( pi, 4 ) * moment2_conc( m )
      End Do

      Return
      End Subroutine update_aero

C-----------------------------------------------------------------------
      Function findAero( vname, required ) Result ( idx )

C  Finds the index of 'required' aerosol species in the aerospc list

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C-----------------------------------------------------------------------

      Implicit None

C Arguments:
      Character( 16 ) :: vname
      Logical :: required
      Integer :: idx

C Local Variables:
      Character( 80 ) :: xmsg
      Integer spc, n

      idx = 0
C Find the substring vname in aerospc( spc )%name( n )
      Do spc = 1, n_aerospc
         If ( aerospc( spc )%bulkname .eq. vname ) Then
            idx = spc
            xmsg = 'Aerosol Species '
     &             // Trim( vname ) // ' found in AE namelist.'
            write(logdev,'(5x,a)') xmsg
            Return
         End If
         Do n = 1, n_mode
            If ( aerospc( spc )%name( n ) .eq. vname ) Then
               idx = spc
               xmsg = 'Aerosol Species '
     &                // Trim( vname ) // ' found in AE namelist.'
               write(logdev,'(5x,a)') xmsg
               Return
            End If
         End Do
      End Do

      If ( .Not. required ) Return

      xmsg = 'Required Species ' // Trim( vname ) // 
     &       ' Not found in AE namelist'
      AE_eflag  = .True.
      Call m3warn( pname, 0, 0, xmsg )

      Return
      End Function findAero

C-----------------------------------------------------------------------
      Subroutine calcmoments( addwet )

C Subroutine calculates wet (addwet=T) or dry (addwet=F) aerosol third
C and second moment and stores them in moment_conc arrays and
C updates wet_moments_flag.
C Note that third moment information will be overwritten no matter what
C the wet_moments_flag indicates. M2 will depend on the history
C of the moment (wet_moments_flag). This routine will not update
C M2 in the event of added mass due to processes other than
C wetting/drying.
C
C Notes:
C wet_moments_flag is obtained from AERO_DATA ! true =  H2O and SOA included in 2,3 moment
C                                             ! false = H2O and SOA excluded from 2,3 moment
C wet_moments_flag reflects the current state of the moment2,3_conc arrays.
C addwet will results in wet (T) or dry (F) moments.
C
C History:
C 4/2016: HOT Pye Created routine
C
C-----------------------------------------------------------------------

      Use const, only: f6dpi, f6pi

      Implicit None

C Arguments:
      Logical :: addwet ! T: result in wet m3 and m2, F: result in dry m3 and m2

C Parameters:
      Real( 8 ), Parameter :: two3rds = 2.0D0 / 3.0D0

C Local variables:
      Integer :: spc, n ! loop variable
      Real( 4 ) :: m3( n_mode )       ! wet or dry M3
      Real( 4 ) :: m2( n_mode )       ! wet or dry M2
      Real( 8 ) :: drysumM3  ! dry M3 [ m**3 / m**3 ]
      Real( 8 ) :: wetsumM3  ! wet M3 [ m**3 / m**3 ]
      Real( 8 ) :: factor
      Real( 4 ) :: initialM3 ! initial M3 from moment3_conc [ m**3 /m**3 ]
      Real( 4 ) :: initialM2 ! initial M2 from moment2_conc [ m**2 /m**3 ]

      Character( 16 )  :: pname_loc = 'CalcMoments'
      Character( 100 ) :: xmsg

C *** Calculate aerosol 3rd moment concentrations [ m**3 / m**3 ], 2nd
C     moment [ m**2/m**3 ]

      If( addwet ) then

         Do n = 1, n_mode
            initialM2 = moment2_conc( n )
            If ( initialM2 .Eq. 0.0 ) Then
                write( xmsg,'(A32,I1,A42)') "Warning: Second Moment for Mode ",
     &                 n," is 0.0. This will cause numerical issues."
                Call m3warn( pname_loc, 0, 0, xmsg )
            End If

            initialM3 = max( moment3_conc( n ), aeromode( n )%min_m3conc )
            If ( initialM3 .Eq. 0.0 ) Then
                write( xmsg,'(A31,I1,A42)') "Warning: Third Moment for Mode ",
     &                 n," is 0.0. This will cause numerical issues."
                call m3warn( pname_loc, 0, 0, xmsg )
            End If

            wetsumM3 = 0.0d0
            Do spc = 1, n_aerospc
               If ( aerospc( spc )%tracer .Or. aero_missing(spc,n) ) Cycle
               factor = Real( 1.0E-9 * f6pi / aerospc( spc )%density, 8 )
               wetsumM3  = wetsumM3 + factor * Real( aerospc_conc( spc,n ), 8 )
            End Do
            m3( n ) = Max ( Real( wetsumM3, 4 ), aeromode( n )%min_m3conc )
            If ( wet_moments_flag ) Then
               m2( n ) = initialM2
            Else
               m2( n ) = initialM2 * ( Real( wetsumM3, 4 ) / initialM3 ) ** Real( two3rds, 4 )
            End if
         End Do

         ! Save back to aero_data variables
         moment2_conc( : ) = m2( : )
         moment3_conc( : ) = m3( : )
         wet_moments_flag = .True.

      Else ! produce dry moments

         Do n = 1, n_mode
            initialM2 = moment2_conc( n )
            If ( initialM2 .Eq. 0.0 )  Then
                write( xmsg,'(A32,I1,A42)') "Warning: Second Moment for Mode ",
     &                 n," is 0.0. This will cause numerical issues."
                Call m3warn( pname_loc, 0, 0, xmsg )
            End If

            initialM3 = max( moment3_conc( n ), aeromode( n )%min_m3conc )
            If ( initialM3 .Eq. 0.0 )  Then
                write( xmsg,'(A31,I1,A42)') "Warning: Third Moment for Mode ",
     &                 n," is 0.0. This will cause numerical issues."
                Call m3warn( pname_loc, 0, 0, xmsg )
            End If

            drysumM3 = 0.0d0
            Do spc = 1, n_aerospc
               If ( aerospc( spc )%tracer .Or. aero_missing(spc,n) .Or.
     &              aerospc( spc )%no_M2Wet  ) Cycle
               factor = Real( 1.0E-9 * f6pi /  aerospc( spc )%density, 8 )
               drysumM3  = drysumM3 + factor * Real( aerospc_conc( spc,n ), 8 )
            End Do
            m3( n ) = Max ( Real( drysumM3, 4 ), aeromode( n )%min_m3conc )
            If ( wet_moments_flag) Then
               m2( n ) = initialM2 * ( Real( drysumM3, 4 ) / initialM3 ) ** Real( two3rds, 4 )
            Else ! already dry
               m2( n ) = initialM2
            End If
         End Do

         ! Save back to aero_data variables
         moment2_conc( : ) = m2( : )
         moment3_conc( : ) = m3( : )
         wet_moments_flag = .False.

      End If

      Return
      End Subroutine calcmoments

C
C-----------------------------------------------------------------------
      Subroutine CHECK_AERO_ICBC( IBCON0, LM2WET, USE_M2, IS_BC, 
     &                            L_WRITE_WARNING, COL, ROW, LAY )

C Subroutine checks that all size distributions from boundary and
C initial conditions are within tolerances for diameter and mode
C width. If any parameters are out of range or particle number or mass
C are neglgible, this routine will enforce default parameters and
C recalculate all three moments so that calculations in subsequent 
C modules are stable.
C
C Inputs:  IBCON - the actual initial or boundary condition vector of 
C                  concentrations from the calling routine
C          LM2WET - Logical identifying if the second moment of the 
C                   distribution is dry or wet. False = Dry. 'Wet'
C                   aerosol includes species for which the variable
C                   no_M2Wet is set to True in the aerolist.
C          USE_M2 - Logical prescribing whether or not to use
C                       the second moment from the input IC or BC file. 
C                       True = use the 2nd moment input from the file.
C          IS_BC - TRUE if this is for BCs, FALSE for ICs
C          L_WRITE_WARNING - Should a warning be printed if a size
C                            distribution fails
C
C 11 May 16  B.Murphy  Program Written
C
C-----------------------------------------------------------------------
      Use CONST, only : pi, f6pi
      Use CGRID_SPCS, only : N_AE_TRNS, N_AE_SPC
      Use HGRD_DEFN, ONLY : NROWS, NCOLS

#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE, SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE, NOOP_UTIL_MODULE)
#endif
#endif


      Implicit None

      REAL, INTENT(INOUT)   :: IBCON0( : )
      LOGICAL, INTENT( IN ) :: LM2WET          ! FALSE (Default) for Dry distribution parameters
                                               ! TRUE  for Wet distribution parameters
      LOGICAL, INTENT( IN ) :: USE_M2          ! TRUE (Default) to use second moment from input file
                                               ! FALSE  to ignore and overwrite M2 from input
                                                  ! file
      LOGICAL, INTENT( IN ) :: IS_BC           ! TRUE if BCON called this routine. 
                                               ! FALSE if ICON called it
      LOGICAL, INTENT( INOUT ) :: L_WRITE_WARNING ! TRUE if warning should be printed 
                                               ! when size distribution fails tests
      INTEGER, INTENT( IN ) :: COL, ROW, LAY

      INTEGER :: LSTAT( N_MODE ) ! 0 - Distribution is ok
                                 ! Nonzero values indicate problem with
                                 ! modal parameters. See below 
                                                                    ! | Before  After
      REAL(8) :: AER_PAR( 2, N_MODE, 8 ) !Track the modal parameters! |    N,    N
                                         !before and after the IC/BC! |  M2WET, M2WET
                                         !check routine             ! |  M2DRY, M2DRY
                                                                    ! |  M3WET, M3WET
                                                                    ! |  M3DRY, M3DRY
                                                                    ! |  dgwet, dgwet
                                                                    ! |  dgdry, dgdry
                                                                    ! |  sigma, sigma
      INTEGER, SAVE    :: J, SFX, EFX, NFX, WFX
      LOGICAL, SAVE    :: BNDY_PE_LOY, BNDY_PE_HIY,
     &                    BNDY_PE_LOX, BNDY_PE_HIX
      LOGICAL, SAVE    :: FIRST_TIME = .TRUE.
      LOGICAL          :: LBC

      REAL(8), PARAMETER  :: F1PI = 1.d0 / REAL(pi,8)
      REAL(8), PARAMETER  :: ONE_THIRD  = 1.0d0 / 3.0d0
      REAL(8), PARAMETER  :: TWO_THIRDS = 2.0d0 / 3.0d0
      CHARACTER( 199 ) :: XMSG2 = ' '
      
      ! Definition of Distribution Error Statuses (LSTAT):
      !    0 = All Parameters within Limits
      !    4 = Standard Deviation is just barely invalid. 
      !         Reset Surface Area but don't warn. (i.e. 1.04999 vs. 1.05)
      !    5 = Diameter is just barely invalid but Standard Deviation 
      !          is valid. Reset Number and Surface Area but don't warn.
      !    6 = Diameter and Standard Deviation are barely invalid. 
      !          Reset Number and Surface Area but don't warn.
      !    11 = Mass is below limit. Reset distribution to minimum valid
      !           concentration (i.e. conmin).
      !    12 = Number is below limit. Reset number and Surface Area
      !    13 = Surface Area is below limit but diameter is valid.
      !          Set standard deviation to default (def_l2sg) and reset 
      !          Surface Area.
      !    14 = Standard Deviation is invalid. Reset Surface Area.
      !    15 = Diameter is invalid but Standard Deviation is valid.
      !          Reset Number and Surface Area.
      !    16 = Diameter and Standard Deviation are invalid. Reset
      !          Number and Surface Area.


C Local variables:

      INTEGER   :: IMODE, IT, IS
      REAL(8), ALLOCATABLE :: IBCON(:)
      REAL(8)   :: NUM, M2, M3, M3DRY, M3WET, M2WET, M2DRY, 
     &             l2sg, dg, dgdry, dgwet, sg, l2sg_new
      REAL, Parameter :: KGPMG = 1.0E-9 !Kilogram per microgram m-3

      IF ( FIRST_TIME ) THEN
         FIRST_TIME = .FALSE.

#ifndef mpas
         ! Retrieve Info about boundary cells
         CALL SUBST_HI_LO_BND_PE ( 'R', BNDY_PE_LOY, BNDY_PE_HIY )
         CALL SUBST_HI_LO_BND_PE ( 'C', BNDY_PE_LOX, BNDY_PE_HIX )
#endif
         SFX = 0
         EFX = NCOLS + 1
         NFX = NCOLS + NROWS + 3
         WFX = 2 * NCOLS + NROWS + 4
      END IF

      ! First Determine Whether or Not this is a true Boundary
      ! Condition Processor and GridCell
      IF ( IS_BC ) THEN
          LBC = .FALSE.
          IF ( BNDY_PE_LOY .AND. ROW .GT. SFX .AND.
     &         ROW .LE. SFX+NCOLS ) LBC = .TRUE.
          
          IF ( BNDY_PE_HIX .AND. ROW .GT. EFX .AND.
     &         ROW .LE. EFX+NROWS ) LBC = .TRUE.

          IF ( BNDY_PE_HIY .AND. ROW .GT. NFX .AND.
     &         ROW .LE. NFX+NCOLS ) LBC = .TRUE.
          
          IF ( BNDY_PE_LOX .AND. ROW .GT. WFX .AND. 
     &         ROW .LE. WFX+NROWS ) LBC = .TRUE.
          
          IF ( .NOT. LBC ) RETURN

      END IF

      ! Initialize Aerosol ICBC Check Routine
      LSTAT    = 0
      AER_PAR = 0.0d0
      dg      = 0.0d0
      sg      = 0.0d0
       
      CALL MAP_AERO()
      ALLOCATE( IBCON( SIZE(IBCON0) ) )
      IBCON = REAL( IBCON0, 8 )

      !Loop Through Each Aerosol Mode. Sum up the third moment, then calculate 
      !the Dg and Sg of the mode and check to make sure they are valid. When 
      !checking Dg, use wet or dry diameter limits depending on the state of
      !the incoming (initial or boundary) size distribution.
      DO IMODE = 1,N_MODE

         IF ( IS_BC ) THEN
            ! IBCON is stored in order of Transported Aerosols
            NUM = SUM( IBCON( : ), MASK = ( L_AETR_MODE( IMODE,: ) .AND. L_AETR_NUM ) ) 
            M2  = SUM( IBCON( : ), MASK = ( L_AETR_MODE( IMODE,: ) .AND. L_AETR_SRF ) ) * F1PI
           
            M3DRY = SUM( IBCON( : ) * REAL( AEROCGRID_RHOINV * F6PI, 8), 
     &                   MASK = ( L_AETR_MASS .AND. L_AETR_MODE( IMODE,: )  
     &                            .AND. L_AETR_DRY ) ) 
            M3WET = SUM( IBCON( : ) * REAL( AEROCGRID_RHOINV * F6PI, 8), 
     &                   MASK = ( L_AETR_MASS .AND. L_AETR_MODE( IMODE,: ) ) )
         ELSE
            ! IBCON is stored in order of CGRID
            NUM = SUM( IBCON( : ), MASK = ( L_AESP_MODE( IMODE,: ) .AND. L_AESP_NUM ) )
            M2  = SUM( IBCON( : ), MASK = ( L_AESP_MODE( IMODE,: ) .AND. L_AESP_SRF ) ) * F1PI
           
            M3DRY = SUM( IBCON( : ) * REAL( AEROCGRID_RHOINV * F6PI, 8), 
     &                   MASK = ( L_AESP_MASS .AND. L_AESP_MODE( IMODE,: )  
     &                            .AND. L_AESP_DRY ) ) 
            M3WET = SUM( IBCON( : ) * REAL( AEROCGRID_RHOINV * F6PI, 8), 
     &                   MASK = ( L_AESP_MASS .AND. L_AESP_MODE( IMODE,: ) ) ) 
         END IF
         
         ! Store M2 as Wet or Dry
         IF ( LM2WET ) THEN
             M2WET = M2
             M2DRY = 0. 
         ELSE
             M2WET = 0.
             M2DRY = M2
         END IF
                
         ! If checking Boundary Conditions, the concentrations are
         ! already in kilograms, thus we do not need to convert them
         ! before applying aerosol density (kg m-3). If checking Initial
         ! Conditions, we do need to convert micrograms to kilograms.
         IF ( .NOT. IS_BC ) THEN 
             M3WET = M3WET * REAL( KGPMG,8)
             M3DRY = M3DRY * REAL( KGPMG,8)
         END IF

         AER_PAR ( 1, IMODE, 1 ) = NUM
         AER_PAR ( 1, IMODE, 2 ) = M2WET
         AER_PAR ( 1, IMODE, 3 ) = M2DRY
         AER_PAR ( 1, IMODE, 4 ) = M3WET
         AER_PAR ( 1, IMODE, 5 ) = M3DRY
         AER_PAR ( 1, IMODE, 6 ) = 0.    
         AER_PAR ( 1, IMODE, 7 ) = 0.    
         AER_PAR ( 1, IMODE, 8 ) = 0.    

         ! Begin Checking Aerosol Parameters. 
         IF ( M3DRY .LT. 1.1e-30 .OR. M3WET .LT. 1.1e-30 ) THEN
             ! Dry or Wet Mass is below limit -> reset distribution
             LSTAT( IMODE ) = 11

             ! Set Problematic Aerosol Mass to Minimum valid
             ! concentration (i.e. conmin) in Output Vector
             IF ( IS_BC ) THEN
                DO IT = 1,N_AE_TRNS
                  IF ( L_AETR_MODE( IMODE,IT ) .AND. L_AETR_MASS( IT ) ) 
     &               IBCON(IT) = MAX( IBCON(IT), CONMIND )
                END DO
                M3DRY = SUM( IBCON( : ) * REAL(AEROCGRID_RHOINV * F6PI,8), 
     &                       MASK = ( L_AETR_MASS .AND. L_AETR_MODE( IMODE,: )  
     &                                .AND. L_AETR_DRY ) ) 
                M3WET = SUM( IBCON( : ) * REAL(AEROCGRID_RHOINV * F6PI,8), 
     &                       MASK = ( L_AETR_MASS .AND. L_AETR_MODE( IMODE,: ) ) )
             ELSE
                DO IS = 1,N_AE_SPC
                  IF ( L_AESP_MODE( IMODE,IS ) .AND. L_AESP_MASS( IS ) ) 
     &               IBCON(IS) = MAX( IBCON(IS), CONMIND )
                END DO
                M3DRY = SUM( IBCON( : ) * REAL(AEROCGRID_RHOINV * F6PI,8), 
     &                       MASK = ( L_AESP_MASS .AND. L_AESP_MODE( IMODE,: )  
     &                                .AND. L_AESP_DRY ) ) 
                M3WET = SUM( IBCON( : ) * REAL(AEROCGRID_RHOINV * F6PI,8), 
     &                       MASK = ( L_AESP_MASS .AND. L_AESP_MODE( IMODE,: ) ) ) 
             END IF

             L2SG  = REAL( DEF_L2SG( IMODE ),8)
             SG    = EXP( SQRT( L2SG ) )
             
             DGDRY = REAL( DEF_DIAM( IMODE ),8)  ! Dry Diameter Default
             NUM   = M3DRY * ( EXP( -4.5 * L2SG ) ) / ( DGDRY ) ** 3
             M2DRY = EXP( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3DRY ) - L2SG )
             
             DGWET = ( M3WET / NUM * EXP( -4.5 * L2SG ) )  ** ( ONE_THIRD )
             M2WET = EXP( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3WET ) - L2SG )

         ELSE IF ( NUM .LT. 1.1e-30 ) THEN
             ! Number is below limit -> reset Num and Surf with
             !  default dry diameter and default standard deviation
             LSTAT( IMODE ) = 12

             L2SG  = REAL( DEF_L2SG( IMODE ), 8)
             SG    = EXP( SQRT( L2SG ) )

             DGDRY = REAL( DEF_DIAM( IMODE ), 8)  ! Dry Diameter Default
             NUM   = M3DRY * ( EXP( -4.5 * L2SG ) ) / ( DGDRY ) ** 3
             M2DRY = EXP( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3DRY ) - L2SG )

             DGWET = ( M3WET / NUM * EXP( -4.5 * L2SG ) )  ** ( ONE_THIRD )
             M2WET = EXP( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3WET ) - L2SG )

         ELSE IF ( M2 .LT. 1.1e-30 .OR. .NOT. USE_M2 ) THEN                
             ! Mass and Number are valid. Surface area is either invalid
             ! or the user has issued an override. The mass and number
             ! concentrations specify the dry and wet diameters, and the
             ! second moment will be generated by assuming a
             ! representative sigma.
             LSTAT( IMODE ) = 13

             L2SG  = REAL( DEF_L2SG( IMODE ), 8)
             SG    = EXP( SQRT( L2SG ) )

             DGDRY = ( M3DRY / NUM * EXP( -4.5 * L2SG ) )  ** ( ONE_THIRD )
             M2DRY = EXP( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3DRY ) - L2SG )

             DGWET = ( M3WET / NUM * EXP( -4.5 * L2SG ) )  ** ( ONE_THIRD )
             M2WET = EXP( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3WET ) - L2SG )

         ELSE
             ! All three moments are possibly valid. 
             ! Diagnose and Check Standard Deviation
             IF ( LM2WET ) THEN 
                L2SG = ( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3WET ) - LOG( M2WET ))
             ELSE
                L2SG = ( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3DRY ) - LOG( M2DRY ))
             END IF

             sg = 1.0d0
             IF ( L2SG .gt. 0.0d0 ) SG = EXP( SQRT( L2SG ) )
             AER_PAR( 1, IMODE, 8 ) = SG
             IF ( (L2SG .LT. REAL( MIN_L2SG,8) .AND. L2SG .GT. 0.95d0 * REAL(MIN_L2SG,8)) .OR.
     &            (L2SG .GT. REAL( MAX_L2SG,8) .AND. L2SG .LT. 1.05d0 * REAL(MAX_L2SG,8)) ) THEN
                  ! Standard deviation is barely invalid. Don't trigger warning
                  LSTAT( IMODE ) = 4
             ELSE IF ( L2SG .LT. REAL( 0.95*MIN_L2SG,8) .OR. L2SG .GT. REAL(1.05*MAX_L2SG,8) ) THEN 
                  ! Standard deviation is invalid. Reset Standard Deviation
                  LSTAT( IMODE ) = 14
             END IF
             L2SG  = MIN( MAX( L2SG, REAL(MIN_L2SG,8) ), REAL(MAX_L2SG,8) )
             SG   = EXP( SQRT( L2SG ) )

             ! Diagnose and Check Dry Diameter against Limits
             DGDRY = ( M3DRY / NUM * EXP( -4.5 * L2SG ) )  ** ( ONE_THIRD )
             AER_PAR( 1, IMODE, 7 ) = DGDRY
             DGWET = ( M3WET / NUM * EXP( -4.5 * L2SG ) )  ** ( ONE_THIRD )
             AER_PAR( 1, IMODE, 6 ) = DGWET

             IF ( (DGDRY .GT. REAL(0.95*MIN_DG_DRY(IMODE),8) .AND. DGDRY .LT. REAL(MIN_DG_DRY(IMODE),8)) .OR.
     &            (DGDRY .GT. REAL(MAX_DG_DRY(IMODE),8) .AND. DGDRY .LT. REAL(1.05*MAX_DG_DRY(IMODE),8)) ) THEN
                  ! Diameter is barely invalid. Don't trigger warning
                  IF ( LSTAT( IMODE ) .EQ. 4 ) THEN
                     LSTAT( IMODE ) = 6  ! Both sg and dg are barely invalid
                  ELSE IF (LSTAT( IMODE ) .EQ. 0 ) THEN
                     LSTAT( IMODE ) = 5  ! Just dg is barely invalid
                  END IF
             
             ELSE IF ( DGDRY .LT. REAL(0.95*MIN_DG_DRY( IMODE ),8)  .OR. 
     &                 DGDRY .GT. REAL(1.05*MAX_DG_DRY(IMODE) ,8 ) ) THEN
                 ! Diameter is invalid. Reset Diameter
                 IF ( LSTAT( IMODE ) .EQ. 4 .OR. LSTAT( IMODE ) .EQ. 12 ) THEN
                    LSTAT( IMODE ) = 16  ! Both dg and sg are invalid
                ELSE IF ( LSTAT( IMODE ) .EQ. 0 ) THEN
                    LSTAT( IMODE ) = 15  ! Just dg is invalid
                 END IF
             ENDIF
             DGDRY = MIN( MAX( DGDRY, MIN_DG_DRY(IMODE) ), MAX_DG_DRY(IMODE) )

             ! Recalculate Number
             IF ( LSTAT( IMODE ) .GT. 0 ) 
     &            NUM   = M3DRY * ( EXP( -4.5 * L2SG ) ) / ( DGDRY ) ** 3

             ! Recalculate Dry Second Moment
             M2DRY = EXP( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3DRY ) - L2SG )

             ! Recalculate Wet Distribution Parameters
             DGWET = ( M3WET / NUM * EXP( -4.5 * L2SG ) )  ** ( ONE_THIRD )
             M2WET = EXP( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3WET ) - L2SG )
 
         ENDIF

         ! Export Number Concentration and Surface Area Concentration
         IF ( LM2WET ) THEN
             M2 = M2WET
         ELSE
             M2 = M2DRY
         END IF

         IF ( IS_BC ) THEN
            DO IT = 1,N_AE_TRNS
              IF ( L_AETR_MODE( IMODE,IT ) .AND. L_AETR_NUM( IT ) ) IBCON0(IT) = REAL(NUM,4)
              IF ( L_AETR_MODE( IMODE,IT ) .AND. L_AETR_SRF( IT ) ) IBCON0(IT) = REAL(M2,4) * PI
            END DO
         ELSE
            DO IS = 1,N_AE_SPC
              IF ( L_AESP_MODE( IMODE,IS ) .AND. L_AESP_NUM( IS ) ) IBCON0(IS) = REAL(NUM,4)
              IF ( L_AESP_MODE( IMODE,IS ) .AND. L_AESP_SRF( IS ) ) IBCON0(IS) = REAL(M2,4) * PI
            END DO
         END IF

         !Save Modal Properties After the Check
         AER_PAR( 2, IMODE, 1 ) = NUM
         AER_PAR( 2, IMODE, 2 ) = M2WET
         AER_PAR( 2, IMODE, 3 ) = M2DRY
         AER_PAR( 2, IMODE, 4 ) = M3WET
         AER_PAR( 2, IMODE, 5 ) = M3DRY
         AER_PAR( 2, IMODE, 6 ) = DGWET
         AER_PAR( 2, IMODE, 7 ) = DGDRY
         AER_PAR( 2, IMODE, 8 ) = SG
          
         !Print warning if any aerosol BC or IC violated the size 
         !distribution parameters
         IF ( LSTAT( IMODE ) .GT. 10 ) THEN
           IF ( IS_BC ) THEN
              IF ( L_WRITE_WARNING ) THEN
                 L_WRITE_WARNING = .FALSE.
                 WRITE( XMSG2, '(A)' ),
     &              'ATTENTION: Applying fix to aerosol Boundary' //
     &              ' Conditions for aerosol modes.' //
     &              ' Set verbose_rdbcon preprocessor flag to' //
     &              ' learn more.'
                 WRITE( LOGDEV, * )
                 CALL LOG_MESSAGE( LOGDEV, XMSG2 ) 
                 WRITE( LOGDEV, * )
              END IF
#ifdef verbose_rdbcon
              WRITE( LOGDEV,* )
              WRITE ( LOGDEV,'(7x,A55,I1,/,9x,A10,I4,A7,I3,A10,I2,/,7x,A20,I1,A42,/,9x,A51,/,
     &              9x,A19,1x,A3,8x,A5,8x,A5,8x,A5,8x,A5,8x,A5,8x,A5,8x,A2,/,
     &              27x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,4x,F7.3,/,
     &              9x,A19,1x,A3,8x,A5,8x,A5,8x,A5,8x,A5,8x,A5,8x,A5,8x,A2,/,
     &              27x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,4x,F7.3)'),
     &            'Warning: Applying Aerosol Boundary Conditions for mode ',IMODE,
     &            'BC Index: ',ROW,'  Lay: ',LAY,'  Status: ',LSTAT(IMODE),
     &            'The Offending Mode (',IMODE,') had diameter and/or sigma out of bounds.',
     &            'It was overwritten by changing the Num and SrfArea.',
     &            'Modal Props Before:','Num','M2WET','M2DRY','M3WET','M3DRY','DGWET','DGDRY','Sg',(AER_PAR(1,IMODE,j),j=1,8),
     &            'Modal Props After: ','Num','M2WET','M2DRY','M3WET','M3DRY','DGWET','DGDRY','Sg',(AER_PAR(2,IMODE,j),j=1,8)
              WRITE( LOGDEV,* )
#endif
           ELSE
              IF ( L_WRITE_WARNING ) THEN
                 L_WRITE_WARNING = .FALSE.
                 WRITE( XMSG2, '(A)' ),
     &              'ATTENTION: Applying fix to aerosol Initial' //
     &              ' Conditions for aerosol modes.' //
     &              ' Set verbose_loadcgrid preprocessor flag to' //
     &              ' learn more.'
                 WRITE( LOGDEV, * )
                 CALL LOG_MESSAGE( LOGDEV, XMSG2 ) 
                 WRITE( LOGDEV, * )
              END IF
#ifdef verbose_loadcgrid 
              WRITE( LOGDEV, * )
              WRITE ( logdev, '(7x,A55,I1,/,9x,A5,I3,A7,I3,A7,I3,A10,I2,/,7x,A20,I1,A42,/,9x,A51,/,
     &              9x,A19,1x,A3,8x,A5,8x,A5,8x,A5,8x,A5,8x,A5,8x,A5,8x,A2,/,
     &              27x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,4x,F7.3,/,
     &              9x,A19,1x,A3,8x,A5,8x,A5,8x,A5,8x,A5,8x,A5,8x,A5,8x,A2,/,
     &              27x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,1x,E11.3,4x,F7.3)'),
     &            'Warning: Applying Aerosol Initial Conditions for mode ',IMODE,
     &            'Col: ',COL,'  Row: ',ROW,'  Lay: ',LAY,'  Status: ',LSTAT(IMODE),
     &            'The Offending Mode (',IMODE,') had diameter and/or sigma out of bounds.',
     &            'It was overwritten by changing the Num and SrfArea.',
     &            'Modal Props Before:','Num','M2WET','M2DRY','M3WET','M3DRY','DGWET','DGDRY','Sg',(AER_PAR(1,IMODE,j),j=1,8),
     &            'Modal Props After: ','Num','M2WET','M2DRY','M3WET','M3DRY','DGWET','DGDRY','Sg',(AER_PAR(2,IMODE,j),j=1,8)
              WRITE( LOGDEV,* )
#endif
           END IF    
         ENDIF
      ENDDO
      
      End Subroutine CHECK_AERO_ICBC

!-----------------------------------------------------------------------
      Subroutine CALC_AERODIST_PARAMS( INIT_TIME )

! Subroutine calculates the wet and then dry aerosol distribution parameters
!     and stores them in public arrays to be passed to the diagnostic 
!     array.
!-----------------------------------------------------------------------
 
      IMPLICIT NONE

      LOGICAL, INTENT( IN ) :: INIT_TIME

      CALL CALCMOMENTS( .TRUE. )
      CALL GETPAR( FIXED_sg )

      WET_AERO_DIAM( : ) = AEROMODE_DIAM( : ) * 1.0E6 ! um
      WET_AERO_M2  ( : ) = MOMENT2_CONC( : )
      WET_AERO_M3  ( : ) = MOMENT3_CONC( : )
      WET_AERO_DENS( : ) = AEROMODE_DENS( : )

      CALL CALCMOMENTS( .FALSE. )
      CALL GETPAR( FIXED_sg )

      DRY_AERO_DIAM( : ) = AEROMODE_DIAM( : ) * 1.0E6 ! um
      DRY_AERO_M2  ( : ) = MOMENT2_CONC( : )
      DRY_AERO_M3  ( : ) = MOMENT3_CONC( : )
      DRY_AERO_DENS( : ) = AEROMODE_DENS( : )

      END SUBROUTINE CALC_AERODIST_PARAMS

      End Module aero_data
 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module vdiff_diag
C diagnostic output of acm2 parameters and sedimentation velocities
      use runtime_vars
      use utilio_defn
      use grid_conf
      use cgrid_spcs

      implicit none

      character( 16 ), save :: vdiff_diag_file = 'VDIFF_DIAG_FILE'

      integer, save :: n_vdiff
      integer, save :: n_vsed
      character( 16 ), allocatable, save :: vsed_name( : )
      integer, allocatable, save :: vsed_map( : )

      integer, save :: ntics = 0           ! no. of substeps within an output time step
C vdiff sub-timestep counter
      real, allocatable :: nlpcr_mean( :,: )   ! over the output time step TSTEP(1)
      real, allocatable :: nlpcr_max( :,: )    ! over the output time step TSTEP(1)
      real, allocatable :: nlpcr_min( :,: )    ! over the output time step TSTEP(1)
      real, allocatable :: nlpcr_sum( :,: )    ! accumulator
C sedi sub-timestep counter
      real, allocatable :: dtccr_mean( :,: )   ! over the output time step TSTEP(1)
      real, allocatable :: dtccr_max( :,: )    ! over the output time step TSTEP(1)
      real, allocatable :: dtccr_min( :,: )    ! over the output time step TSTEP(1)
      real, allocatable :: dtccr_sum( :,: )    ! accumulator
      real, allocatable :: cnvct( :,: )
      real, allocatable :: vsed_buf( :,:,:,: )

      contains

         function vdiff_diag_init( jdate, jtime, tstep1, grvsetl ) result ( success )

! Revision History.
!     Aug 12,2015 D. Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O implementation
!     Mar  2,2016 D. Wong: Modified the code to handle any combination of two environment
!                          variables: CTM_GRAV_SETL and VDIFF_DIAG_FILE, in a robust way for
!                          parallel I/O implementation

#ifndef mpas
#ifdef parallel
         use se_modules            ! stenex (using SE_UTIL_MODULE)
#else
         use noop_modules          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif
         USE MIO_ASCII

         implicit none
         include SUBST_FILES_ID  ! file name parameters
         logical success
         integer jdate, jtime, tstep1
         logical grvsetl
         character( 96 ) :: xmsg = ' '
         character( 16 ) :: pname = 'vdiff_diag_init'  
         logical ok, add, skip
         integer i, j, k, v, ios
         integer, allocatable :: found( : )

#ifndef mpas
         success = .true.

         if ( grvsetl ) then
            n_vdiff = 8   ! nlp's, sedi dtc's, convct, lpbl
            n_vsed = 6    ! aero sedv
            allocate( vsed_name( n_vsed ),
     &                vsed_map( n_vsed ),
     &                found( n_vsed ), stat = ios )
            if ( ios .ne. 0 ) then
               xmsg = "ERROR allocating nlp_'s or cnvct"
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
            vsed_name = ( / 'VNUMACC', 'VNUMCOR', 'VSRFACC',
     &                      'VSRFCOR', 'VMASSJ ', 'VMASSC ' / )
         else
            n_vdiff = 5
            n_vsed = 0
         end if

         if ( grvsetl ) then
C Create the vsed_map (find the 1st vsed_ae species for each of the 6 surrogate classes)
            do i = 1, n_vsed
               found( i ) = -9
            end do

            k = 0
            do v = 1, n_ae_depv

               skip = .true.
               do i = 1, n_vsed   ! search the entire list
                  if ( ae_depv( v ) .eq. vsed_name( i ) ) skip = .false.
               end do
               if ( skip ) cycle

               j = index1( ae_depv( v ), n_vsed, vsed_name )
               add = .true.
               do i = 1, n_vsed   ! search the entire list for j
                  if ( j .eq. found( i ) ) then
                     add = .false.
                  end if
               end do
               if ( add ) then    ! this j is not in the list; add it
                  k = k + 1
                  found( k ) = j
                  vsed_map( k ) = v
               end if

            end do
    
         end if

         if ( io_pe_inclusive ) then

C get CONC file header description
            ok = open3( ctm_conc_1, fsread3, pname )
            ok = desc3( ctm_conc_1 )
            if ( .not. ok ) then
               xmsg = 'could not read '// trim( ctm_conc_1 )
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if

            sdate3d = jdate
            stime3d = jtime
            call nextime ( sdate3d, stime3d, tstep1 ) 

            if ( grvsetl ) then

               nvars3d = n_vsed
               fdesc3d = ' '   ! array
               fdesc3d( 1 ) = 'representative coarse aerosol gravitational settling velocities'
               do v = 1, n_vsed
                  vtype3d( v ) = m3real
                  units3d( v ) = 'm s-1'
                  vname3d( v ) = vsed_name( v )
                  vdesc3d( v ) = 'gravitational settling velocity'
               end do

               ! Store MIO Metadata
               NDIMS3D( 1:NVARS3D ) = 4
               L_TSTEP( 1:NVARS3D ) = .True.
               L_LAY  ( 1:NVARS3D ) = .True.
               L_COL  ( 1:NVARS3D ) = .True.
               L_ROW  ( 1:NVARS3D ) = .True.
               L_VEXT ( 1:NVARS3D ) = .False.

               CALL LOAD_MIO_FILE ( 'CTM_VSED_DIAG', NLAYS3D, 1, NLAYS3D,
     &              VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &              VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &              L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &              L_VEXT(1:NVARS3D) )


               ok = open3( ctm_vsed_diag, fsnew3, pname )
               if ( .not. ok ) then
                  xmsg = 'could not create '// trim( ctm_vsed_diag ) // ' file'
                  call m3warn( 'vdiff_diag', jdate, jtime, xmsg )
                  success = .false.; return
               end if

            end if

            nvars3d = n_vdiff
            nlays3d = 1
            fdesc3d = ' '   ! array
            fdesc3d( 1 ) = 'vdiff diagnostic variables'
            v = 1
            vtype3d( v ) = m3real
            units3d( v ) = ''
            vname3d( v ) = 'NLP_MEAN'
            vdesc3d( v ) = 'mean sub-timestep iteration count'
            v = v + 1
            vtype3d( v ) = m3real
            units3d( v ) = ''
            vname3d( v ) = 'NLP_MAX'
            vdesc3d( v ) = 'max sub-timestep iteration count'
            v = v + 1
            vtype3d( v ) = m3real
            units3d( v ) = ''
            vname3d( v ) = 'NLP_MIN'
            vdesc3d( v ) = 'min sub-timestep iteration count'

            if ( grvsetl ) then

               v = v + 1
               vtype3d( v ) = m3real
               units3d( v ) = ''
               vname3d( v ) = 'SEDI_DTC_MEAN'
               vdesc3d( v ) = 'mean grav. settling velocity sub-timestep iteration count'
               v = v + 1
               vtype3d( v ) = m3real
               units3d( v ) = ''
               vname3d( v ) = 'SEDI_DTC_MAX'
               vdesc3d( v ) = 'max grav. settling velocity sub-timestep iteration count'
               v = v + 1
               vtype3d( v ) = m3real
               units3d( v ) = ''
               vname3d( v ) = 'SEDI_DTC_MIN'
               vdesc3d( v ) = 'min grav. settling velocity sub-timestep iteration count'
            end if

            v = v + 1
            vtype3d( v ) = m3real
            units3d( v ) = ''
            vname3d( v ) = 'CONVCT'
            vdesc3d( v ) = 'Convective cell (for ACM2)'
            v = v + 1
            vtype3d( v ) = m3real
            units3d( v ) = ''
            vname3d( v ) = 'LPBL'
            vdesc3d( v ) = 'PBL top sigma layer'

            ! Store MIO Metadata
            NDIMS3D( 1:NVARS3D ) = 3
            L_TSTEP( 1:NVARS3D ) = .True.
            L_LAY  ( 1:NVARS3D ) = .True.
            L_COL  ( 1:NVARS3D ) = .True.
            L_ROW  ( 1:NVARS3D ) = .True.
            L_VEXT ( 1:NVARS3D ) = .False.

            CALL LOAD_MIO_FILE ( 'CTM_VDIFF_DIAG', NLAYS3D, 1, NLAYS3D,
     &           VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &           VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &           L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &           L_VEXT(1:NVARS3D) )


            ok = open3( ctm_vdiff_diag, fsnew3, pname )
            if ( .not. ok ) then
               xmsg = 'could not create '// trim( ctm_vdiff_diag ) // ' file'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if

         end if  ! io_pe_inclusive

         allocate ( nlpcr_max( ncols,nrows ),
     &              nlpcr_min( ncols,nrows ),
     &              nlpcr_mean( ncols,nrows ),
     &              nlpcr_sum( ncols,nrows ),
     &              cnvct( ncols,nrows ), stat = ios )
         if ( ios .ne. 0 ) then
            xmsg = "ERROR allocating nlp_'s or cnvct"
            call m3warn( pname, jdate, jtime, xmsg )
            success = .false.; return
         end if
         nlpcr_max = 0.0      ! array assignment
         nlpcr_min = 9.9E30   ! array assignment
         nlpcr_sum = 0.0      ! array assignment

         if ( grvsetl ) then

            allocate ( vsed_buf( ncols,nrows,nlays,n_vsed ), stat = ios )
            if ( ios .ne. 0 ) then
               xmsg = 'ERROR allocating vsed_buf'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if

            allocate ( dtccr_max( ncols,nrows ), 
     &                 dtccr_min( ncols,nrows ), 
     &                 dtccr_mean( ncols,nrows ),
     &                 dtccr_sum( ncols,nrows ), stat = ios )
            if ( ios .ne. 0 ) then
               xmsg = "ERROR allocating , sedi dtc's"
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
            dtccr_max = 0.0      ! array assignment
            dtccr_min = 9.9E30   ! array assignment
            dtccr_sum = 0.0      ! array assignment

         end if

#ifdef parallel_io
         call se_barrier
         if ( .not. io_pe_inclusive ) then
            if ( grvsetl ) then
               if ( .not. open3 ( ctm_vsed_diag, fsread3, pname ) ) then
                  xmsg = 'Could not open ' // trim( ctm_vsed_diag )
                  call m3exit ( pname, jdate, jtime, xmsg, xstat2 )
               end if
            end if
            if ( .not. open3 ( ctm_vdiff_diag, fsread3, pname ) ) then
               xmsg = 'Could not open ' // trim( ctm_vdiff_diag )
               call m3exit ( pname, jdate, jtime, xmsg, xstat2 )
            end if
         end if
#endif
#endif

         end function vdiff_diag_init

      end module vdiff_diag

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE VDIFF_DATA

C-----------------------------------------------------------------------
C Function: index mapping between CGRID, diffusion, dry dep, and emissions
C           species

C-----------------------------------------------------------------------

C global diffusion species
      INTEGER, SAVE :: N_SPC_DIFF 
     
C global dry dep species
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: DIFF_SPC( : )

      END MODULE VDIFF_DATA

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module cgrid_spcs

c CGRID gas chem, aerosol, non-reactive, and tracer species definitions
c based on namelist specifications
c Revision History:
c Jeff Young 31 Aug 09: created
c Bill Hutzell 8 Oct 10: added Gas Chemistry consistency check
C Shawn Roselle 16 Feb 11: replaced I/O API include files with UTILIO_DEFN
C 07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C 21 Apr 16 D.Luecken:  increased spc_dim to 1000
C 07 Mar 2019 F. Sidi:  Split up ICBC for CMAQ species  namelist 
C 10 June 2021 G. Sarwar: Replacd CB6R3M_AE7_AQ with CB6R5M_AE7_AQ
c-----------------------------------------------------------------------
      USE RUNTIME_VARS
      Use rxns_data, only: mechname       ! chemical mechanism data
#ifdef mpas
      use util_module, only : junit
#endif

      implicit none

c main CGRID table
      integer,                      save :: n_gc_spc = 0, n_ae_spc = 0, n_nr_spc = 0, n_tr_spc = 0
      character( 16 ), allocatable, save :: gc_spc( : ),  ae_spc( : ),  nr_spc( : ),  tr_spc( : )
      real, allocatable,            save :: gc_molwt( : ), ae_molwt( : ), nr_molwt( : ), tr_molwt( : )

      integer,                      save :: n_gc_spcd = 0

c Starting and ending index of gas chemistry species in CGRID
      integer,                      save :: gc_strt = 1
      integer,                      save :: gc_fini = 0

c Starting and ending index of aerosol species in CGRID
      integer,                      save :: ae_strt = 0
      integer,                      save :: ae_fini = 0

c Starting and ending index of non-reactive species in CGRID
      integer,                      save :: nr_strt = 0
      integer,                      save :: nr_fini = 0

c Starting and ending index of tracer species in CGRID
      integer,                      save :: tr_strt = 0
      integer,                      save :: tr_fini = 0

c number of species in CGRID
      integer,                      save :: nspcsd = 1

c surrogate species
      integer,                      save :: n_gc_ic = 0,   n_ae_ic = 0,   n_nr_ic = 0,   n_tr_ic = 0,
     &                                      n_gc_bc = 0,   n_ae_bc = 0,   n_nr_bc = 0,   n_tr_bc = 0,
     &                                      n_gc_depv = 0, n_ae_depv = 0, n_nr_depv = 0, n_tr_depv = 0,
     &                                      n_gc_scav = 0, n_ae_scav = 0, n_nr_scav = 0, n_tr_scav = 0,
     &                                      n_gc_g2ae = 0,                n_nr_n2ae = 0, n_tr_t2ae = 0,
     &                                      n_gc_g2aq = 0, n_ae_a2aq = 0, n_nr_n2aq = 0, n_tr_t2aq = 0
      integer,                      save :: n_ae_optics = 0
      character( 16 ), allocatable, save :: gc_ic( : ),   ae_ic( : ),   nr_ic( : ),   tr_ic( : ), 
     &                                      gc_bc( : ),   ae_bc( : ),   nr_bc( : ),   tr_bc( : ),   
     &                                      gc_depv( : ), ae_depv( : ), nr_depv( : ), tr_depv( : ),
     &                                      gc_scav( : ), ae_scav( : ), nr_scav( : ), tr_scav( : ),
     &                                      gc_g2ae( : ),               nr_n2ae( : ), tr_t2ae( : ),
     &                                      gc_g2aq( : ), ae_a2aq( : ), nr_n2aq( : ), tr_t2aq( : )
      character( 16 ), allocatable, save :: ae_optics( : )
      integer, allocatable,         save :: gc_ic_map( : ),   ae_ic_map( : ),   nr_ic_map( : ),   tr_ic_map( : ),
     &                                      gc_bc_map( : ),   ae_bc_map( : ),   nr_bc_map( : ),   tr_bc_map( : ),  
     &                                      gc_depv_map( : ), ae_depv_map( : ), nr_depv_map( : ), tr_depv_map( : ),
     &                                      gc_scav_map( : ), ae_scav_map( : ), nr_scav_map( : ), tr_scav_map( : ),
     &                                      gc_g2ae_map( : ),                   nr_n2ae_map( : ), tr_t2ae_map( : ),
     &                                      gc_g2aq_map( : ), ae_a2aq_map( : ), nr_n2aq_map( : ), tr_t2aq_map( : )

      real, allocatable,            save :: gc_ic_fac( : ),   ae_ic_fac( : ),   nr_ic_fac( : ),   tr_ic_fac( : ),
     &                                      gc_bc_fac( : ),   ae_bc_fac( : ),   nr_bc_fac( : ),   tr_bc_fac( : ),
     &                                      gc_depv_fac( : ), ae_depv_fac( : ), nr_depv_fac( : ), tr_depv_fac( : ),
     &                                      gc_scav_fac( : ), ae_scav_fac( : ), nr_scav_fac( : ), tr_scav_fac( : )

c control species
      integer,                      save :: n_gc_trns = 0, n_ae_trns = 0, n_nr_trns = 0, n_tr_adv = 0, n_tr_diff = 0,
     &                                      n_gc_ddep = 0, n_ae_ddep = 0, n_nr_ddep = 0, n_tr_ddep = 0,
     &                                      n_gc_wdep = 0, n_ae_wdep = 0, n_nr_wdep = 0, n_tr_wdep = 0,
     &                                      n_gc_conc = 0, n_ae_conc = 0, n_nr_conc = 0, n_tr_conc = 0
      character( 16 ), allocatable, save :: gc_trns( : ), ae_trns( : ), nr_trns( : ), tr_adv( : ), tr_diff( : ),
     &                                      gc_ddep( : ), ae_ddep( : ), nr_ddep( : ), tr_ddep( : ),
     &                                      gc_wdep( : ), ae_wdep( : ), nr_wdep( : ), tr_wdep( : ),
     &                                      gc_conc( : ), ae_conc( : ), nr_conc( : ), tr_conc( : )
      integer, allocatable,         save :: gc_trns_map( : ), ae_trns_map( : ), nr_trns_map( : ), tr_adv_map( : ), tr_diff_map( : ),
     &                                      gc_ddep_map( : ), ae_ddep_map( : ), nr_ddep_map( : ), tr_ddep_map( : ),
     &                                      gc_wdep_map( : ), ae_wdep_map( : ), nr_wdep_map( : ), tr_wdep_map( : ),
     &                                      gc_conc_map( : ), ae_conc_map( : ), nr_conc_map( : ), tr_conc_map( : )

      LOGICAL :: LTRNS, LDDEP, LWDEP, LCONC, LADVC, LDIFF
      LOGICAL, ALLOCATABLE :: LAIT(:), LACC(:), LCOR(:)


      INTEGER, SAVE              :: N_CGRID_SPC
      INTEGER, SAVE              :: N_SPC_WDEP
      INTEGER, SAVE              :: N_SPC_DDEP
      INTEGER, SAVE              :: N_SPC_DEPV
      INTEGER, SAVE              :: N_SPC_AQ
      INTEGER, SAVE              :: RHOJ_LOC
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: CGRID_NAME( : )
      REAL,    ALLOCATABLE, SAVE :: CGRID_MW       ( : )
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: CGRID_UNITS    ( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_GAS ( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_AERO( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_NUM ( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_SRF ( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_NR  ( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_TRAC( : )
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: CGRID_CONC_UNIT ( : )
      CHARACTER( 256), ALLOCATABLE, SAVE :: CGRID_CONC_DESC ( : )
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: CGRID_SCAV ( : )
      INTEGER, ALLOCATABLE, SAVE :: MAP_DEPVtoCGRID( : )
      INTEGER, ALLOCATABLE, SAVE :: MAP_DDEPtoCGRID( : )
      INTEGER, ALLOCATABLE, SAVE :: MAP_WDEPtoCGRID( : )
      INTEGER, ALLOCATABLE, SAVE :: MAP_CGRIDtoWDEP( : )
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: WDEP_SPC( : )
      INTEGER, ALLOCATABLE, SAVE :: MAP_AQtoCGRID( : )
      CHARACTER( 32 ), ALLOCATABLE, SAVE :: AQ_SPC     ( : )

#ifdef mpas
      character( 16 ), allocatable, save :: all_spc( : )
      integer,                      save :: n_all_spc = 0

      integer, allocatable :: indx_mpas(:)
#endif

      type, public :: base_type
         private
         character( 16 ) :: name
         real            :: mw
      end type
      type, public :: surr1_type
         private
         character( 16 ) :: name
         integer         :: map
         real            :: fac
      end type
      type, public :: surr2_type
         private
         character( 16 ) :: name
         integer         :: map
      end type
      type, public :: ctrl_type
         private
         character( 16 ) :: name
         integer         :: map
      end type
      
      contains

c init routine to allocate the above allocatables
c !! NO   and to populate the allocated arrays from the stnd gc_spc.ext  !!! NO

         function cgrid_spcs_init() result ( success )
            use UTILIO_DEFN
            use stm_vars
            use cgrid_spcs_types

            implicit none

            logical success
            integer, save :: dev_gc_nml, dev_ae_nml, dev_nr_nml, dev_tr_nml
            integer i, ios, IGC, IAE, INR, ITR
            character(  1 ), parameter :: bl = ' '
            integer, parameter :: spc_dim = 1000
            logical :: order = .true., found = .true.
            character( 120 ) :: xmsg
            INTEGER :: ISPC, JSPC, IGRID, IWDEP, IDEPV, IDDEP, IAQ

#ifdef mpas
            integer :: i1, i2, i3, i4   
#endif
            TYPE (SPECIES_DATA_REG_1), ALLOCATABLE :: GC_SPECIES_DATA(:)
            TYPE (SPECIES_DATA_REG_1), ALLOCATABLE :: NR_SPECIES_DATA(:)
            TYPE (SPECIES_DATA_REG_3), ALLOCATABLE :: TR_SPECIES_DATA(:)

            namelist / GC_NML / GC_SPECIES_DATA
            namelist / AE_NML / AE_SPECIES_DATA
            namelist / NR_NML / NR_SPECIES_DATA
            namelist / TR_NML / TR_SPECIES_DATA

c----------------------------------------------------------------------------------------
            success = .true.

            CALL LOG_HEADING( LOGDEV, "Initialize Chemical Species" )

            ! Gas (GC) Namelist
            ALLOCATE( GC_SPECIES_DATA( SPC_DIM ), STAT=IOS )
            GC_SPECIES_DATA%SPECIES_NAME = ''
            GC_SPECIES_DATA%MOLWT = 0.
            GC_SPECIES_DATA%IC_SURR = ''
            GC_SPECIES_DATA%IC_FAC = 0.
            GC_SPECIES_DATA%BC_SURR = ''
            GC_SPECIES_DATA%BC_FAC = 0.
            GC_SPECIES_DATA%DEPV_SURR = ''
            GC_SPECIES_DATA%DEPV_FAC = 0.
            GC_SPECIES_DATA%SCAV_SURR = ''
            GC_SPECIES_DATA%SCAV_FAC = 0.
            GC_SPECIES_DATA%AERO_SURR = ''
            GC_SPECIES_DATA%CLOUD_SURR = ''
            GC_SPECIES_DATA%TRNS_FLAG = ''
            GC_SPECIES_DATA%DDEP_FLAG = ''
            GC_SPECIES_DATA%WDEP_FLAG = ''
            GC_SPECIES_DATA%CONC_FLAG = ''
                                                                                             
            dev_gc_nml = junit()                                                             
            open( file = trim( gc_namelist ), unit = dev_gc_nml,                             
     &            status = 'old', position = 'rewind' )                                      
            read( nml = GC_nml, unit = dev_gc_nml )                                          
                                                                                             
            ! Determine Number of Gas Species                                                
            N_GC_SPC = 0                                                                     
            DO IGC = 1,SPC_DIM                                                              
                IF ( GC_SPECIES_DATA( IGC )%SPECIES_NAME .EQ. '' ) EXIT                      
                N_GC_SPC = IGC
                IF ( GC_SPECIES_DATA( IGC )%IC_FAC .EQ. -1. )
     &               GC_SPECIES_DATA( IGC )%IC_FAC = 0.
                IF ( GC_SPECIES_DATA( IGC )%BC_FAC .EQ. -1. )
     &               GC_SPECIES_DATA( IGC )%BC_FAC = 0.
                IF ( GC_SPECIES_DATA( IGC )%DEPV_FAC .EQ. -1. )
     &               GC_SPECIES_DATA( IGC )%DEPV_FAC = 0.
                IF ( GC_SPECIES_DATA( IGC )%SCAV_FAC .EQ. -1. )
     &               GC_SPECIES_DATA( IGC )%SCAV_FAC = 0.
            END DO                                                                           
                                                                                             
            ! Allocate and Initialize Permanent Variables
            allocate ( 
     &      gc_spc( n_gc_spc+1 ), gc_molwt( n_gc_spc+1 ),
     &      gc_ic( n_gc_spc+1 ),   gc_ic_map( n_gc_spc+1 ),   gc_ic_fac( n_gc_spc+1 ),
     &      gc_bc( n_gc_spc+1 ),   gc_bc_map( n_gc_spc+1 ),   gc_bc_fac( n_gc_spc+1 ),
     &      gc_depv( n_gc_spc+1 ), gc_depv_map( n_gc_spc+1 ), gc_depv_fac( n_gc_spc+1 ),
     &      gc_scav( n_gc_spc+1 ), gc_scav_map( n_gc_spc+1 ), gc_scav_fac( n_gc_spc+1 ),
     &      gc_g2ae( n_gc_spc+1 ), gc_g2ae_map( n_gc_spc+1 ),
     &      gc_g2aq( n_gc_spc+1 ), gc_g2aq_map( n_gc_spc+1 ),
     &      gc_trns( n_gc_spc+1 ), gc_trns_map( n_gc_spc+1 ),
     &      gc_ddep( n_gc_spc+1 ), gc_ddep_map( n_gc_spc+1 ),
     &      gc_wdep( n_gc_spc+1 ), gc_wdep_map( n_gc_spc+1 ),
     &      gc_conc( n_gc_spc+1 ), gc_conc_map( n_gc_spc+1 ),
#ifdef mpas
     &      all_spc( spc_dim ),
#endif
     &      stat = ios )

#ifdef mpas
            all_spc = bl
#endif

            gc_spc = bl; gc_molwt = 0.0                        !  .
            gc_ic = bl;   gc_ic_map = 0;   gc_ic_fac = 0.0     !  .
            gc_bc = bl;   gc_bc_map = 0;   gc_bc_fac = 0.0     !  .
            gc_depv = bl; gc_depv_map = 0; gc_depv_fac = 0.0   !  .
            gc_scav = bl; gc_scav_map = 0; gc_scav_fac = 0.0   ! array
            gc_g2ae = bl; gc_g2ae_map = 0                      !  .
            gc_g2aq = bl; gc_g2aq_map = 0                      ! assignments
            gc_trns = bl; gc_trns_map = 0                      !  .
            gc_ddep = bl; gc_ddep_map = 0                      !  .
            gc_wdep = bl; gc_wdep_map = 0                      !  .
            gc_conc = bl; gc_conc_map = 0                      !  .


            ! Pass Data from GC Namelist to Internal Variables
            N_GC_IC = 0; N_GC_BC = 0; N_GC_DEPV = 0; N_GC_SCAV = 0
            N_GC_G2AE = 0; N_GC_G2AQ = 0; N_GC_TRNS = 0; N_GC_DDEP = 0; N_GC_WDEP = 0
            N_GC_CONC = 0

            DO IGC = 1,N_GC_SPC
                
                GC_SPC( IGC )      = GC_SPECIES_DATA( IGC )%SPECIES_NAME
                GC_MOLWT( IGC )    = GC_SPECIES_DATA( IGC )%MOLWT

                ! Gas ICs
                IF ( GC_SPECIES_DATA( IGC )%IC_SURR .NE. '' ) THEN
                    N_GC_IC = N_GC_IC + 1
                    GC_IC( N_GC_IC )     = GC_SPECIES_DATA( IGC )%IC_SURR 
                    GC_IC_MAP( N_GC_IC ) = IGC
                    GC_IC_FAC( N_GC_IC ) = GC_SPECIES_DATA( IGC )%IC_FAC
                END IF

                ! Gas BCs
                IF ( GC_SPECIES_DATA( IGC )%BC_SURR .NE. '' ) THEN
                    N_GC_BC = N_GC_BC + 1
                    GC_BC( N_GC_BC )     = GC_SPECIES_DATA( IGC )%BC_SURR 
                    GC_BC_MAP( N_GC_BC ) = IGC
                    GC_BC_FAC( N_GC_BC ) = GC_SPECIES_DATA( IGC )%BC_FAC
                END IF
                
                ! Gas Dry Deposition Surrogates
                IF ( GC_SPECIES_DATA( IGC )%DEPV_SURR .NE. '' ) THEN
                    N_GC_DEPV = N_GC_DEPV + 1
                    GC_DEPV( N_GC_DEPV )     = GC_SPECIES_DATA( IGC )%DEPV_SURR 
                    GC_DEPV_MAP( N_GC_DEPV ) = IGC
                    GC_DEPV_FAC( N_GC_DEPV ) = GC_SPECIES_DATA( IGC )%DEPV_FAC
                END IF
                 
                ! Gas Wet Scavenging Surrogates
                IF ( GC_SPECIES_DATA( IGC )%SCAV_SURR .NE. '' ) THEN
                    N_GC_SCAV = N_GC_SCAV + 1
                    GC_SCAV( N_GC_SCAV )     = GC_SPECIES_DATA( IGC )%SCAV_SURR 
                    GC_SCAV_MAP( N_GC_SCAV ) = IGC
                    GC_SCAV_FAC( N_GC_SCAV ) = GC_SPECIES_DATA( IGC )%SCAV_FAC
                END IF
                
                ! Gas -to-Aerosol Module Surrogates
                IF ( GC_SPECIES_DATA( IGC )%AERO_SURR .NE. '' ) THEN
                    N_GC_G2AE = N_GC_G2AE + 1
                    GC_G2AE( N_GC_G2AE )     = GC_SPECIES_DATA( IGC )%AERO_SURR 
                    GC_G2AE_MAP( N_GC_G2AE ) = IGC
                END IF
                
                ! Gas -to-Cloud Chemistry Surrogates
                IF ( GC_SPECIES_DATA( IGC )%CLOUD_SURR .NE. '' ) THEN
                    N_GC_G2AQ = N_GC_G2AQ + 1
                    GC_G2AQ( N_GC_G2AQ )     = GC_SPECIES_DATA( IGC )%CLOUD_SURR 
                    GC_G2AQ_MAP( N_GC_G2AQ ) = IGC
                END IF
                
                ! Gas - Perform Transport
                LTRNS = GET_LOGICAL_NML( GC_SPECIES_DATA( IGC )%TRNS_FLAG )
                IF ( LTRNS ) THEN
                    N_GC_TRNS = N_GC_TRNS + 1
                    GC_TRNS( N_GC_TRNS )     = GC_SPECIES_DATA( IGC )%SPECIES_NAME
                    GC_TRNS_MAP( N_GC_TRNS ) = IGC
                END IF
                
                ! Gas - Output Dry Deposition Flux
                LDDEP = GET_LOGICAL_NML( GC_SPECIES_DATA( IGC )%DDEP_FLAG )
                IF ( LDDEP ) THEN
                    N_GC_DDEP = N_GC_DDEP + 1
                    GC_DDEP( N_GC_DDEP )     = GC_SPECIES_DATA( IGC )%SPECIES_NAME
                    GC_DDEP_MAP( N_GC_DDEP ) = IGC
                END IF
                
                ! Gas - Output Wet Scavenging Flux
                LWDEP = GET_LOGICAL_NML( GC_SPECIES_DATA( IGC )%WDEP_FLAG )
                IF ( LWDEP ) THEN
                    N_GC_WDEP = N_GC_WDEP + 1
                    GC_WDEP( N_GC_WDEP ) = GC_SPECIES_DATA( IGC )%SPECIES_NAME
                    GC_WDEP_MAP( N_GC_WDEP ) = IGC
                END IF
                
                ! Gas - Output Concentration Field
                LCONC = GET_LOGICAL_NML( GC_SPECIES_DATA( IGC )%CONC_FLAG )
                IF ( LCONC ) THEN
                    N_GC_CONC = N_GC_CONC + 1
                    GC_CONC( N_GC_CONC )     = GC_SPECIES_DATA( IGC )%SPECIES_NAME
                    GC_CONC_MAP( N_GC_CONC ) = IGC
                END IF
                
            END DO

            GC_FINI   = GC_STRT + N_GC_SPC - 1
            N_GC_SPCD = GC_FINI + 1
            GC_SPC( N_GC_SPCD ) = 'AIR_DENSITY'
            RHOJ_LOC  = N_GC_SPCD


            ! Aerosol (AE) Namelist
            ALLOCATE( AE_SPECIES_DATA( SPC_DIM ), STAT=IOS )
            AE_SPECIES_DATA%SPECIES_NAME = ''
            AE_SPECIES_DATA%MOLWT = 0.
            AE_SPECIES_DATA%LAIT = .False.
            AE_SPECIES_DATA%LACC = .False.
            AE_SPECIES_DATA%LCOR = .False.
            AE_SPECIES_DATA%IC_SURR = ''
            AE_SPECIES_DATA%IC_FAC = 0.
            AE_SPECIES_DATA%BC_SURR = ''
            AE_SPECIES_DATA%BC_FAC = 0.
            AE_SPECIES_DATA%OPTICS_SURR = ''
            AE_SPECIES_DATA%DEPV_SURR = ''
            AE_SPECIES_DATA%DEPV_FAC = 0.
            AE_SPECIES_DATA%SCAV_SURR = ''
            AE_SPECIES_DATA%SCAV_FAC = 0.
            AE_SPECIES_DATA%CLOUD_SURR = ''
            AE_SPECIES_DATA%TRNS_FLAG = ''
            AE_SPECIES_DATA%DDEP_FLAG = ''
            AE_SPECIES_DATA%WDEP_FLAG = ''
            AE_SPECIES_DATA%CONC_FLAG = ''
                                                                                             

            dev_ae_nml = junit()
            open( file = trim( ae_namelist ), unit = dev_ae_nml,
     &            status = 'old', position = 'rewind' )
            read( nml = AE_nml, unit = dev_ae_nml ) 

            ! First Expand Aerosol Namelist to Add Modes for Each
            ! Species based on Aitken, Accum, and Coarse columns in the AE
            ! namelist
            CALL AERO_NML_MODES()

            ! Determine Number of Aerosol Species
            N_AE_SPC = 0
            DO IAE = 1,SPC_DIM
                IF ( AE_SPECIES_DATA( IAE )%SPECIES_NAME .EQ. '' ) EXIT
                N_AE_SPC = IAE
                IF ( AE_SPECIES_DATA( IAE )%IC_FAC .EQ. -1. )
     &               AE_SPECIES_DATA( IAE )%IC_FAC = 0.
                IF ( AE_SPECIES_DATA( IAE )%BC_FAC .EQ. -1. )
     &               AE_SPECIES_DATA( IAE )%BC_FAC = 0.
                IF ( AE_SPECIES_DATA( IAE )%DEPV_FAC .EQ. -1. )
     &               AE_SPECIES_DATA( IAE )%DEPV_FAC = 0.
                IF ( AE_SPECIES_DATA( IAE )%SCAV_FAC .EQ. -1. )
     &               AE_SPECIES_DATA( IAE )%SCAV_FAC = 0.
            END DO

            IF ( STM ) THEN
               IF ( ( N_AE_SPC + N_STM_AE_SPC ) .GT. SPC_DIM ) THEN
                  WRITE( LOGDEV,* ) '*** Allocated dimension exceeded for AE ', 
     &                              ' species in Sulfur Tracking Model' 
                  SUCCESS = .FALSE.
                  RETURN
               END IF
               
               DO IAE = 1, N_STM_AE_SPC
                  N_AE_SPC = N_AE_SPC + 1
                  AE_SPECIES_DATA( N_AE_SPC )%SPECIES_NAME = STM_AE_SPECIES_DATA( IAE )%SPECIES_NAME
                  AE_SPECIES_DATA( N_AE_SPC )%MOLWT        = STM_AE_SPECIES_DATA( IAE )%MOLWT
                  AE_SPECIES_DATA( N_AE_SPC )%IC_SURR      = STM_AE_SPECIES_DATA( IAE )%IC_SURR
                  AE_SPECIES_DATA( N_AE_SPC )%IC_FAC       = STM_AE_SPECIES_DATA( IAE )%IC_FAC
                  AE_SPECIES_DATA( N_AE_SPC )%BC_SURR      = STM_AE_SPECIES_DATA( IAE )%BC_SURR
                  AE_SPECIES_DATA( N_AE_SPC )%BC_FAC       = STM_AE_SPECIES_DATA( IAE )%BC_FAC
                  AE_SPECIES_DATA( N_AE_SPC )%DEPV_SURR    = STM_AE_SPECIES_DATA( IAE )%DEPV_SURR
                  AE_SPECIES_DATA( N_AE_SPC )%DEPV_FAC     = STM_AE_SPECIES_DATA( IAE )%DEPV_FAC
                  AE_SPECIES_DATA( N_AE_SPC )%SCAV_SURR    = STM_AE_SPECIES_DATA( IAE )%SCAV_SURR
                  AE_SPECIES_DATA( N_AE_SPC )%SCAV_FAC     = STM_AE_SPECIES_DATA( IAE )%SCAV_FAC
                  AE_SPECIES_DATA( N_AE_SPC )%CLOUD_SURR   = STM_AE_SPECIES_DATA( IAE )%CLOUD_SURR
                  AE_SPECIES_DATA( N_AE_SPC )%TRNS_FLAG    = STM_AE_SPECIES_DATA( IAE )%TRNS_FLAG
                  AE_SPECIES_DATA( N_AE_SPC )%DDEP_FLAG    = STM_AE_SPECIES_DATA( IAE )%DDEP_FLAG
                  AE_SPECIES_DATA( N_AE_SPC )%WDEP_FLAG    = STM_AE_SPECIES_DATA( IAE )%WDEP_FLAG
                  AE_SPECIES_DATA( N_AE_SPC )%CONC_FLAG    = STM_AE_SPECIES_DATA( IAE )%CONC_FLAG
               END DO

               If ( ( Index( mechname, 'SAPRC07TIC_AE7I' ) .Gt. 0 ) .OR.
     &              ( Index( mechname, 'CRACMM2'         ) .Gt. 0 ) .OR.
     &              ( Index( mechname, 'CRACMM3'         ) .Gt. 0 ) .OR.
     &              ( Index( mechname, 'CB6R5_AE7'       ) .Gt. 0 ) .OR.
     &              ( Index( mechname, 'CB6R5M_AE7'      ) .Gt. 0 ) ) Then
                     
                  ORGANOSULF = .TRUE.

                  IF ( ( N_AE_SPC + N_STM_OAE_SPC ) .GT. SPC_DIM ) THEN
                     WRITE( LOGDEV,* ) '*** Allocated dimension exceeded for AE ', 
     &                                 ' species in Sulfur Tracking Model' 
                     SUCCESS = .FALSE.
                     RETURN
                  END IF
                  
                  DO IAE = 1, N_STM_OAE_SPC
                     N_AE_SPC = N_AE_SPC + 1
                     AE_SPECIES_DATA( N_AE_SPC )%SPECIES_NAME = STM_OAE_SPECIES_DATA( IAE )%SPECIES_NAME
                     AE_SPECIES_DATA( N_AE_SPC )%MOLWT        = STM_OAE_SPECIES_DATA( IAE )%MOLWT
                     AE_SPECIES_DATA( N_AE_SPC )%IC_SURR      = STM_OAE_SPECIES_DATA( IAE )%IC_SURR
                     AE_SPECIES_DATA( N_AE_SPC )%IC_FAC       = STM_OAE_SPECIES_DATA( IAE )%IC_FAC
                     AE_SPECIES_DATA( N_AE_SPC )%BC_SURR      = STM_OAE_SPECIES_DATA( IAE )%BC_SURR
                     AE_SPECIES_DATA( N_AE_SPC )%BC_FAC       = STM_OAE_SPECIES_DATA( IAE )%BC_FAC
                     AE_SPECIES_DATA( N_AE_SPC )%DEPV_SURR    = STM_OAE_SPECIES_DATA( IAE )%DEPV_SURR
                     AE_SPECIES_DATA( N_AE_SPC )%DEPV_FAC     = STM_OAE_SPECIES_DATA( IAE )%DEPV_FAC
                     AE_SPECIES_DATA( N_AE_SPC )%SCAV_SURR    = STM_OAE_SPECIES_DATA( IAE )%SCAV_SURR
                     AE_SPECIES_DATA( N_AE_SPC )%SCAV_FAC     = STM_OAE_SPECIES_DATA( IAE )%SCAV_FAC
                     AE_SPECIES_DATA( N_AE_SPC )%CLOUD_SURR   = STM_OAE_SPECIES_DATA( IAE )%CLOUD_SURR
                     AE_SPECIES_DATA( N_AE_SPC )%TRNS_FLAG    = STM_OAE_SPECIES_DATA( IAE )%TRNS_FLAG
                     AE_SPECIES_DATA( N_AE_SPC )%DDEP_FLAG    = STM_OAE_SPECIES_DATA( IAE )%DDEP_FLAG
                     AE_SPECIES_DATA( N_AE_SPC )%WDEP_FLAG    = STM_OAE_SPECIES_DATA( IAE )%WDEP_FLAG
                     AE_SPECIES_DATA( N_AE_SPC )%CONC_FLAG    = STM_OAE_SPECIES_DATA( IAE )%CONC_FLAG
                  END DO

               End If
            END IF

            ! Allocate and Initialize Permanent Variables
            allocate ( 
     &      ae_spc( n_ae_spc ), ae_molwt( n_ae_spc ),
     &      ae_ic( n_ae_spc ),   ae_ic_map( n_ae_spc ),   ae_ic_fac( n_ae_spc ),
     &      ae_bc( n_ae_spc ),   ae_bc_map( n_ae_spc ),   ae_bc_fac( n_ae_spc ),
     &      ae_optics( n_ae_spc ),
     &      ae_depv( n_ae_spc ), ae_depv_map( n_ae_spc ), ae_depv_fac( n_ae_spc ),
     &      ae_scav( n_ae_spc ), ae_scav_map( n_ae_spc ), ae_scav_fac( n_ae_spc ),
     &      ae_a2aq( n_ae_spc ), ae_a2aq_map( n_ae_spc ),
     &      ae_trns( n_ae_spc ), ae_trns_map( n_ae_spc ),
     &      ae_ddep( n_ae_spc ), ae_ddep_map( n_ae_spc ),
     &      ae_wdep( n_ae_spc ), ae_wdep_map( n_ae_spc ),
     &      ae_conc( n_ae_spc ), ae_conc_map( n_ae_spc ),
     &      stat = ios )

            ae_spc = bl; ae_molwt = 0.0                        !  .
            ae_optics = bl
            ae_ic = bl;   ae_ic_map = 0;   ae_ic_fac = 0.0     !  .
            ae_bc = bl;   ae_bc_map = 0;   ae_bc_fac = 0.0     !  .
            ae_depv = bl; ae_depv_map = 0; ae_depv_fac = 0.0   !  .
            ae_scav = bl; ae_scav_map = 0; ae_scav_fac = 0.0   ! array
            ae_a2aq = bl; ae_a2aq_map = 0                      !  .
            ae_trns = bl; ae_trns_map = 0                      ! assignments
            ae_ddep = bl; ae_ddep_map = 0                      !  .
            ae_wdep = bl; ae_wdep_map = 0                      !  .
            ae_conc = bl; ae_conc_map = 0                      !  .

            ! Pass Data from AE Namelist to Internal Variables
            N_AE_OPTICS = 0;N_AE_IC = 0; N_AE_BC = 0; N_AE_DEPV = 0; N_AE_SCAV = 0
            N_AE_A2AQ = 0; N_AE_TRNS = 0; N_AE_DDEP = 0; N_AE_WDEP = 0
            N_AE_CONC = 0

            DO IAE = 1,N_AE_SPC

                AE_SPC( IAE )      = AE_SPECIES_DATA( IAE )%SPECIES_NAME
                AE_MOLWT( IAE )    = AE_SPECIES_DATA( IAE )%MOLWT

                ! Aerosol ICs
                IF ( AE_SPECIES_DATA( IAE )%IC_SURR .NE. '' ) THEN
                    N_AE_IC = N_AE_IC + 1
                    AE_IC( N_AE_IC )     = AE_SPECIES_DATA( IAE )%IC_SURR 
                    AE_IC_MAP( N_AE_IC ) = IAE
                    AE_IC_FAC( N_AE_IC ) = AE_SPECIES_DATA( IAE )%IC_FAC
                END IF

                ! Aerosol BCs
                IF ( AE_SPECIES_DATA( IAE )%BC_SURR .NE. '' ) THEN
                    N_AE_BC = N_AE_BC + 1
                    AE_BC( N_AE_BC )     = AE_SPECIES_DATA( IAE )%BC_SURR 
                    AE_BC_MAP( N_AE_BC ) = IAE
                    AE_BC_FAC( N_AE_BC ) = AE_SPECIES_DATA( IAE )%BC_FAC
                END IF

                ! Aerosol Refractive Indices, blank if using default values in AERO_DATA module
                IF ( AE_SPECIES_DATA( IAE )%OPTICS_SURR .NE. '' ) THEN
                    N_AE_OPTICS = N_AE_OPTICS + 1
                    AE_OPTICS( IAE ) = AE_SPECIES_DATA( IAE )%OPTICS_SURR
                END IF 
                
                ! Aerosol Dry Deposition Surrogates
                IF ( AE_SPECIES_DATA( IAE )%DEPV_SURR .NE. '' ) THEN
                    N_AE_DEPV = N_AE_DEPV + 1
                    AE_DEPV( N_AE_DEPV )     = AE_SPECIES_DATA( IAE )%DEPV_SURR 
                    AE_DEPV_MAP( N_AE_DEPV ) = IAE
                    AE_DEPV_FAC( N_AE_DEPV ) = AE_SPECIES_DATA( IAE )%DEPV_FAC
                END IF
                 
                ! Aerosol Wet Scavenging Surrogates
                IF ( AE_SPECIES_DATA( IAE )%SCAV_SURR .NE. '' ) THEN
                    N_AE_SCAV = N_AE_SCAV + 1
                    AE_SCAV( N_AE_SCAV )     = AE_SPECIES_DATA( IAE )%SCAV_SURR 
                    AE_SCAV_MAP( N_AE_SCAV ) = IAE
                    AE_SCAV_FAC( N_AE_SCAV ) = AE_SPECIES_DATA( IAE )%SCAV_FAC
                END IF
                
                ! Aerosol -to-Cloud Chemistry Surrogates
                IF ( AE_SPECIES_DATA( IAE )%CLOUD_SURR .NE. '' ) THEN
                    N_AE_A2AQ = N_AE_A2AQ + 1
                    AE_A2AQ( N_AE_A2AQ )     = AE_SPECIES_DATA( IAE )%CLOUD_SURR 
                    AE_A2AQ_MAP( N_AE_A2AQ ) = IAE
                END IF
                
                ! Aerosol - Perform Transport
                LTRNS = GET_LOGICAL_NML( AE_SPECIES_DATA( IAE )%TRNS_FLAG )
                IF ( LTRNS ) THEN
                    N_AE_TRNS = N_AE_TRNS + 1
                    AE_TRNS( N_AE_TRNS )     = AE_SPECIES_DATA( IAE )%SPECIES_NAME
                    AE_TRNS_MAP( N_AE_TRNS ) = IAE
                END IF
                
                ! Aerosol - Output Dry Deposition Flux
                LDDEP = GET_LOGICAL_NML( AE_SPECIES_DATA( IAE )%DDEP_FLAG )
                IF ( LDDEP ) THEN
                    N_AE_DDEP = N_AE_DDEP + 1
                    AE_DDEP( N_AE_DDEP )     = AE_SPECIES_DATA( IAE )%SPECIES_NAME
                    AE_DDEP_MAP( N_AE_DDEP ) = IAE
                END IF
                
                ! Aerosol - Output Wet Scavenging Flux
                LWDEP = GET_LOGICAL_NML( AE_SPECIES_DATA( IAE )%WDEP_FLAG )
                IF ( LWDEP ) THEN
                    N_AE_WDEP = N_AE_WDEP + 1
                    AE_WDEP( N_AE_WDEP )     = AE_SPECIES_DATA( IAE )%SPECIES_NAME
                    AE_WDEP_MAP( N_AE_WDEP ) = IAE
                END IF
                
                ! Aerosol - Output Concentration Field
                LCONC = GET_LOGICAL_NML( AE_SPECIES_DATA( IAE )%CONC_FLAG )
                IF ( LCONC ) THEN
                    N_AE_CONC = N_AE_CONC + 1
                    AE_CONC( N_AE_CONC )     = AE_SPECIES_DATA( IAE )%SPECIES_NAME
                    AE_CONC_MAP( N_AE_CONC ) = IAE
                END IF
                
            END DO

            AE_STRT   = GC_FINI + 2
            AE_FINI   = AE_STRT + N_AE_SPC - 1
 


            ! Nonreactive (NR) Namelist
            ALLOCATE( NR_SPECIES_DATA( SPC_DIM ), STAT=IOS )
            NR_SPECIES_DATA%SPECIES_NAME = ''
            NR_SPECIES_DATA%MOLWT = 0.
            NR_SPECIES_DATA%IC_SURR = ''
            NR_SPECIES_DATA%IC_FAC = 0.
            NR_SPECIES_DATA%BC_SURR = ''
            NR_SPECIES_DATA%BC_FAC = 0.
            NR_SPECIES_DATA%DEPV_SURR = ''
            NR_SPECIES_DATA%DEPV_FAC = 0.
            NR_SPECIES_DATA%SCAV_SURR = ''
            NR_SPECIES_DATA%SCAV_FAC = 0.
            NR_SPECIES_DATA%AERO_SURR = ''
            NR_SPECIES_DATA%CLOUD_SURR = ''
            NR_SPECIES_DATA%TRNS_FLAG = ''
            NR_SPECIES_DATA%DDEP_FLAG = ''
            NR_SPECIES_DATA%WDEP_FLAG = ''
            NR_SPECIES_DATA%CONC_FLAG = ''

            dev_nr_nml = junit()
            open( file = trim( nr_namelist ), unit = dev_nr_nml,
     &            status = 'old', position = 'rewind' )
            read( nml = NR_nml, unit = dev_nr_nml ) 
           
            ! Determine Number of Gas Species
            N_NR_SPC = 0
            DO INR = 1,SPC_DIM
                IF ( NR_SPECIES_DATA( INR )%SPECIES_NAME .EQ. '' ) EXIT
                N_NR_SPC = INR
                IF ( NR_SPECIES_DATA( INR )%IC_FAC .EQ. -1. )
     &               NR_SPECIES_DATA( INR )%IC_FAC = 0.
                IF ( NR_SPECIES_DATA( INR )%BC_FAC .EQ. -1. )
     &               NR_SPECIES_DATA( INR )%BC_FAC = 0.
                IF ( NR_SPECIES_DATA( INR )%DEPV_FAC .EQ. -1. )
     &               NR_SPECIES_DATA( INR )%DEPV_FAC = 0.
                IF ( NR_SPECIES_DATA( INR )%SCAV_FAC .EQ. -1. )
     &               NR_SPECIES_DATA( INR )%SCAV_FAC = 0.
            END DO

            IF ( STM ) THEN
               IF ( ( N_NR_SPC + N_STM_NR_SPC ) .GT. SPC_DIM ) THEN
                  WRITE( LOGDEV,* ) '*** Allocated dimension exceeded for NR ', 
     &                              ' species in Sulfur Tracking Model' 
                  SUCCESS = .FALSE.
                  RETURN
               END IF
               
               DO INR = 1, N_STM_NR_SPC
                  N_NR_SPC = N_NR_SPC + 1
                  NR_SPECIES_DATA( N_NR_SPC )%SPECIES_NAME = STM_NR_SPECIES_DATA( INR )%SPECIES_NAME
                  NR_SPECIES_DATA( N_NR_SPC )%MOLWT        = STM_NR_SPECIES_DATA( INR )%MOLWT
                  NR_SPECIES_DATA( N_NR_SPC )%IC_SURR      = STM_NR_SPECIES_DATA( INR )%IC_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%IC_FAC       = STM_NR_SPECIES_DATA( INR )%IC_FAC
                  NR_SPECIES_DATA( N_NR_SPC )%BC_SURR      = STM_NR_SPECIES_DATA( INR )%BC_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%BC_FAC       = STM_NR_SPECIES_DATA( INR )%BC_FAC
                  NR_SPECIES_DATA( N_NR_SPC )%DEPV_SURR    = STM_NR_SPECIES_DATA( INR )%DEPV_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%DEPV_FAC     = STM_NR_SPECIES_DATA( INR )%DEPV_FAC
                  NR_SPECIES_DATA( N_NR_SPC )%SCAV_SURR    = STM_NR_SPECIES_DATA( INR )%SCAV_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%SCAV_FAC     = STM_NR_SPECIES_DATA( INR )%SCAV_FAC
                  NR_SPECIES_DATA( N_NR_SPC )%AERO_SURR    = STM_NR_SPECIES_DATA( INR )%AERO_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%CLOUD_SURR   = STM_NR_SPECIES_DATA( INR )%CLOUD_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%TRNS_FLAG    = STM_NR_SPECIES_DATA( INR )%TRNS_FLAG
                  NR_SPECIES_DATA( N_NR_SPC )%DDEP_FLAG    = STM_NR_SPECIES_DATA( INR )%DDEP_FLAG
                  NR_SPECIES_DATA( N_NR_SPC )%WDEP_FLAG    = STM_NR_SPECIES_DATA( INR )%WDEP_FLAG
                  NR_SPECIES_DATA( N_NR_SPC )%CONC_FLAG    = STM_NR_SPECIES_DATA( INR )%CONC_FLAG
               END DO
            END IF ! stm

            ! Allocate and Initialize Permanent Variables
            allocate ( 
     &      NR_spc( n_nr_spc ), NR_molwt( n_nr_spc ),
     &      NR_ic( n_nr_spc ),   NR_ic_map( n_nr_spc ),   NR_ic_fac( n_nr_spc ),
     &      NR_bc( n_nr_spc ),   NR_bc_map( n_nr_spc ),   NR_bc_fac( n_nr_spc ),
     &      NR_depv( n_nr_spc ), NR_depv_map( n_nr_spc ), NR_depv_fac( n_nr_spc ),
     &      NR_scav( n_nr_spc ), NR_scav_map( n_nr_spc ), NR_scav_fac( n_nr_spc ),
     &      NR_n2ae( n_nr_spc ), NR_n2ae_map( n_nr_spc ),
     &      NR_n2aq( n_nr_spc ), NR_n2aq_map( n_nr_spc ),
     &      NR_trns( n_nr_spc ), NR_trns_map( n_nr_spc ),
     &      NR_ddep( n_nr_spc ), NR_ddep_map( n_nr_spc ),
     &      NR_wdep( n_nr_spc ), NR_wdep_map( n_nr_spc ),
     &      NR_conc( n_nr_spc ), NR_conc_map( n_nr_spc ),
     &      stat = ios )

            NR_spc = bl; NR_molwt = 0.0                        !  .
            NR_ic = bl;   NR_ic_map = 0;   NR_ic_fac = 0.0     !  .
            NR_bc = bl;   NR_bc_map = 0;   NR_bc_fac = 0.0     !  .
            NR_depv = bl; NR_depv_map = 0; NR_depv_fac = 0.0   !  .
            NR_scav = bl; NR_scav_map = 0; NR_scav_fac = 0.0   ! array
            NR_n2ae = bl; NR_n2ae_map = 0                      !  .
            NR_n2aq = bl; NR_n2aq_map = 0                      !  .
            NR_trns = bl; NR_trns_map = 0                      ! assignments
            NR_ddep = bl; NR_ddep_map = 0                      !  .
            NR_wdep = bl; NR_wdep_map = 0                      !  .
            NR_conc = bl; NR_conc_map = 0                      !  .

            ! Pass Data from NR Namelist to Internal Variables
            N_NR_IC = 0; N_NR_BC = 0; N_NR_DEPV = 0; N_NR_SCAV = 0
            N_NR_N2AE = 0; N_NR_N2AQ = 0; N_NR_TRNS = 0; N_NR_DDEP = 0; N_NR_WDEP = 0
            N_NR_CONC = 0

            DO INR = 1,N_NR_SPC

                NR_SPC( INR )      = NR_SPECIES_DATA( INR )%SPECIES_NAME
                NR_MOLWT( INR )    = NR_SPECIES_DATA( INR )%MOLWT

                ! Nonreactive ICs
                IF ( NR_SPECIES_DATA( INR )%IC_SURR .NE. '' ) THEN
                    N_NR_IC = N_NR_IC + 1
                    NR_IC( N_NR_IC )     = NR_SPECIES_DATA( INR )%IC_SURR 
                    NR_IC_MAP( N_NR_IC ) = INR
                    NR_IC_FAC( N_NR_IC ) = NR_SPECIES_DATA( INR )%IC_FAC
                END IF

                ! Nonreactive BCs
                IF ( NR_SPECIES_DATA( INR )%BC_SURR .NE. '' ) THEN
                    N_NR_BC = N_NR_BC + 1
                    NR_BC( N_NR_BC )     = NR_SPECIES_DATA( INR )%BC_SURR 
                    NR_BC_MAP( N_NR_BC ) = INR
                    NR_BC_FAC( N_NR_BC ) = NR_SPECIES_DATA( INR )%BC_FAC
                END IF
                
                ! Nonreactive Dry Deposition Surrogates
                IF ( NR_SPECIES_DATA( INR )%DEPV_SURR .NE. '' ) THEN
                    N_NR_DEPV = N_NR_DEPV + 1
                    NR_DEPV( N_NR_DEPV )     = NR_SPECIES_DATA( INR )%DEPV_SURR 
                    NR_DEPV_MAP( N_NR_DEPV ) = INR
                    NR_DEPV_FAC( N_NR_DEPV ) = NR_SPECIES_DATA( INR )%DEPV_FAC
                END IF
                 
                ! Nonreactive Wet Scavenging Surrogates
                IF ( NR_SPECIES_DATA( INR )%SCAV_SURR .NE. '' ) THEN
                    N_NR_SCAV = N_NR_SCAV + 1
                    NR_SCAV( N_NR_SCAV )     = NR_SPECIES_DATA( INR )%SCAV_SURR 
                    NR_SCAV_MAP( N_NR_SCAV ) = INR
                    NR_SCAV_FAC( N_NR_SCAV ) = NR_SPECIES_DATA( INR )%SCAV_FAC
                END IF
 
                ! Nonreactive -to-Aerosol Module Surrogates
                IF ( NR_SPECIES_DATA( INR )%AERO_SURR .NE. '' ) THEN
                    N_NR_N2AE = N_NR_N2AE + 1
                    NR_N2AE( N_NR_N2AE )     = NR_SPECIES_DATA( INR )%AERO_SURR 
                    NR_N2AE_MAP( N_NR_N2AE ) = INR
                END IF
                
                ! Nonreactive -to-Cloud Chemistry Surrogates
                IF ( NR_SPECIES_DATA( INR )%CLOUD_SURR .NE. '' ) THEN
                    N_NR_N2AQ = N_NR_N2AQ + 1
                    NR_N2AQ( N_NR_N2AQ )     = NR_SPECIES_DATA( INR )%CLOUD_SURR 
                    NR_N2AQ_MAP( N_NR_N2AQ ) = INR
                END IF
                
                ! Nonreactive - Perform Transport
                LTRNS = GET_LOGICAL_NML( NR_SPECIES_DATA( INR )%TRNS_FLAG )
                IF ( LTRNS ) THEN
                    N_NR_TRNS = N_NR_TRNS + 1
                    NR_TRNS( N_NR_TRNS )     = NR_SPECIES_DATA( INR )%SPECIES_NAME
                    NR_TRNS_MAP( N_NR_TRNS ) = INR
                END IF
                
                ! Nonreactive - Output Dry Deposition Flux
                LDDEP = GET_LOGICAL_NML( NR_SPECIES_DATA( INR )%DDEP_FLAG )
                IF ( LDDEP ) THEN
                    N_NR_DDEP = N_NR_DDEP + 1
                    NR_DDEP( N_NR_DDEP )     = NR_SPECIES_DATA( INR )%SPECIES_NAME
                    NR_DDEP_MAP( N_NR_DDEP ) = INR
                END IF
                
                ! Nonreactive - Output Wet Scavenging Flux
                LWDEP = GET_LOGICAL_NML( NR_SPECIES_DATA( INR )%WDEP_FLAG )
                IF ( LWDEP ) THEN
                    N_NR_WDEP = N_NR_WDEP + 1
                    NR_WDEP( N_NR_WDEP )     = NR_SPECIES_DATA( INR )%SPECIES_NAME
                    NR_WDEP_MAP( N_NR_WDEP ) = INR
                END IF
                
                ! Nonreactive - Output Concentration Field
                LCONC = GET_LOGICAL_NML( NR_SPECIES_DATA( INR )%CONC_FLAG )
                IF ( LCONC ) THEN
                    N_NR_CONC = N_NR_CONC + 1
                    NR_CONC( N_NR_CONC )     = NR_SPECIES_DATA( INR )%SPECIES_NAME
                    NR_CONC_MAP( N_NR_CONC ) = INR
                END IF
                
            END DO

            NR_STRT   = AE_FINI + 1
            NR_FINI   = NR_STRT + N_NR_SPC - 1
 

            ! Tracer (TR) Namelists
            ALLOCATE( TR_SPECIES_DATA( SPC_DIM ), STAT=IOS )
            TR_SPECIES_DATA%SPECIES_NAME = ''
            TR_SPECIES_DATA%MOLWT = 0.
            TR_SPECIES_DATA%IC_SURR = ''
            TR_SPECIES_DATA%IC_FAC = 0.
            TR_SPECIES_DATA%BC_SURR = ''
            TR_SPECIES_DATA%BC_FAC = 0.
            TR_SPECIES_DATA%DEPV_SURR = ''
            TR_SPECIES_DATA%DEPV_FAC = 0.
            TR_SPECIES_DATA%SCAV_SURR = ''
            TR_SPECIES_DATA%SCAV_FAC = 0.
            TR_SPECIES_DATA%AERO_SURR = ''
            TR_SPECIES_DATA%CLOUD_SURR = ''
            TR_SPECIES_DATA%ADVC_FLAG = ''
            TR_SPECIES_DATA%DIFF_FLAG = ''
            TR_SPECIES_DATA%DDEP_FLAG = ''
            TR_SPECIES_DATA%WDEP_FLAG = ''
            TR_SPECIES_DATA%CONC_FLAG = ''



            dev_tr_nml = junit()
            open( file = trim( tr_namelist ), unit = dev_tr_nml,
     &            status = 'old', position = 'rewind' )
            read( nml = TR_nml, unit = dev_tr_nml )

            ! Determine Number of Gas Species
            N_TR_SPC = 0
            DO ITR = 1,SPC_DIM
                IF ( TR_SPECIES_DATA( ITR )%SPECIES_NAME .EQ. '' ) EXIT
                N_TR_SPC = ITR
                IF ( TR_SPECIES_DATA( ITR )%IC_FAC .EQ. -1. )
     &               TR_SPECIES_DATA( ITR )%IC_FAC = 0.
                IF ( TR_SPECIES_DATA( ITR )%BC_FAC .EQ. -1. )
     &               TR_SPECIES_DATA( ITR )%BC_FAC = 0.
                IF ( TR_SPECIES_DATA( ITR )%DEPV_FAC .EQ. -1. )
     &               TR_SPECIES_DATA( ITR )%DEPV_FAC = 0.
                IF ( TR_SPECIES_DATA( ITR )%SCAV_FAC .EQ. -1. )
     &               TR_SPECIES_DATA( ITR )%SCAV_FAC = 0.
            END DO

            ! Allocate and Initialize Permanent Variables
            allocate ( 
     &      TR_spc( n_tr_spc ), TR_molwt( n_tr_spc ),
     &      TR_ic( n_tr_spc ),   TR_ic_map( n_tr_spc ),   TR_ic_fac( n_tr_spc ),
     &      TR_bc( n_tr_spc ),   TR_bc_map( n_tr_spc ),   TR_bc_fac( n_tr_spc ),
     &      TR_depv( n_tr_spc ), TR_depv_map( n_tr_spc ), TR_depv_fac( n_tr_spc ),
     &      TR_scav( n_tr_spc ), TR_scav_map( n_tr_spc ), TR_scav_fac( n_tr_spc ),
     &      TR_t2ae( n_tr_spc ), TR_t2ae_map( n_tr_spc ),
     &      TR_t2aq( n_tr_spc ), TR_t2aq_map( n_tr_spc ),
     &      TR_adv( n_tr_spc ),  TR_adv_map( n_tr_spc ),
     &      TR_diff( n_tr_spc ), TR_diff_map( n_tr_spc ),
     &      TR_ddep( n_tr_spc ), TR_ddep_map( n_tr_spc ),
     &      TR_wdep( n_tr_spc ), TR_wdep_map( n_tr_spc ),
     &      TR_conc( n_tr_spc ), TR_conc_map( n_tr_spc ),
     &      stat = ios )

            TR_spc = bl; TR_molwt = 0.0                        !  .
            TR_ic = bl;   TR_ic_map = 0;   TR_ic_fac = 0.0     !  .
            TR_bc = bl;   TR_bc_map = 0;   TR_bc_fac = 0.0     !  .
            TR_depv = bl; TR_depv_map = 0; TR_depv_fac = 0.0   !  .
            TR_scav = bl; TR_scav_map = 0; TR_scav_fac = 0.0   ! array
            TR_t2ae = bl; TR_t2ae_map = 0                      !  .
            TR_t2aq = bl; TR_t2aq_map = 0                      !  .
            TR_adv  = bl; TR_adv_map = 0                       ! assignments
            TR_diff = bl; TR_diff_map = 0                      ! assignments
            TR_ddep = bl; TR_ddep_map = 0                      !  .
            TR_wdep = bl; TR_wdep_map = 0                      !  .
            TR_conc = bl; TR_conc_map = 0                      !  .

            ! Pass Data from TR Namelist to Internal Variables
            N_TR_IC = 0; N_TR_BC = 0; N_TR_DEPV = 0; N_TR_SCAV = 0
            N_TR_T2AE = 0; N_TR_T2AQ = 0; N_TR_ADV = 0;  N_TR_DDEP = 0; N_TR_WDEP = 0
            N_TR_CONC = 0; N_TR_DIFF = 0

            DO ITR = 1,N_TR_SPC

                TR_SPC( ITR )      = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                TR_MOLWT( ITR )    = TR_SPECIES_DATA( ITR )%MOLWT

                ! Tracer IC
                IF ( TR_SPECIES_DATA( ITR )%IC_SURR .NE. '' ) THEN
                    N_TR_IC = N_TR_IC + 1
                    TR_IC( N_TR_IC )     = TR_SPECIES_DATA( ITR )%IC_SURR 
                    TR_IC_MAP( N_TR_IC ) = ITR
                    TR_IC_FAC( N_TR_IC ) = TR_SPECIES_DATA( ITR )%IC_FAC
                END IF

                ! Tracer BC
                IF ( TR_SPECIES_DATA( ITR )%BC_SURR .NE. '' ) THEN
                    N_TR_BC = N_TR_BC + 1
                    TR_BC( N_TR_BC )     = TR_SPECIES_DATA( ITR )%BC_SURR 
                    TR_BC_MAP( N_TR_BC ) = ITR
                    TR_BC_FAC( N_TR_BC ) = TR_SPECIES_DATA( ITR )%BC_FAC
                END IF
                                
                ! Tracer Dry Deposition Surrogates
                IF ( TR_SPECIES_DATA( ITR )%DEPV_SURR .NE. '' ) THEN
                    N_TR_DEPV = N_TR_DEPV + 1
                    TR_DEPV( N_TR_DEPV )     = TR_SPECIES_DATA( ITR )%DEPV_SURR 
                    TR_DEPV_MAP( N_TR_DEPV ) = ITR
                    TR_DEPV_FAC( N_TR_DEPV ) = TR_SPECIES_DATA( ITR )%DEPV_FAC
                END IF
                 
                ! Tracer Wet Scavenging Surrogates
                IF ( TR_SPECIES_DATA( ITR )%SCAV_SURR .NE. '' ) THEN
                    N_TR_SCAV = N_TR_SCAV + 1
                    TR_SCAV( N_TR_SCAV )     = TR_SPECIES_DATA( ITR )%SCAV_SURR 
                    TR_SCAV_MAP( N_TR_SCAV ) = ITR
                    TR_SCAV_FAC( N_TR_SCAV ) = TR_SPECIES_DATA( ITR )%SCAV_FAC
                END IF
 
                ! Tracer -to-Aerosol Module Surrogates
                IF ( TR_SPECIES_DATA( ITR )%AERO_SURR .NE. '' ) THEN
                    N_TR_T2AE = N_TR_T2AE + 1
                    TR_T2AE( N_TR_T2AE )     = TR_SPECIES_DATA( ITR )%AERO_SURR 
                    TR_T2AE_MAP( N_TR_T2AE ) = ITR
                END IF
                
                ! Tracer -to-Cloud Chemistry Surrogates
                IF ( TR_SPECIES_DATA( ITR )%CLOUD_SURR .NE. '' ) THEN
                    N_TR_T2AQ = N_TR_T2AQ + 1
                    TR_T2AQ( N_TR_T2AQ )     = TR_SPECIES_DATA( ITR )%CLOUD_SURR 
                    TR_T2AQ_MAP( N_TR_T2AQ ) = ITR
                END IF
                
                ! Tracer - Perform Advection?
                LADVC = GET_LOGICAL_NML( TR_SPECIES_DATA( ITR )%ADVC_FLAG )
                IF ( LADVC ) THEN
                    N_TR_ADV = N_TR_ADV + 1
                    TR_ADV( N_TR_ADV )     = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                    TR_ADV_MAP( N_TR_ADV ) = ITR
                END IF
                
                ! Tracer - Perform Dispersion (i.e. Diffusion)?
                LDIFF = GET_LOGICAL_NML( TR_SPECIES_DATA( ITR )%DIFF_FLAG )
                IF ( LDIFF ) THEN
                    N_TR_DIFF = N_TR_DIFF + 1
                    TR_DIFF( N_TR_DIFF )     = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                    TR_DIFF_MAP( N_TR_DIFF ) = ITR
                END IF
                
                ! Tracer - Output Dry Deposition Flux
                LDDEP = GET_LOGICAL_NML( TR_SPECIES_DATA( ITR )%DDEP_FLAG )
                IF ( LDDEP ) THEN
                    N_TR_DDEP = N_TR_DDEP + 1
                    TR_DDEP( N_TR_DDEP )     = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                    TR_DDEP_MAP( N_TR_DDEP ) = ITR
                END IF
                
                ! Tracer - Output Wet Scavenging Flux
                LWDEP = GET_LOGICAL_NML( TR_SPECIES_DATA( ITR )%WDEP_FLAG )
                IF ( LWDEP ) THEN
                    N_TR_WDEP = N_TR_WDEP + 1
                    TR_WDEP( N_TR_WDEP )     = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                    TR_WDEP_MAP( N_TR_WDEP ) = ITR
                END IF
                
                ! Tracer - Output Concentration Field
                LCONC = GET_LOGICAL_NML( TR_SPECIES_DATA( ITR )%CONC_FLAG )
                IF ( LCONC ) THEN
                    N_TR_CONC = N_TR_CONC + 1
                    TR_CONC( N_TR_CONC )     = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                    TR_CONC_MAP( N_TR_CONC ) = ITR
                END IF
                
            END DO

            TR_STRT   = NR_FINI + 1
            TR_FINI   = TR_STRT + N_TR_SPC - 1
 
            
            !--------------------------------------------------------------
            ! Process Chemical Namelist Informaiton to CGRID Vectors
            !--------------------------------------------------------------

            ! Sum Up All Species Across Phases and Types
            NSPCSD = N_GC_SPCD + N_AE_SPC + N_NR_SPC + N_TR_SPC

#ifdef mpas
            n_all_spc = n_gc_spc + n_ae_spc + n_nr_spc + n_tr_spc
            do i1 = 1, n_gc_spc
               all_spc(i1) = gc_spc(i1)
            end do

            i1 = i1 - 1
            do i2 = 1, n_ae_spc
               all_spc(i1+i2) = ae_spc(i2)
            end do

            i1 = i1 + i2 - 1
            do i3 = 1, n_nr_spc
               all_spc(i1+i3) = nr_spc(i3)
            end do

            i1 = i1 + i3 - 1
            do i4 = 1, n_tr_spc
               all_spc(i1+i4) = nr_spc(i4)
            end do
#endif

            
            ! Move Data To CGRID_xxx Master Arrays
            N_CGRID_SPC = NSPCSD
            ALLOCATE( CGRID_NAME ( N_CGRID_SPC ),
     &                CGRID_MW   ( N_CGRID_SPC ),
     &                CGRID_UNITS( N_CGRID_SPC ),
     &                CGRID_MASK_GAS( N_CGRID_SPC ),
     &                CGRID_MASK_AERO( N_CGRID_SPC ),
     &                CGRID_MASK_NUM( N_CGRID_SPC ),
     &                CGRID_MASK_SRF( N_CGRID_SPC ),
     &                CGRID_MASK_NR( N_CGRID_SPC ),
     &                CGRID_MASK_TRAC( N_CGRID_SPC ),
     &                CGRID_CONC_UNIT( N_CGRID_SPC ),
     &                CGRID_CONC_DESC( N_CGRID_SPC ),
     &                CGRID_SCAV( N_CGRID_SPC ),       
     &                MAP_DEPVtoCGRID( N_CGRID_SPC ),
     &                MAP_DDEPtoCGRID( N_CGRID_SPC ),
     &                MAP_WDEPtoCGRID( N_CGRID_SPC ),
     &                MAP_CGRIDtoWDEP( N_CGRID_SPC ),
     &                WDEP_SPC( N_CGRID_SPC ),
     &                MAP_AQtoCGRID( N_CGRID_SPC ),
     &                AQ_SPC( N_CGRID_SPC ) )
            CGRID_NAME = ''
            CGRID_MW   = 0.
            CGRID_MASK_GAS = .FALSE.
            CGRID_MASK_AERO= .FALSE.
            CGRID_MASK_NUM = .FALSE.
            CGRID_MASK_SRF = .FALSE.
            CGRID_MASK_NR  = .FALSE.
            CGRID_MASK_TRAC= .FALSE.
            CGRID_CONC_UNIT= ''
            CGRID_CONC_DESC= ''
            CGRID_SCAV = ''
            MAP_DEPVtoCGRID= 0
            MAP_DDEPtoCGRID= 0
            MAP_WDEPtoCGRID= 0
            MAP_CGRIDtoWDEP= 0
            WDEP_SPC = ''
            MAP_AQtoCGRID= 0
            CGRID_UNITS = ''
            AQ_SPC= ''

            IGRID = 0
            IWDEP = 0
            IDEPV = 0
            IDDEP = 0
            IAQ = 0
            ! Set Masks for Reactive Gases
            DO ISPC = gc_strt,n_gc_spc
                IGRID = IGRID + 1
                CGRID_NAME( IGRID ) = GC_SPC( ISPC )
                CGRID_MW( IGRID )   = GC_MOLWT( ISPC )
                CGRID_MASK_GAS( IGRID ) = .TRUE.
                CGRID_CONC_UNIT( IGRID )  = 'ppmV'
                CGRID_UNITS( IGRID ) = 'ppmV'
                CGRID_CONC_DESC( IGRID )  = 'Molar Mixing Ratio of ' // CGRID_NAME(IGRID)
                DO JSPC = 1,N_GC_DEPV
                  IF ( GC_DEPV_MAP( JSPC ) .EQ. ISPC ) THEN
                    IDEPV = IDEPV + 1
                    MAP_DEPVtoCGRID( IDEPV ) = IGRID
                  END IF
                END DO
                DO JSPC = 1,N_GC_DDEP
                  IF ( GC_DDEP_MAP( JSPC ) .EQ. ISPC ) THEN
                    IDDEP = IDDEP + 1
                    MAP_DDEPtoCGRID( IDDEP ) = IGRID
                  END IF
                END DO
                DO JSPC = 1,N_GC_WDEP
                  IF ( GC_WDEP_MAP( JSPC ) .EQ. ISPC ) THEN
                    IWDEP = IWDEP + 1
                    MAP_WDEPtoCGRID( IWDEP ) = IGRID
                    MAP_CGRIDtoWDEP( IGRID ) = IWDEP
                    WDEP_SPC( IWDEP ) = GC_WDEP( JSPC )
                  END IF
                ENDDO
                DO JSPC = 1,N_GC_G2AQ
                  IF ( GC_G2AQ_MAP( JSPC ) .EQ. ISPC ) THEN
                    IAQ = IAQ + 1
                    MAP_AQtoCGRID( IAQ ) = IGRID
                    AQ_SPC( IAQ ) = GC_G2AQ( JSPC )
                  END IF
                ENDDO
                DO JSPC = 1,N_GC_SCAV
                  IF ( GC_SCAV_MAP( JSPC ) .EQ. ISPC ) THEN
                    CGRID_SCAV( IGRID ) = GC_SCAV( JSPC )
                  END IF
                ENDDO
            END DO

            ! Set Masks for Density x Jacobian/MSFX2
            CGRID_NAME( RHOJ_LOC ) = 'RHOJ'
            CGRID_MW( RHOJ_LOC )   = 28.96
            CGRID_MASK_GAS( RHOJ_LOC ) = .TRUE.
            IGRID = IGRID + 1

            ! Set Masks for Aerosols
            DO ISPC = 1,n_ae_spc
                IGRID = IGRID + 1
                CGRID_NAME( IGRID ) = AE_SPC( ISPC )
                CGRID_MW( IGRID )   = AE_MOLWT( ISPC )
                CGRID_MASK_AERO( IGRID )   = .TRUE.
                CGRID_CONC_UNIT( IGRID )  = 'ug m-3'
                CGRID_CONC_DESC( IGRID )  = 'PM Mass Concentration of ' // CGRID_NAME(IGRID)
                IF ( INDEX( AE_SPC( ISPC ),'NUM') .NE. 0 ) THEN
                    CGRID_MASK_NUM( IGRID )   = .TRUE.
                    CGRID_CONC_UNIT( IGRID )  = 'm-3'
                    CGRID_CONC_DESC( IGRID )  = 'PM Number Concentration of ' // CGRID_NAME(IGRID)
                END IF
                IF ( INDEX( AE_SPC( ISPC ),'SRF') .NE. 0 ) THEN
                    CGRID_MASK_SRF( IGRID )   = .TRUE.
                    CGRID_CONC_UNIT( IGRID )  = 'm2 m-3'
                    CGRID_CONC_DESC( IGRID )  = 'PM Surface Area Concentration of ' // CGRID_NAME(IGRID)
                END IF
                DO JSPC = 1,N_AE_DEPV
                  IF ( AE_DEPV_MAP( JSPC ) .EQ. ISPC ) THEN
                    IDEPV = IDEPV + 1
                    MAP_DEPVtoCGRID( IDEPV ) = IGRID
                  END IF
                END DO
                DO JSPC = 1,N_AE_DDEP
                  IF ( AE_DDEP_MAP( JSPC ) .EQ. ISPC ) THEN
                    IDDEP = IDDEP + 1
                    MAP_DDEPtoCGRID( IDDEP ) = IGRID
                  END IF
                END DO
                DO JSPC = 1,N_AE_WDEP
                  IF ( AE_WDEP_MAP( JSPC ) .EQ. ISPC ) THEN
                    IWDEP = IWDEP + 1
                    MAP_WDEPtoCGRID( IWDEP ) = IGRID
                    MAP_CGRIDtoWDEP( IGRID ) = IWDEP
                    WDEP_SPC( IWDEP ) = AE_WDEP( JSPC )
                  END IF
                ENDDO
                CGRID_UNITS( IGRID ) = 'ug m-3'
                IF ( INDEX( AE_SPC( ISPC ),'NUM') .NE. 0 ) THEN 
                    CGRID_MASK_NUM( IGRID )   = .TRUE.
                    CGRID_UNITS( IGRID ) = 'm-3'
                END IF
                IF ( INDEX( AE_SPC( ISPC ),'SRF') .NE. 0 ) THEN
                    CGRID_MASK_SRF( IGRID )   = .TRUE.
                    CGRID_UNITS( IGRID ) = 'm2 m-3'
                END IF
                DO JSPC = 1,N_AE_A2AQ
                  IF ( AE_A2AQ_MAP( JSPC ) .EQ. ISPC ) THEN
                    IAQ = IAQ + 1
                    MAP_AQtoCGRID( IAQ ) = IGRID
                    AQ_SPC( IAQ ) = AE_A2AQ( JSPC )
                  END IF
                ENDDO
                DO JSPC = 1,N_AE_SCAV
                  IF ( AE_SCAV_MAP( JSPC ) .EQ. ISPC ) THEN
                    CGRID_SCAV( IGRID ) = AE_SCAV( JSPC )
                  END IF
                ENDDO
            END DO
            
            ! Set Masks for Nonreactive Variables
            DO ISPC = 1,n_nr_spc
                IGRID = IGRID + 1
                CGRID_NAME( IGRID ) = NR_SPC( ISPC )
                CGRID_UNITS( IGRID ) = 'ppmV'
                CGRID_MW( IGRID )   = NR_MOLWT( ISPC )
                CGRID_MASK_NR( IGRID )   = .TRUE.
                CGRID_CONC_UNIT( IGRID )  = 'ppmV'
                CGRID_UNITS( IGRID ) = 'ppmV'
                CGRID_CONC_DESC( IGRID )  = 'Molar Mixing Ratio of ' // CGRID_NAME(IGRID)
                DO JSPC = 1,N_NR_DEPV
                  IF ( NR_DEPV_MAP( JSPC ) .EQ. ISPC ) THEN
                    IDEPV = IDEPV + 1
                    MAP_DEPVtoCGRID( IDEPV ) = IGRID
                  END IF
                END DO
                DO JSPC = 1,N_NR_DDEP
                  IF ( NR_DDEP_MAP( JSPC ) .EQ. ISPC ) THEN
                    IDDEP = IDDEP + 1
                    MAP_DDEPtoCGRID( IDDEP ) = IGRID
                  END IF
                END DO
                DO JSPC = 1,N_NR_WDEP
                  IF ( NR_WDEP_MAP( JSPC ) .EQ. ISPC ) THEN
                    IWDEP = IWDEP + 1
                    MAP_WDEPtoCGRID( IWDEP ) = IGRID
                    MAP_CGRIDtoWDEP( IGRID ) = IWDEP
                    WDEP_SPC( IWDEP ) = NR_WDEP( JSPC )
                  END IF
                ENDDO
                DO JSPC = 1,N_NR_N2AQ
                  IF ( NR_N2AQ_MAP( JSPC ) .EQ. ISPC ) THEN
                    IAQ = IAQ + 1
                    MAP_AQtoCGRID( IAQ ) = IGRID
                    AQ_SPC( IAQ ) = NR_N2AQ( JSPC )
                  END IF
                ENDDO
                DO JSPC = 1,N_NR_SCAV
                  IF ( NR_SCAV_MAP( JSPC ) .EQ. ISPC ) THEN
                    CGRID_SCAV( IGRID ) = NR_SCAV( JSPC )
                  END IF
                ENDDO
            END DO

            ! Set Masks for Tracers
            DO ISPC = 1,n_tr_spc
                IGRID = IGRID + 1
                CGRID_NAME( IGRID ) = TR_SPC( ISPC )
                CGRID_UNITS( IGRID ) = 'ppmV'
                CGRID_MW( IGRID )   = TR_MOLWT( ISPC )
                CGRID_MASK_TRAC( IGRID )   = .TRUE.
                CGRID_CONC_UNIT( IGRID )  = 'ppmV'
                CGRID_UNITS( IGRID ) = 'ppmV'
                CGRID_CONC_DESC( IGRID )  = 'Molar Mixing Ratio of ' // CGRID_NAME(IGRID)
                DO JSPC = 1,N_TR_DEPV
                  IF ( TR_DEPV_MAP( JSPC ) .EQ. ISPC ) THEN
                    IDEPV = IDEPV + 1
                    MAP_DEPVtoCGRID( IDEPV ) = IGRID
                  END IF
                END DO
                DO JSPC = 1,N_TR_DDEP
                  IF ( TR_DDEP_MAP( JSPC ) .EQ. ISPC ) THEN
                    IDDEP = IDDEP + 1
                    MAP_DDEPtoCGRID( IDDEP ) = IGRID
                  END IF
                END DO
                DO JSPC = 1,N_TR_WDEP
                  IF ( TR_WDEP_MAP( JSPC ) .EQ. ISPC ) THEN
                    IWDEP = IWDEP + 1
                    MAP_WDEPtoCGRID( IWDEP ) = IGRID
                    MAP_CGRIDtoWDEP( IGRID ) = IWDEP
                    WDEP_SPC( IWDEP ) = TR_WDEP( JSPC )
                  END IF
                ENDDO
                DO JSPC = 1,N_TR_T2AQ
                  IF ( TR_T2AQ_MAP( JSPC ) .EQ. ISPC ) THEN
                    IAQ = IAQ + 1
                    MAP_AQtoCGRID( IAQ ) = IGRID
                    AQ_SPC( IAQ ) = TR_T2AQ( JSPC )
                  END IF
                ENDDO
                DO JSPC = 1,N_TR_SCAV
                  IF ( TR_SCAV_MAP( JSPC ) .EQ. ISPC ) THEN
                    CGRID_SCAV( IGRID ) = TR_SCAV( JSPC )
                  END IF
                ENDDO
            END DO

            N_SPC_WDEP = IWDEP
            N_SPC_DEPV = IDEPV
            N_SPC_DDEP = IDDEP
            MAP_WDEPtoCGRID = MAP_WDEPtoCGRID(1:N_SPC_WDEP)
            MAP_DEPVtoCGRID = MAP_DEPVtoCGRID(1:N_SPC_DEPV)
            MAP_DDEPtoCGRID = MAP_DDEPtoCGRID(1:N_SPC_DDEP)

            N_SPC_AQ   = IAQ
         return

         end function cgrid_spcs_init

c----------------------------------------------------------------------------------------
         FUNCTION GET_LOGICAL_NML( OP_FLAG ) RESULT ( LFLAG )

         IMPLICIT NONE

         CHARACTER( 16 ) :: OP_FLAG
         LOGICAL         :: LFLAG

         LFLAG = .FALSE.

         IF ( OP_FLAG .EQ. 'yes' .OR. OP_FLAG .EQ. 'Yes' .OR.
     &        OP_FLAG .EQ. 'YES' .OR. OP_FLAG .EQ. 'Y'   .OR.
     &        OP_FLAG .EQ. 'y'   .OR. OP_FLAG .EQ. 'T'   .OR.
     &        OP_FLAG .EQ. 't'   .OR. OP_FLAG .EQ. 'on'  .OR.
     &        OP_FLAG .EQ. 'On'  .OR. OP_FLAG .EQ. 'ON'  .OR.
     &        OP_FLAG .EQ. '1'        ) 
     &     LFLAG = .TRUE.
   
         RETURN

         END FUNCTION GET_LOGICAL_NML

c----------------------------------------------------------------------------------------
            subroutine bubble ( n, ia, aa )

            use UTILIO_DEFN

            implicit none

            integer, intent( in ) :: n
            integer, intent( in out ) :: ia( n )
            character( * ), intent( in out ) :: aa( n )
            character( 8 ) :: at
            integer i, it
            logical :: no_swap

            do
               no_swap = .true.
               do i = 1, n - 1
                   if ( ia( i ) .gt. ia( i+1 ) ) then
                      it = ia( i ); ia( i ) = ia( i+1 ); ia( i+1 ) = it
                      at = aa( i ); aa( i ) = aa( i+1 ); aa( i+1 ) = at
                      no_swap = .false.
                   end if
               end do
               if ( no_swap ) exit
             end do

            it = 0
            do i = 1, n
               if ( ia( i ) .gt. 0 ) then
                  it = it + 1
                  ia( i ) = it
               else
                  aa( i ) = ' '
               end if
            end do

c compress list; move blanks to end
            it = 1
            do i = 1, n
               if ( aa( i ) .ne. ' ' ) then
                  aa( it ) = aa( i )
                  ia( it ) = ia( i )
                  it = it + 1
               end if
            end do
            do i = it, n
               aa( i ) = ' '
               ia( i ) = 0
            end do

            return
            end subroutine bubble

c----------------------------------------------------------------------------------------
            integer function index1a ( name, n, nlist )
            implicit none
            character( * ) name        ! character string being searched for
            integer n                  ! length of array to be searched
            character( * ) nlist( : )  ! array to be searched

            integer i

            do i = 1, n
               if ( name .eq. nlist( i ) ) then
                  index1a = i
                  return
               end if
           end do
           index1a = 0
           return

           end function index1a

      end module cgrid_spcs

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CLDPROC ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C
C  FUNCTION:  RADM/ACM and Resolved cloud process driver
C
C  PRECONDITIONS REQUIRED:
C       Dates and times represented YYYYDDD:HHMMSS.
C
C  REVISION  HISTORY:
C      Date   Who             What
C    -------- ---             -----------------------------------------
C     11/21/00 J. Young       enable appending timesteps to wetdep1 and wetdep2
C     3/01/98 S.Roselle       modified to output 2 wet deposition files
C     8/12/97 S.Roselle       added conversion of cgrid units to mol/mol units
C     6/14/94 Dongming Hwang  configuration management prototype
C     Dec 00  J. Young        move CGRID_MAP into f90 module
C     Sep 01  J. Young        Dyn Alloc - Use HGRD_DEFN
C     Jan 05  J. Young        dyn alloc - establish both horizontal & vertical
C                             domain specifications in one module
C     May 05  J. Pleim        Replaced RADMcld with RADMacmcld
C     6/08/05 S.Roselle       added new cloud diagnostic variables
C     7/21/09 D. Wong         fixed parallel bug in opening WET_DEP_2
C     Oct 10  J.Young         convert for Namelist redesign
C     3/01/11 S.Roselle       replaced I/O API include files with UTILIO_DEFN
C     5/11/11 D.Wong:         incorporated twoway model implementation
C     02Aug12 S.Roselle:      instrumented to output transmissivity for 
C                             convective and resolved clouds
C     Aug 2015 D. Wong        Extracted section of code that deals with creating
C                             CTM_WET_DEP_1 and CTM_WET_DEP_2 and put it in opwdep.F
C                             Added a section of code to let non I/O processors
C                             open CTM_WET_DEP_1 and CTM_WET_DEP_2 for parallel I/O
C                             implementation
C     Feb 2018 D. Wong        Implemented centralized I/O approach, removed all MY_N
C                             clauses
C    Nov 2018 S.Napelenok     ISAM implementation
C    Apr 2019 F.Sidi & 
C             S.Roselle:      Fixed bug relating to incorrect unit conversions
C                             in GC, NR and TR. 
C    Dec 2019 S.Napelenok     DDM-3D implementation for v 5.3.1
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      use CENTRALIZED_IO_MODULE, only : interpolate_var
      USE ELMO_DATA, ONLY : L_ELMO, ELMO_WDEP
      USE CONST

#ifdef isam
      USE SA_DEFN, ONLY: ISAM, NSPC_SA, N_SPCTAG, TOT_SADEP, TOT_SADEP0, 
     &                   CONV_SADEP, MAP_SAtoCGR, VNAM_SPCTAG, NTAG_SA, 
     &                   S_SPCTAG, ITAG, T_SPCTAG, ISAM_SPEC
      USE ELMO_DATA, ONLY : ELMO_ISAM_WDEP
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY: NP, NPMAX, SENGRID, SENNUM, 
     &                      S_TOTDEP, S_TOTDEP0, S_CONDEP, S_DEPWRT, 
     &                      SEN_PAR
      USE ELMO_DATA, ONLY : ELMO_DDM_WDEP
#endif

#ifdef mpas
      use util_module, only : nextime, index1, time2sec
      use mio_module
      use coupler_module
#endif

      IMPLICIT NONE

C...........INCLUDES

      INCLUDE SUBST_FILES_ID         ! file name parameters

      CHARACTER( 120 ) :: XMSG = ' ' ! exit message string

C...........PARAMETERS

C # of wet deposition species
      REAL, PARAMETER :: MWAIR_SI = MWAIR * 1.0E-3    ! kg mol-1
      REAL, PARAMETER :: CNV1 = MWAIR * 1.0E-9
      REAL, PARAMETER :: CNV1I = 1.0 / CNV1
      REAL, PARAMETER :: CNV2 = MWAIR_SI
      REAL, PARAMETER :: CNV2I = 1.0 / CNV2


C...........ARGUMENTS

!     REAL          CGRID( NCOLS, NROWS, NLAYS, * )  ! concentrations
!     REAL       :: CGRID( :,:,:,: )                 ! concentrations
      REAL, POINTER :: CGRID( :,:,:,: )                 ! concentrations
      INTEGER       JDATE            ! current model date, coded YYYYDDD
      INTEGER       JTIME            ! current model time, coded HHMMSS
      INTEGER       TSTEP( 3 )       ! model time step, coded HHMMSS

C...........Local Variables

      LOGICAL, SAVE :: FIRSTIME = .TRUE. ! flag for first pass thru

      CHARACTER( 16 ), SAVE :: PNAME = 'CLDPROC' ! driver program name
      CHARACTER( 16 ) :: VNAME            ! input variable name list

      INTEGER       COL              ! column subscript indices
      INTEGER       FINI             ! ending position
      INTEGER       LAY              ! layer subscript indices
      INTEGER       MDATE            ! middle of this time step
      INTEGER       MTIME            ! middle of this time step
      INTEGER       NDATE            ! middle of this time step
      INTEGER       NTIME            ! middle of this time step
      INTEGER, SAVE :: WSTEP  = 0    ! local write counter
      INTEGER, SAVE :: NNAE          ! number of #/m3 species
      INTEGER, SAVE :: NQAE          ! number of ug/m3 species
      INTEGER, SAVE :: NSAE          ! number of m2/m3 species
      INTEGER       ROW              ! row subscript indices
      INTEGER       SPC              ! species subscript indices
      INTEGER       STRT             ! starting position
      INTEGER       VAR              ! variable subscript indices
      INTEGER       ALLOCSTAT
      INTEGER       I

      REAL, ALLOCATABLE, SAVE :: CGRD   ( :,:,:,: )! concentrations
      REAL, ALLOCATABLE, SAVE :: DENS    ( :,:,: ) ! air density (kg/m3)
      REAL, ALLOCATABLE, SAVE :: FAC     ( :,:,: ) ! conversion factor
      REAL, ALLOCATABLE, SAVE :: CONV_DEP( :,:,: ) ! convective wdep only
      REAL, ALLOCATABLE, SAVE :: TOT_DEP ( :,:,: ) ! total wdep
      REAL, ALLOCATABLE, SAVE :: TOT_DEP0( :,:,: ) ! total wdep
      REAL, ALLOCATABLE, SAVE :: RESTRANS( :,: )   ! resolved cloud transmissivity
      REAL, ALLOCATABLE, SAVE :: SUBTRANS( :,:,: ) ! subgrid cloud transmissivity

      REAL CCMIN
#ifdef mpas
      CHARACTER (20) :: TIME_STAMP               ! this is for mpas
      integer :: year, month, day, hour, minute  ! this is for mpas

! this is for creating the output name list
      character (512) :: fname
      character (30), allocatable, save :: name_list(:)
      character (30) :: oname
      character (120) :: buf, buf2
      integer, save :: loc_n
      integer :: loc_nvars, stat, n, k, fnum
      logical :: found
      character (16) :: wdep_spc(300)
#endif

#ifdef isam
      REAL, ALLOCATABLE, SAVE :: BUFF2 ( :,: )
      INTEGER, ALLOCATABLE, SAVE :: ISAM_WDEP( : )
      INTEGER :: W
      CHARACTER( 16 ) :: ISAM_SPECIES
#endif

C...........EXTERNAL FUNCTIONS

      INTERFACE
         SUBROUTINE RESCLD ( CGRD, JDATE, JTIME, TSTEP,
     &                       DEP, RESTRANS )
            IMPLICIT NONE
            REAL, INTENT( IN )       :: CGRD( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP( 3 )
            REAL,    INTENT( INOUT ) :: DEP( :,:,: )
            REAL,    INTENT( OUT )   :: RESTRANS( :,: )
         END SUBROUTINE RESCLD
         SUBROUTINE CONVCLD_ACM ( CGRD, JDATE, JTIME, TSTEP,
     &                            DEP, SUBTRANS )
            IMPLICIT NONE
            REAL,    INTENT( IN )    :: CGRD( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP( 3 )
            REAL,    INTENT( INOUT ) :: DEP( :,:,: )
            REAL,    INTENT( OUT )   :: SUBTRANS( :,:,: )
         END SUBROUTINE CONVCLD_ACM
      END INTERFACE

C-----------------------------------------------------------------------
C   begin body of subroutine  CLDPROC

C...Initialization

      IF ( FIRSTIME ) THEN
        FIRSTIME = .FALSE.

C...first check to make sure that some species in CGRID were specified
C...for output in the wet deposition array, otherwise notify the user
C...and return
        IF ( N_SPC_WDEP .LE. 0 ) THEN

          XMSG = 'No species were specified for wet deposition ' //
     &           'tracking'
          CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )

          XMSG = 'ONLY CLOUD DIAGNOSTICS WILL BE WRITTEN TO THE ' //
     &           'WETDEP OUTPUT FILE!'
          CALL M3MESG ( XMSG )

        END IF

C...initialize the deposition array before processing clouds

        ALLOCATE ( TOT_DEP ( NCOLS,NROWS,N_SPC_WDEP+1 ),
     &             TOT_DEP0( NCOLS,NROWS,N_SPC_WDEP+1 ),
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating TOT_DEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        TOT_DEP = 0.0   ! array assignment

        ALLOCATE ( CONV_DEP( NCOLS,NROWS,N_SPC_WDEP+8+4 ),
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating CONV_DEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        CONV_DEP = 0.0   ! array assignment

        ALLOCATE ( RESTRANS ( NCOLS,NROWS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating RESTRANS'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        RESTRANS = 1.0   ! array assignment

        ALLOCATE ( SUBTRANS ( NCOLS,NROWS,2 ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating SUBTRANS'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        SUBTRANS = 1.0   ! array assignment

        ALLOCATE ( DENS( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating DENS'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        
        ALLOCATE ( FAC( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating FAC conversion factor'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        
        ALLOCATE ( CGRD( NCOLS,NROWS,NLAYS,N_CGRID_SPC ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating CGRD'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

#ifdef isam
Ckrt deposition arrays for tagged species.....
        ALLOCATE ( TOT_SADEP ( NCOLS,NROWS,NSPC_SA,NTAG_SA ),
     &            CONV_SADEP ( NCOLS,NROWS,NSPC_SA,NTAG_SA ),
     &             TOT_SADEP0( NCOLS,NROWS,NSPC_SA,NTAG_SA ),
     &            ISAM_WDEP  ( N_SPCTAG ),
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating TOT_ or CONV_SADEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        TOT_SADEP = 0.0
        CONV_SADEP = 0.0
        ALLOCATE( BUFF2( NCOLS, NROWS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating BUFF2'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        
        ISAM_WDEP = 0
        DO ITAG = 1, N_SPCTAG
          DO W = 1, N_SPC_WDEP
            ISAM_SPECIES =  ISAM_SPEC( S_SPCTAG(ITAG),1 )
            IF ( TRIM( ISAM_SPECIES ) .EQ. CGRID_NAME( MAP_WDEPtoCGRID(W) ) ) THEN
              ISAM_WDEP( ITAG ) = W
            END IF
          END DO
        END DO

#endif

#ifdef sens
         ALLOCATE ( S_TOTDEP ( NCOLS,NROWS,NPMAX,N_SPC_WDEP+1 ),
     &              S_TOTDEP0( NCOLS,NROWS,NPMAX,N_SPC_WDEP+1 ),
     &              STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating S_TOTDEP'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         S_TOTDEP = 0.0

         ALLOCATE ( S_CONDEP( NCOLS,NROWS,NPMAX,N_SPC_WDEP+1 ),
     &             STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating S_CONDEP'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         S_CONDEP = 0.0

         ALLOCATE ( S_DEPWRT ( NCOLS,NROWS, ( N_SPC_WDEP + 1 ) * NPMAX ),
     &             STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating S_DEPWRT'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         S_DEPWRT = 0.0
#endif

#ifdef parallel_io
         IF ( .NOT. IO_PE_INCLUSIVE ) THEN
            IF ( .NOT. OPEN3( CTM_WET_DEP_1, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // TRIM( CTM_WET_DEP_1 )
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF
         IF ( CLD_DIAG ) THEN
            IF ( .NOT. IO_PE_INCLUSIVE ) THEN
               IF ( .NOT. OPEN3( CTM_WET_DEP_2, FSREAD3, PNAME ) ) THEN
                  XMSG = 'Could not open ' // TRIM( CTM_WET_DEP_2 )
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
            END IF
         END IF
#endif

#ifdef mpas
! this is for creating the output name list
         found = .false.
         fnum = 0
         do while ((.not. found) .and. (fnum < mio_outfile_def_info%num_of_file_definitions))
            fnum = fnum + 1
            if ('CTM_OUT' == mio_outfile_def_info%flist(fnum)%fname) then
               found = .true.
            end if
         end do
         if (.not. found) then
            write (logdev, *) ' Abort: file CTM_OUT not on the file_input.txt'
            stop
         end if

         loc_nvars = mio_outfile_def_info%flist(fnum)%nvars

         loc_n = 0
         if (found) then
            allocate (name_list(loc_nvars), stat=stat)
            do n = 1, loc_nvars
               buf = mio_outfile_def_info%flist(fnum)%vlist(n)
               found = .false.
               k = 0
               do while (.not. found)
                  k = k + 1
                  if (buf(k:k) == ' ') then
                     found = .true.
                  end if
               end do
               if (buf(1:3) == 'WD_') then
                  loc_n = loc_n + 1
                  name_list(loc_n) = buf(4:k-1)
               end if
            end do
         end if


         wdep_spc = ' '
         SPC = 0
         STRT = 1
         FINI = N_GC_WDEP
         DO VAR = STRT, FINI
            SPC = SPC + 1
            wdep_spc( VAR ) = GC_WDEP( SPC )
         END DO

         SPC = 0
         STRT = N_GC_WDEP + 1
         FINI = N_GC_WDEP + N_AE_WDEP
         DO VAR = STRT, FINI
            SPC = SPC + 1
            wdep_spc ( VAR ) = AE_WDEP( SPC )
         END DO

         SPC = 0
         STRT = N_GC_WDEP + N_AE_WDEP + 1
         FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP
         DO VAR = STRT, FINI
            SPC = SPC + 1
            wdep_spc ( VAR ) = NR_WDEP( SPC )
         END DO

         SPC = 0
         STRT = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + 1
         FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP
         DO VAR = STRT, FINI
            SPC = SPC + 1
            wdep_spc ( VAR ) = TR_WDEP( SPC )
         END DO
#endif
         RETURN ! Added for MIO Implementation
      END IF   ! FIRSTIME

      MDATE = JDATE
      MTIME = JTIME

      call interpolate_var ('DENS', mdate, mtime, DENS)  ! kg m-3
      CGRD = CGRID


C...convert units on cgrid and pass data to local cgrd array
      DO LAY = 1, NLAYS
        DO I = 1, N_CGRID_SPC

           ! Gas - Convert to molar mixing ratio
           IF ( CGRID_MASK_GAS( I ) .OR.
     &          CGRID_MASK_NR( I ) .OR.
     &          CGRID_MASK_TRAC( I ) ) THEN
             CGRD( :, :, LAY, I ) = MAX( CGRID( :, :, LAY, I ) * 1.0E-6,  1.0E-36 )
#ifdef sens
             DO ROW = 1,NROWS
               DO COL = 1,NCOLS
                 IF ( CGRD( COL,ROW, LAY, I ) .LE. 1.0E-30 ) THEN
                   SENGRID( COL,ROW,LAY,:,I ) = 0.0
                 ELSE
                   SENGRID( COL,ROW,LAY,:,I ) = SENGRID( COL,ROW,LAY,:,I ) * 1.0E-6
                 END IF
               END DO
             END DO
#endif
           END IF

           ! Aerosol Mass: ug m-3 -> mol / mol air
           IF ( CGRID_MASK_AERO( I ) .AND.
     &           .NOT. CGRID_MASK_NUM( I ) .AND.
     &           .NOT. CGRID_MASK_SRF( I )  ) THEN
             FAC( :,:,LAY ) = CNV1 / DENS( :,:,LAY) / CGRID_MW( I )
             CGRD( :,:,LAY,I ) = FAC(:,:,LAY) * MAX( CGRID( :,:,LAY,I ),1.0E-30/FAC(:,:,LAY) )
#ifdef sens
             DO ROW = 1,NROWS
               DO COL = 1,NCOLS
                 IF ( CGRD( COL,ROW,LAY,I ) .LE. 1.0E-30 ) THEN
                   SENGRID( COL,ROW,LAY,:,I ) = 0.0
                 ELSE
                   SENGRID( COL,ROW,LAY,:,I ) = FAC(COL,ROW,LAY) *
     &                                          SENGRID( COL,ROW,LAY,:,I )
                 ENDIF
               END DO
             END DO
#endif
           END IF

           ! Aerosol Number: N m-3 -> N / mol air
           ! Aerosol Surface Area: m2 m-3 -> m2 / mol air
           IF ( CGRID_MASK_NUM( I ) .OR.
     &          CGRID_MASK_SRF( I )  ) THEN
             FAC(:,:,LAY) = CNV2 / DENS(:,:,LAY)
             CGRD( :,:,LAY,I) = FAC(:,:,LAY) * MAX( CGRID( :,:,LAY, I ),1.0E-30/FAC(:,:,LAY) )
#ifdef sens
             DO ROW = 1,NROWS
               DO COL = 1,NCOLS
                 IF ( CGRD( COL,ROW,LAY,I ) .LE. 1.0E-30 ) THEN
                    SENGRID( COL,ROW,LAY,:,I ) = 0.0
                 ELSE
                    SENGRID( COL,ROW,LAY,:,I ) = FAC(COL,ROW,LAY) * 
     &                                            SENGRID( COL,ROW,LAY,:,I )
                 ENDIF
               END DO
             END DO
#endif
           END IF

        END DO
      END DO

#ifdef isam
c ISAM  unit conversion
      DO SPC = 1, NSPC_SA
        VAR = MAP_SAtoCGR(SPC)

        IF ( VAR .EQ. RHOJ_LOC  ) CYCLE    ! RHOJ 

        IF ( VAR .LE. N_GC_SPC .OR. VAR .GE. NR_STRT ) THEN ! this is not an aerosol
          DO ITAG = 1, NTAG_SA
            DO LAY = 1, NLAYS
              DO ROW = 1, NROWS
                DO COL = 1, NCOLS
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = ISAM(COL,ROW,LAY,SPC,ITAG ) * 1.0E-6
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = MAX ( ISAM( COL,ROW,LAY,SPC, ITAG ), 1.0E-30 )
c                 IF ( ISAM( COL,ROW,LAY,SPC, ITAG ) .LT. 1.0E-10 ) THEN
c                   ISAM( COL,ROW,LAY,SPC, ITAG ) = 0.0
c                 ENDIF
                END DO
              END DO
            END DO
          END DO
        ELSE ! this is an aerosol
          FAC(:,:,:) = CNV1 / DENS(:,:,:) / CGRID_MW( VAR ) 
          DO ITAG = 1, NTAG_SA
            DO LAY = 1, NLAYS
              DO ROW = 1, NROWS
                DO COL = 1, NCOLS
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = ISAM( COL,ROW,LAY,SPC,ITAG ) * FAC(COL,ROW,LAY)
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = MAX ( ISAM(COL,ROW,LAY,SPC, ITAG ), 1.0E-30 )
c                 IF ( ISAM( COL,ROW,LAY,SPC, ITAG ) .LT. 1.0E-10 ) THEN
c                   ISAM( COL,ROW,LAY,SPC, ITAG ) = 0.0
c                 ENDIF
                END DO
              END DO
            END DO
          END DO
        ENDIF
      END DO
#endif

      ! Store Deposition Accumulation so it can be subtracted out to
      ! inform ELMO
      TOT_DEP0 = TOT_DEP + CONV_DEP
#ifdef isam
      TOT_SADEP0 = TOT_SADEP + CONV_SADEP
#endif
#ifdef sens
      S_TOTDEP0 = S_TOTDEP + S_CONDEP
#endif


C...compute cloud effects for the resolved clouds and resolved rainwater

      CALL RESCLD ( CGRD, JDATE, JTIME, TSTEP,
     &              TOT_DEP, RESTRANS )

C...compute cloud effects for convective (subgrid) clouds

      CALL CONVCLD_ACM ( CGRD, JDATE, JTIME, TSTEP,
     &                   CONV_DEP, SUBTRANS )

C...pass deposition flux to ELMO        
      IF ( L_ELMO ) THEN
          DO VAR = 1,N_SPC_WDEP 
              ELMO_WDEP( :,:,MAP_WDEPtoCGRID(VAR) ) = TOT_DEP( :,:,VAR ) 
     &                 + CONV_DEP( :,:,VAR ) - TOT_DEP0(:,:,VAR )
          END DO

#ifdef isam
          DO SPC = 1,N_SPCTAG
            IF ( ISAM_WDEP(SPC) .GT. 0 ) THEN
              ELMO_ISAM_WDEP( :,:,S_SPCTAG(SPC),T_SPCTAG(SPC) ) = 
     &             TOT_SADEP( :,:,S_SPCTAG(SPC),T_SPCTAG(SPC) )
     &           + CONV_SADEP(:,:,S_SPCTAG(SPC),T_SPCTAG(SPC) )
     &           - TOT_SADEP0(:,:,S_SPCTAG(SPC),T_SPCTAG(SPC) )
            END IF
          END DO
#endif          
#ifdef sens
          DO NP = 1,NPMAX
            IF ( L_ELMO ) THEN
              DO SPC = 1, N_SPC_WDEP
                 ELMO_DDM_WDEP( :,:,MAP_WDEPtoCGRID(SPC),NP ) = 
     &                S_TOTDEP(:,:,NP,SPC) + S_CONDEP(:,:,NP,SPC) 
     &                                     - S_TOTDEP0(:,:,NP,SPC)
              END DO
            END IF
          END DO
#endif          

      END IF

C...now check to see if it's time to write the deposition file
      WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )
      IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
        NDATE = JDATE
        NTIME = JTIME
        CALL NEXTIME( NDATE, NTIME, TSTEP( 2 ) )
        WSTEP = 0

        DO VAR = 1, N_SPC_WDEP + 1
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              TOT_DEP( COL, ROW, VAR ) = TOT_DEP ( COL, ROW, VAR )
     &                                 + CONV_DEP( COL, ROW, VAR )
#ifdef sens
              DO NP = 1, NPMAX
                 S_TOTDEP( COL, ROW, NP, VAR ) =
     &                 S_TOTDEP( COL, ROW, NP, VAR )
     &               + S_CONDEP( COL, ROW, NP, VAR )
              END DO
#endif
            END DO
          END DO
        END DO

        DO ROW = 1, NROWS
          DO COL = 1, NCOLS
            VAR = N_SPC_WDEP + 8 + 1
            CONV_DEP( COL, ROW, VAR ) = SUBTRANS( COL, ROW, 1 )
            VAR = VAR + 1
            CONV_DEP( COL, ROW, VAR ) = SUBTRANS( COL, ROW, 2 )
            VAR = VAR + 1
            CONV_DEP( COL, ROW, VAR ) = RESTRANS( COL, ROW )
            VAR = VAR + 1
            CONV_DEP( COL, ROW, VAR ) = SUBTRANS( COL, ROW, 1 )
     &                                * SUBTRANS( COL, ROW, 2 )
     &                                * RESTRANS( COL, ROW )
          END DO
        END DO

        RESTRANS = 1.0
        SUBTRANS = 1.0

#ifdef isam
Ckrt Sum up the wetdep from both resolved and convective clouds
Ckrt  for the tagged species as well....
        DO SPC = 1, N_SPCTAG
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              TOT_SADEP( COL,ROW,S_SPCTAG( SPC ),T_SPCTAG( SPC ) ) =
     &        TOT_SADEP( COL,ROW,S_SPCTAG( SPC ),T_SPCTAG( SPC ) ) +
     &       CONV_SADEP( COL,ROW,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
            END DO ! col
          END DO ! row
        END DO ! n_spctag
#endif

#ifdef mpas

         if ((loc_n > 0) .and. mpas_diag) then
            time_stamp = ctm_out_clock

            DO VAR = 1, N_SPC_WDEP
               k = index1( WDEP_SPC( VAR ), loc_n, name_list)
               if (k .gt. 0) then
                  oname = 'WD_' // WDEP_SPC( VAR )
                  call mio_fwrite ('CTM_OUT', oname, pname, TOT_DEP ( :,1, VAR ), TIME_STAMP)
               end if
            ENDDO
         end if

#else

C...write data to the normal wet deposition file

        IF ( .NOT. WRITE3( CTM_WET_DEP_1, ALLVAR3, NDATE,
     &                     NTIME, TOT_DEP ) ) THEN
          XMSG = 'Could not write ' // CTM_WET_DEP_1 // ' file'
          CALL M3EXIT ( PNAME, NDATE, NTIME, XMSG, XSTAT1 )
        END IF
#endif

        WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &         'Timestep written to', CTM_WET_DEP_1,
     &         'for date and time', NDATE, NTIME


#ifdef sens
C...write data to the sensitivity wet deposition file
c gas species
        DO NP = 1, NPMAX
          DO SPC = 1, ( N_SPC_WDEP + 1 ) 
            SENNUM = ( SPC - 1 ) * NPMAX + NP
            S_DEPWRT(:,:,SENNUM) = S_TOTDEP( :,:,NP,SPC )
          END DO

        END DO

        IF ( .NOT. WRITE3( CTM_SWETDEP_1, ALLVAR3, NDATE,
     &                     NTIME, S_DEPWRT ) ) THEN
          XMSG = 'Could not write ' // CTM_SWETDEP_1 // ' file'
          CALL M3EXIT ( PNAME, NDATE, NTIME, XMSG, XSTAT1 )
        END IF

        WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6)' )
     &         'Timestep written to', CTM_SWETDEP_1,
     &         'for date and time', NDATE, NTIME

#endif


C...write data to the diagnostic file if requested by the user

        IF ( CLD_DIAG ) THEN
#ifdef mpas
           if ((loc_n > 0) .and. mpas_diag) then
              call mio_setfile (CTM_WET_DEP_2)

              do spc = 1, mio_file_data(mio_cfile)%nvars
                 VNAME = mio_file_data(mio_cfile)%var_name(spc)
                 call mio_fwrite (CTM_WET_DEP_2, VNAME, pname, real(CONV_DEP(:,1,spc), 4), TIME_STAMP)
              end do
           end if
#else

          IF ( .NOT. WRITE3( CTM_WET_DEP_2, ALLVAR3, NDATE,
     &                       NTIME, CONV_DEP ) ) THEN
          XMSG = 'Could not write ' // CTM_WET_DEP_2 // ' file'
            CALL M3EXIT ( PNAME, NDATE, NTIME, XMSG, XSTAT1 )
          END IF
#endif

          WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &           'Timestep written to', CTM_WET_DEP_2,
     &           'for date and time', NDATE, NTIME

        END IF   ! CLD_DIAG

C...reinitialize deposition array

        TOT_DEP  = 0.0
        CONV_DEP = 0.0

#ifdef sens
        S_TOTDEP = 0.0
        S_CONDEP = 0.0
#endif

#ifdef isam
        BUFF2 = 0.0
        DO SPC = 1, N_SPCTAG
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              BUFF2( COL,ROW ) = TOT_SADEP( COL,ROW,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
            END DO ! col
          END DO ! row

          IF ( .NOT. WRITE3( SA_WD_1, VNAM_SPCTAG( SPC ),
     &                       NDATE, NTIME, BUFF2 ) ) THEN
            XMSG = 'Could not write ' // SA_WD_1 // ' file'
            CALL M3EXIT ( PNAME, NDATE, NTIME, XMSG, XSTAT1 )
          END IF
          
       END DO ! n_spctag

       TOT_SADEP  = 0.0
       CONV_SADEP = 0.0
#endif

      END IF   ! time to write

C...convert units on cgrid back to original units
C...  convert to ppmV gas

      DO LAY = 1, NLAYS
        DO I = 1,N_CGRID_SPC
           ! Gas - Convert to PPMV
           IF ( CGRID_MASK_GAS( I ) .OR.
     &          CGRID_MASK_NR( I ) .OR.
     &          CGRID_MASK_TRAC( I ) ) THEN
             CGRID( :, :, LAY, I ) = CGRD( :, :, LAY, I ) * 1.0E+6
#ifdef sens
             DO NP = 1, NPMAX
               SENGRID( :,:,LAY,NP,I ) = SENGRID( :,:,LAY,NP,I ) * 1.0E+6
             END DO
#endif
           END IF

           ! Aerosol Mass: mol / mol air -> ug m-3 
           IF ( CGRID_MASK_AERO( I ) .AND.
     &           .NOT. CGRID_MASK_NUM( I ) .AND.
     &           .NOT. CGRID_MASK_SRF( I )  ) THEN
            FAC(:,:,LAY) = CNV1I * DENS( :,:,LAY )
            CGRID( :,:,LAY,I ) = FAC(:,:,LAY) * CGRD( :,:,LAY,I ) * CGRID_MW(I)
#ifdef sens
             DO NP = 1, NPMAX
               SENGRID( :,:,LAY,NP,I ) = FAC(:,:,LAY) * SENGRID( :,:,LAY,NP,I ) * CGRID_MW(I)
             END DO
#endif
           END IF

           ! Aerosol Number: N / mol air -> N m-3
           ! Aerosol Surface Area: m2 / mol air -> m2 m-3
           IF ( CGRID_MASK_NUM( I ) .OR.
     &          CGRID_MASK_SRF( I )  ) THEN
             FAC(:,:,LAY) = CNV2I * DENS( :,:,LAY )
             CGRID( :,:,LAY,I ) = FAC(:,:,LAY) * CGRD( :,:,LAY,I )
#ifdef sens
             DO NP = 1, NPMAX
               SENGRID( :,:,LAY,NP,I ) = FAC(:,:,LAY) * SENGRID( :,:,LAY,NP,I )
             END DO
#endif
           END IF

        END DO
      END DO

#ifdef isam
c ISAM  unit conversion
      DO SPC = 1, NSPC_SA
        VAR = MAP_SAtoCGR(SPC)

        IF ( VAR .EQ. RHOJ_LOC ) CYCLE    ! RHOJ 

        IF ( .NOT. CGRID_MASK_AERO( VAR ) ) THEN ! this is not an aerosol
          DO ITAG = 1, NTAG_SA
            DO LAY = 1, NLAYS
              DO ROW = 1, NROWS
                DO COL = 1, NCOLS
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = ISAM( COL,ROW,LAY,SPC,ITAG ) * 1.0E+6
                  IF ( ISAM( COL,ROW,LAY,SPC, ITAG ) .LT. 1.0E-18 ) THEN
                    ISAM( COL,ROW,LAY,SPC, ITAG ) = 0.0
                  END IF
                END DO
              END DO
            END DO
          END DO
        ELSE ! this is an aerosol
          DO ITAG = 1, NTAG_SA
            FAC(:,:,:) = CNV1I * DENS( :,:,: ) * CGRID_MW( VAR )
            DO LAY = 1, NLAYS
              DO ROW = 1, NROWS
                DO COL = 1, NCOLS
                  ISAM( COL,ROW,LAY,SPC,ITAG ) = ISAM( COL,ROW,LAY,SPC,ITAG ) * 
     &                                           FAC( COL,ROW,LAY )
                  IF ( ISAM( COL,ROW,LAY,SPC, ITAG ) .LT. 1.0E-18 ) THEN
                    ISAM( COL,ROW,LAY,SPC, ITAG ) = 0.0
                  END IF
                END DO
              END DO
            END DO
          END DO
        ENDIF
      END DO
#endif

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE LTNG_DEFN

!C----------------------------------------------------------------------
!C Function: production of NO from lightning

!C Revision History:
!C   1 Jul 2010 Jeff Young
!C   1 Jan 2011 Rob Pinder: added support for online calculation of 
!C               lightning NO from convective precip and NLDN data
!C  10 Mar 2011 Jeff Young: code revisions
!C  11 Apr 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
!C  11 May 2011 D.Wong: incorporated twoway model implementation
!C   6 May 2013 D.Wong: replaced species name RC with RCA in the twoway model
!C  10 Jun 2013 D.Wong: modified the code to work in the twoway model mode
!C  24 Sep 2013 D.Wong: modified the code to allow finer met data time step
!C                      rather than fixed with one hour data
!C  15 Aug 2016 D.Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O
!C                      implementation
!C  16 Aug 2016 D.Kang: Updated the lightning NO calculation with NLDN hourly
!C                      data directly and using NLDN-RC log linear relationship,
!C                      completely changing the data input process   
!C   1 Feb 2017 D.Kang: Modify the parameter (linear-log linear regression) scheme 
!C                      to set log-linear when RC is greater than 
!C                      exp(log-intercept), and move the LTNOx
!C                      production rate to environment variable to be set in run script
!C  18 Apr 2017 D. Kang: Make routine compatible with the two-way coupled model
!C  17 Jul 2017 D. Wong: In subroutine GET_LTNG: 
!C                       * implemented a bug fix for determining LASTTIC base on 
!C                         accumulation of time step, TSTEP(2)
!C                       * called SUBHFILE only once to improve code efficiency
!C  13 Jun 2018 D. Kang: Changes to accommodate the twoway WRF-CMAQ coupled model 
!C                       with/without data passing (lightning assimilation and NO emissions)
!C   5 Feb 2019 D. Kang: Changed the Lightning flash variable name (NLDNstrk) and make it 
!C                       consistent with the name (LNT) used in lightning assimilation;
!C                       In the meantime, it still can read the files with old name by 
!C                       defining a LT_NAME variable. A bug fix related to read RC variable
!C                       from met input file is also implemented.
!C  01 Feb 2019 D. Wong: Implemented centralized I/O approach, removed all MY_N clauses
!C  12 Mar 2019 D. Wong: Implemented centralized I/O approach to the twoway portion of the code
!C                       and fixed a bug to handle the output time step is less than 1 hour
!C                       scenario properly
!C  3 Sep 2019 D. Kang: Added to scale factors for the vertical distribution and to make sure 
!C                      the profile is similar to those reported in literature and fixed a bug 
!C                      that was introduced two years ago for generating diagnotic 3D lightning emissions.
!C 4 Feb 2020 D. Kang: Remove the SATLAM function call that is redundant and clean up the code to comply with 
!C                      the implementation of CIO.Though there is no effect when run the model over the continental
!C                      US (Lambert projection), when run over the hemisphere and turning lightning NOx on,
!C                       the run would crash due to uncompatible projection (polar)
!C 6 Jan 2020 D. Kang: Correct the time steps in the lightning NOx !diagnostic files from 1:00 - 0:00 to 0:00 to 23:00
!C----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE DESID_VARS

      IMPLICIT NONE

      REAL,    ALLOCATABLE, SAVE :: VDEMIS_LT( :,:,: )   ! lightning emis

!C lightning emis species name
      CHARACTER( 16 ), PARAMETER :: LTSPC = 'NO'
      
      PUBLIC :: VDEMIS_LT, LTNG_INIT, GET_LTNG, LTSPC
      PRIVATE

!C lightning log linear regression parameters with RC 
      REAL,                 SAVE :: SQUAREKM
      REAL,                 SAVE :: SCL_FACTOR

      INTEGER,              SAVE :: LTLYRS     ! no. of emissions layers
      REAL,    ALLOCATABLE, SAVE :: VDEMIS_LTDIAG( :,:,: ) ! lightning NO diagnostic
      REAL,    ALLOCATABLE, SAVE :: COLUMN_DIAG( :,: ) ! column total NO

      CHARACTER( 16 ),      SAVE :: RC_NAME       ! RC name: old is RC and CCnew is RCA

!C allocate these if LTNG_FNAME = 'INLINE'
      REAL,    ALLOCATABLE, SAVE :: LTNG_PRSFC     ( :,: ) ! surface pressure
      REAL,    ALLOCATABLE, SAVE :: LTNG_RC        ( :,: ) ! convective rainfall
!C allocate these if LPARAM
      REAL,    ALLOCATABLE, SAVE :: NLDN_STRIKE    ( :,: ) ! Hourly NLDN strike data
      REAL,    ALLOCATABLE, SAVE :: ICCG           ( :,: ) ! intercloud strikes per cloud to ground strike
!C Vertical coord values
      REAL,    ALLOCATABLE, SAVE :: VGLVSLT        ( : )

!C    scenario time/date needed for diagnostic output
      INTEGER,              SAVE :: NTICS = 0 ! no. of substeps within an output tstep
      INTEGER,              SAVE :: MTICS = 0 ! temporary sub for NTICS before it set to 0 
      INTEGER,              SAVE :: LDATE     ! test date to update emissions diag avg
      INTEGER,              SAVE :: LTIME     ! test time to update emissions diag avg
      INTEGER                    :: FDATE     ! Start date to Write to Diagnostic files
      INTEGER                    :: FTIME     ! Start time to Write to Diagnostic files

      INTEGER,              SAVE :: LT_TSTEP
      INTEGER                    :: LT_TSTEP_F  ! same time step info as LT_TSTEP but in HHMMSS format

      CONTAINS

!C======================================================================
!C Initialize lightning routines

         FUNCTION LTNG_INIT ( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )

         USE GRID_CONF ! horizontal & vertical domain specifications
         USE CGRID_SPCS         ! CGRID mechanism species
         USE UTILIO_DEFN
         USE CENTRALIZED_IO_MODULE, only : RCA_AVAIL, ICCG_SUM, ICCG_WIN,
     &                                     FILE_TSTEP, F_MET, F_LTNG,
     &                                     LT_NAME, FILE_XCELL, FILE_YCELL
         USE MIO_ASCII

#ifdef twoway
         USE twoway_data_module
#endif

         IMPLICIT NONE

!C Includes:
         INCLUDE SUBST_FILES_ID  ! file name parameters

!C Arguments:
         INTEGER :: JDATE, JTIME, TSTEP

         LOGICAL SUCCESS

!C External Functions:
         LOGICAL,     EXTERNAL :: CHKGRID

!C value to start log linear regression  
         CHARACTER( 16 )       :: PNAME = 'LTNG_INIT'
         CHARACTER( 80 )       :: VARDESC   ! env variable description
         CHARACTER( 120 )      :: XMSG = ' '
         REAL                  :: X, Y, VAL
         INTEGER               :: C, R

         LOGICAL LTNGPARAM           ! env var to use lightning NO parameters file
         INTEGER LSPCS               ! no. of lightning species
         INTEGER               :: I, J, K, L, V, STATUS
         INTEGER               :: CJDATE
         CHARACTER( 7 )        :: SJDATE

         LOGICAL OK
         INTEGER               :: SPC

!-----------------------------------------------------------------------

         SUCCESS = .TRUE.

!C Lightning NO production
         IF ( .NOT. LTNG_NO ) RETURN

!C Populate Emissions Species Record
         DESID_EMVAR( ILTSRM )%LEN = 1
         ALLOCATE( DESID_EMVAR( ILTSRM )%ARRY ( 1 ) )
         ALLOCATE( DESID_EMVAR( ILTSRM )%UNITS( 1 ) )
         ALLOCATE( DESID_EMVAR( ILTSRM )%MW   ( 1 ) )
         ALLOCATE( DESID_EMVAR( ILTSRM )%USED ( 1 ) )
         ALLOCATE( DESID_EMVAR( ILTSRM )%CONV ( 1 ) )
         ALLOCATE( DESID_EMVAR( ILTSRM )%BASIS( 1 ) )
         ALLOCATE( DESID_EMVAR( ILTSRM )%LAREA( 1 ) )
         ALLOCATE( DESID_EMVAR( ILTSRM )%LAREAADJ( 1 ) )
         
         DESID_EMVAR( ILTSRM )%ARRY  = "NO"
         DESID_EMVAR( ILTSRM )%UNITS = 'MOLES/S'
         DESID_EMVAR( ILTSRM )%MW    = 30.0
         DESID_EMVAR( ILTSRM )%USED  = .FALSE.
         DESID_EMVAR( ILTSRM )%CONV  = 1.0
         DESID_EMVAR( ILTSRM )%BASIS = 'MOLE'
         DESID_EMVAR( ILTSRM )%LAREA = .FALSE.
         DESID_EMVAR( ILTSRM )%LAREAADJ = .FALSE.
 
!C Read in scenario time/date

         WRITE( SJDATE, '(I7)' ) JDATE
         READ( SJDATE, '(4X, I3)' ) CJDATE

#ifndef mpas
!C Is lightning NO production inline, or from a file?
         CALL UPCASE(LTNG_FNAME)
         IF ( LTNG_FNAME .EQ. "INLINE" ) THEN  ! inline lightning NO production
            XMSG = 'Using in-line lightning NO production'
            CALL M3MSG2( XMSG )

#ifdef twoway
           IF (wrf_lightning_assim) THEN
              NLDNSTRIKE = .FALSE.
           END IF
#endif
           IF ( RCA_AVAIL ) THEN
               RC_NAME = 'RCA'
           ELSE
               RC_NAME = 'RC'
           END IF
           IF ( NLDNSTRIKE ) THEN
                  XMSG = 'Using hourly NLDN Strike data'
                  CALL M3MSG2( XMSG )

               LT_TSTEP = TIME2SEC ( FILE_TSTEP(F_LTNG)  )
               LT_TSTEP_F = FILE_TSTEP(F_LTNG) 

            ELSE
                 LT_TSTEP = TIME2SEC ( TSTEP )
                 LT_TSTEP_F = TSTEP 
                 XMSG = 'Using derived parameters for KF scheme '
                 CALL M3MSG2( XMSG )
            END IF  !END if NLDNSTRIKE

!            LT_TSTEP_F = SEC2TIME (LT_TSTEP)

            SQUAREKM = REAL( ( XCELL_GD * YCELL_GD * 1.0D-6 ), 4 )
!C Set up vertical layers
            ALLOCATE( VGLVSLT( 0:DESID_LAYS ), STAT = STATUS )
            CALL CHECKMEM( STATUS, 'VGLVSLT', PNAME )

            ALLOCATE( ICCG        ( NCOLS,NROWS ),
     &                   LTNG_PRSFC  ( NCOLS,NROWS ),
     &                   NLDN_STRIKE ( NCOLS,NROWS ),
     &                   LTNG_RC     ( NCOLS,NROWS ),STAT = STATUS )
               IF ( STATUS .NE. 0 ) THEN
                  XMSG = 'ICCG, OCEAN_MASK, LTNG_Parameters'
     &                 // '  memory allocation failed'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF
               IF ( CJDATE .GT. 90 .AND. CJDATE .LT. 274 ) THEN
                  ICCG = ICCG_SUM
               ELSE
                  ICCG = ICCG_WIN
               END IF
!            END IF  !LPARAM
!C Store local layer information
            DO L = DESID_LAYS, 0, -1
                  VGLVSLT( L ) = VGLVS_GD( L+1 )
!                  WRITE( LOGDEV,'(5X, A, I3, A, F11.7)' ) 'VGLVSLT(', L, ' ):', VGLVSLT( L )
            END DO


            LDATE = STDATE; LTIME = STTIME
            IF ( LTNGDIAG ) THEN
!C Build description for, and open lightning diagnostic file
!C (all but variables-table and horizontal domain in description is borrowed from MNAME)
               FDATE = STDATE
               FTIME = STTIME
               CALL NEXTIME( FDATE, FTIME, TSTEP )
               SDATE3D = FDATE
               STIME3D = FTIME
               TSTEP3D = TSTEP

               FTYPE3D = GRDDED3
               NCOLS3D = GL_NCOLS
               NROWS3D = GL_NROWS
               NTHIK3D = 1
               GDTYP3D = GDTYP_GD
               P_ALP3D = P_ALP_GD
               P_BET3D = P_BET_GD
               P_GAM3D = P_GAM_GD
               XORIG3D = XORIG_GD
               YORIG3D = YORIG_GD
               XCENT3D = XCENT_GD
               YCENT3D = YCENT_GD
               XCELL3D = XCELL_GD
               YCELL3D = YCELL_GD
               VGTYP3D = VGTYP_GD
               VGTOP3D = VGTOP_GD
               GDNAM3D = GRID_NAME  ! from HGRD_DEFN

               NLAYS3D = DESID_LAYS
               DO L = 1, NLAYS3D + 1
                  VGLVS3D( L ) = VGLVS_GD( L )
               END DO

               NVARS3D = 1
               VNAME3D( 1 ) = LTSPC
               VDESC3D( 1 ) = 'hourly average NO produced from lightning'
               VTYPE3D( 1 ) = M3REAL
               UNITS3D( 1 ) = 'mol s-1'

               FDESC3D = ' '   ! array assignment
               FDESC3D( 1 ) = 'Gridded lightning NO production from CMAQ'
               FDESC3D( 2 ) = '/from/ ' // PNAME
               FDESC3D( 3 ) = '/Version/ CMAQ'

               ! Store MIO Metadata
               NDIMS3D( 1:NVARS3D ) = 4
               L_TSTEP( 1:NVARS3D ) = .True.
               L_LAY  ( 1:NVARS3D ) = .True.
               L_COL  ( 1:NVARS3D ) = .True.
               L_ROW  ( 1:NVARS3D ) = .True.
               L_VEXT ( 1:NVARS3D ) = .False.
          
               CALL LOAD_MIO_FILE ( 'CTM_LTNGDIAG_1', NLAYS3D, 1, NLAYS3D,
     &              VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &              VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &              L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &              L_VEXT(1:NVARS3D) )
               
               ! Store MIO Metadata
               NDIMS3D( 1:NVARS3D ) = 3
               L_TSTEP( 1:NVARS3D ) = .True.
               L_LAY  ( 1:NVARS3D ) = .False.
               L_COL  ( 1:NVARS3D ) = .True.
               L_ROW  ( 1:NVARS3D ) = .True.
               L_VEXT ( 1:NVARS3D ) = .False.
               
               CALL LOAD_MIO_FILE ( 'CTM_LTNGDIAG_2', 0, 0, 0,
     &              VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &              VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &              L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &              L_VEXT(1:NVARS3D) )
               
!C Open output file (mol s-1)
               IF ( IO_PE_INCLUSIVE ) THEN
                  IF ( .NOT. OPEN3( CTM_LTNGDIAG_1, FSUNKN3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM( CTM_LTNGDIAG_1 )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
                  NLAYS3D = 1
                  VDESC3D( 1 ) = 'Column NO produced from lightning'
                  IF ( .NOT. OPEN3( CTM_LTNGDIAG_2, FSUNKN3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM( CTM_LTNGDIAG_2 )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF

               END IF

               ALLOCATE( VDEMIS_LTDIAG( NCOLS,NROWS,DESID_LAYS ), STAT = STATUS )
               IF ( STATUS .NE. 0 ) THEN
                  XMSG = 'VDEMIS_LTDIAG memory allocation failed'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF
               VDEMIS_LTDIAG = 0.0   ! array assignment
               ALLOCATE( COLUMN_DIAG( NCOLS,NROWS), STAT = STATUS )
               IF ( STATUS .NE. 0 ) THEN
                  XMSG = 'COLUMN_DIAG memory allocation failed'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF
               COLUMN_DIAG = 0.0   ! array assignment
            END IF   ! LTNGDIAG
         ELSE   ! lightning emissions off line

!C Lightning NO production from an input file
            CALL M3MSG2( 'Using lightning NO production from a file' )

!C Check grid definition (intialize, if first call)
            OK = CHKGRID( LTNG_FNAME )


         END IF   ! IF ( LTNG_FNAME .EQ. "INLINE" ) inline or offline lightning NO production
#endif

         LTLYRS = DESID_LAYS

!C Build Emissions Buffer
         ALLOCATE( VDEMIS_LT( NCOLS,NROWS,LTLYRS ), STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
            XMSG = 'VDEMIS_LT memory allocation failed'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
 
!         RETURN

         END FUNCTION LTNG_INIT

!C======================================================================
!C Get NO produced from lightning in VDEMIS_LT

         SUBROUTINE GET_LTNG ( JDATE, JTIME, TSTEP, L_DESID_DIAG )

         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE UTILIO_DEFN
         USE CENTRALIZED_IO_MODULE, only : interpolate_var,
     &                                     OCEAN_MASK,
     &                                     SLOPE,
     &                                     INTERCEPT,
     &                                     SLOPE_lg,
     &                                     INTERCEPT_lg,
     &                                     ICCG_SUM,
     &                                     ICCG_WIN,
     &                                     LT_NAME
#ifdef mpas
         use util_module, only : time2sec, nextime, upcase
#else
#ifdef twoway
         USE twoway_data_module
#endif
#endif
         IMPLICIT NONE

         INCLUDE SUBST_FILES_ID  ! file name parameters

         INTEGER JDATE, JTIME, TSTEP( 3 )
         INTEGER STATUS
         LOGICAL, INTENT( IN ) :: L_DESID_DIAG ! flag determining whether or not DESID
                                               !   is in diagnostic mode              
         REAL,   PARAMETER :: CONVPA = 1.0E-2  ! convert Pa to hPa
!        REAL,   PARAMETER :: WK = 8.0         ! shape parameter for weibull distribution
!        REAL,   PARAMETER :: WLAMBDA = 700.0  ! scale parameter for weibull distribution
         REAL,   PARAMETER :: WMU = 350.0      ! mean
         REAL,   PARAMETER :: WSIGMA = 200.0   ! standard deviation
         REAL,   PARAMETER :: W2MU = 600.0     ! mean
         REAL,   PARAMETER :: W2SIGMA = 50.0   ! standard deviation
         REAL,   PARAMETER :: SQRT2 = 1.414213562731
         REAL,   PARAMETER :: SFACTOR1 = 0.95  ! the scaling factor for the wider distribution (WMU350)
         REAL,   PARAMETER :: SFACTOR2 = 0.12  ! the scaling factor for the wider distribution (WMU350

         INTEGER COL, ROW, LAY ! iterator variables

         REAL    PCALC    ! pressure level for NO vertical distribution (hPa)
         REAL    BOTTOM   ! pressure at bottom of grid cell (hPa)
         REAL    TOP      ! pressure at top of grid cell (hPa)        
         REAL    BOTTOM_FRAC, TOP_FRAC ! their difference is the fraction of lightning NO in this grid cell
         REAL    BOTTOM_FRAC2, TOP_FRAC2
         REAL    SUM_FRAC ! stores the sum of vertical fractions to re-normalize the column
         REAL    WEIGHT ! used to normalize emissions to total amount
         REAL    inErfB, inErfT !  nputs to error funciton calculation
         REAL    outErfB, outErfT ! outputs from error funciton calculation
         REAL :: LTEMIS( LTLYRS )
         REAL    XCELLR, YCELLR   ! cell spacing ratio to 36Km
         REAL    FLASH_FAC        ! lightning flashes factor

         LOGICAL,     SAVE :: LASTTIC   ! true: last sync step this output tstep
         REAL              :: DIVFAC   ! averaging factor for diagnostic file

         CHARACTER( 16 )   :: MNAME
         CHARACTER( 16 )   :: PNAME = 'GET_LTNG'
         CHARACTER( 120 )  :: XMSG = ' '
         REAL, ALLOCATABLE :: COLUMN_LTNG_NO ( :,: ) ! column total NO
         
         INTEGER           :: cjdate
         INTEGER           :: DTSTEP
         CHARACTER( 7 )    :: SJDATE

         LOGICAL,     SAVE :: R_READY = .TRUE.
         LOGICAL,     SAVE :: wrf_assim = .FALSE.
         INTEGER,     SAVE :: TOT_TSTEP
         LOGICAL,     SAVE :: FIRSTIME = .TRUE.

         REAL :: LOC_VGTOP_GD

!-----------------------------------------------------------------------
         
         CALL UPCASE(LTNG_FNAME)
         IF ( LTNG_FNAME .EQ. "INLINE" ) THEN
!C case of inline lightning NO production
!C initialize output array
            VDEMIS_LT = 0.0

            DTSTEP = TIME2SEC( TSTEP( 1 ) ) / TIME2SEC( TSTEP( 2 ) ) 
            !C Open me filet
!C Get domain window info for met_cro_2d file
            IF (FIRSTIME) THEN
                TOT_TSTEP = 0
                FIRSTIME = .FALSE.
            END IF
            WRITE( SJDATE, '(I7)') JDATE
            READ( SJDATE, '(4X, I3)') CJDATE

!C read in the hourly lightning strike file
#ifdef twoway
            IF(wrf_lightning_assim) THEN
              call interpolate_var ('LNT', jdate, jtime, NLDN_STRIKE)
!C Interpret the timestep NLDN_STRIKE value into hourly value
              NLDN_STRIKE = NLDN_STRIKE*60/LT_ASM_DT
               wrf_assim = .TRUE.
!               WRITE(*,*) "Max NLDN_STRIKE = ", MAXVAL(NLDN_STRIKE)
            ELSE
              IF ( .NOT. NLDNSTRIKE ) THEN
                call interpolate_var (RC_NAME, jdate, jtime, LTNG_RC)
!C Interpret the timestep RC value into hourly value
                LTNG_RC = LTNG_RC*DTSTEP
              END IF
            END IF
            call interpolate_var ('PRSFC', jdate, jtime, LTNG_PRSFC)
#else
            IF ( R_READY ) THEN
               IF ( .NOT. NLDNSTRIKE ) THEN
                  call interpolate_var (RC_NAME, ldate, ltime, LTNG_RC)
               END IF
               call interpolate_var ('PRSFC', ldate, ltime, LTNG_PRSFC)

               IF ( .NOT. NLDNSTRIKE ) THEN
                  R_READY = .FALSE.
               END IF
            END IF
#endif

            IF( R_READY ) THEN
               IF ( NLDNSTRIKE ) THEN
                  call interpolate_var (LT_NAME, ldate, ltime, NLDN_STRIKE)
                  R_READY = .FALSE.
               END IF  ! NLDNSTRIKE
            END IF     !R_READY
            ALLOCATE( COLUMN_LTNG_NO( NCOLS,NROWS ), STAT = STATUS )
            IF ( STATUS .NE. 0 ) THEN
               XMSG = 'COLUMN_LTNG_NO memory allocation failed'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            COLUMN_LTNG_NO( :,: ) = 0.0
!C Iterate over each grid cell and distribute lightning NO vertically
               DO ROW = 1, NROWS
                  DO COL = 1, NCOLS
                     IF ( NLDNSTRIKE .or. wrf_assim ) THEN
                        COLUMN_LTNG_NO( COL,ROW ) =
     &                     ( NLDN_STRIKE( COL,ROW )
     &                       * SQUAREKM     ! NLDN_STRIKE in km-2
     &                       * OCEAN_MASK( COL,ROW ) ! reduce offshore strikes
     &                       * ( MOLSNCG + MOLSNIC * ICCG( COL,ROW ) ) )
     &                       / ( 60.0 * 60.0 ) ! get time units right: emissions are in the unit of moles/s
                     ELSE
                        IF ( LTNG_RC( COL,ROW ) .GT. 0 ) THEN
                           SCL_FACTOR = EXP(INTERCEPT_lg(COL, ROW))
                           IF ( LTNG_RC( COL,ROW ) .GT. SCL_FACTOR .AND. OCEAN_MASK( COL,ROW ) .GT. 0.2 )THEN
                              COLUMN_LTNG_NO( COL,ROW ) =
     &                         ( EXP( SLOPE_LG( COL,ROW ) * LOG( LTNG_RC( COL,ROW ) )
     &                           + INTERCEPT_LG( COL,ROW) )
     &                           * SQUAREKM   ! the relation is built on the unit of flash/km2*hr
     &                           * OCEAN_MASK( COL,ROW ) ! reduce offshore strikes
     &                           * ( MOLSNCG  ! moles N per flash intercloud strikes per cloud-to-ground strike
     &                             + ( MOLSNIC * ICCG( COL,ROW ) ) ) )
     &                         / ( 60.0 * 60.0 )         ! get time units right
                              IF ( COLUMN_LTNG_NO( COL,ROW ) .LT. 0 ) COLUMN_LTNG_NO( COL,ROW ) = 0.0
                           ELSE
                              COLUMN_LTNG_NO( COL,ROW ) =
     &                         ( ( SLOPE( COL,ROW ) * LTNG_RC( COL,ROW ) + INTERCEPT( COL,ROW ) )
     &                           * SQUAREKM   ! the relation is built on flash/km2*hr
     &                           * OCEAN_MASK( COL,ROW ) ! reduce offshore strikes
     &                           * ( MOLSNCG  ! moles N per flash intercloud strikes per cloud-to-ground strike
     &                             + ( MOLSNIC * ICCG( COL,ROW ) ) ) )
     &                         / ( 60.0 * 60.0 )         ! get time units right 
                              IF ( COLUMN_LTNG_NO( COL,ROW ) .LT. 0 ) COLUMN_LTNG_NO( COL,ROW ) = 0.0
                           END IF
                        ELSE
                           COLUMN_LTNG_NO( COL,ROW ) = 0.0
                        END IF
                     END IF   ! NLDNSTRIKE
                  END DO   ! COL
               END DO   ! ROW

            VDEMIS_LT = 0.0   ! array assignment

            DO ROW = 1, NROWS
               DO COL = 1, NCOLS

!C check to see if there are lightning strikes for this grid cell
!C only calculate lightning for cloud top greater than 6500 meters

                  IF ( COLUMN_LTNG_NO( COL,ROW ) .LE. 0.0 ) CYCLE
                  SUM_FRAC = 0.0
                  LTEMIS = 0.0   ! array assignment

#ifdef mpas
                  LOC_VGTOP_GD = 1000.0    ! for simplicity, we have decided to set VGTOP_GD to 1000.0
#else
                  LOC_VGTOP_GD = VGTOP_GD
#endif

                  DO LAY = 1, LTLYRS

!C Get pressures: Use SIGMA values and surface pres.
!p=sigma*(psfc-ptop)+ptop
                     BOTTOM = ( VGLVSLT( LAY-1 )
     &                      * ( LTNG_PRSFC( COL,ROW ) - LOC_VGTOP_GD )
     &                      + LOC_VGTOP_GD ) * CONVPA
!                           write( logdev,* ) "bottom: ", bottom
                     TOP    = ( VGLVSLT( LAY )
     &                      * ( LTNG_PRSFC( COL,ROW ) - LOC_VGTOP_GD )
     &                      + LOC_VGTOP_GD ) * CONVPA

!C Find the bottom and top of each layer, and calculate the fraction 
!C of the column emissions for that layer
!C Use normal distribution, mean = wmu, standard deviation = wsigma
                     inErfB      = ( BOTTOM - WMU ) / ( WSIGMA * SQRT2 )
                     inErfT      = ( TOP - WMU ) / ( WSIGMA * SQRT2 )
                     outErfB     = ERF( inErfB )
                     outErfT     = ERF( inErfT )
                     BOTTOM_FRAC = 0.5 * ( 1.0 + outErfB )
                     TOP_FRAC    = 0.5 * ( 1.0 + outErfT )

!C Find the bottom and top of each layer, and calculate the fraction
!C of the column emissions for that layer
!C use normal distribution, mean = wmu, standard deviation = wsigma
                     inErfB       = ( BOTTOM - W2MU ) / ( W2SIGMA * SQRT2 )
                     inErfT       = ( TOP - W2MU ) / ( W2SIGMA * SQRT2 )
                     outErfB      = ERF( inErfB )
                     outErfT      = ERF( inErfT )
                     BOTTOM_FRAC2 = 0.5 * ( 1.0 + outErfB )
                     TOP_FRAC2    = 0.5 * ( 1.0 + outErfT )

!C Add weighted contribution to this level
                     WEIGHT = ( BOTTOM_FRAC - TOP_FRAC ) * SFACTOR1
     &                      + ( BOTTOM_FRAC2 - TOP_FRAC2 ) * SFACTOR2 

                     LTEMIS( LAY ) = WEIGHT * COLUMN_LTNG_NO( COL,ROW )

!C Sum weights in order to normalize to 1
                     SUM_FRAC = SUM_FRAC + WEIGHT

!C If emissions are less than 0, generate an error message in the log
                     IF ( LTEMIS( LAY ) .LT. 0.0 ) THEN
                        WRITE( LOGDEV,* ) LTEMIS( LAY ),
     &                                    COLUMN_LTNG_NO( COL,ROW ),
     &                                    BOTTOM_FRAC, TOP_FRAC
                        XMSG = '*** Ltng NO emis is less than zero'
                        CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
                     END IF

                  END DO   ! end layers loop 

                  DO LAY = 1, LTLYRS
!C Re-normalize, in some cases area under the error function is not 1
                     VDEMIS_LT( COL,ROW,LAY ) = LTEMIS( LAY ) / SUM_FRAC
                  END DO        ! layers renormalized

               END DO   ! columns
            END DO   ! rows

!C Determine the time to read and/or write the hourly files
            IF ( .NOT. L_DESID_DIAG ) THEN
              NTICS = NTICS + 1
              TOT_TSTEP = TOT_TSTEP + TIME2SEC( TSTEP( 2 ) )
              LASTTIC = TOT_TSTEP .GE. LT_TSTEP
              IF ( LASTTIC ) THEN
                 MTICS = NTICS
                 NTICS = 0
                 TOT_TSTEP = 0
                 CALL NEXTIME( LDATE, LTIME, LT_TSTEP_F)
                 R_READY = .TRUE.
              END IF
            END IF

#ifdef mpas
#else
!C Write lightning NO to the diagnostic file
            IF ( LTNGDIAG .AND. .NOT. L_DESID_DIAG ) THEN 
               VDEMIS_LTDIAG = VDEMIS_LTDIAG + VDEMIS_LT   ! array assignment
               COLUMN_DIAG = COLUMN_DIAG + COLUMN_LTNG_NO
               IF ( LASTTIC ) THEN   ! time to write out
                  DIVFAC = 1.0 / REAL( MTICS, 4 )
                  VDEMIS_LTDIAG = VDEMIS_LTDIAG * DIVFAC   ! array assignment
                  COLUMN_DIAG = COLUMN_DIAG*DIVFAC
                  IF ( .NOT. WRITE3( CTM_LTNGDIAG_1, LTSPC, LDATE, LTIME, VDEMIS_LTDIAG ) )  THEN
                     XMSG = 'Could not write to ' // TRIM( CTM_LTNGDIAG_1 )
                     CALL M3EXIT( PNAME, LDATE, LTIME, XMSG, XSTAT2 )
                  ELSE
                     WRITE( LOGDEV,94040 )
     &                    'Timestep written to', TRIM( CTM_LTNGDIAG_1 ),
     &                    'for date and time', LDATE, LTIME
                  END IF
                  IF ( .NOT. WRITE3( CTM_LTNGDIAG_2, LTSPC, LDATE, LTIME, COLUMN_DIAG ) )  THEN
                     XMSG = 'Could not write to ' // TRIM( CTM_LTNGDIAG_2 )
                     CALL M3EXIT( PNAME, LDATE, LTIME, XMSG, XSTAT2 )
                  ELSE
                     WRITE( LOGDEV,94040 )
     &                    'Timestep written to', TRIM( CTM_LTNGDIAG_2 ),
     &                    'for date and time', LDATE, LTIME
                  END IF

                  VDEMIS_LTDIAG = 0.0   ! array assignment
                  COLUMN_DIAG = 0.0
               END IF ! LASTTIC

            END IF  ! diagnostics turned on
#endif

         ELSE  ! LTNGO is not "InLine", but instead specifies a file

!C Read in lightning NO production from an input file
            VDEMIS_LT = 0.0   ! array assignment

            call interpolate_var (LTSPC, jdate, jtime, VDEMIS_LT)

         END IF  ! end lightning NO production inline or from a file


         DEALLOCATE( COLUMN_LTNG_NO )


         RETURN

C------------------  Format  Statements   ------------------------------

94040 FORMAT( /5X, 3( A, :, 1X ), I8, ":", I6.6 )
94042 FORMAT( /5X, A, 1X, I8, ":", I6.6, 1X, 1PE13.5 )

         END SUBROUTINE GET_LTNG

      END MODULE LTNG_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PHOT_MOD

C-----------------------------------------------------------------------
C
C  FSB This version has NO internal write statements
C  FSB This version has the code for XR96 added.
C  FSB change indices from L to II in newOptics loop 08/17/2006
C  FSB This version has all write statements commented out.(08/03/2006)
C
C  FSB NOTE - this code assumes that the top of the modeling domain
C  is about 100 [mb] or 10 [kPa] ~ 16 [km] in altitude. If a
C  higher altitude top is used , the method of calculating the
C  ozone column and the ozone optical depth will be necessary.
C
C  FSB This version has the addition of Rayleigh optical depth for the
C  stratosphere as well as the calculation of single scattering
C  albedo for the AOD calculation. (01/17/2006)
C  FSB This version has deleted the JPROC values of Cs and Qy as well as
C  the default aerosol.  It also contains the fast optics
C  routines.
C  FSB This module supports the SAPRC99 Chemical mechanism within
C  CMAQ.
C  FSB This version calls a fast optical routine for aerosol
C  extinction and scattering
C  FSB This version uses a set of constant refractive indices
C  The new subroutine GETNEWPAR now sets up the refractive indices.
C  
C  Bill Hutzell(Mar 2011) moved determining refractive indices to a
C  separate file and new subroutine called AERO_PHOTDATA.
C  
C  Bill Hutzell(Jun 2011) modified TWOSTREAM_S subroutine to account for 
C  GAM2 equal to zero in the Toon et al. (1989) solution to the two stream
C  of the radiative transfer equation based on how the NCAR TUV model 
C  implements the approximation
C
C  Bill Hutzell(May 2013) modified optical depth agruments to give vetical
C  profile rather than surface values. Note that TAU_TOT now includes 
C  stratospheric values.
! Bill Hutzell(Mar 2014) modified calculation of aerosol and cloud optical
! properites as well as their calculated optical depths. The changes employ
! FORTRAN modules that contain the layer level of the optical properties.
C  07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C  10/10/14 - DJL added references to IUPAC10 to NO2 and O3 photo rates
C  23Jun15   B.Hutzell: made TWOSTREAM and TRIDIAGONAL routine use REAL(8) variables
C  30Jul15  J.Young: REAL(4) -> REAL for code portability
C-----------------------------------------------------------------------

      USE RUNTIME_VARS    
      USE CSQY_DATA
      USE PHOT_MET_DATA, ONLY: CFRAC_2D_AVE => CFRAC_2D
      USE CONST

      IMPLICIT NONE

!***parameters

      REAL, PARAMETER :: SMALL = 1.0E-36    ! a small number

!***Fundamental Constants: ( Source: CRC76, pp 1-1 to 1-6)

      REAL, PARAMETER :: PLANCK_C = 6.62606876E-34 ! Planck's Constant [Js]
      REAL, PARAMETER :: LIGHT_SPEED = 299792458.0 ! speed of light in a vacuum

      REAL, PARAMETER :: DU_TO_CONC = 2.6879E16        ! factor from [DU] to [molecules/cm^2]
      REAL, PARAMETER :: CONC_TO_DU = 1.0 / DU_TO_CONC 
      
      LOGICAL, PARAMETER :: ADJUST_OZONE = .FALSE.     ! Flag to correct tropospheric ozone optical depth based
                                                       ! on climatology

       REAL :: MIN_STRATO3_FRAC ! minimum fraction of O3 column in statosphere
       REAL :: MAX_TROPOO3_FRAC ! maximum fraction of O3 column in troposphere

!      REAL, PARAMETER :: MIN_STRATO3_FRAC = 0.55                   ! minimum fraction of O3 column in statosphere
                                                                    !  if PTOP = 50 mb
!      REAL, PARAMETER :: MAX_TROPOO3_FRAC = 1.0 - MIN_STRATO3_FRAC ! maximum fraction of O3 column in troposphere

!***LOGDEV for NEW_OPTICS and supporting routines
      
      INTEGER, SAVE :: NEW_OPTICS_LOG

      INTEGER, SAVE              :: N_DIAG_WVL    ! number of diagnostic wavelengths in PHOTDIAG3 file
      INTEGER, ALLOCATABLE, SAVE :: DIAG_WVL( : ) ! pointers to diagnostic wavelengths
      
      INTEGER            :: N_TROPO_O3_TOGGLE      ! number of adjustments to ozone extinction 
 
      REAL, ALLOCATABLE  :: RJ      ( :, :, :, : ) ! average grid cell J-values (min-1)
      REAL, ALLOCATABLE  :: RJ_RES  ( :, :, :, : ) ! resolved cloud J-values (min-1)
      REAL, ALLOCATABLE  :: RJ_SUB  ( :, :, :, : ) ! subgrid cloud J-values (min-1)
      REAL, ALLOCATABLE  :: ETOT_SFC_WL ( :,:,: )  ! total downward irradiance at sfc [ Watts / m**2  ]
      
      REAL, ALLOCATABLE  :: BLKHCHO( : )           ! formaldehyde concentration [ molecules/cm**3 ]
      REAL, ALLOCATABLE  :: BLKCO  ( : )           ! CO concentration [ molecules/cm**3 ]
      REAL, ALLOCATABLE  :: BLKSO2 ( : )           ! SO2 concentration [ molecules/cm**3 ]
      REAL, ALLOCATABLE  :: BLKDZ  ( : )           ! layer thicknesses [ m ]
      REAL, ALLOCATABLE  :: GAS_EXTINCTION( :,: )  ! extinction from gases per layer [1/m]
      REAL, ALLOCATABLE  :: EXTINCTION    ( :,: )  ! total extinction per layer [1/m]
      REAL, ALLOCATABLE  :: ACTINIC_FLUX  ( :,: )  ! actinic fluxes, initially [Photons/(cm^2s)] then  [Watts/m^2] 
      REAL, ALLOCATABLE  :: IRRADIANCE    ( :,: )  ! total downward irradiance [Watts/m^2]
      REAL               :: REFLECTION             ! broad band reflection coefficient (diffuse) at model top 
      REAL               :: TRANSMISSION           ! broad band transmission coefficient (diffuse) at surface
      REAL               :: TRANS_DIRECT           ! broad band direct transmission coefficient at surface
      REAL               :: TROPO_O3_COLUMN        ! ozone column density in the troposphere [Dobson Units]
      REAL               :: TROPO_O3_TOGGLE        ! factor correcting tropospheric ozone column 
      REAL               :: O3_TOGGLE_AVE          ! average of nonunity factors adjusting ozone extinction 
      REAL               :: O3_TOGGLE_MIN          ! Max of nonunity factors adjusting ozone extinction 
      REAL               :: COS85                  ! cosine of 85 degrees
  
      ! Summary Aerosol Metrics Needed by the PM Diagnostic Module
      REAL, ALLOCATABLE, SAVE :: TAU_AERO_550( :,: )   ! total aerosol optical depth at 550 nm (Angstrom Interpolation)
      REAL, ALLOCATABLE, SAVE :: AERO_EXT_550( :,:,: ) ! aerosol extinction at 550 nm for layer [1/m]
      REAL, ALLOCATABLE, SAVE :: TAU_ABS_AERO_550( :,: ) ! sbsorption aerosol optical depth at 550 nm (Angstrom Interpolation)
      REAL, ALLOCATABLE, SAVE :: AERO_ABS_550( :,:,: )   ! aerosol absorption coeff at 550 nm for layer [1/m]

      LOGICAL            :: ONLY_SOLVE_RAD             ! only compute fluxes     
      LOGICAL            :: OBEY_STRATO3_MINS = .TRUE. ! Has stratospheric O3 column not violated 
                                                       ! climatological minimums, yet?
      LOGICAL            :: STRATO3_MINS_MET           ! Does the call to NEW_OPTICS meet the stratospheric O3 column
                                                       ! climatological minimums?

           
      CHARACTER( 133 )   :: PHOT_MOD_MSG
      
      INTEGER            :: PHOT_COL   ! cell column of routine calling module routine
      INTEGER            :: PHOT_ROW   ! cell row of routine calling module routine


      CONTAINS
      
      SUBROUTINE INIT_PHOT_SHARED()

          USE RXNS_DATA            ! chemistry variables and data
          USE GRID_CONF            ! horizontal & vertical domain specifications
          USE UTILIO_DEFN
! Purpose: initialize data and arrays shared by other science processes      
          IMPLICIT NONE
!Arguments: None

!Local:          
          INTEGER          :: ALLOCSTAT
          CHARACTER( 240 ) :: XMSG = ' '
          LOGICAL, SAVE    :: INITIALIZED = .FALSE.
          
          IF ( INITIALIZED ) RETURN
          
          INITIALIZED = .TRUE.

          CALL LOAD_CSQY_DATA( )

          CALL LOAD_OPTICS_DATA( )

          ALLOCATE( RJ      ( NCOLS, NROWS, NLAYS, NPHOTAB ),
     &              RJ_RES  ( NCOLS, NROWS, NLAYS, NPHOTAB ),
     &              RJ_SUB  ( NCOLS, NROWS, NLAYS, NPHOTAB ), STAT = ALLOCSTAT )
          IF ( ALLOCSTAT .NE. 0 ) THEN
              XMSG = 'Failure allocating photolysis rate arrays'
              CALL M3EXIT ( 'INIT_PHOT_SHARED', 0, 0, XMSG, XSTAT1 )
          END IF

          ALLOCATE( ETOT_SFC_WL( NCOLS,NROWS,NWL ), STAT = ALLOCSTAT )
          IF ( ALLOCSTAT .NE. 0 ) THEN
              XMSG = 'Failure allocating irradiance rate array'
              CALL M3EXIT ( 'INIT_PHOT_SHARED', 0, 0, XMSG, XSTAT1 )
          END IF

          RJ = 0.0; RJ_RES = 0.0; RJ_SUB = 0.0
          ETOT_SFC_WL = 0.0
          
      END SUBROUTINE INIT_PHOT_SHARED

C///////////////////////////////////////////////////////////////////////
      SUBROUTINE NEW_OPTICS ( JDATE, JTIME, NLAYS, 
     &                        BLKTA, BLKPRS, BLKDENS, BLKZH, BLKZF,
     &                        BLKO3, BLKNO2,
     &                        ZSFC, COSZEN, SINZEN, RSQD,
     &                        NEW_PROFILE, CLOUDS, CLDFRC,
     &                        BLKRJ, TAUC_AERO, TAU_TOT, TAUO3_TOP,
     &                        TAU_RAY, SSA_AERO, TAU_CLOUD, TOTAL_O3_COLUMN )
C-----------------------------------------------------------------------
C
C  FSB  NOTE new call vector <<<<<<<<<<<<< **********
C
C  FSB This version has clouds
C  FSB calculates the photolysis rates as a function of species and height
C
C  first coded 10/19/2004 by Dr. Francis S. Binkowski
C     Carolina Environmental Program
C     University of North Carolina at Chapel Hill
C     email: frank_binkowski@unc.edu
C  modified by FSB  July 29, 2005, 01/19/2006  by FSB
C
C  Mar 2011 Bill Hutzell
C      -revised arguement to account for aerosol redesign in 
C       CMAQ version 5.0
C      -change array declaration to allow flexible number of
C       wavelength bins 
C  Apr 2012 Bill Hutzell
C      -revised error checking to needed photolysis data 
C      -modified case statement for RACM2 photolysis rates
C      -moved aerosol optics to its own module
C  07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE RXNS_DATA            ! chemical mechanism data
      USE CLOUD_OPTICS         ! data and routines for optics of cloud hydrometeors

      USE AERO_PHOTDATA
      
      IMPLICIT NONE

!***arguments
      INTEGER, INTENT(IN) :: JDATE   ! julian date YYYYDDD
      INTEGER, INTENT(IN) :: JTIME   ! TIME HHMMSS
      INTEGER, INTENT(IN) :: NLAYS   ! # of vertical layers
      
      REAL,    INTENT(IN) :: BLKPRS ( : )       ! Air pressure in [ atm ]
      REAL,    INTENT(IN) :: BLKTA  ( : )       ! Air temperature [ K ]
      REAL,    INTENT(IN) :: BLKDENS( : )       ! Air density  [ molecules / cm**3 ]
      REAL,    INTENT(IN) :: BLKZH  ( : )       ! layer half-height [ m ]
      REAL,    INTENT(IN) :: BLKZF  ( : )       ! layer full height[ m ]
      REAL,    INTENT(IN) :: BLKO3  ( : )       ! O3 concentration [ molecules / cm**3 ]
      REAL,    INTENT(IN) :: BLKNO2 ( : )       ! NO2 concentration [ molecules / cm**3 ]
      REAL,    INTENT(IN) :: ZSFC               ! surface height (msl) [ m ]
      REAL,    INTENT(IN) :: COSZEN, SINZEN     ! sine and cosine of the zenith angle
      REAL,    INTENT(IN) :: RSQD               ! square of  solar distance [ au**2 ]

      LOGICAL, INTENT(IN) :: NEW_PROFILE     ! Has the atmospheric profile changed since last call?
      LOGICAL, INTENT(IN) :: CLOUDS( : )  ! Does layer have clouds
      REAL,    INTENT(IN) :: CLDFRC( : )  ! fraction of gridcell covered by cloud
      

      REAL,    INTENT(OUT) :: BLKRJ( :,: )  ! photolysis rates [ 1 / sec ]

      REAL,    INTENT(OUT) :: TAUC_AERO( :,: )  ! aerosol optical depth, bottom of layer
      REAL,    INTENT(OUT) :: TAU_TOT  ( :,: )  ! total optical depth, bottom of layer
      REAL,    INTENT(OUT) :: TAU_CLOUD( :,: )  ! cloud optical depth, bottom of layer

      REAL,    INTENT(INOUT) :: TAUO3_TOP( : )  ! optical depth of ozone above model domain
      REAL,    INTENT(INOUT) :: TAU_RAY  ( : )  ! Rayleigh optical depth above model domain
      REAL,    INTENT(OUT)   :: SSA_AERO ( : )  ! single scatering albedo for aerosol column
      
      REAL, INTENT(INOUT) :: TOTAL_O3_COLUMN  ! total ozone colum density [ DU ]

!***internal
      REAL, PARAMETER :: ONE_OVER_PI = 1.0 / PI 
      REAL, PARAMETER :: STRAT_TEMP  = 225.0    ! stratospheric temperature
      REAL, PARAMETER :: ZTOA        = 50.0E3   ! top of the atmosphere [ m ]

      INTEGER L, I, IWL, II, ILEV, IPHOT, MODE ! loop indices

      INTEGER NLEVEL
      REAL SOLAR_FLUX        ! solar flux at atmosphere top in a wavelength band, [photons/(cm^2*s)]
      REAL INSOLATION        ! downward solar flux at atmosphere top summed over wavelength bands, [photons/(cm^2*s)]

      REAL DELTA_O3_COLUMN   ! change in ozone column density [molecules/cm2]
      REAL STRAT_O3_COLUMN   ! ozone column density in the stratosphere [molecules/cm2]
      REAL STRAT_O3_COLMIN   ! ozone minium column density in the stratosphere [molecules/cm2]
      REAL TAU_O3            ! optical depth of stratospheric ozone [ m ]
      REAL DENSTOM           ! estimated air density at top of model [ molecules / cm**3 ]
      REAL LAMDA             ! wavelength  [ nm ]
      REAL INV_LAMBDA        ! reciprocal of wavelength [ 1/nm ]
      REAL LAMDA_UM          ! wavelength  [ um ]

!***working absorption cross sections [ cm**2 ]. These have been corrected
!***  for ambient ( pressure and temperature ) conditions.

      REAL AO3
      REAL ANO2
      REAL BETA_M     ! molecular scattering coefficient [ 1/m ]
      REAL BEXT       ! total aerosol extinction coefficient [ 1/m ]
      REAL VFAC, BSC  ! unit correction factors
      REAL BSCAT      ! total aerosol scattering coefficient [ 1/m ]
      REAL G_BAR      ! total aerosol asymmetry factor

!***FSB The following variable is aq switch that allows a fast version of
!***  aerosol optics to be used when set to .TRUE.

!***scattering and absorption for the layer

      REAL DTABS_A, DTABS_M, DTSCAT_A, DTSCAT_M, DTSCAT, DTABS

!***variables describing the layer heights and slants
!     REAL DJ, DF
      REAL ZTOM                               ! top of model  [ m ]
      REAL, ALLOCATABLE, SAVE :: DSDH_TD( : ) ! slant path function from top down
      REAL, ALLOCATABLE, SAVE :: DSDH( : )    ! slant path function
      REAL, SAVE              :: DSDH_TOP     ! slantpath function from ZTOM to ZTOA

!***Increment of optical depth

      REAL, ALLOCATABLE, SAVE :: DTAU    ( : )   ! total depth at level
      REAL, ALLOCATABLE, SAVE :: DT_AERO ( : )   ! aerosol contribution at level
      REAL, ALLOCATABLE, SAVE :: DT_CLOUD( : )   ! cloud contribution at level

!***single scattering albedo for layer

      REAL, ALLOCATABLE, SAVE :: OM( : )

!***asymmetry factor

      REAL, ALLOCATABLE, SAVE :: G( : )

!***arrays for fluxes and irradiances used in

!***delta-Eddington code

      REAL, ALLOCATABLE, SAVE :: FDIR( : )   ! direct actinic flux
      REAL, ALLOCATABLE, SAVE :: FUP ( : )   ! diffuse upward actinic flux
      REAL, ALLOCATABLE, SAVE :: FDN ( : )   ! diffuse downward flux
      REAL, ALLOCATABLE, SAVE :: EDIR( : )   ! direct irradiance
      REAL, ALLOCATABLE, SAVE :: EUP ( : )   ! diffuse upward irradiance
      REAL, ALLOCATABLE, SAVE :: EDN ( : )   ! diffuse downward irradiance

!***surface albedo

      REAL RSFC

      REAL FX
      REAL, ALLOCATABLE, SAVE :: ESUM( : )   ! total downward irradiance
      REAL, ALLOCATABLE, SAVE :: FSUM( : )   ! total actinic flux

!***needed for stratospheric Raleigh optical depth
      REAL, PARAMETER :: R_G = 100.0 * RDGAS / GRAV  ! dry air gas constant
                                                     ! divided by gravitational
                                                     ! acceleration [cm/K] NOTE: cgs units

      REAL HSCALE               ! Scale height [cm] ! NOTE: cgs units

      REAL NBAR                 ! total number of air molecules [ # /cm**2 ]
                                ! above top of model domain


!***FSB Cloud properties.
!***  FSB These properties are taken fro HU & Stamnes,1993,
!***  An accurate parameterizationof the radiative properties of
!***  water clouds suitable for use in climate models, Journal of
!***  Climate, vol. 6, pp. 728-742. The values in the data statements
!***  were calculated with an equivalent radius of 10 micrometers.
!***  Note: Hu &Stamnes give beta in [ 1 / km/ for LWC in [ g / m**3 ]
!***  the values for beta/ LWC also give beta in [1/m] with LWC in [g/m **3]

      REAL G_CLOUD              ! local cloud asymmetry factor
      REAL OM_CLOUD             ! local cloud single scattering albedo
      REAL DTSCAT_CLOUD         ! level increment in cloud scattering optical
      REAL TAU_SCAT_CLD         ! total scattering optical depth of cloud
      REAL LAYERING_FACTOR      ! correction factor for cloud layering
      REAL STOZONE

      LOGICAL, SAVE :: FIRST = .TRUE.  ! Flag for first call
      LOGICAL       :: SUCCESS

!***arrays for fluxes and irradiances used in
      REAL, ALLOCATABLE, SAVE :: SRAYL( : )        ! Molecular scattering cross sections [ cm ** 2]
      REAL, ALLOCATABLE, SAVE :: TAU_SCAT( : )     ! aerosol scattering optical depth
      REAL, ALLOCATABLE, SAVE :: CONV_WM2( : )     ! conversion factor [photons/(cm**2 s )] to [Watts/m**2]

!***three-dimensional array for Cs and Qy
!***  (temperature, wavelength, species)
!***(layer, wavelength species)

      REAL, ALLOCATABLE, SAVE :: CSZ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: QYZ( :,:,: )

      IF ( FIRST ) THEN

         ALLOCATE( CONV_WM2( NWL ) )
         ALLOCATE( SRAYL   ( NWL ) )
         ALLOCATE( TAU_SCAT( NWL ) )
         ALLOCATE( CSZ( NLAYS,NWL,NPHOTAB ) )
         ALLOCATE( QYZ( NLAYS,NWL,NPHOTAB ) )
         
         ALLOCATE( GAS_EXTINCTION( NLAYS,NWL ) )
         ALLOCATE( EXTINCTION    ( NLAYS,NWL ) )
         ALLOCATE( ACTINIC_FLUX  ( NLAYS,NWL ) )
         ALLOCATE( IRRADIANCE    ( NLAYS,NWL ) )
         
         ALLOCATE( DSDH_TD ( NLAYS+1 ),
     &             DSDH    ( NLAYS ),
     &             DTAU    ( NLAYS+1 ),
     &             DT_AERO ( NLAYS+1 ),
     &             DT_CLOUD( NLAYS+1 ),
     &             OM      ( NLAYS+1 ),
     &             G       ( NLAYS+1 ),
     &             FDIR    ( NLAYS+1 ),
     &             FUP     ( NLAYS+1 ),
     &             FDN     ( NLAYS+1 ),
     &             EDIR    ( NLAYS+1 ),
     &             EUP     ( NLAYS+1 ),
     &             EDN     ( NLAYS+1 ),
     &             ESUM    ( NLAYS ),
     &             FSUM    ( NLAYS ) )

!***FSB Set up conversion factor for
!***  [photons / ( cm**2 s) ] to [Watts / m**2 ]
!***  THE 1.0E13 FACTO IS 1.0E9 * 1.0 E4
!***  The 1.0e9 is for the wavelength [ nm ] -> [ m ]
!***  The 1.0e4 is for the area [ cm **2 ] -> [ m**2 ]

         DO IWL = 1, NWL
            LAMDA = WAVELENGTH( IWL )
            CONV_WM2( IWL ) = 1.0E13 * ( PLANCK_C * LIGHT_SPEED ) / LAMDA
         END DO

!         COS85 = COS( 85.0 * PI180 )

!***get molecular scattering cross sections

         CALL GETSRAY ( NWL, WAVELENGTH, SRAYL )

         FIRST = .FALSE.

      END IF   ! FIRSTIME

!***initialize BLKRJ and other layer variables

      BLKRJ          = 0.0
      GAS_EXTINCTION = 0.0
      EXTINCTION     = 0.0
      ACTINIC_FLUX   = 0.0
      IRRADIANCE     = 0.0
      REFLECTION     = 0.0
      TRANSMISSION   = 0.0
      TRANS_DIRECT   = 0.0
      INSOLATION     = 0.0
      TROPO_O3_TOGGLE  = 1.0
      STRATO3_MINS_MET = .TRUE.
!***Initialize sums or set default values for outputs: 
!   TAUC_AERO, TAU_TOT, TAUO3_TOP, TAU_RAY, SSA_AERO, etc.

      TAUC_AERO = 0.0
      TAU_TOT   = 0.0
      TAU_CLOUD = 0.0
      TAU_SCAT  = 0.0
      SSA_AERO  = 0.0
      TOTAL_TAU_CLD = 0.0
#ifdef phot_debug      
      AVE_SSA_CLD   = 0.0
      AVE_ASYMM_CLD = 0.0
#endif
!***Test zenith angle. If coszen is zero or negative, zenith angle is
!***  equal to or greater than 90 degrees, i.e. before sunrise or
!***  after sunset at the surface.
!***  Return  all photolysis rates set to zero. Ignore possible twilight
!***  processes in upper troposphere.

!***FSB NOTE: tests of the algorithm for slant path show that the
!***  critical zenith angle for the tropospheric slant path is 88 degrees,
!***  but the critical zenith angle for the stratospheric slant path is
!***  85 degrees.  Thus, the code returns zeros for angles greater then or
!***  equalt to 85 degrees. cos( 85 degrees ) equals 8.715574e-02.

      IF ( COSZEN .LE. COS85 ) THEN
         TAUO3_TOP = 0.0
         TAU_RAY   = 0.0
         TROPO_O3_COLUMN = 0.0
         TROPO_O3_TOGGLE = 1.0
!        BLKDZ           = 0.0
         CALL SLANTPATH2 ( NLAYS, BLKZF, ZSFC, REARTH, SINZEN, BLKDZ, DSDH )
         RETURN
      END IF

      IF ( NEW_PROFILE ) THEN  ! update based on new temperature and density profile
!***Adjust cross sections and quantum yields for ambient conditions

         CALL GET_CSQY ( BLKTA, BLKDENS, CSZ, QYZ )

!***calculate scale height from top of model domain

         HSCALE = R_G * BLKTA( NLAYS )

!***estimate air density at top of model domain

         DENSTOM = BLKDENS( NLAYS )
     &           * EXP( -100.0 * ( BLKZF( NLAYS + 1 ) - BLKZH( NLAYS ) )
     &           / HSCALE )

!***calculate the total number of air molecules [ # / cm**2 ]
!***  above top of model domain.

         NBAR = HSCALE * DENSTOM

!***set top of modeling domain

         ZTOM = BLKZF( NLAYS + 1 )

!***get layer thicknesses and slantpath starting at the TOP

!        BLKDZ = 0.0
         CALL SLANTPATH2 ( NLAYS, BLKZF, ZSFC, REARTH, SINZEN, BLKDZ, DSDH )

!***get slantpath from ZTOM to ZTOA

         CALL SLANTPATHTOP ( ZTOM, ZTOA, ZSFC, REARTH, SINZEN, DSDH_TOP )

C*** find ozone column density for atmosphere, stratosphere, and troposphere
         STRAT_O3_COLUMN = DU_TO_CONC * REAL( TOTAL_O3_COLUMN )
!         STRAT_O3_COLMIN = 0.10 * STRAT_O3_COLUMN
         STRAT_O3_COLMIN = MIN_STRATO3_FRAC * STRAT_O3_COLUMN
         SUCCESS = .TRUE.
         TROPO_O3_COLUMN = 0.0
         DO L = NLAYS, 1, -1
            DELTA_O3_COLUMN = 100.0 * BLKO3( L ) * BLKDZ( L )
            STRAT_O3_COLUMN = STRAT_O3_COLUMN - DELTA_O3_COLUMN
            TROPO_O3_COLUMN = TROPO_O3_COLUMN + DELTA_O3_COLUMN
            IF ( STRAT_O3_COLUMN .LT. STRAT_O3_COLMIN  .AND. SUCCESS ) THEN
               IF( OBEY_STRATO3_MINS )THEN
                   WRITE( LOGDEV,'( /A, F5.2, A, 3(/A), I3, A,  F8.3, A , 2(I4,1X) )' )
     &             'PHOT WARNING: First Occurance where computed stratospheric O3 column < ',
     &              100.0*MIN_STRATO3_FRAC,'%',
     &             'observed total column. The percentage is a global minimum based on ',
     &             'climatological ozone profiles. ',
     &             'The Error accumulates downward from layer = ', L, ' or alt= ', 
     &              0.001*BLKZF( L ),' Km for col,row = ', PHOT_COL, PHOT_ROW
               END IF
               SUCCESS = .FALSE.
            END IF
         END DO

         STRAT_O3_COLUMN = CONC_TO_DU * STRAT_O3_COLUMN
         TROPO_O3_COLUMN = CONC_TO_DU * TROPO_O3_COLUMN

#ifdef verbose_PHOT_MOD
         IF( PHOT_COL .EQ. 1 .AND. PHOT_ROW .EQ. 1 )THEN
              WRITE( LOGDEV,*)'TOTAL_O3_COLUMN, TROPO_O3_COLUMN = ',TOTAL_O3_COLUMN, TROPO_O3_COLUMN
         END IF
#endif

         IF ( .NOT. SUCCESS ) THEN
            TROPO_O3_TOGGLE   = MAX_TROPOO3_FRAC * TOTAL_O3_COLUMN
     &                        / TROPO_O3_COLUMN
            N_TROPO_O3_TOGGLE = N_TROPO_O3_TOGGLE + 1 
            O3_TOGGLE_AVE     = O3_TOGGLE_AVE + TROPO_O3_TOGGLE
            O3_TOGGLE_MIN     = MIN( O3_TOGGLE_MIN, TROPO_O3_TOGGLE)
            STRATO3_MINS_MET  = .FALSE. 
            STRAT_O3_COLUMN = CONC_TO_DU * STRAT_O3_COLMIN
           IF( OBEY_STRATO3_MINS )THEN ! write to PE log for first occurance
               WRITE( LOGDEV, 99983)STRAT_O3_COLUMN
               IF( ADJUST_OZONE ) WRITE( LOGDEV, 99984)TROPO_O3_TOGGLE
               WRITE( LOGDEV, 99887)
               WRITE( LOGDEV, 99888)TOTAL_O3_COLUMN, TROPO_O3_COLUMN, MAX_TROPOO3_FRAC
               WRITE( LOGDEV, 99999)
               OBEY_STRATO3_MINS = .FALSE.
            END IF
            IF( .NOT. ADJUST_OZONE ) TROPO_O3_TOGGLE = 1.0 ! reset toggle to one 
         ELSE
            TROPO_O3_TOGGLE = 1.0
         END IF


99983    FORMAT( 'Corrective Action: 1) Stratospheric O3 column set to ',F8.3,' DU' ) 
99984    FORMAT( 'and 2) Extinction from Model Domain O3 multiplied by ',F9.6 )
99887    FORMAT(/'Check TROPO_O3_EXCEED and N_EXCEED_TROPO3 in PHOTDIAG1 file for '
     &          /'values greater than zero to assess the extent of the '
     &          /'problem. TROPO_O3_EXCEED and N_EXCEED_TROPO3 are the average '
     &          /'exceedance and their number over file time step for each grid cell,'
     &          /'respectively. Exceedance depends on the predicted tropospheric'
     &          /'fraction over the maximum allowed fraction of the total ozone column.'
     &          /'Its value equals the ratio minus one if ratio is greater than one and'
     &          /'zero if the ratio is less than or equal to one. N_EXCEED_TROPO3 '
     &          /'counts the number of nonzero values per timestep')
99888    FORMAT(/'Direct Cause: Predicted O3 tropospheric Column exceeds maximum allowed '
     &          /'fraction of total OMI column.',
     &          /'OMI Total O3 Column = ',F8.3,' DU: Model Tropospheric O3 Column = ',F8.3,' DU',
     &          /'Climatological Expected Tropospheric Fraction = ',F9.6)
99999    FORMAT(/'ULTIMATE causes include boundary condition and meteorological input files. '
     &          /'Check the former for unrealistic concentrations of ozone and its precursors.'
     &          /'Check the latter for unrealistic advection and diffusion parameters.')           
         
         DO IWL = 1, NWL
!***Get optical depth for stratospheric ozone column
!***Note that stratosphere ozone coluumn assumed to exist above model domain
            CALL GET_TAUO3 ( IWL, STRAT_O3_COLUMN, STRAT_TEMP, TAUO3_TOP( IWL ) )
!***get Rayleigh optical depth for stratosphere
            TAU_RAY( IWL ) = NBAR * SRAYL( IWL )         
         END DO
      END IF ! for NEW_PROFILE

!***loop over wavelengths
      DO IWL = 1, NWL           ! outermost loop

!        RSFC       = ALB( IWL )        ! surface albedo

!***set scaling factor for reducing extraterrestrial flux
!***  add ozone and Rayleigh optical depths. Use the
!***  pseudospherical correction for the stratosphere.

         SOLAR_FLUX = FEXT( IWL ) / RSQD

!*** initialize tau, delta tau's, other variables and loop over layers

         DTAU         = 0.0
         DT_AERO      = 0.0
         DT_CLOUD     = 0.0
         DTSCAT_CLOUD = 0.0
         TAU_SCAT_CLD = 0.0
         
         DO L = 2, NLAYS + 1
            II = NLAYS + 2 - L  ! from top to bottom

!***in the following statements the factor of 100.0 converts
!***  converts [ 1 / cm ] to [ 1 / m ]

            BETA_M = SRAYL( IWL )         * BLKDENS( II ) * 100.0
            AO3    = CSZ( II,IWL,LO3O3P ) * BLKO3  ( II ) * 100.0
            AO3    = TROPO_O3_TOGGLE      * AO3
            ANO2   = CSZ( II,IWL,LNO2   ) * BLKNO2 ( II ) * 100.0

!***set up aerosol optical properties

            G_BAR = AERO_ASYM_FAC ( II,IWL )
            BEXT  = AERO_EXTI_COEF( II,IWL )
            BSCAT = AERO_SCAT_COEF( II,IWL )

!***calculate total absorption and scattering contributions
!***to optical depth

!***The contributions to scattering and absorption from molecules and particles
!***  are calculated separately to facilitate the calculation
!***  of the total single scatering albedo of the column of aerosols
!***  as measured by satellites.

            DTSCAT_M = BETA_M * BLKDZ( II ) ! molecular scattering
            DTSCAT_A = BSCAT  * BLKDZ( II ) ! particle scattering

            DTSCAT_M = MAX( DTSCAT_M, SMALL )
            DTSCAT_A = MAX( DTSCAT_A, SMALL )


            DTABS_M  = ( AO3 + ANO2  )  * BLKDZ( II ) ! molecular absorption
            DTABS_A  = ( BEXT - BSCAT ) * BLKDZ( II ) ! particle absorption

            DTABS_M  = MAX( DTABS_M, SMALL )
            DTABS_A  = MAX( DTABS_A, SMALL )

            GAS_EXTINCTION( II,IWL ) = BETA_M + AO3 + ANO2        ! gas extinction
            EXTINCTION( II,IWL )     = BETA_M + BEXT + AO3 + ANO2 ! gas and aerosol extinction
            
            IF ( CLOUDS( II ) ) THEN 
     
               DT_CLOUD( L ) = ( CLOUD_LIQUID_EXT( II,IWL ) 
     &                       +   CLOUD_ICE_EXT( II,IWL )
     &                       +   CLOUD_AGGREG_EXT( II,IWL ) ) * BLKDZ( II )
               DTSCAT_CLOUD  = ( CLOUD_LIQUID_SCAT( II,IWL )
     &                       +   CLOUD_ICE_SCAT( II,IWL )
     &                       +   CLOUD_AGGREG_SCAT( II,IWL ) ) * BLKDZ( II )

!Adjust DT_CLOUD for cloud fraction by 1/2 power of CLDFRC to approximate cloud overlap.
!Note that the power results because the resolved cloud conentrations are averaged over
!the grid cell so the net overlap correction equal cfrac**(3/2) from Briegleb (1992) times
!cfrac**(-1) for actual in-cloud concentrations (see Voulgarakis et al., 2009, Geosci Model
!Dev., vol. 2, pp. 59-72.

               IF ( CLOUD_LAYERING( II ) ) THEN
                  LAYERING_FACTOR = SQRT( CLDFRC( II ) )
               ELSE
                  LAYERING_FACTOR = CLDFRC( II )
               END IF
               DT_CLOUD( L ) = DT_CLOUD( L ) * LAYERING_FACTOR
               DTSCAT_CLOUD  = DTSCAT_CLOUD  * LAYERING_FACTOR
 
               EXTINCTION( II,IWL ) = EXTINCTION( II,IWL )
     &                              + ( CLOUD_LIQUID_EXT( II,IWL ) 
     &                              +   CLOUD_ICE_EXT( II,IWL )
     &                              +   CLOUD_AGGREG_EXT( II,IWL ) ) * LAYERING_FACTOR
    
               TAU_SCAT_CLD = TAU_SCAT_CLD + DTSCAT_CLOUD

               IF ( DT_CLOUD( L ) .GT. 1.0E-6 ) THEN
                  OM_CLOUD = MAX( 0.000001, MIN( DTSCAT_CLOUD /DT_CLOUD( L ), 0.99999) )
                  IF ( OM_CLOUD .LT. 0.0 .OR. OM_CLOUD .GT. 1.0 .OR. OM_CLOUD .NE. OM_CLOUD) THEN
                     WRITE( LOGDEV,'(A,I3,A,ES12.4,A)',ADVANCE = 'NO')
     &               'OM_CLOUD( L = ', L, ' ) = ', OM_CLOUD,' resetting to '
                     OM_CLOUD = MAX( 0.000001, MIN( OM_CLOUD, 0.99999))
                     WRITE( LOGDEV,'(ES12.4)')OM_CLOUD
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))')'DT_CLOUD, DTSCAT_CLOUD = ',
     &               DT_CLOUD, DTSCAT_CLOUD
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))')'LIQUID_EXT, LIQUID_SCAT = ',
     &               CLOUD_LIQUID_EXT( II,IWL ), CLOUD_LIQUID_SCAT( II,IWL )
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))')'ICE_EXT, ICE_SCAT = ',
     &               CLOUD_ICE_EXT( II,IWL ), CLOUD_ICE_SCAT( II,IWL )
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))')'AGGREG_EXT, AGGREG_SCAT = ',
     &               CLOUD_AGGREG_EXT( II,IWL ), CLOUD_AGGREG_SCAT( II,IWL )
                     CALL M3EXIT( 'NEW_OPTICS', JDATE, JTIME, ' ', XSTAT1 )
                  END IF
               ELSE 
                  OM_CLOUD = 1.0
               END IF


               IF ( DTSCAT_CLOUD .GT. 1.0E-6 ) THEN
               
                  G_CLOUD = ( (CLOUD_LIQUID_ASY( II,IWL ) * CLOUD_LIQUID_SCAT( II,IWL ))
     &                    +   (CLOUD_ICE_ASY( II,IWL )    * CLOUD_ICE_SCAT( II,IWL ))
     &                    +   (CLOUD_AGGREG_ASY( II,IWL ) * CLOUD_AGGREG_SCAT( II,IWL )) )
     &                    *   BLKDZ( II ) * LAYERING_FACTOR


#ifdef phot_debug
                  IF ( .NOT. ONLY_SOLVE_RAD ) THEN
                     AVE_ASYMM_CLD( IWL ) = AVE_ASYMM_CLD( IWL ) + G_CLOUD
                     IF ( AVE_ASYMM_CLD( IWL ) .GT. TAU_SCAT_CLD ) THEN
                        WRITE( LOGDEV,'(A,I3,2(A,ES12.4))' )
     &                  'Sum for AVE_ASYMM_CLD at L (', L,') = ', AVE_ASYMM_CLD( IWL ),
     &                  ' Sum for TAU_SCAT_CLD = ',TAU_SCAT_CLD 
                        WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &                  'AVE_ASYMM_CLD Increment = ', G_CLOUD
                        WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &                  'TAU_SCAT_CLD Increment = ', DTSCAT_CLOUD
                     END IF
                  END IF
#endif                   

                  G_CLOUD  = G_CLOUD / DTSCAT_CLOUD

                  IF ( G_CLOUD .GE. 1.0 .OR. G_CLOUD .LE. -1.0 .OR. G_CLOUD .NE. G_CLOUD ) THEN
                     WRITE( LOGDEV,'(A,I3,A,ES12.4,A)',ADVANCE = 'NO' )
     &                  'G_CLOUD( L = ', L, ' ) = ', G_CLOUD,' resetting to '
                        G_CLOUD = MIN( 0.9999, MAX( G_CLOUD, -0.9999) )
                     WRITE( LOGDEV,'(ES12.4)') G_CLOUD
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &                  'LIQUID_ASY, LIQUID_SCAT = ',
     &                  CLOUD_LIQUID_ASY( II,IWL ), CLOUD_LIQUID_SCAT( II,IWL )
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &                  'ICE_ASY, ICE_SCAT = ',
     &                  CLOUD_ICE_ASY( II,IWL ), CLOUD_ICE_SCAT( II,IWL )
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &                  'AGGREG_ASY, AGGREG_SCAT = ',
     &                  CLOUD_AGGREG_ASY( II,IWL ), CLOUD_AGGREG_SCAT( II,IWL )
                     CALL M3EXIT( 'NEW_OPTICS', JDATE, JTIME, ' ', XSTAT1 )
                  END IF
               ELSE
                  G_CLOUD = 0.0
               END IF            
            ELSE
               DTSCAT_CLOUD = 0.0
               G_CLOUD      = 0.0
               OM_CLOUD     = 1.0
            END IF

!***calculate total absorption and scattering contributions
!***to optical depth

            DTSCAT = DTSCAT_M + DTSCAT_A + DTSCAT_CLOUD
            DTABS  = DTABS_M  + DTABS_A + MAX(( 1.0 - OM_CLOUD ), 0.0) * DT_CLOUD( L )

!***set aerosol optical depth for later use

            DT_AERO ( L ) = BEXT * BLKDZ( II )

!***Now calculate the vertical profiles of optical depth,
!***  single scattering albedo, asymmetry factor
!***  and DSDH starting at the top.

            DTAU( L ) = DTSCAT + DTABS
            OM  ( L ) = DTSCAT / ( DTSCAT + DTABS )
            G   ( L ) = ( G_BAR * DTSCAT_A + G_CLOUD * DTSCAT_CLOUD ) / DTSCAT

            IF ( G( L ) .GE. 1.0 .OR. G( L ) .LE. -1.0 .OR. G( L ) .NE. G( L ) ) THEN
               WRITE( LOGDEV,'(A,ES12.4,A)',ADVANCE = 'NO' )
     &         'G( L ) = ', G( L ),' resetting to '
               G( L ) = MIN( 0.9999, MAX( G( L ), -0.9999) )
               WRITE( LOGDEV,'(ES12.4)')G( L )
               WRITE( LOGDEV,'(A,10(1X,ES12.4))' )
     &         'DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD, G_BAR, G_CLOUD = ',
     &          DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD, G_BAR, G_CLOUD
            END IF

            IF ( OM( L ) .GT. 1.0 .OR. OM( L ) .LE. 0.0 .OR. OM( L ) .NE. OM( L ) ) THEN
               WRITE( LOGDEV,'(A,ES12.4,A)',ADVANCE = 'NO' )
     &         'OM( L ) = ', OM( L ),' resetting to '
               OM( L ) = MIN( 0.9999, MAX( OM( L ), 0.0001) )
#ifdef phot_debug
               WRITE( LOGDEV,'(ES12.4)' ) OM( L )
               WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &         'DTSCAT, DTABS, ( DTSCAT + DTABS) = ',
     &         DTSCAT, DTABS, ( DTSCAT + DTABS )
               WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &         'DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD = ',
     &         DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD
               WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &         'DDTABS_M, DTABS_A, MAX(( 1.0-OM_CLOUD ), 0.0) * DT_CLOUD( L ) = ',
     &         DTABS_M, DTABS_A, MAX(( 1.0 - OM_CLOUD ), 0.0) * DT_CLOUD( L )
               WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &         ' AO3, ANO2,AERO_BEXT, AERO_BSCAT = ',
     &         AO3, ANO2,BEXT, BSCAT
#endif
            ELSE
#ifdef phot_debug
               IF ( OM( L ) .EQ. 1.0 ) THEN
                  WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &            'DTSCAT, DTABS, ( DTSCAT + DTABS ) = ',
     &             DTSCAT, DTABS, (DTSCAT + DTABS)
                  WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &            'DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD = ',
     &             DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD
                  WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &            'DDTABS_M, DTABS_A, MAX(( 1.0-OM_CLOUD ), 0.0) * DT_CLOUD( L ) = ',
     &            DTABS_M, DTABS_A, MAX(( 1.0 - OM_CLOUD ), 0.0 ) * DT_CLOUD( L)
                  WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &            'AO3, ANO2,AERO_BEXT, AERO_BSCAT = ',
     &            AO3, ANO2,BEXT, BSCAT
               END IF
#endif
               OM( L ) = MIN( 0.9999,  OM( L ) )
            END IF

            DSDH_TD( L ) = DSDH( L - 1 )

            IF ( ONLY_SOLVE_RAD ) CYCLE
!***FSB get sums of unscaled optical depths

            TAU_SCAT( IWL ) = TAU_SCAT ( IWL ) + DTSCAT_A

!***initialize optical depth profiles to the layer increment
     
            TAUC_AERO( II,IWL ) = DT_AERO( L )  ! aerosol optical depth
            TAU_TOT  ( II,IWL ) = DTAU( L )     ! total optical depth
            TAU_CLOUD( II,IWL ) = DT_CLOUD( L ) ! cloud optical depth

         END DO                 ! loop over layers

!***set values for the stratosphere

         OM     ( 1 ) = TAU_RAY( IWL ) / ( TAU_RAY( IWL ) + TAUO3_TOP( IWL ) )
         G      ( 1 ) = 0.05
         DTAU   ( 1 ) = TAUO3_TOP( IWL ) + TAU_RAY( IWL )
         DSDH_TD( 1 ) = DSDH_TOP

         NLEVEL = NLAYS + 1

         IF ( .NOT. ONLY_SOLVE_RAD ) THEN
!***calculate optical depth profiles
            TAU_TOT  ( NLAYS,IWL ) = TAU_TOT  ( NLAYS,IWL ) + DTAU( 1 )
            TAUC_AERO( NLAYS,IWL ) = TAUC_AERO( NLAYS,IWL ) + DT_AERO( 1 )  
            TAU_CLOUD( NLAYS,IWL ) = TAU_CLOUD( NLAYS,IWL ) + DT_CLOUD( 1 ) 

            DO L =  NLAYS-1, 1, -1
               TAU_TOT  ( L,IWL ) = TAU_TOT  ( L,IWL ) + TAU_TOT  ( L+1,IWL )
               TAUC_AERO( L,IWL ) = TAUC_AERO( L,IWL ) + TAUC_AERO( L+1,IWL ) 
               TAU_CLOUD( L,IWL ) = TAU_CLOUD( L,IWL ) + TAU_CLOUD( L+1,IWL )
            END DO
         END IF
         
!***Set fluxes to zero

         FDIR = 0.0
         FUP  = 0.0
         FDN  = 0.0
         EDIR = 0.0
         EUP  = 0.0
         EDN  = 0.0

!***calculate fluxes and irradiances
         CALL TWOSTREAM_S ( NLEVEL, COSZEN, ALB( IWL ), DTAU, OM, G, DSDH_TD,
     &                      FDIR, FUP, FDN, EDIR, EUP, EDN )

         DO L = 1, NLAYS
            II = NLAYS + 2 - L
            FSUM( L ) = FDIR( II ) + FDN( II ) + FUP( II ) ! actinic flux
            ESUM( L ) = EDIR( II ) + EDN( II )             ! downward irradiance
         END DO                 ! loop over layers

! add diffusion and direct components for calculating reflectivity and transmissivity
         INSOLATION    = INSOLATION    + SOLAR_FLUX 
         REFLECTION    = REFLECTION    + SOLAR_FLUX * EUP( 1 )
         TRANSMISSION  = TRANSMISSION  + SOLAR_FLUX * EDN( NLEVEL )
         TRANS_DIRECT  = TRANS_DIRECT  + SOLAR_FLUX * EDIR( NLEVEL ) 

         IF ( ONLY_SOLVE_RAD ) CYCLE

!***FSB Calculate column averaged scattering albedo and asymmetry factor

         IF ( TAUC_AERO( 1,IWL ) .GT. 1.0E-30 ) THEN
            SSA_AERO( IWL ) = TAU_SCAT( IWL ) / TAUC_AERO( 1,IWL )
         END IF

         TOTAL_TAU_CLD( IWL ) = TAU_CLOUD( 1,IWL )

#ifdef phot_debug
         IF ( TAU_CLOUD( 1,IWL ) .GT. 1.0E-20 ) THEN
            IF ( AVE_ASYMM_CLD( IWL ) .GT. TAU_SCAT_CLD ) THEN
               WRITE( LOGDEV,'(A,I3,2(A,ES12.4))' )
     &         'Sum for AVE_ASYMM_CLD at L(', 1,') = ', AVE_ASYMM_CLD( IWL ),
     &         'Sum for TAU_SCAT_CLD = ',TAU_SCAT_CLD 
               WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &         'AVE_ASYMM_CLD Increment = ', G_CLOUD
               WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &         'TAU_SCAT_CLD Increment = ',
     &         DTSCAT_CLOUD
            END IF
            IF ( TAU_SCAT_CLD .GT. 1.0E-20 ) THEN
               AVE_ASYMM_CLD( IWL ) = AVE_ASYMM_CLD( IWL ) / TAU_SCAT_CLD
               AVE_SSA_CLD  ( IWL ) = TAU_SCAT_CLD / TAU_CLOUD( 1,IWL )
            ELSE
               AVE_ASYMM_CLD( IWL ) = 0.0
               AVE_SSA_CLD  ( IWL ) = 0.0
            END IF
            IF ( ABS( AVE_ASYMM_CLD( IWL ) ) .GE.  1.0 ) THEN
               WRITE( LOGDEV,'(A,I3,2(A,ES12.4))' )
     &         'Sum for AVE_ASYMM_CLD at L(', 1,') = ', AVE_ASYMM_CLD( IWL )*TAU_SCAT_CLD,
     &         'Sum for TAU_SCAT_CLD = ',TAU_SCAT_CLD 
               WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &         'AVE_ASYMM_CLD Increment = ', G_CLOUD
               WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &         'TAU_SCAT_CLD Increment = ', DTSCAT_CLOUD
            END IF
         ELSE
            TOTAL_TAU_CLD( IWL ) = 0.0
            AVE_SSA_CLD  ( IWL ) = 0.0
            AVE_ASYMM_CLD( IWL ) = 0.0
         END IF
#endif
         
!***FSB capture the total downward irradiance at the surface [ W / m**2]
!
!        ETOT_SFC( IWL ) = CONV_WM2( IWL ) * FLXSCALE * FEXT( IWL )
!     &                  * ESUM( 1 )

         FORALL( L = 1:NLAYS )
!***multiply by the solar flux at the domain top for 
!***actinic flux and irradiance; keeping actinic flux in photons/(cm^2*s)
            ACTINIC_FLUX( L,IWL ) = SOLAR_FLUX * FSUM( L )
            IRRADIANCE  ( L,IWL ) = SOLAR_FLUX * CONV_WM2( IWL ) * ESUM( L )
         END FORALL
      END DO    ! loop over wavelengths

! normalize reflection and transmission coefficients 
      INSOLATION   = 1.0 / ( COSZEN * INSOLATION )
      TRANS_DIRECT = TRANS_DIRECT * INSOLATION
      REFLECTION   = ONE_OVER_PI * REFLECTION * INSOLATION 
      TRANSMISSION = ONE_OVER_PI * TRANSMISSION * INSOLATION

      IF ( ONLY_SOLVE_RAD ) RETURN 
               
! compute photolysis rates
      DO IPHOT = 1, NPHOTAB
         DO IWL = 1, NWL
            DO L = 1, NLAYS 
               BLKRJ( L,IPHOT ) = BLKRJ( L,IPHOT ) 
     &                          + ACTINIC_FLUX( L,IWL ) 
     &                          * CSZ( L,IWL,IPHOT ) * QYZ( L,IWL,IPHOT ) ! [ 1 / sec ]
            END DO
         END DO
      END DO  ! loop on layers, wavelength,  IPHOT
! convert actinic flux to watts/m^2    
      FORALL( L = 1:NLAYS, IWL=1:NWL  )
         ACTINIC_FLUX( L,IWL ) = ACTINIC_FLUX( L,IWL ) * CONV_WM2( IWL )
      END FORALL

!***compute rate of photolysis (j-values) for each reaction        

9503  FORMAT('LAYER = ',I3,' MODE = ',I3,' LAMBDA(nm)  = ',ES12.4,' DGN_CORE(m) = ',ES12.4,
     &       ' DGN_SHELL(m) = ', ES12.4 / ' REFRACT_IDX_SHELL(NR,NI) = ', 2(ES12.4,1X),
     &       ' REFRACT_IDX_CORE(NR,NI) = ', 2(ES12.4,1X) / ' LN(GEO.STD.DEV.) = ',
     &       ES12.4)
9504  FORMAT('LAYER = ',I3,' MODE = ',I3,' LAMBDA(nm)  = ',ES12.4,' DGN(m) = ',ES12.4,
     &       ' REFRACT_IDX(NR,NI) = ', 2(ES12.4,1X) / ' VOL.DENS. = ', ES12.4,
     &       ' LN(GEO.STD.DEV.) = ', ES12.4)

99985 FORMAT('ERROR: Modeled Troposheric Ozone Column downward from layer ',I3,1X)
99986 FORMAT('exceeds Top Ozone Column based on OMI.data file. Negative Optical Depths ')
99987 FORMAT('but are physically unlikey.')
99988 FORMAT(' SETTING O3 Column ABOVE PTOP TO 25% of OMI.dat value  ')
99989 FORMAT(' FOR ROW/COL = ',2(1X,I4))

      RETURN
      END SUBROUTINE NEW_OPTICS

C///////////////////////////////////////////////////////////////////////

      SUBROUTINE GETSRAY ( NWL, LAMDA, SRAYL )
C-----------------------------------------------------------------------
C  calculate molecular (Rayleigh) scattering cross section, srayl
C
C  coded 09/08/2004 by Dr. Francis S. Binkowski
C     Carolina Environmental Program
C     University of North Carolina at Chapel Hill
C     email: frank_binkowski@unc.edu
C
C  Reference:
C     Nicolet, M., On the molecular scattering in the terrestrial
C     atmosphere: An empirical formula for its calculation in the
C     homoshpere, Planetary and Space Science. Vol. 32,No. 11,
C     Pages 1467-1468, November 1984.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      INTEGER, INTENT( IN )  :: NWL           ! number of wavelength bins
      REAL,    INTENT( IN )  :: LAMDA( : )  ! wavelengths  [nm]
      REAL,    INTENT( OUT ) :: SRAYL( : )  ! molecular scattering cross sections [cm**2]

!***Internal variables

      INTEGER I
      REAL    WMICRN               ! wavelenght in micrometers
      REAL    WMICRN1              ! 1 / wmicrn
      REAL    XX                   ! variable in Nicolet method

!***get molecular scattering cross section. This is a fixed
!***  function of wavelength.

      DO I = 1, NWL
         WMICRN = 1.0E-3 * LAMDA( I ) ! wavelength in micrometers
         WMICRN1 = 1.0 / WMICRN

         IF ( WMICRN .LE. 0.55 ) THEN
            XX = 3.6772 + 0.389 * WMICRN + 0.09426 * WMICRN1
         ELSE
            XX = 4.04
         END IF

         SRAYL( I ) = 4.02E-28 * WMICRN1**XX    ! in [cm**2]

      END DO

      RETURN
      END SUBROUTINE GETSRAY


      SUBROUTINE GET_TAUO3 ( IWL, STOZONE, STRAT_TEMP, TAU_O3 )
C-----------------------------------------------------------------------
C  subroutine to calculate the optical depth of ozone in the
C     stratosphere
C
C  special cross sections for calculating stratospheric ozone
C     optical depth
C
C  the following temperatures and cross sections are from
C     Fast-J
C     REFERENCE:
C     Wild, O., X. Zhu, and M.J. Prather, Fast-J: Accurate simulation
C     of in- and below-clolud photolysis in tropospheric chemical
C     models,
C     Journal of Atmospheric Chemistry, Vol. 37, pp 245-282, 2000
C
C  coded 10/20/2004 by Dr. Francis S. Binkowski
C     Carolina Environmental Program
C     University of North Carolina at Chapel Hill
C     email: frank_binkowski@unc.edu
C     Updated to Fast-JX version 5.0
C  Mar 2011 Bill Hutzell
C     revised interpolation method for a general number of
C     interpolation points
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      INTEGER, INTENT( IN )  :: IWL         ! wavelenth index

      REAL,    INTENT( IN )  :: STOZONE     ! ozone column amount [ DU ]
      REAL,    INTENT( IN )  :: STRAT_TEMP  ! average temperature for stratosphere [ K ]
      REAL,    INTENT( OUT ) :: TAU_O3      ! optical depth for statosphere

!***Local

      INTEGER IXT, IXTEMP

      REAL OZONE_CS        ! interpolated ozone absorption cross section
      REAL YTT             ! interpolation variable

!***Find temperature range:

      IF ( STRAT_TEMP .LE. TEMP_O3_STRAT( 1 ) ) IXTEMP = 0

      DO IXT = 1, NTEMP_STRAT - 1
         IF ( STRAT_TEMP .GT. TEMP_O3_STRAT( IXT ) .AND.
     &        STRAT_TEMP .LT. TEMP_O3_STRAT( IXT + 1 ) ) THEN
            IXTEMP = IXT
            YTT = ( STRAT_TEMP - TEMP_O3_STRAT( IXT ) )
     &          / ( TEMP_O3_STRAT( IXT + 1 ) - TEMP_O3_STRAT( IXT ) )
         END IF
      END DO

      IF ( STRAT_TEMP .GE. TEMP_O3_STRAT( NTEMP_STRAT ) ) THEN
         IXTEMP = NTEMP_STRAT
         YTT = 0.0
      END IF

!***do linear interpolation

      IF ( IXTEMP .EQ. 0 ) THEN
         OZONE_CS = XO3CS( 1, IWL )
      ELSE IF ( IXTEMP .GE. 1 .AND. IXTEMP .LT. NTEMP_STRAT ) THEN
         OZONE_CS = XO3CS( IXTEMP, IWL ) +
     &            ( XO3CS( IXTEMP+1, IWL ) - XO3CS( IXTEMP, IWL ) ) * YTT
      ELSE IF ( IXTEMP .EQ. NTEMP_STRAT ) THEN
         OZONE_CS = XO3CS( IXTEMP, IWL )
      END IF

      TAU_O3 = DU_TO_CONC * STOZONE * OZONE_CS

      RETURN
      END SUBROUTINE GET_TAUO3

C///////////////////////////////////////////////////////////////////////

      SUBROUTINE O3AMT ( XLAT, XLONG, MDAY, OZONE )
C-----------------------------------------------------------------------
C  This subroutine implements an algorithm for the annual behavior
C     of total ozone ( taken here to be stratospheric) from
C     climatology
C  Reference:
C     Van Heuklon, Thomas K., Estimating atmospheric ozone for solar
C     radiation models, Solar Energy, Vol. 22, pp 63-68, 1979.
C  updated from an earlier version by
C     Dr. Francis S. Binkowski, The Carolina Environmental Program,
C     The University of North Carolina at Chapel Hill.
C     Email: frank_binkowski@unc.edu
C     November 03. 2004.
C  Only Northern Hemisphere is implemented.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      INTEGER, INTENT( IN )  :: MDAY  ! Day number during the year
                                      ! Jan 1st = 1.0, Feb 1st = 32, etc.

      REAL,    INTENT( IN )  :: XLAT  ! latitude of point on earth's surface
      REAL,    INTENT( IN )  :: XLONG ! longitude of point on earth's surface
      REAL,    INTENT( OUT ) :: OZONE ! Total column amount of ozone [ DU ]

!***Internal:

!***The following parameters are from Table 1 of Van Heuklon (1979).

      REAL, SAVE ::  A, B, C, D, F, G, H, FJ
      DATA A/150.0/, B/1.28/, C/40.0/, D/0.9865/, F/-30.0/, G/20.0/,
     &     H/3.0/, FJ/235.0/

!***FSB FJ is the equatorial annual average of atmospheric ozone
!***  content, as noted on page 65 of Nav Heulklon (1979). This value
!***  sets the basic background for ozone.

      REAL, PARAMETER :: RD = 0.017453   ! degrees to radians

!***Variables of convenience

      REAL E, FI, BPHI, DEF, HLI, SINB, SINB2

!***set the day

      E = FLOAT( MDAY )
      FI = 20.0
      IF ( XLONG .LT. 0.0 ) FI = 0.0
      BPHI  = B * XLAT * RD
      DEF   = D * ( E + F ) * RD
      HLI   = H * ( XLONG + FI ) * RD
      SINB  = SIN( BPHI )
      SINB2 = SINB * SINB

!***the following equation implements equation (4) of VanHeuklon (1979)

      OZONE  = FJ + ( A + C * SIN( DEF ) + G * SIN( HLI ) ) * SINB2

      RETURN
      END SUBROUTINE O3AMT

C///////////////////////////////////////////////////////////////////////

      SUBROUTINE SLANTPATH2 ( NLAYS, Z, ZSFC, REARTH, SINZEN, DZ, DSDH )
C-----------------------------------------------------------------------
C  PURPOSE:
C     Calculate slant path, ds/dh, over vertical depth in spherical
C     geometry also calculates the layer thicknesses.
C     NOTE!!!
C     This version is restricted to zenith angle less than 90 degrees
C-----------------------------------------------------------------------
C  ARGUMENTS:
C     INPUT:
C       NLAYS   - INTEGER, number of specified altitude levels
C       z       - REAL, altitude (agl) [m] <<<    meters
C       This is from file ZF ( full layers ) from METCRO3D
C       Z(1) is zero.
C       zsfc    - REAL, ground elevation (msl) [m]
C       rearth  - REAL, radius of the earth [m]
C       sinzen  - REAL, sine of solar zenith angle
C
C     OUTPUT:
C       dz      - REAL, layer thicknesses [ m ]
C       dsdh    - REAL, slant path of direct beam through each layer
C       when travelling from the top of the atmosphere downward
C-----------------------------------------------------------------------
C  EDIT HISTORY:
C     Inspired by sphers from TUV
C     09/08/2004 modified to specialize for CMAQ application
C     by Dr. Francis S. Binkowski
C     Environmental Modeling for Policy Development group,
C     The Carolina Environmental Program
C     The University of North Carolina-Chapel Hill
C     Email: frank_binkowski@unc.edu
C
C-----------------------------------------------------------------------
C  REFERENCE:
C     Dahlback, A. and K. Stamnes, A new spherical model for computing
C     the radiation field available for photolysis and heating at
C     twilight, Planetary and Space Sciences, Vol. 39, No. 5,
C     pp 671-683, 1991.
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      INTEGER, INTENT( IN )  :: NLAYS

      REAL,    INTENT( IN )  :: Z   ( : )
      REAL,    INTENT( IN )  :: ZSFC
      REAL,    INTENT( IN )  :: REARTH
      REAL,    INTENT( IN )  :: SINZEN
      REAL,    INTENT( OUT ) :: DZ  ( : )  ! layer thicknesses counting from surface upward
      REAL,    INTENT( OUT ) :: DSDH( : )

!***Internal

      INTEGER I, J, K           ! loop indices
      REAL RE
      REAL DSJ                  ! slant path length [m]
      REAL DHJ                  ! layer thickness [m]
      REAL( 8 ) :: RJ, RJP1
      REAL( 8 ) :: RPSINZ            ! rpsinz = (re + zd(i)) * sinzen
      REAL( 8 ) :: RPSINZ2           ! rpsinz * rpsinz
      REAL( 8 ) :: GA, GB            ! see usage
      REAL      :: ZE( NLAYS + 1 )   ! altitudes MSL
      REAL      :: ZD( NLAYS + 1 )   ! array of altitudes indexed from top
      REAL      :: DZI( NLAYS )      ! layer thicknesses counting downward from the top

C-----------------------------------------------------------------------

!***re include the altitude above sea level to the radius of the earth

      RE = REARTH + ZSFC

!***ze is the altitude above msl

      DO K = 1, NLAYS + 1
         ZE( K ) = Z( K )
!!sjr    ZE(K) = Z(K) - ZSFC
      END DO

!***  DZ(1) = ZE(2) - ZE(1)
!***  DZI(1) = ZE(NLAYS + 1) - ZE(NLAYS)

!***calculate dz

      DO K = 1, NLAYS
         DZ( K ) = ZE( K + 1 ) - ZE( K )
      END DO

!***zd, dzi are inverse coordinates of ze & dz

      DO K = 1, NLAYS + 1
         J = NLAYS + 1 - K + 1
         ZD( J ) = ZE( K )
      END DO

      DO K = 1, NLAYS
         J = NLAYS + 1 - K
         DZI( J ) = DZ( K )
      END DO

!***initialize dsdh

      DO I = 1, NLAYS
         DSDH( I ) = 0.0
      END DO

!***FSB The following code is a direct implementation of appendix B
!***  of Dahlbeck and Stamnes (1991) for the case of solar zenith
!***  angle less than 90 degree.

!***calculate ds/dh of every layer starting at the top

      DO J = 1, NLAYS
!***  K = NLAYS - J +1
         RPSINZ  = REAL( ( RE + ZD( J ) ) * SINZEN , 8 )
         RPSINZ2 = RPSINZ * RPSINZ

         IF ( J .LT. NLAYS ) THEN
            RJ   = REAL( RE + ZD( J ), 8 )
            RJP1 = REAL( RE + ZD( J + 1 ), 8 )
            DHJ  = DZI( J )
         ELSE
            RJ   = REAL( RE + ZD( J ), 8)
            RJP1 = REAL( RE, 8 )
            DHJ  = DZI( J )
         END IF

!***define GA and GB

         GB = SQRT( MAX( 0.0D0, RJ * RJ     - RPSINZ2 ) )
         GA = SQRT( MAX( 0.0D0, RJP1 * RJP1 - RPSINZ2 ) )

!***This is equation B1 from Dahlbeck and Stamnes (1991)

         DSJ = ABS( REAL(GB - GA, 4 ) )

!***this is the slant path (Chapman) function.

         DSDH( J ) = DSJ / DHJ    ! Note dsdh is on a top to bottom grid.

      END DO   ! loop over altitude

      RETURN
      END SUBROUTINE SLANTPATH2

C///////////////////////////////////////////////////////////////////////

      SUBROUTINE SLANTPATHTOP ( ZTOM, ZTOA, ZSFC, REARTH, SINZEN,
     &                          DSDHTOP )
C-----------------------------------------------------------------------
C  FSB This is a SPECIAL version to get the slant path from the top of
C    the modeling domain (ztom) to the top of the atmosphere (ztoa).
C-----------------------------------------------------------------------
C  PURPOSE:
C     Calculate slant path, ds/dh, over vertical depth in spherical
C     geometry also calculates the layer thicknesses.
C     NOTE!!!
C     This version is restricted to zenith angle less than 90 degrees
C-----------------------------------------------------------------------
C  ARGUMENTS:
C     INPUT:
C       ztom    - REAL, altitude (agl) of top of modeling domain [m] <<<meters
C       This is from file ZF ( full layers ) from METCRO3D
C       Z(1) is zero.
C       ztoa    - REAL altitude (msl) of top of atmosphere [ m ]
C       zsfc    - REAL, ground elevation (msl) [m]
C       rearth  - REAL, radius of the earth [m]
C       sinzen  - REAL, sine of solar zenith angle
C
C     OUTPUT:
C       dsdhtop   - REAL, slant path of direct beam through each layer
C       when travelling from the top of the atmosphere downward
C       to the top of top model
C-----------------------------------------------------------------------
C  EDIT HISTORY:
C     Inspired by sphers from TUV
C     09/08/2004 modified  to specialize for CMAQ application
C     11/11/2004 modified to do just the one layer from ztom to ztoa.
C     by Dr. Francis S. Binkowski
C     Environmental Modeling for Policy Development group,
C     The Carolina Environmental Program
C     The University of North Carolina-Chapel Hill
C     Email: frank_binkowski@unc.edu
C
C-----------------------------------------------------------------------
C  REFERENCE:
C     Dahlback, A. and K. Stamnes, A new spherical model for computing
C     the radiation field available for photolysis and heating at
C     twilight, Planetary and Space Sciences, Vol. 39, No. 5,
C     pp 671-683, 1991.
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      REAL, INTENT(IN)  :: ZTOM
      REAL, INTENT(IN)  :: ZTOA
      REAL, INTENT(IN)  :: ZSFC
      REAL, INTENT(IN)  :: REARTH
      REAL, INTENT(IN)  :: SINZEN
      REAL, INTENT(OUT) :: DSDHTOP

!***Internal

      INTEGER :: I, J, K  ! loop indices
      REAL    :: RE
      REAL    :: DSJ      ! slant path length [m]
      REAL    :: DHJ      ! layer thickness [m]
      REAL(8) :: RJ, RJP1
      REAL(8) :: RPSINZ   ! rpsinz = (re + zd(i)) * sinzen
      REAL(8) :: RPSINZ2  ! rpsinz * rpsinz
      REAL(8) :: GA, GB   ! see usage

C-----------------------------------------------------------------------

!***re include the altitude above sea level to the radius of the earth

      RE = REARTH + ZSFC

!!sjr DHJ = ZTOA - ZTOM
      DHJ = ZTOA - ( ZTOM + ZSFC )

!***FSB The following code is a direct implementation of appendix B
!***  of Dahlbeck and Stamnes (1991) for the case of solar zenith
!***  angle less than 90 degree.

!***  calculate ds/dh of every layer starting at the top

      RPSINZ  = REAL( ( REARTH + ZTOA ) * SINZEN, 8 )
      RPSINZ2 = RPSINZ * RPSINZ

!!sjr RJ = RE + ZTOA
      RJ   = REAL( REARTH + ZTOA, 8 )
      RJP1 = REAL( RE + ZTOM, 8 )

!***define GA and GB

      GB = SQRT( MAX( 0.0D0, RJ * RJ     - RPSINZ2 ) )
      GA = SQRT( MAX( 0.0D0, RJP1 * RJP1 - RPSINZ2 ) )

!***This is equation B1 from Dahlbeck and Stamnes (1991)

      DSJ = REAL( GB - GA, 4 )

!***this is the slant path (Chapman) function.

      DSDHTOP = DSJ / DHJ

      RETURN
      END SUBROUTINE SLANTPATHTOP

C///////////////////////////////////////////////////////////////////////

      SUBROUTINE TWOSTREAM_S ( NLEVEL, MU, RSFC, TAUU, OMU, GU, DSDH,
     &                         FDR, FUP, FDN, EDR, EUP, EDN )
C-----------------------------------------------------------------------
C  PURPOSE:
C     Solve two-stream equations for multiple layers.  The subroutine is
C     based on equations from:  Toon et al., 1989.
C     It contains only the Delta Eddington method.
C     A pseudo-spherical correction has also been added.
C     FSB This version is restricted to solar zenith angle LESS THAN 90
C     degrees
C-----------------------------------------------------------------------
C  ARGUMENTS:
C     INPUT:
C       nlevel - INTEGER, number of specified altitude levels in the
C                working grid
C       mu     - REAL, cosine of solar senith angle
C       rsfc   - REAL, surface albedo at current wavelength
C       tauu   - REAL, unscaled optical depth of each layer
C       omu    - REAL, unscaled single scattering albedo of each layer
C       gu     - REAL, unscaled asymmetry parameter of each layer
C       dsdh   - REAL, slant path of direct beam through each layer
C                crossed when travelling from the top of the atmosphere
C                to layer
C     OUTPUT:
C       fdr - REAL, contribution of the direct component to the total
C             actinic flux at each altitude level
C       fup - REAL, contribution of the diffuse upwelling component to
C             the total actinic flux at each altitude level
C       fdn - REAL, contribution of the diffuse downwelling component to
C             the total actinic flux at each altitude level
C       edr - REAL, contribution of the direct component to the total
C             spectral irradiance at each altitude level
C       eup - REAL, contribution of the diffuse upwelling component to
C             the total spectral irradiance at each altitude level
C       edn - REAL, contribution of the diffuse downwelling component to
C             the total spectral irradiance at each altitude level
C-----------------------------------------------------------------------
C  EDIT HISTORY:
C     This is a modification of ps2str.f from TUV
C     this routine has been modified from the original TUV code by
C     Dr. Francis S. Binkowski, Carolina Environmental Program
C     09/2004 removed various two-stream methods (FSB)
C     09/2004 made mu an input (FSB)
C     09/2004 simplified for case of solar zenith angle less than
C             90 degrees
C-----------------------------------------------------------------------
C  References:
C
C     Joseph, J.H., W.J. Wiscombe, and J.A. Weinman, The delta-Eddington
C     Approximation for radiative flux transfer, Jour. Atmos. Res.,
C     Vol.33, No. 12, pages 2452 - 2459, December , 1976.
C     (the method implemented here)
C
C     Toon, O.B., C.P. McKay, T.P. Ackerman, and K. Santhanam, Rapid
C     calculation of radiative heating rates and photodissociation rates
C     in inhomogeneous multiple scattering atmospheres, J. Geophys. Res.
C     Vol. 94, No. D13, Pages 16,287 - 16,301, November 20, 1989.
C     (all citations for equation numbers and page numbers are to this
C     reference)
C
C     Zeng, J., S. Madronich, and K. Stamnes, A note on the use of the
C     two-stream delta-scaling approximation for calculating atmospheric
C     photolysis rate coefficients, Journal of Geophysical Research,
C     vol 101, D9, pp 14,525 - 14530, June 20, 1996.
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER, PARAMETER :: KZ = 100
      INTEGER, PARAMETER :: NROWS = 2 * KZ

!***arguments

      INTEGER, INTENT( IN ) :: NLEVEL

      REAL,    INTENT(IN )  :: MU
      REAL,    INTENT(IN )  :: RSFC
      REAL,    INTENT(IN )  :: TAUU( : )
      REAL,    INTENT(IN )  :: OMU ( : )
      REAL,    INTENT(IN )  :: GU  ( : )
      REAL,    INTENT(IN )  :: DSDH( : )
      REAL,    INTENT(OUT ) :: FUP ( : )
      REAL,    INTENT(OUT ) :: FDN ( : )
      REAL,    INTENT(OUT ) :: FDR ( : )
      REAL,    INTENT(OUT ) :: EUP ( : )
      REAL,    INTENT(OUT ) :: EDN ( : )
      REAL,    INTENT(OUT ) :: EDR ( : )

!***local:

      REAL( 8 ) :: TAUC  ( 0:KZ )        ! optical depth variable
      REAL( 8 ) :: TAUSLA( 0:KZ )        ! slant path optical depth
      REAL( 8 ) :: MU2   ( 0:KZ )        ! replaces mu1 for slant path

!***internal coefficients and matrix

      REAL( 8 ) :: LAM( KZ ), TAUN( KZ ), BGAM( KZ )
      REAL( 8 ) :: E1( KZ ), E2( KZ ), E3( KZ ), E4( KZ )
      REAL( 8 ) :: CUP( KZ ), CDN( KZ ), CUPTN( KZ ), CDNTN( KZ )
      REAL( 8 ) :: A( NROWS ), B( NROWS ), D( NROWS ), E( NROWS ), Y( NROWS )

!***other:

      REAL( 8 ) :: GI( KZ ), OMI( KZ ), TEMPG
      REAL( 8 ) :: PIFS, FDN0
      REAL( 8 ) :: F, G, OM
      REAL( 8 ) :: GAM1, GAM2, GAM3, GAM4

      REAL( 8 ) :: EXPON0, EXPON1
      REAL( 8 ) :: EXPON, DIVISR, TEMP, UP, DN
      REAL( 8 ) :: SSFC

      REAL( 8 ) :: MU1  ! reciprocal of constant from delta_Eddington method

      INTEGER   :: ROW
      INTEGER   :: I, J
      INTEGER   :: NLAYER, MROWS, LEV

!***Some additional program constants:

!!!!from above      REAL, PARAMETER :: PI          = 3.1415926535898  ! pi
      REAL( 8 ), PARAMETER :: LARGEST     = 1.0D+36 ! largest machine number
      REAL( 8 ), PARAMETER :: SMALLEST    = 1.0D-36 ! smallest machine number
      REAL( 8 ), PARAMETER :: SQRTLRGST   = 1.0D+18 ! sqrt(largest)
      REAL( 8 ), PARAMETER :: SQRTLRGSTM1 = 1.0D-18 ! 1/sqrt(largest)
      REAL( 8 ), PARAMETER :: EPS         = 1.0D-03
      REAL( 8 ), PARAMETER :: PRECIS      = ( 1.0D0 - 1.0D-07 )

      REAL( 8 ), PARAMETER :: LOG_DBLE_SMALLEST = -709.090848126508D0
      REAL( 8 ), PARAMETER :: LOG_DBLE_LARGEST  =  709.090848126508D0

C-----------------------------------------------------------------------

!***boundary conditions:

      PIFS = 1.0D0                ! solar flux is set to unity here.
      FDN0 = 0.0D0                ! no downward diffuse flux

      NLAYER = NLEVEL - 1

      DO J = 0, KZ
         TAUC  ( J ) = 0.0D0
         TAUSLA( J ) = 0.0D0
         MU2   ( J ) = SQRTLRGST
      END DO

!***scaling for delta-Eddington approximation

!***start diagnostic prinout

      DO I = 1, NLAYER
      
!         print*,'ACM TWSTREAM GU, F = ', F, GU(I)
         F = REAL( GU(I) * GU(I), 8 )
         GI  (I) = ( REAL( GU(I), 8 ) - F ) / ( 1.0D0 - F )
         OMI (I) = ( 1.0D0 - F ) * REAL( OMU(I), 8 ) 
     &           / ( 1.0D0 - REAL( OMU(I), 8 ) * F )
         TAUN(I) = ( 1.0D0 - REAL( OMU(I), 8 ) * F ) 
     *           *  REAL( TAUU(I), 8)
      END DO

!***set  tausla to be slant optical path contribution for each layer.

      DO I = 1, NLAYER
         TAUSLA(I) = TAUN(I) * REAL( DSDH(I), 8 )
      END DO

      TAUC(1)   = TAUN(1)

      DO I = 1, NLAYER
         TAUN(I)   = TAUN(I)
         TAUSLA(I) = TAUSLA(I-1) + TAUSLA(I) ! NOTE redefinition of tausla
                                             ! to be a sum over altitude.
         TAUC(I)   = TAUC(I-1) + TAUN(I)

!***FSB calculate MU2(i). This is the substitute for mu ( = 1/ coszen) for the
!***  pseudo spherical approximation. It is ther ratio of vertical optical
!***  depth to the slant optical depth.
!***  This has been simplified from TUV ps2str because only
!***  zenith angles < or = 90 degrees are considered.

!         IF ( TAUSLA(I) .EQ. TAUSLA(I-1) ) THEN
!            MU2(I) = SQRTLRGST
!         ELSE
!            MU2(I) = (TAUC(I) - TAUC(I-1)) / (TAUSLA(I) - TAUSLA(I-1))
!            MU2(I) = SIGN( MAX( ABS( MU2(I)), SQRTLRGSTM1 ), MU2(I) )
!         END IF
!         MU2(I) = 1.0D0 / MU2(I)
!      END DO

         IF ( TAUSLA(I) .EQ. TAUSLA(I-1) ) THEN
            MU2(I) = SQRTLRGSTM1
         ELSE
            MU2(I) =  (TAUSLA(I) - TAUSLA(I-1)) / (TAUC(I) - TAUC(I-1)) 
            MU2(I) = SIGN( MIN( ABS( MU2(I)), SQRTLRGST ), MU2(I) )
         END IF
      END DO

!***compute coefficients for each layer:
!***  gam1 - gam4 = 2-stream coefficients
!***  expon0 = calculation of e when tau is zero
!***  expon1 = calculation of e when tau is taun
!***  cup and cdn = calculation when tau is zero
!***  cuptn and cdntn = calc. when tau is taun
!***  divisr = prevents division by zero

      DO 11, I = 1, NLAYER

         G = GI(I)
         OM = OMI(I)
!***stay away from 1 by precision.  For g, also stay away from -1

!        TEMPG = MIN( ABS( G ), 1.0D0 - PRECIS )
         TEMPG = MIN( ABS( G ), PRECIS )
         G = SIGN( TEMPG, G )
!        OM = MIN( OM, 1.0D0 - PRECIS )
         OM = MIN( OM, PRECIS )

!***calculate the gamma values from line 1 Table 1, page 16,289

         GAM1 =  ( 7.0D0 - OM * ( 4.0D0 + 3.0D0 * G ) ) * 0.25D0
         GAM2 = -( 1.0D0 - OM * ( 4.0D0 - 3.0D0 * G ) ) * 0.25D0
         GAM3 =  ( 2.0D0 - 3.0D0 * G * REAL( MU, 8 )  ) * 0.25D0
         GAM4 =  1.0D0 - GAM3
         MU1  =  2.0D0

!***lambda = pg 16,290 equation 21
!***big gamma = pg 16,290 equation 22

         IF ( ABS( GAM2 ) .LE. SMALLEST ) THEN
            WRITE( LOGDEV, 2609) I, GI(I), OMI(I), G, OM, GAM1, GAM2
            WRITE( LOGDEV, 2610)
         END IF

         IF ( ( GAM1*GAM1 - GAM2*GAM2 ) .LT. 0.0D0 ) THEN
            WRITE( LOGDEV, 2609) I, GI(I), OMI(I), G, OM, GAM1, GAM2
            WRITE( LOGDEV, 2611)
         END IF
 
     
         LAM(I) = SQRT( GAM1*GAM1 - GAM2*GAM2 )

         IF ( ABS( GAM2 ) .LE. SMALLEST ) THEN 
!***adjustment based on NCAR TUV model
            BGAM(I) = 0.0D0
         ELSE
            BGAM(I) = ( GAM1 - LAM(I) ) / GAM2
         END IF

         EXPON = EXP( MAX( LOG_DBLE_SMALLEST, -LAM(I) * TAUN(I) ) ) 

!***e1 - e4 = pg 16,292 equation 44

         E1(I) = 1.0D0 + BGAM(I) * EXPON
         E2(I) = 1.0D0 - BGAM(I) * EXPON
         E3(I) = BGAM(I) + EXPON
         E4(I) = BGAM(I) - EXPON

!***the following sets up for the C equations 23, and 24
!***  found on page 16,290
!***  prevent division by zero (if LAMBDA = 1 / MU,
!***  shift 1/MU^2 by  EPS = 1.E-3
!***  which is approx equiv to shifting MU by 0.5*EPS* (MU)**3

         DIVISR = LAM(I) * LAM(I) - MU2(I) * MU2(I)
         TEMP = MAX( EPS, ABS( DIVISR ) )
         DIVISR = SIGN( TEMP , DIVISR )
         UP = OM * PIFS *
     &        ( ( GAM1 - MU2(I) ) * GAM3 + GAM4 * GAM2 ) / DIVISR


         DN = OM * PIFS *
     &        ( ( GAM1 + MU2(I) ) * GAM4 + GAM2 * GAM3 ) / DIVISR

!***cup and cdn are when tau is equal to zero
!***cuptn and cdntn are when tau is equal to taun

         EXPON0 = EXP( MAX( LOG_DBLE_SMALLEST, -TAUSLA(I-1) ) )
         EXPON1 = EXP( MAX( LOG_DBLE_SMALLEST, -TAUSLA(I) ) )

         CUP(I)   = UP * EXPON0
         CDN(I)   = DN * EXPON0
         CUPTN(I) = UP * EXPON1
         CDNTN(I) = DN * EXPON1

 11   CONTINUE                  ! loop on layer

!***set up matrix
!*** ssfc = pg 16,292 equation 37  where pi Fs is one (unity).
      SSFC   = REAL( RSFC * MU, 8 ) * PIFS
     &       * EXP( MAX( LOG_DBLE_SMALLEST, -TAUSLA( NLAYER ) ) ) 

!***MROWS = the number of rows in the matrix

      MROWS = 2 * ( NLAYER )

!*** the following are from pg 16,292  equations 39 - 43.
!*** set up first row of matrix:

      I = 1
      A(1) = 0.0D0
      B(1) = E1(I)
      D(1) = -E2(I)
      E(1) = FDN0 - CDN(I)

      ROW = 1

!***set up odd rows 3 thru (MROWS - 1):

      I = 0
      DO 20, ROW = 3, MROWS - 1, 2
         I = I + 1
         A(ROW) = E2(I) * E3(I) - E4(I) * E1(I)
         B(ROW) = E1(I) * E1(I + 1) - E3(I) * E3(I + 1)
         D(ROW) = E3(I) * E4(I + 1) - E1(I) * E2(I + 1)
         E(ROW) = E3(I) * ( CUP(I + 1) - CUPTN(I) ) +
     &            E1(I) * ( CDNTN(I) - CDN(I + 1) )
 20   CONTINUE

!***set up even rows 2 thru (MROWS - 2):

      I = 0
      DO 30, ROW = 2, MROWS - 2, 2
         I = I + 1
         A(ROW) = E2(I + 1) * E1(I) - E3(I) * E4(I + 1)
         B(ROW) = E2(I) * E2(I + 1) - E4(I) * E4(I + 1)
         D(ROW) = E1(I + 1) * E4(I + 1) - E2(I + 1) * E3(I + 1)
         E(ROW) = ( CUP(I + 1) - CUPTN(I) ) * E2(I + 1) -
     &            ( CDN(I + 1) - CDNTN(I) ) * E4(I + 1)
 30   CONTINUE

!***set up last row of matrix at MROWS:

      ROW = MROWS
      I = NLAYER
      F = REAL( RSFC, 8 )
      A(ROW) = E1(I) - F * E3(I)
      B(ROW) = E2(I) - F * E4(I)
      D(ROW) = 0.0D0
      E(ROW) = SSFC - CUPTN(I) + F * CDNTN(I)

!***solve tri-diagonal matrix:
      CALL TRIDIAGONAL ( A, B, D, E, Y, MROWS )

!*** unfold solution of matrix, compute output fluxes:

      ROW = 1
      LEV = 1
      J = 1

!***the following equations are from pg 16,291  equations 31 & 32

      FDR(LEV) = 1.0    ! this the downward flux at the top of the model
      EDR(LEV) = MU * REAL( FDR(LEV) )
      EDN(LEV) = REAL( FDN0 )
      EUP(LEV) = REAL( Y(ROW) * E3(J) - Y(ROW + 1) * E4(J) + CUP(J) )
      FDN(LEV) = EDN(LEV) * REAL( MU1 )
      FUP(LEV) = EUP(LEV) * REAL( MU1 )

      DO 60, LEV = 2, NLAYER + 1
         FDR(LEV) = REAL( EXP( MAX( LOG_DBLE_SMALLEST, -TAUSLA(LEV-1) )  ) )
!         FDR(LEV) = REAL( EXPONS(LEV-1) ) ! REAL( EXP( MAX( LOG_DBLE_SMALLEST, -TAUSLA(LEV-1) )  ) )
         EDR(LEV) = MU * FDR(LEV)
         EDN(LEV) = REAL( Y(ROW) * E3(J) + Y(ROW + 1) * E4(J) + CDNTN(J) )
         EUP(LEV) = REAL( Y(ROW) * E1(J) + Y(ROW + 1) * E2(J) + CUPTN(J) )
         FDN(LEV) = EDN(LEV) * REAL( MU1 )
         FUP(LEV) = EUP(LEV) * REAL( MU1 )

         ROW = ROW + 2
         J = J + 1
 60   CONTINUE

2609  FORMAT(/ 'PHOT_MOD: Instability in Two Stream RadTran Subroutine'
     &       / 'Layer: I = ', I3
     &       / 'Asymmetry Factor: GI = ', ES12.4
     &       / 'Single Scattering Albedo: OMI = ', ES12.4
     &       / 'SIGN( MIN( ABS( GI ), 1.0 - 1.0E-7), GI ): G = ', ES12.4
     &       / 'MIN( OMI, 1.0 - 1.0E-7 ): OM = ', ES12.4
     &       / '0.25*( 7.0 - OM * ( 4.0 + 3.0 * G ) ): GAM1 = ', ES12.4
     &       / '0.25*( OM * ( 4.0 + 3.0 * G ) - 1.0 ): GAM2 = ', ES12.4  /)

2610  FORMAT(/ 'Setting (GAM1 - SQRT(GAM1**2 - GAM2**2))/GAM2 to zero' /)

2611  FORMAT(/ ' ( GAM1**2 - GAM2**2 ) < 0: NaNs introduced into solution ' /)

      RETURN
      END SUBROUTINE TWOSTREAM_S


      SUBROUTINE TRIDIAGONAL ( A, B, D, E, Y, N )
C-----------------------------------------------------------------------
C  This version has the same variable names as in twostream_s, that
C  is D is the superdiagonal and E is the right hand side, and Y is
C  the  solution. The size of A,B,D,E and Y is now N, the
C  number of rows in the matrix.
C-----------------------------------------------------------------------
C
C  Function:
C     Solves tridiagonal system by Thomas algorithm.  Algorithm fails
C     if first pivot is zero.  In that case, rewrite the
C     equation as a set of order N-1, with U(2) trivially eliminated.
C     The associated tri-diagonal system is stored in 3 arrays
C     B: diagonal
C     A: sub-diagonal
C     D: super-diagonal
C     E: right hand side function
C     U : return solution from tridiagonal solver
C
C     [ B(1) D(1) 0    0    0 ...       0     ]
C     [ A(2) B(2) D(2) 0    0 ...       .     ]
C     [ 0    A(3) B(3) D(3) 0 ...       .     ]
C     [ .       .     .     .           .     ] Y(i) = E(i)
C     [ .             .     .     .     0     ]
C     [ .                   .     .     .     ]
C     [ 0                           A(N) B(N) ]
C
C  Preconditions:
C
C  Subroutines and Functions Called:
C
C  Revision History:
C     NO.   DATE     WHO      WHAT
C     __    ____     ___      ____
C     5     11/09/04  FSB  Changed symbols to match twostream_s
C                          made arrays variable.
C     4     4/3/96    SJR  copied code and modified for use in JPROC
C     3     8/16/94   XKX  configuration management include statements
C     2     3/15/92   CJC  For use in Models-3 LCM.
C     1     10/19/89  JKV  converted for use on IBM
C     0      3/89     BDX  Initial version
C     yoj
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***Arguments:

      INTEGER,   INTENT( IN )  :: N        ! number of rows in matrix
      REAL( 8 ), INTENT( IN )  :: A( : )   ! subdiagonal
      REAL( 8 ), INTENT( IN )  :: B( : )   ! diagonal
      REAL( 8 ), INTENT( IN )  :: D( : )   ! superdiagonal
      REAL( 8 ), INTENT( IN )  :: E( : )   ! R.H. side
      REAL( 8 ), INTENT( OUT ) :: Y( : )   ! solution

!***Local Variables:

      INTEGER J   ! loop index

      REAL( 8 ) :: BET        !
      REAL( 8 ) :: GAM( N )   !

!***Decomposition and forward substitution:

      BET = 1.0D0 / B( 1 )
      Y( 1 ) = BET * E( 1 )

      DO J = 2, N
         GAM( J ) = BET * D( J - 1 )
         BET = 1.0D0 / ( B( J ) - A( J ) * GAM( J ) )
         Y( J ) = BET * ( E( J ) - A( J ) * Y( J - 1) )
      END DO

!***Back-substitution:

      DO J = N - 1, 1, -1
         Y( J ) = Y( J ) - GAM( J + 1 ) * Y( J + 1 )
      END DO

      RETURN

      END SUBROUTINE TRIDIAGONAL

C///////////////////////////////////////////////////////////////////////

      INTEGER FUNCTION INDEXR0 ( NAME1, N, NAME2 )
C-----------------------------------------------------------------------
C
C  Function:
C     This routine searches for NAME1 in list NAME2
C
C  Revision History:
C     5/88   Modified for ROMNET
C     July 29, 2005 by FSB
C     Changed name to avoid conflict FSB
C     copied from CMAQ routine INDEX2 to allow internal use
C
C  Argument List Description:
C
C  Input Arguments:
C     NAME1       Character string being searched for
C     N           Length of array to be searched
C     NAME2       Character array to be searched
C
C  Output Arguments:
C     INDEX1      The position within the NAME2 array that NAME1
C                 found. If string was not found, INDEX1 = 0
C
C  Local Variable Description:
C     None
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: N

      CHARACTER*(*), INTENT(IN) :: NAME1
      CHARACTER*(*), INTENT(IN) :: NAME2(*)

      INTEGER I

!***Assume NAME1 is not in list NAME2

      INDEXR0 = 0

      DO I = 1, N
         IF ( INDEX( NAME2( I ), NAME1 ) .EQ. 1 ) THEN
            INDEXR0 = I
            RETURN
         END IF
      END DO

      RETURN
      END FUNCTION INDEXR0

      END MODULE PHOT_MOD

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE ZADV ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Advection in the vertical, x3-direction:
C   The process time step is set equal to TSTEP

C Preconditions:
C   Dates and times represented YYYYDDD:HHMMSS.
C   No "skipped" dates and times. Process time step divides TSTEP exactly
C   CGRID in transport units: SQRT{DET[metric tensor]}*concentration (Mass/Vol)

C Subroutines and functions called:
C   TIME2SEC

C Revision history:
C   02/19/93 by M. Talat Odman  at NCSC
C   05/17/93 by Carlie J. Coats at NCSC:  now uses INTERP3()
C   06/14/94 by Dongming Hwang at NCSC:
C              include statement and subroutine name template
C   10/15/95 by M. Talat Odman at NCSC: generalized coordinates

C   Sep 97 Jeff
C   Aug 98 Jeff better Courant condition tstep limit

C    David Wong, Sep. 1998
C      -- parallelized the code

C    15 Dec 00 J.Young: move CGRID_MAP into f90 module
C                       GLOBAL_RSUM -> Dave Wong's f90 stenex GLOBAL_SUM
C                       GLOBAL_ISUM -> Dave Wong's f90 stenex GLOBAL_SUM

C    28 Jul 01 J.Young: allocatable arrays ...
C                       Since F90 does not preserve dummy argument array
C                       indices, the 3rd dimension of WHAT has been changed
C                       from 0:NLAYS to 1:NLAYS+1 for the sake of vcontvel

C    03 Sep 01 David Wong
C      -- inserted F90 DEALLOCATE statement for NX3
C
C   1/03 - JP modified for Yamo mass conservation
C          Vertical velocity is diagnosed from mass continuity
C          vertical advection is upstream (no call to adv scheme)

C    31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                       domain specifications in one module
C    27 Apr 07 J.Young: Talat's First-order upstream (donor cell) algorithm
C    30 Apr 09 J.Pleim, J.Young: Replace donor cell with ppm, adjust velocity
C                                accordingly
C    21 Aug 09 J.Young: Don't bypass VPPMY if ITER = 0
C    18 Nov 09 J.Young: Combine VPPMY and VPPM functionality
C    21 Jun 10 J.Young: convert for Namelist redesign
C    16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C    11 May 11 D.Wong: incorporated twoway model implementation
C    31 Jul 12 J.Bash: Changed the zadv dt for cases where cc > 1 to be 
C                      more stable for conditions when cc > 10
C    01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all MY_N
C                      clauses
C    09 Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL
C    11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID species number and offsets
      USE WVEL_DEFN             ! derived vertical velocity component
      USE UTILIO_DEFN

#ifdef isam
      USE SA_DEFN               ! 20120821
#endif

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_GLOBAL_SUM_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_GLOBAL_SUM_MODULE)
#endif

#ifdef snl_timing
      USE TIMING
#endif
      USE CENTRALIZED_IO_MODULE, only : interpolate_var

#ifdef sens
      USE DDM3D_DEFN, ONLY: SENGRID, NPMAX, NP
#endif 

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER     JDATE         ! current model date, coded YYYYDDD
      INTEGER     JTIME         ! current model time, coded HHMMSS
      INTEGER     TSTEP( 3 )    ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency

C Parameters:

      INTEGER, PARAMETER :: MAXITER = 30     ! error exit limit

C Advected species dimension

      INTEGER, SAVE :: N_SPC_ADV

C File Variables:

      REAL        RHOJM1( NCOLS,NROWS,NLAYS ) ! RhoJ from Met file at start of tstep
      REAL        RHOJM2( NCOLS,NROWS,NLAYS ) ! RhoJ from Met file at end of tstep

C Local variables:

      CHARACTER( 16 ) :: PNAME = 'ZADVYPPM'
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
!     REAL         UHATJD( NCOLS+1,NROWS+1,NLAYS )  ! x1-component CX-velocity
!     REAL         VHATJD( NCOLS+1,NROWS+1,NLAYS )  ! x2-component CX-velocity

      INTEGER       MTIME, MDATE
!     REAL          CON1( NLAYS,N_SPC_ADV ) ! concentrations subset
      REAL, ALLOCATABLE, SAVE :: CON1( :,: ) ! concentrations subset
      REAL          VEL ( NLAYS+1 )        ! Velocities in a N-S column
      REAL          FLX ( NLAYS+1 )        ! upstream donor cell computed conc. flux
      REAL, ALLOCATABLE, SAVE :: DS ( : )  ! dx3 (dimensionless in sigma coord.)
      REAL          DTSEC                  ! sync time step in seconds
      REAL          DELT                   ! adjusted time step
      REAL          FLUX                   ! intermediate flux

!     INTEGER, SAVE :: ADV_MAP( N_SPC_ADV ) ! global adv map to CGRID
      INTEGER, ALLOCATABLE, SAVE :: ADV_MAP( : ) ! global adv map to CGRID

      INTEGER       COL, ROW, LVL, SPC, VAR ! loop counters
      INTEGER       A2C
      INTEGER       ITER

      CHARACTER( 96 ) :: XMSG = ' '
      REAL          RJ1( NLAYS )           ! local adjusted RHOJ
      REAL          RJ2( NLAYS )           ! local RHOJM at tstep + 1
      REAL          RJT( NLAYS )           ! local adjusted RHOJ
      REAL          DRJ, DUDX, DVDY
      REAL          DIVV( NLAYS )
      REAL          CC                     ! local Courant No.
      REAL          DTNEW                  ! sub timestep
      REAL          DSDT                   ! DS/DT
      REAL, ALLOCATABLE, SAVE :: FBLN( : ) ! blending function for upper layers
      INTEGER       ALLOCSTAT

#ifdef isam
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: NAME_ADV( : )
      REAL    :: SA_CON( NLAYS,N_SPCTAG )
#endif

#ifdef sens
      REAL, ALLOCATABLE, SAVE :: SEN1( :,:,: ) ! ( NLAYS,N_SPC_ADV,NPMAX ) sens subset
#endif

      INTERFACE
#ifdef isam
         SUBROUTINE VPPM ( NI, DT, DS, FLX, VEL, CON, SA_CON )
         USE SA_DEFN
#elif sens
         SUBROUTINE VPPM ( NI, DT, DS, FLX, VEL, CON, SEN1 )
#else
         SUBROUTINE VPPM ( NI, DT, DS, FLX, VEL, CON )
#endif
            INTEGER, INTENT( IN )    :: NI
            REAL,    INTENT( IN )    :: DT, DS( NI )
            REAL,    INTENT( IN )    :: FLX( NI+1 )
!           REAL,    INTENT( IN )    :: VEL( NI+1 )
            REAL,    INTENT( INOUT ) :: VEL( NI+1 )
            REAL,    INTENT( INOUT ) :: CON( :,: )
#ifdef isam
            REAL,    INTENT( INOUT ) :: SA_CON( NI,N_SPCTAG )
#elif sens
            REAL,    INTENT( INOUT ) :: SEN1( :,:,: )
#endif
         END SUBROUTINE VPPM
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         ALLOCATE ( DS( NLAYS ),FBLN( NLAYS ),STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DS or FBLN'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         N_SPC_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV + 1
                                                  ! add 1 for advecting RHOJ
         ALLOCATE ( CON1( NLAYS,N_SPC_ADV ),
     &              ADV_MAP( N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CON1 or ADV_MAP'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#ifdef isam
         ALLOCATE ( NAME_ADV( N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating NAME_ADV'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
#endif

#ifdef sens
         ALLOCATE ( SEN1( NLAYS,N_SPC_ADV,NPMAX ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SEN1'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
#endif

C Get default file header attibutes from MET_CRO_3D (assumes file already open)

C Get dx3 from the GRID_CONF(VGRD) F90 module
!         WRITE( LOGDEV,* ) ' '
!         WRITE( LOGDEV,* ) '    layer    S (X3FACE_GD) Delta S'
         DO LVL = 1, NLAYS
            DS ( LVL ) = ABS ( X3FACE_GD( LVL ) - X3FACE_GD( LVL-1 ) )
!           FBLN( LVL ) = 1.0 - 1.0 / ( 1.0 + EXP( 15.0 * ( X3FACE_GD( LVL ) - 0.5 ) ) )
            FBLN( LVL ) = 1.0
!            WRITE( LOGDEV,'(5X, I3, 3F14.7)' ) LVL, X3FACE_GD( LVL ),
!    &                                          DS( LVL ), FBLN(LVL)
         END DO
!         WRITE( LOGDEV,* ) ' '

C Create global map to CGRID
         SPC = 0
         DO VAR = 1, N_GC_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = GC_STRT - 1 + GC_TRNS_MAP( VAR )
#ifdef isam
            NAME_ADV( SPC ) = GC_TRNS( VAR )  ! KRT
#endif
         END DO
         DO VAR = 1, N_AE_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = AE_STRT - 1 + AE_TRNS_MAP( VAR )
#ifdef isam
            NAME_ADV( SPC ) = AE_TRNS( VAR )  ! KRT
#endif
         END DO
         DO VAR = 1, N_NR_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = NR_STRT - 1 + NR_TRNS_MAP( VAR )
#ifdef isam
            NAME_ADV( SPC ) = NR_TRNS( VAR )  ! KRT
#endif
         END DO
         DO VAR = 1, N_TR_ADV
            SPC = SPC + 1
            ADV_MAP( SPC ) = TR_STRT - 1 + TR_ADV_MAP( VAR )
#ifdef isam
            NAME_ADV( SPC ) = TR_ADV( VAR )  ! KRT
#endif
         END DO
 
         ADV_MAP( N_SPC_ADV ) = RHOJ_LOC

      END IF                    ! if firstime

C Time-stepped gridded computation for Z-direction advection.
      DTSEC  = FLOAT( TIME2SEC( TSTEP( 2 ) ) ) ! process time step (seconds)

C vertical velocities are at face centers, positive upward.
C No boundary conditions are needed because VEL(1) = VEL(NLAYS+1) = 0

C Get rho*J at start of sync step
      MDATE = JDATE
      MTIME = JTIME
#ifdef snl_timing
      call start_timing( zadv_int, read_int, 1 )
#endif
      call interpolate_var ('DENSA_J', mdate, mtime, RHOJM1)

#ifdef snl_timing
      call stop_timing( zadv_int, read_int )
#endif

C Get rho*J at end of sync step
      CALL NEXTIME( MDATE, MTIME, TSTEP( 2 ) )
#ifdef snl_timing
      call start_timing( zadv_int, read_int, 1 )
#endif
      call interpolate_var ('DENSA_J', mdate, mtime, RHOJM2)

#ifdef snl_timing
      call stop_timing( zadv_int, read_int )
#endif

      DO 333 ROW = 1, NROWS
         DO 222 COL = 1, NCOLS

            DO SPC = 1, N_SPC_ADV
               A2C = ADV_MAP( SPC )
               DO LVL = 1, NLAYS
                  CON1( LVL,SPC ) = CGRID( COL,ROW,LVL,A2C )
#ifdef sens
                  DO NP = 1, NPMAX
                     SEN1 ( LVL,SPC,NP ) = SENGRID( COL,ROW,LVL,NP,A2C )
                  END DO
#endif
               END DO
            END DO

            DO LVL = 1, NLAYS
               RJ1( LVL ) = RHOJM1( COL,ROW,LVL )
               RJ2( LVL ) = RHOJM2( COL,ROW,LVL )
            END DO

            ITER = 0
            DELT = DTSEC
            VEL( 1 ) = 0.0   ! impermeable boundary condition at the surface
            FLX( 1 ) = 0.0
            DRJ = 0.0
            DO LVL = 1, NLAYS
               DSDT = DS( LVL ) / DELT              ! initial for this col/row
               RJT( LVL ) = CON1( LVL,N_SPC_ADV )   ! initial for this col/row
!              DUDX = ( UHATJD( COL+1,ROW,LVL ) - UHATJD( COL,ROW,LVL ) ) / XCELL_GD
!              DVDY = ( VHATJD( COL,ROW+1,LVL ) - VHATJD( COL,ROW,LVL ) ) / YCELL_GD
!              DIVV( LVL ) = DUDX * DS( LVL ) + DVDY * DS( LVL )
               DIVV( LVL ) = ( RJ1( LVL ) - RJT( LVL ) ) * DSDT
               DRJ = DRJ - DIVV( LVL )
            END DO

#ifdef isam
Ckrt...import isam array into sa_con
            DO SPC = 1, N_SPCTAG
               DO LVL = 1, NLAYS
                  SA_CON( LVL,SPC ) = ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
               END DO
            END DO
#endif
                        
111         CONTINUE   ! iteration loop if CC > 1

            FLUX = 0.0
            DO LVL = 1, NLAYS
               RJT( LVL ) = CON1( LVL,N_SPC_ADV )
!----Yamo part
               DSDT = DS( LVL ) / DELT
               FLUX = FLUX - DSDT * ( RJ2( LVL ) - RJT( LVL ) )
               FLX( LVL+1 ) = FLX( LVL ) - DS( LVL ) * DRJ - DIVV( LVL )
               FLX( LVL+1 ) = FBLN( LVL ) * FLX( LVL+1 ) + ( 1.0 - FBLN( LVL ) ) * FLUX
               FLUX = FLX( LVL+1 )
            END DO

            DO LVL = 2, NLAYS
               IF ( FLX( LVL ) .GE. 0.0 ) THEN
                  VEL( LVL ) = FLX( LVL ) / RJT( LVL-1 )
               ELSE
                  VEL( LVL ) = FLX( LVL ) / RJT( LVL )
               END IF
            END DO

            VEL( NLAYS+1 ) = FLX( NLAYS+1 ) / RJT( NLAYS )

C Find Maximum Courant Number

            CC = 0.0
            DTNEW = DELT

            DO LVL = 2, NLAYS
               IF ( VEL( LVL ) .GT. 0.0 ) THEN
                  CC = MAX ( CC, ( VEL( LVL ) * DELT / DS( LVL-1 ) ) )
                  DTNEW = MIN( DTNEW, 0.9 * DELT / CC )
               ELSE
                  CC = MAX ( CC, ( -VEL( LVL ) * DELT / DS( LVL ) ) )
   !              DTNEW = MIN( DTNEW, DELT / MAX( CC, 0.9 ) )
                  DTNEW = MIN( DTNEW, 0.9 * DELT / MAX( CC, 1.0 ) ) ! MAX in case vel = 0
               END IF
            END DO

            LVL = NLAYS+1
            IF ( VEL( LVL ) .GT. 0.0 ) THEN
               CC = MAX ( CC, ( VEL( LVL ) * DELT / DS( LVL-1 ) ) )
               DTNEW = MIN( DTNEW, 0.9 * DELT / CC )
            ELSE
               CC = MAX ( CC, ( -VEL( LVL ) * DELT / DS( LVL-1 ) ) )
   !           DTNEW = MIN( DTNEW, DELT / MAX( CC, 0.9 ) )
               DTNEW = MIN( DTNEW, 0.9 * DELT / MAX( CC, 1.0 ) ) ! MAX in case vel = 0
            END IF

            IF ( CC .GT. 1.0 ) THEN ! courant number is larger than unity

C Calculate a sub-time step that satisfies the Courant stability limit.
C Perform vertical advection with the computed velocity and sub-time step.
C Then calculate the difference between the original and sub-time steps.
C The difference is the new sub-time step. Recompute vertical velocities
C that would bring the air density field back to being uniform. Note that
C if Courant number with the new velocity and sub-time step is larger than
C unity again, then the last sub-time step would be split into further
C sub-steps.

               DTNEW = MAX( DTNEW, 1.0 )       

#ifdef isam
               CALL VPPM ( NLAYS, DTNEW, DS, FLX, VEL, CON1, SA_CON )
#elif sens
               CALL VPPM ( NLAYS, DTNEW, DS, FLX, VEL, CON1, SEN1 )
#else
               CALL VPPM ( NLAYS, DTNEW, DS, FLX, VEL, CON1 )
#endif
               DELT = DELT - DTNEW

               ITER = ITER + 1
               IF ( ITER .GT. MAXITER ) THEN
                  WRITE( LOGDEV,2005 ) COL, ROW, CC, DELT, ITER, JTIME
2005              FORMAT( 'zadv col  row     CC', 8X, 'dt    iter   jtime'
     &                    / 'zzzz', 2I4, 1PE12.3, 0PF10.5, 1X, I4, I10.6
     &                    / 10X, 'MetRhoj', 3X, 'TrRhoj', 5X, 'Diff',
     &                       4X, 'adv_rhoj', 3X, 'vel(l)', 6X, 'vel(l+1)' )
                  DO LVL = 1, NLAYS
                     WRITE( LOGDEV,2009 ) LVL, RJ2( LVL ), RJT( LVL ),
     &                                    RJ2( LVL ) - RJT( LVL ),
     &                                    CON1( LVL,N_SPC_ADV ),
     &                                    VEL( LVL ), VEL( LVL+1 )
                  END DO
2009              FORMAT( 'zzz2', I3, 4F10.2, 2(1PE12.3) )
                  WRITE( XMSG,2013 ) JTIME, TSTEP( 2 ), MAXITER
2013              FORMAT( 'vert adv soln failed at', I7.6,  ' with adv step:',
     &                     I7.6, ' HHMMSS', 2X, 'Max Iterations =', I3 )
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               END IF

               GO TO 111

            END IF

#ifdef isam
            CALL VPPM ( NLAYS, DELT, DS, FLX, VEL, CON1, SA_CON )
#elif sens
            CALL VPPM ( NLAYS, DELT, DS, FLX, VEL, CON1, SEN1 )
#else
            CALL VPPM ( NLAYS, DELT, DS, FLX, VEL, CON1 )
#endif
            DO SPC = 1, N_SPC_ADV
               A2C = ADV_MAP( SPC )
               DO LVL = 1, NLAYS
                  CGRID( COL,ROW,LVL,A2C ) = CON1( LVL,SPC )
#ifdef sens
                  DO NP = 1, NPMAX
                     SENGRID( COL,ROW,LVL,NP,A2C ) = SEN1 ( LVL,SPC,NP )
                  END DO
#endif
               END DO
            END DO

#ifdef isam
Ckrt...update ISAM with SA_CON....20120821
            DO SPC = 1, N_SPCTAG
               IF( TRANSPORT_SPC( SPC ) )THEN
                  DO LVL = 1, NLAYS
                     ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) ) = SA_CON( LVL,SPC )
                  END DO
               END IF   
            END DO
#endif
            IF ( W_VEL ) THEN ! If the user wants vertical velocity written to file, fill in global scope array (WY)
              DO LVL = 1, NLAYS
                 WY( LVL,COL,ROW ) = VEL( LVL+1 )
              END DO
            END IF 

222         CONTINUE   ! COL
333      CONTINUE   ! ROW

      IF ( W_VEL ) CALL GET_WVEL( JDATE,JTIME )

      RETURN
      END SUBROUTINE ZADV

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/hdiff/multiscale/rho_j.F,v 1.5 2011/10/21 16:11:22 yoj Exp $ 

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE RHO_J ( JDATE, JTIME, TSTEP, RHOJI )
      
C-----------------------------------------------------------------------
C Function:
C   Get Air Density X SqRDMT for computational grid including boundary
C   where SqRDMT = Sq. Root [det ( metric tensor )]
C   = Jacobian / (map scale factor)**2
 
C Preconditions:
C   Can be used only for conformal map coordinates in the horizontal.
C   Dates and times should be represented YYYYDDD:HHMMSS.
 
C Subroutines and functions called:
C    INTERP3, M3EXIT, TIME2SEC, SEC2TIME, NEXTIME, CHECK3
      
C Revision history:
C    5 Nov 97 Jeff

C    Sep. 1998 David Wong
C      -- parallelized the code
C      -- removed the indirect index reference

C    6 Aug 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with
C                      INTERPX and INTERPB; allocatable arrays ...
C                      Since F90 does not preserve dummy argument array
C                      indices, RHOJI( 1:NCOLS+2,, ) is copied into local array
C                      RHOJI( 0:NCOLS+1,, ).
C                      The caller of RHO_J dimensions the actual argument,
C                      as RHOJ( 0:NCOLS+1,, ).
C                      NOTE: NTHIK must be = 1
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S. Roselle: replaced I/O-API include files w/UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   28 Jul 11 David Wong: set REVERT to .false. for twoway model case since
C                         buffered file has only two time steps data
C    1 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C    1 Aug 19 David Wong: Bug fixed -calling interpolate_var use RHOJ rather 
C                         than DENSJ_BUF in WINDOW scenario
C-----------------------------------------------------------------------
      
      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
      use CENTRALIZED_IO_MODULE

      IMPLICIT NONE

C Includes:
      
!     INCLUDE SUBST_HGRD_ID     ! horizontal dimensioning parameters
!     INCLUDE SUBST_VGRD_ID     ! horizontal dimensioning parameters
      INCLUDE SUBST_FILES_ID    ! file name parameters
 
C Parameters

C Arguments:
      
      INTEGER, INTENT( IN )  :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )  :: JTIME        ! current model time, coded HHMMSS
      INTEGER, INTENT( IN )  :: TSTEP( 3 )   ! time step vector (HHMMSS)
                                             ! TSTEP(1) = local output step
                                             ! TSTEP(2) = sciproc sync. step (chem)
                                             ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                             !            step and wrf/cmaq call frequency
!     REAL        RHOJ( 0:NCOLS+1,0:NROWS+1,NLAYS )  ! Jacobian * air density
      REAL,    INTENT( OUT ) :: RHOJI( :,:,: )
      
C Parameters:

!     INTEGER, PARAMETER :: NTHIN = NTHIK - 1

C file variables:
      
!     REAL        DENSJ_BUF( NCOLS,NROWS,NLAYS ) ! Jacobian * air density
!     REAL        DENSJ_BND( NBNDY,NLAYS )    ! boundary Jacobian * air density
      REAL, ALLOCATABLE :: DENSJ_BUF( :,:,: ) ! Jacobian * air density
      REAL, ALLOCATABLE :: DENSJ_BND( :,: )    ! boundary Jacobian * air density
 
C External Functions: None
       
C local variables:
      
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: PNAME = 'RHO_J'
      CHARACTER( 16 ) :: AMSG
      CHARACTER( 96 ) :: XMSG = ' '
 
      REAL, ALLOCATABLE :: RHOJ( :,:,: )

      INTEGER, SAVE :: MLAYS

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
       
      INTEGER     ALLOCSTAT
      INTEGER     COL, ROW, LVL ! column, row, layer indices
      INTEGER     MDATE         ! mid-advection date
      INTEGER     MTIME         ! mid-advection time
      INTEGER     STEP          ! advection time step in seconds
      INTEGER, SAVE :: LDATE( 2 )    ! last date for data on file
      INTEGER, SAVE :: LTIME( 2 )    ! last time for data on file
      LOGICAL     REVERT        ! recover last time step if true
 
      INTEGER COUNT

      INTEGER, SAVE :: LCB, HCB, LRB, HRB ! convenience pointers

C-----------------------------------------------------------------------
 
      IF ( FIRSTIME ) THEN
 
         FIRSTIME = .FALSE.
 
         LCB = 1 - NTHIK
         HCB = NCOLS + NTHIK
         LRB = 1 - NTHIK
         HRB = NROWS + NTHIK
         MLAYS = SIZE ( RHOJI,3 )

         CALL LSTEPF( MET_CRO_3D, LDATE( 1 ), LTIME( 1 ) )
!        CALL LSTEPF( MET_BDY_3D, LDATE( 2 ), LTIME( 2 ) )

!        LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 2 ) )
!        LTIME( 1 ) = SEC2TIME( MIN(
!    &                              TIME2SEC( LTIME( 1 ) ),
!    &                              TIME2SEC( LTIME( 2 ) )
!    &                              ) )

         END IF                    ! if firstime
 
      MDATE  = JDATE
      MTIME  = JTIME
      STEP   = TIME2SEC( TSTEP( 2 ) )
      CALL NEXTIME( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

#ifdef twoway
      REVERT = .FALSE.
#else
      IF ( MDATE .LT. LDATE( 1 ) ) THEN
         REVERT = .FALSE.
      ELSE IF ( MDATE .EQ. LDATE( 1 ) ) THEN
         IF ( MTIME .LE. LTIME( 1 ) ) THEN
            REVERT = .FALSE.
         ELSE
            REVERT = .TRUE.
         END IF
      ELSE   ! MDATE .GT. LDATE
         REVERT = .TRUE.
      END IF
#endif

      IF ( REVERT ) THEN
         XMSG = 'Current scenario interpolation step not available in both '
     &        // TRIM( MET_CRO_3D ) // 'and '
     &        // TRIM( MET_BDY_3D )
         CALL M3MESG( XMSG )
!        CALL NEXTIME( MDATE, MTIME, -SEC2TIME( STEP / 2 ) )
         WRITE( AMSG,'( 2I8 )' ) LDATE( 1 ), LTIME( 1 )
         XMSG = 'Using data for last file step: ' // AMSG
         CALL M3MESG( XMSG )
         MDATE = LDATE( 1 )
         MTIME = LTIME( 1 )
         END IF
 
C Interpolate Jacobian X Air Density

      ALLOCATE ( RHOJ( LCB:HCB,LRB:HRB,MLAYS ), STAT = ALLOCSTAT )
      IF ( ALLOCSTAT .NE. 0 ) THEN
         XMSG = 'Failure allocating RHOJ'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

      IF ( WINDOW ) THEN

         call interpolate_var ('DENSA_J', mdate, mtime, RHOJ)

         ELSE ! need to extend data from bndy file

         ALLOCATE ( DENSJ_BUF( ncols,nrows,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DENSJ_BUF'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ_BUF)

         ALLOCATE ( DENSJ_BND( NBNDY,MLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DENSJ_BND'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ_BND, 'b')

C Load core of RHOJ array

         DO LVL = 1, MLAYS
            DO ROW = 1, NROWS
               DO COL = 1, NCOLS
                  RHOJ( COL,ROW,LVL ) = DENSJ_BUF( COL,ROW,LVL )
                  END DO
               END DO
            END DO

C Fill in DENSJ array for boundaries

         DO LVL = 1, MLAYS
            COUNT = 0
            DO ROW = 1-NTHIK, 0
               DO COL = 1, NCOLS+NTHIK
                  COUNT = COUNT + 1
                  RHOJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! South
               END DO
            END DO
            DO ROW = 1, NROWS+NTHIK
               DO COL = NCOLS+1, NCOLS+NTHIK
                  COUNT = COUNT + 1
                  RHOJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! East
               END DO
            END DO
            DO ROW = NROWS+1, NROWS+NTHIK
               DO COL = 1-NTHIK, NCOLS
                  COUNT = COUNT + 1
                  RHOJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! North
               END DO
            END DO
            DO ROW = 1-NTHIK, NROWS
               DO COL = 1-NTHIK, 0
                  COUNT = COUNT + 1
                  RHOJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! West
               END DO
            END DO
         END DO

         DEALLOCATE ( DENSJ_BUF )
         DEALLOCATE ( DENSJ_BND )

         END IF   ! WINDOW

C Adjust for argument offset (f90 dummy arguments assumed 1-based)

      DO LVL = 1, MLAYS
         DO ROW = 0, NROWS + 1
            DO COL = 0, NCOLS + 1
               RHOJI( COL+1,ROW+1,LVL ) = RHOJ( COL,ROW,LVL )
               END DO
            END DO
         END DO

      DEALLOCATE ( RHOJ )

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE GETIPROUT

C-----------------------------------------------------------------------
C Function: To process the IPR_OUTPUT option 
 
C Preconditions: None
  
C Key Subroutines/Functions Called: GETCHR
C                                   GETWORD
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI's M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
 
      USE UTILIO_DEFN
      USE PA_DEFN, Only: N_IPR_SPC
      USE PA_IPRVARS
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables:
      CHARACTER( 16 ) :: PNAME = 'GETIPROUT'   ! Program name

C-----------------------------------------------------------------------

c..Increment the counter and check for too many
      N_IPR_SPC = N_IPR_SPC + 1
      N_IPR_OPS( N_IPR_SPC ) = 0
      IF ( N_IPR_SPC .GT. MAXIPRSPC ) THEN
         WRITE( MSG, 94000 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94020 ) MAXIPRSPC
         CALL M3MESG( MSG )
         CALL M3EXIT( PNAME, IZERO, IZERO, ' ', XSTAT2 )
      END IF

c..get the name of the species for IPR_OUTPUT
      CALL GETWORD
      IPR_SPNAM( N_IPR_SPC ) = WORD

c..if the next character is a semicolon, return
      IF ( CHR .EQ. ';' ) THEN
         CALL GETCHR
         RETURN
      END IF

c..the next character must be an equal sign
      IF ( CHR .EQ. '=' ) THEN
         CALL GETCHR         
      ELSE
         WRITE( MSG, 94040 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( PNAME, IZERO, IZERO, ' ', XSTAT2 )
      END IF

c..top of loop for getting operators for this species
20    CONTINUE

c..increment the counters and check for too many
      IF ( CHR .EQ. '+' ) CALL GETCHR
      N_IPR_OPS( N_IPR_SPC ) = N_IPR_OPS( N_IPR_SPC ) + 1

      IF ( N_IPR_OPS( N_IPR_SPC ) .GT. MAXTERMS ) THEN
         WRITE( MSG, 94060 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94080 ) MAXTERMS
         CALL M3MESG( MSG )
         CALL M3EXIT( PNAME, IZERO, IZERO, ' ', XSTAT2 )
      END IF

c..get the operator name
      CALL GETWORD
      IPR_OPNAME( N_IPR_SPC, N_IPR_OPS( N_IPR_SPC ) ) = WORD

c..if more operators, go back or return or err off
      IF ( CHR .EQ. '+' ) THEN
         GO TO 20
      ELSE IF ( CHR .EQ. ';' ) THEN
         CALL GETCHR
         RETURN
      ELSE
         WRITE( MSG, 94100 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( PNAME, IZERO, IZERO, ' ', XSTAT2 )
      END IF

C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( 'ERROR: Maximum number of PA species exceeded' )
94020 FORMAT( '       Modify PARAMETER ( MAXIPRSPC =', I3,' ) or',
     &              '  decrease the number of PA species' )
94040 FORMAT( 'ERROR: Expecting a = or ; after IPR_OUTPUT species',
     &              '  name' ) 
94060 FORMAT( 'ERROR: Maximum number of terms in a PROC_OUTPUT',
     &              '  exceeded' )
94080 FORMAT( '       Modify PARAMETER ( MAXTERMS =', I3,' ) or',
     &              '  decrease the number of terms in the',
     &              '  IPR_OUTPUT request' )
94100 FORMAT( 'ERROR: Expecting a + or ; after a IPR_OUTPUT operator' )
94500 FORMAT( '       Line No. ', I4, ': ', A )
94520 FORMAT( '       Character found: ', A )

      END SUBROUTINE GETIPROUT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE GETIRROUT

C-----------------------------------------------------------------------
C Function: To process the IRR_OUTPUT option 
 
C Preconditions: None
  
C Key Subroutines/Functions Called: GETCHR
C                                   GETWORD
C                                   GETCOEF
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI`s M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
      USE UTILIO_DEFN
      USE PA_GLOBAL     ! Mech and Grid data used 
      USE PA_VARS
      USE PA_DEFN
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables:
      INTEGER :: TERMNUM   ! Counter for number of terms in cycle

C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Get assigned name and check for = sign delimiter
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      NIRROUT = NIRROUT + 1
      IF ( NIRROUT .GT. MAXIRROUT ) THEN
         WRITE( MSG, 94000 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94020 ) MAXIRROUT
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
      END IF

      CALL GETWORD
!     IRRNAME( NIRROUT ) = WORD
!     IRRDESC( NIRROUT ) = WORD
      IRRNAME_TMP( NIRROUT ) = WORD
      IRRDESC_TMP( NIRROUT ) = WORD

      IF ( CHR .NE. '=' ) THEN
         WRITE( MSG, 94040 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
      ELSE
         CALL GETCHR
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Top of loop on terms in output command
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      TERMNUM = 0
20    CONTINUE
      TERMNUM = TERMNUM + 1
      IF ( TERMNUM .GT. MAXOUTTERMS ) THEN
         WRITE( MSG, 94060 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94080 ) MAXOUTTERMS
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
      END IF      

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Get the term`s coefficient if there is one
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      CALL GETCOEF( OUTSC( NIRROUT, TERMNUM ) )
      OUTPNFLAG( NIRROUT, TERMNUM ) = ''

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Reaction rate term
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( CHR .EQ. '<' ) THEN
         OUTTYPE( NIRROUT, TERMNUM ) = 'RXN'
         CALL GETLABEL
         OUTRXLBL( NIRROUT, TERMNUM ) = LABEL
      ELSE
         CALL GETWORD

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Production term
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( WORD .EQ. 'PROD' .OR. WORD .EQ. 'NETP' ) THEN
            OUTTYPE( NIRROUT, TERMNUM ) = WORD
            IF ( CHR .EQ. '[' ) THEN
               CALL GETLABEL
               OUTSPEC1( NIRROUT, TERMNUM ) = LABEL
            ELSE
               WRITE( MSG, 94100 ) 
               CALL M3MESG( MSG )
               WRITE( MSG, 94500 ) LINNUM, INBUF
               CALL M3MESG( MSG )
               WRITE( MSG, 94520 ) CHR
               CALL M3MESG( MSG )
               CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
            END IF

c..FROM option
            OUTSPEC2( NIRROUT, TERMNUM ) = ''
            IF ( CHR .EQ. 'F' ) THEN
               CALL GETWORD
               IF ( WORD .NE. 'FROM' ) THEN
                  WRITE( MSG, 94120 ) 
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94500 ) LINNUM, INBUF
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94540 ) WORD
                  CALL M3MESG( MSG )
                  CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
               END IF
               IF ( CHR .EQ. '[' ) THEN
                  CALL GETLABEL
                  OUTSPEC2( NIRROUT, TERMNUM ) = LABEL
               ELSE
                  WRITE( MSG, 94100 ) 
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94500 ) LINNUM, INBUF
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94520 ) CHR
                  CALL M3MESG( MSG )
                  CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
               END IF
            END IF

            OUTOP2( NIRROUT, TERMNUM ) = ''
            OUTSPEC3( NIRROUT, TERMNUM ) = ''

c..AND/OR operator 
            IF ( CHR .EQ. 'A' .OR. CHR .EQ. 'O' ) THEN
               CALL GETWORD
               IF ( WORD .NE. 'AND' .AND. WORD .NE. 'OR' ) THEN
                  WRITE( MSG, 94140 ) 
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94500 ) LINNUM, INBUF
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94540 ) WORD
                  CALL M3MESG( MSG )
                  CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
               ELSE
                  OUTOP2( NIRROUT, TERMNUM ) = WORD
                  IF ( CHR .EQ. '[' ) THEN
                     CALL GETLABEL
                     OUTSPEC3( NIRROUT, TERMNUM ) = LABEL
                  ELSE
                     WRITE( MSG, 94100 ) 
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94500 ) LINNUM, INBUF
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94520 ) CHR
                     CALL M3MESG( MSG )
                     CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
                   END IF
                END IF
             END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Loss Term
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         ELSE IF ( WORD .EQ. 'LOSS' .OR. WORD .EQ. 'NETL' ) THEN
            OUTTYPE( NIRROUT, TERMNUM ) = WORD
            IF ( CHR .EQ. '[' ) THEN
               CALL GETLABEL
               OUTSPEC1( NIRROUT, TERMNUM ) = LABEL
            ELSE
               WRITE( MSG, 94100 ) 
               CALL M3MESG( MSG )
               WRITE( MSG, 94500 ) LINNUM, INBUF
               CALL M3MESG( MSG )
               WRITE( MSG, 94520 ) CHR
               CALL M3MESG( MSG )
               CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
            END IF

            OUTOP2(   NIRROUT, TERMNUM ) = ''
            OUTSPEC2( NIRROUT, TERMNUM ) = ''
            OUTSPEC3( NIRROUT, TERMNUM ) = ''

c..AND/OR operator 
            IF ( CHR .EQ. 'A' .OR. CHR .EQ. 'O' ) THEN
               CALL GETWORD
               IF ( WORD .NE. 'AND' .AND. WORD. NE. 'OR' ) THEN
                  WRITE( MSG, 94140 ) 
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94500 ) LINNUM, INBUF
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94540 ) WORD
                  CALL M3MESG( MSG )
                  CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
               ELSE
                  OUTOP2( NIRROUT, TERMNUM ) = WORD
                  IF ( CHR .EQ. '[' ) THEN
                     CALL GETLABEL
                     OUTSPEC3( NIRROUT, TERMNUM ) = LABEL
                  ELSE
                     WRITE( MSG, 94100 ) 
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94500 ) LINNUM, INBUF
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94520 ) CHR
                     CALL M3MESG( MSG )
                     CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
                  END IF
               END IF
            END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Net Term
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         ELSE IF ( WORD .EQ. 'NET' ) THEN
            OUTTYPE(  NIRROUT, TERMNUM ) = 'NET'
            OUTOP2(   NIRROUT, TERMNUM ) = ''
            OUTSPEC2( NIRROUT, TERMNUM ) = ''
            OUTSPEC3( NIRROUT, TERMNUM ) = ''
            IF ( CHR .EQ. '[' ) THEN
               CALL GETLABEL
               OUTSPEC1( NIRROUT, TERMNUM ) = LABEL
            ELSE
               WRITE( MSG, 94100 ) 
               CALL M3MESG( MSG )
               WRITE( MSG, 94500 ) LINNUM, INBUF
               CALL M3MESG( MSG )
               WRITE( MSG, 94520 ) CHR
               CALL M3MESG( MSG )
               CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
            END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  The term must be a predefined name
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         ELSE
            OUTTYPE(  NIRROUT, TERMNUM ) = 'NAME'            
            OUTSPEC1( NIRROUT, TERMNUM ) = WORD
            IF ( CHR .EQ. '[' ) THEN
               CALL GETLABEL
               IF ( LABEL .NE. 'POSONLY' .AND. LABEL .NE. 'NEGONLY' ) 
     &              THEN
                  WRITE( MSG, 94180 ) 
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94500 ) LINNUM, INBUF
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94540 ) LABEL
                  CALL M3MESG( MSG )
                  CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
               ELSE          
                  OUTPNFLAG( NIRROUT, TERMNUM ) = LABEL
               END IF
            END IF
         END IF
      END IF
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Go back and get the next operator, return, or err off
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( CHR .EQ. '+' .OR. CHR .EQ. '-' ) THEN
         GO TO 20
      ELSE IF ( CHR .EQ. ';' ) THEN
         NIRRTERMS( NIRROUT ) = TERMNUM
         CALL GETCHR
         RETURN
      ELSE
         WRITE( MSG, 94200 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETIRROUT', IZERO, IZERO, ' ', XSTAT2 )
      END IF            

C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( 'ERROR: Maximum number of IRR_OUTPUTs exceeded' )
94020 FORMAT( '       Modify PARAMETER ( MAXIRROUT =', I3,' ) or',
     &              '  decrease the number of IRR_OUTPUT requests' )
94040 FORMAT( 'ERROR: Equal sign expected after IRR_OUTPUT name' )
94060 FORMAT( 'ERROR: Maximum number of terms in an IRR_OUTPUT exceeded' )
94080 FORMAT( '       Modify PARAMETER ( MAXOUTTERMS =', I3,' ) or', 
     &              ' decrease the number of terms in IRR_OUTPUT' )

94100 FORMAT( 'ERROR: A [ must follow PROD/LOSS/NET operators or',
     &               ' FROM/AND/OR options' )
94120 FORMAT( 'ERROR: Only the FROM option can follow the PROD/NETP',
     &               ' operators' ) 
94140 FORMAT( 'ERROR: Only the AND/OR options can follow the FROM',
     &               ' option' )
94160 FORMAT( 'ERROR: Only the AND/OR options can follow the LOSS',
     &                              ' operator' )
94180 FORMAT( 'ERROR: Only POSONLY/NEGONLY options can follow defined',
     &                              ' names' )
94200 FORMAT( 'ERROR: Expecting a +, -, or ; after an IRR_OUTPUT term' ) 

94500 FORMAT( '       Line No. ', I4, ': ', A )
94520 FORMAT( '       Character found: ', A )
94540 FORMAT( '       Word found: ', A )

      END SUBROUTINE GETIRROUT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/arc/CCTM/src/vadv/wrf/vppm.F,v 1.5 2011/10/21 16:11:40 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#ifdef isam
      SUBROUTINE VPPM ( NI, DT, DS, FLX, VEL, CON, SA_CON  )
#elif sens
      SUBROUTINE VPPM ( NI, DT, DS, FLX, VEL, CON, SEN )
#else
      SUBROUTINE VPPM ( NI, DT, DS, FLX, VEL, CON )
#endif
      
C----------------------------------------------------------------------
C Function      
C   This is the one-dimensional implementation of piecewise parabolic
C   method.  Variable grid spacing is allowed. The scheme is positive
C   definite and monotonic. It is conservative, and causes small
C   numerical diffusion.
      
C   A piecewise continuous parabola is used as the intepolation polynomial.
C   The slope of the parabola at cell edges are computed from a cumulative
C   function of the advected quantity.  These slopes are further modified
C   so that the interpolation function is monotone. For more detailed
C   information see:
      
C   Colella, P., and P. L. Woodward, (1984), "The Piecewise Parabolic
C   Method (PPM) for Gas-Dynamical Simulations," J. Comput. Phys. 54,
C   174-201.
      
C   The concentrations at boundary cells (i.e., at 1 and NI) are not
C   computed here.  They should be updated according to the boundary
C   conditions.
      
C   The following definitions are used:
     
C              |---------------> Positive direction
C     
C  -->|Boundary|<----------------Main Grid----------------->|Boundary|<--
C     
C     |---><---|---><---|       ~|---><---|~       |---><---|---><---|
C       CON(0)   CON(1)            CON(i)            CON(n)  CON(n+1)
C     
C     VEL(1)<->|        VEL(i)<->|        |<->VEL(i+1)      |<->VEL(n+1)
C    
C      FP(0)-->|       FP(i-1)-->|        |-->FP(i)         |-->FP(n)
C     
C      FM(1)<--|         FM(i)<--|        |<--FM(i+1)       |<--FM(n+1)
C    
C                             -->| DS(i)  |<--
      
C----------------------------------------------------------------------
      
C Revision History:
      
C   20 April, 1993 by M. Talat Odman at NCSC: 
C   Created based on Colella and Woodward (1984)
      
C   15 Sept., 1993 by Daewon Byun at EPA:
C   Original code obtained from Phillip Colella at Berkeley
      
C   29 Nov.,  1993 by M. Talat Odman at NCSC:
C   Found no difference from original code
      
C   05 Oct.,  1993 by M. Talat Odman at NCSC:
C   Modified for EDSS archive, made discontinuity capturing an option
      
C   Sep 97 - Jeff
C   Aug 98 - Jeff - optimize for mesh coefficients

C   06/16/04 by Peter Percell & Daewon Byun at UH-IMAQS:
C     - Fixed bug in using fluxes in non-uniform grids to update concentrations

C   07 Dec 04 J.Young: vert dyn alloc - Use VGRD_DEFN
C   08 May 09 J.Young: dimension CON with species; eliminate "STEEPEN" option

C   18 Nov 09 J.Young: combine PPM velocity adjustment and vertically advected
C                      concentrations on one code
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   31 Jul 12 J.Bash: Changed the adjustment to VEL to be the square root
C                     of the flux*dt over the estimated flux*dt because
C                     the relationship between the flux and velocity is 
C                     roughly a second order polynomial and adjustments
C                     under conditions with CFL near 1 could result in 
C                     errors using a linear approximation. 
C   11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C----------------------------------------------------------------------
      
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
#ifdef isam
      USE SA_DEFN
#elif sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX
#endif

      IMPLICIT NONE
      
C Includes:
      
      INTEGER, SAVE :: N_SPC_ADV

C Arguments:
 
      INTEGER, INTENT(  IN )   :: NI          ! number of zones (cells)
      REAL,    INTENT(  IN )   :: DS ( NI )   ! distance between zone (cell) boundaries
      REAL,    INTENT(  IN )   :: FLX( NI+1 ) ! fluxes at zone (cell) boundaries
      REAL,    INTENT(  IN )   :: DT          ! time step
      REAL,    INTENT( INOUT ) :: VEL( NI+1 ) ! velocities at zone (cell) boundaries
      REAL,    INTENT( INOUT ) :: CON( :,: ) ! concs in a vertical column
#ifdef isam
Ckrt
      REAL,    INTENT( INOUT ) :: SA_CON( NI,N_SPCTAG )
#endif

!!! NOTE: Even tho' VEL is not used on output, declaring it as INTENT(IN) causes the
!!!       code to fail. ifort compiler error?
      
C Parameters:
      
      REAL, PARAMETER :: TWO3RDS = 2.0 / 3.0
      REAL, PARAMETER :: EPSF = 0.001
      
C Local variables:
      
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 120 ) :: XMSG = ' '

      REAL    :: FM ( 1:NI+1 ) ! outflux from left or bottom of cell
      REAL    :: FP ( 0:NI )   ! outflux from right or top of cell
      REAL    :: CR ( 1:NI )   ! zone R.H. intercept
      REAL    :: CL ( 1:NI )   ! zone L.H. intercept
      REAL    :: DC ( 1:NI )   ! CR - CL
      REAL    :: C6 ( 1:NI )   ! coefficient of second-order term
      REAL    :: CN ( 1:NI )   ! local con

      REAL X                   ! Courant number
      REAL Y                   ! removed zone slab
      REAL FDN, FUP            ! upstream donor cell versions of fm, fp
      INTEGER ICNT             ! no. of times fdn, fup exceeds fm, fp error range
      
      INTEGER I, S             ! loop index
      INTEGER, PARAMETER :: MAXCNT = 50

#ifdef sens
      REAL,    INTENT( INOUT ) :: SEN( :,:,: )
#endif

C----------------------------------------------------------------------
      
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         N_SPC_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV + 1 ! for advecting Rho_J
      END IF   ! FIRSTIME

      DO I = 1, NI
         CN( I ) = CON( I,N_SPC_ADV )   ! N_SPC_ADV is transported RhoJ index
      END DO

      CALL PPM ( NI, DT, DS, CN, CR, CL, DC, C6 )

c set all fluxes to zero. either positive or negative flux will
c remain zero depending on the sign of the velocity.

c fm: function for mass leaving interval i at lower face (i-1/2)
c = length of segment leaving * integral average concentration in that segment:
c   length of segment leaving = y = -v(i)dt
c   segment integral ave. conc. = cl(i) + 1/2[c6(i)+dc(i)]dx -1/3[c6(i)]dx**2
c fp: function for mass leaving interval i at upper face (i+1/2)
c = length of segment leaving * integral average concentration in that segment:
c   length of segment leaving = y = v(i+1)dt
c   segment integral ave. conc. = cr(i) + 1/2[c6(i)-dc(i)]dx -1/3[c6(i)]dx**2

      FM( 1:NI+1 ) = 0.0
      FP( 0:NI ) = 0.0     

      DO I = 1, NI
         IF ( VEL( I ) .LT. 0.0 ) THEN
            FDN = -FLX( I ) * DT
            ICNT = 0
66          CONTINUE
            Y = -VEL( I ) * DT
            X = Y / DS( I )
            FM( I ) = Y * ( CL( I ) + 0.5 * X
     &              * ( DC( I ) + C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            IF ( ABS( FM( I ) - FDN ) .GT. EPSF * FDN ) THEN
               VEL( I ) = VEL( I ) * SQRT( FDN / FM( I ) )
               ICNT = ICNT + 1
!              if ( vel( i ) .ge. 0.0 ) then
!                 write( *,2013 ) '@#@ icnt,i,fdn,fm,vel changed sign: ',
!    &                            icnt, i, fdn, fm( i ), vel( i )
2013              format( a, 2i4, 2( f15.5 ), 1pe15.3 )
!              end if
               IF ( ICNT .GT. MAXCNT ) THEN
                  XMSG = ' max iterations exceeded in vppm at 66'
                  CALL M3EXIT( 'VPPM', 0, 0, XMSG, XSTAT1 )                     
               END IF
               GO TO 66
            END IF
         END IF
         IF ( VEL( I+1 ) .GT. 0.0 ) THEN
            FUP = FLX( I+1 ) * DT
            ICNT = 0
77          CONTINUE
            Y = VEL( I+1 ) * DT
            X = Y / DS( I )
            FP( I ) = Y * ( CR( I ) - 0.5 * X
     &              * ( DC( I ) - C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            IF ( ABS( FP( I ) - FUP ) .GT. EPSF * FUP ) THEN
               VEL( I+1 ) = VEL( I+1 ) * SQRT( FUP / FP( I ) )
               ICNT = ICNT + 1
!              if ( vel( i+1 ) .le. 0.0 ) then
!                 write( *,2013 ) '@#@ icnt,i,fup,fp,vel changed sign: ',
!    &                            icnt, i, fdn, fm( i ), vel( i+1 )
!              end if
               IF ( ICNT .GT. MAXCNT ) THEN
                  XMSG = ' max iterations exceeded in vppm at 77'
                  CALL M3EXIT( 'VPPM', 0, 0, XMSG, XSTAT1 )                     
               END IF
               GO TO 77
            END IF
         END IF
      END DO

      DO 501 S = 1, N_SPC_ADV

         DO I = 1, NI
            CN( I ) = CON( I,S )
         END DO

         CALL PPM ( NI, DT, DS, CN, CR, CL, DC, C6 )

         FM( 1:NI+1 ) = 0.0
         FP( 0:NI ) = 0.0

         DO I = 1, NI

            IF ( VEL( I ) .LT. 0.0 ) THEN
               Y = -VEL( I ) * DT
               X = Y / DS( I )
               FM( I ) = Y * ( CL( I ) + 0.5 * X
     &                 * ( DC( I ) + C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF

            IF ( VEL( I+1 ) .GT. 0.0 ) THEN
               Y = VEL( I+1 ) * DT
               X = Y / DS( I )
               FP( I ) = Y * ( CR( I ) - 0.5 * X
     &                 * ( DC( I ) - C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF

         END DO

c compute fluxes for top face

         I = NI+1
         IF ( VEL( I ) .LT. 0.0 ) THEN
            Y = -VEL( I ) * DT
            FM( I ) = Y * CON( I-1,S )
         END IF

         DO I = 1, NI
            CON( I,S ) = CON( I,S )
     &               + ( FP( I-1 ) - FP( I ) + FM( I+1 ) - FM( I ) ) / DS( I )
         END DO

501   CONTINUE

#ifdef isam
Ckrt Back up the SA_CON.....
      DO 602 S = 1, N_SPCTAG

         DO I = 1, NI
            CN( I ) = SA_CON( I,S )
         END DO

         CALL PPM ( NI, DT, DS, CN, CR, CL, DC, C6 )

         FM( 1:NI+1 ) = 0.0
         FP( 0:NI ) = 0.0

         DO I = 1, NI

            IF ( VEL( I ) .LT. 0.0 ) THEN
               Y = -VEL( I ) * DT
               X = Y / DS( I )
               FM( I ) = Y * ( CL( I ) + 0.5 * X
     &                 * ( DC( I ) + C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF ! vel < 0 ?

            IF ( VEL( I+1 ) .GT. 0.0 ) THEN
               Y = VEL( I+1 ) * DT
               X = Y / DS( I )
               FP( I ) = Y * ( CR( I ) - 0.5 * X
     &                 * ( DC( I ) - C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF ! vel > 0 ?

         END DO ! loop I

c compute fluxes for top face

         I = NI+1
         IF ( VEL( I ) .LT. 0.0 ) THEN
            Y = -VEL( I ) * DT
            FM( I ) = Y * SA_CON( I-1,S )
         END IF

Ckrt... Advect the apportioning tags ......
         DO I = 1, NI
            SA_CON( I,S ) = SA_CON( I,S )
     &              + ( FP( I-1 ) - FP( I ) + FM( I+1 ) - FM( I ) ) / DS( I )
         END DO

602   CONTINUE
#endif

#ifdef sens
      DO NP = 1, NPMAX

         DO 701 S = 1, N_SPC_ADV

            DO I = 1, NI
               CN( I ) = SEN( I,S,NP )
            END DO

            CALL PPM ( NI, DT, DS, CN, CR, CL, DC, C6 )

            FM( 1:NI+1 ) = 0.0
            FP( 0:NI ) = 0.0

            DO I = 1, NI

               IF ( VEL( I ) .LT. 0.0 ) THEN
                  Y = -VEL( I ) * DT
                  X = Y / DS( I )
                  FM( I ) = Y * ( CL( I ) + 0.5 * X
     &                    * ( DC( I ) + C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
               END IF

               IF ( VEL( I+1 ) .GT. 0.0 ) THEN
                  Y = VEL( I+1 ) * DT
                  X = Y / DS( I )
                  FP( I ) = Y * ( CR( I ) - 0.5 * X
     &                    * ( DC( I ) - C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
               END IF

            END DO

c compute fluxes for top face

            I = NI+1
            IF ( VEL( I ) .LT. 0.0 ) THEN
               Y = -VEL( I ) * DT
               FM( I ) = Y * SEN ( I-1,S,NP )
            END IF

            DO I = 1, NI
               SEN( I,S,NP ) = SEN( I,S,NP )
     &                       + ( FP( I-1 ) - FP( I ) + FM( I+1 ) - FM( I ) ) / DS( I )
            END DO

701      CONTINUE

      END DO
#endif



      RETURN
      END SUBROUTINE VPPM

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PPM ( NI, DT, DS, CN, CR, CL, DC, C6 )

C get ppm coefficients CR, CL, DC, and C6

      USE UTILIO_DEFN

      IMPLICIT NONE

C arguments:

      INTEGER, INTENT(    IN ) :: NI       ! number of zones (cells)
      REAL,    INTENT(    IN ) :: DT       ! time step
      REAL,    INTENT(    IN ) :: DS( NI ) ! distance between zone (cell) boundaries
      REAL,    INTENT(    IN ) :: CN( NI ) ! concentrations in a vertical column
      REAL,    INTENT( INOUT ) :: CR( NI ) ! zone r.h. intercept
      REAL,    INTENT( INOUT ) :: CL( NI ) ! zone l.h. intercept
      REAL,    INTENT( INOUT ) :: DC( NI ) ! CR - CL
      REAL,    INTENT( INOUT ) :: C6( NI ) ! coefficient of second-order term

C local variables:

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      INTEGER ALLOCSTAT
      CHARACTER( 120 ) :: XMSG = ' '

      REAL A, B, C              ! temp lattice vars.

      REAL, ALLOCATABLE, SAVE :: ALPHA ( : )  ! temp lattice var.
      REAL,              SAVE :: BETA
      REAL, ALLOCATABLE, SAVE :: CHI   ( : )  ! lattice var. for dc
      REAL, ALLOCATABLE, SAVE :: PSI   ( : )  ! lattice var. for dc
      REAL, ALLOCATABLE, SAVE :: MU    ( : )  ! lattice var. for cm
      REAL, ALLOCATABLE, SAVE :: NU    ( : )  ! lattice var. for cm
      REAL, ALLOCATABLE, SAVE :: LAMBDA( : )  ! lattice var. for cm
      REAL, ALLOCATABLE, SAVE :: CM    ( : )  ! zone r.h. trial intercept

      INTEGER I

C----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         ALLOCATE ( ALPHA ( 2:NI-1 ),
     &              CHI   ( 2:NI-1 ),
     &              PSI   ( 2:NI-1 ),
     &              MU    ( 2:NI-2 ),
     &              NU    ( 2:NI-2 ),
     &              LAMBDA( 2:NI-2 ),
     &              CM    ( 1:NI+1 ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating '
     &           // 'ALPHA, MU, NU, LAMBDA, CHI, PSI, OR CM'
            CALL M3EXIT( 'VPPM', 0, 0, XMSG, XSTAT1 )
         END IF

         DO I = 2, NI-1
            ALPHA( I ) = DS( I ) + DS( I+1 )
            BETA = DS( I-1 ) + DS( I )
            C = DS( I ) / ( BETA + DS( I+1 ) )
            CHI( I ) = C * ( DS( I-1 ) + BETA ) / ALPHA( I )
            PSI( I ) = C * ( ALPHA( I ) + DS( I+1 ) ) / BETA
         END DO
         DO I = 2, NI-2
            A = DS( I ) / ALPHA( I )
            B = 2.0 * DS( I+1 ) / ALPHA( I )
            C = 1.0 / ( DS( I-1 ) + ALPHA( I ) + DS( I+2 ) )
            MU( I ) = C * DS( I )
     &              * ( DS( I-1 ) + DS( I ) )   / ( DS( I )   + ALPHA( I ) )
            NU( I ) = C * DS( I+1 )
     &              * ( DS( I+1 ) + DS( I+2 ) ) / ( DS( I+1 ) + ALPHA( I ) )
            LAMBDA( I ) = A + MU( I ) * B - 2.0 * NU( I ) * A
         END DO

      END IF   ! FIRSTIME

C zeroth order polynomial at the boundary cells
C first order polynomial at the next cells, no monotonicity constraint needed

      CM( 1 )    = CN( 1 )
      CM( 2 )    = ( DS( 1 ) * CN( 2 ) + DS( 2 ) * CN( 1 ) )
     &           / ( DS( 1 ) + DS( 2 ) )
      CM( NI+1 ) = CN( NI )
      CM( NI )   = ( DS( NI-1 ) * CN( NI ) + DS( NI ) * CN( NI-1 ) )
     &           / ( DS( NI-1 ) + DS( NI ) )

C second order polynomial inside the domain

      DO 101 I = 2, NI-1

C compute average slope in zone i

      DC( I ) = CHI( I ) * ( CN( I+1 ) - CN( I ) )
     &        + PSI( I ) * ( CN( I )   - CN( I-1 ) )      ! equation (1.7)

C guarantee that cm lies between con(i) and con(i+1) - monotonicity constraint

         IF ( ( CN( I+1 ) - CN( I ) ) * ( CN( I ) - CN( I-1 ) ) .GT. 0.0 ) THEN
            DC( I ) = SIGN( 1.0, DC( I ) ) * MIN(
     &                                      ABS( DC( I ) ),
     &                                2.0 * ABS( CN( I+1 ) - CN( I ) ),
     &                                2.0 * ABS( CN( I ) - CN( I-1 ) ) )
         ELSE
            DC( I ) = 0.0
         END IF                                    ! equation (1.8)

101   CONTINUE

      DO I = 2, NI-2                                ! equation (1.6)
         CM( I+1 ) = CN( I ) + LAMBDA( I ) * ( CN( I+1 ) - CN( I ) )
     &             - MU( I ) * DC( I+1 ) + NU( I ) * DC( I )
      END DO

C generate piecewise parabolic distributions

      DO 301 I = 1, NI

         CR( I ) = CM( I+1 )         ! equation (1.15)
         CL( I ) = CM( I )

C monotonicity

         IF ( ( CR( I ) - CN( I ) ) * ( CN( I ) - CL( I ) ) .GT. 0.0 ) THEN

            DC( I ) = CR( I ) - CL( I )  ! temporary computation of dc and c6
            C6( I ) = 6.0 * ( CN( I ) - 0.5 * ( CL( I ) + CR( I ) ) )

C overshoot cases

            IF ( DC( I ) * C6( I ) .GT. DC( I ) * DC( I ) ) THEN
               CL( I ) = 3.0 * CN( I ) - 2.0 * CR( I )
            ELSE IF ( -DC( I ) * DC( I ) .GT. DC( I ) * C6( I ) ) THEN
               CR( I ) = 3.0 * CN( I ) - 2.0 * CL( I )
            END IF

         ELSE     ! local extremum: interpolation function is set to be a constant
            CL( I ) = CN( I )
            CR( I ) = CN( I )

         END IF

         DC( I ) = CR( I ) - CL( I )      ! EQUATION (1.5)
         C6( I ) = 6.0 * ( CN( I ) - 0.5 * ( CL( I ) + CR( I ) ) )

301   CONTINUE

      RETURN
      END SUBROUTINE PPM

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SCIPROC ( CGRID, JDATE, JTIME, TSTEP, ASTEP )

C-----------------------------------------------------------------------
C Function:
C    Controls all of the physical and chemical processes for a grid
C    Operator splitting symmetric around chemistry
 
C Preconditions:
C    Dates and times represented YYYYDDD:HHMMSS.
C    No "skipped" dates and times.  All boundary input variables (layered or
C    non-layered) have the same perimeter structure with a thickness of NTHIK
 
C Subroutines and functions called:
C    All physical and chemical subroutines, 
C    DECOUPLE, COUPLE
 
C Revision History:
C    Oct. 24, 1995 by M. Talat Odman and Clint L. Ingram at NCSC: created
C    13 Dec 97 - Jeff - uncouple diffusion processes
C    27 Jun 98 - Jeff - sync step = chem step
C     7 Jul 01 - Shawn - mv cloud processing before chem
C       Jan 02 - Jeff - dyn alloc; remove PCGRID argument to ping
C    23 Jun 03 J.Young: for layer dependent advection tstep
C    18 Aug 03 J. Pleim - move vdiff before advection
C    29 Aug 03 J.Young: eliminate symmetric processing option and unused
C                       SUBST_GRID_ID string
C    30 May 05 J.Young: mass-conserving advection (yamo)
C     7 Jul 07 J.Young: No cksummer call after HADV - delay possible truncation of
C                       HADV negative conc's until after ZADV
C    25 Jul 08 S.Roselle: removed PING from modeled processes
C    16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C    11 May 11 D.Wong: incorporated twoway model implementation
C    25 Mar 16 R.Mathur: incorporated pot. vorticity strat. O3 scaling
C    16 Sep 16 J.Young: update for inline procan (IPR)
C    10 July 19 F. Sidi: Renamed Couple_WRF to be couple
C-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE RUNTIME_VARS, ONLY: LOGDEV, OUTDEV, MYPE, CKSUM, 
     &                        PRINT_PROC_TIME, WEEKDAY, 
     &                        LOG_MESSAGE, TIMING_SPLIT, STM,
     &                        COLUMN_MODEL, LPVO3
#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
      USE PA_UPDATE
#endif
      USE PA_DEFN, Only: LIPR, IPR_VDIF, IPR_ZADV, IPR_HDIF, IPR_CLDS, 
     &                   IPR_CHEM, IPR_PVO3,
     &                   BUDGET_DIAG ! Process Analysis control and data variables
#ifdef isam
      USE SA_DEFN, Only: ISAM
      USE GRID_CONF
      USE CGRID_SPCS, ONLY: NSPCSD
#endif

      USE STM_MODULE, ONLY: STM_WRAP_GAS, STM_WRAP_AE

      IMPLICIT NONE   

#ifdef parallel
      INCLUDE 'mpif.h'
#endif
C Arguments:
      REAL, POINTER :: CGRID( :,:,:,: )

      INTEGER, INTENT(INOUT) :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT(INOUT) :: JTIME        ! current model time, coded HHMMSS
      INTEGER, INTENT(IN)    :: TSTEP( 3 )   ! time step vector (HHMMSS)
                                             ! TSTEP(1) = local output step
                                             ! TSTEP(2) = sciproc sync. step (chem)
                                             ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                             !            step and wrf/cmaq call frequency

      INTEGER, INTENT(IN)    :: ASTEP( : )   ! layer advection time step

C Local Variables:

      CHARACTER( 16 ) :: PNAME = 'SCIPROC'
      CHARACTER( 120 ) :: XMSG = ' '
      CHARACTER( 36 ) :: NMSG = 'After NEXTIME: returned JDATE, JTIME'

      INTEGER         ::     SDATE       ! current science process date, coded YYYYDDD
      INTEGER         ::     STIME       ! current science process time, coded HHMMSS
 
      REAL            :: REAL_TIME

      REAL( 8 )       :: CPU_TIME_START  ! Timing individual
      REAL( 8 )       :: CPU_TIME_START_MASTER
      CHARACTER( 24 ) :: CDATE_TIME

#ifdef isam
      REAL, ALLOCATABLE, SAVE :: CGRID0( :,:,:,: )
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
#endif
      INTERFACE
         SUBROUTINE CKSUMMER ( PNAME, CGRID, JDATE, JTIME )
            CHARACTER( * ), INTENT( IN ) :: PNAME
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
         END SUBROUTINE CKSUMMER
#ifndef mpas
         SUBROUTINE HADV ( CGRID, JDATE, JTIME, TSTEP, ASTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
            INTEGER, INTENT( IN )     :: ASTEP( : )
         END SUBROUTINE HADV
         SUBROUTINE ZADV ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE ZADV
         SUBROUTINE COUPLE ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE COUPLE
         SUBROUTINE DECOUPLE ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE DECOUPLE
         SUBROUTINE HDIFF ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE HDIFF
#endif
         SUBROUTINE VDIFF ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE VDIFF
         SUBROUTINE PHOT ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( : )
         END SUBROUTINE PHOT
         SUBROUTINE CLDPROC ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE CLDPROC
         SUBROUTINE CHEM ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE CHEM
         SUBROUTINE PVO3 ( CGRID, JDATE, JTIME )
            IMPLICIT NONE
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
         END SUBROUTINE PVO3
         SUBROUTINE AERO ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE AERO
#ifdef isam
         SUBROUTINE SA_WRAP_AE( CGRID0, CGRID, JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            REAL                      :: CGRID0( :,:,:,: )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE
            INTEGER, INTENT( IN )     :: JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE SA_WRAP_AE
#endif
      END INTERFACE
  
C-----------------------------------------------------------------------
#ifdef isam
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         ALLOCATE( CGRID0( NCOLS,NROWS,NLAYS,NSPCSD ) )
      END IF
#endif

      ! Calculate and Write Time Step Information to Summary Logfile
      IF ( MYPE .EQ. 0 ) WRITE( OUTDEV, * ) 
      WRITE( LOGDEV, * )

#ifdef parallel
      CPU_TIME_START =  MPI_WTIME()
#else
      CALL CPU_TIME( REAL_TIME )
      CPU_TIME_START = REAL( REAL_TIME,8 )
#endif
      CPU_TIME_START_MASTER = CPU_TIME_START
      WRITE( XMSG, '(A,I7.7,A,I6.6)' ), 'Processing Day/Time [YYYYDDD:HHMMSS]: ',JDATE, 
     &       ':',JTIME
      IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
      CALL LOG_MESSAGE( LOGDEV, XMSG )

      CDATE_TIME = DT2STR( JDATE, JTIME )
      WRITE( XMSG, '(2x,6A)' ), 'Which is Equivalent to (UTC): ',
     &       CDATE_TIME(1:8),' ',TRIM( WEEKDAY( WKDAY( JDATE ) ) ),
     &       ',', CDATE_TIME(9:)
      IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
      CALL LOG_MESSAGE( LOGDEV, XMSG )

      WRITE( XMSG, '(2x,A,I6.6)' ), 'Time-Step Length (HHMMSS): ',TSTEP(2) 
      IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
      CALL LOG_MESSAGE( LOGDEV, XMSG )

      ! Calculate Vertical Diffusion, Dry Deposition, and Emissions
      CALL VDIFF ( CGRID, JDATE, JTIME, TSTEP )
      IF ( CKSUM ) CALL CKSUMMER ( 'VDIFF', CGRID, JDATE, JTIME )
#ifndef mpas
      IF ( BUDGET_DIAG .OR. LIPR ) CALL PA_UPDATE_PROC ( IPR_VDIF, CGRID, JDATE, JTIME, TSTEP, .FALSE. )
#endif
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'VDIFF' )

      ! Save time at end of the current time-step in SDATE and STIME
      SDATE = JDATE
      STIME = JTIME
      CALL NEXTIME ( SDATE, STIME, TSTEP( 2 ) )

      IF ( .NOT. COLUMN_MODEL ) THEN
         ! Calculate Horizontal Transport
         ! couple CGRID for advection and horizontal diffusion
         ! The COUPLE routine converts aerosol mass from ug/m3 to kg/m3. The 
         ! DECOUPLE routine converts it back to ug/m3.

#ifndef mpas
         CALL COUPLE ( CGRID, JDATE, JTIME, TSTEP )
         IF ( CKSUM ) CALL CKSUMMER ( 'COUPLE', CGRID, JDATE, JTIME )
         IF ( BUDGET_DIAG .OR. LIPR ) CALL PA_UPDATE_PROC ( IPR_ZADV, CGRID, JDATE, JTIME, TSTEP, .TRUE. )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'COUPLE' )

         CALL SUBST_BARRIER()
         CALL HADV ( CGRID, JDATE, JTIME, TSTEP, ASTEP )
         IF ( CKSUM ) CALL CKSUMMER ( 'HADV', CGRID, JDATE, JTIME )
         IF ( BUDGET_DIAG .OR. LIPR ) CALL PA_UPDATE_HADV ( CGRID, JDATE, JTIME, TSTEP )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'HADV' )
         
         CALL ZADV ( CGRID, JDATE, JTIME, TSTEP )
         IF ( CKSUM ) CALL CKSUMMER ( 'ADV', CGRID, JDATE, JTIME )
         IF ( BUDGET_DIAG .OR. LIPR ) CALL PA_UPDATE_PROC ( IPR_ZADV, CGRID, JDATE, JTIME, TSTEP, .TRUE. )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'ZADV' )
         
         CALL HDIFF ( CGRID, JDATE, JTIME, TSTEP )
         IF ( CKSUM ) CALL CKSUMMER ( 'HDIFF', CGRID, JDATE, JTIME )
         IF ( BUDGET_DIAG .OR. LIPR ) CALL PA_UPDATE_PROC ( IPR_HDIF, CGRID, JDATE, JTIME, TSTEP, .TRUE. )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'HDIFF' )
#endif

#ifndef mpas
         ! Decouple CGRID for cloud and chemistry corresponding to conditions
         ! at the end of the time step (i.e. SDATE, STIME)
         CALL DECOUPLE ( CGRID, SDATE, STIME, TSTEP )
         IF ( CKSUM ) CALL CKSUMMER ( 'DECOUPLE', CGRID, JDATE, JTIME )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'DECOUPLE' )
         IF ( BUDGET_DIAG .OR. LIPR ) CALL PA_UPDATE_PROC ( IPR_ZADV, CGRID, SDATE, STIME, TSTEP, .FALSE. )
#endif

      END IF ! Not Column Model
      
      ! Calculate Photolysis Rates
      CALL PHOT ( CGRID, JDATE, JTIME, TSTEP )
      IF ( CKSUM ) CALL CKSUMMER ( 'PHOT', CGRID, JDATE, JTIME )
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'PHOT' )

      ! Calculate Cloud Scavening and Chemistry
      CALL CLDPROC ( CGRID, JDATE, JTIME, TSTEP )
      IF ( CKSUM ) CALL CKSUMMER ( 'CLDPROC', CGRID, JDATE, JTIME )
#ifndef mpas
      IF ( BUDGET_DIAG .OR. LIPR ) CALL PA_UPDATE_PROC ( IPR_CLDS, CGRID, SDATE, STIME, TSTEP, .FALSE. )
#endif
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'CLDPROC' )

      ! Calculate Gas- and Particle-Phase Chemistry
      IF ( STM ) CALL STM_WRAP_GAS ( CGRID, JDATE, JTIME, .TRUE. )
      CALL CHEM ( CGRID, JDATE, JTIME, TSTEP )
      IF ( CKSUM ) CALL CKSUMMER ( 'CHEM', CGRID, JDATE, JTIME )
#ifndef mpas
      IF ( BUDGET_DIAG .OR. LIPR ) CALL PA_UPDATE_PROC ( IPR_CHEM, CGRID, SDATE, STIME, TSTEP, .FALSE. ) 
#endif
      IF ( STM ) CALL STM_WRAP_GAS ( CGRID, JDATE, JTIME, .FALSE. )
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'CHEM' )

      IF ( LPVO3 ) THEN
         CALL PVO3 ( CGRID, JDATE, JTIME )
         IF ( CKSUM ) CALL CKSUMMER ( 'PVO3', CGRID, JDATE, JTIME )
#ifndef mpas
         IF ( BUDGET_DIAG .OR. LIPR ) CALL PA_UPDATE_PROC ( IPR_PVO3, CGRID, SDATE, STIME, TSTEP, .FALSE. )
#endif
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'PVO3' )
      END IF

#ifdef isam
      ! Save ISAM concentration field to use for apportioning
      ! aerosols and semivolatile gases after AERO is called
      CGRID0  = CGRID
#endif

      ! Calculate Aerosol Microphysics
      CALL AERO ( CGRID, JDATE, JTIME, TSTEP )
#ifdef isam
      CALL SA_WRAP_AE( CGRID0, CGRID, JDATE, JTIME, TSTEP )
#endif
      IF ( CKSUM ) CALL CKSUMMER ( 'AERO', CGRID, JDATE, JTIME )
      IF ( STM ) CALL STM_WRAP_AE ( CGRID, JDATE, JTIME )
#ifndef mpas
      IF ( BUDGET_DIAG .OR. LIPR ) CALL PA_UPDATE_AERO ( CGRID, SDATE, STIME )
#endif
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'AERO' )

      ! Advance Time Step
      CALL NEXTIME ( JDATE, JTIME, TSTEP( 2 ) )
      WRITE( LOGDEV,'(/ 5X, A, I8, I7.6)' ) NMSG, JDATE, JTIME

      ! Print Summary Timing for Master time step      
      CALL TIMING_SPLIT ( CPU_TIME_START_MASTER, 2 )

1002  FORMAT ( 2x, A15, ' completed... ', F6.1, ' seconds' )

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HCDIFF3D ( JDATE, JTIME, K11BAR, K22BAR, DT )
      
C-----------------------------------------------------------------------
C Function:
C   Computes the contravariant diffusivities in x1 or x2 directions
C   using a constant physical horizontal diffusivity.
      
C Preconditions:
C   This routine can only be used for conformal map coordinates 
C   in the horizontal.
C   Dates and times should be represented YYYYDDD:HHMMSS.
 
C Subroutines and functions called:
C   INTERP3, M3EXIT, DEFORM 
 
C Revision history:
C   October 17, 1995 by M. Talat Odman and Clint L. Ingram at NCSC:
C   created for SAQM-type coordinates
      
C    5 Nov 97 Jeff targetted

C    Sep. 1998 David Wong
C      -- parallelize the code
C      -- use GLOBAL_MAX to compute the global max

C    1/19/99 David Wong
C      -- add a loop_index call
C      -- change loop index ending point to avoid accessing invalid region.
C         (reason to do this is to prevent using boundary data from PINTERP,
C          which sets pseudo-boundary data to 0)

C    Jul. 8 1999 David Wong
C      -- replace GLOBAL_MAX with GLOBAL_RMAX for naming consistency
C
C    10/10/2000 Daewon Byun
C      -- generalized 3d horizontal diffusivity

C    23 Dec 00 J.Young: GLOBAL_RMAX -> Dave Wong's f90 stenex GLOBAL_MAX
C                       PE_COMM3 -> Dave Wong's f90 stenex COMM

C    6 Aug 01 J.Young: Use HGRD_DEFN; replace INTERP3 with INTERPX;
C                      allocatable arrays
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S. Roselle: replaced I/O-API include files w/UTILIO_DEFN
C   03 Aug 11 David Wong: moved DT calculation outside the loop for efficency
C                         purposes
C   01 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C-----------------------------------------------------------------------
      
      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
      USE CENTRALIZED_IO_MODULE
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_GLOBAL_MAX_MODULE, SE_COMM_MODULE,
                                !               SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_GLOBAL_MAX_MODULE, NOOP_COMM_MODULE,
                                !               NOOP_UTIL_MODULE)
#endif
      USE CONST, only: DG2M, PI180

      IMPLICIT NONE
      
C Includes:
      
      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction

C Arguments:
      
      INTEGER, INTENT( IN )  :: JDATE  ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )  :: JTIME  ! current model time, coded HHMMSS
                                       ! Contravariant diffusivity
!     REAL         K11BAR3D( NCOLS+1,NROWS+1,NLAYS ) ! x1-flux points
!     REAL         K22BAR3D( NCOLS+1,NROWS+1,NLAYS ) ! x2-flux points
      REAL,    INTENT( OUT ) :: K11BAR( :,:,: ) ! x1-flux points
      REAL,    INTENT( OUT ) :: K22BAR( :,:,: ) ! x2-flux points
      REAL,    INTENT( OUT ) :: DT              ! diffusivity time step
 
C Parameters:
 
C Horizontal eddy diffusivity (m^2/s) 
!     REAL, PARAMETER :: KH = 3.3E+04 ! From Brost et al., J.Geophys.Res., 1988
!     REAL, PARAMETER :: KH = 50.0    ! For 12 km SARMAP simulation as per SAQM
      REAL, PARAMETER :: KH = 2000.0  ! For  4 km SARMAP simulation as per SAQM

      REAL, PARAMETER :: KHMIN = 200.0 ! For min KH assigned for deformation
      REAL, PARAMETER :: DXB = 4000.0
      REAL, PARAMETER :: ALP = 0.28

C "Courant" factor = 99%(1/sqrt(2))
!     REAL, PARAMETER :: CFC = 0.700
      REAL, PARAMETER :: CFC = 0.300
      
C local variables:
      
      CHARACTER( 16 ) :: PNAME = 'HCDIFF3D'
      CHARACTER( 96 ) :: XMSG = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      INTEGER, SAVE :: MLAYS
 
      REAL, SAVE :: DX1, DX2            ! CX x1- and x2-cell widths
      REAL, SAVE :: KHA                 ! resolution-adjusted base diffusivity
      REAL, SAVE :: ACOEF               ! ALP**2 * DX1 * DX2
      REAL         KHD                 ! Deformation induced KH
      REAL         DEFORM3D( NCOLS+1,NROWS+1,NLAYS ) ! wind deformation

      REAL         EDDYH3D ( NCOLS+1,NROWS+1,NLAYS ) ! Contra. diffusivity

      REAL         EFFKB               ! Effective Kbar
!     REAL         EKHMAX              ! max Contra. diffusivity (diagnos)
!     REAL         MS2MAX              ! max squared map scale factor (diagnos)
 
      INTEGER      ALLOCSTAT
      INTEGER      COL, ROW, LVL       ! column,row,level indices

      INTEGER MY_TEMP
      INTEGER, SAVE :: STARTROW, ENDROW
      INTEGER, SAVE :: STARTCOL, ENDCOL
 
      INTERFACE
         SUBROUTINE DEFORM( JDATE, JTIME, DEFORM3D )
            INTEGER, INTENT( IN )  :: JDATE, JTIME
            REAL,    INTENT( OUT ) :: DEFORM3D( :,:,: )
         END SUBROUTINE DEFORM
      END INTERFACE

C-----------------------------------------------------------------------
      
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         MLAYS = SIZE ( K11BAR,3 )
 
         CALL SUBST_LOOP_INDEX ( 'R', 1, NROWS, 1, MY_TEMP, STARTROW, ENDROW )

         CALL SUBST_LOOP_INDEX ( 'C', 1, NCOLS, 1, MY_TEMP, STARTCOL, ENDCOL )

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD ! in m.
            DX2 = DG2M * YCELL_GD
     &        * COS( PI180*( YORIG_GD + YCELL_GD * FLOAT( GL_NROWS/2 ))) ! in m.
            ELSE
            DX1 = XCELL_GD        ! in m.
            DX2 = YCELL_GD        ! in m.
            END IF

C Get map scale factor

         KHA = ( DXB * DXB ) / ( DX1 * DX2 ) * KH 

         ACOEF = ALP * ALP * ( DX1 * DX2 )

         END IF                    ! if firstime
 
C get wind deformation 
 
      CALL DEFORM ( JDATE, JTIME, DEFORM3D )

      EDDYH3D = 0.0

      DO LVL = 1, MLAYS
!        EKHMAX = 0.0
         DO ROW = STARTROW, ENDROW      !   DO ROW = 1, NROWS+1
            DO COL = STARTCOL, ENDCOL   !       DO COL = 1, NCOLS+1
!              EDDYH3D( COL,ROW,LVL ) = MSFD2( COL,ROW ) *  
!    &               ( ACOEF * KHA * DEFORM3D( COL,ROW,LVL ) 
!    &              / ( KHA + ACOEF * DEFORM3D( COL,ROW,LVL ) ) 
!    &              + KHMIN )
! Daewon prefers the following
               KHD = MAX( KHMIN, ACOEF * DEFORM3D( COL,ROW,LVL ) )
               EDDYH3D( COL,ROW,LVL ) = MSFD2( COL,ROW )
     &                                * KHA * KHD / ( KHA + KHD )
!              EKHMAX = MAX( EKHMAX, EDDYH3D( COL,ROW,LVL ) )
            END DO
         END DO
      END DO

      CALL SUBST_COMM ( EDDYH3D, DSPL_N1_E1_S0_W0, DRCN_N_E )

C Obtain flux average values of contravariant diffusivities

      EFFKB = 0.0
      DO LVL = 1, MLAYS
         DO ROW = 1, NROWS + 1
            DO COL = 1, NCOLS + 1
               K11BAR( COL,ROW,LVL ) = 0.0
               K22BAR( COL,ROW,LVL ) = 0.0
               END DO
             END DO
          END DO

1003  FORMAT( / '@2@Layer', 5X, 'Time Step', 9X, 'EffKB' )

      DO LVL = 1, MLAYS
         DO ROW = 1, NROWS
            DO COL = STARTCOL, ENDCOL
               K11BAR( COL,ROW,LVL ) = 0.5 * ( EDDYH3D( COL,ROW+1,LVL )
     &                               +         EDDYH3D( COL,ROW,LVL ) )
               END DO
            END DO
         DO COL = STARTCOL, ENDCOL
            K11BAR( COL,NROWS+1,LVL ) = 0.0
            END DO

         DO ROW = STARTROW, ENDROW
            DO COL = 1, NCOLS
               K22BAR( COL,ROW,LVL ) = 0.5 * ( EDDYH3D( COL,ROW,LVL )
     &                               +         EDDYH3D( COL+1,ROW,LVL ) )
              END DO
            END DO
         DO ROW = STARTROW, ENDROW
            K22BAR( NCOLS+1,ROW,LVL ) = 0.0
            END DO

         DO ROW = 1, NROWS
            DO COL = 1, NCOLS
               EFFKB =  MAX ( EFFKB, 
     &                        K11BAR( COL,ROW,LVL ),
     &                        K22BAR( COL,ROW,LVL ) )
               END DO
            END DO

!        DT = CFC * DX1 * DX2 / SUBST_GLOBAL_MAX ( EFFKB )

1005     FORMAT( '@2@ ', I3, 1X, F18.7, 1X, F12.7 )

         END DO ! for LVL

      DT = CFC * DX1 * DX2 / SUBST_GLOBAL_MAX ( EFFKB )

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CGRID_DEPV( GAS_DEPV_FOUND, GAS_DEPV_SUR, CGRID, CGRIDL1 )

C-----------------------------------------------------------------------
C Return layer one CGRID concentrations for the gas depv species with species
C first in the dimensions order - called by GET_DEPV [DEPV_DEFN module] to
C use for bi-directional flux calculations in m3dry
C Revision History:
C   Jeff Young 11 Jan 07: created
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C   1 Feb 19 David Wong: removed MY_N clauses
C-----------------------------------------------------------------------

      USE CGRID_SPCS            ! CGRID mechanism species
      USE HGRD_DEFN             ! horizontal domain specifications
      USE UTILIO_DEFN

C Arguments:

      LOGICAL, INTENT( IN )  :: GAS_DEPV_FOUND( : )
      INTEGER, INTENT( IN )  :: GAS_DEPV_SUR( : )
      REAL,    POINTER       :: CGRID( :,:,:,: )
      REAL,    INTENT( OUT ) :: CGRIDL1( :,:,: )

C Local Variables:

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

       INTEGER C, R, S, N, V, NDX, STRT

C-----------------------------------------------------------------------
      IF ( FIRSTIME )  THEN
         FIRSTIME  =  .FALSE.
      END IF

      N = 0
      STRT = 0
      DO V = 1, N_GC_DEPV
         N = N + 1
         IF ( GAS_DEPV_FOUND( N ) ) THEN
            NDX = GAS_DEPV_SUR( N )
            S = STRT + GC_DEPV_MAP( V )
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  CGRIDL1( NDX,C,R ) = CGRID( C,R,1,S )
               END DO
            END DO
         END IF
      END DO

      STRT = N_GC_SPC + 1 + N_AE_SPC  ! +1 for RHOJ
      DO V = 1, N_NR_DEPV
         N = N + 1
         IF ( GAS_DEPV_FOUND( N ) ) THEN
            NDX = GAS_DEPV_SUR( N )
            S = STRT + NR_DEPV_MAP( V )
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  CGRIDL1( NDX,C,R ) = CGRID( C,R,1,S )
               END DO
            END DO
         END IF
      END DO

      STRT = N_GC_SPC + 1 + N_AE_SPC + N_NR_SPC
      DO V = 1, N_TR_DEPV
         N = N + 1
         IF ( GAS_DEPV_FOUND( N ) ) THEN
            NDX = GAS_DEPV_SUR( N )
            S = STRT + TR_DEPV_MAP( V )
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  CGRIDL1( NDX,C,R ) = CGRID( C,R,1,S )
               END DO
            END DO
         END IF
      END DO

      END SUBROUTINE CGRID_DEPV

C for cb05:
C  strt   v  n ndx  s   GAS_DEPV_FOUND  GAS_DEPV_SUR
C    0    1  1  3   1      (1)   .true.    3        VD_NO2          
C    0    2  2  4   2      (2)   .true.    4        VD_NO           
C    0    3  3  5   4      (3)   .true.    5        VD_O3           
C    0    4  4 19   5      (4)   .true.   19        VD_NO3          
C    0    5  5 18   9      (5)   .true.   18        VD_N2O5         
C    0    6  6  6  10      (6)   .true.    6        VD_HNO3         
C    0    7  7 15  11      (7)   .true.   15        VD_HONO         
C    0    8  8  7  13      (8)   .true.    7        VD_H2O2         
C    0    9  9 14  16      (9)   .true.   14        VD_PAN          
C    0   10 10 10  17     (10)   .true.   10        VD_OP           
C    0   11 11  9  18     (11)   .true.    9        VD_HCHO         
C    0   12 12  8  19     (12)   .true.    8        VD_ALD          
C    0   13 13 20  20     (13)   .true.   20        VD_GEN_ALD      
C    0   14 14 16  22     (14)   .true.   16        VD_CO           
C x  0   15 15 16  22     (15)  .false.   10        VD_OP           
C    0   16 16 17  25     (16)   .true.   17        VD_METHANOL     
C    0   17 17 12  27     (17)   .true.   12        VD_ORA          
C x  0   18 18 12  27     (18)  .false.   14        VD_PAN          
C    0   19 19 11  30     (19)   .true.   11        VD_PAA          
C x  0   20 20 11  30     (20)  .false.   12        VD_ORA          
C x  0   21 21 11  30     (21)  .false.   14        VD_PAN          
C    0   22 22  1  52     (22)   .true.    1        VD_SO2          
C    0   23 23  2  53     (23)   .true.    2        VD_SULF         
C   91    1 24 13  92     (24)   .true.   13        VD_NH3          
C x 91    2 25 13  92     (25)  .false.   12        VD_ORA          
C x 91    3 26 13  92     (26)  .false.   12        VD_ORA          
C x 91    4 27 13  92     (27)  .false.   12        VD_ORA          
C x 91    5 28 13  92     (28)  .false.   12        VD_ORA          
C x 91    6 29 13  92     (29)  .false.   12        VD_ORA          
C x 91    7 30 13  92     (30)  .false.   12        VD_ORA          
C x 91    8 31 13  92     (31)  .false.   12        VD_ORA          
C x 91    9 32 13  92     (32)  .false.   12        VD_ORA          
C x 91   10 33 13  92     (33)  .false.   12        VD_ORA          
C x 91   11 34 13  92     (34)  .false.   12        VD_ORA          
C   91   12 35 21 103     (35)   .true.   21        VD_HCL          

C for cb05cl:
C  strt   v  n ndx  s   GAS_DEPV_FOUND  GAS_DEPV_SUR
C    0    1  1  3   1        .true.         3       VD_NO2
C    0    2  2  4   2        .true.         4       VD_NO
C    0    3  3  5   4        .true.         5       VD_O3
C    0    4  4 19   5        .true.        19       VD_NO3
C    0    5  5 18   9        .true.        18       VD_N2O5
C    0    6  6  6  10        .true.         6       VD_HNO3
C    0    7  7 15  11        .true.        15       VD_HONO
C    0    8  8  7  13        .true.         7       VD_H2O2
C    0    9  9 14  16        .true.        14       VD_PAN
C    0   10 10 10  17        .true.        10       VD_OP
C    0   11 11  9  18        .true.         9       VD_HCHO
C    0   12 12  8  19        .true.         8       VD_ALD
C    0   13 13 20  20        .true.        20       VD_GEN_ALD
C    0   14 14 16  22        .true.        16       VD_CO
C    0   15 15 16  22       .false.        10       VD_OP
C    0   16 16 17  25        .true.        17       VD_METHANOL
C    0   17 17 12  27        .true.        12       VD_ORA
C    0   18 18 12  27       .false.        14       VD_PAN
C    0   19 19 11  30        .true.        11       VD_PAA
C    0   20 20 11  30       .false.        12       VD_ORA
C    0   21 21 11  30       .false.        14       VD_PAN
C    0   22 22  1  52        .true.         1       VD_SO2
C    0   23 23  2  53        .true.         2       VD_SULF
C    0   24 24 21  57        .true.        21       VD_CL2
C    0   25 25 22  59        .true.        22       VD_HOCL
C    0   26 26 24  61        .true.        24       VD_FMCL
C    0   27 27 23  62        .true.        23       VD_HCL
C  122    1 28 13 123        .true.        13       VD_NH3
C  122    2 29 13 123       .false.        12       VD_ORA
C  122    3 30 13 123       .false.        12       VD_ORA
C  122    4 31 13 123       .false.        12       VD_ORA
C  122    5 32 13 123       .false.        12       VD_ORA
C  122    6 33 13 123       .false.        12       VD_ORA
C  122    7 34 13 123       .false.        12       VD_ORA
C  122    8 35 13 123       .false.        12       VD_ORA
C  122    9 36 13 123       .false.        12       VD_ORA
C  122   10 37 13 123       .false.        12       VD_ORA
C  122   11 38 13 123       .false.        12       VD_ORA
C  122   12 39 13 123       .false.        12       VD_ORA
C  122   13 40 13 123       .false.        12       VD_ORA

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE LOAD_CGRID ( FNAME, SPC_CAT, CMIN, CGRID )

C-----------------------------------------------------------------------
C Function:
C   Initialize the model CGRID array from file data

C Revision history:
C   Jeff - Dec 00 - split out from initscen.F
C                 - move CGRID_MAP into f90 module
C   Jeff - Feb 01 - module LOCALFILE to set CCTM IOAPI file defn's
C                 - add BUFSIZE for dfio option
C                 - assumed shape arrays
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX;
C   30 Oct 01 J.Young: fix ICBC_FAC
C    4 Sep 03 J.Young: fix SPC/NDX bug if ASO4J IC's are unavailable
C   20 Nov 03 J.Young: enable loading RHOJ
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                      removed deprecated TRIMLEN
C    2 Sep 11 J.Young: change ICBC_FAC policy to always assigning factor,
C                      if specified, not just if a surrogate is also specified 
C   11 Sep 15 B.Murphy: add condition for no surrogate name
C
C   08 Mar 19 F. Sidi  Split up ICBC_FAC into IC_FAC and BC_FAC for 
C                      tracer namelist only
C   01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all
C                     MY_N clauses
C   01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all
C                     MY_N clauses
C   08 Mar 19 F. Sidi  Split up ICBC_FAC into IC_FAC and BC_FAC for 
C                      tracer namelist only
C   13 Mar 19 D. Wong: Implemented centralized I/O approach
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      USE AERO_DATA, ONLY : CHECK_AERO_ICBC, N_MODE
      Use CENTRALIZED_IO_MODULE, only : interpolate_var
#ifdef mpas
      USE coupler_module
#endif
      USE CONST, ONLY: MWAIR

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

      CHARACTER( 16 ) :: FNAME
      INTEGER      JDATE
      INTEGER      JTIME
      CHARACTER( 2 ) :: SPC_CAT
      REAL         CMIN
!     REAL      :: CGRID( :,:,:,: )  ! for initial CONC
      REAL, POINTER :: CGRID( :,:,:,: )  ! for initial CONC

C Parameters:

C minimum aerosol sulfate concentration [ ug/m**3 ]
      REAL, PARAMETER :: AEROCONCMIN = 0.001

C The following two factors assume that sulfate density is 1.8e3 [ kg/m**3 ]
C and that the geometric mean diameter and geometric standard deviations
C for the Aitken mode are 0.01e-6 [ m ] and 1.7 respectively
C and are 0.07e-6 and 2.0 respectively for the accumulation mode.

C factor to calculate aerosol number concentration from aerosol sulfate mass
C concentration in the Aitken mode [ ug ].
      REAL, PARAMETER :: NUMFACT_I = 2.988524 E11

C factor to calculate aerosol number concentration from aerosol sulfate mass
C concentration in the Accumulation mode [ ug ].
      REAL, PARAMETER :: NUMFACT_J = 3.560191 E08

C fraction of sulfuric acid vapor taken as aerosol for first time step
      REAL, PARAMETER :: SO4VAPTOAER = 0.999
C initial fraction of total aerosol sulfate in the Aitken mode
      REAL, PARAMETER :: IFRACATKN = 0.04

      INTEGER, SAVE :: MXSPC
      INTEGER ASTAT

C File variables:

      REAL      :: DENS( NCOLS,NROWS,NLAYS )       ! air density (kg/m^3)
      REAL      :: RHOJ( NCOLS,NROWS,NLAYS ) ! air density X Jacobian (kg/m^2)

C External Functions:

      INTEGER, EXTERNAL :: FINDEX       !  looks up number in table.

C Local Variables

      REAL         MWH2SO4                           ! H2SO4 molec. wt.
      REAL         H2SO4CONV                         ! ppm -> ug/m**3
      INTEGER      LSULF                             ! Gas chem CGRID index
      INTEGER      ISO4AJ, ISO4AI, INUMATKN, INUMACC ! CGRID aerosol indices

      INTEGER      GXOFF, GYOFF               ! global origin offset from file

C for XTRACT3
      INTEGER       :: STRTCOLINI, ENDCOLINI, STRTROWINI, ENDROWINI
      REAL      :: DBUFF( NCOLS,NROWS,NLAYS )
      REAL      :: DBUFF_TMP( NCOLS,NROWS,NLAYS )

      INTEGER      SPC_STRT, SPC_FINI         ! Species Indices
      INTEGER      N_SPCS                     ! no. of species for this call
      INTEGER      NDX                        ! loop copy of INDX
      INTEGER      ISUR                       ! surrogate index
      INTEGER      ISPCS                      ! model species index
      INTEGER, ALLOCATABLE, SAVE :: INDX( : ) ! Variable indices for all IC species
      REAL,    ALLOCATABLE, SAVE :: ICBC_FAC( : ) ! Factor to be applied to ICs
      INTEGER      C, R, L, SPC, V, J         ! loop counters
      INTEGER      ASPC                       ! CGRID RHOJ pointer
      INTEGER      STAT( N_MODE )             ! Status reported by Aerosol Dist Checker

      INTEGER       :: IMODE    
      REAL          :: AER_PAR( 2, N_MODE,6 )  !Modal parameter after the BC 
                                               !check (N, dg, sg)
                                               !      (N, M2, M3) - Before
                                               !      (N, M2, M3) - After
      REAL          :: AECON( N_AE_SPC )

      CHARACTER( 16 ) :: PNAME = 'LOAD_CGRID'
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: POC_CHK
      CHARACTER( 16 ) :: ICNAME_TMP
      CHARACTER( 16 ) :: CONCMIN
      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER(199 ) :: XMSG2 = ' '
      CHARACTER( 40 ) :: CHWARN = 'Domain extents different from model for '
      CHARACTER( 24 ) :: ESTR1 = 'No IC found for species '
      CHARACTER( 34 ) :: ESTR2 = ' '
      CHARACTER( 34 ) :: ESTR3 = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL       :: L_WRITE_WARNING

C-----------------------------------------------------------------------

      JDATE = STDATE
      JTIME = STTIME

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         CALL LOG_HEADING( LOGDEV, 'Load Initial Conditions' ) 

         MXSPC = N_GC_SPC + N_AE_SPC + N_NR_SPC + N_TR_SPC
         ALLOCATE ( INDX( MXSPC ), ICBC_FAC( MXSPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'ERROR allocating INDX or ICBC_FAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
#ifdef mpas
         ALLOCATE ( INDX_MPAS( MXSPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'ERROR allocating INDX_MPAS '
            call M3EXIT (PNAME, JDATE, JTIME, XMSG, 1)
         END IF
         INDX_MPAS = 0
#endif
      END IF

      WRITE( CONCMIN,'(1PE9.2)' ) CMIN

#ifndef mpas
      IF ( .NOT. OPEN3( FNAME, FSREAD3, PNAME ) ) THEN
         XMSG = 'Could not open ' // FNAME // ' file'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
 
      IF ( .NOT. DESC3( FNAME ) ) THEN
         XMSG = 'Could not get ' // FNAME // ' file description'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
 
      IF ( GL_NCOLS .NE. NCOLS3D ) THEN
         WRITE( LOGDEV,* ) ' '
         WRITE( LOGDEV,* ) '    WARNING: ' // CHWARN // FNAME
         WRITE( LOGDEV,* ) '>>  GL_NCOLS: ', GL_NCOLS, '  NCOLS3D: ', NCOLS3D
      END IF
 
      IF ( GL_NROWS .NE. NROWS3D ) THEN
         WRITE( LOGDEV,* ) ' '
         WRITE( LOGDEV,* ) '    WARNING: ' // CHWARN // FNAME
         WRITE( LOGDEV,* ) '>>  GL_NROWS: ', GL_NROWS, '  NROWS3D: ', NROWS3D
      END IF
 
      IF ( NLAYS .NE. NLAYS3D ) THEN
         XMSG = 'Wrong number of layers in ' // FNAME // ' file'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
#endif

      ESTR2 = ' in ' // TRIM( FNAME ) // '; Look for '
      ESTR3 = ' in ' // TRIM( FNAME ) // '; set to ' // TRIM( CONCMIN )

C The original policy for using surrogate names is first, check if the Namelist
C species is on the IC file; if so ignore any surrogate. If the Namelist species
C is not on the IC file, then check if the surrogate name is; if so also use the
C scale factor (default = 1.0).
C Note: parsing in CGRID_SPCS follows this policy for all the Namelist surrogate
C types (EMIS, DEPV, ICBC, and SCAV).
C => Change this for ICBC:
C First check if there's a surrogate name in the Namelist and use it (and the
C corresponding scale factor) if it exists. If it's not on the IC file, which it
C wouldn`t be if it were blank, e.g., then look for the Namelist species name. If
C that name is found on the IC file, then the default scale factor is applied
C (default = 1.0). To use a scale factor other that 1.0, there must be a name in
C the surrogate slot; it could be the same as the Namelist main species name.

C Get INDX
      DO SPC = 1, MXSPC
         INDX( SPC ) = 0
      END DO

      SPC_STRT = 0
      IF ( SPC_CAT .EQ. 'GC' ) THEN
         WRITE( XMSG,1009 ) 'transported gas-phase (reactive) species'
         WRITE( LOGDEV, * )
         CALL LOG_MESSAGE( LOGDEV, XMSG )
         SPC_STRT = GC_STRT
         N_SPCS = N_GC_SPC
         DO SPC = 1, N_SPCS
C is there a surrogate name?
            ISUR = FINDEX ( SPC, N_GC_IC, GC_IC_MAP )
            NDX = 0
            IF ( ISUR .NE. 0 ) THEN
C is it on the IC file?
#ifdef mpas
               NDX = INDEX1( GC_IC( ISUR ), n_all_spc, all_spc )
#else
               NDX = INDEX1( GC_IC( ISUR ), NVARS3D, VNAME3D )
#endif
               IF ( NDX .NE. 0 ) THEN
C if there`s a surrogate name, CGRID_SPCS handles setting GC_ICBC_FAC
                  INDX( SPC ) = NDX   ! index in the IC file
                  ICBC_FAC( SPC ) = GC_IC_FAC( ISUR )
               ELSE
                  XMSG = ESTR1 // TRIM( GC_IC( ISUR ) ) // ESTR2 // 
     &                   TRIM(GC_SPC( SPC ))
                  CALL M3MESG( XMSG )
               END IF
            END IF
C If there is no surrogate or it cannot be found, look for the (main) species name on the IC file
            If ( ISUR .EQ. 0 .OR. NDX .EQ. 0 .OR. (.NOT. NEW_START ) ) THEN
#ifdef mpas
               NDX = INDEX1( GC_SPC( SPC ), n_all_spc, all_spc )
#else
               NDX = INDEX1( GC_SPC( SPC ), NVARS3D, VNAME3D )
#endif
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX   ! index in the IC file
                  ICBC_FAC( SPC ) = 1.0
               ELSE
                  XMSG = ESTR1 // TRIM( GC_SPC( SPC ) ) // ESTR3
                  CALL M3MESG( XMSG )
               END IF
            END IF

            IF ( INDX( SPC ) .GT. 0 )
     &         WRITE( LOGDEV,1013 ) INDX( SPC ), GC_SPC( SPC ), ICBC_FAC( SPC )

         END DO

      ELSE IF ( SPC_CAT .EQ. 'AE' ) THEN
         WRITE( XMSG,1009 ) 'transported aerosol species'
         WRITE( LOGDEV, * )
         CALL LOG_MESSAGE( LOGDEV, XMSG )
         SPC_STRT = AE_STRT
         N_SPCS = N_AE_SPC
         DO SPC = 1, N_SPCS
C is there a surrogate name?
            ISUR = FINDEX ( SPC, N_AE_IC, AE_IC_MAP )
            NDX = 0
            IF ( ISUR .NE. 0 ) THEN
C is it on the IC file?
#ifdef mpas
               NDX = INDEX1( AE_IC( ISUR ), n_all_spc, all_spc )
#else
               NDX = INDEX1( AE_IC( ISUR ), NVARS3D, VNAME3D )
#endif
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX   ! index in the IC file
                  ICBC_FAC( SPC ) = AE_IC_FAC( ISUR )
               ELSE
                  XMSG = ESTR1 // TRIM( AE_IC( ISUR ) ) // ESTR2 // 
     &                   TRIM(AE_SPC( SPC ))
                  CALL M3MESG( XMSG )
               END IF
            END IF
C If there is no surrogate or it cant be found, look for the (main) species name on the IC file
            If ( ISUR .EQ. 0 .OR. NDX .EQ. 0 .OR. (.NOT. NEW_START ) ) THEN
#ifdef mpas
               NDX = INDEX1( AE_SPC( SPC ), n_all_spc, all_spc )
#else
               NDX = INDEX1( AE_SPC( SPC ), NVARS3D, VNAME3D )
#endif
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX
                  ICBC_FAC( SPC ) = 1.0
               ELSE
                  XMSG = ESTR1 // TRIM( AE_SPC( SPC ) ) // ESTR3
                  CALL M3MESG( XMSG )
               END IF
            END IF

            IF ( INDX( SPC ) .GT. 0 )
     &         WRITE( LOGDEV,1013 ) INDX( SPC ), AE_SPC( SPC ), ICBC_FAC( SPC )
 
         END DO

      ELSE IF ( SPC_CAT .EQ. 'NR' ) THEN
         WRITE( XMSG,1009 ) 'transported non-reactive gas species'
         WRITE( LOGDEV, * )
         CALL LOG_MESSAGE( LOGDEV, XMSG )
         SPC_STRT = NR_STRT
         N_SPCS = N_NR_SPC
         DO SPC = 1, N_SPCS
C is there a surrogate name?
            ISUR = FINDEX ( SPC, N_NR_IC, NR_IC_MAP )
            NDX = 0
            IF ( ISUR .NE. 0 ) THEN
C is it on the IC file?
#ifdef mpas
               NDX = INDEX1( NR_IC( ISUR ), n_all_spc, all_spc )
#else
               NDX = INDEX1( NR_IC( ISUR ), NVARS3D, VNAME3D )
#endif
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX   ! index in the IC file
                  ICBC_FAC( SPC ) = NR_IC_FAC( ISUR )
               ELSE
                  XMSG = ESTR1 // TRIM( NR_IC( ISUR ) ) // ESTR2 // 
     &                   TRIM(NR_SPC( SPC ))
                  CALL M3MESG( XMSG )
               END IF
            END IF
C If there is no surrogate or it cant be found, look for the (main) species name on the IC file
            If ( ISUR .EQ. 0 .OR. NDX .EQ. 0 .OR. (.NOT. NEW_START ) ) THEN
#ifdef mpas
               NDX = INDEX1( NR_SPC( SPC ), n_all_spc, all_spc )
#else
               NDX = INDEX1( NR_SPC( SPC ), NVARS3D, VNAME3D )
#endif
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX
                  ICBC_FAC( SPC ) = 1.0
               ELSE
                  XMSG = ESTR1 // TRIM( NR_SPC( SPC ) ) // ESTR3
                  CALL M3MESG( XMSG )
               END IF
            END IF

            IF ( INDX( SPC ) .GT. 0 )
     &         WRITE( LOGDEV,1013 ) INDX( SPC ), NR_SPC( SPC ), ICBC_FAC( SPC )

         END DO

      ELSE IF ( SPC_CAT .EQ. 'TR' ) THEN
         WRITE( XMSG, 1009 ) 'transported inert tracer gas species'
         WRITE( LOGDEV, * )
         CALL LOG_MESSAGE( LOGDEV, XMSG )
         SPC_STRT = TR_STRT
         N_SPCS = N_TR_SPC
         DO SPC = 1, N_SPCS
C is there a surrogate name?
            ISUR = FINDEX ( SPC, N_TR_IC, TR_IC_MAP )
            NDX = 0
            IF ( ISUR .NE. 0 ) THEN
C is it on the IC file?
#ifdef mpas
               NDX = INDEX1( TR_IC( ISUR ), n_all_spc, all_spc )
#else
               NDX = INDEX1( TR_IC( ISUR ), NVARS3D, VNAME3D )
#endif
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX   ! index in the IC file
                  ICBC_FAC( SPC ) = TR_IC_FAC( ISUR )
               ELSE
                  XMSG = ESTR1 // TRIM( TR_IC( ISUR ) ) // ESTR2 // 
     &                   TRIM(TR_SPC( SPC ))
                  CALL M3MESG( XMSG )
               END IF
            END IF
C If there is no surrogate or it cant be found, look for the (main) species name on the IC file
            If ( ISUR .EQ. 0 .OR. NDX .EQ. 0 .OR. (.NOT. NEW_START ) ) THEN
#ifdef mpas
               NDX = INDEX1( TR_SPC( SPC ), n_all_spc, all_spc )
#else
               NDX = INDEX1( TR_SPC( SPC ), NVARS3D, VNAME3D )
#endif
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX
                  ICBC_FAC( SPC ) = 1.0
               ELSE
                  XMSG = ESTR1 // TRIM( TR_SPC( SPC ) ) // ESTR3
                  CALL M3MESG( XMSG )
               END IF
            END IF

            IF ( INDX( SPC ) .GT. 0 )
     &         WRITE( LOGDEV,1013 ) INDX( SPC ), TR_SPC( SPC ), ICBC_FAC( SPC )

         END DO

      ELSE IF ( SPC_CAT .EQ. 'RJ' ) THEN
         N_SPCS = 0
      ELSE
         XMSG = 'Species categories incorrect for CGRID '
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
      END IF
        
C Read into CGRID

!     CALL SUBHFILE ( FNAME, GXOFF, GYOFF,
!    &                STRTCOLINI, ENDCOLINI, STRTROWINI, ENDROWINI )
C IOFDESC common now loaded with FNAME header

      DO SPC = 1, N_SPCS
         V = SPC_STRT - 1 + SPC
         NDX = INDX( SPC )

         IF ( NDX .GT. 0 ) THEN
#ifndef mpas
            call interpolate_var (VNAME3D ( NDX ), jdate, jtime, DBUFF)

            ! Add Non-Carbon Mass to Carbon Mass if any tracer is
            ! pointing to POC as a surrogate. It is very likely that
            ! these tracers are seeking the entire POA mass (e.g.
            ! semivolatile POA tracers).
            POC_CHK = 'NOTPOC'
            IF ( SPC_CAT .EQ. 'AE' ) POC_CHK = AE_SPC( SPC )

            IF ( VNAME3D( NDX )( 1:4 ) .EQ. 'APOC' .AND.
     &           POC_CHK(1:4) .NE. 'APOC' ) THEN 
               ICNAME_TMP = 'APNCOM' // VNAME3D( NDX )( 5:5 )
               call interpolate_var (ICNAME_TMP, jdate, jtime, DBUFF_TMP)
               DBUFF = DBUFF + DBUFF_TMP
            END IF

            ! Load ICs into CGRID
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,V ) = ICBC_FAC( SPC ) * DBUFF( C,R,L )
                  END DO
               END DO
            END DO
#endif

         END IF   ! INDX .GT. 0

      END DO
 
      IF ( SPC_CAT .EQ. 'RJ' ) THEN

C Load RHOJ for transport and mixing ratio advection adjustment

         call interpolate_var ('DENSA_J', jdate, jtime, RHOJ)

         ASPC = GC_STRT - 1 + N_GC_SPCD
         DO L = 1, NLAYS
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  CGRID( C,R,L,ASPC ) = RHOJ( C,R,L )
               END DO
            END DO
         END DO

      END IF

      IF ( SPC_CAT .EQ. 'AE' ) THEN
         CALL LOG_SUBHEADING( LOGDEV, 'Check Aerosol IC Size Distributions' )

         ! Check Aerosol Size Distributions and Warn the User if They Are Not Robust.
         IF ( NEW_START ) THEN
           SPC_STRT = AE_STRT
           SPC_FINI = AE_STRT + N_AE_SPC - 1
           L_WRITE_WARNING = .TRUE.
           DO L = 1, NLAYS
           DO R = 1, NROWS
           DO C = 1, NCOLS
              AECON( 1:N_AE_SPC ) = CGRID( C,R,L,SPC_STRT:SPC_FINI )
              CALL CHECK_AERO_ICBC( AECON, .FALSE., .TRUE., 
     &                              .FALSE., L_WRITE_WARNING, C,R,L )
              CGRID( C,R,L,SPC_STRT:SPC_FINI ) = AECON( 1:N_AE_SPC )
           END DO
           END DO
           END DO
         END IF

C are ASO4J ICs available on the file?

         VNAME = 'ASO4J'
#ifdef mpas
         NDX = INDEX1( VNAME, n_ae_spc, ae_spc )
#else
         NDX = INDEX1( VNAME, NVARS3D, VNAME3D )
#endif
     
         IF ( NDX .EQ. 0 ) THEN  ! ASO4J not on file

C Set pointers for gas (vapor) phase sulfur species

            NDX = INDEX1( VNAME, N_AE_SPC, AE_SPC )
            IF ( NDX .NE. 0 ) THEN
               ISO4AJ = AE_STRT - 1 + NDX
            ELSE
               XMSG = 'Could not find ' // VNAME // 'in aerosol table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF

            VNAME = 'SULF'
            NDX = INDEX1( VNAME, N_GC_G2AE, GC_G2AE )
            IF ( NDX .NE. 0 ) THEN
               LSULF   = GC_STRT - 1 + GC_G2AE_MAP( NDX )
               MWH2SO4 = GC_MOLWT( GC_G2AE_MAP( NDX ) )
            ELSE
               XMSG = 'Could not find ' // VNAME // 'in gas chem aerosol table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF

            VNAME = 'ASO4I'
            NDX = INDEX1( VNAME, N_AE_SPC, AE_SPC )
            IF ( NDX .NE. 0 ) THEN
               ISO4AI = AE_STRT - 1 + NDX
            ELSE
               XMSG = 'Could not find ' // VNAME // 'in aerosol table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF
            VNAME = 'NUMATKN'
            NDX = INDEX1( VNAME, N_AE_SPC, AE_SPC )
            IF ( NDX .NE. 0 ) THEN
               INUMATKN = AE_STRT - 1 + NDX
            ELSE
               XMSG = 'Could not find ' // VNAME // 'in aerosol table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF
            VNAME = 'NUMACC'
            NDX = INDEX1( VNAME, N_AE_SPC, AE_SPC )
            IF ( NDX .NE. 0 ) THEN
               INUMACC = AE_STRT - 1 + NDX
            ELSE
               XMSG = 'Could not find ' // VNAME // 'in aerosol table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF

            call interpolate_var ('DENS', jdate, jtime, DENS)

C Partition the aerosol sulfate arrays with a fraction of the initial SO4 

            H2SO4CONV = 1.0E3 * MWH2SO4 / MWAIR * SO4VAPTOAER

            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS

C total accumulation mode sulfate:

                     CGRID( C,R,L,ISO4AJ )   = MAX ( AEROCONCMIN,
     &                                         ( 1.0 - IFRACATKN )
     &                                       * H2SO4CONV
     &                                       * DENS ( C,R,L )
     &                                       * CGRID( C,R,L,LSULF ) )

C Accumulation mode number:
    
                     CGRID( C,R,L,INUMACC )  = NUMFACT_J
     &                                       * CGRID( C,R,L,ISO4AJ )

C Aitken mode sulfate:
    
                     CGRID( C,R,L,ISO4AI )   = MAX ( AEROCONCMIN,
     &                                         IFRACATKN
     &                                       * H2SO4CONV
     &                                       * DENS ( C,R,L )
     &                                       * CGRID( C,R,L,LSULF ) )
    
C Aitken mode number:
    
                     CGRID( C,R,L,INUMATKN ) = NUMFACT_I
     &                                       * CGRID( C,R,L,ISO4AI )
    
C correct sulfate vapor concentration for part removed:
    
                     CGRID( C,R,L,LSULF )    = ( 1.0 - SO4VAPTOAER )
     &                                       * CGRID( C,R,L,LSULF)
    
                  END DO
               END DO
            END DO

            XMSG = 'No IC''s found for aerosol sulfate. ' //
     &             'Gas Chem sulfate used for partitioning.'
            CALL M3MESG( XMSG )

         END IF  ! NDX .EQ. 0

      END IF  !  SPC_CAT .EQ. 'AE'

      RETURN

1009  FORMAT( 'Initial Condition Factors used for ', A )
1013  FORMAT( 5X, I3, 2X, A, 1PG13.5 )
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_term_module.f,v 1.2 2006/02/15 14:45:31 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   to terminate stenex library
C
C Revision history:
C
C   Orginal version: 11/30/00 by David Wong
C
C                    12/04/02 by David Wong
C                       -- made the routine more robust by checking 
C                          allocation first before any deallocate call
C --------------------------------------------------------------------------

        module se_term_module

          implicit none

          contains

          subroutine se_term 

          use se_pe_info_ext
          use se_domain_info_ext
          use se_reconfig_grid_info_ext
          use se_subgrid_info_ext

          implicit none

          if (allocated(ranks)) then
             deallocate(ranks)
          end if

          if (allocated(se_gl_ind)) then
             deallocate (se_gl_ind)
          end if

          if (allocated(se_reconfig_grid_send_ind)) then
             deallocate (se_reconfig_grid_send_ind)
             deallocate (se_reconfig_grid_recv_ind)
          end if

          if (allocated(se_subgrid_send_ind)) then
             deallocate (se_subgrid_send_ind)
             deallocate (se_subgrid_recv_ind)
             deallocate (se_subgrid_send)
             deallocate (se_subgrid_recv)
             deallocate (se_subgrid_ind)
          end if

          return
          end subroutine se_term 

        end module se_term_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
      
!-------------------------------------------------------------------------
      SUBROUTINE ELMO_DERIVED_CALC( OUTVAL, J )
!     This subroutine maps the PM diagnostic variables that the user has
!       requested to the entries in the ELMO_DATA table.
!-------------------------------------------------------------------------
      USE CONST
      USE ELMO_DATA
      USE ELMO_DERIVED_DEFN
      USE ELMO_PROC, ONLY : CALC_ELMO
      USE AERO_DATA, ONLY: AEROMODE_LNSG, DRY_AERO_DIAM, WET_AERO_DIAM,
     &                     DRY_AERO_M2, WET_AERO_M2, DRY_AERO_M3, 
     &                     WET_AERO_M3, N_MODE, MOMENT0_CONC, MOMENT2_CONC,
     &                     MOMENT3_CONC, WET_AERO_DENS, AEROSPC_CONC,
     &                     AH2O_IDX, AORGH2O_IDX, AEROSPC, CALC_AERODIST_PARAMS,
     &                     AEROMODE, DRY_AERO_DENS, APOC_IDX, APNCOM_IDX,
     &                     AEROSPC_MAP,
     &                     NPFAS, PFAS, MAP_PFAStoAERO, MAP_PFAStoGAS
      USE AEROMET_DATA, ONLY: AIRRH, AIRTEMP, SRFTEMP, AIRPRES, AIRDENS
      USE CGRID_SPCS, ONLY : RHOJ_LOC, CGRID_MW
      USE SOA_DEFN, ONLY : N_OA, N_OA_NotTracers, OASPC, MAP_OAtoAERO
      USE RUNTIME_VARS, ONLY : PHOTDIAG
      USE ASX_DATA_MOD, ONLY : MET_DATA
      USE ELMO_DERIVED_FXNS

#ifdef isam
      USE SA_DEFN, ONLY : MAP_AEROtoSA,NTAG_SA
#endif

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: J 
      REAL, INTENT( INOUT ) :: OUTVAL
      INTEGER ILOC, IMODE, IVAR, IOA, IM, IV, ISRC, IDG, IUNIT, 
     &        IERR, N, IPFAS
      REAL VAL4, VAL3, VAL2, VAL, FRAC( N_MODE )
      REAL PM01, PM1, PM25, PM10, PMAMS, PM25to10, POM, POC, OtoC
      REAL K, P1, P2, P3, a, K2, PMF_NO3, PMF_NO3_LOSS,
     &     PMF_NH4_LOSS, PMF_NH4, PMF_SO4, PMF,
     &     PM25_NH4, PM25_NO3, PM25_SO4, PM25_NO3_LOSS,
     &     PM25_NH4_LOSS
      LOGICAL ORG_MASK( N_OA ), MODE_MASK( N_MODE )
      CHARACTER( 300 ) :: XMSG

      OUTVAL = 0.0

      IDG    = ELMO_TABLE( J )%ID
      IM     = ELMO_TABLE( J )%IM
      IV     = ELMO_TABLE( J )%VAR_TYPE
      ISRC   = ELMO_TABLE( J )%SOURCE
      IUNIT  = ELMO_TABLE( J )%IUNIT

      ! Determine which variable to calculate
      SELECT CASE( IDG )

         ! Retrieve Standard Deviation of Each Mode
         CASE ( ID_STDEV )
            OUTVAL = EXP( AEROMODE_LNSG( IM ) )

         ! Retrieve Mode Dry Diameter
         CASE ( ID_DRY_DG )
            OUTVAL = DRY_AERO_DIAM( IM )  ! dry diam.

         ! Retrieve Mode Wet Diameter
         CASE ( ID_WET_DG )
            OUTVAL = WET_AERO_DIAM( IM )  ! wet diam.

         ! Retrieve Mode Wet Second Moment
         CASE ( ID_WET_M2 )
            OUTVAL = WET_AERO_M2( IM )  ! dry M2

         ! Retrieve Dry Third Moment
         CASE ( ID_DRY_M3 )
            OUTVAL = DRY_AERO_M3( IM )  ! dry M3

         ! Retrieve Wet Third Moment
         CASE ( ID_WET_M3 )
            OUTVAL = WET_AERO_M3( IM )  ! wet M3

         ! Retrieve Total Particle Number
         CASE ( ID_PM_NUM )
            OUTVAL = SUM( MOMENT0_CONC( : ) ) ! N m-3

         ! Retrieve Ultrafine-Particle Particle Number
         CASE ( ID_PMU_NUM )
            OUTVAL = SUM( MOMENT0_CONC( : ), 
     &                          MASK=AEROMODE(:)%ULTRAFINE_MASK ) ! N m-3
         
         ! Retrieve Fine-Particle Particle Number
         CASE ( ID_PMF_NUM )
            OUTVAL = SUM( MOMENT0_CONC( : ), 
     &                          MASK=AEROMODE(:)%FINE_MASK ) ! N m-3
         
         ! Retrieve Coarse-Particle Particle Number
         CASE ( ID_PMC_NUM )
            OUTVAL = SUM( MOMENT0_CONC( : ), 
     &                          MASK=AEROMODE(:)%COARSE_MASK ) ! N m-3

         ! Retrieve N10 - Number of Particles Greater than 10 nm
         CASE ( ID_N10 )
            CALL SUM_INLET_NUM( INUM10, IWET, OUTVAL )

         ! Retrieve N20 - Number of Particles Greater than 20 nm
         CASE ( ID_N20 )
            CALL SUM_INLET_NUM( INUM20, IWET, OUTVAL )

         ! Retrieve N40 - Number of Particles Greater than 40 nm
         CASE ( ID_N40 )
            CALL SUM_INLET_NUM( INUM40, IWET, OUTVAL )

         ! Retrieve N100 - Number of Particles Greater than 100 nm
         CASE ( ID_N100 )
            CALL SUM_INLET_NUM( INUM100, IWET, OUTVAL )

         ! Retrieve Total Particle Surface Area
         CASE ( ID_PM_SRF )
            OUTVAL = PI * SUM( MOMENT2_CONC( : ) ) ! N m-3

         ! Retrieve Ultrafine Particle Surface Area
         CASE (ID_PMU_SRF )
            OUTVAL = PI * SUM( MOMENT2_CONC( : ), 
     &                          MASK=AEROMODE(:)%ULTRAFINE_MASK ) ! N m-3

         ! Retrieve Fine Particle Surface Area
         CASE ( ID_PMF_SRF )
            OUTVAL = PI * SUM( MOMENT2_CONC( : ), 
     &                          MASK=AEROMODE(:)%FINE_MASK ) ! N m-3

         ! Retrieve Coarse Particle Surface Area
         CASE ( ID_PMC_SRF )
            OUTVAL = PI * SUM( MOMENT2_CONC( : ), 
     &                          MASK=AEROMODE(:)%COARSE_MASK ) ! N m-3

         ! Retrieve Dry Mode Density [kg m-3]
         CASE ( ID_DRY_DENS )
            OUTVAL = DRY_AERO_DENS( IM )  ! dry i-mode Density

         ! Retrieve Wet Mode Density [kg m-3]
         CASE ( ID_WET_DENS )
            OUTVAL = WET_AERO_DENS( IM )  ! wet i-mode Density

         ! Retrieve PM01 Fraction in Each Mode
         CASE ( ID_FPM01 )
            CALL GET_AERO_INLET( IPM01, IM, IWET, VAL ) 
            OUTVAL = VAL

         ! Retrieve PM1 Fraction in Each Mode
         CASE ( ID_FPM1 )
            CALL GET_AERO_INLET( IPM1, IM, IWET, VAL ) 
            OUTVAL = VAL

         ! Retrieve PM25 Fraction in Each Mode
         CASE ( ID_FPM25 )
            CALL GET_AERO_INLET( IPM25, IM, IWET, VAL ) 
            OUTVAL = VAL

         ! Retrieve PM10 Fraction in Each Mode
         CASE ( ID_FPM10 )
            CALL GET_AERO_INLET( IPM10, IM, IWET, VAL ) 
            OUTVAL = VAL

         ! Retrieve PM2.5-10 Fraction in Each Mode
         CASE ( ID_FPM25to10 )
            CALL GET_AERO_INLET( IPM25to10, IM, IWET, VAL ) 
            OUTVAL = VAL

         ! Retrieve AMS Fraction in Each Mode
         CASE ( ID_FAMS )
            CALL GET_AERO_INLET( IPMAMS, IM, IWET, VAL ) 
            OUTVAL = VAL
 
         ! Calculate AHPMOLAL - Fine Mode Concentration of H+ in
         ! Particle Water
         CASE ( ID_PMF_HPM )
            ! Retrieve AHPLUSIJ (umol m-3)
            CALL CALC_ELMO( OUTVAL=VAL, OUT_UNIT=IU_UMOLpM3, 
     &                      J=J_PMF_HP( ISRC+1 ), IERR=IERR )
            IF ( IERR .EQ. 1 ) THEN
               XMSG = 'PMF_HP has not been defined in the chem control namelist '//
     &                'so PMF_HPM cannot be calculated. Please define PMF_HP.'
               CALL M3EXIT( 'ELMO_DERIVED_CALC',0,0,XMSG,1)
            END IF 

            ! Retrieve AH2OIJ (ug m-3)
            CALL CALC_ELMO( OUTVAL=VAL2, OUT_UNIT=IU_UGpM3, 
     &                      J=J_PMF_H2O( ISRC+1 ), IERR=IERR )
            IF ( IERR .EQ. 1 ) THEN
               XMSG = 'PMF_H2O has not been defined in the chem control namelist'//
     &                'so PMF_HPMOLAL cannot be calculated. Please define PMF_H2O.'
               CALL M3EXIT( 'ELMO_DERIVED_CALC',0,0,XMSG,1)
            END IF
            
            ! HPMOLAL = AHPLUSIJ / AH2OIJ * 1000.0 [mol kg-1]
            OUTVAL = VAL / VAL2 * 1000.0

         ! Calculate PMF_PH - Fine-Mode pH
         CASE ( ID_PMF_PH )
            ! Retrieve HPMOLAL (mol kg-1)
            CALL CALC_ELMO( OUTVAL=VAL, OUT_UNIT=IU_MOLpKG, 
     &                      J=J_PMF_HPMOLAL( ISRC+1 ), IERR=IERR )
            IF ( IERR .EQ. 1 ) THEN
               XMSG = 'PMF_HPMOLAL has not been defined in the chem control namelist'//
     &                'so PMF_PH cannot be calculated. Please define PMF_HPMOLAL.'
               CALL M3EXIT( 'ELMO_DERIVED_CALC',0,0,XMSG,1)
            END IF

            ! Retrieve AH2OIJ (ug m-3)
            CALL CALC_ELMO( OUTVAL=VAL2,OUT_UNIT=IU_UGpM3, 
     &                      J=J_PMF_H2O( ISRC+1 ), IERR=IERR )
            IF ( IERR .EQ. 1 ) THEN
               XMSG = 'PMF_H2O has not been defined in the chem control namelist'//
     &                'so PMF_PH cannot be calculated. Please define PMF_H2O.'
               CALL M3EXIT( 'ELMO_DERIVED_CALC',0,0,XMSG,1)
            END IF

            OUTVAL = ELMO_BLANK

            IF ( VAL2 .GT. 0.01 )
     &           OUTVAL = -1.0 * LOG10( VAL )

         ! Calculate Aerosol Fraction of Benzo-a-Pyrene
         CASE ( ID_BENAPY_FAERO )
            ! Confirm that particle and gas benzo-a-pyrene are 
            ! actually mapped composites before computing partition
            ! fraction
            IF ( J_PMF_BENAPY( ISRC+1 ) .GT. 0 .AND. 
     &           J_GAS_BENAPY( ISRC+1 ) .GT. 0 ) THEN

               CALL CALC_ELMO( OUTVAL=VAL,  OUT_UNIT=IU_UGpM3, 
     &                         J=J_PMF_BENAPY( ISRC+1 ), IERR=IERR )
               CALL CALC_ELMO( OUTVAL=VAL2, OUT_UNIT=IU_UGpM3, 
     &                         J=J_GAS_BENAPY( ISRC+1 ), IERR=IERR )
               OUTVAL = VAL / ( VAL + VAL2 + TINY( 0.0 ) )

            ELSE 
               OUTVAL = 0.0
            END IF

         ! Retrieve Fine-Mode Particle Mass Collected by the Federal
         ! Reference Method compliant sampler
         CASE ( ID_PMF_FRM )
            K = EXP( 118.87 - 24084/SRFTEMP - 6.025*LOG( SRFTEMP ) )
            P1 = EXP( 8763/SRFTEMP + 19.12*LOG( SRFTEMP ) - 135.94 )
            P2 = EXP( 9969/SRFTEMP + 16.22*LOG( SRFTEMP ) - 122.65 )
            P3 = EXP( 13875/SRFTEMP + 24.46*LOG( SRFTEMP ) - 182.61 )
            a = 1 - AIRRH 
            IF ( AIRRH .LE. 0.61 ) THEN
                K2 = K ** 0.5
            ELSE
                K2 = ( K * ( P1 - P2*a + P3*a*a ) * ( a**1.75 ) ) ** 0.5
            END IF

            CALL CALC_ELMO( OUTVAL=PMF_NO3, OUT_UNIT=IUNIT, 
     &                      J=J_PMF_NO3( ISRC+1 ), IERR=IERR )
            IF ( IERR .EQ. 1 ) THEN
               XMSG = 'PMF_NO3 has not been defined in the chem control namelist'//
     &                'so PMF_FRM cannot be calculated. Please define PMF_NO3.'
               CALL M3EXIT( 'ELMO_DERIVED_CALC',0,0,XMSG,1)
            END IF
            
            PMF_NO3_LOSS = MIN( 745.7/SRFTEMP * K2, PMF_NO3 )

            PMF_NH4_LOSS = PMF_NO3_LOSS * 18.0 / 62.0

            CALL CALC_ELMO( OUTVAL=PMF_NH4,  OUT_UNIT=IUNIT, 
     &                      J=J_PMF_NH4( ISRC+1 ), IERR=IERR )
            IF ( IERR .EQ. 1 ) THEN
               XMSG = 'PMF_NH4 has not been defined in the chem control namelist'//
     &                'so PMF_FRM cannot be calculated. Please define PMF_NH4.'
               CALL M3EXIT( 'ELMO_DERIVED_CALC',0,0,XMSG,1)
            END IF
            
            CALL CALC_ELMO( OUTVAL=PMF_SO4,  OUT_UNIT=IUNIT, 
     &                      J=J_PMF_SO4( ISRC+1 ), IERR=IERR ) 
            IF ( IERR .EQ. 1 ) THEN
               XMSG = 'PMF_SO4 has not been defined in the chem control namelist'//
     &                'so PMF_FRM cannot be calculated. Please define PMF_SO4.'
               CALL M3EXIT( 'ELMO_DERIVED_CALC',0,0,XMSG,1)
            END IF
            
            PMF = SUM_PM_MODES( IM_F, 0, 0, IV, ISRC ) 

            OUTVAL = PMF - PMF_NO3_LOSS - PMF_NH4_LOSS
     &                      +0.24 * ( PMF_SO4 + PMF_NH4 - PMF_NH4_LOSS ) + 0.5
          
         ! Retrieve PM2.5 Particle Mass Collected by the Federal
         ! Reference Method compliant sampler
         CASE ( ID_PM25_FRM )
            K = EXP( 118.87 - 24084/SRFTEMP - 6.025*LOG( SRFTEMP ) )
            P1 = EXP( 8763/SRFTEMP + 19.12*LOG( SRFTEMP ) - 135.94 )
            P2 = EXP( 9969/SRFTEMP + 16.22*LOG( SRFTEMP ) - 122.65 )
            P3 = EXP( 13875/SRFTEMP + 24.46*LOG( SRFTEMP ) - 182.61 )
            a = 1 - AIRRH 
            IF ( AIRRH .LE. 0.61 ) THEN
                K2 = K ** 0.5
            ELSE
                K2 = ( K * ( P1 - P2*a + P3*a*a ) * ( a**1.75 ) ) ** 0.5
            END IF
            
            CALL CALC_ELMO( OUTVAL=PM25_NO3, OUT_UNIT=IUNIT, 
     &                      J=J_PM25_NO3( ISRC+1 ), IERR=IERR )
            IF ( IERR .EQ. 1 ) THEN
               XMSG = 'PM25_NO3 has not been defined in the chem control namelist'//
     &                'so PM25_FRM cannot be calculated. Please define PM25_NO3.'
               CALL M3EXIT( 'ELMO_DERIVED_CALC',0,0,XMSG,1)
            END IF
            
            PM25_NO3_LOSS = MIN( 745.7/SRFTEMP * K2, PM25_NO3 )

            PM25_NH4_LOSS = PM25_NO3_LOSS * 18.0 / 62.0

            CALL CALC_ELMO( OUTVAL=PM25_NH4, OUT_UNIT=IUNIT, 
     &                      J=J_PM25_NH4( ISRC+1 ), IERR=IERR )
            IF ( IERR .EQ. 1 ) THEN
               XMSG = 'PM25_NH4 has not been defined in the chem control namelist'//
     &                'so PM25_FRM cannot be calculated. Please define PM25_NH4.'
               CALL M3EXIT( 'ELMO_DERIVED_CALC',0,0,XMSG,1)
            END IF
            
            CALL CALC_ELMO( OUTVAL=PM25_SO4, OUT_UNIT=IUNIT, 
     &                      J=J_PM25_SO4( ISRC+1 ), IERR=IERR ) 
            IF ( IERR .EQ. 1 ) THEN
               XMSG = 'PM25_SO4 has not been defined in the chem control namelist'//
     &                'so PM25_FRM cannot be calculated. Please define PM25_SO4.'
               CALL M3EXIT( 'ELMO_DERIVED_CALC',0,0,XMSG,1)
            END IF
            
            PM25 = SUM_PM_MODES( IM_ALL, IPM25, IWET, IV, ISRC ) 

            OUTVAL = PM25 - PM25_NO3_LOSS - PM25_NH4_LOSS
     &                      +0.24 * ( PM25_SO4 + PM25_NH4 - PM25_NH4_LOSS ) + 0.5
          
         ! Retrieve GAMMA_N2O5IJ - fine N2O5 heterogeneous rxn probability
         CASE ( ID_GN2O5F )
            IF ( AERO_CHEM_SET ) OUTVAL = GAMMA_N2O5IJ( C1,R1,L1 )

         ! Retrieve GAMMA_N2O5K - coarse N2O5 heterogeneous rxn probability
         CASE ( ID_GN2O5C )
            IF ( AERO_CHEM_SET ) OUTVAL = GAMMA_N2O5K( C1,R1,L1 )

         ! Retrieve YCLNO2IJ - fine CLNO2 heterogeneous rxn probability
         CASE ( ID_YCLNO2F )
            IF ( AERO_CHEM_SET ) OUTVAL = YCLNO2IJ( C1,R1,L1 )

         ! Retrieve YCLNO2K - coarse CLNO2 heterogeneous rxn probability
         CASE ( ID_YCLNO2C )
            IF ( AERO_CHEM_SET ) OUTVAL = YCLNO2K( C1,R1,L1 )

         ! Retrieve GAMMA_IEPOX - heterogeneous uptake coefficient
         CASE ( ID_GIEPOX )
            IF ( AERO_CHEM_SET ) OUTVAL = GAMMA_IEPOX( C1,R1,L1 )

         ! Retrieve Particle-Phase Reaction Rate Constant for IEPOX
         CASE ( ID_KIEPOX )
            IF ( AERO_CHEM_SET ) OUTVAL = KPARTIEPOX( C1,R1,L1 )

         ! Retrieve IMAE Heterogeneous Uptake Coefficient
         CASE ( ID_GIMAE )
            IF ( AERO_CHEM_SET ) OUTVAL = GAMMA_IMAE( C1,R1,L1 )

        ! Retrieve Indicator for VOC-limited (>0.35) or NOx_limited
         ! (<0.35) ozone formation
         CASE ( ID_VOC_NOX )
            IF ( AERO_CHEM_SET ) OUTVAL = ELMO_VOC_NOX( C1,R1,L1 )

         ! Retrieve Nitric Acid Enhancement Factor from photolysis
         ! of aerosols
         CASE ( ID_EF_HNO3 )
            IF ( AERO_CHEM_SET ) OUTVAL = EF_HNO3( C1,R1,L1 )

         ! Retrieve AOD at 550 nm
         CASE ( ID_AOD550 )
             IF ( L1 .EQ. 1 ) THEN
                 OUTVAL = ELMO_AOD_550( C1,R1 )
             ELSE
                 OUTVAL = ELMO_BLANK
             END IF

         ! Retrieve Aerosol Extinction at 550 nm
         CASE ( ID_PMEXT550 )
            OUTVAL = ELMO_EXT_550( C1,R1,L1 )

         ! Retrieve column density variables
         CASE ( ID_NO2COL )
             IF ( L1 .EQ. 1 ) THEN
             OUTVAL = ELMO_NO2COL( C1,R1 )
             ELSE
             OUTVAL = ELMO_BLANK
             END IF

         CASE ( ID_SO2COL )
             IF ( L1 .EQ. 1 ) THEN
             OUTVAL = ELMO_SO2COL( C1,R1 )
             ELSE
             OUTVAL = ELMO_BLANK
             END IF

         CASE ( ID_HCHOCOL )
             IF ( L1 .EQ. 1 ) THEN
             OUTVAL = ELMO_HCHOCOL( C1,R1 )
             ELSE
             OUTVAL = ELMO_BLANK
             END IF

         CASE ( ID_COCOL )
             IF ( L1 .EQ. 1 ) THEN
             OUTVAL = ELMO_COCOL( C1,R1 )
             ELSE
             OUTVAL = ELMO_BLANK
             END IF

         ! Vertical diffusivity coefficients
         CASE ( ID_KZ )
            IF ( INIT_TIME ) THEN
                OUTVAL = 0.0
            ELSE
                OUTVAL = MET_DATA%KZ( C1,R1,L1 )
            END IF
                 

         CASE ( ID_KZMIN )
            IF ( INIT_TIME ) THEN
                OUTVAL = 0.0
            ELSE
                OUTVAL = MET_DATA%KZMIN( C1,R1,L1 )
            END IF

         ! Retrieve Relative Humidity
         CASE ( ID_RH )
            OUTVAL = AIRRH

         ! Retrieve Air Temperature
         CASE ( ID_TEMP )
            OUTVAL = AIRTEMP
         
         ! Retrieve 2-meter Temperature
         CASE ( ID_SRFTEMP )
            OUTVAL = SRFTEMP

         ! Retrieve Air Pressure
         CASE ( ID_PRES )
            OUTVAL = AIRPRES

         ! Retrieve PBL Height
         CASE ( ID_PBL )
            OUTVAL = MET_DATA%PBL( C1,R1 )

         ! Retrieve Solar Radiation at Ground
         CASE ( ID_RGRND )
            OUTVAL = MET_DATA%RGRND( C1,R1 )

         ! Retrieve Precipitation
         CASE ( ID_PRECIP )
            OUTVAL = MET_DATA%RN( C1,R1 )
            IF ( MET_DATA%RC( C1,R1 ) .GE. 0.0 ) 
     &           OUTVAL = OUTVAL + MET_DATA%RC( C1,R1 )

         ! Retrieve Wind Speed at 10 m
         CASE ( ID_WSPD10 )
            OUTVAL = MET_DATA%WSPD10( C1,R1 )

         ! Retrieve Wind Direction at 10 m
         CASE ( ID_WDIR10 )
            OUTVAL = WDIR10

         ! Retrieve Vertical Wind Velocity
         CASE ( ID_WVEL )
            OUTVAL = MET_DATA%WVEL( C1,R1,L1 )

         ! Retrieve DZ
         CASE ( ID_DZ )
            IF ( L1 .EQ. 1 ) THEN
               OUTVAL = MET_DATA%ZF( C1,R1,L1 )
            ELSE 
               OUTVAL = MET_DATA%ZF( C1,R1,L1 ) - MET_DATA%ZF( C1,R1,L1-1 )
            END IF

         ! Retrieve ZH
         CASE ( ID_ZH )
            OUTVAL = MET_DATA%ZH( C1,R1,L1 )

         ! Retrieve Cloud Fraction
         CASE ( ID_CFRAC )
            OUTVAL = MET_DATA%CFRAC( C1,R1 )

         ! Retrieve Potential Vorticity
         CASE ( ID_PV )
            OUTVAL = PV

         ! Retrieve Air Density x Jacobian/MSFX2
         CASE ( ID_RHOJ )
            OUTVAL = CONC_VEC( RHOJ_LOC ) ! kg m-3

         ! Retrieve Air Density
         CASE ( ID_DENS )
            OUTVAL = MET_DATA%DENS( C1,R1,L1 ) ! kg m-3
 
         ! Retrieve HFPODAF Heterogeneous Uptake Coefficient
         CASE ( ID_GHFPODAF )
            IF ( AERO_CHEM_SET ) OUTVAL = GAMMAHFPODAF( C1,R1,L1 )

         ! Retrieve COF2 Heterogeneous Uptake Coefficient
         CASE ( ID_GCOF2 )
            IF ( AERO_CHEM_SET ) OUTVAL = GAMMACOF2( C1,R1,L1 )

         ! Retrieve PFMOAF Heterogeneous Uptake Coefficient
         CASE ( ID_GPFMOAF )
            IF ( AERO_CHEM_SET ) OUTVAL = GAMMAPFMOAF( C1,R1,L1 )

         ! Retrieve HFPODAF Heterogeneous Rate Constant
         CASE ( ID_KHFPODAF )
            IF ( AERO_CHEM_SET ) OUTVAL = KpartHFPODAF( C1,R1,L1 )

         ! Retrieve COF2 Heterogeneous Rate Constant
         CASE ( ID_KCOF2 )
            IF ( AERO_CHEM_SET ) OUTVAL = KpartCOF2( C1,R1,L1 )

         ! Retrieve PFMOAF Heterogeneous Rate Constant
         CASE ( ID_KPFMOAF )
            IF ( AERO_CHEM_SET ) OUTVAL = KpartPFMOAF( C1,R1,L1 )
 
         ! Sum Total PFAS in Gas Phase
         CASE ( ID_PFAS_GAS )
            VAL = 0.0
            DO IPFAS = 1,NPFAS
                IF ( MAP_PFAStoGAS( IPFAS ) .NE. 0 .AND. 
     &               .NOT. PFAS( IPFAS )%VIRTUAL ) THEN
                   VAL = VAL + CONC_VEC( MAP_PFAStoGAS( IPFAS ) ) *
     &                      CGRID_MW( MAP_PFAStoGAS( IPFAS ) ) / MWAIR *
     &                      1000.0 * AIRDENS  ! ug m-3
                ENDIF
            END DO
            OUTVAL = VAL

         ! Sum Total PFAS in Particle Phase
         CASE ( ID_PFAS_AER )
            VAL = 0.0
            DO IPFAS = 1,NPFAS
              DO IMODE = 1,N_MODE
                 IF ( MAP_PFAStoAERO( IPFAS ) .NE. 0 .AND.
     &                .NOT. PFAS( IPFAS )%VIRTUAL ) THEN
                    VAL = VAL + AEROSPC_CONC( MAP_PFAStoAERO( IPFAS),IMODE )
                 ENDIF
              END DO
            END DO
            OUTVAL = VAL

         ! Sum Total PFAS
         CASE ( ID_PFAS_TOT )
            ! Calculate Vapor and Particle PFAS mass concentrations and
            ! add them together.
            VAL = 0.0
            VAL2 = 0.0
            CALL CALC_ELMO( OUTVAL=VAL, OUT_UNIT=IU_UGpM3,
     &                      J=J_PFAS_GAS( ISRC+1 ), IERR=IERR )
            CALL CALC_ELMO( OUTVAL=VAL, OUT_UNIT=IU_UGpM3,
     &                      J=J_PFAS_AER( ISRC+1 ), IERR=IERR )
            OUTVAL = VAL + VAL2
 
         ! Sum Total PFAS Wet Deposition from Gas Phase
         CASE ( ID_WD_PFAS_GAS )
            VAL = 0.0
            DO IPFAS = 1,NPFAS
                IF ( MAP_PFAStoGAS( IPFAS ) .NE. 0 .AND. 
     &               .NOT. PFAS( IPFAS )%VIRTUAL ) THEN
                   VAL = VAL + WDEP_VEC( MAP_PFAStoGAS( IPFAS ) ) 
                ENDIF
            END DO
            OUTVAL = VAL 

         ! Sum Total PFAS Wet Deposition from Gas Phase
         CASE ( ID_WD_PFAS_AER )
            VAL = 0.0
            DO IPFAS = 1,NPFAS
              DO IMODE = 1,N_MODE
                IF ( MAP_PFAStoAERO( IPFAS ) .NE. 0 .AND. 
     &               .NOT. PFAS( IPFAS )%VIRTUAL ) THEN
                   IF ( AEROSPC_MAP( MAP_PFAStoAERO(IPFAS),IMODE) .NE. 0 ) 
     &                  VAL = VAL + WDEP_VEC( AEROSPC_MAP( MAP_PFAStoAERO(IPFAS),IMODE ) )
                ENDIF
              END DO
            END DO
            OUTVAL = VAL 
 
         ! Sum Total PFAS Wet Deposition from Gas Phase
         CASE ( ID_WD_PFAS_TOT )
            VAL = 0.0
            VAL2 = 0.0
            CALL CALC_ELMO( OUTVAL=VAL, OUT_UNIT=IU_KGpHA,
     &                      J=J_WD_PFAS_GAS( ISRC+1 ), IERR=IERR )
            CALL CALC_ELMO( OUTVAL=VAL, OUT_UNIT=IU_KGpHA,
     &                      J=J_WD_PFAS_AER( ISRC+1 ), IERR=IERR )
            OUTVAL = VAL + VAL2 
         
         ! Sum Total PFAS Dry Deposition from Gas Phase
         CASE ( ID_DD_PFAS_GAS )
            VAL = 0.0
            DO IPFAS = 1,NPFAS
                IF ( MAP_PFAStoGAS( IPFAS ) .NE. 0 .AND. 
     &               .NOT. PFAS( IPFAS )%VIRTUAL ) THEN
                   VAL = VAL + DDEP_VEC( MAP_PFAStoGAS( IPFAS ) ) 
                ENDIF
            END DO
            OUTVAL = VAL 

         ! Sum Total PFAS Dry Deposition from Gas Phase
         CASE ( ID_DD_PFAS_AER )
            VAL = 0.0
            DO IPFAS = 1,NPFAS
              DO IMODE = 1,N_MODE
                IF ( MAP_PFAStoAERO( IPFAS ) .NE. 0 .AND. 
     &               .NOT. PFAS( IPFAS )%VIRTUAL ) THEN
                   IF ( AEROSPC_MAP( MAP_PFAStoAERO(IPFAS),IMODE) .NE. 0 ) 
     &                  VAL = VAL + DDEP_VEC( AEROSPC_MAP( MAP_PFAStoAERO(IPFAS),IMODE ) )
                ENDIF
              END DO
            END DO
            OUTVAL = VAL 
 
         ! Sum Total PFAS Dry Deposition from Gas Phase
         CASE ( ID_DD_PFAS_TOT )
            VAL = 0.0
            VAL2 = 0.0
            CALL CALC_ELMO( OUTVAL=VAL, OUT_UNIT=IU_KGpHA,
     &                      J=J_DD_PFAS_GAS( ISRC+1 ), IERR=IERR )
            CALL CALC_ELMO( OUTVAL=VAL, OUT_UNIT=IU_KGpHA,
     &                      J=J_DD_PFAS_AER( ISRC+1 ), IERR=IERR )
            OUTVAL = VAL + VAL2
  
         CASE DEFAULT
            ! This Could be a PM mass or organic aerosol derived
            ! concentration or deposition. Check the DRVD_TAB field
            N = ELMO_TABLE( J )%DRVD_TAB
            IF ( N .GT. 0 ) THEN
               IF ( ELMO_DRVD_TAB( N )%ORG_OP .EQ. 0 ) THEN
                  ! Total PM Mass across MODES for INLET
                  OUTVAL = SUM_PM_MODES( ELMO_DRVD_TAB( N )%MODE, 
     &                                   ELMO_DRVD_TAB( N )%INLET, 
     &                                   IWET, IV, ISRC ) 
               ELSE
                  ! Organic Aerosol Concentration or Deposition Metric
                  OUTVAL = SUM_ORGS( ELMO_DRVD_TAB( N )%ORG_OP,
     &                               ELMO_DRVD_TAB( N )%ORG_MASK,
     &                               ELMO_DRVD_TAB( N )%MODE, 
     &                               ELMO_DRVD_TAB( N )%INLET, 
     &                               IWET, IV, ISRC )
               END IF
            END IF
         END SELECT 
 
      END SUBROUTINE ELMO_DERIVED_CALC
 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!-------------------------------------------------------------------------
      SUBROUTINE WRITE_ELMO ( JDATE, JTIME, TSTEP, INIT_TIME )
! Revision history
!   20 Feb - B. Murphy: Created
!-------------------------------------------------------------------------

      USE RUNTIME_VARS
      USE ELMO_DATA, ONLY : N_ELMO_FILES, ELMO_FILE, ELMO_NSTEP,
     &                      ELMO_OUT, ELMO_TABLE, 
     &                      ET_WDEP, ET_DDEP, ET_ISAM_WDEP,
     &                      ET_DDM_WDEP, ET_ISAM_DDEP, ET_DDM_DDEP,
     &                      ET_CMPST_DEP, ET_ISAM_CMPST_DEP, ET_DDM_CMPST_DEP,
     &                      ET_DRVD_DDEP, ET_ISAM_DRVD_DDEP, ET_DDM_DRVD_DDEP,
     &                      ET_DRVD_WDEP, ET_ISAM_DRVD_WDEP, ET_DDM_DRVD_WDEP 
      USE UTILIO_DEFN

      IMPLICIT NONE 

      INCLUDE SUBST_FILES_ID

      INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP(3)
      LOGICAL, INTENT( IN ) :: INIT_TIME
      INTEGER MDATE, MTIME
      INTEGER IVAR, IV, IFL, J
      CHARACTER( 300 ) XMSG

      CHARACTER( 16 ), SAVE :: PNAME = 'WRITE_ELMO'

      DO IFL = 1,N_ELMO_FILES
        
        SELECT CASE ( ELMO_FILE( IFL )%TMODE )

        CASE ( 0 )
          ! *** Write data to an instantaneous output file.
#ifndef mpas
          MDATE = JDATE
          MTIME = JTIME

          IF ( .NOT. WRITE3( ELMO_FILE( IFL )%FLOGICAL, 
     &       ALLVAR3, MDATE, MTIME,
     &       ELMO_OUT(IFL)%DATA(:,:,:,:) ) ) THEN
             XMSG = 'Could not write ' // 
     &              ELMO_FILE(IFL)%FLOGICAL // ' file'
             CALL M3EXIT ( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
          END IF

          WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &                   'Timestep written to', ELMO_FILE(IFL)%FLOGICAL,
     &                   'for date and time', MDATE, MTIME

#endif
        CASE ( 1 )
          ! *** Write data to a time-averaged output file.
          IF ( .NOT.INIT_TIME ) THEN
#ifndef mpas
            MDATE = JDATE
            MTIME = JTIME
            IF ( .NOT. END_TIME ) THEN   ! ending time timestamp
               CALL NEXTIME ( MDATE, MTIME, -TSTEP(1) )
            END IF
           
            ! Finalize Values for Averaged Variables
!            DO IVAR = 1,ELMO_FILE( IFL )%N_VARS 
!                J = ELMO_FILE( IFL )%TABID( IVAR )
!                IV = ELMO_TABLE( J )%VAR_TYPE
!                IF ( IV .NE. ET_WDEP .AND. IV .NE. ET_DDEP .AND.
!     &               IV .NE. ET_ISAM_WDEP .AND. IV .NE. ET_ISAM_DDEP .AND.
!     &               IV .NE. ET_DDM_WDEP .AND. IV .NE. ET_DDM_DDEP .AND.
!     &               IV .NE. ET_CMPST_DEP .AND. IV .NE. ET_ISAM_CMPST_DEP .AND.
!     &               IV .NE. ET_DDM_CMPST_DEP .AND. IV .NE. ET_DRVD_DDEP .AND.
!     &               IV .NE. ET_ISAM_DRVD_DDEP .AND. IV .NE. ET_DDM_DRVD_DDEP .AND.
!     &               IV .NE. ET_DRVD_WDEP .AND. IV .NE. ET_ISAM_DRVD_WDEP .AND. 
!     &               IV .NE. ET_DDM_DRVD_WDEP ) THEN
!                ELMO_OUT(IFL)%DATA( :,:,:,IVAR ) = ELMO_OUT(IFL)%DATA( :,:,:,IVAR )
!     &                                        / 2.0 / (ELMO_NSTEP - 1.0)
!                END IF
!            END DO
           
            ! Write Data
            IF ( .NOT. WRITE3( ELMO_FILE( IFL )%FLOGICAL, 
     &           ALLVAR3, MDATE, MTIME, 
     &           ELMO_OUT(IFL)%DATA(:,:,:,:) ) ) THEN
               XMSG = 'Could not write ' // 
     &                ELMO_FILE( IFL )%FLOGICAL // ' file'
               CALL M3EXIT ( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
           
            WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &                       'Timestep written to', CTM_AELMO_1,
     &                       'for date and time', MDATE, MTIME
           
           
#endif     
          END IF
        END SELECT
      END DO

      IF ( .NOT. INIT_TIME ) THEN
         ELMO_NSTEP = 0.
      END IF
      
      RETURN 

      END SUBROUTINE WRITE_ELMO

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!-----------------------------------------------------------------------
      Module XY_BUDGET

!  Collects Advection Process Rates
!
!-----------------------------------------------------------------------

      Implicit None

      SAVE

      ! These Arrays are sorted in the same manner as CGRID so they may
      ! be directly applied in modules like Process Analysis and ISAM
      REAL, ALLOCATABLE :: DELC_XADV  ( :,:,:,: ) ! Change in Species due to X Advection
      REAL, ALLOCATABLE :: DELC_YADV  ( :,:,:,: )   ! Change in Species due to Y Advection

      ! Total burden change at boundaries due to advection. The units are
      ! moles for gases, grams for particle mass, 1 for particle number, 
      ! and m2 for particle surface area. The conversion total burden
      ! must be done at this level because of variability in vertical
      ! grid cell height over the model output time step.
      REAL, ALLOCATABLE :: F_WEST_IN  ( :,: ) ! Mass entering the western boundary
      REAL, ALLOCATABLE :: F_WEST_OUT ( :,: ) ! Mass leaving the western boundary
      REAL, ALLOCATABLE :: F_EAST_IN  ( :,: ) ! Mass entering the eastern boundary
      REAL, ALLOCATABLE :: F_EAST_OUT ( :,: ) ! Mass leaving the eastern boundary
      REAL, ALLOCATABLE :: F_SOUTH_IN ( :,: ) ! Mass entering the southern boundary 
      REAL, ALLOCATABLE :: F_SOUTH_OUT( :,: ) ! Mass leaving the southern boundary  
      REAL, ALLOCATABLE :: F_NORTH_IN ( :,: ) ! Mass entering the northern boundary 
      REAL, ALLOCATABLE :: F_NORTH_OUT( :,: ) ! Mass leaving the northern boundary  

C-----------------------------------------------------------------------

      End Module XY_BUDGET

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
      MODULE MEGAN_HRNO_MOD

      CONTAINS
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE MEGAN_HRNO( JDATE, JTIME, TSTEP, L_DESID_DIAG, PRECADJ)

C-----------------------------------------------------------------------
C Description:
C Similar to HRNO.F, this module outputs hourly rainfall to
C a soilout file at the end of the day. It also outputs LAI for daily 
C growth calculations that are needed by MEGAN, and hourly
C shortwave radiation and 2m temperature for daily averaging.
C Lastly, it calculates PRECADJ for use in megan_fx.f90. The 
C soil NO emissions are calculated in megan_fx.f90 and the YL95
C implementation varies in minor ways from in BEIS. 
C There are three parts to this subroutine:
C  Part 1: keeping track of rainfall pulses
C  Part 2: calculating precadj
C  Part 3: writing to the soilout file
C Please see documentation for more information.    
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE HGRD_DEFN             ! horizontal domain specifications
      USE BEIS_DEFN, ONLY: NSEF ! beis
      USE ASX_DATA_MOD
      USE UTILIO_DEFN
#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif
      USE centralized_io_module

      IMPLICIT NONE
        
C Includes:

C Arguments:
      INTEGER, INTENT( IN )  :: JDATE           ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN )  :: JTIME           ! current simulation time (HHMMSS)
      INTEGER, INTENT( IN )  :: TSTEP( 3 )      ! time step vector (HHMMSS)
      LOGICAL, INTENT( IN )  :: L_DESID_DIAG
      REAL,    INTENT( OUT ) :: PRECADJ( :,: )  ! output precip adjustment
#ifdef mpas
      integer, save :: output_step, half_syn_step  ! values are in seconds
#endif



C External Functions
      LOGICAL,         EXTERNAL :: CHKGRID

C Parameters:
      INTEGER, PARAMETER :: MXRHRS = 24     ! no. of rainfall hours for YL95 algorithm
      INTEGER, PARAMETER :: LSM_WATER = 14
        
C Saturation values for 11 soil types from pxpbl.F  (MCIP PX version)
C In LSM_MOD:WSAT
C Pleim-Xiu Land-Surface and PBL Model (PX-LSM)
C See Jacquemin B. and Noilhan J. (1990), Bound.-Layer Meteorol., 52, 93-134.

C Local Variables:

      CHARACTER( 16 ), SAVE :: MNAME   ! logical name for MET_CRO_2D
      CHARACTER( 16 ), SAVE :: SOILINP ! logical name for input NO soil data
      CHARACTER( 16 ), SAVE :: SOILOUT      = 'MEGAN_SOILOUT' ! logical name for output NO soil data
      CHARACTER( 33 ), SAVE :: DESCSTR      = 'hrly cnv. & non-cnv. rainfall for'
      CHARACTER( 33 ), SAVE :: DESCSTRSW    = 'hrly instantaneous rgrnd for'
      CHARACTER( 33 ), SAVE :: DESCSTRT2M   = 'hrly instantaneous 2m temp for'
      CHARACTER( 33 ), SAVE :: DESCSTRLAI   = 'LAI for day'


      CHARACTER( 16 ) :: VAR        ! variable name

      INTEGER, SAVE :: IHR       ! current simulation hour
      INTEGER          NDX       ! RAINFALL array timestep index


      REAL,    ALLOCATABLE, SAVE :: C_RAINFALL ( :,: ) ! rainfall for current hour
      REAL,    ALLOCATABLE, SAVE :: RNTOT    ( :,: )  ! RN + RC
      INTEGER, SAVE :: RHOURS    ! SOILINP(OUT) file no. of RAINFALL hour variables
      INTEGER, SAVE :: RDATE     ! date to update rainfall
      INTEGER, SAVE :: RTIME     ! time to update rainfall
      INTEGER, SAVE :: EDATE     ! end scenario date
      INTEGER, SAVE :: ETIME     ! end scenario time
      INTEGER, SAVE :: NDATE     ! test date to update rainfall
      INTEGER, SAVE :: NTIME     ! test time to update rainfall
        
      LOGICAL, SAVE :: INITIAL_DAY = .FALSE.  ! true: 1st 24 hours; no previous data
                                              ! false: previous 24 hours of rainfall
                                              ! are available for HRNO

      INTEGER          SOILCAT            ! soil category
      INTEGER, SAVE :: MSTEPS             ! run no. of steps
      INTEGER          I, J, K, R, C, L   ! counters
      INTEGER          IOS                ! IO or memory allocation status
      INTEGER, SAVE :: METSTEP            ! met_cro_2d time step
      
      REAL             FAC2

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 256 ) :: MESG            ! message buffer
      CHARACTER( 16 )  :: PNAME = 'MEG_HRNO'  ! procedure name

#ifdef mpas
      integer :: io_mode
      CHARACTER( 20 ) :: time_stamp
#endif

      LOGICAL, EXTERNAL :: FLUSH3


C-----------------------------------------------------------------------------
C--- Part 1: Keeping track of rainfall pulses
C-----------------------------------------------------------------------------

      PRECADJ = 0.0

      IF ( FIRSTIME ) THEN
!        FIRSTIME = .FALSE.

C Determine last timestamp
         EDATE = STDATE; ETIME = STTIME
         CALL NEXTIME( EDATE, ETIME, RUNLEN )   ! end date & time
         MSTEPS = TIME2SEC( RUNLEN ) / TIME2SEC( TSTEP( 1 ) )

#ifdef mpas
         if (ncd_64bit_offset) then
            io_mode = ior (nf90_noclobber, nf90_64bit_offset)
         else
            io_mode = nf90_noclobber
         end if

         call mio_fcreate (SOILOUT, io_mode)
         METSTEP = TSTEP(3)

         output_step   = time2sec(tstep(1))
         half_syn_step = time2sec(tstep(2)) / 2
#else

C Open met file
         MNAME = PROMPTMFILE(
     &           'Enter name for gridded met input file',
     &           FSREAD3, 'MET_CRO_2D', PNAME )

C Get description of met file
         IF ( .NOT. DESC3( MNAME ) ) THEN
            MESG = 'Could not get description of file "'
     &           // TRIM( MNAME ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF

         METSTEP = TSTEP3D

C Check that grid description matches B3GRD file
         IF ( .NOT. CHKGRID( MNAME ) ) THEN
            MESG = 'Grid in file "' // TRIM( MNAME )
     &           // '" does not match grid in file ' // TRIM( MNAME ) // '"'
#ifdef twoway
            CALL M3WARN( PNAME, 0, 0, MESG )
#else
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
#endif
         END IF
#endif

         ALLOCATE( RNTOT( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'RNTOT', PNAME )

C Initial run until a full 24 hours has been recorded on the SOIL(OUT/INP) file
C for the Yienger and Levy algorithm
         WRITE( LOGDEV,'(/5X, A)' ) 'Temporal BEIS ...'
         RHOURS = MXRHRS

C If initial run, initialize some variables, otherwise get them from file
         IF ( NEW_START .or. IGNORE_SOILINP ) THEN

            PULSEDATE = 0   ! array
            PULSETIME = 0   ! array
            PTYPE     = 0   ! array

         END IF   ! initial run

         ALLOCATE( C_RAINFALL( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'RAINFALL', PNAME )
         C_RAINFALL = 0.0 ! array

         RDATE = STDATE; RTIME = STTIME
!        IHR = 0

      END IF   ! FIRSTIME

C Non-convective (RN) and convective (RC) rain is the total amount for the met
C preprocessor's (typically MCIP) output timestep (typically one hour). It doesn't
C make sense to time-interpolate these values, since rain generally does not fall
C at a constant rate for an output timestep.
      IF ( .NOT. CURRSTEP( JDATE, JTIME, STDATE, STTIME, METSTEP,
     &                     NDATE, NTIME ) ) THEN
         MESG = 'Cannot get step date and time'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT3 )
      END IF

C Store current time step rainfall totals
      IF ( NDATE .EQ. RDATE .AND. NTIME .EQ. RTIME ) THEN   ! on the METSTEP

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            IHR = MOD( RTIME / 10000 + 23, 24 )  ! previous hour bin,
                                                 ! to accommodate non-zero start hour
         END IF

C For the first hour of the simulation day, use the previous 24 hour
C data to compute precip adjustment

         NDX = 1 + MOD( IHR, MXRHRS )
         C_RAINFALL = C_RAINFALL + MET_DATA%RN + MET_DATA%RC
         WRITE( DDTTM( NDX ),'(I8,":",I6.6)' ) RDATE, RTIME

#ifdef mpas
            call mio_time_format_conversion (ndate, ntime, time_stamp)
#endif
         IF ( MOD( NTIME, 10000 ) .EQ. 0 ) THEN    ! at the hourly mark
            RAINFALL( :,:,NDX ) = C_RAINFALL
            C_RAINFALL = 0.0
            HRNO_SW( :,:,NDX )  = MET_DATA%RGRND
            HRNO_T2M( :,:,NDX ) = MET_DATA%TEMP2
            IHR = IHR + 1
#ifdef mpas
            call mio_fwrite ('MEGAN_SOILOUT', 'RAINFALL', pname,RAINFALL(:,1,ndx), time_stamp)
            call mio_fwrite ('MEGAN_SOILOUT', 'T24', pname, HRNO_T2M(:,1,ndx),time_stamp)
            call mio_fwrite ('MEGAN_SOILOUT', 'SW24', pname, HRNO_SW(:,1,ndx),time_stamp)
#endif
         END IF

!        CALL NEXTIME( RDATE, RTIME, TSTEP( 1 ) )
         CALL NEXTIME( RDATE, RTIME, METSTEP )

         RNTOT = 0.0   ! array assignment
         IF ( NEW_START .or. IGNORE_SOILINP) THEN
            IF ( IHR .LT. MXRHRS ) THEN
               INITIAL_DAY = .TRUE.
            ELSE
               INITIAL_DAY = .FALSE.
            END IF
         ELSE   ! store accumulated rain in RNTOT array
            DO I = 1, MXRHRS
               RNTOT = RNTOT + RAINFALL( :,:,I )
            END DO
         END IF

         write( logdev,* ) 'hrno - INITIAL_DAY, IHR: ', initial_day, ihr
#ifdef verbose_hrno

         write( logdev,* ) 'hrno - INITIAL_DAY, IHR: ', initial_day, ihr
#endif

      END IF   ! on the METSTEP


C-----------------------------------------------------------------------------
C--- Part 2: CALCULATING PRECADJ
C-----------------------------------------------------------------------------
      ! just calculate FAC2 always. MEGAN YL95 will work out if it's growseason

         DO R = 1, NROWS
            DO C = 1, NCOLS

               IF ( PX_LSM .OR. CLM_LSM .OR. NOAH_LSM ) THEN

                  IF ( INITIAL_DAY ) THEN
                     FAC2 = 1.0
                     PTYPE( C,R ) = 0
                     PULSEDATE( C,R ) = 0
                     PULSETIME( C,R ) = 0
                  ELSE
                     FAC2 = PRECIP_ADJ_PX( JDATE, JTIME, RNTOT( C,R ),
     &                                     MET_DATA%SOIM1( C,R ),
     &                                     Grid_Data%WSAT( C,R ), PTYPE( C,R ), 
     &                                     PULSEDATE( C,R ), PULSETIME( C,R ) )
                     PRECADJ( C,R) = FAC2
                  END IF

               ELSE

                  IF ( INITIAL_DAY ) THEN
                     FAC2 = 1.0
                     PTYPE( C,R ) = 0
                     PULSEDATE( C,R ) = 0
                     PULSETIME( C,R ) = 0
                  ELSE
                     FAC2 = PRECIP_ADJ( JDATE, JTIME, RNTOT( C,R ),
     &                                  PTYPE( C,R ), PULSEDATE( C,R ),
     &                                  PULSETIME( C,R ) )
                     PRECADJ( C,R) = FAC2
                  END IF

               END IF  ! PX version check

            END DO  ! columns
         END DO  ! rows

C-----------------------------------------------------------------------------
C--- Part 3: Writing to soilout file
C-----------------------------------------------------------------------------
#ifdef mpas
      IF ( MOD((TIME2SEC( JTIME ) - half_syn_step), output_step) .EQ. 0 .and. .not. l_desid_diag) then
      ! at the hourly mark
      ! continue to write
      else
        RETURN
      end if
#else
       IF ( SECSDIFF( JDATE,JTIME, EDATE,ETIME ) .GT. TIME2SEC( TSTEP( 2 ) ) .OR. L_DESID_DIAG ) RETURN
#endif


C Create rain data file for soil NO

C Final timestamp
      NDATE = EDATE; NTIME = ETIME

#ifndef mpas

C Build description for, and create/open soil NO emissions output file
      FTYPE3D = GRDDED3
      SDATE3D = NDATE
      STIME3D = NTIME
      TSTEP3D = 0   ! make it a time-independent file
      NCOLS3D = GL_NCOLS
      NROWS3D = GL_NROWS
      NLAYS3D = 1
      NVARS3D = 52 + RHOURS
      MXREC3D = 1
      NTHIK3D = 1
      GDTYP3D = GDTYP_GD
      P_ALP3D = P_ALP_GD
      P_BET3D = P_BET_GD
      P_GAM3D = P_GAM_GD
      XORIG3D = XORIG_GD
      YORIG3D = YORIG_GD
      XCENT3D = XCENT_GD
      YCENT3D = YCENT_GD
      XCELL3D = XCELL_GD
      YCELL3D = YCELL_GD
      VGTYP3D = VGTYP_GD
      VGTOP3D = VGTOP_GD
      DO L = 1, NLAYS3D + 1
         VGLVS3D( L ) = VGLVS_GD( L )
      END DO
      GDNAM3D = GRID_NAME  ! from HGRD_DEFN

      VNAME3D = ' '
      VNAME3D( 1 ) = 'PTYPE'
      VNAME3D( 2 ) = 'PULSEDATE'
      VNAME3D( 3 ) = 'PULSETIME'

      DO I = 1, RHOURS
         WRITE( VAR, '(A8,I2.2)' ) 'RAINFALL', I
         VNAME3D( I+3 ) = VAR
         WRITE( VAR, '(A2,I2.2)' ) 'SW', I
         VNAME3D( I+27 ) = VAR
         WRITE( VAR, '(A3,I2.2)' ) 'T2M', I
         VNAME3D( I+51 ) = VAR
      END DO

         VNAME3D( 52+RHOURS ) = 'LAI'

      UNITS3D = ' '
      UNITS3D( 1 ) = 'INTEGER'
      UNITS3D( 2 ) = 'YYYYDDD'
      UNITS3D( 3 ) = 'HHMMSS'
      UNITS3D( 4:RHOURS+3 ) = 'cm'

      VDESC3D( 1 ) = 'NO emission pulse type'
      VDESC3D( 2 ) = 'CMAQ starting date for NO emission pulse'
      VDESC3D( 3 ) = 'CMAQ starting time for NO emission pulse'
      VDESC3D( 4:RHOURS+3 ) = 'hourly convective and non-convective rainfall'
      DO I = 1, RHOURS
         VDESC3D( I+3 )  = DESCSTR // DDTTM( I )
         VDESC3D( I+27 ) = DESCSTRSW // DDTTM( I )
         VDESC3D( I+51 ) = DESCSTRT2M // DDTTM( I )
      END DO
         VDESC3D( I+52 ) = DESCSTRLAI

      VTYPE3D = 0
      VTYPE3D( 1 ) = M3INT
      VTYPE3D( 2 ) = M3INT
      VTYPE3D( 3 ) = M3INT
      VTYPE3D( 4:RHOURS+52 ) = M3REAL

      FDESC3D = ' '
      FDESC3D( 1 ) = 'Gridded rainfall data for soil NO emissions'
      FDESC3D( 2 ) = '/From/ ' // PNAME
      FDESC3D( 3 ) = '/Version/ CMAQ'

C Open NO rain data save file
      IF ( IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( SOILOUT, FSNEW3, PNAME ) ) THEN
            MESG = 'Could not open "' // TRIM( SOILOUT ) // '" file'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT1 )
         END IF
      END IF

#ifdef parallel_io
      IF ( IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. FLUSH3 ( SOILOUT ) ) THEN
            MESG = 'Could not sync to disk ' // TRIM( SOILOUT )
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END IF
      CALL SE_BARRIER
      IF ( .NOT. IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( SOILOUT, FSREAD3, PNAME ) ) THEN
            MESG = 'Could not open ' // TRIM( SOILOUT )
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END IF
#endif

C Write soil NO rain data file

      VAR = 'PTYPE'
      IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, PTYPE ) ) THEN
         MESG = 'Could not write "' // TRIM( VAR ) //
     &          '" to file "' // TRIM( SOILOUT ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF

      VAR = 'PULSEDATE'
      IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, PULSEDATE ) ) THEN
         MESG = 'Could not write "' // TRIM( VAR ) //
     &          '" to file "' // TRIM( SOILOUT ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF

      VAR = 'PULSETIME'
      IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, PULSETIME ) ) THEN
         MESG = 'Could not write "' // TRIM( VAR ) //
     &          '" to file "' // TRIM( SOILOUT ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF

      NDX = 1 + MOD( IHR, MXRHRS )
      RAINFALL( :,:,NDX ) = C_RAINFALL
      DO I = 1, RHOURS
         WRITE( VAR, '(A8,I2.2)' ) 'RAINFALL', I
         IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, RAINFALL( :,:,I ) ) ) THEN
            MESG = 'Could not write "' // TRIM( VAR ) //
     &             '" to file "' // TRIM( SOILOUT ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
         WRITE( VAR, '(A2,I2.2)' ) 'SW', I
         IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, HRNO_SW( :,:,I ) ) ) THEN
            MESG = 'Could not write "' // TRIM( VAR ) //
     &             '" to file "' // TRIM( SOILOUT ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
         WRITE( VAR, '(A3,I2.2)' ) 'T2M', I
         IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, HRNO_T2M( :,:,I ) ) ) THEN
            MESG = 'Could not write "' // TRIM( VAR ) //
     &             '" to file "' // TRIM( SOILOUT ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END DO

         IF ( .NOT. WRITE3( SOILOUT, 'LAI', NDATE, NTIME, Met_data%LAI )) THEN
            MESG = 'Could not write "' // TRIM( VAR ) //
     &             '" to file "' // TRIM( SOILOUT ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF

#else
         ! write MPAS end of day variables ==jwilliso
            call mio_fwrite ('MEGAN_SOILOUT', 'PTYPE', pname,PTYPE(:,1),time_stamp)
            call mio_fwrite ('MEGAN_SOILOUT', 'PULSEDATE', pname, PULSEDATE(:,1),time_stamp)
            call mio_fwrite ('MEGAN_SOILOUT', 'PULSETIME', pname, PULSETIME(:,1),time_stamp)
            call mio_fwrite ('MEGAN_SOILOUT', 'LAI', pname,Met_data%LAI(:,1),time_stamp)
#endif

      WRITE( LOGDEV,94040 )
     &      'Timestep written to', SOILOUT,
     &      'for date and time', NDATE, NTIME

      RETURN

94010 FORMAT( A, F10.2, 1X, A, I3, ',', I3 )
94040 FORMAT( /5X, 3( A, :, 1X ), I8, ":", I6.6 )

C-----------------------------------------------------------------------

      CONTAINS

         REAL FUNCTION PRECIP_ADJ_PX( JDATE, JTIME, RAIN, SOILM, WSAT,
     &                                PTYPE, PULSEDATE, PULSETIME )

C-----------------------------------------------------------------------
 
C Description:
   
C    Compute precipitation adjustment factor for estimate of NO emissions 
C    Uses: julian day, time, soil moisture
C    Requires the use of three arrays that are re-used each time step:
C    PTYPE, PULSEDATE, PULSETIME 
C    These arrays store the type of NO pulse initiated by the rainfall
C    and the starting date and time of the pulse.
 
C Preconditions:
C    Soil Moisture current time, Soil Moisture previous time,
C    Soil type, Land Use, PTYPE, PULSEDATE, PULSETIME 
 
C Subroutines and Functions Called:
C    precipfact - computes precip adjustment factor from rainrate and time
C                 since pulse initiation
C    pulsetype  - determines type & duration of NO emission pulse from rainrate
 
C Revision History:
C    11/01 : Prototype by GAP
C    3/05  : create separate functions for PX vs non-PX versions
C    1/10  : J.Young - restructure
C    7/31/19 J. Pleim : Corrected Soil Types and Simplified Code
C-----------------------------------------------------------------------

         USE UTILIO_DEFN

         IMPLICIT NONE

C Function arguments:
         INTEGER, INTENT( IN )    :: JDATE, JTIME
         REAL,    INTENT( IN )    :: RAIN
         REAL,    INTENT( IN )    :: SOILM     ! only avilable if PX version
         REAL,    INTENT( IN )    :: WSAT      ! only tested for PX and CLM versions         
         INTEGER, INTENT( INOUT ) :: PTYPE     ! pulse type
         INTEGER, INTENT( INOUT ) :: PULSEDATE ! date of pulse start
         INTEGER, INTENT( INOUT ) :: PULSETIME ! date of pulse end

C External functions:
         
C Parameters:
         REAL, PARAMETER :: SAT_THRES = 0.95

C Local variables:
         INTEGER SOILCAT     ! soil type category
         INTEGER PTYPE_TEST

C-----------------------------------------------------------------------

C Summary of algorithm
C   1. compute rate of change of soil moisture from soil moisture
C   2. estimate rainrate from soil moisture and soil moisture rate
C   3. compute adjustment using pulsetype, rainrate, ptype, and date/time
C        if stronger NO pulse compared to previous time step, then
C        start a new NO emission pulse,
C        otherwise continue present NO pulse
C   4. override adjustment for saturated soils 

         SOILCAT = GRID_DATA%SLTYP( C,R )
         IF ( SOILCAT .NE. LSM_WATER  ) THEN 
            IF ( SOILM .GE. SAT_THRES * WSAT ) THEN
               PRECIP_ADJ_PX = 0.0
            ELSE
               PTYPE_TEST = PULSETYPE( RAIN )
               IF ( PTYPE_TEST .GT. PTYPE ) THEN ! Rainfall class type increases
                  PULSEDATE = JDATE              ! (NO emission pulse generated)
                  PULSETIME = JTIME
                  PTYPE = PTYPE_TEST
               END IF
               PRECIP_ADJ_PX = PRECIPFAC( JDATE, JTIME, PULSEDATE, PULSETIME, PTYPE )
            END IF
         ELSE
            PRECIP_ADJ_PX = 0.0
         END IF

         RETURN
         
         END FUNCTION PRECIP_ADJ_PX
         
C-----------------------------------------------------------------------

         REAL FUNCTION PRECIP_ADJ( JDATE, JTIME, RAIN,
     &                             PTYPE, PULSEDATE, PULSETIME )

C-----------------------------------------------------------------------
C Description:
   
C    Compute precipitation adjustment factor for estimate of NO emissions 
C    Uses: julian day, time, soil moisture
C    Requires the use of three arrays that are re-used each time step:
C    PTYPE, PULSEDATE, PULSETIME 
C    These arrays store the type of NO pulse initiated by the rainfall
C    and the starting date and time of the pulse.
 
C Preconditions:
C    Soil Moisture current time, Soil Moisture previous time,
C    Soil type, Land Use, PTYPE, PULSEDATE, PULSETIME 
 
C Subroutines and Functions Called:
C    precipfact - computes precip adjustment factor from rainrate and time
C                 since pulse initiation
C    pulsetype  - determines type & duration of NO emission pulse from rainrate
 
C Revision History:
C    11/01 : Prototype by GAP
C    3/05  : created a non-PX version of this function 
C    1/10  : J.Young - restructure
  
C-----------------------------------------------------------------------

         USE UTILIO_DEFN

         IMPLICIT NONE

C Function arguments:
         INTEGER, INTENT( IN )    :: JDATE, JTIME
         REAL,    INTENT( IN )    :: RAIN
         INTEGER, INTENT( INOUT ) :: PTYPE     ! pulse type
         INTEGER, INTENT( INOUT ) :: PULSEDATE ! date of pulse start
         INTEGER, INTENT( INOUT ) :: PULSETIME ! time of pulse start

C External functions:

C Local variable
         INTEGER PTYPE_TEST

C-----------------------------------------------------------------------

C Summary of algorithm
C    1. if no rainfall or new rainfall class less than current one, continue
C       existing NO emission pulse
C    2. if new rainfall that increases rainfall class, then create new NO
C       emission pulse using pulsetype, rainrate, ptype, and date/time -
C       if stronger NO pulse compared to previous time step, then start
C       a new NO emission pulse

         PTYPE_TEST = PULSETYPE( RAIN )
         IF ( PTYPE_TEST .GT. PTYPE ) THEN ! Rainfall class type increases
            PULSEDATE = JDATE              ! (NO emission pulse generated)
            PULSETIME = JTIME
            PTYPE = PTYPE_TEST
         END IF

         PRECIP_ADJ = PRECIPFAC( JDATE, JTIME, PULSEDATE, PULSETIME, PTYPE )

         RETURN
         
         END FUNCTION PRECIP_ADJ

C-----------------------------------------------------------------------

         REAL FUNCTION PRECIPFAC( JDATE, JTIME, PDATE, PTIME, PTYPE )

C Compute a precipitation adjustment factor from a previous 24 hour rainfall
C based on YL 1995
C The pulse type is an integer ranging from 0 to 3 indicating the type of
C rainfall rate:
C If rainfall < 0.1 cm in last 24 hr, "reset"
C Else if rainfall < 0.5 cm in last 24 hr, and time since last pulse is .ge. 2 days,
C    reset; else, precipfact=11.19*...
C Else if rainfall < 1.5 cm in last 24 hr, and time since last pulse is .ge. 6 days,
C    reset; else, precipfact=14.68*...
C Else if rainfall >=1.5 cm in last 24 hr, and time since last pulse is .ge. 13 days,
C    reset; else, precipfact=18.46*...

         USE UTILIO_DEFN

         IMPLICIT NONE
         
C Function arguments:
         INTEGER, INTENT( IN )    :: JDATE, JTIME, PDATE, PTIME
         INTEGER, INTENT( INOUT ) :: PTYPE
         
C External functions:

C Parameters:
         REAL, PARAMETER :: DAYPERSEC = 1.0 / ( 24.0 * 3600.0 ) ! = 0.000011574074074

C Local variables:
         REAL DAYDIFF, DAYDIF1
         
C-----------------------------------------------------------------------

         DAYDIFF = FLOAT( SECSDIFF( PDATE, PTIME, JDATE, JTIME ) ) * DAYPERSEC
         DAYDIF1 = DAYDIFF + 1.0
         
         SELECT CASE( PTYPE )
         CASE( 0 )
            PRECIPFAC = 1.0
         CASE( 1 )
            IF ( ( DAYDIFF ) .LT. 2.0 ) THEN
               PRECIPFAC = 11.19 * EXP( -0.805 * DAYDIF1 )
            ELSE
               PTYPE = 0
               PRECIPFAC = 1.0
            END IF
         CASE( 2 )
            IF ( ( DAYDIFF ) .LT. 6.0 ) THEN
               PRECIPFAC = 14.68 * EXP( -0.384 * DAYDIF1 )
            ELSE
               PTYPE = 0
               PRECIPFAC = 1.0
            END IF
         CASE( 3 )
            IF ( ( DAYDIFF ) .LT. 13.0 ) THEN
               PRECIPFAC = 18.46 * EXP( -0.208 * DAYDIF1 )
            ELSE
               PTYPE = 0
               PRECIPFAC = 1.0
            END IF
         CASE DEFAULT
            WRITE( MESG,'( A, I6 )' ) 'Invalid Pulse Type specified ',
     &                                 PTYPE
            CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
         END SELECT
         
         RETURN
         
         END FUNCTION PRECIPFAC
    
C-----------------------------------------------------------------------

         INTEGER FUNCTION PULSETYPE( RAIN )

C Compute the pulse type from the rainfall rate (see YL 1995).

         IMPLICIT NONE
         
C Function arguments
         REAL, INTENT( IN ) :: RAIN   ! [cm/24hr]
         
C-----------------------------------------------------------------------

         IF ( RAIN .LT. 0.1 ) THEN
            PULSETYPE = 0
         ELSE IF ( RAIN .LT. 0.5 ) THEN
            PULSETYPE = 1
         ELSE IF ( RAIN .LT. 1.5 ) THEN
            PULSETYPE = 2
         ELSE
            PULSETYPE = 3
         END IF
         
         RETURN
         
         END FUNCTION PULSETYPE

C-----------------------------------------------------------------------

      END SUBROUTINE MEGAN_HRNO

      END MODULE MEGAN_HRNO_MOD

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! RCS file, release, date & time of last delta, author, state, [and locker]
! $Header: /project/work/rep/STENEX/src/se_snl/se_data_recv_module.f,v 1.2 2006/02/15 14:41:56 yoj Exp $

! what(1) key, module and SID; SCCS file; date and time of last delta:
! %W% %P% %G% %U%

! --------------------------------------------------------------------------
! Purpose:
!
!   use F90 interface feature to achieve "faked" polymorphism for data 
!   receiving routine
!
! Revision history:
!
!   Orginal version: 11/05/99 by David Wong
!
!                    12/04/02 by David Wong
!                       -- modified the routine to accommodate worker and
!                          I/O processors partition scheme
!                    10/01/12 by David Wong
!                       -- reduced memory usage
!                       -- extended to five dimensional array
!
! Note:
!
!   se_[n]d[e]_data_recv where [n] denotes the dimensionality of the data 
!   and [e] is optional, indicates the first two dimensions are not both 
!   decomposed
!
! Subroutine parameter description:
!
!   In:    rind      -- stores low and high index of each dimension for 
!                       receiving process
!          recv_from -- stores processor number which data is received from
!          dir_ind   -- one of those eight major communication directions
!          tag       -- message tag
!
!   InOut: data      -- variable that receives data from other processors
! --------------------------------------------------------------------------

        module se_data_recv_module

          use se_pe_info_ext

          implicit none

          interface se_data_recv
            module procedure se_1d_data_recv,
     &                       se_2d_data_recv, se_2de_data_recv,
     &                       se_3d_data_recv, se_3de_data_recv,
     &                       se_4d_data_recv, se_4de_data_recv,
     &                       se_5d_data_recv
          end interface

          contains

! -----------------------------------------------------------------------------
        subroutine se_1d_data_recv (data, rind, recv_from, dir_ind, tag)

        implicit none
        include "mpif.h"

        real, intent(inout) :: data(:)
        integer, pointer :: rind(:, :), recv_from(:)
        integer, intent(in) :: dir_ind, tag

        integer :: i, rcount, error
        integer :: status(MPI_STATUS_SIZE)
!       real :: rarray(size(data))
        real, allocatable :: rarray(:)

! -- receive data from corresponding processor

        rcount = rind(2,dir_ind) - rind(1,dir_ind) + 1

        allocate (rarray(rcount), stat=error)

        call mpi_recv (rarray, rcount, mpi_real, recv_from(dir_ind),
     &                 tag, se_worker_comm, status, error)

! -- unpack received data
        rcount = 0
        do i = rind(1,dir_ind), rind(2,dir_ind)
           rcount = rcount + 1
           data(i) = rarray(rcount)
        end do

        deallocate (rarray)

        end subroutine se_1d_data_recv

! -----------------------------------------------------------------------------
        subroutine se_2d_data_recv (data, rind, recv_from, dir_ind, tag)

        implicit none
        include "mpif.h"

        real, intent(inout) :: data(:,:)
        integer, pointer :: rind(:, :, :), recv_from(:)
        integer, intent(in) :: dir_ind, tag

        integer :: i, j, rcount, error
        integer :: status(MPI_STATUS_SIZE)
!       real :: rarray(size(data))
        real, allocatable :: rarray(:)

        rcount = (rind(2,1,dir_ind) - rind(1,1,dir_ind) + 1) *
     &           (rind(2,2,dir_ind) - rind(1,2,dir_ind) + 1)

        allocate (rarray(rcount), stat=error)

        call mpi_recv (rarray, rcount, mpi_real, recv_from(dir_ind),
     &                 tag, se_worker_comm, status, error)

! -- unpack received data
        rcount = 0
        do j = rind(1,2,dir_ind), rind(2,2,dir_ind)
           do i = rind(1,1,dir_ind), rind(2,1,dir_ind)
              rcount = rcount + 1
              data(i,j) = rarray(rcount)
           end do
        end do

        deallocate (rarray)

        end subroutine se_2d_data_recv

! -----------------------------------------------------------------------------
        subroutine se_2de_data_recv (data, rind, recv_from, dir_ind, tag)

        implicit none
        include "mpif.h"

        real, intent(inout) :: data(:,:)
        integer, pointer :: rind(:, :), recv_from(:)
        integer, intent(in) :: dir_ind, tag

        integer :: i, j, rcount, error
        integer :: status(MPI_STATUS_SIZE)
!       real :: rarray(size(data))
        real, allocatable :: rarray(:)

        rcount = (rind(2,dir_ind) - rind(1,dir_ind) + 1) *
     &           (ubound(data,2) - lbound(data,2) + 1)

        allocate (rarray(rcount), stat=error)

        call mpi_recv (rarray, rcount, mpi_real, recv_from(dir_ind),
     &                 tag, se_worker_comm, status, error)

! -- unpack received data
        rcount = 0
        do j = lbound(data,2), ubound(data,2)
           do i = rind(1,dir_ind), rind(2,dir_ind)
              rcount = rcount + 1
              data(i,j) = rarray(rcount)
           end do
        end do

        deallocate (rarray)

        end subroutine se_2de_data_recv

! -----------------------------------------------------------------------------
        subroutine se_3d_data_recv (data, rind, recv_from, dir_ind, tag)

        implicit none
        include "mpif.h"

        real, intent(inout) :: data(:,:,:)
        integer, pointer :: rind(:, :, :), recv_from(:)
        integer, intent(in) :: dir_ind, tag

        integer :: i, j, k, rcount, error
        integer :: status(MPI_STATUS_SIZE)
!       real :: rarray(size(data))
        real, allocatable :: rarray(:)

        rcount = (rind(2,1,dir_ind) - rind(1,1,dir_ind) + 1) *
     &           (rind(2,2,dir_ind) - rind(1,2,dir_ind) + 1) *
     &           (rind(2,3,dir_ind) - rind(1,3,dir_ind) + 1)

        allocate (rarray(rcount), stat=error)

        call mpi_recv (rarray, rcount, mpi_real, recv_from(dir_ind),
     &                 tag, se_worker_comm, status, error)

! -- unpack received data
        rcount = 0
        do k = rind(1,3,dir_ind), rind(2,3,dir_ind)
           do j = rind(1,2,dir_ind), rind(2,2,dir_ind)
              do i = rind(1,1,dir_ind), rind(2,1,dir_ind)
                 rcount = rcount + 1
                 data(i,j,k) = rarray(rcount)
              end do
           end do
        end do

        deallocate (rarray)

        end subroutine se_3d_data_recv

! -----------------------------------------------------------------------------
        subroutine se_3de_data_recv (data, rind, recv_from, dir_ind, tag)

        implicit none
        include "mpif.h"

        real, intent(inout) :: data(:,:,:)
        integer, pointer :: rind(:, :), recv_from(:)
        integer, intent(in) :: dir_ind, tag

        integer :: i, j, k, rcount, error
        integer :: status(MPI_STATUS_SIZE)
!       real :: rarray(size(data))
        real, allocatable :: rarray(:)

        rcount = (rind(2,dir_ind) - rind(1,dir_ind) + 1) *
     &           (ubound(data,2) - lbound(data,2) + 1) *
     &           (ubound(data,3) - lbound(data,3) + 1)

        allocate (rarray(rcount), stat=error)

        call mpi_recv (rarray, rcount, mpi_real, recv_from(dir_ind),
     &                 tag, se_worker_comm, status, error)

! -- unpack received data
        rcount = 0
        do k = lbound(data,3), ubound(data,3)
           do j = lbound(data,2), ubound(data,2)
              do i = rind(1,dir_ind), rind(2,dir_ind)
                 rcount = rcount + 1
                 data(i,j,k) = rarray(rcount)
              end do
           end do
        end do

        deallocate (rarray)

        end subroutine se_3de_data_recv

! -----------------------------------------------------------------------------
        subroutine se_4d_data_recv (data, rind, recv_from, dir_ind, tag)

        implicit none
        include "mpif.h"

        real, intent(inout) :: data(:,:,:,:)
        integer, pointer :: rind(:, :, :), recv_from(:)
        integer, intent(in) :: dir_ind, tag

        integer :: i, j, k, l, rcount, error
        integer :: status(MPI_STATUS_SIZE)
!       real :: rarray(size(data))
        real, allocatable :: rarray(:)

        rcount = (rind(2,1,dir_ind) - rind(1,1,dir_ind) + 1) *
     &           (rind(2,2,dir_ind) - rind(1,2,dir_ind) + 1) *
     &           (rind(2,3,dir_ind) - rind(1,3,dir_ind) + 1) *
     &           (rind(2,4,dir_ind) - rind(1,4,dir_ind) + 1)

        allocate (rarray(rcount), stat=error)

        call mpi_recv (rarray, rcount, mpi_real, recv_from(dir_ind),
     &                 tag, se_worker_comm, status, error)

! -- unpack received data
        rcount = 0
        do l = rind(1,4,dir_ind), rind(2,4,dir_ind)
           do k = rind(1,3,dir_ind), rind(2,3,dir_ind)
              do j = rind(1,2,dir_ind), rind(2,2,dir_ind)
                 do i = rind(1,1,dir_ind), rind(2,1,dir_ind)
                    rcount = rcount + 1
                    data(i,j,k,l) = rarray(rcount)
                 end do
              end do
           end do
        end do

        deallocate (rarray)

        end subroutine se_4d_data_recv

! -----------------------------------------------------------------------------
        subroutine se_4de_data_recv (data, rind, recv_from, dir_ind, tag)

        implicit none
        include "mpif.h"

        real, intent(inout) :: data(:,:,:,:)
        integer, pointer :: rind(:, :), recv_from(:)
        integer, intent(in) :: dir_ind, tag

        integer :: i, j, k, s, rcount, error
        integer :: status(MPI_STATUS_SIZE)
!       real :: rarray(size(data))
        real, allocatable :: rarray(:)

        rcount = (rind(2,dir_ind) - rind(1,dir_ind) + 1) *
     &           (ubound(data,2) - lbound(data,2) + 1) *
     &           (ubound(data,3) - lbound(data,3) + 1) *
     &           (ubound(data,4) - lbound(data,4) + 1)

        allocate (rarray(rcount), stat=error)

        call mpi_recv (rarray, rcount, mpi_real, recv_from(dir_ind),
     &                 tag, se_worker_comm, status, error)

! -- unpack received data
        rcount = 0
        do s = lbound(data,4), ubound(data,4)
           do k = lbound(data,3), ubound(data,3)
              do j = lbound(data,2), ubound(data,2)
                 do i = rind(1,dir_ind), rind(2,dir_ind)
                    rcount = rcount + 1
                    data(i,j,k,s) = rarray(rcount)
                 end do
              end do
           end do
        end do

        deallocate (rarray)

        end subroutine se_4de_data_recv

! -----------------------------------------------------------------------------
        subroutine se_5d_data_recv (data, rind, recv_from, dir_ind, tag)

        implicit none
        include "mpif.h"

        real, intent(inout) :: data(:,:,:,:,:)
        integer, pointer :: rind(:, :, :), recv_from(:)
        integer, intent(in) :: dir_ind, tag

        integer :: i, j, k, l, m, rcount, error
        integer :: status(MPI_STATUS_SIZE)
!       real :: rarray(size(data))
        real, allocatable :: rarray(:)

        rcount = (rind(2,1,dir_ind) - rind(1,1,dir_ind) + 1) *
     &           (rind(2,2,dir_ind) - rind(1,2,dir_ind) + 1) *
     &           (rind(2,3,dir_ind) - rind(1,3,dir_ind) + 1) *
     &           (rind(2,4,dir_ind) - rind(1,4,dir_ind) + 1) *
     &           (rind(2,5,dir_ind) - rind(1,5,dir_ind) + 1)

        allocate (rarray(rcount), stat=error)

        call mpi_recv (rarray, rcount, mpi_real, recv_from(dir_ind),
     &                 tag, se_worker_comm, status, error)

! -- unpack received data
        rcount = 0
        do m = rind(1,5,dir_ind), rind(2,5,dir_ind)
           do l = rind(1,4,dir_ind), rind(2,4,dir_ind)
              do k = rind(1,3,dir_ind), rind(2,3,dir_ind)
                 do j = rind(1,2,dir_ind), rind(2,2,dir_ind)
                    do i = rind(1,1,dir_ind), rind(2,1,dir_ind)
                       rcount = rcount + 1
                       data(i,j,k,l,m) = rarray(rcount)
                    end do
                 end do
              end do
           end do
        end do

        deallocate (rarray)

        end subroutine se_5d_data_recv

        end module se_data_recv_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE UDTYPES

C-----------------------------------------------------------------------
C Function: User-defined types

C Revision History:
C     21 Nov 2007 J.Young: initial implementation
C     22 Dec 2023 C.Nolte: changed from pointers to allocatable arrays,
C                          removed unused types
C-----------------------------------------------------------------------

      IMPLICIT NONE

      TYPE :: IARRY1
         INTEGER, ALLOCATABLE :: ARRY( : )
         INTEGER              :: LEN
      END TYPE IARRY1

      TYPE :: RARRY1
         REAL, ALLOCATABLE  :: ARRY( : )
         INTEGER            :: LEN
      END TYPE RARRY1

      TYPE :: CARRY1
         CHARACTER( 16 ), ALLOCATABLE :: ARRY( : )
         CHARACTER( 16 ), ALLOCATABLE :: UNITS( : )
         INTEGER                      :: LEN
      END TYPE CARRY1

      TYPE :: LARRY1
         LOGICAL, ALLOCATABLE  :: ARRY( : )
         INTEGER               :: LEN
      END TYPE LARRY1

      TYPE :: PTMET_TYPE
         INTEGER          :: LEN1, LEN2
C Allocatable per-source meteorology variables:
         REAL, ALLOCATABLE :: HFX( : )        ! sensible heat flux [watts/m**2]
         REAL, ALLOCATABLE :: HMIX( : )       ! mixing height [m]
         REAL, ALLOCATABLE :: TSFC( : )       ! surface temperature [degK]
         REAL, ALLOCATABLE :: USTAR( : )      ! friction velocity [m/s]
         REAL, ALLOCATABLE :: PRSFC( : )      ! surface pressure [Pa]
C Allocatable temporary per-layer variables from 1:EMLAYS:
         REAL, ALLOCATABLE   :: WSPD( : )       ! wind speed [m/s]
         REAL, ALLOCATABLE   :: DTHDZ( : )      ! virtual pot temp gradient [degK/m]
C Allocatable temporary per-layer variables from 0:EMLAYS:
         REAL, ALLOCATABLE :: PRESF( : )      ! pressure at full-levels
         REAL, ALLOCATABLE :: ZZF( : )        ! per src elevn at full-levels
C Allocatable per-source and per-layer meteorology variables:
C (Dimensioned by layers, then number of sources)
         REAL, ALLOCATABLE :: DDZF ( :,: )    ! 1/( ZF(L) - ZF(L-1) )
         REAL, ALLOCATABLE :: PRES ( :,: )    ! pressure [Pa]
         REAL, ALLOCATABLE :: DENS ( :,: )    ! air density [kg/m**3]
         REAL, ALLOCATABLE :: QV   ( :,: )    ! moisture mixing ratio [kg/kg]
         REAL, ALLOCATABLE :: TA   ( :,: )    ! temperature [degK]
         REAL, ALLOCATABLE :: UWIND( :,: )    ! x-component wind speed [m/s]
         REAL, ALLOCATABLE :: VWIND( :,: )    ! y-component wind speed [m/s]
         REAL, ALLOCATABLE :: ZF   ( :,: )    ! full layer height [m]
         REAL, ALLOCATABLE :: ZH   ( :,: )    ! mid layer height [m]
         REAL, ALLOCATABLE :: ZSTK ( :,: )    ! ZF( L,S ) - STKHT(S) [m]
      END TYPE PTMET_TYPE

      END MODULE UDTYPES

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE GRID_CONF

C Define the horizontal grid and vertical layer structure by inheriting
C HGRD_DEFN and VGRD_DEFN. In addition, set up the computational blocking
C parameters.
C VGRD_DEFN replaces COORD.EXT and VGRD.EXT
C Revision History: Jeff Young 31 Jen 05: created
C.......................................................................

      USE HGRD_DEFN             ! horizontal domain specifications
      USE VGRD_DEFN             ! vertical layer specifications
      USE utilio_defn

      IMPLICIT NONE

!     INTEGER, PARAMETER :: BLKSIZE = 500
      INTEGER, PARAMETER :: BLKSIZE = 50
      INTEGER, SAVE :: MXCELLS
      INTEGER, SAVE :: MXBLKS

      CONTAINS

         FUNCTION GRID_INIT ( NPROCS, MYID ) RESULT ( SUCCESS )

         INTEGER :: NPROCS
         INTEGER :: MYID
         LOGICAL :: SUCCESS

         LOGICAL, SAVE :: FIRSTIME = .TRUE.
         CHARACTER( 96 ) :: MSG = ' '

C-----------------------------------------------------------------------

C This function is expected to be called only once - at startup

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            SUCCESS = .TRUE.

            CALL LOG_HEADING( LOGDEV, "Initialize Grid" )

#ifdef mpas
            MXCELLS = NCOLS * NROWS * NLAYS
            MXBLKS  = 1 + ( MXCELLS - 1 ) / BLKSIZE
#else
C Set up horizontal domain and calculate processor-to-subdomain maps
            CALL LOG_SUBHEADING( LOGDEV, "Retrieve Horizontal Grid" )
            IF ( .NOT. HGRD_INIT ( NPROCS, MYID ) ) THEN
               MSG = '*** Failure defining horizontal domain'
               CALL M3WARN ( 'GRID_INIT', 0, 0, MSG )
               SUCCESS = .FALSE.
               RETURN
               END IF

C define vertical layer structure
            CALL LOG_SUBHEADING( LOGDEV, "Retrieve Vertical Grid" )
            IF ( .NOT. VGRD_INIT() ) THEN
               MSG = '*** Failure defining vertical structure'
               CALL M3WARN ( 'GRID_INIT', 0, 0, MSG )
               SUCCESS = .FALSE.
               RETURN
               END IF

            MXCELLS = NCOLS * NROWS * NLAYS
            MXBLKS  = 1 + ( MXCELLS - 1 ) / BLKSIZE

            ELSE
            MSG = 'Domain configuration already defined'
            CALL M3WARN ( 'GRID_INIT', 0, 0, MSG )
            SUCCESS = .FALSE.; RETURN
#endif
            END IF   ! FIRSTIME

         RETURN
         END FUNCTION GRID_INIT

      END MODULE GRID_CONF

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
      MODULE AERO_PHOTDATA

      IMPLICIT NONE

      REAL( 8 ), ALLOCATABLE :: SHELL_MOMENT3( :,: )  ! modal shell third moment conc.
      REAL( 8 ), ALLOCATABLE :: CORE_MOMENT3 ( :,: )  ! model core third moment conc.

      REAL, ALLOCATABLE :: BLK_AE_VOL  ( :,: )     ! aerosol modal volumes [ m**3/m**3 ]
      REAL, ALLOCATABLE :: BLK_AE_LSG  ( :,: )     ! aerosol modal log of geo. stand. dev
      REAL, ALLOCATABLE :: BLK_AE_DGN  ( :,: )     ! aerosol modal mean geometeric diam. [ m ]
      REAL, ALLOCATABLE :: AE_DGN_CORE ( :,: )   ! inner core modal mean geometeric diam. [ m ]
      REAL, ALLOCATABLE :: AE_DGN_SHELL( :,: )   ! modal mean geometeric diam. [ m ]
      REAL, ALLOCATABLE :: BLK_AE_CONC ( :,:,: ) ! aerosol species concentrations [ ug/m**3]

      REAL, ALLOCATABLE :: AE_NR_SHELL ( :,:,: ) ! real part of refractive index for outer shell
      REAL, ALLOCATABLE :: AE_NI_SHELL ( :,:,: ) ! imaginary part of refractive index for outer shell
      REAL, ALLOCATABLE :: AE_NR_CORE  ( :,:,: ) ! real part of refractive index for inner core
      REAL, ALLOCATABLE :: AE_NI_CORE  ( :,:,: ) ! imaginary part of refractive index for inner core
      REAL, ALLOCATABLE :: BLK_AE_NR   ( :,:,: ) ! mean aerosol real part of refractive index
      REAL, ALLOCATABLE :: BLK_AE_NI   ( :,:,: ) ! mean aerosol imaginary part of refractive index

      REAL, ALLOCATABLE :: AERO_ASYM_FAC ( :,: ) ! aerosol modal averaged asymmetry factor
      REAL, ALLOCATABLE :: AERO_EXTI_COEF( :,: ) ! aerosol modal averaged extinction coeff., 1/m
      REAL, ALLOCATABLE :: AERO_SCAT_COEF( :,: ) ! aerosol modal averaged scattering coeff., 1/m
      REAL, ALLOCATABLE :: AERO_ABSO_COEF( :,: ) ! aerosol modal averaged sbsorption coeff., 1/m
      REAL, ALLOCATABLE :: AERO_EXTI_550  ( : )  ! aerosol modal averaged extinction coeff. at 550nm, 1/m
      REAL, ALLOCATABLE :: AERO_ABSO_550  ( : )  ! aerosol modal averaged extinction coeff. at 550nm, 1/m
 
      PUBLIC            :: AERO_ASYM_FAC, AERO_EXTI_COEF, AERO_SCAT_COEF, AERO_ABSO_COEF,
     &                     INIT_AERO_DATA, GET_AERO_DATA

      INTEGER,   ALLOCATABLE, PRIVATE :: REFRACT_INDX_MAP( : )  ! map array for refactive index

      REAL,      ALLOCATABLE, PRIVATE :: VOL_MINS( : )          ! minmum volume permode
      REAL( 8 ), ALLOCATABLE, PRIVATE :: M3_FACTOR( : )         ! convert mass to portion of 3rd moment
      LOGICAL,   ALLOCATABLE, PRIVATE :: IS_CORE_SPCS( :,: )    ! flag denoting species is in aerosol core

      INTEGER,   PARAMETER, PRIVATE   :: NUMB_COR_SPCS = 3      ! number species in core

      LOGICAL :: CALCULATE_EXT_550   = .FALSE. ! flag to get extinction at 550 nm
      LOGICAL :: USE_ANGSTROM_INTERP = .FALSE. ! flag to use angstrom exponents for 550 nm
      
      INTEGER   :: IWL_ANGSTROM_LOWER  = 0       ! index for wavelength less than 550 nm
      INTEGER   :: IWL_ANGSTROM_UPPER  = 0       ! index for wavelength greater than 550 nm
      REAL( 8 ) :: ANGSTROM_RATIO      = 1.0D0   ! wavelength less than 550 nm divided by 550 nm
      REAL( 8 ) :: LOG_ANGSTROM_RATIO  = 0.0D0    
      REAL( 8 ) :: ANGSTROM_SPAN       = 1.0D0   ! reciprocal of log ((wavelength < 550 nm)/(wavelength > 550 nm)
      REAL( 8 ) :: ANGSTROM_EXPONENT   = 1.0D0   ! Angstrom exponent used to interpolate extinction at 550 nm
          
C *** Species in aerosol core

      CHARACTER( 16 ), PARAMETER, PRIVATE :: CORE_SPCS( NUMB_COR_SPCS ) =
     &                                       (/ 'AECI', 'AECJ', 'AECK' /)
      
      CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE INIT_AERO_DATA( )

C Allocate and define arrays used to calculate aerosol optical properties

         USE GRID_CONF, ONLY: NROWS, NCOLS, NLAYS  ! horizontal & vertical domain specifications
         USE UTILIO_DEFN
      
         USE AERO_DATA           ! aero variable data
         USE SOA_DEFN            ! gas soa data
         USE AEROMET_DATA        
         USE CONST      
         USE CSQY_DATA, ONLY : NWL => NWL_REF, NUM_REFRACTIVE, REFRACTIVE_INDEX,
     &                         WAVELENGTH => EFFWL_REF !!! , FIRST_DAY => NEW_START

         USE WRF_FAST_MIE, ONLY : FAST_MIEAER_MODAL, EFLAG_WRF_FAST_MIE

         IMPLICIT NONE

C Arguments:

C Local:
         CHARACTER(  32 ) :: PNAME             = 'INIT_AERO_DATA'
         CHARACTER( 120 ) :: XMSG 

         INTEGER          :: ALLOCSTAT
         INTEGER          :: ESTAT          ! status from environment var check
         INTEGER          :: JDATE, JTIME
         INTEGER          :: M, N, SPC, V   ! loop counters
      
         LOGICAL, SAVE    :: INITIALIZED  = .FALSE.

         REAL    :: MIE_PARAMETER = 1.0E-3
         COMPLEX :: REFINDX       = (1.0,0.0)

         REAL :: EXTAER,SCATAER,GAER
         REAL :: BSCOEF

#ifdef verbose_phot
         character( 26 ), allocatable :: lambda_list( : )
#endif

         IF ( INITIALIZED ) THEN
            RETURN
         END IF
          
         JDATE  = 0
         JTIME  = 0


C...Allocate needed arrays

         ALLOCATE ( VOL_MINS( N_MODE ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating VOL_MINS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         ALLOCATE ( BLK_AE_CONC( N_AEROSPC,N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BLK_AE_CONC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( SHELL_MOMENT3( N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SHELL_MOMENT3'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( BLK_AE_VOL( N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BLK_AE_VOL'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( BLK_AE_LSG( N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BLK_AE_LSG'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( BLK_AE_DGN( N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BLK_AE_DGN'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AE_DGN_SHELL( N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AE_DGN_SHELL'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AE_NR_SHELL( N_MODE,NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating  AE_NR_SHELL'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AE_NI_SHELL( N_MODE,NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating  AE_NI_SHELL'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AERO_ASYM_FAC( NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AERO_ASYM_FAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AERO_EXTI_COEF( NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AERO_EXTI_FAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AERO_SCAT_COEF( NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AERO_EXTI_FAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AERO_ABSO_COEF( NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AERO_ABSO_FAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         AERO_SCAT_COEF = 0.0
         AERO_EXTI_COEF = 0.0
         AERO_ASYM_FAC  = 0.0
         AERO_ABSO_COEF = 0.0

         IF( CALCULATE_EXT_550 )THEN
            ALLOCATE ( AERO_EXTI_550( NLAYS ),
     &                 AERO_ABSO_550( NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating AERO_EXTI_550'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            AERO_EXTI_550  = 0.0
            AERO_ABSO_550  = 0.0
         END IF   

         CALL MAP_AERO()
                  
         ALLOCATE( M3_FACTOR( N_AEROSPC ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating  M3_FACTOR'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         ALLOCATE( REFRACT_INDX_MAP( N_AEROSPC ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating REFRACT_INDX_MAP'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
!        IF( CORE_SHELL )THEN
            ALLOCATE( IS_CORE_SPCS( N_AEROSPC,N_MODE ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating IS_CORE_SPCS'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         
            IS_CORE_SPCS = .FALSE.

            ALLOCATE ( CORE_MOMENT3( N_MODE,NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating CORE_MOMENT3'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
      
            ALLOCATE ( AE_DGN_CORE( N_MODE,NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating AE_DGN_CORE'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
      
            ALLOCATE ( AE_NR_CORE( N_MODE,NLAYS,NWL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating AE_NR_CORE'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
      
            ALLOCATE ( AE_NI_CORE( N_MODE,NLAYS,NWL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating AE_NI_CORE'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
!        END IF
C ***    Create map for refactive index for each species

#ifdef verbose_phot
         allocate( lambda_list( nwl ) )
         do v = 1, nwl
            write( lambda_list( v ), 5000)int(wavelength( v )), 
     &      int(wavelength( v ))
         end do
         write( logdev, 5001)(lambda_list( v ), v = 1, nwl)
#endif 

         WRITE(LOGDEV,*)
         CALL M3MESG('METHOD FOR AEROSOL OPTICAL PROPERTIES')
         xmsg = 'METHOD FOR AEROSOL OPTICAL PROPERTIES'
         IF ( .NOT. CORE_SHELL ) THEN
            XMSG = 'CORE-SHELL mixing model option is set to off so'
            WRITE(LOGDEV,'(A)')TRIM( XMSG )
         ELSE
            XMSG = 'CORE-SHELL mixing model used when aerosol mode has significant black carbon'
            WRITE(LOGDEV,'(A)')TRIM( XMSG )
            XMSG = 'When aerosol mode does not have significant black carbon,'
            WRITE(LOGDEV,'(A)')TRIM( XMSG )
         END IF
         SELECT CASE ( AEROSOL_OPTICS )
           CASE( 1 )
             XMSG = 'VOLUME MIXING model and Tabular Mie Method used'
             WRITE(LOGDEV,'(A)')TRIM( XMSG )
             CALL FAST_MIEAER_MODAL( MIE_PARAMETER,REFINDX,EXTAER,SCATAER,GAER,BSCOEF )
             IF ( EFLAG_WRF_FAST_MIE ) THEN
                XMSG = 'Above Failure Initializing Tabular Mie Method for aerosol optics'
                CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
             END IF
           CASE( 2 )
             XMSG = 'VOLUME MIXING model and Mie calculation used'
             WRITE(LOGDEV,'(A)')TRIM( XMSG )
           CASE( 3 )
             XMSG = 'VOLUME MIXING model and FAST_OPTICS used'
             WRITE(LOGDEV,'(A)')TRIM( XMSG )
             XMSG = '-Approximations to Mie Theory based on Mie paramter and refractive index '
             WRITE(LOGDEV,'(A)')TRIM( XMSG )
         END SELECT
         WRITE(LOGDEV,*)

         FORALL ( SPC = 1:N_MODE ) VOL_MINS( SPC ) = PI6 * AEROMODE( SPC )%MIN_M3CONC

         DO SPC = 1, N_AEROSPC

            M3_FACTOR( SPC ) = REAL( 1.0E-9 * F6DPI / AEROSPC( SPC )%DENSITY, 8 )

            DO M = 1, NUM_REFRACTIVE
               IF ( AEROSPC( SPC )%OPTIC_SURR .EQ. REFRACTIVE_INDEX( M )%NAME ) THEN
                  REFRACT_INDX_MAP( SPC ) = M
                  DO N = 1, N_MODE

                     IF ( CORE_SHELL ) THEN
                        DO V = 1, NUMB_COR_SPCS
                           IF ( AEROSPC( SPC )%NAME( N ) .EQ. CORE_SPCS( V ) ) THEN
                               IS_CORE_SPCS( SPC, N ) = .TRUE.
                           END IF
                        END DO
                     END IF
#ifdef verbose_phot
                     if ( aero_missing(spc,n) ) cycle
                     write( logdev, 5002)trim( aerospc( spc )%name( n ) ), 
     &               trim( refractive_index( m )%name ),is_core_spcs( spc,n ),
     &               (refractive_index( m )%real_part( n,v ), 
     &                refractive_index( m )%imag_part( n,v ), v = 1, nwl)
#endif                  
                  END DO 
                  EXIT
               END IF
            END DO
            IF ( REFRACT_INDX_MAP( SPC ) .LT. 1 ) THEN
               DO M = 1, N_MODE
                  IF ( aero_missing(spc,n) ) CYCLE
                  XMSG = 'Species ' // TRIM( AEROSPC( SPC )%NAME( M ) )
     &                 // ' does not use defined refractive index.'
                  CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT3 )
               END DO
            END IF
         END DO

         IF( CALCULATE_EXT_550 )THEN ! locate 550 nm in wavebands and set-up interpolation 
            IF ( WAVELENGTH( 1 ) .GE. 550.0 )  THEN
                IWL_ANGSTROM_LOWER = 1
            ELSE IF ( WAVELENGTH( NWL ) .LE. 550.0 ) THEN
                IWL_ANGSTROM_LOWER = NWL
            ELSE
                LOOP_FINDW: DO V = 1, NWL - 1
                   IF ( WAVELENGTH( V ) .LT. 550.0 .AND. WAVELENGTH( V+1 ) .GT. 550.0 ) THEN
                      IWL_ANGSTROM_LOWER = V
                      IWL_ANGSTROM_UPPER = V+1
                      ANGSTROM_SPAN      = REAL( 1.0 / LOG( WAVELENGTH( V ) / WAVELENGTH( V+1 ) ), 8 )
                      ANGSTROM_RATIO     = REAL( (WAVELENGTH( V ) / 550.0), 8)
!                     ANGSTROM_RATIO     = REAL( (WAVELENGTH( V ) / WAVELENGTH( V+1 )), 8)
                      LOG_ANGSTROM_RATIO = LOG( ANGSTROM_RATIO )
!                      WRITE(LOGDEV,'(A,2(F7.3,1X))')'Angstrom Interpolation Wavelengths: ', 
!     &                WAVELENGTH( IWL_ANGSTROM_LOWER ), WAVELENGTH( IWL_ANGSTROM_UPPER  )
!                      WRITE(LOGDEV,'(A,2(ES12.4,1X))')'Angstrom Span, Ratio: ', 
!     &                ANGSTROM_SPAN, ANGSTROM_RATIO
                      USE_ANGSTROM_INTERP  = .TRUE.
                      EXIT LOOP_FINDW
                   ELSE IF ( WAVELENGTH( V ) .EQ. 550.0 ) THEN
                      IWL_ANGSTROM_LOWER = V
                      EXIT LOOP_FINDW
                   END IF
                END DO LOOP_FINDW
            END IF
            IF( .NOT. USE_ANGSTROM_INTERP )THEN
               WRITE(LOGDEV,'(A,2(F7.3,1X))')'No Angstrom Inpolation Used 550 Extinction used at ', 
     &         WAVELENGTH( IWL_ANGSTROM_LOWER )
            END IF
         END IF

      RETURN

5000  FORMAT(2X,'NR_',I3.3,7X,'NI_',I3.3,5X)
5002  FORMAT(2(A16,1X),L12,1X,200(ES12.4,1X))                    
5001  FORMAT('     AE_SPC     ',1X,'  REFRACT_INDX  ',1X,'PART_OF_CORE',1X,200(A26))

      END SUBROUTINE INIT_AERO_DATA

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GET_AERO_DATA ( COL, ROW, NLAYS, DENS, CGRID )

C-----------------------------------------------------------------------
C  FUNCTION:  This subroutine calculates the volume, the natural logs of 
C     geometric standard of all 3 modes. It assumes that aerosols have inner 
C     core with an outer shell to compute a core and total diameter per mode.  
C     The code also calculates the average modal aerosol refractive indices 
C     for the inner core and outer shell.
C
C     Internally mixed wet aerosols are assumed.
C
C     NOTE
C       2nd moment concentrations (M2) are passed into GETPAR in the
C       CBLK array.  The GETPAR calculations implicitly assume
C       that the input value of M2 is up to date
C       If, for example, the input M2 value was calculated
C       for a "dry" aerosol and the Wet_Moments_FLAG is .TRUE., GETPAR would
C       incorrectly adjust the M2 concentrations!
C
C  KEY SUBROUTINES/FUNCTIONS CALLED:  EXTRACT_AERO, EXTRACT_SOA, GETPAR
C                                     AERO_OPTICAL2, AERO_OPTICAL_CS  
C  REVISION HISTORY
C     06/13/13 B.Hutzell - initial version created for aero_photdata.F 
C                          from version 5.01
C     05/2016 H. Pye and B. Murphy - updated treatment of aerosol
C                          moments
C     05/23/16 D.Wong - replaced RRTMG_AERO_OPTICAL_UTIL_MODULE with
C                       CMAQ_RRTMG_AERO_OPTICAL_UTIL_MODULE to avoid
C                       duplication of the same module name on WRF side
C                       of the two-way model
C
C  REFERENCES:
C     Horvath, H., Size segrated light absorption coefficient for
C     the atmospheric aerosol, Atmos. Environ., Vol. 29, No. 8,
C     pp 875-883, 1995.
C
C     Beyer, K.D. A.R. Ravishankara, and E. R. Lovejoy, Meanurements
C     of H2SO4/H2O and H2SO4/HNO3/H2O solutions, J. Geophys. Res. Vol.
C     101, D9, pp 14519-14524, 1996.
C
C-----------------------------------------------------------------------

!     USE GRID_CONF           ! horizontal & vertical domain specifications
      USE RXNS_DATA
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN

      USE AERO_DATA           ! aero variable data
      USE SOA_DEFN            ! gas soa data
      USE AEROMET_DATA        ! met data
      USE CONST      
      USE CSQY_DATA,  ONLY : NWL => NWL_REF, NUM_REFRACTIVE, REFRACTIVE_INDEX,
     &                       WAVELENGTH => EFFWL_REF

      USE CMAQ_RRTMG_AERO_OPTICAL_UTIL_MODULE, ONLY : AERO_OPTICAL2, AERO_OPTICAL_CS

      USE WRF_FAST_MIE, ONLY : AERO_OPTICS_TABULAR

      IMPLICIT NONE

C Includes:

C Arguments:

      INTEGER, INTENT( IN ) :: COL               ! specified column index
      INTEGER, INTENT( IN ) :: ROW               ! specified row index
      INTEGER, INTENT( IN ) :: NLAYS             ! # of vertical layers
      REAL,    INTENT( IN ) :: DENS( :,:,: )
      REAL,    POINTER      :: CGRID( :,:,:,: )

C Parameters:

      REAL( 8 ), PARAMETER :: NEGLECT_FRAC = 1.0D-9      ! skip if below this volume fraction
      REAL( 8 ), PARAMETER :: ONE_THIRD    = 1.0D0/3.0D0 

C Local saved variables:

      CHARACTER( 16 ), SAVE :: AE_VRSN                  ! Aerosol version name
      CHARACTER( 32 ), SAVE :: PNAME = 'GET_AERO_DATA'  ! routine name

C Local variables:

      CHARACTER( 16 ) :: VNAME            ! varable name
      CHARACTER( 96 ) :: XMSG = ' '

      REAL( 8 ) :: FACTOR
      REAL( 8 ) :: FRACTION_CORE
      REAL( 8 ) :: FRACTION_SHELL
      REAL( 8 ) :: MOMENT3_PORTION
      REAL( 8 ) :: SUMRI_R_SHELL
      REAL( 8 ) :: SUMRI_I_SHELL
      REAL( 8 ) :: SUMRI_R_CORE
      REAL( 8 ) :: SUMRI_I_CORE
      REAL( 8 ) :: SUMRI_R
      REAL( 8 ) :: SUMRI_I

      REAL DGN_CORE       ! geometric mean diameters of aerosol core
      REAL VOL            ! Total Modal aerosol volume
      REAL VOL_CORE       ! Modal aerosol volume of aerosol core
      REAL DGN_SHELL      ! geometric mean diameters of aerosol core
      REAL VOL_SHELL      ! Modal aerosol volume of aerosol core
      REAL XXLSG          ! geometric standard deviation
      REAL MIE_PARAMETER  ! Modal Mie parameter

C***  variables for calculating modal averaged properties per layer and lambda

      COMPLEX NR_SHELL
      COMPLEX NI_SHELL
      COMPLEX NR_CORE
      COMPLEX NI_CORE

      REAL BEXT_MODE  ! total aerosol extinction coefficient [ 1/m ]
      REAL BSCAT_MODE ! total aerosol scattering coefficient [ 1/m ]
      REAL GBAR_MODE  ! total aerosol asymmetry factor
      REAL BEXT       ! total aerosol extinction coefficient [ 1/m ]
      REAL VFAC, BSC  ! unit correction factors
      REAL BSCAT      ! total aerosol scattering coefficient [ 1/m ]
      REAL G_BAR      ! total aerosol asymmetry factor
      REAL INV_LAMBDA ! reciprocal of wavelength [ 1/m ]
      REAL LAMDA_UM   ! wavelength  [ um ]

      INTEGER L, V, N, M            ! loop counters
      INTEGER SPC                   ! species loop counter
      INTEGER MODE                  ! aerosol mode loop counter
      LOGICAL SUCCESS
      LOGICAL TROUBLE
      LOGICAL, SAVE    :: FIRSTCALL  = .TRUE.


#ifdef verbose_phot
      character( 26 ), allocatable :: lambda_list( : )
#endif
      
C-----------------------------------------------------------------------

      IF ( N_AE_SPC .LE. 0 ) RETURN

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Put the grid cell physical data in the block arrays
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

C *** initialize internal and external dimensions of aerosols

      CORE_MOMENT3  = 0.0D+0
      SHELL_MOMENT3 = 0.0D+0
      BLK_AE_VOL    = 0.0
      BLK_AE_CONC   = 0.0
      AE_DGN_SHELL  = 0.0
      AE_DGN_CORE   = 0.0
      SUCCESS       = .TRUE.

      LAY_LOOP1: DO L = 1, NLAYS

C *** extract grid cell concentrations of aero species from CGRID into aerospc_conc 
C *** in aero_data module
C     Also converts dry surface area to wet second moment
#ifdef sens
         CALL EXTRACT_AERO ( CGRID( COL,ROW,L,: ), .TRUE., CGRID( COL,ROW,:,: ), .FALSE. )
#else
         CALL EXTRACT_AERO ( CGRID( COL,ROW,L,: ), .TRUE. )
#endif

C *** extract soa concentrations from CGRID
         AIRDENS  = DENS ( COL,ROW,L )
#ifdef sens
         CALL EXTRACT_SOA ( CGRID( COL,ROW,L,: ), CGRID( COL,ROW,:,: ), .FALSE. )
#else
         CALL EXTRACT_SOA ( CGRID( COL,ROW,L,: ) )
#endif

C *** Calculate geometric mean diameters and standard deviations of "wet" size distribution
         CALL GETPAR ( .FALSE. )

#ifdef verbose_phot
         if(col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 )then
            do m = 1, n_mode
               write(logdev, 4999)l, m, aeromode_diam( m ),pi6*moment3_conc( m ),
     &         aeromode_lnsg( m )
4999           format('lay = ',i3,' mode = ',i3,' diam = ',es12.4,' pi6*moment3 = ', 
     &         es12.4,' ae_lsg = ', es12.4)
           end do
         end if
#endif

         DIME_LOOP: DO MODE = 1, N_MODE

            FRACTION_CORE  = 0.0D+0
            FRACTION_SHELL = 0.0D+0
            
            SPC_LOOP1: DO SPC = 1, N_AEROSPC
               IF ( AEROSPC( SPC )%TRACER ) CYCLE      ! skip tracer species
               IF ( AERO_MISSING( SPC,MODE ) ) CYCLE   ! skip undefined species
               BLK_AE_CONC( SPC,MODE,L ) = AEROSPC_CONC( SPC,MODE )

               MOMENT3_PORTION = M3_FACTOR( SPC ) * REAL( AEROSPC_CONC( SPC,MODE ), 8 )
               IF ( IS_CORE_SPCS( SPC,MODE ) ) THEN  
                  CORE_MOMENT3( MODE,L )  = CORE_MOMENT3( MODE,L )  + MOMENT3_PORTION
#ifdef verbose_phot
                  if ( col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 ) then
                     write(logdev,5007)aerospc( spc )%name( mode ),moment3_portion,
     &               core_moment3( mode, l )
5007                 format(a16,1x,'moment3_portion = ',es12.4,1x,'moment3_core = ',es12.4 )
                  end if
#endif 
               ELSE 
                  SHELL_MOMENT3( MODE,L ) = SHELL_MOMENT3( MODE,L ) + MOMENT3_PORTION
#ifdef verbose_phot
                  if ( col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 ) then
                     write(logdev,5008)aerospc( spc )%name( mode ),moment3_portion,
     &               shell_moment3( mode, l )
5008                 format(a16,1x,'moment3_portion = ',es12.4,1x,'moment3_shell = ',es12.4 )
                  end if
#endif 
               END IF 
            END DO SPC_LOOP1


            FRACTION_CORE  = CORE_MOMENT3(  MODE,L ) / REAL( MOMENT3_CONC( MODE ), 8 )
            FRACTION_SHELL = SHELL_MOMENT3( MODE,L ) / REAL( MOMENT3_CONC( MODE ), 8 )

            BLK_AE_LSG  ( MODE,L ) = AEROMODE_LNSG( MODE )
            AE_DGN_SHELL( MODE,L ) = AEROMODE_DIAM( MODE )

            IF ( FRACTION_CORE .LT. NEGLECT_FRAC ) THEN
               AE_DGN_CORE( MODE,L ) = 0.0
            ELSE
               FACTOR = FRACTION_CORE ** ONE_THIRD
               AE_DGN_CORE( MODE,L ) = REAL( FACTOR * AEROMODE_DIAM( MODE ) )
            END IF

            IF ( MOMENT3_CONC( MODE ) .GT. AEROMODE( MODE )%MIN_M3CONC ) THEN
               BLK_AE_VOL( MODE,L ) = PI6 * MOMENT3_CONC( MODE )
            END IF

#ifdef verbose_phot
            if ( col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 ) then
               write(logdev, 5006)l, mode, ae_dgn_core( mode,l ), ae_dgn_shell( mode,l ),
     &         blk_ae_vol( mode,l ),blk_ae_lsg( mode,l) 
5006           format('lay = ',i3,' mode = ',i3,' dgn_core = ', es12.4, ' dgn_shell = ', 
     &         es12.4,' ae_vol = ', es12.4,' ae_lsg = ', es12.4)
            end if
#endif

         END DO DIME_LOOP

      END DO LAY_LOOP1

C *** Initialize refractive indices then compute

      AE_NR_SHELL = 0.0
      AE_NI_SHELL = 0.0
      AE_NR_CORE  = 0.0
      AE_NI_CORE  = 0.0

      LOOP_WAVE: DO V = 1, NWL

         LAMDA_UM   = 1.0E-3 * WAVELENGTH( V ) ! convert to micro-meters
         INV_LAMBDA = 1.0E9 / WAVELENGTH( V )

         LAY_LOOP2: DO L = 1, NLAYS

            REFRAC_LOOP: DO MODE = 1, N_MODE

               SUMRI_R_SHELL = 0.0D+0
               SUMRI_I_SHELL = 0.0D+0
               SUMRI_R_CORE  = 0.0D+0
               SUMRI_I_CORE  = 0.0D+0

               SPC_LOOP2: DO SPC = 1, N_AEROSPC
                  IF ( AEROSPC( SPC )%TRACER ) CYCLE              ! neglect tracer species
                  IF ( AERO_MISSING( SPC,MODE ) ) CYCLE  ! neglect undefined species

                  M = REFRACT_INDX_MAP( SPC )

                  MOMENT3_PORTION = M3_FACTOR( SPC ) * REAL( BLK_AE_CONC( SPC,MODE,L ), 8)
     
                  IF ( IS_CORE_SPCS( SPC, MODE ) ) THEN  
                  
                     SUMRI_R_CORE = SUMRI_R_CORE + MOMENT3_PORTION
     &                            * REAL( REFRACTIVE_INDEX( M )%REAL_PART( MODE,V ), 8)
                     SUMRI_I_CORE = SUMRI_I_CORE + MOMENT3_PORTION
     &                            * REAL( REFRACTIVE_INDEX( M )%IMAG_PART( MODE,V ), 8)

                  ELSE

                     SUMRI_R_SHELL = SUMRI_R_SHELL + MOMENT3_PORTION
     &                             * REAL( REFRACTIVE_INDEX( M )%REAL_PART( MODE,V ), 8)
                     SUMRI_I_SHELL = SUMRI_I_SHELL + MOMENT3_PORTION
     &                             * REAL( REFRACTIVE_INDEX( M )%IMAG_PART( MODE,V ), 8)

                  END IF
                  
               END DO SPC_LOOP2

C ***       Update output array values
               
               IF ( CORE_MOMENT3( MODE,L ) .GT. 0.0D0 ) THEN
                   AE_NR_CORE ( MODE,L,V ) = REAL( SUMRI_R_CORE / CORE_MOMENT3( MODE,L ) )
                   AE_NI_CORE ( MODE,L,V ) = REAL( SUMRI_I_CORE / CORE_MOMENT3( MODE,L ) )
               END IF
               
               IF ( SHELL_MOMENT3( MODE,L ) .GT. 0.0D0 ) THEN
                   AE_NR_SHELL ( MODE,L,V ) = REAL( SUMRI_R_SHELL / SHELL_MOMENT3( MODE,L ) )
                   AE_NI_SHELL ( MODE,L,V ) = REAL( SUMRI_I_SHELL / SHELL_MOMENT3( MODE,L ) )
               END IF
               
            END DO REFRAC_LOOP

C***loop over mode again for mean modal extinction and scattering properties
        
            G_BAR = 0.0
            BEXT  = 0.0
            BSCAT = 0.0

#ifdef verbose_phot_extra
            if ( L .eq. 1 .and. V .eq. 1 ) then

               write(LOGDEV, 9501)L, wavelength( V ), ae_dgn_core(  m,l ), ae_dgn_shell( m, l ), 
     &         ae_nr_shell( m,L,V ), ae_ni_shell( m,L,V ), ae_nr_core( m,L,V ), 
     &         ae_ni_core( m,L,V )

9501           format('layer = ',i2,' lambda  = ',es12.4,' dgn_core = ',es12.4,' dgn_shell = ',
     &                 es12.4,' refract_shell(nr,ni) = ', 2(es12.4,1x),' refract_core = ',
     &                 2(es12.4,1x))

               end if
#endif            

            OPTICS_LOOP: DO MODE = 1, N_MODE
               TROUBLE = .FALSE.
            
               DGN_CORE  = AE_DGN_CORE(  MODE,L )
               DGN_SHELL = AE_DGN_SHELL( MODE,L )
         
               VOL = BLK_AE_VOL( MODE,L )
 
               NR_SHELL = CMPLX( AE_NR_SHELL( MODE,L,V ), AE_NI_SHELL( MODE,L,V ) )

               IF ( AE_NR_SHELL( MODE,L,V ) .LE. 0.0 ) SUCCESS = .FALSE.
               IF ( AE_NI_SHELL( MODE,L,V ) .LE. 0.0 ) SUCCESS = .FALSE.
        
               XXLSG = EXP( BLK_AE_LSG( MODE,L ) )

C***calculate the extinction and scattering coefficients in [ 1 / m ] and the asymmetry 
C*** factor for aerosols.

               IF ( DGN_CORE .GT. 0.0 .AND. DGN_CORE / DGN_SHELL .LT. 0.999 ) THEN

                  VOL_CORE  = PI6 * REAL( CORE_MOMENT3( MODE,L ), 4 )
                  VOL_SHELL = PI6 * REAL( SHELL_MOMENT3( MODE,L ), 4 )

                  NR_CORE  = CMPLX( AE_NR_CORE( MODE,L,V ), AE_NI_CORE( MODE,L,V ) )

                  IF ( AE_NR_CORE( MODE,L,V ) .LE. 0.0 ) SUCCESS = .FALSE.
                  IF ( AE_NI_CORE( MODE,L,V ) .LE. 0.0 ) SUCCESS = .FALSE.

                  IF ( VOL_SHELL .LE. 0.0 ) THEN
                     SUCCESS = .FALSE.
!                    WRITE(6,*)TRIM(PNAME),': VOL_SHELL(',MODE,') = ',VOL_SHELL
                  END IF

                  IF ( VOL_CORE .LE. 0.0 ) THEN
                     SUCCESS = .FALSE.
!                    WRITE(6,*)TRIM(PNAME),':  VOL_CORE(',MODE,') = ',VOL_CORE
                  END IF

                  IF ( DGN_SHELL .LE. 0.0 ) SUCCESS = .FALSE.
                   
C *** Core-Shell case for optics         
                  IF ( SUCCESS ) CALL AERO_OPTICAL_CS( LAMDA_UM, NR_CORE, NR_SHELL,  
     &                                   VOL_CORE, VOL_SHELL, DGN_CORE,      
     &                                   DGN_SHELL, XXLSG,
     &                                   BEXT_MODE, BSCAT_MODE, GBAR_MODE, SUCCESS )

                  VFAC  = 1.0 ! correction factor 

                  IF ( .NOT. SUCCESS ) THEN
     
                     WRITE( LOGDEV,9503 ) L, MODE, WAVELENGTH( V ), 
     &               AE_DGN_CORE( MODE,L ), AE_DGN_SHELL( MODE,L ),
     &               AE_NR_SHELL( MODE,L,V ), AE_NI_SHELL( MODE,L,V ),
     &               AE_NR_CORE( MODE,L,V ),  AE_NI_CORE( MODE,L,V ),
     &               BLK_AE_LSG( MODE,L )
     
                     XMSG =  'FAILURE IN AERO_OPTICAL_CS: core with shell case '
                     CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
                     
                  END IF

C***sum to get total extinction and scattering
C***  and contribution to the overall asymmetry factor

                  BEXT  = BEXT  + BEXT_MODE
                  BSCAT = BSCAT + BSCAT_MODE
                  G_BAR = G_BAR + BSCAT_MODE * GBAR_MODE

               ELSE IF ( VOL .GT. 0.0 ) THEN

!*** FSB Internal Volume mixture case for optics 
                SELECT CASE( AEROSOL_OPTICS )
                  CASE( 1 )
                      CALL AERO_OPTICS_TABULAR( MODE,V,NR_SHELL, VOL, DGN_SHELL,
     &                                   XXLSG, BEXT_MODE, BSCAT_MODE, GBAR_MODE)
                      VFAC  = 1.0 ! correction factor
                  CASE( 2 )
                     IF ( SUCCESS ) CALL AERO_OPTICAL2( LAMDA_UM, NR_SHELL, VOL, 
     &                                   DGN_SHELL, XXLSG,
     &                                   BEXT_MODE, BSCAT_MODE, GBAR_MODE, SUCCESS )
                     VFAC  = 1.0 ! correction factor 
                  CASE DEFAULT ! AEROSOL_OPTICS equals 3
! use old fast optics method
                     IF ( SUCCESS ) CALL FAST_OPTICS( AE_NR_SHELL( MODE, L, V ),  
     &                                       AE_NI_SHELL( MODE, L, V ), 
     &                                       WAVELENGTH( V ), DGN_SHELL, XXLSG, 
     &                                       BEXT_MODE, BSCAT_MODE, GBAR_MODE )
                     VFAC  = VOL * INV_LAMBDA
! updated fast optics method; has problems from eposidically infinite values of aerosol optical depth
!                    MIE_PARAMETER = PI * DGN_SHELL * INV_LAMBDA
!     &                            * EXP( 3.0 * BLK_AE_LSG( MODE, L ) * BLK_AE_LSG( MODE, L ) )
!                    IF( SUCCESS ) CALL FASTER_OPTICS( AE_NR_SHELL( MODE, L, V ),  
!     &                                       AE_NI_SHELL( MODE, L, V ), 
!     &                                       MIE_PARAMETER, BLK_AE_LSG( MODE, L ), 
!     &                                       BEXT_MODE, BSCAT_MODE, GBAR_MODE )
!                    VFAC  = VOL * INV_LAMBDA
                  END SELECT
                   
                  IF ( BEXT_MODE .LT. 0.0 .OR. BEXT_MODE .LT. BSCAT_MODE .OR. BSCAT_MODE .LT. 0.0 ) THEN
                     TROUBLE = .TRUE.
                  END IF

                  IF ( BEXT_MODE .NE. BEXT_MODE .OR. BSCAT_MODE .NE. BSCAT_MODE ) THEN
                     TROUBLE = .TRUE.
                  END IF

                  IF ( GBAR_MODE .NE. GBAR_MODE .OR. ABS( GBAR_MODE ) .GT. 0.9999999 ) THEN
                     TROUBLE = .TRUE.
                  END IF

9402              format('layer = ',i2,' lambda  = ',es12.4,' dgn_core = ',es12.4,' dgn_shell = ',
     &                 es12.4,' ae_bext = ',es12.4,' ae_bscat = ',es12.4,' ae_gbar = ',es12.4,
     &                 ' refract_shell(nr,ni) = ', 2(es12.4,1x),' refract_core = ', 2(es12.4,1x))

                  IF ( TROUBLE ) THEN

                     write(logdev, 9402)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
     &               bscat_mode, gbar_mode, ae_nr_shell( mode, l, v ), ae_ni_shell( mode, l, v ),
     &               ae_nr_core( mode, l, v ), ae_ni_core( mode, l, v )
!                    write(6, 9402)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
!    &               bscat_mode, gbar_mode, ae_nr_shell( mode, l, v ), ae_ni_shell( mode, l, v ),
!    &               ae_nr_core( mode, l, v ), ae_ni_core( mode, l, v )

                     WRITE( LOGDEV, 9504 ) L, MODE, WAVELENGTH( V ), 
     &               AE_DGN_SHELL( MODE,L ), AE_NR_SHELL( MODE,L,V ),
     &               AE_NI_SHELL( MODE,L,V ), BLK_AE_VOL( MODE,L ),
     &               BLK_AE_LSG( MODE,L )
     
                     XMSG =  'FAILURE IN AERO_OPTICAL2: shell only case '
                     CALL M3WARN( PNAME, 0, 0, XMSG )
                     
                  END IF

                  IF ( .NOT. SUCCESS ) THEN

                     write(logdev, 9402)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
     &               bscat_mode, gbar_mode, ae_nr_shell( mode, l, v ), ae_ni_shell( mode, l, v ),
     &               ae_nr_core( mode, l, v ), ae_ni_core( mode, l, v )
!                    write(6, 9402)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
!    &               bscat_mode, gbar_mode, ae_nr_shell( mode, l, v ), ae_ni_shell( mode, l, v ),
!    &               ae_nr_core( mode, l, v ), ae_ni_core( mode, l, v )

                     WRITE( LOGDEV, 9504) L, MODE, WAVELENGTH( V ), 
     &               AE_DGN_SHELL( MODE,L ), AE_NR_SHELL( MODE,L,V ),
     &               AE_NI_SHELL( MODE,L,V ), BLK_AE_VOL( MODE,L ),
     &               BLK_AE_LSG( MODE,L )
     
                     XMSG =  'FAILURE IN AERO_OPTICAL2: shell only case '
                     CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
                     
                  END IF

C***sum to get total extinction and scattering
C***  and contribution to the overall asymmetry factor

                  BEXT  = BEXT + VFAC * BEXT_MODE
                  BSC   = VFAC * BSCAT_MODE
                  BSCAT = BSCAT + BSC
                  G_BAR = G_BAR + BSC * GBAR_MODE

               END IF       

            END DO OPTICS_LOOP

            AERO_SCAT_COEF( L,V ) = MAX( BSCAT,1.0E-30 )
            AERO_EXTI_COEF( L,V ) = MAX( BEXT, 1.0E-30 )
            AERO_ABSO_COEF( L,V ) = MAX( (BEXT-BSCAT), 1.0E-30 )
            AERO_ASYM_FAC ( L,V ) = G_BAR / MAX( BSCAT, 1.0E-30 )

#ifdef verbose_phot_extra
            if( l .eq. 1 .and. v .eq. 1)then
               write(logdev, 9502)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
     &         bscat_mode, gbar_mode, ae_nr_shell( l, mode, v ), ae_ni_shell( v, mode, v ),
     &         ae_nr_core( l, mode, iv ), ae_ni_core( l, mode, v )
9502           format('layer = ',i2,' lambda  = ',es12.4,' dgn_core = ',es12.4,' dgn_shell = ',
     &                 es12.4,' ae_bext = ',es12.4,' ae_bscat = ',es12.4,' ae_gbar = ',es12.4,
     &                 ' refract_shell(nr,ni) = ', 2(es12.4,1x),' refract_core = ', 2(es12.4,1x))
            end if
#endif            

         END DO LAY_LOOP2         

      END DO LOOP_WAVE

      IF( CALCULATE_EXT_550 )THEN
!         IF( USE_ANGSTROM_INTERP .AND. FIRSTCALL )THEN
!          WRITE(LOGDEV,'(A,2(F7.3,1X))')'Angstrom Interpolation Wavelengths: ', 
!     &     WAVELENGTH( IWL_ANGSTROM_LOWER ), WAVELENGTH( IWL_ANGSTROM_UPPER  )
!           WRITE(LOGDEV,'(A,2(ES12.4,1X))')'Angstrom Span, Ratio: ', 
!     &     ANGSTROM_SPAN, ANGSTROM_RATIO
!         END IF
         LOOP_550NM: DO L = 1, NLAYS
              IF( USE_ANGSTROM_INTERP )THEN
!                ANGSTROM_EXPONENT  =  - REAL( LOG( AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER ) 
!    &                                         / AERO_EXTI_COEF( L,IWL_ANGSTROM_UPPER ) ), 8 )

                 ANGSTROM_EXPONENT  =  - REAL( LOG( MAX( AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER ),1.0E-30 )
     &                              /               MAX( AERO_EXTI_COEF( L,IWL_ANGSTROM_UPPER ),1.0E-30 ) ), 8 )
     &                              *  ANGSTROM_SPAN

                 AERO_EXTI_550( L ) =  AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER ) 
     &                              *  REAL( ANGSTROM_RATIO ** ANGSTROM_EXPONENT, 4 )

                 ANGSTROM_EXPONENT  =  - REAL( LOG( MAX( AERO_SCAT_COEF( L,IWL_ANGSTROM_LOWER ),1.0E-30 )
     &                              /               MAX( AERO_SCAT_COEF( L,IWL_ANGSTROM_UPPER ),1.0E-30 ) ), 8 )
     &                              *  ANGSTROM_SPAN

                 AERO_ABSO_550( L ) =  MAX( AERO_EXTI_550( L ) 
     &                              -  AERO_SCAT_COEF( L,IWL_ANGSTROM_LOWER )
     &                              *  REAL( ANGSTROM_RATIO ** ANGSTROM_EXPONENT, 4 ), 0.0 )

!                 IF ( FIRSTCALL ) THEN
!                     WRITE( LOGDEV,'(I3,A,7(ES12.4,1X))')L,
!     &              ' AERO_EXT_LOWER,AERO_EXT_UPPER,EXPONENT,EXPONENT*LOG(RATIO),EXT_550_1,EXT_550_2: ',
!     &               AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER ), AERO_EXTI_COEF( L,IWL_ANGSTROM_UPPER ),
!     &               ANGSTROM_EXPONENT,REAL( ANGSTROM_EXPONENT * LOG_ANGSTROM_RATIO,4),AERO_EXTI_550( L ),
!     &               AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER)*ANGSTROM_RATIO ** ANGSTROM_EXPONENT
!                 END IF
              ELSE
                 AERO_EXTI_550( L ) =  AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER )
              END IF
         END DO LOOP_550NM
!         IF ( FIRSTCALL ) FIRSTCALL = .FALSE.
      END IF 
      
#ifdef verbose_phot
      if ( col .eq. 1 .and. row .eq. 1 ) then
         l = 1
         v = 1
         do mode = 1, n_mode
            write(logdev, 5005)l, mode, v, ae_nr_core ( mode, l, v ), ae_ni_core ( mode, l, v ),
     &      ae_nr_shell ( mode, l, v ), ae_ni_shell ( mode, l, v )
5005        format('lay = ',i3,' mode = ',i3,' wlv index = ',i3,' ae_core(nr,ni) = ',
     &      2(es12.4,1x), ' ae_shell(nr,ni) = ', 2(es12.4,1x))
         end do
      end if
#endif

9503  FORMAT('LAYER = ',I3,' MODE = ',I3,' LAMBDA(nm)  = ',ES12.4,' DGN_CORE(m) = ',ES12.4,
     &       ' DGN_SHELL(m) = ', ES12.4 / ' REFRACT_IDX_SHELL(NR,NI) = ', 2(ES12.4,1X),
     &       ' REFRACT_IDX_CORE(NR,NI) = ', 2(ES12.4,1X) / ' LN(GEO.STD.DEV.) = ',
     &       ES12.4)
9504  FORMAT('LAYER = ',I3,' MODE = ',I3,' LAMBDA(nm)  = ',ES12.4,' DGN(m) = ',ES12.4,
     &       ' REFRACT_IDX(NR,NI) = ', 2(ES12.4,1X) / ' VOL.DENS. = ', ES12.4,
     &       ' LN(GEO.STD.DEV.) = ', ES12.4)

      RETURN
      END SUBROUTINE GET_AERO_DATA
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE FASTER_OPTICS ( NR, NI, ALPHV, XLNSIG, BETA_EXT, BETA_SCAT, G )
C-----------------------------------------------------------------------
C  A parameterization of the aerosol extinction and scattering code
C     Coded by Dr. Francis S. Binkowski
C     CEMP, The Institute for the Environment
C     The University of North Carolina at Chapel Hill
C     email: frank_binkowski@unc.edu
C     Code dates. Began February 25, 2005, current March 18, 2005
C     modified by FSB May 10, 2005 to calculate asymmetry factor by the
C     semi-empirical method of Hanna and Mathur. Note that
C     the normalized scattering coefficient (non-dimensional) is
C     interpreted as an average of  scattering efficiency over the
C     size distribution
C     Modified 05/25/2005 to ensure that if ni = 0.0, that
C     beta_scat = beta_ext.
C     Modified 03/17/2008 to ensure match with reference calculation for
C     all cases of sigma_g.
C     Modified 10/25/2009 to be consistent with research version of code.
C     The modifications include better representation of the
C     asymmetry factor.
C     The form of the mathematical expression for extinction
C     and scattering is based upon that of
C     Heintzenberg & Baker (1976), and further inspired by the work
C     of Willeke and Brockmann(1977) who showed the basic shape of
C     the extinction resulting from an integration of the Mie extinction
C     efficiency over a log normal particle size distribution.
C     This current code has been developed from a direct calculation of
C     extinction and scattering using a Mie code integrated over
C     a log normal distribution. The results of that calculation
C     replicate the Willee and Brockmann (1977) results.
C     The parameterization is based upon a fit to the standard CMAQ
C     radiative transfer code for visibility. to which a module for
C     absorption was added so that absorption and scattering would also be
C     available.
C
C     The  shape has been modified for absorption by small particles
C     by using the formulae of Penndorf (1962). For large particles,
C     the shape has been altered by using the large sphere values from
C     Table I of  Irvine (1965)
C
C     Results are consistent with those of Willeke and Brockmann (1977).
C
C     The asymmetry factor is calculated by a new algorithm FSB - 04/04/2008
C     Sept 2014: J.Young-change arguments and usage of Mie Paramater attempting
C                to optimize runtimes or efficiency
C     Oct  2014: B.Hutzell-Added mininum values for scatttering efficiency for small
C                highly absorbing particles such as Aitken particle that
C                are mostly composed of elemental carbon
C
C  References:
C
C     Heintzenberg, J. and M. Baker, Spherical particle populations:
C     approximate analytic relationship between size distribution
C     parameters and integral optical properties, Applied Optics,
C     Volume 15, Number 5 pp 1178-1181, May 1976.
C
C     Irvine, W. M. Light Scattering by spherical particles: Radiation
C     pressure, asymmetry factor, and extinction cross section,
C     Journal of eh Optical Society of Amerioca, Vol. 55, NO. 1,
C     January ,1965
C
C     Penndorf, R. Scattering and Extinction Coefficeints for small
C     spherical particles, J. Atmospheric Sciences, Volume 19, p 193,
C     March 1962.
C
C     Willeke, K. and  J. E. Brockmann, Extinction coefficients for
C     multmodal atmospheric particle size distributions, Atmospheric
C     Environment, vol. 11, pp 95-999, 1977.
C-----------------------------------------------------------------------

      USE CONST, ONLY: PI, PI180
      IMPLICIT NONE

C***arguments

      REAL, INTENT( IN )  :: NR, NI     ! indices of refraction
      REAL, INTENT( IN )  :: ALPHV      ! Mie parameter for dgv
      REAL, INTENT( IN )  :: XLNSIG     ! log of geometric standard deviation

      REAL, INTENT( OUT ) :: BETA_EXT   ! normalized extinction coefficient
      REAL, INTENT( OUT ) :: BETA_SCAT  ! normalized scattering coefficient
      REAL, INTENT( OUT ) :: G          ! asymmetry factor

C***internal variables

      REAL NR1, NR2, TAU
      REAL C, CEXT, CSCAT
      REAL B, BEXT, BSCAT
      REAL BBFAC
      REAL ALPHA_I
      REAL A, LOGX2, XLNSIG2, MM1

      REAL, PARAMETER :: SIGMA_G_TWO = 2.0
      REAL, PARAMETER :: LOGSIG_TWO = 0.693147
      REAL, PARAMETER :: LOGSIG_TWO_SQD = LOGSIG_TWO * LOGSIG_TWO
      REAL, PARAMETER :: LOGSIG_105 = 1.102500
      REAL, PARAMETER :: DIFFSIG = SIGMA_G_TWO - 1.05
      REAL, PARAMETER :: A_TWO = 0.5 / LOGSIG_TWO_SQD
      REAL LARGESCAT  ! large sphere limit for scattering
      REAL LARGEEXT   ! large sphere limit for extinction
      REAL SMALL_G, LARGE_G

      REAL ALPHV2, ALPHV3
      REAL X_ALPHA, X_ALPHA2, X_ALPHA3
      REAL SIGMA_G, FCORR
      REAL EXPFAC2, EXPFAC3
      REAL EFAC, EFAC_EXT, EFAC_SCAT
      REAL DEN1, FAC1, FAC2
      REAL F1, F2, F3
      REAL G1, G2, G3, G4, G5
      REAL NN, TT

      REAL T1F1, T2F1, T1F2, T2F2, T1F3, T2F3
      REAL T1G1, T2G1, T1G2, T2G2, T1G3, T2G3, T1G4, T2G4
      REAL T1G5, T2G5, T1P1, T2P1

C***the following are for calculating the Penndorff Coefficients

      REAL PENN1, A1, A2, A3, PENN2
      REAL XNR, XNI, XNR2, XNI2, XNRI, XNRI2, XNRMI
      REAL XRI, XRI2, XRI36, XNX, XNX2
      REAL Z1, Z12, Z2, XC1

C***coefficients for polynomials

      REAL, PARAMETER :: F1A0 = -1.309193E-1
      REAL, PARAMETER :: F1A1 =  2.565668E+0

      REAL, PARAMETER :: F2A0 =  1.489233E+1
      REAL, PARAMETER :: F2A1 = -5.311351E+1
      REAL, PARAMETER :: F2A2 =  8.180334E+1
      REAL, PARAMETER :: F2A3 = -4.549854E+1

      REAL, PARAMETER :: F3A0 =  5.549359E-1
      REAL, PARAMETER :: F3A1 =  2.571002E-1
      REAL, PARAMETER :: F3A2 =  9.212703E-1
      REAL, PARAMETER :: F3A3 =  5.155047E-2

      REAL, PARAMETER :: G1A0 =  1.000000E+0
      REAL, PARAMETER :: G1A1 = -7.636121E-1
      REAL, PARAMETER :: G1A2 =  1.285532E+0
      REAL, PARAMETER :: G1A3 =  1.629161E-2

      REAL, PARAMETER :: G2A0 =  1.000000E+0
      REAL, PARAMETER :: G2A1 = -2.507954E+0
      REAL, PARAMETER :: G2A2 =  5.170246E+0
      REAL, PARAMETER :: G2A3 = -4.945515E+0

      REAL, PARAMETER :: G3A0 =  1.000000E+0
      REAL, PARAMETER :: G3A1 = -2.650134E+0
      REAL, PARAMETER :: G3A2 =  4.515327E+0
      REAL, PARAMETER :: G3A3 = -4.027442E+0

      REAL, PARAMETER :: G4A0 =  1.000000E+0
      REAL, PARAMETER :: G4A1 = -8.532647E-1
      REAL, PARAMETER :: G4A2 =  6.766073E-1

      REAL, PARAMETER :: G5A0 =  1.0
      REAL, PARAMETER :: G5A1 = -6.674946E-1
      REAL, PARAMETER :: G5A2 = -5.426378E-1

C *** Coefficients for quadratic fit for <cos> large particles
C     from Irvine (1965) Table I
      REAL, PARAMETER :: IRVA0 =  1.076232E+0
      REAL, PARAMETER :: IRVA1 = -4.891972E-2
      REAL, PARAMETER :: IRVA2 = -2.243449E-2


C FSB Coefficients for SMALL_G  calculation
      REAL, PARAMETER :: XXA0 =  3.392224E-2
      REAL, PARAMETER :: XXA1 =  8.276532E-1
      REAL, PARAMETER :: XXA2 = -3.784926E-1
      REAL, PARAMETER :: XXA3 =  5.853108E-2
      REAL, PARAMETER :: G_ALPHA_I = XXA0 + XXA1 + XXA2 + XXA3

C FSB Coefficients for LARGE_G calculation
      REAL, PARAMETER :: YYA0 =  6.776173E-1
      REAL, PARAMETER :: YYA1 =  2.385339E-2
      REAL, PARAMETER :: YYA2 = -7.952263E-4
      REAL, PARAMETER :: YYA3 =  9.410370E-6

C FSB Coefficientf for adjusting asymmetry factor calculation
      REAL, PARAMETER :: CXG0 = -5.845196E-2
      REAL, PARAMETER :: CXG1 =  3.229183E-1
      REAL, PARAMETER :: CXG2 =  2.764716E-1
      REAL, PARAMETER :: CXG3 = -8.790411E-2

C***FSB added for asymmetry factor calculation

      REAL QSCAT_AVG

      REAL, PARAMETER :: AA0 =  88.466
      REAL, PARAMETER :: AA1 = -61.628
      REAL, PARAMETER :: AA2 =  34.483
      REAL, PARAMETER :: AA3 =  -8.543
      REAL, PARAMETER :: AA4 =   0.77435

      REAL GMAX
      REAL QANGLE
      REAL QQ, QF1, QF2, QF3
      REAL QQSUM, QQF1,QQF2, QQF3, QQCORR

      REAL, PARAMETER :: DEGTORAD = PI180
      REAL, PARAMETER :: THREE_PI_TWO = 3.0 * PI / 2.0

C***FSB start calculation
      SIGMA_G = EXP( XLNSIG )
C FSB check range of SIGMA_G
C *** Maximum value of SIGMA_G allowed is 2.0
      SIGMA_G = MIN( 2.0, SIGMA_G )
C *** Minimum allowed value of SIGMA_G is 1.05
      SIGMA_G = MAX( 1.05, SIGMA_G )

      XLNSIG2 = XLNSIG * XLNSIG
      A = 0.5 / XLNSIG2

      NR1 = NR - 1.0
      NR2 = NR * NR

C***evaluate polynomials
C***  optimize for piplined microprocessor
C***  approach recommended by Dr. Carlie Coats

      NN = NR1 * NR1

      T1F1 = F1A0 + F1A1 * NR1
      T1F2 = F2A0 + F2A1 * NR1
      T2F2 = F2A2 + F2A3 * NR1
      T1F3 = F3A0 + F3A1 * NR1
      T2F3 = F3A2 + F3A3 * NR1

      F1 = T1F1                 ! linear
      F2 = T1F2 + T2F2 * NN     ! cubic
      F3 = T1F3 + T2F3 * NN     ! cubic

      C = F1

C FSB correct for values of SIGMA_ less than 2.0.
C     The smallest value of SIGMA_G allowed is 1.05
C     2.0 - 1.05 = 0.95
C      FCORR   = (1.0 - 0.13 * (SIGMA_G - 1.05)  / 0.95 )
C     1.0 / 0.95 = 1.052632.  1.0 / 0.95 * 0.13 = 0.136842

      FCORR   = 1.0 - 0.136842 * ( SIGMA_G - 1.05 )

      CEXT    = C * FCORR
      CSCAT   = CEXT
      B       = F3 * A_TWO
      ALPHA_I = F2
      BEXT    = B
      BSCAT   = B
      PENN1   = 0.0
      PENN2   = 0.0

      ALPHV2 = ALPHV * ALPHV
      ALPHV3 = ALPHV2 * ALPHV

      IF ( NI .GT. 0.0 ) THEN

         TAU = NI / NR1

C***evaluate more polynomials
C***  optimize for piplined microprocessor
C***  approach recommended by Dr. Carlie Coats

         TT = TAU * TAU
         T1G1 = G1A0 + G1A1 * TAU
         T2G1 = G1A2 + G1A3 * TAU
         T1G2 = G2A0 + G2A1 * TAU
         T2G2 = G2A2 + G2A3 * TAU
         T1G3 = G3A0 + G3A1 * TAU
         T2G3 = G3A2 + G3A3 * TAU
         T1G4 = G4A0 + G4A1 * TAU
         T2G4 = G4A2            ! quadratic
         T1G5 = G5A0 + G5A1 * TAU
         T2G5 = G5A2            ! quadratic
         G1   = T1G1 + T2G1 * TT
         G2   = T1G2 + T2G2 * TT
         G3   = T1G3 + T2G3 * TT
         G4   = T1G4 + T2G4 * TT
         G5   = T1G5 + T2G5 * TT

C *** adjust the variables

         CEXT    = CEXT    * G1
         CSCAT   = CSCAT   * G2
         BEXT    = BEXT    * G3
         BSCAT   = BSCAT   * G4
         ALPHA_I = ALPHA_I * G5

C*** Calculate the Penndorf Coefficients for the small particle limit

         XNR   = NR
         XNI   = NI
         XNR2  = XNR   * XNR
         XNI2  = XNI   * XNI
         XNRI  = XNR2  + XNI2
         XNRI2 = XNRI  * XNRI
         XNRMI = XNR2  - XNI2
         XRI   = XNR   * XNI
         XRI2  = XRI   * XRI
         XRI36 = 36.0  * XRI2
         XNX   = XNRI2 + XNRMI - 2.0
         XNX2  = XNX   * XNX

         Z1    = XNRI2 + 4.0 * XNRMI + 4.0
         Z12   = Z1    * Z1
         Z2    = 4.0   * XNRI2 + 12.0 * XNRMI + 9.0
         XC1   = 8.0   / ( 3.0 * Z12 )
         A1    = 24.0  * XRI / Z1

         A2    = 4.0   * XRI / 15.0 + 20.0 * XRI / ( 3.0 * Z2 ) +
     &           4.8   * XRI * (  7.0 * XNRI2 +
     &           4.0   * ( XNRMI - 5.0 ) ) / Z12

         A3    = XC1   * ( XNX2 - XRI36 )

!        ALPHV2 = ALPHV * ALPHV
!        ALPHV3 = ALPHV2 * ALPHV
         EXPFAC2 = EXP( 2.0 * XLNSIG2 )
         EXPFAC3 = EXP( 4.5 * XLNSIG2 )

         T1P1 = A1 + A2 * ALPHV2 * EXPFAC2
         T2P1 = A3 * ALPHV3 * EXPFAC3

C***PENN1 is the analytic integral of the Pendorff formulae over
C***   a log normal particle size distribution.

         PENN1 = THREE_PI_TWO * ( T1P1 + T2P1 )
         PENN2 = THREE_PI_TWO * T2P1

      END IF   ! test for ni > 0.0

      X_ALPHA  = ALPHV / ALPHA_I

!     LOGX2    = LOG( X_ALPHA )** 2
      LOGX2    = LOG( X_ALPHA )
      LOGX2    = LOGX2 * LOGX2

      BBFAC    = BEXT * A  / ( BEXT + A )

      EFAC_EXT = EXP( -BBFAC * LOGX2 )

C***FSB calculate normalized extinction and scattering coefficients

      BETA_EXT = THREE_PI_TWO * CEXT
     &         * SQRT( A / ( BEXT + A ) ) * EFAC_EXT

      BETA_SCAT = BETA_EXT      ! NI = 0.0 case

C *** Check for NI > 0.0

      IF ( NI .GT. 0.0 ) THEN

!        BBFAC = 1.5 * BBFAC ! reset BBFAC for scattering
         BBFAC = 1.1 * BBFAC ! reset BBFAC for scattering

         EFAC_SCAT = EXP( -BBFAC * LOGX2 )

C *** recalculate the normalized scattering coefficient

         BETA_SCAT = THREE_PI_TWO * CSCAT
     &             * SQRT( A / ( BSCAT + A ) ) * EFAC_SCAT

C *** Adjust beta_ext for small particle absorption:

         IF ( X_ALPHA .LT. 0.13 ) THEN

            FAC1 = ALPHV + 0.6 * ALPHV2

            BETA_EXT = MAX( BETA_EXT,
     &                    ( BETA_EXT  * FAC1 + ( 1.0 - FAC1 ) * PENN1 ) )

            BETA_SCAT = MAX( BETA_SCAT,
     &                     ( BETA_SCAT * FAC1 + ( 1.0 - FAC1 ) * PENN2 ) )

         END IF ! test for   XALPHA < 0.13

! small highly absorbing  particles such as a Tyndall scatterers such as
! described in Jacobson (1999) in Fundmentals of Atmospheric Modeling. This
! is approximately consistent with Penndorf (1962).

        BETA_SCAT = MAX( 0.001 * BETA_EXT, BETA_SCAT )

      END IF  ! test for NI > 0.0

C *** Calculate large sphere limits(Irvine, 1965)

      MM1 = EXP( 0.5 * XLNSIG2 ) / ALPHV

C FSB large sphere limit - scattering

      LARGESCAT = THREE_PI_TWO * ( 8.652439E-01 + 1.501772E-01 * NR ) * MM1

C FSB large spnere limit for extinction ( no edge effects )

      LARGEEXT = THREE_PI_TWO * ( 2.0 * MM1 )

C FSB Adjust for large sphere limits

      IF ( ALPHV .GE. 10.0 ) THEN

         BETA_EXT  = MAX( BETA_EXT, LARGEEXT )

         BETA_SCAT = MAX( BETA_SCAT, LARGESCAT )

      END IF ! test for 10.0 < ALPHV

C***FSB now calculate the asymmetry factor
C***  using the Hanna-Mathur quasi-empirical method
!     GMAX = 0.0

!     QSCAT_AVG = BETA_SCAT
!     QANGLE = AA0

!     IF ( QSCAT_AVG .GT. 1.0E-4 ) THEN
!        QQ  = QSCAT_AVG * QSCAT_AVG
!        QF1 = AA0 + AA1 * QSCAT_AVG
!        QF2 = AA2 + AA3 * QSCAT_AVG
!        QF3 = AA4 * QSCAT_AVG * QSCAT_AVG
!        QANGLE = QF1 + QF2 * QQ + QF3 * QQ
!     END IF

!     QANGLE = DEGTORAD * QANGLE
!     G      = COS( QANGLE)     ! asymmetry factor

C***FSB now calculate the asymmetry factor
C***   using a parametric fit to Mie calculations

      X_ALPHA2 = X_ALPHA * X_ALPHA
      X_ALPHA3 = X_ALPHA2 * X_ALPHA

      SMALL_G = 0.0
      LARGE_G = 0.0

      IF ( ALPHV .LT. 2.6 ) THEN

C FSB Calculate SMALL_G for sigma_g = 2.0

         QF1 = XXA0 + XXA1 * ALPHV
         QF2 = XXA2 * ALPHV2
         QF3 = XXA3 * ALPHV3
         SMALL_G = QF1 + QF2 + QF3 ! valid at sigma_g = 2.0

C FSB adjust SMALL_G for values less than 2.0
C     The smallest sigma_g allowed is 1.05

         QQF1 = CXG0 + CXG1 * ALPHV
         QQF2 = CXG2 * ALPHV2
         QQF3 = CXG3 * ALPHV3
         QQSUM = QQF1 + QQF2 + QQF3
         FAC1 = 1.052632 * ( 2.0 - SIGMA_G )
         QQSUM = MAX( 0.0, QQSUM )
         QQCORR = ( 1.0 - FAC1 ) + FAC1 * QQSUM
         SMALL_G = SMALL_G * QQCORR
         G = SMALL_G

      ELSE IF ( ALPHV .LT. 100.0 ) THEN

         QF1 = YYA0 + YYA1 * X_ALPHA
         QF2 = YYA2 * X_ALPHA2
         QF3 = YYA3 * X_ALPHA3
         LARGE_G = QF1 + QF2 + QF3
         G = LARGE_G

      ELSE

C     Very large sphere limit from fit to Irvine (1965).

         G = 1.124484 - 1.153869E-01 * NR

      END IF

      RETURN
      END SUBROUTINE FASTER_OPTICS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE FAST_OPTICS( NR, NI, LAMBDA, DGN, SIGMA_G, BETA_EXT, BETA_SCAT, G )
C-----------------------------------------------------------------------
C  A parameterization of the aerosol extinction and scattering code
C     Coded by Dr. Francis S. Binkowski
C     CEMP, The Institute for the Environment
C     The University of North Carolina at Chapel Hill
C     email: frank_binkowski@unc.edu
C     Code dates. Began February 25, 2005, current March 18, 2005
C     modified by FSB May 10, 2005 to calculate asymmetry factor by the
C     semi-empirical method of Hanna and Mathur. Note that
C     the normalized scattering coefficient (non-dimensional) is
C     interpreted as an average of  scattering efficiency over the
C     size distribution
C     Modified 05/25/2005 to ensure that if ni = 0.0, that
C     beta_scat = beta_ext.
C     Modified 03/17/2008 to ensure match with reference calculation for
C     all cases of sigma_g.
C     Modified 10/25/2009 to be consistent with research version of code.
C     The modifications include better representation of the
C     asymmetry factor.
C     The form of the mathematical expression for extinction
C     and scattering is based upon that of
C     Heintzenberg & Baker (1976), and further inspired by the work
C     of Willeke and Brockmann(1977) who showed the basic shape of
C     the extinction resulting from an integration of the Mie extinction
C     efficiency over a log normal particle size distribution.
C     This current code has been developed from a direct calculation of
C     extinction and scattering using a Mie code integrated over
C     a log normal distribution. The results of that calculation
C     replicate the Willee and Brockmann (1977) results.
C     The parameterization is based upon a fit to the standard CMAQ
C     radiative transfer code for visibility. to which a module for
C     absorption was added so that absorption and scattering would also be
C     available.
C
C     The  shape has been modified for absorption by small particles
C     by using the formulae of Penndorf (1962). For large particles,
C     the shape has been altered by using the large sphere values from
C     Table I of  Irvine (1965)
C
C     Results are consistent with those of Willeke and Brockmann (1977).
C
C     The asymmetry factor is calculated by a new algorithm FSB - 04/04/2008
C
C     Oct  2014: B.Hutzell-Added mininum values for scatttering efficiency for small
C                highly absorbing particles such as Aitken particle that
C                are mostly composed of elemental carbon
C
C  References:
C
C     Heintzenberg, J. and M. Baker, Spherical particle populations:
C     approximate analytic relationship between size distribution
C     parameters and integral optical properties, Applied Optics,
C     Volume 15, Number 5 pp 1178-1181, May 1976.
C
C     Irvine, W. M. Light Scattering by spherical particles: Radiation
C     pressure, asymmetry factor, and extinction cross section,
C     Journal of eh Optical Society of Amerioca, Vol. 55, NO. 1,
C     January ,1965
C
C     Penndorf, R. Scattering and Extinction Coefficeints for small
C     spherical particles, J. Atmospheric Sciences, Volume 19, p 193,
C     March 1962.
C
C     Willeke, K. and  J. E. Brockmann, Extinction coefficients for
C     multmodal atmospheric particle size distributions, Atmospheric
C     Environment, vol. 11, pp 95-999, 1977.
C-----------------------------------------------------------------------

      USE CONST, ONLY: PI, PI180
      IMPLICIT NONE

C***arguments

      REAL, INTENT( IN )     :: NR, NI     ! indices of refraction
      REAL, INTENT( IN )     :: LAMBDA     ! wavelength, nm
      REAL, INTENT( IN )     :: DGN        ! geometric mean diameter, m
      REAL, INTENT( INOUT )  :: SIGMA_G    ! geometric standard deviation

      REAL, INTENT( OUT )    :: BETA_EXT   ! normalized extinction coefficient
      REAL, INTENT( OUT )    :: BETA_SCAT  ! normalized scattering coefficient
      REAL, INTENT( OUT )    :: G          ! asymmetry factor

C***internal variables

      REAL NR1, NR2, TAU
      REAL C, CEXT, CSCAT
      REAL B, BEXT, BSCAT
      REAL BBFAC
      REAL ALPHV
      REAL ALPHA_I
      REAL A, LOGX2, XLNSIG, XLNSIG2, MM1

      REAL, PARAMETER :: SIGMA_G_TWO = 2.0
      REAL, PARAMETER :: LOGSIG_TWO = 0.693147
      REAL, PARAMETER :: LOGSIG_TWO_SQD = LOGSIG_TWO * LOGSIG_TWO
      REAL, PARAMETER :: LOGSIG_105 = 1.102500
      REAL, PARAMETER :: DIFFSIG = SIGMA_G_TWO - 1.05
      REAL, PARAMETER :: A_TWO = 0.5 / LOGSIG_TWO_SQD
      REAL LARGESCAT  ! large sphere limit for scattering
      REAL LARGEEXT   ! large sphere limit for extinction
      REAL SMALL_G, LARGE_G

      REAL ALPHV2, ALPHV3
      REAL X_ALPHA, X_ALPHA2, X_ALPHA3
      REAL FCORR
      REAL EXPFAC2, EXPFAC3
      REAL EFAC, EFAC_EXT, EFAC_SCAT
      REAL DEN1, FAC1, FAC2
      REAL F1, F2, F3
      REAL G1, G2, G3, G4, G5
      REAL NN, TT

      REAL T1F1, T2F1, T1F2, T2F2, T1F3, T2F3
      REAL T1G1, T2G1, T1G2, T2G2, T1G3, T2G3, T1G4, T2G4
      REAL T1G5, T2G5, T1P1, T2P1

C***the following are for calculating the Penndorff Coefficients

      REAL PENN1, A1, A2, A3, PENN2
      REAL XNR, XNI, XNR2, XNI2, XNRI, XNRI2, XNRMI
      REAL XRI, XRI2, XRI36, XNX, XNX2
      REAL Z1, Z12, Z2, XC1

C***coefficients for polynomials

      REAL, PARAMETER :: F1A0 = -1.309193E-1
      REAL, PARAMETER :: F1A1 =  2.565668E+0

      REAL, PARAMETER :: F2A0 =  1.489233E+1
      REAL, PARAMETER :: F2A1 = -5.311351E+1
      REAL, PARAMETER :: F2A2 =  8.180334E+1
      REAL, PARAMETER :: F2A3 = -4.549854E+1

      REAL, PARAMETER :: F3A0 =  5.549359E-1
      REAL, PARAMETER :: F3A1 =  2.571002E-1
      REAL, PARAMETER :: F3A2 =  9.212703E-1
      REAL, PARAMETER :: F3A3 =  5.155047E-2

      REAL, PARAMETER :: G1A0 =  1.000000E+0
      REAL, PARAMETER :: G1A1 = -7.636121E-1
      REAL, PARAMETER :: G1A2 =  1.285532E+0
      REAL, PARAMETER :: G1A3 =  1.629161E-2

      REAL, PARAMETER :: G2A0 =  1.000000E+0
      REAL, PARAMETER :: G2A1 = -2.507954E+0
      REAL, PARAMETER :: G2A2 =  5.170246E+0
      REAL, PARAMETER :: G2A3 = -4.945515E+0

      REAL, PARAMETER :: G3A0 =  1.000000E+0
      REAL, PARAMETER :: G3A1 = -2.650134E+0
      REAL, PARAMETER :: G3A2 =  4.515327E+0
      REAL, PARAMETER :: G3A3 = -4.027442E+0

      REAL, PARAMETER :: G4A0 =  1.000000E+0
      REAL, PARAMETER :: G4A1 = -8.532647E-1
      REAL, PARAMETER :: G4A2 =  6.766073E-1

      REAL, PARAMETER :: G5A0 =  1.0
      REAL, PARAMETER :: G5A1 = -6.674946E-1
      REAL, PARAMETER :: G5A2 = -5.426378E-1

C *** Coefficients for quadratic fit for <cos> large particles
C     from Irvine (1965) Table I
      REAL, PARAMETER :: IRVA0 =  1.076232E+0
      REAL, PARAMETER :: IRVA1 = -4.891972E-2
      REAL, PARAMETER :: IRVA2 = -2.243449E-2


C FSB Coefficients for SMALL_G  calculation
      REAL, PARAMETER :: XXA0 =  3.392224E-2
      REAL, PARAMETER :: XXA1 =  8.276532E-1
      REAL, PARAMETER :: XXA2 = -3.784926E-1
      REAL, PARAMETER :: XXA3 =  5.853108E-2
      REAL, PARAMETER :: G_ALPHA_I = XXA0 + XXA1 + XXA2 + XXA3

C FSB Coefficients for LARGE_G calculation
      REAL, PARAMETER :: YYA0 =  6.776173E-1
      REAL, PARAMETER :: YYA1 =  2.385339E-2
      REAL, PARAMETER :: YYA2 = -7.952263E-4
      REAL, PARAMETER :: YYA3 =  9.410370E-6

C FSB Coefficientf for adjusting asymmetry factor calculation
      REAL, PARAMETER :: CXG0 = -5.845196E-2
      REAL, PARAMETER :: CXG1 =  3.229183E-1
      REAL, PARAMETER :: CXG2 =  2.764716E-1
      REAL, PARAMETER :: CXG3 = -8.790411E-2

C***FSB added for asymmetry factor calculation

      REAL QSCAT_AVG

      REAL, PARAMETER :: AA0 =  88.466
      REAL, PARAMETER :: AA1 = -61.628
      REAL, PARAMETER :: AA2 =  34.483
      REAL, PARAMETER :: AA3 =  -8.543
      REAL, PARAMETER :: AA4 =   0.77435

      REAL GMAX
      REAL QANGLE
      REAL QQ, QF1, QF2, QF3
      REAL QQSUM, QQF1,QQF2, QQF3, QQCORR

      REAL, PARAMETER :: DEGTORAD = PI180
      REAL, PARAMETER :: THREE_PI_TWO = 3.0 * PI / 2.0


      REAL, PARAMETER :: SCALE = 1.00E+9

C FSB check range of SIGMA_G
C *** Maximum value of SIGMA_G allowed is 2.0
      SIGMA_G = MIN( 2.0, SIGMA_G )
C *** Minimum allowed value fo SIGMA_F is 1.05
      SIGMA_G = MAX( 1.05, SIGMA_G )
C***FSB start calculation
      XLNSIG = LOG( SIGMA_G ) 

      ALPHV = SCALE * PI * DGN * EXP( 3.0 * XLNSIG * XLNSIG ) / LAMBDA
      ALPHV2 = ALPHV * ALPHV
      ALPHV3 = ALPHV * ALPHV * ALPHV

      XLNSIG2 = XLNSIG * XLNSIG
      A = 0.5 / XLNSIG2

      NR1 = NR - 1.0
      NR2 = NR * NR

C***evaluate polynomials
C***  optimize for piplined microprocessor
C***  approach recommended by Dr. Carlie Coats

      NN = NR1 * NR1

      T1F1 = F1A0 + F1A1 * NR1
      T1F2 = F2A0 + F2A1 * NR1
      T2F2 = F2A2 + F2A3 * NR1
      T1F3 = F3A0 + F3A1 * NR1
      T2F3 = F3A2 + F3A3 * NR1

      F1 = T1F1                 ! linear
      F2 = T1F2 + T2F2 * NN     ! cubic
      F3 = T1F3 + T2F3 * NN     ! cubic

      C       = F1

C FSB correct for values of SIGMA_ less than 2.0.
C     The smallest value of SIGMA_G allowed is 1.05
C     2.0 - 1.05 = 0.95
C      FCORR   = (1.0 - 0.13 * (SIGMA_G - 1.05)  / 0.95 )
C     1.0 / 0.95 = 1.052632.  1.0 / 0.95 * 0.13 = 0.136842

      FCORR   = 1.0 - 0.136842 * ( SIGMA_G - 1.05 )

      CEXT    = C * FCORR
      CSCAT   = CEXT
      B       = F3 * A_TWO
      ALPHA_I = F2
      BEXT    = B
      BSCAT   = B
      PENN1   = 0.0
      PENN2   = 0.0

      IF ( NI .GT. 0.0 ) THEN

         TAU = NI / NR1

C***evaluate more polynomials
C***  optimize for piplined microprocessor
C***  appproach recommended by Dr. Carlie Coats

         TT = TAU * TAU
         T1G1 = G1A0 + G1A1 * TAU
         T2G1 = G1A2 + G1A3 * TAU
         T1G2 = G2A0 + G2A1 * TAU
         T2G2 = G2A2 + G2A3 * TAU
         T1G3 = G3A0 + G3A1 * TAU
         T2G3 = G3A2 + G3A3 * TAU
         T1G4 = G4A0 + G4A1 * TAU
         T2G4 = G4A2            ! quadratic
         T1G5 = G5A0 + G5A1 * TAU
         T2G5 = G5A2            ! quadratic
         G1   = T1G1 + T2G1 * TT
         G2   = T1G2 + T2G2 * TT
         G3   = T1G3 + T2G3 * TT
         G4   = T1G4 + T2G4 * TT
         G5   = T1G5 + T2G5 * TT

C *** adjust the variables

         CEXT    = CEXT    * G1
         CSCAT   = CSCAT   * G2
         BEXT    = BEXT    * G3
         BSCAT   = BSCAT   * G4
         ALPHA_I = ALPHA_I * G5

C*** Calculate the Penndorf Coefficients for the small particle limit

         XNR   = NR
         XNI   = NI
         XNR2  = XNR   * XNR
         XNI2  = XNI   * XNI
         XNRI  = XNR2  + XNI2
         XNRI2 = XNRI  * XNRI
         XNRMI = XNR2  - XNI2
         XRI   = XNR   * XNI
         XRI2  = XRI   * XRI
         XRI36 = 36.0  * XRI2
         XNX   = XNRI2 + XNRMI - 2.0
         XNX2  = XNX   * XNX

         Z1    = XNRI2 + 4.0 * XNRMI + 4.0
         Z12   = Z1    * Z1
         Z2    = 4.0   * XNRI2 + 12.0 * XNRMI + 9.0
         XC1   = 8.0   / ( 3.0 * Z12 )
         A1    = 24.0  * XRI / Z1

         A2    = 4.0   * XRI / 15.0 + 20.0 * XRI / ( 3.0 * Z2 ) +
     &           4.8   * XRI * (  7.0 * XNRI2 +
     &           4.0   * ( XNRMI - 5.0 ) ) / Z12

         A3    = XC1   * ( XNX2 - XRI36 )

         EXPFAC2 = EXP( 2.0 * XLNSIG2 )
         EXPFAC3 = EXP( 4.5 * XLNSIG2 )

         T1P1 = A1 + A2 * ALPHV2 * EXPFAC2
         T2P1 = A3 * ALPHV3 * EXPFAC3

C***PENN1 is the analytic integral of the Pendorff formulae over
C***   a log normal particle size distribution.

         PENN1 = THREE_PI_TWO * ( T1P1 + T2P1 )
         PENN2 = THREE_PI_TWO * T2P1

      END IF                    ! test of ni > 0.0

      X_ALPHA  = ALPHV / ALPHA_I

      LOGX2    = LOG( X_ALPHA )** 2

      BBFAC    = BEXT * A  / ( BEXT + A )

      EFAC_EXT = EXP( -BBFAC * LOGX2 )

C***FSB calculate normalized extinction and scattering coefficients

      BETA_EXT = THREE_PI_TWO * CEXT *
     &                      SQRT( A / ( BEXT + A ) ) * EFAC_EXT

      BETA_SCAT = BETA_EXT      ! NI = 0.0 case

C *** Check for 0.0 < NI

      IF ( NI .GT. 0.0 ) THEN

!        BBFAC = 1.5 * BBFAC ! reset BBFAC for scattering
         BBFAC = 1.1 * BBFAC ! reset BBFAC for scattering

         EFAC_SCAT = EXP( -BBFAC * LOGX2 )

C *** recalculate the normalized scattering coefficient

         BETA_SCAT = THREE_PI_TWO * CSCAT *
     &                       SQRT( A / ( BSCAT + A ) ) * EFAC_SCAT

C *** Adjust beta_ext for small particle absorption:

         IF ( X_ALPHA .LT. 0.13 ) THEN

            FAC1 = ALPHV + 0.6 * ALPHV2

            BETA_EXT = MAX( BETA_EXT,
     &                 ( BETA_EXT  * FAC1 + ( 1.0 - FAC1 ) * PENN1 ) )

            BETA_SCAT = MAX( BETA_SCAT,
     &                 ( BETA_SCAT * FAC1 + ( 1.0 - FAC1 ) * PENN2 ) )

         END IF ! test for   XALPHA < 0.13
        
! small highly absorbing  particles such as a Tyndall scatterers such as
! described in Jacobson (1999) in Fundmentals of Atmospheric Modeling. This
! is approximately consistent with Penndorf (1962).

         BETA_SCAT = MAX( 0.001 * BETA_EXT, BETA_SCAT )
          
      END IF  ! test for 0.0  < NI
C *** Calculate large sphere limits(Irvine, 1965)

      MM1 = EXP( 0.5 * XLNSIG2 ) / ALPHV

C FSB large sphere limit - scattering

      LARGESCAT = THREE_PI_TWO * ( 8.652439E-1 + 1.501772E-1 * NR ) * MM1

C FSB large spnere limit for extinction ( no edge effectss )

      LARGEEXT = THREE_PI_TWO * ( 2.0 * MM1 )

C FSB Adjust for large sphere limits

      IF ( ALPHV .GE. 10.0 ) THEN

         BETA_EXT  = MAX( BETA_EXT, LARGEEXT )

         BETA_SCAT = MAX( BETA_SCAT, LARGESCAT )

      END IF ! test for 10.0 < ALPHV

C***FSB now calculate the asymmetry factor
C***  using the Hanna-Mathur quasi-empirical method
!     GMAX = 0.0

!     QSCAT_AVG = BETA_SCAT
!     QANGLE = AA0

!     IF ( QSCAT_AVG .GT. 1.0E-4 ) THEN
!        QQ  = QSCAT_AVG * QSCAT_AVG
!        QF1 = AA0 + AA1 * QSCAT_AVG
!        QF2 = AA2 + AA3 * QSCAT_AVG
!        QF3 = AA4 * QSCAT_AVG * QSCAT_AVG
!        QANGLE = QF1 + QF2 * QQ + QF3 * QQ
!     END IF

!     QANGLE = DEGTORAD * QANGLE
!     G      = COS( QANGLE)     ! asymmetry factor

C***FSB now calculate the asymmetry factor
C***   using a parametric fit to Mie calculations

      X_ALPHA2 = X_ALPHA * X_ALPHA
      X_ALPHA3 = X_ALPHA * X_ALPHA * X_ALPHA

      SMALL_G = 0.0
      LARGE_G = 0.0

      IF ( ALPHV .LT. 2.6 ) THEN

C FSB Calculate SMALL_G for sigma_g = 2.0

         QF1 = XXA0 + XXA1 * ALPHV
         QF2 = XXA2 * ALPHV2
         QF3 = XXA3 * ALPHV3
         SMALL_G = QF1 + QF2 + QF3 ! valid at sigma_g = 2.0

C FSB adjust SMALL_G for values less than 2.0
C     The smallest sigma_g allowed is 1.05

         QQF1 = CXG0 + CXG1 * ALPHV
         QQF2 = CXG2 * ALPHV2
         QQF3 = CXG3 * ALPHV3
         QQSUM = QQF1 + QQF2 + QQF3
         FAC1 = 1.052632 * ( 2.0 - SIGMA_G)
         QQSUM = MAX( 0.0, QQSUM )
         QQCORR =   ( 1.0 - FAC1 ) + FAC1 * QQSUM
         SMALL_G = SMALL_G * QQCORR
         G = SMALL_G

      ELSE IF ( ALPHV .LT. 100.0 ) THEN

         QF1 =  YYA0 + YYA1 * X_ALPHA
         QF2 = YYA2 * X_ALPHA2
         QF3 = YYA3 * X_ALPHA3
         LARGE_G = QF1 + QF2 + QF3
         G = LARGE_G

      ELSE

C     Very large sphere limit from fit to Irvine (1965).

         G = 1.124484 - 1.153869E-1 * NR

      END IF
C Simple and gross fix if appromation exceed realistic bounds
      G = MAX( -0.9999, MIN( G, 0.9999))
      RETURN
      END SUBROUTINE FAST_OPTICS

      END MODULE AERO_PHOTDATA

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
      MODULE BUDGET_DEFN

      USE PA_DEFN               ! Process Anaylsis control and data variables
      USE GRID_CONF             ! horizontal & vertical domain configuration
      USE RUNTIME_VARS
      USE UTILIO_DEFN           ! inherits PARUTILIO
      USE CGRID_SPCS, ONLY : CGRID_MASK_GAS, CGRID_MASK_AERO,
     &    CGRID_MASK_NUM, CGRID_MASK_SRF, CGRID_MASK_NR, CGRID_MASK_TRAC,
     &    CGRID_MW, N_CGRID_SPC, CGRID_NAME, NSPCSD, RHOJ_LOC
      USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_SPC, DIFF_MW,
     &                       DIFF_MASK_AERO, DIFF_MASK_NUM, DIFF_MASK_SRF
      USE CENTRALIZED_IO_MODULE
      USE XY_BUDGET


#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE, SE_DATA_COPY_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE, NOOP_DATA_COPY_MODULE)
#endif
#endif

      INTEGER, PARAMETER      :: BDGC0_ID = -1
      INTEGER, PARAMETER      :: BDGSAVE_ID = 0

      PUBLIC BUDGET_INIT, STORE_BUDGET, STORE_BUDGET_DDEP, 
     &       WRITE_BUDGET, BDGC0_ID, BUDGETVARIABLES, MAX_BUDGET_VARS_NML


      INTEGER, SAVE         :: BDG_UNIT
      INTEGER, PARAMETER      :: BDGCF_ID = -2

      REAL, ALLOCATABLE, SAVE :: BDG_PROC( :,: )
      REAL, ALLOCATABLE, SAVE :: BDG_BURDEN( :,: )

      INTEGER, SAVE :: BDG_JDATE0, BDG_JTIME0
      INTEGER, SAVE :: BDG_JDATE1, BDG_JTIME1
 
      CHARACTER( 16 ),ALLOCATABLE, SAVE :: BDGSPEC( : )
      INTEGER, ALLOCATABLE, SAVE :: MAP_toCGRID( : )
      INTEGER, ALLOCATABLE, SAVE :: MAP_toBDG( : )

      INTEGER, SAVE :: N_BDG_VAR, N_BDG_PAIRS

      !CHARACTER( 9 )  :: tab
      CHARACTER( 1 ), SAVE  :: tab = ','

      CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE BUDGET_INIT( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function: Initialize the budget variables and output file
 
C Preconditions: None
 
C Key Subroutines/Functions Called: None
 
C-----------------------------------------------------------------------
      USE UTIL_FAMILY_MODULE
#ifdef mpas
      use util_module, only : junit, index1, nextime
#endif
 
      IMPLICIT NONE 

      REAL, POINTER :: CGRID(:,:,:,:)
      INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP(3)


      ! Local Variables:
      REAL, ALLOCATABLE :: CONC( :,:,:,: )
      CHARACTER( 90 ) :: CMAQ_HEADER( 200 )
      CHARACTER( 90 ) :: CMAQ_TOC ( 200 )
      INTEGER         :: NCMAQ_HEAD,NCMAQ_TOC
      CHARACTER( 400 ):: XMSG, BDG_FILE
      CHARACTER( 50 ) :: FM
      INTEGER         :: ASTAT
      INTEGER         :: I, J
      LOGICAL, SAVE   :: FIRST_TIME = .TRUE.
      INTEGER         :: SDATE, STIME

      CHARACTER( 16 ) :: BDGSPEC_TMP( 500 ), BDGVAR
      INTEGER :: MAP_toCGRID_TMP( 1000 )
      INTEGER :: MAP_toBDG_TMP( 1000 )
      INTEGER :: N_BDG_REG
      LOGICAL :: EXPAND_SPEC
      LOGICAL, ALLOCATABLE :: CGRID_VEC( : )

!-----------------------------------------------------------------------

      IF ( FIRST_TIME ) THEN
          FIRST_TIME = .FALSE.

          ! Initialize Variables
          ALLOCATE( CONC( NCOLS,NROWS,NLAYS,N_CGRID_SPC ),
     &              CGRID_VEC( N_CGRID_SPC ), STAT=ASTAT )
          CONC = CGRID
          
          ALLOCATE( BDG_PROC( N_CGRID_SPC,NPRCS ),
     &              BDG_BURDEN( N_CGRID_SPC,3),
     &              F_WEST_IN( NLAYS,N_CGRID_SPC ),
     &              F_WEST_OUT( NLAYS,N_CGRID_SPC ),
     &              F_EAST_IN( NLAYS,N_CGRID_SPC ),
     &              F_EAST_OUT( NLAYS,N_CGRID_SPC ),
     &              F_SOUTH_IN( NLAYS,N_CGRID_SPC ),
     &              F_SOUTH_OUT( NLAYS,N_CGRID_SPC ),
     &              F_NORTH_IN( NLAYS,N_CGRID_SPC ),
     &              F_NORTH_OUT( NLAYS,N_CGRID_SPC ),
     &              CSAV( NCOLS,NROWS,NLAYS,N_CGRID_SPC ),
     &              STAT=ASTAT )
          BDG_PROC    = 0.0
          BDG_JDATE0  = JDATE
          BDG_JTIME0  = JTIME
          F_WEST_IN   = 0.0
          F_WEST_OUT  = 0.0
          F_EAST_IN   = 0.0
          F_EAST_OUT  = 0.0
          F_SOUTH_IN  = 0.0
          F_SOUTH_OUT = 0.0
          F_NORTH_IN  = 0.0
          F_NORTH_OUT = 0.0
          CSAV        = CGRID
          

          SDATE = JDATE
          STIME = JTIME
          CALL NEXTIME ( SDATE, STIME, TSTEP( 2 ) )
          CALL STORE_BUDGET( BDGC0_ID, CONC, JDATE, JTIME, .FALSE. )
          DEALLOCATE( CONC )
          
          ! Open Output tab-separated file and print header
          IF ( MYPE .EQ. 0 ) THEN
              IF ( BUDGET_FNAME .EQ. 'CCTM_BUDGET' ) THEN
                 IF ( OUTDIR .EQ. '' ) THEN
                   BDG_FILE = "CCTM_BUDGET_" // TRIM(APPL_NAME) // ".txt"
                 ELSE
                   BDG_FILE = TRIM(OUTDIR) // "/CCTM_BUDGET_" // TRIM(APPL_NAME) // ".txt"
                 END IF
              ELSE
                 J = INDEX( BUDGET_FNAME, ".txt" ) 
                 IF ( J .NE. 0 ) THEN
                    BDG_FILE = BUDGET_FNAME(1:J+3)
                 ELSE
                    BDG_FILE = TRIM( BUDGET_FNAME ) // ".txt"
                 END IF
              END IF
              BDG_UNIT = JUNIT()
              OPEN( UNIT = BDG_UNIT, FILE = BDG_FILE, STATUS = "REPLACE" )
          
              ! Write CMAQ Header
              CALL LOAD_HEADER( CMAQ_HEADER, NCMAQ_HEAD, CMAQ_TOC, NCMAQ_TOC )
              WRITE( BDG_UNIT, '(A)' ), CMAQ_HEADER( 1:NCMAQ_HEAD )
              WRITE( BDG_UNIT, '(A1)' ),'#'
          
              ! Write Execution ID and GridName
              WRITE( BDG_UNIT, '(A1,6x,A,A)' ),'#',"EXEC_ID: ",TRIM(EXECUTION_ID)
              WRITE( BDG_UNIT, '(A1,6x,A,A)' ),'#',"GRIDNAME: ",TRIM(GRID_NAME)
              WRITE( BDG_UNIT, '(A1)' ),'#'
          
              WRITE( BDG_UNIT, '(A1,6x,A,A)' ),'#','All date-times are in ',
     &             'YYYY-mm-ddTHH:MM:SSZ format and in UTC time zone.'
              WRITE( BDG_UNIT, '(A1,6x,A)' ),'#','Delta T (time) Units are hours.' 
              WRITE( BDG_UNIT, '(A1,6x,A)' ),'#','Gas and Aerosol Mass Units are kg'
              WRITE( BDG_UNIT, '(A1,6x,A)' ),'#','Aerosol Number Units are total N'
              WRITE( BDG_UNIT, '(A1,6x,A)' ),'#','Aerosol Surface Area Units are m2'
              WRITE( BDG_UNIT, '(A1)' ),'#'
          
              ! Write Header
              WRITE( BDG_UNIT, '(55(A))' ), 'SPECIES',tab,'T_START',tab,
     &         'T_FINAL',tab,'T_DELTA',tab,'M_START',tab,'M_FINAL',tab,
     &         'M_DELTA',tab,'WEST_IN',tab,'WEST_OUT',tab,'EAST_IN',tab,
     &         'EAST_OUT',tab,'SOUTH_IN',tab,'SOUTH_OUT',tab,'NORTH_IN',tab,
     &         'NORTH_OUT', 
     &         ( tab, TRIM(PROCNAME(i)),i=3,NPRCS),tab,'RESID'
          
          END IF
          
          ! Map Budget Variables to CGRID Species
          N_BDG_REG = INDEX1( '', MAX_BUDGET_VARS_NML, BudgetVariables ) - 1
          IF ( N_BDG_REG .LE. 0 ) THEN
             WRITE( LOGDEV, * )
             WRITE( XMSG, '(A,A)' ),
     &           'No Budget Variables have been selected. All Variables',
     &           'will be output to the budget file.'
             CALL LOG_MESSAGE( LOGDEV, XMSG )     
             N_BDG_REG = 1
             BudgetVariables( 1 ) = '*ALL'
          END IF

          ! Now Error Check and Expand the CMAQ Species Field
          N_BDG_VAR   = 0
          N_BDG_PAIRS = 0
          DO I = 1,N_BDG_REG
             BDGVAR = BudgetVariables( I )
             Expand_Spec = .FALSE.
             IF ( BDGVAR(1:1) .EQ. '*' ) THEN
                Expand_Spec = .TRUE.
                BDGVAR(1:15) = BDGVAR(2:16)
             END IF
             IF ( TRIM(BDGVAR) .EQ. 'ALL' ) THEN
                Expand_Spec = .TRUE.
             END IF

             ! Retrieve logical vector, DIFF_VEC, indicating diffused species
             ! relevant for DiagSpec(I)
             CALL MAP_CHEM_FAMILIES( BDGVAR, CGRID_NAME, N_CGRID_SPC, CGRID_VEC )
         
             ! Save Map to translate each pair to diffused species and
             ! diagnostic species
             IF ( EXPAND_SPEC ) THEN 
                ! Add a Diagnostic Species for every expanded species
                DO J = 1,N_CGRID_SPC
                   IF ( CGRID_VEC( J ) ) THEN
                       N_BDG_VAR = N_BDG_VAR + 1
                       BDGSPEC_TMP( N_BDG_VAR ) = CGRID_NAME( J )
         
                       N_BDG_PAIRS = N_BDG_PAIRS + 1
                       MAP_toCGRID_TMP( N_BDG_PAIRS ) = J
                       MAP_toBDG_TMP( N_BDG_PAIRS ) = N_BDG_VAR
                   END IF
                END DO
             ELSE
                ! Keep only 1 diagnostic species and map all of the diffused
                ! species to it
                IF ( ANY( CGRID_VEC ) ) THEN
                   N_BDG_VAR = N_BDG_VAR + 1
                   BDGSPEC_TMP( N_BDG_VAR ) = BDGVAR
                END IF
                DO J = 1,N_CGRID_SPC
                   IF ( CGRID_VEC( J ) ) THEN
                       N_BDG_PAIRS = N_BDG_PAIRS + 1
                       MAP_toCGRID_TMP( N_BDG_PAIRS ) = J
                       MAP_toBDG_TMP( N_BDG_PAIRS ) = N_BDG_VAR
                   END IF
                END DO
             END IF
          END DO

          ALLOCATE( MAP_toCGRID( N_BDG_PAIRS ),
     &              MAP_toBDG( N_BDG_PAIRS ),
     &              BDGSPEC( N_BDG_VAR ) )
          MAP_toCGRID = MAP_toCGRID_TMP( 1:N_BDG_PAIRS )
          MAP_toBDG   = MAP_toBDG_TMP( 1:N_BDG_PAIRS )
          BDGSPEC     = BDGSPEC_TMP( 1:N_BDG_VAR )

      END IF    

      RETURN
      END SUBROUTINE BUDGET_INIT

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!  Store Budget Data
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE STORE_BUDGET( IPR_ID, CONC, JDATE, JTIME, LCOUPLE )

      USE CENTRALIZED_IO_MODULE, ONLY : MSFX2
      USE CONST, ONLY : MWAIR

      IMPLICIT NONE

      REAL                  :: CONC( :,:,:,: )
      INTEGER, INTENT( IN ) :: IPR_ID            ! Process ID
      INTEGER, INTENT( IN ) :: JDATE, JTIME
      LOGICAL, INTENT( IN ) :: LCOUPLE           ! Flag for whther or not to use 
                                                 ! rhoj from the CGRID array for 
                                                 ! the density calculation for gases

      REAL, ALLOCATABLE, SAVE :: BDG_MASS( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: BDG_MASS_SAVE( :,:,:,: )
      REAL, PARAMETER :: MWAIR_SI = MWAIR / 1.0E+03 ! kg mol-1
      REAL, ALLOCATABLE, SAVE :: DENS( :,:,: )   ! air density (kg m-3)
      REAL, ALLOCATABLE, SAVE :: RHOJ( :,:,: )   ! air density * Jacobian (kg m-3)
      REAL, ALLOCATABLE, SAVE :: JACOBM( :,:,: ) ! Jacobian
      REAL, ALLOCATABLE, SAVE :: ZF( :,:,: )     ! height of layer top
      REAL, ALLOCATABLE, SAVE :: CELLVOL( :,:,: )! cell volume
      REAL                    :: AERO_NORM
      
      LOGICAL :: FIRST_TIME = .TRUE.
      INTEGER ASTAT
      INTEGER L, I, LAYS, R, C

      ! First time through, allocate Budget Concentration conversion
      ! array
      IF ( FIRST_TIME ) THEN
          FIRST_TIME = .FALSE.
          ALLOCATE ( BDG_MASS( NCOLS,NROWS,NLAYS,N_CGRID_SPC ),
     &               BDG_MASS_SAVE( NCOLS,NROWS,NLAYS,N_CGRID_SPC ),
     &                DENS( NCOLS,NROWS,NLAYS ),
     &                RHOJ( NCOLS,NROWS,NLAYS ),
     &                JACOBM( NCOLS,NROWS,NLAYS ),
     &                ZF( NCOLS,NROWS,NLAYS ),
     &                CELLVOL( NCOLS,NROWS,NLAYS ),
     &                STAT = ASTAT )
      END IF

      ! Retrieve Cell Variables for converting concentrations to burden
#ifdef mpas
      CELLVOL( :,1,: ) = cell_vol(:,1,:)
#else
      call interpolate_var ('ZF', jdate, jtime, ZF) ! height of layer top
      CELLVOL( :,:,1 ) = REAL( XCELL_GD * YCELL_GD, 4 ) * ZF( :,:,1 ) / MSFX2(:,:)
      DO L = 2,NLAYS
         CELLVOL( :,:,L ) = REAL( XCELL_GD * YCELL_GD,4) / MSFX2( :,: ) * 
     &                        ( ZF( :,:,L ) - ZF( :,:,L-1) )  ! m3
      END DO
#endif

      ! Calculate Density for Conversion of Gases from ppm to kg. If 
      IF ( LCOUPLE ) THEN
          ! If LCOUPLE is true, then the gases are already in mol mol-1 kg m-2, 
          ! which are the units of ppm * [air density] * [Jacobian]. In 
          ! general, the Jacobian usedin CMAQ includes the map scale 
          ! factor squared: JACOBM = J / msfx2
          ! Aerosols are in units of ug m-2
#ifdef mpas
          JACOBM = 1.0
#else
          call interpolate_var ('JACOBM', jdate, jtime, JACOBM) ! Jacobian
#endif
          DENS = 1.0 / MWAIR_SI * 1.0E-6 * 1.0E-3 ! mol kg-1 air
          CELLVOL = CELLVOL / JACOBM ! m2
          AERO_NORM = 1.0
      ELSE
          ! If LCOUPLE is false, then gases are in ppm and aerosols in 
          ! ug m-3.
          call interpolate_var ('DENS', jdate, jtime, DENS) ! kg m-3
          DENS  = DENS / MWAIR_SI * 1.0E-6 * 1.0E-3 ! umol m-3 air
          AERO_NORM = 1.0E-9
      END IF

      ! Convert Process Units to kg (mass), N (number), and m2 (surface
      ! area). Input gases are in ppm, aerosols in ug m-3, number in N
      ! m-3 and surface area in m2 m-3.
      LAYS = NLAYS
      IF ( IPR_ID .EQ. IPR_DDEP ) LAYS = 1

      DO I = 1,N_CGRID_SPC
         ! Gas - convert ppm to kg
         IF ( ( CGRID_MASK_GAS( I ) .OR.
     &          CGRID_MASK_NR( I )  .OR.
     &          CGRID_MASK_TRAC( I ) ) .AND.
     &          I .NE. RHOJ_LOC ) THEN
            DO L = 1,LAYS
            DO R = 1,NROWS
            DO C = 1,NCOLS
               BDG_MASS(C,R,L,I) = CONC(C,R,L,I) * DENS(C,R,L) 
     &                             * CGRID_MW(I) * CELLVOL(C,R,L)
            END DO
            END DO
            END DO
         END IF

         ! Aerosol Mass:  ug m-3 -> kg
         IF ( CGRID_MASK_AERO( I ) .AND.
     &        .NOT. CGRID_MASK_NUM( I ) .AND.
     &        .NOT. CGRID_MASK_SRF( I )  ) THEN
            DO L = 1,LAYS
            DO R = 1,NROWS
            DO C = 1,NCOLS
               BDG_MASS(C,R,L,I) = CONC(C,R,L,I) * AERO_NORM
     &                             * CELLVOL(C,R,L) 
            END DO
            END DO
            END DO
         END IF

         ! Aerosol Number: N m-3 -> N 
         ! Aerosol Surface Area: m2 m-3 -> m2 
         IF ( CGRID_MASK_NUM( I ) ) THEN
            DO L = 1,LAYS
               BDG_MASS(:,:,L,I) = CONC(:,:,L,I) * CELLVOL(:,:,L) 
            END DO
         END IF
         IF ( CGRID_MASK_SRF( I ) ) THEN
            DO L = 1,LAYS
               BDG_MASS(:,:,L,I) = CONC(:,:,L,I) * CELLVOL(:,:,L) 
            END DO
         END IF
      
      END DO

      ! Sum and Store Process Change 
      IF ( IPR_ID .EQ. BDGC0_ID ) THEN
          BDG_BURDEN( :,1 ) = SUM( SUM( SUM( BDG_MASS(:,:,:,:),1 ),1 ),1 ) 
          BDG_MASS_SAVE = BDG_MASS
      ELSE IF ( IPR_ID .EQ. BDGCF_ID ) THEN
          BDG_BURDEN( :,2 ) = SUM( SUM( SUM( BDG_MASS(:,:,:,:),1 ),1 ),1 ) 
      ELSE IF ( IPR_ID .EQ. IPR_DDEP ) THEN
          BDG_PROC( :,IPR_ID ) = BDG_PROC( :,IPR_ID ) + SUM( SUM( BDG_MASS(:,:,1,:),1 ),1 )
      ELSE IF ( IPR_ID .EQ. IPR_EMIS .OR. IPR_ID .EQ. IPR_XADV .OR. 
     &          IPR_ID .EQ. IPR_YADV .OR. IPR_ID .EQ. IPR_COAG .OR.
     &          IPR_ID .EQ. IPR_COND .OR. IPR_ID .EQ. IPR_NPF  .OR.
     &          IPR_ID .EQ. IPR_GROW ) THEN
          BDG_PROC( :,IPR_ID ) = BDG_PROC( :,IPR_ID ) 
     &                          +SUM( SUM( SUM( BDG_MASS(:,:,:,:),1 ),1 ),1 )
      ELSE IF ( IPR_ID .EQ. BDGSAVE_ID ) THEN
          ! Just Save the Burden
          BDG_MASS_SAVE = BDG_MASS
      ELSE
          BDG_PROC( :,IPR_ID ) = BDG_PROC( :,IPR_ID ) 
     &       + SUM( SUM( SUM( BDG_MASS - BDG_MASS_SAVE,1 ),1 ),1 )
          BDG_MASS_SAVE = BDG_MASS
      END IF

      RETURN
      END SUBROUTINE STORE_BUDGET
 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write Budget Output to CSV File
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE WRITE_BUDGET( CONC, JDATE, JTIME, TSTEP )

#ifdef mpas
      use util_module, only : daymon
#endif

      IMPLICIT NONE

      INTEGER I, J
      INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP(3)
      REAL                  :: CONC( :,:,:,: )
      REAL,ALLOCATABLE,SAVE :: RESID( : ), RESID_F(:)
      LOGICAL, SAVE :: FIRST_TIME = .TRUE.

      REAL DT
      INTEGER DTHR, DTMIN, DTSEC
      INTEGER BDG_YEAR0, BDG_MONTH0, BDG_DAY0, BDG_YYYYMMDD0
      INTEGER BDG_YEAR1, BDG_MONTH1, BDG_DAY1, BDG_YYYYMMDD1
      INTEGER BDG_HOUR0, BDG_MIN0, BDG_SEC0
      INTEGER BDG_HOUR1, BDG_MIN1, BDG_SEC1
      CHARACTER(20) :: BDG_TIME0, BDG_TIME1

      REAL, ALLOCATABLE, SAVE :: BDG_BURDEN_OUT(:,:), BDG_PROC_OUT(:,:),
     &                           ADV_FLUXES_OUT(:,:), ADV_FLUXES(:,:)
      REAL :: TMP, TMP2

      IF ( FIRST_TIME ) THEN
          FIRST_TIME = .FALSE.
          ALLOCATE ( RESID( N_CGRID_SPC ), RESID_F( N_BDG_VAR ),
     &               BDG_BURDEN_OUT( N_BDG_VAR,3 ),
     &               BDG_PROC_OUT( N_BDG_VAR,NPRCS ),
     &               ADV_FLUXES( N_CGRID_SPC,8 ), 
     &               ADV_FLUXES_OUT( N_BDG_VAR,8 ) )
      END IF


      CALL STORE_BUDGET( BDGCF_ID, CONC, JDATE, JTIME, .FALSE. )
      CSAV = CONC

      ! Correct VDIFF by subtracting emissions and dry deposition
      BDG_PROC( :,IPR_VDIF ) = BDG_PROC( :,IPR_VDIF ) - BDG_PROC( :,IPR_EMIS ) - BDG_PROC( :,IPR_DDEP )
      
      ! Calculate total mass change across output time step
      BDG_BURDEN( :,3 ) = BDG_BURDEN( :,2 ) - BDG_BURDEN( :,1 )

      ! Convert units for vapor ADV_FLUXES from 10^-6 mol to kg
      ! Units for aerosol mass should already be kg
      ! Units for aerosol number and surface area should already be N and m2
      ADV_FLUXES( :,1 ) =  SUM( F_WEST_IN, 1 )
      ADV_FLUXES( :,2 ) = -1.0 * SUM( F_WEST_OUT, 1 )
      ADV_FLUXES( :,3 ) =  SUM( F_EAST_IN, 1 )
      ADV_FLUXES( :,4 ) = -1.0 * SUM( F_EAST_OUT, 1 )
      ADV_FLUXES( :,5 ) =  SUM( F_SOUTH_IN, 1 )
      ADV_FLUXES( :,6 ) = -1.0 * SUM( F_SOUTH_OUT, 1 )
      ADV_FLUXES( :,7 ) =  SUM( F_NORTH_IN, 1 )
      ADV_FLUXES( :,8 ) = -1.0 * SUM( F_NORTH_OUT, 1 )
      DO I = 1,N_CGRID_SPC
         IF ( .NOT.CGRID_MASK_AERO( I ) ) 
     &      ADV_FLUXES( I,: ) = ADV_FLUXES( I,: ) * 1.0E-9 * CGRID_MW( I ) 
      END DO

      ! Calculate Date, Time, and Length of Time Interval
      BDG_JDATE1 = JDATE
      BDG_JTIME1 = JTIME
      DTHR = TSTEP(1)/10000
      DTMIN = ( TSTEP(1) - DTHR*10000 ) / 100
      DTSEC = TSTEP(1) - DTHR*10000 - DTMIN*100
      DT = REAL( DTHR,4) + REAL( DTMIN,4 )/60.0 + REAL( DTSEC,4 )/3600.0
      
      ! Format Beginning and Ending Date-Times
      IF ( MYPE .EQ. 0 ) THEN
        BDG_YEAR0 = BDG_JDATE0 / 1000
        BDG_YEAR1 = BDG_JDATE1 / 1000
        CALL DAYMON( BDG_JDATE0, BDG_MONTH0, BDG_DAY0 )
        CALL DAYMON( BDG_JDATE1, BDG_MONTH1, BDG_DAY1 )
        BDG_YYYYMMDD0 = BDG_YEAR0*10000 + BDG_MONTH0*100 + BDG_DAY0
        BDG_YYYYMMDD1 = BDG_YEAR1*10000 + BDG_MONTH1*100 + BDG_DAY1
        BDG_HOUR0 = BDG_JTIME0 / 10000
        BDG_HOUR1 = BDG_JTIME1 / 10000
        BDG_MIN0  = ( BDG_JTIME0 - BDG_HOUR0*10000 ) / 100
        BDG_MIN1  = ( BDG_JTIME1 - BDG_HOUR1*10000 ) / 100
        BDG_SEC0  =   BDG_JTIME0 - BDG_HOUR0*10000 - BDG_MIN0*100
        BDG_SEC1  =   BDG_JTIME1 - BDG_HOUR1*10000 - BDG_MIN1*100
      
        WRITE( BDG_TIME0, '(I4,A1,I2.2,A1,I2.2,A1,I2.2,A1,I2.2,A1,I2.2,A1)' ), 
     &         BDG_YEAR0,'-',BDG_MONTH0,'-',BDG_DAY0,'T',BDG_HOUR0,':',
     &         BDG_MIN0,':',BDG_SEC0,'Z'
        WRITE( BDG_TIME1, '(I4,A1,I2.2,A1,I2.2,A1,I2.2,A1,I2.2,A1,I2.2,A1)' ), 
     &         BDG_YEAR1,'-',BDG_MONTH1,'-',BDG_DAY1,'T',BDG_HOUR1,':',
     &         BDG_MIN1,':',BDG_SEC1,'Z'
      END IF
      
      ! Map CGRID Species to Budget Output Species
      BDG_PROC_OUT = 0.0
      BDG_BURDEN_OUT = 0.0
      ADV_FLUXES_OUT = 0.0
      DO I = 1,N_BDG_PAIRS
          BDG_PROC_OUT( MAP_toBDG( I ),: ) = BDG_PROC_OUT( MAP_toBDG( I ),: ) 
     &             + BDG_PROC( MAP_toCGRID( I ),: )
          BDG_BURDEN_OUT( MAP_toBDG( I ),: ) = BDG_BURDEN_OUT( MAP_toBDG( I ),: ) 
     &             + BDG_BURDEN( MAP_toCGRID( I ),: )
          ADV_FLUXES_OUT( MAP_toBDG( I ),: ) = ADV_FLUXES_OUT( MAP_toBDG( I ),: ) 
     &             + ADV_FLUXES( MAP_toCGRID( I ),: )
      END DO

#ifndef mpas
#ifdef parallel
      ! Sum Changes Across All Processors
      DO J = 1,3
         DO I = 1,N_BDG_VAR
           BDG_BURDEN_OUT(I,J) = SUBST_GLOBAL_SUM( BDG_BURDEN_OUT(I,J) )
         END DO 
      END DO
      DO J = 1,NPRCS
         DO I = 1,N_BDG_VAR
           BDG_PROC_OUT(I,J) = SUBST_GLOBAL_SUM( BDG_PROC_OUT(I,J) )
         END DO
      END DO
      DO J = 1,8
         DO I = 1,N_BDG_VAR
           ADV_FLUXES_OUT(I,J) = SUBST_GLOBAL_SUM( ADV_FLUXES_OUT(I,J) )
         END DO
      END DO
#endif
#endif

      IF ( MYPE .EQ. 0 ) THEN
         ! Positive Residual means sum of processes is greater 
         ! than net change in mass
      !   RESID_F(:) = SUM( BDG_PROC_OUT(:,1:NPRCS),2 ) 
      !&               - BDG_BURDEN_OUT( :,3 ) 
         RESID_F(:) = SUM( BDG_PROC_OUT(:,3:NPRCS),2 ) + SUM( ADV_FLUXES_OUT,2)
     &               - BDG_BURDEN_OUT( :,3 )  ! Use Adv Fluxes instead of total XADV and YADV

         ! Write Species Process Changes to tab-separated file
         DO I = 1,N_BDG_VAR
            ! Default
            WRITE( BDG_UNIT,'(3(A,A),F7.3,A,24(E15.8,A) )' ),TRIM(BDGSPEC(I)),tab, 
     &         BDG_TIME0,tab,BDG_TIME1,tab, DT,tab, (BDG_BURDEN_OUT(I,J),tab,J=1,3 ),
     &         ( ADV_FLUXES_OUT(I,J),tab,J=1,8 ),
     &         ( BDG_PROC_OUT(I,J),tab,J=3,NPRCS ), RESID_F(I)

            ! Debugging
!            WRITE( BDG_UNIT,'(3(A,A),F7.3,A,21(E11.4,A) )' ),TRIM(BDGSPEC(I)),tab, 
!     &         BDG_TIME0,tab,BDG_TIME1,tab, DT,tab, (BDG_BURDEN_OUT(I,J),tab,J=1,3 ),
!     &         SUM( ADV_FLUXES_OUT(I,1:4)),tab, SUM( ADV_FLUXES_OUT(I,5:8)),tab,
!     &         ( BDG_PROC_OUT(I,J),tab,J=1,NPRCS ), RESID_F(I), tab, RESID(I)
         END DO
      END IF

      ! Assign Initial Concentration
      ! and zero Out all Rates, etc
      BDG_PROC = 0.0
      BDG_BURDEN( :,1 ) = BDG_BURDEN( :,2 )
      BDG_BURDEN( :,2 ) = 0
      BDG_BURDEN( :,3 ) = 0

      BDG_JDATE0 = BDG_JDATE1
      BDG_JTIME0 = BDG_JTIME1

      F_WEST_IN = 0
      F_WEST_OUT = 0
      F_EAST_IN = 0
      F_EAST_OUT = 0
      F_SOUTH_IN = 0
      F_SOUTH_OUT = 0
      F_NORTH_IN = 0
      F_NORTH_OUT = 0

      RETURN

      END SUBROUTINE WRITE_BUDGET
 
      END MODULE BUDGET_DEFN

!--------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE VDIFFACMX ( DTSEC, SEDDY, DDEP, TOT_BD_EMIS, DDEPJ, CNGRD )

C-----------------------------------------------------------------------
C Asymmetric Convective Model v2 (ACM2/ACM1) -- Pleim(2006/2014)
C Function:
C   calculates vertical diffusion

C Subroutines and Functions Called:
C   SEC2TIME, TIME2SEC, WRITE3, NEXTIME,
C   M3EXIT, EDDYX, TRI, MATRIX, PA_UPDATE_EMIS, PA_UPDATE_DDEP

C Revision History:
C   Analogous to VDIFFACM2
C 11 Apr 13 J.Young: fix double adjustment of conc for DDBF in heterogeneous HONO
C           if-then-else clauses; eliminate some white space
C 13 May 13 J.Young: access met data from VDIFF_MET module
C                    change CRANKP to THBAR, CRANKQ to THETA
C 25 May 13 J.Young: re-do the acm/eddy algorithm for computational efficiency
C 30 Apr 14 J.Young: switch THBAR and THETA
C  2 May 14 J.Pleim, J.Young: replace the banded tridiagonal matrix solver for the
C           convective PBL, with the ACM1 matrix solver followed by the tridiagonal
C           matrix solver
C   30 May 14 J.Young: split vdiff calculation out of vdiff proc.
C   07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C   10 Feb 19 D.Wong: removed all MY_N clauses
C-----------------------------------------------------------------------

      USE CGRID_SPCS          ! CGRID mechanism species
      USE GRID_CONF
      USE DESID_VARS, ONLY : VDEMIS_DIFF, DESID_LAYS
      USE DESID_PARAM_MODULE, ONLY : DESID_N_SRM
      USE DEPV_DEFN
      USE ASX_DATA_MOD
      USE VDIFF_MAP
      USE UTILIO_DEFN
      USE BIDI_MOD
      USE MOSAIC_MOD, ONLY: Tile_Data
      USE VDIFF_DIAG, NLPCR => NLPCR_MEAN
      USE HGRD_DEFN,only : COLSX_PE, ROWSX_PE
      USE BDSNP_MOD, ONLY: GET_N_DEP
      USE ELMO_DATA, ONLY : L_ELMO

#ifdef isam
      USE SA_DEFN, ONLY: N_SPCTAG, ISAM, VNAM_SPCTAG, TRANSPORT_SPC,
     &                   SA_VDEMIS_DIFF, ITAG, NTAG_SA, NSPC_SA,
     &                   S_SPCTAG, T_SPCTAG, SA_DDEP, OTHRTAG, ISAM_SPEC,
     &                   L_NO3, SA_BIDI, BIDITAG, L_NH4
#endif

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID  ! file name parameters

      CHARACTER( 120 ) :: XMSG = ' '

C Arguments:
      REAL, INTENT( IN )    :: DTSEC                ! model time step in seconds
C--- SEDDY is strictly an input, but it gets modified here
      REAL, INTENT( INOUT ) :: SEDDY       ( :,:,: )   ! flipped EDDYV
      REAL, INTENT( INOUT ) :: DDEP        ( :,:,: )   ! ddep accumulator
      REAL, INTENT( INOUT ) :: TOT_BD_EMIS ( :,:,: )   ! bidi emissions accumlator 
      REAL, INTENT( INOUT ), OPTIONAL :: DDEPJ    ( :,:,:,: ) ! ddep for mosaic
      REAL, INTENT( INOUT ) :: CNGRD       ( :,:,:,: ) ! cgrid replacement

C Parameters:

C explicit, THETA = 0, implicit, THETA = 1     ! Crank-Nicholson: THETA = 0.5
      REAL, PARAMETER :: THETA = 0.5,
     &                   THBAR = 1.0 - THETA

      REAL, PARAMETER :: EPS = 1.0E-06

C External Functions: None

C Local Variables:

      CHARACTER( 16 ), SAVE :: PNAME = 'VDIFFACMX'

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL, SAVE :: SPECLOG = .TRUE.             ! For BDSNP

      REAL, ALLOCATABLE, SAVE :: DD_FAC     ( : )   ! combined subexpression
      REAL, ALLOCATABLE, SAVE :: DD_FACJ    ( :,: ) ! combined subexpression for mosaic
      REAL, ALLOCATABLE, SAVE :: DDBF       ( : )   ! secondary DDEP
      REAL, ALLOCATABLE, SAVE :: DDBFJ      ( :,: ) ! secondary DDEP for mosaic
      REAl, ALLOCATABLE, SAVE :: TMP_BD_EMIS( : )   ! intermediate bidi emissions
      REAL, ALLOCATABLE, SAVE :: CONC       ( :,: ) ! secondary CGRID expression
      REAL, ALLOCATABLE, SAVE :: EMIS       ( :,: ) ! emissions subexpression
      REAL        DTDENS1                       ! DT * layer 1 air density

C ACM Local Variables
      REAL     :: EDDY  ( NLAYS )               ! local converted eddyv
      REAL        MEDDY                         ! ACM2 intermediate var
      REAL        MBAR                          ! ACM2 mixing rate (S-1)
      REAL     :: MBARKS( NLAYS )               ! by layer
      REAL     :: MDWN  ( NLAYS )               ! ACM down mix rate
      REAL     :: MFAC  ( NLAYS )               ! intermediate loop factor
      REAL     :: AA    ( NLAYS )               ! matrix column one
      REAL     :: BB1   ( NLAYS )               ! diagonal for MATRIX1
      REAL     :: BB2   ( NLAYS )               ! diagonal for TRI
      REAL     :: CC    ( NLAYS )               ! subdiagonal
      REAL     :: EE1   ( NLAYS )               ! superdiagonal for MATRIX1
      REAL     :: EE2   ( NLAYS )               ! superdiagonal for TRI
      REAL, ALLOCATABLE, SAVE :: DD ( :,: )     ! R.H.S
      REAL, ALLOCATABLE, SAVE :: UU ( :,: )     ! returned solution
      REAL        DFACP, DFACQ
      REAL     :: DFSP( NLAYS ), DFSQ( NLAYS )  ! intermediate loop factors
      REAL        DELC, DELP, RP, RQ
      REAL     :: LFAC1( NLAYS )                ! intermediate factor for CONVT
      REAL     :: LFAC2( NLAYS )                ! intermediate factor for CONVT
      REAL     :: LFAC3( NLAYS )                ! intermediate factor for eddy
      REAL     :: LFAC4( NLAYS )                ! intermediate factor for eddy
      REAL, ALLOCATABLE, SAVE :: DEPVCR     ( : )   ! dep vel in one cell
      REAL, ALLOCATABLE, SAVE :: DEPVJCR    ( :,: ) ! dep vel in one cell for each landuse
      REAL, ALLOCATABLE, SAVE :: EFAC1 ( : )
      REAL, ALLOCATABLE, SAVE :: EFAC2 ( : )
      REAL, ALLOCATABLE, SAVE :: EMIS_OVER_VD( : ) ! Bidi Emissions/DEPV (ppm)
      REAL        PLDV_HONO                        ! PLDV for HONO
      REAL        DEPV_NO2                         ! dep vel of NO2
      REAL        DEPV_HNO3                        ! dep vel of HNO3
      REAL        FNL                              ! ACM2 Variable
      INTEGER     NLP, NL, LCBL
      INTEGER, SAVE :: NO2_HIT, HONO_HIT, HNO3_HIT, NO2_MAP, HNO3_MAP
      INTEGER, SAVE :: NH3_HIT, HG_HIT
      REAL        DTLIM, DTS, DTACM, RZ

      INTEGER     ASTAT
      INTEGER     C, R, L, S, V, I, J           ! loop induction variables
      INTEGER     MDATE, MTIME                  ! internal simulation date&time
!--Local Arrays for Z-coord implimentation
      REAL     :: DZH   ( NLAYS )               ! ZF(L) - ZF(L-1)
      REAL     :: DZHI  ( NLAYS )               ! 1/DZH
      REAL     :: DZFI  ( NLAYS )               ! ZH(L+1) - ZH(L)
      integer  gl_c, gl_r

      LOGICAL, SAVE :: XMOSAIC = .FALSE.

#ifdef isam
      REAL :: TOTAL_SA_NO2
      REAL, ALLOCATABLE, SAVE :: SA_DDBF( : )
      INTEGER IBGN, JSPCTAG

      REAL, ALLOCATABLE,SAVE :: SAEMIS( :,: )
      REAL, ALLOCATABLE,SAVE :: SACONC( :,: )
      REAL, ALLOCATABLE,SAVE :: SA_DD( :,: )
      REAL, ALLOCATABLE,SAVE :: SA_UU( :,: )

      REAL, ALLOCATABLE,SAVE :: SAFRAC( : )
      REAL, ALLOCATABLE,SAVE :: SA_NO2( : )      
      REAL, ALLOCATABLE,SAVE :: SA_SUM( : )

      INTEGER, SAVE              :: ISAM_INDEX_NO2 = 0   ! ...Index locating NO2 in ISAM
      INTEGER, SAVE              :: ISAM_INDEX_NH3 = 0   ! ...Index locating NH3 in ISAM
      INTEGER, SAVE              :: PLDV_INDEX_NH3 = 0   ! ...Index locating NH3 in PLDV

      INTEGER, ALLOCATABLE, SAVE :: ISAM_DEPV( : )
      INTEGER, ALLOCATABLE, SAVE :: INDEX_SA_HONO( : )
      INTEGER, ALLOCATABLE, SAVE :: INDEX_SA_NH3( : )

      CHARACTER( 16 ) :: ISAM_SPECIES

      INTEGER TOP, BOT
#endif      

      INTERFACE
         SUBROUTINE MATRIX1 ( KL, A, B, E, D, X )
            INTEGER,        INTENT( IN )  :: KL
            REAL,           INTENT( IN )  :: A( : ), B( : ), E( : )
            REAL,           INTENT( IN )  :: D( :,: )
            REAL,           INTENT( OUT ) :: X( :,: )
         END SUBROUTINE MATRIX1
         SUBROUTINE TRI ( L, D, U, B, X )
            REAL,           INTENT( IN )  :: L( : ), D( : ), U( : )
            REAL,           INTENT( IN )  :: B( :,: )
            REAL,           INTENT( OUT ) :: X( :,: )
         END SUBROUTINE TRI
#ifdef isam
         SUBROUTINE SA_MATRIX1 ( KL, A, B, E, D, X )
            INTEGER,        INTENT( IN )  :: KL
            REAL,           INTENT( IN )  :: A( : ), B( : ), E(: )
            REAL,           INTENT( IN )  :: D( :,: )
            REAL,           INTENT( OUT ) :: X( :,: )
         END SUBROUTINE SA_MATRIX1

         SUBROUTINE SA_TRI ( L, D, U, B, X )
            REAL,           INTENT( IN )  :: L( : ), D( : ), U( : )
            REAL,           INTENT( IN )  :: B( :,: )
            REAL,           INTENT( OUT ) :: X( :,: )
         END SUBROUTINE SA_TRI
#endif
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

         MDATE = 0; MTIME = 0

C set auxiliary depv arrays

         ALLOCATE ( DD_FAC    ( N_SPC_DEPV  ),
     &              DDBF      ( N_SPC_DEPV ),
     &              DEPVCR    ( N_SPC_DEPV ),
     &              EFAC1     ( N_SPC_DEPV ),
     &              EFAC2     ( N_SPC_DEPV ),
     &              EMIS_OVER_VD ( N_SPC_DEPV ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DD_FAC, DDBF, DEPVCR, EFAC1, EFAC2, or EMIS_OVER_VDs'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF

         IF ( PRESENT ( DDEPJ ) ) XMOSAIC = .TRUE.

         IF ( XMOSAIC ) THEN
            ALLOCATE ( DD_FACJ( Tile_Data%N_LUFRAC,N_SPC_DEPV ),
     &                 DDBFJ  ( Tile_Data%N_LUFRAC,N_SPC_DEPV ),
     &                 DEPVJCR( Tile_Data%N_LUFRAC,N_SPC_DEPV ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DD_FACJ, DDBFJ or DEPVJCR'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
         END IF   ! if Mosaic

         ALLOCATE ( TMP_BD_EMIS( N_BD_EMIS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating TMP_BD_EMIS'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( CONC( N_SPC_DIFF,NLAYS ),
     &              EMIS( N_SPC_DIFF,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CONC or EMIS'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         CONC = 0.0; EMIS = 0.0   ! array assignment

         ALLOCATE ( DD( N_SPC_DIFF,NLAYS ),
     &              UU( N_SPC_DIFF,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DD or UU'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         DD = 0.0; UU = 0.0   ! array assignment

         HONO_HIT = 0; HNO3_HIT = 0; NO2_HIT  = 0; NH3_HIT = 0
                       HNO3_MAP = 0; NO2_MAP  = 0
         DO V = 1, N_SPC_DEPV
            IF ( DV2DF_SPC( V ) .EQ. 'NO2' ) THEN
               NO2_HIT = V
               NO2_MAP = DV2DF( V )
            ELSE IF ( DV2DF_SPC( V ) .EQ. 'HONO' ) THEN
               HONO_HIT = V
            ELSE IF ( DV2DF_SPC( V ) .EQ. 'HNO3' ) THEN
               HNO3_HIT = V
               HNO3_MAP = DV2DF( V )
            ELSE IF ( DV2DF_SPC( V ) .EQ. 'NH3' ) THEN
               NH3_HIT = V
            ELSE IF ( DV2DF_SPC( V ) .EQ. 'HG' ) THEN
               HG_HIT = V
            END IF
         END DO

#ifdef isam
         ALLOCATE (  SA_DDBF( N_SPCTAG ), 
     &               SACONC( N_SPCTAG, NLAYS ),
     &               SAEMIS( N_SPCTAG, NLAYS ), 
     &               SA_DD ( N_SPCTAG, NLAYS ),
     &               SA_UU ( N_SPCTAG, NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure ISAM diffusion variables'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         ALLOCATE (  SAFRAC ( N_SPCTAG ),
     &               SA_SUM ( NSPC_SA ),
     &               ISAM_DEPV( N_SPCTAG ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure ISAM depv variables'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         
         ALLOCATE ( SA_NO2( NTAG_SA ),
     &              INDEX_SA_HONO( NTAG_SA ), 
     &              INDEX_SA_NH3 ( NTAG_SA ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure ISAM HONO/NH3 variables'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         
         SACONC = 0.0
         SAEMIS = 0.0
         SA_DD  = 0.0
         SA_UU  = 0.0

         SAFRAC        = 0.0
         ISAM_DEPV     = 0
         SA_NO2        = 1.0 / REAL( NTAG_SA )
         INDEX_SA_HONO = 0
         INDEX_SA_NH3  = 0

! set default partitioning of surface fluxes
         DO JSPCTAG = 1, N_SPCTAG
            IF ( T_SPCTAG( JSPCTAG ) .EQ. OTHRTAG ) THEN
               SAFRAC( JSPCTAG ) = 1.0
            ELSE
               SAFRAC( JSPCTAG ) = 0.0
            END IF
         END DO

! find NO2 in tracked species
         DO S = 1, NSPC_SA
            IF( ISAM_SPEC( S,1 ) .EQ. 'NO2' )THEN
                ISAM_INDEX_NO2 = S
                EXIT
            END IF            
         END DO
! find NH3 in tracked species
         IF ( SA_BIDI ) THEN
           DO S = 1, NSPC_SA
              IF( ISAM_SPEC( S,1 ) .EQ. 'NH3' )THEN
                  ISAM_INDEX_NH3 = S
                  EXIT
              END IF
           END DO
           S = -1
           S = INDEX1( 'NH3', N_SPC_DEPV, DEPV_SPC )
           IF ( S .GT. 0 ) THEN
             PLDV_INDEX_NH3 = S
           ELSE
             XMSG = 'NH3 not found in DEPV_SPC array'
             CALL M3EXIT( 'PLDV_INDEX_NH3', 0, 0, XMSG, XSTAT1 )
           END IF
         END IF

! set indices determining depv treatment, equals zero if none
         ITAG = 0
         WRITE(LOGDEV,'(/,A7,1X,2(A16,1X))')'JSPCTAG','ISAM_SPECIES','DEPV Value'
         DO JSPCTAG = 1, N_SPCTAG
            ISAM_SPECIES = ISAM_SPEC( S_SPCTAG( JSPCTAG ),1 )
            IF( TRIM( ISAM_SPECIES ) .EQ. 'HONO' )THEN
               ITAG = ITAG + 1
               INDEX_SA_HONO( ITAG ) = JSPCTAG
            END IF
            DO V = 1, N_SPC_DEPV
               IF ( TRIM( ISAM_SPECIES ) .EQ. DV2DF_SPC( V ) ) THEN
                    ISAM_DEPV( JSPCTAG ) = V
               END IF  
            END DO
            IF ( ISAM_DEPV( JSPCTAG ) .GT. 0 ) THEN
               V = ISAM_DEPV( JSPCTAG )
               WRITE(LOGDEV,'(I4,4X,2(A16,1X))')JSPCTAG,ISAM_SPECIES,DV2DF_SPC( V )
            ELSE
               WRITE(LOGDEV,'(I4,4X,2(A16,1X))')JSPCTAG,ISAM_SPECIES,'NONE'
            END IF   
        END DO       
        WRITE(LOGDEV,'(/,A4,1X,A13,1X,A16))')'ITAG','INDEX_SA_HONO','ISAM_SPECIES'
        DO ITAG = 1, NTAG_SA
           JSPCTAG = INDEX_SA_HONO( ITAG )
           IF ( JSPCTAG .GT. 0 ) THEN
              WRITE(LOGDEV,'(I2,3X,I4,8X,A16)')ITAG,JSPCTAG,VNAM_SPCTAG( JSPCTAG )
           ELSE
              WRITE(LOGDEV,'(I2,3X,I4,8X,A16)')ITAG,JSPCTAG,'MISSING'
           END IF   
        END DO
c       WRITE(LOGDEV,* )'TAG_species, Default Partitioning Coeff.'
c       DO JSPCTAG = 1, N_SPCTAG
c         WRITE(LOGDEV,*)VNAM_SPCTAG( JSPCTAG ),' ,',SAFRAC( JSPCTAG )
c       END DO          

        IF ( ABFLUX .AND. L_NH4 ) THEN
          ITAG = 0
          DO JSPCTAG = 1, N_SPCTAG
            ISAM_SPECIES = ISAM_SPEC( S_SPCTAG( JSPCTAG ),1 )
            IF( TRIM( ISAM_SPECIES ) .EQ. 'NH3' )THEN
               ITAG = ITAG + 1
               INDEX_SA_NH3( ITAG ) = JSPCTAG
            END IF
          END DO

c         DO ITAG = 1, NTAG_SA
c           JSPCTAG = INDEX_SA_NH3( ITAG )
c           SAFRAC( JSPCTAG ) = 0.0 ! to not double count the bi-di emmissions
c         END DO
        END IF
#endif
 
      END IF   !  if Firstime

C ------------------------------------------- Row, Col LOOPS -----------

      DO 345 R = 1, NROWS
      DO 344 C = 1, NCOLS
         DZH(1)  =  Met_Data%ZF( C,R,1 )
         DZHI(1) =  1./DZH(1)
         DO L = 2, NLAYS
            DZH(L)  =  Met_Data%ZF( C,R,L ) - Met_Data%ZF( C,R,L-1 ) 
            DZHI(L) =  1./DZH(L)
         ENDDO
         DO L = 1, NLAYS - 1
            DZFI(L) = 1. / ( Met_Data%ZH( C,R,L+1 ) - Met_Data%ZH( C,R,L ) )
         ENDDO
         DZFI(NLAYS) = DZFI(NLAYS-1)

C for ACM time step
         DTLIM = DTSEC

C dt = .75 dzf*dzh / Kz
         DO L = 1, NLAYS - 1
            DTLIM = MIN( DTLIM, 0.75 / ( SEDDY( L,C,R ) * DZHI(L)*DZFI(L) ) )
         END DO
         MBARKS = 0.0   ! array assignment
         MDWN = 0.0     ! array assignment

C conjoin ACM & EDDY ---------------------------------------------------

         MBAR = 0.0
         FNL = 0.0

         IF ( Met_Data%CONVCT( C,R ) ) THEN   ! Do ACM for this column
            LCBL = Met_Data%LPBL( C,R )
            MEDDY = SEDDY( 1,C,R ) * DZFI(1) / (Met_Data%PBL( C,R ) - Met_Data%ZF(C,R,1))
            FNL = 1.0 / ( 1.0 + ( ( KARMAN / ( -Met_Data%HOL( C,R ) ) ) ** 0.3333 )
     &                / ( 0.72 * KARMAN ) )
            MBAR = MEDDY * FNL
            IF ( MEDDY .LT. EPS ) THEN
               gl_c = c + COLSX_PE(1,mype+1) -1
               gl_r = r + ROWSX_PE(1,mype+1) -1
               WRITE( LOGDEV,* ) ' Warning --- MEDDY < 1e-6 s-1'
               WRITE( LOGDEV,* ) ' SEDDY, MEDDY, FNL, HOL = ',
     &                             SEDDY( 1,C,R ), MEDDY, FNL, Met_Data%HOL( C,R )
               XMSG = '*** ACM fails ***'
               WRITE( LOGDEV,*)' c,r=', gl_c,gl_r,' pbl,ust=',Met_Data%PBL( C,R ),Met_Data%USTAR( C,R )
!               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT2 )
            END IF

            IF ( ( FNL .LE. 0.0 ) .OR.            ! never gonna happen for CONVCT
     &           ( LCBL .GE. NLAYS-1 ) .OR.       ! .GT. never gonna happen
     &           ( Met_Data%HOL( C,R ) .GT. -0.00001 ) )   ! never gonna happen
     &         WRITE( LOGDEV,1015 ) LCBL, MBAR, FNL, SEDDY( 1,C,R ), Met_Data%HOL( C,R )
1015           FORMAT( ' LCBL, MBAR, FNL, SEDDY1, HOL:', I3, 1X, 4(1PE13.5) )

            DO L = 2, LCBL 
               SEDDY( L,C,R ) = ( 1.0 - FNL ) * SEDDY( L,C,R  )
               MBARKS( L ) = MBAR
               MDWN( L )   = MBAR * (Met_Data%PBL( C,R ) - Met_Data%ZF(C,R,L-1)) * DZHI(L)
            END DO
            SEDDY( 1,C,R ) = ( 1.0 - FNL ) * SEDDY( 1,C,R  )
            MBARKS(1) = MBAR
            MBARKS(LCBL) = MDWN(LCBL)
            MDWN(LCBL+1) = 0.0

C Modify Timestep for ACM            
            RZ     = (Met_Data%ZF(C,R,LCBL) - Met_Data%ZF(C,R,1)) * DZHI(1)
            DTACM  = 1.0 / ( MBAR * RZ )
            DTLIM  = MIN( 0.75 * DTACM, DTLIM )
         ELSE
            LCBL = 1
         END IF

C-----------------------------------------------------------------------

         NLP = INT( DTSEC / DTLIM + 0.99 )
         IF ( VDIFFDIAG ) NLPCR( C,R ) = REAL( NLP )
         DTS = DTSEC / REAL( NLP )
         DTDENS1 = DTS * Met_Data%DENS1( C,R )
         DFACP = THETA * DTS
         DFACQ = THBAR * DTS

#ifdef Verbose_Vdiff
        IF ( R .EQ. MY_NROWS / 2 .AND. C .EQ. MY_NCOLS / 2 )
     &      WRITE( LOGDEV,1021 ) Met_Data%CONVCT( C,R ), DTS, EDDYV( C,R,1 ), MBAR, FNL
1021  FORMAT( ' CONVCT, DTS, EDDYV, MBAR, FNL: ', L3, 1X, 4(1PE13.5) )
#endif

#ifdef isam
         SA_SUM = 0.0
         DO V = 1, NSPC_SA
            DO ITAG = 1, NTAG_SA
               SA_SUM( V ) = SA_SUM( V ) + ISAM( C,R,1,V,ITAG )
            END DO
            SA_SUM( V ) = MAX ( 1.0E-30, SA_SUM( V ) )
         END DO

         SAFRAC = 0.0
         DO JSPCTAG = 1, N_SPCTAG
            SAFRAC( JSPCTAG ) = SACONC( JSPCTAG,1 ) / SA_SUM ( S_SPCTAG( JSPCTAG )   ) 
         END DO

         IF ( ABFLUX .AND. L_NH4 ) THEN
            DO ITAG = 1, NTAG_SA
               JSPCTAG = INDEX_SA_NH3( ITAG )
               SAFRAC( JSPCTAG ) = 0.0 ! to not double count the bi-di emmissions
            END DO
         END IF

         IF( L_NO3 .AND. SFC_HONO ) THEN
! compute the flux partitioning for HONO from NO2 surface reaction
            DO ITAG = 1, NTAG_SA
               SA_NO2( ITAG ) = MAX( ISAM( C,R,1,ISAM_INDEX_NO2,ITAG ), 1.0E-30 )
            END DO
            TOTAL_SA_NO2 = 1.0 / SUM( SA_NO2 )
            DO ITAG = 1, NTAG_SA
               JSPCTAG = INDEX_SA_HONO( ITAG )
               SAFRAC( JSPCTAG ) = SA_NO2( ITAG ) * TOTAL_SA_NO2 
            END DO 
         END IF                
#endif

         DO L = 1, NLAYS
            DO V = 1, N_SPC_DIFF
               CONC( V,L ) = CNGRD( DIFF_MAP( V ),L,C,R )
            END DO
#ifdef isam
            DO JSPCTAG = 1, N_SPCTAG
               SACONC( JSPCTAG,L ) = ISAM( C,R,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) )
            END DO
#endif
         END DO

         EMIS = 0.0      ! array assignment
         IF ( DESID_N_SRM .GE. 1 ) 
     &        EMIS( :,1:DESID_LAYS ) = DTS * VDEMIS_DIFF( :,:,C,R )

#ifdef isam
         SAEMIS = 0.0

! modify ground emissions for bidirectional species (for bidi, BIDI_VDEMIS > 0.0)
         IF ( SA_BIDI ) THEN
           SA_VDEMIS_DIFF( ISAM_INDEX_NH3,1,C,R,BIDITAG )
     &             = Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( PLDV_INDEX_NH3 ) )
         END IF

! collapse ISAM emissions array
         DO L = 1, DESID_LAYS
            DO ITAG = 1, NTAG_SA
               BOT = (ITAG-1)*NSPC_SA+1
               TOP = NSPC_SA*ITAG
               SAEMIS( BOT:TOP,L ) = DTS * SA_VDEMIS_DIFF( :,L,C,R,ITAG )
            END DO
         END DO
#endif

         DO L = 1, NLAYS
            DFSP( L ) = DFACP * DZHI( L )
            DFSQ( L ) = DFACQ * DZHI( L )
            EDDY( L ) = SEDDY( L,C,R ) * DZFI(L)
         END DO

         RP        = DFACP * Met_Data%RDEPVHT( C,R )
         RQ        = DFACQ * Met_Data%RDEPVHT( C,R )
         EMIS_OVER_VD = 0.0
         DO V = 1, N_SPC_DEPV
            DDBF( V )   = DDEP( V,C,R )
            DEPVCR( V ) = Tile_Data%Vd_Fac( Tile_Data%dep2vdiff( V ) ) * 
     &                    Tile_Data%Grd_Vd( C,R,Tile_Data%dep2vdiff( V ) )
            DD_FAC( V ) = DTDENS1 * DD_CONV( V ) * DEPVCR( V )
            EFAC1 ( V ) = EXP( -DEPVCR( V ) * RP )
            EFAC2 ( V ) = EXP( -DEPVCR( V ) * RQ )
            If( Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( V ) ) .Gt. 0.0 ) Then
               If(DEPVCR( V ) .Eq. 0.0) Then
                  Write(Logdev,*) 'Warning: A deposition velocity of 0 m/s was detected with a production term greater' 
                  Write(Logdev,*) 'than zero. Check for DEPV_FACs less than zero in the species name list for model species:'
                  Write(Logdev,*) DV2DF_SPC( V ), 'depvcr', DEPVCR( V ), 'bidi emissions', 
     &                            Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( V ) )
                  DEPVCR( V ) = tiny( 0.0 )
               End If
               EMIS_OVER_VD( V ) = Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( V ) ) / DEPVCR( V )                        
            End If
            IF ( ABFLUX ) THEN
               TMP_BD_EMIS( NH3_E ) = TOT_BD_EMIS( NH3_E,C,R )
            END IF
            IF ( HGBIDI ) THEN
               TMP_BD_EMIS( HG_E ) = TOT_BD_EMIS( HG_E,C,R )
            END IF   
            IF ( SFC_HONO ) THEN         
               TMP_BD_EMIS( HONO_E ) = TOT_BD_EMIS( HONO_E,C,R )
            END IF                     
         END DO
         PLDV_HONO = Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( HONO_HIT ) )

#ifdef isam
         DO JSPCTAG = 1, N_SPCTAG
            SA_DDBF( JSPCTAG ) = SA_DDEP( C,R,JSPCTAG )
         END DO
#endif

C These don`t change in the NLP sub-time step loop:---------------------
         DO L = 1, NLAYS
            AA ( L ) = 0.0
            BB1( L ) = 0.0
            EE1( L ) = 0.0
            CC ( L ) = 0.0
            EE2( L ) = 0.0
            BB2( L ) = 0.0
         END DO
         IF ( Met_Data%CONVCT( C,R ) ) THEN
            L = 1
            DELP = Met_Data%PBL( C,R ) - Met_Data%ZF( C,R,L )
            BB1( L ) = 1.0 + DELP * DFSP( L ) * MBARKS( L )
            LFAC1( L ) = DFSQ( L ) * DELP * MBARKS( L )
            LFAC2( L ) = DFSQ( L ) * MDWN( L+1 ) * DZH( L+1 )
            DO L = 2, LCBL
               AA ( L ) = -DFACP * MBARKS( L )
               BB1( L ) = 1.0 + DFACP * MDWN( L )
               EE1( L ) = -DFSP( L-1 ) * DZH( L ) * MDWN( L )
               MFAC( L ) = DZH( L+1 ) * DZHI( L ) * MDWN( L+1 )
            END DO
         END IF

         DO L = 1, NLAYS
            EE2( L ) = - DFSP( L ) * EDDY( L )
            LFAC3( L ) = DFSQ( L ) * EDDY( L )
         END DO

         BB2( 1 ) = 1.0 - EE2( 1 )
         DO L = 2, NLAYS
            CC ( L ) = - DFSP( L ) * EDDY( L-1 )
            BB2( L ) = 1.0 - CC( L ) - EE2( L )
            LFAC4( L ) = DFSQ( L ) * EDDY( L-1 )
         END DO
C ----------------------------------------------------------------------

         IF ( XMOSAIC ) THEN
            DDBFJ( :,: )   = DDEPJ( :,:,C,R )           
            DO L = 1, Tile_Data%n_lufrac
               DEPVJCR( L,: ) = Tile_Data%Vd_Fac( Tile_Data%dep2vdiff ) * 
     &                          Tile_Data%Lu_Vd( C,R,Tile_Data%dep2vdiff,L )
               DD_FACJ( L,: ) = DTDENS1 * DD_CONV( : ) * DEPVJCR( L,: )
            END DO
         END IF

C-----------------------------------------------------------------------

         DO 301 NL = 1, NLP      ! loop over sub time

            DO V = 1, N_SPC_DEPV

C --------- HET HONO RX -----------------


C Use special treatment for HNO3
C HNO3 produced via the heterogeneous reaction sticks on surfaces and
C is accounted as depositional loss; calculate increased deposition loss
               IF ( V .EQ. HNO3_HIT ) THEN
                  S = HNO3_MAP
                  CONC( S,1 ) = EMIS_OVER_VD( V ) + ( CONC( S,1 ) - EMIS_OVER_VD( V ) ) * EFAC1( V )
                  DEPV_HNO3   = DEPVCR( V ) + PLDV_HONO / CONC( NO2_MAP,1 )
                  DD_FAC( V ) = DTDENS1 * DD_CONV( V ) * DEPV_HNO3
                  DDBF( V )   = DDBF( V ) + THETA * DD_FAC( V ) * CONC( S,1 )

C Use special treatment for NO2
C Loss of NO2 via the heterogeneous reaction is accounted for as an additional
C depositional loss. Add the loss of NO2 via the heterogeneous reaction
C to the regular deposition velocity (increased dep. vel.).  This will
C reduce the NO2 conc. in the atmosphere without affecting the depositional loss.
               ELSE IF ( V .EQ. NO2_HIT ) THEN
                  S              = NO2_MAP
                  DEPV_NO2       = DEPVCR( V ) + 2.0 * PLDV_HONO / CONC( S,1 )
                  EFAC1 ( V )    = EXP( -DEPV_NO2 * RP )
                  EFAC2 ( V )    = EXP( -DEPV_NO2 * RQ )
                  EMIS_OVER_VD( V ) = Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( V ) ) / DEPV_NO2
                  CONC( S,1 )    = EMIS_OVER_VD( V ) + ( CONC( S,1 ) - EMIS_OVER_VD( V ) ) * EFAC1( V )
                  DDBF( V )      = DDBF( V ) + THETA * DD_FAC( V ) * CONC( S,1 )
  
C --------- END of HET HONO RX ----------

               ELSE


C Pass selected N species to the BDSNP Soil NO emissions scheme

                  IF ( MGN_ONLN_DEP ) THEN

                    IF(SPECLOG) then
                      IF( V .eq. N_SPC_DEPV)  THEN
                       SPECLOG = .false. ! no need to do any species more than once
                       WRITE( LOGDEV,*) 'BDSNP Species list complete', speclog
                      END IF
                    END IF

                    IF ( (INDEX(TRIM( DV2DF_SPC( V ) ), 'NH3') .NE. 0) .OR.
     &                 (INDEX(TRIM( DV2DF_SPC( V ) ), 'NH4') .NE. 0) .OR.         
     &                 (INDEX(TRIM( DV2DF_SPC( V ) ), 'HNO3').NE. 0) .OR.
     &                 (INDEX(TRIM( DV2DF_SPC( V ) ), 'NO3') .NE. 0) .OR.
     &                 (INDEX(TRIM( DV2DF_SPC( V ) ), 'NO2') .NE. 0) .OR.
     &                 (INDEX(TRIM( DV2DF_SPC( V ) ), 'PAN') .NE. 0)) THEN


                      IF( SPECLOG ) THEN !write species each time it is used
                        WRITE( LOGDEV,*) 'BDSNP Dry Species Used:', TRIM(DV2DF_SPC( V ) ), V, N_SPC_DEPV
                      END IF

                      IF ( ( DDBF(V)- DDEP( V,C,R) ) .LT. 0.0 ) THEN !negative error checking

                       XMSG = 'Negative Deposition'
!                  WRITE( LOGDEV,*) 'BDSNP Negative Deposition vdiff, variable:', 
!     &            TRIM( DV2DF_SPC( V )), ( DDBF(V)- DDEP( V,C,R) ), C, R                  
!                      CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
                       CALL GET_N_DEP (DV2DF_SPC( V ), 0/
     &                           DTSEC, C, R )
                      else
                       CALL GET_N_DEP (DV2DF_SPC( V ), ( DDBF(V)- DDEP( V,C,R) )/
     &                           DTSEC, C, R )
                      END IF !end negative error checking

                     
                    END IF !end species check
                  
                  END IF !end BDSNP check

                  S = DV2DF( V )
                  CONC( S,1 ) = EMIS_OVER_VD( V ) + ( CONC( S,1 ) - EMIS_OVER_VD( V ) ) * EFAC1( V )
                  DDBF( V ) = DDBF( V ) + THETA * DD_FAC( V ) * CONC( S,1 )

                  IF ( ABFLUX .AND. V .EQ. NH3_HIT ) THEN
                     TMP_BD_EMIS( NH3_E ) = TMP_BD_EMIS( NH3_E ) + 
     &                  THETA * Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( V ) ) * DD_CONV( V ) * DTDENS1
                  END IF
                  IF ( HGBIDI .AND. V .EQ. HG_HIT ) THEN
                     TMP_BD_EMIS( HG_E ) = TMP_BD_EMIS( HG_E ) +  
     &                  THETA * Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( V ) ) * DD_CONV( V ) * DTDENS1                 
                  END IF
                  IF ( SFC_HONO .AND. V .EQ. HONO_HIT ) THEN
                     TMP_BD_EMIS( HONO_E ) = TMP_BD_EMIS( HONO_E ) +                    
     &                  THETA * Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( V ) ) * DD_CONV( V ) * DTDENS1                 
                  END IF
               END IF

            END DO
    
            IF ( XMOSAIC ) THEN
               DO V = 1, N_SPC_DEPV
C --------------- HET HONO RX -----------------
                  IF ( V .EQ. HNO3_HIT ) THEN
                     S = HNO3_MAP
                     WHERE( Tile_Data%LUFRAC( c,r,: ) .GT. 0.0 ) 
                        DD_FACJ( :,V ) = DTDENS1 * DD_CONV( V ) * DEPVJCR( :,V ) + PLDV_HONO / CONC( NO2_MAP,1 )
                        DDBFJ( :,V ) = DDBFJ( :,V ) + THETA * DD_FACJ( :,V ) * CONC( S,1 )
                     END WHERE
                  ELSE IF ( V .EQ. NO2_HIT ) THEN  
                     S = NO2_MAP
                     WHERE( Tile_Data%LUFRAC( c,r,: ) .GT. 0.0 .AND.  DEPVJCR( :,V ) .GT. 0.0 ) 
                        DDBFJ  ( :,V ) = DDBFJ( :,V ) + THETA * DD_FACJ( :,V ) * CONC( S,1 )
                     END WHERE
C --------------- END of HET HONO RX ----------
                  ELSE
                     S = DV2DF( V )
                     WHERE( Tile_Data%LUFRAC( c,r,: ) .GT. 0.0 ) 
                        DDBFJ( :,V ) = DDBFJ( :,V )
     &                               + THETA * DD_FACJ( :,V ) * CONC( S,1 )
                     END WHERE
                  END IF
               END DO
            END IF   ! MOSAIC

            DO L = 1, NLAYS
               DO V = 1, N_SPC_DIFF
                  DD( V,L ) = 0.0
                  UU( V,L ) = 0.0
               END DO
            END DO

#ifdef isam
            DO JSPCTAG = 1, N_SPCTAG
               S = ISAM_DEPV( JSPCTAG )
               IF ( S .GT. 0 ) THEN
                  SACONC( JSPCTAG,1 ) = SACONC( JSPCTAG,1 ) * EFAC1( S )
     &                                + SAFRAC( JSPCTAG ) * EMIS_OVER_VD( S ) * ( 1.0 -  EFAC1( S ) )               
                  SA_DDBF( JSPCTAG  ) = SA_DDBF( JSPCTAG )
     &                                + THETA * DD_FAC( S ) *  SACONC( JSPCTAG,1 )
               END IF
            END DO

            DO L = 1, NLAYS
               DO V = 1, N_SPCTAG
                 SA_DD( V,L ) = 0.0
                 SA_UU( V,L ) = 0.0
               END DO
            END DO
#endif

C Compute tendency of CBL concentrations - semi-implicit solution
C Set MATRIX1 elements A (col 1), B (diag.), E (superdiag.) and D (RHS)

            IF ( Met_Data%CONVCT( C,R ) ) THEN

               L = 1
               DO V = 1, N_SPC_DIFF
                  DD( V,L ) = CONC( V,L )
     &                      - LFAC1( L ) * CONC( V,L )
     &                      + LFAC2( L ) * CONC( V,L+1 ) 
               END DO

#ifdef isam
               DO JSPCTAG = 1, N_SPCTAG
                  SA_DD( JSPCTAG, L) = SACONC( JSPCTAG,L )
     &                      - LFAC1( L ) * SACONC( JSPCTAG,L )
     &                      + LFAC2( L ) * SACONC( JSPCTAG,L+1 )
               ENDDO
#endif

               DO L = 2, LCBL
                  DO V = 1, N_SPC_DIFF
                     DELC = MBARKS( L ) * CONC( V,1 )
     &                    -   MDWN( L ) * CONC( V,L )
     &                    +   MFAC( L ) * CONC( V,L+1 )
                     DD( V,L ) = CONC( V,L ) + DFACQ * DELC
                  END DO

#ifdef isam
                  DO JSPCTAG = 1, N_SPCTAG
                     DELC = MBARKS( L ) * SACONC( JSPCTAG,1 )
     &                     -   MDWN( L ) * SACONC( JSPCTAG,L )
     &                     +   MFAC( L ) * SACONC( JSPCTAG,L+1 )
                     SA_DD( JSPCTAG,L ) = SACONC( JSPCTAG,L ) + DFACQ  * DELC
                  END DO
#endif

               END DO

               CALL MATRIX1 ( LCBL, AA, BB1, EE1, DD, UU )
#ifdef isam 
               CALL SA_MATRIX1( LCBL, AA, BB1,EE1, SA_DD, SA_UU)
#endif

C update conc
               DO L = 1, LCBL
                  DO V = 1, N_SPC_DIFF
                     CONC( V,L ) = UU( V,L )
                  END DO
#ifdef isam
                  DO JSPCTAG = 1, N_SPCTAG
                     SACONC ( JSPCTAG,L ) = SA_UU( JSPCTAG,L )
                  ENDDO
#endif
               END DO

C reinitialize for TRI solver
               DO L = 1, NLAYS
                  DO V = 1, N_SPC_DIFF
                     DD( V,L ) = 0.0
                     UU( V,L ) = 0.0
                  END DO
#ifdef isam
                  DO JSPCTAG = 1, N_SPCTAG
                     SA_DD( JSPCTAG,L ) = 0.0
                     SA_UU( JSPCTAG,L ) = 0.0
                  ENDDO
#endif
               END DO

            END IF

            L = 1
            DO V = 1, N_SPC_DIFF
               DD( V,L ) = CONC( V,L )
     &                   + LFAC3( L ) * ( CONC( V,L+1 ) - CONC( V,L ) )
     &                   + EMIS( V,L )
            END DO

#ifdef isam
            DO JSPCTAG = 1, N_SPCTAG
               SA_DD( JSPCTAG,L ) = SACONC( JSPCTAG,L )
     &                   + LFAC3( L ) * ( SACONC( JSPCTAG,L+1 ) - SACONC( JSPCTAG,L ) )
     &                   + SAEMIS( JSPCTAG,L )
            END DO
#endif

            DO L = 2, NLAYS-1
               DO V = 1, N_SPC_DIFF
                  DD( V,L ) = CONC( V,L )
     &                      + LFAC3( L ) * ( CONC( V,L+1 ) - CONC( V,L ) )
     &                      - LFAC4( L ) * ( CONC( V,L ) - CONC( V,L-1 ) )
     &                      + EMIS( V,L )
               END DO
#ifdef isam
               DO JSPCTAG = 1, N_SPCTAG
                  SA_DD( JSPCTAG,L ) = SACONC( JSPCTAG,L )
     &                      + LFAC3( L ) * ( SACONC( JSPCTAG,L+1 ) - SACONC( JSPCTAG,L ) )
     &                      - LFAC4( L ) * ( SACONC( JSPCTAG,L ) - SACONC( JSPCTAG,L-1 ) )
     &                      + SAEMIS( JSPCTAG,L )
               END DO
#endif
            END DO

            L = NLAYS
            DO V = 1, N_SPC_DIFF
               DD( V,L ) = CONC( V,L )
     &                   - LFAC4( L ) * ( CONC( V,L ) - CONC( V,L-1 ) )
            END DO
#ifdef isam
            DO JSPCTAG = 1, N_SPCTAG
               SA_DD( JSPCTAG,L ) = SACONC( JSPCTAG,L )
     &                   - LFAC4( L ) * ( SACONC( JSPCTAG,L ) - SACONC( JSPCTAG,L-1 ) )
            END DO
#endif

            CALL TRI ( CC, BB2, EE2, DD, UU )
#ifdef isam
            CALL SA_TRI ( CC, BB2, EE2, SA_DD, SA_UU )
#endif

C Load into CGRID
            DO L = 1, NLAYS
               DO V = 1, N_SPC_DIFF
                  CONC( V,L ) = UU( V,L )
               END DO
#ifdef isam
               DO JSPCTAG = 1, N_SPCTAG
                  SACONC( JSPCTAG,L ) = SA_UU( JSPCTAG,L )
               END DO
#endif
            END DO
            
            DO V = 1, N_SPC_DEPV

C --------- HET HONO RX -----------------

               IF ( V .EQ. HNO3_HIT ) THEN
                  S = HNO3_MAP
                  CONC( S,1 ) = EMIS_OVER_VD( V ) + ( CONC( S,1 ) - EMIS_OVER_VD( V ) ) * EFAC2( V )
                  DDBF( V )   = DDBF( V ) + THBAR * DD_FAC( V ) * CONC( S,1 )

               ELSE IF ( V .EQ. NO2_HIT ) THEN
                  S = NO2_MAP
                  CONC( S,1 ) = EMIS_OVER_VD( V ) + ( CONC( S,1 ) - EMIS_OVER_VD( V ) ) * EFAC2( V )
                  DDBF( V )   = DDBF( V ) + THBAR * DD_FAC( V ) * CONC( S,1 )

C --------- END of HET HONO RX ----------

               ELSE
                  S = DV2DF( V )
                  CONC( S,1 ) = EMIS_OVER_VD( V ) + ( CONC( S,1 ) - EMIS_OVER_VD( V ) ) * EFAC2( V )
                  DDBF( V ) = DDBF( V ) + THBAR * DD_FAC( V ) * CONC( S,1 )
                  IF ( ABFLUX .AND. V .EQ. NH3_HIT ) THEN
                     TMP_BD_EMIS( NH3_E ) = TMP_BD_EMIS( NH3_E ) + 
     &                  THBAR * Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( V ) ) * DD_CONV( V ) * DTDENS1                                 
                  END IF
                  IF ( HGBIDI .AND. V .EQ. HG_HIT ) THEN
                     TMP_BD_EMIS( HG_E ) = TMP_BD_EMIS( HG_E ) + 
     &                  THBAR * Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( V ) ) * DD_CONV( V ) * DTDENS1                                 
                  END IF
                  IF ( SFC_HONO .AND. V .EQ. HONO_HIT ) THEN
                     TMP_BD_EMIS( HONO_E ) = TMP_BD_EMIS( HONO_E ) + 
     &                  THBAR * Tile_Data%Bidi_Emis( C, R, Tile_Data%dep2vdiff( V ) ) * DD_CONV( V ) * DTDENS1                                 
                  END IF

               END IF

            END DO
    
            IF ( XMOSAIC ) THEN
               DO V = 1, N_SPC_DEPV
C --------- HET HONO RX -----------------
                  IF ( V .EQ. HNO3_HIT ) THEN
                     S = HNO3_MAP
                     WHERE( Tile_Data%LUFRAC( c,r,: ) .GT. 0.0 )
                        DD_FACJ( :,V ) = DTDENS1 * DD_CONV( V ) * DEPVJCR( :,V ) + PLDV_HONO / CONC( NO2_MAP,1 )
                        DDBFJ( :,V ) = DDBFJ( :,V ) + THBAR * DD_FACJ( :,V ) * CONC( S,1 )
                     END WHERE
                  ELSE IF ( V .EQ. NO2_HIT ) THEN  
                     S = NO2_MAP
                     WHERE( Tile_Data%LUFRAC( c,r,: ) .GT. 0.0 .AND.  DEPVJCR( :,V ) .GT. 0.0 ) 
                        DDBFJ  ( :,V ) = DDBFJ( :,V ) + THETA * DD_FACJ( :,V ) * CONC( S,1 )
                     END WHERE
C --------- END of HET HONO RX ----------
                  ELSE
                     S = DV2DF( V )
                     WHERE( Tile_Data%LUFRAC( c,r,: ) .GT. 0.0 )
                        DDBFJ( :,V ) = DDBFJ( :,V ) + THBAR * DD_FACJ( :,V ) * CONC( S,1 )
                     END WHERE
                  END IF
               END DO
            END IF   ! MOSAIC
#ifdef isam
C Update ISAM Dry Deposition
            DO JSPCTAG = 1, N_SPCTAG
               S = ISAM_DEPV( JSPCTAG )
               IF ( S .GT. 0 ) THEN
                  SACONC( JSPCTAG,1 ) = SACONC( JSPCTAG,1 ) * EFAC2( S )
     &                                + SAFRAC( JSPCTAG ) * EMIS_OVER_VD( S ) * ( 1.0 -  EFAC2( S ) )               
                  SA_DDBF( JSPCTAG  ) = SA_DDBF( JSPCTAG )
     &                                + THBAR * DD_FAC( S ) *  SACONC( JSPCTAG,1 )
               END IF
            END DO
#endif

301      CONTINUE                 ! end sub time loop

         DO L = 1, NLAYS
            DO V = 1, N_SPC_DIFF
               CNGRD( DIFF_MAP( V ),L,C,R ) = CONC( V,L )
            END DO
#ifdef isam
            DO JSPCTAG = 1, N_SPCTAG
               IF( TRANSPORT_SPC( JSPCTAG ) )THEN
                  ISAM( C,R,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) = SACONC( JSPCTAG,L )
               END IF
            END DO
#endif
         END DO

         DO V = 1, N_SPC_DEPV
            DDEP( V,C,R ) = DDBF( V )
         END DO

         IF ( ABFLUX ) THEN
            TOT_BD_EMIS( NH3_E,C,R ) = TMP_BD_EMIS( NH3_E )
         END IF
         IF ( HGBIDI ) THEN
            TOT_BD_EMIS( HG_E,C,R ) = TMP_BD_EMIS( HG_E )
         END IF   
         IF ( SFC_HONO ) THEN         
            TOT_BD_EMIS( HONO_E,C,R ) = TMP_BD_EMIS( HONO_E )
         END IF                     
 
         IF ( XMOSAIC ) THEN
            DDEPJ( :,:,C,R ) = DDBFJ( :,: )
         END IF

#ifdef isam
         DO JSPCTAG = 1, N_SPCTAG
            SA_DDEP( C,R,JSPCTAG ) = SA_DDBF( JSPCTAG )
         END DO
#endif

344   CONTINUE         !  end loop on col C
345   CONTINUE         !  end loop on row R

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module Bidi_Mod

C Contains the shared variables and subroutines needed for the bidirectional 
C flux models in CMAQ
C
C OPASX_MEDIA - Opens the output file for NH4+ and H+ in the soil water solution
C               
C Revision History: J. Bash Mar 15 11: Created
C                   J. Bash May 11 11: Updated for CMAQ 5.0
C                   D. Wong Feb 01 19: removed all MY_N clauses

      Implicit None
! Private variables
      Integer, Parameter, Private :: NHx_AQ_CONC  = 4
      Integer, Parameter, Private :: NHx_GAS_CONC = 0      
      Integer, Parameter, Private :: NHx_SOL_CONC = 0     
      Integer, Parameter, Private :: NHx_TOT = NHx_AQ_CONC + NHx_GAS_CONC + NHx_SOL_CONC       
      Integer, Parameter, Private :: HG_AQ_CONC   = 3
      Integer, Parameter, Private :: HG_GAS_CONC  = 1      
      Integer, Parameter, Private :: HG_SOL_CONC  = 2           
      
      Integer, Save,   Private :: N_Hg
      Character( 96 ), Private :: XMSG = ' '
! shared variables
      Character( 16 ), Save , Allocatable :: MEDIA_NAMES( : )
      Character( 16 ), Save , Allocatable :: MEDIA_UNITS( : )
      Character( 80 ), Save , Allocatable :: MEDIA_DESCR( : )

      Integer, Parameter      :: HG_TOT = HG_AQ_CONC + HG_GAS_CONC + HG_SOL_CONC       
      Integer, Save           :: N_TOT
      Real, Save, Allocatable :: gamma1 ( :,: ) ! soil NH4/H
      Real, Save, Allocatable :: gamma2 ( :,: ) ! soil NH4/H
      Real, Save, Allocatable :: MHp1   ( :,: ) ! molar H+
      Real, Save, Allocatable :: MHp2   ( :,: ) ! molar H+  
      Real, Save, Allocatable :: CMEDIA ( :,:,: ) ! surface layer concs 

      Logical, Save     :: INIT_LAI   
      Logical, Save     :: INIT_COMP              


      Contains 
         Subroutine INIT_BIDI()
         Use GRID_CONF
         Use CGRID_SPCS          ! CGRID mechanism species
         Use UTILIO_DEFN
         Use RUNTIME_VARS
         
         Implicit None
         
C... Local:
 
         Character( 16 ) :: PNAME = 'INIT_BIDI       '
         Integer         :: STATUS
         Logical, SAVE   :: INITIALIZED = .FALSE.
         
C--------------------------------------------------------------------------
C Prevent initializing the code twice 
         If ( INITIALIZED ) Return 
         INITIALIZED = .TRUE.

         If ( ABFLUX .And. .Not. HGBIDI ) Then
         
            N_TOT = NHx_TOT
            N_Hg  = 0            
            Allocate( MEDIA_NAMES( N_TOT ), MEDIA_UNITS( N_TOT ), MEDIA_DESCR( N_TOT )  )

            MEDIA_NAMES( 1 ) = 'Gamma1          '
            MEDIA_UNITS( 1 ) = ' '
            MEDIA_DESCR( 1 ) = 'NH4+/H+ in Soil layer 1'
            MEDIA_NAMES( 2 ) = 'Gamma2          '
            MEDIA_UNITS( 2 ) = ' '
            MEDIA_DESCR( 2 ) = 'NH4+/H+ in Soil layer 2'
            MEDIA_NAMES( 3 ) = 'MHpsl1          '
            MEDIA_UNITS( 3 ) = 'mol/l'
            MEDIA_DESCR( 3 ) = 'Molar H+ in Soil layer 1'
            MEDIA_NAMES( 4 ) = 'MHpsl2          '
            MEDIA_UNITS( 4 ) = 'mol/l'
            MEDIA_DESCR( 4 ) = 'Molar H+ in Soil layer 2'
               
         Else If ( .Not. ABFLUX .And. HGBIDI ) Then
            N_TOT = HG_TOT
            N_Hg  = HG_TOT
            Allocate( MEDIA_NAMES( HG_TOT ), MEDIA_UNITS( N_TOT ), MEDIA_DESCR( N_TOT )  )

            MEDIA_NAMES( 1 ) = 'DGM             ' ! Dissolved gaseous Hg
            MEDIA_UNITS( 1 ) = 'umol mol-1' 
            MEDIA_DESCR( 1 ) = 'Surface water dissolved Hg(0)'
            MEDIA_NAMES( 2 ) = 'DRM             ' ! Dissolved reactive Hg
            MEDIA_UNITS( 2 ) = 'umol mol-1' 
            MEDIA_DESCR( 2 ) = 'Surface water dissolved Hg(II)'
            MEDIA_NAMES( 3 ) = 'HGSOIL          '
            MEDIA_UNITS( 3 ) = 'umol mol-1'      
            MEDIA_DESCR( 3 ) = 'Soil water dissolved Hg(0)'
            MEDIA_NAMES( 4 ) = 'HGZ0            '
            MEDIA_UNITS( 4 ) = 'ppmV'      
            MEDIA_DESCR( 4 ) = 'Hg(0) compensation point'
            MEDIA_NAMES( 5 ) = 'HGMES           ' ! mesophyll Hg
            MEDIA_UNITS( 5 ) = 'umol g-1'      
            MEDIA_DESCR( 5 ) = 'Hg(0) bound to leaf mesophyll'
            MEDIA_NAMES( 6 ) = 'HGCUT           ' ! cuticular Hg  
            MEDIA_UNITS( 6 ) = 'umol g-1'      
            MEDIA_DESCR( 6 ) = 'Hg(0) bound to vegetation surfaces'      
            
         Else If ( ABFLUX .And. HGBIDI ) Then
            N_TOT = HG_TOT + NHx_TOT
            N_Hg  = HG_TOT
            Allocate( MEDIA_NAMES( N_TOT ), MEDIA_UNITS( N_TOT ), MEDIA_DESCR( N_TOT )  )

            MEDIA_NAMES( 1 ) = 'DGM             ' ! Dissolved gaseous Hg
            MEDIA_UNITS( 1 ) = 'umol mol-1' 
            MEDIA_DESCR( 1 ) = 'Surface water dissolved Hg(0)'
            MEDIA_NAMES( 2 ) = 'DRM             ' ! Dissolved reactive Hg
            MEDIA_UNITS( 2 ) = 'umol mol-1' 
            MEDIA_DESCR( 2 ) = 'Surface water dissolved Hg(II)'
            MEDIA_NAMES( 3 ) = 'HGSOIL          '
            MEDIA_UNITS( 3 ) = 'umol mol-1'      
            MEDIA_DESCR( 3 ) = 'Soil water dissolved Hg(0)'
            MEDIA_NAMES( 4 ) = 'HGZ0            '
            MEDIA_UNITS( 4 ) = 'ppmV'      
            MEDIA_DESCR( 4 ) = 'Hg(0) compensation point'
            MEDIA_NAMES( 5 ) = 'HGMES           ' ! mesophyll Hg
            MEDIA_UNITS( 5 ) = 'umol g-1'      
            MEDIA_DESCR( 5 ) = 'Hg(0) bound to leaf mesophyll'
            MEDIA_NAMES( 6 ) = 'HGCUT           ' ! cuticular Hg  
            MEDIA_UNITS( 6 ) = 'umol g-1'      
            MEDIA_DESCR( 6 ) = 'Hg(0) bound to vegetation surfaces'   
            MEDIA_NAMES( 7 ) = 'Gamma1          ' 
            MEDIA_UNITS( 7 ) = '' 
            MEDIA_DESCR( 7 ) = 'NH4+/H+ in Soil layer 1'
            MEDIA_NAMES( 8 ) = 'Gamma2          '
            MEDIA_UNITS( 8 ) = '' 
            MEDIA_DESCR( 8 ) = 'NH4+/H+ in Soil layer 2'
            MEDIA_NAMES( 9 ) = 'MHpsl1'
            MEDIA_UNITS( 9 ) = 'mol L-1' 
            MEDIA_DESCR( 9 ) = 'Molar H+ in Soil layer 1'
            MEDIA_NAMES( 10 ) = 'MHpsl2         '
            MEDIA_UNITS( 10 ) = 'mol L-1' 
            MEDIA_DESCR( 10 ) = 'Molar H+ in Soil layer 2'
            
         End If
         
         ! allocate the media array variable
         If ( .Not. Allocated ( CMEDIA ) ) Then
            Allocate ( CMEDIA( NCOLS,NROWS,N_TOT ) )
            CMEDIA = 0.0
         End If         
         
         Return
         
         End Subroutine INIT_BIDI
!*****************************************************************************
!************** Iput / output section of the module **************************
!*****************************************************************************

         Subroutine OPASX_MEDIA( JDATE, JTIME, TSTEP )

         Use GRID_CONF
         Use CGRID_SPCS          ! CGRID mechanism species
         Use UTILIO_DEFN
         Use MIO_ASCII

         Implicit None

         Include SUBST_FILES_ID  ! file name parameters

         Integer,     Intent( In ) :: JDATE
         Integer,     Intent( In ) :: JTIME
         Integer,     Intent( In ) :: TSTEP

         Character( 16 ) :: PNAME = 'OPASX_MEDIA     '
         Character( 96 ) :: MSG = ' '

         Integer  N, V, L
         
C--------------------------------------------------------------------------
         
         If ( ABFLUX .And. .Not. HGBIDI) Then

            If ( .Not. OPEN3( MEDIA_CONC, FSRDWR3, PNAME ) ) Then

               XMSG = 'Could not open ' // MEDIA_CONC // ' file for update - '
     &             // 'try to open new'
               Call M3MESG( XMSG )

               FTYPE3D = GRDDED3
               SDATE3D = JDATE
               STIME3D = JTIME
               TSTEP3D = TSTEP
               Call NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

               NVARS3D = N_TOT
               NCOLS3D = GL_NCOLS
               NROWS3D = GL_NROWS
               NLAYS3D =     1
               NTHIK3D =     1
               GDTYP3D = GDTYP_GD
               P_ALP3D = P_ALP_GD
               P_BET3D = P_BET_GD
               P_GAM3D = P_GAM_GD
               XORIG3D = XORIG_GD
               YORIG3D = YORIG_GD
               XCENT3D = XCENT_GD
               YCENT3D = YCENT_GD
               XCELL3D = XCELL_GD
               YCELL3D = YCELL_GD
               VGTYP3D = VGTYP_GD
               VGTOP3D = VGTOP_GD
               Do L = 1, NLAYS3D + 1
                  VGLVS3D( L ) = VGLVS_GD( L )
               End Do
               GDNAM3D = GRID_NAME  ! from HGRD_DEFN

               FDESC3D = ' '   ! array

               FDESC3D( 1 ) = 'Multimedia concentration estimates from integrated ambient '
     &                     // 'NH3 concentrations and surface exchange algorithms'
                        
               N = 0

               Do V = 1, NHx_AQ_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'mol L-1'
                  VDESC3D( N ) = 'aqueous phase concentration'
               End Do

               N = NHx_AQ_CONC

               Do V = 1, NHx_GAS_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'ppmV'
                  VDESC3D( N ) = 'gas phase concentration'
               End Do

               N = NHx_AQ_CONC + NHx_GAS_CONC

               Do V = 1, NHx_SOL_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol g-1'
                  VDESC3D( N ) = 'Solid phase concentration'
               End Do              
            End If
            
         Else If ( .Not. ABFLUX .And. HGBIDI ) Then              
            
            If ( .Not. OPEN3( MEDIA_CONC, FSRDWR3, PNAME ) ) Then!

               XMSG = 'Could not open ' // MEDIA_CONC // ' file for update - '
     &             // 'try to open new'
               Call M3MESG( XMSG )

               FTYPE3D = GRDDED3
               SDATE3D = JDATE
               STIME3D = JTIME
               TSTEP3D = TSTEP
               Call NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour            
               NVARS3D = N_TOT
               NCOLS3D = GL_NCOLS
               NROWS3D = GL_NROWS
               NLAYS3D =     1
               NTHIK3D =     1
               GDTYP3D = GDTYP_GD
               P_ALP3D = P_ALP_GD
               P_BET3D = P_BET_GD
               P_GAM3D = P_GAM_GD
               XORIG3D = XORIG_GD
               YORIG3D = YORIG_GD
               XCENT3D = XCENT_GD
               YCENT3D = YCENT_GD
               XCELL3D = XCELL_GD
               YCELL3D = YCELL_GD
               VGTYP3D = VGTYP_GD
               VGTOP3D = VGTOP_GD

               FDESC3D = ' '   ! array

               FDESC3D( 1 ) = 'Multimedia concentration estimates from integrated ambient '
     &                     // 'HG concentrations and surface exchange algorithms'

               NLAYS3D = 1

               N = 0

               Do V = 1, HG_AQ_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol mol-1'
                  VDESC3D( N ) = 'aqueous phase concentration'
               End Do

               N = HG_AQ_CONC

               Do V = 1, HG_GAS_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'ppmV'
                  VDESC3D( N ) = 'gas phase concentration'
               End Do

               N = HG_AQ_CONC + HG_GAS_CONC

               Do V = 1, HG_SOL_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol g-1'
                  VDESC3D( N ) = 'Solid phase concentration'
               End Do
            End If
            
         Else If ( ABFLUX .And. HGBIDI ) Then         
            
            If ( .Not. OPEN3( MEDIA_CONC, FSRDWR3, PNAME ) ) Then

               XMSG = 'Could not open ' // MEDIA_CONC // ' file for update - '
     &             // 'try to open new'
               Call M3MESG( XMSG )

               FTYPE3D = GRDDED3
               SDATE3D = JDATE
               STIME3D = JTIME
               TSTEP3D = TSTEP
               Call NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour            
               NVARS3D = N_TOT
               NCOLS3D = GL_NCOLS
               NROWS3D = GL_NROWS
               NLAYS3D =     1
               NTHIK3D =     1
               GDTYP3D = GDTYP_GD
               P_ALP3D = P_ALP_GD
               P_BET3D = P_BET_GD
               P_GAM3D = P_GAM_GD
               XORIG3D = XORIG_GD
               YORIG3D = YORIG_GD
               XCENT3D = XCENT_GD
               YCENT3D = YCENT_GD
               XCELL3D = XCELL_GD
               YCELL3D = YCELL_GD
               VGTYP3D = VGTYP_GD
               VGTOP3D = VGTOP_GD

               FDESC3D = ' '   ! array

               FDESC3D( 1 ) = 'Multimedia concentration estimates from integrated ambient '
     &                     // 'NH3 and HG concentrations and surface exchange algorithms'

               NLAYS3D = 1

               N = 0

               Do V = 1, HG_AQ_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol mol-1'
                  VDESC3D( N ) = 'aqueous phase concentration'
               End Do

               N = HG_AQ_CONC

               Do V = 1, HG_GAS_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'ppmV'
                  VDESC3D( N ) = 'gas phase concentration'
               End Do

               N = HG_AQ_CONC + HG_GAS_CONC

               Do V = 1, HG_SOL_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol g-1'
                  VDESC3D( N ) = 'Solid phase concentration'
               End Do
               
               N = HG_TOT

               Do V = 1, NHx_AQ_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'mol L-1'
                  VDESC3D( N ) = 'aqueous phase concentration'
               End Do

               N = HG_TOT + NHx_AQ_CONC

               Do V = 1, NHx_GAS_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'ppmV'
                  VDESC3D( N ) = 'gas phase concentration'
               End Do

               N = HG_TOT + NHx_AQ_CONC + NHx_GAS_CONC

               Do V = 1, NHx_SOL_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol g-1'
                  VDESC3D( N ) = 'Solid phase concentration'
               End Do        
            End If
                                                  
         End If 

         ! Store MIO Metadata
         NDIMS3D( 1:NVARS3D ) = 3
         L_TSTEP( 1:NVARS3D ) = .True.
         L_LAY  ( 1:NVARS3D ) = .False.
         L_COL  ( 1:NVARS3D ) = .True.
         L_ROW  ( 1:NVARS3D ) = .True.
         L_VEXT ( 1:NVARS3D ) = .False.

         CALL LOAD_MIO_FILE ( 'MEDIA_CONC', 0, 0, 0,
     &        VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &        VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &        L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &        L_VEXT(1:NVARS3D) )
         
! Open file, then close it for subsequent open by all processors
            
         If ( .Not. OPEN3( MEDIA_CONC, FSNEW3, PNAME ) ) Then
            XMSG = 'Could not create '// TRIM( MEDIA_CONC) // ' file'
            Call M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         End If                   

         Return

         End Subroutine OPASX_MEDIA

!****************************************************************************

         Subroutine WRASX_MEDIA( MDATE, MTIME )

! Revision History.
!     Aug 12, 15 D. Wong: added code to handle parallel I/O implementation
!     Jan 16, 16 J. Young: update log file once per output; consistent tokens

         Use GRID_CONF           ! horizontal grid specifications
         Use UTILIO_DEFN

         Implicit None

         Include SUBST_FILES_ID  ! file name parameters

         Integer, Intent( In )    :: MDATE
         Integer, Intent( In )    :: MTIME

         Logical, Save :: FIRSTIME = .TRUE.

         Real          WRMC( NCols,NRows )         ! media write buffer
         Integer V, R, C

         Character( 16 ) :: PNAME = 'WRASX_MEDIA     '
         
!*****************************************************************************         
         
         If ( HGBIDI ) Then
            INIT_LAI  = .FALSE.   
            INIT_COMP = .FALSE.   
         End If
         
         If ( ABFLUX ) Then
            Do R = 1, NRows
               Do C = 1, NCols
                  CMedia( C,R,N_Hg+1 ) = Gamma1( C,R )
                  CMedia( C,R,N_Hg+2 ) = Gamma2( C,R )
                  CMedia( C,R,N_Hg+3 ) = MHp1( C,R )
                  CMedia( C,R,N_Hg+4 ) = MHp2( C,R )
               End Do
            End Do
         End If

#ifdef parallel_io
         If ( FIRSTIME ) Then
            FIRSTIME = .FALSE.
            If ( .Not. IO_PE_INCLUSIVE ) Then
               If ( .Not. OPEN3( MEDIA_CONC, FSREAD3, PNAME ) ) Then
                  XMSG = 'Could not open ' // TRIM( MEDIA_CONC )
                  Call M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               End If
            End If
         End If
#endif
         
         Do V = 1, N_TOT ! species/media loop
            Do R = 1, NRows ! row loop
               Do C = 1,NCols  ! column loop
                  WRMC( C, R ) = CMEDIA( C,R,V  )
               End Do
            End Do

            If ( .Not. WRITE3( MEDIA_CONC, MEDIA_NAMES( V ), MDATE, MTIME,
     &                WRMC ) ) Then
               XMSG = 'Could not write ' // MEDIA_CONC // ' file'
               Call M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            End If

         End Do                 

         Write( LOGDEV, '( /5X, A, I8, ":", I6.6 )' )
     &         'Timestep written to "' // TRIM( MEDIA_CONC ) //
     &         '" for date and time', MDATE, MTIME

         Return

         End Subroutine WRASX_MEDIA

      End Module Bidi_Mod   

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HVELOC ( JDATE, JTIME, TSTEP, UWIND, VWIND, HDIV )
      
C-----------------------------------------------------------------------
C Function:
C    This subroutine reads physical velocities in the x1 and x2 directions
C    and returns the contravariant velocities and the horizontal divergence
 
C Preconditions:
C    This routine can be used only for conformal map coordinates 
C    in the horizontal.
C    Dates and times should be represented YYYYDDD:HHMMSS.
 
C Subroutines and functions called:
C    INTERPX, INTERPB, M3EXIT, TIME2SEC, SEC2TIME, NEXTIME
      
C Revision history:
C   January 30, 1996 by Clint L. Ingram at NCSC: created for
C   RADM-coordinates

C   22 Apr 97 Jeff:
C    7 Aug 97 Jeff: for NTHIK = 1
C    4 Feb 98 Jeff: deal with end-of-scenario
C   20 Sep 98 David Wong: parallelized the code
C                         -- adjust the data declaration for DENSJ
C                         -- remove indirect index reference, and re-adapt to
C                            a general case
C                         -- invoke stencil exchange library
C   21 Nov 00 J.Young: PE_COMM3 -> Dave Wong's f90 stenex COMM
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX
C    6 Apr 01 J.Young: Eliminate NTHIN confusion (assumes NTHIK = 1)
C   12 Apr 01 J.Young: Use PINTERPB for boundary data
C   23 Jun 03 J.Young: for layer dependent advection tstep
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   15 Mar 10 J.Young: revert back to 3D arrays and calculate the horiz. div.
C                      (similar to the deform.F code)
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   28 Jul 11 David Wong: set REVERT to .false. for twoway model case since
C                         buffered file has only two time steps data
C   01 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE)
#endif
#endif
      USE CENTRALIZED_IO_MODULE, only : interpolate_var, window
!    &                              STRTCOLMC2,  ENDCOLMC2,  STRTROWMC2,  ENDROWMC2
      USE CONST, only: DG2M, PI180

      IMPLICIT NONE

C Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction
 
C Parameters
      
C Arguments:
      INTEGER, INTENT( IN )  :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )  :: JTIME        ! current model time, coded HHMMSS
      INTEGER, INTENT( IN )  :: TSTEP        ! time step (HHMMSS)
!     REAL         WIND( NCOLS+1,NROWS+1 ) ! CX xi-velocity 
      REAL,    INTENT( OUT ) :: UWIND( :,:,: )  ! CX xi-velocity 
      REAL,    INTENT( OUT ) :: VWIND( :,:,: )  ! CX yi-velocity 
      REAL,    INTENT( OUT ) :: HDIV ( :,:,: )  ! horizontal divergence
      
C file variables:
!     REAL      DENSJ_BUF( NCOLS,NROWS,NLAYS )     ! Jacobian * air density
!     REAL      DENSJ_BND( NBNDY,NLAYS )           ! bndy Jacobian * air density
!     REAL      DENSJ( 0:NCOLS+1,0:NROWS+1,NLAYS )
      REAL, ALLOCATABLE, SAVE :: DENSJ_BUF( :,:,: )  ! Jacobian * air density
      REAL, ALLOCATABLE, SAVE :: DENSJ_BND( :,: )    ! bndy Jacobian * air density
      REAL, ALLOCATABLE, SAVE :: DENSJ( :,:,: )      ! Jacobian * air density
 
C External Functions:

C local variables:
      
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
       
      INTEGER   MDATE             ! mid-advection date
      INTEGER   MTIME             ! mid-advection time
      INTEGER   STEP              ! advection time step in seconds
      INTEGER, SAVE :: LDATE( 3 ) ! last date for data on file
      INTEGER, SAVE :: LTIME( 3 ) ! last time for data on file
      LOGICAL   REVERT            ! recover last time step if true
      REAL      DJ                ! temporary Jacobian * air density
      REAL       :: DX1, DX2      ! X1 & X2 grid size
      REAL, SAVE :: RDX1, RDX2    ! inverse of DX1 & DX2

      INTEGER   C, C1, R, R1, L   ! induction variables
      INTEGER   BND               ! cell index for constructing density array.
      INTEGER   ALLOCSTAT
 
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: PNAME = 'HVELOC'
      CHARACTER( 16 ) :: AMSG
      CHARACTER( 96 ) :: XMSG = ' '
 
      CHARACTER( 8 ), SAVE :: COMMSTR

!     INTEGER       :: NCOLSDENS, NROWSDENS       ! local for DENSJ_BUF
C for INTERPX
!     INTEGER, SAVE :: STRTCOL,   ENDCOL,   STRTROW,   ENDROW
!     INTEGER       :: STRTCOLMC, ENDCOLMC, STRTROWMC, ENDROWMC
!     INTEGER, SAVE :: STRTCOLMD, ENDCOLMD, STRTROWMD, ENDROWMD

C-----------------------------------------------------------------------

#ifndef mpas
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         CALL LSTEPF( MET_CRO_3D, LDATE( 1 ), LTIME( 1 ) )
!        CALL LSTEPF( MET_BDY_3D, LDATE( 2 ), LTIME( 2 ) )
         CALL LSTEPF( MET_DOT_3D, LDATE( 3 ), LTIME( 3 ) )
 
!        LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 2 ), LDATE( 3 ) )
!        LTIME( 1 ) = SEC2TIME( MIN(
!    &                         TIME2SEC( LTIME( 1 ) ),
!    &                         TIME2SEC( LTIME( 2 ) ),
!    &                         TIME2SEC( LTIME( 3 ) )
!    &                         ) )

         LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 3 ) )
         LTIME( 1 ) = SEC2TIME( MIN(
     &                         TIME2SEC( LTIME( 1 ) ),
     &                         TIME2SEC( LTIME( 3 ) )
     &                         ) )

         WRITE( COMMSTR,'(4I2)' )  1, 1-NTHIK, 2, 1-NTHIK  ! ' 1 0 2 0'

C Get/compute DX1 & DX2

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD ! in m.
            DX2 = DG2M * YCELL_GD *
     &         COS( PI180*( YORIG_GD + YCELL_GD * FLOAT( GL_NROWS/2 ))) !in m
         ELSE
            DX1 = XCELL_GD        ! in m.
            DX2 = YCELL_GD        ! in m.
         END IF

         RDX1 = 1.0 / DX1
         RDX2 = 1.0 / DX2

         ALLOCATE ( DENSJ( 0:NCOLS+1,0:NROWS+1,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DENSJ'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( .NOT. WINDOW ) THEN

            ALLOCATE ( DENSJ_BUF( ncols, nrows, NLAYS ),STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DENSJ_BUF'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( DENSJ_BND( NBNDY,NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DENSJ_BND'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         END IF

      END IF     ! if firstime
 
      MDATE  = JDATE
      MTIME  = JTIME
      STEP   = TIME2SEC( TSTEP )
      CALL NEXTIME( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

#ifdef twoway
      REVERT = .FALSE.
#else
      IF ( MDATE .LT. LDATE( 1 ) ) THEN
         REVERT = .FALSE.
      ELSE IF ( MDATE .EQ. LDATE( 1 ) ) THEN
         IF ( MTIME .LE. LTIME( 1 ) ) THEN
            REVERT = .FALSE.
         ELSE
            REVERT = .TRUE.
         END IF
      ELSE   ! MDATE .GT. LDATE
         REVERT = .TRUE.
      END IF
#endif
 
      IF ( REVERT ) THEN
         XMSG = 'Current scenario interpolation step not available in all of '
     &        // TRIM( MET_CRO_3D ) // ', '
     &        // TRIM( MET_BDY_3D ) // ' and '
     &        // TRIM( MET_DOT_3D )
         CALL M3MESG( XMSG )
         WRITE( AMSG,'( 2I8 )' ) LDATE( 1 ), LTIME( 1 )
         XMSG = 'Using data for last file step: ' // TRIM( AMSG )
         CALL M3MESG( XMSG )
         MDATE = LDATE( 1 )
         MTIME = LTIME( 1 )
      END IF
 
C Interpolate Jacobian X Air Density
 
      IF ( WINDOW ) THEN

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ)

      ELSE  ! need to extend data from bndy file

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ_BUF)

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ_BND, 'b')

C Load DENSJ array

         DO L = 1, NLAYS
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  DENSJ( C,R,L ) = DENSJ_BUF( C,R,L )
               END DO
            END DO
         END DO

C Fill in DENSJ array for boundaries

         DO L = 1, NLAYS
            BND = 0
            DO R = 0, 0
               DO C = 1, NCOLS+1
                  BND = BND + 1
                  DENSJ( C,R,L ) = DENSJ_BND( BND,L )  ! South
               END DO
            END DO
            DO R = 1, NROWS+1
               DO C = NCOLS+1, NCOLS+1
                  BND = BND + 1
                  DENSJ( C,R,L ) = DENSJ_BND( BND,L )  ! East
               END DO
            END DO
            DO R = NROWS+1, NROWS+1
               DO C = 0, NCOLS
                  BND = BND + 1
                  DENSJ( C,R,L ) = DENSJ_BND( BND,L )  ! North
               END DO
            END DO
            DO R = 0, NROWS
               DO C = 0, 0
                  BND = BND + 1
                  DENSJ( C,R,L ) = DENSJ_BND( BND,L )  ! West
               END DO
            END DO
         END DO

      END IF   ! WINDOW

C Interpolate Contravariant Velocity components (already at flux points)
C X Jacobian X Air Density

      call interpolate_var ('UHAT_JD', mdate, mtime, UWIND)

      call interpolate_var ('VHAT_JD', mdate, mtime, VWIND)

C Obtain flux point values of Jacobian * air density and retrieve
C contravariant velocities 

C store actual north, east, south, and west displacement
C define communication pattern

      CALL SUBST_COMM ( DENSJ, DSPL_N0_E0_S0_W1, DRCN_W, COMMSTR )
      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS+1
               DJ = 0.5 * ( DENSJ( C,R,L ) + DENSJ( C-1,R,L ) )
               UWIND( C,R,L ) = UWIND( C,R,L ) / DJ
            END DO
         END DO
      END DO

C store actual north, east, south, and west displacement
C define communication pattern

      CALL SUBST_COMM ( DENSJ, DSPL_N0_E0_S1_W0, DRCN_S, COMMSTR )
      DO L = 1, NLAYS
         DO R = 1, NROWS+1
            DO C = 1, NCOLS
               DJ = 0.5 * ( DENSJ( C,R,L ) + DENSJ( C,R-1,L ) )
               VWIND( C,R,L ) = VWIND( C,R,L ) / DJ
            END DO
         END DO
      END DO

C Compute horizontal divergence

      CALL SUBST_COMM ( UWIND, DSPL_N0_E1_S0_W0, DRCN_E_W )
      CALL SUBST_COMM ( VWIND, DSPL_N1_E0_S0_W0, DRCN_N_S )

      DO L = 1, NLAYS
         DO R = 1, NROWS
            R1 = R + 1
            DO C = 1, NCOLS
               C1 = C + 1
               HDIV( C,R,L ) = ( UWIND( C1,R,L ) - UWIND( C,R,L ) ) * RDX1
     &                       + ( VWIND( C,R1,L ) - VWIND( C,R,L ) ) * RDX2
            END DO
         END DO
      END DO
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      FUNCTION WRITE3_DISTR ( FNAME, VNAME, JDATE, JTIME, DIM1, DIM2, DATA )
     &                        RESULT ( SUCCESS )

C-----------------------------------------------------------------------
C Function: Use I/O-API's WRITE3 and avoid using PWRITE3 to write layer
C           fractions to processor unique fake-gridded files

C Note: This function must live in a file that has a ".f" extension!

C Revision History:
C     5 Dec 2007 J.Young: initial implementation
C    16 Feb 2011 S.Roselle: replaced I/O API include files with M3UTILIO
C-----------------------------------------------------------------------

      USE RUNTIME_VARS
#ifndef mpas
      USE M3UTILIO
#endif

      IMPLICIT NONE

      CHARACTER( * ), INTENT( IN ) :: FNAME
      CHARACTER( * ), INTENT( IN ) :: VNAME
      INTEGER,        INTENT( IN ) :: JDATE, JTIME
      INTEGER,        INTENT( IN ) :: DIM1, DIM2
      REAL,           INTENT( IN ) :: DATA( DIM1,DIM2 )
      LOGICAL SUCCESS

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 96 ) :: XMSG = ' '

C-----------------------------------------------------------------------

      SUCCESS = .TRUE.

#ifndef mpas
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
      END If

      IF ( .NOT. WRITE3( FNAME, VNAME, JDATE, JTIME, DATA ) ) THEN
         XMSG = 'Error writing ' // 'to file "' // TRIM( FNAME ) // '."'
         WRITE( LOGDEV,* ) XMSG
         SUCCESS = .FALSE.
      END IF
#endif

      RETURN
      END FUNCTION WRITE3_DISTR

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PCGRID_DEFN

C-----------------------------------------------------------------------
C Function:
C   Create CGRID target, PCGRID. CGRID becomes a pointer to enable a one-
C   cell ghost region around CGRID for PinG

C Preconditions:
C   Horizontal domain extents must be set (subroutine PAR_INIT -> HGRD_DEFN)
C   Number of species in the species groups must be available (include files
C   in CGRID_SPCS)
C   This module is referenced in driver and sciproc. driver must call HGRD_INIT,
C   CGRID_MAP, and PAR_INIT prior to calling PCGRID_INIT (below).

C Subroutines and functions called:

C Revision history:
C    Apr 00 - Al, David, Jeff - initial implementation
C    Dec 00 - Jeff - add CGRID_MAP "method"
C    Jan 01 - Jeff - remove CGRID_MAP "method" - now in module CGRID_SPCS
C    Nov 01 - Jeff - correct pointer reference for ping
C    Dec 04 - Jeff - dyn alloc - USE VGRD_DEFN
C    Jan 05 - Jeff - dyn alloc - establish both horizontal & vertical
C                    domain specifications in one module
C 21 Jun 10 J.Young: convert for Namelist redesign
C   29 Mar 11 S.Roselle: Replaced I/O API include files with UTILIO_DEFN

C-----------------------------------------------------------------------

      USE GRID_CONF                ! horizontal & vertical domain specifications
      USE CGRID_SPCS, ONLY: NSPCSD  ! CGRID mechanism species

      IMPLICIT NONE

      REAL, ALLOCATABLE, SAVE, TARGET :: PCGRID( :,:,:,: )

      CONTAINS
         FUNCTION PCGRID_INIT () RESULT ( SUCCESS )

         USE UTILIO_DEFN

!        INCLUDE SUBST_VGRD_ID     ! vertical dimensioning parameters

         LOGICAL :: SUCCESS
         INTEGER :: ALLOCSTAT
         LOGICAL, SAVE :: FIRSTIME = .TRUE.
         CHARACTER( 120 ) :: XMSG = ' '

C PCGRID extents
         INTEGER :: LCOL
         INTEGER :: HCOL
         INTEGER :: LROW
         INTEGER :: HROW

         SUCCESS = .TRUE.

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.

#ifdef parallel
            LCOL = 1 - NTHIK
            HCOL = NCOLS + NTHIK
            LROW = 1 - NTHIK
            HROW = NROWS + NTHIK
#else
            LCOL = 1
            HCOL = NCOLS
            LROW = 1
            HROW = NROWS
#endif

            ALLOCATE ( PCGRID( LCOL:HCOL,LROW:HROW,NLAYS,NSPCSD ),
     &                 STAT = ALLOCSTAT )

            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating PCGRID'
               CALL M3WARN ( 'PCGRID_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
               END IF

            PCGRID = 0.0
!           PCGRID = -999.999

            ELSE
            XMSG = 'PCGRID already ALLOCATED'
            CALL M3WARN ( 'PCGRID_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

          RETURN
          END FUNCTION PCGRID_INIT

      END MODULE PCGRID_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! RCS file, release, date & time of last delta, author, state, [and locker]
! $Header: /project/work/rep/STENEX/src/se_snl/se_data_send_module.f,v 1.2 2006/02/15 14:41:56 yoj Exp $

! what(1) key, module and SID; SCCS file; date and time of last delta:
! %W% %P% %G% %U%

! --------------------------------------------------------------------------
! Purpose:
!
!   use F90 interface feature to achieve "faked" polymorphism for data
!   sending routine
!
! Revision history:
!
!   Orginal version: 11/05/99 by David Wong
!                    07/23/01 by David Wong
!                      -- use mpi_isend rather than mpi_send to send messages
!                    03/06/02 David Wong
!                      -- use blocking communication scheme due to non-blocking
!                         timing problems on IBM SP
!                    12/04/02 by David Wong
!                       -- modified the routine to accommodate worker and
!                          I/O processors partition scheme
!                    10/01/12 by David Wong
!                       -- reduced memory usage
!                       -- extended to five dimensional array
!                       -- used block sending mechanism
!
! Note:
!
!   se_[n]d[e]_data_send where [n] denotes the dimensionality of the data
!   and [e] is optional, indicates the first two dimensions are not both
!   decomposed
!
! Subroutine parameter description:
!
!   In:    sind    -- stores low and high index of each dimension for
!                     sending process
!          send_to -- stores processor number which data is sent to
!          dir_ind -- one of those eight major communication directions
!          tag     -- message tag
!          data    -- variable that sends data to other processors
! --------------------------------------------------------------------------

        module se_data_send_module

          use se_pe_info_ext

          implicit none

          interface se_data_send
            module procedure se_1d_data_send,
     &                       se_2d_data_send, se_2de_data_send,
     &                       se_3d_data_send, se_3de_data_send,
     &                       se_4d_data_send, se_4de_data_send,
     &                       se_5d_data_send
          end interface

          contains

! --------------------------------------------------------------------------
        subroutine se_1d_data_send (data, sind, send_to, dir_ind, tag, request)

        implicit none
        include "mpif.h"

        real, intent(in) :: data(:)
        integer, pointer :: sind(:, :), send_to(:)
        integer, intent(in) :: dir_ind, tag
        integer, intent(out) :: request

        integer :: i, scount, error
!       real :: sarray(size(data))
        real, allocatable :: sarray(:)

        allocate (sarray(sind(2,dir_ind) - sind(1,dir_ind) + 1), stat=error)

! -- pack data for sending
        scount = 0
        do i = sind(1,dir_ind), sind(2,dir_ind)
           scount = scount + 1
           sarray(scount) = data(i)
        end do

!       call mpi_isend (sarray, scount, mpi_real, send_to(dir_ind),
!    &                  tag, se_worker_comm, request, error)
        call mpi_send (sarray, scount, mpi_real, send_to(dir_ind),
     &                  tag, se_worker_comm, error)

        deallocate (sarray)

        end subroutine se_1d_data_send

! -----------------------------------------------------------------------------
        subroutine se_2d_data_send (data, sind, send_to, dir_ind, tag, request)

        implicit none
        include "mpif.h"

        real, intent(in) :: data(:,:)
        integer, pointer :: sind(:, :, :), send_to(:)
        integer, intent(in) :: dir_ind, tag
        integer, intent(out) :: request

        integer :: i, j, scount, error
!       real :: sarray(size(data))
        real, allocatable :: sarray(:)

        allocate (sarray( (sind(2,1,dir_ind) - sind(1,1,dir_ind) + 1) *
     $                    (sind(2,2,dir_ind) - sind(1,2,dir_ind) + 1)), stat=error)

        scount = 0

! -- pack data for sending
        do j = sind(1,2,dir_ind), sind(2,2,dir_ind)
           do i = sind(1,1,dir_ind), sind(2,1,dir_ind)
              scount = scount + 1
              sarray(scount) = data(i,j)
           end do
        end do

!       call mpi_isend (sarray, scount, mpi_real, send_to(dir_ind),
!    &                  tag, se_worker_comm, request, error)
        call mpi_send (sarray, scount, mpi_real, send_to(dir_ind),
     &                  tag, se_worker_comm, error)

        deallocate (sarray)

        end subroutine se_2d_data_send

! -----------------------------------------------------------------------------
        subroutine se_2de_data_send (data, sind, send_to, dir_ind, tag, request)

        implicit none
        include "mpif.h"

        real, intent(in) :: data(:,:)
        integer, pointer :: sind(:, :), send_to(:)
        integer, intent(in) :: dir_ind, tag
        integer, intent(out) :: request

        integer :: i, j, scount, error
!       real :: sarray(size(data))
        real, allocatable :: sarray(:)

        allocate (sarray( (sind(2,dir_ind) - sind(1,dir_ind) + 1) *
     $                    size(data, 2)), stat=error)

        scount = 0

! -- pack data for sending
        do j = lbound(data,2), ubound(data,2)
           do i = sind(1,dir_ind), sind(2,dir_ind)
              scount = scount + 1
              sarray(scount) = data(i,j)
           end do
        end do

!       call mpi_isend (sarray, scount, mpi_real, send_to(dir_ind),
!    &                  tag, se_worker_comm, request, error)
        call mpi_send (sarray, scount, mpi_real, send_to(dir_ind),
     &                  tag, se_worker_comm, error)

        deallocate (sarray)

        end subroutine se_2de_data_send

! -----------------------------------------------------------------------------
        subroutine se_3d_data_send (data, sind, send_to, dir_ind, tag, request)

        implicit none
        include "mpif.h"

        real, intent(in) :: data(:,:,:)
        integer, pointer :: sind(:, :, :), send_to(:)
        integer, intent(in) :: dir_ind, tag
        integer, intent(out) :: request

        integer :: i, j, k, scount, error
!       real :: sarray(size(data))
        real, allocatable :: sarray(:)

        allocate (sarray( (sind(2,1,dir_ind) - sind(1,1,dir_ind) + 1) *
     $                    (sind(2,2,dir_ind) - sind(1,2,dir_ind) + 1) *
     $                    (sind(2,3,dir_ind) - sind(1,3,dir_ind) + 1)), stat=error)

        scount = 0

! -- pack data for sending
        do k = sind(1,3,dir_ind), sind(2,3,dir_ind)
           do j = sind(1,2,dir_ind), sind(2,2,dir_ind)
              do i = sind(1,1,dir_ind), sind(2,1,dir_ind)
                 scount = scount + 1
                 sarray(scount) = data(i,j,k)
              end do
           end do
        end do

!       call mpi_isend (sarray, scount, mpi_real, send_to(dir_ind),
!    &                  tag, se_worker_comm, request, error)
        call mpi_send (sarray, scount, mpi_real, send_to(dir_ind),
     &                  tag, se_worker_comm, error)

        deallocate (sarray)

        end subroutine se_3d_data_send

! -----------------------------------------------------------------------------
        subroutine se_3de_data_send (data, sind, send_to, dir_ind, tag, request)

        implicit none
        include "mpif.h"

        real, intent(in) :: data(:,:,:)
        integer, pointer :: sind(:, :), send_to(:)
        integer, intent(in) :: dir_ind, tag
        integer, intent(out) :: request

        integer :: i, j, k, scount, error
!       real :: sarray(size(data))
        real, allocatable :: sarray(:)

        allocate (sarray( (sind(2,dir_ind) - sind(1,dir_ind) + 1) *
     $                    size(data,2) * size(data,3)), stat=error)

        scount = 0

! -- pack data for sending
        do k = lbound(data,3), ubound(data,3)
           do j = lbound(data,2), ubound(data,2)
              do i = sind(1,dir_ind), sind(2,dir_ind)
                 scount = scount + 1
                 sarray(scount) = data(i,j,k)
              end do
           end do
        end do

!       call mpi_isend (sarray, scount, mpi_real, send_to(dir_ind),
!    &                  tag, se_worker_comm, request, error)
        call mpi_send (sarray, scount, mpi_real, send_to(dir_ind),
     &                  tag, se_worker_comm, error)

        deallocate (sarray)

        end subroutine se_3de_data_send

! -----------------------------------------------------------------------------
        subroutine se_4d_data_send (data, sind, send_to, dir_ind, tag, request)

        implicit none
        include "mpif.h"

        real, intent(in) :: data(:,:,:,:)
        integer, pointer :: sind(:, :, :), send_to(:)
        integer, intent(in) :: dir_ind, tag
        integer, intent(out) :: request

        integer :: i, j, k, l, scount, error
!       real :: sarray(size(data))
        real, allocatable :: sarray(:)

        scount = 0

        allocate (sarray( (sind(2,1,dir_ind) - sind(1,1,dir_ind) + 1) *
     $                    (sind(2,2,dir_ind) - sind(1,2,dir_ind) + 1) *
     $                    (sind(2,3,dir_ind) - sind(1,3,dir_ind) + 1) *
     $                    (sind(2,4,dir_ind) - sind(1,4,dir_ind) + 1)), stat=error)

! -- pack data for sending
        do l = sind(1,4,dir_ind), sind(2,4,dir_ind)
           do k = sind(1,3,dir_ind), sind(2,3,dir_ind)
              do j = sind(1,2,dir_ind), sind(2,2,dir_ind)
                 do i = sind(1,1,dir_ind), sind(2,1,dir_ind)
                    scount = scount + 1
                    sarray(scount) = data(i,j,k,l)
                 end do
              end do
           end do
        end do

!       call mpi_isend (sarray, scount, mpi_real, send_to(dir_ind),
!    &                  tag, se_worker_comm, request, error)
        call mpi_send (sarray, scount, mpi_real, send_to(dir_ind),
     &                  tag, se_worker_comm, error)

        deallocate (sarray)

        end subroutine se_4d_data_send

! -----------------------------------------------------------------------------
        subroutine se_4de_data_send (data, sind, send_to, dir_ind, tag, request)

        implicit none
        include "mpif.h"

        real, intent(in) :: data(:,:,:,:)
        integer, pointer :: sind(:, :), send_to(:)
        integer, intent(in) :: dir_ind, tag
        integer, intent(out) :: request

        integer :: i, j, k, s, scount, error
!       real :: sarray(size(data))
        real, allocatable :: sarray(:)

        allocate (sarray( (sind(2,dir_ind) - sind(1,dir_ind) + 1) *
     $                    size(data,2) * size(data,3) * size(data,4)), stat=error)

        scount = 0

! -- pack data for sending
        do s = lbound(data,4), ubound(data,4)
           do k = lbound(data,3), ubound(data,3)
              do j = lbound(data,2), ubound(data,2)
                 do i = sind(1,dir_ind), sind(2,dir_ind)
                    scount = scount + 1
                    sarray(scount) = data(i,j,k,s)
                 end do
              end do
           end do
        end do

!       call mpi_isend (sarray, scount, mpi_real, send_to(dir_ind),
!    &                  tag, se_worker_comm, request, error)
        call mpi_send (sarray, scount, mpi_real, send_to(dir_ind),
     &                  tag, se_worker_comm, error)

        deallocate (sarray)

        end subroutine se_4de_data_send

! -----------------------------------------------------------------------------
        subroutine se_5d_data_send (data, sind, send_to, dir_ind, tag, request)

        implicit none
        include "mpif.h"

        real, intent(in) :: data(:,:,:,:,:)
        integer, pointer :: sind(:, :, :), send_to(:)
        integer, intent(in) :: dir_ind, tag
        integer, intent(out) :: request

        integer :: i, j, k, l, m, scount, error
!       real :: sarray(size(data))
        real, allocatable :: sarray(:)

        allocate (sarray( (sind(2,1,dir_ind) - sind(1,1,dir_ind) + 1) *
     $                    (sind(2,2,dir_ind) - sind(1,2,dir_ind) + 1) *
     $                    (sind(2,3,dir_ind) - sind(1,3,dir_ind) + 1) *
     $                    (sind(2,4,dir_ind) - sind(1,4,dir_ind) + 1) *
     $                    (sind(2,5,dir_ind) - sind(1,5,dir_ind) + 1)), stat=error)

        scount = 0

! -- pack data for sending
        do m = sind(1,5,dir_ind), sind(2,5,dir_ind)
           do l = sind(1,4,dir_ind), sind(2,4,dir_ind)
              do k = sind(1,3,dir_ind), sind(2,3,dir_ind)
                 do j = sind(1,2,dir_ind), sind(2,2,dir_ind)
                    do i = sind(1,1,dir_ind), sind(2,1,dir_ind)
                       scount = scount + 1
                       sarray(scount) = data(i,j,k,l,m)
                    end do
                 end do
              end do
           end do
        end do

!       call mpi_isend (sarray, scount, mpi_real, send_to(dir_ind),
!    &                  tag, se_worker_comm, request, error)
        call mpi_send (sarray, scount, mpi_real, send_to(dir_ind),
     &                  tag, se_worker_comm, error)

        deallocate (sarray)

        end subroutine se_5d_data_send

        end module se_data_send_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains key component from LUS_DEFN.F to facilitate 
! centralized I/O implementation by avoiding cyclic data dependence

! Revision History:
!  01 Feb 2019 D.Wong initial implementation
!  12 Aug 2019 F.Sidi Moved vnmld to its on type, and created a integer entry 
!                     to map dust categories from LUFRAC. **NOTE land use type
!                     with no mapped index has a dummy -999 value.** 
!  31 Mar 2022 J. Willison Removed BELD as wbdust input 
!  18 Sep 2024 C. Hogrefe Corrected erroneous mapping of NLCD40 and NLCD50
!                         shrub/scrub and dwarf scrub to BELD3 barren rather
!                         than BELD3 shrubland 
!------------------------------------------------------------------------!

          module lus_data_module

            implicit none

            type lus_type
               character( 16 ) :: name
               character( 64 ) :: desc
            end type lus_type
            
            type lus_type_2
               character( 16 ) :: name
               character( 64 ) :: desc
               integer :: lu_idx
            end type lus_type_2


            type( lus_type_2 ), allocatable :: vnmld( : )
            type( lus_type ), allocatable :: vnmlu( : )

            real, allocatable    :: ladut( :,:,: ) ! % of desertland
            real, allocatable    :: lut( :,:,: )   ! landuse category fraction
            real, allocatable    :: dmsk( : )      ! desert fraction mask
            real, allocatable    :: uland( :,:,: ) ! % of 4 land categories groups
            integer, allocatable :: dmap( : )      ! desert land map to BELD3

            character( 16 ) :: lufile( 2 ) = ' '
            integer         :: n_dlcat        ! number of desert land categories
            integer         :: n_lucat        ! number of landuse categories

! USGS - United States Geological Survey
! NOAH - A community land-surface model [N=NCEP, O=Oregon State Univ.,
!        A=Air Force, H=Hydrologic Research Lab - NWS(now OHD: Office of
!        Hydrologic Devel.)]
! MODIS - MODerate resolution Imaging Spectroradiometer
! NLCD - National Land Cover Dataset
! IGBP - International Geosphere-Biosphere Programme


! USGS24 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!     read file: GRID_CRO_2D

            integer, parameter :: n_dlcat_usgs24 = 4   ! number of desert land categories
            type( lus_type_2 ), parameter :: vnmld_usgs24( n_dlcat_usgs24 ) = (/
     &            lus_type_2( 'LUFRAC_08', 'Shrubland                   ',8  ),
     &            lus_type_2( 'LUFRAC_19', 'Barren or Sparsely Vegetated',19 ),
     &            lus_type_2( 'LUFRAC_22', 'Mixed Tundra                ',22 ),
     &            lus_type_2( 'LUFRAC_23', 'Bare Ground Tundra          ',23 ) /)

!!!!!    Is some 'tundra' desert land?

            real :: dmsk_usgs24( n_dlcat_usgs24 ) =   ! land use type desert fraction
     &           (/ 0.50,    ! shrubland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75 /)  ! barrenland

            integer :: dmap_usgs24( n_dlcat_usgs24+1 ) =   ! land use type desert map to BELD3
     &           (/ 1,       ! shrubland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3 /)     ! ag landuse surrogate

            integer, parameter :: n_lucat_usgs24 = 24   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_usgs24( n_lucat_usgs24 ) = (/
     &            lus_type( 'LUFRAC_01', 'Urban Land                                      ' ),
     &            lus_type( 'LUFRAC_02', 'Dryland Cropland and Pasture                    ' ),
     &            lus_type( 'LUFRAC_03', 'Irrigated Cropland and Pasture                  ' ),
     &            lus_type( 'LUFRAC_04', 'Mixed Dryland and Irrigated Cropland and Pasture' ),
     &            lus_type( 'LUFRAC_05', 'Cropland-Grassland Mosaic                       ' ),
     &            lus_type( 'LUFRAC_06', 'Cropland-Woodland Mosaic                        ' ),
     &            lus_type( 'LUFRAC_07', 'Grassland                                       ' ),
     &            lus_type( 'LUFRAC_08', 'Shrubland                                       ' ),
     &            lus_type( 'LUFRAC_09', 'Mixed Shrubland-Grassland                       ' ),
     &            lus_type( 'LUFRAC_10', 'Savannah                                        ' ),
     &            lus_type( 'LUFRAC_11', 'Deciduous Broadleaf Forest                      ' ),
     &            lus_type( 'LUFRAC_12', 'Deciduous Needleleaf Forest                     ' ),
     &            lus_type( 'LUFRAC_13', 'Evergreen Broadleaf Forest                      ' ),
     &            lus_type( 'LUFRAC_14', 'Evergreen Needleleaf Forest                     ' ),
     &            lus_type( 'LUFRAC_15', 'Mixed Forest                                    ' ),
     &            lus_type( 'LUFRAC_16', 'Water                                           ' ),
     &            lus_type( 'LUFRAC_17', 'Herbaceous Wetland                              ' ),
     &            lus_type( 'LUFRAC_18', 'Wooded Wetland                                  ' ),
     &            lus_type( 'LUFRAC_19', 'Barren or Sparsely Vegetated                    ' ),
     &            lus_type( 'LUFRAC_20', 'Herbaceous Tundra                               ' ),
     &            lus_type( 'LUFRAC_21', 'Wooded Tundra                                   ' ),
     &            lus_type( 'LUFRAC_22', 'Mixed Tundra                                    ' ),
     &            lus_type( 'LUFRAC_23', 'Bare Ground Tundra                              ' ),
     &            lus_type( 'LUFRAC_24', 'Snow or Ice                                     ' ) /)

! MODIS - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!     read file: GRID_CRO_2D

            integer, parameter :: n_dlcat_modis = 1   ! number of desert land categories
            type( lus_type_2 ), parameter :: vnmld_modis( n_dlcat_modis ) = (/
     &            lus_type_2( 'nada', 'nada',-999 ) /)
            real :: dmsk_modis( n_dlcat_modis ) = 0.0  ! land use type desert fraction
            integer :: dmap_modis( n_dlcat_modis+1 ) = 0 ! land use type desert map to BELD3
            integer, parameter :: n_lucat_modis = 1   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_modis( n_lucat_modis ) = (/
     &            lus_type( 'nada', 'nada' ) /)

! 1  MODIS_0:    31. MODIS: 0 water
! 4  MODIS_1:    32. MODIS: 1 evergreen needleleaf forest
! 4  MODIS_2:    33. MODIS: 2 evergreen broadleaf forest
! 4  MODIS_3:    34. MODIS: 3 deciduous needleleaf forest
! 4  MODIS_4:    35. MODIS: 4 deciduous broadleaf forest
! 4  MODIS_5:    36. MODIS: 5 mixed forests
! 2  MODIS_6:    37. MODIS: 6 closed shrublands
! 2  MODIS_7:    38. MODIS: 7 open shrublands
! 4  MODIS_8:    39. MODIS: 8 woody savannas
! 2  MODIS_9:    40. MODIS: 9 savannas
! 2  MODIS_10:   41. MODIS: 10 grasslands
! 4  MODIS_11:   42. MODIS: 11 permanent wetlands
! 2  MODIS_12:   43. MODIS: 12 croplands
! 3  MODIS_13:   44. MODIS: 13 urban and built up
! 2  MODIS_14:   45. MODIS: 14 cropland / natural vegetation mosaic
! 1  MODIS_15:   46. MODIS: 15 permanent snow and ice
! 1  MODIS_16:   47. MODIS: 16 barren or sparsely vegetated
! 1  MODIS_17:   48. MODIS: 17 IGBP water
! -  MODIS_254:  49. MODIS: 254 unclassified
! -  MODIS_255:  50. MODIS: 255 fill value (normally ocean water)

! MODIS_NOAH
!     read file: GRID_CRO_2D

            integer, parameter :: n_dlcat_modis_noah = 4   ! number of desert land categories
            type( lus_type_2 ), parameter :: vnmld_modis_noah( n_dlcat_modis_noah ) = (/
     &            lus_type_2( 'LUFRAC_06', 'Closed Shrublands           ',6  ),
     &            lus_type_2( 'LUFRAC_07', 'Open Shrublands             ',7  ),
     &            lus_type_2( 'LUFRAC_16', 'Barren or Sparsely Vegetated',16 ),
     &            lus_type_2( 'LUFRAC_20', 'Barren Tundra               ',20 ) /)

            real :: dmsk_modis_noah( n_dlcat_modis_noah ) =   ! land use type desert fraction
     &           (/ 0.50,    ! shrubland
     &              0.50,    ! shrubland
     &              0.75,    ! barrenland
     &              0.75 /)  ! barrenland

            integer :: dmap_modis_noah( n_dlcat_modis_noah+1 ) =  ! land use type desert map to BELD3
     &           (/ 1,       ! shrubland
     &              1,       ! shrubland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3 /)     ! ag landuse surrogate

            integer, parameter :: n_lucat_modis_noah = 20   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_modis_noah( n_lucat_modis_noah ) = (/
     &            lus_type( 'LUFRAC_01', 'Evergreen Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_02', 'Evergreen Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_03', 'Deciduous Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_04', 'Deciduous Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_05', 'Mixed Forests                     ' ),
     &            lus_type( 'LUFRAC_06', 'Closed Shrublands                 ' ),
     &            lus_type( 'LUFRAC_07', 'Open Shrublands                   ' ),
     &            lus_type( 'LUFRAC_08', 'Woody Savannas                    ' ),
     &            lus_type( 'LUFRAC_09', 'Savannas                          ' ),
     &            lus_type( 'LUFRAC_10', 'Grasslands                        ' ),
     &            lus_type( 'LUFRAC_11', 'Permanent Wetlands                ' ),
     &            lus_type( 'LUFRAC_12', 'Croplands                         ' ),
     &            lus_type( 'LUFRAC_13', 'Urban and Built-Up                ' ),
     &            lus_type( 'LUFRAC_14', 'Cropland-Natural Vegetation Mosaic' ),
     &            lus_type( 'LUFRAC_15', 'Snow and Ice                      ' ),
     &            lus_type( 'LUFRAC_16', 'Barren or Sparsely Vegetated      ' ),
     &            lus_type( 'LUFRAC_17', 'Water                             ' ),
     &            lus_type( 'LUFRAC_18', 'Wooded Tundra                     ' ),
     &            lus_type( 'LUFRAC_19', 'Mixed Tundra                      ' ),
     &            lus_type( 'LUFRAC_20', 'Barren Tundra                     ' ) /)

! NLCD_MODIS or NLCD50 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!     read file: GRID_CRO_2D
! includes both nlcd and MODIS versions of shrublands
            integer, parameter :: n_dlcat_nlcd_modis = 7   ! number of desert land types
            type( lus_type_2 ), parameter :: vnmld_nlcd_modis( n_dlcat_nlcd_modis ) = (/
     &            lus_type_2( 'LUFRAC_37', 'Closed Shrublands           ',37 ),
     &            lus_type_2( 'LUFRAC_38', 'Open Shrublands             ',38 ),
     &            lus_type_2( 'LUFRAC_07', 'Barren Land (Rock-Sand-Clay)',7  ),
     &            lus_type_2( 'LUFRAC_12', 'Dwarf Scrub                 ',12 ),
     &            lus_type_2( 'LUFRAC_13', 'Shrub-Scrub                 ',13 ),
     &            lus_type_2( 'LUFRAC_18', 'Tundra                      ',18 ),
     &            lus_type_2( 'LUFRAC_47', 'Barren or Sparsely Vegetated',47 ) /)

            real :: dmsk_nlcd_modis( n_dlcat_nlcd_modis ) =   ! land use type desert fraction
     &           (/ 0.50,    ! shrubland
     &              0.50,    ! shrubland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75 /)  ! barrenland

            integer :: dmap_nlcd_modis( n_dlcat_nlcd_modis+1 ) = ! land use type desert map to BELD3
     &           (/ 1,       ! shrubland
     &              1,       ! shrubland
     &              3,       ! barrenland
     &              1,       ! shrubland
     &              1,       ! shrubland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3 /)     ! ag landuse surrogate

            integer, parameter :: n_lucat_nlcd_modis = 50   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_nlcd_modis( n_lucat_nlcd_modis ) = (/
     &            lus_type( 'LUFRAC_01', 'Open Water' ),
     &            lus_type( 'LUFRAC_02', 'Perennial Ice-Snow                ' ),
     &            lus_type( 'LUFRAC_03', 'Developed Open Space              ' ),  ! ?
     &            lus_type( 'LUFRAC_04', 'Developed Low Intensity           ' ),
     &            lus_type( 'LUFRAC_05', 'Developed Medium Intensity        ' ),
     &            lus_type( 'LUFRAC_06', 'Developed High Intensity          ' ),
     &            lus_type( 'LUFRAC_07', 'Barren Land (Rock-Sand-Clay)      ' ),
     &            lus_type( 'LUFRAC_08', 'Unconsolidated Shore              ' ),  ! ?
     &            lus_type( 'LUFRAC_09', 'Deciduous Forest                  ' ),
     &            lus_type( 'LUFRAC_10', 'Evergreen Forest                  ' ),
     &            lus_type( 'LUFRAC_11', 'Mixed Forest                      ' ),
     &            lus_type( 'LUFRAC_12', 'Dwarf Scrub                       ' ),
     &            lus_type( 'LUFRAC_13', 'Shrub-Scrub                       ' ),
     &            lus_type( 'LUFRAC_14', 'Grassland-Herbaceous              ' ),
     &            lus_type( 'LUFRAC_15', 'Sedge-Herbaceous                  ' ),
     &            lus_type( 'LUFRAC_16', 'Lichens                           ' ),
     &            lus_type( 'LUFRAC_17', 'Moss                              ' ),
     &            lus_type( 'LUFRAC_18', 'Tundra                            ' ),
     &            lus_type( 'LUFRAC_19', 'Pasture-Hay                       ' ),
     &            lus_type( 'LUFRAC_20', 'Cultivated Crops                  ' ),
     &            lus_type( 'LUFRAC_21', 'Woody Wetlands                    ' ),
     &            lus_type( 'LUFRAC_22', 'Palustrine Forested Wetland       ' ),
     &            lus_type( 'LUFRAC_23', 'Palustrine Scrub-Shrub Wetland    ' ),  ! ?
     &            lus_type( 'LUFRAC_24', 'Estuarine Forested Wetland        ' ),
     &            lus_type( 'LUFRAC_25', 'Estuarine Scrub_Shrub Wetland     ' ),  ! ?
     &            lus_type( 'LUFRAC_26', 'Emergent Herbaceous Wetlands      ' ),  ! ?
     &            lus_type( 'LUFRAC_27', 'Palustrine Emergent Wetland       ' ),  ! ?
     &            lus_type( 'LUFRAC_28', 'Estuarine Emergent Wetland        ' ),  ! ?
     &            lus_type( 'LUFRAC_29', 'Palustrine Aquatic Bed            ' ),  ! ?
     &            lus_type( 'LUFRAC_30', 'Estuarine Aquatic Bed             ' ),  ! ?
     &            lus_type( 'LUFRAC_31', 'Water                             ' ),
     &            lus_type( 'LUFRAC_32', 'Evergreen Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_33', 'Evergreen Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_34', 'Deciduous Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_35', 'Deciduous Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_36', 'Mixed Forests                     ' ),
     &            lus_type( 'LUFRAC_37', 'Closed Shrublands                 ' ),
     &            lus_type( 'LUFRAC_38', 'Open Shrublands                   ' ),
     &            lus_type( 'LUFRAC_39', 'Woody Savannas                    ' ),
     &            lus_type( 'LUFRAC_40', 'Savannas                          ' ),
     &            lus_type( 'LUFRAC_41', 'Grasslands                        ' ),
     &            lus_type( 'LUFRAC_42', 'Permanent Wetlands                ' ),
     &            lus_type( 'LUFRAC_43', 'Croplands                         ' ),
     &            lus_type( 'LUFRAC_44', 'Urban and Built Up                ' ),
     &            lus_type( 'LUFRAC_45', 'Cropland-Natural Vegetation Mosaic' ),
     &            lus_type( 'LUFRAC_46', 'Permanent Snow and Ice            ' ),
     &            lus_type( 'LUFRAC_47', 'Barren or Sparsely Vegetated      ' ),
     &            lus_type( 'LUFRAC_48', 'IGBP Water                        ' ),
     &            lus_type( 'LUFRAC_49', 'unclassified                      ' ),  ! ?
     &            lus_type( 'LUFRAC_50', 'fill value                        ' ) /)  ! ?

! NLCD40 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!     read file: GRID_CRO_2D
! includes both nlcd and MODIS versions of shrublands
            integer, parameter :: n_dlcat_nlcd40 = 6   ! number of desert land types
            type( lus_type_2 ), parameter :: vnmld_nlcd40( n_dlcat_nlcd40 ) = (/
     &            lus_type_2( 'LUFRAC_06', 'Closed Shrublands           ',6  ),
     &            lus_type_2( 'LUFRAC_07', 'Open Shrublands             ',7  ),
     &            lus_type_2( 'LUFRAC_27', 'Barren Land (Rock-Sand-Clay)',27 ),
     &            lus_type_2( 'LUFRAC_31', 'Dwarf Scrub                 ',31 ),
     &            lus_type_2( 'LUFRAC_32', 'Shrub-Scrub                 ',32 ),
     &            lus_type_2( 'LUFRAC_16', 'Barren or Sparsely Vegetated',16 ) /)

            real :: dmsk_nlcd40( n_dlcat_nlcd40 ) =   ! land use type desert fraction
     &           (/ 0.50,    ! shrubland
     &              0.50,    ! shrubland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75 /)  ! barrenland

            integer :: dmap_nlcd40( n_dlcat_nlcd40+1 ) = ! land use type desert map to BELD3
     &           (/ 1,       ! shrubland
     &              1,       ! shrubland
     &              3,       ! barrenland
     &              1,       ! shrubland
     &              1,       ! shrubland
     &              3,       ! barrenland
     &              3 /)     ! ag landuse surrogate

            integer, parameter :: n_lucat_nlcd40 = 40   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_nlcd40( n_lucat_nlcd40 ) = (/
     &            lus_type( 'LUFRAC_01', 'Evergreen Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_02', 'Evergreen Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_03', 'Deciduous Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_04', 'Deciduous Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_05', 'Mixed Forests                     ' ),
     &            lus_type( 'LUFRAC_06', 'Closed Shrublands                 ' ),
     &            lus_type( 'LUFRAC_07', 'Open Shrublands                   ' ),
     &            lus_type( 'LUFRAC_08', 'Woody Savannas                    ' ),
     &            lus_type( 'LUFRAC_09', 'Savannas                          ' ),
     &            lus_type( 'LUFRAC_10', 'Grasslands                        ' ),
     &            lus_type( 'LUFRAC_11', 'Permanent Wetlands                ' ),
     &            lus_type( 'LUFRAC_12', 'Croplands                         ' ),
     &            lus_type( 'LUFRAC_13', 'Urban and Built Up                ' ),
     &            lus_type( 'LUFRAC_14', 'Cropland-Natural Vegetation Mosaic' ),
     &            lus_type( 'LUFRAC_15', 'Permanent Snow and Ice            ' ),
     &            lus_type( 'LUFRAC_16', 'Barren or Sparsely Vegetated      ' ),
     &            lus_type( 'LUFRAC_17', 'IGBP Water                        ' ),
     &            lus_type( 'LUFRAC_18', 'unclassified                      ' ),  ! ?
     &            lus_type( 'LUFRAC_19', 'fill value                        ' ),
     &            lus_type( 'LUFRAC_20', 'unclassified                      ' ),  ! ?
     &            lus_type( 'LUFRAC_21', 'Open Water                        ' ),
     &            lus_type( 'LUFRAC_22', 'Perennial Ice-Snow                ' ),
     &            lus_type( 'LUFRAC_23', 'Developed Open Space              ' ),  ! ?
     &            lus_type( 'LUFRAC_24', 'Developed Low Intensity           ' ),
     &            lus_type( 'LUFRAC_25', 'Developed Medium Intensity        ' ),
     &            lus_type( 'LUFRAC_26', 'Developed High Intensity          ' ),
     &            lus_type( 'LUFRAC_27', 'Barren Land (Rock-Sand-Clay)      ' ),
     &            lus_type( 'LUFRAC_28', 'Deciduous Forest                  ' ),
     &            lus_type( 'LUFRAC_29', 'Evergreen Forest                  ' ),
     &            lus_type( 'LUFRAC_30', 'Mixed Forest                      ' ),
     &            lus_type( 'LUFRAC_31', 'Dwarf Scrub                       ' ),
     &            lus_type( 'LUFRAC_32', 'Shrub-Scrub                       ' ),
     &            lus_type( 'LUFRAC_33', 'Grassland-Herbaceous              ' ),
     &            lus_type( 'LUFRAC_34', 'Sedge-Herbaceous                  ' ),
     &            lus_type( 'LUFRAC_35', 'Lichens                           ' ),
     &            lus_type( 'LUFRAC_36', 'Moss                              ' ),
     &            lus_type( 'LUFRAC_37', 'Pasture-Hay                       ' ),
     &            lus_type( 'LUFRAC_38', 'Cultivated Crops                  ' ),
     &            lus_type( 'LUFRAC_39', 'Woody Wetlands                    ' ),
     &            lus_type( 'LUFRAC_40', 'Emergent Herbaceous Wetlands      ' )  /)  ! ?

          end module lus_data_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_REPORT

C-----------------------------------------------------------------------
C Function: To provide an output listing that symbolically represents
C           the operations to be performed in Process Analysis 
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified Jun, 1998 by Jerry Gipson to change name of output report
C  Modified May 2002 by Jerry Gipson to add comma in format statements
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI`s M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE PA_GLOBAL     ! Mech data used 
      USE PA_VARS
      USE PA_IPRVARS
      USE PA_DEFN, Only: LFULLIRR, LPARTIRR, N_IPR_SPC, IRRNAME
      USE PA_PARSE
      use get_env_module 

      IMPLICIT NONE
      
C Includes: None
C Arguments: None
C Parameters:
      CHARACTER( 20 ), PARAMETER :: PACM_REPORT = 'PACM_REPORT'  
      CHARACTER( 16 ), PARAMETER :: PNAME = 'PA_REPORT'  

C External Functions: None

C Local Variables
      CHARACTER(  1 ) :: C = 'c'   ! Lowercase c
      CHARACTER(  3 ) :: LABL      ! Output reaction label or term number
      CHARACTER(  3 ) :: OUTLBL    ! Output label number
      CHARACTER(  4 ) :: OPNAM     ! Operator variable name
      CHARACTER(  4 ) :: TYPE      ! Operator type
      CHARACTER(  7 ) :: PNFLG     ! Pos or Neg only flag
      CHARACTER( 11 ) :: COUT      ! Output coefficient
      CHARACTER( 80 ) :: CEES      ! Line of asterisks
      CHARACTER( 80 ) :: LINOUT    ! line of output
      CHARACTER(  5 ) :: TZ        ! Time zone label
      CHARACTER( 24 ) :: TIMNDAT   ! Wall clock time and date

      CHARACTER( 50 ) :: STRING( 20 )             ! Strings to concatenate
      CHARACTER( LABLEN ) :: RJLABL( MXRXNS ) ! Right justified reaction label
      CHARACTER(  4 ) ::  SAVOP( MAXTERMS )        ! Operator name
      CHARACTER(  3 ) ::  SAVLBL( MAXTERMS )       ! Operator label

      INTEGER E1, E2, E3 ! Ending character positions
      INTEGER EQPOS1     ! Position of equal sign plus 1
      INTEGER ICOUNT     ! Counter of no. of output terms
      INTEGER IE1, IE2   ! Pointer to ending positions in a string
      INTEGER IEND       ! Pointer to end of output line 
      INTEGER INDX       ! Pointer to reaction number
      INTEGER IOUT       ! Unit number for output report   
      INTEGER IS1, IS2   ! Pointer to startinging positions in a string
      INTEGER LEN1       ! Length of a string
      INTEGER :: LINLEN = 80  ! Length of output line
      INTEGER MAXLEN     ! Length of longest reaction label
      INTEGER N          ! Loop index for specis and defined names
      INTEGER NCYC       ! Loop index for number of cycles
      INTEGER NNETR      ! No. of net reaction operators in OUTPUT request
      INTEGER NNLOS      ! No. of net loss operators in OUTPUT request
      INTEGER NLN        ! Loop index for no. of mech lines
      INTEGER NLOSS      ! No. of loss operators in OUTPUT request
      INTEGER NFAM       ! Loop index for number of familys
      INTEGER NNPRD      ! No. of net production operators in OUTPUT request
      INTEGER NOUT       ! Loop index for number of output requests
      INTEGER NIPR       ! Loop index for IPR species
      INTEGER NPROD      ! No. of net production operators in OUTPUT request
      INTEGER NRX        ! Loop index for number of reactions
      INTEGER NR         ! Total number of reactions in operator
      INTEGER NTERM      ! Loop index for number of terms in output request
      INTEGER NUMSTRNGS  ! Number of strings to concatenate
      INTEGER SPOS       ! Starting position of right justified label
      INTEGER IDATE      ! Wall-clock date
      INTEGER ITIME      ! Wall clock time

      INTEGER RXNUMS( MXRXNS )  ! Rx nos. of reactions in operator term

      LOGICAL LFIRST     ! Flag for first time throuhh a loop
      LOGICAL LINITFLG   ! Flag to indicate initialization present

      LOGICAL LRDONLY    ! Flag for read only file
      LOGICAL LFMTTED    ! Flag for formatted file

      LOGICAL LRXINC( MXRXNS )  ! Flag to include reaction in prod,
                                ! loss, or net operations
      REAL    COEFFS( MXRXNS )  ! Coefficients of operator reactions
      INTEGER ASTAT
      CHARACTER(200) :: PACM_NAME

C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Open file and write report header
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      LRDONLY = .FALSE.
      LFMTTED = .TRUE.

      !IOUT = GETEFILE ( PACM_REPORT, LRDONLY, LFMTTED, PNAME )
      IOUT = JUNIT()
      CALL GET_ENV( PACM_NAME, 'PACM_REPORT', 'PACM_REPORT' )
      OPEN ( UNIT = IOUT, FILE = PACM_NAME, STATUS='UNKNOWN', FORM='FORMATTED', IOSTAT=ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR: Could not open PA_REPORT output file'
         CALL M3EXIT( PNAME, IZERO, IZERO, MSG, ASTAT )
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Get the time and date to be used as the time stamp for all outputs;
c  Convert from GMT to EDT or EST
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      CALL GETDTTIME( IDATE, ITIME )

      IF ( ISDSTIME( IDATE ) ) THEN
         CALL NEXTIME( IDATE, ITIME, -40000 )
         TZ = ' EDT '
      ELSE
         CALL NEXTIME( IDATE, ITIME, -50000 )
         TZ = ' EST '
      END IF

      TIMNDAT = DT2STR( IDATE, ITIME )
      TDATOUT = TIMNDAT( 1:8 ) // TZ // TIMNDAT( 10:24 )

      WRITE( IOUT, 93020 ) TDATOUT
      WRITE( IOUT, 93000 )

      DO N = 1, 80
         CEES( N:N ) = C
      END DO

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Do the integrated process rate section
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LINOUT = CEES
      WRITE( IOUT, 93000 ) LINOUT
      IF ( N_IPR_SPC .LE. 0 ) THEN
         WRITE( IOUT, 93080 )
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT
         WRITE( IOUT, 93000 )
         WRITE( IOUT, 93000 )
      ELSE 
         WRITE( IOUT, 93100 )
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT
         LFIRST = .TRUE.
         DO NIPR = 1, N_IPR_SPC
            IF ( IPR_SPTYPE( NIPR ) .EQ. 'FAM' ) THEN
               IF ( LFIRST ) THEN
                  WRITE( IOUT, 93120 )
                  LFIRST = .FALSE.
               END IF 
               INDX = IPR_SPNUM( NIPR )
               DO N = 1, FAMNUMLNS( INDX )
                  WRITE( IOUT, 93000 ) FAMLINE( INDX,N )
               END DO
               WRITE( IOUT, 93140 ) 
               WRITE( IOUT, 93000 ) LINOUT
            END IF
         END DO
         ICOUNT = 0
         DO NIPR = 1, N_IPR_SPC  
            DO N = 1, N_IPR_OPS( NIPR )
               ICOUNT = ICOUNT + 1
               WRITE( IOUT, '(A17,I3,A4,A4,A4,A)' ) '      IPR_OUTPUT(', 
     &                ICOUNT, ') = ', IPR_OPNAME( NIPR, N ),
     &                ' of ', IPR_SPNAM( NIPR ) 
            END DO
         END DO
         WRITE( IOUT, 93000 ) 
         WRITE( IOUT, 93000 ) 
      END IF              

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  If not doing a partial IRR,  write a header and skip to the end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( .NOT. LPARTIRR ) THEN
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT
         IF ( LFULLIRR ) THEN 
            WRITE( IOUT, 93180 ) 
         ELSE
            WRITE( IOUT, 93200 )
         END IF
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT
         GO TO 999
      END IF 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write the section header for the partial IRR section
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LINOUT = CEES
      WRITE( IOUT, 93000 ) LINOUT
      WRITE( IOUT, 93220 )
      LINOUT = CEES
      WRITE( IOUT, 93000 ) LINOUT

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Find the longest reaction label length, right justify and save
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      MAXLEN = 0
      DO NRX = 1, NRXNS
         MAXLEN = MAX( MAXLEN, LEN_TRIM( RXLABEL( NRX ) ) )
      END DO
       
      DO NRX = 1, NRXNS
         DO N = 1, LABLEN
            RJLABL( NRX )( N:N ) = ' '
         END DO
         IS1 = LBLANK( RXLABEL( NRX ) ) + 1
         IE1 = LEN_TRIM( RXLABEL( NRX ) )
         LEN1 = IE1 - IS1 + 1
         IE2 = LABLEN
         IS2 = LABLEN - LEN1 + 1
         RJLABL( NRX )( IS2:IE2 ) = RXLABEL( NRX )( IS1:IE1 )       
      END DO

      SPOS = LABLEN - MAXLEN + 1

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Top of loop for doing each IRR_OUTPUT report
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO 540 NOUT = 1, NIRROUT
         WRITE( OUTLBL, '( I3 )' ) NOUT

c..Write the header for each output
         WRITE( IOUT, 93240 )
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT
         STRING( 1 ) = '   Summary of Input IRR Commands for OUTPUT'
         STRING( 2 ) = INT2CHR( NOUT )
         IEND = LEN_TRIM( STRING( 2 ) )
         STRING( 2 ) = STRING( 2 )( 1:IEND ) // ':'
         STRING( 3 ) = IRRNAME( NOUT )
         NUMSTRNGS = 3         
         CALL CATSTRING( NUMSTRNGS, STRING, LINOUT, LINLEN )
         WRITE( IOUT, 93000 ) LINOUT
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write the input IRR commands
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         WRITE( IOUT, 93140 )
         WRITE( IOUT, 93260 )
         WRITE( IOUT, 93140 )
         LINOUT = '       IRROUT(' // OUTLBL // ') = '
         IEND = LEN_TRIM( LINOUT ) + 1
         EQPOS1 = IEND
         DO 100 NTERM = 1, NIRRTERMS( NOUT )

            CALL DOCOEFF( OUTSC( NOUT,NTERM ), COUT )
            IF ( NTERM .EQ. 1 .AND. OUTSC( NOUT,NTERM ) .GT. 0.0 )
     &            COUT( 1:1 ) = ' '
            LINOUT = LINOUT( 1:EQPOS1 ) // COUT
            IEND = EQPOS1 + 12
            TYPE = OUTTYPE( NOUT,NTERM )
            E1 = MIN( LEN_TRIM( OUTSPEC1( NOUT,NTERM ) ), 6 )
            E2 = MIN( LEN_TRIM( OUTSPEC2( NOUT,NTERM ) ), 6 )
            E3 = MIN( LEN_TRIM( OUTSPEC3( NOUT,NTERM ) ), 6 )

            IF ( TYPE .EQ. 'NAME' ) THEN

               LINOUT = LINOUT( 1:IEND ) // OUTSPEC1( NOUT, NTERM )
               IEND = LEN_TRIM( LINOUT )
               IF ( OUTPNFLAG( NOUT,NTERM ) .EQ. 'POSONLY' ) THEN
                  LINOUT = LINOUT( 1:IEND ) // '[POSONLY]'
               ELSE IF ( OUTPNFLAG( NOUT,NTERM ) .EQ. 'NEGONLY' ) THEN
                  LINOUT = LINOUT( 1:IEND ) // '[NEGONLY]'
               END IF

            ELSE IF ( TYPE .EQ. 'PROD' .OR. TYPE .EQ. 'NETP' ) THEN

               OPNAM = TYPE
               LINOUT = LINOUT( 1:IEND ) // OPNAM // ' [' //
     &                  OUTSPEC1( NOUT,NTERM )( 1:E1 ) // ']'
               IEND   = LEN_TRIM( LINOUT )
               IF ( OUTSPEC2( NOUT,NTERM ) .NE. '' ) THEN
                  LINOUT = LINOUT( 1:IEND ) // ' FROM [' //
     &                     OUTSPEC2( NOUT,NTERM )( 1:E2 ) // ']'
                  IEND   = LEN_TRIM( LINOUT )
               END IF
               IF ( OUTSPEC3( NOUT,NTERM ) .NE. '' ) THEN
                  IF ( OUTOP2( NOUT,NTERM ) .EQ. 'AND' ) THEN
                     LINOUT = LINOUT( 1:IEND ) // ' AND [' //
     &                        OUTSPEC3( NOUT,NTERM )( 1:E3 ) // ']'
                  ELSE
                     LINOUT = LINOUT( 1:IEND ) // ' OR [' //
     &                        OUTSPEC3( NOUT,NTERM )( 1:E3 ) // ']'
                  END IF
                  IEND = LEN_TRIM( LINOUT )
               END IF

            ELSE IF ( TYPE .EQ. 'LOSS' .OR. TYPE .EQ. 'NETL' ) THEN

               OPNAM = TYPE
               LINOUT = LINOUT( 1:IEND ) // OPNAM // ' [' //
     &                  OUTSPEC1( NOUT,NTERM )( 1:E1 ) // ']'
               IEND = LEN_TRIM( LINOUT )
               IF ( OUTSPEC3( NOUT,NTERM ) .NE. '' ) THEN
                  IF ( OUTOP2( NOUT,NTERM ) .EQ. 'AND' ) THEN
                     LINOUT = LINOUT( 1:IEND ) // ' AND [' //
     &                        OUTSPEC3( NOUT,NTERM )( 1:E3 ) // ']'
                  ELSE
                     LINOUT = LINOUT( 1:IEND ) // ' OR [' //
     &                        OUTSPEC3( NOUT,NTERM )( 1:E3 ) // ']'
                  END IF
                  IEND = LEN_TRIM( LINOUT )
               END IF

            ELSE IF ( TYPE .EQ. 'NET' ) THEN

               OPNAM = TYPE
               LINOUT = LINOUT( 1:IEND ) // OPNAM // ' [' //
     &                  OUTSPEC1( NOUT,NTERM )( 1:E1 ) // ']'
               IEND = LEN_TRIM( LINOUT )

            ELSE IF ( TYPE .EQ. 'RXN' ) THEN

               INDX = OUTRN( NOUT,NTERM )
               LINOUT = LINOUT( 1:IEND ) // 'IRR<' //
     &                  RJLABL( INDX )( SPOS:LABLEN ) // '>'
            END IF

            WRITE( IOUT, 93000 ) LINOUT
            LINOUT = '      &'
            LINOUT = LINOUT( 1:EQPOS1 )

100      CONTINUE
         WRITE( IOUT, 93140 )
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT   

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write the descriptions for any families referenced
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NOUTFAMS( NOUT ) .GT. 0 ) THEN
            WRITE( IOUT, 93140 )
            WRITE( IOUT, 93280 )
            DO NFAM = 1, NOUTFAMS( NOUT )
               INDX = OUTFAMS( NOUT,NFAM )
               DO N = 1, FAMNUMLNS( INDX )
                  WRITE( IOUT, 93000 ) FAMLINE( INDX,N )
               END DO
               WRITE( IOUT, 93140 ) 
            END DO
            LINOUT = CEES
            WRITE( IOUT, 93000 ) LINOUT
         END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Output descriptions of all cycles referenced
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NOUTCYCS( NOUT ) .GT. 0 ) THEN
            WRITE( IOUT, 93140 )
            WRITE( IOUT, 93300 )
            DO 200 N = 1, NOUTCYCS( NOUT )
               NCYC = OUTCYCS( NOUT,N )

c..Write the cycle name
               STRING( 1 ) = 'c..CYCLE'
               STRING( 2 ) = INT2CHR( NCYC )
               IEND = LEN_TRIM( STRING( 2 ) )
               STRING( 2 ) = STRING( 2 )( 1:IEND )
               STRING( 3 ) = CYCLNAME( NCYC )
               NUMSTRNGS = 3         
               CALL CATSTRING( NUMSTRNGS, STRING, LINOUT, LINLEN )
               WRITE( IOUT, 93000 ) LINOUT

c..Write reactions used in the cycle
               WRITE( LABL, '( I3 )' ) NCYC
               LINOUT = '      CYSM(' // LABL // ') ='
               IEND = LEN_TRIM( STRING( 2 ) )

               IF ( NCYTERMS( NCYC ) .EQ. 0 ) THEN
                  LINOUT = LINOUT( 1:IEND ) // ' 0.0'
                  WRITE( IOUT, 93000 ) LINOUT
               ELSE
                  WRITE( IOUT, 93000 ) LINOUT
                  DO NTERM = 1, NCYTERMS( NCYC )
                     INDX = CYRXNUM( NCYC,NTERM )
                     CALL DOCOEFF( CYSC( NCYC,NTERM ), COUT )
                     LINOUT = MECLINE( INDX,1 )
                     LINOUT( 9:19 ) = COUT
                     WRITE( IOUT, 93000 ) LINOUT
                     IF ( MECNUMLNS( INDX ) .GT. 1 ) THEN
                        DO NLN = 2, MECNUMLNS( INDX )
                           WRITE( IOUT, 93000 ) MECLINE( INDX,NLN )
                        END DO
                     END IF
                  END DO
                  WRITE( IOUT, 93140 )
               END IF

200         CONTINUE
            LINOUT = CEES
            WRITE( IOUT, 93000 ) LINOUT
         END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Output descriptions of all reaction sums referenced
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NOUTRXSUMS( NOUT ) .GT. 0 ) THEN
            WRITE( IOUT, 93140 )
            WRITE( IOUT, 93320 )
            DO 300 N = 1, NOUTRXSUMS( NOUT )
               NRX = OUTRXSUMS( NOUT,N )

c..Write the reaction sum name
               STRING( 1 ) = 'c..RXSUM'
               STRING( 2 ) = INT2CHR( NRX )
               IEND = LEN_TRIM( STRING( 2 ) )
               STRING( 2 ) = STRING( 2 )( 1:IEND )
               STRING( 3 ) = RXSUMNAME( NRX )
               NUMSTRNGS = 3         
               CALL CATSTRING( NUMSTRNGS, STRING, LINOUT, LINLEN )
               WRITE( IOUT, 93000 ) LINOUT

c..Write reactions used in the reaction sum
               WRITE( LABL, '( I3 )' ) NRX
               LINOUT = '      RXSM(' // LABL // ') ='
               WRITE( IOUT, 93000 ) LINOUT
               IEND = LEN_TRIM( STRING( 2 ) )

               IF ( NRXTERMS( NRX ) .EQ. 0 ) THEN
                  LINOUT = LINOUT( 1:IEND ) // ' 0.0'
                  WRITE( IOUT, LINOUT )
               ELSE
                  DO NTERM = 1, NRXTERMS( NRX )
                     INDX = RXSUMRN( NRX,NTERM )
                     CALL DOCOEFF( RXNSC( NRX,NTERM ), COUT )
                     LINOUT = MECLINE( INDX,1 )
                     LINOUT( 9:19 ) = COUT
                     WRITE( IOUT, 93000 ) LINOUT
                     IF ( MECNUMLNS( INDX ) .GT. 1 ) THEN
                        DO NLN = 2, MECNUMLNS( INDX )
                           WRITE( IOUT, 93000 ) MECLINE( INDX,NLN )
                        END DO
                     END IF
                  END DO
               END IF 
               WRITE( IOUT, 93140 )
300         CONTINUE
            LINOUT = CEES
            WRITE( IOUT, 93000 ) LINOUT
         END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Before doing operators, flag all reactions included in cycles for
c  elimination from production/loss/net operators 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         DO NRX = 1, NRXNS
            LRXINC( NRX ) = .TRUE.
         END DO

         IF ( NOUTCYCS( NOUT ) .GT. 0 ) THEN
            DO N = 1, NOUTCYCS( NOUT )
               NCYC = OUTCYCS( NOUT, N )
               DO NTERM = 1, NCYTERMS( NCYC )
                  INDX = CYRXNUM( NCYC, NTERM )
                  LRXINC( INDX ) = .FALSE.
               END DO
            END DO
         END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Output descriptions of production/loss/net operator
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NOUTOPS( NOUT ) .GT. 0 ) THEN
            WRITE( IOUT, 93140 )
            WRITE( IOUT, 93340 )
            NPROD = 0
            NNPRD = 0
            NLOSS = 0
            NNLOS = 0
            NNETR = 0
            DO 400 NTERM = 1, NIRRTERMS( NOUT )

               TYPE = OUTTYPE( NOUT,NTERM ) 

               IF ( TYPE .NE. 'NAME' .AND. TYPE .NE. 'RXN' ) THEN             

                  CALL GETRXNS( NOUT, NTERM, NR, RXNUMS, COEFFS, LRXINC )

c..Write the operator description
                  IF ( TYPE .EQ. 'PROD' ) THEN
                     STRING( 1 ) = 'c..Production of'
                     OPNAM = 'PROD'
                     NPROD = NPROD + 1
                     WRITE( LABL, '( I3 )' ) NPROD
                  ELSE IF ( TYPE .EQ. 'NETP' ) THEN
                     STRING( 1 ) = 'c..Net production of'
                     OPNAM = 'NPRD'
                     NNPRD = NNPRD + 1
                     WRITE( LABL, '( I3 )' ) NNPRD
                  ELSE IF ( TYPE .EQ. 'LOSS' ) THEN
                     STRING( 1 ) = 'c..Loss of'
                     OPNAM = 'LOSS'
                     NLOSS = NLOSS + 1
                     WRITE( LABL, '( I3 )' ) NLOSS
                  ELSE IF ( TYPE .EQ. 'NETL' ) THEN
                     STRING( 1 ) = 'c..Net loss of'
                     OPNAM = 'NLOS'
                     NNLOS = NNLOS + 1
                     WRITE( LABL, '( I3 )' ) NNLOS
                  ELSE IF ( TYPE .EQ. 'NET' ) THEN
                     STRING( 1 ) = 'c..Net reaction of'
                     OPNAM = 'NETR'
                     NNETR = NNETR + 1
                     WRITE( LABL, '( I3 )' ) NNETR
                  END IF

                  SAVOP( NTERM ) = OPNAM
                  SAVLBL( NTERM ) = LABL

                  STRING( 2 ) = OUTSPEC1( NOUT,NTERM )
                  NUMSTRNGS = 2

                  IF ( OUTSPEC2( NOUT,NTERM ) .NE. '' ) THEN
                     STRING( 3 ) = 'from'
                     STRING( 4 ) = OUTSPEC2( NOUT,NTERM )
                     NUMSTRNGS = 4
                  END IF                  

                  IF ( OUTSPEC3( NOUT,NTERM ) .NE. '' ) THEN
                     IF ( OUTOP2( NOUT,NTERM ) .EQ. 'AND' ) THEN
                        STRING( NUMSTRNGS + 1 ) = 'and'
                     ELSE
                        STRING( NUMSTRNGS + 1 ) = 'or'
                     END IF
                     STRING( NUMSTRNGS + 2 ) = OUTSPEC3( NOUT,NTERM )
                     NUMSTRNGS = NUMSTRNGS + 2
                  END IF

                  CALL CATSTRING( NUMSTRNGS, STRING, LINOUT, LINLEN )
                  IEND = LEN_TRIM( LINOUT )
                  WRITE( IOUT, 93000 ) LINOUT

c..Write reactions used in the operator
                           !123456     7890      1     234      567
                  LINOUT = '      ' // OPNAM // '(' // LABL // ') ='
                  IEND = LEN_TRIM( LINOUT )   ! = 17
                  IF ( NR .LE. 0 ) THEN
                     LINOUT = LINOUT( 1:IEND ) // ' 0.0'
                     WRITE( IOUT, 93000 ) LINOUT                  
                  ELSE
                     WRITE( IOUT, 93000 ) LINOUT
                     DO N = 1, NR
                        INDX = RXNUMS( N )
                        CALL DOCOEFF( COEFFS( N ), COUT )
                        LINOUT = MECLINE( INDX,1 )
                        LINOUT( 9:19 ) = COUT
                        WRITE( IOUT, 93000 ) LINOUT
                        IF ( MECNUMLNS( INDX ) .GT. 1 ) THEN
                           DO NLN = 2, MECNUMLNS( INDX )
                              WRITE( IOUT, 93000 ) MECLINE( INDX,NLN )
                           END DO
                        END IF
                     END DO
                  END IF
                  WRITE( IOUT, 93140 )
               END IF
400         CONTINUE 
            LINOUT = CEES
            WRITE( IOUT, 93000 ) LINOUT
         END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Output list of all reactions referenced in the OUTPUT command
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NOUTRXN( NOUT ) .GT. 0 ) THEN
            WRITE( IOUT, 93140 )
            WRITE( IOUT, 93360 )
            IF ( NOUTRXN( NOUT ) .GT. 0 ) THEN
               DO NTERM = 1, NIRRTERMS( NOUT )
                  TYPE = OUTTYPE( NOUT,NTERM ) 
                  IF ( TYPE .EQ. 'RXN' ) THEN
                     INDX = OUTRN( NOUT,NTERM )
                     LINOUT = MECLINE( INDX, 1 )
                     LINOUT( 6:6 ) = ' '
                     WRITE( IOUT, 93000 ) LINOUT
                     IF ( MECNUMLNS( INDX ) .GT. 1 ) THEN
                        DO NLN = 2, MECNUMLNS( INDX )
                           WRITE( IOUT, 93000 ) MECLINE( INDX,NLN )
                        END DO
                     END IF
                  END IF
               END DO
            END IF
            WRITE( IOUT, 93140 )
            LINOUT = CEES
            WRITE( IOUT, 93000 ) LINOUT
         END IF           

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write the pseudocode for IRROUT
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         STRING( 1 ) = '   Pseudocode for OUTPUT'
         STRING( 2 ) = INT2CHR( NOUT )
         IEND = LEN_TRIM( STRING( 2 ) )
         STRING( 2 ) = STRING( 2 )( 1:IEND ) // ':'
         STRING( 3 ) = IRRNAME( NOUT )
         NUMSTRNGS = 3         
         CALL CATSTRING( NUMSTRNGS, STRING, LINOUT, LINLEN )
         WRITE( IOUT, 93000 ) LINOUT
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT

c..Write the pseudocode for the initialization terms
         LINITFLG = .FALSE.
         LFIRST = .TRUE.
         DO 500  NTERM = 1, NIRRTERMS( NOUT )
            PNFLG = OUTPNFLAG( NOUT,NTERM )

            IF ( PNFLG .NE. '' ) THEN
               LINITFLG = .TRUE.
               TYPE = OUTS1TYP( NOUT,NTERM )
               WRITE( LABL, '( I3 )' ) OUTS1NUM( NOUT,NTERM )
               IF ( LFIRST ) THEN
                  LINOUT = '      IRROUT(' // OUTLBL // ') = 0.0' 
                  WRITE( IOUT, 93000 ) LINOUT
                  WRITE( IOUT, 93000 )
                  LFIRST = .FALSE.
               END IF

               IF ( TYPE .EQ. 'CYCL' ) THEN
                  OPNAM = 'CYSM'
               ELSE
                  OPNAM = 'RXSM'
               END IF

               CALL DOCOEFF( OUTSC( NOUT,NTERM ), COUT )
               IF ( ABS( OUTSC( NOUT,NTERM ) ) .NE. 1.0 ) THEN
                  E1 = 11
               ELSE
                  E1 = 1
               END IF      

               IF ( PNFLG .EQ. 'POSONLY' ) THEN
                  LINOUT = '      IF ( ' // OPNAM // '(' // LABL // 
     &                     ') .GT. 0.0 ) THEN'
               ELSE
                  LINOUT = '      IF ( ' // OPNAM // '(' // LABL // 
     &                     ') .LT. 0.0 ) THEN'
               END IF

               WRITE( IOUT, 93000 ) LINOUT
               IF ( PNFLG .EQ. 'POSONLY' ) THEN
                  LINOUT = '         IRROUT(' // OUTLBL // 
     &                     ') = IRROUT(' // OUTLBL // ') ' //
     &                     COUT( 1:E1 ) // ' ' // OPNAM  //
     &                    '(' // LABL // ')'
               ELSE
                  LINOUT = '         IRROUT(' // OUTLBL //
     &                     ') = IRROUT(' // OUTLBL // ') ' //
     &                     COUT( 1:E1 ) // ' ABS('  // OPNAM //
     &                     '(' // LABL // '))'
               END IF

               WRITE( IOUT, 93000 ) LINOUT
               LINOUT = '      END IF'
               WRITE( IOUT, 93000 ) LINOUT
               WRITE( IOUT, 93000 )
            END IF

500      CONTINUE               

c..Write the final equation for the output integrated reaction rates
         IF ( NIRRTERMS( NOUT ) .EQ. 0 ) THEN
            LINOUT = '       IRROUT(' // OUTLBL // ') = 0.0'
            WRITE( IOUT, 93000 ) LINOUT
         ELSE
            ICOUNT = 0
            DO 520 NTERM = 1, NIRRTERMS( NOUT )
               IF ( NTERM .EQ. 1 ) THEN
                  LINOUT = '      IRROUT(' // OUTLBL // ') = '
                  EQPOS1 = LEN_TRIM( LINOUT ) 
                  IF ( LINITFLG ) THEN
                     LINOUT = LINOUT( 1:EQPOS1 ) // ' IRROUT(' //
     &                        OUTLBL // ')'
                     WRITE( IOUT, 93000 ) LINOUT
                     LINOUT ='     &'
                     LINOUT = LINOUT( 1:EQPOS1 )
                     ICOUNT = ICOUNT + 1
                  END IF 
               ELSE
                  LINOUT ='     &'
                  LINOUT = LINOUT( 1:EQPOS1 )
               END IF

               TYPE = OUTTYPE( NOUT,NTERM )
               IF ( TYPE .EQ. 'NAME' ) TYPE = OUTS1TYP( NOUT,NTERM ) 
               PNFLG = OUTPNFLAG( NOUT,NTERM )

               IF ( PNFLG .EQ. 'POSONLY' .OR. PNFLG .EQ. 'NEGONLY' )
     &             GO TO 520
               IF ( TYPE .EQ. 'CYCL' .AND. PNFLG .EQ. '' ) THEN
                  OPNAM = 'CYSM'
                  WRITE( LABL, '( I3 )' ) OUTS1NUM( NOUT,NTERM )
               ELSE IF ( TYPE .EQ. 'RXSM' .AND. PNFLG .EQ. '' ) THEN
                  OPNAM = 'RXSM'
                  WRITE( LABL, '( I3 )' ) OUTS1NUM( NOUT,NTERM )
               ELSE IF ( TYPE .EQ. 'RXN' ) THEN
                  OPNAM = ' IRR' 
                  INDX = OUTRN( NOUT,NTERM )
               ELSE
                  OPNAM = SAVOP( NTERM )
                  LABL  = SAVLBL( NTERM )
               END IF

               CALL DOCOEFF( OUTSC( NOUT,NTERM ), COUT )
               ICOUNT = ICOUNT + 1
               IF ( OUTSC( NOUT,NTERM ) .GT. 0.0 .AND. ICOUNT .EQ. 1 ) 
     &              COUT( 1:1 ) = ' '
               IF ( TYPE .EQ. 'RXN' ) THEN
                  LINOUT = LINOUT( 1:EQPOS1 ) // COUT // ' ' // 
     &                     OPNAM // '<'  // 
     &                     RJLABL( INDX )( SPOS:LABLEN ) // '>'
               ELSE
                  LINOUT = LINOUT( 1:EQPOS1 ) // COUT // ' ' // 
     &                     OPNAM // '(' // LABL( 1:3 ) // ')'
               END IF
               WRITE( IOUT, 93000 ) LINOUT
520         CONTINUE
         END IF
540   CONTINUE

999   CONTINUE
    
      WRITE( IOUT, 93380 ) 
      CLOSE( IOUT )
      RETURN
      
C----------------------- Format Statements -----------------------------
93000 FORMAT( A )

93020 FORMAT( //'============ Process Analysis Control Module Output', 
     &        ' Report ============'/18X, 'Created  ', A/ )

!3040 FORMAT( ' ', 24X, 'OUTPUT DOMAIN SECTION'/
!    &        '   Process Monitoring and IRR outputs will be generated', 
!    &        ' for the'/
!    &        '   following cells relative to the full modeling domain.' )
!3060 FORMAT( '       Starting column:', I4/
!    &        '       Ending column:  ', I4/
!    &        '       Starting row:   ', I4/
!    &        '       Ending row:     ', I4/ 
!    &        '       Starting layer: ', I4/
!    &        '       Ending layer:   ', I4 ) 

93080 FORMAT( 20X, 'Integrated Process Rate Section'/
     &        '   No requests for IPR outputs were included', 
     &        ' in the command file.' )

93100 FORMAT( 20X, 'Integrated Process Rate Section'/
     &        '   The following section lists the IPR ', 
     &        'outputs generated from the'/
     &        '   command file inputs.' )

93120 FORMAT( ' '/
     &        '   The referenced families are defined as follows:'/
     &        ' ' )
93140 FORMAT( ' ' )
93180 FORMAT( 20X, 'Integrated Reaction Rate Section'/
     &        '   A FULL IRR analysis has been requested. Each reaction', 
     &          ' rate will be'/
     &        '   integrated individually and output for the',
     &          ' specified domain.' )
93200 FORMAT( 20X, 'Integrated Reaction Rate Section'/
     &        '   No requests for IRR analysis were included in the', 
     &        ' command file.' )
93220 FORMAT( 20X, 'Integrated Reaction Rate Section'/
     &        '   The following section gives a symbolic representation', 
     &        ' of how the'/
     &        '   PARTIAL IRR outputs are calculated given the commands', 
     &        ' that were'/
     &        '   included in the command file. The report includes', 
     &        ' pseudocode showing'/
     &        '   how individual integrated reactions rates are', 
     &        ' combined to produce the '/
     &        '   requested output.  In the pseudocode that follows'/
     &        ' '/
     &        '         IRR< x > = the integrated reaction rate for '/
     &        '                    the reaction with label x as '/
     &        '                    defined in the chemical mechanism'/
     &        ' '/
     &        '         IRROUT( n ) = the nth integrated reaction rate'/
     &        '                       output that was requested'/
     &        ' ' )  
93240 FORMAT( //1X )
93260 FORMAT( '   The IRR_OUTPUT command was specified as follows:' )
93280 FORMAT( '   The referenced families are defined as follows:'/' ' )
93300 FORMAT( '   The referenced cycles are defined as follows:'/' ' )
93320 FORMAT( '   The referenced reaction sums are defined as follows:'/
     &        ' ' )
93340 FORMAT( '   The referenced operators are defined as follows:'/' ' )
93360 FORMAT( '   The following reactions are referenced individually:'/
     &        ' ' )
93380 FORMAT( ///'========= End of Process Analysis Control Module', 
     &         ' Output Report ========='  )  
C-----------------------------------------------------------------------

      CONTAINS

         SUBROUTINE DOCOEFF( COEF, COUT )

C-----------------------------------------------------------------------
C Function: Transform a coefficient from numerical to character form for
C           output reports   
C-----------------------------------------------------------------------

         IMPLICIT NONE
      
C Arguments:
         REAL    COEF              ! Coefficient for output term 
         CHARACTER( * ) :: COUT    ! Output coefficient
                                        
C Local Variables
         INTEGER N   ! Loop index
         
C-----------------------------------------------------------------------

         DO N = 1, LEN( COUT )
            COUT( N:N ) = ' '
         END DO

         IF ( ABS( COEF ) .NE. 1.0 ) THEN
            WRITE( COUT, '( 2X, F7.4 )' ) ABS( COEF )
            COUT( 11:11 ) = '*'
         END IF   

         IF ( COEF .GE. 0.0 ) THEN
            COUT( 1:1 ) = '+'
         ELSE
            COUT( 1:1 ) = '-'
         END IF

         RETURN 

         END SUBROUTINE DOCOEFF

         FUNCTION INT2CHR( NOUT ) RESULT( INTSTR )

C-----------------------------------------------------------------------
C Function: Convert an integer number into character representation
C           that is left justified in a string 
C-----------------------------------------------------------------------
         USE UTILIO_DEFN

         IMPLICIT NONE
      
C Arguments:
         INTEGER NOUT               ! Integer number to convert
         CHARACTER( 10 ) :: INTSTR  ! string holder

C Local Variables:
         INTEGER EPOS1         ! Ending positions
         INTEGER SPOS1         ! Starting positions
         INTEGER LEN1          ! Length of string
         INTEGER N             ! Loop index
C-----------------------------------------------------------------------

         WRITE( INTSTR, '( I10 )' ) NOUT
         DO N = 1, 10
            INTSTR( N:N ) = ' '
         END DO

c..Left justify the numeric string
         SPOS1 = LBLANK( INTSTR ) + 1
         EPOS1 = LEN_TRIM( INTSTR )
         LEN1 = EPOS1 - SPOS1 + 1
         INTSTR( 1:LEN1 ) = INTSTR( SPOS1:EPOS1 )

         RETURN
         END FUNCTION INT2CHR

      END SUBROUTINE PA_REPORT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !!
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       MODULE AEROSOL_CHEMISTRY
!-----------------------------------------------------------------------
! Revision history
!
! 26 Sep 14 H. Pye: Heterogeneous uptake of IEPOX added 
! 27 Feb 15 J. Bash:
! 17 March 15 D. Luecken:  Added NTR heterogeneous hydrolysis as per
!    the CB6r3 chemical mechanism used by the Environ CAMX model consult 
!    references 8 and 9., 
! 22 Feb 16 B.Hutzell: Added Flag stating whether module is initialized
! 24 March 16 D. Luecken: removed the references to F_NTR2_ON so that all 
!  nitrates have the potential to partition to aerosol.  
! 24 Mar 16 G. Sarwar: Added heterogeneous uptake of BRONO2 on aerosols
! 10 May 16 H. Pye: Merged with AEROSOL_CHEMISTRY.F from aero6i
!                   Size of NAMES_AERO_RATES reduced to match RXN_DATA_MODULE
!    May 16 H. Pye, B. Murphy: Updated treatment of aerosol moments
! 23 May 16 D. Wong: Allow for calculation for APMDIAG even if PMDIAG is turned off.
! 10 Jun 16 B.Hutzell: reduce occurrences of numerical underflow
! 17 Jul 18 G. Sarwar: Added heterogeneous uptakes of CLNO3, bromine and iodine species
! 01 Feb 19 David Wong: removed MY_N clauses
! 03 Apr 19 H. Pye: Updated IEPOX to consume inorganic sulfate when OS are formed
! 11 Dec 20 G. Sarwar: Removed unused uptake cofficients and added few uptake cofficients for halogen species
! 23 Jun 21 G. Sarwar: Replaced CB6R3M with CB6R5M
! 24 Sep 26 G. Sarwar: Added photolysis of aerosol nitrate
!-----------------------------------------------------------------------

       IMPLICIT NONE
       
       REAL( 8 ), ALLOCATABLE :: KHETERO( :,:,:,: ) ! heterogeneous rx rates, 
                                                    ! [ppm**(RXN Order-1)*min]**-1
     
       PUBLIC  KHETERO, HETCHEM_RATES
       
       PRIVATE 

       INTEGER, PARAMETER :: NUMB_AERO_RATES = 59
       
       CHARACTER( 16 ), PARAMETER :: NAMES_AERO_RATES( NUMB_AERO_RATES ) = 
     &                    (/ 'HETERO_N2O5IJ   ', 'HETERO_N2O5K    ', 
     &                       'HETERO_N2O5IJY  ', 'HETERO_N2O5KY   ', 
     &                       'HETERO_NO2      ', 'HETERO_H2NO3PAIJ',
     &                       'HETERO_H2NO3PBIJ', 'HETERO_H2NO3PAK ',
     &                       'HETERO_H2NO3PBK ', 'HETERO_H2NO3PAI ',
     &                       'HETERO_H2NO3PBI ', 'HETERO_H2NO3PAJ ',
     &                       'HETERO_H2NO3PBJ ', 'HETERO_N2O5I    ',
     &                       'HETERO_N2O5J    ', 'HETERO_PNCOMLI  ',
     &                       'HETERO_PNCOMLJ  ', 'HETERO_IEPOX    ',
     &                       'HETERO_TETROL   ', 'HETERO_IEPOXOS  ',
     &                       'HETERO_TETROLDIM', 'HETERO_IEPOXOSDI',
     &                       'HETERO_IMAE     ', 'HETERO_2MG      ',
     &                       'HETERO_IMAEOS   ', 'HETERO_NO3      ',
     &                       'HETERO_GLY      ', 'HETERO_MGLY     ',
     &                       'HETERO_NTR2     ', 'HETERO_CLNO3_WAI',
     &                       'HETERO_CLNO3_WAJ', 'HETERO_HBR_BRJ  ',
     &                       'HETERO_BRNO3_WAI', 'HETERO_BRNO3_WAJ',
     &                       'HETERO_HOBR_CLJ ', 'HETERO_HOBR_BRJ ',
     &                       'HETERO_BRNO3_CLJ', 'HETERO_BRNO3_BRJ',
     &                       'HETERO_BRNO2_CLJ', 'HETERO_BRNO2_BRJ',
     &                       'HETERO_I2O2_AI  ', 'HETERO_I2O2_AJ  ',
     &                       'HETERO_I2O3_AI  ', 'HETERO_I2O3_AJ  ',
     &                       'HETERO_I2O4_AI  ', 'HETERO_I2O4_AJ  ',
     &                       'HETERO_INO3_CLJ ', 'HETERO_INO3_BRJ ',
     &                       'HETERO_INO2_CLJ ', 'HETERO_INO2_BRJ ',
     &                       'HETERO_HOI_CLJ  ', 'HETERO_HOI_BRJ  ',
     &                       'HETERO_ISO3NOSJ ', 'HETERO_ISO3OSJ  ',
     &                       'HETERO_HO2      ', 'HETERO_ANO3     ',
     &                       'HETERO_HFPODAF  ', 'HETERO_COF2     ',
     &                       'HETERO_PFMOAF   '/)

       INTEGER, PARAMETER  :: IA_N2O5IJ         =   1
       INTEGER, PARAMETER  :: IA_N2O5K          =   2
       INTEGER, PARAMETER  :: IA_N2O5IJY        =   3
       INTEGER, PARAMETER  :: IA_N2O5KY         =   4
       INTEGER, PARAMETER  :: IA_NO2            =   5
       INTEGER, PARAMETER  :: IA_H2NO3PAIJ      =   6
       INTEGER, PARAMETER  :: IA_H2NO3PBIJ      =   7
       INTEGER, PARAMETER  :: IA_H2NO3PAK       =   8
       INTEGER, PARAMETER  :: IA_H2NO3PBK       =   9
       INTEGER, PARAMETER  :: IA_H2NO3PAI       =   10
       INTEGER, PARAMETER  :: IA_H2NO3PBI       =   11
       INTEGER, PARAMETER  :: IA_H2NO3PAJ       =   12
       INTEGER, PARAMETER  :: IA_H2NO3PBJ       =   13
       INTEGER, PARAMETER  :: IA_N2O5I          =   14
       INTEGER, PARAMETER  :: IA_N2O5J          =   15
       INTEGER, PARAMETER  :: IA_PNCOMLI        =   16
       INTEGER, PARAMETER  :: IA_PNCOMLJ        =   17
       INTEGER, PARAMETER  :: IA_IEPOX          =   18
       INTEGER, PARAMETER  :: IA_TETROL         =   19
       INTEGER, PARAMETER  :: IA_IEPOXOS        =   20
       INTEGER, PARAMETER  :: IA_TETROLDIM      =   21
       INTEGER, PARAMETER  :: IA_IEPOXOSDI      =   22
       INTEGER, PARAMETER  :: IA_IMAE           =   23
       INTEGER, PARAMETER  :: IA_2MG            =   24
       INTEGER, PARAMETER  :: IA_IMAEOS         =   25
       INTEGER, PARAMETER  :: IA_NO3            =   26
       INTEGER, PARAMETER  :: IA_GLY            =   27
       INTEGER, PARAMETER  :: IA_MGLY           =   28
       INTEGER, PARAMETER  :: IA_NTR2           =   29
       INTEGER, PARAMETER  :: IA_CLNO3_WAI      =   30
       INTEGER, PARAMETER  :: IA_CLNO3_WAJ      =   31
       INTEGER, PARAMETER  :: IA_HBR_BRJ        =   32
       INTEGER, PARAMETER  :: IA_BRNO3_WAI      =   33
       INTEGER, PARAMETER  :: IA_BRNO3_WAJ      =   34
       INTEGER, PARAMETER  :: IA_HOBR_CLJ       =   35
       INTEGER, PARAMETER  :: IA_HOBR_BRJ       =   36
       INTEGER, PARAMETER  :: IA_BRNO3_CLJ      =   37
       INTEGER, PARAMETER  :: IA_BRNO3_BRJ      =   38
       INTEGER, PARAMETER  :: IA_BRNO2_CLJ      =   39
       INTEGER, PARAMETER  :: IA_BRNO2_BRJ      =   40
       INTEGER, PARAMETER  :: IA_I2O2_AI        =   41
       INTEGER, PARAMETER  :: IA_I2O2_AJ        =   42
       INTEGER, PARAMETER  :: IA_I2O3_AI        =   43
       INTEGER, PARAMETER  :: IA_I2O3_AJ        =   44
       INTEGER, PARAMETER  :: IA_I2O4_AI        =   45
       INTEGER, PARAMETER  :: IA_I2O4_AJ        =   46
       INTEGER, PARAMETER  :: IA_INO3_CLJ       =   47
       INTEGER, PARAMETER  :: IA_INO3_BRJ       =   48
       INTEGER, PARAMETER  :: IA_INO2_CLJ       =   49
       INTEGER, PARAMETER  :: IA_INO2_BRJ       =   50
       INTEGER, PARAMETER  :: IA_HOI_CLJ        =   51
       INTEGER, PARAMETER  :: IA_HOI_BRJ        =   52
       INTEGER, PARAMETER  :: IA_ISO3NOSJ       =   53
       INTEGER, PARAMETER  :: IA_ISO3OSJ        =   54
       INTEGER, PARAMETER  :: IA_HO2            =   55
       INTEGER, PARAMETER  :: IA_ANO3           =   56
       INTEGER, PARAMETER  :: IA_HFPODAF        =   57
       INTEGER, PARAMETER  :: IA_COF2           =   58
       INTEGER, PARAMETER  :: IA_PFMOAF         =   59


       INTEGER, PARAMETER :: INDEX_AERO_RATES( NUMB_AERO_RATES ) = 
     &                    (/ IA_N2O5IJ   , IA_N2O5K    , 
     &                       IA_N2O5IJY  , IA_N2O5KY   , 
     &                       IA_NO2      , IA_H2NO3PAIJ,
     &                       IA_H2NO3PBIJ, IA_H2NO3PAK ,
     &                       IA_H2NO3PBK , IA_H2NO3PAI ,
     &                       IA_H2NO3PBI , IA_H2NO3PAJ ,
     &                       IA_H2NO3PBJ , IA_N2O5I    , 
     &                       IA_N2O5J    , IA_PNCOMLI  ,
     &                       IA_PNCOMLJ  , IA_IEPOX    ,
     &                       IA_TETROL   , IA_IEPOXOS  ,
     &                       IA_TETROLDIM, IA_IEPOXOSDI,
     &                       IA_IMAE     , IA_2MG      ,
     &                       IA_IMAEOS   , IA_NO3      ,
     &                       IA_GLY      , IA_MGLY     ,
     &                       IA_NTR2     , IA_CLNO3_WAI,
     &                       IA_CLNO3_WAJ, IA_HBR_BRJ  ,
     &                       IA_BRNO3_WAI, IA_BRNO3_WAJ,
     &                       IA_HOBR_CLJ , IA_HOBR_BRJ ,
     &                       IA_BRNO3_CLJ, IA_BRNO3_BRJ,
     &                       IA_BRNO2_CLJ, IA_BRNO2_BRJ,
     &                       IA_I2O2_AI  , IA_I2O2_AJ  ,
     &                       IA_I2O3_AI  , IA_I2O3_AJ  ,
     &                       IA_I2O4_AI  , IA_I2O4_AJ  ,
     &                       IA_INO3_CLJ , IA_INO3_BRJ ,
     &                       IA_INO2_CLJ , IA_INO2_BRJ ,
     &                       IA_HOI_CLJ  , IA_HOI_BRJ  ,
     &                       IA_ISO3NOSJ , IA_ISO3OSJ  ,
     &                       IA_HO2      , IA_ANO3     ,
     &                       IA_HFPODAF  , IA_COF2     ,  
     &                       IA_PFMOAF    /)

       INTEGER               :: SELECTED_AERO_RATES
       INTEGER, ALLOCATABLE  :: WHICH_AERO_RATE( : )
       
C *** Molecular weight
      REAL( 8 ), SAVE        :: MWTIEPOX        ! molecular weight of IEPOX [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_IEPOX   ! factor used for the mean molecular speed of IEPOX [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTIMAE         ! molecular weight of IMAE [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_IMAE    ! factor used for the mean molecular speed of IMAE [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTNO3          ! molecular weight of NO3 [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_NO3     ! factor used for the mean molecular speed of NO3 [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTGLY          ! molecular weight of GLY [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_GLY     ! factor used for the mean molecular speed of GLY [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTMGLY         ! molecular weight of MGLY [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_MGLY    ! factor used for the mean molecular speed of MGLY [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTHFPODAF      ! molecular weight ofHFPODAF [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_HFPODAF ! factor used for the mean molecular speed of HFPOAF [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTCOF2         ! molecular weight of COF2 [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_COF2    ! factor used for the mean molecular speed of COF2 [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTPFMOAF       ! molecular weight of PFMOAF [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_PFMOAF  ! factor used for the mean molecular speed of PFMOAF [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTHO2          ! molecular weight of HO2 [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_HO2     ! factor used for the mean molecular speed of HO2 [m/(s^1*(deg K)^0.5)]

C *** 2nd and 3rd moments with wet species
      REAL( 8 ), ALLOCATABLE :: WET_M3( : ) ! WET_M3_I,  WET_M3_J, WET_M3_K   ! M3 w.H2O, svOA
      REAL( 8 ), ALLOCATABLE :: WET_M2( : ) ! WET_M2_I,  WET_M2_J, WET_M2_K   ! M2 w.H2O, svOA
      REAL( 8 ), ALLOCATABLE :: DE_WET( : ) ! DE_AT_WET, DE_AC_WET, DE_CO_WET ! Initial effective diameter w.H2O

C Isoprene product particle phase reaction rates (Eddingsaas et al. 2010) [1/(M^2 s)]
      REAL ( 8 ), PARAMETER :: K_H_WATER    = 9.0D-4
      REAL ( 8 ), PARAMETER :: K_H_NUC      = 2.0D-4
      REAL ( 8 ), PARAMETER :: K_H_SO4      = 8.83D-3 ! Piletic et al. 2013, Budisulistiorini et al. in prep
      REAL ( 8 ), PARAMETER :: K_HSO4_WATER = 1.31D-5
      REAL ( 8 ), PARAMETER :: K_HSO4_NUC   = 2.92D-6

C Acid catalyzed particle phase reactions
      TYPE ACID_CAT
         CHARACTER( 16 ) :: PARENT     ! gas-phase parent species
         CHARACTER( 16 ) :: NUC        ! aerosol-phase nucleophile that adds to epoxide ring
         CHARACTER( 16 ) :: ACID       ! acid that catalyzes epoxide ring opening
         INTEGER         :: IDX_ACID   ! array index for acid concentration
         INTEGER         :: IDX_REMOVE ! array index denoting whether to correct nucleophile for acid
         REAL( 8 )       :: KCHEM      ! particle phase rate constant [1/(M^2 s)]
         CHARACTER( 16 ) :: PROD       ! product of nucleophile+parent
      END TYPE ACID_CAT

C IEPOX uptake parameters 
      INTEGER, SAVE                       :: N_NUCPAIRS          ! NUMBER OF ACID/NUCLEOPHILE PAIRS 
      TYPE( ACID_CAT ), ALLOCATABLE, SAVE :: ACID_NUC_PAIRS( : )
      INTEGER, SAVE                       :: NUMVOC              ! number of VOCs treated (IEPOX, IMAE)

C IEPOX uptake parameters for standard AERO6 or AERO7 (condensed IEPOX SOA)
      INTEGER, PARAMETER       :: N_NUCPAIRS_AE = 6      ! NUMBER OF ACID/NUCLEOPHILE PAIRS 

C IEPOX uptake based on Eddingsaas et al. 2010 parameters with Piletic
C 2013 update for the organosulfate. Same as Pye et al. 2013
C implementation except dimers are not considered. 
      TYPE( ACID_CAT ), PARAMETER :: ACID_NUC_PAIRS_AE( N_NUCPAIRS_AE ) = (/
C                  Parent   Nucleophile     Acid     Acid    Remove   Rate Constant  Product
C                 (parent)    (nuc)        (acid)    Index   Index       (kchem)      (prod)
C                 --------  -----------  ----------  -----   ------   -------------  --------
     &   ACID_CAT('IEPOX',  'AH2OJ    ', 'HPLUS   ',   1,     0,       K_H_WATER,    'AISO3J' ),
     &   ACID_CAT('IEPOX',  'ASO4J    ', 'HPLUS   ',   1,     2,       K_H_SO4,      'AISO3J'  ),
     &   ACID_CAT('IEPOX',  'ANO3J    ', 'HPLUS   ',   1,     0,       K_H_NUC,      'AISO3J'  ),
     &   ACID_CAT('IEPOX',  'AH2OJ    ', 'HSO4    ',   2,     0,       K_HSO4_WATER, 'AISO3J' ),
     &   ACID_CAT('IEPOX',  'ASO4J    ', 'HSO4    ',   2,     2,       K_HSO4_NUC,   'AISO3J'  ),
     &   ACID_CAT('IEPOX',  'ANO3J    ', 'HSO4    ',   2,     0,       K_HSO4_NUC,   'AISO3J'  )/)

C IEPOX + MAE uptake parameters for AERO6i or AERO7i (explicit IEPOX SOA)
      INTEGER, PARAMETER :: N_NUCPAIRS_AEI = 12      ! NUMBER OF ACID/NUCLEOPHILE PAIRS

C IEPOX uptake following the implementation
C in Pye et al. 2013 ES&T base simulation except epoxide-derived organonitrates are no longer
C considered in saprc07tic_ae7i due to their predicted small contribution to ambient PM. In addition,
C oligomerization of MAE/HMML-derived aerosol is not considered also due to its predicted
C small contribution and desire to have the model "dimer" species be only IEPOX derived.
      TYPE( ACID_CAT ), PARAMETER :: ACID_NUC_PAIRS_AEI( N_NUCPAIRS_AEI ) = (/
C                  Parent   Nucleophile     Acid     Acid    Remove   Rate Constant  Product
C                 (parent)    (nuc)        (acid)    Index   Index       (kchem)      (prod)
C                 --------  -----------  ----------  -----   ------   -------------  --------
     &   acid_cat('IEPOX',  'AH2OJ    ', 'HPLUS   ',   1,     0,       k_H_water,    'AIETETJ' ),
     &   acid_cat('IEPOX',  'ASO4J    ', 'HPLUS   ',   1,     2,       k_H_SO4,      'AIEOSJ'  ),
     &   acid_cat('IEPOX',  'AIEOSJ   ', 'HPLUS   ',   1,     0,       k_H_nuc,      'ADIMJ'   ),
     &   acid_cat('IEPOX',  'AIETETJ  ', 'HPLUS   ',   1,     0,       k_H_nuc,      'ADIMJ'   ),
     &   acid_cat('IEPOX',  'AH2OJ    ', 'HSO4    ',   2,     0,       k_HSO4_water, 'AIETETJ' ),
     &   acid_cat('IEPOX',  'ASO4J    ', 'HSO4    ',   2,     2,       k_HSO4_nuc,   'AIEOSJ'  ),
     &   acid_cat('IEPOX',  'AIEOSJ   ', 'HSO4    ',   2,     0,       k_HSO4_nuc,   'ADIMJ'   ),
     &   acid_cat('IEPOX',  'AIETETJ  ', 'HSO4    ',   2,     0,       k_HSO4_nuc,   'ADIMJ'   ),
     &   acid_cat('IMAE',   'AH2OJ    ', 'HPLUS   ',   1,     0,       k_H_water,    'AIMGAJ'  ),
     &   acid_cat('IMAE',   'ASO4J    ', 'HPLUS   ',   1,     2,       k_H_nuc,      'AIMOSJ'  ),
     &   acid_cat('IMAE',   'AH2OJ    ', 'HSO4    ',   2,     0,       k_HSO4_water, 'AIMGAJ'  ),
     &   acid_cat('IMAE',   'ASO4J    ', 'HSO4    ',   2,     2,       k_HSO4_nuc,   'AIMOSJ'  )/)

C IEPOX uptake for CRACMM mechanism

        INTEGER, PARAMETER       :: N_NUCPAIRS_CRCM = 6      ! NUMBER OF ACID/NUCLEOPHILE PAIRS

        TYPE( ACID_CAT ), PARAMETER :: ACID_NUC_PAIRS_CRCM( N_NUCPAIRS_CRCM ) = (/

C                  Parent   Nucleophile     Acid     Acid    Remove  Rate Constant  Product
C                 (parent)    (nuc)        (acid)    Index   Index     (kchem)      (prod)
C                 --------  -----------  ----------  -----   ------  -------------  --------
     &   acid_cat('IEPOX',  'AH2OJ    ', 'HPLUS   ',   1,     0,       K_H_WATER,   'AISO3NOSJ' ),
     &   acid_cat('IEPOX',  'ASO4J    ', 'HPLUS   ',   1,     2,       K_H_SO4,     'AISO3OSJ'  ),
     &   acid_cat('IEPOX',  'ANO3J    ', 'HPLUS   ',   1,     0,       K_H_NUC,     'AISO3NOSJ' ),
     &   acid_cat('IEPOX',  'AH2OJ    ', 'HSO4    ',   2,     0,       K_HSO4_WATER,   'AISO3NOSJ' ),
     &   acid_cat('IEPOX',  'ASO4J    ', 'HSO4    ',   2,     2,       K_HSO4_NUC,     'AISO3OSJ'  ),
     &   acid_cat('IEPOX',  'ANO3J    ', 'HSO4    ',   2,     0,       K_HSO4_NUC,     'AISO3NOSJ' )/)


C Mapping array for location of acid enhanced products and nucleophiles in aerospc_conc 
      INTEGER, ALLOCATABLE, SAVE :: ACID_PRODMAP_IDX( : )
      INTEGER, ALLOCATABLE, SAVE ::  ACID_NUCMAP_IDX( : )

      CONTAINS

      SUBROUTINE HETCHEM_RATES( TEMP, PRESS, WVAPOR, CGRID, DENS )

c Calculates the heterogeneous reactions for N2O5, NO2, CLNO2, and IEPOX. 
c
c Key Subroutines Called: EXTRACT_AERO, EXTRACT_SOA, PATPAR
c                         N2O5_GAMMA
c
c 09/18/13 - B.Hutzell - initial version adapted from the hetchem.F file
c            in aero6 module of CMAQ version 5.01. The adaptation includes
c            heterogeneous nitryl chloride production used for Sarwar et al.
c            (2012).
c 09/12/14 - G. Sarwar - revised the heterogeneous nitryl chloride production
c 09/26/14 - H. Pye - Heterogeneous uptake of IEPOX on acidic aerosol added
c            following Pye et al. (2013).
c 10/01/14 - B.Hutzell - change STP value for N205 diffusivity based on
c            review paper: 1)   M. J. Tang, R. A. Cox, and M. Kalberer.
c            Compilation and evaluation of gas-phase diffusion coefficients 
c            of inorganic reactive trace gases in the atmosphere. Atmos. Chem.
c            Phys. Discuss., 14, 15645–15682, 2014. 
c            www.atmos-chem-phys-discuss.net/14/15645/2014/doi:10.5194/acpd-14-15645-2014.pdf
c 09/12/14 - G. Sarwar - revised the heterogeneous nitryl chloride production
C 10/01/14 - B.Hutzell - change STP value for N205 diffusivity based on
C            review paper: 1)   M. J. Tang, R. A. Cox, and M. Kalberer.
C            Compilation and evaluation of gas-phase diffusion coefficients 
C            of inorganic reactive trace gases in the atmosphere. Atmos. Chem.
C            Phys. Discuss., 14, 15645–15682, 2014. 
C            www.atmos-chem-phys-discuss.net/14/15645/2014/doi:10.5194/acpd-14-15645-2014.pdf
c 01/02/15 - H. Pye - Heterogeneous uptake of MAE added to saprc07tic_ae6i version
C            heterogeneous nitryl chloride production used for Sarwar et al.
c            (2012).
C 02/09/15 - B.Hutzell - corrected NO2 rate by a factor of two based consulting the stoiciometery for 
c            reaction published in Sarwar et al. (2008) and its analytical solution
C 05/06/2015 H Pye - Added NO3 heterogeneous reaction using low end of
C            range from Mao et al 2013 
C 06/2015    H Pye - Added SOA from GLY and MGLY uptake onto particles
C 09/2015    B.Hutzell - Added data and varaibles to calculate pseudo-first order rate constant 
C            for heterogeneous hydrolysis that converts organic nitrate to nitric acid. Both are
C            assumed gas phase species. The reaction comes the CB6r3 chemical mechanism used by 
C            the Environ CAMX model consult references 9 and 10.
c 03/24/16 - G. Sarwar - Heterogeneous uptake of BRONO2 on aerosols
C 5/2016     H Pye - merged with AERO6i version (added NO3, GLY, MGLY, IMAE het rxn)
c 07/17/18 - G. Sarwar - Heterogeneous uptakes of chlorine, bromine and iodine species on aerosols
C 06/10/21 - G. Sarwar: Added CB6R5M_AE7_AQ
C 11/08/23 - N. Skipper: Added heterogeneous uptake of HO2
C
c  REFERENCES:
c   1. Pleim, J.E., F.S. Binkowski, J.K.S. Ching, R.L. Dennis, and N.V.
c      Gallani, An improved representation of the reaction of N2O5 on
c      aerosols for mesoscale air quality models.  In "Regional
c      Photochemical Measurement and Modeling Studies, Vol 2 - Results
c      and Status of Modeling," Eds A.J. Ranzieri and P.A. Solomon, pp
c      904-913, 1995.
c
c   2. Davis, J.M., P.V. Bhave, and K.M. Foley, Parameterization of N2O5
c      reaction probabilities on the surface of particles containing
c      ammonium, sulfate, and nitrate.  Atmos. Chem. Phys., 2008, in
c      press.
c
c   3. Vogel, B., H. Vogel, J. Kleffman, and R. Kurtenbach, Measured and
c      simulated vertical profiles of nitrous acid - Part II. Model
c      simulations and indications for a photolytic source, Atmospheric
c      Environment, 37, 2957-2966, 2003.
c
c   4. Sarwar, G., S.J. Roselle, R. Mathur, W. Appel, R.L. Dennis, and
c      B. Vogel, A comparison of CMAQ HONO predictions with observations
c      from the Northeast Oxidant and Particle Study, Atmospheric
c      Environment, 2008, in press.
C
C   5. Bertram, T. H. and J.A. Thornton, Toward a general parameterization
C      of N2O5 reactivity on aqueous particles: the competing effects of 
C      particle liquid water, nitrate, and chloride, ACP, 9, 8351-8363, 2009 
C
C   6. Sarwar, G., H. Simon2, P. Bhave1, and G. Yarwood. Examining the impact of 
C      heterogeneous nitryl chloride production on air quality across the United
C      States. Atmos. Chem. Phys., 12, 6455-6473, 2012.
C
C   7. Pye et al., Epoxide pathways improve model predictions of isoprene
C      markers and reveal key role of acidity in aerosol formation,
C      Environ. Sci. Technol., doi: 10.1021/es402106h, 2013.
C
C   8. Rollins, A.W., S. Pusede, P.Wooldridge, K.-E.Min, D.R. Gentner, A.H. 
C      Goldstein, S. Liu, D.A. Day, L.M. Russell, C.L. Rubitschun, J.D. Surratt,
C      and R.C. Cohen, Gas/particle partitioning of total alkyl nitrates 
C      observed with TD-LIF in Bakersfield.J.Geophys.Res., 118, 6651-6662, 2013.
C
C   9. Liu, S., J.E. Shilling, C. Song, N. Hiranuma, R.A. Zaveri, L.M. Russell,
C      Hydrolysis of Organonitrate Functional Groups in Aerosol Particles.
C      Aerosol Sci. Technol., 46, 1359-1369, 2012.
C
C  10. Yang, X., R. A. Cox, N. J. Warwick, J. A. Pyle, G. D. Carver, F. M.
C      O'Connor, and N. H. Savage, Tropospheric bromine chemistry
C      and its impacts on ozone: A model study, J. Geophys. Res., 110, D23311,
C      doi:10.1029/2005JD006244, 2005.
C
C  11. Mao et al. Ozone and organic nitrates over the eastern United
C      States: Sensitivity to isoprene chemistry, J. Geophys. Res. doi:
C      10.1002/jgrd.50817, 2013.

C  12. Fernandez et al., Bromine partitioning in the tropical tropopause layer: 
C      implications for stratospheric injection, ACP, 14, 13391-13410, 2014.
C
C  13. Schmidt et al., Modeling the observed tropospheric BrO background: Importance 
C      of multiphase chemistry and implications for ozone, OH, and mercury, 
C      J. Geophys. Res. doi: 10.1002/2015JD024229
C
C  14. Sherwen et al., Global impacts of tropospheric halogens on oxidants and 
C      composition in GEOS-CHEM: ACP, 16, 12239-12271, 2016
C
C  15. Deiber et al., Uptake of ClONO2 and BrONO2 by halide containing droplets
C      ACP, 4, 1291-1299, 2004
C
C  16. Ivatt et al., Suppression of surface ozone by an aerosol-inhibited
C      photochemical ozone regime, Nat. Geosci.,
C      doi: 10.1038/s41561-022-00972-9, 2022
C  17. Jacob, Heterogeneous chemistry and tropospheric ozone, Atm Env.,
C      doi: 10.1016/S1352-2310(99)00462-8, 2000
C
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE UTILIO_DEFN
      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE RXNS_DATA
      USE AERO_DATA
      USE AEROMET_DATA, ONLY: airdens
      USE PRECURSOR_DATA
      USE SOA_DEFN
      USE ASX_DATA_MOD,  ONLY: MET_DATA, GRID_DATA
      USE PHOT_MOD,      ONLY: RJ, RJ_RES, RJ_SUB, LHNO3  
      USE ELMO_DATA
      !USE ELMO_PROC
      USE CENTRALIZED_IO_MODULE
      USE CONST

      IMPLICIT NONE

C *** Arguments
      REAL,           POINTER       :: CGRID ( :,:,:,: )  ! pointer of model concentrations
      REAL,           INTENT( IN )  :: TEMP  ( :,:,: )    ! temperature [K]
      REAL,           INTENT( IN )  :: PRESS ( :,:,: )    ! pressure [Pa]
      REAL,           INTENT( IN )  :: WVAPOR( :,:,: )    ! water vapor mass mixing ratio(Kg/Kg air)
      REAL, OPTIONAL, INTENT( IN )  :: DENS ( :,:,: )     ! air density(Kg/m3 air)

      CHARACTER(16), SAVE ::  PNAME = 'HETCHEM_RATES'
      
C *** Parameters
      REAL( 8 ), PARAMETER :: AQUEOUS_FREQUENCY = 1.0D+9
      REAL( 8 ), PARAMETER :: INV_SQRT_MWNO2  = 1.47425932467825D-1
      REAL( 8 ), PARAMETER :: INV_SQRT_MWN2O5 = 9.62161363758323D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWCLNO3  = 1.012739360000D-1        
      REAL( 8 ), PARAMETER :: INV_SQRT_MWBRNO3 = 8.394770000000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWBRNO2  = 8.91220000000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWHOBR   = 1.015869000D-1
      REAL( 8 ), PARAMETER :: INV_SQRT_MWHBR    = 1.111797000D-1                   
      REAL( 8 ), PARAMETER :: INV_SQRT_MWI2O2 = 5.9151900D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWI2O3 = 5.7562500D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWI2O4 = 5.6090000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWINO3 = 7.275850000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWINO2 = 7.605050000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWHOI  = 8.336220000D-2

      REAL( 8 ), PARAMETER :: UGM3_CONV_FAC   = 8.31251724585556D00 ! =1.0E-3*AIRDENS_STD*(PRESS_STD/TEMP_STD)
      REAL( 8 ), PARAMETER :: COEF1           = 7.24382926227485D10 ! Molec/cc to ppm conv factor 
      REAL( 8 ), PARAMETER :: COEF2           = 2.14805198392421D13 ! convert air density [kg/m3] to number density [ppm]

      REAL( 8 ), PARAMETER :: GAMMA_NO3       = 1.0D-3 ! Jacob 2000
      REAL( 8 ), PARAMETER :: GAMMA_GLY       = 2.9D-3 ! Liggio et al. 2005
      REAL( 8 ), PARAMETER :: GAMMA_HO2       = 0.2D+0 ! Ivatt et al. 2022

      REAL( 8 ), PARAMETER :: STD_DIFF_N2O5 = 0.0855D-4  ! N2O5 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]
      REAL( 8 ), PARAMETER :: STD_DIFF_CLNO3  = 0.1014D-4    ! CLNO3 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]   
      REAL( 8 ), PARAMETER :: STD_DIFF_BRNO3  = 0.0855D-4    ! BRONO2 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]
      REAL( 8 ), PARAMETER :: STD_DIFF_BRNO2  = 0.0999D-4    ! BRNO2 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]
      REAL( 8 ), PARAMETER :: STD_DIFF_HOBR   = 0.1101D-4    ! HOBR molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]
      REAL( 8 ), PARAMETER :: STD_DIFF_HBR    = 0.1216D-4    ! HBR molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]    
      REAL( 8 ), PARAMETER :: STD_DIFF_I2O2   = 0.0732D-4    ! I2O2 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_I2O3   = 0.0707D-4    ! I2O3 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_I2O4   = 0.0684D-4    ! I2O4 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_INO3   = 0.0792D-4    ! INO3 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_INO2   = 0.0833D-4    ! INO2 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_HOI    = 0.0972D-4    ! HOI molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 

!     REAL,      PARAMETER :: GPKG        = 1.0E+03                      ! g/kg unit conversion
      REAL,      PARAMETER :: CFACTOR     = 8.0 * GPKG  * RGASUNIV / PI  ! factor in cbar_coeff
      REAL,      PARAMETER :: PA2ATM      = 1.0 / STDATMPA               ! Pascal to atm conv fac
      REAL,      PARAMETER :: WMASS2PPM   = 1.0E6 * MWAIR / MWWAT        ! H2O mixing ratio to ppm
      REAL,      PARAMETER :: MAOMV       = MWAIR / MWWAT
      REAL,      PARAMETER :: CONCOFM     = 1.0E+06        ! conc. of M = 1E+06 ppm
      REAL,      PARAMETER :: INV_STDTEMP = 1.0 / STDTEMP
      REAL,      PARAMETER :: EPSWATER    = MWWAT / MWAIR
C *** parameters for heterogeneous hydrolysis of NTR2
      REAL,      PARAMETER :: ON_ALPHA1   = 0.34,     ! Organic nitrate (ON) partitioning parameters
     &                        ON_ALPHA2   = 0.66,     ! based on Rollins et al., 2013
     &                        ON_CSTAR1   = 0.73,
     &                        ON_CSTAR2   = 1000.0

      REAL,      PARAMETER :: MIN_TOA     = 0.0001       ! Min. conc. of total OA for partitioning to occur [ug/m3]
      REAL,      PARAMETER :: KHON        = 2.7778E-03   ! heterogeneous ON hydrolysis rate [1/min] ~ 4/day

C *** Local Variables
      REAL( 8 )    :: AIRTEMP          ! air temperature [K]
      REAL( 8 )    :: AIRPRES          ! air pressure [Pa] 
      REAL( 8 )    :: GAMMA            ! fine mode N2O5->NO3 rxn probability
      REAL( 8 )    :: GAMMAIEPOX       ! IEPOX uptake coefficient
      REAL( 8 )    :: GAMMAIMAE        ! IMAE uptake coefficient
      REAL( 8 )    :: GAMMA_HFPODAF    ! HFPODAF uptake coefficient
      REAL( 8 )    :: GAMMA_COF2       ! COF2 uptake coefficient
      REAL( 8 )    :: GAMMA_PFMOAF     ! PFMOAF uptake coefficient
      REAL( 8 )    :: KPIEPOX          ! IEPOX particle-phase reaction rate const (pseudo 1st order, sec-1)
      REAL( 8 )    :: KPHFPODAF        ! HFPODAF particle-phase reaction rate const (pseudo 1st order, sec-1)
      REAL( 8 )    :: KPCOF2           ! COF2 particle-phase reaction rate const (pseudo 1st order, sec-1)
      REAL( 8 )    :: KPPFMOAF         ! PFMOAF particle-phase reaction rate const (pseudo 1st order, sec-1)
      REAL( 8 )    :: KN2O5( N_MODE  ) ! pseudo-first order rate constant, sec-1
      REAL( 8 )    :: KNO3(  N_MODE  ) ! pseudo-first order rate constant, sec-1
      REAL( 8 )    :: KGLY(  N_MODE  ) ! pseudo-first order rate constant, sec-1
      REAL( 8 )    :: KMGLY( N_MODE  ) ! pseudo-first order rate constant, sec-1
      REAL( 8 )    :: KNO2             ! pseudo-first order rate constant, sec-1
      REAL( 8 )    :: KIEPOX           ! pseudo-first order rate constant for IEPOX uptake, sec-1
      REAL( 8 )    :: KIMAE            ! pseudo-first order rate constant for MAE uptake, sec-1
      REAL( 8 )    :: KHFPODAF         ! pseudo-first order rate constant for HFPODAF uptake, sec-1
      REAL( 8 )    :: KCOF2            ! pseudo-first order rate constant for COF2 uptake, sec-1
      REAL( 8 )    :: KPFMOAF          ! pseudo-first order rate constant for PFMOAF uptake, sec-1
      REAL( 8 )    :: KHO2(  N_MODE  ) ! pseudo-first order rate constant, sec-1

      REAL( 8 )    :: K1               ! pseudo-first order rate constant, sec-1 
      REAL( 8 )    :: K2               ! pseudo-first order rate constant, sec-1 
      REAL( 8 ), PARAMETER :: MIN_VALUE = 1.0D-09      ! minimum concentration for activating chemistry

      REAL( 8 )    :: CBAR_COEFF       ! cell coefficient for mean molecular speed
      REAL( 8 )    :: ADJUST_DIFF      ! Cell temp and press correction to diffusivity
      REAL( 8 )    :: INV_DIFFUSIVITY  ! reciprocal molecular diffusivity [m2/sec] 

      REAL( 8 )    :: XXF( N_MODE )         ! XXF_AT,    XXF_AC,    XXF_CO    ! modal factors to calculate KN2O5
      REAL( 8 )    :: CL_PPM( N_MODE )      ! aerosol chlorine in ppm
      REAL( 8 )    :: BR_PPM( N_MODE )      ! aerosol bromine in ppm
      REAL( 8 )    :: YIELD_CLNO2( N_MODE ) ! model reactions yields of CLNO2      
      
      REAL( 8 )    :: H2OVP    ! ambient water vapor pressure [Atm]
      REAL( 8 )    :: AIRRH    ! Relative Humidity            [Fractional]
      REAL( 8 )    :: YIELDIJ  ! fine mode reaction yield, dimensionaless
      REAL( 8 )    :: TOTSURFA ! aerosol surface area (m**2/m**3)
      REAL( 8 )    :: FACTOR   ! scratch multiplicative factor
      REAL( 8 )    :: RFACTOR  ! factor converting rate constant from cm3/molec/sec to 1/ppm/min
      REAL( 8 )    :: RADIUS_I ! effective particle radius [m] - i-mode
      REAL( 8 )    :: RADIUS   ! effective particle radius [m] - j-mode

      REAL( 8 )    :: SSALT_SURFA       ! sea-salt aerosol surface area (m**2/m**3)
      REAL( 8 )    :: SSALT_VOL         ! sea-salt aerosol volume (m**3/m**3)
      
      REAL( 8 )       :: CBAR             ! molecular velocity of N2O5 (m/s)
      REAL( 8 )       :: CBARIEPOX        ! molecular velocity of IEPOX (m/s)
      REAL( 8 )       :: CBARIMAE         ! molecular velocity of IMAE (m/s)
      REAL( 8 )       :: CBARNO3          ! molecular velocity of NO3 (m/s)
      REAL( 8 )       :: CBARGLY          ! molecular velocity of GLY (m/s)
      REAL( 8 )       :: CBARMGLY         ! molecular velocity of MGLY (m/s)
      REAL( 8 )       :: CBARHO2          ! molecular velocity of HO2 (m/s)
      REAL( 8 )       :: TETROL_PPM       ! accumulation mode aerosol tetrol in ppm
      REAL( 8 )       :: IEPOXOS_PPM      ! accumulation mode iepox organosulfate in ppm
      REAL( 8 )       :: ASO4J_PPM        ! accumulation mode inorganic sulfate in ppm
      REAL( 8 )       :: FH2O(2)          ! fraction of epoxide aerosol from  hydrolysis, index: IEPOX(1) and MAE(2)
      REAL( 8 )       :: FOS(2)           ! fraction of epoxide aerosol as organosulfate, index: IEPOX(1) and MAE(2)
      REAL( 8 )       :: FDIM1(2)         ! fraction of epoxide aerosol as dimer, index: IEPOX(1) and MAE(2)
      REAL( 8 )       :: FDIM2(2)         ! fraction of epoxide aerosol as organosulfate dimer, index: IEPOX(1) and MAE(2)
      REAL( 8 ), SAVE :: INV_MWIETET, INV_MWIEOS  ! reciprocal of molecular weight for tetrol, iepoxos [mol/g]
      REAL( 8 ), SAVE :: INV_MWASO4       ! reciprocal of molecular weight of particulate sulfate [mol/g]

      REAL( 8 )       :: CBAR_CLNO3        ! molecular velocity of CLNO3 (m/s)      
      REAL( 8 )       :: CBAR_HBR          ! molecular velocity of HOBR (m/s)        
      REAL( 8 )       :: CBAR_BRNO2        ! molecular velocity of BRNO2 (m/s)      
      REAL( 8 )       :: CBAR_BRNO3        ! molecular velocity of BRNO3 (m/s)
      REAL( 8 )       :: CBAR_HOBR         ! molecular velocity of HOBR (m/s)                                          
      REAL( 8 )       :: CBAR_I2O2         ! molecular velocity of I2O2 (m/s)  
      REAL( 8 )       :: CBAR_I2O3         ! molecular velocity of I2O3 (m/s) 
      REAL( 8 )       :: CBAR_I2O4         ! molecular velocity of I2O4 (m/s)   
      REAL( 8 )       :: CBAR_INO2         ! molecular velocity of INO2 (m/s) 
      REAL( 8 )       :: CBAR_INO3         ! molecular velocity of INO3 (m/s)  
      REAL( 8 )       :: CBAR_HOI          ! molecular velocity of HOI (m/s)
      REAL( 8 )       :: CBAR_HFPODAF      ! molecular velocity of HFPODAF (m/s)
      REAL( 8 )       :: CBAR_COF2         ! molecular velocity of COF2 (m/s)
      REAL( 8 )       :: CBAR_PFMOAF       ! molecular velocity of PFMOAF (m/s)


      REAL( 8 )       :: CLNO3_H2O_RXN_TIME   ! CLNO3 reaction time per aerosol surface area density with H2O (s/m)  
      REAL( 8 )       :: HBR_RXN_TIME         ! HBR reaction time per aerosol surface area density with seasalt (s/m)
      REAL( 8 )       :: BRNO3_H2O_RXN_TIME   ! BRNO3 reaction time per aerosol surface area density with H2O (s/m)
      REAL( 8 )       :: HOBR_ASS_RXN_TIME    ! HOBR reaction time per aerosol surface area density with fine-mode ACL (s/m)
      REAL( 8 )       :: BRNO2_RXN_TIME       ! BRNO2 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: BRNO3_RXN_TIME       ! BRNO3 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: I2O2_RXN_TIME        ! I2O2 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: I2O3_RXN_TIME        ! I2O3 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: I2O4_RXN_TIME        ! I2O4 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: INO2_RXN_TIME        ! INO2 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: INO3_RXN_TIME        ! INO3 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: HOI_RXN_TIME         ! HOI reaction time per aerosol surface area density (s/m)

      REAL( 8 )       :: INV_DIFF_CLNO3       ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_HBR         ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_BRNO3       ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_BRNO2       ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_HOBR        ! reciprocal molecular diffusivity [m2/sec]                           
      REAL( 8 )       :: INV_DIFF_I2O2        ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_I2O3        ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_I2O4        ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_INO3        ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_INO2        ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_HOI         ! reciprocal molecular diffusivity [m2/sec]

      REAL            :: MARINE_AREA                     ! variable to identify grid-cells over ocean

      INTEGER, SAVE   :: IMAE_IDX
      !INTEGER, SAVE   :: IHMML_IDX
      INTEGER, SAVE   :: NO3_IDX
      INTEGER, SAVE   :: GLY_IDX
      INTEGER, SAVE   :: MGLY_IDX
      INTEGER, SAVE   :: BR_IDX   
      INTEGER, SAVE   :: HFPODAF_IDX
      INTEGER, SAVE   :: COF2_IDX
      INTEGER, SAVE   :: PFMOAF_IDX
      INTEGER, SAVE   :: HO2_IDX

C *** variables for parameterization by Bertram and Thornton 
      REAL         :: ACL           ! i+j or k mode chloride, ug/m3 
      REAL         :: ABR           ! i+j or k mode bromide, ug/m3   
      REAL         :: AH2O          ! i+j or k mode water, ug/m3          
      REAL         :: POC           ! i or j mode primary organic carbon, ug/m3 
      REAL         :: PNCOM         ! i or j mode primary noncarbon organic matter, ug/m3          
      REAL,      SAVE :: MWCLH2O       ! ratio of MWCL/MWH2O 
      REAL,      SAVE :: MWH2OCL       ! ratio of MWH2O/MWCL 
      REAL,      SAVE :: MWCLCLNO2     ! ratio of MWCL/MWCLNO2
      REAL( 8 ), SAVE :: INV_MWCL      ! ratio of 1.0D0/MWCL 
      REAL( 8 ), SAVE :: INV_MWBR      ! ratio of 1.0D0/MWBR   
      REAL( 8 )       :: PPM_FACTOR    ! conversion factor to umoles/m3 to ppm
C *** variables for heterogeneous hydrolysis of NTR2
      REAL            :: CON_TOA       ! Conc. of total OA [ug/m3]
      REAL            :: F_PART_NTR2   ! NTR2 fraction in the particle phase
      
C Latitude and longitude for zenith angle calculation: Golam Sarwar * July 1, 2024
      REAL          COSZ                            ! local cosine of zenith angle
      REAL          JHNO3                           ! HNO3 photolysis rate, 1/min
      LOGICAL       DARK                            ! DARK = TRUE is night,  DARK = FALSE is day
      
      REAL      ASEASTM   ! seasalt,  [moles / m3 ] 
      REAL      ANO3      ! fine mode nitrate [ ug/m3 ] 
      REAL      ANO3M     ! nitrate,  [moles / m3 ] 

      REAL      FAC_HNO3  ! Enhancement factor for HNO3 photolysis rate for a grid-cell [-]  
      
      LOGICAL, SAVE     :: FIRSTIME = .TRUE.

      INTEGER           :: IRATE        ! loop counter
      INTEGER           :: INDX         ! found array index
      INTEGER, SAVE     :: CLNO2_IDX
      INTEGER, SAVE     :: IEPOX_IDX

      INTEGER           :: C
      INTEGER           :: R
      INTEGER           :: L
      INTEGER           :: N
      INTEGER           :: I

      INTEGER      SPC        ! loop counter  
      
C *** variables for getting aerosol diagnostic file flag
      INTEGER           :: STATUS                      ! ENV... status
      CHARACTER( 80 )   :: VARDESC                     ! environment variable description
      
      CHARACTER( 132 )  :: XMSG

C *** parameters for calculating GAMMA of HBR ---> ABR, Sherwen et al., ACP, 2016 and IUPAC
      REAL( 8 ) :: GAMMA_HBR                             ! uptake coefficient of HBR  
      REAL( 8 ) :: INV_GAMMA_HBR       
      
! reciprocal of rxn probability for CLNO3 on aerosol, Dieber et al., ACP, 2004
      REAL( 8 ), PARAMETER :: INV_GAMMA_CLNO3_H2O  = 1.0D0 / 0.024D0               ! Dieber et al., ACP, 2004 (with H2O)

! reciprocal of rxn probability for bromine species on aerosol
      REAL( 8 ), PARAMETER :: INV_GAMMA_BRNO3_H2O  = 1.0D0 / 0.03D0                ! Dieber et al., ACP, 2004
      REAL( 8 ), PARAMETER :: INV_GAMMA_HOBR_ASS   = 1.0D0 / 0.1D0                 ! Fernandez et al, 2014
      REAL( 8 ), PARAMETER :: INV_GAMMA_BRNO3  = 1.0D0 / 0.08D0                    ! Fernandez et al, 2014
      REAL( 8 ), PARAMETER :: INV_GAMMA_BRNO2  = 1.0D0 / 0.04D0                    ! Fernandez et al, 2014

! reciprocal of rxn probability for iodine species on aerosol, selective 
      REAL( 8 ), PARAMETER :: INV_GAMMA_I2O2  = 1.0D0 / 0.02D0                     ! Sherwen et al., 2016
      REAL( 8 ), PARAMETER :: INV_GAMMA_I2O3  = 1.0D0 / 0.02D0                     ! Sherwen et al., 2016
      REAL( 8 ), PARAMETER :: INV_GAMMA_I2O4  = 1.0D0 / 0.02D0                     ! Sherwen et al., 2016
      REAL( 8 ), PARAMETER :: INV_GAMMA_HOI   = 1.0D0 / 0.01D0                     ! Sherwen et al., 2016     
      REAL( 8 ), PARAMETER :: INV_GAMMA_INO3  = 1.0D0 / 0.01D0                     ! Saiz-Lopez et al. 2014
      REAL( 8 ), PARAMETER :: INV_GAMMA_INO2  = 1.0D0 / 0.02D0                     ! Saiz-Lopez et al. 2014

#ifdef verbose_aerosol_chemistry
       LOGICAL              :: DUMP_CELL
#endif


      INTERFACE
         SUBROUTINE GETPAR( FIXED_sg  )
           LOGICAL, INTENT( IN ) :: FIXED_sg    ! fix coarse and accum Sg's to the input value?
         END SUBROUTINE GETPAR
         Subroutine Hetchem_Extract_Aero( CONCVEC, C, R, L, WET_M2,
     &                                  WET_M3, DE_WET )
           Real, Intent( In )    :: CONCVEC( : )
           Integer, Intent(In)   :: C, R, L
           Real(8), Intent( Out ):: Wet_M2( : ), Wet_M3( : ), De_Wet( : )
         End Subroutine Hetchem_Extract_Aero
      END INTERFACE 
      
C-----------------------------------------------------------------------

      IF ( NHETERO .LT. 1 )RETURN

C *** compute only on first pass

      IF ( FIRSTIME ) THEN
      
        FIRSTIME = .FALSE.

        CALL MAP_AERO()
        CALL MAP_PRECURSOR()

        CALL LOG_HEADING( LOGDEV,'Initialize Aerosol Heterogeneous Chemistry')

        ALLOCATE( WHICH_AERO_RATE( NHETERO ) )
        
C *** 2nd and 3rd moments (w. H2O and svOA)
        ALLOCATE(  WET_M3( N_MODE ), 
     &             WET_M2( N_MODE ), 
     &             DE_WET( N_MODE ) )
C *** Allocate Gridded Dry Initial Moments so they can be saved for the
C     end of the gas-phase chemical driver
        WHICH_AERO_RATE = -1
        
        SELECTED_AERO_RATES = 0
        DO IRATE = 1, NHETERO
           INDX = INDEX1( HETERO( IRATE ), NUMB_AERO_RATES, NAMES_AERO_RATES )
           IF ( INDX .LT. 1 ) THEN
               XMSG = 'Heterogeneous Reaction Label '// TRIM ( HETERO( IRATE ) )
     &             // ' is not in list of available Reaction Rates.'
               CALL M3EXIT( 'HETCHEM_RATES', 0, 0, XMSG, XSTAT3 )
           END IF 
           SELECTED_AERO_RATES = SELECTED_AERO_RATES + 1
           WHICH_AERO_RATE( SELECTED_AERO_RATES ) = INDEX_AERO_RATES( INDX )
       END DO

       ALLOCATE( KHETERO( SELECTED_AERO_RATES, NCOLS,NROWS,NLAYS ) )
       
       IF ( L_ELMO ) THEN
          ALLOCATE( GAMMA_N2O5IJ( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(  GAMMA_N2O5K( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(  GAMMA_IEPOX( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(   GAMMA_IMAE( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(   KPARTIEPOX( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(     YCLNO2IJ( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(      YCLNO2K( NCOLS,NROWS,NLAYS ) )
          ALLOCATE( GAMMAHFPODAF( NCOLS,NROWS,NLAYS ) )
          ALLOCATE( GAMMACOF2   ( NCOLS,NROWS,NLAYS ) )
          ALLOCATE( GAMMAPFMOAF ( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(      EF_HNO3( NCOLS,NROWS,NLAYS ) )
          ALLOCATE( KpartHFPODAF( NCOLS,NROWS,NLAYS ) )
          ALLOCATE( KpartCOF2   ( NCOLS,NROWS,NLAYS ) )
          ALLOCATE( KpartPFMOAF ( NCOLS,NROWS,NLAYS ) )
       END IF

C ***  Determine molecular weights
       INV_MWCL  = REAL( 1.0 / aerospc_mw( ACL_IDX ), 8 )
       MWCLH2O   = aerospc_mw( ACL_IDX ) / aerospc_mw( AH2O_IDX )
       MWH2OCL   = 1.0 / MWCLH2O
       CLNO2_IDX = INDEX1( 'CLNO2', NUMB_MECH_SPC, CHEMISTRY_SPC )
       
       IF ( CLNO2_IDX .GT. 0 ) THEN
          MWCLCLNO2 = aerospc_mw( ACL_IDX) / SPECIES_MOLWT( CLNO2_IDX )
       ELSE
          MWCLCLNO2 = 0.0
       END IF

       IEPOX_IDX = INDEX1( 'IEPOX', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF ( IEPOX_IDX .GT. 0 ) THEN
          MWTIEPOX  = REAL( SPECIES_MOLWT( IEPOX_IDX ), 8 ) 
       ELSE
          MWTIEPOX  = 118.1D0
       END IF
       CFACTOR_IEPOX = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTIEPOX * DPI ) )

       IMAE_IDX = INDEX1( 'IMAE', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( IMAE_IDX .GT. 0 )THEN
           MWTIMAE  = REAL( SPECIES_MOLWT( IMAE_IDX ), 8 )
       ELSE
           MWTIMAE  = 102.0D0
       END IF
       CFACTOR_IMAE = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTIMAE * DPI ) )

       IF( AIETET_IDX .GT. 0 ) THEN
          INV_MWIETET = REAL( 1.0/ aerospc_mw( AIETET_IDX ), 8 )
       ELSE
          INV_MWIETET = 0.0D0
       END IF

       IF( AIEOS_IDX .GT. 0 ) THEN
          INV_MWIEOS  = REAL( 1.0/ aerospc_mw( AIEOS_IDX  ), 8 )
       ELSE 
          INV_MWIEOS = 0.0D0
       END IF

       IF( ASO4_IDX .GT. 0 )THEN
          INV_MWASO4 = REAL( 1.0/ aerospc_mw( ASO4_IDX ), 8 )
       ELSE
          INV_MWASO4 = 0D0
       END IF

       NO3_IDX = INDEX1( 'NO3', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( NO3_IDX .GT. 0 )THEN
           MWTNO3  = REAL( SPECIES_MOLWT( NO3_IDX ), 8 )
       ELSE
           MWTNO3  = 62.01D0
       END IF
       CFACTOR_NO3 = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTNO3 * DPI ) )

       GLY_IDX = INDEX1( 'GLY', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( GLY_IDX .GT. 0 )THEN
           MWTGLY  = REAL( SPECIES_MOLWT( GLY_IDX ), 8 )
       ELSE
           MWTGLY  = 58.04D0
       END IF
       CFACTOR_GLY = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTGLY * DPI ) )

       MGLY_IDX = INDEX1( 'MGLY', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( MGLY_IDX .GT. 0 )THEN
           MWTMGLY  = REAL( SPECIES_MOLWT( MGLY_IDX ), 8 )
       ELSE
           MWTMGLY  = 72.07D0
       END IF
       CFACTOR_MGLY = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTMGLY * DPI ) )

       HFPODAF_IDX = INDEX1( 'HFPODAF', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( HFPODAF_IDX .GT. 0 )THEN
           MWTHFPODAF  = REAL( SPECIES_MOLWT( HFPODAF_IDX ), 8 )
       ELSE
           MWTHFPODAF  = 332.05D0
       END IF
       CFACTOR_HFPODAF = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTHFPODAF * DPI ) )

       COF2_IDX = INDEX1( 'COF2', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( COF2_IDX .GT. 0 )THEN
           MWTCOF2  = REAL( SPECIES_MOLWT( COF2_IDX ), 8 )
       ELSE
           MWTCOF2  = 66.01D0
       END IF
       CFACTOR_COF2 = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTCOF2 * DPI ) )

       PFMOAF_IDX = INDEX1( 'PFMOAF', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( PFMOAF_IDX .GT. 0 )THEN
           MWTPFMOAF  = REAL( SPECIES_MOLWT( PFMOAF_IDX ), 8 )
       ELSE
           MWTPFMOAF  = 182.02D0
       END IF
       CFACTOR_PFMOAF = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTPFMOAF * DPI ) )

       HO2_IDX = INDEX1( 'HO2', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( HO2_IDX .GT. 0 )THEN
           MWTHO2  = REAL( SPECIES_MOLWT( HO2_IDX ), 8 )
       ELSE
           MWTHO2  = 33.0D0
       END IF
       CFACTOR_HO2 = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTHO2 * DPI ) )

C ***  Map to acids/nucleophiles for epoxide uptake
       CALL LOG_SUBHEADING( LOGDEV, 'Map Acid-Nuc Pairs for Heterogeneous Chemistry')

       INDX =  INDEX1( NAMES_AERO_RATES( IA_IEPOX ), NHETERO, HETERO )   
       IF ( INDX .GT. 0 ) THEN ! Find indices for acid catalyzed species in IEPOX reaction
          If ( ( INDEX( MECHNAME, 'AE7I' ) .GT. 0 ) ) then
             NUMVOC         = 2 ! IEPOX + MAE/HMML
             N_NUCPAIRS     = N_NUCPAIRS_AEI
             ALLOCATE ( ACID_NUC_PAIRS( N_NUCPAIRS ) )
             ACID_NUC_PAIRS = ACID_NUC_PAIRS_AEI
          Else If ( (INDEX( MECHNAME, 'CRACMM2') .GT. 0)
     &      .OR.    (INDEX( MECHNAME, 'CRACMM3') .GT. 0) ) then
             NUMVOC         = 1
             N_NUCPAIRS     = N_NUCPAIRS_CRCM
             ALLOCATE ( ACID_NUC_PAIRS( N_NUCPAIRS ) )
             ACID_NUC_PAIRS = ACID_NUC_PAIRS_CRCM
          Else ! AERO6/7 (condensed IEPOX SOA)
             NUMVOC         = 1
             N_NUCPAIRS     = N_NUCPAIRS_AE
             ALLOCATE ( ACID_NUC_PAIRS( N_NUCPAIRS ) )
             ACID_NUC_PAIRS = ACID_NUC_PAIRS_AE
          END IF
          ALLOCATE ( ACID_PRODMAP_IDX( N_NUCPAIRS ) )
          ALLOCATE (  ACID_NUCMAP_IDX( N_NUCPAIRS ) )
          ACID_PRODMAP_IDX = 0
          ACID_NUCMAP_IDX  = 0
          DO N = 1, N_NUCPAIRS
            ACID_PRODMAP_IDX(N) = FINDAERO( ACID_NUC_PAIRS(N)%PROD, .TRUE. )
            ACID_NUCMAP_IDX(N)  = FINDAERO( ACID_NUC_PAIRS(N)%NUC,  .TRUE. )
#ifdef verbose_aerosol_chemistry        
            Write( logdev,'( 5x, a, i4 )' ) acid_nuc_pairs(n)%prod, acid_prodmap_idx(n)
            Write( logdev,'( 5x, a, i4 )' ) acid_nuc_pairs(n)%nuc,  acid_nucmap_idx(n)
#endif
          END DO
       END IF

       AERO_CHEM_SET = .TRUE.

      END IF   ! first time condition

      KHETERO = 0.0D0
      
      IF ( L_ELMO ) THEN
         GAMMA_N2O5IJ = 0.0
         GAMMA_N2O5K  = 0.0
         YCLNO2IJ     = 0.0
         YCLNO2K      = 0.0
         GAMMA_IEPOX  = 0.0
         GAMMA_IMAE   = 0.0
         KPARTIEPOX   = 0.0
         GAMMAHFPODAF = 0.0
         GAMMACOF2    = 0.0
         GAMMAPFMOAF  = 0.0
	     EF_HNO3      = 0.0
         KpartHFPODAF = 0.0
         KpartCOF2    = 0.0
         KpartPFMOAF  = 0.0
      END IF
     
C *** Calculate rate constants at each grid cell location
      LOOP_LAY: DO L = 1, NLAYS
         LOOP_ROW: DO R = 1, NROWS
            LOOP_COL: DO C = 1, NCOLS
     
#ifdef verbose_aerosol_chemistry        
               IF ( L .EQ. 1 .AND. R .EQ. INT(NROWS/2)+1 .AND.
     &              C .EQ. INT(NCOLS/2)+1 ) THEN
                  DUMP_CELL = .TRUE.
               ELSE
                  DUMP_CELL = .FALSE.
               END IF
#endif         
C *** Extract aerosol concentrations and update aerosol volume, surface
C     area and diameter values.
               AIRDENS = DENS( C,R,L )

               CALL HETCHEM_EXTRACT_AERO( CGRID( C,R,L,: ), C, R, L,
     &               WET_M2, WET_M3, DE_WET )

C *** Load Meteorological Variables
               AIRTEMP = REAL( TEMP( C,R,L ), 8 )
               AIRPRES = REAL(  PRESS( C,R,L ), 8 )   

C *** to compute RH & molecular kinetic factors
               H2OVP = REAL( PRESS( C,R,L ) * WVAPOR( C,R,L )
     &               / ( EPSWATER  + WVAPOR( C,R,L ) ), 8 )    
     
               AIRRH = MAX( 0.005D0, MIN( 0.99D0, H2OVP * INV_ESATL( AIRTEMP ) ) )

               CBAR_COEFF  = REAL( SQRT( CFACTOR * TEMP( C,R,L ) ), 8) 
               
               ADJUST_DIFF = REAL( ( TEMP( C,R,L ) * INV_STDTEMP ) ** 1.75 * ( STDATMPA / PRESS( C,R,L ) ), 8 )

               IF ( PRESENT( DENS ) ) THEN
                  PPM_FACTOR  = 1.0D-3 * REAL( MWAIR / DENS( C,R,L ), 8 )
               ELSE
                  PPM_FACTOR  = UGM3_CONV_FAC * REAL( TEMP( C,R,L ) / PRESS( C,R,L ), 8 )
               END IF
              
               RFACTOR = 60.0D0 * COEF1 * REAL( PRESS( C,R,L ) / TEMP( C,R,L ), 8 )

C *** calculate molecular speeds (m/s) using Eq 4 of Pleim et al (1995)
               CBAR = CBAR_COEFF * INV_SQRT_MWN2O5
               CBARNO3 = CFACTOR_NO3 * DSQRT( AIRTEMP )
               CBARGLY = CFACTOR_GLY  * DSQRT( AIRTEMP )
               CBARMGLY = CFACTOR_MGLY * DSQRT( AIRTEMP )
               CBAR_HFPODAF = CFACTOR_HFPODAF * DSQRT( AIRTEMP )
               CBAR_COF2 = CFACTOR_COF2 * DSQRT( AIRTEMP )
               CBAR_PFMOAF = CFACTOR_PFMOAF * DSQRT( AIRTEMP )
               CBARHO2 = CFACTOR_HO2 * DSQRT( AIRTEMP )

               CBAR_CLNO3 = CBAR_COEFF * INV_SQRT_MWCLNO3
               CBAR_HBR   = CBAR_COEFF * INV_SQRT_MWHBR
               CBAR_BRNO3 = CBAR_COEFF * INV_SQRT_MWBRNO3       
               CBAR_BRNO2 = CBAR_COEFF * INV_SQRT_MWBRNO2
               CBAR_HOBR  = CBAR_COEFF * INV_SQRT_MWHOBR                 
               CBAR_I2O2  = CBAR_COEFF * INV_SQRT_MWI2O2
               CBAR_I2O3  = CBAR_COEFF * INV_SQRT_MWI2O3
               CBAR_I2O4  = CBAR_COEFF * INV_SQRT_MWI2O4
               CBAR_INO3  = CBAR_COEFF * INV_SQRT_MWINO3
               CBAR_INO2  = CBAR_COEFF * INV_SQRT_MWINO2
               CBAR_HOI   = CBAR_COEFF * INV_SQRT_MWHOI

C *** correct N2O5 molecular diffusivity for ambient conditions

               INV_DIFFUSIVITY = 1.0D0 / ( STD_DIFF_N2O5 * ADJUST_DIFF )

C *** correct molecular diffusivity for ambient conditions - assumed similar to that of N2O5

               INV_DIFF_CLNO3  = 1.0D0 / ( STD_DIFF_CLNO3 * ADJUST_DIFF )
               INV_DIFF_HBR    = 1.0D0 / ( STD_DIFF_HBR * ADJUST_DIFF )
               INV_DIFF_BRNO3  = 1.0D0 / ( STD_DIFF_BRNO3 * ADJUST_DIFF )
               INV_DIFF_BRNO2  = 1.0D0 / ( STD_DIFF_BRNO2 * ADJUST_DIFF )
               INV_DIFF_HOBR   = 1.0D0 / ( STD_DIFF_HOBR * ADJUST_DIFF )
               INV_DIFF_I2O2   = 1.0D0 / ( STD_DIFF_I2O2 * ADJUST_DIFF )
               INV_DIFF_I2O3   = 1.0D0 / ( STD_DIFF_I2O3 * ADJUST_DIFF )
               INV_DIFF_I2O4   = 1.0D0 / ( STD_DIFF_I2O4 * ADJUST_DIFF )
               INV_DIFF_INO3   = 1.0D0 / ( STD_DIFF_INO3 * ADJUST_DIFF )
               INV_DIFF_INO2   = 1.0D0 / ( STD_DIFF_INO2  * ADJUST_DIFF )
               INV_DIFF_HOI    = 1.0D0 / ( STD_DIFF_HOI * ADJUST_DIFF )

C *** get KN2O5 rate constants YIELD_CLNO2 for each mode
               YIELD_CLNO2 = 0.0D0
               YIELDIJ     = 0.0D0

               DO N = 1, N_MODE          

                  IF ( N .LE. 2 ) THEN
                     GAMMA = N2O5_GAMMA( AIRTEMP, AIRRH, 0 )
                     IF ( L_ELMO ) GAMMA_N2O5IJ( C,R,L ) = REAL( GAMMA, 4 )
                  ELSE IF ( N .EQ. 3 ) THEN
                     GAMMA = N2O5_GAMMA( AIRTEMP, AIRRH, 5 )
                     IF ( L_ELMO ) GAMMA_N2O5K( C,R,L ) = REAL( GAMMA, 4 )
                  ELSE
                     GAMMA = 0.0D0
                  END IF
                                     
                  XXF( N ) = WET_M2( N )
     &                    / ( 4.0D0 + 0.5D0 * DE_WET( N ) * GAMMA * CBAR * INV_DIFFUSIVITY )
     
                  KN2O5( N ) = GAMMA * XXF( N )

                  IF ( GAMMA_NO3 .GT. 0.0D0 ) THEN
                     KNO3( N ) = GAMMA_NO3 * WET_M2( N ) 
     &                         / ( 4.0D0 + 0.5D0 * DE_WET( N ) * GAMMA_NO3 
     &                         * CBARNO3 * INV_DIFFUSIVITY ) * CBARNO3 * DPI
                  ELSE
                     KNO3( N ) = 0.0d0
                  END IF

                  IF( GAMMA_GLY .GT. 0.0D0) THEN
                     KGLY( N ) = GAMMA_GLY * WET_M2( N ) 
     &                         / ( 4.0D0 + 0.5D0 * DE_WET( N ) * GAMMA_GLY 
     &                         * CBARGLY * INV_DIFFUSIVITY ) * CBARGLY * DPI
                     ! scale MGLY uptake by relative H-law (Marais et
                     ! al. ACPD approach) implemented 1/2016 H. Pye
                     KMGLY( N ) = 0.09 * GAMMA_GLY * WET_M2( N ) 
     &                          / ( 4.0D0 + 0.5D0 * DE_WET( N ) * 0.09 * GAMMA_GLY 
     &                          * CBARMGLY * INV_DIFFUSIVITY ) * CBARMGLY * DPI
                  ELSE
                     KGLY( N ) = 0.0D0
                     KMGLY( N ) = 0.0D0
                  END IF

                  IF( GAMMA_HO2 .GT. 0.0D0) THEN
                     KHO2( N ) = GAMMA_HO2 * WET_M2( N )
     &                         / ( 4.0D0 + 0.5D0 * DE_WET( N ) * GAMMA_HO2
     &                         * CBARHO2 * INV_DIFFUSIVITY ) * CBARHO2 * DPI
                  ELSE
                     KHO2( N ) = 0.0D0
                  END IF


c *** get fine aerosol H2O and chlorine concentrations in
                  AH2O = aerospc_conc( AH2O_IDX,N )
                  ACL  = aerospc_conc( ACL_IDX, N )
                  CL_PPM( N ) = PPM_FACTOR * ( ACL * INV_MWCL )

      If ( Index( mechname, 'CB6R5M_AE7_AQ' ) .Gt. 0 ) Then 
         ABR  = aerospc_conc( ABR_IDX, N ) 
         INV_MWBR  = REAL( 1.0 / aerospc_mw( ABR_IDX ), 8 )  
         BR_PPM( N ) = PPM_FACTOR * ( ABR * INV_MWBR ) 
      Else
         BR_PPM( N ) = 0.0D0  
      End If

C *** If only a small amount of water is present on aerosol, keep YIELD_CLNO2 zero
                 IF ( AH2O .GT. 5.0E-01 .AND. ACL .GT. 1.0E-04 ) THEN
                     IF ( MWH2OCL * ACL .GT. 1.0E-4 * AH2O ) THEN 
                        YIELD_CLNO2( N ) = 1.0D0
     &                                   / ( 1.0D0 + ( 1.0D0 / 483.0D0 ) * ( AH2O / ACL ) * MWCLH2O )
                     END IF
                  END IF
 
               END DO ! End each mode 

c *** compute yield from lumped Aitken and Accumulations concentrations
               AH2O = aerospc_conc( AH2O_IDX,1 ) + aerospc_conc( AH2O_IDX,2 )
               ACL  = aerospc_conc( ACL_IDX,1 )  + aerospc_conc( ACL_IDX,2 )
               IF ( AH2O .GT. 5.0E-01 .AND. ACL .GT. 1.0E-04 ) THEN
                  IF ( MWH2OCL * ACL .GT. 1.0E-4 * AH2O ) THEN 
                     YIELDIJ = 1.0D0 / ( 1.0D0 + ( 1.0D0 / 483.0D0 )
     &                       * REAL( ( AH2O / ACL ) * MWCLH2O, 8 ) )
                  END IF
               END IF  
              
               KN2O5 = CBAR * DPI * KN2O5
C *** calculate aerosol surface area
               TOTSURFA = ( WET_M2( 1 ) + WET_M2( 2 ) ) * DPI

C *** Calculate IEPOX and MAE uptake information for accumulation mode
               RADIUS_I  = 0.5D0 * DE_WET( 1 ) ! particle size - i-mode
               RADIUS    = 0.5D0 * DE_WET( 2 ) ! particle size - j-mode

C *** Calculate approximate seasalt surface area, m2/m3
C *** Main components of Seasalt are: NA, CL, MG, K, CA, SO4
C *** However, SO4 over seawater can generate from other sources
C *** Fo SO4, use SO4/NA emissions ratio in seasalt

               MARINE_AREA = ( OCEAN( C,R ) + SZONE( C,R ) )

                IF ( MARINE_AREA .GT. 0.0 ) THEN
                 SSALT_VOL  =   1.0D-9 * ( Real ( aerospc_conc( ANA_IDX,2 ) / aerospc(ANA_IDX)%density, 8 ) +          ! NAJ - m3/m3
     @                                    Real ( aerospc_conc( ACL_IDX,2 ) / aerospc(ACL_IDX)%density, 8 ) +          ! CLJ - m3/m3
     @                                    Real ( aerospc_conc( AMG_IDX,2 ) / aerospc(AMG_IDX)%density, 8 ) +          ! MGJ - m3/m3
     @                                    Real ( aerospc_conc( AK_IDX,2 )  / aerospc(AK_IDX)%density, 8  ) +          ! KJ - m3/m3
     @                                    Real ( aerospc_conc( ACA_IDX,2 ) / aerospc(ACA_IDX)%density, 8 ) +          ! CAJ - m3/m3
     @                                    Real ( 0.2514 * aerospc_conc( ANA_IDX,2 ) / aerospc(ASO4_IDX)%density, 8) ) ! SO4 - m3/m3 - use SO4/NA ratio in seasalt

                SSALT_SURFA = ( 3.0D0 * SSALT_VOL / RADIUS ) * DEXP ( 0.5D0 * AEROMODE_LNSG( 2 ) * AEROMODE_LNSG( 2 ) )
               ELSE
                SSALT_SURFA = 0.0
                ENDIF

C *** calculate GAMMA_HBR  
      GAMMA_HBR = 1.3D-8 * DEXP ( 4290/ AIRTEMP) 
      INV_GAMMA_HBR = 1.0D0 / GAMMA_HBR
                                                                                                               
C *** set up variables needed for calculating K_BRONO2              
               CLNO3_H2O_RXN_TIME   = 4.0D0 * INV_GAMMA_CLNO3_H2O / CBAR_CLNO3
               HBR_RXN_TIME         = 4.0D0 * INV_GAMMA_HBR / CBAR_HBR 
               BRNO3_H2O_RXN_TIME   = 4.0D0 * INV_GAMMA_BRNO3_H2O / CBAR_BRNO3
               HOBR_ASS_RXN_TIME    = 4.0D0 * INV_GAMMA_HOBR_ASS  / CBAR_HOBR
               BRNO3_RXN_TIME       = 4.0D0 * INV_GAMMA_BRNO3 / CBAR_BRNO3
               BRNO2_RXN_TIME       = 4.0D0 * INV_GAMMA_BRNO2 / CBAR_BRNO2
               I2O2_RXN_TIME        = 4.0D0 * INV_GAMMA_I2O2 / CBAR_I2O2
               I2O3_RXN_TIME        = 4.0D0 * INV_GAMMA_I2O3 / CBAR_I2O3
               I2O4_RXN_TIME        = 4.0D0 * INV_GAMMA_I2O4 / CBAR_I2O4
               INO3_RXN_TIME        = 4.0D0 * INV_GAMMA_INO3 / CBAR_INO3
               INO2_RXN_TIME        = 4.0D0 * INV_GAMMA_INO2 / CBAR_INO2
               HOI_RXN_TIME         = 4.0D0 * INV_GAMMA_HOI  / CBAR_HOI
              
! Only do aerosol nitrate photolysis for CRACMM3
               If ( ( Index( mechname, 'CRACMM3' ) .Gt. 0 ) ) Then 
C...  calculate cosine of zenith angle for the cell and determine day or night; Golam Sarwar
                 
                 COSZ = MET_DATA%COSZEN( C, R )
                 
                 IF ( COSZ .LE. 0.0 ) THEN
                      DARK = .TRUE.   ! night
                      JHNO3 = 0.0D0                                 ! 1/min
                 ELSE
                      DARK = .FALSE.  ! day
                      JHNO3 = RJ( C, R, L, LHNO3 )              ! 1/min                   
                 END IF
                 
! Calculate FAC_HNO3

                ANO3 = aerospc_conc( ANO3_IDX,1 ) + aerospc_conc( ANO3_IDX,2 )
                ANO3M = ANO3 / aerospc_mw( ANO3_IDX )
        
                ASEASTM = aerospc_conc( ASEAST_IDX, 2 ) / aerospc_mw( ASEAST_IDX )
               
                FAC_HNO3 = 100.0  / ( 1.0 + ( ANO3M / ASEASTM ))                
                FAC_HNO3 = AMAX1(10.0, FAC_HNO3)

                IF ( L_ELMO ) THEN 
                   IF (.NOT. DARK) THEN
                     EF_HNO3( C,R,L ) = FAC_HNO3
                   ELSE 
                     EF_HNO3( C,R,L ) = 0.0 
                   ENDIF
                ENDIF
               Else
                JHNO3    = 0.0D0
                FAC_HNO3 = 0.0D0
               End If

! Done FAC_HNO3       

               CBARIEPOX = CFACTOR_IEPOX * DSQRT( AIRTEMP )
               CBARIMAE  = CFACTOR_IMAE  * DSQRT( AIRTEMP )

               ! Rate constants and concentrations
               CALL CALCISOPGAMMAS( RADIUS, AIRTEMP, GAMMAIEPOX,
     &                              GAMMAIMAE, KPIEPOX, FH2O, FOS, FDIM1, FDIM2)

               IF( GAMMAIEPOX .GT. 1.0D-72 ) THEN
                  KIEPOX = WET_M2( 2 ) * DPI
     &                   / ( RADIUS * INV_DIFFUSIVITY +  4.0D0 / ( CBARIEPOX * GAMMAIEPOX) )
                  If ( AIETET_IDX .GT. 0 ) Then
                     TETROL_PPM  = PPM_FACTOR
     &                       * REAL( aerospc_conc( AIETET_IDX,2 ), 8 ) * INV_MWIETET
                  Else
                     TETROL_PPM = 0.0D0
                  End If 
                  If ( AIEOS_IDX .GT. 0 ) Then
                     IEPOXOS_PPM = PPM_FACTOR
     &                     * REAL( aerospc_conc( AIEOS_IDX,2 ), 8 ) * INV_MWIEOS
                  Else
                     IEPOXOS_PPM = 0.0D0
                  End If
                  If ( ASO4_IDX .GT. 0 ) Then
                     ASO4J_PPM = PPM_FACTOR
     &                     * REAL( aerospc_conc( ASO4_IDX,2 ), 8 ) * INV_MWASO4
                  Else
                     ASO4J_PPM = 0.0D0
                  End If
               ELSE
                  KIEPOX = 0.0D0
                  TETROL_PPM = 0.0D0
                  IEPOXOS_PPM = 0.0D0
                  ASO4J_PPM = 0.0D0
               END IF

               IF( GAMMAIMAE .GT. 1.0D-72 ) THEN
                  KIMAE = WET_M2( 2 ) * DPI
     &                  / ( RADIUS * INV_DIFFUSIVITY + 4.0D0 / ( CBARIMAE * GAMMAIMAE ) )
               ELSE
                  KIMAE = 0.0d0
               END IF

C *** PFAS gamma & rates
              CALL CALCPFASGAMMAS( RADIUS, AIRTEMP, GAMMA_HFPODAF, 
     &                             GAMMA_COF2, GAMMA_PFMOAF, KPHFPODAF,
     &                             KPCOF2, KPPFMOAF)

                  IF( GAMMA_HFPODAF .GT. 0.0D0) THEN
                  KHFPODAF = WET_M2( 2 ) * DPI
     &                   / ( RADIUS * INV_DIFFUSIVITY +  4.0D0 / (CBAR_HFPODAF * GAMMA_HFPODAF)) !same formula as GLY (just rearranged)
                  ELSE
                     KHFPODAF = 0.0D0
                  END IF

                  IF( GAMMA_COF2 .GT. 0.0D0) THEN
                  KCOF2 = WET_M2( 2 ) * DPI
     &                   / ( RADIUS * INV_DIFFUSIVITY +  4.0D0 /(CBAR_COF2 * GAMMA_COF2)) !same formula as GLY (just rearranged)
                  ELSE
                     KCOF2 = 0.0D0
                  END IF

                  IF( GAMMA_PFMOAF .GT. 0.0D0) THEN
                  KPFMOAF = WET_M2( 2 ) * DPI
     &                   / ( RADIUS * INV_DIFFUSIVITY +  4.0D0 / (CBAR_PFMOAF * GAMMA_HFPODAF)) !same formula as GLY (just rearranged)
                  ELSE
                     KPFMOAF = 0.0D0
                  END IF

C end PFAS section

               ! Diagnostic information for ELMO
               IF ( L_ELMO ) GAMMA_IEPOX( C,R,L ) = REAL( GAMMAIEPOX,4 )
               IF ( L_ELMO ) GAMMA_IMAE(  C,R,L ) = REAL( GAMMAIMAE, 4 )
               IF ( L_ELMO ) KPARTIEPOX(  C,R,L ) = REAL( KPIEPOX,   4 )
               IF ( L_ELMO ) GAMMAHFPODAF(C,R,L ) = REAL( GAMMA_HFPODAF,4 )
               IF ( L_ELMO ) GAMMACOF2(   C,R,L ) = REAL( GAMMA_COF2,   4 )
               IF ( L_ELMO ) GAMMAPFMOAF( C,R,L ) = REAL( GAMMA_PFMOAF, 4 )
               IF ( L_ELMO ) KpartHFPODAF(C,R,L ) = REAL( KPHFPODAF, 4 )
               IF ( L_ELMO ) KpartCOF2(   C,R,L ) = REAL( KPCOF2,    4 )
               IF ( L_ELMO ) KpartPFMOAF( C,R,L ) = REAL( KPPFMOAF,  4 )

               LOOP_RATES: DO IRATE = 1, SELECTED_AERO_RATES
 
               SELECT CASE( WHICH_AERO_RATE( IRATE ) )
                  CASE( IA_N2O5IJ )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * ( KN2O5( 1 ) + KN2O5( 2 ) )! convert to min-1
                          
                  CASE( IA_N2O5K )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * KN2O5 (3) ! convert to min-1
                     
                  CASE( IA_N2O5J )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * KN2O5 (2) ! convert to min-1
                     
                  CASE( IA_N2O5I )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * KN2O5 (1) ! convert to min-1
                     
                  CASE( IA_N2O5IJY )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * YIELDIJ * ( KN2O5( 1 ) + KN2O5( 2 ) ) ! convert to min-1
                     IF ( L_ELMO ) YCLNO2IJ( C,R,L ) = REAL( YIELDIJ, 4 )

                  CASE( IA_N2O5KY )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * YIELD_CLNO2( 3 ) * KN2O5( 3 ) 
                     IF ( L_ELMO ) YCLNO2K( C,R,L ) = REAL( YIELD_CLNO2( 3 ), 4 )

                  CASE( IA_H2NO3PAIJ )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                       *  MAX( ( 1.0D0 - YIELDIJ ), 0.0D0 ) 
                     IF ( L_ELMO ) YCLNO2IJ( C,R,L ) = REAL( YIELDIJ, 4 )
                     
                  CASE( IA_H2NO3PBIJ )  
                     IF ( YIELDIJ .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY * YIELDIJ 
     &                                          / ( CL_PPM( 1 ) + CL_PPM( 2 ) )   ! 1/(min*ppm)
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF
                     
                  CASE( IA_H2NO3PAI )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                       * MAX( ( 1.0D0 - YIELD_CLNO2( 1 ) ), 0.0D0 ) 

                  CASE( IA_H2NO3PBI )
                     IF ( YIELD_CLNO2( 1 ) .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                          * YIELD_CLNO2( 1 ) / CL_PPM( 1 ) ! (min*ppm)-1
                        IF ( L_ELMO ) THEN
                           FACTOR = CL_PPM( 1 ) / ( CL_PPM( 1 )+ CL_PPM( 2 ) )
                           YCLNO2IJ( C,R,L ) = REAL( FACTOR * YIELD_CLNO2( 1 ), 4 ) 
     &                                       + YCLNO2IJ( C,R,L )
                        END IF
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF 
                              
                  CASE( IA_H2NO3PAJ )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                       * MAX( ( 1.0D0 - YIELD_CLNO2( 2 ) ), 0.0D0 ) 
                               
                  CASE( IA_H2NO3PBJ )
                     IF (  YIELD_CLNO2( 2 ) .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) =  60.0D0 * AQUEOUS_FREQUENCY
     &                                          *  YIELD_CLNO2( 2 ) / CL_PPM( 2 ) ! (min*ppm)-1
                        IF ( L_ELMO ) THEN
                           FACTOR = CL_PPM( 2 ) / ( CL_PPM( 1 )+ CL_PPM( 2 ) )
                           YCLNO2IJ( C,R,L ) = YCLNO2IJ( C,R,L ) + REAL( FACTOR * YIELD_CLNO2( 2 ), 4 ) 
                        END IF                               
                     ELSE
                          KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF 
                                
                  CASE( IA_PNCOMLI )
                     POC   = aerospc_conc( APOC_IDX,1 )
                     PNCOM = aerospc_conc( APNCOM_IDX,1 )
                     KHETERO( IRATE, C,R,L ) = RFACTOR * PNCOM_LOSS( POC, PNCOM )
                      
                  CASE( IA_PNCOMLJ )
                     POC   = aerospc_conc( APOC_IDX,2 )
                     PNCOM = aerospc_conc( APNCOM_IDX,2 )
                     KHETERO( IRATE, C,R,L ) = RFACTOR * PNCOM_LOSS( POC, PNCOM )

                  CASE( IA_H2NO3PAK )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                       *  MAX( ( 1.0D0 - YIELD_CLNO2( 3 ) ), 0.0D0 ) ! * KN2O5( 3 )
                               
                  CASE( IA_H2NO3PBK )
                     IF ( YIELD_CLNO2( 3 ) .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                          * YIELD_CLNO2( 3 ) / CL_PPM( 3 ) ! (min*ppm)-1
                        IF ( L_ELMO ) YCLNO2K( C,R,L ) = REAL( YIELD_CLNO2( 3 ), 4 ) 
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF 
                               
                  CASE( IA_NO2 )
C *** calculate pseudo-first order rate constant for NO2 loss using Eq 1 of Vogel
C     et al. (2003). Units of KNO2 is in 1/min in the paper; divide it
C     by 60 to convert it into 1/sec
                     KNO2 = MAX ( 0.0D0, 1.0D-04 * TOTSURFA )
                     KHETERO( IRATE, C,R,L )  = 60.0D0 * KNO2 ! convert to min-1

C ***            Isoprene epoxide uptake
                 CASE( IA_IEPOX )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * KIEPOX ! min-1

                 CASE( IA_TETROL )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY * FH2O( 1 )

                 CASE( IA_IEPOXOS )
                     IF ( ASO4J_PPM .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY 
     &                                          * FOS( 1 ) / ASO4J_PPM
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF

                 CASE( IA_TETROLDIM )
                     IF ( TETROL_PPM .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                          * FDIM1( 1 ) / TETROL_PPM ! min*ppm-1  
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF

                 CASE( IA_IEPOXOSDI )
                     IF ( IEPOXOS_PPM .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                          * FDIM2( 1 ) / IEPOXOS_PPM ! min*ppm-1
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF

                 CASE( IA_IMAE )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * KIMAE ! min-1

                 CASE( IA_2MG )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY * FH2O(2)

                 CASE( IA_IMAEOS )
                     IF ( ASO4J_PPM .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY 
     &                                         * FOS(2) / ASO4J_PPM
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF


C *** CRACMM1 Implementation of sulfated and non-sulfated IEPOX-SOA

                 CASE( IA_ISO3NOSJ )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY * FH2O( 1 )

                 CASE( IA_ISO3OSJ )
                     IF ( ASO4J_PPM .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                          * FOS( 1 ) / ASO4J_PPM
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF


                 CASE( IA_NO3 )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * ( KNO3( 1 ) + KNO3( 2 ) ) ! min-1

                 CASE( IA_GLY )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * (  KGLY( 2 ) ) ! min-1

                 CASE( IA_MGLY )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * (  KMGLY( 2 ) ) ! min-1
                 
                 CASE( IA_HO2 )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * (  KHO2( 2 ) ) ! min-1

C *** PFAS
                 CASE( IA_HFPODAF )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * (  KHFPODAF ) ! min-1

                 CASE( IA_COF2 )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * (  KCOF2 ) ! min-1

                 CASE( IA_PFMOAF )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * (  KPFMOAF ) ! min-1


                 CASE( IA_NTR2 )
C *** calculate gas-particle partitioning of NTR2
                    CON_TOA = SUM( SUM( AEROSPC_CONC( :,1:2 ),2 ), 
     &                        MASK = ( AEROSPC( : )%OM .AND. .NOT. AEROSPC( : )%TRACER ) )
                    
                    F_PART_NTR2 = 0.0
                    IF ( CON_TOA .GE. MIN_TOA ) THEN
                       F_PART_NTR2 = ON_ALPHA1 / ( 1.0 + ON_CSTAR1 / CON_TOA )
     &                             + ON_ALPHA2 / ( 1.0 + ON_CSTAR2 / CON_TOA )
                    END IF

C *** calculate pseudo-first order rate constant for heterogeneous NTR2
C hydrolysis
                     IF ( AIRRH .LE. 0.2D0 .OR. F_PART_NTR2 .LE. 0.0 ) THEN
                        KHETERO( IRATE, C, R, L ) = 0.0D0
                     ELSE IF ( AIRRH .GE. 0.4D0 ) THEN
                        KHETERO( IRATE, C, R, L ) = REAL( F_PART_NTR2 * KHON, 8 ) ! [1/min]
                     ELSE
                        KHETERO( IRATE, C, R, L ) = REAL( F_PART_NTR2 * KHON, 8 ) ! [1/min]
     &                                            * ( 5.0D0 * AIRRH - 1.0D0 )
                     END IF

                CASE( IA_CLNO3_WAI )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 1 ) * DPI / ( RADIUS_I * INV_DIFF_CLNO3 + CLNO3_H2O_RXN_TIME )

                CASE( IA_CLNO3_WAJ )   
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_CLNO3 + CLNO3_H2O_RXN_TIME )  

                 CASE( IA_HBR_BRJ )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * SSALT_SURFA / ( RADIUS * INV_DIFF_HBR + HBR_RXN_TIME )  ! use sea-salt surface area

                 CASE( IA_BRNO3_WAI )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 1 ) * DPI / ( RADIUS_I * INV_DIFF_BRNO3 + BRNO3_H2O_RXN_TIME )

                 CASE( IA_BRNO3_WAJ )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_BRNO3 + BRNO3_H2O_RXN_TIME )

                 CASE( IA_HOBR_CLJ )
                  K1 = 0.35 * SSALT_SURFA / ( RADIUS * INV_DIFF_HOBR + HOBR_ASS_RXN_TIME ) ! use sea-salt surface area
                  IF ( CL_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (2) 
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_HOBR_BRJ )
                  K1 = 0.65 * SSALT_SURFA / ( RADIUS * INV_DIFF_HOBR + HOBR_ASS_RXN_TIME )       ! use sea-salt surface area
                  IF ( BR_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (2)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_BRNO3_CLJ )
                  K1 = 0.35 * SSALT_SURFA / ( RADIUS * INV_DIFF_BRNO3 + BRNO3_RXN_TIME )         ! use sea-salt surface area
                  IF ( CL_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0
                  ENDIF

                 CASE( IA_BRNO3_BRJ )
                  K1 = 0.65 * SSALT_SURFA / ( RADIUS * INV_DIFF_BRNO3 + BRNO3_RXN_TIME )         ! use sea-salt surface area
                  IF ( BR_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0
                  ENDIF

                 CASE( IA_BRNO2_CLJ )
                  K1 =  0.35 * SSALT_SURFA / ( RADIUS * INV_DIFF_BRNO2 + BRNO2_RXN_TIME )        ! use sea-salt surface area
                  IF ( CL_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                    KHETERO( IRATE, C,R,L ) = 0.0D0
                  ENDIF

                 CASE( IA_BRNO2_BRJ )
                  K1 =  0.65 * SSALT_SURFA / ( RADIUS * INV_DIFF_BRNO2 + BRNO2_RXN_TIME )       ! use sea-salt surface area
                  IF ( BR_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                    KHETERO( IRATE, C,R,L ) = 0.0D0
                  ENDIF

                 CASE( IA_I2O2_AI )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 1 ) * DPI / ( RADIUS_I * INV_DIFF_I2O2 + I2O2_RXN_TIME )

                 CASE( IA_I2O2_AJ )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_I2O2 + I2O2_RXN_TIME ) 

                 CASE( IA_I2O3_AI )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 1 ) * DPI / ( RADIUS_I * INV_DIFF_I2O3 + I2O3_RXN_TIME )

                 CASE( IA_I2O3_AJ ) 
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_I2O3 + I2O3_RXN_TIME )

                 CASE( IA_I2O4_AI )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 1 ) * DPI / ( RADIUS_I * INV_DIFF_I2O4 + I2O4_RXN_TIME )

                 CASE( IA_I2O4_AJ )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_I2O4 + I2O4_RXN_TIME ) 

                 CASE( IA_INO3_CLJ )          
                  K1 = 0.5 * SSALT_SURFA / ( RADIUS * INV_DIFF_INO3 + INO3_RXN_TIME )        ! use sea-salt surface area
                  IF ( CL_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_INO3_BRJ )
                  K1 = 0.5 * SSALT_SURFA / ( RADIUS * INV_DIFF_INO3 + INO3_RXN_TIME )        ! use sea-salt surface area
                  IF ( BR_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_INO2_CLJ )
                  K1 =  0.5 * SSALT_SURFA / ( RADIUS * INV_DIFF_INO2 + INO2_RXN_TIME )       ! use sea-salt surface area
                  IF ( CL_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_INO2_BRJ )
                  K1 =  0.5 * SSALT_SURFA / ( RADIUS * INV_DIFF_INO2 + INO2_RXN_TIME )        ! use sea-salt surface area
                  IF ( BR_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_HOI_CLJ )                            
                  K1 = 0.5 * SSALT_SURFA / ( RADIUS * INV_DIFF_HOI + HOI_RXN_TIME )           ! use sea-salt surface area
                  IF ( CL_PPM (2) .GT. MIN_VALUE ) THEN
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF 

                 CASE( IA_HOI_BRJ )                            
                  K1 = 0.5 * SSALT_SURFA / ( RADIUS * INV_DIFF_HOI + HOI_RXN_TIME )           ! use sea-salt surface area
                  IF ( BR_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                CASE( IA_ANO3 )                                   
                  KHETERO( IRATE, C,R,L ) = JHNO3 * FAC_HNO3                                                          ! 1/min 

               END SELECT

            END DO LOOP_RATES

#ifdef verbose_aerosol_chemistry
            IF ( DUMP_CELL ) THEN

               WRITE( LOGDEV,* ) 'In GAS HETCHEM for MYPE = ', MYPE
               WRITE( LOGDEV,9499 ) C,R,L
               WRITE( LOGDEV,9500 ) 'TEMP        = ', AIRTEMP
               WRITE( LOGDEV,9500 ) 'AIRRH       = ', AIRRH
               WRITE( LOGDEV,9500 ) 'DIFFUSIVITY = ', 1.0 / INV_DIFFUSIVITY
               WRITE( LOGDEV,9500 ) 'INV_SQRT_MWN2O5 = ', INV_SQRT_MWN2O5
               WRITE( LOGDEV,9500 ) 'CBAR_COEFF      = ', CBAR_COEFF
               WRITE( LOGDEV,9500 ) 'CBAR        = ', CBAR
               WRITE( LOGDEV,9500 ) 'PPM_FACTORA = ',
     &                UGM3_CONV_FAC * REAL( TEMP( C,R,L ) / PRESS( C,R,L ), 8 )
               WRITE( LOGDEV,9500 ) 'PPM_FACTOR = ', PPM_FACTOR
               WRITE( LOGDEV,9500 ) 'PPM_FACTOR*INV_MWCL = ', PPM_FACTOR * INV_MWCL
               WRITE( LOGDEV,9500 ) 'PPM_FACTORA*INV_MWCL = ',
     &                UGM3_CONV_FAC * REAL( TEMP( C,R,L ) / PRESS( C,R,L ), 8 ) * INV_MWCL
               WRITE( LOGDEV,9500 ) 'ACLI_PPM  = ', CL_PPM( 1 )
               WRITE( LOGDEV,9500 ) 'ACLJ_PPM  = ', CL_PPM( 2 )
               WRITE( LOGDEV,9500 ) 'ACLK_PPM  = ', CL_PPM( 3 )
               WRITE( LOGDEV,9500 ) 'ANH4I = ', aerospc_conc( ANH4_IDX,1 ) 
               WRITE( LOGDEV,9500 ) 'ANO3I = ', aerospc_conc( ANO3_IDX,1 ) 
               WRITE( LOGDEV,9500 ) 'ASO4I = ', aerospc_conc( ASO4_IDX,1 ) 
               WRITE( LOGDEV,9500 ) 'ACLI  = ', aerospc_conc( ACL_IDX,1 ) 
               WRITE( LOGDEV,9500 ) 'AH2OI = ', aerospc_conc( AH2O_IDX,1 ) 
               WRITE( LOGDEV,9500 ) 'ANH4J = ', aerospc_conc( ANH4_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ANO3J = ', aerospc_conc( ANO3_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ASO4J = ', aerospc_conc( ASO4_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ACLJ  = ', aerospc_conc( ACL_IDX,2) 
               WRITE( LOGDEV,9500 ) 'AH2OJ = ', aerospc_conc( AH2O_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ANH4IJ = ',
     &                aerospc_conc( ANH4_IDX,1 ) + aerospc_conc( ANH4_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ANO3IJ = ',
     &                aerospc_conc( ANO3_IDX,1 ) + aerospc_conc( ANO3_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ASO4IJ = ',
     &                aerospc_conc( ASO4_IDX,1 ) + aerospc_conc( ASO4_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ACLIJ  = ',
     &                aerospc_conc( ACL_IDX,1 ) + aerospc_conc( ACL_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'AH2OIJ = ',
     &                aerospc_conc( AH2O_IDX,1 ) + aerospc_conc( AH2O_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'GAMMA = ', N2O5_GAMMA( AIRTEMP, AIRRH, 0 )
               WRITE( LOGDEV,9500 ) 'ANH4K = ', aerospc_conc( ANH4_IDX,3 ) 
               WRITE( LOGDEV,9500 ) 'ANO3K = ', aerospc_conc( ANO3_IDX,3 ) 
               WRITE( LOGDEV,9500 ) 'ASO4K = ', aerospc_conc( ASO4_IDX,3 ) 
               WRITE( LOGDEV,9500 ) 'ACLK  = ', aerospc_conc( ACL_IDX, 3 ) 
               WRITE( LOGDEV,9500 ) 'AH2OK = ', aerospc_conc( AH2O_IDX,3 ) 
               WRITE( LOGDEV,9500 ) 'GAMMAK     = ', N2O5_GAMMA( AIRTEMP, AIRRH, 5 )
               WRITE( LOGDEV,9500 ) 'XXF_AT     = ', XXF( 1 )
               WRITE( LOGDEV,9500 ) 'XXF_AC     = ', XXF( 2 )
               WRITE( LOGDEV,9500 ) 'XXF_COR    = ', XXF( 3 )
               WRITE( LOGDEV,'( A )' ) 'Product/Nucleophile mapping for epox uptake:'
               DO N = 1, N_NUCPAIRS
                  WRITE( LOGDEV,'( 5X,A,I4 )' ) ACID_NUC_PAIRS( N )%PROD, ACID_PRODMAP_IDX( N )
                  WRITE( LOGDEV,'( 5X,A,I4 )' ) ACID_NUC_PAIRS( N )%NUC, ACID_NUCMAP_IDX( N )
               END DO
               WRITE( LOGDEV,9500 ) 'GAMMAIEPOX  = ', GAMMAIEPOX
               WRITE( LOGDEV,9500 ) 'GAMMAIMAE   = ', GAMMAIMAE
               WRITE( LOGDEV,9500 ) 'k_particle_iepox =       ', KPIEPOX
               WRITE( LOGDEV,9500 ) 'Fraction tetrol =        ', FH2O( 1 )
               WRITE( LOGDEV,9500 ) 'Fraction iepoxos =       ', FOS(  1 )
               WRITE( LOGDEV,9500 ) 'Fraction tetrol dimer =  ', FDIM1( 1 )
               WRITE( LOGDEV,9500 ) 'Fraction iepoxos dimer = ', FDIM2( 1 )
               WRITE( LOGDEV,9500 ) 'Fraction 2-MG =          ', FH2O( 2 )
               WRITE( LOGDEV,9500 ) 'Fraction mae-os =        ', FOS( 2 )
               WRITE( LOGDEV,9500 ) 'Fraction mae dimers = 0  ', FDIM1( 2 ) + FDIM2( 2 )
               WRITE( LOGDEV,9500 ) 'TETROL_PPM =             ', TETROL_PPM
               WRITE( LOGDEV,9500 ) 'IEPOXOS_PPM =            ', IEPOXOS_PPM
               WRITE( LOGDEV,9501 ) 'KN2O5IJ = ', 60.0D0 * ( KN2O5( 1 ) + KN2O5( 2 ) ),' 1/min'
               WRITE( LOGDEV,9501 ) 'KN2O5K =  ', 60.0D0 * KN2O5(3), ' 1/min'
               WRITE( LOGDEV,9501 ) 'KNO2  =   ', 60.0D0 * KNO2, ' 1/min'
               WRITE( LOGDEV,9501 ) 'YIELDI =  ', YIELD_CLNO2( 1 ), ' '
               WRITE( LOGDEV,9501 ) 'YIELDJ =  ', YIELD_CLNO2( 2 ), ' '
               WRITE( LOGDEV,9501 ) 'YIELDIJ = ', YIELDIJ, ' '
               WRITE( LOGDEV,9501 ) 'YIELDK =  ', YIELD_CLNO2( 3 ), ' '
               WRITE( LOGDEV,9501 ) 'F_PART_NTR2 =  ', F_PART_NTR2, ' '
               WRITE( LOGDEV,9501 ) 'GAMMA_NO3= ', GAMMA_NO3, ' '
               WRITE( LOGDEV,9501 ) 'GAMMA_GLY= ', GAMMA_GLY, ' '
               WRITE( LOGDEV,9501 ) 'GAMMA_HFPODAF= ', GAMMA_HFPODAF, ' '
               WRITE( LOGDEV,9501 ) 'GAMMA_COF2= ', GAMMA_COF2, ' '
               WRITE( LOGDEV,9501 ) 'GAMMA_PFMOAF= ', GAMMA_PFMOAF, ' '
               WRITE( LOGDEV,9501 ) 'GAMMA_HO2= ', GAMMA_HO2, ' '
               WRITE( LOGDEV,9501 ) 'KNO3(1)= ', KNO3( 1 ), ' '
               WRITE( LOGDEV,9501 ) 'KNO3(2)= ', KNO3( 2 ), ' '
               WRITE( LOGDEV,9501 ) 'KNO3(3)= ', KNO3( 3 ), ' '
               WRITE( LOGDEV,9501 ) 'KGLY(2)= ', KGLY( 2 ), ' '
               WRITE( LOGDEV,9501 ) 'KMGLY(2)= ', KMGLY( 2 ), ' '
               WRITE( LOGDEV,9501 ) 'KpartHFPODAF= ', KPHFPODAF, ' '
               WRITE( LOGDEV,9501 ) 'KpartCOF2= ', KPCOF2, ' '
               WRITE( LOGDEV,9501 ) 'KpartPFMOAF= ', KPPFMOAF, ' '
               WRITE( LOGDEV,9501 ) 'KHO2(2)= ', KHO2( 2 ), ' '

               DO N = 1, NHETERO
                  WRITE( LOGDEV,9501 ) HETERO( N ) // ' = ', KHETERO( N, C,R,L ),' '
               END DO
            END IF          
9499        FORMAT( 'At COL = ',I3,' ROW = ',I3,' LAY = ',I3 )
9500        FORMAT( A, ES12.4 )
9501        FORMAT( A, ES12.4, A )          
#endif
        
            END DO LOOP_COL
         END DO  LOOP_ROW
      END DO LOOP_LAY

      RETURN

      END SUBROUTINE HETCHEM_RATES

C ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      REAL( 8 ) FUNCTION PNCOM_LOSS( POC, PNCOM )
! Calculates rate constant in cm3 molec-1 sec-1 for PNCOM loss by reacting 
! with OH, derived from the reactions in the below POA aging scheme 
! in CMAQ v5.0-v5.02:
! start with the definition of POCRm 
!      - POCRm = reduced primary organic carbon (molar concentration)
!  changes POCRm correspond to changes in PNCOM via a rate constant
!  koheff*[OH] that comes from Weitkamp et al (2008) and George et al (2007)
!
! POCRm = POC/12 - Omoles
!  where Omoles represent fraction that is already PNCOM oxidized
! Omoles = NCOM/(16 + PHOrat) if 14/12 < (POC + NCOM)/POC <  44/12 
!      - see Simon et al (2011) for derivation
! Omoles = NCOM/16            if (POC + NCOM)/POC >= 44/12 
!      - interpretted as POC is fully oxidized and all 
!        NCOM is oxygen 
! Omoles = 0                  if (POC + NCOM)/POC <= 14/12 
!      - if OM/OC < 1.167, then POC is fully reduced and all 
!        NCOM is hydrogen
!      - see Simon et al. (2011) for derivation
! note:we divide POC by 12 b/c we want moles of carbon atoms not moles 
!      of POC (since each carbon atom w\in the molecule is allowed 
!      to react)
! note: we calculate Omoles based on the equations above derived from 
!      Heald et al (2010) and documented in Simon et al (2011).
!
! The following rate equation comes from the reaction above:
!      dPOCRm/dt = POCRm*koheff*[OH] 
!        -assume that [OH] does not change as a result of this reaction
!      solve for POCRm at time, t
!        moles: POCRm(t) = POCRm(0)*EXP(-koheff*[OH]*t) = POCRm(0)*expdt
!
!      One mole of "NCOMm" is formed for every mole of POCRm that reacts:
!             -dPOCRm/dt = dNCOMm/det
!        moles of NCOMm: NCOMm = NCOMm(0) + POCRm(0)*[1-EXP(-koheff*[OH]*t)] = 
!                        NCOMm(0) + POCRm(0)*(1-expdt)
!        NCOMg = NCOMm*15.0 
!          - every mole of newly formed NCOM results in an average gain of 1 oxygen atom 
!            and an average loss of 1 hydrogen atoms (on average, two oxidation steps 
!            convert a CH3 functional group into a COOH functional group) 
!               -(based on Heald et al. (2010)) 
!      Rewrite NCOM formation equation using grams: 
!        NCOMg/15.0 = NCOMg(0)/15.0 + POCRm*(1-expdt) 
!                         V 
!        NCOMg == NCOM(0) + 15.0*POCRm*(1-expdt)
!                          or
!        dNCOMg/dt = (15.0/12.0)*POC*koheff*[OH]-15.0*Omoles*PNCOM*koheff*[OH]
!            ----> 15.0*Omoles*koheff is rate constant of PNCOM loss
! 
! Key Subroutines Called: none
!
! Key Functions Called: none
!
! Revision History:
!    June 2014:  Bill Hutzell-initial version based on the poaaging subroutine
!                in CMAQ v5.0 thru v5.0.2.
! 
!  REFERENCES:
!   1. George, I.J., Vlasenko, A., Slowik, J.G., Broekhuizen, K., 
!      Abbatt, J.P.D. (2007), Heterogeneous oxidation of saturated
!      organic aerosols by hydroxyl radicals: uptake kinetics, 
!      condesned-phase products, and particle size change, 
!      Atmospheric Chemistry and Physics, 7, 4187-4201 
!     
!   2. Heald, C.L., Kroll, J.H., Jimenez, J.L., Docherty, K.S., 
!      DeCarlo, P.F., Aiken, A.C., Chen, Q., Martin, S.T., Farmer, S.T.,
!      Artaxo, P. (2010), A simplified description of the evolution of 
!      organic aerosol composition in the atmosphere, GRL, 37, L08803. 
!
!   3. Simon, H. and Bhave, P.V. (2011), Simulating the degree of oxidation 
!      in atmospheric organic particles  
!      In Review at ES&T.
!
!   4. Weitkamp, E.A., Lambe, A.T., Donahue, N.M., Robinson, A.L. (2008),
!      Laboratory measurements of the heterogeneous oxidation of condensed-
!      phase organic molecular markers for motor vehicl exhaust, 42, 
!      7950-7956.
!-----------------------------------------------------------------------
      
      IMPLICIT NONE
      
! Arguments: Note specific units do not material as long as consistent
!           between arguments, i.e., the same
       REAL, INTENT( IN ) :: POC    ! concentration of primary organic carbon
       REAL, INTENT( IN ) :: PNCOM  ! concentration of primart noncarbon organic matter
! Parameter:
       REAL( 8 ), PARAMETER :: KOHEFF      =  2.5D-12  ! POC + OH rate constant, cm3 molec-1 sec-1
       REAL,      PARAMETER :: LOWER_LIMIT =  7.0/6.0
       REAL,      PARAMETER :: UPPER_LIMIT = 11.0/3.0
       REAL( 8 ), PARAMETER :: MAX_RATE    = 15.0D0/16.0D0 * KOHEFF ! max rate constant for PNCOM loss
! Local    
       REAL( 8 )            :: RATIO   ! the hydrogen to oxygen ratio in organic matter
       
        PNCOM_LOSS = 0.0D0

        IF (  POC .LE. 1.0D-30 ) RETURN
              
        RATIO = REAL( ( POC + PNCOM ) / POC, 8 )

        IF ( RATIO .GT. LOWER_LIMIT .AND. RATIO .LT. UPPER_LIMIT ) THEN
           PNCOM_LOSS = 15.0D0 * KOHEFF
     &                / ( 16.0D0 + (UPPER_LIMIT - RATIO) / (RATIO - LOWER_LIMIT) )
        ELSE IF ( RATIO .GE. UPPER_LIMIT ) THEN 
           PNCOM_LOSS = MAX_RATE
        END IF
        
        RETURN   
      END FUNCTION PNCOM_LOSS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      REAL( 8 ) FUNCTION N2O5_GAMMA( TEMP, RH, GPARAM )

C  Calculates the N2O5 heterogeneous reaction probability, which is the
C  fraction of collisions between a gaseous N2O5 molecule and a particle
C  surface that leads to nitrate production.  In the literature, this
C  probability is commonly referred to with the Greek letter, GAMMA.  To
C  avoid conflicts with the intrinsic GAMMA function on some compilers,
C  we refer to the reaction probability as N2O5_GAMMA in this function.

C  A variety of parameterizations of N2O5_GAMMA are available in this
C  function.  Users may select among the different parameterizations
C  by changing the input argument, GPARAM.  This argument may take on
C  the following values (see code for further details):
C     1. Constant value of 0.1 based on Dentener & Crutzen (1993)
C     2. Function of particle SO4 and NO3, based on Riemer et al. (2003)
C     3. Function of RH, Temp, and particle composition, based on a
C        combination of parameterizations by Evans & Jacob (2005) and
C        Riemer et al. (2003)
C  If GPARAM matches none of the above values, the default calculation
C  of N2O5_GAMMA is a function of RH, T, particle composition, and phase
C  state, based on the parameterization by Davis et al. (2008).

C  Key Subroutines Called: none

C  Key Functions Called: CRYSTALIZED, FREEZES

C  Revision History:
C    First version was coded in November 2007 by Dr. Prakash Bhave
C    using excerpts of the HETCHEM subroutine, which contained only
C    one option for computing N2O5_GAMMA (i.e., GPARAM = 3).
C
C  PVB 11/03/07 Removed code that sets N2O5_GAMMA to zero when RH < 1%.
C
C  PVB 11/05/07 Corrected GPARAM = 3 option to fix the typographical
C               error in the paper by Evans & Jacob (2005), which was
C               found by Dr. Jerry Davis.
C
C  PVB 04/11/08 Updated formulas for LAM1 & LAM2 based on revised paper
C               by Davis et al. (2008).  Added APNDX flag so users may
C               switch between base parameterization and the alternative
C               discussed in Appendix A by Davis et al.  Set default
C               parameterization to match equations in Appendix A.
C               Reduced all regression coefficients by one decimal place
C               for consistency with revised paper.
C
C  JTK 04/17/08 Moved molar mass to AERO_INFO.f
C
C  SH  12/08/09 Use new Fortran modules (aero_data, met_data) in lieu of
C               CBLK array and AERO_INFO module
C
C  SH  03/10/11 Renamed met_data to aeromet_data

C  GS  09/12/14 Added an opiton for N2O5 heterogeneous reaction probability
C               based on Bertram and Thornton (2009) (fine and coarse mode)
 
C References:
C   1. Dentener, F.J. and P.J. Crutzen, Reaction of N2O5 on tropospheric
C      aerosols: Impact of global distributions of NOx, O3, and OH.
C      J. Geophys. Res., Vol 98, 7149-7163, 1993.
C
C   2. Riemer, N., H. Vogel, B. Vogel, B. Schell, I. Ackermann, C.
C      Kessler, and H. Hass, Impact of the heterogeneous hydrolysis
C      of N2O5 on chemistry of nitrate aerosol formation in the lower
C      troposphere under photosmog conditions.  J. Geophys. Res., Vol
C      108, No D4, 4144, doi:10.1029/2002JD002436, 2003.
C
C   3. Evans, M.J. and D.J. Jacob, Impact of new laboratory studies of
C      N2O5 hydrolysis on global model budgets of tropospheric nitrogen
C      oxides, ozone, and OH.  Geophys. Res. Lett., 32, L09813,
C      doi:10.1029/2005GL022469, 2005.
C
C   4. Davis, J.M., P.V. Bhave, and K.M. Foley, Parameterization of N2O5
C      reaction probabilities on the surface of particles containing
C      ammonium, sulfate, and nitrate.  Atmos. Chem. Phys., 2008, in
C      press.
C
C   5. Mentel, T.F., M. Sohn, and A. Wahner, Nitrate effect in the
C      heterogeneous hydrolysis of dinitrogen pentoxide on aqueous
C      aerosols.  Phys. Chem. Chem. Phys., 1, 5451-5457, 1999.
C
C   6. Bertram, T. H. and J.A. Thornton, Toward a general parameterization
C      of N2O5 reactivity on aqueous particles: the competing effects of 
C      particle liquid water, nitrate, and chloride, ACP, 9, 8351-8363, 2009. 

C-----------------------------------------------------------------------

      USE AERO_DATA
      USE CONST, ONLY: F6PI

      IMPLICIT NONE

C *** Arguments
      REAL( 8 ),    INTENT( IN ) :: TEMP     ! Air temperature [ K ]
      REAL( 8 ),    INTENT( IN ) :: RH       ! Fractional relative humidity
      INTEGER,      INTENT( IN ) :: GPARAM   ! switch to select among
                                             !  parameterizations

C *** Parameters

C *** switch for alternative parameterization of LAM1 & LAM2
C     when APNDX = .TRUE. (default), Eqs A1-A2 are used for reaction
C     probability on aqueous sulfate particles.  Alternatively, set
C     APNDX = .FALSE. to use Eqs 4-5.
      LOGICAL, PARAMETER :: APNDX = .TRUE.

C *** Local Variables

C *** chemical species concentrations [ug/m3]
      REAL      ANH4      ! i+j mode ammonium
      REAL      ANO3      ! i+j mode nitrate
      REAL      ASO4      ! i+j mode sulfate

C *** variables for computing N2O5_GAMMA when GPARAM = 2 or 3
      REAL      FRACSO4   ! aerosol mass ratio of SO4/(SO4+NO3)
      REAL      GAMMA1    ! upper limit of rxn prob
      REAL      GAMMA2    ! lower limit of rxn prob
      REAL      ALPHA     ! RH-dependent parameter to compute GAMMA1
      REAL      BETA      ! TEMP-dependent parameter to compute GAMMA1

C *** variables for default parameterization of N2O5_GAMMA
!     LOGICAL, EXTERNAL ::   CRYSTALIZED      ! function to determine if RH is below CRH
      LOGICAL   CRYSTAL   ! true if ambient RH < CRH, false otherwise
!     LOGICAL, EXTERNAL ::   FREEZES   ! function to determine whether RH exceeds IRH
      LOGICAL   FROZEN    ! true if ambient RH > IRH, false otherwise
      REAL      NNO3      ! particle-phase nitrate [micromoles/m3]
      REAL      NSO4      ! particle-phase sulfate [micromoles/m3]
      REAL      NNH4      ! particle-phase ammonium [micromoles/m3]
      REAL      NANI      ! particle-phase anions [micromoles/m3]
      REAL      X1        ! mole fraction of ammonium bisulfate
      REAL      X2        ! mole fraction of ammonium sulfate
      REAL      X3        ! mole fraction of ammonium nitrate
      REAL      LAM1      ! logit transformation of N2O5_GAMMA on
      REAL      LAM2      !   aqueous NH4HSO4 [LAM1], aqueous (NH4)2SO4
      REAL      LAM3      !   [LAM2], aqueous NH4NO3 [LAM3], and dry
      REAL      LAMD      !   sulfate-containing particles [LAMD]
      REAL      GAM1      ! reaction probability on aqueous NH4HSO4
      REAL      GAM2      !    "          "      "     "    (NH4)2SO4
      REAL      GAM3      !    "          "      "     "    NH4NO3
      REAL      GAMD      !    "          "      " dry sulfate particles
      REAL      T293,T291 ! temperature threshold variables
      REAL      RH46      ! RH threshold variable

C *** variables for parameterization based on Bertram and Thornton (2009)

      REAL      ACLF      ! I & J mode chloride, ug/m3 
      REAL      AH2OF     ! I & J mode water, ug/m3    
      REAL      ANO3F     ! I & J mode nitrate, ug/m3  

      REAL      ACLK      ! k mode chloride, ug/m3 
      REAL      AH2OK     ! k mode water, ug/m3    
      REAL      ANO3K     ! k mode nitrate, ug/m3  

      REAL      ACLM      ! chloride, [moles / liter of particles] 
      REAL      AH2OM     ! water,    [moles / liter of particles] 
      REAL      ANO3M     ! nitrate,  [moles / liter of particles] 
   
      REAL DEN1           ! local variable
      REAL DEN2           ! local variable
      REAL DEN            ! local variable
      REAL INV_VOL        ! local variable 
      
      REAL, PARAMETER :: A = 3.2E-08       ! Unit [s] - Table 2       
      REAL, PARAMETER :: BETA_BT = 1.15E06 ! Unit [1/s] - Table 2  
      REAL, PARAMETER :: DELTA = 1.3E-01   ! Unit [1/M] - Table 2  
      REAL, PARAMETER :: K3OK2B = 6.0E-02  ! Unit [ ] - Table 2  
      REAL, PARAMETER :: K4OK2B = 29.0     ! Unit [ ] - Table 2  
      REAL K2FP                            ! variable in eqn 10
                 
C *** statement function for inverting the logit transformation given
C     in Eq 7 by Davis et al (2008)
      REAL      LOGITINV  ! statement function
      REAL      XX        ! dummy argument for LOGITINV
      LOGITINV( XX ) = 1.0 / ( 1.0 + EXP( -XX ) )

C-----------------------------------------------------------------------

C *** retrieve fine-mode particle-phase ammonium, nitrate, and sulfate [ug/m3]
      ANH4 = aerospc_conc( ANH4_IDX,1 ) + aerospc_conc( ANH4_IDX,2 )
      ANO3 = aerospc_conc( ANO3_IDX,1 ) + aerospc_conc( ANO3_IDX,2 )
      ASO4 = aerospc_conc( ASO4_IDX,1 ) + aerospc_conc( ASO4_IDX,2 )

c *** Retrieve fine-mode particle-phase liquid water, chloride, nitrate [ug/m3]
      AH2OF  = aerospc_conc( AH2O_IDX,1 ) + aerospc_conc( AH2O_IDX,2 ) 
      ACLF   = aerospc_conc( ACL_IDX,1 )  + aerospc_conc( ACL_IDX,2 ) 
      ANO3F  = aerospc_conc( ANO3_IDX,1 ) + aerospc_conc( ANO3_IDX,2 )

c *** Retrieve coarse-mode particle-phase liquid water, chloride, nitrate [ug/m3]
      AH2OK  = aerospc_conc( AH2O_IDX,3 )
      ACLK   = aerospc_conc(  ACL_IDX,3 )
      ANO3K  = aerospc_conc( ANO3_IDX,3 )      

      WHAT_OPTION: SELECT CASE( GPARAM )

         CASE ( 1 )
C *** User Option: GPARAM = 1
C     Dentener and Crutzen (1993) recommended a constant value of
C     N2O5_GAMMA = 0.1, which was used in CMAQ prior to ver4.3.  In more
C     recent literature, this value has been recognized as an upper
C     estimate of N2O5_GAMMA so it should not be used for routine
C     simulations.  It is included here only to facilitate sensitivity
C     studies by CMAQ model users.

            N2O5_GAMMA = 0.1D0
            RETURN
            
         CASE( 2, 3 )
C *** User Options: GPARAM = 2 and 3
C     These options both employ Eqs 2 and 3 by Riemer et al (2003), in
C     which N2O5_GAMMA varies according to the particle-phase sulfate and
C     nitrate concentrations.  In both options, the NO3 effect (i.e.,
C     GAMMA1/GAMMA2) is assumed to be a factor of 10 based on Mentel et
C     al (1999) and Riemer et al (2003).
C      - When GPARAM = 2, upper limit of N2O5_GAMMA is fixed at 0.02.
C        This was the default setting in CMAQ ver4.3 through ver4.5.1.
C      - When GPARAM = 3, upper limit of N2O5_GAMMA is a function of
C        ambient TEMP & RH based on the "Sulfate" equation in Table 1
C        by Evans & Jacob (2005).  This was the default setting in CMAQ
C        ver4.6.  After that release, a typographical error was found
C        in the published equation of Evans & Jacob (2005) so this code
C        has been corrected accordingly.

            IF ( GPARAM .EQ. 2 ) THEN
            
                GAMMA1 = 0.02

            ELSE 
C        In this function, RH is in fractional units whereas the
C        published equation by Evans&Jacob refers to RH as a percentage.

               ALPHA = 2.79E-04
     &               + REAL( RH * ( 1.3D-02 + RH * ( -3.43D-02 + 7.52D-02 * RH ) ), 4 )

C        To fix the typographical error by Evans & Jacob (2005), the
C        sign of BETA has been switched in this code.

               IF ( TEMP .LT. 282.0D0 ) THEN
                  GAMMA1 = 3.0199517 * ALPHA   ! (10.0 ** 0.48) * ALPHA
               ELSE
                  BETA  = 0.04 * ( 294.0 - REAL( TEMP,4 ) )
                  GAMMA1 = ALPHA * ( 10.0 ** BETA )
               END IF
            END IF

            IF ( ANO3 .GT. 0.0 ) THEN
               FRACSO4 = ASO4 / ( ASO4 + ANO3 )
            ELSE
               FRACSO4 = 1.0
            END IF

            GAMMA2 = 0.1 * GAMMA1
            N2O5_GAMMA = REAL( ( GAMMA2 + FRACSO4 * ( GAMMA1 - GAMMA2 ) ), 8 )
   
            RETURN

         CASE ( 4 )

C *** User Option: GPARAM = 4  (fine-mode particles)
C *** It calculates N2O5_GAMMA based on Bertran and Thornton, 2009
  
            INV_VOL = 1.0E-9 * f6pi / REAL( ( WET_M3( 1 ) + WET_M3( 2 ) ), 4 )
        
            AH2OM = AH2OF * INV_VOL / aerospc_mw( AH2O_IDX )
            ACLM  = ACLF  * INV_VOL / aerospc_mw( ACL_IDX )
            ANO3M = ANO3F * INV_VOL / aerospc_mw( ANO3_IDX )
            
            K2FP =  BETA_BT - BETA_BT * EXP( -DELTA * AH2OM )
          
            DEN1 = K3OK2B * ( AH2OM / ANO3M )

            DEN2 = K4OK2B * ( ACLM  / ANO3M  )

            DEN  = DEN1 + 1.0 + DEN2
         
            N2O5_GAMMA = REAL( A * K2FP * (1.0 - 1.0 / DEN), 8 )
                   
            RETURN

         CASE ( 5 )
   
C *** User Option: GPARAM = 5 (coarse-mode particles)
C     It calculates N2O5_GAMMA based on Bertran and Thornton, 2009

            INV_VOL = 1.0E-9 * f6pi / REAL( WET_M3( 3 ), 4 )
        
            AH2OM = AH2OK * INV_VOL / aerospc_mw( AH2O_IDX )
            ACLM  = ACLK  * INV_VOL / aerospc_mw( ACL_IDX )
            ANO3M = ANO3K * INV_VOL / aerospc_mw( ANO3_IDX )
            
            K2FP =  BETA_BT - BETA_BT * EXP( -DELTA * AH2OM )
          
            DEN1 = K3OK2B * ( AH2OM / ANO3M )

            DEN2 = K4OK2B * ( ACLM  / ANO3M )

            DEN  = DEN1 + 1.0 + DEN2      

            N2O5_GAMMA = REAL( A * K2FP * (1.0 - 1.0 / DEN), 8)
                                                         
            RETURN
    
!           IF ( DUMP_CELL ) THEN
!              WRITE(*,*)'AH2OM = ',AH2OM
!              WRITE(*,*)'ACLM  = ',ACLM
!              WRITE(*,*)'ANO3M = ',ANO3M
!              WRITE(*,*)'DEN   = ',DEN
!              WRITE(*,*)'DEN1  = ',DEN1
!              WRITE(*,*)'DEN2  = ',DEN2
!              WRITE(*,*)'K2FP  = ',K2FP
!              WRITE(*,*)'GAMMAK = ',A * K2FP * (1.0 - 1.0 / DEN)
!           END IF
                                
!           RETURN
             
         CASE DEFAULT
      
C *** Default setting in current version of CMAQ:
C     This code implements the parameterization given in Eq 15 by Davis
C     et al (2008), in which N2O5_GAMMA is a function of RH, TEMP,
C     particle composition, and phase state.  Note: In this function, RH
C     is in fractional units whereas the published equations refer to RH
C     as a percentage.

C *** Check whether the ambient RH is below the crystallization RH for
C     the given inorganic particle composition.
            CRYSTAL = CRYSTALIZED( RH, .TRUE. )

C *** Check whether the ambient RH exceeds the RH of ice formation.
            FROZEN = FREEZES( TEMP, RH )
      
            IF ( FROZEN ) THEN
C *** Set N2O5_GAMMA to constant value if particles contain ice, based on
C     Eq 14 by Davis et al (2008).

               N2O5_GAMMA = 0.02D0                               ! Eq 14

            ELSE
C *** Compute mole-fractional-composition of particles based on Eq 11 by
C     Davis et al (2008).
               NNO3 = ANO3 / aerospc_mw( ANO3_IDX )
               NSO4 = ASO4 / aerospc_mw( ASO4_IDX )
               NNH4 = ANH4 / aerospc_mw( ANH4_IDX )
               NANI = NNO3 + NSO4
         
               X3 = NNO3 / NANI
               X2 = MAX( 0.0, MIN( 1.0 - X3, NNH4/NANI - 1.0 ) )
               X1 = 1.0 - ( X2 + X3 )

C *** Compute N2O5_GAMMA on pure NH4NO3 particles using Eqs 6 and 8 by
C     Davis et al (2008).
               LAM3 = -8.10774 + 4.902 * REAL( RH, 4 )            ! Eq 6
               GAM3 = MIN( LOGITINV( LAM3 ), 0.0154 )             ! Eq 8

C *** Compute N2O5_GAMMA on dry particles using Eqs 9, 10, and 13 by
C     Davis et al (2008).
               IF ( CRYSTAL ) THEN
                  T293     = MAX( 0.0, REAL( TEMP ) - 293.0 )
                  LAMD     = -6.13376 + 3.592 * REAL( RH, 4 )     ! Eq 9
     &                     - 0.19688 * T293
                  GAMD     = MIN( LOGITINV( LAMD ), 0.0124 )      ! Eq 10
                  N2O5_GAMMA = REAL( ( X1 + X2 ) * GAMD           ! Eq 13
     &                       +         X3 * MIN( GAMD, GAM3 ), 8)

C *** Compute N2O5_GAMMA on aqeuous particles using Eqs A1, A2, 8, and 12
C     by Davis et al (2008).  When APNDX = .TRUE. (default), Eqs A1-A2
C     are used for reaction probability on aqueous sulfate particles.
C     Switch to .FALSE. if Eqs 4-5 are desired.  See Appendix A by
C     Davis et al. (2008) for a discussion of these options.
               ELSE
                  T291 = MAX( 0.0, REAL( TEMP ) - 291.0 )
                  IF ( APNDX ) THEN
                     RH46  = MIN( 0.0, REAL( RH )- 0.46 )
                     LAM2  = -3.64849 + 9.553 * RH46          ! Eq A2
                     LAM1  = LAM2 + 0.97579                   ! Eqs A1 & A2
     &                     - 0.20427 * T291
                  ELSE
                     LAM1  = -4.10612 + 2.386 * REAL( RH )    ! Eq 4
     &                     - 0.23771 * T291
                     LAM2  = LAM1 - 0.80570                   ! Eqs 4 & 5
     &                     + 0.10225 * T291
                  END IF

                  GAM1     = MIN( LOGITINV( LAM1 ), 0.08585 ) ! Eq 8
                  GAM2     = MIN( LOGITINV( LAM2 ), 0.053 )   ! Eq 9
                  N2O5_GAMMA = REAL( ( X1 * GAM1 )            ! Eq 12
     &                       +       ( X2 * GAM2 )
     &                       +       ( X3 * GAM3 ), 8 )

               END IF
            END IF

      END SELECT WHAT_OPTION


      RETURN

      END FUNCTION N2O5_GAMMA

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      LOGICAL FUNCTION CRYSTALIZED( RH, COMPLETE )

C  Determines whether the ambient RH is below the crystallization relative
C  humidity (CRH).  The output of this logical function is .TRUE. when the
C  ambient RH is below the CRH and .FALSE. otherwise.  The empirical
C  equations developed by Martin et al (2003) are applied to determine the
C  CRH for a given mixture of sulfate, nitrate, and ammonium.  Though those
C  equations are validated only at 293K, they are applied at all ambient
C  temperatures because insufficient data exist to estimate the temperature
C  dependence of the CRH of mixed sulfate-nitrate-ammonium particles.
C  Users can opt to compute either the RH of initial crystal formation
C (i.e., COMPLETE .EQ. .FALSE.) or the RH of compete crystallization (i.e.,
C  COMPLETE .EQ. .TRUE.).

C  References:
C   1. Martin, S.T., J.C. Schlenker, A. Malinowski, H.-M. Hung, and
C      Y. Rudich, Crystallization of atmospheric sulfate-nitrate-
C      ammonium particles.  Geophys. Res. Lett., 30(21), 2102,
C      doi:10.1029/2003GL017930, 2003.

C  Revision History:
C    PVB 11/05/07 Coded the first version.
C    JTK 04/17/08 Moved molar mass to AERO_INFO.f
C    SH  12/08/09 Use aero_data module in lieu of CBLK array

C-----------------------------------------------------------------------

      USE AERO_DATA

      IMPLICIT NONE

C *** Arguments
      REAL( 8 ), INTENT( IN )    :: RH        ! fractional relative humidity
      LOGICAL,   INTENT( IN )    :: COMPLETE  ! flag deciding which CRH
                                              !  equation to use

C *** Local Variables

C *** chemical species concentrations [micromoles/m3]
      REAL      NSO4     ! i+j mode sulfate
      REAL      NNO3     ! i+j mode nitrate
      REAL      NNH4     ! i+j mode ammonium
      REAL      NCAT     ! i+j mode cations
      REAL      NANI     ! i+j mode anions

C *** cation and anion mole fractions used in CRH equations
      REAL X         ! ammonium/cation mole fraction: NH4/(NH4+H)
      REAL Y         ! sulfate/anion mole fraction:  SO4/(SO4+NO3)

C *** intermediate variables used in CRH equations
      REAL X2, XY, Y2, X2Y, XY2, RDEN

      REAL CRH       ! crystallization RH (fractional units)

C-----------------------------------------------------------------------

C *** Experimental measurements of CRH are lacking below 1% relative
C     humidity.  Under those very dry conditions, we assume that
C     particles will crystallize.  Equations by Martin et al (2003) for
C     internally-mixed sulfate-nitrate-ammonium particles yield maximum
C     CRH values of 35.03% and 34.50% for initial crystal formation and
C     complete crystallization, respectively.  Therefore, the full CRH
C     calculation can be avoided when RH > 35.1%.
      IF ( RH .LE. 0.01D0 ) THEN
         CRYSTALIZED = .TRUE.    ! ambient particles are dry
         RETURN
      ELSE IF ( RH .GT. 0.351D0 ) THEN
         CRYSTALIZED = .FALSE.   ! ambient RH exceeds CRH
         RETURN
      END IF

C *** calculate total particle-phase composition [micromoles/m3]
      NNO3 = ( aerospc_conc( ANO3_IDX,1 ) + aerospc_conc( ANO3_IDX,2 ) )
     &     / aerospc_mw( ANO3_IDX )
      NSO4 = ( aerospc_conc( ASO4_IDX,1 ) + aerospc_conc( ASO4_IDX,2 ) )
     &     / aerospc_mw( ASO4_IDX )
      NNH4 = ( aerospc_conc( ANH4_IDX,1 ) + aerospc_conc( ANH4_IDX,2 ) )
     &     / aerospc_mw( ANH4_IDX )

C *** calculate total anion and cation concentrations
      NCAT = MAX( NNH4, 2.0 * NSO4 + NNO3 )
      NANI = NNO3 + NSO4

C *** calculate ammonium and sulfate mole fractions
      X = NNH4 / NCAT
      Y = NSO4 / NANI

C *** Experimental data of Martin et al. (2003) show no crystal
C     formation when X < 0.50 or Y < 0.22.  For these particle
C     compositions, the full CRH calculation can be avoided.
C
C     Note: Martin`s equation for initial crystal formation returns
C     very large CRH values when X and Y approach zero.  However,
C     those values were verified to be erroneous by personal
C     communication with Dr. Scot Martin on Aug. 30, 2007.
      IF ( ( X .LT. 0.50 ) .OR. ( Y .LT. 0.22 ) ) THEN
         CRYSTALIZED = .FALSE.   ! ambient RH exceeds CRH
         RETURN
      END IF

C *** store some terms needed to evaluate the CRH equations
      X2   = X * X
      XY   = X * Y
      X2Y  = X2 * Y
      Y2   = Y * Y
      XY2  = X * Y2
      RDEN = 1.0 / ( 25.0 + ( X - 0.7 ) * ( Y - 0.5 ) )

C *** calculate CRH using empirical equations of Martin et al (2003)
      IF ( COMPLETE ) THEN

         CRH = 3143.44 + (63.07 * X) + (0.114 * X2) + (87.97 * Y)
     &       - (125.73 * XY) + (0.586 * X2Y) + (0.95 * Y2)
     &       - (1.384 * XY2) - (79692.5 * RDEN)

      ELSE

         CRH = -697.908 - (15.351 * X) + (0.43 * X2) - (22.11 * Y)
     &       + (33.882 * XY) - (1.818 * X2Y) + (0.772 * Y2)
     &       - (1.636 * XY2) + (17707.6 * RDEN)

      END IF

C *** set value of the output variable, CRYSTALIZED
      IF ( RH .LE. REAL( CRH, 8 ) ) THEN
         CRYSTALIZED = .TRUE.    ! ambient particles are dry
      ELSE
         CRYSTALIZED = .FALSE.   ! ambient RH exceeds CRH
      END IF

      RETURN

      END FUNCTION CRYSTALIZED

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      LOGICAL FUNCTION FREEZES( TEMP, RH )

C  Determines whether the ambient RH has exceeded the RH of ice formation,
C  based on the Goff-Gratch equations as given by List (1984).

C  References:
C   1. Goff, J.A. and S. Gratch, Low-pressure properties of water from
C      -160 to 212 F, in Transactions of the American Society of Heating
C      and Ventilating Engineers, pp 95-122, New York, 1946.
C   2. List, R.J. (editor), Smithsonian Meteorological Tables, 5th ed.
C      pp. 350, 1984.

C  Revision History:
C   PVB 11/06/07 Coded the first version.
C-----------------------------------------------------------------------

      IMPLICIT NONE

C *** Arguments
      REAL( 8 ), INTENT( IN ) :: TEMP        ! Air temperature [ K ]
      REAL( 8 ), INTENT( IN ) :: RH          ! Fractional relative humidity

C *** Parameters

C *** The following values are taken from List (1984).  Note that
C     these differ slightly from the original equations published by
C     Goff & Gratch (1946).  We also note that T0 and PST differ
C     slightly from STDTEMP and STDATMPA in the AERO_INFO module.
C     Here, we use 273.16 K and 1013.246 hPa to be consistent with
C     the Goff-Gratch equations as given by List (1984).
      REAL( 8 ), PARAMETER :: TST = 373.16D0    ! steam-point temperature, K
      REAL( 8 ), PARAMETER :: T0  = 273.16D0    ! ice-point temperature, K
      REAL( 8 ), PARAMETER :: PST = 1013.246D0  ! sat vapor pres at TST, hPa
      REAL( 8 ), PARAMETER :: P0  = 6.1071D0    ! sat vapor pres at T0, hPa

      REAL( 8 ), PARAMETER :: LOGPST = 3.0057149D0     ! LOG10(PST)
      REAL( 8 ), PARAMETER :: LOGP0  = 0.78583503D0    ! LOG10(P0)

C *** Local Variables

C *** estimates of IRH using a polynomial approximation
      REAL( 8 )      EIRH   ! IRH approximated using 2nd order polynomial
      REAL( 8 )      LIRH   ! lower-bound of IRH
      REAL( 8 )      UIRH   ! upper-bound of IRH

C *** variables used to compute RH of ice formation
      REAL( 8 )      TSDT, TDTS, T0DT, TDT0  ! intermediate variables
      REAL( 8 )      LOGPW  ! log10 of saturation vapor pressure over H2O
      REAL( 8 )      LOGPI  ! log10 of saturation vapor pressure over ice

      REAL( 8 )      IRH    ! fractional RH at which ice forms

C-----------------------------------------------------------------------

      IF ( TEMP .LT. T0 ) THEN

C *** To mitigate the computational expense associated with Goff-Gratch
C     equations, use a 2nd order polynomial function to approximate IRH.
C     This approximation, EIRH, matches IRH from the full Goff-Gratch
C     equations within 0.004 over the entire low-temperature range of
C     interest (200 to 275K) and is used for screening purposes.
         EIRH = 1.61299D0 + TEMP * ( 4.4117437D-5 * TEMP - 1.4293888D-2 )
         LIRH = EIRH - 0.005D0
         UIRH = EIRH + 0.005D0

         IF ( RH .GT. UIRH ) THEN
            FREEZES = .TRUE.
         ELSE IF ( RH .LT. LIRH ) THEN
            FREEZES = .FALSE.
         ELSE

C *** Compute IRH using Goff-Gratch equations as given by List (1984)
            TSDT  = TST / TEMP
            TDTS  = TEMP / TST
            T0DT  = T0 / TEMP
            TDT0  = TEMP / T0
            LOGPW = -7.90298D0 * ( TSDT - 1.0D0 )
     &            + 5.02808D0 * LOG10( TSDT )
     &            - 1.3816D-7 * ( 10.0D0 ** ( 11.344D0 *  (1.0D0 - TDTS) ) - 1.0D0 )
     &            + 8.1328D-3 * ( 10.0D0 ** ( -3.49149D0 * (TSDT - 1.0D0) ) - 1.0D0 )
     &            + LOGPST
            LOGPI = -9.09718D0 * (T0DT - 1.0D0)
     &            - 3.56654D0 * LOG10( T0DT )
     &            + .876793D0 * (1.0D0 - TDT0)
     &            + LOGP0
            IRH   = 10.0D0 ** ( LOGPI - LOGPW )

            IF ( RH .GT. IRH ) THEN
               FREEZES = .TRUE.
            ELSE
               FREEZES = .FALSE.
            END IF

         END IF
      ELSE
         FREEZES = .FALSE.
      END IF

      RETURN

      END FUNCTION FREEZES

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CALCISOPGAMMAS( RADIUS, TEMPERATURE,
     &                           GAMMAIEPOX, GAMMAIMAE,
     &                           KPIEPOX, fTET, fOS, fdim1, fdim2 )

C  Calculates the uptake coefficients (gammas) for IEPOX, IMAE, and IHMML
C  based on particle phase H+ (EQLBH) and other particle constituents.
C  Also returns calculated particle phase reaction rate, fraction of uptake
C  producing tetrols, organosulfates, and dimers.

C  Note that indices 1 and 2 are used for both acids (1=H+, 2=bisulfate) and
C  the organics (1=IEPOX, 2=IMAE).

C  Key Subroutines Called: none

C  Key Functions Called: none

C  Revision History: 
C  HOTP 1/18/13 First coding
C  HOTP 9/26/14 Reduced form considering only IEPOX uptake with no
C               speciation developed for CB05
C  HOTP 5/10/16 Merged with AERO6I code. Now handles SAPRC07tic and MAE uptake.

C  References
C  1. Chan, M. N., et al. "Characterization and quantification of isoprene-
C     derived expoxydiols in ambient aerosol in the Southeastern United States,"
C     Environ. Sci. Technol., 2010, 44, 4590-4596.
C  2. Eddingsaas, N. C., VanderVelde, D. G., Wennberg, P. O. "Kinetics 
C     and products of the acid-catalyzed ring-opening of atmospherically
C     relevant butyl epoxy alcohols," J. Phys. Chem A., 2010, 114, 8106-8113.
C  3. Gharagheizi, F., et al. "Representation and prediction of molecular diffusivity
C     of nonelectrolyte organic compounds in water at infinite dilution using the
C     artificial neural network-group contribution method," J. Chemical & Engineering
C     Data, 2011, 46, 1741-1750.
C  4. Hanson, D. R., Ravishankara, A. R., Solomon, S. "Heterogeneous reactions in
C     sulfuric acid aerosols: A framework for model calculations," J. Geophys. Res.,
C     1994, 99, 3615-3629.
C  5. McNeill, V. F., et al. "Aqueous-phase secondary organic aerosol and organosulfate 
C     formation in atmospheric aerosols: A modeling study," Environ Sci Technol., 2012,
C     46, 8075-8081.
C  6. Pye et al., Epoxide pathways improve model predictions of isoprene
C     markers and reveal key role of acidity in aerosol formation,
C     Envion. Sci. Technol, 2013, doi: 10.1021/es402106h. 
C-----------------------------------------------------------------------

      Use aero_data
      Use precursor_data
      Use aeromet_data   ! airtemp
      Use utilio_defn    ! error message and abort
      Use hlconst_mod

      Implicit None

C *** Arguments
      Real( 8 ), Intent( IN )  :: RADIUS       ! Particle radius [m]
      Real( 8 ), Intent( IN )  :: TEMPERATURE  ! air temperature [deg K]
      Real( 8 ), Intent( OUT ) :: GAMMAIEPOX ! Uptake coeff for IEPOX []
      Real( 8 ), Intent( OUT ) :: GAMMAIMAE  ! Uptake coeff for MAE []
      Real( 8 ), Intent( OUT ) :: KPIEPOX ! Particle phase reaction rate for IEPOX [1/s]
      Real( 8 ), Intent( OUT ) :: fTET(2), fOS(2), fdim1(2), fdim2(2)
                                  ! fraction of tetrol, organosulfate, tetroldimer, osdimer []
                                  ! first value for IEPOX-derived, second for IMAE-derived
C *** Parameters
C     For gamma calculation
      Real( 8 ), Parameter :: inv_alpha    = 1.0d0/0.02d0 ! reciproaccomodation coefficient from McNeill et al. 2012 []
      Real( 8 ), Parameter :: diffusivity  = 1.0d-9    ! liquid phase diffusivity, based on C4-C5 epoxides 
                                                       ! and diols at infinite dilution in water (Gharagheizi et al. 2011) [m2/s]
      Real( 8 ), Parameter :: RgasLatmmolK = 0.08206d0 ! Universal gas constant [L atm/mol K]
      Real( 8 ), Parameter :: small        = 1.0d-8   ! small number to prevent calculations that may have precision issues
      Real( 8 ), Parameter :: smaller      = 1.0d-20  ! smaller number to prevent division by zero

C     Acid related
      Integer, Parameter   :: n_acids      = 2 ! number of acids: H+ and HSO4-
      Integer, Parameter   :: hacid_idx    = 1 ! H+ acid index
      Integer, Parameter   :: hso4acid_idx = 2 ! HSO4 acid index

C     Henry's law coeff for IEPOX (1) and IMAE (2) (HenryWin v 3.2)
      Real( 8 ) :: Heff(2)

C     Diagnostic
      Character (16 ), Parameter :: pname = 'CALCISOPGAMMAS'

C *** Local Variables
      Integer   :: i                   ! counter and temporary indices
      Real( 8 ) :: eqlbh               ! Particle Phase H+ from isoropia [mol/m**3]
      Real( 8 ) :: q, denom            ! quantities in Hanson et al. 1994 equation for gamma []
      Real( 8 ) :: nu                  ! molecular speed [m/s], note this is the same as CBAR but we want to avoid excessive passing
      Real( 8 ) :: acidmolconc( n_acids ) ! concentration of acid in mol/m3
      Real( 8 ) :: acid                ! temporary concentration of acid in mol/m3
      Real( 8 ) :: nuc                 ! nucleophile concentration in mol/m3
      Real( 8 ) :: charge              ! temporary for charge balance calculation [umol/m3]
      Real( 8 ) :: inv_volume          ! reciprocal of particle volume [m3 air/Liters particles]
      Real( 8 ) :: kchem, kparticle(2) 
      Real( 8 ) :: kchemtet(2),kchemos(2), kchemdim1(2), kchemdim2(2) ! particle phase rxn rates [1/s] 
      Real( 8 ) :: gammaisop(2)        ! temporary value for IEPOX (1) and IMAE (2) gammas
      Real( 8 ) :: cfactor_isop(2)     ! cfactor for IEPOX(1) and MAE(2)
      Real( 4 ) :: temp                ! air temperature [deg K]
      Character ( 80 ) :: xmsg         ! error message

C-----------------------------------------------------------------------

C *** Determine H+ acid concentration of j mode [mol/m3]
      eqlbh = aerospc_conc( ah3op_idx, 2 ) / aerospc_mw( ah3op_idx ) * 1.0d-6
      acidmolconc( hacid_idx ) = Max( eqlbh, 0.0d0 ) 

C *** Calculate HSO4 by charge balance
C     Note: if isorropia has returned a negative H+ concentration
C     we effectively treat all H+ like HSO4 (slightly less effective
C     in catalyzing the ring-opening)
      charge = 0.0d0  ! umol/m3
      Do i = 1, n_aerospc
         If ( aerospc( i )%tracer ) Cycle
         If ( aero_missing( i,2 ) ) Cycle
         charge = charge - aerospc( i )%charge * aerospc_conc( i,2 )
     &          / aerospc_mw( i )
      End Do
      acidmolconc( hso4acid_idx ) = Max( ( charge*1.0d-6 - acidmolconc( hacid_idx ) ), 0.0d0 ) 

C *** J-mode particle volume [L/m**3 air]
      inv_volume = 0.0d0
      Do i = 1, n_aerospc 
         If ( aerospc( i )%tracer ) Cycle
         If ( aero_missing( i,2 ) ) Cycle
!        If ( aerospc( i )%no_M2Wet ) Cycle
         inv_volume = inv_volume + Real( aerospc_conc( i, 2 ) / aerospc(i)%density, 8 ) !  * 1.0d-6
      End Do
      inv_volume = 1.0d6 / inv_volume

C *** Loop over nucleophile/acid pairs defined in acid_nuc_pairs in AERO_DATA
C     and calculate rate of particle phase reaction
      kchem     = 0.0d0   ! intermediate value
      kparticle = 0.0d0   ! accumulating IEPOX and IMAE value
      kchemos   = 0.0d0   ! accumulating organosulfate for IEPOX and IMAE
      kchemtet  = 0.0d0   ! accumulating tetrols or equivalent for IEPOX and IMAE
      kchemdim1 = 0.0d0   ! accumulating tetrol-dimer or equivalent for IEPOX and IMAE
      kchemdim2 = 0.0d0   ! accumulating os-dimer or equivalent for IEPOX and IMAE

      Do i = 1, n_nucpairs

C        Find J-mode nucleophile concentration in ug/m3 and convert to mol/m3
         nuc = aerospc_conc( acid_nucmap_idx( i ), 2 ) 
     &       /  aerospc_mw( acid_nucmap_idx( i ) ) * 1.0d-6

         acid = acidmolconc( acid_nuc_pairs( i )%idx_acid ) ! mol/m3

C        Correct sulfate for presence of bisulfate
         If ( acid_nuc_pairs( i )%idx_remove .Ge. 1 ) Then
            nuc = Max( nuc - acidmolconc( acid_nuc_pairs( i )%idx_remove ), 0.0d0 )
         End If

C        Determine rate of particle phase rxn for a given pair (Eddingsaas et al.)
         kchem = acid_nuc_pairs( i )%kchem* nuc * acid * ( inv_volume*inv_volume )
         
C        Update sum
C        Store information with speciation for IEPOX
         if ( acid_nuc_pairs( i )%parent .eq. 'IEPOX' ) then
            kparticle( 1 )  = kparticle(1) + kchem
            if ( acid_nuc_pairs( i )%prod .eq. 'AIEOSJ' ) then !ae6i
              kchemos( 1 )  = kchemos(1)   + kchem
            else if ( (acid_nuc_pairs( i )%prod .eq. 'ADIMJ')
     &             .and. (acid_nuc_pairs( i )%nuc .eq. 'AIETETJ') ) then !ae6i
              kchemdim1( 1 ) = kchemdim1(1)  + kchem
            else if ( (acid_nuc_pairs( i )%prod .eq. 'ADIMJ')
     &             .and. (acid_nuc_pairs( i )%nuc .eq. 'AIEOSJ') ) then !ae6i
              kchemdim2( 1 ) = kchemdim2(1)  + kchem
            else if ( acid_nuc_pairs( i )%prod .eq. 'AIETETJ' ) then !ae6i
              kchemtet( 1 ) = kchemtet(1)  + kchem
            else if ( acid_nuc_pairs( i )%prod .eq. 'AISO3OSJ' ) then !craccm1
              kchemos( 1 )  = kchemos(1)   + kchem
            else if ( acid_nuc_pairs( i )%prod .eq. 'AISO3NOSJ' ) then !craccm1
              kchemtet( 1 )  = kchemtet(1)   + kchem
            else if ( acid_nuc_pairs( i )%prod .eq. 'AISO3J' ) then !lumped treatments
               if ( acid_nuc_pairs( i )%nuc .eq. 'ASO4J' ) then !organosulfate
                 kchemos( 1 )  = kchemos(1)   + kchem
               else ! non sulfated species
                 kchemtet( 1 ) = kchemtet(1)  + kchem
               end if
            else
               xmsg = 'For IEPOX parent, reaction product not recognized '
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            end if
         end if

C        Store information with speciation for IMAE
         if ( acid_nuc_pairs( i )%parent .eq. 'IMAE' ) then
            kparticle( 2 )  = kparticle( 2 ) + kchem
            if( acid_nuc_pairs( i )%prod .eq. 'AIMOSJ' ) then
              kchemos( 2 )  = kchemos( 2 )   + kchem
            else if( acid_nuc_pairs( i )%prod .eq. 'AIMGAJ' ) then
              kchemtet( 2 ) = kchemtet( 2 )  + kchem
            else
               xmsg = 'For IMAE parent, reaction product not recognized '
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            end if
         end if
      End Do      

C *** Calculate gamma following Pye et al. 2013 ES&T
C     (see also Hanson et al. 1994 JGR Eqn (2) for details)
C *** Calculate gammas for IEPOX and IMAE

C *** Henry's Law coefficients
      temp = real( TEMPERATURE, 4)
      Heff( 1 ) = REAL(HLCONST( HLC_IEPOX, temp, .False., 0.0 ), 8)
      Heff( 2 ) = REAL(HLCONST( HLC_IMAE,  temp, .False., 0.0 ), 8)

C *** Cfactor
      cfactor_isop( 1 ) = cfactor_iepox
      cfactor_isop( 2 ) = cfactor_imae

C     Loop over precursor species and calculate gamma
C     (see Hanson et al. 1994 JGR Eqn (2) for details)
      Do  i = 1, numvoc

C     Note that if the rate of particle phase reaction is very slow, there may not
C     be enough digits of precision to properly calculate q which can result in
C     erroneously high gamma values. Only calculate gamma if particle phase reaction
C     is faster than 1e-8 1/s

      ! Diffuso reactive parameter [ m * sqrt ( 1/s s/m2 ) = dim'less ]
      q = radius * dsqrt ( kparticle(i)/ diffusivity )

      If ( q / Tanh( q ) .Gt. 1.0d0 ) Then

         ! Molecular speed [ sqrt ( J/mol K * K / g * mol * g/ kg ) = sqrt (J/kg) = m/s ]
         nu = cfactor_isop( i ) * dsqrt( temperature )

         ! Gamma [ denom:  m/s / ( mol/L/atm * L atm /mol/ K * K * sqrt ( m2/s * 1/s )) = dim'less ]

          denom = ( inv_alpha + nu * radius
     &          / ( 4.0d0 * Heff( i )* RgasLatmmolK * temperature * diffusivity
     &            * ( q / Tanh( q ) -1.0d0 ) ) ) 

          gammaisop( i ) = 1.0d0 / denom

          ftet( i ) = kchemtet( i ) / kparticle( i )
          fos( i )  = kchemos( i ) / kparticle( i )
          fdim1( i ) = kchemdim1( i ) / kparticle( i )
          fdim2( i ) = kchemdim2( i ) / kparticle( i )

C     No/slow reaction
      Else

         gammaisop( i ) = 0.0d0
         ftet( i )  = 0d0
         fos( i )   = 0d0
         fdim1( i ) = 0d0
         fdim2( i ) = 0d0

      End If

      End Do

C *** Calculate final values to return
      gammaiepox = gammaisop( 1 )
      gammaimae  = gammaisop( 2 )
      kpiepox    = kparticle( 1 )

      RETURN
 
      END SUBROUTINE CALCISOPGAMMAS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CALCPFASGAMMAS( RADIUS, TEMPERATURE, GAMMA_HFPODAF,
     &                           GAMMA_COF2, GAMMA_PFMOAF, KPHFPODAF,
     &                           KPCOF2, KPPFMOAF)

C  Calculates the uptake coefficients (gammas) for HFPODAF, COF2, and
C  PFMOAF. Also returns calculated particle phase reaction rate.

C  Key Subroutines Called: none

C  Key Functions Called: none

C  Revision History:
C  ELD 5/14/24 First coding

C  References
C  1. 
C-----------------------------------------------------------------------

      Use aero_data
      Use precursor_data
      Use aeromet_data   ! Includes CONST.EXT (pi) and airtemp
      Use utilio_defn    ! error message and abort
      Use hlconst_mod
      USE CONST, ONLY: F6PI

      Implicit None

C *** Arguments
      Real( 8 ), Intent( IN )  :: RADIUS       ! Particle radius [m]
      Real( 8 ), Intent( IN )  :: TEMPERATURE  ! air temperature [deg K]
      Real( 8 ), Intent( OUT ) :: GAMMA_HFPODAF! Uptake coeff for HFPODA 
      Real( 8 ), Intent( OUT ) :: GAMMA_COF2   ! Uptake coeff for COF2
      Real( 8 ), Intent( OUT ) :: GAMMA_PFMOAF ! Uptake coeff for PFMOAF
      Real( 8 ), Intent( OUT ) :: KPHFPODAF    ! Particle phase rate constant for HFPODAF [1/s]
      Real( 8 ), Intent( OUT ) :: KPCOF2       ! Particle phase rate constant for COF2 [1/s]
      Real( 8 ), Intent( OUT ) :: KPPFMOAF     ! Particle phase rate constant for PFMOAF [1/s]

C *** Parameters
C     For gamma calculation
      Real( 8 ), Parameter :: inv_alpha    = 1.0d0/0.02d0 !reciproaccomodation coefficient, assume default
      Real( 8 ), Parameter :: diffusivity  = 0.5d-9    ! liquid phase diffusivity, based on 6 PFAS at infinite dilution 
                                                       ! in water (Damiao et al. Fluid Phase Euquilibria 2023) [m2/s]
      Real( 8 ), Parameter :: RgasLatmmolK = 0.08206d0 ! Universal gas constant [L atm/mol K]
      Real( 8 ), Parameter :: small        = 1.0d-8   ! small number to prevent calculations that may have precision issues
      Real( 8 ), Parameter :: smaller      = 1.0d-20  ! smaller number to prevent division by zero

C     Henry's law coeff for HFPO-DAF (change the 1 to higher numbers if
C     you increase PFAS) (HenryWin v 3.2)
      Real( 8 ) :: Heff(3)

C     Diagnostic
      Character (16 ), Parameter :: pname = 'CALCPFASGAMMAS'

C *** Local Variables
      Integer   :: i                   ! counter and temporary indices
      Real( 8 ) :: q, denom            ! quantities in Hanson et al. 1994 equation for gamma []
      Real( 8 ) :: nu                  ! molecular speed [m/s], note this is the same as CBAR but we want to avoid excessive passing
      Real( 8 ) :: inv_volume          ! reciprocal of particle volume [m3 air/Liters particles]
      Real( 8 ) :: AH2OF               ! I & J mode water, ug/m3
      Real( 8 ) :: AH2OM               ! organic + inorganic water concentration [mol/L, aka M]
      Real( 8 ) :: kparticle(3)
      Real( 8 ) :: gammapfas(3)        ! temporary value for HFPODAF(1), COF2(2), & PFMOAF(3)
      Real( 8 ) :: cfactor_pfas(3)     ! cfactor for HFPODAF(1), COF2(2), & PFMOAF(3)
      Real( 4 ) :: temp                ! air temperature [deg K]
      Character ( 80 ) :: xmsg         ! error message

C-----------------------------------------------------------------------

C *** Calculate acyl fluoride gamma's following Pye et al. 2013 ES&T
C     (see also Hanson et al. 1994 JGR Eqn (2) for details)

C *** Henry's Law coefficients
      temp = real( TEMPERATURE, 4)
      Heff( 1 ) = REAL(HLCONST( HLC_HFPODAF, temp, .False., 0.0 ), 8)
      Heff( 2 ) = REAL(HLCONST( HLC_COF2,  temp, .False., 0.0 ), 8)
      Heff( 3 ) = REAL(HLCONST( HLC_PFMOAF,  temp, .False., 0.0 ), 8)

C *** Cfactor
      cfactor_pfas( 1 ) = CFACTOR_HFPODAF
      cfactor_pfas( 2 ) = CFACTOR_COF2
      cfactor_pfas( 3 ) = CFACTOR_PFMOAF

C *** Calculate the particle phase rate constants
      !Retrieve inorganic & organice fine-mode particle-phase liquid water [ug/m3]
      AH2OF  = aerospc_conc( AH2O_IDX,1 ) + aerospc_conc( AH2O_IDX,2 ) + aerospc_conc(AORGH2O_IDX, 1) + aerospc_conc(AORGH2O_IDX, 2)
      !calculate the inverse particle volume [m3 air/L particles]
      inv_volume = 1.0E-9 * f6pi / REAL( ( WET_M3( 1 ) + WET_M3( 2 ) ), 8 )

c *** Calculate the organic + inorganic water concentration [mol/L, aka M]
        AH2OM = AH2OF * inv_volume / aerospc_mw( AH2O_IDX )
c *** Calculate the 1st order rate constant [s-1]
      kparticle( 1 ) = 8.3d-1 * AH2OM ! HFPODAF, calculated by Ivan, 01/31/2025
      kparticle( 2 ) = 8.3d-1 * AH2OM ! COF2, calculated by Ivan, 01/31/2025
      kparticle( 3 ) = 8.3d-1 * AH2OM ! PFMOAF, calculated by Ivan, 01/31/2025


C     Loop over precursor species and calculate gamma
C     (see Hanson et al. 1994 JGR Eqn (2) for details)
      Do  i = 1, 3 

C     Note that if the rate of particle phase reaction is very slow, there may not
C     be enough digits of precision to properly calculate q which can result in
C     erroneously high gamma values. Only calculate gamma if particle phase reaction
C     is faster than 1e-8 1/s


      ! Diffuso reactive parameter [ m * sqrt ( 1/s s/m2 ) = dim'less ]
      q = radius * dsqrt ( kparticle(i) / diffusivity )

      If ( q / Tanh( q ) .Gt. 1.0d0 ) Then

         ! Molecular speed [ sqrt ( J/mol K * K / g * mol * g/ kg ) = sqrt (J/kg) = m/s ]
         nu = cfactor_pfas(i) * dsqrt( temperature )

         ! Gamma [ denom:  m/s / ( mol/L/atm * L atm /mol/ K * K * sqrt ( m2/s * 1/s )) = dim'less ]

          denom = ( inv_alpha + nu * radius
     &          / ( 4.0d0 * Heff(i) * RgasLatmmolK * temperature 
     &          * diffusivity * ( q / Tanh( q ) -1.0d0 ) ) )

          gammapfas(i) =  1.0d0 / denom


C     No/slow reaction
      Else

         gammapfas(i) =  0.0d0

      End If

      End Do

C *** Calculate final values to return
      GAMMA_HFPODAF = gammapfas( 1 )
      GAMMA_COF2    = gammapfas( 2 )
      GAMMA_PFMOAF  = gammapfas( 3 ) 

      KPHFPODAF     = kparticle( 1 )
      KPCOF2        = kparticle( 2 )
      KPPFMOAF      = kparticle( 3 )

      RETURN

      END SUBROUTINE CALCPFASGAMMAS


      END MODULE AEROSOL_CHEMISTRY

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_disp_info_ext.f,v 1.1 2004/03/26 16:16:47 yoj Exp $ 

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Note: all these variables with prefix se_ are for stencil exchange library
C       only
C
C to define maximum displacement variables:
C
C   se_mndis -- maximun displacement in the north direction
C   se_medis -- maximun displacement in the east direction
C   se_msdis -- maximun displacement in the south direction
C   se_mwdis -- maximun displacement in the west direction
C --------------------------------------------------------------------------

        module se_disp_info_ext

          integer :: se_mndis, se_medis, se_msdis, se_mwdis

        end module se_disp_info_ext

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE  METEMIS

        !!-----------------------------------------------------------------------
        !!  DESCRIPTION:
        !!      This module initializes data structures for, reads (temperature-binned)
        !!      pseudo-layered gridded emissions from program MOVESTABLE and calculates
        !!      gridded speciated emissions
        !!
        !!  PRECONDITIONS REQUIRED:
        !!      setenv METEMIS_TBL    <path for pseudo-layered emissions>
        !!
        !!  REVISION  HISTORY:
        !!      5/2021: initial version by C.J.Coats & B.H. Baek
        !!      7/2022: initial version by B.H. Baek
        !!-----------------------------------------------------------------------

        USE DESID_VARS
        USE RUNTIME_VARS, ONLY: MYPE
        USE HGRD_DEFN             ! horizontal domain specifications
        USE ASX_DATA_MOD          ! all gridded input variables, as Met_Data%*(ncols,nrows)
        USE UTILIO_DEFN

        IMPLICIT NONE
        
        INCLUDE SUBST_FILES_ID  ! file name parameters

        PUBLIC METEMIS_INIT, GET_METEMIS

        INTEGER           , PUBLIC, PROTECTED, SAVE :: NMETSPC
        CHARACTER(NAMLEN3), PUBLIC, PROTECTED, SAVE :: MTNAME( MXVARS3 )
        CHARACTER(NAMLEN3), PUBLIC, PROTECTED, SAVE :: MTUNIT( MXVARS3 )
        CHARACTER(NAMLEN3), PUBLIC, PROTECTED, SAVE :: MTBASIS( MXVARS3 )
        REAL              , PUBLIC, PROTECTED, SAVE :: MET_WT( MXVARS3 )
        REAL,  ALLOCATABLE, PUBLIC, PROTECTED, SAVE :: MTEMPS( : )
        REAL,  ALLOCATABLE, PUBLIC, PROTECTED, SAVE :: VDEMIS_MV( :,:,: ) !! ( NMETSPC,NCOLS,NROWS )
        REAL,  ALLOCATABLE, PRIVATE, PROTECTED, SAVE :: VDEMIS_MVDIAG( :,:,: ) !! ( NMETSPC,NCOLS,NROWS )
        LOGICAL, ALLOCATABLE,PRIVATE,PROTECTED, SAVE :: MT_GAS( : ), MT_DSL( : )


        PRIVATE     !!  everything else

        LOGICAL  INITFLAG

        !!........  PARAMETERs:

        REAL        , PARAMETER :: CTOK    = 273.15
        REAL        , PARAMETER :: CTOF    = 9.0 / 5.0

        !!........  SAVEd Local Variables:

        INTEGER          GXOFF, GYOFF        ! global origin offset from file
        INTEGER, SAVE :: STRTCOL, ENDCOL     !!  full-grid starting, ending col,
        INTEGER, SAVE :: STRTROW, ENDROW     !!  row subscripts

        INTEGER, SAVE :: NMTEMP, I

        INTEGER, SAVE :: SDATEMT
        INTEGER, SAVE :: STIMEMT
        INTEGER, SAVE :: TSTEPMT

        CHARACTER*16, SAVE :: TBLNAME = 'METEMIS_TBL'

        REAL, ALLOCATABLE, SAVE :: ETABLE( :,:,:,: )  !! ( NCOLS,NROWS,NMTEMP,NMETSPC )
        REAL, ALLOCATABLE, SAVE :: TEMPVAL( :,: )     !! ( NCOLS,NROWS ) for temperature
        REAL, ALLOCATABLE, SAVE :: QVMOL( :,:,: )       !! ( NCOLS,NROWS, NLAYS ) for specific humidity 

        INTEGER,SAVE  :: NTICS = 0 ! num. of substeps within an output tstep
        INTEGER,SAVE  :: MTICS = 0 ! temporary sub for NTICS before it is set to 0
        INTEGER,SAVE  :: LDATE     ! test date to update emissions diag avg
        INTEGER,SAVE  :: LTIME     ! test time to update emissions diag avg
        INTEGER       :: FDATE     ! Start date to Write to Diagnostic files
        INTEGER       :: FTIME     ! Start time to Write to Diagnostic files
        INTEGER,SAVE  :: MV_TSTEP
        INTEGER       :: MV_TSTEP_F  ! same time step info as MV_TSTEP but in HHMMSS format


      CONTAINS !!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

        LOGICAL FUNCTION METEMIS_INIT( JDATE, JTIME, TSTEP )

            USE RUNTIME_VARS, ONLY: MYPE

            INTEGER, INTENT(IN   ) :: JDATE, JTIME
            INTEGER, INTENT(IN   ) :: TSTEP

            CHARACTER*24, PARAMETER :: PNAME = 'METEMIS:METEMIS_INIT'

            INTEGER         ISTAT, ISPC, K, N
            CHARACTER*256   MESG

            !!........  Open MVMT and read header

            IF ( .NOT.OPEN3( TBLNAME, FSREAD3, PNAME ) ) THEN
                CALL M3WARN( PNAME, 0,0, 'Could not open "'//TRIM(TBLNAME)//'"')
                METEMIS_INIT = .FALSE.
                RETURN
            ELSE IF ( .NOT.DESC3( TBLNAME ) ) THEN
                CALL M3WARN( PNAME, 0,0, 'Could not DESC3( MTEMP )')
                METEMIS_INIT = .FALSE.
                RETURN
            ELSE IF ( .NOT.FILCHK3( TBLNAME,  GRDDED3,
     &                              GL_NCOLS, GL_NROWS, NLAYS3D, NTHIK3D ) ) THEN
                CALL M3WARN( PNAME, 0,0, 'Inconsistent dims for "'//TRIM(TBLNAME)//'"')
                METEMIS_INIT =.FALSE.
                RETURN
            ELSE IF ( .NOT.GRDCHK3( TBLNAME,
     &                              P_ALP_GD, P_BET_GD, P_GAM_GD, XCENT_GD, YCENT_GD,
     &                              XORIG_GD, YORIG_GD, XCELL_GD, YCELL_GD,
     &                              NLAYS3D, VGTYP3D, VGTOP3D, VGLVS3D ) ) THEN
                CALL M3WARN( PNAME, 0,0, 'Inconsistent coord/grid  for "'//TRIM(TBLNAME)//'"')
                METEMIS_INIT = .FALSE.
                RETURN
            ELSE
                SDATEMT = SDATE3D
                STIMEMT = STIME3D
                TSTEPMT = TSTEP3D
                NMTEMP  = NLAYS3D
                NMETSPC = NVARS3D
            END IF      !!  if not open3() ...else...

            CALL SUBHFILE( TBLNAME, GXOFF, GYOFF, STRTCOL, ENDCOL,
     &                     STRTROW, ENDROW )

         !!........  Allocate input-related arrays:
            ALLOCATE( DESID_EMVAR( IMETSRM )%ARRY ( NMETSPC ),
     &                DESID_EMVAR( IMETSRM )%UNITS( NMETSPC ),
     &                DESID_EMVAR( IMETSRM )%MW   ( NMETSPC ),
     &                DESID_EMVAR( IMETSRM )%USED ( NMETSPC ),
     &                DESID_EMVAR( IMETSRM )%CONV ( NMETSPC ),
     &                DESID_EMVAR( IMETSRM )%BASIS( NMETSPC ),
     &                DESID_EMVAR( IMETSRM )%LAREA( NMETSPC ),
     &                DESID_EMVAR( IMETSRM )%LAREAADJ( NMETSPC ),
     &                ETABLE( NCOLS,NROWS,NMTEMP,NMETSPC ),
     &                TEMPVAL( NCOLS,NROWS ), MTEMPS( NMTEMP ),
     &                VDEMIS_MV( NMETSPC,NCOLS,NROWS ),
     &                VDEMIS_MVDIAG( NMETSPC,NCOLS,NROWS ), STAT = ISTAT )
            ETABLE = 0.0
            TEMPVAL= 0.0
            VDEMIS_MVDIAG = 0.0
            
            MTEMPS( 1:NMTEMP )  = VGLVS3D( 1:NMTEMP )
            MTNAME( 1:NMETSPC ) = VNAME3D( 1:NMETSPC )
            MTUNIT( 1:NMETSPC ) = UNITS3D( 1:NMETSPC )
            MTBASIS( 1:NMETSPC) = 'UNIT'

            IF (HUM_NOX_YN) THEN
                ALLOCATE( QVMOL( NCOLS,NROWS,NLAYS), STAT = ISTAT ) 
                QVMOL= 0.0
                ALLOCATE( MT_GAS( NMETSPC ), MT_DSL( NMETSPC ), STAT=ISTAT )
                MT_GAS = .FALSE.
                MT_DSL = .FALSE.

                DO ISPC = 1,NMETSPC
                    IF ( MTNAME( ISPC ) .EQ. 'NO_GAS' .OR.
     &                   MTNAME( ISPC ) .EQ. 'NO2_GAS' .OR.
     &                   MTNAME( ISPC ) .EQ. 'HONO_GAS' ) THEN
                      MT_GAS( ISPC ) = .TRUE.
                    ELSE IF( MTNAME( ISPC ) .EQ. 'NO_DIS' .OR.
     &                       MTNAME( ISPC ) .EQ. 'NO2_DIS' .OR.
     &                       MTNAME( ISPC ) .EQ. 'HONO_DIS' ) THEN
                      MT_DSL( ISPC ) = .TRUE.
                    END IF
               END DO
            END IF


            IF ( ISTAT .NE. 0 ) THEN
                WRITE( MESG, '( A, I9 )' ) 'Error allocating ETABLE:  STATUS=', ISTAT
                CALL M3WARN( PNAME, 0, 0, MESG )
                METEMIS_INIT = .FALSE.
                RETURN
            END IF

            DESID_EMVAR( IMETSRM )%LEN   = NMETSPC
            DESID_EMVAR( IMETSRM )%ARRY  = MTNAME( 1:NMETSPC )
            DESID_EMVAR( IMETSRM )%UNITS = MTUNIT( 1:NMETSPC )
            DESID_EMVAR( IMETSRM )%MW    = MET_WT( 1:NMETSPC )
            DESID_EMVAR( IMETSRM )%USED  = .FALSE.
            DESID_EMVAR( IMETSRM )%CONV  = 1.0
            DESID_EMVAR( IMETSRM )%BASIS = MTBASIS(1:NMETSPC )
            DESID_EMVAR( IMETSRM )%LAREA = .FALSE.
            DESID_EMVAR( IMETSRM )%LAREAADJ = .FALSE.
            
            MV_TSTEP = TIME2SEC( TSTEP )
            MV_TSTEP_F = TSTEP

            LDATE = STDATE; LTIME = STTIME

            IF ( .NOT.METEMDIAG ) THEN
                CONTINUE

            ELSE IF( IO_PE_INCLUSIVE ) THEN

                FDATE = STDATE
                FTIME = STTIME
                CALL NEXTIME( FDATE, FTIME, TSTEP )
                SDATE3D = FDATE
                STIME3D = FTIME
                TSTEP3D = TSTEP
                FTYPE3D = GRDDED3
                NCOLS3D = GL_NCOLS
                NROWS3D = GL_NROWS
                NLAYS3D = 1
                NTHIK3D = 1
                GDTYP3D = GDTYP_GD
                GDNAM3D = GRID_NAME  ! from HGRD_DEFN
                P_ALP3D = P_ALP_GD
                P_BET3D = P_BET_GD
                P_GAM3D = P_GAM_GD
                XORIG3D = XORIG_GD
                YORIG3D = YORIG_GD
                XCENT3D = XCENT_GD
                YCENT3D = YCENT_GD
                XCELL3D = XCELL_GD
                YCELL3D = YCELL_GD
                VGTYP3D = VGTYP_GD
                VGTOP3D = VGTOP_GD

                NVARS3D = NMETSPC

                !! borrow rest of FDESC from input-file...
                FDESC3D      = ' '
                FDESC3D( 1 ) = 'hourly met-modulated mobile emissions (diagnostic outputs)'
                IF ( .NOT. OPEN3( CTM_METEMIS_DIAG, FSUNKN3, PNAME ) ) THEN
                    CALL M3WARN( PNAME, 0,0, 'Could not open '//CTM_METEMIS_DIAG )
                    METEMIS_INIT = .FALSE.
                    RETURN
                END IF

            END IF

            METEMIS_INIT = .TRUE.
            RETURN

        END FUNCTION METEMIS_INIT


        !!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


        SUBROUTINE GET_METEMIS( JDATE, JTIME, TSTEP, L_DESID_DIAG )

            USE DESID_VARS
            USE RUNTIME_VARS, ONLY: MYPE
            USE HGRD_DEFN             ! horizontal domain specifications
            USE ASX_DATA_MOD          ! all gridded input variables, as Met_Data%*(ncols,nrows)
            USE UTILIO_DEFN
            USE CENTRALIZED_IO_MODULE

            IMPLICIT NONE

            INTEGER, INTENT(IN   ) :: JDATE, JTIME
            INTEGER, INTENT(IN   ) :: TSTEP( 3 )    ! time step vector (HHMMSS)
            LOGICAL, INTENT(IN   ) :: L_DESID_DIAG  ! flag for determining whether or not 
                                                    !   DESID is in diagnostic mode

            CHARACTER*24, PARAMETER :: PNAME = 'METEMIS:GET_METEMIS'

            REAL            EMDIAG( NCOLS,NROWS )

            INTEGER         C, R, K, L, LL, V, IDX1, IDX2

            INTEGER,SAVE  ::PRVHR=-10000
            LOGICAL,SAVE  :: LASTTIC   ! true: last sync step this output step
            INTEGER,SAVE  :: TOT_TSTEP 
            LOGICAL,SAVE  :: R_READY = .TRUE.

            CHARACTER( 120 )  :: XMSG = ' '
            LOGICAL,SAVE  :: FIRSTIME = .TRUE.

            REAL            TF2, QV, QVM, ADJ, PP, E1, E2, A, B
            CHARACTER*16    VNAME
            CHARACTER*512   MESG
        !!-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

            IF ( FIRSTIME ) THEN
               TOT_TSTEP = 0
               FIRSTIME = .FALSE.
            END IF

            WRITE( MESG, '(A,I8)' ),
     &         '     Processing Met-modulated '
     &          //'emissions table for date:', JDATE
            CALL LOG_MESSAGE( LOGDEV, MESG )

            ! Read METEMIS_TBL Data if this is the first timestep past
            ! the most recent time point on the table.
            STIMEMT = INT( JTIME/10000 ) * 10000
            IF ( PRVHR .NE. STIMEMT ) THEN
                IF( .NOT.XTRACT3( TBLNAME, ALLVAR3, 1, NMTEMP,
     &                         STRTROW, ENDROW, STRTCOL, ENDCOL,
     &                         SDATEMT, STIMEMT, ETABLE ) ) THEN
                    MESG = 'Error(s) reading "'//TRIM(TBLNAME)//'"'
                    CALL M3EXIT( PNAME, SDATEMT, STIMEMT, MESG, 2 )
                END IF
                PRVHR = STIMEMT
            END IF
            
            !!.......   Retrieve Met variable (TEMP2) to compute MetEmis
            CALL interpolate_var ( 'TEMP2', JDATE, JTIME, TEMPVAL )
            IF (HUM_NOX_YN) 
     &          CALL interpolate_var ( 'QV', JDATE, JTIME, QVMOL )

            !!........  Compute-process:  interpolate between pseudo-layers in table
            !!........  Do not extrapolate beyond temperature-range of table.

            DO R = 1, NROWS
            DO C = 1, NCOLS

                TF2 = ( TEMPVAL( C,R ) - CTOK ) * CTOF + 32.0 !!  K ~~> F conversion

                IF ( TF2 .LT. MTEMPS( 1 ) ) THEN     !!  error?  below bottom of table-temperatures

                    DO V = 1, NMETSPC
                        VDEMIS_MV( V,C,R ) =  ETABLE( C,R,1,V )
                    END DO

                ELSE IF ( TF2 .GT. MTEMPS( NMTEMP ) ) THEN     !!  error?  above top of table-temperatures

                    DO V = 1, NMETSPC
                        VDEMIS_MV( V,C,R ) = ETABLE( C,R,NMTEMP,V )
                    END DO
                ELSE

                    DO LL = NMTEMP, 1, -1
                       IF( TF2 < MTEMPS( LL ) ) CYCLE
                       IF( TF2 == MTEMPS( LL ) ) THEN
                           IDX1 = LL
                           IDX2 = LL
                       ELSE
                           IDX1 = LL
                           IDX2 = LL + 1
                       END IF
                       EXIT
                    END DO

                    PP = 1.0
                    IF( IDX1 .NE. IDX2 ) THEN
                        PP = ( TF2 - MTEMPS( IDX1 ) ) / ( MTEMPS( IDX2 ) - MTEMPS( IDX1 ) )
                    END IF

                    DO V = 1, NMETSPC
                        E1 = ETABLE( C,R,IDX1,V )
                        E2 = ETABLE( C,R,IDX2,V )
                        VDEMIS_MV( V,C,R ) = E1 + PP * ( E2 - E1 )
                    END DO

                END IF

C.................  NOx humidity corrections for mobile sources (MOVES3)
                IF (HUM_NOX_YN) THEN
                  QV  = QVMOL( C,R,1 ) * 1000.0  ! convert from kg water/kg dry air to g/kg

                  DO V = 1, NMETSPC
                      IF( MT_GAS( V ) ) THEN
                          ! Correct Gasoline Emission (NO, NO2, and HONO) for Humidity
                          A = MIN( QV, 17.71 )
                          B = MAX( 3.0, A )
                          ADJ = 1.0 - 0.0329 * ( B - 10.71 )   ! NOx humidity correction for Gasoline fuel
                          VDEMIS_MV( V,C,R ) = VDEMIS_MV( V,C,R ) * ADJ

                      ELSE IF( MT_DSL( V ) ) THEN
                          ! Correct Diesel Emission (NO, NO2, and HONO) for Humidity
                          QVM = QV * 0.001607524  ! convert from g of water/kg of dry air to moles of water/moles
                          A = MIN( QVM, 0.035 )
                          B = MAX( 0.002, A )
                          ADJ = 1.0 / ( 9.953 * B  + 0.832 )  ! NOx humidity correction for Diesel fuel
                          VDEMIS_MV( V,C,R ) = VDEMIS_MV( V,C,R ) * ADJ
                      END IF
                  END DO
                END IF

            END DO
            END DO

C ..........  Determine the time to read and/or write the hourly files
            IF ( .NOT. L_DESID_DIAG ) THEN
              NTICS = NTICS + 1
              TOT_TSTEP = TOT_TSTEP + TIME2SEC( TSTEP( 2 ) )
              LASTTIC = TOT_TSTEP .GE. MV_TSTEP
              IF ( LASTTIC ) THEN
                 MTICS = NTICS
                 NTICS = 0
                 TOT_TSTEP = 0
                 CALL NEXTIME( LDATE, LTIME, MV_TSTEP_F)
                 R_READY = .TRUE.
              END IF


C ..........  Output diagnostic emissions
              IF ( METEMDIAG ) THEN
                
                 VDEMIS_MVDIAG = VDEMIS_MVDIAG + VDEMIS_MV   ! array assignment
                 IF ( LASTTIC ) THEN   ! time to write out
                    VDEMIS_MVDIAG = VDEMIS_MVDIAG / REAL( MTICS, 4 )  ! array assignment
                    DO V = 1, NMETSPC
                      IF ( .NOT. WRITE3( CTM_METEMIS_DIAG, MTNAME(V), 
     &                                   LDATE, LTIME,VDEMIS_MVDIAG( V,:,:) ) ) THEN
                         XMSG = 'Could not write to ' // TRIM( CTM_METEMIS_DIAG )
                         CALL M3EXIT( PNAME, LDATE, LTIME, XMSG, XSTAT2 )
                      END IF
                    END DO
                    WRITE( LOGDEV,94040 )
     &                     'Timestep written to', TRIM( CTM_METEMIS_DIAG ),
     &                     'for date and time', LDATE, LTIME
                    VDEMIS_MVDIAG = 0.0   ! array assignment
                 END IF ! LASTTIC

              END IF      !!  if metemdiag
            END IF

            RETURN

94040 FORMAT( /5X, 3( A, :, 1X ), I8, ":", I6.6 )

        END SUBROUTINE GET_METEMIS


      END MODULE  METEMIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE BEIS_DEFN

C-----------------------------------------------------------------------
C Function: biogenics emissions interface to the speciation profiles file

C Revision History:
C     ?? ??? ???? ?.?????: initial implementation
C     20 Sep 2007 J.Young: inline DSCSPROF, eliminate MODSPRO module
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     16 Aug 2018 G. Sarwar: updated for CB6R3M_AE7_KMTBR
C     01 Feb 2019 D. Wong: Implemented centralized I/O approach, and 
C                          created a new module biog_emis_param_module 
C                          (model_data_module.F) to hold some of information
C                          originally stored here to avoid cyclic dependence
C     10 Mar 2021 G. Sarwar: Changed CB6R3M_AE7_KMTBR to CB6R3M_AE7_AQ
C     10 June 2021 G. Sarwar: Replacd CB6R3M_AE7_AQ with CB6R5M_AE7_AQ
C      Xiaoyang Chen at Northeastern University notified that CMAQ is not generating any monoterpene
C             emissions when in-line option is enabled with RACM2
C     07 June 2021 G. Sarwar: replaced "B10RD" with "B3V10" for RACM2
C     30 Sept 2021 G. Sarwar: added CB6R5_AE7_AQ
C     04 Oct  2021 G. Sarwar: added CB6R5HAP_AE7_AQ
C     14 Sep  2023 G. Sarwar: added CRACMM2
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE DESID_VARS
      USE biog_emis_param_module

      IMPLICIT NONE

      INTEGER, SAVE                      :: MSPCS         ! no. of emitted species
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: EMSPC( : )    ! emitted species names
      REAL,    ALLOCATABLE, SAVE         :: VDEMIS_BI( :,:,: ) ! beis emis

      CHARACTER( 16 ), SAVE :: MNAME   ! logical name for MET_CRO_2D
      CHARACTER( 16 ), SAVE :: SNAME   ! logical name for diagnostic emis output (mass)
      INTEGER, SAVE :: MDATE      ! test date to update beis diag avg
      INTEGER, SAVE :: MTIME      ! test time to update beis diag avg


C Mole and mass factors:
      REAL,            ALLOCATABLE, SAVE :: MLFAC( :,: ) ! mole factors
      REAL,            ALLOCATABLE, SAVE :: MSFAC( :,: ) ! mass factors

C-----------------------------------------------------------------------

      CONTAINS
         FUNCTION BEIS_INIT( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )
      
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE RXNS_DATA, ONLY : MECHNAME
         USE UTILIO_DEFN
         USE CGRID_SPCS, ONLY : N_CGRID_SPC, CGRID_NAME, CGRID_MW
#ifdef mpas
         USE util_module, only : PROMPTFFILE, index1, str2real, sortic
#else
#ifdef parallel
         USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
         USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif

         USE MIO_ASCII

         IMPLICIT NONE

C External Functions
         LOGICAL,         EXTERNAL :: CHKGRID

C Arguments:
         LOGICAL :: SUCCESS
         INTEGER, INTENT(  IN ) :: JDATE   ! current simulation date (YYYYDDD)
         INTEGER, INTENT(  IN ) :: JTIME   ! current simulation time (HHMMSS)
         INTEGER, INTENT(  IN ) :: TSTEP(3)! timestep vector (output time step)

C Parameters:
C (A line from the profile file is a record.)
         INTEGER,        PARAMETER :: NSEGS = 6  ! # of potential line segments (fields)
         INTEGER,        PARAMETER :: MXLINES = 100 ! max lines for requested sppro name
         INTEGER,        PARAMETER :: MXSPPOL = 10  ! max no. spc per pollutant
         INTEGER,        PARAMETER :: NMECHS  = 8   ! dimension for number of mechanisms considered
         CHARACTER,      PARAMETER :: CINVHDR = '#' ! Indicator for inventory hdr fields
!        REAL,           PARAMETER :: GM2TON  = 1.0 / 907184.74  ! grams to tons
                         
C unit number for speciation profiles file
         INTEGER :: RDEV

C Header definitions for NONHAP pollutants 
         CHARACTER( 7 ), PARAMETER :: HDRSTART = '/NONHAP' ! start of header
         CHARACTER( 5 ), PARAMETER :: HDREND   = '/END/'   ! end of header

         INTEGER :: MXSPEC    ! max no. of species per pol

C Table of species names per inventory pollutant
         CHARACTER( 16 ), ALLOCATABLE :: SPCNAMES( :,: )
C Table of mole-based units per inventory pollutant for all species
         CHARACTER( 16 ), ALLOCATABLE :: MOLUNITS( :,: )

C Arrays for getting pollutant-specific information from file
         INTEGER         :: NSPECA ( NSEF )     ! number of species per pollutant
         CHARACTER( 16 ) :: POLNAMA( NSEF )     ! unsorted pollutant names
         CHARACTER( 20 ) :: SEGMENT( NSEGS )    ! Segments of parsed lines
         INTEGER         :: INDX1A  ( MXLINES ) ! sorting index for SPECNMA
         CHARACTER( 16 ) :: SPECNMA ( MXLINES ) ! unsort spcs names
         CHARACTER( 16 ) :: TMPNAMES( MXSPPOL,NSEF ) ! unsort names per pollutant
         LOGICAL         :: LMOLAR  ( MXLINES ) ! true: moles conversion is not mass

         INTEGER         :: IPOS( MXSPPOL )   ! position in input pollutant list

C Local variables
         INTEGER        I, J, K, M, N ! counters and indices
         INTEGER        ICOUNT     ! tmp counter while populating SPCNAMES
         INTEGER        IOS        ! i/o status
         INTEGER        POL        ! pollutant counter
         INTEGER        IREC       ! record counter
         INTEGER        ISP        ! species names counter
         INTEGER        NIPOS      ! number of pollutant matches
         INTEGER        PNDX       ! position (from INDEX1) of pol in POLNAMA
         INTEGER        SNDX       ! position (from INDEX1) of pol in SPECNMA
         INTEGER        NDX, INDX  ! index position
         INTEGER        ISTR       ! DESID instruction counter
         INTEGER        STATUS     ! Report problem with allocate

         LOGICAL     :: INHEADER = .FALSE.   ! true: in file header

         CHARACTER( 256 ) :: LINE       ! buffer for profile record
         CHARACTER( 256 ) :: MESG       ! message buffer
         CHARACTER(  16 ) :: SPNPRF     ! record (line) speciation profile name
         CHARACTER(  16 ) :: POLNAM     ! record (line) pollutant name
         CHARACTER(  16 ) :: SPECNM     ! record (line) species name
         CHARACTER(  16 ) :: FILE_SPPRO ! label read from gspro

         REAL                SPLTFAC, SDIV, SMFAC ! line speciation profile factors
         REAL,    ALLOCATABLE, SAVE :: NOPOL( :,: )    ! emissions of NO

         TYPE BIOG_MECH_TYPE
              CHARACTER( 32 ) :: CHEMMECH
              CHARACTER( 16 ) :: BIOGMECH
         END TYPE BIOG_MECH_TYPE

         TYPE( BIOG_MECH_TYPE ) :: BIOG_MECH_MAP( NMECHS ) = (/
     &         BIOG_MECH_TYPE( 'CB6R5HAP_AE7_AQ        ','B10C6AE7'),
     &         BIOG_MECH_TYPE( 'CB6R5_AE7_AQ           ','B10C6AE7'),     
     &         BIOG_MECH_TYPE( 'CB6R5M_AE7_AQ          ','B10C6AE7'),
     &         BIOG_MECH_TYPE( 'CB6R5PFAS_AE7_AQ       ','B10C6AE7'),
     &         BIOG_MECH_TYPE( 'SAPRC07TC_AE6_AQ       ','B10SP   '),
     &         BIOG_MECH_TYPE( 'SAPRC07TIC_AE7I_AQ     ','B10SP   '),
     &         BIOG_MECH_TYPE( 'CRACMM3                ','CRACMM3 '),
     &         BIOG_MECH_TYPE( 'CRACMM2                ','CRACMM2 ') /)
 
         CHARACTER( 16 )  :: PNAME = 'BEIS_INIT'
         CHARACTER( 120 ) :: XMSG = ' '

         INTERFACE
            SUBROUTINE HRNO( JDATE, JTIME, TSTEP, NOPOL, L_DESID_DIAG )
               INTEGER, INTENT( IN )  :: JDATE
               INTEGER, INTENT( IN )  :: JTIME
               INTEGER, INTENT( IN )  :: TSTEP( 3 )
               REAL,    INTENT( OUT ) :: NOPOL( :,: )
               LOGICAL, INTENT( IN )  :: L_DESID_DIAG
            END SUBROUTINE HRNO
         END INTERFACE
 
C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

C Open speciation profiles file
         RDEV = PROMPTFFILE(
     &            'Enter logical name for Speciation Profiles file',
     &            .TRUE., .TRUE., 'GSPRO', PNAME )

         IF ( SPPRO .EQ. 'DEFAULT' ) THEN 
            INDX = INDEX1( MECHNAME, NMECHS, BIOG_MECH_MAP%CHEMMECH )
            SPPRO = BIOG_MECH_MAP( INDX )%BIOGMECH
            WRITE( LOGDEV, '(5X,A,A,A)' ), 'Accessing compatible biogenic ',
     &             'emissions mechanism: ',TRIM( SPPRO )
         END IF

C Scan speciation profiles file to get all of the pollutant-species combinations
C that are valid for the pollutants in the inventory. The species names are sorted
C in alphebetical order for each pollutant, and the pollutants are in the same order
C as BIOTYPES. Also retrieve the maximum number of species per pollutant and the
C maximum number of profile entries per pollutant.

C Initialize species count per pollutant and flag for indicating true molar
C conversions (NOTE - for some pollutants like PM10, there are no mole-based
C factor and outputs should be in units of gm/mole in the mole-base speciation
C matrix)
         NSPECA   = 0        ! array
         POLNAMA  = ' '      ! array
         TMPNAMES = ' '      ! array
         LMOLAR   = .FALSE.  ! array

C Read through input file to determine the total number of pollutants in the input
C file, to determine the number of profiles per pollutant, to store the unique
C species names, and to store the units for mass-based and mole-based conversions
         ICOUNT = 1
         POL    = 0
         ISP    = 0
         IREC   = 0
         DO
            READ( RDEV, 93000, END=1999, IOSTAT=IOS ) LINE
            IREC = IREC + 1
            IF ( IOS .GT. 0 ) THEN
               WRITE( MESG, 94010 )
     &               'I/O error', IOS, 'reading speciation profile ' //
     &               'file at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Skip blank and comment lines
            IF ( LINE .EQ. ' ' .OR. LINE( 1:1 ) .EQ. CINVHDR ) CYCLE

C Skip all lines until the end of the header...
C Check for header start
            NDX = INDEX( LINE, HDRSTART )
            IF ( NDX .GT. 0 ) INHEADER = .TRUE.

            NDX = INDEX( LINE, HDREND )
            IF ( INHEADER ) THEN
               IF ( NDX .GT. 0 ) INHEADER = .FALSE.
               CYCLE
            ELSE IF ( NDX .GT. 0 ) THEN
               WRITE( MESG,94010 ) 'Header end found before header ' //
     &                             'started at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Skip lines that dont reference the requested speciation profile name
            IF ( LINE( 1:1 ) .EQ. '"' ) THEN
               FILE_SPPRO = LINE( 2: INDEX( LINE,'"' )-1 )
               IF ( FILE_SPPRO .NE. SPPRO ) CYCLE 
            ELSE
               FILE_SPPRO = LINE( 1: INDEX( LINE,';' )-1 )
               IF ( FILE_SPPRO .NE. SPPRO ) CYCLE 
            END IF

C Separate the line of data (record) into the segments (parse the record fields)
            CALL PARSLINE( LINE, NSEGS, SEGMENT )

C Left-justify character strings and convert factors to reals
            SPNPRF  = ADJUSTL ( SEGMENT( 1 ) )
            POLNAM  = ADJUSTL ( SEGMENT( 2 ) )
            SPECNM  = ADJUSTL ( SEGMENT( 3 ) )
            SPLTFAC = STR2REAL( SEGMENT( 4 ) )
            SDIV    = STR2REAL( SEGMENT( 5 ) )
            SMFAC   = STR2REAL( SEGMENT( 6 ) )

C Check width of character fields of fixed length
            N = LEN_TRIM( SPNPRF )
            IF ( N .GT. 16 ) THEN
               WRITE( MESG,94010 ) 'ERROR: Speciation profile code ' //
     &                'exceeds max width of 16 characters at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

            N = LEN_TRIM( POLNAM )
            IF ( N .GT. 16 ) THEN
               WRITE( MESG,94010 ) 'ERROR: Pollutant name ' //
     &                'exceeds max characters of 16 at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

            N = LEN_TRIM( SPECNM )
            IF ( N .GT. 16 ) THEN
               WRITE( MESG,94010 ) 'ERROR: Species name ' //
     &                 'exceeds max characters of 16 at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Make sure divisor factor is not zero
            IF ( SDIV .EQ. 0.0 ) THEN
               WRITE( MESG,94010 ) 'ERROR: Zero divisor found at line ', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Search for pollutant in list of valid names, and go to the end of the loop if
C none found (skip entry).  Record number and position of all matches.
            M    = 0
            IPOS = 0   ! array
            DO N = 1, NSEF
               IF ( POLNAM .EQ. BIOTYPES( N ) ) THEN
                  M = M + 1
                  IF ( M .LE. MXSPPOL ) THEN
                     IPOS( M ) = N
                  ELSE      ! Max of 10 profile pollutant names per biotype
                     MESG = 'ERROR: Exceeded max pollutant names' //
     &                      'per biotype in ' // PNAME
                     CALL M3MSG2( MESG )
                     MESG = 'Quitting'
                     CALL M3MESG( MESG )
                     SUCCESS = .FALSE.; RETURN
                  END IF
               END IF
            END DO
            NIPOS = M

            IF ( MAXVAL( IPOS ) .EQ. 0 ) CYCLE

C Build unique pollutant name list (POLNAMA) from list of all profile file pollutants
            PNDX = INDEX1( POLNAM, POL, POLNAMA )

            IF ( PNDX .LE. 0 ) THEN     ! if current POLNAM is not in POLNAMA, then
               POL = POL + 1            ! increment counter, and
               POLNAMA( POL ) = POLNAM  ! add POLNAM to POLNAMA
            END IF

C Build unique species name list (SPECNMA) from list of profile file species names
            SNDX = INDEX1( SPECNM, ISP, SPECNMA )

            IF ( SNDX .LE. 0 ) THEN     ! if current SPECNM is not in SPECNMA, then
               ISP = ISP + 1
               INDX1A ( ISP ) = ISP     ! add to index
               SPECNMA( ISP ) = SPECNM  ! add SPECNM to SPECNMA

C If mole-based = mass based, then use molar transform
               IF ( SPLTFAC / SDIV .NE. SMFAC ) LMOLAR( ISP ) = .TRUE.

            END IF

C Check if species is already stored for current pollutant, and if not, increment
C species-per-pollutant counter and add species to list.
            DO M = 1, NIPOS
               K   = NSPECA( IPOS( M ) )
#ifdef mpas
               NDX = INDEX1( SPECNM, K, TMPNAMES( :,IPOS( M ) ) )
#else
               NDX = INDEX1( SPECNM, K, TMPNAMES( 1,IPOS( M ) ) )
#endif
               IF ( NDX .LE. 0 ) THEN
                  K = K + 1
                  IF ( K .LE. MXSPPOL ) THEN
                     TMPNAMES( K,IPOS( M ) ) = SPECNM
                  ELSE
                     MESG = 'ERROR: Exceeded TMPNAMES dimension'
                     CALL M3MESG( MESG )
                     SUCCESS = .FALSE.; RETURN
                  END IF
                  NSPECA( IPOS( M ) ) = K
               END IF
            END DO

         END DO   ! infinite read loop

1999     CONTINUE ! end reading speciation profile input lines

         IF ( POL .EQ. 0 ) THEN
            MESG = 'ERROR: No pollutants found in speciation ' //
     &             'profiles that match the inventory!'
            CALL M3MESG( MESG )
            SUCCESS = .FALSE.; RETURN
         END IF

         IF ( ISP .EQ. 0 ) THEN
            MESG = 'ERROR: No species found in speciation profile!'
            CALL M3MESG( MESG )
            SUCCESS = .FALSE.; RETURN
         END IF

C max number of species per pollutant
         MXSPEC  = MAXVAL( NSPECA )

C Allocate memory for species names array and units to use for mole-based
C transformations.
         ALLOCATE( SPCNAMES( MXSPEC,NSEF ), STAT=IOS )
         CALL CHECKMEM( IOS, 'SPCNAMES', PNAME )
         ALLOCATE( MOLUNITS( MXSPEC,NSEF ), STAT=IOS )
         CALL CHECKMEM( IOS, 'MOLUNITS', PNAME )

         SPCNAMES = ' '   ! array
         MOLUNITS = ' '   ! array

C Sort master species names
         CALL SORTIC( ISP, INDX1A, SPECNMA )  ! sort on INDX1A

C Cycle through count of all valid pollutants (NSEF) and all species associated
C with these pollutants (ISP).  Check if species is valid for the current pollutant,
C and if so, store in the output species name list.
         DO I = 1, NSEF
            ICOUNT = 0
            DO J = 1, ISP
C Process species in sorted order
               K = INDX1A( J )
C Find species in list of valid species per pollutant
#ifdef mpas
               NDX = INDEX1( SPECNMA( K ), NSPECA( I ), TMPNAMES( :,I ) )
#else
               NDX = INDEX1( SPECNMA( K ), NSPECA( I ), TMPNAMES( 1,I ) )
#endif
               IF ( NDX .GT. 0 ) THEN
                  ICOUNT = ICOUNT + 1
                  SPCNAMES( ICOUNT, I ) = SPECNMA( K )
C When the species does not have molar factors, store the molar units as mass units
                  IF ( LMOLAR( K ) ) THEN
                     MOLUNITS( ICOUNT, I ) = 'moles/ton'
                  ELSE
                     MOLUNITS( ICOUNT, I ) = 'g/ton'
                  END IF
               END IF
            END DO
         END DO

C Reposition sequential file for second pass

         REWIND( RDEV )

         ALLOCATE( EMSPC( MXLINES ), STAT=IOS )
         CALL CHECKMEM( IOS, 'EMSPC', PNAME )

         EMSPC = ' '   ! array initialization

#ifdef Verbose
         write( logdev,* ) '    Biogenic emissions species:'
         write( logdev,* ) '    Pol POLNAMES  Spc SPCNAMES         Mspcs EMSPC'
#endif

C Find emitted CMAQ species names
         MSPCS = 0
         DO POL = 1, NSEF
            DO ISP = 1, MXSPEC
               IF ( SPCNAMES( ISP,POL ) .EQ. ' ' ) CYCLE
               NDX = INDEX1 ( SPCNAMES( ISP,POL ), MSPCS, EMSPC ) 
               IF ( NDX .EQ. 0 ) THEN
                  MSPCS = MSPCS + 1
                  EMSPC( MSPCS ) = SPCNAMES( ISP,POL )

                  WRITE (MESG, '(A,I0,A,A)'),'BEIS: Species ',MSPCS,' is ',TRIM(EMSPC( MSPCS ))
                  CALL M3MESG( MESG )
#ifdef Verbose
                  write( logdev,'( 5X, I3, 1X, A5, 5X, I3, 1X, A16, I4, 3X, A16 )' )
     &                   pol, biotypes( pol ), isp, spcnames( isp,pol ), mspcs,
     &                   emspc( mspcs )
               else
                  write( logdev,'( 5X, I3, 1X, A5, 5X, I3, 1X, A16 )' )
     &                   pol, biotypes( pol ), isp, spcnames( isp,pol )
#endif
               END IF
            END DO
         END DO

         WRITE (MESG, '(A,I0)'),'BEIS: Number species found in speciation profile = ',MSPCS
         CALL M3MESG( MESG )

C Save Species names in global array for mapping emissions
         DESID_EMVAR( IBIOSRM )%LEN = MSPCS
         ALLOCATE( DESID_EMVAR( IBIOSRM )%ARRY ( MSPCS ) )
         ALLOCATE( DESID_EMVAR( IBIOSRM )%UNITS( MSPCS ) )
         ALLOCATE( DESID_EMVAR( IBIOSRM )%MW   ( MSPCS ) )
         ALLOCATE( DESID_EMVAR( IBIOSRM )%USED ( MSPCS ) )
         ALLOCATE( DESID_EMVAR( IBIOSRM )%CONV ( MSPCS ) )
         ALLOCATE( DESID_EMVAR( IBIOSRM )%BASIS( MSPCS ) )
         ALLOCATE( DESID_EMVAR( IBIOSRM )%LAREA( MSPCS ) )
         ALLOCATE( DESID_EMVAR( IBIOSRM )%LAREAADJ( MSPCS ) )

         DESID_EMVAR( IBIOSRM )%ARRY  = EMSPC
         DESID_EMVAR( IBIOSRM )%UNITS = 'MOLES/S'
         DESID_EMVAR( IBIOSRM )%MW    = 1.0
         DESID_EMVAR( IBIOSRM )%USED  = .FALSE.
         DESID_EMVAR( IBIOSRM )%CONV  = 1.0
         DESID_EMVAR( IBIOSRM )%BASIS = 'MOLE'
         DESID_EMVAR( IBIOSRM )%LAREA = .FALSE.
         DESID_EMVAR( IBIOSRM )%LAREAADJ = .FALSE.

         ! Populate the Molecular Weight Field by Matching Gas Species
         ! to the CMAQ mechanism species
         DO ISP = 1,MSPCS
             INDX = INDEX1( EMSPC( ISP ), N_CGRID_SPC, CGRID_NAME )
             IF ( INDX .NE. 0 ) THEN
                 DESID_EMVAR( IBIOSRM )%MW( ISP ) = CGRID_MW( INDX )
             ELSE
                 WRITE( MESG, '(A,A,A,A)' ) 'WARNING: BEIS emission species ',
     &               EMSPC( ISP ),' is not found in the Gas-Phase Mechanism. ',
     &               'The emission variable molecular weight will be set to 1.0'
                 CALL LOG_MESSAGE( LOGDEV, MESG )
                 DESID_EMVAR( IBIOSRM )%MW( ISP ) = 1.0
             END IF

         END DO

C Allocate memory for storing mole- and mass-based factors
         ALLOCATE( MLFAC( MSPCS,NSEF ), STAT=IOS )
         CALL CHECKMEM( IOS, 'MLFAC', PNAME )
         ALLOCATE( MSFAC( MSPCS,NSEF ), STAT=IOS )
         CALL CHECKMEM( IOS, 'MSFAC', PNAME )
         MLFAC = 0.0   ! array
         MSFAC = 0.0   ! array

C Read through input file to determine the total number of pollutants in the
C input file, to determine the number of profiles per pollutant, to store the
C unique species names, and to store the units for mass-based and mole-based
C conversions
         IREC = 0
         DO
            READ( RDEV, 93000, END=2999, IOSTAT=IOS ) LINE
            IREC = IREC + 1
            IF ( IOS .GT. 0 ) THEN
               WRITE( MESG, 94010 )
     &              'I/O error', IOS, 'reading speciation profile ' //
     &              'file at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Skip blank and comment lines
            IF ( LINE .EQ. ' ' .OR. LINE( 1:1 ) .EQ. CINVHDR ) CYCLE

C Skip lines that dont reference the requested speciation profile name
            IF ( LINE( 1:1 ) .EQ. '"' ) THEN
               FILE_SPPRO = LINE( 2: INDEX( LINE,'"' )-1 )
               IF ( FILE_SPPRO .NE. SPPRO ) CYCLE 
            ELSE
               FILE_SPPRO = LINE( 1: ( INDEX( LINE,';' )-1 ) )
               IF ( FILE_SPPRO .NE. SPPRO ) CYCLE 
            END IF

C Separate the line of data into each part
            CALL PARSLINE( LINE, NSEGS, SEGMENT )

C Left-justify character strings and convert factors to reals
            SPNPRF  = ADJUSTL ( SEGMENT( 1 ) )
            POLNAM  = ADJUSTL ( SEGMENT( 2 ) )
            SPECNM  = ADJUSTL ( SEGMENT( 3 ) )
            SPLTFAC = STR2REAL( SEGMENT( 4 ) )
            SDIV    = STR2REAL( SEGMENT( 5 ) )
            SMFAC   = STR2REAL( SEGMENT( 6 ) )

C Search for pollutant in list of valid names, and go to the end of the loop if
C not found (skip entry)
            PNDX = INDEX1( POLNAM, NSEF, BIOTYPES )
            IF ( PNDX .EQ. 0 ) CYCLE
            SNDX = INDEX1( SPECNM, MSPCS, EMSPC )
            IF ( SNDX .GT. 0 ) THEN
               MLFAC( SNDX,PNDX ) = SPLTFAC / SDIV
               MSFAC( SNDX,PNDX ) = SMFAC
            END IF

         END DO   ! infinite read loop

2999     CONTINUE ! end reading speciation profile input lines

#ifndef mpas
C Ensure met data time and grid for this run match beis emissions data files
         MNAME = PROMPTMFILE(
     &           'Enter name for gridded met input file',
     &           FSREAD3, 'MET_CRO_2D', PNAME )

C Get description of met file
         IF ( .NOT. DESC3( MNAME ) ) THEN
            MESG = 'Could not get description of file "'
     &           // TRIM( MNAME ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF

C Check that grid description matches BGRD file
         IF ( .NOT. CHKGRID( MNAME ) ) THEN
            MESG = 'Grid in file "' // TRIM( MNAME )
     &           // '" does not match previously set grid.'
            CALL M3WARN( PNAME, 0, 0, MESG )
         END IF

         IF ( BEMIS_DIAG ) THEN
C Build description for, and open beis diagnostic file
            MDATE = STDATE; MTIME = STTIME
            CALL NEXTIME( MDATE, MTIME, TSTEP(1) )

            GDNAM3D = GRID_NAME  ! from HGRD_DEFN
            SDATE3D = MDATE
            STIME3D = MTIME
            TSTEP3D = TSTEP(1)
            NCOLS3D = GL_NCOLS
            NROWS3D = GL_NROWS
            NLAYS3D =     1
            NTHIK3D =     1
            GDTYP3D = GDTYP_GD
            P_ALP3D = P_ALP_GD
            P_BET3D = P_BET_GD
            P_GAM3D = P_GAM_GD
            XORIG3D = XORIG_GD
            YORIG3D = YORIG_GD
            XCENT3D = XCENT_GD
            YCENT3D = YCENT_GD
            XCELL3D = XCELL_GD
            YCELL3D = YCELL_GD
            VGTYP3D = VGTYP_GD
            VGTOP3D = VGTOP_GD

            DO I = 1, NLAYS3D + 1
               VGLVS3D( I ) = VGLVS_GD( I )
            END DO

            VNAME3D = ''
            VDESC3D = ''
            UNITS3D = ''
            DO J = 1, MSPCS
               VNAME3D( J ) = EMSPC( J )
               VDESC3D( J ) = 'biogenic emissions of the indicated species'
               VTYPE3D( J ) = M3REAL
               UNITS3D( J ) = 'gm s-1'
            END DO

            NVARS3D = MSPCS
            FDESC3D = ' '   ! array

            FDESC3D( 1 ) = 'Gridded biogenic emissions from CMAQ-BEIS3'
            FDESC3D( 2 ) = '/from/ ' // PNAME
            FDESC3D( 3 ) = '/Version/ CMAQ'

            ! Store MIO Metadata
            NDIMS3D( 1:NVARS3D ) = 3
            L_TSTEP( 1:NVARS3D ) = .True.
            L_LAY  ( 1:NVARS3D ) = .False.
            L_COL  ( 1:NVARS3D ) = .True.
            L_ROW  ( 1:NVARS3D ) = .True.
            L_VEXT ( 1:NVARS3D ) = .False.

            CALL LOAD_MIO_FILE ( 'B3GTS_S', 0, 0, 0,
     &           VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &           VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &           L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &           L_VEXT(1:NVARS3D) )


C Open mass output file (tons/hour)

            SNAME = 'B3GTS_S'
            CALL SUBST_BARRIER
            IF ( IO_PE_INCLUSIVE ) THEN
               IF ( .NOT. OPEN3( SNAME, FSNEW3, PNAME ) ) THEN
                  MESG = 'Could not open "' // TRIM( SNAME ) // '" file'
                  CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT1 )
               END IF
            END IF

         END IF
#endif

C Initialize Biogenic Emission Array Variable
         ALLOCATE( VDEMIS_BI( MSPCS,NCOLS,NROWS ), STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
           XMSG = 'VDEMIS_BI memory allocation failed'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
          
C Initialize temporal non-speciated soil NO emissions
         ALLOCATE( NOPOL( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'NOPOL', PNAME )
         NOPOL(:,:) = 0.0
         CALL HRNO( JDATE, JTIME, TSTEP, NOPOL, .FALSE. )

         SUCCESS = .TRUE.

         RETURN

C-----------------------------------------------------------------------

93000    FORMAT( A )
94010    FORMAT( 10( A, :, I8, :, 1X ) )

         END FUNCTION BEIS_INIT

      END MODULE BEIS_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! Revision history: 01 Feb, 19 D. Wong: Implemented centralized I/O approach, 
!                                       removed all MY_N clauses

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      MODULE PHOT_MET_DATA

         IMPLICIT NONE

         REAL, ALLOCATABLE :: QC( :,:,: )  ! cloud water content [kg/kg]
         REAL, ALLOCATABLE :: QR( :,:,: )  ! rain water content [kg/kg]
         REAL, ALLOCATABLE :: QI( :,:,: )  ! ice content [kg/kg]
         REAL, ALLOCATABLE :: QS( :,:,: )  ! snow content [kg/kg]
         REAL, ALLOCATABLE :: QG( :,:,: )  ! graupel content [kg/kg]
         REAL, ALLOCATABLE :: QV( :,:,: )  ! water vapor content [kg/kg]
           
         REAL, ALLOCATABLE :: CFRAC_3D( :,:,: ) ! 3D fractional cloud coverage
         REAL, ALLOCATABLE :: CFRAC_2D( :,: )   ! layer averaged 3D fractional cloud coverage
         REAL, ALLOCATABLE :: AVE_HYDROMETEORS( :,: ) ! Cloud Hydrometeor Content averaged over cloudy layers, [g/m3]

! properties of ACM unresolved cloud
         LOGICAL           :: USE_ACM_CLOUD = .TRUE.
           
         REAL, ALLOCATABLE :: ACM_CFRAC( :,:,: )   ! total fractional cloud coverage
         REAL, ALLOCATABLE :: ACM_QC   ( :,:,: )   ! cloud water content [kg/kg]
         REAL, ALLOCATABLE :: ACM_QR   ( :,:,: )   ! rain water content [kg/kg]
         REAL, ALLOCATABLE :: ACM_QI   ( :,:,: )   ! ice content [kg/kg]
         REAL, ALLOCATABLE :: ACM_QG   ( :,:,: )   ! graupel content [kg/kg]
         REAL, ALLOCATABLE :: ACM_CLOUDS ( :,: )   ! subgrid cloud fractions averaged over cloudy layer
         REAL, ALLOCATABLE :: ACM_AVE_H2O( :,: )   ! subgrid cloud water content averaged over cloudy layer, [g/m3]

         REAL, ALLOCATABLE :: COSINE_ZENITH( :,: ) ! cosine of solar zenith angle
           
         REAL, ALLOCATABLE :: DENS   ( :,:,: )     ! air density [Kg/m **3]
         REAL, ALLOCATABLE :: TA     ( :,:,: )     ! air temperature [K]
         REAL, ALLOCATABLE :: PRES   ( :,:,: )     ! air pressure [Pa]
         REAL, ALLOCATABLE :: ZM     ( :,:,: )     ! layer half height agl [m]
         REAL, ALLOCATABLE :: ZFULL  ( :,:,: )     ! layer full height agl [m]
          
         REAL              :: DIST_TO_SUN          ! solar distance [au]

! public variables:
         PUBLIC :: QC, QR, QI, QS, QG, QV,
     &             CFRAC_2D, CFRAC_3D, AVE_HYDROMETEORS,
     &             USE_ACM_CLOUD, ACM_CFRAC, ACM_QC, ACM_QR, ACM_QI, ACM_QG,
     &             ACM_CLOUDS, ACM_AVE_H2O,
     &             COSINE_ZENITH,
     &             DENS, TA, PRES, ZM, ZFULL, DIST_TO_SUN

! public procedures:
         PUBLIC :: GET_PHOT_MET, UPDATE_SUN, CLEAR_ACM_CLOUD, 
     &             CAPTURE_ACM_CLOUD
           
         PRIVATE

         INTEGER           :: HYDROMETEORS ! denotes mix of hydrometeors available
!        value   cloud water  rain       ice        snow     graupel
!          1        x          x
!          2        x          x          x          x
!          3        x          x          x          x          x

         REAL, ALLOCATABLE :: CFRAC   ( :,: )      ! total fractional cloud coverage
         REAL, ALLOCATABLE :: DELTA_Z( :,:,: )     ! layer thickness [m]

! flags for hydrometeors available on file:
!        LOGICAL           :: QV_AVAIL       = .TRUE.   ! QV (vapor)
!        LOGICAL           :: QC_AVAIL       = .TRUE.   ! QC (liquid)
!        LOGICAL           :: QR_AVAIL       = .TRUE.   ! QR (rain)
!        LOGICAL           :: QI_AVAIL       = .TRUE.   ! QI (ice)
!        LOGICAL           :: QS_AVAIL       = .TRUE.   ! QS (snow)
!        LOGICAL           :: QG_AVAIL       = .TRUE.   ! QG (graupel)
!        LOGICAL           :: CFRAC_3D_AVAIL = .TRUE.   ! CFRAC_3D

         LOGICAL           :: FIRSTIME = .TRUE. ! flag for first pass thru

         CHARACTER( 16 )   :: VARNM            ! variable name for IOAPI to get
         CHARACTER( 16 )   :: VNAME_RN
         CHARACTER( 300 )  :: XMSG = ' '       ! Exit status message

         INTEGER           :: LDATE             ! last jdate MET data updated
         INTEGER           :: LTIME             ! last jtime MET data updated
         INTEGER           :: STDATE            ! jdate MET module initiated
         INTEGER           :: STTIME            ! jtime MET module initiated
         INTEGER           :: ACM_DATE = -1     ! last date routine called
         INTEGER           :: ACM_TIME = -1     ! last time routine called
          
         INTEGER           :: GXOFF, GYOFF      ! global origin offset from file

         REAL, ALLOCATABLE :: SINLATS( :,: ) ! sine of latitude
         REAL, ALLOCATABLE :: COSLATS( :,: ) ! cosine of latitude
         REAL              :: STRTHR         ! starting GMT hour

         LOGICAL           :: SET_ACM_ARRAYS = .TRUE.

         CONTAINS 
       
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE INIT_PHOT_MET( JDATE, JTIME )

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN
         USE CENTRALIZED_IO_MODULE
         USE CONST, ONLY: PI180

         IMPLICIT NONE

!...........Includes:

         INCLUDE SUBST_FILES_ID             ! file name parameters
       
!...........Inputs:       

         INTEGER, INTENT( IN ) :: JDATE     ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN ) :: JTIME     ! current model time, coded HHMMSS
       
!...........Local:
         INTEGER               :: COL       ! column loop counter
         INTEGER               :: ROW       ! row loop counter
         INTEGER               :: ASTAT     ! memory allocation status

         CHARACTER( 16 )       :: PNAME = 'INIT_PHOT_MET' 
       
         LOGICAL,  SAVE        :: INITIALIZED = .FALSE.
       
         IF ( INITIALIZED ) RETURN
       
         INITIALIZED = .TRUE.
       
! set up variables for calculating cosine of solar zenith angle

         ALLOCATE ( SINLATS( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SINLATS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( COSLATS( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating COSLATS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         DO ROW = 1, NROWS
            DO COL = 1, NCOLS
                SINLATS( COL,ROW ) = SIN( PI180 * LAT ( COL,ROW ) )
                COSLATS( COL,ROW ) = COS( PI180 * LAT ( COL,ROW ) )
             END DO
         END DO

         ALLOCATE ( COSINE_ZENITH( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating COSINE_ZENITH'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         !ALLOCATE ( CFRAC( NCOLS,NROWS ), STAT = ASTAT )
         !IF ( ASTAT .NE. 0 ) THEN
         !   XMSG = 'Failure allocating CFRAC'
         !   CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         !END IF

         ALLOCATE ( DENS( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DENS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( TA( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating TA'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( PRES( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating PRES'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( ZM( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating ZM'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         ALLOCATE ( ZFULL( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating ZFULL'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( DELTA_Z( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DELTA_Z'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( QV( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QV'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( QC( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( QR( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QR'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         HYDROMETEORS = 1   ! always cloud water and rain

! test for which optional hydrometeors are available
! For WRF/MCIP: if GQ is available, all hydrometeors are available
!               else if QI or QS is available, QC and QR are available

         IF ( QG_AVAIL ) THEN
            HYDROMETEORS = 3
         ELSE
            WRITE( LOGDEV, '(3(/10X,A),(/10X,3(A,1X)),(/10X,A))' )
     &           'YOU SHOULD VERIFY that the cloud microphysics scheme used',
     &           'in the Meteorological Model did not include graupel.  If',
     &           'it did, then you need to reprocess the meteorological data',
     &           'through MCIP and pass QG to file ',
     &           TRIM( MET_CRO_3D ), ' to avoid',
     &           'errors in the photolysis simulation.'
            WRITE( LOGDEV, '((/5X,A),/)' )
     &           'Processing will continue with QG set to ZERO.  <<--<<'
            IF ( QI_AVAIL ) THEN
               HYDROMETEORS = 2
            ELSE
               WRITE( LOGDEV, '(3(/10X,A),(/10X,3(A,1X)),(/10X,A))' )
     &              'YOU SHOULD VERIFY that the cloud microphysics scheme used',
     &              'in the Meteorological Model did not include ice/snow.  If',
     &              'it did, then you need to reprocess the meteorological data',
     &              'through MCIP and pass QI to file ',
     &              TRIM( MET_CRO_3D ), ' to avoid',
     &              'errors in the photolysis simulation.'
               WRITE( LOGDEV, '((/5X,A),/)' )
     &              'Processing will continue with QI set to ZERO.  <<---<<'
            END IF
         END IF

         ALLOCATE ( QG( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QG'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF        
         QG = 0.0
        
         ALLOCATE ( QI( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QI'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         QI = 0.0

         ALLOCATE ( QS( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         QS = 0.0

         IF ( SET_ACM_ARRAYS .AND. USE_ACM_CLOUD ) THEN
            CALL INIT_ACM_CLOUD( 0, 0 )
            SET_ACM_ARRAYS = .FALSE.
         END IF

         IF ( .NOT. CFRAC_3D_AVAIL ) THEN
            XMSG = 'Variable CFRAC_3D (cloud fraction) not found in ' // MET_CRO_3D
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            WRITE( LOGDEV, * )
            WRITE( XMSG, '(4A)' )
     &           'Model will diagnose layer cloud fraction using Randall (1995) ',
     &           'and Hong (1998), based on mixing ratios of water vapor and its ',
     &           'condensed states. You may want to reprocess the meteorological ',
     &           'data to obtain layer cloud fractions if possible.'
            CALL LOG_MESSAGE( LOGDEV, XMSG )

         END IF
        
         ALLOCATE ( CFRAC_3D( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CFRAC_3D'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         CFRAC_3D = 0.0

         ALLOCATE ( CFRAC_2D( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CFRAC_2D'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AVE_HYDROMETEORS( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AVE_HYDROMETEORS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

! report out hydrometeors found
         SELECT CASE( HYDROMETEORS )
            CASE( 1 )
                 WRITE( LOGDEV,2021 ) TRIM( PNAME ), "QC and QR"
            CASE( 2 )
                 WRITE( LOGDEV,2021 ) TRIM( PNAME ), "QC, QR, QI and QS"
            CASE( 3 )
                 WRITE( LOGDEV,2021 ) TRIM( PNAME ), "QC, QR, QG, QI and QS"
         END SELECT        
2021     FORMAT( /10X, A, ": Cloud has ", A )
        
         LDATE  = 0
         LTIME  = 0

         STDATE = JDATE
         STTIME = JTIME
         STRTHR = FLOAT( JTIME / 10000 )

         FIRSTIME = .FALSE.
        
         END SUBROUTINE INIT_PHOT_MET

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE GET_PHOT_MET( JDATE, JTIME, MDATE, MTIME )
        
         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN         ! IO routines & utilties
         USE CENTRALIZED_IO_MODULE

         IMPLICIT NONE

!  REVISION  HISTORY:
!  B.Hutzell Oct 13, 2015 Changed computation of effective resolved fraction, CFRAC_2D,
!             to be consisitent with random cloud overlap model that in used in the 
!             radiative transfer calculation. Consult Tain and Curry (1989), JGR, vol.94,
!             9925-9935 for more information.
!...........Includes:

         INCLUDE SUBST_FILES_ID             ! file name parameters

         INTEGER, INTENT( IN ) :: JDATE     ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN ) :: JTIME     ! current model time, coded HHMMSS
         INTEGER, INTENT( IN ) :: MDATE     ! date for calculation/interpolation(yyyyddd)
         INTEGER, INTENT( IN ) :: MTIME     ! time for calculation/interpolation (hhmmss)

!..........Local:

         CHARACTER( 16 ), SAVE :: PNAME =  'GET_PHOT_MET'
        
         INTEGER               :: COL       ! column loop counter
         INTEGER               :: ROW       ! row loop counter
         INTEGER               :: LAY       ! layer loop counter
        
         INTEGER               :: ASTAT           ! allocation status measure
        
         REAL                  :: SUM_WEIGHTS
         REAL                  :: WEIGHT
         REAL                  :: WATER
       
       
         IF ( FIRSTIME ) THEN
            CALL INIT_PHOT_MET( JDATE, JTIME )
         END IF

!...store met file time, date, and step information and compute
!...  the met timestep in hours

         IF ( LDATE .EQ. MDATE .AND. LTIME .EQ. MTIME ) RETURN
        
         LDATE = MDATE
         LTIME = MTIME

!...  Interpolate time dependent layered input variables

         VARNM = 'ZH' ! midlayer height
         call interpolate_var (VARNM, mdate, mtime, ZM)

         VARNM = 'ZF' ! full layer height
         call interpolate_var (VARNM, mdate, mtime, ZFULL)

!...Get air density (kg/m3)

         VARNM = 'DENS'
         call interpolate_var (VARNM, mdate, mtime, DENS)

!...get temperature [K]

         VARNM = 'TA'
         call interpolate_var (VARNM, mdate, mtime, TA)
 
!...pressure [Pa]

         VARNM = 'PRES'
         call interpolate_var (VARNM, mdate, mtime, PRES)

!...Get resolved cloud fractions

         VARNM = 'CFRAC'
         !call interpolate_var (VARNM, mdate, mtime, CFRAC)

!...Get resolved water vapor mixing ratio (kg H2O / kg air)

         VARNM = 'QV'
         call interpolate_var (VARNM, mdate, mtime, QV)

!...Get resolved cloud water mixing ratio (kg H2O / kg air)
         VARNM = 'QC'
         call interpolate_var (VARNM, mdate, mtime, QC)

!...Get resolved rain water mixing ratio (kg H2O / kg air)
         VARNM = 'QR'
         call interpolate_var (VARNM, mdate, mtime, QR)

         IF ( QG_AVAIL ) THEN
!...read resolved graupel and the other hydrometeor mixing ratios (kg H2O / kg air)
!...from the met file if available
            VARNM = 'QG'
            call interpolate_var (VARNM, mdate, mtime, QG)

!...read resolved ice and snow mixing ratios (kg H2O / kg air)
            VARNM = 'QI'
            call interpolate_var (VARNM, mdate, mtime, QI)

            VARNM = 'QS'
            call interpolate_var (VARNM, mdate, mtime, QS)

         ELSE IF ( QI_AVAIL ) THEN
!...read resolved ice and snow mixing ratios (kg H2O / kg air) from the met
!...from the met file if available
            VARNM = 'QI'
            call interpolate_var (VARNM, mdate, mtime, QI)

            VARNM = 'QS'
            call interpolate_var (VARNM, mdate, mtime, QS)

         END IF
         
! floor values of QC, QR, QI, QS, and QG to zero

         IF ( QG_AVAIL ) THEN
            DO LAY = 1, NLAYS
               DO ROW = 1, NROWS
                  DO COL = 1, NCOLS
                     QC( COL,ROW,LAY ) = MAX( QC( COL,ROW,LAY ), 0.0 )
                     QR( COL,ROW,LAY ) = MAX( QR( COL,ROW,LAY ), 0.0 )
                     QI( COL,ROW,LAY ) = MAX( QI( COL,ROW,LAY ), 0.0 )
                     QS( COL,ROW,LAY ) = MAX( QS( COL,ROW,LAY ), 0.0 )
                     QG( COL,ROW,LAY ) = MAX( QG( COL,ROW,LAY ), 0.0 )
                  END DO
               END DO
            END DO
         ELSE IF ( QI_AVAIL ) THEN
            DO LAY = 1, NLAYS
               DO ROW = 1, NROWS
                  DO COL = 1, NCOLS
                     QC( COL,ROW,LAY ) = MAX( QC( COL,ROW,LAY ), 0.0 )
                     QR( COL,ROW,LAY ) = MAX( QR( COL,ROW,LAY ), 0.0 )
                     QI( COL,ROW,LAY ) = MAX( QI( COL,ROW,LAY ), 0.0 )
                     QS( COL,ROW,LAY ) = MAX( QS( COL,ROW,LAY ), 0.0 )
                  END DO
               END DO
            END DO
         ELSE
            DO LAY = 1, NLAYS
               DO ROW = 1, NROWS
                  DO COL = 1, NCOLS
                     QC( COL,ROW,LAY ) = MAX( QC( COL,ROW,LAY ), 0.0 )
                     QR( COL,ROW,LAY ) = MAX( QR( COL,ROW,LAY ), 0.0 )
                  END DO
               END DO
            END DO
         END IF

         DO ROW = 1, NROWS 
            DO COL = 1, NCOLS
               DELTA_Z( COL,ROW,1 ) = ZFULL( COL,ROW,1 )
               FORALL ( LAY = 2:NLAYS )
                  DELTA_Z( COL,ROW,LAY ) = ZFULL( COL,ROW,LAY ) - ZFULL( COL,ROW,LAY-1 )
               END FORALL
            END DO
         END DO

         IF ( CFRAC_3D_AVAIL ) THEN  ! read from file
            VARNM = 'CFRAC_3D'
            call interpolate_var (VARNM, mdate, mtime, CFRAC_3D)
 
         ELSE  ! diagnose CFRAC_3D from available data

            CALL CAL_CFRAC_3D()

         END IF

! compute averages for resolved cloud                

         DO ROW = 1, NROWS
            DO COL = 1, NCOLS
               SUM_WEIGHTS = 0.0
               CFRAC_2D( COL,ROW ) = 1.0
               AVE_HYDROMETEORS( COL,ROW ) = 0.0
               DO LAY = 1, NLAYS
                  IF ( CFRAC_3D( COL,ROW,LAY ) .LE. 0.0 ) CYCLE
                  WEIGHT = DELTA_Z( COL,ROW,LAY ) 
                  CFRAC_2D( COL,ROW ) = CFRAC_2D( COL,ROW )
     &                                * ( 1.0 - CFRAC_3D( COL,ROW,LAY ) )
                  SUM_WEIGHTS = SUM_WEIGHTS + WEIGHT

                  WATER = QC( COL,ROW,LAY ) + QR( COL,ROW,LAY ) + QI( COL,ROW,LAY )
     &                  + QS( COL,ROW,LAY ) + QG( COL,ROW,LAY )

                  AVE_HYDROMETEORS( COL,ROW ) = AVE_HYDROMETEORS( COL,ROW )
     &                                        + DENS( COL,ROW,LAY ) * WATER * WEIGHT
#ifdef phot_debug     
                  if ( cfrac_2d( col,row ) .ne. cfrac_2d( col,row ) .or.
     &                 sum_weights .ne. sum_weights ) then
                     write( logdev,"(a,2es12.4)" ) "WEIGHT, CFRAC_3D = ",
     &                                             weight, cfrac_3d( col,row,lay ) 
                     xmsg = 'Floating point exception for CFRAC_2D'
                     call m3exit ( pname, jdate, jtime, xmsg, xstat1 )
                  end if
#endif              
               END DO
               IF ( SUM_WEIGHTS .LT. 1.0 ) THEN 
                    CFRAC_2D( COL,ROW ) = 0.0
               ELSE
                    CFRAC_2D( COL,ROW ) = 1.0 - CFRAC_2D( COL,ROW )
                    AVE_HYDROMETEORS( COL,ROW ) = 1.0E+3 * AVE_HYDROMETEORS( COL,ROW ) / SUM_WEIGHTS
               END IF
            END DO
         END DO

         IF ( USE_ACM_CLOUD ) THEN ! compute averages for subgrid clouds                
            DO ROW = 1, NROWS
               DO COL = 1, NCOLS
                  SUM_WEIGHTS  = 0.0
!                 ACM_CLOUDS( COL,ROW )  = 0.0
                  ACM_AVE_H2O( COL,ROW ) = 0.0
                  DO LAY = 1, NLAYS
                     IF ( ACM_CFRAC( LAY,COL,ROW ) .LE. 0.0 ) CYCLE
                     WEIGHT      = DELTA_Z( COL,ROW,LAY ) 
                     SUM_WEIGHTS = SUM_WEIGHTS + WEIGHT
! acm clouds do not contain snow
                     WATER = ACM_QC( LAY,COL,ROW ) + ACM_QI( LAY,COL,ROW ) 
     &                     + ACM_QG( LAY,COL,ROW ) + ACM_QR( LAY,COL,ROW )  

! assume acm cloud is uniform or constant if it does not equal zero so set in  
! subroutine CAPTURE_ACM_CLOUD
!                    ACM_CLOUDS( COL,ROW ) = ACM_CLOUDS( COL,ROW )
!     &                                    + WEIGHT * ACM_CFRAC( LAY,COL,ROW ) 

                     ACM_AVE_H2O( COL,ROW ) = ACM_AVE_H2O( COL,ROW )
     &                                      + DENS( COL,ROW,LAY ) * WEIGHT * WATER
                  END DO
                  IF ( SUM_WEIGHTS .LT. 1.0 ) CYCLE
!                    ACM_CLOUDS( COL,ROW )  = ACM_CLOUDS( COL,ROW ) / SUM_WEIGHTS
                     ACM_AVE_H2O( COL,ROW ) = 1.0E+3 * ACM_AVE_H2O( COL,ROW ) / SUM_WEIGHTS
               END DO
            END DO
         END IF

         END SUBROUTINE GET_PHOT_MET

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE UPDATE_SUN( JDATE, JTIME, MDATE, MTIME )

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN         ! IO routines & utilties
         USE CENTRALIZED_IO_MODULE
  
         IMPLICIT NONE     
          
! Inputs:  
         INTEGER, INTENT( IN ) :: JDATE            ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN ) :: JTIME            ! current model time, coded HHMMSS
         INTEGER, INTENT( IN ) :: MDATE            ! date for calculation/interpolation(yyyyddd)
         INTEGER, INTENT( IN ) :: MTIME            ! time for calculation/interpolation (hhmmss)

! Local:
         INTEGER, SAVE         :: PDATE = 0        ! previous date called (yyyyddd)
         INTEGER, SAVE         :: PTIME = 0        ! previous time called (hhmmss)
         INTEGER               :: COL              ! column loop counter
         INTEGER               :: ROW              ! row loop counter

         REAL                  :: SINDEC           ! sine of the solar declination
         REAL                  :: COSDEC           ! cosine of the solar declination
         REAL                  :: JYEAR            ! year
         REAL                  :: JDAY             ! current Julian day (DDD)
         REAL                  :: EQUATION_OF_TIME ! equation of time
         REAL                  :: CURRHR           ! current GMT hour
         REAL                  :: CURRHR_LST       ! local standard time at each grid cell
        
         REAL, PARAMETER       :: ONE_OVER_15   = 1.0 / 15.0
         REAL, PARAMETER       :: ONE_OVER_3600 = 1.0 / 3600     

         IF ( FIRSTIME ) CALL INIT_PHOT_MET( JDATE, JTIME )

         IF ( PDATE .EQ. JDATE .AND. PTIME .EQ. JTIME ) RETURN
        
         PDATE = JDATE
         PTIME = JTIME
   
! Compute distance to sun and set solar declination variables

         JDAY   = FLOAT( MOD( JDATE, 1000 ) )
         JYEAR  = FLOAT( JDATE / 1000  )        

         CURRHR = STRTHR
     &          + FLOAT( SECSDIFF( STDATE, STTIME, MDATE, MTIME ) )
     &          * ONE_OVER_3600

         CALL SOLEFM3 ( JYEAR, JDAY, EQUATION_OF_TIME, SINDEC, COSDEC, DIST_TO_SUN )
        
         DO ROW = 1, NROWS
            DO COL = 1, NCOLS

!...correct  CURRHR for current *positive* West longitude convention
!...to obtain LST.
!...this convention on longititude should be reexamined for different domains

               CURRHR_LST = CURRHR + LON( COL,ROW ) * ONE_OVER_15

               CALL GETZEN2 ( CURRHR_LST , SINLATS( COL,ROW ), COSLATS( COL,ROW ),
     &                        SINDEC, COSDEC, EQUATION_OF_TIME, 
     &                        COSINE_ZENITH( COL,ROW ) )

#ifdef verbose_update_sun
               if ( row .eq. 1 .and. col .eq. 1 ) then
                  write(logdev,"(a,3es12.4)") "PHT: JYEAR, JDSTRT, SOLDIST = ",
     &                                        jyear, jday, dist_to_sun
                  write(logdev,"(a,7es12.4)") "PHT: CURRHR_LST, SINLAT, COSLAT, " //
     &                                        "SINDEC, COSDEC, EQT, COSZEN = ",
     &                                         currhr_lst , sinlats( col,row ),
     &                                         coslats( col,row ), sindec, cosdec,
     &                                         equation_of_time, cosine_zenith( col,row )
               end if
#endif            

            END DO
         END DO
               
         END SUBROUTINE UPDATE_SUN

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE SOLEFM3 ( YEAR, DAY, EQT, SINDEC, COSDEC, SOLDIST )

C-----------------------------------------------------------------------
C  This subroutine calculates the sine and cosine of the solar
C     declination and the equation of time, and solar distance
C     using an approximation to equations used to generate the
C     tables in  The Astronomical Almanac.
 
C  input:
C     year = year (e.g. 1998)
C     day  = day of the year (e.g. Feb. 2 is 33)
C     lat  = latitude in degrees (north is positive)
C     long = longitude in degrees (east is positive)
 
C  output:
C     EQT    = Equation of Time
C     sindec = sine of the solar declination
C     cosdec = cosine of the solar declination
C     soldist = distance of sun in astronomical units

C  Revision history:
C  FSB Coded September 9, 2004 by Dr. Francis S. Binkowski
C     Environmental Modeling for Policy Development group,
C     The Carolina Environmental Program
C     The University of North Carolina-Chapel Hill
C     Email: frank_binkowski@unc.edu
 
C  REFERENCE:The code is a modification of that  from
C     J.J. Michalsky, The Astronomical Almanac`s algorithm for
C     approximate solar position (1950-2050)
C     Solar Energy vol. 40, No. 3, pp 227-235, 1988.
C     who based it upon
C     The Astronomical Almanac, U.S. Gov`t. Printing Office,
C     Washington DC. Page c24 has the algorithm
 
C  The stated accuracy is 0.01 degree for the epoch ( 1950 - 2050).
C-----------------------------------------------------------------------

         USE CONST, ONLY: PI, PI180
         IMPLICIT NONE

!***arugments

         REAL, INTENT( IN )  :: YEAR, DAY
         REAL, INTENT( OUT ) :: EQT, SINDEC, COSDEC, SOLDIST

!***parameters

         REAL, PARAMETER :: TWOPI = 2.0 * PI
         REAL, PARAMETER :: RAD   = PI180
         REAL, PARAMETER :: RADM1 = 1.0 / RAD

!***FSB inline documentation defines the variables.

         REAL    :: DELTA, LEAP, JD, TIME, L, G, LAMDA, EPSILON
         REAL    :: ALPHA
         REAL    :: SING, SIN2G, COSG, COS2G
         REAL(8) :: NUM, DEN

!***start code
!***get current julian date, jd
!***  the offset year of 1949 is for convenience of having all
!***  positive numbers for the epoch (1950 - 2050)

         DELTA = YEAR - 1949.0
         LEAP  = AINT( DELTA / 4.0 )

!***jd = 32916.5 + 365.0 * delta + leap + hour / 24.0
!***set hour = 12.0 and 12.0 / 24.0 -> 0.5

         JD = 2432916.5 + 365.0 * DELTA + LEAP + DAY + 0.5

!***first number is jd for midnight 0 Jan 1949
!***  leap is leap days since 1949.

!***  calculate ecliptic conditions:

         TIME = JD - 2451545.0     ! 51545.0 is noon Jan 1, 2000

!***calculate mean solar longitude (L)

         L = 280.460 + 0.985674 * TIME ! mean solar longitude

!***now force L to be between 0.0 and 360. degrees

         L = MODULO( L, 360.0 )
         IF ( L .lt. 0.0 ) L = L + 360.0

!***calculate mean anomaly (g) in radians between 0 and twopi

         G = 357.528 + 0.9856003 * TIME
         G = MODULO( G, 360.0 )
         IF ( G .LT. 0.0 ) G = G + 360.0

         G = RAD * G    ! in radians now

!***calculate trig functions of g using identities
!***  this speeds up the calculations

         SING = SIN( G )
         COSG = COS( G )
         SIN2G = 2.0 * SING * COSG
         COS2G = COSG * COSG - SING * SING

!***calculate ecliptic longitude ( Lamda) and
!***  obliquity (epsilon) of ecliptic in radians

         LAMDA = L +  1.915 * SING  + 0.020 * SIN2G
         LAMDA = MODULO( LAMDA, 360.0 )
         IF ( LAMDA .LT. 0.0 ) LAMDA = LAMDA + 360.0

!***calculate obliquity (epsilon)

         EPSILON = 23.429 - 4.0E-7 * TIME
         LAMDA   = RAD * LAMDA    ! in radians
         EPSILON = RAD * EPSILON  ! in radians

!***now calculate right ascension (Alpha) Use this method to get the
!***  correct quadrant.

         NUM = REAL( COS( EPSILON ) * SIN( LAMDA ), 8 ) ! numerator
         DEN = REAL( COS( LAMDA ), 8 )                  ! denominator
         ALPHA = REAL( ATAN( NUM / DEN ), 4)

!***force right ascension to be between 0 and twopi

         IF ( DEN .LT. 0.0D0 ) THEN
            ALPHA = ALPHA + PI
         ELSE IF ( NUM .LT. 0.0D0 ) THEN
            ALPHA = ALPHA + TWOPI
         END IF

!***Alpha = atan2(num,den)
!***  Alpha = MOD(Alpha, 360.0)
!***  IF ( Alpha .lt. 0.0)  Alpha = Alpha + 360.0

         ALPHA = RADM1 * ALPHA     ! Alpha now in degrees

!***calculate the sine of the declination
!***  (sindec) cosine of the declination (cosdec)

         SINDEC = SIN( EPSILON ) * SIN( LAMDA )
         COSDEC = SQRT( 1.0 - SINDEC * SINDEC )

!***calculate the Equation of Time( EQT) in degrees.

         EQT = L - ALPHA
         IF ( EQT .GT. 350.0 ) EQT = EQT - 360.0 ! catch a problem

!***calculate solar distance

         SOLDIST = 1.00014 - 0.01671 * COSG - 0.00014 * COS2G

         RETURN
         END SUBROUTINE SOLEFM3

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE GETZEN2 ( TIME, SINLAT, COSLAT, SINDEC, COSDEC, EQT,
     &                        COSZEN )
C-----------------------------------------------------------------------
C  calculate the zenith angle information at the present time step
 
C  input:
C     time    = LST in decimal hours <<NOTE: LST
C     sinlat  = sine of the latitude
C     coslat  = cosine of the latitude
C     sindec  = sine of the solar declination
C     cosdec  = cosine of the solar declination
C     EQT     = equation of time in degrees
 
C  Output:
C     coszen  = cosine of the zenith angle
 
C  Revision history:
C     FSB Coded September 10, 2004 by Dr. Francis S. Binkowski
C     FSB modified February 15, 2005 to increase efficiency
C     Environmental Modeling for Policy Development group,
C     The Carolina Environmental Program
C     The University of North Carolina-Chapel Hill
C     Email: frank_binkowski@unc.edu
 
C  Note: because this routine will be called frequently
C     during a simulation, the sines and cosines of the
C     latitude should be calculated once at the beginning of
C     simulation.
C-----------------------------------------------------------------------

         USE CONST, ONLY: PI180
         IMPLICIT NONE

!***arguments

         REAL, INTENT( IN )  :: TIME, SINLAT, COSLAT
         REAL, INTENT( IN )  :: SINDEC, COSDEC, EQT
         REAL, INTENT( OUT ) :: COSZEN

!***internal variables

         REAL HANGLE          ! local hour angle in degrees

         REAL, PARAMETER :: RAD = PI180

         HANGLE = 15.0 * ( TIME - 12.0 )  + EQT
         COSZEN = SINDEC * SINLAT + COSLAT * COSDEC * COS( RAD * HANGLE )

!***do not allow zenith angle to be lower than 1 degree (COSZEN = 0.999998)
!***when COSZEN is 1.0, gas-phase chemistry solver does not work properly 
         COSZEN = MIN( COSZEN, 0.999998 )

         RETURN
         END SUBROUTINE GETZEN2        

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE CAL_CFRAC_3D ()

!---------------------------------------------------------------------
! DESCRIPTION:
! Compute cloud fraction from input ice and cloud water fields
! if provided.
!
! Whether QI or QC is active or not is determined from the indices of
! the fields into the 4D scalar arrays in WRF. These indices are 
! P_QI and P_QC, respectively, and they are passed in to the routine
! to enable testing to see if QI and QC represent active fields in
! the moisture 4D scalar array carried by WRF.
! 
! If a field is active its index will have a value greater than or
! equal to PARAM_FIRST_SCALAR, which is also an input argument to 
! this routine.
!
! References:
! 1) Randall, D. A. (1995), Parameterizing fractional cloudiness produced
!    by cumulus entrainment. Preprints, Workshop on Cloud Microphysics
!    Parameterizations in Global Atmospheric Circulation
!    Models, Kananaskis, AB, Canada, WMO, 1–16.
! 2) Xu, K. And D.A. Randall (1996), A semiempircal cloudiness 
!    parameterization for use in climate models, J. Atm. Sci., vol 53(21),
!    pp 3084-3102.
! 3) Hong et al. (1998). Implementation of Prognostic Cloud Scheme for a
!    Regional Spectral Model. Monhtly Weather Review, vol. 126, pp 2621-
!    2639.
! Routine copied from module_radiation_driver.F in WRF 3.5 and modified for
! CMAQ applications (Bill Hutzell), Revised somewhat by J. Young Nov,2014
!---------------------------------------------------------------------

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN         ! IO routines & utilties
         USE CENTRALIZED_IO_MODULE
         USE CONST, ONLY: STDTEMP, RDGAS, RWVAP

         IMPLICIT NONE

! arguments:

!  Local:
         INTEGER :: I, J, K   ! loop counters
          
         REAL    :: RHUM       ! relative humidty   (fraction)
         REAL    :: TC         ! temp               (degrees Celuis)
         REAL    :: ESW        ! water vapor liquid saturaturion vapor pressure (Pa)
         REAL    :: ESI        ! water vapor ice saturaturion vapor pressure (Pa)
         REAL    :: QVSW       ! water vapor saturation mixing ratio (Kg/Kg)
         REAL    :: QVSI       ! water ice saturation mixing ratio (Kg/Kg) 
         REAL    :: QVS_WEIGHT ! weighted average of liquid and ice mixing ratios
         REAL    :: DENOM      ! scratch variable
         REAL    :: ARG        ! scratch variable
         REAL    :: SUBSAT     ! scratch variable
         REAL, ALLOCATABLE, SAVE :: QCLD  ( :,:,: ) ! cloud water mixing ratio
         REAL, ALLOCATABLE, SAVE :: WEIGHT( :,:,: ) ! weighting factor between liquid and ice content
         REAL    :: WHT        ! intermediate weighting factor
         INTEGER :: ASTAT      ! memory allocation status
         LOGICAL, SAVE :: FRSTCALL = .TRUE.

! Parameters:
! Used for saturation mixing ratio weighted based on fractions of water and ice. 
! Following:
!   Murray, F.W. 1966. ``On the computation of Saturation Vapor Pressure,'
!   J. Appl. Meteor.,  6, p. 204.
! For saturation vapor pressure for each water phase
! es (in mb) = 6.1078exp[ a(T-273.16)/ (T-b) ], 1 mb = 100 Pa
!     over water   over ice  
! a = 17.2693882   21.8745584
! b = 35.86         7.66 
!        REAL, PARAMETER :: SVP1  =   0.61078
         REAL, PARAMETER :: SVP1  = 610.78      ! [ Pa ]
         REAL, PARAMETER :: SVP2  =  17.2693882
         REAL, PARAMETER :: SVP3  =  35.86
         REAL, PARAMETER :: SVPI2 =  21.8745584
         REAL, PARAMETER :: SVPI3 =   7.66
         REAL, PARAMETER :: SVPT0 = STDTEMP
         REAL, PARAMETER :: R_D   = RDGAS
         REAL, PARAMETER :: R_V   = RWVAP
         REAL, PARAMETER :: EP_2  = R_D / R_V
!-----------------------------------------------------------------------
!---  Parameters for GRID-SCALE CLOUD COVER FOR RADIATION
!     (modified by Ferrier, Feb '02)
!
!---  Cloud fraction parameterization follows Randall, 1994
!     (see Hong et al., 1998)
!-----------------------------------------------------------------------
         REAL, PARAMETER :: ALPHA0  = 1.0E+02
         REAL, PARAMETER :: GAMMA   = 0.49
         REAL, PARAMETER :: QCLDMIN = 1.0E-12
         REAL, PARAMETER :: PEXP    = 0.25
         REAL, PARAMETER :: RHGRID  = 1.0
   
         IF ( FRSTCALL ) THEN
            FRSTCALL = .FALSE.
            ALLOCATE ( QCLD  ( NCOLS,NROWS,NLAYS ),
     &                 WEIGHT( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating QCLD or WEIGHT'
               CALL M3EXIT ( 'CAL_CFRAC_3D', 0, 0, XMSG, XSTAT1 )
            END IF
         END IF

! Alternative calculation for critical RH for grid saturation
!     RHGRID = 0.90 + .08*((100.-DX)/95.)**.5
   
!---------------------------------------------------------------------

!--- Total "cloud" mixing ratio, QCLD.  Rain is not part of cloud,
!    only cloud water + cloud ice + snow
! Mixing ratios of rain are not considered in this scheme.

         CFRAC_3D = 0.0   ! array assignment
         
         IF ( QG_AVAIL ) THEN
            DO K = 1, NLAYS
               DO J = 1, NROWS
                  DO I = 1, NCOLS
                     QCLD(I,J,K) = QC(I,J,K) + QI(I,J,K) + QS(I,J,K) + QG(I,J,K)
                     IF ( QCLD(I,J,K) .GE. QCLDMIN ) THEN
                        WEIGHT(I,J,K) = ( QI(I,J,K) + QS(I,J,K) + QG(I,J,K) ) / QCLD(I,J,K)
                     ELSE
                        WEIGHT(I,J,K) = 0.0
                     END IF
                  END DO
               END DO
            END DO
         ELSE IF ( QI_AVAIL ) THEN
            DO K = 1, NLAYS
               DO J = 1, NROWS
                  DO I = 1, NCOLS
                     QCLD(I,J,K) = QC(I,J,K) + QI(I,J,K) + QS(I,J,K)
                     IF ( QCLD(I,J,K) .GE. QCLDMIN ) THEN
                        WEIGHT(I,J,K) = ( QI(I,J,K) + QS(I,J,K) ) / QCLD(I,J,K)
                     ELSE
                        WEIGHT(I,J,K) = 0.0
                     END IF
                  END DO
               END DO
            END DO
         ELSE IF ( QC_AVAIL ) THEN
            DO K = 1, NLAYS
               DO J = 1, NROWS
                  DO I = 1, NCOLS
                     QCLD(I,J,K) = QC(I,J,K)
                     IF ( QCLD(I,J,K) .GE. QCLDMIN ) THEN
                        IF ( TA(I,J,K) .GT. 273.15 ) WEIGHT(I,J,K) = 0.0
                        IF ( TA(I,J,K) .LE. 273.15 ) WEIGHT(I,J,K) = 1.0
                     ELSE
                        WEIGHT(I,J,K) = 0.0
                     END IF
                  END DO
               END DO
            END DO
         ELSE          
            RETURN
         END IF !  IF ( QG_AVAIL )

         DO K = 1, NLAYS
            DO J = 1, NROWS
               DO I = 1, NCOLS
!--- Determine cloud fraction (modified from original algorithm)
                  IF ( QCLD(I,J,K) .LT. QCLDMIN ) THEN
!--- Assume zero cloud fraction if there is no cloud mixing ratio
                     CFRAC_3D(I,J,K) = 0.0
                     CYCLE
                  END IF
                  
                  TC   = TA(I,J,K) - SVPT0
                  ESW  = SVP1 * EXP( SVP2  * TC / ( TA(I,J,K) - SVP3  ) )
                  ESI  = SVP1 * EXP( SVPI2 * TC / ( TA(I,J,K) - SVPI3 ) )
                  QVSW = EP_2 * ESW / ( PRES(I,J,K) - ESW )
                  QVSI = EP_2 * ESI / ( PRES(I,J,K) - ESI )
                  WHT  = WEIGHT(I,J,K)
!                 QVS_WEIGHT = ( 1.0 - WHT ) * QVSW + WHT * QVSI
                  QVS_WEIGHT = QVSW + WHT * ( QVSI - QVSW )
                  RHUM = QV(I,J,K) / QVS_WEIGHT   !--- Relative Humidity                  
                  
                  IF ( RHUM .GE. RHGRID ) THEN
!--- Assume cloud fraction of unity if near saturation and the cloud
!    mixing ratio is at or above the minimum threshold
                     CFRAC_3D(I,J,K) = 1.0
                     CYCLE
                  ELSE
!--- Adaptation of original algorithm (Randall, 1994; Zhao, 1995)
!    modified based on assumed grid-scale saturation at RH=RHgrid.
                     SUBSAT = MAX( 1.E-10, RHGRID * QVS_WEIGHT - QV(I,J,K) )
                     DENOM  = SUBSAT ** GAMMA
                     ARG    = MAX( -6.9, -ALPHA0 * QCLD(I,J,K) / DENOM )   ! <-- EXP(-6.9)=.001
                     CFRAC_3D(I,J,K) = ( RHUM / RHGRID ) ** PEXP * ( 1.0 - EXP( ARG ) )
                  END IF          !--- END IF (QCLD(I,J,K) .LT. QCLDMIN)

                  IF ( CFRAC_3D(I,J,K) .LT. 0.01 ) CFRAC_3D(I,J,K) = 0.0

                  IF ( CFRAC_3D(I,J,K) .NE. CFRAC_3D(I,J,K) .OR.
     &                 CFRAC_3D(I,J,K) .GT. 1.0 ) THEN 
                     WRITE( LOGDEV,'(/2X,A,3I6)' ) 'COL, ROW, LAY = ', I, J, K
                     WRITE( LOGDEV,'(/2X,A,4ES12.4)' )
     &                     'TA, PRES = ', TA(I,J,K), PRES(I,J,K)
                     WRITE( LOGDEV,'(/2X,A,4ES12.4)' )
     &                     'QV, QC, QI, QS = ', QV(I,J,K), QC(I,J,K), QI(I,J,K), QS(I,J,K)
                     WRITE( LOGDEV,'(/2X,A,4ES12.4)' )
     &                     'ESW, ESI, QVSW, QVSI = ', ESW, ESI, QVSW, QVSI
                     WRITE( LOGDEV,'(/2X,A,4ES12.4)' )
     &                     'WEIGH, QVS_WEIGH = ', WHT, QVS_WEIGHT 
                     WRITE( LOGDEV,'(/2X,A,4ES12.4)' )
     &                     'SUBSAT, RHUM, RHGRID, ARG = ', SUBSAT, RHUM, RHGRID, ARG
                     XMSG = 'Floating point exception for CFRAC_3D'
                     CALL M3EXIT ( 'CAL_CFRAC_3D', 0, 0, XMSG, XSTAT1 )
                  END IF

               END DO   ! i
            END DO   ! j
         END DO   ! k

         END SUBROUTINE CAL_CFRAC_3D

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE CAPTURE_ACM_CLOUD( JDATE, JTIME, COL, ROW, BOTTOM, TOP,
     &                                 FRACTION, WATER, ICE )

            USE CLOUD_OPTICS, ONLY : CLDMIN
         
            IMPLICIT NONE
! Purpose:
!   Save properties determined by ACM subgrid cloud at vertical column into
!   for radiation transfer calculations
!  REVISION  HISTORY:
!  12Jun15: BHutzell: comment out call to CLEAR_ACM_CLOUD because CONVCLD_ACM routine
!                     calls CLEAR_ACM_CLOUD at every synchronization time if acm 
!                     convection algorithm engaged, i.e., CONVCLD = .TRUE.
! Arguments:
            INTEGER, INTENT( IN )  :: JDATE      
            INTEGER, INTENT( IN )  :: JTIME                 
            INTEGER, INTENT( IN )  :: COL           ! array column index
            INTEGER, INTENT( IN )  :: ROW           ! array row index
            INTEGER, INTENT( IN )  :: TOP           ! vertical layer index
            INTEGER, INTENT( IN )  :: BOTTOM        ! vertical layer index
            REAL,    INTENT( IN )  :: FRACTION      ! cloud fraction of ACM cloud
            REAL,    INTENT( IN )  :: WATER( : )    ! liquid water droplet mixing ratio
            REAL,    INTENT( IN )  :: ICE( : )      ! ice partical mixing ratio

! Parameters:
!           None

! Local variables:
            INTEGER                :: LAY           ! loop index

            DO LAY = BOTTOM, TOP
               IF ( WATER( LAY ) + ICE( LAY ) .LT. CLDMIN ) CYCLE
               ACM_CFRAC( LAY,COL,ROW ) = FRACTION
               ACM_QC   ( LAY,COL,ROW ) = WATER( LAY )
               ACM_QI   ( LAY,COL,ROW ) =   ICE( LAY )
            END DO
                     
            DO LAY = 1, BOTTOM - 1
               IF ( WATER( LAY ) + ICE( LAY ) .LT. CLDMIN ) CYCLE
               ACM_CFRAC( LAY,COL,ROW ) = FRACTION
               ACM_QR   ( LAY,COL,ROW ) = WATER( LAY )
               ACM_QG   ( LAY,COL,ROW ) =   ICE( LAY )
            END DO

            ACM_CLOUDS( COL,ROW )  = FRACTION             
             
!           WRITE(LOGDEV,'(A,2(I3,1X),10(ES12.4,1X))')'COL,ROW,ACM_CFRAC = ',COL,ROW,
!     &     ACM_CFRAC( TOP,COL,ROW ), ACM_QC( TOP,COL,ROW ),ACM_QI( TOP,COL,ROW )            
            RETURN

         END SUBROUTINE CAPTURE_ACM_CLOUD

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE INIT_ACM_CLOUD( JDATE, JTIME )

            USE GRID_CONF           ! horizontal & vertical domain specifications
            USE UTILIO_DEFN         ! IO routines & utilties

!Arguments:
            INTEGER, INTENT( IN )  :: JDATE      
            INTEGER, INTENT( IN )  :: JTIME
! Local variables:             
            INTEGER                :: ASTAT     ! memory allocation status
             
            CHARACTER( 18 ), PARAMETER  :: PNAME = 'INIT_ACM_CLOUD'
                       
            WRITE( XMSG, '(3A)' ), 'ATTENTION: Attempt to include subgrid ',
     &             'cloud effects: photolysis rates include ACM CLOUD effects. ',
     &             'It would be prudent to examine diagnostic cloud fractions.'
            CALL LOG_MESSAGE( LOGDEV, XMSG)
            WRITE( LOGDEV, * )
             
            ALLOCATE ( ACM_CFRAC( NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_CFRAC'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_QC( NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_QC'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_QI( NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_QI'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_QR( NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_QR'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_QG( NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_QG'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_CLOUDS( NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_CLOUDS'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_AVE_H2O( NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_AVE_H2O'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
 
            ACM_CLOUDS  = 0.0
            ACM_CFRAC   = 0.0
            ACM_AVE_H2O = 0.0
            ACM_QC      = 0.0
            ACM_QI      = 0.0
            ACM_QR      = 0.0
            ACM_QG      = 0.0
             
            RETURN

         END SUBROUTINE INIT_ACM_CLOUD        

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE CLEAR_ACM_CLOUD( JDATE, JTIME )
          
            IMPLICIT NONE
! Purpose:
!          -Determine if acm cloud propeties have been set
!          -Zero out their array if not
! Arguments:
            INTEGER, INTENT( IN )  :: JDATE      
            INTEGER, INTENT( IN )  :: JTIME                 
! Local Variables: None

            IF ( SET_ACM_ARRAYS )THEN
               CALL INIT_ACM_CLOUD( JDATE, JTIME)
               SET_ACM_ARRAYS = .FALSE.
            END IF

            IF ( JDATE .NE. ACM_DATE .OR. JTIME .NE. ACM_TIME )THEN
               ACM_CFRAC   = 0.0   ! array assignment
               ACM_QC      = 0.0   !   "       "
               ACM_QI      = 0.0   !   "       "
               ACM_QR      = 0.0   !   "       "
               ACM_QG      = 0.0   !   "       "
               ACM_CLOUDS  = 0.0   !   "       "
               ACM_AVE_H2O = 0.0   !   "       "
               ACM_DATE    = JDATE
               ACM_TIME    = JTIME
            END IF

            RETURN

         END SUBROUTINE CLEAR_ACM_CLOUD
      END MODULE PHOT_MET_DATA

         
!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

        SUBROUTINE SA_DIM 

C KWOK: Determine dimensions of tagging array based on user-supplied sa_io_list
C KWOK: Created Oct 20, 2010
C
C20140428  Called by driver.F
C

        USE UTILIO_DEFN
        USE SA_DEFN
        USE DESID_VARS, ONLY: DESID_N_SRM

        IMPLICIT NONE

        CHARACTER( 16 ) :: PNAME = 'SA_DIM'

        INTEGER IOST

        INTEGER NTAGS

C----------------------------------------------

C...Count the number of tags specified by user
          CALL CNT_SA_IO_LIST( NTAGS )

C...Reading in the tag information
          ALLOCATE ( TAGNAME( NTAGS + 4 ), STAT = IOST )
          CALL CHECKMEM( IOST, 'TAGNAME', PNAME )
          TAGNAME = "NOT"

          ALLOCATE ( TAGSTREAMS_TEMP( NTAGS ), STAT = IOST )
          CALL CHECKMEM( IOST, 'TAGSTREAMS_TEMP', PNAME )
          TAGSTREAMS_TEMP = ''

          ALLOCATE ( TAGSTREAMS_NUM( NTAGS ) )
          TAGSTREAMS_NUM = 0

          ALLOCATE ( ISAMRGN_TEMP( NTAGS ), STAT = IOST )
          CALL CHECKMEM( IOST, 'ISAMRGN_TEMP', PNAME )

          ALLOCATE ( ISAMRGN_NUM( NTAGS ), STAT = IOST )
          CALL CHECKMEM( IOST, 'ISAMRGN_NUM', PNAME )
          ISAMRGN_NUM = 0

C...Process tag infromation from control file
          CALL RD_SA_IO_LIST( NTAGS )

C...Assign Tag Indices To ICON, BCON, OTHER *in that order*
          BCONTAG = NTAGS + 1
          OTHRTAG = BCONTAG + 1
          ICONTAG = OTHRTAG + 1
          NTAG_SA = ICONTAG

          TAGNAME( BCONTAG ) = "BCO"
          TAGNAME( OTHRTAG ) = "OTH"
          TAGNAME( ICONTAG ) = "ICO"

          CALL GET_NSPC_SA 

          N_SPCTAG = NSPC_SA * NTAG_SA

          CALL GET_MAP_SAtoCGR ()

          ! Allocate arrays of species indices, tagging indices, and
          ! variable names for the combined species-tags
          ! i.e. set s_spctag, t_spctag, and vnam_spctag
          ALLOCATE ( S_SPCTAG( N_SPCTAG ), STAT=IOST )
          CALL CHECKMEM( IOST, 'S_SPCTAG', PNAME )
          ALLOCATE ( T_SPCTAG( N_SPCTAG ), STAT=IOST )
          CALL CHECKMEM( IOST, 'T_SPCTAG', PNAME )
          ALLOCATE ( VNAM_SPCTAG( N_SPCTAG ), STAT=IOST )
          CALL CHECKMEM( IOST, 'VNAM_SPCTAG', PNAME )
          ALLOCATE ( BCON_SPC( N_SPCTAG ), STAT=IOST )
          CALL CHECKMEM( IOST, 'BCON_SPC', PNAME )

          ! Assign BCON tag indicies used in advection
          BCON_SPC = .FALSE.
          BCON_SPC( ((BCONTAG - 1)*NSPC_SA+1) : (NSPC_SA*BCONTAG) ) = .TRUE.

           
        END SUBROUTINE SA_DIM

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE GETFAMILY

C-----------------------------------------------------------------------
C Function: To process the DEFINE FAMILY command
 
C Preconditions: None
  
C Key Subroutines/Functions Called: GETCHR
C                                   GETWORD
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI's M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
 
      USE UTILIO_DEFN
      USE PA_VARS
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables:
      INTEGER MEMNUM    ! Counter for number of members in the family
      
C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Get the name of the Family and check for a trailing equal sign
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      NFAMLYS = NFAMLYS + 1
      MEMNUM = 0
      IF ( NFAMLYS .GT. MAXFAMLYS ) THEN
         WRITE( MSG, 94000 )
         CALL M3MESG( MSG )
         WRITE( MSG, 94020 ) MAXFAMLYS
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETFAMILY', IZERO, IZERO, ' ', XSTAT2 )
      END IF

      CALL GETWORD
      FAMNAME( NFAMLYS ) = WORD

      IF ( CHR .NE. '=' ) THEN
         WRITE( MSG, 94040 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETFAMILY', IZERO, IZERO,' ', XSTAT2 )
      ELSE
         CALL GETCHR
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Top of loop for getting the family member names and coefficients
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
20    CONTINUE
      MEMNUM = MEMNUM + 1

      IF ( MEMNUM .GT. MAXFAMMEM ) THEN
         WRITE( MSG, 94060 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94080 ) MAXFAMMEM
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETFAMILY', IZERO, IZERO, ' ', XSTAT2 )
      END IF

c..Set the coefficient for family member 
      CALL GETCOEF( FAMSC( NFAMLYS, MEMNUM ) ) 

c..Get the name of the family member
      CALL GETWORD
      FAMMEMNAM( NFAMLYS, MEMNUM ) = WORD
      NUMFAMMEM( NFAMLYS ) = MEMNUM 

c..Go back and get the next family member, return, or err off  
      IF ( CHR .EQ. '+' .OR. CHR .EQ. '-' ) THEN
         GO TO 20
      ELSE IF ( CHR .EQ. ';' ) THEN
         CALL GETCHR
         RETURN
      ELSE
         WRITE( MSG, 94100 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETFAMILY', IZERO, IZERO, ' ', XSTAT2 ) 
      END IF

C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( 'ERROR: Maximum number of FAMILY''s exceeded' )
94020 FORMAT( '       Modify PARAMETER ( MAXFAMLYS =', I3,' ) or',
     &              '  decrease the number of defined FAMILY''s' )     
94040 FORMAT( 'ERROR: Equal sign expected after FAMILY name' )
94060 FORMAT( 'ERROR: Maximum number of family members exceeded' )
94080 FORMAT( '       Modify PARAMETER ( MAXFAMMEM =',I3, ' ) or',
     &              '  decrease the number of members in the family' )
94100 FORMAT( 'ERROR: A +, -, or ; must follow a family member name' )
94500 FORMAT( '       Line No. ', I4, ':', A )
94520 FORMAT( '       Character found:', A )

      END SUBROUTINE GETFAMILY

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/PARIO/src/parutilio.f,v 1.2 2012/04/11 13:47:45 sjr Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C....................................................................
C  CONTAINS:  Interface for PAR I/O procedures
C
C  REVISION HISTORY:
C       Original version 02/11 by Shawn Roselle
C       Modified 12/09/2015 by David Wong
C          -- Added an optional argument in PIO_RE_INIT routine
C       Modified 01/26/2016 by Jeff Young
C          -- Change WFLG to an optional argument, eliminate PIO_RE_INIT, and make
C          PIO_INIT the only routine with a new optional IO_PE_INCLUSIVE argument;
C          replace WRSUBMAP with the new WRSUBDMAP
C       Modified 02/01/2019 by David Wong
C          removed unnecessary function declaration
C....................................................................

      MODULE PARUTILIO

         IMPLICIT NONE

C...Declare PWRITE3 outside the interface block:  with check interface
C...  option, compilers complained about type mismatches for buffer 
C...  array passed to function PWRITE3 (when included in interface).

         LOGICAL, EXTERNAL :: PWRITE3

C...Interface

         INTERFACE

!           SUBROUTINE BOUNDARY ( GNBNDY, NBNDY, NLAYS, BTHICK, NEIGHBOR,
!    &                            MY_COL1, MY_ROW1, NCOL, NROW,
!    &                            GNCOLS, GNROWS, GARRAY, LARRAY )
!              INTEGER :: NLAYS
!              INTEGER :: NBNDY
!              INTEGER :: GNBNDY
!              INTEGER :: BTHICK
!              INTEGER :: NEIGHBOR(8)
!              INTEGER :: MY_COL1
!              INTEGER :: MY_ROW1
!              INTEGER :: NCOL
!              INTEGER :: NROW
!              INTEGER :: GNCOLS
!              INTEGER :: GNROWS
!              REAL    :: GARRAY( GNBNDY,NLAYS )
!              REAL    :: LARRAY( NBNDY,NLAYS )
!           END SUBROUTINE BOUNDARY

            SUBROUTINE GET_WRITE_MAP ( NP, NPC, NPR, NCOLS3D, NROWS3D, NLAYS3D )
               INTEGER :: NP
               INTEGER :: NPC
               INTEGER :: NPR
               INTEGER :: NCOLS3D
               INTEGER :: NROWS3D
               INTEGER :: NLAYS3D
            END SUBROUTINE GET_WRITE_MAP

!           LOGICAL FUNCTION GROWBUF( PTR_ARRAY, END )
!              USE PINTERPB_MODULE
!              TYPE (MEM_TYPE) :: PTR_ARRAY
!              INTEGER, INTENT(IN) :: END
!           END FUNCTION GROWBUF

            LOGICAL FUNCTION GTNDXHDV( FILE, VAR, JDATE, JTIME, VARSIZE, NBVS,
     &                                 ENDBUF, VX, NEWVAR )
               CHARACTER(16) :: FILE
               CHARACTER(16) :: VAR
               INTEGER :: JDATE
               INTEGER :: JTIME
               INTEGER :: VARSIZE
               INTEGER :: NBVS
               INTEGER :: ENDBUF
               INTEGER :: VX
               LOGICAL :: NEWVAR
            END FUNCTION GTNDXHDV

            LOGICAL FUNCTION INTERPOL( DATE, TIME, DATE1, TIME1, DATE2, TIME2,
     &                                 NUMVALS, VALSIN1, VALSIN2, VALSOUT, S_IND, E_IND )
               INTEGER, INTENT(IN) :: NUMVALS
               INTEGER, INTENT(IN) :: DATE
               INTEGER, INTENT(IN) :: TIME
               INTEGER, INTENT(IN) :: DATE1
               INTEGER, INTENT(IN) :: TIME1
               INTEGER, INTENT(IN) :: DATE2
               INTEGER, INTENT(IN) :: TIME2
               REAL, INTENT(IN)    :: VALSIN1( NUMVALS )
               REAL, INTENT(IN)    :: VALSIN2( NUMVALS )
               REAL, INTENT(OUT)   :: VALSOUT( NUMVALS )
               INTEGER, INTENT(IN), OPTIONAL :: S_IND, E_IND
            END FUNCTION INTERPOL

!           LOGICAL FUNCTION PINTERPB( FILNAME, VARNAME, CALLER, JDATE, JTIME,
!    &                                  VSIZE, VARRAY, LVL )
!              INTEGER, INTENT(IN)       :: VSIZE
!              CHARACTER(16), INTENT(IN) :: FILNAME
!              CHARACTER(*), INTENT(IN)  :: VARNAME
!              CHARACTER(*), INTENT(IN)  :: CALLER
!              INTEGER, INTENT(IN)       :: JDATE
!              INTEGER, INTENT(IN)       :: JTIME
!              REAL, INTENT(OUT)         :: VARRAY( VSIZE )
!              INTEGER, INTENT(IN), OPTIONAL :: LVL
!           END FUNCTION PINTERPB

            LOGICAL FUNCTION PIO_INIT( colrow, gl_ncols, gl_nrows, nlays,
     &                                 nthik, ncols, nrows, npcol, nprow,
     &                                 nprocs, mype, wflg, io_pe_inclusive )
               CHARACTER(2), INTENT(INOUT) :: colrow
               INTEGER, INTENT(IN) :: gl_ncols
               INTEGER, INTENT(IN) :: gl_nrows
               INTEGER, INTENT(IN) :: nlays
               INTEGER, INTENT(IN) :: nthik
               INTEGER, INTENT(IN) :: ncols
               INTEGER, INTENT(IN) :: nrows
               INTEGER, INTENT(IN) :: npcol
               INTEGER, INTENT(IN) :: nprow
               INTEGER, INTENT(IN) :: nprocs
               INTEGER, INTENT(IN) :: mype
               LOGICAL, INTENT(IN), OPTIONAL :: wflg
               LOGICAL, INTENT(IN), OPTIONAL :: io_pe_inclusive
            END FUNCTION PIO_INIT
C Note: more than one optional argument requires that the caller calls by name

            SUBROUTINE PM3ERR ( CALLER, JDATE, JTIME, ERRTXT, FATAL )
               CHARACTER(*) :: CALLER
               INTEGER      :: JDATE
               INTEGER      :: JTIME
               CHARACTER(*) :: ERRTXT
               LOGICAL      :: FATAL
            END SUBROUTINE PM3ERR

            SUBROUTINE PM3EXIT ( CALLER, JDATE, JTIME, MSGTXT, EXITSTAT )
               CHARACTER(*) :: CALLER
               INTEGER      :: JDATE
               INTEGER      :: JTIME
               CHARACTER(*) :: MSGTXT
               INTEGER      :: EXITSTAT
            END SUBROUTINE PM3EXIT

            SUBROUTINE PM3WARN ( CALLER, JDATE, JTIME, ERRTXT )
               CHARACTER(*) :: CALLER
               INTEGER      :: JDATE
               INTEGER      :: JTIME
               CHARACTER(*) :: ERRTXT
            END SUBROUTINE PM3WARN

            LOGICAL FUNCTION PSHUT3 ()
            END FUNCTION PSHUT3

            LOGICAL FUNCTION PTRWRITE3( FNAME, VNAME, JDATE, JTIME, BUFFER )
               CHARACTER(*)  :: FNAME
               CHARACTER(*)  :: VNAME
               INTEGER       :: JDATE
               INTEGER       :: JTIME
               REAL, POINTER :: BUFFER( :,:,:,: )
            END FUNCTION PTRWRITE3

            LOGICAL FUNCTION PWRGRDD( FILNAME, VARNAME, DATE, TIME, BUFFER,
     &                                NCOLS3D, NROWS3D, NLAYS3D, NCOLS, NROWS,
     &                                NP )
               INTEGER      :: NROWS
               INTEGER      :: NCOLS
               INTEGER      :: NLAYS3D
               CHARACTER(*) :: FILNAME
               CHARACTER(*) :: VARNAME
               INTEGER      :: DATE
               INTEGER      :: TIME
               REAL         :: BUFFER( NCOLS,NROWS,NLAYS3D )
               INTEGER      :: NCOLS3D
               INTEGER      :: NROWS3D
               INTEGER      :: NP
            END FUNCTION PWRGRDD

            LOGICAL FUNCTION READBNDY( FILNAME, VARNAME, VX, NBNDY, NLAYS,
     &                                 DATE, TIME, RFLAG, FLIP )
               CHARACTER(16) :: FILNAME
               CHARACTER(16) :: VARNAME
               INTEGER :: VX
               INTEGER :: NBNDY
               INTEGER :: NLAYS
               INTEGER :: DATE(2)
               INTEGER :: TIME(2)
               INTEGER :: RFLAG
               INTEGER :: FLIP
            END FUNCTION READBNDY

            SUBROUTINE SUBDMAP ( NUMPROCS, NCOLS, NROWS, NLAYS, NPCOL, NPROW,
     &                           NCOLS_PE, NROWS_PE, COLSX_PE, ROWSX_PE,
     &                           MAXCELLS, IERR )
               INTEGER :: NUMPROCS
               INTEGER :: NCOLS
               INTEGER :: NROWS
               INTEGER :: NLAYS
               INTEGER :: NPCOL
               INTEGER :: NPROW
               INTEGER :: NCOLS_PE( NUMPROCS )
               INTEGER :: NROWS_PE( NUMPROCS )
               INTEGER :: COLSX_PE( 2,NUMPROCS )
               INTEGER :: ROWSX_PE( 2,NUMPROCS )
               INTEGER :: MAXCELLS
               INTEGER :: IERR
            END SUBROUTINE SUBDMAP

            SUBROUTINE WRSUBDMAP ( NUMPROCS, NCOLS_PE, NROWS_PE, COLSX_PE,
     &                             ROWSX_PE )
               INTEGER :: NUMPROCS
               INTEGER :: NCOLS_PE(*)
               INTEGER :: NROWS_PE(*)
               INTEGER :: COLSX_PE(2,*)
               INTEGER :: ROWSX_PE(2,*)
            END SUBROUTINE WRSUBDMAP

         END INTERFACE

      END MODULE PARUTILIO

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WR_AVG_SA ( JDATE, JTIME, TSTEP )

C Writes hourly averaged ISAM conc to SA_ACONC_1
C
C          Called by driver.F
C
C     01 Nov 2018: S.Napelenok Updates for cmaq5.3 release 
C     09 May 2019: D.Wong Removed all MY_ clauses

C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
      USE SA_DEFN
      USE RUNTIME_VARS
      USE MIO_ASCII

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif


      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! file name parameters

      INTEGER      JDATE        ! current model date, coded YYYYDDD
      INTEGER      JTIME        ! current model time, coded HHMMSS
      INTEGER      TSTEP        ! output timestep (HHMMSS)

C Local variables:

      REAL, ALLOCATABLE :: BUF4( :,:,:,: )
      INTEGER      MDATE        ! modified model date, coded YYYYDDD
      INTEGER      MTIME        ! modified model time, coded HHMMSS

      CHARACTER( 16 ) :: PNAME = 'WR_AVG_SA'
      CHARACTER( 16 ) :: ACONC_END_TIME = 'ACONC_END_TIME'
      CHARACTER( 80 ) :: VARDESC = ' '
      CHARACTER( 96 ) :: XMSG = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL OK

      INTEGER      L, K, KD, VAR, SPC ! loop counters
      INTEGER      STATUS

      INTEGER, SAVE :: A_NLYS

      INTEGER TSTEP_RF, NTHIK_RF, NCOLS_RF, NROWS_RF, GDTYP_RF
      REAL( 8 ) :: P_ALP_RF, P_BET_RF, P_GAM_RF
      REAL( 8 ) :: XCENT_RF, YCENT_RF
      REAL( 8 ) :: XORIG_RF, YORIG_RF
      REAL( 8 ) :: XCELL_RF, YCELL_RF
      INTEGER VGTYP_RF
      REAL VGTOP_RF
C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.
         MDATE = JDATE; MTIME = JTIME
         IF ( END_TIME ) THEN 
            CALL NEXTIME ( MDATE, MTIME, TSTEP )
         END IF

C Try to open existing file for update

         IF ( AISAM_ELEV .EQ. -1 ) AISAM_ELEV = NLAYS

         A_NLYS = AISAM_ELEV - AISAM_BLEV + 1

         OK = OPEN3( SA_ACONC_1, FSRDWR3, PNAME )
         CALL SUBST_GLOBAL_LOGICAL( OK, 'AND' )
         IF ( .NOT. OK ) THEN

            XMSG = 'Could not open ' // TRIM( SA_ACONC_1 )
     &           // ' file for update - try to open new'
            CALL M3MESG( XMSG )

            IF ( MYPE .EQ. 0 ) THEN

C Get default file header attibutes from CONC file (assumes file already open)

               IF ( .NOT. DESC3( SA_CONC_1 ) ) THEN
                  XMSG = 'Could not get '
     &                 // TRIM( SA_CONC_1 )
     &                 // ' file description'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

C Set file header attributes that differ from CONC and open the file

               SDATE3D = MDATE
               STIME3D = MTIME
               TSTEP3D = TSTEP
               NLAYS3D = A_NLYS

               L = 0
               DO K = AISAM_BLEV, AISAM_ELEV
                  L = L + 1
                  VGLVS3D( L ) = VGLVS_GD( K )
               END DO
               GDNAM3D = GRID_NAME  ! from HGRD_DEFN

               FDESC3D( 1 ) = 'Src Apportionment file output '
               FDESC3D( 2 ) = 
     &                'Averaged over the synchronization time steps '
               FDESC3D( 3 ) = 
     &              'Timestamp represents beginning computed date/time '
               FDESC3D( 4 ) = 'Layer mapping (ISAM to AISAM):'
               KD = 4
               VAR = AISAM_BLEV
               L = 0
               DO K = KD + 1, MIN ( A_NLYS + KD, MXDESC3 )
                  L = L + 1
                  WRITE( FDESC3D( K ),'( "Layer", I3, " to", I3, " " )' )
     &            VAR + L - 1, L
               END DO
               IF ( ( KD + 1 + L ) .LT. MXDESC3 ) THEN
                  DO K = KD + 1 + L, MXDESC3
                     FDESC3D( K ) = ' '
                  END DO
               END IF

               WRITE( LOGDEV,* ) ' '
               WRITE( LOGDEV,* ) 
     &                  '      Avg ISAM File Header Description:'
               DO K = 1, KD + L
                  WRITE( LOGDEV,* ) '    => ',
     &            TRIM( FDESC3D( K ) )
               END DO

               ! Store MIO Metadata
               NDIMS3D( 1:NVARS3D ) = 4
               L_TSTEP( 1:NVARS3D ) = .True.
               L_LAY  ( 1:NVARS3D ) = .True.
               L_COL  ( 1:NVARS3D ) = .True.
               L_ROW  ( 1:NVARS3D ) = .True.
               L_VEXT ( 1:NVARS3D ) = .False.
              
               CALL LOAD_MIO_FILE ( 'SA_ACONC_1', A_NLYS, AISAM_BLEV, AISAM_ELEV,
     &              VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &              VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &              L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &              L_VEXT(1:NVARS3D) )

 
               IF ( .NOT. OPEN3( SA_ACONC_1, FSNEW3, PNAME ) ) THEN
                  XMSG = 'Could not open '
     &                 // TRIM( SA_ACONC_1 ) // ' file'
                  CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               END IF

            END IF   ! MYPE = 0

         ELSE

C File exists. Make sure it matches requested output.

            IF ( .NOT. DESC3( SA_CONC_1 ) ) THEN
               XMSG = 'Could not get '
     &              // TRIM( SA_CONC_1 )
     &              // ' file description'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            TSTEP_RF = TSTEP3D
            NTHIK_RF = NTHIK3D
            NCOLS_RF = NCOLS3D
            NROWS_RF = NROWS3D
            GDTYP_RF = GDTYP3D
            P_ALP_RF = P_ALP3D
            P_BET_RF = P_BET3D
            P_GAM_RF = P_GAM3D
            XCENT_RF = XCENT3D
            YCENT_RF = YCENT3D
            XORIG_RF = XORIG3D
            YORIG_RF = YORIG3D
            XCELL_RF = XCELL3D
            YCELL_RF = YCELL3D
            VGTYP_RF = VGTYP3D
            VGTOP_RF = VGTOP3D

            IF ( .NOT. DESC3( SA_ACONC_1 ) ) THEN
               XMSG = 'Could not get '
     &              // TRIM( SA_ACONC_1 )
     &              // ' file description'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            IF ( N_SPCTAG .NE. NVARS3D ) THEN
               WRITE( XMSG, '( A, 2I6 )' )
     &         'Number of variables don''t match file: ', N_SPCTAG, NVARS3D
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            DO SPC = 1, N_SPCTAG
               DO VAR = 1, NVARS3D
                  IF ( VNAM_SPCTAG( SPC ) .EQ. VNAME3D( VAR ) ) GO TO 101
               END DO
               XMSG = 'Could not find ' // VNAM_SPCTAG( SPC )
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
101            CONTINUE
            END DO

            IF ( A_NLYS .NE. NLAYS3D ) THEN
               WRITE( XMSG, '( A, 2I6 )' )
     &         'Number of layers don''t match file: ', A_NLYS, NLAYS3D
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

C Check other header data with CONC file as reference

            IF ( TSTEP_RF .NE. TSTEP3D .OR.
     &           NTHIK_RF .NE. NTHIK3D .OR.
     &           NCOLS_RF .NE. NCOLS3D .OR.
     &           NROWS_RF .NE. NROWS3D .OR.
     &           GDTYP_RF .NE. GDTYP3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_ACONC_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( P_ALP_RF .NE. P_ALP3D .OR.
     &           P_BET_RF .NE. P_BET3D .OR.
     &           P_GAM_RF .NE. P_GAM3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_ACONC_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XCENT_RF .NE. XCENT3D .OR.
     &           YCENT_RF .NE. YCENT3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_ACONC_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XORIG_RF .NE. XORIG3D .OR.
     &           YORIG_RF .NE. YORIG3D ) THEN
               XMSG = 'Header inconsistent on existing SA_ACONC_1'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XCELL_RF .NE. XCELL3D .OR.
     &           YCELL_RF .NE. YCELL3D ) THEN
               XMSG = 'Header inconsistent on existing SA_ACONC_1'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( VGTYP_RF .NE. VGTYP3D ) THEN
               XMSG = 'Header inconsistent on existing SA_ACONC_1'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( VGTOP_RF .NE. VGTOP3D ) THEN
               XMSG = 'Header inconsistent on existing SA_ACONC_1'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

         END IF   ! .NOT. OPEN SA_ACONC_1

         RETURN    ! Initialization of MIO File

      END IF   ! FIRSTIME
    
      MDATE = JDATE; MTIME = JTIME
      IF ( .NOT. END_TIME ) THEN
         CALL NEXTIME( MDATE, MTIME, -TSTEP)
      END IF
      IF ( .NOT. ALLOCATED( BUF4 ) ) ALLOCATE( BUF4( NCOLS, NROWS, A_NLYS, N_SPCTAG ) )

    
      DO SPC = 1, N_SPCTAG
         L = 0
         DO K = AISAM_BLEV, AISAM_ELEV
          L = L + 1
          BUF4( :,:,L,SPC ) = AISAM( :,:,L, S_SPCTAG(SPC), T_SPCTAG(SPC) )
         ENDDO !
         IF ( .NOT. WRITE3( SA_ACONC_1, VNAM_SPCTAG( SPC ),
     &      MDATE, MTIME, BUF4( :,:,:,SPC ) ) ) THEN
            XMSG = 'Could not write '
     &           // VNAM_SPCTAG( SPC )
     &           // ' to ' // SA_ACONC_1
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
!     write( logdev,* ) ' <>var, A_GC_SPC: ', VAR, A_GC_SPC( SPC )
      END DO
 
      WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &      'Timestep written to', SA_ACONC_1,
     &      'for date and time', MDATE, MTIME

      IF ( ALLOCATED( BUF4 ) ) DEALLOCATE( BUF4 )

      RETURN 
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_DATAGEN( )
 
C----------------------------------------------------------------------
C Function: Create the Process Analysis control data
 
C Preconditions: None
 
C Key Subroutines/Functions Called:
 
C  Revision History:
C  27 Jul 16 J.Young: inline PA ctl program
C----------------------------------------------------------------------

      USE RUNTIME_VARS
      USE UTILIO_DEFN
      USE PA_VARS, Only: NFAMLYS, NRXSUMS, NCYCLES, NIRROUT
      USE PA_DEFN            ! Process Anaylsis control and data variables
      USE PAGRD_DEFN, ONLY : PAGRD_INIT

      IMPLICIT NONE 

C..Includes: None
C..Arguments: None
C..Parameters: None
C..External Functions: None
C..Local Variables: None
      CHARACTER(  16 ) :: PNAME      = 'PA_DATAGEN'
      
      CHARACTER( 240 ) :: XMSG = ' '

      INTEGER          :: JDATE, JTIME
      INTEGER          :: ESTAT         ! status from environment var check
        
C----------------------------------------------------------------------

!...Get flag to use process analysis
      WRITE( LOGDEV, * )
      CALL LOG_HEADING( LOGDEV, 'INITIALIZE PROCESS ANALYSIS' )


      JDATE = 0; JTIME = 0
      IF ( PROCAN ) THEN
         XMSG = TRIM( PNAME ) // ': Process Analysis is activated'
         CALL M3MESG( XMSG )
      ELSE
         XMSG = TRIM( PNAME ) // ': Process Analysis is not activated'
         CALL M3MESG( XMSG )
         RETURN
      END IF
        
      CALL PA_READ
      CALL PA_ERRCHECK
      CALL PA_SETUP_IPR
      CALL PA_SETUP_IRR
      CALL PA_COMPMECH
!     CALL PA_WRTPADEFN
      IF ( MYPE .EQ. 0 ) CALL PA_REPORT
      CALL M3MESG( 'End of initial Process Analysis Control data generation' )
      CALL M3MESG( ' ' )

      NFAMLYS = 0
      NRXSUMS = 0
      NCYCLES = 0
      NIRROUT = 0
 
! Set up horizontal domain and calculate processor-to-subdomain maps for
! process analysis, if required
      IF ( LIPR .OR. LIRR ) THEN
         IF ( .NOT. PAGRD_INIT( MYPE ) ) THEN
            XMSG = '*** Failure defining PA domain configuration'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF
 
      RETURN
      END SUBROUTINE PA_DATAGEN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module NH3_Bidi_Mod

! Contains the shared variables and subroutines needed for the bidirectional 
! NH3 flux model in CMAQ
!
! INIT_NH3_BiDi - Initializes the NH3 flux routines, allocates arrays, reads in
!                 initial soil NH3 & H concentrations, and fertilizer application
!                 amounts and timing for the model run
! 
! Revision History: J. Bash Dec 08 10:      Created
!                   J. Bash May 11 11:      Updated for CMAQ 5.0
!                   J.Young Oct 26 11:      KIND=16->KIND=8 for Portland Group compiler (pgi)
!                                           IsNaN function   "    "        "      "
!                                           (This Module must be compiled w/ -Kieee if pgi)
!                   J. Bash Jan 31 12:      New daily EPIC output now includes soil NH3 from 
!                                           mineralization of organic and no longer includes 
!                                           the monthly fertilizer totals. The initialization 
!                                           of soil NH3 was rewritten to reflect this.
!                   J. Bash Apr 19 12:      Set bounds on the soil moisture from the met. model
!                                           to be between saturation and residual soil moisture
!                                           to avoid errors in the soil resistance from rounding
!                                           errors. Corrected a units conversion error in the 
!                                           coupling of the soil NH4 to the atmospheric NH3.
!                                           This will maintain a better mass balance and have
!                                           a small impact on the model results ~ 1% of the
!                                           ambient NH3 concentrations.
!                   J. Bash Apr 19 12:      The apoplast compensation point for agricultural land use 
!                                           is now a function of the soil ammonium concentration 
!                                           following Massad et al. 2010 doi:10.5194/acp-10-10359-2010
!                   J. Bash Aug 29 12:      The subroutine was modified to utilize new EPIC output that 
!                                           estimates the ammonium content of fertilizer applied to the 
!                                           1cm and 5cm soil layers. 
!                   D. Schwede Sept 12 12:  Added code for NLCD40 land use classification
!                   J. Bash    Apr   4 13:  Brought in new water, agriculture and snow land use 
!                                           classification in LSM_MOD to simplify the case structures
C                   J. Bash:   Nov   7 14:  Modified for the restructuring of vidff.
!                   D. Wong:   Feb  10 19:  Implemented centralized I/O approach, removed all MY_N clauses
C-------------------------------------------------------------------------------
      Use, intrinsic :: ieee_arithmetic, only: isnan => ieee_is_nan

      Implicit None
! shared variables
      Real, Save, Allocatable :: frac_ir( :,: ) ! irrigated fraction of ag 
! Private variables used in this module and subroutines     
      Real, Save,              Private :: C_gam           ! Canadian fertilizer factor   
      Real, Parameter,         Private :: maxgam   = 2.0e5 ! maximum soil gamma. It is assumed that any excess NH4 is from salts

! variables for STAGE bidi NH3
      Real, Save, Allocatable, Private :: frac_ag( :,: ) ! fraction of ag    
      Real, Save, Allocatable, Private :: knit1  ( :,: ) ! EPIC Grid nitrification rate
      Real, Save, Allocatable, Private :: knit2  ( :,: ) ! EPIC Grid nitrification rate
      Real, Save, Allocatable, Private :: NH4_G1 ( :,: ) ! EPIC Grid soil ammonium
      Real, Save, Allocatable, Private :: NH4_G2 ( :,: ) ! EPIC Grid soil ammonium
      Real, Save, Allocatable, Private :: BDs1   ( :,: ) ! mean ag soil bulk density kg/ha
      Real, Save, Allocatable, Private :: BDs2   ( :,: ) ! mean ag soil bulk density kg/ha
      Real, Save,              Private :: wg             ! Soil moisture for biogeochemical calcs
      Real, Save,              Private :: zsoil          ! Soil depth for biogeochemical calcs
     
      Contains 

!------------------------------------------------------------------------------
! STAGE option NH3 bidi initialization
!------------------------------------------------------------------------------

         Subroutine Init_NH3_Bidi( jdate, jtime)
 
         Use HGRD_DEFN           ! horizontal grid specifications
         Use UTILIO_DEFN         
         Use Bidi_Mod, Only: gamma1, gamma2, MHp1, MHp2
         Use ASX_DATA_MOD, Only: zsoil1, zsoil2, Grid_Data
         Use LSM_MOD
         Use depv_data_module
         Use centralized_io_module
!         Use CONST

         Implicit None 
! Includes
         Include SUBST_FILES_ID  ! file name parameters

! Local Variables

         Integer, Intent( In )  :: jdate
         Integer, Intent( In )  :: jtime   
         Integer                :: c,r,l,k
         Integer            :: ALLOCSTAT
         Real,    Parameter :: convl1 = 7.142857e-04   ! ha/m**2 * mol/g N * 1/z_soil_l1 
         Real,    Parameter :: convl2 = 7.142857e-05   ! ha/m**2 * mol/g N * 1/z_soil_l2 
         Real               :: pHfac1
         Real               :: pHfac2
! STAGE bidi variables
         Real,       Allocatable :: L1_MIN     ( :,:,: ) ! Epic Layer 1 organic N mineralization
         Real,       Allocatable :: L2_MIN     ( :,:,: ) ! Epic Layer 2 organic N mineralization 
         Real,       Allocatable :: C_knit1    ( :,:,: ) ! EPIC Crop nitrification rate
         Real,       Allocatable :: C_knit2    ( :,:,: ) ! EPIC Crop nitrification rate
         Real,       Allocatable :: fagam1     ( :,: )   ! delta gamma due to fertilizer app and mineralization
         Real,       Allocatable :: fagam2     ( :,: )   ! delta gamma due to fertilizer app and mineralization           
 
         Character( 16 ), Parameter :: pname = 'Init_NH3_Bidi' 
         Character( 96 )            :: xmsg = ' '

! Find the Canadian fertilizer factor based off of Sheppard et al 2010 Canadian J. Soil Sci. & 
! Zhang et al. 2010 JGR 
         Select Case( jdate )
            Case(  60:90 )
               C_gam = 811.5
            Case(  91:120 )
               C_gam = 3447.3
            Case( 121:151 )
               C_gam = 8702.8
            Case( 152:181 )
               C_gam = 1269.3
            Case( 182:212 )
               C_gam = 667.1
            Case( 213:243 )
               C_gam = 704.2
            Case( 244:273 )
               C_gam = 811.5
            Case( 274:304 )
               C_gam = 1376.7
            Case( 305:334 )
               C_gam = 1079.6
            Case Default
               C_gam = 630.0
         End Select           
                  
         Allocate( L1_MIN     ( ncols,nrows,e2c_cats ),
     &             L2_MIN     ( ncols,nrows,e2c_cats ),    
     &             C_Knit1    ( ncols,nrows,e2c_cats ),
     &             C_Knit2    ( ncols,nrows,e2c_cats ),
     &             STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating EPIC vars'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If
         L1_MIN  = 0.0
         L2_MIN  = 0.0
         C_Knit1 = 0.0
         C_Knit2 = 0.0

         Beld_ag = 0.01 * Beld_ag   ! convert to fraction

! Allocate variable needed soil processes and fertilization
         Allocate( fagam1     ( ncols,nrows ),
     &             fagam2     ( ncols,nrows ), 
     &             MHp1       ( ncols,nrows ),
     &             MHp2       ( ncols,nrows ),
     &             BDs1       ( ncols,nrows ),
     &             BDs2       ( ncols,nrows ),
     &             Knit1      ( ncols,nrows ),
     &             Knit2      ( ncols,nrows ),
     &             NH4_G1     ( ncols,nrows ),
     &             NH4_G2     ( ncols,nrows ),
     &             frac_ir    ( ncols,nrows ), 
     &             frac_ag    ( ncols,nrows ), 
     &              STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating soil vars'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If

         fagam1  = 0.0
         fagam2  = 0.0
         MHp1    = 0.0
         MHp2    = 0.0
         BDs1    = 0.0
         BDs2    = 0.0
         Knit1   = 0.0
         Knit2   = 0.0
         NH4_G1  = 0.0
         NH4_G2  = 0.0
         frac_ir = 0.0
         frac_ag = 0.0    

! EPIC v1.4 does not always correctly write out m3badval in areas where there is no data. In these cases, 
! EPIC writes out large negative values which can cause issues with the bidirectional exchange numerics. 
! The following variables should always be positive and a floor of 0.0 is now set to mitigate numerical issues. 
         Where( isnan( Nit1   ) ) Nit1   = 0.0
         Where( isnan( Nit2   ) ) Nit2   = 0.0
         Where( isnan( F1_NH4 ) ) F1_NH4 = 0.0
         Where( isnan( F2_NH4 ) ) F2_NH4 = 0.0
         Where( isnan( NH4ps1 ) ) NH4ps1 = 0.0
         Where( isnan( NH4ps2 ) ) NH4ps2 = 0.0
         Where( isnan( pHs1   ) ) pHs1   = 0.0
         Where( isnan( pHs2   ) ) pHs2   = 0.0
         Where( Nit1   .Lt. 0.0 ) Nit1   = 0.0
         Where( Nit2   .Lt. 0.0 ) Nit2   = 0.0
         Where( F1_NH4 .Lt. 0.0 ) F1_NH4 = 0.0
         Where( F2_NH4 .Lt. 0.0 ) F2_NH4 = 0.0
         Where( NH4ps1 .Lt. 0.0 ) NH4ps1 = 0.0
         Where( NH4ps2 .Lt. 0.0 ) NH4ps2 = 0.0

! get fertilizer from the previous month to estimate soil NH4+        
! time in the files is not the same
         If ( .Not. MEDC_AVAIL ) Then
            Write(Logdev,*) 'Estimating soil NHx from EPIC output'
            gamma1  = 0.0
            gamma2  = 0.0

            If ( .Not. E2C_CHEM_AVAIL ) Then
               xmsg = E2C_CHEM // ' file not available'
               Call M3exit ( pname, jdate, jtime, xmsg, xstat1 )
            End If

            If( GMN_AVAIL ) Then
! NH4 from organic N mineralization is not layer specific in Fest-C v1.4 therefore it is allocated proportionally
! to the organic N from which it was mineralized.
               Where( GMN .Gt. 0.0 .And. L1_ON .Gt. 0.0 )
                  L1_MIN = GMN * L1_ON / ( L1_ON + L2_ON )
               End Where
               Where( GMN .Gt. 0.0 .And. L2_ON .Gt. 0.0 )
                  L2_MIN = GMN * L2_ON / ( L1_ON + L2_ON )
               End Where

            End iF
! EPIC data as simulated in FEST-C 1.3 is for the end of the day. Here we 
! want to get the values at the beginning of the day.
! EPIC ammonia evasion is estimated as 5% of nitrification. We add the 
! evaded ammonia and nitrification back to the soil NH3 to account for losses.
            F1_NH4 = Nit1 / 0.95 + L1_MIN
            F2_NH4 = Nit2 / 0.95 + L2_MIN
! Calculate grid cell values from the EPIC crop specific data            
            frac_ag  = sum(Beld_ag,DIM=3)
            Do l = 1, e2c_cats
               Where( pHs1(:,:,l) .Gt. 4.0 .And. pHs1(:,:,l) .Lt. 9.0 .And. Beld_ag(:,:,l) .Gt. 0.0 )
                  MHp1   = MHp1   + Beld_ag(:,:,l) * 10.0 ** (-pHs1(:,:,l) )
                  MHp2   = MHp2   + Beld_ag(:,:,l) * 10.0 ** (-pHs2(:,:,l) )
                  BDs1   = BDs1   + Beld_ag(:,:,l) * BDc1(:,:,l)
                  BDs2   = BDs2   + Beld_ag(:,:,l) * BDc2(:,:,l)
                  Knit1  = Knit1  + Beld_ag(:,:,l) * Nit1(:,:,l)
                  Knit2  = Knit2  + Beld_ag(:,:,l) * Nit2(:,:,l)
                  NH4_G1 = NH4_G1 + Beld_ag(:,:,l) * NH4ps1(:,:,l)
                  NH4_G2 = NH4_G2 + Beld_ag(:,:,l) * NH4ps2(:,:,l)
                  gamma1 = gamma1 + convl1 * NH4ps1(:,:,l) / 10.0 ** (-pHs1(:,:,l) ) * Beld_ag(:,:,l)
                  gamma2 = gamma2 + convl2 * NH4ps2(:,:,l) / 10.0 ** (-pHs2(:,:,l) ) * Beld_ag(:,:,l)
                  fagam1 = fagam1 + convl1 * F1_NH4(:,:,l) / 10.0 ** (-pHs1(:,:,l) ) * Beld_ag(:,:,l)
                  fagam2 = fagam2 + convl2 * F2_NH4(:,:,l) / 10.0 ** (-pHs2(:,:,l) ) * Beld_ag(:,:,l)
               End Where
               If ( Index( Beld_Names( l ), '_ir' ) .Gt. 0 ) Then
                  frac_ir = frac_ir + Beld_ag( :,:,l )
               End If                    
            End Do
            Where( frac_ag .gt. 0.0 )
               MHp1 = MHp1 / frac_ag
               MHp2 = MHp2 / frac_ag
               gamma1 = max(( gamma1 + fagam1 ) / frac_ag, 630.0 )
               gamma2 = max(( gamma2 + fagam2 ) / frac_ag, 630.0 )
               BDs1   = BDs1 / frac_ag
               BDs2   = BDs2 / frac_ag
               frac_ir = frac_ir / frac_ag
            End Where
! Eliminate unrealistically low bulk density 
            Where( BDs1 .Lt. 1.0 ) BDs1 = 1.6
            Where( BDs2 .Lt. 1.0 ) BDs2 = 1.6
! prevent missmatched data between soil and daily files
            Where( MHp1 .Eq. 0.0 .Or. MHp2 .Eq. 0.0 )
               gamma1 = 0.0
               gamma2 = 0.0  
            End Where

            Where( NH4_G1 .Gt. 0.0 )
               Knit1 = min(-log(NH4_G1 / (NH4_G1 + Knit1)),-log(0.5))
            Elsewhere
               Knit1 = 0.0
            End Where
            Where( NH4_G2 .Gt. 0.0 )
               Knit2 = min(-log(NH4_G2 / (NH4_G2 + Knit2)),-log(0.5))
            Elsewhere
               Knit2 = 0.0
            End Where

         Else ! read

            If( GMN_AVAIL ) Then
! NH4 from organic N mineralization is not layer specific in Fest-C v1.4 therefore it is allocated proportionally
! to the organic N from which it was mineralized.
               Where( GMN .Gt. 0.0 .And. L1_ON .Gt. 0.0 .And. L2_ON .Gt. 0.0 )
                  L1_MIN = GMN * L1_ON / ( L1_ON + L2_ON )
                  L2_MIN = GMN * L2_ON / ( L1_ON + L2_ON )
               End Where

            Else
! The organic soil change from the previous day is equal to the fertilization - mineralization 
! Here we read in the previous days concentration to calculate the mineralization and add it to the NH4 pool.
! In EPIC run for CMAQ organic N mineralized goes to the NH4 pool and if mineralization is negative it is 
! taken from the soil NO3 pool. A cap was placed on the maximum mineralization based on the 0.999 percentile 
! from multiple years of EPIC simulations. 
               L1_MIN = L1_ON_Yest - L1_ON - F1_ON
               L2_MIN = L2_ON_Yest - L2_ON - F2_ON
               Where( L1_MIN .Lt. 0.0 )
                  L1_MIN = 0.0
               Else Where( L1_MIN .Gt. 0.3 )
                  L1_MIN = 0.3
               End Where
               Where( L2_MIN .Lt. 0.0 )
                  L2_MIN = 0.0
               Else Where( L2_MIN .Gt. 0.3 )
                  L2_MIN = 0.3
               End Where
            End If
            F1_NH4  = F1_NH4 + L1_MIN
            F2_NH4  = F2_NH4 + L2_MIN
! Calculate grid cell values from the EPIC crop specific data            
            frac_ag  = sum(Beld_ag,DIM=3)
            Do l = 1, e2c_cats
               Where( pHs1(:,:,l) .Gt. 4.0 .And. pHs1(:,:,l) .Lt. 9.0 .And. Beld_ag(:,:,l) .Gt. 0.0 )
                  MHp1   = MHp1   + Beld_ag(:,:,l) * 10.0 ** (-pHs1(:,:,l) )
                  MHp2   = MHp2   + Beld_ag(:,:,l) * 10.0 ** (-pHs2(:,:,l) )
                  BDs1   = BDs1   + Beld_ag(:,:,l) * BDc1(:,:,l)
                  BDs2   = BDs2   + Beld_ag(:,:,l) * BDc2(:,:,l)
                  Knit1  = Knit1  + Beld_ag(:,:,l) * Nit1(:,:,l)
                  Knit2  = Knit2  + Beld_ag(:,:,l) * Nit2(:,:,l)
                  NH4_G1 = NH4_G1 + Beld_ag(:,:,l) * NH4ps1(:,:,l)
                  NH4_G2 = NH4_G2 + Beld_ag(:,:,l) * NH4ps2(:,:,l)
                  fagam1 = fagam1 + convl1 * F1_NH4(:,:,l) / 10.0 ** (-pHs1(:,:,l) ) * Beld_ag(:,:,l)
                  fagam2 = fagam2 + convl2 * F2_NH4(:,:,l) / 10.0 ** (-pHs2(:,:,l) ) * Beld_ag(:,:,l)
               End Where
               If ( Index( Beld_Names( l ), '_ir' ) .Gt. 0 ) Then
                  frac_ir = frac_ir + Beld_ag( :,:,l )
               End If                    
            End Do

            Where( frac_ag .gt. 0.0 )
               MHp1 = MHp1 / frac_ag
               MHp2 = MHp2 / frac_ag
               gamma1 = max( gamma1 + fagam1 / frac_ag, 630.0 )
               gamma2 = max( gamma2 + fagam2 / frac_ag, 630.0 )
               BDs1   = BDs1 / frac_ag
               BDs2   = BDs2 / frac_ag
               frac_ir = frac_ir / frac_ag
            End Where

! Eliminate unrealistically low bulk density 
            Where( BDs1 .Lt. 1.0 ) BDs1 = 1.6
            Where( BDs2 .Lt. 1.0 ) BDs2 = 1.6
! prevent mismatched data between soil and daily files
            Where( MHp1 .Eq. 0.0 .Or. MHp2 .Eq. 0.0 )
               gamma1 = 0.0
               gamma2 = 0.0  
            End Where

            Where( NH4_G1 .Gt. 0.0 )
               Knit1 = min(-log(NH4_G1 / (NH4_G1 + Knit1)),-log(0.5))
            Elsewhere
               Knit1 = 0.0
            End Where
            Where( NH4_G2 .Gt. 0.0 )
               Knit2 = min(-log(NH4_G2 / (NH4_G2 + Knit2)),-log(0.5))
            Elsewhere
               Knit2 = 0.0
            End Where

         End If ! MEDC_AVAIL
         
         Return
         
         End Subroutine Init_NH3_Bidi
                  
!------------------------------------------------------------------------------
! Subroutine to get the soil and canopy compensation point for STAGE
!------------------------------------------------------------------------------          
         Subroutine Get_NH3_Comp( NH3_st, NH3_ll, NH3_g, diff, r, c, l, l_ag )
         
         Use UTILIO_DEFN
         Use Bidi_Mod, Only: gamma1, gamma2, MHp1, MHp2
         Use ASX_DATA_MOD
         Use LSM_MOD
         Use MOSAIC_MOD, Only: Tile_Data 
         
         Implicit None
         
         Include SUBST_FILES_ID  ! file name parameters

         Integer, Intent( IN )  :: r, c, l  ! Row, Column, Land use indices
         Integer, Intent( IN )  :: l_ag     ! Ag index  
         Real,    Intent( IN )  :: diff     ! NH3 diffusion in air m2/s
         Real,    Intent( OUT ) :: NH3_st   ! Stomatal Compensation point
         Real,    Intent( OUT ) :: NH3_ll   ! Leaf litter/under canopy Compensation point
         Real,    Intent( OUT ) :: NH3_g    ! Soil Compensation point
         
         Real                   :: cnh3g1, cnh3g2   ! NH3 compensation concentration for ground [ppm]
         Real                   :: cnh3ll1      ! NH3 compensation concentration for ground [ppm]
         Real                   :: mNH4         ! Soil total NH4+ mg N / Kg
         Real                   :: Ka           ! NH4 acid dissociation constant
         Real                   :: coef_a       ! intermediate variable to solve for soil solution NHx
         Real                   :: coef_b       ! intermediate variable to solve for soil solution NHx
         Real                   :: coef_c       ! intermediate variable to solve for soil solution NHx
         Real                   :: NH4_sol      ! NH4+ in soil water solution mg N / kg
         Real                   :: NH3_sol      ! NH3 in soil water solution mg N / kg
         Real                   :: NH3_gam_ll   ! Under canopy leaf litter molar emission potential [NH3]/[H+]
         Real                   :: frac_sol     ! Fraction of NHx in solution
         Real                   :: ldry1
         Real                   :: ldry2
         Real                   :: ldry_max
         Real( 8 )              :: dp
         Real( 8 )              :: rsoil1
         Real( 8 )              :: rsoil2
         Real( 8 )              :: a1
         Real,        Parameter :: twothree = 2.0/3.0
         Real,        Parameter :: onethree = 1.0/3.0
         Real,        Parameter :: MolN     = 14.007  ! g/mol N      
         Real                   :: wg_ir        ! 1 cm soil moisture  
         Real                   :: w5cm, cg         ! soil moisture in top 5 cm (vol frc)

         Integer                :: j
! Point were soil solution NH4 equals half the maximum sorption capacity Alnosour 2020  Bi-directional exchange of
!  ammonia from soils in row crop agro-ecosystems. Dissertation. North Carolina State University 
!  http://www.lib.ncsu.edu/resolver/1840.20/37245
         Real, Parameter        :: half_sol = 124.0 ! update from NC State Alnosour Thesis
! Maximum NH4 soil sorption capacity 
         Real, Parameter        :: max_sorp = 426.0 ! update from NC State Alnosour Thesis 
         Real, Parameter        :: NH3_gam_soil = 20.0 ! bare soil water solution emission potetnial [NH3]/[H+]
 
         If( PX_LSM ) Then
! simplified from Darcy's law assuming stationarity and only gravitational draining with the Campbell hydrological functions applied
! 0.4 is the difference in the layer depths of 1cm and 5 cm
            w5cm = MET_DATA%SOIM1( c,r ) * exp( 0.04 * GRAV )**(1.0/GRID_DATA%BSLP( c,r ))
            w5cm = Min( w5cm, GRID_DATA%WSAT( c,r ) )
            w5cm = Max( w5cm, GRID_DATA%WRES( c,r ) )
         Else If( CLM_LSM .OR. NOAH_LSM ) Then
            w5cm = MET_DATA%SOIM2( c,r )
            w5cm = Min( w5cm, GRID_DATA%WSAT( c,r ) )
            w5cm = Max( w5cm, GRID_DATA%WRES( c,r ) )
         End If

! Updated based on EPIC 5cm soil moisture estimates where the 25% percentile of the irrigated crop fractional soil moisture was 
! approximately equal approximately equal to 60% of the field capacity.  
         If ( frac_ir( c,r ) .Gt. 0.0 .And. MET_DATA%SOIM2( c,r ) .LE.  0.60 * GRID_DATA%WFC( c,r ) ) Then            
            wg_ir = ( 1.0 - frac_ir( c,r ) ) * MET_DATA%SOIM1( c,r ) + frac_ir( c,r ) * 0.60 * GRID_DATA%WFC( c,r )
            w5cm  = ( 1.0 - frac_ir( c,r ) ) * w5cm + frac_ir( c,r ) * 0.60 * GRID_DATA%WFC( c,r )
         Else
            wg_ir = MET_DATA%SOIM1( c,r )
         End If
 
         wg_ir = Min( wg_ir,GRID_DATA%WSAT( c,r ) )
         wg_ir = Max( wg_ir,GRID_DATA%WRES( c,r ) )

! The following resistance parameterization is derived from measurements with soil samples of 2 cm thick (Kondo et al 1990)
! https://doi.org/10.1175/1520-0450(1990)029<0385:APOEFB>2.0.CO;2 as discussed in Sakaguchi and Zeng 2009 JGR 
! https://doi.org/10.1029/2008JD010834 According to Swenson and Lawrence 2014 (https://doi.org/10.1002/2014JD022314) and the 
! references therin the dry layer thickness varies from 1 to 3 cm. 
         ldry_max = 0.02
! From Sakaguchi and Zeng 2009 JGR Equation 10
         ldry1 = ldry_max * ( Exp( ( 1.0 - wg_ir / GRID_DATA%WSAT( c,r ) ) ** 5 ) - 1.0 ) / 1.718

!> Compute compensation point. gamma is specified according to the amount of 
!> cultivated vegetation               
         a1     = 161512.0d0 / real( MET_DATA%SoiT1( c,r ), 8 )
     &          * 10.0d0 ** ( -4507.11d0 / real( MET_DATA%SoiT1( c,r ), 8 ) )
         a1     = a1 * 24.5d0 * 1.0d6  ! ppm
         NH3_st       = a1 * Tile_Data%NH3_gam_st( l )
         NH3_gam_ll = Tile_Data%NH3_gam_grnd( l ) 
         
!> Set a maximum [NH4]/[H+] ratio at 200,000 based on output from the AIM aerosol
!> model any [NH4] in excess of this ratio is assumed to partition into the solid
!> phase. Canada soil gamma taken from Zhang et al 2010 JGR Table 5
         cnh3ll1 = 0.0
         If( l .Eq. l_ag ) Then
! Use the soil ammonium sorption model of Venteria et al. Sci. Rep. doi:10.1038/srep12153 to estimate the NHx 
! available for volatilization 
           If( gamma1( c,r ) .eq. 0.0 ) Then 
               cg = wg_ir/1.6 ! L water / kg soil
               mNH4    = C_gam*1.0e-7/1.6*MolN*1.0e3 ! assume a bulk density of 1.6 kg/l untill Canadian data is available
               Ka      = 5.68853e-10*exp(-6248.151*(1.0/MET_DATA%SoiT1( c,r )-1.0/298.15))
               coef_a  = cg * (1.0+Ka/1.0e-7) ! assume a pH of 7
               coef_b  = max_sorp+cg * half_sol * (1.0+Ka/1.0e-7) - mNH4
               coef_c  = -half_sol * mNH4
               NH4_sol = (-coef_b+sqrt(coef_b**2.0-4.0*coef_a*coef_c))/(2.0*coef_a)
               NH3_sol = NH4_sol*Ka/1.0e-7 ! mg N/l
               cnh3g1  = (NH4_sol+NH3_sol)*1.0e-3/MolN/1.0e-7
               cnh3ll1 = cnh3g1
            Else
               cg = wg_ir/BDs1( c,r ) ! L water / kg soil
               mNH4 = gamma1( c,r )*MHp1( c,r )/BDs1( c,r )*MolN*1.0e3
               Ka      = 5.68853e-10*exp(-6248.151*(1.0/MET_DATA%SoiT1( c,r )-1.0/298.15))
               coef_a  = cg*(1.0+Ka/MHp1( c,r ))
               coef_b  = max_sorp+cg*half_sol*(1.0+Ka/MHp1(c,r)) - mNH4
               coef_c  = -half_sol*mNH4
               NH4_sol = (-coef_b+sqrt(coef_b**2.0-4.0*coef_a*coef_c))/(2.0*coef_a)
               NH3_sol = NH4_sol*Ka/MHp1( c,r ) ! mg N/l
               cnh3g1  = (NH4_sol+NH3_sol)*1.0e-3/MolN/MHp1( c,r )
               cnh3ll1 = cnh3g1
            End If
            If( gamma2( c,r ) .eq. 0.0 ) Then 
               cg = w5cm/1.6 ! L water / kg soil
               mNH4    = C_gam*1.0e-7/1.6*MolN*1.0e3 ! assume a bulk density of 1.6 kg/l untill Canadian data is available
               Ka      = 5.68853e-10*exp(-6248.151*(1.0/MET_DATA%SoiT1( c,r )-1.0/298.15))
               coef_a  = cg*(1.0+Ka/1.0e-7)
               coef_b  = max_sorp+cg*half_sol*(1.0+Ka/1.0e-7) - mNH4
               coef_c  = -half_sol*mNH4
               NH4_sol = (-coef_b+sqrt(coef_b**2.0-4.0*coef_a*coef_c))/(2.0*coef_a)
               NH3_sol = NH4_sol*Ka/1.0e-7 ! mg N/l
               cnh3g2  = (NH4_sol+NH3_sol)*1.0e-3/MolN/1.0e-7!/wg_ir
               NH3_st   = Max( NH3_st, Real( a1 ) *( C_gam * 1.0e-7
     &                  * w5cm * MolN * zsoil2 * 1.0e4 * 12.3 + 20.3 ) )
             Else 
               cg = w5cm/BDs2( c,r ) ! L water / kg soil
               mNH4 = gamma2( c,r )*MHp2( c,r )/BDs2( c,r )*MolN*1.0e3
               Ka      = 5.68853e-10*exp(-6248.151*(1.0/MET_DATA%SoiT1( c,r )-1.0/298.15))
               coef_a  = cg*(1.0+Ka/MHp2( c,r ))
               coef_b  = max_sorp+cg*half_sol*(1.0+Ka/MHp2(c,r)) - mNH4
               coef_c  = -half_sol*mNH4
               NH4_sol = (-coef_b+sqrt(coef_b**2.0-4.0*coef_a*coef_c))/(2.0*coef_a)
               NH3_sol = NH4_sol*Ka/MHp2( c,r ) ! mg N/l
               cnh3g2  = (NH4_sol+NH3_sol)*1.0e-3/MolN/MHp2( c,r )
               NH3_st   = Max( NH3_st, Real( a1 ) * ( gamma2(c,r) * 1.0e-7
     &                  * w5cm * MolN * zsoil2 * 1.0e4 * 12.3 + 20.3 ) )
            End If
         Else 
            cnh3ll1 = Min( NH3_gam_ll / wg_ir, maxgam )
            cnh3g1  = Min( NH3_gam_soil / wg_ir, maxgam )
            cnh3g2  = Min( NH3_gam_soil / w5cm, maxgam ) ! if the leaf litter is too dry use the soil value
         End If
         cnh3ll1 = a1 * Max( cnh3ll1, 0.01 )
         cnh3g1  = a1 * Max( cnh3g1, 0.01 )
         cnh3g2  = a1 * Max( cnh3g2, 0.01 )

         If( ldry1 .Le. zsoil1 ) Then
            NH3_g  = cnh3g1
            NH3_ll = cnh3ll1
            wg     = wg_ir
            zsoil  = zsoil1
         Else
            NH3_g  = cnh3g2
            NH3_ll = cnh3g2
            wg     = w5cm
            zsoil  = zsoil2
         End If
         Return         
         End Subroutine Get_NH3_Comp
!------------------------------------------------------------------------------
! Subroutine to update the soil ammonia and pH due to evasion, deposition, 
! nitrification, leaching, and run off
! Soil ammonium, pH, leaching, and run off are defined in the module
!------------------------------------------------------------------------------
         Subroutine Calc_Nitrif ( dt, C, R, l_ag, flux_ag )
         
         Use UTILIO_DEFN
         Use ASX_DATA_MOD
         Use Bidi_Mod, Only: gamma1, gamma2, MHp1, MHp2
         Use LSM_MOD
         Use MOSAIC_MOD, Only: Tile_Data 
         
         Implicit None                
         
         Real,      Intent( IN )    :: dt     ! time step in s
         Integer,   Intent( IN )    :: C      ! Column
         Integer,   Intent( IN )    :: R      ! Row
         Integer,   Intent( IN )    :: L_ag   ! LU Agricuture index
         Real,      Intent( IN )    :: flux_ag ! ag emissions ppm*m/s

         Real    :: Kn     ! nitrification rate 1/s
         Real    :: Knit   ! EPIC combined nitrification rate
         Real    :: kn_max ! EPIC maximum nitrification rate
         Real    :: Kvs    ! Air-soil exchange rate for aqueous NH4+
         Real    :: MNHx   ! molar soil water NH4+ + NH3 conc.
         Real    :: pHsl   ! Soil pH
         Real    :: T_Soil ! Soil T
         Real    :: NH3_flux  ! mol/l/s emissions are positive
         Real    :: MHp       ! molar H concentration
         Real    :: gam       ! updated land use specific gamma
         Real    :: MV_air    ! Molar volume of air L/mol

         CHARACTER( 96 )            :: xmsg = ' '
         Character( 16 ), Parameter :: pname = 'Calc_Nitrif' 

! get the correct soil temp
         If(zsoil .Eq. zsoil1 ) Then
            T_Soil = MET_DATA%SoiT1( C,R )
            gam    = max( gamma1( C,R ), 630.0 )
            MHp    = MHp1( C,R )  
            Knit   = Knit1( C,R )
            gamma2( C,R ) = gamma2( C,R ) * exp( -Knit2( c,r ) * dt )
         Else
            T_Soil = MET_DATA%SoiT2( C,R )
            gam    = max( gamma2( C,R ), 630.0 )
            MHp    = MHp2( C,R ) 
            Knit   = Knit2( C,R ) 
            gamma1( C,R ) = gamma1( C,R ) * exp( -Knit1( c,r ) * dt ) 
         End If

! if MHp = 0.0 then there is no EPIC data for the grid cell or is not agricultural
         If( MHp .Eq. 0.0 .Or. frac_ag( C,R ) .Lt. 1.0e-3 ) Return
! Note that the kg to g and m3 to L units cancel 
         MV_air       = MWAIR / MET_DATA%DENS1( C,R )
! convert deposition from ppmv m/s to mol/l/s
         NH3_flux     = flux_ag * 1.0e-6 / MV_air / zsoil
! Get the soil pH
         pHsl = -log10( MHp )

! get NH4+ from gamma ([NH4+]/[H+] with units in mol/l)
         MNHx = gam * MHp
! Estimate the soil evasion rate assuming that the flux = MNHx*(1-exp(-kvs*dt)) where dt = 1 s and the flux is negative for deposition to the
! soil and positive for evasion from the soil. 
         If( NH3_flux .lt. 0.0 ) Then
            Kvs    = 0.0
! In epic the nitrification and evasion rates are added in a combined nitrification/evasion rate. 
! Then the emissions are assumed to be 5% of the total combined loss. Here we calcuate the nitrification/evasion rate as in EPIC and then the
! maximum rate is adjusted for the EPIC evasion because we will calculate the evasion seperately and add the rate to 
! EPIC nitrification. 
! EPIC estimates a combined evasion and nitrification rate with a maximum user specified rate. Here we subtract the CMAQ evasion rate from the 
! EPIC nitrification rate to ensure that the maximum rate is retained. 
            Kn     =  Knit/24.0/3600.0    
            If ( Frac_ag( c,r ) .Gt. 0.0 ) Then 
               If ( Kn .Gt. 0.0 ) Then
                  MNHx = -NH3_flux / Kn + ( MNHx + NH3_flux / Kn ) * exp( -Kn * dt )
               End If
               gam = MNHx / MHp 
            Else
               gam = Tile_Data%NH3_gam_grnd( L_Ag )
            End If
          Else ! evasion
            Kvs    = -log(1.0-NH3_flux/MNHx)
! In epic the nitrification and evasion rates are added in a combined nitrification/evasion rate. 
! Then the emissions are assumed to be 5% of the total combined loss. Here we calcuate the nitrification/evasion rate as in EPIC and then the
! maximum rate is adjusted for the EPIC evasion because we will calculate the evasion seperately and add the rate to 
! EPIC nitrification. 
            Kn     = Knit/24.0/3600.0 + Kvs 
            If ( Frac_ag( c,r ) .Gt. 0.0 ) Then 
               If ( Kn .Gt. 0.0 ) Then
                  MNHx = MNHx * exp( -Kn * dt )
               End If
               gam = MNHx / MHp 
            Else
               gam = Tile_Data%NH3_gam_grnd( L_Ag )
            End If
          End If
! Update soil concentrations
         If(zsoil .Eq. zsoil1 ) Then
            gamma1( C,R ) = gam 
         Else
            gamma2( C,R ) = gam
         End If

         If ( isnan( gam ) ) Then
            xmsg = 'NaN in Gamma Calculation'
            Write( logdev,* ) 'MNHx   :', MNHx
            Write( logdev,* ) 'gam    :', gam
            Write( logdev,* ) 'MHp    :', MHp
            Write( logdev,* ) 'wg     :', wg
            Write( logdev,* ) 'wres   :', GRID_DATA%WRES( c,r )
            Write( logdev,* ) 'wsat   :', GRID_DATA%WSAT( c,r )
            Write( logdev,* ) 'wfc    :', GRID_DATA%WFC( c,r )
            Write( logdev,* ) 'wwlt   :', GRID_DATA%WWLT( c,r )
            Write( logdev,* ) 'kvs    :', kvs
            Write( logdev,* ) 'kn     :', kn
            Write( logdev,* ) 'zsoil  :', zsoil
            Write( logdev,* ) 'frac_ag:', frac_ag( c,r )
            Call M3exit( pname, 0, 0, xmsg, xstat1)
         End If

         Return
         End Subroutine Calc_Nitrif

      End Module NH3_Bidi_Mod

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE AERO_EMIS

C  Emissions data and code required for the modal aerosol module in CMAQ
C  Based on original codes by Dr. Francis S. Binkowski and J. Young
 
C  Dependent Upon:  NONE
 
C  Revision History:
 
C   30 Aug 01 J.Young:  dyn alloc - Use HGRD_DEFN
C   09 Oct 03 J.Gipson: added MW array for AE emis species to module contents
C   31 Jan 05 J.Young:  dyn alloc - establish both horizontal & vertical
C                       domain specifications in one module, GRID_CONF
C   26 Apr 05 P.Bhave:  removed code supporting the "old type" of emission 
C                        files that had unspeciated PM10 and PM2.5 only
C                       removed need for 'AERO_SPC.EXT' by declaring the 
C                        required variables locally
C   13 Jun 05 P.Bhave:  added vars needed for sea-salt emission processing
C                       inherit N_AE_EMIS,AE_EMIS,AE_EMIS_MAP from AE_EMIS.EXT
C                       moved RHO* parameters from RDEMIS_AE to this module
C                        for use by SSEMIS routine
C   24 Aug 07 J.Young:  Modified to enable in-line plume rise calculation for
C                       3D pt source emissions. Distinguish between PM (primary,
C                       unspeciated, file data) and AE (model speciated). Re-
C                       named RDEMIS_AE to GET_AERO_EMIS.
C   11 Apr 08 J.Kelly:  added code to emit coarse surface area
C    4 Jan 10 J.Young:  restructure; eliminate ref to older AERO versions
C   21 Feb 10 J.Young:  move sea salt emissions to its own module (SSEMIS)
C   23 Apr 10 J.Young:  replace include files with mechanism namelists
C   30 Apr 10 J.Young:  update to use aero_reeng by Steve Howard, Prakash Bhave,
C                       Jeff Young, and Sergey Napelenok
C   23 Jul 10 D.Wong:   remove CLOSE3 and BARRIER
C   24 Feb 11 J.Young:  Reorganized module with initialization and timestepping
C                       procedures
C   25 Feb 11 J.Young:  add windblown dust module
C   25 Mar 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   18 Aug 11 David Wong: In the merge inline point source PM species calculation,
C                         arrays EMBUFF and PMEMIS_PT have incorrect index values
C   17 Apr 13 J.Young: replace "SPFC ASO4" (found by Havala Pye) with "SPFC_ASO4"
C   07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C-----------------------------------------------------------------------

      USE AERO_DATA, ONLY: DESID_N_AERO_REF, N_MODE
      USE DESID_VARS, ONLY: DESID_LAYS, DESID_STREAM_AERO, DESID_N_SRM, CELLVOL

      IMPLICIT NONE
      SAVE 
C aerosol emissions: [ppmv/s] for mass & number spcs, [m2/mol/s] for surface area spcs
      PUBLIC DESID_SIZE_DIST, AERO_EMIS_INIT, DESID_INIT_SIZE_DIST,
     &       MAP_ISTRtoAERO, MAP_ISTRtoMODE, MAP_NUMtoISTR, MAP_SRFtoISTR,
     &       MAP_ISTRtoNUM,  MAP_ISTRtoSRF,  MAP_ISTRtoSD,  DESID_STREAM_AERO, 
     &       SD_SPLIT
      PRIVATE

C Variables for converting mass emissions rate to number emissions rate
      REAL   :: FACNUM( DESID_N_AERO_REF,N_MODE )

C Variables for converting mass emissions rate to 2nd moment emissions rate
      REAL   :: FACSRF( DESID_N_AERO_REF,N_MODE )

C Variables for Saving split factors between emission modes
      REAL, ALLOCATABLE :: SD_SPLIT( :,: )

C Emission rate of all aerosol species interpolated to current time
      INTEGER, ALLOCATABLE :: MAP_ISTRtoAERO( : )   
      INTEGER, ALLOCATABLE :: MAP_ISTRtoMODE( : )   
      INTEGER, ALLOCATABLE :: MAP_NUMtoISTR ( : )  
      INTEGER, ALLOCATABLE :: MAP_SRFtoISTR ( : )   
      INTEGER, ALLOCATABLE :: MAP_ISTRtoNUM ( : )  
      INTEGER, ALLOCATABLE :: MAP_ISTRtoSRF ( : )   
      INTEGER, ALLOCATABLE :: MAP_ISTRtoSD  ( :,: ) 
      INTEGER, ALLOCATABLE :: MAP_AEROtoDIFF( :,: )     ! indices of aero species to CGRID

C Miscellaneous variables
      CHARACTER( 200 ) :: XMSG = ' '

      CONTAINS

C-----------------------------------------------------------------------
         FUNCTION  AERO_EMIS_INIT ( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS)

C  Revision History:
 
C   30 Aug 01 J.Young:  dynamic allocation - Use INTERPX
C   29 Jul 03 P.Bhave:  added compatibility with emission files that contain 
C                       PM10, PEC, POA, PNO3, PSO4, and PMF, but do not 
C                       contain PMC
C   20 Aug 03 J.Young:  return aero emissions in molar mixing ratio, ppm units
C   09 Oct 03 J.Gipson: added MW array for AE emis species to module contents
C   01 Sep 04 P.Bhave:  changed MW for primary organics from 120 to 220 g/mol,
C                       to match MWPOA in subroutine ORGAER3.
C   31 Jan 05 J.Young:  dyn alloc - removed HGRD_ID, VGRID_ID, and COORD_ID 
C                       include files because those parameters are now 
C                       inherited from the GRID_CONF module
C   26 Apr 05 P.Bhave:  removed code supporting the "old type" of emission 
C                        files that had unspeciated PM10 and PM2.5 only
C                       removed need for 'AERO_CONST.EXT' by declaring the
C                        required variables locally
C                       simplified the CONVM, CONVN, CONVS calculations
C                       updated and enhanced in-line documentation
C   03 May 05 P.Bhave:  fixed bug in the H2SO4 unit conversion, initially
C                        identified by Jinyou Liang of CARB
C   13 Jun 05 P.Bhave:  calculate sea-salt emissions; execute if MECHNAME = AE4
C                        read input fields from new OCEAN_1 file
C                        read extra input fields from MET_CRO_2D and MET_CRO_3D
C                        write diagnostic sea-salt emission file
C                        added TSTEP to call vector for diagnostic output file
C                       inherit MWs from AE_SPC.EXT instead of hardcoding
C                       find pointers to CGRID indices instead of hardcoding
C   08 Mar 07 P.Bhave&   added capability for emission files that contain 
C             S.Roselle:  POC or POA
C   30 Jan 08 P.Bhave:  added compatibility with AE5 mechanisms
C   23 Mar 08 J.Young:  modifications to allow for in-line point source emissions
C   11 Apr 08 J.Kelly:  added code to emit coarse surface area
C   09 Sep 08 P.Bhave:  backward compatibility with AE4 mechanisms
C   20 Feb 10 J.Young:  move ssemis out to its own F90 module
C   24 Feb 11 J.Young:  add windblown dust emissions option
C   25 Mar 11 S.Roselle: Replaced I/O API include files with UTILIO_DEFN
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C   17 Sep 14 K.Fahey:  Changed geometric mean diameter and geometric
C                       standard deviation of emitted particles according to 
C                       Elleman and Covert (2010)
C   15 Apr 16 J.Young: Use aerosol factors from the AERO_DATA module's named constants;
C                      Moved K.Fahey's mods to geometric mean diameter and standard
C                      deviation to the AERO_DATA module
 
C  References:
C    CRC76,        "CRC Handbook of Chemistry and Physics (76th Ed)",
C                   CRC Press, 1995
C    Elleman & Covert, "Aerosol size distribution modeling with the Community
C                   Multiscale Air Quality modeling system in the Pacific
C                   Northwest: 3. Size distribution of particles emitted
C                   into a mesoscale model", J. Geophys. Res., Vol 115,
C                   No D3, doi:10.1029/2009JD012401, 2010
C    Hobbs, P.V.   "Basic Physical Chemistry for the Atmospheric Sciences",
C                   Cambridge Univ. Press, 206 pp, 1995.
C    Snyder, J.P.  "Map Projections-A Working Manual", U.S. Geological Survey
C                   Paper 1395 U.S.GPO, Washington, DC, 1987.
C    Binkowski & Roselle  Models-3 Community Multiscale Air Quality (CMAQ)
C                   model aerosol component 1: Model Description.  
C                   J. Geophys. Res., Vol 108, No D6, 4183 
C                   doi:10.1029/2001JD001409, 2003
C-----------------------------------------------------------------------

         USE AERO_DATA, ONLY: DESID_AERO_REF, N_AEROSPC, AEROSPC, 
     &                        AERO_MISSING, MAP_AERO
         USE GRID_CONF, ONLY: GDTYP_GD, XCELL_GD, YCELL_GD, YORIG_GD, GL_NROWS, X3FACE_GD
         USE DUST_EMIS, ONLY: DUST_EMIS_INIT
         USE DESID_VARS, ONLY: MAP_ISTRtoEMVAR
         USE PRECURSOR_DATA, ONLY: MAP_PRECURSOR
         USE RUNTIME_VARS, ONLY:  OCEAN_CHEM, WB_DUST
         USE SSEMIS, ONLY:    SSEMIS_INIT
         USE UTILIO_DEFN
         USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_SPC
         USE CONST

         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

         INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
         INTEGER, INTENT( IN ) :: TSTEP      ! time step vector (HHMMSS)
                                             ! TSTEP(1) = local output step
         LOGICAL SUCCESS

C External Functions:
         INTEGER, EXTERNAL :: FINDEX       !  looks up number in table.

C Local Variables:
         REAL  DGV, SG, SPLIT_ACCUM

C Domain decomposition info from emission and meteorology files
         INTEGER GXOFF, GYOFF          ! origin offset

C Miscellaneous variables
         INTEGER STATUS                   ! ENV..., ALLOCATE status
         CHARACTER( 16 ), SAVE :: PNAME = 'AERO_EMIS_INIT  '
         CHARACTER( 16 ) :: VNAME         ! temp var for species names
         CHARACTER( 50 ) :: VARDESC       ! variable for reading environ. variables
         INTEGER L, N, S, V, IAERO, ISRM, ! Loop indices
     &           IEM, IDIFF, ISPC

C ----------------------------------------------------------------------

         SUCCESS = .TRUE.

C *** Map data modules
         CALL MAP_AERO()
         CALL MAP_PRECURSOR()

C *** set up for sea-spray emission processing
         IF ( OCEAN_CHEM ) THEN
            IF ( .NOT. SSEMIS_INIT( JDATE, JTIME, TSTEP ) ) THEN
               XMSG = 'Failure initializing sea-spray emission processing'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
         END IF

C *** set up for dust emission processing
         IF ( WB_DUST ) THEN
            IF ( .NOT. DUST_EMIS_INIT( JDATE, JTIME, TSTEP ) ) THEN
               XMSG = 'Failure initializing dust emission processing'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
         END IF

C *** Set up emissions size distribution arrays
      ! Calculate factors for converting 3rd moment emission rates into 
      ! number and surface area emission rates.  See Equation 7b of 
      ! Binkowski & Roselle (2003)
         DO IEM = 1,DESID_N_AERO_REF
           DO N = 1, N_MODE
              DGV = DESID_AERO_REF( IEM )%DGVEM( N )
              SG  = DESID_AERO_REF( IEM )%SGEM ( N )

              IF ( DESID_AERO_REF( IEM )%SPLIT( N ) .GT. 0.0 ) THEN
                FACNUM( IEM,N ) = EXP( 4.5 * LOG( SG ) ** 2 ) / DGV ** 3
                FACSRF( IEM,N ) = PI * EXP( 0.5 * LOG( SG ) ** 2 ) / DGV
              ELSE
                FACNUM( IEM,N ) = 0.0
                FACSRF( IEM,N ) = 0.0
              END IF
           END DO

         END DO

       ! Map the Modal-Dependent Names to Transported Species
       ALLOCATE ( MAP_AEROtoDIFF( N_AEROSPC, N_MODE ) )
       DO ISPC = 1,N_AEROSPC
         DO N = 1,N_MODE
           MAP_AEROtoDIFF( ISPC, N ) = INDEX1( AEROSPC( ISPC )%name( N ), 
     &                                 N_SPC_DIFF, DIFF_SPC )
         END DO
       END DO

     
       ! Modify the reference emissions splits based on what transported 
       ! aerosol species are actually available. For example, if the aerosol
       ! namelist only includes the accumulation mode (J) but not the 
       ! Aitken mode (I) for a particular species, then the split for
       ! Aitken mode should be added to the Accumulation mode. Save
       ! these scale factors as a function of transported species and
       ! mode. 
       ALLOCATE( SD_SPLIT( N_SPC_DIFF, DESID_N_AERO_REF ) )
       SD_SPLIT = 0.0
       DO IEM = 1,DESID_N_AERO_REF
         ! For the Fine Mode Reference Distribution, lump Aitken
         ! with Accumulation mode if Aitken Mode does not exist
         IF ( DESID_AERO_REF( IEM )%NAME .EQ. 'FINE_REF' ) THEN
            DO ISPC = 1,N_AEROSPC
              SPLIT_ACCUM = 0.0
              DO N = 1,N_MODE-1
                IF ( AERO_MISSING( ISPC,N ) ) THEN
                  SPLIT_ACCUM = SPLIT_ACCUM + DESID_AERO_REF( IEM )%SPLIT( N )
                ELSE
                  SD_SPLIT( MAP_AEROtoDIFF( ISPC,N ),IEM ) = 
     &               SD_SPLIT( MAP_AEROtoDIFF( ISPC,N ),IEM ) +
     &               DESID_AERO_REF( IEM )%SPLIT( N ) + SPLIT_ACCUM
                  SPLIT_ACCUM = 0.0
                END IF
              END DO
            END DO
         ELSE 
            ! Arbitrary Distribution -> Apply factor to species
            ! if it exists in each mode
            DO ISPC = 1, N_AEROSPC
              DO N = 1, N_MODE
                IF ( .NOT. AERO_MISSING( ISPC,N ) ) THEN
                  SD_SPLIT( MAP_AEROtoDIFF( ISPC,N ),IEM ) = 
     &               DESID_AERO_REF( IEM )%SPLIT( N ) 
                END IF
              END DO
            END DO
         END IF
       END DO
                  
       ALLOCATE ( MAP_NUMtoISTR ( N_MODE ),
     &            MAP_SRFtoISTR ( N_MODE ), STAT = STATUS )
       CALL CHECKMEM( STATUS, 'MAP_NUMtoEM', PNAME )
       CALL CHECKMEM( STATUS, 'MAP_SRFtoEM', PNAME )
 
       END FUNCTION  AERO_EMIS_INIT

C-----------------------------------------------------------------------

       SUBROUTINE DESID_INIT_SIZE_DIST ( JDATE, JTIME )

C  EM_SD_INIT initializes the structures that map modes and streams to
C  reference modes including splits, diameters, and standard deviations.

C-----------------------------------------------------------------------
       USE AERO_DATA, ONLY: DESID_AERO_REF, DESID_N_AERO_REF
       USE DESID_VARS, ONLY: DESID_SD_NML
       USE DESID_UTIL, ONLY: DESID_GET_RULE_STREAMS
       USE UTILIO_DEFN, ONLY: INDEX1, XSTAT1, M3EXIT, UPCASE
         
       IMPLICIT NONE

       INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
       INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
       INTEGER ISRM
       
       INTEGER                          :: N_SD_RULE
       INTEGER                          :: N_SD( DESID_N_SRM )
       CHARACTER( 16 )                  :: SD_NAME( DESID_N_SRM, 10 )
       INTEGER                          :: SD( DESID_N_SRM, 10 )
       LOGICAL                          :: RULE_STREAM( DESID_N_SRM )
       CHARACTER( 16 )                  :: CSUR
       CHARACTER( 16 ), SAVE            :: PNAME = 'EM_SD_INIT  '
       CHARACTER( 20 )                  :: DESID_AERO_REF_CAPS( DESID_N_AERO_REF )

       INTEGER IRULE, ISUR, N, NLEN, ISD, IM, IEM, NRULE
       LOGICAL   :: LREMOVE, LERROR
       
       ! Find Total Number of Size Distribution Registries
       N_SD_RULE = 0
       DO IRULE = 1,SIZE( DESID_SD_NML )
          IF ( DESID_SD_NML( IRULE )%STREAM .EQ. '' ) EXIT
          N_SD_RULE = IRULE
       END DO

       ! First Load all of the Streams with the Default FINE, COARSE, and
       ! AERO Mode references
       SD = 0
       SD_NAME = ''

       ! Capitalize EM_AERO_REF(:)%NAME
       DO IM = 1,DESID_N_AERO_REF
          DESID_AERO_REF_CAPS( IM ) = DESID_AERO_REF( IM )%NAME
          CALL UPCASE( DESID_AERO_REF_CAPS( IM ) )
       ENDDO

       DO ISRM = 1,DESID_N_SRM
         N_SD( ISRM ) = 2
         SD_NAME( ISRM,1 ) = 'FINE'
         SD( ISRM,1 ) = INDEX1( 'FINE_REF',   DESID_N_AERO_REF, DESID_AERO_REF_CAPS( : ) )
         SD_NAME( ISRM,2 ) = 'COARSE'
         SD( ISRM,2 ) = INDEX1( 'COARSE_REF', DESID_N_AERO_REF, DESID_AERO_REF_CAPS( : ) )
       END DO
       
       ! Now Modify those defaults or add new modes to desired streams
       DO IRULE = 1, N_SD_RULE
         ! Expand Size Distribution Rule to All Streams if Requested
         LREMOVE = .FALSE.
         IF ( DESID_SD_NML( IRULE )%STREAM .EQ. '' ) CYCLE
         CALL DESID_GET_RULE_STREAMS( DESID_SD_NML( IRULE )%STREAM, IRULE, 
     &                 RULE_STREAM, LREMOVE, LERROR )
         IF ( LREMOVE ) CYCLE

         ! Loop through streams, set defaults, and build map array
         DO ISRM = 1, DESID_N_SRM
            IF ( RULE_STREAM( ISRM ) ) THEN
               ! This Stream is Being Modified by a Size Distribution
               ! rule
               CALL UPCASE( DESID_SD_NML( IRULE )%MODE_REF )
               IF ( DESID_SD_NML( IRULE )%MODE .EQ. 'FINE' ) THEN
                   ! Overwrite the FINE mode. All fine particle species
                   ! will go to this mode by default
                   SD( ISRM,1 ) = INDEX1( DESID_SD_NML( IRULE )%MODE_REF,
     &                               DESID_N_AERO_REF, DESID_AERO_REF_CAPS( : ) )
                   IF ( SD( ISRM,1 ) .EQ. 0 ) THEN
                      WRITE( XMSG,'(A,A,A,/,A,I2,A)' ), '*** Reference Aerosol Mode (', 
     &                       DESID_SD_NML( IRULE )%MODE_REF, 'Specified in Emissions Size ',
     &                       'Dist Rule ',IRULE,' does not exist in AERO_DATA.'
                      CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                   END IF

               ELSEIF ( DESID_SD_NML( IRULE )%MODE .EQ. 'COARSE' ) THEN
                   ! Overwrite the COARSE mode. All coarse particle
                   ! species will go to this mode by default
                   SD( ISRM,2 ) = INDEX1( DESID_SD_NML( IRULE )%MODE_REF,
     &                               DESID_N_AERO_REF, DESID_AERO_REF_CAPS( : ) )
                   IF ( SD( ISRM,2 ) .EQ. 0 ) THEN
                      WRITE( XMSG,'(A,A,A,/,A,I2,A)' ), '*** Reference Aerosol Mode (', 
     &                       DESID_SD_NML( IRULE )%MODE_REF, 'Specified in Emissions Size ',
     &                       'Dist Rule ',IRULE,' does not exist in AERO_DATA.'
                      CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                   END IF

               ELSE
                   ! Add a New Available Mode. For example, add a mode
                   ! just for BC, call it PUREBC, and make sure the AEC
                   ! for this stream is pointing to this mode. Also make
                   ! sure you set AEC for FINE mode aerosol to 0.0 if
                   ! you have default mapping turned on.
                   N_SD( ISRM ) = N_SD( ISRM ) + 1
                   SD_NAME( ISRM,N_SD( ISRM ) ) = DESID_SD_NML( IRULE )%MODE
                   SD( ISRM,N_SD( ISRM ) ) = INDEX1( DESID_SD_NML( IRULE )%MODE_REF,
     &                                DESID_N_AERO_REF, DESID_AERO_REF_CAPS( : ) )
                   IF ( SD( ISRM,N_SD( ISRM )) .EQ. 0 ) THEN
                      WRITE( XMSG,'(A,A,A,/,A,I2,A)' ), '*** Reference Aerosol Mode (', 
     &                       DESID_SD_NML( IRULE )%MODE_REF, 'Specified in Emissions Size ',
     &                       'Dist Rule ',IRULE,' does not exist in AERO_DATA.'
                      CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                   END IF

               END IF
           END IF
         END DO
      END DO
 
      ! Finally, transfer this data to a global variable which
      ! captures and organizes the modes of each stream
      ALLOCATE( DESID_STREAM_AERO( DESID_N_SRM ) )
      DO ISRM = 1,DESID_N_SRM
          N = N_SD( ISRM )
          DESID_STREAM_AERO( ISRM )%LEN = N + 1
          ALLOCATE( DESID_STREAM_AERO( ISRM )%NAME( N+1 ) )
          ALLOCATE( DESID_STREAM_AERO( ISRM )%REF( N+1 ) )
          ALLOCATE( DESID_STREAM_AERO( ISRM )%FACNUM( N+1,N_MODE ) )
          ALLOCATE( DESID_STREAM_AERO( ISRM )%FACSRF( N+1,N_MODE ) )

          DESID_STREAM_AERO( ISRM )%NAME( 2:N+1 ) = SD_NAME( ISRM,1:N )
          DESID_STREAM_AERO( ISRM )%REF( 2:N+1 )  = SD( ISRM,1:N )
          DESID_STREAM_AERO( ISRM )%NAME( 1 ) = 'GAS'
          DESID_STREAM_AERO( ISRM )%REF( 1 )  = 0

          ! Map Factors for Converting Aerosol Mass to Number and
          ! Surface Area to each Emission Stream
          DESID_STREAM_AERO( ISRM )%FACNUM( :,: ) = 0.0
          DESID_STREAM_AERO( ISRM )%FACSRF( :,: ) = 0.0
          DO ISD = 2,N+1
             IEM = DESID_STREAM_AERO( ISRM )%REF( ISD )
             DO IM = 1,N_MODE
                 DESID_STREAM_AERO( ISRM )%FACNUM( ISD,IM ) = FACNUM( IEM,IM ) 
                 DESID_STREAM_AERO( ISRM )%FACSRF( ISD,IM ) = FACSRF( IEM,IM )
             END DO
          END DO
      END DO

      END SUBROUTINE DESID_INIT_SIZE_DIST    


C-----------------------------------------------------------------------

         SUBROUTINE DESID_SIZE_DIST ( ISRM, VDEMIS, NL )

C  EMISS_SIZE_DIST distributes bulk aerosol emissions into size space
C  using parameters precompiled in the AERO_DATA module. 
C
C  Revision History:

C   16 AUG 17 BMURPHY: Created
C                      
C ----------------------------------------------------------------------

         USE AERO_DATA, ONLY: AEROSPC, N_AEROSPC, AEROSPC_MWINV 
         USE CONST, ONLY: F6DPI
         USE ASX_DATA_MOD, ONLY: MET_DATA
         USE DESID_VARS, ONLY: DESID_N_ISTR, IDUSTSRM, ISEASRM
         USE GRID_CONF, ONLY: NCOLS, NROWS
         USE SSEMIS, ONLY: SEA_FACTNUM, SEA_FACTSRF

         INTEGER, INTENT( IN ) :: ISRM, NL
         REAL, INTENT( INOUT ) :: VDEMIS ( :,:,:,: ) 

         INTEGER :: N, S, IAERO, IM, ISD, ISTR   ! Looping Variables
         INTEGER :: ROW, COL, LAY, N_SD, INUM, ISRF, MAX_N_SD
         REAL    :: FACNUM, FACSRF, MW_FAC
         REAL, ALLOCATABLE, SAVE :: EMISM3( :,:,:,:,: ) 
         REAL, ALLOCATABLE, SAVE :: GSFAC( :,:,: )
         REAL, ALLOCATABLE, SAVE :: DENS_FAC( : )
         REAL, PARAMETER   :: F6DPIM3 = 1.0E-3 * F6DPI  ! 1.0E-3 = Kg/g
         LOGICAL, SAVE     :: FIRST_TIME = .TRUE.

C *** Initialize Variables  
         
         IF ( FIRST_TIME ) THEN
             FIRST_TIME = .FALSE.
             ALLOCATE( GSFAC ( DESID_LAYS,NCOLS,NROWS ) )

             ALLOCATE( DENS_FAC( N_AEROSPC ) )
             DO IAERO = 1,N_AEROSPC
                 ! Conversion from g --> m3
                 !     F6DPIM3 [kg/g] / DENS [kg/m3]
                 DENS_FAC( IAERO ) = F6DPIM3 / AEROSPC( IAERO )%DENSITY
             END DO
             
             MAX_N_SD = MAXVAL( DESID_STREAM_AERO(:)%LEN )

             ALLOCATE( EMISM3( DESID_LAYS,NCOLS,NROWS,N_MODE,MAX_N_SD ) )

         END IF
         N_SD   = DESID_STREAM_AERO( ISRM )%LEN 
         EMISM3 = 0.0

C *** Apply Aerosol Size Distribution
         DO ISTR = 1, DESID_N_ISTR
             ! Find which Size Distribution or Phase this emissions species belongs 
             ! to for this stream. If the value is a 0, then there are no emissions 
             ! for this species from this stream. If it is a 1, then this species is
             ! a gas and the following aerosol conversions should be skipped.
             ISD   = MAP_ISTRtoSD( ISTR,ISRM )
             IF ( ISD .LE. 1 ) CYCLE
             
             ! Look up Aerosol Species and Mode of Interest
             IAERO = MAP_ISTRtoAERO( ISTR )   !This maps to the CMAQ aerosol
                                              !  species so we can retrieve density
             IM    = MAP_ISTRtoMODE( ISTR )   !This maps to the internal CMAQ modes 
                                              !  (ie. I, J, and K)

             ! Sum Total Volume of Mode N [m3/s]
             IF ( .NOT. AEROSPC( IAERO )%TRACER )
     &             EMISM3( 1:NL,:,:,IM,ISD ) = EMISM3( 1:NL,:,:,IM,ISD ) + 
     &                  VDEMIS( ISTR,1:NL,:,: ) * DENS_FAC( IAERO )

             ! Convert Mass Emission Rates from [g/s] to [mol/s]
             VDEMIS( ISTR,1:NL,:,: ) = VDEMIS( ISTR,1:NL,:,: ) * AEROSPC_MWINV( IAERO )

         END DO          

C *** Calculate the number emissions rate for each mode [1/s], using 
C     Equation 7b of Binkowski & Roselle (2003).
C     Calculate the surface area emissions rate for the fine modes [m2/s],
C     using Equation 7c of Binkowski & Roselle (2003).  Multiplying by PI 
C     converts 2nd moment to surface area.
            
         DO ISD = 2, N_SD   ! Skip the Index for the Gas Phase
            IF ( ISRM .EQ. ISEASRM ) THEN
               ! Apply Spatially-Dependent Number and Surface Area Scale Factors
               DO IM = 1, N_MODE
                  INUM = MAP_NUMtoISTR(IM)
                  VDEMIS( INUM,1,:,: ) = VDEMIS( INUM,1,:,: ) 
     &                     + EMISM3( 1,:,:,IM,ISD ) * SEA_FACTNUM( IM,:,: ) 

                  ISRF = MAP_SRFtoISTR(IM)
                  VDEMIS( ISRF,1,:,: ) = VDEMIS( ISRF,1,:,: ) 
     &                     + EMISM3( 1,:,:,IM,ISD ) * SEA_FACTSRF( IM,:,: ) 
               END DO
            ELSE
               ! Apply Homogeneous Scale Factors Consistent with this Stream
               DO IM = 1, N_MODE
                  INUM = MAP_NUMtoISTR(IM)
                  FACNUM = DESID_STREAM_AERO( ISRM )%FACNUM( ISD,IM )
                  VDEMIS( INUM,1:NL,:,: ) = VDEMIS( INUM,1:NL,:,: ) + EMISM3( 1:NL,:,:,IM,ISD ) * FACNUM

                  ISRF = MAP_SRFtoISTR(IM)
                  FACSRF = DESID_STREAM_AERO( ISRM )%FACSRF( ISD,IM )
                  VDEMIS( ISRF,1:NL,:,: ) = VDEMIS( ISRF,1:NL,:,: ) + EMISM3( 1:NL,:,:,IM,ISD ) * FACSRF
               END DO
            END IF
         END DO
 
         END SUBROUTINE DESID_SIZE_DIST
 
      END MODULE AERO_EMIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C......................................................................
      MODULE PA_VARS
 
C Contains: IRR data used in the Process Analysis Control Program
 
C Dependent Upon: None
 
C Revision History:
C  Prototype created by Jerry Gipson, July, 1996
C  Revised by Jerry Gipson April, 1997 to add the ADJC process and replace
C  NSPCSD with NSPCS for dimensioning
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified May 2002 by Jerry Gipson to increase number of reaction lines (for saprc99)
C  Aug 2011 Jeff Young: Removed domain data
C  Jun 2016 Jeff Young: made PA_VARS.EXT int this module
 
C......................................................................
      USE PA_GLOBAL, Only: MXSPEC, MXRXNS
      USE CGRID_SPCS, Only:
     &          CGRID_SPCS_INIT,
     &          N_GC_SPC, GC_SPC,
     &          N_AE_SPC, AE_SPC,
     &          N_NR_SPC, NR_SPC,
     &          N_TR_SPC, TR_SPC

      IMPLICIT NONE

C Parameters:

      INTEGER, PARAMETER :: MAXFAMLYS = 150     ! Max no. of families

      INTEGER, PARAMETER :: MAXRXNSUM = 150     ! Max no. of reaction sums

      INTEGER, PARAMETER :: MAXCYCLES = 150     ! Max no. of cycles

      INTEGER, PARAMETER :: MAXIRROUT = 900     ! Max number of IRR outputs

      INTEGER, PARAMETER :: MAXDEFNAMES =       ! Max no. of defined names
     &                                    MAXFAMLYS
     &                                  + MAXRXNSUM
     &                                  + MAXCYCLES
     &                                  + MAXIRROUT

      INTEGER, PARAMETER :: MAXRXTERMS = 300    ! Max no. of terms in a reaction sum
      
      INTEGER, PARAMETER :: MAXCYTERMS = 300    ! Max no. of rxns in a cycle

      INTEGER, PARAMETER :: MAXOUTTERMS = 300   ! Max no. of terms in an IRR output

      INTEGER, PARAMETER :: MAXTERMS = 900      ! Generic max no. of terms

      INTEGER, PARAMETER :: MAXFAMMEM = MXSPEC  ! Max no of members in any family

      INTEGER, PARAMETER :: MXMECHLINE = 30

      INTEGER, PARAMETER :: MXFAMLINE = 15

C Common Variables:
      CHARACTER(  4 ) :: CYSPTYP( MAXCYCLES )              ! Type of name for cycle
      CHARACTER(  4 ) :: OUTTYPE ( MAXIRROUT,MAXOUTTERMS ) ! Output term type
      CHARACTER(  4 ) :: OUTOP2  ( MAXIRROUT,MAXOUTTERMS ) ! Output AND/OR keyword
      CHARACTER(  4 ) :: OUTS1TYP( MAXIRROUT,MAXOUTTERMS ) ! Name type for species 1 
      CHARACTER(  4 ) :: OUTS2TYP( MAXIRROUT,MAXOUTTERMS ) ! Name type for species 2
      CHARACTER(  4 ) :: OUTS3TYP( MAXIRROUT,MAXOUTTERMS ) ! Name type for species 3

      CHARACTER(  7 ) :: OUTPNFLAG( MAXIRROUT,MAXOUTTERMS ) ! Flag to include
                                                            ! only if sum is + or -

      CHARACTER( 16 ) :: FAMNAME  ( MAXFAMLYS )  ! Name of Family
      CHARACTER( 16 ) :: RXSUMNAME( MAXRXNSUM )  ! Name assigned to reaction sum
      CHARACTER( 16 ) :: CYCLNAME ( MAXCYCLES )  ! Name assigned to reaction sum
      CHARACTER( 16 ) :: CYCLSPEC ( MAXCYCLES )  ! Species to cycle if so defined

      CHARACTER( 16 ) :: FAMMEMNAM( MAXFAMLYS,MAXFAMMEM )  ! Name of family member
      CHARACTER( 16 ) :: RXSUMLBL ( MAXRXNSUM,MAXRXTERMS ) ! Rx no. of terms in sum
      CHARACTER( 16 ) :: CYRXLBL  ( MAXCYCLES,MAXCYTERMS ) ! Rx no. of cycle terms
      CHARACTER( 16 ) :: OUTRXLBL ( MAXIRROUT,MAXOUTTERMS ) ! Reaction labels of 
                                                            ! terms in command
      CHARACTER( 16 ) :: OUTSPEC1 ( MAXIRROUT,MAXOUTTERMS ) ! Species 1 name for  
                                                            ! output operator
      CHARACTER( 16 ) :: OUTSPEC2 ( MAXIRROUT,MAXOUTTERMS ) ! Species 2 name for  
                                                            ! output operator
      CHARACTER( 16 ) :: OUTSPEC3 ( MAXIRROUT,MAXOUTTERMS ) ! Species 3 name for  
                                                            ! output operator
      CHARACTER( 16 ), SAVE :: IRRNAME_TMP( MAXIRROUT ) ! for IRRNAME

      CHARACTER( 28 ) :: TDATOUT    ! Output clock time and date

      CHARACTER( 60 ), SAVE :: IRRDESC_TMP( MAXIRROUT ) ! for IRRDESC

      CHARACTER( 80 ) :: MECLINE( MXRXNS,MXMECHLINE )    ! Compressed reaction lines
      CHARACTER( 80 ) :: FAMLINE( MAXFAMLYS,MXFAMLINE )  ! Compressed family lines

      INTEGER :: NFAMLYS                 ! Number of families pdefined
      INTEGER :: NRXSUMS                 ! Number of reaction sums defined
      INTEGER :: NCYCLES                 ! Number of cycles defined
      INTEGER :: NIRROUT                 ! Number of outputs IRR fields requested
      INTEGER :: FAMNUMLNS ( MAXFAMLYS ) ! Number of lines for family
      INTEGER :: MECNUMLNS (    MXRXNS ) ! Number of lines for reaction
      INTEGER :: NUMFAMMEM ( MAXFAMLYS ) ! Number of members of each family
      INTEGER :: NRXTERMS  ( MAXRXNSUM ) ! Number of terms in reaction sum
      INTEGER :: NCYTERMS  ( MAXCYCLES ) ! Number of reaction terms in each cycle
      INTEGER :: NIRRTERMS ( MAXIRROUT ) ! Number of terms in each output request
      INTEGER :: NOUTCYCS  ( MAXIRROUT ) ! No. of cycles used in output
      INTEGER :: NOUTFAMS  ( MAXIRROUT ) ! No. of families used in output
      INTEGER :: NOUTRXSUMS( MAXIRROUT ) ! No. of reaction sums used in output
      INTEGER :: NOUTOPS   ( MAXIRROUT ) ! No. of output operators
      INTEGER :: NOUTRXN   ( MAXIRROUT ) ! No. of reaction used in output
      INTEGER :: CYSPNUM   ( MAXCYCLES ) ! Species or family-name number

      INTEGER :: TEMPOUTIND_TMP( MAXTERMS )  ! Init no. of temp IRR terms to add
      INTEGER :: INDXOUTIND_TMP( MAXTERMS )  ! Init IRR output index of temp terms
      INTEGER :: TEMPOUTNEG_TMP( MAXTERMS )  ! Init no. of temp IRR terms to add if neg
      INTEGER :: INDXOUTNEG_TMP( MAXTERMS )  ! Init IRR output index of neg only temp terms
      INTEGER :: TEMPOUTPOS_TMP( MAXTERMS )  ! Init no. of temp IRR terms to add if pos
      INTEGER :: INDXOUTPOS_TMP( MAXTERMS )  ! Init IRR output index of pos only temp terms
      INTEGER :: TEMPTERMS_TMP ( MAXTERMS )  ! Init no of temp IRRs to compute
      INTEGER :: TEMPRXN_TMP   ( MAXTERMS,MAXTERMS )   ! Init Rxn nos. for each temp IRR

      INTEGER :: FAMSPIDS  ( MAXFAMLYS,MAXFAMMEM )   ! Mech spec IDs for fam. mem.
      INTEGER :: RXSUMRN   ( MAXRXNSUM,MAXRXTERMS )  ! Rx numbers of rxsum terms 
      INTEGER :: CYRXNUM   ( MAXCYCLES,MAXCYTERMS )  ! Rx numbers of cycle terms
      INTEGER :: OUTCYCS   ( MAXIRROUT,MAXOUTTERMS ) ! Cycle number of output terms
      INTEGER :: OUTFAMS   ( MAXIRROUT,MAXOUTTERMS )
      INTEGER :: OUTRXSUMS ( MAXIRROUT,MAXOUTTERMS ) ! Rxsum number of output terms 
      INTEGER :: OUTS1NUM  ( MAXIRROUT,MAXOUTTERMS ) ! Species/family name number
      INTEGER :: OUTS2NUM  ( MAXIRROUT,MAXOUTTERMS ) ! Species/family name number
      INTEGER :: OUTS3NUM  ( MAXIRROUT,MAXOUTTERMS ) ! Species/family name number
      INTEGER :: OUTRN     ( MAXIRROUT,MAXOUTTERMS ) ! Input IRR Rxn nos.
      INTEGER :: IRRRXN_TMP( MAXIRROUT,MAXTERMS )  ! Initial IRR Rx nos. excluding
                                                   ! CYCLES and RXNSUMS -> IRRRXN

      REAL    :: COEFOUTIND_TMP( MAXTERMS )        ! Init coefficients for pos or neg init
      REAL    :: COEFOUTNEG_TMP( MAXTERMS )        ! Init coefficients for neg init
      REAL    :: COEFOUTPOS_TMP( MAXTERMS )        ! Init coefficients for pos init


      REAL    :: FAMSC( MAXFAMLYS,MAXFAMMEM )    ! Coefficients for a family member
      REAL    :: RXNSC( MAXRXNSUM,MAXRXTERMS )   ! Coefficients for a sum rxn term
      REAL    :: CYSC ( MAXCYCLES,MAXCYTERMS )   ! Coefficients for cycle terms
      REAL    :: OUTSC( MAXIRROUT,MAXOUTTERMS )  ! Coefficients for output terms
      REAL    :: IRRCOEF_TMP( MAXIRROUT,MAXTERMS ) ! Initial coefficients for IRR Rxns
      REAL    :: TEMPCOEF_TMP( MAXTERMS,MAXTERMS ) ! Initial coefficients for temp IRRs

      END MODULE PA_VARS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPENLAYOUT( SDATE, STIME, TSTEP, EMLAYS, VGLVSXG,
     &                       NPTGRPS, MY_NSRC, LNAME )

C-----------------------------------------------------------------------
 
C  Description:
C    Opens the diagnostic layer fractions file(s).
 
C  Preconditions:
 
C  Subroutines and Functions Called:
C       I/O API 

C Revision History:
C   16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   26 Sep 2016 D.Wong: reformatted PLAY_BASE variable as PLAY_BASE_*
C                       rather than PLAY_BASE*_

C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling
C             System
C File: @(#)$Id: openlayout.F,v 1.4 2011/10/21 16:11:30 yoj Exp $
C COPYRIGHT (C) 2002, MCNC Environmental Modeling Center
C All Rights Reserved
C See file COPYRIGHT for conditions of use.
C Environmental Modeling Center
C MCNC
C P.O. Box 12889
C Research Triangle Park, NC  27709-2889
C smoke@emc.mcnc.org
C Pathname: $Source: /project/yoj/arc/CCTM/src/plrise/smoke/openlayout.F,v $
C Last updated: $Date: 2011/10/21 16:11:30 $ 
 
C-----------------------------------------------------------------------

      USE RUNTIME_VARS, ONLY : LOGDEV, PLAY_BASE
      USE HGRD_DEFN, ONLY: MYPE
      USE UTILIO_DEFN

      IMPLICIT NONE
 
C Includes:

C Local Parameters:

C Arguments:
      INTEGER,        INTENT( IN )  :: SDATE    ! Julian start date
      INTEGER,        INTENT( IN )  :: STIME    ! start time (HHMMSS)
      INTEGER,        INTENT( IN )  :: TSTEP    ! time step (HHMMSS)
      INTEGER,        INTENT( IN )  :: EMLAYS   ! number of emissions layers
      REAL,           INTENT( IN )  :: VGLVSXG( 0: )      !  vertical coord values
      INTEGER,        INTENT( IN )  :: NPTGRPS  ! number of output files
      INTEGER,        INTENT( IN )  :: MY_NSRC( : ) ! number of point sources
      CHARACTER( * ), INTENT( OUT ) :: LNAME( : )   ! layer fractions logical file name

C Local variables:

      INTEGER J, N
      CHARACTER( 256 ) :: XMSG      !  buffer for M3EXIT() messages
      CHARACTER(  16 ) :: PNAME = 'OPENLAYOUT'   ! procedure name

      CHARACTER(   3 ) :: CMYPE
      CHARACTER(   4 ) :: POSTSTR = '.ncf'
      CHARACTER(  96 ) :: PLAY_EQ
      CHARACTER(  96 ) :: EQNAME
      CHARACTER( 256 ) :: BASE

      INTEGER :: IOS

C-----------------------------------------------------------------------

#ifndef mpas
C Set up and open diagnostic file(s)

      FTYPE3D = GRDDED3
      SDATE3D = SDATE
      STIME3D = STIME
      TSTEP3D = TSTEP

      NROWS3D = EMLAYS
      NLAYS3D = 1
      NTHIK3D = 1
      NVARS3D = 2
      GDTYP3D = IMISS3
      P_ALP3D = AMISS3
      P_BET3D = AMISS3
      P_GAM3D = AMISS3
      XCENT3D = AMISS3
      YCENT3D = AMISS3
      XORIG3D = AMISS3
      YORIG3D = AMISS3
      XCELL3D = AMISS3
      YCELL3D = AMISS3
      VGTYP3D = IMISS3
      VGTOP3D = AMISS3
      GDNAM3D = ' '

      VNAME3D = ' '     ! array
      VTYPE3D = 0       ! array
      UNITS3D = ''     ! array
      VDESC3D = ' '     ! array
      VNAME3D( 1 ) = 'LFRAC'
      VTYPE3D( 1 ) = M3REAL
      UNITS3D( 1 ) = '1'
      VDESC3D( 1 ) = 'Fraction of plume emitted into layer'
      VNAME3D( 2 ) = 'ZPLUME'
      VTYPE3D( 2 ) = M3REAL
      UNITS3D( 2 ) = '1'
      VDESC3D( 2 ) = 'plume elevation above ground'

      VGLVS3D = 0.0     ! array
      J = LBOUND( VGLVS3D, 1 )
      VGLVS3D( J:J+EMLAYS ) = VGLVSXG( 0:EMLAYS )  ! array
      VGTYP3D = -1
      VGTOP3D = 0.0

      UPNAM3D = 'DISTR_GRIDDED'   ! Mandatory!

      FDESC3D = ' '  ! array
      FDESC3D( 1 ) = 'By-source hourly plume rise layer fractions'
      FDESC3D( 2 ) = '/FROM/ '    // PNAME
      FDESC3D( 3 ) = '/VERSION/ Inline'

      WRITE( CMYPE,'(I3.3)' ) MYPE
      DO N = 1, NPTGRPS

         IF ( MY_NSRC( N ) .GT. 0 ) THEN
            NCOLS3D = MY_NSRC( N )

            PLAY_EQ = TRIM( PLAY_BASE( N ) ) // '_' // CMYPE // POSTSTR
            WRITE( LNAME( N ),'( "PLAY_", I2.2 )' ) N
            IF ( .NOT. SETENVVAR ( LNAME( N ), PLAY_EQ ) ) THEN
               XMSG = 'Could not set environment variable for ' // PLAY_EQ
               CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT3 )
            END IF
            IF ( .NOT. OPEN3( LNAME( N ), FSNEW3, UPNAM3D ) ) THEN
               XMSG = 'Could not open ' // TRIM( FDESC3D( 1 ) ) // ' file'
               CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )
            END IF

         ELSE

            WRITE( LOGDEV,1009 ) N

         END IF

      END DO
#endif

      RETURN

1009  FORMAT( /5X, 'No sources in this subdomain for file sector', I2
     &        /5X, 'Therefore no plume layer fraction file created' )

      END SUBROUTINE OPENLAYOUT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE OP_SA ( JDATE, JTIME, TSTEP, NSTEPS, FILE_NAME )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c       op_sa.F called by initscen.F
c
C     01 Nov 2018: S.Napelenok Updates for cmaq5.3 release 
C     09 May 2019: D.Wong Removed all MY_ clauses
c
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


!      USE HGRD_DEFN             ! horizontal domain specifications
      USE GRID_CONF
c     USE SA_LAYERS
      USE SA_DEFN               ! Mc06
      USE UTILIO_DEFN           ! replaces ioparms, iofdesc, iodecl
c     USE SUBST_MODULES         ! stenex
      USE RUNTIME_VARS
      USE MIO_ASCII

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

C...Arguments Declaration
      INTEGER    JDATE          ! current model date, coded YYYYDDD
      INTEGER    JTIME          ! current model time, coded HHMMSS
      INTEGER    TSTEP(3)       ! format 10000, 0, 0
cyqw
      INTEGER    NSTEPS         ! Number of time steps of 3D output
cyqw
      CHARACTER( 16 )       :: FILE_NAME

   
C...End of argument declaration

C Local variables:
      
c     INTEGER          ALLOCSTAT, LOGDEV
      INTEGER          ALLOCSTAT

      CHARACTER( 16 ), DIMENSION( :,: ), ALLOCATABLE::VNAME
      CHARACTER( 1 ),  DIMENSION(:), ALLOCATABLE::SPECIE_NAME
      CHARACTER( 16 ) :: TEMP, CSUFFX
      INTEGER          LENGTH

      CHARACTER( 16 ) :: PNAME = 'OP_SA'
      CHARACTER( 96 ) :: XMSG = ' '
      
      INTEGER   C,R,S,K,N, L    ! loop induction variables
c     INTEGER   ITAG, JSPC, JSPCTAG
      INTEGER   JSPC, JSPCTAG


      REAL, ALLOCATABLE :: ISAM_BUFF ( :,:,:,: )

Ckrt Diagnostic
      CHARACTER( 256 ) EQNAME

C-----------------------------------------------------------------------



Ckrt Create variable names for tag output


        LOGDEV = INIT3()

        IF ( ISAM_ELEV .EQ. -1 ) ISAM_ELEV = NLAYS
        SA_NLAYS = ISAM_ELEV - ISAM_BLEV + 1

        ALLOCATE( VNAME(NSPC_SA,NTAG_SA) )
        VNAME = ''
        JSPCTAG = 0
        DO ITAG = 1, NTAG_SA
          DO JSPC = 1, NSPC_SA
            JSPCTAG = JSPCTAG + 1
            LENGTH = LEN_TRIM( ISAM_SPEC( JSPC,ITAG ) )
            IF ( LENGTH .GT. 0 ) THEN
              TEMP = ISAM_SPEC( JSPC,ITAG )( 1:LENGTH )
              ALLOCATE ( SPECIE_NAME( LENGTH ) )
              DO N = 1, LENGTH
                SPECIE_NAME(N:N) = TEMP(N:N)
              ENDDO
              IF ( ITAG .EQ. BCONTAG ) THEN
                CSUFFX = 'BCO             '
                CALL WR_VARNAME( SPECIE_NAME, LENGTH, NTAG_SA, NSPC_SA,
     &             CSUFFX, VNAME( JSPC,ITAG ) )
              ELSEIF ( ITAG .EQ. OTHRTAG ) THEN
                CSUFFX = 'OTH             '
                CALL WR_VARNAME( SPECIE_NAME, LENGTH, NTAG_SA, NSPC_SA,
     &             CSUFFX, VNAME( JSPC,ITAG ) )
              ELSEIF ( ITAG .EQ. ICONTAG ) THEN
                CSUFFX = 'ICO             '
                CALL WR_VARNAME( SPECIE_NAME, LENGTH, NTAG_SA, NSPC_SA,
     &             CSUFFX, VNAME( JSPC,ITAG ) )
              ELSE
                CALL WR_VARNAME( SPECIE_NAME, LENGTH, NTAG_SA, NSPC_SA,
     &             TAGNAME(ITAG), VNAME( JSPC,ITAG ) )
              ENDIF ! Is itag bcon, othr, icon, or emis ?
!              WRITE(LOGDEV,'(I3,2(1X,I2),2(1X,A16))')JSPCTAG,JSPC,ITAG,ISAM_SPEC( JSPC,ITAG ),VNAME( JSPC,ITAG )
              DEALLOCATE ( SPECIE_NAME )
            ENDIF ! length > 0?
          ENDDO ! jspc
        ENDDO ! itag

Ckrt Set nvars3d for SA_CONC_1 or SA_CGRID_1 file
        NVARS3D = N_SPCTAG

Ckrt Set vname3d for SA_CONC_1 file
        JSPCTAG = 0
!       write (logdev, *) NSPC_SA, NTAG_SA

        DO ITAG = 1, NTAG_SA
           DO JSPC = 1, NSPC_SA
              JSPCTAG = JSPCTAG + 1
              VTYPE3D( JSPCTAG ) = M3REAL
              VNAME3D( JSPCTAG ) = VNAME(JSPC,ITAG)
              IF( IS_SPC_AEROSOL( JSPC,ITAG ) )THEN 
                UNITS3D( JSPCTAG ) = "micrograms/m**3 "
              ELSE 
                UNITS3D( JSPCTAG ) = "ppmV            "
              END IF
              VDESC3D( JSPCTAG ) = "tracer conc."
              S_SPCTAG  ( JSPCTAG ) = JSPC
              T_SPCTAG  ( JSPCTAG ) = ITAG
              VNAM_SPCTAG ( JSPCTAG ) = VNAME(JSPC,ITAG)
!              WRITE(LOGDEV,'(I4,2(1X,I3),2(1X,A16),2(1X,I3))')
!     &        JSPCTAG,JSPC,ITAG,  
!     &        VNAME3D( JSPCTAG ), UNITS3D( JSPCTAG ),
!     &        S_SPCTAG( JSPCTAG ), T_SPCTAG( JSPCTAG )
           END DO
        END DO

        SDATE3D = JDATE
        STIME3D = JTIME

        FTYPE3D = GRDDED3
cyqw    TSTEP3D = TSTEP(1)
        TSTEP3D = TSTEP ( 1 ) * NSTEPS
         
        NCOLS3D = GL_NCOLS
        NROWS3D = GL_NROWS
        NLAYS3D = SA_NLAYS
        NTHIK3D =     1
        GDTYP3D = GDTYP_GD
        P_ALP3D = P_ALP_GD
        P_BET3D = P_BET_GD 
        P_GAM3D = P_GAM_GD
        XORIG3D = XORIG_GD
        YORIG3D = YORIG_GD
        XCENT3D = XCENT_GD
        YCENT3D = YCENT_GD
        XCELL3D = XCELL_GD
        YCELL3D = YCELL_GD
        VGTYP3D = VGTYP_GD
        VGTOP3D = VGTOP_GD


        K = 0
        DO L = ISAM_BLEV, ISAM_ELEV
           K = 1 + K
           VGLVS3D( K ) = VGLVS_GD( L )
        END DO

!       GDNAM3D = GDNAME_GD
        GDNAM3D = GRID_NAME  ! from HGRD_DEFN

        FDESC3D( 1 ) = 'SA_CONC_1 stores contributing srcs '
        DO L = 2, MXDESC3
            FDESC3D( L ) = ' '
        END DO
   
        ! Store MIO Metadata
        NDIMS3D( 1:NVARS3D ) = 4
        L_TSTEP( 1:NVARS3D ) = .True.
        L_LAY  ( 1:NVARS3D ) = .True.
        L_COL  ( 1:NVARS3D ) = .True.
        L_ROW  ( 1:NVARS3D ) = .True.
        L_VEXT ( 1:NVARS3D ) = .False.

        CALL LOAD_MIO_FILE ( FILE_NAME, NLAYS3D, ISAM_BLEV, ISAM_ELEV,
     &       VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &       VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &       L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &       L_VEXT(1:NVARS3D) )
               
        IF ( MYPE .EQ. 0 ) THEN
!           CALL M3EXIT( 'OP_SA', 0, 0, 'Fatal Error Encountered', XSTAT2 )
           IF ( .NOT. OPEN3( FILE_NAME, FSNEW3, PNAME ) ) THEN
              XMSG = 'Could not create '// FILE_NAME // ' file'
              CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
           END IF
        END IF

Ckrt...Write initial conditions to sa_conc_1 ( or last hour sa_cgrid_1 )
          ALLOCATE ( ISAM_BUFF( NCOLS, NROWS, SA_NLAYS, N_SPCTAG ), 
     &     STAT = ALLOCSTAT )
          IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating ISAM_BUFF'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          ENDIF
          ISAM_BUFF = 0.0
C
         ! print *, S, N_SPCTAG,ISAM_BLEV, ISAM_ELEV
          DO S = 1, N_SPCTAG
            K = 0
            DO L = ISAM_BLEV, ISAM_ELEV
              K = K + 1
              ISAM_BUFF( :,:,K,S ) = ISAM( :,:,L,S_SPCTAG(S),T_SPCTAG(S) )
            ENDDO
          END DO ! loop over total tags
          IF ( .NOT. WRITE3( FILE_NAME, ALLVAR3, JDATE, JTIME, 
     &     ISAM_BUFF ) ) THEN
            XMSG = 'Could not write to '
     &         // FILE_NAME
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          END IF
          if ( MYPE .eq. 0 ) then
            !print*,'Finished write3 S =',S
            !print*,'While N_SPCTAG =',N_SPCTAG
          endif
          DEALLOCATE( ISAM_BUFF )

      
c.....couple ISAM after writing

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   this subroutine must be implemented to overcome Character*1 X 16
c   to Character*16 conversion.
c   new varname will be created by this way.
c
c   by bo wang
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine wr_varname(input, length, ntag_tssa, nspc_tssa, 
     &     src_name, varname)
     
c     ...argument
      integer                     length
      character*1              :: input(length)
      integer                     ntag_tssa, nspc_tssa
      character*16                src_name
      character*16                varname

c     ...local variable
      integer                     i
      CHARACTER*7                 CHAR1
Ckrt  CHARACTER(len=16-length) :: CHAR1
      character(len=length)       output
      character*16                temp

c     ...external function
      integer len_trim
      
c.....................................................................
      
      do i = 1, length
         output(i:i) = input(i)
      end do

      temp = src_name

!0711 do i = 1, 7
      do i = 1, min( 7, 16-length-1 )
        char1(i:i) = temp(i:i)
      end do
         
      VARNAME = output // '_' // char1

      end

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/plrise/smoke/preplm.f,v 1.3 2011/10/21 16:11:31 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PREPLM( FIREFLG, EMLAYS, HMIX, HTS, PSFC, TS, DDZF, QV,
     &                   TA, UW, VW, ZH, ZF, PRES, LSTK, LPBL, TSTK, 
     &                   WSTK, DTHDZ, WSPD )

C-----------------------------------------------------------------------
C Description:
C   Computes the values needed for the PLMRIS subroutine from the 
C   meteorology data.
 
C Preconditions:
C   Interpolated (to the location of a source) meteorology data as input,
C   vertical grid structure.
 
C Subroutines and Functions Called:
C    I/O API 
 
C Revision History:
C  Copied from preplm.f v 1.2 in DAQM-V2 Emissions Preprocessor by
C  M. Houyoux 3/99
C  16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C  Aug 2015, D. Wong: - Used assumed shape array declaration and adjusted
C                       array accessing index accordingly
C                     - Replaced run time dynamical array with allocatable 
C                     - Fixed temp. and windsp. polynomial interpolation to
C                       stack top
C  12 Oct 2015 J.Young: fix how PRES is used: defined at layer top surface
 
C-----------------------------------------------------------------------
C Modified from:
 
C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling System
C File: @(#)$Id: preplm.f,v 1.3 2011/10/21 16:11:31 yoj Exp $
C COPYRIGHT (C) 2002, MCNC Environmental Modeling Center
C All Rights Reserved
C See file COPYRIGHT for conditions of use.
C Environmental Modeling Center
C MCNC
C P.O. Box 12889
C Research Triangle Park, NC  27709-2889
C smoke@emc.mcnc.org
C Pathname: $Source: /project/yoj/arc/CCTM/src/plrise/smoke/preplm.f,v $
C Last updated: $Date: 2011/10/21 16:11:31 $ 
C-----------------------------------------------------------------------
 
      USE UTILIO_DEFN

      IMPLICIT NONE
 
C Includes:

C External Functions:

C Parameters:
      INTEGER, PARAMETER :: DEG = 3       ! degree of interpolationg polynomial
      REAL,    PARAMETER :: CTOK = 273.15 ! conversion from deg. C to deg. K

C Arguments:
C (Note: All met parms are per-source)
      LOGICAL, INTENT( IN )  :: FIREFLG         ! .true. => processing fire source
      INTEGER, INTENT( IN )  :: EMLAYS          ! no. emissions layers
      REAL,    INTENT( IN )  :: HMIX            ! mixing height
      REAL,    INTENT( IN )  :: HTS             ! stack height
      REAL,    INTENT( IN )  :: PSFC            ! surface pressure
      REAL,    INTENT( IN )  :: TS              ! surface temperature
      REAL,    INTENT( IN )  :: DDZF( : )       ! 1/( zf(l) - zf(l-1) )
      REAL,    INTENT( IN )  :: QV  ( : )       ! mixing ratio
      REAL,    INTENT( IN )  :: TA  ( : )       ! absolute temperature
      REAL,    INTENT( IN )  :: UW  ( : )       ! x-direction winds
      REAL,    INTENT( IN )  :: VW  ( : )       ! y-direction winds
      REAL,    INTENT( IN )  :: ZH  ( : )       ! layer center  height [m]
      REAL,    INTENT( IN )  :: ZF  ( : )       ! layer surface height [m]
      REAL,    INTENT( IN )  :: PRES( 0: )      ! pres at full layer hts (mod by YOJ)
      INTEGER, INTENT( OUT ) :: LSTK            ! first L: ZF(L) > STKHT
      INTEGER, INTENT( OUT ) :: LPBL            ! first L: ZF(L) > mixing layer
      REAL,    INTENT( OUT ) :: TSTK            ! temperature @ top of stack [K]
      REAL,    INTENT( OUT ) :: WSTK            ! wind speed @ top of stack [m/s]
      REAL,    INTENT( OUT ) :: DTHDZ( : )      ! potential temp. grad. 
      REAL,    INTENT( OUT ) :: WSPD ( : )      ! wind speed [m/s]

C Local Variables:
      INTEGER      L, M
      REAL         ES
      REAL         QSFC
      REAL         TVSFC
      REAL         THETG
      REAL         THV1
      REAL         THVK
!     REAL         TV( EMLAYS )   ! Virtual temperature
!     REAL         TF( EMLAYS )   ! Full-layer height temperatures
      REAL, ALLOCATABLE :: TV( : )   ! Virtual temperature
      REAL, ALLOCATABLE :: TF( : )   ! Full-layer height temperatures
      REAL         P, Q
      REAL         DZZ
      REAL         DELZ

      CHARACTER( 240 ) :: XMSG = ' '
      INTEGER :: STAT

C-----------------------------------------------------------------------

      ALLOCATE ( TV( EMLAYS ), TF( EMLAYS ), STAT=STAT )
      IF ( STAT .NE. 0 ) THEN
         WRITE( XMSG, *) ' Cannot allocate TV and TF in PREPLM'
         CALL M3MSG2( XMSG )
         STOP
      END IF

C Convert pressure to millibars from pascals, compute wind speed,
C and virtual temperature

      DO L = 1, EMLAYS
         P = UW( L )
         Q = VW( L )
         WSPD( L ) = SQRT( P * P + Q * Q )
         TV( L ) = TA( L ) * ( 1.0 + 0.622 * ( QV( L ) / ( 1.0 + QV( L ) ) ) )
      END DO

      ES    = 6.1078 * EXP( 5384.21 / CTOK - 5384.21 / TS )
      QSFC  = 0.622 * ES / ( PSFC - ES )
      TVSFC = TS * ( 1.0 + 0.6077 * QSFC )
      THETG = TVSFC * ( 1000.0 / PSFC ) ** 0.286
      IF ( HMIX .LE. ZF( 1 ) ) LPBL = 1
      IF ( HTS .LE. ZF( 1 ) ) LSTK = 1

C Interpolate the virtual temperatures at the full-layer face heights (at ZFs)
      DO L = 1, EMLAYS - 1
         DELZ = ZH( L+1 ) - ZH( L )
         TF( L ) = TV( L ) + ( TV( L+1 ) - TV( L ) ) * ( ZF( L ) - ZH( L ) ) / DELZ
      END DO
      L = EMLAYS
      DELZ = ZH( L ) - ZH( L-1 )
      TF( L ) = TV( L ) + ( TV( L ) - TV( L-1 ) ) * ( ZF( L ) - ZH( L ) ) / DELZ

!     THV1  = TF( 1 ) * ( 1000.0 / PRES( 2 ) ) ** 0.286
      THV1  = TF( 1 ) * ( 1000.0 / PRES( 1 ) ) ** 0.286

!     DTHDZ( 1 ) = ( THV1 - THETG ) / ZF( 1 )

      DO L = 2, EMLAYS
 
         IF ( HMIX .GT. ZF( L-1 ) ) LPBL = L
         IF ( HTS .GT. ZF( L-1 ) ) LSTK = L
 
!        THVK = TF( L ) * ( 1000.0 / PRES( L+1 ) ) ** 0.286
         THVK = TF( L ) * ( 1000.0 / PRES( L ) ) ** 0.286
         DTHDZ( L ) = DDZF( L ) * ( THVK - THV1 )
         THV1 = THVK
 
      END DO

C Set the 1st level vertical THETV gradient to the 2nd layer value -
C overrides the layer 1 gradient determined above
      DTHDZ( 1 ) = DTHDZ( 2 )

      IF ( .NOT. FIREFLG ) THEN
C Interpolate ambient temp. and windspeed to top of stack using DEG deg. polynomial
         M    = MAX( 1, LSTK - DEG - 1 )
         TSTK =      POLY( HTS, ZH( M:EMLAYS ), TA( M:EMLAYS ), DEG )
         WSTK = MAX( POLY( HTS, ZH( M:EMLAYS ), WSPD( M:EMLAYS ), DEG ), 0.1 )
      ELSE
         TSTK = TS
         WSTK = WSPD( 1 )
      END IF

      DEALLOCATE ( TV, TF )

      END SUBROUTINE PREPLM

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module stm_module

C  Contains:
C     Subroutines stm_wrap_ae
C                 stm_wrap_gas

C  Revision History:
C SR 12/13/2018 Initial version

C----------------------------------------------------------------------

      Implicit None

      Logical, Private, Save :: stm_mapped = .False.

      Real, Allocatable :: aero_conc( :,: ) ! aero species concentration [ ug/m^3 ]

      Contains

C-----------------------------------------------------------------------
      Subroutine stm_wrap_ae ( cgrid, jdate, jtime )

C  capture changes from aero proc (changes in aso4 from new particle
C     formation and condensation)

C  Revision History:
C     Initial version - 6/5/19 - Shawn Roselle
C
C-----------------------------------------------------------------------
      Use grid_conf, Only: ncols, nrows, nlays
      Use runtime_vars, Only: adj_stmspc
      Use aero_budget, Only: aero_cond, aero_npf
      Use aero_data, Only : aso4_idx, aso4aqh2o2_idx, aso4aqo3_idx,
     &                      aso4aqfemn_idx, aso4aqmhp_idx, aso4aqpaa_idx,
     &                      aso4gas_idx, aso4emis_idx, aso4icbc_idx,
     &                      oso4aqh2o2_idx, oso4aqo3_idx, oso4aqfemn_idx,
     &                      oso4aqmhp_idx, oso4aqpaa_idx, oso4_idx,
     &                      oso4gas_idx, oso4emis_idx, oso4icbc_idx,
     &                      aerospc_map, aerospc_mw, aerospc,
     &                      n_mode, ae6isoa,
     &                      findAero
      Use stm_vars, Only: organosulf

      Implicit None

C Arguments

      Real, Pointer :: cgrid( :,:,:,: )

      Integer, Intent( In ) :: jdate
      Integer, Intent( In ) :: jtime

C Local variables

      Integer c, r, l, m

      Real aso4tot, oso4tot
      Real mscor

      Do c = 1, ncols
         Do r = 1, nrows
            Do l = 1, nlays

C extract aerosol species from CGRID

               Call stm_extract_aero ( cgrid( c,r,l,: ) )

               Do m = 1, n_mode
                  aero_conc( aso4gas_idx, m ) =
     &                     Max( ( aero_conc( aso4gas_idx, m )
     &                          + aero_cond( c,r,l,aerospc_map( aso4_idx,m ) )
     &                          + aero_npf ( c,r,l,aerospc_map( aso4_idx,m ) ) ),
     &                          aerospc( aso4gas_idx )%min_conc( m ) )
               End Do

C normalize tracked sulfate species to total modeled sulfate

               If ( adj_stmspc ) Then

                  Do m = 1, n_mode

                     aso4tot = aero_conc( aso4gas_idx, m )
     &                       + aero_conc( aso4emis_idx,m )
     &                       + aero_conc( aso4icbc_idx,m )

C...  for the accumulation mode, add aqueous tracked species

                     If ( m .Eq. 2 ) Then

                        aso4tot = aso4tot
     &                          + aero_conc( aso4aqh2o2_idx,m )
     &                          + aero_conc( aso4aqo3_idx,  m )
     &                          + aero_conc( aso4aqfemn_idx,m )
     &                          + aero_conc( aso4aqmhp_idx, m )
     &                          + aero_conc( aso4aqpaa_idx, m )

                     End If

C...  normalize sulfur tracking species

                     If ( aso4tot .Gt. 0.0 ) Then

                        aso4tot = Max( aso4tot,
     &                                 aerospc( aso4_idx )%min_conc( m ) )
                        mscor = Max( aero_conc( aso4_idx, m ),
     &                               aerospc( aso4_idx )%min_conc( m ) )
     &                        / aso4tot

                        aero_conc( aso4gas_idx, m ) =
     &                     Max( aero_conc( aso4gas_idx, m ) * mscor,
     &                          aerospc( aso4gas_idx )%min_conc( m ) )
                        aero_conc( aso4emis_idx, m ) =
     &                     Max( aero_conc( aso4emis_idx, m ) * mscor,
     &                          aerospc( aso4emis_idx )%min_conc( m ) )
                        aero_conc( aso4icbc_idx, m ) =
     &                     Max( aero_conc( aso4icbc_idx, m ) * mscor,
     &                          aerospc( aso4icbc_idx )%min_conc( m ) )

C...  for the accumulation mode, adjust aqueous tracked species

                        If ( m .Eq. 2 ) Then
                           aero_conc( aso4aqh2o2_idx, m ) =
     &                        Max( aero_conc( aso4aqh2o2_idx, m ) * mscor,
     &                             aerospc( aso4aqh2o2_idx )%min_conc( m ) )
                           aero_conc( aso4aqo3_idx, m ) =
     &                        Max( aero_conc( aso4aqo3_idx, m ) * mscor,
     &                             aerospc( aso4aqo3_idx )%min_conc( m ) )
                           aero_conc( aso4aqfemn_idx, m ) =
     &                        Max( aero_conc( aso4aqfemn_idx, m ) * mscor,
     &                             aerospc( aso4aqfemn_idx )%min_conc( m ) )
                           aero_conc( aso4aqmhp_idx, m ) =
     &                        Max( aero_conc( aso4aqmhp_idx, m ) * mscor,
     &                             aerospc( aso4aqmhp_idx )%min_conc( m ) )
                           aero_conc( aso4aqpaa_idx, m ) =
     &                        Max( aero_conc( aso4aqpaa_idx, m ) * mscor,
     &                             aerospc( aso4aqpaa_idx )%min_conc( m ) )
                        End If

                     End If

                     If ( organosulf ) Then

C...  in the current implementation of heterogeneous chemistry,
C...    only the accumulation mode sulfate can be converted to organosulfate

                        If ( m .Eq. 2 ) Then
                           oso4tot = aero_conc( oso4gas_idx, m )
     &                             + aero_conc( oso4emis_idx,m )
     &                             + aero_conc( oso4icbc_idx,m )
     &                             + aero_conc( oso4aqh2o2_idx,m )
     &                             + aero_conc( oso4aqo3_idx,  m )
     &                             + aero_conc( oso4aqfemn_idx,m )
     &                             + aero_conc( oso4aqmhp_idx, m )
     &                             + aero_conc( oso4aqpaa_idx, m )

                           If ( oso4tot .Gt. 0.0 ) Then

                              oso4tot = Max( oso4tot,
     &                                       aerospc( oso4_idx )%min_conc( m ) )
                              mscor = Max( aero_conc( oso4_idx, m ),
     &                                     aerospc( oso4_idx )%min_conc( m ) )
     &                              / oso4tot

                              aero_conc( oso4gas_idx, m ) =
     &                           Max( aero_conc( oso4gas_idx, m ) * mscor,
     &                                aerospc( oso4gas_idx )%min_conc( m ) )
                              aero_conc( oso4emis_idx, m ) =
     &                           Max( aero_conc( oso4emis_idx, m ) * mscor,
     &                                aerospc( oso4emis_idx )%min_conc( m ) )
                              aero_conc( oso4icbc_idx, m ) =
     &                           Max( aero_conc( oso4icbc_idx, m ) * mscor,
     &                                aerospc( oso4icbc_idx )%min_conc( m ) )
                              aero_conc( oso4aqh2o2_idx, m ) =
     &                           Max( aero_conc( oso4aqh2o2_idx, m ) * mscor,
     &                                aerospc( oso4aqh2o2_idx )%min_conc( m ) )
                              aero_conc( oso4aqo3_idx, m ) =
     &                           Max( aero_conc( oso4aqo3_idx, m ) * mscor,
     &                                aerospc( oso4aqo3_idx )%min_conc( m ) )
                              aero_conc( oso4aqfemn_idx, m ) =
     &                           Max( aero_conc( oso4aqfemn_idx, m ) * mscor,
     &                                aerospc( oso4aqfemn_idx )%min_conc( m ) )
                              aero_conc( oso4aqmhp_idx, m ) =
     &                           Max( aero_conc( oso4aqmhp_idx, m ) * mscor,
     &                                aerospc( oso4aqmhp_idx )%min_conc( m ) )
                              aero_conc( oso4aqpaa_idx, m ) =
     &                           Max( aero_conc( oso4aqpaa_idx, m ) * mscor,
     &                                aerospc( oso4aqpaa_idx )%min_conc( m ) )

                           End If
                        End If
                     End If

                  End Do

               End If

C update aerosol species in CGRID

               Call stm_update_aero ( cgrid( c,r,l,: ) )

            End Do
         End Do
      End Do

      Return

      End Subroutine stm_wrap_ae


C-----------------------------------------------------------------------
      Subroutine stm_wrap_gas ( cgrid, jdate, jtime, b4chem )

C  capture changes in aso4 from gas phase chemistry
C  in the current release, ASO4 can be lost in gas chem to form organo-sulfate
C
C     Initial version - 6/5/19 - Shawn Roselle
C-----------------------------------------------------------------------

      Use grid_conf, Only: ncols, nrows, nlays
      Use utilio_defn
      Use aero_data, Only : aso4_idx, aso4aqh2o2_idx, aso4aqo3_idx,
     &                      aso4aqfemn_idx, aso4aqmhp_idx, aso4aqpaa_idx,
     &                      aso4gas_idx, aso4emis_idx, aso4icbc_idx,
     &                      oso4aqh2o2_idx, oso4aqo3_idx, oso4aqfemn_idx,
     &                      oso4aqmhp_idx, oso4aqpaa_idx, oso4_idx,
     &                      oso4gas_idx, oso4emis_idx, oso4icbc_idx,
     &                      aerospc, n_mode, ae6isoa
      Use stm_vars, Only: organosulf

      Implicit None

C Arguments

      Real, Pointer :: cgrid( :,:,:,: )

      Integer, Intent( In ) :: jdate
      Integer, Intent( In ) :: jtime
      Logical, Intent( In ) :: b4chem

C local variables

      Character( 16 ) :: pname = 'STM_WRAP_GAS'
      Character( 96 ) :: xmsg = ' '

      Logical, Save :: firstime = .True.

      Integer c, r, l, m
      Integer allocstat

      Real fso4, omfso4
      Real, Save, Allocatable :: so4b4( :,:,:,: )

C-----------------------------------------------------------------------
C  begin body of subroutine stm_wrap_gas

      If ( firstime ) Then

         Allocate ( so4b4( ncols, nrows, nlays, n_mode ),
     &              Stat = allocstat )
         If ( allocstat .Ne. 0 ) Then
            xmsg = 'Failure allocating so4_b4 '
            Call m3exit( pname, jdate, jtime, xmsg, xstat1 )
         End If

         firstime = .False.

      End If

      if ( .not. organosulf ) Return

C capture the loss of ASO4J to organosulfate
      m = 2  ! in the current implementation of heterogeneous chemistry,
             ! only accumulation mode sulfate can be converted to organosulfate

C save ASO4 concentrations before call to CHEM
      If ( b4chem ) Then

         Do c = 1, ncols
            Do r = 1, nrows
               Do l = 1, nlays

C extract aerosol species from CGRID
                  Call stm_extract_aero ( cgrid( c,r,l,: ) )

                  so4b4( c,r,l,m ) = Max( aero_conc( aso4_idx, m ),
     &                                    aerospc( aso4_idx )%min_conc( m ) )

               End Do
            End Do
         End Do

C scale sulfur tracking species by change in ASO4J following call to CHEM
      Else

         Do c = 1, ncols
            Do r = 1, nrows
               Do l = 1, nlays

C extract aerosol species from CGRID
                  Call stm_extract_aero ( cgrid( c,r,l,: ) )

                  If ( ( aero_conc( aso4_idx, m ) .Ne. so4b4( c,r,l,m ) ) .And.
     &                 ( so4b4( c,r,l,m ) .Gt. 0.0 ) ) Then

C fractional change in ASO4J
                     fso4 = Max( aero_conc( aso4_idx, m ),
     &                           aerospc( aso4_idx )%min_conc( m ) )
     &                    / so4b4( c,r,l,m )
                     omfso4 = 1.0 - fso4

                     aero_conc( oso4_idx, m ) =
     &                  Max( ( aero_conc( oso4_idx, m )
     &                       + ( so4b4( c,r,l,m ) - aero_conc( aso4_idx, m ) ) ),
     &                       aerospc( oso4_idx )%min_conc( m ) )

                     aero_conc( oso4gas_idx, m ) =
     &                  Max( ( aero_conc( oso4gas_idx, m )
     &                       + aero_conc( aso4gas_idx, m ) * omfso4 ),
     &                       aerospc( oso4gas_idx )%min_conc( m ) )
                     aero_conc( oso4emis_idx, m ) =
     &                  Max( ( aero_conc( oso4emis_idx, m )
     &                       + aero_conc( aso4emis_idx, m ) * omfso4 ),
     &                       aerospc( oso4emis_idx )%min_conc( m ) )
                     aero_conc( oso4icbc_idx, m ) =
     &                  Max( ( aero_conc( oso4icbc_idx, m )
     &                       + aero_conc( aso4icbc_idx, m ) * omfso4 ),
     &                       aerospc( oso4icbc_idx )%min_conc( m ) )
                     aero_conc( oso4aqh2o2_idx, m ) =
     &                  Max( ( aero_conc( oso4aqh2o2_idx, m )
     &                       + aero_conc( aso4aqh2o2_idx, m ) * omfso4 ),
     &                       aerospc( oso4aqh2o2_idx )%min_conc( m ) )
                     aero_conc( oso4aqo3_idx, m ) =
     &                  Max( ( aero_conc( oso4aqo3_idx, m )
     &                       + aero_conc( aso4aqo3_idx, m ) * omfso4 ),
     &                       aerospc( oso4aqo3_idx )%min_conc( m ) )
                     aero_conc( oso4aqfemn_idx, m ) =
     &                  Max( ( aero_conc( oso4aqfemn_idx, m )
     &                       + aero_conc( aso4aqfemn_idx, m ) * omfso4 ),
     &                       aerospc( oso4aqfemn_idx )%min_conc( m ) )
                     aero_conc( oso4aqmhp_idx, m ) =
     &                  Max( ( aero_conc( oso4aqmhp_idx, m )
     &                       + aero_conc( aso4aqmhp_idx, m ) * omfso4 ),
     &                       aerospc( oso4aqmhp_idx )%min_conc( m ) )
                     aero_conc( oso4aqpaa_idx, m ) =
     &                  Max( ( aero_conc( oso4aqpaa_idx, m )
     &                       + aero_conc( aso4aqpaa_idx, m ) * omfso4 ),
     &                       aerospc( oso4aqpaa_idx )%min_conc( m ) )

c  reduce tracked inorganic species by amount converted to organosulfate
                     aero_conc( aso4gas_idx, m ) =
     &                  Max( aero_conc( aso4gas_idx, m ) * fso4,
     &                       aerospc( aso4gas_idx )%min_conc( m ) )
                     aero_conc( aso4emis_idx, m ) =
     &                  Max( aero_conc( aso4emis_idx, m ) * fso4,
     &                       aerospc( aso4emis_idx )%min_conc( m ) )
                     aero_conc( aso4icbc_idx, m ) =
     &                  Max( aero_conc( aso4icbc_idx, m ) * fso4,
     &                       aerospc( aso4icbc_idx )%min_conc( m ) )
                     aero_conc( aso4aqh2o2_idx, m ) =
     &                  Max( aero_conc( aso4aqh2o2_idx, m ) * fso4,
     &                       aerospc( aso4aqh2o2_idx )%min_conc( m ) )
                     aero_conc( aso4aqo3_idx, m ) =
     &                  Max( aero_conc( aso4aqo3_idx, m ) * fso4,
     &                       aerospc( aso4aqo3_idx )%min_conc( m ) )
                     aero_conc( aso4aqfemn_idx, m ) =
     &                  Max( aero_conc( aso4aqfemn_idx, m ) * fso4,
     &                       aerospc( aso4aqfemn_idx )%min_conc( m ) )
                     aero_conc( aso4aqmhp_idx, m ) =
     &                  Max( aero_conc( aso4aqmhp_idx, m ) * fso4,
     &                       aerospc( aso4aqmhp_idx )%min_conc( m ) )
                     aero_conc( aso4aqpaa_idx, m ) =
     &                  Max( aero_conc( aso4aqpaa_idx, m ) * fso4,
     &                       aerospc( aso4aqpaa_idx )%min_conc( m ) )
                  End If

C update aerosol species in CGRID

                  Call stm_update_aero ( cgrid( c,r,l,: ) )

               End Do
            End Do
         End Do

      End If
      Return

      End Subroutine stm_wrap_gas

C-----------------------------------------------------------------------
      Subroutine stm_extract_aero( conc )

C  Extracts aerosol data into the aero_conc array
C  The original idea is that the data for conc comes from CGRID

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     6/25/19 streamlined version of extract_aero borrowed from AERO_DATA
C-----------------------------------------------------------------------

      Use aero_data, Only : n_aerospc, aerospc_map, n_mode

      Implicit None

C Arguments:
      Real,    Intent( In ) :: conc( : )

C Local Variables:
      Logical, Save :: firstime = .True.

      Integer m, n, spc

      If ( .Not. stm_mapped ) Then
         Call stm_map_aero()
      End If

C Copy grid cell concentrations of aero species to aero_conc
      aero_conc = 0.0
      Do m = 1, n_mode
         Do spc = 1, n_aerospc
            n = aerospc_map( spc,m )
            If ( n .Ne. 0 ) Then
               aero_conc( spc,m ) = conc( n )   ! [ug/m^3]
            End If
         End Do
      End Do

      Return
      End Subroutine stm_extract_aero

C-----------------------------------------------------------------------
      Subroutine stm_update_aero( conc )

C  Updates conc from the aero_conc array.
C  The original idea is that the data in conc updates CGRID
C  stm_update_aero now also saves the updated surface area back to CGRID as
C  well.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     6/25/19 streamlined version of update_aero borrowed from AERO_DATA
C-----------------------------------------------------------------------

      Use aero_data, Only : n_aerospc, aerospc_map, n_mode

      Use utilio_defn

      Implicit None

C Arguments:
      Real, Intent( Out ) :: conc( : )

C Local variables:

      Character( 16 ) :: pname = 'STM_WRAP_GAS'
      Character( 80 ) :: xmsg

      Integer m, n, spc

      If ( .Not. stm_mapped ) Then
         xmsg = 'CGRID Species has not been mapped in stm_update_aero'
         Call m3exit( pname, 0, 0, xmsg, xstat3 )
      End If

C Copy aero_conc back to grid cell concentrations

      Do m = 1, n_mode
         Do spc = 1, n_aerospc
            n = aerospc_map( spc,m )
            If ( n .Ne. 0 ) Then
                 conc( n ) = aero_conc( spc,m )
            End If
         End Do
      End Do

      Return
      End Subroutine stm_update_aero

C-----------------------------------------------------------------------
      Subroutine stm_map_aero()

C  Defines aerosol mapping from CGRID for species

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     6/25/19 streamlined version of map_aero borrowed from AERO_DATA
C-----------------------------------------------------------------------

      Use aero_data, Only : n_aerospc, map_aero, n_mode

      Implicit None

      If ( stm_mapped ) Return

C...map the aerosol species using map_aero in the AERO_DATA module
      Call map_aero()

      Allocate ( aero_conc  ( n_aerospc, n_mode ) )

      stm_mapped = .True.

      Return
      End Subroutine stm_map_aero

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      End Module stm_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE GETRXNSUM

C-----------------------------------------------------------------------
 
C FUNCTION: To process the DEFINE RXNSUM command 
 
C PRECONDITIONS: None
  
C KEY SUBROUTINES/FUNCTIONS CALLED: GETCHR
C                                   GETWORD
C                                   GETCOEF
C                                   GETLABEL
 
C REVISION HISTORY:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI's M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
 
      USE UTILIO_DEFN
      USE PA_GLOBAL     ! Mech data used 
      USE PA_VARS
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None

C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables:
      INTEGER TERMNUM   ! Counter for number of terms in sum
      
C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Get assigned name and check for = sign delimiter
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      NRXSUMS = NRXSUMS + 1
      IF ( NRXSUMS .GT. MAXRXNSUM )  THEN
         WRITE( MSG, 94000 )  
         CALL M3MESG( MSG ) 
         WRITE( MSG, 94500 )  LINNUM,  INBUF
         CALL M3MESG( MSG ) 
         WRITE( MSG, 94020 )  MAXRXNSUM
         CALL M3MESG( MSG ) 
         CALL M3EXIT( 'GETRXNSUM',  IZERO,  IZERO, ' ', XSTAT2 ) 
      END IF

      TERMNUM = 0
      CALL GETWORD
      RXSUMNAME( NRXSUMS )  = WORD

      IF ( CHR .NE. '=' )  THEN
         WRITE( MSG, 94040 )  
         CALL M3MESG( MSG ) 
         WRITE( MSG, 94500 )  LINNUM,  INBUF
         CALL M3MESG( MSG ) 
         WRITE( MSG, 94520 )  CHR
         CALL M3MESG( MSG ) 
         CALL M3EXIT( 'GETRXNSUM',  IZERO,  IZERO, ' ', XSTAT2 ) 
      ELSE
         CALL GETCHR
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Top of loop for getting all terms and their coefficients
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
20    CONTINUE
      TERMNUM = TERMNUM + 1

      IF ( TERMNUM .GT. MAXRXTERMS )  THEN
         WRITE( MSG, 94060 )  
         CALL M3MESG( MSG ) 
         WRITE( MSG, 94500 )  LINNUM,  INBUF
         CALL M3MESG( MSG ) 
         WRITE( MSG, 94080 )  MAXRXTERMS
         CALL M3MESG( MSG ) 
         CALL M3EXIT( 'GETRXNSUM',  IZERO,  IZERO, ' ', XSTAT2 ) 
      END IF

c..Get coefficient for the reaction
      CALL GETCOEF( RXNSC( NRXSUMS, TERMNUM )  ) 

c..Get the reaction label 
      IF ( CHR .EQ. '<' )  THEN
         CALL GETLABEL
         RXSUMLBL( NRXSUMS, TERMNUM )  = LABEL
      ELSE
         WRITE( MSG, 94100 )  
         CALL M3MESG( MSG ) 
         WRITE( MSG, 94500 )  LINNUM,  INBUF
         CALL M3MESG( MSG ) 
         WRITE( MSG, 94520 )  CHR
         CALL M3MESG( MSG ) 
         CALL M3EXIT( 'GETRXNSUM',  IZERO,  IZERO, ' ', XSTAT2 ) 
      END IF

c..check for more terms or end delimiter         
      IF ( CHR .EQ. '+' .OR. CHR .EQ. '-' )  THEN
         GO TO 20
      ELSE IF ( CHR .EQ. ';' )  THEN
         NRXTERMS( NRXSUMS )  = TERMNUM
         CALL GETCHR
         RETURN
      ELSE
         WRITE( MSG, 94120 )  
         CALL M3MESG( MSG ) 
         WRITE( MSG, 94500 )  LINNUM,  INBUF
         CALL M3MESG( MSG ) 
         WRITE( MSG, 94520 )  CHR
         CALL M3MESG( MSG ) 
         CALL M3EXIT( 'GETRXNSUM',  IZERO,  IZERO, ' ', XSTAT2 ) 
      END IF
      
C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( 'ERROR: Maximum number of RXNSUMs exceeded' ) 
94020 FORMAT( '       Modify PARAMETER ( MAXRXNSUM =', I3, ' )', 
     &              ' or decrease the number of RXNSUMs' ) 
94040 FORMAT( 'ERROR: Equal sign expected after RXNSUM name' ) 
94060 FORMAT( 'ERROR: Maximum number of terms in RXNSUM exceeded' ) 
94080 FORMAT( '       Modify PARAMETER ( MAXRXTERMS =', I3, ' )', 
     &              ' or decrease the number of terms in RXNSUM' ) 
94100 FORMAT( 'ERROR: Expecting a reaction label starting with a <' ) 
94120 FORMAT( 'ERROR: Expecting a + - or ; after a reaction label' ) 

94500 FORMAT( '       Line No. ', I4, ':', A ) 
94520 FORMAT( '       Character found:', A ) 

      END SUBROUTINE GETRXNSUM

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WR_CONC ( JDATE, JTIME, TSTEP )

C Revision History:
C   10/13/99 David Wong at LM
C      -- Called from driver, where CGRID is a pointer (subset) of PCGRID.
C         Necessary, to keep from referencing parts of PCGRID that don't
C         belong to CGRID.
C    1/31/2000 Jeff Young
C      -- f90 memory mgmt
C   Jeff - Dec 00 - move CGRID_MAP into f90 module
C   Jeff - Feb 01 - assumed shape arrays
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; DBUFF for WRITE3
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   30 May 05 J.Young: optional save derived vert. vel. to conc file
C   29 Aug 06 J.Young: in conjunction with state CGRID file
C   30 Jan 10 David Wong: modified the code to write one species at a time
C                         in case ALLVAR3 cannot deal with large CONC size
C   14 Sep 10 J.Young: fix ALLVAR3 bug in writing W_VEL
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: - let non I/O PEs open CTM_CONC_1 for read only
C   12 Aug 15 D.Wong: - Replaced MYPE with IO_PE_INCLUSIVE for parallel
C                       I/O implementation
C                     - Added code to allow non IO processor to open
C                       CTM_CONC_1
C   01 Feb 19 D.Wong: - Implemented centralized I/O approach
C   Sept 19 F. Sidi: Replaced L_CONC_WVEL(depreciated) with W_VEL 
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE STD_CONC              ! standard CONC
      USE WVEL_DEFN             ! derived vertical velocity component
      USE UTILIO_DEFN
      USE ASX_DATA_MOD, ONLY : MET_DATA
      USE CENTRALIZED_IO_MODULE

      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

      INTEGER      JDATE        ! current model date, coded YYYYDDD
      INTEGER      JTIME        ! current model time, coded HHMMSS
      INTEGER      TSTEP        ! output timestep (HHMMSS)

C Local variables:
      CHARACTER( 16 ) :: PNAME = 'WR_CONC'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER      ALLOCSTAT

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      INTEGER      C, R, K, L, V, VAR, SPC   ! loop induction variables

      CHARACTER( 16 ), ALLOCATABLE, SAVE :: VNAME( : )
      INTEGER, SAVE :: NVARS

C-----------------------------------------------------------------------

#ifndef mpas
      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

C open conc file for update

         IF ( .NOT. IO_PE_INCLUSIVE ) THEN
            IF ( .NOT. OPEN3( CTM_CONC_1, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // CTM_CONC_1 // ' file for update'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

         IF ( .NOT. DESC3( CTM_CONC_1 ) ) THEN
            XMSG = 'Could not get file description from ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         ! Retrieve number and values of variable names
         NVARS = NVARS3D
         ALLOCATE ( VNAME( NVARS ), STAT=ALLOCSTAT )
         VNAME = VNAME3D( 1:NVARS )

      END IF   ! firstime

      VAR = 0

      ! Write Gas-Phase Species to CONC File
      DO SPC = 1, N_C_GC_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( CTM_CONC_1, C_GC_SPC( SPC ),
     &      JDATE, JTIME, SGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( C_GC_SPC( SPC ) )
     &           // ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO
 
      ! Write Aerosol Species Concentrations to CONC File
      DO SPC = 1, N_C_AE_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( CTM_CONC_1, C_AE_SPC( SPC ),
     &      JDATE, JTIME, SGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( C_AE_SPC( SPC ) )
     &           // ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO

      ! Write Nonreactive Species Concentrations to CONC File
      DO SPC = 1, N_C_NR_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( CTM_CONC_1, C_NR_SPC( SPC ),
     &      JDATE, JTIME, SGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( C_NR_SPC( SPC ) )
     &           // ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO

      ! Write Tracer Species Concentrations to CONC File
      DO SPC = 1, N_C_TR_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( CTM_CONC_1, C_TR_SPC( SPC ),
     &      JDATE, JTIME, SGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( C_TR_SPC( SPC ) )
     &           // ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO

      ! Write Vertical Velocity to Output CONC file
      IF ( W_VEL ) THEN
         IF ( .NOT. WRITE3( CTM_CONC_1, 'W_VEL',
     &      JDATE, JTIME, WVEL( :,:,CONC_BLEV:CONC_ELEV ) ) ) THEN
            XMSG = 'Could not write W_VEL to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF   ! W_VEL

      ! Write Relative Humidity to Output CONC file
      IF ( L_CONC_RH ) THEN
      IF ( .NOT. WRITE3( CTM_CONC_1, 'RH',
     &     JDATE, JTIME, MET_DATA%RH( :,:,CONC_BLEV:CONC_ELEV ) ) ) THEN
         XMSG = 'Could not write RH to ' // CTM_CONC_1
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
      END IF

      ! Write Temperature to Output CONC file
      IF ( L_CONC_TA ) THEN
      IF ( .NOT. WRITE3( CTM_CONC_1, 'TA',
     &     JDATE, JTIME, MET_DATA%TA( :,:,CONC_BLEV:CONC_ELEV ) ) ) THEN
         XMSG = 'Could not write Temperature to ' // CTM_CONC_1
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
      END IF

      ! Write Pressure to Output CONC file
      IF ( L_CONC_PRES ) THEN
      IF ( .NOT. WRITE3( CTM_CONC_1, 'PRES',
     &     JDATE, JTIME, MET_DATA%PRES( :,:,CONC_BLEV:CONC_ELEV ) ) ) THEN
         XMSG = 'Could not write Pressure to ' // CTM_CONC_1
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
      END IF

! Write Summary Message for Output Procedure
      WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &      'Timestep written to', CTM_CONC_1,
     &      'for date and time', JDATE, JTIME
#endif

      RETURN 
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE EDDYX ( EDDYV )

C--------------------------------------------------------------------------
C---- Eddy diffusivity (Kz) computed according to 2 different models:
C----   1- Boundary Layer scaling based on Hostlag and Boville (1993)
C----      Kz = k ust z(1-z/h)2 / phih
C       2- Local scaling based on local Richardson # and vertical shear
C          similar to Liu and Carroll (1996)
C
C  Revision History:
C  JEP        4/00 - CCTM implimentation from MM5
C  JEP        4/06 - Updated for ACM2
C  TLO       10/09 - Allow read of C-staggered UWINDC and VWINDC from
C                    MET_DOT_3D, and corrected algorithm that computes
C                    component-wise shear so that B-staggered winds
C                    will be properly used.  Removed map-scale factor
C                    from wind shear calculation.
C  SJR       02/11 - replaced I/O API include files with UTILIO_DEFN
C  YOJ       05/13 - access met data from VDIFF_MET module
C  JOB       11/14 - Updated for the ASX_DATA_MOD shared data module which 
C                    included variables in the VDIFF_MET module.
C  HF        07/15 - Included pleim5 formulation. 
C  David Wong 02/19 - removed all MY_N clauses
C--------------------------------------------------------------------------

      USE GRID_CONF             ! horizontal domain specifications
      USE ASX_DATA_MOD          ! Includes CONST
      USE UTILIO_DEFN

      IMPLICIT NONE

C Includes:

C Arguments:
      REAL,   INTENT( OUT ) :: EDDYV ( :,:,: ) ! eddy diffusivity (m**2/s)

C Parameters:

      REAL, PARAMETER :: RLAM   = 80.0 ! asymptotic mixing length (m)
      REAL, PARAMETER :: RIC    = 0.25 ! critical Richardson #
      REAL, PARAMETER :: QUARTER = 0.25
      REAL, PARAMETER :: SIXTEENTH = QUARTER * QUARTER  ! 1/16

C External Functions: None

C File Variables:
      REAL    KZM                            ! local KZMIN

C Local variables:
      INTEGER MDATE, MTIME, STEP
      INTEGER C, R, L, V

      REAL    DZL                     ! Z(L+1)-Z(L)
      REAL    WW2                     ! (wind speed)**2
      REAL    WS2                     ! (wind shear)**2
      REAL    RIB                     ! Bulk Richardson Number
      REAL    ZOL
      REAL    ZFUNC, HPBL 
      REAL    EDDV                    ! local EDDYV
      REAL    FH

      INTEGER MCOL                   ! these don't need to be initialized
      INTEGER MROW
      INTEGER MLVL
      REAL    MTH1                   ! pot. temp. in layer L
      REAL    MTH2                   ! pot. temp. in layer L+1
      REAL    MRIB                   ! bulk Richardson Number
      REAL    MWS                    ! wind shear (/sec)
      REAL    MEDDYV                 ! eddy diffusivity (m**2/sec)

      REAL    QMEAN, TMEAN
      REAL    XLV, ALPH, CHI
      REAL    CPAIR, ZK, SQL, PHIH
      REAL    PHIM
      REAL    WT, ZSOL
      REAL    EDYZ
      REAL    ZFL                    ! local ZF

      CHARACTER( 16 ) :: PNAME = 'EDDYX'
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: UNITSCK
      CHARACTER( 96 ) :: XMSG = ' '

C-----------------------------------------------------------------------

      MEDDYV = 0.0

      DO 233 L = 1, NLAYS-1
      DO 222 R = 1, NROWS
      DO 211 C = 1, NCOLS
         HPBL = MAX( Met_Data%PBL( C,R ), 20.0 )
         ZFL = Met_Data%ZF( C,R,L )
         KZM = Met_Data%KZMIN( C,R,L )

         ZOL = ZFL * Met_Data%MOLI( C,R )
         IF ( ZFL .LT. HPBL ) THEN
            IF ( ZOL .LT. 0.0 ) THEN
               IF ( ZFL .LT. 0.1 * HPBL ) THEN
                  PHIH = 1.0 / SQRT( 1.0 - GAMAH * ZOL )
               ELSE
                  ZSOL = 0.1 * HPBL * Met_Data%MOLI( C,R )
                  PHIH = 1.0 / SQRT( 1.0 - GAMAH * ZSOL )
               END IF
            ELSE IF ( ZOL .LT. 1.0 ) THEN
               PHIH = 1.0 + BETAH * ZOL
            ELSE
               PHIH = BETAH + ZOL
            END IF
            WT = Met_Data%USTAR( C,R ) / PHIH
            ZFUNC = 1.0 - ZFL / HPBL
            ZFUNC = ZFL * ZFUNC * ZFUNC
            EDYZ = KARMAN * WT * ZFUNC
            EDYZ = MAX( EDYZ, KZM )
         ELSE
            EDYZ = 0.0
         END IF

         IF ( CSTAGUV ) THEN  ! u- and v-component winds on C-stagger
           WW2 = QUARTER                  ! component-wise wind shear
     &         * ( ( Met_Data%UWIND( C+1,R,  L+1 ) - Met_Data%UWIND( C+1,R  ,L  )
     &             + Met_Data%UWIND( C,  R,  L+1 ) - Met_Data%UWIND( C,  R  ,L  ) ) ** 2
     &         +   ( Met_Data%VWIND( C,  R+1,L+1 ) - Met_Data%VWIND( C,  R+1,L )
     &             + Met_Data%VWIND( C,  R,  L+1 ) - Met_Data%VWIND( C,  R,  L  ) ) ** 2 )
         ELSE  ! u- and v-component winds on B-stagger
           WW2 = SIXTEENTH                ! component-wise wind shear
     &         * ( ( Met_Data%UWIND( C,  R,  L+1 ) - Met_Data%UWIND( C,  R  ,L  )
     &             + Met_Data%UWIND( C+1,R,  L+1 ) - Met_Data%UWIND( C+1,R  ,L  )
     &             + Met_Data%UWIND( C,  R+1,L+1 ) - Met_Data%UWIND( C,  R+1,L  )
     &             + Met_Data%UWIND( C+1,R+1,L+1 ) - Met_Data%UWIND( C+1,R+1,L  ) ) ** 2
     &          +  ( Met_Data%VWIND( C,  R,  L+1 ) - Met_Data%VWIND( C,  R  ,L  )
     &             + Met_Data%VWIND( C+1,R,  L+1 ) - Met_Data%VWIND( C+1,R  ,L  )
     &             + Met_Data%VWIND( C,  R+1,L+1 ) - Met_Data%VWIND( C,  R+1,L  )
     &             + Met_Data%VWIND( C+1,R+1,L+1 ) - Met_Data%VWIND( C+1,R+1,L  ) ) ** 2 )
         END IF

         DZL = Met_Data%ZH( C,R,L+1 ) - Met_Data%ZH( C,R,L )
         WS2 = WW2 / ( DZL * DZL ) + 1.0E-9

         RIB = 2.0 * GRAV * ( Met_Data%THETAV( C,R,L+1 ) - Met_Data%THETAV( C,R,L ) )
     &      / ( DZL * WS2 * ( Met_Data%THETAV( C,R,L+1 ) + Met_Data%THETAV( C,R,L ) ) )

C-- Adjustment to vert diff in Moist air from HIRPBL

         IF ( ( Met_Data%QC( C,R,L ) .GT. 0.01E-3 ) .OR.
     &        ( Met_Data%QC( C,R,L+1 ) .GT. 0.01E-3 ) ) THEN
            QMEAN = 0.5 * ( Met_Data%QV( C,R,L ) + Met_Data%QV( C,R,L+1 ) )
            TMEAN = 0.5 * ( Met_Data%TA( C,R,L ) + Met_Data%TA( C,R,L+1 ) )
            XLV = ( 2.501 - 0.00237 * ( TMEAN - 273.15 ) ) * 1.0E6
            ALPH = XLV * QMEAN / RDGAS / TMEAN
            CPAIR = 1004.67 * ( 1.0 + 0.84 * Met_Data%QV( C,R,L ) )   ! J/(K KG)
            CHI = XLV * XLV * QMEAN / ( CPAIR * RWVAP * TMEAN * TMEAN )
            RIB = ( 1.0 + ALPH )
     &          * ( RIB - GRAV * GRAV / ( WS2 * TMEAN * CPAIR )
     &          * ( ( CHI - ALPH ) / ( 1.0 + CHI ) ) )
         END IF

         ZK = 0.4 * ZFL
         SQL = ZK * RLAM / ( RLAM + ZK )
         SQL = SQL * SQL

         IF ( RIB .GE. 0.0 ) THEN
!           FH = 1.0   ! pleim5
!    &         / ( 1.0 + 10.0 * RIB + 50.0 * RIB ** 2 + 5000.0 * RIB ** 4 ) + 0.0012
            FH =  1.0 + RIB * ( 10.0 + RIB * ( 50.0 + 5000.0 * RIB * RIB ) )
            FH = 0.0012 + 1.0 / FH  ! pleim5

            EDDV = KZM + SQRT( WS2 ) * FH * SQL
         ELSE
            EDDV = KZM + SQRT( WS2 * ( 1.0 - 25.0 * RIB ) ) * SQL
         END IF

         IF ( ZFL .LT. HPBL .AND. EDYZ .GT. EDDV ) THEN
            EDDV = EDYZ
         END IF
         EDDV = MIN( 1000.0, EDDV )

         IF ( EDDV .GT. MEDDYV ) THEN
C Capture the col, row, lvl, and EDDYV for the global min DT
            MCOL = C
            MROW = R
            MLVL = L
            MEDDYV = EDDV
            MTH1 = Met_Data%THETAV( C,R,L )
            MTH2 = Met_Data%THETAV( C,R,L+1 )
            MRIB = RIB
            MWS  = SQRT ( WS2 )
         END IF

         EDDYV( C,R,L ) = EDDV
         Met_Data%KZ( C,R,L ) = EDDV

211   CONTINUE       !  end loop on columns
222   CONTINUE       !  end loop on rows
233   CONTINUE       !  end loop on levels

      !WRITE( LOGDEV,* ) ' '
      !WRITE( LOGDEV,1001 ) MEDDYV, MCOL, MROW, MLVL
1001  FORMAT(/ 5X, 'Maximum eddy diffusivity of:', 1PG13.5,
     &         1X, '(m**2/sec)'
     &       / 5X, 'at col, row, layer:', I4, 2(', ', I3) )
      !WRITE( LOGDEV,1003 ) MWS, MRIB, MTH1, MTH2
1003  FORMAT(  5X, 'corresponding to a free tropospheric wind shear of:',
     &         1PG13.5,  1X, '(/sec),'
     &        /28X, 'a bulk Richardson Number of:', 1PG13.5, ','
     &        / 5X, 'and pot. temps. in layer and layer+1:', 2(1PG13.5) )
      WRITE( LOGDEV,* ) '    '

      DO R = 1, NROWS
         DO C = 1, NCOLS
            EDDYV( C,R,NLAYS ) = 0.0
         END DO
      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AQ_MAP ( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                    CTHK1, AIRM, PRATE1, TAUCLD, POLC, CEND,
     &                    REMOV, REMOVAC, ALFA0, ALFA2, ALFA3, COSZ )

C-----------------------------------------------------------------------
C  DESCRIPTION:  This is an interface processor between the cloud dynamics
C     module(s) and the aqueous chemistry module.  It uses indices to
C     map species from their order in the array POLC, CEND, REMOV to
C     the species that are expected for AQCHEM, ie GAS and AEROSOL.
 
C  Revision History:
C      No   Date   Who  What
C      -- -------- ---  -----------------------------------------
C       0 01/15/98 sjr  created program
C       1 02/13/98 sjr  modified/generalized the mapping procedure
C         Dec 00   Jeff move CGRID_MAP into f90 module
C       3 06/07/05 sjr  added logic for coarse sulfate
C       4 04/11/08 jtk  added logic for coarse ammonium
C       5 10/10/10 yoj  update to use aero_reeng by Steve Howard, Prakash Bhave,
C                       Jeff Young, Sergey Napelenok, and Shawn Roselle
C       6 03/01/11 sjr  replaced I/O API include files with UTILIO_DEFN;
C       7 07/01/01 gs   calculate zenith angle to determine daytime and nightime 
C                       needed for sulfur oxidation via metal catalysis
C       8 09/10/11 wth  adapted for multiple pollutant model, i.e., Gas phase mercury 
C                       PM mercury and tracer species
C       07 Jul 14  wth: replaced mechanism include file(s) with fortran module
C       01 Feb 19 D.Wong: replaced run time dynamic arrays with allocatable arrays
C       30 Dec 19 S.Napelenok: ddm-3d implementation for v 5.3.1
 
C  Called by:  RADMCLD and RESCLD
 
C  Calls the following subroutines:  AQCHEM
 
C  ARGUMENTS    TYPE      I/O       DESCRIPTION
C  ---------   -------  ------  --------------------------------
C    JDATE     integer   input  current model julian date (yyyyddd)
C    JTIME     integer   input  current model time (hhmmss)
C    WTBAR      real     input  avg total water content (kg/m3)
C    WCBAR      real     input  avg liquid water content (kg/m3)
C    TBARC      real     input  avg cloud temperature (K)
C    PBARC      real     input  avg cloud pressure (Pa)
C    CTHK1      real     input  cloud thickness (m)
C    AIRM       real     input  total air mass (moles/m2) in cloudy air
C    PRATE1     real     input  precipitation rate (mm/hr)
C    TAUCLD     real     input  cloud lifetime (s)
C    POLC       real     input  ave vert conc incloud (moles sp/ mole air)
C    CEND       real    output  ending incloud conc (moles/mole)
C    REMOV      real    output  moles/m2 or mm*mol/lit scavenged
C    REMOVAC    real    output  variable storing H+ deposition
C    ALFA0      real     input  scav coef for aitken aerosol number
C    ALFA2      real     input  scav coef for aitken aerosol surface area
C    ALFA3      real     input  scav coef for aitken aerosol mass
C    COSZ       real     input cosine solar zenith angle
C-----------------------------------------------------------------------

      USE CGRID_SPCS     ! CGRID mechanism species
      USE AERO_DATA      ! aerosol shared parameters
      USE AQ_DATA        ! aqueous chemistry shared parameters
      USE UTILIO_DEFN
#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, S_POLC, S_CEND, S_REMOV,
     &                       S_REMOVAC, S_HPWDEP, S_GAS, S_GASWDEP,
     &                       S_AEROSOL, S_AERWDEP
#endif 
      USE CONST, ONLY  : DPI
      IMPLICIT NONE
      
      CHARACTER( 120 ) :: XMSG = ' '    ! Exit status message

C Parameters:

      INTEGER, SAVE :: MXSPCS   ! Number of species in CGRID

      REAL, PARAMETER :: ONETHIRD  = 1.0 / 3.0
      REAL, PARAMETER :: TWOTHIRDS = 2.0 / 3.0

C Arguments:

      INTEGER, INTENT( IN )    :: JDATE     ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )    :: JTIME     ! current model time, coded HHMMSS

      REAL,    INTENT( IN )    :: WTBAR     ! total wat cont (kg/m2) int. thru cld
      REAL,    INTENT( IN )    :: WCBAR     ! liq water content of cloud (kg/m3)
      REAL,    INTENT( IN )    :: TBARC     ! mean cloud temp (K)
      REAL,    INTENT( IN )    :: PBARC     ! mean cloud pressure (Pa)
      REAL,    INTENT( IN )    :: CTHK1     ! aq chem calc cloud thickness
      REAL,    INTENT( IN )    :: AIRM      ! total air mass (moles/m2) in cloudy air
      REAL,    INTENT( IN )    :: PRATE1    ! storm rainfall rate (mm/hr)
      REAL,    INTENT( IN )    :: TAUCLD    ! cloud lifetime
      REAL,    INTENT( IN )    :: POLC ( : )  ! avg vert conc incloud (moles/mole)
      REAL,    INTENT( INOUT ) :: CEND ( : )  ! ending incloud conc (moles/mole)
      REAL,    INTENT( INOUT ) :: REMOV( : )  ! moles/m2 or mm*mol/lit scavenged
      REAL,    INTENT( INOUT ) :: REMOVAC   ! variable storing H+ deposition
      REAL,    INTENT( IN )    :: ALFA0     ! scav coef for aitken aerosol number
      REAL,    INTENT( IN )    :: ALFA2     ! scav coef for aitken aerosol sfc area
      REAL,    INTENT( IN )    :: ALFA3     ! scav coef for aitken aerosol mass
      REAL,    INTENT( IN )    :: COSZ      ! cosine solar zenith angle

C Local Variables (scalars):

      LOGICAL, SAVE :: FIRSTIME = .TRUE.      ! flag for first pass thru

      CHARACTER(16), SAVE :: PNAME = 'AQ_MAP' ! program name

      INTEGER       IAER                ! aerosol loop counter
      INTEGER       IM                  ! aerosol mode loop counter
      INTEGER       IGAS                ! gas loop counter
      INTEGER       ISRG                ! surrogate loop counter
      INTEGER       PNTR                ! relative pointer variable
      INTEGER       SPC, ISPC, IAQ, JSPC! species loop counters
      INTEGER ::    STAT

      REAL( 8 )  :: BETASO4
      REAL       :: EALFA2T                ! EXP( -ALFA2 * TAUCLD )
      REAL( 8 )  :: M3NEW( N_MODE )        ! modal mass at time t
      REAL( 8 )  :: M3OLD( N_MODE )        ! modal mass at time 0
      REAL( 8 )  :: Dens_wmean_old( N_MODE ) ! concentration weighted molecular weight g/mol
      REAL( 8 )  :: Dens_wmean_new( N_MODE ) ! concentration weighted molecular weight g/mol

      REAL       :: HPWDEP                        ! hydrogen wet dep (mm mol/liter)
      REAL( 8 ), ALLOCATABLE, SAVE :: GAS    ( : )    ! gas phase conc (mol/mol)
      REAL( 8 ), ALLOCATABLE, SAVE :: GASWDEP( : )    ! gas phase wet dep array (mm mol/liter)
      REAL( 8 ), ALLOCATABLE, SAVE :: AEROSOL( :, :)  ! aerosol conc (mol/mol)
      REAL( 8 ), ALLOCATABLE, SAVE :: AERWDEP( :, :)  ! aerosol wet dep array (mm mol/liter)
      REAL( 8 ), ALLOCATABLE, SAVE :: WSRGAQ( : )     ! weights of each CGRID species in 
                                                      !   its surrogate

C External Functions:

      INTEGER, EXTERNAL :: INDEXN           ! external func to get species pointers


      INTERFACE
        SUBROUTINE AQCHEM ( JDATE, JTIME, TEMP, PRES_PA, TAUCLD, PRCRATE,
     &                      WCAVG, WTAVG, AIRM, ALFA0, ALFA2, ALFA3, GAS,
     &                      AEROSOL, GASWDEP, AERWDEP, HPWDEP, BETASO4, COSZ)
           INTEGER,   INTENT( IN )  :: JDATE  ! current model date, coded YYYYDDD
           INTEGER,   INTENT( IN )  :: JTIME  ! current model time, coded HHMMSS
           REAL,      INTENT( IN )  :: AIRM      ! total air mass in cloudy layers (mol/m2)
           REAL,      INTENT( IN )  :: ALFA0     ! scav coef for aitken aerosol number
           REAL,      INTENT( IN )  :: ALFA2     ! scav coef for aitken aerosol sfc area
           REAL,      INTENT( IN )  :: ALFA3     ! scav coef for aitken aerosol mass
           REAL,      INTENT( OUT ) :: HPWDEP    ! hydrogen wet deposition (mm mol/liter)
           REAL( 8 ), INTENT( OUT ) :: BETASO4  
           REAL,      INTENT( IN )  :: PRCRATE   ! precip rate (mm/hr)
           REAL,      INTENT( IN )  :: PRES_PA   ! pressure (Pa)
           REAL,      INTENT( IN )  :: TAUCLD    ! timestep for cloud (s)
           REAL,      INTENT( IN )  :: TEMP      ! temperature (K)
           REAL,      INTENT( IN )  :: WCAVG     ! liquid water content (kg/m3)
           REAL,      INTENT( IN )  :: WTAVG     ! total water content (kg/m3)
           REAL( 8 ), INTENT( INOUT ) :: GAS    ( : )   ! gas phase concentrations (mol/molV)
           REAL( 8 ), INTENT( INOUT ) :: AEROSOL( :,: ) ! aerosol concentrations (mol/molV)
           REAL( 8 ), INTENT( INOUT ) :: GASWDEP( : )   ! gas phase wet deposition array (mm mol/liter)
           REAL( 8 ), INTENT( INOUT ) :: AERWDEP( :,: ) ! aerosol wet deposition array (mm mol/liter)
	       REAL,      INTENT( IN )  :: COSZ      ! cosine solar zenith angle
        END SUBROUTINE AQCHEM
      END INTERFACE      

C-----------------------------------------------------------------------

C...Initialization
C...  event-statistics variables.

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

        CALL AQ_DATA_INIT()  
	
        ALLOCATE ( GAS    ( N_AQ_GAS ),
     &             GASWDEP( N_AQ_GAS ),
     &             AEROSOL( N_AQ_AER, N_MODE),
     &             AERWDEP( N_AQ_AER, N_MODE),
     &             WSRGAQ ( N_CGRID_SPC ),
     &             STAT = STAT)
        IF (STAT .NE. 0) THEN
           XMSG = 'Memory allocation failure'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

#ifdef sens
C... Allocate sensitivity arrays
        ALLOCATE ( S_HPWDEP( NPMAX ), STAT = STAT )
        IF ( STAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_HPWDEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE ( S_GAS( NPMAX,N_AQ_GAS ), S_GASWDEP( NPMAX,N_AQ_GAS ), STAT = STAT )
        IF ( STAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_GAS or S_GASWDEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE ( S_AEROSOL( NPMAX,N_AQ_AER,N_MODE ), S_AERWDEP( NPMAX,N_AQ_AER,N_MODE ), STAT = STAT )
        IF ( STAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_AEROSOL or S_AERWDEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

#endif

      END IF

C...for subsequent calls, check to make sure some surrogates were
C...  specified, otherwise there is no need to perform aqueous chemistry

      IF ( N_SPC_AQ .EQ. 0 ) RETURN

C...Zero out concentrations

      GAS     = 0.0D0
      GASWDEP = 0.0D0
      AEROSOL = 0.0D0
      AERWDEP = 0.0D0
      WSRGAQ  = 0.0D0
      
      ! Initialize Gas and Aerosol Vectors at Background 
      DO IGAS = 1,N_AQ_GAS
        IF ( N_AQSRG_GAS( IGAS ) .EQ. 0 ) 
     &     GAS( IGAS ) = REAL( SRGGAS( IGAS )%BACKGND, 8 ) * 1.0D-6 ! [mol/molV]
      END DO

      DO IAER = 1,N_AQ_AER
        DO IM = 1,N_MODE
          IF ( N_AQSRG_AER( IAER, IM ) .EQ. 0 ) THEN
            IF ( IAER .EQ. LNUM .OR. IAER .EQ. LSRF ) THEN
               AEROSOL( IAER,: ) = REAL( SRGAER( IAER )%BACKGND 
     &                                        * CTHK1 / AIRM, 8 ) ! [mol/molV]
            ELSE
               AEROSOL( IAER,: ) = REAL( SRGAER( IAER )%BACKGND * 1.0E-6 * CTHK1, 8 )
     &                           / REAL( SRGAER( IAER )%MOLWT * AIRM, 8 )  ! [molmolV]

            END IF
          END IF
        END DO
      END DO

#ifdef sens
      S_GAS = 0.0D0
      S_GASWDEP = 0.0D0
      S_AEROSOL = 0.0D0
      S_AERWDEP = 0.0D0
#endif

      ! Load all Gas and Aerosol Concentrations
      DO ISPC = 1,N_CGRID_SPC
        IAQ = MAP_CGRIDtoAQGAS( ISPC )
        IF ( IAQ .GT. 0 ) THEN 
           GAS( IAQ ) = GAS( IAQ ) + REAL( POLC( ISPC ), 8 )
#ifdef sens
           DO NP = 1, NPMAX
              S_GAS( NP, IAQ ) = S_GAS( NP, IAQ ) + S_POLC ( NP, ISPC )
           ENDDO
#endif
        END IF

        IAQ = MAP_CGRIDtoAQAERO( ISPC )
        IF ( IAQ .GT. 0 ) THEN
           IM = MAP_CGRIDtoAQMODE( ISPC )
           AEROSOL( IAQ,IM ) = AEROSOL( IAQ,IM ) + REAL( POLC( ISPC ),8 )
#ifdef sens
           DO NP = 1, NPMAX
              S_AEROSOL( NP, IAQ, IM ) = S_AEROSOL( NP, IAQ, IM ) + S_POLC( NP, ISPC )
           ENDDO
#endif
        END IF
      END DO

      ! Now Calculate Surrogate Fractions
      DO ISPC = 1,N_CGRID_SPC

        ! First determine if this species is mapped to a gas surrogate
        IAQ = MAP_CGRIDtoAQGAS( ISPC ) 
        IF ( IAQ .GT. 0 ) THEN 
           IF ( GAS( IAQ ) .GT. 0.0D0 ) THEN
              WSRGAQ( ISPC ) = REAL( POLC( ISPC ), 8 ) / GAS( IAQ )
           ELSE
              WSRGAQ( ISPC ) = 1.0D0 / N_AQSRG_GAS( IAQ )
           END IF
        END IF

        ! Next try aerosol surrogates
        IAQ = MAP_CGRIDtoAQAERO( ISPC ) 
        IF ( IAQ .GT. 0 ) THEN
           IM = MAP_CGRIDtoAQMODE( ISPC )
           IF ( AEROSOL( IAQ, IM ) .GT. 0.0D0 ) THEN
              WSRGAQ( ISPC ) = REAL( POLC( ISPC ), 8 )
     &                       / REAL( AEROSOL( IAQ, IM ), 8 )               
           ELSE
              WSRGAQ( ISPC ) = 1.0D0 / REAL( N_AQSRG_AER( IAQ, IM ), 8 )
           END IF
        END IF

      END DO


C *** extract grid cell concentrations of aero species from CGRID
C     into aerospc_conc in aero_data module

#ifdef sens
      CALL EXTRACT_AERO ( POLC, .FALSE., REAL(S_POLC,4), .TRUE. )
#else
      CALL EXTRACT_AERO ( POLC, .FALSE. )
#endif

C *** Calculate pseudo aerosol 3rd moment (ignore factors that cancel in the division)
C ... M3OLD is in units of m3/kmol_air
      M3OLD = 0.0
      Dens_wmean_old = 0.0
      DO IM = 2, N_MODE

        DO SPC = 1, N_AEROSPC
          IF (  AEROSPC( SPC )%TRACER ) CYCLE 
          IF ( ( AEROSPC( SPC )%NAME( IM ) .NE. ' ' ) .AND.
     &         ( .NOT. AEROSPC( SPC )%NO_M2WET ) ) THEN
             M3OLD( IM ) = M3OLD( IM )
     &                      + ( AEROSPC_CONC( SPC,IM ) * AEROSPC_MW( SPC )
     &                      / AEROSPC( SPC )%DENSITY )
             Dens_wmean_old( IM ) = Dens_wmean_old( IM )  
     &                      + AEROSPC_CONC( SPC,IM ) * AEROSPC_MW( SPC )
          END IF
        END DO
      END DO
      Dens_wmean_old(2:N_MODE) = Dens_wmean_old(2:N_MODE) / M3OLD(2:N_MODE)

C...perform aqueous-phase chemistry calculations

      CALL AQCHEM ( JDATE, JTIME, TBARC, PBARC, TAUCLD, PRATE1,
     &              WCBAR, WTBAR, AIRM, ALFA0, ALFA2, ALFA3, GAS,
     &              AEROSOL, GASWDEP, AERWDEP, HPWDEP, BETASO4, COSZ)

C...  compute the scavenging coefficient
      EALFA2T = EXP( -ALFA2 * TAUCLD )

C...store the amount of hydrogen deposition

      REMOVAC = HPWDEP
#ifdef sens
      DO NP = 1, NPMAX
        S_REMOVAC( NP ) = S_HPWDEP( NP )
      END DO
#endif

C...Now, re-apportion mass back into cend/remov (cgrid-type) array
      ! Gases
      DO ISPC = 1,N_CGRID_SPC
        IAQ = MAP_CGRIDtoAQGAS( ISPC )
        IF ( IAQ .GT. 0 ) THEN 

             CEND ( ISPC ) = GAS    ( IAQ ) * WSRGAQ( ISPC )
             REMOV( ISPC ) = GASWDEP( IAQ ) * WSRGAQ( ISPC )
#ifdef sens
             DO NP = 1, NPMAX
               S_CEND ( NP, ISPC ) = S_GAS    ( NP, IAQ ) * WSRGAQ( ISPC )
               S_REMOV( NP, ISPC ) = S_GASWDEP( NP, IAQ ) * WSRGAQ( ISPC )
             ENDDO
#endif
        END IF 
 
        ! Particles
        IAQ = MAP_CGRIDtoAQAERO( ISPC )
        IF ( IAQ .GT. 0 ) THEN
             IM = MAP_CGRIDtoAQMODE( ISPC )
             ! Transfer Aitken and Coarse Mode Mass
             CEND ( ISPC ) = AEROSOL( IAQ, IM ) * WSRGAQ( ISPC )
             REMOV( ISPC ) = AERWDEP( IAQ, IM ) * WSRGAQ( ISPC )
#ifdef sens
             DO NP = 1, NPMAX
                S_CEND ( NP,ISPC ) = S_AEROSOL( NP,IAQ,IM ) * WSRGAQ( ISPC )
                S_REMOV( NP,ISPC ) = S_AERWDEP( NP,IAQ,IM ) * WSRGAQ( ISPC )
             ENDDO
#endif 
             IF ( IM .EQ. IACC ) THEN
                JSPC = MAP_ACCtoAIT( ISPC )  ! JSPC will have a value if ISPC is an 
                                             ! accumulation-mode species and it connects 
                                             ! to an Aitken mode species

                IF ( JSPC .GT. 0 ) THEN
                   ! Transfer Accumulation-Mode Mass, including Aitken-mode
                   ! mass that was scavenged and combined with the accumulation mode
                   CEND ( ISPC ) = (1.d0 - FRACAIT(IAQ)) * AEROSOL( IAQ,IM ) * WSRGAQ( ISPC )
     &                                   + FRACAIT(IAQ)  * AEROSOL( IAQ,IM ) * WSRGAQ( JSPC )
                   REMOV( ISPC ) = (1.d0 - FRACAIT(IAQ)) * AERWDEP( IAQ,IM ) * WSRGAQ( ISPC )
     &                                   + FRACAIT(IAQ)  * AERWDEP( IAQ,IM ) * WSRGAQ( JSPC )
#ifdef sens      
                   DO NP = 1, NPMAX
                      S_CEND ( NP,ISPC ) = (1.d0 - FRACAIT(IAQ)) * S_AEROSOL(NP,IAQ,IM) * WSRGAQ( ISPC )
     &                                           + FRACAIT(IAQ)  * S_AEROSOL(NP,IAQ,IM) * WSRGAQ( JSPC )
                      S_REMOV( NP,ISPC ) = (1.d0 - FRACAIT(IAQ)) * S_AERWDEP(NP,IAQ,IM) * WSRGAQ( ISPC )
     &                                           + FRACAIT(IAQ)  * S_AERWDEP(NP,IAQ,IM) * WSRGAQ( JSPC )
                   ENDDO
#endif           
                ELSE
                   ! Transfer Accumulation-Mode Mass without an Aitken mode counterpart
                   CEND ( ISPC ) = (1.d0 - FRACAIT(IAQ)) * AEROSOL( IAQ,IM ) * WSRGAQ( ISPC )
                   REMOV( ISPC ) = (1.d0 - FRACAIT(IAQ)) * AERWDEP( IAQ,IM ) * WSRGAQ( ISPC )
#ifdef sens        
                   DO NP = 1, NPMAX
                      S_CEND ( NP,ISPC ) = (1.d0 - FRACAIT(IAQ)) * S_AEROSOL( NP,IAQ,IM ) * WSRGAQ( ISPC )
                      S_REMOV( NP,ISPC ) = (1.d0 - FRACAIT(IAQ)) * S_AERWDEP( NP,IAQ,IM ) * WSRGAQ( ISPC )
                   ENDDO
#endif             
                END IF
             END IF
        END IF
      END DO
 
C *** extract grid cell concentrations of aero species from CGRID
C     into aerospc_conc in aero_data module

#ifdef sens
      CALL EXTRACT_AERO ( CEND, .FALSE., REAL(S_CEND,4), .TRUE. )
#else
      CALL EXTRACT_AERO ( CEND, .FALSE. )
#endif

C *** Calculate pseudo aerosol 3rd moment (ignore factors that cancel in the division)
C ... M3NEW is in units of m3/kmol_air
      M3NEW = 0.0
      Dens_wmean_new = 0.0
      DO IM = IACC, N_MODE

        DO SPC = 1, N_AEROSPC
          IF (  AEROSPC( SPC )%TRACER ) CYCLE 
          IF ( ( AEROSPC( SPC )%NAME( IM ) .NE. ' ' ) .AND.
     &         ( .NOT. AEROSPC( SPC )%NO_M2WET ) ) THEN
             M3NEW( IM ) = M3NEW( IM )
     &                      + ( AEROSPC_CONC( SPC,IM ) * AEROSPC_MW( SPC )
     &                      / AEROSPC( SPC )%DENSITY )
             Dens_wmean_new( IM ) = Dens_wmean_new( IM )  
     &                      + AEROSPC_CONC( SPC,IM ) * AEROSPC_MW( SPC )
          END IF
        END DO
      END DO

C...Update aerosol number 
      CEND( AERONUM_MAP( iait ) ) = MAX( CEND( AERONUM_MAP( iait ) ), aeromode_minNum( iait )/ (AIRM/CTHK1) )
      CEND( AERONUM_MAP( iacc ) ) = MAX( CEND( AERONUM_MAP( iacc ) ), aeromode_minNum( iacc )/ (AIRM/CTHK1) )
      CEND( AERONUM_MAP( icor ) ) = MAX( CEND( AERONUM_MAP( icor ) ), aeromode_minNum( icor )/ (AIRM/CTHK1) )

#ifdef sens
C... Remove number sensitivity calculations for now
      S_CEND( :, AERONUM_MAP( iait ) ) = 0.0
      S_CEND( :, AERONUM_MAP( iacc ) ) = 0.0
      S_CEND( :, AERONUM_MAP( icor ) ) = 0.0
#endif

C...check for minimums
C...ug/m3*m3/mol_air*1e3 mol_air/kmol_air*1e-9kg/ug*m3/kg=> m3/kmol_air
      DO IM = IACC, N_MODE
        IF ( M3NEW( IM ) .GT. 0.0D0 ) THEN  ! Dens_wmean_new will be .GT. 0 also
           Dens_wmean_new( IM ) = Dens_wmean_new( IM ) / M3NEW( IM )
           M3OLD( IM ) = MAX( M3OLD( IM ), CONMIND * 1.0d-6 / ( Dens_wmean_old( IM ) * AIRM / CTHK1 ) )
           M3NEW( IM ) = MAX( M3NEW( IM ), CONMIND * 1.0d-6 / ( Dens_wmean_new( IM ) * AIRM / CTHK1 ) )
        END IF
      END DO

C...Update surface area

      CEND( AEROSRF_MAP( IAIT ) ) = POLC( AEROSRF_MAP( IAIT ) ) * EALFA2T
      CEND( AEROSRF_MAP( IAIT ) ) = MAX( CEND( AEROSRF_MAP( IAIT ) ), aeromode_minM2( IAIT ) * DPI / (AIRM/CTHK1) )
      
      CEND( AEROSRF_MAP( IACC ) ) = POLC( AEROSRF_MAP( IACC ) )
     &                         * EXP( -BETASO4 * TAUCLD * ONETHIRD )
     &                         * ( M3NEW( IACC ) / M3OLD( IACC ) ) ** TWOTHIRDS
      CEND( AEROSRF_MAP( IACC ) ) = MAX( CEND( AEROSRF_MAP( IACC ) ), aeromode_minM2( IACC ) * DPI / (AIRM/CTHK1) )

      CEND( AEROSRF_MAP( ICOR ) ) = POLC( AEROSRF_MAP( ICOR ) )
     &                         * ( CEND( AERONUM_MAP( ICOR ) )
     &                             / POLC( AERONUM_MAP( ICOR ) ) ) ** ONETHIRD
     &                         * ( M3NEW( ICOR ) / M3OLD( ICOR ) ) ** TWOTHIRDS
      CEND( AEROSRF_MAP( ICOR ) ) = MAX( CEND( AEROSRF_MAP( ICOR ) ), aeromode_minM2( ICOR ) * DPI / (AIRM/CTHK1) )

#ifdef sens
C... Remove surface area sensitivity calculations for now
      S_CEND( :, AEROSRF_MAP( IAIT ) ) = 0.0
      S_CEND( :, AEROSRF_MAP( IACC ) ) = 0.0
      S_CEND( :, AEROSRF_MAP( ICOR ) ) = 0.0
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


      MODULE SA_IRR_DEFN

C***********************************************************************
C20140428                       
C  
C  (1) Stores initial reaction rates in a C-R-L-nrxns array
C  (2) Contains subroutines SA_IRR_INIT
C                       and ACCUMRR
C
C    Aug 16, 2011: chemical integration time interval is in MINUTES
C
C***********************************************************************


      IMPLICIT NONE


      REAL, ALLOCATABLE :: RXINIT( :,:,:,: )
      REAL, ALLOCATABLE :: RKI_INIT( :,:,:,: )
      REAL, ALLOCATABLE :: YC_INIT( :,:,:,: )
      REAL, ALLOCATABLE :: PRDRATE( : )
      REAL, ALLOCATABLE :: RKMID ( : )

!20140307 Integrated Rates


      INTEGER              :: ISAM_CHEMISTRY_SPC ! number of ISAM species om photochemistry
      INTEGER, ALLOCATABLE :: ISAM_SPC_MAP( : ) ! index in ISAM species array
      INTEGER, ALLOCATABLE :: ISAM_TO_CHEM( : ) ! index is CHEMSITRY_SPC array
      LOGICAL, ALLOCATABLE :: CONVERT_ISAM( : ) ! whether to ISAM concentration for photochemsitry 
      LOGICAL, ALLOCATABLE :: BIAS_CHEMISTRY_SPC( :,: ) ! whether to favor chemistry species when a reactant
           
      REAL                   :: CONMIN_TAG               ! min tag concentration uploaded
      REAL( 8 )              :: NUMB_ISAM_CELLS = 0.0D0
      REAL( 8 )              :: DCONCMIN                 ! internal min concentration
      REAL( 8 )              :: DCONMIN_TAG              ! internal min tag concentration
      REAL( 8 )              :: UNIFORM_DCONMIN_TAG      ! min tag concentration evenly distributed

      REAL( 8 ), ALLOCATABLE :: UGM3_TO_PPM( : )      ! CGRID to CHEM Species conversion factor
      REAL,      ALLOCATABLE :: PPM_TO_UGM3( : )      ! CHEM to CGRID Species conversion factor
      REAL( 8 ), ALLOCATABLE :: SOLD( :,: )           ! local source concentrations

      
      LOGICAL, ALLOCATABLE :: ISAM_SPECIES( : )
      LOGICAL              :: ISAM_NOT_FOUND = .FALSE.

      TYPE SPECIES_BUDGET
         CHARACTER(16)        :: SPECIES_NAME = ' '
         INTEGER              :: NREACTIONS   = 0
         INTEGER, ALLOCATABLE :: IREACTION( : )
         REAL(8), ALLOCATABLE :: COEFF_NET( : )
         INTEGER              :: NRXNS_PROD   = 0
         INTEGER, ALLOCATABLE :: IRXN_PROD( : )
         REAL(8), ALLOCATABLE :: COEFF_POS( : )
         INTEGER              :: NRXNS_LOSS   = 0
         INTEGER, ALLOCATABLE :: IRXN_LOSS( : )
         REAL(8), ALLOCATABLE :: COEFF_NEG( : )
      END TYPE SPECIES_BUDGET
      
      TYPE(SPECIES_BUDGET), ALLOCATABLE :: MECHANISM_BUDGET ( : )
      TYPE(SPECIES_BUDGET), ALLOCATABLE :: OX_RADICAL_BUDGET( : )
      TYPE(SPECIES_BUDGET), ALLOCATABLE :: ISAM_SPC_BUDGET  ( : )   
      
      INTEGER :: NRXNS_PROD_H2O2      = 0              ! # reactions producing only H2O2
      INTEGER :: NRXNS_PROD_HNO3      = 0              ! # reactions producing only HNO3
      INTEGER :: NRXNS_PROD_H2O2_HNO3 = 0              ! # reactions producing H2O2 or HNO3
      INTEGER, ALLOCATABLE :: H2O2_HNO3_PROD_RXNS( : ) ! indices of H2O2 or HNO3 producing reactions

      REAL( 8 ), ALLOCATABLE :: H2O2_HNO3_YIELD( : )   ! H2O2 or HNO3 yield for a reaction subset
      REAL( 8 ) :: VOC_TO_NOX 
       
      INTEGER :: ISAM_LOG        ! Unit number of output log
      INTEGER :: ISAM_JDATE = 0
      INTEGER :: ISAM_JTIME = 0
      INTEGER :: ISAM_NSTEP = 0
#ifdef verbose_isam
      LOGICAL :: CHECK_ISAM  = .TRUE.
      LOGICAL :: WRITE_BUDGET_REPORT = .TRUE.
#else
      LOGICAL :: CHECK_ISAM  = .FALSE.
      LOGICAL :: WRITE_BUDGET_REPORT = .FALSE.
#endif      
      LOGICAL :: WRITE_CELL  = .FALSE.
      LOGICAL :: UPDATE_SOLD = .FALSE.
      LOGICAL :: UPDATE_PROBABILITIES = .FALSE.

      INTEGER, PARAMETER :: N_OX_RADICALS = 13
      CHARACTER( 16 )    :: OX_RADICALS( N_OX_RADICALS ) = 
     &                      (/ 'O               ',      
     &                         'O1D             ',      
     &                         'ACO3            ',      
     &                         'MEO3            ',      
     &                         'C2O3            ',      
     &                         'O3P             ',      
     &                         'NO              ',
     &                         'NO2             ',     
     &                         'NO3             ',     
     &                         'N2O5            ',     
     &                         'HO2             ',
     &                         'MEO2            ',
     &                         'MO2             ' /)
     
       LOGICAL, ALLOCATABLE :: IS_ISAM_OX_RADICAL( : )
       LOGICAL, ALLOCATABLE :: IS_CHEM_OX_RADICAL( : )
       LOGICAL, ALLOCATABLE :: IS_TAG_NONZERO( : )

       INTEGER              :: OX_RADICAL_FOUND = 0   
       INTEGER              :: OZONE_INDEX      = 0     
       INTEGER, ALLOCATABLE :: OX_INDEX ( : )
       
       LOGICAL :: ISAM_WITH_OZONE = .FALSE.

! specific species indices in chemical mechanism 
       INTEGER              :: H2O2_INDEX       = 0     
       INTEGER              :: HNO3_INDEX       = 0     
       INTEGER              :: O3_INDEX         = 0     
       LOGICAL              :: CHEMISTRY_WITH_O3 = .FALSE.

       REAL( 8 ), PARAMETER, PRIVATE :: ONE    = 1.0D0
       REAL( 8 ), PARAMETER, PRIVATE :: ZERO   = 0.0D0
       REAL( 8 ), PARAMETER, PRIVATE :: CUTOFF = 1.0D-23
       REAL( 8 ), PARAMETER, PRIVATE :: BULK_CUTOFF = ZERO

      CONTAINS
        SUBROUTINE SA_IRR_INIT

          USE HGRD_DEFN
          USE VGRD_DEFN
          USE UTILIO_DEFN
          USE RXNS_DATA
          USE SA_DEFN
          USE CONST, ONLY: MWAIR
C Initialize arrays and maps that store reaction rates in each grid cell and that
C         relate ISAM species to chemistry species
C
C         Called by chemistry driver

        IMPLICIT NONE

         CHARACTER( 16 ), PARAMETER :: PNAME = 'SA_IRR_INIT'     ! Program name

         INTEGER :: I, J, RXN, IP, IL 
         INTEGER :: IOSTAT
         INTEGER :: C, L, R, S   ! Loop indices
         INTEGER :: SPC          ! array index
         INTEGER :: IOS


         CHARACTER( 132 ) :: MSG           ! Message text
! temporary arrays to set maps between isam to chemistry species
         INTEGER, ALLOCATABLE :: ISAM_SPC_IDX( : )
         INTEGER, ALLOCATABLE :: ISAM_2_CHEMI( : )
         LOGICAL, ALLOCATABLE :: NO_CHEMISTRY( : )

         CHARACTER(16), ALLOCATABLE :: FIND_IN_ISAM( : )

! temporary variables to define MECHANISM_BUDGET

         INTEGER, ALLOCATABLE :: IREACTION( : )
         INTEGER, ALLOCATABLE :: IRXN_PROD( : )
         INTEGER, ALLOCATABLE :: IRXN_LOSS( : )
         REAL(8), ALLOCATABLE :: COEFF_NET( : )
         REAL(8), ALLOCATABLE :: COEFF_POS( : )
         REAL(8), ALLOCATABLE :: COEFF_NEG( : )
         REAL(8)              :: COEFF

         TYPE(SPECIES_BUDGET) :: H2O2_BUDGET
         TYPE(SPECIES_BUDGET) :: HNO3_BUDGET
         
C=======================================================

        ISAM_LOG = INIT3( )
        


        ALLOCATE( ISAM_2_CHEMI( NSPC_SA + 1 ) )
        ALLOCATE( ISAM_SPC_IDX( NSPC_SA + 1 ) )
        ALLOCATE( NO_CHEMISTRY( NSPC_SA + 1 ) )
        ALLOCATE( FIND_IN_ISAM( NSPC_SA + 1 ) )
        ALLOCATE( BIAS_CHEMISTRY_SPC( NBIAS, NUMB_MECH_SPC ) )
        BIAS_CHEMISTRY_SPC = .FALSE.
        
        ! Identify species index in ISAM array
        ISAM_SPC_IDX = 0
        ISAM_2_CHEMI = 0
        NO_CHEMISTRY = .TRUE.
        FIND_IN_ISAM = ' '

        SPC = 0
        
        DO S = 1, NSPC_SA
           FIND_IN_ISAM( S ) = ISAM_SPEC( S,OTHRTAG )
           ISAM_SPC_IDX( S ) = S
        END DO
        SPC = NSPC_SA
! find tagged species in chemistry_spc array to set value of convert_isam
        ISAM_CHEMISTRY_SPC = 0
        DO S = 1, SPC
           R  = INDEX1( TRIM(FIND_IN_ISAM( S )), NUMB_MECH_SPC, CHEMISTRY_SPC )
           IF ( R .LE. 0 ) THEN
              MSG = 'ISAM SPECIES: ' 
     &           // TRIM( FIND_IN_ISAM( S ) ) 
     &           // ' not found in CHEMISTRY_SPC array  '
              CALL M3WARN( PNAME, 0, 0, MSG )
              CYCLE
           END IF
           ISAM_CHEMISTRY_SPC = ISAM_CHEMISTRY_SPC
     &                        + 1           
           ISAM_2_CHEMI( S )  = R
           BIAS_CHEMISTRY_SPC( :,R ) = ISAM_SPECIES_BIAS( :,S )
           NO_CHEMISTRY( S )  = .FALSE.
        END DO
        
        HNO3_INDEX = INDEX1( 'HNO3', NUMB_MECH_SPC, CHEMISTRY_SPC )
        H2O2_INDEX = INDEX1( 'H2O2', NUMB_MECH_SPC, CHEMISTRY_SPC )
        IF ( H2O2_INDEX .LT. 1 ) THEN
            H2O2_INDEX = INDEX1( 'HO2H', NUMB_MECH_SPC, CHEMISTRY_SPC )        
        END IF
        O3_INDEX = INDEX1( 'H2O2', NUMB_MECH_SPC, CHEMISTRY_SPC )
        IF ( O3_INDEX .GT. 0 ) CHEMISTRY_WITH_O3 = .TRUE.
        
        IF ( ISAM_CHEM_BIAS .EQ. 5 ) THEN
          IF ( H2O2_INDEX .LT. 1 .OR. HNO3_INDEX .LT. 1 ) THEN
             IF ( H2O2_INDEX .LT. 1 ) THEN
                 WRITE(LOGDEV,'(A)')'ISAM_O3_WEIGHTS set to 5 but hydrogen peroxide not found gas chemistry.'
             END IF
             IF ( HNO3_INDEX .LT. 1 ) THEN
                 WRITE(LOGDEV,'(A)')'ISAM_O3_WEIGHTS set to 5 but nitric acid not found gas chemistry.'
             END IF
             MSG = 'Above Error(s) not found using ISAM runtime option'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
          END IF        
          IF ( O3_INDEX .LT. 1 ) THEN
             WRITE(LOGDEV,'(A)')'ISAM_O3_WEIGHTS set to 5 but gas chemistry does not have ozone.'
             WRITE(LOGDEV,'(A)')'ISAM_O3_WEIGHTS reset to 1.'
             ISAM_CHEM_BIAS = 1
          END IF
        END IF

        IF( ANY(  .NOT. NO_CHEMISTRY ) )THEN
C..Save pointer for isam species found in chemistry species
           ALLOCATE( ISAM_TO_CHEM( ISAM_CHEMISTRY_SPC ) )
           ALLOCATE( ISAM_SPC_MAP( ISAM_CHEMISTRY_SPC ) )
           WRITE(ISAM_LOG,'(/A)')'Below isam species participate in photochemistry'
           WRITE(ISAM_LOG,'("SPC     ISAM_SPC     SPC PHOTOCHEM_SPC  ")')
           L = 0 
           DO S = 1, SPC
              IF ( .NOT. NO_CHEMISTRY( S ) ) THEN
                 L = L + 1
                 C = ISAM_SPC_IDX( S )
                 R = ISAM_2_CHEMI( S )
                 ISAM_SPC_MAP( L ) = ISAM_SPC_IDX( S )
                 ISAM_TO_CHEM( L ) = ISAM_2_CHEMI( S )
                 WRITE(ISAM_LOG,'(I3,1X,A16,1x,I3,1X,A16)') 
     &           C, FIND_IN_ISAM( S ), R, CHEMISTRY_SPC( R )
              END IF
           END DO
           IF( L .NE. ISAM_CHEMISTRY_SPC )THEN
             MSG = 'ERROR mapping isam to chemistry species: inconsistent number found'
             CALL M3EXIT ( PNAME, 0, 0, MSG, XSTAT1 )
           END IF
        ELSE
           MSG = 'NO ISAM species participate in photochemistry '
           CALL M3WARN ( PNAME, 0, 0, MSG )
        END IF
        L = 0
        DO S = 1, SPC
           IF( NO_CHEMISTRY( S ) )THEN
                C = ISAM_SPC_IDX( S )
                IF( C .LE. 0 )CYCLE
                L = L + 1
                IF( L .LT. 2 )THEN
                    WRITE(ISAM_LOG,'(/A)')'Below isam species DO NOT participate in photochemistry'
                    WRITE(ISAM_LOG,'("SPC     ISAM_SPC")')
                END IF    
                WRITE(ISAM_LOG,'(I3,1X,A16,1x,I3,A16)') C, FIND_IN_ISAM( S )
           END IF
        END DO

        DEALLOCATE( ISAM_2_CHEMI )
        DEALLOCATE( ISAM_SPC_IDX )
        DEALLOCATE( NO_CHEMISTRY )

C...Allocate and set conversion factors for isam chemistry species
        ALLOCATE( CONVERT_ISAM( ISAM_CHEMISTRY_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating CONVERT_ISAM'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 
              
        ALLOCATE( UGM3_TO_PPM( ISAM_CHEMISTRY_SPC ),
     &            PPM_TO_UGM3( ISAM_CHEMISTRY_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating UGM3_TO_PPM or PPM_TO_UGM3'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 

        ALLOCATE( IS_ISAM_OX_RADICAL( ISAM_CHEMISTRY_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating IS_ISAM_A_RADICAL'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 
        IS_ISAM_OX_RADICAL = .FALSE.

        ALLOCATE( IS_CHEM_OX_RADICAL( NUMB_MECH_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating IS_ISAM_A_RADICAL'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 
        IS_CHEM_OX_RADICAL = .FALSE.

        WRITE(ISAM_LOG,'(/A)')'Final Table of ISAM chemistry species'
        WRITE(ISAM_LOG,'("SPC     ISAM_SPC     SPC PHOTOCHEM_SPC  Mol.Wei Convert Conc. Radical Spc")')
              
        ALLOCATE( IS_TAG_NONZERO( NTAG_SA ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating IS_TAG_NONZERO'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 

!       ALLOCATE( FRAC_TOTAL( NTAG_SA ), STAT = IOS )
!       IF ( IOS .NE. 0 ) THEN
!            MSG = 'Error allocating FRAC_TOTAL'
!            CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
!       END IF 

        ALLOCATE( ISAM_SPECIES( NUMB_MECH_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
           MSG = 'Error allocating ISAM_SPECIES'
           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF
        ISAM_SPECIES = .FALSE. 

        DO S = 1, ISAM_CHEMISTRY_SPC
           C = ISAM_SPC_MAP( S )
           R = ISAM_TO_CHEM( S )
           IF( FIND_IN_ISAM( C ) .EQ. 'O3' )THEN
               ISAM_WITH_OZONE = .TRUE.
               OZONE_INDEX     =  R
               WRITE(ISAM_LOG,'(A)')'ISAM Species include ozone'
           END IF    
           DO L = 1, N_OX_RADICALS
              IF( FIND_IN_ISAM( C ) .EQ. OX_RADICALS( L ) )THEN
                  IS_ISAM_OX_RADICAL( S ) = .TRUE.
              END IF    
              IF( CHEMISTRY_SPC( R ) .EQ. OX_RADICALS( L ) )THEN
                  IS_CHEM_OX_RADICAL( R ) = .TRUE.
                  OX_RADICAL_FOUND        = OX_RADICAL_FOUND + 1
              END IF    
           END DO
           CONVERT_ISAM( S ) = CONVERT_CONC( R )
           ISAM_SPECIES( R ) = .TRUE.
           UGM3_TO_PPM ( S ) = REAL( 1.0E-3 * MWAIR / SPECIES_MOLWT( R ), 8 )
           PPM_TO_UGM3 ( S ) = 1.0E+3 / MWAIR * SPECIES_MOLWT( R )
           WRITE(ISAM_LOG,'(I3,1X,A16,1x,I3,1X,A16,2X,F7.2,3(1X,L14))') 
     &     C, FIND_IN_ISAM( C ), R, CHEMISTRY_SPC( R ), SPECIES_MOLWT( R ), 
     &     CONVERT_ISAM( S ), IS_ISAM_OX_RADICAL( S ),IS_CHEM_OX_RADICAL( R )
        END DO
        
        DEALLOCATE( FIND_IN_ISAM )

        ALLOCATE( OX_INDEX( OX_RADICAL_FOUND ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
           MSG = 'Error allocating SOLD'
           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 
        OX_INDEX = 0

        DCONMIN_TAG = 1.0D-40 
        DCONCMIN    = 1.0D-30 
        CONMIN_TAG  = 1.0E-30
         
        UNIFORM_DCONMIN_TAG = DCONMIN_TAG / REAL( NTAG_SA,8 ) 

        ALLOCATE( SOLD( NTAG_SA, NUMB_MECH_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
           MSG = 'Error allocating SOLD'
           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 
        
        ALLOCATE( MECHANISM_BUDGET( NUMB_MECH_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
           MSG = 'Error allocating MECHANISM_BUDGET'
           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 

        ALLOCATE( IREACTION( NRXNS ),
     &            IRXN_PROD( NRXNS ),
     &            IRXN_LOSS( NRXNS ),
     &            COEFF_POS( NRXNS ),
     &            COEFF_NEG( NRXNS ),
     &            COEFF_NET( NRXNS ),  STAT = IOS )     
        IF ( IOS .NE. 0 ) THEN
           MSG = 'Error allocating IREACTION and COEFF_NET arrays'
           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 

        ISAM_WITH_OZONE = ( ISAM_WITH_OZONE .AND. OX_RADICAL_FOUND .GT. 0 )
        IF( OX_RADICAL_FOUND .GT. 0  )THEN
           ALLOCATE( OX_RADICAL_BUDGET( OX_RADICAL_FOUND ), STAT = IOS )
           IF ( IOS .NE. 0 ) THEN
              MSG = 'Error allocating MECHANISM_BUDGET'
              CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
           END IF 
        END IF

! find how reactions affect all chemistry species
        L = 0
        DO SPC = 1, NUMB_MECH_SPC
           S  = 0
           IP = 0
           IL = 0
           MECHANISM_BUDGET( SPC )%SPECIES_NAME = CHEMISTRY_SPC( SPC )
           MECHANISM_BUDGET( SPC )%NREACTIONS   = 0
           MECHANISM_BUDGET( SPC )%NRXNS_PROD   = 0
           MECHANISM_BUDGET( SPC )%NRXNS_LOSS   = 0
           IREACTION = 0
           COEFF_NET = 0.0D0
           COEFF_POS = 0.0D0
           COEFF_NEG = 0.0D0           
! set indices for Ox radicals
           IF( IS_CHEM_OX_RADICAL( SPC ) )THEN
               L = L + 1
               OX_INDEX( L ) = SPC
               OX_RADICAL_BUDGET( L )%SPECIES_NAME = CHEMISTRY_SPC( SPC )
               OX_RADICAL_BUDGET( L )%NREACTIONS   = 0
               OX_RADICAL_BUDGET( L )%NRXNS_PROD   = 0
               OX_RADICAL_BUDGET( L )%NRXNS_LOSS   = 0
           END IF    
! find effect on CHEMISTRY_SPC( SPC ) and save results
           DO R = 1, NRXNS
              COEFF = EFFECT_REACTION( SPC, R, C )
              IF( ABS( COEFF ) .GT. 1.0D-8 )THEN
                 S = S + 1
                 IREACTION( S ) = R
                 COEFF_NET( S ) = COEFF
                 IF( COEFF  .GT. 0.0D0 )THEN
                   IP = IP + 1
                   IRXN_PROD( IP ) = R
                   COEFF_POS( IP ) = COEFF
                 ELSE
                   IL = IL + 1
                   IRXN_LOSS( IL ) = R
                   COEFF_NEG( IL ) = ABS( COEFF )
                 END IF
              END IF
           END DO
! set up species budget                
           IF( S .GT. 0 )THEN
               MECHANISM_BUDGET( SPC )%NREACTIONS = S
               ALLOCATE( MECHANISM_BUDGET( SPC )%IREACTION( S ),
     &                   MECHANISM_BUDGET( SPC )%COEFF_NET( S ),  STAT = IOS )
               IF ( IOS .NE. 0 ) THEN
                    MSG = 'Error allocating bulk MECHANISM_BUDGET arrays'
                   CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
               END IF 
               MECHANISM_BUDGET( SPC )%IREACTION( 1:S ) = IREACTION( 1:S )
               MECHANISM_BUDGET( SPC )%COEFF_NET( 1:S ) = COEFF_NET( 1:S )
               IF( IS_CHEM_OX_RADICAL( SPC ) )THEN
                   OX_RADICAL_BUDGET( L )%NREACTIONS = S
                   ALLOCATE( OX_RADICAL_BUDGET( L )%IREACTION( S ),
     &                       OX_RADICAL_BUDGET( L )%COEFF_NET( S ),  STAT = IOS )
                   IF ( IOS .NE. 0 ) THEN
                       MSG = 'Error allocating production OX_RADICAL_BUDGET arrays'
                       CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
                   END IF 
                   OX_RADICAL_BUDGET( L )%IREACTION( 1:S )  = IRXN_PROD( 1:S )
                   OX_RADICAL_BUDGET( L )%COEFF_NET( 1:S )  = COEFF_NET( 1:S )
               END IF
               IF( IP .GT. 0 )THEN
! define production information
                  MECHANISM_BUDGET( SPC )%NRXNS_PROD = IP
                  ALLOCATE( MECHANISM_BUDGET( SPC )%IRXN_PROD( IP ),
     &                      MECHANISM_BUDGET( SPC )%COEFF_POS( IP ),  STAT = IOS )
                  IF ( IOS .NE. 0 ) THEN
                       MSG = 'Error allocating production MECHANISM_BUDGET arrays'
                      CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
                  END IF 
                  MECHANISM_BUDGET( SPC )%IRXN_PROD( 1:IP )  = IRXN_PROD( 1:IP )
                  MECHANISM_BUDGET( SPC )%COEFF_POS( 1:IP )  = COEFF_POS( 1:IP )
! capture production information if OX radical
                  IF( IS_CHEM_OX_RADICAL( SPC ) )THEN
                     OX_RADICAL_BUDGET( L )%NRXNS_PROD = IP
                     ALLOCATE( OX_RADICAL_BUDGET( L )%IRXN_PROD( IP ),
     &                         OX_RADICAL_BUDGET( L )%COEFF_POS( IP ),  STAT = IOS )
                     IF ( IOS .NE. 0 ) THEN
                         MSG = 'Error allocating production OX_RADICAL_BUDGET arrays'
                         CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
                     END IF 
                     OX_RADICAL_BUDGET( L )%IRXN_PROD( 1:IP )  = IRXN_PROD( 1:IP )
                     OX_RADICAL_BUDGET( L )%COEFF_POS( 1:IP )  = COEFF_POS( 1:IP )
                  END IF
               END IF
               
               IF( IL .GT. 0 )THEN
! define destruction information
                  MECHANISM_BUDGET( SPC )%NRXNS_LOSS = IL
                  ALLOCATE( MECHANISM_BUDGET( SPC )%IRXN_LOSS( IL ),
     &                      MECHANISM_BUDGET( SPC )%COEFF_NEG( IL ),  STAT = IOS )
                  IF ( IOS .NE. 0 ) THEN
                       MSG = 'Error allocating destruction MECHANISM_BUDGET arrays'
                      CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
                  END IF 
                  MECHANISM_BUDGET( SPC )%IRXN_LOSS( 1:IL ) = IRXN_LOSS( 1:IL )
                  MECHANISM_BUDGET( SPC )%COEFF_NEG( 1:IL ) = COEFF_NEG( 1:IL )
! capture destruction information if OX radical
                  IF( IS_CHEM_OX_RADICAL( SPC ) )THEN
                     OX_RADICAL_BUDGET( L )%NRXNS_LOSS = IL
                     ALLOCATE( OX_RADICAL_BUDGET( L )%IRXN_LOSS( IL ),
     &                         OX_RADICAL_BUDGET( L )%COEFF_NEG( IL ),  STAT = IOS )
                     IF ( IOS .NE. 0 ) THEN
                         MSG = 'Error allocating production OX_RADICAL_BUDGET arrays'
                         CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
                     END IF 
                     OX_RADICAL_BUDGET( L )%IRXN_LOSS( 1:IL )  = IRXN_LOSS( 1:IL )
                     OX_RADICAL_BUDGET( L )%COEFF_NEG( 1:IL )  = COEFF_NET( 1:IL )
                  END IF
               END IF
           END IF                  
        END DO
        
        DEALLOCATE( IREACTION,
     &              IRXN_PROD,
     &              IRXN_LOSS,
     &              COEFF_POS,
     &              COEFF_NEG,
     &              COEFF_NET )     


! Set Hydrogen Peroxide budget data        
        IF ( H2O2_INDEX .GT. 0 ) THEN
           H2O2_BUDGET%SPECIES_NAME = CHEMISTRY_SPC( H2O2_INDEX )           
           H2O2_BUDGET%NREACTIONS = MECHANISM_BUDGET( H2O2_INDEX )%NREACTIONS

! set up reaction data with net hydrogen peroxide change                
           S = H2O2_BUDGET%NREACTIONS
           IF ( S .GT. 0 ) THEN
               ALLOCATE( H2O2_BUDGET%IREACTION( S ),
     &                   H2O2_BUDGET%COEFF_NET( S ),  STAT = IOS )
               IF ( IOS .NE. 0 ) THEN
                    MSG = 'Error allocating H2O2 budget array'
                   CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
               END IF
               H2O2_BUDGET%IREACTION( 1:S ) = MECHANISM_BUDGET( H2O2_INDEX )%IREACTION( 1:S )
               H2O2_BUDGET%COEFF_NET( 1:S ) = MECHANISM_BUDGET( H2O2_INDEX )%COEFF_NET( 1:S )
           END IF    

! define hydrogen peroxide production reaction information
           
           H2O2_BUDGET%NRXNS_PROD = MECHANISM_BUDGET( H2O2_INDEX )%NRXNS_PROD
           IP = H2O2_BUDGET%NRXNS_PROD
           IF ( IP .GT. 0 ) THEN
               ALLOCATE( H2O2_BUDGET%IRXN_PROD( IP ),
     &                   H2O2_BUDGET%COEFF_POS( IP ),  STAT = IOS )
               IF ( IOS .NE. 0 ) THEN
                    MSG = 'Error allocating production H2O2_BUDGET arrays'
                   CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
               END IF
               H2O2_BUDGET%IRXN_PROD( 1:IP ) = MECHANISM_BUDGET( H2O2_INDEX )%IRXN_PROD( 1:IP )
               H2O2_BUDGET%COEFF_POS( 1:IP ) = MECHANISM_BUDGET( H2O2_INDEX )%COEFF_POS( 1:IP )
           END IF

! define hydrogen peroxide production reaction information

           H2O2_BUDGET%NRXNS_LOSS = MECHANISM_BUDGET( H2O2_INDEX )%NRXNS_LOSS
           IL = H2O2_BUDGET%NRXNS_LOSS
           IF ( IL .GT. 0 ) THEN
               ALLOCATE( H2O2_BUDGET%IRXN_LOSS( IL ),
     &                   H2O2_BUDGET%COEFF_NEG( IL ),  STAT = IOS )
               IF ( IOS .NE. 0 ) THEN
                    MSG = 'Error allocating production H2O2_BUDGET arrays'
                   CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
               END IF
               H2O2_BUDGET%IRXN_LOSS( 1:IL ) = MECHANISM_BUDGET( H2O2_INDEX )%IRXN_LOSS( 1:IL )
               H2O2_BUDGET%COEFF_NEG( 1:IL ) = MECHANISM_BUDGET( H2O2_INDEX )%COEFF_NEG( 1:IL )
           END IF

        END IF

! Set Nitric Acid budget data        
        IF ( HNO3_INDEX .GT. 0 ) THEN

! set up reaction data with net nitric acid change                
           HNO3_BUDGET%SPECIES_NAME = CHEMISTRY_SPC( HNO3_INDEX )
           HNO3_BUDGET%NREACTIONS = MECHANISM_BUDGET( HNO3_INDEX )%NREACTIONS
           S = HNO3_BUDGET%NREACTIONS
           IF ( S .GT. 0 ) THEN
               ALLOCATE( HNO3_BUDGET%IREACTION( S ),
     &                   HNO3_BUDGET%COEFF_NET( S ),  STAT = IOS )
               IF ( IOS .NE. 0 ) THEN
                    MSG = 'Error allocating HNO3 budget array'
                   CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
               END IF
               HNO3_BUDGET%IREACTION( 1:S ) = MECHANISM_BUDGET( HNO3_INDEX )%IREACTION( 1:S )
               HNO3_BUDGET%COEFF_NET( 1:S ) = MECHANISM_BUDGET( HNO3_INDEX )%COEFF_NET( 1:S )
           END IF    

! define nitric acid production reaction information
           HNO3_BUDGET%NRXNS_PROD = MECHANISM_BUDGET( HNO3_INDEX )%NRXNS_PROD
           IP = HNO3_BUDGET%NRXNS_PROD
           IF ( IP .GT. 0 ) THEN
               ALLOCATE( HNO3_BUDGET%IRXN_PROD( IP ),
     &                   HNO3_BUDGET%COEFF_POS( IP ),  STAT = IOS )
               IF ( IOS .NE. 0 ) THEN
                    MSG = 'Error allocating production HNO3_BUDGET arrays'
                   CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
               END IF
               HNO3_BUDGET%IRXN_PROD( 1:IP ) = MECHANISM_BUDGET( HNO3_INDEX )%IRXN_PROD( 1:IP )
               HNO3_BUDGET%COEFF_POS( 1:IP ) = MECHANISM_BUDGET( HNO3_INDEX )%COEFF_POS( 1:IP )
           END IF
! define nitric acid destruction information
           HNO3_BUDGET%NRXNS_LOSS = MECHANISM_BUDGET( HNO3_INDEX )%NRXNS_LOSS
           IL = HNO3_BUDGET%NRXNS_LOSS
           IF ( IL .GT. 0 ) THEN
               ALLOCATE( HNO3_BUDGET%IRXN_LOSS( IL ),
     &                   HNO3_BUDGET%COEFF_NEG( IL ),  STAT = IOS )
               IF ( IOS .NE. 0 ) THEN
                    MSG = 'Error allocating production HNO3_BUDGET arrays'
                   CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
               END IF
               HNO3_BUDGET%IRXN_LOSS( 1:IL ) = MECHANISM_BUDGET( HNO3_INDEX )%IRXN_LOSS( 1:IL )
               HNO3_BUDGET%COEFF_NEG( 1:IL ) = MECHANISM_BUDGET( HNO3_INDEX )%COEFF_NEG( 1:IL )
           END IF
        END IF

        NRXNS_PROD_HNO3 = HNO3_BUDGET%NRXNS_PROD
        NRXNS_PROD_H2O2 = H2O2_BUDGET%NRXNS_PROD
        NRXNS_PROD_H2O2_HNO3 = NRXNS_PROD_HNO3 + NRXNS_PROD_H2O2
        IF ( NRXNS_PROD_HNO3 .GT. 0 .AND. NRXNS_PROD_HNO3 .GT. 0 ) THEN
           ALLOCATE( H2O2_HNO3_PROD_RXNS( NRXNS_PROD_H2O2_HNO3 ),STAT = IOS )
           IF ( IOS .NE. 0 ) THEN
                MSG = 'Error allocating production H2O2_HNO3_PROD_RXNS arrays'
               CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
           END IF
           IP = NRXNS_PROD_H2O2
           IL = NRXNS_PROD_HNO3
           H2O2_HNO3_PROD_RXNS( 1:IP )      = H2O2_BUDGET%IRXN_PROD( 1:IP ) 
           H2O2_HNO3_PROD_RXNS( (IP+1):IP+IL ) = HNO3_BUDGET%IRXN_PROD( 1:IL ) 
           ALLOCATE( H2O2_HNO3_YIELD( NRXNS_PROD_H2O2_HNO3 ),STAT = IOS )
           IF ( IOS .NE. 0 ) THEN
                MSG = 'Error allocating production H2O2_HNO3_YIELD arrays'
               CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
           END IF
           H2O2_HNO3_YIELD( 1:IP ) = H2O2_BUDGET%COEFF_POS( 1:IP ) 
           H2O2_HNO3_YIELD( (IP+1):IP+IL ) = HNO3_BUDGET%COEFF_POS( 1:IL ) 
        END IF

        ALLOCATE( ISAM_SPC_BUDGET( ISAM_CHEMISTRY_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating ISAM_SPC_BUDGET'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 

        DO SPC = 1, ISAM_CHEMISTRY_SPC
           R = ISAM_TO_CHEM( SPC )
           ISAM_SPC_BUDGET( SPC )%SPECIES_NAME = MECHANISM_BUDGET( R )%SPECIES_NAME
           ISAM_SPC_BUDGET( SPC )%NREACTIONS   = MECHANISM_BUDGET( R )%NREACTIONS  
           ISAM_SPC_BUDGET( SPC )%NRXNS_PROD   = MECHANISM_BUDGET( R )%NRXNS_PROD  
           ISAM_SPC_BUDGET( SPC )%NRXNS_LOSS   = MECHANISM_BUDGET( R )%NRXNS_LOSS  
! define net information
           S =  ISAM_SPC_BUDGET( SPC )%NREACTIONS
           IF( S .GT. 0 )THEN
               ALLOCATE( ISAM_SPC_BUDGET( SPC )%IREACTION( S ),
     &                   ISAM_SPC_BUDGET( SPC )%COEFF_NET( S ),  STAT = IOS )
               IF ( IOS .NE. 0 ) THEN
                    MSG = 'Error allocating bulk ISAM_SPC_BUDGET arrays'
                   CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
               END IF 
               ISAM_SPC_BUDGET( SPC )%IREACTION( 1:S ) = MECHANISM_BUDGET( R )%IREACTION( 1:S )
               ISAM_SPC_BUDGET( SPC )%COEFF_NET( 1:S ) = MECHANISM_BUDGET( R )%COEFF_NET( 1:S )
           END IF          
           IP = ISAM_SPC_BUDGET( SPC )%NRXNS_PROD
           IF( IP .GT. 0 )THEN
! define production information
              ALLOCATE( ISAM_SPC_BUDGET( SPC )%IRXN_PROD( IP ),
     &                  ISAM_SPC_BUDGET( SPC )%COEFF_POS( IP ),  STAT = IOS )
              IF ( IOS .NE. 0 ) THEN
                  MSG = 'Error allocating production ISAM_SPC_BUDGET arrays'
                  CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
              END IF 
              ISAM_SPC_BUDGET( SPC )%IRXN_PROD( 1:IP )  = MECHANISM_BUDGET( R )%IRXN_PROD( 1:IP )
              ISAM_SPC_BUDGET( SPC )%COEFF_POS( 1:IP )  = MECHANISM_BUDGET( R )%COEFF_POS( 1:IP )
           END IF       
           IL = ISAM_SPC_BUDGET( SPC )%NRXNS_LOSS
           IF( IL .GT. 0 )THEN
! define destruction information
              ALLOCATE( ISAM_SPC_BUDGET( SPC )%IRXN_LOSS( IL ),
     &                  ISAM_SPC_BUDGET( SPC )%COEFF_NEG( IL ),  STAT = IOS )
              IF ( IOS .NE. 0 ) THEN
                  MSG = 'Error allocating production ISAM_SPC_BUDGET arrays'
                  CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
              END IF 
              ISAM_SPC_BUDGET( SPC )%IRXN_LOSS( 1:IL )  = MECHANISM_BUDGET( R )%IRXN_LOSS( 1:IL )
              ISAM_SPC_BUDGET( SPC )%COEFF_NEG( 1:IL )  = MECHANISM_BUDGET( R )%COEFF_NEG( 1:IL )
           END IF  
           WRITE(ISAM_LOG,*)SPC, ISAM_SPC_BUDGET( SPC )%SPECIES_NAME,IP,IL    
        END DO          
        
! report budget for mechanism species and OX radicals
        IF( WRITE_BUDGET_REPORT ) THEN
            CALL REPORT_MECH_BUDGET( ISAM_LOG )
            IF( OX_RADICAL_FOUND .GT. 0  )THEN
               CALL REPORT_OX_RADICALS( ISAM_LOG )
            ELSE
               MSG = "Note that no Oxygen Radicals were found in mechanism."   
               WRITE(ISAM_LOG,'(A)')TRIM( MSG )
            END IF
            IF( ISAM_CHEMISTRY_SPC .GT. 0 )THEN
               CALL REPORT_ISAM_BUDGET( ISAM_LOG )
            ELSE
               MSG = "Note that ISAM found in mechanism."   
               WRITE(ISAM_LOG,'(A)')TRIM( MSG )
            END IF
        END IF    
        
        END SUBROUTINE SA_IRR_INIT
      REAL(8) FUNCTION EFFECT_REACTION( NAMINDX, NRX, OCCURS )

C-----------------------------------------------------------------------
C Function: To find net effect on the number of species molecules from a reaction 
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Bill Hutzell, May, 2018
C-----------------------------------------------------------------------
      USE RXNS_DATA

      IMPLICIT NONE
      
C Includes: None
      
C Arguments:
      INTEGER,        INTENT(IN )   :: NAMINDX  ! Index for chemistry species 
      INTEGER,        INTENT(IN )   :: NRX      ! Reaction number
      INTEGER,        INTENT(INOUT) :: OCCURS   ! Number of products and reaction 
                                        
C Parameters: None

C External Functions: None 

C Local Variables:

      CHARACTER( 16 ) :: SPECIS    ! Species name to check

      INTEGER INDX       ! Pointer to reactant or product in CHEMISTRY_SPC array
      INTEGER IRRPNTR    ! Pointer to reactant or product in IRR array
      INTEGER N          ! Loop index over IRR array

      REAL(8) TOTAL      ! Sum of molecular production and loss coeffecients
         
C-----------------------------------------------------------------------
      OCCURS = 0
      TOTAL  = 0.0D0

      SPECIS = CHEMISTRY_SPC( NAMINDX )
c..Subtract the number of species molecules lost in this reaction
      DO N = 1, NREACT( NRX )
         INDX = IRR( NRX, N )
         IF ( INDX .EQ. NAMINDX ) THEN
             TOTAL  = TOTAL - 1.0D0
             OCCURS = OCCURS + 1
         END IF    
      END DO
      
c..Add the number of species molecules produced in this reaction
      DO N = 1, NPRDCT( NRX )
         IRRPNTR = N + 3
         INDX = IRR( NRX, IRRPNTR )
         IF ( INDX .EQ. NAMINDX ) THEN
             TOTAL  = TOTAL + REAL( SC( NRX,N ), 8)
             OCCURS = OCCURS + 1
         END IF    
      END DO

      EFFECT_REACTION = TOTAL

      RETURN

      END FUNCTION EFFECT_REACTION
      SUBROUTINE REPORT_MECH_BUDGET( OUT_UNIT )
!        purpose writes out 
         USE RXNS_DATA

         IMPLICIT NONE


!..Arguments:
         INTEGER,   INTENT( IN ) ::  OUT_UNIT  ! output unit #
         
        INTEGER SPC
        INTEGER IR, NR
         
        DO SPC = 1, NUMB_MECH_SPC
           WRITE(OUT_UNIT,95000)MECHANISM_BUDGET( SPC )%SPECIES_NAME, 
     &                          MECHANISM_BUDGET( SPC )%NREACTIONS
           DO NR = 1, MECHANISM_BUDGET( SPC )%NREACTIONS
              IR = MECHANISM_BUDGET( SPC )%IREACTION( NR )
              WRITE(OUT_UNIT,95001)RXLABEL( IR ),MECHANISM_BUDGET( SPC )%COEFF_NET( NR )
           END DO
              WRITE(OUT_UNIT,95005)MECHANISM_BUDGET( SPC )%SPECIES_NAME, 
     &                             MECHANISM_BUDGET( SPC )%NRXNS_PROD
              DO NR = 1, MECHANISM_BUDGET( SPC )%NRXNS_PROD
                 IR = MECHANISM_BUDGET( SPC )%IRXN_PROD( NR )
                 WRITE(OUT_UNIT,95001)RXLABEL( IR ),MECHANISM_BUDGET( SPC )%COEFF_POS( NR )
              END DO
        END DO
        
95000   FORMAT("Chemistry species, ",A16,", changed by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )
95001   FORMAT(3X,A16,1X,ES12.4)
95005   FORMAT("Radical  species, ",A16,", produced by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )

      END SUBROUTINE REPORT_MECH_BUDGET    
      SUBROUTINE REPORT_OX_RADICALS( OUT_UNIT )
!        purpose writes out production and loss reaction for each OX radical
         USE RXNS_DATA

         IMPLICIT NONE

!..Arguments:
         INTEGER,   INTENT( IN ) ::  OUT_UNIT  ! output unit #
         
        INTEGER SPC
        INTEGER IR, NR
         
        DO SPC = 1, OX_RADICAL_FOUND
           IF( OX_RADICAL_BUDGET( SPC )%NRXNS_PROD .GT. 0 )THEN
              WRITE(OUT_UNIT,95005)OX_RADICAL_BUDGET( SPC )%SPECIES_NAME, 
     &                             OX_RADICAL_BUDGET( SPC )%NRXNS_PROD
              DO NR = 1, OX_RADICAL_BUDGET( SPC )%NRXNS_PROD
                 IR = OX_RADICAL_BUDGET( SPC )%IRXN_PROD( NR )
                 WRITE(OUT_UNIT,95001)RXLABEL( IR ),OX_RADICAL_BUDGET( SPC )%COEFF_POS( NR )
              END DO
           ELSE   
              WRITE(OUT_UNIT,95003)OX_RADICAL_BUDGET( SPC )%SPECIES_NAME 
           END IF   
           IF( OX_RADICAL_BUDGET( SPC )%NRXNS_LOSS .GT. 0 )THEN
              WRITE(OUT_UNIT,95002)OX_RADICAL_BUDGET( SPC )%SPECIES_NAME, 
     &                             OX_RADICAL_BUDGET( SPC )%NRXNS_LOSS
              DO NR = 1, OX_RADICAL_BUDGET( SPC )%NRXNS_LOSS
                 IR = OX_RADICAL_BUDGET( SPC )%IRXN_LOSS( NR )
                 WRITE(OUT_UNIT,95001)RXLABEL( IR ),OX_RADICAL_BUDGET( SPC )%COEFF_NEG( NR )
              END DO
           ELSE
              WRITE(OUT_UNIT,95004)OX_RADICAL_BUDGET( SPC )%SPECIES_NAME 
           END IF   
        END DO
        
95005   FORMAT("Radical  species, ",A16,", produced by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )
95001   FORMAT(3X,A16,1X,ES12.4)
95002   FORMAT("Radical  species, ",A16,", destoryed by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )
95003   FORMAT(A16, " radical not produced by any reactions.")
95004   FORMAT(A16, " radical not destoryed by any reactions.")

      END SUBROUTINE REPORT_OX_RADICALS
      SUBROUTINE REPORT_ISAM_BUDGET( OUT_UNIT )
!        purpose writes out 
         USE RXNS_DATA

         IMPLICIT NONE


!..Arguments:
         INTEGER,   INTENT( IN ) ::  OUT_UNIT  ! output unit #
         
        INTEGER SPC
        INTEGER IR, NR
         
        DO SPC = 1, ISAM_CHEMISTRY_SPC
           WRITE(OUT_UNIT,95100)ISAM_SPC_BUDGET( SPC )%SPECIES_NAME, 
     &                          ISAM_SPC_BUDGET( SPC )%NREACTIONS
           DO NR = 1, ISAM_SPC_BUDGET( SPC )%NREACTIONS
              IR = ISAM_SPC_BUDGET( SPC )%IREACTION( NR )
              WRITE(OUT_UNIT,95101)RXLABEL( IR ),ISAM_SPC_BUDGET( SPC )%COEFF_NET( NR )
           END DO
              WRITE(OUT_UNIT,95105)ISAM_SPC_BUDGET( SPC )%SPECIES_NAME, 
     &                             ISAM_SPC_BUDGET( SPC )%NRXNS_PROD
              DO NR = 1, ISAM_SPC_BUDGET( SPC )%NRXNS_PROD
                 IR = ISAM_SPC_BUDGET( SPC )%IRXN_PROD( NR )
                 WRITE(OUT_UNIT,95101)RXLABEL( IR ),ISAM_SPC_BUDGET( SPC )%COEFF_POS( NR )
              END DO
        END DO
        
95100   FORMAT("   ISAM  species, ",A16,", changed by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )
95101   FORMAT(3X,A16,1X,ES12.4)
95105   FORMAT("   ISAM  species, ",A16,", produced by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )

      END SUBROUTINE REPORT_ISAM_BUDGET    
      SUBROUTINE SA_IRR_EXTRACT( COL, ROW, LAY, DENS, CONC )
                
          USE HGRD_DEFN
          USE VGRD_DEFN
          USE RXNS_DATA
          USE UTILIO_DEFN
          USE SA_DEFN  

         IMPLICIT NONE

!..Arguments:
         INTEGER,   INTENT( IN ) ::  COL        ! cell column index
         INTEGER,   INTENT( IN ) ::  ROW        ! cell row index 
         INTEGER,   INTENT( IN ) ::  LAY        ! cell layer index      
         REAL,      INTENT( IN ) ::  DENS       ! air mass density, kg/m3
         REAL(8),   INTENT( IN ) ::  CONC( : )  ! cgrid concentrations

!..Local:
         CHARACTER( 16 ), PARAMETER :: PNAME = 'SA_IRR_EXTRACT'     ! Program name

         REAL      :: FACTOR2
         REAL( 8 ) :: TOTAL, FACTOR1, FACTOR3
         REAL( 8 ) :: INV_DENS       ! one over air mass density, m3/kg

         INTEGER :: JSPC, KTAG
!..variables borrowed from DDM
         INTEGER :: I, J, RXN
         INTEGER :: C, L, R, S   ! Loop indices
         INTEGER :: SPC          ! array index
!        REAL(8) :: TAGS_TOTAL
         
!         INTEGER :: IOS         
!         CHARACTER( 132 )  :: MSG

          SOLD = ZERO

          INV_DENS = REAL( ONE/DENS, 8 )
          
          DO JSPC = 1, ISAM_CHEMISTRY_SPC
             S       = ISAM_TO_CHEM( JSPC )
             SPC     = ISAM_SPC_MAP( JSPC )
             IS_TAG_NONZERO = .FALSE.
             LOAD_SOLD: DO KTAG = 1, NTAG_SA
                SOLD( KTAG, S ) = MAX( ZERO,
     &                            REAL( ISAM( COL,ROW,LAY,SPC,KTAG ),8 ))
             END DO LOAD_SOLD ! ktag loop
!            TAGS_TOTAL = SUM( SOLD( 1:NTAG_SA, S ) )
!            TAGS_TOTAL = 1.0D0 / MAX( TAGS_TOTAL, DCONMIN_TAG )
             FILTER_SOLD: DO KTAG = 1, NTAG_SA
!               FRAC_TOTAL( KTAG ) = SOLD( KTAG, S ) * TAGS_TOTAL
                IF( SOLD( KTAG, S ) .GT. ZERO )THEN
                   IS_TAG_NONZERO( KTAG ) = .TRUE.
                   IF( CONVERT_ISAM( JSPC ) )THEN
                      SOLD( KTAG, S ) = SOLD( KTAG, S )
     &                                * INV_DENS * UGM3_TO_PPM( JSPC )
                   END IF
                   IF( SOLD( KTAG,S ) .LT. CUTOFF )THEN
                      SOLD( KTAG,S ) = ZERO
                   END IF
                END IF
             END DO FILTER_SOLD ! ktag loop

! Remove bangs to prevent All SOLD equaling zero               
!             IF( MAXVAL( SOLD( 1:NTAG_SA,S ) ) .LE. ZERO )THEN
!                IF( ANY( IS_TAG_NONZERO ) )THEN
!                    DO KTAG = 1, NTAG_SA                    
!                       IF( IS_TAG_NONZERO( KTAG ) )THEN
!                          SOLD( KTAG,S ) = FRAC_TOTAL( KTAG ) * DCONMIN_TAG
!                       END IF
!                    END DO
!             END IF    
          END DO ! loop jspc

#ifdef verbose_isam          
          IF( WRITE_CELL )THEN
             DO KTAG = 1, NTAG_SA
               WRITE(ISAM_LOG,*)' '
               WRITE(ISAM_LOG,'(A24,2(1X,ES12.4))')'Initial MAX Values',
     &         MAXVAL(ISAM(:,:,:,:,KTAG))
             END DO ! ktag loop
             DO JSPC = 1, NSPC_SA 
                  TOTAL = SUM( ISAM( COL,ROW,LAY,JSPC,1:NTAG_SA ) )
                  WRITE(ISAM_LOG,'(A16,11(1X,ES12.4))')ISAM_SPEC( JSPC,OTHRTAG ),
     &            (ISAM( COL,ROW,LAY,JSPC,KTAG ),KTAG = 1, NTAG_SA), TOTAL
             END DO
             WRITE(ISAM_LOG,*)'EX: Initial Totals'
             DO JSPC = 1, ISAM_CHEMISTRY_SPC
                S   = ISAM_TO_CHEM( JSPC )
                SPC = ISAM_SPC_MAP( JSPC ) 
                TOTAL = 0.0
                DO KTAG = 1, NTAG_SA
                   TOTAL = TOTAL + ISAM( COL,ROW,LAY,SPC,KTAG )
                END DO 
                WRITE(ISAM_LOG,'(2(A16,1X),5(1X,ES12.4))')ISAM_SPEC( SPC,OTHRTAG ), CHEMISTRY_SPC(S), 
     &          TOTAL, CONC( S ),TOTAL-CONC( S ), TOTAL/CONC( S )
             END DO ! loop jspc
          END IF
#endif
        END SUBROUTINE SA_IRR_EXTRACT
        SUBROUTINE SA_IRR_UPLOAD( COL, ROW, LAY, DENS, CONC )
                
          USE HGRD_DEFN
          USE VGRD_DEFN
          USE RXNS_DATA
          USE UTILIO_DEFN
          USE SA_DEFN    ! 20130517

         IMPLICIT NONE

!..Arguments:
         INTEGER,   INTENT( IN ) ::  COL        ! cell column index
         INTEGER,   INTENT( IN ) ::  ROW        ! cell row index 
         INTEGER,   INTENT( IN ) ::  LAY        ! cell layer index      
         REAL,      INTENT( IN ) ::  DENS       ! air mass density, kg/m3
         REAL(8),   INTENT( IN ) ::  CONC( : )  ! cgrid concentrations

!..Local:
         CHARACTER( 16 ), PARAMETER :: PNAME = 'SA_IRR_UPLOAD'     ! Program name

         REAL      :: TOTAL
         REAL( 8 ) :: INV_DENS       ! one over air mass density, m3/kg

         INTEGER :: JSPC, KTAG
         INTEGER :: I, J, RXN
         INTEGER :: C, L, R, S   ! Loop indices
         INTEGER :: SPC          ! array index
         
!         INTEGER :: IOS         
!         CHARACTER( 132 )  :: MSG

         REAL :: TEMP_VALUE

         DO JSPC = 1, ISAM_CHEMISTRY_SPC
            S   = ISAM_TO_CHEM( JSPC )
            SPC = ISAM_SPC_MAP( JSPC ) 
            LOAD_ISAM: DO KTAG = 1, NTAG_SA
               IF( SOLD( KTAG,S ) .GT. DCONCMIN )THEN
                 TEMP_VALUE = REAL( SOLD( KTAG,S ) )
                 IF( CONVERT_ISAM( JSPC ) )THEN
                     TEMP_VALUE = TEMP_VALUE
     &                          * DENS * PPM_TO_UGM3( JSPC )
                 END IF
                 ISAM( COL,ROW,LAY,SPC,KTAG ) = MAX( CONMIN_TAG, TEMP_VALUE )
               ELSE
                 ISAM( COL,ROW,LAY,SPC,KTAG ) = ZERO
               END IF    
            END DO LOAD_ISAM ! ktag loop     
         END DO   ! jspc
 
#ifdef verbose_isam             
          IF( WRITE_CELL )THEN
             DO KTAG = 1, NTAG_SA
               WRITE(ISAM_LOG,*)' '
               WRITE(ISAM_LOG,'(A24,2(1X,ES12.4))')'Final MAX Values',
     &         MAXVAL(ISAM(:,:,:,:,KTAG))
             END DO ! ktag loop
             DO JSPC = 1, NSPC_SA 
                  TOTAL = SUM( ISAM( COL,ROW,LAY,JSPC,1:NTAG_SA ) )
                  WRITE(ISAM_LOG,'(A16,11(1X,ES12.4))')ISAM_SPEC( JSPC,OTHRTAG ),
     &            (ISAM( COL,ROW,LAY,JSPC,KTAG ),KTAG = 1, NTAG_SA), TOTAL
             END DO
             WRITE(ISAM_LOG,*)'UP: Final Totals'
             DO JSPC = 1, ISAM_CHEMISTRY_SPC
                S   = ISAM_TO_CHEM( JSPC )
                SPC = ISAM_SPC_MAP( JSPC )
                TEMP_VALUE =  MAX( REAL(CONC( S )),1.0E-30 )
                TOTAL = 0.0
                DO KTAG = 1, NTAG_SA
                   TOTAL = TOTAL + ISAM( COL,ROW,LAY,SPC,KTAG )
                END DO 
                WRITE(ISAM_LOG,'(2(A16,1X),3(1X,ES12.4))')ISAM_SPEC( SPC,OTHRTAG ), CHEMISTRY_SPC(S), 
     &          TOTAL,TEMP_VALUE,TOTAL-TEMP_VALUE
             END DO ! loop jspc
          END IF
#endif
        END SUBROUTINE SA_IRR_UPLOAD
C----------------------------------------------------------------------
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SA_IRR_UNBLOCKED ( LSTART, RK, CONC, DELT )

C-----------------------------------------------------------------------
C  Function: Iupdate tag concentrations
 
C  Preconditions: None
 
C  Key Subroutines/Functions Called: None
 
C  Revision History:
C   Prototype created by Jerry Gipson, September, 1996
C   global BLKPRM Jeff Dec 96
C   Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C   Modified Jun, 1998 by Jerry Gipson to add reaction number error checks
C   Modified 1/19/99 by David Wong at LM:
C                      -- add four include files because of new PA_CMN.EXT
C   Modified 2/26/99 by David Wong at LM:
C                      -- remove SUBST_AE_SPC, SUBST_NR_SPC, SUBST_TR_SPC,
C                         three .EXT files
C   31 Mar 01 J.Young: Use HGRD_DEFN; eliminate BLKPRM.EXT
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   19 Aug 11 J.Young: Replaced I/O API include files with UTILIO_DEFN
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module

C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE RXNS_DATA             ! chemical mechanism data
      USE CGRID_SPCS            ! CGRID mechanism species
      USE SA_DEFN
      USE UTILIO_DEFN

      IMPLICIT NONE 

C..Includes: None
      
C..Arguments: 
      LOGICAL, INTENT( IN ) :: LSTART   ! Flag to indicate start of chemical integration period

      REAL( 8 ),    INTENT( IN ) :: RK  ( : )    ! Reaction rate coefficients
      REAL( 8 ),    INTENT( IN ) :: CONC( : )    ! species concentrations
      REAL( 8 ),    INTENT( IN ) :: DELT         ! Chemistry integration time size

C..Parameters: None

      REAL(8), SAVE  :: NOX_VOC_SWITCH ! REAL( VOC_NOX_TRANS,8 ), switch between NOx to limiting ozone production
      
C..External Functions: None
 
      CHARACTER( 16 ) , SAVE :: PNAME = 'PA_IRR'   ! Program name
      CHARACTER( 132)        :: MSG

      LOGICAL, SAVE :: LFIRST = .TRUE.   ! Flag for first call to subroutine

C..Scratch Local Variables:
      INTEGER ISP1, ISP2, ISP3  ! Species indices
      INTEGER    S, JSPC,  SPC  ! Species indices
      INTEGER NCELL             ! Loop index for cells
      INTEGER NIRR              ! Loop index for IRR outputs
      INTEGER NOUT              ! IRR output index
      INTEGER NC,NR,NRX         ! Loop index for reactions
      INTEGER NTEMP             ! Loop index for temp IRRs
      INTEGER NTERM             ! Loop index for terms
      INTEGER ASTAT             ! allocation status
      INTEGER KTAG              ! Loop index/pointer for source
      INTEGER POSITIVE          ! count of tag concentration greater than zero

      REAL(8) TOTAL                   ! scratch term for summations
      REAL(8) TOTAL_PROD              ! scratch term for total bulk production
      REAL(8) ISAM_PROD               ! scratch term for total isam production
      REAL(8) TERM                    ! scratch term for summations
      REAL(8) TOTAL_LOSS              ! scratch term for total bulk loss
      REAL(8) ISAM_LOSS               ! scratch term for total isam loss
      REAL(8) LOSS_FACT               ! effective loss frequency
      REAL(8) DELTA_BULK              ! change in bulk concentration
      REAL(8) DELTA_H2O2              ! change in bulk H2O2 concentration
      REAL(8) DELTA_HNO3              ! change in bulk HNO3 concentration
      REAL(8) COEFF                   ! Coefficient of IRR term
      REAL(8) TOTAL_PROBABILITY       ! normalization coefficient for SOURCE_PROBABILITY
      REAL(8) ISAM_TOTAL_PROBABILITY  ! normalization coefficient for ISAM_PROBABILITY
      REAL(8) H2O2_Production         ! gross hydrogen peroxide production
      REAL(8) HNO3_Production         ! gross nitric acid production
      
      LOGICAL :: REMOVED                 = .FALSE.   ! whether initial concentrations are wiped out
      LOGICAL, SAVE :: DISTRIBUTE_TO_ALL = .TRUE.    ! distribute extra production among all source tags 
                                                     ! or just to the other source tag
                                                     
      LOGICAL, ALLOCATABLE, SAVE   :: SOURCE_ZERO( : ) ! whether source concentration greater than zero 
C..Saved Local Variables:

      REAL( 8 ), ALLOCATABLE, SAVE :: YCOLD  ( : )     ! bulk concentrations from previous time step
      REAL( 8 ), ALLOCATABLE, SAVE :: OUTSIDE( : )     ! species concentration outside isam tags
      REAL( 8 ), ALLOCATABLE, SAVE :: YCMID  ( : )     ! bulk concentrations from previous time step
      REAL( 8 ), ALLOCATABLE, SAVE :: YCRATES( : )     ! bulk concentration used to calculate reactionvrates 
      REAL( 8 ), ALLOCATABLE, SAVE :: RXRAT  ( : )     ! reactions rates   
      REAL( 8 ), ALLOCATABLE, SAVE :: INTRXN ( : )     ! Integrated reaction rates

      REAL( 8 ) :: ONE_OVER_CONC      ! reciprocal of total species concentrations
      REAL( 8 ), ALLOCATABLE, SAVE :: TOTAL_ISAM_CONC( : )      ! total concentrations from isam sources
      REAL( 8 ), ALLOCATABLE, SAVE :: NOT_OUTSIDE_ISAM( : )     ! fraction of species not from non-isam sources
      REAL( 8 ), ALLOCATABLE, SAVE :: NOT_ISAM_SOURCE( :,: )    ! fraction of species not from an isam source
      REAL( 8 ), ALLOCATABLE, SAVE :: ISAM_SOURCE( :,: )        ! fraction of species from an isam source
      REAL( 8 ), ALLOCATABLE, SAVE :: SOURCE_PROBABILITY( :,: ) ! probability or amount that a source contributes to reaction
      REAL( 8 ), ALLOCATABLE, SAVE :: SOURCE_DELTA   ( :,: )    ! change in source tag species 
      REAL( 8 ), ALLOCATABLE, SAVE :: SA_DELTA( : )
      REAL( 8 ), ALLOCATABLE, SAVE :: SA_LOSS( : )
      REAL( 8 ), ALLOCATABLE, SAVE :: ISAM_PROBABILITY  ( :,: ) ! probability or amount that a source contributes to reaction      
      LOGICAL,   ALLOCATABLE, SAVE :: ZERO_ISAM( :           )  ! whether isam species have no effect on reaction
      LOGICAL,   ALLOCATABLE, SAVE :: REBALANCE( : )            ! renormalize tag concentration when production occurs
      LOGICAL,   ALLOCATABLE, SAVE :: SOURCE_NONZERO( :,: )     ! fraction of species not from an isam source

      INTEGER,   ALLOCATABLE, SAVE :: MAP_REACTANT_CASE( : )      
      LOGICAL,   ALLOCATABLE, SAVE :: TWO_REACTANT_CASE( :,:,: )
      LOGICAL,   ALLOCATABLE, SAVE :: THREE_REACTANT_CASE( :,:,: )
      
      

C-----------------------------------------------------------------------

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  On first call, flag the reactions for which to calculate IRRS
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LFIRST ) THEN

C set value of NOX_VOC_SWITCH

        NOX_VOC_SWITCH = REAL( VOC_NOX_TRANS,8 )

C Allocate arrays:

        ALLOCATE( YCOLD( NUMB_MECH_SPC ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating YCOLD variable'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
        END IF

        ALLOCATE( YCMID( NUMB_MECH_SPC ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating YCOLD variable'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
        END IF
        
        ALLOCATE( YCRATES( NUMB_MECH_SPC ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating YCRATES variable'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
        END IF
        
        ALLOCATE( OUTSIDE( NUMB_MECH_SPC ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating YCOLD variable'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
        END IF
        
        OUTSIDE = 0.0D0
        
        ALLOCATE( RXRAT  ( NRXNS ),
     &            INTRXN ( NRXNS ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
        END IF

!         ALLOCATE( ONE_OVER_CONC( NUMB_MECH_SPC ), STAT = ASTAT )
!         IF ( ASTAT .NE. 0 ) THEN
!           MSG = 'ERROR allocating SA_IRR variables'
!           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
!         END IF

         ALLOCATE( TOTAL_ISAM_CONC( NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( NOT_ISAM_SOURCE( NTAG_SA, NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( ISAM_SOURCE( NTAG_SA, NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( SOURCE_PROBABILITY( NTAG_SA + 1, NRXNS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( ISAM_PROBABILITY( NTAG_SA, NRXNS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating ISAM_PROBABILITY variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( ZERO_ISAM( NRXNS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating ZERO_ISAM '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( REBALANCE( NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating REBALANCE '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF
         REBALANCE = .FALSE.
             
         ALLOCATE( SOURCE_DELTA( NTAG_SA + 1, NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SOURCE_DELTA '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( SA_DELTA( NTAG_SA ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_DELTA '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( SA_LOSS( NTAG_SA ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_LOSS '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( SOURCE_ZERO( NTAG_SA + 1 ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SOURCE_ZERO '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF
         LFIRST = .FALSE.

         ALLOCATE( NOT_OUTSIDE_ISAM( NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( SOURCE_NONZERO( NTAG_SA, NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         SOURCE_NONZERO = .TRUE.

! map unimolecular, bimolecular and trimolecular reactions
         
         ALLOCATE( MAP_REACTANT_CASE( NRXNS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF
         MAP_REACTANT_CASE = -1
         
         ISP1 = 0
         ISP2 = 0
         ISP3 = 0
         DO NRX = 1, NRXNS
            SELECT CASE ( NREACT( NRX ) )
               CASE ( 1 )
                  ISP1 = ISP1 + 1                    
                  MAP_REACTANT_CASE( NRX ) = ISP1
               CASE( 2 ) 
                  ISP2 = ISP2 + 1                    
                  MAP_REACTANT_CASE( NRX ) = ISP2
               CASE( 3 )
                  ISP3 = ISP3 + 1                    
                  MAP_REACTANT_CASE( NRX ) = ISP3
            END SELECT
         END DO

         IF( ISP2 .GT. 0 )THEN
            ALLOCATE( TWO_REACTANT_CASE( NBIAS,ISP2,3 ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
              MSG = 'ERROR allocating SA_IRR variables'
              CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
            END IF
            TWO_REACTANT_CASE = .FALSE.
         END IF
         
         IF( ISP3 .GT. 0 )THEN
            ALLOCATE( THREE_REACTANT_CASE( NBIAS,ISP3,7 ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
              MSG = 'ERROR allocating SA_IRR variables'
              CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
            END IF
            THREE_REACTANT_CASE = .FALSE.
         END IF         

C...Calculate reactant cases based on species_bias for each reactant
         DO NC = 1, NBIAS
            DO NRX = 1, NRXNS
               NR = MAP_REACTANT_CASE( NRX )
               SELECT CASE ( NREACT( NRX ) )
                  CASE( 2 ) 
                      ISP1 = IRR( NRX,1 )
                      ISP2 = IRR( NRX,2 )
                      TWO_REACTANT_CASE( NC,NR,1 ) = (  BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                 .AND. .NOT. BIAS_CHEMISTRY_SPC( NC,ISP2 ) )
                      TWO_REACTANT_CASE( NC,NR,2 ) = ( .NOT. BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                 .AND. BIAS_CHEMISTRY_SPC( NC,ISP2 ) )
                      TWO_REACTANT_CASE( NC,NR,3 ) = ( .NOT. BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                 .AND. .NOT. BIAS_CHEMISTRY_SPC( NC,ISP2 ) )
     &                                           .OR. ( BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                 .AND. BIAS_CHEMISTRY_SPC( NC,ISP2 ) )
                  CASE( 3 )
                      ISP1 = IRR( NRX,1 )
                      ISP2 = IRR( NRX,2 )
                      ISP3 = IRR( NRX,3 )
                      THREE_REACTANT_CASE( NC,NR,1 ) = (              BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                   .AND.  .NOT. BIAS_CHEMISTRY_SPC( NC,ISP2 ) 
     &                                                   .AND.  .NOT. BIAS_CHEMISTRY_SPC( NC,ISP3 ) )
                      THREE_REACTANT_CASE( NC,NR,2 ) = (        .NOT. BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                   .AND.        BIAS_CHEMISTRY_SPC( NC,ISP2 ) 
     &                                                   .AND. .NOT.  BIAS_CHEMISTRY_SPC( NC,ISP3 ) )
                      THREE_REACTANT_CASE( NC,NR,3 ) = (       .NOT.  BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                   .AND. .NOT.  BIAS_CHEMISTRY_SPC( NC,ISP2 ) 
     &                                                   .AND.        BIAS_CHEMISTRY_SPC( NC,ISP3 ) )
                      THREE_REACTANT_CASE( NC,NR,4 ) = (              BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                   .AND.        BIAS_CHEMISTRY_SPC( NC,ISP2 ) 
     &                                                   .AND. .NOT.  BIAS_CHEMISTRY_SPC( NC,ISP3 ) )
                      THREE_REACTANT_CASE( NC,NR,5 ) = (              BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                   .AND. .NOT.  BIAS_CHEMISTRY_SPC( NC,ISP2 ) 
     &                                                   .AND.        BIAS_CHEMISTRY_SPC( NC,ISP3 ) )
                      THREE_REACTANT_CASE( NC,NR,6 ) = (       .NOT.  BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                   .AND.        BIAS_CHEMISTRY_SPC( NC,ISP2 ) 
     &                                                   .AND.        BIAS_CHEMISTRY_SPC( NC,ISP3 ) )
                      THREE_REACTANT_CASE( NC,NR,7 ) = (       .NOT.  BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                   .AND. .NOT.  BIAS_CHEMISTRY_SPC( NC,ISP2 ) 
     &                                                   .AND. .NOT.  BIAS_CHEMISTRY_SPC( NC,ISP3 ) )
     &                                             .OR. (      BIAS_CHEMISTRY_SPC( NC,ISP1 ) 
     &                                                   .AND. BIAS_CHEMISTRY_SPC( NC,ISP2 ) 
     &                                                   .AND. BIAS_CHEMISTRY_SPC( NC,ISP3 ) )      
              END SELECT
             END DO
         END DO
C...Assume that ISAM_SPECIES is fixed over the domain and simulation        
         WHERE ( ISAM_SPECIES ) 
            NOT_OUTSIDE_ISAM = 1.0D0
         ELSE WHERE
            NOT_OUTSIDE_ISAM = 0.0D0
         END WHERE            
         DO ISP2 = 1, NUMB_MECH_SPC
            IF( .NOT. ISAM_SPECIES( ISP2 ) )THEN            
              DO KTAG = 1, NTAG_SA
                NOT_ISAM_SOURCE( KTAG,ISP2 ) = 1.0D0
              END DO
            END IF
         END DO            
      END IF ! LFIRST
      UPDATE_PROBABILITIES = .TRUE.
      
      IF( LSTART )THEN
!         UPDATE_SOLD = .FALSE.
         SOURCE_DELTA = 0.0D0
         DO NIRR = 1, NUMB_MECH_SPC 
            YCOLD( NIRR ) = CONC( NIRR )
         END DO
         YCMID = YCOLD
         RETURN
      END IF
      
C...filter bulk concentrations for concentrations used for reaction rates   
      WHERE ( CONC .GE. BULK_CUTOFF )
         YCRATES = CONC
      ELSE WHERE
         YCRATES = 0.0D0
      END WHERE   

C...check for bad values
         TOTAL_ISAM_CONC = 0.0D0 ! 1.0D-40
         DO ISP2 = 1, NUMB_MECH_SPC
            DO KTAG = 1, NTAG_SA
               TOTAL_ISAM_CONC( ISP2 ) = TOTAL_ISAM_CONC( ISP2 )
     &                                 + SOLD( KTAG,ISP2 )
               IF( SOLD( KTAG,ISP2 ) .LT. 0.0D0 )
     &         WRITE(ISAM_LOG,*)TRIM(CHEMISTRY_SPC(ISP2)) // ' bad value = ',SOLD( KTAG,ISP2 )
            END DO
         END DO
C..compute species fractions from ISAM groups and the remainder group for all mechanism species
!  Note that remainder group (NTAG_SA+1) exists to handle untracked model species 
      DO ISP2 = 1, NUMB_MECH_SPC
         IF( ISAM_SPECIES( ISP2 ) )THEN          
           ONE_OVER_CONC   = 1.0D0 / MAX( TOTAL_ISAM_CONC( ISP2 ), DCONMIN_TAG )
           DO KTAG = 1, NTAG_SA
             ISAM_SOURCE( KTAG,ISP2 )     = SOLD( KTAG,ISP2 )*ONE_OVER_CONC
             NOT_ISAM_SOURCE( KTAG,ISP2 ) = MAX( 0.0D0, 1.0D0-ISAM_SOURCE( KTAG,ISP2 ))
           END DO
           OUTSIDE( ISP2 ) = 0.0D0    
           NOT_OUTSIDE_ISAM( ISP2 ) = 1.0D0
         ELSE
           ONE_OVER_CONC   = 1.0D0 / MAX( YCMID( ISP2 ), DCONMIN_TAG )
           DO KTAG = 1, NTAG_SA
             ISAM_SOURCE( KTAG,ISP2 )     = SOLD( KTAG,ISP2 )*ONE_OVER_CONC
             NOT_ISAM_SOURCE( KTAG,ISP2 ) = MAX( 0.0D0, 1.0D0-ISAM_SOURCE( KTAG,ISP2 ))
           END DO
           IF ( TOTAL_ISAM_CONC( ISP2 ) .GT. DCONMIN_TAG ) THEN
              TERM = MAX( (YCMID( ISP2 )-TOTAL_ISAM_CONC( ISP2 )), 0.0D0 )
           ELSE
              TERM =  YCMID( ISP2 )
           END IF
           OUTSIDE( ISP2 ) = TERM    
           NOT_OUTSIDE_ISAM( ISP2 ) = MAX( 1.0D0 - TERM * ONE_OVER_CONC, 0.0D0 )
         END IF
         DO KTAG = 1, NTAG_SA
           IF( SOLD( KTAG,ISP2 ) .GE. DCONMIN_TAG )THEN
              SOURCE_NONZERO(  KTAG,ISP2 ) = .TRUE.
           ELSE
              SOURCE_NONZERO(  KTAG,ISP2 ) = .FALSE.
           END IF  
        END DO
      END DO 

C...Calculate reaction rates and source probabilties
        IF ( ISAM_CHEM_BIAS .EQ. 5 ) THEN
!  for concentrations 0.35 is average of range in 
!      Sillman et al. (1998). J. Geophys. Res., 103, 22,629–22,644, 
!  but Need to add routine that HNO2 and H2O2 production based MECHANISM_BUDGET array  
!            
! determine if net production of ozone takes place
!           IF ( (CONC( O3_INDEX )-YCMID( O3_INDEX )) .GT. 0.0D0 ) THEN 
! Using net change in H2O2 and HNO3 concentrations
!              DELTA_H2O2 = CONC( H2O2_INDEX )-YCMID( H2O2_INDEX )
!              DELTA_HNO3 = CONC( HNO3_INDEX )-YCMID( HNO3_INDEX )
!              IF ( DELTA_H2O2/MAX( 1.0D-30,DELTA_NO3 ) .LT. VOC_NOX_TRANS  ) THEN
! Using H2O2 and HNO3 concentrations
!              IF ( CONC( H2O2_INDEX )/MAX( 1.0D-30,CONC( HNO3_INDEX ) ) .LT. VOC_NOX_TRANS  ) THEN
! Using gross production of H2O2 and HNO3
               VOC_TO_NOX = PH2O2_OVER_PHNO3( RK,CONC )
               IF ( VOC_TO_NOX .GT. NOX_VOC_SWITCH  ) THEN
!              IF ( PH2O2_OVER_PHNO3( RK,CONC ) .GT. REAL( VOC_NOX_TRANS,8 )  ) THEN
                  NC = ISAM_NOX_CASE
               ELSE 
                  NC = ISAM_VOC_CASE
               END IF

!           ELSE
!              NC = 3
!           END IF
            IF ( WRITE_CELL ) THEN

                WRITE(ISAM_LOG,*)'PH2O2_OVER_PHNO3, NC = ',PH2O2_OVER_PHNO3( RK,CONC ), NC

            END IF
        ELSE 
            NC = ISAM_CHEM_BIAS
            VOC_TO_NOX = NOX_VOC_SWITCH
        END IF
        DO NRX = 1, NRXNS
            NR = MAP_REACTANT_CASE( NRX )
            SELECT CASE ( NREACT( NRX ) )
               CASE( 1 )
                  ISP1 = IRR( NRX,1 )
                  RXRAT( NRX ) = RK( NRX )
     &                         * YCRATES( ISP1 )
                  DO KTAG = 1, NTAG_SA
                    SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 - NOT_ISAM_SOURCE( KTAG,ISP1 ) 
                  END DO
                  KTAG = NTAG_SA + 1
                  SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 - NOT_OUTSIDE_ISAM( ISP1 ) 
               CASE( 2 ) 
                   ISP1 = IRR( NRX,1 )
                   ISP2 = IRR( NRX,2 )
                   RXRAT( NRX ) = RK( NRX )
     &                          * YCRATES( ISP1 )
     &                          * YCRATES( ISP2 ) 
                   IF ( TWO_REACTANT_CASE( NC,NR,1 ) ) THEN
                       DO KTAG = 1, NTAG_SA
                         SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                  -  NOT_ISAM_SOURCE( KTAG,ISP1 ) 
                       END DO
                       KTAG = NTAG_SA + 1
                       SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                -  NOT_OUTSIDE_ISAM( ISP1 ) 
                   ELSE IF ( TWO_REACTANT_CASE( NC,NR,2 ) ) THEN
                       DO KTAG = 1, NTAG_SA
                         SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                  -  NOT_ISAM_SOURCE( KTAG,ISP2 ) 
                       END DO
                       KTAG = NTAG_SA + 1
                       SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                -  NOT_OUTSIDE_ISAM( ISP2 ) 
                   ELSE IF ( TWO_REACTANT_CASE( NC,NR,3 ) ) THEN
                       DO KTAG = 1, NTAG_SA
                         SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                  -  NOT_ISAM_SOURCE( KTAG,ISP1 ) 
     &                                                  *  NOT_ISAM_SOURCE( KTAG,ISP2 ) 
                       END DO
                       KTAG = NTAG_SA + 1
                       SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                -  NOT_OUTSIDE_ISAM( ISP1 ) 
     &                                                *  NOT_OUTSIDE_ISAM( ISP2 ) 

                   END IF
               CASE( 3 )
                   ISP1 = IRR( NRX,1 )
                   ISP2 = IRR( NRX,2 )
                   ISP3 = IRR( NRX,3 )
                   RXRAT( NRX ) = RK( NRX )
     &                          * YCRATES( ISP1 )
     &                          * YCRATES( ISP2 )
     &                          * YCRATES( ISP3 ) 
                   IF ( THREE_REACTANT_CASE( NC,NR,1 ) ) THEN
                       DO KTAG = 1, NTAG_SA
                         SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                  -  NOT_ISAM_SOURCE( KTAG,ISP1 ) 
                       END DO
                       KTAG = NTAG_SA + 1
                       SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                -  NOT_OUTSIDE_ISAM( ISP1 ) 
                   ELSE IF ( THREE_REACTANT_CASE( NC,NR,2 ) ) THEN
                       DO KTAG = 1, NTAG_SA
                         SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                  -  NOT_ISAM_SOURCE( KTAG,ISP2 ) 
                       END DO
                       KTAG = NTAG_SA + 1
                       SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                -  NOT_OUTSIDE_ISAM( ISP2 ) 
                   ELSE IF ( THREE_REACTANT_CASE( NC,NR,3 ) ) THEN
                       DO KTAG = 1, NTAG_SA
                         SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                  -  NOT_ISAM_SOURCE( KTAG,ISP3 ) 
                       END DO
                       KTAG = NTAG_SA + 1
                       SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                -  NOT_OUTSIDE_ISAM( ISP3 ) 
                   ELSE IF ( THREE_REACTANT_CASE( NC,NR,4 ) ) THEN
                       DO KTAG = 1, NTAG_SA
                         SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                  -  NOT_ISAM_SOURCE( KTAG,ISP1 ) 
     &                                                  *  NOT_ISAM_SOURCE( KTAG,ISP2 ) 
                       END DO
                       KTAG = NTAG_SA + 1
                       SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                *  NOT_OUTSIDE_ISAM( ISP1 ) 
     &                                                *  NOT_OUTSIDE_ISAM( ISP2 ) 

                   ELSE IF ( THREE_REACTANT_CASE( NC,NR,5 ) ) THEN
                       DO KTAG = 1, NTAG_SA
                         SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                  -  NOT_ISAM_SOURCE( KTAG,ISP1 ) 
     &                                                  *  NOT_ISAM_SOURCE( KTAG,ISP3 ) 
                       END DO
                       KTAG = NTAG_SA + 1
                       SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                *  NOT_OUTSIDE_ISAM( ISP1 ) 
     &                                                *  NOT_OUTSIDE_ISAM( ISP3 ) 
                   ELSE IF ( THREE_REACTANT_CASE( NC,NR,6 ) ) THEN
                       DO KTAG = 1, NTAG_SA
                         SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                  -  NOT_ISAM_SOURCE( KTAG,ISP2 ) 
     &                                                  *  NOT_ISAM_SOURCE( KTAG,ISP3 ) 
                       END DO
                       KTAG = NTAG_SA + 1
                       SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                *  NOT_OUTSIDE_ISAM( ISP1 ) 
     &                                                *  NOT_OUTSIDE_ISAM( ISP3 ) 
                   ELSE IF ( THREE_REACTANT_CASE( NC,NR,7 ) ) THEN
                        DO KTAG = 1, NTAG_SA
                          SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                   -  NOT_ISAM_SOURCE( KTAG,ISP1 ) 
     &                                                   *  NOT_ISAM_SOURCE( KTAG,ISP2 ) 
     &                                                   *  NOT_ISAM_SOURCE( KTAG,ISP3 ) 
                        END DO
                        KTAG = NTAG_SA + 1
                        SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                                 -  NOT_OUTSIDE_ISAM( ISP1 ) 
     &                                                 *  NOT_OUTSIDE_ISAM( ISP2 ) 
     &                                                 *  NOT_OUTSIDE_ISAM( ISP3 ) 
                   END IF
               CASE( 0 ) 
                  RXRAT( NRX ) = RK( NRX )
                  DO KTAG = 1, NTAG_SA
                     SOURCE_PROBABILITY( KTAG,NRX ) = 0.0D0 
                  END DO
                  KTAG = NTAG_SA + 1
                  SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
            END SELECT
C..Normalize sources probabilities for reaction
            ISAM_TOTAL_PROBABILITY  =  0.0D0
            DO KTAG = 1, NTAG_SA
               SOURCE_PROBABILITY( KTAG,NRX ) = MAX( SOURCE_PROBABILITY( KTAG,NRX ), 0.0D0 )
               ISAM_PROBABILITY  ( KTAG,NRX ) = SOURCE_PROBABILITY( KTAG,NRX )
               ISAM_TOTAL_PROBABILITY = ISAM_TOTAL_PROBABILITY + ISAM_PROBABILITY( KTAG,NRX )
            END DO
            KTAG = NTAG_SA + 1
            SOURCE_PROBABILITY( KTAG,NRX ) = MAX( SOURCE_PROBABILITY( KTAG,NRX ), 0.0D0 )
            TOTAL_PROBABILITY = ISAM_TOTAL_PROBABILITY + SOURCE_PROBABILITY( KTAG,NRX )
            IF( ISAM_TOTAL_PROBABILITY .LE. 1.0D-30 )THEN
                ZERO_ISAM( NRX ) = .TRUE. 
                DO KTAG = 1, NTAG_SA
                   ISAM_PROBABILITY( KTAG,NRX ) = 0.0D0
                END DO
!               ISAM_PROBABILITY( OTHRTAG,NRX ) = 1.0D0
            ELSE
                ZERO_ISAM( NRX ) = .FALSE.
                ISAM_TOTAL_PROBABILITY = 1.0D0 / ISAM_TOTAL_PROBABILITY
                DO KTAG = 1, NTAG_SA
                   ISAM_PROBABILITY( KTAG,NRX ) = ISAM_PROBABILITY( KTAG,NRX )
     &                                          * ISAM_TOTAL_PROBABILITY
                END DO
            END IF    
            IF( TOTAL_PROBABILITY .LT. 0.0D0 )THEN
               DO JSPC = 1, ISAM_CHEMISTRY_SPC
                  S   = ISAM_TO_CHEM( JSPC )
                  SPC = ISAM_SPC_MAP( JSPC ) 
                  WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')CHEMISTRY_SPC(S),(SOLD( KTAG, S ),KTAG=1,NTAG_SA ),
     &            YCOLD( S )
               END DO ! loop jspc
               MSG = 'Fraction Results, note that last column is total isam over total species CONCentration'
               WRITE(ISAM_LOG,'(A)')TRIM(MSG)
               WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Species/Tag #',(KTAG,KTAG=1,NTAG_SA+1)
               DO ISP2 = 1, NUMB_MECH_SPC
                  WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')CHEMISTRY_SPC(ISP2),
     &           (1.0D0-NOT_ISAM_SOURCE( KTAG,ISP2 ),KTAG=1,NTAG_SA),1.0D0-NOT_OUTSIDE_ISAM( ISP2 )
               END DO

               MSG = 'Unnormalized Source Probabilities, note that last column is for NonISAM CONCentrations'
               WRITE(ISAM_LOG,'(A)')TRIM(MSG)
               WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Reaction/Tag #',(KTAG,KTAG=1,NTAG_SA+1)
               WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')RXLABEL( NRX ),
     &         (SOURCE_PROBABILITY( KTAG,NRX ),KTAG=1,NTAG_SA+1)

               MSG = 'TOTAL_PROBABILITY < zero from reaction label: ' 
     &             // TRIM( RXLABEL( NRX ) )
               CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
            ELSE IF( TOTAL_PROBABILITY .EQ. 0.0D0 )THEN   
               TOTAL_PROBABILITY = 1.0D0
            END IF
            TOTAL_PROBABILITY = 1.0D0 / TOTAL_PROBABILITY
            DO KTAG = 1, NTAG_SA + 1
               SOURCE_PROBABILITY( KTAG,NRX ) = SOURCE_PROBABILITY( KTAG,NRX )
     &                                        * TOTAL_PROBABILITY
            END DO
        END DO
#ifdef verbose_isam
        IF( WRITE_CELL )THEN
           MSG = 'Calculated Source Probabilities, note that last column is for NonISAM concentrations'
           WRITE(ISAM_LOG,'(A)')TRIM(MSG)
           WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Reaction/Tag #',(KTAG,KTAG=1,NTAG_SA+1)
           DO NRX = 1, NRXNS
              WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')RXLABEL( NRX ),
     &        (SOURCE_PROBABILITY( KTAG,NRX ),KTAG=1,NTAG_SA+1)
           END DO
           MSG = 'Caculated ISAM Probabilities, note that last column is their sum'
           WRITE(ISAM_LOG,'(A)')TRIM(MSG)
           WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Reaction/Tag #',(KTAG,KTAG=1,NTAG_SA+1)
           DO NRX = 1, NRXNS
              ISAM_TOTAL_PROBABILITY = SUM( ISAM_PROBABILITY( 1:NTAG_SA,NRX ) )
              WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')RXLABEL( NRX ),
     &       (ISAM_PROBABILITY( KTAG,NRX ),KTAG=1,NTAG_SA),ISAM_TOTAL_PROBABILITY
           END DO
         END IF ! WRITE_CELL  
#endif         

C..Compute integrated reaction rates
      DO NRX = 1, NRXNS
          INTRXN( NRX ) = DELT * RXRAT( NRX )
      END DO

c..Compute change in source concentrations for updating source concentrations
        DO JSPC = 1, NUMB_MECH_SPC
! compute species total production and isam production 
             ISAM_PROD  = 0.0D0
             TOTAL_PROD = 0.0D0
             SA_DELTA   = 0.0D0
             DO NTERM = 1, MECHANISM_BUDGET( JSPC )%NRXNS_PROD
                NRX   = MECHANISM_BUDGET( JSPC )%IRXN_PROD( NTERM )
                COEFF = MECHANISM_BUDGET( JSPC )%COEFF_POS( NTERM )
     &                * INTRXN( NRX )
                TOTAL_PROD = TOTAL_PROD + COEFF
                IF( .NOT. ZERO_ISAM( NRX ) )THEN
                  DO KTAG = 1, NTAG_SA
                     TERM      = COEFF 
     &                         * MIN( (SOURCE_PROBABILITY( KTAG,NRX ) 
     &                         +       SOURCE_PROBABILITY((NTAG_SA+1),NRX )
     &                         *       ISAM_PROBABILITY  ( KTAG,NRX )),
     &                                 1.0D0 )
                     ISAM_PROD = ISAM_PROD + TERM
                     SA_DELTA( KTAG ) = SA_DELTA( KTAG ) + TERM
                  END DO                    
                END IF
             END DO

             IF( ISAM_PROD .GT. TOTAL_PROD )TOTAL_PROD = ISAM_PROD
             IF ( WRITE_CELL ) THEN
                IF ( JSPC .EQ. H2O2_INDEX ) THEN
                   H2O2_Production = TOTAL_PROD
                   write(isam_log,*)'H2O2 Production = ',TOTAL_PROD
                END IF
                IF ( JSPC .EQ. HNO3_INDEX ) THEN
                   HNO3_Production = TOTAL_PROD
                   write(isam_log,*)'HNO3 Production = ',TOTAL_PROD
                END IF

             END IF
! compute species loss
             ISAM_LOSS  = 0.0D0
             TOTAL_LOSS = 0.0D0
             SA_LOSS    = 0.0D0
             DO NTERM = 1, MECHANISM_BUDGET( JSPC )%NRXNS_LOSS
                NRX   = MECHANISM_BUDGET( JSPC )%IRXN_LOSS( NTERM )
                COEFF = MECHANISM_BUDGET( JSPC )%COEFF_NEG( NTERM )
     &                * INTRXN( NRX )
                TOTAL_LOSS = TOTAL_LOSS + INTRXN( NRX )
             END DO
             NIRR = JSPC
             DELTA_BULK        = (CONC( JSPC )-YCMID( JSPC ))
             REMOVED           = .FALSE. 
             REBALANCE( JSPC ) = .FALSE. 
             IF( TOTAL_PROD .GT. 1.0D-30 )THEN
! estimate net change concentration inside and outside source tags based on total loss
                 IF( TOTAL_LOSS .GT. 1.0D-30 )THEN
! correct outside and isam production/concentration based on the bulk average loss frequency times timestep
                    LOSS_FACT  =  TOTAL_LOSS / CONC( JSPC )
                    IF ( LOSS_FACT .LT. 14.0D0 ) THEN ! > one millionth of initial concentration remains
!                    IF ( LOSS_FACT .LT. 34.5D0 ) THEN ! > one millionth of initial concentration remains
                       REBALANCE( JSPC ) = .TRUE.
                       TERM              = ( 1.0D0 - EXP( -LOSS_FACT ) )
                       COEFF             = TERM / LOSS_FACT
                       TOTAL_PROD        = TOTAL_PROD * COEFF                    
                       DO KTAG = 1, NTAG_SA
                          SA_LOSS ( KTAG )          = SOLD( KTAG,JSPC ) * TERM
                          SA_DELTA( KTAG )          = SA_DELTA(  KTAG ) * COEFF
                          SOURCE_DELTA( KTAG,JSPC ) = MAX( SA_DELTA( KTAG ) - SA_LOSS( KTAG ),
     &                                                    -SOLD( KTAG,JSPC ) )
                       END DO
                       ISAM_PROD  = SUM( SA_DELTA( 1:NTAG_SA ) )
! estimate changes in outside concentration based on surplus production 
                       OUTSIDE( JSPC ) = OUTSIDE( JSPC ) * ( 1.0D0 - TERM )
     &                                 + (TOTAL_PROD-ISAM_PROD) 
                       OUTSIDE( JSPC ) = MAX(  OUTSIDE( JSPC ),0.0D0 )  
                    ELSE 
! tag change removes initial value and apportions bulk concentration to the tag based on its relative production
                       REMOVED = .TRUE.
                       COEFF = CONC( JSPC ) / MAX( TOTAL_PROD,1.0D-30 )
                       DO KTAG = 1, NTAG_SA
                          SOURCE_DELTA( KTAG,JSPC ) = SA_DELTA( KTAG )*COEFF - SOLD( KTAG,JSPC )
                       END DO   
                       OUTSIDE( JSPC ) = COEFF * MAX( TOTAL_PROD-ISAM_PROD,0.0D0 ) 
                     END IF  
                 ELSE
! simply scale tag changes based their fraction of production
                    LOSS_FACT  = -1.0D0
                    COEFF      = DELTA_BULK / MAX( TOTAL_PROD,1.0D-30 )
                    DO KTAG = 1, NTAG_SA
                       SOURCE_DELTA( KTAG,JSPC ) = SA_DELTA(  KTAG ) * COEFF
                    END DO
! estimate changes in outside concentration based on surplus production and loss
                    OUTSIDE( JSPC ) = OUTSIDE( JSPC ) 
     &                              + COEFF * MAX( TOTAL_PROD-ISAM_PROD, 0.0D0 )
                 END IF     
! add surplus concentration to tags based on whether species is tracked
                 IF( ISAM_SPECIES( JSPC ) )THEN
                    IF ( ISAM_PROD .GT. 1.0D-30 ) THEN
! add outside concentration to tag based on their production relative to the isam total
                       TERM = 1.0D0 / ISAM_PROD
                       DO KTAG = 1, NTAG_SA
                          SA_DELTA( KTAG ) = TERM * SA_DELTA( KTAG )
                          SOURCE_DELTA( KTAG,JSPC ) = SOURCE_DELTA( KTAG,JSPC )
     &                                              + OUTSIDE( JSPC ) * SA_DELTA( KTAG )
                       END DO
                    ELSE  ! add to other tag
                       TERM = 1.0D0
                       SOURCE_DELTA( OTHRTAG,JSPC ) = SOURCE_DELTA( OTHRTAG,JSPC )
     &                                              + OUTSIDE( JSPC )                     
                    END IF                    
                 END IF  
!                 WRITE( LOGDEV,'(A,6(ES20.10,1X))')'Surplus Changes for ' // CHEMISTRY_SPC( JSPC ) // ' = ',
!     &           TOTAL_PROD,TOTAL_LOSS,OUTSIDE( JSPC ),COEFF,SUM( SOURCE_DELTA( :,JSPC ) ),ISAM_LOSS
#ifdef verbose_isam
                 IF( ISAM_SPECIES( JSPC ) )THEN
                    IF( REMOVED )DELTA_BULK = CONC( JSPC )
                    IF( WRITE_CELL )WRITE(ISAM_LOG,'(2A,30(1X,ES20.10))', ADVANCE = 'NO')MECHANISM_BUDGET( JSPC )%SPECIES_NAME,
     &              ' P ',-LOSS_FACT,(SOURCE_DELTA( KTAG,JSPC ),KTAG =1, NTAG_SA), OUTSIDE( JSPC ), TERM, DELTA_BULK                 
                 END IF
#endif     
                 IF( ISAM_SPECIES( JSPC ) ) OUTSIDE( JSPC ) = 0.0D0
             ELSE !!!!IF ( DELTA_BULK .LT. 0.0D0 ) THEN
! scale by relative change in bulk and fraction of species in tag             
               LOSS_FACT = MAX( -1.0D0, DELTA_BULK / MAX( YCMID( JSPC ),DCONMIN_TAG ) ) 
               DO KTAG = 1, NTAG_SA
                  SOURCE_DELTA( KTAG,JSPC ) = SOURCE_DELTA( KTAG, JSPC )
     &                                      + SOLD( KTAG,JSPC ) * LOSS_FACT
               END DO
!  have to add lines for outside change?
#ifdef verbose_isam
                 IF( ISAM_SPECIES( JSPC ) )THEN
                    IF( WRITE_CELL )WRITE(ISAM_LOG,'(2A,30(1X,ES20.10))',ADVANCE = 'NO')MECHANISM_BUDGET( JSPC )%SPECIES_NAME,
     &              ' L ',-LOSS_FACT,(SOURCE_DELTA( KTAG,JSPC ),KTAG =1, NTAG_SA),OUTSIDE( JSPC ),COEFF,
     &              DELTA_BULK            
                 END IF
#endif     
             END IF
!
#ifdef verbose_isam
             IF( ISAM_SPECIES( JSPC ) )THEN
                TOTAL = SUM( SOURCE_DELTA( 1:NTAG_SA,JSPC ))
                IF( WRITE_CELL )WRITE(ISAM_LOG,'(A,ES12.4,A,ES12.4)')
     &          ' Net ISAM Change ', TOTAL,': Change ISAM-BULK ',( TOTAL-DELTA_BULK )
             END IF
#endif
             DO KTAG = 1, NTAG_SA
                IF( SOURCE_DELTA( KTAG, JSPC ) .LT. -SOLD( KTAG, JSPC ) )THEN
                   SOURCE_DELTA( KTAG, JSPC ) = -SOLD( KTAG, JSPC )
                END IF 
             END DO   
       END DO

       IF ( WRITE_CELL ) THEN            
                   write(isam_log,'(A,2(ES12.4,1X))')
     &            'H2O2_Production/HNO3_Production, PH2O2_OVER_PHNO3  = ',
     &             H2O2_Production/max(HNO3_Production,1.0d-30) ,PH2O2_OVER_PHNO3( RK,CONC )
       END IF

C...update SOLD using SOURCE_DELTA       
        DO JSPC = 1,NUMB_MECH_SPC
           NIRR = JSPC 
           DO KTAG = 1, NTAG_SA
              SOLD( KTAG, JSPC ) = SOLD( KTAG, JSPC ) + SOURCE_DELTA( KTAG, JSPC )
               IF( SOLD( KTAG,JSPC ) .LT. DCONMIN_TAG )SOLD( KTAG,JSPC ) = 0.0D0
           END DO           
           IF( REBALANCE( JSPC ) )THEN 
!     adjust tags based on final bulk concentration
              TERM  = MAX( OUTSIDE( JSPC ) + SUM( SOLD(1:NTAG_SA,JSPC) ), DCONMIN_TAG ) 
              COEFF = CONC( JSPC ) / TERM            
              DO KTAG = 1, NTAG_SA
                 SOLD( KTAG,JSPC ) = COEFF * SOLD( KTAG,JSPC )
                 IF( SOLD( KTAG,JSPC ) .LT. DCONMIN_TAG )SOLD( KTAG,JSPC ) = 0.0D0
              END DO
              OUTSIDE( JSPC ) = COEFF * OUTSIDE ( JSPC )
           END IF
! set tags to conmin if initially nonzero
           IF( MAXVAL( SOLD( 1:NTAG_SA,JSPC ) ) .LT. DCONMIN_TAG )THEN
              DO KTAG = 1, NTAG_SA
                 IF( SOURCE_NONZERO( KTAG,JSPC ) )SOLD( KTAG,JSPC ) = DCONMIN_TAG
              END DO
! zero out ICON tag
!             SOLD( NTAG_SA,JSPC )   = 0.0D0
           END IF    
        END DO

#ifdef verbose_isam
       IF( WRITE_CELL )THEN
          WRITE(ISAM_LOG,'(A)')'Source Delta Concentration include extra delta then last two columns, Solver Change and Sum Deltas'
          WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Species/Tag #',(KTAG,KTAG=1,NTAG_SA),0,NTAG_SA+1
!          DO S = 1, NUMB_MECH_SPC 
          DO JSPC = 1, ISAM_CHEMISTRY_SPC
             S = ISAM_TO_CHEM( JSPC )
             WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')CHEMISTRY_SPC(S),(SOURCE_DELTA( KTAG, JSPC ),KTAG=1,NTAG_SA ),
     &      (CONC( S )-YCMID( S )),SUM(SOURCE_DELTA( 1:(NTAG_SA), JSPC ))
          END DO
          WRITE(ISAM_LOG,*)' '
          WRITE(ISAM_LOG,'(A21,5(1X,A12))')'ISAM_CHEMISTRY_SPC,','  IRR Conc,  ',' True Conc,  correction ',
     &                                    '  IRR Change,  ','  True Change  ',' Difference '
!          DO NIRR = 1, NUMB_MECH_SPC 
          DO JSPC = 1, ISAM_CHEMISTRY_SPC
             NIRR = ISAM_TO_CHEM( JSPC )
             COEFF = 0.0D0
             TERM  = 0.0D0
             DO KTAG = 1, NTAG_SA
!                SOLD( KTAG, NIRR ) = MAX( SOLD( KTAG, NIRR ) + SOURCE_DELTA( KTAG, JSPC ), 0.0D0 )
                TERM  = TERM  + SOLD( KTAG, NIRR )
                COEFF = COEFF + SOURCE_DELTA( KTAG, JSPC )
             END DO
             DELTA_BULK =  CONC( NIRR )- YCMID( NIRR )             
             WRITE(ISAM_LOG,'(A21,5(1X,",",ES12.4))')'ISAM_' // CHEMISTRY_SPC(NIRR),
     &       MAX(0.0D0,TERM),CONC( NIRR ),COEFF,DELTA_BULK,(DELTA_BULK-COEFF)
          END DO
       END IF
#endif

       DO NIRR = 1, NUMB_MECH_SPC 
          YCMID( NIRR ) = CONC( NIRR )
       END DO
          
C..Clear source deltas
       SOURCE_DELTA = 0.0D0
C..Save concentrations
       DO NIRR = 1, NUMB_MECH_SPC 
          YCOLD( NIRR ) = CONC( NIRR )
       END DO
#ifdef verbose_isam
       IF( WRITE_CELL )THEN
          WRITE(ISAM_LOG,'(A,I7,1X,I6.6,1X,I3)')'At Date, Time, Nstep = ',ISAM_JDATE,ISAM_JTIME,ISAM_NSTEP
          WRITE(ISAM_LOG,*)'Final Source Concentration then New Total (Last Column) Concentrations'
          WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Species/Tag #',(KTAG,KTAG=1,NTAG_SA),0,NTAG_SA+1
!          DO S = 1, NUMB_MECH_SPC 
          DO JSPC = 1, ISAM_CHEMISTRY_SPC
             S = ISAM_TO_CHEM( JSPC )
             WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')CHEMISTRY_SPC(S),(SOLD( KTAG, S ),KTAG=1,NTAG_SA ),
     &       CONC( S ),SUM(SOLD(1:NTAG_SA,S) )
          END DO
       END IF
#endif        
      

      RETURN
      END SUBROUTINE SA_IRR_UNBLOCKED
      REAL( 8 ) FUNCTION PH2O2_OVER_PHNO3( RKI,CONC )
      
      USE UTILIO_DEFN
      USE RXNS_DATA             ! chemical mechanism data

      IMPLICIT NONE 

C..Includes: None
      
C..Arguments: 
      REAL( 8 ),    INTENT( IN ) :: RKI  ( : )    ! Reaction rate coefficients
      REAL( 8 ),    INTENT( IN ) :: CONC ( : )    ! species concentrations

C..Parameters: None

C..Local
      INTEGER       :: IRXN, ISTART, ISTOP
      INTEGER       :: NRX
      INTEGER       :: IOS
      INTEGER       :: ISP1, ISP2, ISP3

      INTEGER, SAVE :: NRXNS_PROD_H2O2_HNO3 = 0

      REAL( 8 )     :: PROD_H2O2
      REAL( 8 )     :: PROD_HNO3
      
      LOGICAL, SAVE :: FIRSTCALL = .TRUE.
      LOGICAL, SAVE :: NO_SPECIES_PROD = .FALSE.
      
      REAL( 8 ), ALLOCATABLE, SAVE :: RXRAT( : )

      CHARACTER( 132 ) :: MSG
      IF ( FIRSTCALL ) THEN 
           
         IF ( NRXNS_PROD_HNO3 .LT. 1 .OR. NRXNS_PROD_H2O2 .LT. 1 ) THEN
            NO_SPECIES_PROD = .TRUE.
         ELSE 
            NRXNS_PROD_H2O2_HNO3 = NRXNS_PROD_HNO3 + NRXNS_PROD_H2O2
            ALLOCATE( RXRAT( NRXNS_PROD_H2O2_HNO3 ),  STAT = IOS )
            IF ( IOS .NE. 0 ) THEN
                MSG = 'Error allocating RXRAT arrays'
                CALL M3EXIT( ' PH2O2_OVER_PHNO3', 0, 0, MSG, XSTAT1 )
            END IF  
          END IF
                   
         FIRSTCALL = .FALSE.
      END IF

      IF ( NO_SPECIES_PROD ) THEN
         PH2O2_OVER_PHNO3 = CONC( H2O2_INDEX ) / MAX( 1.0D-30,CONC( HNO3_INDEX ))
         RETURN
      END IF
      
      DO IRXN = 1, NRXNS_PROD_H2O2_HNO3
            NRX = H2O2_HNO3_PROD_RXNS( IRXN )
            SELECT CASE ( NREACT( NRX ) )
               CASE( 1 )
                  ISP1 = IRR( NRX,1 )
                  RXRAT(IRXN ) = RKI( NRX )
     &                         * CONC( ISP1 )
               CASE( 2 ) 
                   ISP1 = IRR( NRX,1 )
                   ISP2 = IRR( NRX,2 )
                   RXRAT( IRXN ) = RKI( NRX )
     &                          * CONC( ISP1 )
     &                          * CONC( ISP2 ) 
               CASE( 3 )
                   ISP1 = IRR( NRX,1 )
                   ISP2 = IRR( NRX,2 )
                   ISP3 = IRR( NRX,3 )
                   RXRAT( IRXN ) = RKI( NRX )
     &                          * CONC( ISP1 )
     &                          * CONC( ISP2 )
     &                          * CONC( ISP3 ) 
               CASE( 0 ) 
                  RXRAT( IRXN ) = RKI( NRX )
            END SELECT
      END DO

! Compute hydrogen peroxide production
      PROD_H2O2 = 0.0D0
      ISTART = 1
      ISTOP  = NRXNS_PROD_H2O2
      DO IRXN = ISTART, ISTOP
         PROD_H2O2 = PROD_H2O2
     &             + H2O2_HNO3_YIELD( IRXN ) * RXRAT( IRXN )
      END DO

! Compute hydrogen peroxide production
      PROD_HNO3 = 0.0D0
      ISTART = ISTOP + 1
      ISTOP  = NRXNS_PROD_H2O2_HNO3
      DO IRXN = ISTART, ISTOP
         PROD_HNO3 = PROD_HNO3
     &             + H2O2_HNO3_YIELD( IRXN ) * RXRAT( IRXN )
      END DO
      
      PH2O2_OVER_PHNO3 = PROD_H2O2 / MAX( 1.0D-30,PROD_HNO3 )
      
      END FUNCTION PH2O2_OVER_PHNO3
      END MODULE SA_IRR_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/vdiff/acm2/opddep.F,v 1.6 2012/01/19 14:40:52 yoj Exp $
 
C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%
 
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPDDEP ( JDATE, JTIME, TSTEP )

C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN
C   03 Sep 01 David Wong: for new pario
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 J.Bash: Modified to output NH3 bidi component fluxes
C   04 Jan 12 J.Young: Initalize char strings with blank padding
C   08 Jun 12 J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      USE MIO_ASCII

      IMPLICIT NONE
 
      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

      INTEGER, INTENT( IN ) :: JDATE  ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME  ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP  ! output time step

C Local variables:

      CHARACTER( 16 ) :: PNAME = 'OPDDEP'
      CHARACTER( 96 ) :: XMSG = ' '

! component flux varialbes      
      INTEGER,         SAVE :: N_BD_EMIS 
      CHARACTER( 16 ), SAVE :: BD_EMIS_SPC( 3 )
      INTEGER,         SAVE :: N_BD_FLUX 
      CHARACTER( 16 ), SAVE :: BD_FLUX_SPC( 1 )

      INTEGER      V, N, L     ! loop induction variables
      INTEGER      STRT, FINI  ! loop induction variables

C-----------------------------------------------------------------------

C Try to open existing file for update

      IF ( .NOT. OPEN3( CTM_DRY_DEP_1, FSRDWR3, PNAME ) ) THEN

         N_BD_EMIS = 0
         N_BD_FLUX = 0
         If( ABFLUX ) Then
            N_BD_EMIS = N_BD_EMIS + 1
            BD_EMIS_SPC( N_BD_EMIS ) = 'NH3_Emis'
            N_BD_FLUX = 1
            BD_FLUX_SPC( 1 ) = 'NH3_Flux'
         End If 
         If( HGBIDI ) Then
            N_BD_EMIS = N_BD_EMIS + 1
            BD_EMIS_SPC( N_BD_EMIS ) = 'HG_Emis'
         End If 
         If( SFC_HONO ) Then 
            N_BD_EMIS = N_BD_EMIS + 1      
            BD_EMIS_SPC( N_BD_EMIS ) = 'HONO_Het '
         End If      

         XMSG = 'Could not open ' // CTM_DRY_DEP_1 // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG( XMSG )

C Set output file characteristics based on COORD.EXT and open the dry dep file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME
         TSTEP3D = TSTEP
         CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour
         NVARS3D = N_SPC_DDEP + N_BD_EMIS + N_BD_FLUX 
         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D =     1
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD 
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         N = 0
         STRT = 1
         FINI = N_GC_DDEP
         DO V = STRT, FINI
            N = N + 1
            VTYPE3D( V ) = M3REAL
            VNAME3D( V ) = GC_DDEP( N )
            UNITS3D( V ) = 'kg ha-1'
            VDESC3D( V ) = 'hourly dry deposition values'
         END DO

         N = 0
         STRT = N_GC_DDEP + 1
         FINI = N_GC_DDEP + N_AE_DDEP
         DO V = STRT, FINI
            N = N + 1
            VTYPE3D( V ) = M3REAL
            VNAME3D( V ) = AE_DDEP( N )
            IF ( AE_DDEP( N )( 1:3 ) .EQ. 'NUM' ) THEN
               UNITS3D( V ) = 'ha-1'
            ELSE IF ( AE_DDEP( N )( 1:3 ) .EQ. 'SRF' ) THEN
               UNITS3D( V ) = 'm2 ha-1'
            ELSE
               UNITS3D( V ) = 'kg ha-1'
            END IF
            VDESC3D( V ) = 'hourly dry deposition values'
         END DO

         N = 0
         STRT = N_GC_DDEP + N_AE_DDEP + 1
         FINI = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP
         DO V = STRT, FINI
            N = N + 1
            VTYPE3D( V ) = M3REAL
            VNAME3D( V ) = NR_DDEP( N )
            UNITS3D( V ) = 'kg ha-1'
            VDESC3D( V ) = 'hourly dry deposition values'
         END DO

         N = 0
         STRT = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP + 1
         FINI = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP + N_TR_DDEP
         DO V = STRT, FINI
            N = N + 1
            VTYPE3D( V ) = M3REAL
            VNAME3D( V ) = TR_DDEP( N )
            UNITS3D( V ) = 'kg ha-1'
            VDESC3D( V ) = 'hourly dry deposition values'
         END DO

         IF ( ABFLUX ) THEN
            N = 0   
            STRT = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP + N_TR_DDEP + 1
            FINI = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP + N_TR_DDEP + 1
            DO V = STRT, FINI
               N = N + 1
               VTYPE3D( V ) = M3REAL
               VNAME3D( V ) = BD_EMIS_SPC( N )
               UNITS3D( V ) = 'kg ha-1'
               VDESC3D( V ) = 'hourly emission values'
            END DO
            N = 0   
            STRT = FINI + 1
            FINI = FINI + N_BD_FLUX
            DO V = STRT, FINI
               N = N + 1
               VTYPE3D( V ) = M3REAL
               VNAME3D( V ) = BD_FLUX_SPC( N )
               UNITS3D( V ) = 'kg ha-1'
               VDESC3D( V ) = 'hourly flux values'
            END DO
         END IF
         IF ( HGBIDI ) THEN
            STRT = FINI + 1
            FINI = FINI + 1
            DO V = STRT, FINI
               VTYPE3D( V ) = M3REAL
               VNAME3D( V ) = 'HG_Emis'
               UNITS3D( V ) = 'kg ha-1'
               VDESC3D( V ) = 'hourly emission values'
            END DO
         END IF
         IF ( SFC_HONO ) THEN
            STRT = FINI + 1
            FINI = FINI + 1
            DO V = STRT, FINI
               VTYPE3D( V ) = M3REAL
               VNAME3D( V ) = 'HONO_Het '
               UNITS3D( V ) = 'kg ha-1'
               VDESC3D( V ) = 'hourly surface heterogenous production values'
            END DO
         END IF

         FDESC3D( 1 ) = 'hourly 1-layer cross-point STAGE dry deposition data'
         DO L = 2, MXDESC3
            FDESC3D( L ) = ' '
         END DO

         ! Store MIO Metadata
         NDIMS3D( 1:NVARS3D ) = 3
         L_TSTEP( 1:NVARS3D ) = .True.
         L_LAY  ( 1:NVARS3D ) = .False.
         L_COL  ( 1:NVARS3D ) = .True.
         L_ROW  ( 1:NVARS3D ) = .True.
         L_VEXT ( 1:NVARS3D ) = .False.

         CALL LOAD_MIO_FILE ( 'CTM_DRY_DEP_1', 0, 0, 0,
     &        VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &        VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &        L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &        L_VEXT(1:NVARS3D) )
         
C    Open dry deposition file

         IF ( .NOT. OPEN3( CTM_DRY_DEP_1, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// CTM_DRY_DEP_1 // ' file'
            CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_SETUP_IRR

C-----------------------------------------------------------------------
C Function: To store IRR data that will be needed to
C           generate the PA report and output INCLUDE files
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI`s M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
 
      USE UTILIO_DEFN
      USE PA_GLOBAL     ! Mech data used 
      USE PA_DEFN
      USE PA_VARS
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions:
      REAL MOLCLOSS    ! Function to get number of species or 
                       ! family molecules lost in a reaction
      REAL MOLCPROD    ! Function to get number of species or 
                       ! family molecules produced in a reaction

C Local Variables: 

      CHARACTER(  4 ) :: NAMETYPE   ! Type of name (mech or family)
      CHARACTER(  4 ) :: TYPE       ! Operator type
      CHARACTER(  7 ) :: PNFLAG     ! Initialization flag
      CHARACTER( 10 ) :: LBLOUT    ! Holder for output label

      INTEGER EPOS1, EPOS2 ! Position of last non-blank character in string
      INTEGER ICOUNT       ! Count of number of output terms in sum
      INTEGER INDX         ! Pointer to cycle or rxsum number
      INTEGER N            ! Loop index for specis and defined names
      INTEGER NAMINDX      ! Pointer to species or family name
      INTEGER NCYC         ! Loop index for number of cycles
      INTEGER NFAM         ! Loop index for number of familys
      INTEGER NFAMIN       ! Counter of no. of families in output
      INTEGER NFAMOUT      ! Counter of no. of families listed for output
      INTEGER NOUT         ! Loop index for number of output requests
      INTEGER NRFND        ! Number of reactant species found
      INTEGER NPFND        ! Number of reactant species found
      INTEGER NRX          ! Loop index for number of reactions or Rxsums
      INTEGER NTERM        ! Loop index for number of terms in output request
      INTEGER SPOS1, SPOS2 ! Starting position for first non-blank character
      INTEGER ASTAT        ! Memory allocation staus

      INTEGER FAMINDX( MAXOUTTERMS )   ! Index of family

      REAL SUM           ! Sum of molecular production and loss
         
C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Store reaction data for all cycles  
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NCYC = 1, NCYCLES         
         IF ( CYCLSPEC( NCYC ) .NE. '' ) THEN
            NAMETYPE = CYSPTYP( NCYC ) 
            NAMINDX  = CYSPNUM( NCYC ) 
            ICOUNT = 0
            DO NRX = 1, NRXNS
               SUM = MOLCPROD( NAMETYPE, NAMINDX, NRX, NPFND )  - 
     &               MOLCLOSS( NAMETYPE, NAMINDX, NRX, NRFND ) 
               IF ( ABS( SUM ) .GT. 0.0001 )  THEN
                  ICOUNT = ICOUNT + 1
                  CYRXNUM( NCYC,ICOUNT ) = NRX
                  NCYTERMS( NCYC ) = ICOUNT 
                  CYSC( NCYC, ICOUNT ) = SUM
               END IF
            END DO
         END IF
      END DO

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Store data on the families used in each IRR_OUTPUT command
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NOUT = 1, NIRROUT
         NFAMIN = 0

         DO N = 1, NIRRTERMS( NOUT ) 
            IF ( OUTS1TYP( NOUT,N ) .EQ. 'FAM' )  THEN
               NFAMIN = NFAMIN + 1
               FAMINDX( NFAMIN ) = OUTS1NUM( NOUT,N ) 
            END IF
            IF ( OUTS2TYP( NOUT,N ) .EQ. 'FAM' )  THEN
               NFAMIN = NFAMIN + 1
               FAMINDX( NFAMIN ) = OUTS2NUM( NOUT,N ) 
            END IF
            IF ( OUTS3TYP( NOUT,N ) .EQ. 'FAM' )  THEN
               NFAMIN = NFAMIN + 1
               FAMINDX( NFAMIN ) = OUTS3NUM( NOUT,N ) 
            END IF
         END DO

         IF ( NFAMIN .GT. 0 ) THEN
            NFAMOUT = 0
            DO NFAM = 1, NFAMIN
               INDX = 0
               DO N = 1,  NFAMOUT
                  IF ( FAMINDX( NFAM ) .EQ. OUTFAMS( NOUT,N ) ) INDX = N
               END DO
               IF ( INDX .EQ. 0 ) THEN
                  NFAMOUT = NFAMOUT + 1
                  OUTFAMS( NOUT,NFAMOUT )  = FAMINDX( NFAM ) 
               END IF
            END DO
            NOUTFAMS( NOUT ) = NFAMOUT
         END IF
      END DO

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Store data on the cycles used in each IRR_OUTPUT command
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NOUT = 1, NIRROUT
         ICOUNT = 0
         DO NTERM = 1, NIRRTERMS( NOUT ) 
            IF ( OUTS1TYP( NOUT, NTERM ) .EQ. 'CYCL' ) THEN
               ICOUNT = ICOUNT + 1
               NOUTCYCS( NOUT ) = ICOUNT
               OUTCYCS( NOUT,ICOUNT ) = OUTS1NUM( NOUT,NTERM )        
            END IF
         END DO
      END DO

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Store data on all reaction sums used in each IRR_OUTPUT command
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NOUT = 1, NIRROUT
         ICOUNT = 0
         DO NTERM = 1, NIRRTERMS( NOUT ) 
            IF ( OUTS1TYP( NOUT, NTERM ) .EQ. 'RXSM' ) THEN
               ICOUNT = ICOUNT + 1
               NOUTRXSUMS( NOUT ) = ICOUNT
               OUTRXSUMS( NOUT,ICOUNT ) = OUTS1NUM( NOUT,NTERM ) 
            END IF
         END DO
      END DO

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Store data on all operators used in each IRR_OUTPUT command
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NOUT = 1, NIRROUT
         ICOUNT = 0
         DO NTERM = 1, NIRRTERMS( NOUT ) 
            TYPE = OUTTYPE( NOUT,NTERM ) 
            IF ( TYPE .NE. 'NAME' .AND. TYPE .NE. 'RXN' ) THEN
               ICOUNT = ICOUNT + 1
               NOUTOPS( NOUT ) = ICOUNT
            END IF
         END DO
      END DO
           
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Store data on individual reactions referenced in each IRR_OUTPUT
c  command
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO NOUT = 1, NIRROUT
         ICOUNT = 0
         DO NTERM = 1, NIRRTERMS( NOUT ) 
            TYPE = OUTTYPE( NOUT,NTERM ) 
            IF ( TYPE .EQ. 'RXN' ) THEN
               ICOUNT = ICOUNT + 1
               NOUTRXN( NOUT ) = ICOUNT
            END IF
         END DO
      END DO

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Store data on the defined reaction sums that initialize IRR outputs
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      NUMOUTPOS = 0
      NUMOUTNEG = 0
      NUMOUTIND = 0
      DO NOUT = 1, NIRROUT 
         DO NTERM = 1, NIRRTERMS( NOUT ) 
            TYPE = OUTS1TYP( NOUT,NTERM ) 

            IF ( TYPE .EQ. 'CYCL' .OR. TYPE .EQ. 'RXSM' ) THEN
               INDX = OUTS1NUM( NOUT,NTERM ) 
               IF ( TYPE .EQ. 'RXSM' ) INDX = INDX + NCYCLES              
               PNFLAG = OUTPNFLAG( NOUT,NTERM ) 
               IF ( PNFLAG .EQ. 'POSONLY' )  THEN
                  NUMOUTPOS = NUMOUTPOS + 1
                  TEMPOUTPOS_TMP( NUMOUTPOS ) = INDX
                  INDXOUTPOS_TMP( NUMOUTPOS ) = NOUT
                  COEFOUTPOS_TMP( NUMOUTPOS ) = OUTSC( NOUT,NTERM ) 
               ELSE IF ( PNFLAG .EQ. 'NEGONLY' ) THEN
                  NUMOUTNEG = NUMOUTNEG + 1
                  TEMPOUTNEG_TMP( NUMOUTNEG ) = INDX
                  INDXOUTNEG_TMP( NUMOUTNEG ) = NOUT
                  COEFOUTNEG_TMP( NUMOUTNEG ) = OUTSC( NOUT,NTERM )  
               ELSE IF ( PNFLAG .EQ. '' ) THEN
                  NUMOUTIND = NUMOUTIND + 1
                  TEMPOUTIND_TMP( NUMOUTIND ) = INDX
                  INDXOUTIND_TMP( NUMOUTIND ) = NOUT
                  COEFOUTIND_TMP( NUMOUTIND ) = OUTSC( NOUT,NTERM ) 
               END IF 
            END IF

         END DO
      END DO

      ALLOCATE( TEMPOUTPOS( NUMOUTPOS ),
     &          INDXOUTPOS( NUMOUTPOS ),
     &          COEFOUTPOS( NUMOUTPOS ),
     &          TEMPOUTNEG( NUMOUTNEG ),
     &          INDXOUTNEG( NUMOUTNEG ),
     &          COEFOUTNEG( NUMOUTNEG ),
     &          TEMPOUTIND( NUMOUTIND ),
     &          INDXOUTIND( NUMOUTIND ),
     &          COEFOUTIND( NUMOUTIND ), STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 1 allocating IRR variables'
         CALL M3EXIT ( 'PA_SETUP_IRR', 0, 0, MSG, XSTAT2 )
      END IF

      TEMPOUTPOS = TEMPOUTPOS_TMP( 1:NUMOUTPOS )
      INDXOUTPOS = INDXOUTPOS_TMP( 1:NUMOUTPOS )
      COEFOUTPOS = COEFOUTPOS_TMP( 1:NUMOUTPOS )
      TEMPOUTNEG = TEMPOUTNEG_TMP( 1:NUMOUTNEG )
      INDXOUTNEG = INDXOUTNEG_TMP( 1:NUMOUTNEG )
      COEFOUTNEG = COEFOUTNEG_TMP( 1:NUMOUTNEG )
      TEMPOUTIND = TEMPOUTIND_TMP( 1:NUMOUTIND )
      INDXOUTIND = INDXOUTIND_TMP( 1:NUMOUTIND )
      COEFOUTIND = COEFOUTIND_TMP( 1:NUMOUTIND )

      NUMTEMPS = 0                                   
      MXTEMPTRMS = 0
      DO NCYC = 1, NCYCLES
         NUMTEMPS   = NUMTEMPS + 1
         MXTEMPTRMS = MAX( MXTEMPTRMS, NCYTERMS( NCYC ) ) 
         TEMPTERMS_TMP( NUMTEMPS ) = NCYTERMS( NCYC ) 
         DO N = 1,  NCYTERMS( NCYC ) 
            TEMPRXN_TMP( NUMTEMPS,N )  = CYRXNUM( NCYC,N ) 
            TEMPCOEF_TMP( NUMTEMPS,N ) = CYSC( NCYC,N ) 
         END DO
      END DO

      DO NRX = 1, NRXSUMS
         NUMTEMPS   = NUMTEMPS + 1
         MXTEMPTRMS = MAX( MXTEMPTRMS, NRXTERMS( NRX )  ) 
         TEMPTERMS_TMP( NUMTEMPS ) = NRXTERMS( NRX ) 
         DO N = 1,  NRXTERMS( NRX ) 
            TEMPRXN_TMP( NUMTEMPS,N )  = RXSUMRN( NRX,N ) 
            TEMPCOEF_TMP( NUMTEMPS,N ) = RXNSC( NRX,N ) 
         END DO
      END DO

      ALLOCATE( TEMPTERMS( NUMTEMPS ),
     &          TEMPRXN  ( NUMTEMPS,MXTEMPTRMS ),
     &          TEMPCOEF ( NUMTEMPS,MXTEMPTRMS ), STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 2 allocating IRR variables'
         CALL M3EXIT ( 'PA_SETUP_IRR', 0, 0, MSG, XSTAT2 )
      END IF

      TEMPTERMS = TEMPTERMS_TMP( 1:NUMTEMPS )
      TEMPRXN   = TEMPRXN_TMP  ( 1:NUMTEMPS,1:MXTEMPTRMS )
      TEMPCOEF  = TEMPCOEF_TMP ( 1:NUMTEMPS,1:MXTEMPTRMS )

      IF ( LFULLIRR )  THEN
         DO N = 1,  NRXNS
            WRITE( LBLOUT, '( I10 )' ) N
            SPOS1 = LBLANK(  LBLOUT ) + 1
            EPOS1 = LEN_TRIM( LBLOUT )           
            SPOS2 = LBLANK(  RXLABEL( N ) ) + 1
            EPOS2 = LEN_TRIM( RXLABEL( N )  )           
            IRRNAME( N ) = 'IRR_' // LBLOUT( SPOS1:EPOS1 ) 
            IRRDESC( N ) = 'IRR_' // LBLOUT( SPOS1:EPOS1 )
     &                   // ': ' // '<' //
     &                      RXLABEL( N )( SPOS2:EPOS2 ) // '>'
         END DO
      END IF

      RETURN

      END SUBROUTINE PA_SETUP_IRR

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This serves the main program for offline CMAQ mode

! Revision History:
!  02/01/19, D. Wong: initial implementation
!  02/10/20, D. Wong: Added new environmental variable MET_TSTEP
!                     to allow running with temporally fine 
!                     meteorology
!------------------------------------------------------------------------!

      PROGRAM CMAQ

        USE RUNTIME_VARS
        USE UTILIO_DEFN

        IMPLICIT NONE

#ifdef parallel
        INCLUDE 'mpif.h'

        INTEGER   PAR_ERR     ! Error code from parallel initialization
        REAL( 8 ) BEGTIME     ! Wall-clock time (sec) at MPI initialization
        REAL( 8 ) ENDTIME     ! Wall-clock time (sec) at MPI finish
        REAL( 8 ) ELAPTIME    ! ENDTIME-BEGTIME
#else
      REAL      BEGTIME     ! Wall-clock time (sec) at MPI initialization
      REAL      ENDTIME     ! Wall-clock time (sec) at MPI finish
      REAL      ELAPTIME    ! ENDTIME-BEGTIME
#endif
        CHARACTER( 96 ) :: XMSG = ' '

        INTEGER :: MODEL_TSTEP, NSTEPS, ISTEP,
     $             JDATE, JTIME, TOTSECS, STEPSECS
        CHARACTER( 96 ) :: MSG = ' '

        INTERFACE
          SUBROUTINE CMAQ_DRIVER ( MODEL_STDATE, MODEL_STTIME, MODEL_TSTEP,
     $                             MODEL_JDATE, MODEL_JTIME, LAST_STEP,
     $                             COUPLE_TSTEP, NCOLS_IN, NLAYS_IN)
            INTEGER, INTENT( IN )  :: MODEL_STDATE, MODEL_STTIME, MODEL_TSTEP
            INTEGER, INTENT( OUT ) :: MODEL_JDATE, MODEL_JTIME
            LOGICAL, INTENT( IN )  :: LAST_STEP
            INTEGER, INTENT( IN ), OPTIONAL :: COUPLE_TSTEP
            INTEGER, INTENT( IN ), OPTIONAL :: NCOLS_IN, NLAYS_IN
          END SUBROUTINE CMAQ_DRIVER
        END INTERFACE

#ifdef parallel
C Start up processor communication and retrieve number of compute
C processes (NPROCS)
        CALL MPCOMM_INIT( NPROCS, MYPE, BEGTIME, PAR_ERR )
#else
        NPROCS = 1
        MYPE = 0
        CALL CPU_TIME( BEGTIME )
#endif
        ! Initialize all runscript environmental variables
        CALL INIT_ENV_VARS( 0, 0 )

        MODEL_TSTEP = LOCAL_TSTEP

        TOTSECS  = TIME2SEC( RUNLEN )

        STEPSECS = TIME2SEC( MIN( MODEL_TSTEP, MET_TSTEP) )

        IF ( MOD( TOTSECS, STEPSECS ) .EQ. 0 ) THEN
           NSTEPS = TOTSECS / STEPSECS
        ELSE
           MSG = 'EXIT: Output time step ' // HHMMSS( MODEL_TSTEP ) //
     &           ' does not divide duration ' // HHMMSS( RUNLEN )
           CALL M3EXIT( 'CMAQ_MAIN', STDATE, STTIME, MSG, XSTAT1 )
        END IF
        
        ! Call to driver, for nsteps or how often the model synchronization step
        ! needs to be recalculated (RUNLEN = 60*(NSTEPS*NREPS*TSTEP(2))

        DO ISTEP = 1, NSTEPS
           CALL CMAQ_DRIVER (STDATE, STTIME, MODEL_TSTEP, JDATE, JTIME, (ISTEP .EQ. NSTEPS))
        END DO

#ifdef parallel
        ENDTIME = MPI_WTIME()   ! get final wall-clock time
#else
        CALL CPU_TIME( ENDTIME )   ! get final wall-clock time
#endif
        ELAPTIME = ENDTIME - BEGTIME
        WRITE( XMSG, '(A,F10.1,A)' ) 'The elapsed time for this simulation was', 
     &                               ELAPTIME, ' seconds.'
        CALL LOG_MESSAGE( LOGDEV, XMSG )
        IF ( MYPE .EQ. 0 ) WRITE( OUTDEV, * )
        IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
        IF ( MYPE .EQ. 0 ) WRITE( OUTDEV, * )

#ifdef parallel
C Shut down MPI
        CALL MPI_FINALIZE ( PAR_ERR )
        IF ( PAR_ERR .NE. 0 ) THEN
           MSG = 'Error terminating MPI'
           CALL M3EXIT( 'CMAQ_MAIN', STDATE, STTIME, MSG, XSTAT1 )
        END IF
#endif

      END PROGRAM CMAQ

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE HGRD_DEFN

C Define the horizontal domain, globally and for each processor, if parallel
C Revision History: David Wong 18 Feb 01: created
C                   Jeff Young 23 Feb 01: generalize
C                              31 Mar 01: add BLKPRM.EXT
C                              10 Nov 01: change to use GRIDDESC, env vars
C                   J Gipson   01 Sep 04: change block size to 50
C                   J Young    07 Dec 04: remove layer dependency (for MXCELLS,
C                                         MXBLKS) to implement vertical layer
C                                         dyn alloc appropriately
C                   J Young    22 Dec 05: move proc. anayl. stuff to PAGRD_DEFN
C                   S. Roselle 29 Mar 11: Replaced I/O API include files
C                                         with UTILIO_DEFN
C                   D. Wong    11 May 11: incorporated twoway model implementation
C                   D. Wong    Aug 15:    Added a new logical variable, IO_PE_INCLUSIVE
C                                           to facilitate parallel I/O implementation
C                   D. Wong    01 Feb 19: removed all MY_N clauses
C.......................................................................
      USE RUNTIME_VARS

      IMPLICIT NONE

C returned coordinate system (projection)
      CHARACTER( 16 ), SAVE :: COORD_SYS_NAME

C map projection type (should be named PRTYP_GD!)
      INTEGER, SAVE :: GDTYP_GD = 2 ! LAMGRD3

C first map projection parameter (degrees)
      REAL( 8 ), SAVE :: P_ALP_GD = 30.0

C second map projection parameter (degrees)
      REAL( 8 ), SAVE :: P_BET_GD = 60.0

C third map projection parameter (degrees)
      REAL( 8 ), SAVE :: P_GAM_GD = -90.0

C longitude for coord-system center (degrees)
      REAL( 8 ), SAVE :: XCENT_GD = -90.0

C latitude for coord-system center (degrees)
      REAL( 8 ), SAVE :: YCENT_GD = 40.0

      REAL( 8 ), SAVE :: XORIG_GD ! X-coordinate origin of computational grid
      REAL( 8 ), SAVE :: YORIG_GD ! Y-coordinate origin of computational grid

      REAL( 8 ), SAVE :: XCELL_GD ! X-coordinate cell width (M)
      REAL( 8 ), SAVE :: YCELL_GD ! Y-coordinate cell width (M)

      INTEGER, SAVE :: GL_NCOLS   ! no. of columns in global grid
      INTEGER, SAVE :: GL_NROWS   ! no. of rows in global grid
      INTEGER, SAVE :: GL_NBNDY   ! no. of cells in one layer of global boundary
 
      INTEGER, SAVE :: NCOLS      ! grid columns array dimension
      INTEGER, SAVE :: NROWS      ! grid rows array dimension
      INTEGER, SAVE :: NBNDY      ! no. of cells in one layer of local boundary
 
!     INTEGER, PARAMETER :: NTHIK = 1     ! boundary thickness (cells)
      INTEGER, SAVE :: NTHIK      ! boundary thickness (cells)
 
      INTEGER, SAVE :: MY_NCOLS_DOT ! local no. of dot file grid columns
      INTEGER, SAVE :: MY_NROWS_DOT ! local no. of dot file grid rows
C column range for each processor
      INTEGER, ALLOCATABLE, SAVE :: COLSX_PE( :,: )
      INTEGER, ALLOCATABLE, SAVE :: COLSD_PE( :,: )  ! dot file
C row range for each processor
      INTEGER, ALLOCATABLE, SAVE :: ROWSX_PE( :,: )
      INTEGER, ALLOCATABLE, SAVE :: ROWSD_PE( :,: )  ! dot file

C maximum stencil displacement in the north, east, south, and west direction
      INTEGER, PARAMETER :: MNDIS = 2
      INTEGER, PARAMETER :: MEDIS = 2
      INTEGER, PARAMETER :: MSDIS = 2
      INTEGER, PARAMETER :: MWDIS = 2

      LOGICAL :: IO_PE_INCLUSIVE

C BLKPRM

!     INTEGER, PARAMETER :: BLKSIZE = 500
!     INTEGER, PARAMETER :: BLKSIZE = 50
!     INTEGER, SAVE :: MXCELLS
!     INTEGER, SAVE :: MXBLKS

C Integral average conc

      CONTAINS

         FUNCTION HGRD_INIT ( NPROCS, MYID ) RESULT ( SUCCESS )

         USE UTILIO_DEFN

!        INCLUDE SUBST_VGRD_ID     ! vertical dimensioning parameters

         INTEGER, INTENT( IN ) :: NPROCS  ! total worker processors
         INTEGER, INTENT( IN ) :: MYID
         LOGICAL :: SUCCESS

         LOGICAL, SAVE :: FIRSTIME = .TRUE.
         CHARACTER( 96 ) :: XMSG = ' '

C environment variable grid name to select from GRIDDESC
         INTEGER :: STATUS, ALST

         INTEGER, ALLOCATABLE :: NCOLS_PE( : )  ! Column range for each PE
         INTEGER, ALLOCATABLE :: NROWS_PE( : )  ! Row range for each PE

         INTEGER I

C-----------------------------------------------------------------------

C This function is expected to be called only once - at startup

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            SUCCESS = .TRUE.

            MYPE = MYID

#ifndef mpas
C With GRID_NAME (only input) retrieve all horizontal grid parameters from
C the grid description file pointed to by the GRIDDESC env var:
            IF ( .NOT. DSCGRID ( GRID_NAME,
     &                           COORD_SYS_NAME, GDTYP_GD, 
     &                           P_ALP_GD, P_BET_GD, P_GAM_GD,
     &                           XCENT_GD, YCENT_GD,
     &                           XORIG_GD, YORIG_GD, XCELL_GD, YCELL_GD,
     &                           GL_NCOLS, GL_NROWS, NTHIK ) ) THEN
               XMSG = 'Failure retrieving horizontal grid parameters'
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
#endif
 
            IF ( GL_NROWS .LE. 1 .AND. GL_NCOLS .LE. 1 ) COLUMN_MODEL = .TRUE.

C Check NPROCS against NPCOL*NPROW
            IF ( NPROCS .NE. NPCOL*NPROW ) THEN
               WRITE( LOGDEV,* ) ' --- Nprocs, NProw, NPcol ',
     &                                 NPROCS, NPROW, NPCOL
               XMSG = 'NPROCS is not equal to NPCOL*NPROW'
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            IF ( NPROCS .GT. GL_NCOLS*GL_NROWS ) THEN

               WRITE( LOGDEV,* ) ' --- Nprocs, TOTAL_NCOLS, TOTAL_NROWS ',
     &                                 NPROCS, GL_NCOLS, GL_NROWS
               IF ( MYPE .EQ. 0 ) THEN
                  WRITE( OUTDEV,'(A,4(1X,I4))') ' --- Nprocs, TOTAL_NCOLS, TOTAL_NROWS ',
     &                                                NPROCS, GL_NCOLS, GL_NROWS
               END IF

               XMSG = 'NPROCS must be less than or equal to TOTAL_NCOLS*TOTAL_NROWS'
               IF ( MYPE .EQ. 0 ) THEN
                  WRITE(OUTDEV,'(A)')TRIM( XMSG )
               END IF 
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )

               XMSG = 'Change NPROCS, NPCOL, NPROW in runscript to fit TOTAL_NCOLS and TOTAL_NROWS'
               IF ( MYPE .EQ. 0 ) THEN
                  WRITE(OUTDEV,'(A,/)')TRIM( XMSG )
               END IF 
               WRITE(LOGDEV,'(A)')TRIM( XMSG )

               SUCCESS = .FALSE.; RETURN

            END IF

            ALLOCATE ( COLSX_PE( 2,NPROCS ),
     &                 ROWSX_PE( 2,NPROCS ), STAT = ALST )
            IF ( ALST .NE. 0 ) THEN
               XMSG = '*** COLSX_PE or ROWSX_PE Memory allocation failed'
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            ALLOCATE ( COLSD_PE( 2,NPROCS ),
     &                 ROWSD_PE( 2,NPROCS ), STAT = ALST )
            IF ( ALST .NE. 0 ) THEN
               XMSG = '*** COLSD_PE or ROWSD_PE  Memory allocation failed'
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            ALLOCATE ( NCOLS_PE( NPROCS ),
     &                 NROWS_PE( NPROCS ), STAT = ALST )
            IF ( ALST .NE. 0 ) THEN
               XMSG = '*** NCOLS_PE or NROWS_PE Memory allocation failed'
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Construct the processor-to-subdomain map for main domain
            CALL SUBHDOMAIN( NPROCS, NPCOL, NPROW, GL_NCOLS, GL_NROWS,
     &                       NCOLS_PE, NROWS_PE, COLSX_PE, ROWSX_PE )

C Get corresponding dot file map

            DO I = 1, NPROCS
               COLSD_PE( 1,I ) = COLSX_PE( 1,I )
               COLSD_PE( 2,I ) = COLSX_PE( 2,I )
               ROWSD_PE( 1,I ) = ROWSX_PE( 1,I )
               ROWSD_PE( 2,I ) = ROWSX_PE( 2,I )
            END DO

            DO I = NPCOL, NPROCS, NPCOL
               COLSD_PE( 2,I ) = COLSD_PE( 2,I ) + 1
            END DO

            DO I = NPROCS, NPROCS - NPCOL + 1, -1
               ROWSD_PE( 2,I ) = ROWSD_PE( 2,I ) + 1
            END DO

            NCOLS = NCOLS_PE( MYPE+1 )
            NROWS = NROWS_PE( MYPE+1 )
            NBNDY = 2*NTHIK * ( NCOLS + NROWS + 2*NTHIK )
            GL_NBNDY = 2*NTHIK * ( GL_NCOLS + GL_NROWS + 2*NTHIK )

            MY_NCOLS_DOT = COLSD_PE( 2,MYPE+1 ) - COLSD_PE( 1,MYPE+1 ) + 1
            MY_NROWS_DOT = ROWSD_PE( 2,MYPE+1 ) - ROWSD_PE( 1,MYPE+1 ) + 1

!           MXCELLS = NCOLS * NROWS * NLAYS
!           MXBLKS  = 1 + ( MXCELLS - 1 ) / BLKSIZE

            DEALLOCATE ( NCOLS_PE )
            DEALLOCATE ( NROWS_PE )

         ELSE
            XMSG = 'Horizontal domain decomposition already defined'
            CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN

         END IF   ! FIRSTIME

         RETURN
         END FUNCTION HGRD_INIT
 
      END MODULE HGRD_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/PARIO/src/get_write_map.f,v 1.6 2011/10/20 22:49:57 sjr Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

      SUBROUTINE GET_WRITE_MAP( NP, NPC, NPR, NCOLS3D, NROWS3D, NLAYS3D )
C.....................................................................
 
C  PURPOSE:  Determine the processor-to-grid map for the grid
C            to be written.
 
C  REVISION HISTORY: 
C       Original version  1/1999 by Al Bourgeois, to allow pwrite3 to
C              write output on a subgrid.
C       Modified 08/06/1999 by Al Bourgeois to make this a subroutine
C              instead of a function.
C       Modified 10/08/01 by David Wong
C         -- added a missing variable IERR in the SUBDMAP calling arguments
C       Modified 12/31/02 by David Wong
C         -- extended to handle dot file
C       6 May 06 J.Young
C      24 Aug 11 David Wong: extended the implementation to handle window
C                            MET_CRO_3D file
 
C  ARGUMENT LIST DESCRIPTION:
C  E1 in PIOGRID.EXT
C  M2 in PIOMAPS_MODULE
C  IN:
C     INTEGER  NP                    ! Number of processors
C     INTEGER  NPC                   ! Number of processors across grid cols
C     INTEGER  NPR                   ! Number of processors across grid rows
C     INTEGER  GNCOLS            E1  ! Column dimension of global domain
C     INTEGER  GNROWS            E1  ! Row dimension of global domain
C     INTEGER  NCOLS3D               ! Column dimension of file variables
C     INTEGER  NROWS3D               ! Row dimension of file variables
C     INTEGER  NLAYS3D               ! Layer dimension of file variable
C     INTEGER  NCOLS_PE(NP)      M2  ! Number columns in each processor
C     INTEGER  NROWS_PE(NP)      M2  ! Number rows in each processor
C     INTEGER  COLSX_PE(2,NP)    M2  ! Column range for each PE
C     INTEGER  ROWSX_PE(2,NP)    M2  ! Row range for each PE

C  OUT:
C     INTEGER  WR_NCOLS_PE(NP)   M2  ! No. cols of each PE subgrid to write
C     INTEGER  WR_NROWS_PE(NP)   M2  ! No. rows of each PE subgrid to write
C     INTEGER  WR_COLSX_PE(2,NP) M2  ! Col range of each PE subgrid to write
C     INTEGER  WR_ROWSX_PE(2,NP) M2  ! Row range of each PE subgrid to write
 
C  CALLS: SUBDMAP
C........................................................................

      USE PIOMAPS_MODULE

      IMPLICIT  NONE

      INCLUDE 'PIOGRID.EXT'
 
C Arguments:

      INTEGER  NP                    ! Number of processors 
      INTEGER  NPR                   ! Number of processors across grid rows
      INTEGER  NPC                   ! Number of processors across grid cols
      INTEGER  NCOLS3D               ! Column dimension of file variables
      INTEGER  NROWS3D               ! Row dimension of file variables
      INTEGER  NLAYS3D               ! Layer dimension of file variable
 
C Local Variables: 

      INTEGER      I             ! Loop index
      INTEGER      IDUMMY        ! Dummy argument to SUBDMAP, not used
      INTEGER      IERR          ! Return Error code

C........................................................................

C Determine the processor-to-subdomain mapping for the grid to
C be written. If the file variables to be written are defined on
C the entire (global) domain, load the previously defined
C decomposition map. Otherwise, get the new mapping on the subgrid.

      IF (( NCOLS3D .EQ. GNCOLS) .AND. ( NROWS3D .EQ. GNROWS )) THEN

C Set the full-grid processor-to-subdomain mapping

         DO I = 1, NP
            WR_NCOLS_PE( I )   = NCOLS_PE( I )
            WR_NROWS_PE( I )   = NROWS_PE( I )
            WR_COLSX_PE( 1,I ) = COLSX_PE( 1,I )
            WR_COLSX_PE( 2,I ) = COLSX_PE( 2,I )
            WR_ROWSX_PE( 2,I ) = ROWSX_PE( 2,I )
            WR_ROWSX_PE( 1,I ) = ROWSX_PE( 1,I )
         END DO

      ELSE IF (( NCOLS3D .EQ. GNCOLS+1) .AND. ( NROWS3D .EQ. GNROWS+1 )) THEN

C Set the dot full-grid processor-to-subdomain mapping

         DO I = 1, NP
            WR_NCOLS_PE( I )   = NCOLS_PE( I )
            WR_NROWS_PE( I )   = NROWS_PE( I )
            WR_COLSX_PE( 1,I ) = COLSX_PE( 1,I )
            WR_COLSX_PE( 2,I ) = COLSX_PE( 2,I )
            WR_ROWSX_PE( 2,I ) = ROWSX_PE( 2,I )
            WR_ROWSX_PE( 1,I ) = ROWSX_PE( 1,I )
         END DO

         DO I = NPC, NP, NPC
            WR_NCOLS_PE( I )   = NCOLS_PE( I ) + 1
            WR_COLSX_PE( 2,I ) = COLSX_PE( 2,I ) + 1
         END DO

         DO I = NP, NP-NPC+1, -1
            WR_NROWS_PE( I )   = NROWS_PE( I ) + 1
            WR_ROWSX_PE( 2,I ) = ROWSX_PE( 2,I ) + 1
         END DO

      ELSE IF (( NCOLS3D .EQ. GNCOLS+2) .AND. ( NROWS3D .EQ. GNROWS+2 )) THEN

C Set the extended cross full-grid processor-to-subdomain mapping

         DO I = 1, NP
            WR_NCOLS_PE( I )   = NCOLS_PE( I )
            WR_NROWS_PE( I )   = NROWS_PE( I )
            WR_COLSX_PE( 1,I ) = COLSX_PE( 1,I ) + 1
            WR_COLSX_PE( 2,I ) = COLSX_PE( 2,I ) + 1
            WR_ROWSX_PE( 2,I ) = ROWSX_PE( 2,I ) + 1
            WR_ROWSX_PE( 1,I ) = ROWSX_PE( 1,I ) + 1
         END DO

         DO I = 1, NPC    ! south
            WR_NROWS_PE( I )   = NROWS_PE( I ) + 1
            WR_ROWSX_PE( 1,I ) = WR_ROWSX_PE( 1,I ) - 1
         END DO

         DO I = 1, NP, NPC    ! west
            WR_NCOLS_PE( I )   = NCOLS_PE( I ) + 1
            WR_COLSX_PE( 1,I ) = WR_COLSX_PE( 1,I ) - 1
         END DO

         DO I = NPC, NP, NPC  ! east
            WR_NCOLS_PE( I )   = NCOLS_PE( I ) + 1
            WR_COLSX_PE( 2,I ) = WR_COLSX_PE( 2,I ) + 1
         END DO

         DO I = NP, NP-NPC+1, -1  ! north
            WR_NROWS_PE( I )   = NROWS_PE( I ) + 1
            WR_ROWSX_PE( 2,I ) = WR_ROWSX_PE( 2,I ) + 1
         END DO

      ELSE

C Get the subgrid processor-to_subdomain mapping

         CALL SUBDMAP( NP, NCOLS3D, NROWS3D, NLAYS3D, NPC, NPR,
     &                 NCOLS_PE, NROWS_PE, COLSX_PE, ROWSX_PE,
     &                 IDUMMY, IERR )

      END IF
     
      RETURN
      END

!------------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in           !
!  continuous development by various groups and is based on information        !
!  from these groups: Federal Government employees, contractors working        !
!  within a United States Government contract, and non-Federal sources         !
!  including research institutions.  These groups give the Government          !
!  permission to use, prepare derivative works of, and distribute copies       !
!  of their work in the CMAQ system to the public and to permit others         !
!  to do so.  The United States Environmental Protection Agency                !
!  therefore grants similar permission to use the CMAQ system software,        !
!  but users are requested to provide copies of derivative works or            !
!  products designed to operate in the CMAQ system to the United States        !
!  Government without restrictions as to use by others.  Software              !
!  that is used with the CMAQ system but distributed under the GNU             !
!  General Public License or the GNU Lesser General Public License is          !
!  subject to their copyright restrictions.                                    !
!------------------------------------------------------------------------------!

MODULE const

!------------------------------------------------------------------------------! 
! Purpose: Fundamental constants for air quality modeling. Includes functions
!          for calculating saturation vapor pressure and its reciprocal.
!------------------------------------------------------------------------------! 
 
!------------------------------------------------------------------------------! 
! References:
!   CRC Handbook of Chemistry and Physics (76th Ed), CRC Press, 1995 
!
!   Hobbs, P.V., Basic Physical Chemistry for the Atmospheric Sciences,
!     Cambridge Univ. Press, 206 pp, 1995.  
!
!   Snyder, J.P., Map Projections-A Working Manual, U.S. Geological Survey
!     Paper 1395 U.S.GPO, Washington, DC, 1987.
!
!   Stull, R.B., An Introduction to Boundary Layer Meteorology, Kluwer, 
!     Dordrecht, 1988
!
!   NIST, The International System of Units (SI). Newell, D.B. and 
!     Tiesinga, E., eds. NIST Special Publication 330, 2019.
!     doi: 10.6028/nist.sp.330-2019.
!------------------------------------------------------------------------------! 

  IMPLICIT NONE

! Geometric Constants:
  REAL,      PARAMETER :: PI = 3.14159265
  REAL( 8 ), PARAMETER :: DPI = 3.14159265358979324D0
  Real( 8 ), Parameter :: f6dpi = 6.0D0 / dpi
  Real,      Parameter :: f6pi = 6.0 / pi
  Real( 8 ), Parameter :: dpi6 = dpi / 6.0D0
  Real,      Parameter :: pi6 = pi / 6.0

! pi/180 [ rad/deg ]
  REAL,      PARAMETER :: PI180  = PI / 180.0

! Geodetic Constants:
 
  ! radius of the earth [ m ]
  ! -- radius of sphere having same surface area as Clarke ellipsoid of 1866 
  !    ( Source: Snyder, 1987)
 !REAL,      PARAMETER :: REARTH = 6370997.0
  REAL,      PARAMETER :: REARTH = 6370000.0    ! default Re in MM5 and WRF
 
  ! length of a sidereal day [ sec ]  (Source: CRC76 p. 14-6 )
  REAL,      PARAMETER :: SIDAY = 86164.09
 
  ! mean gravitational acceleration [ m/sec**2 ]
  ! -- mean of polar and equatorial values  (Source: CRC76 p. 14-6)
  REAL,      PARAMETER :: GRAV = 9.80622

  ! latitude degrees to meters
  REAL,      PARAMETER :: DG2M = REARTH * PI180

  ! Solar constant [ W/m**2 ] (Source: CRC76 p. 14-2)
  ! UNUSED IN CMAQ
  !   REAL, PARAMETER :: SOLCNST = 1373.0

! Fundamental Constants: (Source: CRC76, pp. 1-1 to 1-6 except where 
!                         specified otherwise)

  ! Avogadro's Constant [ number/mol ] 
  ! Exact definition. Source: NIST 2019 
  REAL,      PARAMETER :: AVO  = 6.02214076E23 
  REAL( 8 ), PARAMETER :: DAVO = 6.02214076D23

  ! Boltzmann Constant [ J K-1 ]
  ! Exact definition. Source: NIST 2019
  REAL,      PARAMETER :: KBOLTZ   = 1.380649E-23 
  REAL( 8 ), PARAMETER :: DKBOLTZ  = 1.380649D-23 

  ! Exact definition. Source: NIST 2019
  REAL,      PARAMETER :: RGASUNIV  =  AVO * KBOLTZ
  REAL( 8 ), PARAMETER :: DRGASUNIV = DAVO * DKBOLTZ

  ! standard atmosphere  [ Pa ]
  REAL,      PARAMETER :: STDATMPA = 101325.0

  ! Standard Temperature [ K ]
  REAL,      PARAMETER :: STDTEMP = 273.15

  ! Stefan-Boltzmann constant [ W/(m**2 K**4) ]
  ! UNUSED IN CMAQ
  ! REAL, PARAMETER :: STFBLZ = 5.67051E-8

! Non-MKS

  ! Molar volume at STP [ L/mol ] Non MKS units 
   REAL,     PARAMETER :: MOLVOL = 22.41410

! Atmospheric Constants: 

! mean molecular weight for dry air [ g/mol ]
! FSB: 78.06% N2, 21% O2, and 0.943% Ar on a mole 
! fraction basis (Source: Hobbs, pp. 69-70)
   REAL,     PARAMETER :: MWAIR = 28.9628
   Real,     Parameter :: inv_mwair   = 1.0E3 / mwair  ! [ mol/kg ]

! dry-air gas constant [ J / kg-K ]
   REAL,     PARAMETER :: RDGAS = 1.0E3 * RGASUNIV / MWAIR   ! 287.07548994

! mean molecular weight for water vapor [ g/mol ]
   REAL,     PARAMETER :: MWWAT = 18.0153

! gas constant for water vapor [ J/kg-K ]
   REAL,     PARAMETER :: RWVAP = 1.0E3 * RGASUNIV / MWWAT   ! 461.52492604

! FSB NOTE: CPD, CVD, CPWVAP and CVWVAP are calculated assuming dry air and
! water vapor are classical ideal gases, i.e. vibration does not contribute
! to internal energy.

! specific heat of dry air at constant pressure [ J/kg-K ]
   REAL,     PARAMETER :: CPD = 7.0 * RDGAS / 2.0            ! 1004.7642148 

! specific heat of dry air at constant volume [ J/kg-K ]
   REAL,     PARAMETER :: CVD = 5.0 * RDGAS / 2.0            ! 717.68872485

! specific heat for water vapor at constant pressure [ J/kg-K ]
   REAL,     PARAMETER :: CPWVAP = 4.0 * RWVAP               ! 1846.0997042

! specific heat for water vapor at constant volume [ J/kg-K ]
   REAL,     PARAMETER :: CVWVAP = 3.0 * RWVAP               ! 1384.5747781

! vapor press of water at 0 C [ Pa ] Source: CRC76 pp. 6-15
   REAL,     PARAMETER :: VP0 = 611.29

! latent heat of vaporization of water at 0 C [ J/kg ] 
! Source: Stull, p. 641
   REAL,     PARAMETER :: LV0 = 2.501E6

! Rate of change of latent heat of vaporization with
! respect to temperature [ J/kg-K ]
! Source: Stull, p. 641
   REAL,     PARAMETER :: DLVDT = 2370.0

! latent heat of fusion of water at 0 C [ J/kg ]
! Source: Stull, p. 641
   REAL,     PARAMETER :: LF0 = 3.34E5

   CONTAINS

! Function to compute saturation vapor pressure of water as a function 
!  of air temperature [Pa]
      REAL FUNCTION ESATL( TT )
        REAL, INTENT(IN) :: TT  ! air temperature in K

        REAL, PARAMETER :: AL = 610.94
        REAL, PARAMETER :: BL = 17.625
        REAL, PARAMETER :: CL = 243.04

! *** values of AL, BL, and CL are from:
!     Alduchov and Eskridge, "Improved Magnus Form Approximations of
!                            Saturation Vapor Pressure,"
!                            Jour. of Applied Meteorology, vol. 35,
!                            pp 601-609, April, 1996.

         ESATL = AL * EXP( BL * ( TT - 273.15 ) / ( TT - 273.15 + CL ) )
       END FUNCTION ESATL

! Function to compute reciprocal of saturation vapor pressure of water
!   as a function of air temperature. [Pa-1] 
      REAL( 8 ) FUNCTION INV_ESATL( TT )
        REAL( 8 ), INTENT( IN ) :: TT
! *** values of AL, BL, and CL are from:
!     Alduchov and Eskridge, "Improved Magnus Form Approximations of
!                            Saturation Vapor Pressure,"
!                            Jour. of Applied Meteorology, vol. 35,
!                            pp 601-609, April, 1996.
        REAL( 8 ), PARAMETER :: AL = 610.94D0 
        REAL( 8 ), PARAMETER :: BL = 17.625D0
        REAL( 8 ), PARAMETER :: CL = 243.04D0
        REAL( 8 ), PARAMETER :: DL = 1.0D0 / AL
        INV_ESATL = DL * DEXP( BL * ( 273.15D0 - TT ) / ( TT - 273.15D0 + CL ) )
      END FUNCTION INV_ESATL

END MODULE const

      MODULE PISAM_DEFN
c
c20140428 Has function PISAM_INIT
c 
c-----------------------------------------------------------------------

!      USE HGRD_DEFN    ! horizontal domain specifications
      USE GRID_CONF    ! horizontal domain specifications
      USE UTILIO_DEFN  ! 20120615

      IMPLICIT NONE

      REAL, ALLOCATABLE, SAVE, TARGET :: PISAM( :,:,:,:,: )

      CONTAINS
        FUNCTION PISAM_INIT (NSPC_TSSA, NTAG_TSSA) RESULT ( SUCCESS )

C-----------------------------------------------------------------------
C20140428   Create ISAM target, PISAM; just like CGRID on PCGRID.
C            Called by driver.F
C      
C-----------------------------------------------------------------------

!         INCLUDE SUBST_VGRD_ID     ! vertical dimensioning parameters
!0615    INCLUDE SUBST_IODECL      ! I/O definitions and declarations

         INTEGER :: NSPC_TSSA
         INTEGER :: NTAG_TSSA

         LOGICAL :: SUCCESS
         INTEGER :: ALLOCSTAT
         LOGICAL, SAVE :: FIRSTIME = .TRUE.
         CHARACTER( 120 ) :: XMSG = ' '

C PISAM extents
         INTEGER :: LCOL
         INTEGER :: HCOL
         INTEGER :: LROW
         INTEGER :: HROW

         SUCCESS = .TRUE.

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.

#ifdef parallel
            LCOL = 1 - NTHIK
            HCOL = NCOLS + NTHIK
            LROW = 1 - NTHIK
            HROW = NROWS + NTHIK
#else
            LCOL = 0
            HCOL = NCOLS+1
            LROW = 0
            HROW = NROWS+1
#endif
            
            ALLOCATE ( PISAM( LCOL:HCOL,
     &                        LROW:HROW,
     &                        NLAYS,
     &                        NSPC_TSSA,
     &                        NTAG_TSSA ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating PISAM'
               CALL M3WARN ( 'PISAM_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
            
            PISAM = 0.0
            
         ELSE
            XMSG = 'PISAM already ALLOCATED'
            CALL M3WARN ( 'PISAM_INIT', 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
         
         RETURN
         END FUNCTION PISAM_INIT
      
      END MODULE PISAM_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains key component from BEIS_DEFN.F to facilitate 
! centralized I/O implementation by avoiding cyclic data dependence

! Revision History:
!  01 Feb 2019 D.Wong initial implementation, 
!------------------------------------------------------------------------!

          module biog_emis_param_module

! Former include file  B3V12DIMS3.EXT
! dimensioning parameters for BEIS v3.12 

            INTEGER, PARAMETER :: NSEF     = 35 ! # of em class in Summer emis factor table
            INTEGER, PARAMETER :: NSEASONS = 2  ! number of seasons modeled (2 for now)
            INTEGER, PARAMETER :: NLAI     = 3  ! no. of different LAIs (ISOP and MBO)
            INTEGER, PARAMETER :: NSUMMER  = 1  ! summer flag
            INTEGER, PARAMETER :: NWINTER  = 2  ! winter flag

! Names for BEIS species, emitted model species
! DO NOT CHANGE THE ORDER OF THESE ARRAYS

            CHARACTER( 5 ), PARAMETER :: BIOTYPES( NSEF ) =
     &                          (/ 'ISOP ', 'MBO  ', 'METH ',
     &                             'APIN ', 'BPIN ', 'D3CAR', 'DLIM ',
     &                             'CAMPH', 'MYRC ', 'ATERP', 'BPHE ',
     &                             'SABI ', 'PCYM ', 'OCIM ', 'ATHU ',
     &                             'TRPO ', 'GTERP', 'ETHE ', 'PROPE',
     &                             'ETHO ', 'ACET ', 'HEXA ', 'HEXE ',
     &                             'HEXY ', 'FORM ', 'ACTAL', 'BUTE ',
     &                             'ETHA ', 'FORAC', 'ACTAC', 'BUTO ',
     &                             'CO   ', 'ORVOC', 'SESQT',
     &                             'NO   ' /)

            CHARACTER( 5 ), PARAMETER :: LAITYPES( NLAI ) =
     &                          (/ 'ISOP ', 'MBO  ', 'METH ' /)

            CHARACTER( 1 ), PARAMETER :: SEASON( NSEASONS ) =
     &                          (/ 'S', 'W' /)

          end module biog_emis_param_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! RCS file, release, date & time of last delta, author, state, [and locker]
! $Header: /project/work/rep/STENEX/src/se_snl/se_comm_module.f,v 1.1 2004/03/26 16:16:47 yoj Exp $

! what(1) key, module and SID; SCCS file; date and time of last delta:
! %W% %P% %G% %U%

! --------------------------------------------------------------------------
! Purpose:
!
!   use F90 interface feature to achieve "faked" polymorphism for pe 
! communication routine and use F90 module feature to modulize pe communication
! functionality of the stencil exchange library
!
! Revision history:
!
!   Orginal version: 11/05/99 by David Wong
!          Modified: 08/24/11 by David Wong
!                      -- elminated data and geo orientation
!          Modified: 10/04/12 by David Wong
!                      -- extended to five dimensional array and made the third,
!                         and fourth dimension more flexible and only limited to
!                         layer and species
!          Modified: 11/01/18 by David Wong
!                      -- remove TAB character
! --------------------------------------------------------------------------

        module se_comm_module

        implicit none

        interface se_comm
          module procedure se_pe_comm1, 
     &                     se_pe_comm2, se_pe_comm2e, 
     &                     se_pe_comm3, se_pe_comm3e, se_pe_comm3s,
     &                     se_pe_comm4,
     &                     se_pe_comm5
        end interface

        contains

! -----------------------------------------------------------------------------
! Purpose:
!
!   determine the set of neighbouring processor(s) that my own processor needs 
!   to communicate with, base upon the input data dependency.
!
! Revision history:
!
!   Orginal version: 7/29/98 by David Wong 
!
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!                    02/06/02 by David Wong
!                      -- adjust the communication direction if it is NE, SE,
!                         SW, or NW
!                    08/24/11 by David Wong
!                      -- removed se_ori_ext to eliminate data and geo orientation
!
! Subroutine parameter description:
!
!   In: dirstr    -- indicator of communication direction associated with
!                    the data dependency: 0 (without communication), 
!                                         1 (with communication)
!       send_to   -- processor number which data needs to be sent to
!       recv_from -- processor number which data is received from
!
! Local variable description:
!
!   rdirection -- input communication direction for receiveing
!   sdirection -- communication direction for sending
!   i, j, k    -- loop indexes
!
! Include file:
!
!   se_comm_info_ext
!
!     se_ngb_pe -- an array to indicate a communication with a certain 
!                  processor is required base upon near-neighbour communication 
!                  pattern: -1 denotes no communication is needed, and a non 
!                  -1 number denotes processor number with which communication 
!                  is formed
!
!   se_ori_ext
!   se_internal_util_module
! -----------------------------------------------------------------------------

        subroutine se_comm_pat (dirstr, send_to, recv_from)

        use se_comm_info_ext
!       use se_ori_ext
        use se_internal_util_module

        implicit none

        character (len = 16), intent(in) :: dirstr
        integer, intent(out) :: send_to (8), recv_from (8)

        integer :: i, j, k
        integer :: rdirection (8), sdirection(8)

! -- extract inform from input strings

        read (dirstr, 10) (rdirection(i), i=1, 8)
 10     format (8i2)

! -- make adjustment if communication direction is: NE, SE, SW, or NW

        do i = 2, 8, 2
           if (rdirection(i) .eq. 1) then
              rdirection(mod(i-1,8)) = 1
              rdirection(mod(i+1,8)) = 1
           end if
        end do

!       if (se_geo_ori .eq. 0) then
           call swap (rdirection(1), rdirection(5))
           call swap (rdirection(2), rdirection(4))
           call swap (rdirection(8), rdirection(6))
!       end if

! -- figuring out send direction pattern
        do i = 1, 8
           sdirection(i) = rdirection(mod(i+3,8)+1)
        end do

! -- determine where data is receiving from
! -- first: N, E, S, and W
        do i = 1, 7, 2
           if ((rdirection (i) .gt. 0) .and.
     &         (se_ngb_pe(i) .ge. 0)) then
              recv_from(i) = se_ngb_pe(i)
           else
              recv_from(i) = -1
           end if
        end do

! -- second: NE, SE, SW, NW, and their immediate neighbours
! --         for instance, NE's immediate neighbours are N, and E
        do i = 2, 8, 2
           if (rdirection(i) .gt. 0) then
              do j = i-1, i+1
                 k = j
                 if (k .eq. 9) then
                    k = 1
                  end if 
                  if (se_ngb_pe(k) .ge. 0) then
                     recv_from(k) = se_ngb_pe(k)
                  else
                     recv_from(k) = -1
                  end if
              end do
           else
              recv_from(i) = -1
           end if
        end do

! -- determine where data is sending to
! -- first: N, E, S, and W
        do i = 1, 7, 2
           if ((sdirection (i) .gt. 0) .and.
     &         (se_ngb_pe(i) .ge. 0)) then
              send_to(i) = se_ngb_pe(i)
           else
              send_to(i) = -1
           end if
        end do

! -- second: NE, SE, SW, NW, and their immediate neighbours
! --         for instance, NE's immediate neighbours are N, and E
        do i = 2, 8, 2
           if (sdirection(i) .gt. 0) then
              do j = i-1, i+1
                 k = j
                 if (k .eq. 9) then
                    k = 1
                  end if 
                  if (se_ngb_pe(k) .ge. 0) then
                     send_to(k) = se_ngb_pe(k)
                  else
                     send_to(k) = -1
                  end if
              end do
           else
              send_to(i) = -1
           end if
        end do

        return
        end subroutine se_comm_pat

! --------------------------------------------------------------------------
! Purpose:
!
!   program se_pe_comm[n][e] performs near-neighbour communication for a 
! n-dimensional data structure
!
! Revision history:
!
!   Orginal version: 9/15/98 by David Wong
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!                    07/23/01 by David Wong
!                      -- redesign the message sending and receiving algorithm
!                    03/06/02 David Wong
!                      -- use blocking communication scheme
!                      -- use array copy mechanism when communicates to itself
!
! Subroutine parameter description:
!
!   In:  data    -- original data
!        dispstr -- displacement string
!        dirstr  -- indicator of communication direction
!                   0 (without communication), 1 (with communication)
!        str     -- an optional argument to indicate the starting index of 
!                   certain dimension
!        flag    -- to indicate se_pe_comm[n]e is used
!
!   Out: data    -- original data after communication
!
! Local variable description:
!
!    send_to       -- processor number which data needs to be sent to
!    send_to_ptr   -- a F90 pointer (alias) of send_to
!    recv_from     -- processor number which data is recvd from
!    recv_from_ptr -- a F90 pointer (alias) of recv_from
!    sdir, rdir    -- loop indexes which indicate send to or recvd from
!    sind          -- store low and high index of each dimension for sending
!                     process
!    sind_ptr      -- a F90 pointer (alias) of sind
!    rind          -- store low and high index of each dimension for receiving
!                     process
!    rind_ptr      -- a F90 pointer (alias) of rind
!    shift         -- an array to hold the amount of index shifting due to
!                     starting index is 1 in a subroutine
!    num_shift     -- number of shifting
!    loc_str       -- a local copy of str
!
! Include file:
!
!   se_data_send_module
!   se_data_recv_module
!   se_internal_util_module
!
! Subroutine/Function call:
!
!   se_comm_pat
!   se_up_low[1]
!
! --------------------------------------------------------------------------

        subroutine se_pe_comm1 (data, dispstr, dirstr, str)

        use se_data_send_module
        use se_data_recv_module
        use se_internal_util_module
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(inout) :: data(:)
        character (len = 16), intent(in) :: dirstr
        character (len = 12), intent(in) :: dispstr
        character (len = *), optional, intent(in) :: str

        integer, target :: sind(2,8), rind(2,8)
        integer, pointer :: sind_ptr(:,:), rind_ptr(:,:)
        integer, target :: send_to(8), recv_from(8)
        integer, pointer :: send_to_ptr(:), recv_from_ptr(:)
        integer :: sdir, rdir
        integer :: shift(2), num_shift
        character (len = 80) :: loc_str
        integer :: request, status(MPI_STATUS_SIZE), error

        if (present(str)) then
           loc_str = str
           call se_string_to_integer (loc_str, shift, num_shift)
        else
           num_shift = 0
        end if

        call se_comm_pat (dirstr, send_to, recv_from)

        call se_up_low1 (dispstr, sind, rind, shift, num_shift)

        send_to_ptr => send_to
        recv_from_ptr => recv_from
        sind_ptr => sind
        rind_ptr => rind

        do sdir = 1, 8, 2

           rdir = mod((sdir + 3), 8) + 1

           if (send_to(sdir) .eq. se_my_pe) then

              data(rind(1,rdir):rind(2,rdir)) = data(sind(1,sdir):sind(2,sdir))

           else 

              if (send_to(sdir) .ge. 0) then
                 call se_data_send (data, sind_ptr, send_to_ptr, sdir, sdir, 
     $                              request)
              end if

              if ((recv_from(rdir) .ge. 0) .and. 
     $            (recv_from(rdir) .ne. se_my_pe)) then
                 call se_data_recv (data, rind_ptr, recv_from_ptr, rdir, sdir)
              end if

!             if (send_to(sdir) .ge. 0) then
!                call mpi_wait (request, status, error)
!             end if

           end if
        end do

        return
        end subroutine se_pe_comm1

! --------------------------------------------------------------------------
! Purpose:
!
!   perform near-neighbour communication for a 2-D data structure with 2-D
! decomposition (se_pe_comm2) or 1-D decomposition (se_pe_comm2e)
!
! Revision history:
!
!   Orginal version: 8/3/98 by David Wong
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!                    07/23/01 by David Wong
!                      -- redesign the message sending and receiving algorithm
!                    03/06/02 David Wong
!                      -- use blocking communication scheme
!                      -- use array copy mechanism when communicates to itself
!
! Subroutine parameter description:
!
!   In:  data    -- original data
!        dispstr -- displacement string
!        dirstr  -- indicator of communication direction
!                   0 (without communication), 1 (with communication)
!        flag    -- to indicate se_pe_comm2e is used
!        str     -- an optional argument to indicate the starting index of
!                   certain dimension
!
!   Out: data    -- original data after communication
!
! Local variable description:
!
!    send_to       -- processor number which data needs to be sent to
!    send_to_ptr   -- a F90 pointer (alias) of send_to
!    recv_from     -- processor number which data is recvd from
!    recv_from_ptr -- a F90 pointer (alias) of recv_from
!    sdir, rdir    -- loop indexes which indicate send to or recvd from
!    sind          -- store low and high index of each dimension for sending
!                     process
!    sind_ptr      -- a F90 pointer (alias) of sind
!    rind          -- store low and high index of each dimension for receiving
!                     process
!    rind_ptr      -- a F90 pointer (alias) of rind
!    shift         -- an array to hold the amount of index shifting due to
!                     starting index is 1 in a subroutine
!    num_shift     -- number of shifting
!    loc_str       -- a local copy of str
!
! Include file:
!
!    se_data_send_module
!    se_data_recv_module
!
! Subroutine/Function call:
!
!   se_comm_pat 
!   se_up_low2 
!
! --------------------------------------------------------------------------

        subroutine se_pe_comm2 (data, dispstr, dirstr, str)

        use se_data_send_module
        use se_data_recv_module
        use se_internal_util_module
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(inout) :: data(:,:)
        character (len = 16), intent(in) :: dirstr
        character (len = 12), intent(in) :: dispstr
        character (len = *), optional, intent(in) :: str

        integer, target :: send_to(8), recv_from(8)
        integer, pointer :: send_to_ptr(:), recv_from_ptr(:)
        integer, target :: sind(2,2,8), rind(2,2,8)
        integer, pointer :: sind_ptr(:,:,:), rind_ptr(:,:,:)
        integer :: sdir, rdir
        integer :: shift(4), num_shift
        character (len = 80) :: loc_str
        integer :: request, status(MPI_STATUS_SIZE), error

        if (present(str)) then
           loc_str = str
           shift(2:4:2) = 1
           call se_string_to_integer (loc_str, shift, num_shift)
        else
           num_shift = 0
        end if

        call se_comm_pat (dirstr, send_to, recv_from)

        send_to_ptr => send_to
        recv_from_ptr => recv_from

        call se_up_low2 (dispstr, sind, rind, shift, num_shift)

        sind_ptr => sind
        rind_ptr => rind

        do sdir = 1, 8

           rdir = mod((sdir + 3), 8) + 1

           if (send_to(sdir) .eq. se_my_pe) then

              data(rind(1,1,rdir):rind(2,1,rdir),rind(1,2,rdir):rind(2,2,rdir))
     $        =
     $        data(sind(1,1,sdir):sind(2,1,sdir),sind(1,2,sdir):sind(2,2,sdir))

           else

              if (send_to(sdir) .ge. 0) then
                 call se_data_send (data, sind_ptr, send_to_ptr, sdir, sdir, 
     $                              request)
              end if

              if ((recv_from(rdir) .ge. 0) .and.
     $            (recv_from(rdir) .ne. se_my_pe)) then
                 call se_data_recv (data, rind_ptr, recv_from_ptr, rdir, sdir)
              end if

!             if (send_to(sdir) .ge. 0) then
!                call mpi_wait (request, status, error)
!             end if

           end if

        end do

        return
        end subroutine se_pe_comm2

! -----------------------------------------------------------------------------
        subroutine se_pe_comm2e (data, dispstr, dirstr, flag, str)

        use se_data_send_module
        use se_data_recv_module
        use se_internal_util_module
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(inout) :: data(:,:)
        character (len = 16), intent(in) :: dirstr
        character (len = 12), intent(in) :: dispstr
        integer, intent(in) :: flag
        character (len = *), optional, intent(in) :: str

        integer, target :: send_to(8), recv_from(8)
        integer, pointer :: send_to_ptr(:), recv_from_ptr(:)
        integer, target :: sind(2,8), rind(2,8)
        integer, pointer :: sind_ptr(:,:), rind_ptr(:,:)
        integer :: sdir, rdir
        integer :: shift(4), num_shift
        character (len = 80) :: loc_str
        integer :: request, status(MPI_STATUS_SIZE), error

        if (present(str)) then
           loc_str = str
           shift(2:4:2) = 1
           call se_string_to_integer (loc_str, shift, num_shift)
        else
           num_shift = 0
        end if

        call se_comm_pat (dirstr, send_to, recv_from)

        send_to_ptr => send_to
        recv_from_ptr => recv_from

        call se_up_low1 (dispstr, sind, rind, shift, num_shift)

        sind_ptr => sind
        rind_ptr => rind

        do sdir = 1, 8, 2

           rdir = mod((sdir + 3), 8) + 1

           if (send_to(sdir) .eq. se_my_pe) then

              data(rind(1,rdir):rind(2,rdir),:) 
     $        =
     $        data(sind(1,sdir):sind(2,sdir),:)

           else

              if (send_to(sdir) .ge. 0) then
                 call se_data_send (data, sind_ptr, send_to_ptr, sdir, sdir,
     $                              request)
              end if

              if ((recv_from(rdir) .ge. 0) .and.
     $            (recv_from(rdir) .ne. se_my_pe)) then
                 call se_data_recv (data, rind_ptr, recv_from_ptr, rdir, sdir)
              end if

!             if (send_to(sdir) .ge. 0) then
!                call mpi_wait (request, status, error)
!             end if

           end if
        end do

        return
        end subroutine se_pe_comm2e

! --------------------------------------------------------------------------
! Purpose:
!
!   perform near-neighbour communication for a 3-D data structure with 2-D
! decomposition (se_pe_comm3) or 1-D decomposition (se_pe_comm3e)
!
! Revision history:
!
!   Orginal version: 7/29/98 by David Wong 
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!                    07/23/01 by David Wong
!                      -- redesign the message sending and receiving algorithm
!                    03/06/02 David Wong
!                      -- use blocking communication scheme
!                      -- use array copy mechanism when communicates to itself
!
! Subroutine parameter description:
!
!   In:  data    -- original data
!        dispstr -- displacement string
!        dirstr  -- indicator of communication direction
!                   0 (without communication), 1 (with communication)
!        flag    -- to indicate se_pe_comm2e is used
!        str     -- an optional argument to indicate the starting index of
!                   certain dimension
!
!   Out: data     -- original data after communication
!
! Local variable description:
!
!    send_to       -- processor number which data needs to be sent to
!    send_to_ptr   -- a F90 pointer (alias) of send_to
!    recv_from     -- processor number which data is recvd from
!    recv_from_ptr -- a F90 pointer (alias) of recv_from
!    sdir, rdir    -- loop indexes which indicate send to or recvd from
!    rdirection    -- input communication direction for receiveing
!    sdirection    -- communication direction for sending
!    ldecomp       -- domain decomposition indicator
!    sind          -- store low and high index of each dimension for sending
!                     process
!    sind_ptr      -- a F90 pointer (alias) of sind
!    rind          -- store low and high index of each dimension for receiving
!                     process
!    rind_ptr      -- a F90 pointer (alias) of rind
!    shift         -- an array to hold the amount of index shifting due to
!                     starting index is 1 in a subroutine
!    num_shift     -- number of shifting
!    loc_str       -- a local copy of str
!
! Include file:
!
!    se_data_send_module
!    se_data_recv_module
!
! Subroutine/Function call:
!
!   se_comm_pat
!   se_up_low3
!
! --------------------------------------------------------------------------

        subroutine se_pe_comm3 (data, dispstr, dirstr, str)

        use se_data_send_module
        use se_data_recv_module
        use se_internal_util_module
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(inout) ::  data(:,:,:)
        character (len = 16), intent(in) :: dirstr
        character (len = 12), intent(in) :: dispstr
        character (len = *), optional, intent(in) :: str

        integer, target :: send_to(8), recv_from(8)
        integer, pointer :: send_to_ptr(:), recv_from_ptr(:)
        integer, target :: sind(2,3,8), rind(2,3,8)
        integer, pointer :: sind_ptr(:,:,:), rind_ptr(:,:,:)
        integer :: sdir, rdir
        integer :: shift(6), num_shift
        character (len = 80) :: loc_str
        integer :: request, status(MPI_STATUS_SIZE), error

        if (present(str)) then
           loc_str = str
           shift(2:6:2) = 1
           call se_string_to_integer (loc_str, shift, num_shift)
        else
           num_shift = 0
        end if

        call se_comm_pat (dirstr, send_to, recv_from)

        send_to_ptr => send_to
        recv_from_ptr => recv_from

        call se_up_low3 (dispstr, sind, rind, shift, num_shift, size(data,3))

        sind_ptr => sind
        rind_ptr => rind

        do sdir = 1, 8

           rdir = mod((sdir + 3), 8) + 1

           if (send_to(sdir) .eq. se_my_pe) then

              data(rind(1,1,rdir):rind(2,1,rdir),
     $             rind(1,2,rdir):rind(2,2,rdir),
     $             rind(1,3,rdir):rind(2,3,rdir))
     $        =
     $        data(sind(1,1,sdir):sind(2,1,sdir),
     $             sind(1,2,sdir):sind(2,2,sdir),
     $             sind(1,3,sdir):sind(2,3,sdir))

           else

              if (send_to(sdir) .ge. 0) then
                 call se_data_send (data, sind_ptr, send_to_ptr, sdir, sdir,
     $                              request)
              end if

              if ((recv_from(rdir) .ge. 0) .and.
     $            (recv_from(rdir) .ne. se_my_pe)) then
                 call se_data_recv (data, rind_ptr, recv_from_ptr, rdir, sdir)
              end if

!             if (send_to(sdir) .ge. 0) then
!                call mpi_wait (request, status, error)
!             end if

           end if
        end do
 
        return
        end subroutine se_pe_comm3

! --------------------------------------------------------------------------
        subroutine se_pe_comm3e (data, dispstr, dirstr, flag, str)

        use se_data_send_module
        use se_data_recv_module
        use se_internal_util_module
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(inout) ::  data(:,:,:)
        character (len = 16), intent(in) :: dirstr
        character (len = 12), intent(in) :: dispstr
        integer, intent(in) :: flag
        character (len = *), optional, intent(in) :: str

        integer, target :: send_to(8), recv_from(8)
        integer, pointer :: send_to_ptr(:), recv_from_ptr(:)
        integer, target :: sind(2,8), rind(2,8)
        integer, pointer :: sind_ptr(:,:), rind_ptr(:,:)
        integer :: sdir, rdir
        integer :: shift(6), num_shift
        character (len = 80) :: loc_str
        integer :: request, status(MPI_STATUS_SIZE), error

        if (present(str)) then
           loc_str = str
           shift(2:6:2) = 1
           call se_string_to_integer (loc_str, shift, num_shift)
        else
           num_shift = 0
        end if

        call se_comm_pat (dirstr, send_to, recv_from)

        send_to_ptr => send_to
        recv_from_ptr => recv_from

        call se_up_low1 (dispstr, sind, rind, shift, num_shift)

        sind_ptr => sind
        rind_ptr => rind

        do sdir = 1, 8, 2

           rdir = mod((sdir + 3), 8) + 1

           if (send_to(sdir) .eq. se_my_pe) then

              data(rind(1,rdir):rind(2,rdir),:,:)
     $        =
     $        data(sind(1,sdir):sind(2,sdir),:,:)

           else
              if (send_to(sdir) .ge. 0) then
                 call se_data_send (data, sind_ptr, send_to_ptr, sdir, sdir,
     $                              request)
              end if

              if ((recv_from(rdir) .ge. 0) .and.
     $            (recv_from(rdir) .ne. se_my_pe)) then
                 call se_data_recv (data, rind_ptr, recv_from_ptr, rdir, sdir)
              end if

!             if (send_to(sdir) .ge. 0) then
!                call mpi_wait (request, status, error)
!             end if

           end if
        end do
 
        return
        end subroutine se_pe_comm3e

! --------------------------------------------------------------------------
! Purpose:
!
!   perform near-neighbour communication for transfer data between two 3-D arrays
!
! Revision history:
!
!   Orginal version: 10/29/17 by David Wong
!
! Subroutine parameter description:
!
!   In:  sdata   -- input data
!        dispstr -- displacement string
!        dirstr  -- indicator of communication direction
!                   0 (without communication), 1 (with communication)
!        str     -- an optional argument to indicate the starting index of
!                   certain dimension
!
!   Out: ddata   -- output data after communication
!
! Local variable description:
!
!    send_to       -- processor number which data needs to be sent to
!    send_to_ptr   -- a F90 pointer (alias) of send_to
!    recv_from     -- processor number which data is recvd from
!    recv_from_ptr -- a F90 pointer (alias) of recv_from
!    sdir, rdir    -- loop indexes which indicate send to or recvd from
!    sind          -- store low and high index of each dimension for sending
!                     process
!    sind_ptr      -- a F90 pointer (alias) of sind
!    rind          -- store low and high index of each dimension for receiving
!                     process
!    rind_ptr      -- a F90 pointer (alias) of rind
!    shift         -- an array to hold the amount of index shifting due to
!                     starting index is 1 in a subroutine
!    num_shift     -- number of shifting
!    loc_str       -- a local copy of str
!
! Include file:
!
!    se_data_send_module
!    se_data_recv_module
!
! Subroutine/Function call:
!
!   se_comm_pat
!   se_up_low3
!
! --------------------------------------------------------------------------
        subroutine se_pe_comm3s (sdata, ddata, dispstr, dirstr, str)

        use se_data_send_module
        use se_data_recv_module
        use se_internal_util_module
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(in)  ::  sdata(:,:,:)
        real, intent(out) ::  ddata(:,:,:)
        character (len = 16), intent(in) :: dirstr
        character (len = 12), intent(in) :: dispstr
        character (len = *), optional, intent(in) :: str

        integer, target :: send_to(8), recv_from(8)
        integer, pointer :: send_to_ptr(:), recv_from_ptr(:)
        integer, target :: sind(2,8), rind(2,8)
        integer, pointer :: sind_ptr(:,:), rind_ptr(:,:)
        integer :: sdir, rdir
        integer :: shift(6), num_shift
        character (len = 80) :: loc_str
        integer :: request, status(MPI_STATUS_SIZE), error, dsize

        if (present(str)) then
           loc_str = str
           shift(2:6:2) = 1
           call se_string_to_integer (loc_str, shift, num_shift)
        else
           num_shift = 0
        end if

        call se_comm_pat (dirstr, send_to, recv_from)

        send_to_ptr => send_to
        recv_from_ptr => recv_from

        call se_up_low1 (dispstr, sind, rind, shift, num_shift)

        sind_ptr => sind
        rind_ptr => rind

        dsize = size(sdata)

        do sdir = 1, 8, 2

           rdir = mod((sdir + 3), 8) + 1

           if (send_to(sdir) .eq. se_my_pe) then

              ddata = sdata

           else
              if (send_to(sdir) .ge. 0) then
                 call mpi_send (sdata, dsize, mpi_real, send_to_ptr(sdir), 
     $                          sdir, se_worker_comm, error)
              end if

              if ((recv_from(rdir) .ge. 0) .and.
     $            (recv_from(rdir) .ne. se_my_pe)) then
                 call mpi_recv (ddata, dsize, mpi_real, recv_from_ptr(rdir), sdir,
     &                          se_worker_comm, status, error)
              end if

!             if (send_to(sdir) .ge. 0) then
!                call mpi_wait (request, status, error)
!             end if

           end if
        end do
 
        end subroutine se_pe_comm3s

! --------------------------------------------------------------------------
! Purpose:
!
!   perform near-neighbour communication for a 4-D data structure with 2-D
! decomposition 
!
! Revision history:
!
!   Orginal version: 7/31/98 by David Wong
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!                    07/23/01 by David Wong
!                      -- redesign the message sending and receiving algorithm
!                    03/06/02 David Wong
!                      -- use blocking communication scheme
!                      -- use array copy mechanism when communicates to itself
!
! Subroutine parameter description:
!
!   In:  data    -- original data
!        dispstr -- displacement string
!        dirstr  -- indicator of communication direction
!                   0 (without communication), 1 (with communication)
!        str     -- an optional argument to indicate the starting index of
!                   certain dimension
!
!   Out: data    -- original data after communication
!
! Local variable description:
!
!    send_to       -- processor number which data needs to be sent to
!    send_to_ptr   -- a F90 pointer (alias) of send_to
!    recv_from     -- processor number which data is recvd from
!    recv_from_ptr -- a F90 pointer (alias) of recv_from
!    sdir, rdir    -- loop indexes which indicate send to or recvd from
!    sind          -- store low and high index of each dimension for sending
!                     process
!    sind_ptr      -- a F90 pointer (alias) of sind
!    rind          -- store low and high index of each dimension for receiving
!                     process
!    rind_ptr      -- a F90 pointer (alias) of rind
!    shift         -- an array to hold the amount of index shifting due to
!                     starting index is 1 in a subroutine
!    num_shift     -- number of shifting
!    loc_str       -- a local copy of str
!
! Include file:
!
!    se_data_send_module
!    se_data_recv_module
!
! Subroutine/Function call:
!
!   se_comm_pat
!   se_up_low4
!
! --------------------------------------------------------------------------

        subroutine se_pe_comm4 (data, dispstr, dirstr, str)

        use se_data_send_module
        use se_data_recv_module
        use se_internal_util_module
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(inout) :: data(:,:,:,:)
        character (len = 16), intent(in) :: dirstr
        character (len = 12), intent(in) :: dispstr
        character (len = *), optional, intent(in) :: str

        integer, target :: send_to(8), recv_from(8)
        integer, pointer :: send_to_ptr(:), recv_from_ptr(:)
        integer, target :: sind(2,4,8), rind(2,4,8)
        integer, pointer :: sind_ptr(:,:,:), rind_ptr(:,:,:)
        integer :: sdir, rdir
        integer :: shift(8), num_shift
        character (len = 80) :: loc_str
        integer :: request, status(MPI_STATUS_SIZE), error

        if (present(str)) then
           loc_str = str
           shift(2:8:2) = 1
           call se_string_to_integer (loc_str, shift, num_shift)
        else
           num_shift = 0
        end if

        call se_comm_pat (dirstr, send_to, recv_from)

        call se_up_low4 (dispstr, sind, rind, shift, num_shift, size(data,3), size(data,4))

        send_to_ptr => send_to
        recv_from_ptr => recv_from
        sind_ptr => sind
        rind_ptr => rind

        do sdir = 1, 8

           rdir = mod((sdir + 3), 8) + 1

           if (send_to(sdir) .eq. se_my_pe) then

              data(rind(1,1,rdir):rind(2,1,rdir),
     $             rind(1,2,rdir):rind(2,2,rdir),
     $             rind(1,3,rdir):rind(2,3,rdir),
     $             rind(1,4,rdir):rind(2,4,rdir))
     $        =
     $        data(sind(1,1,sdir):sind(2,1,sdir),
     $             sind(1,2,sdir):sind(2,2,sdir),
     $             sind(1,3,sdir):sind(2,3,sdir),
     $             sind(1,4,sdir):sind(2,4,sdir))

           else

              if (send_to(sdir) .ge. 0) then
                 call se_data_send (data, sind_ptr, send_to_ptr, sdir, sdir,
     $                              request)
              end if

              if ((recv_from(rdir) .ge. 0) .and.
     $            (recv_from(rdir) .ne. se_my_pe)) then
                 call se_data_recv (data, rind_ptr, recv_from_ptr, rdir, sdir)
              end if

!             if (send_to(sdir) .ge. 0) then
!                call mpi_wait (request, status, error)
!             end if

           end if
        end do

        return
        end subroutine se_pe_comm4

! --------------------------------------------------------------------------
        subroutine se_pe_comm4e (data, dispstr, dirstr, flag, str)

        use se_data_send_module
        use se_data_recv_module
        use se_internal_util_module
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(inout) ::  data(:,:,:,:)
        character (len = 16), intent(in) :: dirstr
        character (len = 12), intent(in) :: dispstr
        integer, intent(in) :: flag
        character (len = *), optional, intent(in) :: str

        integer, target :: send_to(8), recv_from(8)
        integer, pointer :: send_to_ptr(:), recv_from_ptr(:)
        integer, target :: sind(2,8), rind(2,8)
        integer, pointer :: sind_ptr(:,:), rind_ptr(:,:)
        integer :: sdir, rdir
        integer :: shift(8), num_shift
        character (len = 80) :: loc_str
        integer :: request, status(MPI_STATUS_SIZE), error

        if (present(str)) then
           loc_str = str
           shift(2:8:2) = 1
           call se_string_to_integer (loc_str, shift, num_shift)
        else
           num_shift = 0
        end if

        call se_comm_pat (dirstr, send_to, recv_from)

        send_to_ptr => send_to
        recv_from_ptr => recv_from

        call se_up_low1 (dispstr, sind, rind, shift, num_shift)

        sind_ptr => sind
        rind_ptr => rind

        do sdir = 1, 8, 2

           rdir = mod((sdir + 3), 8) + 1

           if (send_to(sdir) .eq. se_my_pe) then

              data(rind(1,rdir):rind(2,rdir),:,:,:)
     $        =
     $        data(sind(1,sdir):sind(2,sdir),:,:,:)

           else
              if (send_to(sdir) .ge. 0) then
                 call se_data_send (data, sind_ptr, send_to_ptr, sdir, sdir,
     $                              request)
              end if

              if ((recv_from(rdir) .ge. 0) .and.
     $            (recv_from(rdir) .ne. se_my_pe)) then
                 call se_data_recv (data, rind_ptr, recv_from_ptr, rdir, sdir)
              end if

!             if (send_to(sdir) .ge. 0) then
!                call mpi_wait (request, status, error)
!             end if

           end if
        end do
 
        return
        end subroutine se_pe_comm4e

! --------------------------------------------------------------------------

        subroutine se_pe_comm5 (data, dispstr, dirstr, str)

        use se_data_send_module
        use se_data_recv_module
        use se_internal_util_module
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(inout) :: data(:,:,:,:,:)
        character (len = 16), intent(in) :: dirstr
        character (len = 12), intent(in) :: dispstr
        character (len = *), optional, intent(in) :: str

        integer, target :: send_to(8), recv_from(8)
        integer, pointer :: send_to_ptr(:), recv_from_ptr(:)
        integer, target :: sind(2,5,8), rind(2,5,8)
        integer, pointer :: sind_ptr(:,:,:), rind_ptr(:,:,:)
        integer :: sdir, rdir
        integer :: shift(10), num_shift
        character (len = 80) :: loc_str
        integer :: request, status(MPI_STATUS_SIZE), error

        if (present(str)) then
           loc_str = str
           shift(2:10:2) = 1
           call se_string_to_integer (loc_str, shift, num_shift)
        else
           num_shift = 0
        end if

        call se_comm_pat (dirstr, send_to, recv_from)

        call se_up_low5 (dispstr, sind, rind, shift, num_shift, size(data,3), size(data,4), size(data,5))

        send_to_ptr => send_to
        recv_from_ptr => recv_from
        sind_ptr => sind
        rind_ptr => rind

        do sdir = 1, 8

           rdir = mod((sdir + 3), 8) + 1

           if (send_to(sdir) .eq. se_my_pe) then

              data(rind(1,1,rdir):rind(2,1,rdir),
     $             rind(1,2,rdir):rind(2,2,rdir),
     $             rind(1,3,rdir):rind(2,3,rdir),
     $             rind(1,4,rdir):rind(2,4,rdir),
     $             rind(1,5,rdir):rind(2,5,rdir))
     $        =
     $        data(sind(1,1,sdir):sind(2,1,sdir),
     $             sind(1,2,sdir):sind(2,2,sdir),
     $             sind(1,3,sdir):sind(2,3,sdir),
     $             sind(1,4,sdir):sind(2,4,sdir),
     $             sind(1,5,sdir):sind(2,5,sdir))

           else

              if (send_to(sdir) .ge. 0) then
                 call se_data_send (data, sind_ptr, send_to_ptr, sdir, sdir,
     $                              request)
              end if

              if ((recv_from(rdir) .ge. 0) .and.
     $            (recv_from(rdir) .ne. se_my_pe)) then
                 call se_data_recv (data, rind_ptr, recv_from_ptr, rdir, sdir)
              end if

!             if (send_to(sdir) .ge. 0) then
!                call mpi_wait (request, status, error)
!             end if

           end if
        end do

        end subroutine se_pe_comm5

! --------------------------------------------------------------------------
! Purpose:
!
!   initialize the lower and upper index of each dimension of a local
!   1-D array
!
! Revision history:
!
!   Orginal version: 9/9/98 by David Wong
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!                    08/24/11 by David Wong
!                      -- removed se_ori_ext to eliminate data and geo orientation
!
! Subroutine parameter description:
!
!   In:  dispstr   -- displacement string
!        shift     -- an array to hold the amount of index shifting due to
!                     starting index is 1 in a subroutine
!        num_shift -- number of shifting
!
!   Out: sind    -- store low and high index of each dimension for sending
!                   process
!        rind    -- store low and high index of each dimension for receiving
!                   process
!
! Local variable description:
!
!    ndis      -- North displacement
!    edis      -- East displacement
!    sdis      -- South displacement
!    wdis      -- West displacement
!    loc_shift -- local adjustment of dummy argument shift
!
! Include file:
! 
!   se_domain_info_ext
!   se_ori_ext
!
! Subroutine/Function call:
!
!   store1 
!
! --------------------------------------------------------------------------

        subroutine se_up_low1 (dispstr, sind, rind, shift, num_shift)

        use se_domain_info_ext
!       use se_ori_ext

        implicit none

        integer, intent(out) :: sind(2,8), rind(2,8)
        character (len = 12), intent(in) :: dispstr
        integer, intent(in) :: shift(2), num_shift
        integer :: ndis, edis, sdis, wdis, loc_shift

        if (num_shift .gt. 0) then
           loc_shift = 1 - shift(2)
        else
           loc_shift = 0
        end if

!       if (se_geo_ori .eq. 0) then
           read (dispstr, 20) sdis, edis, ndis, wdis
!       else
!          read (dispstr, 20) ndis, edis, sdis, wdis
!       end if
 20     format (4i3)

! -- ( sending ) determine ghost cells indexes configuration
        if (sdis .gt. 0) then
           call store1 (sind, 1, 1+loc_shift, sdis+loc_shift)
        end if
        if (ndis .gt. 0) then
           call store1 (sind, 5, se_my_nrows-ndis+1+loc_shift, 
     &                  se_my_nrows+loc_shift)
        end if
        if (wdis .gt. 0) then
           call store1 (sind, 3, se_my_ncols-wdis+1+loc_shift, 
     &                  se_my_ncols+loc_shift)
        end if
        if (edis .gt. 0) then
           call store1 (sind, 7, 1+loc_shift, edis+loc_shift)
        end if
 
! -- ( receiving ) determine ghost cells indexes configuration
        if (ndis .gt. 0) then
           call store1 (rind, 1, 1-ndis+loc_shift, loc_shift)
        end if
        if (sdis .gt. 0) then
           call store1 (rind, 5, se_my_nrows+1+loc_shift, 
     &                  se_my_nrows+sdis+loc_shift)
        end if
        if (edis .gt. 0) then
           call store1 (rind, 3, se_my_ncols+1+loc_shift, 
     &                  se_my_ncols+edis+loc_shift)
        end if
        if (wdis .gt. 0) then
           call store1 (rind, 7, 1-wdis+loc_shift, loc_shift)
        end if

        return
        end subroutine se_up_low1

! --------------------------------------------------------------------------
! Purpose:
!
!   to store low and high array indexes of a given domain with ghost cells
!
! Revision history:
!
!   Orginal version: 9/9/98 by David Wong
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!
! Subroutine parameter description:
!
!   In:  direction -- communication direction
!        i1        -- low index of I dimension
!        i2        -- high index of I dimension
!
!   Out: array     -- array with low and high indexes of each dimension
! --------------------------------------------------------------------------

        subroutine store1 (array, direction, i1, i2)

        integer, intent(out) :: array (2,8) 
        integer, intent(in) :: direction, i1, i2

          array(1,direction) = i1
          array(2,direction) = i2

        return
        end subroutine store1

! --------------------------------------------------------------------------
! Purpose:
!
!   initialize the lower and upper index of each dimension of a local
!   2-D array 
!
! Revision history:
!
!   Orginal version: 8/3/98 by David Wong
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!                    1/17/01 by David Wong
!                      -- use a new function se_corner_adjust to adjust stencil
!                         in the NE, SE, SW, and NW direction of the boundary
!                         processors. The adjustment is applied to the store
!                         function which determine the sending and receiving
!                         indices.
!                    11/28/01 by David Wong
!                      -- make calculation of loc_shift more general to suit
!                         RC orientation.
!                    08/24/11 by David Wong
!                      -- removed se_ori_ext to eliminate data and geo orientation
!
! Subroutine parameter description:
!
!   In:  dispstr   -- displacement string
!        shift     -- an array to hold the amount of index shifting due to
!                     starting index is 1 in a subroutine
!        num_shift -- number of shifting
!
!   Out: sind    -- store low and high index of each dimension for sending
!                   process
!        rind    -- store low and high index of each dimension for receiving
!                   process
!
! Local variable description:
!
!    ndis      -- North displacement
!    edis      -- East displacement
!    sdis      -- South displacement
!    wdis      -- West displacement
!    i         -- loop index
!    loc_shift -- local adjustment of dummy argument shift
!
! Include file:
! 
!   se_domain_info_ext
!   se_ori_ext
!
! Subroutine/Function call:
!
!   store2 
!
! --------------------------------------------------------------------------

        subroutine se_up_low2 (dispstr, sind, rind, shift, num_shift)

        use se_domain_info_ext
!       use se_ori_ext
        use se_internal_util_module

        implicit none

        integer, intent(inout) :: sind(2,2,8), rind(2,2,8)
        character (len = 12), intent(in) :: dispstr
        integer, intent(in) :: shift(4), num_shift

        integer :: ndis, edis, sdis, wdis, loc_shift(2), i
        integer :: n_adj, e_adj, s_adj, w_adj

        if (num_shift .gt. 0) then
!          if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
              if (shift(1) .eq. 1) then
                 loc_shift(1) = 1 - shift(4)
                 loc_shift(2) = 1 - shift(2)
              else
                 loc_shift(1) = 1 - shift(2)
                 loc_shift(2) = 1 - shift(4)
              end if
!          else
!             if (shift(1) .eq. 1) then
!                loc_shift(1) = 1 - shift(2)
!                loc_shift(2) = 1 - shift(4)
!             else
!                loc_shift(1) = 1 - shift(4)
!                loc_shift(2) = 1 - shift(2)
!             end if
!          end if
        else
           loc_shift(1) = 0
           loc_shift(2) = 0
        end if

!       if (se_geo_ori .eq. 0) then
           read (dispstr, 20) sdis, edis, ndis, wdis
!       else
!          read (dispstr, 20) ndis, edis, sdis, wdis
!       end if
 20     format (4i3)

        call se_corner_adjust (ndis, edis, sdis, wdis, 1,
     &                         n_adj, e_adj, s_adj, w_adj)

! -- ( sending ) determine ghost cells indexes configuration 
        call store2 (sind, 1, 1+loc_shift(1), sdis+loc_shift(1),
     &               1+loc_shift(2)-w_adj, se_my_ncols+loc_shift(2)+e_adj)
        call store2 (sind, 2, 1+loc_shift(1), sdis+loc_shift(1),
     &               se_my_ncols-wdis+1+loc_shift(2), se_my_ncols+loc_shift(2))
        call store2 (sind, 3, 1+loc_shift(1)-n_adj, 
     &               se_my_nrows+loc_shift(1)+s_adj,
     &               se_my_ncols-wdis+1+loc_shift(2), se_my_ncols+loc_shift(2))
        call store2 (sind, 4, se_my_nrows-ndis+1+loc_shift(1),
     &               se_my_nrows+loc_shift(1), se_my_ncols-wdis+1+loc_shift(2),
     &               se_my_ncols+loc_shift(2))
        call store2 (sind, 5, se_my_nrows-ndis+1+loc_shift(1),
     &               se_my_nrows+loc_shift(1), 1+loc_shift(2)-w_adj,
     &               se_my_ncols+loc_shift(2)+e_adj)
        call store2 (sind, 6, se_my_nrows-ndis+1+loc_shift(1),
     &               se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &               edis+loc_shift(2))
        call store2 (sind, 7, 1+loc_shift(1)-n_adj, 
     &               se_my_nrows+loc_shift(1)+s_adj,
     &               1+loc_shift(2), edis+loc_shift(2))
        call store2 (sind, 8, 1+loc_shift(1), sdis+loc_shift(1),
     &               1+loc_shift(2), edis+loc_shift(2))

        call se_corner_adjust (ndis, edis, sdis, wdis, 2,
     &                         n_adj, e_adj, s_adj, w_adj)

! -- ( receiving ) determine ghost cells indexes configuration 
        call store2 (rind, 1, 1-ndis+loc_shift(1), loc_shift(1),
     &               1+loc_shift(2)-w_adj, se_my_ncols+loc_shift(2)+e_adj)
        call store2 (rind, 2, 1-ndis+loc_shift(1), loc_shift(1),
     &               se_my_ncols+1+loc_shift(2), se_my_ncols+edis+loc_shift(2))
        call store2 (rind, 3, 1+loc_shift(1)-n_adj, 
     &               se_my_nrows+loc_shift(1)+s_adj, se_my_ncols+1+loc_shift(2),
     &               se_my_ncols+edis+loc_shift(2))
        call store2 (rind, 4, se_my_nrows+1+loc_shift(1),
     &               se_my_nrows+sdis+loc_shift(1),
     &               se_my_ncols+1+loc_shift(2), se_my_ncols+edis+loc_shift(2))
        call store2 (rind, 5, se_my_nrows+1+loc_shift(1),
     &               se_my_nrows+sdis+loc_shift(1), 1+loc_shift(2)-w_adj,
     &               se_my_ncols+loc_shift(2)+e_adj)
        call store2 (rind, 6, se_my_nrows+1+loc_shift(1),
     &               se_my_nrows+sdis+loc_shift(1), 1-wdis+loc_shift(2),
     &               loc_shift(2))
        call store2 (rind, 7, 1+loc_shift(1)-n_adj, 
     &               se_my_nrows+loc_shift(1)+s_adj,
     &               1-wdis+loc_shift(2), loc_shift(2))
        call store2 (rind, 8, 1-ndis+loc_shift(1), loc_shift(1),
     &               1-wdis+loc_shift(2), loc_shift(2))

!       if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
           do i = 1, 8
              call swap (sind(1,1,i), sind(1,2,i))
              call swap (sind(2,1,i), sind(2,2,i))
              call swap (rind(1,1,i), rind(1,2,i))
              call swap (rind(2,1,i), rind(2,2,i))
           end do
!       end if

        return
        end subroutine se_up_low2

! --------------------------------------------------------------------------
! Purpose:
!
!   to store low and high array indexes of a given domain with ghost cells
!
! Revision history:
!
!   Orginal version: 7/28/98 by David Wong
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!
! Subroutine parameter description:
!
!   In:  direction -- communication direction
!        i1        -- low index of I dimension
!        i2        -- high index of I dimension
!        j1        -- low index of J dimension
!        j2        -- high index of J dimension
!
!   Out: array     -- array with low and high indexes of each dimension
! --------------------------------------------------------------------------

        subroutine store2 (array, direction, i1, i2, j1, j2)

        integer, intent(out) :: array (2,2,8) 
        integer, intent(in) :: direction, i1, i2, j1, j2

          array(1,1,direction) = i1
          array(2,1,direction) = i2
          array(1,2,direction) = j1
          array(2,2,direction) = j2

        return
        end subroutine store2

! --------------------------------------------------------------------------
! Purpose:
!
!   initialize the lower and upper index of each dimension of a local
!   3-D array
!
! Revision history:
!
!   Orginal version: 8/2/98 by David Wong 
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!                    1/17/01 by David Wong
!                      -- use a new function se_corner_adjust to adjust stencil
!                         in the NE, SE, SW, and NW direction of the boundary
!                         processors. The adjustment is applied to the store
!                         function which determine the sending and receiving
!                         indices.
!                    11/28/01 by David Wong
!                      -- make calculation of loc_shift more general to suit
!                         RC orientation.
!                    08/24/11 by David Wong
!                      -- removed se_ori_ext to eliminate data and geo orientation
!
! Subroutine parameter description:
!
!   In:  dispstr   -- displacement string
!        shift     -- an array to hold the amount of index shifting due to
!                     starting index is 1 in a subroutine
!        num_shift -- number of shifting
!
!   Out: sind    -- store low and high index of each dimension for sending
!                   process
!        rind    -- store low and high index of each dimension for receiving
!                   process
!
! Local variable description:
!
!    ndis      -- North displacement
!    edis      -- East displacement
!    sdis      -- South displacement
!    wdis      -- West displacement
!    i         -- loop index
!    loc_shift -- local adjustment of dummy argument shift
!    ldecomp   -- hold the values of decompstr
!
! Include file:
!
!   se_domain_info_ext
!   se_ori_ext
!
!   se_comm_info_ext
!
!     decompstr -- indicator of which dimenion(s) of data is/are decomposed,
!                  0 (not decomposed), 1 (decomposed)
!
! Subroutine/Function call:
!
!   store3 
!
! --------------------------------------------------------------------------

        subroutine se_up_low3 (dispstr, sind, rind, shift, num_shift, s3)

        use se_domain_info_ext
        use se_comm_info_ext
!       use se_ori_ext
        use se_internal_util_module

        implicit none

        integer, intent(inout) :: sind(2,3,8), rind(2,3,8)
        character (len = 12), intent(in) :: dispstr
        integer, intent(in) :: shift(6), num_shift, s3

        integer :: ndis, edis, sdis, wdis, loc_shift(3), i
        integer :: ldecomp(4)
        integer :: n_adj, e_adj, s_adj, w_adj

        read (se_decompstr, 15) (ldecomp(i), i=1, 4)
 15     format (8i2)

        if (num_shift .gt. 0) then
!          if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
              if (shift(1) .eq. 1) then
                 loc_shift(1) = 1 - shift(4)
                 loc_shift(2) = 1 - shift(2)
              else
                 loc_shift(1) = 1 - shift(2)
                 loc_shift(2) = 1 - shift(4)
              end if
!          else
!             if (shift(1) .eq. 1) then
!                loc_shift(1) = 1 - shift(2)
!                loc_shift(2) = 1 - shift(4)
!             else
!                loc_shift(1) = 1 - shift(4)
!                loc_shift(2) = 1 - shift(2)
!             end if
!          end if
           loc_shift(3) = 1 - shift(6)
        else
           loc_shift(1:3) = 0
        end if

!       if (se_geo_ori .eq. 0) then
           read (dispstr, 20) sdis, edis, ndis, wdis
!       else
!          read (dispstr, 20) ndis, edis, sdis, wdis
!       end if
 20     format (4i3)

        call se_corner_adjust (ndis, edis, sdis, wdis, 1,
     &                         n_adj, e_adj, s_adj, w_adj)

! -- ( sending ) determine ghost cells indexes configuration which
! -- depends on spatial decomposition type 1, 2, and 3, respectively
        if ((ldecomp(1) + ldecomp(3) .eq. 1) .and. 
     &      (ldecomp(1) .eq. 1)) then
           call store3 (sind, 1, 1+loc_shift(1), sdis+loc_shift(1), 
     &                  1+loc_shift(2)-w_adj, se_my_ncols+loc_shift(2)+e_adj, 
     &                  1+loc_shift(3), s3+loc_shift(3))
           call store3 (sind, 2, 1+loc_shift(1), sdis+loc_shift(1), 
     &                  se_my_ncols-wdis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 3, 1+loc_shift(1)-n_adj, 
     &                  se_my_nrows+loc_shift(1)+s_adj, 
     &                  se_my_ncols-wdis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 4, se_my_nrows-ndis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-wdis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 5, se_my_nrows-ndis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2)-w_adj, 
     &                  se_my_ncols+loc_shift(2)+e_adj, 1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 6, se_my_nrows-ndis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  edis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 7, 1+loc_shift(1)-n_adj, 
     &                  se_my_nrows+loc_shift(1)+s_adj, 
     &                  1+loc_shift(2), edis+loc_shift(2), 1+loc_shift(3),
     &                  s3+loc_shift(3))
           call store3 (sind, 8, 1+loc_shift(1), sdis+loc_shift(1), 
     &                  1+loc_shift(2), edis+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3))
        else if ((ldecomp(1) + ldecomp(2) .eq. 1) .and. 
     &           (ldecomp(2) .eq. 1)) then
           call store3 (sind, 1, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), sdis+loc_shift(2), 1+loc_shift(3)-w_adj,
     &                  s3+loc_shift(3)+e_adj)
           call store3 (sind, 2, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), sdis+loc_shift(2), 
     &                  s3-wdis+1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 3, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  s3-wdis+1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 4, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-ndis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 
     &                  s3-wdis+1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 5, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-ndis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3)-w_adj,
     &                  s3+loc_shift(3)+e_adj)
           call store3 (sind, 6, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-ndis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  edis+loc_shift(3))
           call store3 (sind, 7, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  1+loc_shift(3), edis+loc_shift(3))
           call store3 (sind, 8, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), sdis+loc_shift(2), 1+loc_shift(3), 
     &                  edis+loc_shift(3))
        else
           call store3 (sind, 1, 1+loc_shift(1)-w_adj,
     &                  se_my_nrows+loc_shift(1)+e_adj, 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), sdis+loc_shift(3))
           call store3 (sind, 2, se_my_nrows-wdis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  sdis+loc_shift(3))
           call store3 (sind, 3, se_my_nrows-wdis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3)-n_adj, 
     &                  s3+loc_shift(3)+s_adj)
           call store3 (sind, 4, se_my_nrows-wdis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 
     &                  s3-ndis+1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 5, 1+loc_shift(1)-w_adj,
     &                  se_my_nrows+loc_shift(1)+e_adj,
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3-ndis+1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 6, 1+loc_shift(1), edis+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3-ndis+1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (sind, 7, 1+loc_shift(1), edis+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3)-n_adj, s3+loc_shift(3)+s_adj)
           call store3 (sind, 8, 1+loc_shift(1), edis+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), sdis+loc_shift(3))
        end if

        call se_corner_adjust (ndis, edis, sdis, wdis, 2,
     &                         n_adj, e_adj, s_adj, w_adj)

! -- ( receiving ) determine ghost cells indexes configuration which
! -- depends on spatial decomposition, type 1, 2, and 3, respectively
        if ((ldecomp(1) + ldecomp(3) .eq. 1) .and. 
     &      (ldecomp(1) .eq. 1)) then
           call store3 (rind, 1, 1-ndis+loc_shift(1), loc_shift(1), 
     &                  1+loc_shift(2)-w_adj, se_my_ncols+loc_shift(2)+e_adj, 
     &                  1+loc_shift(3), s3+loc_shift(3))
           call store3 (rind, 2, 1-ndis+loc_shift(1), loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+edis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (rind, 3, 1+loc_shift(1)-n_adj, 
     &                  se_my_nrows+loc_shift(1)+s_adj, 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+edis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (rind, 4, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+sdis+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+edis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (rind, 5, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+sdis+loc_shift(1), 1+loc_shift(2)-w_adj, 
     &                  se_my_ncols+loc_shift(2)+e_adj, 1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (rind, 6, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+sdis+loc_shift(1), 1-wdis+loc_shift(2), 
     &                  loc_shift(2), 1+loc_shift(3), s3+loc_shift(3))
           call store3 (rind, 7, 1+loc_shift(1)-n_adj, 
     &                  se_my_nrows+loc_shift(1)+s_adj, 
     &                  1-wdis+loc_shift(2), loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3))
           call store3 (rind, 8, 1-ndis+loc_shift(1), loc_shift(1), 
     &                  1-wdis+loc_shift(2), loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3))
        else if ((ldecomp(1) + ldecomp(2) .eq. 1) .and. 
     &           (ldecomp(2) .eq. 1)) then
           call store3 (rind, 1, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1-ndis+loc_shift(2), loc_shift(2), 1+loc_shift(3)-w_adj,
     &                  s3+loc_shift(3)+e_adj)
           call store3 (rind, 2, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1-ndis+loc_shift(2), loc_shift(2), 
     &                  s3+1+loc_shift(3), 
     &                  s3+edis+loc_shift(3))
           call store3 (rind, 3, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  s3+1+loc_shift(3), 
     &                  s3+edis+loc_shift(3))
           call store3 (rind, 4, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+sdis+loc_shift(2), 
     &                  s3+1+loc_shift(3), 
     &                  s3+edis+loc_shift(3))
           call store3 (rind, 5, 1+loc_shift(1), se_my_nrows+loc_shift(1),
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+sdis+loc_shift(2), 1+loc_shift(3)-w_adj, 
     &                  s3+loc_shift(3)+e_adj)
           call store3 (rind, 6, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+sdis+loc_shift(2), 1-wdis+loc_shift(3), 
     &                  loc_shift(3))
           call store3 (rind, 7, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  1-wdis+loc_shift(3), loc_shift(3))
           call store3 (rind, 8, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1-ndis+loc_shift(2), loc_shift(2), 1-wdis+loc_shift(3), 
     &                  loc_shift(3))
        else
           call store3 (rind, 1, 1+loc_shift(1)-w_adj, 
     &                  se_my_nrows+loc_shift(1)+e_adj, 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1-ndis+loc_shift(3), 
     &                  loc_shift(3))
           call store3 (rind, 2, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+edis+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1-ndis+loc_shift(3), 
     &                  loc_shift(3))
           call store3 (rind, 3, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+edis+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3)-n_adj,
     &                  s3+loc_shift(3)+s_adj)
           call store3 (rind, 4, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+edis+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), s3+1+loc_shift(3), 
     &                  s3+sdis+loc_shift(3))
           call store3 (rind, 5, 1+loc_shift(1)-w_adj, 
     &                  se_my_nrows+loc_shift(1)+e_adj, 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), s3+1+loc_shift(3), 
     &                  s3+sdis+loc_shift(3))
           call store3 (rind, 6, 1-wdis+loc_shift(1), loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3+1+loc_shift(3), 
     &                  s3+sdis+loc_shift(3))
           call store3 (rind, 7, 1-wdis+loc_shift(1), loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3)-n_adj, s3+loc_shift(3)+s_adj)
           call store3 (rind, 8, 1-wdis+loc_shift(1), loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1-ndis+loc_shift(3), loc_shift(3))
        end if

!       if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
           do i = 1, 8
              call swap (sind(1,1,i), sind(1,2,i))
              call swap (sind(2,1,i), sind(2,2,i))
              call swap (rind(1,1,i), rind(1,2,i))
              call swap (rind(2,1,i), rind(2,2,i))
           end do
!       end if

        return
        end subroutine se_up_low3

! --------------------------------------------------------------------------
! Purpose:
!
!   to store low and high array indexes of a given domain with ghost cells
!
! Revision history:
!
!   Orginal version: 7/28/98 by David Wong
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!
! Subroutine parameter description:
!
!   In:  direction -- communication direction
!        i1        -- low index of I dimension
!        i2        -- high index of I dimension
!        j1        -- low index of J dimension
!        j2        -- high index of J dimension
!        k1        -- low index of K dimension
!        k2        -- high index of K dimension
!
!   Out: array     -- array with low and high indexes of each dimension
! --------------------------------------------------------------------------

        subroutine store3 (array, direction, i1, i2, j1, j2, k1, k2)

        integer, intent(out) :: array (2,3,8) 
        integer, intent(in) :: direction, i1, i2, j1, j2, k1, k2

          array(1,1,direction) = i1
          array(2,1,direction) = i2
          array(1,2,direction) = j1
          array(2,2,direction) = j2
          array(1,3,direction) = k1
          array(2,3,direction) = k2

        return
        end subroutine store3

! --------------------------------------------------------------------------
! Purpose:
!
!   initialize the lower and upper index of each dimension of a local
!   4-D array
!
! Revision history:
!
!   Orginal version: 8/3/98 by David Wong
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!                    1/17/01 by David Wong
!                      -- use a new function se_corner_adjust to adjust stencil
!                         in the NE, SE, SW, and NW direction of the boundary
!                         processors. The adjustment is applied to the store
!                         function which determine the sending and receiving
!                         indices.
!                    11/28/01 by David Wong
!                      -- make calculation of loc_shift more general to suit
!                         RC orientation.
!                    08/24/11 by David Wong
!                      -- removed se_ori_ext to eliminate data and geo orientation
!
! Subroutine parameter description:
!
!   In:  dispstr   -- displacement string
!        shift     -- an array to hold the amount of index shifting due to
!                     starting index is 1 in a subroutine
!        num_shift -- number of shifting
!
!   Out: sind      -- store low and high index of each dimension for sending
!                     process
!        rind      -- store low and high index of each dimension for receiving
!                     process
!
! Local variable description:
!
!    ndis      -- North displacement
!    edis      -- East displacement
!    sdis      -- South displacement
!    wdis      -- West displacement
!    i         -- loop index
!    loc_shift -- local adjustment of dummy argument shift
!    ldecomp   -- hold the values of decompstr 
!
! Include file:
!
!   se_domain_info_ext
!   se_ori_ext
!
!   se_comm_info.ext
!
!     decompstr -- indicator of which dimenion(s) of data is/are decomposed,
!                  0 (not decomposed), 1 (decomposed)
!
! Subroutine/Function call:
!
!   store4 
!
! --------------------------------------------------------------------------

        subroutine se_up_low4 (dispstr, sind, rind, shift, num_shift, s3, s4)

        use se_domain_info_ext
        use se_comm_info_ext
!       use se_ori_ext
        use se_internal_util_module

        implicit none

        integer, intent(inout) :: sind(2,4,8), rind(2,4,8)
        character (len = 12), intent(in) :: dispstr
        integer, intent(in) :: shift(8), num_shift, s3, s4

        integer :: ndis, edis, sdis, wdis, loc_shift(4), i
        integer :: ldecomp(4)
        integer :: n_adj, e_adj, s_adj, w_adj

        if (num_shift .gt. 0) then
!          if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
              if (shift(1) .eq. 1) then
                 loc_shift(1) = 1 - shift(4)
                 loc_shift(2) = 1 - shift(2)
              else
                 loc_shift(1) = 1 - shift(2)
                 loc_shift(2) = 1 - shift(4)
              end if
!          else
!             if (shift(1) .eq. 1) then
!                loc_shift(1) = 1 - shift(2)
!                loc_shift(2) = 1 - shift(4)
!             else
!                loc_shift(1) = 1 - shift(4)
!                loc_shift(2) = 1 - shift(2)
!             end if
!          end if
           loc_shift(3) = 1 - shift(6)
           loc_shift(4) = 1 - shift(8)
        else
           loc_shift(1:4) = 0
        end if

        read (se_decompstr, 15) (ldecomp(i), i=1, 4)
 15     format (8i2)

!       if (se_geo_ori .eq. 0) then
           read (dispstr, 20) sdis, edis, ndis, wdis
!       else
!          read (dispstr, 20) ndis, edis, sdis, wdis
!       end if
 20     format (4i3)

        call se_corner_adjust (ndis, edis, sdis, wdis, 1,
     &                         n_adj, e_adj, s_adj, w_adj)

! -- ( sending ) determine ghost cells indexes configuration which
! -- depends on spatial decomposition type 1, 2, 3, 4, 5, and 6, respectively
        if ((ldecomp(1) + ldecomp(3) .eq. 1) .and. 
     &      (ldecomp(1) .eq. 1) .and. (ldecomp(4) .eq. 0)) then
           call store4 (sind, 1, 1+loc_shift(1), sdis+loc_shift(1),
     &                  1+loc_shift(2)-w_adj, se_my_ncols+loc_shift(2)+e_adj,
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  1+loc_shift(4), s4+loc_shift(4))
           call store4 (sind, 2, 1+loc_shift(1), sdis+loc_shift(1),
     &                  se_my_ncols-wdis+1+loc_shift(2),
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 3, 1+loc_shift(1)-n_adj,
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  se_my_ncols-wdis+1+loc_shift(2),
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 4, se_my_nrows-ndis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-wdis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 5, se_my_nrows-ndis+1+loc_shift(1),
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2)-w_adj,
     &                  se_my_ncols+loc_shift(2)+e_adj, 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 6, se_my_nrows-ndis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  edis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 7, 1+loc_shift(1)-n_adj,
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  1+loc_shift(2), edis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 8, 1+loc_shift(1), sdis+loc_shift(1), 
     &                  1+loc_shift(2), edis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
        else if ((ldecomp(2) + ldecomp(4) .eq. 1) .and. 
     &           (ldecomp(2) .eq. 1) .and. (ldecomp(1) .eq. 0)) then
           call store4 (sind, 1, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), sdis+loc_shift(2), 1+loc_shift(3)-w_adj,
     &                  s3+loc_shift(3)+e_adj, 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 2, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), sdis+loc_shift(2), 
     &                  s3-wdis+1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 3, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  s3-wdis+1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 4, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-ndis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 
     &                  s3-wdis+1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 5, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-ndis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3)-w_adj,
     &                  s3+loc_shift(3)+e_adj, 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 6, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-ndis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  edis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 7, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  1+loc_shift(3), edis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 8, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), sdis+loc_shift(2), 1+loc_shift(3), 
     &                  edis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
        else if ((ldecomp(3) + ldecomp(4) .eq. 1) .and. 
     &           (ldecomp(3) .eq. 1) .and. (ldecomp(2) .eq. 0)) then
           call store4 (sind, 1, 1+loc_shift(1)-w_adj, 
     &                  se_my_nrows+loc_shift(1)+e_adj, 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  sdis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 2, se_my_nrows-wdis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  sdis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 3, se_my_nrows-wdis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3)-n_adj, 
     &                  s3+loc_shift(3)+s_adj, 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 4, se_my_nrows-wdis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 
     &                  s3-ndis+1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 5, 1+loc_shift(1)-w_adj, 
     &                  se_my_nrows+loc_shift(1)+e_adj, 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 
     &                  s3-ndis+1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 6, 1+loc_shift(1), edis+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3-ndis+1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 7, 1+loc_shift(1), edis+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3)-n_adj, s3+loc_shift(3)+s_adj,
     &                  1+loc_shift(4), s4+loc_shift(4))
           call store4 (sind, 8, 1+loc_shift(1), edis+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), sdis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
        else if ((ldecomp(1) + ldecomp(4) .eq. 1) .and. 
     &           (ldecomp(4) .eq. 1) .and. (ldecomp(2) .eq. 0)) then
           call store4 (sind, 1, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3)-w_adj, s3+loc_shift(3)+e_adj,
     &                  1+loc_shift(4), sdis+loc_shift(4))
           call store4 (sind, 2, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3-wdis+1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  sdis+loc_shift(4))
           call store4 (sind, 3, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3-wdis+1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4)-n_adj, 
     &                  s4+loc_shift(4)+s_adj)
           call store4 (sind, 4, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3-wdis+1+loc_shift(3), 
     &                  s3+loc_shift(3), 
     &                  s4-ndis+1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 5, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3)-w_adj, s3+loc_shift(3)+e_adj,
     &                  s4-ndis+1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 6, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), edis+loc_shift(3), 
     &                  s4-ndis+1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 7, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), edis+loc_shift(3), 1+loc_shift(4)-n_adj,
     &                  s4+loc_shift(4)+s_adj)
           call store4 (sind, 8, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), edis+loc_shift(3), 1+loc_shift(4), 
     &                  sdis+loc_shift(4))
        else if ((ldecomp(2) + ldecomp(4) .eq. 1) .and. 
     &           (ldecomp(4) .eq. 1) .and. (ldecomp(3) .eq. 0)) then
           call store4 (sind, 1, 1+loc_shift(1), sdis+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  1+loc_shift(4)-w_adj, s4+loc_shift(4)+e_adj)
           call store4 (sind, 2, 1+loc_shift(1), sdis+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  s4-wdis+1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 3, 1+loc_shift(1)-n_adj, 
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  s4-wdis+1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 4, se_my_nrows-ndis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 
     &                  s4-wdis+1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 5, se_my_nrows-ndis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3)-w_adj,
     &                  s3+loc_shift(3)+e_adj, 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 6, se_my_nrows-ndis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  edis+loc_shift(4))
           call store4 (sind, 7, 1+loc_shift(1)-n_adj, 
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  1+loc_shift(4), edis+loc_shift(4))
           call store4 (sind, 8, 1+loc_shift(1), sdis+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  1+loc_shift(4), edis+loc_shift(4))
        else
           call store4 (sind, 1, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), sdis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4)-w_adj,
     &                  s4+loc_shift(4)+e_adj)
           call store4 (sind, 2, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), sdis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 
     &                  s4-wdis+1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 3, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  s4-wdis+1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 4, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-ndis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 
     &                  s4-wdis+1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (sind, 5, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-ndis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4)-w_adj, 
     &                  s4+loc_shift(4)+e_adj)
           call store4 (sind, 6, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-ndis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  edis+loc_shift(4))
           call store4 (sind, 7, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  1+loc_shift(4), edis+loc_shift(4))
           call store4 (sind, 8, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), sdis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  edis+loc_shift(4))
        end if

        call se_corner_adjust (ndis, edis, sdis, wdis, 2,
     &                         n_adj, e_adj, s_adj, w_adj)

! -- ( receiving ) determine ghost cells indexes configuration which
! -- depends on spatial decomposition, type 1, 2, and 3, respectively
        if ((ldecomp(1) + ldecomp(3) .eq. 1) .and.
     &      (ldecomp(1) .eq. 1) .and. (ldecomp(4) .eq. 0)) then
           call store4 (rind, 1, 1-ndis+loc_shift(1), loc_shift(1),
     &                  1+loc_shift(2)-w_adj, se_my_ncols+loc_shift(2)+e_adj,
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  1+loc_shift(4), s4+loc_shift(4))
           call store4 (rind, 2, 1-ndis+loc_shift(1), loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+edis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4),
     &                  s4+loc_shift(4))
           call store4 (rind, 3, 1+loc_shift(1)-n_adj,
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  se_my_ncols+1+loc_shift(2),
     &                  se_my_ncols+edis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4),
     &                  s4+loc_shift(4))
           call store4 (rind, 4, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+sdis+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+edis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 5, se_my_nrows+1+loc_shift(1),
     &                  se_my_nrows+sdis+loc_shift(1), 1+loc_shift(2)-w_adj,
     &                  se_my_ncols+loc_shift(2)+e_adj, 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 6, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+sdis+loc_shift(1), 1-wdis+loc_shift(2), 
     &                  loc_shift(2), 1+loc_shift(3), s3+loc_shift(3), 
     &                  1+loc_shift(4), s4+loc_shift(4))
           call store4 (rind, 7, 1+loc_shift(1)-n_adj,
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  1-wdis+loc_shift(2), loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 8, 1-ndis+loc_shift(1), loc_shift(1), 
     &                  1-wdis+loc_shift(2), loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
        else if ((ldecomp(2) + ldecomp(4) .eq. 1) .and.
     &           (ldecomp(2) .eq. 1) .and. (ldecomp(1) .eq. 0)) then
           call store4 (rind, 1, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1-ndis+loc_shift(2), loc_shift(2), 1+loc_shift(3)-w_adj,
     &                  s3+loc_shift(3)+e_adj, 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 2, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1-ndis+loc_shift(2), loc_shift(2), 
     &                  s3+1+loc_shift(3), 
     &                  s3+edis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 3, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  s3+1+loc_shift(3), 
     &                  s3+edis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 4, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+sdis+loc_shift(2), 
     &                  s3+1+loc_shift(3), 
     &                  s3+edis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 5, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+sdis+loc_shift(2), 1+loc_shift(3)-w_adj, 
     &                  s3+loc_shift(3)+e_adj, 1+loc_shift(4),
     &                  s4+loc_shift(4))
           call store4 (rind, 6, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+sdis+loc_shift(2), 1-wdis+loc_shift(3), 
     &                  loc_shift(3), 1+loc_shift(4), s4+loc_shift(4))
           call store4 (rind, 7, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  1-wdis+loc_shift(3), loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 8, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1-ndis+loc_shift(2), loc_shift(2), 1-wdis+loc_shift(3), 
     &                  loc_shift(3), 1+loc_shift(4), s4+loc_shift(4))
        else if ((ldecomp(3) + ldecomp(4) .eq. 1) .and.
     &           (ldecomp(3) .eq. 1) .and. (ldecomp(2) .eq. 0)) then
           call store4 (rind, 1, 1+loc_shift(1)-w_adj, 
     &                  se_my_nrows+loc_shift(1)+e_adj,
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1-ndis+loc_shift(3), loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 2, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+edis+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1-ndis+loc_shift(3), 
     &                  loc_shift(3), 1+loc_shift(4), s4+loc_shift(4))
           call store4 (rind, 3, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+edis+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3)-n_adj, 
     &                  s3+loc_shift(3)+s_adj, 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 4, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+edis+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), s3+1+loc_shift(3), 
     &                  s3+sdis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 5, 1+loc_shift(1)-w_adj, 
     &                  se_my_nrows+loc_shift(1)+e_adj,
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3+1+loc_shift(3), 
     &                  s3+sdis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 6, 1-wdis+loc_shift(1), loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3+1+loc_shift(3), 
     &                  s3+sdis+loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
           call store4 (rind, 7, 1-wdis+loc_shift(1), loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3)-n_adj, s3+loc_shift(3)+s_adj,
     &                  1+loc_shift(4), s4+loc_shift(4))
           call store4 (rind, 8, 1-wdis+loc_shift(1), loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1-ndis+loc_shift(3), loc_shift(3), 1+loc_shift(4), 
     &                  s4+loc_shift(4))
        else if ((ldecomp(1) + ldecomp(4) .eq. 1) .and.
     &           (ldecomp(4) .eq. 1) .and. (ldecomp(2) .eq. 0)) then
           call store4 (rind, 1, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3)-w_adj, s3+loc_shift(3)+e_adj,
     &                  1-ndis+loc_shift(4), loc_shift(4))
           call store4 (rind, 2, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3+1+loc_shift(3), 
     &                  s3+edis+loc_shift(3), 1-ndis+loc_shift(4), 
     &                  loc_shift(4))
           call store4 (rind, 3, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3+1+loc_shift(3), 
     &                  s3+edis+loc_shift(3), 1+loc_shift(4)-n_adj, 
     &                  s4+loc_shift(4)+s_adj)
           call store4 (rind, 4, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  s3+1+loc_shift(3), 
     &                  s3+edis+loc_shift(3), 
     &                  s4+1+loc_shift(4), 
     &                  s4+sdis+loc_shift(4))
           call store4 (rind, 5, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3)-w_adj, s3+loc_shift(3)+e_adj,
     &                  s4+1+loc_shift(4), 
     &                  s4+sdis+loc_shift(4))
           call store4 (rind, 6, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1-wdis+loc_shift(3), loc_shift(3), 
     &                  s4+1+loc_shift(4), 
     &                  s4+sdis+loc_shift(4))
           call store4 (rind, 7, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1-wdis+loc_shift(3), loc_shift(3), 1+loc_shift(4)-n_adj,
     &                  s4+loc_shift(4)+s_adj)
           call store4 (rind, 8, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1-wdis+loc_shift(3), loc_shift(3), 1-ndis+loc_shift(4), 
     &                  loc_shift(4))
        else if ((ldecomp(2) + ldecomp(4) .eq. 1) .and.
     &           (ldecomp(4) .eq. 1) .and. (ldecomp(3) .eq. 0)) then
           call store4 (rind, 1, 1-ndis+loc_shift(1), loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  1+loc_shift(4)-w_adj, s4+loc_shift(4)+e_adj)
           call store4 (rind, 2, 1-ndis+loc_shift(1), loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  s4+1+loc_shift(4), 
     &                  s4+edis+loc_shift(4))
           call store4 (rind, 3, 1+loc_shift(1)-n_adj, 
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  s4+1+loc_shift(4), 
     &                  s4+edis+loc_shift(4))
           call store4 (rind, 4, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+sdis+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), s4+1+loc_shift(4), 
     &                  s4+edis+loc_shift(4))
           call store4 (rind, 5, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+sdis+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4)-w_adj,
     &                  s4+loc_shift(4)+e_adj)
           call store4 (rind, 6, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+sdis+loc_shift(1), 1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1-wdis+loc_shift(4), 
     &                  loc_shift(4))
           call store4 (rind, 7, 1+loc_shift(1)-n_adj, 
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  1-wdis+loc_shift(4), loc_shift(4))
           call store4 (rind, 8, 1-ndis+loc_shift(1), loc_shift(1), 
     &                  1+loc_shift(2), se_my_ncols+loc_shift(2), 
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  1-wdis+loc_shift(4), loc_shift(4))
        else
           call store4 (rind, 1, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1-ndis+loc_shift(2), loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4)-w_adj,
     &                  s4+loc_shift(4)+e_adj)
           call store4 (rind, 2, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1-ndis+loc_shift(2), loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), s4+1+loc_shift(4), 
     &                  s4+edis+loc_shift(4))
           call store4 (rind, 3, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  s4+1+loc_shift(4), 
     &                  s4+edis+loc_shift(4))
           call store4 (rind, 4, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+sdis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), s4+1+loc_shift(4), 
     &                  s4+edis+loc_shift(4))
           call store4 (rind, 5, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+sdis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1+loc_shift(4)-w_adj,
     &                  s4+loc_shift(4)+e_adj)
           call store4 (rind, 6, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+sdis+loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1-wdis+loc_shift(4), 
     &                  loc_shift(4))
           call store4 (rind, 7, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1+loc_shift(2)-n_adj, se_my_ncols+loc_shift(2)+s_adj,
     &                  1+loc_shift(3), s3+loc_shift(3), 
     &                  1-wdis+loc_shift(4), loc_shift(4))
           call store4 (rind, 8, 1+loc_shift(1), se_my_nrows+loc_shift(1), 
     &                  1-ndis+loc_shift(2), loc_shift(2), 1+loc_shift(3), 
     &                  s3+loc_shift(3), 1-wdis+loc_shift(4), 
     &                  loc_shift(4))
        end if

!       if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
           do i = 1, 8
              call swap (sind(1,1,i), sind(1,2,i))
              call swap (sind(2,1,i), sind(2,2,i))
              call swap (rind(1,1,i), rind(1,2,i))
              call swap (rind(2,1,i), rind(2,2,i))
           end do
!       end if

        return
        end subroutine se_up_low4

! --------------------------------------------------------------------------
! Purpose:
!
!   to store low and high array indexes of a given domain with ghost cells
!
! Revision history:
!
!   Orginal version: 7/28/98 by David Wong
!                    11/05/99 by David Wong
!                      -- recode the code using F90 syntax
!
! Subroutine parameter description:
!
!   In:  direction -- communication direction
!        i1        -- low index of I dimension
!        i2        -- high index of I dimension
!        j1        -- low index of J dimension
!        j2        -- high index of J dimension
!        k1        -- low index of K dimension
!        k2        -- high index of K dimension
!        l1        -- low index of L dimension
!        l2        -- high index of L dimension
!
!   Out: array     -- array with low and high indexes of each dimension
! --------------------------------------------------------------------------

        subroutine store4 (array, dir, i1, i2, j1, j2, k1, k2, l1, l2)

        integer, intent(out) :: array (2,4,8) 
        integer, intent(in) :: dir, i1, i2, j1, j2, k1, k2, l1, l2

          array(1,1,dir) = i1
          array(2,1,dir) = i2
          array(1,2,dir) = j1
          array(2,2,dir) = j2
          array(1,3,dir) = k1
          array(2,3,dir) = k2
          array(1,4,dir) = l1
          array(2,4,dir) = l2

        return
        end subroutine store4

! --------------------------------------------------------------------------

        subroutine se_up_low5 (dispstr, sind, rind, shift, num_shift, s1, s2, s3)

        use se_domain_info_ext
        use se_comm_info_ext
!       use se_ori_ext
        use se_internal_util_module

        use se_pe_info_ext

        implicit none

        integer, intent(inout) :: sind(2,5,8), rind(2,5,8)
        character (len = 12), intent(in) :: dispstr
        integer, intent(in) :: shift(10), num_shift, s1, s2, s3

        integer :: ndis, edis, sdis, wdis, loc_shift(5), i
        integer :: ldecomp(4)
        integer :: n_adj, e_adj, s_adj, w_adj

        if (num_shift .gt. 0) then
           if (shift(1) .eq. 1) then
              loc_shift(1) = 1 - shift(4)
              loc_shift(2) = 1 - shift(2)
           else
              loc_shift(1) = 1 - shift(2)
              loc_shift(2) = 1 - shift(4)
           end if
           loc_shift(3) = 1 - shift(6)
           loc_shift(4) = 1 - shift(8)
           loc_shift(5) = 1 - shift(10)
        else
           loc_shift(1:5) = 0
        end if

        read (se_decompstr, 15) (ldecomp(i), i=1, 4)
 15     format (8i2)

        read (dispstr, 20) sdis, edis, ndis, wdis
 20     format (4i3)

        call se_corner_adjust (ndis, edis, sdis, wdis, 1,
     &                         n_adj, e_adj, s_adj, w_adj)

! -- ( sending ) determine ghost cells indexes configuration which
! -- depends on spatial decomposition type 1, 2, 3, 4, 5, and 6, respectively
        if ((ldecomp(1) + ldecomp(3) .eq. 1) .and. 
     &      (ldecomp(1) .eq. 1) .and. (ldecomp(4) .eq. 0)) then
           call store5 (sind, 1, 1+loc_shift(1), sdis+loc_shift(1),
     &                  1+loc_shift(2)-w_adj, se_my_ncols+loc_shift(2)+e_adj,
     &                  1+loc_shift(3), s1+loc_shift(3), 
     &                  1+loc_shift(4), s2+loc_shift(4), 
     &                  1+loc_shift(5), s3+loc_shift(5))
           call store5 (sind, 2, 1+loc_shift(1), sdis+loc_shift(1),
     &                  se_my_ncols-wdis+1+loc_shift(2),
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
           call store5 (sind, 3, 1+loc_shift(1)-n_adj,
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  se_my_ncols-wdis+1+loc_shift(2),
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
           call store5 (sind, 4, se_my_nrows-ndis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 
     &                  se_my_ncols-wdis+1+loc_shift(2), 
     &                  se_my_ncols+loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
           call store5 (sind, 5, se_my_nrows-ndis+1+loc_shift(1),
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2)-w_adj,
     &                  se_my_ncols+loc_shift(2)+e_adj, 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
           call store5 (sind, 6, se_my_nrows-ndis+1+loc_shift(1), 
     &                  se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &                  edis+loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
           call store5 (sind, 7, 1+loc_shift(1)-n_adj,
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  1+loc_shift(2), edis+loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
           call store5 (sind, 8, 1+loc_shift(1), sdis+loc_shift(1), 
     &                  1+loc_shift(2), edis+loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
        else
           print *, ' ==d== comm5 unknown pattern '
           stop
        end if

        call se_corner_adjust (ndis, edis, sdis, wdis, 2,
     &                         n_adj, e_adj, s_adj, w_adj)

! -- ( receiving ) determine ghost cells indexes configuration which
! -- depends on spatial decomposition, type 1, 2, and 3, respectively
        if ((ldecomp(1) + ldecomp(3) .eq. 1) .and.
     &      (ldecomp(1) .eq. 1) .and. (ldecomp(4) .eq. 0)) then
           call store5 (rind, 1, 1-ndis+loc_shift(1), loc_shift(1),
     &                  1+loc_shift(2)-w_adj, se_my_ncols+loc_shift(2)+e_adj,
     &                  1+loc_shift(3), s1+loc_shift(3), 
     &                  1+loc_shift(4), s2+loc_shift(4), 
     &                  1+loc_shift(5), s3+loc_shift(5))
           call store5 (rind, 2, 1-ndis+loc_shift(1), loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+edis+loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4),
     &                  s2+loc_shift(4), 1+loc_shift(5),
     &                  s3+loc_shift(5))
           call store5 (rind, 3, 1+loc_shift(1)-n_adj,
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  se_my_ncols+1+loc_shift(2),
     &                  se_my_ncols+edis+loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4),
     &                  s2+loc_shift(4), 1+loc_shift(5),
     &                  s3+loc_shift(5))
           call store5 (rind, 4, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+sdis+loc_shift(1), 
     &                  se_my_ncols+1+loc_shift(2), 
     &                  se_my_ncols+edis+loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
           call store5 (rind, 5, se_my_nrows+1+loc_shift(1),
     &                  se_my_nrows+sdis+loc_shift(1), 1+loc_shift(2)-w_adj,
     &                  se_my_ncols+loc_shift(2)+e_adj, 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
           call store5 (rind, 6, se_my_nrows+1+loc_shift(1), 
     &                  se_my_nrows+sdis+loc_shift(1), 1-wdis+loc_shift(2), 
     &                  loc_shift(2), 1+loc_shift(3), s1+loc_shift(3), 
     &                  1+loc_shift(4), s2+loc_shift(4),
     &                  1+loc_shift(5), s3+loc_shift(5))
           call store5 (rind, 7, 1+loc_shift(1)-n_adj,
     &                  se_my_nrows+loc_shift(1)+s_adj,
     &                  1-wdis+loc_shift(2), loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
           call store5 (rind, 8, 1-ndis+loc_shift(1), loc_shift(1), 
     &                  1-wdis+loc_shift(2), loc_shift(2), 1+loc_shift(3), 
     &                  s1+loc_shift(3), 1+loc_shift(4), 
     &                  s2+loc_shift(4), 1+loc_shift(5), 
     &                  s3+loc_shift(5))
        else
           print *, ' ==d== comm5 unknown pattern '
           stop
        end if

        do i = 1, 8
           call swap (sind(1,1,i), sind(1,2,i))
           call swap (sind(2,1,i), sind(2,2,i))
           call swap (rind(1,1,i), rind(1,2,i))
           call swap (rind(2,1,i), rind(2,2,i))
        end do

        end subroutine se_up_low5

! --------------------------------------------------------------------------
        subroutine store5 (array, dir, i1, i2, j1, j2, k1, k2, l1, l2, m1, m2)

        integer, intent(out) :: array (2,5,8) 
        integer, intent(in) :: dir, i1, i2, j1, j2, k1, k2, l1, l2, m1, m2

          array(1,1,dir) = i1
          array(2,1,dir) = i2
          array(1,2,dir) = j1
          array(2,2,dir) = j2
          array(1,3,dir) = k1
          array(2,3,dir) = k2
          array(1,4,dir) = l1
          array(2,4,dir) = l2
          array(1,5,dir) = m1
          array(2,5,dir) = m2

        end subroutine store5

        end module se_comm_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPCONC ( JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Create the IO/API netCDF header and open the output CONC file

C Revision history:
C   Jeff - Dec 00 - split out from initscen.F
C                 - move CGRID_MAP into f90 module
C   Jeff - Feb 01 - assumed shape arrays
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN
C
C    3 Sep 01 David Wong
C     -- let PE 0 open CTM_CONC_1 as new and later on let the rest open
C        it for read and write
C     -- put an explicit barrier before opening a new netCDF file to avoid
C        NCOPEN error
C    7 May 03 J.Young: open and close conc file in processor 0; spin-wait to
C                      deal with nfs network latency for mpich cluster
C   28 Aug 03 J.Young: following Zion Wang at CERT, remove the spin-wait and
C                      simplify opening and closing CONC file (see initscen)
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   30 May 05 J.Young: optional save derived vert. vel. to conc file
C   21 Jan 06 J.Young: add subset non-reactives capability with NR_CONC.EXT
C                      and subset layers saved to conc file; no longer save
C                      RHOJ to conc file
C   22 Aug 06 J.Young: enable capturing IC's as 0 timestep
C   11 Jun 08 J.Young: clean up
C   30 Mar 10 David Wong: removed unnecessary barrier
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                      removed deprecated TRIMLEN
C   Aug 15 D.Wong:     Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O
C                        implementation
C                      Added a block of code to let non I/O processor to open
C                        CTM_CONC_1 file
C   Dec 15 D.Wong:     Removed all the data writing parts and moved it into a
C                      new file, wr_init.F
C   Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE WVEL_DEFN             ! derived vertical velocity component
      USE STD_CONC              ! standard CONC
      USE UTILIO_DEFN
      USE MIO_ASCII
      USE RUNTIME_VARS, ONLY : CONC_BLEV, CONC_ELEV
#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

      INTEGER      JDATE        ! starting date (YYYYDDD)
      INTEGER      JTIME        ! starting time (HHMMSS)
      INTEGER      TSTEP        ! output timestep (HHMMSS)

C Local Variables:

      CHARACTER( 16 ) :: PNAME = 'OPCONC'
      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER( 28 ) :: SSTR = ' species saved to CONC file:'

C environment variable for no. of layers from bottom to save on CONC file
      CHARACTER( 16 ) :: NLAYS_CONC = 'NLAYS_CONC'

C  environment variable description
      CHARACTER( 80 ) :: VARDESC

      INTEGER      K, KD, L, SPC, V, VAR   ! loop counters
      INTEGER      STRT, FINI         ! loop counters
      INTEGER      INDX

      LOGICAL, EXTERNAL :: FLUSH3

C-----------------------------------------------------------------------

#ifndef mpas
C Set output file characteristics based on COORD.EXT and open it

      FTYPE3D = GRDDED3
      SDATE3D = JDATE
      STIME3D = JTIME
      TSTEP3D = TSTEP
      NVARS3D = N_CONC_VARS
      NCOLS3D = GL_NCOLS
      NROWS3D = GL_NROWS
      NLAYS3D = C_NLAYS
      NTHIK3D = 1
      GDTYP3D = GDTYP_GD
      P_ALP3D = P_ALP_GD
      P_BET3D = P_BET_GD 
      P_GAM3D = P_GAM_GD
      XORIG3D = XORIG_GD
      YORIG3D = YORIG_GD
      XCENT3D = XCENT_GD
      YCENT3D = YCENT_GD
      XCELL3D = XCELL_GD
      YCELL3D = YCELL_GD
      VGTYP3D = VGTYP_GD
      VGTOP3D = VGTOP_GD
!     VGTPUN3D = VGTPUN_GD ! currently, not defined
      DO L = 1, NLAYS3D + 1
         VGLVS3D( L ) = VGLVS_GD( L )
      END DO
      GDNAM3D = GRID_NAME  ! from HGRD_DEFN

      FDESC3D( 1 ) = 'Concentration file output'
      FDESC3D( 2 ) = 'From CMAQ model dyn alloc version CTM'
      FDESC3D( 3 ) = 'Set of variables (possibly) reduced from CGRID'
      FDESC3D( 4 ) = 'For next scenario continuation runs,'
      FDESC3D( 5 ) = 'use the "one-step" CGRID file'
      KD = 5
      V = CONC_BLEV
      L = 0
      DO K = KD + 1, MIN ( C_NLAYS + KD, MXDESC3 )
         L = L + 1
         WRITE( FDESC3D( K ),'( "Layer", I3, " to", I3, " " )' )
     &   V + L - 1, L
      END DO
      IF ( ( KD + 1 + L ) .LT. MXDESC3 ) THEN
         DO K = KD + 1 + L, MXDESC3
            FDESC3D( K ) = ' '
         END DO
      END IF

      WRITE( LOGDEV,* ) ' '
      WRITE( LOGDEV,* ) '    Conc File Header Description:'
      DO K = 1, KD + L
         WRITE( LOGDEV,* ) '       ', TRIM( FDESC3D( K ) )
      END DO

      V = 0
      STRT = 1
      FINI = N_C_GC_SPC
      DO SPC = STRT, FINI
         V = V + 1
         VTYPE3D( SPC ) = M3REAL
         VNAME3D( SPC ) = C_GC_SPC( V )
         UNITS3D( SPC ) = 'ppmV'
         VDESC3D( SPC ) = 'Instantaneous Molar Mixing Ratio ' // VNAME3D( SPC )
      END DO

      V = 0
      STRT = FINI + 1
      FINI = FINI + N_C_AE_SPC
      DO SPC = STRT, FINI
         V = V + 1
         VTYPE3D( SPC ) = M3REAL
         VNAME3D( SPC ) = C_AE_SPC( V )   ! from STD_CONC module
         IF ( VNAME3D( SPC )(1:3) .EQ. 'NUM' ) THEN
            UNITS3D( SPC ) = 'm-3'
         ELSE IF ( VNAME3D( SPC )(1:3) .EQ. 'SRF' ) THEN
            UNITS3D( SPC ) = 'm2 m-3'
         ELSE
            UNITS3D( SPC ) = 'ug m-3'
         END IF
         VDESC3D( SPC ) = 'Instantaneous Aerosol Concentration of ' // VNAME3D( SPC )
      END DO

      V = 0
      STRT = FINI + 1
      FINI = FINI + N_C_NR_SPC
      DO SPC = STRT, FINI
         V = V + 1
         VTYPE3D( SPC ) = M3REAL
         VNAME3D( SPC ) = C_NR_SPC( V )   ! from STD_CONC module
         UNITS3D( SPC ) = 'ppmV'
         VDESC3D( SPC ) = 'Instantaneous molar mixing ratio of ' // VNAME3D( SPC )
      END DO

      V = 0
      STRT = FINI + 1
      FINI = FINI + N_C_TR_SPC ! write all TR species
      DO SPC = STRT, FINI
         V = V + 1
         VTYPE3D( SPC ) = M3REAL
         VNAME3D( SPC ) = C_TR_SPC( V )   ! from STD_CONC module
         UNITS3D( SPC ) = 'ppmV'
         VDESC3D( SPC ) = 'Instantaneous molar mixing ratio of ' // VNAME3D( SPC )
      END DO

      VAR = FINI
      IF ( W_VEL ) THEN   ! for vertical velocity from advection
         VAR = VAR + 1
         VTYPE3D( VAR ) = M3REAL
         VNAME3D( VAR ) = 'W_VEL'
         UNITS3D( VAR ) = 'm s-1'
         VDESC3D( VAR ) = 'Derived vertical velocity component'
      END IF
 
      IF ( L_CONC_RH ) THEN   ! for Relative Humidity
         VAR = VAR + 1 
         VTYPE3D( VAR ) = M3REAL
         VNAME3D( VAR ) = 'RH'
         UNITS3D( VAR ) = '1'
         VDESC3D( VAR ) = 'Fractional Relative Humidity'
      END IF
    
      IF ( L_CONC_TA ) THEN   ! for Temperature
         VAR = VAR + 1 
         VTYPE3D( VAR ) = M3REAL
         VNAME3D( VAR ) = 'TA'
         UNITS3D( VAR ) = 'K'
         VDESC3D( VAR ) = 'Air Temperature'
      END IF
    
      IF ( L_CONC_PRES ) THEN   ! for Pressure
         VAR = VAR + 1 
         VTYPE3D( VAR ) = M3REAL
         VNAME3D( VAR ) = 'PRES'
         UNITS3D( VAR ) = 'Pa'
         VDESC3D( VAR ) = 'Air Pressure'
      END IF

      ! Store MIO Metadata
      NDIMS3D( 1:NVARS3D ) = 4
      L_TSTEP( 1:NVARS3D ) = .True.
      L_LAY  ( 1:NVARS3D ) = .True.
      L_COL  ( 1:NVARS3D ) = .True.
      L_ROW  ( 1:NVARS3D ) = .True.
      L_VEXT ( 1:NVARS3D ) = .False.

      CALL LOAD_MIO_FILE ( 'CTM_CONC_1', NLAYS3D, CONC_BLEV, CONC_ELEV,
     &     VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D), 
     &     VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D), 
     &     L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &     L_VEXT(1:NVARS3D) )

C create header

      IF ( IO_PE_INCLUSIVE ) THEN   ! open new

         IF ( .NOT. OPEN3( CTM_CONC_1, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not open ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( .NOT. FLUSH3 ( CTM_CONC_1 ) ) THEN
            XMSG = 'Could not sync to disk ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

      END IF
#endif

      END SUBROUTINE OPCONC

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! RCS file, release, date & time of last delta, author, state, [and locker]
! $Header: /project/work/rep/STENEX/src/se_snl/se_reconfig_grid_module.f,v 1.2 2006/02/15 15:04:29 yoj Exp $

! what(1) key, module and SID; SCCS file; date and time of last delta:
! %W% %P% %G% %U%

! --------------------------------------------------------------------------
! Purpose:
!
!   use F90 interface feature to achieve "faked" polymorphism for grid
! reconfigureation routines which consists of two major parts: se_grid_to_grid
! and se_reconfig_data_copy. The former one is to determine data mapping with
! respect of grid reconfiguration. The latter routine is to conduct messages
! sending and receiving.
!
! Revision history:
!
!   Orginal version: 02/27/01 by David Wong
!                    03/06/02 David Wong
!                      -- use blocking communication scheme
!                      -- use array copy mechanism when communicates to itself
! --------------------------------------------------------------------------

        module se_reconfig_grid_module

        implicit none

        interface se_grid_to_grid
          module procedure se_grid_to_grid2,
     &                     se_grid_to_grid3,
     &                     se_grid_to_grid4
        end interface

        interface se_reconfig_data_copy
          module procedure se_reconfig_data_copy2,
     &                     se_reconfig_data_copy3,
     &                     se_reconfig_data_copy4
        end interface

        contains

C -----------------------------------------------------------------------------
        subroutine se_grid_to_grid2 (nprow1, npcol1, map1, data1,
     &                               nprow2, npcol2, map2, data2)

        use se_reconfig_grid_info_ext
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        integer, intent(in) :: map1(:,:,:), map2(:,:,:)
        real, intent(inout) :: data1(:,:)
        real, intent(inout) :: data2(:,:)
        integer, intent(in) :: nprow1, npcol1, nprow2, npcol2

        integer :: mype
        integer :: tpe, mpe, dpe, error, block, i, j, allocate_status
        integer :: nprow1npcol1, nprow2npcol2

        logical :: intersect

        nprow1npcol1 = nprow1 * npcol1
        nprow2npcol2 = nprow2 * npcol2
c       mype = se_my_pe
        mype = se_myworker_pe

C -- allocate data
        allocate (se_grid1_map(2,2,0:nprow1npcol1-1),stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error '
           stop
        end if

        allocate (se_grid2_map(2,2,0:nprow2npcol2-1),stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error '
           stop
        end if

        se_grid1_map = map1
        se_grid2_map = map2

C -- allocate data
        allocate (se_reconfig_grid_send_ind(2, 4, 0:nprow2npcol2-1), 
     &            stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              ' allocation erorr in se_reconfig_grid_send_ind'
           stop
        end if

        allocate (se_reconfig_grid_recv_ind(2, 4, 0:nprow1npcol1-1), 
     &            stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              ' allocation erorr in se_reconfig_grid_recv_ind'
           stop
        end if

        allocate (se_reconfig_grid_send(0:nprow2npcol2-1), 
     &            stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              'allocation erorr in se_reconfig_grid_send'
           stop
        end if

        allocate (se_reconfig_grid_recv(0:nprow1npcol1-1), 
     &            stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Subroutine SE_SUBGD_INDEX: ',
     &              'allocation erorr in se_reconfig_grid_recv'
           stop
        end if

        se_reconfig_grid_send_ind_ptr => se_reconfig_grid_send_ind
        se_reconfig_grid_recv_ind_ptr => se_reconfig_grid_recv_ind
        se_reconfig_grid_send_ptr => se_reconfig_grid_send
        se_reconfig_grid_recv_ptr => se_reconfig_grid_recv

        se_reconfig_grid_send = -1
        if (mype .lt. nprow1npcol1) then
           do i = 0, nprow2npcol2-1
              intersect = .true.

              if (     (se_grid1_map(1,1,mype) .gt. se_grid2_map(2,1,i))
     &            .or. (se_grid1_map(2,1,mype) .lt. se_grid2_map(1,1,i))) then
                 intersect = .false.
              else
                  if (     (se_grid1_map(1,2,mype) .gt. se_grid2_map(2,2,i))
     &                .or. (se_grid1_map(2,2,mype) .lt. se_grid2_map(1,2,i))) 
     &               then
                     intersect = .false.
                  end if
              end if

              if (intersect) then
                 se_reconfig_grid_send_ind(1,1,i) = max(se_grid1_map(1,1,mype),
     &                         se_grid2_map(1,1,i)) - se_grid1_map(1,1,mype) + 1
                 se_reconfig_grid_send_ind(2,1,i) = min(se_grid1_map(2,1,mype),
     &                         se_grid2_map(2,1,i)) - se_grid1_map(1,1,mype) + 1
                 se_reconfig_grid_send_ind(1,2,i) = max(se_grid1_map(1,2,mype),
     &                         se_grid2_map(1,2,i)) - se_grid1_map(1,2,mype) + 1
                 se_reconfig_grid_send_ind(2,2,i) = min(se_grid1_map(2,2,mype),
     &                         se_grid2_map(2,2,i)) - se_grid1_map(1,2,mype) + 1
                 se_reconfig_grid_send(i) = i
              else
                 se_reconfig_grid_send(i) = -1
              end if
           end do
         end if

C -- determine data is going to receive from which PE, and corresponding local
C    index

        se_reconfig_grid_recv = -1

        if (mype .lt. nprow2npcol2) then
           do i = 0, nprow1npcol1-1
              intersect = .true.

              if (     (se_grid1_map(1,1,i) .gt. se_grid2_map(2,1,mype))
     &            .or. (se_grid1_map(2,1,i) .lt. se_grid2_map(1,1,mype))) then
                 intersect = .false.
              else
                 if (     (se_grid1_map(1,2,i) .gt. se_grid2_map(2,2,mype))
     &               .or. (se_grid1_map(2,2,i) .lt. se_grid2_map(1,2,mype)))then
                    intersect = .false.
                 end if
              end if

              if (intersect) then
                 se_reconfig_grid_recv_ind(1,1,i) = max(se_grid1_map(1,1,i), 
     &                      se_grid2_map(1,1,mype)) - se_grid2_map(1,1,mype) + 1
                 se_reconfig_grid_recv_ind(2,1,i) = min(se_grid1_map(2,1,i), 
     &                      se_grid2_map(2,1,mype)) - se_grid2_map(1,1,mype) + 1
                 se_reconfig_grid_recv_ind(1,2,i) = max(se_grid1_map(1,2,i),
     &                      se_grid2_map(1,2,mype)) - se_grid2_map(1,2,mype) + 1
                 se_reconfig_grid_recv_ind(2,2,i) = min(se_grid1_map(2,2,i),
     &                      se_grid2_map(2,2,mype)) - se_grid2_map(1,2,mype) + 1
                 se_reconfig_grid_recv(i) = i
              end if
           end do
        end if

        call se_reconfig_data_copy2 (npcol1, nprow1, data1, 
     &                               npcol2, nprow2, data2)

        deallocate (se_grid1_map)
        deallocate (se_grid2_map)

        return
        end subroutine se_grid_to_grid2

C -----------------------------------------------------------------------------
        subroutine se_grid_to_grid3 (nprow1, npcol1, map1, data1,
     &                               nprow2, npcol2, map2, data2)

        use se_reconfig_grid_info_ext
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        integer, intent(in) :: map1(:,:,:), map2(:,:,:)
        real, intent(inout) :: data1(:,:,:)
        real, intent(inout) :: data2(:,:,:)
        integer, intent(in) :: nprow1, npcol1, nprow2, npcol2

        integer :: mype
        integer :: tpe, mpe, dpe, error, block, i, j, allocate_status
        integer :: nprow1npcol1, nprow2npcol2

        logical :: intersect

        nprow1npcol1 = nprow1 * npcol1
        nprow2npcol2 = nprow2 * npcol2
c       mype = se_my_pe
        mype = se_myworker_pe

C -- allocate data
        allocate (se_grid1_map(2,2,0:nprow1npcol1-1),stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error '
           stop
        end if

        allocate (se_grid2_map(2,2,0:nprow2npcol2-1),stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error '
           stop
        end if

        se_grid1_map = map1
        se_grid2_map = map2

C -- allocate data
        if (.not. allocated(se_reconfig_grid_send_ind)) then
           allocate (se_reconfig_grid_send_ind(2, 4, 0:nprow2npcol2-1), 
     &               stat=allocate_status)
           if (allocate_status .ne. 0) then
              print *, ' Subroutine SE_SUBGD_INDEX: ',
     &                 ' allocation erorr in se_reconfig_grid_send_ind'
              stop
           end if

           allocate (se_reconfig_grid_recv_ind(2, 4, 0:nprow1npcol1-1), 
     &               stat=allocate_status)
           if (allocate_status .ne. 0) then
              print *, ' Subroutine SE_SUBGD_INDEX: ',
     &                 ' allocation erorr in se_reconfig_grid_recv_ind'
              stop
           end if

           allocate (se_reconfig_grid_send(0:nprow2npcol2-1), 
     &               stat=allocate_status)
           if (allocate_status .ne. 0) then
              print *, ' Subroutine SE_SUBGD_INDEX: ',
     &                 'allocation erorr in se_reconfig_grid_send'
              stop
           end if

           allocate (se_reconfig_grid_recv(0:nprow1npcol1-1), 
     &               stat=allocate_status)
           if (allocate_status .ne. 0) then
              print *, ' Subroutine SE_SUBGD_INDEX: ',
     &                 'allocation erorr in se_reconfig_grid_recv'
              stop
           end if

           se_reconfig_grid_send_ind_ptr => se_reconfig_grid_send_ind
           se_reconfig_grid_recv_ind_ptr => se_reconfig_grid_recv_ind
           se_reconfig_grid_send_ptr => se_reconfig_grid_send
           se_reconfig_grid_recv_ptr => se_reconfig_grid_recv

        end if

        se_reconfig_grid_send = -1
        if (mype .lt. nprow1npcol1) then
           do i = 0, nprow2npcol2-1
              intersect = .true.

              if (     (se_grid1_map(1,1,mype) .gt. se_grid2_map(2,1,i))
     &            .or. (se_grid1_map(2,1,mype) .lt. se_grid2_map(1,1,i))) then
                 intersect = .false.
              else
                  if (     (se_grid1_map(1,2,mype) .gt. se_grid2_map(2,2,i))
     &                .or. (se_grid1_map(2,2,mype) .lt. se_grid2_map(1,2,i))) 
     &                then
                     intersect = .false.
                  end if
              end if

              if (intersect) then
                 se_reconfig_grid_send_ind(1,1,i) = max(se_grid1_map(1,1,mype),
     &                         se_grid2_map(1,1,i)) - se_grid1_map(1,1,mype) + 1
                 se_reconfig_grid_send_ind(2,1,i) = min(se_grid1_map(2,1,mype),
     &                         se_grid2_map(2,1,i)) - se_grid1_map(1,1,mype) + 1
                 se_reconfig_grid_send_ind(1,2,i) = max(se_grid1_map(1,2,mype),
     &                         se_grid2_map(1,2,i)) - se_grid1_map(1,2,mype) + 1
                 se_reconfig_grid_send_ind(2,2,i) = min(se_grid1_map(2,2,mype),
     &                         se_grid2_map(2,2,i)) - se_grid1_map(1,2,mype) + 1
                 se_reconfig_grid_send(i) = i
              else
                 se_reconfig_grid_send(i) = -1
              end if
           end do
        end if

C -- determine data is going to receive from which PE, and corresponding local
C    index

        se_reconfig_grid_recv = -1

        if (mype .lt. nprow2npcol2) then
           do i = 0, nprow1npcol1-1
              intersect = .true.

              if (     (se_grid1_map(1,1,i) .gt. se_grid2_map(2,1,mype))
     &            .or. (se_grid1_map(2,1,i) .lt. se_grid2_map(1,1,mype))) then
                 intersect = .false.
              else
                 if (     (se_grid1_map(1,2,i) .gt. se_grid2_map(2,2,mype))
     &               .or. (se_grid1_map(2,2,i) .lt. se_grid2_map(1,2,mype)))
     &                then
                    intersect = .false.
                 end if
              end if

              if (intersect) then
                 se_reconfig_grid_recv_ind(1,1,i) = max(se_grid1_map(1,1,i), 
     &                      se_grid2_map(1,1,mype)) - se_grid2_map(1,1,mype) + 1
                 se_reconfig_grid_recv_ind(2,1,i) = min(se_grid1_map(2,1,i), 
     &                      se_grid2_map(2,1,mype)) - se_grid2_map(1,1,mype) + 1
                 se_reconfig_grid_recv_ind(1,2,i) = max(se_grid1_map(1,2,i),
     &                      se_grid2_map(1,2,mype)) - se_grid2_map(1,2,mype) + 1
                 se_reconfig_grid_recv_ind(2,2,i) = min(se_grid1_map(2,2,i),
     &                      se_grid2_map(2,2,mype)) - se_grid2_map(1,2,mype) + 1
                 se_reconfig_grid_recv(i) = i
              end if
           end do
        end if

        call se_reconfig_data_copy3 (npcol1, nprow1, data1, 
     &                               npcol2, nprow2, data2)

        deallocate (se_grid1_map)
        deallocate (se_grid2_map)

        return
        end subroutine se_grid_to_grid3

C -----------------------------------------------------------------------------
        subroutine se_grid_to_grid4 (nprow1, npcol1, map1, data1,
     &                               nprow2, npcol2, map2, data2)

        use se_reconfig_grid_info_ext
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        integer, intent(in) :: map1(:,:,:), map2(:,:,:)
        real, intent(inout) :: data1(:,:,:,:)
        real, intent(inout) :: data2(:,:,:,:)
        integer, intent(in) :: nprow1, npcol1, nprow2, npcol2

        integer :: mype
        integer :: tpe, mpe, dpe, error, block, i, j, allocate_status
        integer :: nprow1npcol1, nprow2npcol2

        logical, save :: firstime
        data firstime / .true. /

        logical :: intersect

        nprow1npcol1 = nprow1 * npcol1
        nprow2npcol2 = nprow2 * npcol2
c       mype = se_my_pe
        mype = se_myworker_pe

C -- allocate data
        allocate (se_grid1_map(2,2,0:nprow1npcol1-1),stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error '
           stop
        end if

        allocate (se_grid2_map(2,2,0:nprow2npcol2-1),stat=allocate_status)
        if (allocate_status .ne. 0) then
           print *, ' Allocation error '
           stop
        end if

        se_grid1_map = map1
        se_grid2_map = map2

        if (firstime) then
           firstime = .false.
C -- allocate data
           allocate (se_reconfig_grid_send_ind(2, 4, 0:nprow2npcol2-1),
     &               stat=allocate_status)
           if (allocate_status .ne. 0) then
              print *, ' Subroutine se_grid_to_grid4: ',
     &                 ' allocation erorr in se_reconfig_grid_send_ind'
              stop
           end if

           allocate (se_reconfig_grid_recv_ind(2, 4, 0:nprow1npcol1-1),
     &               stat=allocate_status)
           if (allocate_status .ne. 0) then
              print *, ' Subroutine se_grid_to_grid4: ',
     &                 ' allocation erorr in se_reconfig_grid_recv_ind'
              stop
           end if

           allocate (se_reconfig_grid_send(0:nprow2npcol2-1),
     &               stat=allocate_status)
           if (allocate_status .ne. 0) then
              print *, ' Subroutine SE_SUBGD_INDEX: ',
     &                 'allocation erorr in se_reconfig_grid_send'
              stop
           end if

           allocate (se_reconfig_grid_recv(0:nprow1npcol1-1),
     &               stat=allocate_status)
           if (allocate_status .ne. 0) then
              print *, ' Subroutine SE_SUBGD_INDEX: ',
     &                 'allocation erorr in se_reconfig_grid_recv'
              stop
           end if

           se_reconfig_grid_send_ind_ptr => se_reconfig_grid_send_ind
           se_reconfig_grid_recv_ind_ptr => se_reconfig_grid_recv_ind
           se_reconfig_grid_send_ptr => se_reconfig_grid_send
           se_reconfig_grid_recv_ptr => se_reconfig_grid_recv
        end if

        se_reconfig_grid_send = -1
        if (mype .lt. nprow1npcol1) then
           do i = 0, nprow2npcol2-1
              intersect = .true.

              if (     (se_grid1_map(1,1,mype) .gt. se_grid2_map(2,1,i))
     &            .or. (se_grid1_map(2,1,mype) .lt. se_grid2_map(1,1,i))) then
                 intersect = .false.
              else
                  if (     (se_grid1_map(1,2,mype) .gt. se_grid2_map(2,2,i))
     &                .or. (se_grid1_map(2,2,mype) .lt. se_grid2_map(1,2,i))) 
     &                then
                     intersect = .false.
                  end if
              end if

              if (intersect) then
                 se_reconfig_grid_send_ind(1,1,i) = max(se_grid1_map(1,1,mype),
     &                         se_grid2_map(1,1,i)) - se_grid1_map(1,1,mype) + 1
                 se_reconfig_grid_send_ind(2,1,i) = min(se_grid1_map(2,1,mype),
     &                         se_grid2_map(2,1,i)) - se_grid1_map(1,1,mype) + 1
                 se_reconfig_grid_send_ind(1,2,i) = max(se_grid1_map(1,2,mype),
     &                         se_grid2_map(1,2,i)) - se_grid1_map(1,2,mype) + 1
                 se_reconfig_grid_send_ind(2,2,i) = min(se_grid1_map(2,2,mype),
     &                         se_grid2_map(2,2,i)) - se_grid1_map(1,2,mype) + 1
                 se_reconfig_grid_send(i) = i
              else
                 se_reconfig_grid_send(i) = -1
              end if
           end do
         end if

C -- determine data is going to receive from which PE, and corresponding local
C    index

        se_reconfig_grid_recv = -1

        if (mype .lt. nprow2npcol2) then
           do i = 0, nprow1npcol1-1
              intersect = .true.

              if (     (se_grid1_map(1,1,i) .gt. se_grid2_map(2,1,mype))
     &            .or. (se_grid1_map(2,1,i) .lt. se_grid2_map(1,1,mype))) then
                 intersect = .false.
              else
                 if (     (se_grid1_map(1,2,i) .gt. se_grid2_map(2,2,mype))
     &               .or. (se_grid1_map(2,2,i) .lt. se_grid2_map(1,2,mype)))
     &               then
                    intersect = .false.
                 end if
              end if

              if (intersect) then
                 se_reconfig_grid_recv_ind(1,1,i) = max(se_grid1_map(1,1,i),
     &                      se_grid2_map(1,1,mype)) - se_grid2_map(1,1,mype) + 1
                 se_reconfig_grid_recv_ind(2,1,i) = min(se_grid1_map(2,1,i),
     &                      se_grid2_map(2,1,mype)) - se_grid2_map(1,1,mype) + 1
                 se_reconfig_grid_recv_ind(1,2,i) = max(se_grid1_map(1,2,i),
     &                      se_grid2_map(1,2,mype)) - se_grid2_map(1,2,mype) + 1
                 se_reconfig_grid_recv_ind(2,2,i) = min(se_grid1_map(2,2,i),
     &                      se_grid2_map(2,2,mype)) - se_grid2_map(1,2,mype) + 1
                 se_reconfig_grid_recv(i) = i
              end if
           end do
        end if

        call se_reconfig_data_copy4 (npcol1, nprow1, data1,
     &                               npcol2, nprow2, data2)

        deallocate (se_grid1_map)
        deallocate (se_grid2_map)

        return
        end subroutine se_grid_to_grid4

C --------------------------------------------------------------------------
        subroutine se_reconfig_data_copy2 (nprow1, npcol1, data1, 
     &                                     nprow2, npcol2, data2)

        use se_reconfig_grid_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        integer, intent(in) :: nprow1, npcol1, nprow2, npcol2
        real, intent(in)  :: data1(:, :)
        real, intent(out) :: data2(:, :)

        integer :: dir, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do dir = 0, max(nprow1*npcol1-1, nprow2*npcol2-1)

           if (dir .lt. nprow2*npcol2) then
              sdir = dir

c             if ((se_reconfig_grid_send(sdir) .eq. se_my_pe) .and.
              if ((se_reconfig_grid_send(sdir) .eq. se_myworker_pe) .and.
     &            (dir .lt. nprow1*npcol1)) then

                 data2( se_reconfig_grid_recv_ind(1,1,sdir)
     &                 :se_reconfig_grid_recv_ind(2,1,sdir),
     &                  se_reconfig_grid_recv_ind(1,2,sdir)
     &                 :se_reconfig_grid_recv_ind(2,2,sdir))
     &           =
     &           data1( se_reconfig_grid_send_ind(1,1,sdir)
     &                 :se_reconfig_grid_send_ind(2,1,sdir),
     &                  se_reconfig_grid_send_ind(1,2,sdir)
     &                 :se_reconfig_grid_send_ind(2,2,sdir))

              else

                 if (se_reconfig_grid_send(sdir) .ge. 0) then
c                   tag = (sdir + 1) * 10000 + se_my_pe
                    tag = (sdir + 1) * 10000 + se_myworker_pe
                    call se_data_send (data1, se_reconfig_grid_send_ind_ptr,
     &                                 se_reconfig_grid_send_ptr, sdir, tag, 
     &                                 request)
                 end if
              end if
           end if

           if (dir .lt. nprow1*npcol1) then
              rdir = dir

              if ((se_reconfig_grid_recv(rdir) .ge. 0) .and.
     &            (se_reconfig_grid_recv(rdir) .ne. se_myworker_pe)) then
c    &            (se_reconfig_grid_recv(rdir) .ne. se_my_pe)) then
                 tag = (se_myworker_pe + 1) * 10000 + rdir
c                tag = (se_my_pe + 1) * 10000 + rdir
                 call se_data_recv (data2, se_reconfig_grid_recv_ind_ptr,
     &                              se_reconfig_grid_recv_ptr, rdir, tag)
              end if
           end if

c          if ((dir .lt. nprow2*npcol2) .and.
c    &         (se_reconfig_grid_send(sdir) .ge. 0)) then
c             call mpi_wait (request, status, error)
c          end if

        end do

        return
        end subroutine se_reconfig_data_copy2

C --------------------------------------------------------------------------
        subroutine se_reconfig_data_copy3 (nprow1, npcol1, data1, 
     &                                     nprow2, npcol2, data2)

        use se_reconfig_grid_info_ext
        use se_pe_info_ext
        use se_domain_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        integer, intent(in) :: nprow1, npcol1, nprow2, npcol2
        real, intent(in)  :: data1(:, :, :)
        real, intent(out) :: data2(:, :, :)

        integer :: i, dir, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, nprow2*npcol2-1
           se_reconfig_grid_send_ind(1,3,i) = 1
           se_reconfig_grid_send_ind(2,3,i) = size(data1,3)
        end do

        do i = 0, nprow1*npcol1-1
           se_reconfig_grid_recv_ind(1,3,i) = 1
           se_reconfig_grid_recv_ind(2,3,i) = size(data1,3)
        end do

        do dir = 0, max(nprow1*npcol1-1, nprow2*npcol2-1)

           if (dir .lt. nprow2*npcol2) then
              sdir = dir

c             if ((se_reconfig_grid_send(sdir) .eq. se_my_pe) .and.
              if ((se_reconfig_grid_send(sdir) .eq. se_myworker_pe) .and.
     &            (dir .lt. nprow1*npcol1)) then

                 data2( se_reconfig_grid_recv_ind(1,1,sdir)
     &                 :se_reconfig_grid_recv_ind(2,1,sdir),
     &                  se_reconfig_grid_recv_ind(1,2,sdir)
     &                 :se_reconfig_grid_recv_ind(2,2,sdir),
     &                  se_reconfig_grid_recv_ind(1,3,sdir)
     &                 :se_reconfig_grid_recv_ind(2,3,sdir))
     &           =
     &           data1( se_reconfig_grid_send_ind(1,1,sdir)
     &                 :se_reconfig_grid_send_ind(2,1,sdir),
     &                  se_reconfig_grid_send_ind(1,2,sdir)
     &                 :se_reconfig_grid_send_ind(2,2,sdir),
     &                  se_reconfig_grid_send_ind(1,3,sdir)
     &                 :se_reconfig_grid_send_ind(2,3,sdir))

              else

                 if (se_reconfig_grid_send(sdir) .ge. 0) then
c                   tag = (sdir + 1) * 10000 + se_my_pe
                    tag = (sdir + 1) * 10000 + se_myworker_pe

                    call se_data_send (data1, se_reconfig_grid_send_ind_ptr,
     &                                 se_reconfig_grid_send_ptr, sdir, tag, 
     &                                 request)
                 end if

              end if
           end if

           if (dir .lt. nprow1*npcol1) then
              rdir = dir
              if ((se_reconfig_grid_recv(rdir) .ge. 0) .and.
     &            (se_reconfig_grid_recv(rdir) .ne. se_myworker_pe)) then
c    &            (se_reconfig_grid_recv(rdir) .ne. se_my_pe)) then
c                tag = (se_my_pe + 1) * 10000 + rdir
                 tag = (se_myworker_pe + 1) * 10000 + rdir

                 call se_data_recv (data2, se_reconfig_grid_recv_ind_ptr,
     &                              se_reconfig_grid_recv_ptr, rdir, tag)
              end if
           end if

c          if ((dir .lt. nprow2*npcol2) .and. 
c    &         (se_reconfig_grid_send(sdir) .ge. 0)) then
c             call mpi_wait (request, status, error)
c          end if

        end do

        return
        end subroutine se_reconfig_data_copy3

C --------------------------------------------------------------------------
        subroutine se_reconfig_data_copy4 (nprow1, npcol1, data1, 
     &                                     nprow2, npcol2, data2)

        use se_reconfig_grid_info_ext
        use se_pe_info_ext
        use se_domain_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        integer, intent(in) :: nprow1, npcol1, nprow2, npcol2
        real, intent(in)  :: data1(:, :, :, :)
        real, intent(out) :: data2(:, :, :, :)

        integer :: i, dir, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, nprow2*npcol2-1
           se_reconfig_grid_send_ind(1,3,i) = 1
           se_reconfig_grid_send_ind(2,3,i) = size(data1,3)
           se_reconfig_grid_send_ind(1,4,i) = 1
           se_reconfig_grid_send_ind(2,4,i) = size(data1,4)
        end do

        do i = 0, nprow1*npcol1-1
           se_reconfig_grid_recv_ind(1,3,i) = 1
           se_reconfig_grid_recv_ind(2,3,i) = size(data1,3)
           se_reconfig_grid_recv_ind(1,4,i) = 1
           se_reconfig_grid_recv_ind(2,4,i) = size(data1,4)
        end do

        do dir = 0, max(nprow1*npcol1-1, nprow2*npcol2-1)

           if (dir .lt. nprow2*npcol2) then
              sdir = dir

c             if ((se_reconfig_grid_send(sdir) .eq. se_my_pe) .and.
              if ((se_reconfig_grid_send(sdir) .eq. se_myworker_pe) .and.
     &            (dir .lt. nprow1*npcol1)) then

                 data2( se_reconfig_grid_recv_ind(1,1,sdir)
     &                 :se_reconfig_grid_recv_ind(2,1,sdir),
     &                  se_reconfig_grid_recv_ind(1,2,sdir)
     &                 :se_reconfig_grid_recv_ind(2,2,sdir),
     &                  se_reconfig_grid_recv_ind(1,3,sdir)
     &                 :se_reconfig_grid_recv_ind(2,3,sdir),
     &                  se_reconfig_grid_recv_ind(1,4,sdir)
     &                 :se_reconfig_grid_recv_ind(2,4,sdir))
     &           =
     &           data1( se_reconfig_grid_send_ind(1,1,sdir)
     &                 :se_reconfig_grid_send_ind(2,1,sdir),
     &                  se_reconfig_grid_send_ind(1,2,sdir)
     &                 :se_reconfig_grid_send_ind(2,2,sdir),
     &                  se_reconfig_grid_send_ind(1,3,sdir)
     &                 :se_reconfig_grid_send_ind(2,3,sdir),
     &                  se_reconfig_grid_send_ind(1,4,sdir)
     &                 :se_reconfig_grid_send_ind(2,4,sdir))

              else

                 if (se_reconfig_grid_send(sdir) .ge. 0) then
c                   tag = (sdir + 1) * 10000 + se_my_pe
                    tag = (sdir + 1) * 10000 + se_myworker_pe

                    call se_data_send (data1, se_reconfig_grid_send_ind_ptr,
     &                                 se_reconfig_grid_send_ptr, sdir, tag, 
     &                                 request)
                 end if

              end if
           end if

           if (dir .lt. nprow1*npcol1) then
              rdir = dir

              if ((se_reconfig_grid_recv(rdir) .ge. 0) .and.
     &            (se_reconfig_grid_recv(rdir) .ne. se_myworker_pe)) then
c    &            (se_reconfig_grid_recv(rdir) .ne. se_my_pe)) then
c                tag = (se_my_pe + 1) * 10000 + rdir
                 tag = (se_myworker_pe + 1) * 10000 + rdir

                 call se_data_recv (data2, se_reconfig_grid_recv_ind_ptr,
     &                              se_reconfig_grid_recv_ptr, rdir, tag)
              end if
           end if

c          if ((dir .lt. nprow2*npcol2) .and.
c    &         (se_reconfig_grid_send(sdir) .ge. 0)) then
c             call mpi_wait (request, status, error)
c          end if

        end do

        return
        end subroutine se_reconfig_data_copy4

        end module se_reconfig_grid_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/checkmem.f,v 1.3 2011/10/21 16:10:17 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CHECKMEM( MSTATUS, AVAR, CALLER )
 
C-----------------------------------------------------------------------
 
C  Description:
C       Reports an error and exits if memory status flag is non-zero.
 
C  Preconditions:
 
C  Subroutines and Functions Called:
 
C  Revision History:
C       Adapted 10/98 by M Houyoux
C       02/11: S.Roselle-Removed deprecated TRIMLEN

C-----------------------------------------------------------------------
C Modified from:
 
C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling
C             System
C File: @(#)$Id: checkmem.f,v 1.3 2011/10/21 16:10:17 yoj Exp $
C COPYRIGHT (C) 1999, MCNC--North Carolina Supercomputing Center
C All Rights Reserved
C See file COPYRIGHT for conditions of use.
C Environmental Programs Group
C MCNC--North Carolina Supercomputing Center
C P.O. Box 12889
C Research Triangle Park, NC  27709-2889
C env_progs@mcnc.org
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/checkmem.f,v $
C Last updated: $Date: 2011/10/21 16:10:17 $ 
 
C-----------------------------------------------------------------------
#ifdef mpas
      use utilio_defn
#endif
 
      IMPLICIT NONE

C Arguments:

      INTEGER           MSTATUS  ! ALLOCATE function exit status
      CHARACTER( * ) :: AVAR     ! Variable name of ALLOCATE statement
      CHARACTER( * ) :: CALLER   ! Name of calling procedure

C External Functions:

C Local Variables;
      INTEGER       L1
      INTEGER       L2
      CHARACTER( 256 ) :: MESG = ' '

C-----------------------------------------------------------------------

C Abort if memory status is non-zero

      IF ( MSTATUS .GT. 0 ) THEN           
         L1 = LEN_TRIM( AVAR )
         L2 = LEN_TRIM( CALLER )
         MESG = 'Failure allocating memory for "' // AVAR( 1:L1 )
     &        // '" variable'
         CALL M3EXIT( CALLER( 1:L2 ), 0, 0, MESG, 2 )
      END IF

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency         !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or     !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software       !
!  that is used with the CMAQ system but distributed under the GNU      !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                             !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module Cloud_Optics

! Purpose:
! Calculate the optical properties of hydrometeors per wavelength and layer.
! Five types are treated liquid cloud droplet, ice particles, snowflakes, graupel
! and rain droplet. The last three are lumped into one catagory called cloud 
! aggregates
! History:
! 09/15/14: B.Hutzell: Initial version created
! 02/01/19: D.Wong:    Cleaned up USE module clauses

         Implicit None

         real, parameter   :: cldmin   = 1.e-20      ! minimum value for cloud quantities
         
         real, allocatable :: cloud_liquid_ext ( :,: )   ! resolved cloud liquid droplet extinction, 1/m
         real, allocatable :: cloud_liquid_scat( :,: )   ! resolved cloud liquid droplet scattering, 1/m
         real, allocatable :: cloud_liquid_ssa ( :,: )   ! resolved cloud liquid droplet co-albedo
         real, allocatable :: cloud_liquid_asy ( :,: )   ! resolved cloud liquid droplet asymmetery factor

         real, allocatable :: cloud_aggreg_ext ( :,: )   ! resolved cloud aggregates extinction, 1/m
         real, allocatable :: cloud_aggreg_scat( :,: )   ! resolved cloud aggregates scattering, 1/m
         real, allocatable :: cloud_aggreg_ssa ( :,: )   ! resolved cloud aggregates co-albedo
         real, allocatable :: cloud_aggreg_asy ( :,: )   ! resolved cloud aggregates asymmetery factor

         real, allocatable :: cloud_ice_ext  ( :,: )    ! resolved cloud ice particle extinction, 1/m
         real, allocatable :: cloud_ice_scat ( :,: )    ! resolved cloud ice particle scattering, 1/m
         real, allocatable :: cloud_ice_ssa  ( :,: )    ! resolved cloud ice particle single scattering albedo
         real, allocatable :: cloud_ice_asy  ( :,: )    ! resolved cloud ice particle asymmetery factor
         real, allocatable :: cloud_ice_del  ( :,: )    ! resolved cloud ice delta forward tranmission function

         real, allocatable :: total_tau_cld( : )         ! total optical depth of resolved cloud 
#ifdef phot_debug         
         real, allocatable :: ave_asymm_cld( : )         ! column average of resolved cloud asymmetry factor
         real, allocatable :: ave_ssa_cld  ( : )         ! column average of resolved cloud single scattering albedo
#endif
 
         real, allocatable :: cloud_ext_coeff( :,: )   ! total cloud extinction coefficient, 1/m
         real, allocatable :: cloud_scat_coef( :,: )   ! total cloud scattering coefficent, 1/m
         real, allocatable :: cloud_asym_fact( :,: )   ! average cloud asymmetery factor


         real, allocatable :: total_tau_urcld( : ) ! total optical depth of unresolved cloud 
         real, allocatable :: ave_asymm_urcld( : ) ! column average of unresolved cloud asymmetry factor
         real, allocatable :: ave_ssa_urcld  ( : ) ! column average of unresolved cloud single scattering albedo

         real, allocatable :: rel( : )             ! liquid droplet effective radius, um
         real, allocatable :: dge( : )             ! generalized ice particle size, um
         real              :: max_dge              ! maximum allowed value for dge, um
         real              :: max_dge_squ          ! maximum allowed value squared for dge , um2
         real              :: min_dge              ! minimum allowed value for dge, um
        
         logical, allocatable :: cloud_layering ( : ) ! flag to use optical depth correction for cloud layering

         
         integer            :: row_cloud 
         integer            :: col_cloud
         
         public             :: init_cloud_optics,  general_effective_size, get_ice_optics,
     &                         get_droplet_optics, relcalc, get_aggregate_optics

         real, parameter, private :: low      = 1.e-06      ! epsilon
         real, parameter, private :: high     = 1.0e0 - low ! 1.0 - epsilon
         real, parameter, private :: cldtiny  = high*cldmin ! minimum value for cloud scattering
         
! Abscissas of Gauss-Laguerre Integration
! for 32 point quadrature
         real( 8 ), parameter, private :: xk(32) = 
     &    (/ 0.0444893658333D+0, 0.23452610952D+0,  
     &       0.576884629302D+0,  1.07244875382D+0, 1.72240877644D+0, 2.52833670643D+0, 
     &       3.49221327285D+0,   4.61645677223D+0, 5.90395848335D+0, 7.3581268086D+0,   
     &       8.98294126732D+0,   10.783012089D+0,  12.763745476D+0,  14.9309117981D+0,    
     &       17.2932661372D+0,   19.8536236493D+0, 22.6357789624D+0, 25.6201482024D+0,  
     &       28.8739336869D+0,   32.3333294017D+0, 36.1132042245D+0, 40.1337377056D+0,  
     &       44.5224085362D+0,   49.2086605665D+0, 54.3501813324D+0, 59.8791192845D+0,  
     &       65.9833617041D+0,   72.6842683222D+0, 80.1883747906D+0, 88.735192639D+0,   
     &       98.8295523184D+0,   111.751398227D+0 /)

! total weights (weight*exp(xk)) of Modified Gauss-Laguerre Integration
         real( 8 ), parameter, private :: totalw(32) = 
     &    (/ 0.114187105768D+0, 0.266065216898D+0, 
     &       0.418793137325D+0, 0.572532846497D+0, 0.727648788453D+0, 0.884536718946D+0, 
     &       1.04361887597D+0,  1.20534920595D+0,  1.37022171969D+0,  1.53877595906D+0,     
     &       1.71164594592D+0,  1.8895649683D+0,   2.07318851235D+0,  2.26590144444D+0,      
     &       2.46997418988D+0,  2.64296709494D+0,  2.76464437462D+0,  3.22890542981D+0,     
     &       2.92019361963D+0,  4.3928479809D+0,   4.27908673189D+0,  5.20480398519D+0,      
     &       5.11436212961D+0,  4.15561492173D+0,  6.19851060567D+0,  5.34795780128D+0,     
     &       6.28339212457D+0,  6.89198340969D+0,  7.92091094244D+0,  9.20440555803D+0,     
     &       11.1637432904D+0,  15.3902417688D+0 /)
     
         real( 8 ), private          :: newtotalw(32)
! Abscissas for 16 point quadrature
         real( 8 ), parameter, private :: gauss_laguerre_node( 16 ) =   
     &     (/ 0.8764941047892792D-1, 0.4626963289150808D+0, 1.141057774831227D+0,    
     &        2.129283645098381D+0,  3.437086633893207D+0, 5.078018614549768D+0,    
     &        7.070338535048235D+0,  9.438314336391938D+0, 12.21422336886616D+0,
     &        15.44152736878162D+0,  19.18015685675314D+0, 23.51590569399191D+0, 
     &        28.57872974288214D+0,  34.58339870228663D+0, 41.94045264768833D+0,
     &        51.70116033954332D+0 /)      
     
! total weights for 16 points     
         real( 8 ), parameter, private :: gauss_laguerre_weight( 16 ) = 
     &     (/ 0.2250363148642442D+0, 0.5258360527623427D+0, 0.8319613916870883D+0,
     &        1.146099240963750D+0,  1.471751316966809D+0,  1.813134687381348D+0,
     &        2.175517519694609D+0,  2.565762750165028D+0,  2.993215086371375D+0,
     &        3.471234483102089D+0,  4.020044086444668D+0,  4.672516607732857D+0,
     &        5.487420657986129D+0,  6.585361233289269D+0,  8.276357984364143D+0,
     &        11.82427755165841D+0 /)
     
         real( 8 ), private            :: gauss_laguerre_total( 16 )
     
         real( 8 ), parameter :: cloud_largest      = 9.0d+307 
         real( 8 ), parameter :: cloud_smallest     = 9.0d-307
         real( 8 ), parameter :: cloud_log_largest  =  709.090848126508d0
         real( 8 ), parameter :: cloud_log_smallest = -709.090848126508d0
         
         contains         
      
!-----------------------------------------------------------------------
         subroutine init_cloud_optics()

         use VGRD_DEFN, ONLY : NLAYS
         USE UTILIO_DEFN
         USE CSQY_DATA

         Implicit None

         integer          :: allocstat           ! memory allocation status
         integer          :: i

         Character( 132 ) :: xmsg
         Character(  32 ) :: pname = 'init_cloud_optics'
         Logical, Save    :: initialized = .false.
                
         If ( initialized ) Return
         
         initialized = .true.
         
         allocate( cloud_layering( nlays ),
     &             rel           ( nlays ),
     &             dge           ( nlays ), stat = allocstat )
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating cloud_layering, rel, dge'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If

         max_dge     = maxi_diameter_ice-low
         max_dge_squ = max_dge*max_dge
         min_dge     = mini_diameter_ice+low
         
         cloud_layering = .true.
         
         allocate( cloud_liquid_ext ( nlays,nwl_ref ), 
     &             cloud_liquid_scat( nlays,nwl_ref ),
     &             cloud_liquid_ssa ( nlays,nwl_ref ),
     &             cloud_liquid_asy ( nlays,nwl_ref ), stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating cloud_liquid_ext, cloud_liquid_scat, cloud_liquid_ssa, cloud_liquid_asy'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If

         cloud_liquid_ext  = 0.0
         cloud_liquid_scat = 0.0
         cloud_liquid_ssa  = 1.0
         cloud_liquid_asy  = 0.0          

         allocate( cloud_ice_ext ( nlays,nwl_ref ), 
     &             cloud_ice_scat( nlays,nwl_ref ),
     &             cloud_ice_ssa ( nlays,nwl_ref ),
     &             cloud_ice_del ( nlays,nwl_ref ),
     &             cloud_ice_asy ( nlays,nwl_ref ), stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating cloud_ice_ext, cloud_ice_ext,cloud_ice_ssa, cloud_ice_del, ice_asy_rcld'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If
         
         cloud_ice_ext  = 0.0
         cloud_ice_scat = 0.0
         cloud_ice_ssa  = 1.0
         cloud_ice_asy  = 0.0

         allocate( cloud_aggreg_ext ( nlays,nwl_ref ), 
     &             cloud_aggreg_scat( nlays,nwl_ref ),
     &             cloud_aggreg_ssa ( nlays,nwl_ref ),
     &             cloud_aggreg_asy ( nlays,nwl_ref ), stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating cloud_aggreg_ext, cloud_aggreg_ext,cloud_aggreg_ssa,'
     &         // 'cloud_aggreg_del, cloud_aggreg_asy'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If

         cloud_aggreg_ext  = cldmin
         cloud_aggreg_scat = cldtiny
         cloud_aggreg_ssa  = 1.0
         cloud_aggreg_asy  = 0.0

         allocate( cloud_ext_coeff( nlays,nwl_ref ), 
     &             cloud_scat_coef( nlays,nwl_ref ),
     &             cloud_asym_fact( nlays,nwl_ref ), stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating cloud_ext_coeff, cloud_scat_coef, cloud_asy_fact'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If
         
         allocate( total_tau_cld( nwl_ref ), stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating total_tau'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If

#ifdef phot_debug
         allocate( ave_asymm_cld( nwl_ref ),
     &             ave_ssa_cld( nwl_ref ),   stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating ave_asymm, ave_ssa'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If
#endif         
         
         do i = 1, 32
            newtotalw( i ) = xk( i ) * xk( i ) * totalw( i )
         end do

         do i = 1, 16
            gauss_laguerre_total( i ) = gauss_laguerre_node( i )
     &                                * gauss_laguerre_node( i )
     &                                * gauss_laguerre_weight( i )
         end do

         end subroutine init_cloud_optics

!-----------------------------------------------------------------------
         subroutine general_effective_size( levels, t )
! Purpose: calculate the generalized effective size
!         of ice particle based on temperature. The routine
!         was adapted from WRF version 3.5 implementation of 
!         RRTMG
! returns the effect raduis, re,  of cloud ice particles, at
! temperature, t

            Implicit None

! Arguments:
            integer, intent(in)    :: levels  ! layers of process
            real,    intent(in)    :: t(:)    ! air temperaure, K
    
! Local:
            real corr
            integer i
            integer k
            integer index

            real, save :: retab(95)  ! look up table effective size, um, of ice particle versus 
                                    ! temperature. Values of re(T) are tabulated over temperature 
                                    ! interval 180 K -- 274 K; hexagonal columns assumed:
!
! The table comes from CAM version 4.0 and does not matched
! citation reference, equation (4) in 
! Kristjässon, J. E., J. M. Edwards, and D. L. Mitchell (1999),
! A new parameterization scheme for the optical properties of 
! ice crystals for use in general circulation models of the 
! atmosphere, Phys. Chem. Earth, B24, 231–236. 
! or 1030.7*EXP(0.05522*(Temp-279.5))
! Array's first value corresponds to Temp equals 186.1 K
! last temp correspond to Temp equal 253.8 K.

            data retab /
     &          5.92779, 6.26422, 6.61973, 6.99539, 7.39234,           ! 5
     &          7.81177, 8.25496, 8.72323, 9.21800, 9.74075, 10.2930,  ! 11
     &          10.8765, 11.4929, 12.1440, 12.8317, 13.5581, 14.2319,  ! 17
     &          15.0351, 15.8799, 16.7674, 17.6986, 18.6744, 19.6955,  ! 23
     &          20.7623, 21.8757, 23.0364, 24.2452, 25.5034, 26.8125,  ! 29
     &          27.7895, 28.6450, 29.4167, 30.1088, 30.7306, 31.2943,  ! 35
     &          31.8151, 32.3077, 32.7870, 33.2657, 33.7540, 34.2601,  ! 41
     &          34.7892, 35.3442, 35.9255, 36.5316, 37.1602, 37.8078,  ! 47
     &          38.4720, 39.1508, 39.8442, 40.5552, 41.2912, 42.0635,  ! 53
     &          42.8876, 43.7863, 44.7853, 45.9170, 47.2165, 48.7221,  ! 59
     &          50.4710, 52.4980, 54.8315, 57.4898, 60.4785, 63.7898,  ! 65
     &          65.5604, 71.2885, 75.4113, 79.7368, 84.2351, 88.8833,  ! 71
     &          93.6658, 98.5739, 103.603, 108.752, 114.025, 119.424,  ! 77
     &          124.954, 130.630, 136.457, 142.446, 148.608, 154.956,  ! 83
     &          161.503, 168.262, 175.248, 182.473, 189.952, 197.699,  ! 89
     &          205.728, 214.055, 222.694, 231.661, 240.971, 250.639/  ! 95

            do k = 1, levels
               If( t(k) .le. 179.0 )Then
                  index = 1
               Else If( t(k) .ge. 273.0 )Then
                  index = 94
               Else
                  index = max( int(t(k)-179.0), 1 )
               End If
               corr = t(k) - aint( t(k) )      ! temperatures of retab values differ by one degree K
               dge(k) = retab(index) + (retab(index+1)-retab(index))*corr

! Convert from effective radius to generalized effective size (*1.0315; Fu et al. 1996)
! but limit to upper bound in Fu et al. (1996) ice parameterization
               dge(k) = max( min( max_dge, 1.0315*dge(k) ), min_dge)
            end do

         return

         end subroutine general_effective_size

!-----------------------------------------------------------------------
         subroutine get_ice_optics( levels, t, iwc )
! Purpose calculate optical properties for ice particles
! Uses Fu (1996) parameterization for ice particle generalized effective size, dge, from 5 to 140 microns, 
! *** NOTE: Fu parameterization requires particle size in generalized effective size.
! and uses Ebert and Curry (1992) parameteriztion size, dge, >= 140 microns.
! *** NOTE: Transition between two methods has not been smoothed. 
! Algorithm adapted Rapid Radiative Model Global (RRTMG) version 3.8 and Weather Research Forecasting model
! (WRF) version 3.5

            USE UTILIO_DEFN         ! IO functions and parameters
            USE CSQY_DATA           ! number and value of wavelengths

            IMPLICIT NONE
! arguments:
            integer, intent( inout ) :: levels     ! layers to process
            real,    intent( inout ) :: t(:)       ! air temperaure, K
            real,    intent( in    ) :: iwc( : )   ! cloud ice water content, g/m3

! ice water coefficients (Ebert and Curry,1992, JGR, 97, 3831-3836)     
            real, save :: abari(4) = (/ 3.448e-03, 3.448e-03,3.448e-03,3.4480e-03/)
            real, save :: bbari(4) = (/ 2.431e+00, 2.431e+00,2.431e+00,2.4310e+00/)
            real, save :: cbari(4) = (/ 1.000e-05, 1.10e-04 ,1.861e-02,4.6658e-01/)
            real, save :: dbari(4) = (/ 0.000e+00, 1.405e-05,8.328e-04,2.0500e-05/)
            real, save :: ebari(4) = (/ 7.661e-01, 0.773e+00,0.794e+00,0.9595e+00/)
            real, save :: fbari(4) = (/ 5.851e-04, 5.665e-04,7.267e-04,1.0760e-04/)

! Local:
            real    factor
            real    fint
            real    forwice ! forward sccatering parameter
            integer iwl     ! loop counter
            integer layer   ! loop counter
            integer index
           
            character( 132 )      :: XMSG
            character( 16 ), save :: pname = 'GET_ICE_OPTICS'
           
            logical               :: error_flag

                 
            cloud_ice_ext ( 1:levels, 1:nwl_ref ) = cldmin
            cloud_ice_scat( 1:levels, 1:nwl_ref ) = cldtiny
            cloud_ice_ssa ( 1:levels, 1:nwl_ref ) = high
            cloud_ice_asy ( 1:levels, 1:nwl_ref ) = 0.0
            dge           ( 1:levels )            = 0.0

!           forall( layer = 1:levels )
!              dge( layer ) = 0.0
!              forall( iwl = 1:nwl_ref ) 
!                 cloud_liquid_ext ( layer, iwl ) = cldmin
!                 cloud_liquid_scat( layer, iwl ) = cldtiny
!                 cloud_liquid_ssa ( layer, iwl ) = high
!                 cloud_liquid_asy ( layer, iwl ) = 0.0
!              end forall 
!           end forall
              
            if( maxval( iwc ) .le. cldmin )return

            call general_effective_size( levels, t )

! Calculation of optical propeties due to ice particle
! Note that this loop structure may not be the most efficientbecuase the 
! inner loop use the farther right array index. The code does this because cycle 
! condition per layer may be more efficient than iterating over wavelength than 
! layer             

            error_flag = .false.
            
            do layer = 1, levels
               if( iwc( layer ) .le. cldmin )cycle
               do iwl = 1, nwl_ref
#ifdef phot_debug                                     
                  if (dge(layer) .lt. mini_diameter_ice)then
                      write(xmsg,*)Trim(pname)
     &                // ': ICE PARTICLE GENERALIZED EFFECTIVE SIZE OUT OF BOUNDS'
     &                // ' dge(', layer, ') = ', dge(layer),' um '
                      call m3mesg(xmsg)
                      error_flag = .true.
                  end if
#endif                   
                  if (dge(layer) .ge. mini_diameter_ice .and. dge(layer) .le. maxi_diameter_ice) then
                     factor = freq_diameter_ice * (dge(layer) - mini_diameter_ice)
                     index = int(factor)
                     fint = max( factor - float(index),0.0 )
                     index = min(  ndiameter_ice - 1, max( 1, index ) )
                     cloud_ice_ext(layer, iwl) =  ice_extinct(index,iwl) 
     &                                         +  fint * (ice_extinct(index+1,iwl) - ice_extinct(index,iwl))
                     cloud_ice_ssa(layer, iwl) =  1.0 - ice_coalbedo(index,iwl) 
     &                                         +  fint * (ice_coalbedo(index+1,iwl) - ice_coalbedo(index,iwl))
                     cloud_ice_asy(layer, iwl) =  ice_asymfact(index,iwl) 
     &                                         +  fint * (ice_asymfact(index+1,iwl) - ice_asymfact(index,iwl))
                     cloud_ice_del(layer, iwl) = ice_deltrans(index,iwl) 
     &                                         + fint * (ice_deltrans(index+1,iwl) - ice_deltrans(index,iwl))
#ifdef phot_debug                      
                     if (cloud_ice_del(layer, iwl) .gt. 1.0 .or. cloud_ice_del(layer, iwl) .lt. 0.0)then
                         write(xmsg, 99950)'ice particle delta function outside bounds and equals ', 
     &                   cloud_ice_del(layer, iwl),' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if 
#endif
                     if(cloud_ice_ssa(layer, iwl) .gt. low)then
                         forwice = cloud_ice_del(layer, iwl) + 0.5 / cloud_ice_ssa(layer, iwl)
                     else 
                         forwice = high
                     end if 

! See Fu (1996) p. 2067 
                     if (cloud_ice_asy(layer, iwl) .ge. 1.0) cloud_ice_asy(layer, iwl) = cloud_ice_asy(layer, iwl)-low
                     if (cloud_ice_asy(layer, iwl) .le. 0.0) cloud_ice_asy(layer, iwl) = cloud_ice_asy(layer, iwl)+low
                     if (forwice .gt. cloud_ice_asy(layer, iwl)) forwice = cloud_ice_asy(layer, iwl)

                  else if (dge(layer) .gt. maxi_diameter_ice) then
                     if (effwl_ref(iwl) .lt. 0.700) then
                        index = 1
                     else if (effwl_ref(iwl) .lt. 1.300) then
                        index = 2
                     else if (effwl_ref(iwl) .lt. 1.900) then
                        index = 3
                     else if (effwl_ref(iwl) .lt. 2.500) then
                        index = 4
                     else ! if (effwl_ref(iwl) .e. 3.500) then
                        index = 5
                     end if
                     cloud_ice_ext(layer, iwl) = abari(index) + bbari(index)/dge(layer) 
                     cloud_ice_ssa(layer, iwl) = 1.0 - cbari(index) - dbari(index)*dge(layer) 
                     cloud_ice_asy(layer, iwl) = ebari(index) + fbari(index)*dge(layer) 
                     if (cloud_ice_asy(layer, iwl) .ge. 1.0)cloud_ice_asy(layer, iwl) = 1.0-low
                     if (cloud_ice_asy(layer, iwl) .le. 0.0)cloud_ice_asy(layer, iwl) = cloud_ice_asy(layer, iwl)+low
                     forwice = cloud_ice_asy(layer, iwl)*cloud_ice_asy(layer, iwl)
                  end if

! adjust results for fraction of light in forward scattering peak from nonspheric particles
! see Appendix A in Fu (1996), equations A.2(a,b,c)
!!! temporary to check interpolation method
                  cloud_ice_ext(layer, iwl) = (1.0 - forwice*cloud_ice_ssa(layer, iwl)) 
     &                                      *  cloud_ice_ext(layer, iwl)
                  cloud_ice_ssa(layer, iwl) =  cloud_ice_ssa(layer, iwl)*(1.0 - forwice) 
     &                                      / (1.0 - forwice*cloud_ice_ssa(layer, iwl))
                  cloud_ice_asy(layer, iwl) = (cloud_ice_asy(layer, iwl) -  forwice)                 
     &                                      / (1.0 - forwice)
                  cloud_ice_del(layer, iwl) = forwice
! convert extinction coefficient to extinction per layer thickness
                  cloud_ice_ext(layer, iwl) = cloud_ice_ext(layer, iwl) * iwc(layer)
! calculate scattering per per layer thickness
                  cloud_ice_scat(layer, iwl) =  cloud_ice_ssa(layer, iwl) * cloud_ice_ext(layer, iwl)
#ifdef phot_debug                       
! Check to ensure all calculated quantities are within physical limits.
                  if (cloud_ice_ext(layer, iwl) .lt. 0.0)then
                     write(xmsg,99950)'ice particle extinction equals ', 
     &               cloud_ice_ext(layer, iwl), ' at layer = ',layer
                     error_flag = .true.
                  end if
                  if (cloud_ice_ssa(layer, iwl) .gt. high .or. cloud_ice_ssa(layer, iwl) .lt. low)then
                     write(xmsg, 99950)'ice particle SSA outside bounds and equals ', 
     &               cloud_ice_ssa(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
!                    error_flag = .true.
                  end if 
                  if (cloud_ice_asy(layer, iwl) .gt. 1.0 .or. cloud_ice_asy(layer, iwl) .lt. -1.0)then
                     write(xmsg, 99950)'ice particle asymmetery factor outside bounds and equals ', 
     &               cloud_ice_asy(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if 
                  if (cloud_ice_scat(layer, iwl) .gt. cloud_ice_ext(layer, iwl))then
                     write(xmsg, 99950)'ice particle scattering greater than extinction, SSA ', 
     &               cloud_ice_ssa(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if                   
#endif
               end do
            end do

#ifdef phot_debug                       
            if( error_flag )then
               write(xmsg,99951)'Encountered the above Errors at COLUMN = ', col_cloud,
     &         ' and ROW = ', row_cloud
               call m3exit(pname,0,0,'Encountered the above Errors', XSTAT1 )
            end if
#endif
             
99950    format(a,es12.4,a,i3)
99951    format(a,i5,a,i5)
99962    format(a,1x,10(es12.4,1x),a,10(es12.4,1x))

         end subroutine get_ice_optics

!-----------------------------------------------------------------------
         subroutine relcalc( levels, t, owater_frac, icefrac, snowfrac )
!----------------------------------------------------------------------- 
! Purpose: 
! Compute effective radius of cloud water droplets
! Subroutine adapted WRF version 3.5 by Phil Rasch
! Method: 
! analytic formula following the formulation originally developed by J. T. Kiehl
! for CAM version 3.0 and 4.0 
!-----------------------------------------------------------------------
            Implicit None

! Arguments:
            integer, intent( in ) :: levels            ! layers to process
            real,    intent( in ) :: t( : )            ! Air Temperature, K
            real,    intent( in ) :: owater_frac       ! Open water fractional coverage
            real,    intent( in ) :: icefrac           ! Sea Ice fractional coverage
            real,    intent( in ) :: snowfrac          ! Snow fractional coverage

! Parameters:
            real, parameter :: tmelt     = 273.16 ! freezing temperature of fresh water (K)
            real, parameter :: rliqland  =  8.0   ! liquid drop size if over land
            real, parameter :: rliqocean = 14.0   ! liquid drop size if over ocean
            real, parameter :: rliqice   = 14.0   ! liquid drop size if over sea ice
             
            real, parameter :: del_land_ocean   = rliqocean - rliqland
!           real, parameter :: del_land_seaice  = rliqice - rliqland
             
            real, parameter :: sheight_factor = 1.0e-2 ! conversion factor for snow height
                                                       ! equal 0.001 in rrtmg implementation in WRF 3.5
                                                       ! times 10.0 factor in original relcalc subroutine
! variables:
            integer         :: k                    ! loop counter
            real            :: snowh                ! snow height
                                 
!           snowh = sheight_factor * snowfrac 
              
            forall( k=1:levels ) ! effective radius algorithm
! Start with temperature-dependent value appropriate for continental air
               rel(k) = rliqland + del_land_ocean * min(1.0,max(0.0,0.05*(tmelt-t(k))))
 ! Ramp up for snow frac over land; uses fill increase if snow_frac is 100%
               rel(k) = rel(k) + (rliqocean-rel(k)) * min(1.0, snowfrac)  ! min(1.0,max( 0.0, snowh))
 ! Ramp up between polluted value over land to clean value over ocean.
               rel(k) = rel(k) + (rliqocean-rel(k)) * min(1.0,max( 0.0, owater_frac))
 ! Ramp up between the resultant value and a sea ice value in the presence of ice.
               rel(k) = rel(k) + (rliqice-rel(k))   * min(1.0,max( 0.0, icefrac ))
            end forall
              
         end subroutine relcalc            

!-----------------------------------------------------------------------
         subroutine get_droplet_optics( levels, t, owater_frac, icefrac, snowfrac, lwc )

            USE UTILIO_DEFN         ! IO functions and parameters
            USE CSQY_DATA           ! number and value of wavelengths
            
            Implicit None
! Agruments:
            integer, intent( inout ) :: levels            ! layers to process
            real,    intent( inout ) :: t( : )            ! Air Temperature, K
            real,    intent( inout ) :: owater_frac       ! Open water fractional coverage
            real,    intent( inout ) :: icefrac           ! Sea Ice fractional coverage
            real,    intent( inout ) :: snowfrac          ! Snow fractional coverage
            real,    intent( in )    :: lwc( : )          ! cloud liquid water content, g/m3

! local:
            real    :: radliq
            real    :: fint
            integer :: index
            integer :: iwl
            integer :: layer

            character( 132 )      :: XMSG
            character( 32 ), save :: pname = 'GET_DROPLET_OPTICS'

            logical               :: error_flag

            error_flag = .false.
 
!           forall( layer = 1:levels )
!              rel( layer ) = 0.0
!              forall( iwl = 1:nwl_ref ) 
!                 cloud_liquid_ext ( layer, iwl ) = cldmin
!                 cloud_liquid_scat( layer, iwl ) = cldtiny
!                 cloud_liquid_ssa ( layer, iwl ) = high
!                 cloud_liquid_asy ( layer, iwl ) = 0.0
!              end forall 
!           end forall

            cloud_liquid_ext ( 1:levels, 1:nwl_ref ) = cldmin
            cloud_liquid_scat( 1:levels, 1:nwl_ref ) = cldtiny
            cloud_liquid_ssa ( 1:levels, 1:nwl_ref ) = high
            cloud_liquid_asy ( 1:levels, 1:nwl_ref ) = 0.0
             
            if( maxval(lwc) .le. cldmin )return
             
            call relcalc( levels, t, owater_frac, icefrac, snowfrac )
             
! Calculation of optical coefficients due to water clouds droplets
! Note that this loop structure may not be the most efficientbecuase the 
! inner loop use the farther right array index. The code does this because cycle 
! condition per layer may be more efficient than iterating over wavelength than 
! layer
            error_flag = .false.
             
            do layer = 1, levels
               if( lwc( layer ) .le. cldmin )cycle
               do iwl = 1, nwl_ref
                  radliq = rel(layer)
#ifdef phot_debug                    
                  if (radliq .lt. mini_radius_liquid .or. radliq .gt. maxi_radius_liquid)then
                     write(xmsg, 99950)'liquid effective radius outside bounds and equals ', radliq,
     &               ' um at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if
#endif                    
                  index = int(radliq - init_radius_liquid)
                  if (index .le. 0) index = 1
                  if (index .ge. nradius_liquid) index = nradius_liquid - 1
                    
                  fint = max( freq_radius_liquid*(radliq - init_radius_liquid - real(index)), 0.0)
     
                  cloud_liquid_ext(layer, iwl) = liquid_extinct(index,iwl) 
     &                                         + fint * (liquid_extinct(index+1,iwl) - liquid_extinct(index,iwl))
     
                  cloud_liquid_ssa(layer, iwl) = 1.0 - liquid_coalbedo(index,iwl) 
     &                                         + fint * (liquid_coalbedo(index+1,iwl) - liquid_coalbedo(index,iwl))
                  if (cloud_liquid_ssa(layer, iwl) .le. 0.0)then
                     cloud_liquid_ssa(layer, iwl) = cloud_liquid_ssa(layer, iwl) + low
                  else if(cloud_liquid_ssa(layer, iwl) .ge. 1.0)then
                     cloud_liquid_ssa(layer, iwl) = cloud_liquid_ssa(layer, iwl) - low
                  end if
                  cloud_liquid_asy(layer, iwl) = liquid_asymfact(index,iwl) 
     &                                         + fint * (liquid_asymfact(index+1,iwl) - liquid_asymfact(index,iwl))

!                 forwliq(iwl) = cloud_liquid_asy(ig)*cloud_liquid_asy(iwl)

! convert extinction coefficient into extinction per layer 
                  cloud_liquid_ext(layer, iwl)  = cloud_liquid_ext(layer, iwl) * lwc(layer)
                    
! calculate scattering per layer
                  cloud_liquid_scat(layer, iwl) = cloud_liquid_ssa(layer, iwl) * cloud_liquid_ext(layer, iwl)
#ifdef phot_debug                    
! Check to ensure all calculated quantities are within physical limits.
                  if (cloud_liquid_ext(layer, iwl) .lt. 0.0)then
                     write(xmsg,99950)'cloud droplet extinction equals ', 
     &               cloud_liquid_ext(layer, iwl), ' at layer = ',layer
                     error_flag = .true.
                  end if
                  if (cloud_liquid_ssa(layer, iwl) .gt. high .or. cloud_liquid_ssa(layer, iwl) .lt. low)then
                     write(xmsg, 99950)'liquid cloud droplet SSA outside bounds and equals ', 
     &               cloud_liquid_ssa(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
!                    error_flag = .true.
                  end if 
                  if (cloud_liquid_scat(layer, iwl) .gt. cloud_liquid_ext(layer, iwl))then
                     write(xmsg, 99950)'cloud droplet scattering greater than extinction, SSA = ', 
     &               cloud_liquid_ssa(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if 
                  if (cloud_liquid_asy(layer, iwl) .gt. 1.0 .or. cloud_liquid_asy(layer, iwl) .lt. -1.0)then
                     write(xmsg, 99950)'liquid cloud droplet asymmetery factor outside bounds and equals ', 
     &               cloud_liquid_asy(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if 
#endif                    
               end do
            end do
#ifdef phot_debug                                            
            if( error_flag )then
               write(xmsg,99951)'Encountered the above Errors at COLUMN = ', col_cloud,
     &         ' and ROW = ', row_cloud
               call m3exit(pname,0,0,'Encountered the above Errors', XSTAT1 )
            end if
#endif
           
99950       format(a,es12.4,a,i3)
99951       format(a,i5,a,i5)
         end subroutine get_droplet_optics

!-----------------------------------------------------------------------
         subroutine aggreg_size_effective(hydro_type, q, reff, nlayers)

!---------------------------------------------------------------------------
! Purpose: compute effective radius of cloud water and ice aggregegates:
!         rain droplets, snowflakes and graupel from water liquid and ice
!         
! METHOD: 
!   assume exponential particle size distribution and spherical particles
!                     use Gauss-Laguerre Quadrature for integration
! HISTORY: 08/15/2014: B.Hutzell adapted from NCAR CAM model version 3 
!---------------------------------------------------------------------------

            use const, only : PI
            implicit none

!...Arguments:
            integer, intent(in)  :: hydro_type        ! aggregegate to calculate
            real,    intent(in)  :: q   ( : )         ! aggregegate mixing ratio, g/m3
            real,    intent(out) :: reff( : )         ! effective radius, um
            integer, intent(in)  :: nlayers             ! # of layers

! constants  
! values for n0 values taken from default column of Table 1. in Wainwright et. al (2014)
! J. of Appl. Meteo. Climat., vol 53. pp 2072.
            real( 8 ), parameter :: n0_rain  =    0.08D0    ! cm(-4)
            real( 8 ), parameter :: n0_snow  =    0.03D0    ! cm(-4)
            real( 8 ), parameter :: n0_grau  =    0.005D0   ! cm(-4)
            real( 8 ), parameter :: rho_rain = 1000.0D0     ! kg m(-3)
            real( 8 ), parameter :: rho_snow =  100.0D0     ! kg m(-3)
            real( 8 ), parameter :: rho_grau =  400.0D0     ! kg m(-3)

            real( 8 ), parameter :: chi_rain = -4.47806054D+01 ! -2.0*(1.0e+3*pi*rho_rain*n0_rain)**0.25, (cm-4*g/m3)**.25
            real( 8 ), parameter :: chi_snow = -1.97059682D+01 ! -2.0*(1.0e+3*pi*rho_snow*n0_snow)**0.25, (cm-4*g/m3)**.25
            real( 8 ), parameter :: chi_grau = -1.78063523D+01 ! -2.0*(1.0e+3*pi*rho_grau*n0_grau)**0.25, (cm-4*g/m3)**.25
   
!!!!!!!!!!! real, parameter :: limit = 1.0E-10 ! value of q where calculation converges to a lower limit
            real, parameter :: limit = 1.0E-04 ! value of q where calculation converges to a upper limit

            real, parameter :: dmin_snow = 887.873       ! lower convergence results for snow, um 
            real, parameter :: dmin_grau = dmin_snow     ! lower convergence results for graupel, um 
            real, parameter :: dmin_rain = 0.5*dmin_snow ! lower convergence results for rain, um 

!  local variables
            integer   :: lay, nk
            real( 8 ) :: rho_hydro
            real( 8 ) :: sum1, sum2 
            real( 8 ) :: lamda
            real( 8 ) :: n0
            real( 8 ) :: chi
            real( 8 ) :: comp
            real( 8 ) :: psd      ! partical size distribution
            real( 8 ) :: argument
            real      :: factor
            real      :: dmin  ! value if q .le. limit

! initialize
!
! cloud rain/snow/graupel effective radius
!
            if ( maxval( q ) .le. cldmin )then
               reff( 1:nlayers )  = min_dge
               return
            end if
               select case ( hydro_type )
               case( 1 )
                  rho_hydro =  rho_rain
                  n0        =  n0_rain
                  chi       =  chi_rain
                  factor    =  1.0e+4
                  dmin      =  dmin_rain
               case( 2 )
                  rho_hydro =  rho_snow
                  n0        =  n0_snow
                  chi       =  chi_snow
                  factor    =  2.0e+4
                  dmin      =  dmin_snow
               case( 3 )
                  rho_hydro =  rho_grau
                  n0        =  n0_grau
                  chi       =  chi_grau
                  factor    =  2.0e+4
                  dmin      =  dmin_snow
               case default
                  reff( 1:nlayers )  = min_dge
                  return
               end select
               
            do lay = 1, nlayers
!              lamda = (1.0e+3*pi*rho_hydro*n0/q(lay))**0.25
               if( q(lay) .le.  limit )then
                  reff(lay) = dmin
                  cycle
               end if
               lamda = chi*(1.0D0/real( q(lay), 8))**0.25D0
               sum1 = 0.0D0
               sum2 = 0.0D0
!original method used thirty-two nodes
               do nk = 1, 32
                  argument = lamda*xk(nk)
                  if( argument .lt. cloud_log_smallest ) cycle ! assume dexp( argument ) equals zero
                  psd = n0*dexp( argument ) 
                  comp = newtotalw(nk) * psd
                  sum2 = sum2 + comp 
                  sum1 = sum1 + xk(nk)*comp
! reff results sixteen point seem off from thirty two points up to a factor of two
!              do nk = 1, 16
!                 psd  = n0*exp(lamda*gauss_laguerre_node(nk))
!                 comp = gauss_laguerre_total(nk) * psd
!                 sum2 = sum2 + comp 
!                 sum1 = sum1 + gauss_laguerre_node(nk)*comp
               end do
               if( sum2 .lt. cloud_smallest )then
                 reff(lay) = dmin
               else
                 reff(lay) = factor * real( sum1/sum2, 4 )    ! microns
               end if
            end do

         end subroutine aggreg_size_effective

!-----------------------------------------------------------------------
         subroutine get_aggregate_optics( levels, rwc, swc, gwc )
! Purpose calculate optical properties for aggregates: combined rain droplet, snowflakes and graupel
! Uses Fu (1996) parameterization for ice particle generalized effective size, dge, from 5 to 140 microns, 
! Algorithm adapted Rapid Radiative Model Global (RRTMG) version 3.9 and Weather Research Forecasting model
! (WRF) version 3.6

            use VGRD_DEFN, ONLY : NLAYS
            USE UTILIO_DEFN         ! IO functions and parameters
            USE CSQY_DATA           ! number and value of wavelengths

            IMPLICIT NONE
! arguments:
            integer, intent( inout ) :: levels     ! layer to processes
            real,    intent( inout ) :: rwc( : )   ! rain water content, g/m3
            real,    intent( inout ) :: swc( : )   ! snowflake content, g/m3
            real,    intent( inout ) :: gwc( : )   ! graupel content, g/m3

! Local:
            real     :: factor
            real     :: fint
            real     :: forwice                ! forward sccatering parameter
            real     :: reff_rain( nlays )     ! effective radius of rain droplet, um
            real     :: deff_snow( nlays )     ! effective diameter of snowflakes, um
            real     :: deff_graupel( nlays )  ! effective diameter of graupel, um
            
            real     :: deff_hydro( nlays )    ! effective diameter for unmodified hydrometeor, um
            real     :: hydro_content( nlays ) ! unmodified hydrometeor content, g/m3

            real     :: rain_ext               ! rain droplet extinction coefficient, 1/m
            real     :: rain_ssa               ! rain droplet sing scattering albedo
            real     :: rain_scat              ! rain droplet scattering coefficient, 1/m
            real     :: rain_asy               ! rain droplet asymmetry factor

            real     :: snow_ext               ! snowflake extinction coefficient, 1/m
            real     :: snow_ssa               ! snowflake sing scattering albedo
            real     :: snow_scat              ! snowflake scattering coefficient, 1/m
            real     :: snow_asy               ! snowflake asymmetry factor

            real     :: graupel_ext            ! graupel extinction coefficient, 1/m
            real     :: graupel_ssa            ! graupel sing scattering albedo
            real     :: graupel_scat           ! graupel scattering coefficient, 1/m
            real     :: graupel_asy            ! graupel asymmetry factor

            real     :: snow_del                ! snowflake delta forward tranmission function
            real     :: graupel_del             ! graupel delta forward tranmission function

            integer  :: iwl                    ! loop counter
            integer  :: layer                  ! loop counter
            integer  :: index
            
            character( 132 )       :: XMSG
            character(  32 ), save :: pname = 'GET_AGGREGATE_OPTICS'
            
            logical  :: error_flag
            logical  :: normalize

! for rain droplets used simple parameterization in Goddard Radiation Model

            normalize = .false.
            error_flag = .false.
           
! initialize optical properties to minimums
            forall( layer = 1:levels, iwl = 1:nwl_ref )
               cloud_aggreg_ext ( layer,iwl )  = cldmin
               cloud_aggreg_scat( layer,iwl )  = cldtiny
               cloud_aggreg_asy ( layer,iwl )  = 0.0
               cloud_aggreg_ssa ( layer,iwl )  = high
            end forall
!           cloud_aggreg_ext ( 1:levels,1:nwl_ref ) = cldmin
!           cloud_aggreg_scat( 1:levels,1:nwl_ref ) = cldtiny
!           cloud_aggreg_ssa ( 1:levels,1:nwl_ref ) = high
!           cloud_aggreg_asy ( 1:levels,1:nwl_ref ) = 0.0

           
            if( maxval( rwc ) .gt. cldmin )then
!!!!!!!!!      call aggreg_size_effective( 1, rwc, reff_rain, levels)

!Parameterization for rain droplets is taken from Goddard Space Flight Radiation Model
!in WRF version 3.6. Their derivation is discussed in Chou and Suarez (1999),
! A Solar Radiation Parameterization for Atmospheric Studies, NASA/TM-1999-104606,
!Vol. 15, pages 17-20.

               rain_ext  =  3.0e-3
               rain_ssa  =  high
               rain_scat =  rain_ssa*rain_ext
               rain_asy  =  0.883
               do layer = 1, levels
                  if( rwc( layer ) .le. cldmin )cycle
                  forall ( iwl = 1:nwl_ref )
                     cloud_aggreg_ext (layer,iwl) = rain_ext  * rwc(layer)
                     cloud_aggreg_scat(layer,iwl) = rain_scat * rwc(layer)
                     cloud_aggreg_asy (layer,iwl) = rain_asy * cloud_aggreg_scat(layer, iwl)
                     cloud_aggreg_ssa (layer, iwl) = rain_ssa
                  end forall
               end do
               normalize = .true.
            end if
            
            if( maxval( swc ) .gt. cldmin )then

               call aggreg_size_effective( 2, swc, deff_snow, levels)

               do layer = 1, levels
                  if( swc( layer ) .le. cldmin )cycle
                  deff_hydro(layer)    = deff_snow(layer)
! correct the snowflake effective size to be within maxi and min parameters then
! updated concentrations. Latter step is taken from the RRTMG code version 3.9 so Fu (1996) can be
! used for optical properties.
                  if( deff_snow( layer ) .ge. maxi_diameter_ice )then
                      hydro_content( layer ) = swc( layer ) * max_dge_squ
     &                                       / (deff_snow( layer )*deff_snow( layer ))
                  else
                      hydro_content(layer)   = swc(layer)
                  end if
                  deff_snow( layer ) = max( min( deff_snow( layer ), max_dge ), min_dge )
                  do iwl = 1, nwl_ref                 
                     factor = freq_diameter_ice * (deff_snow(layer) - mini_diameter_ice)
                     index = int(factor)
                     fint = max( factor - float(index),0.0 )
                     index = min(  ndiameter_ice - 1, max( 1, index ) )
                     snow_ext  =  ice_extinct(index,iwl) 
     &                         +  fint * (ice_extinct(index+1,iwl) - ice_extinct(index,iwl))
                     snow_ssa  =  1.0 - ice_coalbedo(index,iwl) 
     &                         +  fint * (ice_coalbedo(index+1,iwl) - ice_coalbedo(index,iwl))
                     snow_asy  =  ice_asymfact(index,iwl) 
     &                         +  fint * (ice_asymfact(index+1,iwl) - ice_asymfact(index,iwl))
                     snow_del  = ice_deltrans(index,iwl) 
     &                         + fint * (ice_deltrans(index+1,iwl) - ice_deltrans(index,iwl))
#ifdef phot_debug                     
                     if (snow_del .gt. 1.0 .or. snow_del .lt. 0.0)then
                         write(xmsg, 99960)'snowflake delta function outside bounds and equals ', 
     &                   snow_del,' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if 
!                    if( iwl .eq. 1 .and. row_cloud .eq. 1 .and. col_cloud .eq. 1 )then
!                        write(log_cloud_optics,99962)'hdc,deff_snow,snow_ext,snow_asy,ssa,del = ',
!     &                  hydro_content( layer ),deff_snow(layer),snow_ext,snow_asy,
!     &                  snow_ssa, snow_del
!                    end if
#endif                     

                     if(snow_ssa .gt. low)then
                         forwice = snow_del + 0.5 / snow_ssa
                     else 
                        forwice = high
                     end if 
! See Fu (1996) p. 2067 
                     if (snow_asy .ge. 1.0) snow_asy = snow_asy-low
                     if (snow_asy .le. 0.0) snow_asy = snow_asy+low
                     if (forwice .gt. snow_asy) forwice = snow_asy
! adjust results for fraction of light in forward scattering peak from nonspheric particles
! see Appendix A in Fu (1996), equations A.2(a,b,c)
                     snow_ext = (1.0 - forwice*snow_ssa) *  snow_ext
                     snow_ssa =  snow_ssa*(1.0 - forwice) / (1.0 - forwice*snow_ssa)
                     snow_asy = (snow_asy -  forwice) / (1.0 - forwice)
                     snow_del = forwice
! calculate extinction and scattering coefficients per layer
                     snow_ext  =  snow_ext * hydro_content(layer)
                     snow_scat =  snow_ssa * snow_ext
#ifdef phot_debug                      
! Check to ensure all calculated quantities are within physical limits.
                     if (snow_ext .lt. 0.0 .or. snow_ext .ne. snow_ext )then
                        write(xmsg,99960)'snowflake extinction equals ', 
     &                  snow_ext, ' at layer = ',layer
                        error_flag = .true.
                     end if
                     if (snow_ssa .gt. high .or. snow_ssa .lt. low .or. snow_ssa .ne. snow_ssa )then
                        write(xmsg, 99960)'snowflake SSA outside bounds and equals ', 
     &                  snow_ssa,' at layer ', layer
                        call m3mesg(xmsg)
!                       error_flag = .true.
                     end if 
                     if (snow_asy .ge. 1.0 .or. snow_asy .le. -1.0 .or. snow_asy .ne. snow_asy )then
                         write(xmsg, 99960)'snowflake asymmetery factor outside bounds and equals ', 
     &                   snow_asy,' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if 
                     if (snow_scat .gt. snow_ext)then
                         write(xmsg, 99960)'snowflake scattering greater than extinction, SSA ', 
     &                   snow_ssa,' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if                      
!                    if( iwl .eq. 1 .and. row_cloud .eq. 1 .and. col_cloud .eq. 1 )then
!                        write(log_cloud_optics,99962)'swc,deff_hydro,snow_ext,snow_scat,snow_asyssa,del = ',
!     &                  swc( layer ),deff_hydro(layer),snow_ext/hydro_content(layer),snow_scat/hydro_content(layer),snow_asy,
!     &                  snow_ssa, snow_del
!                    end if
#endif
                     cloud_aggreg_ext(layer, iwl)  = cloud_aggreg_ext(layer, iwl)  + snow_ext
                     cloud_aggreg_scat(layer, iwl) = cloud_aggreg_scat(layer, iwl) + snow_scat
                     cloud_aggreg_asy(layer, iwl)  = cloud_aggreg_asy(layer, iwl)  + (snow_asy*snow_scat)
#ifdef phot_debug                                          
!             if( abs( cloud_aggreg_asy(layer, iwl) ) .ge. cloud_aggreg_scat(layer, iwl) )then
!                 write(log_cloud_optics,99962)
!     &           'swc,deff_hydro,snow_ext,snow_scat,snow_asy * snow_scat, ssa,del,  cloud_aggreg_asy = ',
!     &           swc( layer ),deff_hydro(layer),snow_ext,snow_scat,(snow_asy*snow_scat),
!     &           snow_ssa, snow_del, cloud_aggreg_asy(layer, iwl), cloud_aggreg_scat(layer, iwl)
!             end if
#endif
                  end do
               end do
               normalize = .true.
            end if

            if( maxval( gwc ) .gt. cldmin )then

               call aggreg_size_effective( 3, gwc, deff_graupel, levels)

               do layer = 1, levels
                  if( gwc( layer ) .le. cldmin )cycle                     
                  deff_hydro(layer) = deff_graupel(layer)
! correct effective size to be within maxi and min parameters then
! updated concentrations. Latter step is taken from the RRTMG code 
! version 3.9 so Fu (1996) can be used for optical properties.
                  if( deff_graupel( layer ) .ge. maxi_diameter_ice )then
                     hydro_content( layer ) = gwc( layer ) * max_dge_squ
     &                                      / (deff_graupel( layer )*deff_graupel( layer )) 
                  else
                     hydro_content(layer)   = gwc(layer)                    
                  end if
                  deff_graupel( layer ) = max( min( deff_graupel( layer ), max_dge ), min_dge )
                  do iwl = 1, nwl_ref
                     factor = freq_diameter_ice * (deff_graupel(layer) - mini_diameter_ice)
                     index = int(factor)
                     fint = max( factor - float(index), 0.0 )
                     index = min(  ndiameter_ice - 1, max( 1, index ) )
                     graupel_ext  =  ice_extinct(index,iwl) 
     &                            +  fint * (ice_extinct(index+1,iwl) - ice_extinct(index,iwl))
                     graupel_ssa  =  1.0 - ice_coalbedo(index,iwl) 
     &                            +  fint * (ice_coalbedo(index+1,iwl) - ice_coalbedo(index,iwl))
                     graupel_asy  =  ice_asymfact(index,iwl) 
     &                            +  fint * (ice_asymfact(index+1,iwl) - ice_asymfact(index,iwl))
                     graupel_del  = ice_deltrans(index,iwl) 
     &                            + fint * (ice_deltrans(index+1,iwl) - ice_deltrans(index,iwl))
#ifdef phot_debug                     
                     if (graupel_del .gt. 1.0 .or. graupel_del .lt. 0.0)then
                         write(xmsg, 99960)'graupel delta function outside bounds and equals ', 
     &                   graupel_del,' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if 
!                    if( iwl .eq. 1 .and. row_cloud .eq. 1 .and. col_cloud .eq. 1 )then
!                        write(log_cloud_optics,99962)'hdc,deff_graupel,graupel_ext,graupel_asy,ssa,del = ',
!     &                  hydro_content( layer ),deff_graupel(layer),graupel_ext,graupel_asy,
!     &                  graupel_ssa, graupel_del
!                    end if
#endif

                     if(graupel_ssa .gt. low)then
                         forwice = graupel_del + 0.5 / graupel_ssa
                     else 
                         forwice = high
                     end if 

! See Fu (1996) p. 2067 
                     if (graupel_asy .ge. 1.0) graupel_asy = graupel_asy-low
                     if (graupel_asy .le. 0.0) graupel_asy = graupel_asy+low
                     if (forwice .gt. graupel_asy) forwice = graupel_asy
! adjust results for fraction of light in forward scattering peak from nonspheric particles
! see Appendix A in Fu (1996), equations A.2(a,b,c)
!!! temporary to check interpolation method
                     graupel_ext = (1.0 - forwice*graupel_ssa) *  graupel_ext
                     graupel_ssa =  graupel_ssa*(1.0 - forwice) / (1.0 - forwice*graupel_ssa)
                     graupel_asy = (graupel_asy -  forwice) / (1.0 - forwice)
                     graupel_del = forwice
! calculate extinction and scattering coefficients per layer
                     graupel_ext  =  graupel_ext * hydro_content(layer)
                     graupel_scat =  graupel_ssa * graupel_ext
#ifdef phot_debug                     
! Check to ensure all calculated quantities are within physical limits.
                     if (graupel_ext .lt. 0.0 .or. graupel_ext .ne. graupel_ext )then
                        write(xmsg,99960)'graupel extinction equals ', 
     &                  graupel_ext, ' at layer = ',layer
                        error_flag = .true.
                     end if
                     if (graupel_ssa .gt. high .or. graupel_ssa .lt. low .or. graupel_ssa .ne. graupel_ssa )then
                        write(xmsg, 99960)'graupel SSA outside bounds and equals ', 
     &                  graupel_ssa,' at layer ', layer
                        call m3mesg(xmsg)
!                       error_flag = .true.
                      end if 
                      if (graupel_asy .gt. 1.0 .or. graupel_asy .lt. -1.0 .or. graupel_asy .ne. graupel_asy )then
                         write(xmsg, 99960)'graupel asymmetery factor outside bounds and equals ', 
     &                   graupel_asy,' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if 
!                    if( iwl .eq. 1 .and. row_cloud .eq. 1 .and. col_cloud .eq. 1 )then
!                       write(log_cloud_optics,99962)'gwc,deff_hydro,graupel_ext,graupel_scat,graupel_asy,ssa,del = ',
!     &                 gwc( layer ),deff_hydro(layer),graupel_ext/hydro_content(layer),graupel_scat/hydro_content(layer),
!     &                 graupel_asy,graupel_ssa, graupel_del
!                    end if
#endif
                     cloud_aggreg_ext(layer, iwl)  = cloud_aggreg_ext(layer, iwl)  + graupel_ext
                     cloud_aggreg_scat(layer, iwl) = cloud_aggreg_scat(layer, iwl) + graupel_scat
                     cloud_aggreg_asy(layer, iwl)  = cloud_aggreg_asy(layer, iwl)  + (graupel_asy*graupel_scat)
#ifdef phot_debug                     
                     if( abs( cloud_aggreg_asy(layer, iwl) ) .gt. cloud_aggreg_scat(layer, iwl) )then
                        write(logdev,99962)
     &                  'gwc,deff_hydro,graupel_ext,graupel_scat,graupel_asy*graupel_scat,ssa,del, cloud_aggreg_asy = ',
     &                  gwc( layer ),deff_hydro(layer),graupel_ext,graupel_scat,(graupel_asy*graupel_scat),
     &                  graupel_ssa, graupel_del, cloud_aggreg_asy(layer, iwl), cloud_aggreg_scat(layer, iwl)
                     end if
#endif                     
                  end do
               end do
               normalize = .true.                
            end if   
     
! computed average properties: single scattering albedo and asymmetery factor
            if( .Not. normalize )RETURN
            
            forall( layer = 1:levels, iwl = 1:nwl_ref )
               cloud_aggreg_ssa(layer,iwl) = cloud_aggreg_scat(layer,iwl)/cloud_aggreg_ext(layer,iwl)
               cloud_aggreg_asy(layer,iwl) =  cloud_aggreg_asy(layer,iwl)/cloud_aggreg_scat(layer,iwl)
            end forall
#ifdef phot_debug                                  
!           do layer = 1, nlays
!              do iwl = 1,nwl_ref
!                 if( abs( cloud_aggreg_asy(layer, iwl) ) .ge. 1.0 )then 
!                     write(log_cloud_optics,99964)
!     &               'layer, iwln cloud_aggreg_scat, cloud_aggreg_scat, cloud_aggreg_ssa, cloud_aggreg_asy = ',
!     &               layer, iwl, cloud_aggreg_ext(layer, iwl), cloud_aggreg_scat(layer, iwl), cloud_aggreg_ssa(layer, iwl), 
!     &               cloud_aggreg_asy(layer, iwl)
!                     error_flag = .true.
!                 end if
!              end do
!           end do
            if( error_flag )then
               write(xmsg,99961)'Encountered the above Errors at COLUMN = ', col_cloud,
     &         ' and ROW = ', row_cloud
               call m3exit(pname,0,0,'Encountered the above Errors', XSTAT1 )
            end if
#endif           

99960       format(a,es12.4,a,i3)
99961       format(a,i5,a,i5)
99962       format(a,1x,10(es12.4,1x),a,10(es12.4,1x))
99964       format(a,2(1x,i3),1x,10(es12.4,1x),a,10(es12.4,1x))
         end subroutine get_aggregate_optics

!-----------------------------------------------------------------------
         subroutine clear_hydrometeor_optics()
            implicit none
!Purpose clear values for hydrometeor optical properties
!Arguments: None
            cloud_liquid_ext  = 0.0
            cloud_liquid_scat = 0.0
            cloud_liquid_ssa  = 1.0
            cloud_liquid_asy  = 0.0          
            cloud_ice_ext     = 0.0
            cloud_ice_scat    = 0.0
            cloud_ice_ssa     = 1.0
            cloud_ice_asy     = 0.0
            cloud_aggreg_ext  = cldmin
            cloud_aggreg_scat = cldtiny
            cloud_aggreg_ssa  = 1.0
            cloud_aggreg_asy  = 0.0              
         end subroutine clear_hydrometeor_optics

      end module cloud_optics   

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE DEGRADE_ROUTINES

         USE DEGRADE_SETUP_TOX

         IMPLICIT NONE

         REAL( 8 ), PARAMETER, PRIVATE :: COEF1     =  7.33981D+15 ! Molec/cc to ppm conv factor

      CONTAINS



      SUBROUTINE DEGRADE( CBLK, DT, JDATE, JTIME )

C**********************************************************************
C
C Function: Calculate changes in gas species based on a exponential decay.
C           The decay rate sums losses from processes in DEGRADE_DATA.
C
C CALLED BY: HRSOLVER
C
C WARNING: THIS ROUTINE ASSUMES SIMPLE AND LINEAR TRANSFORMATIONS FROM
C          ATMOSPHERIC CHEMISTRY.
C
C Species being degraded are governed by the equation,
C     dx/dt = -b*x, where b is the sum of N loss rates
C
C IT DOES NOT SOLVE A SYSTEM OF ODE's AS IN SMVGEAR, ROS3, and EBI SOLVERS.
C
C  REVISION HISTORY:  07/29/05 : B.Hutzell - Initial version
C                     09/30/11 : B.Hutzell - added CYCLE statements to allow 
C                                optional degraded species i.e., RXTANT_MAP( I )
C                                is less than zero
C**********************************************************************

      USE RXNS_DATA
#ifdef isam
      USE SA_DEFN
#endif      

      IMPLICIT NONE

C.....ARGUMENTS:

      REAL( 8 ), INTENT( IN ) :: CBLK( : )      ! array holding species concentrations
      REAL( 8 ), INTENT( IN ) :: DT             ! time step for integrations [sec]
      INTEGER,   INTENT( IN ) :: JDATE          ! current model date , coded YYYYDDD
      INTEGER,   INTENT( IN ) :: JTIME          ! current model time , coded HHMMSS

C.....PARAMETERS:

      CHARACTER(16), PARAMETER :: PNAME  = ' DEGRADE    '  ! name of routine calling I/OAPI

      INTEGER, PARAMETER :: LOCAL_DT = 3     ! minimum time step, mili-seconds

      REAL(8), PARAMETER :: CONMIN = 1.0D-30 ! concentration lower limit
      REAL(8), PARAMETER :: ONE    = 1.0D0
      REAL(8), PARAMETER :: ZERO   = 0.0D0


C.....LOCAL VARIABLES:

      CHARACTER(16)  ::  VNAME                    ! variable name
      CHARACTER(120) ::  XMSG

      INTEGER        :: TIME_SECONDS                ! TIME, sec
      INTEGER        :: I_RXT, I_RAD, J_RAD, I_PROD ! indices
      INTEGER        :: I, J, K, L                  ! loop counters
      INTEGER, SAVE  :: I_SIZE                      ! scratch
      
      integer        :: icount

  
      LOGICAL, SAVE  :: FIRSTCALL  = .TRUE.
      LOGICAL, SAVE  :: ANY_PRODUCTS( N_REACT )  ! does degraded species have any daughter products
      
      REAL(8)        :: TRANS                    ! molecules/cm^3 transferred to products
      REAL(8)        :: LOSS_RATE( N_PROCESSES ) ! individual loss rates  [sec^-1]
      REAL(8)        :: NET_RATE                 ! net rate of transfer   [sec^-1]
      REAL(8)        :: NET_LIFE( N_REACT)       ! lifetime based on net transfer rate  [sec]
      REAL(8)        :: TSTEP                    ! degradation time step, sec
      REAL(8)       ::  EQU_FACTOR               ! equilibrium concentration, [ dimensionaless ] 
#ifdef isam
      REAL(8)        :: FACTOR                   ! relative change in bulk concentration
      REAL(8)        :: ISAM_INIT                ! sum of initial tag concentrations
#endif      
C**********************************************************************

      IF ( FIRSTCALL ) THEN  ! initialize maps
         I_SIZE = SIZE( CBLK )
         FIRSTCALL = .FALSE.
 
         DO I = 1, N_REACT
           IF( ANY( PROD_MAP( 1:N_PROCESSES, I ) > 0 ) )THEN
              ANY_PRODUCTS( I ) = .TRUE.
           ELSE
              ANY_PRODUCTS( I ) = .FALSE.
           END IF
         END DO
         !TAG_CONMIN = CONMIN / REAL( NTAG_SA,8 )
      ENDIF

C..Update concentrations except degraded species

      LOOP_NEW: DO I = 1, I_SIZE
         DO J = 1, N_REACT
            IF( RXTANT_MAP( J ) .EQ. I )THEN
                CYCLE LOOP_NEW
            END IF
         ENDDO
         NEW_CONC( I ) = CBLK( I ) 
      ENDDO LOOP_NEW
      
      CHANGE_CONC = ZERO

C..Quality Control on time step

      TSTEP = DT
      BLOCK_A : IF ( TSTEP < 0.0D0 ) THEN
         XMSG = ' Time step has negative value. '
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      ENDIF BLOCK_A

C..Loop over each reactant

      LOOP_REACT: DO I = 1, N_REACT
      
         LOSS_RATE = ZERO
         NET_RATE  = ZERO
         NET_LIFE( I ) = ZERO

         I_RXT = RXTANT_MAP( I )
         IF( I_RXT < 0 )CYCLE LOOP_REACT
         

         IF( NEW_CONC( I_RXT ) <= CONMIN )CYCLE LOOP_REACT


         LOOP_UNIRATE: DO J = UNI_START, UNI_STOP
             LOSS_RATE( J ) = CELL_RKI( J, I )
         ENDDO LOOP_UNIRATE

         L = 0

         LOOP_BIRATE: DO J = BI_START, BI_STOP
            L = L + 1
            I_RAD = RAD_MAP( L, I )
            IF ( I_RAD < 1 ) CYCLE   ! radical species is undefined
            IF( I_RAD < 9000 )THEN
                LOSS_RATE( J ) = 0.5D0 * CELL_RKI( J, I )
     &                         * ( OLD_CONC( I_RAD ) + NEW_CONC( I_RAD ) )
            ELSE
                LOSS_RATE( J ) = CELL_RKI( J, I )
            END IF
         ENDDO LOOP_BIRATE

         L = 0

         LOOP_TRIRATE: DO J = TRI_START, TRI_STOP
            L = L + 1
            I_RAD = RAD2_MAP( 1, L, I )
            J_RAD = RAD2_MAP( 2, L, I )
            IF ( I_RAD < 1 .OR. J_RAD < 1 ) CYCLE   ! radical species are undefined
            IF ( I_RAD > 9000 .AND. J_RAD < 9000 ) THEN
               LOSS_RATE( J ) = 0.5D0 * CELL_RKI( J, I )
     &                        * ( OLD_CONC( J_RAD ) + NEW_CONC( J_RAD ) )
            ELSE IF ( J_RAD > 9000 .AND. I_RAD < 9000 ) THEN
               LOSS_RATE( J ) = 0.5D0 * CELL_RKI( J, I )
     &                        * ( OLD_CONC( I_RAD ) + NEW_CONC( I_RAD ) )
            ELSE IF ( J_RAD < 9000 .AND. I_RAD < 9000 ) THEN
               LOSS_RATE( J ) = 0.5D0 * CELL_RKI( J, I )
     &                        * ( OLD_CONC( I_RAD ) * OLD_CONC( J_RAD )
     &                        +   NEW_CONC( I_RAD ) * NEW_CONC( J_RAD ) )
            ELSE 
               LOSS_RATE( J ) = CELL_RKI( J, I )
            END IF
         ENDDO LOOP_TRIRATE

         L = 0
         LOOP_PHOTORATE: DO J = PHOTO_START, PHOTO_STOP
            L = L + 1
            LOSS_RATE( J ) = CELL_RKI( J, I )
         ENDDO LOOP_PHOTORATE

         L = 0 

         LOOP_LHRATE: DO J = LANHIN_START, LANHIN_STOP
            L = L + 1
            I_RAD = RAD_MAP( L + N_BI_LOSS, I )
            IF ( I_RAD < 1 ) CYCLE   ! radical species is undefined
            IF ( I_RAD < 9000 )THEN
               EQU_FACTOR = 0.5D0 * CELL_RKI( J, I )
     &                    * ( OLD_CONC( I_RAD ) + NEW_CONC( I_RAD ) )
            ELSE
               EQU_FACTOR = CELL_RKI( J, I ) 
            END IF
            LOSS_RATE( J ) = LHRATE( L, I ) * EQU_FACTOR 
     &                     / ( 1.0D0 + EQU_FACTOR )

         ENDDO LOOP_LHRATE

         LOOP_RATE :  DO J = 1, N_PROCESSES
               NET_RATE = NET_RATE + LOSS_RATE( J )
         ENDDO LOOP_RATE
         
         IF ( NET_RATE * DT .LE. EFFECTIVE_ZERO ) THEN
            TRANS = 0.0D0
         ELSE
            NET_LIFE( I ) = 1.0D0 / NET_RATE         
            TRANS = NEW_CONC( I_RXT ) * ( 1.0D0 - DEXP( -NET_RATE * DT ) )
         END IF

         IF ( TRANS > CONMIN ) THEN
             CHANGE_CONC( I_RXT ) = TRANS    
             IF( ANY( PROD_MAP( 1:N_PROCESSES, I ) > 0 ) )THEN
               LOOP_PROD: DO J = 1, N_PROCESSES
                  I_PROD = PROD_MAP( J, I )
                  IF( I_PROD > 0 )THEN
                    CHANGE_CONC( I_PROD ) = ( LOSS_RATE( J ) * NET_LIFE( I ) )
                  END IF
                END DO LOOP_PROD
             END IF
          END IF

      ENDDO LOOP_REACT

      OLD_CONC( 1:NSPCSD ) = NEW_CONC( 1:NSPCSD )

C..update concentrations

      LOOP_UPDATE1: DO I = 1, N_REACT
      
         I_RXT = RXTANT_MAP( I )
         IF( I_RXT < 0 )CYCLE LOOP_UPDATE1

         IF ( CHANGE_CONC( I_RXT ) <= EFFECTIVE_ZERO .OR. NEW_CONC( I_RXT ) <= CONMIN ) CYCLE
         NEW_CONC( I_RXT ) = MAX( NEW_CONC( I_RXT )- CHANGE_CONC( I_RXT ),CONMIN )
         IF( ANY_PRODUCTS( I ) )THEN
            LOOP_UPDATE2: DO J = 1, N_PROCESSES
               I_PROD = PROD_MAP( J, I )
               IF ( I_PROD > 0 ) THEN ! specified product
                  CHANGE_CONC( I_PROD ) =  CHANGE_CONC( I_PROD )
     &                                *  MAX( OLD_CONC( I_RXT )-NEW_CONC( I_RXT ),
     &                                        ZERO ) 
                  NEW_CONC( I_PROD ) = NEW_CONC( I_PROD )
     &                                + RATE_YIELD( J, I )
     &                                * MAX( CHANGE_CONC( I_PROD ), CONMIN )
               END IF
            ENDDO LOOP_UPDATE2
         END IF
      ENDDO LOOP_UPDATE1
#if defined(isam) && defined(verbose_isam_deg)
      IF( DEG_LAY .EQ. 1 .AND. DEG_ROW .EQ. 1 .AND. DEG_COL .EQ. 1 )THEN
         WRITE(LOGDEV,'(/,A,I3)')'SA_DEGRADE_STEP: ',SA_DEGRADE_STEP
         WRITE(LOGDEV,'(/A18,(1X,A12),1X,A12,6(1X,A12))')'S ISAM_DEGRADED', 'FACTOR', 'REACT',
     &   'INIT_BULK','ISAM_INIT','FINI_BULK','ISAM_FINI','LIFE (days)'
      END IF
#endif      
#ifdef isam
      LOOP_ISAM: DO I = 1, ISAM_DEGRADED_SPC
      
         I_RXT = ISAM_TO_DEGRADED( I )
         I_RAD = ISAM_TO_REACTANT( I )
         IF( I_RXT .GT. 0 )THEN 

! scale loss of tag based on their fraction of the bulk
               FACTOR = NEW_CONC( I_RXT ) / MAX( OLD_CONC( I_RXT ),CONMIN )
#if defined(isam) && defined(verbose_isam_deg)
               ISAM_INIT = SUM(CELL_ISAM( 1:NTAG_SA,I))
#endif
               DO J = 1,  NTAG_SA
                  CELL_ISAM( J,I ) = CELL_ISAM( J,I ) * FACTOR
               END DO ! ktag loop
#if defined(isam) && defined(verbose_isam_deg)
               IF( DEG_LAY .EQ. 1 .AND. DEG_ROW .EQ. 1 .AND. DEG_COL .EQ. 1 )THEN
                  WRITE(LOGDEV,'(A2,A16,1X,ES12.4,1X,A16,6(1X,ES12.4))')'S ',ISAM_DEGRADED( I ), FACTOR, REACT( I_RAD ),
     &            OLD_CONC( I_RXT ),ISAM_INIT,
     &            NEW_CONC( I_RXT ),SUM(CELL_ISAM( 1:NTAG_SA,I)),
     &            1.15741D-5*NET_LIFE( I_RAD )
               END IF
#endif          
         END IF
      ENDDO LOOP_ISAM
#endif

      RETURN
      END SUBROUTINE DEGRADE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/arc/CCTM/src/gas/ros3/degrade.F,v 1.3 2011/10/21 16:11:12 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%


      SUBROUTINE DEGRADE_BLK( CBLK, DT, JDATE, JTIME, BLKID )
C**********************************************************************
C
C Function: Calculate changes in gas species based on a exponential decay.
C           The decay rate sums losses from processes in DEGRADE_DATA.
C
C CALLED BY: RBSOLVER or GRSMVGEAR
C
C WARNING: THIS ROUTINE ASSUMES SIMPLE AND LINEAR TRANSFORMATIONS FROM
C          ATMOSPHERIC CHEMISTRY.
C
C Species being degraded are governed by the equation,
C     dx/dt = -b*x, where b is the sum of N loss rates
C
C IT DOES NOT SOLVE A SYSTEM OF ODE's AS IN SMVGEAR, ROS3, and EBI SOLVERS.
C
C  REVISION HISTORY:  07/29/05 : B.Hutzell - Initial version
C
C**********************************************************************

      USE RXNS_DATA

      IMPLICIT NONE

C.....ARGUMENTS:

      REAL( 8 ), INTENT( IN ) :: CBLK( :,  : ) ! array holding species concentrations
      REAL( 8 ), INTENT( IN ) :: DT            ! time step for integrations [sec]
      INTEGER,   INTENT( IN ) :: JDATE         ! current model date , coded YYYYDDD
      INTEGER,   INTENT( IN ) :: JTIME         ! current model time , coded HHMMSS
      INTEGER,   INTENT( IN ) :: BLKID         ! ID number for the BLK

C.....PARAMETERS:

      CHARACTER(16), PARAMETER :: PNAME = ' DEGRADE    '  ! name of routine calling I/OAPI

      INTEGER, PARAMETER :: LOCAL_DT = 3     ! minimum time step, mili-seconds

      REAL(8), PARAMETER :: CONMIN = 1.0D-30 ! concentration lower limit
      REAL(8), PARAMETER :: ZERO   = 0.00D00 ! concentration lower limit

C.....LOCAL VARIABLES:

      CHARACTER(16)  ::  VNAME                   ! variable name
      CHARACTER(120) ::  XMSG

      LOGICAL, SAVE  :: FIRSTCALL  = .TRUE.
      LOGICAL, SAVE  :: ANY_PRODUCTS( N_REACT )  ! does degraded species have any daughter products

      INTEGER        :: TIME_SECONDS                ! TIME, sec
      INTEGER        :: I_RXT, I_RAD, J_RAD, I_PROD ! indices
      INTEGER        :: I, J, K, L, I_CELL          ! loop counters
      INTEGER, SAVE  :: I_SIZE                      ! scratch

      REAL           ::  TSTEP                             ! time step for integrations
      REAL(8)        ::  TRANS    ( BLKSIZE )              ! molecules/cm^3 transferred to products
      REAL(8)        ::  NET_RATE ( BLKSIZE )              ! net rate of transfer   [sec^-1]
      REAL(8)        ::  NET_LIFE ( BLKSIZE )              ! lifetime based on net transfer rate  [sec]
      REAL(8)        ::  LOSS_RATE( BLKSIZE, N_PROCESSES ) ! individual loss rates  [sec^-1]
      
      REAL(8)        ::  FACTOR
      REAL(8)        ::  LIFETIME( N_REACT ) = 0.0D0

C***********************************************************************

      IF ( FIRSTCALL ) THEN  ! initialize maps
         I_SIZE = SIZE( CURR_CONC, 2 )
         FIRSTCALL = .FALSE.
         DO I = 1, N_REACT
           IF( ANY( PROD_MAP( 1:N_PROCESSES, I ) > 0 ) )THEN
              ANY_PRODUCTS( I ) = .TRUE.
           ELSE
              ANY_PRODUCTS( I ) = .FALSE.
           END IF
         END DO
      ENDIF

C..Initialize concentrations changes

      DELT_CONC = 0.0D0

C..Quality Control on time step

      TSTEP = DT
      BLOCK_A : IF ( TSTEP < 0.0D0 ) THEN
         WRITE(XMSG,'(A)')TRIM(' Time step has negative value. ')
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      ENDIF BLOCK_A

C..Update concentrations except degraded species

      LOOP_UPDATE0: DO J = 1, NSPCSD
         DO I = 1, N_REACT
            IF( RXTANT_MAP( I ) .EQ. J )CYCLE LOOP_UPDATE0
         END DO
         DO I_CELL = 1, NCELLS               
            CURR_CONC( I_CELL, J ) = CBLK( I_CELL, J )
         ENDDO
      ENDDO LOOP_UPDATE0

C..Loop over each reactant

      LOOP_REACT: DO I = 1, N_REACT

         I_RXT = RXTANT_MAP( I )
         
         IF( I_RXT < 0 )CYCLE LOOP_REACT


         LOSS_RATE = 0.0D0
         NET_RATE  = 0.0D0
         NET_LIFE  = 0.0D0

         LOOP_UNIRATE: DO J = UNI_START, UNI_STOP
            DO I_CELL = 1, NCELLS
               IF( CURR_CONC( I_CELL, I_RXT ) <= CONMIN )CYCLE 
               LOSS_RATE( I_CELL, J ) = RATE_CONST( I_CELL, J, I )
            ENDDO
         ENDDO LOOP_UNIRATE

         L = 0

         LOOP_BIRATE: DO J = BI_START, BI_STOP
            L = L + 1
            I_RAD = RAD_MAP( L, I )
            IF ( I_RAD < 1 ) CYCLE   ! radical species is undefined
            IF ( I_RAD > 9000 ) THEN
               DO I_CELL = 1, NCELLS
                  IF( CURR_CONC( I_CELL, I_RXT ) <= CONMIN )CYCLE 
                  LOSS_RATE( I_CELL, J ) = RATE_CONST( I_CELL, J, I )
     &                                   * NUMB_DENS( I_CELL )
               ENDDO
            ELSE
               DO I_CELL = 1, NCELLS
                  IF( CURR_CONC( I_CELL, I_RXT ) <= CONMIN )CYCLE 
                  LOSS_RATE( I_CELL, J ) = 0.5D0 * RATE_CONST( I_CELL, J, I )
     &                                   * ( PREV_CONC( I_CELL, I_RAD )
     &                                   +   CURR_CONC( I_CELL, I_RAD ) )
               ENDDO
            ENDIF
         ENDDO LOOP_BIRATE

         L = 0

         LOOP_TRIRATE: DO J = TRI_START, TRI_STOP
            L = L + 1
            I_RAD = RAD2_MAP( 1, L, I )
            J_RAD = RAD2_MAP( 2, L, I )
            IF ( I_RAD < 1 .OR. J_RAD < 1 ) CYCLE   ! radical species are undefined
            IF ( I_RAD < 9000 .AND. J_RAD < 9000 ) THEN
               DO I_CELL = 1, NCELLS
                  IF( CURR_CONC( I_CELL, I_RXT ) <= CONMIN )CYCLE 
                  LOSS_RATE( I_CELL, J ) =  0.5D0 * RATE_CONST( I_CELL, J, I )
     &                                   * ( PREV_CONC( I_CELL, I_RAD )
     &                                   *   PREV_CONC( I_CELL, J_RAD )
     &                                   +   CURR_CONC( I_CELL, I_RAD )
     &                                   *   CURR_CONC( I_CELL, J_RAD ) )
               ENDDO
            ELSE IF ( J_RAD > 9000 .AND. I_RAD < 9000 ) THEN
               DO I_CELL = 1, NCELLS
                  IF( CURR_CONC( I_CELL, I_RXT ) <= CONMIN )CYCLE 
                  LOSS_RATE( I_CELL, J ) =  0.5D0 * RATE_CONST( I_CELL, J, I )
     &                                   * ( PREV_CONC( I_CELL, I_RAD )
     &                                   +   CURR_CONC( I_CELL, I_RAD ) )
               ENDDO
            ELSE IF ( J_RAD < 9000 .AND. I_RAD > 9000 ) THEN
               DO I_CELL = 1, NCELLS
                  IF( CURR_CONC( I_CELL, I_RXT ) <= CONMIN )CYCLE 
                  LOSS_RATE( I_CELL, J ) =  0.5D0 * RATE_CONST( I_CELL, J, I )
     &                                   * ( PREV_CONC( I_CELL, J_RAD )
     &                                   +   CURR_CONC( I_CELL, J_RAD ) )
               ENDDO
            END IF
         ENDDO LOOP_TRIRATE

         L = 0
         LOOP_PHOTORATE: DO J = PHOTO_START, PHOTO_STOP
            L = L + 1
            DO I_CELL = 1, NCELLS
               LOSS_RATE( I_CELL, J ) = RATE_CONST( I_CELL, J, I )
            ENDDO
         ENDDO LOOP_PHOTORATE

         L = 0
         LOOP_LHRATE: DO J = LANHIN_START, LANHIN_STOP
            L = L + 1
            I_RAD = RAD_MAP( L + N_BI_LOSS, I )
            IF ( I_RAD < 1 ) CYCLE   ! radical species is undefined
            DO I_CELL = 1, NCELLS
               IF ( I_RAD < 9000 )THEN
                   LOSS_RATE( I_CELL, J ) = 0.5D0 * RATE_CONST( I_CELL, J, I )
     &                                    * ( PREV_CONC( I_CELL, I_RAD ) + CURR_CONC( I_CELL, I_RAD ) )
               ELSE
                   LOSS_RATE( I_CELL, J ) = RATE_CONST( I_CELL, J, I ) 
               END IF
               LOSS_RATE( I_CELL, J ) = LHRATE( L, I ) * LOSS_RATE( I_CELL, J ) 
     &                                / ( 1.0D0 + LOSS_RATE( I_CELL, J ) )
            END DO
         ENDDO LOOP_LHRATE


         LOOP_RATE :  DO J = 1, N_PROCESSES
            DO I_CELL = 1, NCELLS
               NET_RATE( I_CELL ) = NET_RATE( I_CELL )
     &                            + LOSS_RATE( I_CELL, J )
            ENDDO
         ENDDO LOOP_RATE

         LOOP_LIFE: DO I_CELL = 1, NCELLS
            IF ( NET_RATE( I_CELL ) * DT .LE. EFFECTIVE_ZERO .OR. CURR_CONC( I_CELL, I_RXT ) <=  CONMIN ) THEN
               TRANS( I_CELL ) = ZERO
#ifdef verbose_deg
!              IF( WRITE_CELL( I_CELL ) )LIFETIME( I ) = INFINITY
               LIFETIME( I ) = INFINITY
#endif
            ELSE
               NET_LIFE( I_CELL ) = 1.0D0 / NET_RATE( I_CELL )
#ifdef verbose_deg
!              IF( WRITE_CELL( I_CELL ) )LIFETIME( I ) = NET_LIFE( I_CELL ) 
               LIFETIME( I ) = NET_LIFE( I_CELL ) 
#endif
               TRANS( I_CELL ) = CURR_CONC( I_CELL, I_RXT )
     &                         * ( 1.0D0 - DEXP( - NET_RATE( I_CELL )*DT ) )
               DELT_CONC( I_CELL, I_RXT ) = - MAX( TRANS( I_CELL ), ZERO )
            END IF
         END DO LOOP_LIFE
         
         IF( ANY( PROD_MAP( 1:N_PROCESSES, I ) > 0 ) )THEN
            IF( ANY( DELT_CONC( :, I_RXT ) > -CONMIN ) )THEN
               LOOP_PROD: DO J = 1, N_PROCESSES
                  I_PROD = PROD_MAP( J, I )
                  IF( I_PROD > 0 )THEN
                    DO I_CELL = 1, NCELLS
                       DELT_CONC( I_CELL, I_PROD ) = ( LOSS_RATE( I_CELL, J ) * NET_LIFE( I_CELL ) )
                    END DO
                  END IF
               END DO LOOP_PROD
             END IF
          END IF
         
      ENDDO LOOP_REACT

C..update previous concentrations

      DO J = 1, NSPCSD
         DO I_CELL = 1, NCELLS
            PREV_CONC( I_CELL, J ) = CURR_CONC( I_CELL, J )
         ENDDO
      ENDDO

C..update current concentrations
#ifdef verbose_deg
      IF( WRITE_BLOCK )THEN
         DEGRADE_STEP = DEGRADE_STEP + 1
         WRITE(LOGDEV,'(/,A,I3)')'DEGRADE_STEP: ',DEGRADE_STEP
         WRITE(LOGDEV,'(/A18,7(1X,A18))')'S DEGRADED', 'FACTOR', 
     &   'PREV_CONC','CURR_CONC','LIFE (days)','DCONC','LOSS FREQ(1/min)'
      END IF
#endif
      LOOP_UPDATE1: DO I = 1, N_REACT
      
         I_RXT = RXTANT_MAP( I )
         IF( I_RXT < 0 )CYCLE LOOP_UPDATE1
         DO I_CELL = 1, NCELLS
            IF( -DELT_CONC( I_CELL, I_RXT ) > CONMIN .AND. CURR_CONC( I_CELL, I_RXT ) > CONMIN )THEN
              CURR_CONC( I_CELL, I_RXT  ) = MAX( (PREV_CONC( I_CELL, I_RXT  ) + DELT_CONC( I_CELL, I_RXT )),
     &                                            CONMIN )
            END IF
#ifdef verbose_deg
            IF( WRITE_CELL( I_CELL ) )THEN
                FACTOR = 1.0D0 + MIN( -1.0D0,( DELT_CONC( I_CELL,I_RXT )/PREV_CONC( I_CELL,I_RXT ) )  )
                WRITE(LOGDEV,'(A2,A16,7(1X,ES18.10))')'S ',REACT( I ), FACTOR, 
     &          PREV_CONC( I_CELL,I_RXT ),CURR_CONC( I_CELL,I_RXT ),1.15741D-5*LIFETIME( I ),
     &          DELT_CONC( I_CELL,I_RXT ), 60.0D0 / LIFETIME(I)
            END IF
#endif
         ENDDO

         IF( ANY_PRODUCTS( I ) )THEN
            LOOP_UPDATE2: DO J = 1, N_PROCESSES
               I_PROD = PROD_MAP( I, J )
               IF ( I_PROD > 0 ) THEN ! a specified product
                  DO I_CELL = 1, NCELLS
                       DELT_CONC( I_CELL, I_PROD ) = DELT_CONC( I_CELL, I_PROD )
     &                                             * MAX( PREV_CONC(I_CELL, I_RXT )-CURR_CONC( I_CELL, I_RXT ),
     &                                                    ZERO ) 
                       CURR_CONC( I_CELL, I_PROD ) = CURR_CONC( I_CELL, I_PROD )
     &                                             + RATE_YIELD( I, J ) * DELT_CONC( I_CELL, I_PROD )
                  ENDDO
               END IF
            END DO LOOP_UPDATE2
         END IF

      ENDDO LOOP_UPDATE1

      RETURN
      END SUBROUTINE DEGRADE_BLK

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header$

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%


      SUBROUTINE FINAL_DEGRADE( CBLK )
C**********************************************************************
C
C  FUNCTION: Update CBLK concentrations with concentrations from degrade
C            routines
C
C  CALLED BY: HRDRIVER
C
C  REVISION HISTORY: 07/29/05 : B.Hutzell - Initial version
C                    09/30/11 : B.Hutzell - added CYCLE statements to allow 
C                               optional degraded species i.e., RXTANT_MAP( I )
C                               is less than zero
C
C**********************************************************************


      IMPLICIT NONE

C.....ARGUMENTS:

      REAL( 8 ), INTENT( INOUT ) :: CBLK( : )    !  species concentration in cell

C.....LOCAL VARIABLES:

      REAL, PARAMETER ::  CONMIN = 1.0E-30

      INTEGER         ::  I_RXT, I_PROD   ! indices
      INTEGER         ::  I, J, K         ! loop counters

C**********************************************************************

      LOOP_REACT: DO I = 1, N_REACT ! Loop over each reactant

c..update CBLK

         I_RXT = RXTANT_MAP( I )

         IF( I_RXT <= 0 )CYCLE LOOP_REACT

         CBLK( I_RXT ) = NEW_CONC( I_RXT )

         LOOP_PROD: DO J = 1, N_PROCESSES

            I_PROD = PROD_MAP( J, I )

            IF( I_PROD < 1 ) CYCLE ! no specified product

            CBLK( I_PROD ) = NEW_CONC( I_PROD )

         ENDDO LOOP_PROD

      ENDDO LOOP_REACT

      END SUBROUTINE FINAL_DEGRADE


!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE FINAL_DEGRADE_BLK( CBLK )
C**********************************************************************
C
C  FUNCTION:  Update CBLK concentrations with concentrations from degrade
C             routines
C
C  CALLED BY: GRDRIVER or RBDRIVER
C
C  REVISION HISTORY: 07/29/05 : B.Hutzell - Initial version
C                    09/30/11 : B.Hutzell - added CYCLE statements to allow 
C                               optional degraded species i.e., RXTANT_MAP( I )
C                               is less than zero
C
C
C**********************************************************************


      IMPLICIT NONE


C.....ARGUMENTS:

      REAL( 8 ),   INTENT( INOUT ) ::  CBLK( :, : ) ! species conc in cell

C.....LOCAL VARIABLES:

      REAL, PARAMETER ::  CONMIN = 1.0E-30

      INTEGER         ::  I_RXT, I_PROD     ! indices
      INTEGER         ::  I, J, K, I_CELL   ! loop counters

C**********************************************************************

      LOOP_BLOCK: DO I_CELL = 1, NCELLS

         LOOP_REACT: DO I = 1, N_REACT  ! Loop over each reactant

c..update CBLK

            I_RXT = RXTANT_MAP( I )

            IF( I_RXT < 0 )CYCLE LOOP_REACT

            CBLK( I_CELL, I_RXT ) = CURR_CONC( I_CELL, I_RXT )

            LOOP_PROD: DO J = 1, N_PROCESSES

               I_PROD = PROD_MAP( J, I )

               IF( I_PROD < 1 ) CYCLE   ! no specified product

               CBLK( I_CELL, I_PROD ) = CURR_CONC( I_CELL, I_PROD )

            ENDDO LOOP_PROD

         ENDDO LOOP_REACT

      ENDDO LOOP_BLOCK

      END SUBROUTINE FINAL_DEGRADE_BLK

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header$

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

         SUBROUTINE FIND_DEGRADED( JDATE, JTIME, CALL_DEGRADE )

C**********************************************************************
C
C  Function:  Set Logic Flag in whether to call degradation routines
C
C  CALLED BY: HRDRIVER
C
C**********************************************************************
 

           IMPLICIT NONE
 
C.....INCLUDES: NONE

C.....ARGUMENTS:

           INTEGER, INTENT( IN )  :: JDATE        ! current model date , coded YYYYDDD
           INTEGER, INTENT( IN )  :: JTIME        ! current model time , coded HHMMSS
           LOGICAL, INTENT( OUT ) :: CALL_DEGRADE ! whether to call degradation routines

C.....LOCAL VARIABLES:

           CHARACTER( 144 )        :: XMSG                    ! Message text
           CHARACTER( 16  ), SAVE  :: PNAME = 'FIND_DEGRADED' ! Routine name

           CALL DEGRADE_DATA()

           CALL DEGRADE_MAP( JDATE, JTIME )
           
           IF( N_REACT_FOUND .GT. 0 )THEN
               CALL_DEGRADE = .TRUE.
           ELSE
               CALL_DEGRADE = .FALSE.
           ENDIF
        
           RETURN
         
         END SUBROUTINE FIND_DEGRADED

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header$

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%


      SUBROUTINE INIT_DEGRADE( CBLK, TCELL, DCELL, PRESS_CELL, QV_CELL, PHOTO_CELL,
     &                         JDATE, JTIME )
C**********************************************************************
C
C  FUNCTION:  Initialize arrays used by degrade routines then load
C             CBLK concentration needed in degrade routines.
C
C  CALLED BY: HRDRIVER
C
C  REVISION HISTORY:  07/29/05 : B.Hutzell - Initial version
C                     09/30/11 : B.Hutzell - added CYCLE statements to allow 
C                                optional degraded species i.e., RXTANT_MAP( I )
C                                is less than zero
C
C**********************************************************************

      USE RUNTIME_VARS
      USE RXNS_DATA
      USE AERO_DATA
#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX
#endif

      IMPLICIT NONE


C.....ARGUMENTS:

      REAL( 8 ), INTENT( IN ) :: CBLK( : )                 !  species concentration in cell
      REAL,      INTENT( IN ) :: TCELL                     !  cell temperature  [ k ]
      REAL,      INTENT( IN ) :: DCELL                     !  cell air density  [ kg/m^3 ]
      REAL,      INTENT( IN ) :: PRESS_CELL                !  cell Pressure  [ Pa ]
      REAL,      INTENT( IN ) :: QV_CELL                   !  cell water vapor mass mixing ratio  [ kg/kg ]
      REAL( 8 ), INTENT( IN ) :: PHOTO_CELL( : )           !  Photolysis table for cell [ 1/min ]

      INTEGER, INTENT( IN ) :: JDATE  ! current model date , coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME  ! current model time , coded HHMMSS

C.....LOCAL VARIABLES:

      CHARACTER( 144 )        :: XMSG                   ! Message text
      CHARACTER( 16  ), SAVE  :: PNAME = 'INIT_DEGRADE' ! Routine name

      REAL(8), SAVE ::  MASS_TO_NUMBER ! air mass density( Kg/m3) to number density( #/cm3 ) [ (# per moles)/Kg ]

      REAL(8), SAVE ::  CONV_M2N       ! factor to convert ppm times mass density in [kg/m^3]
                                       ! into number density in [molecules/cm^3]
                                       
      REAL(8)       ::  PPM_2_NUMBER   ! conversion factor from ppm to molecules/cm^3
      REAL(8)       ::  INV_TAIR       ! reciprocal of temperature, [K^-1]
      REAL(8)       ::  FACTOR         ! scale factor
      

      INTEGER       :: I, J, K        ! loop counters
      INTEGER, SAVE :: ISIZE          ! dimension of CBLK array
      
      LOGICAL, SAVE ::  FIRSTCALL = .TRUE. 

      REAL, PARAMETER :: MAOMW   =  MWAIR / MWWAT ! Mol Wt of air over Mol Wt of water 
      
!   Murray, F.W. 1966. ``On the computation of Saturation Vapor Pressure,'
!   J. Appl. Meteor.,  6, p. 204.
!   esw (in mb) = 6.1078exp[ a(T-273.16)/ (T-b) ], 1 mb = 100 Pa
!     SVP1 => 610.78
!     SVP2 => a and SV3 => 35.85
!     over water  
      REAL, PARAMETER :: EP_2  = RDGAS / RWVAP
      REAL, PARAMETER :: SVP1  = 610.78         ! [ Pa ]
      REAL, PARAMETER :: SVP2  = 17.2693882
      REAL, PARAMETER :: SVP3  = 35.86

      REAL( 8 ), SAVE :: COEF2   ! COEF1 time Pascal to atm conv fac

      REAL    :: ESW        ! water vapor liquid saturaturion vapor pressure (Pa)
      REAL    :: QVSW       ! water vapor saturation mixing ratio (Kg/Kg)
      REAL    :: RHUM       ! relative humidity (fraction)

      REAL    :: ORG_H2O    ! moles water in organic aeosol mass
      REAL    :: ORG_AERO   ! moles organic mass
      REAL    :: H2O_MOLAR_FRACTION ! molar fraction of water in organic aerosol mass

C**********************************************************************

      IF ( FIRSTCALL ) THEN  ! initialize constants and allocate arrays

         COEF2 =  REAL( 1.0 / STDATMPA, 8) * COEF1

         MASS_TO_NUMBER = REAL( 1.0E-3*AVO / MWAIR, 8 )
         
         CONV_M2N       = 1.0D-6 * MASS_TO_NUMBER

         ISIZE = SIZE( CBLK )
         
         ALLOCATE( OLD_CONC( ISIZE ) )
         ALLOCATE( NEW_CONC( ISIZE ) )
#ifdef sens
         ALLOCATE( SENS_CONC ( NPMAX, N_AE_SPC ) )
         SENS_CONC = 0.0
#endif
         ALLOCATE( CHANGE_CONC( ISIZE ) )
         ALLOCATE( IS_AERO_ORGANIC ( N_AEROSPC ) )
         ALLOCATE( CELL_RKI( N_PROCESSES, N_REACT ) )
         
         IS_AERO_ORGANIC( : ) = ( AEROSPC( : )%OM .AND. .NOT. AEROSPC( : )%TRACER )

         FIRSTCALL = .FALSE.

         EFFECTIVE_ZERO  = TINY( CONV_M2N )

      ENDIF

C..initialize concentrations and their changes
      CHANGE_CONC  = 0.0D0
      CELL_RKI = 0.0D0

      DO I = 1, ISIZE
         OLD_CONC( I ) = MAX( CBLK( I ), 0.0D0 )
         NEW_CONC( I ) = OLD_CONC( I )
      END DO
         

      TEMP_AIR = REAL( TCELL, 8 )
      INV_TAIR   = 1.0D0 / TEMP_AIR

!!!!  CONC_AIR  = MASS_TO_NUMBER * REAL( DCELL, 8 )
      CONC_AIR  = 1.0E6 * COEF2 * REAL( PRESS_CELL,8 ) * INV_TAIR

      CONC_N2   = ATM_N2  * CONC_AIR  
      CONC_O2   = ATM_O2  * CONC_AIR  
      CONC_CH4  = ATM_CH4 * CONC_AIR  
      CONC_H2   = ATM_H2  * CONC_AIR  
      CONC_H2O  = MAOMW   * QV_CELL * CONC_AIR  
      

!!!!  PPM_2_NUMBER  = CONV_M2N * REAL( DCELL, 8 )
      PPM_2_NUMBER = 1.0D-6 * CONC_AIR

      LOOP_REACT: DO I = 1, N_REACT ! calculated rate constants

         IF( RXTANT_MAP( I ) < 0 )CYCLE LOOP_REACT

         LOOP_UNIRATE: DO J = 1, N_UNI_LOSS
            IF( UNIRATE( J, I ) .LT. EFFECTIVE_ZERO )CYCLE
            CELL_RKI( J, I ) = UNIRATE( J, I )
     &                         * TEMP_AIR**UNI_TEXP( J, I )
     &                         * DEXP( -UNI_ACT( J, I )*INV_TAIR )
         END DO LOOP_UNIRATE

         LOOP_BIRATE: DO J = 1, N_BI_LOSS
            IF( BIRATE( J, I ) .LT. EFFECTIVE_ZERO )CYCLE
             IF ( RAD_MAP( J, I ) < 0 ) CYCLE
             SELECT CASE ( RAD_MAP( J, I ) )
               CASE ( 9999 )
                  FACTOR = CONC_AIR  
               CASE ( 9998 )
                  FACTOR = CONC_N2
               CASE ( 9997 )
                  FACTOR = CONC_O2
               CASE ( 9996 )
                  FACTOR = CONC_CH4
               CASE ( 9995 )
                  FACTOR = CONC_H2
               CASE ( 9994 )
                  FACTOR = CONC_H2O
               CASE DEFAULT
                  FACTOR = PPM_2_NUMBER 
             END SELECT 
             CELL_RKI( J+UNI_STOP, I  ) = FACTOR * BIRATE( J, I )
     &                                    * TEMP_AIR**BI_TEXP( J, I )
     &                                    * DEXP( -BI_ACT( J, I )*INV_TAIR )

         END DO LOOP_BIRATE
#ifdef verbose_deg
         WRITE(LOGDEV,'(A,6(1X,ES12.4))')'TEMP,NUMB,PRESS = ',TCELL,CONC_AIR,
     &   PRESS
         WRITE(LOGDEV,*)'BIRATES for ',REACT(I)
         DO J = 1, N_BI_LOSS
            WRITE(LOGDEV,'(I5,2(1X,ES12.4))')J+UNI_STOP,
     &      CELL_RKI( J+UNI_STOP, I  )/FACTOR, FACTOR 
         END DO
#endif


         LOOP_TRIRATE: DO J = 1, N_TRI_LOSS
            IF( TRIRATE( J, I ) .LT. EFFECTIVE_ZERO )CYCLE
             IF ( RAD2_MAP( 1, J, I ) < 0 .OR. RAD2_MAP( 2, J, I ) < 0 ) CYCLE
             SELECT CASE ( RAD2_MAP( 1, J, I ) )
               CASE ( 9999 )
                  FACTOR = CONC_AIR  
               CASE ( 9998 )
                  FACTOR = CONC_N2
               CASE ( 9997 )
                  FACTOR = CONC_O2
               CASE ( 9996 )
                  FACTOR = CONC_CH4
               CASE ( 9995 )
                  FACTOR = CONC_H2
               CASE ( 9994 )
                  FACTOR = CONC_H2O
               CASE DEFAULT
                  FACTOR = PPM_2_NUMBER 
             END SELECT 
             SELECT CASE ( RAD2_MAP( 2, J, I ) )
               CASE ( 9999 )
                  FACTOR = FACTOR * CONC_AIR  
               CASE ( 9998 )
                  FACTOR = FACTOR * CONC_N2
               CASE ( 9997 )
                  FACTOR = FACTOR * CONC_O2
               CASE ( 9996 )
                  FACTOR = FACTOR * CONC_CH4
               CASE ( 9995 )
                  FACTOR = FACTOR * CONC_H2
               CASE ( 9994 )
                  FACTOR = FACTOR * CONC_H2O
               CASE DEFAULT
                  FACTOR = FACTOR * PPM_2_NUMBER 
             END SELECT
             CELL_RKI( J+BI_STOP, I ) = FACTOR * TRIRATE( J, I )
     &                                  * TEMP_AIR**TRI_TEXP( J, I )
     &                                  * DEXP( -TRI_ACT( J, I )*INV_TAIR )
         END DO LOOP_TRIRATE

         LOOP_PHOTORATE: DO J = 1, N_PHOTO_LOSS

            K = PHOTO_MAP( J, I )
            IF ( K < 1 ) CYCLE
            IF( A_PHOTO( J, I ) .LT. EFFECTIVE_ZERO )CYCLE
            CELL_RKI( J+TRI_STOP, I ) = A_PHOTO( J, I )
     &                                  * PHOTO_CELL( K )

         END DO LOOP_PHOTORATE


         IF ( AE7ORGH2O ) THEN ! use water absorbed by organic mass
#ifdef sens
             CALL EXTRACT_AERO( REAL( CBLK( : ),4 ), .FALSE., SENS_CONC, .FALSE. )
#else
             CALL EXTRACT_AERO( REAL( CBLK( : ),4 ), .FALSE. )
#endif
             ORG_H2O  = SUM( AEROSPC_CONC( AORGH2O_IDX, 1:2 ) ) * AEROSPC_MWINV( AORGH2O_IDX )
             ORG_AERO = SUM( SUM( AEROSPC_CONC( :,1:2 ),2 ) * AEROSPC_MWINV( : ), 
     &                            MASK=IS_AERO_ORGANIC( : ) ) 
             H2O_MOLAR_FRACTION = ORG_H2O / MAX( (ORG_H2O + ORG_AERO), EFFECTIVE_ZERO )
         ELSE                  ! use relative humidity as surrogate
             ESW  = SVP1 * EXP( SVP2  * ( TCELL - STDTEMP ) / ( TCELL - SVP3  ) )
             QVSW = ( EP_2 * ESW ) / ( PRESS_CELL - ESW )
             RHUM = QV_CELL / QVSW                   
             H2O_MOLAR_FRACTION = RHUM
         END IF
         
         LOOP_LHRATE: DO J = 1, N_LANHIN_LOSS

            IF ( RAD_MAP( J + N_BI_LOSS, I ) < 0 ) CYCLE
            IF( LHRATE( J, I ) .GT. EFFECTIVE_ZERO 
     &             .AND. TCELL .GT. LH_TAMIN( J, I ) 
     &                 .AND. H2O_MOLAR_FRACTION .GT. LH_RHMIN( J, I )  )THEN
             SELECT CASE ( RAD_MAP( J + N_BI_LOSS, I ) )
               CASE ( 9999 )
                  FACTOR = CONC_AIR  
               CASE ( 9998 )
                  FACTOR = CONC_N2
               CASE ( 9997 )
                  FACTOR = CONC_O2
               CASE ( 9996 )
                  FACTOR = CONC_CH4
               CASE ( 9995 )
                  FACTOR = CONC_H2
               CASE ( 9994 )
                  FACTOR = CONC_H2O
               CASE DEFAULT
                  FACTOR = PPM_2_NUMBER 
             END SELECT 
             CELL_RKI( J+PHOTO_STOP, I ) = LH_EQU( J, I ) * FACTOR
            END IF

         END DO LOOP_LHRATE

      END DO LOOP_REACT

      RETURN

      END SUBROUTINE INIT_DEGRADE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header$

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%


      SUBROUTINE INIT_DEGRADE_BLK( CBLK, TCELL, DCELL, PRESS_CELL, H2O_CELL, PHOTO_CELL,
     &                         JDATE, JTIME )
C**********************************************************************
C
C  FUNCTION:  Initialize arrays used by degrade routines then load
C             CBLK concentration needed in degrade routines.
C
C  CALLED BY: GRDRIVER or RBDRIVER
C
C  REVISION HISTORY:  07/29/05 : B.Hutzell - Initial version
C                     09/30/11 : B.Hutzell - added CYCLE statements to allow 
C                                optional degraded species i.e., RXTANT_MAP( I )
C                                is less than zero
C
C**********************************************************************

      USE RUNTIME_VARS
      USE RXNS_DATA
      USE AERO_DATA
#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX
#endif

      IMPLICIT NONE


C.....ARGUMENTS:

      REAL( 8 ), INTENT( IN ) :: CBLK( :,: )               !  species concentration in cell
      REAL( 8 ), INTENT( IN ) :: TCELL( : )                !  cell temperature  [ k ]
      REAL( 8 ), INTENT( IN ) :: DCELL( : )                !  cell air density  [ kg/m^3 ]
      REAL( 8 ), INTENT( IN ) :: PRESS_CELL( : )           !  cell Pressure  [ atm ]
      REAL( 8 ), INTENT( IN ) :: H2O_CELL( : )             !  cell water vapor mass mixing ratio  [ ppm ]
      REAL( 8 ), INTENT( IN ) :: PHOTO_CELL( :,: )         !  Photolysis table for cell [1/min]

      INTEGER, INTENT( IN ) :: JDATE  ! current model date , coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME  ! current model time , coded HHMMSS

C.....LOCAL VARIABLES:

      CHARACTER( 144 )        :: XMSG                   ! Message text
      CHARACTER( 16  ), SAVE  :: PNAME = 'INIT_DEGRADE' ! Routine name

      REAL(8), SAVE ::  MASS_TO_NUMBER ! air mass density( Kg/m3) to number density( #/cm3 ) [ (# per moles)/Kg ]

      REAL(8), SAVE ::  CONV_M2N       ! factor to convert ppm times mass density in [kg/m^3]
                                       ! into number density in [molecules/cm^3]
                                       
      REAL(8)       ::  FACTOR         ! scale factor
      

      INTEGER       :: I, J, K        ! loop counters
      INTEGER, SAVE :: ISIZE          ! dimension of CBLK array
      
      LOGICAL, SAVE ::  FIRSTCALL = .TRUE. 

      REAL,      PARAMETER :: MAOMW     =  MWAIR / MWWAT           ! Mol Wt of air over Mol Wt of water 
      REAL( 8 ), PARAMETER :: MWOMA     =  REAL( MWWAT / MWAIR,8 ) ! Mol Wt of water over Mol Wt of air 
      REAL( 8 ), PARAMETER :: ATM_TO_PA =  REAL( STDATMPA,8 )      ! Pascals per Atmosphere

      
!   Murray, F.W. 1966. ``On the computation of Saturation Vapor Pressure,'
!   J. Appl. Meteor.,  6, p. 204.
!   esw (in mb) = 6.1078exp[ a(T-273.16)/ (T-b) ], 1 mb = 100 Pa
!     SVP1 => 610.78
!     SVP2 => a and SV3 => 35.85
!     over water  
      REAL, PARAMETER :: EP_2  = RDGAS / RWVAP
      REAL, PARAMETER :: SVP1  = 610.78         ! [ Pa ]
      REAL, PARAMETER :: SVP2  = 17.2693882
      REAL, PARAMETER :: SVP3  = 35.86

      REAL    :: ESW        ! water vapor liquid saturaturion vapor pressure (Pa)
      REAL    :: QVSW       ! water vapor saturation mixing ratio (Kg/Kg)
      REAL    :: RHUM       ! relative humidity (fraction)

      REAL    :: ORG_H2O    ! moles water in organic aeosol mass
      REAL    :: ORG_AERO   ! moles organic mass
      REAL, ALLOCATABLE, SAVE :: H2O_MOLAR_FRACTION( : ) ! molar fraction of water in organic aerosol mass
      
      INTEGER :: ICELL

C**********************************************************************

      IF ( FIRSTCALL ) THEN  ! initialize constants and allocate arrays


         MASS_TO_NUMBER = REAL( 1.0E-3*AVO / MWAIR, 8 )
         
         CONV_M2N       = 1.0D-6 * MASS_TO_NUMBER

         ALLOCATE( PREV_CONC ( BLKSIZE, NSPCSD ) )
         ALLOCATE( CURR_CONC ( BLKSIZE, NSPCSD ) )
#ifdef sens
         ALLOCATE( SENS_BLK  ( BLKSIZE, NPMAX, N_AE_SPC ) )
         SENS_BLK = 0.0
#endif
         ALLOCATE( DELT_CONC ( BLKSIZE, NSPCSD ) )
         ALLOCATE( TEMP      ( BLKSIZE ) )
         ALLOCATE( INV_TEMP  ( BLKSIZE ) )
         ALLOCATE( NUMB_DENS ( BLKSIZE ) )
         ALLOCATE( NUMB_H2O  ( BLKSIZE ) )
         ALLOCATE( CONV_FACT ( BLKSIZE ) )
         ALLOCATE( IS_AERO_ORGANIC ( N_AEROSPC ) )

         ALLOCATE( RATE_CONST( BLKSIZE, N_PROCESSES, N_REACT ) )

         ALLOCATE( H2O_MOLAR_FRACTION( BLKSIZE ) )
         
         IS_AERO_ORGANIC( : ) = ( AEROSPC( : )%OM .AND. .NOT. AEROSPC( : )%TRACER )

         INFINITY  = HUGE( CONV_M2N )
         EFFECTIVE_ZERO  = TINY( CONV_M2N )
         WRITE_CELL      = .FALSE.

         FIRSTCALL = .FALSE.
      ENDIF

C..initialize concentrations and their changes
      DELT_CONC  = 0.0D0
      RATE_CONST = 0.0D0
      DEGRADE_STEP = 0
      
      DO I = 1, NSPCSD
         PREV_CONC( :,I ) = MAX( CBLK( :,I ), 0.0D0 )
         CURR_CONC( :,I ) = PREV_CONC( :,I )
      END DO
         
      PRESS = ATM_TO_PA * PRESS_CELL

      TEMP =  REAL( TCELL, 8 )
      WHERE( TEMP .GT. 0 )
         INV_TEMP = 1.0D0 / TEMP
      ELSE WHERE
         INV_TEMP = 0.0D0
      END WHERE

      NUMB_DENS = 1.0E6 * COEF1 * REAL( PRESS_CELL,8 ) * INV_TEMP
      NUMB_H2O  = 1.0D-6 * H2O_CELL * NUMB_DENS
      CONV_FACT = 1.0D-6 * NUMB_DENS
      
      

      LOOP_REACT: DO I = 1, N_REACT ! calculated rate constants

         IF( RXTANT_MAP( I ) < 0 )CYCLE LOOP_REACT

#ifdef verbose_deg
         WRITE(LOGDEV,'(2A)')'DEGRADED SPECIES: ',TRIM( REACT(I) )
#endif

         LOOP_UNIRATE: DO J = 1, N_UNI_LOSS
            IF( UNIRATE( J, I ) .LT. EFFECTIVE_ZERO )CYCLE
            LOOP_CELL: DO ICELL = 1, NCELLS
               RATE_CONST( ICELL, J, I ) = UNIRATE( J, I )
     &                                   * TEMP( ICELL )**UNI_TEXP( J, I )
     &                                   * DEXP( -UNI_ACT( J, I )*INV_TEMP( ICELL ) )
            END DO LOOP_CELL
         END DO LOOP_UNIRATE
#ifdef verbose_deg
         IF( WRITE_BLOCK )THEN
            WRITE(LOGDEV,'(A,6(1X,ES12.4))')'TEMP,NUMB,PRESS = ',TCELL(ICELL_WRITE),NUMB_DENS(ICELL_WRITE),
     &      PRESS(ICELL_WRITE)
            WRITE(LOGDEV,*)'UNIRATES for ',REACT(I)
            DO J = 1, N_UNI_LOSS
               WRITE(LOGDEV,'(I5,1X,ES12.4)')J,RATE_CONST( ICELL_WRITE, J, I  )
            END DO
         END IF
#endif

         LOOP_BIRATE: DO J = 1, N_BI_LOSS
            IF( BIRATE( J, I ) .LT. EFFECTIVE_ZERO )CYCLE
             IF ( RAD_MAP( J, I ) < 0 ) CYCLE
             SELECT CASE ( RAD_MAP( J, I ) )
               CASE ( 9999 )
                  FACTOR = ATM_AIR 
               CASE ( 9998 )
                  FACTOR = ATM_N2
               CASE ( 9997 )
                  FACTOR = ATM_O2
               CASE ( 9996 )
                  FACTOR = ATM_CH4
               CASE ( 9995 )
                  FACTOR = ATM_H2
               CASE DEFAULT
                  FACTOR = 1.0D0 
             END SELECT 
             IF ( RAD_MAP( J, I ) .EQ. 9994 ) THEN
                DO ICELL = 1, NCELLS
                   RATE_CONST( ICELL, J+UNI_STOP, I  ) = NUMB_H2O( ICELL ) * BIRATE( J, I )
     &                                                 * TEMP( ICELL )**BI_TEXP( J, I )
     &                                                 * DEXP( -BI_ACT( J, I )*INV_TEMP( ICELL ) )
                END DO
             ELSE
                DO ICELL = 1, NCELLS
                   RATE_CONST( ICELL, J+UNI_STOP, I  ) = FACTOR * CONV_FACT( ICELL ) * BIRATE( J, I )
     &                                                 * TEMP( ICELL )**BI_TEXP( J, I )
     &                                                 * DEXP( -BI_ACT( J, I )*INV_TEMP( ICELL ) )
                END DO      
             END IF
         END DO LOOP_BIRATE
#ifdef verbose_deg
         IF( WRITE_BLOCK )THEN
            WRITE(LOGDEV,'(A,6(1X,ES12.4))')'TEMP,NUMB,PRESS = ',TCELL(ICELL_WRITE),NUMB_DENS(ICELL_WRITE),
     &      PRESS(ICELL_WRITE)
            WRITE(LOGDEV,*)'BIRATES for ',REACT(I)
            DO J = 1, N_BI_LOSS
               WRITE(LOGDEV,'(I5,2(1X,ES12.4))')J+UNI_STOP,
     &         RATE_CONST( ICELL_WRITE, J+UNI_STOP, I  )/( FACTOR * CONV_FACT( ICELL_WRITE ) ),
     &         FACTOR * CONV_FACT( ICELL_WRITE )
            END DO
         END IF
#endif

         LOOP_TRIRATE: DO J = 1, N_TRI_LOSS
            IF( TRIRATE( J, I ) .LT. EFFECTIVE_ZERO )CYCLE
             IF ( RAD2_MAP( 1, J, I ) < 0 .OR. RAD2_MAP( 2, J, I ) < 0 ) CYCLE
             SELECT CASE ( RAD2_MAP( 1, J, I ) )
               CASE ( 9999 )
                  FACTOR = ATM_AIR
               CASE ( 9998 )
                  FACTOR = ATM_N2
               CASE ( 9997 )
                  FACTOR = ATM_O2
               CASE ( 9996 )
                  FACTOR = ATM_CH4
               CASE ( 9995 )
                  FACTOR = ATM_H2
               CASE DEFAULT
                  FACTOR = 1.0D0
             END SELECT
             SELECT CASE ( RAD2_MAP( 2, J, I ) )
               CASE ( 9999 )
                  FACTOR = FACTOR * ATM_AIR
               CASE ( 9998 )
                  FACTOR = FACTOR * ATM_N2
               CASE ( 9997 )
                  FACTOR = FACTOR * ATM_O2
               CASE ( 9996 )
                  FACTOR = FACTOR * ATM_CH4
               CASE ( 9995 )
                  FACTOR = FACTOR * ATM_H2
               CASE DEFAULT
                  FACTOR = FACTOR 
             END SELECT
             IF ( RAD2_MAP( 1, J, I ) .EQ. 9994 .AND. RAD2_MAP( 2, J, I ) .NE. 9994 ) THEN
                DO ICELL = 1, NCELLS
                   RATE_CONST( ICELL, J+BI_STOP, I ) = FACTOR * TRIRATE( J, I )
     &                                               * NUMB_H2O( ICELL ) * CONV_FACT( ICELL )           
     &                                               * TEMP( ICELL )**TRI_TEXP( J, I )
     &                                               * DEXP( -TRI_ACT( J, I )*INV_TEMP( ICELL ) )
                END DO
             ELSE IF  ( RAD2_MAP( 1, J, I ) .NE. 9994 .AND. RAD2_MAP( 2, J, I ) .EQ. 9994 ) THEN
                DO ICELL = 1, NCELLS
                   RATE_CONST( ICELL, J+BI_STOP, I ) = FACTOR * TRIRATE( J, I )
     &                                               * NUMB_H2O( ICELL ) * CONV_FACT( ICELL )           
     &                                               * TEMP( ICELL )**TRI_TEXP( J, I )
     &                                               * DEXP( -TRI_ACT( J, I )*INV_TEMP( ICELL ) )
                END DO
             ELSE IF  ( RAD2_MAP( 1, J, I ) .EQ. 9994 .AND. RAD2_MAP( 2, J, I ) .EQ. 9994 ) THEN
                DO ICELL = 1, NCELLS
                   RATE_CONST( ICELL, J+BI_STOP, I ) = TRIRATE( J, I )
     &                                               * NUMB_H2O( ICELL ) * NUMB_H2O( ICELL )           
     &                                               * TEMP( ICELL )**TRI_TEXP( J, I )
     &                                               * DEXP( -TRI_ACT( J, I )*INV_TEMP( ICELL ) )
                END DO
             ELSE
                DO ICELL = 1, NCELLS
                   RATE_CONST( ICELL, J+BI_STOP, I ) = FACTOR * TRIRATE( J, I )
     &                                               * CONV_FACT( ICELL ) * CONV_FACT( ICELL )           
     &                                               * TEMP( ICELL )**TRI_TEXP( J, I )
     &                                               * DEXP( -TRI_ACT( J, I )*INV_TEMP( ICELL ) )
                END DO
             END IF
         END DO LOOP_TRIRATE
#ifdef verbose_deg
         IF( WRITE_BLOCK )THEN
            WRITE(LOGDEV,'(A,6(1X,ES12.4))')'TEMP,NUMB,PRESS = ',TCELL(ICELL_WRITE),NUMB_DENS(ICELL_WRITE),
     &      PRESS(ICELL_WRITE)
            WRITE(LOGDEV,*)'TRI_RATES for ',REACT(I)
            DO J = 1, N_TRI_LOSS
               WRITE(LOGDEV,'(I5,1X,ES12.4)')J+BI_STOP,RATE_CONST( ICELL_WRITE, J+BI_STOP, I  )
     &         /(FACTOR*CONV_FACT( ICELL_WRITE ))
            END DO
         END IF
#endif

         LOOP_PHOTORATE: DO J = 1, N_PHOTO_LOSS

            K = PHOTO_MAP( J, I )
            IF ( K < 1 ) CYCLE
            IF( A_PHOTO( J, I ) .LT. EFFECTIVE_ZERO )CYCLE
            DO ICELL = 1, NCELLS
!              RATE_CONST( ICELL, J+TRI_STOP, I ) = 60.0D0 * A_PHOTO( J, I )
               RATE_CONST( ICELL, J+TRI_STOP, I ) = A_PHOTO( J, I )
     &                                            * PHOTO_CELL( ICELL, K )
            END DO

         END DO LOOP_PHOTORATE
#ifdef verbose_deg
         IF( WRITE_BLOCK )THEN
            WRITE(LOGDEV,'(A,6(1X,ES12.4))')'TEMP,NUMB,PRESS = ',TCELL(ICELL_WRITE),NUMB_DENS(ICELL_WRITE),
     &      PRESS(ICELL_WRITE)
            WRITE(LOGDEV,*)'PHOTO_RATES for ',REACT(I)
            DO J = 1, N_PHOTO_LOSS
               WRITE(LOGDEV,'(I5,1X,ES12.4)')J+TRI_STOP,RATE_CONST( ICELL_WRITE,J+TRI_STOP, I  )
            END DO
         END IF
#endif



         IF ( AE7ORGH2O ) THEN ! use water absorbed by organic mass
             DO ICELL = 1, NCELLS
#ifdef sens
                CALL EXTRACT_AERO( REAL( CBLK( ICELL,: ),4 ), .FALSE., SENS_BLK(ICELL,:,:), .FALSE.)
#else
 
                CALL EXTRACT_AERO( REAL( CBLK(ICELL,: ),4 ), .FALSE. )
#endif
                ORG_H2O  = SUM( AEROSPC_CONC( AORGH2O_IDX, 1:2 ) ) * AEROSPC_MWINV( AORGH2O_IDX )
                ORG_AERO = SUM( SUM( AEROSPC_CONC( :,1:2 ),2 ) * AEROSPC_MWINV( : ),
     &                          MASK=IS_AERO_ORGANIC( : ) )
                H2O_MOLAR_FRACTION( ICELL ) = ORG_H2O 
     &                                      / MAX( (ORG_H2O + ORG_AERO), EFFECTIVE_ZERO )
#ifdef verbose_deg
                IF( ICELL .EQ. ICELL_WRITE )THEN
                  WRITE(LOGDEV,'(A,6(1X,ES12.4))')'ORG_H2O, ORG_H2O,H2O_MOLAR_FRACTION = ',  
     &            ORG_H2O, ORG_H2O,H2O_MOLAR_FRACTION(ICELL)                    
                END IF 
#endif
             END DO
         ELSE                  ! use relative humidity as surrogate
             DO ICELL = 1, NCELLS
                ESW  = SVP1 * EXP( SVP2  * ( TEMP( ICELL ) - STDTEMP ) / ( TEMP( ICELL ) - SVP3  ) )
                QVSW = ( EP_2 * ESW ) / ( PRESS( ICELL ) - ESW )
                RHUM = ( 1.0D-6 * MWOMA * H2O_CELL( ICELL ) ) / QVSW                   
                H2O_MOLAR_FRACTION( ICELL ) = RHUM
             END DO             
         END IF
         
         LOOP_LHRATE: DO J = 1, N_LANHIN_LOSS

            IF ( RAD_MAP( J + N_BI_LOSS, I ) < 0 ) CYCLE
            IF( LHRATE( J, I ) .GT. EFFECTIVE_ZERO )THEN
               DO ICELL = 1, NCELLS
                  IF ( TCELL( ICELL ) .GT. LH_TAMIN( J, I ) 
     &                    .AND. H2O_MOLAR_FRACTION( ICELL ) .GT. LH_RHMIN( J, I )  ) THEN
                     SELECT CASE ( RAD_MAP( J, I ) )
                       CASE ( 9999 )
                          FACTOR = ATM_AIR
                       CASE ( 9998 )
                          FACTOR = ATM_N2
                       CASE ( 9997 )
                          FACTOR = ATM_O2
                       CASE ( 9996 )
                         FACTOR = ATM_CH4
                       CASE ( 9995 )
                         FACTOR = ATM_H2
                       CASE DEFAULT
                         FACTOR = 1.0D0 
                     END SELECT 
                     IF ( RAD_MAP( J, I ) .EQ. 9994 ) THEN
                        RATE_CONST( ICELL, J+PHOTO_STOP, I  ) = NUMB_H2O( ICELL ) * LH_EQU( J, I )
                     ELSE
                        RATE_CONST( ICELL, J+PHOTO_STOP, I  ) = FACTOR * CONV_FACT( ICELL ) * LH_EQU( J, I )
                     END IF
                  END IF                  
               END DO 
            END IF

         END DO LOOP_LHRATE
#ifdef verbose_deg
         IF( WRITE_BLOCK )THEN
            WRITE(LOGDEV,'(A,6(1X,ES12.4))')'TEMP,NUMB,PRESS,H2O = ',TCELL(ICELL_WRITE),NUMB_DENS(ICELL_WRITE),
     &      PRESS(ICELL_WRITE),NUMB_H2O(ICELL_WRITE)
            WRITE(LOGDEV,'(2A)')'LH_RATES for ',REACT(I)
            DO J = 1, N_LANHIN_LOSS
               WRITE(LOGDEV,'(A,1X,I3,6(1X,ES12.4))')'LH_RCONST:', J+PHOTO_STOP,RATE_CONST( ICELL_WRITE, J+PHOTO_STOP, I  )
     &         / (FACTOR * CONV_FACT( ICELL_WRITE  ))
            END DO
         END IF
#endif

      END DO LOOP_REACT

      RETURN

      END SUBROUTINE INIT_DEGRADE_BLK

      END MODULE DEGRADE_ROUTINES

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine aero_sedv ( col, row, cgrd, vsed_ae )

C-----------------------------------------------------------------------
C Get accum. and coarse mode grav. settling vel
C used Binkowski`s aerosol dry deposition routine as a guide
C 08 Feb 13 J.Young: initial
C 20 Jun 14 J.Young: restructure
C 22 Oct 14 J.Bash:  replaced P0 with STDATMPA from CONST.EXT and shared 
C                    variables in the asx_data_mod
C May 2015 B. Murphy, H. Pye: Updated treatment of aerosol moments
C-----------------------------------------------------------------------

      use grid_conf           ! horizontal & vertical domain specifications
      use cgrid_spcs          ! CGRID mechanism species
      use utilio_defn      
      use asx_data_mod, Only: Met_Data
      use aero_data           ! aero variable data
      use aeromet_data
      use const, only: stdatmpa, grav        

      implicit none

C Includes:

C Arguments
      integer, intent( in )  :: col, row
      real,    intent( in )  :: cgrd( :,: )     ! cgrid subsection (layers,species)
      real,    intent( out ) :: vsed_ae( :,: )  ! settling velocities [ m/s ]

C Parameters
      real,    parameter :: t0 = 288.15      ! [ K ] ! starting standard surface temp.
      real,    parameter :: two3 = 2.0 / 3.0
      integer, parameter :: n_ae_sed_spc = 6 ! no. of surrogates for aero settling velocities

C set up species indices for settling velocity internal array vsed
      integer, parameter :: vgnacc = 1,  ! accumulation mode number
     &                      vgncor = 2,  ! coarse mode number
     &                      vgsacc = 3,  ! accumulation mode surface area
     &                      vgscor = 4,  ! coarse mode surface area
     &                      vgmacc = 5,  ! accumulation mode mass
     &                      vgmcor = 6   ! coarse mode mass

C Local variables:

C follow the Namelist dep vel surrogate name table
      character( 16 ) :: vgae_name( n_ae_sed_spc ) = ! grav. settling vel surrogate table
     &                (/ 'VNUMACC',
     &                   'VNUMCOR',
     &                   'VSRFACC',
     &                   'VSRFCOR',
     &                   'VMASSJ ',
     &                   'VMASSC ' /)

      integer, allocatable, save :: sedi_sur( : )   ! pointer to surrogate

      real, allocatable, save :: xxlsgac( : )   ! log of stnd dev
      real, allocatable, save :: xxlsgco( : )
      real, allocatable, save :: dgacc  ( : )   ! geometric mean diameter
      real, allocatable, save :: dgcor  ( : )
      real, allocatable, save :: pdensac( : )   ! particle density
      real, allocatable, save :: pdensco( : )

      real, allocatable, save :: xlm    ( : )   ! mean free path [ m ]
      real, allocatable, save :: amu    ( : )   ! dynamic viscosity [ kg/m/s ]

      real, allocatable, save :: vsed   ( :,: ) ! grav settling velocity [ m/s ]

      real m2_wet, m2_dry
      real m3_wet, m3subt, m3_dry

      logical, save :: firstime = .true.
      character( 16 ), save :: pname = 'AERO_SEDI'
      character( 16 ) :: vname                  ! variable name
      character( 96 ) :: xmsg = ' '

      integer  l, v, n, j      ! loop counters
      integer  spc, s          ! species loop counter
      integer  astat

      integer :: jdate = 0, jtime = 0

      interface
        subroutine get_sedv ( xlm, amu,
     &                        dgacc, dgcor,
     &                        xxlsgac, xxlsgco,
     &                        pdensac, pdensco,
     &                        vsed )
          real, intent( in ) :: xlm    ( : )  ! atmos mean free path [ m ]
          real, intent( in ) :: amu    ( : )  ! atmos dynamic viscosity [ kg/(m s) ]
          real, intent( in ) :: dgacc  ( : )  ! accum mode geom mean diameter [ m ]
          real, intent( in ) :: dgcor  ( : )  ! coarse mode geom mean diameter  [ m ]
          real, intent( in ) :: xxlsgac( : )  ! accum mode log of stnd dev
          real, intent( in ) :: xxlsgco( : )  ! coarse mode
          real, intent( in ) :: pdensac( : )  ! avg particle density in accum mode
          real, intent( in ) :: pdensco( : )  ! avg particle density in coarse mode
          real, intent( out ) :: vsed  ( :,: ) ! settling velocity [ m/s ]
        end subroutine get_sedv
      end interface

c-----------------------------------------------------------------------

      if ( firstime ) then
         firstime = .false.

C  Allocate arrays
         allocate( xxlsgac( nlays ),
     &             xxlsgco( nlays ),
     &             dgacc  ( nlays ),
     &             dgcor  ( nlays ),
     &             pdensac( nlays ),
     &             pdensco( nlays ),
     &             xlm    ( nlays ),
     &             amu    ( nlays ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating'
     &           //  ' xxlsgac, xxlsgco,'
     &           //  ' dgacc, dgcor,'
     &           //  ' pdensac, pdensco,'
     &           //  ' xlm, or amu'
            call m3exit( pname, jdate, jtime, xmsg, xstat1 )
         end if

         allocate( vsed( nlays,n_ae_spc), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating vsed'
            call m3exit( pname, jdate, jtime, xmsg, xstat1 )
         end if

         allocate( sedi_sur( n_ae_spc ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating sedi_sur'
            call m3exit( pname, jdate, jtime, xmsg, xstat1 )
         end if

C Set the settling vel surrogate pointers according to the depv table
         j = 0
         do v = 1, n_ae_depv   ! assume n_ae_spc = n_ae_depv
            n = index1( ae_depv( v ), n_ae_sed_spc, vgae_name )
            if ( n .ne. 0 ) then
               j = j + 1
               sedi_sur( v ) = n
            else
               write( logdev,* ) ' surrogate ', trim( ae_depv( v ) ),
     &                           ' not used for', v, trim( ae_spc( v ) )
               sedi_sur( v ) = 0
            end if
         end do
         n = j

         write( logdev,* ) n, ' Aerosol species with a grav. settling vel'
         do j = 1, n_ae_spc
            n = sedi_sur( j )
            if ( n .ne. 0 ) write( logdev,'( i3, 2x, a9, i3, 2x, a )' )
     &                             j, ae_spc( j ), n, trim( ae_depv( j ) )
         end do

      end if    ! firstime      

      do l = 1, nlays

C Set meteorological data for the grid cell.
         airtemp = Met_Data%ta  ( col,row,l )
         airpres = Met_Data%pres( col,row,l )

C extract grid cell concentrations of aero species from CGRID
C into aerospc_conc in aero_data module
C Also converts dry surface area to wet 2nd moment
#ifdef sens
         call extract_aero( cgrd( l,: ), .true., cgrd( :,: ), .false. )
#else
         call extract_aero( cgrd( l,: ), .true. )  ! set minimum floor
#endif

C Get the geometric mean diameters and standard deviations of the
C "wet" size distribution
         call getpar( .false. )     
C                        | do not fix stnd dev`s to existing value

C Save getpar values to arrays
         xxlsgac( l ) = aeromode_lnsg( 2 )
         xxlsgco( l ) = aeromode_lnsg( 3 )

         dgacc( l )   = aeromode_diam( 2 )
         dgcor( l )   = aeromode_diam( 3 )

         pdensac( l ) = aeromode_dens( 2 )
         pdensco( l ) = aeromode_dens( 3 )
 
C Calculate mean free path [ m ]:
         xlm( l ) = 6.6328e-8 * STDATMPA * airtemp / ( t0 * airpres )

C Calculate dynamic viscosity [ kg/m/s ]:
         amu( l ) = 1.458e-6 * airtemp * sqrt( airtemp ) / ( airtemp + 110.4 )

      end do ! layer loop

C get settling velocities:
      call get_sedv ( xlm, amu,
     &                dgacc, dgcor,
     &                xxlsgac, xxlsgco,
     &                pdensac, pdensco,
     &                vsed )

C Return sedimentation velocities for aerosols and cfl-safe iteration count

C "Stores read an entire cache line, modify the target, then write back the
C  entire line. Thus, non-consecutive stores are worse than non-consecutive
C  loads."

      do l = 1, nlays
         do v = 1, n_ae_spc
            if ( sedi_sur( v ) .gt. 0 ) then
               vsed_ae( v,l ) = vsed( l,sedi_sur( v ) )
            else
               vsed_ae( v,l ) = 0.0
            end if
         end do
      end do

      return
      end subroutine aero_sedv

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine get_sedv ( xlm, amu,
     &                      dgacc, dgcor,
     &                      xxlsgac, xxlsgco,
     &                      pdensac, pdensco,
     &                      vsed )

C Calculate settling velocity for Aitken, accumulation, and coarse modes.
C-----------------------------------------------------------------------

      use asx_data_mod, Only: Met_Data
      use aeromet_data   
      use const, only: grav

      implicit none

C *** arguments

      real, intent( in ) :: xlm    ( : )  ! atmospheric mean free path [m]
      real, intent( in ) :: amu    ( : )  ! atmospheric dynamic viscosity [kg/(m s)]
      real, intent( in ) :: dgacc  ( : )  ! accum mode geom mean diameter [m]
      real, intent( in ) :: dgcor  ( : )  ! coarse mode geom mean diameter [m]
      real, intent( in ) :: xxlsgac( : )  ! accum mode log of modal geom stnd dev`s
      real, intent( in ) :: xxlsgco( : )  ! coarse mode log of modal geom stnd dev`s
      real, intent( in ) :: pdensac( : )  ! avg particle dens in accum mode [kg/m**3]
      real, intent( in ) :: pdensco( : )  ! avg particle dens in coarse mode [kg/m**3]
      real, intent( out ) :: vsed  ( :,: )  ! grav settling velocity [ m/s ]

C *** array indices hardcoded to match SUBROUTINE aero_sedi
      integer, parameter :: vgnacc = 1,  ! accumulation mode number
     &                      vgncor = 2,  ! coarse mode number
     &                      vgsacc = 3,  ! accumulation mode surface area
     &                      vgscor = 4,  ! coarse mode surface area
     &                      vgmacc = 5,  ! accumulation mode mass
     &                      vgmcor = 6   ! coarse mode mass

C modal Knudsen numbers X bhat
      real bknacc   ! accumulation mode 
      real bkncor   ! coarse mode

C modal sedimentation velocities for 0th (number), 2nd (srf area), and 3rd (mass) moments
      real vghat0a, vghat0c
      real vghat2a, vghat2c
      real vghat3a, vghat3c

      integer l

      real    dconst2, dconst3a, dconst3c
      real    bxlm

 !    real, parameter :: bhat    = 1.246 ! Constant from Cunningham slip correction
      real, parameter :: bhat    = 2.492 ! 2 X Constant from Cunningham slip correction

C Scalar variables for VARIABLE standard deviations.

      real    l2sgac, l2sgco   ! log^2( sigmag )

      real    esac01           ! accumu mode " ** 4
      real    esco01           ! coarse      "

      real    esac02           ! accumu mode " ** 8
      real    esco02           ! coarse      "

      real    esac04           ! accumu mode " ** 16
      real    esco04           ! coarse      "

      real    esac05           ! accumu mode " ** 20
      real    esco05           ! coarse      "

      real    esac07           ! accumu mode " ** 28
      real    esco07           ! coarse      "

      real    esac12           ! accumu mode " ** 48    
      real    esco12           ! coarse      "     

      real    esac16           ! accumu mode " ** 64
      real    esco16           ! coarse      "

C-----------------------------------------------------------------------

      do l = 1, size( met_data%ta, 3 )

C Calculate Knudsen numbers * bhat
         bxlm = bhat * xlm( l )
         bknacc = bxlm / dgacc( l )
         bkncor = bxlm / dgcor( l )

C Calculate functions of variable standard deviation.
         l2sgac = xxlsgac( l ) * xxlsgac( l )
         l2sgco = xxlsgco( l ) * xxlsgco( l )

         esac01  = exp( 0.5 * l2sgac )
         esco01  = exp( 0.5 * l2sgco )

         esac02  = esac01 * esac01
         esco02  = esco01 * esco01

         esac04  = esac02 * esac02
         esco04  = esco02 * esco02

         esac05  = esac04 * esac01
         esco05  = esco04 * esco01

         esac07  = esac05 * esac02
         esco07  = esco05 * esco02

         esac12  = esac07 * esac05
         esco12  = esco07 * esco05

         esac16  = esac12 * esac04
         esco16  = esco12 * esco04

         dconst2  = grav / ( 18.0 * amu( l ) )
         dconst3a = dconst2 * pdensac( l ) * dgacc( l ) * dgacc( l )
         dconst3c = dconst2 * pdensco( l ) * dgcor( l ) * dgcor( l )

c acc mode
         vghat0a  = dconst3a * ( esac04  + bknacc * esac01 )
         vghat2a  = dconst3a * ( esac12  + bknacc * esac05 )
         vghat3a  = dconst3a * ( esac16  + bknacc * esac07 )

c coarse mode
         vghat0c  = dconst3c * ( esco04  + bkncor * esco01 )
         vghat2c  = dconst3c * ( esco12  + bkncor * esco05 )
         vghat3c  = dconst3c * ( esco16  + bkncor * esco07 )

C settling velocities

C vsed of 0th moment for the number 
         vsed( l,vgnacc ) = vghat0a   ! accum mode
         vsed( l,vgncor ) = vghat0c   ! coarse mode

c vsed of 2nd moment for the surface area 
         vsed( l,vgsacc ) = vghat2a   ! accum mode
         vsed( l,vgscor ) = vghat2c   ! coarse mode

c vsed of 3rd moment for the mass 
         vsed( l,vgmacc ) = vghat3a   ! accum mode
         vsed( l,vgmcor ) = vghat3c   ! coarse mode

      end do ! end loop on l

      return
      end subroutine get_sedv

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/PARIO/src/pshut3.f,v 1.2 2011/03/30 18:13:05 sjr Exp $ 

        LOGICAL FUNCTION  PSHUT3 ( )

C***********************************************************************
C  FUNCTION:  Flushes and closes down all Models-3 files currently open by
C             PE 0 only.
C
C  RETURN VALUE:  TRUE iff it succeeds.
C
C  PRECONDITIONS:  none
C
C  SUBROUTINES AND FUNCTIONS CALLED:
C
C  REVISION  HISTORY:  
C       prototype 09/02 by David Wong
C       Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with M3UTILIO
C       Modified 09/10/2014 by David Wong
C          -- Removed redundant INCLUDE NETCDF.EXT statement
C       Modified 12/09/2015 by David Wong
C          -- Introduced a new variable PARIO_IO_PE_INCLUSIVE to determine
C             which procesor involves in file closing process
C***********************************************************************

      USE M3UTILIO              ! i/o api
      USE PIOMAPS_MODULE

      IMPLICIT NONE

C...........   INCLUDES:

        INCLUDE 'STATE3.EXT'
        INCLUDE 'PIOVARS.EXT'
        INCLUDE "mpif.h"

C...........   SCRATCH LOCAL VARIABLES and their descriptions:

        INTEGER         FILE            !  loop counter over files
        INTEGER         V               !  loop counter over vbles
        INTEGER         IERR            !  netCDF error status return
        INTEGER         ERROR           !  MPI error status return
        INTEGER         FID
        INTEGER         LOC_MPIGRD3

        INTEGER, EXTERNAL :: NF_CLOSE
        INTEGER, EXTERNAL :: NFMPI_CLOSE

C***********************************************************************

        PSHUT3 = .TRUE.
        IF (.NOT. FINIT3) THEN
            RETURN
        END IF

#ifdef parallel_io
        LOC_MPIGRD3 = MPIGRD3
#else
        LOC_MPIGRD3 = IMISS3
#endif

        DO FILE = 1, COUNT3

           FID = CDFID3(FILE)

           IF ((FID .GE. 0) .AND. (FLIST3(FILE) .NE. CMISS3)) THEN

!             IF (MY_PE .EQ. 0) THEN
!                CALL NCCLOS( CDFID3( FILE ), IERR )
!                IF (IERR .NE. 0) THEN
!                   WRITE (LOGDEV,91010)
!    &                     'Error closing netCDF file ',
!    &                     'File name:  ' // FLIST3( FILE ) ,
!    &                     'netCDF error number', IERR
!                   PSHUT3 = .FALSE.
!                END IF
!             END IF

              IF( FTYPE3( FILE ) .EQ. LOC_MPIGRD3 ) THEN

#ifdef parallel_io
                 IF( PARIO_IO_PE_INCLUSIVE ) THEN
                   IERR =  NFMPI_CLOSE( FID )
                   IF ( IERR .NE. 0 ) THEN
                       WRITE( LOGDEV,91010 )
     &                 'Error closing PnetCDF file ',
     &                 'File name:  ' // FLIST3( FILE ) ,
     &                 'PnetCDF error number', IERR
                       PSHUT3 = .FALSE.
                   END IF
                 END IF
#endif

              ELSE IF( FTYPE3( FILE ) .GE. 0 ) THEN

                   IERR =  NF_CLOSE( FID )
                   IF ( IERR .NE. 0 ) THEN
                       WRITE( LOGDEV,91010 )
     &                 'Error closing netCDF file ',
     &                 'File name:  ' // FLIST3( FILE ) ,
     &                 'netCDF error number', IERR
                       PSHUT3 = .FALSE.
                   END IF
              END IF
           END IF

           CALL BUFDEL3 (FILE)
           FLIST3(FILE) = CMISS3
           DO V = 1, NVARS3( FILE )
              ILAST3(V,FILE) = IMISS3
              LDATE3(V,FILE) = IMISS3
              LTIME3(V,FILE) = IMISS3
              NDATE3(V,FILE) = IMISS3
              NTIME3(V,FILE) = IMISS3
           END DO

        END DO      !  end loop on files

        COUNT3 = IMISS3
        FINIT3 = .FALSE.

        CALL MPI_BCAST (PSHUT3, 1, MPI_LOGICAL, 0 ,MPI_COMM_WORLD, ERROR)

        RETURN

C******************  FORMAT  STATEMENTS   ******************************

C...........   Error and warning message formats..... 91xxx

91010   FORMAT ( //5X , '>>> WARNING in subroutine SHUT3 <<<',
     &            3 ( /5X , A , : ) , I5, // )

        END FUNCTION PSHUT3

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE STK_PRMS

C-----------------------------------------------------------------------
C Function: stack parameters from stack groups file

C Revision History:
C     29 Dec 2006 J.Young: initial implementation
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C      3 Nov 2011 D.Wong: fix source location within grid determination bug
C     30 Apr 2016 J.Young: add multiple fire source capability, in affiliation with
C                          Yongtao Hu (Georgia Tech)
C     01 Feb 2019 D.Wong: Implemented centralized I/O approach and moved some of
C                         data declaration in this module to stack_group_data_module 
C                         (model_data_module.f) to avoid cyclic dependence
C-----------------------------------------------------------------------

      USE UDTYPES, ONLY: IARRY1, RARRY1

      IMPLICIT NONE

      INTEGER,        ALLOCATABLE, SAVE :: MY_NSRC( : )

      TYPE( IARRY1 ), ALLOCATABLE, SAVE :: SOURCE     ( : ) ! my stack source index
      TYPE( IARRY1 ), ALLOCATABLE, SAVE :: MY_STKCOL  ( : )
      TYPE( IARRY1 ), ALLOCATABLE, SAVE :: MY_STKROW  ( : )
      TYPE( IARRY1 ), ALLOCATABLE, SAVE :: MY_STKID   ( : )
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: MY_XLOCA   ( : ) ! X-location [grid coord]
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: MY_YLOCA   ( : ) ! Y-location [grid coord]
      INTEGER,        ALLOCATABLE, SAVE :: MY_STRT_SRC( : )
      INTEGER,        ALLOCATABLE, SAVE :: MY_END_SRC ( : )
      REAL, ALLOCATABLE, SAVE :: MY_STKBUFF( : )
      INTEGER, ALLOCATABLE, SAVE :: MY_COLBUFF( : )
      INTEGER, ALLOCATABLE, SAVE :: MY_ROWBUFF( : )

      integer, allocatable :: my_nsrc_index(:,:)       ! point source location in the file belong to a processor
      integer, allocatable :: my_nsrc_mesh_index(:,:)  ! point source position w.r.t. sub-domain mesh point sequence
      real, allocatable :: my_nsrc_pressure(:,:,:)

      CONTAINS

         FUNCTION STK_PRMS_INIT ( STKPRMS ) RESULT ( SUCCESS )

         USE HGRD_DEFN             ! horizontal domain specifications
         USE UTILIO_DEFN
         USE stack_group_data_module
         USE RUNTIME_VARS

         IMPLICIT NONE

         CHARACTER( 16 ), INTENT( IN ) :: STKPRMS( : )   ! stack groups file names
         LOGICAL SUCCESS

         INTEGER, ALLOCATABLE :: LOC_MAP( : )

         INTEGER SCOL, ECOL, SROW, EROW
         INTEGER C, R, STRT_SRC, END_SRC, MY_DELTA, N, NGRPS
         REAL    X, Y

         INTEGER M, S, SRC, V, ASTAT
         CHARACTER( 300 ) :: XMSG = ' '
         CHARACTER( 16 ) :: PNAME = 'STK_PRMS_INIT'

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

         NGRPS = SIZE( STKPRMS )

         ALLOCATE ( MY_NSRC( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_NSRC', PNAME )

         ALLOCATE ( SOURCE( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'SOURCE', PNAME )

         ALLOCATE ( MY_STKCOL( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_STKCOL', PNAME )

         ALLOCATE ( MY_STKROW( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_STKROW', PNAME )

         ALLOCATE ( MY_STKID( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_STKID', PNAME )

         ALLOCATE ( MY_XLOCA( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_XLOCA', PNAME )

         ALLOCATE ( MY_YLOCA( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_YLOCA', PNAME )

         ALLOCATE ( MY_STRT_SRC( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_STRT_SRC', PNAME )

         ALLOCATE ( MY_END_SRC( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_END_SRC', PNAME )

         ALLOCATE ( STKDIAM( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKDIAM', PNAME )

         ALLOCATE ( STKHT( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKHT', PNAME )

         ALLOCATE ( STKTK( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKTK', PNAME )

         ALLOCATE ( STKVEL( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKVEL', PNAME )

         ALLOCATE ( ACRES_BURNED( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'ACRES_BURNED', PNAME )

         MY_NSRC = 0
#ifndef mpas
         M = MYPE + 1
         SCOL = COLSX_PE( 1,M ); ECOL = COLSX_PE( 2,M )
         SROW = ROWSX_PE( 1,M ); EROW = ROWSX_PE( 2,M )

         DO N = 1, NGRPS

!           IF ( .NOT. OPEN3( STKPRMS( N ), FSREAD3, PNAME ) ) THEN
!              XMSG = 'Could not open '// TRIM( STKPRMS( N ) ) // ' file'
!              CALL M3MESG( XMSG )
!              SUCCESS = .FALSE.; RETURN
!           END IF

!           IF ( .NOT. DESC3( STKPRMS( N ) ) ) THEN
!              XMSG = 'Could not get ' // TRIM( STKPRMS( N ) ) // ' file description'
!              CALL M3MESG( XMSG )
!              SUCCESS = .FALSE.; RETURN
!           END IF

            ALLOCATE ( LOC_MAP( NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'LOC_MAP', PNAME )

            SOURCE( N )%LEN = NSRC( N )
            ALLOCATE ( SOURCE( N )%ARRY( NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'SOURCE', PNAME )

            MY_STKCOL( N )%LEN = NSRC( N )
            ALLOCATE ( MY_STKCOL( N )%ARRY( NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'MY_STKCOL', PNAME )

            MY_STKROW( N )%LEN = NSRC( N )
            ALLOCATE ( MY_STKROW( N )%ARRY( NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'MY_STKROW', PNAME )

            MY_STKID( N )%LEN = NSRC( N )
            ALLOCATE ( MY_STKID( N )%ARRY( NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'MY_STKID', PNAME )

            MY_NSRC( N ) = 0
            STRT_SRC = 0; END_SRC = 0
            DO S = 1, NSRC( N )
               X = ( XLOCA( S, N ) - REAL( XORIG_GD, 4 ) ) / REAL( XCELL_GD, 4 )
               IF ( X .GE. 0.0 ) THEN
                  C = 1 + INT( X )
               ELSE
                  C = -1 - INT( -X )
               END IF
               IF ( C .GE. SCOL .AND. C .LE. ECOL ) THEN
                  Y = ( YLOCA( S, N ) - REAL( YORIG_GD, 4 ) ) / REAL( YCELL_GD, 4 )
                  IF ( Y .GE. 0.0 ) THEN
                     R = 1 + INT( Y )
                  ELSE
                     R = -1 - INT( -Y )
                  END IF
                  IF ( R .GE. SROW .AND. R .LE. EROW ) THEN
                     IF ( STRT_SRC .LE. 0 ) STRT_SRC = S
                     END_SRC = S
                     MY_NSRC( N ) = MY_NSRC( N ) + 1
                     LOC_MAP( MY_NSRC( N ) ) = S
                     SOURCE( N )%ARRY( MY_NSRC( N ) ) = S - STRT_SRC + 1  !**
                     MY_STKCOL( N )%ARRY( MY_NSRC( N ) ) = C - SCOL + 1
                     MY_STKROW( N )%ARRY( MY_NSRC( N ) ) = R - SROW + 1
                     MY_STKID( N )%ARRY( MY_NSRC( N ) ) = STKID( S, N )
                  END IF
               END IF
            END DO
 
C** SOURCE is the mapping from STKEMIS read by INTERPX starting at one.
C INTERPX reads a contiguous set from MY_STRT_SRC to MY_END_SRC into STKEMIS.
C So MY_STRT_SRC maps into the first index of STKEMIS.
C SOURCE must map skips in data between MY_STRT_SRC and MY_END_SRC.
C SOURCE maps STKEMIS read from stk emis file to local STKEM in GET_PT3D_EMIS.

            MY_STRT_SRC( N ) = STRT_SRC
            MY_END_SRC( N ) = END_SRC
            MY_DELTA = END_SRC - STRT_SRC + 1

            STKDIAM( N )%LEN = MY_DELTA
            ALLOCATE ( STKDIAM( N )%ARRY( MY_DELTA ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'STKDIAM', PNAME )

            STKHT( N )%LEN = MY_DELTA
            ALLOCATE ( STKHT( N )%ARRY( MY_DELTA ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'STKHT', PNAME )

            STKTK( N )%LEN = MY_DELTA
            ALLOCATE ( STKTK( N )%ARRY( MY_DELTA ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'STKTK', PNAME )

            STKVEL( N )%LEN = MY_DELTA
            ALLOCATE ( STKVEL( N )%ARRY( MY_DELTA ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'STKVEL', PNAME )

            IF ( FIRE_ON( N ) ) THEN
               ACRES_BURNED( N )%LEN = MY_DELTA
               ALLOCATE ( ACRES_BURNED( N )%ARRY( MY_DELTA ), STAT = ASTAT )
               CALL CHECKMEM( ASTAT, 'ACRES_BURNED', PNAME )
            END IF

            MY_XLOCA( N )%LEN = MY_NSRC( N )
            ALLOCATE ( MY_XLOCA( N )%ARRY( MY_NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'MY_XLOCA', PNAME )
            MY_XLOCA( N )%ARRY = 0.0   ! array

            MY_YLOCA( N )%LEN = MY_NSRC( N )
            ALLOCATE ( MY_YLOCA( N )%ARRY( MY_NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'MY_YLOCA', PNAME )
            MY_YLOCA( N )%ARRY = 0.0   ! array

            IF ( MY_NSRC( N ) .LE. 0 ) THEN

               MY_DELTA = 0

               MY_XLOCA( N )%LEN = MY_NSRC( N )
               MY_YLOCA( N )%LEN = MY_NSRC( N )

            END IF   ! MY_NSRC( N ) .GT. 0
        
            DO S = 1, MY_NSRC( N )
               SRC = LOC_MAP( S )
               MY_XLOCA( N )%ARRY( S ) = XLOCA( SRC, N )
               MY_YLOCA( N )%ARRY( S ) = YLOCA( SRC, N )
            END DO

            DEALLOCATE ( LOC_MAP )
            
            WRITE( XMSG, '(A,I3,A,I7)'), 
     &             'Number of Point Sources from ',N,' equals ', MY_NSRC(N)
            IF ( N .EQ. 1 ) THEN
                CALL LOG_MESSAGE( LOGDEV, '')
                CALL LOG_SUBHEADING( LOGDEV, 
     &              'Checking the number of sources on each point source file.')
            END IF
            CALL LOG_MESSAGE( LOGDEV, XMSG )

         END DO   ! NGRPS

         WRITE( XMSG, '(A,I7)'), 
     &          'Number of Total Point Sources on this sub-domain equals ', SUM(MY_NSRC(:))
         CALL LOG_MESSAGE( LOGDEV, XMSG )
         CALL LOG_MESSAGE( LOGDEV, '' )
         XMSG = 'Note: Large numbers of point sources (e.g. > 100,000 on any sub-domain '//
     &          'processor) will cause noticeable runtime penalties. Users are advised to '//
     &          'limit the maximum number of point sources on any sub-domain to below this '//
     &          'threshold.'
         CALL LOG_MESSAGE( LOGDEV, XMSG )

         ALLOCATE( MY_STKBUFF( MAXVAL( MY_NSRC(:) ) ) )
           CALL CHECKMEM( ASTAT, 'MY_STKBUFF', PNAME )
         ALLOCATE( MY_COLBUFF( MAXVAL( MY_NSRC(:) ) ) )
           CALL CHECKMEM( ASTAT, 'MY_COLBUFF', PNAME )
         ALLOCATE( MY_ROWBUFF( MAXVAL( MY_NSRC(:) ) ) )
           CALL CHECKMEM( ASTAT, 'MY_ROWBUFF', PNAME )
#endif
 
         RETURN

         END FUNCTION STK_PRMS_INIT

      END MODULE STK_PRMS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPWDEP ( JDATE, JTIME, TSTEP )

!-----------------------------------------------------------------------
!
!  FUNCTION:  Open wet dep file(s)
!
!  PRECONDITIONS:
!       Dates and times represented YYYYDDD:HHMMSS.
!
!  REVISION  HISTORY:
!      Date   Who             What
!    -------- ---             -----------------------------------------
!     07/17/15 D. Wong        initial version
!     12/30/19 S. Napelenok   ddm-3d implemenation for v5.3.1
!-----------------------------------------------------------------------

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      USE MIO_ASCII

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, SEN_PAR, SENNUM, S_WETDEPSPC
#endif

      IMPLICIT NONE

!...........INCLUDES

      INCLUDE SUBST_FILES_ID         ! file name parameters

      CHARACTER( 120 ) :: XMSG = ' ' ! exit message string

!...........PARAMETERS

!...........ARGUMENTS

      INTEGER, INTENT (IN) :: JDATE            ! current model date, coded YYYYDDD
      INTEGER, INTENT (IN) :: JTIME            ! current model time, coded HHMMSS
      INTEGER, INTENT (IN) :: TSTEP            ! model time step, coded HHMMSS

!...........Local Variables

      CHARACTER( 16 ), SAVE :: PNAME = 'OPWDEP' ! driver program name

      INTEGER       FINI             ! ending position
      INTEGER       L                ! loop counter
      INTEGER       SPC              ! species subscript indices
      INTEGER       STRT             ! starting position
      INTEGER       VAR              ! variable subscript indices

!-----------------------------------------------------------------------

!...Initialization

!...first check to make sure that some species in CGRID were specified
!...for output in the wet deposition array, otherwise notify the user
!...and return

        IF ( N_SPC_WDEP .LE. 0 ) THEN

          XMSG = 'No species were specified for wet deposition ' //
     &           'tracking'
          CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )

          XMSG = 'ONLY CLOUD DIAGNOSTICS WILL BE WRITTEN TO THE ' //
     &           'WETDEP OUTPUT FILE!'
          CALL M3MESG ( XMSG )

        END IF

#ifndef mpas
C Try to open existing wet deposition file for update

        IF ( IO_PE_INCLUSIVE ) THEN
           WRITE( LOGDEV, * )
           IF ( .NOT. OPEN3( CTM_WET_DEP_1, FSRDWR3, PNAME ) ) THEN

              XMSG = 'Could not open ' // CTM_WET_DEP_1 // ' file for update - '
     &               // 'try to open new'
              CALL M3MESG( XMSG )

!...Create wet deposition file:
!...   copy most of header description from
!...   MET_CRO_2D and initialize depositions to zero.

!...open MET_CRO_2D

              IF ( .NOT. OPEN3( MET_CRO_2D, FSREAD3, PNAME ) ) THEN
                XMSG = 'Could not open '// MET_CRO_2D // ' file'
                CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
              END IF

!...get description from the met file

              IF ( .NOT. DESC3( MET_CRO_2D ) ) THEN
                XMSG = 'Could not get ' // MET_CRO_2D //' file description'
                CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
              END IF

              NCOLS3D = GL_NCOLS
              NROWS3D = GL_NROWS

              XORIG3D = XORIG_GD
              YORIG3D = YORIG_GD

!...advance to time variable for the output file to the next hour

              SDATE3D = JDATE
              STIME3D = 10000 * ( JTIME / 10000 )     !  clear MMSS fields
              TSTEP3D = TSTEP     
              CALL NEXTIME ( SDATE3D, STIME3D, TSTEP3D ) !  on the next hour

              NVARS3D = N_SPC_WDEP + 1

!...define wet deposition output descriptors for gaseous species

              SPC = 0
              STRT = 1
              FINI = N_GC_WDEP
              DO VAR = STRT, FINI
                 SPC = SPC + 1
                 VTYPE3D ( VAR ) = M3REAL
                 VNAME3D ( VAR ) = GC_WDEP( SPC )
                 UNITS3D ( VAR ) = 'kg ha-1'
                 VDESC3D ( VAR ) = 'hourly wet deposition values'
              END DO

!...define wet deposition output descriptors for aerosol species

              SPC = 0
              STRT = N_GC_WDEP + 1
              FINI = N_GC_WDEP + N_AE_WDEP
              DO VAR = STRT, FINI
                 SPC = SPC + 1
                 VTYPE3D ( VAR ) = M3REAL
                 VNAME3D ( VAR ) = AE_WDEP( SPC )
                 IF ( INDEX( AE_WDEP( SPC ), 'NUM' ) .GT. 0 ) THEN
                    UNITS3D ( VAR ) = 'ha-1'
                 ELSE IF ( INDEX( AE_WDEP( SPC ), 'SRF' ) .GT. 0 ) THEN
                    UNITS3D ( VAR ) = 'm2 ha-1'
                 ELSE
                    UNITS3D ( VAR ) = 'kg ha-1'
                 END IF
                 VDESC3D ( VAR ) = 'hourly wet deposition values'
              END DO

!...define wet deposition output descriptors for non-reactive species

              SPC = 0
              STRT = N_GC_WDEP + N_AE_WDEP + 1
              FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP
              DO VAR = STRT, FINI
                 SPC = SPC + 1
                 VTYPE3D ( VAR ) = M3REAL
                 VNAME3D ( VAR ) = NR_WDEP( SPC )
                 UNITS3D ( VAR ) = 'kg ha-1'
                 VDESC3D ( VAR ) = 'hourly wet deposition values'
              END DO

!...define wet deposition output descriptors for tracer species

              SPC = 0
              STRT = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + 1
              FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP
              DO VAR = STRT, FINI
                 SPC = SPC + 1
                 VTYPE3D ( VAR ) = M3REAL
                 VNAME3D ( VAR ) = TR_WDEP( SPC )
                 UNITS3D ( VAR ) = 'kg ha-1'
                 VDESC3D ( VAR ) = 'hourly wet deposition values'
              END DO

!...define output descriptor for hydrogen concentration

              VAR = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP + 1
              VTYPE3D( VAR ) = M3REAL
              VNAME3D( VAR ) = 'HPLUS'
              UNITS3D( VAR ) = 'kg ha-1'
              VDESC3D( VAR ) = 'hourly wet deposition values'

!...initialize the file descriptors

              FDESC3D( 1 ) = 'hourly 1-layer cross-point wet deposition'
     &                       // ' from all cloud types'
              DO L = 2 , MXDESC3
                 FDESC3D( L ) = ' '
              END DO

              GDNAM3D = GRID_NAME  ! from HGRD_DEFN
 
!...Store MIO Metadata
              NDIMS3D( 1:NVARS3D ) = 3
              L_TSTEP( 1:NVARS3D ) = .True.
              L_LAY  ( 1:NVARS3D ) = .False.
              L_COL  ( 1:NVARS3D ) = .True.
              L_ROW  ( 1:NVARS3D ) = .True.
              L_VEXT ( 1:NVARS3D ) = .False.
              
              CALL LOAD_MIO_FILE ( 'CTM_WET_DEP_1', 0, 0, 0,
     &             VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &             VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &             L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &             L_VEXT(1:NVARS3D) )
 
!...try to open the output file new

              IF ( .NOT. OPEN3( CTM_WET_DEP_1, FSNEW3, PNAME ) ) THEN
                 XMSG = 'Could not create '// CTM_WET_DEP_1 // ' file'
                 CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
              END IF

           END IF   ! open CTM_WET_DEP_1 read/write

#ifdef sens
           IF ( .NOT. OPEN3( CTM_SWETDEP_1, FSRDWR3, PNAME ) ) THEN
               XMSG = 'Could not open ' // CTM_SWETDEP_1 //
     &                ' file for update - try to open new'
               CALL M3MESG( XMSG )

C...Create sensitivity wet deposition file:
               NVARS3D = ( N_SPC_WDEP + 1 ) * NPMAX

               ALLOCATE ( S_WETDEPSPC( NVARS3D ) )
               S_WETDEPSPC = 'blank'

               VTYPE3D = M3REAL
               VDESC3D = 'Sens of hourly wet dep values'              

C...define sens wet deposition output descriptors for gaseous species
               SPC = 0
               STRT = 1
               FINI = N_GC_WDEP
               DO VAR = STRT, FINI
                 SPC = SPC + 1
                 DO NP = 1, NPMAX
                   SENNUM = ( SPC - 1 ) * NPMAX + NP
                   VNAME3D ( SENNUM ) = TRIM( GC_WDEP( SPC )( 1:12 ) ) //'_'// SEN_PAR( NP )
                   UNITS3D ( SENNUM ) = 'kg/hectare'
                   S_WETDEPSPC ( SENNUM ) = VNAME3D ( SENNUM )
                 END DO
               END DO

C...define wet deposition output descriptors for aerosol species
               SPC = 0
               STRT = N_GC_WDEP + 1
               FINI = N_GC_WDEP + N_AE_WDEP
               DO VAR = STRT, FINI
                  SPC = SPC + 1
                  DO NP = 1, NPMAX
                     SENNUM = ( NPMAX * N_GC_WDEP ) + ( SPC - 1 ) *NPMAX + NP
                     VNAME3D ( SENNUM ) = TRIM( AE_WDEP( SPC )( 1:12 ) ) //'_'// SEN_PAR( NP )
                     IF ( INDEX( AE_WDEP( SPC ), 'NUM' ) .GT. 0 ) THEN
                        UNITS3D ( SENNUM ) = 'number/hectare'
                     ELSE IF ( INDEX( AE_WDEP( SPC ), 'SRF' ) .GT. 0 ) THEN
                        UNITS3D ( SENNUM ) = 'm2/hectare'
                     ELSE
                        UNITS3D ( SENNUM ) = 'kg/hectare'
                     END IF
                     S_WETDEPSPC ( SENNUM ) = VNAME3D ( SENNUM )
                  END DO
               END DO

C...define wet deposition output descriptors for non-reactive species
               SPC = 0
               STRT = N_GC_WDEP + N_AE_WDEP + 1
               FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP
               DO VAR = STRT, FINI
                  SPC = SPC + 1
                  DO NP = 1, NPMAX
                     SENNUM = NPMAX * ( N_GC_WDEP + N_AE_WDEP ) + ( SPC - 1 ) * NPMAX + NP
                     VNAME3D ( SENNUM ) = TRIM( NR_WDEP( SPC )( 1:12 ) ) //'_'// SEN_PAR( NP )
                     UNITS3D ( SENNUM ) = 'kg/hectare'
                     S_WETDEPSPC ( SENNUM ) = VNAME3D ( SENNUM )
                  END DO
               END DO

C...define wet deposition output descriptors for tracer species
               SPC = 0
               STRT = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + 1
               FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP
               DO VAR = STRT, FINI
                  SPC = SPC + 1
                  DO NP = 1, NPMAX
                     SENNUM = NPMAX * ( N_GC_WDEP + N_AE_WDEP + N_NR_WDEP ) + ( SPC - 1 ) * NPMAX + NP
                     VNAME3D ( SENNUM ) = TRIM( TR_WDEP( SPC )( 1:12 ) ) //'_'// SEN_PAR( NP )
                     UNITS3D ( SENNUM ) = 'kg/hectare'
                     S_WETDEPSPC ( SENNUM ) = VNAME3D ( SENNUM )
                  END DO
               END DO

C...define output descriptor for hydrogen concentration
               VAR = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP
               DO NP = 1, NPMAX
                  SENNUM = NPMAX * VAR + NP
                  VNAME3D ( SENNUM ) = 'HPLUS_' // SEN_PAR( NP )
                  UNITS3D ( SENNUM ) = 'kg/hectare'
                  S_WETDEPSPC ( SENNUM ) = VNAME3D ( SENNUM )
               END DO

C...initialize the file descriptors
               FDESC3D = ' '
               FDESC3D( 1 ) = 'Sensitivity of hourly 1-layer '
     &                        // 'cross-point wet deposition '
     &                        // 'from all cloud types'

               ! Store MIO Metadata
               NDIMS3D( 1:NVARS3D ) = 3
               L_TSTEP( 1:NVARS3D ) = .True.
               L_LAY  ( 1:NVARS3D ) = .False.
               L_COL  ( 1:NVARS3D ) = .True.
               L_ROW  ( 1:NVARS3D ) = .True.
               L_VEXT ( 1:NVARS3D ) = .False.

               CALL LOAD_MIO_FILE ( 'CTM_SWETDEP_1', 0, 0, 0,
     &              VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &              VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &              L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &              L_VEXT(1:NVARS3D) )

C...try to open the output file new
               IF ( .NOT. OPEN3( CTM_SWETDEP_1, FSNEW3, PNAME ) ) THEN
                  XMSG = 'Could not create '// CTM_SWETDEP_1 // ' file'
                  CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
               END IF

           END IF   ! open CTM_SWETDEP_1 read/write
#endif

!...open the diagnostic file if user asked for it

           IF ( CLD_DIAG ) THEN

!...Try to open existing file for update
              WRITE( LOGDEV, * )
              IF ( .NOT. OPEN3( CTM_WET_DEP_2, FSRDWR3, PNAME ) ) THEN

                 XMSG = 'Could not open ' // CTM_WET_DEP_2 // ' file for update - '
     &                  // 'try to open new'
                 CALL M3MESG( XMSG )

!...copy most of header description from
!...CTM_WET_DEP_1 and initialize depositions to zero.

!...get description from the other wet dep file

                 IF ( .NOT. DESC3( CTM_WET_DEP_1 ) ) THEN
                    XMSG = 'Could not get ' // CTM_WET_DEP_1 //' file description'
                    CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                 END IF

!...advance to time variable for the output file to the next hour

                 SDATE3D = JDATE
                 STIME3D = 10000 * ( JTIME / 10000 )     !  clear MMSS fields
                 TSTEP3D = TSTEP     
                 CALL NEXTIME ( SDATE3D, STIME3D, TSTEP3D ) !  on the next hour

                 NVARS3D = N_SPC_WDEP + 8 + 4

!...define output descriptor for pressure at the lifting condensation
!...level (LCL)

                 VAR = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP + 2
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'PLCL'
                 UNITS3D( VAR ) = 'Pa'
                 VDESC3D( VAR ) = 'pressure at lifting condensation level, '
     &                            // 'or MISSING = -9999.9'

!...define output descriptor for cloud bottom layer number

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'CLOUD_BOTTOM'
                 UNITS3D( VAR ) = ''
                 VDESC3D( VAR ) = 'layer number containing bottom of cloud, or MISSING = -9999.9'

!...define output descriptor for precipitating cloud top layer number

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'PR_CLOUDTOP'
                 UNITS3D( VAR ) = ''
                 VDESC3D( VAR ) = 'layer number containing top of PR cloud, or MISSING = -9999.9'

!...define output descriptor for non-precipitating cloud top layer number

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'NP_CLOUDTOP'
                 UNITS3D( VAR ) = ''
                 VDESC3D( VAR ) = 'layer number containing top of NP cloud, or MISSING = -9999.9'

!...define output descriptor for rain event flag

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'RAIN_FLAG'
                 UNITS3D( VAR ) = ''
                 VDESC3D( VAR ) = 'Rain-event flag (values: 1,0)'
 
!...define output descriptor for precitating cloud fraction

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'PR_CLDFRAC'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Precipitating cloud fraction'

!...define output descriptor for non-precipitating cloud fraction

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'NP_CLDFRAC'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Non-precipitating cloud fraction'

!...define output descriptor for precipitating cloud transmissivity

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'PR_TRANS'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Precipitating cloud transmissivity'

!...define output descriptor for non-precipitating cloud transmissivity

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'NP_TRANS'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Non-precipitating cloud transmissivity'

!...define output descriptor for resolved cloud transmissivity

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'RES_TRANS'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Resolved cloud transmissivity'

!...define output descriptor for overall cloud transmissivity

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'CLD_TRANS'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Total cloud transmissivity'

!...initialize the file descriptors

                 FDESC3D( 1 ) = 'hourly 1-layer cross-point wet deposition '
     &                           // 'from sub-grid clouds and cloud data'
                 DO L = 2 , MXDESC3
                    FDESC3D( L ) = ' '
                 END DO

!...Store MIO Metadata
                 NDIMS3D( 1:NVARS3D ) = 3
                 L_TSTEP( 1:NVARS3D ) = .True.
                 L_LAY  ( 1:NVARS3D ) = .False.
                 L_COL  ( 1:NVARS3D ) = .True.
                 L_ROW  ( 1:NVARS3D ) = .True.
                 L_VEXT ( 1:NVARS3D ) = .False.
                 
                 CALL LOAD_MIO_FILE ( 'CTM_WET_DEP_2', 0, 0, 0,
     &                VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &                VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &                L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &                L_VEXT(1:NVARS3D) )

!...try to open the diagnostic output file

                 IF ( .NOT. OPEN3( CTM_WET_DEP_2, FSNEW3, PNAME ) ) THEN
                    XMSG = 'Could not create '// CTM_WET_DEP_2 // ' file'
                    CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
                 END IF

              END IF   ! open CTM_WET_DEP_2 read/write

           END IF   ! CLD_DIAG

        END IF   ! IO_PE_INCLUSIVE
#endif

      END SUBROUTINE OPWDEP

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains the definition of various Families that are       !
! useful for users wanting to scale inputs or otherwise modify the the   !
! options for their outputs.                                             !
!                                                                        !
! Revision History:                                                      !
!  25 Jun 2020 B. Murphy initial implementation                          !
!------------------------------------------------------------------------!

      module util_Family_module

      IMPLICIT NONE

      SAVE

      ! Define Chemical Family Variables
      Integer                     :: N_Chem_Fams = 0
      Integer                     :: Max_Chem_Fam_Members = 0
      Character( 32 ),Allocatable :: ChemFamilyName( : ) 
      Integer,Allocatable         :: ChemFamilyNum( : ) 
      Character( 16 ),Allocatable :: ChemFamilyUnits( : ) 
      Character( 32 ),Allocatable :: ChemFamilyMembers( :,: ) 

      ! Define Stream Family Variables
      Integer                     :: Desid_N_Stream_Fams = 0
      Integer                     :: Desid_Max_Stream_Fam_Members = 0
      Character( 32 ),Allocatable :: StreamFamilyName( : ) 
      Integer,Allocatable         :: StreamFamilyNum( : )
      Character( 32 ),Allocatable :: StreamFamilyMembers( :,: )

      ! Define Region Family Variables
      Integer                     :: Desid_N_Reg_Fams = 0
      Integer                     :: Desid_Max_Reg_Fam_Members = 0
      Character( 32 ),Allocatable :: RegionFamilyName( : )
      Integer,Allocatable         :: RegionFamilyNum( : )
      Character( 32 ),Allocatable :: RegionFamilyMembers( :,: )

      ! Other Variables
      Logical                     :: linit = .FALSE.

      contains

          
! ----------------------------------------------------------------------
      subroutine read_families
! ----------------------------------------------------------------------
!     Load definitions for families from the Control File to these 
!     globally available variables.
!     
! ----------------------------------------------------------------------

      use RUNTIME_VARS, only : CMAQ_CTRL, CMAQ_CHEM_CTRL, logdev, log_message, 
     &                         log_subheading
      use UTILIO_DEFN
      use desid_param_module, only : Desid_Max_Reg
      use aero_data, only : n_aerospc, aerospc, n_mode, aero_missing
      
      IMPLICIT NONE
      
      ! Define Dummy Variables for Opening Emission Control Namelist
      CHARACTER( 300 ) :: XMSG
      INTEGER          :: FUNIT
      INTEGER          :: STAT, IFAM, INUM, IOST, IAER, JAER, IM
      CHARACTER( 200 ) :: TMPLINE


      ! Define Chemical Families           
      NAMELIST / Chemical_FamVars / N_Chem_Fams, Max_Chem_Fam_Members
      NAMELIST / ChemicalFamilies / ChemFamilyName, ChemFamilyUnits, ChemFamilyMembers

      ! Define Stream Families
      NAMELIST / Desid_StreamFamVars / Desid_N_Stream_Fams, Desid_Max_Stream_Fam_Members
      NAMELIST / Desid_StreamFam     / StreamFamilyName, StreamFamilyMembers

      ! Define Region Families
      NAMELIST / Desid_RegionDefVars / Desid_Max_Reg, Desid_N_Reg_Fams,
     &                                 Desid_Max_Reg_Fam_Members
      NAMELIST / Desid_RegionFam / RegionFamilyName, RegionFamilyMembers
 
      CALL LOG_SUBHEADING( LOGDEV, "Reading Family Definitions from Control File" )

      ! Retrieve the Name of the CMAQ Chemical Control File
      IF ( CMAQ_CHEM_CTRL .EQ. "CMAQ_CH_CTRL_NML" ) THEN
          XMSG = 'You have chosen not to indicate the location of a' //
     &              'Chemical Control namelist file. You must give a value ' //
     &              'for the CMAQ_CH_CTRL_NML variable in the CMAQ runscript.'
          CALL M3EXIT( 'READ_FAMILIES',0,0,XMSG,1 )
      END IF
 
      ! Open CMAQ Control Namelist File
      FUNIT = JUNIT()
      OPEN( FILE = CMAQ_CHEM_CTRL, UNIT = FUNIT, STATUS = 'OLD',
     &      POSITION = 'REWIND', FORM='FORMATTED', IOSTAT = STAT )

      ! Check for Error in File Open Process
      IF ( STAT .NE. 0 ) THEN
          WRITE( XMSG, '(A,A,A)' ),'ERROR: Could not read ',
     &           'CMAQ Chemical Control namelist file: ',TRIM( CMAQ_CHEM_CTRL )
          CALL M3EXIT( 'READ_FAMILIES',0,0,XMSG,1 )
      END IF
 
      ! Read Number of Chemical Families
      REWIND( FUNIT )
      READ( NML = Chemical_FamVars, UNIT = FUNIT, IOSTAT=STAT )
      IF ( STAT .EQ. -1 ) THEN
          XMSG = 'Note: the Chemical_FamVars section of the Chemical Control ' //
     &           'Namelist is missing. Default values for this section will be ' //
     &           'assumed.'
          CALL LOG_MESSAGE( LOGDEV, ' ' )
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          N_Chem_Fams          = 0
          Max_Chem_Fam_Members = 120
      ELSE IF ( STAT .NE. 0 ) THEN
          ! Read Error Detected for CMAQ_CHEM_CTRL
          backspace( FUNIT )
          read( FUNIT, fmt='(A)' ) tmpline
          XMSG = 'ERROR: There was a syntax error reading the Chemical_FamVars '//
     &           'variable for use by the families module. Please check the format of '//
     &           'each line for syntax errors. The invalid line was likely: '
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE
          CALL M3EXIT ( 'Read_Families', 0, 0, 'CMAQ must Crash until you '//
     &                  'fix the Chemical Families', 1 ) 
 
      END IF
 
      IF ( N_CHEM_FAMS .EQ. 0 ) THEN
          CALL LOG_MESSAGE( LOGDEV, 'No chemical families have been ' //
     &         'added by the user. Bulk aerosol species are still ' //
     &         'available as chemical families.')
      END IF

      ! Read Chemical Family Specification Section
      N_Chem_Fams = N_Chem_Fams + n_aerospc
      ALLOCATE( ChemFamilyName( N_Chem_Fams),
     &          ChemFamilyNum( N_Chem_Fams),
     &          ChemFamilyUnits( N_Chem_Fams),
     &          ChemFamilyMembers( N_Chem_Fams, Max_Chem_Fam_Members ),
     &          STAT = IOST)
      CALL CHECKMEM( IOST, 'ChemFamilies', 'Read_Families' )
      ChemFamilyName    = ''
      ChemFamilyUnits   = ''
      ChemFamilyMembers = ''

      REWIND( FUNIT )
      READ( NML = ChemicalFamilies, UNIT = FUNIT, IOSTAT=STAT )
      IF ( STAT .EQ. -1 ) THEN
          XMSG = 'Note: the ChemicalFamilies section of the Chemical Control ' //
     &           'Namelist is missing. Default values for this section will be ' //
     &           'assumed.'
          CALL LOG_MESSAGE( LOGDEV, ' ' )
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          ChemFamilyName     = ''
          ChemFamilyMembers  = ''
      ELSE IF ( STAT .NE. 0 ) THEN
          ! Read Error Detected for RGN_NML
          backspace( FUNIT )
          read( FUNIT, fmt='(A)' ) tmpline
          XMSG = 'ERROR: There was a syntax error reading the ChemicalFamilies '//
     &           'variable for use by the DESID module. Please check the format of '//
     &           'each line for syntax errors. The invalid line was likely: '
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE
          CALL M3EXIT ( 'Read_Families', 0, 0, 'CMAQ must Crash until you '//
     &                  'fix the Chemical Families', 1 ) 
 
      END IF

      ! Add Aerosol Species to Chemical Family List if they aren't
      ! already there
      DO IAER = 1,N_AEROSPC
         JAER = INDEX1( AEROSPC(IAER)%BULKNAME,N_Chem_Fams,ChemFamilyName )
         IF ( JAER .EQ. 0 ) THEN
           ! Add Aerosol Bulkname to the end of the chemical family
           ! list
           DO IFAM = 1,N_Chem_Fams
             if ( ChemFamilyName(ifam) .eq. '' ) then
                ChemFamilyName(ifam) = aerospc(iaer)%bulkname
                ChemFamilyUnits(ifam) = 'ug m-3'
                inum = 0
                do im = 1,n_mode
                  if ( .not.aero_missing(iaer,im) ) then
                     inum = inum + 1
                     ChemFamilyMembers(ifam,inum) = aerospc(iaer)%name(im)
                  end if
                end do
                exit
             end if
           END DO
         ELSE
           N_Chem_Fams = N_Chem_Fams - 1
         END IF
      END DO

      ! Reallocate Chemical Family Arrays in case N_Chem_Fams was
      ! shortened due to aerosol bulknames being already present in the
      ! user-defined family list.
      ChemFamilyName    = ChemFamilyName(1:N_Chem_Fams)
      ChemFamilyUnits   = ChemFamilyUnits(1:N_Chem_Fams)
      ChemFamilyMembers = ChemFamilyMembers(1:N_Chem_Fams,1:Max_Chem_Fam_Members)

      ! Populate and Error Check All Family and Member Names
      DO IFAM = 1,N_Chem_Fams
          IF ( ChemFamilyName(IFAM) .EQ. '' ) THEN
             WRITE( XMSG, '(A,I3,A,A,A)' ),'ERROR: The number of Chemical Families ',
     &              N_Chem_Fams, ' is larger than the number of fields ',
     &              'provided in the ChemFamilyName array. Reduce N_Chem_Fams ',
     &              'in the CMAQ_CH_CTRL_NML file or provide more Chemical Families.'
             CALL M3EXIT( 'Read_Families',0,0,XMSG,1 )
          END IF
          CALL UPCASE( ChemFamilyName( IFAM ) )
          ChemFamilyNum( IFAM ) = 0

          DO INUM = 1,Max_Chem_Fam_Members
              IF ( ChemFamilyMembers( IFAM,INUM ) .EQ. '' ) EXIT
              CALL UPCASE( ChemFamilyMembers( IFAM,INUM ) )
              ChemFamilyNum ( IFAM ) = INUM
          END DO
      END DO  
      CLOSE( UNIT = FUNIT )
 
      !!! Stream Families !!!
      ! Retrieve the Name of the DESID Control File
      IF ( CMAQ_CTRL .EQ. "CMAQ_CTRL_NML" ) THEN
          XMSG = 'You have chosen not to indicate the location of a' //
     &              'CMAQ Control namelist file. You must give a value ' //
     &              'for the CMAQ_CTRL_NML variable in the CMAQ runscript.'
          CALL M3EXIT( 'READ_FAMILIES',0,0,XMSG,1 )
      END IF
 
      ! Open Emission Control Namelist File
      FUNIT = JUNIT()
      OPEN( FILE = CMAQ_CTRL, UNIT = FUNIT, STATUS = 'OLD',
     &      POSITION = 'REWIND', FORM='FORMATTED', IOSTAT = STAT )

      ! Check for Error in File Open Process
      IF ( STAT .NE. 0 ) THEN
          WRITE( XMSG, '(A,A,A)' ),'ERROR: Could not read ',
     &           'CMAQ control namelist file: ',TRIM( CMAQ_CTRL )
          CALL M3EXIT( 'READ_FAMILIES',0,0,XMSG,1 )
      END IF
 
      ! Read Stream Family Specification Section
      REWIND( FUNIT )
      READ( NML = Desid_StreamFamVars, UNIT = FUNIT, IOSTAT=STAT )
      IF ( STAT .EQ. -1 ) THEN
          XMSG = 'Note: the StreamFamilies section of the CMAQ Control ' //
     &           'Namelist is missing. Default values for this section will be ' //
     &           'assumed.'
          CALL LOG_MESSAGE( LOGDEV, ' ' )
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          Desid_N_Stream_Fams  = 0
          Desid_Max_Stream_Fam_Members = 0
      ELSE IF ( STAT .NE. 0 ) THEN
          ! Read Error Detected for RGN_NML
          backspace( FUNIT )
          read( FUNIT, fmt='(A)' ) tmpline
          XMSG = 'ERROR: There was a syntax error reading the Desid_StreamFamVars '//
     &           'variable for use by the DESID module. Please check the format of '//
     &           'each line for syntax errors. The invalid line was likely: '
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE
          CALL M3EXIT ( 'Read_Families', 0, 0, 'CMAQ must Crash until you '//
     &                  'fix the Stream Families', 1 ) 
 
      END IF

      ALLOCATE( StreamFamilyName( Desid_N_Stream_Fams ),
     &          StreamFamilyNum( Desid_N_Stream_Fams ),
     &          StreamFamilyMembers( Desid_N_Stream_Fams, Desid_Max_Stream_Fam_Members ),
     &          STAT = IOST )
      CALL CHECKMEM( IOST, 'Stream Families', 'Read_Families' )
      StreamFamilyName = ''
      StreamFamilyMembers = ''

      ! Read Stream Family Specification Section
      REWIND( FUNIT )
      READ( NML = Desid_StreamFam, UNIT = FUNIT, IOSTAT=STAT )
      IF ( STAT .EQ. -1 ) THEN
          XMSG = 'Note: the StreamFamilies section of the CMAQ Control ' //
     &           'Namelist is missing. Default values for this section will be ' //
     &           'assumed.'
          CALL LOG_MESSAGE( LOGDEV, ' ' )
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          StreamFamilyName     = ''
          StreamFamilyMembers  = ''
      ELSE IF ( STAT .NE. 0 ) THEN
          ! Read Error Detected for RGN_NML
          backspace( FUNIT )
          read( FUNIT, fmt='(A)' ) tmpline
          XMSG = 'ERROR: There was a syntax error reading the Desid_StreamFam '//
     &           'variable for use by the DESID module. Please check the format of '//
     &           'each line for syntax errors. The invalid line was likely: '
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE
          CALL M3EXIT ( 'Read_Families', 0, 0, 'CMAQ must Crash until you '//
     &                  'fix the Stream Families', 1 ) 
 
      END IF
 
      ! Capitalize All Family and Member Names
      DO IFAM = 1,Desid_N_Stream_Fams
          IF ( StreamFamilyName(IFAM) .EQ. '' ) THEN
             WRITE( XMSG, '(A,I3,A,A,A)' ),'ERROR: The number of Stream Families ',
     &              Desid_N_Stream_Fams, ' is larger than the number of fields ',
     &              'provided in StreamFamilyName array. Reduce Desid_N_Stream_Fams ',
     &              'in the CMAQ_CTRL_NML file or provide more Stream Families.'
             CALL M3EXIT( 'Read_Families',0,0,XMSG,1 )
          END IF
          CALL UPCASE( StreamFamilyName( IFAM ) )
          StreamFamilyNum( IFAM ) = 0

          DO INUM = 1,Desid_Max_Stream_Fam_Members
              IF ( StreamFamilyMembers(IFAM,INUM) .EQ. '' ) EXIT
              CALL UPCASE( StreamFamilyMembers( IFAM,INUM ) )
              StreamFamilyNum( IFAM ) = INUM
          END DO
      END DO

 
      !!! Region Families !!!
      ! Read Region Family Specification Section
      REWIND( FUNIT )
      READ( NML = Desid_RegionDefVars, UNIT = FUNIT, IOSTAT=STAT )
      IF ( STAT .EQ. -1 ) THEN
          XMSG = 'Note: the Desid_Regoin_DefVars section of the CMAQ Control ' //
     &           'Namelist is missing. Default values for this section will be '//
     &           'assumed.'
          CALL LOG_MESSAGE( LOGDEV, ' ' )
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          Desid_Max_Reg  = 0
          Desid_N_Reg_Fams  = 0
          Desid_Max_Reg_Fam_Members  = 0
      ELSE IF ( STAT .NE. 0 ) THEN
          ! Read Error Detected for RGN_NML
          backspace( FUNIT )
          read( FUNIT, fmt='(A)' ) tmpline
          XMSG = 'ERROR: There was a syntax error reading the RegionFamilies '//
     &           'variable for use by the DESID module. Please check the format of '//
     &           'each line for syntax errors. The invalid line was likely: '
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE
          CALL M3EXIT ( 'Read_Families', 0, 0, 'CMAQ must Crash until you '//
     &                  'fix the Region Families', 1 ) 
 
      END IF

      ALLOCATE( RegionFamilyName( Desid_N_Reg_Fams ),
     &          RegionFamilyNum( Desid_N_Reg_Fams ),
     &          RegionFamilyMembers( Desid_N_Reg_Fams, Desid_Max_Reg_Fam_Members ),
     &          STAT=IOST )
      CALL CHECKMEM( IOST, 'Region Families','Read Families' )
      RegionFamilyName = ''
      RegionFamilyMembers = ''

      REWIND( FUNIT )
      READ( NML = Desid_RegionFam, UNIT = FUNIT, IOSTAT=STAT )
      IF ( STAT .EQ. -1 ) THEN
          XMSG = 'Note: the Desid_RegionFam section of the CMAQ Control ' //
     &           'Namelist is missing. Default values for this section will be '//
     &           'assumed.'
          CALL LOG_MESSAGE( LOGDEV, ' ' )
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          RegionFamilyName     = ''
          RegionFamilyMembers  = ''
      ELSE IF ( STAT .NE. 0 ) THEN
          ! Read Error Detected for RGN_NML
          backspace( FUNIT )
          read( FUNIT, fmt='(A)' ) tmpline
          XMSG = 'ERROR: There was a syntax error reading the RegionFamilies '//
     &           'variable for use by the DESID module. Please check the format of '//
     &           'each line for syntax errors. The invalid line was likely: '
          CALL LOG_MESSAGE( LOGDEV, ' ')
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, '(8x,A)' ) TMPLINE
          CALL M3EXIT ( 'Read_Families', 0, 0, 'CMAQ must Crash until you '//
     &                  'fix the Region Families', 1 ) 
 
      END IF
 
      ! Capitalize All Family and Member Names
      DO IFAM = 1,Desid_N_Reg_Fams
          IF ( RegionFamilyName(IFAM) .EQ. '' ) THEN
             WRITE( XMSG, '(A,I3,A,A,A)' ),'ERROR: The number of Region Families ',
     &              Desid_N_Reg_Fams, ' is larger than the number of fields ',
     &              'provided in RegionFamilyName array. Reduce Desid_N_Reg_Fams ',
     &              'in the CMAQ_CTRL_NML file or provide more Region Families.'
             CALL M3EXIT( 'Read_Families',0,0,XMSG,1 )
          END IF
          CALL UPCASE( RegionFamilyName( IFAM ) )
          RegionFamilyNum( IFAM ) = 0

          DO INUM = 1,Desid_Max_Reg_Fam_Members
              IF ( RegionFamilyMembers( IFAM,INUM ) .EQ. '' ) EXIT
              CALL UPCASE( RegionFamilyMembers( IFAM,INUM ) )
              RegionFamilyNum( IFAM ) = INUM
          END DO
      END DO
 

      CLOSE( UNIT = FUNIT )

      CALL LOG_MESSAGE( LOGDEV, ' ' ) ! Add a buffer space in the log file

      end subroutine read_families

! ----------------------------------------------------------------------
      subroutine map_chem_families( species0, spec_vec, nvec, out_vec )
! ----------------------------------------------------------------------
!     Return a vector out_vec of size nvec, equal to the size of specvec.
!     Out_vec is a logical which maps the input species name "species" 
!     to specvec, expanding any chemical families or keywords.
! ----------------------------------------------------------------------

      USE AERO_DATA, ONLY: N_MODE, MODESUFF, AEROSPC, N_AEROSPC
      USE RUNTIME_VARS, ONLY: LOGDEV
      USE UTILIO_DEFN

      IMPLICIT NONE

      CHARACTER(16), INTENT(IN) :: SPECIES0
      INTEGER      , INTENT(IN) :: NVEC
      CHARACTER(16), INTENT(IN) :: SPEC_VEC( NVEC )
      LOGICAL      , INTENT(OUT):: OUT_VEC( NVEC )

      CHARACTER(16) :: SPECIES

      INTEGER IFAM, ICHEM, IDX, JDX, IM, KDX, NCHEM
      CHARACTER(16) :: CHEM_NAME( 150 ), SN
      CHARACTER(200) :: XMSG

      ! Initialize Emissions Species Array
      SPECIES = SPECIES0
      CALL UPCASE( SPECIES )
      OUT_VEC = .FALSE.


      ! Find Indices of Species Relevant for "species"
      IF ( SPECIES .EQ. 'ALL' ) THEN
         ! Expand to Apply to All Species
         OUT_VEC = .TRUE.
      ELSE     
         ! Determine if the Species Label Refers to A Family and if So, 
         ! Apply the Rule to all members of that Family
         IFAM = INDEX1( SPECIES, N_Chem_Fams, ChemFamilyName )
         IF ( IFAM .EQ. 0 ) THEN
            NCHEM = 1
            CHEM_NAME(1) = SPECIES
         ELSE
            NCHEM = ChemFamilyNum( IFAM )
            CHEM_NAME(1:NCHEM) = ChemFamilyMembers( IFAM,1:NCHEM )
         END IF
      
         DO ICHEM = 1,NCHEM
           ! Find the Specific Species this Rule Identifies
           IDX = INDEX1( CHEM_NAME( ICHEM ), NVEC, SPEC_VEC )
           JDX = INDEX1( CHEM_NAME( ICHEM ), N_AEROSPC,  AEROSPC( : )%BULKNAME )
           IF ( IDX .NE. 0 ) THEN
             OUT_VEC( IDX ) = .TRUE.
           ELSE IF ( JDX .NE. 0 ) THEN
             ! This is an aerosol species, and it is being
             ! identified with a bulk name (no mode suffix). 
             ! We need to allow for all possible DIFF_SPC with
             ! all used suffixes
             SN = CHEM_NAME( ICHEM )
             DO IM = 1,N_MODE
               KDX = INDEX1( TRIM( SN )//MODESUFF( IM ), NVEC, SPEC_VEC )
               IF ( KDX .NE. 0 ) OUT_VEC( KDX ) = .TRUE.
             END DO
           ELSE
             WRITE( LOGDEV, '(/,19A,A,1A,A,A,/,A,/,A,/,A,/,A,/,A,/,A)' ),
     &         'Attention: Species ',TRIM(SPECIES),':',TRIM(CHEM_NAME(ICHEM)),
     &         ' was used in the CMAQ Chemical',
     &         ' Control Instructions but it is not a valid CMAQ ',
     &         'transported species or family. Please add it to one of the ',
     &         'input chemical namelists (ie. GC, AE, etc), if desired. If the ',
     &         'variable is on an emission file and not a CMAQ species, no ',
     &         'further action is required. Note that aerosol Number and Surface ',
     &         'Area Species are not valid for scaling.'
            END IF
         END DO
      END IF 
 
      end subroutine map_chem_families

      end module util_Family_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE GETRXNS( NOUT, NTERM, NR, RXNUM, COEFF, LRXINC )

C-----------------------------------------------------------------------
C Function: To get the reaction numbers and coefficients for the
C           PROD/LOSS/NET operators
             
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI's M3UTILIO
C  Sep 2018 C. Nolte: remove unused M3UTILIO 
C-----------------------------------------------------------------------

      USE PA_GLOBAL     ! Mech data used 
      USE PA_VARS
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
      
C Arguments:
      INTEGER NOUT     ! The incoming output number
      INTEGER NTERM    ! The incoming term number in the output list
      INTEGER NR       ! The outgoing number of reactions found
      INTEGER :: RXNUM ( MXRXNS )  ! The reaction numbers found
      REAL    :: COEFF ( MXRXNS )  ! The coefficients of the reactions found
      LOGICAL :: LRXINC( MXRXNS )  ! Flag to include reaction in prod,
                                   ! loss, or net operations
      
C Parameters: None

C External Functions: 

      REAL MOLCLOSS    ! Function to get number of species or 
                       ! family molecules lost in a reaction
      REAL MOLCPROD    ! Function to get number of species or 
                       ! family molecules produced in a reaction

C Local Variables:

      CHARACTER(  4 ) :: NAMETYPE  ! Type of name (mech or family)
      CHARACTER(  4 ) :: TYPE      ! Type of term
      CHARACTER( 11 ) :: SP1      ! Species name holder
      CHARACTER( 11 ) :: SP2      ! species name holder

      INTEGER INDX       ! Holder for pointer 
      INTEGER NPFND      ! Number of reactant species found
      INTEGER NRFND      ! Number of reactant species found
      INTEGER NRFND1     ! Holder for number of reactant species found
      INTEGER NRX        ! Loop index for number of reactions

      LOGICAL LINCL      ! Flag to include reaction in output
      LOGICAL LTEST1, LTEST2    ! Flags to indicate that test passed

      REAL COEF          ! Coefficient for product or reactant 
      REAL COEF2         ! Coefficient for reactant for LOSS/OR operator
      REAL SUM           ! Sum of molecular production and loss
         
C-----------------------------------------------------------------------

      TYPE = OUTTYPE( NOUT,NTERM )
      NR = 0

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Do the production operator
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( TYPE .EQ. 'PROD' .OR. TYPE .EQ. 'NETP' ) THEN

         DO 20 NRX = 1, NRXNS

c..Skip the reaction if it is in a cycle or the species is not produced
            IF ( .NOT. LRXINC( NRX ) ) GO TO 20
            NAMETYPE = OUTS1TYP( NOUT,NTERM )
            INDX = OUTS1NUM( NOUT,NTERM )
            IF ( TYPE .EQ. 'PROD' ) THEN 
               COEF = MOLCPROD( NAMETYPE, INDX, NRX, NPFND )              
            ELSE
               COEF = MOLCPROD( NAMETYPE, INDX, NRX, NPFND ) -
     &                MOLCLOSS( NAMETYPE, INDX, NRX, NRFND )
            END IF
            IF ( COEF .LE. 0.0 ) GO TO 20

            NRFND1 = 0

c..Set the test flag for the FROM operator
            LTEST1 = .FALSE.
            IF ( OUTSPEC2( NOUT,NTERM ) .EQ. '' ) THEN
               LTEST1 = .TRUE.
            ELSE
               NAMETYPE = OUTS2TYP( NOUT,NTERM )
               INDX  = OUTS2NUM( NOUT,NTERM ) 
               IF ( OUTSPEC2( NOUT,NTERM ) .NE. 'hv' ) THEN
                  SUM = MOLCLOSS( NAMETYPE, INDX, NRX, NRFND )
                  NRFND1 = NRFND
                  IF ( NRFND .NE. 0 ) LTEST1 = .TRUE.
               ELSE
                  IF ( BTEST( IRXBITS( NRX ), 1 ) ) LTEST1 = .TRUE.
               END IF
            END IF

c..Set the test flag for the AND/OR operator 
            LTEST2 = .FALSE.
            IF ( OUTSPEC3( NOUT,NTERM  ) .EQ. ''  ) THEN
               LTEST2 = .TRUE.
            ELSE
               SP1  = OUTSPEC2( NOUT,NTERM )
               SP2  = OUTSPEC3( NOUT,NTERM )
               NAMETYPE  = OUTS3TYP( NOUT,NTERM )
               INDX = OUTS3NUM( NOUT, NTERM ) 
               IF ( OUTSPEC3( NOUT,NTERM ) .NE. 'hv' ) THEN
                  SUM = MOLCLOSS( NAMETYPE, INDX, NRX, NRFND )
                  IF ( SP1 .NE. SP2 ) THEN
                     IF ( NRFND .GT. 0 ) LTEST2 = .TRUE.
                  ELSE
                     NRFND = NRFND + NRFND1
                     IF ( NRFND .GE. 4 ) LTEST2 = .TRUE.
                  END IF
               ELSE
                  IF ( BTEST( IRXBITS( NRX ), 1 ) ) LTEST2 = .TRUE.
               END IF
            END IF

c..Determine whether this reaction is to be included
            LINCL = .FALSE.
            IF ( OUTSPEC2( NOUT,NTERM ) .EQ. '' ) THEN
               LINCL = .TRUE.
            ELSE 
               IF ( OUTSPEC3( NOUT,NTERM ) .EQ. '' ) THEN
                  IF ( LTEST1 ) LINCL = .TRUE.
               ELSE                                    
                  IF ( OUTOP2( NOUT,NTERM ) .EQ. 'OR' ) THEN
                     IF ( LTEST1 .OR. LTEST2 ) LINCL = .TRUE.
                  ELSE IF ( OUTOP2( NOUT,NTERM ) .EQ. 'AND' ) THEN
                     IF ( LTEST1 .AND. LTEST2 ) LINCL = .TRUE. 
                  END IF
               END IF
            END IF
  
c..Store reaction data for this term
            IF ( LINCL ) THEN
                NR = NR + 1
                RXNUM( NR ) = NRX
                COEFF( NR ) = COEF
            END IF
20       CONTINUE
         RETURN
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Do the loss operator
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( TYPE .EQ. 'LOSS' .OR. TYPE .EQ. 'NETL' ) THEN
         NRFND1 = 0
         DO 40 NRX = 1, NRXNS

c..Skip the reaction if it is in a cycle and set test1 flag
            IF ( .NOT. LRXINC( NRX ) ) GO TO 40
            LTEST1 = .TRUE.
            NAMETYPE  = OUTS1TYP( NOUT,NTERM )
            INDX = OUTS1NUM( NOUT, NTERM )
            COEF = MOLCLOSS( NAMETYPE, INDX, NRX, NRFND ) -
     &             MOLCPROD( NAMETYPE, INDX, NRX, NPFND )
            IF ( TYPE .EQ. 'LOSS' .AND. NRFND .GT. 0 ) COEF = 1.0
            IF ( COEF .LE. 0.0 ) LTEST1 = .FALSE.

c..Set the test flag for the AND/OR operator 
            LTEST2 = .FALSE.
            IF ( OUTSPEC3( NOUT,NTERM ) .EQ. '' ) THEN
               LTEST2 = .TRUE.
            ELSE
               SP1 = OUTSPEC1( NOUT,NTERM )
               SP2 = OUTSPEC3( NOUT,NTERM )
               NAMETYPE = OUTS3TYP( NOUT,NTERM )
               INDX = OUTS3NUM( NOUT,NTERM ) 
               IF ( OUTSPEC3( NOUT,NTERM ) .NE. 'hv' ) THEN
                  COEF2 = MOLCLOSS( NAMETYPE, INDX, NRX, NRFND ) -
     &                    MOLCPROD( NAMETYPE, INDX, NRX, NPFND )
                  IF ( TYPE .EQ. 'LOSS' .AND. NRFND .GT. 0 ) COEF2 = 1.0
                  IF ( SP1 .NE. SP2 ) THEN
                     IF ( NRFND .GT. 0 ) LTEST2 = .TRUE.
                  ELSE
                     NRFND = NRFND + NRFND1
                     IF ( NRFND .GE. 4 ) LTEST2 = .TRUE.
                  END IF
               ELSE
                  IF ( BTEST( IRXBITS( NRX ), 1 ) ) LTEST2 = .TRUE.
               END IF
            END IF

c..Determine whether this reaction is to be included
            LINCL = .FALSE.
            IF ( OUTSPEC3( NOUT,NTERM ) .EQ. '' ) THEN
               IF ( LTEST1 ) LINCL = .TRUE.
            ELSE                       
               IF ( OUTOP2( NOUT,NTERM ) .EQ. 'OR' ) THEN
                  IF ( LTEST1 .OR. LTEST2 ) LINCL = .TRUE.
                  IF ( LINCL .AND. .NOT. LTEST1 ) COEF = COEF2
               ELSE IF ( OUTOP2( NOUT,NTERM ) .EQ. 'AND' ) THEN
                  IF ( LTEST1 .AND. LTEST2 ) LINCL = .TRUE. 
               END IF
            END IF

c..Store reaction data for this term
            IF ( LINCL ) THEN
                NR = NR + 1
                RXNUM( NR ) = NRX
                COEFF( NR ) = COEF
            END IF
40       CONTINUE
         RETURN
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Do the net operator
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( TYPE .EQ. 'NET' ) THEN
         DO 60 NRX = 1, NRXNS

c..Skip the reaction if it is in a cycle and set test1 flag
            IF ( .NOT. LRXINC( NRX ) ) GO TO 60
            LTEST1 = .TRUE.
            NAMETYPE = OUTS1TYP( NOUT,NTERM )
            INDX = OUTS1NUM( NOUT,NTERM )
            COEF = MOLCPROD( NAMETYPE, INDX, NRX, NPFND ) -
     &             MOLCLOSS( NAMETYPE, INDX, NRX, NRFND )
            IF ( COEF .NE. 0.0 ) THEN
                NR = NR + 1
                RXNUM( NR ) = NRX
                COEFF( NR ) = COEF
            END IF
60       CONTINUE
         RETURN
      END IF 

      RETURN

      END SUBROUTINE GETRXNS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE  HRDATA

C*************************************************************************
C
C  FUNCTION:  Mechanism & solver data for EBI solver
C
C  PRECONDITIONS: For the CB6R5PFAS_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, Jun 26, 2025
C
C   18 Jul 14 B.Hutzell: revised to use real(8) variables for solution
C*************************************************************************

c..EBI solver fixed parameters
      INTEGER, PARAMETER    ::  NEBITER       = 1000      ! No. of iterations for EBI
      INTEGER, PARAMETER    ::  MAX_CELLS_EBI = 1         ! max # cells in local conc arrays
      REAL( 8 ), PARAMETER  ::  DELTAT        = 2.500D+00 ! EBI time step (min)

c..Mechanism specific variables
      INTEGER   N_SPEC       ! No. of species in mechanism
      INTEGER   N_RXNS       ! No. of reactions in mechanism
      INTEGER   N_EBISP      ! No. of species solved by EBI
      INTEGER   NING1        ! No. of species in group 1
      INTEGER   NING2        ! No. of species in group 2
      INTEGER   N_SPCL_RKS   ! No. of special rate constants
      INTEGER   N_ACTSP      ! No. of species in mechanism (non-ss spec)
      INTEGER   NCELL        ! cell number in EBI Block

c..Control flags
      LOGICAL   L_AE_VRSN    ! Flag for aerosol version of mech
      LOGICAL   L_AQ_VRSN    ! Flag for aqueous chemistry version of mech
      LOGICAL   CALL_IRR     ! Flag initializing for IRR and calling PA_IRR

  ! SWITCH for calling DEGRADE routine
      LOGICAL, SAVE :: CALL_DEG = .TRUE.

c..Miscellaneous variables
      INTEGER   N_EBI_IT      ! No. of iterations for EBI
      INTEGER   N_EBI_STEPS   ! No. of time steps for EBI
      INTEGER   N_INR_STEPS   ! No. of inner time steps for EBI
      INTEGER   PECOL_OFFSET  ! Local Column Offset for processor
      INTEGER   PEROW_OFFSET  ! Local Column Offset for processor
  
      INTEGER, SAVE ::   MODEL_SPECIES ! No. of species in CGRID

      REAL( 8 )    EBI_TMSTEP          ! Time step for EBI loops (min)
      REAL( 8 )    CHEMSTEP            ! Chemistry integration interval (min)

c...Allocatable arrays
      INTEGER, ALLOCATABLE :: EBISP( : )         ! Index of EBI species
      INTEGER, ALLOCATABLE :: SSASP( : )         ! Index of ss species
      INTEGER, ALLOCATABLE :: ACTSP( : )         ! Index of active species
      INTEGER, ALLOCATABLE :: IOLD2NEW( :,: )    ! YC species map, used if NSPECIAL > 0

      REAL( 8 ), ALLOCATABLE ::  RKI(  : )     ! Rate constants
      REAL( 8 ), ALLOCATABLE ::  RKI_SAV(  :,  : )  ! Saved values of RKI for SS species calcs

      REAL( 8 ), ALLOCATABLE ::  YC (  : )      ! Species concentrations
      REAL( 8 ), ALLOCATABLE ::  YC0(  : )      ! Species concentrations
      REAL( 8 ), ALLOCATABLE ::  YCP(  : )      ! Species concentrations
      REAL( 8 ), ALLOCATABLE ::  SYC(  :, : )   ! Species concentrations

      REAL, ALLOCATABLE      :: FORWARD_CONV( : )  ! CGRID to CHEM Species conversion factor
      REAL, ALLOCATABLE      :: REVERSE_CONV( : )  ! CHEM to CGRID Species conversion factor

      REAL( 8 ), ALLOCATABLE ::  RXRAT( : )     ! Reaction rates
      REAL( 8 ), ALLOCATABLE ::  RTOL(  : )        ! Species tolerances
      REAL( 8 ), ALLOCATABLE ::  YCCELL( : )       ! ALL Species in cgrid
      REAL( 8 ), ALLOCATABLE ::  PROD(  : )     ! Prod of species
      REAL( 8 ), ALLOCATABLE ::  LOSS(  : )     ! Loss of species
      REAL( 8 ), ALLOCATABLE ::  PNEG(  : )! Negative production rates

      REAL, ALLOCATABLE      :: PRES( :, :, : )          ! pressure (Pa)
      REAL, ALLOCATABLE      :: QV  ( :, :, : )          ! water vapor (Kg/Kg air)
      REAL, ALLOCATABLE      :: TA  ( :, :, : )          ! temperature (K)

      REAL, ALLOCATABLE      :: SEAICE ( :, :)            ! fractional seaice cover, [-]
      REAL, ALLOCATABLE      :: DENS( :, :, : )           ! mass density (Kg/m^3)

      REAL, ALLOCATABLE      :: SEAWATER_ZONE   ( :,: )       ! fractional area of OPEN+SURF
      LOGICAL, ALLOCATABLE   :: LFLAGIRR    ( :,:,: )     ! Conduct IRR for cell

      REAL( 8 ), ALLOCATABLE ::  ATMPRES ( : )     ! Cell pressure, Atm
!      REAL( 8 ), ALLOCATABLE ::  PRESCELL( : )         ! Cell pressure, Pa
      REAL( 8 ), ALLOCATABLE ::  H2O     ( : )     ! Cell H2O mixing ratio (ppmV)
      REAL( 8 ), ALLOCATABLE ::  TEMP    ( : )     ! Cell Temperature
      REAL( 8 ), ALLOCATABLE ::  DENSITY ( : )     ! Cell mass density (Kg/m3)
      REAL( 8 ), ALLOCATABLE ::  HET     ( :, : )  ! cell heterogeneous reaction rates
      REAL( 8 ), ALLOCATABLE ::  RJIN    ( :, : )  ! J-values for a cell
      REAL( 8 ), ALLOCATABLE ::  SEAWATER ( : )    ! fractional area of OPEN+SURF for specific cell

c..Species indices
      INTEGER, PARAMETER :: NO2              =    1
      INTEGER, PARAMETER :: NO               =    2
      INTEGER, PARAMETER :: O                =    3
      INTEGER, PARAMETER :: O3               =    4
      INTEGER, PARAMETER :: NO3              =    5
      INTEGER, PARAMETER :: O1D              =    6
      INTEGER, PARAMETER :: OH               =    7
      INTEGER, PARAMETER :: HO2              =    8
      INTEGER, PARAMETER :: H2O2             =    9
      INTEGER, PARAMETER :: N2O5             =   10
      INTEGER, PARAMETER :: HNO3             =   11
      INTEGER, PARAMETER :: HONO             =   12
      INTEGER, PARAMETER :: PNA              =   13
      INTEGER, PARAMETER :: SO2              =   14
      INTEGER, PARAMETER :: SULF             =   15
      INTEGER, PARAMETER :: SULRXN           =   16
      INTEGER, PARAMETER :: C2O3             =   17
      INTEGER, PARAMETER :: MEO2             =   18
      INTEGER, PARAMETER :: RO2              =   19
      INTEGER, PARAMETER :: PAN              =   20
      INTEGER, PARAMETER :: PACD             =   21
      INTEGER, PARAMETER :: AACD             =   22
      INTEGER, PARAMETER :: CXO3             =   23
      INTEGER, PARAMETER :: ALD2             =   24
      INTEGER, PARAMETER :: XO2H             =   25
      INTEGER, PARAMETER :: PANX             =   26
      INTEGER, PARAMETER :: FORM             =   27
      INTEGER, PARAMETER :: MEPX             =   28
      INTEGER, PARAMETER :: MEOH             =   29
      INTEGER, PARAMETER :: ROOH             =   30
      INTEGER, PARAMETER :: XO2              =   31
      INTEGER, PARAMETER :: XO2N             =   32
      INTEGER, PARAMETER :: NTR1             =   33
      INTEGER, PARAMETER :: NTR2             =   34
      INTEGER, PARAMETER :: FACD             =   35
      INTEGER, PARAMETER :: CO               =   36
      INTEGER, PARAMETER :: HCO3             =   37
      INTEGER, PARAMETER :: ALDX             =   38
      INTEGER, PARAMETER :: GLYD             =   39
      INTEGER, PARAMETER :: GLY              =   40
      INTEGER, PARAMETER :: MGLY             =   41
      INTEGER, PARAMETER :: ETHA             =   42
      INTEGER, PARAMETER :: ETOH             =   43
      INTEGER, PARAMETER :: KET              =   44
      INTEGER, PARAMETER :: PAR              =   45
      INTEGER, PARAMETER :: ACET             =   46
      INTEGER, PARAMETER :: PRPA             =   47
      INTEGER, PARAMETER :: XPRP             =   48
      INTEGER, PARAMETER :: XPAR             =   49
      INTEGER, PARAMETER :: ROR              =   50
      INTEGER, PARAMETER :: ETHY             =   51
      INTEGER, PARAMETER :: ETH              =   52
      INTEGER, PARAMETER :: OLE              =   53
      INTEGER, PARAMETER :: IOLE             =   54
      INTEGER, PARAMETER :: ISOP             =   55
      INTEGER, PARAMETER :: ISO2             =   56
      INTEGER, PARAMETER :: ISOPRXN          =   57
      INTEGER, PARAMETER :: ISPD             =   58
      INTEGER, PARAMETER :: INTR             =   59
      INTEGER, PARAMETER :: ISPX             =   60
      INTEGER, PARAMETER :: HPLD             =   61
      INTEGER, PARAMETER :: OPO3             =   62
      INTEGER, PARAMETER :: EPOX             =   63
      INTEGER, PARAMETER :: EPX2             =   64
      INTEGER, PARAMETER :: TERP             =   65
      INTEGER, PARAMETER :: TRPRXN           =   66
      INTEGER, PARAMETER :: TERPNRO2         =   67
      INTEGER, PARAMETER :: APIN             =   68
      INTEGER, PARAMETER :: BENZENE          =   69
      INTEGER, PARAMETER :: CRES             =   70
      INTEGER, PARAMETER :: BZO2             =   71
      INTEGER, PARAMETER :: OPEN             =   72
      INTEGER, PARAMETER :: BENZRO2          =   73
      INTEGER, PARAMETER :: TOL              =   74
      INTEGER, PARAMETER :: TO2              =   75
      INTEGER, PARAMETER :: TOLRO2           =   76
      INTEGER, PARAMETER :: XOPN             =   77
      INTEGER, PARAMETER :: XYLMN            =   78
      INTEGER, PARAMETER :: XLO2             =   79
      INTEGER, PARAMETER :: XYLRO2           =   80
      INTEGER, PARAMETER :: NAPH             =   81
      INTEGER, PARAMETER :: PAHRO2           =   82
      INTEGER, PARAMETER :: CRO              =   83
      INTEGER, PARAMETER :: CAT1             =   84
      INTEGER, PARAMETER :: CRON             =   85
      INTEGER, PARAMETER :: OPAN             =   86
      INTEGER, PARAMETER :: ECH4             =   87
      INTEGER, PARAMETER :: CL2              =   88
      INTEGER, PARAMETER :: CL               =   89
      INTEGER, PARAMETER :: HOCL             =   90
      INTEGER, PARAMETER :: CLO              =   91
      INTEGER, PARAMETER :: FMCL             =   92
      INTEGER, PARAMETER :: HCL              =   93
      INTEGER, PARAMETER :: CLNO2            =   94
      INTEGER, PARAMETER :: CLNO3            =   95
      INTEGER, PARAMETER :: SVAVB2           =   96
      INTEGER, PARAMETER :: SVAVB3           =   97
      INTEGER, PARAMETER :: SVAVB4           =   98
      INTEGER, PARAMETER :: SVAVB1           =   99
      INTEGER, PARAMETER :: SESQ             =  100
      INTEGER, PARAMETER :: SESQRXN          =  101
      INTEGER, PARAMETER :: SOAALK           =  102
      INTEGER, PARAMETER :: H2NO3PIJ         =  103
      INTEGER, PARAMETER :: H2NO3PK          =  104
      INTEGER, PARAMETER :: ACLI             =  105
      INTEGER, PARAMETER :: ACLJ             =  106
      INTEGER, PARAMETER :: ACLK             =  107
      INTEGER, PARAMETER :: IEPOXP           =  108
      INTEGER, PARAMETER :: ASO4J            =  109
      INTEGER, PARAMETER :: AISO3J           =  110
      INTEGER, PARAMETER :: AGLYJ            =  111
      INTEGER, PARAMETER :: MTNO3            =  112
      INTEGER, PARAMETER :: AMTNO3J          =  113
      INTEGER, PARAMETER :: AMTHYDJ          =  114
      INTEGER, PARAMETER :: AAVB2J           =  115
      INTEGER, PARAMETER :: AOLGAJ           =  116
      INTEGER, PARAMETER :: AAVB3J           =  117
      INTEGER, PARAMETER :: AAVB4J           =  118
      INTEGER, PARAMETER :: AISO1J           =  119
      INTEGER, PARAMETER :: AOLGBJ           =  120
      INTEGER, PARAMETER :: AISO2J           =  121
      INTEGER, PARAMETER :: ASQTJ            =  122
      INTEGER, PARAMETER :: APOCI            =  123
      INTEGER, PARAMETER :: APNCOMI          =  124
      INTEGER, PARAMETER :: APOCJ            =  125
      INTEGER, PARAMETER :: APNCOMJ          =  126
      INTEGER, PARAMETER :: PCVOC            =  127
      INTEGER, PARAMETER :: PCSOARXN         =  128
      INTEGER, PARAMETER :: VLVPO1           =  129
      INTEGER, PARAMETER :: VSVPO1           =  130
      INTEGER, PARAMETER :: VSVPO2           =  131
      INTEGER, PARAMETER :: VSVPO3           =  132
      INTEGER, PARAMETER :: VIVPO1           =  133
      INTEGER, PARAMETER :: VLVOO1           =  134
      INTEGER, PARAMETER :: VLVOO2           =  135
      INTEGER, PARAMETER :: VSVOO2           =  136
      INTEGER, PARAMETER :: VSVOO3           =  137
      INTEGER, PARAMETER :: VSVOO1           =  138
      INTEGER, PARAMETER :: FORM_PRIMARY     =  139
      INTEGER, PARAMETER :: ALD2_PRIMARY     =  140
      INTEGER, PARAMETER :: BUTADIENE13      =  141
      INTEGER, PARAMETER :: ACROLEIN         =  142
      INTEGER, PARAMETER :: ACRO_PRIMARY     =  143
      INTEGER, PARAMETER :: TOLU             =  144
      INTEGER, PARAMETER :: HG               =  145
      INTEGER, PARAMETER :: HGIIAER          =  146
      INTEGER, PARAMETER :: HGIIGAS          =  147
      INTEGER, PARAMETER :: DMS              =  148
      INTEGER, PARAMETER :: MSA              =  149
      INTEGER, PARAMETER :: HFPODAF          =  150
      INTEGER, PARAMETER :: AHFJ             =  151
      INTEGER, PARAMETER :: HFPODAghyd       =  152
      INTEGER, PARAMETER :: AHFPODAphydJ     =  153
      INTEGER, PARAMETER :: COF2             =  154
      INTEGER, PARAMETER :: AFCOOHphydJ      =  155
      INTEGER, PARAMETER :: PFMOAF           =  156
      INTEGER, PARAMETER :: APFMOAAphydJ     =  157

      END MODULE HRDATA

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PAGRD_DEFN

C process analysis variables that are dependent on NCOLS, NROWS

C Preconditions: HGRD_INIT() called from PAR_INIT, which is called from DRIVER

C Revision History:
C   J.Young 17 Aug 01: create
C   D.Wong, J.Young Oct 01: set dimensions for DELC and CSAV correctly for
C   subdomain; IRROUT must have full domain because of SE_DATA_COPY in pa_output
C   J.Young 31 Jan 05: dyn alloc - establish both horizontal & vertical domain
C   specifications in one module
C   J.Young 22 Dec 05: move proc. analy. stuff from HGRD_DEFN to here. create
C   arrays COLSZ_PE and ROWSZ_PE for proc analy, which are equivalent to
C   COLSX_PE and ROWSX_PE
C   J.Young  8 Jul 10: minor mods
C   S. Roselle 29 Mar 11: Replaced I/O API include files with UTILIO_DEFN
C   J.Young 14 Sep 11: allow default subdomain values
C   J.Young 28 Jun 16: use PA_DEFN module intead of include files
C   J.Young 16 Sep 16: update for inline procan
C   C. Nolte, S. Roselle Sep 18: replace M3UTILIO with UTILIO_DEFN
C   D.Dwong 01 Feb 19: removed all MY_N clauses
C.......................................................................
      USE RUNTIME_VARS

      IMPLICIT NONE

C Total number of columns, rows and layers for PA output
      INTEGER, SAVE :: PACOLS, PAROWS, PALEVS

C Starting and ending column of local PA grid in this processor
      INTEGER, SAVE :: MY_BEGCOL, MY_ENDCOL
C Starting and ending row of local PA grid in this processor
      INTEGER, SAVE :: MY_BEGROW, MY_ENDROW
C Starting and ending layer of local PA grid in this processor
      INTEGER, SAVE :: MY_BEGLEV, MY_ENDLEV

C Starting and ending column of local IRR grid in this processor
      INTEGER, SAVE :: MY_IRR_BEGCOL, MY_IRR_ENDCOL
C Starting and ending row of local IRR grid in this processor
      INTEGER, SAVE :: MY_IRR_BEGROW, MY_IRR_ENDROW
C Starting and ending layer of local IRR grid in this processor
      INTEGER, SAVE :: MY_IRR_BEGLEV, MY_IRR_ENDLEV

C Number of columns and rows of local PA/IRR grid in this processor
      INTEGER, SAVE :: MY_PACOLS, MY_PAROWS

C column and row range for each processor
      INTEGER, ALLOCATABLE, SAVE :: COLSZ_PE( :,: ), ROWSZ_PE( :,: )

C Conc difference for a science process
      REAL, ALLOCATABLE, SAVE :: DELC( :,:,:,: )

C Array for outputting IRR results
      REAL, ALLOCATABLE, SAVE :: IRROUT( :,:,:,: )

C Buffer for writing IRR results
      REAL, ALLOCATABLE, SAVE :: DBUFF( :,:,: )

      CONTAINS
         FUNCTION PAGRD_INIT ( RANK ) RESULT ( SUCCESS )

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN
#ifndef mpas
#ifdef parallel
         USE SE_MODULES          ! stenex (using SE_UTIL_MODULE)
#else
         USE NOOP_MODULES        ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif
         USE PA_DEFN             ! Process Anaylsis control and data variables

         INTEGER, INTENT( IN ) :: RANK
         LOGICAL SUCCESS

         INTEGER IRCOLS
         INTEGER IRROWS
         INTEGER IRLEVS

         INTEGER, ALLOCATABLE :: NCOLS_PE( : )  ! Column range for each PE
         INTEGER, ALLOCATABLE :: NROWS_PE( : )  ! Row range for each PE

         LOGICAL, SAVE :: FIRSTIME = .TRUE.
         INTEGER ALST
         INTEGER X1F0  ! dimension homotopy for parallel or serial
         CHARACTER( 16 ) :: PNAME = 'PAGRD_INIT'
         CHARACTER( 96 ) :: XMSG = ' '

C-----------------------------------------------------------------------

C This function is expected to be called only once - at startup

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            SUCCESS = .TRUE.

            IF ( LIPR .OR. LIRR ) THEN

C Retrieve the process analysis subdomain dimensions:
               IF ( PA_ENDCOL .EQ. 0 ) PA_ENDCOL = GL_NCOLS
               IF ( PA_ENDROW .EQ. 0 ) PA_ENDROW = GL_NROWS
               IF ( PA_ENDLEV .EQ. 0 ) PA_ENDLEV = NLAYS

               IF ( PA_BEGCOL .LT. 1 .OR. PA_ENDCOL .GT. GL_NCOLS .OR.
     &              PA_BEGROW .LT. 1 .OR. PA_ENDROW .GT. GL_NROWS .OR.
     &              PA_BEGLEV .LT. 1 .OR. PA_ENDLEV .GT. NLAYS ) THEN
                  XMSG = 'Process Analysis domain inconsistent with CTM domain' 
                  CALL M3WARN ( PNAME, 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF

#ifndef mpas
C Determine IPR subgrid mapping with data redistribution
               CALL SUBST_SUBGRID_INDEX
     &             ( PA_BEGCOL, PA_ENDCOL, PA_BEGROW, PA_ENDROW,
     &               PA_BEGLEV, PA_ENDLEV,
     &               MY_BEGCOL, MY_ENDCOL, MY_BEGROW, MY_ENDROW,
     &               MY_BEGLEV, MY_ENDLEV, MY_PACOLS, MY_PAROWS )

               PACOLS = PA_ENDCOL - PA_BEGCOL + 1
               PAROWS = PA_ENDROW - PA_BEGROW + 1
               PALEVS = PA_ENDLEV - PA_BEGLEV + 1
#endif

               ALLOCATE ( NCOLS_PE( NPROCS ),
     &                    NROWS_PE( NPROCS ), STAT = ALST )
               IF ( ALST .NE. 0 ) THEN
                  XMSG = '*** PA_NCOLS_PE or PA_NROWS_PE Memory allocation failed'
                  CALL M3WARN ( PNAME, 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF

               ALLOCATE ( COLSZ_PE( 2,NPROCS ),
     &                    ROWSZ_PE( 2,NPROCS ), STAT = ALST )
               IF ( ALST .NE. 0 ) THEN
                  XMSG = '*** COLSX_PE or ROWSX_PE Memory allocation failed'
                  CALL M3WARN ( PNAME, 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF

C Construct the processor-to-subdomain map for IPR domain
               CALL SUBHDOMAIN( NPROCS, NPCOL, NPROW, PACOLS, PAROWS,
     &                          NCOLS_PE, NROWS_PE, COLSZ_PE, ROWSZ_PE )

               MY_PACOLS = NCOLS_PE( RANK+1 )
               MY_PAROWS = NROWS_PE( RANK+1 )

               IF ( LIPR ) THEN

                  ALLOCATE ( DELC( MY_PACOLS,MY_PAROWS,PALEVS,NIPRVAR ),
     &                       STAT = ALST )
                  IF ( ALST .NE. 0 ) THEN
                     XMSG = '*** DELC Memory allocation failed'
                     CALL M3WARN ( PNAME, 0, 0, XMSG )
                     SUCCESS = .FALSE.; RETURN
                  END IF

               END IF

               IF ( LIRR ) THEN

C Determine IRR subgrid mapping without data redistribution
#ifndef mpas
                  CALL SUBST_SUBGRID_INDEX
     &                ( PA_BEGCOL, PA_ENDCOL, PA_BEGROW, PA_ENDROW,
     &                  PA_BEGLEV, PA_ENDLEV,
     &                  MY_IRR_BEGCOL, MY_IRR_ENDCOL, MY_IRR_BEGROW,
     &                  MY_IRR_ENDROW, MY_IRR_BEGLEV, MY_IRR_ENDLEV, 'N' )
#endif

                  X1F0 = ( NCOLS / GL_NCOLS ) * ( NROWS / GL_NROWS )
                  IRCOLS = X1F0 * PACOLS + ( 1 - X1F0 ) * NCOLS
                  IRROWS = X1F0 * PAROWS + ( 1 - X1F0 ) * NROWS
                  IRLEVS = PALEVS

                  ALLOCATE ( IRROUT( IRCOLS,IRROWS,IRLEVS,NIRRVAR ),
     &                       STAT = ALST )
                  IF ( ALST .NE. 0 ) THEN
                     XMSG = '*** IRROUT Memory allocation failed'
                     CALL M3WARN ( PNAME, 0, 0, XMSG )
                     SUCCESS = .FALSE.; RETURN
                  END IF

                  ALLOCATE ( DBUFF( MY_PACOLS,MY_PAROWS,PALEVS ), STAT = ALST )
                  IF ( ALST .NE. 0 ) THEN
                     XMSG = 'ERROR allocating DBUFF'
                     CALL M3WARN ( PNAME, 0, 0, XMSG )
                     SUCCESS = .FALSE.; RETURN
                  ENDIF

               END IF

            ELSE

               PA_BEGCOL = 1
               PA_ENDCOL = 1
               PA_BEGROW = 1
               PA_ENDROW = 1
               PA_BEGLEV = 1
               PA_ENDLEV = 1

               XMSG = 'No Process Analysis for this run'
               CALL M3WARN ( PNAME, 0, 0, XMSG )
               SUCCESS = .TRUE.; RETURN

            END IF

         ELSE   ! called more than once

            XMSG = 'Horizontal domain dependent variables already allocated'
            CALL M3WARN ( PNAME, 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN

         END IF   ! FIRSTIME

         RETURN
         END FUNCTION PAGRD_INIT

      END MODULE PAGRD_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Subroutine getpar( fixed_sg  )

C  Calculates the 3rd moments (M3), masses, aerosol densities, and
C  geometric mean diameters (Dg) of all 3 modes, and the natural logs of
C  geometric standard deviations (Sg) of the Aitken and accumulation modes.

C  The logical variable, WET_MOMENTS_FLAG, dictates whether the
C  calculations in GETPAR are to assume that the aerosol is "wet" or
C  "dry."  In the present context, a "wet" aerosol consists of all
C  chemical components of the aerosol.  A "dry" aerosol excludes
C  particle-bound water and also excludes semivol secondary organic aerosol.

C  NOTE! 2nd moment concentrations (M2) are passed into GETPAR in the
C  CBLK array and are modified within GETPAR only in the event that
C  the Sg value of a given mode has gone outside of the acceptable
C  range (1.05 to 2.50).  The GETPAR calculations implicitly assume
C  that the input value of M2 is consistent with the input value of
C  WET_MOMENTS_FLAG.  If, for example, the input M2 value was calculated
C  for a "dry" aerosol and the WET_MOMENTS_FLAG is .TRUE., GETPAR would
C  incorrectly adjust the M2 concentrations!
C  
C  Outputs: 
C    moment3_conc  third moment, proportional to volume [ m3/m3 ]
C    moment2_conc  second moment, prop. to surface area [ m2/m3 ] 
C                     (adjusted if standard dev. hits limit)
C    aeromode_dens [ kg/m3 ]
C    aeromode_lnsg log of geometric standard deviation
C    aeromode_diam geometric mean diameter [ m ]
C    aeromode_mass mass concentration: [ ug / m**3 ]
C
C SH  03/10/11 Renamed met_data to aeromet_data
C HP and BM 4/2016: Updated use of wet_moments_flag which is now
C    available through AERO_DATA consistent with the moments it refers to
C-----------------------------------------------------------------------

      Use aero_data, only : wet_moments_flag, moment3_conc, moment2_conc, moment0_conc,
     &                       aeromode_dens, aeromode_lnsg, aeromode_diam, aeromode_mass,
     &                       min_dg_dry, min_dg_wet, min_sigma_g, max_sigma_g, n_mode, 
     &                       aerospc, aero_missing, aerospc_conc, aeromode, n_aerospc
      Use const, only : f6pi   

      Implicit None

C Arguments:
      Logical, Intent( In ) :: fixed_sg  ! If TRUE, then the second moment is modified 
                                         ! during each call in order to preserve the 
                                         ! standard deviation at the current value.
                                         !
                                         ! If FALSE, then the standard deviation is 
                                         ! recalculated to be consistent with the current 
                                         ! combination of the 0th, 2nd and 3rd moments.
                                         ! During this calculation, standard deviation is 
                                         ! limited by parameters in AERO_DATA (min_sigma_g 
                                         ! and max_sigma_g)

C Local Variables:
      Real( 8 ) :: xxm0        ! temporary storage of moment 0 conc's
      Real( 8 ) :: xxm2        ! temporary storage of moment 2 conc's
      Real( 8 ) :: xxm3        ! temporary storage of moment 3 conc's
      Real( 8 ) :: xfsum       ! (ln(M0)+2ln(M3))/3; used in Sg calcs
      Real( 8 ) :: lxfm2       ! ln(M2); used in Sg calcs
      Real( 8 ) :: l2sg        ! square of ln(Sg); used in diameter calcs
      Real      :: es36        ! exp(4.5*l2sg); used in diameter calcs

      Real( 8 ), Parameter :: one3d = 1.0D0 / 3.0D0
      Real( 8 ), Parameter :: two3d = 2.0D0 / 3.0D0

      Real,      Parameter :: one3  = 1.0 / 3.0
      Real,      Parameter :: densmin = 1.0E03  ! minimum particle density [ kg/m**3 ]

      Real( 8 ), Save :: minl2sg( n_mode )   ! min value of ln(sg)**2 for each mode
      Real( 8 ), Save :: maxl2sg( n_mode )   ! max value of ln(sg)**2 for each mode

      Real( 8 ) :: factor
      Real( 8 ) :: species_mass
      Real( 8 ) :: sumM3
      Real( 8 ) :: sumMass
      Integer   :: n, spc   ! loop counters

      Logical,   Save :: FirsTime = .True.

C-----------------------------------------------------------------------

      If ( FirsTime ) Then
          ! Set bounds for ln(Sg)**2
          minl2sg = Real( Log( min_sigma_g ) ** 2, 8 )
          maxl2sg = Real( Log( max_sigma_g ) ** 2, 8 )
          FirsTime = .False.
      End If

C *** Calculate aerosol 3rd moment concentrations [ m**3 / m**3 ]

      Do n = 1, n_mode
         sumM3   = 0.0d0
         sumMass = 0.0d0

         Do spc = 1, n_aerospc
            If ( aerospc( spc )%tracer .Or. aero_missing(spc,n) .Or. 
     &         ( aerospc( spc )%no_M2Wet .AND. .Not. wet_moments_flag ) ) Cycle

            factor       = Real( 1.0E-9 * f6pi / aerospc( spc )%density, 8 )
            species_mass = Real( aerospc_conc( spc,n ), 8 )
            sumM3        = sumM3   + factor * species_mass
            sumMass      = sumMass + species_mass
         End Do

         moment3_conc( n )  = Max ( Real( sumM3 ), aeromode( n )%min_m3conc )
         aeromode_mass( n ) = Real( sumMass )
      End Do

C *** Calculate modal average particle densities [ kg/m**3 ]
      aeromode_dens = 1.0E-9 * f6pi * aeromode_mass / moment3_conc
      Where( aeromode_dens .Lt. densmin )
         aeromode_dens = densmin
      End Where

C *** Calculate geometric standard deviations as follows:
c        ln^2(Sg) = 1/3*ln(M0) + 2/3*ln(M3) - ln(M2)
c     NOTES:
c      1. Equation 10-5a of [Binkowski:1999] and Equation 5a of
c         Binkowski&Roselle(2003) contain typographical errors.
c      2. If the square of the logarithm of the geometric standard
c         deviation is out of an acceptable range, reset this value and
c         adjust the second moments to be consistent with this value.
c         In this manner, M2 is artificially increased when Sg exceeds
c         the maximum limit.  M2 is artificially decreased when Sg falls
c         below the minimum limit.

      Do n = 1, n_mode
         xxm0 = Real( moment0_conc( n ), 8 )
         xxm3 = Real( moment3_conc( n ), 8 )
         xfsum = one3d * Log( xxm0 ) + two3d * Log( xxm3 )

         if ( fixed_sg ) then
            l2sg  = Real( aeromode_lnsg( n ) ** 2, 8)

         else
            xxm2  = Real( moment2_conc( n ), 8 )

            lxfm2 = Log( xxm2 )
            l2sg  = xfsum - lxfm2

            l2sg  = Max( l2sg, minl2sg( n ) )
            l2sg  = Min( l2sg, maxl2sg( n ) )

         end if

         lxfm2 = xfsum - l2sg
         moment2_conc( n )  = Real( Exp ( lxfm2 ) )
         aeromode_lnsg( n ) = Real( Sqrt( l2sg ) )

         ES36 = Real( Exp( 4.5d0 * l2sg ) )

         ! Implement a lower-bound on the number concentration that
         ! constrains the mean diameter of each mode to less than 100 um
         moment0_conc( n ) = Max(moment0_conc( n ),
     &                           moment3_conc( n )/(1.0e-12 * es36) )

         aeromode_diam( n ) = ( moment3_conc( n ) / 
     &                          ( moment0_conc( n ) * es36 ) ) ** one3 

      End Do

      Return
      End Subroutine getpar

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPPHOT ( JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C
C  FUNCTION:  Opens the photolysis diagnostic files
C
C  PRECONDITIONS REQUIRED:
C     None
C
C  REVISION  HISTORY:
C       Date   Who          What
C     -------- ----------   -----------------------------------------
C     01/2008  S.Roselle    Adapted from OPDIAM in the aerosol module
C                           for opening the photolysis diagnostic files
C     03/2011  B.Hutzell    Generalized and modified to write out surface albedo
C     03/29/11 S.Roselle    Replaced I/O API include files with UTILIO_DEFN
C     09/30/14 B.Hutzell    Added several diagnostics based on changes to cloud
C                           and aerosol description in radiation transfer solution
C-----------------------------------------------------------------------

      USE GRID_CONF               ! horizontal & vertical domain specifications
      USE RXNS_DATA               ! chemical mechanism declarations and data
      USE UTILIO_DEFN
      USE PHOT_MET_DATA, ONLY:  USE_ACM_CLOUD ! Met and Grid data
      USE PHOT_MOD                            ! photolysis in-line routines and data
      USE MIO_ASCII

      IMPLICIT none

      INCLUDE SUBST_FILES_ID  ! file name parameters

C...Arguments

      INTEGER, INTENT( IN ) :: JDATE  ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME  ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP  ! output time step

C...Local variables

      CHARACTER( 16 ), SAVE :: PNAME = 'OPPHOT'
      CHARACTER( 16 )       :: LAMBDA
      CHARACTER( 96 )       :: XMSG = ' '

      INTEGER N, L, JWL, INCR     ! loop variables
C-----------------------------------------------------------------------

#ifndef mpas
C...Try to open existing file for update

      IF ( .NOT. OPEN3( CTM_RJ_1, FSRDWR3, PNAME ) ) THEN

         XMSG = 'Could not open ' // CTM_RJ_1 // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG( XMSG )

C...Set output file characteristics based on COORD.EXT and open
C...  the photolysis diagnostic file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME
         TSTEP3D = TSTEP

         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D =     1
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD

         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO

         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

C...CSA Variables, Units and Descriptions for RJ_FILE

         N = 1
         VNAME3D( N ) = 'COSZENS'
         UNITS3D( N ) = ''
         VDESC3D( N ) = 'Cosine of Solar Zenith Angle'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'OZONE_COLUMN'
         UNITS3D( N ) = 'DU'
         VDESC3D( N ) = 'Observed Total Ozone Column Density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'NO2_COLUMN'
         UNITS3D( N ) = 'petamolec cm-2'
         VDESC3D( N ) = 'Predicted nitrogen dioxide column density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'CO_COLUMN'
         UNITS3D( N ) = 'petamolec cm-2'
         VDESC3D( N ) = 'Predicted carbon monoxide column density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'SO2_COLUMN'
         UNITS3D( N ) = 'petamolec cm-2'
         VDESC3D( N ) = 'Predicted sulfur dioxide column density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'HCHO_COLUMN'
         UNITS3D( N ) = 'petamolec cm-2'
         VDESC3D( N ) = 'Predicted formaldehyde column density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'TROPO_O3_COLUMN'
         UNITS3D( N ) = 'DU'
         VDESC3D( N ) = 'Predicted Tropospheric Ozone Column density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'JNO2'
         UNITS3D( N ) = 'min-1'
         VDESC3D( N ) = 'Photodissociation rate of NO2'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'JO3O1D'
         UNITS3D( N ) = 'min-1'
         VDESC3D( N ) = 'Photodissociation rate of ozone producing O(1D)'
         VTYPE3D( N ) = M3REAL


         N = N + 1
         VNAME3D( N ) = 'RESOLVED_CFRAC'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'Resolved Cloud Fraction averaged over cloudy layers'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'RESOLVED_WBAR'
         UNITS3D( N ) = 'g m-3'
         VDESC3D( N ) = 'Resolved Cloud Hydrometeor Content averaged over cloudy layers'
         VTYPE3D( N ) = M3REAL
         
         IF( USE_ACM_CLOUD )THEN
             N = N + 1
             VNAME3D( N ) = 'SUBGRID_CFRAC'
             UNITS3D( N ) = '1'
             VDESC3D( N ) = 'Subgrid Cloud Fraction averaged over cloudy layers'
             VTYPE3D( N ) = M3REAL

             N = N + 1
             VNAME3D( N ) = 'SUBGRID_WBAR'
             UNITS3D( N ) = 'g m-3'
             VDESC3D( N ) = 'Subgrid Cloud Hydrometeor Content averaged over cloudy layers'
             VTYPE3D( N ) = M3REAL
         END IF             

         N = N + 1
         VNAME3D( N ) = 'TRANS_DIFFUSE'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band transmission coefficient for diffuse radiation at surface'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'TRANS_DIRECT'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band transmission coefficient for direct radiation at surface'
         VTYPE3D( N ) = M3REAL
 
         N = N + 1
         VNAME3D( N ) = 'REFLECTION'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band reflection coefficient at top of atmosphere'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'CLR_TRANS_DIF'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band diffuse transmission for clear sky at surface'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'CLR_TRANS_DIR'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band direct transmission for clear sky at surface'
         VTYPE3D( N ) = M3REAL
              
         N = N + 1
         VNAME3D( N ) = 'CLR_REFLECTION'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band reflection for clear sky at top of atmosphere'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'TROPO_O3_EXCEED'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'Average Exceedance of modeled ozone column from max fraction of Total Column, '
     &               // ' a relative fraction from total column.'         
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'N_EXCEED_TROPO3'
         UNITS3D( N ) = ''
         VDESC3D( N ) = '# of times predicted tropospheric ozone column exceeds observed total column '
     &               // 'per file time step'          
         VTYPE3D( N ) = M3REAL


         DO JWL = 1, NWL

C...assumes that lamba in nanometers is on order of 100 or less

            WRITE( LAMBDA,'(I3.3)' ) INT( WAVELENGTH( JWL ) )

            N = N + 1
            VNAME3D( N ) = 'ETOT_SFC_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'W m-2'
            VDESC3D( N ) = 'Total Downward Irradiance at surface at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'AOD_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Total Aerosol Optical Depth at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'AOD_ABS_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Absorption Aerosol Optical Depth at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'TAU_CLOUD_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Cloud Optical Depth at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL
#ifdef phot_debug
            N = N + 1
            VNAME3D( N ) = 'SSA_CLOUD_W' // TRIM( LAMBDA )
            UNITS3D( N ) = '1'
            VDESC3D( N ) = 'Column Averaged Cloud Single Scattering Albedo at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'ASY_CLOUD_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Column Averaged Cloud Asymmetry Factor at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL
#endif
            N = N + 1
            VNAME3D( N ) = 'TAU_TOT_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Total Optical Depth at'
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'TAUO3_TOP_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Optical Depth of O3 above model domain at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'ALBEDO_W' // TRIM( LAMBDA )
            UNITS3D( N ) = '1'
            VDESC3D( N ) = 'Surface Albedo at the wavelength at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

         ENDDO

         N = N + 1
         VNAME3D( N ) = 'AOD_W550_ANGST' 
         UNITS3D( N ) = ''
         VDESC3D( N ) = 'Aerosol Optical Depth at'
     &                // ' 550 nm based on an Angstrom Interpolation'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'AAOD_W550_ANGST' 
         UNITS3D( N ) = ''
         VDESC3D( N ) = 'Aerosol Absorption Optical Depth at'
     &                // ' 550 nm based on an Angstrom Interpolation'
         VTYPE3D( N ) = M3REAL

         NVARS3D = N

         FDESC3D( 1 ) = 'Surface Values of Optical Inputs and Radiative Results '
         FDESC3D( 2 ) = 'from the In-line calculation of Photolysis Rates '
         FDESC3D( 3 ) = 'for the ' // TRIM( MECHNAME ) // ' photochemical mechanism '
         DO L = 4, MXDESC3
            FDESC3D( L ) = ' '
         END DO

!C...Write ascii table describing variables
!         WRITE(LOGDEV,'(A)')'*PHOTDIAG1 File Contents'
!         WRITE(LOGDEV,'(A)')'**Surface Values of Optical Inputs and Radiative '
!     &                   // 'Results from the In-line calculation of Photolysis Rates '
!         WRITE(LOGDEV,99950)
!         WRITE(LOGDEV,99951)
!         DO L = 1, NVARS3D
!            WRITE(LOGDEV,99952)TRIM(VNAME3D( L )),TRIM(UNITS3D( L )),TRIM(VDESC3D( L ))
!         END DO

         ! Store MIO Metadata
         NDIMS3D( 1:NVARS3D ) = 4
         L_TSTEP( 1:NVARS3D ) = .True.
         L_LAY  ( 1:NVARS3D ) = .True.
         L_COL  ( 1:NVARS3D ) = .True.
         L_ROW  ( 1:NVARS3D ) = .True.
         L_VEXT ( 1:NVARS3D ) = .False.
       
         CALL LOAD_MIO_FILE ( 'CTM_RJ_1', NLAYS3D, 1, NLAYS3D,
     &        VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &        VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &        L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &        L_VEXT(1:NVARS3D) )
 

C...Open the 1st photolysis diagnostic file

         IF ( .NOT. OPEN3( CTM_RJ_1, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// CTM_RJ_1 // ' file'
            CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF
    
C...Try to open existing file for update

      IF ( .NOT. OPEN3( CTM_RJ_2, FSRDWR3, PNAME ) ) THEN

         XMSG = 'Could not open ' // CTM_RJ_2 // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG ( XMSG )

C...Set output file characteristics based on COORD.EXT and open
C...  the photolysis diagnostic file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME
         TSTEP3D = TSTEP

         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D = NLAYS_DIAG
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO

         FDESC3D( 1 ) = 'Three dimensional values of Photolysis rates '
         FDESC3D( 2 ) = 'used to make predictions for the ' // TRIM( MECHNAME )
         FDESC3D( 3 ) = 'photochemical mechanism from the In-line calculation.'
         FDESC3D( 4 ) = 'Data files can be found in CMAQ repository under subdirectory,'
         FDESC3D( 5 ) = 'UTIL/inline_phot_preproc/photolysis_CSQY_data'
         DO N = 6, MXDESC3
            FDESC3D( N ) = ' '
         END DO

C...load data from photolysis reaction list

         DO N = 1, NPHOTAB
            VNAME3D( N ) = PHOTAB( N )
            VTYPE3D( N ) = M3REAL
            UNITS3D( N ) = 'min-1'
            VDESC3D( N ) = 'Photolysis rates calculated based on data file; ' // VNAME3D(N)
         END DO

         NVARS3D = NPHOTAB
         
!C...Write ascii table describing variables
!         WRITE(LOGDEV,'(A)')'*PHOTDIAG2 File Contents'
!         WRITE(LOGDEV,'(A)')'**Three dimensionals values of Photolysis rates '
!     &                   // 'used to make predictions from the In-line calculation '
!     &                   // ' of Photolysis Rates '
!         WRITE(LOGDEV,99950)
!         WRITE(LOGDEV,99951)
!         DO L = 1, NVARS3D
!            WRITE(LOGDEV,99952)TRIM(VNAME3D( L )),TRIM(UNITS3D( L )),TRIM(VDESC3D( L ))
!         END DO
 
         ! Store MIO Metadata
         NDIMS3D( 1:NVARS3D ) = 4
         L_TSTEP( 1:NVARS3D ) = .True.
         L_LAY  ( 1:NVARS3D ) = .True.
         L_COL  ( 1:NVARS3D ) = .True.
         L_ROW  ( 1:NVARS3D ) = .True.
         L_VEXT ( 1:NVARS3D ) = .False.
       
         CALL LOAD_MIO_FILE ( 'CTM_RJ_2', NLAYS3D, 1, NLAYS3D,
     &        VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &        VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &        L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &        L_VEXT(1:NVARS3D) )
 

         IF ( .NOT. OPEN3( CTM_RJ_2, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// CTM_RJ_2 // ' file'
            CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF

C...Try to open existing file for update

      IF ( .NOT. OPEN3( CTM_RJ_3, FSRDWR3, PNAME ) ) THEN

         XMSG = 'Could not open ' // CTM_RJ_3 // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG ( XMSG )

C...Set output file characteristics based on COORD.EXT and open
C...  the photolysis diagnostic file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME
         TSTEP3D = TSTEP

         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D = NLAYS_DIAG
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO

         FDESC3D( 1 ) = 'Three dimensional values of Optical Inputs and Radiative'
         FDESC3D( 2 ) = 'Results from the In-line photolysis calculation using the'
         FDESC3D( 3 ) =  TRIM( MECHNAME ) // ' photochemical mechanism.'

         DO N = 4, MXDESC3
            FDESC3D( N ) = ' '
         END DO
         
         N = 0
         
         DO L = 1, N_DIAG_WVL

C...assumes that lambda in nanometers is on order of 100 or less

            JWL = DIAG_WVL( L )
            
            WRITE( LAMBDA,'(I3.3)' ) INT( WAVELENGTH( JWL ) )

            N = N + 1
            VNAME3D( N ) = 'AERO_SCAT_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'Km-1'
            VDESC3D( N ) = 'Aerosol Scattering of layer at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'AERO_ASYM_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Aerosol Asymmetry Factor at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'EXT_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'Km-1'
            VDESC3D( N ) = 'Total Extinction of layer for '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'GAS_EXT_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'Km-1' 
            VDESC3D( N ) = 'Total Extinction from Rayleigh scattering NO2 and O3 in layer for '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL
 
            N = N + 1
            VNAME3D( N ) = 'EXT_AERO_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'Km-1'
            VDESC3D( N ) = 'Aerosol Extinction in layer for '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL
            
            N = N + 1
            VNAME3D( N ) = 'ACTINIC_FX_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'W m-2'
            VDESC3D( N ) = 'Net Actinic Flux, '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

        END DO
        
         N = N + 1
         VNAME3D( N ) = 'CFRAC_3D'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'Resolved Cloud Fraction in grid cell'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'EXT_AERO_W550'
         UNITS3D( N ) = 'Km-1'
         VDESC3D( N ) = ' Aerosol Extinction of layer for '
     &                // '550 nm based on an Angstrom Interpolation'
         VTYPE3D( N ) = M3REAL
        

         NVARS3D = N

!C...Write ascii table describing variables
!         WRITE(LOGDEV,'(A)')'*PHOTDIAG3 File Contents'
!         WRITE(LOGDEV,'(A)')'**Three dimensionals values of Optical Inputs and Radiative '
!     &                    // 'Results from the In-line photolysis calculation.'
!         WRITE(LOGDEV,99950)
!         WRITE(LOGDEV,99951)
!         DO L = 1, NVARS3D
!            WRITE(LOGDEV,99952)TRIM(VNAME3D( L )),TRIM(UNITS3D( L )),TRIM(VDESC3D( L ))
!         END DO

         ! Store MIO Metadata
         NDIMS3D( 1:NVARS3D ) = 4
         L_TSTEP( 1:NVARS3D ) = .True.
         L_LAY  ( 1:NVARS3D ) = .True.
         L_COL  ( 1:NVARS3D ) = .True.
         L_ROW  ( 1:NVARS3D ) = .True.
         L_VEXT ( 1:NVARS3D ) = .False.
       
         CALL LOAD_MIO_FILE ( 'CTM_RJ_3', NLAYS3D, 1, NLAYS3D,
     &        VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &        VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &        L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &        L_VEXT(1:NVARS3D) )

C...Open the 3rd photolysis diagnostic file

         IF ( .NOT. OPEN3( CTM_RJ_3, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// CTM_RJ_3 // ' file'
            CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF
#endif

99950    FORMAT('|Variable Name|Units|Description                                   |')         
99951    FORMAT('|:----|:----:|:---------------------------------------------|')
99952    FORMAT('|', A16, '|', A16, '|', A, '|')

      RETURN

      END SUBROUTINE OPPHOT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE ADVBC_MAP ( CONCMIN, BCNAME, BCFAC, ONFILE )
 
C-----------------------------------------------------------------------
C Function:
C   Set up advected species mapping to BCON data - read variable BCNAME
C   from file - if BCNAME is blank, skip read and zero out the BCON array
C   for the variable corresponding to the blank BCNAME
C   BCNAME returned is either the file variable name, the file name
C   corresponding to the ICBC surrogate nate, or blank

C Preconditions:

C Subroutines and functions called:

C   OPEN3, DESC3, INDEX1, TRIMLEN, FINDEX, M3MESG, M3EXIT

C Revision history:
C   Jeff - Aug 1997 Based on beta version
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                      removed deprecated TRIMLEN
C   10 Sep 11 J.Young: changed Namelist surrogate policy to enable use of
C                      icbc factors
C   21 Oct 16 D.Wong: If both surrogate and species are on the BC file, write to
C                     the log that the surrogate is used.
C   01 Feb 19 D.Wong: Implemented centralized I/O approach
C-----------------------------------------------------------------------

      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      USE CENTRALIZED_IO_MODULE, only : n_cio_bc_file_vars, cio_bc_file_var_name

      IMPLICIT NONE
 
C Includes:
      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:
      CHARACTER( 16 ), INTENT( IN )  :: CONCMIN     ! min value allowed for BCs
      CHARACTER( 16 ), INTENT( OUT ) :: BCNAME( : ) ! BC name for adv species
      REAL,            INTENT( OUT ) :: BCFAC ( : ) ! Scale factor for BCs
      LOGICAL,         INTENT( OUT ) :: ONFILE( : ) ! BCs exist on file for this name

C External Functions:
      INTEGER, EXTERNAL :: FINDEX

C Local variables:
      CHARACTER( 16 ) :: PNAME = 'ADVBC_MAP'
!     CHARACTER( 16 ) :: BLNK = ' '
!     CHARACTER( 16 ) :: BLNK = '                '
      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: WRVAR( : )

      INTEGER    WRCNT                ! no. of species not on file
      INTEGER :: XDATE = 999999       ! dummy date
      INTEGER :: XTIME = 999999       ! dummy time
      INTEGER    INDX                 ! Species index
      INTEGER    ISUR                 ! Surrogate index
      INTEGER    ITRNS                ! Transport species index
      INTEGER    SPC, VAR             ! loop copunters
      INTEGER    IERR
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

C Map advected species to bc`s

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         ALLOCATE ( WRVAR( N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV ), STAT = IERR )
         IF ( IERR .NE. 0 ) THEN
            XMSG = 'Error allocating WRVAR'
            CALL M3EXIT( PNAME, XDATE, XTIME, XMSG, XSTAT1 )
         END IF

      END IF
 
      SPC = 0
 
      ! Map advected reactive gas species to bc`s

      IF ( N_GC_TRNS .GT. 0 ) THEN

         WRCNT = 0
         DO VAR = 1, N_GC_TRNS
            SPC = SPC + 1
            ONFILE( SPC ) = .TRUE.
            BCFAC( SPC ) = 1.0
            INDX = 0

            ISUR = FINDEX( GC_TRNS_MAP( VAR ), N_GC_BC, GC_BC_MAP )

            IF ( ISUR .NE. 0 ) THEN   ! variable has a surrogate name
               INDX = INDEX1( GC_BC( ISUR ), n_cio_bc_file_vars, cio_bc_file_var_name )
               IF ( INDX .NE. 0 ) THEN   ! BC file surrogate is used
                  BCNAME( SPC ) = cio_bc_file_var_name( INDX )
                  BCFAC( SPC ) = GC_BC_FAC( ISUR )
               END IF
            END IF

            ! If there is no surrogate or it can`t be found, look 
            ! for the adv species on the BC file
            IF ( ISUR .EQ. 0 .OR. INDX .EQ. 0 ) THEN
               ITRNS = INDEX1( GC_TRNS( VAR ), n_cio_bc_file_vars, cio_bc_file_var_name )
               IF ( ITRNS .NE. 0 ) THEN
                  BCNAME( SPC ) = cio_bc_file_var_name( ITRNS )
               ELSE
                  ONFILE( SPC ) = .FALSE.
                  WRCNT = WRCNT + 1
                  WRVAR( WRCNT ) = GC_TRNS( VAR )
               END IF
            END IF

#ifdef verbose_rdbcon
            write( logdev,* ) '=b=spc,name: ', spc, bcname( spc ),
     &                        '   bcfac:', bcfac( spc )
            write( logdev,* ) ' '
#endif

         END DO

         IF ( WRCNT .GT. 0 ) THEN
            WRITE( LOGDEV,1019 ) TRIM( BNDY_CONC_1 ), TRIM( CONCMIN )
            DO VAR = 1, WRCNT
               WRITE( LOGDEV,1025 ) TRIM( WRVAR( VAR ) )
            END DO
         END IF

      END IF

      ! Map advected aerosol species to bc`s

      IF ( N_AE_TRNS .GT. 0 ) THEN

         WRCNT = 0
         DO VAR = 1, N_AE_TRNS
            SPC = SPC + 1
            ONFILE( SPC ) = .TRUE.
            BCFAC( SPC ) = 1.0
            INDX = 0

            ISUR = FINDEX( AE_TRNS_MAP( VAR ), N_AE_BC, AE_BC_MAP )

            IF ( ISUR .NE. 0 ) THEN   ! variable has a surrogate name
               INDX = INDEX1( AE_BC( ISUR ), n_cio_bc_file_vars, cio_bc_file_var_name )
               IF ( INDX .NE. 0 ) THEN   ! BC file surrogate is used
                  BCNAME( SPC ) = cio_bc_file_var_name( INDX )
                  BCFAC( SPC ) = AE_BC_FAC( ISUR )
               END IF
            END IF
            
            ! If there is no surrogate or it can`t be found, look 
            ! for the adv species on the BC file
            IF ( ISUR .EQ. 0 .OR. INDX .EQ. 0 ) THEN
               ITRNS = INDEX1( AE_TRNS( VAR ), n_cio_bc_file_vars, cio_bc_file_var_name )
               IF ( ITRNS .NE. 0 ) THEN
                  BCNAME( SPC ) = cio_bc_file_var_name( ITRNS )
               ELSE
                  ONFILE( SPC ) = .FALSE.
                  WRCNT = WRCNT + 1
                  WRVAR( WRCNT ) = AE_TRNS( VAR )
               END IF
            END IF

#ifdef verbose_rdbcon
            write( logdev,* ) '=b=spc,name: ', spc, bcname( spc ),
     &                        '   bcfac:', bcfac( spc )
            write( logdev,* ) ' '
#endif

         END DO

         IF ( WRCNT .GT. 0 ) THEN
            WRITE( LOGDEV,1019 ) TRIM( BNDY_CONC_1 ), TRIM( CONCMIN )
            DO VAR = 1, WRCNT
               WRITE( LOGDEV,1025 ) TRIM( WRVAR( VAR ) )
            END DO
         END IF 

      END IF
  
      ! Map advected non-reactive species to bc`s

      IF ( N_NR_TRNS .GT. 0 ) THEN

         WRCNT = 0
         DO VAR = 1, N_NR_TRNS
            SPC = SPC + 1
            ONFILE( SPC ) = .TRUE.
            BCFAC( SPC ) = 1.0
            INDX = 0
            
            ISUR = FINDEX( NR_TRNS_MAP( VAR ), N_NR_BC, NR_BC_MAP )

            IF ( ISUR .NE. 0 ) THEN   ! variable has a surrogate name
               INDX = INDEX1( NR_BC( ISUR ), n_cio_bc_file_vars, cio_bc_file_var_name )
               IF ( INDX .NE. 0 ) THEN   ! BC file surrogate is used
                  BCNAME( SPC ) = cio_bc_file_var_name( INDX )
                  BCFAC( SPC ) = NR_BC_FAC( ISUR )
               END IF
            END IF

            ! If there is no surrogate or it can`t be found, look 
            ! for the adv species on the BC file
            IF ( ISUR .EQ. 0 .OR. INDX .EQ. 0 ) THEN
               ITRNS = INDEX1( NR_TRNS( VAR ), n_cio_bc_file_vars, cio_bc_file_var_name )
               IF ( ITRNS .NE. 0 ) THEN
                  BCNAME( SPC ) = cio_bc_file_var_name( ITRNS )
               ELSE
                  ONFILE( SPC ) = .FALSE.
                  WRCNT = WRCNT + 1
                  WRVAR( WRCNT ) = NR_TRNS( VAR )
               END IF
            END IF

#ifdef verbose_rdbcon
            write( logdev,* ) '=b=spc,name: ', spc, bcname( spc ),
     &                        '   bcfac:', bcfac( spc )
            write( logdev,* ) ' '
#endif

         END DO

         IF ( WRCNT .GT. 0 ) THEN
            WRITE( LOGDEV,1019 ) TRIM( BNDY_CONC_1 ), TRIM( CONCMIN )
            DO VAR = 1, WRCNT
               WRITE( LOGDEV,1025 ) TRIM( WRVAR( VAR ) )
            END DO
         END IF 

      END IF
  
      ! Map advected tracer species to bc`s

      IF ( N_TR_ADV .GT. 0 ) THEN

         WRCNT = 0
         DO VAR = 1, N_TR_ADV
            SPC = SPC + 1
            ONFILE( SPC ) = .TRUE.
            BCFAC( SPC ) = 1.0
            INDX = 0

            ISUR = FINDEX( TR_ADV_MAP( VAR ), N_TR_BC, TR_BC_MAP )

            IF ( ISUR .NE. 0 ) THEN   ! variable has a surrogate name
               INDX = INDEX1( TR_BC( ISUR ), n_cio_bc_file_vars, cio_bc_file_var_name )
               IF ( INDX .NE. 0 ) THEN   ! BC file surrogate is used
                  BCNAME( SPC ) = cio_bc_file_var_name( INDX )
                  BCFAC( SPC ) = TR_BC_FAC( ISUR )
               END IF
            END IF

            ! If there is no surrogate or it can`t be found, look 
            ! for the adv species on the BC file
            IF ( ISUR .EQ. 0 .OR. INDX .EQ. 0 ) THEN
               ITRNS = INDEX1( TR_ADV( VAR ), n_cio_bc_file_vars, cio_bc_file_var_name )
               IF ( ITRNS .NE. 0 ) THEN
                  BCNAME( SPC ) = cio_bc_file_var_name( ITRNS )
               ELSE
                  ONFILE( SPC ) = .FALSE.
                  WRCNT = WRCNT + 1
                  WRVAR( WRCNT ) = TR_ADV( VAR )
               END IF
            END IF

#ifdef verbose_rdbcon
            write( logdev,* ) '=b=spc,name: ', spc, bcname( spc ),
     &                        '   bcfac:', bcfac( spc )
            write( logdev,* ) ' '
#endif

         END DO

         IF ( WRCNT .GT. 0 ) THEN
            WRITE( LOGDEV,1019 ) TRIM( BNDY_CONC_1 ), TRIM( CONCMIN )
            DO VAR = 1, WRCNT
               WRITE( LOGDEV,1025 ) TRIM( WRVAR( VAR ) )
            END DO
         END IF 

      END IF

      RETURN

1015  FORMAT( / 5X, "BC file surrogate ", A, " used instead of adv species, ", A )
1019  FORMAT( / 5X, "No BC's in file " A, " for the following adv species:"
     &          1X, "Set to " A )
1025  FORMAT( 10X, A )

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE STD_CONC

      IMPLICIT NONE

C Function: species, layer pointers and definitions for standard CONC
C calculations
C Revision: J.Young 13Sep2011: Increase size of CONC_FILE_SPCS dimension -
C           previous revision used dynamic allocation, but GET_ENV_LIST
C           was called with the CONC_FILE_SPCS argument before it was allocated
C           D.Wong 11 May 2016: Modified code to provide flexibility to handle
C                environment variable CONC_FILE_SPCS is set to 'ALL' or not set.
C           F.Sidi 09 Sep 2019: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL &
C           added W_VEL to species conc_species list depending on
C           if the user requests the vertical velocity to be output
C
C
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      INTEGER, SAVE :: N_CSPCS = 0 ! Number of chemical species saved to conc file
      INTEGER, SAVE :: C_NLAYS = 1 ! Number of layers saved to conc file

      INTEGER, SAVE, ALLOCATABLE :: CONC_MAP( : ) ! pointer into CGRID
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: C_GC_SPC( : ) ! pointer into GC_SPC
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: C_AE_SPC( : ) ! pointer into AE_SPC
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: C_NR_SPC( : ) ! pointer into NR_SPC
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: C_TR_SPC( : ) ! pointer into TR_SPC

      REAL, SAVE, ALLOCATABLE :: SGRID( :,:,:,: ) ! conc subset

C species classes configuration for CONC 
      INTEGER, SAVE :: C_GC_STRT
      INTEGER, SAVE :: N_C_GC_SPC
      INTEGER, SAVE :: C_AE_STRT
      INTEGER, SAVE :: N_C_AE_SPC
      INTEGER, SAVE :: C_NR_STRT
      INTEGER, SAVE :: N_C_NR_SPC
      INTEGER, SAVE :: C_TR_STRT
      INTEGER, SAVE :: N_C_TR_SPC

      INTEGER, SAVE :: N_C_AE_SPCD

C Logical to test whether met variables are included
      LOGICAL, SAVE :: L_CONC_RH = .FALSE.
      LOGICAL, SAVE :: L_CONC_TA = .FALSE.
      LOGICAL, SAVE :: L_CONC_PRES = .FALSE.

      CONTAINS

         SUBROUTINE CONC_DEFN ()

         USE RUNTIME_VARS
         USE HGRD_DEFN             ! horizontal domain specifications
         USE VGRD_DEFN             ! vertical layer specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE UTILIO_DEFN

         CHARACTER( 16 ) :: PNAME = 'CONC_DEFN'
         CHARACTER( 96 ) :: XMSG = ' '

         INTEGER OFF, VAR, V, NV, LVL
         INTEGER ALLOCSTAT, STATUS
         INTEGER :: JDATE = 0
         INTEGER :: JTIME = 0

         INTEGER, ALLOCATABLE :: GC_MAP( : )
         INTEGER, ALLOCATABLE :: AE_MAP( : )
         INTEGER, ALLOCATABLE :: NR_MAP( : )
         INTEGER, ALLOCATABLE :: TR_MAP( : )

C-----------------------------------------------------------------------

C Retrieve the species saved to the concentration file

         IF ( N_CONC_VARS .EQ. 0 .OR. CONC_FILE_SPCS( 1 ) .EQ. 'ALL' ) THEN
            V = 0
            DO VAR = 1, N_GC_CONC
               V = V + 1
               CONC_FILE_SPCS( V ) = GC_CONC( VAR )
            END DO
            DO VAR = 1, N_AE_CONC
               V = V + 1
               CONC_FILE_SPCS( V ) = AE_CONC( VAR )
            END DO
            DO VAR = 1, N_NR_CONC
               V = V + 1
               CONC_FILE_SPCS( V ) = NR_CONC( VAR )
            END DO
            DO VAR = 1, N_TR_SPC
               V = V + 1
               CONC_FILE_SPCS( V ) = TR_SPC( VAR )
            END DO
            CONC_FILE_SPCS( V + 1 ) = 'RH'
            CONC_FILE_SPCS( V + 2 ) = 'TA'
            CONC_FILE_SPCS( V + 3 ) = 'PRES'
            N_CONC_VARS = V + 3 
         END IF

C  Retrieve CTM_WVEL environmental variable to see if user wants diagnosed vertical velocity
         IF ( W_VEL ) THEN
            CONC_FILE_SPCS( N_CONC_VARS + 1 ) = 'WVEL'
            N_CONC_VARS = N_CONC_VARS + 1
         END IF

C Retrieve the layer range used in the concentration file
        IF ( CONC_ELEV .EQ. -1 ) CONC_ELEV = NLAYS

        IF ( CONC_BLEV .LE. 0 .OR. CONC_ELEV .GT. NLAYS ) THEN
               WRITE( XMSG,'( "Layer range", 2I4, " invalid for this model" )' )
     &         CONC_BLEV, CONC_ELEV
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF
         IF ( CONC_BLEV .NE. 1 ) THEN
               WRITE( XMSG,'( "Layer", I3, " Not 1st layer in CGRID" )' )
     &         CONC_BLEV
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
         END IF

         C_NLAYS = CONC_ELEV - CONC_BLEV + 1

C Create conc subset array

         ALLOCATE ( SGRID( NCOLS,NROWS,C_NLAYS,N_CONC_VARS ),
     &              STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'SGRID memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         SGRID = 0.0

C Check species names against include files and create CONC_MAP, and
C get starting index in CGRID and total count for each species class

         ALLOCATE ( C_GC_SPC( N_CONC_VARS ),
     &              C_AE_SPC( N_CONC_VARS ),
     &              C_NR_SPC( N_CONC_VARS ),
     &              C_TR_SPC( N_CONC_VARS ),
     &              GC_MAP( N_CONC_VARS ),
     &              AE_MAP( N_CONC_VARS ),
     &              NR_MAP( N_CONC_VARS ),
     &              TR_MAP( N_CONC_VARS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'CONC species mapping  memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

         N_C_GC_SPC = 0
         N_C_AE_SPC = 0
         N_C_NR_SPC = 0
         N_C_TR_SPC = 0

         DO VAR = 1, N_CONC_VARS
            V = INDEX1 ( CONC_FILE_SPCS( VAR ), N_GC_SPC, GC_SPC )
            IF ( V .GT. 0 ) THEN
               N_CSPCS = N_CSPCS + 1
               N_C_GC_SPC = N_C_GC_SPC + 1
               C_GC_SPC( N_C_GC_SPC ) = CONC_FILE_SPCS( VAR )
               OFF = 0
               GC_MAP( N_C_GC_SPC ) = V + OFF
            ELSE
               V = INDEX1 ( CONC_FILE_SPCS( VAR ), N_AE_SPC, AE_SPC )
               IF ( V .GT. 0 ) THEN
                  N_CSPCS = N_CSPCS + 1
                  N_C_AE_SPC = N_C_AE_SPC + 1
                  OFF = N_GC_SPC + 1   ! accounts for advected density
                  C_AE_SPC( N_C_AE_SPC ) = CONC_FILE_SPCS( VAR )
                  AE_MAP( N_C_AE_SPC ) = V + OFF
               ELSE
                  V = INDEX1 ( CONC_FILE_SPCS( VAR ), N_NR_SPC, NR_SPC )
                  IF ( V .GT. 0 ) THEN
                     N_CSPCS = N_CSPCS + 1
                     N_C_NR_SPC = N_C_NR_SPC + 1
                     OFF = N_GC_SPC + 1 + N_AE_SPC
                     C_NR_SPC( N_C_NR_SPC ) = CONC_FILE_SPCS( VAR )
                     NR_MAP( N_C_NR_SPC ) = V + OFF
                  ELSE
                     V = INDEX1 ( CONC_FILE_SPCS( VAR ), N_TR_SPC, TR_SPC )
                     IF ( V .GT. 0 ) THEN
                        N_CSPCS = N_CSPCS + 1
                        N_C_TR_SPC = N_C_TR_SPC + 1
                        OFF = N_GC_SPC + 1 + N_AE_SPC + N_NR_SPC
                        C_TR_SPC( N_C_TR_SPC ) = CONC_FILE_SPCS( VAR )
                        TR_MAP( N_C_TR_SPC ) = V + OFF
                     ELSE IF ( CONC_FILE_SPCS( VAR ) .EQ. 'RH' ) THEN
                        L_CONC_RH = .TRUE.
                     ELSE IF ( CONC_FILE_SPCS( VAR ) .EQ. 'TA' ) THEN
                        L_CONC_TA = .TRUE.
                     ELSE IF ( CONC_FILE_SPCS( VAR ) .EQ. 'PRES' ) THEN
                        L_CONC_PRES = .TRUE.
                     ELSE IF ( CONC_FILE_SPCS( VAR ) .NE. 'WVEL' ) THEN
                        XMSG = 'Variable ' // CONC_FILE_SPCS( VAR )
     &                  // ' incorrect for this model'
                        CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
                     END IF
                  END IF
               END IF
            END IF
         END DO

         C_GC_STRT = 1
         C_AE_STRT = C_GC_STRT + N_C_GC_SPC
         C_NR_STRT = C_AE_STRT + N_C_AE_SPC
         C_TR_STRT = C_NR_STRT + N_C_NR_SPC

         IF ( N_C_AE_SPC .GT. 0 ) THEN
            N_C_AE_SPCD = N_C_AE_SPC
         ELSE
            N_C_AE_SPCD = 1
         END IF

         ! Populate CONC species maps
         ALLOCATE ( CONC_MAP( N_CSPCS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'CONC_MAP memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

         VAR = 0
         DO V = 1, N_C_GC_SPC
            VAR = VAR + 1
            CONC_MAP( VAR ) = GC_MAP( V )
         END DO

         DO V = 1, N_C_AE_SPC
            VAR = VAR + 1
            CONC_MAP( VAR ) = AE_MAP( V )
         END DO

         DO V = 1, N_C_NR_SPC
            VAR = VAR + 1
            CONC_MAP( VAR ) = NR_MAP( V )
         END DO

         DO V = 1, N_C_TR_SPC
            VAR = VAR + 1
            CONC_MAP( VAR ) = TR_MAP( V )
         END DO

         ! Deallocate Arrays if Possible
         IF ( N_C_GC_SPC .EQ. 0 ) DEALLOCATE ( C_GC_SPC )
         IF ( N_C_AE_SPC .EQ. 0 ) DEALLOCATE ( C_AE_SPC )
         IF ( N_C_NR_SPC .EQ. 0 ) DEALLOCATE ( C_NR_SPC )
         IF ( N_C_TR_SPC .EQ. 0 ) DEALLOCATE ( C_TR_SPC )

         END SUBROUTINE CONC_DEFN

      END MODULE STD_CONC

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_SETUP_IPR

C-----------------------------------------------------------------------
C Function: To store IPR data that will be needed to 
C           generate the PA report and output INCLUDE files
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified by Jerry Gipson April, 1997, to add ADJC process
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified Jun, 1998 by Jerry Gipson to add PING to the CTM science processes
C  Modified Feb, 2002 by Jerry Gipson to correct IO/API variable names for
C  TOTDIF & TOTTRAN
C  Jun, 2005 Jeff Young to add HADV for yamo
C  Jan, 2006 Jeff Young: change operator names to be 4 chars - they prepend
C species names, which must remain less that 12 chars, i.e. OPNM_<__SPECIES__>
C                                                           12345 67890123456
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI`s M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
      USE UTILIO_DEFN
      USE PA_GLOBAL     ! Mech data used 
      USE PA_VARS, Only: NFAMLYS, FAMNAME, NUMFAMMEM, FAMMEMNAM, FAMSC
      USE PA_IPRVARS
      USE PA_DEFN
      USE PA_PARSE, Only: IZERO
      USE CGRID_SPCS, Only: N_CGRID_SPC, CGRID_NAME

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables:
      INTEGER IFM    ! Family pointer 
      INTEGER ISPC   ! Species pointer
      INTEGER N      ! Loop counter
      INTEGER NIPR   ! Loop counter on IPR output commands
      INTEGER IPRSPC ! Loop counter on IPR output commands
      INTEGER ICG    ! Loop index for species
      INTEGER ISV    ! Loop index for species
      INTEGER ASTAT  ! Memory allocation status

      LOGICAL :: LSAVSP( N_CGRID_SPC )  ! Flag to save species conc for PA

      CHARACTER( 16 )  :: IPRNAME_TMP( MAXIPROUT )
      CHARACTER( 60 )  :: IPRDESC_TMP( MAXIPROUT )
      INTEGER          :: MAP_IPRVARtoSPC_TMP( MAXIPROUT )
      LOGICAL          :: MASK_IPR_PROC_TMP( MAXIPROUT,NPRCS )
      INTEGER          :: MAP_IPRtoCGRID_TMP( MAXIPRSPC,MXSPEC )
      REAL             :: SPCOEF_TMP( MAXIPRSPC,MXSPEC )
      CHARACTER( 200 ) :: MSG = ' '
         
C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Set up the Process analysis output pointers 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      NIPRVAR = 0
      DO NIPR = 1, N_IPR_SPC
         IF ( LEN_TRIM( IPR_SPNAM( NIPR ) ) .GT. 11 ) THEN
            WRITE( *,* ) ' '
            WRITE( MSG, 94030 ) TRIM( IPR_SPNAM( NIPR ) )
            CALL M3MESG( MSG )
            WRITE( MSG, 94031 )
            CALL M3MESG( MSG )
         END IF

         DO N = 1, N_IPR_OPS( NIPR )

            NIPRVAR = NIPRVAR + 1

            IF ( NIPRVAR .GT. MAXIPROUT ) THEN
               WRITE( MSG, 94000 ) 
               CALL M3MESG( MSG )
               WRITE( MSG, 94020 ) MAXIPROUT
               CALL M3MESG( MSG )
               CALL M3EXIT( 'GETEXTDAT', IZERO, IZERO, ' ', XSTAT2 )
            END IF

            IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'ZADV' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'ZADV_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Z-Advection of ' // 
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_ZADV ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'XADV' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'XADV_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Horizontal X-Advection of ' //
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_XADV ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'YADV' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'YADV_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Horizontal Y-Advection of ' //
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_YADV ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'HDIF' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'HDIF_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Horizontal diffusion for ' // 
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_HDIF ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'VDIF' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'VDIF_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Vertical diffusion for ' // 
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_VDIF ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'EMIS' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'EMIS_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Emissions of ' // 
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_EMIS ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'DDEP' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'DDEP_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Dry deposition for ' // 
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_DDEP ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'CLDS' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'CLDS_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Clouds for ' // 
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_CLDS ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'PVO3' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'PVO3_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'Potential Vorticity for ' // 
     &                                    IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_PVO3 ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'CHEM' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'CHEM_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'Chemistry of ' // 
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_CHEM ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'COND' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'COND_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'Condensation for ' // 
     &                                    IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_COND ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'COAG' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'COAG_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'Coagulation for ' // 
     &                                    IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_COAG ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:5 ) .EQ. 'GROW' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'GROW_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'Aerosol Growth (Renaming) for ' // 
     &                                    IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_GROW ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:3 ) .EQ. 'NPF' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'NPF_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'New Particle Formation for ' // 
     &                                    IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_NPF ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'AERO' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'AERO_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Aerosol Impact on ' // 
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_COND ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_COAG ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_GROW ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_NPF ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'HADV' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'HADV_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Horizontal Advection of ' //
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_XADV ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_YADV ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'MADV' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'MADV_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Horizontal and Vertical Advection of ' //
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_ZADV ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_XADV ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_YADV ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'TDIF' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'TDIF_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Total Diffusion of ' //
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_HDIF ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_VDIF ) = .TRUE.

            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'TRNM' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'TRNM_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Total Mass-Conserving Transport of ' //
     &                                   IPR_SPNAM( NIPR )
               MAP_IPRVARtoSPC_TMP( NIPRVAR )= NIPR
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_HDIF ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_VDIF ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_ZADV ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_XADV ) = .TRUE.
               MASK_IPR_PROC_TMP( NIPRVAR,IPR_YADV ) = .TRUE.

            ELSE
               MSG = 'Unknown Process ' // TRIM(IPR_OPNAME(NIPR,N )) //
     &               ' has been selected in Process Analysis.'
               CALL M3EXIT( 'PA_SETUP_IPR',0,0,MSG,XSTAT2 )
            END IF
         END DO
      END DO

      ! Save Name and Description Vectors for Processes
      ALLOCATE( IPRNAME( NIPRVAR ),
     &          IPRDESC( NIPRVAR ), 
     &          MAP_IPRVARtoSPC( NIPRVAR ),
     &          MASK_IPR_PROC( NIPRVAR,NPRCS ),
     &          STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 2 allocating IPR variables'
         CALL M3EXIT ( 'PA_SETUP_IPR', 0, 0, MSG, XSTAT2 )
      END IF
      IPRNAME = IPRNAME_TMP( 1:NIPRVAR )
      IPRDESC = IPRDESC_TMP( 1:NIPRVAR )
      MAP_IPRVARtoSPC = MAP_IPRVARtoSPC_TMP( 1:NIPRVAR )
      MASK_IPR_PROC = MASK_IPR_PROC_TMP( 1:NIPRVAR,: )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Set up the species pointers for the IPR Outputs
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LSAVSP = .FALSE.

      ALLOCATE( NCGRID ( N_IPR_SPC ), 
     &           STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 3 allocating IPR variables'
         CALL M3EXIT ( 'PA_SETUP_IPR', 0, 0, MSG, XSTAT2 )
      END IF
      
      ! Map IPR Species Names to CGRID
      MAP_IPRtoCGRID_TMP = 0
      SPCOEF_TMP = 0

      DO IPRSPC = 1, N_IPR_SPC
         ICG = INDEX1( IPR_SPNAM( IPRSPC ), N_CGRID_SPC, CGRID_NAME )
         IF ( ICG .NE. 0 ) THEN
            NCGRID( IPRSPC ) = 1
            MAP_IPRtoCGRID_TMP( IPRSPC,1 ) = ICG
            SPCOEF_TMP( IPRSPC,1 ) = 1.0
         ELSE
            ! This IPR Species is a Family. Find its members on CGRID
            IFM = INDEX1( IPR_SPNAM( IPRSPC ), NFAMLYS, FAMNAME )
            NCGRID( IPRSPC ) = NUMFAMMEM( IFM )
            DO N = 1, NUMFAMMEM( IFM )
               ICG = INDEX1( FAMMEMNAM( IFM,N ), N_CGRID_SPC, CGRID_NAME )
               MAP_IPRtoCGRID_TMP( IPRSPC,N ) = ICG
               SPCOEF_TMP( IPRSPC,N ) = FAMSC( IFM,N )
            END DO
         END IF
      END DO
      MXCGRID = MAX( 1, MAXVAL( NCGRID( : ) ) )

      ALLOCATE( MAP_IPRtoCGRID( N_IPR_SPC,MXCGRID ),
     &          SPCOEF ( N_IPR_SPC,MXCGRID ), 
     &          STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 4 allocating IPR variables'
         CALL M3EXIT ( 'PA_SETUP_IPR', 0, 0, MSG, XSTAT2 )
      END IF
      MAP_IPRtoCGRID  = MAP_IPRtoCGRID_TMP( 1:N_IPR_SPC,1:MXCGRID )
      SPCOEF          = SPCOEF_TMP( 1:N_IPR_SPC,1:MXCGRID )

      RETURN

C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( 'ERROR: Maximum number of IPR_OUTPUTs exceeded' )
94020 FORMAT( '       Modify PARAMETER ( MAXIPROUT =', I3,' ) or',
     &              ' decrease the number of IPR_OUTPUTs' )
94030 FORMAT( 'WARNING: Species name ', A, ' too long.' )
94031 FORMAT( '     Combined variable name will ',
     &        'exceed the I/O-API''s 16 character limit.' )
            
      END SUBROUTINE PA_SETUP_IPR

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
      MODULE MEGAN_GSPRO

!
! This module determines the speciation map files to use and populates 
! the MEGAN_NAMES array. This array is used in EMIS_DEFN.F via the 
! variable vdemis_me in the MIOG stream.
!

      IMPLICIT NONE
         
           INTEGER, SAVE :: NMGNSPC
           INTEGER, SAVE :: n_scon_spc 
           CHARACTER( 16 ), ALLOCATABLE :: MEGAN_NAMES(:)
           INTEGER, ALLOCATABLE ::  spmh_map(:),mech_map(:)   ! speciated species name

           REAL, ALLOCATABLE :: conv_fac(:)        
           REAL,ALLOCATABLE :: mech_mwt(:)
           CHARACTER( 16 ), ALLOCATABLE :: mech_spc(:)

            INCLUDE 'SPC_NOCONVER.EXT'
            INCLUDE 'SPC_CB6_AE7.EXT'
            INCLUDE 'SPC_CRACMM2.EXT'        ! new in CMAQ 5.5
            INCLUDE 'SPC_CRACMM3.EXT'        ! new in CMAQ 6.0
            INCLUDE 'SPC_SAPRC07T.EXT'       ! new in MEGAN3
            INCLUDE 'MAP_CV2CB6_AE7.EXT'      
            INCLUDE 'MAP_CV2CRACMM2.EXT'
            INCLUDE 'MAP_CV2CRACMM3.EXT'
            INCLUDE 'MAP_CV2SAPRC07T.EXT'

         CONTAINS

         subroutine MEGAN_MAP

         USE RXNS_DATA, ONLY : MECHNAME
         USE RUNTIME_VARS, ONLY : LOGDEV
         USE UTILIO_DEFN

          IMPLICIT NONE

           CHARACTER( 16 ) :: MECHANISM              ! Mechanism name
           INTEGER ios,INDX
         INTEGER,        PARAMETER :: NMECHS = 7     ! dimension for number of mechanisms considered

         INTEGER I

         CHARACTER( 256 ) :: XMSG
         LOGICAL          :: EFLAG 

         TYPE MIOG_MECH_TYPE
              CHARACTER( 32 ) :: CHEMMECH
              CHARACTER( 16 ) :: MIOGMECH
         END TYPE MIOG_MECH_TYPE
           TYPE( MIOG_MECH_TYPE ) :: MIOG_MECH_MAP( NMECHS ) = (/
     &         MIOG_MECH_TYPE( 'CB6R5HAP_AE7_AQ        ','CB6_ae7 '),
     &         MIOG_MECH_TYPE( 'CB6R5_AE7_AQ           ','CB6_ae7 '),
     &         MIOG_MECH_TYPE( 'CB6R5M_AE7_AQ          ','CB6_ae7 '),
     &         MIOG_MECH_TYPE( 'SAPRC07TC_AE6_AQ       ','SAPRC07T'),
     &         MIOG_MECH_TYPE( 'SAPRC07TIC_AE7I_AQ     ','SAPRC07T'),
     &         MIOG_MECH_TYPE( 'CRACMM2                ','CRACMM2 '),
     &         MIOG_MECH_TYPE( 'CRACMM3                ','CRACMM3 ') /)

            INDX = INDEX1( MECHNAME, NMECHS, MIOG_MECH_MAP%CHEMMECH )
            MECHANISM = MIOG_MECH_MAP( INDX )%MIOGMECH
            EFLAG = .FALSE.
 
          SELECT CASE ( TRIM(MECHANISM) )
            CASE ('SAPRC07T')
              n_scon_spc = n_saprc07t
              NMGNSPC = n_saprc07t_spc
            CASE ('CB6_ae7')
              n_scon_spc = n_cb6_ae7
              NMGNSPC = n_cb6_ae7_spc
            CASE ('CRACMM2')
              n_scon_spc = n_cracmm2
              NMGNSPC = n_cracmm2_spc
            CASE ('CRACMM3')
              n_scon_spc = n_cracmm3
              NMGNSPC = n_cracmm3_spc
            CASE DEFAULT
              EFLAG = .TRUE.
              XMSG = "Mechanism," // TRIM( MECHNAME ) 
     &             // ", is not identified."
              WRITE(LOGDEV,'(A)')TRIM( XMSG )
          ENDSELECT
   
          ALLOCATE ( MEGAN_NAMES(NMGNSPC), STAT = ios )
          ALLOCATE ( spmh_map(n_scon_spc), STAT = ios )
          ALLOCATE ( mech_map(n_scon_spc), STAT = ios )
          ALLOCATE ( conv_fac(n_scon_spc), STAT = ios )
          ALLOCATE ( mech_spc(NMGNSPC ), STAT = ios )
          ALLOCATE ( mech_mwt(NMGNSPC ), STAT = ios )
  
          SELECT CASE ( TRIM(MECHANISM) )
  
            CASE ('SAPRC07T')
              spmh_map(1:n_scon_spc) = spmh_map_saprc07t(1:n_scon_spc)
              mech_map(1:n_scon_spc) = mech_map_saprc07t(1:n_scon_spc)
              conv_fac(1:n_scon_spc) = conv_fac_saprc07t(1:n_scon_spc)
              mech_spc(1:NMGNSPC)    = mech_spc_saprc07t(1:NMGNSPC)
              mech_mwt(1:NMGNSPC)    = mech_mwt_saprc07t(1:NMGNSPC)
              MEGAN_NAMES(1:NMGNSPC)     = mech_spc(1:NMGNSPC)
            CASE ('CB6_ae7')
              spmh_map(1:n_scon_spc) = spmh_map_cb6_ae7(1:n_scon_spc)
              mech_map(1:n_scon_spc) = mech_map_cb6_ae7(1:n_scon_spc)
              conv_fac(1:n_scon_spc) = conv_fac_cb6_ae7(1:n_scon_spc)
              mech_spc(1:NMGNSPC)    = mech_spc_cb6_ae7(1:NMGNSPC)
              mech_mwt(1:NMGNSPC)    = mech_mwt_cb6_ae7(1:NMGNSPC)
              MEGAN_NAMES(1:NMGNSPC)     = mech_spc(1:NMGNSPC)
            CASE ('CRACMM2')
              spmh_map(1:n_scon_spc) = spmh_map_cracmm2(1:n_scon_spc)
              mech_map(1:n_scon_spc) = mech_map_cracmm2(1:n_scon_spc)
              conv_fac(1:n_scon_spc) = conv_fac_cracmm2(1:n_scon_spc)
              mech_spc(1:NMGNSPC)    = mech_spc_cracmm2(1:NMGNSPC)
              mech_mwt(1:NMGNSPC)    = mech_mwt_cracmm2(1:NMGNSPC)
              MEGAN_NAMES(1:NMGNSPC)     = mech_spc(1:NMGNSPC)
            CASE ('CRACMM3')
              spmh_map(1:n_scon_spc) = spmh_map_cracmm3(1:n_scon_spc)
              mech_map(1:n_scon_spc) = mech_map_cracmm3(1:n_scon_spc)
              conv_fac(1:n_scon_spc) = conv_fac_cracmm3(1:n_scon_spc)
              mech_spc(1:NMGNSPC)    = mech_spc_cracmm3(1:NMGNSPC)
              mech_mwt(1:NMGNSPC)    = mech_mwt_cracmm3(1:NMGNSPC)
              MEGAN_NAMES(1:NMGNSPC)     = mech_spc(1:NMGNSPC)
            CASE DEFAULT 
              EFLAG = .TRUE.
              XMSG = "Mapping for Mechanism," // TRIM( MECHNAME )
     &             // ", is unspecified."
              WRITE(LOGDEV,'(A)')TRIM( XMSG )
          ENDSELECT
          
          IF( EFLAG )THEN
             XMSG = 'Above Error(s) detected'
             CALL M3EXIT('MAP_MEGAN', 0, 0, XMSG, XSTAT1 )
          END IF


        End subroutine MEGAN_MAP
      END MODULE MEGAN_GSPRO

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE VDIFF_MAP

C-----------------------------------------------------------------------
C Function: index mapping between CGRID, diffusion, dry dep, and emissions
C           species

C Module depends on prior call to DEPV_INIT to get NDEPV_SPC

C Revision History:
C   10 Apr 2008 J.Young: initial implementation using subroutine vdiff_map.F
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 J.Bash: Modified for NH3 bidi component fluxes
C   04 Jan 12 J.Young: Initalize char strings with blank padding

C-----------------------------------------------------------------------
      USE VDIFF_DATA

C global diffusion species
      !INTEGER, SAVE :: N_SPC_DIFF 
     
C global dry dep species
      !INTEGER, SAVE :: N_SPC_DDEP 

      INTEGER, ALLOCATABLE, SAVE :: DIFF_MAP( : ) ! global diff map to CGRID
      INTEGER, ALLOCATABLE, SAVE :: DF2DV   ( : ) ! map from diff spc to depv spc
      INTEGER, ALLOCATABLE, SAVE :: DF2EM   ( : ) ! map from diff spc to emis spc
      INTEGER, ALLOCATABLE, SAVE :: DD2DV   ( : ) ! map from ddep spc to depv spc
      INTEGER, ALLOCATABLE, SAVE :: DEPV_MAP( : ) ! global depv map to CGRID
      INTEGER, ALLOCATABLE, SAVE :: DV2DF   ( : )  ! map from depv spc to diff spc

      ! These Masks Identify the Phase/Nature of Species in The Diffused
      ! Species Vector
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_GAS ( : ) !Gases
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_AERO( : ) !Particles
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_NUM ( : ) !Particles
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_SRF ( : ) !Particles
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_NR  ( : ) !Non-Reactives
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_TRAC( : ) !Tracers

      CHARACTER( 16 ), ALLOCATABLE, SAVE :: DDEP_SPC( : )
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: DEPV_SPC( : )
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: DV2DF_SPC( : )
      REAL,            ALLOCATABLE, SAVE :: DIFF_MW  ( : )

C component flux output variables 
      INTEGER,         SAVE :: N_BD_EMIS, NH3_E, HG_E, HONO_E
      CHARACTER( 16 ), SAVE :: BD_EMIS_SPC( 4 ) = ' '

      CONTAINS

C-----------------------------------------------------------------------
         FUNCTION VDIFF_MAP_INIT( ) RESULT ( SUCCESS )

         USE CGRID_SPCS   ! CGRID species number and offsets
         USE UTILIO_DEFN

         IMPLICIT NONE

C Includes:
         INCLUDE SUBST_EMISPRM   ! Emissions processing control parameters

C Arguments:
         LOGICAL SUCCESS

C External Functions:
         INTEGER, EXTERNAL :: FINDEX

C Local variables:
         
         CHARACTER( 80 )  :: XMSG       ! Message text
         CHARACTER( 16 )  :: PNAME = 'VDIFF_MAP'

         INTEGER STRT, FINI
         INTEGER S, V, N, I, INDX
         INTEGER ALLOCSTAT

         LOGICAL LERROR                    ! Error flag

!-----------------------------------------------------------------------
         SUCCESS = .TRUE.

         N_SPC_DIFF = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_DIFF
         
         ALLOCATE ( DIFF_MAP( N_SPC_DIFF+1 ),
     &              DF2DV( N_SPC_DIFF+1 ),
     &              DIFF_MW( N_SPC_DIFF+1 ),
     &              DIFF_SPC( N_SPC_DIFF+1 ), stat = allocstat )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DIFF_MAP, DF2DV or DIFF_SPC'
            CALL M3WARN( PNAME, 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

         N_SPC_DDEP = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP + N_TR_DDEP

         ALLOCATE ( DD2DV( N_SPC_DDEP+1 ),
     &              DDEP_SPC( N_SPC_DDEP+1 ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DD2DV or DDEP_SPC'
            CALL M3WARN( PNAME, 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

         ALLOCATE ( DEPV_MAP( N_SPC_DEPV+1 ),
     &              DEPV_SPC( N_SPC_DEPV ),
     &              DV2DF( N_SPC_DEPV ),
     &              dv2df_spc( n_spc_depv ), stat = allocstat )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DEPV_MAP, DEPV_SPC, DV2DF or dv2df_spc'
            CALL M3WARN( PNAME, 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

! Populate global maps to CGRID

! Map Diffusion Module Species to Deposition Velocity Species
         I = 0; S = 0; N = 0
         DO V = 1, N_GC_TRNS ! assumes dep.vel species subset of vdif species
            N = N + 1
            INDX = FINDEX( GC_TRNS_MAP( V ), N_GC_DEPV, GC_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               I = I + 1
               DF2DV( N ) = S + INDX
            ELSE
               DF2DV( N ) = N_SPC_DEPV + 1
            END IF
         END DO
         S = S + I     ! S should now be = N_GC_DEPV

         I = 0
         DO V = 1, N_AE_TRNS
            N = N + 1
            INDX = FINDEX( AE_TRNS_MAP( V ), N_AE_DEPV, AE_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               I = I + 1
               DF2DV( N ) = S + INDX
            ELSE
               DF2DV( N ) = N_SPC_DEPV + 1
            END IF
         END DO
         S = S + I     ! S should now be = N_GC_DEPV + N_AE_DEPV

         I = 0
         DO V = 1, N_NR_TRNS
            N = N + 1
            INDX = FINDEX( NR_TRNS_MAP( V ), N_NR_DEPV, NR_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               I = I + 1
               DF2DV( N ) = S + INDX
            ELSE
               DF2DV( N ) = N_SPC_DEPV + 1
            END IF
         END DO
         S = S + I     ! S should now be = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV

         DO V = 1, N_TR_DIFF
            N = N + 1
            INDX = FINDEX( TR_DIFF_MAP( V ), N_TR_DEPV, TR_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               DF2DV( N ) = S + INDX
            ELSE
               DF2DV( N ) = N_SPC_DEPV + 1
            END IF
         END DO

! Map Deposition Velocity Species to Dry Deposition Module Species
         LERROR = .FALSE.
         S = 0; V = 0
         DO N = 1, N_GC_DDEP
            V = V + 1
            INDX = FINDEX ( GC_DDEP_MAP( N ), N_GC_DEPV, GC_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               DD2DV ( V ) = S + INDX        ! Dry Dep Species --> Dep Vel Index
               DDEP_SPC( V ) = GC_DDEP( N )  ! Dep Species Name = Gas Name
            ELSE
               XMSG = 'ERROR: No deposition velocity for DDEP species ' //
     &               GC_DDEP( N )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_DEPV
         DO N = 1, N_AE_DDEP
            V = V + 1
            INDX = FINDEX ( AE_DDEP_MAP( N ), N_AE_DEPV, AE_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               DD2DV ( V ) = S + INDX
               DDEP_SPC( V ) = AE_DDEP( N )
            ELSE
               XMSG = 'ERROR: No deposition velocity for DDEP species ' //
     &               AE_DDEP( N )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_DEPV + N_AE_DEPV
         DO N = 1, N_NR_DDEP
            V = V + 1
            INDX = FINDEX ( NR_DDEP_MAP( N ), N_NR_DEPV, NR_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               DD2DV ( V ) = S + INDX
               DDEP_SPC( V ) = NR_DDEP( N )
            ELSE
               XMSG = 'ERROR: No deposition velocity for DDEP species ' //
     &               NR_DDEP( N )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV
         DO N = 1, N_TR_DEPV
            V = V + 1
            INDX = FINDEX ( TR_DDEP_MAP( N ), N_TR_DEPV, TR_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               DD2DV ( V ) = S + INDX
               DDEP_SPC( V ) = TR_DDEP( N )
            ELSE
               XMSG = 'ERROR: No deposition velocity for DDEP species ' //
     &               TR_DDEP( N )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO
         NH3_E  = 0
         HG_ E  = 0
         HONO_E = 0
         IF ( ABFLUX ) THEN          
            NH3_E = 1
            N_BD_EMIS = NH3_E
            BD_EMIS_SPC( NH3_E ) = 'NH3_Emis'
         END IF
         IF ( HGBIDI ) THEN
            HG_E = NH3_E + 1 
            N_BD_EMIS = HG_E
            BD_EMIS_SPC( HG_E ) = 'HG_Emis'             
         END IF   
         IF ( SFC_HONO ) THEN
            HONO_E = max(NH3_E,HG_E) + 1   
            N_BD_EMIS = HONO_E
            BD_EMIS_SPC( HONO_E ) = 'HONO_Het '                      
         END IF    

! Populate Deposition Velocity Map and Species 
         S = 0
         DO V = 1, N_GC_DEPV
            S = S + 1
            DEPV_MAP( S ) = GC_STRT - 1 + GC_DEPV_MAP( V )
            DEPV_SPC( S ) = GC_SPC( GC_DEPV_MAP( V ) )
         END DO
         DO V = 1, N_AE_DEPV
            S = S + 1
            DEPV_MAP( S ) = AE_STRT - 1 + AE_DEPV_MAP( V )
            DEPV_SPC( S ) = AE_SPC( AE_DEPV_MAP( V ) )
         END DO
         DO V = 1, N_NR_DEPV
            S = S + 1
            DEPV_MAP( S ) = NR_STRT - 1 + NR_DEPV_MAP( V )
            DEPV_SPC( S ) = NR_SPC( NR_DEPV_MAP( V ) )
         END DO
         DO V = 1, N_TR_DEPV
            S = S + 1
            DEPV_MAP( S ) = TR_STRT - 1 + TR_DEPV_MAP( V )
            DEPV_SPC( S ) = TR_SPC( TR_DEPV_MAP( V ) )
         END DO

! Populate Diffusion Module Map and Species
         ALLOCATE( DIFF_MASK_GAS ( N_SPC_DIFF ) )
         ALLOCATE( DIFF_MASK_AERO( N_SPC_DIFF ) )
         ALLOCATE( DIFF_MASK_NUM( N_SPC_DIFF ) )
         ALLOCATE( DIFF_MASK_SRF( N_SPC_DIFF ) )
         ALLOCATE( DIFF_MASK_NR  ( N_SPC_DIFF ) )
         ALLOCATE( DIFF_MASK_TRAC( N_SPC_DIFF ) )
         DIFF_MASK_GAS  = .FALSE.
         DIFF_MASK_AERO = .FALSE.
         DIFF_MASK_NUM  = .FALSE.
         DIFF_MASK_SRF  = .FALSE.
         DIFF_MASK_NR   = .FALSE.
         DIFF_MASK_TRAC = .FALSE.
         DIFF_MAP = 0
         DIFF_SPC = ""
         DIFF_MW  = 0.

         S = 0
         DO V = 1, N_GC_TRNS
            S = S + 1
            DIFF_MAP( S ) = GC_STRT - 1 + GC_TRNS_MAP( V )
            DIFF_SPC( S ) = GC_SPC( GC_TRNS_MAP( V ) )
            DIFF_MW ( S ) = GC_MOLWT( GC_TRNS_MAP( V ) )
            DIFF_MASK_GAS( S ) = .TRUE.
         END DO
         DO V = 1, N_AE_TRNS
            S = S + 1
            DIFF_MAP( S ) = AE_STRT - 1 + AE_TRNS_MAP( V )
            DIFF_SPC( S ) = AE_SPC( AE_TRNS_MAP( V ) )
            DIFF_MW ( S ) = AE_MOLWT( AE_TRNS_MAP( V ) )
            DIFF_MASK_AERO( S ) = .TRUE.
            IF ( INDEX( DIFF_SPC( S ), 'NUM' ) .NE. 0 ) THEN
                DIFF_MASK_NUM( S ) = .TRUE.
            END IF
            IF ( INDEX( DIFF_SPC( S ), 'SRF' ) .NE. 0 ) THEN
                DIFF_MASK_SRF( S ) = .TRUE.
            END IF
         END DO
         DO V = 1, N_NR_TRNS
            S = S + 1
            DIFF_MAP( S ) = NR_STRT - 1 + NR_TRNS_MAP( V )
            DIFF_SPC( S ) = NR_SPC( NR_TRNS_MAP( V ) )
            DIFF_MW ( S ) = NR_MOLWT( NR_TRNS_MAP( V ) )
            DIFF_MASK_NR( S ) = .TRUE.
         END DO
         DO V = 1, N_TR_DIFF
            S = S + 1
            DIFF_MAP( S ) = TR_STRT - 1 + TR_DIFF_MAP( V )
            DIFF_SPC( S ) = TR_SPC( TR_DIFF_MAP( V ) )
            DIFF_MW ( S ) = TR_MOLWT( TR_DIFF_MAP( V ) )
            DIFF_MASK_TRAC( S ) = .TRUE.
         END DO

! Map Deposition Velocity Species to Diffusion Module Species
         S = 0; V = 0
         DO N = 1, N_GC_DEPV
            V = V + 1
            INDX = FINDEX ( GC_DEPV_MAP( N ), N_GC_TRNS, GC_TRNS_MAP )
            IF ( INDX .GT. 0 ) THEN
               DV2DF ( V ) = S + INDX
               dv2df_spc( v ) = gc_trns( indx )
            ELSE
               XMSG = 'ERROR: deposition velocity specified for non-diff species '
     &               // GC_SPC( GC_DEPV_MAP( N ) )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_TRNS
         DO N = 1, N_AE_DEPV
            V = V + 1
            INDX = FINDEX ( AE_DEPV_MAP( N ), N_AE_TRNS, AE_TRNS_MAP )
            IF ( INDX .GT. 0 ) THEN
               DV2DF ( V ) = S + INDX
               dv2df_spc( v ) = ae_trns( indx )
            ELSE
               XMSG = 'ERROR: deposition velocity specified for non-diff species '
     &               // AE_SPC( AE_DEPV_MAP( N ) )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_TRNS + N_AE_TRNS
         DO N = 1, N_NR_DEPV
            V = V + 1
            INDX = FINDEX ( NR_DEPV_MAP( N ), N_NR_TRNS, NR_TRNS_MAP )
            IF ( INDX .GT. 0 ) THEN
               DV2DF ( V ) = S + INDX
               dv2df_spc( v ) = nr_trns( indx )
            ELSE
               XMSG = 'ERROR: deposition velocity specified for non-diff species '
     &               // NR_SPC( NR_DEPV_MAP( N ) )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS
         DO N = 1, N_TR_DEPV
            V = V + 1
            INDX = FINDEX ( TR_DEPV_MAP( N ), N_TR_DIFF, TR_DIFF_MAP )
            IF ( INDX .GT. 0 ) THEN
               DV2DF ( V ) = S + INDX
               dv2df_spc( v ) = tr_diff( indx )
            ELSE
               XMSG = 'ERROR: deposition velocity specified for non-diff species '
     &               // TR_SPC( TR_DEPV_MAP( N ) )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

! Check for Errors and Exit
         IF ( LERROR ) THEN
            XMSG = '*** Species mapping error(s) in VDIFF_MAP'
            CALL M3WARN( PNAME, 0, 0, XMSG )
            SUCCESS = .FALSE.
         END IF

         RETURN

         END FUNCTION VDIFF_MAP_INIT

      END MODULE VDIFF_MAP

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
      
      MODULE ELMO_DERIVED_FXNS

      CONTAINS 

!----------------------------------------------------------------------
      REAL FUNCTION SUM_PM_MODES( MODE_MASK_IN, INLET, WETNESS, IV, ISRC )
     &              RESULT( OUTVAL )
!----------------------------------------------------------------------
!     SUM_PM_MODES returns the sum of total PM Mass ignoring water,
!     organic water, and mass of all aerosol tracer species. It uses the
!     MODE_MASK input variable, which is a vector of logical variables,
!     to determine which modes to sum.
!
!     The input variable IV instructs the function to sum for ISAM or
!     DDM variables instead, and the variable ISRC identifies which
!     source to sum.          
!----------------------------------------------------------------------

      USE AERO_DATA, ONLY: N_MODE, AEROSPC_CONC, AH2O_IDX, AORGH2O_IDX, 
     &                     AEROSPC, N_AEROSPC, AEROMODE
      USE ELMO_DATA, ONLY : ET_CMPST, ET_DRVD, IM_ALL, IM_UF, IM_F,
     &                      IM_C, IM_ACC, IM_AIT, IM_NUC
#ifdef isam      
      USE ELMO_DATA, ONLY : ET_ISAM_CMPST, ET_ISAM_DRVD, ISAM_VEC
      USE SA_DEFN, ONLY : MAP_AEROtoSA, NTAG_SA
#endif
#ifdef sens
      USE ELMO_DATA, ONLY : ET_DDM_CMPST, ET_DDM_DRVD, DDM_VEC
      USE AERO_DDM3D, ONLY : S_AEROSPC_CONC
#endif


      IMPLICIT NONE

      INTEGER :: MODE_MASK_IN         ! Index for Mode Selection
      INTEGER :: IV, ISRC             ! ELMO Variable type, Source number
      INTEGER :: INLET                ! Integer prescribing the inlet type
      INTEGER :: WETNESS              ! 1 = Wet Aerosol; 2 = Dry Aerosol
                                      !   (see ELMO_INLET table in ELMO_DATA module)
      LOGICAL :: MODE_MASK( N_MODE )  ! Mask Indicating which modes to sum
      INTEGER :: IM, IAER, ISA
      REAL    :: FRAC
                                        
      OUTVAL = 0.0

      ! Select Correct Mode Mask
      SELECT CASE ( MODE_MASK_IN )
         CASE( IM_ALL )
            MODE_MASK = AEROMODE%ALL_MASK
         CASE( IM_UF )
            MODE_MASK = AEROMODE%ULTRAFINE_MASK
         CASE( IM_F )
            MODE_MASK = AEROMODE%FINE_MASK
         CASE( IM_C )
            MODE_MASK = AEROMODE%COARSE_MASK
         CASE( IM_ACC )
            MODE_MASK = AEROMODE%ACCUM_MASK
         CASE( IM_AIT )
            MODE_MASK = AEROMODE%AITKEN_MASK
         CASE( IM_NUC )
            MODE_MASK = AEROMODE%NUC_MASK
         CASE DEFAULT
            MODE_MASK = .FALSE.
      END SELECT

      ! Determine Which Type of ELMO Variable is Requested
      SELECT CASE ( IV )
         CASE ( ET_CMPST, ET_DRVD )
            ! Standard ELMO PM Sum
            DO IM = 1,N_MODE
               IF ( MODE_MASK( IM ) ) THEN
                 CALL GET_AERO_INLET( INLET, IM, WETNESS, FRAC )
                 OUTVAL = OUTVAL + FRAC * 
     &                    SUM( AEROSPC_CONC( :,IM ),
     &                         MASK=.NOT.AEROSPC(:)%TRACER .AND.
     &                              .NOT.AEROSPC(:)%NO_M2WET) ! ug m-3
               END IF
            END DO

#ifdef isam            
         CASE ( ET_ISAM_CMPST, ET_ISAM_DRVD )
           ! ISAM PM Sum
           DO IM = 1,N_MODE
              IF ( MODE_MASK(IM) ) THEN
                CALL GET_AERO_INLET( INLET, IM, WETNESS, FRAC )
                DO IAER = 1,N_AEROSPC                  
                  IF ( .NOT. AEROSPC(IAER)%TRACER .AND.
     &                 IAER .NE. AH2O_IDX .AND. IAER .NE. AORGH2O_IDX ) THEN
                    ! Add up PM for this source
                    ISA = MAP_AEROtoSA( IAER, IM )
                    IF ( ISA .NE. 0 ) THEN
                    IF ( ISRC .LE. NTAG_SA ) THEN
                       OUTVAL = OUTVAL + FRAC * ISAM_VEC(ISA,ISRC) 
                    ELSE
                       OUTVAL = OUTVAL + FRAC * SUM(ISAM_VEC( ISA,:) ) 
                    END IF
                    END IF
                  END IF
                END DO
              END IF
           END DO
#endif

#ifdef sens
         CASE ( ET_DDM_CMPST, ET_DDM_DRVD )
           ! DDM PM Sum
           DO IM = 1,N_MODE
              IF ( MODE_MASK(IM) ) THEN
                CALL GET_AERO_INLET( INLET, IM, WETNESS, FRAC )
                DO IAER = 1,N_AEROSPC                  
                  IF ( .NOT. AEROSPC(IAER)%TRACER .AND.
     &                 IAER .NE. AH2O_IDX .AND. IAER .NE. AORGH2O_IDX ) THEN
                    ! Add up PM for this source
                    OUTVAL = OUTVAL + FRAC * S_AEROSPC_CONC(IAER,IM,ISRC) 
                  END IF
                END DO
              END IF
           END DO
#endif          
 

      END SELECT
 
      RETURN
      END FUNCTION SUM_PM_MODES

!----------------------------------------------------------------------
      RECURSIVE FUNCTION SUM_ORGS( ORG_TYPE, ORG_MASK_IN, MODE_MASK_IN, 
     &                        INLET, WETNESS, IV, ISRC ) RESULT( OUTVAL )
!----------------------------------------------------------------------
!     SUM_ORGS returns the sum of total Organic species given a mask
!     of which species to add. This mask should be of the same length
!     as those in the OASPC table. That length of ORG_MASK is 
!     N_OA_NotTracers. The input variable ORG_TYPE specifies which 
!     organic aerosol metric to calcualte (e.g. mass, carbon, OM:OC,
!     or O:C).
!
!     Size specifications are communicated via the MODE_MASK and INLET 
!     parameters.
!
!     The input variable IV instructs the function to sum for ISAM or
!     DDM variables instead, and the variable ISRC identifies which
!     source to sum.          
!----------------------------------------------------------------------

      USE AERO_DATA, ONLY: N_MODE, AEROSPC_CONC, AH2O_IDX, AORGH2O_IDX, 
     &                     AEROSPC, N_AEROSPC, AEROSPC_MAP, 
     &                     APOC_IDX, APNCOM_IDX, AERO_MISSING,
     &                     MAP_MODE_MASK
      USE CGRID_SPCS, ONLY : MAP_CGRIDtoWDEP
      USE VDIFF_MAP, ONLY : DEPV_MAP
      USE SOA_DEFN, ONLY : N_OA, N_OA_NotTracers, MAP_OAtoAERO, OASPC,
     &                     MAP_ORG_MASK
      USE ELMO_DATA, ONLY : ET_CMPST, ET_DRVD, OT_OA, OT_OC, OT_OMOC, 
     &                      OT_OTOC, OT_DD_OA, OT_DD_OC, OT_WD_OA, 
     &                      OT_DD_OC, OT_WD_OC, ET_DRVD_DDEP, ET_DRVD_WDEP,
     &                      ET_ISAM_DRVD, ET_ISAM_DRVD_DDEP, ET_ISAM_DRVD_WDEP,
     &                      ET_DDM_DRVD, ET_DDM_DRVD_DDEP, ET_DDM_DRVD_WDEP,
     &                      DDEP_VEC, WDEP_VEC, ET_AEROPROP
#ifdef isam      
      USE ELMO_DATA, ONLY : ISAM_VEC, ISAM_WDEP_VEC, ISAM_DDEP_VEC
      USE SA_DEFN, ONLY : MAP_AEROtoSA, NTAG_SA
#endif
#ifdef sens
      USE ELMO_DATA, ONLY : DDM_VEC, DDM_WDEP_VEC, DDM_DDEP_VEC
      USE AERO_DDM3D, ONLY : S_AEROSPC_CONC
#endif


      IMPLICIT NONE

      INTEGER :: ORG_TYPE
      INTEGER :: ORG_MASK_IN
      LOGICAL :: ORG_MASK( N_OA )
      INTEGER :: MODE_MASK_IN         ! Parameter selecting the aerosol modes
      LOGICAL :: MODE_MASK( N_MODE )  ! Mask Indicating which modes to sum
      INTEGER :: IV, ISRC             ! ELMO Variable type, Source number
      INTEGER :: INLET                ! Integer prescribing the inlet type
      INTEGER :: WETNESS              ! 1 = Wet Aerosol; 2 = Dry Aerosol
                                      !   (see ELMO_INLET table in ELMO_DATA module)
      INTEGER :: IM, IAER, ISA, IOA, IVAR
      REAL    :: FRAC( N_MODE ), VAL, VAL2,
     &           POC, POM, OtoC
      REAL    :: OUTVAL
 
      ! Select Correct Mode Mask
      CALL MAP_MODE_MASK( MODE_MASK_IN, MODE_MASK )                                 

      ! Loop through modes and calculate inlet fraction     
      ! unless this is OM:OC, in which case the fraction will be applied
      ! at a lower level (i.e. the sums of OA and OC)
      IF ( ORG_TYPE .NE. OT_OMOC ) THEN
        DO IM = 1,N_MODE
           CALL GET_AERO_INLET( INLET, IM, WETNESS, FRAC(IM) )
        END DO
      END IF

      ! Map ORG_MASK_IN input parameter to a Mask of Organic Aerosol
      ! Variables
      CALL MAP_ORG_MASK( ORG_MASK_IN, ORG_MASK )

      ! If Organic Carbon is being calculated, only
      ! consider species with real OM:OC
      IF ( ORG_TYPE .EQ. OT_OC .OR.
     &     ORG_TYPE .EQ. OT_DD_OC .OR.
     &     ORG_TYPE .EQ. OT_WD_OC )
     &   ORG_MASK = ORG_MASK .AND. OASPC( : )%OMtoOC .GT. 0.0


      ! Calculate Organic Aerosol Metric
      OUTVAL = 0.0
 
      SELECT CASE ( ORG_TYPE )
        CASE ( OT_OA )
          ! Sum up organic aerosol mass
          DO IOA = 1,N_OA_NotTracers
             DO IM = 1,N_MODE
                ! Just Select Species from the Org_Mask
                IF ( ORG_MASK( IOA ) .AND. MODE_MASK( IM ) 
     &               .AND. .NOT. AERO_MISSING( MAP_OAtoAERO(IOA),IM) ) THEN
                    
                   IF ( IV .EQ. ET_DRVD ) THEN  ! Core Model
                     OUTVAL = OUTVAL + FRAC( IM ) 
     &                        * AEROSPC_CONC( MAP_OAtoAERO(IOA),IM )

                   ELSE IF ( IV .EQ. ET_ISAM_DRVD ) THEN  ! ISAM
#ifdef isam      
                     IVAR = MAP_AEROtoSA( MAP_OAtoAERO(IOA),IM )
                     IF ( IVAR .NE. 0 ) THEN
                     IF ( ISRC .LE. NTAG_SA ) THEN
                       OUTVAL = OUTVAL + FRAC( IM ) * ISAM_VEC( IVAR,ISRC ) 
                     ELSE
                       OUTVAL = OUTVAL + FRAC( IM ) * SUM(ISAM_VEC( IVAR,: )) 
                     END IF
                     END IF
#endif
                   ELSE IF ( IV .EQ. ET_DDM_DRVD ) THEN  ! DDM
#ifdef sens      
                     IVAR = AEROSPC_MAP( MAP_OAtoAERO(IOA),IM )
                     OUTVAL = OUTVAL + FRAC( IM ) * DDM_VEC( ISRC,IVAR ) 
#endif
                   END IF 
                END IF
             END DO
          END DO
 
        CASE ( OT_OC )
          ! Sum up organic carbon mass
          DO IOA = 1,N_OA_NotTracers
             DO IM = 1,N_MODE 
                ! Just Select Species from the Org_Mask
                IF ( ORG_MASK( IOA ) .AND. MODE_MASK( IM ) 
     &               .AND. .NOT. AERO_MISSING( MAP_OAtoAERO(IOA),IM) ) THEN

                   IF ( IV .EQ. ET_DRVD ) THEN  ! Core Model
                     OUTVAL = OUTVAL + FRAC( IM )
     &                        * AEROSPC_CONC( MAP_OAtoAERO(IOA),IM )
     &                        / OASPC( IOA )%OMtoOC

                   ELSE IF ( IV .EQ. ET_ISAM_DRVD ) THEN  ! ISAM
#ifdef isam      
                     IVAR = MAP_AEROtoSA( MAP_OAtoAERO(IOA),IM ) 
                     IF ( IVAR .NE. 0 ) THEN
                     IF ( ISRC .LE. NTAG_SA ) THEN
                       OUTVAL = OUTVAL + FRAC( IM )
     &                          * ISAM_VEC( IVAR,ISRC ) 
     &                          / OASPC( IOA )%OMtoOC
                     ELSE
                       OUTVAL = OUTVAL + FRAC( IM )
     &                          * SUM(ISAM_VEC( IVAR,: )) 
     &                          / OASPC( IOA )%OMtoOC
                     END IF
                     END IF
#endif

                   ELSE IF ( IV .EQ. ET_DDM_DRVD ) THEN  ! DDM
#ifdef sens      
                     IVAR = AEROSPC_MAP( MAP_OAtoAERO(IOA),IM )
                     OUTVAL = OUTVAL + FRAC( IM )
     &                        * DDM_VEC( ISRC,IVAR ) 
     &                        / OASPC( IOA )%OMtoOC
#endif

                   END IF
                END IF
             END DO
          END DO

        CASE ( OT_OMOC )
          ! Calculate OM:OC of Species selected by ORG_MASK
          VAL = SUM_ORGS( OT_OA, ORG_MASK_IN, MODE_MASK_IN, INLET, 
     &                    WETNESS, ET_DRVD, 0 )

          ORG_MASK = ORG_MASK .AND. OASPC( : )%OMtoOC .GT. 0.0
          VAL2= SUM_ORGS( OT_OC, ORG_MASK_IN, MODE_MASK_IN, INLET, 
     &                    WETNESS, ET_DRVD, 0 )

          OUTVAL = VAL / ( VAL2 + TINY( 0.0 ) )
        
        CASE ( OT_OTOC )
          ! Calculate O:C of Species selected by ORG_MASK
          ! First retrieve OM of this selection
          VAL = SUM_ORGS( OT_OA, ORG_MASK_IN, MODE_MASK_IN, INLET, 
     &                    WETNESS, ET_DRVD, 0 )
        
          ! Now Calculate Weighted O:C
          VAL2 = 0.0
          DO IOA = 1,N_OA_NotTracers
             DO IM = 1,N_MODE
                IF ( ORG_MASK( IOA ) .AND. MODE_MASK( IM ) .AND.
     &               MAP_OAtoAERO(IOA) .NE. APOC_IDX .AND.
     &               MAP_OAtoAERO(IOA) .NE. APNCOM_IDX 
     &               .AND. .NOT. AERO_MISSING( MAP_OAtoAERO(IOA),IM) ) THEN
                
                   IF ( IV .EQ. ET_AEROPROP ) THEN   ! Core Model
                      ! Weight OA Sum by O:C
                      VAL2 = VAL2 + FRAC( IM )
     &                       * AEROSPC_CONC( MAP_OAtoAERO(IOA),IM )
     &                       * OASPC(IOA)%OtoC

                   ELSE IF ( IV .EQ. ET_ISAM_DRVD ) THEN  ! ISAM
#ifdef isam      
                     IVAR = MAP_AEROtoSA( MAP_OAtoAERO(IOA),IM )
                     IF ( IVAR .NE. 0 ) THEN
                     IF ( ISRC .LE. NTAG_SA ) THEN
                       VAL2 = VAL2 + FRAC( IM )
     &                        * ISAM_VEC( IVAR,ISRC ) * OASPC( IOA )%OtoC
                     ELSE
                       VAL2 = VAL2 + FRAC( IM )
     &                        * SUM(ISAM_VEC( IVAR,: )) * OASPC( IOA )%OtoC
                     END IF
                     END IF
#endif

                   ELSE IF ( IV .EQ. ET_DDM_DRVD ) THEN  ! DDM
#ifdef sens      
                     IVAR = AEROSPC_MAP( MAP_OAtoAERO(IOA),IM )
                     VAL2 = VAL2 + FRAC( IM )
     &                      * DDM_VEC( ISRC,IVAR ) * OASPC( IOA )%OtoC
#endif

                   END IF
                   
                END IF
             END DO  
          END DO

          ! Add POC/PNCOM Contribution to Weighted O:C
          POC = 0.0
          POM = 0.0
          DO IM = 1,N_MODE
            IF ( MODE_MASK( IM ) ) THEN
               
               IF ( IV .EQ. ET_DRVD ) THEN  ! Core Model
                  IF ( APOC_IDX .NE. 0  
     &                 .AND. .NOT. AERO_MISSING( APOC_IDX,IM) ) 
     &               POC = POC + AEROSPC_CONC(APOC_IDX,IM) * FRAC(IM)
                  IF ( APNCOM_IDX .NE. 0  
     &                 .AND. .NOT. AERO_MISSING( APNCOM_IDX,IM) ) 
     &               POM = POM + AEROSPC_CONC(APNCOM_IDX,IM) * FRAC(IM)

               ELSE IF ( IV .EQ. ET_ISAM_DRVD ) THEN  ! ISAM
#ifdef isam      
                  IF ( APOC_IDX .NE. 0 
     &                 .AND. .NOT. AERO_MISSING( APOC_IDX,IM) ) THEN
                     IVAR = MAP_AEROtoSA( APOC_IDX,IM )
                     IF ( ISRC .LE. NTAG_SA ) THEN
                        POC = POC + FRAC(IM) * ISAM_VEC( IVAR,ISRC ) 
                     ELSE
                        POC = POC + FRAC(IM) * SUM(ISAM_VEC( IVAR,: ))
                     END IF
                  END IF
                  IF ( APNCOM_IDX .NE. 0 
     &                 .AND. .NOT. AERO_MISSING( APNCOM_IDX,IM) ) THEN
                     IVAR = MAP_AEROtoSA( APNCOM_IDX,IM )
                     IF ( ISRC .LE. NTAG_SA ) THEN
                        POM = POM + FRAC(IM) * ISAM_VEC( IVAR,ISRC ) 
                     ELSE
                        POM = POM + FRAC(IM) * SUM(ISAM_VEC( IVAR,: ))
                     END IF   
                  END IF 
#endif

               ELSE IF ( IV .EQ. ET_DDM_DRVD ) THEN  ! DDM
#ifdef sens      
                  IF ( APOC_IDX .NE. 0 
     &                 .AND. .NOT. AERO_MISSING( APOC_IDX,IM) ) THEN
                     IVAR = AEROSPC_MAP( APOC_IDX,IM )
                     POC = POC + FRAC(IM) * DDM_VEC( ISRC,IVAR ) 
                  END IF
                  IF ( APNCOM_IDX .NE. 0 
     &                 .AND. .NOT. AERO_MISSING( APNCOM_IDX,IM) ) THEN
                     IVAR = AEROSPC_MAP( APNCOM_IDX,IM )
                     POM = POM + FRAC(IM) * DDM_VEC( ISRC,IVAR ) 
                  END IF
#endif
               END IF
 
            END IF
          END DO
          POM = POM + POC

          ! Calculate O:C from OM:OC using the relationship from Aiken
          ! et al. ES&T (2008), Fig. 4A. The best-fit line is rearranged to
          ! solve for O:C as a function of OM:OC.
          OtoC = 12./15. * ( POM / ( POC + TINY(0.0) ) )- 14./15.  
            
          OUTVAL = ( VAL2 + OtoC*POM ) / ( VAL + TINY(0.0))
 
        CASE ( OT_WD_OA )
          ! Sum up wet deposition of organic aerosol mass
          DO IOA = 1,N_OA_NotTracers
             DO IM = 1,N_MODE
                ! Just Select Species from the Org_Mask
                IF ( ORG_MASK( IOA ) .AND. MODE_MASK( IM ) 
     &               .AND. .NOT. AERO_MISSING( MAP_OAtoAERO(IOA),IM) ) THEN
                
                   IVAR = AEROSPC_MAP( MAP_OAtoAERO(IOA),IM )
                   IF ( IVAR .NE. 0 ) THEN
                    
                     IF ( IV .EQ. ET_DRVD_WDEP ) THEN  ! Core Model
                       OUTVAL = OUTVAL + FRAC( IM ) * WDEP_VEC( IVAR )

                     ELSE IF ( IV .EQ. ET_ISAM_DRVD_WDEP ) THEN  ! ISAM
#ifdef isam      
                       IVAR = MAP_AEROtoSA( MAP_OAtoAERO(IOA),IM )
                       IF ( IVAR .NE. 0 ) THEN
                       IF ( ISRC .LE. NTAG_SA ) THEN
                         ! Just one source (ISRC)
                         OUTVAL = OUTVAL + FRAC( IM ) 
     &                            * ISAM_WDEP_VEC( IVAR,ISRC ) 
                       ELSE
                         ! Sum All Sources
                         OUTVAL = OUTVAL + FRAC( IM ) 
     &                            * SUM(ISAM_WDEP_VEC( IVAR,: )) 
                       END IF
                       END IF
#endif

                     ELSE IF ( IV .EQ. ET_DDM_DRVD_WDEP ) THEN  ! DDM
#ifdef sens      
                       ! Just one source (ISRC)
                       OUTVAL = OUTVAL + FRAC( IM ) 
     &                          * DDM_WDEP_VEC( IVAR,ISRC ) 
#endif

                     END IF
                   END IF 
                END IF
             END DO
          END DO
 
        CASE ( OT_WD_OC )
          ! Sum up wet deposition of organic carbon mass
          DO IOA = 1,N_OA_NotTracers
             DO IM = 1,N_MODE 
                ! Just Select Species from the Org_Mask
                IF ( ORG_MASK( IOA ) .AND. MODE_MASK( IM ) 
     &               .AND. .NOT. AERO_MISSING( MAP_OAtoAERO(IOA),IM) ) THEN

                   IVAR = AEROSPC_MAP( MAP_OAtoAERO(IOA),IM )
                   IF ( IVAR .GT. 0 ) THEN

                     IF ( IV .EQ. ET_DRVD_WDEP ) THEN  ! Core Model
                       OUTVAL = OUTVAL + FRAC( IM ) * WDEP_VEC( IVAR )
     &                          / OASPC( IOA )%OMtoOC
                    
                     ELSE IF ( IV .EQ. ET_ISAM_DRVD_WDEP ) THEN  ! ISAM
#ifdef isam      
                       IVAR = MAP_AEROtoSA( MAP_OAtoAERO(IOA),IM )
                       IF ( IVAR .NE. 0 ) THEN
                       IF ( ISRC .LE. NTAG_SA ) THEN
                         ! Just one source (ISRC)
                         OUTVAL = OUTVAL + FRAC( IM )
     &                            * ISAM_WDEP_VEC( IVAR,ISRC ) 
     &                            / OASPC( IOA )%OMtoOC
                       ELSE
                         ! Sum All Sources
                         OUTVAL = OUTVAL + FRAC( IM )
     &                            * SUM(ISAM_WDEP_VEC( IVAR,: )) 
     &                            / OASPC( IOA )%OMtoOC
                       END IF
                       END IF
#endif
                    
                     ELSE IF ( IV .EQ. ET_DDM_DRVD_WDEP ) THEN  ! DDM
#ifdef sens      
                       ! Just one source (ISRC)
                       OUTVAL = OUTVAL + FRAC( IM )
     &                          * DDM_WDEP_VEC( IVAR,ISRC ) 
     &                          / OASPC( IOA )%OMtoOC
#endif
                    
                     END IF
                   END IF
                END IF
             END DO
          END DO
 
        CASE ( OT_DD_OA )
          ! Sum up dry deposition of organic aerosol mass
          DO IOA = 1,N_OA_NotTracers
             DO IM = 1,N_MODE
                ! Just Select Species from the Org_Mask
                IF ( ORG_MASK( IOA ) .AND. MODE_MASK( IM ) 
     &               .AND. .NOT. AERO_MISSING( MAP_OAtoAERO(IOA),IM) ) THEN
                   
                   IVAR = AEROSPC_MAP( MAP_OAtoAERO(IOA),IM )
                   IF ( IVAR .GT. 0 ) THEN
                    
                     IF ( IV .EQ. ET_DRVD_DDEP ) THEN  ! Core Model
                       OUTVAL = OUTVAL + FRAC( IM ) * DDEP_VEC( IVAR )

                     ELSE IF ( IV .EQ. ET_ISAM_DRVD_DDEP ) THEN  ! ISAM
#ifdef isam      
                       IVAR = MAP_AEROtoSA( MAP_OAtoAERO(IOA),IM )
                       IF ( IVAR .NE. 0 ) THEN
                       IF ( ISRC .LE. NTAG_SA ) THEN
                         ! Just one source (ISRC)
                         OUTVAL = OUTVAL + FRAC( IM ) 
     &                            * ISAM_DDEP_VEC( IVAR,ISRC ) 
                       ELSE
                         ! Sum All Sources
                         OUTVAL = OUTVAL + FRAC( IM ) 
     &                            * SUM(ISAM_DDEP_VEC( IVAR,: )) 
                       END IF
                       END IF
#endif

                     ELSE IF ( IV .EQ. ET_DDM_DRVD_DDEP ) THEN  ! DDM
#ifdef sens      
                       ! Just one source (ISRC)
                       OUTVAL = OUTVAL + FRAC( IM ) 
     &                          * DDM_DDEP_VEC( IVAR,ISRC ) 
#endif

                     END IF
                   END IF
                END IF
             END DO
          END DO
 
        CASE ( OT_DD_OC )
          ! Sum up dry deposition of organic carbon mass
          DO IOA = 1,N_OA_NotTracers
             DO IM = 1,N_MODE 
                ! Just Select Species from the Org_Mask
                IF ( ORG_MASK( IOA ) .AND. MODE_MASK( IM ) 
     &               .AND. .NOT. AERO_MISSING( MAP_OAtoAERO(IOA),IM) ) THEN

                   IVAR = AEROSPC_MAP( MAP_OAtoAERO(IOA),IM )
                   IF ( IVAR .GT. 0 ) THEN

                     IF ( IV .EQ. ET_DRVD_DDEP ) THEN  ! Core Model
                       OUTVAL = OUTVAL + FRAC( IM ) * DDEP_VEC( IVAR )
     &                          / OASPC( IOA )%OMtoOC
                    
                     ELSE IF ( IV .EQ. ET_ISAM_DRVD_DDEP ) THEN  ! ISAM
#ifdef isam      
                       IVAR = MAP_AEROtoSA( MAP_OAtoAERO(IOA),IM )
                       IF ( IVAR .NE. 0 ) THEN
                       IF ( ISRC .LE. NTAG_SA ) THEN
                         ! Just one source (ISRC)
                         OUTVAL = OUTVAL + FRAC( IM )
     &                            * ISAM_DDEP_VEC( IVAR,ISRC ) 
     &                            / OASPC( IOA )%OMtoOC
                       ELSE
                         ! Sum All Sources
                         OUTVAL = OUTVAL + FRAC( IM )
     &                            * SUM(ISAM_DDEP_VEC( IVAR,: )) 
     &                            / OASPC( IOA )%OMtoOC
                       END IF
                       END IF
#endif
                    
                     ELSE IF ( IV .EQ. ET_DDM_DRVD_DDEP ) THEN  ! DDM
#ifdef sens      
                       ! Just one source (ISRC)
                       OUTVAL = OUTVAL + FRAC( IM )
     &                          * DDM_DDEP_VEC( IVAR,ISRC ) 
     &                          / OASPC( IOA )%OMtoOC
#endif
                    
                     END IF
                   END IF
                END IF
             END DO
          END DO
 
        
      END SELECT
      RETURN
      END FUNCTION SUM_ORGS
      END MODULE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE ELMO_DATA

      USE AERO_DATA, ONLY : N_MODE, IM_ALL, IM_UF, IM_F, IM_C, IM_AIT,
     &                      IM_ACC, IM_NUC
      USE SOA_DEFN, ONLY  : IOA_PRI, IOA_SEC, IOA_ANTSEC, IOA_BIOSEC
      USE UTILIO_DEFN

      IMPLICIT NONE

#ifdef mpas
      INTEGER, PARAMETER :: M3REAL  =   5
#endif

      ! Define Logical values as T and F for the aerospc table
      Logical, Parameter, Private :: T = .true.
      Logical, Parameter, Private :: F = .false.

      LOGICAL, SAVE :: L_ELMO
      INTEGER, SAVE :: ELMO_NSTEP = 0
 
      ! Define ELMO Variable Types
      INTEGER, PARAMETER :: ET_CONC  = 1, ET_WDEP      = 2, ET_DDEP = 3, 
     &                      ET_CMPST = 4, ET_CMPST_DEP = 5, ET_DRVD = 6,
     &                      ET_DRVD_DDEP = 7, ET_DRVD_WDEP = 8,
     &                      ET_ISAM_CONC = 11, ET_ISAM_WDEP = 12, 
     &                      ET_ISAM_DDEP = 13, ET_ISAM_CMPST= 14, 
     &                      ET_ISAM_CMPST_DEP = 15, ET_ISAM_DRVD = 16, 
     &                      ET_ISAM_DRVD_DDEP = 17, ET_ISAM_DRVD_WDEP = 18,
     &                      ET_DDM_CONC = 21, ET_DDM_WDEP = 22, 
     &                      ET_DDM_DDEP = 23, ET_DDM_CMPST= 24, 
     &                      ET_DDM_CMPST_DEP = 25, ET_DDM_DRVD = 26, 
     &                      ET_DDM_DRVD_DDEP = 27, ET_DDM_DRVD_WDEP = 28,
     &                      ET_AEROPROP = 30, ET_CHEM = 31, ET_MET = 32,
     &                      ET_PHOT = 33

      CHARACTER( 14 ), PARAMETER :: CETYPE(33) = 
     &    (/'CONC          ','WET DEP       ','DRY DEP       ',
     &      'COMPOSITE CONC','COMPOSITE DEP ','DERIVED CONC  ',
     &      'DERIVED DDEP  ','DERIVED WDEP  ','              ',
     &      '              ','ISAM CONC     ','ISAM WETDEP   ',
     &      'ISAM DRY DEP  ','ISAM COMP CONC','ISAM COMP DEP ',
     &      'ISAM DERIVED  ','ISAM DRVD DDEP','ISAM DRVD WDEP',
     &      '              ','              ','DDM CONC      ',
     &      'DDM WET DEP   ','DDM DRY DEP   ','DDM COMP CONC ',
     &      'DDM COMP DEP  ','DDM DERIVED   ','DDM DRVD DDEP ',
     &      'DDM DRVD WDEP ','              ','AERO PROPERTY ',
     &      'CHEMISTRY     ','METEOROLOGY   ','PHOT          '/) 

      ! Define Indices for All Variables on the ELMO List
      ! The idea here is that these variables will be organized on
      ! the ELMO_TABLE in the order of this integer list, not the 
      ! ELMO_LIST. ELMO_LIST is searchable via the Parameter names 
      ! but they link to this list of integers so that each parameter 
      ! can be easily referenced during the run without having to do 
      ! string lookups. Please see the table defining the ELMO_LIST 
      ! below for a description of each of these indices.
      INTEGER, PARAMETER :: ID_STDEV =        1
      INTEGER, PARAMETER :: ID_DRY_DG =       2
      INTEGER, PARAMETER :: ID_WET_DG =       3 
      INTEGER, PARAMETER :: ID_WET_M2 =       4
      INTEGER, PARAMETER :: ID_DRY_M3 =       5
      INTEGER, PARAMETER :: ID_WET_M3 =       6
      INTEGER, PARAMETER :: ID_PM_NUM =       7
      INTEGER, PARAMETER :: ID_PMU_NUM =      8
      INTEGER, PARAMETER :: ID_PMF_NUM =      9
      INTEGER, PARAMETER :: ID_PMC_NUM =     10
      INTEGER, PARAMETER :: ID_N10 =         11
      INTEGER, PARAMETER :: ID_N20 =         12
      INTEGER, PARAMETER :: ID_N40 =         13
      INTEGER, PARAMETER :: ID_N100 =        14
      INTEGER, PARAMETER :: ID_PM_SRF =      15
      INTEGER, PARAMETER :: ID_PMU_SRF =     16
      INTEGER, PARAMETER :: ID_PMF_SRF =     17
      INTEGER, PARAMETER :: ID_PMC_SRF =     18
      INTEGER, PARAMETER :: ID_PM =          19
      INTEGER, PARAMETER :: ID_PMU =         20
      INTEGER, PARAMETER :: ID_PMF =         21
      INTEGER, PARAMETER :: ID_PMC =         22
      INTEGER, PARAMETER :: ID_PMNUC =       23
      INTEGER, PARAMETER :: ID_PMAIT =       24
      INTEGER, PARAMETER :: ID_PMACC =       25
      INTEGER, PARAMETER :: ID_DRY_DENS =    26
      INTEGER, PARAMETER :: ID_WET_DENS =    27
      INTEGER, PARAMETER :: ID_FPM01 =       28
      INTEGER, PARAMETER :: ID_FPM1 =        29
      INTEGER, PARAMETER :: ID_FPM25 =       30
      INTEGER, PARAMETER :: ID_FPM10 =       31
      INTEGER, PARAMETER :: ID_FPM25to10 =   32
      INTEGER, PARAMETER :: ID_FAMS =        33
      INTEGER, PARAMETER :: ID_PM01 =        34
      INTEGER, PARAMETER :: ID_PM1 =         35
      INTEGER, PARAMETER :: ID_PM25 =        36
      INTEGER, PARAMETER :: ID_PM10 =        37
      INTEGER, PARAMETER :: ID_PM25to10 =    38
      INTEGER, PARAMETER :: ID_PMAMS =       39
      INTEGER, PARAMETER :: ID_PMF_OC =      40
      INTEGER, PARAMETER :: ID_PMF_OA =      41
      INTEGER, PARAMETER :: ID_PMF_HPM =     42               
      INTEGER, PARAMETER :: ID_PMF_PH =      43               
      INTEGER, PARAMETER :: ID_PMF_POC =     44               
      INTEGER, PARAMETER :: ID_PMF_SOC =     45
      INTEGER, PARAMETER :: ID_PMF_POA =     46
      INTEGER, PARAMETER :: ID_PMF_SOA =     47
      INTEGER, PARAMETER :: ID_PMF_OMOC =    48
      INTEGER, PARAMETER :: ID_PMF_OtoC =    49
      INTEGER, PARAMETER :: ID_PMF_ASOA =    50
      INTEGER, PARAMETER :: ID_PMF_BSOA =    51
      INTEGER, PARAMETER :: ID_AMS_OA =      52
      INTEGER, PARAMETER :: ID_AMS_OTOC =    53
      INTEGER, PARAMETER :: ID_PM1_OC =      54
      INTEGER, PARAMETER :: ID_PM1_OA =      55
      INTEGER, PARAMETER :: ID_PM25_OC =     56
      INTEGER, PARAMETER :: ID_PM25_OA =     57
      INTEGER, PARAMETER :: ID_BENAPY_FAERO= 58
      INTEGER, PARAMETER :: ID_PM25_FRM =    59                   
      INTEGER, PARAMETER :: ID_PMF_FRM =     60                   
      INTEGER, PARAMETER :: ID_RH =          61
      INTEGER, PARAMETER :: ID_TEMP =        62
      INTEGER, PARAMETER :: ID_SRFTEMP =     63
      INTEGER, PARAMETER :: ID_PRES =        64
      INTEGER, PARAMETER :: ID_GN2O5F =      65
      INTEGER, PARAMETER :: ID_GN2O5C =      66
      INTEGER, PARAMETER :: ID_YCLNO2F =     67
      INTEGER, PARAMETER :: ID_YCLNO2C =     68
      INTEGER, PARAMETER :: ID_GIEPOX =      69
      INTEGER, PARAMETER :: ID_KIEPOX =      70
      INTEGER, PARAMETER :: ID_GIMAE =       71
      INTEGER, PARAMETER :: ID_VOC_NOX =     72
      INTEGER, PARAMETER :: ID_EF_HNO3 =     73
      INTEGER, PARAMETER :: ID_DZ    =       74
      INTEGER, PARAMETER :: ID_ZH    =       75
      INTEGER, PARAMETER :: ID_CFRAC =       76
      INTEGER, PARAMETER :: ID_PV    =       77
      INTEGER, PARAMETER :: ID_DENS  =       78
      INTEGER, PARAMETER :: ID_RHOJ  =       79
      INTEGER, PARAMETER :: ID_NO2COL  =     80
      INTEGER, PARAMETER :: ID_SO2COL  =     81
      INTEGER, PARAMETER :: ID_HCHOCOL  =    82
      INTEGER, PARAMETER :: ID_COCOL  =      83
      INTEGER, PARAMETER :: ID_KZ     =      84
      INTEGER, PARAMETER :: ID_KZMIN  =      85
      INTEGER, PARAMETER :: ID_AOD550 =      86
      INTEGER, PARAMETER :: ID_PMEXT550 =    87
      INTEGER, PARAMETER :: ID_PBL =         88
      INTEGER, PARAMETER :: ID_RGRND =       89
      INTEGER, PARAMETER :: ID_PRECIP =      90
      INTEGER, PARAMETER :: ID_WSPD10 =      91
      INTEGER, PARAMETER :: ID_WDIR10 =      92
      INTEGER, PARAMETER :: ID_WVEL   =      93
      INTEGER, PARAMETER :: ID_DD_OA =       94
      INTEGER, PARAMETER :: ID_WD_OA =       95
      INTEGER, PARAMETER :: ID_DD_OC =       96
      INTEGER, PARAMETER :: ID_WD_OC =       97
      INTEGER, PARAMETER :: ID_DD_POA =      98
      INTEGER, PARAMETER :: ID_WD_POA =      99
      INTEGER, PARAMETER :: ID_DD_POC =     100
      INTEGER, PARAMETER :: ID_WD_POC =     101
      INTEGER, PARAMETER :: ID_DD_SOA =     102
      INTEGER, PARAMETER :: ID_WD_SOA =     103
      INTEGER, PARAMETER :: ID_DD_SOC =     104
      INTEGER, PARAMETER :: ID_WD_SOC =     105
      INTEGER, PARAMETER :: ID_GHFPODAF =   106
      INTEGER, PARAMETER :: ID_GCOF2    =   107
      INTEGER, PARAMETER :: ID_GPFMOAF  =   108
      INTEGER, PARAMETER :: ID_KHFPODAF =   109
      INTEGER, PARAMETER :: ID_KCOF2    =   110
      INTEGER, PARAMETER :: ID_KPFMOAF  =   111
      INTEGER, PARAMETER :: ID_PFAS_GAS =   112
      INTEGER, PARAMETER :: ID_PFAS_AER =   113
      INTEGER, PARAMETER :: ID_PFAS_TOT =   114
      INTEGER, PARAMETER :: ID_DD_PFAS_GAS =115
      INTEGER, PARAMETER :: ID_DD_PFAS_AER =116
      INTEGER, PARAMETER :: ID_DD_PFAS_TOT =117
      INTEGER, PARAMETER :: ID_WD_PFAS_GAS =118
      INTEGER, PARAMETER :: ID_WD_PFAS_AER =119
      INTEGER, PARAMETER :: ID_WD_PFAS_TOT =120

      TYPE ELDTP
        CHARACTER (LEN = 16) :: NAME      !Parameter Name
        INTEGER              :: ID        !ID Number in Case Statement
        INTEGER              :: VAR_TYPE  !ELMO Variable Type (e.g. ET_CONC, ET_WDEP, etc.)
        LOGICAL              :: L_MODE    !Is this property mode-expansive?
        CHARACTER (LEN = 16) :: UNIT      !Units for Parameter
        CHARACTER (LEN = 80) :: DESC      !Description
      END TYPE ELDTP

      INTEGER, PARAMETER :: N_ELMO_LIST = 120

      TYPE (ELDTP), PARAMETER :: ELMO_LIST( N_ELMO_LIST ) = (/

      ! Aerosol Parameters and Diagnostics
     &ELDTP( 'STDEV        ',ID_STDEV,      ET_AEROPROP, T, '      ', 'Mode standard deviation (dry and wet)' ),
     &ELDTP( 'DRY_DG       ',ID_DRY_DG,     ET_AEROPROP, T, 'um    ', 'Mode mean diameter (dry)' ),
     &ELDTP( 'WET_DG       ',ID_WET_DG,     ET_AEROPROP, T, 'um    ', 'Mode mean diameter (wet)' ),
     &ELDTP( 'WET_M2       ',ID_WET_M2,     ET_AEROPROP, T, 'm2 m-3', 'Mode 2nd moment (wet)' ),
     &ELDTP( 'DRY_M3       ',ID_DRY_M3,     ET_AEROPROP, T, 'm3 m-3', 'Mode 3rd moment (dry)' ),
     &ELDTP( 'WET_M3       ',ID_WET_M3,     ET_AEROPROP, T, 'm3 m-3', 'Mode 3rd moment (wet)' ),
     &ELDTP( 'TSP_NUM      ',ID_PM_NUM,     ET_AEROPROP, F, 'N m-3' , 'Total Particle Number' ),
     &ELDTP( 'PMU_NUM      ',ID_PMU_NUM,    ET_AEROPROP, F, 'N m-3' , 'Ultrafine-Mode Particle Number' ),
     &ELDTP( 'PMF_NUM      ',ID_PMF_NUM,    ET_AEROPROP, F, 'N m-3' , 'Fine-Mode Particle Number' ),
     &ELDTP( 'PMC_NUM      ',ID_PMC_NUM,    ET_AEROPROP, F, 'N m-3' , 'Coarse-Mode Particle Number' ),
     &ELDTP( 'N10          ',ID_N10,        ET_AEROPROP, F, 'N m-3' , 'Total Particle Number greater than 10 nm' ),
     &ELDTP( 'N20          ',ID_N20,        ET_AEROPROP, F, 'N m-3' , 'Total Particle Number greater than 20 nm' ),
     &ELDTP( 'N40          ',ID_N40,        ET_AEROPROP, F, 'N m-3' , 'Total Particle Number greater than 40 nm' ),
     &ELDTP( 'N100         ',ID_N100,       ET_AEROPROP, F, 'N m-3' , 'Total Particle Number greater than 100 nm' ),
     &ELDTP( 'TSP_SRF      ',ID_PM_SRF,     ET_AEROPROP, F, 'm2 m-3', 'Particle Surface Area' ),
     &ELDTP( 'PMU_SRF      ',ID_PMU_SRF,    ET_AEROPROP, F, 'm2 m-3', 'Ultrafine-Mode Surface Area' ),
     &ELDTP( 'PMF_SRF      ',ID_PMF_SRF,    ET_AEROPROP, F, 'm2 m-3', 'Fine-Mode Surface Area' ),
     &ELDTP( 'PMC_SRF      ',ID_PMC_SRF,    ET_AEROPROP, F, 'm2 m-3', 'Coarse-Mode Surface Area' ),
     &ELDTP( 'TSP          ',ID_PM,         ET_DRVD,     F, 'ug m-3', 'Total Particle Mass' ),
     &ELDTP( 'PMU          ',ID_PMU,        ET_DRVD,     F, 'ug m-3', 'Ultrafine Particle Mass' ),
     &ELDTP( 'PMF          ',ID_PMF,        ET_DRVD,     F, 'ug m-3', 'Fine Particle Mass' ),
     &ELDTP( 'PMC          ',ID_PMC,        ET_DRVD,     F, 'ug m-3', 'Coarse Particle Mass' ),
     &ELDTP( 'PMNUC        ',ID_PMNUC,      ET_DRVD,     F, 'ug m-3', 'Nucleation Mode Total PM' ),
     &ELDTP( 'PMAIT        ',ID_PMAIT,      ET_DRVD,     F, 'ug m-3', 'Aitken Mode Total PM' ),
     &ELDTP( 'PMACC        ',ID_PMACC,      ET_DRVD,     F, 'ug m-3', 'Accumulation Mode Total PM' ),
     &ELDTP( 'DRY_DENS     ',ID_DRY_DENS,   ET_AEROPROP, T, 'kg m-3', 'Bulk Density of Particles excluding particle water' ),
     &ELDTP( 'WET_DENS     ',ID_WET_DENS,   ET_AEROPROP, T, 'kg m-3', 'Bulk Density of Particles including particle water' ),
     &ELDTP( 'FPM01        ',ID_FPM01,      ET_AEROPROP, T, '1     ', 'PM01 fraction of mode' ),
     &ELDTP( 'FPM1         ',ID_FPM1,       ET_AEROPROP, T, '1     ', 'PM1 fraction of mode' ),
     &ELDTP( 'FPM25        ',ID_FPM25,      ET_AEROPROP, T, '1     ', 'PM2.5 fraction of mode' ),
     &ELDTP( 'FPM10        ',ID_FPM10,      ET_AEROPROP, T, '1     ', 'PM10 fraction of mode' ),
     &ELDTP( 'FPM25TO10    ',ID_FPM25to10,  ET_AEROPROP, T, '1     ', 'PM2.5-10 fraction of mode' ),
     &ELDTP( 'FAMS         ',ID_FAMS,       ET_AEROPROP, T, '1     ', 'AMS Transmission Fraction of mode' ),
     &ELDTP( 'PM01         ',ID_PM01,       ET_DRVD,     F, 'ug m-3', 'Bulk PM0.1 Concentration' ), 
     &ELDTP( 'PM1          ',ID_PM1,        ET_DRVD,     F, 'ug m-3', 'Bulk PM1.0 Concentration' ), 
     &ELDTP( 'PM25         ',ID_PM25,       ET_DRVD,     F, 'ug m-3', 'Bulk PM2.5 Concentration' ), 
     &ELDTP( 'PM10         ',ID_PM10,       ET_DRVD,     F, 'ug m-3', 'Bulk PM10.0 Concentration' ),
     &ELDTP( 'PM25TO10     ',ID_PM25to10,   ET_DRVD,     F, 'ug m-3', 'Coarse-Mode Total' ),
     &ELDTP( 'PMAMS        ',ID_PMAMS,      ET_DRVD,     F, 'ug m-3', 'Bulk PM Concentration in AMS' ),
                                                          
      ! Fine-Mode PM Species                         
     &ELDTP( 'PMF_OA       ',ID_PMF_OA,     ET_DRVD,     F, 'ug m-3', 'Fine-Mode Organic Aerosol' ),
     &ELDTP( 'PMF_OC       ',ID_PMF_OC,     ET_DRVD,     F, 'ug m-3', 'Fine-Mode Organic Carbon (excludes non-carbon atoms)' ),
     &ELDTP( 'PMF_HPMOLAL  ',ID_PMF_HPM,    ET_AEROPROP, F, 'mol kg-1','Fine-Mode Concentration of H+ in Particle Water' ),
     &ELDTP( 'PMF_PH       ',ID_PMF_PH,     ET_AEROPROP, F, '1'     , 'Fine-Mode pH' ),
                                                  
      ! Organic Aerosol Relevant Aggregates          
     &ELDTP( 'PMF_POA      ',ID_PMF_POA,    ET_DRVD,     F, 'ug m-3', 'Fine-Mode Primary Organic Aerosol' ),
     &ELDTP( 'PMF_POC      ',ID_PMF_POC,    ET_DRVD,     F, 'ug m-3', 'Fine-Mode Primary Organic Carbon (excluding non-carbon)' ),
     &ELDTP( 'PMF_SOA      ',ID_PMF_SOA,    ET_DRVD,     F, 'ug m-3', 'Fine-Mode Secondary Organic Aerosol' ),
     &ELDTP( 'PMF_SOC      ',ID_PMF_SOC,    ET_DRVD,     F, 'ug m-3', 'Fine-Mode Secondary Organic Carbon (excluding non-carbon)' ),
     &ELDTP( 'PMF_ASOA     ',ID_PMF_ASOA,   ET_DRVD,     F, 'ug m-3', 'Fine-Mode Anthropogenic-VOC Derived OA' ),
     &ELDTP( 'PMF_BSOA     ',ID_PMF_BSOA,   ET_DRVD,     F, 'ug m-3', 'Fine-Mode Biogenic-VOC Derived OA' ),
     &ELDTP( 'PMF_OMOC     ',ID_PMF_OMOC,   ET_AEROPROP, F, '1     ', 'Fine-Mode OM/OC' ),
     &ELDTP( 'PMF_OTOC     ',ID_PMF_OtoC,   ET_AEROPROP, F, '1     ', 'Fine-Mode O:C' ),
                                                  
      ! AMS Speciation                            
     &ELDTP( 'PMAMS_OA     ',ID_AMS_OA,     ET_DRVD,     F, 'ug m-3', 'Organic Aerosol Collected by the AMS' ),
     &ELDTP( 'PMAMS_OTOC   ',ID_AMS_OTOC,   ET_AEROPROP, F, 'ug ug-1','O:C Collected and Measured by the AMS' ),
                                                  
      ! PM1 Speciation                            
     &ELDTP( 'PM1_OA       ',ID_PM1_OA,     ET_DRVD,     F, 'ug m-3', 'PM1 Organic Aerosol' ),
     &ELDTP( 'PM1_OC       ',ID_PM1_OC,     ET_DRVD,     F, 'ug m-3', 'PM1 Organic Carbon (excluding non-carbon atoms)' ),
                                                  
      ! PM2.5 Speciation                          
     &ELDTP( 'PM25_OA      ',ID_PM25_OA,    ET_DRVD,     F, 'ug m-3', 'PM2.5 Organic Aerosol' ),
     &ELDTP( 'PM25_OC      ',ID_PM25_OC,    ET_DRVD,     F, 'ug m-3', 'PM2.5 Organic Carbon (excluding non-carbon atoms)' ),
     &ELDTP( 'BENAPY_FAERO ',ID_BENAPY_FAERO,ET_AEROPROP,F, '',       'Benzo-a-Pyrene Aerosol-Phase Fraction' ),
     
      ! Deposition of Organic Classes
     &ELDTP( 'DD_PMF_OA    ',ID_DD_OA,      ET_DRVD_DDEP,F, 'kg ha-1','Dry Deposition of Organic Aerosol' ),
     &ELDTP( 'WD_PMF_OA    ',ID_WD_OA,      ET_DRVD_WDEP,F, 'kg ha-1','Wet Deposition of Organic Aerosol' ),
     &ELDTP( 'DD_PMF_OC    ',ID_DD_OC,      ET_DRVD_DDEP,F, 'kg ha-1','Dry Deposition of Organic Carbon' ),
     &ELDTP( 'WD_PMF_OC    ',ID_WD_OC,      ET_DRVD_WDEP,F, 'kg ha-1','Wet Deposition of Organic Carbon' ),
     &ELDTP( 'DD_PMF_POA   ',ID_DD_POA,     ET_DRVD_DDEP,F, 'kg ha-1','Dry Deposition of Primary Organic Aerosol' ),
     &ELDTP( 'WD_PMF_POA   ',ID_WD_POA,     ET_DRVD_WDEP,F, 'kg ha-1','Wet Deposition of Primary Organic Aerosol' ),
     &ELDTP( 'DD_PMF_POC   ',ID_DD_POC,     ET_DRVD_DDEP,F, 'kg ha-1','Dry Deposition of Primary Organic Carbon' ),
     &ELDTP( 'WD_PMF_POC   ',ID_WD_POC,     ET_DRVD_WDEP,F, 'kg ha-1','Wet Deposition of Primary Organic Carbon' ),
     &ELDTP( 'DD_PMF_SOA   ',ID_DD_SOA,     ET_DRVD_DDEP,F, 'kg ha-1','Dry Deposition of Secondary Organic Aerosol' ),
     &ELDTP( 'WD_PMF_SOA   ',ID_WD_SOA,     ET_DRVD_WDEP,F, 'kg ha-1','Wet Deposition of Secondary Organic Aerosol' ),
     &ELDTP( 'DD_PMF_SOC   ',ID_DD_SOC,     ET_DRVD_DDEP,F, 'kg ha-1','Dry Deposition of Secondary Organic Carbon' ),
     &ELDTP( 'WD_PMF_SOC   ',ID_WD_SOC,     ET_DRVD_WDEP,F, 'kg ha-1','Wet Deposition of Secondary Organic Carbon' ),

      ! Spectral Variables and diagnostics
     &ELDTP( 'AOD_550      ',ID_AOD550,     ET_PHOT,     F, '1     ', 'Aerosol Optical Depth at 550 nm -Angstrom interp' ),
     &ELDTP( 'PM_EXT_550   ',ID_PMEXT550,   ET_PHOT,     F, 'Mm-1  ', 'Aerosol Extinction at 550 nm -Angstrom interp' ),
     &ELDTP( 'NO2_COLUMN   ',ID_NO2COL,     ET_PHOT,     F, 'Pmolec cm-2', 'NO2 column density' ),
     &ELDTP( 'SO2_COLUMN   ',ID_SO2COL,     ET_PHOT,     F, 'Pmolec cm-2', 'SO2 column density' ),
     &ELDTP( 'HCHO_COLUMN  ',ID_HCHOCOL,    ET_PHOT,     F, 'Pmolec cm-2', 'HCHO column density' ),
     &ELDTP( 'CO_COLUMN    ',ID_COCOL,      ET_PHOT,     F, 'Pmolec cm-2', 'CO column density' ),

      ! Other Special Variables and Properties            
     &ELDTP( 'PM25_FRM     ',ID_PM25_FRM,   ET_DRVD,     F, 'ug m-3', 'Federal Reference Method PM2.5' ),
     &ELDTP( 'PMF_FRM      ',ID_PMF_FRM,    ET_DRVD,     F, 'ug m-3', 'Federal Reference Method PMIJ' ),
     &ELDTP( 'RH           ',ID_RH,         ET_MET,      F, '1     ', 'Relative humidity' ),
     &ELDTP( 'TA           ',ID_TEMP,       ET_MET,      F, 'K     ', 'Temperature' ),
     &ELDTP( 'SFC_TMP      ',ID_SRFTEMP,    ET_MET,      F, 'K     ', '2-meter Surface Temperature' ),
     &ELDTP( 'PRES         ',ID_PRES,       ET_MET,      F, 'Pa    ', 'Pressure' ),
     &ELDTP( 'PBL          ',ID_PBL,        ET_MET,      F, 'm     ', 'Planetry Boundary Layer (PBL) Height' ),
     &ELDTP( 'RGRND        ',ID_RGRND,      ET_MET,      F, 'W m-2 ', 'Solar Radiation at Ground' ),
     &ELDTP( 'PRECIP       ',ID_PRECIP,     ET_MET,      F, 'cm    ', 'Precipitation' ),
     &ELDTP( 'WSPD10       ',ID_WSPD10,     ET_MET,      F, 'm s-1 ', 'Wind Speed at 10 m' ),
     &ELDTP( 'WDIR10       ',ID_WDIR10,     ET_MET,      F, 'deg   ', 'Wind Direction at 10 m' ),
     &ELDTP( 'WVEL         ',ID_WVEL,       ET_MET,      F, 'm s-1 ', 'Vertical Wind Velocity' ),
     &ELDTP( 'GAMMA_N2O5   ',ID_GN2O5F,     ET_CHEM,     F, '1     ', 'Fine Mode N2O5 Heterogeneous rxn probability' ),
     &ELDTP( 'GAMMA_N2O5K  ',ID_GN2O5C,     ET_CHEM,     F, '1     ', 'Coarse Mode N2O5 Heterogeneous rxn probability' ),
     &ELDTP( 'YIELD_CLNO2  ',ID_YCLNO2F,    ET_CHEM,     F, '1     ', 'Fine Mode CLNO2 Heterogeneous reaction yield' ),
     &ELDTP( 'YIELD_CLNO2K ',ID_YCLNO2C,    ET_CHEM,     F, '1     ', 'Coarse Mode CLNO2 Heterogeneous reaction yield' ),
     &ELDTP( 'GAMMA_IEPOX  ',ID_GIEPOX,     ET_CHEM,     F, '1     ', 'IEPOX heterogeneous uptake coefficient' ),
     &ELDTP( 'K_IEPOX      ',ID_KIEPOX,     ET_CHEM,     F, 's-1   ', 'IEPOX 1st order particle phase reaction rate const' ),
     &ELDTP( 'GAMMA_IMAE   ',ID_GIMAE,      ET_CHEM,     F, '1     ', 'IMAE+HMML heterogeneous uptake coefficient' ),
     &ELDTP( 'VOC_NOX      ',ID_VOC_NOX,    ET_CHEM,     F, '      ', 'VOC-limiting (>0.35) or NOx-limiting (<0.35) O3 formation' ),
     &ELDTP( 'EF_HNO3      ',ID_EF_HNO3,    ET_CHEM,     F, '1     ', 'Enhancement factor for HNO3 photolysis' ),
     &ELDTP( 'DZ           ',ID_DZ,         ET_MET,      F, 'm     ', 'Height of each grid cell computed from top layer height' ),
     &ELDTP( 'ZH           ',ID_ZH,         ET_MET,      F, 'm     ', 'Height of grid cell midpoints (mass-weighted)' ),
     &ELDTP( 'CFRAC        ',ID_CFRAC,      ET_MET,      F, '      ', 'Cloud Fraction' ),
     &ELDTP( 'PV           ',ID_PV,         ET_MET,      F, '      ', 'Potential Vorticity' ),
     &ELDTP( 'DENS         ',ID_DENS,       ET_MET,      F, 'kg m-3', 'Advected Density' ),
     &ELDTP( 'KZ           ',ID_KZ,         ET_MET,      F, 'm2 s-1', 'Vertical diffusivity coefficients' ),
     &ELDTP( 'KZMIN        ',ID_KZMIN,      ET_MET,      F, 'm2 s-1', 'Vertical diffusivity coefficients' ),
     &ELDTP( 'RHOJ         ',ID_RHOJ,       ET_MET,      F, 'kg m-3', 'Advected Density x Jacobian/MSFX^2' ),

      ! PFAS Derived Variables
     &ELDTP( 'PFAS_GAS     ',ID_PFAS_GAS,   ET_DRVD,     F, 'ug m-3', 'Total Gas-Phase PFAS Mixing Ratio'),
     &ELDTP( 'PFAS_AER     ',ID_PFAS_AER,   ET_DRVD,     F, 'ug m-3', 'Total Particle-Phase PFAS MassConcentration'),
     &ELDTP( 'PFAS_TOT     ',ID_PFAS_TOT,   ET_DRVD,     F, 'ug m-3', 'Total PFAS Mass Concentration'),
     &ELDTP( 'DD_PFAS_GAS  ',ID_DD_PFAS_GAS,ET_DRVD_DDEP,F, 'kg ha-1','Total Gas-Phase PFAS Mixing Ratio'),
     &ELDTP( 'DD_PFAS_AER  ',ID_DD_PFAS_AER,ET_DRVD_DDEP,F, 'kg ha-1','Total Particle-Phase PFAS MassConcentration'),
     &ELDTP( 'DD_PFAS_TOT  ',ID_DD_PFAS_TOT,ET_DRVD_DDEP,F, 'kg ha-1','Total PFAS Mass Concentration'),
     &ELDTP( 'WD_PFAS_GAS  ',ID_WD_PFAS_GAS,ET_DRVD_WDEP,F, 'kg ha-1','Total Gas-Phase PFAS Mixing Ratio'),
     &ELDTP( 'WD_PFAS_AER  ',ID_WD_PFAS_AER,ET_DRVD_WDEP,F, 'kg ha-1','Total Particle-Phase PFAS MassConcentration'),
     &ELDTP( 'WD_PFAS_TOT  ',ID_WD_PFAS_TOT,ET_DRVD_WDEP,F, 'kg ha-1','Total PFAS Mass Concentration'),
     &ELDTP( 'GAMMA_HFPODAF',ID_GHFPODAF,   ET_CHEM,     F, '1     ', 'HFPODAF Particle Uptake and Hydrolysis' ),
     &ELDTP( 'GAMMA_COF2   ',ID_GCOF2,      ET_CHEM,     F, '1     ', 'COF2 Particle Uptake and Hydrolysis' ),
     &ELDTP( 'GAMMA_PFMOAF ',ID_GPFMOAF,    ET_CHEM,     F, '1     ', 'PFMOAF Particle Uptake and Hydrolysis' ),
     &ELDTP( 'KPART_HFPODAF',ID_KHFPODAF,   ET_CHEM,     F, 's-1   ', 'HFPODAF Heterogeneous Rxn Rate Constant' ),
     &ELDTP( 'KPART_COF2   ',ID_KCOF2,      ET_CHEM,     F, 's-1   ', 'COF2 Heterogeneous Rxn Rate Constant' ),
     &ELDTP( 'KPART_PFMOAF ',ID_KPFMOAF,    ET_CHEM,     F, 's-1   ', 'PFMOAF Heterogeneous Rxn Rate Constant' )
     &/)
     

      TYPE ELMO_KEY_TYPE
          CHARACTER( 32 )             :: WORD    ! Keyword for selecting multiple ELMO parameters
          INTEGER                     :: N       ! Number of Parameters associated with the Keyword
          CHARACTER( 32 ),ALLOCATABLE :: LIST(:) ! List of parameters
      END TYPE ELMO_KEY_TYPE

      TYPE (ELMO_KEY_TYPE), ALLOCATABLE, SAVE :: ELMO_KEY( : )
      INTEGER, SAVE :: N_KEY

      INTEGER, SAVE :: N_ELMO_FILES

      TYPE ELMO_FILE_TYPE
          CHARACTER(300)              :: FILENAME     ! Filename with full path
          CHARACTER(50)               :: SHORTNAME    ! ELMO[N]_[Flabel]
          INTEGER                     :: STRUCT       ! 0 = gridded, 1 = unstructured
          CHARACTER( 16)              :: FLOGICAL     ! I/O Logical Name for each output file
          INTEGER                     :: TSTEP        ! Output Time Step (HHMMSS)
          INTEGER                     :: TMODE        ! 0 = Instantaneous, 1 = Average/Cumulative
          INTEGER                     :: LAY_BOT      ! Bottom Layer
          INTEGER                     :: LAY_TOP      ! Top Layer
          INTEGER                     :: NLAYS        ! Number of Layers
          INTEGER                     :: N_VARS_IN    ! Number of variables for this file 
                                                      !   specified through the interface
          CHARACTER(32), ALLOCATABLE  :: VARS_IN(:)   ! Variables on each output file
          INTEGER                     :: N_VARS       ! Number of Variables after processing
          INTEGER, ALLOCATABLE        :: TABID(:)     ! ID of Variable on ELMO_TABLE
          INTEGER, ALLOCATABLE        :: USEDID(:)    ! ID of Variable in ELMO_USED array
      END TYPE ELMO_FILE_TYPE

      TYPE ( ELMO_FILE_TYPE ), ALLOCATABLE, SAVE :: ELMO_FILE( : )

      LOGICAL, ALLOCATABLE, SAVE :: L_ELMO_TABLE_OUT(:), L_ELMO_TABLE_USED(:)

      TYPE ELMO_OUT_TYPE
          REAL, ALLOCATABLE           :: DATA(:,:,:,:)
      END TYPE ELMO_OUT_TYPE

      TYPE ( ELMO_OUT_TYPE ), ALLOCATABLE, SAVE :: ELMO_OUT( : )

      INTEGER, ALLOCATABLE, SAVE :: MAP_USEDtoTABLE( : ), MAP_TABLEtoUSED( : )
      LOGICAL, ALLOCATABLE, SAVE :: L_CALCULATED( : )
      INTEGER, ALLOCATABLE, SAVE :: ELMO_USED_UNIT( : )
      INTEGER, SAVE :: N_ELMO_USED
      INTEGER, SAVE :: LAY_TOP_MAX, LAY_BOT_MIN

      ! Variables for Storing Values of ELMO Output      
      REAL, ALLOCATABLE, SAVE :: ELMO_USED( : )
      LOGICAL, ALLOCATABLE, SAVE :: L_CALC( : )
      REAL, ALLOCATABLE, SAVE :: CONC_VEC( : )
      REAL, ALLOCATABLE, SAVE :: WDEP_VEC( : )
      REAL, ALLOCATABLE, SAVE :: DDEP_VEC( : )
#ifdef isam
      REAL, ALLOCATABLE, SAVE :: ISAM_VEC( :,: )
      REAL, ALLOCATABLE, SAVE :: ISAM_WDEP_VEC( :,: )
      REAL, ALLOCATABLE, SAVE :: ISAM_DDEP_VEC( :,: )
#endif
#ifdef sens
      REAL, ALLOCATABLE, SAVE :: DDM_VEC( :,: )
      REAL, ALLOCATABLE, SAVE :: DDM_WDEP_VEC( :,: )
      REAL, ALLOCATABLE, SAVE :: DDM_DDEP_VEC( :,: )
#endif
      
      
      INTEGER, SAVE           :: C1, R1, L1

      ! Variables for Aerosol Chemistry
      REAL, SAVE, ALLOCATABLE :: GAMMA_N2O5IJ( :,:,:  ) ! Fine modes N2O5 rx effic.
      REAL, SAVE, ALLOCATABLE :: GAMMA_N2O5K(  :,:,:  ) ! Coarse mode N2O5 rx effic.
      REAL, SAVE, ALLOCATABLE :: KPARTIEPOX (  :,:,:  ) ! IEPOX particle-phase reaction rate constant (sec-1)
      REAL, SAVE, ALLOCATABLE :: GAMMA_IEPOX(  :,:,:  ) ! IEPOX uptake coeff
      REAL, SAVE, ALLOCATABLE :: GAMMA_IMAE (  :,:,:  ) ! IMAE uptake coeff
      REAL, SAVE, ALLOCATABLE :: YCLNO2IJ   (  :,:,:  ) ! Yield CLNO2 in Fine modes 
      REAL, SAVE, ALLOCATABLE :: YCLNO2K    (  :,:,:  ) ! Yield CLNO2 in coarse mode 
      REAL, SAVE, ALLOCATABLE :: EF_HNO3    (  :,:,:  ) ! Enhancement factor for calculating J_ANO3
      REAL, SAVE, ALLOCATABLE :: GAMMAHFPODAF( :,:,:  )
      REAL, SAVE, ALLOCATABLE :: GAMMACOF2   ( :,:,:  )
      REAL, SAVE, ALLOCATABLE :: GAMMAPFMOAF ( :,:,:  )
      REAL, SAVE, ALLOCATABLE :: KpartHFPODAF( :,:,:  )
      REAL, SAVE, ALLOCATABLE :: KpartCOF2   ( :,:,:  )
      REAL, SAVE, ALLOCATABLE :: KpartPFMOAF ( :,:,:  )
  
      LOGICAL, SAVE           :: AERO_CHEM_SET = .FALSE.
 
      ! Define type for storing names, properties, and components of
      ! all ELMO variables 
      TYPE ELMO_TABLE_TYPE
          CHARACTER (LEN = 16) :: NAME        ! Variable Name ( as it appears on the ELMO_LIST, in CGRID, etc.)
          CHARACTER (LEN = 16) :: OUT_NAME    ! Variable Name that will be written to the output file
          INTEGER              :: OUT_TYPE    ! IOAPI Variable Type
          INTEGER              :: ID          ! ID Number mapping to specific calculation, CGRID index, AERO 
                                              !   index, Family, etc.
          INTEGER              :: VAR_TYPE    ! ELMO Variable Type (Derived, Composite, CGRID, WDEP, DDEP)
          INTEGER              :: IM          ! Mode of interest if mode-dependent
          INTEGER              :: SOURCE      ! Source Number for ISAM or DDM3D Variables
          CHARACTER (LEN = 16) :: CUNIT       ! Units in Character Format
          INTEGER              :: IUNIT       ! Units in Integer Format:
                                              !   0 = unspecified;  1 = 'ug m-3';  2 = 'ppmV' 
          CHARACTER (LEN = 80) :: DESC        ! Description for Output File
                                              
          REAL                 :: MW          ! Species molecular weight, if defined
          LOGICAL              :: L_COMP      ! Is this variable a linear combination of other variables
          INTEGER              :: DRVD_TAB    ! Index in the table of Derived Variable Parameters
      END TYPE ELMO_TABLE_TYPE

      TYPE ELMO_COMP_TYPE
          INTEGER              :: N_VARS      ! Some variables are linear combinations of other variables.
                                              !   N_VARS is the number of components within such a combination. 
                                              !   This should not account for modes. For example, 
                                              !   to sum ASO4IJK, N_VARS would be 1 since only 
                                              !   ASO4 is being used.
          INTEGER, ALLOCATABLE :: TABID(:)    ! ID Number in ELMO_TABLE
          INTEGER, ALLOCATABLE :: ID(:)       ! Index in native array (e.g. CGRID, AEROSPC, SA_ACONC, etc.)
          INTEGER, ALLOCATABLE :: VAR_TYPE(:) ! ELMO Variable Type (Derived, CGRID, COMPOSITE, WDEP, DDEP)
          REAL,    ALLOCATABLE :: MW(:)       ! Species molecular weight, if defined
          INTEGER, ALLOCATABLE :: SPC_UNIT(:) ! Indicates whether this variables units are mass-based(1), 
                                              !   mole-based(2), or neither(0).
          REAL,    ALLOCATABLE :: COEFF(:)    ! Coefficient for each variable
          LOGICAL, ALLOCATABLE :: L_MODE(:)   ! For which modes does this aggregate apply
          LOGICAL, ALLOCATABLE :: L_SOURCE(:) ! For Which sources does this component apply
          INTEGER              :: INLET       ! Integer pointing to the corresponding inlet of choice 
                                              !   in the ELMO_INLET structure
          INTEGER              :: WETNESS     ! Integer prescribing wet or dry aerosol (1 = wet, 2 = dry)
                                              !   Default is wet
      END TYPE ELMO_COMP_TYPE

      TYPE (ELMO_TABLE_TYPE), ALLOCATABLE, SAVE :: ELMO_TABLE( : )
      TYPE (ELMO_COMP_TYPE ), ALLOCATABLE, SAVE :: ELMO_COMP( : ) 

      INTEGER, SAVE :: N_ELMO_TABLE



      ! Define List of Possible Units for Output
      INTEGER, PARAMETER :: N_UNIT = 39
      CHARACTER( 11 ), PARAMETER :: CUNIT( N_UNIT ) = 
     &    (/'UG M-3     ','PPMV       ','UGC M-3    ','PPMC       ',
     &      'UGN M-3    ','PPMN       ','M-3        ','M2 M-3     ',
     &      'HA-1       ','M2 HA-1    ','KG HA-1    ','1          ',
     &      '           ','UM         ','M3 M-3     ','N M-3      ',
     &      'KG M-3     ','UMOL M-3   ','MOL L-1    ','UG UG-1    ',
     &      'K          ','PA         ','S-1        ','M          ',
     &      'MM-1       ','M2 S-1     ','PMOLEC CM-2','NG M-3     ',
     &      'PPBV       ','MOL KG-1   ','KGN HA-1   ','KGS HA-1   ',
     &      'MEQN M-2   ','MEQS M-2   ','W M-2      ','CM         ',
     &      'M S-1      ','DEG        ','PPBC       '/)
      
      INTEGER, PARAMETER :: IU_UNSP       = 0   ! Unspecified Units
      INTEGER, PARAMETER :: IU_UGpM3      = 1   ! ug m-3
      INTEGER, PARAMETER :: IU_PPMV       = 2   ! ppmV
      INTEGER, PARAMETER :: IU_UGCpM3     = 3   ! ugC m-3
      INTEGER, PARAMETER :: IU_PPMC       = 4   ! ppmC
      INTEGER, PARAMETER :: IU_UGNpM3     = 5   ! ugN m-3
      INTEGER, PARAMETER :: IU_PPMN       = 6   ! ppmN
      INTEGER, PARAMETER :: IU_pM3        = 7   ! m-3
      INTEGER, PARAMETER :: IU_M2pM3      = 8   ! m2 m-3
      INTEGER, PARAMETER :: IU_pHA        = 9   ! ha-1
      INTEGER, PARAMETER :: IU_M2pHA      = 10  ! m2 ha-1
      INTEGER, PARAMETER :: IU_KGpHA      = 11  ! kg ha-1
      INTEGER, PARAMETER :: IU_1          = 12  ! 1
      INTEGER, PARAMETER :: IU_NONE       = 13  ! dimensionless
      INTEGER, PARAMETER :: IU_UM         = 14  ! um
      INTEGER, PARAMETER :: IU_M3pM3      = 15  ! m3 m-3
      INTEGER, PARAMETER :: IU_NpM3       = 16  ! N m-3
      INTEGER, PARAMETER :: IU_KGpM3      = 17  ! kg m-3
      INTEGER, PARAMETER :: IU_UMOLpM3    = 18  ! umol m-3
      INTEGER, PARAMETER :: IU_MOLpL      = 19  ! mol L-1
      INTEGER, PARAMETER :: IU_UGpUG      = 20  ! ug ug-1
      INTEGER, PARAMETER :: IU_K          = 21  ! K
      INTEGER, PARAMETER :: IU_PA         = 22  ! Pa
      INTEGER, PARAMETER :: IU_pS         = 23  ! s-1
      INTEGER, PARAMETER :: IU_M          = 24  ! m
      INTEGER, PARAMETER :: IU_pMM        = 25  ! Mm-1
      INTEGER, PARAMETER :: IU_M2pS       = 26  ! m2 s-1
      INTEGER, PARAMETER :: IU_PMOLECpCM2 = 27  ! Petamolecule cm-2
      INTEGER, PARAMETER :: IU_NGpM3      = 28  ! ng m-3
      INTEGER, PARAMETER :: IU_PPBV       = 29  ! ppbV
      INTEGER, PARAMETER :: IU_MOLpKG     = 30  ! mol kg-1
      INTEGER, PARAMETER :: IU_KGNpHA     = 31  ! kgN ha-1
      INTEGER, PARAMETER :: IU_KGSpHA     = 32  ! kgS ha-1
      INTEGER, PARAMETER :: IU_MEQNpM2    = 33  ! meqN m-2
      INTEGER, PARAMETER :: IU_MEQSpM2    = 34  ! meqS m-2
      INTEGER, PARAMETER :: IU_WpM2       = 35  ! W m-2
      INTEGER, PARAMETER :: IU_CM         = 36  ! CM
      INTEGER, PARAMETER :: IU_MpS        = 37  ! m s-1
      INTEGER, PARAMETER :: IU_DEG        = 38  ! deg
      INTEGER, PARAMETER :: IU_PPBC       = 39  ! ppbC


      ! Define Logical flags for turning on output categories
      LOGICAL, SAVE :: L_ELMO_WDEP, L_ELMO_DDEP

      TYPE ELMO_INLET_TYPE
          CHARACTER( 16 ) CINLET            ! Inlet Name
          REAL            DIAM_LO           ! Lower Diameter of this Inlet [um]
          REAL            DIAM_HI           ! Upper Diameter of this inlet [um]
      END TYPE ELMO_INLET_TYPE

      INTEGER, PARAMETER :: N_INLET = 10
      INTEGER, PARAMETER :: IPM01 = 1, IPM1 = 2, IPM25 = 3, IPM10 = 4, 
     &                      IPM25to10 = 5, IPMAMS = 6, INUM10 = 7,
     &                      INUM20 = 8, INUM40 = 9, INUM100 = 10
      INTEGER, PARAMETER :: IWET = 1, IDRY = 2

      TYPE (ELMO_INLET_TYPE), PARAMETER :: ELMO_INLET( N_INLET ) = (/
       !                       Inlet Name D_Lo  D_Hi
       !                       ---------- ----  ----
     &        ELMO_INLET_TYPE( 'PM01    ', 0.0,  0.1 ),
     &        ELMO_INLET_TYPE( 'PM1     ', 0.0,  1.0 ),
     &        ELMO_INLET_TYPE( 'PM25    ', 0.0,  2.5 ),
     &        ELMO_INLET_TYPE( 'PM10    ', 0.0, 10.0 ),
     &        ELMO_INLET_TYPE( 'PM25TO10', 2.5, 10.0 ),
     &        ELMO_INLET_TYPE( 'AMS     ', 0.0,  0.0 ),
     &        ELMO_INLET_TYPE( 'INUM10  ', 0.01,1.0e3),
     &        ELMO_INLET_TYPE( 'INUM20  ', 0.02,1.0e3),
     &        ELMO_INLET_TYPE( 'INUM40  ', 0.04,1.0e3),
     &        ELMO_INLET_TYPE( 'INUM100 ', 0.1, 1.0e3) /)

      REAL, SAVE :: INLET_FRAC( N_INLET,N_MODE,2 )  ! Fraction of each aerosol mode 
                                                    !   collected by each inlet
                                                    !   Third dimension is 1
                                                    !     for wet and 2 for dry

      ! Integers for specifying the kind of organic aerosol metric
      ! requested from the function SUM_ORGS in ELMO_CALC_DERIVED.F
      INTEGER, PARAMETER :: OT_OA = 1, OT_OC = 2, OT_OMOC = 3, 
     &                      OT_OTOC = 4, OT_DD_OA = 5, OT_WD_OA = 6,
     &                      OT_DD_OC = 7, OT_WD_OC = 8

      
      ! Make table of Parameters for documenting and calculating derived
      ! concentration and deposition variables
      TYPE ELMO_DRVD_TYPE
          INTEGER  ID        ! Variable ID from ELMO_LIST
          INTEGER  MODE      ! Index of Mode Mask
          INTEGER  INLET     ! Index of Mode Mask
          INTEGER  ORG_OP    ! Operation used for calculation
          INTEGER  ORG_MASK  ! Which organic categories to consider
      END TYPE ELMO_DRVD_TYPE

      INTEGER, PARAMETER :: N_ELMO_DRVD = 41
      TYPE (ELMO_DRVD_TYPE), PARAMETER :: ELMO_DRVD_TAB( N_ELMO_DRVD ) = (/
       !                 ID           Mode    Inlet   ORG_OP    ORG_MASK
       !                ------------- -----   -----   ------    --------
       !                                   
        ! Mass Variables
     &  ELMO_DRVD_TYPE( ID_PM,        IM_ALL, 0,        0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PMU,       IM_UF,  0,        0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PMF,       IM_F,   0,        0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PMC,       IM_C,   0,        0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PMNUC,     IM_NUC, 0,        0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PMAIT,     IM_AIT, 0,        0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PMACC,     IM_ACC, 0,        0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PM01,      IM_ALL, IPM01,    0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PM1,       IM_ALL, IPM1,     0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PM25,      IM_ALL, IPM25,    0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PM10,      IM_ALL, IPM10,    0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PM25to10,  IM_ALL, IPM25to10,0,        0       ),
     &  ELMO_DRVD_TYPE( ID_PMAMS,     IM_ALL, IPMAMS,   0,        0       ),

        ! Organics
     &  ELMO_DRVD_TYPE( ID_PMF_OA,    IM_F,   0,        OT_OA,    0       ),                                          
     &  ELMO_DRVD_TYPE( ID_PMF_OC,    IM_F,   0,        OT_OC,    0       ),                                          
     &  ELMO_DRVD_TYPE( ID_PMF_POA,   IM_F,   0,        OT_OA,    IOA_PRI ),                                          
     &  ELMO_DRVD_TYPE( ID_PMF_POC,   IM_F,   0,        OT_OC,    IOA_PRI ),                                          
     &  ELMO_DRVD_TYPE( ID_PMF_SOA,   IM_F,   0,        OT_OA,    IOA_SEC ),                                          
     &  ELMO_DRVD_TYPE( ID_PMF_SOC,   IM_F,   0,        OT_OC,    IOA_SEC ),                                          
     &  ELMO_DRVD_TYPE( ID_PMF_ASOA,  IM_F,   0,        OT_OA, IOA_ANTSEC ),  
     &  ELMO_DRVD_TYPE( ID_PMF_BSOA,  IM_F,   0,        OT_OA, IOA_BIOSEC ),                                          
     &  ELMO_DRVD_TYPE( ID_PMF_OMOC,  IM_F,   0,        OT_OMOC,  0       ),                                          
     &  ELMO_DRVD_TYPE( ID_PMF_OTOC,  IM_F,   0,        OT_OTOC,  0       ),                                          
     &  ELMO_DRVD_TYPE( ID_AMS_OA,    IM_ALL, IPMAMS,   OT_OA,    0       ),                                          
     &  ELMO_DRVD_TYPE( ID_AMS_OTOC,  IM_ALL, IPMAMS,   OT_OTOC,  0       ),                                          
     &  ELMO_DRVD_TYPE( ID_PM1_OA,    IM_ALL, IPM1,     OT_OA,    0       ),                                          
     &  ELMO_DRVD_TYPE( ID_PM1_OC,    IM_ALL, IPM1,     OT_OC,    0       ),                                          
     &  ELMO_DRVD_TYPE( ID_PM25_OA,   IM_ALL, IPM25,    OT_OA,    0       ),                                          
     &  ELMO_DRVD_TYPE( ID_PM25_OC,   IM_ALL, IPM25,    OT_OC,    0       ),                                          
       
        ! Organic Deposition
     &  ELMO_DRVD_TYPE( ID_DD_OA,     IM_F,   0,        OT_DD_OA, 0       ),                                          
     &  ELMO_DRVD_TYPE( ID_WD_OA,     IM_F,   0,        OT_WD_OA, 0       ),                                          
     &  ELMO_DRVD_TYPE( ID_DD_OC,     IM_F,   0,        OT_DD_OC, 0       ),                                          
     &  ELMO_DRVD_TYPE( ID_WD_OC,     IM_F,   0,        OT_WD_OC, 0       ),                                          
     &  ELMO_DRVD_TYPE( ID_DD_POA,    IM_F,   0,        OT_DD_OA, IOA_PRI ),                                          
     &  ELMO_DRVD_TYPE( ID_WD_POA,    IM_F,   0,        OT_WD_OA, IOA_PRI ),                                          
     &  ELMO_DRVD_TYPE( ID_DD_POC,    IM_F,   0,        OT_DD_OC, IOA_PRI ),                                          
     &  ELMO_DRVD_TYPE( ID_WD_POC,    IM_F,   0,        OT_WD_OC, IOA_PRI ),                                          
     &  ELMO_DRVD_TYPE( ID_DD_SOA,    IM_F,   0,        OT_DD_OA, IOA_SEC ),                                          
     &  ELMO_DRVD_TYPE( ID_WD_SOA,    IM_F,   0,        OT_WD_OA, IOA_SEC ),                                          
     &  ELMO_DRVD_TYPE( ID_DD_SOC,    IM_F,   0,        OT_DD_OC, IOA_SEC ),                                    
     &  ELMO_DRVD_TYPE( ID_WD_SOC,    IM_F,   0,        OT_WD_OC, IOA_SEC )

     &  /)
                                                                                                                   
                                                                                                                                  
                                                                                                                                  
      ! Define global arrays for capturing ELMO variable data from other                                                          
      ! CMAQ modules                                                                                                              
        REAL, ALLOCATABLE, SAVE, PUBLIC ::                                                                                        
     &                             ELMO_AOD_550(:,:),  ! total aerosol optical depth at                                           
                                                       !   550 nm (Angstrom Interpolation)                                        
     &                             ELMO_EXT_550(:,:,:),! aerosol extinction at 550 nm for layer [1/m]                             
     &                             ELMO_NO2COL(:,:),   ! NO2 Column                                                                 
     &                             ELMO_SO2COL(:,:),   ! SO2 Column                                                                 
     &                             ELMO_HCHOCOL(:,:),  ! Formaldehyde Column                                                        
     &                             ELMO_COCOL(:,:),    ! CO Column                                                                  
     &                             ELMO_VOC_NOX(:,:,:) ! VOC or NOx limited ozone formation                                                                  
                                                                                                                                  
        REAL, ALLOCATABLE, SAVE :: ELMO_WDEP(:,:,:) ! wet deposition accumulated per time step                                    
        REAL, ALLOCATABLE, SAVE :: ELMO_DDEP(:,:,:) ! dry deposition accumulated per time step                                    
        REAL, ALLOCATABLE, SAVE :: ELMO_ISAM_WDEP(:,:,:,:) ! wet deposition accumulated per time step                             
        REAL, ALLOCATABLE, SAVE :: ELMO_ISAM_DDEP(:,:,:,:) ! dry deposition accumulated per time step                             
        REAL, ALLOCATABLE, SAVE :: ELMO_DDM_WDEP(:,:,:,:) ! wet deposition accumulated per time step                              
        REAL, ALLOCATABLE, SAVE :: ELMO_DDM_DDEP(:,:,:,:) ! dry deposition accumulated per time step                              
                                                                                                                                  
        REAL, SAVE :: WDIR10, PV                                                                                                                
                                                                                                                                                
        LOGICAL, SAVE :: INIT_TIME

        ! Set Value for Missing Variables
#ifdef mpas
        REAL, PARAMETER :: ELMO_BLANK = -9.000E36
#else
        REAL, PARAMETER :: ELMO_BLANK = AMISS3
#endif       
        CONTAINS

!------------------------------------------------------------------------------------------            
        subroutine elmo_init_shared
!------------------------------------------------------------------------------------------            
        use runtime_vars, only : voc_nox_trans
        use grid_conf,  only : ncols, nrows, nlays
        use cgrid_spcs, only : n_cgrid_spc
#ifdef isam
        use sa_defn,    only : nspc_sa, ntag_sa
#endif
#ifdef sens
        use ddm3d_defn, only : npmax
#endif

        implicit none

        integer ios
        character(32) :: pname = 'ELMO_INIT_SHARED'
        logical, save :: firstime = .True.

        if (firstime ) then
            firstime = .false.
            
            allocate( elmo_aod_550(ncols, nrows ), stat=ios)
            call checkmem( ios, 'ELMO_AOD_550',pname )
            elmo_aod_550 = 0.0
     
            allocate( elmo_ext_550(ncols, nrows, nlays ), stat=ios)
            call checkmem( ios, 'ELMO_EXT_550',pname )
            elmo_ext_550 = 0.0
     
            allocate( elmo_no2col(ncols, nrows ), stat=ios)
            call checkmem( ios, 'ELMO_NO2COL',pname )
            elmo_no2col = 0.0
     
            allocate( elmo_so2col(ncols, nrows ), stat=ios)
            call checkmem( ios, 'ELMO_SO2COL',pname )
            elmo_so2col = 0.0
     
            allocate( elmo_hchocol(ncols, nrows ), stat=ios)
            call checkmem( ios, 'ELMO_HCHOCOL',pname )
            elmo_hchocol = 0.0
     
            allocate( elmo_cocol(ncols, nrows ), stat=ios)
            call checkmem( ios, 'ELMO_COCOL',pname )
            elmo_cocol = 0.0
     
            allocate( elmo_wdep(ncols, nrows, n_cgrid_spc ), stat=ios)
            call checkmem( ios, 'ELMO_WDEP',pname )
            elmo_wdep = 0.0
     
            allocate( elmo_ddep(ncols, nrows, n_cgrid_spc ), stat=ios)
            call checkmem( ios, 'ELMO_DDEP',pname )
            elmo_ddep = 0.0

#ifdef isam
            allocate( elmo_voc_nox(ncols, nrows, nlays ), stat=ios)
            call checkmem( ios, 'ELMO_VOC_NOX',pname )
            elmo_voc_nox = voc_nox_trans
         
            allocate( elmo_isam_wdep(ncols, nrows, nspc_sa, ntag_sa ), stat=ios)
            call checkmem( ios, 'ELMO_ISAM_WDEP',pname )
            elmo_isam_wdep = 0.0
         
            allocate( elmo_isam_ddep(ncols, nrows, nspc_sa, ntag_sa ), stat=ios)
            call checkmem( ios, 'ELMO_ISAM_DDEP',pname )
            elmo_isam_ddep = 0.0
#endif
#ifdef sens
            allocate( elmo_ddm_wdep(ncols, nrows, n_cgrid_spc, npmax ), stat=ios)
            call checkmem( ios, 'ELMO_DDM_WDEP',pname )
            elmo_ddm_wdep = 0.0
            
            allocate( elmo_ddm_ddep(ncols, nrows, n_cgrid_spc, npmax ), stat=ios)
            call checkmem( ios, 'ELMO_DDM_DDEP',pname )
            elmo_ddm_ddep = 0.0
#endif
        end if


        end subroutine elmo_init_shared


!------------------------------------------------------------------------------------------            
      SUBROUTINE MAP_ELMO_NML( IFL, L_ELMO_TABLE, IERROR )
!     This subroutine maps user input from the CMAQ_Control namelist to
!     the ELMO_TABLE to define which variables should be output. It
!     expands Keywords, maps to concentrations, deposition fluxes, and
!     families, with expansion for families if requested (using a * in
!     front of the family name).
!-------------------------------------------------------------------------

      USE util_Family_module
      USE RXNS_DATA, ONLY : MECHNAME
      USE aero_Data, ONLY : NPFAS, PFAS, aerospc, map_pfastoaero

      IMPLICIT NONE

      INTEGER, INTENT( IN )  :: IFL
      LOGICAL, INTENT( OUT ) :: L_ELMO_TABLE( N_ELMO_TABLE )
      INTEGER, INTENT( OUT ) :: IERROR
      CHARACTER(32), ALLOCATABLE :: VARS_NML( : )

      INTEGER N_END, N_NML
      LOGICAL EXPAND_NML
      INTEGER I1, I2, I3, IT, IVAR, J, IV, IM, IPFAS
      CHARACTER(16) :: AERNAME
      
      
      CHARACTER( 250 ) :: XMSG
      CHARACTER(32), PARAMETER :: PNAME = 'MAP_ELMO_NML'

      
      IERROR = 0

      ! Diagnose VARS_NML_IN Size
      N_NML = ELMO_FILE( IFL )%N_VARS_IN
      N_END = INDEX1( '', N_NML, ELMO_FILE( IFL )%VARS_IN(:) ) - 1
      IF ( N_END .LE. 0 ) THEN
          WRITE( XMSG, '(A)' ),'ERROR: Unreadable variables requested for ELMO output'
          CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
      END IF
      
      ! Initialize VARS_NML
      ALLOCATE( VARS_NML( 1000 ) )
      VARS_NML = ''
      VARS_NML( 1:N_END ) = ELMO_FILE( IFL )%VARS_IN( 1:N_END )

      ! Loop through VARS_NML and Activate ELMO Variables
      DO WHILE ( N_END .GT. 0 )
         !CALL UPCASE( VARS_NML( 1 ) )
         EXPAND_NML = .FALSE.
         IF ( VARS_NML(1)(1:1) .EQ. '*' ) THEN
            EXPAND_NML = .TRUE.
            VARS_NML(1)(1:32) = VARS_NML( 1 )(2:32)//' '
         END IF

         ! Detect location of VARS_NML( INUM ) in the ELMO_TABLE
         ! or Keyword List
         I1 = INDEX1( VARS_NML(1), N_KEY, ELMO_KEY%WORD )
         I2 = INDEX1( VARS_NML(1), N_ELMO_TABLE, ELMO_TABLE%NAME )
         I3 = INDEX1( VARS_NML(1), N_ELMO_TABLE, ELMO_TABLE%OUT_NAME )

         IF ( VARS_NML(1) .EQ. 'ALL' ) THEN
            ! Add All ELMO_TABLE variables to the File
            L_ELMO_TABLE( : ) = .TRUE.

         ELSE IF ( VARS_NML(1) .EQ. 'ALL_CONC' ) THEN
            ! Activate all CGRID species
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_CONC )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
          
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_DEP' ) THEN
            ! Activate all Deposition Fluxes
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_WDEP .OR.
     &               ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_DDEP )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
          
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_WDEP' ) THEN
            ! Activate all Wet Deposition Fluxes
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_WDEP )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
          
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_DDEP' ) THEN
            ! Activate all Dry Deposition FLuxes
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_DDEP )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
          
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_ISAM_CONC' ) THEN
            ! Activate all ISAM Species
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_ISAM_CONC )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
          
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_ISAM_WDEP' ) THEN
            ! Activate all ISAM Wet Deposition Fluxes
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_ISAM_WDEP )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
          
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_ISAM_DDEP' ) THEN
            ! Activate all ISAM Dry Deposition Fluxes
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_ISAM_DDEP )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
          
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_DDM_CONC' ) THEN
            ! Activate all DDM3D Species
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_DDM_CONC )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
          
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_DDM_WDEP' ) THEN
            ! Activate all DDM Wet Deposition Fluxes
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_DDM_WDEP )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
          
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_DDM_DDEP' ) THEN
            ! Activate all DDM Dry Deposition Fluxes
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_DDM_DDEP )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
         
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_AEROPROP' ) THEN
            ! Activate all Aerosol Properties
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_AEROPROP )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
         
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_CHEM' ) THEN
            ! Activate all Available Chemistry Parameters
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_CHEM )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
         
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_MET' ) THEN
            ! Activate all Meteorological Variables
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_MET )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
         
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_PHOT' ) THEN
            ! Activate all Photolysis Variables
            DO IT = 1,N_ELMO_TABLE
                IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ET_PHOT )
     &                  L_ELMO_TABLE( IT ) = .TRUE.
            END DO
 
         ELSE IF ( VARS_NML(1) .EQ. 'DEFAULT' ) THEN
            ! Replace generic DEFAULT keyword with mechanism-specific
            ! keyword
            VARS_NML( N_END+1 ) = 'DEFAULT_' // TRIM( MECHNAME )
            N_END = N_END + 1
         
         ELSE IF ( VARS_NML(1) .EQ. 'DEFAULT_DEP' ) THEN
            ! Replace generic DEFAULT keyword with mechanism-specific
            ! keyword
            VARS_NML( N_END+1 ) = 'DEFAULT_DEP_' // TRIM( MECHNAME )
            N_END = N_END + 1
         
          ELSE IF ( VARS_NML(1) .EQ. 'ALL_PFAS' ) THEN
            ! Activate all PFAS species
            DO IPFAS = 1,NPFAS
              DO IT = 1,N_ELMO_TABLE
                 IF ( ELMO_TABLE(IT)%NAME .EQ. PFAS(IPFAS)%GASNAME ) 
     &              L_ELMO_TABLE( IT ) = .TRUE.

                 DO IM = 1,N_MODE
                    AERNAME = AEROSPC( MAP_PFAStoAERO(IPFAS) )%NAME(IM)
                    IF ( ELMO_TABLE(IT)%NAME .EQ. AERNAME ) 
     &                  L_ELMO_TABLE( IT ) = .TRUE.
                 END DO
              END DO
            END DO
         
         ELSE IF ( VARS_NML(1) .EQ. 'ALL_PFAS_DEP' ) THEN
            ! Activate Deposition for all PFAS species
            DO IPFAS = 1,NPFAS
              DO IT = 1,N_ELMO_TABLE
                 IF ( ELMO_TABLE(IT)%NAME .EQ. 'DD_'//PFAS(IPFAS)%GASNAME .OR.
     &                ELMO_TABLE(IT)%NAME .EQ. 'WD_'//PFAS(IPFAS)%GASNAME ) 
     &              L_ELMO_TABLE( IT ) = .TRUE.

                 DO IM = 1,N_MODE
                    AERNAME = AEROSPC( MAP_PFAStoAERO(IPFAS))%NAME(IM)
                    IF ( ELMO_TABLE(IT)%NAME .EQ. 'DD_'//AERNAME .OR.
     &                   ELMO_TABLE(IT)%NAME .EQ. 'WD_'//AERNAME) 
     &                  L_ELMO_TABLE( IT ) = .TRUE.
                 END DO
              END DO            
            END DO
        
         ELSEIF ( I1 .GT. 0 ) THEN
            ! Expand Matched Keyword
            VARS_NML( N_END+1:N_END+ELMO_KEY( I1 )%N ) =
     &                              ELMO_KEY( I1 )%LIST
            N_END = N_END + ELMO_KEY( I1 )%N

         ELSE IF ( I2 .GT. 0 ) THEN
            ! First check for COMPOSITES
            IF ( (ELMO_TABLE( I2 )%VAR_TYPE .EQ. ET_CMPST .OR.
     &            ELMO_TABLE( I2 )%VAR_TYPE .EQ. ET_CMPST_DEP .OR.
     &            ELMO_TABLE( I2 )%VAR_TYPE .EQ. ET_ISAM_CMPST .OR.
     &            ELMO_TABLE( I2 )%VAR_TYPE .EQ. ET_ISAM_CMPST_DEP .OR.
     &            ELMO_TABLE( I2 )%VAR_TYPE .EQ. ET_DDM_CMPST .OR.
     &            ELMO_TABLE( I2 )%VAR_TYPE .EQ. ET_DDM_CMPST_DEP ) 
     &          .AND. EXPAND_NML ) THEN

                 ! Expand the COMPOSITE if the * was used
                 DO IVAR = 1,ELMO_COMP( I2 )%N_VARS
                   J = ELMO_COMP( I2 )%TABID( IVAR )
                   VARS_NML( N_END+IVAR ) = ELMO_TABLE( J )%NAME 
                 END DO
                 N_END = N_END + ELMO_COMP( I2 )%N_VARS
                
            ELSE 
              ! Entry Matches the NAME of a variable on the ELMO Table.
              ! But this could be a mode-dependent or source-dependent 
              ! variable so all of the ELMO Table entries that match 
              ! this name but correspond to different modes or sources 
              ! should be activated.
              DO IT = 1,N_ELMO_TABLE
                  IF ( ELMO_TABLE( IT )%VAR_TYPE .EQ. ELMO_TABLE( I2 )%VAR_TYPE .AND.
     &                 ELMO_TABLE( IT )%NAME .EQ. ELMO_TABLE( I2 )%NAME ) THEN
                     L_ELMO_TABLE( IT ) = .TRUE.
                  END IF
              END DO

            END IF

         ELSE IF ( I3 .GT. 0 ) THEN
            ! Entry Matches the OUT_NAME of a variable on the ELMO
            ! Table.    
            ! First check for COMPOSITES
            IF ( (ELMO_TABLE( I3 )%VAR_TYPE .EQ. ET_CMPST .OR.
     &            ELMO_TABLE( I3 )%VAR_TYPE .EQ. ET_CMPST_DEP .OR.
     &            ELMO_TABLE( I3 )%VAR_TYPE .EQ. ET_ISAM_CMPST .OR.
     &            ELMO_TABLE( I3 )%VAR_TYPE .EQ. ET_ISAM_CMPST_DEP .OR.
     &            ELMO_TABLE( I3 )%VAR_TYPE .EQ. ET_DDM_CMPST .OR.
     &            ELMO_TABLE( I3 )%VAR_TYPE .EQ. ET_DDM_CMPST_DEP ) 
     &          .AND. EXPAND_NML ) THEN

                 ! Expand the COMPOSITE if the * was used
                 DO IVAR = 1,ELMO_COMP( I3 )%N_VARS
                   J = ELMO_COMP( I3 )%TABID( IVAR )
                   VARS_NML( N_END+IVAR ) = ELMO_TABLE( J )%OUT_NAME 
                 END DO
                 N_END = N_END + ELMO_COMP( I3 )%N_VARS
                
            ELSE 
                 ! This is a very specific variable. Mode and source
                 ! dependence are fixed.
                 L_ELMO_TABLE( I3 ) = .TRUE.
            END IF
          
         ELSE
            ! Entry Doesn't Match any variable on the ELMO table. Crash the
            ! model.
            XMSG = 'An ELMO variable ' // TRIM(VARS_NML(1)) //
     &             ' has been requested that does not exist. It is on ' //
     &             ' file: ' // TRIM( ELMO_FILE( IFL )%FLOGICAL )
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF

         ! Remove Keyword after processing
         VARS_NML( 1:N_END-1 ) = VARS_NML( 2:N_END )
         VARS_NML( N_END ) = ''
         N_END = N_END - 1
      END DO

      ! Check if any dry deposition variable has been requested
      DO IVAR = 1,N_ELMO_TABLE
         IV = ELMO_TABLE( IVAR )%VAR_TYPE
         IF ( IV .EQ. ET_DDEP .OR. IV .EQ. ET_ISAM_DDEP .OR.
     &        IV .EQ. ET_DDM_DDEP .OR. IV .EQ. ET_CMPST_DEP .OR.
     &        IV .EQ. ET_ISAM_CMPST_DEP .OR. IV .EQ. ET_DDM_CMPST_DEP .OR.
     &        IV .EQ. ET_DRVD_DDEP .OR. IV .EQ. ET_ISAM_DRVD_DDEP .OR.
     &        IV .EQ. ET_DDM_DRVD_DDEP ) THEN
         
              L_ELMO_DDEP = .TRUE.
              EXIT
         END IF
      END DO

      ! Check if any wet deposition variable has been requested
      DO IVAR = 1,N_ELMO_TABLE
         IV = ELMO_TABLE( IVAR )%VAR_TYPE
         IF ( IV .EQ. ET_WDEP .OR. IV .EQ. ET_ISAM_WDEP .OR.
     &        IV .EQ. ET_DDM_WDEP .OR. IV .EQ. ET_CMPST_DEP .OR.
     &        IV .EQ. ET_ISAM_CMPST_DEP .OR. IV .EQ. ET_DDM_CMPST_DEP .OR.
     &        IV .EQ. ET_DRVD_WDEP .OR. IV .EQ. ET_ISAM_DRVD_WDEP .OR.
     &        IV .EQ. ET_DDM_DRVD_WDEP ) THEN
         
              L_ELMO_WDEP = .TRUE.
              EXIT
         END IF
      END DO

      END SUBROUTINE MAP_ELMO_NML    

!------------------------------------------------------------------------------------------            
      SUBROUTINE ELMO_CHECK_LAYERS( LAYER_TOP, LAYER_BOT, IFILE )
!     This subroutine checks that the layers specified for an ELMO file
!     are allowed.
!-------------------------------------------------------------------------

      USE GRID_CONF, ONLY : NLAYS

      IMPLICIT NONE

      INTEGER, INTENT( INOUT )    :: LAYER_TOP
      INTEGER, INTENT( IN )       :: LAYER_BOT
      INTEGER, INTENT( IN )       :: IFILE
      CHARACTER(250)              :: XMSG
      CHARACTER(32), PARAMETER    :: PNAME = 'ELMO_CHECK_LAYERS'
      CHARACTER( 13 )             :: FNAME

      WRITE( FNAME, '("ELMO FILE ",I3.3)' ) IFILE

      IF ( LAYER_TOP .EQ. -1 ) LAYER_TOP = NLAYS
      IF ( LAYER_TOP .LE. 0 .OR. LAYER_TOP .GT. NLAYS ) THEN
           XMSG = TRIM( FNAME ) // '_LAY_TOP must be prescribed between '//
     &            '1 and NLAYS, or set to -1 to automatically choose NLAYS.'
           CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF
      IF ( LAYER_BOT .LE. 0 .OR. LAYER_BOT .GT. NLAYS ) THEN
           XMSG = TRIM(FNAME) // '_LAY_BOT must be prescribed between '// 
     &            '1 and NLAYS.'
           CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF
      IF ( LAYER_BOT .GT. LAYER_TOP ) THEN
           XMSG = TRIM(FNAME) // ' LAY_BOT must be less than or equal '// 
     &            'to ' // TRIM(FNAME) // ' LAY_TOP.'
           CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF

      END SUBROUTINE ELMO_CHECK_LAYERS

!-------------------------------------------------------------------------
      SUBROUTINE MAP_ELMO_UNITS( UNIT_TMP, IUNIT, VARNAME, VARTYPE )
!     This subroutine maps units in character strings to a standard
!     vector of ELMO units that are available for output. This integer
!     vector distinguishes mass-based units from mole-based units so
!     that density conversions may be applied online.
!-------------------------------------------------------------------------

      IMPLICIT NONE

      CHARACTER( * ), INTENT( IN ) :: UNIT_TMP 
      INTEGER, INTENT( OUT )       :: IUNIT
      CHARACTER( 16 ), INTENT( IN ):: VARNAME
      INTEGER, INTENT( IN )        :: VARTYPE
      CHARACTER(  16 ) UNITTYPE
      CHARACTER( 200 ) XMSG
      INTEGER IT
 

      ! Assign Unit to Aggregate Variable
      UNITTYPE = UNIT_TMP
      CALL UPCASE( UNITTYPE )
      
      IUNIT = 0
      DO IT = 1,N_UNIT
         IF ( UNITTYPE .EQ. CUNIT( IT ) ) THEN
            IUNIT = IT
         END IF
      END DO

      IF ( IUNIT .EQ. 0 ) THEN
         IUNIT = 0
         XMSG = 'A unit (' // trim(UNIT_TMP) // ') has been given ' //
     &        'for the mapping of a variable of type ' // 
     &        TRIM(CETYPE(VARTYPE)) // ' that is unknown to ELMO. ' //
     &        'Confirm that this is correct for variable ' // trim(VARNAME) //
     &        '.  ' // TRIM( UNITTYPE)
         CALL M3WARN( 'MAP_ELMO_UNITS', 0, 0, XMSG )
      END IF
 
      END SUBROUTINE MAP_ELMO_UNITS
 
!------------------------------------------------------------------------------------------            
      REAL FUNCTION ELMO_UNIT_CONV( J, OUT_UNIT, D )
!     This subroutine calculates the conversion factor from a component
!     variable to an output variable.
!-------------------------------------------------------------------------
 
      USE AEROMET_DATA, ONLY : AIRDENS
      USE CONST, ONLY : MWAIR

      IMPLICIT NONE
 
      INTEGER, INTENT( IN )  :: J         ! Table ID of Data
      INTEGER, INTENT( IN )  :: OUT_UNIT  ! Output unit
      REAL,    INTENT( IN )  :: D         ! Data to be converted 

      INTEGER :: SPC_UNIT
      CHARACTER(16) :: PNAME = 'ELMO_UNIT_CONV'
      CHARACTER(200) :: XMSG

      ! Determine Unit Conversion Factors
      SPC_UNIT = ELMO_TABLE( J )%IUNIT
      
      IF ( SPC_UNIT .EQ. OUT_UNIT .OR. OUT_UNIT .EQ. 0 ) THEN
          ELMO_UNIT_CONV = D
          RETURN
      END IF

      ! Check if this variable has a non-zero MW, which is needed
      ! for any unit conversions.
      IF ( ELMO_TABLE( J )%MW .EQ. 0.0 ) THEN
        XMSG = 'ELMO is attempting to convert variable ' // 
     &       TRIM( ELMO_TABLE( J )%NAME ) // ' from '//
     &       'units but the MW is equal to 0.0'
        CALL M3WARN( PNAME, 0, 0, XMSG )
      END IF

      ! Calculate Unit Conversions
      SELECT CASE ( OUT_UNIT )
        CASE ( IU_UGpM3 ) ! ug m-3 out
          SELECT CASE ( SPC_UNIT )
            CASE ( IU_UGpM3 ) ! mass-based
              ELMO_UNIT_CONV = D
            CASE ( IU_PPMV ) ! mole-based
              ELMO_UNIT_CONV = D * ELMO_TABLE( J )%MW
     &            / MWAIR * AIRDENS * 1000.0 ! to mass concentration
            CASE DEFAULT
              XMSG = 'ELMO is attempting to convert variable ' // 
     &           TRIM( ELMO_TABLE( J )%NAME ) // ' from '// 
     &           TRIM(CUNIT( SPC_UNIT )) // ' to ' // TRIM(CUNIT( OUT_UNIT )) //
     &           ' but it does not know to do it. No conversion is applied.'
              CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
          END SELECT 


        CASE ( IU_PPMV ) ! ppmv out
          SELECT CASE ( SPC_UNIT )
            CASE ( IU_UGpM3 ) ! mass-based
              ELMO_UNIT_CONV = D / ELMO_TABLE( J )%MW 
     &             * MWAIR / AIRDENS / 1000.0 ! to mole mixing ratio
            CASE ( IU_PPMV ) ! mole-based
              ELMO_UNIT_CONV = D
            CASE DEFAULT
              XMSG = 'ELMO is attempting to convert variable ' // 
     &           TRIM( ELMO_TABLE( J )%NAME ) // ' from '// 
     &           TRIM(CUNIT( SPC_UNIT )) // ' to ' // TRIM(CUNIT( OUT_UNIT )) //
     &           ' but it does not know to do it. No conversion is applied.'
              CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
          END SELECT 
 
        CASE ( IU_UMOLpM3 ) ! umol m-3 out
          SELECT CASE ( SPC_UNIT )
            CASE ( IU_UGpM3 ) ! mass-based
              ELMO_UNIT_CONV = D / ELMO_TABLE( J )%MW
            CASE ( IU_PPMV ) ! mole-based
              ELMO_UNIT_CONV = D / MWAIR * AIRDENS * 1000.0 
            CASE DEFAULT
              XMSG = 'ELMO is attempting to convert variable ' // 
     &           TRIM( ELMO_TABLE( J )%NAME ) // ' from '// 
     &           TRIM(CUNIT( SPC_UNIT )) // ' to ' // TRIM(CUNIT( OUT_UNIT )) //
     &           ' but it does not know to do it. No conversion is applied.'
              CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
          END SELECT 
 
        CASE ( IU_NGpM3 ) ! ng m-3 out
          SELECT CASE ( SPC_UNIT )
            CASE ( IU_UGpM3 ) ! mass-based
              ELMO_UNIT_CONV = D * 1000.0
            CASE ( IU_PPMV ) ! mole-based
              ELMO_UNIT_CONV = D * ELMO_TABLE( J )%MW
     &            / MWAIR * AIRDENS * 1.0E6 ! to mass concentration
            CASE DEFAULT
              XMSG = 'ELMO is attempting to convert variable ' // 
     &           TRIM( ELMO_TABLE( J )%NAME ) // ' from '// 
     &           TRIM(CUNIT( SPC_UNIT )) // ' to ' // TRIM(CUNIT( OUT_UNIT )) //
     &           ' but it does not know to do it. No conversion is applied.'
              CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
          END SELECT 

        CASE ( IU_PPBV ) ! ppbV out
          SELECT CASE ( SPC_UNIT )
            CASE ( IU_UGpM3 ) ! mass-based
              ELMO_UNIT_CONV = D / ELMO_TABLE( J )%MW 
     &             * MWAIR / AIRDENS ! to mole mixing ratio
            CASE ( IU_PPMV ) ! mole-based
              ELMO_UNIT_CONV = D * 1000.0
            CASE DEFAULT
              XMSG = 'ELMO is attempting to convert variable ' // 
     &           TRIM( ELMO_TABLE( J )%NAME ) // ' from '// 
     &           TRIM(CUNIT( SPC_UNIT )) // ' to ' // TRIM(CUNIT( OUT_UNIT )) //
     &           ' but it does not know to do it. No conversion is applied.'
              CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
          END SELECT 
 
        CASE ( IU_PPMC ) ! ppmC out
          SELECT CASE ( SPC_UNIT )
            CASE ( IU_UGpM3 ) ! mass-based
              ELMO_UNIT_CONV = D / ELMO_TABLE( J )%MW 
     &             * MWAIR / AIRDENS / 1000.0 ! to mole mixing ratio
            CASE ( IU_PPMV ) ! mole-based
              ELMO_UNIT_CONV = D
            CASE DEFAULT
              XMSG = 'ELMO is attempting to convert variable ' // 
     &           TRIM( ELMO_TABLE( J )%NAME ) // ' from '// 
     &           TRIM(CUNIT( SPC_UNIT )) // ' to ' // TRIM(CUNIT( OUT_UNIT )) //
     &           ' but it does not know to do it. No conversion is applied.'
              CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
          END SELECT 
 
        CASE ( IU_KGNpHA ) ! kgN ha-1 out
          SELECT CASE ( SPC_UNIT )
            CASE ( IU_KGpHA ) ! deposition output
              ELMO_UNIT_CONV = D 
            CASE DEFAULT
              XMSG = 'ELMO is attempting to convert variable ' // 
     &           TRIM( ELMO_TABLE( J )%NAME ) // ' from '// 
     &           TRIM(CUNIT( SPC_UNIT )) // ' to ' // TRIM(CUNIT( OUT_UNIT )) //
     &           ' but it does not know to do it. No conversion is applied.'
              CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
          END SELECT 
 
        CASE ( IU_KGSpHA ) ! kgS ha-1 out
          SELECT CASE ( SPC_UNIT )
            CASE ( IU_KGpHA ) ! deposition output
              ELMO_UNIT_CONV = D 
            CASE DEFAULT
              XMSG = 'ELMO is attempting to convert variable ' // 
     &           TRIM( ELMO_TABLE( J )%NAME ) // ' from '// 
     &           TRIM(CUNIT( SPC_UNIT )) // ' to ' // TRIM(CUNIT( OUT_UNIT )) //
     &           ' but it does not know to do it. No conversion is applied.'
              CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
          END SELECT 
 

        CASE DEFAULT
              XMSG = 'ELMO is attempting to convert variable ' // 
     &           TRIM( ELMO_TABLE( J )%NAME ) // ' from '// 
     &           TRIM(CUNIT( SPC_UNIT )) // ' to ' // TRIM(CUNIT( OUT_UNIT )) //
     &           ' but cannot complete it because '//TRIM(CUNIT( OUT_UNIT ))//
     &           ' is not a supported option in ELMO. Please add it to '//
     &           'ELMO_UNIT_CONV.'
              CALL M3EXIT( PNAME, 0, 0, XMSG, 1 )
 
      END SELECT 
 
      RETURN

      END FUNCTION ELMO_UNIT_CONV

      END MODULE ELMO_DATA

! Revision History:
!  2016/02/23 David Wong extracted the complex number module and put it in a file
!  2016/05/23 David Wong - replaced rrtmg_aero_optical_util_module with
!                          cmaq_rrtmg_aero_optical_util_module to avoid duplication 
!                          of the same module name on WRF side of the two-way model

MODULE cmaq_rrtmg_aero_optical_util_module


     Integer      :: AERO_UTIL_LOG = 0 
private
public :: aero_optical, aero_optical2, aero_optical_CS, AERO_UTIL_LOG

interface ghintBH 
  module procedure ghintBH_1, ghintBH_2, ghintBH_Odd
end interface

interface ghintBH_CS
  module procedure ghintBH_CS_even, ghintBH_CS_odd
end interface

      Logical, Parameter :: Use_Odd_Quadrature = .True.
       Integer, Parameter :: Quadrature_Points = 3
!      Integer, Parameter :: Quadrature_Points = 1
      
!B.Hutzell One point quadature IGH = 1

       real, parameter :: ghxi_1(1) = 0.00000000000
       real, parameter :: ghwi_1(1) = 1.77245385091
       
!B.Hutzell Three point quadature IGH = 3
       real, parameter :: ghxi_3(3) = (/ -1.22474487139,   &
                                          0.00000000000,   &
                                          1.22474487139 /)

       real, parameter :: ghwi_3(3) = (/ 0.295408975151,   &
                                         1.181635900000,   &
                                         0.295408975151 /)
                                         
!B.Hutzell Five point quadature IGH = 5
       real(8), parameter :: ghxi_5(5) = (/ -2.02018287046d0,  &
                                            -0.958572464614d0, & 
                                             0.00000000000d0,  &
                                             0.958572464614d0, &
                                             2.02018287046d0 /)

       real(8), parameter :: ghwi_5(5) = (/ 0.019953242059d0,   &
                                            0.393619323152d0,   &
                                            0.945308720483d0,   &
                                            0.393619323152d0,   &
                                            0.019953242059d0 /)

                                         

!B.Hutzell Nine point quadature IGH = 9 points
!No.  Abscissas  Weight  Total Weight  
       real, parameter :: ghxi_9(9) = (/ -3.19099320178,  &  
                                         -2.26658058453,  &  
                                         -1.46855328922,  &  
                                         -0.72355101875,  & 
                                          0.00000000000,  &  
                                          0.72355101875,  & 
                                          1.46855328922,  &  
                                          2.26658058453,  &   
                                          3.19099320178 /)  

       real, parameter :: ghwi_9(9) = (/ 3.96069772633E-5, &
                                         0.00494362428,    &
                                         0.08847452739,    &
                                         0.43265155900,    &
                                         0.72023521561,    &
                                         0.43265155900,    &
                                         0.08847452739,    &
                                         0.004943624275,   &
                                         3.96069772633E-5 /)



contains

! ------------------------------------------------------------------
       subroutine getqext_BH (xx, crefin, qextalf, qscatalf, gscatalfg,SUCCESS)
       implicit none

       real, intent(in)     :: XX 
       real, intent(out)    :: qextalf, qscatalf, gscatalfg
       complex, intent(in)  :: CREFIN
       logical, intent(out) :: success
!local        
       real( 8 ), parameter  :: one_third = 1.0d0 / 3.0d0
       integer              :: NXX
       integer              :: nstop, modulus

       real :: QEXT, QSCA, QBACK, G_MIE, xx1
       
       real( 8 )    :: x
       complex( 8 ) :: refractive_index
       
       x = real( XX, 8 )
       refractive_index = dcmplx( real( CREFIN ), imag( CREFIN ) )
       
       modulus = int( abs( x * refractive_index ) )      
       nstop = int( x + 4.0d0 * x**one_third + 2.0d0 )
       
       nxx = max( modulus, nstop ) + 15
       
       xx1 = 1.0 / XX
       
!       CALL BHMIE (XX,CREFIN,QEXT,QSCA,QBACK,G_MIE, SUCCESS)
        CALL BHMIE_FLEXI (XX, NXX, NSTOP, CREFIN,QEXT,QSCA,QBACK,G_MIE, SUCCESS)

       qextalf   = QEXT * xx1
       qscatalf  = QSCA * xx1
       gscatalfg = qscatalf * G_MIE

       end subroutine getqext_bh

! ------------------------------------------------------------------
       SUBROUTINE BHMIE (X, REFREL, QQEXT, QQSCA, QBACK, GSCA, SUCCESS)

! FSB Changed the call vector to return only QEXT, QSCAT QBACK GSCA
!     and ignore NANG, S1 and S2 and all calculations for them

       implicit none 

! Arguments:
       real, intent(in)    :: X        ! X = pi*particle_diameter / Wavelength
       complex, intent(in) :: REFREL

!    REFREL = (complex refr. index of sphere)/(real index of medium)
!    in the current use the index of refraction of the the medium
!    i taken at 1.0 real.
!
!    Output

       real,    intent(out) :: QQEXT, QQSCA, QBACK, GSCA
       logical, intent(out) :: SUCCESS

!     QQEXT   Efficiency factor for extinction
!     QQSCA   Efficiency factor for scattering
!     QQBACK  Efficiency factor for back scatter
!     GSCA    asymmetry factor <cos>
!     SUCCESS flag for successful calculation
! REFERENCE: 
!  Bohren, Craig F. and Donald R. Huffman, Absorption and 
!    Scattering of Light by Small Particles, Wiley-Interscience
!    copyright 1983. Paperback Published 1998.
! FSB
!    This code was originally listed in Appendix A. pp 477-482.
!    As noted below, the original code was subsequently 
!    modified by Prof. Bruce T. Drain of Princetion University.
!    The code was further modified for a specific application
!    in a large three-dimensional code requiring as much 
!    computational efficiency as possible. 
!    Prof. Francis S. Binkowski of The University of North
!    Carolina at Chapel Hill. 

! Declare parameters:
! Note: important that MXNANG be consistent with dimension of S1 and S2
!       in calling routine!

       integer, parameter :: MXNANG=10, NMXX=600000   ! FSB new limits
       real*8, parameter  :: PII = 3.1415916536D0
       real*8, parameter  :: ONE = 1.0D0, TWO = 2.0D0

! Local variables:
       integer    :: NANG
       integer    :: N,NSTOP,NMX,NN
       real*8     :: QSCA, QEXT, DX1, DXX1      
       real*8     :: CHI,CHI0,CHI1,DX,EN,P,PSI,PSI0,PSI1,XSTOP,YMOD               
       real*8     :: TWO_N_M_ONE, TWO_N_P_ONE, EN1, FACTOR
       complex*16 :: AN,AN1,BN,BN1,DREFRL,XI,XI1,Y, Y1, DREFRL1
       complex*16 :: D(NMXX), FAC1, FAC2
       complex*16   :: XBACK

!***********************************************************************
! Subroutine BHMIE is the Bohren-Huffman Mie scattering subroutine
!    to calculate scattering and absorption by a homogenous isotropic
!    sphere.
! Given:
!    X = 2*pi*a/lambda
!    REFREL = (complex refr. index of sphere)/(real index of medium)
!    real refractive index of medium taken as 1.0 
! Returns:
!    QEXT  = efficiency factor for extinction
!    QSCA  = efficiency factor for scattering
!    QBACK = efficiency factor for backscatter
!            see Bohren & Huffman 1983 p. 122
!    GSCA = <cos> asymmetry for scattering
!
! Original program taken from Bohren and Huffman (1983), Appendix A
! Modified by Prof. Bruce T.Draine, Princeton Univ. Obs., 90/10/26
! in order to compute <cos(theta)>
! 91/05/07 (BTD): Modified to allow NANG=1
! 91/08/15 (BTD): Corrected error (failure to initialize P)
! 91/08/15 (BTD): Modified to enhance vectorizability.
! 91/08/15 (BTD): Modified to make NANG=2 if called with NANG=1
! 91/08/15 (BTD): Changed definition of QBACK.
! 92/01/08 (BTD): Converted to full double precision and double complex
!                 eliminated 2 unneed lines of code
!                 eliminated redundant variables (e.g. APSI,APSI0)
!                 renamed RN -> EN = double precision N
!                 Note that DOUBLE COMPLEX and DCMPLX are not part
!                 of f77 standard, so this version may not be fully
!                 portable.  In event that portable version is
!                 needed, use src/bhmie_f77.f
! 93/06/01 (BTD): Changed AMAX1 to generic function MAX
! FSB April 09,2012 This code was modified by: 
! Prof.  Francis S. Binkowski University of North Carolina at
! Chapel Hill, Institue for the Environment.
!
! The modifications were made to enhance computation speed 
! for use in a three-dimensional code. This was done by
! removing code that calculated angular scattering. The method
! of calculating QEXT, QBACK was also changed. 
 
!***********************************************************************
!*** Safety checks

       SUCCESS = .TRUE.
       NANG = 2 ! FSB only this value 
! IF(NANG.GT.MXNANG)STOP'***Error: NANG > MXNANG in bhmie'
!      IF (NANG .LT. 2) NANG = 2

       DX = REAL( X, 8 )
! FSB Define reciprocals so that divisions can be replaced by multiplications.      
       DX1  = ONE / DX
       DXX1 = DX1 * DX1
       DREFRL = DCMPLX( REFREL ) 
       DREFRL1 = ONE / DREFRL
       Y = DX * DREFRL
       Y1 = ONE / Y
       YMOD = ABS(Y)
 
!*** Series expansion terminated after NSTOP terms
!    Logarithmic derivatives calculated from NMX on down
       XSTOP = REAL( X + 4.0 * X**0.3333 + 2.0, 8)
       NMX  = INT( MAX(XSTOP,YMOD) ) + 15

! BTD experiment 91/1/15: add one more term to series and compare results
!      NMX=AMAX1(XSTOP,YMOD)+16
! test: compute 7001 wavelengths between .0001 and 1000 micron
! for a=1.0micron SiC grain.  When NMX increased by 1, only a single
! computed number changed (out of 4*7001) and it only changed by 1/8387
! conclusion: we are indeed retaining enough terms in series!
       NSTOP = INT( XSTOP )
       FACTOR = 1.0D0
 
       IF (NMX .GT. NMXX) THEN
          WRITE(6,*)'Error: NMX > NMXX=',NMXX,' for |m|x=',YMOD
          SUCCESS = .FALSE.
          RETURN
       END IF

! FSB all code relating to scattering angles is removed out for
!     reasons of efficiency when running in a three-dimensional 
!     code. We only need QQSCA, QQEXT, GSCA AND QBACK

 
!*** Logarithmic derivative D(J) calculated by downward recurrence
!    beginning with initial value (0.,0.) 
 
       D(NMX) = DCMPLX(0.0D0,0.0D0)
       NN = NMX - 1
       DO N = 1,NN
          EN  = REAL(NMX - N + 1, 8 )
! FSB In the following division by Y has been replaced by 
!     multiplication by Y1, the reciprocal of Y.          
          D(NMX-N) = ( EN * Y1 ) - (ONE / ( D(NMX-N+1) + EN * Y1)) 
       END DO
 
!*** Riccati-Bessel functions with real argument X
!    calculated by upward recurrence
 
       PSI0 =  COS(DX)
       PSI1 =  SIN(DX)
       CHI0 = -SIN(DX)
       CHI1 =  PSI0
       XI1  =  DCMPLX(PSI1,-CHI1)
       QSCA =  0.0D0
       GSCA =  0.0D0
       QEXT =  0.0D0
       P    = -ONE
       XBACK = (0.0d0,0.0d0)

! FSB Start main loop       
       DO N = 1,NSTOP
          EN        = REAL( N, 8)
          EN1       = ONE / EN
          TWO_N_M_ONE = TWO * EN - ONE
! for given N, PSI  = psi_n        CHI  = chi_n
!              PSI1 = psi_{n-1}    CHI1 = chi_{n-1}
!              PSI0 = psi_{n-2}    CHI0 = chi_{n-2}
! Calculate psi_n and chi_n
          PSI = TWO_N_M_ONE * PSI1 * DX1 - PSI0
          CHI = TWO_N_M_ONE * CHI1 * DX1 - CHI0
          XI  = DCMPLX(PSI,-CHI)
 
!*** Compute AN and BN:
! FSB Rearrange to get common terms
          FAC1 = D(N) * DREFRL1 + EN * DX1 
          AN   = (FAC1) * PSI - PSI1
          AN   = AN / ( (FAC1 )* XI - XI1 )
          FAC2 = ( DREFRL * D(N) + EN * DX1)
          BN   = ( FAC2) * PSI -PSI1
          BN   = BN / ((FAC2) * XI - XI1 )

! FSB calculate sum for QEXT as done by Wiscombe
!     get common factor
          TWO_N_P_ONE = (TWO * EN + ONE)
          QEXT = QEXT + (TWO_N_P_ONE) * (REAL(AN) + REAL(BN) ) 
          QSCA = QSCA + (TWO_N_P_ONE) * ( ABS(AN)**2+ ABS(BN)**2 )
          
! FSB calculate XBACK from B & H Page 122          
          FACTOR = -1.0d0 * FACTOR  ! calculate (-1.0 ** N)
          XBACK = XBACK + (TWO_N_P_ONE) * factor * (AN - BN)
          
! FSB calculate asymmetry factor   
           GSCA = GSCA + REAL( ((TWO_N_P_ONE)/(EN * (EN + ONE))) *     &
                 (REAL(AN)*REAL(BN)+IMAG(AN)*IMAG(BN)))

          IF (N .GT. 1)THEN
             GSCA = GSCA + REAL( (EN - EN1) *                         &
                    (REAL(AN1)*REAL(AN) + IMAG(AN1)*IMAG(AN) +  &
                     REAL(BN1)*REAL(BN) + IMAG(BN1)*IMAG(BN)))
          ENDIF

!*** Store previous values of AN and BN for use in computation of g=<cos(theta)>
          AN1 = AN
          BN1 = BN

! FSB set up for next iteration
          PSI0 = PSI1
          PSI1 = PSI
          CHI0 = CHI1
          CHI1 = CHI
          XI1  = DCMPLX(PSI1,-CHI1)

       END DO   ! main  loop on n
 
!*** Have summed sufficient terms.

!    Now compute QQSCA,QQEXT,QBACK,and GSCA
       GSCA  = REAL( TWO / QSCA )  * GSCA

! FSB in the following, divisions by DX * DX has been replaced by
!      multiplication by DXX1 the reciprocal of 1.0 / (DX *DX)           
       QQSCA = REAL( TWO * QSCA * DXX1 )
       QQEXT = REAL( TWO * QEXT * DXX1 ) 
       QBACK = REAL( REAL ( 0.5d0 * XBACK * CONJG(XBACK), 8 ) * DXX1 )  ! B&H Page 122

       END subroutine BHMIE

! ------------------------------------------------------------------
       subroutine aero_optical ( lamda_in, nmode, nr, ni, Vol,   &
                                 dgn, sig, bext, bscat, g_bar,   &
                                 modulus, success )
     
! *** calculate the extinction and scattering coefficients and
!     assymetry factors for each wavelength as a sum over the 
!     individual lognormal modes. Each mode may have a different 
!     set of refractive indices.

      IMPLICIT NONE
! *** input variables
      real, intent(in)    :: lamda_in               ! wavelengths  [micro-m]
      INTEGER, intent(in) :: nmode                  ! number of lognormal modes
      real, intent(in)    :: nr( nmode), ni(nmode)  ! real and imaginary 
                                                    ! refractive indices
      real, intent(in)    :: Vol(nmode)             ! modal aerosol volumes [m**3 /m**3]
      real, intent(in)    :: dgn(nmode)             ! geometric mean diameters 
                                                    ! for number distribution [ m]
      real, intent(in)    :: sig(nmode)             ! geometric standard deviation 

      real, intent(in), optional :: modulus(nmode)  ! modulus of refracive index                          
      
! *** output variables 
      real, intent(out)    :: bext    ! extinction coefficient [ 1 / m ]
      real, intent(out)    :: bscat   ! scattering coefficient [ 1 / m ]
      real, intent(out)    :: g_bar   ! assymetry factor for Mie and molecular scattering
      logical, intent(out) :: success ! flag for successful calculation
! *** internal variables
      INTEGER  :: j             ! loop index
!     real     :: xlnsig(nmode) ! natural log of geometric standard deviations      
      real     :: beta_Sc, bsc  !aerosol scattering coefficient 
 
      real     :: beta_Ex       ! aerosol extinction coefficients       
      real     :: G             ! modal aerosol assymetry factors
      real     :: sum_g
      real     :: LSIGX
      real     :: lamdam1       ! 1/ lamda
      real     :: alphav        ! Mie size parameter
      real     :: vfac
      real     :: modalph

      real, parameter :: pi = 3.14159265359

       Logical, Save :: Initialize = .True.
       
! *** coded 09/08/2004 by Dr. Francis S. Binkowski
! FSB Modified for RRTMG version December 2009.
! FSB modified 10/06/2004, 10/12/2004, 10/18/2005
! FSB 01/12/2006
!     Formerly Carolina Environmental Program
! FSB now the Institute for the Environment
!     University of North Carolina at Chapel Hill
!     email: frank_binkowski@unc.edu


! *** initialize variables
       lamdam1 = 1.0e6 / lamda_in   ! lamda now in [ m ]
       bext    = 0.0
       bscat   = 0.0
       sum_g   = 0.0
        
!      write(30,*) ' inside aero_optical', ' lamda = ', lamda
      
       DO j = 1, nmode
!    calculate the extinction and scattering coefficients
!    for each mode 
!         write(20,*) ' j = ', j
          LSIGX = log(sig(j))

!         write(30,*) 'j = ', j
!         write(30,*) 'VLX = ', Vol(j)
!         write(30,*) 'DGX = ', dgn(j)
!         write(30,*) 'SIGX = ', sig(j)
!         write(30,*) 'NRX =', nr(j)
!         write(30,*) 'NIX = ', ni(j)
!         write(30,*) 'LSIGX = ', LSIGX
       
!     calculate Mie size parameter for volume distribution
!     exp(3.0 * xlnsig*xlnsig)  converts dgn to dgv (volume diameter)
          alphav =  pi * dgn(j) * exp(3.0 * LSIGX * LSIGX) * lamdam1

          if (present(modulus)) then
             modalph = alphav * modulus(j)   
          end if

!         Write(30,*) ' alphav = ', alphav
       
!         write(20,*) j, alphav, modalph, modulus(j)
!         write(20,*) j, alphav, modalph, nr(j), ni(j)
      
 
          CALL ghintBH (nr(j), ni(j), alphav, LSIGX, beta_EX, beta_Sc, G, success)            

!         write(30,*) 'after Call to ghintBH ',' j = ', j 
!         write(30,*) ' beta_EX =', beta_EX
!         write(30,*) ' beta_SC = ', beta_Sc
!         write(30,*) ' G = ', G

! *** ghintBH returns the normalized values
!     Calculate the actual extinction and scattering coefficients 
!     by multplying by the modal volume and dividing by the wavelength
         
         
          vfac  =  Vol(j) * lamdam1 

!         write(20,*)' vfac = ', vfac
!         write(20,*)' G = ', G
!         write(20,*) ' beta_Ex = ', beta_Ex
!         write(20,*) ' beta_Sc = ', beta_Sc
        
! *** sum to get total extinction and scattering 
!     and contribution to the overal assymetry factor

          bext    = bext  + vfac * beta_Ex  ! [ 1 / m ]
          bsc     = vfac * beta_Sc
          bscat   = bscat + bsc          
          sum_g   = sum_g + bsc * G

       END DO  ! loop on modes  
       
! *** calculate combined assymetry factor for all modes  

       g_bar = sum_g / bscat ! changed to divide by bscat

!      write(30,*) ' inside aero_optical after loop '       
!      write(30,*) ' g_bar = ', g_bar
!      write(20,*) ' bext = ', bext
!      write(20,*) ' bscat = ', bscat
!      write(20,*) ' gbar = ', g_bar 
      
       END SUBROUTINE aero_optical

! ------------------------------------------------------------------
       subroutine ghintBH_1 (nr, ni, alfv, xlnsig, Qext_GH, Qscat_GH, g_gh, success) 

! FSB *********** This is the newest (05_30_2012) version of GhintBH
!      this version does the Mie method and calculates the optimum set of 
!      set of Gauss-Hermite abscissas and weights. 
! FSB Calls Penndorf codes for alfv .le.  0.3 

!      Dr. Francis S. Binkowski, The University of North Carolina
!                                at Chapel Hill
! FSB this code file now contains all of the necessary subroutines that 
!     are called to perform an integral of the Bohren and Huffman
!     Mie codes ( as updated by Prof. Bruce C. Drain of Princeton)
!       calculates the extinction and scattering coefficients 
!       normalized by wavelength and total particle volume
!       concentration for a log normal particle distribution 
!       with the logarithm of the geometric  standard deviation
!       given by xlnsig. The integral of the
!       asymmetry factor g is also calculated.
! FSB Change 12/20/2011 This code now has a choice of IGH based
!     upon alfv and nr. 
!  *** Does Gauss-Hermite quadrature of Qext / alfa & Qscat / alfa
!      and asymmetry factor <cos> over log normal distribution using 
!      symmetric  points.
 
       implicit none

       real, intent(in)     :: nr, ni     ! refractive indices
       real, intent(in)     :: alfv       ! Mie parameter for dgv
       real, intent(in)     :: xlnsig     ! log of geometric  standard deviation
       real, intent(out)    :: Qext_GH    ! normalized extinction efficiency
       real, intent(out)    :: Qscat_GH   ! normalized scattering efficiency
       real, intent(out)    :: g_GH       ! asymmetry factor <cos>
       logical, intent(out) :: success    ! flag for successful calculation
      
       real    :: bext_P, bscat_P, babs_P, g_PCS, xlnsg2  ! see below for definition
      
       real    :: aa1                ! see below for definition
       real    :: alfaip, alfaim     ! Mie parameters at abscissas
     
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e ! extinction  
       real    :: qalfip_s, qalfim_s ! scattering
       real    :: gsalfp, gsalfm     ! scattering times asymmetry factor
       integer :: IGH                ! index for GH quadrature      

! FSB define parameters 
       real, parameter :: pi = 3.14159265
       real, parameter :: sqrtpi = 1.772454 
       real, parameter :: sqrtpi1 = 1.0 / sqrtpi 
       real, parameter :: sqrt2 = 1.414214 
       real, parameter :: three_pi_two = 3.0 * pi / 2.0 
       real, parameter :: const = three_pi_two * sqrtpi1 
      
       integer :: i
       complex :: crefin                  ! complex index of refraction      
       real    :: sum_e,sum_s, xi,wxi,xf
       real    :: sum_sg

! Gauss-Hermite abscissas and weights
! *** the following weights and abscissas are from Abramowitz
!     Stegun, Table 25.10 page 924 
! FSB full precision from Table 25.10 

! FSB ten-point  - IGH = 5
       real, parameter :: ghxi_10(5) = (/ 0.342901327223705,     &
                                          1.036610829789514,     &
                                          1.756683649299882,     &
                                          2.532731674232790,     &
                                          3.436159118837738 /)

       real, parameter :: ghwi_10(5) = (/ 6.108626337353e-01,    &
                                          2.401386110823e-01,    &
                                          3.387439445548e-02,    &
                                          1.343645746781e-03,    &
                                          7.640432855233e-06 /)

! FSB six-point - IGH = 3
       real, parameter :: ghxi_6(3) = (/ 0.436077411927617,      &
                                         1.335849074013597,      &
                                         2.350604973674492 /)

       real, parameter :: ghwi_6(3) = (/ 7.246295952244e-01,     &
                                         1.570673203229e-01,     &
                                         4.530009905509e-03 /)

! FSB two-point - IGH = 1
       real, parameter :: ghxi_2(1) = (/ 0.707106781186548 /)

       real, parameter :: ghwi_2(1) = (/ 8.862269254528e-01 /)

       real    :: GHXI(5), GHWI(5) ! weight and abscissas
       integer :: NMAX             ! number of weights and abscissa

! FSB Check for valid range of Penndorf application.     
       if ( alfv .le. 0.3) then
          xlnsg2 = xlnsig*xlnsig
          call pennfsb (nr,ni,alfv,xlnsg2,bext_P,bscat_P,babs_P,g_PCS)
          Qext_GH  = bext_P
          Qscat_GH = bscat_p
          g_GH     = g_PCS * exp(4.0 * xlnsg2) ! match GH integral            
       else

! FSB We need to do a full Mie calculation now 
!     Choose IGH. These choices are designed to improve
!     the computational efficiency without sacrificing accuracy.

          IGH=3 ! default value; six_point is sufficient generally
! six point
          NMAX = 3

          if (nr .ge. 1.7) then 
! 10 point     
             IGH = 5 ! more points needed here
             NMAX = 5
          end if

          if ( alfv .gt. 20.0 .or. alfv .lt. 0.5 ) then
             IGH  = 1 ! in  this range fewer points are needed
             NMAX = 1
          end if

          if (IGH == 1) then
             GHXI(1)    = ghxi_2(1)
             GHWI(1)    = ghwi_2(1)
          else if (IGH == 3) then
             do i = 1, NMAX
                GHXI(i) = ghxi_6(i)
                GHWI(i) = ghwi_6(i)
             end do 
          else
             do i = 1,NMAX
                GHXI(i) = ghxi_10(i)
                GHWI(i) = ghwi_10(i)
             end do  
          end if ! set up number of abscissas and weights 
 
! FSB set  complex refractive index.      
          crefin= cmplx(nr,ni)      

! FSB now start the integration code
          aa1 = sqrt2 * xlnsig   ! This 1.0 / Sqrt( A ) in derivation of the integral
                                 ! where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! Then alpha = alfv * exp[ u / sqrt(A) ]
! For Gauss-Hermite Quadrature u = xi 
! Therefore, xf = exp( xi / sqrt(A) ),
!  or xf = exp( xi * aa1 ) 
          sum_e  = 0.0
          sum_s  = 0.0
          sum_sg = 0.0
! FSB do NMAX calls to the MIE codes
          do i = 1,NMAX
             xi      = GHXI(i)
             wxi     = GHWI(i)
             xf      = exp( xi * aa1 )
             alfaip  = alfv * xf
             alfaim  = alfv / xf ! division cheaper than another exp()
! *** call subroutine to fetch the effficiencies

             call getqext_BH (alfaip, crefin, qalfip_e, qalfip_s, gsalfp, success)
             call getqext_BH (alfaim, crefin, qalfim_e, qalfim_s, gsalfm, success)

             sum_e  = sum_e + wxi  * ( qalfip_e + qalfim_e ) 
             sum_s  = sum_s + wxi  * ( qalfip_s + qalfim_s ) 
             sum_sg = sum_sg + wxi * ( gsalfp + gsalfm ) 
          end do 

          g_GH     = sum_sg / sum_s ! this is <cos>
          Qext_GH  = const * sum_e  ! 
          Qscat_GH = const * sum_s  
       end if

       end subroutine ghintBH_1

! ------------------------------------------------------------------
       subroutine pennfsb (n, k, xx, lnsg2, bext, bscat, babs, g)

! FSB a new version of Penndorf's equations. This version does 
!     analytical integration for Qext, Qscat, Qabs to generate
!     bext, bscat, babs. Note that the expressions for Qext & Qscat
!     hve been divide through by xx.
!
!     Reference:
!     Caldas, M., V. Semiao, 2001, Radiative properties of small
!                     particles: and extension of the Penndorff Model. Journal 
!                     of the Optical Society of America A, Vol. 18, No. 4, 
!                     pp 831-838.  

!       Penndorf, R., 1962a,Scattering and extinction coefficients for small
!                     absorbing and nonabsorbing aerosols,
!                     J. Optical Society of America, 52, 896-904.

!       Penndorf, P., 1962b,Scattering and extinction coefficients for 
!                     small Spherical aerosols, J. Atmos. Sci., 19, p 193

! FSB Coded by Dr. Francis S. Binkowski on October 25, 2011 by combining
!     two previous versions to get a common code for the Penndorf and
!     and Caldas & Semiao approaches. The Penndorf Qext, Qscat are much
!     better than the versions from Caldas & Semiao despite claims to
!     the contrary. The values of the asymmetry factor from Caldas & Semiao 
!     are better than can be obtained from Penndorf. 

! FSB This version does the analytical integral ove a lognormal 
!     size distribution.

       implicit none 
!     input variables
       real, intent(in)  :: n, k     ! refractive index
       real, intent(in)  :: xx       ! pi * diameter / wavelength
       real, intent(in)  :: lnsg2    ! log(sigma_g)**2       
       real, intent(out) :: bext     ! extinction coefficient
       real, intent(out) :: bscat    ! scattering coefficient
       real, intent(out) :: babs     ! absorption coefficient
       real, intent(out) :: g        ! asmmetry factor

!     internal variables
       complex*16  :: m, m2,m4,m6,m21,m22 
       complex*16  :: P,Q,R,S,T,U,V,W
       complex*16  :: Qprime, Rprime,Sprime,Tprime
       complex*16  :: Uprime, Vprime, Wprime
       real*8      :: Qs, gQs, gpennCS
       real*8      :: P1,P2, Q1, Q2 , S2,V1, V2 ! see usage
       real*8      :: P1SQ, P2SQ  ! see usage
       real*8      :: y, y2, y3, y4, y6, y7,  y8, y9       
       real*8      :: x, x2, x3, x4, x6, x7,  x8, x9 
       real        :: mag, modalf
! FSB define useful numbers and fractions 
       real, parameter :: pi = 3.14159265358979324d0 
       real, parameter :: three_pi_two = 1.5d0 * pi

       real*8, parameter :: one = 1.0d0
       real*8, parameter :: two = 2.0d0
       real*8, parameter :: three = 3.0d0
       real*8, parameter :: four = 4.0d0
       real*8, parameter :: five = 5.0d0
       real*8, parameter :: six = 6.0d0
       real*8, parameter :: eight = 8.0d0
       real*8, parameter :: nine = 9.0d0
       real*8, parameter :: fifteen = 15.0d0
       real*8, parameter :: fortyfive = 45.0d0
!      real*8, parameter :: two5ths = two / five
       real*8, parameter :: twothrds = two / three
       real*8, parameter :: fourthirds = four / three
       real*8, parameter :: onefifteenth = one / fifteen
       real*8, parameter :: twofifteenths = two * onefifteenth
!      real*8, parameter :: fourninths = four / nine
       real*8, parameter :: eightthirds = two * fourthirds
       real*8, parameter :: one_big = one / 31500.0d0
       real*8, parameter :: two_fortyfive = two / fortyfive
       real*8, parameter :: four_225 = four / 225.0d0 
       real*8, parameter :: one_210 = one / 210.0d0
!      real*8, parameter :: one_half = one / two 
!      real*8, parameter :: four_two = two
       real*8, parameter :: nine_two = 4.5d0
!      real*8, parameter :: sixteen_two = eight
!      real*8, parameter :: thirtysix_two = 36.0 / two
!      real*8, parameter :: twentyfive_two = 25.0d0 / two
!      real*8, parameter :: sixtyfour_two = 64.0d0 / two
!      real*8, parameter :: fortynine_two = 49.0d0 / two
!      real*8, parameter :: eightyone_two = 81.0d0 / two
       real*8            :: A,B,C,D,E, AA,BB,CC

! FSB start code
       mag = sqrt( n * n + k * k )
       modalf = mag * xx
       y  = REAL( xx, 8 ) ! convert to real*8
! FSB get powers of y        
       y2 = y * y
       y3 = y2 * y
       y4 = y3 * y
       y6 = y3 * y3
       y7 = y3 * y4
       y8 = y4 * y4
       y9 = y6 * y3 

! FSB Calculate integrals ove the lognormal distribution
!     this is done term by term and the form is
!     xn = yn * exp( (n**2) * lnsig2 /2.0d0)

       x  = y 
       x2 = y2 * exp( two              * lnsg2)
       x3 = y3 * exp( nine_two         * lnsg2)
       x4 = y4 ! * exp( eight            * lnsg2)      
       x6 = y6 ! * exp( thirtysix_two    * lnsg2)
       x7 = y7 ! * exp( fortynine_two    * lnsg2)
       x8 = y8 ! * exp( fortynine_two    * lnsg2)
       x9 = y9 ! * exp( eightyone_two    * lnsg2)

        
! FSB explicitly calculate complex refrative index m        
       m = dcmplx(n,-k)
! FSB get powers and functions of m        
       m2 = m * m
       m4 = m2 * m2
       m6 = m2 * m4
       m21 = m2 - one
       m22 = m2 + two

! FSB calculate Penndorf's definitions from Table II of Penndorf (1962a)        
       P = m21 / m22
       Q = (m2 - two ) / m22
       S = m21 / ( two * m2 + three)
       V = m21
! FSB get real & imaginary parts following Penndorf's mptation        
       P1 = real(P)
       P2 = -aimag(P)
       P1SQ = P1 * P1
       P2SQ = P2 * P2

       Q1 = real(Q)
       Q2 = -aimag(Q)
       S2 = -aimag(S)
       V1 = real(V)
       v2 = -aimag(V)


! FSB Get bext from Penndorf (1962a) Equation (7) up to x4 
!     consistent with equation (8)
!     We have then divided through by x and integrated analytically
       bext = REAL( four * P2 + ( 2.4d0 * (P1 * Q2 + P2 * Q1 ) +  twothrds * S2          &
            + twofifteenths * V2 ) * x2 + ( eightthirds * ( P1SQ - P2SQ ) ) * x3, 4 )

! FSB get bscat from Penndorf Equation (9) up to x4 
!     we have divided through by x and integrated analytically
       bscat = REAL( eightthirds * ( P1SQ + P2SQ ) * x3 )
! FSB calculate babs
!      babs = bext - bscat

! FSB now get asymmetry factor from Caldas & Semiao (2001)      
!    
! *** The following additional variables from Caldas & Semiao (2001)
!     are defined in Equations 10a to 10h.

       R = (m6 + 20.0d0*m4 -200.0d0*m2 + 200.0d0) / m22**2
       T = m21 / ( ( 2.0d0 * M2 + 3.0d0) **2 )
       U = m21 / (3.0d0 * M2 + 4.0d0 )
       W = m21 * ( 2.0d0 * m2 - 5.0d0)

! *** further definitions from Caldas & Semiao (2001)      
       Qprime = Q
       Rprime = 18.0d0 * R
       Sprime = 5.0d0 * S / P
       Tprime = 375.0d0 * T / P
!      Uprime = 28.0d0 * U / P
       Vprime = V / P
       Wprime = 5.0d0 * W / P

! FSB calculate gQs and Qs from Caldas & Semiao (2001)
! *** calculate Qs equation 13
!      Qs = eightthirds * abs(P)**2                                        &
!           * (x4 + onefifteenth * real(Qprime) * x6                       &
!           + fourthirds * aimag(P) * x7                                   &
!           + one_big * ( 35.0d0 * abs(Qprime)**2                          &
!           + 20.0d0 * real(Rprime) + 35.0d0 * abs(Vprime)**2              &
!           + 21.0d0 * abs(Sprime)**2 ) * x8                               &
!           + two_fortyfive * aimag( Qprime * ( P - conjg(P) )) * x9 ) 

! *** calculate gQs equation 15
      
!      gQs = four_225 * abs(P)**2 * (                                      &
!              (5.0d0 * Real(Vprime) + 3.0d0 * real(Sprime) ) * x6         &
!             + one_210 * ( 35.0d0 * real(Vprime*conjg(Qprime) )           &
!             + 21.0d0 * real(Sprime * conjg(Qprime) )                     &
!             + 10.0d0 * real(Wprime)- 6.0d0 * real(Tprime) ) * x8         &
!             - twothrds * ( 5.0d0 * aimag(Vprime * conjg(P) )             &
!             + 3.0d0 * aimag(Sprime * conjg(P) ) ) * x9    )

! FSB recast into specific terms 
       A = 1.0D0 * x4
       B = onefifteenth * real(Qprime) * x6 
       C = fourthirds * aimag(P) * x7
       D = one_big * ( 35.0d0 * abs(Qprime)**2                             &
           + 20.0d0 * real(Rprime) + 35.0d0 * abs(Vprime)**2               &
           + 21.0d0 * abs(Sprime)**2 ) * x8     
       E = two_fortyfive * aimag( Qprime * ( P - conjg(P) )) * x9   
       
       Qs = eightthirds * abs(P)**2 *( A + B + C + D + E )
       
       AA = (5.0d0 * Real(Vprime) + 3.0d0 * real(Sprime) ) * x6 
       BB = one_210 * ( 35.0d0 * real(Vprime*conjg(Qprime) )               &
            + 21.0d0 * real(Sprime * conjg(Qprime) )                       &
            + 10.0d0 * real(Wprime)- 6.0d0 * real(Tprime) ) * x8         
       CC = twothrds * ( 5.0d0 * aimag(Vprime * conjg(P) )                 &
            + 3.0d0 * aimag(Sprime * conjg(P) ) ) * x9    

       gQs = four_225 * abs(P)**2 * ( AA + BB + CC )
      
! FSB calculate asymmetry factor and adjust with empirical term.      
       g = REAL(gQs / Qs)
!  FSB now multiply by three_pi_two  get output  values        
       bext  = three_pi_two * bext  
       bscat = three_pi_two * bscat 
! FSB calculate babs
       babs = bext - bscat
        
       end subroutine pennfsb
        
! ------------------------------------------------------------------
       subroutine aero_optical2( lamda_in, crefin, Vol, dgn, &
                                 sig, bext, bscat, gfac, success )

! FSB NOTE: this subroutine calculates for single mode     
     
! *** calculate the extinction and scattering coefficients and
!     assymetry factors for each wavelength as a sum over the 
!     individual lognormal modes. Each mode may have a different 
!     set of refractive indices.

      IMPLICIT NONE

! *** input variables
      real, intent(in)    :: lamda_in   ! wavelengths  [micro-m]
      complex, intent(in) :: crefin     ! Complex refractive index 
      real, intent(in)    :: Vol        ! modal aerosol volumes [m**3 /m**3]
      real, intent(in)    :: dgn        ! geometric mean diameters 
                                        ! for number distribution [ m]
      real, intent(in)    :: sig        ! geometric standard deviation 
      
! *** output variables 
      real, intent(out)    :: bext         ! extinction coefficient [ 1 / m ]
      real, intent(out)    :: bscat        ! scattering coefficient [ 1 / m ]
      real, intent(out)    :: gfac         ! assymetry factor for Mie and molecular scattering
      logical, intent(out) :: success      ! flag for successful calculation

      
      
! *** internal variables
!     real :: xlnsig(nmode) ! natural log of geometric standard deviations      
      real :: beta_Sc       ! aerosol scattering coefficient 
 
      real :: beta_Ex       ! aerosol extinction coefficients       
      real :: G             ! modal aerosol assymetry factors
      real :: sum_g
      real :: LSIGX
      real :: lamdam1       ! 1/ lamda
      real :: alphav        ! Mie size parameter
      real :: vfac
      real, parameter :: pi = 3.14159265359

       Logical, Save :: Initialize = .True.
      
       
! FSB coded 04/15/2012 by Dr. Francis S. Binkowski
!     modified from an earlier version
!     Center for Environmental Modeling for PolicyDevelopment
!     Institute for the Environment
!     University of North Carolina at Chapel Hill
!     email: frank_binkowski@unc.edu

! *** initialize variables
       lamdam1 = 1.0e6 / lamda_in ! lamda now in [ m ]
       bext  = 0.0
       bscat = 0.0
       sum_g = 0.0
!      write(20,*) ' j = ', j
       LSIGX = log(sig)
       
!     calculate Mie size parameter for volume distribution
!     exp(3.0 * xlnsig*xlnsig)  converts dgn to dgv (volume diameter)
       alphav =  pi * dgn * exp(3.0 * LSIGX * LSIGX) * lamdam1
       
!      write(20,*) j, alphav, modalph, modulus(j)
!      write(20,*) j, alphav, modalph, NRX, NIX

       If(Initialize .And. AERO_UTIL_LOG .GT. 0 )Then
          If( Use_Odd_Quadrature )then
              write(AERO_UTIL_LOG,99501)Quadrature_Points
          else
              write(AERO_UTIL_LOG,99504)
              Initialize = .False.
          End If
       End If

       If( Use_Odd_Quadrature )then
           CALL ghintBH (Initialize, crefin, alphav, LSIGX, beta_EX, beta_Sc, G, success)
       Else
           CALL ghintBH (crefin, alphav, LSIGX, beta_EX, beta_Sc, G, success)
       End If
       

! *** ghintBH returns the normalized values
!     Calculate the actual extinction and scattering coefficients 
!     by multplying by the modal volume and dividing by the wavelength
         
         
       vfac  =  Vol * lamdam1         
       bext    = vfac * beta_Ex  ! [ 1 / m ]
       bscat   = vfac * beta_Sc  ! [ 1 / m ]
       gfac    = G
99501  Format(I2,' Quadrature Points for Volume Averaged Aerosol Optics')
99504  Format('Even Number Quadrature Points for Volume Averaged Aerosol Optics')
       
       END SUBROUTINE aero_optical2

! ------------------------------------------------------------------
       subroutine aero_optical_CS ( lamda_in, refcor,refshell, VOLCOR,   &
                                    VOLSHELL, DGNCOR, DGNSHELL, SIG,     &
                                    bext, bscat, gfac, succesS )
     
! FSB NOTE: values for one mode are returend      
! *** calculate the extinction and scattering coefficients and
!     assymetry factors for each wavelength as a sum over the 
!     individual lognormal modes. Each mode may have a different 
!     set of refractive indices.

       IMPLICIT NONE
! *** input variables
       real,intent(in)    :: lamda_in   ! wavelengths  [micro-m]                      
       complex,intent(in) :: refcor     ! Complex refractive index -core
       complex,intent(in) :: refshell   ! Complex refractive index -shell
       real,intent(in)    ::  VOLCOR    ! volume of core
       real,intent(in)    ::  VOLSHELL  ! volume of shell
       real,intent(in)    ::  DGNCOR    ! geometric mean diameters  
                                        ! for number distribution [m]
       real,intent(in)    ::  DGNSHELL  ! geometric mean diameters  
                                        ! for number distribution [m]
       real,intent(in)    ::  SIG       ! geometric standard deviation 
      
! *** output variables 
       real,intent(out)     ::  bext      ! extinction coefficient [ 1 / m ]
       real,intent(out)     ::  bscat     ! scattering coefficient [ 1 / m ]
       real,intent(out)     ::  gfac      ! assymetry factor 
       logical, intent(OUT) :: success    ! flag for successful calculation
      
! *** internal variables
!      real    :: xlnsig(nmode)    ! natural log of geometric standard deviations      
       real    :: beta_Sc          ! aerosol scattering coefficient 
 
       real    :: beta_Ex          ! aerosol extinction coefficients       
       real    :: G                ! modal aerosol assymetry factors
       real    :: LSIGX
       real    :: XX, YY           ! Mie size parameter
       real    :: expfac
       real    :: lamdam1          ! 1/ lamda
       real    :: vfac
       
       Logical, Save :: Initialize = .True.

       real, parameter :: pi = 3.14159265359
       
! FSB coded 04/15/2012 by Dr. Francis S. Binkowski
!     modified from an earlier version
!     Center for Environmental Modeling for PolicyDevelopment
!     Institute for the Environment
!     University of North Carolina at Chapel Hill
!     email: frank_binkowski@unc.edu


! *** initialize variables
       lamdam1 = 1.0e6 / lamda_in ! lamda now in [ m ]
        
!      write(20,*) ' inside aero_optical', ' lamda = ', lamda
      
!    calculate the extinction and scattering coefficients
       LSIGX  = log(SIG)
       expfac = pi * exp(3.0 * LSIGX * LSIGX) * lamdam1
        
!     calculate Mie size parameter for volume distribution
!     exp(3.0 * xlnsig*xlnsig)  converts dgn to dgv (volume diameter)
       XX =  DGNCOR * expfac                                       
       YY =  DGNSHELL * expfac
       
       If(Initialize .And. AERO_UTIL_LOG .GT. 0 )Then
          If( Use_Odd_Quadrature )then
              write(AERO_UTIL_LOG,99500)Quadrature_Points
          else
              write(AERO_UTIL_LOG,99502)
              Initialize = .False.
          End If
       End If
       
       If( Use_Odd_Quadrature )then
           CALL ghintBH_CS(Initialize,refcor,refshell,XX,YY,LSIGX,beta_EX,beta_Sc,G, success)
       Else
           CALL ghintBH_CS(refcor,refshell,XX,YY,LSIGX,beta_EX,beta_Sc,G, success)
       End If            

! FSB ghintBH_CS returns the normalized values
!     Calculate the actual extinction and scattering coefficients 
!     by multplying by the modal volume and dividing by the wavelength.
!     For the coated-sphere (core-shell) calculation use the combined
!     volume         
         
       vfac   =  (VOLCOR + VOLSHELL) * lamdam1         
       bext   = vfac * beta_Ex  ! [ 1 / m ]
       bscat  = vfac * beta_Sc  ! [ 1 / m ]
       gfac   = G
99500  Format(I2,' Quadrature Points for Core-Shell Aerosol Optics')
99502  Format('Even Number Quadrature Points for Core-Shell Aerosol Optics')
       END SUBROUTINE aero_optical_CS

! ------------------------------------------------------------------
       subroutine ghintBH_2 (crefin,alfv,xlnsig,Qext_GH,Qscat_GH,g_gh, success) 

! *************** REVISED VERSION < NOTE
! FSB *********** This is the newest (04_14_2012) version of GhintBH
!      this version does the Mie method and calculates the optimum set of 
!      set of Gauss-Hermite abscissas and weights. 
!      Dr. Francis S. Binkowski, The University of North Carolina
!                                at Chapel Hill
! FSB this code file now contains all of the necessary subroutines that 
!     are called to perform an integral of the Bohren and Huffman
!     Mie codes ( as updated by Prof. Bruce C. Drain of Princeton)
!       calculates the extinction and scattering coefficients 
!       normalized by wavelength and total particle volume
!       concentration for a log normal particle distribution 
!       with the logarithm of the geometric  standard deviation
!       given by xlnsig. The integral of the
!       asymmetry factor g is also calculated.
! FSB Change 12/20/2011 This code now has a choice of IGH based
!     upon alfv and nr. 
! FBB Changes Simplified code. Eliminated Penndorf code
!  *** Does Gauss-Hermite quadrature of Qext / alfa & Qscat / alfa
!      and asymmetry factor <cos> over log normal distribution using 
!      symmetric  points.
!
       implicit none

       complex, intent(in) :: crefin     ! complex index of refraction
       real, intent(in)    :: alfv       ! Mie parameter for dgv
       real, intent(in)    :: xlnsig     ! log of geometric  standard deviation
       real, intent(out)   :: Qext_GH    ! normalized extinction efficiency
       real, intent(out)   :: Qscat_GH   ! normalized scattering efficiency
       real, intent(out)   :: g_GH       ! asymmetry factor <cos>
       logical, intent(out) :: success   ! flag for successful calculation
       
       real    :: nr                 ! real part of  refractive index      
       real    :: aa1                ! see below for definition
       real    :: alfaip, alfaim     ! Mie parameters at abscissas
     
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e ! extinction  
       real    :: qalfip_s, qalfim_s ! scattering
       real    :: gsalfp, gsalfm     ! scattering times asymmetry factor
       integer :: IGH                ! index for GH quadrature      

! FSB define parameters 
       real, parameter :: pi = 3.14159265
       real, parameter :: sqrtpi = 1.772454 
       real, parameter :: sqrtpi1 = 1.0 / sqrtpi 
       real, parameter :: sqrt2 = 1.414214 
       real, parameter :: three_pi_two = 3.0 * pi / 2.0 
       real, parameter :: const = three_pi_two * sqrtpi1 
       
       integer ::  i
       real    ::  sum_e,sum_s, xi,wxi,xf
       real    ::  sum_sg

! Gauss-Hermite abscissas and weights
! *** the following weights and abscissas are from Abramowitz
!     Stegun, Table 25.10 page 924
! FSB full precision from Table 25.10 

! FSB ten-point  - IGH = 5
       real, parameter :: ghxi_10(5) = (/ 0.342901327223705,     &
                                          1.036610829789514,     &
                                          1.756683649299882,     &
                                          2.532731674232790,     &
                                          3.436159118837738 /)

       real, parameter :: ghwi_10(5) = (/ 6.108626337353e-01,    &
                                          2.401386110823e-01,    &
                                          3.387439445548e-02,    &
                                          1.343645746781e-03,    &
                                          7.640432855233e-06 /)

! FSB six-point - IGH = 3
       real, parameter :: ghxi_6(3) = (/ 0.436077411927617,      &
                                         1.335849074013597,      &
                                         2.350604973674492 /)

       real, parameter :: ghwi_6(3) = (/ 7.246295952244e-01,     &
                                         1.570673203229e-01,     &
                                         4.530009905509e-03 /)

! FSB two-point - IGH = 1
       real, parameter :: ghxi_2(1) = (/ 0.707106781186548 /)

       real, parameter :: ghwi_2(1) = (/ 8.862269254528e-01 /)

       real    :: GHXI(5), GHWI(5) ! weight and abscissas
       integer :: NMAX             ! number of weights and abscissa


! start code
! FSB now choose IGH. These choices are designed to improve
!     the computational efficiency without sacrificing accuracy.


       nr = real(crefin)      

       IGH=3 ! default value; six_point is sufficient generally
! six point
       NMAX = 3

       if (nr .ge. 1.7) then 
! 10 point     
          IGH = 5 ! more points needed here
          NMAX = 5
       end if

       if( alfv .gt. 20.0 .or. alfv .lt. 0.5 ) then
          IGH  = 1 ! in  this range fewer points are needed
          NMAX = 1
       end if

       if (IGH == 1) then
! two point
          GHXI(1)    = ghxi_2(1)
          GHWI(1)    = ghwi_2(1)
       else if (IGH == 3) then
          do i = 1, NMAX
             GHXI(i) = ghxi_6(i)
             GHWI(i) = ghwi_6(i)
          end do 
       else
          do i = 1,NMAX
             GHXI(i) = ghxi_10(i)
             GHWI(i) = ghwi_10(i)
          end do  
       end if ! set up number of abscissas and weights 
      
! FSB now start the integration code
       aa1 = sqrt2 * xlnsig    ! This 1.0 / Sqrt( A ) in derivation of the integral
                               ! where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! Then alpha = alfv * exp[ u / sqrt(A) ]
! For Gauss-Hermite Quadrature u = xi 
! Therefore, xf = exp( xi / sqrt(A) ),
!  or xf = exp( xi * aa1 ) 

       sum_e  = 0.0
       sum_s  = 0.0
       sum_sg = 0.0
! FSB do NMAX calls to the MIE codes      
       do i = 1,NMAX
          xi      = GHXI(i)
          wxi     = GHWI(i)
          xf      = exp( xi * aa1 )
          alfaip  = alfv * xf
          alfaim  = alfv / xf ! division cheaper than another exp()
! *** call subroutine to fetch the effficiencies

          call getqext_BH(alfaip,crefin,qalfip_e,qalfip_s, gsalfp, success)
          call getqext_BH(alfaim,crefin,qalfim_e,qalfim_s, gsalfm, success)

          sum_e  = sum_e + wxi  * ( qalfip_e + qalfim_e ) 
          sum_s  = sum_s + wxi  * ( qalfip_s + qalfim_s ) 
          sum_sg = sum_sg + wxi * ( gsalfp + gsalfm ) 

       end do 

       g_GH     = sum_sg / sum_s ! this is <cos>
       Qext_GH  = const * sum_e  ! 
       Qscat_GH = const * sum_s  

       end subroutine ghintBH_2

! ------------------------------------------------------------------
       subroutine ghintBH_CS_even (RCORE, RSHELL , XX, YY, xlnsig,  &                  
                              Qext_GH,Qscat_GH, g_gh, success)

! FSB code for coated-sphere (core-shell) version

! *************** REVISED VERSION < NOTE
! FSB *********** This is the newest (04_14_2012) version of ghintBH_CS
!      for the coated-sphere (core-shell) method using BHCOAT
!      this version does the Mie method and calculates the optimum set of 
!      set of Gauss-Hermite abscissas and weights. 
!      Dr. Francis S. Binkowski, The University of North Carolina
!                                at Chapel Hill
       
! FSB this code file now contains all of the necessary subroutines that 
!     are called to perform an integral of the Bohren and Huffman
!     Mie codes ( as updated by Prof. Bruce C. Drain of Princeton)
!       calculates the extinction and scattering coefficients 
!       normalized by wavelength and total particle volume
!       concentration for a log normal particle distribution 
!       with the logarithm of the geometric  standard deviation
!       given by xlnsig. The integral of the
!       asymmetry factor g is also calculated.
! FSB Change 12/20/2011 This code now has a choice of IGH based
!     upon alfv and nr. 
! FBB Changes Simplified code. Eliminated Penndorf code
!  *** Does Gauss-Hermite quadrature of Qext / alfa & Qscat / alfa
!      and asymmetry factor <cos> over log normal distribution using 
!      symmetric  points.
!
       implicit none
       complex, intent(in) :: RCORE      ! refractive index of core
       complex, intent(in) :: RSHELL     ! refractive index of shell
       real, intent(in)    :: XX         ! Mie parameter for core
       real, intent(in)    :: YY         ! Mie parameter for shell
       real, intent(in)    :: xlnsig     ! log of geometric  standard deviation
       real, intent(out)   :: Qext_GH    ! normalized extinction efficiency
       real, intent(out)   :: Qscat_GH   ! normalized scattering efficiency
       real, intent(out)   :: g_GH       ! asymmetry factor <cos>
       logical, intent(out) :: success   ! flag for successful calculation

       real    :: nr                     ! real part of  refractive index      
       real    :: aa1                    ! see below for definition
       real    :: XXP, XXM               ! Mie parameters at abscissas - CORE
       real    :: YYP, YYM               ! Mie parameters at abscissas - SHELL
     
! FSB define parameters 
      real, parameter :: pi = 3.14159265
      real, parameter :: sqrtpi = 1.772454 
      real, parameter :: sqrtpi1 = 1.0 / sqrtpi 
      real, parameter :: sqrt2 = 1.414214 
      real, parameter :: three_pi_two = 3.0 * pi / 2.0 
      real, parameter ::  const = three_pi_two * sqrtpi1 
 
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e     ! extinction  
       real    :: qalfip_s, qalfim_s     ! scattering
       real    :: gsalfp, gsalfm         ! scattering times asymmetry factor
       integer :: IGH                    ! index for GH quadrature      
       integer ::  i
       real    ::  sum_e,sum_s, xi,wxi,xf, temp
       real    ::  sum_sg

! Gauss-Hermite abscissas and weights
! *** the following weights and abscissas are from Abramowitz
!     Stegun, Table 25.10 page 924
! FSB full precision from Table 25.10 

! FSB ten-point  - IGH = 5
       real, parameter :: ghxi_10(5) = (/ 0.342901327223705,     &
                                          1.036610829789514,     &
                                          1.756683649299882,     &
                                          2.532731674232790,     &
                                          3.436159118837738 /)

       real, parameter :: ghwi_10(5) = (/ 6.108626337353e-01,    &
                                          2.401386110823e-01,    &
                                          3.387439445548e-02,    &
                                          1.343645746781e-03,    &
                                          7.640432855233e-06 /)

! FSB six-point - IGH = 3
       real, parameter :: ghxi_6(3) = (/ 0.436077411927617,      &
                                         1.335849074013597,      &
                                         2.350604973674492 /)

       real, parameter :: ghwi_6(3) = (/ 7.246295952244e-01,     &
                                         1.570673203229e-01,     &
                                         4.530009905509e-03 /)

! FSB two-point - IGH = 1
       real, parameter :: ghxi_2(1) = (/ 0.707106781186548 /)

       real, parameter :: ghwi_2(1) = (/ 8.862269254528e-01 /)

       real GHXI(5), GHWI(5) ! weight and abscissas
       integer NMAX ! number of weights and abscissa

! start code
! FSB now choose IGH. These choices are designed to improve
!     the computational efficiency without sacrificing accuracy.


       nr = real(RSHELL)      

       IGH=3 ! default value; six_point is sufficient generally
! six point
       NMAX = 3

       if (nr .ge. 1.7) then 
! 10 point     
          IGH = 5 ! more points needed here
          NMAX = 5
       end if

       if ( XX .gt. 20.0 .or. XX .lt. 0.5 ) then
          IGH  = 1 ! in  this range fewer points are needed
          NMAX = 1
       end if

       if (IGH == 1) then
! two point
          GHXI(1)    = ghxi_2(1)
          GHWI(1)    = ghwi_2(1)
       else if (IGH == 3) then
          do i = 1, NMAX
             GHXI(i) = ghxi_6(i)
             GHWI(i) = ghwi_6(i)
          end do 
       else
          do i = 1,NMAX
             GHXI(i) = ghxi_10(i)
             GHWI(i) = ghwi_10(i)
          end do  
       end if ! set up number of abscissas and weights 

! FSB now start the integration code
       aa1 = sqrt2 * xlnsig   ! This 1.0 / Sqrt( A ) in derivation of the integral
                              ! where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! Then alpha = alfv * exp[ u / sqrt(A) ]
! For Gauss-Hermite Quadrature u = xi 
! Therefore, xf = exp( xi / sqrt(A) ),
!  or xf = exp( xi * aa1 ) 
       sum_e  = 0.0
       sum_s  = 0.0
       sum_sg = 0.0
! FSB do NMAX calls to the MIE codes      
       do i = 1,NMAX
          xi      = GHXI(i)
          wxi     = GHWI(i)
          xf      = exp( xi * aa1 )
          temp    = 1.0 / xf
          XXP     = XX * xf
          XXM     = XX * temp ! division cheaper than another exp()
          YYP     = YY * xf
          YYM     = YY * temp ! division cheaper than another exp()
! *** call subroutine to fetch the effficiencies

          call getqsgBHCS(XXP,YYP,RCORE,RSHELL,qalfip_e,qalfip_s,gsalfp, success)
          call getqsgBHCS(XXM,YYM,RCORE,RSHELL,qalfim_e,qalfim_s,gsalfm, success)
          
          sum_e  = sum_e  + wxi  * ( qalfip_e + qalfim_e ) 
          sum_s  = sum_s  + wxi  * ( qalfip_s + qalfim_s ) 
          sum_sg = sum_sg + wxi  * ( gsalfp   + gsalfm   ) 
       end do 

       g_GH     = sum_sg / sum_s ! this is <cos>
       Qext_GH  = const * sum_e  ! 
       Qscat_GH = const * sum_s  

       end subroutine ghintBH_CS_even
      
! ------------------------------------------------------------------
       subroutine getqsgBHCS (XX,YY,RRFRL1,RRFRL2,qxtalf,qscalf,qsgalf, success)
       implicit none

       real, intent(in)    :: XX, YY
       real, intent(out)   :: qxtalf, qscalf, qsgalf
       complex, intent(in) :: RRFRL1,RRFRL2            ! refractive indices Core , Shell 
       logical, intent(out) :: success                 ! flag for successful calculation

       real    :: QEXT, QSCA, QBACK, G_MIE
       real    :: xx1
       character (len = 20) :: mystr1, mystr2, mystr3, mystr4

       xx1    = 1.0 / YY

!      if (     (xx *  real(RRFRL1) >= 30.0)   &
!          .or. (xx * aimag(RRFRL1) >= 30.0)   &
!          .or. (yy * aimag(RRFRL2) >= 30.0)) then
!         print *, ' ==d== bhcoat error'
!      end if

       call BHCOAT (XX,YY,RRFRL1,RRFRL2,QEXT,QSCA,QBACK,G_MIE, SUCCESS)

!      write (mystr1, *) QEXT
!      write (mystr2, *) QSCA
!      write (mystr3, *) QBACK
!      write (mystr4, *) G_MIE

!      if ((trim(mystr1) == ' NaN') .or.  &
!          (trim(mystr2) == ' NaN') .or.  &
!          (trim(mystr3) == ' NaN') .or.  &
!          (trim(mystr4) == ' NaN')) then
!          call BHCOAT (XX,YY,RRFRL1,RRFRL2,QEXT,QSCA,QBACK,G_MIE)
!      end if

       qxtalf = QEXT * xx1
       qscalf = QSCA * xx1
       qsgalf = qscalf * G_MIE 

       END subroutine getqsgBHCS


! ------------------------------------------------------------------
      SUBROUTINE BHCOAT (XX, YY, RRFRL1, RRFRL2, QQEXT, QQSCA, QBACK, GGSCA, SUCCESS)
      
      use complex_number_module

      implicit none ! added by FSB

! Arguments:
       real, intent(in)    :: XX,YY             ! Defined below
       complex, intent(in) :: RRFRL1,RRFRL2     ! Defined below
       real, intent(out)   :: QQEXT,QQSCA,QBACK ! Defined below
       real, intent(out)   :: GGSCA             ! asymmetry factor <cos> added by FSB
       logical,intent(out) :: success

! Local variables:
     
       real*8, parameter     :: DEL = 1.0D-08  
       real*8, parameter     :: ONE = 1.0D0, TWO = 2.0D0 
!      complex*16, save :: II
!      data II/(0.D0,1.D0)/
       type(complex_number) :: II

       integer :: IFLAG,N,NSTOP

       character (len = 400) :: mystr

!         -----------------------------------------------------------
!              del is the inner sphere convergence criterion
!         -----------------------------------------------------------
     
       real*8 :: CHI0Y,CHI1Y,CHIY,PSI0Y,PSI1Y,PSIY,QEXT,RN,QSCA,X,Y,YSTOP,GSCA
       real*8 :: TWO_N_M_ONE, TWO_N_P_ONE
       real*8 :: RY, RYY, RNRY, RN1, factor
       
!      complex*16 :: AMESS1,AMESS2,AMESS3,AMESS4,AN,ANCAP,AN1, BN,BNCAP,BN1, BRACK,   &
       type(complex_number) :: AMESS1,AMESS2,AMESS3,AMESS4,AN,ANCAP,AN1, BN,BNCAP,BN1, BRACK,   &
                     CHI0X2,CHI0Y2,CHI1X2,CHI1Y2,CHIX2,CHIPX2,CHIPY2,CHIY2,CRACK,     &
                     D0X1,D0X2,D0Y2,D1X1,D1X2,D1Y2,DNBAR,GNBAR,                       &
                     REFREL,RFREL1,RFREL2, XBACK,XI0Y,XI1Y,XIY,                       &
                     X1,X2,Y2,RCX1, RCX2,RCY2, FAC1, FAC2

!***********************************************************************
! NOTES from Prof. Bruce T. Draine, Princeton University
! Subroutine BHCOAT calculates Q_ext, Q_sca, Q_back for coated sphere.
! All bessel functions computed by upward recurrence.
! Input:
!        XX = 2*PI*RCORE*REFMED/WAVEL
!        YY = 2*PI*RMANT*REFMED/WAVEL
!        RFREL1 = REFCOR/REFMED
!        RFREL2 = REFMAN/REFMED 
! where  REFCOR = complex refr.index of core)
!        REFMAN = complex refr.index of mantle)
!        REFMED = real refr.index of medium)
!        RCORE = radius of core
!        RMANT = radius of mantle
!        WAVEL = wavelength of light in ambient medium
!
! Routine BHCOAT is taken from Bohren & Huffman (1983)
! Obtained from C.L.Joseph
!
! History:
! 92/11/24 (BTD) Explicit declaration of all variables
! April 30,2012 (FSB) added additional code to optimize
!  run time by finding common terms and replacing multiple
!  divisions by multiplication by a reciprocal. 
! April 09, 2012  code transferred from BTD's BMHMIE to
! calculate the asymmetry factor by  Prof. Francis S. Binkowski of 
! The University of North Carolina at Chapel Hill.
! April 30,2012 (FSB) added additional code to optimize
!  run time by finding common terms and replacing multiple
!  divisions by multiplication by a reciprocal. 
! July 16, 2010  more optimization by Dr. David Wong (DW) at US EPA
 
! REFERENCE: 
!  Bohren, Craig F. and Donald R. Huffman, Absorption and 
!    Scattering of Light by Small Particles, Wiley-Interscience
!    copyright 1983. Paperback Published 1998.
!    This code was originally listed in Appendix B. pp 483-489.
!    As noted above , the original code was subsequently 
!    modified by Prof. Bruce T. Draine of Princeton University.
! 
! FSB The background for this code is discussed in Borhen & Huffman (1983)
! on pages 181-183 ( Equations 8.2 ) and on pages 483-484. 
!***********************************************************************
!
! Start Code 

       SUCCESS = .TRUE.      

       II = c_set(0.0D0, 1.0D0)

! this technique will make the second 4 byte in the 8 byte variable be 0
! rather than arbitrary digits to increase accuracy
       write (mystr, *) xx, yy, real(RRFRL1), aimag(RRFRL1), real(RRFRL2), aimag(RRFRL2)
       read  (mystr, *) x,  y,  RFREL1, RFREL2

!      X      = XX
!      Y      = YY
       RY     = ONE / Y
       RYY    = RY * RY
!      RFREL1%real_part = real(RRFRL1)
!      RFREL1%imag_part = aimag(RRFRL1)
!      RFREL2%real_part = real(RRFRL2)
!      RFREL2%imag_part = aimag(RRFRL2)
       x1     = c_mul(x, rfrel1)
       x2     = c_mul(x, rfrel2)
       y2     = c_mul(y, rfrel2)
       RCX1   = c_div(ONE, X1)
       RCX2   = c_div(ONE, X2)
       RCY2   = c_div(ONE, Y2)
       refrel = c_div(rfrel2, rfrel1)
       ystop  = y + 4.0 * y**0.3333 + 2.0
       nstop  = INT( ystop )

!         -----------------------------------------------------------
!              series terminated after nstop terms
!         -----------------------------------------------------------

!   initialize variables 
       d0x1   = c_div(c_cos(x1), c_sin(x1))
       d0x2   = c_div(c_cos(x2), c_sin(x2))
       d0y2   = c_div(c_cos(y2), c_sin(y2))

       psi0y  = cos(y)
       psi1y  = sin(y)
       chi0y  = -sin(y)
       chi1y  = cos(y)

       xi0y   = c_sub(psi0y, c_mul(chi0y, II))
       xi1y   = c_sub(psi1y, c_mul(chi1y, II))

       chi0y2 = c_mul(-1.0d0, c_SIN(y2))
       chi1y2 = c_COS(y2)
       chi0x2 = c_mul(-1.0d0, c_SIN(x2))
       chi1x2 = c_COS(x2)
       qsca   = 0.0d0
       qext   = 0.0d0
       GSCA   = 0.0d0
       xback  = c_set(0.0d0, 0.0d0)
       iflag  = 0
       factor = 1.0d0

!      print *, ' ==d== N ', nstop

! FSB Start main loop      
       DO n = 1, nstop
          rn = REAL( n, 8 )
          RN1 = ONE / RN
          TWO_N_M_ONE = TWO * RN - ONE
          TWO_N_P_ONE = TWO * RN + ONE
          psiy = (TWO_N_M_ONE)*psi1y*RY - psi0y
          chiy = (TWO_N_M_ONE)*chi1y*RY - chi0y
          xiy  = c_sub(psiy, c_mul(chiy, II))
          d1y2 = c_sub(c_div(ONE, c_sub(c_mul(rn, RCY2), d0y2)), c_mul(rn, RCY2))

          IF (iflag .eq. 0) THEN
! *** Calculate inner sphere ancap, bncap
!      and brack and crack
             d1x1   = c_sub(c_div(ONE, c_sub(c_mul(rn, RCX1), d0x1)), c_mul(rn, RCX1))
             d1x2   = c_sub(c_div(ONE, c_sub(c_mul(rn, RCX2), d0x2)), c_mul(rn, RCX2))

             chix2  = c_sub(c_mul(c_mul(TWO*rn - ONE, chi1x2), RCX2), chi0x2)
             chiy2  = c_sub(c_mul(c_mul(TWO*rn - ONE, chi1y2), RCY2), chi0y2)

             chipx2 = c_sub(chi1x2, c_mul(c_mul(rn, chix2), RCX2))
             chipy2 = c_sub(chi1y2, c_mul(c_mul(rn, chiy2), RCY2))

!            ANCAP  = (REFREL*D1X1 - D1X2) /                              & 
!                     ( (REFREL*D1X1*CHIX2 - CHIPX2) * (CHIX2*D1X2 - CHIPX2) )

             ANCAP = c_sub(c_mul(c_mul(REFREL, D1X1), CHIX2), CHIPX2)
             ANCAP = c_mul(ANCAP, c_sub(c_mul(CHIX2, D1X2), CHIPX2))
             ANCAP = c_div(c_sub(c_mul(REFREL, D1X1), D1X2), ANCAP)

             brack  = c_mul(ancap, c_sub(c_mul(chiy2, d1y2), chipy2))

             bncap  = c_sub(c_mul(refrel, d1x2), d1x1)
             bncap  = c_div(bncap, c_sub(c_mul(refrel, chipx2), c_mul(d1x1, chix2)))
             bncap  = c_div(bncap, c_sub(c_mul(chix2, d1x2), chipx2))

             crack  = c_mul(bncap, c_sub(c_mul(chiy2, d1y2), chipy2))
! *** calculate convergence test expressions
!     for inner sphere.
! *** see pages 483-485 of Bohren & Huffman for
!     definitions. 
             amess1 = c_mul(brack, chipy2)
             amess2 = c_mul(brack, chiy2)
             amess3 = c_mul(crack, chipy2)
             amess4 = c_mul(crack, chiy2)

! Now test for convergence for inner sphere
!  All four criteria must be satisfied. See page 484 of B & H
             IF (c_ABS(amess1) .LE. del*c_ABS(d1y2)  .AND.                          &
                (c_ABS(amess2) .LE. del)             .AND.                          &
                (c_ABS(amess3) .LE. del*c_ABS(d1y2)) .AND.                          &
                (c_ABS(amess4) .LE. del)                ) THEN
!               convergence for inner sphere        
                brack = c_set(0.0D0,0.0D0)
                crack = c_set(0.0D0,0.0D0)
                iflag = 1
!         ELSE
! no convergence yet
!            iflag = 0
             END IF 
          END IF ! test on iflag .eq. 0

! *** note usage of brack and crack See equations on
!     Page 485  and discussion on pages 486 -487 of B & H      
          dnbar = c_sub(d1y2, c_mul(brack, chipy2))
          dnbar = c_div(dnbar, c_sub(ONE, c_mul(brack, chiy2)))
          gnbar = c_sub(d1y2, c_mul(crack, chipy2))
          gnbar = c_div(gnbar, c_sub(ONE, c_mul(crack, chiy2)))
!*** Store previous values of an and bn for use 
!    in computation of g=<cos(theta)>
          IF (N .GT. 1) THEN
             AN1 = an
             BN1 = bn
          END IF    
! *** update an and bn  
          RNRY = rn * RY 
          FAC1 = c_add(c_div(dnbar, rfrel2), RNRY)

          an = c_sub(c_mul(psiy, FAC1), psi1y)
          an = c_div(an, c_sub(c_mul(FAC1, xiy), xi1y))
          FAC2 = c_add(c_mul(rfrel2, gnbar), RNRY)
          bn = c_sub(c_mul(psiy, FAC2), psi1y)
          bn = c_div(bn, c_sub(c_mul(FAC2, xiy), xi1y))
      
! *** Calculate sums for qsca, qext, xback      
          qsca  = qsca + (TWO_N_P_ONE) * (c_ABS(an)**2 + c_ABS(bn)**2)
      
          qext  = qext + TWO_N_P_ONE * (an%real_part + bn%real_part)
      
! DW        XBACK = XBACK +  (TWO_N_P_ONE) * (-1.)**N * (AN-BN)
          FACTOR = FACTOR * (-1.0D0)
          XBACK = c_add(XBACK, c_mul(TWO_N_P_ONE * FACTOR, c_sub(AN, BN)))

! FSB calculate the sum for the asymmetry factor 

          GSCA = GSCA + ((TWO_N_P_ONE)/(RN* (RN + ONE)))*                     &
                 (an%real_part*bn%real_part + an%imag_part*bn%imag_part)
 
          IF (n .GT. 1) THEN
        
! DW         GSCA = GSCA + ((RN - ONE) * (RN + ONE) * RN1) *             &
             GSCA = GSCA + (RN - RN1) *                                  &
                   (AN1%real_part*AN%real_part + AN1%imag_part*AN%imag_part +            &
                    BN1%real_part*BN%real_part + BN1%imag_part*BN%imag_part)
     
          END IF
! continue update for next interation        
          psi0y  = psi1y
          psi1y  = psiy
          chi0y  = chi1y
          chi1y  = chiy
          xi1y   = c_sub(psi1y, c_mul(chi1y, II))
          chi0x2 = chi1x2
          chi1x2 = chix2
          chi0y2 = chi1y2
          chi1y2 = chiy2
          d0x1   = d1x1
          d0x2   = d1x2
          d0y2   = d1y2
       END DO  ! end of main loop 
  
!*** Have summed sufficient terms.
!    Now compute QQSCA,QQEXT,QBACK,and GSCA
       GGSCA = REAL( TWO * GSCA / qsca )
       QQSCA = REAL( TWO * qsca * RYY )
       QQEXT = REAL( TWO * qext * RYY )
!      QBACK = 0.5 * REAL ( ( xback * conjg(xback) ) * RYY )

       QBACK = 0.5 * real((xback%real_part**2 + xback%imag_part**2) * RYY)
!      QBACK = real((xback%real_part**2 + xback%imag_part**2) * RYY)

!       write (6, '(a19, 20e18.10)') ' ==d== bhcoat z ', GGSCA, GSCA, qsca
!       write (6, '(a19, 20e18.10)') ' ==d== bhcoat z ', QQSCA, qsca, RYY
!       write (6, '(a19, 20e18.10)') ' ==d== bhcoat z ', QQEXT, qext, RYY
!       write (6, '(a19, 20e18.10)') ' ==d== bhcoat z ', QBACK, xback, RYY

       end subroutine BHCOAT

       subroutine ghintBH_Odd (INIT, crefin,alfv,xlnsig,Qext_GH,Qscat_GH,g_gh, success ) 

! *************** REVISED VERSION < NOTE
! FSB *********** This is the newest (04_14_2012) version of GhintBH
!      this version does the Mie method and calculates the optimum set of 
!      set of Gauss-Hermite abscissas and weights. 
!      Dr. Francis S. Binkowski, The University of North Carolina
!                                at Chapel Hill
! FSB this code file now contains all of the necessary subroutines that 
!     are called to perform an integral of the Bohren and Huffman
!     Mie codes ( as updated by Prof. Bruce C. Drain of Princeton)
!       calculates the extinction and scattering coefficients 
!       normalized by wavelength and total particle volume
!       concentration for a log normal particle distribution 
!       with the logarithm of the geometric  standard deviation
!       given by xlnsig. The integral of the
!       asymmetry factor g is also calculated.
! FSB Change 12/20/2011 This code now has a choice of IGH based
!     upon alfv and nr. 
! FBB Changes Simplified code. Eliminated Penndorf code
!  *** Does Gauss-Hermite quadrature of Qext / alfa & Qscat / alfa
!      and asymmetry factor <cos> over log normal distribution using 
!      symmetric  points.
!
       implicit none

       logical, intent(INOUT)        :: INIT       ! initialize number of qudraure points
       complex, intent(in)           :: crefin     ! complex index of refraction
       real, intent(in)              :: alfv       ! Mie parameter for dgv
       real, intent(in)              :: xlnsig     ! log of geometric  standard deviation
       real, intent(out)             :: Qext_GH    ! normalized extinction efficiency
       real, intent(out)             :: Qscat_GH   ! normalized scattering efficiency
       real, intent(out)             :: g_GH       ! asymmetry factor <cos>
       logical, intent(out)          :: success    ! flag for successful calculation
       
       real    :: nr                 ! real part of  refractive index      
       real    :: aa1                ! see below for definition
       real    :: alfaip, alfaim     ! Mie parameters at abscissas
     
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e ! extinction  
       real    :: qalfip_s, qalfim_s ! scattering
       real    :: gsalfp, gsalfm     ! scattering times asymmetry factor

! FSB define parameters 
       real, parameter :: pi = 3.14159265
       real, parameter :: sqrtpi = 1.772454 
       real, parameter :: sqrtpi1 = 1.0 / sqrtpi 
       real, parameter :: sqrt2 = 1.414214 
       real, parameter :: three_pi_two = 3.0 * pi / 2.0 
       real, parameter :: const = three_pi_two * sqrtpi1 
       
       integer ::  i
       real    ::  sum_e,sum_s, xi,wxi,xf
       real    ::  sum_sg

       real,    allocatable,  save  :: GHXI(:), GHWI(:) ! weight and abscissas
       integer, save  :: IGH                            ! number of weights and abscissa
       integer, save  :: NMAX                           ! optimumized number of weights and abscissa


! start code
! FSB now choose IGH. These choices are designed to improve
!     the computational efficiency without sacrificing accuracy.

     If( INIT )Then

          Select Case( Quadrature_Points )
            Case( 1,3,9 )
              IGH = Quadrature_Points
            Case Default
              IGH = 3
          End Select

          NMAX = Max( Int( IGH / 2 ), 0)

          If( Allocated( GHXI ) .Or. Allocated( GHWI ) )Then
              Success = .False.
              Return             
          End If
          
          Allocate( GHXI( NMAX + 1 ), GHWI( NMAX + 1 ) )
 
          Select Case ( IGH ) 
            Case ( 1 )
              GHXI(1)  = ghxi_1(1)
              GHWI(1)  = ghwi_1(1)
            Case ( 3 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_3(i)
                GHWI(i) = ghwi_3(i)
              end do 
            Case ( 9 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_9(i)
                GHWI(i) = ghwi_9(i)
              end do 
          end select 
          
          If( AERO_UTIL_LOG .GT. 0 )Then
              write(AERO_UTIL_LOG,*)'BHMIE: IGH,(NMAX + 1) = ',IGH,(NMAX + 1)
              do i = 1, NMAX + 1
                write(AERO_UTIL_LOG,*)'BHMIE: i, GHXI(i), GHWI(i) = ',i, GHXI(i), GHWI(i)
              end do
          End If
          
          INIT = .False.
       Else
          If( .Not. Allocated( GHXI ) .Or. .Not. Allocated( GHWI ) )Then
              Success = .False.
              Return             
          End If                
       End If ! set up number of abscissas and weights 
 
       nr = real(crefin)      

      
! FSB now start the integration code
       aa1 = sqrt2 * xlnsig    ! This 1.0 / Sqrt( A ) in derivation of the integral
                               ! where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! Then alpha = alfv * exp[ u / sqrt(A) ]
! For Gauss-Hermite Quadrature u = xi 
! Therefore, xf = exp( xi / sqrt(A) ),
!  or xf = exp( xi * aa1 ) 

!start integration at zero point
       xi      = 0.0
       wxi     = GHWI(NMAX+1)
       xf      = 1.0
       alfaip  = alfv
! fetch the effficiencies at zero point

       call getqext_BH(alfaip,crefin,qalfip_e,qalfip_s, gsalfp, success)

       sum_e  = wxi * qalfip_e
       sum_s  = wxi * qalfip_s
       sum_sg = wxi * gsalfp

! FSB do NMAX calls to the MIE codes      
       do i = 1, NMAX
          xi      = GHXI(i)
          wxi     = GHWI(i)
          xf      = exp( xi * aa1 )
          alfaip  = alfv * xf
          alfaim  = alfv / xf ! division cheaper than another exp()
! *** call subroutine to fetch the effficiencies

          call getqext_BH(alfaip,crefin,qalfip_e,qalfip_s, gsalfp, success)
          call getqext_BH(alfaim,crefin,qalfim_e,qalfim_s, gsalfm, success)

          sum_e  = sum_e + wxi  * ( qalfip_e + qalfim_e ) 
          sum_s  = sum_s + wxi  * ( qalfip_s + qalfim_s ) 
          sum_sg = sum_sg + wxi * ( gsalfp + gsalfm ) 

       end do
       

       g_GH     = sum_sg / sum_s ! this is <cos>
       Qext_GH  = const * sum_e  ! 
       Qscat_GH = const * sum_s  

       end subroutine ghintBH_Odd
! ------------------------------------------------------------------
       subroutine ghintBH_CS_Odd (INIT, RCORE, RSHELL , XX, YY, xlnsig,  &                  
                                  Qext_GH,Qscat_GH, g_gh, success)

! FSB code for coated-sphere (core-shell) version

! *************** REVISED VERSION < NOTE
! FSB *********** This is the newest (04_14_2012) version of ghintBH_CS
!      for the coated-sphere (core-shell) method using BHCOAT
!      this version does the Mie method and calculates the optimum set of 
!      set of Gauss-Hermite abscissas and weights. 
!      Dr. Francis S. Binkowski, The University of North Carolina
!                                at Chapel Hill
       
! FSB this code file now contains all of the necessary subroutines that 
!     are called to perform an integral of the Bohren and Huffman
!     Mie codes ( as updated by Prof. Bruce C. Drain of Princeton)
!       calculates the extinction and scattering coefficients 
!       normalized by wavelength and total particle volume
!       concentration for a log normal particle distribution 
!       with the logarithm of the geometric  standard deviation
!       given by xlnsig. The integral of the
!       asymmetry factor g is also calculated.
! FSB Change 12/20/2011 This code now has a choice of IGH based
!     upon alfv and nr. 
! FBB Changes Simplified code. Eliminated Penndorf code
!  *** Does Gauss-Hermite quadrature of Qext / alfa & Qscat / alfa
!      and asymmetry factor <cos> over log normal distribution using 
!      symmetric  points.
!
       implicit none

       logical, intent(inout) :: INIT       ! initialize number of qudraure points
       complex, intent(in)    :: RCORE      ! refractive index of core
       complex, intent(in)    :: RSHELL     ! refractive index of shell
       real, intent(in)       :: XX         ! Mie parameter for core
       real, intent(in)       :: YY         ! Mie parameter for shell
       real, intent(in)       :: xlnsig     ! log of geometric  standard deviation
       real, intent(out)      :: Qext_GH    ! normalized extinction efficiency
       real, intent(out)      :: Qscat_GH   ! normalized scattering efficiency
       real, intent(out)      :: g_GH       ! asymmetry factor <cos>
       logical, intent(out)   :: success   ! flag for successful calculation

       real    :: nr                     ! real part of  refractive index      
       real    :: aa1                    ! see below for definition
       real    :: XXP, XXM               ! Mie parameters at abscissas - CORE
       real    :: YYP, YYM               ! Mie parameters at abscissas - SHELL
     
! FSB define parameters 
      real, parameter :: pi = 3.14159265
      real, parameter :: sqrtpi = 1.772454 
      real, parameter :: sqrtpi1 = 1.0 / sqrtpi 
      real, parameter :: sqrt2 = 1.414214 
      real, parameter :: three_pi_two = 3.0 * pi / 2.0 
      real, parameter ::  const = three_pi_two * sqrtpi1 
 
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e     ! extinction  
       real    :: qalfip_s, qalfim_s     ! scattering
       real    :: gsalfp, gsalfm         ! scattering times asymmetry factor
       integer ::  i
       real    ::  sum_e,sum_s, xi,wxi,xf, temp
       real    ::  sum_sg


       real,    allocatable,  save  :: GHXI(:), GHWI(:) ! weight and abscissas
       integer,               save  :: IGH              ! number of weights and abscissa
       integer,               save  :: NMAX             ! optimized number of weights and abscissa

! start code
! FSB now choose IGH. These choices are designed to improve
!     the computational efficiency without sacrificing accuracy.

     If( INIT )Then

          Select Case( Quadrature_Points )
            Case( 1,3,9 )
              IGH = Quadrature_Points
            Case Default
              IGH = 3
          End Select
                    
          If( Allocated( GHXI ) .Or. Allocated( GHWI ) )Then
              Success = .False.
              Return             
          End If

          NMAX = Max( Int( IGH / 2 ), 0)
          
          Allocate( GHXI( NMAX + 1 ), GHWI( NMAX + 1 ) )

          Select Case ( IGH ) 
            Case ( 1 )
              GHXI(1)  = ghxi_1(1)
              GHWI(1)  = ghwi_1(1)
            Case ( 3 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_3(i)
                GHWI(i) = ghwi_3(i)
              end do 
            Case ( 9 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_9(i)
                GHWI(i) = ghwi_9(i)
              end do  
          end select 

          If( AERO_UTIL_LOG .GT. 0 )Then
              write(AERO_UTIL_LOG,*)'BHCoat: IGH,(NMAX + 1) = ',IGH,(NMAX + 1)
              do i = 1, NMAX + 1
                write(AERO_UTIL_LOG,*)'BHCoat: i, GHXI(i), GHWI(i) = ',i, GHXI(i), GHWI(i)
              end do
          End If
          
          INIT = .False.
          
       Else
          If( .Not. Allocated( GHXI ) .Or. .Not. Allocated( GHWI ) )Then
              Success = .False.
              Return             
          End If      
       End If ! set up number of abscissas and weights 

       nr = real(RSHELL)      

! FSB now start the integration code
       aa1 = sqrt2 * xlnsig   ! This 1.0 / Sqrt( A ) in derivation of the integral
                              ! where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! Then alpha = alfv * exp[ u / sqrt(A) ]
! For Gauss-Hermite Quadrature u = xi 
! Therefore, xf = exp( xi / sqrt(A) ),
!  or xf = exp( xi * aa1 ) 

!start integration at zero point

          xi      = 0.0
          wxi     = GHWI(NMAX+1)
          xf      = 1.0
          XXP     = XX
          YYP     = YY

! fetch the effficiencies at zero point

          call getqsgBHCS(XXP,YYP,RCORE,RSHELL,qalfip_e,qalfip_s,gsalfp, success)
          
          sum_e  = wxi  * qalfip_e
          sum_s  = wxi  * qalfip_s
          sum_sg = wxi  * gsalfp   

! FSB do NMAX calls to the MIE codes      
       do i = 1, NMAX
          xi      = GHXI(i)
          wxi     = GHWI(i)
          xf      = exp( xi * aa1 )
          temp    = 1.0 / xf
          XXP     = XX * xf
          XXM     = XX * temp ! division cheaper than another exp()
          YYP     = YY * xf
          YYM     = YY * temp ! division cheaper than another exp()
! *** call subroutine to fetch the effficiencies

          call getqsgBHCS(XXP,YYP,RCORE,RSHELL,qalfip_e,qalfip_s,gsalfp, success)
          call getqsgBHCS(XXM,YYM,RCORE,RSHELL,qalfim_e,qalfim_s,gsalfm, success)
          
          sum_e  = sum_e  + wxi  * ( qalfip_e + qalfim_e ) 
          sum_s  = sum_s  + wxi  * ( qalfip_s + qalfim_s ) 
          sum_sg = sum_sg + wxi  * ( gsalfp   + gsalfm   ) 
       end do 

       g_GH     = sum_sg / sum_s ! this is <cos>
       Qext_GH  = const * sum_e  ! 
       Qscat_GH = const * sum_s  


       end subroutine ghintBH_CS_Odd        
    

! ------------------------------------------------------------------
       SUBROUTINE BHMIE_FLEXI (X, NMX, NSTOP, REFREL, QQEXT, QQSCA, QBACK, GSCA, SUCCESS)

! FSB Changed the call vector to return only QEXT, QSCAT QBACK GSCA
!     and ignore NANG, S1 and S2 and all calculations for them

       implicit none 

! Arguments:
       real,    intent(in) :: X        ! X = pi*particle_diameter / Wavelength
       integer, intent(in) :: NMX      ! maximum number of terms in Mie series 
       integer, intent(in) :: NSTOP    ! minumum number of terms in Mie series 
       complex, intent(in) :: REFREL   ! refractive index

!    REFREL = (complex refr. index of sphere)/(real index of medium)
!    in the current use the index of refraction of the the medium
!    i taken at 1.0 real.
!
!    Output

       real,    intent(out) :: QQEXT, QQSCA, QBACK, GSCA
       logical, intent(out) :: SUCCESS

!     QQEXT   Efficiency factor for extinction
!     QQSCA   Efficiency factor for scattering
!     QQBACK  Efficiency factor for back scatter
!     GSCA    asymmetry factor <cos>
!     SUCCESS flag for successful calculation
! REFERENCE: 
!  Bohren, Craig F. and Donald R. Huffman, Absorption and 
!    Scattering of Light by Small Particles, Wiley-Interscience
!    copyright 1983. Paperback Published 1998.
! FSB
!    This code was originally listed in Appendix A. pp 477-482.
!    As noted below, the original code was subsequently 
!    modified by Prof. Bruce T. Drain of Princetion University.
!    The code was further modified for a specific application
!    in a large three-dimensional code requiring as much 
!    computational efficiency as possible. 
!    Prof. Francis S. Binkowski of The University of North
!    Carolina at Chapel Hill. 

! Declare parameters:
! Note: important that MXNANG be consistent with dimension of S1 and S2
!       in calling routine!

       integer, parameter    :: MXNANG=10, NMXX=150000   ! FSB new limits
       integer, parameter    :: NANG  = 2
       real*8, parameter     :: PII = 3.1415916536D0
       real*8, parameter     :: ONE = 1.0D0, TWO = 2.0D0
       complex*16, parameter :: COMPLEX_DZERO = (0.0D0,0.0D0)
       complex,    parameter :: COMPLEX_ZERO  = (0.0,0.0)

! Local variables:
       integer    :: N, NN
       real*8     :: QSCA, QEXT, DX1, DXX1      
       real*8     :: CHI,CHI0,CHI1,DX,EN,P,PSI,PSI0,PSI1,XSTOP,YMOD               
       real*8     :: TWO_N_M_ONE, TWO_N_P_ONE, EN1, FACTOR
       complex*16 :: AN,AN1,BN,BN1,DREFRL,XI,XI1,Y, Y1, DREFRL1
       complex*16 :: D(NMX)
       complex*16 :: FAC1, FAC2
       complex*16 :: XBACK

!***********************************************************************
! Subroutine BHMIE is the Bohren-Huffman Mie scattering subroutine
!    to calculate scattering and absorption by a homogenous isotropic
!    sphere.
! Given:
!    X = 2*pi*a/lambda
!    REFREL = (complex refr. index of sphere)/(real index of medium)
!    real refractive index of medium taken as 1.0 
! Returns:
!    QEXT  = efficiency factor for extinction
!    QSCA  = efficiency factor for scattering
!    QBACK = efficiency factor for backscatter
!            see Bohren & Huffman 1983 p. 122
!    GSCA = <cos> asymmetry for scattering
!
! Original program taken from Bohren and Huffman (1983), Appendix A
! Modified by Prof. Bruce T.Draine, Princeton Univ. Obs., 90/10/26
! in order to compute <cos(theta)>
! 91/05/07 (BTD): Modified to allow NANG=1
! 91/08/15 (BTD): Corrected error (failure to initialize P)
! 91/08/15 (BTD): Modified to enhance vectorizability.
! 91/08/15 (BTD): Modified to make NANG=2 if called with NANG=1
! 91/08/15 (BTD): Changed definition of QBACK.
! 92/01/08 (BTD): Converted to full double precision and double complex
!                 eliminated 2 unneed lines of code
!                 eliminated redundant variables (e.g. APSI,APSI0)
!                 renamed RN -> EN = double precision N
!                 Note that DOUBLE COMPLEX and DCMPLX are not part
!                 of f77 standard, so this version may not be fully
!                 portable.  In event that portable version is
!                 needed, use src/bhmie_f77.f
! 93/06/01 (BTD): Changed AMAX1 to generic function MAX
! FSB April 09,2012 This code was modified by: 
! Prof.  Francis S. Binkowski University of North Carolina at
! Chapel Hill, Institue for the Environment.
!
! The modifications were made to enhance computation speed 
! for use in a three-dimensional code. This was done by
! removing code that calculated angular scattering. The method
! of calculating QEXT, QBACK was also changed. 
 
!***********************************************************************
!*** Safety checks

       SUCCESS = .TRUE.
!       NANG = 2 ! FSB only this value 
! IF(NANG.GT.MXNANG)STOP'***Error: NANG > MXNANG in bhmie'
!      IF (NANG .LT. 2) NANG = 2

       DX = REAL( X, 8 )
! FSB Define reciprocals so that divisions can be replaced by multiplications.      
       DX1  = ONE / DX
       DXX1 = DX1 * DX1
       DREFRL = DCMPLX( REAL( REFREL ), IMAG( REFREL ) )
       DREFRL1 = ONE / DREFRL
       Y = DX * DREFRL
       Y1 = ONE / Y
!       YMOD = ABS(Y)
 
!*** Series expansion terminated after NSTOP terms
!    Logarithmic derivatives calculated from NMX on down
!       XSTOP = X + 4.0 * X**0.3333 + 2.0
!       NMX  = MAX(XSTOP,YMOD) + 15

! BTD experiment 91/1/15: add one more term to series and compare results
!      NMX=AMAX1(XSTOP,YMOD)+16
! test: compute 7001 wavelengths between .0001 and 1000 micron
! for a=1.0micron SiC grain.  When NMX increased by 1, only a single
! computed number changed (out of 4*7001) and it only changed by 1/8387
! conclusion: we are indeed retaining enough terms in series!

       FACTOR = 1.0D0
 
!       IF (NMX .GT. NMXX) THEN
!          WRITE(6,*)'Error: NMX > NMXX=',NMXX,' for |m|x=',YMOD
!          SUCCESS = .FALSE.
!          RETURN
!       END IF

! FSB all code relating to scattering angles is removed out for
!     reasons of efficiency when running in a three-dimensional 
!     code. We only need QQSCA, QQEXT, GSCA AND QBACK

 
!*** Logarithmic derivative D(J) calculated by downward recurrence
!    beginning with initial value (0.,0.) 
 
       D(NMX) = COMPLEX_DZERO
       NN = NMX - 1
       DO N = 1,NN
          EN  = REAL( NMX - N + 1, 8 )
! FSB In the following division by Y has been replaced by 
!     multiplication by Y1, the reciprocal of Y.          
          D(NMX-N) = ( EN * Y1 ) - (ONE / ( D(NMX-N+1) + EN * Y1)) 
       END DO
 
!*** Riccati-Bessel functions with real argument X
!    calculated by upward recurrence
 
       PSI0 =  COS(DX)
       PSI1 =  SIN(DX)
       CHI0 = -SIN(DX)
       CHI1 =  PSI0
       XI1  =  DCMPLX(PSI1,-CHI1)
       QSCA =  0.0D0
       GSCA =  0.0D0
       QEXT =  0.0D0
       P    = -ONE
       XBACK = COMPLEX_DZERO

! FSB Start main loop       
       DO N = 1,NSTOP
          EN        = REAL( N, 8 )
          EN1       = ONE / EN
          TWO_N_M_ONE = TWO * EN - ONE
! for given N, PSI  = psi_n        CHI  = chi_n
!              PSI1 = psi_{n-1}    CHI1 = chi_{n-1}
!              PSI0 = psi_{n-2}    CHI0 = chi_{n-2}
! Calculate psi_n and chi_n
          PSI = TWO_N_M_ONE * PSI1 * DX1 - PSI0
          CHI = TWO_N_M_ONE * CHI1 * DX1 - CHI0
          XI  = DCMPLX(PSI,-CHI)
 
!*** Compute AN and BN:
! FSB Rearrange to get common terms
          FAC1 = D(N) * DREFRL1 + EN * DX1 
          AN   = (FAC1) * PSI - PSI1
          AN   = AN / ( (FAC1 )* XI - XI1 )
          FAC2 = ( DREFRL * D(N) + EN * DX1)
          BN   = ( FAC2) * PSI -PSI1
          BN   = BN / ((FAC2) * XI - XI1 )

! FSB calculate sum for QEXT as done by Wiscombe
!     get common factor
          TWO_N_P_ONE = (TWO * EN + ONE)
          QEXT = QEXT + (TWO_N_P_ONE) * (REAL(AN) + REAL(BN) ) 
          QSCA = QSCA + (TWO_N_P_ONE) * ( ABS(AN)**2 + ABS(BN)**2 )
          
! FSB calculate XBACK from B & H Page 122          
          FACTOR = -1.0d0 * FACTOR  ! calculate (-1.0 ** N)
          XBACK = XBACK + (TWO_N_P_ONE) * factor * (AN - BN)
          
! FSB calculate asymmetry factor   
       
          GSCA = GSCA + REAL((TWO_N_P_ONE)/(EN * (EN + ONE)) *     &
                 (REAL(AN)*REAL(BN)+IMAG(AN)*IMAG(BN)))

          IF (N .GT. 1)THEN
             GSCA = GSCA + REAL((EN - EN1) *                         &
                    (REAL(AN1)*REAL(AN) + IMAG(AN1)*IMAG(AN) +  &
                     REAL(BN1)*REAL(BN) + IMAG(BN1)*IMAG(BN)))
          ENDIF

!*** Store previous values of AN and BN for use in computation of g=<cos(theta)>
          AN1 = AN
          BN1 = BN

! FSB set up for next iteration
          PSI0 = PSI1
          PSI1 = PSI
          CHI0 = CHI1
          CHI1 = CHI
          XI1  = DCMPLX(PSI1,-CHI1)

       END DO   ! main  loop on n
 
!*** Have summed sufficient terms.

!    Now compute QQSCA,QQEXT,QBACK,and GSCA
       GSCA  = REAL( TWO / QSCA ) * GSCA

! FSB in the following, divisions by DX * DX has been replaced by
!      multiplication by DXX1 the reciprocal of 1.0 / (DX *DX)           
       QQSCA = REAL( TWO * QSCA * DXX1 )
       QQEXT = REAL( TWO * QEXT * DXX1 )
       QBACK = REAL( REAL( 0.5D0 * XBACK * CONJG(XBACK), 8 ) * DXX1 ) ! B&H Page 122

       END subroutine BHMIE_FLEXI


END MODULE cmaq_rrtmg_aero_optical_util_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_INIT( CGRID, SDATE, STIME, TSTEP )
 
C-----------------------------------------------------------------------
 
C Function: Create the Process Analysis ouput files and initialize
C           Process Analysis arrays           
 
C Preconditions: None
 
C Key Subroutines/Functions Called: SUBST_PA_INDEX, SUBST_IRR_INDEX,
C                                   PA_MKHDR, SUBST_4D_DATA_COPY
 
C  Revision History:
C  Prototype created by Jerry Gipson, July, 1996
C  allow env var for file names Jeff, Dec, 1996
C  Changed CGOUT dimension parameter from NSPCSD to NSPCS -- Jerry Gipson, May, 1997.
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified June 1997 by Jerry Gipson to change CGOUT to CGRID       
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified Jun, 1998 by Jerry Gipson to add PA domain error check
C  Modified 1/19/99 by David Wong at LM:
C                      -- add four include files because of new PA_CMN.EXT
C                      -- modify PA_INDEX function call parameter list
C                      -- add DATA_COPY function call to redistribute PA grid
C  Modified 2/26/99 by David Wong at LM:
C                      -- remove SUBST_AE_SPC, SUBST_NR_SPC, SUBST_TR_SPC,
C                         three .EXT files
C                      -- call SUBST_IRR_INDEX to determine row, column, and
C                         level loop indexes which are associated with IRR
C                         calculations
C                      -- renamed DATA_COPY function name
C                      -- use ifdef statement to distinguish parallel
C                         implementation of IRR calculation which does not 
C                         shift to the origin
C  Modified 4/12/00 by Jerry Gipson to correct units for aerosol IPRs writen to IO/API file
C  Modified 1 Jul 2000 by Jeff Young to allow for file updating - added PA_MKHDR
C  Modified 22 Nov 00 by J.Young: Dave Wong`s f90 stenex SUBGRID_INDEX and DATA_COPY
C  6 Oct 01 J.Young: dyn alloc - generic CGRID declaration; Use PAGRD_DEFN,
C                                which uses HGRD_DEFN; new pario
C  Modified 10 Oct 01 by David Wong
C                      -- let other processors open PA output files after
C                         processor has created them.
C                      -- used a new formula to compute number of IPR and IRR 
C                         output files
C  31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                                 domain specifications in one module (GRID_CONF)
C  16 Jan 06 J.Young: move PAGRD_INIT to par_init
C   1 Apr 09 J.Young: remove cruft
C   8 Jul 10 J.Young: restructure
C  23 Jul 10 D.Wong:  move first OPEN3 try inside IF ( MYPE .EQ. 0 ) clause
C  16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C  11 May 11 D.Wong: incorporated twoway model implementation
C  16 Sep 16 J.Young: update for inline procan
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE PAGRD_DEFN            ! PA horiz domain specs
      USE UTILIO_DEFN
#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE, SE_DATA_COPY_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE, NOOP_DATA_COPY_MODULE)
#endif
#endif
      USE PA_DEFN               ! Process Anaylsis control and data variables

      IMPLICIT NONE 

C..Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters

C..Arguments:
      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: SDATE      !  starting date, format YYYYDDD
      INTEGER, INTENT( IN ) :: STIME      !  starting time, format HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP( 3 ) ! time step vector (HHMMSS)
                             ! TSTEP(1) = local output step
                             ! TSTEP(2) = sciproc sync. step (chem)
                             ! TSTEP(3) = twoway model time step w.r.t. wrf time
                             !            step and wrf/cmaq call frequency

C..Parameters:

C..External Functions: None

C..Local Variables:
      CHARACTER(  16 ) :: ENV_DFLT  ! Environment variable default value
      CHARACTER(  80 ) :: ENV_DESC  ! Environment variab;e description
      CHARACTER(  16 ) :: OUTFNAME  ! Assigned IPR or IRR output file name
      CHARACTER(  16 ) :: PNAME = 'PA_INIT' ! Routine Name
      CHARACTER( 128 ) :: XMSG = ' '
      CHARACTER( 256 ) :: RET_VAL   ! Returned value of environment variable

      LOGICAL LSTOP     ! Flag to stop because a PA file not assigned
 
      INTEGER C         ! Loop index for columns
      INTEGER R         ! Loop index for rows
      INTEGER L         ! Loop index for layers
      INTEGER PC        ! Index for PA output column
      INTEGER PL        ! Index for PA output level
      INTEGER PR        ! Index for PA output row
      INTEGER ICG       ! Index for species in cgout array
      INTEGER NIRR      ! Loop index for IRR outputs
      INTEGER NFL       ! Loop index for no. of files
      INTEGER NOUT      ! Loop index for process monitoring outputs
      INTEGER NUMFLS    ! Number of PA or IRR output files needed
      INTEGER STATUS    ! Status Code

C-----------------------------------------------------------------------

      LSTOP = .FALSE.         

#ifndef mpas
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Open the Integrated Process Rates output file(s) if needed
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      IF ( LIPR ) THEN

C..compute the number of files needed

         NUMFLS = ( NIPRVAR - 1 ) / MXVARS3 + 1

C..open each one 
         DO NFL = 1, NUMFLS

            IF ( NFL .EQ. 1 ) THEN
               OUTFNAME = CTM_IPR_1
            ELSE IF ( NFL .EQ. 2 ) THEN
               OUTFNAME = CTM_IPR_2
            ELSE IF ( NFL .EQ. 3 ) THEN
               OUTFNAME = CTM_IPR_3
            ELSE IF ( NFL .GT. 3 ) THEN
               XMSG = 'Maximum number of IPR output files exceeded'
               CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )
            END IF

            ENV_DESC = 'IPR Output file ' // OUTFNAME 
            ENV_DFLT = ' '       
            XMSG = 'IPR output file ' // TRIM( OUTFNAME ) // ' not assigned'
            CALL ENVSTR( OUTFNAME, ENV_DESC, ENV_DFLT, RET_VAL, STATUS)
            IF ( STATUS .NE. 0 ) CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )

            IF ( MYPE .EQ. 0 ) THEN

C..try to open existing file for update
               IF ( .NOT. OPEN3( OUTFNAME, FSRDWR3, PNAME ) ) THEN

                  XMSG = 'Could not open ' // TRIM( OUTFNAME )
     &                 // ' file for update - try to open new'
                  CALL M3MESG( XMSG )

                  CALL PA_MKHDR( 'IPR', NFL, OUTFNAME, SDATE, STIME, TSTEP )

                  IF ( OPEN3( OUTFNAME, FSNEW3, PNAME ) ) THEN   ! open new
                     XMSG = 'Opened Integrated Reaction Rate Output File: '
     &                    // OUTFNAME
                     CALL M3MESG( XMSG )
                  ELSE
                     XMSG = 'Could not open Integrated Process Rate Output File: ' 
     &                   // OUTFNAME
                     CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )
                  END IF

               END IF

            END IF

            CALL SUBST_BARRIER

         END DO   ! NUMFLS

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Initialize arrays
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         DELC = 0.0

      END IF   ! LIPR

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Open the Integrated Reaction Rates output file(s) if needed
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      IF ( LIRR ) THEN

C..compute the number of files needed

         NUMFLS = ( NIRRVAR - 1 ) / MXVARS3 + 1

C..open each one
         DO NFL = 1, NUMFLS

            IF ( NFL .EQ. 1 ) THEN
               OUTFNAME = CTM_IRR_1
            ELSE IF ( NFL .EQ. 2 ) THEN
               OUTFNAME = CTM_IRR_2
            ELSE IF ( NFL .EQ. 3 ) THEN
               OUTFNAME = CTM_IRR_3
            ELSE IF ( NFL .GT. 3 ) THEN
               XMSG = 'Maximum number of IRR output files exceeded'
               CALL M3EXIT(PNAME, SDATE, STIME, XMSG, XSTAT2 )
            END IF

            ENV_DESC = 'IRR Output file ' // OUTFNAME 
            ENV_DFLT = ' '       
            CALL ENVSTR( OUTFNAME, ENV_DESC, ENV_DFLT, RET_VAL, STATUS )
            XMSG = 'IRR output file ' // TRIM( OUTFNAME ) // ' not assigned'
            IF ( STATUS .NE. 0 ) CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )

            IF ( MYPE .EQ. 0 ) THEN

C..try to open existing file for update
               IF ( .NOT. OPEN3( OUTFNAME, FSRDWR3, PNAME ) ) THEN

                  XMSG = 'Could not open ' // TRIM( OUTFNAME )
     &                 // ' file for update - try to open new'
                  CALL M3MESG( XMSG )

                  CALL PA_MKHDR( 'IRR', NFL, OUTFNAME, SDATE, STIME, TSTEP )

                  IF ( OPEN3( OUTFNAME, FSNEW3, PNAME ) ) THEN   ! open new
                     XMSG = 'Opened Integrated Reaction Rate Output File: '
     &                    // OUTFNAME
                     CALL M3MESG( XMSG )
                  ELSE
                     XMSG = 'Could not open Integrated Reaction Rate Output'
     &                    // ' File ' // OUTFNAME
                     CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )
                  END IF

               END IF

            END IF

            CALL SUBST_BARRIER

         END DO   ! NFL

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Initialize arrays
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         IRROUT = 0.0

      END IF   !   LIRR
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains key component from STK_PRMS.F to facilitate 
! centralized I/O implementation by avoiding cyclic data dependence

! Revision History:
!  01 Feb 2019 D.Wong initial implementation, 
!------------------------------------------------------------------------!

          module stack_group_data_module

            use UDTYPES, ONLY: IARRY1, RARRY1

            real, allocatable    :: XLOCA(:,:),
     &                              YLOCA(:,:)
            integer, ALLOCATABLE :: NSRC( : )
            integer, allocatable :: STKID(:,:)

            TYPE( RARRY1 ), ALLOCATABLE :: STKDIAM( : )
            TYPE( RARRY1 ), ALLOCATABLE :: STKHT  ( : )
            TYPE( RARRY1 ), ALLOCATABLE :: STKTK  ( : )
            TYPE( RARRY1 ), ALLOCATABLE :: STKVEL ( : )
            TYPE( RARRY1 ), ALLOCATABLE :: ACRES_BURNED( : )

            LOGICAL, ALLOCATABLE :: FIRE_ON( : )

          end module stack_group_data_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_reconfig_grid_info_ext.f,v 1.1 2004/03/26 16:16:47 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Note: -- all these variables with prefix se_ are for stencil exchange library 
C          only
C       -- variable *_ptr is a pointer type variable of its counter part *
C
C to define grid reconfiguration process common variables:
C
C se_reconfig_grid_send_ind -- indexes determine which part of the data is
C                              sending
C se_reconfig_grid_recv_ind -- indexes determine which part of the data is 
C                              receiving
C se_reconfig_grid_send     -- PE number indicates where data is sending to
C se_reconfig_grid_recv     -- PE number indicates where data is coming from
C se_grid1_map  -- mapping info of grid 1
C se_grid2_map  -- mapping info of grid 2
C --------------------------------------------------------------------------

        module se_reconfig_grid_info_ext

          integer, allocatable, save, target :: se_reconfig_grid_send_ind(:,:,:)
          integer, allocatable, save, target :: se_reconfig_grid_recv_ind(:,:,:)
          integer, pointer :: se_reconfig_grid_send_ind_ptr (:, :, :)
          integer, pointer :: se_reconfig_grid_recv_ind_ptr (:, :, :)

          integer, allocatable, save, target :: se_reconfig_grid_send(:)
          integer, allocatable, save, target :: se_reconfig_grid_recv(:)
          integer, pointer :: se_reconfig_grid_send_ptr(:)
          integer, pointer :: se_reconfig_grid_recv_ptr(:)

          integer, allocatable, target :: se_grid1_map(:,:,:)
          integer, pointer :: se_grid1_map_ptr(:,:,:)
          integer, allocatable, target :: se_grid2_map(:,:,:)
          integer, pointer :: se_grid2_map_ptr(:,:,:)

        end module se_reconfig_grid_info_ext

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     
c      [2] write tssa concentration data 
c     
C     Revision history
C     01 Nov 2018: S.Napelenok Updates for cmaq5.3 release 
C     09 May 2019: D.Wong Removed all MY_ clauses
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      SUBROUTINE WR_SA ( JDATE, JTIME, TSTEP, NSTEPS )

C20140428  Writes ISAM values to SA_CONC_1 file
C
C          Called by driver.F

!      USE HGRD_DEFN             ! horizontal domain specifications
      USE GRID_CONF
      USE UTILIO_DEFN           ! 20120615
c     USE SA_LAYERS
      USE SA_DEFN               ! Mc06
c     USE SUBST_MODULES         ! stenex
      USE RUNTIME_VARS

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

C...Arguments Declaration
      INTEGER    JDATE          ! current model date, coded YYYYDDD
      INTEGER    JTIME          ! current model time, coded HHMMSS
      INTEGER    TSTEP(3)       ! format 10000, 0, 0
cyqw
      INTEGER    NSTEPS         ! Number of time steps of 3D output
cyqw
!0711 CHARACTER( 16 )       :: FILE_NAME

C...End of argument declaration

C Local variables:
      
c     INTEGER          ALLOCSTAT, LOGDEV
      INTEGER          ALLOCSTAT
      LOGICAL, SAVE :: FIRSTIME = .TRUE.    !20140228

      CHARACTER( 16 ) :: PNAME = 'WR_SA'
      CHARACTER( 96 ) :: XMSG = ' '
      
      INTEGER   C,R,S,K,N, L, JSPC    ! loop induction variables

      REAL, ALLOCATABLE, SAVE :: ISAM_BUFF ( :,:,:,: )  ! save added on 20140306

C-----------------------------------------------------------------------


      CALL SUBST_BARRIER


Ckrt     print*,'N_SPCTAG, JDATE, JTIME '
Ckrt     print*, N_SPCTAG, JDATE, JTIME  

!0710    IF ( .NOT. OPEN3( FILE_NAME, FSRDWR3, PNAME ) ) THEN
!0710       XMSG = 'Could not open ' // FILE_NAME // ' file for update'
!0710       CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
!0710    END IF

!0711    IF ( .NOT. DESC3( FILE_NAME ) ) THEN
!0711       XMSG = 'Could not get file description from ' // FILE_NAME
!0711       CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
!0711    END IF

      IF ( FIRSTIME ) THEN  ! 20140228

        FIRSTIME = .FALSE.
        LOGDEV = INIT3 ()

        IF ( MYPE .NE. 0 ) THEN
          IF ( .NOT. OPEN3( SA_CONC_1, FSREAD3, PNAME ) ) THEN
            XMSG = 'Could not open ' // SA_CONC_1 // 'file for update'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          END IF !open3
        END IF ! mype nonzero

        IF ( .NOT. DESC3( SA_CONC_1 ) ) THEN
          XMSG = 'Could not get file description from ' // SA_CONC_1
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( ISAM_ELEV .EQ. -1 ) ISAM_ELEV = NLAYS
        SA_NLAYS = ISAM_ELEV - ISAM_BLEV + 1

!20140306 relocated here the following five lines
         ALLOCATE ( ISAM_BUFF( NCOLS, NROWS, SA_NLAYS, N_SPCTAG ),
     &     STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating ISAM_BUFF'
           CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         ENDIF

      IF ( ISAM_ELEV .EQ. -1 ) ISAM_ELEV = NLAYS

      END IF ! firstime

      ISAM_BUFF = 0.0
!Ckrt  print*,'S,VNAME3D(S),S_SPCTAG(S),T_SPCTAG(S)'
      DO S = 1, N_SPCTAG
       K = 0
       DO L = ISAM_BLEV, ISAM_ELEV
        K = K + 1
        DO R = 1, NROWS
         DO C = 1, NCOLS
          ISAM_BUFF( C,R,K,S ) = ISAM( C,R,L,S_SPCTAG(S),T_SPCTAG(S) )
         ENDDO
        ENDDO
       ENDDO


!20140306 Mentioning of vname3d is dangerous. Use vnam_spctag instead
!20140306       IF ( .NOT. WRITE3( SA_CONC_1, VNAME3D(S), JDATE, JTIME,
       IF ( .NOT. WRITE3( SA_CONC_1, VNAM_SPCTAG(S), JDATE, JTIME,
     &    ISAM_BUFF(:,:,:,S)) ) THEN
         XMSG = 'Could not write to ' 
!0711&        // FILE_NAME 
     &        // SA_CONC_1 
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
       END IF
      END DO
!20140306         IF ( ALLOCATED(ISAM_BUFF) ) DEALLOCATE( ISAM_BUFF )
      
c.....couple ISAM after writing

      return
      end

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      INTEGER FUNCTION FINDEX (INDX, N, NLIST)

C Searches for INDX in list NLIST and returns the subscript
C (1...N) at which it is found, or returns 0 if INDX not found

      IMPLICIT NONE
 
      INTEGER INDX        !  index being searched for
      INTEGER N           !  Length of array to be searched
      INTEGER NLIST(*)    !  array to be searched

      INTEGER I

      DO I = 1, N
         IF ( INDX .EQ. NLIST( I ) ) THEN  ! found
            FINDEX = I
            RETURN
            END IF
         END DO
      FINDEX = 0        !  not found
      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!



!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE CSQY_DATA

      USE RUNTIME_VARS

      IMPLICIT NONE

      CHARACTER( 32 ), PUBLIC :: JTABLE_REF

      INTEGER, PUBLIC :: NPHOT_REF  ! # ref phot reactions
      INTEGER, PUBLIC :: NTEMP_REF  ! # ref temperatures
      INTEGER, PUBLIC :: NWL_REF    ! # ref wavelengths

!...Names of the mapped photolysis reactions (available to chemical)
!... mechanisms) and their pointers to the reference photolysis rxn

      CHARACTER( 16 ), ALLOCATABLE, PUBLIC :: PNAME_REF( : )

!...Setup the Mapping from CMAQ chemical reactions to the reference data

      INTEGER, PUBLIC :: NPHOT_MAP  ! #  phot mapped reactions

      CHARACTER( 16 ), ALLOCATABLE, PUBLIC :: PNAME_MAP( : )
      INTEGER, ALLOCATABLE,         PUBLIC :: PHOT_MAP ( : )

      REAL, PUBLIC, ALLOCATABLE :: STWL_REF ( : )
      REAL, PUBLIC, ALLOCATABLE :: EFFWL_REF( : )
      REAL, PUBLIC, ALLOCATABLE :: ENDWL_REF( : )

      REAL, ALLOCATABLE, PUBLIC :: CLD_BETA_REF    ( : )  ! cloud extinction coef divided by LWC
      REAL, ALLOCATABLE, PUBLIC :: CLD_COALBEDO_REF( : )  ! cloud coalbedo
      REAL, ALLOCATABLE, PUBLIC :: CLD_G_REF       ( : )  ! cloud asymmetry factor

      REAL, ALLOCATABLE, PUBLIC :: FSOLAR_REF( : )        ! initial solar flux [photons*cm-2*s-1]

      REAL, ALLOCATABLE, PUBLIC :: TEMP_BASE ( : )        ! reference temperatures
      REAL, ALLOCATABLE, PUBLIC :: TEMP_REF( :,: )        ! reference temperatures

      REAL, ALLOCATABLE, PUBLIC :: CS_REF ( :,:,: )       ! effective cross sections
      REAL, ALLOCATABLE, PUBLIC :: QY_REF ( :,:,: )       ! effective quantum yields
      REAL, ALLOCATABLE, PUBLIC :: ECS_REF( :,:,: )       ! CS*QY averaged UCI Solar Flux

      INTEGER,           PUBLIC :: NTEMP_STRAT_REF        ! number of stratos temperatures
      REAL, ALLOCATABLE, PUBLIC :: TEMP_STRAT_REF( : )    ! temperature for stratos O3 xcross, K
      REAL, ALLOCATABLE, PUBLIC :: O3_CS_STRAT_REF( :,: ) ! ozone xcross at stratos temperatures, cm2

!...    effective quantum yields were computed by performing separate
!...    interval integrations for the cross sections and for the
!...    effective cross sections (cs*qy) (calculated on the finer
!...    wavelength grid.  The effective quantum yield values
!...    were then calculated for the 7 wavelength intervals by
!...    dividing the effective cross sections by the interval average
!...    cross sections (eQY=eCS/CS).

      REAL, ALLOCATABLE, PUBLIC :: EQY_REF( :,:,: ) ! eCS/CS averaged 77 bins in UCI Model

      INTEGER, PUBLIC :: NUM_REFRACTIVE

      TYPE MODAL_COMPLEX
         CHARACTER( 16 ) :: NAME                           ! name of complex property
         REAL, ALLOCATABLE, DIMENSION( :, : ) :: REAL_PART ! real part
         REAL, ALLOCATABLE, DIMENSION( :, : ) :: IMAG_PART ! imaginary part
      END TYPE MODAL_COMPLEX

      TYPE( MODAL_COMPLEX ), ALLOCATABLE, PUBLIC :: REFRACTIVE_INDEX( : )

      INTEGER, PUBLIC :: IWLR  ! wavelength loop variable
      INTEGER, PUBLIC :: ITTR  ! temperature loop variable

! arrays for the size and optical properties of liquid droplets. The latter
! is a function of radius and wavelength
      INTEGER, PUBLIC  :: NRADIUS_LIQUID

      REAL, ALLOCATABLE, PUBLIC  ::  RADIUS_LIQUID( : )       ! droplet radius, um
      REAL, PUBLIC               ::  INIT_RADIUS_LIQUID
      REAL, PUBLIC               ::  MAXI_RADIUS_LIQUID
      REAL, PUBLIC               ::  MINI_RADIUS_LIQUID
      REAL, PUBLIC               ::  FREQ_RADIUS_LIQUID

      REAL, ALLOCATABLE, PUBLIC ::  LIQUID_EXTINCT( :, : )   ! extinction coefficient, m**3/g
      REAL, ALLOCATABLE, PUBLIC :: LIQUID_ASYMFACT( :, : )   ! asymmetery factor, dimensionaless
      REAL, ALLOCATABLE, PUBLIC :: LIQUID_COALBEDO( :, : )   ! One minus single scattering albebo, dimensionaless

! arrays for the size and optical properties of ice particles. The latter
! is a function of effective diameter and wavelength

      INTEGER, PUBLIC  :: NDIAMETER_ICE

      REAL, ALLOCATABLE, PUBLIC ::  DIAMETER_ICE( : )     ! particle effective diameter, um
      REAL, PUBLIC              ::  INIT_DIAMETER_ICE
      REAL, PUBLIC              ::  MAXI_DIAMETER_ICE
      REAL, PUBLIC              ::  MINI_DIAMETER_ICE
      REAL, PUBLIC              ::  FREQ_DIAMETER_ICE

      REAL, ALLOCATABLE, PUBLIC ::  ICE_EXTINCT( :, : )   ! extinction coefficient, m**3/g
      REAL, ALLOCATABLE, PUBLIC :: ICE_ASYMFACT( :, : )   ! asymmetery factor, dimensionaless
      REAL, ALLOCATABLE, PUBLIC :: ICE_COALBEDO( :, : )   ! One minus single scattering albebo, dimensionaless
      REAL, ALLOCATABLE, PUBLIC :: ICE_DELTRANS( :, : )   ! Delta Transmission Function at zero scattering angle, dimensionaless

      PUBLIC            :: LOAD_CSQY_DATA, LOAD_OPTICS_DATA, GET_CSQY


!***Information for photolysis

      INTEGER, SAVE       :: NWL     ! number of wavelengths
!     INTEGER, PARAMETER  :: NWL_INLINE_METHOD = 7

      INTEGER JWAVE             ! index use for wavelength
      INTEGER ITEMP             ! index for temperature
      INTEGER IRRXN

      REAL, ALLOCATABLE :: WAVELENGTH( : )  ! effective wavelengths [nm ]
      REAL, ALLOCATABLE :: WAVENUMBER( : )  ! effective wavenumbers [cm-1]

      REAL, ALLOCATABLE :: FEXT( : )   ! downward solar direct flux at the top of
                                             ! of the Atmosphere.  [ photons / ( cm **2 s) ]

!***surface albedo

      REAL, ALLOCATABLE :: ALB( : )  ! set in subroutine PHOT

!**Cloud albedo values from JPROC

      REAL, ALLOCATABLE :: CLOUD_BETA_LWC( : ) ! cloud extinction coef divided by LWC
      REAL, ALLOCATABLE :: CLOUD_COALBEDO( : ) ! cloud coalbedo
      REAL, ALLOCATABLE :: CLOUD_G( : )        ! cloud asymmetry factor

      INTEGER            :: NTEMP_STRAT
      REAL, ALLOCATABLE  :: XO3CS( :,: )       !
      REAL, ALLOCATABLE  :: TEMP_O3_STRAT( : ) ! temperature for XO3CS, K

!***arrays for reference data for needed photolysis rates

      REAL, ALLOCATABLE :: XXCS( :,:,: )  ! absorption cross sections
      REAL, ALLOCATABLE :: XXQY( :,:,: )  ! quantum yield
      REAL, ALLOCATABLE :: RTEMP_S( :,: )

      INTEGER                     :: MECHANISM_RATES
      CHARACTER(16), ALLOCATABLE  :: PHOTOLYSIS_RATE( : ) ! subset of photolysis rates from CSQY DATA

!***Indices for special case photolysis cross sections

      INTEGER :: LNO2
      INTEGER :: LO3O1D
      INTEGER :: LO3O3P
      INTEGER :: LACETONE
      INTEGER :: LKETONE
      INTEGER :: LMGLY_ADJ
      INTEGER :: LMGLY_ABS
      INTEGER :: LHCHOR_06
      INTEGER :: LH2O2
      INTEGER :: LHNO3
      INTEGER :: LACETONE_CO
      INTEGER :: LACETONE_CH3CO

      LOGICAL :: ACETONE_CHANNELS

! integer pointer for specific density correction to cross-section
! and/or quantum yield values
            INTEGER, PARAMETER :: ACETALDEHYDE           =  1
            INTEGER, PARAMETER :: HIGHER_ALDEHYDES       =  2
            INTEGER, PARAMETER :: METHYL_VINYL_KETONE    =  3
            INTEGER, PARAMETER :: METHYL_ACROLEIN        =  4
            INTEGER, PARAMETER :: METHYL_ETHYL_KETONE    =  5
            INTEGER, PARAMETER :: METHYL_GLYOXAL_IUPAC04 =  6
            INTEGER, PARAMETER :: ACROLEIN               =  7
            INTEGER, PARAMETER :: FORMALDEHYDE_MOLECULAR =  8
            INTEGER, PARAMETER :: ACETONE                =  9
            INTEGER, PARAMETER :: KETONE_LEGACY          = 10
            INTEGER, PARAMETER :: KETONE_RACM2           = 11
            INTEGER, PARAMETER :: GLYOXAL_RACM2          = 12
            INTEGER, PARAMETER :: METHYL_GLYOXAL_LEGACY  = 13
            INTEGER, PARAMETER :: NBUTYRALDEHYDE         = 14
            INTEGER, PARAMETER :: BIACETYL               = 15
            INTEGER, PARAMETER :: ACETONE_CH3CO          = 16
            INTEGER, PARAMETER :: GLYOXAL_IUPAC_2013     = 17
            INTEGER, PARAMETER :: CH3CHO_IUPAC2013       = 18

            CHARACTER( 32 ) :: CSQY_ADJUSTMENTS( 0:18 )
            DATA CSQY_ADJUSTMENTS /
     &                             'NO_ADJUSTMENT',
     &                             'ACETALDEHYDE',
     &                             'HIGHER_ALDEHYDES',
     &                             'METHYL_VINYL_KETONE',
     &                             'METHYL_ACROLEIN',
     &                             'METHYL_ETHYL_KETONE',
     &                             'METHYL_GLYOXAL_IUPAC04',
     &                             'ACROLEIN',
     &                             'FORMALDEHYDE_MOLECULAR',
     &                             'ACETONE',
     &                             'KETONE_LEGACY',
     &                             'KETONE_RACM2',
     &                             'GLYOXAL_RACM2',
     &                             'METHYL_GLYOXAL_LEGACY',
     &                             'NBUTYRALDEHYDE',
     &                             'BIACETYL',
     &                             'ACETONE_CH3CO',
     &                             'GLYOXAL_IUPAC_2013',
     &                             'CH3CHO_IUPAC2013'      /

! integer pointer for density correction to a photolysis rates' cross-section
! and/or quantum yield values
            INTEGER, ALLOCATABLE :: CSQY_ADJUST( : )

            REAL,    ALLOCATABLE :: IPHI0_MGLY( : ) ! Reciprocal Methyl Glyoxal Quantum Yields at zero pressure
            REAL,    ALLOCATABLE :: KMGLY    ( : )  ! Quenching Coefficient for Methyl Glyoxal Quantum Yields

! coefficients used correct acetaldehyde Quantum Yields based on IUPAC 2013 recommendations
            REAL,    ALLOCATABLE :: IPHIS_CH3CHO( : ) ! Reciprocal acetaldehyde Quantum Yields at surface pressure
            REAL,    ALLOCATABLE :: IPHI0_CH3CHO( : ) ! Reciprocal acetaldehyde Quantum Yields at zero pressure
            REAL,    ALLOCATABLE :: KCH3CHO     ( : ) ! Quenching Coefficient for acetaldehyde Quantum Yields



      INTEGER :: IREFTEMPS  ! number of ref. temperatures

      INTEGER :: NUMB_LANDUSE_REF
      INTEGER :: INDEX_GRASSLAND_REF
      INTEGER :: INDEX_OCEAN_REF
      INTEGER :: INDEX_SEA_ICE

      CHARACTER(30), ALLOCATABLE :: LANDUSE_REF( : )
      REAL,          ALLOCATABLE :: ZENITH_COEFF_REF( : )
      REAL,          ALLOCATABLE :: SEASON_COEFF_REF( : )
      REAL,          ALLOCATABLE :: SNOW_COEFF_REF( : )
      REAL,          ALLOCATABLE :: SPECTRAL_ALBEDO_REF( :,: )

      INTEGER, PARAMETER         :: NUMB_EXPECT_NLCD50  = 50
      INTEGER                    :: NUMB_LANDUSE_NLCD50
      CHARACTER(60), ALLOCATABLE :: LANDUSE_NLCD50( : )
      INTEGER,       ALLOCATABLE :: ALBMAP_REF2NLCD50( : )
      REAL,          ALLOCATABLE :: ALBFAC_REF2NLCD50( : )

      INTEGER, PARAMETER         :: NUMB_EXPECT_NLCD40  = 40
      INTEGER, SAVE              :: NUMB_LANDUSE_NLCD40
      CHARACTER(60), ALLOCATABLE :: LANDUSE_NLCD40( : )
      INTEGER,       ALLOCATABLE :: ALBMAP_REF2NLCD40( : )
      REAL,          ALLOCATABLE :: ALBFAC_REF2NLCD40( : )

      INTEGER, PARAMETER         :: NUMB_EXPECT_USGS  = 24
      INTEGER                    :: NUMB_LANDUSE_USGS
      CHARACTER(60), ALLOCATABLE :: LANDUSE_USGS( : )
      INTEGER,       ALLOCATABLE :: ALBMAP_REF2USGS( : )
      REAL,          ALLOCATABLE :: ALBFAC_REF2USGS( : )

      INTEGER, PARAMETER         :: NUMB_EXPECT_MODIS = 33
      INTEGER                    :: NUMB_LANDUSE_MODIS
      CHARACTER(60), ALLOCATABLE :: LANDUSE_MODIS( : )
      INTEGER,       ALLOCATABLE :: ALBMAP_REF2MODIS( : )
      REAL,          ALLOCATABLE :: ALBFAC_REF2MODIS( : )

      LOGICAL      :: NO_NLCD40
      LOGICAL      :: WRITE_CELL

!***special information for acetone
!***  Reference:
!***     Cameron-Smith, P., Incorporation of non-linear
!***     effective cross section parameterization into a
!***     fast photolysis computation  code (Fast-J)
!***     Journal of Atmospheric Chemistry, Vol. 37,
!***     pp 283-297, 2000.

      INTEGER, PARAMETER :: NWL_ACETONE_FJX = 7

      REAL :: OP0( 2, NWL_ACETONE_FJX ) ! variable needed for acetone

      DATA ( OP0( 1, JWAVE ), JWAVE = 1, NWL_ACETONE_FJX ) /
     &     2.982E-20, 1.301E-20, 4.321E-21, 1.038E-21,
     &     5.878E-23, 1.529E-25, 0.0/

      DATA ( OP0( 2, JWAVE ), JWAVE = 1, NWL_ACETONE_FJX ) /
     &     3.255E-20, 1.476E-20, 5.179E-21, 1.304E-21,
     &     9.619E-23, 2.671E-25, 0.0 /

      REAL :: YY30( NWL_ACETONE_FJX )   ! variable needed for acetone

      DATA YY30 / 5.651E-20, 1.595E-19, 2.134E-19,
     &     1.262E-19, 1.306E-19, 1.548E-19, 0.0 /

      REAL :: OPTT                ! variable needed for acetone

      CONTAINS

      SUBROUTINE LOAD_CSQY_DATA ( )
!-----------------------------------------------------------------------
!  Purpose: read input file for
!           -wavelength bin and temperature structure.
!           -photolysis cross-sections and quantum
!
!  Revision History:
!   31 Jan 2014 B.Hutzell: Initial Version based on LOAD_REF_DATA in
!   CMAQ version 5.0
!   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
!-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE RXNS_DATA           ! chemical mechanism data

      IMPLICIT NONE

!***arguments

C     NONE

!***local

      LOGICAL :: WRITE_LOG = .TRUE.

      CHARACTER(  32 ) :: PNAME = 'LOAD_CSQY_DATA'
      CHARACTER(  16 ) :: CSQY_FILE = 'CSQY_DATA' ! CSQY_DATA i/o logical name
      CHARACTER(  16 ) :: PHOT_EXPECT
      CHARACTER(  30 ) :: LAND_EXPECT
      CHARACTER( 120 ) :: MSG                     ! buffer for messages to output
      CHARACTER( 240 ) :: FILE_LINE

      CHARACTER(  16 ),  ALLOCATABLE :: AE_RERACT_REF( : )

!     INTEGER, INTENT(OUT) :: NWL_PHOT    ! # of wavelengths used in PHOT_MOD.F
      INTEGER :: NWL_PHOT    ! # of wavelengths used in PHOT_MOD.F
      INTEGER :: IOST        ! IOST returned from OPEN function
      INTEGER :: JDATE = 0
      INTEGER :: PHOTAB_UNIT
      INTEGER :: IPHOT, IPHOT_LOAD ! loop indices
      INTEGER :: ITT, ITT_LOAD     ! loop indices
      INTEGER :: IP_MAP, IP_REF    ! photolysis reaction indicies
      INTEGER :: IWL, IWL_LOAD
      INTEGER :: STRT, FINI


      INTEGER :: NAE_REFRACT_REF

      REAL,       ALLOCATABLE :: AE_IMAG_REFRACT( :, : )
      REAL,       ALLOCATABLE :: AE_REAL_REFRACT( :, : )

      LOGICAL                  :: ERROR_FLAG = .FALSE.

!***external functions: none

      PHOTAB_UNIT = GETEFILE( CSQY_FILE, .TRUE., .TRUE., PNAME )

      IF ( PHOTAB_UNIT .LT. 0 ) THEN
         MSG = 'Error opening the CSQY data file: ' // TRIM( CSQY_FILE )
         CALL M3WARN ( PNAME, 0, 0, MSG )
         ERROR_FLAG = .TRUE.
      END IF

C...begin read

      READ( PHOTAB_UNIT,'(22X,A32)' ) JTABLE_REF

      IF ( JTABLE_REF .NE. MECHNAME ) THEN
         MSG =  'WARNING: JTABLE mechanism is for ' // JTABLE_REF
     &       // ' but gas chemistry name is '       // MECHNAME
         CALL M3WARN( PNAME, 0, 0, MSG )
      END IF

      READ( PHOTAB_UNIT,'(10X,I4)' ) NPHOT_MAP

      IF ( NPHOT_MAP .LT. NPHOTAB ) THEN
         WRITE( MSG,'( A,1X,I4,1X,A,1X,I4)')
     &   'Error: CSQY data file has',NPHOT_MAP,
     &   'rates but the need number is',NPHOTAB
          CALL M3WARN( PNAME, 0, 0, MSG )
         ERROR_FLAG = .TRUE.
      END IF


#ifdef verbose_phot
      write( LOGDEV,'(A,a32)' )'JTABLE_REF = ',trim(jtable_ref)
      write( LOGDEV,'(A,10x,i4)' )'NPHOT_MAP = ', nphot_map
#endif

      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

      ALLOCATE( PNAME_MAP( NPHOT_MAP ) )
      ALLOCATE( PNAME_REF( NPHOT_MAP ) )
      ALLOCATE( PHOT_MAP ( NPHOT_MAP ) )

      DO IPHOT_LOAD = 1, NPHOT_MAP
         READ( PHOTAB_UNIT,'(A16)' ) PNAME_REF( IPHOT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,'(i3,1x,a16)' ) iphot_load, pname_ref( iphot_load )
#endif

         PNAME_MAP( IPHOT_LOAD ) = PNAME_REF( IPHOT_LOAD )
         PHOT_MAP ( IPHOT_LOAD ) = IPHOT_LOAD
      END DO

      READ( PHOTAB_UNIT,'(10X,I3)' ) NTEMP_REF

#ifdef verbose_phot
      write( LOGDEV,'(10x,i3)' ) ntemp_ref
#endif

      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

#ifdef verbose_phot
      write( LOGDEV,* ) trim( file_line )
#endif

      IREFTEMPS = NTEMP_REF

      ALLOCATE( TEMP_BASE( NTEMP_REF ) )

      DO ITT_LOAD = 1, NTEMP_REF
         READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

#ifdef verbose_phot
         write( LOGDEV,* ) trim( file_line )
#endif

         READ( FILE_LINE,* ) IPHOT_LOAD, TEMP_BASE( ITT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,'(4x,f6.2)' ) temp_base( itt_load )
#endif

      END DO

      ALLOCATE( TEMP_REF( NTEMP_REF, NPHOT_MAP) )

      DO ITT_LOAD = 1, 15 ! skip next 15 lines
         READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(I2,1X,A)' )ITT_LOAD,TRIM(FILE_LINE)
#endif
      END DO

      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

#ifdef verbose_phot
      write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif
      READ( FILE_LINE, 4999) NWL_REF

#ifdef verbose_phot
      write( LOGDEV,'(17x,i3)' ) nwl_ref
#endif


4999  FORMAT(17X,I3,2X,17X,I3)


      NWL       = NWL_REF
      NWL_PHOT  = NWL


      IF ( NWL_REF .LT. 1 ) THEN
         WRITE( LOGDEV,* ) 'NWL_REF  = ', NWL_REF
         MSG = 'NWL_REF in ' // CSQY_FILE
     &       // ' has the bad value, written above. '
         CALL M3EXIT( PNAME, 0, 0, MSG, -1 )
      END IF

      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, * )FILE_LINE
#endif

      IF( .NOT. ALLOCATED( STWL_REF   ) ) ALLOCATE( STWL_REF  ( NWL_REF ) )
      IF( .NOT. ALLOCATED( ENDWL_REF  ) ) ALLOCATE( ENDWL_REF ( NWL_REF ) )
      IF( .NOT. ALLOCATED( FSOLAR_REF ) ) ALLOCATE( FSOLAR_REF( NWL_REF ) )
      IF( .NOT. ALLOCATED( EFFWL_REF  ) ) ALLOCATE( EFFWL_REF ( NWL_REF ) )
      IF( .NOT. ALLOCATED( FEXT       ) ) ALLOCATE( FEXT      ( NWL_REF ) )
      IF( .NOT. ALLOCATED( WAVELENGTH ) ) ALLOCATE( WAVELENGTH( NWL_REF ) )
      IF( .NOT. ALLOCATED( WAVENUMBER ) ) ALLOCATE( WAVENUMBER( NWL_REF ) )

      DO IWL_LOAD = 1, NWL_REF
!         READ( PHOTAB_UNIT,'(4X,3(F8.3,2X),2X,ES12.4,2X,2(F8.3,2X),ES12.4,2X)' )
         READ( PHOTAB_UNIT, * )iphot_load,
     &         STWL_REF( IWL_LOAD ), EFFWL_REF( IWL_LOAD ),
     &         ENDWL_REF( IWL_LOAD ), FSOLAR_REF( IWL_LOAD )

#ifdef verbose_phot
         write( LOGDEV,'(4x,3(f8.3,2x),2x,2(es12.4,2x),f8.3,2x,12(es12.4,2x))' )
     &          stwl_ref( iwl_load ), effwl_ref( iwl_load ),
     &          endwl_ref( iwl_load ),fsolar_ref( iwl_load )
#endif
         WAVELENGTH( IWL_LOAD ) = EFFWL_REF ( IWL_LOAD )
         WAVENUMBER( IWL_LOAD ) = 1.0E7 / EFFWL_REF ( IWL_LOAD )
         FEXT      ( IWL_LOAD ) = FSOLAR_REF( IWL_LOAD )
      END DO


      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

      ALLOCATE( CS_REF (  NWL_REF, NTEMP_REF, NPHOT_MAP ) )
      ALLOCATE( QY_REF (  NWL_REF, NTEMP_REF, NPHOT_MAP ) )
      ALLOCATE( EQY_REF(  NWL_REF, NTEMP_REF, NPHOT_MAP ) )
      ALLOCATE( ECS_REF(  NWL_REF, NTEMP_REF, NPHOT_MAP ) )

      CS_REF = 0.0
      QY_REF  = 0.0
      EQY_REF = 0.0
      ECS_REF = 0.0

      DO IPHOT_LOAD = 1, NPHOT_MAP
         DO ITT_LOAD = 1, NTEMP_REF
            READ( PHOTAB_UNIT,'(A16,7X,F8.3,1X,40(1PE13.6,2X))' )
     &            PHOT_EXPECT, TEMP_REF( ITT_LOAD, IPHOT_LOAD),
     &            ( CS_REF( IWL_LOAD, ITT_LOAD, IPHOT_LOAD ), IWL_LOAD = 1, NWL_REF )

#ifdef verbose_phot
            write( LOGDEV,'(a16,7x,f8.3,1x,40(1pe13.6,2x))' )
     &             phot_expect, temp_ref( itt_load, iphot_load),
     &             ( cs_ref( iwl_load, itt_load, iphot_load ), iwl_load = 1, nwl_ref )
#endif

            IF ( PHOT_EXPECT .NE. PNAME_REF( IPHOT_LOAD ) ) THEN
                MSG =  'CS for ' // TRIM( PHOT_EXPECT )
     &              // ' does match the order the PHOT_MAP array.'
                CALL M3EXIT( PNAME, 0, 0, MSG, -1 )
            END IF

            READ( PHOTAB_UNIT,'(A16,7X,F8.3,1X,40(1PE13.6,2X))' )
     &            PHOT_EXPECT, TEMP_REF( ITT_LOAD, IPHOT_LOAD),
     &            ( EQY_REF( IWL_LOAD, ITT_LOAD, IPHOT_LOAD ), IWL_LOAD = 1, NWL_REF )

            QY_REF( 1:NWL_REF, ITT_LOAD, IPHOT_LOAD ) = EQY_REF( 1:NWL_REF, ITT_LOAD, IPHOT_LOAD )

#ifdef verbose_phot
            write( LOGDEV,'(a16,7x,f8.3,1x,40(1pe13.6,2x))' )
     &             phot_expect, temp_ref( itt_load, iphot_load),
     &             ( qy_ref( iwl_load, itt_load, iphot_load ), iwl_load = 1, nwl_ref )
#endif

            IF ( PHOT_EXPECT .NE. PNAME_REF(IPHOT_LOAD) ) THEN
               MSG =  'EQY for ' // TRIM( PHOT_EXPECT )
     &             // ' does match the order the PHOT_MAP array.'
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
         END DO
      END DO

      DO ITT_LOAD = 1, 3 ! skip next 3 lines
         READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
      END DO

      READ( PHOTAB_UNIT,'(15X,I3)' ) NTEMP_STRAT_REF

#ifdef verbose_phot
      write( LOGDEV,'(16x,i3)' ) ntemp_strat_ref
#endif

      ALLOCATE( TEMP_STRAT_REF ( NTEMP_STRAT_REF ) )
      ALLOCATE( O3_CS_STRAT_REF( NWL_REF, NTEMP_STRAT_REF ) )

      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

      DO ITT_LOAD = 1, NTEMP_STRAT_REF
         READ( PHOTAB_UNIT,'(A16,7X,F8.3,1X,40(1PE13.6,2X))' )
     &         PHOT_EXPECT, TEMP_STRAT_REF( ITT_LOAD ),
     &         ( O3_CS_STRAT_REF( IWL_LOAD, ITT_LOAD ), IWL_LOAD = 1, NWL_REF )

#ifdef verbose_phot
         write( LOGDEV,'(a16,7x,f8.3,1x,40(1pe13.6,2x))' )
     &          phot_expect, temp_strat_ref( itt_load ),
     &          ( o3_cs_strat_ref( iwl_load, itt_load ), iwl_load = 1, nwl_ref )
#endif

         IF ( PHOT_EXPECT .NE. 'O3_STRAT' ) THEN
            MSG = 'O3_STRAT not found at expected location in CSQY_FILE. ' //
     &            TRIM( PHOT_EXPECT ) // ' found.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            ERROR_FLAG = .TRUE.
         END IF
      END DO


      NTEMP_STRAT = NTEMP_STRAT_REF
      ALLOCATE( TEMP_O3_STRAT( NTEMP_STRAT_REF ) )
      ALLOCATE( XO3CS        ( NTEMP_STRAT_REF, NWL_PHOT ) )

      DO ITT_LOAD = 1, NTEMP_STRAT_REF
         TEMP_O3_STRAT( ITT_LOAD ) = TEMP_STRAT_REF( ITT_LOAD )
         DO IWL_LOAD = 1, NWL_PHOT
            XO3CS( ITT_LOAD, IWL_LOAD ) = O3_CS_STRAT_REF( IWL_LOAD, ITT_LOAD )
         END DO
      END DO

!***initialize pointers for mandatory photolysis rates

      LNO2      = 0
      LO3O1D    = 0
      LO3O3P    = 0
      LACETONE  = 0
      LKETONE   = 0
      LMGLY_ADJ = 0
      LMGLY_ABS = 0
      LHCHOR_06 = 0
      LH2O2     = 0
      LHNO3     = 0

! initialized pointers and flag if specific acetone channel are used
      LACETONE_CO    = 0
      LACETONE_CH3CO = 0
      ACETONE_CHANNELS = .FALSE.

!***get needed photolysis data for the model chemistry from the
!***CSQY_DATA

       ALLOCATE( PHOTOLYSIS_RATE ( NPHOTAB ) )
       ALLOCATE( XXCS( IREFTEMPS, NWL, NPHOTAB ) )
       ALLOCATE( XXQY( IREFTEMPS, NWL, NPHOTAB ) )
       ALLOCATE( RTEMP_S( IREFTEMPS, NPHOTAB ) )

       MECHANISM_RATES = NPHOTAB


       DO IPHOT = 1, NPHOTAB
          IP_MAP = INDEXR( PHOTAB( IPHOT ), NPHOT_MAP, PNAME_MAP )
          IF ( IP_MAP .LE. 0 ) THEN
             MSG = 'FATAL ERROR: photolysis reaction ' // TRIM( PHOTAB( IPHOT ) )
     &          // ' not found in ' //
     &             'the reference data! '
             ERROR_FLAG = .TRUE.
             CALL M3WARN ( PNAME, 0, 0, MSG )
             CYCLE
          END IF
          IP_REF = PHOT_MAP( IP_MAP )
          PHOTOLYSIS_RATE( IPHOT ) = PNAME_MAP( IP_MAP )

!***check to see if this photolysis reaction is a special case that
!***  is referenced in other sections of the code.  if so, then set
!***  the appropriate pointers for later processing

           SELECT CASE ( PHOTOLYSIS_RATE( IPHOT ) )
              CASE( 'O3O3P', 'O3O3P_SAPRC99', 'O3O3P_06', 'O3_O3P_IUPAC04', 'O3O3P_NASA06', 'O3_O3P_IUPAC10' )
                    LO3O3P = IPHOT
              CASE( 'NO2', 'NO2_SAPRC99', 'NO2_06', 'NO2_RACM2', 'NO2_IUPAC10' )
                    LNO2 = IPHOT
              CASE( 'O3O1D',  'O3O1D_SAPRC99' , 'O3O1D_06', 'O3_O1D_IUPAC04', 'O3O1D_NASA06', 'O3_O1D_IUPAC10' )
                    LO3O1D = IPHOT
              CASE( 'KETONE', 'KET_RACM2', 'KET_JGR19' )
                    LKETONE   = IPHOT
              CASE( 'MGLY_ADJ' )
                    LMGLY_ADJ = IPHOT
              CASE(  'MGLY_ABS' )
                    LMGLY_ABS = IPHOT
              CASE( 'ACETONE', 'CH3COCH3_RACM2', 'ACET_IUPAC10' )
                    IF( NWL .EQ. NWL_ACETONE_FJX ) LACETONE  = IPHOT
              CASE( 'HCHOR_06', 'HCHO_R_SAPRC99', 'HCHO_RAD_RACM2', 'FORM_R_IUPAC10', 
     &              'FORM_R_IUPAC13', 'HCHO_R_MCMv32', 'HCHO_RAD_JPL19' )
                    LHCHOR_06 = IPHOT
              CASE( 'ACET_CH3CO_CRI', 'CH3COCH3A_JPL19' )
                    LACETONE_CH3CO   = IPHOT
                    ACETONE_CHANNELS = .TRUE.
              CASE( 'H2O2', 'H2O2_SAPRC99', 'H2O2_RACM2', 'H2O2_IUPAC10' )
                   LH2O2 = IPHOT
              CASE( 'HNO3', 'HNO3_IUPAC04', 'HNO3_IUPAC10', 'HNO3_RACM2' )
                   LHNO3 = IPHOT
           END SELECT



!***load the local cross section & quantum yield data from the reference
!***  dataset for this photolysis reaction

            DO ITT = 1, IREFTEMPS
               RTEMP_S( ITT, IPHOT ) = TEMP_REF( ITT, IP_REF )
               DO IWL = 1, NWL
                  XXCS( ITT, IWL, IPHOT ) = CS_REF( IWL, ITT, IP_REF )
                  XXQY( ITT, IWL, IPHOT ) = QY_REF( IWL, ITT, IP_REF )
               END DO   ! iwl
            END DO   ! itt

       END DO   ! iphot

       IF ( LNO2   .EQ. 0 ) THEN
          MSG = 'NO2 cross-section not found in the CSQY data! '
          ERROR_FLAG = .TRUE.
          CALL M3WARN ( PNAME, 0, 0, MSG )
       END IF
       IF ( LO3O1D .EQ. 0 ) THEN
          MSG = 'O3(1D) production not found in the CSQY data! '
          CALL M3WARN ( 'NEW_OPTICS', 0, 0, MSG )
       END IF
       IF ( LO3O3P .EQ. 0 ) THEN
          MSG = 'O3 cross-section not found in the CSQY data! '
          ERROR_FLAG = .TRUE.
          CALL M3WARN ( PNAME, 0, 0, MSG )
       END IF
       IF ( LH2O2 .EQ. 0 ) THEN
          MSG = 'H2O2 cross-section not found in the CSQY data! '
          ERROR_FLAG = .TRUE.
          CALL M3WARN ( PNAME, 0, 0, MSG )
       END IF
       IF ( LHNO3 .EQ. 0 ) THEN
          MSG = 'HNO3 cross-section not found in the CSQY data! '
          ERROR_FLAG = .TRUE.
          CALL M3WARN ( PNAME, 0, 0, MSG )
       END IF

       IF( ERROR_FLAG )THEN
         MSG = 'The above fatal error(s) found in CSQY data! '
         CALL M3EXIT( PNAME, 0, 0, MSG, -1 )
       END IF

      CLOSE(PHOTAB_UNIT)

5012  FORMAT( 4X,A30,1X,3(F8.3,2X) )
5013  FORMAT( 22X,I3 )
5016  FORMAT( 4X,A60,1X,I3,2X,3(F8.3,2X) )

#ifdef verbose_phot
6009  format( a3,', ',8(a,', ') )
6013  format( a22,1x,i3 )
6016  format( i3,1x,a60,1x,i3,2x,3(f8.3,2x) )
#endif

      RETURN
      END SUBROUTINE LOAD_CSQY_DATA



      SUBROUTINE LOAD_OPTICS_DATA()
!-----------------------------------------------------------------------
!  Purpose: read input file for
!           -wavelength bin for cross check against
!           -size dependent optical data for liquid droplets and ice
!            ice particles
!           -landuse type data for surface alebdo
!
!  Revision History:
!   31 Jan 2014 B.Hutzell: Initial Version based on LOAD_REF_DATA in
!   CMAQ version 5.0
!-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE AERO_DATA,   ONLY: N_MODE

      IMPLICIT NONE

!***arguments

      REAL, PARAMETER  :: EPSILON = 1.0E-6     ! small number

!***local

      LOGICAL :: WRITE_LOG = .TRUE.

      CHARACTER(  32 ) :: PNAME         = 'LOAD_OPTICS_DATA'
      CHARACTER(  16 ) :: OPTICS_FILE   = 'OPTICS_DATA'      ! OPTICS_DATA i/o logical name
      CHARACTER(  16 ) :: OPTICS_EXPECT
      CHARACTER(  16 ) :: QUANTITY
      CHARACTER(  30 ) :: LAND_EXPECT
      CHARACTER( 120 ) :: MSG                               ! buffer for messages to output
      CHARACTER( 240 ) :: FILE_LINE

      CHARACTER(  16 ),  ALLOCATABLE :: AE_RERACT_REF( : )

!     INTEGER, INTENT(OUT) :: NWL_OPTICS    ! # of wavelengths used in PHOT_MOD.F
      INTEGER :: NWL_OPTICS    ! # of wavelengths used in PHOT_MOD.F
      INTEGER :: IOST        ! IOST returned from OPEN function
      INTEGER :: JDATE = 0
      INTEGER :: OPTICS_UNIT
      INTEGER :: IPHOT, IPHOT_LOAD ! loop indices
      INTEGER :: ITT, ITT_LOAD     ! loop indices
      INTEGER :: IP_MAP, IP_REF    ! photolysis reaction indicies
      INTEGER :: IWL_LOAD
      INTEGER :: STRT, FINI

      INTEGER :: NAE_REFRACT_REF

      REAL,       ALLOCATABLE :: AE_IMAG_REFRACT( :, : )
      REAL,       ALLOCATABLE :: AE_REAL_REFRACT( :, : )
      REAL                    :: DELTA

      LOGICAL                  :: ERROR_FLAG = .FALSE.

!***external functions: none

      OPTICS_UNIT = GETEFILE( OPTICS_FILE, .TRUE., .TRUE., PNAME )


      READ( OPTICS_UNIT,'(A)' ) FILE_LINE

#ifdef verbose_phot
      write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif

      READ( FILE_LINE, 4999) NWL_REF
#ifdef verbose_phot
      write( LOGDEV,'(17x,i3)' ) nwl_ref
#endif

      NWL_OPTICS = NWL_REF

      DO ITT_LOAD = 1, 15 ! skip next 15 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif
      END DO

      ALLOCATE( CLD_BETA_REF    ( NWL_REF ), CLOUD_BETA_LWC( NWL_REF ) )
      ALLOCATE( CLD_COALBEDO_REF( NWL_REF ), CLOUD_COALBEDO( NWL_REF ) )
      ALLOCATE( CLD_G_REF       ( NWL_REF ), CLOUD_G       ( NWL_REF ) )

      IF( .NOT. ALLOCATED( STWL_REF   ) ) ALLOCATE( STWL_REF  ( NWL_REF ) )
      IF( .NOT. ALLOCATED( ENDWL_REF  ) ) ALLOCATE( ENDWL_REF ( NWL_REF ) )
      IF( .NOT. ALLOCATED( FSOLAR_REF ) ) ALLOCATE( FSOLAR_REF( NWL_REF ) )
      IF( .NOT. ALLOCATED( EFFWL_REF  ) ) ALLOCATE( EFFWL_REF ( NWL_REF ) )
      IF( .NOT. ALLOCATED( FEXT       ) ) ALLOCATE( FEXT      ( NWL_REF ) )
      IF( .NOT. ALLOCATED( WAVELENGTH ) ) ALLOCATE( WAVELENGTH( NWL_REF ) )

      DO IWL_LOAD = 1, NWL_REF
         READ( OPTICS_UNIT, * )IPHOT_LOAD,
     &   STWL_REF( IWL_LOAD ), EFFWL_REF( IWL_LOAD ), ENDWL_REF( IWL_LOAD ),
     &   CLD_BETA_REF( IWL_LOAD ), CLD_G_REF( IWL_LOAD ), CLD_COALBEDO_REF( IWL_LOAD )


#ifdef verbose_phot
         write( LOGDEV, 99946 )
     &   stwl_ref( iwl_load ), effwl_ref( iwl_load ), endwl_ref( iwl_load ),
     &   cld_beta_ref( iwl_load ), cld_g_ref( iwl_load ), cld_coalbedo_ref( iwl_load )
#endif

         WAVELENGTH( IWL_LOAD ) = EFFWL_REF ( IWL_LOAD )
         FEXT      ( IWL_LOAD ) = FSOLAR_REF( IWL_LOAD )

         CLOUD_BETA_LWC( IWL_LOAD ) = CLD_BETA_REF    ( IWL_LOAD )
         CLOUD_COALBEDO( IWL_LOAD ) = CLD_COALBEDO_REF( IWL_LOAD )
         CLOUD_G       ( IWL_LOAD ) = CLD_G_REF       ( IWL_LOAD )

      END DO

      DO ITT_LOAD = 1, 7 ! skip next 7 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif

      READ( FILE_LINE, 4999)NAE_REFRACT_REF

#ifdef verbose_phot
      write( LOGDEV, * )' NAE_REFRACT_REF = ', NAE_REFRACT_REF
#endif

      NUM_REFRACTIVE = NAE_REFRACT_REF
      
      ALLOCATE( AE_RERACT_REF   ( NAE_REFRACT_REF ) )

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE

#ifdef verbose_phot
      write( LOGDEV, '(a)')TRIM(FILE_LINE)
#endif

      STRT = SCAN(FILE_LINE, '=', BACK = .TRUE.) + 1
      FINI =  LEN(FILE_LINE)

      READ( FILE_LINE( STRT:FINI ), * )( AE_RERACT_REF( ITT_LOAD ),
     &                                   ITT_LOAD = 1, NAE_REFRACT_REF )

#ifdef verbose_phot
      write( LOGDEV, 99947)'REFRACTIVE_INDICES'
      write( LOGDEV, 99948 )(AE_RERACT_REF( ITT_LOAD ),ITT_LOAD = 1, 
     &                                 NAE_REFRACT_REF )
#endif


      ALLOCATE( AE_REAL_REFRACT ( NAE_REFRACT_REF, NWL_REF ) )
      ALLOCATE( AE_IMAG_REFRACT ( NAE_REFRACT_REF, NWL_REF ) )
      ALLOCATE( REFRACTIVE_INDEX( NAE_REFRACT_REF ) )

      DO ITT_LOAD = 1, NAE_REFRACT_REF
! set up refractive indices used by aero_photdata routine

          REFRACTIVE_INDEX( ITT_LOAD )%NAME = AE_RERACT_REF( ITT_LOAD )
          ALLOCATE( REFRACTIVE_INDEX( ITT_LOAD )%REAL_PART( N_MODE, NWL_REF ) )
          ALLOCATE( REFRACTIVE_INDEX( ITT_LOAD )%IMAG_PART( N_MODE, NWL_REF )  )

#ifdef verbose_phot
          write( LOGDEV, '(i3, 1x, a16)')itt_load, refractive_index( itt_load )%name
#endif

      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif

      DO IWL_LOAD = 1, NWL_REF
         READ( OPTICS_UNIT, * )iphot_load,
     &   STWL_REF( IWL_LOAD ), EFFWL_REF( IWL_LOAD ), ENDWL_REF( IWL_LOAD ),
     &   (AE_REAL_REFRACT( ITT_LOAD, IWL_LOAD ), AE_IMAG_REFRACT( ITT_LOAD, IWL_LOAD ),
     &    ITT_LOAD = 1, NAE_REFRACT_REF)

               DO ITT_LOAD = 1, NAE_REFRACT_REF
                  REFRACTIVE_INDEX( ITT_LOAD )%REAL_PART( 1:N_MODE, IWL_LOAD )
     &                                      = AE_REAL_REFRACT( ITT_LOAD, IWL_LOAD )
                  REFRACTIVE_INDEX( ITT_LOAD )%IMAG_PART( 1:N_MODE, IWL_LOAD )
     &                                      = AE_IMAG_REFRACT( ITT_LOAD, IWL_LOAD )
               END DO
#ifdef verbose_phot
         write( LOGDEV, 99949 )
     &          stwl_ref( iwl_load ), effwl_ref( iwl_load ),
     &          endwl_ref( iwl_load ),fsolar_ref( iwl_load ),
     &          ( ae_real_refract( itt_load, iwl_load ),
     &            ae_imag_refract( itt_load, iwl_load ), itt_load = 1, nae_refract_ref )
#endif

      END DO

      DO ITT_LOAD = 1, 8 ! skip next 8 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      END DO

! read optical data for liquid droplets

      READ( FILE_LINE, 4999)NRADIUS_LIQUID

#ifdef verbose_phot
      write( LOGDEV, '(a,i4)' )'NRADIUS_LIQUID = ',NRADIUS_LIQUID
#endif

      ALLOCATE(RADIUS_LIQUID( NRADIUS_LIQUID ))

      ALLOCATE( LIQUID_EXTINCT(NRADIUS_LIQUID, NWL_OPTICS),
     &         LIQUID_ASYMFACT(NRADIUS_LIQUID, NWL_OPTICS),
     &         LIQUID_COALBEDO(NRADIUS_LIQUID, NWL_OPTICS))

      QUANTITY = 'LIQ_EXT'

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      DO ITT_LOAD = 1, NRADIUS_LIQUID
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_EXTINCT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_EXTINCT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO


      QUANTITY = 'LIQ_ASY'

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      DO ITT_LOAD = 1, NRADIUS_LIQUID
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_ASYMFACT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_ASYMFACT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      QUANTITY = 'LIQ_COA'

      DO ITT_LOAD = 1, NRADIUS_LIQUID
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_COALBEDO( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_COALBEDO( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO


      DO ITT_LOAD = 1, 7 ! skip next 7 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      END DO

! read optical data for liquid droplets

      READ( FILE_LINE, 4999)NDIAMETER_ICE

#ifdef verbose_phot
      write( LOGDEV, '(a,i4)' )'NDIAMETER_ICE = ',NDIAMETER_ICE
#endif

      ALLOCATE(DIAMETER_ICE( NDIAMETER_ICE ))

      ALLOCATE( ICE_EXTINCT(NDIAMETER_ICE, NWL_OPTICS),
     &         ICE_ASYMFACT(NDIAMETER_ICE, NWL_OPTICS),
     &         ICE_COALBEDO(NDIAMETER_ICE, NWL_OPTICS),
     &            ICE_DELTRANS(NDIAMETER_ICE, NWL_OPTICS))

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      QUANTITY = 'ICE_EXT'

      DO ITT_LOAD = 1, NDIAMETER_ICE
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_EXTINCT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_EXTINCT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      QUANTITY = 'ICE_ASY'

      DO ITT_LOAD = 1, NDIAMETER_ICE
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_ASYMFACT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_ASYMFACT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      QUANTITY = 'ICE_COA'

      DO ITT_LOAD = 1, NDIAMETER_ICE
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_COALBEDO( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_COALBEDO( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      QUANTITY = 'ICE_DEL'

      DO ITT_LOAD = 1, NDIAMETER_ICE
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_DELTRANS( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_DELTRANS( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO

! Determine limit and frequencies of liquid and ice inputs
      MAXI_RADIUS_LIQUID = MAXVAL( RADIUS_LIQUID )
      MINI_RADIUS_LIQUID = MINVAL( RADIUS_LIQUID )

      DELTA = (RADIUS_LIQUID( 2 ) - RADIUS_LIQUID( 1 ))

      IF( DELTA  .LE. EPSILON )THEN
         WRITE( MSG, 99951)DELTA
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
      ELSE
         FREQ_RADIUS_LIQUID = 1.0 / DELTA
         INIT_RADIUS_LIQUID = MINI_RADIUS_LIQUID
     &                      - DELTA
      END IF

      MAXI_DIAMETER_ICE = MAXVAL( DIAMETER_ICE )
      MINI_DIAMETER_ICE = MINVAL( DIAMETER_ICE )

      DELTA = (DIAMETER_ICE( 2 ) - DIAMETER_ICE( 1 ))

      IF( DELTA  .LE. EPSILON )THEN
         WRITE( MSG, 99952)DELTA
         CALL M3WARN( PNAME, 0, 0, MSG )
         ERROR_FLAG = .TRUE.
      ELSE
         FREQ_DIAMETER_ICE = 1.0 / DELTA
         INIT_DIAMETER_ICE = MINI_DIAMETER_ICE
     &                     - DELTA
      END IF

!  read data for calculating surface albedo

      DO ITT_LOAD = 1, 6 ! skip next 6 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      END DO

      READ( OPTICS_UNIT,5013 ) NUMB_LANDUSE_REF

      DO ITT_LOAD = 1, 3 ! skip next 3 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      END DO

      READ( OPTICS_UNIT,5013 ) INDEX_GRASSLAND_REF
      READ( OPTICS_UNIT,5013 ) INDEX_OCEAN_REF
      READ( OPTICS_UNIT,5013 ) INDEX_SEA_ICE

#ifdef verbose_phot
      write( LOGDEV,6013 )'NUMB_LANDUSE_REF    = ', numb_landuse_ref
      write( LOGDEV,6013 )'INDEX_GRASSLAND_REF = ', index_grassland_ref
      write( LOGDEV,6013 )'INDEX_OCEAN_REF     = ', index_ocean_ref
      write( LOGDEV,6013 )'INDEX_SEA_ICE       = ', index_sea_ice
#endif

      ALLOCATE( LANDUSE_REF     ( NUMB_LANDUSE_REF ) )
      ALLOCATE( ZENITH_COEFF_REF( NUMB_LANDUSE_REF ) )
      ALLOCATE( SEASON_COEFF_REF( NUMB_LANDUSE_REF ) )
      ALLOCATE( SNOW_COEFF_REF  ( NUMB_LANDUSE_REF ) )
      ALLOCATE( SPECTRAL_ALBEDO_REF( NWL_OPTICS, NUMB_LANDUSE_REF ) )

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      DO ITT_LOAD = 1, NUMB_LANDUSE_REF
         READ( OPTICS_UNIT,5012 ) LANDUSE_REF( ITT_LOAD ),
     &                            ZENITH_COEFF_REF( ITT_LOAD ),
     &                            SEASON_COEFF_REF( ITT_LOAD ),
     &                            SNOW_COEFF_REF( ITT_LOAD )
#ifdef verbose_phot
         write( LOGDEV,5012 ) landuse_ref( itt_load ),
     &                          zenith_coeff_ref( itt_load ),
     &                          season_coeff_ref( itt_load ),
     &                          snow_coeff_ref( itt_load )
#endif
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      DO ITT_LOAD = 1, NUMB_LANDUSE_REF
         READ( OPTICS_UNIT,'(A30,1X,40(1PE13.6,2X))' ) LAND_EXPECT,
     &        ( SPECTRAL_ALBEDO_REF(IWL_LOAD, ITT_LOAD), IWL_LOAD = 1, NWL_REF )

#ifdef verbose_phot
         write( LOGDEV,'(a30,1x,40(1pe13.6,2x))' ) trim( land_expect ),
     &        ( spectral_albedo_ref(iwl_load, itt_load), iwl_load = 1, nwl_ref )
#endif

      END DO

      DO ITT_LOAD = 1, 3 ! skip next 3 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      END DO

      READ( OPTICS_UNIT,5013 ) NUMB_LANDUSE_NLCD50
      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line

#ifdef verbose_phot
      write( LOGDEV,6013 ) 'NUMB_NLCD50_MODIS = ', numb_landuse_NLCD50
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      ALLOCATE( LANDUSE_NLCD50( NUMB_LANDUSE_NLCD50 )  )
      ALLOCATE( ALBMAP_REF2NLCD50( NUMB_LANDUSE_NLCD50 )  )
      ALLOCATE( ALBFAC_REF2NLCD50( NUMB_LANDUSE_NLCD50 )  )

      DO ITT_LOAD = 1, NUMB_LANDUSE_NLCD50
         READ( OPTICS_UNIT,5016 ) LANDUSE_NLCD50( ITT_LOAD ),
     &                            ALBMAP_REF2NLCD50( ITT_LOAD ),
     &                            ALBFAC_REF2NLCD50( ITT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,6016 ) itt_load, landuse_NLCD50( itt_load ),
     &                          albmap_ref2NLCD50( itt_load ),
     &                          albfac_ref2NLCD50( itt_load )
#endif

      END DO

      READ( OPTICS_UNIT,5013 ) NUMB_LANDUSE_USGS
      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line
#ifdef verbose_phot
      write( LOGDEV,6013 ) 'NUMB_USGS = ', numb_landuse_usgs
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      ALLOCATE( LANDUSE_USGS   ( NUMB_LANDUSE_USGS ) )
      ALLOCATE( ALBMAP_REF2USGS( NUMB_LANDUSE_USGS ) )
      ALLOCATE( ALBFAC_REF2USGS( NUMB_LANDUSE_USGS ) )

      DO ITT_LOAD = 1, NUMB_LANDUSE_USGS
         READ( OPTICS_UNIT,5016 ) LANDUSE_USGS( ITT_LOAD ),
     &                            ALBMAP_REF2USGS( ITT_LOAD ),
     &                            ALBFAC_REF2USGS( ITT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,6016 ) itt_load, landuse_usgs( itt_load ),
     &                          albmap_ref2usgs( itt_load ),
     &                          albfac_ref2usgs( itt_load )
#endif

      END DO

      READ( OPTICS_UNIT,5013 ) NUMB_LANDUSE_MODIS
      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line
#ifdef verbose_phot
      write( LOGDEV,6013 ) 'NUMB_MODIS = ', numb_landuse_modis
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      ALLOCATE( LANDUSE_MODIS   ( NUMB_LANDUSE_MODIS ) )
      ALLOCATE( ALBMAP_REF2MODIS( NUMB_LANDUSE_MODIS ) )
      ALLOCATE( ALBFAC_REF2MODIS( NUMB_LANDUSE_MODIS ) )

      DO ITT_LOAD = 1, NUMB_LANDUSE_MODIS
         READ( OPTICS_UNIT,5016 ) LANDUSE_MODIS( ITT_LOAD ),
     &                            ALBMAP_REF2MODIS( ITT_LOAD ),
     &                            ALBFAC_REF2MODIS( ITT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,6016 ) itt_load, landuse_modis( itt_load ),
     &                          albmap_ref2modis( itt_load ),
     &                          albfac_ref2modis( itt_load )
#endif

      END DO

      NO_NLCD40 = .TRUE.  ! default condition that file does not contain NLCD40 Landuse data

      READ( OPTICS_UNIT,5013, END = 101 ) NUMB_LANDUSE_NLCD40
      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line
#ifdef verbose_phot
      write( LOGDEV,6013 ) 'NUMB_NLCD40_MODIS = ', numb_landuse_NLCD40
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      ALLOCATE( LANDUSE_NLCD40( NUMB_LANDUSE_NLCD40 )  )
      ALLOCATE( ALBMAP_REF2NLCD40( NUMB_LANDUSE_NLCD40 )  )
      ALLOCATE( ALBFAC_REF2NLCD40( NUMB_LANDUSE_NLCD40 )  )

      DO ITT_LOAD = 1, NUMB_LANDUSE_NLCD40
         READ( OPTICS_UNIT,5016 ) LANDUSE_NLCD40( ITT_LOAD ),
     &                            ALBMAP_REF2NLCD40( ITT_LOAD ),
     &                            ALBFAC_REF2NLCD40( ITT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,6016 ) itt_load, landuse_NLCD40( itt_load ),
     &                          albmap_ref2NLCD40( itt_load ),
     &                          albfac_ref2NLCD40( itt_load )
#endif

      END DO

      NO_NLCD40 = .FALSE.

101   IF( NO_NLCD40 )THEN
          MSG = TRIM( PNAME ) // ':'
     &       // TRIM( OPTICS_FILE )
     &       // ' does not contain data for NLCD40 land use and'
     &       // ' corresponds to CMAQ version 5.01.'
          CALL M3MESG( MSG )
      END IF

! set the default values for surface albedo
      ALLOCATE( ALB( NWL_OPTICS ) )

      DO IWL_LOAD = 1, NWL_OPTICS
         IF ( WAVELENGTH( IWL_LOAD ) .LE. 380.1 ) THEN
            ALB( IWL_LOAD ) = 0.05
         ELSE
            ALB( IWL_LOAD ) = 0.10
         END IF
      END DO



      IF( ERROR_FLAG )THEN
         MSG = 'The above fatal error(s) found in CSQY data! '
         CALL M3EXIT( PNAME, 0, 0, MSG, -1 )
      END IF


      CLOSE(OPTICS_UNIT)

4999  FORMAT(17X,I3,2X,17X,I3)
5012  FORMAT( 4X,A30,1X,3(F8.3,2X) )
5013  FORMAT( 22X,I3 )
5016  FORMAT( 4X,A60,1X,I3,2X,3(F8.3,2X) )
99946 FORMAT(4x,3(f8.3,2x),2x,2(es12.4,2x),f8.3,2x,12(es12.4,2x))
99947 FORMAT(a3, 1x, a16)
99948 FORMAT(10(a16,1x))
99949 FORMAT(4x,3(f8.3,2x),2x,2(es12.4,2x),f8.3,2x,12(es12.4,2x))
99950 FORMAT(a8,1x,f10.3,40(1x,1pe13.6))
99951 FORMAT('Too Small Differences in Liquid Droplet Radii = ',1PE12.4,' um ')
99952 FORMAT('Too Small Differences in Ice Particle Sizes   = ',1PE12.4,' um ')
#ifdef verbose_phot
6009  format( a3,', ',8(a,', ') )
6013  format( a22,1x,i3 )
6016  format( i3,1x,a60,1x,i3,2x,3(f8.3,2x) )
#endif

      RETURN
      END SUBROUTINE LOAD_OPTICS_DATA

C///////////////////////////////////////////////////////////////////////
       INTEGER FUNCTION INDEXR ( NAME1, N, NAME2 )
C-----------------------------------------------------------------------
C
C  FUNCTION:
C     This routine searches for NAME1 in list NAME2
C
C  REVISION HISTORY:
C     5/88   Modified for ROMNET
C     July 29, 2005 by FSB
C     Changed name to avoid conflict FSB
C     copied from CMAQ routine INDEX2 to allow internal use
C
C  ARGUMENT LIST DESCRIPTION:
C
C  Input arguments:
C     NAME1       Character string being searched for
C     N           Length of array to be searched
C     NAME2       Character array to be searched
C
C  Output arguments:
C     INDEX1      The position within the NAME2 array that NAME1
C                 found.  If string was not found, INDEX1 = 0
C
C  LOCAL VARIABLE DESCRIPTION:
C     None
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: N

      CHARACTER*(*), INTENT(IN) :: NAME1
      CHARACTER*(*), INTENT(IN) :: NAME2(*)

      INTEGER I

!***Assume NAME1 is not in list NAME2

      INDEXR = 0

      DO I = 1, N
         IF ( INDEX( NAME2( I ), NAME1 ) .EQ. 1 ) THEN
            INDEXR = I
            RETURN
         END IF
      END DO

      RETURN
      END FUNCTION INDEXR
      SUBROUTINE GET_CSQY ( TEMP, DENS, CSZ, QYZ )
!-----------------------------------------------------------------------
!  Purpose: Calculate values of absorption cross
!     section and quantum yield, given, temperature and air
!     pressure and density.
!
!  reference for acetone:
!     Cameron-Smith, Philip J., Incorporating non_linear computation
!     code (Fast-J), Journal of Atmospheric Chemistry, Vol. 37,
!     pp 283-297, 2000)
!
!  Mar 2011: Bill Hutzell
!     - revised interpolation method for a general number of
!     interpolation points
!     - revised density corrections for specific photolysis reactions
!  Apr 2014: Bill Hutzell
!     -revised method to determine what density corrections for a
!      specific photolysis reactions from name select to index selection
!     -revision agrument an variable names to use data available in CSQY_DATA
!      and GRID_CONF modules
!  Sept 2014: Bill Hutzell
!     -revised fortrans looping constructs attempting to improve computational
!      efficiency
!     -corrected several density or pressure adjustment for quantum yield based on
!      re-consulting source and cited references
!-----------------------------------------------------------------------

      USE GRID_CONF           ! horizontal & vertical domain specifications

      IMPLICIT NONE

!***Arguments


      REAL, INTENT(IN)  :: TEMP( : )      ! air temperature [K]
      REAL, INTENT(IN)  :: DENS( : )      ! air density [molecules/cm**3]
      REAL, INTENT(OUT) :: CSZ( :, :, : ) ! abs cross sections
      REAL, INTENT(OUT) :: QYZ( :, :, : ) ! quantum yields

!***Internal:

      INTEGER  :: IT, IWL, LAYS, IPHOT
      REAL     :: XTEMP            ! local temperature
      REAL     :: YTEMP            ! temperature difference ratio

      REAL,    ALLOCATABLE, SAVE :: DELTA_REFT( :, : )
      INTEGER, ALLOCATABLE, SAVE :: ITEMP( :, : )

      REAL, PARAMETER :: TTX1 = 235.0
      REAL, PARAMETER :: TTX2 = 298.0
      REAL, PARAMETER :: DTTX = TTX2 - TTX1

      REAL            :: PRESSURE          ! units vary
      REAL            :: FACTOR            ! scratch variable for yield
      REAL            :: ALPHA, BETA       ! scratch variables
      REAL            :: PHI_CO            ! CO channel of acetone QYZ
      REAL            :: PHI_CH3CO         ! CH3CO channel of acetone QYZ

      LOGICAL, SAVE   :: FIRSTCALL = .TRUE.

      IF ( FIRSTCALL ) THEN
          ALLOCATE( ITEMP( NLAYS, MECHANISM_RATES ) )
          ALLOCATE( DELTA_REFT( (IREFTEMPS - 1), MECHANISM_RATES ) )
          DO IT = 1, IREFTEMPS - 1
             DO IPHOT = 1, MECHANISM_RATES
                DELTA_REFT( IT, IPHOT ) = RTEMP_S( IT + 1, IPHOT ) -  RTEMP_S( IT, IPHOT )
             END DO
          END DO
          CALL DEFINE_CSQY_ADJUST()
          FIRSTCALL = .FALSE.
      END IF

!***determine and save where layer temperatures fall within range of CS and QY data
      DO IPHOT = 1, MECHANISM_RATES
         DO LAYS = 1, NLAYS
             IF ( TEMP( LAYS ) .LE. RTEMP_S( 1, IPHOT ) )  THEN
                ITEMP( LAYS, IPHOT ) = 0
             ELSE IF ( TEMP( LAYS ) .GE. RTEMP_S( IREFTEMPS, IPHOT ) ) THEN
                ITEMP( LAYS, IPHOT ) = IREFTEMPS
             ELSE
                 LOOP_FINDT: DO IT = 1, IREFTEMPS - 1
                    IF ( TEMP( LAYS ) .GT. RTEMP_S( IT, IPHOT ) .AND. TEMP( LAYS ) .LE. RTEMP_S( IT + 1, IPHOT ) ) THEN
                       ITEMP( LAYS, IPHOT ) = IT
                       EXIT LOOP_FINDT
                    END IF
                 END DO LOOP_FINDT
            END IF
         END DO
      END DO


      CSZ = 0.0
      QYZ = 1.0
!***loop over rates for temperature corrections
      DO IPHOT = 1, MECHANISM_RATES
!***loop over wavelengths
        DO IWL = 1, NWL_REF
!***Loop over layers:
           DO LAYS = 1, NLAYS
!***fetch temperature data
               XTEMP = TEMP( LAYS )
               IT    = ITEMP( LAYS, IPHOT )

               IF ( IT .EQ. 0 ) THEN
!***if the ambient temperature is cooler than the minimum
!***  reference temperature, then use the value at the minimum reference temperature
                  CSZ( LAYS, IWL, IPHOT ) = XXCS( IT+1, IWL, IPHOT )
                  QYZ( LAYS, IWL, IPHOT ) = XXQY( IT+1, IWL, IPHOT )
               ELSE IF ( IT .GE. 1 .AND. IT .LT. IREFTEMPS ) THEN
!***for the next case use linear interpolation
                  YTEMP = ( XTEMP - RTEMP_S( IT, IPHOT ) )
     &                  /   DELTA_REFT( IT, IPHOT )

                  CSZ( LAYS, IWL, IPHOT ) =   XXCS(   IT, IWL, IPHOT )
     &                                    + ( XXCS( IT+1, IWL, IPHOT )
     &                                      - XXCS(   IT, IWL, IPHOT ) )
     &                                    * YTEMP
                  QYZ( LAYS, IWL, IPHOT ) =   XXQY(   IT, IWL, IPHOT )
     &                                    + ( XXQY( IT+1, IWL, IPHOT )
     &                                      - XXQY(   IT, IWL, IPHOT ) )
     &                                    * YTEMP
               ELSE
!***if the ambient temperature is warmer than the maximum
!***  reference temperature, then use the value at the maximum reference temperature
                  CSZ( LAYS, IWL, IPHOT ) = XXCS( IT, IWL, IPHOT )
                  QYZ( LAYS, IWL, IPHOT ) = XXQY( IT, IWL, IPHOT )
               END IF
           END DO
        END DO
      END DO

!***Make specific temperature and/or density corrections if needed
!***Note specific acetone channels are treated outside these three nested loops
      DO IPHOT = 1, MECHANISM_RATES

        IF( CSQY_ADJUST( IPHOT ) .LT. 1 )CYCLE

        SELECT CASE (  CSQY_ADJUST( IPHOT ) )
           CASE ( ACETALDEHYDE )      ! 'CH3CHO -> CH3 + HCO'
               FORALL( IWL = 1:NWL_REF )
                  FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 )
                     QYZ( LAYS, IWL, IPHOT ) = 1.0
     &                                       / ( 1.0 + ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - 1.0 ) * DENS( LAYS ) * 4.0568E-20 )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                  END FORALL
               END FORALL
           CASE( CH3CHO_IUPAC2013 ) ! IUPAC 2013 correction for acetaldehyde
! density correction to quantum yield recommended in
! http://iupac.pole-ether.fr/htdocs/datasheets/pdf/P2_CH3CHO+hv.pdf dated June 2013
! and based on
! Warneck, P. and Moortgat, G.K. (2012). Quantum yields and photodissociation coefficients of
! acetaldehyde in the troposphere, Atmos. Environ., 62, 153-163.
               FORALL( IWL = 1:NWL_REF )
                  FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 )
                     QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT )
     &                                       * IPHIS_CH3CHO( IWL )
     &                                       / ( IPHI0_CH3CHO( IWL ) + KCH3CHO( IWL ) * DENS( LAYS ) )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                  END FORALL
               END FORALL
!      IF ( FIRSTCALL )THEN
!             DO LAYS = 1, NLAYS
!                WRITE(LOGDEV, 99951)'DENS, CH3CHO_IUPAC2013 QYZ factor =  ', ' ',DENS( LAYS ),
!     &          (IPHIS_CH3CHO( IWL )/( IPHI0_CH3CHO( IWL ) + KCH3CHO( IWL ) * DENS( LAYS ) ),IWL=1,NWL_REF)
!             END DO
!      END IF
           CASE ( HIGHER_ALDEHYDES )  ! C3 and some higher aldehydes
!***density correction to quantum yield
               FORALL( IWL = 1:NWL_REF )
                  FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 )
                     QYZ( LAYS, IWL, IPHOT ) = 1.0
     &                                       / ( 1.0 + ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - 1.0 ) * DENS( LAYS ) * 4.0568E-20 )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                  END FORALL
               END FORALL
           CASE( NBUTYRALDEHYDE ) ! both photolysis channels for n-C3H7CHO
! based on recommendation in
! IUPAC Recommendation
! http://iupac.pole-ether.fr/htdocs/datasheets/pdf/P11_nC3H7CHO+hv.pdf dated 2002
               FORALL( IWL = 1:NWL_REF )
                  FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 )
                     QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT )
     &                                       * ( 1.81 + 4.919E-3 * TEMP( LAYS ) )
     &                                       / ( 1.81 + 2.000E-22 * DENS( LAYS ) * TEMP( LAYS ) )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                  END FORALL
               END FORALL
           CASE ( METHYL_VINYL_KETONE )
!***quantum yield from
!***  Gierczak, T., J. B. Burkholder, R. K. Talukdar, A. Mellouki, S. B. Barone,
!***  and A. R. Ravishankara, Atmospheric fate of methyl vinyl ketone and methacrolein,
!***  J. Photochem. Photobiol A: Chemistry, 110 1-10, 1997.
!***  depends on pressure and wavelength, set upper limit to 1.0
!***  However, chamber evaluations for SAPRC07T require a pressure correction where
!***  number density coefficient is five times higher.
!***density correction to quantum yield
!***remove wavelength dependence
              FORALL( LAYS = 1:NLAYS, IWL = 1:NWL_REF )
                     QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT ) *  118.4
     &                                       / ( 5.5 + 4.6E-19 * DENS( LAYS ) )
                     QYZ( LAYS, IWL, IPHOT ) = MAX(0.0, MIN( QYZ( LAYS, IWL, IPHOT ), 1.0 ) )
              END FORALL
           CASE ( METHYL_ACROLEIN )
!***quantum yield based on 2.76 times MVK from
!***  Gierczak, T., J. B. Burkholder, R. K. Talukdar, A. Mellouki, S. B. Barone,
!***  and A. R. Ravishankara, Atmospheric fate of methyl vinyl ketone and methacrolein,
!***  J. Photochem. Photobiol A: Chemistry, 110 1-10, 1997.
!***  depends on pressure and wavelength, set upper limit to 1.0
!***  However, chamber evaluations for SAPRC07T require a pressure correction where
!***  number density coefficient is five times higher.
!***density correction to quantum yield
!***remove wavelength dependence
              FORALL( LAYS = 1:NLAYS, IWL = 1:NWL_REF )
                 QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT ) * 118.4
     &                                   / ( 5.5 + 4.6E-19 * DENS( LAYS ) )
                 QYZ( LAYS, IWL, IPHOT ) = MAX(0.0, MIN( QYZ( LAYS, IWL, IPHOT ), 1.0 ) )
              END FORALL
           CASE ( METHYL_ETHYL_KETONE )
!***Quantum Yields from
!***  Raber, W.H. (1992) PhD Thesis, Johannes Gutenberg-Universitaet, Mainz, Germany.
!***  other channels assumed negligible (less than 10%).
!***  Total quantum yield  = 0.38 at 760 Torr.
!***  Ttemperature/Density correction to quantum yield in
!***  Stern-Volmer form :  1/phi = 0.96 + 2.22e-3*P(torr)
!***  Using relative correction to quantum yields based on above formula
               FORALL( IWL = 1:NWL_REF )
                   FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 0.0 )
! skips SAPRC07T cases where qy is set to one and photolysis rate is scaled in mech.def
!***  Carter adjusted to 0.175 based on chamber tests and sets the values in
!***  mechanism definition file. The photolysis data submitted for SAPRC07T sets this
!***  quantum yield to one.
!                     IF( QYZ( LAYS, IWL, IPHOT ) .GE.  1.0 )THEN
!                          CYCLE
!                     END IF
!                     PRESSURE = ( 1.03547E-19 * DENS( LAYS ) * TEMP( LAYS ) ) ! TORR
!                     IF ( PRESSURE  .LT. 18.02 ) THEN
!                        QYZ( LAYS, IWL, IPHOT ) =  1.0
!                     ELSE
!                        QYZ( LAYS, IWL, IPHOT ) =  1.0 / ( 0.96 + 2.22E-3 * PRESSURE )
!                     END IF
                     QYZ( LAYS, IWL, IPHOT ) =  QYZ( LAYS, IWL, IPHOT )
     &                                       * ( 0.96 + 5.66639E-03 * TEMP( LAYS ) )
     &                                       / ( 0.96 + 2.29874E-22 * DENS( LAYS ) * TEMP( LAYS ) )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                   END FORALL
               END FORALL
           CASE ( BIACETYL )
! Biacetyl quantum yield (CH3CO + CH3CO) = 0.158 for wavelength less than 460 nm
! Pressure correction based on phi(z=infi) and ph(z=0) values based on
! http://iupac.pole-ether.fr/htdocs/datasheets/pdf/P23_Biacetyl+hv.pdf dated 2011
! by solving the below for kq
! phi(z=infi)/ph(z=0) = (0.76/0.16) = 1.0 + kq*Temp(z=0)*Number_Density(z=0)
! where Temp(z=0) = 298.15K and Number_Density(z=0) = 2.46E19 molecules/cm3
               FORALL( IWL = 1:NWL_REF )
                   FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 0.0 )
                     QYZ( LAYS, IWL, IPHOT ) =  QYZ( LAYS, IWL, IPHOT )
     &                                       * ( 1.0 + 1.37662E-02 * TEMP( LAYS ) )
     &                                       / ( 1.0 + 5.19481E-22 * DENS( LAYS ) * TEMP( LAYS ) )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                   END FORALL
               END FORALL
           CASE ( METHYL_GLYOXAL_IUPAC04 )
               DO IWL = 1, NWL_REF
                   IF( WAVELENGTH( IWL ) .GE. 500.0 .OR. WAVELENGTH( IWL ) .LE. 240.0 )CYCLE
                   DO LAYS = 1, NLAYS
                        IF( QYZ( LAYS, IWL, IPHOT ) .LE. 0.0 )CYCLE
! Replaced the following method used in CMAQ 5.01
!***  Pressure dependence based on Koch and Moortgat (1998),
!***  J. Phys. Chem. A, vol 102, pages 9142. The application contradicts
!***  NASA (2006) & IUPAC (2005) and is used based recommendations for
!***  SAPRC07T photolysis rates by William Carter (2009)
!                       PRESSURE = MIN( 472.0, 1.03547E-19 * DENS( LAYS ) * TEMP( LAYS )  ) ! in TORRs
!***remove wavelength dependence
!                       QYZ( LAYS, IWL, IPHOT ) = 6.4192E10 ! 1.36E8 * ( 472.0 )
!     &                                         / ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - 1.0 )
!                       QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT )
!     &                                         / ( QYZ( LAYS, IWL, IPHOT ) + 1.36E8 * PRESSURE )
! by using the relative correction recommended in NASA JPL (2011).  Note that linearily interpolated
! values are assumed to be at air number density equal to 2.465E19 molecules/cm3. Pressure units are Torrs.
! New correction is based on recommendation in
! http://iupac.pole-ether.fr/htdocs/datasheets/pdf/P6_CH3COCHO+hv.pdf dated 2003
! but places lower limit on pressure of 4 Torrs based on source of recommendation:
!     Y. Chen, W. Wang and L. Zhu, J. Phys. Chem. A, 104 11126 (2000).
                       PRESSURE = 1.03547E-19 * TEMP( LAYS ) * DENS( LAYS )
                       FACTOR   = 2.5524 * TEMP( LAYS ) ! pressure for dens at 2.465e19 molec/cm3
                       IF( WAVELENGTH( IWL ) .LE. 370.0 )THEN
                           PRESSURE = MAX( 400.0, PRESSURE )
                           FACTOR   = MAX( 400.0, FACTOR   )
                       END IF
                       QYZ( LAYS, IWL, IPHOT ) =  QYZ( LAYS, IWL, IPHOT )
     &                                         * ( IPHI0_MGLY( IWL ) + KMGLY( IWL ) * FACTOR )
     &                                         / ( IPHI0_MGLY( IWL ) + KMGLY( IWL ) * PRESSURE )
                       QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                   END DO
               END DO
           CASE (  ACROLEIN )
!***density correction quantum yield
               DO IWL = 1, NWL_REF
                   DO LAYS = 1, NLAYS
!***Number density dependence based on Gardner et. al (1987),
!***  J. Phys. Chem., vol 91, pages 1922. The application uses
!***  the quantum yields set in in cross-section file.
!***  For SAPRC07T CSQY data, yields set approximately four times NASA (2006)
!***  because the mechanism developer sums over all possible channels and
!***  Gardner et. al may support this conclusion.
                     IF ( DENS( LAYS ) .GE. 8.0E+17 ) THEN
                        QYZ( LAYS, IWL, IPHOT ) = 153.5 * QYZ( LAYS, IWL, IPHOT )
     &                                          * ( 4.0E-3 + 1.0 / ( 8.6E-2 + 1.613E-17 * DENS( LAYS ) ) )
                     ELSE IF ( DENS( LAYS ) .LT. 8.0E+17 ) THEN
                        QYZ( LAYS, IWL, IPHOT ) = 12.431 * QYZ( LAYS, IWL, IPHOT )
                     END IF

                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                   END DO
               END DO
           CASE ( FORMALDEHYDE_MOLECULAR )  ! 'CH2O -> H2 + CO'
!***temperature/density correction to quantum yield
! based on
! Sander, S. P., Friedl, R. R., Abbatt, J. P. D., Barker, J. R.,
! Burkholder, J. B., Golden, D. M., Kolb, C. E., Kurylo, M. J.,
! Moortgat, G. K., Wine, P. H., Huie, R. E., and Orkin, V. L.:
! Chemical kinetics and photochemical data for use in atmospheric
! studies. Evaluation number 17, JPL-Publication 10-6, Pasadena,
! 2011.
              IF ( LHCHOR_06 .LE. 0 )CYCLE
              DO IWL = 1, NWL_REF
                 IF ( WAVELENGTH( IWL ) .LE. 329.0 ) CYCLE
                 DO LAYS = 1, NLAYS
                    IF ( QYZ( LAYS, IWL, IPHOT ) .LE. 0.0 ) CYCLE

                    IF( QYZ( LAYS, IWL, LHCHOR_06 ) .GT. 0.9999999 )THEN
                        WRITE(6,*)"QYZ( LAYS, IWL, LHCHOR_06 ) = ",QYZ( LAYS, IWL, LHCHOR_06 ) 
                        CALL M3EXIT( 'GET_CSQY', 0, 0, 'CHECK master log for information', -1 )
                    END IF
                         
                    BETA = 1.0 / ( 1.0 - QYZ( LAYS, IWL, LHCHOR_06 ) )
                    IF ( TEMP( LAYS ) .LT. 300.0 .AND. TEMP( LAYS ) .GT. 220.0 ) THEN
                        PRESSURE = 1.36312E-22  * DENS( LAYS ) * TEMP( LAYS )   ! pressure units, atm
                        ALPHA = ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - BETA )
     &                        * ( 1.0 + 0.05 * ( WAVELENGTH( IWL ) - 329.0 )
     &                        * ( ( TEMP( LAYS ) - 80.0 ) * 0.0125 ) )
                    ELSE IF ( TEMP( LAYS ) .LE. 220.0 ) THEN
                        PRESSURE = 3.0E-20 * DENS( LAYS )
                        ALPHA = ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - BETA )
     &                        * ( 1.0 + 0.0875 * ( WAVELENGTH( IWL ) - 329.0 ) )
                    ELSE IF ( TEMP( LAYS ) .GE. 300.0 ) THEN
                        PRESSURE = 4.09E-20 * DENS( LAYS )
                        ALPHA = ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - BETA )
     &                        * ( 1.0 + 0.1375 * ( WAVELENGTH( IWL ) - 329.0 ) )
                    END IF
!***use relative change assuming that air density for interpolated value is 2.465e19 molecules/cm3
                    QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT )
     &                                      * ( BETA + 3.3601E-3 * TEMP( LAYS ) * ALPHA ) 
     &                                      / ( BETA + PRESSURE * ALPHA )                    
!      IF ( FIRSTCALL )THEN 
!                WRITE(LOGDEV, 99951)'TEMP, DENS, HCHO_M QYZ factor =  ', ' ',TEMP( LAYS ), DENS( LAYS ),
!     &          ( BETA + 3.3601E-3 * TEMP( LAYS ) * ALPHA )/( BETA + PRESSURE * ALPHA )
!      END IF

                    QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                 END DO
              END DO
           CASE (  ACETONE ) ! 'CH3COCH3 -> products' total quantum yield
!***temperature/density correction to quantum yield
              IF ( IPHOT .EQ. LACETONE ) THEN
!***OPTT is the effective cross section ( Cs * QY )
!***This is an implementation of eq(21) of Cameron-Smith (2000)
!***special information for acetone. Reference:
!***  Cameron-Smith, P., Incorporation of non-linear effective cross section
!***  parameterization into a fast photolysis computation  code (Fast-J)
!***  Journal of Atmospheric Chemistry, Vol. 37, pp 283-297, 2000.
                 FORALL( LAYS = 1:NLAYS, IWL = 1:NWL_REF )
                       CSZ( LAYS, IWL, LACETONE ) = ( ( TTX2 - TEMP( LAYS ) ) * OP0( 1, IWL )
     &                                            + ( TEMP( LAYS ) - TTX1 ) * OP0( 2, IWL ) )
     &                                            / ( DTTX * ( 1.0 + YY30( IWL ) * DENS( LAYS ) ) )
                       QYZ( LAYS, IWL, LACETONE ) = 1.0
                 END FORALL
             ELSE ! approximate relative correction based on effective wavelengths
                 DO IWL = 1, NWL_REF
                      DO LAYS = 1, NLAYS
                        QYZ( LAYS, IWL, IPHOT ) = RQUANTUM_ACETONE( TEMP( LAYS ), DENS( LAYS ), IWL )
     &                                          * QYZ( LAYS, IWL, IPHOT )
                        QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                   END DO
                END DO
             END IF
         CASE (  ACETONE_CH3CO  )
             DO IWL = 1, NWL_REF
                DO LAYS = 1, NLAYS
                   QYZ( LAYS, IWL, IPHOT ) = RQY_ACETONE_CH3CO( TEMP( LAYS ), DENS( LAYS ), IWL )
     &                                     * QYZ( LAYS, IWL, IPHOT )
                   QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                END DO
             END DO
         CASE( GLYOXAL_IUPAC_2013 )
             DO IWL = 1, NWL_REF
                DO LAYS = 1, NLAYS
                   QYZ( LAYS, IWL, IPHOT ) = RQY_GLYOXAL( TEMP( LAYS ), DENS( LAYS ), IWL )
     &                                     * QYZ( LAYS, IWL, IPHOT )
                   QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                END DO
             END DO
         CASE (  KETONE_LEGACY  )
             FORALL( LAYS = 1:NLAYS, IWL = 1:NWL_REF )
                 CSZ( LAYS, IWL, IPHOT ) = CSZ( LAYS, IWL, IPHOT ) / ( 1.0 + 0.80E-19 * DENS( LAYS ) )
             END FORALL
         CASE ( KETONE_RACM2 ) ! Ketone treatement from W. Stockwell sbox
             FORALL( IWL = 1:NWL_REF )
                FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 .AND. QYZ( LAYS, IWL, IPHOT ) .LT. 0.9999 )
                   QYZ( LAYS, IWL, IPHOT ) =  1.0
     &                                     / (1.0 + 4.057E-20 * DENS( LAYS ) * ( 1.0 / QYZ(LAYS, IWL, IPHOT ) - 1.0 ))
                   QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                END FORALL
             END FORALL
         CASE ( GLYOXAL_RACM2  ) ! glyoxal treatement from W. Stockwell sbox
             FORALL( IWL = 1:NWL_REF )
                FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 .AND. QYZ( LAYS, IWL, IPHOT ) .LT. 0.9999 )
                   QYZ( LAYS, IWL, IPHOT ) =  1.0
     &                                     / ( 1.0 + 4.057E-20 * DENS( LAYS ) * ( 1.0 / QYZ(LAYS, IWL, IPHOT ) - 1.0 ))
                   QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                END FORALL
             END FORALL
         CASE (  METHYL_GLYOXAL_LEGACY )
             FORALL( LAYS = 1:NLAYS, IWL = 1:NWL_REF )
                   CSZ( LAYS, IWL, IPHOT ) = CSZ( LAYS, IWL, IPHOT ) / ( 1.0 + 1.67E-19 * DENS( LAYS ) )
             END FORALL
         END SELECT

      END DO   ! loop on IPHOT


!      IF ( FIRSTCALL )THEN
!          DO IPHOT = 1, MECHANISM_RATES
!             DO LAYS = 1, NLAYS
!                WRITE(LOGDEV, 99951)'CSZ for ', PHOTOLYSIS_RATE( IPHOT ),(CSZ( LAYS, IWL, IPHOT ),IWL=1,NWL_REF)
!                WRITE(LOGDEV, 99951)'QYZ for ', PHOTOLYSIS_RATE( IPHOT ),(QYZ( LAYS, IWL, IPHOT ),IWL=1,NWL_REF)
!             END DO
!          END DO
!          FIRSTCALL = .FALSE.
!      END IF

99951 FORMAT(A,A16,40(1X,ES12.4))
      RETURN
      END SUBROUTINE GET_CSQY
      SUBROUTINE DEFINE_CSQY_ADJUST()
! Purpose determine whether a photolysis rate uses specific corrections to
! CSQY data
!          Apr  2014 B.Hutzell Initial version
!          Sept 2014 B.Hutzell corrected acetaldehyde case to include CCHO_R_SAPRC99,
!                    the photolysis rate used in original CB05 mechanism

               IMPLICIT NONE

               INTEGER :: IPHOT, IWL

               REAL( 8 ) :: ILAMBDA

               ALLOCATE( CSQY_ADJUST( MECHANISM_RATES ) )

               DO IPHOT = 1, MECHANISM_RATES
                  SELECT CASE ( TRIM( PHOTOLYSIS_RATE( IPHOT ) ) )
                     CASE ( 'CCHO_R', 'CCHO_R_SAPRC99', 'CH3CHO_RACM2', 'ALD2_R_IUPAC10',
     &                      'ALD2_R_IUPAC13' )                                             ! 'CH3CHO -> CH3 + HCO'
                        CSQY_ADJUST( IPHOT ) = ACETALDEHYDE
                     CASE ( 'CCHO_R1_MCMv32', 'CCHO_R2_MCMv32' )      ! 'CH3CHO -> CH3 + HCO'
                        CSQY_ADJUST( IPHOT ) = CH3CHO_IUPAC2013
                        IF( .NOT. ALLOCATED( KCH3CHO ) ) ALLOCATE( KCH3CHO( NWL_REF ) )
                        IF( .NOT. ALLOCATED( IPHI0_CH3CHO ) ) ALLOCATE( IPHI0_CH3CHO( NWL_REF ) )
                        IF( .NOT. ALLOCATED( IPHIS_CH3CHO ) ) ALLOCATE( IPHIS_CH3CHO( NWL_REF ) )
                        DO IWL = 1, NWL_REF
                           IF(  WAVELENGTH( IWL ) .LE. 608.0 )THEN
                             ILAMBDA = REAL( 1.0D0 / WAVELENGTH( IWL ), 8 )
                             KCH3CHO( IWL )   = REAL( 1.0D-21
     &                                        * (1.04D27*EXP(-1.792D4*ILAMBDA) + 1.48D6*EXP(-3.211D3*ILAMBDA)))
                             IPHI0_CH3CHO( IWL ) = 1.0 + EXP( 0.2627801*(  WAVELENGTH( IWL ) - 320.56 ) )
                             IPHIS_CH3CHO( IWL ) = IPHI0_CH3CHO( IWL ) + 2.465E19 *  KCH3CHO( IWL )
                           ELSE ! use values for wavelength equals 608 nm
                             KCH3CHO( IWL )      = 1.64731E-07
                             IPHI0_CH3CHO( IWL ) = 5.50947E+32
                             IPHIS_CH3CHO( IWL ) = 5.50946E+32
                           END IF                               
!                WRITE(LOGDEV, 99951)'DENS, CH3CHO_IUPAC2013 QYZ factor =  ', ' ',2.465E19,
!     &          IPHIS_CH3CHO( IWL ),IPHI0_CH3CHO( IWL ),KCH3CHO( IWL )
                        END DO
                     CASE ( 'NC3CHO_R_MCMv32', 'NC3CHO_M_MCMv32' ) ! n-C3H7CHO (n-butyraldehyde, n-butanal)
                        CSQY_ADJUST( IPHOT ) = NBUTYRALDEHYDE
                     CASE ( 'C2CHO', 'ALD_RACM2', 'BALD_RACM2', 'UALD_RACM2', 'ALDX_R_IUPAC10', 'ALDX_R_IUPAC13'  )  ! C3 and higher aldehydes
                        CSQY_ADJUST( IPHOT ) = HIGHER_ALDEHYDES
                     CASE ( 'MVK_06' )
                        CSQY_ADJUST( IPHOT ) = METHYL_VINYL_KETONE
                     CASE ( 'MACR_06', 'MACR_RACM2', 'MACR_MCMv32' )
                        CSQY_ADJUST( IPHOT ) = METHYL_ACROLEIN
                     CASE ( 'MEK_06', 'MEK_MCMv32' )
                        CSQY_ADJUST( IPHOT ) = METHYL_ETHYL_KETONE
                     CASE ( 'MGLY_06' , 'BACL_07', 'MGLY_IUPAC04', 'MGLY_IUPAC10' )
                        CSQY_ADJUST( IPHOT ) = METHYL_GLYOXAL_IUPAC04
                        IF( .NOT. ALLOCATED( KMGLY ) ) ALLOCATE( KMGLY( NWL_REF ) )
                        IF( .NOT. ALLOCATED( IPHI0_MGLY ) ) ALLOCATE( IPHI0_MGLY( NWL_REF ) )
                        WHERE( WAVELENGTH .LT. 380.41 )
                            IPHI0_MGLY = 1.0
                            KMGLY      = 7.08021E-03
                        ELSE WHERE ! maximum value correspond to wavelength = 711.8954 nm
                            IPHI0_MGLY =  MAX( 2.755E+06 * EXP( -5639.0 / WAVELENGTH ), 1.0E+03 )
                            KMGLY       = MAX(  1.93E+04 * EXP( -5639.0 / WAVELENGTH ), 7.00590 )
                        END WHERE
                     CASE (  'ACRO_09' )
                        CSQY_ADJUST( IPHOT ) = ACROLEIN
                     CASE (  'BIACET_MCMv32' )
                        CSQY_ADJUST( IPHOT ) = BIACETYL
                     CASE ( 'HCHO_M_MCMv32', 'HCHOM_06', 'HCHO_M_SAPRC99', 'HCHO_MOL_RACM2', 'FORM_M_IUPAC10',
     &                      'FORM_M_IUPAC13', 'HCHO_MOL_JPL19' )                ! 'CH2O -> H2 + CO'
                        CSQY_ADJUST( IPHOT ) = FORMALDEHYDE_MOLECULAR
                     CASE (  'ACET_06', 'ACETONE', 'CH3COCH3_RACM2', 'ACET_IUPAC10' ) ! 'CH3COCH3 -> products'
                        CSQY_ADJUST( IPHOT ) = ACETONE
                     CASE (  'KETONE'  )
                        CSQY_ADJUST( IPHOT ) = KETONE_LEGACY
                     CASE ( 'KET_RACM2', 'KET_JGR19', 'HKET_RACM2', 'MEK_RACM2', 'MEK_JGR19', 'MVK_RACM2' ) ! Ketone treatement from W. Stockwell sbox
                        CSQY_ADJUST( IPHOT ) = KETONE_RACM2
                     CASE ( 'GLYH2_RACM2', 'GLYF_RACM2', 'GLYHX_RACM2', 'MGLY_RACM2'  ) ! glyoxal treatement from W. Stockwell sbox
                        CSQY_ADJUST( IPHOT ) = GLYOXAL_RACM2
                     CASE ( 'GLYOX_R_CRI', 'GLYOX_M_CRI', 'GLY_R_IUPAC10', 'GLY_R_IUPAC13'  ) ! glyoxal treatement based on IUPAC 2013 datasheet
                        CSQY_ADJUST( IPHOT ) = GLYOXAL_IUPAC_2013
                     CASE (  'MGLY_ADJ',  'MGLY_ABS' )
                        CSQY_ADJUST( IPHOT ) = METHYL_GLYOXAL_LEGACY
                     CASE ( 'ACET_R2_CRI', 'CH3COCH3A_JPL19' )
                        CSQY_ADJUST( IPHOT ) = ACETONE_CH3CO
                     CASE DEFAULT
                        CSQY_ADJUST( IPHOT ) =  0
                     END SELECT
!                      WRITE(LOGDEV,'(A)')'For rate ' // TRIM( PHOTOLYSIS_RATE( IPHOT ) ) 
!     &               // ' using CSQY_ADJUSTMENT ' // TRIM( CSQY_ADJUSTMENTS( CSQY_ADJUST( IPHOT ) ) )
               END DO
              RETURN
99951 FORMAT(A9,A16,40(1X,ES12.4))
      END SUBROUTINE DEFINE_CSQY_ADJUST
      REAL FUNCTION QUANTUM_ACETONE( TEMP, DENS_NUMB, LAMBDA )

C-----------------------------------------------------------------------
C Computes acetone quantum yields according to:
C IUPAC (2013) recommendation based on
C Blitz, M. A., D. E. Heard, M. J. Pilling, S. R. Arnold, and M. P. Chipperfield
C       (2004), Pressure and temperature-dependent quantum yields for the
C       photodissociation of acetone between 279 and 327.5 nm, Geophys.
C       Res. Lett., 31, L06111, doi:10.1029/2003GL018793.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      REAL, INTENT(IN) :: TEMP        ! air temperature, K
      REAL, INTENT(IN) :: DENS_NUMB   ! air number density, 1/cm^3
      REAL, INTENT(IN) :: LAMBDA      ! wavelength, nm

!***local
      REAL, PARAMETER  :: ONE_OVER_295K  = 1.0 / 295  ! 1/K

      REAL A0           ! 1st coef for qy
      REAL A1           ! 2nd coef for qy
      REAL A2           ! 3rd coef for qy
      REAL A3           ! 4th coef for qy
      REAL A4           ! 5th coef for qy

      REAL PHI_CO       ! CO branch of IUPAC (2013) acetone QYZ
      REAL PHI_CH3CO    ! CH3CO branch of IUPAC (2013) acetone QYZ
      REAL AA           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL BB           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL CC           ! scratch variable for IUPAC (2013) acetone QYZ

      REAL TEMP_OVER_295K   ! temperature divided by 295 K
      REAL ONE_OVER_LAMBDA  ! reciprocal of wavelength, 1E7/nm or 1/cm

      TEMP_OVER_295K  = TEMP * ONE_OVER_295K
      ONE_OVER_LAMBDA = 1.0E7 / LAMBDA

      IF ( LAMBDA .GE. 248.0 .AND. LAMBDA .LE. 349.0 ) THEN

         AA = 0.350 * ( TEMP_OVER_295K )**(-1.28)
         BB = 0.068 * ( TEMP_OVER_295K )**(-2.65)
         A0 = ( AA / ( 1.0 - AA ) ) * EXP( BB * ( LAMBDA - 248.0 ) )
         PHI_CO = 1.0 / ( 1.0 + A0 )

         IF ( LAMBDA .LE. 302.0 ) THEN

!***wavelengths 248-302 nm

            AA = 1.600E-19 * ( TEMP_OVER_295K )**(-2.38)
            BB =  0.55E-03 * ( TEMP_OVER_295K )**(-3.19)
            A1 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 33113.0 ) )
            PHI_CH3CO = ( 1.0 - PHI_CO ) / ( 1.0 + A1*DENS_NUMB )

!***wavelengths 302-349 nm

         ELSE

            AA = 1.62E-17 * ( TEMP_OVER_295K )**(-10.03)
            BB = 1.79E-03  * ( TEMP_OVER_295K )**(-1.364)
            A2 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 30488.0 ) )

            AA = 26.29 * ( TEMP_OVER_295K )**(-6.59)
            BB = 5.72E-7 * ( TEMP_OVER_295K )**(-2.93)
            CC = ( 30006.0 )   * ( TEMP_OVER_295K )**(-0.064)
            A3 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - CC )**2.0 )

            AA = 1.67E-15 * ( TEMP_OVER_295K )**(-7.25)
            BB = 2.08E-03  * ( TEMP_OVER_295K )**(-1.16)
            A4 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 30488.0 ) )

            PHI_CH3CO = ( 1.0 - PHI_CO )
     &                * ( 1.0 + A4 * DENS_NUMB + A3 )
     &                / ( ( 1.0 + A2 * DENS_NUMB + A3 )
     &                *   ( 1.0 + A4 * DENS_NUMB ) )
         END IF

         QUANTUM_ACETONE = MAX( 0.0, MIN( 1.0, (PHI_CO+PHI_CH3CO) ) )

      ELSE IF ( LAMBDA .LT. 248.0 .AND. LAMBDA .GT. 0.0 ) THEN ! set QY to 1.0

!***based on IUPAC (2013) data sheet

         QUANTUM_ACETONE = 1.0

      ELSE IF ( LAMBDA .GT. 349.0 ) THEN

         QUANTUM_ACETONE = 0.0

      END IF


      RETURN
      END FUNCTION QUANTUM_ACETONE
      SUBROUTINE QY_ACETONE_CHANNELS( TEMP, DENS_NUMB, LAMBDA, PHI_CO, PHI_CH3CO )

C-----------------------------------------------------------------------
C Computes acetone quantum yields according to:
C IUPAC (2013) recommendation based on
C Blitz, M. A., D. E. Heard, M. J. Pilling, S. R. Arnold, and M. P. Chipperfield
C       (2004), Pressure and temperature-dependent quantum yields for the
C       photodissociation of acetone between 279 and 327.5 nm, Geophys.
C       Res. Lett., 31, L06111, doi:10.1029/2003GL018793.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      REAL, INTENT(IN)  :: TEMP        ! air temperature, K
      REAL, INTENT(IN)  :: DENS_NUMB   ! air number density, 1/cm^3
      REAL, INTENT(IN)  :: LAMBDA      ! wavelength, nm
      REAL, INTENT(OUT) :: PHI_CO      ! CO branch of IUPAC (2013) acetone QYZ
      REAL, INTENT(OUT) :: PHI_CH3CO   ! CH3CO branch of IUPAC (2013) acetone QYZ

!***local
      REAL, PARAMETER  :: ONE_OVER_295K  = 1.0 / 295.0  ! 1/K

      REAL A0           ! 1st coef for qy
      REAL A1           ! 2nd coef for qy
      REAL A2           ! 3rd coef for qy
      REAL A3           ! 4th coef for qy
      REAL A4           ! 5th coef for qy

      REAL AA           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL BB           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL CC           ! scratch variable for IUPAC (2013) acetone QYZ

      REAL TEMP_OVER_295K   ! temperature divided by 295 K
      REAL ONE_OVER_LAMBDA  ! reciprocal of wavelength, 1E7/nm or 1/cm

      TEMP_OVER_295K  = TEMP * ONE_OVER_295K
      ONE_OVER_LAMBDA = 1.0E7 / LAMBDA

      IF ( LAMBDA .GE. 248.0 .AND. LAMBDA .LE. 349.0 ) THEN

         AA = 0.350 * ( TEMP_OVER_295K )**(-1.28)
         BB = 0.068 * ( TEMP_OVER_295K )**(-2.65)
         A0 = ( AA / ( 1.0 - AA ) ) * EXP( BB * ( LAMBDA - 248.0 ) )
         PHI_CO = 1.0 / ( 1.0 + A0 )

         PHI_CO = MAX( 0.0, MIN( 1.0, PHI_CO ) )

         IF ( LAMBDA .LE. 302.0 ) THEN

!***wavelengths 248-302 nm

            AA = 1.60E-19 * ( TEMP_OVER_295K )**(-2.38)
            BB = 0.55E-03 * ( TEMP_OVER_295K )**(-3.19)
            A1 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 33113.0 ) )
            PHI_CH3CO = ( 1.0 - PHI_CO ) / ( 1.0 + A1*DENS_NUMB )

!***wavelengths 302-349 nm

         ELSE

            AA = 1.62E-17 * ( TEMP_OVER_295K )**(-10.03)
            BB = 1.79E-03  * ( TEMP_OVER_295K )**(-1.364)
            A2 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 30488.0 ) )

            AA = 26.29 * ( TEMP_OVER_295K )**(-6.59)
            BB = 5.72E-7 * ( TEMP_OVER_295K )**(-2.93)
            CC = 30006.0 * ( TEMP_OVER_295K )**(-0.064)
            A3 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - CC )**2.0 )

            AA = 1.67E-15 * ( TEMP_OVER_295K )**(-7.25)
            BB = 2.08E-03  * ( TEMP_OVER_295K )**(-1.16)
            A4 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 30488.0 ) )

            PHI_CH3CO = ( 1.0 - PHI_CO )
     &                * ( 1.0 + A4 * DENS_NUMB + A3 )
     &                / ( ( 1.0 + A2 * DENS_NUMB + A3 )
     &                *   ( 1.0 + A4 * DENS_NUMB ) )
         END IF

         PHI_CH3CO = MAX( 0.0, MIN( 1.0, PHI_CH3CO ) )

      ELSE IF ( LAMBDA .LT. 248.0 .AND. LAMBDA .GT. 0.0 ) THEN ! set QY to 1.0

!***based on IUPAC (2013) data sheet

         PHI_CO    = 0.45
         PHI_CH3CO = 0.55

      ELSE IF ( LAMBDA .GT. 349.0 ) THEN

         PHI_CO    = 0.0
         PHI_CH3CO = 0.0

      END IF

      RETURN
      END SUBROUTINE QY_ACETONE_CHANNELS
#ifdef preprocessor
      REAL FUNCTION RQY_ACETONE_CH3CO( TEMP, DENS_NUMB, LAMBDA )
#else
      REAL FUNCTION RQY_ACETONE_CH3CO( TEMP, DENS_NUMB, IWAVE )
#endif
C-----------------------------------------------------------------------
C Computes correction to acetone CH3CO quantum yields at (TEMP, DENS_NUMB)  relative to
C quantum yields at (TEMP, DENS_NUMB = 2.46E19) according to:
C IUPAC (2013) recommendation based on
C Blitz, M. A., D. E. Heard, M. J. Pilling, S. R. Arnold, and M. P. Chipperfield
C       (2004), Pressure and temperature-dependent quantum yields for the
C       photodissociation of acetone between 279 and 327.5 nm, Geophys.
C       Res. Lett., 31, L06111, doi:10.1029/2003GL018793.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      REAL,    INTENT(IN)  :: TEMP        ! air temperature, K
      REAL,    INTENT(IN)  :: DENS_NUMB   ! air number density, molcules/cm^3
#ifdef preprocessor
      REAL,     INTENT(IN) :: LAMBDA      ! wavelength, nm
#else
      INTEGER, INTENT(IN)  :: IWAVE       !  wavelength index
#endif

!***local
      REAL, PARAMETER  :: ONE_OVER_295K  = 1.0 / 295.0  ! 1/K
      REAL, PARAMETER  :: DENS0          = 2.46E19      ! air number at STP, molecules/cm^3

      REAL A0           ! 1st coef for qy
      REAL A1           ! 2nd coef for qy
      REAL A2           ! 3rd coef for qy
      REAL A3           ! 4th coef for qy
      REAL A4           ! 5th coef for qy

      REAL PHI_CO       ! CO qy  at (TEMP, DENS_NUMB)
      REAL PHI_CH3CO    ! CH3CO qy at (TEMP, DENS_NUMB)
      REAL PHI_COS      ! CO qy branch at (TEMP, DENS0)
      REAL PHI_CH3COS   ! inverse of CH3CO qy at (TEMP, DENS0)
      REAL AA           ! scratch variable for acetone QY
      REAL BB           ! scratch variable for acetone QY
      REAL CC           ! scratch variable for acetone QY

      REAL TEMP_OVER_295K   ! temperature divided by 295 K
      REAL ONE_OVER_LAMBDA  ! wavenumber, 10E7/nm or 1/cm
#ifndef preprocessor
      REAL LAMBDA           ! wavelength, nm

      LAMBDA          = WAVELENGTH( IWAVE )
      ONE_OVER_LAMBDA = WAVENUMBER( IWAVE )
#else
      ONE_OVER_LAMBDA = 1.0E7 / LAMBDA
#endif

      TEMP_OVER_295K  = TEMP * ONE_OVER_295K

      IF ( LAMBDA .GE. 248.0 .AND. LAMBDA .LE. 349.0 ) THEN

         IF ( LAMBDA .LE. 302.0 ) THEN

!***wavelengths 248-302 nm

            AA = 1.60E-19 * ( TEMP_OVER_295K )**(-2.38)
            BB = 0.55E-03 * ( TEMP_OVER_295K )**(-3.19)
            A1 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - 33113.0 ) )
            RQY_ACETONE_CH3CO = ( 1.0 + A1*DENS0 ) / ( 1.0 + A1*DENS_NUMB )

!***wavelengths 302-349 nm

         ELSE

            AA = 1.62E-17 * ( TEMP_OVER_295K )**(-10.03)
            BB = 1.79E-03  * ( TEMP_OVER_295K )**(-1.364)
            A2 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - 30488.0 ) )

            AA = 26.29 * ( TEMP_OVER_295K )**(-6.59)
            BB = 5.72E-7 * ( TEMP_OVER_295K )**(-2.93)
            CC = 30006.0 * ( TEMP_OVER_295K )**(-0.064)
            A3 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - CC )**2.0 )

            AA = 1.67E-15 * ( TEMP_OVER_295K )**(-7.25)
            BB = 2.08E-03  * ( TEMP_OVER_295K )**(-1.16)
            A4 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - 30488.0 ) )

!***below qy_ch3co values are normalized by (1 - qy_co) which does not depend on
!***number density
            PHI_CH3CO  = ( 1.0 + A4 * DENS_NUMB + A3 )
     &                 / ( ( 1.0 + A2 * DENS_NUMB + A3 ) * ( 1.0 + A4 * DENS_NUMB ) )

            PHI_CH3COS = ( ( 1.0 + A2 * DENS0 + A3 ) * ( 1.0 + A4 * DENS0 ) )
     &                 / ( 1.0 + A4 * DENS0 + A3 )

            RQY_ACETONE_CH3CO = PHI_CH3CO * PHI_CH3COS

         END IF

      ELSE ! set RQY to 1.0 for 248.0 > LAMBDA or LAMBDA 349.0

         RQY_ACETONE_CH3CO = 1.0

      END IF

      RETURN
      END FUNCTION RQY_ACETONE_CH3CO
#ifdef preprocessor
      REAL FUNCTION RQUANTUM_ACETONE( TEMP, DENS_NUMB, LAMBDA )
#else
      REAL FUNCTION RQUANTUM_ACETONE( TEMP, DENS_NUMB, IWAVE )
#endif


C-----------------------------------------------------------------------
C Computes total acetone quantum yields at (TEMP, DENS_NUMB)  relative to
C quantum yields at (TEMP, DENS_NUMB = 2.46E19) according to
C IUPAC (2013) recommendation based on
C Blitz, M. A., D. E. Heard, M. J. Pilling, S. R. Arnold, and M. P. Chipperfield
C       (2004), Pressure and temperature-dependent quantum yields for the
C       photodissociation of acetone between 279 and 327.5 nm, Geophys.
C       Res. Lett., 31, L06111, doi:10.1029/2003GL018793.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      REAL,    INTENT(IN) :: TEMP        ! air temperature, K
      REAL,    INTENT(IN) :: DENS_NUMB   ! air number density, 1/cm^3
#ifdef preprocessor
      REAL,    INTENT(IN) :: LAMBDA      ! wavelength, nm
#else
      INTEGER, INTENT(IN) :: IWAVE       !  wavelength index
#endif

!***local
      REAL, PARAMETER  :: ONE_OVER_295K  = 1.0 / 295.0  ! 1/K
      REAL, PARAMETER  :: DENS0          = 2.46E19      ! air number at STP, molecules/cm^3

      REAL A0           ! 1st coef for qy
      REAL A1           ! 2nd coef for qy
      REAL A2           ! 3rd coef for qy
      REAL A3           ! 4th coef for qy
      REAL A4           ! 5th coef for qy

      REAL PHI_CO       ! CO branch of IUPAC (2013) acetone QYZ
      REAL DEL_PHI_CO   ! one minus CO branch of IUPAC (2013) acetone QYZ
      REAL PHI_CH3CO    ! CH3CO branch of IUPAC (2013) acetone QYZ
      REAL PHI_CH3CO0   ! CH3CO branch of IUPAC (2013) acetone QYZ at DENS0
      REAL AA           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL BB           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL CC           ! scratch variable for IUPAC (2013) acetone QYZ

      REAL TEMP_OVER_295K   ! temperature divided by 295 K
      REAL ONE_OVER_LAMBDA  ! reciprocal of wavelength, 1E7/nm or 1/cm
#ifndef preprocessor
      REAL LAMBDA           ! wavelength, nm

      LAMBDA          = WAVELENGTH( IWAVE )
      ONE_OVER_LAMBDA = WAVENUMBER( IWAVE )
#else
      ONE_OVER_LAMBDA = 1.0E7 / LAMBDA
#endif

      TEMP_OVER_295K  = TEMP * ONE_OVER_295K

      IF ( LAMBDA .GE. 248.0 .AND. LAMBDA .LE. 349.0 ) THEN

         AA = 0.350 * ( TEMP_OVER_295K )**(-1.28)
         BB = 0.068 * ( TEMP_OVER_295K )**(-2.65)
         A0 = ( AA / ( 1.0 - AA ) ) * EXP( BB * ( LAMBDA - 248.0 ) )
         PHI_CO     = 1.0 / ( 1.0 + A0 )
         DEL_PHI_CO = MAX(0.0, 1.0 - PHI_CO)

         IF ( LAMBDA .LE. 302.0 ) THEN

!***wavelengths 248-302 nm

            AA = 1.600E-19 * ( TEMP_OVER_295K )**(-2.38)
            BB =  0.55E-03 * ( TEMP_OVER_295K )**(-3.19)
            A1 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 33113.0 ) )
            PHI_CH3CO  = DEL_PHI_CO / ( 1.0 + A1*DENS_NUMB )
            PHI_CH3CO0 = DEL_PHI_CO / ( 1.0 + A1*DENS0 )

!***wavelengths 302-349 nm

         ELSE

            AA = 1.62E-17 * ( TEMP_OVER_295K )**(-10.03)
            BB = 1.79E-03  * ( TEMP_OVER_295K )**(-1.364)
            A2 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - 30488.0 ) )

            AA = 26.29 * ( TEMP_OVER_295K )**(-6.59)
            BB = 5.72E-7 * ( TEMP_OVER_295K )**(-2.93)
            CC = ( 30006.0 )   * ( TEMP_OVER_295K )**(-0.064)
            A3 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - CC )**2.0 )

            AA = 1.67E-15 * ( TEMP_OVER_295K )**(-7.25)
            BB = 2.08E-03  * ( TEMP_OVER_295K )**(-1.16)
            A4 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - 30488.0 ) )

            PHI_CH3CO = DEL_PHI_CO
     &                * ( 1.0 + A4 * DENS_NUMB + A3 )
     &                / ( ( 1.0 + A2 * DENS_NUMB + A3 )
     &                *   ( 1.0 + A4 * DENS_NUMB ) )

            PHI_CH3CO0 = DEL_PHI_CO
     &                * ( 1.0 + A4 * DENS0 + A3 )
     &                / ( ( 1.0 + A2 * DENS0 + A3 )
     &                *   ( 1.0 + A4 * DENS0 ) )

         END IF

         IF( (PHI_CO + PHI_CH3CO0) .GT. 1.0E-10 )THEN
             RQUANTUM_ACETONE = ( PHI_CO + PHI_CH3CO ) / ( PHI_CO + PHI_CH3CO0 )
         ELSE
             RQUANTUM_ACETONE = 1.0
         END IF

      ELSE

         RQUANTUM_ACETONE = 1.0

      END IF


      RETURN
      END FUNCTION RQUANTUM_ACETONE
#ifdef preprocessor
      REAL FUNCTION RQY_GLYOXAL( TEMP, DENS_NUMB, LAMBDA )
#else
      REAL FUNCTION RQY_GLYOXAL( TEMP, DENS_NUMB, IWAVE )
#endif

!-----------------------------------------------------------------------
! Computes total glyoxal (CHOCHO) quantum yield at (TEMP, DENS_NUMB)
! relative to total yield at (TEMP0, DENS_NUMB = 2.46E19) according to
!  IUPAC (2013) recommendation
!  http://iupac.pole-ether.fr/htdocs/datasheets/pdf/P4_%28CHO%292+hv.pdf
! that is based on
!  Salter, R. J., Blitz, M. A., Heard, D. E., Kovacs, T., Pilling, M. J.,
!  Rickard, A. R. and Seakins, P. W. (2013), Quantum yields for the photolysis
!  of glyoxal below 350 nm and parameterisations for its photolysis rate in
!  the troposphere, Phys. Chem. Chem. Phys., 15, 4984-4994,
!  doi:10.1039/c3cp43597k.
!-----------------------------------------------------------------------

        IMPLICIT NONE

!***arguments
        REAL,  INTENT(IN) :: TEMP        ! air temperature, K
        REAL,  INTENT(IN) :: DENS_NUMB   ! air number density, 1/cm^3
#ifdef preprocessor
      REAL,    INTENT(IN) :: LAMBDA      ! wavelength, nm
#else
      INTEGER, INTENT(IN) :: IWAVE       !  wavelength index
#endif
!***local
        REAL,      PARAMETER  :: ONE_OVER_295K  = 1.0 / 295.0  ! 1/K
        REAL( 8 ), PARAMETER  :: DENS0          = 2.46D19      ! air number at STP, molecules/cm^3

        REAL( 8 ) TEMP_OVER_295K   ! temperature divided by 295 K

        REAL( 8 ) AA           ! scratch variable for qy
        REAL( 8 ) BB           ! scratch variable for qy
        REAL( 8 ) A1           ! 2nd coef for qy
        REAL( 8 ) A2           ! 3rd coef for qy
        REAL( 8 ) A3           ! 4th coef for qy
        REAL( 8 ) WN_OFFSET    ! adjusted wavenumber, 1/cm
        REAL( 8 ) R8_DENS      ! air number density, 1/cm^3

        REAL ONE_OVER_LAMBDA  ! wavenumber, 10E7/nm or 1/cm
        REAL QY_DENS_NUMB     ! total qy at DENS_NUMB
        REAL IQY_DENS0        ! reciprocal of total qy at DENS0
#ifndef preprocessor
        REAL LAMBDA           ! wavelength, nm

        LAMBDA    = WAVELENGTH( IWAVE )
        WN_OFFSET = REAL( WAVENUMBER( IWAVE ) - 23800.0, 8 )
#else
        WN_OFFSET = REAL( 1.0E7 / LAMBDA - 23800.0, 8 )
#endif

        TEMP_OVER_295K  = REAL( TEMP * ONE_OVER_295K, 8 )
        R8_DENS         = REAL( DENS_NUMB, 8 )


         IF( LAMBDA .LT. 460.0 .AND. LAMBDA .GT. 250.0 )THEN
            AA = 6.48D-19 * TEMP_OVER_295K**(-1.83D0)
            BB = 7.60D-04 * TEMP_OVER_295K**(-0.515D0)
            A1 = AA * EXP( -BB * WN_OFFSET )

            AA = 1.128D02 * TEMP_OVER_295K**(-1.53D0)
            BB = 4.61D-03 * TEMP_OVER_295K**(-0.507D0)
            A2 = AA * EXP( -BB * WN_OFFSET  )

            AA = 2.25D-16 * TEMP_OVER_295K**(-9.18D0)
            BB = 7.80D-04 * TEMP_OVER_295K**(-7.03D0)
            A3 = AA * EXP( -BB * WN_OFFSET )

!*** note that values are normalized by total qy at DENS = 0.0 but
!    its values equals 1.0

            IQY_DENS0 = REAL( (1.0 + A2 + A3*DENS0 )
     &                / ((1.0 + A1*DENS0 + A2)*(1.0 + A3*DENS0)) )

            QY_DENS_NUMB  = REAL( (1.0 + A2 + A3*R8_DENS )
     &                / ((1.0 + A1*R8_DENS + A2)*(1.0 + A3*R8_DENS)) )


            RQY_GLYOXAL  = QY_DENS_NUMB * IQY_DENS0

          ELSE

            RQY_GLYOXAL  = 1.0

          END IF

          RETURN
       END FUNCTION RQY_GLYOXAL
      END MODULE CSQY_DATA

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! what(1) key, module and SID; SCCS file; date and time of last delta:
! %W% %P% %G% %U%

! --------------------------------------------------------------------------
! Purpose:
!
!   use F90 interface feature to achieve "faked" polymorphism for global gather
!   operation for PE 0
!
! Revision history:
!
!   Orginal version: 12/14/21 by David Wong
!
! Parameter List:
!
!   In: var -- distributed variable which needs be determined the max value
!              among all processors
!
! Local Variable:
!
!   max   -- maximum value among all processors
!   error -- error code of mpi call
!
! Include Files:
!
!   mpif.h
C -----------------------------------------------------------------------------

        module se_global_gather_module

          use se_pe_info_ext, only : se_worker_comm, se_myworker_pe, se_numworkers
          use se_domain_info_ext, only : se_gl_ind

          implicit none

          integer :: sc, ec, sr, er, nc, nr
          logical :: called_setup = .false.

          interface se_global_gather
            module procedure se_global_gather_2d_r,
     $                       se_global_gather_3d_r,
     $                       se_global_gather_2d_i,
     $                       se_global_gather_3d_i,
     $                       se_global_gather_2d_l,
     $                       se_global_gather_3d_l
          end interface

          contains

! -----------------------------------------------------------------------------
          subroutine se_global_gather_setup

            sc = se_gl_ind (1,1,se_myworker_pe)
            ec = se_gl_ind (2,1,se_myworker_pe)

            sr = se_gl_ind (1,2,se_myworker_pe)
            er = se_gl_ind (2,2,se_myworker_pe)

            nc = ec - sc + 1
            nr = er - sr + 1

          end subroutine se_global_gather_setup

! -----------------------------------------------------------------------------
          subroutine se_global_gather_2d_r (indata, outdata)

            real, intent(in)  :: indata(:,:)
            real, intent(out) :: outdata(:,:)

            include "mpif.h"

            integer :: data_size, error, pe, lsc, lec, lsr, ler,
     $                 lnc, lnr, status(MPI_STATUS_SIZE)
            real, allocatable :: buf(:,:)

            if (.not. called_setup) then
               call se_global_gather_setup
               called_setup = .true.
            end if

            if (se_myworker_pe == 0) then

               outdata(sc:ec, sr:er) = indata

               do pe = 1, se_numworkers-1
                  lsc = se_gl_ind (1,1,pe)
                  lec = se_gl_ind (2,1,pe)

                  lsr = se_gl_ind (1,2,pe)
                  ler = se_gl_ind (2,2,pe)

                  lnc = lec - lsc + 1
                  lnr = ler - lsr + 1

                  data_size = lnc * lnr

                  allocate (buf(lnc, lnr), stat=error)

                  call mpi_recv (buf, data_size, mpi_real, pe, pe+100,
     &                          se_worker_comm, status, error)

                  if (error .ne. 0) then
                     write (6, *) ' Abort: Error occurred while performing global 2d'
                     write (6, *) '        real gather in receiving data from PE ', pe
                     stop
                  end if

                  outdata(lsc:lec, lsr:ler) = buf

                  deallocate (buf)
               end do
            else
               data_size = nc * nr

               call mpi_send (indata, data_size, mpi_real, 0,
     $                        se_myworker_pe+100, se_worker_comm, error)

               if (error .ne. 0) then
                  write (6, *) ' Abort: Error occurred while performing global 2d'
                  write (6, *) '        real gather in sending data from PE ', pe
                  stop
               end if
            end if

          end subroutine se_global_gather_2d_r

! -----------------------------------------------------------------------------
          subroutine se_global_gather_3d_r (indata, outdata)

            real, intent(in)  :: indata(:,:,:)
            real, intent(out) :: outdata(:,:,:)

            include "mpif.h"

            integer :: data_size, error, pe, lsc, lec, lsr, ler,
     $                 lnc, lnr, status(MPI_STATUS_SIZE)
            real, allocatable :: buf(:,:,:)

            if (.not. called_setup) then
               call se_global_gather_setup
               called_setup = .true.
            end if

            if (se_myworker_pe == 0) then

               outdata(sc:ec, sr:er, :) = indata

               do pe = 1, se_numworkers-1
                  lsc = se_gl_ind (1,1,pe)
                  lec = se_gl_ind (2,1,pe)

                  lsr = se_gl_ind (1,2,pe)
                  ler = se_gl_ind (2,2,pe)

                  lnc = lec - lsc + 1
                  lnr = ler - lsr + 1

                  data_size = lnc * lnr * size(indata,3)

                  allocate (buf(lnc, lnr, size(indata,3)), stat=error)

                  call mpi_recv (buf, data_size, mpi_real, pe, pe+100,
     &                          se_worker_comm, status, error)

                  if (error .ne. 0) then
                     write (6, *) ' Abort: Error occurred while performing global 3d'
                     write (6, *) '        real gather in receiving data from PE ', pe
                     stop
                  end if

                  outdata(lsc:lec, lsr:ler, :) = buf

                  deallocate (buf)
               end do
            else
               data_size = nc * nr * size(indata, 3)

               call mpi_send (indata, data_size, mpi_real, 0,
     $                        se_myworker_pe+100, se_worker_comm, error)

               if (error .ne. 0) then
                  write (6, *) ' Abort: Error occurred while performing global 3d'
                  write (6, *) '        real gather in sending data from PE ', pe
                  stop
               end if
            end if

          end subroutine se_global_gather_3d_r

! -----------------------------------------------------------------------------
          subroutine se_global_gather_2d_i (indata, outdata)

            integer, intent(in)  :: indata(:,:)
            integer, intent(out) :: outdata(:,:)

            include "mpif.h"

            integer :: data_size, error, pe, lsc, lec, lsr, ler,
     $                 lnc, lnr, status(MPI_STATUS_SIZE)
            integer, allocatable :: buf(:,:)

            if (.not. called_setup) then
               call se_global_gather_setup
               called_setup = .true.
            end if

            if (se_myworker_pe == 0) then

               outdata(sc:ec, sr:er) = indata

               do pe = 1, se_numworkers-1
                  lsc = se_gl_ind (1,1,pe)
                  lec = se_gl_ind (2,1,pe)

                  lsr = se_gl_ind (1,2,pe)
                  ler = se_gl_ind (2,2,pe)

                  lnc = lec - lsc + 1
                  lnr = ler - lsr + 1

                  data_size = lnc * lnr

                  allocate (buf(lnc, lnr), stat=error)

                  call mpi_recv (buf, data_size, mpi_int, pe, pe+100,
     &                          se_worker_comm, status, error)

                  if (error .ne. 0) then
                     write (6, *) ' Abort: Error occurred while performing global 2d'
                     write (6, *) '        integer gather in receiving data from PE ', pe
                     stop
                  end if

                  outdata(lsc:lec, lsr:ler) = buf

                  deallocate (buf)
               end do
            else
               data_size = nc * nr

               call mpi_send (indata, data_size, mpi_int, 0,
     $                        se_myworker_pe+100, se_worker_comm, error)

               if (error .ne. 0) then
                  write (6, *) ' Abort: Error occurred while performing global 2d'
                  write (6, *) '        integer gather in sending data from PE ', pe
                  stop
               end if
            end if

          end subroutine se_global_gather_2d_i

! -----------------------------------------------------------------------------
          subroutine se_global_gather_3d_i (indata, outdata)

            integer, intent(in)  :: indata(:,:,:)
            integer, intent(out) :: outdata(:,:,:)

            include "mpif.h"

            integer :: data_size, error, pe, lsc, lec, lsr, ler,
     $                 lnc, lnr, status(MPI_STATUS_SIZE)
            integer, allocatable :: buf(:,:,:)

            if (.not. called_setup) then
               call se_global_gather_setup
               called_setup = .true.
            end if

            if (se_myworker_pe == 0) then

               outdata(sc:ec, sr:er, :) = indata

               do pe = 1, se_numworkers-1
                  lsc = se_gl_ind (1,1,pe)
                  lec = se_gl_ind (2,1,pe)

                  lsr = se_gl_ind (1,2,pe)
                  ler = se_gl_ind (2,2,pe)

                  lnc = lec - lsc + 1
                  lnr = ler - lsr + 1

                  data_size = lnc * lnr * size(indata,3)

                  allocate (buf(lnc, lnr, size(indata,3)), stat=error)

                  call mpi_recv (buf, data_size, mpi_int, pe, pe+100,
     &                          se_worker_comm, status, error)

                  if (error .ne. 0) then
                     write (6, *) ' Abort: Error occurred while performing global 3d'
                     write (6, *) '        integer gather in receiving data from PE ', pe
                     stop
                  end if

                  outdata(lsc:lec, lsr:ler, :) = buf

                  deallocate (buf)
               end do
            else
               data_size = nc * nr * size(indata, 3)

               call mpi_send (indata, data_size, mpi_int, 0,
     $                        se_myworker_pe+100, se_worker_comm, error)

               if (error .ne. 0) then
                  write (6, *) ' Abort: Error occurred while performing global 3d'
                  write (6, *) '        integer gather in sending data from PE ', pe
                  stop
               end if
            end if

          end subroutine se_global_gather_3d_i

! -----------------------------------------------------------------------------
          subroutine se_global_gather_2d_l (indata, outdata)

            logical, intent(in)  :: indata(:,:)
            logical, intent(out) :: outdata(:,:)

            include "mpif.h"

            integer :: data_size, error, pe, lsc, lec, lsr, ler,
     $                 lnc, lnr, status(MPI_STATUS_SIZE)
            logical, allocatable :: buf(:,:)

            if (.not. called_setup) then
               call se_global_gather_setup
               called_setup = .true.
            end if

            if (se_myworker_pe == 0) then

               outdata(sc:ec, sr:er) = indata

               do pe = 1, se_numworkers-1
                  lsc = se_gl_ind (1,1,pe)
                  lec = se_gl_ind (2,1,pe)

                  lsr = se_gl_ind (1,2,pe)
                  ler = se_gl_ind (2,2,pe)

                  lnc = lec - lsc + 1
                  lnr = ler - lsr + 1

                  data_size = lnc * lnr

                  allocate (buf(lnc, lnr), stat=error)

                  call mpi_recv (buf, data_size, mpi_logical, pe, pe+100,
     &                          se_worker_comm, status, error)

                  if (error .ne. 0) then
                     write (6, *) ' Abort: Error occurred while performing global 2d'
                     write (6, *) '        logical gather in receiving data from PE ', pe
                     stop
                  end if

                  outdata(lsc:lec, lsr:ler) = buf

                  deallocate (buf)
               end do
            else
               data_size = nc * nr

               call mpi_send (indata, data_size, mpi_logical, 0,
     $                        se_myworker_pe+100, se_worker_comm, error)

               if (error .ne. 0) then
                  write (6, *) ' Abort: Error occurred while performing global 2d'
                  write (6, *) '        logical gather in sending data from PE ', pe
                  stop
               end if
            end if

          end subroutine se_global_gather_2d_l

! -----------------------------------------------------------------------------
          subroutine se_global_gather_3d_l (indata, outdata)

            logical, intent(in)  :: indata(:,:,:)
            logical, intent(out) :: outdata(:,:,:)

            include "mpif.h"

            integer :: data_size, error, pe, lsc, lec, lsr, ler,
     $                 lnc, lnr, status(MPI_STATUS_SIZE)
            logical, allocatable :: buf(:,:,:)

            if (.not. called_setup) then
               call se_global_gather_setup
               called_setup = .true.
            end if

            if (se_myworker_pe == 0) then

               outdata(sc:ec, sr:er, :) = indata

               do pe = 1, se_numworkers-1
                  lsc = se_gl_ind (1,1,pe)
                  lec = se_gl_ind (2,1,pe)

                  lsr = se_gl_ind (1,2,pe)
                  ler = se_gl_ind (2,2,pe)

                  lnc = lec - lsc + 1
                  lnr = ler - lsr + 1

                  data_size = lnc * lnr * size(indata,3)

                  allocate (buf(lnc, lnr, size(indata,3)), stat=error)

                  call mpi_recv (buf, data_size, mpi_logical, pe, pe+100,
     &                          se_worker_comm, status, error)

                  if (error .ne. 0) then
                     write (6, *) ' Abort: Error occurred while performing global 3d'
                     write (6, *) '        logical gather in receiving data from PE ', pe
                     stop
                  end if

                  outdata(lsc:lec, lsr:ler, :) = buf

                  deallocate (buf)
               end do
            else
               data_size = nc * nr * size(indata, 3)

               call mpi_send (indata, data_size, mpi_logical, 0,
     $                        se_myworker_pe+100, se_worker_comm, error)

               if (error .ne. 0) then
                  write (6, *) ' Abort: Error occurred while performing global 3d'
                  write (6, *) '        logical gather in sending data from PE ', pe
                  stop
               end if
            end if

          end subroutine se_global_gather_3d_l

        end module se_global_gather_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WR_ACONC ( AGRID, JDATE, JTIME, TSTEP )

C Revision History:
C   Jeff - July 01
C   Note: If previous A_CONC exists, check that user hasn't changed what
C         species/layers to save (or domain).
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   20 Jul 11 J.Young: added option for ending time timestamp
C   12 Aug 15 D.Wong:  Extracted section of code that deals with creating
C                        A_CONC_1 and put it in opaconc.F
C                      Added a section of code to allow non IO processors
C                        to open A_CONC_1
C   19 May 16 D.Wong: renamed ACONC_END_TIME to AVG_FILE_ENDTIME
C   27 Mar 17 D.Wong: removed redundant parallel_io ifdef construct
C   09 Sep 19 F. Sidi: Replaced L_ACONC_WVEL(depreciated) with W_VEL
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE AVG_CONC              ! integral average CONC
      USE UTILIO_DEFN
      USE RUNTIME_VARS
#ifndef mpas
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif

      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! file name parameters

      REAL      :: AGRID( :,:,:,: )
      INTEGER      JDATE        ! current model date, coded YYYYDDD
      INTEGER      JTIME        ! current model time, coded HHMMSS
      INTEGER      TSTEP        ! output timestep (HHMMSS)

C Local variables:

      INTEGER      MDATE        ! modified model date, coded YYYYDDD
      INTEGER      MTIME        ! modified model time, coded HHMMSS

      CHARACTER( 16 ) :: PNAME = 'WR_ACONC'
      CHARACTER( 96 ) :: XMSG = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL OK

      INTEGER      L, K, VAR, SPC ! loop counters
      INTEGER      STATUS

C-----------------------------------------------------------------------

C Change output date/time to starting date/time - e.g. timestamp 1995196:090000
C represents data computed from time 1995196:090000 to 1995196:100000

#ifndef mpas
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

C Override default beginning time timestamp for ACONC?
         IF ( .NOT. IO_PE_INCLUSIVE ) THEN
            IF ( .NOT. OPEN3( A_CONC_1, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // A_CONC_1 // ' file for update'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

      END IF

      IF ( END_TIME ) THEN   ! ending time timestamp
         MDATE = JDATE; MTIME = JTIME
      ELSE                   ! beginning time timestamp
         MDATE = JDATE; MTIME = JTIME
         CALL NEXTIME ( MDATE, MTIME, -TSTEP )
      END IF

      VAR = 0
    
      DO SPC = 1, N_A_GC_SPC
         VAR = VAR + 1

         IF ( .NOT. WRITE3( A_CONC_1, A_GC_SPC( SPC ),
     &      MDATE, MTIME, AGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( A_GC_SPC( SPC ) )
     &           // ' to ' // A_CONC_1
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
      END DO
 
      DO SPC = 1, N_A_AE_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( A_CONC_1, A_AE_SPC( SPC ),
     &      MDATE, MTIME, AGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( A_AE_SPC( SPC ) )
     &           // ' to ' // A_CONC_1
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
      END DO
 
      DO SPC = 1, N_A_NR_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( A_CONC_1, A_NR_SPC( SPC ),
     &      MDATE, MTIME, AGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( A_NR_SPC( SPC ) )
     &           // ' to ' // A_CONC_1
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
      END DO
 
      ! Write Tracer Species Concentrations to Average Concentration File
      DO SPC = 1, N_A_TR_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( A_CONC_1, A_TR_SPC( SPC ),
     &      MDATE, MTIME, AGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( A_TR_SPC( SPC ) )
     &           // ' to ' // A_CONC_1
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
      END DO
 
      ! Write Vertical Velocity to Average Concentration File
      IF ( W_VEL ) THEN
        IF ( .NOT. WRITE3( A_CONC_1, 'W_VEL',
     &        MDATE, MTIME, AVG_WVEL ) ) THEN
              XMSG = 'Could not write Vertical Wind Velocity'
     &             // ' to ' // A_CONC_1
              CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
        END IF 
      END IF
 
      ! Write Relative Humidity to Average Concentration File
      IF ( L_ACONC_RH ) THEN
        IF ( .NOT. WRITE3( A_CONC_1, 'RH',
     &        MDATE, MTIME, AVG_RH ) ) THEN
              XMSG = 'Could not write Relative Humidity'
     &             // ' to ' // A_CONC_1
              CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
        END IF 
      END IF
      
      ! Write Temperature to Average Concentration File
      IF ( L_ACONC_TA ) THEN
        IF ( .NOT. WRITE3( A_CONC_1, 'TA',
     &        MDATE, MTIME, AVG_TA ) ) THEN
              XMSG = 'Could not write Temperature'
     &             // ' to ' // A_CONC_1
              CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
        END IF 
      END IF
 

      ! Write Pressure to Average Concentration File
      IF (L_ACONC_PRES ) THEN
        IF ( .NOT. WRITE3( A_CONC_1, 'PRES',
     &        MDATE, MTIME, AVG_PRES ) ) THEN
              XMSG = 'Could not write Pressure'
     &             // ' to ' // A_CONC_1
              CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
        END IF 
      END IF
 

      WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &      'Timestep written to', A_CONC_1,
     &      'for date and time', MDATE, MTIME
#endif

      RETURN 
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HCONTVEL ( JDATE, JTIME, TSTEP, LVL, UORV, WIND )
      
C-----------------------------------------------------------------------
C Function:
C    This subroutine reads physical velocities in the x1 or x2 directions
C    and returns the contravariant velocities.
 
C Preconditions:
C    This routine can be used only for conformal map coordinates 
C    in the horizontal.
C    Dates and times should be represented YYYYDDD:HHMMSS.
C    Must call for U-Winds first (UORV = UFLAG)
 
C Subroutines and functions called:
C    INTERPX, INTERPB, M3EXIT, TIME2SEC, SEC2TIME, NEXTIME
      
C Revision history:
C   January 30, 1996 by Clint L. Ingram at NCSC: created for
C   RADM-coordinates

C   22 Apr 97 Jeff:
C    7 Aug 97 Jeff: for NTHIK = 1
C    4 Feb 98 Jeff: deal with end-of-scenario
C   20 Sep 98 David Wong: parallelized the code
C                         -- adjust the data declaration for DENSJ
C                         -- remove indirect index reference, and re-adapt to
C                            a general case
C                         -- invoke stencil exchange library
C   21 Nov 00 J.Young: PE_COMM3 -> Dave Wong's f90 stenex COMM
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX
C    6 Apr 01 J.Young: Eliminate NTHIN confusion (assumes NTHIK = 1)
C   12 Apr 01 J.Young: Use PINTERPB for boundary data
C   23 Jun 03 J.Young: for layer dependent advection tstep
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                      removed deprecated TRIMLEN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   28 Jul 11 David Wong: set REVERT to .false. for twoway model case since
C                         buffered file has only two time steps data
C   01 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE)
#endif
      use CENTRALIZED_IO_MODULE, only : interpolate_var, window

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction
 
C Arguments:
      
      INTEGER, INTENT(  IN ) :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT(  IN ) :: JTIME        ! current model time, coded HHMMSS
      INTEGER, INTENT(  IN ) :: TSTEP        ! time step (HHMMSS)
      INTEGER, INTENT(  IN ) :: LVL          ! layer
      CHARACTER( 16 ), INTENT(  IN ) :: UORV ! flag for velocity component
!     REAL         WIND( NCOLS+1,NROWS+1 )
      REAL,    INTENT( OUT ) :: WIND( :,: )  ! CX xi-velocity 
      
C Parameters:

      CHARACTER( 16 ), PARAMETER :: UFLAG = 'X1VEL'
      CHARACTER( 16 ), PARAMETER :: VFLAG = 'X2VEL'

C file variables:
      
!     REAL      DENSJ_BUF( NCOLS,NROWS,NLAYS )     ! Jacobian * air density
      REAL, ALLOCATABLE, SAVE :: DENSJ_BUF( :,:,: ) ! Jacobian * air density
!     REAL, ALLOCATABLE, SAVE :: DENSJ_BUF( :,: )   ! Jacobian * air density
!     REAL      DENSJ_BND( NBNDY,NLAYS )           ! bndy Jacobian * air density
      REAL, ALLOCATABLE, SAVE :: DENSJ_BND( :,: )  ! bndy Jacobian * air density
!     REAL    DENSJ( 0:NCOLS+1,0:NROWS+1,NLAYS )
      REAL, ALLOCATABLE, SAVE :: DENSJ( :,: )      ! Jacobian * air density

C External Functions: None
      
C local variables:
      
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
       
      INTEGER   ROW               ! Row index
      INTEGER   COL               ! Column index
      INTEGER   MDATE             ! mid-advection date
      INTEGER   MTIME             ! mid-advection time
      INTEGER, SAVE :: LDATE( 3 ) ! last date for data on file
      INTEGER, SAVE :: LTIME( 3 ) ! last time for data on file
      LOGICAL   REVERT            ! recover last time step if true
      INTEGER   STEP              ! advection time step in seconds
      REAL      DJ                ! temporary Jacobian * air density
      INTEGER   ESTAT
 
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: PNAME = 'HCONTVEL'
      CHARACTER( 16 ) :: AMSG
      CHARACTER( 14 ) :: MSG1 = 'Error reading '
      CHARACTER( 96 ) :: XMSG = ' '
 
      CHARACTER( 8 ), SAVE :: COMMSTR

      INTEGER COUNT     ! Counter for constructing density array.

      LOGICAL, SAVE :: CSTAGUV = .TRUE.      ! Winds are available on C staggered grid?

      integer, save :: old_time = -9

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         CALL LSTEPF( MET_CRO_3D, LDATE( 1 ), LTIME( 1 ) )
!        CALL LSTEPF( MET_BDY_3D, LDATE( 2 ), LTIME( 2 ) )
         CALL LSTEPF( MET_DOT_3D, LDATE( 3 ), LTIME( 3 ) )

!        LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 2 ), LDATE( 3 ) )
!        LTIME( 1 ) = SEC2TIME( MIN(
!    &                         TIME2SEC( LTIME( 1 ) ),
!    &                         TIME2SEC( LTIME( 2 ) ),
!    &                         TIME2SEC( LTIME( 3 ) )
!    &                         ) )

         LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 3 ) )
         LTIME( 1 ) = SEC2TIME( MIN(
     &                         TIME2SEC( LTIME( 1 ) ),
     &                         TIME2SEC( LTIME( 3 ) )
     &                         ) )

         WRITE( COMMSTR,'(4I2)' )  1, 1-NTHIK, 2, 1-NTHIK  ! ' 1 0 2 0'

         VNAME3D = ' '   ! array assignment
         IF ( .NOT. DESC3( MET_DOT_3D ) ) THEN
            XMSG = 'Could not get '
     &           // TRIM( MET_DOT_3D ) // ' file description'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VNAME = 'UWINDC'
         IF ( INDEX1( VNAME, NVARS3D, VNAME3D ) .LE. 0 ) THEN
            XMSG = 'Could not find ' // VNAME // ' in ' // MET_DOT_3D
            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
            CSTAGUV = .FALSE.
         END IF

         IF ( .NOT. CSTAGUV ) THEN

            ALLOCATE ( DENSJ( 0:NCOLS+1,0:NROWS+1 ), STAT = ESTAT )
            IF ( ESTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DENSJ'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            IF ( .NOT. WINDOW ) THEN
               ALLOCATE ( DENSJ_BUF( ncols,nrows,NLAYS ),STAT = ESTAT )
!              ALLOCATE ( DENSJ_BUF( NCOLSDENS,NROWSDENS ),      STAT = ESTAT )
               IF ( ESTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating DENSJ_BUF'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
               ALLOCATE ( DENSJ_BND( NBNDY,NLAYS ), STAT = ESTAT )
               IF ( ESTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating DENSJ_BND'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
            END IF

         END IF

      END IF   ! if firstime
 
      MDATE = JDATE
      MTIME = JTIME
      STEP  = TIME2SEC( TSTEP )
      CALL NEXTIME( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

#ifdef twoway
      REVERT = .FALSE.
#else
      IF ( MDATE .LT. LDATE( 1 ) ) THEN
         REVERT = .FALSE.
         ELSE IF ( MDATE .EQ. LDATE( 1 ) ) THEN
            IF ( MTIME .LE. LTIME( 1 ) ) THEN
               REVERT = .FALSE.
            ELSE
               REVERT = .TRUE.
            END IF
      ELSE   ! MDATE .GT. LDATE
         REVERT = .TRUE.
      END IF
#endif

      IF ( REVERT ) THEN
         XMSG = 'Current scenario interpolation step not available in all of '
     &        // TRIM( MET_CRO_3D ) // ', '
     &        // TRIM( MET_BDY_3D ) // ' and '
     &        // TRIM( MET_DOT_3D )
         CALL M3MESG( XMSG )
         WRITE( AMSG,'( 2I8 )' ) LDATE( 1 ), LTIME( 1 )
         XMSG = 'Using data for last file step: ' // AMSG
         CALL M3MESG( XMSG )
         MDATE = LDATE( 1 )
         MTIME = LTIME( 1 )
      END IF

      IF ( LVL .GT. NLAYS ) THEN
         WRITE( XMSG,'( "layer", I4, " greater than NLAYS" )') LVL
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF

C Try to read u-component wind on C-staggered grid from variable UWINDC.
C (First available in MCIPv3.5, Fall 2009.)  If UWINDC is not in MET_DOT_3D,
C try to read u-component wind on B-staggered grid as UWIND.

      IF ( UORV .EQ. UFLAG ) THEN

         IF ( CSTAGUV ) THEN
            call interpolate_var ('UWINDC', mdate, mtime, WIND, SLAY=LVL)

            RETURN
         END IF

      ELSE IF ( UORV .EQ. VFLAG ) THEN

C If u-component wind was C-staggered, read v-component wind on C-staggered
C grid.  Otherwise, read v-component wind from B-staggered grid.

         IF ( CSTAGUV ) THEN
            call interpolate_var ('VWINDC', mdate, mtime, WIND, SLAY=LVL)

            RETURN
         END IF

      ELSE

         XMSG = 'UORV Flag, not set correctly'
         CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT2 )

      END IF   ! if UORV

C Interpolate Jacobian X Air Density
 
      VNAME = 'DENSA_J'
      IF ( WINDOW ) THEN

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ, slay=lvl)

      ELSE ! need to extend data from bndy file

         IF (old_time .ne. mtime) THEN
           call interpolate_var (VNAME, mdate, mtime, DENSJ_BUF)
           old_time = mtime

           call interpolate_var (VNAME, mdate, mtime, DENSJ_BND, 'b')
         END IF

C Load DENSJ array

         DO ROW = 1, NROWS
            DO COL = 1, NCOLS
               DENSJ( COL,ROW ) = DENSJ_BUF( COL,ROW,LVL )
            END DO
         END DO

C Fill in DENSJ array for boundaries

         COUNT = 0
         DO ROW = 0, 0
            DO COL = 1, NCOLS+1
               COUNT = COUNT + 1
               DENSJ( COL,ROW ) = DENSJ_BND( COUNT,LVL )  ! South
            END DO
         END DO
         DO ROW = 1, NROWS+1
            DO COL = NCOLS+1, NCOLS+1
               COUNT = COUNT + 1
               DENSJ( COL,ROW ) = DENSJ_BND( COUNT,LVL )  ! East
            END DO
         END DO
         DO ROW = NROWS+1, NROWS+1
            DO COL = 0, NCOLS
               COUNT = COUNT + 1
               DENSJ( COL,ROW ) = DENSJ_BND( COUNT,LVL )  ! North
            END DO
         END DO
         DO ROW = 0, NROWS
            DO COL = 0, 0
               COUNT = COUNT + 1
               DENSJ( COL,ROW ) = DENSJ_BND( COUNT,LVL )  ! West
            END DO
         END DO

      END IF   ! WINDOW

C Interpolate Contravariant Velocity components (already at flux points)
C X Jacobian X Air Density

      IF ( UORV .EQ. UFLAG ) THEN

         call interpolate_var ('UHAT_JD', mdate, mtime, WIND, SLAY=LVL)

C get west-direction RhoJ in halo cells and retrieve contravariant velocities

         CALL SUBST_COMM ( DENSJ, DSPL_N0_E0_S0_W1, DRCN_W, COMMSTR )
         DO ROW = 1, NROWS
            DO COL = 1, NCOLS+1
               DJ = 0.5 * ( DENSJ( COL,ROW) + DENSJ( COL-1,ROW ) )
               WIND( COL,ROW ) = WIND( COL,ROW ) / DJ
            END DO
         END DO

      ELSE

         call interpolate_var ('VHAT_JD', mdate, mtime, WIND, SLAY=LVL)

C get south-direction RhoJ in halo cells and retrieve contravariant velocities

         CALL SUBST_COMM ( DENSJ, DSPL_N0_E0_S1_W0, DRCN_S, COMMSTR )
         DO ROW = 1, NROWS+1
            DO COL = 1, NCOLS
               DJ = 0.5 * ( DENSJ( COL,ROW ) + DENSJ( COL,ROW-1 ) )
               WIND( COL,ROW ) = WIND( COL,ROW ) / DJ
            END DO
         END DO

      END IF

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! RCS file, release, date & time of last delta, author, state, [and locker]
! $Header: /home/wdx/lib/src/junk/junk/CMAQv5.0.1/models/STENEX/src/se_snl/se_twoway_comm_module.f,v 1.1.1.1 2012/04/19 19:48:15 sjr Exp $

! what(1) key, module and SID; SCCS file; date and time of last delta:
! %W% %P% %G% %U%

!-----------------------------------------------------------------------
! Purpose:
!   implement data exchange between WRF and CMAQ to accommodate different
!   domain sizes and domain decomposition strategies

! Revision history:
!   Orginal version: 4/10/07 by David Wong
!          Modified: 5/21/12 by David Wong
!                      -- used a more strict hand-shake paradiagm for communication
!          Modified: 9/30/15 by David Wong
!                      -- reduced the value of tag to accommodate various MPI 
!                         implementation
!-----------------------------------------------------------------------

        module se_twoway_comm_module

        use se_comm_info_ext

        implicit none

        integer, private :: wrf_cmaq_loc_ngb(0:8) = -1
        integer, private :: wrf_cmaq_loc_ngb_send_to(0:8, 2) = -1
        integer, private :: wrf_cmaq_loc_ngb_recv_from(0:8, 2) = -1
        logical, private :: wrf_cmaq_computed = .false.

        integer, private :: cmaq_wrf_loc_ngb(0:8) = -1
        integer, private :: cmaq_wrf_loc_ngb_send_to(0:8, 2) = -1
        integer, private :: cmaq_wrf_loc_ngb_recv_from(0:8, 2) = -1
        logical, private :: cmaq_wrf_computed = .false.

        interface se_wrf_cmaq_comm
          module procedure se_wrf_cmaq_comm2, se_wrf_cmaq_comm3, se_wrf_cmaq_comm4
        end interface

        interface se_cmaq_wrf_comm
          module procedure se_cmaq_wrf_comm2, se_cmaq_wrf_comm3, se_cmaq_wrf_comm4
        end interface

        contains

! -----------------------------------------------------------------------------

        subroutine se_wrf_cmaq_comm2 (mype, wrf_data, cmaq_data, 
     &                                wrf_cmaq_send_to, wrf_cmaq_recv_from,
     &                                wrf_cmaq_send_index_l, wrf_cmaq_recv_index_l, 
     &                                flag)

        implicit none

        integer, intent(in) :: mype
        real, intent(in)  :: wrf_data(:,:)
        real, intent(out) :: cmaq_data(:,:)
        integer, pointer :: wrf_cmaq_send_to(:,:), wrf_cmaq_recv_from(:,:)
        integer, pointer :: wrf_cmaq_send_index_l(:,:,:), wrf_cmaq_recv_index_l(:,:,:)
        integer, intent(in) :: flag

        include "mpif.h"

        integer :: c, r, lc, lr, i, j, k, index, sdir, rdir, 
     $             request, status(MPI_STATUS_SIZE), error
        integer :: data_size, tag, li, lj, s_ind, r_ind
        real,allocatable :: sarray(:), rarray(:)
        logical :: found

           call compute_ngb (mype, wrf_cmaq_loc_ngb, se_twoway_npcol,
     $                       se_twoway_nprow)

           do k = 0, 8

              call loc_index (wrf_cmaq_loc_ngb(k), wrf_cmaq_send_to(:,mype), 
     $                        wrf_cmaq_loc_ngb_send_to(k,1),
     $                        wrf_cmaq_loc_ngb_send_to(k,2))
              call loc_index (wrf_cmaq_loc_ngb(8-k), wrf_cmaq_recv_from(:,mype), 
     $                        wrf_cmaq_loc_ngb_recv_from(8-k,1),
     $                        wrf_cmaq_loc_ngb_recv_from(8-k,2))
           end do

        do k = 0, 8

           sdir = wrf_cmaq_loc_ngb_send_to(k,1)
           rdir = wrf_cmaq_loc_ngb_recv_from(8-k,1)

           if (sdir > -1) then
              s_ind = wrf_cmaq_loc_ngb_send_to(k,2)
              j = (s_ind - 1) * 3 + 1

              if (mype .eq. sdir) then

                 found = .false.
                 li = 0
                 do while (.not. found)
                    li = li + 1
                    if (mype .eq. wrf_cmaq_recv_from(li, mype)) then
                       found = .true.
                       lj = (li - 1) * 3 + 1
                    end if
                 end do

                 lr = wrf_cmaq_recv_index_l(lj,2,mype) - 1
                 do r = wrf_cmaq_send_index_l(j,2,mype), wrf_cmaq_send_index_l(j+1,2,mype)
                    lr = lr + 1
                    lc = wrf_cmaq_recv_index_l(lj,1,mype) - 1
                    do c = wrf_cmaq_send_index_l(j,1,mype), wrf_cmaq_send_index_l(j+1,1,mype)
                       lc = lc + 1
                       cmaq_data(lc,lr) = wrf_data(c,r)
                    end do
                 end do
              else
                 data_size = wrf_cmaq_send_index_l(j+2,1,mype) * wrf_cmaq_send_index_l(j+2,2,mype)

                 allocate (sarray(data_size), stat=error)
                 index = 0
                 do r = wrf_cmaq_send_index_l(j,2,mype), wrf_cmaq_send_index_l(j+1,2,mype)
                    do c = wrf_cmaq_send_index_l(j,1,mype), wrf_cmaq_send_index_l(j+1,1,mype)
                       index = index + 1
                       sarray(index) = wrf_data(c,r)
                    end do
                 end do
!                tag = flag * 1000000 + mype * 1000 + sdir
                 tag = flag * 1000 + sdir

                 call mpi_send (sarray, data_size, mpi_real, sdir,
     &                          tag, mpi_comm_world, error)

                 deallocate (sarray)

              end if
           end if

           if (rdir > -1) then

              if (mype .ne. rdir) then

                 r_ind = wrf_cmaq_loc_ngb_recv_from(8-k,2)
                 j = (r_ind - 1) * 3 + 1

                 data_size = wrf_cmaq_recv_index_l(j+2,1,mype) * wrf_cmaq_recv_index_l(j+2,2,mype)

                 allocate (rarray(data_size), stat=error)
!                tag = flag * 1000000 + rdir * 1000 + mype
                 tag = flag * 1000 + mype

                 call mpi_recv (rarray, data_size, mpi_real, rdir, tag,
     $                          mpi_comm_world, status, error)

                 index = 0
                 do r = wrf_cmaq_recv_index_l(j,2,mype), wrf_cmaq_recv_index_l(j+1,2,mype)
                    do c = wrf_cmaq_recv_index_l(j,1,mype), wrf_cmaq_recv_index_l(j+1,1,mype)
                       index = index + 1
                       cmaq_data(c,r) = rarray(index)
                    end do
                 end do
                 deallocate (rarray)
              end if
           end if

        end do

        return
        end subroutine se_wrf_cmaq_comm2

! -----------------------------------------------------------------------------

        subroutine se_wrf_cmaq_comm3 (mype, wrf_data, cmaq_data, 
     &                                wrf_cmaq_send_to, wrf_cmaq_recv_from,
     &                                wrf_cmaq_send_index_l, wrf_cmaq_recv_index_l, 
     &                                flag)

        implicit none

        integer, intent(in) :: mype
        real, intent(in)  :: wrf_data(:,:,:)
        real, intent(out) :: cmaq_data(:,:,:)
        integer, pointer :: wrf_cmaq_send_to(:,:), wrf_cmaq_recv_from(:,:)
!       integer, intent(in) :: wrf_cmaq_send_to(:,:), wrf_cmaq_recv_from(:,:)
        integer, pointer :: wrf_cmaq_send_index_l(:,:,:), wrf_cmaq_recv_index_l(:,:,:)
        integer, intent(in) :: flag

        include "mpif.h"

        integer :: c, r, lc, lr, d, i, j, k, index, sdir, rdir, 
     $             request, status(MPI_STATUS_SIZE), error
        integer :: data_size, size_3d, tag, li, lj, s_ind, r_ind
        real,allocatable :: sarray(:), rarray(:)
!       real :: sarray(size(wrf_data))  ! the second dimension is needed to keep the send
                                          ! data since all the send instructions are done
                                          ! before any receive instruction
!       real :: rarray(size(cmaq_data))
        logical :: found

        integer :: total_s, total_r, n_s, n_r
        integer :: total_ss, total_rr, n_ss, n_rr

!       if (.not. wrf_cmaq_computed) then
           call  compute_ngb (mype, wrf_cmaq_loc_ngb, se_twoway_npcol, 
     $                        se_twoway_nprow)

!         write (6, '(a13, 9i5)') ' ==dw3 ngb a ', wrf_cmaq_loc_ngb

!         write (6, '(a15, 20i5)') ' ==dw3 send to ', 
!    $      wrf_cmaq_send_to(0:wrf_cmaq_send_to(0,mype), mype)

!         write (6, '(a15, 20i5)') ' ==dw3 recv fr ', 
!    $      wrf_cmaq_recv_from(0:wrf_cmaq_recv_from(0,mype), mype)

           wrf_cmaq_computed = .true.
           do k = 0, 8

              call loc_index (wrf_cmaq_loc_ngb(k), wrf_cmaq_send_to(:,mype), 
     $                        wrf_cmaq_loc_ngb_send_to(k,1), 
     $                        wrf_cmaq_loc_ngb_send_to(k,2)) 
              call loc_index (wrf_cmaq_loc_ngb(8-k), wrf_cmaq_recv_from(:,mype), 
     $                        wrf_cmaq_loc_ngb_recv_from(8-k,1), 
     $                        wrf_cmaq_loc_ngb_recv_from(8-k,2)) 
           end do

!          do k = 0, 8
!         write (6, '(a13, 9i5)') ' ==dw3 ngb b ', k, wrf_cmaq_loc_ngb_send_to(k,:)
!          end do
!          do k = 0, 8
!         write (6, '(a13, 9i5)') ' ==dw3 ngb c ', k, wrf_cmaq_loc_ngb_recv_from(k,:)
!          end do

!       end if

        size_3d = size(wrf_data, 3)

        total_s = 0
        total_r = 0
        n_s = 0
        n_r = 0
        do k = 0, 8
!          call loc_index (loc_ngb(k), wrf_cmaq_send_to(:,mype), sdir, s_ind)
!          call loc_index (loc_ngb(8-k), wrf_cmaq_recv_from(:,mype), rdir, r_ind)

           sdir = wrf_cmaq_loc_ngb_send_to(k,1) 
           rdir = wrf_cmaq_loc_ngb_recv_from(8-k,1) 
 
!          write (6, '(a7, 30i5)') ' ==d== ', k, mype, loc_ngb(k), wrf_cmaq_send_to(:,mype), sdir, s_ind
!          write (6, '(a7, 30i5)') ' ==d== ', k, mype, loc_ngb(8-k), wrf_cmaq_recv_from(:,mype), rdir, r_ind

!          goto 999

           if (sdir > -1) then
              total_s = total_s + 1 
              s_ind = wrf_cmaq_loc_ngb_send_to(k,2)
              j = (s_ind - 1) * 3 + 1

              if (mype .eq. sdir) then

                 found = .false.
                 li = 0
                 do while (.not. found)
                    li = li + 1
                    if (mype .eq. wrf_cmaq_recv_from(li, mype)) then
                       found = .true.
                       lj = (li - 1) * 3 + 1
                    end if
                 end do

                 lr = wrf_cmaq_recv_index_l(lj,2,mype) - 1
                 do r = wrf_cmaq_send_index_l(j,2,mype), wrf_cmaq_send_index_l(j+1,2,mype)
                    lr = lr + 1
                    lc = wrf_cmaq_recv_index_l(lj,1,mype) - 1
                    do c = wrf_cmaq_send_index_l(j,1,mype), wrf_cmaq_send_index_l(j+1,1,mype)
                       lc = lc + 1
                       cmaq_data(lc,lr,:) = wrf_data(c,r,:)
                    end do
                 end do
              else
                 data_size = size_3d * wrf_cmaq_send_index_l(j+2,1,mype) * wrf_cmaq_send_index_l(j+2,2,mype)

                 allocate (sarray(data_size), stat=error)
                 index = 0
                 do d = 1, size_3d
                    do r = wrf_cmaq_send_index_l(j,2,mype), wrf_cmaq_send_index_l(j+1,2,mype)
                       do c = wrf_cmaq_send_index_l(j,1,mype), wrf_cmaq_send_index_l(j+1,1,mype)
                          index = index + 1
                          sarray(index) = wrf_data(c,r,d)
                       end do
                    end do
                 end do
!                tag = flag * 1000000 + mype * 1000 + sdir
                 tag = flag * 1000 + sdir

!        write (6, '(a12, 2i5, 8i10)') ' ==dw3 send ', j, sdir, tag, data_size, 
!    $     size_3d, wrf_cmaq_send_index_l(j+2,1,mype),
!    $     wrf_cmaq_send_index_l(j+2,2,mype), size(sarray)

                 call mpi_send (sarray, data_size, mpi_real, sdir,
     &                          tag, mpi_comm_world, error)

!                n_s = n_s + 1 
!                call mpi_send (mype, 1, mpi_integer, sdir,
!    &                          tag, mpi_comm_world, error)
                 deallocate (sarray)

              end if
           end if

           if (rdir > -1) then

              total_r = total_r + 1 
              if (mype .ne. rdir) then

                 r_ind = wrf_cmaq_loc_ngb_recv_from(8-k,2)
                 j = (r_ind - 1) * 3 + 1

                 data_size = size_3d * wrf_cmaq_recv_index_l(j+2,1,mype) * wrf_cmaq_recv_index_l(j+2,2,mype)

                 allocate (rarray(data_size), stat=error)
!                tag = flag * 1000000 + rdir * 1000 + mype
                 tag = flag * 1000 + mype

                 call mpi_recv (rarray, data_size, mpi_real, rdir, tag, 
     $                          mpi_comm_world, status, error)

!                n_r = n_r + 1 
!                call mpi_recv (request, 1, mpi_integer, rdir, tag, mpi_comm_world, status, error)

!        write (6, '(a12, 2i5, 10i8)') ' ==dw3 recv ', j, rdir, tag,
!    $       data_size, size_3d, wrf_cmaq_recv_index_l(j+2,1,mype), 
!    $       wrf_cmaq_recv_index_l(j+2,2,mype), size(rarray)

                 index = 0
                 do d = 1, size_3d
                    do r = wrf_cmaq_recv_index_l(j,2,mype), wrf_cmaq_recv_index_l(j+1,2,mype)
                       do c = wrf_cmaq_recv_index_l(j,1,mype), wrf_cmaq_recv_index_l(j+1,1,mype)
                          index = index + 1
                          cmaq_data(c,r,d) = rarray(index)
                       end do
                     end do
                 end do
                 deallocate (rarray)
              end if
           end if
 999       continue

        end do

        end subroutine se_wrf_cmaq_comm3

! -----------------------------------------------------------------------------

        subroutine se_wrf_cmaq_comm4 (mype, wrf_data, cmaq_data, 
     &                                wrf_cmaq_send_to, wrf_cmaq_recv_from,
     &                                wrf_cmaq_send_index_l, wrf_cmaq_recv_index_l, 
     &                                flag)

        implicit none

        integer, intent(in) :: mype
        real, intent(in)  :: wrf_data(:,:,:,:)
        real, intent(out) :: cmaq_data(:,:,:,:)
        integer, pointer :: wrf_cmaq_send_to(:,:), wrf_cmaq_recv_from(:,:)
        integer, pointer :: wrf_cmaq_send_index_l(:,:,:), wrf_cmaq_recv_index_l(:,:,:)
        integer, intent(in) :: flag

        include "mpif.h"

        integer :: sdir, rdir, size_l_v, nlays, nvars, si, ri
        logical :: done
        integer :: c, r, l, v, i, j, k, data_size, tag, li, lj, s_ind, 
     $             r_ind, index, lr, lc,
     $             request, status(MPI_STATUS_SIZE), error
        real,allocatable :: sarray(:), rarray(:)
        logical :: found

           call  compute_ngb (mype, wrf_cmaq_loc_ngb, se_twoway_npcol,
     $                        se_twoway_nprow)

           do k = 0, 8

              call loc_index (wrf_cmaq_loc_ngb(k), wrf_cmaq_send_to(:,mype), 
     $                        wrf_cmaq_loc_ngb_send_to(k,1),
     $                        wrf_cmaq_loc_ngb_send_to(k,2))
              call loc_index (wrf_cmaq_loc_ngb(8-k), wrf_cmaq_recv_from(:,mype), 
     $                        wrf_cmaq_loc_ngb_recv_from(8-k,1),
     $                        wrf_cmaq_loc_ngb_recv_from(8-k,2))
           end do

        nlays = size(wrf_data, 3)
        nvars = size(wrf_data, 4)
        size_l_v = nlays * nvars

        do k = 0, 8

           sdir = wrf_cmaq_loc_ngb_send_to(k,1)
           rdir = wrf_cmaq_loc_ngb_recv_from(8-k,1)

           if (sdir > -1) then
              s_ind = wrf_cmaq_loc_ngb_send_to(k,2)
              j = (s_ind - 1) * 3 + 1

              if (mype .eq. sdir) then

                 found = .false.
                 li = 0
                 do while (.not. found)
                    li = li + 1
                    if (mype .eq. wrf_cmaq_recv_from(li, mype)) then
                       found = .true.
                       lj = (li - 1) * 3 + 1
                    end if
                 end do

                 lr = wrf_cmaq_recv_index_l(lj,2,mype) - 1
                 do r = wrf_cmaq_send_index_l(j,2,mype), wrf_cmaq_send_index_l(j+1,2,mype)
                    lr = lr + 1
                    lc = wrf_cmaq_recv_index_l(lj,1,mype) - 1
                    do c = wrf_cmaq_send_index_l(j,1,mype), wrf_cmaq_send_index_l(j+1,1,mype)
                       lc = lc + 1
                       cmaq_data(lc,lr,:,:) = wrf_data(c,r,:,:)
                    end do
                 end do
              else
                 data_size = size_l_v * wrf_cmaq_send_index_l(j+2,1,mype) * wrf_cmaq_send_index_l(j+2,2,mype)

                 allocate (sarray(data_size), stat=error)
                 index = 0
                 do v = 1, nvars
                    do l = 1, nlays
                       do r = wrf_cmaq_send_index_l(j,2,mype), wrf_cmaq_send_index_l(j+1,2,mype)
                          do c = wrf_cmaq_send_index_l(j,1,mype), wrf_cmaq_send_index_l(j+1,1,mype)
                             index = index + 1
                             sarray(index) = wrf_data(c,r,l,v)
                          end do
                       end do
                    end do
                 end do
!                tag = flag * 1000000 + mype * 1000 + sdir
                 tag = flag * 1000 + sdir

                 call mpi_send (sarray, data_size, mpi_real, sdir,
     &                          tag, mpi_comm_world, error)

                 deallocate (sarray)

              end if
           end if

           if (rdir > -1) then

              if (mype .ne. rdir) then

                 r_ind = wrf_cmaq_loc_ngb_recv_from(8-k,2)
                 j = (r_ind - 1) * 3 + 1

                 data_size = size_l_v * wrf_cmaq_recv_index_l(j+2,1,mype) * wrf_cmaq_recv_index_l(j+2,2,mype)

                 allocate (rarray(data_size), stat=error)
!                tag = flag * 1000000 + rdir * 1000 + mype
                 tag = flag * 1000 + mype

                 call mpi_recv (rarray, data_size, mpi_real, rdir, tag,
     $                          mpi_comm_world, status, error)

                 index = 0
                 do v = 1, nvars
                    do l = 1, nlays
                       do r = wrf_cmaq_recv_index_l(j,2,mype), wrf_cmaq_recv_index_l(j+1,2,mype)
                          do c = wrf_cmaq_recv_index_l(j,1,mype), wrf_cmaq_recv_index_l(j+1,1,mype)
                             index = index + 1
                             cmaq_data(c,r,l,v) = rarray(index)
                          end do
                       end do
                     end do
                 end do
                 deallocate (rarray)
              end if
           end if

        end do

        return
        end subroutine se_wrf_cmaq_comm4

! -----------------------------------------------------------------------------

        subroutine se_cmaq_wrf_comm2 (mype, cmaq_data, wrf_data,
     &                                cmaq_wrf_send_to, cmaq_wrf_recv_from,
     &                                cmaq_wrf_send_index_l, cmaq_wrf_recv_index_l, 
     &                                flag)

        implicit none

        integer, intent(in) :: mype
        real, intent(in)  :: cmaq_data(:,:)
        real, intent(out) :: wrf_data(:,:)
        integer, pointer :: cmaq_wrf_send_to(:,:), cmaq_wrf_recv_from(:,:)
        integer, pointer :: cmaq_wrf_send_index_l(:,:,:), cmaq_wrf_recv_index_l(:,:,:)
        integer, intent(in) :: flag

        include "mpif.h"

        integer :: c, r, lc, lr, i, j, k, index, sdir, rdir, 
     $             request, status(MPI_STATUS_SIZE), error
        integer :: data_size, tag, li, lj, s_ind, r_ind
        real,allocatable :: sarray(:), rarray(:)
        logical :: found

           call compute_ngb (mype, cmaq_wrf_loc_ngb, se_twoway_npcol,
     $                       se_twoway_nprow)

           do k = 0, 8

              call loc_index (cmaq_wrf_loc_ngb(k), cmaq_wrf_send_to(:,mype), 
     $                        cmaq_wrf_loc_ngb_send_to(k,1),
     $                        cmaq_wrf_loc_ngb_send_to(k,2))
              call loc_index (cmaq_wrf_loc_ngb(8-k), cmaq_wrf_recv_from(:,mype), 
     $                        cmaq_wrf_loc_ngb_recv_from(8-k,1),
     $                        cmaq_wrf_loc_ngb_recv_from(8-k,2))
           end do

        do k = 0, 8

           sdir = cmaq_wrf_loc_ngb_send_to(k,1)
           rdir = cmaq_wrf_loc_ngb_recv_from(8-k,1)

           if (sdir > -1) then
              s_ind = cmaq_wrf_loc_ngb_send_to(k,2)
              j = (s_ind - 1) * 3 + 1

              if (mype .eq. sdir) then

                 found = .false.
                 li = 0
                 do while (.not. found)
                    li = li + 1
                    if (mype .eq. cmaq_wrf_recv_from(li, mype)) then
                       found = .true.
                       lj = (li - 1) * 3 + 1
                    end if
                 end do

                 lr = cmaq_wrf_recv_index_l(lj,2,mype) - 1
                 do r = cmaq_wrf_send_index_l(j,2,mype), cmaq_wrf_send_index_l(j+1,2,mype)
                    lr = lr + 1
                    lc = cmaq_wrf_recv_index_l(lj,1,mype) - 1
                    do c = cmaq_wrf_send_index_l(j,1,mype), cmaq_wrf_send_index_l(j+1,1,mype)
                       lc = lc + 1
                       wrf_data(lc,lr) = cmaq_data(c,r)
                    end do
                 end do
              else
                 data_size = cmaq_wrf_send_index_l(j+2,1,mype) * cmaq_wrf_send_index_l(j+2,2,mype)

                 allocate (sarray(data_size), stat=error)
                 index = 0
                 do r = cmaq_wrf_send_index_l(j,2,mype), cmaq_wrf_send_index_l(j+1,2,mype)
                    do c = cmaq_wrf_send_index_l(j,1,mype), cmaq_wrf_send_index_l(j+1,1,mype)
                       index = index + 1
                       sarray(index) = cmaq_data(c,r)
                    end do
                 end do
!                tag = flag * 1000000 + mype * 1000 + sdir
                 tag = flag * 1000 + sdir

                 call mpi_send (sarray, data_size, mpi_real, sdir,
     &                          tag, mpi_comm_world, error)

                 deallocate (sarray)

              end if
           end if

           if (rdir > -1) then

              if (mype .ne. rdir) then

                 r_ind = cmaq_wrf_loc_ngb_recv_from(8-k,2)
                 j = (r_ind - 1) * 3 + 1

                 data_size = cmaq_wrf_recv_index_l(j+2,1,mype) * cmaq_wrf_recv_index_l(j+2,2,mype)

                 allocate (rarray(data_size), stat=error)
!                tag = flag * 1000000 + rdir * 1000 + mype
                 tag = flag * 1000 + mype

                 call mpi_recv (rarray, data_size, mpi_real, rdir, tag,
     $                          mpi_comm_world, status, error)

                 index = 0
                 do r = cmaq_wrf_recv_index_l(j,2,mype), cmaq_wrf_recv_index_l(j+1,2,mype)
                    do c = cmaq_wrf_recv_index_l(j,1,mype), cmaq_wrf_recv_index_l(j+1,1,mype)
                       index = index + 1
                       wrf_data(c,r) = rarray(index)
                    end do
                 end do
                 deallocate (rarray)
              end if
           end if

        end do

        return
        end subroutine se_cmaq_wrf_comm2

! -----------------------------------------------------------------------------

        subroutine se_cmaq_wrf_comm3 (mype, cmaq_data, wrf_data,
     &                                cmaq_wrf_send_to, cmaq_wrf_recv_from,
     &                                cmaq_wrf_send_index_l, cmaq_wrf_recv_index_l, 
     &                                flag)

        implicit none

        integer, intent(in) :: mype
        real, intent(in)  :: cmaq_data(:,:,:)
        real, intent(out) :: wrf_data(:,:,:)
        integer, pointer :: cmaq_wrf_send_to(:,:), cmaq_wrf_recv_from(:,:)
        integer, pointer :: cmaq_wrf_send_index_l(:,:,:), cmaq_wrf_recv_index_l(:,:,:)
        integer, intent(in) :: flag

        include "mpif.h"

        integer :: c, r, lc, lr, d, i, j, k, index, sdir, rdir, 
     $             request, status(MPI_STATUS_SIZE), error
        integer :: data_size, size_3d, tag, li, lj, s_ind, r_ind
        real,allocatable :: sarray(:), rarray(:)
        logical :: found

        integer :: total_s, total_r, n_s, n_r
        integer :: total_ss, total_rr, n_ss, n_rr

!       if (.not. cmaq_wrf_computed) then
           call  compute_ngb (mype, cmaq_wrf_loc_ngb, se_twoway_npcol, 
     $                        se_twoway_nprow)

!         write (6, '(a13, 9i5)') ' ==dc3 ngb a ', cmaq_wrf_loc_ngb

!         write (6, '(a15, 20i5)') ' ==dc3 send to ', 
!    $      cmaq_wrf_send_to(0:cmaq_wrf_send_to(0,mype), mype)

!         write (6, '(a15, 20i5)') ' ==dc3 recv fr ', 
!    $      cmaq_wrf_recv_from(0:cmaq_wrf_recv_from(0,mype), mype)

           cmaq_wrf_computed = .true.
           do k = 0, 8

              call loc_index (cmaq_wrf_loc_ngb(k), cmaq_wrf_send_to(:,mype), 
     $                        cmaq_wrf_loc_ngb_send_to(k,1), 
     $                        cmaq_wrf_loc_ngb_send_to(k,2)) 
              call loc_index (cmaq_wrf_loc_ngb(8-k), cmaq_wrf_recv_from(:,mype), 
     $                        cmaq_wrf_loc_ngb_recv_from(8-k,1), 
     $                        cmaq_wrf_loc_ngb_recv_from(8-k,2)) 
           end do

!          do k = 0, 8
!         write (6, '(a13, 9i5)') ' ==dc3 ngb b ', k, cmaq_wrf_loc_ngb_send_to(k,:)
!          end do
!          do k = 0, 8
!         write (6, '(a13, 9i5)') ' ==dc3 ngb c ', k, cmaq_wrf_loc_ngb_recv_from(k,:)
!          end do

!       end if

        size_3d = size(cmaq_data, 3)

        n_s = 0
        n_r = 0
        do k = 0, 8

           sdir = cmaq_wrf_loc_ngb_send_to(k,1) 
           rdir = cmaq_wrf_loc_ngb_recv_from(8-k,1) 
 
           if (sdir > -1) then
              total_s = total_s + 1 
              s_ind = cmaq_wrf_loc_ngb_send_to(k,2)
              j = (s_ind - 1) * 3 + 1

              if (mype .eq. sdir) then

                 found = .false.
                 li = 0
                 do while (.not. found)
                    li = li + 1
                    if (mype .eq. cmaq_wrf_recv_from(li, mype)) then
                       found = .true.
                       lj = (li - 1) * 3 + 1
                    end if
                 end do

                 lr = cmaq_wrf_recv_index_l(lj,2,mype) - 1
                 do r = cmaq_wrf_send_index_l(j,2,mype), cmaq_wrf_send_index_l(j+1,2,mype)
                    lr = lr + 1
                    lc = cmaq_wrf_recv_index_l(lj,1,mype) - 1
                    do c = cmaq_wrf_send_index_l(j,1,mype), cmaq_wrf_send_index_l(j+1,1,mype)
                       lc = lc + 1
                       wrf_data(lc,lr,:) = cmaq_data(c,r,:)
                    end do
                 end do
              else
                 data_size = size_3d * cmaq_wrf_send_index_l(j+2,1,mype) * cmaq_wrf_send_index_l(j+2,2,mype)

                 allocate (sarray(data_size), stat=error)
                 index = 0
                 do d = 1, size_3d
                    do r = cmaq_wrf_send_index_l(j,2,mype), cmaq_wrf_send_index_l(j+1,2,mype)
                       do c = cmaq_wrf_send_index_l(j,1,mype), cmaq_wrf_send_index_l(j+1,1,mype)
                          index = index + 1
                          sarray(index) = cmaq_data(c,r,d)
                       end do
                    end do
                 end do
!                tag = flag * 1000000 + mype * 1000 + sdir
                 tag = flag * 1000 + sdir

!        write (6, '(a12, 2i5, 8i10)') ' ==dc3 send ', j, sdir, tag, data_size, 
!    $     size_3d, cmaq_wrf_send_index_l(j+2,1,mype),
!    $     cmaq_wrf_send_index_l(j+2,2,mype), size(sarray)

                 call mpi_send (sarray, data_size, mpi_real, sdir,
     &                          tag, mpi_comm_world, error)

                 deallocate (sarray)

              end if
           end if

           if (rdir > -1) then

              total_r = total_r + 1 
              if (mype .ne. rdir) then

                 r_ind = cmaq_wrf_loc_ngb_recv_from(8-k,2)
                 j = (r_ind - 1) * 3 + 1

                 data_size = size_3d * cmaq_wrf_recv_index_l(j+2,1,mype) * cmaq_wrf_recv_index_l(j+2,2,mype)

                 allocate (rarray(data_size), stat=error)
!                tag = flag * 1000000 + rdir * 1000 + mype
                 tag = flag * 1000 + mype

                 call mpi_recv (rarray, data_size, mpi_real, rdir, tag, 
     $                          mpi_comm_world, status, error)

!        write (6, '(a12, 2i5, 10i8)') ' ==dc3 recv ', j, rdir, tag,
!    $       data_size, size_3d, cmaq_wrf_recv_index_l(j+2,1,mype), 
!    $       cmaq_wrf_recv_index_l(j+2,2,mype), size(rarray)

                 index = 0
                 do d = 1, size_3d
                    do r = cmaq_wrf_recv_index_l(j,2,mype), cmaq_wrf_recv_index_l(j+1,2,mype)
                       do c = cmaq_wrf_recv_index_l(j,1,mype), cmaq_wrf_recv_index_l(j+1,1,mype)
                          index = index + 1
                          wrf_data(c,r,d) = rarray(index)
                       end do
                     end do
                 end do
                 deallocate (rarray)
              end if
           end if

        end do

        end subroutine se_cmaq_wrf_comm3

! -----------------------------------------------------------------------------

        subroutine se_cmaq_wrf_comm4 (mype, cmaq_data, wrf_data,
     &                                cmaq_wrf_send_to, cmaq_wrf_recv_from,
     &                                cmaq_wrf_send_index_l, cmaq_wrf_recv_index_l, 
     &                                flag)

        implicit none

        integer, intent(in) :: mype
        real, intent(in)  :: cmaq_data(:,:,:,:)
        real, intent(out) :: wrf_data(:,:,:,:)
        integer, pointer :: cmaq_wrf_send_to(:,:), cmaq_wrf_recv_from(:,:)
        integer, pointer :: cmaq_wrf_send_index_l(:,:,:), cmaq_wrf_recv_index_l(:,:,:)
        integer, intent(in) :: flag

        include "mpif.h"

        integer :: sdir, rdir, size_l_v, nlays, nvars, si, ri
        logical :: done
        integer :: c, r, l, v, i, j, k, data_size, tag, li, lj, s_ind, 
     $             r_ind, index, lr, lc,
     $             request, status(MPI_STATUS_SIZE), error
        real,allocatable :: sarray(:), rarray(:)
        logical :: found

           call  compute_ngb (mype, cmaq_wrf_loc_ngb, se_twoway_npcol,
     $                        se_twoway_nprow)

!         write (6, '(a13, 9i5)') ' ==dc4 ngb a ', cmaq_wrf_loc_ngb

!         write (6, '(a15, 20i5)') ' ==dc4 send to ', 
!    $      cmaq_wrf_send_to(0:cmaq_wrf_send_to(0,mype), mype)

!         write (6, '(a15, 20i5)') ' ==dc4 recv fr ', 
!    $      cmaq_wrf_recv_from(0:cmaq_wrf_recv_from(0,mype), mype)

           do k = 0, 8

              call loc_index (cmaq_wrf_loc_ngb(k), cmaq_wrf_send_to(:,mype), 
     $                        cmaq_wrf_loc_ngb_send_to(k,1),
     $                        cmaq_wrf_loc_ngb_send_to(k,2))
              call loc_index (cmaq_wrf_loc_ngb(8-k), cmaq_wrf_recv_from(:,mype), 
     $                        cmaq_wrf_loc_ngb_recv_from(8-k,1),
     $                        cmaq_wrf_loc_ngb_recv_from(8-k,2))
           end do

!          do k = 0, 8
!         write (6, '(a13, 9i5)') ' ==dc4 ngb b ', k, cmaq_wrf_loc_ngb_send_to(k,:)
!          end do
!          do k = 0, 8
!         write (6, '(a13, 9i5)') ' ==dc4 ngb c ', k, cmaq_wrf_loc_ngb_recv_from(k,:)
!          end do

        nlays = size(cmaq_data, 3)
        nvars = size(cmaq_data, 4)
        size_l_v = nlays * nvars

        do k = 0, 8

           sdir = cmaq_wrf_loc_ngb_send_to(k,1)
           rdir = cmaq_wrf_loc_ngb_recv_from(8-k,1)

           if (sdir > -1) then
              s_ind = cmaq_wrf_loc_ngb_send_to(k,2)
              j = (s_ind - 1) * 3 + 1

              if (mype .eq. sdir) then

                 found = .false.
                 li = 0
                 do while (.not. found)
                    li = li + 1
                    if (mype .eq. cmaq_wrf_recv_from(li, mype)) then
                       found = .true.
                       lj = (li - 1) * 3 + 1
                    end if
                 end do

                 lr = cmaq_wrf_recv_index_l(lj,2,mype) - 1
                 do r = cmaq_wrf_send_index_l(j,2,mype), cmaq_wrf_send_index_l(j+1,2,mype)
                    lr = lr + 1
                    lc = cmaq_wrf_recv_index_l(lj,1,mype) - 1
                    do c = cmaq_wrf_send_index_l(j,1,mype), cmaq_wrf_send_index_l(j+1,1,mype)
                       lc = lc + 1
                       wrf_data(lc,lr,:,:) = cmaq_data(c,r,:,:)
                    end do
                 end do
              else
                 data_size = size_l_v * cmaq_wrf_send_index_l(j+2,1,mype) * cmaq_wrf_send_index_l(j+2,2,mype)

                 allocate (sarray(data_size), stat=error)
                 index = 0
                 do v = 1, nvars
                    do l = 1, nlays
                       do r = cmaq_wrf_send_index_l(j,2,mype), cmaq_wrf_send_index_l(j+1,2,mype)
                          do c = cmaq_wrf_send_index_l(j,1,mype), cmaq_wrf_send_index_l(j+1,1,mype)
                             index = index + 1
                             sarray(index) = cmaq_data(c,r,l,v)
                          end do
                       end do
                    end do
                 end do
!                tag = flag * 1000000 + mype * 1000 + sdir
                 tag = flag * 1000 + sdir

!        write (6, '(a12, 2i5, 8i10)') ' ==dc4 send ', j, sdir, tag, data_size, 
!    $     size_l_v, cmaq_wrf_send_index_l(j+2,1,mype),
!    $     cmaq_wrf_send_index_l(j+2,2,mype), size(sarray)

                 call mpi_send (sarray, data_size, mpi_real, sdir,
     &                          tag, mpi_comm_world, error)

                 deallocate (sarray)

              end if
           end if

           if (rdir > -1) then

              if (mype .ne. rdir) then

                 r_ind = cmaq_wrf_loc_ngb_recv_from(8-k,2)
                 j = (r_ind - 1) * 3 + 1

                 data_size = size_l_v * cmaq_wrf_recv_index_l(j+2,1,mype) * cmaq_wrf_recv_index_l(j+2,2,mype)

                 allocate (rarray(data_size), stat=error)
!                tag = flag * 1000000 + rdir * 1000 + mype
                 tag = flag * 1000 + mype

!        write (6, '(a12, 2i5, 10i8)') ' ==dc4 recv ', j, rdir, tag,
!    $       data_size, size_l_v, cmaq_wrf_recv_index_l(j+2,1,mype), 
!    $       cmaq_wrf_recv_index_l(j+2,2,mype), size(rarray)

                 call mpi_recv (rarray, data_size, mpi_real, rdir, tag,
     $                          mpi_comm_world, status, error)

                 index = 0
                 do v = 1, nvars
                    do l = 1, nlays
                       do r = cmaq_wrf_recv_index_l(j,2,mype), cmaq_wrf_recv_index_l(j+1,2,mype)
                          do c = cmaq_wrf_recv_index_l(j,1,mype), cmaq_wrf_recv_index_l(j+1,1,mype)
                             index = index + 1
                             wrf_data(c,r,l,v) = rarray(index)
                          end do
                       end do
                     end do
                 end do
                 deallocate (rarray)
              end if
           end if

        end do

        return
        end subroutine se_cmaq_wrf_comm4

! -----------------------------------------------------------------------------

        subroutine se_twoway_send4 (mype, si, sdir, source_data, dest_data, 
     &                              recv_from, send_index_l, 
     &                              recv_index_l, flag, size_l_v,
     &                              nvars, nlays)

        integer, intent(in) :: mype, si, sdir, size_l_v, nvars, nlays
        real, intent(in)  :: source_data(:,:,:,:)
        real, intent(out) :: dest_data(:,:,:,:)
        integer, pointer :: recv_from(:,:)
        integer, pointer :: send_index_l(:,:,:), recv_index_l(:,:,:)
        integer, intent(in) :: flag

        include "mpif.h" 

        integer :: c, r, lc, lr, l, v, j, index, request, status(MPI_STATUS_SIZE), error
        integer :: data_size, tag, lj, li 
        real, allocatable :: sarray(:)
        logical :: found

        allocate (sarray(size(source_data)), stat=error)

           j = (si - 1) * 3 + 1            ! 1st diminsion of *_index_l array has three components: 
                                           ! starting index, ending index, and distance
                                           ! between starting and ending indices

           if (mype .eq. sdir) then

              found = .false.
              li = 0
              do while (.not. found)
                 li = li + 1
                 if (mype .eq. recv_from(li, mype)) then
                    found = .true.
                    lj = (li - 1) * 3 + 1
                 end if
              end do

              do v = 1, nvars
                 do l = 1, nlays
                    lr = recv_index_l(lj,2,mype) - 1
                    do r = send_index_l(j,2,mype), send_index_l(j+1,2,mype)
                       lr = lr + 1
                       lc = recv_index_l(lj,1,mype) - 1
                       do c = send_index_l(j,1,mype), send_index_l(j+1,1,mype)
                          lc = lc + 1
                          dest_data(lc,lr,l,v) = source_data(c,r,l,v)
                       end do
                    end do
                 end do
              end do

           else

              data_size = size_l_v * send_index_l(j+2,1,mype) * send_index_l(j+2,2,mype)

              index = 0
              do v = 1, nvars
                 do l = 1, nlays
                    do r = send_index_l(j,2,mype), send_index_l(j+1,2,mype)
                       do c = send_index_l(j,1,mype), send_index_l(j+1,1,mype)
                          index = index + 1
                          sarray(index) = source_data(c,r,l,v)
                       end do
                    end do
                 end do
              end do
!             tag = flag * 1000000 + mype * 1000 + sdir
              tag = flag * 1000 + sdir

!             call mpi_issend (sarray(1:data_size), data_size, mpi_real, sdir,
!    &                         tag, mpi_comm_world, request, error)
              call mpi_send (sarray(1:data_size), data_size, mpi_real, sdir,
     &                         tag, mpi_comm_world, error)

!             call mpi_wait (request, status, error)
!             call mpi_request_free (request, error)
           end if

        deallocate (sarray)

        end subroutine se_twoway_send4

! -----------------------------------------------------------------------------

        subroutine se_twoway_recv4 (mype, ri, rdir, dest_data, 
     &                              recv_index_l, flag, size_l_v,
     &                              nvars, nlays)

        integer, intent(in) :: mype, ri, rdir, size_l_v, nvars, nlays
        real, intent(out) :: dest_data(:,:,:,:)
        integer, pointer :: recv_index_l(:,:,:)
        integer, intent(in) :: flag

        include "mpif.h"

        integer :: c, r, lc, lr, l, v, j, index, request, status(MPI_STATUS_SIZE), error
        integer :: data_size, tag
        real, allocatable :: rarray(:)
        logical :: found

        allocate (rarray(size(dest_data)), stat=error)

              j = (ri - 1) * 3 + 1            ! 1st diminsion of *_index_l array has three components: 
                                              ! starting index, ending index, and distance
                                              ! between starting and ending indices

              data_size = size_l_v * recv_index_l(j+2,1,mype) * recv_index_l(j+2,2,mype)

!             tag = flag * 1000000 + rdir * 1000 + mype
              tag = flag * 1000 + mype

              call mpi_recv (rarray(1:data_size), data_size, mpi_real, rdir, tag, mpi_comm_world, status, error)

              index = 0
              do v = 1, nvars
                 do l = 1, nlays
                    do r = recv_index_l(j,2,mype), recv_index_l(j+1,2,mype)
                       do c = recv_index_l(j,1,mype), recv_index_l(j+1,1,mype)
                          index = index + 1
                          dest_data(c,r,l,v) = rarray(index)
                       end do
                    end do
                  end do
              end do

        deallocate (rarray)

        end subroutine se_twoway_recv4 

! -----------------------------------------------------------------------------
        subroutine compute_ngb (mype, loc_ngb, npcol, nprow)

        integer, intent(in)  :: mype, npcol, nprow
        integer, intent(out) :: loc_ngb(0:)

        integer :: loci, locj, pos, i, j
        integer, parameter :: conv(9) = (/ 0, 1, 2, 3, 5, 6, 7, 8, 4 /)

        loci = mype / npcol
        locj = mod ( mype, npcol )
        pos = 0
        do i = loci-1, loci+1
           do j = locj-1, locj+1
              if ( ( i .ne. loci ) .or. ( j .ne. locj ) ) then
                 pos = pos + 1
                 if ( ( i .ge. 0 ) .and. ( i .lt. nprow ) .and.
     &                ( j .ge. 0 ) .and. ( j .lt. npcol ) ) then
                    loc_ngb( conv( pos ) ) = i * npcol + j
                 else
                    loc_ngb( conv( pos ) ) = -1
                 end if
              else
                 loc_ngb( 4 ) = mype
              end if
           end do
        end do

        end subroutine compute_ngb

! -----------------------------------------------------------------------------
        subroutine loc_index (pe, list, dir, ind)

        integer, intent(in)  :: pe, list(0:)
        integer, intent(out) :: dir, ind

        logical :: found
        integer :: n

        found = .false.
        n = 0
        dir = -1
        ind = -1
        do while ((.not. found) .and. (n < list(0)))
           n = n + 1
           if (list(n) == pe) then
              found = .true.
              dir = list(n)
              ind = n
           end if
        end do

        end subroutine loc_index

      end module se_twoway_comm_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GETALPHA ( NUMI, MASSI, SURFI,
     &                      LWC, T, P, RHOAIR, ALFA0, ALFA2, ALFA3 )

C-----------------------------------------------------------------------
C  Description:
C    Calculate the in-cloud scavenging coefficients for number (alfa0),
C    surface area (alfa2) and mass (alfa3). This code combines the RPM
C    codes getcld.f, and pandkcd.f
 
C  Revision History:
C      Date       Who                      What
C    -------- -------------------------  -------------------------------
C    12/16/97 Dr. Francis S. Binkowski.  Coded
C    12/22/97 S.Roselle                  Revised to comply with M3 Coding
C                                           standards
C    02/10/99 Binkowski                  Added provision for 2nd moment
C                                           and variable geometric
C                                           standard deviation
C    09/25/00 S.Roselle                  Modified to enable backwards
C                                           compatibility with aerosol
C                                           model version 1
C    08/23/2005  Binkowski               Changed check on MASSI to
C                                           be 1.0e-6 [ug/M**3] rather than
C                                           to avoid difficulties causing NAN's
C                                           as found by Bonyoung Koo
C                                           I have also commented out some lines 
C                                           code that are unnecessary in this 
C                                           implementation
C-----------------------------------------------------------------------

      USE AERO_DATA
      USE CONST, ONLY : PI, RGASUNIV, AVO, GRAV
      IMPLICIT NONE

C...........Parameters:

      REAL, PARAMETER :: SIGC = 1.2     ! geometric standard deviation for cloud droplets

      REAL, PARAMETER :: P0 = 101325.0  ! Standard pressure [ Pa ]

      REAL, PARAMETER :: T0 = 288.0

      REAL, PARAMETER :: ONE3 = 1.0 / 3.0

      REAL, PARAMETER :: TWO3 = 2.0 / 3.0

      REAL, PARAMETER :: KBOLTZ = RGASUNIV / AVO    ! 1.38065E-23 [ J/K ]

      REAL, PARAMETER :: RHOPART = 1.0E3   ! particle density [ kg/ m**3 ]

!sjr  REAL, PARAMETER :: AERCONST = 6.0E-9 / ( RHOPART * PI / 6.0 )
      REAL, PARAMETER :: AERCONST = 1.0E-9 / ( RHOPART * PI / 6.0 )

      REAL, PARAMETER :: RHO_WATER = 1.0E3 ! density of water at 20 C & 1 ATM [ kg/m**3 ]

C...........Arguments:

      REAL          NUMI       ! total number concentration for the Aitken mode [ #/m**3 ]
      REAL          MASSI      ! total mass concentration in AItken mode [ ug/m**3 ]
      REAL          SURFI      ! total surface area in Aitken mode [ m**2 / m**3 ]
      REAL          LWC        ! cloud liquid water content [ kg/m**3 ]
      REAL          T          ! average cloud temperature [ K ]
      REAL          P          ! average cloud pressure [ Pa ]
      REAL          RHOAIR     ! average cloud density [ kg/m**3 ]
      REAL          ALFA0      ! scavenging coefficient for number [ 1/s ]
      REAL          ALFA2      ! scavenging coefficient for surface area [ 1/s ]
      REAL          ALFA3      ! scavenging coefficient for mass [ 1/s ]

C...........Local Variables (scalars):

      REAL          DGNI       ! geometric mean diameter for AItken mode [ m ]
      REAL          L2SGI      ! square of the log of the
                               ! Aitken mode geometric standard deviation
!     REAL          XXFN       ! fraction for computing L2SGI

c *** ranges for acceptable values of LOG( sigma_g).

      REAL, SAVE   :: MINL2SG  ! minimum value of L2SG
      REAL, SAVE   :: MAXL2SG  ! maximum value of L2SG
      REAL, SAVE   :: DEFL2SG  ! default value of L2SG if no surface area

      REAL          NC         ! total cloud droplet number concentration  [ #/m**3 ]
      REAL          DGC        ! geometric mean diameter for cloud droplet [ m ]
      REAL          ESG4       ! exp(0.5 * L2SGI )
      REAL          ESG16      ! exp(2.0 * L2SGI )
      REAL          ESG36      ! exp(4.5 * L2SGI )
      REAL          DG2        ! square of geometic mean diameter
      REAL          AMM2       ! -2nd moment of the Aitken mode distribution
      REAL          AMM1       ! -1st moment of the Aitken mode distribution
      REAL          AM1        ! 1st moment of the Aitken mode distribution
      REAL          AM0        ! alternative name for Aitken mode number  [ #/m**3]
      REAL          AM2        ! 2nd moment of the Aitken mode distribution
      REAL          AM3        ! 3rd moment of the Aitken mode distribution
      REAL          M0C        ! moments of the cloud droplet distribution
      REAL          M1C        ! moments of the cloud droplet distribution
      REAL          M2C        ! moments of the cloud droplet distribution

      REAL          LSGC, LSGC2  ! log and square of log of SIGC
      REAL, SAVE :: ESGC4      !
      REAL, SAVE :: ESGC16     !

      REAL          COEF       !
      !REAL          DIFF0      ! aerosol diffusivities
      !REAL          DIFF2      ! aerosol diffusivities
      REAL          DIFF3      ! aerosol diffusivities
      !REAL          PE0        ! Peclet numbers
      !REAL          PE2        ! Peclet numers
      REAL          PE3        ! Peclet numbers
      REAL          COEF2      !
      REAL          COEF3      !
      REAL          COEF4      !
      REAL          VSETTL     ! settling velocity for cloud drops
      REAL          LAMDA      ! mean free path of air [ m ]
      REAL          MU         ! dynamic viscosity [ kg/(m*s) ]
      REAL          NU         ! kinematic viscosity [ m**2/s ]

      REAL          CUBRT      ! cube root
      REAL          XX         ! dummy arguement for cube root

      REAL, SAVE :: CLCONST    !

      LOGICAL, SAVE :: FIRSTIME = .TRUE.   ! flag for first pass thru

C...........Statement Functions:

      CUBRT( XX ) = EXP( ONE3 * LOG( XX ) )

C-----------------------------------------------------------------------
C     begin body of subroutine GETALPHA

      IF ( FIRSTIME ) THEN
        FIRSTIME = .FALSE.

C...compute special variables for moments
C...  of cloud droplet distribution

        LSGC   = LOG( SIGC )
        LSGC2  = LSGC * LSGC
        ESGC4  = EXP( 0.5 * LSGC2 )
        ESGC16 = EXP( 2.0 * LSGC2 )

C...compute constant for obtaining dgc

        CLCONST = 6.0 / ( RHO_WATER * PI * EXP( 4.5 * LOG( SIGC ) ** 2 ) )

        MINL2SG = LOG( MIN_SIGMA_G ) ** 2.0        ! minimum sigma_g = 1.05 (2.380480e-3)
        MAXL2SG = LOG( MAX_SIGMA_G ) ** 2.0        ! maximum sigma_g = 2.5  (8.395887e-1)
        DEFL2SG = LOG( DEF_SIGMA_G( 1 ) ) ** 2.0   ! default sigma_g = 1.7  (2.815663e-1)

      END IF ! check on firstime

C...check to make sure that there is aerosol mass and number before
C... proceeding, if not set alphas to zero

!cc FSB      IF ( ( NUMI .LE. 0.0 ) .OR. ( MASSI .LE. 0.0 ) .OR.
!cc FSB    &     ( LWC  .LE. 0.0 ) ) THEN

C FSB mass check changed to be 1.0e-6 [ug/m**3] - 08/23/2005
C     to avoid AM3 becomming too small.  With this change
C     AM3 is no smaller than 1.0e-18

      IF ( ( NUMI .LE. 0.0 ) .OR. ( MASSI .LE. 1.0e-6 ) .OR.
     &     ( LWC  .LE. 0.0 ) ) THEN
!cc     &     ( SURFI .LE. 0.0 ) .OR. ( LWC  .LE. 0.0 ) ) THEN
        ALFA0 = 0.0
        ALFA2 = 0.0
        ALFA3 = 0.0
        RETURN
      END IF

C...get cloud characteristics
C...  reference: Bower, K.N. and T.W. Choularton, 1992,
C...  " A parameterisation of the effective radius of ice
C...  free clouds for use in global climate models"
C...  Atmospheric Research, 27, 305-339, figures 10 & 11.
C...
C...  data in Bower & Choularton fit with quadratic function
C...  for droplet number as a function of lwc

C...calculate the total number concentration of cloud droplets.

      IF ( LWC .LE. 3.0E-3 ) THEN
        NC = 4.80E11 * LWC - 8.0E13 * LWC * LWC
      ELSE
        NC = 7.20E8
      END IF

C...calculate dgc

      DGC =  CUBRT( CLCONST * LWC / NC )

C...get m0c cloud droplet number and 1st and 2nd moments
C...  of cloud droplet distribution

      M0C = NC
      M1C = M0C * DGC * ESGC4
      M2C = M0C * DGC * DGC * ESGC16

C...set values for the 0th and 3rd moments

      AM3   = AERCONST * MASSI
      AM0   = NUMI

C...Check to see if surface area exists and process accordingly

      IF ( SURFI .GT. 0.0 ) THEN

C...set the 2nd moment value

        AM2   = SURFI / PI

C...get square of the log of the geometric standard deviation L2SGI
C...  The following method is much more robust, even if it uses three log calls.

        L2SGI = ONE3 * LOG( AM0 ) +
     &          TWO3 * LOG( AM3 ) -
     &                 LOG( AM2 )

        L2SGI = MAX( MINL2SG, L2SGI )
        L2SGI = MIN( MAXL2SG, L2SGI )

      ELSE

C...set the standard deviation to a fixed value (e.g. 1.7)

        L2SGI = DEFL2SG

C...calculate the 2nd moment based on the fixed standard deviation

        AM2 = EXP( TWO3 * LOG( AM3 ) +
     &             ONE3 * LOG( AM0 ) -
     &             L2SGI )

      END IF

C...compute special variables for moments
C...  of Aitken mode distribution

      ESG4  = EXP( 0.5 * L2SGI )
      ESG16 = EXP( 2.0 * L2SGI )
      ESG36 = ESG4 * ESG16 * ESG16

C...calculate dgni from numi and m3i

      DGNI = CUBRT( AM3 / ( AM0 * ESG36 ) )
      DG2  = DGNI  * DGNI

C...now get other aerosol moments

      AMM2  = AM0  * ESG16 / DG2
      AMM1  = AM0  * ESG4  / DGNI
      AM1   = AM0  * DGNI  * ESG4

C...calculate:
C...  lamda     mean free path of air [ m ]
C...  mu        dynamic viscosity [ kg/(m*s) ]
C...  nu        kinematic viscosity [ m**2/s ]

      MU = 1.458E-6 * T * SQRT( T ) / ( T + 110.4 )
      LAMDA = 6.6328E-8 * ( P0 / P ) * ( T / T0 )
      NU = MU / RHOAIR

C...implement Pruppacher and Klett method for scavenging coefficients
C...  calculates scavenging coefficients for number and mass
C...  of interstitial aerosol with a variable sigma_g.
C...  this method uses Brownian diffusion with convective enhancement.
C...  reference:
C...      Pruppacher & Klett "Microphysics of Clouds & Precipitation"
C...                             pp 380 - 384, 1978, D. Reidel

      COEF = KBOLTZ * ( T / ( 3.0 * PI * MU ) )

C...get aerosol diffusivities

!cc FSB these values are not used
!cc      DIFF0 = COEF * ( AMM1 + 2.492 * LAMDA * AMM2 ) / AM0
!cc      DIFF2 = COEF * ( AM1  + 2.492 * LAMDA * AM0  ) / AM2
      DIFF3 = COEF * ( ( AM2  + 2.492 * LAMDA * AM1  ) / AM3 )

C...set up coefficient coef2 for settling velocity of cloud drops

      COEF2 = ( GRAV / ( 18.0 * NU ) ) * ( RHOPART / RHOAIR )

C...get settling velocity for cloud drops

      VSETTL = COEF2 * M2C / M0C

C...set up for Peclet numbers

      COEF3 = VSETTL * DGC

C...calculate Peclet numbers

!cc FSB because these Peclet numbers are not used, I have commented 
!cc     these lines of code - Binkowski 08/23/2005
!cc      PE0 = COEF3 / DIFF0
!cc      PE2 = COEF3 / DIFF2
      PE3 = COEF3 / DIFF3

C...now get in-cloud scavenging coefficients
C...  including convective enhancement

      COEF4  = 2.0 * PI * M1C

!cc FSB use a common value, that for 3rd moment.
!cc
!cc      ALFA0 = COEF4 * DIFF0 * ( 1.0 + 0.5 * CUBRT( PE0 ) )
!cc      ALFA2 = COEF4 * DIFF2 * ( 1.0 + 0.5 * CUBRT( PE2 ) )
      ALFA3 = COEF4 * DIFF3 * ( 1.0 + 0.5 * CUBRT( PE3 ) )
      ALFA0 = ALFA3
      ALFA2 = ALFA3

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module desid_vars

!-----------------------------------------------------------------------
! Function: Define global variables used for emissions processor

! Revision History:
!     09 Nov 2017 B.Murphy: Extracted these variables from EMIS_DEFN
!-----------------------------------------------------------------------
      use runtime_vars
      use desid_param_module

      IMPLICIT NONE

      SAVE
      REAL,    ALLOCATABLE :: CELLAREA( :,: )
      REAL,    ALLOCATABLE :: CELLHGT ( :,:,: )
      REAL,    ALLOCATABLE :: CELLVOL ( :,:,: )
      REAL                 :: DX1, DX2
      REAL,    ALLOCATABLE :: VDEMIS_DIFF( :,:,:,: ) ! emissions array mapped to diffused species

      INTEGER              :: DESID_LAYS

      CHARACTER( 16 ), ALLOCATABLE :: LOCAL_SPEC( : )   ! Vector of Internal CMAQ Species names for each 
                                                        ! emission rule
      CHARACTER( 16 ), ALLOCATABLE :: LOCAL_EMVAR( :,: )! Emissions Variable to be read ( species, stream )

      TYPE DESID_EMVAR_TYPE
          INTEGER         :: LEN    ! Length of Sub-Vector
          CHARACTER( 16 ), ALLOCATABLE :: ARRY( : )    ! Emission Variable Name
          CHARACTER( 16 ), ALLOCATABLE :: UNITS( : )   ! Units determined from input files
          REAL,            ALLOCATABLE :: MW( : )      ! Default MW from SPECIATE/SMOKE/MOVE
          LOGICAL,         ALLOCATABLE :: USED( : )    ! Whether or not the variable is used in CMAQ
          Real,            ALLOCATABLE :: CONV( : )    ! Conversion factor to account for kg -> g or hr -> s
          CHARACTER( 16 ), ALLOCATABLE :: BASIS( : )   ! 'MOLE', 'MASS', or 'UNKNOWN' 
          LOGICAL,         ALLOCATABLE :: LAREA( : )   ! Whether or not the variable is an area flux
          LOGICAL,         ALLOCATABLE :: LAREAADJ( : )! Whether or not the emissions should be adjusted 
                                                       !    by the map scale factor
      END TYPE DESID_EMVAR_TYPE
      TYPE( DESID_EMVAR_TYPE ),ALLOCATABLE :: DESID_EMVAR( : )! Species to be read from each stream file

      TYPE DESID_FAC_TYPE
          INTEGER              :: NFAC    ! Number of scaling instructions that apply to this element of 
                                          !   the EM_FAC_ST structure. The other attributes will be of 
                                          !   length LEN.
          INTEGER              :: NREG    ! Number of unique regions for each instruction stack
          REAL, ALLOCATABLE    :: FAC(:)  ! Scale Factor applied with potential aerosol splitting
          REAL, ALLOCATABLE    :: BULK(:) ! Scale Factor for bulk emission without
                                          !   splitting for aerosols
          REAL, ALLOCATABLE    :: BASIS(:)! Conversion factor to account for mole or mass basis
          LOGICAL, ALLOCATABLE :: AREA(:) ! True if the emission is a flux that needs to be multiplied 
                                          !   by the grid cell area
          LOGICAL, ALLOCATABLE :: AREAADJ(:) ! True if the emissions need to be adjusted by the map scale
                                             !   factor to convert from real space to projected space
          INTEGER, ALLOCATABLE :: REG(:)  ! Index Mapping this entry to a particlar region in EM_REGIONS
          INTEGER, ALLOCATABLE :: REG_UNQ(:)    ! Record of Unique Regions for each instruction stack
          INTEGER, ALLOCATABLE :: REG_RMDR(:)   ! Map to remainder map
          INTEGER, ALLOCATABLE :: OP(:)   ! Operation to perform for this scaling
                                          !   (addition,'a' = 1, 
                                          !    multiplication,'m' = 2, 
                                          !    overwrite,'o' = 3)
      END TYPE DESID_FAC_TYPE
      TYPE( DESID_FAC_TYPE ), ALLOCATABLE :: DESID_FAC ( :,: ) ! Emissions Scale Factors ( species, stream )
      CHARACTER( 1 ) :: DESID_OP_NAME( 3 ) = (/'a','m','o'/)
      
      ! Define Region Remainder Mask Structure
      TYPE DESID_REG_RMDR_TYPE
          INTEGER              :: REG        ! large region with variable number of subset regions
          LOGICAL, ALLOCATABLE :: SUB(:)     ! If an element true, then that subset region is active in 
                                             !   the same instruction as the large region
          REAL, ALLOCATABLE    :: MASK(:,:)  ! Remainder of the large region minus all subset regions in SUB
      END TYPE DESID_REG_RMDR_TYPE
      TYPE( DESID_REG_RMDR_TYPE ),ALLOCATABLE :: DESID_REG_RMDR( : ) ! Structure of Masks defining the remainder of 
                                                                     ! regions after subtracting their subset regions

      ! Define Structure for Holding Emissions Aerosol Mode Information Globally
      TYPE DESID_STREAM_AERO_TYPE
         INTEGER  :: LEN
         INTEGER,         ALLOCATABLE :: REF( : )
         CHARACTER( 16 ), ALLOCATABLE :: NAME( : )
         REAL,            ALLOCATABLE :: FACNUM( :,: )
         REAL,            ALLOCATABLE :: FACSRF( :,: )
      END TYPE DESID_STREAM_AERO_TYPE
      TYPE( DESID_STREAM_AERO_TYPE ), ALLOCATABLE :: DESID_STREAM_AERO( : )
 
      ! Define Emissions File Attribute Variables
      CHARACTER( 200 ),ALLOCATABLE :: DESID_STREAM_NAME( : )  ! Filename of each emissions stream
      CHARACTER( 32  ),ALLOCATABLE :: DESID_STREAM_LAB ( : )  ! Nickname of each emissions stream
      CHARACTER( 16  ),ALLOCATABLE :: DESID_STREAM_TYPE( : )  ! shortname for the type of each emission
      INTEGER,         ALLOCATABLE :: DESID_STREAM_ITYPE( : ) ! shortname for the type of each emission
      CHARACTER( 100 ),ALLOCATABLE :: DESID_STREAM_DESC( : )  ! Description of each emissions stream
      LOGICAL,         ALLOCATABLE :: DESID_STREAM_LAPPLY( : )! Flag to use each emissions stream
      LOGICAL         ,ALLOCATABLE :: DESID_STREAM_DIFF( :,: )! Test for whether or not a stream contributes to 
                                                         !   a particular transported variable
      LOGICAL         ,ALLOCATABLE :: DESID_STREAM_SYM_DATE( : ) ! Toggle for whether or not to let the 
                                                             ! emission stream date override the model
      INTEGER         ,ALLOCATABLE :: DESID_STREAM_DATE( : )! Date to be read in from each emissions stream
      LOGICAL         ,ALLOCATABLE :: DESID_STREAM_FIRE( : )! Is this Emission Stream Representing Fires (1=Yes)

      INTEGER         ,ALLOCATABLE :: DESID_DIAG_N_STREAM( : )    ! Number of Streams for each diagnostic file
      LOGICAL         ,ALLOCATABLE :: DESID_DIAG_STREAM_MASK(:,:) ! True if a stream contributes to a diagnostic
      CHARACTER( 16 ) ,ALLOCATABLE :: DESID_DIAG_LOGICAL( : )     ! I/O Logical Name for each diagnostic file
      CHARACTER( 6 )  ,ALLOCATABLE :: DESID_DIAG_FORMAT( : )      ! FALSE/TRUE/2D/3D/2DCOL
      CHARACTER( 300 ),ALLOCATABLE :: DESID_DIAG_FILENAME( : )    ! Filename for diagnostic
      CHARACTER( 32 ) ,ALLOCATABLE :: DESID_DIAG_LAB( : )         ! Shorthand Label for Diagnostic
      INTEGER         ,ALLOCATABLE :: DESID_DIAG_LAYS( : )        ! Layers for each diagnostic file
      INTEGER         ,ALLOCATABLE :: DESID_DIAG_SUM( : )
      REAL            ,ALLOCATABLE :: VDEMIS_DIAG( :,:,:,: )      ! Rates for aggregate diagnostic files

      TYPE DESID_DIAG_SPEC_TYPE
         INTEGER                   :: NSPEC
         CHARACTER(16),ALLOCATABLE :: SPEC( : )
         CHARACTER(16),ALLOCATABLE :: UNITS( : )
         INTEGER                   :: NPAIRS
         INTEGER      ,ALLOCATABLE :: MAP_toDIFF( : )
         INTEGER      ,ALLOCATABLE :: MAP_toDIAG( : )
      END TYPE DESID_DIAG_SPEC_TYPE
      TYPE( DESID_DIAG_SPEC_TYPE ), ALLOCATABLE :: DESID_DIAG_SPEC( : )
      TYPE( DESID_DIAG_SPEC_TYPE ), ALLOCATABLE :: DESID_DIAG_SPEC_BUFF( : )

      INTEGER         ,ALLOCATABLE :: Map_DIAGtoVDEMIS( :,: )

      INTEGER              :: IBIOSRM, IMIOGSRM, IMGSRM, ILTSRM, ISEASRM, IDUSTSRM, IMETSRM
      INTEGER, ALLOCATABLE :: IGSRM( : ), IPSRM( : ), ITSRM( : ), MAP_PTtoISRM( : )

      INTEGER, ALLOCATABLE :: Map_ISTRtoEMVAR( :,: ), Map_ISTRtoDIFF( : ), Map_ISTRtoGAS( : )

      ! Create Lookup table of Molecular Weight for likely emission
      ! variable species. These values are used to compute mole <-> mass
      ! conversions if requested. This is a comprehensive list of all
      ! possible emitted species across all chemical mechanisms
      ! supported by CMAQ.
      Type desid_legend
          Character( 16 ) :: NAME  ! Emissions Variable Species
          REAL            :: MW    ! Emissions Variable Molecular Weight [g mol-1]
      End Type desid_legend
      
      Integer, Parameter :: Desid_N_Emvar_Table = 209
      Type( desid_legend ), save :: Desid_Emvar_Table( Desid_N_Emvar_Table)

      CONTAINS

        SUBROUTINE INIT_DESID_EMVAR_MW()

                                                                        ! CB SAPRC  CRACMM  
        ! Inorganic Gases
        Desid_Emvar_Table(  1) = desid_legend( 'CH4          ' ,016.0 ) ! x
        Desid_Emvar_Table(  2) = desid_legend( 'CL2          ' ,071.0 ) ! x    x
        Desid_Emvar_Table(  3) = desid_legend( 'CO           ' ,028.0 ) ! x    x      x
        Desid_Emvar_Table(  4) = desid_legend( 'HCL          ' ,036.5 ) ! x    x      x
        Desid_Emvar_Table(  5) = desid_legend( 'HONO         ' ,047.0 ) ! x    x      x
        Desid_Emvar_Table(  6) = desid_legend( 'NH3          ' ,017.0 ) ! x    x      x
        Desid_Emvar_Table(  7) = desid_legend( 'NH3_FERT     ' ,017.0 ) ! x    x      x
        Desid_Emvar_Table(  8) = desid_legend( 'NO           ' ,030.0 ) ! x    x      x
        Desid_Emvar_Table(  9) = desid_legend( 'NO2          ' ,046.0 ) ! x    x      x
        Desid_Emvar_Table( 10) = desid_legend( 'SO2          ' ,064.0 ) ! x    x      x
        Desid_Emvar_Table( 11) = desid_legend( 'SULF         ' ,098.0 ) ! x    x      x

        ! Organic Gases
        Desid_Emvar_Table( 12) = desid_legend( '13BDE        ' ,054.1 ) !
        Desid_Emvar_Table( 13) = desid_legend( 'AACD         ' ,060.1 ) ! x    x
        Desid_Emvar_Table( 14) = desid_legend( 'ACD          ' ,044.0 ) !             x
        Desid_Emvar_Table( 15) = desid_legend( 'ACE          ' ,026.0 ) !             x
        Desid_Emvar_Table( 16) = desid_legend( 'ACET         ' ,058.1 ) ! x    x
        Desid_Emvar_Table( 17) = desid_legend( 'ACETONE      ' ,058.1 ) !      x
        Desid_Emvar_Table( 18) = desid_legend( 'ACRO         ' ,056.1 ) !      x      x
        Desid_Emvar_Table( 19) = desid_legend( 'ACROLEIN     ' ,056.1 ) ! x    x
        Desid_Emvar_Table( 20) = desid_legend( 'ACT          ' ,058.0 ) !             x
        Desid_Emvar_Table( 21) = desid_legend( 'ACYE         ' ,026.0 ) !      x
        Desid_Emvar_Table( 22) = desid_legend( 'ALD          ' ,058.0 ) !             x
        Desid_Emvar_Table( 23) = desid_legend( 'ALD2         ' ,044.0 ) ! x
        Desid_Emvar_Table( 24) = desid_legend( 'ALD2_PRIMARY ' ,044.0 ) ! x
        Desid_Emvar_Table( 25) = desid_legend( 'ALDX         ' ,058.1 ) ! x
        Desid_Emvar_Table( 26) = desid_legend( 'ALK1         ' ,030.1 ) !      x
        Desid_Emvar_Table( 27) = desid_legend( 'ALK2         ' ,036.7 ) !      x
        Desid_Emvar_Table( 28) = desid_legend( 'ALK3         ' ,058.6 ) !      x
        Desid_Emvar_Table( 29) = desid_legend( 'ALK4         ' ,077.6 ) !      x
        Desid_Emvar_Table( 30) = desid_legend( 'ALK5         ' ,118.9 ) !      x
        Desid_Emvar_Table( 31) = desid_legend( 'API          ' ,136.4 ) !             x
        Desid_Emvar_Table( 32) = desid_legend( 'APIN         ' ,136.2 ) ! x    x
        Desid_Emvar_Table( 33) = desid_legend( 'ARO1         ' ,095.2 ) !      x
        Desid_Emvar_Table( 34) = desid_legend( 'ARO2MN       ' ,118.7 ) !      x
        Desid_Emvar_Table( 35) = desid_legend( 'B124         ' ,120.2 ) !      x
        Desid_Emvar_Table( 36) = desid_legend( 'BACL         ' ,086.1 ) !      x
        Desid_Emvar_Table( 37) = desid_legend( 'BALD         ' ,106.0 ) !      x      x
        Desid_Emvar_Table( 38) = desid_legend( 'BDE13        ' ,054.1 ) !      x      x
        Desid_Emvar_Table( 39) = desid_legend( 'BEN          ' ,078.1 ) !             x
        Desid_Emvar_Table( 40) = desid_legend( 'BENZ         ' ,078.1 ) ! x    x
        Desid_Emvar_Table( 41) = desid_legend( 'BENZENE      ' ,078.1 ) ! x
        Desid_Emvar_Table( 42) = desid_legend( 'BUTADIENE13  ' ,054.0 ) ! x
        Desid_Emvar_Table( 43) = desid_legend( 'CCHO         ' ,044.1 ) !      x
        Desid_Emvar_Table( 44) = desid_legend( 'CCOOH        ' ,060.05) !      x
        Desid_Emvar_Table( 45) = desid_legend( 'CRES         ' ,108.1 ) ! x    x
        Desid_Emvar_Table( 46) = desid_legend( 'CSL          ' ,136.2 ) !             x
        Desid_Emvar_Table( 47) = desid_legend( 'DCB1         ' ,098.0 ) !             x
        Desid_Emvar_Table( 48) = desid_legend( 'DIEN         ' ,054.0 ) !             x
        Desid_Emvar_Table( 49) = desid_legend( 'ETE          ' ,028.1 ) !             x
        Desid_Emvar_Table( 50) = desid_legend( 'ETEG         ' ,062.1 ) !             x
        Desid_Emvar_Table( 51) = desid_legend( 'ETHA         ' ,030.1 ) ! x
        Desid_Emvar_Table( 52) = desid_legend( 'ETH          ' ,030.1 ) ! x           x
        Desid_Emvar_Table( 53) = desid_legend( 'ETHE         ' ,028.1 ) !      x
        Desid_Emvar_Table( 54) = desid_legend( 'ETHENE       ' ,028.1 ) !      x
        Desid_Emvar_Table( 55) = desid_legend( 'ETHY         ' ,026.0 ) ! x
        Desid_Emvar_Table( 56) = desid_legend( 'ETOH         ' ,046.1 ) ! x    x
        Desid_Emvar_Table( 57) = desid_legend( 'EOH          ' ,046.1 ) !             x
        Desid_Emvar_Table( 58) = desid_legend( 'FACD         ' ,046.0 ) ! x    x
        Desid_Emvar_Table( 59) = desid_legend( 'FORM         ' ,030.0 ) ! x
        Desid_Emvar_Table( 60) = desid_legend( 'FORM_PRIMARY ' ,030.0 ) ! x
        Desid_Emvar_Table( 61) = desid_legend( 'FURAN        ' ,096.1 ) !             x
        Desid_Emvar_Table( 62) = desid_legend( 'GLY          ' ,058.0 ) ! x    x      x
        Desid_Emvar_Table( 63) = desid_legend( 'HC3          ' ,044.1 ) !             x
        Desid_Emvar_Table( 64) = desid_legend( 'HC5          ' ,072.1 ) !             x
        Desid_Emvar_Table( 65) = desid_legend( 'HC8          ' ,114.0 ) !             x
        Desid_Emvar_Table( 66) = desid_legend( 'HC10         ' ,142.28) !             x
        Desid_Emvar_Table( 67) = desid_legend( 'HCHO         ' ,030.0 ) !      x      x
        Desid_Emvar_Table( 68) = desid_legend( 'HCOOH        ' ,046.03) !      x
        Desid_Emvar_Table( 69) = desid_legend( 'HKET         ' ,074.0 ) !             x
        Desid_Emvar_Table( 70) = desid_legend( 'IOLE         ' ,056.1 ) ! x
        Desid_Emvar_Table( 71) = desid_legend( 'IPRD         ' ,100.1 ) !      x
        Desid_Emvar_Table( 72) = desid_legend( 'ISO          ' ,068.1 ) !             x
        Desid_Emvar_Table( 73) = desid_legend( 'ISOP         ' ,068.1 ) ! x    x
        Desid_Emvar_Table( 74) = desid_legend( 'ISOPRENE     ' ,068.1 ) !      x
        Desid_Emvar_Table( 75) = desid_legend( 'KET          ' ,086.0 ) ! x           x
        Desid_Emvar_Table( 76) = desid_legend( 'LIM          ' ,136.3 ) !             x
        Desid_Emvar_Table( 77) = desid_legend( 'MACR         ' ,070.0 ) !      x      x
        Desid_Emvar_Table( 78) = desid_legend( 'MCT          ' ,124.1 ) !             x
        Desid_Emvar_Table( 79) = desid_legend( 'MEK          ' ,072.1 ) !      x      x
        Desid_Emvar_Table( 80) = desid_legend( 'MEOH         ' ,032.0 ) ! x    x
        Desid_Emvar_Table( 81) = desid_legend( 'MGLY         ' ,072.0 ) ! x    x      x
        Desid_Emvar_Table( 82) = desid_legend( 'MOH          ' ,032.0 ) !             x
        Desid_Emvar_Table( 83) = desid_legend( 'MVK          ' ,070.1 ) !      x      x
        Desid_Emvar_Table( 84) = desid_legend( 'MXYL         ' ,106.2 ) !      x
        Desid_Emvar_Table( 85) = desid_legend( 'NAPH         ' ,128.17) ! x           x
        Desid_Emvar_Table( 86) = desid_legend( 'NAPHTHALENE  ' ,128.17) !      x
        Desid_Emvar_Table( 87) = desid_legend( 'OLE          ' ,042.1 ) ! x
        Desid_Emvar_Table( 88) = desid_legend( 'OLE1         ' ,072.3 ) !      x
        Desid_Emvar_Table( 89) = desid_legend( 'OLE2         ' ,075.8 ) !      x
        Desid_Emvar_Table( 90) = desid_legend( 'OLI          ' ,070.1 ) !             x
        Desid_Emvar_Table( 91) = desid_legend( 'OLT          ' ,042.0 ) !             x
        Desid_Emvar_Table( 92) = desid_legend( 'ONIT         ' ,119.0 ) !             x
        Desid_Emvar_Table( 93) = desid_legend( 'ORA1         ' ,046.0 ) !             x
        Desid_Emvar_Table( 94) = desid_legend( 'ORA2         ' ,060.2 ) !             x
        Desid_Emvar_Table( 95) = desid_legend( 'OXYL         ' ,106.2 ) !      x
        Desid_Emvar_Table( 96) = desid_legend( 'PACD         ' ,076.0 ) ! x    x
        Desid_Emvar_Table( 97) = desid_legend( 'PAR          ' ,014.0 ) ! x
        Desid_Emvar_Table( 98) = desid_legend( 'PHEN         ' ,110.1 ) !             x
        Desid_Emvar_Table( 99) = desid_legend( 'PRD2         ' ,116.2 ) !      x
        Desid_Emvar_Table(100) = desid_legend( 'PROG         ' ,076.1 ) !             x
        Desid_Emvar_Table(101) = desid_legend( 'PROPENE      ' ,042.1 ) !      x
        Desid_Emvar_Table(102) = desid_legend( 'PRPA         ' ,044.1 ) ! x
        Desid_Emvar_Table(103) = desid_legend( 'PRPE         ' ,042.1 ) !      x
        Desid_Emvar_Table(104) = desid_legend( 'PXYL         ' ,106.2 ) !      x
        Desid_Emvar_Table(105) = desid_legend( 'RCHO         ' ,058.1 ) !      x
        Desid_Emvar_Table(106) = desid_legend( 'RNO3         ' ,147.2 ) !      x
        Desid_Emvar_Table(107) = desid_legend( 'ROH          ' ,060.0 ) !             x
        Desid_Emvar_Table(108) = desid_legend( 'SESQ         ' ,204.4 ) ! x    x      x
        Desid_Emvar_Table(109) = desid_legend( 'SLOWROC      ' ,075.4 ) !             x      
        Desid_Emvar_Table(110) = desid_legend( 'SOAALK       ' ,112.0 ) ! x    x
        Desid_Emvar_Table(111) = desid_legend( 'TERP         ' ,136.2 ) ! x    x
        Desid_Emvar_Table(112) = desid_legend( 'TOL          ' ,092.1 ) ! x           x
        Desid_Emvar_Table(113) = desid_legend( 'TOLU         ' ,092.0 ) ! x    x
        Desid_Emvar_Table(114) = desid_legend( 'TOLUENE      ' ,092.1 ) !      x
        Desid_Emvar_Table(115) = desid_legend( 'UALD         ' ,084.1 ) !             x
        Desid_Emvar_Table(116) = desid_legend( 'VROCIOXY     ' ,247.0 ) !             x      
        Desid_Emvar_Table(117) = desid_legend( 'XYE          ' ,106.2 ) !             x
        Desid_Emvar_Table(118) = desid_legend( 'XYLMN        ' ,106.2 ) ! x
        Desid_Emvar_Table(119) = desid_legend( 'XYM          ' ,106.2 ) !             x
        Desid_Emvar_Table(120) = desid_legend( 'XYO          ' ,106.0 ) !             x
        Desid_Emvar_Table(121) = desid_legend( 'XYOP         ' ,106.2 ) !             x
        Desid_Emvar_Table(122) = desid_legend( 'XYP          ' ,106.0 ) !             x
                          

        ! Particles
        Desid_Emvar_Table(123) = desid_legend( 'ASOIL        ' ,100.0 ) ! x    x      x
        Desid_Emvar_Table(124) = desid_legend( 'ASEACAT      ' ,023.75) ! x    x      x
        Desid_Emvar_Table(125) = desid_legend( 'PAL          ' ,027.0 ) ! x    x      x
        Desid_Emvar_Table(126) = desid_legend( 'PCA          ' ,040.1 ) ! x    x      x
        Desid_Emvar_Table(127) = desid_legend( 'PCL          ' ,035.5 ) ! x    x      x
        Desid_Emvar_Table(128) = desid_legend( 'PEC          ' ,012.0 ) ! x    x      x
        Desid_Emvar_Table(129) = desid_legend( 'PFE          ' ,055.8 ) ! x    x      x
        Desid_Emvar_Table(130) = desid_legend( 'PK           ' ,039.1 ) ! x    x      x
        Desid_Emvar_Table(131) = desid_legend( 'PH2O         ' ,018.0 ) ! x    x      x
        Desid_Emvar_Table(132) = desid_legend( 'PMC          ' ,100.0 ) ! x    x      x
        Desid_Emvar_Table(133) = desid_legend( 'PMG          ' ,024.3 ) ! x    x      x
        Desid_Emvar_Table(134) = desid_legend( 'PMN          ' ,054.9 ) ! x    x      x
        Desid_Emvar_Table(135) = desid_legend( 'PMNCOMN2     ' ,422.83) ! x    x      x        POC value
        Desid_Emvar_Table(136) = desid_legend( 'PMOCN2       ' ,422.83) ! x    x      x        PNCOM value
        Desid_Emvar_Table(137) = desid_legend( 'PMOTHR       ' ,200.0 ) ! x    x      x
        Desid_Emvar_Table(138) = desid_legend( 'PNA          ' ,023.0 ) ! x    x      x
        Desid_Emvar_Table(139) = desid_legend( 'PNCOM        ' ,220.0 ) ! x    x      x
        Desid_Emvar_Table(140) = desid_legend( 'PNCOMN2      ' ,506.99) ! x    x      x        based on ALK equivalent C*
        Desid_Emvar_Table(141) = desid_legend( 'PNCOMN1      ' ,408.80) ! x    x      x        based on ALK equivalent C*
        Desid_Emvar_Table(142) = desid_legend( 'PNCOMP0      ' ,394.77) ! x    x      x        based on ALK equivalent C*
        Desid_Emvar_Table(143) = desid_legend( 'PNCOMP1      ' ,380.75) ! x    x      x        based on ALK equivalent C*
        Desid_Emvar_Table(144) = desid_legend( 'PNCOMP2      ' ,338.66) ! x    x      x        based on ALK equivalent C*
        Desid_Emvar_Table(145) = desid_legend( 'PNH4         ' ,018.0 ) ! x    x      x
        Desid_Emvar_Table(146) = desid_legend( 'PNO3         ' ,062.0 ) ! x    x      x
        Desid_Emvar_Table(147) = desid_legend( 'POC          ' ,220.0 ) ! x    x      x
        Desid_Emvar_Table(148) = desid_legend( 'POCN2        ' ,506.99) ! x    x      x        based on ALK equivalent C*
        Desid_Emvar_Table(149) = desid_legend( 'POCN1        ' ,408.80) ! x    x      x        based on ALK equivalent C*
        Desid_Emvar_Table(150) = desid_legend( 'POCP0        ' ,394.77) ! x    x      x        based on ALK equivalent C*
        Desid_Emvar_Table(151) = desid_legend( 'POCP1        ' ,380.75) ! x    x      x        based on ALK equivalent C*
        Desid_Emvar_Table(152) = desid_legend( 'POCP2        ' ,338.66) ! x    x      x      
        Desid_Emvar_Table(153) = desid_legend( 'PSI          ' ,028.1 ) ! x    x      x
        Desid_Emvar_Table(154) = desid_legend( 'PSO4         ' ,096.0 ) ! x    x      x
        Desid_Emvar_Table(155) = desid_legend( 'PTI          ' ,047.9 ) ! x    x      x
        Desid_Emvar_Table(156) = desid_legend( 'ROCN2        ' ,422.83) ! x    x      x      
        Desid_Emvar_Table(157) = desid_legend( 'ROCN1        ' ,408.8 ) ! x    x      x      
        Desid_Emvar_Table(158) = desid_legend( 'ROCP0        ' ,394.77) ! x    x      x      
        Desid_Emvar_Table(159) = desid_legend( 'ROCP1        ' ,380.75) ! x    x      x      
        Desid_Emvar_Table(160) = desid_legend( 'ROCP2        ' ,338.66) ! x    x      x      
        Desid_Emvar_Table(161) = desid_legend( 'ROCP3        ' ,296.58) ! x    x      x      
        Desid_Emvar_Table(162) = desid_legend( 'ROCP4        ' ,254.50) ! x    x      x      
        Desid_Emvar_Table(163) = desid_legend( 'ROCP5        ' ,198.39) ! x    x      x      
        Desid_Emvar_Table(164) = desid_legend( 'ROCP6        ' ,184.37) ! x    x      x      
        Desid_Emvar_Table(165) = desid_legend( 'ROCN2ALK     ' ,422.83) ! x    x      x      
        Desid_Emvar_Table(166) = desid_legend( 'ROCN1ALK     ' ,408.8 ) ! x    x      x      
        Desid_Emvar_Table(167) = desid_legend( 'ROCP0ALK     ' ,394.77) ! x    x      x      
        Desid_Emvar_Table(168) = desid_legend( 'ROCP1ALK     ' ,380.75) ! x    x      x      
        Desid_Emvar_Table(169) = desid_legend( 'ROCP2ALK     ' ,338.66) ! x    x      x      
        Desid_Emvar_Table(160) = desid_legend( 'ROCP3ALK     ' ,296.58) ! x    x      x      
        Desid_Emvar_Table(171) = desid_legend( 'ROCP4ALK     ' ,254.50) ! x    x      x      
        Desid_Emvar_Table(172) = desid_legend( 'ROCP5ALK     ' ,198.39) ! x    x      x      
        Desid_Emvar_Table(173) = desid_legend( 'ROCP6ALK     ' ,184.37) ! x    x      x      
        Desid_Emvar_Table(174) = desid_legend( 'ROCP5ARO     ' ,190.33) ! x    x      x      
        Desid_Emvar_Table(175) = desid_legend( 'ROCP6ARO     ' ,176.30) ! x    x      x      
        Desid_Emvar_Table(176) = desid_legend( 'ROCN2OXY2    ' ,282.4 ) ! x    x      x      
        Desid_Emvar_Table(177) = desid_legend( 'ROCN2OXY4    ' ,232.3 ) ! x    x      x      
        Desid_Emvar_Table(178) = desid_legend( 'ROCP0OXY2    ' ,242.4 ) ! x    x      x      
        Desid_Emvar_Table(179) = desid_legend( 'ROCP0OXY4    ' ,202.3 ) ! x    x      x      
        Desid_Emvar_Table(170) = desid_legend( 'ROCP1OXY1    ' ,270.5 ) ! x    x      x      
        Desid_Emvar_Table(181) = desid_legend( 'ROCP1OXY3    ' ,202.3 ) ! x    x      x      
        Desid_Emvar_Table(182) = desid_legend( 'ROCP2OXY2    ' ,200.3 ) ! x    x      x      
        Desid_Emvar_Table(183) = desid_legend( 'ROCP3OXY2    ' ,186.3 ) ! x    x      x      
                           
        ! Toxics           
        Desid_Emvar_Table(184) = desid_legend( 'HGNRVA       ' ,200.6 ) 
        Desid_Emvar_Table(185) = desid_legend( 'HGIIGAS      ' ,200.6 ) 
        Desid_Emvar_Table(186) = desid_legend( 'NICKEL_F     ' ,058.7 ) 
        Desid_Emvar_Table(187) = desid_legend( 'NICKEL_C     ' ,058.7 ) 
        Desid_Emvar_Table(188) = desid_legend( 'CHROMEHEX_F  ' ,052.0 ) 
        Desid_Emvar_Table(189) = desid_legend( 'CHROMEHEX_C  ' ,052.0 ) 
        Desid_Emvar_Table(190) = desid_legend( 'CHROMTRI_F   ' ,052.0 ) 
        Desid_Emvar_Table(191) = desid_legend( 'CHROMTRI_C   ' ,052.0 ) 
        Desid_Emvar_Table(192) = desid_legend( 'BERYLLIUM_F  ' ,009.0 ) 
        Desid_Emvar_Table(193) = desid_legend( 'BERYLLIUM_C  ' ,009.0 ) 
        Desid_Emvar_Table(194) = desid_legend( 'LEAD_F       ' ,207.2 ) 
        Desid_Emvar_Table(195) = desid_legend( 'LEAD_C       ' ,207.2 ) 
        Desid_Emvar_Table(196) = desid_legend( 'DIESEL_PMFINE' ,200.0 ) 
        Desid_Emvar_Table(197) = desid_legend( 'DIESEL_PMEC  ' ,012.0 ) 
        Desid_Emvar_Table(198) = desid_legend( 'DIESEL_PMOC  ' ,220.0 ) 
        Desid_Emvar_Table(199) = desid_legend( 'DIESEL_PMNO3 ' ,062.0 ) 
        Desid_Emvar_Table(200) = desid_legend( 'DIESEL_PMSO4 ' ,096.0 ) 
        Desid_Emvar_Table(201) = desid_legend( 'DIESEL_PMC   ' ,100.0 ) 
        Desid_Emvar_Table(202) = desid_legend( 'CADMIUM_F    ' ,112.4 ) 
        Desid_Emvar_Table(203) = desid_legend( 'CADMIUM_C    ' ,112.4 ) 
        Desid_Emvar_Table(204) = desid_legend( 'MANGANESE_F  ' ,054.9 ) 
        Desid_Emvar_Table(205) = desid_legend( 'MANGANESE_C  ' ,054.9 ) 
        Desid_Emvar_Table(206) = desid_legend( 'ARSENIC_F    ' ,074.92) 
        Desid_Emvar_Table(207) = desid_legend( 'ARSENIC_C    ' ,074.92) 
        Desid_Emvar_Table(208) = desid_legend( 'PHGI         ' ,200.5 ) 
        Desid_Emvar_Table(209) = desid_legend( 'HF           ' ,020.1 )                                                                       
        END SUBROUTINE                                                  
                                                                        
                                                                        
      END MODULE DESID_VARS                                             
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        
                                                                        

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users requested to provide copies of derivative works or          !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module STAGE_DATA
C-----------------------------------------------------------------------
C Function: User-defined types

C Revision History:
C     26 June 2014 J.Bash: initial implementation

      Implicit None

      Real,    Parameter, Private :: pr         = 0.709      ! [dim'less]
      Real,    Parameter, Private :: twothirds  = 2.0 / 3.0
      
      INTEGER,           Save            :: dep_gas_all 
      Character( 16 ), Allocatable, Save :: vd_name     ( : )       ! Deposition species name
      Real, Allocatable, Save            :: rel_rx      ( : )       ! reactivity relative to HNO3
      Real, Allocatable, Save            :: LeBasM      ( : )       ! Le Bas molar volume [cm3/mol ]
      Real, Allocatable, Save            :: f0          ( : )       ! Exception for species that
      Real, Allocatable, Save            :: M_ac        ( : )       ! Mass accommodation Coeff
      Real, Allocatable, Save            :: molwt_all   ( : )       ! Molar Weight from the namelist
      CHARACTER( 16 ), Allocatable, SAVE :: H_name_all  ( : )       ! Henry's constant name for all species        
      Integer, Allocatable, SAVE         :: hlind       ( : )       ! Henry's constant index
      LOGICAL, Allocatable, SAVE         :: USE_DEPSPC  ( : )
      Logical, Allocatable, Save         :: asx_run_map ( : )

      INTEGER, SAVE                      :: N_USE_DEPSPC            ! number of gas species used in this simulation 
      CHARACTER( 16 ), Parameter         :: DEPV_METHOD = 'STAGE'

      Contains
         SUBROUTINE Map_STAGE( N_DEPV_NAMES, DEPV_NAMES, DEPV_SUR ) 

         USE CGRID_SPCS          ! CGRID mechanism species
         USE UTILIO_DEFN 
         USE RUNTIME_VARS, ONLY: STAGECTRL, LOGDEV!, log_message, log_subheading
         USE HLCONST_MOD

         IMPLICIT NONE

         INTEGER,         INTENT( IN )    :: N_DEPV_NAMES  ! number of unique dep vel species
         CHARACTER( 16 ), INTENT( INOUT ) :: DEPV_NAMES( : ) ! names of dep vel species
         INTEGER,         INTENT( OUT )   :: DEPV_SUR( : ) ! pointers to model species for
                                                        ! calculated deposition velocities
                                                        ! (surrogate dep vels [m/s**2])

         Integer                       :: c, r, l, n, s, v
         INTEGER                       :: STRT, FINI
         Integer                       :: ALLOCSTAT
         INTEGER                       :: DEPCTRL_NML
         INTEGER                       :: STAT
         CHARACTER( 16 ), ALLOCATABLE  :: gc_depv_name( : )
         CHARACTER( 16 )               :: VNAME            ! scratch string
         CHARACTER( 16 )               :: PNAME = 'Map_STAGE'
         CHARACTER( 120 )              :: XMSG = ' '
         Logical                       :: n_xref_end
         Logical                       :: lerror

         Integer, Parameter            :: n_max_depv = 300

         Type :: Chem_Data_Type
            Character( 16 ) :: vd_name 
            Real            :: rel_rx           ! reactivity relative to HNO3
            Real            :: f0               ! Exception for species that
            Real            :: LeBasM           ! Le Bas molar volume [cm3/mol ]
            Real            :: M_ac             ! Mass accommodation Coeff 
         End Type Chem_Data_Type 
 
         Type( Chem_Data_Type ) :: STAGE_CHEM_DATA( n_max_depv )

         NAMELIST / STAGE_DATA / STAGE_CHEM_DATA

         STAGE_CHEM_DATA%vd_name = 'N/A'
         STAGE_CHEM_DATA%rel_rx  = 0.0
         STAGE_CHEM_DATA%f0      = 0.0
         STAGE_CHEM_DATA%LeBasM  = 0.0
         STAGE_CHEM_DATA%M_ac    = 0.0

      ! Retrieve the Name of the Deposition Control File
         IF ( STAGECTRL .EQ. "STAGECTRL_NML" ) THEN
            XMSG = 'You have chosen not to indicate the location of a ' //
     &             'STAGE deposition Control namelist file. This file ' //
     &             'is required by the STAGE dry deposition module.'
            CALL M3EXIT( 'Map_STAGE',0,0,XMSG,1 )
         END IF

      ! Open Deposition Control Namelist File
         DEPCTRL_NML = JUNIT()
         OPEN( FILE = STAGECTRL, UNIT = DEPCTRL_NML, STATUS = 'OLD',
     &         POSITION = 'REWIND', FORM='FORMATTED', IOSTAT = STAT )

      ! Check for Error in File Open Process
         IF ( STAT .NE. 0 ) THEN
            WRITE( XMSG, '(A,A,A)' ),'ERROR: Could not read ',
     &              'STAGE control namelist file: ',TRIM( STAGECTRL )
            CALL M3EXIT( 'STAGE_LU_MAPPER',0,0,XMSG,1 )
         END IF

         REWIND( DEPCTRL_NML )
         READ( NML = STAGE_DATA, UNIT = DEPCTRL_NML, IOSTAT=STAT )
         IF ( STAT .NE. 0 ) THEN
            WRITE( LOGDEV, "(5x,A,/,5x,A,/,5x,A,/,5x,A)" ),
     &        'Warning! Something went wrong while reading the ',
     &        'STAGE land use section of the STAGE Deposition',
     &        'Control Namelist. Default values for this section ',
     &        'will be assumed.'
         END IF

         dep_gas_all = 1
         n_xref_end  = .TRUE.
         Do While( n_xref_end )
            If( STAGE_CHEM_DATA(dep_gas_all)%vd_name .Eq. 'N/A' ) Then
               n_xref_end = .FALSE.
               dep_gas_all = dep_gas_all - 1
            Else
               dep_gas_all = dep_gas_all + 1
            End If
         End Do
         
! Allocate Chem Data
         ALLOCATE ( vd_name     ( dep_gas_all ),
     &              rel_rx      ( dep_gas_all ), 
     &              LeBasM      ( dep_gas_all ),
     &              f0          ( dep_gas_all ),
     &              M_ac        ( dep_gas_all ),
     &              molwt_all   ( dep_gas_all ),
     &              H_name_all  ( dep_gas_all ),
     &              hlind       ( dep_gas_all ),
     &              USE_DEPSPC  ( dep_gas_all ),
     &              asx_run_map ( dep_gas_all ),
     &              gc_depv_name( dep_gas_all ),STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating chemical deposition parameters '
            Call M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
         End If
          
! load arrays from STAGE namelist data
         vd_name = STAGE_CHEM_DATA(1:dep_gas_all)%vd_name
         rel_rx  = STAGE_CHEM_DATA(1:dep_gas_all)%rel_rx 
         f0      = STAGE_CHEM_DATA(1:dep_gas_all)%f0
         LeBasM  = STAGE_CHEM_DATA(1:dep_gas_all)%LeBasM
         M_ac    = STAGE_CHEM_DATA(1:dep_gas_all)%M_ac

! Initialize arrays to be populated by MECH namelist data
         molwt_all    = 0.0
         asx_run_map  = .FALSE.
         gc_depv_name = 'None'
         H_name_all   = 'None'
         lerror       = .FALSE.
         
         Do v = 1, N_GC_DEPV
            s = index1( gc_depv( v ),dep_gas_all,'VD_'//vd_name ) 
            If( s .Gt. 0.0 ) Then
               molwt_all( s ) = gc_molwt( gc_depv_map( v ) )
               gc_depv_name( s ) = gc_spc( gc_depv_map( v ) )
               asx_run_map( s ) = .TRUE.
            End If
         End Do 
         Do v = 1, N_GC_SCAV
            s = index1(gc_spc(gc_scav_map(v)),dep_gas_all,gc_depv_name)
            if( s .Gt. 0.0 ) Then
               H_name_all( s ) = gc_scav(v)
               call hlindex( H_name_all( s ), hlind( s ), lerror )
            End if
         End Do
         Do v = 1, N_NR_DEPV
            s = index1( nr_depv( v ),dep_gas_all,'VD_'//vd_name ) 
            If( s .Gt. 0.0 ) Then
               molwt_all( s ) = nr_molwt( nr_depv_map( v ) )
               gc_depv_name( s ) = nr_spc( nr_depv_map( v ) )
               asx_run_map( s ) = .TRUE.
            End If
         End Do 
         Do v = 1, N_NR_SCAV
            s = index1(nr_spc(nr_scav_map(v)),dep_gas_all,gc_depv_name)
            if( s .Gt. 0.0 ) Then
               H_name_all( s ) = nr_scav(v)
               call hlindex( H_name_all( s ), hlind( s ), lerror )
            End if
         End Do
         Do v = 1, N_TR_DEPV
            s = index1( tr_depv( v ),dep_gas_all,'VD_'//vd_name ) 
            If( s .Gt. 0.0 ) Then
               molwt_all( s ) = tr_molwt( tr_depv_map( v ) )
               gc_depv_name( s ) = tr_spc( tr_depv_map( v ) )
               asx_run_map( s ) = .TRUE.
            End If
         End Do 
         Do v = 1, N_TR_SCAV
            s = index1(tr_spc(tr_scav_map(v)),dep_gas_all,gc_depv_name)
            if( s .Gt. 0.0 ) Then
               H_name_all( s ) = tr_scav(v)
               call hlindex( H_name_all( s ), hlind( s ), lerror )
            End if
         End Do

         if ( lerror ) then
            xmsg = 'Could not find deposition species in Henry''s Law table.'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
         end if 

! Map the deposition surrogate species 
         IF ( ( N_GC_SPC + N_NR_SPC + N_TR_SPC ) .LE. 0 ) THEN
            XMSG = 'Model not compiled for gases'
            CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF

C Set up names and indices
         N_USE_DEPSPC = 0
         USE_DEPSPC = .FALSE.   ! array

C Set up the DEPV pointers to calculated deposition velocities

         DO V = 1, N_DEPV_NAMES
            VNAME = DEPV_NAMES( V )( 4:LEN_TRIM( DEPV_NAMES( V ) ) )
            N = INDEX1( VNAME, dep_gas_all, vd_name )
            IF ( N .NE. 0 ) THEN
               IF ( .NOT. USE_DEPSPC( N ) ) THEN
                  USE_DEPSPC( N ) = .TRUE.
                  N_USE_DEPSPC = N_USE_DEPSPC + 1
               END IF    
            ELSE
               XMSG = 'Could not find ' // TRIM( DEPV_NAMES( V ) ) // 
     &                ' in '            // TRIM( DEPV_METHOD )     //
     &                ' surrogate table.'
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
            END IF
         END DO

C Sort DEPV_NAMES based on the order in DEPSPC (DEPVVARS module)

         N = 0
         DO V = 1, dep_gas_all           
            IF ( USE_DEPSPC( V ) ) THEN
               N = N + 1
               VNAME = 'VD_' // vd_name( V )( 1:LEN_TRIM( vd_name( V ) ) )
               DEPV_NAMES( N ) = VNAME
            END IF
         END DO

C Locate model species' DEPVs in the unique DEPV_NAMES list

         DO V = 1, N_GC_DEPV
            VNAME = GC_DEPV( V )
            N = INDEX1( VNAME, N_DEPV_NAMES, DEPV_NAMES )
            IF ( N .NE. 0 ) THEN
               DEPV_SUR( V ) = N
            ELSE
               XMSG = 'Could not find ' // TRIM( GC_DEPV( V ) )
     &              // ' in STAGE Deposition Namelist.'  
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
            END IF
         END DO

         STRT = N_GC_DEPV + 1
         FINI = N_GC_DEPV + N_NR_DEPV 
         DO V = STRT, FINI
            VNAME = NR_DEPV( V - ( STRT-1 ) )
            N = INDEX1( VNAME, N_DEPV_NAMES, DEPV_NAMES )
            IF ( N .NE. 0 ) THEN
               DEPV_SUR( V ) = N
            ELSE
               XMSG = 'Could not find ' // TRIM( NR_DEPV( V ) )
     &              // ' in STAGE Deposition Namelist.'  
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
            END IF
         END DO

         STRT = N_GC_DEPV + N_NR_DEPV + 1
         FINI = N_GC_DEPV + N_NR_DEPV + N_TR_DEPV
         DO V = STRT, FINI
            VNAME = TR_DEPV( V - (STRT-1) )
            N = INDEX1( VNAME, N_DEPV_NAMES, DEPV_NAMES )
            IF ( N .NE. 0 ) THEN
               DEPV_SUR( V ) = N
            ELSE
               XMSG = 'Could not find ' // TRIM( TR_DEPV( V ) )
     &              // ' in STAGE Deposition Namelist.'  
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
            END IF
         END DO

         Write(Logdev,*) '*********************** STAGE Deposition Map ***********************'
         Write(Logdev,99901) 'Dep. Species', 'H Surrogate', 'Mol Weight'

         Do v = 1, dep_gas_all
           If( asx_run_map (v) ) Write(Logdev,99902) gc_depv_name( v ), H_name_all(v), molwt_all(v)
         End Do
       
         Return

99901    Format(A16,1x,A16,1x,A16)
99902    Format(A16,1x,A16,10x,F6.2)

         End Subroutine Map_Stage

      End Module Stage_Data

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
       SUBROUTINE CONVCLD_PROP_ACM( JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C
C  FUNCTION: Convective cloud processor Models-3 science process:
C       MAIN ROUTINE calculates cloud characteristics, and uses them
C       to generate cloud top, bottom, water, ice and fractions.
C
C       ICLDTYPE = 1 => computes raining cloud physics
C       ICLDTYPE = 2 => does the same for non-precip clouds utilizing saved
C                       info from RNCLD in the case of co-existing clouds
C
C  PRECONDITIONS REQUIRED:
C       Dates and times represented YYYYDDD:HHMMSS.
C
C
C  REVISION  HISTORY:
C       Adapted 3/93 by CJC from science module template
C       Version 3/3/93 with complete LCM aqueous chem by JNY.
C       Modified 6/3-7/93 by CJC & JNY to correct treatment of half layers
C       vs. full layers in loop 255:  calculation of DTDP centered at
C       quarter-layers using PSTAR; corresponding revisions to TLCL, TSAT.
C       Uses 4th order R-K solver there.
C       Version 6/5/93 by CJC using relative rainout rates.
C       Version 7/6/93 by CJC using INTERP3()
C       Adapted from LCM aqueous chemistry, initial version, 9/93
C              by JNY and CJC
C       Completion of EM cloud mixing, JNY 12/93
C       Inclusion of EM aqueous chemistry JNY 12/93
C       UPGRADE TO FULL RADM CLOUD MODULE EMULATION, JNY 4/94
C       8/16/94 by Dongming Hwang Configuration management template
C       Adapted 10/96 by S.Roselle for Models-3
C       1/97 s.roselle added McHenry`s well mixed assumption code
C       8/97 S.Roselle revised cgrid units, pressure units, rainfall
C              to hourly amounts, built indices for wet dep species,
C              scavenged species, and aqueous species, built wrapper
C              around aqueous chemistry module
C       10/97 S.Roselle removed McHenry`s well mixed assumption code
C              and put back the below cloud concentration scaling
C       11/97 S.Roselle moved the wet deposition output to the calling
C              routine--CLDPROC
C       01/98 S.Roselle moved indexing code to AQINTER, also
C              moved scavenging to SCAVWDEP
C       03/98 S.Roselle read sub-hourly rainfall data
C       12/98 David Wong at LM:
C             -- changed division of 8000, 2, 1000 to its corresponding
C                reciprocal
C              -- added INT in the expression STEP * 0.5 when calling SEC2TIME
C       03/99 David Wong at LM:
C             -- replaced "/ FRAC * .001" by "/ ( FRAC * 1000.0 )" to minimize
C                lost of significant digits in calculation
C       Jeff - Dec 00 - move CGRID_MAP into f90 module
C       Jeff - Sep 01 - Dyn Alloc - Use HGRD_DEFN
C       4/02 S.Roselle changed minimum horizontal resolution for subgrid
C             clouds from 12km to 8km.
C       1/05 J.Young: dyn alloc - establish both horizontal & vertical
C                     domain specifications in one module
C       5/05 J.Pleim Replaced cloud mixing algorithm with ACM
C       6/05 S.Roselle added new cloud diagnostic variables
C       7/05 J.Young: clean up and mod for CMAQ-F
C       8/10 J.Young: replace chem mechanism include files with namelists
C                    and accomodate Shawn Roselle`s, Sergey Napelenok`s
C                    and Steve Howard`s aerosol reengineering
C       3/11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C       5/11/11 D.Wong: incorporated twoway model implementation
C       7/11 G. Sarwar: calculate zenith angle to determine daytime and nightime 
C                    needed for sulfur oxidation via metal catalysis
C       9/11 S.Roselle: enable CMAQ subgrid cloud model only when met. driver
C             uses a convective cloud parameterization (removed minimum
C             horizontal grid resolution restriction)
C       02Aug12 S.Roselle:  instrumented to calculate and return
C                           transmissivity for convective clouds
C       04Apr14 B.Hutzell:  Added routine call to capture cloud fractions,
C                           water, and ice mixing ratios
C       11Feb15 J.Young: Updated call to czangle.F which uses the ASX_DATA_MOD shared
C                        data module (Implemented by J.Bash on 07 Nov 14)
C       09/04/15 D.Wong: - Made variable declaration method consistent in the caller
C                          and calling routines
C                        - Used a variable rather than an array in calculation to
C                          reduce memory footprint and to increase code efficiency
C       28May15 J.Young: cleanup
C       12Jun15 B.Hutzell: Moved call to CLEAR_ACM_CLOUD to after FIRSTIME block to
C                          insure results from previous time step are removed
C       12Jan16 D.Wong: Fixed a bug that causes different result when code run with 
C                       different domain decomposition
C       4Apr16 J.Bash      Calculate the Sundqvist et al. 1989 threshold humidities 
C                          for cloud formation based on Mocko and Cotton (1995) to be
C                          More consistent with WRF
C       01Feb19 D.Wong: Implemented centralized I/O approach, removed all MY_N
C                       clauses
C       01AUG19 D.Wong: Modified code to work with two-way model
C       11 Nov 19 F. Sidi: Changed MSTEP to accomdate Centralized I/O changes
C-----------------------------------------------------------------------

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE HGRD_DEFN,     ONLY: MYPE
      USE UTILIO_DEFN
      USE PHOT_MET_DATA, ONLY: USE_ACM_CLOUD, CLEAR_ACM_CLOUD, CAPTURE_ACM_CLOUD
      USE ASX_DATA_MOD,  ONLY: INIT_MET, GRID_DATA
      USE CONST
      USE CENTRALIZED_IO_MODULE,  ONLY: RCA_AVAIL, cio_model_sdate,
#ifdef mpas
     &                                  cell_area,
#endif
     &                                  cio_model_stime, 
     &                                  interpolate_var,
     &                                  file_tstep, f_met 

     

      IMPLICIT NONE

C...........INCLUDES

      INCLUDE SUBST_FILES_ID            ! file name parameters

C...........Arguments

      INTEGER, INTENT( IN )    :: JDATE
      INTEGER, INTENT( IN )    :: JTIME
      INTEGER, INTENT( IN )    :: TSTEP( 3 )


C...........Parameters

#ifdef mpas
C critical rel humidity for land (fraction)
      REAL, ALLOCATABLE, SAVE      :: RCRITL(:,:)

C critical rel humidity for water (fraction)
      REAL, ALLOCATABLE, SAVE      :: RCRITW(:,:)
#else
C critical rel humidity for land (fraction)
      REAL, SAVE      :: RCRITL

C critical rel humidity for water (fraction)
      REAL, SAVE      :: RCRITW
#endif

C intermediate factor
      REAL            :: XKM

C param contlng sidewall entrainment function for raining clouds
      REAL, PARAMETER :: SIDEFAC = 0.5

C storm rainout efficiency
      REAL, PARAMETER :: STORME  = 0.3

C emp sat vapor press constant from RADM
      REAL, PARAMETER :: C303 = 19.83

C emp sat vapor press constant from RADM
      REAL, PARAMETER :: C302 = 5417.4

C g/kg
      REAL, PARAMETER :: GPKG = 1.0E+03

C 1 hectare = 1.0e4 m**2
      REAL, PARAMETER :: M2PHA = 1.0E+04

C subgrid scale temp perturb (deg K)
      REAL, PARAMETER :: PERT = 1.5

C wvp mix ratio perturb (dimensionless)
      REAL, PARAMETER :: PERQ = 1.5E-3

C rainfall threshold (mm/hr)
      REAL, PARAMETER :: RTHRESH = 0.1

C vapor press of water at 0 C (Pa)
      REAL, PARAMETER :: VP0PA = 611.2

C 1.0 / (vapor press of water @ 0 C) (1/Pa)
      REAL, PARAMETER :: VPINV = 1.0 / VP0PA

C converg. crit. for entrainment solver
      REAL, PARAMETER :: TST = 0.01

C assumed cloud lifetime for convective clouds (sec)
      REAL, PARAMETER :: TCLIFE = 3600.0

C ratio of mol wt of water vapor to mol wt of air
      REAL, PARAMETER :: MVOMA = MWWAT / MWAIR

C ratio of dry gas const to specific heat
      REAL, PARAMETER :: ROVCP = RDGAS / CPD

C ratio of latent heat of vap to specific heat
      REAL, PARAMETER :: LVOCP = LV0 / CPD

C dry adiabatic lapse rate (deg K/m)
      REAL, PARAMETER :: DALR = GRAV / CPD

C Number of species in CGRID
      INTEGER, SAVE :: MXSPCS

C parameter to control frequency of convective cloud processing
C   SYNCCLD=.TRUE.  : every synchronization timestep
C   SYNCCLD=.FALSE. : every hour on the half hour
      LOGICAL, PARAMETER :: SYNCCLD = .TRUE. ! default to sync timestep

      INTEGER       ICLDTYPE            ! 1: raining, 2: either CNP or PFW

C...........Local Variables

C-------for ACM version - jp 2/05        REAL DPB
#ifndef mpas
      REAL, ALLOCATABLE, SAVE :: SIGF( : )
#endif
C-------------------------------------------

      LOGICAL, SAVE :: FIRSTIME = .TRUE. ! flag for first pass thru
      LOGICAL, SAVE :: CONVCLD = .TRUE.  ! flag for modeling convective clds

      CHARACTER( 16 ) :: PNAME = 'CONVCLD_ACM'   ! prcess name
      CHARACTER( 16 ) :: VARNM          ! variable name for IOAPI to get

      CHARACTER( 16 ), SAVE :: RC_NAME  ! RC name: old is RC and new is RCA

      INTEGER          ATIME            ! time diff from half-hour
      INTEGER          CLTOP            ! model LAY containing cloud top
      INTEGER          COL              ! column loop counter
      INTEGER          ROW              ! row loop counter
      INTEGER          CTOP             ! dummy variable for cloud top layer
      INTEGER          FINI             ! ending position
      INTEGER          I599C            ! entrainment solver iteration counter
      INTEGER          LAY              ! layer loop counter
      INTEGER          MDATE            ! process date
      INTEGER          MTIME            ! process time (half-hour)
      INTEGER, SAVE :: MSTEP            ! met file time step (hhmmss)
      INTEGER, SAVE :: SDATE            ! met file start date
      INTEGER          SPC              ! liquid species loop counter
      INTEGER          STEP             ! step loop counter
      INTEGER          STRT             ! starting position
      INTEGER, SAVE :: STIME            ! met file start time
      INTEGER          VAR              ! variable loop counter

      INTEGER          CLBASE           ! cld base layer
      INTEGER          CLTOPUSTBL       ! unstable cld top layer
      INTEGER          ISOUND           ! flag for sounding stability
      INTEGER          SRCLAY           ! cloud source level vert index

      REAL             AIRM             ! total air mass (mol/m2) in cloudy air
      REAL             AIRMB0           ! mol/m2 air below cloud
      REAL             AIRMBI           ! inverse mol/m2 air below cloud
      REAL             ALFA0            ! aitken mode number scavenging coef
      REAL             ALFA2            ! aitken mode sfc area scavenging coef
      REAL             ALFA3            ! aitken mode mass scavenging coef
      REAL             ARPRES           ! ave cloud pres in atm
      REAL             CONDIS           !
      REAL             CTHK             ! cloud thickness (m)
      REAL             CTHK1            ! aq chem calc cloud thickness
      REAL             DAMDP            ! dry adiabatic minus dew point lapse rate
      REAL             DP               ! pressure increment along moist adiabat
      REAL             DPLR             ! dew point lapse rate
      REAL             DQI              ! change in ice mix ratio due to melting caused by entrainment
      REAL             DQL              ! change in liq wat mix ratio due to evap caused by entrainment
      REAL             DTCLD            ! cloud integration timestep (s)
      REAL             DTDP             ! moist adiabatic lapse rate
      REAL             DZLCL            ! height increment to LCL above source level
      REAL             ZLCL             ! height of LCL above ground
      REAL             EMAX             ! water vapor pressure at source level
      REAL             EQTH             ! parcel equivalent potential temperature
      REAL             EQTHM            ! parcel equivalent potential temp
      REAL             FA               ! entrainment functional value at TEMPA
      REAL             FB               ! entrainment functional value at TEMPB
      REAL             FRAC             ! cloud fractional coverage
      REAL             FTST             ! functional product in Walcek bisection solver
      REAL             HTST             ! temp diff in Walcek bisection solver
      REAL, SAVE    :: METSTEP          ! reciprocal of timestep on the met file, 1/hr
      REAL             P1               ! intermediate pressure used in calculating WL
      REAL             P2               ! intermediate pressure used in calculating WL
      REAL             P3               ! intermediate pressure used in calculating WL
      REAL             PBAR             ! mean pressure in vertical increments up from LCL along moist adiabat
      REAL             PBARC            ! mean cloud pressure (Pa)
      REAL             PMAX             ! parcel pressure
      REAL             PP               ! scratch pressure variable
      REAL             PRATE            ! total rainfall (mm/hr)
      REAL             PRATE1           ! storm rainfall rate (mm/hr)
      REAL             QENT             ! wat vap mix ratio due to cld sidewall entrainmt
      REAL             QP               ! perturbed water vap mix ratio of parcel
      REAL             QXS              ! int. excess wat ov grid cell needed for rainout
      REAL             REMOVAC          ! variable storing H+ deposition
      REAL             RHOAIR           ! air density in kg/m3
      REAL             RLH              ! relative humidity
      REAL             RLHSRC           ! relative humidity at cld src level
      REAL             RTCH             ! chemical gas const times temp
      REAL             T1               ! perturbed temp to calc neutral buoyancy also used as max temp in cell comparing cloud with environment
      REAL             TBAR             ! mean temp in vertical increments up from LCL along moist adiabat
      REAL             TBARC            ! mean cloud temp (K)
      REAL             TBASE            ! iterative temp along moist adiabat
      REAL             TDMAX            ! dew point at source level
      REAL             TEMPA            ! lower limit on temp for entrainment solver
      REAL             TEMPB            ! upper limit on temp for entrainment solver
      REAL             TEMPC            ! scratch temp solved for cloudy air parcel
      REAL             TENT             ! temp accounting for cld sidewall entrainment
      REAL             THMAX            ! parcel potential temperature
      REAL             TI               ! init temp of cloud air before evap of water
      REAL             TLCL             ! temp at LCL
      REAL             TMAX             ! perturbed temp of parcel
      REAL             TP               ! perturbed temp of parcel
      REAL             TTOP             ! scr vbl used in application of Eq. 7, W&T
      REAL             TWC              ! tot wat cont in cloud (kg H2O/m3 air)
      REAL             WCBAR            ! liq water content of cloud (kg/m3)
      REAL             WL               ! Warner profile (an earlier version appears appears in Walcek and Taylor (JAS, 1986)
      REAL             WTBAR            ! total wat cont (kg/m2) int. thru cloud depth
      REAL             X1               ! intermediate vbles in lapse rate calculation X1 also reused as scratch vble in mixing
      REAL             QDIF             ! scratch vbl used in entrainment solver
      REAL             CLOD
      REAL             LWP
      REAL             STRNS            ! intermediate to set subgrid cld transmissivity
      REAL          :: DENSL( NLAYS )      ! air density (kg/m3)
      REAL          :: F    ( NLAYS )      ! cloud entrainment fraction to be solved for
      REAL          :: FSIDE( NLAYS )      ! sidewall entrainment vertical profile
      REAL          :: LWC  ( NLAYS )      ! liq wat cont of cloud in kg H2O/m3 air
      REAL, ALLOCATABLE, SAVE :: QICE ( : )      ! ice mixing ratio in cloud
      REAL, ALLOCATABLE, SAVE :: QLQD ( : )      ! actual liq. wat. mix ratio in cloud
      REAL          :: QVC  ( NLAYS )      ! saturation wat vap mix ratio at T1
      REAL          :: QWAT ( NLAYS )      ! liq wat mix rat, taken as total condensed water (ice + liq) profile (Eq.4, W&T)
      REAL          :: RHOM2( NLAYS )      ! mol/m2 air
      REAL          :: TCLD ( NLAYS )      ! temp of cloudy air parcel

      REAL             FRACMAX             ! max frac cov for NP cld
      REAL             PLCL                ! pressure at LCL
      REAL             QMAX                ! pertbd w.. mix rat of parcel
      REAL          :: RAIN( NCOLS,NROWS ) ! this timestep rainfall (mm/hr)
      REAL             BCLDWT              ! below cloud weighting function

      REAL          :: RC   ( NCOLS,NROWS )        ! hourly convective rainfall (cm)
      REAL          :: PBL  ( NCOLS,NROWS )        ! PBL height (m)
      REAL          :: DZZ  ( NCOLS,NROWS,NLAYS )  ! computed gridded vble
      REAL          :: DZZL ( NLAYS )              ! grid cell delta Z
      REAL          :: PRES ( NCOLS,NROWS,NLAYS )  ! file gridded vble
      REAL          :: PRESL( NLAYS )              ! grid cell pressure
      REAL          :: QAD  ( NLAYS )              ! moist adiab. sat. mix ratio
      REAL          :: QV   ( NCOLS,NROWS,NLAYS )  ! input gridded vble
      REAL          :: QVL  ( NLAYS )              ! grid cell sp. hum.
      REAL          :: TA   ( NCOLS,NROWS,NLAYS )  ! input gridded vble
      REAL          :: TAL  ( NLAYS )              ! grid cell temp
      REAL          :: TSAT ( NLAYS )              ! parcel temp along moist adiabat @ half levels
      REAL          :: ZH   ( NCOLS,NROWS,NLAYS )  ! mid-layer height (m)
      REAL          :: ZF   ( NCOLS,NROWS,NLAYS )  ! level/layer-face height (m)

      INTEGER         ALLOCSTAT
      INTEGER         STATUS

      CHARACTER( 120 ) :: XMSG = ' '   ! Exit status message

C...........Statement Functions

      REAL             ESAT            ! sat vap pres (Pa) as fn of T (deg K)
      REAL             QSAT            ! sat water vapor mixing ratio

      REAL             T               ! temperature dummy arg
      REAL             E               ! sat vapor pressure dummy arg
      REAL             P               ! pressure dummy arg

      ESAT( T ) = VP0PA * EXP( C303 - ( C302 / T ) )

      QSAT( E, P ) = MVOMA * ( E / ( P - E ) )

C-----------------------------------------------------------------------
C  begin body of subroutine CONVCLD_ACM

C...INITIALIZATION for the CONVCLD_ACM module:
C...  event-statistics variables.

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

        CALL INIT_MET( JDATE, JTIME )

C...check the grid resolution from the MET_CRO_2D and set an appropriate
C...  flag as to whether convective clouds should be run for the given
C...  resolution

C...open MET_CRO_3D

!       IF ( .NOT. OPEN3( MET_CRO_3D, FSREAD3, PNAME ) ) THEN
!         XMSG = 'Could not open '// MET_CRO_3D // ' file'
!         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
!       END IF

C...get description from the met file

!       IF ( .NOT. DESC3( MET_CRO_2D ) ) THEN
!         XMSG = 'Could not get ' // MET_CRO_2D //' file description'
!         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
!       END IF

C cccccccccccccccccccc enable backward compatiblity ccccccccccccccccccccc

        IF ( RCA_AVAIL ) THEN
           RC_NAME = 'RCA'
        ELSE
           RC_NAME = 'RC'
        END IF

C...store met file time, date, and step information and compute
C...  the met timestep in hours

        SDATE = cio_model_sdate
        STIME = cio_model_stime
        MSTEP = file_tstep(f_met) 
        
        METSTEP = 3600.0 / FLOAT( TIME2SEC( MSTEP ) ) ! convert to 1/hours

C...check convective precipitation on met files to determine if WRF used
C...  a convective parameterization

        call interpolate_var (RC_NAME, sdate, stime, RC)

C...in coordination with MCIPv4.0, negative values will be loaded into the RC
C...  field if a convective parameterization was not used in the WRF simulation

        IF ( MAXVAL( RC ) .LT. 0.0 ) THEN
          CONVCLD = .FALSE.
          XMSG = 'MCIP files indicate no convective parameterization was '
     &        // 'used in the WRF simulation'
          CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
          XMSG = 'Processing will continue without subgrid clouds'
          CALL M3MESG ( XMSG )
          RETURN
        END IF

C...allocate saved arrays
#ifndef mpas
        ALLOCATE ( SIGF( 0:NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating SIGF'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        DO LAY = 1, NLAYS
          SIGF( LAY ) = 1.0 - X3FACE_GD( LAY )
        END DO
        SIGF( 0 ) = 1.0
#endif
        ALLOCATE ( QLQD   ( NLAYS ), 
     &             QICE   ( NLAYS ), 
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating BMOL, CBASE0, CBASEF, CEND, POLC, REMOV,'
     &         // 'QLQD or QICE'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF


C...Calculate the Sundqvist et al. 1989 threshold humidities for cloud formation based on 
C...Mocko and Cotton (1995)
#ifdef mpas
       ALLOCATE ( RCRITL( NCOLS,NROWS ),
     &             RCRITW( NCOLS,NROWS ),
     &             STAT = ALLOCSTAT )
          IF ( ALLOCSTAT .NE. 0 ) THEN
             XMSG = 'EXIT: Failure allocating RCRITL, RCRITW'
             call prog_interrupt (PNAME, JDATE, JTIME, XMSG, 1)
          END IF
        DO ROW = 1, NROWS
          DO COL = 1, NCOLS
            ! Reformulate using cell_area to replace XKM
            RCRITW(COL,ROW) = 0.879 + SQRT( 1.0 / ( 100.0 + 1.0E-6*cell_area(col,row)  ))
            RCRITL(COL,ROW) = 0.839 + SQRT( 1.0 / ( 50.0 + 0.5 * 1.0E-9*(cell_area(col,row))**1.5 ) )
          END DO
        END DO

#else
        XKM = REAL( XCELL_GD / 1000 )
        RCRITW = 0.879 + SQRT( 1.0 / ( 100.0 + XKM * XKM ) )
        RCRITL = 0.839 + SQRT( 1.0 / ( 50.0 + 0.5 * XKM ** 3 ) )
#endif

      END IF   ! Firstime

      IF ( .NOT. CONVCLD ) RETURN

C...check option for processing clouds on the synchronization timestep

      MDATE = JDATE
      MTIME = JTIME

C...set the cloud timestep (=adv timestep)

      STEP  = TIME2SEC( TSTEP( 2 ) )         ! syncronization timestep
      DTCLD = REAL( STEP )

C...set time to the midpoint of this timestep for data interpolation

      CALL NEXTIME ( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

C...clear arrays that capture ACM cloud results

      IF ( USE_ACM_CLOUD ) CALL CLEAR_ACM_CLOUD( JDATE, JTIME )

C...ACTUAL SCIENCE PROCESS (loop on internal process time steps):
C...  Interpolate time dependent layered input variables
C...  (reading those variables for which it is necessary)

      call interpolate_var ('TA', mdate, mtime, TA)

      call interpolate_var ('QV', mdate, mtime, QV)

      call interpolate_var ('ZF', mdate, mtime, ZF)

      call interpolate_var ('ZH', mdate, mtime, ZH)

C...Get pressure (Pa)
      call interpolate_var ('PRES', mdate, mtime, PRES)

C...compute layer thicknesses (m)
      DO ROW = 1, NROWS
        DO COL = 1, NCOLS
          DZZ( COL,ROW, 1 ) = ZF( COL,ROW, 1 )
          DO LAY = 2, NLAYS
            DZZ( COL,ROW,LAY ) = ZF( COL,ROW,LAY ) - ZF( COL,ROW,LAY - 1 )
          END DO
        END DO
      END DO

C...Get PBL height (m)
      call interpolate_var ('PBL', mdate, mtime, PBL)

C...advance the MDATE and MTIME to the next time on the met file
C...  to get ready to read the precipitation amounts.
C...  Precipitation data WILL NOT BE INTERPOLATED!  Precipitation data
C...  on the input file are amounts within the metfiles timestep.

      IF ( .NOT. CURRSTEP( JDATE, JTIME, SDATE, STIME, MSTEP,
     &                     MDATE, MTIME ) ) THEN
        XMSG = 'Cannot get step-starting date and time'
        CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      END IF

      CALL NEXTIME ( MDATE, MTIME, MSTEP )  ! set mdate:mtime to the hour

C...Get convective precipitation amount (cm)

      call interpolate_var (RC_NAME, mdate, mtime, RC)

C...Convert the rainfall rate into mm/hr, then set a flag noting the
C...  presence of raining clouds if the rainfall is above the specified
C...  threshold

      DO ROW = 1, NROWS
        DO COL = 1, NCOLS
          RAIN( COL,ROW ) = 10.0 * RC( COL,ROW ) * METSTEP
        END DO
      END DO
      IF ( MINVAL( RAIN ) .LT. 0.0 ) THEN
        XMSG = 'NEGATIVE RAIN...PROBABLY BAD MET DATA... in' // MET_CRO_2D
        CALL M3EXIT ( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
      END IF

C...Loop through all grid cells

      DO 311 ROW = 1, NROWS
        DO 301 COL = 1, NCOLS

          QLQD = 0.0
          QICE = 0.0
          FRAC = 0.0


          CLBASE     = NLAYS
          CLTOP      = CLBASE
          CLTOPUSTBL = NLAYS
          QMAX       = 0.0
          PLCL       = 0.0
          SRCLAY     = NLAYS

          DO LAY = 1, NLAYS
            QAD( LAY ) = 0.0
            PRESL( LAY ) = PRES( COL,ROW,LAY )
            TAL( LAY )   = TA( COL,ROW,LAY )
            QVL( LAY )   = QV( COL,ROW,LAY )
            DZZL( LAY )  = DZZ( COL,ROW,LAY )
            DENSL( LAY ) = PRESL( LAY ) / ( RDGAS * TAL( LAY ) )
          END DO

C...Test for raining clouds
C...If the rainfall amount is below the specified threshold, then set
C...  values for some of the parameters which will be used when the
C...  routine is called again for non-precipitating clouds...then
C...  skip to the next grid cell.

          IF ( RAIN( COL,ROW ) .GE. RTHRESH ) THEN
            ICLDTYPE = 1
            PRATE = RAIN( COL,ROW )
            FRACMAX = 0.0
          ELSE
            ICLDTYPE = 2
            FRACMAX = 0.5
          END IF

C...Determine cloud source level by determining equivalent
C...   potential temperature profile given perturbed temperature
C...   and water vapor to account for local hot spots which
C...   initiate convection.  Layer with maximum equivalent
C...   potential temperature is cloud source layer.

          SRCLAY = 1
          TMAX  = TAL( 1 ) + PERT
          QMAX  = QVL( 1 ) + PERQ
          PMAX  = PRESL( 1 )
          THMAX = TMAX * ( 1.0E+05 / PMAX ) ** ROVCP
          EQTHM = THMAX * EXP( LVOCP * QMAX / TMAX )

          DO LAY = 2, NLAYS

            PP = PRESL( LAY )

            IF ( ZH( COL,ROW,LAY ) .GT. 3000.0 ) EXIT   ! 650 mb

            TP = TAL( LAY ) + PERT
            QP = QVL( LAY ) + PERQ
            THMAX = TP * ( 1.0E+05 / PP ) ** ROVCP
            EQTH = THMAX * EXP( LVOCP * QP / TP )

            IF ( EQTH .GT. EQTHM ) THEN
              TMAX = TP
              SRCLAY = LAY
              QMAX  = QP
              PMAX = PP
              EQTHM = EQTH
            END IF

          END DO

C...Equivalent potential temp max is now known between LAY 1
C...   and 650 mb. We now proceed to compute lifting condensation
C...   level. First, compute vapor pressure at the source level.
C...   Find dewpoint using empirical relationship, avoiding
C...   supersaturation. Then compute dew point lapse rate -
C...   see Walcek and Taylor, 1986.

          EMAX  = QMAX * PMAX / ( MVOMA + QMAX )
          TDMAX = C302 / ( C303 - LOG( EMAX * VPINV ) )
          TDMAX = MIN( TDMAX, TMAX )
          DPLR  = ( GRAV * TDMAX * TDMAX ) / ( MVOMA * LV0 * TMAX )

c...Compute difference between dry adiabatic and dew point lapse
C...   rate, height increment above source level to reach LCL,
C...   then calculate value of pressure at LCL.  Save result
C...   in CONV_DEP( *,*,N_SPC_WDEP+2 ).

          DAMDP = DALR - DPLR

          IF ( DAMDP .LE. 0.0 ) THEN

            DZLCL = 0.0
            PLCL = PMAX
C...walcek formula
            TLCL = TMAX
C...walcek formula

          ELSE

            DZLCL = ( TMAX - TDMAX ) / DAMDP
C...walcek formula
            TLCL = TMAX - DALR * DZLCL
C...walcek formula
            TBAR = TMAX - 0.5 * DALR * DZLCL   !  midpt of TMAX, TLCL
            TBAR = MAX( TBAR , 150.0 )
            PLCL = PMAX * EXP( -( GRAV / RDGAS ) * DZLCL / TBAR )
            ZLCL = DZLCL + ZH( COL,ROW, SRCLAY )

          END IF

C...Determine cloud base at LAY in  which LCL resides,
C...  but not below layer 2.

C...plcl above middle of top layer

          IF ( PRESL( NLAYS ) .GE. PLCL ) THEN
            PLCL = PRESL( NLAYS )
            CLBASE = NLAYS
            CLTOP = CLBASE
            WRITE( LOGDEV,* ) ' WARNING: PLCL above top: Continuing'

C...search loop to find CLBASE

          ELSE

            DO LAY = 2, NLAYS
              IF ( PRESL( LAY ) .LE. PLCL ) THEN
                CLBASE = LAY
                GO TO 245
              END IF
            END DO

            CLBASE = NLAYS   ! if you get here base never found

245         CONTINUE

          END IF      ! if plcl < ptop or , or ...

C...CLBASE is LAY of LCL. Now, determine cloud top by following
C...   moist adiabat up from CLBASE. Assume a stable sounding
C...   (ISOUND=0) at first.  Moist adiabat solver calculates
C...   saturation temperatures TF at the full levels and TSAT( COL,ROW,LAY )
C...   at the half-levels, using a 2nd order Runge method employing
C...   temperatures and pressures at the quarter-levels.

          ISOUND = 0
          DO 255 LAY = CLBASE, NLAYS

C...walcek formulas

            DP   = PRESL( LAY - 1 ) - PRESL( LAY )
            PBAR = PRESL( LAY - 1 ) - DP * 0.5
            IF ( LAY .EQ. CLBASE ) THEN
              DP    = PLCL - PRESL( LAY )
              PBAR  = PLCL - DP * 0.5
              TBASE = TLCL
            END IF

            TBAR = MAX( TBASE - 0.00065 * DP, 150.0 )
            X1 = LV0 * QSAT( ESAT( TBAR ), PBAR ) / ( RDGAS * TBAR ) ! Walcek's
            DTDP = ( ( RDGAS * TBAR ) / ( PBAR * CPD ) )             ! original
     &           * ( ( 1.0 + X1 )                                    ! formulas
     &           / ( 1.0 + ( 0.622 * LVOCP / TBAR ) * X1 ) )
            TSAT( LAY ) = MAX( TBASE - DP * DTDP, 150.0 )
            QAD ( LAY ) = QSAT( ESAT( TSAT( LAY ) ), PRESL( LAY ) )
            TBASE = TSAT( LAY )

C...end Walcek formulas

C...QAD is the moist adiabatic saturation mixing ratio, needed
C...  for the entrainment solver
C...  Now make choice on stability of sounding, comparing parcel
C...  temperature TSAT with environmental temperature TA.
C...  ISOUND is index for sounding stability. If ISOUND=0,
C...  moist adiabat never warmer than environment (stable).
C...  ISOUND=1, moist adiabat becomes warmer than environment
C...  (unstable).

            IF ( ISOUND .EQ. 0 ) THEN
              IF ( TSAT( LAY ) .GT. TAL( LAY ) ) ISOUND = 1
            ELSE           ! cloud top determined by neutral bouyancy
              T1 = TSAT( LAY ) ! - 0.5 * PERT
              IF ( T1 .LT. TAL( LAY ) ) THEN
                CLTOP = LAY - 1
                GO TO 256
              END IF
            END IF

255       CONTINUE            !  end loop following moist adiabat

          CLTOP = NLAYS - 1   !  if you get here:  cloud stable or no top

256       CONTINUE

C...At this point, if ISOUND has not been set to 1, we have a
C...  "stable" cloud. In this case, we find cloud top by relative
C...   humidity criterion, or, not let cloud top go above 600mb.

          IF ( ISOUND .EQ. 0 ) THEN
            IF ( ICLDTYPE .NE. 1 ) GO TO 299

            DO 265 LAY = CLBASE + 1, NLAYS
              IF ( PRESL( LAY ) .LE. 60000.0 ) THEN
                CLTOP = LAY - 1
                GO TO 267        ! loop exit
              END IF
              RLH = QVL( LAY ) / QSAT( ESAT( TAL( LAY ) ), PRESL( LAY ) )
              IF ( RLH .LT. 0.65 ) THEN
                CLTOP = LAY - 1
                GO TO 267        ! loop exit
              END IF
265         CONTINUE

            CLTOP = NLAYS - 1   ! if you get here:  top never found

          ELSE

            CLTOPUSTBL = CLTOP  ! store unstable cloud top

          END IF

267       CONTINUE   ! loop exit target

          IF ( ICLDTYPE .NE. 1 ) THEN   !  get cloud top for either CNP or PFW

            IF ( ZLCL .GT. PBL( COL,ROW ) ) GO TO 299

C...compute relative humidity at the cloud source level

            RLHSRC = MIN( 1.0, QVL( SRCLAY )
     &                        / QSAT( ESAT( TAL( SRCLAY ) ), PRESL( SRCLAY ) ) )

C...If all tests pass, then a CNP or PFW cloud exists
C...  Proceed to find CLTOP for CNP or PFW; don`t allow
C...  cloud top to exceed 500mb, or, when RH falls below
C...  65%, cloud top found

C...Distiguish between CNP and PFW by whether rain is falling
C...  in the cell; if PFW, limit depth and find new CLTOP,
C...  else leave CLTOP alone

            IF ( CLTOP .EQ. CLBASE ) THEN
              GO TO 322
            ELSE                   ! confine PFW to 1500 meters
              CTOP = CLTOP

              DO LAY = CTOP, CLBASE, -1
                IF ( ZH( COL,ROW,LAY ) - ZH( COL,ROW,CLBASE ) .LE. 3000.0 ) THEN
                  CLTOP = LAY
                  GO TO 322   ! exit loop
                END IF
              END DO

            END IF

322         CONTINUE     ! loop exit for PFW cloud

C...If unstable CNP or PFW, limit CLTOP to CLTOPUSTBL so that
C...  QAD profile is known through cloud depth for entrainment
C...  solver

            IF ( ISOUND .EQ. 1 ) CLTOP = MIN( CLTOP, CLTOPUSTBL )

C...Now compute fractional coverage for either CNP or PFW:
C...Now based on Sunqdvist et al. 1989 DOI: 10.1175/1520-0493(1989)117<1641:CACPSW>2.0.CO;2 
            FRAC = 0.0
            IF ( GRID_DATA%LWMASK( COL,ROW ) .EQ. 1.0 ) THEN   ! land
#ifdef mpas
               IF ( RLHSRC .GE. RCRITL( COL,ROW) )
     &            FRAC = 1.0 - SQRT( ( 1.0 - RLHSRC ) / ( 1.0 - RCRITL( COL,ROW ) ) )
#else
               IF ( RLHSRC .GE. RCRITL )
     &            FRAC = 1.0 - SQRT( ( 1.0 - RLHSRC ) / ( 1.0 - RCRITL ) )
#endif
            ELSE   ! water
#ifdef mpas
               IF ( RLHSRC .GE. RCRITW( COL,ROW ) )
     &            FRAC = 1.0 - SQRT( ( 1.0 - RLHSRC ) / ( 1.0 - RCRITW( COL,ROW ) ) )
#else
               IF ( RLHSRC .GE. RCRITW )
     &            FRAC = 1.0 - SQRT( ( 1.0 - RLHSRC ) / ( 1.0 - RCRITW ) )
#endif
            END IF
            FRAC = MAX( 0.0, MIN( FRAC, 0.95 ) )

            IF ( FRAC .LT. 0.01 ) GO TO 299


          END IF  ! end of existence, depth and frac cov calc for
                  ! either PFW or CNP clouds

C...Now cloud existence is established, initialize various
C...  variables needed for rest of computations

C...First, get mol air/m2 at each layer, initialize FSIDE

          DO LAY = 1, NLAYS
            RHOM2( LAY ) = PRESL( LAY ) * DZZL( LAY )
     &                   * 1.0E3 / ( RDGAS * MWAIR * TAL( LAY ) )
            FSIDE( LAY ) = 0.0
          END DO

C...Initialize variables needed for entrainment and in-cloud properties solver

          QXS =   0.0  ! integrated excess water over grid cell nec. for rnout
          AIRM =  0.0  ! total air mass (mol/m2) in cloudy layers
          PBARC = 0.0  ! in-cloud average pressure
          CTHK  = 0.0  ! cloud thickness (m)
          WCBAR = 0.0  ! condensed wat cont (kg/m2) integ. thru cloud depth
          WTBAR = 0.0  ! total wat cont (kg/m2) integrated thru cloud depth
          TBARC = 0.0  ! cloud mean temp (K)

C...Determine condensed water content and entrainment at each cloud level
C...  Determine FSIDE profile for raining clouds; side entrainment
C...  only for PFW and CNP clouds

          IF ( ICLDTYPE .EQ. 1 ) THEN   ! raining cloud

            IF ( CLBASE .EQ. CLTOP ) THEN
              FSIDE( CLBASE ) = 1.0
            ELSE

              DO LAY = CLBASE, CLTOP
                FSIDE( LAY ) = 1.0
              END DO

            END IF

          ELSE                    ! CNP or PFW

            DO LAY = CLBASE, CLTOP
              FSIDE( LAY ) = 1.0
            END DO

          END IF

C...Use Warner profile to close system of conservation and
C...  thermodynamic equations solved iteratively, using Secant solver

          DO LAY = CLBASE, CLTOP
            WL = 0.7 * EXP( ( PRESL( LAY ) - PLCL ) * 0.000125 ) + 0.2

            IF ( LAY .EQ. CLBASE ) THEN
              P1 = 0.5 * ( PRESL( LAY ) + PRESL( LAY - 1 ) )

              IF ( PLCL .LT. P1 ) THEN
                P2 = 0.5 * ( PRESL( LAY + 1 ) + PRESL( LAY ) )
                P3 = ( P2 + PLCL ) * 0.5
                WL = 0.7 * EXP( ( P3 - PLCL ) * 0.000125 ) + 0.2
              END IF

            END IF

c...original Walcek bisection solver

            QWAT( LAY ) = WL * ( QMAX - QAD( LAY ) )
            QWAT( LAY ) = MAX( QWAT( LAY ), 1.0E-20 )

            TEMPA = TSAT( LAY ) - 20.0
            TEMPB = TSAT( LAY ) + 10.0

            QENT = FSIDE( LAY ) * QVL( LAY )
     &           + ( 1.0 - FSIDE( LAY ) ) * QVL( CLTOP )
            QDIF = QENT - QMAX
            IF ( QDIF .EQ. 0.0 ) QDIF = 1.0E-10
            F( LAY ) = ( QSAT( ESAT( TEMPA ), PRESL( LAY ) )
     &               + QWAT( LAY ) - QMAX ) / QDIF
            F( LAY ) = MIN( F( LAY ), 1.0 )
            F( LAY ) = MAX( F( LAY ), 0.0 )

            TTOP = TAL( CLTOP ) * ( PRESL( LAY ) / PRESL( CLTOP ) ) ** ROVCP
            TENT = TTOP * ( 1.0 - FSIDE( LAY ) ) + TAL( LAY ) * FSIDE( LAY )

            TI = TSAT( LAY ) * ( 1.0 - F( LAY ) ) + TENT * F( LAY )
            DQL = ( QMAX - QAD( LAY ) ) * ( 1.0 - F( LAY ) - WL )
            DQI = 0.0

            IF ( TEMPA .LT. 273.15 ) THEN
              DQI = -QWAT( LAY ) * ( TEMPA - 273.15 ) / 18.0
              IF ( TEMPA .LE. 255.15 ) DQI = QWAT( LAY )
            END IF

            FA = CPD * ( TEMPA - TI ) + LV0 * DQL + LF0 * DQI

C...test for convergence, then cut the interval in half

            I599C = 0

599         CONTINUE

            HTST = TEMPB - TEMPA
            IF ( HTST .LT. TST ) GO TO 595   ! convergence
            I599C = I599C + 1

            IF ( I599C .GT. 1000 ) THEN
              WRITE( XMSG, 91010 )
     &             'NO CONVERGENCE IN ENTRAINMENT SOLVER AT COL= ',
     &             COL, ' ROW= ',  ROW, ' ICLDTYPE= ', ICLDTYPE
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            TEMPC = ( TEMPA + TEMPB ) * 0.5
            QENT = FSIDE( LAY ) * QVL( LAY )
     &           + ( 1.0 - FSIDE( LAY ) ) * QVL( CLTOP )
            QDIF = QENT - QMAX
            IF ( QDIF .EQ. 0.0 ) QDIF = 1.0E-10
            F( LAY ) = ( QSAT( ESAT( TEMPC ), PRESL( LAY ) )
     &               + QWAT( LAY ) - QMAX ) / QDIF
            F( LAY ) = MIN( F( LAY ), 0.99 )
            F( LAY ) = MAX( F( LAY ), 0.01 )
            TTOP = TAL( CLTOP ) * ( PRESL( LAY ) / PRESL( CLTOP ) ) ** ROVCP
            TENT = TTOP * ( 1.0 - FSIDE( LAY ) ) + TAL( LAY ) * FSIDE( LAY )
            TI = TSAT( LAY ) * ( 1.0 - F( LAY ) ) + TENT * F( LAY )
            DQL = ( QMAX - QAD( LAY ) ) * ( 1.0 - F( LAY ) - WL )
            DQI = 0.0

            IF ( TEMPC .LT. 273.15 ) THEN
              DQI = -QWAT( LAY ) * ( TEMPC - 273.15 ) / 18.0
              IF ( TEMPC .LE. 255.15 ) DQI = QWAT( LAY )
            END IF

            FB = CPD * ( TEMPC - TI ) + LV0 * DQL + LF0 * DQI

            FTST = FA * FB

C...if fa*fb < 0 then zero lies between ta & tc
C...if fa*fb > 0 then zero lies between tc & tb

            IF ( FTST .LE. 0.0 ) THEN
              TEMPB = TEMPC
            ELSE
              TEMPA = TEMPC
            END IF
            GO TO 599

595         CONTINUE   ! exit from iterator, convergence achieved

C...we have obtained parcel temp TEMPC at layer LAY
C...and entrainment fraction F(LAY)

C...end of Walcek bisection solver

            TCLD( LAY ) = MAX( TEMPC, 150.0 )

C...ice load in cloud is a function of temperature below freezing

            IF ( TCLD( LAY ) .LT. 273.15 ) THEN
              QICE( LAY ) = -QWAT( LAY ) * ( TCLD( LAY ) - 273.15 ) / 18.0
              IF ( TCLD( LAY ) .LE. 255.15 ) QICE( LAY ) = QWAT( LAY )
            END IF

C...After determining the ice fraction, compute the actual
C...  liquid water mixing ratio:

            QLQD( LAY ) = QWAT( LAY ) - QICE( LAY )

C...compute the Liquid Water Content (LWC) by taking the
C...  product of the liquid wat mix ratio and the air density
C...  LWC in kg H2O per m**3 air:

            RHOAIR = PRESL( LAY ) / ( RDGAS * TCLD( LAY ) )
            LWC( LAY ) = QLQD( LAY ) * RHOAIR
            LWC( LAY ) = MAX( 5.0E-6, LWC( LAY ) )  ! lower limit
            TWC = QWAT( LAY ) * RHOAIR         ! total water content

C...Now perform vertical integration, weighting by liquid water
C...  content so that averaged quantities (used in Aqueous
C...  Chemistry) get the greatest weight where the liquid
C...  water content is greatest.

C...weighted cloud temp
            TBARC = TBARC + TCLD( LAY ) * DZZL( LAY ) * LWC( LAY )

C...weighted cloud pres
            PBARC = PBARC + PRESL( LAY ) * DZZL( LAY ) * LWC( LAY )

C...integrated liquid water content (kg/m3)
            WCBAR = WCBAR + DZZL( LAY ) * LWC( LAY )

C...integrated total water content
            WTBAR = WTBAR + DZZL( LAY ) * TWC
            CTHK = CTHK + DZZL( LAY )   ! Cloud thickness

C...Now compute integrated excess water over grid cell
C...  average necessary for rainout, through cloud depth.
C...  First, get max temp in the cell (either in cloud or env.)

            T1 = MAX( TCLD( LAY ), TAL( LAY ) )

C...get saturation water vapor mixing ratio at that temp:

            QVC( LAY ) = QSAT( ESAT( T1 ), PRESL( LAY ) )

C...excess water is the sum of total condensed and saturated
C...  vapor minus grid cell average mixing ratio: QXS in kg/m2:
C...  integrated through cloud depth

            QXS = QXS
     &          + ( QWAT( LAY ) + QVC( LAY ) - QVL( LAY ) )
     &          * RHOAIR * DZZL( LAY )

C...get total air mass in cloudy layers:

            AIRM = AIRM + RHOM2( LAY )

          END DO

C...Now begin to split calculations for non-raining and raining
C...  clouds depending on inner loop index ICLDTYPE (1 = raining,
C...  2 = nonraining: either CNP of PFW:)

          IF ( ICLDTYPE .EQ. 2 ) THEN   ! no precip or excess water
            PRATE1 = 1.0E-30
            PRATE  = 1.0E-30
            QXS    = 1.0E-30
            GO TO 7000       ! branch for further CNP or PFW calculations
          END IF

C...continue here for raining cloud...

C...get PRATE1, storm rainout rate in mm/hour, noting that 1 kg
C...  of water occupies a 1 mm thick layer of water in a square meter
C...  of ground (accounts for density of water = 1000 kg/m3)

          PRATE1 = STORME * QXS * 3600.0 / TCLIFE
          IF ( PRATE1 .LE. 1.001 * PRATE ) THEN
            FRAC = 0.999                ! Changed back to .999 - jp 6/05
            PRATE1 = PRATE / FRAC
          ELSE
            FRAC = PRATE / PRATE1
          END IF
          IF ( FRAC .LT. 0.01 ) GO TO 299

C...for raining cloud, compute water properties of interest
C...  below cloud base. First, parameterize total water content

          TWC = ( 0.067 * PRATE ** ( 0.846 ) ) / ( FRAC * 1000.0 ) ! tot wat cont kg/m3

          DO LAY = 1, CLBASE - 1
            TCLD( LAY ) = TAL( LAY )
            RHOAIR = PRESL( LAY ) / ( RDGAS * TCLD( LAY ) )
            QWAT( LAY ) = TWC / RHOAIR    ! kg H2O / kg air

C...again partition into ice and liquid

            IF ( TCLD( LAY ) .LT. 273.15 ) THEN
              QICE( LAY) = -QWAT( LAY ) * ( TCLD( LAY ) - 273.15 ) / 18.0
              IF ( TCLD( LAY ) .LE. 255.15 ) QICE( LAY ) = QWAT( LAY )
            END IF

            QLQD( LAY ) = QWAT( LAY ) - QICE( LAY )
            LWC ( LAY ) = QLQD( LAY ) * RHOAIR
            LWC ( LAY ) = MAX( 5.0E-06, LWC( LAY ) )         ! lower limit
            PBARC = PBARC + PRESL( LAY ) * DZZL( LAY ) * LWC( LAY )
            TBARC = TBARC + TCLD( LAY ) * DZZL( LAY ) * LWC( LAY )
            WCBAR = WCBAR + DZZL( LAY ) * LWC( LAY )
            WTBAR = WTBAR + DZZL( LAY ) * TWC
            CTHK = CTHK + DZZL( LAY )

C...excess water is all rain

            QXS = QXS + QWAT( LAY ) * RHOAIR * DZZL( LAY )
            
          END DO

C...Final calc of storm rainfall rate and frac area (raining clds)

          PRATE1 = STORME * QXS * 3600.0 / TCLIFE

          IF ( PRATE1 .LE. 1.001 * PRATE ) THEN
            FRAC = 0.999        ! Changed back to .999 - jp 6/05
            PRATE1 = PRATE / FRAC
          ELSE
            FRAC = PRATE / PRATE1
          END IF
          IF ( FRAC .LT. 0.01 ) GO TO 299
          
7000      CONTINUE                        ! target of cloudtype split

C...Capture cloud information for both cloud types

          IF ( USE_ACM_CLOUD ) THEN
!            WRITE(6,'(A,7(I8,1X),3(ES12.4,1X))')
!     &      'MYPE, JDATE, JTIME, COL, ROW, SUBGRID CLD CLBASE, CLTOP,FRAC, SUM(QLQD), SUM(QICE) = ',
!     &       MYPE, JDATE, JTIME, COL, ROW, CLBASE, CLTOP,FRAC, SUM(QLQD), SUM(QICE)
            CALL CAPTURE_ACM_CLOUD( JDATE, JTIME, COL, ROW, CLBASE, CLTOP,
     &                              FRAC, QLQD, QICE )
          END IF

299     CONTINUE

301     CONTINUE        !  end loop on columns COL
311   CONTINUE        !  end loop on rows    ROW

      RETURN          !  from main routine CLDPROC

91010 FORMAT( 3( A, :, I3, : ) )
      END SUBROUTINE CONVCLD_PROP_ACM

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker] 
C $Header: /project/work/rep/PARIO/src/subdmap.f,v 1.8 2011/03/30 18:13:07 sjr Exp $

      SUBROUTINE SUBDMAP ( NUMPROCS, NCOLS, NROWS, NLAYS, NPCOL, NPROW,
     &                     NCOLS_PE, NROWS_PE, COLSX_PE, ROWSX_PE,
     &                     MAXCELLS, IERR )
C ....................................................................
 
C  PURPOSE:   Subroutine to construct the horizontal
C             processor-to-subdomain map.
 
C  REVISION HISTORY: 
C       Original version  3/96 by Al Bourgeois for parallel implementation.
C       Modified 6/98 by AJB to improve error detection.
C       Modified 07/08/1998 by AJB to add NPCOL and NPROW to argument list.
C       Modified 07/29/1998 by AJB to use M3WARN instead of EXTMSG.
C       Modified 08/31/1998 by AJB to remove MYCELLS, MAXBNDRY from arg. list.
C       Modified 09/03/1998 by AJB to remove call to WRSUBMAP, and remove
C                arguments IO_PE and MY_PE.
C       Modified 09/12/1998 by AJB to increase MAXCELLS for DOT grid.
C       Modified 12/07/1998 by Al Bourgeois to add EXTERNAL declarations.
C       Modified 08/06/1999 by Al Bourgeois to remove error flag from argument
C                list and to exit with PM3EXIT on allocation errors.
C       Modified 02/02/2004 by David Wong
C         -- uses f90 syntax to allocate memory rather than using DYNMEM library
C       Modified 02/23/2011 by Shawn Roselle
C         -- Replaced I/O API include files with M3UTILIO
 
C  ARGUMENT LIST DESCRIPTION:
C M1 = PIOMAPS_MODULE
C  IN:
C        INTEGER    NUMPROCS                  ! Number of processors
C        INTEGER    NCOLS                     ! Total number of columns in grid
C        INTEGER    NROWS                     ! Total number of rows in grid
C        INTEGER    NLAYS                     ! Total number of layers in grid
C        INTEGER    NPCOL                     ! Number of PEs across grid cols
C        INTEGER    NPROW                     ! Number of PEs across grid rows
C  OUT:
C        INTEGER    NCOLS_PE( NUMPROCS )   M1 ! Number of columns for each PE
C        INTEGER    NROWS_PE( NUMPROCS )   M1 ! Number of rows for each PE
C        INTEGER    COLSX_PE( 2,NUMPROCS ) M1 ! Column index range for each PE
C        INTEGER    ROWSX_PE( 2,NUMPROCS ) M1 ! Row index range for each PE
C        INTEGER    MAXCELLS                  ! Maximum subdomain size over PEs
C        INTEGER    IERR
 
C  LOCAL VARIABLE DESCRIPTION:  see below
 
C  NOTES:  Uses dynamic memory allocation for NCOLS_WE and NROWS_SN
 
C .......................................................................

!     USE PIOMAPS_MODULE
      USE M3UTILIO              ! i/o api

      IMPLICIT  NONE

C ARGUMENTS:

      INTEGER    NUMPROCS               ! Number of processors
      INTEGER    NCOLS                  ! Total number of columns in grid
      INTEGER    NROWS                  ! Total number of rows in grid
      INTEGER    NLAYS                  ! Total number of layers in grid
      INTEGER    NPCOL                  ! Number of PEs across grid columns
      INTEGER    NPROW                  ! Number of PEs across grid rows
      INTEGER    NCOLS_PE( NUMPROCS )   ! Number of columns for each PE
      INTEGER    NROWS_PE( NUMPROCS )   ! Number of rows for each PE
      INTEGER    COLSX_PE( 2,NUMPROCS ) ! Column index range for each PE
      INTEGER    ROWSX_PE( 2,NUMPROCS ) ! Row index range for each PE
      INTEGER    MAXCELLS               ! Maximum subdomain size over PEs
      INTEGER    IERR                   ! return error code

C EXTERNAL FUNCTIONS:

C LOCAL VARIABLES: 

      INTEGER    I               ! Loop counter.
      INTEGER    NDX             ! Temporary index for processors row, column.
      INTEGER    NCOLX           ! Used for computing columns per domain.
      INTEGER    NROWX           ! Used for computing rows per domain.
      INTEGER    ICELLS          ! Temporary variable for computing MAXCELLS.
      INTEGER    DOT             ! For allocation of dot-grid variables.
      CHARACTER( 80 ) :: MSG     ! Message issued from M3WARN routine.

C Dynamic arrays.

      INTEGER, ALLOCATABLE :: NCOLS_WE( : )     ! Number columns in west-to-east subdomains.
      INTEGER, ALLOCATABLE :: NROWS_SN( : )     ! Number rows in south-to-north subdomains.
 
C .......................................................................

C Initialize.
      DOT = 1

C Allocate arrays.

      ALLOCATE ( NCOLS_WE( NPCOL ), STAT=IERR )
      IF ( IERR .NE. 0 ) THEN
         MSG = 'Error allocating NCOLS_WE.'
         CALL M3WARN ( 'SUBDMAP', 0, 0, MSG )
         RETURN
      END IF

      ALLOCATE ( NROWS_SN( NPROW ), STAT=IERR )
      IF ( IERR .NE. 0 ) THEN
         MSG = 'Error allocating NCOLS_SN.'
         CALL M3WARN ( 'SUBDMAP', 0, 0, MSG )
         RETURN
      END IF

C Construct the processor-to-subdomain map.

      NCOLX = NCOLS / NPCOL
      NROWX = NROWS / NPROW

      DO I = 1 , NPCOL
         NCOLS_WE( I ) = NCOLX
      END DO

      DO I = 1 , NPROW
         NROWS_SN( I ) = NROWX
      END DO

      DO I = 1, NCOLS - NPCOL*NCOLX       ! Spread out remaining columns
         NCOLS_WE( I ) = NCOLS_WE( I ) + 1
      END DO

      DO I = 1, NROWS - NPROW*NROWX
         NROWS_SN( I ) = NROWS_SN( I ) + 1     ! Spread out remaining rows
      END DO
       
C Assign the number of rows and columns for each PE subdomain, 
C and calculate the index range into the global domain.

C                                                    NPCOL
C  Example subdomain layout         _____________________________________
C  for 8 processors with           |         |         |        |        |
C  NPCOL=4, NPROW=2.               |         |         |        |        |
C                                  |    5    |    6    |    7   |    8   |
C                                  |         |         |        |        |
C                           NPROW  |_________|_________|________|________|
C                                  |         |         |        |        |
C                                  |         |         |        |        |
C                                  |    1    |    2    |    3   |    4   |
C                                  |         |         |        |        |
C                                  |         |         |        |        |
C                                  |_________|_________|________|________|

      DO I = 1, NUMPROCS

C Set NDX to the subdomain column index for processor I.
          NDX = MOD ( I,NPCOL )
          IF ( NDX .EQ. 0 ) NDX = NPCOL

C Assign the number of columns in this PE.
          NCOLS_PE( I ) = NCOLS_WE( NDX )

C Calculate column range of this PE in the global domain.
          IF ( NDX .EQ. 1 ) THEN
             COLSX_PE( 1,I ) = 1
             COLSX_PE( 2,I ) = NCOLS_PE( I )
          ELSE
             COLSX_PE( 1,I ) = COLSX_PE( 2,I-1 ) + 1
             COLSX_PE( 2,I ) = COLSX_PE( 2,I-1 ) + NCOLS_PE( I ) 
          END IF

C Set NDX to the subdomain row number for processor I.
          NDX = ( I - 1 ) / NPCOL + 1

C Calculate number of rows in this PE.
          NROWS_PE( I ) = NROWS_SN( NDX )

C Calculate row range of this PE in the global domain.
          IF ( I .LE. NPCOL ) THEN
             ROWSX_PE( 1,I ) = 1
             ROWSX_PE( 2,I ) = NROWS_PE( I )
          ELSE
             ROWSX_PE( 1,I ) = ROWSX_PE( 2,I-NPCOL ) + 1
             ROWSX_PE( 2,I ) = ROWSX_PE( 2,I-NPCOL ) + NROWS_PE( I ) 
          END IF

      END DO

C Compute the largest subdomain and the largest boundary.
      MAXCELLS = 0
      DO I = 1, NUMPROCS
         ICELLS = ( DOT + NCOLS_PE( I ) ) * ( DOT + NROWS_PE( I ) )
         IF ( MAXCELLS .LT. ICELLS ) MAXCELLS = ICELLS
      END DO
      MAXCELLS = MAXCELLS * NLAYS

C Free memory allocated for dynamic arrays.

      DEALLOCATE ( NCOLS_WE, STAT=IERR )
      IF ( IERR .NE. 0 ) THEN
         MSG = 'Error deallocating NCOLS_WE.'
         CALL M3WARN ( 'SUBDMAP', 0, 0, MSG )
      END IF

      DEALLOCATE ( NROWS_SN, STAT=IERR )
      IF ( IERR .NE. 0 ) THEN
         MSG = 'Error deallocating NROWS_SN.'
         CALL M3WARN ( 'SUBDMAP', 0, 0, MSG )
      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! what(1) key, module and SID; SCCS file; date and time of last delta:
! %W% %P% %G% %U%

! --------------------------------------------------------------------------
! Purpose:
!
!   use F90 interface feature to achieve "faked" polymorphism for global broadcast
!   operation from PE 0
!
! Revision history:
!
!   Orginal version: 12/14/21 by David Wong
!
! Parameter List:
!
! Local Variable:
!
! Include Files:
!
!   mpif.h
C -----------------------------------------------------------------------------

        module se_global_bcast_module

          use se_pe_info_ext, only : se_worker_comm, se_myworker_pe, se_numworkers
          use se_domain_info_ext, only : se_gl_ind

          implicit none

          interface se_global_bcast
            module procedure se_global_bcast_2d_r,
     $                       se_global_bcast_2d_i,
     $                       se_global_bcast_2d_l
          end interface

          contains

! -----------------------------------------------------------------------------
          subroutine se_global_bcast_2d_r (indata)

            real, intent(in)  :: indata(:,:)

            include "mpif.h"

            integer :: data_size, error

            data_size = size(indata,1) * size(indata,2)

            call mpi_bcast (indata, data_size, mpi_real, 0, se_worker_comm, error)

          end subroutine se_global_bcast_2d_r

! -----------------------------------------------------------------------------
          subroutine se_global_bcast_2d_i (indata)

            integer, intent(in)  :: indata(:,:)

            include "mpif.h"

            integer :: data_size, error

            data_size = size(indata,1) * size(indata,2)

            call mpi_bcast (indata, data_size, mpi_integer, 0, se_worker_comm, error)

          end subroutine se_global_bcast_2d_i

! -----------------------------------------------------------------------------
          subroutine se_global_bcast_2d_l (indata)

            logical, intent(in)  :: indata(:,:)

            include "mpif.h"

            integer :: data_size, error

            data_size = size(indata,1) * size(indata,2)

            call mpi_bcast (indata, data_size, mpi_logical, 0, se_worker_comm, error)

          end subroutine se_global_bcast_2d_l

        end module se_global_bcast_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_bndy_copy_module.f,v 1.2 2006/02/15 14:41:56 yoj Exp $ 

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   use F90 interface feature to achieve "faked" polymorphism for pe boundary
C exchange routine and use F90 module feature to modulize pe boundary exchange
C functionality of the stencil exchange library. Shallow Water Model is the 
C target application.
C
C Note: 
C
C   Currently only 2-D case is implemented.
C
C Revision history:
C
C   Orginal version: 11/28/01 by David Wong
C          Modified: 08/24/11 by David Wong
C                      -- eliminated data and geo orientation
C --------------------------------------------------------------------------

        module se_bndy_copy_module

        implicit none

        interface se_bndy_copy
          module procedure se_bndy_copy2
        end interface

        contains

C --------------------------------------------------------------------------
C Purpose:
C
C   determine the set of boundary exchange "neighbouring" processor(s) that 
C   my own processor needs to communicate with.
C
C Revision history:
C
C   Orginal version: 11/28/01 by David Wong
C                    08/24/11 by David Wong
C                      -- removed se_ori_ext to eliminate data and geo orientation
C
C Subroutine parameter description:
C
C   In:  dirstr    -- indicator of communication direction
C                     0 (without communication), 1 (with communication)
C
C   Out: send_to   -- processor number which data needs to be sent to
C        recv_from -- processor number which data is recvd from
C
C Local variable description:
C
C   rdirection -- input communication direction for receiveing
C   sdirection -- communication direction for sending
C   i, j       -- loop indexes
C   k          -- location indicator
C --------------------------------------------------------------------------

        subroutine se_bndy_copy_pat (dirstr, send_to, recv_from)

        use se_bndy_copy_info_ext
!       use se_ori_ext
        use se_internal_util_module

        implicit none

        character (len = 16), intent(in) :: dirstr
        integer, intent(out) :: send_to (8), recv_from (8)

        integer :: i, j, k
        integer :: rdirection (8), sdirection(8)
        
C -- extract inform from input strings

        read (dirstr, 10) (sdirection(i), i=1, 8)
 10     format (8i2)

C -- figuring out send direction pattern
        do i = 1, 8
           rdirection(i) = sdirection(mod(i+3,8)+1)
        end do

C -- determine where data is receiving from
C -- first: N, E, S, and W
        do i = 1, 7, 2
           if ((rdirection (i) .gt. 0) .and.
     &         (se_bngb_pe(i) .ge. 0)) then
              recv_from(i) = se_bngb_pe(i)
           else
              recv_from(i) = -1
           end if
        end do

C -- second: NE, SE, SW, NW, and their immediate neighbours
C --         for instance, NE's immediate neighbours are N, and E
        do i = 2, 8, 2
           if (rdirection(i) .gt. 0) then
              do j = i-1, i+1
                 k = j
                 if (k .eq. 9) then
                    k = 1
                  end if 
                  if (se_bngb_pe(k) .ge. 0) then
                     recv_from(k) = se_bngb_pe(k)
                  else
                     recv_from(k) = -1
                  end if
              end do
           else
              recv_from(i) = -1
           end if
        end do

C -- determine where data is sending to
C -- first: N, E, S, and W
        do i = 1, 7, 2
           if ((sdirection (i) .gt. 0) .and.
     &         (se_bngb_pe(i) .ge. 0)) then
              send_to(i) = se_bngb_pe(i)
           else
              send_to(i) = -1
           end if
        end do

C -- second: NE, SE, SW, NW, and their immediate neighbours
C --         for instance, NE's immediate neighbours are N, and E
        do i = 2, 8, 2
           if (sdirection(i) .gt. 0) then
              do j = i-1, i+1
                 k = j
                 if (k .eq. 9) then
                    k = 1
                  end if 
                  if (se_bngb_pe(k) .ge. 0) then
                     send_to(k) = se_bngb_pe(k)
                  else
                     send_to(k) = -1
                  end if
              end do
           else
              send_to(i) = -1
           end if
        end do

        return
        end subroutine se_bndy_copy_pat

C --------------------------------------------------------------------------
C Purpose:
C
C   perform boundary exchange communication in the global scenario
C
C   Example:
C
C     Give a global data, A (10, 20)
C
C     various exchange examples:
C
C       -- copying data from A(1, 1:19) to A(10, 1:19)
C       -- copying data from (10,20) to A(1,1)
C
C Revision history:
C
C   Orginal version: 11/28/01 by David Wong
C                    03/06/02 David Wong
C                      -- use blocking communication scheme
C                      -- use array copy mechanism when communicates to itself
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Subroutine parameter description:
C
C   In:  data    -- original data
C        dispstr -- displacement string
C        dirstr  -- indicator of communication direction
C                   0 (without communication), 1 (with communication)
C        str     -- an optional argument to indicate the starting index of
C                   certain dimension
C
C   Out: data    -- original data after communication
C
C Local variable description:
C
C    send_to       -- processor number which data needs to be sent to
C    send_to_ptr   -- a F90 pointer (alias) of send_to
C    recv_from     -- processor number which data is recvd from
C    recv_from_ptr -- a F90 pointer (alias) of recv_from
C    sdir, rdir    -- loop indexes which indicate send to or recvd from
C    sind          -- store low and high index of each dimension for sending
C                     process
C    sind_ptr      -- a F90 pointer (alias) of sind
C    rind          -- store low and high index of each dimension for receiving
C                     process
C    rind_ptr      -- a F90 pointer (alias) of rind
C    shift         -- an array to hold the amount of index shifting due to
C                     starting index is 1 in a subroutine
C    num_shift     -- number of shifting
C    loc_str       -- a local copy of str
C    request       -- MPI sending request status
C    status        -- MPI waiting status
C    error         -- MPI call return error code
C --------------------------------------------------------------------------

        subroutine se_bndy_copy2 (data, dispstr, dirstr, str)

        use se_data_send_module
        use se_data_recv_module
        use se_internal_util_module
        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(inout) :: data(:,:)
        character (len = 16), intent(in) :: dirstr
        character (len = 12), intent(in) :: dispstr
        character (len = *), optional, intent(in) :: str

        integer, target :: send_to(8), recv_from(8)
        integer, pointer :: send_to_ptr(:), recv_from_ptr(:)
        integer, target :: sind(2,2,8), rind(2,2,8)
        integer, pointer :: sind_ptr(:,:,:), rind_ptr(:,:,:)
        integer :: sdir, rdir
        integer :: shift(4), num_shift
        character (len = 80) :: loc_str
        integer :: request, status(MPI_STATUS_SIZE), error

        if (present(str)) then
           loc_str = str
           shift(2:4:2) = 1
           call se_string_to_integer (loc_str, shift, num_shift)
        else
           num_shift = 0
        end if

        call se_bndy_copy_pat (dirstr, send_to, recv_from)

        call se_bndy_up_low2 (dispstr, sind, rind, shift, num_shift)

        send_to_ptr => send_to
        recv_from_ptr => recv_from
        sind_ptr => sind
        rind_ptr => rind

        do sdir = 1, 8

           rdir = mod((sdir + 3), 8) + 1

           if (send_to(sdir) .eq. se_myworker_pe) then

              data(rind(1,1,rdir):rind(2,1,rdir),
     $             rind(1,2,rdir):rind(2,2,rdir))
     $        =
     $        data(sind(1,1,sdir):sind(2,1,sdir),
     $             sind(1,2,sdir):sind(2,2,sdir))

           else

              if (send_to(sdir) .ge. 0) then
                 call se_data_send (data, sind_ptr, send_to_ptr, sdir, sdir,
     $                              request)
              end if

              if ((recv_from(rdir) .ge. 0) .and.
     $            (recv_from(rdir) .ne. se_myworker_pe)) then
                 call se_data_recv (data, rind_ptr, recv_from_ptr, rdir, sdir)
              end if

c             if (send_to(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_bndy_copy2

C --------------------------------------------------------------------------
C Purpose:
C
C   initialize variables sind and rind
C
C Revision history:
C
C   Orginal version: 11/27/01 by David Wong
C                    08/24/11 by David Wong
C                      -- removed se_ori_ext to eliminate data and geo orientation
C
C Subroutine parameter description:
C
C   In:  dispstr   -- displacement string
C        shift     -- an array to hold the amount of index shifting due to
C                     starting index is 1 in a subroutine
C        num_shift -- number of shifting
C
C   Out: sind    -- store low and high index of each dimension for sending
C                   process
C        rind    -- store low and high index of each dimension for receiving
C                   process
C
C Local variable description:
C
C    ndis      -- North displacement
C    edis      -- East displacement
C    sdis      -- South displacement
C    wdis      -- West displacement
C    i         -- loop index
C    loc_shift -- local adjustment of dummy argument shift
C --------------------------------------------------------------------------

        subroutine se_bndy_up_low2 (dispstr, sind, rind, shift, num_shift)

        use se_domain_info_ext
!       use se_ori_ext
        use se_internal_util_module

        implicit none

        integer, intent(inout) :: sind(2,2,8), rind(2,2,8)
        character (len = 12), intent(in) :: dispstr
        integer, intent(in) :: shift(4), num_shift

        integer :: ndis, edis, sdis, wdis, loc_shift(2), i

        if (num_shift .gt. 0) then
!          if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
              if (shift(1) .eq. 1) then
                 loc_shift(1) = 1 - shift(4)
                 loc_shift(2) = 1 - shift(2)
              else
                 loc_shift(1) = 1 - shift(2)
                 loc_shift(2) = 1 - shift(4)
              end if
!          else
!             if (shift(1) .eq. 1) then
!                loc_shift(1) = 1 - shift(2)
!                loc_shift(2) = 1 - shift(4)
!             else
!                loc_shift(1) = 1 - shift(4)
!                loc_shift(2) = 1 - shift(2)
!             end if
!          end if
        else
           loc_shift(1) = 0
           loc_shift(2) = 0
        end if

!       if (se_geo_ori .eq. 0) then
           read (dispstr, *) sdis, edis, ndis, wdis
!       else
!          read (dispstr, *) ndis, edis, sdis, wdis
!       end if

C -- ( sending ) determine ghost cells indexes configuration 
        call store2 (sind, 1, se_my_nrows-sdis+1+loc_shift(1),
     &               se_my_nrows+loc_shift(1), 1+loc_shift(2),
     &               se_my_ncols+loc_shift(2))
        call store2 (sind, 2, se_my_nrows-sdis+1+loc_shift(1),
     &               se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &               wdis+loc_shift(2))
        call store2 (sind, 3, 1+loc_shift(1), se_my_nrows+loc_shift(1),
     &               1+loc_shift(2), wdis+loc_shift(2))
        call store2 (sind, 4, 1+loc_shift(1), ndis+loc_shift(1),
     &               1+loc_shift(2), wdis+loc_shift(2))
        call store2 (sind, 5, 1+loc_shift(1), ndis+loc_shift(1),
     &               1+loc_shift(2), se_my_ncols+loc_shift(2))
        call store2 (sind, 6, 1+loc_shift(1), ndis+loc_shift(1),
     &               se_my_ncols-edis+1+loc_shift(2), se_my_ncols+loc_shift(2))
        call store2 (sind, 7, 1+loc_shift(1), se_my_nrows+loc_shift(1),
     &               se_my_ncols-edis+1+loc_shift(2), se_my_ncols+loc_shift(2))
        call store2 (sind, 8, se_my_nrows-sdis+1+loc_shift(1),
     &               se_my_nrows+loc_shift(1), se_my_ncols-edis+1+loc_shift(2),
     &               se_my_ncols+loc_shift(2))

C -- ( receiving ) determine ghost cells indexes configuration 
        call store2 (rind, 5, 1+loc_shift(1), sdis+loc_shift(1),
     &               1+loc_shift(2), se_my_ncols+loc_shift(2))

        call store2 (rind, 6, 1+loc_shift(1), sdis+loc_shift(1),
     &               se_my_ncols-wdis+1+loc_shift(2), se_my_ncols+loc_shift(2))

        call store2 (rind, 7, 1+loc_shift(1), se_my_nrows+loc_shift(1),
     &               se_my_ncols-wdis+1+loc_shift(2), se_my_ncols+loc_shift(2))

        call store2 (rind, 8, se_my_nrows-ndis+1+loc_shift(1), 
     &               se_my_nrows+loc_shift(1), 
     &               se_my_ncols-wdis+1+loc_shift(2), se_my_ncols+loc_shift(2))

        call store2 (rind, 1, se_my_nrows-ndis+1+loc_shift(1), 
     &               se_my_nrows+loc_shift(1), 1+loc_shift(2),
     &               se_my_ncols+loc_shift(2))

        call store2 (rind, 2, se_my_nrows-ndis+1+loc_shift(1), 
     &               se_my_nrows+loc_shift(1), 1+loc_shift(2), 
     &               edis+loc_shift(2))

        call store2 (rind, 3, 1+loc_shift(1), se_my_nrows+loc_shift(1),
     &               1+loc_shift(2), edis+loc_shift(2))

        call store2 (rind, 4, 1+loc_shift(1), sdis+loc_shift(1),
     &               1+loc_shift(2), edis+loc_shift(2))

!       if ((se_data_ori .eq. "cr") .or. (se_data_ori .eq. "CR")) then
           do i = 1, 8
              call swap (sind(1,1,i), sind(1,2,i))
              call swap (sind(2,1,i), sind(2,2,i))
              call swap (rind(1,1,i), rind(1,2,i))
              call swap (rind(2,1,i), rind(2,2,i))
           end do
!       end if

        return
        end subroutine se_bndy_up_low2

C --------------------------------------------------------------------------
C Purpose:
C
C   to store low and high array indexes (same as in se_comm_module.f)
C
C Revision history:
C
C   Orginal version: 7/28/98 by David Wong
C
C Subroutine parameter description:
C
C   In:  direction -- communication direction
C        i1        -- low index of I dimension
C        i2        -- high index of I dimension
C        j1        -- low index of J dimension
C        j2        -- high index of J dimension
C
C   Out: array     -- array with low and high indexes of each dimension
C --------------------------------------------------------------------------

        subroutine store2 (array, direction, i1, i2, j1, j2)

        integer, intent(out) :: array (2,2,8) 
        integer, intent(in) :: direction, i1, i2, j1, j2

          array(1,1,direction) = i1
          array(2,1,direction) = i2
          array(1,2,direction) = j1
          array(2,2,direction) = j2

        return
        end subroutine store2

        end module se_bndy_copy_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in
!  continuous development by various groups and is based on information
!  from these groups: Federal Government employees, contractors working
!  within a United States Government contract, and non-Federal sources
!  including research institutions.  These groups give the Government
!  permission to use, prepare derivative works of, and distribute copies
!  of their work in the CMAQ system to the public and to permit others
!  to do so.  The United States Environmental Protection Agency
!  therefore grants similar permission to use the CMAQ system software,
!  but users are requested to provide copies of derivative works or
!  products designed to operate in the CMAQ system to the United States
!  Government without restrictions as to use by others.  Software
!  that is used with the CMAQ system but distributed under the GNU
!  General Public License or the GNU Lesser General Public License is
!  subject to their copyright restrictions.
!------------------------------------------------------------------------!
C Adopted from CMAQ files and modified for MEGAN3.1 by Ling Huang
C 2019/07/15
C Adopted from MEGAN3.1 and modified for CMAQ 5.4 by Jeff Willison

      MODULE BDSNP_MOD
 
      USE centralized_io_util_module
      USE HGRD_DEFN
      USE ASX_DATA_MOD, ONLY: MET_DATA,GRID_DATA
      USE RUNTIME_VARS, ONLY: NEW_START, PX_LSM, MGN_ONLN_DEP, IGNORE_SOILINP
      
      IMPLICIT NONE
      
      CONTAINS
C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HRNOBDSNP( JDATE, JTIME, TSTEP,MONTH,  
     &             L_DESID_DIAG, SOILM, SOILT, RSTYP,LAI,
     &                       BDSNP_NO )

  
      USE RUNTIME_VARS, ONLY: STTIME,STDATE,RUNLEN,LOGDEV
      USE PHOT_MOD,     ONLY: CFRAC_2D_AVE

      USE UTILIO_DEFN
#ifdef mpas
      use mio_module
      use util_module, only : TIME2SEC, secsdiff, nextime
#else
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif


      USE centralized_io_module, only: bdsnp_ndep,bdsnp_landtype,
     &                                 bdsnp_arid,bdsnp_nonarid,bdsnp_fert,
     &                                 soilmprev,ndepres,ndeprate,dryperiod,pfactor
     
      IMPLICIT NONE

C Arguments:

      INTEGER, INTENT( IN )  :: JDATE             ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN )  :: JTIME             ! current simulation time (HHMMSS)
      INTEGER, INTENT( IN )  :: MONTH             ! current simulation month

      INTEGER, INTENT( IN )  :: TSTEP( 3 )        ! time step vector (HHMMSS)
      LOGICAL, INTENT( IN ) :: L_DESID_DIAG
      INTEGER, INTENT( IN ) :: RSTYP  ( NCOLS,NROWS )        ! soil type
      REAL,    INTENT( IN ) :: SOILM ( NCOLS,NROWS )         ! soil moisture [m3/m3] (PX)
      REAL,    INTENT( IN ) :: SOILT  ( NCOLS,NROWS )        ! soil temperature [K] (PX)

      REAL,    INTENT( IN ) :: LAI  ( NCOLS,NROWS )        ! leaf area index (m2/m2)
      REAL,    INTENT( OUT ) :: BDSNP_NO ( NCOLS,NROWS ) ! output NO emissions in nanomol/m^2/s

C Parameters:
      ! Value calculated by running the 2x2.5 GEOS-Chem model
      REAL*8,  PARAMETER :: TAU_MONTHS   = 6. ! this is the decay time for dep. N reservoir, fert is 4 months
      REAL*8,  PARAMETER :: SECPERDAY    = 86400.d0
      REAL*8,  PARAMETER :: DAYSPERMONTH = 30.
      REAL*8,  PARAMETER :: TAU_SEC      = TAU_MONTHS * DAYSPERMONTH * SECPERDAY
      
      ! New soil biomes based on Steinkamp et al., 2011
      INTEGER, PARAMETER :: NSOIL    = 24

      ! Canopy wind extinction coefficients
      ! (cf. Yienger & Levy [1995], Sec 5), now a function of the MODIS/KOPPEN biometype (J.D. Maasakkers)
       REAL*8,  PARAMETER :: SOILEXC(NSOIL)    = (/ 
     &  0.10, 0.50, 0.10, 0.10, 0.10,
     &  0.10, 0.10, 0.10, 0.10, 1.00,
     &  1.00, 1.00, 1.00, 2.00, 4.00,
     &  4.00, 4.00, 4.00, 4.00, 4.00,
     &  4.00, 2.00, 0.10, 2.00                  /)
      ! Steinkamp and Lawrence, 2011 A values, wet biome coefficients
      ! for each of the 24 soil biomes [ng N/m2/s] 
      REAL*8,  PARAMETER :: A_BIOME(NSOIL)          =                (/ 
     &   0.00, 0.00, 0.00, 0.00, 0.00, 0.06, 0.09, 0.09, 0.01, 
     &   0.84, 0.84, 0.24, 0.42, 0.62, 0.03, 0.36, 0.36, 0.35, 
     &   1.66, 0.08, 0.44, 0.57, 0.57, 0.57     /)
        
C Saturation values from ASX. For PX see:
C Jacquemin B. and Noilhan J. (1990), Bound.-Layer Meteorol., 52, 93-134.

C Local Variables:

      CHARACTER( 16 ), SAVE :: SOILINSTATE = 'SOILINSTATE' ! logical name for input NO soil data, restart file
      CHARACTER( 16 ), SAVE :: SOILOUT = 'BDSNPOUT' ! logical name for output NO soil data - same format as soilinstate
      integer, save :: output_step, half_syn_step  ! values are in seconds
      CHARACTER (20) :: TIME_STAMP

C Land use files for BDSNP: both time independant in CMAQ sense and absolutely - e.g. fertilizer does not vary with year

      CHARACTER( 16 ) :: VAR        ! variable name

      REAL,    ALLOCATABLE, SAVE :: FERT     ( :,: )  ! "ng N m-2" already - reservoir
C Gridded Canopy NOx reduction factor for BDSNP Soil NO calculations
      REAL,    ALLOCATABLE, SAVE :: CRF   ( :,: )     ! 0-1
      REAL,    ALLOCATABLE, SAVE :: CFRAC ( :,: )  ! 0-1

C --- diagnostic variables, can be removed in final version      
      REAL,    ALLOCATABLE, SAVE :: CRFAVG   ( :,: )  ! 0-1
      REAL,    ALLOCATABLE, SAVE :: PULSEAVG   ( :,: )  ! 1+
      REAL,    ALLOCATABLE, SAVE :: BASESUM   ( :,: )  ! used in calculating the above two averages
      REAL,    ALLOCATABLE, SAVE :: THETA_DIAG( :,: )  ! diagnositc theta
      REAL,    ALLOCATABLE, SAVE :: WET_DIAG ( :,: )  ! diagnositc wet term
      REAL,    ALLOCATABLE, SAVE :: TEMP_DIAG ( :,: )  ! diagnositc temp term
      REAL,    ALLOCATABLE, SAVE :: A_DIAG ( :,: )  ! diagnositc biome base emissions term
      REAL,    ALLOCATABLE, SAVE :: AFERT_DIAG ( :,: )  ! diagnositc fert emissions term
      REAL,    ALLOCATABLE, SAVE :: NRES_FERT_DIAG ( :,: )  ! diagnositc nres fert
      REAL,    ALLOCATABLE, SAVE :: NRES_DEP_DIAG ( :,: )  ! diagnositc nres  dep    
C ---------------------------------------------------------------------------      

      REAL,                 SAVE :: EMPOL,EMPOLSUM, EMPOLAVG       ! use to check reasonableness of results, g/hr
      REAL,                 SAVE :: TIMECHECK ! use to output CPU_TIME(TIMECHECK) to see if this section of code is running unreasonably long
      
      
      INTEGER, SAVE :: EDATE     ! end scenario date
      INTEGER, SAVE :: ETIME     ! end scenario time
      INTEGER, SAVE :: NDATE     ! test date to update rainfall
      INTEGER, SAVE :: NTIME     ! test time to update rainfall
      INTEGER, SAVE :: SDATE     ! scenario start date
      INTEGER, SAVE :: STIME     ! scenario start time
        
      LOGICAL, SAVE :: PX_VERSION         ! true: use PX version of MCIP; should always be true

      INTEGER          SOILCAT            ! soil category
      INTEGER          NSTEPS             ! run duration (HHMMSS)
      INTEGER, SAVE :: MSTEPS             ! run no. of steps
      INTEGER          I, J, K, R, C, L   ! counters
      CHARACTER*3      CHARDAY
      CHARACTER*2      CHARMON
      LOGICAL          OK
      INTEGER          IOS                ! IO or memory allocation status
      
C      REAL,    SAVE :: EFAC
       REAL            TEMP_TERM
       REAL            WET_TERM
       REAL            PULSE
       REAL            A_FERT
       REAL            CRF_TERM
       REAL            SOILNOX, FERTDIAG
C      REAL             CFNO               ! NO correction factor
C      REAL             CFNOGRASS          ! NO correction factor for grasslands
C      REAL             TAIR               ! surface temperature
C      REAL             TSOI               ! soil temperature
       REAL             THETA              ! water filled pore space
       REAL             THETAPREV

C      REAL             CFNOWET,  THETA
C      REAL             FAC1, FAC2, FAC3, FAC4

      LOGICAL, SAVE :: USE_SOILT = .TRUE. ! use soil temperature in PX version
                                          ! rather than estimate as in BEIS2

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 256 ) :: MESG            ! message buffer
      CHARACTER( 16 )  :: PNAME = 'BDSNPHRNO'  ! procedure name

C-----------------------------------------------------------------------
      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.
         ! we need to initialize and allocate:
         ! pulse
         ! length of dry period
         ! soil moisture of previous time step
         ! N reservoir, deposition only
         ! These values can be provided from a restart file. The restart file is 'timeless'.
         ! This means CMAQ isn't checking to see if the restart file is actually from
         ! the immediately prior timstep.

C Determine last timestamp
         EDATE = STDATE; ETIME = STTIME
         CALL NEXTIME( EDATE, ETIME, RUNLEN )   ! end date & time

C     ! make sure it only runs with PX version
         IF( .NOT. PX_LSM ) THEN
            MESG = "BDSNP Soil NO is only compatible with PX version"
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, 2)
         END IF

C Allocate memory for data and read
#ifdef mpas
         output_step   = time2sec(tstep(1))
         half_syn_step = time2sec(tstep(2)) / 2
#endif

         ALLOCATE( FERT( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'FERT', PNAME )

         ALLOCATE( CFRAC( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'CFRAC', PNAME )

         ALLOCATE( CRF( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'CRF', PNAME )

         ALLOCATE( CRFAVG( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'CRFAVG', PNAME )

         ALLOCATE( PULSEAVG( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'PULSEAVG', PNAME )

         ALLOCATE( BASESUM( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'BASESUM', PNAME )


C ------ Diagnostics -----------------------------------
         ALLOCATE( THETA_DIAG( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'THETA_DIAG', PNAME )

         ALLOCATE( WET_DIAG( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'WET_DIAG', PNAME )

         ALLOCATE( TEMP_DIAG( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'TEMP_DIAG', PNAME )

         ALLOCATE( A_DIAG( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'A_DIAG(', PNAME )

         ALLOCATE( AFERT_DIAG( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'AFERT_DIAG', PNAME )

         ALLOCATE( NRES_FERT_DIAG( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'NRES_FERT_DIAG', PNAME )

         ALLOCATE( NRES_DEP_DIAG( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'NRES_DEP_DIAG', PNAME )

C-----------------------------------------------------------------------------
C Initial run if the model hasnt been run before, otherwise use a restart file
C to determine DRYPERIOD, pulse state, prev. timestep soil moisture, and N reservoir.

        
C If initial run, initialize some variables, otherwise get them from file
         IF ( NEW_START .or. IGNORE_SOILINP) THEN

            PFACTOR   = 1d0   ! array
            DRYPERIOD = 0.01  ! array initialized non-zero to avoid log(0)
            CFRAC     = 0. 
            SOILMPREV = 0d0   ! array
            FERT      = 0d0   ! array
            EMPOL  = 0d0
            EMPOLSUM  = 0d0
            EMPOLAVG  = 0d0
            BASESUM = 0.0
            CRFAVG = 0.0
            PULSEAVG = 0.0
            NDEPRES   = 0d0   ! array

C open nitrogen deposition file

           if (.not. MGN_ONLN_DEP) THEN 
             ndeprate = bdsnp_ndep(:,:,month)  ! optional for using offline NDEP
                                               !         instead of online NDEP
            ! When using online deposition there is no attempt to shorten the
            ! spin up time so we do not initialize this.
           end if
                                        
            !attempt to use steady state condition to reduce spin up time by setting dN/dt = 0
            !or NDEPRES = Dep rate * tau, the decay time
            DO R = 1, NROWS
                DO C = 1, NCOLS
                NDEPRES( C,R ) = NDEPRATE( C,R )*TAU_SEC
C           check for negatives
          IF( NDEPRES(C,R) .lt. 0.0 ) THEN
            Write(MESG,*) 'NDEPRES negative', NDEPRES, ' ',NDEPRATE(C,R)
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, 2 )
          ELSE IF( NDEPRATE(C,R) .lt. 0.0 ) THEN
            Write(MESG,*) 'NDEPRATE negative', NDEPRES,' ',NDEPRATE(C,R)
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, 2 )
          END IF
              END DO
           END DO

        ELSE ! SOILINSTATE file available for NDEPRES
            BASESUM = 0.0
            CRFAVG = 0.0
            PULSEAVG = 0.0
            EMPOLSUM  = 0d0
           if (.not. MGN_ONLN_DEP) THEN 
             ndeprate = bdsnp_ndep(:,:,month)  ! For using offline NDEP
                                               ! instead of online NDEP
           end if

        END IF  ! initial run check

      END IF ! FIRSTIME
#ifdef mpas
      IF ( MOD((TIME2SEC( JTIME ) - half_syn_step), output_step) .EQ. 0 .and. .not. l_desid_diag) GOTO 9999
#else
      IF (SECSDIFF(JDATE,JTIME,EDATE,ETIME) .LE. TIME2SEC(TSTEP(2)) .and. .not. L_DESID_DIAG) GOTO 9999
#endif
    
#ifdef twoway
       ! CFRAC for offline comes from MCIP but that's unavailable in twoway mode
       if (.not. allocated(CFRAC_2D_AVE)) then
         CFRAC = Met_Data%CFRAC
!       write(6,'(a,es14.2)')'MaxVal cfrac = ',MAXVAL(cfrac)
!       write(logdev,'(a,es14.2)')'MaxVal cfrac = ',MAXVAL(cfrac)
       else
         CFRAC = CFRAC_2D_AVE
       end if
#else
       CFRAC = Met_Data%CFRAC
#endif 

   
C    read day dependant fertilizer reservoir e.g. Potter et al 2010
C get the days fertilizer
        fert = bdsnp_fert

C Fertilizer N reservoir already calculated and read from file, update deposition reservoir from dep rate
      DO R = 1, NROWS
        DO C = 1, NCOLS
            CALL GET_NDEPRES( TSTEP, NDEPRES( C,R ),
     &                                            TAU_SEC, C, R,L_DESID_DIAG)
        END DO
      END DO


C Calculate temporal non-speciated soil NO emissions to EMPOL

C     If False Dont do any calculations to test - replicate 0 output
      IF( .TRUE. ) THEN

      CALL GET_CANOPY_NOX(JDATE, JTIME, Met_Data%COSZEN,
     & MET_DATA%TEMP2, MET_DATA%RGRND, met_data%PRSFC, 
     & BDSNP_LANDTYPE, LAI, Met_Data%SNOCOV, CFRAC, Met_Data%WSPD10, CRF)

      DO R = 1, NROWS
         DO C = 1, NCOLS

            SOILNOX  = 0d0
            FERTDIAG = 0d0

            K = BDSNP_LANDTYPE( C,R ) !Skip LANDTYPE not present
            ! Temperature-dependent term of soil NOx emissions
            ! [unitless]
            ! Uses PX soil temperature instead of inferring from air
            ! temperature
            TEMP_TERM = SOILTEMP( SOILT(C,R) )

            ! Use THETA instead of boolean wet/dry climate
            SOILCAT = INT( RSTYP( C,R ) )
            IF ( SOILCAT .NE. 14) THEN !not water
               THETA =  SOILM( C,R ) / Grid_Data%WSAT( C,R )
               THETAPREV = SOILMPREV( C,R ) / Grid_Data%WSAT( C,R )
               ! Soil moisture scaling of soil NOx emissions
               WET_TERM = SOILWET( THETA , BDSNP_ARID( C,R ), BDSNP_NONARID( C,R ))
            ELSE
               WET_TERM = 0d0
               THETA = 0d0
               THETAPREV = 0d0
            END IF
            ! Cumulative multiplication factor (over baseline emissions)
            ! that accounts for soil pulsing
C            PFACTOR( C,R ) = PULSING( THETA, TSTEP, THETAPREV,
C     &                       PFACTOR( C,R ), DRYPERIOD( C,R ) )
            PULSE = PULSING( L_DESID_DIAG, THETA, TSTEP, THETAPREV,
     &                       PFACTOR( C,R ), DRYPERIOD( C,R ) )

            A_FERT = FERTADD( FERT( C,R ) , NDEPRES( C,R ) ) !adds reservoirs returns emission rates

            ! Canopy reduction factor
            CRF_TERM  = CRF( C,R )
C                  CRF_TERM  = SOILCRF( K, LAI,
C     &                        R_CANOPY(K),
C     &                               WINDSQR, SUNCOS )

         !  SOILNOX includes fertilizer
            SOILNOX   = ( A_BIOME(K) + A_FERT )  !don't forget to check parenthesis when uncommenting
     &             * ( TEMP_TERM * WET_TERM * PULSE )
     &             * ( 1.d0 - CRF_TERM  )

         !  FERTDIAG, only used for the fertilizer diagnostic, note
         !  includes DEP
         !  not actually used for anything at the moment, only
         !  diagnostics
            FERTDIAG  = ( A_FERT )
     &             * ( TEMP_TERM * WET_TERM * PULSE )
     &             * ( 1.d0 - CRF_TERM  )

C            END IF !LANDTYPE check

C            ENDDO

           !scale emissions
           EMPOL = SOILNOX *  3600.0 * 1.0e-9 ! [ng N/m2/s] *  s/hr * g/ng
           BDSNP_NO(C,R) = SOILNOX / 14 ! [nmol/m2/s]
           ! sum various quantities for daily averaging
           EMPOLSUM = EMPOLSUM + EMPOL
           BASESUM(C,R) = BASESUM(C,R) + ( A_BIOME(K) + A_FERT ) 
     &             * ( TEMP_TERM * WET_TERM)
     &             *  3600.0 * 1.0e-9 ! [ng N/m2/s] *  s/hr * g/ng
           PULSEAVG(C,R) = PULSEAVG(C,R) + ( A_BIOME(K) + A_FERT ) 
     &             * ( TEMP_TERM * WET_TERM * PULSE )
     &             *  3600.0 * 1.0e-9 ! [ng N/m2/s] *  s/hr * g/ng
           CRFAVG(C,R) = CRFAVG(C,R) + ( A_BIOME(K) + A_FERT ) 
     &             * ( TEMP_TERM * WET_TERM )
     &             * ( 1.d0 - CRF_TERM  )
     &             *  3600.0 * 1.0e-9 ! [ng N/m2/s] *  s/hr * g/ng


C--------- MORE DIAGNOSTICS  ---------------------------------
           A_DIAG( C,R ) = A_BIOME(K)
           AFERT_DIAG( C,R ) = A_FERT
           NRES_FERT_DIAG( C,R ) = FERT( C,R )
           NRES_DEP_DIAG( C,R )  = NDEPRES( C,R )
           WET_DIAG( C,R ) = WET_TERM
           THETA_DIAG( C,R ) = THETA
           TEMP_DIAG( C,R ) = TEMP_TERM

C -----------------------------------------------------
        END DO ! columns
      END DO ! rows
#ifdef mpas
        IF ( MOD( NTIME, 10000 ) .EQ. 0 ) THEN    ! at the hourly mark

             call mio_time_format_conversion (jdate, jtime, time_stamp)

             call mio_fwrite('BDSNP_DIAG','A_DIAG','BDSNP_MOD',
     &                             a_diag(:,1),time_stamp)
             call mio_fwrite('BDSNP_DIAG','AFERT_DIAG','BDSNP_MOD',
     &                             afert_diag(:,1),time_stamp)
             call mio_fwrite('BDSNP_DIAG','NRES_FERT_DIAG','BDSNP_MOD',
     &                             nres_fert_diag(:,1),time_stamp)
             call mio_fwrite('BDSNP_DIAG','NRES_DEP_DIAG','BDSNP_MOD',
     &                             nres_dep_diag(:,1),time_stamp)
             call mio_fwrite('BDSNP_DIAG','WET_DIAG','BDSNP_MOD',
     &                             wet_diag(:,1),time_stamp)
             call mio_fwrite('BDSNP_DIAG','TEMP_DIAG','BDSNP_MOD',
     &                             temp_diag(:,1),time_stamp)
       ENDIF
#endif

      ELSE ! add things until it dies
      WRITE( MESG,*) 'BDSNP testing terms'
      
      !!CALL M3MESG(MESG)
         DO R = 1, NROWS
         DO C = 1, NCOLS
            K = BDSNP_LANDTYPE( C,R ) !Skip LANDTYPE not present
            ! Temperature-dependent term of soil NOx emissions
            ! [unitless]
            ! Uses PX soil temperature instead of inferring from air
            ! temperature
            TEMP_TERM = SOILTEMP( SOILT(C,R) )
            ! Use THETA instead of boolean wet/dry climate
            SOILCAT = INT( RSTYP( C,R ) )
            IF ( SOILCAT .NE. 14) THEN !not water
               THETA = SOILM( C,R ) / Grid_Data%WSAT(C,R)
               THETAPREV =  SOILMPREV( C,R ) / Grid_Data%WSAT(C,R)
               ! Soil moisture scaling of soil NOx emissions
               WET_TERM = SOILWET( THETA , BDSNP_ARID( C,R ), BDSNP_NONARID( C,R ))
            ELSE
               WET_TERM = 0d0
               THETA = 0d0
               THETAPREV = 0d0
            END IF
            ! Cumulative multiplication factor (over baseline emissions)
            ! that accounts for soil pulsing
C            PFACTOR( C,R ) = PULSING( THETA, TSTEP, THETAPREV,
C     &                       PFACTOR( C,R ), DRYPERIOD( C,R ) )
            PULSE = PULSING( L_DESID_DIAG, THETA, TSTEP, THETAPREV,
     &                       PFACTOR( C,R ), DRYPERIOD( C,R ) )

         END DO
         END DO
      END IF ! end do nothing test if

      SOILMPREV = SOILM !save soilM array to soilMprev for next time step
      MESG = 'BDSNP calculated emissions'
      !CALL M3MESG(MESG)
      CALL CPU_TIME(TIMECHECK)
      WRITE(MESG,*)  'PROCESS TOOK:', TIMECHECK, 'SECONDS'
      !CALL M3MESG(MESG)
      EMPOLAVG = EMPOLSUM/FLOAT(NCOLS*NROWS)
      WRITE( MESG,*) 'average value:', EMPOLAVG
      !CALL M3MESG(MESG)
      EMPOLSUM = 0d0 !array
  
      RETURN
!      IF ( SECSDIFF( JDATE,JTIME, EDATE,ETIME ) .GT. TIME2SEC( TSTEP( 2 ) ) .OR. L_DESID_DIAG) RETURN
9999   CONTINUE


C Create soil NO state save file at the end of the run for restart purposes

C Final timestamp
      NDATE = EDATE; NTIME = ETIME

!       Avoid divide by zero over water where BASESUM = 0
             WHERE ( BASESUM .eq. 0) BASESUM = 1.0  
             CRFAVG   = CRFAVG/BASESUM
             PULSEAVG = PULSEAVG/BASESUM
             WHERE ( CRFAVG   .gt. 100 ) CRFAVG   = 0.0  
             WHERE ( PULSEAVG .gt. 100 ) PULSEAVG = 0.0  

#ifdef mpas
             call julian_to_mpas_date_time (jdate, jtime, time_stamp)

             call mio_fwrite('BDSNPOUT','PFACTOR', pname,
     &                             PFACTOR(:,1),time_stamp)
             call mio_fwrite('BDSNPOUT','DRYPERIOD', pname,
     &                             DRYPERIOD(:,1),time_stamp)
             call mio_fwrite('BDSNPOUT','NDEPRES', pname,
     &                             NDEPRES(:,1),time_stamp)
             call mio_fwrite('BDSNPOUT','SOILMPREV', pname,
     &                             SOILMPREV(:,1),time_stamp)
             call mio_fwrite('BDSNPOUT','NDEPRATE_DIAG', pname,
     &                           NDEPRATE(:,1),time_stamp)
#else
!C Build description for, and create/open soil NO emissions output file

      FTYPE3D = GRDDED3
      SDATE3D = NDATE
      STIME3D = NTIME
      TSTEP3D = 0   ! make it a time-independent file
      NCOLS3D = GL_NCOLS
      NROWS3D = GL_NROWS
      NLAYS3D = 1
      NVARS3D = 14
      MXREC3D = 1
!
      VNAME3D = ' '
      VNAME3D( 1 ) = 'PFACTOR'
      VNAME3D( 2 ) = 'DRYPERIOD'
      VNAME3D( 3 ) = 'NDEPRES'
      VNAME3D( 4 ) = 'SOILMPREV'

!C --- DIAGNOSTICS ---------------------------
      VNAME3D( 5 ) = 'THETA_DIAG'
      VNAME3D( 6 ) = 'WET_TERM_DIAG'
      VNAME3D( 7 ) = 'TEMP_DIAG'
      VNAME3D( 8 ) = 'TEMP_TERM_DIAG'
      VNAME3D( 9 ) = 'A_DIAG'
      VNAME3D( 10 ) = 'NRES_FERT_DIAG'
      VNAME3D( 11 ) = 'AFERT_DIAG'
      VNAME3D( 12 ) = 'NDEPRATE_DIAG'
      VNAME3D( 13 ) = 'CRFAVG'
      VNAME3D( 14 ) = 'PULSEAVG'
!c -------------------------------------------
      UNITS3D = ' '
      UNITS3D( 1 ) = 'REAL'
      UNITS3D( 2 ) = 'REAL'
      UNITS3D( 3 ) = 'REAL'
      UNITS3D( 4 ) = 'REAL'
      UNITS3D( 5 ) = 'REAL'
      UNITS3D( 6 ) = 'REAL'
      UNITS3D( 7 ) = 'REAL'
      UNITS3D( 8 ) = 'REAL'
      UNITS3D( 9 ) = 'REAL'
      UNITS3D( 10 ) = 'REAL'
      UNITS3D( 11 ) = 'REAL'
      UNITS3D( 12 ) = 'REAL'
      UNITS3D( 13 ) = 'REAL'
      UNITS3D( 14 ) = 'REAL'


      VDESC3D( 1 ) = 'NO emission current pulse factor'
      VDESC3D( 2 ) = 'length of the dry period in hours'
      VDESC3D( 3 ) = 'soil N reservoir from deposition'
      VDESC3D( 4 ) = 'Soil moisture prev. timestep m3/m3'
      VDESC3D( 5 ) = 'moisture WFPS 0-1'
      VDESC3D( 6 ) = 'moisture scale factore diagnostic'
      VDESC3D( 7 ) = 'temperature diagnostic'
      VDESC3D( 8 ) = 'temperature scale factor diagnostic'
      VDESC3D( 9 ) = 'biome base emission diagnostic'
      VDESC3D( 10 ) = 'NRES fert only diagnostic'
      VDESC3D( 11 ) = 'fertilizer emission factor diagnostic'
      VDESC3D( 12 ) = 'N deposition rate diagnostic'
      VDESC3D( 13 ) = 'canopy reduction factor diagnostic'
      VDESC3D( 14 ) = 'pulse factor diagnostic'

      VTYPE3D = 0
      VTYPE3D( 1:14 ) = M3REAL

      FDESC3D = ' '
      FDESC3D( 1 ) = 'Gridded soil state data for soil NO emissions'
      FDESC3D( 2 ) = '/From/ ' // PNAME
      FDESC3D( 3 ) = '/Version/ MEGAN3.1'
!

C Open NO rain data save file
      IF ( IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( SOILOUT, FSNEW3, PNAME ) ) THEN
            MESG = 'Could not open "' // TRIM( SOILOUT ) // '" file'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT1 )
         END IF
      END IF

#ifdef parallel_io
      IF ( IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. FLUSH3 ( SOILOUT ) ) THEN
            MESG = 'Could not sync to disk ' // TRIM( SOILOUT )
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END IF
      CALL SE_BARRIER
      IF ( .NOT. IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( SOILOUT, FSREAD3, PNAME ) ) THEN
            MESG = 'Could not open ' // TRIM( SOILOUT )
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END IF
#endif

      IF ( .NOT. WRITE3(SOILOUT,'PFACTOR',NDATE,NTIME,PFACTOR)) THEN
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF
!
      IF ( .NOT. WRITE3(SOILOUT,'DRYPERIOD',NDATE,NTIME,DRYPERIOD )) THEN
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF

      IF ( .NOT. WRITE3(SOILOUT,'NDEPRES',NDATE,NTIME,NDEPRES )) THEN
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF

      IF ( .NOT. WRITE3(SOILOUT,'SOILMPREV',NDATE,NTIME,SOILM )) THEN
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF
!
!C ---- DIAGNOSTICS -------------------------------------------------------------------
      IF ( .NOT. WRITE3(SOILOUT,'THETA_DIAG',NDATE,NTIME,THETA_DIAG )) THEN ! diagnostic theta
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing THETA_DIAG to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF

      IF ( .NOT. WRITE3(SOILOUT,'WET_TERM_DIAG',NDATE,NTIME,WET_DIAG )) THEN ! diagnostic theta
!        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
         MESG = 'Could not write "' // TRIM( 'WET_TERM_DIAG' ) //
     &          '" to file "' // TRIM( SOILOUT ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      ENDIF


      IF ( .NOT. WRITE3(SOILOUT,'TEMP_DIAG',NDATE,NTIME,SOILT)) THEN ! diagnostic theta
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing TEMP_DIAG to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF

      IF ( .NOT.WRITE3(SOILOUT,'TEMP_TERM_DIAG',NDATE,NTIME,TEMP_DIAG)) THEN ! diagnostic theta
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing TEMP_TERM_DIAG to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF

      IF ( .NOT.WRITE3(SOILOUT,'A_DIAG',NDATE,NTIME,A_DIAG)) THEN ! diagnostic theta
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing A_DIAG to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF

      IF ( .NOT.WRITE3(SOILOUT,'AFERT_DIAG',NDATE,NTIME,AFERT_DIAG)) THEN ! diagnostic theta
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing AFERT_DIAG to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF

      IF ( .NOT.WRITE3(SOILOUT,'NRES_FERT_DIAG',NDATE,NTIME,
     &                                  NRES_FERT_DIAG)) THEN ! diagnostic theta
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing NRES_FERT_DIAG to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF

      IF ( .NOT.WRITE3(SOILOUT,'NDEPRATE_DIAG',NDATE,NTIME,
     &                                  NDEPRATE)) THEN !diagnostic theta
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing NDEPRATE_DIAG to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF

      IF ( .NOT.WRITE3(SOILOUT,'CRFAVG',NDATE,NTIME,
     &                                  CRFAVG)) THEN !diagnostic theta
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing CRFAVG to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF

      IF ( .NOT.WRITE3(SOILOUT,'PULSEAVG',NDATE,NTIME,
     &                                  PULSEAVG)) THEN !diagnostic theta
        CALL NAMEVAL (SOILOUT, MESG)  ! get input file name and path
        MESG = 'Error writing PULSEAVG to file: '//TRIM(MESG)
        CALL M3EXIT(PNAME,JDATE,JTIME,MESG,XSTAT2)
      ENDIF
#endif


C ------------------------------------------------------------------------------------
      WRITE( MESG,* )
     &      'Timestep written to', SOILOUT,
     &      'for date and time', NDATE, NTIME

      RETURN

94040 FORMAT( 5X, 3( A, :, 1X ), I8, ":", I6.6)

      END SUBROUTINE HRNOBDSNP
C----------------------------------------------------------------------------------

         REAL FUNCTION PULSING( L_DESID_DIAG, THETA, TSTEP, THETAPREV,
     &                       PFACTOR, DRYPERIOD )!_____
! !DESCRIPTION: Function PULSING calculates the increase (or "pulse") of
!  soil NOx emission that happens after preciptiation falls on dry soil.
!\\
!\\
!  According to  Yan et al., [2005] , this pulsing process is thought to
!  be due to a release of inorganic nitrogen trapped on top of the dry soil
!  and a subsequent reactivation of water-stressed bacteria, which then
!  metabolize the excess nitrogen. This can happen in seasonally dry
!  grasslands and savannahs or over freshly fertilized fields.
!  Soil NOx emissions consist of baseline emissions plus discrete "pulsing"
!  episodes.  We follow the Yan et al., [2005] algorithm, where the pulse
!  (relative to the flux pre wetting) is determined by the antecedent dry
!  period, with a simple logarithmic relationship,
!
!  PFACTOR = 13.01 ln ( DRYPERIOD ) -  53.6
!
!  ,where PFACTOR is the magnitude of peak flux relative to prewetting flux,
!  and DRYPERIOD  is the length of the antecedent dry period in hours.
!
!  The pulse decays with
!
!  PFACTOR = PFACTOR * EXP( -0.068d0 * TSTEP(HOURS) )

#ifdef mpas
      use util_module, only : TIME2SEC
#endif

         IMPLICIT NONE

#ifndef mpas
         INTEGER, EXTERNAL       ::   TIME2SEC
#endif

C Function arguments:
         INTEGER, INTENT( IN )    :: TSTEP( 3 )        ! time step vector (HHMMSS)
         LOGICAL, INTENT( IN )    :: L_DESID_DIAG
         REAL,    INTENT( IN )    :: THETA, THETAPREV  ! only avilable if PX version
         REAL,    INTENT( INOUT ) :: DRYPERIOD
         REAL,    INTENT( INOUT ) :: PFACTOR
C Local Variables
         REAL MOISTDIFF
         REAL DTHOURS
         DTHOURS = TIME2SEC(TSTEP(2))/3600.0
         IF (L_DESID_DIAG) then 
            DTHOURS = 0.
         END IF
         ! If soil moisture less than 0.3 and no pulse is taking place
         IF ( THETA < 0.3D0 .and. PFACTOR == 1.D0) THEN

            ! Get change in soil moisture since previous timestep
            MOISTDIFF = ( THETA - THETAPREV )

            ! If change in soil moisture is > 0.01 (rains)
            IF ( MOISTDIFF > 0.01 ) THEN

               !Initialize new pulse factor (dry period hours)
               PFACTOR = 13.01 * LOG( DRYPERIOD ) - 53.6

               ! If dry period < ~3 days then no pulse
               IF ( PFACTOR < 1.0 ) PFACTOR = 1.0

                  ! Reinitialize dry period
                  DRYPERIOD = 0.001

                ! If no rain (i.e.,  change in soil moisture is < 0.01)
               ELSE
                ! Add one timestep to dry period
                DRYPERIOD = DRYPERIOD + DTHOURS

            ENDIF

         ! If box is already pulsing , then decay pulse one timestep
         ELSEIF ( PFACTOR /= 1.d0) THEN

            ! Decay pulse
            PFACTOR   = PFACTOR * EXP( -0.068d0 * DTHOURS )

            ! Update dry period
            IF ( THETA < 0.3D0 ) DRYPERIOD = DRYPERIOD + DTHOURS

            ! If end of pulse
            IF ( PFACTOR < 1.d0 ) PFACTOR = 1.d0

         ENDIF
         PULSING = PFACTOR
         RETURN

         END FUNCTION PULSING!_____

C---------------------------------------------------------------------------------------------
      
         SUBROUTINE GET_NDEPRES( TSTEP, NDEPRES, TAU_SEC,C,R,L_DESID_DIAG)
C Get the deposition rate of the appropriate species for the appropriate timestep, add to reservoir and decay.
C Return reservoir amount.



         USE centralized_io_module, ONLY: ndeprate
         USE RUNTIME_VARS, ONLY:  MGN_ONLN_DEP
#ifdef mpas
         USE utilio_defn
         use util_module, only : TIME2SEC
#endif

         IMPLICIT NONE

#ifndef mpas
         INTEGER, EXTERNAL       ::   TIME2SEC
#endif

C Function arguments:

         INTEGER, INTENT( IN )  :: TSTEP( 3 )        ! time step vector (HHMMSS)
         INTEGER, INTENT( IN )  :: C
         INTEGER, INTENT( IN )  :: R
         REAL*8,  INTENT( IN )  :: TAU_SEC
         LOGICAL, INTENT( IN ) :: L_DESID_DIAG
         REAL,    INTENT( INOUT ) :: NDEPRES

C Local Variables
         CHARACTER( 256 ) :: MESG            ! message buffer
         CHARACTER( 16 )  :: PNAME = 'GET_NDEPRES'  ! procedure name

         REAL*8  :: C1 ! a factor
         REAL*8  :: C2  ! another one
         REAL*8  :: TS_SEC ! time step in seconds
         real NDEPTEMP
C           check for negatives
          IF( NDEPRES < 0.0 ) THEN
          WRITE(MESG,*) 'NDEPRES negative'
          Write(*,*) 'In GET_NDEPRES:'
          Write(*,*) 'NDEPRES negative', NDEPRES,' '
          write(*,*) 'TS, TAU, C1, C2:', TS_SEC, TAU_SEC,C1,C2
          CALL M3EXIT( PNAME, 0, 0, MESG, 2)
          ELSE IF( NDEPRATE(c,r) < 0.0 ) THEN
          MESG = 'NDEPRATE negative'
          Write(*,*) 'In GET_NDEPRES:'
          Write(*,*) 'NDEPRATE negative', NDEPRATE(c,r)
          CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
          END IF

         ! takes the NDEPRATE and uses it to update NDEPRES before
         ! clearing it.

         !Do mass balance (see Intro to Atm Chem Chap. 3)
         !m(t) = m(0) * exp(-t/tau) + Source * tau * (1 - exp(-t/tau))
         TS_SEC = TIME2SEC(TSTEP(2))
         C1 = EXP( - TS_SEC / TAU_SEC)
         C2 = 1.d0 - C1
               NDEPTEMP = NDEPRES
               NDEPRES = NDEPRES*C1+NDEPRATE(c,r)*TAU_SEC*C2
C           check for negatives
          IF( NDEPRES < 0.0 ) THEN
          MESG = 'negative'
          Write(*,*) 'In GET_NDEPRES:'
          Write(*,*) 'NDEPRES negative', NDEPRES
          write(*,*) 'TS, TAU, C1, C2:', TS_SEC, TAU_SEC,C1,C2
          CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
          END IF
         ! clear NDEPRATE for use during next time step
          
         IF (.not. L_DESID_DIAG .and. MGN_ONLN_DEP) THEN 
                                      ! need this not to be zero'd 
                                      ! out on last time step
                                      ! and don't want it zero'd if using
                                      ! offline values
          NDEPRATE(c,r) = 0.0 
         END IF
          

         RETURN

         END SUBROUTINE GET_NDEPRES

C -----------------------------------------------------------------------------

        SUBROUTINE GET_N_DEP( SPEC,DEP,C,R )
            USE UTILIO_DEFN       
            USE centralized_io_module, only: ndeprate

            IMPLICIT NONE
            CHARACTER( 256 ) :: MESG            ! message buffer
            CHARACTER( 8 ), INTENT( IN ) :: SPEC  !  dep species
            REAL,      INTENT( IN ) :: DEP !  deposition rate in kg/ha/s 
            INTEGER,   INTENT( IN ) :: C
            INTEGER,   INTENT( IN ) :: R
            REAL, PARAMETER :: HAOM2   = 1.0e-4 ! ha/m^2 conversion
            REAL, PARAMETER :: MWNH3   = 17.031 ! molecular weight of NH3
            REAL, PARAMETER :: MWNH4   = 18.039 ! molecular weight of NH4
            REAL, PARAMETER :: MWHNO3  = 63.013 ! molecular weight of HNO3
            REAL, PARAMETER :: MWNO3   = 62.005 ! molecular weight of NO3
            REAL, PARAMETER :: MWNO2   = 46.006 ! molecular weight of NO2
            REAL, PARAMETER :: MWPAN   = 121.05 ! molecular weight of Peroxyacyl nitrate
            REAL, PARAMETER :: MWN     = 14.007 ! molecular weight of Nitrogen
            REAL, PARAMETER :: NGOKG   = 1.0e12 ! ng/kg conversion
            
            ! takes Kg/hectare/s and converts to ng N / m^2/s

            IF( INDEX(TRIM( SPEC ), 'NH3') .NE. 0 ) THEN
               NDEPRATE( C,R ) = NDEPRATE( C,R ) + DEP*HAOM2*NGOKG*MWN/MWNH3 
            ELSE IF( INDEX(TRIM( SPEC ), 'NH4') .NE. 0 ) THEN
               NDEPRATE( C,R ) = NDEPRATE( C,R ) + DEP*HAOM2*NGOKG*MWN/MWNH4
            ELSE IF( INDEX(TRIM( SPEC ), 'HNO3') .NE. 0 ) THEN
               NDEPRATE( C,R ) = NDEPRATE( C,R ) + DEP*HAOM2*NGOKG*MWN/MWHNO3
            ELSE IF( INDEX(TRIM( SPEC ), 'NO3') .NE. 0) THEN
               NDEPRATE( C,R ) = NDEPRATE( C,R ) + DEP*HAOM2*NGOKG*MWN/MWNO3
            ELSE IF( INDEX(TRIM( SPEC ), 'NO2') .NE. 0 ) THEN
               NDEPRATE( C,R ) = NDEPRATE( C,R ) + DEP*HAOM2*NGOKG*MWN/MWNO2
            ELSE IF( INDEX(TRIM( SPEC ), 'PAN') .NE. 0 ) THEN
               NDEPRATE( C,R ) = NDEPRATE( C,R ) + DEP*HAOM2*NGOKG*MWN/MWPAN
            Else
               MESG = 'Invalid Species Name in Get_N_Dep: "' // SPEC // '"'
               !CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
            END IF
            
            IF( (DEP<0.0) .OR. (NDEPRATE( C,R )<0.0) ) then
            Write(*,*) 'DEP or sum negative',DEP, ' ',NDEPRATE( C,R)
            MESG = 'negative'
               CALL M3EXIT( 'GET_N_DEP', 0, 0, MESG, XSTAT2 )
            END if

         RETURN

         
         END SUBROUTINE GET_N_DEP  

C -----------------------------------------------------------------------------
         REAL FUNCTION SOILTEMP( SOILT )
C Calculate the soil temperature factor

         IMPLICIT NONE
C Function arguments:
         REAL, INTENT( IN )       :: SOILT !kelvin, soil temperature
C Local Variables
         REAl SOILTC !temperature in degrees celsius
         CHARACTER( 256 ) :: MESG            ! message buffer
         CHARACTER( 16 )  :: PNAME = 'SOILTEMP'  ! procedure name
         SOILTC = SOILT - 273.16

         IF ( SOILTC <= 0d0 ) THEN
         ! No soil emissions if temp below freezing
         SOILTEMP = 0d0
C         BENCHMARKING:
C         MESG = 'temperature less than 0 in august florida?'
C         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT1 )

         ELSE

         ! Caps temperature response at 30C
         IF ( SOILTC >= 30.d0 ) SOILTC = 30.d0

         SOILTEMP =  EXP( 0.103 * SOILTC )

         ENDIF
         RETURN

         END FUNCTION SOILTEMP

C ---------------------------------------------------------------------------------------------------------
         REAL FUNCTION FERTADD( FERT , DEPN )
C Add fertilizer reservoir to deposition reservoir and create N driven
C emission factor
         IMPLICIT NONE
C Function arguments:
         REAL, INTENT( IN )       :: FERT !fertilizer reservoir [ngN/m2]
         REAL, INTENT( IN )       :: DEPN !deposition reservoir [ngN/m2]

C Local Variables
         REAL*8,  PARAMETER :: SECPERYEAR    = 86400.d0 * 365.
         ! Scale factor so that fertilizer emission = 1.8 Tg N/yr
         ! (Stehfest and Bouwman, 2006)
         ! before canopy reduction
         REAL*8, PARAMETER :: FERT_SCALE = 0.0068 ! [yr -1]
         ! Value calculated by running the 2x2.5 GEOS-Chem model
         ! (J.D. Maasakkers)
         FERTADD = FERT + DEPN
         FERTADD = FERTADD / SECPERYEAR * FERT_SCALE

         RETURN

         END FUNCTION FERTADD

C -------------------------------------------------------------------------------------

C Local Variables

         REAL FUNCTION SOILWET( THETA , ARID, NONARID)
C Calculate the soil moisture factor

         IMPLICIT NONE
C Function arguments:
         REAL, INTENT( IN )       :: THETA !0-1 soil moisture
         INTEGER, INTENT( IN )    :: ARID !1 indicates arid cell
         INTEGER, INTENT( IN )    :: NONARID !1 indicates nonarid cell, if both 0 then
C Local Variables

         IF ( ARID .EQ. 1 ) THEN !ARID, Max poison at theta = .2
         SOILWET = 8.24*THETA*EXP(-12.5*THETA*THETA)
         ELSE IF (NONARID .EQ. 1 ) THEN !NONARID Max Poisson at theta =.3
         SOILWET = 5.5*THETA*EXP(-5.55*THETA*THETA)
         ELSE !neither arid nor nonarid, water or non-emitting cell
         SOILWET = 0.0
         END IF

         RETURN

         END FUNCTION SOILWET

C -------------------------------------------------------------------

      SUBROUTINE GET_CANOPY_NOX(JDATE, JTIME, COSZEN,
     & TASFC, SSOLAR, PRES, LANDTYPE, LAI, SNOCOV, CFRAC, WSPD, CRF) ! called tmpbeis, change called BDSNP, add K argument

      IMPLICIT NONE

C Arguments
      INTEGER, INTENT( IN )  :: JDATE             ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN )  :: JTIME             ! current simulation time (HHMMSS)
C     These are arrays 
      REAL,    INTENT( IN ) :: COSZEN( NCOLS,NROWS )        ! cosine of zenith angle
      REAL,    INTENT( IN ) :: TASFC ( NCOLS,NROWS )        ! surface air temperature [K]
      REAL,    INTENT( IN ) :: SSOLAR( NCOLS,NROWS )        ! surface radiation [w/m**2]
      REAL,    INTENT( IN ) :: PRES  ( NCOLS,NROWS )        ! surface pressure [Pa]
      INTEGER, INTENT( IN ) :: LANDTYPE( NCOLS,NROWS )     ! the biome type in each cell
      REAL,    INTENT( IN ):: LAI  ( NCOLS,NROWS )        ! leaf area index (m2/m2)
      REAL,    INTENT( IN ):: SNOCOV  ( NCOLS,NROWS )        ! snow cover
      REAL,    INTENT( IN ):: CFRAC  ( NCOLS,NROWS )        ! cloud fraction
      REAL,    INTENT( IN ):: WSPD  ( NCOLS,NROWS )        ! cloud fraction
      REAL,    INTENT( OUT ):: CRF  ( NCOLS,NROWS )        ! outputs the canopy reduction factor
      ! !LOCAL VARIABLES:
      !
      CHARACTER( 16 )  :: PNAME = 'CANOPY_NOX'  ! procedure name
      INTEGER          IOS                ! IO or memory allocation status
      CHARACTER( 256 ) :: MESG            ! message buffer
      ! Scalars
      INTEGER :: C, R, K, KK, MY_NCOLS, MY_NROWS
      REAL*8  :: F0,     HSTAR, XMW              
      REAL*8  :: DTMP1,  DTMP2, DTMP3,  DTMP4, GFACT, GFACI
      REAL*8  :: RT,     RAD0,  RIX,    RIXX,  RDC,   RLUXX
      REAL*8  :: RGSX,   RCLX,  TEMPK,  TEMPC, WINDSQR
      REAL*8 :: VFNEW
      
      LOGICAL, SAVE          :: FIRSTCANOPY = .TRUE. 

      ! Arrays
      REAL*8  :: RI  (24)       
      REAL*8  :: RLU (24)      
      REAL*8  :: RAC (24)      
      REAL*8  :: RGSS(24)     
      REAL*8  :: RGSO(24)     
      REAL*8  :: RCLS(24)     
      REAL*8  :: RCLO(24)
! !DEFINED PARAMETERS:
!      
      INTEGER, PARAMETER :: SNIRI(24) = (/9999, 200, 9999, 9999, 9999, 9999, 
     & 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 400, 400, 
     & 200, 200, 200, 9999, 200/)

      INTEGER, PARAMETER :: SNIRLU(24) = (/9999, 9000, 9999, 9999, 9999, 
     & 9999, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 1000, 
     & 9000, 9000, 9000, 9000, 1000, 9000, 9999, 9000/)

      INTEGER, PARAMETER :: SNIRAC(24) = (/0, 300, 0, 0, 0, 0, 100, 100, 
     & 100, 100, 100, 100, 100, 100, 2000, 2000, 2000, 2000, 2000, 2000, 
     & 2000, 200, 100, 200/)

      INTEGER, PARAMETER :: SNIRGSS(24) = (/0, 0, 100, 1000, 100, 1000, 350, 
     & 350, 350, 350, 350, 350, 350, 350, 500, 200, 500, 500, 500, 500, 
     & 200, 150, 400, 150/)

      INTEGER, PARAMETER :: SNIRGSO(24) = (/2000, 1000, 3500, 400, 3500, 
     & 400, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 200, 
     & 200, 200, 200, 150, 300, 150/)

      INTEGER, PARAMETER :: SNIRCLS(24) = (/9999, 2500, 9999, 9999, 9999, 
     & 9999, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 9999, 
     & 2000, 2000, 2000, 2000, 9999, 2000, 9999, 2000/)
    
      INTEGER, PARAMETER :: SNIRCLO(24) = (/9999, 1000, 1000, 9999, 1000, 
     & 9999, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 1000, 9999, 
     & 1000, 1000, 1000, 1000, 9999, 1000, 9999, 1000/)

      INTEGER, PARAMETER :: SNIVSMAX(24) = (/10, 100, 100, 10, 100, 10, 100, 
     & 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 100, 
     & 100, 100, 100, 100/)   

      REAL, PARAMETER :: DRYCOEFF(20) = (/-0.358, 3.02, 3.85, -0.0978, -3.66, 
     & 12.0, 0.252, -7.8, 0.226, 0.274, 1.14, -2.19, 0.261, -4.62, 0.685, 
     & -0.254, 4.37, -0.266, -0.159, -0.206 /)   

      ! Canopy wind extinction coefficients
      ! (cf. Yienger & Levy [1995], Sec 5), now a function of the MODIS/KOPPEN biometype (J.D. Maasakkers)
       REAL*8,  PARAMETER :: SOILEXC(24)    = (/ 
     &  0.10, 0.50, 0.10, 0.10, 0.10,
     &  0.10, 0.10, 0.10, 0.10, 1.00,
     &  1.00, 1.00, 1.00, 2.00, 4.00,
     &  4.00, 4.00, 4.00, 4.00, 4.00,
     &  4.00, 2.00, 0.10, 2.00                  /)     
      

      ! Molecular weight of water [kg]
      REAL*8, PARAMETER :: XMWH2O = 18d-3
      !
      ! Ventilation velocity for NOx, day & night values [m/s]
      REAL*8,  PARAMETER :: VFDAY   = 1.0d-2
      REAL*8,  PARAMETER :: VFNIGHT = 0.2d-2 
      REAL*8, PARAMETER :: PRESS  = 1.5d5

      ! Set physical parameters
      HSTAR = 0.01d0              ! Henry's law constant
      F0    = 0.1d0               ! Reactivity factor for biological oxidation 
      XMW   = 46d-3               ! Molecular wt of NO2 (kg)

      IF( FIRSTCANOPY ) THEN
        FIRSTCANOPY = .FALSE.
      END IF
   
      CRF = 0d0 ! array
      
      ! begin calculating canopy reduction factor
      DO C=1, NCOLS
        DO R=1, NROWS
          IF(LAI(C,R) > 0.0) THEN
            TEMPC = TASFC(C,R) - 273.15d0 ! convert kelvin to Celsius
      ! Compute bulk surface resistance for gases.    
         !                                  
         !  Adjust external surface resistances for temperature; 
         !  from Wesely [1989], expression given in text on p. 1296.        
            RT = 1000.0D0 * EXP( -TEMPC - 4.0d0 )
         
                
         !--------------------------------------------------------------
         ! Get surface resistances - loop over biome types K
         !
         ! The land types within each grid square are defined using the 
         ! Olson land-type database.  Each of the Olson land types is 
         ! assigned a corresponding "deposition land type" with 
         ! characteristic values of surface resistance components.  
         ! There are 74 Olson land-types but only 11 deposition 
         ! land-types (i.e., many of the Olson land types share the 
         ! same deposition characteristics).  Surface resistance 
         ! components for the "deposition land types" are from Wesely 
         ! [1989] except for tropical forests [Jacob and Wofsy, 1990] 
         ! and for tundra [Jacob et al., 1992].  All surface resistance 
         ! components are normalized to a leaf area index of unity.
         !--------------------------------------------------------------
	!Set biometype
         
            K = LANDTYPE( C,R )
            
            ! Set second loop variable to K to allow snow/ice correction
	     KK = K

            ! If the surface is snow or ice, then set K=3
            IF ( SNOCOV(C,R) .EQ. 1 ) KK = 3

		!USE new MODIS/KOPPEN Biometypes to read data

            ! Read the internal resistance RI (minimum stomatal resistance 
            ! for water vapor, per unit area of leaf) from the IRI array; 
            ! a '9999' value means no deposition to stomata so we impose a 
            ! very large value for RI.
            RI(K) = DBLE( SNIRI(KK) )
            IF ( RI(K) >= 9999.D0 ) RI(K)= 1.D12
            
            ! Cuticular resistances IRLU read in from 'drydep.table'
            ! are per unit area of leaf; divide them by the leaf area index 
            ! to get a cuticular resistance for the bulk canopy.  If IRLU is 
            !'9999' it means there are no cuticular surfaces on which to 
            ! deposit so we impose a very large value for RLU.
            IF ( SNIRLU(KK) >= 9999 .OR. LAI(C,R) <= 0d0 ) THEN
               RLU(K)  = 1.D6
            ELSE
               RLU(K)= DBLE( SNIRLU(KK) ) / LAI(C,R) + RT
            ENDIF

            ! The following are the remaining resistances for the Wesely
            ! resistance-in-series model for a surface canopy
            ! (see Atmos. Environ. paper, Fig.1).  
            RAC(K)  = MAX( DBLE( SNIRAC(KK)  ),      1d0 )
            RGSS(K) = MAX( DBLE( SNIRGSS(KK) ) + RT, 1d0 )
            RGSO(K) = MAX( DBLE( SNIRGSO(KK) ) + RT, 1d0 ) 
            RCLS(K) =      DBLE( SNIRCLS(KK) ) + RT           
            RCLO(K) =      DBLE( SNIRCLO(KK) ) + RT 

            IF (  RAC(K) >= 9999.D0 ) RAC(K)  = 1d12
            IF ( RGSS(K) >= 9999.D0 ) RGSS(K) = 1d12
            IF ( RGSO(K) >= 9999.D0 ) RGSO(K) = 1d12
            IF ( RCLS(K) >= 9999.D0 ) RCLS(K) = 1d12         
            IF ( RCLO(K) >= 9999.D0 ) RCLO(K) = 1d12

            !-------------------------------------------------------------
            ! Adjust stomatal resistances for insolation and temperature:  
            ! 
            ! Temperature adjustment is from Wesely [1989], equation (3).
            ! 
            ! Light adjustment by the function BIOFIT is described by Wang 
            ! [1996].  It combines:
            !
            ! - Local dependence of stomal resistance on the intensity I 
            !   of light impinging the leaf; this is expressed as a 
            !   multiplicative factor I/(I+b) to the stomatal resistance 
            !   where b = 50 W m-2
            !   (equation (7) of Baldocchi et al. [1987])
            ! - Radiative transfer of direct and diffuse radiation in the 
            !   canopy using equations (12)-(16) from Guenther et al. 
            !   [1995]
            ! - Separate accounting of sunlit and shaded leaves using
            !   equation (12) of Guenther et al. [1995]
            ! - Partitioning of the radiation at the top of the canopy 
            !   into direct and diffuse components using a 
            !   parameterization to results from an atmospheric radiative 
            !   transfer model [Wang, 1996]
            !
            ! The dependent variables of the function BIOFIT are the leaf 
            ! area index (XYLAI), the cosine of zenith angle (SUNCOS) and 
            ! the fractional cloud cover (CFRAC).  The factor GFACI 
            ! integrates the light dependence over the canopy depth; so
            ! be scaled by LAI to yield a bulk canopy value because that's 
            ! already done in the GFACI formulation.
            !-------------------------------------------------------------

            ! Radiation @ sfc [W/m2]
            RAD0 = SSOLAR(C,R)
            
            ! Internal resistance
            RIX  = RI(K)

            ! Skip the following block if the resistance RIX is high
            IF ( RIX < 9999d0 ) THEN
               GFACT = 100.0D0

               IF ( TEMPC > 0.D0 .AND. TEMPC < 40.D0) THEN
                  GFACT = 400.D0 / TEMPC / ( 40.0D0 - TEMPC )
               ENDIF

               GFACI = 100.D0

               IF ( RAD0 > 0d0 .AND. LAI(C,R) > 0d0 ) THEN
                  GFACI= 1d0 / 
     &                   BIOFIT( DRYCOEFF,       LAI(C,R),
     &                           COSZEN(C,R), CFRAC(C,R)    )
               ENDIF
            
               RIX = RIX * GFACT * GFACI
            ENDIF
            
            ! Compute aerodynamic resistance to lower elements in lower 
            ! part of the canopy or structure, assuming level terrain - 
            ! equation (5) of Wesely [1989].                     
            RDC = 100.D0*(1.0D0+1000.0D0/(RAD0 + 10.D0))

            ! Loop over species; species-dependent corrections to resistances
            ! are from equations (6)-(9) of Wesely [1989].
            !
            ! NOTE: here we only consider NO2 (bmy, 6/22/09)
            RIXX   = RIX * DIFFG( TASFC(C,R), PRESS, XMWH2O ) /
     &                     DIFFG( TASFC(C,R), PRESS, XMW    )
     &             + 1.D0 / ( HSTAR/3000.D0 + 100.D0*F0  )

            RLUXX  = 1.D12

            IF ( RLU(K) < 9999.D0 ) THEN
               RLUXX = RLU(K) / ( HSTAR / 1.0D+05 + F0 )
            ENDIF
            
            ! To prevent virtually zero resistance to species with huge HSTAR, 
            ! such as HNO3, a minimum value of RLUXX needs to be set. 
            ! The rationality of the existence of such a minimum is 
            ! demonstrated by the observed relationship between Vd(NOy-NOx) 
            ! and Ustar in Munger et al.[1996]; Vd(HNO3) never exceeds 2 cm/s 
            ! in observations. The corresponding minimum resistance is 50 s/m.
            ! was introduced by J.Y. Liang on 7/9/95.
            RGSX = 1d0 / ( HSTAR/1d5/RGSS(K) + F0/RGSO(K) )
            RCLX = 1d0 / ( HSTAR/1d5/RCLS(K) + F0/RCLO(K) )

            ! Get the bulk surface resistance of the canopy
            ! from the network of resistances in parallel and in series 
            ! (Fig. 1 of Wesely [1989])
            DTMP1 = 1.D0 / RIXX
            DTMP2 = 1.D0 / RLUXX
            DTMP3 = 1.D0 / ( RAC(K) + RGSX )
            DTMP4 = 1.D0 / ( RDC      + RCLX )

            ! Save the within canopy depvel of NOx, used in calculating 
            ! the canopy reduction factor for soil emissions [1/s]
            CRF(C,R) = DTMP1 + DTMP2 + DTMP3 + DTMP4
            
            ! Pick proper ventilation velocity for day or night
            IF ( COSZEN( C,R ) > 0d0 ) THEN
               VFNEW = VFDAY              
            ELSE 
               VFNEW = VFNIGHT            
            ENDIF

      ! If the leaf area index and the bulk surface resistance
      ! of the canopy to NOx deposition are both nonzero ...
            IF (CRF(C,R) > 0d0 ) THEN

         ! Adjust the ventilation velocity.  
         ! NOTE: SOILEXC(21) is the canopy wind extinction 
         ! coefficient for the tropical rainforest biome.
              WINDSQR=WSPD(C,R)*WSPD(C,R)
              VFNEW    = (VFNEW * SQRT( WINDSQR/9d0 * 7d0/LAI(C,R)) *
     &                          ( SOILEXC(21)  / SOILEXC(K) ))

         ! Soil canopy reduction factor
              CRF(C,R) = CRF(C,R) / ( CRF(C,R) + VFNEW )
         
C         IF( CRF(C,R) > 1.0 ) THEN
C         write(*,*) 'CANOPY NOX REDUCTION FACTOR TOO HIGH'
C         write(*,*) 'C,R,k,crf,vfnew,dt1,dt2,dt3,dt4'
C         write(*,*) C,R,k, CRF(C,R), VFNEW, DTMP1, DTMP2, DTMP3, DTMP4 
C         write(*,*) 'windsqr, cos, lai'
C         write(*,*) WINDSQR, COSZEN(C,R),LAI(C,R)
C         write(*,*) 'soil21/soilk'
C         write(*,*) SOILEXC(21)/SOILEXC(K) 
C         write(*,*) 'rdc,rclx,rac,rgsx,rluxx,rixx,rclo'
C         write(*,*) RDC, RCLX, RAC(K), RGSX, RLUXX, RIXX, RCLO(K)
C         write(*,*) 'RCLS(K), RGSO(K), RGSS(K), RLU(K)'
C         write(*,*) RCLS(K), RGSO(K), RGSS(K), RLU(K)
C         write(*,*) 'DIFFG(h20)/DIFFG(no2)'        
c         write(*,*) DIFFG( TASFC(C,R), PRESS, XMWH2O ) /
C     &                     DIFFG( TASFC(C,R), PRESS, XMW    )
C        write(*,*) DIFFG( TASFC(C,R), PRESS, XMWH2O )
C         write(*,*) DIFFG( TASFC(C,R), PRESS, XMW    )
C         write(*,*) TASFC(C,R), PRESS, XMW, XMWH2O
C         write(*,*) '1.D0 / ( HSTAR/3000.D0 + 100.D0*F0  )'
C         write(*,*) 1.D0 / ( HSTAR/3000.D0 + 100.D0*F0  )
C         write(*,*) 'RAD0, GFACT, GFACI, BIOFIT'
C         write(*,*) RAD0, GFACT, GFACI, BIOFIT( DRYCOEFF, LAI(C,R),
C     &                           COSZEN(C,R), CFRAC(C,R))
C         write(*,*) 'TEMPC, CFRAC(C,R), DRYCOEFF(K), RT'
C         write(*,*) TEMPC, CFRAC(C,R), DRYCOEFF(K), RT
C         write(*,*) 'RI(K),RLU(K),RAC(K),RGSS(K),RGSO(K),RCLS(K),RCLO(K)'
C         write(*,*) RI(K), RLU(K),RAC(K),RGSS(K),RGSO(K),RCLS(K),RCLO(K)
C         MESG = 'CRF too high'
C         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT1 )
C         END IF   

            ELSE ! CRF < 0.0
     
         ! Otherwise set the soil canopy reduction factor to zero
              CRF(C,R) = 0d0

            END IF

            IF( CRF(C,R) .LT. 0.0) THEN
            
            MESG = 'CRF Less than 0'
!            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, 2 )
            
            ELSE IF( CRF(C,R) .GT. 1.0) THEN
            
            MESG = 'CRF Greater than one'
!            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, 2 ) 
            
            END IF
            
          ELSE
            CRF(C,R) = 0.0
          END IF !lai check

        END DO !row loop
      END DO !col loop
            
      END SUBROUTINE GET_CANOPY_NOX
      
      FUNCTION DIFFG( TK, PRESS, XM ) RESULT( DIFF_G )
! !DESCRIPTION: Function DIFFG calculates the molecular diffusivity [m2/s] in 
!  air for a gas X of molecular weight XM [kg] at temperature TK [K] and 
!  pressure PRESS [Pa].
!\\
!\\
!  We specify the molecular weight of air (XMAIR) and the hard-sphere molecular
!  radii of air (RADAIR) and of the diffusing gas (RADX).  The molecular
!  radius of air is given in a Table on p. 479 of Levine [1988].  The Table
!  also gives radii for some other molecules.  Rather than requesting the user
!  to supply a molecular radius we specify here a generic value of 2.E-10 m for
!  all molecules, which is good enough in terms of calculating the diffusivity
!  as long as molecule is not too big.
!
! !INPUT PARAMETERS:
!
      REAL, INTENT(IN) :: TK      ! Temperature [K]
      REAL*8, INTENT(IN) :: PRESS   ! Pressure [Pa]
      REAL*8, INTENT(IN) :: XM      ! Molecular weight of gas [kg]
!
! !RETURN VALUE:
!
      REAL*8             :: DIFF_G  ! Molecular diffusivity [m2/s]
!
! !REVISION HISTORY:
!     22 Jun 2009 - R. Yantosca - Copied from "drydep_mod.f"
!EOP
!------------------------------------------------------------------------------
!BOC
!
! !LOCAL VARIABLES:
!
      REAL*8             :: AIRDEN, Z, DIAM, FRPATH, SPEED            
!
! !DEFINED PARAMETERS:
!
      REAL*8, PARAMETER  :: XMAIR  = 28.8d-3 
      REAL*8, PARAMETER  :: RADAIR = 1.2d-10
      REAL*8, PARAMETER  :: PI     = 3.1415926535897932d0
      REAL*8, PARAMETER  :: RADX   = 1.5d-10
      REAL*8, PARAMETER  :: RGAS   = 8.32d0
      REAL*8, PARAMETER  :: AVOGAD = 6.023d23

      !=================================================================
      ! DIFFG begins here!
      !=================================================================

      ! Air density
      AIRDEN = ( PRESS * AVOGAD ) / ( RGAS * TK )

      ! DIAM is the collision diameter for gas X with air.
      DIAM   = RADX + RADAIR

      ! Calculate the mean free path for gas X in air: 
      ! eq. 8.5 of Seinfeld [1986];
      Z      = XM  / XMAIR
      FRPATH = 1d0 /( PI * SQRT( 1d0 + Z ) * AIRDEN*( DIAM**2 ) )

      ! Calculate average speed of gas X; eq. 15.47 of Levine [1988]
      SPEED  = SQRT( 8d0 * RGAS * TK / ( PI * XM ) )

      ! Calculate diffusion coefficient of gas X in air; 
      ! eq. 8.9 of Seinfeld [1986]
      DIFF_G = ( 3d0 * PI / 32d0 ) * ( 1d0 + Z ) * FRPATH * SPEED

      ! Return to calling program
      END FUNCTION DIFFG
      
      SUBROUTINE SUNPARAM(X)

      IMPLICIT NONE


!===============================================
! the sequence is lai,suncos,cloud fraction
!===============================================
!  NN = number of variables (lai,suncos,cloud fraction)
      INTEGER NN
      PARAMETER(NN=3)
!  ND = scaling factor for each variable
      INTEGER ND(NN),I
      DATA ND /55,20,11/
!  X0 = maximum for each variable
      REAL X(NN),X0(NN),XLOW
      DATA X0 /11.,1.,1./

      DO I=1,NN
        X(I)=MIN(X(I),X0(I))
! XLOW = minimum for each variable
        IF (I.NE.3) THEN
          XLOW=X0(I)/REAL(ND(I))
        ELSE
          XLOW= 0.
        END IF
        X(I)=MAX(X(I),XLOW)
        X(I)=X(I)/X0(I)
      END DO

      RETURN
      END SUBROUTINE SUNPARAM
      
      REAL*8 FUNCTION BIOFIT(COEFF1,XLAI1,SUNCOS1,CFRAC1)

      IMPLICIT NONE

!===============================================
! Calculate the light correction
!===============================================
!* BIOFIT and SUNPARAM were written by Y.H. Wang.   
!*             !-------------------------------------------------------------
            ! Adjust stomatal resistances for insolation and temperature:  
            ! 
            ! Temperature adjustment is from Wesely [1989], equation (3).
            ! 
            ! Light adjustment by the function BIOFIT is described by Wang 
            ! [1996].  It combines:
            !
            ! - Local dependence of stomal resistance on the intensity I 
            !   of light impinging the leaf; this is expressed as a 
            !   multiplicative factor I/(I+b) to the stomatal resistance 
            !   where b = 50 W m-2
            !   (equation (7) of Baldocchi et al. [1987])
            ! - Radiative transfer of direct and diffuse radiation in the 
            !   canopy using equations (12)-(16) from Guenther et al. 
            !   [1995]
            ! - Separate accounting of sunlit and shaded leaves using
            !   equation (12) of Guenther et al. [1995]
            ! - Partitioning of the radiation at the top of the canopy 
            !   into direct and diffuse components using a 
            !   parameterization to results from an atmospheric radiative 
            !   transfer model [Wang, 1996]
            !
            ! The dependent variables of the function BIOFIT are the leaf 
            ! area index (XYLAI), the cosine of zenith angle (SUNCOS) and 
            ! the fractional cloud cover (CFRAC).  The factor GFACI 
            ! integrates the light dependence over the canopy depth; so
            ! be scaled by LAI to yield a bulk canopy value because that's 
            ! already done in the GFACI formulation.
!*************************************************************
      INTEGER KK
      PARAMETER (KK=4)
      REAL COEFF1(20),TERM(KK),REALTERM(20)
      REAL XLAI1,SUNCOS1,CFRAC1
      INTEGER K,K1,K2,K3

      TERM(1)=1.
      TERM(2)=XLAI1
      TERM(3)=SUNCOS1
      TERM(4)=CFRAC1
      CALL SUNPARAM(TERM(2))
      K=0
      DO K3=1,KK
        DO K2=K3,KK
          DO K1=K2,KK
            K=K+1
            REALTERM(K)=TERM(K1)*TERM(K2)*TERM(K3)
          END DO
        END DO
      END DO
      BIOFIT=0
      DO K=1,20
        BIOFIT=BIOFIT+COEFF1(K)*REALTERM(K)
      END DO
      IF (BIOFIT.LT.0.1) BIOFIT=0.1

      RETURN
      END FUNCTION BIOFIT
      
!  References:
!  ============================================================================
!  (1 ) Baldocchi, D.D., B.B. Hicks, and P. Camara, "A canopy stomatal
!        resistance model for gaseous deposition to vegetated surfaces",
!        Atmos. Environ. 21, 91-101, 1987.
!  (2 ) Brutsaert, W., "Evaporation into the Atmosphere", Reidel, 1982.
!  (3 ) Businger, J.A., et al., "Flux-profile relationships in the atmospheric 
!        surface layer", J. Atmos. Sci., 28, 181-189, 1971.
!  (4 ) Dwight, H.B., "Tables of integrals and other mathematical data",
!        MacMillan, 1957.
!  (5 ) Guenther, A., and 15 others, A global model of natural volatile
!         organic compound emissions, J. Geophys. Res., 100, 8873-8892, 1995.
!  (6 ) Hicks, B.B., and P.S. Liss, "Transfer of SO2 and other reactive
!        gases across the air-sea interface", Tellus, 28, 348-354, 1976.
!  (7 ) Jacob, D.J., and S.C. Wofsy, "Budgets of reactive nitrogen,
!        hydrocarbons, and ozone over the Amazon forest during the wet season",
!        J.  Geophys. Res., 95, 16737-16754, 1990.
!  (8 ) Jacob, D.J., et al, "Deposition of ozone to tundra", J. Geophys. Res., 
!        97, 16473-16479, 1992.
!  (9 ) Levine, I.N., "Physical Chemistry, 3rd ed.", McGraw-Hill, 
!        New York, 1988.
!  (10) Munger, J.W., et al, "Atmospheric deposition of reactive nitrogen 
!        oxides and ozone in a temperate deciduous forest and a sub-arctic 
!        woodland", J. Geophys. Res., in press, 1996.
!  (11) Walcek, C.J., R.A. Brost, J.S. Chang, and M.L. Wesely, "SO2, sulfate, 
!        and HNO3 deposition velocities computed using regional landuse and
!        meteorological data", Atmos. Environ., 20, 949-964, 1986.
!  (12) Wang, Y.H., paper in preparation, 1996.
!  (13) Wesely, M.L, "Improved parameterizations for surface resistance to
!        gaseous dry deposition in regional-scale numerical models", 
!        Environmental Protection Agency Report EPA/600/3-88/025,
!        Research Triangle Park (NC), 1988.
!  (14) Wesely, M. L., Parameterization of surface resistance to gaseous dry 
!        deposition in regional-scale numerical models.  Atmos. Environ., 23
!        1293-1304, 1989. 
!  (15) Price, H., L. Jaeglé, A. Rice, P. Quay, P.C. Novelli, R. Gammon, 
!        Global Budget of Molecular Hydrogen and its Deuterium Content: 
!        Constraints from Ground Station, Cruise, and Aircraft Observations,
!        submitted to J. Geophys. Res., 2007.      
      END MODULE BDSNP_MOD
      

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE HRRATES

C***********************************************************************
C
C  FUNCTION: To calculate rates of reactions
C
C  PRECONDITIONS: For the CB6R5PFAS_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, Jun 26, 2025
C
C***********************************************************************
      USE HRDATA

      IMPLICIT NONE

C.....INCLUDES: NONE


C.....ARGUMENTS: NONE


C.....PARAMETERS: NONE


C.....EXTERNAL FUNCTIONS: NONE


C.....SAVED VARIABLES: NONE
!     CHARACTER( 16 ), SAVE  ::  PNAME = 'HRRATES'   ! Program name


C.....LOCAL VARIABLES: None

C***********************************************************************
C..NOTE: RXRAT commented out are not referenced by any routine
!     RXRAT(      1 ) = RKI(     1 ) * YC(  NO2 )
!     RXRAT(      2 ) = RKI(     2 ) * YC(  O )
!     RXRAT(      3 ) = RKI(     3 ) * YC(  O3 ) * YC(  NO )
!     RXRAT(      4 ) = RKI(     4 ) * YC(  O ) * YC(  NO )
!     RXRAT(      5 ) = RKI(     5 ) * YC(  O ) * YC(  NO2 )
      RXRAT(      6 ) = RKI(     6 ) * YC(  O ) * YC(  NO2 )
!     RXRAT(      7 ) = RKI(     7 ) * YC(  O ) * YC(  O3 )
      RXRAT(      8 ) = RKI(     8 ) * YC(  O3 )
      RXRAT(      9 ) = RKI(     9 ) * YC(  O3 )
!     RXRAT(     10 ) = RKI(    10 ) * YC(  O1D )
!     RXRAT(     11 ) = RKI(    11 ) * YC(  O1D )
!     RXRAT(     12 ) = RKI(    12 ) * YC(  O3 ) * YC(  OH )
!     RXRAT(     13 ) = RKI(    13 ) * YC(  O3 ) * YC(  HO2 )
!     RXRAT(     14 ) = RKI(    14 ) * YC(  OH ) * YC(  O )
!     RXRAT(     15 ) = RKI(    15 ) * YC(  HO2 ) * YC(  O )
      RXRAT(     16 ) = RKI(    16 ) * YC(  OH ) * YC(  OH )
      RXRAT(     17 ) = RKI(    17 ) * YC(  OH ) * YC(  OH )
!     RXRAT(     18 ) = RKI(    18 ) * YC(  OH ) * YC(  HO2 )
      RXRAT(     19 ) = RKI(    19 ) * YC(  HO2 ) * YC(  HO2 )
      RXRAT(     20 ) = RKI(    20 ) * YC(  HO2 ) * YC(  HO2 )
      RXRAT(     21 ) = RKI(    21 ) * YC(  H2O2 )
      RXRAT(     22 ) = RKI(    22 ) * YC(  H2O2 ) * YC(  OH )
      RXRAT(     23 ) = RKI(    23 ) * YC(  H2O2 ) * YC(  O )
!     RXRAT(     24 ) = RKI(    24 ) * YC(  NO ) * YC(  NO )
!     RXRAT(     25 ) = RKI(    25 ) * YC(  HO2 ) * YC(  NO )
      RXRAT(     26 ) = RKI(    26 ) * YC(  NO2 ) * YC(  O3 )
      RXRAT(     27 ) = RKI(    27 ) * YC(  NO3 )
      RXRAT(     28 ) = RKI(    28 ) * YC(  NO3 )
      RXRAT(     29 ) = RKI(    29 ) * YC(  NO3 ) * YC(  NO )
      RXRAT(     30 ) = RKI(    30 ) * YC(  NO3 ) * YC(  NO2 )
      RXRAT(     31 ) = RKI(    31 ) * YC(  NO3 ) * YC(  O )
      RXRAT(     32 ) = RKI(    32 ) * YC(  NO3 ) * YC(  OH )
      RXRAT(     33 ) = RKI(    33 ) * YC(  NO3 ) * YC(  HO2 )
      RXRAT(     34 ) = RKI(    34 ) * YC(  NO3 ) * YC(  O3 )
      RXRAT(     35 ) = RKI(    35 ) * YC(  NO3 ) * YC(  NO3 )
!     RXRAT(     36 ) = RKI(    36 ) * YC(  NO3 ) * YC(  NO2 )
      RXRAT(     37 ) = RKI(    37 ) * YC(  N2O5 )
      RXRAT(     38 ) = RKI(    38 ) * YC(  N2O5 )
      RXRAT(     39 ) = RKI(    39 ) * YC(  N2O5 )
!     RXRAT(     40 ) = RKI(    40 ) * YC(  NO ) * YC(  OH )
      RXRAT(     41 ) = RKI(    41 ) * YC(  NO ) * YC(  NO2 )
      RXRAT(     42 ) = RKI(    42 ) * YC(  HONO ) * YC(  HONO )
      RXRAT(     43 ) = RKI(    43 ) * YC(  HONO )
      RXRAT(     44 ) = RKI(    44 ) * YC(  HONO ) * YC(  OH )
      RXRAT(     45 ) = RKI(    45 ) * YC(  NO2 ) * YC(  OH )
      RXRAT(     46 ) = RKI(    46 ) * YC(  HNO3 ) * YC(  OH )
      RXRAT(     47 ) = RKI(    47 ) * YC(  HNO3 )
!     RXRAT(     48 ) = RKI(    48 ) * YC(  HO2 ) * YC(  NO2 )
      RXRAT(     49 ) = RKI(    49 ) * YC(  PNA )
      RXRAT(     50 ) = RKI(    50 ) * YC(  PNA )
      RXRAT(     51 ) = RKI(    51 ) * YC(  PNA ) * YC(  OH )
      RXRAT(     52 ) = RKI(    52 ) * YC(  SO2 ) * YC(  OH )
      RXRAT(     53 ) = RKI(    53 ) * YC(  C2O3 ) * YC(  NO )
!     RXRAT(     54 ) = RKI(    54 ) * YC(  C2O3 ) * YC(  NO2 )
      RXRAT(     55 ) = RKI(    55 ) * YC(  PAN )
      RXRAT(     56 ) = RKI(    56 ) * YC(  PAN )
      RXRAT(     57 ) = RKI(    57 ) * YC(  C2O3 ) * YC(  HO2 )
      RXRAT(     58 ) = RKI(    58 ) * YC(  C2O3 ) * YC(  RO2 )
      RXRAT(     59 ) = RKI(    59 ) * YC(  C2O3 ) * YC(  C2O3 )
      RXRAT(     60 ) = RKI(    60 ) * YC(  C2O3 ) * YC(  CXO3 )
      RXRAT(     61 ) = RKI(    61 ) * YC(  CXO3 ) * YC(  NO )
      RXRAT(     62 ) = RKI(    62 ) * YC(  CXO3 ) * YC(  NO2 )
      RXRAT(     63 ) = RKI(    63 ) * YC(  PANX )
      RXRAT(     64 ) = RKI(    64 ) * YC(  PANX )
      RXRAT(     65 ) = RKI(    65 ) * YC(  CXO3 ) * YC(  HO2 )
      RXRAT(     66 ) = RKI(    66 ) * YC(  CXO3 ) * YC(  RO2 )
      RXRAT(     67 ) = RKI(    67 ) * YC(  CXO3 ) * YC(  CXO3 )
      RXRAT(     68 ) = RKI(    68 ) * YC(  RO2 ) * YC(  NO )
      RXRAT(     69 ) = RKI(    69 ) * YC(  RO2 ) * YC(  HO2 )
      RXRAT(     70 ) = RKI(    70 ) * YC(  RO2 ) * YC(  RO2 )
      RXRAT(     71 ) = RKI(    71 ) * YC(  MEO2 ) * YC(  NO )
      RXRAT(     72 ) = RKI(    72 ) * YC(  MEO2 ) * YC(  HO2 )
      RXRAT(     73 ) = RKI(    73 ) * YC(  MEO2 ) * YC(  C2O3 )
      RXRAT(     74 ) = RKI(    74 ) * YC(  MEO2 ) * YC(  RO2 )
      RXRAT(     75 ) = RKI(    75 ) * YC(  XO2H ) * YC(  NO )
      RXRAT(     76 ) = RKI(    76 ) * YC(  XO2H ) * YC(  HO2 )
      RXRAT(     77 ) = RKI(    77 ) * YC(  XO2H ) * YC(  C2O3 )
      RXRAT(     78 ) = RKI(    78 ) * YC(  XO2H ) * YC(  RO2 )
      RXRAT(     79 ) = RKI(    79 ) * YC(  XO2 ) * YC(  NO )
      RXRAT(     80 ) = RKI(    80 ) * YC(  XO2 ) * YC(  HO2 )
      RXRAT(     81 ) = RKI(    81 ) * YC(  XO2 ) * YC(  C2O3 )
      RXRAT(     82 ) = RKI(    82 ) * YC(  XO2 ) * YC(  RO2 )
      RXRAT(     83 ) = RKI(    83 ) * YC(  XO2N ) * YC(  NO )
      RXRAT(     84 ) = RKI(    84 ) * YC(  XO2N ) * YC(  HO2 )
      RXRAT(     85 ) = RKI(    85 ) * YC(  XO2N ) * YC(  C2O3 )
      RXRAT(     86 ) = RKI(    86 ) * YC(  XO2N ) * YC(  RO2 )
      RXRAT(     87 ) = RKI(    87 ) * YC(  MEPX ) * YC(  OH )
      RXRAT(     88 ) = RKI(    88 ) * YC(  MEPX )
      RXRAT(     89 ) = RKI(    89 ) * YC(  ROOH ) * YC(  OH )
      RXRAT(     90 ) = RKI(    90 ) * YC(  ROOH )
      RXRAT(     91 ) = RKI(    91 ) * YC(  NTR1 ) * YC(  OH )
      RXRAT(     92 ) = RKI(    92 ) * YC(  NTR1 )
      RXRAT(     93 ) = RKI(    93 ) * YC(  FACD ) * YC(  OH )
      RXRAT(     94 ) = RKI(    94 ) * YC(  AACD ) * YC(  OH )
      RXRAT(     95 ) = RKI(    95 ) * YC(  PACD ) * YC(  OH )
      RXRAT(     96 ) = RKI(    96 ) * YC(  FORM ) * YC(  OH )
      RXRAT(     97 ) = RKI(    97 ) * YC(  FORM )
      RXRAT(     98 ) = RKI(    98 ) * YC(  FORM )
      RXRAT(     99 ) = RKI(    99 ) * YC(  FORM ) * YC(  O )
      RXRAT(    100 ) = RKI(   100 ) * YC(  FORM ) * YC(  NO3 )
      RXRAT(    101 ) = RKI(   101 ) * YC(  FORM ) * YC(  HO2 )
      RXRAT(    102 ) = RKI(   102 ) * YC(  HCO3 )
      RXRAT(    103 ) = RKI(   103 ) * YC(  HCO3 ) * YC(  NO )
      RXRAT(    104 ) = RKI(   104 ) * YC(  HCO3 ) * YC(  HO2 )
      RXRAT(    105 ) = RKI(   105 ) * YC(  ALD2 ) * YC(  O )
      RXRAT(    106 ) = RKI(   106 ) * YC(  ALD2 ) * YC(  OH )
      RXRAT(    107 ) = RKI(   107 ) * YC(  ALD2 ) * YC(  NO3 )
      RXRAT(    108 ) = RKI(   108 ) * YC(  ALD2 )
      RXRAT(    109 ) = RKI(   109 ) * YC(  ALDX ) * YC(  O )
      RXRAT(    110 ) = RKI(   110 ) * YC(  ALDX ) * YC(  OH )
      RXRAT(    111 ) = RKI(   111 ) * YC(  ALDX ) * YC(  NO3 )
      RXRAT(    112 ) = RKI(   112 ) * YC(  ALDX )
      RXRAT(    113 ) = RKI(   113 ) * YC(  GLYD ) * YC(  OH )
      RXRAT(    114 ) = RKI(   114 ) * YC(  GLYD )
      RXRAT(    115 ) = RKI(   115 ) * YC(  GLYD ) * YC(  NO3 )
      RXRAT(    116 ) = RKI(   116 ) * YC(  GLY ) * YC(  OH )
      RXRAT(    117 ) = RKI(   117 ) * YC(  GLY )
      RXRAT(    118 ) = RKI(   118 ) * YC(  GLY ) * YC(  NO3 )
      RXRAT(    119 ) = RKI(   119 ) * YC(  MGLY )
      RXRAT(    120 ) = RKI(   120 ) * YC(  MGLY ) * YC(  NO3 )
      RXRAT(    121 ) = RKI(   121 ) * YC(  MGLY ) * YC(  OH )
!     RXRAT(    122 ) = RKI(   122 ) * YC(  OH )
      RXRAT(    123 ) = RKI(   123 ) * YC(  CO ) * YC(  OH )
      RXRAT(    124 ) = RKI(   124 ) * YC(  OH )
      RXRAT(    125 ) = RKI(   125 ) * YC(  ETHA ) * YC(  OH )
      RXRAT(    126 ) = RKI(   126 ) * YC(  MEOH ) * YC(  OH )
      RXRAT(    127 ) = RKI(   127 ) * YC(  ETOH ) * YC(  OH )
      RXRAT(    128 ) = RKI(   128 ) * YC(  KET )
      RXRAT(    129 ) = RKI(   129 ) * YC(  ACET )
      RXRAT(    130 ) = RKI(   130 ) * YC(  ACET ) * YC(  OH )
      RXRAT(    131 ) = RKI(   131 ) * YC(  PRPA ) * YC(  OH )
      RXRAT(    132 ) = RKI(   132 ) * YC(  PAR ) * YC(  OH )
      RXRAT(    133 ) = RKI(   133 ) * YC(  ROR )
      RXRAT(    134 ) = RKI(   134 ) * YC(  ROR )
      RXRAT(    135 ) = RKI(   135 ) * YC(  ROR ) * YC(  NO2 )
      RXRAT(    136 ) = RKI(   136 ) * YC(  ETHY ) * YC(  OH )
      RXRAT(    137 ) = RKI(   137 ) * YC(  ETH ) * YC(  O )
      RXRAT(    138 ) = RKI(   138 ) * YC(  ETH ) * YC(  OH )
      RXRAT(    139 ) = RKI(   139 ) * YC(  ETH ) * YC(  O3 )
      RXRAT(    140 ) = RKI(   140 ) * YC(  ETH ) * YC(  NO3 )
      RXRAT(    141 ) = RKI(   141 ) * YC(  OLE ) * YC(  O )
      RXRAT(    142 ) = RKI(   142 ) * YC(  OLE ) * YC(  OH )
      RXRAT(    143 ) = RKI(   143 ) * YC(  OLE ) * YC(  O3 )
      RXRAT(    144 ) = RKI(   144 ) * YC(  OLE ) * YC(  NO3 )
      RXRAT(    145 ) = RKI(   145 ) * YC(  IOLE ) * YC(  O )
      RXRAT(    146 ) = RKI(   146 ) * YC(  IOLE ) * YC(  OH )
      RXRAT(    147 ) = RKI(   147 ) * YC(  IOLE ) * YC(  O3 )
      RXRAT(    148 ) = RKI(   148 ) * YC(  IOLE ) * YC(  NO3 )
      RXRAT(    149 ) = RKI(   149 ) * YC(  ISOP ) * YC(  OH )
      RXRAT(    150 ) = RKI(   150 ) * YC(  ISOP ) * YC(  O )
      RXRAT(    151 ) = RKI(   151 ) * YC(  ISO2 ) * YC(  NO )
      RXRAT(    152 ) = RKI(   152 ) * YC(  ISO2 ) * YC(  HO2 )
      RXRAT(    153 ) = RKI(   153 ) * YC(  ISO2 ) * YC(  C2O3 )
      RXRAT(    154 ) = RKI(   154 ) * YC(  ISO2 ) * YC(  RO2 )
      RXRAT(    155 ) = RKI(   155 ) * YC(  ISO2 )
      RXRAT(    156 ) = RKI(   156 ) * YC(  ISOP ) * YC(  O3 )
      RXRAT(    157 ) = RKI(   157 ) * YC(  ISOP ) * YC(  NO3 )
      RXRAT(    158 ) = RKI(   158 ) * YC(  ISPD ) * YC(  OH )
      RXRAT(    159 ) = RKI(   159 ) * YC(  ISPD ) * YC(  O3 )
      RXRAT(    160 ) = RKI(   160 ) * YC(  ISPD ) * YC(  NO3 )
      RXRAT(    161 ) = RKI(   161 ) * YC(  ISPD )
      RXRAT(    162 ) = RKI(   162 ) * YC(  ISPX ) * YC(  OH )
      RXRAT(    163 ) = RKI(   163 ) * YC(  HPLD )
      RXRAT(    164 ) = RKI(   164 ) * YC(  HPLD ) * YC(  NO3 )
      RXRAT(    165 ) = RKI(   165 ) * YC(  EPOX ) * YC(  OH )
      RXRAT(    166 ) = RKI(   166 ) * YC(  EPX2 ) * YC(  HO2 )
      RXRAT(    167 ) = RKI(   167 ) * YC(  EPX2 ) * YC(  NO )
      RXRAT(    168 ) = RKI(   168 ) * YC(  EPX2 ) * YC(  C2O3 )
      RXRAT(    169 ) = RKI(   169 ) * YC(  EPX2 ) * YC(  RO2 )
      RXRAT(    170 ) = RKI(   170 ) * YC(  INTR ) * YC(  OH )
      RXRAT(    171 ) = RKI(   171 ) * YC(  TERP ) * YC(  O )
      RXRAT(    172 ) = RKI(   172 ) * YC(  TERP ) * YC(  OH )
      RXRAT(    173 ) = RKI(   173 ) * YC(  TERP ) * YC(  O3 )
      RXRAT(    174 ) = RKI(   174 ) * YC(  TERP ) * YC(  NO3 )
      RXRAT(    175 ) = RKI(   175 ) * YC(  APIN ) * YC(  O )
      RXRAT(    176 ) = RKI(   176 ) * YC(  APIN ) * YC(  OH )
      RXRAT(    177 ) = RKI(   177 ) * YC(  APIN ) * YC(  O3 )
      RXRAT(    178 ) = RKI(   178 ) * YC(  APIN ) * YC(  NO3 )
      RXRAT(    179 ) = RKI(   179 ) * YC(  BENZENE ) * YC(  OH )
      RXRAT(    180 ) = RKI(   180 ) * YC(  BZO2 ) * YC(  NO )
      RXRAT(    181 ) = RKI(   181 ) * YC(  BZO2 ) * YC(  C2O3 )
      RXRAT(    182 ) = RKI(   182 ) * YC(  BZO2 ) * YC(  HO2 )
      RXRAT(    183 ) = RKI(   183 ) * YC(  BZO2 ) * YC(  RO2 )
      RXRAT(    184 ) = RKI(   184 ) * YC(  TOL ) * YC(  OH )
      RXRAT(    185 ) = RKI(   185 ) * YC(  TO2 ) * YC(  NO )
      RXRAT(    186 ) = RKI(   186 ) * YC(  TO2 ) * YC(  C2O3 )
      RXRAT(    187 ) = RKI(   187 ) * YC(  TO2 ) * YC(  HO2 )
      RXRAT(    188 ) = RKI(   188 ) * YC(  TO2 ) * YC(  RO2 )
      RXRAT(    189 ) = RKI(   189 ) * YC(  XYLMN ) * YC(  OH )
      RXRAT(    190 ) = RKI(   190 ) * YC(  NAPH ) * YC(  OH )
      RXRAT(    191 ) = RKI(   191 ) * YC(  XLO2 ) * YC(  NO )
      RXRAT(    192 ) = RKI(   192 ) * YC(  XLO2 ) * YC(  HO2 )
      RXRAT(    193 ) = RKI(   193 ) * YC(  XLO2 ) * YC(  C2O3 )
      RXRAT(    194 ) = RKI(   194 ) * YC(  XLO2 ) * YC(  RO2 )
      RXRAT(    195 ) = RKI(   195 ) * YC(  CRES ) * YC(  OH )
      RXRAT(    196 ) = RKI(   196 ) * YC(  CRES ) * YC(  NO3 )
      RXRAT(    197 ) = RKI(   197 ) * YC(  CRO ) * YC(  NO2 )
      RXRAT(    198 ) = RKI(   198 ) * YC(  CRO ) * YC(  HO2 )
      RXRAT(    199 ) = RKI(   199 ) * YC(  CRON ) * YC(  OH )
      RXRAT(    200 ) = RKI(   200 ) * YC(  CRON ) * YC(  NO3 )
      RXRAT(    201 ) = RKI(   201 ) * YC(  CRON )
      RXRAT(    202 ) = RKI(   202 ) * YC(  XOPN )
      RXRAT(    203 ) = RKI(   203 ) * YC(  XOPN ) * YC(  OH )
      RXRAT(    204 ) = RKI(   204 ) * YC(  XOPN ) * YC(  O3 )
      RXRAT(    205 ) = RKI(   205 ) * YC(  XOPN ) * YC(  NO3 )
      RXRAT(    206 ) = RKI(   206 ) * YC(  OPEN )
      RXRAT(    207 ) = RKI(   207 ) * YC(  OPEN ) * YC(  OH )
      RXRAT(    208 ) = RKI(   208 ) * YC(  OPEN ) * YC(  O3 )
      RXRAT(    209 ) = RKI(   209 ) * YC(  OPEN ) * YC(  NO3 )
      RXRAT(    210 ) = RKI(   210 ) * YC(  CAT1 ) * YC(  OH )
      RXRAT(    211 ) = RKI(   211 ) * YC(  CAT1 ) * YC(  NO3 )
      RXRAT(    212 ) = RKI(   212 ) * YC(  OPO3 ) * YC(  NO )
      RXRAT(    213 ) = RKI(   213 ) * YC(  OPO3 ) * YC(  NO2 )
      RXRAT(    214 ) = RKI(   214 ) * YC(  OPAN )
      RXRAT(    215 ) = RKI(   215 ) * YC(  OPO3 ) * YC(  HO2 )
      RXRAT(    216 ) = RKI(   216 ) * YC(  OPO3 ) * YC(  C2O3 )
      RXRAT(    217 ) = RKI(   217 ) * YC(  OPO3 ) * YC(  RO2 )
      RXRAT(    218 ) = RKI(   218 ) * YC(  OPAN ) * YC(  OH )
      RXRAT(    219 ) = RKI(   219 ) * YC(  PANX ) * YC(  OH )
      RXRAT(    220 ) = RKI(   220 ) * YC(  ECH4 ) * YC(  OH )
      RXRAT(    221 ) = RKI(   221 ) * YC(  XPRP )
      RXRAT(    222 ) = RKI(   222 ) * YC(  XPRP )
      RXRAT(    223 ) = RKI(   223 ) * YC(  XPAR )
      RXRAT(    224 ) = RKI(   224 ) * YC(  XPAR )
      RXRAT(    225 ) = RKI(   225 ) * YC(  NO2 ) * YC(  OH )
      RXRAT(    226 ) = RKI(   226 ) * YC(  CL2 )
      RXRAT(    227 ) = RKI(   227 ) * YC(  HOCL )
      RXRAT(    228 ) = RKI(   228 ) * YC(  CL ) * YC(  O3 )
      RXRAT(    229 ) = RKI(   229 ) * YC(  CLO ) * YC(  CLO )
      RXRAT(    230 ) = RKI(   230 ) * YC(  CLO ) * YC(  NO )
      RXRAT(    231 ) = RKI(   231 ) * YC(  CLO ) * YC(  HO2 )
      RXRAT(    232 ) = RKI(   232 ) * YC(  CLO ) * YC(  MEO2 )
      RXRAT(    233 ) = RKI(   233 ) * YC(  OH ) * YC(  FMCL )
      RXRAT(    234 ) = RKI(   234 ) * YC(  FMCL )
      RXRAT(    235 ) = RKI(   235 ) * YC(  CL )
      RXRAT(    236 ) = RKI(   236 ) * YC(  CL ) * YC(  PAR )
      RXRAT(    237 ) = RKI(   237 ) * YC(  CL ) * YC(  PRPA )
      RXRAT(    238 ) = RKI(   238 ) * YC(  CL ) * YC(  ETHA )
      RXRAT(    239 ) = RKI(   239 ) * YC(  CL ) * YC(  ETH )
      RXRAT(    240 ) = RKI(   240 ) * YC(  CL ) * YC(  OLE )
      RXRAT(    241 ) = RKI(   241 ) * YC(  CL ) * YC(  IOLE )
      RXRAT(    242 ) = RKI(   242 ) * YC(  CL ) * YC(  ISOP )
      RXRAT(    243 ) = RKI(   243 ) * YC(  CL ) * YC(  FORM )
      RXRAT(    244 ) = RKI(   244 ) * YC(  CL ) * YC(  ALD2 )
      RXRAT(    245 ) = RKI(   245 ) * YC(  CL ) * YC(  ALDX )
      RXRAT(    246 ) = RKI(   246 ) * YC(  CL ) * YC(  MEOH )
      RXRAT(    247 ) = RKI(   247 ) * YC(  CL ) * YC(  ETOH )
      RXRAT(    248 ) = RKI(   248 ) * YC(  HCL ) * YC(  OH )
      RXRAT(    249 ) = RKI(   249 ) * YC(  CL ) * YC(  TOL )
      RXRAT(    250 ) = RKI(   250 ) * YC(  CL ) * YC(  XYLMN )
      RXRAT(    251 ) = RKI(   251 ) * YC(  CL ) * YC(  NAPH )
      RXRAT(    252 ) = RKI(   252 ) * YC(  CLNO2 )
      RXRAT(    253 ) = RKI(   253 ) * YC(  CLO ) * YC(  NO2 )
      RXRAT(    254 ) = RKI(   254 ) * YC(  CLNO3 )
      RXRAT(    255 ) = RKI(   255 ) * YC(  CLNO3 )
      RXRAT(    256 ) = RKI(   256 ) * YC(  CLNO3 )
      RXRAT(    257 ) = RKI(   257 ) * YC(  CLNO3 )
      RXRAT(    258 ) = RKI(   258 ) * YC(  TOLRO2 ) * YC(  NO )
      RXRAT(    259 ) = RKI(   259 ) * YC(  TOLRO2 ) * YC(  HO2 )
      RXRAT(    260 ) = RKI(   260 ) * YC(  XYLRO2 ) * YC(  NO )
      RXRAT(    261 ) = RKI(   261 ) * YC(  XYLRO2 ) * YC(  HO2 )
      RXRAT(    262 ) = RKI(   262 ) * YC(  BENZRO2 ) * YC(  NO )
      RXRAT(    263 ) = RKI(   263 ) * YC(  BENZRO2 ) * YC(  HO2 )
      RXRAT(    264 ) = RKI(   264 ) * YC(  SESQ ) * YC(  O3 )
      RXRAT(    265 ) = RKI(   265 ) * YC(  SESQ ) * YC(  OH )
      RXRAT(    266 ) = RKI(   266 ) * YC(  SESQ ) * YC(  NO3 )
      RXRAT(    267 ) = RKI(   267 ) * YC(  PAHRO2 ) * YC(  NO )
      RXRAT(    268 ) = RKI(   268 ) * YC(  PAHRO2 ) * YC(  HO2 )
      RXRAT(    269 ) = RKI(   269 ) * YC(  SOAALK ) * YC(  OH )
      RXRAT(    270 ) = RKI(   270 ) * YC(  NTR2 )
      RXRAT(    271 ) = RKI(   271 ) * YC(  N2O5 )
      RXRAT(    272 ) = RKI(   272 ) * YC(  N2O5 )
      RXRAT(    273 ) = RKI(   273 ) * YC(  H2NO3PIJ )
      RXRAT(    274 ) = RKI(   274 ) * YC(  H2NO3PK )
      RXRAT(    275 ) = RKI(   275 ) * YC(  H2NO3PIJ ) * YC(  ACLI )
      RXRAT(    276 ) = RKI(   276 ) * YC(  H2NO3PIJ ) * YC(  ACLJ )
      RXRAT(    277 ) = RKI(   277 ) * YC(  H2NO3PK ) * YC(  ACLK )
      RXRAT(    278 ) = RKI(   278 ) * YC(  NO2 )
!     RXRAT(    279 ) = RKI(   279 ) * YC(  O3 )
      RXRAT(    280 ) = RKI(   280 ) * YC(  EPOX )
      RXRAT(    281 ) = RKI(   281 ) * YC(  IEPOXP ) * YC(  ASO4J )
      RXRAT(    282 ) = RKI(   282 ) * YC(  IEPOXP )
      RXRAT(    283 ) = RKI(   283 ) * YC(  GLY )
      RXRAT(    284 ) = RKI(   284 ) * YC(  MGLY )
      RXRAT(    285 ) = RKI(   285 ) * YC(  TERPNRO2 ) * YC(  NO )
      RXRAT(    286 ) = RKI(   286 ) * YC(  TERPNRO2 ) * YC(  HO2 )
      RXRAT(    287 ) = RKI(   287 ) * YC(  TERPNRO2 ) * YC(  NO3 )
      RXRAT(    288 ) = RKI(   288 ) * YC(  TERPNRO2 ) * YC(  RO2 )
      RXRAT(    289 ) = RKI(   289 ) * YC(  MTNO3 ) * YC(  CL )
      RXRAT(    290 ) = RKI(   290 ) * YC(  MTNO3 ) * YC(  OH )
      RXRAT(    291 ) = RKI(   291 ) * YC(  MTNO3 )
      RXRAT(    292 ) = RKI(   292 ) * YC(  AMTNO3J )
      RXRAT(    293 ) = RKI(   293 ) * YC(  AAVB2J )
      RXRAT(    294 ) = RKI(   294 ) * YC(  AAVB3J )
      RXRAT(    295 ) = RKI(   295 ) * YC(  AAVB4J )
      RXRAT(    296 ) = RKI(   296 ) * YC(  AISO1J )
      RXRAT(    297 ) = RKI(   297 ) * YC(  AISO2J )
      RXRAT(    298 ) = RKI(   298 ) * YC(  ASQTJ )
      RXRAT(    299 ) = RKI(   299 ) * YC(  APOCI ) * YC(  OH )
      RXRAT(    300 ) = RKI(   300 ) * YC(  APNCOMI ) * YC(  OH )
      RXRAT(    301 ) = RKI(   301 ) * YC(  APOCJ ) * YC(  OH )
      RXRAT(    302 ) = RKI(   302 ) * YC(  APNCOMJ ) * YC(  OH )
      RXRAT(    303 ) = RKI(   303 ) * YC(  PCVOC ) * YC(  OH )
      RXRAT(    304 ) = RKI(   304 ) * YC(  VLVPO1 ) * YC(  OH )
      RXRAT(    305 ) = RKI(   305 ) * YC(  VSVPO1 ) * YC(  OH )
      RXRAT(    306 ) = RKI(   306 ) * YC(  VSVPO2 ) * YC(  OH )
      RXRAT(    307 ) = RKI(   307 ) * YC(  VSVPO3 ) * YC(  OH )
      RXRAT(    308 ) = RKI(   308 ) * YC(  VIVPO1 ) * YC(  OH )
      RXRAT(    309 ) = RKI(   309 ) * YC(  VLVOO1 ) * YC(  OH )
      RXRAT(    310 ) = RKI(   310 ) * YC(  VLVOO2 ) * YC(  OH )
      RXRAT(    311 ) = RKI(   311 ) * YC(  VSVOO1 ) * YC(  OH )
      RXRAT(    312 ) = RKI(   312 ) * YC(  VSVOO2 ) * YC(  OH )
      RXRAT(    313 ) = RKI(   313 ) * YC(  VSVOO3 ) * YC(  OH )
      RXRAT(    314 ) = RKI(   314 ) * YC(  FORM_PRIMARY ) * YC(  OH )
      RXRAT(    315 ) = RKI(   315 ) * YC(  FORM_PRIMARY ) * YC(  NO3 )
      RXRAT(    316 ) = RKI(   316 ) * YC(  FORM_PRIMARY ) * YC(  O )
      RXRAT(    317 ) = RKI(   317 ) * YC(  FORM_PRIMARY )
      RXRAT(    318 ) = RKI(   318 ) * YC(  FORM_PRIMARY )
      RXRAT(    319 ) = RKI(   319 ) * YC(  FORM_PRIMARY ) * YC(  CL )
      RXRAT(    320 ) = RKI(   320 ) * YC(  ALD2_PRIMARY ) * YC(  OH )
      RXRAT(    321 ) = RKI(   321 ) * YC(  ALD2_PRIMARY ) * YC(  NO3 )
      RXRAT(    322 ) = RKI(   322 ) * YC(  ALD2_PRIMARY ) * YC(  O )
      RXRAT(    323 ) = RKI(   323 ) * YC(  ALD2_PRIMARY )
      RXRAT(    324 ) = RKI(   324 ) * YC(  ALD2_PRIMARY ) * YC(  CL )
      RXRAT(    325 ) = RKI(   325 ) * YC(  BUTADIENE13 ) * YC(  OH )
      RXRAT(    326 ) = RKI(   326 ) * YC(  BUTADIENE13 ) * YC(  O3 )
      RXRAT(    327 ) = RKI(   327 ) * YC(  BUTADIENE13 ) * YC(  NO3 )
      RXRAT(    328 ) = RKI(   328 ) * YC(  BUTADIENE13 ) * YC(  CL )
      RXRAT(    329 ) = RKI(   329 ) * YC(  ACRO_PRIMARY ) * YC(  OH )
      RXRAT(    330 ) = RKI(   330 ) * YC(  ACRO_PRIMARY ) * YC(  O3 )
      RXRAT(    331 ) = RKI(   331 ) * YC(  ACRO_PRIMARY ) * YC(  NO3 )
      RXRAT(    332 ) = RKI(   332 ) * YC(  ACRO_PRIMARY )
      RXRAT(    333 ) = RKI(   333 ) * YC(  ACRO_PRIMARY ) * YC(  CL )
      RXRAT(    334 ) = RKI(   334 ) * YC(  ACROLEIN ) * YC(  OH )
      RXRAT(    335 ) = RKI(   335 ) * YC(  ACROLEIN ) * YC(  O3 )
      RXRAT(    336 ) = RKI(   336 ) * YC(  ACROLEIN ) * YC(  NO3 )
      RXRAT(    337 ) = RKI(   337 ) * YC(  ACROLEIN )
      RXRAT(    338 ) = RKI(   338 ) * YC(  ACROLEIN ) * YC(  CL )
      RXRAT(    339 ) = RKI(   339 ) * YC(  TOLU ) * YC(  OH )
      RXRAT(    340 ) = RKI(   340 ) * YC(  TOLU ) * YC(  CL )
      RXRAT(    341 ) = RKI(   341 ) * YC(  HG ) * YC(  O3 )
      RXRAT(    342 ) = RKI(   342 ) * YC(  HG ) * YC(  CL2 )
      RXRAT(    343 ) = RKI(   343 ) * YC(  HG ) * YC(  H2O2 )
      RXRAT(    344 ) = RKI(   344 ) * YC(  HG ) * YC(  OH )
      RXRAT(    345 ) = RKI(   345 ) * YC(  HG ) * YC(  CL )
      RXRAT(    346 ) = RKI(   346 ) * YC(  DMS ) * YC(  OH )
      RXRAT(    347 ) = RKI(   347 ) * YC(  DMS ) * YC(  OH )
      RXRAT(    348 ) = RKI(   348 ) * YC(  DMS ) * YC(  NO3 )
      RXRAT(    349 ) = RKI(   349 ) * YC(  DMS ) * YC(  CL )
      RXRAT(    350 ) = RKI(   350 ) * YC(  HFPODAF )
      RXRAT(    351 ) = RKI(   351 ) * YC(  HFPODAF )
      RXRAT(    352 ) = RKI(   352 ) * YC(  COF2 )
      RXRAT(    353 ) = RKI(   353 ) * YC(  PFMOAF )


      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE MIO_ASCII

      IMPLICIT NONE

      INTEGER, SAVE :: N_MIO_IN, N_MIO_OUT

      TYPE MIO_FILE_DATA_TYPE
          CHARACTER(16)              :: FILE_LOGICAL
          INTEGER                    :: NLAYS
          INTEGER                    :: BLEV
          INTEGER                    :: ELEV
          INTEGER                    :: NVARS
          CHARACTER(32), ALLOCATABLE :: VARNAMES(:)
          INTEGER,       ALLOCATABLE :: VARTYPES(:)
          CHARACTER(16), ALLOCATABLE :: VARUNITS(:)
          CHARACTER(256),ALLOCATABLE :: VARDESC (:)
          INTEGER,       ALLOCATABLE :: NDIMS(:)
          LOGICAL,       ALLOCATABLE :: L_TSTEP(:)
          LOGICAL,       ALLOCATABLE :: L_LAY(:)
          LOGICAL,       ALLOCATABLE :: L_COL(:)
          LOGICAL,       ALLOCATABLE :: L_ROW(:)
          LOGICAL,       ALLOCATABLE :: L_VEXT(:)
      END TYPE MIO_FILE_DATA_TYPE

      TYPE( MIO_FILE_DATA_TYPE ) :: MIO_TXT_FILE_DATA( 200 )

      INTEGER, PARAMETER :: N_MIO_VARS = 5000
      INTEGER :: NDIMS3D( N_MIO_VARS )
      LOGICAL :: L_TSTEP( N_MIO_VARS )
      LOGICAL :: L_LAY( N_MIO_VARS )
      LOGICAL :: L_COL( N_MIO_VARS )
      LOGICAL :: L_ROW( N_MIO_VARS )
      LOGICAL :: L_VEXT( N_MIO_VARS )

      CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE INIT_MIO_FILE_DATA

          N_MIO_IN  = 0
          N_MIO_OUT = 0

      END SUBROUTINE INIT_MIO_FILE_DATA

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE LOAD_MIO_FILE ( FILE_LOGICAL, NLAYS, BLEV, ELEV, VARNAMES, 
     &           VARTYPES, VARUNITS, VARDESC, NDIMS, 
     &           L_TSTEP, L_LAY, L_COL, L_ROW, L_VEXT )


      IMPLICIT NONE

      CHARACTER(*),  INTENT( IN )  :: FILE_LOGICAL
      INTEGER,       INTENT( IN )  :: NLAYS
      INTEGER,       INTENT( IN )  :: BLEV
      INTEGER,       INTENT( IN )  :: ELEV
      CHARACTER(*),  INTENT( IN )  :: VARNAMES( : )
      INTEGER,       INTENT( IN )  :: VARTYPES( : )
      CHARACTER(16), INTENT( IN )  :: VARUNITS( : )
      CHARACTER(*),  INTENT( IN )  :: VARDESC ( : )
      INTEGER,       INTENT( IN )  :: NDIMS( : )
      LOGICAL,       INTENT( IN )  :: L_TSTEP(:), L_LAY(:), 
     &                                L_COL(:), L_ROW(:), L_VEXT(:)

      INTEGER NVARS
      INTEGER IOS

      NVARS = SIZE( VARTYPES )
      N_MIO_OUT = N_MIO_OUT + 1

      ! Set high-level parameters for this output file in the MIO file
      ! structure
      MIO_TXT_FILE_DATA( N_MIO_OUT )%FILE_LOGICAL = FILE_LOGICAL
      MIO_TXT_FILE_DATA( N_MIO_OUT )%NLAYS = NLAYS
      MIO_TXT_FILE_DATA( N_MIO_OUT )%BLEV  = BLEV
      MIO_TXT_FILE_DATA( N_MIO_OUT )%ELEV  = ELEV
      MIO_TXT_FILE_DATA( N_MIO_OUT )%NVARS = NVARS

      ! Allocate MIO File Structure for this Output File
      ALLOCATE( MIO_TXT_FILE_DATA( N_MIO_OUT )%VARNAMES( NVARS ) ,
     &          MIO_TXT_FILE_DATA( N_MIO_OUT )%VARTYPES( NVARS ) ,
     &          MIO_TXT_FILE_DATA( N_MIO_OUT )%VARUNITS( NVARS ) ,
     &          MIO_TXT_FILE_DATA( N_MIO_OUT )%VARDESC ( NVARS ) ,
     &          MIO_TXT_FILE_DATA( N_MIO_OUT )%NDIMS   ( NVARS ) ,
     &          MIO_TXT_FILE_DATA( N_MIO_OUT )%L_TSTEP ( NVARS ) ,
     &          MIO_TXT_FILE_DATA( N_MIO_OUT )%L_LAY   ( NVARS ) ,
     &          MIO_TXT_FILE_DATA( N_MIO_OUT )%L_COL   ( NVARS ) ,
     &          MIO_TXT_FILE_DATA( N_MIO_OUT )%L_ROW   ( NVARS ) ,
     &          MIO_TXT_FILE_DATA( N_MIO_OUT )%L_VEXT  ( NVARS ) ,
     &          STAT = IOS )
      CALL CHECKMEM( IOS, 'MIO_TXT_FILE_DATA','LOAD_MIO_FILE' )

      ! Populate MIO File Structure
      MIO_TXT_FILE_DATA( N_MIO_OUT )%VARNAMES = VARNAMES
      MIO_TXT_FILE_DATA( N_MIO_OUT )%VARTYPES = VARTYPES
      MIO_TXT_FILE_DATA( N_MIO_OUT )%VARUNITS = VARUNITS
      MIO_TXT_FILE_DATA( N_MIO_OUT )%VARDESC  = VARDESC
      MIO_TXT_FILE_DATA( N_MIO_OUT )%NDIMS    = NDIMS
      MIO_TXT_FILE_DATA( N_MIO_OUT )%L_TSTEP  = L_TSTEP
      MIO_TXT_FILE_DATA( N_MIO_OUT )%L_LAY    = L_LAY
      MIO_TXT_FILE_DATA( N_MIO_OUT )%L_COL    = L_COL
      MIO_TXT_FILE_DATA( N_MIO_OUT )%L_ROW    = L_ROW
      MIO_TXT_FILE_DATA( N_MIO_OUT )%L_VEXT   = L_VEXT

      END SUBROUTINE LOAD_MIO_FILE

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WRITE_MIO_ASCII ( FNAME )

C   This subroutine will create a mock-up of the MIO input file which
C   specifies the number of input and output files, their filenames, and
C   the variables on each file, along with metadata for each variable.
C   The subroutine is expected to be used to demonstrate that the
C   updates made to driver.F to initialize the CMAQ system are
C   successfully making available all of the information needed by MIO.
C   After these updates are confirmed, approved, and merged, it is
C   expected that this routine will either be removed, or it may be kept
C   as an optional diagnostic for MIO characterization. It should not be
C   used in default operations of CMAQ.
C-----------------------------------------------------------------------

      USE UTILIO_DEFN 
      USE RUNTIME_VARS, ONLY : OUTDIR, APPL_NAME

      IMPLICIT NONE

      CHARACTER(*)   :: FNAME
      INTEGER        :: IOUT, IFILE, IVAR
      CHARACTER(10)  :: VT
      CHARACTER(100) :: DIMSTRING
      CHARACTER(400) :: FPATH

C-----------------------------------------------------------------------


      FPATH = TRIM(OUTDIR) // '/' // TRIM(FNAME) // '_' //
     &        TRIM(APPL_NAME) // '.txt'
      IOUT = JUNIT()
      OPEN( IOUT,  FILE = FPATH, STATUS = 'UNKNOWN' )

      WRITE ( IOUT, '(A3, I0, A5, I0)' ) 'in ' , N_MIO_IN, 
     &                                  ' out ', N_MIO_OUT

      ! Write Output File Metadata
      DO IFILE = 1,N_MIO_OUT
         WRITE ( IOUT,* ) 
         WRITE ( IOUT, '(A)' ) MIO_TXT_FILE_DATA( IFILE )%FILE_LOGICAL
         WRITE ( IOUT, '(I0)' ) MIO_TXT_FILE_DATA( IFILE )%NVARS

         DO IVAR = 1,MIO_TXT_FILE_DATA( IFILE )%NVARS 
           ! Find string for vairbale type
#ifndef mpas
             IF ( MIO_TXT_FILE_DATA( IFILE )%VARTYPES( IVAR ) .EQ. M3REAL ) VT = 'real'
#else 
           ! Assume real
             VT = 'real'
#endif

           ! Make string for dimensions
           DIMSTRING = ''
           IF ( MIO_TXT_FILE_DATA( IFILE )%L_TSTEP(IVAR) ) DIMSTRING = TRIM(DIMSTRING) // ' TSTEP'
           IF ( MIO_TXT_FILE_DATA( IFILE )%L_LAY(IVAR) )   DIMSTRING = TRIM(DIMSTRING) // ' LAY'
           IF ( MIO_TXT_FILE_DATA( IFILE )%L_ROW(IVAR) )   DIMSTRING = TRIM(DIMSTRING) // ' ROW'
           IF ( MIO_TXT_FILE_DATA( IFILE )%L_COL(IVAR) )   DIMSTRING = TRIM(DIMSTRING) // ' COL'
           IF ( MIO_TXT_FILE_DATA( IFILE )%L_VEXT(IVAR) )  DIMSTRING = TRIM(DIMSTRING) // ' VEXT'

           WRITE ( IOUT, '(A,1x,A,1x,I0,A,1x,A1,A,A1,1x,A1,A,A1)' ) 
     &             TRIM( MIO_TXT_FILE_DATA( IFILE )%VARNAMES( IVAR ) ), TRIM(VT),
     &             MIO_TXT_FILE_DATA( IFILE )%NDIMS( IVAR ),TRIM(DIMSTRING),
     &             '"',TRIM(MIO_TXT_FILE_DATA( IFILE )%VARUNITS( IVAR )),'"',
     &             '"',TRIM(MIO_TXT_FILE_DATA( IFILE )%VARDESC ( IVAR )),'"'
         END DO
      END DO

      CLOSE( IOUT )

      END SUBROUTINE WRITE_MIO_ASCII

      END MODULE MIO_ASCII

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE DEFORM ( JDATE, JTIME, DEFORM3D )
      
C-----------------------------------------------------------------------
C Function:
C    Computes wind deformation based on the contravariant horizontal
C    velocity components.
 
C Preconditions:
C    This routine can be used only for conformal map coordinates 
C    in the horizontal.
C    Dates and times should be represented YYYYDDD:HHMMSS.
 
C Subroutines and functions called:
C    INTERP3, M3EXIT, TIME2SEC, SEC2TIME, NEXTIME
      
C Revision history:
C
C    Oct 10, 2000  Initial development (code adapted from hcontvel.F)
C      Daewon Byun and Avi Lacser

C    26 Dec 00 J.Young: GLOBAL_RMAX -> Dave Wong's f90 stenex GLOBAL_MAX
C                       PE_COMM3 -> Dave Wong's f90 stenex COMM
C
C    11 Jan 01 David Wong: -- Introduced two new local variable LOC_UWIND and
C                             LOC_VWIND: because of INTERP3, The file buffer
C                             UWIND, neccessarily does not have dimensions for
C                             a row ghost region. the same is true for VWIND
C                             with respect to a column ghost region.
C                          -- invoked SE_LOOP_INDEX to compute correct loop
C                             index for the local processor
C                          -- corrected communication pattern for DENSJ
C     7 Aug 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX
C                       and INTERPB; allocatable arrays
C                       Not developed for other than NTHIK = 1
C    25 MAr 04 G.Hammond: move wind velocity ghost cell updates outside layer
C                         loop. Use SNL "swap3d".
C    31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                       domain specifications in one module
C    16 Feb 11 S. Roselle: replaced I/O-API include files w/UTILIO_DEFN
C    11 May 11 D.Wong: incorporated twoway model implementation
C    28 Jul 11 David Wong: set REVERT to .false. for twoway model case since
C                          buffered file has only two time steps data
C    29 Nov 17 David Wong: removed all SWAP routines and replaced with SE_COMM
C    01 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                          clauses
C-----------------------------------------------------------------------
      
      USE GRID_CONF            ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES           ! stenex (using SE_GLOBAL_MAX_MODULE, SE_COMM_MODULE)
#else
      USE NOOP_MODULES         ! stenex (using NOOP_GLOBAL_MAX_MODULE, NOOP_COMM_MODULE)
#endif
      use CENTRALIZED_IO_MODULE, only : interpolate_var, window
      USE CONST, ONLY: DG2M, PI180

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_FILES_ID   ! file name parameters
      INCLUDE SUBST_PE_COMM    ! PE communication displacement and direction
 
C Parameters:

C Arguments:
      
      INTEGER, INTENT( IN )  :: JDATE             ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )  :: JTIME             ! current model time, coded HHMMSS
      REAL,    INTENT( OUT ) :: DEFORM3D( :,:,: ) ! Wind deformation
      
C Parameters:

C file variables:
      
      REAL      DENSJ_BUF( NCOLS,NROWS,NLAYS ) ! Jacobian * air density
      REAL      DENSJ_BND( NBNDY,NLAYS )       ! boundary Jacobian * air density
 
C External Functions: None
      
C local variables:
      
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      INTEGER, SAVE :: MLAYS
       
      INTEGER   ROW               ! Row index
      INTEGER   COL               ! Column index
      INTEGER   LVL               ! Layer index
      INTEGER   MDATE             ! mid-advection date
      INTEGER   MTIME             ! mid-advection time
!     INTEGER   STEP              ! advection time step in seconds
      INTEGER, SAVE :: LDATE( 3 ) ! last date for data on file
      INTEGER, SAVE :: LTIME( 3 ) ! last time for data on file
      LOGICAL   REVERT            ! recover last time step if true
      REAL      DJ                ! temporary Jacobian * air density
 
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: PNAME = 'DEFORM'
      CHARACTER( 16 ) :: AMSG
      CHARACTER( 96 ) :: XMSG = ' '
 
C Jacobian * air density
      REAL         DENSJ    ( 0:NCOLS+1,0:NROWS+1,NLAYS )

      REAL         UWIND    (   NCOLS+1,  NROWS+1,NLAYS ) ! ContrVar x1-velocity 
      REAL         LOC_UWIND(   NCOLS+1,0:NROWS+1,NLAYS ) ! local CV x1-velocity 
      REAL         VWIND    (   NCOLS+1,  NROWS+1,NLAYS ) ! ContrVar x2-velocity 
      REAL         LOC_VWIND( 0:NCOLS+1,  NROWS+1,NLAYS ) ! local CV x2-velocity 
      REAL         DUDX     (   NCOLS,    NROWS )
      REAL         DUDY     (   NCOLS,    NROWS )
      REAL         DVDX     (   NCOLS,    NROWS )
      REAL         DVDY     (   NCOLS,    NROWS )
      CHARACTER( 8 ), SAVE :: COMMSTR

      REAL, SAVE :: DX1, DX2       ! X1 & X2 grid size
      REAL, SAVE :: RDX1, RDX2     ! inverse of DX1 & DX2
!     REAL, SAVE :: RDX1O2, RDX2O2 ! half of inverse of DX1 & DX2
      REAL, SAVE :: RDX1O4, RDX2O4 ! quarter of inverse of DX1 & DX2
      REAL    UBAR1, UBAR2         ! U average at X point (Avi)
      REAL    VBAR1, VBAR2         ! V average at X point (Avi)
      REAL    DF1, DF2             ! deformation components
      INTEGER C, R, L              ! notations for COL, ROW, LVL
      INTEGER C1, R1               ! C1 = C+1, R1 = R+1  (Avi)
      INTEGER C2, R2               ! C2 = C-1, R2 = R-1  (Avi)
!     INTEGER C1, R1               ! C1 = MAX(1, C-1), R1 = MAX(1, R-1) (Daewon)
!     INTEGER C2, R2               ! C2 = MIN(C+1, NCOLS), R2 = MIN(R+1, NROWS) (DBX)
      INTEGER COUNT                ! Counter for constructing density array.
      REAL    DEFMAX               ! max deformation (dianostic)

      INTEGER MY_TEMP
      INTEGER, SAVE :: FRSTROW, LASTROW, FRSTCOL, LASTCOL

C-----------------------------------------------------------------------
 
      IF ( FIRSTIME ) THEN
 
         FIRSTIME = .FALSE.

         MLAYS = SIZE ( DEFORM3D,3 )
 
         CALL LSTEPF( MET_CRO_3D, LDATE( 1 ), LTIME( 1 ) )
!        CALL LSTEPF( MET_BDY_3D, LDATE( 2 ), LTIME( 2 ) )
         CALL LSTEPF( MET_DOT_3D, LDATE( 3 ), LTIME( 3 ) )
 
!        LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 2 ), LDATE( 3 ) )
!        LTIME( 1 ) = SEC2TIME( MIN(
!    &                         TIME2SEC( LTIME( 1 ) ),
!    &                         TIME2SEC( LTIME( 2 ) ),
!    &                         TIME2SEC( LTIME( 3 ) )
!    &                         ) )

         LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 3 ) )
         LTIME( 1 ) = SEC2TIME( MIN(
     &                         TIME2SEC( LTIME( 1 ) ),
     &                         TIME2SEC( LTIME( 3 ) )
     &                         ) )

         WRITE( COMMSTR,'(4I2)' )  1, 0, 2, 0

C Get/compute DX1 & DX2
 
         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD ! in m.
            DX2 = DG2M * YCELL_GD *
     &         COS( PI180*( YORIG_GD + YCELL_GD * FLOAT( GL_NROWS/2 ))) !in m
         ELSE
            DX1 = XCELL_GD        ! in m.
            DX2 = YCELL_GD        ! in m.
         END IF                                                              

         RDX1 = 1.0 / DX1
         RDX2 = 1.0 / DX2
!        RDX1O2 = 0.5 / DX1
!        RDX2O2 = 0.5 / DX2
         RDX1O4 = 0.25 / DX1
         RDX2O4 = 0.25 / DX2

         CALL SUBST_LOOP_INDEX ( 'R', 2, NROWS, -1, MY_TEMP,
     &                           FRSTROW, LASTROW )
         CALL SUBST_LOOP_INDEX ( 'C', 2, NCOLS, -1, MY_TEMP, 
     &                           FRSTCOL, LASTCOL )

      END IF  ! if firstime
 
      MDATE  = JDATE
      MTIME  = JTIME
!     STEP   = TIME2SEC( TSTEP )
!     CALL NEXTIME( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

#ifdef twoway
      REVERT = .FALSE.
#else
      IF ( MDATE .LT. LDATE( 1 ) ) THEN
         REVERT = .FALSE.
      ELSE IF ( MDATE .EQ. LDATE( 1 ) ) THEN
         IF ( MTIME .LE. LTIME( 1 ) ) THEN
            REVERT = .FALSE.
         ELSE
            REVERT = .TRUE.
         END IF
      ELSE   ! MDATE .GT. LDATE
         REVERT = .TRUE.
      END IF
#endif
 
      IF ( REVERT ) THEN
         XMSG = 'Current scenario interpolation step not available in all of '
     &        // TRIM( MET_CRO_3D ) // ', '
     &        // TRIM( MET_BDY_3D ) // ' and '
     &        // TRIM( MET_DOT_3D )
         CALL M3MESG( XMSG )
!        CALL NEXTIME( MDATE, MTIME, -SEC2TIME( STEP / 2 ) )
         WRITE( AMSG,'( 2I8 )' ) LDATE( 1 ), LTIME( 1 )
         XMSG = 'Using data for last file step: ' // AMSG
         CALL M3MESG( XMSG )
         MDATE = LDATE( 1 )
         MTIME = LTIME( 1 )
      END IF
 
C Interpolate Jacobian X Air Density

      IF ( WINDOW ) THEN

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ)

      ELSE ! need to extend data from bndy file

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ_BUF)

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ_BND, 'b')

C Load DENSJ array

         DO LVL = 1, MLAYS
            DO ROW = 1, NROWS
               DO COL = 1, NCOLS
                  DENSJ( COL,ROW,LVL ) = DENSJ_BUF( COL,ROW,LVL )
               END DO
            END DO
         END DO

C Fill in DENSJ array for boundaries

         DO LVL = 1, MLAYS
            COUNT = 0
            DO ROW = 0, 0
               DO COL = 1, NCOLS + 1
                  COUNT = COUNT + 1
                  DENSJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! South
               END DO
            END DO
            DO ROW = 1, NROWS + 1
               DO COL = NCOLS + 1, NCOLS + 1
                  COUNT = COUNT + 1
                  DENSJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! East
               END DO
            END DO
            DO ROW = NROWS + 1, NROWS + 1
               DO COL = 0, NCOLS
                  COUNT = COUNT + 1
                  DENSJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! North
               END DO
            END DO
            DO ROW = 0, NROWS
               DO COL = 0, 0
                  COUNT = COUNT + 1
                  DENSJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! West
               END DO
            END DO
         END DO

      END IF   ! WINDOW
 
C Interpolate Contravariant Velocity components (already at flux points)
C X Jacobian X Air Density

      call interpolate_var ('UHAT_JD', mdate, mtime, UWIND)

      call interpolate_var ('VHAT_JD', mdate, mtime, VWIND)

C Obtain flux point values of Jacobian * air density and retrieve
C contravariant velocities 

C create U/RhoJ - update ghost regions for RhoJ

      CALL SUBST_COMM ( DENSJ, DSPL_N0_E1_S0_W1, DRCN_E_W, COMMSTR )

      LOC_UWIND = 0.0   ! array assignment
      DO LVL = 1, MLAYS
         DO ROW = 1, NROWS
            DO COL = 1, NCOLS + 1
               DJ = 0.5*( DENSJ( COL,ROW,LVL ) + DENSJ( COL-1,ROW,LVL ) )
               LOC_UWIND( COL,ROW,LVL ) = UWIND( COL,ROW,LVL ) / DJ
            END DO
         END DO
      END DO

C create V/RhoJ - update ghost regions for RhoJ

      CALL SUBST_COMM ( DENSJ, DSPL_N1_E0_S1_W0, DRCN_N_S, COMMSTR )

      LOC_VWIND = 0.0   ! array assignment
      DO LVL = 1, MLAYS
         DO ROW = 1, NROWS + 1
            DO COL = 1, NCOLS
               DJ = 0.5*( DENSJ( COL,ROW,LVL ) + DENSJ( COL,ROW-1,LVL ) )
               LOC_VWIND( COL,ROW,LVL ) = VWIND( COL,ROW,LVL ) / DJ
            END DO
         END DO
      END DO

C Compute wind deformation
 
C initialize deformation arrays
C deformation at all boundary cells are defined to be zero
      DO L = 1, MLAYS
         DO R = 1, NROWS + 1
            DO C = 1, NCOLS + 1
               DEFORM3D( C,R,L ) = 0.0
            END DO
         END DO
      END DO

      CALL SUBST_COMM ( LOC_UWIND, DSPL_N1_E1_S1_W0, DRCN_N_NE_SE_S, '2 0' )

      CALL SUBST_COMM ( LOC_VWIND, DSPL_N1_E1_S0_W1, DRCN_NE_E_W_NW, '1 0' )

      DO 101 L = 1, MLAYS

         DEFMAX = 0.0
C initialize wind shear components (inner domain only dimensioned)
         DO R = 1, NROWS
            DO C = 1, NCOLS
               DUDX( C,R ) = 0.0
               DUDY( C,R ) = 0.0
               DVDX( C,R ) = 0.0
               DVDY( C,R ) = 0.0
            END DO
         END DO

C ORIGINAL by Daewon October 2000
C Compute gradients only at inner domain
!        DO R = 1, NROWS
!           DO C = 1, NCOLS
!              C1 = MAX( 1,C-1 )
!              R1 = MAX( 1,R-1 )
!              C2 = MIN( C+1,NCOLS )
!              R2 = MIN( R+1,NROWS )

!              DUDX( C,R ) = ( UWIND( C,R,L )  - UWIND( C1,R,L ) ) * RDX1
!              DUDY( C,R ) = ( UWIND( C,R2,L ) - UWIND( C,R1,L ) ) * RDX2O2
!              DVDX( C,R ) = ( VWIND( C2,R,L ) - VWIND( C1,R,L ) ) * RDX1O2
!              DVDY( C,R ) = ( VWIND( C,R,L )  - VWIND( C,R1,L ) ) * RDX2
!           END DO
!        END DO

C SUGGESTED by Avi October 2000
C for whole domain (DUDX, DVDY)
         DO R = 1, NROWS
            R1 = R + 1
            DO C = 1, NCOLS
               C1 = C + 1
               DUDX(C,R) = ( LOC_UWIND( C1,R,L ) - LOC_UWIND( C,R,L ) ) * RDX1
               DVDY(C,R) = ( LOC_VWIND( C,R1,L ) - LOC_VWIND( C,R,L ) ) * RDX2
            END DO
         END DO

1003     FORMAT( / '@1@Layer', 4X, 'Max Deform',
     &             5X, 'DUDX(4,5)',
     &             5X, 'DUDY(4,5)',
     &             5X, 'DVDX(4,5)',
     &             5X, 'DVDY(4,5)' )

C for DUDY inside domain (compute the gradient of the averages)
         DO R = FRSTROW, LASTROW
            R1 = R + 1
            R2 = R - 1
            DO C = 1, NCOLS
               C1 = C + 1
               UBAR1 = LOC_UWIND( C,R1,L ) + LOC_UWIND( C1,R1,L )
               UBAR2 = LOC_UWIND( C,R2,L ) + LOC_UWIND( C1,R2,L )
               DUDY(C,R) = ( UBAR1 - UBAR2 ) * RDX2O4
               END DO
            END DO
 
C for DVDX inner domain (compute the gradient of the averages)
         DO R = 1, NROWS
            R1 = R + 1
            DO C = FRSTCOL, LASTCOL
               C1 = C + 1
               C2 = C - 1
               VBAR1 = LOC_VWIND( C1,R1,L ) + LOC_VWIND( C1,R,L )
               VBAR2 = LOC_VWIND( C2,R1,L ) + LOC_VWIND( C2,R,L )
               DVDX(C,R) = ( VBAR1 - VBAR2 ) * RDX1O4
               END DO
            END DO

C DUDY = 0 for R=1 and NROWS for all NCOLS
C DVDX = 0 for C=1 and NCOLS for all NROWS

C END of section done by Avi

C Deformation only at inner domain
         DO R = 1, NROWS
            DO C = 1, NCOLS
               DF1 = DUDX( C,R ) - DVDY( C,R )
               DF2 = DVDX( C,R ) + DUDY( C,R )
               DEFORM3D( C,R,L ) = SQRT( DF1 * DF1 + DF2 * DF2 ) 
               DEFMAX = MAX( DEFMAX, DEFORM3D( C,R,L ) )
               END DO
            END DO
1005     FORMAT( '@1@ ', I3, 2X, 5( 1PE14.6 ) )

101   CONTINUE   ! MLAYS

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE HLCONST_MOD
         IMPLICIT NONE

C...pointers for dissociating species needed to compute effective 
c   Henry's law constants
         INTEGER, PUBLIC  :: HLC_SO2, HLC_HNO2, HLC_HNO3, HLC_CO2, 
     &                       HLC_H2O2, HLC_HCOOH, HLC_HO2, HLC_NH3,
     &                       HLC_HYDRAZINE, HLC_ATRA, HLC_DATRA, HLC_CL2, 
     &                       HLC_HCL, HLC_HOCL, HLC_HBR, HLC_HI, 
     &                       HLC_ACRYACID

         INTEGER, PUBLIC :: HLC_PFOA, HLC_HFPODA, HLC_FCOOH, HLC_PFMOAA,
     &                      HLC_PAF, HLC_PMPF, HLC_TAF2, HLC_COF2, HLC_PEPF,
     &                      HLC_DA, HLC_HFPOTA, HLC_TAF, HLC_MA, HLC_HFPODAF,
     &                      HLC_PFMOAF

C...pointers for additional Henry's law species needed in AQCHEM
         INTEGER, PUBLIC  :: HLC_O3, HLC_MHYDPOX, HLC_PEROXYACET, 
     &                       HLC_GLY, HLC_MGLY, HLC_OH

C...pointers for additional Henry's law species needed in KMT version of AQCHEM
         INTEGER, PUBLIC  :: HLC_CH3COOH, HLC_NO2, HLC_HNO4, HLC_NO3,                          
     &                       HLC_PYRUVACID                                                     
                                                                                               
C...pointers for Henry's law species needed in AEROSOL_CHEMISTRY                               
         INTEGER, PUBLIC  :: HLC_IEPOX, HLC_IMAE                                               

         PUBLIC :: SUBNAME, HLCONST, HLCONST_INIT, HLINDEX                                              
                                                                                               
C...........PARAMETERS and their descriptions:                                                 
                                                                                               
         INTEGER, PUBLIC, PARAMETER :: MXSPCS = 318     ! Number of substances                 
                                                                                               
         PRIVATE                                                                               
                                                                                               
         INTEGER, PARAMETER :: MXDSPCS = 40     ! Number of dissociating species               
                                                                                               
C...pointers for the dissociation constants (arrays B and D)                                   
                                                                                               
         INTEGER, PARAMETER :: MSO2       =  1  ! SO2                                          
         INTEGER, PARAMETER :: MHSO3      =  2  ! HSO3                                         
         INTEGER, PARAMETER :: MHNO2      =  3  ! HNO3                                         
         INTEGER, PARAMETER :: MHNO3      =  4  ! HNO3                                         
         INTEGER, PARAMETER :: MCO2       =  5  ! CO2                                          
         INTEGER, PARAMETER :: MHCO3      =  6  ! HCO3                                         
         INTEGER, PARAMETER :: MH2O2      =  7  ! H2O2                                         
         INTEGER, PARAMETER :: MHCOOH     =  8  ! HCOOH                                        
         INTEGER, PARAMETER :: MHO2       =  9  ! HO2                                          
         INTEGER, PARAMETER :: MNH4OH     = 10  ! NH4OH                                        
         INTEGER, PARAMETER :: MH2O       = 11  ! H2O                                          
         INTEGER, PARAMETER :: MATRA      = 12  ! Atrazine                                     
         INTEGER, PARAMETER :: MCL2       = 13  ! CL2                                          
         INTEGER, PARAMETER :: MHOCL      = 14  ! HOCL
         INTEGER, PARAMETER :: MHCL       = 15  ! HCL
         INTEGER, PARAMETER :: MHYDRAZINE = 16  ! Hydrazine
         INTEGER, PARAMETER :: MHBR       = 17  ! HBR
         INTEGER, PARAMETER :: MHI        = 18  ! HI
         INTEGER, PARAMETER :: MACRYACID  = 19  ! CCH3COOH
         INTEGER, PARAMETER :: MPAF       = 20  ! PAF
         INTEGER, PARAMETER :: MPMPF      = 21  ! PMPF
         INTEGER, PARAMETER :: MTAF2      = 22  ! TAF2
         INTEGER, PARAMETER :: MHFPODA    = 23  ! HFPODA (GENx)
         INTEGER, PARAMETER :: MCOF2      = 24  ! COF2
         INTEGER, PARAMETER :: MPEPF      = 25  ! PEPF
         INTEGER, PARAMETER :: MDA        = 26  ! DA
         INTEGER, PARAMETER :: MHFPOTA    = 27  ! HFPOTA
         INTEGER, PARAMETER :: MTAF       = 28  ! TAF
         INTEGER, PARAMETER :: MMA        = 29  ! MA
         INTEGER, PARAMETER :: MPFOA      = 30  ! PFOA
         INTEGER, PARAMETER :: MHFPODAghyd= 31  ! HFPODA produced from gas-phase hydrolysis
         INTEGER, PARAMETER :: MHFPODAchyd= 32  ! HFPODA produced from cloud hydrolysis
         INTEGER, PARAMETER :: MHFPODAphyd= 33  ! HFPODA produced from particle-phase hydrolysis
         INTEGER, PARAMETER :: MFCOOH     = 34  ! FCOOH, hydrolysis product of COF2
         INTEGER, PARAMETER :: MFCOOHchyd = 35  ! FCOOH produced from cloud hydrolysis
         INTEGER, PARAMETER :: MFCOOHphyd = 36  ! FCOOH produced from particle-phase hydrolysis
         INTEGER, PARAMETER :: MPFMOAF    = 37  ! FCOOH, hydrolysis product of COF2
         INTEGER, PARAMETER :: MPFMOAA    = 38  ! FCOOH, hydrolysis product of COF2
         INTEGER, PARAMETER :: MPFMOAAchyd= 39  ! FCOOH produced from cloud hydrolysis
         INTEGER, PARAMETER :: MPFMOAAphyd= 40  ! FCOOH produced from particle-phase hydrolysis
 
         CHARACTER( 16 )    :: SUBNAME( MXSPCS )  ! list of substance names


C...Henry's law constant data taken mostly from Rolf Sanders' Compilation of
C...  Henry's Law Constants for Inorganic and Organic Species of Potential
C...  Importance in Environment Chemistry 1999

      REAL, SAVE :: A( MXSPCS )         ! Henry's law constants at 298.15K (M/atm)
      REAL, SAVE :: E( MXSPCS )         ! enthalpy (like activation energy) (K)

C...dissociation constant data taken mostly from 6.A.1 of Seinfeld and Pandis
C...  Atmospheric Chemistry and Physics, 1997

      REAL, SAVE :: B( MXDSPCS )        ! dissociation constant at 298.15K (M or M2)
      REAL, SAVE :: D( MXDSPCS )        ! -dH/R (K)

      DATA SUBNAME(  1), A(  1), E(  1) / 'O3              ', 1.14E-02, 2.3E+03 / ! Kosak 1983
      DATA SUBNAME(  2), A(  2), E(  2) / 'HO2             ', 4.0E+03, 5.9E+03 /  ! Hanson et al. 1992
      DATA SUBNAME(  3), A(  3), E(  3) / 'H2O2            ', 1.1E+05, 7.4E+03 /  ! E: O'Sullivan et al. 1996, A: Sander 1999 as used in Nguyen et al. 2015 PNAS
      DATA SUBNAME(  4), A(  4), E(  4) / 'NH3             ', 6.1E+01, 4.2E+03 /  ! Clegg and Brimblecombe 1989
      DATA SUBNAME(  5), A(  5), E(  5) / 'NO              ', 1.9E-03, 1.4E+03 /  ! Lide and Frederikse 1995
      DATA SUBNAME(  6), A(  6), E(  6) / 'NO2             ', 1.2E-02, 2.5E+03 /  ! Chameides 1984
      DATA SUBNAME(  7), A(  7), E(  7) / 'NO3             ', 0.6E+00, 0.0E+00 /  ! Rudich, Talukdar et al.1996
      DATA SUBNAME(  8), A(  8), E(  8) / 'N2O5            ', 1.0E+30, 0.0E+00 /  ! "inf" Sander and Crutzen 1996
      DATA SUBNAME(  9), A(  9), E(  9) / 'HNO2            ', 5.0E+01, 4.9E+03 /  ! Becker et al. 1996
      DATA SUBNAME( 10), A( 10), E( 10) / 'HNO3            ', 2.1E+05, 8.7E+03 /  ! Leieveld and Crutzen 1991
      DATA SUBNAME( 11), A( 11), E( 11) / 'HNO4            ', 1.2E+04, 6.9E+03 /  ! Regimbal and Mozurkewich 1997
      DATA SUBNAME( 12), A( 12), E( 12) / 'SO2             ', 1.4E+00, 2.9E+03 /  ! Linde and Frederikse 1995
      DATA SUBNAME( 13), A( 13), E( 13) / 'H2SO4           ', 1.0E+30, 0.0E+00 /  ! infinity
      DATA SUBNAME( 14), A( 14), E( 14) / 'METHANE         ', 1.4E-03, 1.6E+03 /  ! Linde and Frederikse 1995
      DATA SUBNAME( 15), A( 15), E( 15) / 'ETHANE          ', 1.9E-03, 2.3E+03 /  ! Linde and Frederikse 1995
      DATA SUBNAME( 16), A( 16), E( 16) / 'PROPANE         ', 1.5E-03, 2.7E+03 /  ! Linde and Frederikse 1995
      DATA SUBNAME( 17), A( 17), E( 17) / 'BUTANE          ', 1.1E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 18), A( 18), E( 18) / 'PENTANE         ', 8.1E-04, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 19), A( 19), E( 19) / 'HEXANE          ', 6.18E-04,3.8E+03 /  ! Sander, ACP, 2015; Abraham Matteoli (1988)
      DATA SUBNAME( 20), A( 20), E( 20) / 'OCTANE          ', 2.9E-03, 7.8E+03 /  ! Hansen et al. 1993
      DATA SUBNAME( 21), A( 21), E( 21) / 'NONANE          ', 2.4E-03, 2.1E+02 /  ! Ashworth, Howe et al 1988
      DATA SUBNAME( 22), A( 22), E( 22) / 'DECANE          ', 1.4E-04, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 23), A( 23), E( 23) / 'ETHENE          ', 4.7E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 24), A( 24), E( 24) / 'PROPENE         ', 4.8E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 25), A( 25), E( 25) / 'ISOPRENE        ', 2.8E-02, 0.0E+00 /  ! Karl, Lindinger et al 2003
      DATA SUBNAME( 26), A( 26), E( 26) / 'ACETYLENE       ', 4.1E-02, 1.8E+03 /  ! Wilhelm et al. 1977
      DATA SUBNAME( 27), A( 27), E( 27) / 'BENZENE         ', 1.6E-01, 4.1E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 28), A( 28), E( 28) / 'TOLUENE         ', 1.5E-01, 4.0E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 29), A( 29), E( 29) / 'O-XYLENE        ', 1.9E-01, 4.0E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 30), A( 30), E( 30) / 'METHANOL        ', 2.2E+02, 5.2E+03 /  ! Snider and Dawson 1985
      DATA SUBNAME( 31), A( 31), E( 31) / 'ETHANOL         ', 1.9E+02, 6.6E+03 /  ! Snider and Dawson 1985
      DATA SUBNAME( 32), A( 32), E( 32) / '2-CRESOL        ', 8.2E+02, 0.0E+00 /  ! Betterton 1992
      DATA SUBNAME( 33), A( 33), E( 33) / '4-CRESOL        ', 1.3E+02, 0.0E+00 /  ! Betterton 1992
      DATA SUBNAME( 34), A( 34), E( 34) / 'METHYLHYDROPEROX', 3.1E+02, 5.2E+03 /  ! O'Sullivan et al. 1996
      DATA SUBNAME( 35), A( 35), E( 35) / 'FORMALDEHYDE    ', 3.2E+03, 6.8E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 36), A( 36), E( 36) / 'ACETALDEHYDE    ', 1.4E+01, 5.6E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 37), A( 37), E( 37) / 'GENERIC_ALDEHYDE', 4.2E+03, 0.0E+00 /  ! Graedel and Goldberg 1983
      DATA SUBNAME( 38), A( 38), E( 38) / 'GLYOXAL         ', 3.6E+05, 0.0E+00 /  ! Zhou and Mopper 1990
      DATA SUBNAME( 39), A( 39), E( 39) / 'ACETONE         ', 3.0E+01, 4.6E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 40), A( 40), E( 40) / 'FORMIC_ACID     ', 8.9E+03, 6.1E+03 /  ! Johnson et al. 1996
      DATA SUBNAME( 41), A( 41), E( 41) / 'ACETIC_ACID     ', 4.1E+03, 6.3E+03 /  ! Johnson et al. 1996
      DATA SUBNAME( 42), A( 42), E( 42) / 'METHYL_GLYOXAL  ', 3.2E+04, 0.0E+00 /  ! Zhou and Mopper 1990
      DATA SUBNAME( 43), A( 43), E( 43) / 'CO              ', 9.9E-04, 1.3E+03 /  ! Linde and Frederikse 1995
      DATA SUBNAME( 44), A( 44), E( 44) / 'CO2             ', 3.6E-02, 2.2E+03 /  ! Zheng et al. 1997
      DATA SUBNAME( 45), A( 45), E( 45) / 'PAN             ', 2.8E+00, 6.5E+03 /  ! Kames et al. 1991
      DATA SUBNAME( 46), A( 46), E( 46) / 'MPAN            ', 1.7E+00, 0.0E+00 /  ! Kames and Schurath 1995
      DATA SUBNAME( 47), A( 47), E( 47) / 'OH              ', 3.0E+01, 4.5E+03 /  ! Hanson et al. 1992
      DATA SUBNAME( 48), A( 48), E( 48) / 'METHYLPEROXY_RAD', 2.0E+03, 6.6E+03 /  ! Lelieveld and Crutzen 1991
      DATA SUBNAME( 49), A( 49), E( 49) / 'PEROXYACETIC_ACI', 8.4E+02, 5.3E+03 /  ! O'Sullivan et al. 1996
      DATA SUBNAME( 50), A( 50), E( 50) / 'PROPANOIC_ACID  ', 5.7E+03, 0.0E+00 /  ! Kahn et al. 1995
      DATA SUBNAME( 51), A( 51), E( 51) / '2-NITROPHENOL   ', 7.0E+01, 4.6E+03 /  ! USEPA 1982
      DATA SUBNAME( 52), A( 52), E( 52) / 'PHENOL          ', 3.3E+03, 3.6E+03 /  ! Meylan and Howard (1991)
      DATA SUBNAME( 53), A( 53), E( 53) / 'BIACETYL        ', 7.4E+01, 5.7E+03 /  ! Betteron 1991
      DATA SUBNAME( 54), A( 54), E( 54) / 'BENZALDEHYDE    ', 3.9E+01, 4.8E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 55), A( 55), E( 55) / 'PINENE          ', 4.9E-02, 0.0E+00 /  ! Karl and Lindinger 1997
      DATA SUBNAME( 56), A( 56), E( 56) / 'ATRA            ', 4.1E+05, 6.0E+03 /  ! CIBA Corp (1989) and Scholtz (1999)
      DATA SUBNAME( 57), A( 57), E( 57) / 'DATRA           ', 4.1E+05, 6.0E+03 /  ! assumed same as Atrazine
      DATA SUBNAME( 58), A( 58), E( 58) / 'ADIPIC_ACID     ', 2.0E+08, 0.0E+00 /  ! Saxena and Hildemann (1996)
      DATA SUBNAME( 59), A( 59), E( 59) / 'ACROLEIN        ', 8.2E+00, 0.0E+00 /  ! Meylan and Howard (1991)
      DATA SUBNAME( 60), A( 60), E( 60) / '13-BUTADIENE    ', 1.4E-02, 0.0E+00 /  ! Mackay and Shiu (1981)
      DATA SUBNAME( 61), A( 61), E( 61) / 'ACRYLONITRILE   ', 7.3E+00, 0.0E+00 /  ! Meylan and Howard (1991)
      DATA SUBNAME( 62), A( 62), E( 62) / 'CARBONTETRACHLOR', 3.4E-02, 4.2E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 63), A( 63), E( 63) / 'PROPYLENE_DICHLO', 3.4E-01, 4.3E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 64), A( 64), E( 64) / '13DICHLOROPROPEN', 6.5E-01, 4.2E+03 /  ! Wright et al (1992b)
      DATA SUBNAME( 65), A( 65), E( 65) / '1122-CL4ETHANE  ', 2.4E+00, 3.2E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 66), A( 66), E( 66) / 'CHLOROFORM      ', 2.5E-01, 4.5E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 67), A( 67), E( 67) / '12DIBROMOETHANE ', 1.5E+00, 3.9E+03 /  ! Ashworth et al (1988)
      DATA SUBNAME( 68), A( 68), E( 68) / '12DICHLOROETHANE', 7.3E-01, 4.2E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 69), A( 69), E( 69) / 'METHYLENE_CHLORI', 3.6E-01, 4.1E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 70), A( 70), E( 70) / 'PERCHLOROETHYLEN', 5.9E-02, 4.8E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 71), A( 71), E( 71) / 'TRICHLOROETHENE ', 1.0E-01, 4.6E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 72), A( 72), E( 72) / 'VINYL_CHLORIDE  ', 3.9E-02, 3.1E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 73), A( 73), E( 73) / 'ETHYLENE_OXIDE  ', 8.4E+00, 0.0E+00 /  ! CRC
      DATA SUBNAME( 74), A( 74), E( 74) / 'PPN             ', 2.9E+00, 0.0E+00 /  ! Kames and Schurath (1995)
      DATA SUBNAME( 75), A( 75), E( 75) / 'NAPHTHALENE     ', 2.0E+00, 3.6E+03 /  ! USEPA 1982
      DATA SUBNAME( 76), A( 76), E( 76) / 'QUINOLINE       ', 3.7E+03, 5.4E+03 /  ! USEPA 1982
      DATA SUBNAME( 77), A( 77), E( 77) / 'MEK             ', 2.0E+01, 5.0E+03 /  ! Zhou and Mopper 1990
      DATA SUBNAME( 78), A( 78), E( 78) / 'MVK             ', 4.1E+01, 0.0E+00 /  ! Iraci et al. 1998
      DATA SUBNAME( 79), A( 79), E( 79) / 'METHACROLEIN    ', 6.5E+00, 0.0E+00 /  ! Iraci et al. 1998
      DATA SUBNAME( 80), A( 80), E( 80) / 'CL2             ', 8.6E-02, 2.0E+03 /  ! ROLF SANDERS COMPILATION (1999)/KAVANAUGH AND TRUSSELL (1980)
      DATA SUBNAME( 81), A( 81), E( 81) / 'HOCL            ', 6.6E+02, 5.9E+03 /  ! ROLF SANDERS COMPILATION (1999)/HUTHWELKER ET AL (1995)
      DATA SUBNAME( 82), A( 82), E( 82) / 'HCL             ', 1.9E+01, 6.0E+02 /  ! ROLF SANDERS COMPILATION (1999)/DEAN (1992)
      DATA SUBNAME( 83), A( 83), E( 83) / 'FMCL            ', 1.1E+00, 0.0E+00 /  ! EPA SUITE PROGRAM/UNIT CONVERTED TO MATCH THE DEFINITION BY ROLF SANDERS.
      DATA SUBNAME( 84), A( 84), E( 84) / 'ICL1            ', 6.9E+01, 0.0E+00 /  ! EPA SUITE PROGRAM/UNIT CONVERTED TO MATCH THE DEFINITION BY ROLF SANDERS.
      DATA SUBNAME( 85), A( 85), E( 85) / 'ICL2            ', 6.9E+01, 0.0E+00 /  ! EPA SUITE PROGRAM/ASSUMED EQUAL TO THAT OF ICL1
      DATA SUBNAME( 86), A( 86), E( 86) / 'HG              ', 1.11E-01, 4.97E+03 /! Elemental Mercury from Clever et al. (1985)
      DATA SUBNAME( 87), A( 87), E( 87) / 'HGIIGAS         ', 1.41E+06, 5.26E+03 /! Hg(II) gas as mercuric chloride from Lindqvist and Rodhe (1985)
      DATA SUBNAME( 88), A( 88), E( 88) / 'TECDD_2378      ', 5.1E+00, 3.6E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 89), A( 89), E( 89) / 'PECDD_12378     ', 4.6E+00, 3.2E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 90), A( 90), E( 90) / 'HXCDD_123478    ', 8.1E+00, 2.9E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 91), A( 91), E( 91) / 'HXCDD_123678    ', 2.9E+00, 2.8E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 92), A( 92), E( 92) / 'HXCDD_123789    ', 6.5E+00, 2.7E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 93), A( 93), E( 93) / 'HPCDD_1234678   ', 1.2E+01, 2.4E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 94), A( 94), E( 94) / 'OTCDD           ', 9.8E+00, 2.3E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 95), A( 95), E( 95) / 'TECDF_2378      ', 8.5E+01, 3.7E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 96), A( 96), E( 96) / 'PECDF_12378     ', 5.2E+01, 2.9E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 97), A( 97), E( 97) / 'PECDF_23478     ', 1.8E+02, 3.0E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 98), A( 98), E( 98) / 'HXCDF_123478    ', 3.8E+01, 2.4E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 99), A( 99), E( 99) / 'HXCDF_123678    ', 9.0E+01, 2.9E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(100), A(100), E(100) / 'HXCDF_234678    ', 1.0E+02, 2.6E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(101), A(101), E(101) / 'HXCDF_123789    ', 5.6E+01, 2.6E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(102), A(102), E(102) / 'HPCDF_1234678   ', 2.8E+01, 1.6E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(103), A(103), E(103) / 'HPCDF_1234789   ', 8.0E+01, 2.1E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(104), A(104), E(104) / 'OTCDF           ', 7.6E+01, 2.4E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(105), A(105), E(105) / 'NAPHTHOL        ', 3.60E+03, 0.0E+00 / ! Eabraham et al. (1994)
      DATA SUBNAME(106), A(106), E(106) / '1NITRONAPHTHALEN', 5.68E+02, 0.0E+00 / ! Altschuh et al. (1999)
      DATA SUBNAME(107), A(107), E(107) / '2NITRONAPHTHALEN', 6.42E+02, 0.0E+00 / ! HENRYWIN v3.10 (Meylan and Howard, 1991)
      DATA SUBNAME(108), A(108), E(108) / '14NAPHTHOQUINONE', 5.08E+05, 0.0E+00 / ! HENRYWIN v3.10 (Meylan and Howard, 1991)
      DATA SUBNAME(109), A(109), E(109) / '24-TOLUENE_DIIS ', 7.25E+00, 0.0E+00 / ! HENRYWIN v3.10 (Meylan and Howard, 1991)
      DATA SUBNAME(110), A(110), E(110) / 'HEXAMETHYLE_DIIS', 2.08E+01, 0.0E+00 / ! HENRYWIN v3.10 (Meylan and Howard, 1991)
      DATA SUBNAME(111), A(111), E(111) / 'HYDRAZINE       ', 1.14E+03, 0.0E+00 / ! Daubert and Danner (1989), and Amoore and Hautala (1983)
      DATA SUBNAME(112), A(112), E(112) / 'MALEIC_ANHYDRIDE', 2.54E+02, 0.0E+00 / ! HENRYWIN v3.10 (Meylan and Howard, 1991)
      DATA SUBNAME(113), A(113), E(113) / 'TRIETHYLAMINE   ', 6.71E+00, 0.0E+00 / ! Yalkowsky and Dannenfelser (1992), and Riddick et al. (1986)
      DATA SUBNAME(114), A(114), E(114) / 'P_DICHLOROBENZEN', 2.38E+00, 0.0E+00 / ! MacKay and Shiu (1981), measured
      DATA SUBNAME(115), A(115), E(115) / 'M-XYLENE        ', 1.43E-01, 3.9E+03 / ! Staudinger and Roberts (2001)
      DATA SUBNAME(116), A(116), E(116) / 'P-XYLENE        ', 1.35E-01, 3.7E+03 / ! Staudinger and Roberts (2001)

      DATA SUBNAME(117), A(117), E(117) / 'N-HEXANE        ', 6.18E-04, 3.8E+03 /  ! Sander, ACP, 2015, Abraham Matteoli (1988)
      DATA SUBNAME(118), A(118), E(118) / 'PROPANAL        ', 1.64E+00, 5.4E+03 /  ! Staudinger and Roberts (2001)
      DATA SUBNAME(119), A(119), E(119) / 'STYRENE         ', 2.74E-01, 0.0E+00 /  ! Sander, ACP, 2015, Kim and Kim (2014)
      DATA SUBNAME(120), A(120), E(120) / '124TRIMETH_BENZE', 1.50E-01, 4.3E+03 /  ! Hanson et al. (1995)
      DATA SUBNAME(121), A(121), E(121) / 'CHLOROACETALDEHY', 4.18E+01, 0.0E+00 /  ! Bond Estimate by EPA SUITE PROGRAM  (2007)
      DATA SUBNAME(122), A(122), E(122) / 'CHLOROACETONE   ', 3.82E-01, 0.0E+00 /  ! Staudinger and Roberts (2001)

      DATA SUBNAME(123), A(123), E(123) / 'NITROSYL_CHLORID', 5.10E-01, 0.0E+00 /  ! Bond Estimate by EPA SUITE PROGRAM  (2007)
      DATA SUBNAME(124), A(124), E(124) / 'NITRYL_CHLORIDE ', 2.43E-02, 0.0E+00 /  ! Behnke et al. (1997), JGR, D102, 3795-3804
      DATA SUBNAME(125), A(125), E(125) / 'HEXYL_HYDROPEROX', 1.23E+01, 0.0E+00 /  ! Bond Estimated by EPA SUITE PROGRAM  (2007)

      DATA SUBNAME(126), A(126), E(126) / 'HYDROXY_NITRATES', 1.70E+04, 9.20E+03 /  ! Shepson et al. (1996), Treves et al. (2000)
      DATA SUBNAME(127), A(127), E(127) / 'HYDROXY_PEROXIDE', 8.30E+04, 7.40E+03 /  ! using value for H2O2
      DATA SUBNAME(128), A(128), E(128) / 'PROPNN          ', 1.00E+04, 0.00E+00 /  ! Nguyen et al. (2015) PNAS using Shepson (1996)
      DATA SUBNAME(129), A(129), E(129) / 'HACET           ', 2.93E+03, 0.00E+00 /  ! Spaulding et al. (2002)
      DATA SUBNAME(130), A(130), E(130) / 'PYRUVIC_ACID    ', 3.00E+05, 5.20E+03 /  ! Staudinger and Roberts (1996) 
      DATA SUBNAME(131), A(131), E(131) / 'XYLENOL         ', 1.05E+03, 0.00E+03 /  ! experimental value from EPA SUITE PROGRAM  (2008)
      DATA SUBNAME(132), A(132), E(132) / 'CATECHOL        ', 3.16E+05, 0.00E+03 /  ! experimental value from EPA SUITE PROGRAM  (2008)
      DATA SUBNAME(133), A(133), E(133) / 'IEPOX           ', 3.0E+07,  0.00E+00 /  ! Nguyen et al. ACP (2014)
      DATA SUBNAME(134), A(134), E(134) / 'IMAE            ', 1.2E+05,  0.00E+00 /  ! Pye et al. ES&T (2013)

      DATA SUBNAME(135), A(135), E(135) / 'DIETHYLKETONE   ', 2.00E+01, 9.2E+03 /   ! ROLF SANDERS COMPILATION (1999)/JANINI AND QUADDORA (1986)
      DATA SUBNAME(136), A(136), E(136) / 'N-PROPANOL      ', 1.10E+02, 0.0E+00 /   ! ROLF SANDERS COMPILATION (1999)/YAWS AND YANG (1992)
      DATA SUBNAME(137), A(137), E(137) / 'ETHYLENEGLYCOL  ', 4.00E+06, 0.0E+00 /   ! ROLF SANDERS COMPILATION (1999)/BONE ET AL. (1983)
      DATA SUBNAME(138), A(138), E(138) / 'HYDROXY-ACETONE ', 2.00E+04, 0.0E+00 /   ! MATSUNAGA ET AL., 41, 790-796, AE, (2007)            
      DATA SUBNAME(139), A(139), E(139) / '2NITRO_1BUTNL   ', 6.30E+03, 9.6E+03 /   ! Shepson et al., 1992 
      DATA SUBNAME(140), A(140), E(140) / 'PYROCATECHOL    ', 4.60E+03, 0.0E+00 /   ! Mackay et al., 1995            
      DATA SUBNAME(141), A(141), E(141) / 'NTR_ALK         ', 6.50E-01, 5.4E+03 /   ! 2-butylnitrate, from Sander
      DATA SUBNAME(142), A(142), E(142) / 'NTR_OH          ', 6.50E+03, 9.5E+03 /   ! 3-nitrooxy-butanol, from Sander
      DATA SUBNAME(143), A(143), E(143) / 'DINTR           ', 1.80E+01, 0.0E+00 /   ! 2,3-pentanedinitrate
      DATA SUBNAME(144), A(144), E(144) / 'NTR_PX          ', 3.40E+02, 6.0E+03 /   ! ethylhydroperoxide 
      DATA SUBNAME(145), A(145), E(145) / 'MTNO3           ', 1.5E+06,  0.0E+00 /   ! monoterpene nitrates HenryWin v3.2 
      DATA SUBNAME(146), A(146), E(146) / 'ISOPNN          ', 4.5E+08,  0.0E+00 /   ! isoprene dinitrate HenryWin v3.2
      DATA SUBNAME(147), A(147), E(147) / 'SVALK1          ', 6.2E+08,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(148), A(148), E(148) / 'SVALK2          ', 4.5E+06,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(149), A(149), E(149) / 'SVBNZ1          ', 2.1E+08,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(150), A(150), E(150) / 'SVBNZ2          ', 2.0E+06,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(151), A(151), E(151) / 'SVISO1          ', 4.3E+07,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(152), A(152), E(152) / 'SVISO2          ', 3.7E+09,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(153), A(153), E(153) / 'SVPAH1          ', 5.1E+07,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(154), A(154), E(154) / 'SVPAH2          ', 7.2E+05,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(155), A(155), E(155) / 'SVSQT           ', 6.2E+08,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(156), A(156), E(156) / 'SVTOL1          ', 4.2E+07,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(157), A(157), E(157) / 'SVTOL2          ', 7.3E+06,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(158), A(158), E(158) / 'SVTRP1          ', 9.9E+08,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(159), A(159), E(159) / 'SVTRP2          ', 1.4E+08,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(160), A(160), E(160) / 'SVXYL1          ', 6.2E+07,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(161), A(161), E(161) / 'SVXYL2          ', 4.0E+06,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL

      DATA SUBNAME(162), A(162), E(162) / 'I2              ', 3.10E+00, 4.6E+03 /   ! ROLF SANDERS COMPILATION (1999)/Berdnikov and Bazhin (1970)
      DATA SUBNAME(163), A(163), E(163) / 'I               ', 6.30E-03, 2.3E+03 /   ! ROLF SANDERS COMPILATION (1999)/Berdnikov and Bazhin (1970)
      DATA SUBNAME(164), A(164), E(164) / 'IO              ', 4.50E+02, 0.0E+00 /   ! Saiz-Lopez et al., ACPD, 2014
      DATA SUBNAME(165), A(165), E(165) / 'OIO             ', 1.00E+04, 0.0E+00 /   ! Saiz-Lopez et al., ACPD, 2014
      DATA SUBNAME(166), A(166), E(166) / 'I2O2            ', 1.00E+30, 0.0E+00 /   ! Sherwen et al., 2016
      DATA SUBNAME(167), A(167), E(167) / 'I2O3            ', 1.00E+30, 0.0E+00 /   ! Sherwen et al., 2016
      DATA SUBNAME(168), A(168), E(168) / 'I2O4            ', 1.00E+30, 0.0E+00 /   ! Sherwen et al., 2016
      DATA SUBNAME(169), A(169), E(169) / 'HI              ', 2.50E+00, 5.3E+03 /   ! Schweitzer et al. (2000)
      DATA SUBNAME(170), A(170), E(170) / 'HOI             ', 1.53E+04, 8.3E+03 /   ! Sherwen et al., 2016      

      DATA SUBNAME(171), A(171), E(171) / 'INO             ', 5.00E-02, 0.0E+00 /   ! Same as ClNO which is from ROLF SANDERS COMPILATION (1999)/Scheer et al. (1997)
      DATA SUBNAME(172), A(172), E(172) / 'INO2            ', 3.00E-01, 0.0E+00 /   ! Same as BRNO2 which is from ROLF SANDERS COMPILATION (1999)/Frenzel et al. (1998)
      DATA SUBNAME(173), A(173), E(173) / 'INO3            ', 1.00E+30, 0.0E+00 /   ! Same as BRNO3; BRNO3 from Sander (2015)      
      DATA SUBNAME(174), A(174), E(174) / 'CH3I            ', 1.40E-01, 4.3E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(175), A(175), E(175) / 'MIC             ', 8.90E-01, 4.3E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(176), A(176), E(176) / 'MIB             ', 8.90E-01, 4.3E+03 /   ! Same as MIC, Final Report to TCEQ, Environ International, 2012
      DATA SUBNAME(177), A(177), E(177) / 'MI2             ', 2.30E+00, 5.0E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)

      DATA SUBNAME(178), A(178), E(178) / 'BRO             ', 7.10E-01, 0.0E+00 /   ! Parrella et al. (2012)
      DATA SUBNAME(179), A(179), E(179) / 'HOBR            ', 6.10E+03, 6.0E+03 /   ! Sherwen et al., 2016
      DATA SUBNAME(180), A(180), E(180) / 'HBR             ', 7.50E-01, 6.1E+03 /   ! A from Schweitzer et al. (2000) and E from Chmeides and Stelson (1992) - ROLF SANDERS COMPILATION (1999)
      DATA SUBNAME(181), A(181), E(181) / 'BR2             ', 7.60E-01, 4.1E+03 /   ! Dean et al. (1992)
      DATA SUBNAME(182), A(182), E(182) / 'BRNO3           ', 1.00E+30, 0.0E+00 /   ! Sander (2015)

      DATA SUBNAME(183), A(183), E(183) / 'MB3             ', 1.40E+00, 5.0E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(184), A(184), E(184) / 'CH3BR           ', 1.50E-01, 0.0E+00 /   ! ROLF SANDERS COMPILATION (1999)/Yaws and Yang et al. (1992)
      DATA SUBNAME(185), A(185), E(185) / 'MB2             ', 9.30E-01, 4.4E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(186), A(186), E(186) / 'MB2C            ', 7.30E-01, 4.9E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(187), A(187), E(187) / 'MBC2            ', 4.00E-01, 4.7E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(188), A(188), E(188) / 'MBC             ', 8.90E-01, 4.3E+03 /   ! Same as MIC
      DATA SUBNAME(189), A(189), E(189) / 'BRNO2           ', 3.00E-01, 0.0E+00 /   ! Frenzel et al. (1998)
      DATA SUBNAME(190), A(190), E(190) / 'BRCL            ', 9.70E-01, 0.0E+00 /   ! Sherwen et al., 2016
      DATA SUBNAME(191), A(191), E(191) / 'ICL             ', 1.10E+02, 2.1E+03 /   ! Sherwen et al., 2016

      DATA SUBNAME(192), A(192), E(192) / 'DMS             ', 4.80E-01, 3.1E+03 /   ! ROLF SANDERS COMPILATION (1999)/De Bryuyn et al. (1995)
      DATA SUBNAME(193), A(193), E(193) / 'MSA             ', 7.70E+04, 0.0E+00 /   ! Meylan and Howard (1991), inverse of the value is used due to unit conversion
      DATA SUBNAME(194), A(194), E(194) / 'XYLENE          ', 1.90E-01, 4.2E+03  / ! .35/.3/.35 m/o/p, Sander ACP 2015, Staudinger and Roberts (2001) for m; Fogg and Sangster (2003) for o and p
      DATA SUBNAME(195), A(195), E(195) / 'ETHYLBENZENE    ', 1.42E-01, 4.8E+03 /  ! Sander ACP 2015, Fogg Sangster (2003)
      DATA SUBNAME(196), A(196), E(196) / 'ACRYACID        ', 3.141E+03, 0.0E+00 / ! Sander ACP 2015, Lide Frederikse (1995)
      DATA SUBNAME(197), A(197), E(197) / 'ACETONITRILE    ', 5.269E+01, 4.0E+03 / ! Sander ACP 2015, Sander et al (2011)
      DATA SUBNAME(198), A(198), E(198) / 'CHLOROPRENE     ', 4.760E+00, 0.0E+00 / ! Sander ACP 2015, Mackay et al. (1993)
      DATA SUBNAME(199), A(199), E(199) / 'METHCHLORIDE    ', 1.320E-01, 3.3E+03 / ! Sander ACP 2015, Sander et al. (2011)
      DATA SUBNAME(200), A(200), E(200) / 'CARBSULFIDE     ', 2.130E-02, 3.3E+03 / ! Sander ACP 2015, Warneck Williams (2012)
      DATA SUBNAME(201), A(201), E(201) / '6_NITRO_O_CRESOL', 2.938E+01, 0.0E+00 / ! 6-methyl-2-nitrophenol from Sander ACP 2015, Tremp et. al (1992)
      DATA SUBNAME(202), A(202), E(202) / 'SVMT1           ', 7.1E+11,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(203), A(203), E(203) / 'SVMT2           ', 8.9E+10,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(204), A(204), E(204) / 'SVMT3           ', 1.1E+10,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(205), A(205), E(205) / 'SVMT4           ', 1.4E+09,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(206), A(206), E(206) / 'SVMT5           ', 1.8E+08,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(207), A(207), E(207) / 'SVMT6           ', 2.2E+07,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(208), A(208), E(208) / 'SVMT7           ', 2.8E+06,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(209), A(209), E(209) / 'SVAVB1          ', 5.5E+09,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(210), A(210), E(210) / 'SVAVB2          ', 7.9E+07,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(211), A(211), E(211) / 'SVAVB3          ', 1.2E+07,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(212), A(212), E(212) / 'SVAVB4          ', 1.8E+06,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(213), A(213), E(213) / 'CLNO3           ', 1.00E+30, 0.0E+00 /   ! Sander (2015)
      DATA SUBNAME(214), A(214), E(214) / 'IBR             ', 2.43E+01, 4.9E+03 /   ! Sherwen et al., 2016
      DATA SUBNAME(215), A(215), E(215) / 'FMBR            ', 7.40E+01, 0.0E+00 /   ! Sander, R. ACP (2015), krysztofiak et al. (2012)
      DATA SUBNAME(216), A(216), E(216) / 'CLO             ', 7.00E-03, 0.0E+00 /   ! Sander et al., ACP, 2015
      
      DATA SUBNAME(217), A(217), E(217) / 'BENAPY          ', 2.00E+03, 4.7E+03 /   ! benzo[a]pyrene Ma et al. (2010) and ten Hulscher et al. (1992) in  Sander et al., ACP, 2015
      DATA SUBNAME(218), A(218), E(218) / 'XYEOPERA        ', 1.27E-01, 4.0E+03 /   ! O-xylene T dep from Staudinger and Roberts 1996, CRACMM RepCmp (OPERA SAR)
      DATA SUBNAME(219), A(219), E(219) / 'ROCIOXYOPERA    ', 8.12E+00, 0.0E+00 /   ! emission wt. CRACMM value (OPERA SAR)
      DATA SUBNAME(220), A(220), E(220) / 'UALDOPERA       ', 44.0E+00, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(221), A(221), E(221) / 'OLTOPERA        ', 5.09E-03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(222), A(222), E(222) / 'OLIOPERA        ', 4.85E-03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(223), A(223), E(223) / 'BENOPERA        ', 0.18E+00, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(224), A(224), E(224) / 'PHENOPERA       ', 1.83E+04, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(225), A(225), E(225) / 'TOLOPERA        ', 0.15E+00, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(226), A(226), E(226) / 'CSLOPERA        ', 1.42E+03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(227), A(227), E(227) / 'XYMOPERA        ', 0.14E+00, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(228), A(228), E(228) / 'ISOOPERA        ', 1.86E-02, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(229), A(229), E(229) / 'APIOPERA        ', 7.49E-03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(230), A(230), E(230) / 'LIMOPERA        ', 4.44E-02, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(231), A(231), E(231) / 'ORA2OPERA       ', 9.95E+03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(232), A(232), E(232) / 'ACROOPERA       ', 8.28E+00, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(233), A(233), E(233) / 'BDE13OPERA      ', 2.42E-02, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(234), A(234), E(234) / 'PROGOPERA       ', 1.65E+04, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(235), A(235), E(235) / 'FURANOPERA      ', 5.11E+03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(236), A(236), E(236) / 'SLOWROCOPERA    ', 1.95E+00, 0.0E+00 /   ! emission wt. CRACMM value (OPERA SAR)
      DATA SUBNAME(237), A(237), E(237) / 'SESQOPERA       ', 1.07E-01, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(238), A(238), E(238) / 'NAPHOPERA       ', 2.28E+00, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(239), A(239), E(239) / 'HC3OPERA        ', 2.55E-03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(240), A(240), E(240) / 'HC5OPERA        ', 8.04E-04, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(241), A(241), E(241) / 'HC10OPERA       ', 6.52E-03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(242), A(242), E(242) / 'ORA1OPERA       ', 5.95E+03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(243), A(243), E(243) / 'MCTOPERA        ', 5.80E+03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(244), A(244), E(244) / 'FURANONEOPERA   ', 7.87E+04, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(245), A(245), E(245) / 'IPCOPERA        ', 4.72E+05, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(246), A(246), E(246) / 'IPNOPERA        ', 4.69E+04, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(247), A(247), E(247) / 'VROCN2OXY2OPERA ', 1.15E+05, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(248), A(248), E(248) / 'VROCN2OXY4OPERA ', 9.71E+05, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(249), A(249), E(249) / 'VROCN2OXY8OPERA ', 3.80E+06, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(250), A(250), E(250) / 'VROCN1OXY1OPERA ', 2.14E+04, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(251), A(251), E(251) / 'VROCN1OXY3OPERA ', 2.87E+06, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(252), A(252), E(252) / 'VROCN1OXY6OPERA ', 1.01E+06, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(253), A(253), E(253) / 'VROCP0OXY2OPERA ', 4.03E+05, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(254), A(254), E(254) / 'VROCP0OXY4OPERA ', 8.55E+05, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(255), A(255), E(255) / 'VROCP1OXY1OPERA ', 4.52E+04, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(256), A(256), E(256) / 'VROCP1OXY3OPERA ', 1.02E+04, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(257), A(257), E(257) / 'VROCP2OXY2OPERA ', 4.93E+03, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(258), A(258), E(258) / 'VROCP3OXY2OPERA ', 1.10E+02, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(259), A(259), E(259) / 'VROCP4OXY2OPERA ', 6.45E+02, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(260), A(260), E(260) / 'VROCP5OXY1OPERA ', 1.57E+00, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(261), A(261), E(261) / 'VROCP6OXY1OPERA ', 1.37E+00, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(262), A(262), E(262) / 'VROCP5AROOPERA  ', 4.15E-01, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(263), A(263), E(263) / 'VROCP6AROOPERA  ', 1.87E-01, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(264), A(264), E(264) / 'VROCN2ALKOPERA  ', 1.34E+03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(265), A(265), E(265) / 'VROCN1ALKOPERA  ', 1.34E+03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(266), A(266), E(266) / 'VROCP0ALKOPERA  ', 1.33E+03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(267), A(267), E(267) / 'VROCP1ALKOPERA  ', 1.33E+03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(268), A(268), E(268) / 'VROCP2ALKOPERA  ', 1.17E+03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(269), A(269), E(269) / 'VROCP3ALKOPERA  ', 6.10E+02, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(270), A(270), E(270) / 'VROCP4ALKOPERA  ', 2.94E+01, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(271), A(271), E(271) / 'VROCP5ALKOPERA  ', 5.41E-02, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(272), A(272), E(272) / 'VROCP6ALKOPERA  ', 6.90E-03, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(273), A(273), E(273) / 'STYOPERA        ', 3.89E-01, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(274), A(274), E(274) / 'EBZOPERA        ', 1.27E-01, 4.0E+03 /   ! O-xylene T dep from Staudinger and Roberts 1996, CRACMM RepCmp (OPERA SAR)
      DATA SUBNAME(275), A(275), E(275) / 'XYLOPERA        ', 0.14E+00, 0.0E+00 /   ! CRACMM RepCmp value (OPERA SAR)
      DATA SUBNAME(276), A(276), E(276) / 'INALDOPERA      ', 1.00E+05, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(277), A(277), E(277) / 'IPXOPERA        ', 1.55E+07, 0.0E+00 /   ! CRACMM RepCMP value (OPERA SAR)
      DATA SUBNAME(278), A(278), E(278) / 'HFPODA          ', 1.40E+02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(279), A(279), E(279) / 'HFPODAF         ', 2.20E-02, 0.0E+00 /   ! from Ivan
      DATA SUBNAME(280), A(280), E(280) / 'TFE             ', 6.17E+00, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(281), A(281), E(281) / 'HFPO            ', 8.62E-03, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(282), A(282), E(282) / 'HFP             ', 6.54E+00, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(283), A(283), E(283) / 'E2              ', 1.07E+00, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(284), A(284), E(284) / 'PSEPVE          ', 5.15E+02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(285), A(285), E(285) / 'PAF             ', 2.49E+00, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(286), A(286), E(286) / 'CH3F            ', 6.38E-01, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(287), A(287), E(287) / 'PPVE            ', 2.08E-01, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(288), A(288), E(288) / 'PMVE            ', 1.02E+00, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(289), A(289), E(289) / 'PEVE            ', 7.52E-01, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(290), A(290), E(290) / 'PFB             ', 1.55E+00, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(291), A(291), E(291) / 'PMPF            ', 1.87E-01, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(292), A(292), E(292) / 'TAF2            ', 5.05E-02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(293), A(293), E(293) / 'EVE             ', 7.04E+04, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(294), A(294), E(294) / 'COF2            ', 18.0E+00, 0.0E+00 /   ! from Ivan
      DATA SUBNAME(295), A(295), E(295) / 'E1              ', 7.81E-02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(296), A(296), E(296) / 'PEPF            ', 4.95E-02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(297), A(297), E(297) / 'DA              ', 3.24E+04, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(298), A(298), E(298) / 'HFPOTA          ', 1.70E+02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(299), A(299), E(299) / 'TAF             ', 2.62E-02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(300), A(300), E(300) / 'MA              ', 1.32E+02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(301), A(301), E(301) / 'F113            ', 1.21E-02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(302), A(302), E(302) / 'TFF4            ', 1.14E+00, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(303), A(303), E(303) / 'CF3H            ', 1.24E-02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(304), A(304), E(304) / 'PFASOTHER       ', 2.09E-01, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(305), A(305), E(305) / 'PFASGAS         ', 3.29E-02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(306), A(306), E(306) / 'PFASGP          ', 3.29e-02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(307), A(307), E(307) / 'PFASGASOTHER    ', 5.93e-02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(308), A(308), E(308) / 'PFOA            ', 5.24e+06, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(309), A(309), E(309) / 'HFPODAghyd      ', 1.40E+02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(300), A(300), E(300) / 'HFPODAchyd      ', 1.40E+02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(311), A(311), E(311) / 'HFPODAphyd      ', 1.40E+02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(312), A(312), E(312) / 'FCOOH           ', 1.30e+04, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(313), A(313), E(313) / 'FCOOHphyd       ', 1.30e+04, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(314), A(314), E(314) / 'FCOOHchyd       ', 1.30e+04, 0.0E+00 /   ! Estimated from OPERA      
      DATA SUBNAME(315), A(315), E(315) / 'PFMOAF          ', 0.11E+00, 0.0E+00 /   ! from Ivan
      DATA SUBNAME(316), A(316), E(316) / 'PFMOAA          ', 6.80e+02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(317), A(317), E(317) / 'PFMOAAphyd      ', 6.80e+02, 0.0E+00 /   ! Estimated from OPERA
      DATA SUBNAME(318), A(318), E(318) / 'PFMOAAchyd      ', 6.80e+02, 0.0E+00 /   ! Estimated from OPERA
 
      ! Additional Parameters for Dissociating Species (B = dissociation constant, D = -dH/R)
      DATA B( MSO2   ), D( MSO2   ) / 1.30E-02,  1.96E+03 /  ! SO2*H2O<=>HSO3+H     : Smith and Martell (1976)
      DATA B( MHSO3  ), D( MHSO3  ) / 6.60E-08,  1.50E+03 /  ! HSO3<=>SO3+H         : Smith and Martell (1976)
      DATA B( MHNO2  ), D( MHNO2  ) / 5.10E-04, -1.26E+03 /  ! HNO2(aq)<=>NO2+H     : Schwartz and White (1981)
      DATA B( MHNO3  ), D( MHNO3  ) / 1.54E+01,  8.70E+03 /  ! HNO3(aq)<=>NO3+H     : Schwartz (1984)
      DATA B( MCO2   ), D( MCO2   ) / 4.30E-07, -1.00E+03 /  ! CO2*H2O<=>HCO3+H     : Smith and Martell (1976)
      DATA B( MHCO3  ), D( MHCO3  ) / 4.68E-11, -1.76E+03 /  ! HCO3<=>CO3+H         : Smith and Martell (1976)
      DATA B( MH2O2  ), D( MH2O2  ) / 2.20E-12, -3.73E+03 /  ! H2O2(aq)<=>HO2+H     : Smith and Martell (1976)
      DATA B( MHCOOH ), D( MHCOOH ) / 1.80E-04, -2.00E+01 /  ! HCOOH(aq)<=>HCOO+H   : Martell and Smith (1977)
      DATA B( MHO2   ), D( MHO2   ) / 3.50E-05,  0.00E+00 /  ! HO2(aq)<=>H+O2       : Perrin (1982)
      DATA B( MNH4OH ), D( MNH4OH ) / 1.70E-05, -4.50E+02 /  ! NH4*OH<=>NH4+OH      : Smith and Martell (1976)
      DATA B( MH2O   ), D( MH2O   ) / 1.00E-14, -6.71E+03 /  ! H2O<=>H+OH           : Smith and Martell (1976)
      DATA B( MATRA  ), D( MATRA  ) / 2.09E-02,  0.00E+00 /  ! C8H14ClN5<=>C8H13ClN5+H  : Weber (1970)
      DATA B( MCL2   ), D( MCL2   ) / 5.01E-04,  0.00E+00 /  ! CL2*H2O <=> HOCL + H + CL : LIN AND PEHKONEN (1998, see note below)
      DATA B( MHOCL  ), D( MHOCL  ) / 3.16E-08,  0.00E+00 /  ! HOCL <=>H + OCL      : LIN AND PEHKONEN (1998) 
      DATA B( MHCL   ), D( MHCL   ) / 1.74E+06,  6.90E+03 /  ! HCL <=> H + CL       : Marsh and McElroy (1985)
      DATA B( MHYDRAZINE), D( MHYDRAZINE) / 1.11E-08,  0.00E+00 /  ! HYDRAZINE <=> HYDRAZINE+ + OH-  : Moliner and Street (1989)
      DATA B( MHBR   ), D( MHBR   ) / 1.00E+09,  0.00E+00 /  ! HBR <=> H + BR       : Schweitzer et al. (2000)
      DATA B( MHI    ), D( MHI    ) / 3.20E+09,  0.00E+00 /  ! HI <=> H + I         : Schweitzer et al. (2000)
      DATA B( MACRYACID ), D( MACRYACID ) / 5.62E-05,  0.00E+00 /  ! CH3C(O)OH <=> H + CH3C(O)O  : Riddick et al. (1985)   

      DATA B( MPFOA),   D( MPFOA)   /  4.57E-01,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MHFPODA), D( MHFPODA) /  2.84E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MFCOOH) , D( MFCOOH)  /  1.00E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MPFMOAA), D( MPFMOAA) /  2.84E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      !DATA B( MPAF   ), D( MPAF   ) / 0.19E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      !DATA B( MPMPF  ), D( MPMPF  ) / 0.85E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      !DATA B( MTAF2  ), D( MTAF2  ) / 1.66E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      !DATA B( MCOF2  ), D( MCOF2  ) / 0.08E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      !DATA B( MPEPF  ), D( MPEPF  ) / 7.24E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      !DATA B( MDA    ), D( MDA    ) / 1.02E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      !DATA B( MHFPOTA), D( MHFPOTA) / 1.95E+01,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      !DATA B( MTAF   ), D( MTAF   ) / 8.91E-04,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      !DATA B( MMA    ), D( MMA    ) / 1.12E-01,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      
      DATA B( MPAF   ), D( MPAF   ) / 0.00E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MPMPF  ), D( MPMPF  ) / 0.00E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MTAF2  ), D( MTAF2  ) / 0.00E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MCOF2  ), D( MCOF2  ) / 0.00E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MPEPF  ), D( MPEPF  ) / 0.00E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MDA    ), D( MDA    ) / 0.00E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MHFPOTA), D( MHFPOTA) / 0.00E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MTAF   ), D( MTAF   ) / 0.00E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-
      DATA B( MMA    ), D( MMA    ) / 0.00E+00,  0.00E+00 /  ! R(O)OH <=> H + R(O)O-                     


!-------------------------------------------------------------------------------
! Note for dissociation constant for equation LCL2: CL2*H2O <=> HOCL + H + CL
! Need aqueous [CL-] concentration to calculate effective henry's law coefficient
! Used a value of 2.0 mM following Lin and Pehkonen, JGR, 103, D21, 28093-28102, November 20, 1998
!-------------------------------------------------------------------------------


      CONTAINS

! Look for species CSPEC in Henry's Law table of substances SUBNAME
         SUBROUTINE HLINDEX( CSPEC, IND, LERROR )
            USE RUNTIME_VARS, ONLY : LOGDEV, LOG_MESSAGE
            USE UTILIO_DEFN
            IMPLICIT NONE

            CHARACTER(16), INTENT(IN   ) :: CSPEC
            INTEGER,       INTENT(  OUT) :: IND
            LOGICAL,       INTENT(INOUT) :: LERROR

            CHARACTER(120)               :: XMSG

            IND = INDEX1( CSPEC, MXSPCS, SUBNAME )
            IF ( IND .EQ. 0 ) THEN
               LERROR = .TRUE.
               XMSG = ' Could not find ' // TRIM( CSPEC ) // 
     &                ' in Henry''s Law table SUBNAME'
               CALL LOG_MESSAGE( LOGDEV, XMSG )
            END IF

         END SUBROUTINE HLINDEX

         SUBROUTINE HLCONST_INIT
            USE RUNTIME_VARS, ONLY : LOGDEV, LOG_MESSAGE
            USE UTILIO_DEFN
            IMPLICIT NONE

            CHARACTER( 80 ) :: XMSG
            CHARACTER( 16 ) :: PNAME = 'HLCONST_INIT'
            LOGICAL         :: LERROR = .FALSE.
! species that dissociate, needed for calculating effective Henry's Law coeffs
            CALL HLINDEX( 'SO2             ', HLC_SO2      , LERROR )
            CALL HLINDEX( 'HNO2            ', HLC_HNO2     , LERROR ) 
            CALL HLINDEX( 'HNO3            ', HLC_HNO3     , LERROR ) 
            CALL HLINDEX( 'CO2             ', HLC_CO2      , LERROR ) 
            CALL HLINDEX( 'H2O2            ', HLC_H2O2     , LERROR ) 
            CALL HLINDEX( 'FORMIC_ACID     ', HLC_HCOOH    , LERROR ) 
            CALL HLINDEX( 'HO2             ', HLC_HO2      , LERROR ) 
            CALL HLINDEX( 'NH3             ', HLC_NH3      , LERROR ) 
            CALL HLINDEX( 'HYDRAZINE       ', HLC_HYDRAZINE, LERROR ) 
            CALL HLINDEX( 'ATRA            ', HLC_ATRA     , LERROR ) 
            CALL HLINDEX( 'DATRA           ', HLC_DATRA    , LERROR ) 
            CALL HLINDEX( 'CL2             ', HLC_CL2      , LERROR ) 
            CALL HLINDEX( 'HCL             ', HLC_HCL      , LERROR ) 
            CALL HLINDEX( 'HOCL            ', HLC_HOCL     , LERROR ) 
            CALL HLINDEX( 'HBR             ', HLC_HBR      , LERROR ) 
            CALL HLINDEX( 'HI              ', HLC_HI       , LERROR ) 
            CALL HLINDEX( 'ACRYACID        ', HLC_ACRYACID , LERROR ) 

            ! PFAS Compounds that dissociate                                                  
            CALL HLINDEX( 'PFOA            ', HLC_PFOA     , LERROR ) 
            CALL HLINDEX( 'HFPODA          ', HLC_HFPODA   , LERROR ) 
            CALL HLINDEX( 'FCOOH           ', HLC_FCOOH    , LERROR ) 
            CALL HLINDEX( 'PFMOAA          ', HLC_PFMOAA   , LERROR ) 
            CALL HLINDEX( 'PAF             ', HLC_PAF      , LERROR ) 
            CALL HLINDEX( 'PMPF            ', HLC_PMPF     , LERROR ) 
            CALL HLINDEX( 'TAF2            ', HLC_TAF2     , LERROR ) 
            CALL HLINDEX( 'COF2            ', HLC_COF2     , LERROR ) 
            CALL HLINDEX( 'PEPF            ', HLC_PEPF     , LERROR ) 
            CALL HLINDEX( 'DA              ', HLC_DA       , LERROR ) 
            CALL HLINDEX( 'HFPOTA          ', HLC_HFPOTA   , LERROR ) 
            CALL HLINDEX( 'TAF             ', HLC_TAF      , LERROR ) 
            CALL HLINDEX( 'MA              ', HLC_MA       , LERROR ) 
            CALL HLINDEX( 'HFPODAF         ', HLC_HFPODAF  , LERROR )
            CALL HLINDEX( 'PFMOAF          ', HLC_PFMOAF   , LERROR )
                                                                                               
! additional species needed in AQCHEM                                                          
            CALL HLINDEX( 'O3              ', HLC_O3        , LERROR )                            
            CALL HLINDEX( 'METHYLHYDROPEROX', HLC_MHYDPOX   , LERROR )                            
            CALL HLINDEX( 'PEROXYACETIC_ACI', HLC_PEROXYACET, LERROR )                            
            CALL HLINDEX( 'GLYOXAL         ', HLC_GLY       , LERROR )                            
            CALL HLINDEX( 'METHYL_GLYOXAL  ', HLC_MGLY      , LERROR )                            
            CALL HLINDEX( 'OH              ', HLC_OH        , LERROR )                            
                                                                                                  
! add'l species needed in KMT version of AQCHEM                                                   
            CALL HLINDEX( 'ACETIC_ACID     ', HLC_CH3COOH   , LERROR )                            
            CALL HLINDEX( 'NO2             ', HLC_NO2       , LERROR )                                           
            CALL HLINDEX( 'HNO4            ', HLC_HNO4      , LERROR )                        
            CALL HLINDEX( 'NO3             ', HLC_NO3       , LERROR )                        
            CALL HLINDEX( 'PYRUVIC_ACID    ', HLC_PYRUVACID , LERROR )                        
                                                                                              
! additional species needed in AEROSOL_CHEMISTRY                                              
            CALL HLINDEX( 'IEPOX           ', HLC_IEPOX     , LERROR )                        
            CALL HLINDEX( 'IMAE            ', HLC_IMAE      , LERROR )                        
                                                                                              
            IF ( LERROR ) THEN                                                                
               XMSG = ' Missing species required for computing Henry''s law constants'
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            END IF

         END SUBROUTINE HLCONST_INIT

         REAL FUNCTION HLCONST ( ISUB, TEMP, EFFECTIVE, HPLUS )

C-----------------------------------------------------------------------
C
C  FUNCTION: return the Henry's law constant for the specified substance
C            at the given temperature
C
C  References:
C
C  1. Nguyen, T. B., Coggon, M. M., Bates, K. H., Zhang, X., Schwantes,
C     R. H., Schilling, K. A., Loza, C. L., Flagan, R. C., Wennberg, P. O.,
C     and Seinfeld, J. H.: Organic aerosol formation from the reactive
C     uptake of isoprene epoxydiols (IEPOX) onto non-acidified inorganic
C     seeds, Atmos. Chem. Phys., 14, 3497-3510,
C     doi:10.5194/acp-14-3497-2014, 2014.
C 
C  revision history:
C    who        when           what
C  ---------  --------  -------------------------------------
C  S.Roselle  08/15/97  code written for Models-3
C  J.Gipson   06/18/01  added Henry's Law constants 50-55 for saprc99
C  W.Hutzell  07/03/01  added Henry's Law constants 56-57 for Atrazine
C                       and the daughter products from Atrazine and OH
C                       reactions.
C  J.Gipson.  09/06/02  added Henry's Law constants 59-73   for toxics
C  S.Roselle  11/07/02  added capability for calculating the effective
C                       Henry's law constant and updated coefficients
C                       in Henry's law constant table
C  J.Gipson   08/06/03  added Henry's Law constants 77-79
C  G.Sarwar   11/21/04  added constants for chlorine chemistry (Henry's
C                       law constants 80-85 and dissociation constants
C                       14-16
C  R.Bullock  07/05/05  added Henry's Law constants 86-87 for mercury 
C                       with enthalpy calculated from cited laboratory 
C                       data fit to an Arrhenius equation
C  W.Hutzell  02/14/06  added HLC 88 to 116, dissociation constant for
C                       17 (hydrazine)
C  A.Carlton  09/20/06  updated Henry's Law constants for 1,7,19,20,21,30 
C                       O3, NO3, hexane, octane, nonane, methanol and
C                       isoprene reference
C  S.Roselle  10/10/07  changed pointers to parameters; reformatted
C                       variable declarations
C  W.Hutzell  03/07/08  added Henry's Law constants for 117 to 120
C  W.Hutzell  01/01/09  added Henry's Law constants for 121 to 125 for
C                       for SAPRC07T mechanism                 
C  Y.Xie      6/11/10  added Henry's Law constants for 126 to 130 for 
C                       isoprene chemistry in SAPRC07               
C  S.Roselle  03/01/11  replaced I/O API include files with UTILIO_DEFN;
C                       removed deprecated TRIMLEN
C  W.Hutzell  08/16/12  updated IOAPI and Henry Constant names to V5.01
C                       standards
C  W.Hutzell  01/30/13  updated PHENOL, and add values for CATECHOL and
C                       XYLENOL
C  H.Pye      02/05/13  added Henry's Law 133-134 for IEPOX and IMAE
C  G.Sarwar   12/18/13  added Henry's Law constants for 135 to 140
C  W.Hutzell  07/11/14  correct error in DATA from last revision
C  D.Luecken  07/11/14  added 141 through 144 for nitrates
C  H.Pye      05/05/15  added monoterpene and isoprene nitrates
C  H.Pye      01/26/2016 added SOA SVOCs
C  G.Sarwar   03/24/15  added iodine and bromine species
C  H.Pye      05/31/16  updated IEPOX H-law from 2.7e6 to 3.0e7 M/atm
C                       to reflect Nguyen et al. 2014.
C  W.Hutzell  09/16/16  1) removed HCHO dissociation because its henry's
C                        constant already accounts for the effect.
C                       2) added henry's constant for compounds 194 thru
C                        199 representing several toxic air pollutants
C  
C  D. Luecken 09/21/2016 
C       1. added HAPs in 194-200; 
C       2. modified existing HEXANE (19),N-HEXANE (117), and STYRENE (119); 
C       3. removed dissociation  calculation for formaldedhyde because the listed value 
C          is already an effective rate (Sander ACP, 2015, note 187)
C       4. added dissociation constant for acrylic acid (LACRYACID) (via B. Hutzell)
C  H.Pye       06/2017  added semivolatile monoterpene products
C  G.Sarwar    08/2018  added Henry's Law constant for ClNO3, FMBR, IBR, and updated iodine and bromine species
C  G. Sarwar   11/2018  added Henry's Law constant for CLO
C  H.Pye       09/2021 added CRACMM emission weighted surrogates
C-----------------------------------------------------------------------

      USE UTILIO_DEFN

      IMPLICIT NONE

C...........ARGUMENTS and their descriptions

      INTEGER, INTENT ( IN ) :: ISUB       ! index in SUBNAME array
      REAL,    INTENT ( IN ) :: TEMP       ! temperature (K)
      LOGICAL, INTENT ( IN ) :: EFFECTIVE  ! true=compute the effective henry's law constant
      REAL,    INTENT ( IN ) :: HPLUS      ! hydrogen ion concentration (mol/l)

C...........SCRATCH LOCAL VARIABLES and their descriptions:

      CHARACTER( 16 ), SAVE :: PNAME = 'HLCONST'  ! program name
      CHARACTER( 120 ) :: XMSG = ' '    ! exit status message string

      REAL          HPLUSI              ! 1 / HPLUS
      REAL          HPLUS2I             ! 1 / HPLUS**2
      REAL          CLMINUS             ! chlorine ion conc [CL-]
      REAL          CLMINUSI            ! 1 / CLMINUS
      REAL          TFAC                ! (298-T)/(T*298)
      REAL          AKEQ1               ! temp var for dissociation constant
      REAL          AKEQ2               ! temp var for dissociation constant
      REAL          OHION               ! OH ion concentration
      REAL          KH                  ! temp var for henry's law constant

C-----------------------------------------------------------------------

C...error if index out of range in table

      IF ( ISUB .LE. 0 .OR. ISUB .GT. MXSPCS ) THEN
        WRITE( XMSG, '(A,I4,A)' ) ' index ', ISUB, ' out of range in Henry''s'//
     &         ' Law Constant table in routine HLCONST'
        CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF

C...compute the Henry's Law Constant

      TFAC = ( 298.0 - TEMP) / ( 298.0 * TEMP )
      KH = A( ISUB ) * EXP( E( ISUB ) * TFAC )
      HLCONST = KH

C...compute the effective Henry's law constants

      IF ( EFFECTIVE ) THEN

        IF ( HPLUS .LE. 0.0 ) THEN
          XMSG = 'Negative or Zero [H+] concentration specified ' //
     &           'in HLCONST '
          CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT2 )
        END IF

        HPLUSI = 1.0 / HPLUS
        HPLUS2I = HPLUSI * HPLUSI

C...assign a value for clminus.  use 2.0 mM based on Lin and Pehkonen, 1998, JGR

        CLMINUS   = 2.0E-03                ! chloride ion conc [CL-]
        CLMINUSI  = 1.0 / CLMINUS          ! 1 / CLMINUS

        IF ( ISUB .EQ. HLC_SO2 ) THEN         !   SO2H2O <=> HSO3- + H+
                                           ! & HSO3- <=> SO3= + H+

          AKEQ1 = B( MSO2 )  * EXP( D( MSO2 )  * TFAC )
          AKEQ2 = B( MHSO3 ) * EXP( D( MHSO3 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI + AKEQ1 * AKEQ2 * HPLUS2I )

        ELSE IF ( ISUB .EQ. HLC_HNO2 ) THEN   ! HNO2(aq) <=> NO2- + H+

          AKEQ1 = B( MHNO2 ) * EXP( D( MHNO2 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_HNO3 ) THEN   ! HNO3(aq) <=> NO3- + H+

          AKEQ1 = B( MHNO3 ) * EXP( D( MHNO3 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_CO2 ) THEN    !   CO2H2O <=> HCO3- + H+
                                              ! & HCO3- <=> CO3= + H+

          AKEQ1 = B( MCO2 )  * EXP( D( MCO2 )  * TFAC )
          AKEQ2 = B( MHCO3 ) * EXP( D( MHCO3 ) * TFAC )
          HLCONST = KH
     &            * ( 1.0 + AKEQ1 * HPLUSI + AKEQ1 * AKEQ2 * HPLUS2I )

        ELSE IF ( ISUB .EQ. HLC_H2O2 ) THEN   ! H2O2(aq) <=> HO2- + H+

          AKEQ1 = B( MH2O2 ) * EXP( D( MH2O2 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_HCOOH ) THEN  ! HCOOH(aq) <=> HCOO- + H+

          AKEQ1 = B( MHCOOH ) * EXP( D( MHCOOH ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_HO2 ) THEN    ! HO2(aq) <=> H+ + O2-

          AKEQ1 = B( MHO2 ) * EXP( D( MHO2 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_NH3 ) THEN    ! NH4OH <=> NH4+ + OH-

          AKEQ1 = B( MNH4OH ) * EXP( D( MNH4OH ) * TFAC )
          AKEQ2 = B( MH2O ) * EXP( D( MH2O ) * TFAC )
          OHION = AKEQ2 * HPLUSI
          HLCONST = KH * ( 1.0 + AKEQ1 / OHION )

        ELSE IF ( ISUB. EQ. HLC_HYDRAZINE ) THEN ! HYDRAZINE <=> HYDRAZINE+ + OH-

          AKEQ1 = B( MHYDRAZINE ) * EXP( D( MHYDRAZINE ) * TFAC )
          AKEQ2 = B( MH2O ) * EXP( D( MH2O ) * TFAC )
          OHION = AKEQ2 * HPLUSI
          HLCONST = KH * ( 1.0 + AKEQ1 / OHION )

        ELSE IF ( ISUB. EQ. HLC_ATRA .OR. 
     &            ISUB .EQ. HLC_DATRA ) THEN  !     ATRA(aq)  <=>  ATRA- + H
                                              !  or DATRA(aq) <=> DATRA- + H

          AKEQ1   = B( MATRA ) * EXP( D( MATRA ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_CL2 ) THEN    ! CL2*H2O <=> HOCL + H + CL
                                              ! HOCL <=>H + OCL

          AKEQ1   = B( MCL2 )  * EXP( D( MCL2 ) * TFAC )
          AKEQ2   = B( MHOCL ) * EXP( D( MHOCL ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI * CLMINUSI
     &            + AKEQ1 * AKEQ2 * HPLUS2I * CLMINUSI )

        ELSE IF ( ISUB .EQ. HLC_HCL ) THEN    ! HCL <=> H+ + CL-

          AKEQ1   = B( MHCL ) * EXP( D( MHCL ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_HOCL ) THEN   ! HOCL <=> H+ + OCL-

          AKEQ1   = B( MHOCL ) * EXP( D( MHOCL ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_HBR ) THEN    ! HBR <=> H+ + BR-

          AKEQ1   = B( MHBR ) * EXP( D( MHBR ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_HI ) THEN     ! HI <=> H+ + I-

          AKEQ1   = B( MHI ) * EXP( D( MHI ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_ACRYACID ) THEN ! CH3C(O)OH <=> H + CH3C(O)O 

          AKEQ1   = B( MACRYACID ) * EXP( D( MACRYACID ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_PAF )  THEN    ! PAF <=> H+ + R(O)O-

          AKEQ1   = B( MPAF ) * EXP( D( MPAF ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_PMPF )  THEN   ! PMPF <=> H+ + R(O)O-

          AKEQ1   = B( MPMPF ) * EXP( D( MPMPF ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_TAF2 )  THEN  ! TAF2 <=> H+ + R(O)O-

          AKEQ1   = B( MTAF2 ) * EXP( D( MTAF2 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_HFPODA ) THEN     ! HFPODA <=> H+ + R(O)O-

          AKEQ1   = B( MHFPODA ) * EXP( D( MHFPODA ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_COF2 ) THEN     ! COF2 <=> H+ + R(O)O-

          AKEQ1   = B( MCOF2 ) * EXP( D( MCOF2 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_PEPF ) THEN     ! PEPF <=> H+ + R(O)O-

          AKEQ1   = B( MPEPF ) * EXP( D( MPEPF ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_DA ) THEN     ! DA <=> H+ + R(O)O-

          AKEQ1   = B( MDA ) * EXP( D( MDA ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_HFPOTA ) THEN     ! HFPOTA <=> H+ + R(O)O-

          AKEQ1   = B( MHFPOTA ) * EXP( D( MHFPOTA ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_TAF ) THEN     ! TAF <=> H+ + R(O)O-

          AKEQ1   = B( MTAF ) * EXP( D( MTAF ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_MA ) THEN     ! MA <=> H+ + R(O)O-

          AKEQ1   = B( MMA ) * EXP( D( MMA ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_FCOOH ) THEN     ! FCOOH <=> H+ + R(O)O-

          AKEQ1   = B( MFCOOH ) * EXP( D( MFCOOH ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        ELSE IF ( ISUB .EQ. HLC_PFMOAA ) THEN   ! PFMOAA <=> H+ + R(O)O-

          AKEQ1   = B( MPFMOAA ) * EXP( D( MPFMOAA ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )


        END IF 

      END IF  ! EFFECTIVE

      RETURN
      END

      END MODULE HLCONST_MOD

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/init/yamo/diffmsg.F,v 1.4 2011/10/21 16:11:23 yoj Exp $ 

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

       SUBROUTINE DIFFMSG ( VNAME, INT1, INT2 )

C----------------------------------------------------------------------
C Function: To write message for inconsistency between two values
 
C Preconditions: None
 
C Key Subroutines/ unctions Called:
 
C Revision History: Prototype created by Jerry Gipson, September, 1997
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   04 Apr 11 S.Roselle: updated string blank space removal to use
C                        fortran intrinsic functions
 
C----------------------------------------------------------------------

      USE UTILIO_DEFN

      IMPLICIT NONE 

C..INCLUDES: None
     
C..ARGUMENTS:
      CHARACTER(*) VNAME        ! Variable Name
      CHARACTER(*) STR1         ! Value of character variable 1
      CHARACTER(*) STR2         ! Value of character variable 2
      
      INTEGER  INT1         ! Value of integer variable 1
      INTEGER  INT2         ! Value of integer variable 2

C..PARAMETERS: None

C..EXTERNAL FUNCTIONS: None

C..SAVED LOCAL VARIABLES: None
      
C..SCRATCH LOCAL VARIABLES:
      CHARACTER( 80 ) MSG
      CHARACTER( 20 ) CHR1      ! Value of variable 1 in character data
      CHARACTER( 20 ) CHR2      ! Value of variable 1 in character data

C----------------------------------------------------------------------

         ENTRY INTDIFF ( VNAME, INT1, INT2 )
         WRITE( CHR1, 94020 ) INT1
         WRITE( CHR2, 94020 ) INT2
         MSG = '    Inconsistent values for '
     &       // TRIM( ADJUSTL( VNAME ) ) // ': '
     &       // TRIM( ADJUSTL( CHR1  ) ) // ' versus '
     &       // TRIM( ADJUSTL( CHR2  ) )
         CALL M3MESG( MSG )
         RETURN

         ENTRY CHRDIFF ( VNAME, STR1, STR2 )
         MSG = '    Inconsistent values for '
     &       // TRIM( ADJUSTL( VNAME ) ) // ': '
     &       // TRIM( ADJUSTL( STR1  ) ) // ' versus '
     &       // TRIM( ADJUSTL( STR2  ) )
         CALL M3MESG( MSG )
         RETURN

94020    FORMAT(I20)
         END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_WRTPADEFN

C-----------------------------------------------------------------------
 
C Function: To write the Models-3 Process Analysis Control PA_DEFN module 
 
C Preconditions: Requires mechanism to have been processed
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified Jan, 2006 by J. Young I couldn't resist the temptation to F90-ize the output
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI's M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
      USE UTILIO_DEFN
      USE PA_VARS, Only: TDATOUT
      USE PA_IPRVARS, Only: MAXIPROUT
      USE PA_PARSE
      USE PA_DEFN

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables:

!     CHARACTER(  1 ) :: DOT = '.'  ! Dot character
      CHARACTER(  1 ) :: DIT = '='  ! Dit character
      CHARACTER( 72 ) :: DELIM      ! Delimiter line output
      CHARACTER( 72 ) :: CEES       ! Line of 'c's
      CHARACTER( 80 ) :: LINOUT     ! Output line

      INTEGER IOUT            ! Unit number for include file
      INTEGER N               ! Loop index
         
      INTEGER MXCGRIDD        ! Dimension for number of familys for PA
      INTEGER MXNIRRRXNSD     ! Dimension parameter for MXNIRRRXNS
      INTEGER MXTEMPTRMSD     ! Dimension parameter for MXTEMPTRMS
      INTEGER NIRRVARD        ! Dimension of IRR output variables
      INTEGER N_IPR_SPCD      ! Dimension statement for no. of PA species
      INTEGER NIPRVARD        ! Dimension of PA output variables
      INTEGER NUMTEMPSD       ! Dimension for number of temp IRRs
      INTEGER NUMOUTPOSD      ! Dimension parameter for NUMOUTPOS
      INTEGER NUMOUTNEGD      ! Dimension parameter for NUMOUTNEG
      INTEGER NUMOUTINDD      ! Dimension parameter for NUMOUTIND

      CHARACTER(  7 ) :: BUF6 ( MAXIPROUT )  ! 6-Character buffer
      CHARACTER( 13 ) :: BUF12( MAXIPROUT )  ! 12-Character buffer
      CHARACTER( 21 ) :: BUF20( MAXIPROUT )  ! 20-Character buffer

      INTEGER :: MAXCNT = 99  ! Maximum number of continuation lines
      INTEGER NHI             ! Highest index of loop
      INTEGER NIRR            ! IRR loop index
      INTEGER NLO             ! Lowest index of loop
      INTEGER NPA             ! IPR species loop index
      INTEGER NS              ! Loop index for sets of data statments
      INTEGER NSETS           ! Number of sets of data statements to write

C-----------------------------------------------------------------------

      DO N = 1, 72
         DELIM( N:N ) = DIT
         CEES( N:N ) = 'c'
      END DO     
      DELIM( 1:1 ) = 'C'

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Open and Control Include file and write the header data
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IOUT = JUNIT(  )
      OPEN( UNIT = IOUT, FILE = 'PA_DEFN_REPORT' )
      WRITE( IOUT, 94000 ) DELIM( 1:72 )
      LINOUT = '      MODULE PA_DEFN'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      WRITE( IOUT, 94000 ) LINOUT( 1:1 )
      LINOUT = 'C Contains: Control parameters for Process Analysis'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      WRITE( IOUT, 94000 ) LINOUT( 1:1 )
      LINOUT = 'C Dependent On: Mechanism Input file'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      WRITE( IOUT, 94000 ) LINOUT( 1:1 )
      LINOUT = 'C Created By: Process Analysis Control Program'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      LINOUT = 'C           ' // TDATOUT
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      LINOUT = ''
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write the control parameters
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 94020 )
      WRITE( IOUT, 94040 )      
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )

c..LIPR -- for integrated process rates
      IF ( N_IPR_SPC .GT. 0 ) THEN
         WRITE( IOUT, 94080 )
      ELSE
         WRITE( IOUT, 94100 )
      END IF

c..LIRR -- for integrated reaction rates     
      IF ( LFULLIRR .OR. LPARTIRR ) THEN
         WRITE( IOUT, 94140 )
      ELSE
         WRITE( IOUT, 94160 )
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write messages about array dimensioning if needed
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( .NOT. LIRR ) THEN
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 95020 )
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 94000 )
      END IF

      IF ( .NOT. LIPR ) THEN
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 95040 )
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 94000 ) 
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write output file variables 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95120 ) 
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95140 ) 
      WRITE( IOUT, 94000 ) CEES
      NIPRVARD = MAX( NIPRVAR, 1 )
      NIRRVARD = MAX( NIRRVAR, 1 )
      WRITE( IOUT, 95160 ) NIPRVAR, NIPRVARD
      WRITE( IOUT, 95180 ) NIRRVAR, NIRRVARD
      WRITE( IOUT, 95200 )
 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write integrated process rate variables 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95260 ) 
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95280 ) 
      WRITE( IOUT, 94000 ) CEES

      N_IPR_SPCD  = MAX( N_IPR_SPC, 1 )
      MXCGRIDD    = MAX( MXCGRID, 1 )

      WRITE( IOUT, 95300 ) NPRCS,
     &                     N_IPR_SPC, N_IPR_SPCD,
     &                     MXCGRID, MXCGRIDD
      WRITE( IOUT, 95320 )
      LINOUT = ''
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write integrated reaction rate variables 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95360 ) 
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95380 ) 
      WRITE( IOUT, 94000 ) CEES

      IF ( LFULLIRR ) THEN
         WRITE( IOUT, 95420 )
      ELSE
         WRITE( IOUT, 95440 )
      END IF

      IF ( LPARTIRR ) THEN
         WRITE( IOUT, 95480 )
      ELSE
         WRITE( IOUT, 95500 )
      END IF

!     IF ( .NOT. LPARTIRR ) THEN
!        NUMTEMPS   = 0
!        NUMOUTPOS  = 0
!        NUMOUTNEG  = 0
!        NUMOUTIND  = 0
!        MXNIRRRXNS = 0
!        MXTEMPTRMS = 0
!     END IF

      NUMTEMPSD    = MAX( NUMTEMPS,   1 )
      NUMOUTPOSD   = MAX( NUMOUTPOS,  1 )
      NUMOUTNEGD   = MAX( NUMOUTNEG,  1 )
      NUMOUTINDD   = MAX( NUMOUTIND,  1 )
      MXNIRRRXNSD  = MAX( MXNIRRRXNS, 1 )
      MXTEMPTRMSD  = MAX( MXTEMPTRMS, 1 )

      WRITE( IOUT, 95520 ) NUMTEMPS, NUMTEMPSD,
     &                     NUMOUTPOS, NUMOUTPOSD,
     &                     NUMOUTNEG, NUMOUTNEGD,
     &                     NUMOUTIND, NUMOUTINDD,
     &                     MXNIRRRXNS, MXNIRRRXNSD,
     &                     MXTEMPTRMS, MXTEMPTRMSD

      IF ( NIRRVAR .NE. 0 ) THEN
         WRITE( IOUT, 95542 )
      ELSE 
         WRITE( IOUT, 95544 )
      END IF

      WRITE( IOUT, 95580 )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write monocode extensions (declarations and common block) and end
c  line and return
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( .NOT. LIPR .AND. .NOT. LIRR ) THEN
         WRITE( IOUT, 96110 )
         GO TO 999
      END IF         

C-----------------------------------------------------------------------
      LINOUT = ''
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      LINOUT = 'C Initialize variable arrays via DATA stmts.'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write data statements for output file variables
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 96120 ) 
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 96200 ) 
 
      IF ( NIPRVAR .GT. 0 ) THEN
         NSETS = ( ( NIPRVAR - 1 ) / ( 3 * MAXCNT ) ) + 1
         write( *,* ) 'n IPR var nsets 1: ', nsets
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( 3 * MAXCNT ) + 1
            NHI = MIN( ( NS * 3 * MAXCNT ), NIPRVAR )
            write( *,* ) 'n IPR var nlo nhi: ', nlo, nhi
            WRITE( IOUT, 96220 ) NLO,  NHI
            DO NPA = NLO, NHI
               BUF20( NPA ) = ' "' // IPRNAME( NPA ) // '",'
            END DO
            BUF20( NHI )( 20:21 ) = ' /'
            call listout( NLO, NHI, 3, IOUT, BUF20 )
         END DO

         NSETS = ( ( NIPRVAR - 1 ) / MAXCNT ) + 1
         write( *,* ) 'n IPR var nsets 2: ', nsets
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( MAXCNT ) + 1
            NHI = MIN( ( NS * MAXCNT ), NIPRVAR )         
            write( *,* ) 'n IPR var nlo nhi: ', nlo, nhi
            WRITE( IOUT, 96240 ) NLO,  NHI
            DO NPA = NLO, NHI
               LINOUT = '     &  "' // IPRDESC( NPA ) // '",'
               IF ( NPA .EQ. NHI ) LINOUT( 71:71 ) = '/'
               WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
            END DO
         END DO
      END IF

      IF ( NIRRVAR .GT. 0 ) THEN
         NSETS = ( ( NIRRVAR - 1 ) / ( 3 * MAXCNT ) ) + 1
         write( *,* ) 'n IRR var nsets 1: ', nsets
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( 3 * MAXCNT ) + 1
            NHI = MIN( ( NS * 3 * MAXCNT ), NIRRVAR )
            write( *,* ) 'n IRR var nlo nhi: ', nlo, nhi
            WRITE( IOUT, 96260 ) NLO, NHI
            DO NIRR = NLO, NHI
               BUF20( NIRR ) = ' "' // IRRNAME( NIRR ) // '",'
            END DO
            BUF20( NHI )( 20:21 ) = ' /'
            call listout( NLO, NHI, 3, IOUT, BUF20 )
         END DO

         NSETS = ( ( NIRRVAR - 1 ) / MAXCNT ) + 1
         write( *,* ) 'n IRR var nsets 2: ', nsets
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( MAXCNT ) + 1
            NHI = MIN( ( NS * MAXCNT ), NIRRVAR )         
            write( *,* ) 'n IRR var nlo nhi: ', nlo, nhi
            WRITE( IOUT, 96280 ) NLO,  NHI
            DO NIRR = NLO, NHI
               LINOUT = '     &  "' // IRRDESC( NIRR ) // '",'
               IF ( NIRR .EQ. NHI ) LINOUT( 71:71 ) = '/'
               WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
            END DO
         END DO
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write data statements for integrated Process rate variables
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LIPR ) THEN
         WRITE( IOUT, 94000 ) ''
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 96140 ) 
         WRITE( IOUT, 94000 ) CEES

         NSETS = ( ( NPRCS - 1 ) / ( 3 * MAXCNT ) ) + 1
         DO NS = 1,  NSETS
            NLO = ( NS - 1 ) * ( 3 * MAXCNT ) + 1
            NHI = MIN( ( NS * 3 * MAXCNT ),  NPRCS )         
            WRITE( IOUT, 96290 ) NLO, NHI
            DO NPA = NLO, NHI
               BUF20( NPA ) = ' "' // PROCNAME( NPA ) // '",' 
            END DO
            BUF20( NHI )( 20:21 ) = ' /'
            call listout( NLO, NHI, 3, IOUT, BUF20 )
         END DO
      END IF

      IF ( N_IPR_SPC .GT. 0 ) THEN
         NSETS = ( ( N_IPR_SPC - 1 ) / ( 10 * MAXCNT ) ) + 1
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
            NHI = MIN( ( NS * 10 * MAXCNT ), N_IPR_SPC )         
            WRITE( IOUT, 96300 ) NLO, NHI
            DO NPA = NLO,  NHI
               WRITE( BUF6( NPA ), "( I5, ',' )" ) NCGRID( NPA )
            END DO
            BUF6( NHI )( 6:7 ) = ' /'
            call listout( NLO, NHI, 10, IOUT, BUF6 )
         END DO
      END IF

      IF ( N_IPR_SPC .GT. 0 ) THEN
         DO NPA = 1, NIPRVAR
            NSETS = ( ( NPRCS - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NPRCS )         
               WRITE( IOUT, 96340 ) NPA, NLO, NHI
               DO N = NLO,  NHI
                  WRITE( BUF6( N ), 96080 ) MASK_IPR_PROC( NPA, N )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO 
         END DO
      END IF 

      IF ( N_IPR_SPC .GT. 0 ) THEN
         DO NPA = 1, N_IPR_SPC
            NSETS = ( ( NCGRID( NPA ) - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ),  NCGRID( NPA ) )         
               WRITE( IOUT, 96360 ) NPA, NLO, NHI
               DO N = NLO, NHI
                  WRITE( BUF6( N ), 96080 ) MAP_IPRtoCGRID( NPA, N )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO 
         END DO
      END IF

      IF ( N_IPR_SPC .GT. 0 ) THEN
         DO NPA = 1, N_IPR_SPC
            NSETS = ( ( NCGRID( NPA ) - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NCGRID( NPA ) )         
               WRITE( IOUT, 96380 ) NPA,  NLO,  NHI
               DO N = NLO, NHI
                  WRITE( BUF6( N ), 96080 ) MAP_IPRtoSAVE( NPA, N )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO 
         END DO
      END IF

      IF ( LIPR ) THEN
         NSETS = ( ( NPRCS - 1 ) / ( 5 * MAXCNT ) ) + 1
         DO NS = 1,  NSETS
            NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
            NHI = MIN( ( NS * 5 * MAXCNT ), NPRCS )         
            WRITE( IOUT, 96400 ) NLO,  NHI
            DO N = NLO, NHI
               IF ( ANY( MASK_IPR_PROC( :,N )) ) THEN
                  BUF12( N ) = '     .TRUE., '
               ELSE
                  BUF12( N ) = '    .FALSE., '
               END IF
            END DO
            BUF12( NHI )( 12:13 ) = ' /'  
            call listout( NLO, NHI, 5, IOUT, BUF12 )
         END DO
      END IF

      IF ( N_IPR_SPC .GT. 0 ) THEN
         DO NPA = 1, N_IPR_SPC
            NSETS = ( ( NCGRID( NPA ) - 1 ) / ( 5 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
               NHI = MIN( ( NS * 5 * MAXCNT ), NCGRID( NPA ) )         
               WRITE( IOUT, 96420 ) NPA, NLO, NHI
               DO N = 1,  NCGRID( NPA )
                  WRITE( BUF12( N ), 96100 ) SPCOEF( NPA,  N )
               END DO
               BUF12( NHI )( 12:13 ) = ' /'
               WRITE( IOUT, 96060 ) ( BUF12( N ), N = NLO, NHI )
            END DO 
         END DO
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write data statements for IRR variables
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LPARTIRR ) THEN
         WRITE( IOUT, 94000 )
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 96160 ) 
         WRITE( IOUT, 94000 ) CEES

         IF ( NIRRVAR .GT. 0 ) THEN
            NSETS = ( ( NIRRVAR - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NIRRVAR )         
               WRITE( IOUT, 96440 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) NIRRRXNS( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF     

         IF ( NUMTEMPS .GT. 0 ) THEN
            NSETS = ( ( NUMTEMPS - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ),  NUMTEMPS )         
               WRITE( IOUT, 96460 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) TEMPTERMS( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF     
 
         IF ( NUMOUTPOS .GT. 0 ) THEN
            NSETS = ( ( NUMOUTPOS - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN(  ( NS * 10 * MAXCNT ),  NUMOUTPOS )         
               WRITE( IOUT, 96480 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) TEMPOUTPOS( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF 
             
         IF ( NUMOUTNEG .GT. 0 ) THEN
            NSETS = ( ( NUMOUTNEG - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ),  NUMOUTNEG )         
               WRITE( IOUT, 96500 ) NLO,  NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) TEMPOUTNEG( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF 

         IF ( NUMOUTIND .GT. 0 ) THEN
            NSETS = ( ( NUMOUTIND - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NUMOUTIND )         
               WRITE( IOUT, 96520 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) TEMPOUTIND( NIRR )
              END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF 

         IF ( NUMOUTPOS .GT. 0 ) THEN
            NSETS = ( ( NUMOUTPOS - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NUMOUTPOS )         
               WRITE( IOUT, 96540 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) INDXOUTPOS( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF 

         IF ( NUMOUTNEG .GT. 0 ) THEN
            NSETS = ( ( NUMOUTNEG - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NUMOUTNEG )       
               WRITE( IOUT, 96560 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) INDXOUTNEG( NIRR )
              END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF 

         IF ( NUMOUTIND .GT. 0 ) THEN
            NSETS = ( ( NUMOUTIND - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NUMOUTIND )       
               WRITE( IOUT, 96580 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) INDXOUTIND( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF

         IF ( NIRRVAR .GT. 0 ) THEN
            DO NIRR = 1, NIRRVAR
               IF ( NIRRRXNS( NIRR ) .GT. 0 ) THEN
                  NSETS = ( ( NIRRRXNS( NIRR ) - 1 ) / ( 10 * MAXCNT ) ) + 1
                  DO NS = 1,  NSETS
                     NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
                     NHI = MIN( ( NS * 10 * MAXCNT ), NIRRRXNS( NIRR ) )         
                     WRITE( IOUT, 96600 ) NIRR, NLO, NHI
                     DO N = NLO, NHI
                        WRITE( BUF6( N ), 96080 ) IRRRXN( NIRR, N )
                     END DO
                     BUF6( NHI )( 6:7 ) = ' /'
                     call listout( NLO, NHI, 10, IOUT, BUF6 )
                  END DO
               END IF 
            END DO
         END IF

         IF ( NUMTEMPS .GT. 0 ) THEN
            DO NIRR= 1, NUMTEMPS
               IF ( TEMPTERMS( NIRR ) .GT. 0 ) THEN
                  NSETS = ( ( TEMPTERMS( NIRR ) - 1 ) / ( 10 * MAXCNT ) ) + 1
                  DO NS = 1, NSETS
                     NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
                     NHI = MIN( ( NS * 10 * MAXCNT ), TEMPTERMS( NIRR ) )         
                     WRITE( IOUT, 96620 ) NIRR,  NLO,  NHI
                     DO N = NLO, NHI
                        WRITE( BUF6( N ), 96080 ) TEMPRXN( NIRR, N )
                     END DO
                     BUF6( NHI )( 6:7 ) = ' /'
                     call listout( NLO, NHI, 10, IOUT, BUF6 )
                  END DO
               END IF
            END DO
         END IF

         IF ( NUMOUTPOS .GT. 0 ) THEN
            NSETS = ( ( NUMOUTPOS - 1 ) / ( 5 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
               NHI = MIN( ( NS * 5 * MAXCNT ), NUMOUTPOS )         
               WRITE( IOUT, 96640 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF12( NIRR ), 96100 ) COEFOUTPOS( NIRR )
               END DO
               BUF12( NHI )( 12:13 ) = ' /'
!              WRITE( IOUT, 96060 ) ( BUF12( NIRR ), NIRR = NLO, NHI )
               call listout( NLO, NHI, 5, IOUT, BUF12 )
            END DO
         END IF

         IF ( NUMOUTNEG .GT. 0 ) THEN
            NSETS = ( ( NUMOUTNEG - 1 ) / ( 5 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
               NHI = MIN( ( NS * 5 * MAXCNT ), NUMOUTNEG )         
               WRITE( IOUT, 96660 ) NLO,  NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF12( NIRR ), 96100 ) COEFOUTNEG( NIRR )
               END DO
               BUF12( NHI )( 12:13 ) = ' /'
!              WRITE( IOUT, 96060 ) ( BUF12( NIRR ), NIRR = NLO, NHI )
               call listout( NLO, NHI, 5, IOUT, BUF12 )
            END DO
         END IF

         IF ( NUMOUTIND .GT. 0 ) THEN
            NSETS = ( ( NUMOUTIND - 1 ) / ( 5 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
               NHI = MIN( ( NS * 5 * MAXCNT ), NUMOUTIND )         
               WRITE( IOUT, 96680 ) NLO,  NHI
               DO NIRR = NLO, NHI
                 WRITE( BUF12( NIRR ), 96100 ) COEFOUTIND( NIRR )
               END DO
               BUF12( NHI )( 12:13 ) = ' /'
!              WRITE( IOUT, 96060 ) ( BUF12( NIRR ), NIRR = NLO, NHI )
               call listout( NLO, NHI, 5, IOUT, BUF12 )
            END DO
         END IF

         IF ( NUMTEMPS .GT. 0 ) THEN
            DO NIRR= 1, NUMTEMPS
               IF ( TEMPTERMS( NIRR ) .GT. 0 ) THEN
                  NSETS = ( ( TEMPTERMS( NIRR ) - 1 ) / ( 5 * MAXCNT ) ) + 1
                  DO NS = 1, NSETS
                     NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
                     NHI = MIN(  ( NS * 5 * MAXCNT ), TEMPTERMS( NIRR ) )         
                     WRITE( IOUT, 96700 ) NIRR, NLO, NHI
                     DO N = NLO, NHI
                        WRITE( BUF12( N ), 96100 ) TEMPCOEF( NIRR, N )
                     END DO
                     BUF12( NHI )( 12:13 ) = ' /'
!                    WRITE( IOUT, 96060 ) ( BUF12( N ), N = NLO, NHI )
                     call listout( NLO, NHI, 5, IOUT, BUF12 )
                 END DO
               END IF 
            END DO
         END IF

         IF ( NIRRVAR .GT. 0 ) THEN
            DO NIRR = 1, NIRRVAR
               IF ( NIRRRXNS( NIRR ) .GT. 0 ) THEN
                  NSETS = ( ( NIRRRXNS( NIRR ) - 1 ) / ( 5 * MAXCNT ) ) + 1
                  DO NS = 1, NSETS
                     NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
                     NHI = MIN( ( NS * 5 * MAXCNT ), NIRRRXNS( NIRR ) )         
                     WRITE( IOUT, 96720 ) NIRR,  NLO,  NHI
                     DO N = NLO, NHI
                        WRITE( BUF12( N ), 96100 ) IRRCOEF( NIRR, N )
                     END DO
                     BUF12( NHI )( 12:13 ) = ' /'
!                    WRITE( IOUT, 96060 ) ( BUF12( N ), N = NLO, NHI )
                     call listout( NLO, NHI, 5, IOUT, BUF12 )
                  END DO
               END IF 
            END DO
         END IF
      END IF

999   CONTINUE

      LINOUT = ''
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      LINOUT = '      END MODULE PA_DEFN'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      CLOSE( IOUT )

      RETURN 
     
C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( A )     
94020 FORMAT( 
     & 'c  The following variables are used to control calls to', 
     &     ' the Integrated' /
     & 'c  Process Rate and Integrated Reaction Rate routines:' )
94040 FORMAT( 
     & 'c     LIPR = Flag for calculating Integrated Process Rates' /
     & 'c     LIRR = Flag for calculating Integrated Reaction Rates' )
94080 FORMAT(   6X, 'LOGICAL, PARAMETER :: LIPR = .TRUE.' / )
94100 FORMAT(   6X, 'LOGICAL, PARAMETER :: LIPR = .FALSE.' / )
94140 FORMAT(   6X, 'LOGICAL, PARAMETER :: LIRR = .TRUE.' / )
94160 FORMAT(   6X, 'LOGICAL, PARAMETER :: LIRR = .FALSE.' / )

C----------------------- FORMAT Statements -----------------------------

95020 FORMAT( 
     & 'c  Integrated Reaction Rates are not being computed.  All',
     &     ' associated'/
     & 'c  arrays will be set to the smallest possible dimension.' )

95040 FORMAT( 
     & 'c  Integrated Process Rates are not being computed.  All',
     &     ' associated'/
     & 'c  arrays will be set to the smallest possible dimension.' )

95120 FORMAT( 
     &'c  The following variables are used in the output file ', 
     &      'descriptions' )
95140 FORMAT( 
     &'c     NIPRVAR   = Number of IPR output variables'/
     &'c     NIRRVAR   = Number of IRR output variables'/
     &'c     NIPRVARD  = Dimension for IPR output variables'/
     &'c     NIRRVARD  = Dimension for IRR output variables'/
     &'c     IPRNAME   = Name of IPR output variable'/
     &'c     IRRNAME   = Name of IRR output variable'/
     &'c     IPRDESC   = Extended name of IPR output variable'/
     &'c     IRRDESC   = Extended name of IRR output variable' )

95160 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: NIPRVAR =', I4, ',',
     & 2X,                       'NIPRVARD =', I4 )

95180 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: NIRRVAR =', I4, ',',
     & 2X,                       'NIRRVARD =', I4 / )

95200 FORMAT( 
     & 6X, 'CHARACTER( 16 ) :: IPRNAME( NIPRVARD )' /
     & 6X, 'CHARACTER( 60 ) :: IPRDESC( NIPRVARD )' /
     & 6X, 'CHARACTER( 16 ) :: IRRNAME( NIRRVARD )' /
     & 6X, 'CHARACTER( 60 ) :: IRRDESC( NIRRVARD )' / )

95260 FORMAT( 
     & 'c  The following variables are used in the integrated process', 
     &     ' rate '/'c  computations.' )

95280 FORMAT( 
     & 'c    NPRCS      = No. of science processes that can be monitored' /
     & 'c    N_IPR_SPC  = Number of families for IPR' /
     & 'c    MXCGRID    = Max number of CTM species in an IPR family' /
     & 'c    N_IPR_SPCD = Dimension for number of families for IPR' /
     & 'c    MXCGRIDD   = Dimension for MXCGRID' /
     & 'c    NCGRID     = Array of no. of CTM species in an IPR family' /
     & 'c    IPROUT     = Array of IPR output variable indices' /
     & 'c    IPR2GRD    = Array of CTM species indices for IPR families' /
     & 'c    IPR2SAV    = Array of saved species indices for IPR families' /
     & 'c    SV2GRD     = Array of CTM indicies for saved concs' /
     & 'c    SPCOEF     = Array of coefficients for IPR familys' ) 

95300 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: NPRCS      =', I4 /
     & 6X, 'INTEGER, PARAMETER :: N_IPR_SPC  =', I4, ',',
     & 2X,                       'N_IPR_SPCD =', I4 /
     & 6X, 'INTEGER, PARAMETER :: MXCGRID    =', I4, ',',
     & 2X,                       'MXCGRIDD   =', I4 / )

95320 FORMAT( 
     & 6X, 'CHARACTER( 16 ) :: PROCNAME( NPRCS )' /
     & 6X, 'LOGICAL            LPROCOUT( NPRCS )' //
     & 6X, 'INTEGER NCGRID ( N_IPR_SPCD )' /
     & 6X, 'INTEGER IPROUT ( N_IPR_SPCD,NPRCS )' /
     & 6X, 'INTEGER IPR2GRD( N_IPR_SPCD,MXCGRIDD )' /
     & 6X, 'INTEGER IPR2SAV( N_IPR_SPCD,MXCGRIDD )' //
     & 6X, 'REAL    SPCOEF ( N_IPR_SPCD,MXCGRIDD )' )

95360 FORMAT( 
     & 'c  The following variables are used in the integrated reaction', 
     &     ' rate' / 'c  computations.' )

95380 FORMAT( 
     & 'c    LFULLIRR     = Flag for computing IRRs for every reaction' /
     & 'c    LPARTIRR     = Flag for computing IRRs for selected', 
     &                    ' reactions' /
     & 'c    NUMTEMPS     = No. of temporary intermediate IRRs to', 
     &                    ' compute' /
     & 'c    NUMOUTPOS    = No. of temp. IRR terms to add iff the', 
     &                   ' IRR > 0' /
     & 'c    NUMOUTNEG    = No. of temp. IRR terms to add iff the', 
     &                   ' IRR < 0' /
     & 'c    NUMOUTIND    = No. of temp. IRR terms to add regardless', 
     &                   ' of sign' /
     & 'c    MXNIRRRXNS   = Max no. of reaction terms in an output IRR' /
     & 'c    MXTEMPTRMS   = Max no. of reaction terms in a temp. IRR' /
     & 'c    NUMTEMPSD    = Dimension for number of temp IRRs' /
     & 'c    NUMOUTPOSD   = Dimension parameter for NUMOUTPOS' /
     & 'c    NUMOUTNEGD   = Dimension parameter for NUMOUTNEG' /
     & 'c    NUMOUTINDD   = Dimension parameter for NUMOUTIND' /
     & 'c    MXNIRRRXNSD  = Dimension parameter for MXNIRRRXNS' /
     & 'c    MXTEMPTRMSD  = Dimension parameter for MXTEMPTRMS' /
     & 'c    NIRRRXNS     = Vector of no. of reaction terms in an', 
     &                    ' output IRR' /
     & 'c    TEMPTERMS    = Vector of no. of terms in a temporary IRR' /
     & 'c    TEMPOUTPOS   = Vector of no. of IRR terms to add if', 
     &                    ' IRR > 0' /
     & 'c    TEMPOUTNEG   = Vector of no. of IRR terms to add if', 
     &                    ' IRR < 0' /
     & 'c    TEMPOUTIND   = Vector of no. of IRR terms to add', 
     &                    ' regardless of sign' /
     & 'c    INDXOUTPOS   = Vector of indices pointing to IRR output', 
     &                    ' variable' /
     & 'c    INDXOUTNEG   = Vector of indices pointing to IRR output', 
     &                    ' variable' /
     & 'c    INDXOUTIND   = Vector of indices pointing to IRR output', 
     &                    ' variable' /
     & 'c    COEFOUTPOS   = Vector of temp IRR coefficients' /
     & 'c    COEFOUTNEG   = Vector of temp IRR coefficients' /
     & 'c    COEFOUTIND   = Vector of temp IRR coefficients' /
     & 'c    TEMPRXN      = Array of reaction nos. for a temp. IRR' /
     & 'c    IRRRXN       = Array of reaction nos. for an output IRR' /
     & 'c    TEMPCOEF     = Array of reaction coefficients for a', 
     &                    ' temp IRR' /
     & 'c    IRRCOEF      = Array of reaction coefficients for an', 
     &                   ' output IRR' /
     & 'c    IRRSTEP      = Array of output IRRs for one time step' /
     & 'c    IRRBLK       = Array of output IRRs for a block of cells' /
     & 'c    IRROUT       = Array of IRRs to output' ) 

95420 FORMAT( / 6X,  'LOGICAL, PARAMETER :: LFULLIRR = .TRUE.' )
95440 FORMAT( / 6X,  'LOGICAL, PARAMETER :: LFULLIRR = .FALSE.' )  
95480 FORMAT( / 6X,  'LOGICAL, PARAMETER :: LPARTIRR = .TRUE.' )
95500 FORMAT( / 6X,  'LOGICAL, PARAMETER :: LPARTIRR = .FALSE.' ) 

95520 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: NUMTEMPS   =', I4, ',',
     & 2X,                       'NUMTEMPSD   =', I4 /
     & 6X, 'INTEGER, PARAMETER :: NUMOUTPOS  =', I4, ',',
     & 2X,                       'NUMOUTPOSD  =', I4 /
     & 6X, 'INTEGER, PARAMETER :: NUMOUTNEG  =', I4, ',',
     & 2X,                       'NUMOUTNEGD  =', I4 /
     & 6X, 'INTEGER, PARAMETER :: NUMOUTIND  =', I4, ',',
     & 2X,                       'NUMOUTINDD  =', I4 /
     & 6X, 'INTEGER, PARAMETER :: MXNIRRRXNS =', I4, ',',
     & 2X,                       'MXNIRRRXNSD =', I4 /
     & 6X, 'INTEGER, PARAMETER :: MXTEMPTRMS =', I4, ',',
     & 2X,                       'MXTEMPTRMSD =', I4 )

95542 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: BLKSIZED = BLKSIZE' )

95544 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: BLKSIZED = 1' )

95580 FORMAT( /
     & 6X, 'INTEGER NIRRRXNS  ( NIRRVARD )' /
     & 6X, 'INTEGER TEMPTERMS ( NUMTEMPSD )' /
     & 6X, 'INTEGER TEMPOUTPOS( NUMOUTPOSD )' /
     & 6X, 'INTEGER INDXOUTPOS( NUMOUTPOSD )' /
     & 6X, 'INTEGER TEMPOUTNEG( NUMOUTNEGD )' /
     & 6X, 'INTEGER INDXOUTNEG( NUMOUTNEGD )' /
     & 6X, 'INTEGER TEMPOUTIND( NUMOUTINDD )' /
     & 6X, 'INTEGER INDXOUTIND( NUMOUTINDD )' /
     & 6X, 'INTEGER IRRRXN    ( NIRRVARD,MXNIRRRXNSD )' /
     & 6X, 'INTEGER TEMPRXN   ( NUMTEMPSD,MXTEMPTRMSD )' //
     & 6X, 'REAL    COEFOUTPOS( NUMOUTPOSD )' /
     & 6X, 'REAL    COEFOUTNEG( NUMOUTNEGD )' /
     & 6X, 'REAL    COEFOUTIND( NUMOUTINDD )' /
     & 6X, 'REAL    TEMPCOEF  ( NUMTEMPSD,MXTEMPTRMSD )' /
     & 6X, 'REAL    IRRCOEF   ( NIRRVARD,MXNIRRRXNSD )' /
     & 6X, 'REAL    IRRSTEP   ( BLKSIZED,NIRRVARD )' /
     & 6X, 'REAL    IRRBLK    ( BLKSIZED,NIRRVARD )' )
 
C----------------------- FORMAT Statements -----------------------------

96060 FORMAT( 5X, '&  ', 5A13 )
96080 FORMAT( I5, ',' )
96100 FORMAT( F11.4, ',' )
96110 FORMAT( 'c  Neither IPR nor IRR calculations are being done.' /
     &        'c  Additional data are not required' )
96120 FORMAT( 'c  Output file descriptor data' )
96140 FORMAT( 'c  IPR data' )
96160 FORMAT( 'c  IRR data' )
96200 FORMAT( /6X, 'INTEGER TERM' )
96220 FORMAT( /6X, 'DATA ( IPRNAME( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96240 FORMAT( /6X, 'DATA ( IPRDESC( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96260 FORMAT( /6X, 'DATA ( IRRNAME( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96280 FORMAT( /6X, 'DATA ( IRRDESC( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96290 FORMAT( /6X, 'DATA ( PROCNAME( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96300 FORMAT( /6X, 'DATA ( NCGRID( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96320 FORMAT( /6X, 'DATA ( SV2GRD( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96340 FORMAT( /6X, 'DATA ( IPROUT( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96360 FORMAT( /6X, 'DATA ( IPR2GRD( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96380 FORMAT( /6X, 'DATA ( IPR2SAV( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96400 FORMAT( /6X, 'DATA ( LPROCOUT( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96420 FORMAT( /6X, 'DATA ( SPCOEF( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96440 FORMAT( /6X, 'DATA ( NIRRRXNS( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96460 FORMAT( /6X, 'DATA ( TEMPTERMS( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96480 FORMAT( /6X, 'DATA ( TEMPOUTPOS( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96500 FORMAT( /6X, 'DATA ( TEMPOUTNEG( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96520 FORMAT( /6X, 'DATA ( TEMPOUTIND( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96540 FORMAT( /6X, 'DATA ( INDXOUTPOS( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96560 FORMAT( /6X, 'DATA ( INDXOUTNEG( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96580 FORMAT( /6X, 'DATA ( INDXOUTIND( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96600 FORMAT( /6X, 'DATA ( IRRRXN( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96620 FORMAT( /6X, 'DATA ( TEMPRXN( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96640 FORMAT( /6X, 'DATA ( COEFOUTPOS( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96660 FORMAT( /6X, 'DATA ( COEFOUTNEG( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96680 FORMAT( /6X, 'DATA ( COEFOUTIND( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96700 FORMAT( /6X, 'DATA ( TEMPCOEF( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96720 FORMAT( /6X, 'DATA ( IRRCOEF( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )

      contains
C=======================================================================
         subroutine listout ( lo, hi, n_form, iout, buf )

C    format a list and write to iout
C    n_form can be 3, 5, or 10

         integer, intent (in ) :: lo, hi, n_form, iout
         character( * ), intent( in ) :: buf( * )

         character( 80 ) :: linout
         character( 19 ) :: fstr
         integer i, j, k, n, rng, last

         select case ( n_form )
            case(  3 )   ! associated w/ buf20
               fstr = "( 5x, '&  ', 3a21 )"
            case(  5 )   ! associated w/ buf12
               fstr = "( 5x, '&  ', 5a13 )"
            case( 10 )   ! associated w/ buf6
               fstr = "( 5x, '&  ', 10a7 )"
            case default
               write( *,* ) '*** INVALID format ', n_form
               stop
         end select

         rng = hi - lo + 1
         last = mod( rng, n_form )
         i = lo
         do k = 1, rng / n_form
            j = i + n_form - 1
            write( linout, fstr ) ( buf( n ), n = i, j )
            write( iout, '( a )' ) linout( 1:len_trim( linout ) )
            i = j + 1
         end do
         if ( last .gt. 0 ) then
         j = i + last - 1
         write( linout, fstr ) ( buf( n ), n = i, j )
         write( iout, '( a )' ) linout( 1:len_trim( linout ) )
         end if


         end subroutine listout

      END SUBROUTINE PA_WRTPADEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module aq_data

C  Defines gas and aerosol surrogate data.
C  this module replace the AQ_PARAMS.EXT include file
C
C  Revision History:
C     First version was coded in May 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     Feb 2011: Steve Howard, Shawn Roselle, Prakash Bhave, Bill Hutzell -
C     Mar 2011: Sergey Napelenok - AE6 update for Ca/Mg/K/Fe/Mn 
C               indexing, density, variable names
C     Mar 2011: Shawn Roselle, replaced I/O API include files with UTILIO_DEFN
C     Sep 2011: B.Hutzell: adapted for mercury and HAP mechanisms
C     Jun 2012: J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2
C     Oct 2014: B.Hutzell:forcing to skip mapping if aerosol species
C     index equals the values for H3OP species as for aerosol water
C     species 
C-----------------------------------------------------------------------
      Use aero_data, Only: n_aerolist, n_aerospc, conmin, n_mode, 
     &                     iait, iacc, icor
      Use runtime_vars
#ifdef mpas
      Use util_module, only : index1
#endif

      Implicit None

      Integer, Parameter :: n_aq_gas = 21   ! number of gas-phase species for AQCHEM
      Integer, Parameter :: n_aq_aer = 37   ! number of aerosol surrogate species for AQCHEM

      Integer, Parameter :: n_aq_liqs = 70  ! number of liquid-phase species in AQCHEM
      Integer, Parameter :: mxsrg = 72      ! maximum number of species for surrogate

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C...Gas surrogates species 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      Type sur_gas_type
         Character( 16 ) :: name               ! surrogate name
         Real            :: backgnd            ! background value [ppm]
      End Type sur_gas_type

      Type ( sur_gas_type ), Parameter :: srggas( n_aq_gas ) = (/
C                          Name       Background
C                       ----------    ----------
     & sur_gas_type( 'SO2       ',        0.0 ),
     & sur_gas_type( 'HNO3      ',        0.0 ),
     & sur_gas_type( 'N2O5      ',        0.0 ),
     & sur_gas_type( 'CO2       ',      340.0 ),
     & sur_gas_type( 'NH3       ',        0.0 ),
     & sur_gas_type( 'H2O2      ',        0.0 ),
     & sur_gas_type( 'O3        ',        0.0 ),
     & sur_gas_type( 'FOA       ',        0.0 ),
     & sur_gas_type( 'MHP       ',        0.0 ),
     & sur_gas_type( 'PAA       ',        0.0 ),
     & sur_gas_type( 'H2SO4     ',        0.0 ),
     & sur_gas_type( 'HCL       ',        0.0 ),
     & sur_gas_type( 'GLY       ',        0.0 ),
     & sur_gas_type( 'MGLY      ',        0.0 ),
     & sur_gas_type( 'HO        ',        0.0 ),
     & sur_gas_type( 'HFPODAchyd',        0.0 ),
     & sur_gas_type( 'HFPODAF   ',        0.0 ),
     & sur_gas_type( 'FCOOHchyd ',        0.0 ),
     & sur_gas_type( 'COF2      ',        0.0 ),
     & sur_gas_type( 'PFMOAAchyd',        0.0 ),
     & sur_gas_type( 'PFMOAF    ',        0.0 ) / )

C...Pointers for the AQCHEM array GAS

      Integer, Parameter :: lso2     = 1  ! Sulfur Dioxide
      Integer, Parameter :: lhno3    = 2  ! Nitric Acid
      Integer, Parameter :: ln2o5    = 3  ! Dinitrogen Pentoxide
      Integer, Parameter :: lco2     = 4  ! Carbon Dioxide
      Integer, Parameter :: lnh3     = 5  ! Ammonia
      Integer, Parameter :: lh2o2    = 6  ! Hydrogen Peroxide
      Integer, Parameter :: lo3      = 7  ! Ozone
      Integer, Parameter :: lfoa     = 8  ! Formic Acid
      Integer, Parameter :: lmhp     = 9  ! Methyl Hydrogen Peroxide
      Integer, Parameter :: lpaa     = 10 ! Peroxyacetic Acid
      Integer, Parameter :: lh2so4   = 11 ! Sulfuric Acid
      Integer, Parameter :: lhcl     = 12 ! Hydrogen Chloride
      Integer, Parameter :: lgly     = 13 ! Glyoxal
      Integer, Parameter :: lmgly    = 14 ! Methylglyoxal
      Integer, Parameter :: lho      = 15 ! OH, hydroxyl radical
      Integer, Parameter :: lhfpodachyd_g = 16 ! GenX formed in cloud water
      Integer, Parameter :: lhfpodaf_g    = 17 ! GenX precursor, dimer acid fluoride
      Integer, Parameter :: lfcoohchyd_g  = 18 ! FCOOH formed in cloud water
      Integer, Parameter :: lcof2_g       = 19 ! FCOOH precursor (aka COF2), dimer acid fluoride
      Integer, Parameter :: lpfmoaachyd_g = 20 ! PFMOAA formed in cloud water
      Integer, Parameter :: lpfmoaf_g     = 21 ! PFMOAA precursor, dimer acid fluoride

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C...Aerosol surrogates species 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      Character(32) :: srgaer_name( n_aq_aer,n_mode )
      Type sur_aer_type
         Character( 16 ) :: name     ! bulk surrogate name
         Real            :: backgnd  ! background value [ug m-3]
         Real            :: density  ! density [kg m-3] 
         Real            :: molwt    ! molecular weight [g mol-1]
      End Type sur_aer_type

      Type ( sur_aer_type ), Parameter  :: srgaer( n_aq_aer ) = (/

C                      Name     Background  Density  MolWt
C                    ----------  ----------  ------  -----
     & sur_aer_type('SO4       ',   0.0,     1800.0,  96.0 ),
     & sur_aer_type('NH4       ',   0.0,     1800.0,  18.0 ),
     & sur_aer_type('NO3       ',   0.0,     1800.0,  62.0 ),
     & sur_aer_type('SOA       ',   0.0,     1400.0, 200.0 ),
     & sur_aer_type('AORGC     ',   0.0,     1400.0, 177.0 ),
     & sur_aer_type('POA       ',   0.0,     1400.0, 220.0 ),
     & sur_aer_type('EC        ',   0.0,     2200.0,  12.0 ),
     & sur_aer_type('PRI       ',   0.0,     1400.0, 218.0 ),
     & sur_aer_type('NA        ',   0.0,     2200.0,  23.0 ),
     & sur_aer_type('CL        ',   0.0,     2200.0,  35.5 ),
     & sur_aer_type('CA        ',   0.0,     2200.0,  40.1 ),
     & sur_aer_type('MG        ',   0.0,     2200.0,  24.3 ),
     & sur_aer_type('K         ',   0.0,     2200.0,  39.1 ),
     & sur_aer_type('FE        ',   0.0,     2200.0,  55.8 ),
     & sur_aer_type('MN        ',   0.0,     2200.0,  54.9 ),
     & sur_aer_type('SOIL      ',   0.0,     2600.0, 100.0 ),
     & sur_aer_type('ANTH      ',   0.0,     2200.0, 100.0 ),
     & sur_aer_type('SEAS      ',   0.0,     2200.0,  23.75),
     & sur_aer_type('TRACER    ',   0.0,     2200.0,  60.0 ),
     & sur_aer_type('PHG       ',   0.0,     2200.0, 200.5 ),
     & sur_aer_type('CACO3     ',   0.0,     2200.0, 100.08),
     & sur_aer_type('MGCO3     ',   0.0,     2200.0,  84.31),
     & sur_aer_type('A3FE      ',   0.0,     2200.0,  55.85),
     & sur_aer_type('B2MN      ',   0.0,     2200.0,  54.93),
     & sur_aer_type('SO4_AQH2O2',   0.0,     1800.0,  96.0 ),
     & sur_aer_type('SO4_AQO3  ',   0.0,     1800.0,  96.0 ),
     & sur_aer_type('SO4_AQFEMN',   0.0,     1800.0,  96.0 ),
     & sur_aer_type('SO4_AQMHP ',   0.0,     1800.0,  96.0 ),
     & sur_aer_type('SO4_AQPAA ',   0.0,     1800.0,  96.0 ),
     & sur_aer_type('HFPODACHYD',   0.0,     1800.0, 330.05),
     & sur_aer_type('HFPODAF   ',   0.0,     1800.0, 332.05),
     & sur_aer_type('FCOOHCHYD ',   0.0,     1400.0,  64.02),
     & sur_aer_type('COF2      ',   0.0,     1139.0,  66.01),
     & sur_aer_type('PFMOAACHYD',   0.0,     1700.0, 180.03),
     & sur_aer_type('PFMOAF    ',   0.0,     1546.0, 182.02),
     & sur_aer_type('NUM       ',   0.0,        1.0,   1.0 ),
     & sur_aer_type('SRF       ',   0.0,        1.0,   1.0 )/)

C...Pointers for the AQCHEM array AEROSOL
      Integer, Parameter :: lso4       = 1  !  Sulfate
      Integer, Parameter :: lnh4       = 2  !  Ammonium
      Integer, Parameter :: lno3       = 3  !  Nitrate
      Integer, Parameter :: lsoa       = 4  !  SOA
      Integer, Parameter :: lorgc      = 5  !  SOA (anthropogenic organic oligomers)
      Integer, Parameter :: lpoa       = 6  !  Primary organic aerosol
      Integer, Parameter :: lec        = 7  !  Elemental carbon
      Integer, Parameter :: lpri       = 8  !  Primary aerosol (Aitken and Accumulation)
      Integer, Parameter :: lna        = 9  !  Sodium
      Integer, Parameter :: lcl        = 10 !  Chloride ion
      Integer, Parameter :: lca        = 11 !  Ca in Accumulation mode (AE6) SLN 16March2011
      Integer, Parameter :: lmg        = 12 !  Mg in Accumulation mode (AE6) SLN 16March2011
      Integer, Parameter :: lk         = 13 !  K in Accumulation mode (AE6)  SLN 16March2011
      Integer, Parameter :: lfe        = 14 !  Fe in Accumulation mode (AE6) SLN 22March2011
      Integer, Parameter :: lmn        = 15 !  Mn in Accumulation mode (AE6) SLN 22March2011
      Integer, Parameter :: lsoil      = 16 !  SOIL in Coarse mode (AE6)     SLN 16March2011
      Integer, Parameter :: lanth      = 17 !  CORS in Coarse mode (AE6)     SLN 16March2011
      Integer, Parameter :: lseas      = 18 !  SEAS in Coarse mode (AE6)     SLN 16March2011
      Integer, Parameter :: ltracer    = 19 !  Tracer aerosols (Aitken)
      Integer, Parameter :: lphg       = 20 !  Mercuric aerosols (Aitken and Accumulation)
      Integer, Parameter :: lcaco3     = 21 !  Calcium Carbonate aerosol (place holder)
      Integer, Parameter :: lmgco3     = 22 !  Magnesium Carbonate aerosol (place holder)
      Integer, Parameter :: la3fe      = 23 !  Iron aerosol (place holder)
      Integer, Parameter :: lb2mn      = 24 !  Manganese aerosol (place holder)
      Integer, Parameter :: lso4aqh2o2 = 25 !  Sulfate from aq H2O2 rxn
      Integer, Parameter :: lso4aqo3   = 26 !  Sulfate from aq O3 rxn
      Integer, Parameter :: lso4aqfemn = 27 !  Sulfate from aq rxn catalyzed by FE&MN
      Integer, Parameter :: lso4aqmhp  = 28 !  Sulfate from aq MHP rxn
      Integer, Parameter :: lso4aqpaa  = 29 !  Sulfate from aq PAA rxn
      Integer, Parameter :: lhfpodachyd_p= 30 !  GenX formed in Cloud Water
      Integer, Parameter :: lhfpodaf_p   = 31 !  Dimer Acid Fluoride
      Integer, Parameter :: lfcoohchyd_p = 32 !  FCOOH formed in Cloud Water
      Integer, Parameter :: lcof2_p      = 33 !  Dimer Acid Fluoride precursor
      Integer, Parameter :: lpfmoaachyd_p= 34 !  PFMOAA formed in Cloud Water
      Integer, Parameter :: lpfmoaf_p  = 35 !  Dimer Acid Fluoride precursor
      Integer, Parameter :: lnum       = 36 !  Number
      Integer, Parameter :: lsrf       = 37 !  Surface area

C...Pointers for the AQCHEM arrays LIQUID and WETDEP
      Integer, Parameter :: lacl        = 01  ! Hydrogen ion
      Integer, Parameter :: lnh4accl    = 02  ! Ammonium(attributed to accum. mode)
      Integer, Parameter :: lcacorl     = 03  ! coarse mode Calcium 
      Integer, Parameter :: lnaaccl     = 04  ! Sodium
      Integer, Parameter :: lohl        = 05  ! Hydroxyl radical
      Integer, Parameter :: lso4accl    = 06  ! Sulfate (attributed to accumulation mode)
      Integer, Parameter :: lhso4accl   = 07  ! bisulfate (attributed to accumulation mode)
      Integer, Parameter :: lso3l       = 08  ! sulfite
      Integer, Parameter :: lhso3l      = 09  ! bisulfite
      Integer, Parameter :: lso2l       = 10  ! sulfur dioxide
      Integer, Parameter :: lco3l       = 11  ! carbonate
      Integer, Parameter :: lhco3l      = 12  ! bicarbonate
      Integer, Parameter :: lco2l       = 13  ! carbon dioxide
      Integer, Parameter :: lno3accl    = 14  ! nitrate(attributed to accumulation mode)
      Integer, Parameter :: lnh3l       = 15  ! ammonia
      Integer, Parameter :: lclaccl     = 16  ! chloride ion (attributed to accumulation mode)
      Integer, Parameter :: lh2o2l      = 17  ! hydrogen peroxide
      Integer, Parameter :: lo3l        = 18  ! ozone
      Integer, Parameter :: lfecorl     = 19  ! iron
      Integer, Parameter :: lmncorl     = 20  ! Manganese
      Integer, Parameter :: lal         = 21  ! generalized anion associated with iron
      Integer, Parameter :: lfoal       = 22  ! Formic acid
      Integer, Parameter :: lhco2l      = 23  ! HCOO- ion
      Integer, Parameter :: lmhpl       = 24  ! Methyl hydrogen peroxide
      Integer, Parameter :: lpaal       = 25  ! Peroxyacidic acid
      Integer, Parameter :: lhcll       = 26  ! Hydrogen chloride
      Integer, Parameter :: lpriml      = 27  ! primary aerosol
      Integer, Parameter :: lmgcorl     = 28  ! coarse mode Magnesium
      Integer, Parameter :: lkcorl      = 29  ! coarse mode Potassium
      Integer, Parameter :: lbl         = 30  ! generalized anion associated with manganese
      Integer, Parameter :: lhno3l      = 31  ! nitric acid
!     Integer, Parameter :: lprimcorl   = 32  ! coarse-mode primary aerosol
      Integer, Parameter :: lnumcorl    = 32  ! coarse-mode number
      Integer, Parameter :: lts6corl    = 33  ! sulfate (attributed to coarse mode)
      Integer, Parameter :: lnacorl     = 34  ! sodium (attributed to coarse mode)
      Integer, Parameter :: lclcorl     = 35  ! chloride ion (attributed to coarse mode)
      Integer, Parameter :: lno3corl    = 36  ! nitrate (attributed to coarse mode)
      Integer, Parameter :: lnh4corl    = 37  ! ammonium (attributed to coarse mode)
      Integer, Parameter :: lsoal       = 38  ! secondary organic aerosols
      Integer, Parameter :: lorgcl      = 39  ! in-cloud soa
      integer, parameter :: lpoal       = 40  ! primary organic aerosols
      Integer, Parameter :: lecl        = 41  ! elemental carbon
      Integer, Parameter :: lglyl       = 42  ! glyoxal
      Integer, Parameter :: lmglyl      = 43  ! methylglyoxal
      Integer, Parameter :: lcaaccl     = 44  ! accumulation mode Calcium (AE6)   SLN 16March2011
      Integer, Parameter :: lmgaccl     = 45  ! accumulation mode Magnesium (AE6) SLN 16March2011
      Integer, Parameter :: lkaccl      = 46  ! accumulation mode Potassium (AE6) SLN 16March2011
      Integer, Parameter :: lsoilcl     = 47  ! coarse mode SOIL (AE6)   SLN 16March2011
      Integer, Parameter :: lanthcl     = 48  ! coarse mode CORS (lol) (AE6)   SLN 16March2011
      Integer, Parameter :: lseascl     = 49  ! coarse mode SEAS (AE6) SLN 16March2011
      Integer, Parameter :: lfeaccl     = 50  ! accumulation mode Iron (AE6)      SLN 22March2011
      Integer, Parameter :: lmnaccl     = 51  ! accumulation mode Manganese (AE6) SLN 22March2011

C for TX version
      integer, parameter :: ltracerl    = 52 ! TRACER
      integer, parameter :: ltracercorl = 53 ! Coarse-mode TRACER
      integer, parameter :: lphgfinel   = 54 ! Fine-mode Mercury Tracer
      integer, parameter :: lphgcorl    = 55 ! Coarse-mode Mercury Tracer
C for sulfur tracking model
      Integer, Parameter :: lts6aqh2o2l = 56 ! total S(VI) from aq H2O2 rxn
      Integer, Parameter :: lts6aqo3l   = 57 ! total S(VI) from aq O3 rxn
      Integer, Parameter :: lts6aqfemnl = 58 ! total S(VI) from aq FE&MN catalyzed rxn
      Integer, Parameter :: lts6aqmhpl  = 59 ! total S(VI) from aq MHP rxn
      Integer, Parameter :: lts6aqpaal  = 60 ! total S(VI) from aq PAA rxn
      
      Integer, Parameter :: ltracil     = 61
      Integer, Parameter :: lpoail      = 62
      Integer, Parameter :: lpriil      = 63
      Integer, Parameter :: lsoail      = 64
      
      Integer, Parameter :: lhfpodachyd_l= 65 ! GenX produced in cloud water
      Integer, Parameter :: lhfpodaf_l   = 66 ! GenX precursor, dimer acid fluoride
      Integer, Parameter :: lfcoohchyd_l = 67 ! FCOOH produced in cloud water
      Integer, Parameter :: lcof2_l      = 68 ! FCOOH precursor, dimer acid fluoride
      Integer, Parameter :: lpfmoaachyd_l= 69 ! PFMOAA produced in cloud water
      Integer, Parameter :: lpfmoaf_l    = 70 ! PFMOAA precursor, dimer acid fluoride

      Integer, Save :: n_aqsrg_gas( n_aq_gas )             ! Store Number of CGRID species pointing to each surrogate
      Integer, Save :: n_aqsrg_aer( n_aq_aer,n_mode )      ! Store Number of CGRID species pointing to each surrogate
      Integer, Allocatable, Save :: MAP_CGRIDtoAQGAS( : )  ! Map from CGRID to Surrogates
      Integer, Allocatable, Save :: MAP_CGRIDtoAQAERO( : ) ! Map from CGRID to Surrogates
      Integer, Allocatable, Save :: MAP_CGRIDtoAQMODE( : ) ! Map from CGRID to Surrogates
      Integer, Allocatable, Save :: MAP_ACCtoAIT( : )      ! Map Accumulation to Aitken Mode Species
      Real( 8 ),    Save         :: FRACAIT( N_AQ_AER )    ! Store fraction of Aitken mode in each aerosol surrogate

      Real( 8 )   :: jh2o2_hydrometeors    ! H2O2 photolysis rate in condensed water [sec-1]
      Real( 8 )   :: jhno3_hydrometeors    ! HNO3 photolysis rate in condensed water [sec-1]

      Logical, Private, Save :: mapped = .False.

      Contains
 
C------------------------------------------------------------------------
      Subroutine aq_data_init()

C  Defines mapping from CGRID for species concentration and moments.
 
C  Revision History:
C     First version was coded in May 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     Jan 2017: Additional error check added to avoid array out of
C     bounds when additional aerosol species are added. HOT Pye.
C-----------------------------------------------------------------------

      Use cgrid_spcs          ! CGRID mechanism species
      Use utilio_defn
      Use aero_data 
      Use phot_mod, Only: init_phot_shared  ! set-up shared photolysis arrays
      
      Implicit None

C Functions:
      Integer, External :: indexn

C Local Variables:
      Character( 300 ) :: xmsg
      Character( 10 ) :: bkground
      Integer :: igas
      Integer :: iaer
      Integer :: isrg
      Integer :: spc
      Integer :: i, im, im0, iaero, iaero0
      Integer :: n
      Integer :: var
      Logical :: new, Jexist
      Integer :: lsrg( mxsrg )
      Integer :: ios

C Local Variable used to determine what optional TX to add to surrogates
      !Logical :: found_all_modes
      !Integer :: n_missing_tx
      !Integer :: n_which_txadd( nadd_tx )
      CHARACTER(16) :: NAMEI, NAMEJ
      INTEGER JAIT, JACC, JAQ_ACC, JAQ_AIT

      Logical, Save :: Firstcall = .True.
      
C-----------------------------------------------------------------------


      If ( Firstcall ) Then
         Firstcall = .False.
      Else
         Return
      End if
 
      Call init_phot_shared()
      
C...Allocate Maps from CGRID to Aqueous Chemistry Vectors
      Allocate ( MAP_CGRIDtoAQGAS( n_cgrid_spc ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating MAP_CGRIDtoAQGAS'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

      Allocate ( MAP_CGRIDtoAQAERO( n_cgrid_spc ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating MAP_CGRIDtoAQAERO'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

      Allocate ( MAP_CGRIDtoAQMODE( n_cgrid_spc ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating MAP_CGRIDtoAQMODE'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

      Allocate ( MAP_ACCtoAIT( n_cgrid_spc ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating MAP_ACCtoAIT'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

C...Map aero species
      Call map_aero()

C...Initialize aerosol surrogate species names 
      Do spc = 1, n_aq_aer
        Do im = 1,n_mode
          srgaer_name( spc,im ) = trim(srgaer( spc )%name) // '_' // trim(modename( im ))
        End Do
      End Do

C...Create Map Directly from CGRID to the gas and aerosol species in AQCHEM
      MAP_CGRIDtoAQGAS  = 0
      MAP_CGRIDtoAQAERO = 0
      MAP_CGRIDtoAQMODE = 0
      N_AQSRG_GAS = 0
      N_AQSRG_AER = 0
            
      DO I = 1,N_SPC_AQ
         SPC = MAP_AQtoCGRID( I ) 
         IF ( CGRID_MASK_GAS( SPC ) .OR. CGRID_MASK_NR( SPC ) .OR.
     &        CGRID_MASK_TRAC( SPC ) ) THEN
           ! Map Gas-Phase Species
           igas = index1( aq_spc( I ), n_aq_gas, SRGGAS(:)%name )
           if ( igas .eq. 0 ) then
             Write ( xmsg, '(A,A,A,A,A,A)' ),'Aqueous Chem Surrogate ',trim( aq_spc(I) ),
     &             ' for species ',trim( CGRID_NAME( SPC )),' is not available as a gas in the ',
     &             ' Aq Chem Solver. Please Correct or Delete.'
             Call m3exit( 'AQ_INIT', 0, 0, xmsg, xstat3 )
           else
             MAP_CGRIDtoAQGAS( SPC ) = IGAS
             N_AQSRG_GAS( IGAS ) = N_AQSRG_GAS( IGAS ) + 1
           end if
         ELSEIF ( CGRID_MASK_AERO( SPC ) ) THEN
           ! Map Aerosol Species
           ! Loop over modes; find the AE surrogate name on the local
           ! mode-dependent cloud chemistry list; there will only be one
           ! match across all modes.
           iaero = 0
           do im0 = 1,n_mode
             iaero0 = index1( aq_spc( I ), n_aq_aer, SRGAER_name(:,im0) )
             if ( iaero0 .ne. 0 ) then
                 iaero = iaero0
                 im = im0
             end if
           end do
           if ( iaero .eq. 0 ) then
             Write ( xmsg, '(A,A,A,A,A,A)' ),'Aqueous Chem Surrogate ',trim( aq_spc(I) ),
     &             ' for species ',trim( CGRID_NAME( SPC )),' is not available as an ',
     &             'aerosol in the Aq Chem Solver. Please Correct or Delete.'
             Call m3exit( 'AQ_INIT', 0, 0, xmsg, xstat3 )
           else
             MAP_CGRIDtoAQAERO( SPC ) = IAERO
             MAP_CGRIDtoAQMODE( SPC ) = IM
             N_AQSRG_AER( IAERO,IM ) = N_AQSRG_AER( IAERO,IM ) + 1
           end if
        END IF
      END DO

      mapped = .True.
      
C...Match Accumulation mode surrogate indices to their Aitken mode counterparts
      MAP_ACCtoAIT = 0
      DO IAERO = 1,N_AEROSPC
         ! Find the CGRID Indeces for the Accumulation and Aitken 
         ! mode species
         JACC = AEROSPC_MAP( IAERO, IACC )
         JAIT = AEROSPC_MAP( IAERO, IAIT )

         ! Determine if these species have aqueous chemistry surrogates
         IF ( JACC .GT. 0 .AND. JAIT .GT. 0 ) THEN 
            JAQ_ACC = MAP_CGRIDtoAQAERO( JACC )
            JAQ_AIT = MAP_CGRIDtoAQAERO( JAIT )

            ! If both species are mapped and both have aqueous-chemistry
            ! surrogates that are the same, then link them.
            IF ( JAQ_ACC .GT. 0 .AND. JAQ_ACC .EQ. JAQ_AIT ) 
     &         MAP_ACCtoAIT( JACC ) = JAIT
         END IF
      END DO

      Write( logdev,'( / 5x, a / )' ) ' --- AQCHEM Gas and Aerosol Species Mapped ---'

      Return
      End Subroutine aq_data_init

C-----------------------------------------------------------------------
      Subroutine set_aeconcmin( aeconcmin )
C-----------------------------------------------------------------------
C
C  Function:
C       set minimum concentrations for aerosol species
C       routine called from convcld_acm
C
C  Preconditions:
C       Dates and times represented YYYYDDD:HHMMSS.
C
C  Revision History:
C       5/05 copied code from aero_depv to begin subroutine
C       4/08 J.Kelly: added code to set min for coarse surface area
C       21 Jun 10 J.Young: convert for Namelist redesign
C-----------------------------------------------------------------------

      Use cgrid_spcs            ! CGRID mechanism species
      Use aero_data
      Use utilio_defn
      Use const, only : mwair
      Implicit None

C..Arguments:
      Real, Intent( Out ) :: aeconcmin( : ) ! array of minimum concentrations

C..Local Variables:

      Integer m        ! mode loop counter
      Integer n        ! aerospc loop counter
      Integer spc      ! species loop counter


      ! compute minimums for numbers and surfaces

      Do m = 1, n_mode
         spc = index1( aeromode( m )%num_name, n_ae_spc, ae_spc )
         aeconcmin( spc ) = aeromode_minNum( m ) * mwair * 1.0E-3

         spc = index1( aeromode( m )%srf_name, n_ae_spc, ae_spc )
         aeconcmin( spc ) = aeromode_minM2( m ) * mwair * 1.0E-3
      End Do

      ! compute minimums for aerosol species
      Do m = 1, n_mode
         Do n = 1, n_aerospc
            If ( .NOT. aero_missing(n,m) ) Then
               spc = index1( aerospc( n )%name( m ), n_ae_spc, ae_spc )
               If ( spc .Ne. 0 ) Then
                  aeconcmin( spc ) = aerospc( n )%min_conc( m ) * mwair * 1.0E-9 / ae_molwt( spc )
               End If               
            End If
         End Do
      End Do 

      Return
      End Subroutine set_aeconcmin

      End Module aq_data

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains utility functions to support centralized I/O 
! implementation

! Revision History:
!  02/01/19, D. Wong: initial implementation
!  04/23/19, D. Wong: added two new subroutines: leap_year and
!                     julian_to_mpas_date_time
!  08/01/19, D. Wong: modified code to work with two-way model
!  11/20/19, F. Sidi: Modified time to sec to handle negative numbers
!  03/05/20, D. Wong: Expanded CIO functionalities to MPAS as well
!  07/07/20, D. Wong: Formulated a robust routine to compute JDATE1 - JDATE2
!                     and JDATE + NDAYS
!  01/12/21, D. Wong: Modified character declaration legnth from 20 to
!                     * for intent(out) mpas_time_stamp in subroutine
!                     julian_to_mpas_date_time and put in some error
!                     checking for jdate
!------------------------------------------------------------------------!

      module centralized_io_util_module

        implicit none

        interface time_diff
          module procedure time_diff_i,
     &                     time_diff_str
        end interface

        interface binary_search
          module procedure binary_search_char,
     &                     binary_search_int
        end interface

        interface quicksort
          module procedure quicksort_c1d,
     &                     quicksort_c2d
        end interface

        interface search
          module procedure search_c,
     &                     search_i
        end interface

        contains

! ----------------------------------------------------------------------
! this is for mpas extracting layer distribution information store in an emission file

        subroutine ext_layer_info (buf, layer, bot, top, factor)

          implicit none

          character (*), intent(in) :: buf
          integer, intent(out) :: bot(:), top(:), layer
          real, intent(out) :: factor(:)

          integer :: index(5), loc, str_len, n, start, t_lay
          logical :: zero

          zero = .true.
          str_len = len_trim(buf)
          start = 27
          do while (start .lt. str_len)
             loc = start
             n = 1
             index(1) = loc
             do while (n < 5)
                loc = loc + 1
                if (buf(loc:loc) == ',') then
                   n = n + 1
                   index(n) = loc
                else if (buf(loc:loc) == ';') then
                   n = n + 1
                   index(n) = loc - 1
                else if (loc == str_len) then
                   n = n + 1
                   index(n) = loc + 1
                end if
             end do

             start = loc + 1

             read (buf(index(1):index(2)-1), *) t_lay
             read (buf(index(2)+1:index(3)-1), *) bot(t_lay)
             read (buf(index(3)+1:index(4)-1), *) top(t_lay)
             read (buf(index(4)+1:index(5)), *) factor(t_lay)

             if (factor(t_lay) .gt. 0) then
                zero = .false.
             else if ((factor(t_lay) .eq. 0) .and. (.not. zero)) then
                start = str_len + 1
             end if 

          end do

          layer = t_lay - 1  

        end subroutine ext_layer_info

! ----------------------------------------------------------------------
        subroutine cal_distribution (bottom, top, atmo_height, factor, layer, 
     &                               num_dist_layers, new_factor)

          implicit none

          integer, intent(in) :: bottom(:), top(:), layer
          real, intent(in) :: atmo_height(:), factor(:)
          integer, intent(out) :: num_dist_layers
          real, intent(out) :: new_factor(:)

          integer  :: e_lay, a_lay, n_lay, state, stat, i, j, k, lvl
          real :: ratio, remaining, diff
          integer, allocatable :: distribution(:,:)
          real, allocatable :: distribution_factor(:,:)

          allocate (distribution(0:5, size(atmo_height)),
     &              distribution_factor(5, size(atmo_height)),
     &              stat=stat)

          distribution = 0
          distribution_factor = 0.0
          remaining = 0.0
          e_lay = 1
          a_lay = 1
          n_lay = 0
          remaining = 1.0
          ratio = 0.0
          if (top(1) < atmo_height(1)) then
             state = 0    ! considering distribution height < model height
          else
             state = 1    ! considering distribution height > model height
          end if

          do while (e_lay .le. layer)

             if (top(e_lay) < atmo_height(a_lay)) then

                n_lay = n_lay + 1 
                distribution(n_lay, a_lay) = e_lay
                if (state == 0) then
                   remaining = 1.0
                end if
                distribution_factor(n_lay, a_lay) = remaining
                distribution(0, a_lay) = n_lay
                e_lay = e_lay + 1
                state = 0

             else

                if (state == 0) then
                   diff = atmo_height(a_lay) - bottom(e_lay)
                   ratio = diff / (top(e_lay) - bottom(e_lay))
                   remaining = 1.0 - ratio
                else
                   if (a_lay == 1) then
                      ratio = atmo_height(1) / top(e_lay)
                      remaining = 1.0 - ratio
                   else
                      diff = atmo_height(a_lay) - atmo_height(a_lay-1)
                      ratio = diff / (top(e_lay) - bottom(e_lay))
                      remaining = remaining - ratio
                   end if
                end if
                n_lay = n_lay + 1 
                distribution(n_lay, a_lay) = e_lay
                distribution_factor(n_lay, a_lay) = ratio
                distribution(0, a_lay) = n_lay

                a_lay = a_lay + 1
                n_lay = 0
                state = 1
             end if 

          end do

          if (remaining > 0.0) then
             distribution(n_lay, a_lay) = e_lay - 1
             distribution_factor(n_lay, a_lay) = remaining
             distribution(0, a_lay) = n_lay
          end if

          num_dist_layers = a_lay

          new_factor = 0.0
          do k = 1, a_lay
             do j = 1, distribution(0, k)
                lvl = distribution(j, k)
                new_factor(k) = new_factor(k) + distribution_factor(j, k) * factor(lvl)
             end do
          end do

          deallocate (distribution, distribution_factor)

        end subroutine cal_distribution

! -------------------------------------------------------------------------
        recursive subroutine quicksort_c1d (name, begin, end)

          character (*), intent(out) :: name(:)
          integer, intent(in)         :: begin, end

          integer        :: i, j
          character (50) :: str1, str2
          logical        :: done

          str1 = name( (begin + end) / 2 )
          i = begin
          j = end
          done = .false.
          do while (.not. done)
             do while (name(i) < str1)
                i = i + 1
             end do
             do while (str1 < name(j))
                j = j - 1
             end do
             if (i .ge. j) then
                done = .true.
             else
                str2 = name(i)
                name(i) = name(j)
                name(j) = str2
                i = i + 1
                j = j - 1
             end if
          end do
          if (begin < i-1) call quicksort(name, begin, i-1)
          if (j+1 < end)   call quicksort(name, j+1, end)

        end subroutine quicksort_c1d

! -------------------------------------------------------------------------
        recursive subroutine quicksort_c2d (name, begin, end)

          character (*), intent(out) :: name(:,:)
          integer, intent(in)         :: begin, end

          integer        :: i, j, dsize
          character (50) :: str1, str2(3)
          logical        :: done

          dsize = size(name,2)
          str1 = name( (begin + end) / 2, 1 )
          i = begin
          j = end
          done = .false.
          do while (.not. done)
             do while (name(i,1) < str1)
                i = i + 1
             end do
             do while (str1 < name(j, 1))
                j = j - 1
             end do
             if (i .ge. j) then
                done = .true.
             else
                str2(1:dsize) = name(i,:)  
                name(i,:) = name(j,:)
                name(j,:) = str2(1:dsize)
                i = i + 1
                j = j - 1
             end if
          end do
          if (begin < i-1) call quicksort(name, begin, i-1)
          if (j+1 < end)   call quicksort(name, j+1, end)

        end subroutine quicksort_c2d

! -------------------------------------------------------------------------
        function binary_search_char (name, list, n) result (loc)

         use RUNTIME_VARS

          character (*), intent(in) :: name, list(:)
          integer, intent(in)        :: n
          integer :: loc

          logical :: found
          integer :: mid_loc, start_loc, end_loc

          start_loc = 1
          end_loc   = n
          found = .false.
          do while ((start_loc .le. end_loc) .and. (.not. found))
             mid_loc = start_loc + (end_loc - start_loc) / 2
             if (name .lt. list(mid_loc)) then
                end_loc = mid_loc - 1
             else if (name .gt. list(mid_loc)) then
                start_loc = mid_loc + 1
             else
                found = .true.
             end if
          end do

          if (found) then
             loc = mid_loc
          else
             loc = -1
          end if

        end function binary_search_char

! -------------------------------------------------------------------------
        function binary_search_int (name, list, n) result (loc)

          integer, intent(in) :: name, list(:)
          integer, intent(in) :: n
          integer :: loc

          logical :: found
          integer :: mid_loc, start_loc, end_loc

          start_loc = 1
          end_loc   = n
          found = .false.
          do while ((start_loc .le. end_loc) .and. (.not. found))
             mid_loc = start_loc + (end_loc - start_loc) / 2
             if (name .lt. list(mid_loc)) then
                end_loc = mid_loc - 1
             else if (name .gt. list(mid_loc)) then
                start_loc = mid_loc + 1
             else
                found = .true.
             end if
          end do

          if (found) then
             loc = mid_loc
          else
             loc = -1
          end if

        end function binary_search_int

! -------------------------------------------------------------------------
        function search_c (name, list, n) result (loc)

          character (*), intent(in) :: name, list(:)
          integer, intent(in)        :: n
          integer :: loc

          logical :: found
          integer :: lloc

          lloc = 0
          found = .false.
          do while ((lloc .lt. n) .and. (.not. found))
             lloc = lloc + 1
             if (name .eq. list(lloc)) then
                found = .true.
             end if
          end do

          if (found) then
             loc = lloc
          else
             loc = -1
          end if

        end function search_c

! -------------------------------------------------------------------------
        function search_i (data, list, n) result (loc)

          integer, intent(in) :: data, list(:)
          integer, intent(in) :: n
          integer :: loc

          logical :: found
          integer :: lloc

          lloc = 0
          found = .false.
          do while ((lloc .lt. n) .and. (.not. found))
             lloc = lloc + 1
             if (data .eq. list(lloc)) then
                found = .true.
             end if
          end do

          if (found) then
             loc = lloc
          else
             loc = -1
          end if

        end function search_i

! -------------------------------------------------------------------------
        integer function time_to_sec (time)

          integer, intent(in) :: time    ! in hhmmss format
          integer :: neg_time
          integer :: time_in_sec, hr, min, sec

          if (time .gt. 0) then
             hr = time / 10000
             min = mod(time/100, 100)
             sec = mod(time, 100)
             time_to_sec = hr * 3600 + min * 60 + sec
          else
             neg_time = abs(time)
             hr = neg_time / 10000
             min = mod(neg_time/100, 100)
             sec = mod(neg_time, 100)
             time_to_sec = -1*(hr * 3600 + min * 60 + sec)
          end if
          
        end function time_to_sec

! -------------------------------------------------------------------------
        integer function time_diff_i (time1, time2)

          integer, intent(in) :: time1, time2    ! in hhmmss format

          time_diff_i = time_to_sec(time1) - time_to_sec(time2)

        end function time_diff_i

! -------------------------------------------------------------------------
        integer function time_diff_str (time1, time2)

          character (64), intent(in) :: time1, time2    ! in yyyy-mm-dd_hh:mm:ss format

          integer :: hr1, min1, sec1, hr2, min2, sec2, hr, min, sec, diff, str_len

! for current implementation, assume yyyy-mm-dd are the same

          str_len = len_trim(time1) 
          read (time1(str_len-7:str_len), '(i2, 1x, i2, 1x, i2)') hr1, min1, sec1
          str_len = len_trim(time2) 
          read (time2(str_len-7:str_len), '(i2, 1x, i2, 1x, i2)') hr2, min2, sec2
     
          diff = (hr1 - hr2) * 3600 + (min1 - min2) * 60 + (sec1 - sec2)

          hr = diff / 3600
          diff = diff - hr * 3600

          min = diff / 60

          sec = diff - min * 60 

          time_diff_str = hr * 10000 + min * 100 + sec

        end function time_diff_str

! --------------------------------------------------------------------------------
        logical function leap_year (year)

          integer, intent(in) :: year

          logical :: temp_leap_year

          if (mod(year, 4) .ne. 0) then
             temp_leap_year = .false.
          else if (mod(year, 400) .eq. 0) then
             temp_leap_year = .true.
          else if (mod(year, 100) .eq. 0) then
             temp_leap_year = .false.
          else
             temp_leap_year = .true.
          endif

          leap_year = temp_leap_year

        end function leap_year

! -------------------------------------------------------------------------
        subroutine julian_to_mpas_date_time (jdate, jtime, mpas_time_stamp)

          integer, intent(in)  :: jdate, jtime
          character (*), intent(out) :: mpas_time_stamp

          integer, parameter :: num_days (12, 2) =
     &        reshape ((/ 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365,
     &                    31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366 /), (/12, 2/))

          integer :: ind, t_date, i, year, month, day, hour, minute, sec
          logical :: found

          year = jdate / 1000
          t_date = mod(jdate, 1000)

          if (leap_year(year)) then
             if (t_date > 366) then
                write (6, *) ' Error: JDATE > 366 for a leap year', jdate
                stop
             end if
             ind = 2
          else
             if (t_date > 365) then
                write (6, *) ' Error: JDATE > 365 for a non leap year', jdate
                stop
             end if
             ind = 1
          end if

          found = .false.
          i = 12
          do while ((.not. found) .and. (i > 0))
             if (t_date > num_days(i, ind)) then
                found = .true.
             else
                i = i - 1
             end if
          end do

          month = i + 1
          if (i == 0) then
             day = t_date
          else
             day = t_date - num_days(i, ind)
          end if

          hour   = jtime / 10000
          minute = mod(jtime, 10000) / 100
          sec    = mod(jtime, 100)

          write (mpas_time_stamp, '(i4, 5(a1, i2.2))')
     $          year, '-', month, '-', day, '_', hour, ':', minute, ':', sec

        end subroutine julian_to_mpas_date_time

! -------------------------------------------------------------------------
        subroutine mpas_date_time_to_julian (mpas_time_stamp, jdate, jtime)

          character (20), intent(in) :: mpas_time_stamp
          integer, intent(out)       :: jdate, jtime

          integer, parameter :: num_days (12, 2) =
     &        reshape ((/ 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334,
     &                    0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335 /), (/12, 2/))

          integer :: ind, year, month, day, hour, minute, sec

          read (mpas_time_stamp, '(i4, 5(1x, i2))') year, month, day, hour, minute, sec

          if (leap_year(year)) then
             ind = 2
          else
             ind = 1
          end if

          jdate = year * 1000 + num_days(month, ind) + day
          jtime = hour * 10000 + minute * 100 + sec

        end subroutine mpas_date_time_to_julian

!--------------------------------------------------------------------------
       integer function next_day (jday)

! This function determermins the next day for time interpolation 
          implicit none

          integer, intent(in) :: jday
          integer year, day

          day  = MOD(jday,1000)
          year = INT(jday/1000)

          If( day .LT. 365 ) Then
             next_day = jday+1
          Else
             If( MOD(year,4) .Eq. 0 .And. MOD(year,100) .Ne. 0 ) Then
! Leap Year        
                If( day .Eq. 365 ) Then
                   next_day = jday + 1
                Else
                   next_day = (INT(jday/1000)+1)*1000+1
                End If
             Else If(MOD(year,400) .Eq. 0 ) Then
! also a leap year, e.g. 2000 but not 2100
                If( day .Eq. 365 ) Then
                   next_day = jday + 1
                Else
                   next_day = (INT(jday/1000)+1)*1000+1
                End If
             Else
! not a leap year
                next_day = (INT(jday/1000)+1)*1000+1
             End If
          End If

       end function next_day

      end module centralized_io_util_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE AVG_CONC

      IMPLICIT NONE

C Revision History
C   10 May 2016 D. Wong Modified code to provide flexibility to handle
C                       environment variable ACONC_FILE_SPCS is set to 'ALL' 
C                       or not set.
C 
C   09 Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL &
C                      added W_VEL to species aconc_species list depending on
C                      if the user requests the vertical velocity to be output
C
C
C Function: species, layer pointers and definitions for integral average
C CONC calculations
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      INTEGER, SAVE :: N_ASPCS = 0

      INTEGER, SAVE, ALLOCATABLE :: AVG_CONC_MAP( : ) ! pointer into CGRID
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: A_GC_SPC( : ) ! pointer into GC_SPC
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: A_AE_SPC( : ) ! pointer into AE_SPC
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: A_NR_SPC( : ) ! pointer into NR_SPC
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: A_TR_SPC( : ) ! pointer into TR_SPC

C species classes configuration for average CONC 
      INTEGER, SAVE :: A_GC_STRT
      INTEGER, SAVE :: N_A_GC_SPC
      INTEGER, SAVE :: A_AE_STRT
      INTEGER, SAVE :: N_A_AE_SPC
      INTEGER, SAVE :: A_NR_STRT
      INTEGER, SAVE :: N_A_NR_SPC
      INTEGER, SAVE :: A_TR_STRT
      INTEGER, SAVE :: N_A_TR_SPC

      INTEGER, SAVE :: N_A_AE_SPCD
                                
C Number of Average Concentration Layers                                
      INTEGER, SAVE :: A_NLYS = 1

C Average Arrays for Met variables
      REAL, SAVE, ALLOCATABLE :: AVG_WVEL( :,:,: )
      REAL, SAVE, ALLOCATABLE :: AVG_RH( :,:,: )
      REAL, SAVE, ALLOCATABLE :: AVG_TA( :,:,: )
      REAL, SAVE, ALLOCATABLE :: AVG_PRES( :,:,: )

C Logical to test whether met variables are included
      LOGICAL, SAVE :: L_ACONC_RH = .FALSE.
      LOGICAL, SAVE :: L_ACONC_TA = .FALSE.
      LOGICAL, SAVE :: L_ACONC_PRES = .FALSE.

      CONTAINS

         SUBROUTINE A_CONC_DEFN ()

         USE RUNTIME_VARS
         USE GRID_CONF             ! Grid Configuration
         USE CGRID_SPCS            ! CGRID mechanism species
         USE UTILIO_DEFN

#ifdef sens
         Use DDM3D_DEFN, Only: N_ASENS_VARS
#endif

         CHARACTER( 16 ) :: PNAME = 'A_CONC_DEFN'
         CHARACTER(200 ) :: XMSG = ' '

         INTEGER OFF, VAR, V, NV, LVL
         INTEGER ALLOCSTAT, STATUS
         INTEGER :: JDATE = 0
         INTEGER :: JTIME = 0

         INTEGER, ALLOCATABLE :: GC_MAP( : )
         INTEGER, ALLOCATABLE :: AE_MAP( : )
         INTEGER, ALLOCATABLE :: NR_MAP( : )
         INTEGER, ALLOCATABLE :: TR_MAP( : )


C-----------------------------------------------------------------------

C RETRIEVE THE SPECIES SAVED TO INTEGRAL AVERAGE CONCENTRATION FILE

         IF ( N_ACONC_VARS .EQ. 0 .OR. ACONC_FILE_SPCS( 1 ) .EQ. 'ALL' ) THEN
            V = 0
            DO VAR = 1, N_GC_CONC
               V = V + 1
               ACONC_FILE_SPCS( V ) = GC_CONC( VAR )
            END DO
            DO VAR = 1, N_AE_CONC
               V = V + 1
               ACONC_FILE_SPCS( V ) = AE_CONC( VAR )
            END DO
            DO VAR = 1, N_NR_CONC
               V = V + 1
               ACONC_FILE_SPCS( V ) = NR_CONC( VAR )
            END DO
            DO VAR = 1, N_TR_SPC
               V = V + 1
               ACONC_FILE_SPCS( V ) = TR_SPC( VAR )
            END DO
            ACONC_FILE_SPCS( V + 1 ) = 'RH'
            ACONC_FILE_SPCS( V + 2 ) = 'TA'
            ACONC_FILE_SPCS( V + 3 ) = 'PRES'
            N_ACONC_VARS = V + 3
#ifdef sens
            N_ASENS_VARS = V
#endif
         END IF
C  Retrieve CTM_WVEL environmental variable to see if user wants diagnosed vertical velocity
         IF ( W_VEL ) THEN 
            ACONC_FILE_SPCS( N_ACONC_VARS + 1 ) = 'WVEL'
            N_ACONC_VARS = N_ACONC_VARS + 1
         END IF
C Retrieve the layer range used in integral average concentration file
         IF ( ACONC_ELEV .EQ. -1 ) ACONC_ELEV = NLAYS

         IF ( ACONC_BLEV .LE. 0 .OR. ACONC_ELEV .GT. NLAYS ) THEN
            WRITE( XMSG,'( "Layer range", 2I4, " invalid for this model" )' )
     &      ACONC_BLEV, ACONC_ELEV
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

         A_NLYS = ACONC_ELEV - ACONC_BLEV + 1

C Check species names against include files and create AVG_CONC_MAP, and
C get starting index in AGRID and total count for each species class

         ALLOCATE ( A_GC_SPC    ( N_ACONC_VARS ),
     &              A_AE_SPC    ( N_ACONC_VARS ),
     &              A_NR_SPC    ( N_ACONC_VARS ),
     &              A_TR_SPC    ( N_ACONC_VARS ),
     &              GC_MAP      ( N_ACONC_VARS ),
     &              AE_MAP      ( N_ACONC_VARS ),
     &              NR_MAP      ( N_ACONC_VARS ),
     &              TR_MAP      ( N_ACONC_VARS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'AVG_CONC_MAP or A_GC_SPC or A_AE_SPC or A_NR_SPC'
     &           // ' or A_TR_SPC or GC_MAP or AE_MAP or NR_MAP or TR_MAP'
     &           // ' memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

C The selected species MUST be contiguous with the classes,
C and the classes must be in the sequence: GC, AE, NR, TR

         N_A_GC_SPC = 0
         N_A_AE_SPC = 0
         N_A_NR_SPC = 0
         N_A_TR_SPC = 0

         DO VAR = 1, N_ACONC_VARS
            V = INDEX1 ( ACONC_FILE_SPCS( VAR ), N_GC_SPC, GC_SPC )
            IF ( V .GT. 0 ) THEN
               N_ASPCS = N_ASPCS + 1
               N_A_GC_SPC = N_A_GC_SPC + 1
               A_GC_SPC( N_A_GC_SPC ) = ACONC_FILE_SPCS( VAR )
               OFF = 0
               GC_MAP( N_A_GC_SPC ) = V + OFF
            ELSE
               V = INDEX1 ( ACONC_FILE_SPCS( VAR ), N_AE_SPC, AE_SPC )
               IF ( V .GT. 0 ) THEN
                  N_ASPCS = N_ASPCS + 1
                  N_A_AE_SPC = N_A_AE_SPC + 1
                  OFF = N_GC_SPC + 1   ! accounts for advected density
                  A_AE_SPC( N_A_AE_SPC ) = ACONC_FILE_SPCS( VAR )
                  AE_MAP( N_A_AE_SPC ) = V + OFF
               ELSE
                  V = INDEX1 ( ACONC_FILE_SPCS( VAR ), N_NR_SPC, NR_SPC )
                  IF ( V .GT. 0 ) THEN
                     N_ASPCS = N_ASPCS + 1
                     N_A_NR_SPC = N_A_NR_SPC + 1
                     OFF = N_GC_SPC + 1 + N_AE_SPC
                     A_NR_SPC( N_A_NR_SPC ) = ACONC_FILE_SPCS( VAR )
                     NR_MAP( N_A_NR_SPC ) = V + OFF
                  ELSE
                     V = INDEX1 ( ACONC_FILE_SPCS( VAR ), N_TR_SPC, TR_SPC )
                     IF ( V .GT. 0 ) THEN
                        N_ASPCS = N_ASPCS + 1
                        N_A_TR_SPC = N_A_TR_SPC + 1
                        OFF = N_GC_SPC + 1 + N_AE_SPC + N_NR_SPC
                        A_TR_SPC( N_A_TR_SPC ) = ACONC_FILE_SPCS( VAR )
                        TR_MAP( N_A_TR_SPC ) = V + OFF
                     ELSE IF ( ACONC_FILE_SPCS( VAR ) .EQ. 'WVEL' ) THEN
                        ALLOCATE( AVG_WVEL( NCOLS,NROWS,A_NLYS ) )
                     ELSE IF ( ACONC_FILE_SPCS( VAR ) .EQ. 'RH' ) THEN
                        L_ACONC_RH = .TRUE.
                        ALLOCATE( AVG_RH( NCOLS,NROWS,A_NLYS ) )
                     ELSE IF ( ACONC_FILE_SPCS( VAR ) .EQ. 'TA' ) THEN
                        L_ACONC_TA = .TRUE.
                        ALLOCATE( AVG_TA( NCOLS,NROWS,A_NLYS ) )
                     ELSE IF ( ACONC_FILE_SPCS( VAR ) .EQ. 'PRES' ) THEN
                        L_ACONC_PRES = .TRUE.
                        ALLOCATE( AVG_PRES( NCOLS,NROWS,A_NLYS ) )
                     ELSE
                        XMSG = 'Variable ' // ACONC_FILE_SPCS( VAR )
     &                  // ' was requested for average concentration '
     &                  // ' output, but it is not available from any '
     &                  // ' species namelist.'
                        CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
                     END IF
                  END IF
               END IF
            END IF
         END DO

         A_GC_STRT = 1
         A_AE_STRT = A_GC_STRT + N_A_GC_SPC
         A_NR_STRT = A_AE_STRT + N_A_AE_SPC
         A_TR_STRT = A_NR_STRT + N_A_NR_SPC

         IF ( N_A_AE_SPC .GT. 0 ) THEN
            N_A_AE_SPCD = N_A_AE_SPC
         ELSE
            N_A_AE_SPCD = 1
         END IF

         ! Map the CGRID indices to the AGRID indices 
         !    i.e.: AVG_CONC_MAP( AGRID_IND ) = CGRID_IND
         ALLOCATE( AVG_CONC_MAP( N_ASPCS ) )
         VAR = 0
         DO V = 1, N_A_GC_SPC
            VAR = VAR + 1
            AVG_CONC_MAP( VAR ) = GC_MAP( V )
         END DO

         DO V = 1, N_A_AE_SPC
            VAR = VAR + 1
            AVG_CONC_MAP( VAR ) = AE_MAP( V )
         END DO

         DO V = 1, N_A_NR_SPC
            VAR = VAR + 1
            AVG_CONC_MAP( VAR ) = NR_MAP( V )
         END DO

         DO V = 1, N_A_TR_SPC
            VAR = VAR + 1
            AVG_CONC_MAP( VAR ) = TR_MAP( V )
         END DO

         ! Deallocate arrays if they are unused
         DEALLOCATE( GC_MAP, AE_MAP, NR_MAP, TR_MAP )
         IF ( N_A_GC_SPC .EQ. 0 ) DEALLOCATE ( A_GC_SPC )
         IF ( N_A_AE_SPC .EQ. 0 ) DEALLOCATE ( A_AE_SPC )
         IF ( N_A_NR_SPC .EQ. 0 ) DEALLOCATE ( A_NR_SPC )
         IF ( N_A_TR_SPC .EQ. 0 ) DEALLOCATE ( A_TR_SPC )

         END SUBROUTINE A_CONC_DEFN

      END MODULE AVG_CONC

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_READ

C-----------------------------------------------------------------------
C Function: To read the Process Analysis input commmand file 
 
C Preconditions: None
  
C Key Subroutines/Functions Called: GETCHR
C                                   GETCYCLE
C                                   GETDESC
C                                   GETFAMILY
C                                   GETIPROUT
C                                   GETIRROUT
C                                   GETRXNSUM
C                                   GETWORD
C                                   RDLINE 
 
C Revision History:
C  Prototype created by Jerry Gipson, May, 1997
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Fixed default domain problem, Jerry Gipson, Feb '98
C  Updated May 2002 by Jerry Gipson for dynamic allocation version of CCTM
C  Updated August 2004 by Jerry Gipson to get input file path from environment variables
C  Modified output_domain error message, J. Gipson Aug '04 
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI`s M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
      USE UTILIO_DEFN
      USE PA_GLOBAL     ! Mech and Grid data used 
      USE PA_VARS
      USE PA_DEFN, Only: LIPR, LIRR, NIPRVAR, NIRRVAR,
     &                   IRRNAME, IRRDESC, LPARTIRR, LFULLIRR, N_IPR_SPC
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters:
      ! env var for the Process Analysis Control Module input file name
      CHARACTER( 16 ), PARAMETER :: PACM_INFILE = 'PACM_INFILE'  
      CHARACTER( 16 ), PARAMETER :: PNAME = 'PA_READ'  

C External Functions: 

C Local Variables:
      CHARACTER( 16 ) :: CMND       ! Current command being processed
      CHARACTER( 16 ) :: LASTCMND   ! Previous command processed

      INTEGER NDOMAIN    ! Number of GETDOMIN calls
      INTEGER ASTAT      ! Memory allocation status

      LOGICAL LIRRTYPE   ! Flag for input IRRTYPE command
      LOGICAL LIRRNONE   ! Flag for no IRR analysis
      LOGICAL LRDONLY    ! Flag for read only file
      LOGICAL LFMTTED    ! Flag for formatted file

C-----------------------------------------------------------------------
 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Open irr mb file and get the first non-comment line
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LRDONLY = .TRUE.
      LFMTTED = .TRUE.

      IFILE = GETEFILE ( PACM_INFILE, LRDONLY, LFMTTED, PNAME )
      IF ( IFILE .LT. 0 ) THEN
         MSG = 'PACM_INFILE not found; looking for pa.inp'
         CALL M3MESG( MSG )
         IFILE = GETEFILE ( 'pa.inp', LRDONLY, LFMTTED, PNAME )
         IF ( IFILE .LT. 0 ) THEN 
            MSG = 'ERROR: Could not open PACM input file'
            CALL M3EXIT( PNAME, IZERO, IZERO, MSG, XSTAT2 )
         END IF
      END IF
 
      LINNUM  = 0
      NDOMAIN = 0
      LIRRTYPE = .FALSE.
      LIRRNONE = .FALSE.
      CALL RDLINE
      CALL GETCHR
      CALL GETWORD

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Process the IRRTYPE command if it is present
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( WORD .EQ. 'IRRTYPE' ) THEN
         LIRRTYPE = .TRUE.
         IF ( CHR .NE. '=' ) THEN
            WRITE( MSG, 94060 ) 
            CALL M3MESG( MSG )
            WRITE( MSG, 94000 ) LINNUM, INBUF
            CALL M3MESG( MSG )
            WRITE( MSG, 94020 ) CHR
            CALL M3MESG( MSG )
            CALL M3EXIT( PNAME, IZERO, IZERO, ' ', XSTAT2 )
         END IF
         CALL GETCHR
         CALL GETWORD
         IF ( WORD .EQ. 'FULL' ) THEN
            LFULLIRR = .TRUE.
            LPARTIRR = .FALSE.
         ELSE IF ( WORD .EQ. 'PARTIAL' ) THEN
            LFULLIRR = .FALSE.
            LPARTIRR = .TRUE.
         ELSE IF ( WORD .EQ. 'NONE' ) THEN
            LIRRNONE = .TRUE.
            LFULLIRR = .FALSE.
            LPARTIRR = .FALSE.             
         ELSE
            WRITE( MSG, 94080 ) 
            CALL M3MESG( MSG )
            WRITE( MSG, 94000 ) LINNUM, INBUF
            CALL M3MESG( MSG )
            WRITE( MSG, 94040 ) WORD
            CALL M3MESG( MSG )
            CALL M3EXIT( PNAME, IZERO, IZERO, ' ', XSTAT2 )
         END IF
         IF ( CHR .NE. ';' ) THEN
            WRITE( MSG, 94100 ) 
            CALL M3MESG( MSG )
            WRITE( MSG, 94000 ) LINNUM, INBUF
            CALL M3MESG( MSG )
            WRITE( MSG, 94020 ) CHR
            CALL M3MESG( MSG )
            CALL M3EXIT( PNAME, IZERO, IZERO, ' ', XSTAT2 )
         ELSE
            CALL GETCHR
            CALL GETWORD
         END IF
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Top of loop for processing remaining commands
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
20    CONTINUE
      CMND = WORD
      IF ( WORD .EQ. 'DEFINE' ) THEN
         CALL GETWORD
         IF ( WORD .EQ. 'FAMILY' ) THEN 
            CALL GETFAMILY
         ELSE IF ( WORD .EQ. 'RXNSUM' ) THEN
            CALL GETRXNSUM
         ELSE IF ( WORD .EQ. 'CYCLE' ) THEN
            CALL GETCYCLE
         ELSE
            WRITE( MSG, 94120 ) 
            CALL M3MESG( MSG )
            WRITE( MSG, 94000 ) LINNUM, INBUF
            CALL M3MESG( MSG )
            WRITE( MSG,94040 ) WORD
            CALL M3MESG( MSG )
            CALL M3EXIT( PNAME, IZERO, IZERO, ' ', XSTAT2 )
         END IF
      ELSE IF ( WORD .EQ. 'IPR_OUTPUT' ) THEN
         CALL GETIPROUT
      ELSE IF ( WORD .EQ. 'IRR_OUTPUT' ) THEN
         CALL GETIRROUT
      ELSE IF ( WORD .EQ. 'DESCRIPTION' ) THEN
         CALL GETDESC( LASTCMND )
      ELSE IF ( WORD .EQ. 'ENDPA' ) THEN
         GO TO 100
      ELSE
         WRITE( MSG, 94140 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94000 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94040 ) WORD
         CALL M3MESG( MSG )
         CALL M3EXIT( PNAME, IZERO, IZERO, ' ', XSTAT2 )
      END IF
      LASTCMND = CMND
      CALL GETWORD
      GO TO 20

100   CONTINUE

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Set the control parameters
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c..LIPR -- for integrated process rates
      IF ( N_IPR_SPC .GT. 0 ) THEN
         LIPR = .TRUE.
      ELSE
         LIPR = .FALSE.
      END IF

c..LIRR -- for integrated reaction rates
      IF ( LFULLIRR ) THEN
         LIRR    = .TRUE.
         NIRRVAR = NRXNS
      ELSE IF ( LPARTIRR ) THEN
         LIRR    = .TRUE.
         NIRRVAR = NIRROUT
      ELSE
         LIRR = .FALSE.
      END IF

      NIPRVAR = MAX( NIPRVAR, 1 )
      NIRRVAR = MAX( NIRRVAR, 1 )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Allocate file variables
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      ALLOCATE ( IRRNAME( NIRRVAR ),
     &           IRRDESC( NIRRVAR ), STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         WRITE( MSG, 94460 )
         CALL M3EXIT( PNAME, IZERO, IZERO, MSG, XSTAT2 )
      END IF
      IRRNAME = IRRNAME_TMP( 1:NIRRVAR )
      IRRDESC = IRRDESC_TMP( 1:NIRRVAR )

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Print Warning messages for inconsistencies,omissions, etc.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LIRRTYPE ) THEN
         IF ( LFULLIRR .AND. NIRROUT .GT. 0 ) THEN
            WRITE( MSG, 94240 ) 
            CALL M3MESG( MSG )
            WRITE( MSG, 94260 ) 
            CALL M3MESG( MSG )
         ELSE IF ( LPARTIRR .AND. NIRROUT .EQ. 0 ) THEN
            LPARTIRR = .FALSE.
            WRITE( MSG, 94280 ) 
            CALL M3MESG( MSG )
            WRITE( MSG, 94300 ) 
            CALL M3MESG( MSG )
         ELSE IF ( LIRRNONE .AND. NIRROUT .GT. 0 ) THEN
            WRITE( MSG, 94320 ) 
            CALL M3MESG( MSG )
            WRITE( MSG, 94340 ) 
            CALL M3MESG( MSG )
         END IF
      ELSE
         IF ( NIRROUT .GT. 0 ) THEN
            LPARTIRR = .TRUE.
            LFULLIRR = .FALSE.
            WRITE( MSG, 94360 ) 
            CALL M3MESG( MSG )
            WRITE( MSG, 94380 ) 
            CALL M3MESG( MSG )
         END IF
      END IF            
      RETURN 

C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( '   Line No. ', I4, ': ', A )
94020 FORMAT( '   Character found: ', A )
94040 FORMAT( '   Word found: ', A )
94060 FORMAT( 'ERROR: Equal sign expected after IRRTYPE' )
94080 FORMAT( 'ERROR: FULL, PARTIAL, or NONE must follow IRRTYPE' )
94100 FORMAT( 'ERROR: A ; must follow FULL, PARTIAL, or NONE' )
94120 FORMAT( 'ERROR: FAMILY, RXNSUM, OR CYCLE must follow the DEFINE',
     &                 ' command' )
94140 FORMAT( 'ERROR: Invalid command' )
94240 FORMAT( 'WARNING: LIRRTYPE = FULL but PARTIAL commands included' )
94260 FORMAT( '         A FULL IRR analysis will be assumed' )
94280 FORMAT( 'WARNING: LIRRTYPE = PARTIAL but no PARTIAL commands',
     &                    ' included' )
94300 FORMAT( '         No IRR outputs will be generated' )
94320 FORMAT( 'WARNING: LIRRTYPE = NONE but PARTIAL IRR commands', 
     &                     ' included' )
94340 FORMAT( '          No IRR outputs will be generated' )
94360 FORMAT( 'WARNING: LIRRTYPE not specified but PARTIAL commands',
     &                     ' included' )
94380 FORMAT( '         A PARTIAL IRR analysis will be generated' )  
94460 FORMAT( 'ERROR: Unable to allocate IRRNAME or IRRDESC memory' )

      END SUBROUTINE PA_READ

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/plrise/smoke/oppt3d_diag.F,v 1.3 2011/10/21 16:11:31 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPPT3D_DIAG( PT3DNAME, TSTEP, 
     &                        N_SPC, SPEC_NAME, SPEC_UNITS )

C-----------------------------------------------------------------------
 
C  Description:
C    Opens the output 3d point source emissions diagnostic file
 
C  Preconditions:
 
C  Subroutines and Functions Called:
C       I/O API 

C Revision History:
C      4 Sep 2007 J.Young: initial
C     29 Jan 2010 D. Wong: Eliminate potential race condition at the MYPE = 0
C                          to open the diagnostic file. Eliminate the BARRIER
C                          and the CLOSE3 and OPEN3.
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     Aug 2015 D. Wong:    Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O
C                            implementation
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
      USE DESID_VARS, ONLY : DESID_LAYS
      USE MIO_ASCII

      IMPLICIT NONE
 
C Includes:

C External Functions:

C Local Parameters:

C Arguments:
      CHARACTER( 16 ), INTENT( IN ) :: PT3DNAME ! diagnostic file logical name
      INTEGER,         INTENT( IN ) :: TSTEP    ! time step (HHMMSS)
      INTEGER,         INTENT( IN ) :: N_SPC    ! number of point source surrogates
      CHARACTER( 16 ), INTENT( IN ) :: SPEC_NAME( N_SPC )  ! species names
      CHARACTER( 16 ), INTENT( IN ) :: SPEC_UNITS( N_SPC ) ! units

C Local variables:

      INTEGER L, V, IOS
      CHARACTER( 256 ) :: XMSG      ! buffer for M3EXIT() messages
      CHARACTER( 256 ) :: RET_VAL   ! env var returned value
      CHARACTER(  16 ) :: PNAME = 'OPPT3DDIAG'   ! procedure name

C-----------------------------------------------------------------------

#ifndef mpas
C Set output file characteristics based on GRID_CONF module and open the 3D emis file

      FTYPE3D = GRDDED3
      SDATE3D = STDATE
      STIME3D = STTIME
      TSTEP3D = TSTEP
      NCOLS3D = GL_NCOLS
      NROWS3D = GL_NROWS
      NLAYS3D = DESID_LAYS
      NTHIK3D = 1
      NVARS3D = N_SPC
      GDTYP3D = GDTYP_GD
      P_ALP3D = P_ALP_GD
      P_BET3D = P_BET_GD
      P_GAM3D = P_GAM_GD
      XORIG3D = XORIG_GD
      YORIG3D = YORIG_GD
      XCENT3D = XCENT_GD
      YCENT3D = YCENT_GD
      XCELL3D = XCELL_GD
      YCELL3D = YCELL_GD
      VGTYP3D = VGTYP_GD
      VGTOP3D = VGTOP_GD
      GDNAM3D = GRID_NAME  ! from HGRD_DEFN

      DO L = 1, NLAYS3D + 1
         VGLVS3D( L ) = VGLVS_GD( L )
      END DO

      VNAME3D = ' '     ! array
      DO V = 1, N_SPC
         VNAME3D( V ) = SPEC_NAME( V )
      END DO

      VTYPE3D = 0       ! array
      VTYPE3D( 1:NVARS3D ) = M3REAL

      UNITS3D = ' '     ! array
      DO V = 1, N_SPC
         UNITS3D( V ) = SPEC_UNITS( V )
      END DO

      VDESC3D = ' '     ! array
      DO V = 1, N_SPC
         VDESC3D( V ) = 'Model species: ' // TRIM( SPEC_NAME( V ) )
      END DO

      FDESC3D = ' '  ! array
      FDESC3D( 1 ) = 'gridded hourly point source layered emissions'
      FDESC3D( 2 ) = '/From/ ' // PNAME
      FDESC3D( 3 ) = '/Version/ Inline'

      ! Store MIO Metadata
      NDIMS3D( 1:NVARS3D ) = 4
      L_TSTEP( 1:NVARS3D ) = .True.
      L_LAY  ( 1:NVARS3D ) = .True.
      L_COL  ( 1:NVARS3D ) = .True.
      L_ROW  ( 1:NVARS3D ) = .True.
      L_VEXT ( 1:NVARS3D ) = .False.

      CALL LOAD_MIO_FILE ( PT3DNAME, NLAYS3D, 1, NLAYS3D,
     &     VNAME3D(1:NVARS3D), VTYPE3D(1:NVARS3D), UNITS3D(1:NVARS3D),
     &     VDESC3D(1:NVARS3D), NDIMS3D(1:NVARS3D), L_TSTEP(1:NVARS3D),
     &     L_LAY(1:NVARS3D),   L_COL(1:NVARS3D),   L_ROW(1:NVARS3D),
     &     L_VEXT(1:NVARS3D) )


C create header

      IF ( IO_PE_INCLUSIVE ) THEN   ! open new
         IF ( .NOT. OPEN3( PT3DNAME, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not open ' // TRIM( PT3DNAME )
            CALL M3EXIT( PNAME, STDATE, STTIME, XMSG, XSTAT1 )
         END IF
      END IF
#endif

      RETURN

      END SUBROUTINE OPPT3D_DIAG

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_slice_module.f,v 1.2 2006/02/15 14:41:56 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   use F90 interface feature to achieve "faked" polymorphism for data
C   slicing routine
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C   Add integer data 12/16/00 by Jeff Young
C --------------------------------------------------------------------------

        module se_slice_module

        implicit none

        interface se_slice
          module procedure se_slice1i, se_slice1r,
     &                     se_slice2i, se_slice2r,
     &                     se_slice3i, se_slice3r,
     &                     se_slice4i, se_slice4r
        end interface

        contains

C --------------------------------------------------------------------------
C Purpose:
C
C   to perform transferring a slice of a 1-D integer data 
C
C Revision history:
C
C   Orginal version: 5/26/99 by David Wong 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and 
C                          I/O processors partition scheme
C
C Subroutine parameter description:
C
C   In:  data     -- original data
C        sourcepe -- source PE
C        destpe   -- target PE
C        sdim     -- slicing dimension
C        from     -- index of the slicing source
C        to       -- index of the slicing destination
C
C   Out: data     -- original data after communication
C
C Local variable description:
C
C    status     -- return status of MPI_RECEIVING call
C    error      -- error code of invoking MPI calls
C
C Include file:
C
C    se_pe_info.ext
C
C Subroutine/Function call:
C
C   mpi_send
C   mpi_recv
C
C --------------------------------------------------------------------------

        subroutine se_slice1i (data, sourcepe, destpe, sdim, from, to)

        use se_pe_info_ext

        implicit none

        include "mpif.h"

        integer, intent(inout) :: data(:)
        integer, intent(in) :: sourcepe, destpe, sdim, from, to

        integer :: error
        integer :: status(MPI_STATUS_SIZE)

        if ((sourcepe .ge. 0) .and. (destpe .ge. 0) .and. 
     &      (sourcepe .ne. destpe)) then
           if (se_myworker_pe .eq. sourcepe) then

C -- send data to corresponding processor 

              call mpi_send (data(from), 1, mpi_integer, destpe,
     &                       sourcepe, se_worker_comm, error)

           else if (se_myworker_pe .eq. destpe) then

C -- receive data from corresponding processor

              call mpi_recv (data(to), 1, mpi_integer, sourcepe,
     &                       sourcepe, se_worker_comm, status, error)

           end if
        end if

        return
        end subroutine se_slice1i

C --------------------------------------------------------------------------
C Purpose:
C
C   to perform transferring a slice of a 1-D real data 
C
C Revision history:
C
C   Orginal version: 5/26/99 by David Wong 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Subroutine parameter description:
C
C   In:  data     -- original data
C        sourcepe -- source PE
C        destpe   -- target PE
C        sdim     -- slicing dimension
C        from     -- index of the slicing source
C        to       -- index of the slicing destination
C
C   Out: data     -- original data after communication
C
C Local variable description:
C
C    status     -- return status of MPI_RECEIVING call
C    error      -- error code of invoking MPI calls
C
C Include file:
C
C    se_pe_info.ext
C
C Subroutine/Function call:
C
C   mpi_send
C   mpi_recv
C
C --------------------------------------------------------------------------

        subroutine se_slice1r (data, sourcepe, destpe, sdim, from, to)

        use se_pe_info_ext

        implicit none

        include "mpif.h"

        real, intent(inout) :: data(:)
        integer, intent(in) :: sourcepe, destpe, sdim, from, to

        integer :: error
        integer :: status(MPI_STATUS_SIZE)

        if ((sourcepe .ge. 0) .and. (destpe .ge. 0) .and. 
     &      (sourcepe .ne. destpe)) then
           if (se_myworker_pe .eq. sourcepe) then

C -- send data to corresponding processor 

              call mpi_send (data(from), 1, mpi_real, destpe,
     &                       sourcepe, se_worker_comm, error)

           else if (se_myworker_pe .eq. destpe) then

C -- receive data from corresponding processor

              call mpi_recv (data(to), 1, mpi_real, sourcepe,
     &                       sourcepe, se_worker_comm, status, error)

           end if
        end if

        return
        end subroutine se_slice1r

C --------------------------------------------------------------------------
C Purpose:
C
C   transfer a slice of a 2-D integer array 
C
C Revision history:
C
C   Orginal version: 5/26/99 by David Wong 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/16/00 by Jeff Young
C                      -- mod for integer data
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C                    09/19/18 by David Wong
C                       -- removed unused variable
C
C Subroutine parameter description:
C
C   In:  data     -- original data
C        sourcepe -- source PE
C        destpe   -- target PE
C        sdim     -- slicing dimension
C        from     -- index of the slicing source
C        to       -- index of the slicing destination
C
C   Out: data     -- original data after communication
C
C Local variable description:
C
C    i, j       -- loop indexes
C    li, ui     -- local low and upper index of i dimension
C    lj, uj     -- local low and upper index of j dimension
C    status     -- return status of MPI_RECEIVING call
C    error      -- error code of invoking MPI calls
C    scount     -- number of items need to be sent
C    rcount     -- number of items are expected to receive
C    sarray     -- array to hold sending data
C    rarray     -- array to hold receiving data
C
C Include file:
C
C    se_pe_info.ext
C
C Subroutine/Function call:
C
C   mpi_send
C   mpi_recv
C
C --------------------------------------------------------------------------

        subroutine se_slice2i (data, sourcepe, destpe, sdim, from, to)

        use se_pe_info_ext

        implicit none

        include "mpif.h"
        
        integer, intent(inout) :: data(:,:)
        integer, intent(in) :: sourcepe, destpe, sdim, from, to

        integer :: error
        integer :: i, j, li, lj, ui, uj
        integer :: status(MPI_STATUS_SIZE)
        integer :: scount, rcount
        integer :: sarray(size(data)), rarray(size(data))

C -- send data to corresponding processor 

        if ((sourcepe .ge. 0) .and. (destpe .ge. 0) .and.
     &      (sourcepe .ne. destpe)) then

           li = lbound(data,1)
           ui = ubound(data,1)
           lj = lbound(data,2)
           uj = ubound(data,2)

           if (se_myworker_pe .eq. sourcepe) then

                if (sdim .eq. 1) then
                 li = from
                 ui = from
                else
                 lj = from
                 uj = from
              end if

              scount = 0
C -- pack data for sending
              do j = lj, uj
                 do i = li, ui
                    scount = scount + 1
                    sarray(scount) = data(i,j)
                 end do
              end do

              call mpi_send (sarray, scount, mpi_integer, destpe,
     &                       sourcepe, se_worker_comm, error)

           else if (se_myworker_pe .eq. destpe) then

                   if (sdim .eq. 1) then
                 li = to
                 ui = to
                else
                 lj = to
                 uj = to
              end if

C -- receive data from corresponding processor

              rcount = (ui - li + 1) * (uj - lj + 1)

              call mpi_recv (rarray, rcount, mpi_integer, sourcepe,
     &                       sourcepe, se_worker_comm, status, error)

C -- unpack received data
              rcount = 0
              do j = lj, uj
                  do i = li, ui
                     rcount = rcount + 1
                     data(i,j) = rarray(rcount) 
                  end do
              end do

           end if
        end if

        return
        end subroutine se_slice2i

C --------------------------------------------------------------------------
C Purpose:
C
C   to perform transferring a slice of a 2-D real data 
C
C Revision history:
C
C   Orginal version: 5/26/99 by David Wong 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C                    09/19/18 by David Wong
C                       -- removed unused variable
C
C Subroutine parameter description:
C
C   In:  data     -- original data
C        sourcepe -- source PE
C        destpe   -- target PE
C        sdim     -- slicing dimension
C        from     -- index of the slicing source
C        to       -- index of the slicing destination
C
C   Out: data     -- original data after communication
C
C Local variable description:
C
C    i, j       -- loop indexes
C    li, ui     -- local low and upper index of i dimension
C    lj, uj     -- local low and upper index of j dimension
C    status     -- return status of MPI_RECEIVING call
C    error      -- error code of invoking MPI calls
C    scount     -- number of items need to be sent
C    rcount     -- number of items are expected to receive
C    sarray     -- array to hold sending data
C    rarray     -- array to hold receiving data
C
C Include file:
C
C    se_pe_info.ext
C
C Subroutine/Function call:
C
C   mpi_send
C   mpi_recv
C
C --------------------------------------------------------------------------

        subroutine se_slice2r (data, sourcepe, destpe, sdim, from, to)

        use se_pe_info_ext

        implicit none

        include "mpif.h"
        
        real, intent(inout) :: data(:,:)
        integer, intent(in) :: sourcepe, destpe, sdim, from, to

        integer :: error
        integer :: i, j, li, lj, ui, uj
        integer :: status(MPI_STATUS_SIZE)
        integer :: scount, rcount
        real :: sarray(size(data)), rarray(size(data))

C -- send data to corresponding processor 

        if ((sourcepe .ge. 0) .and. (destpe .ge. 0) .and.
     &      (sourcepe .ne. destpe)) then

           li = lbound(data,1)
           ui = ubound(data,1)
           lj = lbound(data,2)
           uj = ubound(data,2)

           if (se_myworker_pe .eq. sourcepe) then

                if (sdim .eq. 1) then
                 li = from
                 ui = from
                else
                 lj = from
                 uj = from
              end if

              scount = 0
C -- pack data for sending
              do j = lj, uj
                 do i = li, ui
                    scount = scount + 1
                    sarray(scount) = data(i,j)
                 end do
              end do

              call mpi_send (sarray, scount, mpi_real, destpe,
     &                       sourcepe, se_worker_comm, error)

           else if (se_myworker_pe .eq. destpe) then

                   if (sdim .eq. 1) then
                 li = to
                 ui = to
                else
                 lj = to
                 uj = to
              end if

C -- receive data from corresponding processor

              rcount = (ui - li + 1) * (uj - lj + 1)

              call mpi_recv (rarray, rcount, mpi_real, sourcepe,
     &                       sourcepe, se_worker_comm, status, error)

C -- unpack received data
              rcount = 0
              do j = lj, uj
                  do i = li, ui
                     rcount = rcount + 1
                     data(i,j) = rarray(rcount) 
                  end do
              end do

           end if
        end if

        return
        end subroutine se_slice2r

C --------------------------------------------------------------------------
C Purpose:
C
C   transfer a slice of a 3-D integer array 
C
C Revision history:
C
C   Orginal version: 5/26/99 by David Wong 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/16/00 by Jeff Young
C                      -- mod for integer data
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Subroutine parameter description:
C
C   In:  data     -- original data
C        sourcepe -- source PE
C        destpe   -- target PE
C        sdim     -- slicing dimension
C        from     -- index of the slicing source
C        to       -- index of the slicing destination
C
C   Out: data     -- original data after communication
C
C Local variable description:
C
C    i, j, k    -- loop indexes
C    li, ui     -- local low and upper index of i dimension
C    lj, uj     -- local low and upper index of j dimension
C    lk, uk     -- local low and upper index of k dimension
C    status     -- return status of MPI_RECEIVING call
C    error      -- error code of invoking MPI calls
C    scount     -- number of items need to be sent
C    rcount     -- number of items are expected to receive
C    sarray     -- array to hold sending data
C    rarray     -- array to hold receiving data
C
C Include file:
C
C    se_pe_info.ext
C
C Subroutine/Function call:
C
C   mpi_send
C   mpi_recv
C
C --------------------------------------------------------------------------

        subroutine se_slice3i (data, sourcepe, destpe, sdim, from, to)

        use se_pe_info_ext

        implicit none

        integer, intent(inout) :: data(:,:,:)
        integer, intent(in) :: sourcepe, destpe, sdim, from, to

        include "mpif.h"
        
        integer :: error
        integer :: i, j, k, li, lj, lk, ui, uj, uk
        integer :: status(MPI_STATUS_SIZE)
        integer :: scount, rcount
        integer :: sarray(size(data)), rarray(size(data))

        if ((sourcepe .ge. 0) .and. (destpe .ge. 0) .and.
     &      (sourcepe .ne. destpe)) then

C -- send data to corresponding processor 

           li = lbound(data,1)
           ui = ubound(data,1)
           lj = lbound(data,2)
           uj = ubound(data,2)
           lk = lbound(data,3)
           uk = ubound(data,3)

           if (se_myworker_pe .eq. sourcepe) then

                if (sdim .eq. 1) then
                 li = from
                 ui = from
                 else if (sdim .eq. 2) then
                 lj = from
                 uj = from
              else
                 lk = from
                 uk = from
              end if

              scount = 0
C -- pack data for sending
              do k = lk, uk
                 do j = lj, uj
                    do i = li, ui
                       scount = scount + 1
                       sarray(scount) = data(i,j,k)
                    end do
                 end do
              end do

              call mpi_send (sarray, scount, mpi_integer, destpe,
     &                       sourcepe, se_worker_comm, error)

           else if (se_myworker_pe .eq. destpe) then

                if (sdim .eq. 1) then
                 li = to
                 ui = to
                else if (sdim .eq. 2) then
                 lj = to
                 uj = to
              else
                 lk = to
                 uk = to
              end if

C -- receive data from corresponding processor

              rcount = (ui - li + 1) * (uj - lj + 1) * (uk - lk + 1)

              call mpi_recv (rarray, rcount, mpi_integer, sourcepe,
     &                       sourcepe, se_worker_comm, status, error)

C -- unpack received data
              rcount = 0
              do k = lk, uk
                 do j = lj, uj
                    do i = li, ui
                       rcount = rcount + 1
                       data(i,j,k) = rarray(rcount) 
                    end do
                 end do
              end do

           end if
        end if

        return
        end subroutine se_slice3i

C --------------------------------------------------------------------------
C Purpose:
C
C   to perform transferring a slice of a 3-D data 
C
C Revision history:
C
C   Orginal version: 5/26/99 by David Wong 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Subroutine parameter description:
C
C   In:  data     -- original data
C        sourcepe -- source PE
C        destpe   -- target PE
C        sdim     -- slicing dimension
C        from     -- index of the slicing source
C        to       -- index of the slicing destination
C
C   Out: data     -- original data after communication
C
C Local variable description:
C
C    i, j, k    -- loop indexes
C    li, ui     -- local low and upper index of i dimension
C    lj, uj     -- local low and upper index of j dimension
C    lk, uk     -- local low and upper index of k dimension
C    status     -- return status of MPI_RECEIVING call
C    error      -- error code of invoking MPI calls
C    scount     -- number of items need to be sent
C    rcount     -- number of items are expected to receive
C    sarray     -- array to hold sending data
C    rarray     -- array to hold receiving data
C
C Include file:
C
C    se_pe_info.ext
C
C Subroutine/Function call:
C
C   mpi_send
C   mpi_recv
C
C --------------------------------------------------------------------------

        subroutine se_slice3r (data, sourcepe, destpe, sdim, from, to)

        use se_pe_info_ext

        implicit none

        real, intent(inout) :: data(:,:,:)
        integer, intent(in) :: sourcepe, destpe, sdim, from, to

        include "mpif.h"
        
        integer :: error
        integer :: i, j, k, li, lj, lk, ui, uj, uk
        integer :: status(MPI_STATUS_SIZE)
        integer :: scount, rcount
        real :: sarray(size(data)), rarray(size(data))

        if ((sourcepe .ge. 0) .and. (destpe .ge. 0) .and.
     &      (sourcepe .ne. destpe)) then

C -- send data to corresponding processor 

           li = lbound(data,1)
           ui = ubound(data,1)
           lj = lbound(data,2)
           uj = ubound(data,2)
           lk = lbound(data,3)
           uk = ubound(data,3)

           if (se_myworker_pe .eq. sourcepe) then

                if (sdim .eq. 1) then
                 li = from
                 ui = from
                 else if (sdim .eq. 2) then
                 lj = from
                 uj = from
              else
                 lk = from
                 uk = from
              end if

              scount = 0
C -- pack data for sending
              do k = lk, uk
                 do j = lj, uj
                    do i = li, ui
                       scount = scount + 1
                       sarray(scount) = data(i,j,k)
                    end do
                 end do
              end do

              call mpi_send (sarray, scount, mpi_real, destpe,
     &                       sourcepe, se_worker_comm, error)

           else if (se_myworker_pe .eq. destpe) then

                if (sdim .eq. 1) then
                 li = to
                 ui = to
                else if (sdim .eq. 2) then
                 lj = to
                 uj = to
              else
                 lk = to
                 uk = to
              end if

C -- receive data from corresponding processor

              rcount = (ui - li + 1) * (uj - lj + 1) * (uk - lk + 1)

              call mpi_recv (rarray, rcount, mpi_real, sourcepe,
     &                       sourcepe, se_worker_comm, status, error)

C -- unpack received data
              rcount = 0
              do k = lk, uk
                 do j = lj, uj
                    do i = li, ui
                       rcount = rcount + 1
                       data(i,j,k) = rarray(rcount) 
                    end do
                 end do
              end do

           end if
        end if

        return
        end subroutine se_slice3r

C --------------------------------------------------------------------------
C Purpose:
C
C   transfer a slice of a 4-D integer array
C
C Revision history:
C
C   Orginal version: 5/26/99 by David Wong 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/16/00 by Jeff Young
C                      -- mod for integer data
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Subroutine parameter description:
C
C   In:  data     -- original data
C        sourcepe -- source PE
C        destpe   -- target PE
C        sdim     -- slicing dimension
C        from     -- index of the slicing source
C        to       -- index of the slicing destination
C
C   Out: data     -- original data after communication
C
C Local variable description:
C
C    i, j, k, l -- loop indexes
C    li, ui     -- local low and upper index of i dimension
C    lj, uj     -- local low and upper index of j dimension
C    lk, uk     -- local low and upper index of k dimension
C    ll, ul     -- local low and upper index of l dimension
C    status     -- return status of MPI_RECEIVING call
C    error      -- error code of invoking MPI calls
C    scount     -- number of items need to be sent
C    rcount     -- number of items are expected to receive
C    sarray     -- array to hold sending data
C    rarray     -- array to hold receiving data
C
C Include file:
C
C    se_pe_info.ext
C
C Subroutine/Function call:
C
C   mpi_send
C   mpi_recv
C
C --------------------------------------------------------------------------

        subroutine se_slice4i (data, sourcepe, destpe, sdim, from, to)

        use se_pe_info_ext

        implicit none

        include "mpif.h"
        
        integer, intent(inout) :: data(:,:,:,:)
        integer, intent(in) :: sourcepe, destpe, sdim, from, to

        integer :: error
        integer :: i, j, k, l, li, lj, lk, ll, ui, uj, uk, ul
        integer :: status(MPI_STATUS_SIZE)
        integer :: scount, rcount
        integer :: sarray(size(data)), rarray(size(data))

        if ((sourcepe .ge. 0) .and. (destpe .ge. 0) .and.
     &      (sourcepe .ne. destpe)) then

C -- send data to corresponding processor 

           li = lbound(data,1)
           ui = ubound(data,1)
           lj = lbound(data,2)
           uj = ubound(data,2)
           lk = lbound(data,3)
           uk = ubound(data,3)
           ll = lbound(data,4)
           ul = ubound(data,4)

           if (se_myworker_pe .eq. sourcepe) then

                  if (sdim .eq. 1) then
                 li = from
                 ui = from
                else if (sdim .eq. 2) then
                 lj = from
                 uj = from
                else if (sdim .eq. 3) then
                 lk = from
                 uk = from
              else
                 ll = from
                 ul = from
              end if

              scount = 0
C -- pack data for sending
              do l = ll, ul
                 do k = lk, uk
                    do j = lj, uj
                       do i = li, ui
                          scount = scount + 1
                          sarray(scount) = data(i,j,k,l)
                       end do
                    end do
                 end do
              end do

              call mpi_send (sarray, scount, mpi_integer, destpe,
     &                       sourcepe, se_worker_comm, error)

           else if (se_myworker_pe .eq. destpe) then

                if (sdim .eq. 1) then
                 li = to
                 ui = to
                else if (sdim .eq. 2) then
                 lj = to
                 uj = to
                else if (sdim .eq. 3) then
                 lk = to
                 uk = to
              else
                 ll = to
                 ul = to
              end if

C -- receive data from corresponding processor

              rcount =   (ui - li + 1) * (uj - lj + 1)
     &                 * (uk - lk + 1) * (ul - ll + 1) 

              call mpi_recv (rarray, rcount, mpi_integer, sourcepe,
     &                       sourcepe, se_worker_comm, status, error)

C -- unpack received data
              rcount = 0
              do l = ll, ul
                 do k = lk, uk
                    do j = lj, uj
                       do i = li, ui
                          rcount = rcount + 1
                          data(i,j,k,l) = rarray(rcount) 
                       end do
                    end do
                 end do
              end do

           end if
        end if

        return
        end subroutine se_slice4i

C --------------------------------------------------------------------------
C Purpose:
C
C   to perform transferring a slice of a 4-D real data 
C
C Revision history:
C
C   Orginal version: 5/26/99 by David Wong 
C                    11/05/99 by David Wong
C                      -- recode the code using F90 syntax
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Subroutine parameter description:
C
C   In:  data     -- original data
C        sourcepe -- source PE
C        destpe   -- target PE
C        sdim     -- slicing dimension
C        from     -- index of the slicing source
C        to       -- index of the slicing destination
C
C   Out: data     -- original data after communication
C
C Local variable description:
C
C    i, j, k, l -- loop indexes
C    li, ui     -- local low and upper index of i dimension
C    lj, uj     -- local low and upper index of j dimension
C    lk, uk     -- local low and upper index of k dimension
C    ll, ul     -- local low and upper index of l dimension
C    status     -- return status of MPI_RECEIVING call
C    error      -- error code of invoking MPI calls
C    scount     -- number of items need to be sent
C    rcount     -- number of items are expected to receive
C    sarray     -- array to hold sending data
C    rarray     -- array to hold receiving data
C
C Include file:
C
C    se_pe_info.ext
C
C Subroutine/Function call:
C
C   mpi_send
C   mpi_recv
C
C --------------------------------------------------------------------------

        subroutine se_slice4r (data, sourcepe, destpe, sdim, from, to)

        use se_pe_info_ext

        implicit none

        include "mpif.h"
        
        real, intent(inout) :: data(:,:,:,:)
        integer, intent(in) :: sourcepe, destpe, sdim, from, to

        integer :: error
        integer :: i, j, k, l, li, lj, lk, ll, ui, uj, uk, ul
        integer :: status(MPI_STATUS_SIZE)
        integer :: scount, rcount
        real :: sarray(size(data)), rarray(size(data))

        if ((sourcepe .ge. 0) .and. (destpe .ge. 0) .and.
     &      (sourcepe .ne. destpe)) then

C -- send data to corresponding processor 

           li = lbound(data,1)
           ui = ubound(data,1)
           lj = lbound(data,2)
           uj = ubound(data,2)
           lk = lbound(data,3)
           uk = ubound(data,3)
           ll = lbound(data,4)
           ul = ubound(data,4)

           if (se_myworker_pe .eq. sourcepe) then

                  if (sdim .eq. 1) then
                 li = from
                 ui = from
                else if (sdim .eq. 2) then
                 lj = from
                 uj = from
                else if (sdim .eq. 3) then
                 lk = from
                 uk = from
              else
                 ll = from
                 ul = from
              end if

              scount = 0
C -- pack data for sending
              do l = ll, ul
                 do k = lk, uk
                    do j = lj, uj
                       do i = li, ui
                          scount = scount + 1
                          sarray(scount) = data(i,j,k,l)
                       end do
                    end do
                 end do
              end do

              call mpi_send (sarray, scount, mpi_real, destpe,
     &                       sourcepe, se_worker_comm, error)

           else if (se_myworker_pe .eq. destpe) then

                if (sdim .eq. 1) then
                 li = to
                 ui = to
                else if (sdim .eq. 2) then
                 lj = to
                 uj = to
                else if (sdim .eq. 3) then
                 lk = to
                 uk = to
              else
                 ll = to
                 ul = to
              end if

C -- receive data from corresponding processor

              rcount =   (ui - li + 1) * (uj - lj + 1)
     &                 * (uk - lk + 1) * (ul - ll + 1) 

              call mpi_recv (rarray, rcount, mpi_real, sourcepe,
     &                       sourcepe, se_worker_comm, status, error)

C -- unpack received data
              rcount = 0
              do l = ll, ul
                 do k = lk, uk
                    do j = lj, uj
                       do i = li, ui
                          rcount = rcount + 1
                          data(i,j,k,l) = rarray(rcount) 
                       end do
                    end do
                 end do
              end do

           end if
        end if

        return
        end subroutine se_slice4r

        end module se_slice_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE X_PPM ( CGRID, FDATE, FTIME, TSTEP, LVL, BCON )

C-----------------------------------------------------------------------
C Function:
C   Piecewise Parabolic Method advection in the X-direction

C Preconditions:

C Subroutines and functions called:

C Revision history:
C  28 Jun 2004: Jeff Young

C   1 Nov 06: Jeff Young - Following Glenn Hammond, moved all communication
C   out of HPPM to this level; using "swap_sandia" communication; update only
C   local values in the CGRID array within a time step, discarding previous
C   ghost values.
C   11 May 2009: Jeff Young: Simplify - assume constant cell widths, DS( i )
C   11 May 2010: Jeff Young: New hppm fix for PGI compiler by David Wong
C   21 Jun 2010: Jeff Young: convert for Namelist redesign
C   16 Feb 2011: Shawn Roselle: replaced I/O API include files with UTILIO_DEFN
C   19 Oct 2015: Jeff Young: Remove stmnt func to resolve PGI compiler error
C   29 Nov 17 David Wong: removed all SWAP routines and replaced with SE_COMM
C   16 NOv 2018 S.Napelenok: ISAM implementation
C    1 Feb 19 David Wong: removed all MY_N clauses
C   11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C-----------------------------------------------------------------------

      USE HGRD_DEFN             ! horizontal domain specifications
      USE GRID_CONF, ONLY: NLAYS
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      USE PA_DEFN, ONLY : BUDGET_DIAG, BUDGET_HPPM
      USE XY_BUDGET, ONLY : F_WEST_IN, F_WEST_OUT, F_EAST_IN, F_EAST_OUT
      use CENTRALIZED_IO_MODULE, only : interpolate_var, MSFX2

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE, SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE, NOOP_UTIL_MODULE)
#endif

#ifdef isam
      USE SA_DEFN, Only: ISAM, N_SPCTAG, S_SPCTAG, T_SPCTAG, 
     &                   TRANSPORT_SPC, BCON_SPC, MAP_ADVtoSA
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY:SENGRID, NPMAX, NP, BSEN, BCS, DATENUM, IPT, IDATE, IPARM, IREGION, CKTIME, STARTDATE
#endif 
      USE CONST, ONLY: DG2M, PI180

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction

C Arguments:

      REAL,    POINTER      :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: FDATE         ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: FTIME         ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP         ! time step (HHMMSS)
      INTEGER, INTENT( IN ) :: LVL           ! layer
      REAL,    INTENT( IN ) :: BCON( :,: )      ! boundary concentrations

C External Functions not declared in IODECL3.EXT:

      REAL,    EXTERNAL :: ZFDBC

C Parameters:

C Advected species dimension

      INTEGER, SAVE :: N_SPC_ADV

! #ifdef parallel
      INTEGER, PARAMETER :: SWP = 3
! #else
!     INTEGER, PARAMETER :: SWP = 1
! #endif

C File Variables:

      REAL         UHAT( NCOLS+1,NROWS+1 )       ! x1-component CX-velocity

C Local Variables:

      CHARACTER( 16 ) :: PNAME = 'X_PPM'
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 96 ) :: XMSG = ' '

      REAL,    SAVE :: DX1, DX2, AX             ! dx1 (meters), dx2(m), ax(m2)

      REAL, ALLOCATABLE, SAVE :: VELX( : ),     ! Velocities along a row
     &                           CONX( :,: )    ! Conc's along a row

#ifdef isam
      REAL, ALLOCATABLE, SAVE :: SA_CONX( :,: )
#endif

      REAL          DT                          ! TSTEP in sec
      INTEGER       ALLOCSTAT

      INTEGER, ALLOCATABLE, SAVE :: ADV_MAP( : ) ! global adv map to CGRID

      CHARACTER( 16 ) :: X1VEL = 'X1VEL'

      INTEGER      COL, ROW, SPC, VAR, I           ! loop counters
      INTEGER      A2C

      REAL     :: JACOBM( NCOLS,NROWS,NLAYS )  !"total" Jacobian
      REAL     :: ZF( NCOLS,NROWS,NLAYS )      !Grid cell height
      REAL, PARAMETER :: MWAIR_SI = 0.02897    ! kg mol-1
      REAL     :: VOL, VOL2                    ! Grid Volume

      LOGICAL, SAVE :: BNDY_PE_LOX, BNDY_PE_HIX
      REAL, ALLOCATABLE, SAVE :: F_LO_IN( : )
      REAL, ALLOCATABLE, SAVE :: F_LO_OUT( : )
      REAL, ALLOCATABLE, SAVE :: F_HI_IN( : )
      REAL, ALLOCATABLE, SAVE :: F_HI_OUT( : )

#ifdef parallel
      INTEGER EAST_COL
      REAL, ALLOCATABLE, SAVE :: HALO_EAST( :,:,: )
      REAL, ALLOCATABLE, SAVE :: HALO_WEST( :,:,: )
      REAL, ALLOCATABLE, SAVE :: BUF_EW( :,:,: )

#ifdef isam
      REAL, ALLOCATABLE, SAVE :: SA_HALO_EAST( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_HALO_WEST( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_BUF_EW( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_F_LO_IN( : )
      REAL, ALLOCATABLE, SAVE :: SA_F_LO_OUT( : )
      REAL, ALLOCATABLE, SAVE :: SA_F_HI_IN( : )
      REAL, ALLOCATABLE, SAVE :: SA_F_HI_OUT( : )
#endif

#endif

      INTEGER, SAVE :: EFX    ! fixed parameter for eastern boundary
      INTEGER, SAVE :: WFX    ! fixed parameter for western boundary

#ifdef sens
      LOGICAL TIMEFLAG                  ! checks if within desired time
      REAL, ALLOCATABLE, SAVE :: SENX( :,: )      ! Sens along a row
      REAL,    EXTERNAL :: S_ZFDBC   ! similar to zfdbc, for sens
#ifdef parallel
      REAL, ALLOCATABLE, SAVE :: S_HALO_EAST( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: S_HALO_WEST( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: S_BUF_EW( :,:,:,: )
#endif
#endif

C Required interface for allocatable array dummy arguments

      INTERFACE
         SUBROUTINE HCONTVEL( FDATE, FTIME, TSTEP, LVL, UORV, UHAT )
            INTEGER, INTENT( IN )         :: FDATE, FTIME, TSTEP, LVL
            CHARACTER( 16 ), INTENT( IN ) :: UORV
            REAL,    INTENT( OUT )        :: UHAT( :,: )
         END SUBROUTINE HCONTVEL
         SUBROUTINE HPPM ( NI, NJ, CON, VEL, DT, DS, ORI,
     &               F_LO_IN, F_LO_OUT, F_HI_IN, F_HI_OUT )
! #ifdef parallel
            INTEGER, PARAMETER         :: SWP = 3
! #else
!           INTEGER, PARAMETER         :: SWP = 1
! #endif
            INTEGER,   INTENT( IN )    :: NI, NJ
            REAL,      INTENT( INOUT ) :: CON( 1-SWP:,1: )
            REAL,      INTENT( IN )    :: VEL( : )
            REAL,      INTENT( IN )    :: DT
            REAL,      INTENT( IN )    :: DS
            CHARACTER, INTENT( IN )    :: ORI
            REAL     , INTENT( OUT)    :: F_LO_IN( : )
            REAL     , INTENT( OUT)    :: F_LO_OUT( : )
            REAL     , INTENT( OUT)    :: F_HI_IN( : )
            REAL     , INTENT( OUT)    :: F_HI_OUT( : )
         END SUBROUTINE HPPM
      END INTERFACE
C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         EFX = NCOLS + 1
         WFX = 2 * NCOLS + NROWS + 4

C Get dx1 from HGRD_DEFN module

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD
     &          * COS( PI180*( YORIG_GD + YCELL_GD*FLOAT( GL_NROWS/2 ))) ! in m.
            DX2 = DG2M * YCELL_GD
         ELSE
            DX1 = XCELL_GD        ! in m.
            DX2 = YCELL_GD        ! in m.
         END IF
         AX = DX1 * DX2  ! in m2

         N_SPC_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV + 1
                                                  ! add 1 for advecting RHOJ

         ALLOCATE ( CONX( 1-SWP:NCOLS+SWP,N_SPC_ADV ),
#ifdef isam
     &           SA_CONX( 1-SWP:NCOLS+SWP,N_SPCTAG ), ! 20120816
#endif
     &              VELX( NCOLS+1 ), STAT = ALLOCSTAT ) ! Vel along a row
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating VELX, or CONX'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
#ifdef isam
         SA_CONX = 0.0
#endif
         ALLOCATE ( ADV_MAP( N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating ADV_MAP'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF

#ifdef parallel
         ALLOCATE ( HALO_EAST( SWP,NROWS,N_SPC_ADV ),
     &              HALO_WEST( SWP,NROWS,N_SPC_ADV ),
     &              BUF_EW   ( SWP,NROWS,N_SPC_ADV ),
#ifdef isam
     &              SA_HALO_EAST( SWP,NROWS,N_SPCTAG ),
     &              SA_HALO_WEST( SWP,NROWS,N_SPCTAG ),
     &              SA_BUF_EW   ( SWP,NROWS,N_SPCTAG ),
#endif
     &              STAT = ALLOCSTAT )

         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating HALO_EAST, HALO_WEST, or BUF_EW'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
         HALO_EAST = 0.0   ! array
         HALO_WEST = 0.0   ! array
         BUF_EW    = 0.0   ! array

#ifdef isam
         SA_HALO_EAST = 0.0   ! KRT array
         SA_HALO_WEST = 0.0   ! KRT array
         SA_BUF_EW    = 0.0   ! KRT array
#endif

#endif

#ifdef sens
         ALLOCATE ( SENX( 1-SWP:NCOLS+SWP,N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SENX'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
#ifdef parallel
         ALLOCATE ( S_HALO_EAST( SWP,NROWS,N_SPC_ADV,NPMAX ),
     &              S_HALO_WEST( SWP,NROWS,N_SPC_ADV,NPMAX ),
     &              S_BUF_EW   ( SWP,NROWS,N_SPC_ADV,NPMAX ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG =
     &        'Failure allocating S_HALO_EAST, S_HALO_WEST, or S_BUF_EW'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
         S_HALO_EAST = 0.0   ! array
         S_HALO_WEST = 0.0   ! array
         S_BUF_EW    = 0.0   ! array
#endif
#endif

C Create global map to CGRID

         SPC = 0
         DO VAR = 1, N_GC_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = GC_STRT - 1 + GC_TRNS_MAP( VAR )
         END DO
         DO VAR = 1, N_AE_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = AE_STRT - 1 + AE_TRNS_MAP( VAR )
         END DO
         DO VAR = 1, N_NR_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = NR_STRT - 1 + NR_TRNS_MAP( VAR )
         END DO
         DO VAR = 1, N_TR_ADV
            SPC = SPC + 1
            ADV_MAP( SPC ) = TR_STRT - 1 + TR_ADV_MAP( VAR )
         END DO

         ADV_MAP( N_SPC_ADV ) = RHOJ_LOC

         CALL SUBST_HI_LO_BND_PE ( 'C', BNDY_PE_LOX, BNDY_PE_HIX )

         ! Allocate FLuxes for Budget Tool
         ALLOCATE( F_LO_IN(N_SPC_ADV),
     &             F_LO_OUT(N_SPC_ADV),
     &             F_HI_IN(N_SPC_ADV),
     &             F_HI_OUT(N_SPC_ADV) )

#ifdef isam
         ALLOCATE( SA_F_LO_IN(N_SPCTAG),
     &             SA_F_LO_OUT(N_SPCTAG),
     &             SA_F_HI_IN(N_SPCTAG),
     &             SA_F_HI_OUT(N_SPCTAG) )
#endif

      END IF                    ! if firstime

      DT = FLOAT ( TIME2SEC ( TSTEP ) )

#ifdef sens
      ! index that will be used by IDATE
      DATENUM = 1 + FDATE - STARTDATE
#endif

C Do the computation for x advection

C Get the contravariant x1 velocity component

      CALL HCONTVEL ( FDATE, FTIME, TSTEP, LVL, X1VEL, UHAT )

      CALL SUBST_COMM (UHAT, DSPL_N0_E1_S0_W0, DRCN_E)

#ifdef parallel
      EAST_COL = NCOLS - SWP
      DO SPC = 1, N_SPC_ADV
         A2C = ADV_MAP( SPC )
         DO ROW = 1, NROWS
            DO COL = 1, SWP
               HALO_WEST( COL,ROW,SPC ) = CGRID( COL,ROW,LVL,A2C )
               HALO_EAST( COL,ROW,SPC ) = CGRID( EAST_COL+COL,ROW,LVL,A2C )
               BUF_EW( COL,ROW,SPC ) = HALO_EAST( COL,ROW,SPC )
#ifdef sens
               DO NP = 1, NPMAX
                  S_HALO_WEST( COL,ROW,SPC,NP ) = SENGRID( COL,ROW,LVL,NP,A2C )
                  S_HALO_EAST( COL,ROW,SPC,NP ) = SENGRID( EAST_COL+COL,ROW,LVL,NP,A2C )
                  S_BUF_EW( COL,ROW,SPC,NP ) = S_HALO_EAST( COL,ROW,SPC,NP )
               END DO
#endif
            END DO
         END DO
      END DO

      CALL SUBST_COMM (HALO_WEST, HALO_EAST, DSPL_N0_E1_S0_W0, DRCN_E)
      CALL SUBST_COMM (BUF_EW,    HALO_WEST, DSPL_N0_E0_S0_W1, DRCN_W)

#ifdef sens
      DO NP = 1, NPMAX
         CALL SUBST_COMM( S_HALO_WEST(:,:,:,NP), S_HALO_EAST(:,:,:,NP), 
     &                    DSPL_N0_E1_S0_W0, DRCN_E )
         CALL SUBST_COMM( S_BUF_EW(:,:,:,NP),        S_HALO_WEST(:,:,:,NP), 
     &                    DSPL_N0_E0_S0_W1, DRCN_W )
      END DO
#endif

#ifdef isam
      DO SPC = 1, N_SPCTAG
         IF( TRANSPORT_SPC( SPC ) )THEN
            DO ROW = 1, NROWS
               DO COL = 1, SWP
                  SA_HALO_WEST( COL,ROW,SPC ) =
     &                    ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG ( SPC ) )
                  SA_HALO_EAST( COL,ROW,SPC ) =
     &                    ISAM( EAST_COL+COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
                  SA_BUF_EW( COL,ROW,SPC ) = SA_HALO_EAST( COL,ROW,SPC )
               END DO
            END DO
         END IF
      END DO

      CALL SUBST_COMM (SA_HALO_WEST, SA_HALO_EAST, DSPL_N0_E1_S0_W0, DRCN_E)
      CALL SUBST_COMM (SA_BUF_EW,    SA_HALO_WEST, DSPL_N0_E0_S0_W1, DRCN_W)
#endif

#endif

      DO 233 ROW = 1, NROWS

         DO COL = 1, NCOLS+1
            VELX( COL ) = UHAT( COL,ROW )
         END DO

         DO SPC = 1, N_SPC_ADV

            A2C = ADV_MAP( SPC )
            DO COL = 1, NCOLS
               CONX( COL,SPC ) = CGRID( COL,ROW,LVL,A2C )
            END DO

#ifdef parallel
            DO COL = 1, SWP
               CONX( COL-SWP,SPC )      = HALO_WEST( COL,ROW,SPC )
               CONX( NCOLS+COL,SPC ) = HALO_EAST( COL,ROW,SPC )
            END DO
#endif

C West boundary

            IF ( BNDY_PE_LOX ) THEN
               IF ( VELX( 1 ) .LT. 0.0 ) THEN          ! outflow
                  CONX( 1-SWP:0,SPC ) =
     &               ZFDBC ( CONX( 1,SPC ), CONX( 2,SPC ),
     &                       VELX( 1 ),     VELX( 2 ) )
               ELSE    ! inflow
                  CONX( 1-SWP:0,SPC ) = BCON( WFX+ROW,SPC )
               END IF
            END IF

C East boundary

            IF ( BNDY_PE_HIX ) THEN
               IF ( VELX( NCOLS+1 ) .GT. 0.0 ) THEN     ! outflow
                  CONX( NCOLS+1:NCOLS+SWP,SPC ) =
     &               ZFDBC ( CONX( NCOLS,SPC ), CONX( NCOLS-1,SPC ),
     &                       VELX( NCOLS+1 ),   VELX( NCOLS ) )
               ELSE    ! inflow
                  CONX( NCOLS+1:NCOLS+SWP,SPC ) = BCON( EFX+ROW,SPC )
               END IF
            END IF

         END DO

#ifdef isam
         DO SPC = 1, N_SPCTAG
         
            IF( TRANSPORT_SPC( SPC ) )THEN

               DO COL = 1, NCOLS
                  SA_CONX( COL, SPC  ) = ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
               END DO
               
#ifdef parallel
               DO COL = 1, SWP
                  SA_CONX( COL-SWP,SPC ) = SA_HALO_WEST( COL,ROW,SPC )
                  SA_CONX( NCOLS+COL,SPC ) = SA_HALO_EAST( COL,ROW,SPC )
               END DO
#endif

C West boundary
               IF ( BNDY_PE_LOX ) THEN
                  IF ( VELX( 1 ) .LT. 0.0 ) THEN   ! outflow
                     SA_CONX( 1-SWP:0,SPC ) =
     &               ZFDBC( SA_CONX( 1,SPC ), SA_CONX( 2,SPC ), VELX( 1 ), VELX( 2 ) )
                  ELSE    ! inflow
                     IF ( BCON_SPC( SPC ) ) THEN
                        SA_CONX( 1-SWP:0,SPC ) = BCON( WFX+ROW,MAP_ADVtoSA( SPC ) )
                     ELSE   ! non-bcon tags ?
                        SA_CONX( 1-SWP:0,SPC ) = 0.0
                     END IF   
                  END IF   ! velx < 0 ?
               END IF   ! bndy_pe_lox ?

C East boundary
               IF ( BNDY_PE_HIX ) THEN
                  IF ( VELX( NCOLS+1 ) .GT. 0.0 ) THEN     ! outflow
                     SA_CONX( NCOLS+1:NCOLS+SWP,SPC ) =
     &               ZFDBC ( SA_CONX( NCOLS,SPC ), SA_CONX( NCOLS-1,SPC ),
     &                       VELX( NCOLS+1 ), VELX( NCOLS ) )
                  ELSE    ! inflow
                     IF ( BCON_SPC( SPC ) ) THEN
                        SA_CONX( NCOLS+1:NCOLS+SWP,SPC ) = BCON( EFX+ROW, MAP_ADVtoSA( SPC ) )
                     ELSE   ! non-bcon tags ?
                        SA_CONX( NCOLS+1:NCOLS+SWP,SPC ) = 0.0
                     END IF 
                  END IF   ! velx > 0 ?
               END IF   ! bndy_pe_hix ?
               
            END IF
         END DO  ! SPC loop
#endif

C PPM scheme
         F_LO_IN = 0.
         F_LO_OUT= 0.
         F_HI_IN = 0.
         F_HI_OUT= 0.

         IF ( BUDGET_DIAG ) BUDGET_HPPM = .TRUE.
         CALL HPPM ( NCOLS, NROWS, CONX, VELX, DT, DX1, 'C',
     &               F_LO_IN, F_LO_OUT, F_HI_IN, F_HI_OUT )


         ! Store Boundary Fluxes for Budget Diagnostic
         ! Flux units are converted:
         !     vapors: [Jacobian x rho] x [ppm] --> umol
         !     aerosol mass: [Jacobian] x [kg m-3] --> kg
         !     aerosol number: [Jacobian] x [N m-3] --> N
         !     aerosol surface area: [Jacobian] x [m2 m-3] --> m2
         IF ( BUDGET_HPPM ) THEN
            IF ( BNDY_PE_LOX ) THEN
                call interpolate_var ('JACOBM', fdate, ftime, JACOBM)
                call interpolate_var ('ZF', fdate, ftime, ZF)
                IF ( LVL .EQ. 1 ) THEN
                    VOL = AX * ZF( 1,ROW,1 ) / MSFX2( 1,ROW )
                ELSE
                    VOL = AX * ( ZF( 1,ROW,LVL ) - ZF( 1,ROW,LVL-1 ) ) / MSFX2(1,ROW)
                END IF
                DO I = 1,N_SPC_ADV
                   A2C = ADV_MAP( I )
                   VOL2 = VOL
                   IF ( .NOT. CGRID_MASK_AERO( A2C ) ) VOL2 = VOL / MWAIR_SI
                   F_WEST_IN( LVL,A2C )  = F_WEST_IN( LVL,A2C ) 
     &                      + F_LO_IN(I) / JACOBM( 1,ROW,LVL ) * VOL2
                   F_WEST_OUT( LVL,A2C ) = F_WEST_OUT( LVL,A2C ) 
     &                      + F_LO_OUT(I) / JACOBM( 1,ROW,LVL ) * VOL2
                END DO
            END IF
            IF ( BNDY_PE_HIX ) THEN
                call interpolate_var ('JACOBM', fdate, ftime, JACOBM)
                call interpolate_var ('ZF', fdate, ftime, ZF)
                IF ( LVL .EQ. 1 ) THEN
                    VOL = AX * ZF( NCOLS,ROW,1 ) / MSFX2(NCOLS,ROW)
                ELSE
                    VOL = AX * (ZF( NCOLS,ROW,LVL ) - ZF( NCOLS,ROW,LVL-1 )) / MSFX2(NCOLS,ROW)
                END IF
                DO I = 1,N_SPC_ADV
                   A2C = ADV_MAP( I )
                   VOL2 = VOL
                   IF ( .NOT. CGRID_MASK_AERO( A2C ) ) VOL2 = VOL / MWAIR_SI
                   F_EAST_IN( LVL,A2C )  = F_EAST_IN( LVL,A2C ) 
     &                    + F_HI_IN(I) / JACOBM( NCOLS,ROW,LVL ) * VOL2
                   F_EAST_OUT( LVL,A2C ) = F_EAST_OUT( LVL,A2C ) 
     &                    + F_HI_OUT(I) / JACOBM( NCOLS,ROW,LVL ) * VOL2
                END DO
            END IF
            BUDGET_HPPM = .FALSE.
         END IF

#ifdef isam
         CALL HPPM ( NCOLS, NROWS, SA_CONX, VELX, DT, DX1, 'C',
     &               SA_F_LO_IN, SA_F_LO_OUT, SA_F_HI_IN, SA_F_HI_OUT )
#endif

         DO SPC = 1, N_SPC_ADV
            A2C = ADV_MAP( SPC )
            DO COL = 1, NCOLS
               CGRID( COL,ROW,LVL,A2C ) = CONX( COL,SPC )
            END DO
         END DO

#ifdef isam
         DO SPC = 1, N_SPCTAG
           IF( TRANSPORT_SPC( SPC ) )THEN           
             DO COL = 1, NCOLS  
                ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) ) = SA_CONX( COL,SPC )
             END DO
           END IF     
         END DO
#endif

#ifdef sens
         DO NP = 1, NPMAX

           CALL CKTIME( FDATE,FTIME,NP,TIMEFLAG) ! Check if the current time is within the time range

           DO SPC = 1, N_SPC_ADV
             A2C = ADV_MAP( SPC )
             DO COL = 1, NCOLS
               SENX( COL,SPC ) = SENGRID( COL,ROW,LVL,NP,A2C )
             END DO

#ifdef parallel
             DO COL = 1, SWP
               SENX( COL-SWP,SPC )   = S_HALO_WEST( COL,ROW,SPC,NP )
               SENX( NCOLS+COL,SPC ) = S_HALO_EAST( COL,ROW,SPC,NP )
             END DO
#endif

C West boundary
             IF ( BNDY_PE_LOX ) THEN
               IF ( VELX( 1 ) .LT. 0.0 ) THEN          ! outflow
                 IF ( CONX( 0, SPC ) .EQ. 0.0 ) THEN
                   SENX( 1-SWP:0, SPC ) = 0.0
                 ELSE ! Zero-flux divergence boundary condition for sens
                   SENX( 1-SWP:0,SPC ) =
     &               S_ZFDBC ( SENX( 1,SPC ), SENX( 2,SPC ),
     &                         VELX( 1 ),     VELX( 2 ) )
                 END IF
               ELSE    ! inflow
                 IF ( BCS ) THEN
                   SENX( 1-SWP:0,SPC ) = BSEN( WFX+ROW,SPC,NP )
                 ELSE IF ( ( IPT( NP ) .EQ. 2 ) .AND. ( TIMEFLAG ) ) THEN
                 ! Insert boundary condition to SEN iff time, date,
                 ! species, and region match and senstype is BOUN
                   SENX( 1-SWP:0,SPC ) = BCON( WFX+ROW,SPC )
     &                                 * IREGION( 1, ROW, LVL, NP )
     &                                 * REAL ( IDATE ( NP, DATENUM ) )
     &                                 * REAL ( IPARM ( NP, A2C     ) )
                 ELSE
                 ! Otherwise, set to 0
                   SENX( 1-SWP:0, SPC ) = 0.0
                 END IF
               END IF
             END IF

C East boundary
             IF ( BNDY_PE_HIX ) THEN
               IF ( VELX( NCOLS+1 ) .GT. 0.0 ) THEN     ! outflow
                 IF ( CONX( NCOLS+1, SPC ) .EQ. 0.0 ) THEN
                   SENX( NCOLS+1:NCOLS+SWP, SPC ) = 0.0
                 ELSE
                 ! Zero-flux divergence boundary condition for
                 ! sens
                   SENX( NCOLS+1:NCOLS+SWP,SPC ) =
     &               S_ZFDBC ( SENX( NCOLS,SPC ), SENX( NCOLS-1,SPC ),
     &                         VELX( NCOLS+1 ),   VELX( NCOLS ) )
                 END IF
               ELSE    ! inflow
                 IF ( BCS ) THEN
                   SENX( NCOLS+1:NCOLS+SWP,SPC ) = BSEN( EFX+ROW,SPC,NP )
                 ELSE IF ( ( IPT( NP ) .EQ. 2 ) .AND. ( TIMEFLAG ) ) THEN
                 ! Insert boundary condition to SEN iff time, date,
                 ! species, and region match and senstype is BOUN
                   SENX( NCOLS+1:NCOLS+SWP,SPC ) = BCON( EFX+ROW,SPC )
     &                               * IREGION( NCOLS, ROW, LVL, NP )
     &                               * REAL ( IDATE ( NP, DATENUM ) )
     &                               * REAL ( IPARM ( NP, A2C     ) )
                 ELSE
                   SENX( NCOLS+1:NCOLS+SWP,SPC ) = 0.0
                 END IF
               END IF
             END IF

           END DO

C PPM scheme
           CALL HPPM ( NCOLS, NROWS, SENX, VELX, DT, DX1, 'C',
     &               F_LO_IN, F_LO_OUT, F_HI_IN, F_HI_OUT )

           DO SPC = 1, N_SPC_ADV
             A2C = ADV_MAP( SPC )
             DO COL = 1, NCOLS
               SENGRID( COL,ROW,LVL,NP,A2C ) = SENX( COL,SPC )
             END DO
           END DO

         END DO   ! NP
#endif

233   CONTINUE

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GET_BEIS( JDATE, JTIME, TSTEP, L_DESID_DIAG )

C-----------------------------------------------------------------------
 
C Description:
C   Computes hourly time stepped gridded biogenic emissions using 
C   normalized gridded emissions from Normbeis3 (3.12) and postprocessed MM5
C   meteorology.
 
C Preconditions:
C   Postprocessed MM5 meteorology that contains temperature, 
C   solar radiation, and pressure data. 
C   Normalized gridded emissions BEIS_NORM_EMIS from Normbeis 
 
C Subroutines and Functions Called:
C   BEIS, HRNO,  
C   CURRSTEP, HHMMSS, UPCASE, CHECKMEM, M3EXIT, M3MSG2,
C   WRITE3, OPEN3, CLOSE3, NEXTIME, TIME2SEC
 
C Revision History:
C   3/01: Prototype by Jeff Vukovich
C         Tested only on 36km Lambert domain 
C         Summer/winter switch file option not tested
C   8/04: Updated for BEIS v3.12
C  10/06: J.Young - CMAQ inline
C                 - assumes first call is scenario start date/time
C                 - optional integral average mass diagnostic emissions file
C  10/09: J.Young - intel compiler problem; move last EMISS calculation as
C                   separate assignment
C  01/10: J.Young - move soil NO data and required input data processing to hrno
C  01/10: D. Wong - Eliminate potential race condition at the MYPE = 0
C                   to open the diagnostic file. Eliminate the BARRIER
C                   and the CLOSE3 and OPEN3.
C  02/11: S.Roselle-Replaced I/O API include files with UTILIO_DEFN
C  05/11: D.Wong-incorporated twoway model implementation
C  07/14: J.Bash-Added meteorological variables needed for leaf temperature
C                calculations.
C  08/14: J.Bash-Added backwards compatibility for earlier versions of MCIP
C  07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C  12 Aug 15 D.Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O implementation
C  07 May 18 D. Schwede: Removed call to CZANGLE. COSZEN now calculated in ASX_DATA_MOD
C  01 Feb 19 D. Wong: Implemented centralized I/O approach, removed all MY_N clauses
C-----------------------------------------------------------------------
C Modified from:
 
C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling
C                System
C File: @(#)$Id: tmpbeis.F,v 1.6 2011/10/21 16:10:18 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Last updated: $Date: 2011/10/21 16:10:18 $ 
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
      USE BEIS_DEFN             ! beis
      USE centralized_io_module, only : AVGEMIS, interpolate_var
      Use ASX_DATA_MOD, only: MET_DATA
      USE MIO_ASCII

#ifdef mpas
      USE util_module, only : hhmmss, time2sec
#else
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#endif

      IMPLICIT NONE

C Includes:
        
C Arguments:
      INTEGER, INTENT(  IN ) :: JDATE   ! current simulation date (YYYYDDD)
      INTEGER, INTENT(  IN ) :: JTIME   ! current simulation time (HHMMSS)
      INTEGER, INTENT(  IN ) :: TSTEP( 3 )      ! timestep vector
      LOGICAL, INTENT(  IN ) :: L_DESID_DIAG ! flag determining whether or not DESID
                                             !   is in diagnostic mode              

C Parameters:
      REAL,    PARAMETER :: HR2SEC = 1.0 / 3600.0

C Gridded meteorology data:
      REAL, ALLOCATABLE, SAVE :: FSEAS( :,: )     ! Seasonal function

C Gridded normalized emissions:
      REAL, ALLOCATABLE, SAVE :: SEMIS( :,:,: )    ! Normailized Beis emissions

C Mole and mass factors:
      REAL MLFC, MSFC, EMPL

C Diagnostic file avg factor
      REAL DIVFAC

C BEIS3 internal, output species:
      REAL,    ALLOCATABLE, SAVE :: EMPOL( :,:,: )  ! emissions of biogenic emissions (mechanism specific)
      REAL,    ALLOCATABLE, SAVE :: BIPOL( :,:,: )  ! emissions of beis emissions (all beis BVOCs)
      REAL,    ALLOCATABLE, SAVE :: NOPOL( :,: )    ! emissions of NO
      REAL,    ALLOCATABLE, SAVE :: EMISS( :,:,: )  ! emissions in g/s

C Logical names and unit numbers:
            
      CHARACTER( 16 ), SAVE :: NNAME   ! logical name for normalized-emissions input
      CHARACTER( 16 ), SAVE :: GNAME   ! logical name for GRID_CRO_2D
      CHARACTER( 16 ), SAVE :: BNAME   ! logical name for frost switch input

C Other variables:
      INTEGER, SAVE :: IHR        ! current simulation hour
      INTEGER          IOS        ! IO or memory allocation status
      INTEGER, SAVE :: LDATE      ! previous simulation date
      INTEGER, SAVE :: NSTEPS     ! run duration
      INTEGER, SAVE :: WSTEP  = 0 ! local write counter
      INTEGER          PARTYPE    ! method number to calculate PAR
      INTEGER          C, R, I, J, K, S  ! loop counters and subscripts

      LOGICAL          OK        ! check flag
      LOGICAL, SAVE :: LASTTIC                ! true: last sync step this output tstep
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      CHARACTER( 256 ) :: MESG       ! message buffer
      CHARACTER( 256 ) :: EQNAME     ! equivalent filename
      CHARACTER(  16 ) :: VAR        ! variable name
      CHARACTER(  16 ) :: PNAME = 'GET_BEIS'   ! prodedure name

#ifdef verbose_getbeis
      REAL,    ALLOCATABLE, SAVE :: EMISX( : )
      INTEGER, ALLOCATABLE, SAVE :: CX( : ), RX( : )
#endif

      INTERFACE
         SUBROUTINE BEIS( JDATE, JTIME, NX, NY, MSPCS, SEMIS, BIPOL )
            INTEGER, INTENT( IN ) :: JDATE
            INTEGER, INTENT( IN ) :: JTIME
            INTEGER, INTENT( IN ) :: NX
            INTEGER, INTENT( IN ) :: NY
            INTEGER, INTENT( IN ) :: MSPCS
            REAL,    INTENT( IN ) :: SEMIS ( :,:,: )
            REAL,    INTENT( OUT ) :: BIPOL( :,:,: )
         END SUBROUTINE BEIS
         SUBROUTINE HRNO( JDATE, JTIME, TSTEP, NOPOL, L_DESID_DIAG )
            INTEGER, INTENT( IN )  :: JDATE
            INTEGER, INTENT( IN )  :: JTIME
            INTEGER, INTENT( IN )  :: TSTEP( 3 )
            REAL,    INTENT( OUT ) :: NOPOL( :,: )
            LOGICAL, INTENT( IN )  :: L_DESID_DIAG
         END SUBROUTINE HRNO
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

C Determine last timestamp
         NSTEPS = RUNLEN / TSTEP( 1 )           ! initscen guarantees divisibility

C Allocate seasonality array
         ALLOCATE( FSEAS( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'FSEAS', PNAME )
         FSEAS = 0   ! array

C Allocate memory for arrays
         
         ALLOCATE( EMPOL( NCOLS,NROWS,NSEF ), STAT=IOS )
         CALL CHECKMEM( IOS, 'EMPOL', PNAME )

         ALLOCATE( BIPOL( NCOLS,NROWS,NSEF-1 ), STAT=IOS )
         CALL CHECKMEM( IOS, 'BIPOL', PNAME )

         ALLOCATE( NOPOL( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'NOPOL', PNAME )

         IF ( BEMIS_DIAG ) THEN
            ALLOCATE( EMISS( NCOLS,NROWS,MSPCS ), STAT=IOS )
            CALL CHECKMEM( IOS, 'EMISS', PNAME )
         END IF

         ALLOCATE( SEMIS( NCOLS,NROWS,NSEF-1 ), STAT=IOS )
         CALL CHECKMEM( IOS, 'SEMIS', PNAME )

         LDATE = 0

#ifdef verbose_getbeis
         ALLOCATE( EMISX( MSPCS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'EMISX', PNAME )
         ALLOCATE( CX( MSPCS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'CX', PNAME )
         ALLOCATE( RX( MSPCS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'RX', PNAME )
#endif

#ifndef mpas
         IF ( BEMIS_DIAG ) THEN
            EMISS = 0.0   ! array
#ifdef parallel_io
            IF ( .NOT. IO_PE_INCLUSIVE ) THEN
               IF ( .NOT. OPEN3( SNAME, FSREAD3, PNAME ) ) THEN
                  MESG = 'Could not open ' // TRIM(SNAME)
                  CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
               END IF
            END IF
#endif
         END IF
#endif

      END IF   ! FIRSTIME

C Loop thru the number of time steps (hourly)

      VDEMIS_BI = 0.0   ! array
      EMPOL = 0.0   ! array
#ifdef verbose_getbeis
      EMISX = 0.0   ! array
#endif

      IF ( JDATE .NE. LDATE ) THEN

         CALL WRDAYMSG( JDATE, MESG )               

C calculate fseas based on deep soil temperature following WRF 3.8.1 PX 
         Where( Met_Data%SOIT2 .Lt. 290.0 .And. Met_Data%SOIT2 .Gt. 282.0 )
            FSEAS = 1.0 - 0.015625 * ( 290.0 - Met_Data%SOIT2 ) ** 2
         Elsewhere( Met_Data%SOIT2 .Ge. 290.0 )
            FSEAS = 1.0
         Elsewhere
            FSEAS = 0.0
         End where

         DO S = 1, NSEF-1 ! normalized emission factors
            SEMIS( :,:,S ) =         FSEAS   * AVGEMIS( :,:,S,NSUMMER ) + ! Deciduous fraction
     &                       ( 1.0 - FSEAS ) * AVGEMIS( :,:,S,NWINTER )   ! Evergreen fraction
         END DO

      END IF   ! if new day

      WRITE( MESG,94030 ) HHMMSS( JTIME )
      CALL M3MSG2( MESG )

#ifndef mpas
C repopulate the met_cro_2d variable attributes
      IF ( .NOT. DESC3( MNAME ) ) THEN
         MESG = 'Could not get description of file "'
     &           // TRIM( MNAME ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF
#endif

C Calculate temporal non-speciated beis emissions
      CALL BEIS( JDATE, JTIME, NCOLS, NROWS, MSPCS, SEMIS, BIPOL )

C Calculate temporal non-speciated soil NO emissions
      CALL HRNO( JDATE, JTIME, TSTEP, NOPOL, L_DESID_DIAG )

      EMPOL( :,:,1:NSEF-1 ) = BIPOL
      EMPOL( :,:,NSEF )     = NOPOL

C Speciate emissions
      DO K = 1, NSEF
         DO R = 1, NROWS
            DO C = 1, NCOLS
               EMPL = EMPOL( C,R,K ) * HR2SEC
               IF ( EMPL .GT. 0.0 ) 
     &            VDEMIS_BI( :,C,R ) = VDEMIS_BI( :,C,R ) + EMPL * MLFAC( :,K )
            END DO
         END DO
      END DO

#ifdef verbose_getbeis
      WRITE( LOGDEV,* ) ' '
      WRITE( LOGDEV,* ) '       from GET_BEIS'
      WRITE( LOGDEV,* ) '    Spc   VDEMIS_BI  MaxC MaxR'
      DO S = 1, MSPCS
         WRITE( LOGDEV,'( 4X, I3, F10.5, 2I4 )' ) S, EMISX( S ), CX( S ), RX( S )
      END DO

      EMISX = 0.0    ! array
      WRITE( LOGDEV,* ) ' '
      WRITE( LOGDEV,* ) '                   from GET_BEIS'
      WRITE( LOGDEV,* ) '    Spc SpcName  Pol  MLFAC     EMPOL     VDEMIS_BI( Spc,32,7 )'
      C = 32; R = 7
      DO K = 1, NSEF
         EMPL = EMPOL( C,R,K ) * HR2SEC
         IF ( EMPL .LE. 0.0 ) CYCLE
         DO S = 1, MSPCS
            MLFC = MLFAC( S,K )
            EMISX( S ) = EMISX( S ) + EMPL * MLFC
            IF ( MLFC .NE. 0.0 )
     &         WRITE( LOGDEV,'( 4X, I3, 2X, A6, 2X, I3, 1X, 3( 1PE10.3 ) )' )
     &                           S, EMSPC( S ), K,  MLFC, EMPL, EMISX( S )
         END DO
      END DO
#endif

      IF ( BEMIS_DIAG .AND. .NOT. L_DESID_DIAG ) THEN
         WSTEP   =   WSTEP + TIME2SEC( TSTEP( 2 ) )
         LASTTIC = ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) )

#ifndef mpas
         DO K = 1, NSEF
            DO S = 1, MSPCS
! Unit conversion for the emission and fraction of the sync time step to the output time step
                  MSFC = MSFAC( S,K ) * FLOAT( TIME2SEC( TSTEP( 2 ) ) ) / FLOAT( TIME2SEC( TSTEP( 1 ) ) )
! Add the emission for the model output time step
                  EMISS( :,:,S ) = EMISS( :,:,S ) + EMPOL( :,:,K ) * MSFC
            END DO
         END DO
         IF ( LASTTIC ) THEN
            EMISS = EMISS * HR2SEC   ! convert from gm/h to gm/s
            DO S = 1,MSPCS
               IF ( .NOT. WRITE3( SNAME, EMSPC( S ), MDATE, MTIME, EMISS(:,:,S) ) ) THEN
                  MESG = 'Could not write to output file "' // TRIM( SNAME ) // '"'
                  CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
               END IF
            END DO
            WRITE( LOGDEV,94040 )
     &            'Timestep written to', SNAME,
     &            'for date and time', MDATE, MTIME
            EMISS = 0.0   ! array
            WSTEP = 0
            CALL NEXTIME( MDATE, MTIME, TSTEP( 1 ) )
         END IF
      END IF
#endif

C Save date
      LDATE = JDATE

      RETURN

C------------------  FORMAT  STATEMENTS   ------------------------------

94010 FORMAT( 10( A, ':', I8, ':', 1X ) )
94020 FORMAT( 1X, I7, ":", I6.7 )
94030 FORMAT( 5X, 'Temporal BEIS at time ', A8 )
94040 FORMAT( /5X, 3( A, :, 1X ), I8, ":", I6.6 )

      END SUBROUTINE GET_BEIS  

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
       SUBROUTINE PVO3( CGRID, JDATE, JTIME )

C-----------------------------------------------------------------------
C  Function: Scales O3 in free-troposphere to potential vorticity 
 
C  Revision History:
C  Prototype, Rohit Mathur, Nov. 2007
C             Scaling only at top layer; scaling factor based on 2006 IONS O3 and 
C             PV estimated from NAM at ~100mb,  Rohit Mathur, Nov. 2008
C             Incorporation in CMAQv4.7.1,  Rohit Mathur, Jan.2010
C  12 Mar 2019 D. Wong: Implemented centralized I/O approach and removed all MY_N clauses
C   1 Apr 2019 D. Wong: Remove call to SUBHFILE
C   March 2023 R.Mathur: removed sigma-coordinate dependence in determing layers
C               above which PV-scaling is applied
C-----------------------------------------------------------------------

      USE CGRID_SPCS          ! CGRID mechanism species
      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
      USE CENTRALIZED_IO_MODULE, only : interpolate_var, lat

#ifdef isam
      USE SA_DEFN, ONLY: ISAM, N_SPCTAG, NTAG_SA, ITAG, OTHRTAG,
     &                   ISAM_PVO3_MAP, ISAM_SPEC, L_OZONE,
     &                   ISAMRGN_NUM, ISAMRGN_MAP, NSPC_SA
      USE desid_param_module, ONLY: DESID_REG_FAC, DESID_N_REG
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, SENGRID, IPT
#endif
      USE CONST, ONLY : PI180
     
      IMPLICIT NONE

C..Includes:
      INCLUDE SUBST_FILES_ID  ! CMAQ files

C..Parameters:
      REAL, PARAMETER :: PSFC = 100000.0  ! generic surface pres. [Pa]

C To scale O3 with PV at specified altitudes, set highest pressure level to exclude
C PV scaling:
      REAL, PARAMETER :: PPVT = 11000.0   ! [Pa] (~14-16km or X3 > 0.93)

      REAL, PARAMETER :: AX = 203.53
      REAL, PARAMETER :: BX = -13.622
      REAL, PARAMETER :: CX =  5.4157E-1
      REAL, PARAMETER :: DX = -9.4264E-3
      REAL, PARAMETER :: EX =  7.299E-5
      REAL, PARAMETER :: FX = -2.0214E-7

      REAL, PARAMETER :: AY = -2.1902E-2
      REAL, PARAMETER :: BY =  4.5507E-4
      REAL, PARAMETER :: CY = -2.4557E-6

C..Arguments:
      REAL, POINTER :: CGRID( :,:,:,: )   ! Species concentrations
      INTEGER, INTENT( IN ) :: JDATE      ! Current date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME      ! Current time (HHMMSS)

C..Saved Local Variables:
      CHARACTER( 16 ), SAVE :: PNAME = 'PVO3'     ! Program name
      LOGICAL, SAVE :: LFIRST = .TRUE.  ! Flag for first call to this subroutine
      INTEGER, SAVE :: VO3       ! ozone
      INTEGER, SAVE :: VO3T = 0  ! tracer
      INTEGER, SAVE :: KPV

C..Scratch Local Variables:
      CHARACTER( 132 ) :: MSG       ! Message text
      CHARACTER(  16 ) :: VNAME     ! Name of I/O API data variable
      CHARACTER( 120 ) :: XMSG  = ' '    ! Exit status message

      INTEGER C, L, R        ! Loop indices
      INTEGER       ALLOCSTAT

      INTEGER YEAR
      INTEGER JDAY
      REAL    CSTAR          ! dynamic PV coefficiency
      REAL    FC, GC         ! cstar = fc * gc
      REAL    LATABS         ! absolute latitude
      REAL    MFRC           ! month fraction
      REAL    PLAY           ! pressure for layer applied

      REAL, ALLOCATABLE, SAVE :: CSTARZ( :,: ) ! cstar at 58hPa estimated by polynomial fit
      REAL, ALLOCATABLE, SAVE :: CXX( :,: )    ! intermediate quadratic (< 0 for any lat.)
      REAL ::  PV( NCOLS,NROWS,NLAYS )   ! potential vorticity
      REAL PRES( NCOLS,NROWS,NLAYS )           ! Air pressure [ Pa ]

#ifdef isam
      INTEGER, SAVE           :: S_O3 = 0
      REAL                    :: PVO3_STORE = 1.0
      INTEGER                 :: RGN = 0
#endif 

C First time: set up parameters
      IF ( LFIRST ) THEN
         LFIRST = .FALSE.

         VO3 = INDEX1( 'O3', N_GC_SPC, GC_SPC )
         WRITE( LOGDEV,92000 ) N_GC_SPC, VO3

C Get number of species, and starting indices for CGRID array.
         VO3T = INDEX1( 'O3PV', N_TR_SPC, TR_SPC )
         IF ( VO3T .GT. 0 ) then
            XMSG = '     Option used: a tracer Namelist file with species O3PV'
            CALL M3MESG ( XMSG )
            VO3T = TR_STRT - 1 + VO3T
            WRITE( LOGDEV,92001 ) TR_STRT-1, N_TR_SPC, VO3T
         END IF

C Scale top 3 layers O3 to PV
!        KPV = NLAYS - 2
C Scale only top layer O3 to PV
!        KPV = NLAYS
C        WRITE( LOGDEV,92002 ) KPV, X3FACE_GD( KPV )
         WRITE( LOGDEV,92003 ) PPVT

         ALLOCATE ( CSTARZ( NCOLS,NROWS ),
     &              CXX( NCOLS,NROWS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CSTARZ, or CXX'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#ifdef isam
        IF ( L_OZONE ) S_O3  = INDEX1( 'O3', NSPC_SA, ISAM_SPEC(:,OTHRTAG) )
#endif

      END IF      ! First time

C.. Get PV 
      call interpolate_var ('PV', jdate, jtime, pv)

C.. Get PRES
      call interpolate_var ('PRES', jdate, jtime, PRES)

C.. Calculate month fraction
      YEAR = INT( FLOAT( JDATE ) / 1000.0 )
      JDAY = JDATE - YEAR * 1000

      IF ( MOD( YEAR, 4 ) .EQ. 0 ) THEN
         MFRC = FLOAT( JDAY ) / 366.0
      ELSE
         MFRC = FLOAT( JDAY ) / 365.0
      END IF

      GC = 1.0 + 0.22 * SIN( PI180 * 12.0 * ( MFRC * 30.0 + 2.0 ) )

C.. Scale O3 in free-trop based on PV
C   O3 in ppb = 30*PV or O3 in ppm = .03*PV
C   This constant of proportionality is determined based on examining the relationship
C   between NAM PV and average observed O3 at the 2006 IONS sites for the topmost layer
C   of a 22-layer configuration

      DO R = 1, NROWS
         DO C = 1, NCOLS
            LATABS = ABS( LAT( C,R ) )
            CSTARZ( C,R ) =            AX
     &                    + LATABS * ( BX
     &                    + LATABS * ( CX
     &                    + LATABS * ( DX
     &                    + LATABS * ( EX
     &                    + LATABS * ( FX ) ) ) ) )

            CXX( C,R )    =            AY
     &                    + LATABS * ( BY
     &                    + LATABS * ( CY ) )
         END DO
      END DO

C     DO L = KPV, NLAYS
      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS

             IF (PRES(C,R,L).LT.PPVT ) THEN ! scale O3 above PPVT

               FC     = CSTARZ( C,R ) + ( PRES( C,R,L ) - 5856.0 ) * CXX( C,R )

               CSTAR  = MAX ( 30.0, ABS( FC * GC ) )

               CGRID( C,R,L,VO3 ) = 0.001 * CSTAR * ABS( PV( C,R,L ) )
#ifdef isam
               IF ( L_OZONE ) THEN
                 ISAM( C,R,L,S_O3,: ) = 1E-30
                 PVO3_STORE = 1.0
                 IF ( SUM( ISAM_PVO3_MAP(:) ) .EQ. 0 ) THEN  ! no PV tracking specified, toss it into OTHER
                   ISAM( C,R,L,S_O3,OTHRTAG ) = CGRID( C,R,L,VO3 )
                 ELSE IF ( SUM( ISAM_PVO3_MAP(:) ) .GE. 1 ) THEN ! at least 1 PVO3 tag
                   DO ITAG = 1, NTAG_SA-3
                     IF( ISAM_PVO3_MAP(ITAG) .EQ. 1 ) THEN ! PV for this tag
                        IF ( ISAMRGN_NUM( ITAG ) .LT. 1 ) THEN ! full domain
                          ISAM( C,R,L,S_O3,ITAG ) = CGRID( C,R,L,VO3 )
                          PVO3_STORE = 0.0
                        ELSE ! split into regions and other
                          DO RGN = 1, ISAMRGN_NUM( ITAG )
                            ISAM( C,R,L,S_O3,ITAG ) = ISAM( C,R,L,S_O3,ITAG )
     &                            + CGRID( C,R,L,VO3 )
     &                            * DESID_REG_FAC(C,R,ISAMRGN_MAP(ITAG,RGN))
                            PVO3_STORE = PVO3_STORE
     &                            - DESID_REG_FAC(C,R,ISAMRGN_MAP(ITAG,RGN))
                          END DO
                        END IF 
                     END IF
                   END DO
                   IF ( PVO3_STORE .LT. 1E-6 .AND. PVO3_STORE .GT. 0.0 ) PVO3_STORE = 0.0 ! round off precision error
                   IF ( PVO3_STORE .GE. 0.0 ) THEN ! put the rest into OTHER tag
                     ISAM( C,R,L,S_O3,OTHRTAG ) = PVO3_STORE * CGRID( C,R,L,VO3 )
                   ELSE
                     XMSG = ' ERROR: Possible overspecification of ' //
     &                      'ISAM tags for PV'
                     CALL M3EXIT ( 'ISAM_PV', JDATE, JTIME, XMSG, XSTAT1 )
                   ENDIF
                 ELSE
                   XMSG = ' ERROR in ISAM PV definitions '
                   CALL M3EXIT ( 'ISAM_PV', JDATE, JTIME, XMSG, XSTAT1 )
                 END IF
               END IF
#endif

#ifdef sens
               DO NP = 1, NPMAX
                  IF ( IPT( NP ) .EQ. 6 ) THEN
                     SENGRID( C, R, L, NP, VO3 ) = CGRID( C, R, L, VO3 )
                  END IF
               END DO
#endif

               IF ( VO3T .GT. 0 ) THEN
                  CGRID( C,R,L,VO3T ) = CGRID( C,R,L,VO3 )
               END IF

             END IF ! check PPVT

            END DO
         END DO
      END DO
               
      RETURN

92000 FORMAT( / 10X, 'In Subroutine PVO3: setting index for O3 '
     &        / 10X, 'Number of gas phase species:  ', I4
     &        / 10X, 'Species index for O3:         ', I4 )
92001 FORMAT( / 10X, 'In Subroutine PVO3: setting index for O3 '
     &        / 10X, 'CGRID offset for tracer species: ', I4
     &        / 10X, 'Number of tracer phase species:  ', I4
     &        / 10X, 'Species index for O3PV tracer:         ', I4 )
92002 FORMAT( / 10X, 'PV Scaling at Layers Starting from: ', I4
     &        / 10X, 'X3 coordinate value at starting layer: ', F10.7 / )
92003 FORMAT( / 10X, 'PV Scaling applied above ', F10.2, 'Pa')

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SCAVWDEP ( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                      CTHK1, AIRM, PRATE1, TAUCLD, POLC, CEND,
     &                      REMOV, REMOVAC, ALFA0, ALFA2, ALFA3 )
C-----------------------------------------------------------------------
C  Description: Compute simplistic incloud scavenging and wet removal
 
C  Revision History:
C      No   Date   Who  What
C      -- -------- ---  -----------------------------------------
C       0 01/15/98 sjr  created program
C       1 07/27/99 sjr  added scavenging coefficient scaling factors
C       3 Dec 00   Jeff move CGRID_MAP into f90 module
C       4 Dec 02   sjr  revised calls to HLCONST
C       5 Jun 10   J.Young: convert for Namelist redesign
C       6 Mar 11   S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                       removed deprecated TRIMLEN
C       6 Mar 11   B.Hutzell: added TRACER string for AE_SPCs to omit while
C                       computing Aitken mode mass
C    1 Dec 15 S.L.Napelenok:  ddm-3d implementaiton for version 5.1.1
 
C  Called by:  RADMCLD and RESCLD
 
C  Calls the following subroutines:  GETALPHA
 
C  Calls the following functions:  HLCONST
 
C  Arguments    Type      I/O       Description
C  ---------   -------  ------  --------------------------------
C    JDATE     integer   input  current model julian date (yyyyddd)
C    JTIME     integer   input  current model time (hhmmss)
C    WTBAR      real     input  avg total water content (kg/m3)
C    WCBAR      real     input  avg liquid water content (kg/m3)
C    TBARC      real     input  avg cloud temperature (K)
C    PBARC      real     input  avg cloud pressure (Pa)
C    CTHK1      real     input  cloud thickness (m)
C    AIRM       real     input  total air mass (moles/m2) in cloudy air
C    PRATE1     real     input  precipitation rate (mm/hr)
C    TAUCLD     real     input  cloud lifetime (s)
C    POLC       real     input  ave vert conc incloud (moles sp/ mole air)
C    CEND       real    output  ending incloud conc (moles/mole)
C    REMOV      real    output  moles/m2 or mm*mol/lit scavenged
C    REMOVAC    real    output  variable storing H+ deposition
C    ALFA0      real    output  scav coef for aitken aerosol number
C    ALFA2      real    output  scav coef for aitken mode sfc area
C    ALFA3      real    output  scav coef for aitken aerosol mass
 
C-----------------------------------------------------------------------

      USE CGRID_SPCS                    ! CGRID mechanism species
      USE UTILIO_DEFN
      USE CONST
      USE HLCONST_MOD, MXHSPCS => MXSPCS
#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, S_POLC, S_CEND, S_REMOV, S_REMOVAC
#endif 

      IMPLICIT NONE

      CHARACTER( 120 ) :: XMSG = ' '    ! Exit status message

C...........Parameters:

      REAL, PARAMETER :: H2ODENS = 1000.0  ! density of water at 20 C
                                           ! and 1 ATM (kg/m3)

C Number of species in CGRID
      INTEGER, SAVE :: MXSPCS

C Number of species scavenged
      INTEGER, SAVE :: N_SPC_SCAV

      REAL, PARAMETER :: TWOTHIRDS = 2.0 / 3.0

      REAL, PARAMETER :: KGPG = 1.0E-03   ! kilograms per gram

C...........Arguments:

      INTEGER, INTENT(  IN ) :: JDATE   ! current model date, coded YYYYDDD
      INTEGER, INTENT(  IN ) :: JTIME   ! current model time, coded HHMMSS
      REAL,    INTENT(  IN ) :: WTBAR   ! total wat cont (kg/m2) int. thru cloud depth
      REAL,    INTENT(  IN ) :: WCBAR   ! liq water content of cloud (kg/m3)
      REAL,    INTENT(  IN ) :: TBARC   ! mean cloud temp (K)
      REAL,    INTENT(  IN ) :: PBARC   ! mean cloud pressure (Pa)
      REAL,    INTENT(  IN ) :: CTHK1   ! aq chem calc cloud thickness
      REAL,    INTENT(  IN ) :: AIRM    ! total air mass (moles/m2) in cloudy air
      REAL,    INTENT(  IN ) :: PRATE1  ! storm rainfall rate (mm/hr)
      REAL,    INTENT(  IN ) :: TAUCLD  ! cloud lifetime
      REAL,    INTENT( OUT ) :: ALFA0   ! scav coef for aitken aerosol number
      REAL,    INTENT( OUT ) :: ALFA2   ! scav coef for aitken aerosol sfc area
      REAL,    INTENT( OUT ) :: ALFA3   ! scav coef for aitken aerosol mass
      REAL,    INTENT( OUT ) :: REMOVAC ! variable storing H+ deposition
      REAL,    INTENT(  IN ) :: POLC ( : )  ! avg vert conc incloud (moles/mole)
      REAL,    INTENT( OUT ) :: CEND ( : )  ! ending incloud conc (moles/mole)
      REAL,    INTENT( OUT ) :: REMOV( : )  ! moles/m2 or mm*mol/lit scavenged

C...........Local Variables:

      LOGICAL, SAVE :: FIRSTIME = .TRUE.   ! flag for first pass thru
      CHARACTER( 16 ), SAVE :: PNAME = 'SCAVWDEP'  ! program name

      CHARACTER( 16 ), ALLOCATABLE, SAVE :: SCAV_SPC( : )  ! CGRID species scavenged
      INTEGER, ALLOCATABLE, SAVE :: SCAV_MAP( : ) ! CGRID map to scavenged spc
      REAL, ALLOCATABLE,    SAVE :: SCAV_FAC( : )  ! CGRID scav coef factors
      LOGICAL, ALLOCATABLE, SAVE :: SCAV_MASK_GAS( : )   ! Mask for Gases on Scav list
      LOGICAL, ALLOCATABLE, SAVE :: SCAV_MASK_AERO( : )  ! Mask for Aerosols on Scav list
      LOGICAL, ALLOCATABLE, SAVE :: SCAV_MASK_AITKEN( : )! Mask for Aitken PM on Scav list
      LOGICAL, ALLOCATABLE, SAVE :: SCAV_MASK_NUM( : )   ! Mask for Aero Number on Scav list
      LOGICAL, ALLOCATABLE, SAVE :: SCAV_MASK_SRF( : )   ! Mask for Aero Surface on Scav list
      LOGICAL, ALLOCATABLE, SAVE :: SCAV_MASK_NR( : )    ! Mask for Non-Reactives on Scav list
      LOGICAL, ALLOCATABLE, SAVE :: SCAV_MASK_TRAC( : )  ! Mask for Tracers on Scav list
      INTEGER, ALLOCATABLE, SAVE :: L_NUMAKN( : ) ! pointers to aitken aerosol #
      INTEGER, ALLOCATABLE, SAVE :: L_MASAKN( : ) ! pointers to aitken aerosols
      INTEGER, ALLOCATABLE, SAVE :: L_SRFAKN( : ) ! pntrs to aitken aerosol surface area
      INTEGER, ALLOCATABLE, SAVE :: HLIND( : )    ! pointers to Henry's Law species
      INTEGER ASTAT

      INTEGER       I
      INTEGER, SAVE :: N_NUMAKN            ! # aitken aerosol number species
      INTEGER, SAVE :: N_MASAKN            ! # aitken aerosol mass species
      INTEGER, SAVE :: N_SRFAKN            ! # aitken aerosol sfc area species
      INTEGER       PNTR                ! relative pointer variable
      INTEGER       SPC                 ! liquid species loop counter
      INTEGER       VAR                 ! variable loop counter

      REAL          ALFA                ! scavenging coefficient (1/s)
      REAL          KH                  ! Henry's law constant (mol/l/atm)
      REAL          NUMAKN              ! Aitken mode aerosol # (#/m3)
      REAL          MASAKN              ! Total Aitken mode mass (ug/m3)
      REAL(8)       MASAKN_D            ! Double-precision verson of MASAKN
      REAL          SRFAKN
      REAL          ONE_OVER_TWASH      ! 1 / TWASH
      REAL,    SAVE :: HPLUS = 1.0E-4   ! typical value hydrogen ion concentration [mol/l]
      REAL          RHOAIR              ! air density in kg/m3
      REAL          RTCH                ! chemical gas const times temp
      REAL          TWASH               ! washout time for clouds (sec) with low liq wat content
      REAL          TWF                 ! washout scaling factor (mol/l/atm)

      LOGICAL       LERROR

C...........External Functions:

      INTEGER, EXTERNAL :: INDEXN

C-----------------------------------------------------------------------

C...INITIALIZATION SCAVWDEP module:
C...  event-statistics variables.  Open output files.

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

        N_SPC_SCAV = N_GC_SCAV + N_AE_SCAV + N_NR_SCAV + N_TR_SCAV

C...first check to make sure that some species in CGRID were specified
C...  for scavenging, otherwise notify the user and return

        IF ( N_SPC_SCAV .LE. 0 ) THEN
          XMSG = 'No species were specified for scavenging by cloud ' //
     &           'or rain water...SCAVENGING WILL NOT BE PERFORMED!'
          CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
          RETURN
        END IF

        ALLOCATE ( SCAV_SPC( N_SPC_SCAV ),
     &             SCAV_MAP( N_SPC_SCAV ),
     &             SCAV_FAC( N_SPC_SCAV ),
     &             SCAV_MASK_GAS( N_SPC_SCAV ),
     &             SCAV_MASK_AERO( N_SPC_SCAV ),
     &             SCAV_MASK_AITKEN( N_SPC_SCAV ),
     &             SCAV_MASK_NUM( N_SPC_SCAV ),
     &             SCAV_MASK_SRF( N_SPC_SCAV ),
     &             SCAV_MASK_NR( N_SPC_SCAV ),
     &             SCAV_MASK_TRAC( N_SPC_SCAV ), 
     &             HLIND( N_SPC_SCAV ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating arrays dimensioned N_SPC_SCAV'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        MXSPCS = N_GC_SPCD + N_AE_SPC + N_NR_SPC + N_TR_SPC

        ALLOCATE ( L_NUMAKN( MXSPCS ),
     &             L_MASAKN( MXSPCS ),
     &             L_SRFAKN( MXSPCS ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating L_NUMAKN, L_MASAKN or L_SRFAKN'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

C...prepare indices for scavenged species
        SCAV_SPC = ''
        SCAV_MAP = 0
        SCAV_FAC = 0
        SCAV_MASK_GAS = .FALSE.
        SCAV_MASK_AERO = .FALSE.
        SCAV_MASK_AITKEN = .FALSE.
        SCAV_MASK_NUM = .FALSE.
        SCAV_MASK_SRF = .FALSE.
        SCAV_MASK_NR = .FALSE.
        SCAV_MASK_TRAC = .FALSE.
        HLIND = 0

C...  load the CGRID to scavenged species pointers for the gases
        SPC = 0
        DO VAR=1, N_GC_SCAV
          SPC = SPC + 1
          SCAV_SPC( SPC ) = GC_SCAV( VAR )
          SCAV_MAP( SPC ) = GC_SCAV_MAP( VAR ) + GC_STRT - 1
          SCAV_FAC( SPC ) = GC_SCAV_FAC( VAR )
          SCAV_MASK_GAS( SPC ) = .TRUE.
        END DO

C...  load the CGRID to scavenged species pointers for the aerosols

        DO VAR=1, N_AE_SCAV
          SPC = SPC + 1
          SCAV_SPC( SPC ) = AE_SCAV( VAR )
          SCAV_MAP( SPC ) = AE_SCAV_MAP( VAR ) + AE_STRT - 1
          SCAV_FAC( SPC ) = AE_SCAV_FAC( VAR )
          IF ( INDEX( SCAV_SPC( SPC ), 'NUM' ) .NE. 0 ) SCAV_MASK_NUM( SPC ) = .TRUE.
          IF ( INDEX( SCAV_SPC( SPC ), 'SRF' ) .NE. 0 ) SCAV_MASK_SRF( SPC ) = .TRUE.
          IF ( INDEX( SCAV_SPC( SPC ), 'AITKEN' ) .NE. 0 ) SCAV_MASK_AITKEN( SPC ) = .TRUE.
          SCAV_MASK_AERO( SPC ) = .TRUE.
        END DO

C...  load the CGRID to scavenged species pointers for the non-reactives

        DO VAR=1, N_NR_SCAV
          SPC = SPC + 1
          SCAV_SPC( SPC ) = NR_SCAV( VAR )
          SCAV_MAP( SPC ) = NR_SCAV_MAP( VAR ) + NR_STRT - 1
          SCAV_FAC( SPC ) = NR_SCAV_FAC( VAR )
          SCAV_MASK_NR( SPC ) = .TRUE.
        END DO

C...  load the CGRID to scavenged species pointers for the tracers

        DO VAR=1, N_TR_SCAV
          SPC = SPC + 1
          SCAV_SPC( SPC ) = TR_SCAV( VAR )
          SCAV_MAP( SPC ) = TR_SCAV_MAP( VAR ) + TR_STRT - 1
          SCAV_FAC( SPC ) = TR_SCAV_FAC( VAR )
          SCAV_MASK_TRAC( SPC ) = .TRUE.
        END DO

C...create the pointers from CGRID to the species needed by AQCHEM
        N_NUMAKN = INDEXN( 'NUM_AITKEN', N_SPC_SCAV, SCAV_SPC, L_NUMAKN )
        N_MASAKN = INDEXN( 'AITKEN    ', N_SPC_SCAV, SCAV_SPC, L_MASAKN )
        N_SRFAKN = INDEXN( 'SRF_AITKEN', N_SPC_SCAV, SCAV_SPC, L_SRFAKN )

        LERROR = .FALSE.
        DO SPC=1, N_SPC_SCAV
           IF ( SCAV_MASK_AERO( SPC ) ) CYCLE
           CALL HLINDEX( SCAV_SPC( SPC ), HLIND( SPC ), LERROR )
        END DO

        IF ( LERROR ) THEN
           XMSG = 'Missing wet scavenging species required for Henry''s Law table.'
           CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
        END IF
      END IF

C...for subsequent calls, check to make sure some species were
C...  specified, otherwise there is no need to perform scavenging

      IF ( N_SPC_SCAV .LE. 0 ) RETURN

      RTCH = ( MOLVOL / STDTEMP ) * TBARC
      TWASH = WTBAR * 1000.0 * CTHK1 * 3600.0
     &      / ( H2ODENS * AMAX1( 1.0E-20, PRATE1 ) )
ccc          TWASH = AMAX1( TWASH, TAUCLD / 60.0 )   ! <different units?sec&min
      TWASH = AMAX1( TWASH, TAUCLD )
      ONE_OVER_TWASH = 1.0 / TWASH
      TWF = H2ODENS / ( WTBAR * RTCH )
      REMOVAC = 0.0

#ifdef sens
      S_REMOVAC = 0.0
#endif

      RHOAIR = ( AIRM / CTHK1 ) * MWAIR * KGPG

C...compute total Aitken mode number (#/m3)

      NUMAKN = 0.0

      DO I = 1, N_NUMAKN
        PNTR = SCAV_MAP( L_NUMAKN( I ) )
        NUMAKN = NUMAKN + ( POLC( PNTR ) * AIRM / CTHK1 )
      END DO

C...compute total Aitken mode mass (ug/m3)

      MASAKN_D = 0.0D0

      DO I = 1, N_MASAKN
        PNTR = SCAV_MAP( L_MASAKN( I ) )
        IF (( INDEX( SCAV_SPC( L_MASAKN( I ) ), 'NUM' ) .EQ. 0 ) .AND.
     &      ( INDEX( SCAV_SPC( L_MASAKN( I ) ), 'SRF' ) .EQ. 0 ) .AND.
     &      ( INDEX( SCAV_SPC( L_MASAKN( I ) ), 'H2O' ) .EQ. 0 ) .AND.
     &      ( INDEX( SCAV_SPC( L_MASAKN( I ) ), 'TRACER' ) .EQ. 0 ) ) THEN
          MASAKN_D = MASAKN_D + REAL( ( POLC( PNTR ) * AIRM / CTHK1
     &           * CGRID_MW( PNTR ) ),8 ) * 1.0D6
        END IF
      END DO

      MASAKN = REAL( MASAKN_D, 4 )

C...compute total Aitken mode surface area (m2/m3)

      SRFAKN = 0.0

      DO I = 1, N_SRFAKN
        PNTR = SCAV_MAP( L_SRFAKN( I ) )
        SRFAKN = SRFAKN + ( POLC( PNTR ) * AIRM / CTHK1 )
      END DO

C...compute the scavenging coefficients for aitken mode aerosol mass
C...  and number
C...  NOTE:  for now, scavenging coefficients are computed for only
C...         the liquid water content, not on the total water content
C...         therefore, no ice phase scavenging is considered at this
C...         time, but it should be added in the future!

      CALL GETALPHA ( NUMAKN, MASAKN, SRFAKN, WCBAR, TBARC, PBARC,
     &                RHOAIR, ALFA0, ALFA2, ALFA3 )

      ! Compute Wet Scavenging Removal
      SPC = 0
      DO SPC = 1, N_SPC_SCAV
        IF ( SCAV_MASK_GAS( SPC ) .OR.
     &       SCAV_MASK_NR( SPC )  .OR.
     &       SCAV_MASK_TRAC( SPC ) ) THEN

          ! Gases, Non-Reactives, and Tracers
          PNTR = SCAV_MAP( SPC )
          KH = HLCONST( HLIND( SPC ), TBARC, .TRUE., HPLUS )
          IF ( KH .GT. 0.0 ) THEN
            ALFA = SCAV_FAC( SPC ) * ONE_OVER_TWASH / ( 1.0 + TWF / KH )
            CEND ( PNTR ) = POLC( PNTR ) * EXP( -ALFA * TAUCLD )
            REMOV( PNTR ) = ( POLC( PNTR ) - CEND( PNTR ) ) * AIRM
#ifdef sens
            DO NP = 1, NPMAX
              S_CEND ( NP, PNTR ) = S_POLC( NP, PNTR ) * EXP( -ALFA * TAUCLD )
              S_REMOV( NP, PNTR ) = ( S_POLC( NP, PNTR ) - S_CEND( NP, PNTR ) ) * AIRM
            END DO
#endif
          ELSE
            ALFA = 0.0
            CEND ( PNTR ) = POLC( PNTR )
            REMOV( PNTR ) = 0.0
#ifdef sens
            DO NP = 1, NPMAX
              S_CEND( NP, PNTR )  = S_POLC( NP, PNTR )
              S_REMOV( NP, PNTR ) = 0.0
            END DO
#endif
          END IF
        ELSE  
          ! Aerosol scavenging and wet deposition
          PNTR = SCAV_MAP( SPC )
          IF ( SCAV_MASK_AITKEN( SPC ) ) THEN
            ! Aitken Mode Particles
            IF ( SCAV_MASK_NUM( SPC ) ) THEN
              ! Aitken Number
              ALFA = SCAV_FAC( SPC ) * ALFA0 
            ELSE IF ( SCAV_MASK_SRF( SPC ) ) THEN
              ! Aitken Surface Area
              ALFA = SCAV_FAC( SPC ) * ALFA2
            ELSE
              ! Aitken Mass
              ALFA = SCAV_FAC( SPC ) * ALFA3
            END IF
          ELSE
            ! Accumulation and Coarse Number, Surface Area and Mass
            ALFA = SCAV_FAC( SPC ) * ONE_OVER_TWASH
          END IF
      
          CEND ( PNTR ) = POLC( PNTR ) * EXP( -ALFA * TAUCLD )
          REMOV( PNTR ) = ( POLC( PNTR ) - CEND( PNTR ) ) * AIRM
      
#ifdef sens
          DO NP = 1, NPMAX
            S_CEND ( NP,PNTR ) = S_POLC( NP,PNTR ) * EXP( -ALFA * TAUCLD )
            S_REMOV( NP,PNTR ) = ( S_POLC( NP,PNTR ) - S_CEND( NP, PNTR ) ) * AIRM
          ENDDO
#endif
        END IF
      END DO
      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!....................................................................
!  The RUNTIME_VARS module contains file unit identifiers for the log files,
!  input files, and the values of all environment variables.
!
!  It also contains routines for reading environment variables, and
!  opening input files.
!
!  History:
!   07/19/18, D. Wong: removed some of the ifdef clause for twoway model
!                      and added new logical environment variables
!                      ncd_64bit_offset and cell_num for MPAS coupling scheme
!  31 Jan 2019  (David Wong)
!     -- removed all twoway related environment variables in this file
!  01 Feb 2019  (David Wong)
!     -- implemented invocation of GET_ENV call directly, removed unnecessay
!        interface block and unnecessary functions
!  02 May 2019  (David Wong)
!     -- set BIOGEMIS_SEASON = .FALSE. as the default value
!  13 May 2019  (David Wong)
!     -- setup environment variable ISAM_NEW_START
!  14 May 2019  (David Wong)
!     -- updated environment variable ISAM_NEW_START with default value 'Y'
!  15 May 2019  (David Wong)
!     -- included check for using marine gas emission or not
!  13 June 2019 (F. Sidi) 
!     -- Set the default for ERODE_AGLAND to FALSE. No longer supported feature
!        in CMAQv5.3
!  25 July 2019 (D. Wong) 
!     -- Included a logic to determine whether met data was created from 
!        WRF V4+ is used
!  01 Aug 2019 (D. Wong) 
!     -- Modified code to work with two-way model
!  07 Nov 2019 (D. Wong) 
!     -- Made RUNLEN environment variable avilable to two-way model as well
!  22 Nov 2019 (F. Sidi) 
!     -- Re-introduced master switch to overide emissions file date for
!        representative day files
!  10 Feb 2020 (D. Wong) 
!     -- Added new environmental variable, MET_TSTEP, to enable
!        running with temporally finer meteorology
!  10 Jun 2021 (G. Sarwar)
!     -- Added 'CB6R5M' and deleted "CB6R3M"
!  4 Mar 2022 (G. Sarwar)
!     -- Added 'CB6R5'
!....................................................................

      MODULE RUNTIME_VARS

      use get_env_module
#ifdef mpas
      use universal_data_module, only : logdev
      use mydata_module
#endif

      IMPLICIT NONE

      SAVE

      PUBLIC

      INTEGER :: OUTDEV = 6   ! File Unit for Standard Output
#ifndef mpas
      INTEGER :: LOGDEV = -1  ! File Unit for Ascii Log File
#endif
      INTEGER :: TOTPE  = 1   ! Number of Total Processors
      INTEGER :: NPROCS = 1   ! Number of Total Processors
      INTEGER :: MYPE   = -1  ! Processor Number
      CHARACTER( 3 ) :: CMYPE  = ""  ! Processor Number

      !-----------------------------------------------------------------------------------
      !>> Parameters for formatting output log files
      !-----------------------------------------------------------------------------------

      INTEGER, PARAMETER :: CTM_DIAG_LVL = 0
      
      INTEGER :: LOG_LINE_LENGTH = 80  ! Cut the log offs at this character if possible
      INTEGER :: LOG_MAJOR_TAB   = 5   ! Left tab for all text including headings
      INTEGER :: LOG_MINOR_TAB   = 2   ! Tab for indenting subsequent lines of text in
                                       ! a paragraph for instance.

      CHARACTER( 10 ) :: WEEKDAY( 7 ) = (/'Monday   ','Tuesday  ','Wednesday',
     &                        'Thursday ','Friday   ','Saturday ','Sunday   ' /)


! this is for MPAS
      LOGICAL :: ncd_64bit_offset = .FALSE.

      !-----------------------------------------------------------------------------------
      !>> Define Environment Variables for Controlling CMAQ Processes
      !-----------------------------------------------------------------------------------

      ! Met model version
      LOGICAL :: WRF_V4P         = .FALSE.  ! Indicator of whether WRF version is 4+ or not

      ! Convective scheme in met model
      LOGICAL :: CONVECTIVE_SCHEME = .TRUE.
      ! Flag for column model
      LOGICAL :: COLUMN_MODEL      = .FALSE.

      ! Grid and High-Level Model Parameters
      LOGICAL :: NEW_START       = .TRUE.   ! Start New Simulation. Not a Restart
      LOGICAL :: IGNORE_SOILINP  = .FALSE.   ! In case you don't have prev day
      CHARACTER(300):: EXECUTION_ID = ''    ! Execution ID
      CHARACTER(16) :: GRID_NAME = ''       ! grid name selected from GRIDDESC
      CHARACTER(16) :: PROGNAME  = 'DRIVER' ! Program name selected from GRIDDESC
      INTEGER :: RUNLEN          = 480000   ! Run Length
      INTEGER :: STDATE          = 1995192  ! Start Date
      INTEGER :: STTIME          = 000000   ! Start Time
      INTEGER :: LOCAL_TSTEP     = 010000   ! set to TSTEP( 1 ) in initscen.F
      INTEGER :: MET_TSTEP                  ! set meterology input temporal frequency
      INTEGER :: NPCOL           = 1        ! no. of processors across grid columns
      INTEGER :: NPROW           = 1        ! no. of processors across grid rows
      INTEGER :: MAXSYNC         = 720      ! force max TSTEP(2) (sec)
      INTEGER :: MINSYNC         = 60       ! force min TSTEP(2) (sec)

      INTEGER, PARAMETER :: MAXLEN_CCTM_APPL     = 200    ! Length of Logfile Names
      CHARACTER( MAXLEN_CCTM_APPL ) :: APPL_NAME = 'APPL' ! Logfile Names
      CHARACTER( MAXLEN_CCTM_APPL ) :: BLDFOLD   = ''     ! Build Directory
      CHARACTER( MAXLEN_CCTM_APPL ) :: OUTDIR    = ''     ! Output Directory

      ! General; Multiprocess control, output and error checking
      LOGICAL :: PRINT_PROC_TIME = .FALSE. ! Flag to print elapsed time for all 
                                           ! science submodules
      LOGICAL :: FL_ERR_STOP=.TRUE.        ! Flag to stop run if errors are found.
      LOGICAL :: CKSUM     = .TRUE.        ! flag for cksum on, default = [T]
      LOGICAL :: END_TIME  = .FALSE.       ! Override default beginning ACONC timestamp
      LOGICAL :: CTM_MIO_FILE = .FALSE.    ! Flag to write out ascii file that informs MIO 
                                           !   about output file metadata
      
      INTEGER :: N_ACONC_VARS = 0    ! Number of species saved to avg conc file
      INTEGER :: N_CONC_VARS  = 0    ! Number of species saved to conc file
      INTEGER :: ACONC_BLEV= 0       ! Beginning level saved to avg conc file
      INTEGER :: ACONC_ELEV= 0       ! Ending level saved to avg conc file
      INTEGER :: CONC_BLEV = 0       ! Beginning level saved to conc file
      INTEGER :: CONC_ELEV = 0       ! Ending level saved to conc file
      CHARACTER(  16 ) :: ACONC_FILE_SPCS( 900 ) = '' ! avg conc file species list
      CHARACTER(  16 ) :: CONC_FILE_SPCS(900 )   = '' ! conc file species list
      LOGICAL :: PWRTFLAG  = .TRUE.  ! Print confirmation of successful output 
                                           ! to logfile
      LOGICAL :: LVEXT = .FALSE.     ! Flag to perform vertical Extraction
      CHARACTER( 1000 ) :: VEXT_COORD_PATH = "" ! File Path for Lon-Lat Text file specifying 
                                                ! locations for vertical extraction
      
      CHARACTER(256) :: GC_NAMELIST = '' ! Gas Species Namelist
      CHARACTER(256) :: AE_NAMELIST = '' ! Aerosol Species Namelist
      CHARACTER(256) :: NR_NAMELIST = '' ! Nonreactive Species Namelist
      CHARACTER(256) :: TR_NAMELIST = '' ! Tracer Species Namelist
     
      ! Chemistry and Photolysis
      LOGICAL :: PHOTDIAG  = .FALSE.       ! Flag for PHOTDIAG file
      INTEGER :: NLAYS_DIAG = 0            ! Number of Diagnostic Layers to write out for photolysis
      INTEGER :: NWAVE = 0                 ! Number of Diagnostic Wavelengths
      CHARACTER(16) :: WAVE_ENV(100)       ! Targeted wavelengths for diagnostic output
      LOGICAL :: CORE_SHELL= .FALSE.       ! flag for using core-shell mixing model for aerosol optics
      INTEGER :: AEROSOL_OPTICS = 3        ! optics calculation method of volume mixture aerosols
      REAL    :: GEAR_RTOL = 1.0E-3        ! Relative Tolerance for Gear Solver
      REAL    :: GEAR_MAX_ATOL = 1.0E-7    ! Upper Bound for Absolute Tolerance in Gear Solver (ppmV)
      REAL    :: GEAR_MIN_ATOL = 1.0E-9    ! Lower Bound for Absolute Tolerance in Gear Solver (ppmV)
      REAL    :: GEAR_CONC_FLOOR = 1.0E-12 ! Lowest Concentration used determing ATOL in Gear Solver (ppmV)
      REAL    :: GLBL_ATOL = 1.0E-7        ! Absolute Tolerance for Rosenbrock Solver (ppmV)
      REAL    :: GLBL_RTOL = 1.0E-3        ! Relative Tolerance for Rosenbrock Solver
      LOGICAL :: LPVO3     = .FALSE.       ! Activate Potential Vorticity Module (default=False)

      ! Aerosols
      LOGICAL :: BC_AERO_M2WET=.FALSE.! flag for specifying wet aerosol size parameters 
                                      !   for boundary conditions. FALSE = dry
      LOGICAL :: BC_AERO_M2USE=.TRUE. ! flag for using the second moment from the input file
                                          !   for boundary conditions.TRUE = use input 2nd moment

      ! Cloud Parameters
      LOGICAL :: CLD_DIAG  = .FALSE. ! flag to output cloud diagnostic files

      ! Air-Surface Exchange
      LOGICAL :: ABFLUX     = .FALSE. ! flag for ammonia bi-directional flux with in-lining depv
      LOGICAL :: MOSAIC     = .FALSE. ! flag for STAGE mosaic - output land use specific deposition and deposition velocity
      LOGICAL :: SFC_HONO   = .FALSE. ! flag for HONO interaction with surfaces 
      LOGICAL :: PX_LSM     = .TRUE.  ! flag for WRF PX land surface model
      LOGICAL :: CLM_LSM    = .FALSE. ! flag for WRF CLM land surface model
      LOGICAL :: NOAH_LSM   = .TRUE.  ! flag for WRF NOAH land surface model
      LOGICAL :: DEPV_DIAG  = .FALSE. ! flag for grid cell deposition velocity diagnostic file
      Logical :: HGBIDI     = .FALSE. ! flag for Hg bidirectional exchange
      Logical :: BIDI_FERT_NH3 = .TRUE. ! flag to remove fertilizer ammonia from Bidirectional emissions
      Logical :: STAGE_E20 = .TRUE.   ! flag for the Emerson et al. 2020 Aerosol deposition model PNAS https://www.pnas.org/cgi/doi/10.1073/pnas.2014761117
      Logical :: STAGE_P22 = .FALSE.  ! flag for the Pleim et al. 2022 Aerosol deposition model
      Logical :: STAGE_S22 = .FALSE.  ! flag for the Shu et al. 2022 Aerosol deposition model
      CHARACTER(16) :: DUST_LAND_SCHEME = "UNKNOWN" ! NLCD, USGS, etc
 

      ! Transport Processes
      LOGICAL :: VDIFFDIAG = .FALSE. ! flag for VDIFF diagnostic files
      REAL    :: SIGST     = 0.7     ! sigma_sync_top value
      REAL    :: HDIV_LIM  = 0.9     ! cutoff for max horizontal divergence step adj
      REAL    :: CFL       = 0.75    ! maximum Courant-Friedrichs-Lewy number allowed
      Logical :: MINKZ     = .TRUE.  ! flag for minimum Kz 
      LOGICAL :: W_VEL     = .FALSE. ! flag for vertical velocity 
      LOGICAL :: GRAV_SETL = .TRUE.  ! flag for aerosol gravitational setling


      ! Emissions Processes
      CHARACTER( MAXLEN_CCTM_APPL ) :: STAGECTRL  = 'STAGECTRL_NML' ! STAGE Deposition Control Filename
      CHARACTER( MAXLEN_CCTM_APPL ) :: CMAQ_CTRL  = 'CMAQ_CTRL_NML' ! Emission Control Filename
      CHARACTER( MAXLEN_CCTM_APPL ) :: CMAQ_CHEM_CTRL  = 'CMAQ_CH_CTRL_NML' ! Emission Control Filename
      INTEGER :: EMLAYS_MX     = 0       ! Emission Layers
      INTEGER :: N_FILE_GR     = 0       ! Number of Gridded Emission Files
      INTEGER :: N_FILE_TR     = 0       ! NUmber of Tracer Emission Files
      LOGICAL :: EMISCHK       = .TRUE.  ! flag for checking that surrogate emissions 
                                               !   are present on emission files
      LOGICAL :: BIOGEMIS_BEIS = .FALSE. ! flag to in-line biogenic VOC emissions
      LOGICAL :: BIOGEMIS_MEGAN= .FALSE. ! flag to in-line MEGAN biogenic emissions
      LOGICAL :: USE_MEGAN_LAI = .FALSE. ! flag to use MEGAN LAI values
      LOGICAL :: MGN_ONLN_DEP  = .FALSE. ! flag to use ONLINE N deposition in BDSNP
      LOGICAL :: BDSNP_MEGAN   = .FALSE. ! flag to use BDSNP for soil NO 
      CHARACTER(16) :: SPPRO   = 'DEFAULT' ! requested speciation profile name
      LOGICAL :: BEMIS_DIAG    = .TRUE.  ! true: write diagnostic emiss file
      LOGICAL :: MGEMDIAG      = .FALSE. ! flag for MGEM diagnostic file
      LOGICAL :: OCEAN_CHEM    = .TRUE.  ! Flag for ocean halogen chemistry and sea spray aerosol emissions
      LOGICAL :: WB_DUST       = .FALSE. ! flag for On-Line Dust Emission Calculation
      LOGICAL :: DUSTEM_DIAG   = .FALSE. ! flag for dustemis diagnostic file
      LOGICAL :: SSEMDIAG      = .FALSE. ! flag for SSEMIS diagnostic file
      LOGICAL :: LTNG_NO       = .FALSE. ! flag for online calculation of NO from lightning
      INTEGER :: LT_ASM_DT     = 0       ! Lightning Input Time Interval
      LOGICAL :: NLDNSTRIKE    = .FALSE. ! flag to use NLDN STRIKE directly 
      LOGICAL :: LTNGDIAG      = .FALSE. ! flag to turn on lightning NO diagnostics
      REAL    :: MOLSNCG       = 350.0   ! Lightning NO Production Rate
      REAL    :: MOLSNIC       = 350.0   ! Lightning NO Production Rate
      CHARACTER(250) :: LTNG_FNAME = 'InLine' ! Lightning NO Input Name

      INTEGER :: NPTGRPS       = 0       ! no. pt src input file groups
      LOGICAL :: PT3DDIAG      = .FALSE. ! Write point source 3d emis diagnostic file
      LOGICAL :: PT3DFRAC      = .FALSE. ! Write layer fractions diagnostic file, if true
      INTEGER :: PT_NSTEPS     = 1
      INTEGER :: PT_DATE       = 1995192 ! Julian start date (YYYYDDD)
      INTEGER :: PT_TIME       = 0       ! start time (HHMMSS)
      INTEGER :: IPVERT        = 0       ! Numerical flag for plume vertical spread method
      INTEGER :: REP_LAYR      = -1      ! Minimum layer for reporting srcs w/ high plumes
      LOGICAL :: EMIS_SYM_DATE = .FALSE.  ! Overrider CMAQ not to check
                                          ! if the dates on the emissions file match that of 
                                          ! the interal model (representative day case)
      CHARACTER(  16 ), SAVE, ALLOCATABLE :: PLAY_BASE( : ) ! Use for Plume Rise Calculation

      LOGICAL :: USE_MARINE_GAS_EMISSION = .FALSE.
      LOGICAL :: USE_MET_EMIS            = .FALSE. ! flag for met-modulated emissions
      LOGICAL :: METEMDIAG               = .FALSE. ! flag for MET_EM diagnostic file
      LOGICAL :: HUM_NOX_YN              = .FALSE. ! flag for MET_EM NOx correction

      ! Process Analysis
      LOGICAL :: PROCAN    = .FALSE. ! flag for process analysis
      INTEGER :: PA_BEGCOL = 0       ! Starting PA output
      INTEGER :: PA_ENDCOL = 0       ! ending column for PA output
      INTEGER :: PA_BEGROW = 0       ! Starting row for PA output
      INTEGER :: PA_ENDROW = 0       ! ending row for PA output
      INTEGER :: PA_BEGLEV = 0       ! Starting layer for PA output
      INTEGER :: PA_ENDLEV = 0       ! ending layer for PA output
      CHARACTER( MAXLEN_CCTM_APPL ) :: BUDGET_FNAME  = 'CCTM_BUDGET' ! STAGE Deposition Control Filename

      ! Sulfur tracking
      LOGICAL :: STM        = .FALSE. ! flag for sulfur tracking option
      LOGICAL :: ADJ_STMSPC = .TRUE.  ! flag for normalizing sulfur tracking species

      ! ISAM
      CHARACTER(1) :: ISAM_NEW_START = 'Y'  ! Start New Simulation. Not a Restart for ISAM
      INTEGER :: ISAM_BLEV = 0              ! Beginning level saved to conc file
      INTEGER :: ISAM_ELEV = 0              ! Ending level saved to conc file
      INTEGER :: SA_NLAYS = 0               ! Number of layers saved to conc file
      INTEGER :: AISAM_BLEV = 0             ! Beginning level saved to sa_aconc file
      INTEGER :: AISAM_ELEV = 0             ! Ending level saved to sa_aconc file
      INTEGER :: AVGSA_LAYS = 0             ! Number of layers saved to conc file
      INTEGER :: ISAM_CHEM_BIAS = 5         ! which chemistry are biased in apportioning reaction yields
                                            ! to source reactant
                                            ! 1 for none so divided equally between sources' reactant
                                            ! 2 for all products apportioned to sources with NO, NO2, NO3, HONO, ANO3
                                            !   -equally if reactants are neither or both
                                            ! 3 for all products apportioned to sources with Case 2 plus select OVOC species 
                                            ! and radicals
                                            !   -equally if reactants are neither or both
                                            ! 4 for all products apportioned to sources with select OVOC species 
                                            ! and radicals
                                            !   -equally if reactants are neither or both
                                            ! 5 to switch between Cases 2 and 3 based on whether
                                            ! production H2O2 over production HNO3 less than VOC_NOX_TRANS
                                   
      REAL     :: VOC_NOX_TRANS = 0.35      ! H2O2 to HNO3 marking transition from NOx to VOC limiting O3 production 
      INTEGER  :: ISAM_NOX_CASE = 2         ! option of ISAM_CHEM_BIAS representing NOx limiting O3 production
      INTEGER  :: ISAM_VOC_CASE = 4         ! option of ISAM_CHEM_BIAS representing VOC limiting O3 production

      CONTAINS
          
!.........................................................................
      SUBROUTINE INIT_ENV_VARS( JDATE, JTIME )

!  Defines and retrieves values for all environment variable input to 
!  CMAQ. 
!.........................................................................

      USE RXNS_DATA, ONLY : MECHNAME
#ifdef mpas
      use utilio_defn
#else
      USE M3UTILIO
#endif

      IMPLICIT NONE                         

      INCLUDE SUBST_FILES_ID             ! file name parameters

#ifdef parallel      
      include 'mpif.h'
#endif
 
      INTEGER, INTENT( In )  :: JDATE       
      INTEGER, INTENT( In )  :: JTIME  
      CHARACTER(  16 )       :: V_LIST2( 20 )
      CHARACTER( 240 )       :: XMSG   = ''  
      INTEGER                :: NV


      INTEGER          :: STATUS      ! ENV... status
      CHARACTER( 400 ) :: STRTEMP
      CHARACTER( 80 )  :: PBASE     
      INTEGER, PARAMETER :: EXIT_STATUS = 1
      INTEGER          :: ERROR
      INTEGER          :: VARDEV = -1

      LOGICAL          :: FOUND
      LOGICAL          :: EFLAG = .FALSE.
      INTEGER          :: LOC, STR_LEN
      CHARACTER(10)    :: WRF_VERSION

      CHARACTER( 16 ) :: PNAME = 'RUNTIME_VARS'

      !-------------------------------------------------------------------------------------------------------
      !>> Grid and High-Level Model Parameters
      !-------------------------------------------------------------------------------------------------------
#ifdef parallel
      CALL MPI_COMM_RANK ( MPI_COMM_WORLD, MYPE, ERROR )
      CALL MPI_COMM_SIZE ( MPI_COMM_WORLD, TOTPE, ERROR )
#else
      MYPE = 0
      TOTPE = 0
#endif
 
      IF ( MYPE .EQ. 0 ) VARDEV = OUTDEV

      ! Get Simulation Scenario Name to Label Log Files, etc
      CALL GET_ENV( APPL_NAME, 'CTM_APPL', APPL_NAME, VARDEV )
      
      ! Start I/O-API and set up log file(s)
      CALL SETUP_LOGDEV()
      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_HEADING( OUTDEV, "Environment Variable Report" )
         CALL LOG_SUBHEADING( OUTDEV, "Grid and High-Level Model Parameters" )
         WRITE( OUTDEV, '(6x,A)' ),'  ---Env Variable---  |  ---Value---'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

       ! Get Logfile Directory
      CALL GET_ENV ( BLDFOLD, 'BLD', BLDFOLD, VARDEV ) 
 
      ! Get Logfile Directory
      CALL GET_ENV ( OUTDIR, 'OUTDIR', OUTDIR, VARDEV ) 
 
      ! Determine if this run is a new start or a restart
      CALL GET_ENV ( NEW_START, 'NEW_START', NEW_START, VARDEV )

      ! Determine if prev day soilinp is available for MEGAN
      CALL GET_ENV ( IGNORE_SOILINP, 'IGNORE_SOILINP', IGNORE_SOILINP, VARDEV )
    
      ! Get Execution ID
      CALL GET_ENV ( STRTEMP, 'EXECUTION_ID', EXECUTION_ID, VARDEV )
      EXECUTION_ID = STRTEMP(1:300)

      ! Get Grid Name
      CALL GET_ENV ( STRTEMP, 'GRID_NAME', GRID_NAME, VARDEV )
      GRID_NAME = STRTEMP(1:16)

      ! Output Time Step
      CALL GET_ENV ( LOCAL_TSTEP, 'CTM_TSTEP', LOCAL_TSTEP, VARDEV )

      ! Run Duration
      CALL GET_ENV ( RUNLEN,  'CTM_RUNLEN', RUNLEN, VARDEV )
      
#ifndef twoway
      ! Main Program Name
      CALL GET_ENV ( STRTEMP, 'CTM_PROGNAME', PROGNAME, VARDEV )
      PROGNAME = STRTEMP( 1:16 )

      ! Starting Date
      CALL GET_ENV ( STDATE, 'CTM_STDATE', STDATE, VARDEV )

      ! Starting Time
      CALL GET_ENV ( STTIME, 'CTM_STTIME', STTIME, VARDEV )

      ! Retrieve the domain decomposition processor array
      IF ( NPROCS .GT. 1 ) THEN
         CALL GET_ENVLIST ( 'NPCOL_NPROW', NV, V_LIST2, VARDEV )
         IF ( NV .NE. 2 ) THEN
            XMSG = 'Environment variable problem for NPCOL_NPROW'
     &           // ' using default 1X1'
            CALL M3WARN ( 'INIT_ENV_VARS', 0, 0, XMSG )
            NV = 2
            V_LIST2( 1 ) = '1'
            V_LIST2( 2 ) = '1'
         END IF
         READ( V_LIST2( 1 ), '( I4 )' ) NPCOL
         READ( V_LIST2( 2 ), '( I4 )' ) NPROW
      END IF
      
#endif
      
      ! MAXSYNC
      CALL GET_ENV ( MAXSYNC, 'CTM_MAXSYNC', MAXSYNC, VARDEV )

      ! MINSYNC
      CALL GET_ENV ( MINSYNC, 'CTM_MINSYNC', MINSYNC, VARDEV )


      !-------------------------------------------------------------------------------------------------------
      !>> General; Multiprocess control, output and error checking
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Multiprocess control, output and error checking" )
         WRITE( OUTDEV, '(6x,A)' ),'  ---Env Variable---  |  ---Value---'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! PRINT_PROC_TIME
      CALL GET_ENV ( PRINT_PROC_TIME, 'PRINT_PROC_TIME', PRINT_PROC_TIME, VARDEV )  

      ! FL_ERR_STOP
      CALL GET_ENV ( FL_ERR_STOP, 'FL_ERR_STOP', FL_ERR_STOP, VARDEV )  

      ! PRINT MIO INPUT FILE
      CALL GET_ENV ( CTM_MIO_FILE, 'CTM_MIO_FILE', CTM_MIO_FILE, VARDEV )  

      ! CKSUM
      CALL GET_ENV ( CKSUM, 'CTM_CKSUM', CKSUM, VARDEV )

      ! Override default beginning time timestamp for ACONC?
      CALL GET_ENV ( END_TIME, 'AVG_FILE_ENDTIME', END_TIME, VARDEV )
      
      ! ACONC File Species List
      CALL GET_ENVLIST ( 'AVG_CONC_SPCS', N_ACONC_VARS, ACONC_FILE_SPCS, VARDEV )

      ! CONC File Species List 
      CALL GET_ENVLIST ( 'CONC_SPCS', N_CONC_VARS, CONC_FILE_SPCS, VARDEV )
 
      ! ACONC Layer Specification
      CALL GET_ENVLIST ( 'ACONC_BLEV_ELEV', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   ! assume 1:NLAYS
         ACONC_BLEV = 1
         ACONC_ELEV = -1
      ELSE IF ( NV .EQ. 1 ) THEN ! Assume 1:CONC_BLEV_ELEV
         ACONC_BLEV = 1
         READ( V_LIST2( 2 ), '( I4 )' ) ACONC_ELEV
      ELSE IF ( NV .EQ. 2 ) THEN ! Correct Input
         READ( V_LIST2( 1 ), '( I4 )' ) ACONC_BLEV
         READ( V_LIST2( 2 ), '( I4 )' ) ACONC_ELEV
      ELSE 
         XMSG = 'Environment variable error for ACONC_BLEV_ELEV'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF
  
      ! CONC File Vertical Layer Range and Speciation
      CALL GET_ENVLIST ( 'CONC_BLEV_ELEV', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   ! assume 1:NLAYS
         CONC_BLEV = 1
         CONC_ELEV = -1
      ELSE IF ( NV .EQ. 1 ) THEN ! Assume 1:CONC_BLEV_ELEV
         CONC_BLEV = 1
         READ( V_LIST2( 2 ), '( I4 )' ) CONC_ELEV
      ELSE IF ( NV .EQ. 2 ) THEN ! Correct Input
         READ( V_LIST2( 1 ), '( I4 )' ) CONC_BLEV
         READ( V_LIST2( 2 ), '( I4 )' ) CONC_ELEV
      ELSE 
         XMSG = 'Environment variable error for CONC_BLEV_ELEV'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF

      ! PWRTFLAG
      CALL GET_ENV ( PWRTFLAG, 'IOAPI_LOG_WRITE', PWRTFLAG, VARDEV )

      ! Get Flag for Vertical Extraction
      CALL GET_ENV ( LVEXT, 'VERTEXT', LVEXT, VARDEV )
#ifdef parallel
      ! Get Filepath for File Specifying Lon-Lat Coordinates for
      ! Vertical Extraction
      CALL GET_ENV ( VEXT_COORD_PATH, 'VERTEXT_COORD_PATH', VEXT_COORD_PATH, VARDEV )
#else
      IF( LVEXT ) THEN
          LVEXT = .FALSE.
          WRITE( OUTDEV,'(A)')'Option to extract a Vertical Column of Ouptut Data set to YES'
          WRITE( OUTDEV,'(A)')'However, the serial version cannot execute the option'
          WRITE( LOGDEV,'(A)')'Option to extract a Vertical Column of Ouptut Data set to YES'
          WRITE( LOGDEV,'(A)')'However, the serial version cannot execute the option'
      END IF
#endif

      ! Get Filename for Gas Species Namelist
      CALL GET_ENV ( GC_NAMELIST, 'gc_matrix_nml', GC_NAMELIST, VARDEV )

      ! Get Filename for Aerosol Species Namelist
      CALL GET_ENV ( AE_NAMELIST, 'ae_matrix_nml', AE_NAMELIST, VARDEV )

      ! Get Filename for Nonreactive Species Namelist
      CALL GET_ENV ( NR_NAMELIST, 'nr_matrix_nml', NR_NAMELIST, VARDEV )

      ! Get Filename for Tracer Species Namelist
      CALL GET_ENV ( TR_NAMELIST, 'tr_matrix_nml', TR_NAMELIST, VARDEV )

#ifdef isam
      !-------------------------------------------------------------------------------------------------------
      !>> ISAM
      !-------------------------------------------------------------------------------------------------------
      IF ( MYPE .EQ. 0 ) THEN
         CALL LOG_SUBHEADING( OUTDEV, "ISAM setting and output options" )
         WRITE( OUTDEV, '(6x,A)' ),'  ---Env Variable---  |  ---Value---'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF


      ! Determine if this ISAM run is a new start or a restart
      CALL GET_ENV ( ISAM_NEW_START, 'ISAM_NEW_START', ISAM_NEW_START, VARDEV )
    
      ! SA_ACONC Layer Specification
      CALL GET_ENVLIST ( 'AISAM_BLEV_ELEV', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   ! assume 1:NLAYS
         AISAM_BLEV = 1
         AISAM_ELEV = -1
      ELSE IF ( NV .EQ. 1 ) THEN ! Assume 1:AISAM_BLEV_ELEV
         AISAM_BLEV = 1
         READ( V_LIST2( 2 ), '( I4 )' ) AISAM_ELEV
      ELSE IF ( NV .EQ. 2 ) THEN ! Correct Input
         READ( V_LIST2( 1 ), '( I4 )' ) AISAM_BLEV
         READ( V_LIST2( 2 ), '( I4 )' ) AISAM_ELEV
      ELSE
         XMSG = 'Environment variable error for AISAM_BLEV_ELEV'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF

      ! SA_CONC File Vertical Layer Range and Speciation
      CALL GET_ENVLIST ( 'ISAM_BLEV_ELEV', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   ! assume 1:NLAYS
         ISAM_BLEV = 1
         ISAM_ELEV = -1
      ELSE IF ( NV .EQ. 1 ) THEN ! Assume 1:ISAM_BLEV_ELEV
         ISAM_BLEV = 1
         READ( V_LIST2( 2 ), '( I4 )' ) ISAM_ELEV
      ELSE IF ( NV .EQ. 2 ) THEN ! Correct Input
         READ( V_LIST2( 1 ), '( I4 )' ) ISAM_BLEV
         READ( V_LIST2( 2 ), '( I4 )' ) ISAM_ELEV
      ELSE
         XMSG = 'Environment variable error for ISAM_BLEV_ELEV'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF

      ! Get species bias case
      CALL GET_ENV ( ISAM_CHEM_BIAS, 'ISAM_O3_WEIGHTS', ISAM_CHEM_BIAS, VARDEV )
      IF ( ISAM_CHEM_BIAS .LT. 1 .OR. ISAM_CHEM_BIAS .GT. 5 ) THEN
         XMSG = 'ISAM_O3_WEIGHTS must equal 1 thru 5'
         WRITE( OUTDEV, '(A)' )TRIM( XMSG )
         CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF

      IF ( ISAM_CHEM_BIAS .EQ. 5 ) THEN
        EFLAG = .FALSE.
      ! VOC_NOX_TRANS value, ratio of H2O2 over HNO3 production rates or concentration 
          CALL GET_ENV ( VOC_NOX_TRANS, 'VOC_NOX_TRANS', VOC_NOX_TRANS, VARDEV )
          CALL GET_ENV ( ISAM_NOX_CASE, 'ISAM_NOX_CASE', ISAM_NOX_CASE, VARDEV )
          CALL GET_ENV ( ISAM_VOC_CASE, 'ISAM_VOC_CASE', ISAM_VOC_CASE, VARDEV )
          IF ( ISAM_NOX_CASE .LT. 1 .OR. ISAM_NOX_CASE .GT. 4 ) THEN
              XMSG = 'ISAM_NOX_CASE  must equal 1 thru 4'
              WRITE( OUTDEV, '(A)' )TRIM( XMSG )
              EFLAG = .TRUE.
          END IF 
          IF ( ISAM_VOC_CASE .LT. 1 .OR. ISAM_VOC_CASE .GT. 4 ) THEN
              XMSG = 'ISAM_VOC_CASE  must equal 1 thru 4'
              WRITE( OUTDEV, '(A)' )TRIM( XMSG )
              EFLAG = .TRUE.
          END IF 
          IF ( ISAM_VOC_CASE .EQ. ISAM_NOX_CASE ) THEN
              XMSG = 'ISAM_VOC_CASE  must NOT equal ISAM_NOX_CASE'
              WRITE( OUTDEV, '(A)' )TRIM( XMSG )
              XMSG = 'Set ISAM_O3_WEIGHTS to their value.'
              WRITE( OUTDEV, '(A)' )TRIM( XMSG )
              EFLAG = .TRUE.
          END IF 
          IF ( EFLAG ) CALL M3EXIT ( PNAME, 0, 0, 'Found errors in ISAM options', XSTAT1 )
      END IF   
#endif
      
      !-------------------------------------------------------------------------------------------------------
      !>> Chemistry and Photolysis
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Chemistry and Photolysis" )
         WRITE( OUTDEV, '(6x,A)' ),'  ---Env Variable---  |  ---Value---'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Get photolysis rate diagnostic file flag
      CALL GET_ENV ( PHOTDIAG, 'CTM_PHOTDIAG', PHOTDIAG, VARDEV )

      IF( PHOTDIAG ) THEN
      ! Get desired number of layers for PHOTDIAG2 and PHOTDIAG3 files
         CALL GET_ENV ( NLAYS_DIAG, 'NLAYS_PHOTDIAG', NLAYS_DIAG, VARDEV )

      ! Get Desired Wavelengths for Diagnostic Output
        CALL GET_ENVLIST( 'NWAVE_PHOTDIAG', NWAVE, WAVE_ENV, VARDEV )
      END IF  

      CALL GET_ENV ( AEROSOL_OPTICS, 'AEROSOL_OPTICS', AEROSOL_OPTICS, VARDEV )
      IF ( AEROSOL_OPTICS .GT. 3 ) THEN ! core-shell mixing model possible
          CORE_SHELL = .TRUE.
          AEROSOL_OPTICS = AEROSOL_OPTICS - 3
      END IF

      IF ( AEROSOL_OPTICS .LT. 1 .OR. AEROSOL_OPTICS .GT. 3 ) THEN
         XMSG = 'AEROSOL_OPTICS option must equal 1 to 6'
         WRITE( OUTDEV, '(A)' )TRIM( XMSG )
         CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF

      IF ( MYPE .EQ. 0 ) THEN
         WRITE( OUTDEV, '(/,6x,A,/)' )'--ATOL settings are in ppmV.--'
      END IF

      ! Upper Bound for Absolute Tolerance for Gear Solver
      CALL GET_ENV ( GEAR_MAX_ATOL, 'GEAR_MAX_ATOL', GEAR_MAX_ATOL, VARDEV )
      
      ! Lower Bound for Absolute Tolerance for Gear Solver
      CALL GET_ENV ( GEAR_MIN_ATOL, 'GEAR_MIN_ATOL', GEAR_MIN_ATOL, VARDEV )
      
      ! Lowest Concentration used determing ATOL for Gear Solver
      CALL GET_ENV ( GEAR_CONC_FLOOR, 'GEAR_CONC_FLOOR', GEAR_CONC_FLOOR, VARDEV )
      
      !Relative Tolerance for SMVGEAR
      CALL GET_ENV ( GEAR_RTOL, 'GEAR_RTOL', GEAR_RTOL, VARDEV )
      
      ! Tolerances for Rosenbrock Solver
      CALL GET_ENV ( GLBL_RTOL, 'RB_RTOL', GLBL_RTOL, VARDEV )

      ! Absolute Tolerance for RB Solver
      CALL GET_ENV ( GLBL_ATOL, 'RB_ATOL', GLBL_ATOL, VARDEV )
      
      ! Get option for scaling ozone in free-troposphere to potential vorticity
      CALL GET_ENV ( LPVO3, 'CTM_PVO3', LPVO3, VARDEV )
 
      !-------------------------------------------------------------------------------------------------------
      !>> Aerosols
      !-------------------------------------------------------------------------------------------------------
      
      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Aerosols" )
         WRITE( OUTDEV, '(6x,A)' ),'  ---Env Variable---  |  ---Value---'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Get flag for interpreting initial condition aerosol size distributions as dry
      CALL GET_ENV ( BC_AERO_M2WET, 'BC_AERO_M2WET', BC_AERO_M2WET, VARDEV )

      ! Get flag for using initial condition aerosol second moment
      CALL GET_ENV ( BC_AERO_M2USE, 'BC_AERO_M2USE', BC_AERO_M2USE, VARDEV )

      !-------------------------------------------------------------------------------------------------------
      !>> sulfur tracking option
      !-------------------------------------------------------------------------------------------------------

      ! Flag for sulfur tracking option
      CALL GET_ENV ( STM, 'STM_SO4TRACK', STM, VARDEV )

      IF ( STM ) THEN
         ! Get sulfur tracking normalization flag
         CALL GET_ENV ( ADJ_STMSPC, 'STM_ADJSO4', ADJ_STMSPC, VARDEV )
      END IF      

      !-------------------------------------------------------------------------------------------------------
      !>> Cloud Parameters
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Cloud Processes" )
         WRITE( OUTDEV, '(6x,A)' ),'  ---Env Variable---  |  ---Value---'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! FLag for outputting cloud diagnostics
      CALL GET_ENV ( CLD_DIAG, 'CLD_DIAG', CLD_DIAG, VARDEV )

      !-------------------------------------------------------------------------------------------------------
      !>> Air-Surface Exchange Parameters
      !-------------------------------------------------------------------------------------------------------
 
      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Air-Surface Exchange Processes" )
         WRITE( OUTDEV, '(6x,A)' ),'  ---Env Variable---  |  ---Value---'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Check if using PX version of MCIP
      CALL GET_ENV ( PX_LSM, 'PX_VERSION', PX_LSM, VARDEV )

      ! Flag for Ammonia bi-directional flux with in-line deposition 
      ! velocities calculation
      CALL GET_ENV ( ABFLUX, 'CTM_ABFLUX', ABFLUX, VARDEV )

      ! Flag for Mosaic method to get land-use specific deposition velocities
      CALL GET_ENV ( MOSAIC, 'CTM_MOSAIC', MOSAIC, VARDEV )

      ! Flag for HONO interaction with leaf and building surfaces
      CALL GET_ENV ( SFC_HONO, 'CTM_SFC_HONO', SFC_HONO, VARDEV )
         
      ! Flag CLM LSM
      CALL GET_ENV ( CLM_LSM, 'CLM_VERSION', CLM_LSM, VARDEV )

      ! Flag for NOAH LSM
      CALL GET_ENV ( NOAH_LSM, 'NOAH_VERSION', NOAH_LSM, VARDEV )

      ! CTM_DEPV_FILE
      CALL GET_ENV ( DEPV_DIAG, 'CTM_DEPV_FILE', DEPV_DIAG, VARDEV )

      ! CTM_HGBIDI
      CALL GET_ENV ( HGBIDI, 'CTM_HGBIDI', HGBIDI, VARDEV )
 
      ! CTM_IGNORE_FERT_NH3
      CALL GET_ENV ( BIDI_FERT_NH3, 'CTM_BIDI_FERT_NH3', BIDI_FERT_NH3, VARDEV )
 
      ! Flag for using BELD Land Use for WindBlown Dust 
      CALL GET_ENV ( STRTEMP, 'CTM_WBDUST_BELD', DUST_LAND_SCHEME, VARDEV )
      DUST_LAND_SCHEME = STRTEMP( 1:16)

      ! Get Name of STAGE Control File
      CALL GET_ENV ( STAGECTRL, 'STAGECTRL_NML', STAGECTRL, VARDEV )

      ! Flag for Surface Tiled Aerosol and Gaseous Exchange (STAGE) model Pleim et al. 2022 Aerosol Deposition Option
      CALL GET_ENV ( STAGE_P22, 'CTM_STAGE_P22', STAGE_P22, VARDEV )

      ! Flag for Surface Tiled Aerosol and Gaseous Exchange (STAGE) model Emerson et al. 2020 Aerosol Deposition Option
      CALL GET_ENV ( STAGE_E20, 'CTM_STAGE_E20', STAGE_E20, VARDEV )

      ! Flag for Surface Tiled Aerosol and Gaseous Exchange (STAGE) model Shu et al. 2022 (CMAQ v5.3) Aerosol Deposition Option
      CALL GET_ENV ( STAGE_S22, 'CTM_STAGE_S22', STAGE_S22, VARDEV )
 
      !-------------------------------------------------------------------------------------------------------
      !>> Transport Processes
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Transport Processes" )
         WRITE( OUTDEV, '(6x,A)' ),'  ---Env Variable---  |  ---Value---'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Flag for writing vertical diffusion diagnostic file and possibly gravitational settling diagnostic file
      CALL GET_ENV ( VDIFFDIAG, 'VDIFF_DIAG_FILE', VDIFFDIAG, VARDEV )

      ! Get Minimum Layer for Advection Time Step Adjustment
      CALL GET_ENV ( SIGST, 'SIGMA_SYNC_TOP', SIGST, VARDEV )

      ! Get Maximum Horizontal Div Limit for Advection Adjustment
      CALL GET_ENV ( HDIV_LIM, 'ADV_HDIV_LIM', HDIV_LIM, VARDEV )

      ! CFL Criteria
      CALL GET_ENV ( CFL, 'CTM_ADV_CFL', CFL, VARDEV )

      ! CTM_KZMIN
      CALL GET_ENV ( MINKZ, 'KZMIN', MINKZ, VARDEV )

      ! CTM_WVEL
#ifdef mpas
      W_VEL = .FALSE.
#else
      CALL GET_ENV ( W_VEL, 'CTM_WVEL', W_VEL, VARDEV )
#endif

      ! CTM_GRAV_SETL
      CALL GET_ENV ( GRAV_SETL, 'CTM_GRAV_SETL', GRAV_SETL, VARDEV )

      !-------------------------------------------------------------------------------------------------------
      !>> Emission Environment Variables 
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Emissions Parameters" )
         WRITE( OUTDEV, '(6x,A)' ),'  ---Env Variable---  |  ---Value---'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Number of Layers for Emissions
      CALL GET_ENV ( EMLAYS_MX, 'CTM_EMLAYS', EMLAYS_MX, VARDEV )

      ! Get Name of Emission Control File
      CALL GET_ENV ( CMAQ_CTRL, 'CMAQ_CTRL_NML', CMAQ_CTRL, VARDEV )
      CALL GET_ENV ( CMAQ_CHEM_CTRL,'CMAQ_CH_CTRL_NML', CMAQ_CHEM_CTRL, VARDEV )

      ! Get number of different Gridded File Emissions Streams
      CALL GET_ENV ( N_FILE_GR, 'N_EMIS_GR', N_FILE_GR, VARDEV )
      
      ! Get number of different Gridded File Emissions Streams
      CALL GET_ENV ( N_FILE_TR, 'N_EMIS_TR', N_FILE_TR, VARDEV )

      ! Flag for checking emissions surrogates against species actually
      ! present on emissions files
      CALL GET_ENV (  EMISCHK, 'CTM_EMISCHK', EMISCHK, VARDEV )
 
      ! CTM_BIOGEMIS_BE
      CALL GET_ENV ( BIOGEMIS_BEIS, 'CTM_BIOGEMIS_BE', BIOGEMIS_BEIS, VARDEV )

      ! CTM_BIOGEMIS_MG
      CALL GET_ENV(BIOGEMIS_MEGAN, 'CTM_BIOGEMIS_MG', BIOGEMIS_MEGAN,VARDEV )
      CALL GET_ENV(USE_MEGAN_LAI, 'USE_MEGAN_LAI',USE_MEGAN_LAI,VARDEV )
      CALL GET_ENV(MGN_ONLN_DEP, 'MGN_ONLN_DEP',MGN_ONLN_DEP,VARDEV )
      CALL GET_ENV(BDSNP_MEGAN, 'BDSNP_MEGAN',BDSNP_MEGAN,VARDEV )

      ! Get the speciation profile to use
      CALL GET_ENV ( SPPRO, 'BIOG_SPRO', SPPRO, VARDEV )
 
      ! Biogenic Emission Diag File
      CALL GET_ENV ( BEMIS_DIAG, 'B3GTS_DIAG', BEMIS_DIAG, VARDEV )
 
      ! Get marine gas emission diagnostic output file flag.
      CALL GET_ENV ( MGEMDIAG, 'CTM_MGEMDIAG', MGEMDIAG, VARDEV )
 
      ! Flag for ocean halogen chemistry and sea spray aerosol emissions
      CALL GET_ENV ( OCEAN_CHEM, 'CTM_OCEAN_CHEM', OCEAN_CHEM, VARDEV )

      ! Flag for Online Calculation of Windblown dust emissions
      CALL GET_ENV ( WB_DUST, 'CTM_WB_DUST', WB_DUST, VARDEV )

      ! Get env var for diagnostic output
      CALL GET_ENV ( DUSTEM_DIAG, 'CTM_DUSTEM_DIAG', DUSTEM_DIAG, VARDEV )
       
      ! Get sea spray emission diagnostic output file flag.
      CALL GET_ENV ( SSEMDIAG, 'CTM_SSEMDIAG', SSEMDIAG, VARDEV )
 
      ! Set CTM_MET_EMIS to Y or T ro turn on met-modulated emissions
      CALL GET_ENV ( USE_MET_EMIS, 'CTM_MET_EMIS', USE_MET_EMIS, VARDEV )
 
      ! Get met-modulated emission diagnostic output file flag.
      CALL GET_ENV ( METEMDIAG, 'CTM_MET_EMIS_DIAG', METEMDIAG, VARDEV )

      ! Get met-modulated emission diagnostic output file flag.
      CALL GET_ENV ( HUM_NOX_YN, 'CTM_MET_EMIS_HUM', HUM_NOX_YN, VARDEV )

      ! Set LTNG_NO to Y or T to turn on lightning NO production
      CALL GET_ENV ( LTNG_NO, 'CTM_LTNG_NO', LTNG_NO, VARDEV ) 

      ! Get Lightning Input Time Interval
      CALL GET_ENV ( LT_ASM_DT, 'LTNG_ASSIM_DT', LT_ASM_DT, VARDEV ) 

      ! Get Lightning NO File Name
      CALL GET_ENV ( LTNG_FNAME, 'LTNGNO', LTNG_FNAME, VARDEV )
 
      ! Flag for using NLDN data for Lightning Strikes
      CALL GET_ENV ( NLDNSTRIKE, 'USE_NLDN', NLDNSTRIKE, VARDEV )
 
      ! Flag for Outputing Lightning Diagnostic File
      CALL GET_ENV ( LTNGDIAG, 'LTNGDIAG', LTNGDIAG, VARDEV )
       
      ! Get Lightning NO Production Rate
      CALL GET_ENV ( MOLSNCG, 'MOLSNCG', 350.0, VARDEV )
      
      ! Get Lightning NO Production Rate
      CALL GET_ENV ( MOLSNIC, 'MOLSNIC', 350.0, VARDEV )
 
      ! get number of different file groups (sectors)
      CALL GET_ENV ( NPTGRPS, 'N_EMIS_PT', NPTGRPS, VARDEV )
      
      ! PT3DDIAG
!     CALL GET_ENV ( PT3DDIAG, 'PT3DDIAG', PT3DDIAG, VARDEV )

      ! PT3DFRAC
!     CALL GET_ENV ( PT3DFRAC, 'PT3DFRAC', PT3DFRAC, VARDEV )

      ! Point Source Time Steps
!     CALL GET_ENV ( PT_NSTEPS, 'LAYP_NSTEPS', PT_NSTEPS, VARDEV )

      ! Point Source Date
!     CALL GET_ENV ( PT_DATE, 'LAYP_STDATE', PT_DATE, VARDEV )

      ! Point Source Time
!     CALL GET_ENV ( PT_TIME, 'LAYP_STTIME', PT_TIME, VARDEV )

      ! IPVERT
      CALL GET_ENV ( IPVERT, 'IPVERT', IPVERT, VARDEV )

      ! REP_LAYR
!     CALL GET_ENV ( REP_LAYR, 'REP_LAYER_MIN', REP_LAYR, VARDEV )
 
!     ALLOCATE( PLAY_BASE( NPTGRPS ) )
!     PLAY_BASE( : ) = ''
!     DO NV = 1,NPTGRPS
!        WRITE( PBASE,'( "PLAY_BASE", "_", I2.2 )' ) NV
!        CALL GET_ENV ( STRTEMP, PBASE, PLAY_BASE( NV ), VARDEV )
!        PLAY_BASE( NV ) = STRTEMP
!     END DO
       
      ! Determine user-defined default for emissions date override for representative days
      CALL GET_ENV ( EMIS_SYM_DATE, 'EMIS_SYM_DATE', EMIS_SYM_DATE, VARDEV )
 
      !-------------------------------------------------------------------------------------------------------
      !>> Process Analysis
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Process Analysis Parameters" )
         WRITE( OUTDEV, '(6x,A)' ),'  ---Env Variable---  |  ---Value---'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Flag for Using Process Analysis
      CALL GET_ENV ( PROCAN, 'CTM_PROCAN', PROCAN, VARDEV )
       
      ! Get the Beginning and Ending Columns for Process Analysis
      IF ( PROCAN ) THEN
         CALL GET_ENVLIST ( 'PA_BCOL_ECOL', NV, V_LIST2, VARDEV )
         IF ( NV .LE. 0 ) THEN   
            PA_BEGCOL = 1; PA_ENDCOL = 0
         ELSE IF ( NV .EQ. 2 ) THEN
            READ( V_LIST2( 1 ), '( I4 )' ) PA_BEGCOL
            READ( V_LIST2( 2 ), '( I4 )' ) PA_ENDCOL
         ELSE 
            XMSG = 'Environment variable error for PA_BCOL_ECOL'
            CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
         END IF
     
         ! Get the Beginning and Ending Rows for Process Analysis
         CALL GET_ENVLIST ( 'PA_BROW_EROW', NV, V_LIST2, VARDEV )
         IF ( NV .LE. 0 ) THEN   
            PA_BEGROW = 1; PA_ENDROW = 0
         ELSE IF ( NV .EQ. 2 ) THEN
            READ( V_LIST2( 1 ), '( I4 )' ) PA_BEGROW
            READ( V_LIST2( 2 ), '( I4 )' ) PA_ENDROW
         ELSE 
            XMSG = 'Environment variable error for PA_BROW_EROW'
            CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
         END IF
     
         ! Get the Beginning and Ending Layers for Process Analysis
         CALL GET_ENVLIST ( 'PA_BLEV_ELEV', NV, V_LIST2, VARDEV )
         IF ( NV .LE. 0 ) THEN  
            PA_BEGLEV = 1; PA_ENDLEV = 0
         ELSE IF ( NV .EQ. 2 ) THEN
            READ( V_LIST2( 1 ), '( I4 )' ) PA_BEGLEV
            READ( V_LIST2( 2 ), '( I4 )' ) PA_ENDLEV
         ELSE 
            XMSG = 'Environment variable error for PA_BLEV_ELEV'
            CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
         END IF
      END IF

      ! Get the Budget File Name
      CALL GET_ENV ( BUDGET_FNAME, 'CTM_BUDGET', BUDGET_FNAME, VARDEV )


      IF ( OCEAN_CHEM ) THEN
       IF ( (INDEX( MECHNAME, 'CB6R5M_AE7_AQ') .GT. 0 ) .OR. 
     &      (INDEX( MECHNAME, 'CB6R5_AE7_AQ' ) .GT. 0) ) then     
       USE_MARINE_GAS_EMISSION = .TRUE.
       ENDIF
      ENDIF

! for MPAS
#ifdef mpas
      call get_env (ncd_64bit_offset, 'ncd_64bit_offset', .false., vardev)
      call get_env( cell_num, 'cell_num', 1, vardev)
#else

#ifdef twoway
      WRF_V4P = .TRUE.
#else
      
      ! to obtain WRF version information
      CALL LOG_HEADING( LOGDEV, 'Determine WRF Input Version' )

      IF ( .NOT. OPEN3( MET_CRO_3D, FSREAD3, PNAME ) ) THEN
         XMSG = 'Could not open '// MET_CRO_3D // ' file'
         CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF

      IF ( .NOT. DESC3( MET_CRO_3D ) ) THEN
         XMSG = 'Could not get ' // MET_CRO_3D //' file description'
         CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF

      ! Get environ. variable met_tstep to control meteorology frequency
      CALL GET_ENV ( MET_TSTEP, 'MET_TSTEP', TSTEP3D, VARDEV)

      ! Ensure users cannot pick a met_tstep that is not smaller than the
      ! file time step and something that is not a multiple of that tstep
          
      IF (MOD(TIME2SEC(MET_TSTEP), TIME2SEC(TSTEP3D)) .NE. 0) then
          XMSG = 'MET_TSTEP environmental variable not equal to or a 
     & multiple greater than time step of met file ' // MET_CRO_3D
          CALL M3EXIT(PNAME, 0, 0, XMSG, XSTAT1)
      end if 

      FOUND = .FALSE.
      NV = 0
      Do WHILE ((.NOT. FOUND) .AND. (NV .LT. MXDESC3))
         NV = NV + 1
         LOC = INDEX (FDESC3D(NV), 'WRF ARW V')
         IF (LOC > 0) THEN
            FOUND = .TRUE.
            STR_LEN = LEN_TRIM(FDESC3D(NV))
            READ (FDESC3D(NV)(LOC+9:STR_LEN), *) WRF_VERSION
            IF (WRF_VERSION .GE. '4.1') THEN
               WRF_V4P = .TRUE.
            END IF
         END IF
      END DO

      XMSG = 'MET data determined based on WRF ARW version '
      IF( MYPE .EQ. 0 ) THEN
          WRITE(OUTDEV,'(/,5X,2(A,1X),/)')TRIM( XMSG ), TRIM( FDESC3D(NV)(LOC+9:STR_LEN) )
          WRITE(LOGDEV,'(/,5X,2(A,1X),/)')TRIM( XMSG ), TRIM( FDESC3D(NV)(LOC+9:STR_LEN) )
      ELSE
          WRITE(LOGDEV,'(/,5X,2(A,1X),/)')TRIM( XMSG ), TRIM( FDESC3D(NV)(LOC+9:STR_LEN) )
      END IF

      IF ( .NOT. CLOSE3( MET_CRO_3D ) ) THEN
        XMSG = 'Could not close ' // MET_CRO_3D
        CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF
#endif

#endif

      END SUBROUTINE INIT_ENV_VARS

!.........................................................................
      SUBROUTINE LOG_HEADING( FUNIT, CHEAD_IN )

!  Formats and writes a user-supplied heading to a specific log file.
!  This approach is intended to standardize the log files that are
!  created by CMAQ. The length of the input array is set at 80 because
!  we would like to try limiting lines to 80 characters and a heading
!  should probably just be one line.
!.........................................................................

#ifdef mpas
      use util_module
#endif

      IMPLICIT NONE

      INTEGER, INTENT( IN )           :: FUNIT
      CHARACTER( * ), INTENT( IN )    :: CHEAD_IN
      CHARACTER( len=: ), ALLOCATABLE :: CHEAD
      CHARACTER( 20 )                 :: FMT
      CHARACTER( 20 )                 :: FMT2
      INTEGER                         :: LDASH

      ! Capitalize the heading
      CHEAD = CHEAD_IN
      CALL UPCASE( CHEAD )

      ! Write the heading to the log file
      WRITE( FUNIT, * )
      WRITE( FUNIT, * )
      WRITE( FMT, '("(", I0, "x,A,A,A)")' ) LOG_MAJOR_TAB
      WRITE( FMT2,'("(", I0, "x,A,)")' ) LOG_MAJOR_TAB

      LDASH = 2*8 + LEN_TRIM( CHEAD )
      WRITE( FUNIT, FMT2 ), REPEAT( '=', LDASH )
      WRITE( FUNIT, FMT ),
     &       '|>---   ',TRIM( CHEAD ),'   ---<|'
      WRITE( FUNIT, FMT2 ), REPEAT( '=', LDASH )

      END SUBROUTINE LOG_HEADING
      
!.........................................................................
      SUBROUTINE LOG_SUBHEADING( FUNIT, CHEAD )

!  Formats and writes a user-supplied sub-heading to a specific log file.
!  This approach is intended to standardize the log files that are
!  created by CMAQ. The length of the input array is set at 80 because
!  we would like to try limiting lines to 80 characters and a sub-heading
!  should probably just be one line.
!.........................................................................

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: FUNIT
      CHARACTER( * ), INTENT( IN ) :: CHEAD
      CHARACTER( 20 )       :: FMT
      INTEGER                         :: LDASH

      ! Write the sub-heading to the log file
      WRITE( FMT, '("(/,", I0, "x,A,A,A)")' ) LOG_MAJOR_TAB
      WRITE( FUNIT, FMT ),'|> ',TRIM( CHEAD ),':'
      LDASH = 2*3 - 1 + LEN_TRIM( CHEAD )

      WRITE( FMT, '("(", I0, "x,A,A)")' ) LOG_MAJOR_TAB
      WRITE( FUNIT, FMT ) '+',REPEAT( '=', LDASH )

      END SUBROUTINE LOG_SUBHEADING
      
!.........................................................................
      SUBROUTINE LOG_MESSAGE( FUNIT, CMSG_IN )

!  Formats and writes a user-supplied message to a specific log file.
!  This approach is intended to standardize the log files that are
!  created by CMAQ.
!.........................................................................

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: FUNIT
      CHARACTER( * ), INTENT( IN ) :: CMSG_IN
      CHARACTER( len=: ), ALLOCATABLE :: CMSG
      CHARACTER( 20 )       :: FMT

      CHARACTER( LOG_LINE_LENGTH ) :: CTEMP
      INTEGER :: MSG_SIZE
      INTEGER :: NLINE1, NLINE2, NLINE, NTAB, LAST_SPACE

      CMSG = CMSG_IN

      ! Write the message to the log file, while trimming to 80
      ! characters (while accounting for tab-length)
      NLINE1 = LOG_LINE_LENGTH - LOG_MAJOR_TAB
      NLINE2 = LOG_LINE_LENGTH - LOG_MAJOR_TAB - LOG_MINOR_TAB
      NLINE  = NLINE1
      NTAB   = LOG_MAJOR_TAB
      
      ! Determine Length of Total Message
      MSG_SIZE = LEN_TRIM( CMSG )
      
      DO WHILE ( MSG_SIZE .GT. LOG_LINE_LENGTH )
         ! Isolate One Line of Text
         LAST_SPACE = INDEX( CMSG( 1:NLINE+1 ), " ", BACK=.TRUE. )
     
         CTEMP = CMSG( 1:LAST_SPACE-1 )

         WRITE( FMT, '("(", I0, "x,A)")' ) NTAB
         WRITE( FUNIT, FMT ), CTEMP

         CMSG = CMSG( LAST_SPACE+1:LEN( CMSG ) )
         MSG_SIZE = LEN_TRIM( CMSG )

         IF ( NTAB .EQ. LOG_MAJOR_TAB ) NTAB = NTAB + LOG_MINOR_TAB
         IF ( NLINE.EQ. NLINE1 ) NLINE = NLINE2
      END DO

      ! Write Last Line
      WRITE( FMT, '("(", I0, "x,A)")' ) NTAB
      WRITE( FUNIT, FMT ), TRIM( CMSG )


      END SUBROUTINE LOG_MESSAGE
!.........................................................................
      REAL( 8 ) FUNCTION SET_CPU_TIMING()

! Function set cpu time
      
       IMPLICIT NONE

#ifdef parallel
      INCLUDE 'mpif.h'
#endif
      
 ! local:      
      REAL( 8 )  :: CPU_TIME_FINISH
#ifndef parallel
      REAL       :: REAL_TIME
#endif
       
#ifdef parallel
      SET_CPU_TIMING = MPI_WTIME()
#else
      CALL CPU_TIME( REAL_TIME )
      SET_CPU_TIMING = REAL( REAL_TIME,8 )
#endif
          
      END FUNCTION SET_CPU_TIMING
!.........................................................................
      SUBROUTINE TIMING_DELTA( CPU_TIME_START, CPU_TIME_DELTA )
      
         IMPLICIT NONE

#ifdef parallel
      INCLUDE 'mpif.h'
#endif
        REAL( 8 ), INTENT( INOUT ) :: CPU_TIME_START
        REAL( 8 ), INTENT( INOUT ) :: CPU_TIME_DELTA
      
 ! local:      
      REAL( 8 )  :: CPU_TIME_FINISH
#ifndef parallel
      REAL       :: REAL_TIME
#endif

!  This subroutine calculates and returns elapsed time from CPU_TIME_START
!  as an update to CPU_TIME_DELTA so total time expense can be determine
!  for code block in a cyclng loop.
!  It also resets CPU_TIME_START to current CPU time.

#ifdef parallel
      CPU_TIME_FINISH = MPI_WTIME()
#else
      CALL CPU_TIME( REAL_TIME )
      CPU_TIME_FINISH = REAL( REAL_TIME,8 )
#endif
      CPU_TIME_DELTA = CPU_TIME_DELTA + (CPU_TIME_FINISH-CPU_TIME_START)

#ifdef parallel      
      CPU_TIME_START = MPI_WTIME()
#else
      CALL CPU_TIME( REAL_TIME )
      CPU_TIME_START = REAL( REAL_TIME,8 )
#endif
      
      END SUBROUTINE TIMING_DELTA

!.........................................................................
      SUBROUTINE TIMING_SPLIT( CPU_TIME_START, IMSG, CPROCIN )

!  This subroutine provides a split for the MPI timing functions and
!  then prints out a message for how much time has passed using a
!  character string input for customizing that message. 
!.........................................................................
 
      IMPLICIT NONE

#ifdef parallel
      INCLUDE 'mpif.h'
#endif
      REAL( 8 ), INTENT( INOUT ) :: CPU_TIME_START
      INTEGER,   INTENT( IN   )  :: IMSG   ! What kind of checkpoint this is
      CHARACTER( * ), INTENT(IN), OPTIONAL :: CPROCIN
      
! local:      
      REAL( 8 )        :: CPU_TIME_FINISH
                                 !  1 = 'PROCESS'
                                 !  2 = 'MASTER TIME STEP'
                                 !  3 = 'OUTPUT'
      CHARACTER( len=: ), ALLOCATABLE :: CPROC
      CHARACTER( 250 ) :: XMSG

#ifndef parallel
      REAL :: REAL_TIME
#endif


      IF ( PRESENT( CPROCIN ) ) THEN
         CPROC = CPROCIN
      ELSE
         CPROC = ' '
      END IF
 
      ! Record Time at this Checkpoint
#ifdef parallel
      CPU_TIME_FINISH = MPI_WTIME()
#else
      CALL CPU_TIME( REAL_TIME )
      CPU_TIME_FINISH = REAL( REAL_TIME,8 )
#endif


      ! Assemble the statement requested by the calling program
      SELECT CASE ( IMSG )
      CASE ( 1 )
          ! Write Out The Time to Complete Each Sub-Process
          WRITE( XMSG, 1002 ),TRIM( CPROC ), CPU_TIME_FINISH-CPU_TIME_START
1002      FORMAT ( 2x, A15, ' completed... ', F12.4, ' seconds' )

      CASE ( 2 ) 
          ! Write out the time to complete the entire master time step
          WRITE( XMSG, '(7x,A16)' ),'Master Time Step'
          CALL LOG_MESSAGE( LOGDEV, XMSG )
#ifndef twoway
          IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
#endif
          WRITE( XMSG, '(7x,A24,F12.4,A8)' ),'Processing completed... ',
     &                     (CPU_TIME_FINISH-CPU_TIME_START),' seconds'
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, * )

      CASE ( 3 ) 
          ! Write out the time to complete the output procedure
          WRITE( XMSG, '(1x,A32,F10.4,A)' ), '=--> Data Output completed...   ',
     &                     (CPU_TIME_FINISH-CPU_TIME_START),' seconds'
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, * )
#ifndef twoway
          IF ( MYPE .EQ. 0 ) WRITE( OUTDEV, * )
          
#endif
      CASE( 4 )
 
      END SELECT 

      ! Write out the timing statement
#ifndef twoway
      IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
#endif
#ifdef parallel      
      CPU_TIME_START = MPI_WTIME()
#else
      CALL CPU_TIME( REAL_TIME )
      CPU_TIME_START = REAL( REAL_TIME,8 )
#endif
      END SUBROUTINE TIMING_SPLIT    
 
      END MODULE RUNTIME_VARS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE VDIFF ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Asymmetric Convective Model v2 (ACM2) -- Pleim(2006)
C Function:
C   calculates and writes dry deposition.
C   calculates vertical diffusion

C Subroutines and Functions Called:
C   SEC2TIME, TIME2SEC, WRITE3, NEXTIME,
C   M3EXIT, EDDYX, TRI, MATRIX, PA_UPDATE_EMIS, PA_UPDATE_DDEP

C Revision History:
C   Analogous to VDIFFIM (Eddy diffusion PBL scheme)

C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module (GRID_CONF)
C    7 Jun 05 P.Bhave: added call to OPSSEMIS if MECHNAME='AE4';
C                      added TSTEP to RDEMIS_AE call vector
C    Aug 05 J. Pleim Update to v4.5
C
C    Jan 06 J. Pleim ACM2 implementation
C    Jul 06 J.Young: emis module
C    Nov 06 B.Hutzell, J.Young: depv module
C    Mar 08 G.Sarwar: added heterogeneous reaction for HONO. It affects HONO, NO2 and HNO3
C    Apr 08 J.Young: optional inline beis and plume rise emissions
C 21 Jun 10 J.Young: convert for Namelist redesign
C 16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C 10 May 11 J.Bash: updated for NH3 bidirectional exchange
C 11 May 11 D.Wong: - incorporated twoway model implementation
C 20 May 11 D.Schwede: modified to include mosaic
C 15 Aug 11 D.Schwede and G. Sarwar: Modified HONO calculation so that deposition
C           velocity for NO2 that is output in DEPV file does not include the loss due
C           to the heterogeneous reaction.
C           This additional loss is now accounted for in vdiff.F
C 14 Sep 11 J.Young: fix TSTEP bug in call to DEPV_INIT
C 11 Apr 13 J.Young: fix double adjustment of conc for DDBF in heterogeneous HONO
C           if-then-else clauses; eliminate some white space
C 13 May 13 J.Young: access met data from VDIFF_MET module
C                    change CRANKP to THBAR, CRANKQ to THETA
C 25 May 13 J.Young: re-do the acm/eddy algorithm for computational efficiency
C 30 Apr 14 J.Young: switch THBAR and THETA
C  2 May 14 J.Pleim, J.Young: replace the banded tridiagonal matrix solver for the
C           convective PBL, with the ACM1 matrix solver followed by the tridiagonal
C           matrix solver
C 30 May 14 J.Young: split vdiff calculation out of vdiff proc.
C 31 Jul 14 J.Young: incorporate gravitational settling for J-,K-mode aerosols
C 07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C 03 Jul 15 J.Young: put sedi stuff into a module
C 13 Aug 15 J.Bash: updated for MP model
C 15 Aug 15 D.Wong: - Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O 
C                     implementation
C                   - Added a block of code to allow non I/O processors
C                     to open CTM_DRY_DEP_1, CTM_VSED_DIAG, CTM_VDIFF_DIAG,
C                     CTM_DRY_DEP_MOS, and CTM_DRY_DEP_FST
C 03 Mar 16 G.Sarwar: updated for halogen emissions
C 16 Sep 16 J.Young: update for inline procan (IPR)
C 10 Feb 19 D.Wong: removed all MY_N clauses
C-----------------------------------------------------------------------

      USE CGRID_SPCS          ! CGRID mechanism species
      USE GRID_CONF
      USE DESID_VARS, ONLY : VDEMIS_DIFF, DESID_LAYS
      USE DESID_MODULE, ONLY : DESID_INIT, DESID_DRIVER
      USE ELMO_DATA, ONLY : L_ELMO, ELMO_DDEP
      USE DEPV_DEFN
      USE ASX_DATA_MOD
      USE VDIFF_MAP
      USE UTILIO_DEFN
      USE BIDI_MOD
      USE HGSIM
      Use MOSAIC_MOD, Only: Tile_Data
      USE SEDIMENTATION
      USE VDIFF_DIAG
      USE PA_UPDATE
      USE PA_DEFN, ONLY : LIPR, BUDGET_DIAG

#ifdef isam
      USE SA_DEFN, Only: ITAG, N_SPCTAG, VNAM_SPCTAG, SA_DDEP, SA_DDEP0,
     &                   S_SPCTAG, T_SPCTAG, NSPC_SA, ISAM_SPEC
      USE ELMO_DATA, Only : ELMO_ISAM_DDEP
#endif

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID  ! file name parameters

      CHARACTER( 120 ) :: XMSG = ' '

C Arguments:

      REAL, POINTER :: CGRID( :,:,:,: )              !  concentrations
      INTEGER      JDATE        ! current model date, coded YYYYDDD
      INTEGER      JTIME        ! current model time, coded HHMMSS
      INTEGER      TSTEP( 3 )   ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency

C Parameters:

C External Functions: None

C Local Variables: 
      CHARACTER( 16 ), SAVE :: PNAME = 'VDIFFPROC'

      CHARACTER( 80 ) :: VARDESC                ! env variable description

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL, SAVE :: WRITE_FIRSTIME = .TRUE.
      INTEGER, SAVE :: WSTEP  = 0               ! local write counter
      INTEGER  STATUS                           ! ENV... status

      REAL             FCMSF                         ! loop local RMSFX4( C,R )

      REAL, ALLOCATABLE, SAVE :: CNGRD      ( :,:,:,: )    ! cgrid aero in mixing ratio
      REAL, ALLOCATABLE, SAVE :: DDEP       ( :,:,: )   ! ddep accumulator
      REAL, ALLOCATABLE, SAVE :: DDEP0    ( :,:,: )   ! ddep initial before call to vdiffacmx
      REAL, ALLOCATABLE, SAVE :: TOT_BD_EMIS( :,:,: )   ! bidi emissions accumlator 
      REAL, ALLOCATABLE, SAVE :: DDEPJ      ( :,:,:,: ) ! ddep for mosaic

      REAL     :: WRDD( NCOLS,NROWS )                 ! ddep write buffer
      REAL     :: WRDDJ( NCOLS,NROWS,Tile_Data%N_LUFRAC+1 )     ! mosaic ddep write buffer

      REAL, ALLOCATABLE, SAVE :: DDEP_PA  ( :,:,: )   ! ddep for process analysis
      REAL, ALLOCATABLE, SAVE :: EMIS_PA( :,:,:,: )   ! emis for process analysis

      INTEGER, SAVE :: N_SPC_CGRID              ! no. of CGRID species
      INTEGER, SAVE :: NH3_HIT

      REAL     :: EDDYV ( NCOLS,NROWS,NLAYS )   ! from EDYINTB
      REAL     :: SEDDY ( NLAYS,NCOLS,NROWS )   ! flipped EDDYV
      REAL        DTSEC                         ! model time step in seconds

      REAL, ALLOCATABLE, SAVE :: VSED_AE( :,:,:,: )

C Local Variables

      INTEGER     ASTAT
      INTEGER     C, R, L, S, V, I, J, OFF      ! loop induction variables
      INTEGER     MDATE, MTIME, MSTEP           ! internal simulation date&time

      INTERFACE
         SUBROUTINE CONV_CGRID ( CGRID, JDATE, JTIME, CNGRD )
            REAL, POINTER :: CGRID( :,:,:,: )
            INTEGER,        INTENT( IN )  :: JDATE, JTIME
            REAL,           INTENT( INOUT ) :: CNGRD( :,:,:,: )
         END SUBROUTINE CONV_CGRID
         SUBROUTINE REV_CGRID ( CNGRD, JDATE, JTIME, CGRID )
            REAL,           INTENT( INOUT ) :: CNGRD( :,:,:,: )
            INTEGER,        INTENT( IN )  :: JDATE, JTIME
            REAL, POINTER :: CGRID( :,:,:,: )
         END SUBROUTINE REV_CGRID
         SUBROUTINE EDDYX ( EDDYV )
            REAL,           INTENT( OUT ) :: EDDYV( :,:,: )
         END SUBROUTINE EDDYX
         SUBROUTINE VDIFFACMX( dtsec, seddy, ddep, TOT_BD_EMIS, ddepj, cngrd )
            REAL, INTENT( IN )    :: dtsec
            REAL, INTENT( INOUT ) :: seddy( :,:,: )
            REAL, INTENT( INOUT ) :: ddep ( :,:,: )
            REAL, INTENT( INOUT ) :: TOT_BD_EMIS ( :,:,: )
            REAL, INTENT( INOUT ), OPTIONAL :: ddepj    ( :,:,:,: )
            REAL, INTENT( INOUT ) :: cngrd( :,:,:,: )
         END SUBROUTINE VDIFFACMX
#ifdef isam
         SUBROUTINE SA_OPWDDEP ( SADEPFILE, JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            CHARACTER( 16 ) SADEPFILE ! Dry or wet dep file for tags
            INTEGER      JDATE      ! current model date, coded YYYYDDD
            INTEGER      JTIME      ! current model time, coded HHMMSS
            INTEGER      TSTEP      ! output time step
         END SUBROUTINE SA_OPWDDEP
#endif
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

         CALL LOG_HEADING( LOGDEV, "Initialize Surface Exchange Module" )

         IF ( .NOT. DEPV_INIT ( JDATE, JTIME, TSTEP, CGRID ) ) THEN
            XMSG = 'Failure initializing deposition velocities module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C create global maps
         IF ( .NOT. VDIFF_MAP_INIT( ) ) THEN
            XMSG = 'Failure initializing index mapping module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Initialize the met data
         CALL INIT_MET( JDATE, JTIME )

         IF ( HGBIDI ) THEN ! Initialize HGSIM module
            CALL INIT_HGSIM(JDATE, JTIME)
         END IF

C Set output file characteristics based on COORD.EXT and open the dry dep file
         IF ( IO_PE_INCLUSIVE ) THEN
            CALL OPDDEP ( JDATE, JTIME, TSTEP( 1 ), N_SPC_DDEP )
#ifdef isam
            CALL SA_OPWDDEP ( SA_DD_1, JDATE, JTIME,TSTEP( 1 ) )
#endif
            IF ( ABFLUX .OR. HGBIDI ) CALL OPASX_MEDIA( JDATE, JTIME, TSTEP( 1 ) )
         END IF

C Open vdiff diagnostics file (ioapi header from cgrd)
         IF ( VDIFFDIAG ) THEN
            IF ( .NOT. VDIFF_DIAG_INIT ( JDATE, JTIME, TSTEP( 1 ), GRAV_SETL ) ) THEN
               XMSG = 'Failure initializing vdiff diagnostics module'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

C Allocate and initialize dry deposition array

         ALLOCATE ( DDEP( N_SPC_DEPV,NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DDEP'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         DDEP = 0.0   ! array assignment

         ALLOCATE ( DDEP0( N_SPC_DEPV,NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DDEP0'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         DDEP0 = 0.0   ! array assignment
  
         ALLOCATE ( TOT_BD_EMIS( N_BD_EMIS,NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating TOT_BD_EMIS'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         TOT_BD_EMIS = 0.0   ! array assignment

         CALL LOG_HEADING( LOGDEV, "Initialize DESID Emission Module" )

         IF ( .NOT. DESID_INIT ( JDATE, JTIME, TSTEP ) ) THEN
            XMSG = 'Failure initializing emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#ifdef isam
         ALLOCATE ( SA_DDEP( NCOLS,NROWS,N_SPCTAG ),
     &              SA_DDEP0(NCOLS,NROWS,N_SPCTAG ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SA_DDEP'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         SA_DDEP = 0.0
         SA_DDEP0= 0.0
#endif

C Set up for process analysis
         CALL LOG_HEADING( LOGDEV, "Initialize Surface Exchange for Process Analysis" )

         IF ( BUDGET_DIAG .OR. LIPR .OR. L_ELMO ) THEN
            ALLOCATE ( EMIS_PA( NCOLS,NROWS,NLAYS,N_CGRID_SPC ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'EMIS_PA memory allocation failed'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF
         
         ALLOCATE ( DDEP_PA( NCOLS,NROWS,N_CGRID_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'DDEP_PA memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Set up for grav. settling
         IF ( GRAV_SETL ) THEN
            CALL LOG_HEADING( LOGDEV, "Set Up Gravitational Settling" )

            ALLOCATE ( VSED_AE( N_AE_SPC,NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating VSED_AE'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

         N_SPC_CGRID = SIZE ( CGRID,4 )

         ALLOCATE ( CNGRD( N_SPC_CGRID,NLAYS,NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CNGRD'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         CNGRD = 0.0   ! array assignment
       
!----------------------------------------------------------------------------------------
!  Move to ASX driver to get stage data set up mapping in init_stage
!----------------------------------------------------------------------------------------

         IF ( MOSAIC ) THEN 
            ALLOCATE ( DDEPJ( Tile_Data%N_LUFRAC,N_SPC_DEPV,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DDEPJ'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
            DDEPJ = 0.0   ! array assignment
            IF ( IO_PE_INCLUSIVE )
     &         CALL OPDDEP_MOS ( JDATE, JTIME, TSTEP( 1 ), N_SPC_DDEP )
         END IF   ! if Mosaic
!--------------------------------------------------------------------------------------------------
         DO V = 1, N_SPC_DEPV
            IF ( DV2DF_SPC( V ) .EQ. 'NH3' ) THEN
               NH3_HIT = V
            END IF
         END DO

         RETURN ! Added for MIO implementation
      END IF   !  if Firstime

      MDATE = JDATE
      MTIME = JTIME
      MSTEP = TIME2SEC( TSTEP( 2 ) )
      DTSEC = FLOAT( MSTEP )
      CALL NEXTIME ( MDATE, MTIME, SEC2TIME( MSTEP / 2 ) )

C Convert non-molar mixing ratio species and re-order CGRID
      CALL CONV_CGRID ( CGRID, MDATE, MTIME, CNGRD )

C read & interpolate met data
      CALL GET_MET ( MDATE, MTIME, MSTEP )

C read & interpolate deposition velocities
      CALL GET_DEPV ( MDATE, MTIME, TSTEP, CGRID )      

      IF ( GRAV_SETL ) THEN
C Get gravitational settling velocity for the vsed aero species:
C AERO_SEDV assumes that every aero species is dry deposited and is diffused (trns)
C Calculate the changes in the layer J-,K-mode aerosol concentrations
         CALL SEDI( MDATE, MTIME, DTSEC, VSED_AE, CGRID, CNGRD )
      END IF

C read & interpolate emissions data => VDEMIS_DIFF from EMIS_DEFN module
      CALL DESID_DRIVER ( MDATE, MTIME, TSTEP, CGRID )

      IF ( BUDGET_DIAG .OR. LIPR ) THEN
         EMIS_PA = 0.0
         DO S = 1, N_SPC_DIFF
            DO L = 1, DESID_LAYS
               EMIS_PA( :,:,L,DIFF_MAP(S) ) = VDEMIS_DIFF( S,L,:,: )
            END DO
         END DO
         CALL PA_UPDATE_EMIS ( EMIS_PA, JDATE, JTIME, TSTEP )
      END IF
      
      CALL EDDYX ( EDDYV )

C EDDYV returned = Kz, where Kz is in m**2/sec

      DO L = 1, NLAYS
         SEDDY( L,:,: ) = EDDYV( :,:,L )              
      END DO

      IF ( WSTEP .EQ. 0 ) THEN
         DDEP = 0.0                      ! array assignment
         TOT_BD_EMIS = 0.0                      ! array assignment
         IF ( MOSAIC ) THEN
            DDEPJ = 0.0                  ! array assignment
         END IF
      END IF

C Store Deposition Change in Budget and Process Analysis Arrays
      IF ( BUDGET_DIAG .OR. LIPR .OR. L_ELMO ) THEN
          DDEP0 = DDEP
#ifdef isam
          SA_DDEP0 = SA_DDEP
#endif
      END IF

C Calculate the change in concentration and dry dep from vertical diffusion and vsed
C Note: cngrd is the argument keyword (from the INTERFACE); CNGRD is the actual argument
      IF ( .NOT. MOSAIC ) THEN
         CALL VDIFFACMX( DTSEC, SEDDY, DDEP, TOT_BD_EMIS,
     &                   cngrd = CNGRD )
      ELSE
         CALL VDIFFACMX( DTSEC, SEDDY, DDEP, TOT_BD_EMIS,
     &                   ddepj = DDEPJ, cngrd = CNGRD )
      END IF 

      IF ( VDIFFDIAG ) THEN
         NTICS = NTICS + 1
         NLPCR_SUM = NLPCR_SUM + NLPCR_MEAN    ! array assignment
         DO R = 1, NROWS
            DO C = 1, NCOLS
               NLPCR_MAX( C,R ) = MAX( NLPCR_MEAN( C,R ), NLPCR_MAX( C,R ) )
               NLPCR_MIN( C,R ) = MIN( NLPCR_MEAN( C,R ), NLPCR_MIN( C,R ) )
            END DO
         END DO
         IF ( GRAV_SETL ) THEN
            DTCCR_SUM = DTCCR_SUM + DTCCR_MEAN    ! array assignment
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  DTCCR_MAX( C,R ) = MAX( DTCCR_MEAN( C,R ), DTCCR_MAX( C,R ) )
                  DTCCR_MIN( C,R ) = MIN( DTCCR_MEAN( C,R ), DTCCR_MIN( C,R ) )
               END DO
            END DO
         END IF
      END IF
 
C Store Deposition Change in Budget and Process Analysis Arrays
      IF ( BUDGET_DIAG .OR. LIPR .OR. L_ELMO ) THEN
         DDEP_PA = 0.0
         DO V = 1, N_SPC_DDEP
            S = DD2DV( V )
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  DDEP_PA( C,R,MAP_DDEPtoCGRID(V)) = DDEP( S,C,R ) - DDEP0( S,C,R )
               END DO
            END DO
            IF ( L_ELMO ) 
     &         ELMO_DDEP(:,:,MAP_DDEPtoCGRID(V)) = DDEP_PA(:,:,MAP_DDEPtoCGRID(V))
         END DO
         CALL PA_UPDATE_DDEP ( DDEP_PA, JDATE, JTIME, TSTEP )

#ifdef isam
         DO ITAG = 1, N_SPCTAG
            ELMO_ISAM_DDEP(:,:,S_SPCTAG(ITAG), T_SPCTAG(ITAG) ) =
     &            SA_DDEP( :,:,ITAG ) - SA_DDEP0( :,:,ITAG )
         END DO
#endif
      END IF
 
C Revert non-molar mixing ratio species and re-order CGRID
      CALL REV_CGRID ( CNGRD, MDATE, MTIME, CGRID )

C If last call this hour:  write accumulated depositions:

      WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )
      IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
         MDATE = JDATE
         MTIME = JTIME
         CALL NEXTIME( MDATE, MTIME, TSTEP( 2 ) )
         WSTEP = 0

#ifdef parallel_io
         IF ( WRITE_FIRSTIME ) THEN
            WRITE_FIRSTIME = .FALSE.

            IF ( .NOT. IO_PE_INCLUSIVE ) THEN
               IF ( .NOT. OPEN3( CTM_DRY_DEP_1, FSREAD3, PNAME ) ) THEN
                  XMSG = 'Could not open ' // TRIM(CTM_DRY_DEP_1)
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
               IF ( MOSAIC ) THEN
                  IF ( .NOT. OPEN3( CTM_DRY_DEP_MOS, FSREAD3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM(CTM_DRY_DEP_MOS)
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               END IF
            END IF   ! .NOT. IO_PE_INCLUSIVE
         END IF
#endif

         DO V = 1, N_SPC_DDEP
            S = DD2DV( V )
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  WRDD( C,R ) = DDEP( S,C,R )
               END DO
            END DO

            IF ( .NOT. WRITE3( CTM_DRY_DEP_1, DDEP_SPC( V ),
     &                 MDATE, MTIME, WRDD ) ) THEN
               XMSG = 'Could not write ' // CTM_DRY_DEP_1 // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
         END DO 
! STAGE Diagnostic output
         IF ( ABFLUX ) THEN
            IF ( .NOT. WRITE3( CTM_DRY_DEP_1, BD_EMIS_SPC( NH3_E ),
     &           MDATE, MTIME, TOT_BD_EMIS( NH3_E,:,: ) ) ) THEN
               XMSG = 'Could not write ' // CTM_DRY_DEP_1 // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF     
            WRDD( :,: ) = DDEP(NH3_HIT,:,:) - TOT_BD_EMIS( NH3_E,:,: )
            IF ( .NOT. WRITE3( CTM_DRY_DEP_1, 'NH3_Flux',
     &           MDATE, MTIME, WRDD ) ) THEN
               XMSG = 'Could not write ' // CTM_DRY_DEP_1 // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF          
         ENDIF
         IF ( HGBIDI ) THEN
            IF ( .NOT. WRITE3( CTM_DRY_DEP_1, BD_EMIS_SPC( HG_E ),
     &           MDATE, MTIME, TOT_BD_EMIS( HG_E,:,: ) ) ) THEN
               XMSG = 'Could not write ' // CTM_DRY_DEP_1 // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF     
         ENDIF
         IF ( SFC_HONO ) THEN
            IF ( .NOT. WRITE3( CTM_DRY_DEP_1, BD_EMIS_SPC( HONO_E ),
     &           MDATE, MTIME, TOT_BD_EMIS( HONO_E,:,: ) ) ) THEN
               XMSG = 'Could not write ' // CTM_DRY_DEP_1 // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF     
         ENDIF
! End of STAGE Diagnostic output
         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &         'Timestep written to', CTM_DRY_DEP_1,
     &         'for date and time', MDATE, MTIME
         
C Write vdiff diagnostics
         IF ( VDIFFDIAG ) THEN
            IF ( GRAV_SETL ) THEN   ! Write vsed diagnostics

               DO V = 1, N_VSED
                  S = VSED_MAP( V )
                  DO L = 1, NLAYS
                     DO R = 1, NROWS
                        DO C = 1, NCOLS
                           VSED_BUF( C,R,L,V ) = VSED_AE( S,L,C,R )
                        END DO
                     END DO
                  END DO
                  IF ( .NOT. WRITE3( CTM_VSED_DIAG, VSED_NAME( V ),
     &                               MDATE, MTIME, VSED_BUF( :,:,:,V ) ) ) THEN
                     XMSG = 'Could not write ' // TRIM( VSED_NAME( V ) )
     &                    // ' to ' // CTM_VSED_DIAG
                     CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
                  END IF
               END DO

               WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &               'Timestep written to', CTM_VSED_DIAG,
     &               'for date and time', MDATE, MTIME

            END IF   ! GRAV_SETL

C Write other diagnostics
            NLPCR_MEAN = NLPCR_SUM / FLOAT( NTICS )
            IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'NLP_MEAN',
     &                         MDATE, MTIME, NLPCR_MEAN ) ) THEN
               XMSG = 'Could not write ' //  'NLP_MEAN to ' // CTM_VDIFF_DIAG
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
            IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'NLP_MAX',
     &                         MDATE, MTIME, NLPCR_MAX ) ) THEN
               XMSG = 'Could not write ' //  'NLP_MAX to ' // CTM_VDIFF_DIAG
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
            IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'NLP_MIN',
     &                         MDATE, MTIME, NLPCR_MIN ) ) THEN
               XMSG = 'Could not write ' //  'NLP_MIN to ' // CTM_VDIFF_DIAG
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
            NLPCR_MAX = 0.0      ! array assignment
            NLPCR_MIN = 9.9E30   ! array assignment
            NLPCR_SUM = 0.0      ! array assignment

            IF ( GRAV_SETL ) THEN   ! Write vsed diagnostics
               DTCCR_MEAN = DTCCR_SUM / FLOAT( NTICS )
               IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'SEDI_DTC_MEAN',
     &                            MDATE, MTIME, DTCCR_MEAN ) ) THEN
                  XMSG = 'Could not write ' //  'SEDI_DTC_MEAN to ' // CTM_VDIFF_DIAG
                  CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               END IF
               IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'SEDI_DTC_MAX',
     &                            MDATE, MTIME, DTCCR_MAX ) ) THEN
                  XMSG = 'Could not write ' //  'SEDI_DTC_MAX to ' // CTM_VDIFF_DIAG
                  CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               END IF
               IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'SEDI_DTC_MIN',
     &                            MDATE, MTIME, DTCCR_MIN ) ) THEN
                  XMSG = 'Could not write ' //  'SEDI_DTC_MIN to ' // CTM_VDIFF_DIAG
                  CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               END IF
               DTCCR_MAX = 0.0      ! array assignment
               DTCCR_MIN = 9.9E30   ! array assignment
               DTCCR_SUM = 0.0      ! array assignment
            END IF

            CNVCT = 0.0   ! array assignment
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  IF ( Met_Data%CONVCT( C,R ) ) CNVCT( C,R ) = 1.0
               END DO
            END DO
            IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'CONVCT',
     &                         MDATE, MTIME, CNVCT ) ) THEN
               XMSG = 'Could not write ' //  'convct to ' // CTM_VDIFF_DIAG
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF

            IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'LPBL',
     &                         MDATE, MTIME, REAL( Met_Data%LPBL ) ) ) THEN
               XMSG = 'Could not write ' //  'lpbl to ' // CTM_VDIFF_DIAG
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF

            WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6, I6 )' )
     &            'Timestep written to', CTM_VDIFF_DIAG,
     &            'for date and time (and ntics)', MDATE, MTIME, NTICS
            NTICS = 0

         END IF
         
         IF ( MOSAIC ) THEN

            DO V = 1, N_SPC_DDEP
               S = DD2DV( V )
               WRDD = 0.0 ! reuse array since it has already been written for hour
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     DO J = 1, Tile_Data%N_LUFRAC
                        WRDD( C,R ) = WRDD( C,R ) + DDEPJ( J,S,C,R ) * Tile_Data%LUFRAC( C,R,J )
                        WRDDJ( C,R,J ) = DDEPJ( J,S,C,R )
                     END DO
                     WRDDJ( C,R,Tile_Data%N_LUFRAC+1 ) = WRDD( C,R )  ! last array element is total across all land use categories
                  END DO
               END DO

               IF ( .NOT. WRITE3( CTM_DRY_DEP_MOS, DDEP_SPC( V ),
     &                     MDATE, MTIME, WRDDJ ) ) THEN
                  XMSG = 'Could not write ' // CTM_DRY_DEP_MOS // ' file'
                  CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               END IF

            END DO

            WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &             'Timestep written to', CTM_DRY_DEP_MOS,
     &             'for date and time', MDATE, MTIME

         END IF   ! MOSAIC

         IF ( ABFLUX .OR. HGBIDI ) THEN    
            CALL WRASX_MEDIA( MDATE, MTIME )
         END IF 
 
C re-set dry deposition array to zero

         DDEP = 0.0
         TOT_BD_EMIS = 0.0
         IF ( MOSAIC ) THEN
            DDEPJ = 0.0   ! array assignment
         END IF

#ifdef isam
         WRDD = 0.0
         DO ITAG = 1, N_SPCTAG
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  WRDD( C,R ) = SA_DDEP( C,R,ITAG )
               END DO
            END DO

            IF ( .NOT. WRITE3( SA_DD_1, VNAM_SPCTAG( ITAG ),
     &                         MDATE, MTIME, WRDD ) ) THEN
               XMSG = 'Could not write ' // SA_DD_1 // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
         END DO

         SA_DDEP = 0.0
#endif

      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


      SUBROUTINE HRINIT
C***********************************************************************
C
C  FUNCTION: To initialize species tolerances, arrays, and indices
C
C  PRECONDITIONS: For the CB6R5PFAS_AE7_AQ mechanism
C
C  RETURN VALUES: None
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, Jun 26, 2025
C   21 Jun 10 J.Young:   convert for Namelist redesign
C   18 Jul 14 B.Hutzell: revised to use the RXNS_DATA and RXNS_FUNCTION
C                        modules instead of include files
C***********************************************************************

      USE UTILIO_DEFN
      USE HRDATA
      USE RXNS_DATA
      USE RXNS_FUNCTION
      USE CONST, ONLY : MWAIR

      IMPLICIT NONE

C.....SAVED VARIABLES:
      CHARACTER( 16 ), SAVE  ::  PNAME = 'HRINIT'   ! Program name


C.....LOCAL VARIABLES:
      CHARACTER( 132 ) ::  MSG       ! Log message

      INTEGER N               ! Loop index
      INTEGER IOS             ! Allocate error status

C***********************************************************************

      N_SPEC = NUMB_MECH_SPC
      N_RXNS = NRXNS
      N_SPCL_RKS =   0
      ALLOCATE( RKI( NRXNS ),
     &          RKI_SAV( MAX_CELLS_EBI, NRXNS ),
     &          FORWARD_CONV( NUMB_MECH_SPC),
     &          REVERSE_CONV( NUMB_MECH_SPC),
     &          RXRAT( NRXNS ),
     &          RTOL( NUMB_MECH_SPC),
     &          YC(   NUMB_MECH_SPC),
     &          YC0(  NUMB_MECH_SPC),
     &          YCP(  NUMB_MECH_SPC),
     &          PROD( NUMB_MECH_SPC),
     &          LOSS( NUMB_MECH_SPC),
     &          PNEG( N_SPEC),
     &          STAT = IOS )

       IF ( IOS .NE. 0 ) THEN
          MSG = 'Error allocating RKI, RXRAT, RTOL, YC, YC0, YCP, FORWARD_CONV, '
     &       // 'REVERSE_CONV, PROD, LOSS, or PNEG'
          CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
       END IF

       ALLOCATE( ATMPRES( MAX_CELLS_EBI ),
     &           H2O    ( MAX_CELLS_EBI ),
     &           TEMP   ( MAX_CELLS_EBI ),
     &           DENSITY( MAX_CELLS_EBI ),
     &           HET    ( MAX_CELLS_EBI, NHETERO ),
     &           RJIN   ( MAX_CELLS_EBI, NPHOTAB ),
     &           SEAWATER  ( MAX_CELLS_EBI ) ,
     &           STAT = IOS )

       IF ( IOS .NE. 0 ) THEN
          MSG = 'Error allocating ATMPRES, H2O, TEMP, HET, RJIN, SEAWATER '
          CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
       END IF

       IF( NSPECIAL .GT. 0 )THEN
          ALLOCATE( SYC( MAX_CELLS_EBI, NUMB_MECH_SPC ), STAT = IOS )
          IF ( IOS .NE. 0 ) THEN
               MSG = 'Error allocating SYC'
               CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
          END IF
          ALLOCATE( IOLD2NEW( NUMB_MECH_SPC, 1 ), STAT = IOS )
          IF ( IOS .NE. 0 ) THEN
               MSG = 'Error allocating IOLD2NEW'
               CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
          END IF
          DO N = 1, NUMB_MECH_SPC
             IOLD2NEW( N, 1 ) = N
          END DO
       END IF

       IF( .NOT. MAP_CHEMISTRY_SPECIES() )THEN
          MSG = 'Detected above error(s) when mapping Chemistry species from CGRID species'
          CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT2 )
       END IF

       DO N = 1, NUMB_MECH_SPC
          FORWARD_CONV( N ) = 1.0E-3 * MWAIR / SPECIES_MOLWT( N )
          REVERSE_CONV( N ) = 1.0E+3 / MWAIR * SPECIES_MOLWT( N )
       END DO

! initialize all reaction rates to zero so unused array elements are defined

       RXRAT = 0.0D0

! initialize all production and loss rates to zero so unused array elements are defined

       PROD  = 0.0D0
       LOSS  = 0.0D0

       NING1 = 4
       NING2 = 4

       ALLOCATE( YCCELL( MODEL_SPECIES), STAT = IOS )  ! array for degradation routines
       IF ( IOS .NE. 0 ) THEN
          MSG = 'Error allocating YCCELL '
          CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
       END IF


c..Allocate and define ebi species

      N_EBISP  = 144
      ALLOCATE( EBISP( N_EBISP ), STAT = IOS ) 
      IF ( IOS .NE. 0 ) THEN
         MSG = 'Error allocating EBISP' 
         CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
      END IF

      EBISP(   1 ) = H2O2
      EBISP(   2 ) = HNO3
      EBISP(   3 ) = SO2
      EBISP(   4 ) = SULF
      EBISP(   5 ) = SULRXN
      EBISP(   6 ) = MEO2
      EBISP(   7 ) = RO2
      EBISP(   8 ) = PACD
      EBISP(   9 ) = AACD
      EBISP(  10 ) = CXO3
      EBISP(  11 ) = ALD2
      EBISP(  12 ) = XO2H
      EBISP(  13 ) = PANX
      EBISP(  14 ) = FORM
      EBISP(  15 ) = MEPX
      EBISP(  16 ) = MEOH
      EBISP(  17 ) = ROOH
      EBISP(  18 ) = XO2
      EBISP(  19 ) = XO2N
      EBISP(  20 ) = NTR1
      EBISP(  21 ) = NTR2
      EBISP(  22 ) = FACD
      EBISP(  23 ) = CO
      EBISP(  24 ) = HCO3
      EBISP(  25 ) = ALDX
      EBISP(  26 ) = GLYD
      EBISP(  27 ) = GLY
      EBISP(  28 ) = MGLY
      EBISP(  29 ) = ETHA
      EBISP(  30 ) = ETOH
      EBISP(  31 ) = KET
      EBISP(  32 ) = PAR
      EBISP(  33 ) = ACET
      EBISP(  34 ) = PRPA
      EBISP(  35 ) = XPRP
      EBISP(  36 ) = XPAR
      EBISP(  37 ) = ROR
      EBISP(  38 ) = ETHY
      EBISP(  39 ) = ETH
      EBISP(  40 ) = OLE
      EBISP(  41 ) = IOLE
      EBISP(  42 ) = ISOP
      EBISP(  43 ) = ISO2
      EBISP(  44 ) = ISOPRXN
      EBISP(  45 ) = ISPD
      EBISP(  46 ) = INTR
      EBISP(  47 ) = ISPX
      EBISP(  48 ) = HPLD
      EBISP(  49 ) = OPO3
      EBISP(  50 ) = EPOX
      EBISP(  51 ) = EPX2
      EBISP(  52 ) = TERP
      EBISP(  53 ) = TRPRXN
      EBISP(  54 ) = TERPNRO2
      EBISP(  55 ) = APIN
      EBISP(  56 ) = BENZENE
      EBISP(  57 ) = CRES
      EBISP(  58 ) = BZO2
      EBISP(  59 ) = OPEN
      EBISP(  60 ) = BENZRO2
      EBISP(  61 ) = TOL
      EBISP(  62 ) = TO2
      EBISP(  63 ) = TOLRO2
      EBISP(  64 ) = XOPN
      EBISP(  65 ) = XYLMN
      EBISP(  66 ) = XLO2
      EBISP(  67 ) = XYLRO2
      EBISP(  68 ) = NAPH
      EBISP(  69 ) = PAHRO2
      EBISP(  70 ) = CRO
      EBISP(  71 ) = CAT1
      EBISP(  72 ) = CRON
      EBISP(  73 ) = OPAN
      EBISP(  74 ) = ECH4
      EBISP(  75 ) = CL2
      EBISP(  76 ) = CL
      EBISP(  77 ) = HOCL
      EBISP(  78 ) = CLO
      EBISP(  79 ) = FMCL
      EBISP(  80 ) = HCL
      EBISP(  81 ) = CLNO2
      EBISP(  82 ) = CLNO3
      EBISP(  83 ) = SVAVB2
      EBISP(  84 ) = SVAVB3
      EBISP(  85 ) = SVAVB4
      EBISP(  86 ) = SVAVB1
      EBISP(  87 ) = SESQ
      EBISP(  88 ) = SESQRXN
      EBISP(  89 ) = SOAALK
      EBISP(  90 ) = H2NO3PIJ
      EBISP(  91 ) = H2NO3PK
      EBISP(  92 ) = ACLI
      EBISP(  93 ) = ACLJ
      EBISP(  94 ) = ACLK
      EBISP(  95 ) = IEPOXP
      EBISP(  96 ) = ASO4J
      EBISP(  97 ) = AISO3J
      EBISP(  98 ) = AGLYJ
      EBISP(  99 ) = MTNO3
      EBISP( 100 ) = AMTNO3J
      EBISP( 101 ) = AMTHYDJ
      EBISP( 102 ) = AAVB2J
      EBISP( 103 ) = AOLGAJ
      EBISP( 104 ) = AAVB3J
      EBISP( 105 ) = AAVB4J
      EBISP( 106 ) = AISO1J
      EBISP( 107 ) = AOLGBJ
      EBISP( 108 ) = AISO2J
      EBISP( 109 ) = ASQTJ
      EBISP( 110 ) = APOCI
      EBISP( 111 ) = APNCOMI
      EBISP( 112 ) = APOCJ
      EBISP( 113 ) = APNCOMJ
      EBISP( 114 ) = PCVOC
      EBISP( 115 ) = PCSOARXN
      EBISP( 116 ) = VLVPO1
      EBISP( 117 ) = VSVPO1
      EBISP( 118 ) = VSVPO2
      EBISP( 119 ) = VSVPO3
      EBISP( 120 ) = VIVPO1
      EBISP( 121 ) = VLVOO1
      EBISP( 122 ) = VLVOO2
      EBISP( 123 ) = VSVOO2
      EBISP( 124 ) = VSVOO3
      EBISP( 125 ) = VSVOO1
      EBISP( 126 ) = FORM_PRIMARY
      EBISP( 127 ) = ALD2_PRIMARY
      EBISP( 128 ) = BUTADIENE13
      EBISP( 129 ) = ACROLEIN
      EBISP( 130 ) = ACRO_PRIMARY
      EBISP( 131 ) = TOLU
      EBISP( 132 ) = HG
      EBISP( 133 ) = HGIIAER
      EBISP( 134 ) = HGIIGAS
      EBISP( 135 ) = DMS
      EBISP( 136 ) = MSA
      EBISP( 137 ) = HFPODAF
      EBISP( 138 ) = AHFJ
      EBISP( 139 ) = HFPODAghyd
      EBISP( 140 ) = AHFPODAphydJ
      EBISP( 141 ) = COF2
      EBISP( 142 ) = AFCOOHphydJ
      EBISP( 143 ) = PFMOAF
      EBISP( 144 ) = APFMOAAphydJ


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Set species tolerances
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      RTOL( NO2          ) = 5.0D-04
      RTOL( NO           ) = 5.0D-04
      RTOL( O            ) = 1.0D+00
      RTOL( O3           ) = 5.0D-04
      RTOL( NO3          ) = 5.0D-04
      RTOL( O1D          ) = 1.0D+00
      RTOL( OH           ) = 5.0D-04
      RTOL( HO2          ) = 5.0D-04
      RTOL( H2O2         ) = 5.0D-04
      RTOL( N2O5         ) = 5.0D-04
      RTOL( HNO3         ) = 5.0D-04
      RTOL( HONO         ) = 5.0D-04
      RTOL( PNA          ) = 5.0D-04
      RTOL( SO2          ) = 5.0D-04
      RTOL( SULF         ) = 1.0D+00
      RTOL( SULRXN       ) = 1.0D+00
      RTOL( C2O3         ) = 5.0D-04
      RTOL( MEO2         ) = 5.0D-04
      RTOL( RO2          ) = 5.0D-04
      RTOL( PAN          ) = 5.0D-04
      RTOL( PACD         ) = 5.0D-04
      RTOL( AACD         ) = 5.0D-04
      RTOL( CXO3         ) = 5.0D-04
      RTOL( ALD2         ) = 5.0D-04
      RTOL( XO2H         ) = 5.0D-04
      RTOL( PANX         ) = 5.0D-04
      RTOL( FORM         ) = 5.0D-04
      RTOL( MEPX         ) = 5.0D-04
      RTOL( MEOH         ) = 5.0D-04
      RTOL( ROOH         ) = 5.0D-04
      RTOL( XO2          ) = 5.0D-04
      RTOL( XO2N         ) = 5.0D-04
      RTOL( NTR1         ) = 5.0D-04
      RTOL( NTR2         ) = 5.0D-04
      RTOL( FACD         ) = 5.0D-04
      RTOL( CO           ) = 5.0D-04
      RTOL( HCO3         ) = 1.0D+00
      RTOL( ALDX         ) = 5.0D-04
      RTOL( GLYD         ) = 5.0D-04
      RTOL( GLY          ) = 5.0D-04
      RTOL( MGLY         ) = 5.0D-04
      RTOL( ETHA         ) = 5.0D-04
      RTOL( ETOH         ) = 5.0D-04
      RTOL( KET          ) = 5.0D-04
      RTOL( PAR          ) = 5.0D-04
      RTOL( ACET         ) = 5.0D-04
      RTOL( PRPA         ) = 5.0D-04
      RTOL( XPRP         ) = 5.0D-04
      RTOL( XPAR         ) = 5.0D-04
      RTOL( ROR          ) = 5.0D-04
      RTOL( ETHY         ) = 5.0D-04
      RTOL( ETH          ) = 5.0D-04
      RTOL( OLE          ) = 5.0D-04
      RTOL( IOLE         ) = 5.0D-04
      RTOL( ISOP         ) = 5.0D-04
      RTOL( ISO2         ) = 5.0D-04
      RTOL( ISOPRXN      ) = 1.0D+00
      RTOL( ISPD         ) = 5.0D-04
      RTOL( INTR         ) = 5.0D-04
      RTOL( ISPX         ) = 5.0D-04
      RTOL( HPLD         ) = 5.0D-04
      RTOL( OPO3         ) = 5.0D-04
      RTOL( EPOX         ) = 5.0D-04
      RTOL( EPX2         ) = 5.0D-04
      RTOL( TERP         ) = 5.0D-04
      RTOL( TRPRXN       ) = 1.0D+00
      RTOL( TERPNRO2     ) = 5.0D-04
      RTOL( APIN         ) = 5.0D-04
      RTOL( BENZENE      ) = 5.0D-04
      RTOL( CRES         ) = 5.0D-04
      RTOL( BZO2         ) = 5.0D-04
      RTOL( OPEN         ) = 5.0D-04
      RTOL( BENZRO2      ) = 5.0D-04
      RTOL( TOL          ) = 5.0D-04
      RTOL( TO2          ) = 5.0D-04
      RTOL( TOLRO2       ) = 5.0D-04
      RTOL( XOPN         ) = 5.0D-04
      RTOL( XYLMN        ) = 5.0D-04
      RTOL( XLO2         ) = 5.0D-04
      RTOL( XYLRO2       ) = 5.0D-04
      RTOL( NAPH         ) = 5.0D-04
      RTOL( PAHRO2       ) = 1.0D+00
      RTOL( CRO          ) = 5.0D-04
      RTOL( CAT1         ) = 5.0D-04
      RTOL( CRON         ) = 5.0D-04
      RTOL( OPAN         ) = 5.0D-04
      RTOL( ECH4         ) = 5.0D-04
      RTOL( CL2          ) = 5.0D-04
      RTOL( CL           ) = 5.0D-04
      RTOL( HOCL         ) = 5.0D-04
      RTOL( CLO          ) = 5.0D-04
      RTOL( FMCL         ) = 5.0D-04
      RTOL( HCL          ) = 5.0D-04
      RTOL( CLNO2        ) = 5.0D-04
      RTOL( CLNO3        ) = 5.0D-04
      RTOL( SVAVB2       ) = 5.0D-04
      RTOL( SVAVB3       ) = 5.0D-04
      RTOL( SVAVB4       ) = 5.0D-04
      RTOL( SVAVB1       ) = 5.0D-04
      RTOL( SESQ         ) = 5.0D-04
      RTOL( SESQRXN      ) = 1.0D+00
      RTOL( SOAALK       ) = 5.0D-04
      RTOL( H2NO3PIJ     ) = 5.0D-04
      RTOL( H2NO3PK      ) = 5.0D-04
      RTOL( ACLI         ) = 5.0D-04
      RTOL( ACLJ         ) = 5.0D-04
      RTOL( ACLK         ) = 5.0D-04
      RTOL( IEPOXP       ) = 5.0D-04
      RTOL( ASO4J        ) = 5.0D-04
      RTOL( AISO3J       ) = 5.0D-04
      RTOL( AGLYJ        ) = 5.0D-04
      RTOL( MTNO3        ) = 5.0D-04
      RTOL( AMTNO3J      ) = 5.0D-04
      RTOL( AMTHYDJ      ) = 5.0D-04
      RTOL( AAVB2J       ) = 5.0D-04
      RTOL( AOLGAJ       ) = 5.0D-04
      RTOL( AAVB3J       ) = 5.0D-04
      RTOL( AAVB4J       ) = 5.0D-04
      RTOL( AISO1J       ) = 5.0D-04
      RTOL( AOLGBJ       ) = 5.0D-04
      RTOL( AISO2J       ) = 5.0D-04
      RTOL( ASQTJ        ) = 5.0D-04
      RTOL( APOCI        ) = 5.0D-04
      RTOL( APNCOMI      ) = 5.0D-04
      RTOL( APOCJ        ) = 5.0D-04
      RTOL( APNCOMJ      ) = 5.0D-04
      RTOL( PCVOC        ) = 5.0D-04
      RTOL( PCSOARXN     ) = 5.0D-04
      RTOL( VLVPO1       ) = 5.0D-04
      RTOL( VSVPO1       ) = 5.0D-04
      RTOL( VSVPO2       ) = 5.0D-04
      RTOL( VSVPO3       ) = 5.0D-04
      RTOL( VIVPO1       ) = 5.0D-04
      RTOL( VLVOO1       ) = 5.0D-04
      RTOL( VLVOO2       ) = 5.0D-04
      RTOL( VSVOO2       ) = 5.0D-04
      RTOL( VSVOO3       ) = 5.0D-04
      RTOL( VSVOO1       ) = 5.0D-04
      RTOL( FORM_PRIMARY ) = 5.0D-04
      RTOL( ALD2_PRIMARY ) = 5.0D-04
      RTOL( BUTADIENE13  ) = 5.0D-04
      RTOL( ACROLEIN     ) = 5.0D-04
      RTOL( ACRO_PRIMARY ) = 5.0D-04
      RTOL( TOLU         ) = 5.0D-04
      RTOL( HG           ) = 5.0D-04
      RTOL( HGIIAER      ) = 5.0D-04
      RTOL( HGIIGAS      ) = 5.0D-04
      RTOL( DMS          ) = 5.0D-04
      RTOL( MSA          ) = 5.0D-04
      RTOL( HFPODAF      ) = 5.0D-04
      RTOL( AHFJ         ) = 5.0D-04
      RTOL( HFPODAghyd   ) = 5.0D-04
      RTOL( AHFPODAphydJ ) = 5.0D-04
      RTOL( COF2         ) = 5.0D-04
      RTOL( AFCOOHphydJ  ) = 5.0D-04
      RTOL( PFMOAF       ) = 5.0D-04
      RTOL( APFMOAAphydJ ) = 5.0D-04


      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE FIRE_PLMRIS( EMLAYS, LSTK, HFX, HMIX,
     &                        BFLX,
     &                        TSTK, USTAR, DTHDZ, TA, WSPD, 
     &                        ZF,           WSTK, ZPLM )

C-----------------------------------------------------------------------
 
C Description:  
C     computes final effective plume centerline height.
 
C Preconditions:
C     meteorology and stack parameters
 
C Subroutines and Functions called:
 
C Revision History:
C     Prototype 12/95 by CJC, based on Briggs algorithm adapted from
C     RADM 2.6 subroutine PLUMER() (but with completely different 
C     data structuring).
C     Copied from plmris.F 4.4 by M Houyoux 3/99 
C     Aug 2015, D. Wong: Used assumed shape array declaration
C     Jan 2022, D. Wong: variable FIRSTIME is obsolete
 
C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling System
C File: @(#)$Id: fire_plmris.F,v 1.2 2011/10/21 16:11:30 yoj Exp $
C COPYRIGHT (C) 2002, MCNC Environmental Modeling Center
C All Rights Reserved
C See file COPYRIGHT for conditions of use.
C Environmental Modeling Center
C MCNC
C P.O. Box 12889
C Research Triangle Park, NC  27709-2889
C smoke@emc.mcnc.org
C Pathname: $Source: /project/yoj/arc/CCTM/src/plrise/smoke/fire_plmris.F,v $
C Last updated: $Date: 2011/10/21 16:11:30 $ 
C-----------------------------------------------------------------------
      USE RUNTIME_VARS, ONLY : LOGDEV
      USE CONST,        ONLY : GRAV

      IMPLICIT NONE

C Arguments:
      INTEGER, INTENT( IN )  :: EMLAYS          ! no. of emission layers
      INTEGER, INTENT( IN )  :: LSTK            ! lyr of top of fire, = RADM's KSTK
      REAL,    INTENT( IN )  :: HFX             ! sensible heat flux [m K/s]
      REAL,    INTENT( IN )  :: HMIX            ! mixing height [m]

      REAL,    INTENT( IN )  :: BFLX            ! Buoyancy Flux [m**4/s**3]

      REAL,    INTENT( IN )  :: TSTK            ! tmptr at top of fire [deg K]
      REAL,    INTENT( IN )  :: USTAR           ! friction velocity [m/s]
      REAL,    INTENT( IN )  :: DTHDZ( : )      ! gradient of THETV
      REAL,    INTENT( IN )  :: TA   ( : )      ! temperature [deg K]
      REAL,    INTENT( IN )  :: WSPD ( : )      ! wind speed [m/s]
      REAL,    INTENT( IN )  :: ZF  ( 0: )      ! layer surface height [m]
      REAL,    INTENT( INOUT ) :: WSTK          ! wind speed @ top of fire [m/s]
                                                ! OUT for reporting, only
      REAL,    INTENT( OUT ) :: ZPLM            ! initially, plume top height above fire,
                                                ! finally, plume centerline height [m]
                                                ! can be greater than the top of EMLAYS

C Parameters:
      REAL, PARAMETER :: HCRIT   =  1.0E-4 * 0.03  ! hfx min * tolerance
      REAL, PARAMETER :: SMALL   =  3.0E-5         ! Criterion for stability
      REAL, PARAMETER :: D3      =  1.0 /  3.0     ! 1/ 3
      REAL, PARAMETER :: D6      =  1.0 /  6.0     ! 1/6
      REAL, PARAMETER :: D45     =  1.0 / 45.0     ! 1/45
      REAL, PARAMETER :: D2664   =  1.0 /  2.664   ! 1/ 2.664
      REAL, PARAMETER :: D59319  =  1.0 / 59.319   ! 1/59.319
      REAL, PARAMETER :: TWOTHD  =  2.0 /  3.0     ! 2/3
      REAL, PARAMETER :: FIVETHD =  5.0 /  3.0     ! 5/3
      REAL, PARAMETER :: NODIV0  =  1.0            ! Prevent divide by zero
      
      REAL, PARAMETER :: ZERO = 0.0

C Local Variables:
      INTEGER IQ              ! stability class: 1-unstable, 2-neutral, 3-stable
      INTEGER LPLM            ! first L: ZH(L) > Plume height ! same as RADM's KPR
      INTEGER NN              ! Counter for interations through layers
      REAL    DH              ! plume rise increment to center of the plume
      REAL    DHM             ! plume rise from momentum
      REAL    DHSM            ! stable momentum plume rise
      REAL    DHN             ! plume rise for neutral case
      REAL    DHT             ! plume rise increment to the top of the plume
      REAL    HSTAR           ! convective scale at fire (m**2/s**3)
      REAL    PX, RX, SX      ! scratch coefficients
      REAL    RBFLX           ! residual buoyancy flux (m**4/s**3)
      REAL    TPLM            ! temperature at top of plume (m/s)
      REAL    WPLM            ! wind speed  at top of plume (m/s)
      REAL    ZMIX            ! hmix - hs

C Statement Functions:
      REAL    B,    S, U, US  ! arguments
       
      REAL    NEUTRL          ! neutral-stability plume rise function
      REAL    STABLE          ! stable            plume rise function
      REAL    UNSTBL          ! unstable          plume rise function

      NEUTRL( B, U, US ) = 1.3327804 * B / ( U * US * US )

      STABLE( B, U, S ) =  2.6 * ( B / ( U * S ) ) ** D3
      UNSTBL( B, U )    = 30.0 * ( B / U ) ** 0.6

C-----------------------------------------------------------------------

C Compute convective scale.

      HSTAR = GRAV * HFX / TA( 1 )   ! Using surface temperature is correct

C Initialize layer of plume
      LPLM  = LSTK

C Compute momentum rise ( set min wind speed to 1 m/s)
      WSTK = MAX( WSTK, 1.0 )
      DHM  = ZERO

C Compute initial plume rise from fire top to next level surface:

      IF ( HSTAR .GT. HCRIT ) THEN           ! unstable case:
         ZMIX = HMIX 

         IF ( ZMIX .LE. 0.0 ) THEN           ! Fire above mixing height:
            SX = MAX( GRAV * DTHDZ( LPLM ) / TSTK, SMALL )

C Reset the wind speed at fire to the wind speed at plume when the layer
C of the plume is not equal to the layer of the fire.
            IF ( LPLM .NE. LSTK ) THEN
               WSTK = WSPD( LPLM )
               IF ( WSTK .EQ. 0.0 ) WSTK = NODIV0
            END IF

C Compute the stable momentum rise, for layer of the fire.
            IF ( DTHDZ( LPLM ) .GT. 0.001 ) THEN
               DHSM = ZERO
            ELSE
               DHSM = DHM     ! Set it to DHM, if THGRAD too small
            END IF
            DHM = MIN( DHSM, DHM )

C Compute the neutral and stable plume rises.         
            DHN = NEUTRL( BFLX, WSTK, USTAR )
            DH  = STABLE( BFLX, WSTK, SX )

            IF ( DHN .LT. DH ) THEN  ! Take the minimum of neutral and stable
               DH = DHN
               IQ = 2
            ELSE 
               IQ = 3 
            END IF

            IF ( DHM .GT. DH .AND. WSTK .GT. 1.0 ) THEN
               DH = DHM
               IQ = 4
            END IF
            DHT = 1.5 * DH

         ELSE                        !  unstable case:
            DH  = UNSTBL( BFLX, WSTK )
            DHN = NEUTRL( BFLX, WSTK, USTAR )

            IF ( DHN .LT. DH ) THEN
               DH = DHN
               IQ = 2
            ELSE
               IQ = 1
            END IF

            IF ( DHM .GT. DH .AND. WSTK .GT. 1.0 ) THEN
               DH = DHM
               IQ = 4 
            END IF

            DHT = 1.5 * DH

         END IF

      ELSE IF ( HSTAR .LT. -HCRIT .OR. DTHDZ( LSTK ) .GT. 0.001 ) THEN   ! stable case:

         SX = MAX( GRAV * DTHDZ( LSTK ) / TSTK, SMALL )
         DHT = 1.5 * STABLE( BFLX, WSTK, SX )
         DHN = 1.5 * NEUTRL( BFLX, WSTK, USTAR )
         IF ( DHN .LT. DHT ) THEN
             DHT = DHN
             IQ = 2
         ELSE
             IQ = 3
         END IF

      ELSE                             !  neutral case:

         DHT = 1.5 * NEUTRL( BFLX, WSTK, USTAR )
         IQ  = 2

      END IF                 !  hstar ==> unstable, stable, or neutral
  
C Compute further plume rise from between level surfaces:
      NN = 0
      RBFLX = BFLX
      ZPLM  = DHT

C End calculations if the momentum rise was used in the calculation

      IF ( IQ .EQ. 4 ) GO TO 199  ! to point past iterative buoyancy loop

      DO       !  loop computing further plume rise

         RX = ZPLM - ZF( LPLM )
         IF ( RX .LE. 0.0 ) THEN
            EXIT  ! exit plume rise loop
         END IF

         IF ( LPLM .EQ. EMLAYS ) THEN   ! we're finished
            ZPLM = MIN( ZPLM, ZF( EMLAYS ) )
            WRITE( LOGDEV,'(5X, A, I3, F10.3)' )
     &                    'Plume rise reached EMLAYS with ZPLM:', EMLAYS, ZPLM
            EXIT  ! exit plume rise loop
         END IF

C Reset met data. NOTE- the original RADM code submitted the 
C WSPD and TA to an interpolator, but then requested the height of
C interpolation identical to ZH( LPLM ).
         NN = NN + 1
         IF ( NN .GT. 1 ) THEN
            WPLM = WSPD( LPLM )
            TPLM = TA  ( LPLM )
         ELSE                  ! 1st time, use stack values ...
            WPLM = WSTK
            TPLM = TSTK
         END IF
 
C Compute residual bflx by stability case IQ:

         IF ( IQ .EQ. 1 ) THEN
            RX = D45 * RX      ! Includes the 1.5 factor for plume top
            RBFLX = WPLM * ( RX ** FIVETHD )
         ELSE IF ( IQ .EQ. 2 ) THEN
            PX = TWOTHD * ZPLM         
            RBFLX = D2664 * ( RX ** FIVETHD ) * WPLM * ( USTAR * USTAR ) / PX ** TWOTHD
         ELSE      !  else iq = 3:
            RBFLX = D59319 * WPLM * SX * RX ** 3
         END IF      !  if stability flag iq is 1, 2, or 3

C Increment the layer number below.
         IF ( LPLM .LT. EMLAYS ) LPLM = LPLM + 1
         WPLM = WSPD( LPLM )
         TPLM = TA  ( LPLM )

C Prevent divide-by-zero by WPLM
         IF ( WPLM .EQ. 0.0 ) WPLM = NODIV0

C Process according to stability cases:
         SX = GRAV * DTHDZ( LPLM ) / TPLM
         IF ( SX .GT. SMALL ) THEN               ! stable case:
C Use the theta gradient to determine pr eqn.
            DHT = 1.5 * STABLE( RBFLX, WPLM, SX )
            DHN = 1.5 * NEUTRL( RBFLX, WPLM, USTAR )
            IF ( DHN .LT. DHT ) THEN
               DHT = DHN
               IQ  = 2
            ELSE
               IQ  = 3
            END IF
            DH = DHT / 1.5
         ELSE          ! if upper layer is not stable, use neutral formula
                         
            DHN = NEUTRL( RBFLX, WPLM, USTAR )
            DH  = UNSTBL( RBFLX, WPLM )
            IQ = 1
            IF ( DHN .LT. DH ) THEN
               DH = DHN
               IQ  = 2
            END IF
            DHT = 1.5 * DH

         END IF
  
         ZPLM = ZF( LPLM-1 ) + DHT
         DH   = ZF( LPLM-1 ) + DH 
        
      END DO  ! end loop computing further plume rise

199   CONTINUE

C Compute plume rise amount (DH) and actual final plume centerline height (ZPLM):
      DH  = TWOTHD * ZPLM
      ZPLM = DH            

      RETURN

      END SUBROUTINE FIRE_PLMRIS

#!/bin/csh -f

# ===================== CCTMv5.4.X Run Script ========================= 
# Usage: run.cctm >&! cctm_v54X.log &                                
#
# To report problems or request help with this script/program:
#             http://www.epa.gov/cmaq    (EPA CMAQ Website)
#             http://www.cmascenter.org  (CMAS Website)
# ===================================================================  


# ===================================================================
#> Runtime Environment Options
# ===================================================================

echo 'Start Model Run At ' `date`

#> Toggle Diagnostic Mode which will print verbose information to 
#> standard output
 setenv CTM_DIAG_LVL 0

#> Choose compiler and set up CMAQ environment with correct 
#> libraries using config.cmaq. Options: intel | gcc | pgi
 if ( ! $?compiler ) then
   setenv compiler intel
 endif
 if ( ! $?compilerVrsn ) then
   setenv compilerVrsn Empty
 endif

#> Source the config.cmaq file to set the build environment
 cd ../..
 source ./config_cmaq.csh $compiler $compilerVrsn
 cd CCTM/scripts

#> Set General Parameters for Configuring the Simulation
 set VRSN      = v55_PFAShydro     #> Code Version
 set PROC      = mpi               #> serial or mpi
 set MECH      = cb6r5pfas_ae7_aq  #> Mechanism ID
 set EMIS      = 2018ff            #> Emission Inventory Details
 set APPL      = 2018_1NC1         #> Application Name (e.g. Gridname)

#> Define RUNID as any combination of parameters above or others. By default,
#> this information will be collected into this one string, $RUNID, for easy
#> referencing in output binaries and log files as well as in other scripts.
 setenv RUNID  ${VRSN}_${compilerString}_${APPL}

#> Set the build directory (this is where the CMAQ executable
#> is located by default).
 set BLD       = ${CMAQ_HOME}/CCTM/scripts/BLD_CCTM_${VRSN}_${compilerString}
 set EXEC      = CCTM_${VRSN}.exe  

#> Output Each line of Runscript to Log File
 if ( $CTM_DIAG_LVL != 0 ) set echo 

#> Set Working, Input, and Output Directories
 setenv WORKDIR ${CMAQ_HOME}/CCTM/scripts       #> Working Directory. Where the runscript is.
 setenv OUTDIR  ${CMAQ_DATA}/output_CCTM_${RUNID} #> Output Directory
 setenv INPDIR  /work/MOD3DATA/2018_1NC1  #Input Directory
 setenv LOGDIR  ${OUTDIR}/LOGS     #> Log Directory Location
 setenv NMLpath ${BLD}             #> Location of Namelists. Common places are: 
                                   #>   ${WORKDIR} | ${CCTM_SRC}/MECHS/${MECH} | ${BLD}

 echo ""
 echo "Working Directory is $WORKDIR"
 echo "Build Directory is $BLD"
 echo "Output Directory is $OUTDIR"
 echo "Log Directory is $LOGDIR"
 echo "Executable Name is $EXEC"

# =====================================================================
#> CCTM Configuration Options
# =====================================================================

#> Set Start and End Days for looping
 setenv NEW_START TRUE            #> Set to FALSE for model restart
 set START_DATE = "2017-12-23"     #> beginning date (December 22, 2017)
 set END_DATE   = "2018-12-31"     #> ending date    (December 31, 2018)

#> Set Timestepping Parameters
set STTIME     = 000000            #> beginning GMT time (HHMMSS)
set NSTEPS     = 240000            #> time duration (HHMMSS) for this run
set TSTEP      = 010000            #> output time step interval (HHMMSS)

#> Horizontal domain decomposition
if ( $PROC == serial ) then
   setenv NPCOL_NPROW "1 1"; set NPROCS   = 1 # single processor setting
else
   @ NPCOL  =  16; @ NPROW =  24
   @ NPROCS = $NPCOL * $NPROW
   setenv NPCOL_NPROW "$NPCOL $NPROW"; 
endif

#> Define Execution ID: e.g. [CMAQ-Version-Info]_[User]_[Date]_[Time]
if ( ! -e ${BLD}/CCTM_${VRSN}.cfg ) then
   set SHAID = ""
else
   set SHAID = `grep "sha_ID" ${BLD}/CCTM_${VRSN}.cfg | cut -c 13-22`
   if ( $SHAID == not_a_repo ) then
     set SHAID = ""
   else
     set SHAID = "_sha="$SHAID
   endif
endif
setenv EXECUTION_ID "CMAQ_CCTM${VRSN}${SHAID}_`id -u -n`_`date -u +%Y%m%d_%H%M%S_%N`"    #> Inform IO/API of the Execution ID
echo ""
echo "---CMAQ EXECUTION ID: $EXECUTION_ID ---"

#> Keep or Delete Existing Output Files
set CLOBBER_DATA = FALSE

#> Logfile Options
#> Master Log File Name; uncomment to write standard output to a log, otherwise write to screen
#setenv LOGFILE $CMAQ_HOME/$RUNID.log  
if (! -e $LOGDIR ) then
  mkdir -p $LOGDIR
endif
setenv PRINT_PROC_TIME Y           #> Print timing for all science subprocesses to Logfile
                                   #>   [ default: TRUE or Y ]
setenv STDOUT T                    #> Override I/O-API trying to write information to both the processor 
                                   #>   logs and STDOUT [ options: T | F ]

setenv GRID_NAME 1NC1     #> check GRIDDESC file for GRID_NAME options
setenv GRIDDESC $INPDIR/GRIDDESC   #> grid description file

#> Retrieve the number of columns, rows, and layers in this simulation
set NZ = 35
set NX = `grep -A 1 ${GRID_NAME} ${GRIDDESC} | tail -1 | sed 's/  */ /g' | cut -d',' -f6`
set NY = `grep -A 1 ${GRID_NAME} ${GRIDDESC} | tail -1 | sed 's/  */ /g' | cut -d',' -f7`
set NCELLS = `echo "${NX} * ${NY} * ${NZ}" | bc -l`

#> Output Species and Layer Options
   #> CONC file species; comment or set to "ALL" to write all species to CONC
   setenv CONC_SPCS "O3 NO ANO3I ANO3J NO2 FORM ISOP NH3 ANH4I ANH4J ASO4I ASO4J" 
   setenv CONC_BLEV_ELEV " 1 1" #> CONC file layer range; comment to write all layers to CONC

   #> ACONC file species; comment or set to "ALL" to write all species to ACONC
   #setenv AVG_CONC_SPCS "O3 NO CO NO2 ASO4I ASO4J NH3" 
   setenv AVG_CONC_SPCS "ALL" 
   setenv ACONC_BLEV_ELEV " 1 1" #> ACONC file layer range; comment to write all layers to ACONC
   setenv AVG_FILE_ENDTIME N     #> override default beginning ACONC timestamp [ default: N ]

#> Synchronization Time Step and Tolerance Options
setenv CTM_MAXSYNC 300       #> max sync time step (sec) [ default: 720 ]
setenv CTM_MINSYNC  60       #> min sync time step (sec) [ default: 60 ]
setenv SIGMA_SYNC_TOP 0.7    #> top sigma level thru which sync step determined [ default: 0.7 ] 
#setenv ADV_HDIV_LIM 0.95    #> maximum horiz. div. limit for adv step adjust [ default: 0.9 ]
setenv CTM_ADV_CFL 0.95      #> max CFL [ default: 0.75]
#setenv RB_ATOL 1.0E-09      #> global ROS3 solver absolute tolerance [ default: 1.0E-07 ] 

#> Science Options
setenv CTM_OCEAN_CHEM Y      #> Flag for ocean halogen chemistry, sea spray aerosol emissions,
                             #> and enhanced ozone deposition over ocean waters  [ default: Y ]
setenv CTM_WB_DUST N         #> use inline windblown dust emissions [ default: Y ]
setenv CTM_LTNG_NO N         #> turn on lightning NOx [ default: N ]
setenv KZMIN Y               #> use Min Kz option in edyintb [ default: Y ], 
                             #>    otherwise revert to Kz0UT
setenv PX_VERSION Y          #> WRF PX LSM
setenv CLM_VERSION N         #> WRF CLM LSM
setenv NOAH_VERSION N        #> WRF NOAH LSM
setenv CTM_ABFLUX N          #> ammonia bi-directional flux for in-line deposition 
                             #>    velocities [ default: N ]
setenv CTM_BIDI_FERT_NH3 F   #> subtract fertilizer NH3 from emissions because it will be handled
                             #>    by the BiDi calculation [ default: Y ]
setenv CTM_HGBIDI N          #> mercury bi-directional flux for in-line deposition 
                             #>    velocities [ default: N ]
setenv CTM_SFC_HONO N        #> surface HONO interaction [ default: Y ]
setenv CTM_GRAV_SETL Y       #> vdiff aerosol gravitational sedimentation [ default: Y ]
setenv CTM_BIOGEMIS_BE Y     #> calculate in-line biogenic emissions [ default: N ]
setenv CTM_BIOGEMIS_MG N     #> turns on MEGAN biogenic emission [ default: N ]
setenv USE_MEGAN_LAI N       #> use separate LAI input file [ default: N ]
setenv BDSNP_MEGAN N         #> turns on BDSNP soil NO emissions [ default: N ]


setenv IC_AERO_M2WET F       #> Specify whether or not initial condition aerosol size distribution 
                             #>    is wet or dry [ default: F = dry ]
setenv BC_AERO_M2WET F       #> Specify whether or not boundary condition aerosol size distribution 
                             #>    is wet or dry [ default: F = dry ]
setenv IC_AERO_M2USE T       #> Specify whether or not to use aerosol surface area from initial 
                             #>    conditions [ default: T = use aerosol surface area  ]
setenv BC_AERO_M2USE T       #> Specify whether or not to use aerosol surface area from boundary 
                             #>    conditions [ default: T = use aerosol surface area  ]
                             
#> Surface Tiled Aerosol and Gaseous Exchange Options
#> Only active if DepMod=stage at compile time
setenv CTM_MOSAIC N          #> Output landuse specific deposition velocities [ default: N ]
setenv CTM_STAGE_P22 N       #> Pleim et al. 2022 Aerosol deposition model [default: N]
setenv CTM_STAGE_E20 Y       #> Emerson et al. 2020 Aerosol deposition model [default: Y]
setenv CTM_STAGE_S22 N       #> Shu et al. 2022 (CMAQ v5.3) Aerosol deposition model [default: N]

#> Vertical Extraction Options
setenv VERTEXT N
setenv VERTEXT_COORD_PATH ${WORKDIR}/lonlat.csv

#> I/O Controls
setenv IOAPI_LOG_WRITE F     #> turn on excess WRITE3 logging [ options: T | F ]
setenv FL_ERR_STOP N         #> stop on inconsistent input files
setenv PROMPTFLAG F          #> turn on I/O-API PROMPT*FILE interactive mode [ options: T | F ]
setenv IOAPI_OFFSET_64 YES   #> support large timestep records (>2GB/timestep record) [ options: YES | NO ]
setenv IOAPI_CHECK_HEADERS N #> check file headers [ options: Y | N ]
setenv CTM_EMISCHK N         #> Abort CMAQ if missing surrogates from emissions Input files
setenv EMISDIAG F            #> Print Emission Rates at the output time step after they have been
                             #>   scaled and modified by the user Rules [options: F | T or 2D | 3D | 2DSUM ]
                             #>   Individual streams can be modified using the variables:
                             #>       GR_EMIS_DIAG_## | STK_EMIS_DIAG_## | BIOG_EMIS_DIAG
                             #>       MG_EMIS_DIAG    | LTNG_EMIS_DIAG   | DUST_EMIS_DIAG
                             #>       SEASPRAY_EMIS_DIAG   
                             #>   Note that these diagnostics are different than other emissions diagnostic
                             #>   output because they occur after scaling.

#> Diagnostic Output Flags
setenv CTM_CKSUM Y           #> checksum report [ default: Y ]
setenv CLD_DIAG N            #> cloud diagnostic file [ default: N ]

setenv CTM_PHOTDIAG N        #> photolysis diagnostic file [ default: N ]
setenv NLAYS_PHOTDIAG "1"    #> Number of layers for PHOTDIAG2 and PHOTDIAG3 from 
                             #>     Layer 1 to NLAYS_PHOTDIAG  [ default: all layers ] 
#setenv NWAVE_PHOTDIAG "294 303 310 316 333 381 607"  #> Wavelengths written for variables
                                                      #>   in PHOTDIAG2 and PHOTDIAG3 
                                                      #>   [ default: all wavelengths ]

setenv CTM_SSEMDIAG N        #> sea-spray emissions diagnostic file [ default: N ]
setenv CTM_DUSTEM_DIAG N     #> windblown dust emissions diagnostic file [ default: N ]; 
                             #>     Ignore if CTM_WB_DUST = N
setenv CTM_DEPV_FILE Y       #> deposition velocities diagnostic file [ default: N ]
setenv VDIFF_DIAG_FILE N     #> vdiff & possibly aero grav. sedimentation diagnostic file [ default: N ]
setenv LTNGDIAG N            #> lightning diagnostic file [ default: N ]
setenv B3GTS_DIAG N          #> BEIS mass emissions diagnostic file [ default: N ]
setenv CTM_WVEL Y            #> save derived vertical velocity component to conc
                             #>    file [ default: Y ]

#> MPI Optimization Flags
setenv MPI_SM_POOL 16000     #> increase shared memory pool in case many MPI_SEND headers
setenv MP_EAGER_LIMIT 65536  #> set MPI message passing buffer size to max
setenv MP_SINGLE_THREAD yes  #> optimize for single threaded applications [ default: no ]
setenv MP_STDOUTMODE ordered #> order output by the processor ID
setenv MP_LABELIO yes        #> label output by processor ID [ default: no ]
setenv MP_SHARED_MEMORY yes  #> force use of shared memory for tasks on same node [ default: no ]
setenv MP_ADAPTER_USE shared #> share the MP adapter with other jobs
setenv MP_CPU_USE multiple   #> share the node with multiple users/jobs
setenv MP_CSS_INTERRUPT yes  #> specify whether arriving packets generate interrupts [ default: no ]

# =====================================================================
#> Input Directories and Filenames
# =====================================================================

set ICpath    = $INPDIR/icbc/cb6r3_ae7_aq              #> initial conditions input directory
set BCpath    = $INPDIR/icbc/cb6r3_ae7_aq              #> boundary conditions input directory
set EMISpath  = $INPDIR/emis/cb6r3_ae6_20190605/cmaq_ready/gridded #> surface emissions input directory
set IN_PTpath = /work/MOD3DATA/2018_12US1/emis/cb6r3_ae6_20190604  #> elevated emissions input directory (in-line point only)
set IN_LTpath = $INPDIR/met/lightning     #> lightning NOx input directory
set METpath   = $INPDIR/met/WRFv4.1.1_MCIPv5.0              #> meteorology input directory
#set JVALpath  = $INPDIR/jproc            #> offline photolysis rate table directory
set OMIpath   = $BLD                      #> ozone column data for the photolysis model
set LUpath    = $INPDIR/surface           #> BELD landuse data for windblown dust model
set SZpath    = $INPDIR/surface           #> surf zone file for in-line seaspray emissions

# =====================================================================
#> Begin Loop Through Simulation Days
# =====================================================================
set rtarray = ""

set TODAYG = ${START_DATE}
set TODAYJ = `date -ud "${START_DATE}" +%Y%j` #> Convert YYYY-MM-DD to YYYYJJJ
set START_DAY = ${TODAYJ} 
set STOP_DAY = `date -ud "${END_DATE}" +%Y%j` #> Convert YYYY-MM-DD to YYYYJJJ
set NDAYS = 0

while ($TODAYJ <= $STOP_DAY )  #>Compare dates in terms of YYYYJJJ
  
  set NDAYS = `echo "${NDAYS} + 1" | bc -l`

  #> Retrieve Calendar day Information
  set YYYYMMDD = `date -ud "${TODAYG}" +%Y%m%d` #> Convert YYYY-MM-DD to YYYYMMDD
  set YYYYMM   = `date -ud "${TODAYG}" +%Y%m`   #> Convert YYYY-MM-DD to YYYYMM
  set YYYY     = `date -ud "${TODAYG}" +%Y`     #> Convert YYYY-MM-DD to YYYY
  set YYMMDD   = `date -ud "${TODAYG}" +%y%m%d` #> Convert YYYY-MM-DD to YYMMDD
  set MM       = `date -ud "${TODAYG}" +%m`     #> Convert YYYY-MM-DD to YYMMDD
  set MMDD     = `date -ud "${TODAYG}" +%m%d`   #> Convert YYYY-MM-DD to YYMMDD
  set YYYYJJJ  = $TODAYJ

  #> Calculate Yesterday's Date
  set YESTERDAY = `date -ud "${TODAYG}-1days" +%Y%m%d` #> Convert YYYY-MM-DD to YYYYJJJ

# =====================================================================
#> Set Output String and Propagate Model Configuration Documentation
# =====================================================================
  echo ""
  echo "Set up input and output files for Day ${TODAYG}."

  #> set output file name extensions
  setenv CTM_APPL ${RUNID}_${YYYYMMDD} 
  
  #> Copy Model Configuration To Output Folder
  if ( ! -d "$OUTDIR" ) mkdir -p $OUTDIR
  cp $BLD/CCTM_${VRSN}.cfg $OUTDIR/CCTM_${CTM_APPL}.cfg

# =====================================================================
#> Input Files (Some are Day-Dependent)
# =====================================================================

  #> Initial conditions
  if ($NEW_START == true || $NEW_START == TRUE ) then
     setenv ICFILE CCTM_CGRID_v53_intel18.0_2018_1NC1_${YESTERDAY}.nc
     setenv INIT_MEDC_1 notused
     setenv INITIAL_RUN Y #related to restart soil information file
  else
     set ICpath = $OUTDIR
     setenv ICFILE CCTM_CGRID_${RUNID}_${YESTERDAY}.nc
     setenv INIT_MEDC_1 $ICpath/CCTM_MEDIA_CONC_${RUNID}_${YESTERDAY}
     setenv INITIAL_RUN N
  endif

  #> Boundary conditions, use STAGE files if CCTM uses the stage option for depv
  set BCFILE = BCON_v53_2018_1NC1_regrid_${YYYYMMDD}

  #> Off-line photolysis rates 
  #set JVALfile  = JTABLE_${YYYYJJJ}

  #> Ozone column data
  set OMIfile   = OMI_1979_to_2019.dat

  #> Optics file
  set OPTfile = PHOT_OPTICS.dat

  #> MCIP meteorology files
  setenv GRID_BDY_2D $METpath/GRIDBDY2D.$GRID_NAME.${NZ}L.$YYMMDD
  setenv GRID_CRO_2D $METpath/GRIDCRO2D.$GRID_NAME.${NZ}L.$YYMMDD
  #setenv GRID_CRO_3D $METpath/GRIDCRO3D.$GRID_NAME.${NZ}L.$YYMMDD
  setenv GRID_DOT_2D $METpath/GRIDDOT2D.$GRID_NAME.${NZ}L.$YYMMDD
  setenv MET_CRO_2D  $METpath/METCRO2D.$GRID_NAME.${NZ}L.$YYMMDD
  setenv MET_CRO_3D  $METpath/METCRO3D.$GRID_NAME.${NZ}L.$YYMMDD
  setenv MET_DOT_3D  $METpath/METDOT3D.$GRID_NAME.${NZ}L.$YYMMDD
  setenv MET_BDY_3D  $METpath/METBDY3D.$GRID_NAME.${NZ}L.$YYMMDD
  #setenv LUFRAC_CRO  $METpath/LUFRAC_CRO.$GRID_NAME.${NZ}L.$YYMMDD
  setenv LUFRAC_CRO  $METpath/LUFRAC_CRO.1NC1.35L.2018.Tindependent

  #> Control File
  #>
  #> IMPORTANT NOTE
  #>
  #> The DESID control files defined below are an integral part of controlling the behavior of the model simulation.
  #> Among other things, they control the mapping of species in the emission files to chemical species in the model and
  #> several aspects related to the simulation of organic aerosols.
  #> Please carefully review the DESID control files to ensure that they are configured to be consistent with the assumptions
  #> made when creating the emission files defined below and the desired representation of organic aerosols.
  #> For further information, please see:
  #> + AERO7 Release Notes section on 'Required emission updates':
  #>   https://github.com/USEPA/CMAQ/blob/master/DOCS/Release_Notes/aero7_overview.md
  #> + CMAQ User's Guide section 6.9.3 on 'Emission Compatability':
  #>   https://github.com/USEPA/CMAQ/blob/master/DOCS/Users_Guide/CMAQ_UG_ch06_model_configuration_options.md#6.9.3_Emission_Compatability
  #> + Emission Control (DESID) Documentation in the CMAQ User's Guide:
  #>   https://github.com/USEPA/CMAQ/blob/master/DOCS/Users_Guide/Appendix/CMAQ_UG_appendixB_emissions_control.md
  #>
  setenv CMAQ_CTRL_NML ${BLD}/CMAQ_Control.nml
  setenv CMAQ_CH_CTRL_NML ${BLD}/CMAQ_Chem_Control_${MECH}.nml

  #> The following namelist controls the mapping of meteorological land use types and the NH3 and Hg emission
  #> potentials
  setenv STAGECTRL_NML ${BLD}/CMAQ_Control_STAGE.nml

  #> Spatial Masks For Emissions Scaling
#  setenv CMAQ_MASKS $SZpath/OCEAN_${MM}_L3m_MC_CHL_chlor_a_12US1.nc

  # For the CarbAcid sensitivity simulation, use a modified set of emission control files
  #setenv EMISSCTRL_NML $INPDIR/emis/cb6r3_ae6_20190605/EmissCtrl/EmissCtrl_cb6r3_ae7_aq_CarbAcid_${YYYYMMDD}.nml 

  #> Determine Representative Emission Days
  set EMDATES = $INPDIR/emis/emis_dates/smk_merge_dates_2018${MM}.txt
  set intable = `grep "^2018${MMDD}" $EMDATES`
  set thisDate = `echo $intable[1] | cut -d, -f1`
  set aveday_N = `echo $intable[2] | cut -d, -f1`
  set aveday_Y = `echo $intable[3] | cut -d, -f1`
  set mwdss_N  = `echo $intable[4] | cut -d, -f1`
  set mwdss_Y  = `echo $intable[5] | cut -d, -f1`
  set week_N   = `echo $intable[6] | cut -d, -f1`
  set week_Y   = `echo $intable[7] | cut -d, -f1`
  set all      = `echo $intable[8] | cut -d, -f1`

  #> Gridded Emissions files
  setenv N_EMIS_GR 1
  set EMISfile  = emis_mole_all_${thisDate}_1NC1_nobeis_2018ff_18j.ncf
  setenv GR_EMIS_001 ${EMISpath}/${EMISfile}
  setenv GR_EMIS_LAB_001 GRIDDED_EMIS
  setenv GR_EM_SYM_DATE_001 T

  #set EMISfile  = emis_mole_rwc_${thisDate}_12US1_cmaq_cb6_2016ff_16j.ncf
  #setenv GR_EMIS_002 ${EMISpath2}/${EMISfile}
  #setenv GR_EMIS_LAB_002 GRIDDED_RWC
 
  #> In-Line Point Emissions Files
  setenv N_EMIS_PT 13          #> Number of elevated source groups

  set STKCASEE401 = 12US1_cmaq_cb6_2018ff_18j_WR401  # In-line Emission Rate File Suffix
  set STKCASEG401 = 12US1_2018ff_18j_WR401                 # Stack parameter File Suffix
  set STKCASEE405 = 12US1_cmaq_cb6_2018ff_18j_WR405  # In-line Emission Rate File Suffix
  set STKCASEG405 = 12US1_2018ff_18j_WR405                 # Stack parameter File Suffix

  setenv STK_GRPS_001 $IN_PTpath/ptnonipm_nopfas/stack_groups_ptnonipm_nopfas_${STKCASEG405}.ncf
  setenv STK_GRPS_002 $IN_PTpath/ptegu/stack_groups_ptegu_${STKCASEG401}.ncf
  setenv STK_GRPS_003 $IN_PTpath/othpt/stack_groups_othpt_${STKCASEG401}.ncf
  setenv STK_GRPS_004 $IN_PTpath/ptagfire/stack_groups_ptagfire_${thisDate}_${STKCASEG401}.ncf
  setenv STK_GRPS_005 $IN_PTpath/ptfire/stack_groups_ptfire_${thisDate}_${STKCASEG401}.ncf
  setenv STK_GRPS_006 $IN_PTpath/ptfire_othna/stack_groups_ptfire_othna_${thisDate}_${STKCASEG401}.ncf
  setenv STK_GRPS_007 $IN_PTpath/pt_oilgas/stack_groups_pt_oilgas_${STKCASEG401}.ncf
  setenv STK_GRPS_008 $IN_PTpath/cmv_c3/stack_groups_cmv_c3_${STKCASEG401}.ncf
  setenv STK_GRPS_009 $IN_PTpath/ptnonipm_pfas_chemoursnc/stack_groups_ptnonipm_pfas_chemoursnc_${STKCASEG405}.ncf
  setenv STK_GRPS_010 $IN_PTpath/ptnonipm_pfas_chemoursother/stack_groups_ptnonipm_pfas_chemoursother_${STKCASEG405}.ncf
  setenv STK_GRPS_011 $IN_PTpath/ptnonipm_pfas_dupont/stack_groups_ptnonipm_pfas_dupont_${STKCASEG405}.ncf
  setenv STK_GRPS_012 $IN_PTpath/ptnonipm_pfas_stgobain/stack_groups_ptnonipm_pfas_stgobain_${STKCASEG405}.ncf
  setenv STK_GRPS_013 $IN_PTpath/ptnonipm_pfas_other/stack_groups_ptnonipm_pfas_other_${STKCASEG405}.ncf
  setenv LAYP_STTIME $STTIME
  setenv LAYP_NSTEPS $NSTEPS

  setenv STK_EMIS_001 $IN_PTpath/ptnonipm_nopfas/inln_mole_ptnonipm_nopfas_${mwdss_Y}_${STKCASEE405}.ncf
  setenv STK_EMIS_002 $IN_PTpath/ptegu/inln_mole_ptegu_${thisDate}_${STKCASEE401}.ncf
  setenv STK_EMIS_003 $IN_PTpath/othpt/inln_mole_othpt_${mwdss_N}_${STKCASEE401}.ncf
  setenv STK_EMIS_004 $IN_PTpath/ptagfire/inln_mole_ptagfire_${thisDate}_${STKCASEE401}.ncf
  setenv STK_EMIS_005 $IN_PTpath/ptfire/inln_mole_ptfire_${thisDate}_${STKCASEE401}.ncf
  setenv STK_EMIS_006 $IN_PTpath/ptfire_othna/inln_mole_ptfire_othna_${thisDate}_${STKCASEE401}.ncf
  setenv STK_EMIS_007 $IN_PTpath/pt_oilgas/inln_mole_pt_oilgas_${mwdss_Y}_${STKCASEE401}.ncf
  setenv STK_EMIS_008 $IN_PTpath/cmv_c3/inln_mole_cmv_c3_${aveday_N}_${STKCASEE401}.ncf
  setenv STK_EMIS_009 $IN_PTpath/ptnonipm_pfas_chemoursnc/inln_mole_ptnonipm_pfas_chemoursnc_${mwdss_Y}_${STKCASEE405}.ncf
  setenv STK_EMIS_010 $IN_PTpath/ptnonipm_pfas_chemoursother/inln_mole_ptnonipm_pfas_chemoursother_${mwdss_Y}_${STKCASEE405}.ncf
  setenv STK_EMIS_011 $IN_PTpath/ptnonipm_pfas_dupont/inln_mole_ptnonipm_pfas_dupont_${mwdss_Y}_${STKCASEE405}.ncf
  setenv STK_EMIS_012 $IN_PTpath/ptnonipm_pfas_stgobain/inln_mole_ptnonipm_pfas_stgobain_${mwdss_Y}_${STKCASEE405}.ncf
  setenv STK_EMIS_013 $IN_PTpath/ptnonipm_pfas_other/inln_mole_ptnonipm_pfas_other_${mwdss_Y}_${STKCASEE405}.ncf
  setenv LAYP_STDATE $YYYYJJJ

  # Label Each Emissions Stream
  setenv STK_EMIS_LAB_001 PT_NONEGU
  setenv STK_EMIS_LAB_002 PT_EGU
  setenv STK_EMIS_LAB_003 PT_OTHER
  setenv STK_EMIS_LAB_004 PT_AGFIRES
  setenv STK_EMIS_LAB_005 PT_FIRES
  setenv STK_EMIS_LAB_006 PT_OTHFIRES
  setenv STK_EMIS_LAB_007 PT_OILGAS
  setenv STK_EMIS_LAB_008 PT_CMV
  setenv STK_EMIS_LAB_009 PT_PFAS_CHEMOURSNC
  setenv STK_EMIS_LAB_010 PT_PFAS_CHEMOURSOTHER
  setenv STK_EMIS_LAB_011 PT_PFAS_DUPONT
  setenv STK_EMIS_LAB_012 PT_PFAS_STGOBAIN
  setenv STK_EMIS_LAB_013 PT_PFAS_OTHER

  setenv STK_EM_SYM_DATE_001 T
  setenv STK_EM_SYM_DATE_002 T
  setenv STK_EM_SYM_DATE_003 T
  setenv STK_EM_SYM_DATE_004 T
  setenv STK_EM_SYM_DATE_005 T
  setenv STK_EM_SYM_DATE_006 T
  setenv STK_EM_SYM_DATE_007 T
  setenv STK_EM_SYM_DATE_008 T
  setenv STK_EM_SYM_DATE_009 T
  setenv STK_EM_SYM_DATE_010 T
  setenv STK_EM_SYM_DATE_011 T
  setenv STK_EM_SYM_DATE_012 T
  setenv STK_EM_SYM_DATE_013 T

  #> Lightning NOx configuration
  if ( $CTM_LTNG_NO == 'Y' ) then
     setenv LTNGNO "InLine"    #> set LTNGNO to "Inline" to activate in-line calculation

  #> In-line lightning NOx options
     setenv USE_NLDN  Y        #> use hourly NLDN strike file [ default: Y ]
     if ( $USE_NLDN == Y ) then
        setenv NLDN_STRIKES ${IN_LTpath}/NLDN.12US1.${YYYYMMDD}.ioapi
     endif
     setenv LTNGPARMS_FILE ${IN_LTpath}/LTNG_AllParms_12US1.ncf #> lightning parameter file; ignore if LTNGPARAM = N
  endif

  #> In-line biogenic emissions configuration
  if ( $CTM_BIOGEMIS_BE == 'Y' ) then   
     set IN_BEISpath = ${INPDIR}
     setenv GSPRO      $BLD/gspro_biogenics.txt
     setenv BEIS_NORM_EMIS   $IN_BEISpath/surface/b3grd_1NC1.ncf
     setenv BIOSW_YN   Y     #> use frost date switch [ default: Y ]
     setenv BIOSEASON  $IN_BEISpath/bioseason.cmaq.2018_1NC1_out.ncf #updated for paper run, 1 May 2020
     setenv SUMMER_YN  Y     #> Use summer normalized emissions? [ default: Y ]
     setenv PX_VERSION Y     #> MCIP is PX version? [ default: N ]
     setenv BEIS_SOILINP    $OUTDIR/CCTM_BSOILOUT_${RUNID}_${YESTERDAY}.nc
                             #> Biogenic NO soil input file; ignore if INITIAL_RUN = Y
  endif
  if ( $CTM_BIOGEMIS_MG == 'Y' ) then
     echo "Error: MEGAN Inputs unavailable for 2018 4LIST1 case"
     exit()
  endif


  #> Windblown dust emissions configuration
  if ( $CTM_WB_DUST == 'Y' ) then
     # Input variables for BELD3 Landuse option
     setenv DUST_LU_1 $LUpath/beld3_12US1_459X299_output_a.ncf
     setenv DUST_LU_2 $LUpath/beld41_feb2017_1NC1_output.ncf
  endif
  
  #> In-line sea spray emissions configuration
  setenv OCEAN_1 $SZpath/ocean_file_1NC1.nc

  #> Bidirectional ammonia configuration
  if ( $CTM_ABFLUX == 'Y' ) then
     # need to modify for FEST-C v1.4.
     setenv E2C_SOIL ${INPDIR}/surface/toCMAQ_festc1.4_epic/us1_2016_cmaq12km_soil.nc
     setenv E2C_CHEM ${INPDIR}/surface/toCMAQ_festc1.4_epic/us1_2016_cmaq12km_time${YYYYMMDD}.nc
     setenv E2C_CHEM_YEST ${INPDIR}/surface/toCMAQ_festc1.4_epic/us1_2016_cmaq12km_time${YESTERDAY}.nc
     setenv E2C_LU ${INPDIR}/surface/beld41_feb2017_1NC1_output.ncf
  endif

#> Inline Process Analysis 
  setenv CTM_PROCAN N        #> use process analysis [ default: N]
  if ( $?CTM_PROCAN ) then   # $CTM_PROCAN is defined
     if ( $CTM_PROCAN == 'Y' || $CTM_PROCAN == 'T' ) then
#> process analysis global column, row and layer ranges
#       setenv PA_BCOL_ECOL "10 90"  # default: all columns
#       setenv PA_BROW_EROW "10 80"  # default: all rows
#       setenv PA_BLEV_ELEV "1  4"   # default: all levels
        setenv PACM_INFILE ${NMLpath}/pa_${MECH}.ctl
        setenv PACM_REPORT $OUTDIR/"PA_REPORT".${YYYYMMDD}
     endif
  endif

#> Integrated Source Apportionment Method (ISAM) Options
 setenv CTM_ISAM N
 if ( $?CTM_ISAM ) then
    if ( $CTM_ISAM == 'Y' || $CTM_ISAM == 'T' ) then
       setenv SA_IOLIST ${WORKDIR}/isam_control.txt
       setenv ISAM_BLEV_ELEV " 1 1"
       setenv AISAM_BLEV_ELEV " 1 1"

       #> Set Up ISAM Initial Condition Flags
       if ($NEW_START == true || $NEW_START == TRUE ) then
          setenv ISAM_NEW_START Y
          setenv ISAM_PREVDAY
       else
          setenv ISAM_NEW_START N
          setenv ISAM_PREVDAY "$OUTDIR/CCTM_SA_CGRID_${RUNID}_${YESTERDAY}.nc"
       endif

       #> Set Up ISAM Output Filenames
       setenv SA_ACONC_1      "$OUTDIR/CCTM_SA_ACONC_${CTM_APPL}.nc -v"
       setenv SA_CONC_1       "$OUTDIR/CCTM_SA_CONC_${CTM_APPL}.nc -v"
       setenv SA_DD_1         "$OUTDIR/CCTM_SA_DRYDEP_${CTM_APPL}.nc -v"
       setenv SA_WD_1         "$OUTDIR/CCTM_SA_WETDEP_${CTM_APPL}.nc -v"
       setenv SA_CGRID_1      "$OUTDIR/CCTM_SA_CGRID_${CTM_APPL}.nc -v"

       #> Set optional ISAM regions files
#      setenv ISAM_REGIONS /work/MOD3EVAL/nsu/isam_v53/CCTM/scripts/input/RGN_ISAM.nc

       #> Options used to favor tracked species in reactions for Ozone-NOx chemistry
       setenv ISAM_O3_WEIGHTS 5   # weights for tracked species Default is 5
                                  #     OPTIONS
                                  # 1 does not weight any species
                                  # 2 weights NOx and subset of NOz species
                                  # 3 uses with from option 2 plus weight OVOC species, organic radicals and operators
                                  # 4 weight OVOC species, organic radicals and operators
                                  # 5 toggles between two weighting set based on VOC and NOx limited ozone production
       # Below options only used if ISAM_O3_WEIGHTS set to 5
       setenv ISAM_NOX_CASE  2    # weights for tracked species when ozone production is NOx limited. Default is 2
       setenv ISAM_VOC_CASE  4    # weights for tracked species when ozone production is VOC limited. Default is 4
       setenv VOC_NOX_TRANS  0.35 # value of Prod H2O2 over Prod HNO3 less than where 
                                  # ISAM_VOC_CASE weights are used. Otherwise, ISAM_NOX_CASE
                                  # weights are used. Default is 0.35


    endif
 endif

#> Sulfur Tracking Model (STM)
 setenv STM_SO4TRACK N        #> sulfur tracking [ default: N ]
 if ( $?STM_SO4TRACK ) then
    if ( $STM_SO4TRACK == 'Y' || $STM_SO4TRACK == 'T' ) then

      #> option to normalize sulfate tracers [ default: Y ]
      setenv STM_ADJSO4 Y

    endif
 endif

#> Decoupled Direct Method in 3D (DDM-3D) Options
 setenv CTM_DDM3D N    # Sets up requisite script settings for DDM-3D (default is N/F)
                       # Additionally requires for CCTM to be compiled for DDM-3D simulations

 set NPMAX    = 1      # Number of sensitivity parameters defined in SEN_INPUT
 setenv SEN_INPUT ${WORKDIR}/sensinput.dat

 setenv DDM3D_HIGH N   # allow higher-order sensitivity parameters in SEN_INPUT [ T | Y | F | N ] (default is N/F)

 if ($NEW_START == true || $NEW_START == TRUE ) then
    setenv DDM3D_RST N # begins from sensitivities from a restart file [ T | Y | F | N ] (default is Y/T)
    set S_ICpath =     # sensitivity fields are initialized to 0.0 on the first hour of the first day
    set S_ICfile =
 else
    setenv DDM3D_RST Y # begins from sensitivities from a restart file [ T | Y | F | N ] (default is Y/T)  
    set S_ICpath = $OUTDIR
    set S_ICfile = CCTM_SENGRID_${RUNID}_${YESTERDAY}.nc
 endif

 setenv CTM_NPMAX       $NPMAX
 setenv CTM_SENS_1      "$OUTDIR/CCTM_SENGRID_${CTM_APPL}.nc -v"
 setenv A_SENS_1        "$OUTDIR/CCTM_ASENS_${CTM_APPL}.nc -v"
 setenv CTM_SWETDEP_1   "$OUTDIR/CCTM_SENWDEP_${CTM_APPL}.nc -v"
 setenv CTM_SDRYDEP_1   "$OUTDIR/CCTM_SENDDEP_${CTM_APPL}.nc -v"
 setenv INIT_SENS_1     $S_ICpath/$S_ICfile
 
# =====================================================================
#> Output Files
# =====================================================================

  #> set output file names
  setenv S_CGRID         "$OUTDIR/CCTM_CGRID_${CTM_APPL}.nc"         #> 3D Inst. Concentrations
  setenv CTM_CONC_1      "$OUTDIR/CCTM_CONC_${CTM_APPL}.nc -v"       #> On-Hour Concentrations
  setenv A_CONC_1        "$OUTDIR/CCTM_ACONC_${CTM_APPL}.nc -v"      #> Hourly Avg. Concentrations
  setenv MEDIA_CONC      "$OUTDIR/CCTM_MEDIA_CONC_${CTM_APPL}.nc -v" #> NH3 Conc. in Media
  setenv CTM_DRY_DEP_1   "$OUTDIR/CCTM_DRYDEP_${CTM_APPL}.nc -v"     #> Hourly Dry Deposition
  setenv CTM_DEPV_DIAG   "$OUTDIR/CCTM_DEPV_${CTM_APPL}.nc -v"       #> Dry Deposition Velocities
  setenv B3GTS_S         "$OUTDIR/CCTM_B3GTS_S_${CTM_APPL}.nc -v"    #> Biogenic Emissions
  setenv BEIS_SOILOUT    "$OUTDIR/CCTM_BSOILOUT_${CTM_APPL}.nc"      #> Soil Emissions
  setenv MEGAN_SOILOUT   "$OUTDIR/CCTM_MSOILOUT_${CTM_APPL}.nc"      #> Soil Emissions
  setenv CTM_WET_DEP_1   "$OUTDIR/CCTM_WETDEP1_${CTM_APPL}.nc -v"    #> Wet Dep From All Clouds
  setenv CTM_WET_DEP_2   "$OUTDIR/CCTM_WETDEP2_${CTM_APPL}.nc -v"    #> Wet Dep From SubGrid Clouds
  setenv CTM_ELMO_1      "$OUTDIR/CCTM_ELMO_${CTM_APPL}.nc -v"       #> On-Hour Particle Diagnostics
  setenv CTM_AELMO_1     "$OUTDIR/CCTM_AELMO_${CTM_APPL}.nc -v"      #> Hourly Avg. Particle Diagnostics
  setenv CTM_RJ_1        "$OUTDIR/CCTM_PHOTDIAG1_${CTM_APPL}.nc -v"  #> 2D Surface Summary from Inline Photolysis
  setenv CTM_RJ_2        "$OUTDIR/CCTM_PHOTDIAG2_${CTM_APPL}.nc -v"  #> 3D Photolysis Rates 
  setenv CTM_RJ_3        "$OUTDIR/CCTM_PHOTDIAG3_${CTM_APPL}.nc -v"  #> 3D Optical and Radiative Results from Photolysis
  setenv CTM_SSEMIS_1    "$OUTDIR/CCTM_SSEMIS_${CTM_APPL}.nc -v"     #> Sea Spray Emissions
  setenv CTM_DUST_EMIS_1 "$OUTDIR/CCTM_DUSTEMIS_${CTM_APPL}.nc -v"   #> Dust Emissions
  setenv CTM_BUDGET      "$OUTDIR/CCTM_BUDGET_${CTM_APPL}.txt -v"    #> Budget
  setenv CTM_IPR_1       "$OUTDIR/CCTM_PA_1_${CTM_APPL}.nc -v"       #> Process Analysis
  setenv CTM_IPR_2       "$OUTDIR/CCTM_PA_2_${CTM_APPL}.nc -v"       #> Process Analysis
  setenv CTM_IPR_3       "$OUTDIR/CCTM_PA_3_${CTM_APPL}.nc -v"       #> Process Analysis
  setenv CTM_IRR_1       "$OUTDIR/CCTM_IRR_1_${CTM_APPL}.nc -v"      #> Chem Process Analysis
  setenv CTM_IRR_2       "$OUTDIR/CCTM_IRR_2_${CTM_APPL}.nc -v"      #> Chem Process Analysis
  setenv CTM_IRR_3       "$OUTDIR/CCTM_IRR_3_${CTM_APPL}.nc -v"      #> Chem Process Analysis
  setenv CTM_DRY_DEP_MOS "$OUTDIR/CCTM_DDMOS_${CTM_APPL}.nc -v"      #> Dry Dep
  setenv CTM_DEPV_MOS    "$OUTDIR/CCTM_DEPVMOS_${CTM_APPL}.nc -v"    #> Dry Dep Velocity
  setenv CTM_VDIFF_DIAG  "$OUTDIR/CCTM_VDIFF_DIAG_${CTM_APPL}.nc -v" #> Vertical Dispersion Diagnostic
  setenv CTM_VSED_DIAG   "$OUTDIR/CCTM_VSED_DIAG_${CTM_APPL}.nc -v"  #> Particle Grav. Settling Velocity
  setenv CTM_LTNGDIAG_1  "$OUTDIR/CCTM_LTNGHRLY_${CTM_APPL}.nc -v"   #> Hourly Avg Lightning NO
  setenv CTM_LTNGDIAG_2  "$OUTDIR/CCTM_LTNGCOL_${CTM_APPL}.nc -v"    #> Column Total Lightning NO
  setenv CTM_VEXT_1      "$OUTDIR/CCTM_VEXT_${CTM_APPL}.nc -v"       #> On-Hour 3D Concs at select sites

  #> set floor file (neg concs)
  setenv FLOOR_FILE ${OUTDIR}/FLOOR_${CTM_APPL}.txt

  #> look for existing log files and output files
  ( ls CTM_LOG_???.${CTM_APPL} > buff.txt ) >& /dev/null
  ( ls ${LOGDIR}/CTM_LOG_???.${CTM_APPL} >> buff.txt ) >& /dev/null
  set log_test = `cat buff.txt`; rm -f buff.txt

  set OUT_FILES = (${FLOOR_FILE} ${S_CGRID} ${CTM_CONC_1} ${A_CONC_1} ${MEDIA_CONC}         \
             ${CTM_DRY_DEP_1} $CTM_DEPV_DIAG $B3GTS_S $BEIS_SOILOUT $MEGAN_SOILOUT $CTM_WET_DEP_1\
             $CTM_WET_DEP_2 $CTM_ELMO_1 $CTM_AELMO_1             \
             $CTM_RJ_1 $CTM_RJ_2 $CTM_RJ_3 $CTM_SSEMIS_1 $CTM_DUST_EMIS_1 $CTM_IPR_1 $CTM_IPR_2       \
             $CTM_IPR_3 $CTM_BUDGET $CTM_IRR_1 $CTM_IRR_2 $CTM_IRR_3 $CTM_DRY_DEP_MOS                   \
             $CTM_DEPV_MOS $CTM_VDIFF_DIAG $CTM_VSED_DIAG $CTM_LTNGDIAG_1 $CTM_LTNGDIAG_2 $CTM_VEXT_1 )
  if ( $?CTM_ISAM ) then
     if ( $CTM_ISAM == 'Y' || $CTM_ISAM == 'T' ) then
        set OUT_FILES = (${OUT_FILES} ${SA_ACONC_1} ${SA_CONC_1} ${SA_DD_1} ${SA_WD_1}      \
                         ${SA_CGRID_1} )
     endif
  endif
  if ( $?CTM_DDM3D ) then
     if ( $CTM_DDM3D == 'Y' || $CTM_DDM3D == 'T' ) then
        set OUT_FILES = (${OUT_FILES} ${CTM_SENS_1} ${A_SENS_1} ${CTM_SWETDEP_1} ${CTM_SDRYDEP_1} )
     endif
  endif
  set OUT_FILES = `echo $OUT_FILES | sed "s; -v;;g" `
  ( ls $OUT_FILES > buff.txt ) >& /dev/null
  set out_test = `cat buff.txt`; rm -f buff.txt

  #> delete previous output if requested
  if ( $CLOBBER_DATA == true || $CLOBBER_DATA == TRUE ) then
     echo 
     echo "Existing Logs and Output Files for Day ${TODAYG} Will Be Deleted"

     #> remove previous log files
     foreach file ( ${log_test} )
        #echo "Deleting log file: $file"
        /bin/rm -f $file  
     end
 
     #> remove previous output files
     foreach file ( ${out_test} )
        #echo "Deleting output file: $file"
        /bin/rm -f $file  
     end
     /bin/rm -f ${OUTDIR}/CCTM_EMDIAG*${RUNID}_${YYYYMMDD}.nc
     /bin/rm -f ${OUTDIR}/CCTM_DESID*${RUNID}_${YYYYMMDD}.nc

  else
     #> error if previous log files exist
     if ( "$log_test" != "" ) then
       echo "*** Logs exist - run ABORTED ***"
       echo "*** To overide, set CLOBBER_DATA = TRUE in run_cctm.csh ***"
       echo "*** and these files will be automatically deleted. ***"
       exit 1
     endif
     
     #> error if previous output files exist
     if ( "$out_test" != "" ) then
       echo "*** Output Files Exist - run will be ABORTED ***"
       foreach file ( $out_test )
          echo " cannot delete $file"
       end
       echo "*** To overide, set CLOBBER_DATA = TRUE in run_cctm.csh ***"
       echo "*** and these files will be automatically deleted. ***"
       exit 1
     endif
  endif

  #> for the run control ...
  setenv CTM_STDATE      $YYYYJJJ
  setenv CTM_STTIME      $STTIME
  setenv CTM_RUNLEN      $NSTEPS
  setenv CTM_TSTEP       $TSTEP
  setenv INIT_CONC_1 $ICpath/$ICFILE
  setenv BNDY_CONC_1 $BCpath/$BCFILE
  setenv OMI $OMIpath/$OMIfile
  setenv OPTICS_DATA $OMIpath/$OPTfile
 #setenv XJ_DATA $JVALpath/$JVALfile
  set TR_DVpath = $METpath
  set TR_DVfile = $MET_CRO_2D
 
  #> species defn & photolysis
  setenv gc_matrix_nml ${NMLpath}/GC_$MECH.nml
  setenv ae_matrix_nml ${NMLpath}/AE_$MECH.nml
  setenv nr_matrix_nml ${NMLpath}/NR_$MECH.nml
  setenv tr_matrix_nml ${NMLpath}/Species_Table_TR_0.nml

  #> check for photolysis input data
  setenv CSQY_DATA ${NMLpath}/CSQY_DATA_$MECH

  if (! (-e $CSQY_DATA ) ) then
     echo " $CSQY_DATA  not found "
     exit 1
  endif
  if (! (-e $OPTICS_DATA ) ) then
     echo " $OPTICS_DATA  not found "
     exit 1
  endif

# ===================================================================
#> Execution Portion
# ===================================================================

  #> Print attributes of the executable
  if ( $CTM_DIAG_LVL != 0 ) then
     ls -l $BLD/$EXEC
     size $BLD/$EXEC
     unlimit
     limit
  endif

  #> Print Startup Dialogue Information to Standard Out
  echo 
  echo "CMAQ Processing of Day $YYYYMMDD Began at `date`"
  echo 

  #> Executable call for single PE, uncomment to invoke
  #( /usr/bin/time -p $BLD/$EXEC ) |& tee buff_${EXECUTION_ID}.txt

  #> Executable call for multi PE, configure for your system 
  #set MPI = /home/local-rhel7/apps/intel/compilers_and_libraries_2019.5.281/linux/mpi/intel64/bin
  #set MPIRUN = $MPI/mpirun
  ( /usr/bin/time -p mpirun -np $NPROCS $BLD/$EXEC ) |& tee buff_${EXECUTION_ID}.txt

  #> Harvest Timing Output so that it may be reported below
  set rtarray = "${rtarray} `tail -3 buff_${EXECUTION_ID}.txt | grep -Eo '[+-]?[0-9]+([.][0-9]+)?' | head -1` "
  rm -rf buff_${EXECUTION_ID}.txt

  #> Abort script if abnormal termination
  if ( ! -e $S_CGRID ) then
    echo ""
    echo "**************************************************************"
    echo "** Runscript Detected an Error: CGRID file was not written. **"
    echo "**   This indicates that CMAQ was interrupted or an issue   **"
    echo "**   exists with writing output. The runscript will now     **"
    echo "**   abort rather than proceeding to subsequent days.       **"
    echo "**************************************************************"
    break
  endif

  #> Print Concluding Text
  echo 
  echo "CMAQ Processing of Day $YYYYMMDD Finished at `date`"
  echo
  echo "\\\\\=====\\\\\=====\\\\\=====\\\\\=====/////=====/////=====/////=====/////"
  echo

# ===================================================================
#> Finalize Run for This Day and Loop to Next Day
# ===================================================================

  #> Save Log Files and Move on to Next Simulation Day
  mv CTM_LOG_???.${CTM_APPL} $LOGDIR
  if ( $CTM_DIAG_LVL != 0 ) then
    mv CTM_DIAG_???.${CTM_APPL} $LOGDIR
  endif

  #> The next simulation day will, by definition, be a restart
  setenv NEW_START false

  #> Increment both Gregorian and Julian Days
  set TODAYG = `date -ud "${TODAYG}+1days" +%Y-%m-%d` #> Add a day for tomorrow
  set TODAYJ = `date -ud "${TODAYG}" +%Y%j` #> Convert YYYY-MM-DD to YYYYJJJ

end  #Loop to the next Simulation Day

# ===================================================================
#> Generate Timing Report
# ===================================================================
set RTMTOT = 0
foreach it ( `seq ${NDAYS}` )
    set rt = `echo ${rtarray} | cut -d' ' -f${it}`
    set RTMTOT = `echo "${RTMTOT} + ${rt}" | bc -l`
end

set RTMAVG = `echo "scale=2; ${RTMTOT} / ${NDAYS}" | bc -l`
set RTMTOT = `echo "scale=2; ${RTMTOT} / 1" | bc -l`

echo
echo "=================================="
echo "  ***** CMAQ TIMING REPORT *****"
echo "=================================="
echo "Start Day: ${START_DATE}"
echo "End Day:   ${END_DATE}"
echo "Number of Simulation Days: ${NDAYS}"
echo "Domain Name:               ${GRID_NAME}"
echo "Number of Grid Cells:      ${NCELLS}  (ROW x COL x LAY)"
echo "Number of Layers:          ${NZ}"
echo "Number of Processes:       ${NPROCS}"
echo "   All times are in seconds."
echo
echo "Num  Day        Wall Time"
set d = 0
set day = ${START_DATE}
foreach it ( `seq ${NDAYS}` )
    # Set the right day and format it
    set d = `echo "${d} + 1"  | bc -l`
    set n = `printf "%02d" ${d}`

    # Choose the correct time variables
    set rt = `echo ${rtarray} | cut -d' ' -f${it}`

    # Write out row of timing data
    echo "${n}   ${day}   ${rt}"

    # Increment day for next loop
    set day = `date -ud "${day}+1days" +%Y-%m-%d`
end
echo "     Total Time = ${RTMTOT}"
echo "      Avg. Time = ${RTMAVG}"

exit
